#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 8398
#define LARGE_STATE_COUNT 3542
#define SYMBOL_COUNT 437
#define ALIAS_COUNT 3
#define TOKEN_COUNT 197
#define EXTERNAL_TOKEN_COUNT 13
#define FIELD_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 68

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_namespace = 2,
  anon_sym_global = 3,
  anon_sym_rec = 4,
  anon_sym_module = 5,
  anon_sym_EQ = 6,
  anon_sym_open = 7,
  anon_sym_LBRACK_LT = 8,
  anon_sym_GT_RBRACK = 9,
  anon_sym_COLON = 10,
  anon_sym_assembly = 11,
  anon_sym_return = 12,
  anon_sym_field = 13,
  anon_sym_property = 14,
  anon_sym_param = 15,
  anon_sym_type = 16,
  anon_sym_constructor = 17,
  anon_sym_event = 18,
  anon_sym_do = 19,
  anon_sym_and = 20,
  anon_sym_let = 21,
  anon_sym_let_BANG = 22,
  anon_sym_inline = 23,
  anon_sym_mutable = 24,
  aux_sym_access_modifier_token1 = 25,
  anon_sym_as = 26,
  anon_sym_LPAREN = 27,
  anon_sym_RPAREN = 28,
  anon_sym_COMMA = 29,
  anon_sym_null = 30,
  anon_sym__ = 31,
  anon_sym_QMARK = 32,
  anon_sym_COLON_QMARK = 33,
  anon_sym_COLON_COLON = 34,
  anon_sym_PIPE = 35,
  anon_sym_AMP = 36,
  anon_sym_SEMI = 37,
  anon_sym_LBRACK = 38,
  anon_sym_RBRACK = 39,
  anon_sym_LBRACK_PIPE = 40,
  anon_sym_PIPE_RBRACK = 41,
  anon_sym_LBRACE = 42,
  anon_sym_LT_AT = 43,
  anon_sym_AT_GT = 44,
  anon_sym_LT_AT_AT = 45,
  anon_sym_AT_AT_GT = 46,
  anon_sym_DOT = 47,
  anon_sym_RBRACE = 48,
  anon_sym_LBRACE_PIPE = 49,
  anon_sym_PIPE_RBRACE = 50,
  anon_sym_with = 51,
  anon_sym_new = 52,
  anon_sym_return_BANG = 53,
  anon_sym_yield = 54,
  anon_sym_yield_BANG = 55,
  anon_sym_lazy = 56,
  anon_sym_assert = 57,
  anon_sym_upcast = 58,
  anon_sym_downcast = 59,
  anon_sym_COLON_GT = 60,
  anon_sym_COLON_QMARK_GT = 61,
  anon_sym_for = 62,
  anon_sym_in = 63,
  anon_sym_to = 64,
  anon_sym_downto = 65,
  anon_sym_done = 66,
  anon_sym_while = 67,
  anon_sym_else = 68,
  anon_sym_then = 69,
  anon_sym_elif = 70,
  anon_sym_if = 71,
  anon_sym_fun = 72,
  anon_sym_DASH_GT = 73,
  anon_sym_try = 74,
  anon_sym_finally = 75,
  anon_sym_match = 76,
  anon_sym_match_BANG = 77,
  anon_sym_function = 78,
  anon_sym_LT_DASH = 79,
  anon_sym_DOT_LBRACK = 80,
  anon_sym_LT = 81,
  anon_sym_GT = 82,
  anon_sym_use = 83,
  anon_sym_use_BANG = 84,
  anon_sym_do_BANG = 85,
  anon_sym_DOT_DOT = 86,
  anon_sym_when = 87,
  anon_sym_begin = 88,
  anon_sym_end = 89,
  anon_sym_LPAREN2 = 90,
  anon_sym_DOT_DOT2 = 91,
  anon_sym_DOT_DOT3 = 92,
  anon_sym_STAR = 93,
  anon_sym_LT2 = 94,
  anon_sym_LBRACK_RBRACK = 95,
  anon_sym_POUND = 96,
  anon_sym_CARET = 97,
  anon_sym_SQUOTE = 98,
  anon_sym_unit = 99,
  anon_sym_struct = 100,
  anon_sym_not = 101,
  anon_sym_enum = 102,
  anon_sym_unmanaged = 103,
  anon_sym_equality = 104,
  anon_sym_comparison = 105,
  anon_sym_delegate = 106,
  anon_sym_default = 107,
  anon_sym_or = 108,
  anon_sym_static = 109,
  anon_sym_member = 110,
  anon_sym_get = 111,
  anon_sym_set = 112,
  anon_sym_interface = 113,
  anon_sym_id = 114,
  anon_sym_of = 115,
  anon_sym_abstract = 116,
  anon_sym_override = 117,
  anon_sym_val = 118,
  anon_sym_inherit = 119,
  anon_sym_EQ2 = 120,
  sym__escape_char = 121,
  sym__non_escape_char = 122,
  sym__unicodegraph_short = 123,
  sym__unicodegraph_long = 124,
  sym__trigraph = 125,
  aux_sym__simple_string_char_token1 = 126,
  aux_sym_char_token1 = 127,
  anon_sym_LBRACE2 = 128,
  anon_sym_DOLLAR_DQUOTE = 129,
  anon_sym_DQUOTE = 130,
  anon_sym_BSLASH = 131,
  aux_sym__verbatim_string_char_token1 = 132,
  anon_sym_AT_DQUOTE = 133,
  anon_sym_DQUOTE2 = 134,
  anon_sym_DQUOTEB = 135,
  anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE = 136,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 137,
  sym_bool = 138,
  sym_unit = 139,
  anon_sym_LPAREN_PIPE = 140,
  anon_sym_PIPE_RPAREN = 141,
  sym_op_identifier = 142,
  anon_sym_PLUS = 143,
  anon_sym_DASH = 144,
  anon_sym_PLUS_DOT = 145,
  anon_sym_DASH_DOT = 146,
  anon_sym_PERCENT = 147,
  anon_sym_AMP_AMP = 148,
  anon_sym_TILDE = 149,
  aux_sym_prefix_op_token1 = 150,
  aux_sym_infix_op_token1 = 151,
  anon_sym_PIPE_PIPE = 152,
  anon_sym_BANG_EQ = 153,
  anon_sym_COLON_EQ = 154,
  anon_sym_DOLLAR = 155,
  anon_sym_QMARK_LT_DASH = 156,
  sym_int = 157,
  sym_xint = 158,
  anon_sym_y = 159,
  anon_sym_uy = 160,
  anon_sym_s = 161,
  anon_sym_us = 162,
  anon_sym_l = 163,
  aux_sym_uint32_token1 = 164,
  anon_sym_n = 165,
  anon_sym_un = 166,
  anon_sym_L = 167,
  aux_sym_uint64_token1 = 168,
  anon_sym_f = 169,
  anon_sym_lf = 170,
  anon_sym_LF = 171,
  aux_sym_bignum_token1 = 172,
  aux_sym_decimal_token1 = 173,
  anon_sym_DOT2 = 174,
  aux_sym_float_token1 = 175,
  anon_sym_SLASH_SLASH_SLASH = 176,
  aux_sym_xml_doc_token1 = 177,
  anon_sym_LPAREN_STAR = 178,
  anon_sym_STAR_RPAREN = 179,
  anon_sym_SLASH_SLASH = 180,
  aux_sym_line_comment_token1 = 181,
  anon_sym_POUNDnowarn = 182,
  aux_sym_compiler_directive_decl_token1 = 183,
  anon_sym_POUNDr = 184,
  anon_sym_POUNDload = 185,
  aux_sym_preproc_line_token1 = 186,
  anon_sym_POUNDif = 187,
  anon_sym_POUNDendif = 188,
  anon_sym_POUNDelse = 189,
  sym__newline = 190,
  sym__indent = 191,
  sym__dedent = 192,
  sym__triple_quoted_content = 193,
  sym_block_comment_content = 194,
  sym__inside_string_marker = 195,
  sym__error_sentinel = 196,
  sym_file = 197,
  sym_namespace = 198,
  sym_named_module = 199,
  sym_module_abbrev = 200,
  sym_module_defn = 201,
  sym_import_decl = 202,
  sym_attributes = 203,
  sym_attribute_set = 204,
  sym_attribute = 205,
  sym_attribute_target = 206,
  sym_object_construction = 207,
  sym_value_declaration = 208,
  sym_do = 209,
  sym__function_or_value_defns = 210,
  sym_function_or_value_defn = 211,
  sym__function_or_value_defn_body = 212,
  sym_function_declaration_left = 213,
  sym_value_declaration_left = 214,
  sym_access_modifier = 215,
  sym_class_as_reference = 216,
  sym_primary_constr_args = 217,
  sym_repeat_pattern = 218,
  sym__pattern = 219,
  sym_optional_pattern = 220,
  sym_type_check_pattern = 221,
  sym_attribute_pattern = 222,
  sym_paren_pattern = 223,
  sym_as_pattern = 224,
  sym_cons_pattern = 225,
  sym_disjunct_pattern = 226,
  sym_conjunct_pattern = 227,
  sym_typed_pattern = 228,
  sym_argument_patterns = 229,
  sym_field_pattern = 230,
  sym__atomic_pattern = 231,
  sym__list_pattern_content = 232,
  sym_list_pattern = 233,
  sym_array_pattern = 234,
  sym_record_pattern = 235,
  sym_identifier_pattern = 236,
  sym__pattern_param = 237,
  sym__expression_block = 238,
  sym__expression = 239,
  sym_literal_expression = 240,
  sym_long_identifier_or_op = 241,
  sym_tuple_expression = 242,
  sym_brace_expression = 243,
  sym_anon_record_expression = 244,
  sym_with_field_expression = 245,
  sym_object_expression = 246,
  sym_prefixed_expression = 247,
  sym_typecast_expression = 248,
  sym_for_expression = 249,
  sym_while_expression = 250,
  sym__else_expression = 251,
  sym_elif_expression = 252,
  sym__if_branch = 253,
  sym_if_expression = 254,
  sym_fun_expression = 255,
  sym_try_expression = 256,
  sym_match_expression = 257,
  sym_function_expression = 258,
  sym_object_instantiation_expression = 259,
  sym_mutate_expression = 260,
  sym_index_expression = 261,
  sym_dot_expression = 262,
  sym_typed_expression = 263,
  sym_declaration_expression = 264,
  sym_do_expression = 265,
  sym__list_elements = 266,
  sym__list_element = 267,
  sym_list_expression = 268,
  sym_array_expression = 269,
  sym_range_expression = 270,
  sym_rule = 271,
  sym_rules = 272,
  sym_begin_end_expression = 273,
  sym_paren_expression = 274,
  sym_application_expression = 275,
  sym_infix_expression = 276,
  sym_ce_expression = 277,
  sym_sequential_expression = 278,
  sym__comp_or_range_expression = 279,
  sym_short_comp_expression = 280,
  sym_slice_ranges = 281,
  sym__slice_range_special = 282,
  sym_slice_range = 283,
  sym_type = 284,
  sym__simple_type = 285,
  sym__generic_type = 286,
  sym__paren_type = 287,
  sym__function_type = 288,
  sym__compound_type = 289,
  sym__postfix_type = 290,
  sym__list_type = 291,
  sym__static_type = 292,
  sym__constrained_type = 293,
  sym__flexible_type = 294,
  sym_types = 295,
  sym__static_type_identifier = 296,
  sym__static_parameter = 297,
  sym_named_static_parameter = 298,
  sym_static_parameter_value = 299,
  sym_type_attribute = 300,
  sym_type_attributes = 301,
  sym_atomic_type = 302,
  sym_constraint = 303,
  sym_type_argument_constraints = 304,
  sym_type_argument = 305,
  sym_type_argument_defn = 306,
  sym_type_arguments = 307,
  sym_trait_member_constraint = 308,
  sym_member_signature = 309,
  sym_curried_spec = 310,
  sym_argument_spec = 311,
  sym_arguments_spec = 312,
  sym_argument_name_spec = 313,
  sym_type_definition = 314,
  sym__type_defn_body = 315,
  sym_type_name = 316,
  sym_type_extension = 317,
  sym_delegate_type_defn = 318,
  sym_delegate_signature = 319,
  sym_type_abbrev_defn = 320,
  sym__class_type_body_inner = 321,
  sym__class_type_body = 322,
  sym_record_type_defn = 323,
  sym_record_fields = 324,
  sym_record_field = 325,
  sym_enum_type_defn = 326,
  sym_enum_type_cases = 327,
  sym_enum_type_case = 328,
  sym_union_type_defn = 329,
  sym_union_type_cases = 330,
  sym_union_type_case = 331,
  sym_union_type_fields = 332,
  sym_union_type_field = 333,
  sym_anon_type_defn = 334,
  sym__class_function_or_value_defn = 335,
  sym_type_extension_elements = 336,
  sym__type_defn_elements = 337,
  sym_interface_implementation = 338,
  sym__member_defns = 339,
  sym__object_members = 340,
  sym_member_defn = 341,
  sym_property_or_ident = 342,
  sym__method_defn = 343,
  sym__property_defn = 344,
  sym_method_or_prop_defn = 345,
  sym_additional_constr_defn = 346,
  sym_class_inherits_decl = 347,
  sym_field_initializer = 348,
  sym_field_initializers = 349,
  sym__simple_string_char = 350,
  sym__string_char = 351,
  sym_char = 352,
  sym_format_string_eval = 353,
  sym_format_string = 354,
  sym__string_literal = 355,
  sym_string = 356,
  sym__verbatim_string_char = 357,
  sym_verbatim_string = 358,
  sym_bytearray = 359,
  sym_verbatim_bytearray = 360,
  sym_format_triple_quoted_string = 361,
  sym_triple_quoted_string = 362,
  sym_const = 363,
  sym_long_identifier = 364,
  sym_active_pattern = 365,
  sym__identifier_or_op = 366,
  sym__infix_or_prefix_op = 367,
  sym_prefix_op = 368,
  sym_infix_op = 369,
  sym_sbyte = 370,
  sym_byte = 371,
  sym_int16 = 372,
  sym_uint16 = 373,
  sym_int32 = 374,
  sym_uint32 = 375,
  sym_nativeint = 376,
  sym_unativeint = 377,
  sym_int64 = 378,
  sym_uint64 = 379,
  sym_ieee32 = 380,
  sym_ieee64 = 381,
  sym_bignum = 382,
  sym_decimal = 383,
  sym_float = 384,
  sym_xml_doc = 385,
  sym_block_comment = 386,
  sym_line_comment = 387,
  sym_compiler_directive_decl = 388,
  sym_fsi_directive_decl = 389,
  sym_preproc_line = 390,
  sym_preproc_if = 391,
  sym_preproc_else = 392,
  sym_preproc_if_in_expression = 393,
  sym_preproc_else_in_expression = 394,
  sym_preproc_if_in_class_definition = 395,
  sym_preproc_else_in_class_definition = 396,
  aux_sym_file_repeat1 = 397,
  aux_sym_file_repeat2 = 398,
  aux_sym_attributes_repeat1 = 399,
  aux_sym_attribute_set_repeat1 = 400,
  aux_sym__function_or_value_defns_repeat1 = 401,
  aux_sym_repeat_pattern_repeat1 = 402,
  aux_sym_argument_patterns_repeat1 = 403,
  aux_sym__list_pattern_content_repeat1 = 404,
  aux_sym_record_pattern_repeat1 = 405,
  aux_sym__object_expression_inner_repeat1 = 406,
  aux_sym_if_expression_repeat1 = 407,
  aux_sym__list_elements_repeat1 = 408,
  aux_sym_rules_repeat1 = 409,
  aux_sym_sequential_expression_repeat1 = 410,
  aux_sym_slice_ranges_repeat1 = 411,
  aux_sym__compound_type_repeat1 = 412,
  aux_sym_types_repeat1 = 413,
  aux_sym_type_attributes_repeat1 = 414,
  aux_sym_type_argument_constraints_repeat1 = 415,
  aux_sym_type_argument_repeat1 = 416,
  aux_sym_type_arguments_repeat1 = 417,
  aux_sym_curried_spec_repeat1 = 418,
  aux_sym_arguments_spec_repeat1 = 419,
  aux_sym_type_definition_repeat1 = 420,
  aux_sym__class_type_body_repeat1 = 421,
  aux_sym_record_fields_repeat1 = 422,
  aux_sym_enum_type_cases_repeat1 = 423,
  aux_sym_union_type_cases_repeat1 = 424,
  aux_sym_union_type_fields_repeat1 = 425,
  aux_sym__member_defns_repeat1 = 426,
  aux_sym__method_defn_repeat1 = 427,
  aux_sym_field_initializers_repeat1 = 428,
  aux_sym_format_string_repeat1 = 429,
  aux_sym__string_literal_repeat1 = 430,
  aux_sym_verbatim_string_repeat1 = 431,
  aux_sym_long_identifier_repeat1 = 432,
  aux_sym_active_pattern_repeat1 = 433,
  aux_sym_prefix_op_repeat1 = 434,
  aux_sym_preproc_if_in_expression_repeat1 = 435,
  aux_sym_preproc_if_in_class_definition_repeat1 = 436,
  alias_sym_active_pattern_op_name = 437,
  alias_sym_wildcard_active_pattern_op = 438,
  alias_sym_wildcard_pattern = 439,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_namespace] = "namespace",
  [anon_sym_global] = "global",
  [anon_sym_rec] = "rec",
  [anon_sym_module] = "module",
  [anon_sym_EQ] = "=",
  [anon_sym_open] = "open",
  [anon_sym_LBRACK_LT] = "[<",
  [anon_sym_GT_RBRACK] = ">]",
  [anon_sym_COLON] = ":",
  [anon_sym_assembly] = "assembly",
  [anon_sym_return] = "return",
  [anon_sym_field] = "field",
  [anon_sym_property] = "property",
  [anon_sym_param] = "param",
  [anon_sym_type] = "type",
  [anon_sym_constructor] = "constructor",
  [anon_sym_event] = "event",
  [anon_sym_do] = "do",
  [anon_sym_and] = "and",
  [anon_sym_let] = "let",
  [anon_sym_let_BANG] = "let!",
  [anon_sym_inline] = "inline",
  [anon_sym_mutable] = "mutable",
  [aux_sym_access_modifier_token1] = "access_modifier_token1",
  [anon_sym_as] = "as",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_null] = "null",
  [anon_sym__] = "_",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON_QMARK] = ":\?",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_SEMI] = ";",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_PIPE] = "[|",
  [anon_sym_PIPE_RBRACK] = "|]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_LT_AT] = "<@",
  [anon_sym_AT_GT] = "@>",
  [anon_sym_LT_AT_AT] = "<@@",
  [anon_sym_AT_AT_GT] = "@@>",
  [anon_sym_DOT] = ".",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_with] = "with",
  [anon_sym_new] = "new",
  [anon_sym_return_BANG] = "return!",
  [anon_sym_yield] = "yield",
  [anon_sym_yield_BANG] = "yield!",
  [anon_sym_lazy] = "lazy",
  [anon_sym_assert] = "assert",
  [anon_sym_upcast] = "upcast",
  [anon_sym_downcast] = "downcast",
  [anon_sym_COLON_GT] = ":>",
  [anon_sym_COLON_QMARK_GT] = ":\?>",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_to] = "to",
  [anon_sym_downto] = "downto",
  [anon_sym_done] = "done",
  [anon_sym_while] = "while",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_elif] = "elif",
  [anon_sym_if] = "if",
  [anon_sym_fun] = "fun",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_try] = "try",
  [anon_sym_finally] = "finally",
  [anon_sym_match] = "match",
  [anon_sym_match_BANG] = "match!",
  [anon_sym_function] = "function",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_DOT_LBRACK] = ".[",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_use] = "use",
  [anon_sym_use_BANG] = "use!",
  [anon_sym_do_BANG] = "do!",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_when] = "when",
  [anon_sym_begin] = "begin",
  [anon_sym_end] = "end",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT2] = "..",
  [anon_sym_DOT_DOT3] = "..",
  [anon_sym_STAR] = "*",
  [anon_sym_LT2] = "<",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_POUND] = "#",
  [anon_sym_CARET] = "^",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_unit] = "unit",
  [anon_sym_struct] = "struct",
  [anon_sym_not] = "not",
  [anon_sym_enum] = "enum",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_equality] = "equality",
  [anon_sym_comparison] = "comparison",
  [anon_sym_delegate] = "delegate",
  [anon_sym_default] = "default",
  [anon_sym_or] = "or",
  [anon_sym_static] = "static",
  [anon_sym_member] = "member",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_interface] = "interface",
  [anon_sym_id] = "id",
  [anon_sym_of] = "of",
  [anon_sym_abstract] = "abstract",
  [anon_sym_override] = "override",
  [anon_sym_val] = "val",
  [anon_sym_inherit] = "inherit",
  [anon_sym_EQ2] = "=",
  [sym__escape_char] = "_escape_char",
  [sym__non_escape_char] = "_non_escape_char",
  [sym__unicodegraph_short] = "_unicodegraph_short",
  [sym__unicodegraph_long] = "_unicodegraph_long",
  [sym__trigraph] = "_trigraph",
  [aux_sym__simple_string_char_token1] = "_simple_string_char_token1",
  [aux_sym_char_token1] = "char_token1",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_DOLLAR_DQUOTE] = "$\"",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_BSLASH] = "\\",
  [aux_sym__verbatim_string_char_token1] = "_verbatim_string_char_token1",
  [anon_sym_AT_DQUOTE] = "@\"",
  [anon_sym_DQUOTE2] = "\"",
  [anon_sym_DQUOTEB] = "\"B",
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = "$\"\"\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [sym_bool] = "bool",
  [sym_unit] = "unit",
  [anon_sym_LPAREN_PIPE] = "(|",
  [anon_sym_PIPE_RPAREN] = "|)",
  [sym_op_identifier] = "op_identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_DOT] = "+.",
  [anon_sym_DASH_DOT] = "-.",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_TILDE] = "~",
  [aux_sym_prefix_op_token1] = "prefix_op_token1",
  [aux_sym_infix_op_token1] = "infix_op_token1",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_QMARK_LT_DASH] = "\?<-",
  [sym_int] = "int",
  [sym_xint] = "xint",
  [anon_sym_y] = "y",
  [anon_sym_uy] = "uy",
  [anon_sym_s] = "s",
  [anon_sym_us] = "us",
  [anon_sym_l] = "l",
  [aux_sym_uint32_token1] = "uint32_token1",
  [anon_sym_n] = "n",
  [anon_sym_un] = "un",
  [anon_sym_L] = "L",
  [aux_sym_uint64_token1] = "uint64_token1",
  [anon_sym_f] = "f",
  [anon_sym_lf] = "lf",
  [anon_sym_LF] = "LF",
  [aux_sym_bignum_token1] = "bignum_token1",
  [aux_sym_decimal_token1] = "decimal_token1",
  [anon_sym_DOT2] = "float",
  [aux_sym_float_token1] = "float",
  [anon_sym_SLASH_SLASH_SLASH] = "///",
  [aux_sym_xml_doc_token1] = "xml_doc_content",
  [anon_sym_LPAREN_STAR] = "(*",
  [anon_sym_STAR_RPAREN] = "*)",
  [anon_sym_SLASH_SLASH] = "//",
  [aux_sym_line_comment_token1] = "line_comment_token1",
  [anon_sym_POUNDnowarn] = "#nowarn",
  [aux_sym_compiler_directive_decl_token1] = "compiler_directive_decl_token1",
  [anon_sym_POUNDr] = "#r",
  [anon_sym_POUNDload] = "#load",
  [aux_sym_preproc_line_token1] = "#line",
  [anon_sym_POUNDif] = "#if",
  [anon_sym_POUNDendif] = "#endif",
  [anon_sym_POUNDelse] = "#else",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__triple_quoted_content] = "_triple_quoted_content",
  [sym_block_comment_content] = "block_comment_content",
  [sym__inside_string_marker] = "_inside_string_marker",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_file] = "file",
  [sym_namespace] = "namespace",
  [sym_named_module] = "named_module",
  [sym_module_abbrev] = "module_abbrev",
  [sym_module_defn] = "module_defn",
  [sym_import_decl] = "import_decl",
  [sym_attributes] = "attributes",
  [sym_attribute_set] = "attribute_set",
  [sym_attribute] = "attribute",
  [sym_attribute_target] = "attribute_target",
  [sym_object_construction] = "object_construction",
  [sym_value_declaration] = "value_declaration",
  [sym_do] = "do",
  [sym__function_or_value_defns] = "_function_or_value_defns",
  [sym_function_or_value_defn] = "function_or_value_defn",
  [sym__function_or_value_defn_body] = "_function_or_value_defn_body",
  [sym_function_declaration_left] = "function_declaration_left",
  [sym_value_declaration_left] = "value_declaration_left",
  [sym_access_modifier] = "access_modifier",
  [sym_class_as_reference] = "class_as_reference",
  [sym_primary_constr_args] = "primary_constr_args",
  [sym_repeat_pattern] = "repeat_pattern",
  [sym__pattern] = "_pattern",
  [sym_optional_pattern] = "optional_pattern",
  [sym_type_check_pattern] = "type_check_pattern",
  [sym_attribute_pattern] = "attribute_pattern",
  [sym_paren_pattern] = "paren_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym_cons_pattern] = "cons_pattern",
  [sym_disjunct_pattern] = "disjunct_pattern",
  [sym_conjunct_pattern] = "conjunct_pattern",
  [sym_typed_pattern] = "typed_pattern",
  [sym_argument_patterns] = "argument_patterns",
  [sym_field_pattern] = "field_pattern",
  [sym__atomic_pattern] = "_atomic_pattern",
  [sym__list_pattern_content] = "_list_pattern_content",
  [sym_list_pattern] = "list_pattern",
  [sym_array_pattern] = "array_pattern",
  [sym_record_pattern] = "record_pattern",
  [sym_identifier_pattern] = "identifier_pattern",
  [sym__pattern_param] = "_pattern_param",
  [sym__expression_block] = "_expression_block",
  [sym__expression] = "_expression",
  [sym_literal_expression] = "literal_expression",
  [sym_long_identifier_or_op] = "long_identifier_or_op",
  [sym_tuple_expression] = "tuple_expression",
  [sym_brace_expression] = "brace_expression",
  [sym_anon_record_expression] = "anon_record_expression",
  [sym_with_field_expression] = "with_field_expression",
  [sym_object_expression] = "object_expression",
  [sym_prefixed_expression] = "prefixed_expression",
  [sym_typecast_expression] = "typecast_expression",
  [sym_for_expression] = "for_expression",
  [sym_while_expression] = "while_expression",
  [sym__else_expression] = "_else_expression",
  [sym_elif_expression] = "elif_expression",
  [sym__if_branch] = "_if_branch",
  [sym_if_expression] = "if_expression",
  [sym_fun_expression] = "fun_expression",
  [sym_try_expression] = "try_expression",
  [sym_match_expression] = "match_expression",
  [sym_function_expression] = "function_expression",
  [sym_object_instantiation_expression] = "object_instantiation_expression",
  [sym_mutate_expression] = "mutate_expression",
  [sym_index_expression] = "index_expression",
  [sym_dot_expression] = "dot_expression",
  [sym_typed_expression] = "typed_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_do_expression] = "do_expression",
  [sym__list_elements] = "_list_elements",
  [sym__list_element] = "_list_element",
  [sym_list_expression] = "list_expression",
  [sym_array_expression] = "array_expression",
  [sym_range_expression] = "range_expression",
  [sym_rule] = "rule",
  [sym_rules] = "rules",
  [sym_begin_end_expression] = "begin_end_expression",
  [sym_paren_expression] = "paren_expression",
  [sym_application_expression] = "application_expression",
  [sym_infix_expression] = "infix_expression",
  [sym_ce_expression] = "ce_expression",
  [sym_sequential_expression] = "sequential_expression",
  [sym__comp_or_range_expression] = "_comp_or_range_expression",
  [sym_short_comp_expression] = "short_comp_expression",
  [sym_slice_ranges] = "slice_ranges",
  [sym__slice_range_special] = "_slice_range_special",
  [sym_slice_range] = "slice_range",
  [sym_type] = "type",
  [sym__simple_type] = "_simple_type",
  [sym__generic_type] = "_generic_type",
  [sym__paren_type] = "_paren_type",
  [sym__function_type] = "_function_type",
  [sym__compound_type] = "_compound_type",
  [sym__postfix_type] = "_postfix_type",
  [sym__list_type] = "_list_type",
  [sym__static_type] = "_static_type",
  [sym__constrained_type] = "_constrained_type",
  [sym__flexible_type] = "_flexible_type",
  [sym_types] = "types",
  [sym__static_type_identifier] = "_static_type_identifier",
  [sym__static_parameter] = "_static_parameter",
  [sym_named_static_parameter] = "named_static_parameter",
  [sym_static_parameter_value] = "static_parameter_value",
  [sym_type_attribute] = "type_attribute",
  [sym_type_attributes] = "type_attributes",
  [sym_atomic_type] = "atomic_type",
  [sym_constraint] = "constraint",
  [sym_type_argument_constraints] = "type_argument_constraints",
  [sym_type_argument] = "type_argument",
  [sym_type_argument_defn] = "type_argument_defn",
  [sym_type_arguments] = "type_arguments",
  [sym_trait_member_constraint] = "trait_member_constraint",
  [sym_member_signature] = "member_signature",
  [sym_curried_spec] = "curried_spec",
  [sym_argument_spec] = "argument_spec",
  [sym_arguments_spec] = "arguments_spec",
  [sym_argument_name_spec] = "argument_name_spec",
  [sym_type_definition] = "type_definition",
  [sym__type_defn_body] = "_type_defn_body",
  [sym_type_name] = "type_name",
  [sym_type_extension] = "type_extension",
  [sym_delegate_type_defn] = "delegate_type_defn",
  [sym_delegate_signature] = "delegate_signature",
  [sym_type_abbrev_defn] = "type_abbrev_defn",
  [sym__class_type_body_inner] = "_class_type_body_inner",
  [sym__class_type_body] = "_class_type_body",
  [sym_record_type_defn] = "record_type_defn",
  [sym_record_fields] = "record_fields",
  [sym_record_field] = "record_field",
  [sym_enum_type_defn] = "enum_type_defn",
  [sym_enum_type_cases] = "enum_type_cases",
  [sym_enum_type_case] = "enum_type_case",
  [sym_union_type_defn] = "union_type_defn",
  [sym_union_type_cases] = "union_type_cases",
  [sym_union_type_case] = "union_type_case",
  [sym_union_type_fields] = "union_type_fields",
  [sym_union_type_field] = "union_type_field",
  [sym_anon_type_defn] = "anon_type_defn",
  [sym__class_function_or_value_defn] = "_class_function_or_value_defn",
  [sym_type_extension_elements] = "type_extension_elements",
  [sym__type_defn_elements] = "_type_defn_elements",
  [sym_interface_implementation] = "interface_implementation",
  [sym__member_defns] = "_member_defns",
  [sym__object_members] = "_object_members",
  [sym_member_defn] = "member_defn",
  [sym_property_or_ident] = "property_or_ident",
  [sym__method_defn] = "_method_defn",
  [sym__property_defn] = "_property_defn",
  [sym_method_or_prop_defn] = "method_or_prop_defn",
  [sym_additional_constr_defn] = "additional_constr_defn",
  [sym_class_inherits_decl] = "class_inherits_decl",
  [sym_field_initializer] = "field_initializer",
  [sym_field_initializers] = "field_initializers",
  [sym__simple_string_char] = "_simple_string_char",
  [sym__string_char] = "_string_char",
  [sym_char] = "char",
  [sym_format_string_eval] = "format_string_eval",
  [sym_format_string] = "format_string",
  [sym__string_literal] = "_string_literal",
  [sym_string] = "string",
  [sym__verbatim_string_char] = "_verbatim_string_char",
  [sym_verbatim_string] = "verbatim_string",
  [sym_bytearray] = "bytearray",
  [sym_verbatim_bytearray] = "verbatim_bytearray",
  [sym_format_triple_quoted_string] = "format_triple_quoted_string",
  [sym_triple_quoted_string] = "triple_quoted_string",
  [sym_const] = "const",
  [sym_long_identifier] = "long_identifier",
  [sym_active_pattern] = "active_pattern",
  [sym__identifier_or_op] = "_identifier_or_op",
  [sym__infix_or_prefix_op] = "_infix_or_prefix_op",
  [sym_prefix_op] = "prefix_op",
  [sym_infix_op] = "infix_op",
  [sym_sbyte] = "sbyte",
  [sym_byte] = "byte",
  [sym_int16] = "int16",
  [sym_uint16] = "uint16",
  [sym_int32] = "int32",
  [sym_uint32] = "uint32",
  [sym_nativeint] = "nativeint",
  [sym_unativeint] = "unativeint",
  [sym_int64] = "int64",
  [sym_uint64] = "uint64",
  [sym_ieee32] = "ieee32",
  [sym_ieee64] = "ieee64",
  [sym_bignum] = "bignum",
  [sym_decimal] = "decimal",
  [sym_float] = "float",
  [sym_xml_doc] = "xml_doc",
  [sym_block_comment] = "block_comment",
  [sym_line_comment] = "line_comment",
  [sym_compiler_directive_decl] = "compiler_directive_decl",
  [sym_fsi_directive_decl] = "fsi_directive_decl",
  [sym_preproc_line] = "preproc_line",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_if_in_expression] = "preproc_if",
  [sym_preproc_else_in_expression] = "preproc_else",
  [sym_preproc_if_in_class_definition] = "preproc_if",
  [sym_preproc_else_in_class_definition] = "preproc_else",
  [aux_sym_file_repeat1] = "file_repeat1",
  [aux_sym_file_repeat2] = "file_repeat2",
  [aux_sym_attributes_repeat1] = "attributes_repeat1",
  [aux_sym_attribute_set_repeat1] = "attribute_set_repeat1",
  [aux_sym__function_or_value_defns_repeat1] = "_function_or_value_defns_repeat1",
  [aux_sym_repeat_pattern_repeat1] = "repeat_pattern_repeat1",
  [aux_sym_argument_patterns_repeat1] = "argument_patterns_repeat1",
  [aux_sym__list_pattern_content_repeat1] = "_list_pattern_content_repeat1",
  [aux_sym_record_pattern_repeat1] = "record_pattern_repeat1",
  [aux_sym__object_expression_inner_repeat1] = "_object_expression_inner_repeat1",
  [aux_sym_if_expression_repeat1] = "if_expression_repeat1",
  [aux_sym__list_elements_repeat1] = "_list_elements_repeat1",
  [aux_sym_rules_repeat1] = "rules_repeat1",
  [aux_sym_sequential_expression_repeat1] = "sequential_expression_repeat1",
  [aux_sym_slice_ranges_repeat1] = "slice_ranges_repeat1",
  [aux_sym__compound_type_repeat1] = "_compound_type_repeat1",
  [aux_sym_types_repeat1] = "types_repeat1",
  [aux_sym_type_attributes_repeat1] = "type_attributes_repeat1",
  [aux_sym_type_argument_constraints_repeat1] = "type_argument_constraints_repeat1",
  [aux_sym_type_argument_repeat1] = "type_argument_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_curried_spec_repeat1] = "curried_spec_repeat1",
  [aux_sym_arguments_spec_repeat1] = "arguments_spec_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__class_type_body_repeat1] = "_class_type_body_repeat1",
  [aux_sym_record_fields_repeat1] = "record_fields_repeat1",
  [aux_sym_enum_type_cases_repeat1] = "enum_type_cases_repeat1",
  [aux_sym_union_type_cases_repeat1] = "union_type_cases_repeat1",
  [aux_sym_union_type_fields_repeat1] = "union_type_fields_repeat1",
  [aux_sym__member_defns_repeat1] = "_member_defns_repeat1",
  [aux_sym__method_defn_repeat1] = "_method_defn_repeat1",
  [aux_sym_field_initializers_repeat1] = "field_initializers_repeat1",
  [aux_sym_format_string_repeat1] = "format_string_repeat1",
  [aux_sym__string_literal_repeat1] = "_string_literal_repeat1",
  [aux_sym_verbatim_string_repeat1] = "verbatim_string_repeat1",
  [aux_sym_long_identifier_repeat1] = "long_identifier_repeat1",
  [aux_sym_active_pattern_repeat1] = "active_pattern_repeat1",
  [aux_sym_prefix_op_repeat1] = "prefix_op_repeat1",
  [aux_sym_preproc_if_in_expression_repeat1] = "preproc_if_in_expression_repeat1",
  [aux_sym_preproc_if_in_class_definition_repeat1] = "preproc_if_in_class_definition_repeat1",
  [alias_sym_active_pattern_op_name] = "active_pattern_op_name",
  [alias_sym_wildcard_active_pattern_op] = "wildcard_active_pattern_op",
  [alias_sym_wildcard_pattern] = "wildcard_pattern",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_rec] = anon_sym_rec,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_LBRACK_LT] = anon_sym_LBRACK_LT,
  [anon_sym_GT_RBRACK] = anon_sym_GT_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_let_BANG] = anon_sym_let_BANG,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_mutable] = anon_sym_mutable,
  [aux_sym_access_modifier_token1] = aux_sym_access_modifier_token1,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_null] = anon_sym_null,
  [anon_sym__] = anon_sym__,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON_QMARK] = anon_sym_COLON_QMARK,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_PIPE] = anon_sym_LBRACK_PIPE,
  [anon_sym_PIPE_RBRACK] = anon_sym_PIPE_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_LT_AT] = anon_sym_LT_AT,
  [anon_sym_AT_GT] = anon_sym_AT_GT,
  [anon_sym_LT_AT_AT] = anon_sym_LT_AT_AT,
  [anon_sym_AT_AT_GT] = anon_sym_AT_AT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_return_BANG] = anon_sym_return_BANG,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_yield_BANG] = anon_sym_yield_BANG,
  [anon_sym_lazy] = anon_sym_lazy,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_upcast] = anon_sym_upcast,
  [anon_sym_downcast] = anon_sym_downcast,
  [anon_sym_COLON_GT] = anon_sym_COLON_GT,
  [anon_sym_COLON_QMARK_GT] = anon_sym_COLON_QMARK_GT,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_downto] = anon_sym_downto,
  [anon_sym_done] = anon_sym_done,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_fun] = anon_sym_fun,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_match_BANG] = anon_sym_match_BANG,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_DOT_LBRACK] = anon_sym_DOT_LBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_use_BANG] = anon_sym_use_BANG,
  [anon_sym_do_BANG] = anon_sym_do_BANG,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT2] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT3] = anon_sym_DOT_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_unit] = anon_sym_unit,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_equality] = anon_sym_equality,
  [anon_sym_comparison] = anon_sym_comparison,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_member] = anon_sym_member,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_id] = anon_sym_id,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_val] = anon_sym_val,
  [anon_sym_inherit] = anon_sym_inherit,
  [anon_sym_EQ2] = anon_sym_EQ,
  [sym__escape_char] = sym__escape_char,
  [sym__non_escape_char] = sym__non_escape_char,
  [sym__unicodegraph_short] = sym__unicodegraph_short,
  [sym__unicodegraph_long] = sym__unicodegraph_long,
  [sym__trigraph] = sym__trigraph,
  [aux_sym__simple_string_char_token1] = aux_sym__simple_string_char_token1,
  [aux_sym_char_token1] = aux_sym_char_token1,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_DOLLAR_DQUOTE] = anon_sym_DOLLAR_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym__verbatim_string_char_token1] = aux_sym__verbatim_string_char_token1,
  [anon_sym_AT_DQUOTE] = anon_sym_AT_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [anon_sym_DQUOTEB] = anon_sym_DQUOTEB,
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [sym_bool] = sym_bool,
  [sym_unit] = sym_unit,
  [anon_sym_LPAREN_PIPE] = anon_sym_LPAREN_PIPE,
  [anon_sym_PIPE_RPAREN] = anon_sym_PIPE_RPAREN,
  [sym_op_identifier] = sym_op_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_DOT] = anon_sym_PLUS_DOT,
  [anon_sym_DASH_DOT] = anon_sym_DASH_DOT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [aux_sym_prefix_op_token1] = aux_sym_prefix_op_token1,
  [aux_sym_infix_op_token1] = aux_sym_infix_op_token1,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_QMARK_LT_DASH] = anon_sym_QMARK_LT_DASH,
  [sym_int] = sym_int,
  [sym_xint] = sym_xint,
  [anon_sym_y] = anon_sym_y,
  [anon_sym_uy] = anon_sym_uy,
  [anon_sym_s] = anon_sym_s,
  [anon_sym_us] = anon_sym_us,
  [anon_sym_l] = anon_sym_l,
  [aux_sym_uint32_token1] = aux_sym_uint32_token1,
  [anon_sym_n] = anon_sym_n,
  [anon_sym_un] = anon_sym_un,
  [anon_sym_L] = anon_sym_L,
  [aux_sym_uint64_token1] = aux_sym_uint64_token1,
  [anon_sym_f] = anon_sym_f,
  [anon_sym_lf] = anon_sym_lf,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_bignum_token1] = aux_sym_bignum_token1,
  [aux_sym_decimal_token1] = aux_sym_decimal_token1,
  [anon_sym_DOT2] = anon_sym_DOT2,
  [aux_sym_float_token1] = anon_sym_DOT2,
  [anon_sym_SLASH_SLASH_SLASH] = anon_sym_SLASH_SLASH_SLASH,
  [aux_sym_xml_doc_token1] = aux_sym_xml_doc_token1,
  [anon_sym_LPAREN_STAR] = anon_sym_LPAREN_STAR,
  [anon_sym_STAR_RPAREN] = anon_sym_STAR_RPAREN,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [aux_sym_line_comment_token1] = aux_sym_line_comment_token1,
  [anon_sym_POUNDnowarn] = anon_sym_POUNDnowarn,
  [aux_sym_compiler_directive_decl_token1] = aux_sym_compiler_directive_decl_token1,
  [anon_sym_POUNDr] = anon_sym_POUNDr,
  [anon_sym_POUNDload] = anon_sym_POUNDload,
  [aux_sym_preproc_line_token1] = aux_sym_preproc_line_token1,
  [anon_sym_POUNDif] = anon_sym_POUNDif,
  [anon_sym_POUNDendif] = anon_sym_POUNDendif,
  [anon_sym_POUNDelse] = anon_sym_POUNDelse,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym__triple_quoted_content] = sym__triple_quoted_content,
  [sym_block_comment_content] = sym_block_comment_content,
  [sym__inside_string_marker] = sym__inside_string_marker,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_file] = sym_file,
  [sym_namespace] = sym_namespace,
  [sym_named_module] = sym_named_module,
  [sym_module_abbrev] = sym_module_abbrev,
  [sym_module_defn] = sym_module_defn,
  [sym_import_decl] = sym_import_decl,
  [sym_attributes] = sym_attributes,
  [sym_attribute_set] = sym_attribute_set,
  [sym_attribute] = sym_attribute,
  [sym_attribute_target] = sym_attribute_target,
  [sym_object_construction] = sym_object_construction,
  [sym_value_declaration] = sym_value_declaration,
  [sym_do] = sym_do,
  [sym__function_or_value_defns] = sym__function_or_value_defns,
  [sym_function_or_value_defn] = sym_function_or_value_defn,
  [sym__function_or_value_defn_body] = sym__function_or_value_defn_body,
  [sym_function_declaration_left] = sym_function_declaration_left,
  [sym_value_declaration_left] = sym_value_declaration_left,
  [sym_access_modifier] = sym_access_modifier,
  [sym_class_as_reference] = sym_class_as_reference,
  [sym_primary_constr_args] = sym_primary_constr_args,
  [sym_repeat_pattern] = sym_repeat_pattern,
  [sym__pattern] = sym__pattern,
  [sym_optional_pattern] = sym_optional_pattern,
  [sym_type_check_pattern] = sym_type_check_pattern,
  [sym_attribute_pattern] = sym_attribute_pattern,
  [sym_paren_pattern] = sym_paren_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym_cons_pattern] = sym_cons_pattern,
  [sym_disjunct_pattern] = sym_disjunct_pattern,
  [sym_conjunct_pattern] = sym_conjunct_pattern,
  [sym_typed_pattern] = sym_typed_pattern,
  [sym_argument_patterns] = sym_argument_patterns,
  [sym_field_pattern] = sym_field_pattern,
  [sym__atomic_pattern] = sym__atomic_pattern,
  [sym__list_pattern_content] = sym__list_pattern_content,
  [sym_list_pattern] = sym_list_pattern,
  [sym_array_pattern] = sym_array_pattern,
  [sym_record_pattern] = sym_record_pattern,
  [sym_identifier_pattern] = sym_identifier_pattern,
  [sym__pattern_param] = sym__pattern_param,
  [sym__expression_block] = sym__expression_block,
  [sym__expression] = sym__expression,
  [sym_literal_expression] = sym_literal_expression,
  [sym_long_identifier_or_op] = sym_long_identifier_or_op,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_brace_expression] = sym_brace_expression,
  [sym_anon_record_expression] = sym_anon_record_expression,
  [sym_with_field_expression] = sym_with_field_expression,
  [sym_object_expression] = sym_object_expression,
  [sym_prefixed_expression] = sym_prefixed_expression,
  [sym_typecast_expression] = sym_typecast_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_while_expression] = sym_while_expression,
  [sym__else_expression] = sym__else_expression,
  [sym_elif_expression] = sym_elif_expression,
  [sym__if_branch] = sym__if_branch,
  [sym_if_expression] = sym_if_expression,
  [sym_fun_expression] = sym_fun_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_match_expression] = sym_match_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_object_instantiation_expression] = sym_object_instantiation_expression,
  [sym_mutate_expression] = sym_mutate_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_dot_expression] = sym_dot_expression,
  [sym_typed_expression] = sym_typed_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_do_expression] = sym_do_expression,
  [sym__list_elements] = sym__list_elements,
  [sym__list_element] = sym__list_element,
  [sym_list_expression] = sym_list_expression,
  [sym_array_expression] = sym_array_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_rule] = sym_rule,
  [sym_rules] = sym_rules,
  [sym_begin_end_expression] = sym_begin_end_expression,
  [sym_paren_expression] = sym_paren_expression,
  [sym_application_expression] = sym_application_expression,
  [sym_infix_expression] = sym_infix_expression,
  [sym_ce_expression] = sym_ce_expression,
  [sym_sequential_expression] = sym_sequential_expression,
  [sym__comp_or_range_expression] = sym__comp_or_range_expression,
  [sym_short_comp_expression] = sym_short_comp_expression,
  [sym_slice_ranges] = sym_slice_ranges,
  [sym__slice_range_special] = sym__slice_range_special,
  [sym_slice_range] = sym_slice_range,
  [sym_type] = sym_type,
  [sym__simple_type] = sym__simple_type,
  [sym__generic_type] = sym__generic_type,
  [sym__paren_type] = sym__paren_type,
  [sym__function_type] = sym__function_type,
  [sym__compound_type] = sym__compound_type,
  [sym__postfix_type] = sym__postfix_type,
  [sym__list_type] = sym__list_type,
  [sym__static_type] = sym__static_type,
  [sym__constrained_type] = sym__constrained_type,
  [sym__flexible_type] = sym__flexible_type,
  [sym_types] = sym_types,
  [sym__static_type_identifier] = sym__static_type_identifier,
  [sym__static_parameter] = sym__static_parameter,
  [sym_named_static_parameter] = sym_named_static_parameter,
  [sym_static_parameter_value] = sym_static_parameter_value,
  [sym_type_attribute] = sym_type_attribute,
  [sym_type_attributes] = sym_type_attributes,
  [sym_atomic_type] = sym_atomic_type,
  [sym_constraint] = sym_constraint,
  [sym_type_argument_constraints] = sym_type_argument_constraints,
  [sym_type_argument] = sym_type_argument,
  [sym_type_argument_defn] = sym_type_argument_defn,
  [sym_type_arguments] = sym_type_arguments,
  [sym_trait_member_constraint] = sym_trait_member_constraint,
  [sym_member_signature] = sym_member_signature,
  [sym_curried_spec] = sym_curried_spec,
  [sym_argument_spec] = sym_argument_spec,
  [sym_arguments_spec] = sym_arguments_spec,
  [sym_argument_name_spec] = sym_argument_name_spec,
  [sym_type_definition] = sym_type_definition,
  [sym__type_defn_body] = sym__type_defn_body,
  [sym_type_name] = sym_type_name,
  [sym_type_extension] = sym_type_extension,
  [sym_delegate_type_defn] = sym_delegate_type_defn,
  [sym_delegate_signature] = sym_delegate_signature,
  [sym_type_abbrev_defn] = sym_type_abbrev_defn,
  [sym__class_type_body_inner] = sym__class_type_body_inner,
  [sym__class_type_body] = sym__class_type_body,
  [sym_record_type_defn] = sym_record_type_defn,
  [sym_record_fields] = sym_record_fields,
  [sym_record_field] = sym_record_field,
  [sym_enum_type_defn] = sym_enum_type_defn,
  [sym_enum_type_cases] = sym_enum_type_cases,
  [sym_enum_type_case] = sym_enum_type_case,
  [sym_union_type_defn] = sym_union_type_defn,
  [sym_union_type_cases] = sym_union_type_cases,
  [sym_union_type_case] = sym_union_type_case,
  [sym_union_type_fields] = sym_union_type_fields,
  [sym_union_type_field] = sym_union_type_field,
  [sym_anon_type_defn] = sym_anon_type_defn,
  [sym__class_function_or_value_defn] = sym__class_function_or_value_defn,
  [sym_type_extension_elements] = sym_type_extension_elements,
  [sym__type_defn_elements] = sym__type_defn_elements,
  [sym_interface_implementation] = sym_interface_implementation,
  [sym__member_defns] = sym__member_defns,
  [sym__object_members] = sym__object_members,
  [sym_member_defn] = sym_member_defn,
  [sym_property_or_ident] = sym_property_or_ident,
  [sym__method_defn] = sym__method_defn,
  [sym__property_defn] = sym__property_defn,
  [sym_method_or_prop_defn] = sym_method_or_prop_defn,
  [sym_additional_constr_defn] = sym_additional_constr_defn,
  [sym_class_inherits_decl] = sym_class_inherits_decl,
  [sym_field_initializer] = sym_field_initializer,
  [sym_field_initializers] = sym_field_initializers,
  [sym__simple_string_char] = sym__simple_string_char,
  [sym__string_char] = sym__string_char,
  [sym_char] = sym_char,
  [sym_format_string_eval] = sym_format_string_eval,
  [sym_format_string] = sym_format_string,
  [sym__string_literal] = sym__string_literal,
  [sym_string] = sym_string,
  [sym__verbatim_string_char] = sym__verbatim_string_char,
  [sym_verbatim_string] = sym_verbatim_string,
  [sym_bytearray] = sym_bytearray,
  [sym_verbatim_bytearray] = sym_verbatim_bytearray,
  [sym_format_triple_quoted_string] = sym_format_triple_quoted_string,
  [sym_triple_quoted_string] = sym_triple_quoted_string,
  [sym_const] = sym_const,
  [sym_long_identifier] = sym_long_identifier,
  [sym_active_pattern] = sym_active_pattern,
  [sym__identifier_or_op] = sym__identifier_or_op,
  [sym__infix_or_prefix_op] = sym__infix_or_prefix_op,
  [sym_prefix_op] = sym_prefix_op,
  [sym_infix_op] = sym_infix_op,
  [sym_sbyte] = sym_sbyte,
  [sym_byte] = sym_byte,
  [sym_int16] = sym_int16,
  [sym_uint16] = sym_uint16,
  [sym_int32] = sym_int32,
  [sym_uint32] = sym_uint32,
  [sym_nativeint] = sym_nativeint,
  [sym_unativeint] = sym_unativeint,
  [sym_int64] = sym_int64,
  [sym_uint64] = sym_uint64,
  [sym_ieee32] = sym_ieee32,
  [sym_ieee64] = sym_ieee64,
  [sym_bignum] = sym_bignum,
  [sym_decimal] = sym_decimal,
  [sym_float] = sym_float,
  [sym_xml_doc] = sym_xml_doc,
  [sym_block_comment] = sym_block_comment,
  [sym_line_comment] = sym_line_comment,
  [sym_compiler_directive_decl] = sym_compiler_directive_decl,
  [sym_fsi_directive_decl] = sym_fsi_directive_decl,
  [sym_preproc_line] = sym_preproc_line,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_if_in_expression] = sym_preproc_if,
  [sym_preproc_else_in_expression] = sym_preproc_else,
  [sym_preproc_if_in_class_definition] = sym_preproc_if,
  [sym_preproc_else_in_class_definition] = sym_preproc_else,
  [aux_sym_file_repeat1] = aux_sym_file_repeat1,
  [aux_sym_file_repeat2] = aux_sym_file_repeat2,
  [aux_sym_attributes_repeat1] = aux_sym_attributes_repeat1,
  [aux_sym_attribute_set_repeat1] = aux_sym_attribute_set_repeat1,
  [aux_sym__function_or_value_defns_repeat1] = aux_sym__function_or_value_defns_repeat1,
  [aux_sym_repeat_pattern_repeat1] = aux_sym_repeat_pattern_repeat1,
  [aux_sym_argument_patterns_repeat1] = aux_sym_argument_patterns_repeat1,
  [aux_sym__list_pattern_content_repeat1] = aux_sym__list_pattern_content_repeat1,
  [aux_sym_record_pattern_repeat1] = aux_sym_record_pattern_repeat1,
  [aux_sym__object_expression_inner_repeat1] = aux_sym__object_expression_inner_repeat1,
  [aux_sym_if_expression_repeat1] = aux_sym_if_expression_repeat1,
  [aux_sym__list_elements_repeat1] = aux_sym__list_elements_repeat1,
  [aux_sym_rules_repeat1] = aux_sym_rules_repeat1,
  [aux_sym_sequential_expression_repeat1] = aux_sym_sequential_expression_repeat1,
  [aux_sym_slice_ranges_repeat1] = aux_sym_slice_ranges_repeat1,
  [aux_sym__compound_type_repeat1] = aux_sym__compound_type_repeat1,
  [aux_sym_types_repeat1] = aux_sym_types_repeat1,
  [aux_sym_type_attributes_repeat1] = aux_sym_type_attributes_repeat1,
  [aux_sym_type_argument_constraints_repeat1] = aux_sym_type_argument_constraints_repeat1,
  [aux_sym_type_argument_repeat1] = aux_sym_type_argument_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_curried_spec_repeat1] = aux_sym_curried_spec_repeat1,
  [aux_sym_arguments_spec_repeat1] = aux_sym_arguments_spec_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__class_type_body_repeat1] = aux_sym__class_type_body_repeat1,
  [aux_sym_record_fields_repeat1] = aux_sym_record_fields_repeat1,
  [aux_sym_enum_type_cases_repeat1] = aux_sym_enum_type_cases_repeat1,
  [aux_sym_union_type_cases_repeat1] = aux_sym_union_type_cases_repeat1,
  [aux_sym_union_type_fields_repeat1] = aux_sym_union_type_fields_repeat1,
  [aux_sym__member_defns_repeat1] = aux_sym__member_defns_repeat1,
  [aux_sym__method_defn_repeat1] = aux_sym__method_defn_repeat1,
  [aux_sym_field_initializers_repeat1] = aux_sym_field_initializers_repeat1,
  [aux_sym_format_string_repeat1] = aux_sym_format_string_repeat1,
  [aux_sym__string_literal_repeat1] = aux_sym__string_literal_repeat1,
  [aux_sym_verbatim_string_repeat1] = aux_sym_verbatim_string_repeat1,
  [aux_sym_long_identifier_repeat1] = aux_sym_long_identifier_repeat1,
  [aux_sym_active_pattern_repeat1] = aux_sym_active_pattern_repeat1,
  [aux_sym_prefix_op_repeat1] = aux_sym_prefix_op_repeat1,
  [aux_sym_preproc_if_in_expression_repeat1] = aux_sym_preproc_if_in_expression_repeat1,
  [aux_sym_preproc_if_in_class_definition_repeat1] = aux_sym_preproc_if_in_class_definition_repeat1,
  [alias_sym_active_pattern_op_name] = alias_sym_active_pattern_op_name,
  [alias_sym_wildcard_active_pattern_op] = alias_sym_wildcard_active_pattern_op,
  [alias_sym_wildcard_pattern] = alias_sym_wildcard_pattern,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_access_modifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lazy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comparison] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_member] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_id] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_val] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inherit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ2] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_char] = {
    .visible = false,
    .named = true,
  },
  [sym__non_escape_char] = {
    .visible = false,
    .named = true,
  },
  [sym__unicodegraph_short] = {
    .visible = false,
    .named = true,
  },
  [sym__unicodegraph_long] = {
    .visible = false,
    .named = true,
  },
  [sym__trigraph] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__simple_string_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__verbatim_string_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEB] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_op_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_prefix_op_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_infix_op_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_xint] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_y] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_s] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_us] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_l] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint32_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_n] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_un] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_L] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint64_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_f] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_bignum_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decimal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOT2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_float_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_xml_doc_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_line_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUNDnowarn] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_compiler_directive_decl_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUNDr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDload] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_line_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDendif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDelse] = {
    .visible = true,
    .named = false,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__triple_quoted_content] = {
    .visible = false,
    .named = true,
  },
  [sym_block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__inside_string_marker] = {
    .visible = false,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym_named_module] = {
    .visible = true,
    .named = true,
  },
  [sym_module_abbrev] = {
    .visible = true,
    .named = true,
  },
  [sym_module_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_import_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_set] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_target] = {
    .visible = true,
    .named = true,
  },
  [sym_object_construction] = {
    .visible = true,
    .named = true,
  },
  [sym_value_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym__function_or_value_defns] = {
    .visible = false,
    .named = true,
  },
  [sym_function_or_value_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__function_or_value_defn_body] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration_left] = {
    .visible = true,
    .named = true,
  },
  [sym_value_declaration_left] = {
    .visible = true,
    .named = true,
  },
  [sym_access_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_as_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_constr_args] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_optional_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_type_check_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_cons_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_conjunct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__atomic_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__list_pattern_content] = {
    .visible = false,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_param] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_block] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_long_identifier_or_op] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_brace_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_record_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typecast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__else_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_elif_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__if_branch] = {
    .visible = false,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_fun_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_mutate_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_do_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__list_elements] = {
    .visible = false,
    .named = true,
  },
  [sym__list_element] = {
    .visible = false,
    .named = true,
  },
  [sym_list_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_rules] = {
    .visible = true,
    .named = true,
  },
  [sym_begin_end_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_application_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ce_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequential_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comp_or_range_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_short_comp_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_ranges] = {
    .visible = true,
    .named = true,
  },
  [sym__slice_range_special] = {
    .visible = false,
    .named = true,
  },
  [sym_slice_range] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_type] = {
    .visible = false,
    .named = true,
  },
  [sym__generic_type] = {
    .visible = false,
    .named = true,
  },
  [sym__paren_type] = {
    .visible = false,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym__compound_type] = {
    .visible = false,
    .named = true,
  },
  [sym__postfix_type] = {
    .visible = false,
    .named = true,
  },
  [sym__list_type] = {
    .visible = false,
    .named = true,
  },
  [sym__static_type] = {
    .visible = false,
    .named = true,
  },
  [sym__constrained_type] = {
    .visible = false,
    .named = true,
  },
  [sym__flexible_type] = {
    .visible = false,
    .named = true,
  },
  [sym_types] = {
    .visible = true,
    .named = true,
  },
  [sym__static_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__static_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_named_static_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_static_parameter_value] = {
    .visible = true,
    .named = true,
  },
  [sym_type_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_type_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_member_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_member_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_curried_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_name_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_defn_body] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_extension] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_abbrev_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__class_type_body_inner] = {
    .visible = false,
    .named = true,
  },
  [sym__class_type_body] = {
    .visible = false,
    .named = true,
  },
  [sym_record_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_record_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_field] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__class_function_or_value_defn] = {
    .visible = false,
    .named = true,
  },
  [sym_type_extension_elements] = {
    .visible = true,
    .named = true,
  },
  [sym__type_defn_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_implementation] = {
    .visible = true,
    .named = true,
  },
  [sym__member_defns] = {
    .visible = false,
    .named = true,
  },
  [sym__object_members] = {
    .visible = false,
    .named = true,
  },
  [sym_member_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_property_or_ident] = {
    .visible = true,
    .named = true,
  },
  [sym__method_defn] = {
    .visible = false,
    .named = true,
  },
  [sym__property_defn] = {
    .visible = false,
    .named = true,
  },
  [sym_method_or_prop_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_additional_constr_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_class_inherits_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializers] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_char] = {
    .visible = false,
    .named = true,
  },
  [sym__string_char] = {
    .visible = false,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_format_string_eval] = {
    .visible = true,
    .named = true,
  },
  [sym_format_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_string_char] = {
    .visible = false,
    .named = true,
  },
  [sym_verbatim_string] = {
    .visible = true,
    .named = true,
  },
  [sym_bytearray] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_bytearray] = {
    .visible = true,
    .named = true,
  },
  [sym_format_triple_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_triple_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_const] = {
    .visible = true,
    .named = true,
  },
  [sym_long_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_active_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_op] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_or_prefix_op] = {
    .visible = false,
    .named = true,
  },
  [sym_prefix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_sbyte] = {
    .visible = true,
    .named = true,
  },
  [sym_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_int16] = {
    .visible = true,
    .named = true,
  },
  [sym_uint16] = {
    .visible = true,
    .named = true,
  },
  [sym_int32] = {
    .visible = true,
    .named = true,
  },
  [sym_uint32] = {
    .visible = true,
    .named = true,
  },
  [sym_nativeint] = {
    .visible = true,
    .named = true,
  },
  [sym_unativeint] = {
    .visible = true,
    .named = true,
  },
  [sym_int64] = {
    .visible = true,
    .named = true,
  },
  [sym_uint64] = {
    .visible = true,
    .named = true,
  },
  [sym_ieee32] = {
    .visible = true,
    .named = true,
  },
  [sym_ieee64] = {
    .visible = true,
    .named = true,
  },
  [sym_bignum] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_xml_doc] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_compiler_directive_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_fsi_directive_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_line] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_class_definition] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_file_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_or_value_defns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_repeat_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_pattern_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__object_expression_inner_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rules_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequential_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_ranges_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__compound_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curried_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_type_cases_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_cases_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__member_defns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__method_defn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_verbatim_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_long_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_active_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefix_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_class_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_active_pattern_op_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard_active_pattern_op] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard_pattern] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_args = 2,
  field_assignee = 3,
  field_base = 4,
  field_block = 5,
  field_body = 6,
  field_condition = 7,
  field_constraints = 8,
  field_else = 9,
  field_field = 10,
  field_from = 11,
  field_guard = 12,
  field_in = 13,
  field_index = 14,
  field_instance = 15,
  field_method = 16,
  field_name = 17,
  field_pattern = 18,
  field_then = 19,
  field_to = 20,
  field_type_name = 21,
  field_value = 22,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_args] = "args",
  [field_assignee] = "assignee",
  [field_base] = "base",
  [field_block] = "block",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_constraints] = "constraints",
  [field_else] = "else",
  [field_field] = "field",
  [field_from] = "from",
  [field_guard] = "guard",
  [field_in] = "in",
  [field_index] = "index",
  [field_instance] = "instance",
  [field_method] = "method",
  [field_name] = "name",
  [field_pattern] = "pattern",
  [field_then] = "then",
  [field_to] = "to",
  [field_type_name] = "type_name",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [7] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 2},
  [10] = {.index = 7, .length = 1},
  [11] = {.index = 8, .length = 1},
  [12] = {.index = 9, .length = 1},
  [13] = {.index = 10, .length = 1},
  [14] = {.index = 11, .length = 2},
  [18] = {.index = 13, .length = 2},
  [19] = {.index = 15, .length = 2},
  [20] = {.index = 17, .length = 2},
  [22] = {.index = 19, .length = 1},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 23, .length = 1},
  [26] = {.index = 24, .length = 1},
  [27] = {.index = 25, .length = 1},
  [28] = {.index = 26, .length = 3},
  [29] = {.index = 29, .length = 1},
  [30] = {.index = 30, .length = 1},
  [31] = {.index = 31, .length = 1},
  [32] = {.index = 32, .length = 3},
  [33] = {.index = 35, .length = 1},
  [34] = {.index = 36, .length = 2},
  [35] = {.index = 38, .length = 1},
  [36] = {.index = 39, .length = 1},
  [37] = {.index = 40, .length = 3},
  [38] = {.index = 43, .length = 1},
  [39] = {.index = 44, .length = 2},
  [40] = {.index = 46, .length = 2},
  [41] = {.index = 48, .length = 2},
  [42] = {.index = 50, .length = 1},
  [45] = {.index = 51, .length = 2},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 3},
  [48] = {.index = 57, .length = 3},
  [49] = {.index = 60, .length = 3},
  [50] = {.index = 63, .length = 2},
  [51] = {.index = 65, .length = 4},
  [52] = {.index = 69, .length = 1},
  [54] = {.index = 70, .length = 2},
  [55] = {.index = 72, .length = 3},
  [56] = {.index = 75, .length = 4},
  [57] = {.index = 79, .length = 1},
  [58] = {.index = 80, .length = 5},
  [59] = {.index = 85, .length = 1},
  [60] = {.index = 86, .length = 3},
  [61] = {.index = 89, .length = 2},
  [62] = {.index = 91, .length = 5},
  [63] = {.index = 96, .length = 1},
  [64] = {.index = 97, .length = 3},
  [65] = {.index = 100, .length = 4},
  [66] = {.index = 104, .length = 7},
  [67] = {.index = 111, .length = 8},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_type_name, 0},
  [2] =
    {field_body, 1, .inherited = true},
  [3] =
    {field_guard, 1},
  [4] =
    {field_in, 1},
  [5] =
    {field_name, 1},
    {field_name, 2},
  [7] =
    {field_name, 2},
  [8] =
    {field_type_name, 1},
  [9] =
    {field_body, 2, .inherited = true},
  [10] =
    {field_body, 0, .inherited = true},
  [11] =
    {field_from, 0, .inherited = true},
    {field_to, 0, .inherited = true},
  [13] =
    {field_base, 0},
    {field_field, 2},
  [15] =
    {field_assignee, 0},
    {field_value, 2},
  [17] =
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [19] =
    {field_type_name, 2},
  [20] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
  [22] =
    {field_block, 1, .inherited = true},
  [23] =
    {field_body, 2},
  [24] =
    {field_to, 1},
  [25] =
    {field_from, 0},
  [26] =
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
  [29] =
    {field_condition, 1},
  [30] =
    {field_name, 3},
  [31] =
    {field_index, 2},
  [32] =
    {field_else, 3, .inherited = true},
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [35] =
    {field_type_name, 3},
  [36] =
    {field_args, 1, .inherited = true},
    {field_name, 0},
  [38] =
    {field_name, 0},
  [39] =
    {field_block, 2, .inherited = true},
  [40] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
  [43] =
    {field_constraints, 3},
  [44] =
    {field_from, 0},
    {field_to, 2},
  [46] =
    {field_field, 0},
    {field_value, 2},
  [48] =
    {field_block, 2},
    {field_pattern, 0},
  [50] =
    {field_in, 4},
  [51] =
    {field_alternative, 3},
    {field_condition, 1},
  [53] =
    {field_else, 1},
  [54] =
    {field_else, 4, .inherited = true},
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [57] =
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
  [60] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [63] =
    {field_instance, 0},
    {field_method, 2},
  [65] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
  [69] =
    {field_body, 4},
  [70] =
    {field_alternative, 4},
    {field_condition, 1},
  [72] =
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
  [75] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
  [79] =
    {field_args, 0},
  [80] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [85] =
    {field_block, 4, .inherited = true},
  [86] =
    {field_block, 4},
    {field_guard, 2},
    {field_pattern, 0},
  [89] =
    {field_guard, 1},
    {field_then, 3},
  [91] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_body, 3, .inherited = true},
    {field_name, 0},
  [96] =
    {field_args, 1},
  [97] =
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
  [100] =
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [104] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
    {field_block, 8},
  [111] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
    {field_block, 8},
    {field_block, 9},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = alias_sym_wildcard_pattern,
  },
  [6] = {
    [0] = anon_sym_DOT2,
  },
  [8] = {
    [1] = sym_string,
  },
  [15] = {
    [1] = alias_sym_active_pattern_op_name,
  },
  [16] = {
    [0] = anon_sym_DOT2,
    [2] = anon_sym_DOT2,
  },
  [17] = {
    [0] = anon_sym_SEMI,
  },
  [21] = {
    [2] = sym_string,
  },
  [43] = {
    [1] = alias_sym_active_pattern_op_name,
    [3] = alias_sym_wildcard_active_pattern_op,
  },
  [44] = {
    [0] = anon_sym_DOT2,
    [2] = anon_sym_DOT2,
    [4] = anon_sym_DOT2,
  },
  [53] = {
    [1] = alias_sym_active_pattern_op_name,
    [4] = alias_sym_wildcard_active_pattern_op,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__string_literal, 2,
    sym__string_literal,
    sym_string,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 7,
  [12] = 2,
  [13] = 9,
  [14] = 6,
  [15] = 3,
  [16] = 10,
  [17] = 8,
  [18] = 5,
  [19] = 4,
  [20] = 20,
  [21] = 20,
  [22] = 6,
  [23] = 3,
  [24] = 6,
  [25] = 2,
  [26] = 8,
  [27] = 3,
  [28] = 2,
  [29] = 10,
  [30] = 9,
  [31] = 5,
  [32] = 8,
  [33] = 10,
  [34] = 7,
  [35] = 4,
  [36] = 5,
  [37] = 20,
  [38] = 9,
  [39] = 7,
  [40] = 4,
  [41] = 41,
  [42] = 42,
  [43] = 42,
  [44] = 6,
  [45] = 42,
  [46] = 3,
  [47] = 4,
  [48] = 7,
  [49] = 42,
  [50] = 50,
  [51] = 8,
  [52] = 5,
  [53] = 2,
  [54] = 10,
  [55] = 9,
  [56] = 2,
  [57] = 57,
  [58] = 5,
  [59] = 9,
  [60] = 10,
  [61] = 2,
  [62] = 3,
  [63] = 57,
  [64] = 64,
  [65] = 64,
  [66] = 64,
  [67] = 8,
  [68] = 64,
  [69] = 64,
  [70] = 64,
  [71] = 64,
  [72] = 5,
  [73] = 73,
  [74] = 57,
  [75] = 64,
  [76] = 64,
  [77] = 4,
  [78] = 7,
  [79] = 57,
  [80] = 6,
  [81] = 4,
  [82] = 64,
  [83] = 64,
  [84] = 64,
  [85] = 85,
  [86] = 7,
  [87] = 87,
  [88] = 57,
  [89] = 89,
  [90] = 57,
  [91] = 64,
  [92] = 92,
  [93] = 9,
  [94] = 94,
  [95] = 41,
  [96] = 4,
  [97] = 10,
  [98] = 8,
  [99] = 7,
  [100] = 57,
  [101] = 6,
  [102] = 2,
  [103] = 6,
  [104] = 104,
  [105] = 5,
  [106] = 57,
  [107] = 3,
  [108] = 4,
  [109] = 7,
  [110] = 9,
  [111] = 10,
  [112] = 57,
  [113] = 2,
  [114] = 6,
  [115] = 10,
  [116] = 85,
  [117] = 9,
  [118] = 5,
  [119] = 8,
  [120] = 57,
  [121] = 8,
  [122] = 57,
  [123] = 4,
  [124] = 3,
  [125] = 6,
  [126] = 7,
  [127] = 6,
  [128] = 8,
  [129] = 7,
  [130] = 57,
  [131] = 4,
  [132] = 5,
  [133] = 9,
  [134] = 3,
  [135] = 135,
  [136] = 10,
  [137] = 2,
  [138] = 2,
  [139] = 10,
  [140] = 9,
  [141] = 8,
  [142] = 57,
  [143] = 94,
  [144] = 3,
  [145] = 3,
  [146] = 5,
  [147] = 147,
  [148] = 147,
  [149] = 149,
  [150] = 5,
  [151] = 149,
  [152] = 104,
  [153] = 3,
  [154] = 149,
  [155] = 155,
  [156] = 156,
  [157] = 149,
  [158] = 147,
  [159] = 3,
  [160] = 160,
  [161] = 89,
  [162] = 149,
  [163] = 9,
  [164] = 10,
  [165] = 2,
  [166] = 149,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 149,
  [171] = 160,
  [172] = 172,
  [173] = 160,
  [174] = 172,
  [175] = 169,
  [176] = 149,
  [177] = 149,
  [178] = 149,
  [179] = 6,
  [180] = 2,
  [181] = 3,
  [182] = 10,
  [183] = 9,
  [184] = 167,
  [185] = 147,
  [186] = 7,
  [187] = 156,
  [188] = 167,
  [189] = 149,
  [190] = 169,
  [191] = 149,
  [192] = 4,
  [193] = 147,
  [194] = 7,
  [195] = 149,
  [196] = 160,
  [197] = 4,
  [198] = 149,
  [199] = 172,
  [200] = 5,
  [201] = 169,
  [202] = 6,
  [203] = 167,
  [204] = 149,
  [205] = 149,
  [206] = 149,
  [207] = 149,
  [208] = 147,
  [209] = 149,
  [210] = 8,
  [211] = 167,
  [212] = 212,
  [213] = 8,
  [214] = 149,
  [215] = 169,
  [216] = 172,
  [217] = 160,
  [218] = 149,
  [219] = 149,
  [220] = 149,
  [221] = 92,
  [222] = 147,
  [223] = 156,
  [224] = 149,
  [225] = 212,
  [226] = 149,
  [227] = 172,
  [228] = 156,
  [229] = 147,
  [230] = 149,
  [231] = 149,
  [232] = 149,
  [233] = 167,
  [234] = 169,
  [235] = 160,
  [236] = 172,
  [237] = 147,
  [238] = 156,
  [239] = 167,
  [240] = 167,
  [241] = 160,
  [242] = 149,
  [243] = 149,
  [244] = 244,
  [245] = 6,
  [246] = 2,
  [247] = 10,
  [248] = 248,
  [249] = 249,
  [250] = 8,
  [251] = 5,
  [252] = 149,
  [253] = 4,
  [254] = 149,
  [255] = 7,
  [256] = 212,
  [257] = 156,
  [258] = 9,
  [259] = 167,
  [260] = 160,
  [261] = 172,
  [262] = 10,
  [263] = 2,
  [264] = 6,
  [265] = 167,
  [266] = 169,
  [267] = 168,
  [268] = 172,
  [269] = 169,
  [270] = 160,
  [271] = 9,
  [272] = 149,
  [273] = 149,
  [274] = 3,
  [275] = 149,
  [276] = 167,
  [277] = 7,
  [278] = 156,
  [279] = 149,
  [280] = 147,
  [281] = 149,
  [282] = 167,
  [283] = 149,
  [284] = 4,
  [285] = 7,
  [286] = 149,
  [287] = 149,
  [288] = 288,
  [289] = 167,
  [290] = 135,
  [291] = 149,
  [292] = 147,
  [293] = 293,
  [294] = 167,
  [295] = 149,
  [296] = 147,
  [297] = 160,
  [298] = 172,
  [299] = 169,
  [300] = 167,
  [301] = 149,
  [302] = 6,
  [303] = 169,
  [304] = 149,
  [305] = 156,
  [306] = 172,
  [307] = 149,
  [308] = 169,
  [309] = 8,
  [310] = 172,
  [311] = 160,
  [312] = 160,
  [313] = 5,
  [314] = 149,
  [315] = 149,
  [316] = 149,
  [317] = 172,
  [318] = 169,
  [319] = 156,
  [320] = 149,
  [321] = 147,
  [322] = 3,
  [323] = 149,
  [324] = 167,
  [325] = 325,
  [326] = 156,
  [327] = 327,
  [328] = 8,
  [329] = 9,
  [330] = 149,
  [331] = 169,
  [332] = 10,
  [333] = 149,
  [334] = 2,
  [335] = 147,
  [336] = 172,
  [337] = 160,
  [338] = 338,
  [339] = 156,
  [340] = 340,
  [341] = 149,
  [342] = 149,
  [343] = 149,
  [344] = 149,
  [345] = 5,
  [346] = 155,
  [347] = 4,
  [348] = 156,
  [349] = 3,
  [350] = 8,
  [351] = 5,
  [352] = 4,
  [353] = 156,
  [354] = 7,
  [355] = 9,
  [356] = 10,
  [357] = 2,
  [358] = 6,
  [359] = 249,
  [360] = 360,
  [361] = 361,
  [362] = 361,
  [363] = 360,
  [364] = 360,
  [365] = 360,
  [366] = 361,
  [367] = 361,
  [368] = 361,
  [369] = 361,
  [370] = 360,
  [371] = 360,
  [372] = 361,
  [373] = 361,
  [374] = 361,
  [375] = 360,
  [376] = 361,
  [377] = 360,
  [378] = 361,
  [379] = 361,
  [380] = 360,
  [381] = 360,
  [382] = 360,
  [383] = 360,
  [384] = 360,
  [385] = 361,
  [386] = 386,
  [387] = 386,
  [388] = 386,
  [389] = 386,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 398,
  [400] = 391,
  [401] = 391,
  [402] = 397,
  [403] = 397,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 398,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 404,
  [412] = 412,
  [413] = 398,
  [414] = 404,
  [415] = 404,
  [416] = 397,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 419,
  [421] = 419,
  [422] = 422,
  [423] = 423,
  [424] = 418,
  [425] = 419,
  [426] = 418,
  [427] = 423,
  [428] = 418,
  [429] = 422,
  [430] = 422,
  [431] = 422,
  [432] = 423,
  [433] = 423,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 437,
  [439] = 439,
  [440] = 439,
  [441] = 439,
  [442] = 442,
  [443] = 443,
  [444] = 443,
  [445] = 443,
  [446] = 443,
  [447] = 443,
  [448] = 442,
  [449] = 443,
  [450] = 443,
  [451] = 443,
  [452] = 442,
  [453] = 442,
  [454] = 443,
  [455] = 442,
  [456] = 443,
  [457] = 442,
  [458] = 442,
  [459] = 442,
  [460] = 443,
  [461] = 443,
  [462] = 462,
  [463] = 442,
  [464] = 443,
  [465] = 442,
  [466] = 442,
  [467] = 442,
  [468] = 443,
  [469] = 443,
  [470] = 442,
  [471] = 443,
  [472] = 443,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 475,
  [477] = 474,
  [478] = 473,
  [479] = 475,
  [480] = 475,
  [481] = 462,
  [482] = 473,
  [483] = 474,
  [484] = 475,
  [485] = 473,
  [486] = 473,
  [487] = 473,
  [488] = 475,
  [489] = 474,
  [490] = 475,
  [491] = 474,
  [492] = 474,
  [493] = 474,
  [494] = 473,
  [495] = 475,
  [496] = 475,
  [497] = 474,
  [498] = 475,
  [499] = 474,
  [500] = 475,
  [501] = 474,
  [502] = 474,
  [503] = 474,
  [504] = 473,
  [505] = 473,
  [506] = 475,
  [507] = 475,
  [508] = 474,
  [509] = 473,
  [510] = 462,
  [511] = 473,
  [512] = 473,
  [513] = 473,
  [514] = 514,
  [515] = 514,
  [516] = 514,
  [517] = 514,
  [518] = 518,
  [519] = 514,
  [520] = 514,
  [521] = 521,
  [522] = 514,
  [523] = 514,
  [524] = 514,
  [525] = 514,
  [526] = 514,
  [527] = 514,
  [528] = 518,
  [529] = 514,
  [530] = 530,
  [531] = 521,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 462,
  [536] = 533,
  [537] = 462,
  [538] = 538,
  [539] = 539,
  [540] = 538,
  [541] = 541,
  [542] = 538,
  [543] = 539,
  [544] = 538,
  [545] = 538,
  [546] = 539,
  [547] = 539,
  [548] = 539,
  [549] = 539,
  [550] = 538,
  [551] = 539,
  [552] = 539,
  [553] = 539,
  [554] = 538,
  [555] = 538,
  [556] = 539,
  [557] = 539,
  [558] = 539,
  [559] = 538,
  [560] = 541,
  [561] = 539,
  [562] = 538,
  [563] = 538,
  [564] = 538,
  [565] = 539,
  [566] = 538,
  [567] = 539,
  [568] = 539,
  [569] = 569,
  [570] = 569,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 572,
  [575] = 575,
  [576] = 576,
  [577] = 569,
  [578] = 575,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 573,
  [584] = 584,
  [585] = 585,
  [586] = 569,
  [587] = 585,
  [588] = 579,
  [589] = 569,
  [590] = 569,
  [591] = 572,
  [592] = 575,
  [593] = 581,
  [594] = 580,
  [595] = 595,
  [596] = 580,
  [597] = 572,
  [598] = 573,
  [599] = 571,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 569,
  [604] = 582,
  [605] = 569,
  [606] = 569,
  [607] = 569,
  [608] = 584,
  [609] = 579,
  [610] = 580,
  [611] = 569,
  [612] = 582,
  [613] = 613,
  [614] = 573,
  [615] = 573,
  [616] = 576,
  [617] = 613,
  [618] = 613,
  [619] = 569,
  [620] = 569,
  [621] = 569,
  [622] = 622,
  [623] = 623,
  [624] = 600,
  [625] = 622,
  [626] = 626,
  [627] = 627,
  [628] = 582,
  [629] = 569,
  [630] = 585,
  [631] = 576,
  [632] = 575,
  [633] = 602,
  [634] = 581,
  [635] = 572,
  [636] = 576,
  [637] = 580,
  [638] = 579,
  [639] = 569,
  [640] = 569,
  [641] = 582,
  [642] = 569,
  [643] = 575,
  [644] = 573,
  [645] = 581,
  [646] = 613,
  [647] = 582,
  [648] = 613,
  [649] = 572,
  [650] = 623,
  [651] = 569,
  [652] = 569,
  [653] = 584,
  [654] = 569,
  [655] = 569,
  [656] = 584,
  [657] = 569,
  [658] = 569,
  [659] = 575,
  [660] = 585,
  [661] = 575,
  [662] = 573,
  [663] = 582,
  [664] = 575,
  [665] = 575,
  [666] = 579,
  [667] = 667,
  [668] = 613,
  [669] = 572,
  [670] = 580,
  [671] = 571,
  [672] = 613,
  [673] = 569,
  [674] = 581,
  [675] = 569,
  [676] = 573,
  [677] = 581,
  [678] = 585,
  [679] = 569,
  [680] = 569,
  [681] = 576,
  [682] = 576,
  [683] = 626,
  [684] = 613,
  [685] = 571,
  [686] = 582,
  [687] = 623,
  [688] = 622,
  [689] = 569,
  [690] = 573,
  [691] = 569,
  [692] = 569,
  [693] = 569,
  [694] = 569,
  [695] = 569,
  [696] = 579,
  [697] = 569,
  [698] = 569,
  [699] = 699,
  [700] = 571,
  [701] = 573,
  [702] = 582,
  [703] = 582,
  [704] = 613,
  [705] = 705,
  [706] = 580,
  [707] = 579,
  [708] = 705,
  [709] = 600,
  [710] = 584,
  [711] = 711,
  [712] = 580,
  [713] = 576,
  [714] = 600,
  [715] = 622,
  [716] = 623,
  [717] = 623,
  [718] = 581,
  [719] = 600,
  [720] = 622,
  [721] = 576,
  [722] = 581,
  [723] = 575,
  [724] = 576,
  [725] = 569,
  [726] = 622,
  [727] = 623,
  [728] = 613,
  [729] = 571,
  [730] = 569,
  [731] = 731,
  [732] = 569,
  [733] = 600,
  [734] = 571,
  [735] = 572,
  [736] = 569,
  [737] = 627,
  [738] = 569,
  [739] = 569,
  [740] = 584,
  [741] = 572,
  [742] = 585,
  [743] = 575,
  [744] = 571,
  [745] = 585,
  [746] = 622,
  [747] = 581,
  [748] = 569,
  [749] = 575,
  [750] = 623,
  [751] = 569,
  [752] = 569,
  [753] = 571,
  [754] = 585,
  [755] = 582,
  [756] = 573,
  [757] = 581,
  [758] = 573,
  [759] = 579,
  [760] = 571,
  [761] = 576,
  [762] = 613,
  [763] = 582,
  [764] = 580,
  [765] = 582,
  [766] = 573,
  [767] = 580,
  [768] = 613,
  [769] = 581,
  [770] = 575,
  [771] = 579,
  [772] = 579,
  [773] = 584,
  [774] = 579,
  [775] = 580,
  [776] = 582,
  [777] = 600,
  [778] = 575,
  [779] = 575,
  [780] = 585,
  [781] = 573,
  [782] = 580,
  [783] = 582,
  [784] = 584,
  [785] = 622,
  [786] = 585,
  [787] = 585,
  [788] = 585,
  [789] = 585,
  [790] = 571,
  [791] = 623,
  [792] = 575,
  [793] = 584,
  [794] = 585,
  [795] = 581,
  [796] = 571,
  [797] = 573,
  [798] = 582,
  [799] = 569,
  [800] = 580,
  [801] = 579,
  [802] = 579,
  [803] = 585,
  [804] = 579,
  [805] = 576,
  [806] = 571,
  [807] = 573,
  [808] = 584,
  [809] = 569,
  [810] = 569,
  [811] = 569,
  [812] = 569,
  [813] = 572,
  [814] = 575,
  [815] = 579,
  [816] = 579,
  [817] = 569,
  [818] = 613,
  [819] = 600,
  [820] = 623,
  [821] = 622,
  [822] = 571,
  [823] = 572,
  [824] = 569,
  [825] = 584,
  [826] = 731,
  [827] = 580,
  [828] = 580,
  [829] = 600,
  [830] = 623,
  [831] = 613,
  [832] = 584,
  [833] = 569,
  [834] = 622,
  [835] = 600,
  [836] = 623,
  [837] = 585,
  [838] = 622,
  [839] = 600,
  [840] = 623,
  [841] = 622,
  [842] = 600,
  [843] = 569,
  [844] = 571,
  [845] = 569,
  [846] = 569,
  [847] = 576,
  [848] = 600,
  [849] = 623,
  [850] = 622,
  [851] = 579,
  [852] = 580,
  [853] = 572,
  [854] = 571,
  [855] = 572,
  [856] = 573,
  [857] = 581,
  [858] = 585,
  [859] = 584,
  [860] = 571,
  [861] = 582,
  [862] = 580,
  [863] = 576,
  [864] = 864,
  [865] = 864,
  [866] = 866,
  [867] = 864,
  [868] = 864,
  [869] = 866,
  [870] = 866,
  [871] = 864,
  [872] = 866,
  [873] = 864,
  [874] = 864,
  [875] = 864,
  [876] = 864,
  [877] = 864,
  [878] = 864,
  [879] = 879,
  [880] = 880,
  [881] = 866,
  [882] = 882,
  [883] = 864,
  [884] = 864,
  [885] = 864,
  [886] = 886,
  [887] = 866,
  [888] = 864,
  [889] = 864,
  [890] = 890,
  [891] = 864,
  [892] = 866,
  [893] = 866,
  [894] = 866,
  [895] = 866,
  [896] = 896,
  [897] = 866,
  [898] = 898,
  [899] = 866,
  [900] = 886,
  [901] = 882,
  [902] = 890,
  [903] = 879,
  [904] = 904,
  [905] = 866,
  [906] = 866,
  [907] = 907,
  [908] = 908,
  [909] = 880,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 880,
  [927] = 927,
  [928] = 928,
  [929] = 879,
  [930] = 930,
  [931] = 931,
  [932] = 890,
  [933] = 886,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 882,
  [938] = 938,
  [939] = 911,
  [940] = 907,
  [941] = 915,
  [942] = 913,
  [943] = 898,
  [944] = 904,
  [945] = 908,
  [946] = 912,
  [947] = 896,
  [948] = 910,
  [949] = 949,
  [950] = 914,
  [951] = 918,
  [952] = 904,
  [953] = 890,
  [954] = 954,
  [955] = 931,
  [956] = 956,
  [957] = 914,
  [958] = 938,
  [959] = 898,
  [960] = 960,
  [961] = 890,
  [962] = 879,
  [963] = 930,
  [964] = 882,
  [965] = 912,
  [966] = 966,
  [967] = 928,
  [968] = 880,
  [969] = 886,
  [970] = 927,
  [971] = 971,
  [972] = 972,
  [973] = 910,
  [974] = 974,
  [975] = 908,
  [976] = 976,
  [977] = 921,
  [978] = 978,
  [979] = 935,
  [980] = 936,
  [981] = 934,
  [982] = 922,
  [983] = 919,
  [984] = 924,
  [985] = 917,
  [986] = 986,
  [987] = 896,
  [988] = 879,
  [989] = 911,
  [990] = 915,
  [991] = 907,
  [992] = 882,
  [993] = 971,
  [994] = 913,
  [995] = 920,
  [996] = 886,
  [997] = 923,
  [998] = 998,
  [999] = 925,
  [1000] = 1000,
  [1001] = 916,
  [1002] = 880,
  [1003] = 880,
  [1004] = 1004,
  [1005] = 916,
  [1006] = 880,
  [1007] = 1007,
  [1008] = 936,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 890,
  [1013] = 971,
  [1014] = 935,
  [1015] = 921,
  [1016] = 915,
  [1017] = 886,
  [1018] = 1018,
  [1019] = 890,
  [1020] = 882,
  [1021] = 923,
  [1022] = 1022,
  [1023] = 949,
  [1024] = 927,
  [1025] = 925,
  [1026] = 922,
  [1027] = 971,
  [1028] = 934,
  [1029] = 918,
  [1030] = 886,
  [1031] = 919,
  [1032] = 928,
  [1033] = 896,
  [1034] = 930,
  [1035] = 882,
  [1036] = 924,
  [1037] = 879,
  [1038] = 917,
  [1039] = 1039,
  [1040] = 911,
  [1041] = 879,
  [1042] = 938,
  [1043] = 931,
  [1044] = 920,
  [1045] = 886,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 908,
  [1050] = 912,
  [1051] = 914,
  [1052] = 904,
  [1053] = 896,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 949,
  [1057] = 880,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 971,
  [1062] = 898,
  [1063] = 904,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 880,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 915,
  [1072] = 913,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 890,
  [1076] = 976,
  [1077] = 913,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 890,
  [1081] = 910,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 966,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 907,
  [1089] = 1089,
  [1090] = 1022,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 880,
  [1100] = 880,
  [1101] = 1101,
  [1102] = 882,
  [1103] = 1103,
  [1104] = 890,
  [1105] = 1105,
  [1106] = 879,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 911,
  [1116] = 908,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 912,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 886,
  [1124] = 882,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 879,
  [1129] = 907,
  [1130] = 971,
  [1131] = 886,
  [1132] = 882,
  [1133] = 1133,
  [1134] = 960,
  [1135] = 914,
  [1136] = 890,
  [1137] = 879,
  [1138] = 882,
  [1139] = 886,
  [1140] = 911,
  [1141] = 1141,
  [1142] = 978,
  [1143] = 1143,
  [1144] = 998,
  [1145] = 986,
  [1146] = 1146,
  [1147] = 910,
  [1148] = 879,
  [1149] = 1149,
  [1150] = 898,
  [1151] = 921,
  [1152] = 1152,
  [1153] = 915,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 956,
  [1157] = 890,
  [1158] = 1000,
  [1159] = 879,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 896,
  [1163] = 1163,
  [1164] = 974,
  [1165] = 1165,
  [1166] = 972,
  [1167] = 880,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 882,
  [1174] = 1174,
  [1175] = 890,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 886,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 954,
  [1185] = 1185,
  [1186] = 978,
  [1187] = 904,
  [1188] = 923,
  [1189] = 910,
  [1190] = 924,
  [1191] = 917,
  [1192] = 1000,
  [1193] = 1122,
  [1194] = 930,
  [1195] = 976,
  [1196] = 938,
  [1197] = 913,
  [1198] = 910,
  [1199] = 928,
  [1200] = 971,
  [1201] = 1039,
  [1202] = 920,
  [1203] = 930,
  [1204] = 918,
  [1205] = 931,
  [1206] = 917,
  [1207] = 954,
  [1208] = 1059,
  [1209] = 938,
  [1210] = 971,
  [1211] = 915,
  [1212] = 898,
  [1213] = 918,
  [1214] = 921,
  [1215] = 925,
  [1216] = 925,
  [1217] = 916,
  [1218] = 998,
  [1219] = 986,
  [1220] = 960,
  [1221] = 974,
  [1222] = 922,
  [1223] = 972,
  [1224] = 896,
  [1225] = 911,
  [1226] = 913,
  [1227] = 1004,
  [1228] = 915,
  [1229] = 908,
  [1230] = 971,
  [1231] = 934,
  [1232] = 907,
  [1233] = 914,
  [1234] = 919,
  [1235] = 922,
  [1236] = 912,
  [1237] = 911,
  [1238] = 956,
  [1239] = 920,
  [1240] = 908,
  [1241] = 919,
  [1242] = 898,
  [1243] = 916,
  [1244] = 921,
  [1245] = 923,
  [1246] = 1010,
  [1247] = 896,
  [1248] = 927,
  [1249] = 896,
  [1250] = 927,
  [1251] = 912,
  [1252] = 922,
  [1253] = 928,
  [1254] = 935,
  [1255] = 931,
  [1256] = 907,
  [1257] = 936,
  [1258] = 915,
  [1259] = 1009,
  [1260] = 966,
  [1261] = 934,
  [1262] = 911,
  [1263] = 1007,
  [1264] = 890,
  [1265] = 904,
  [1266] = 1022,
  [1267] = 914,
  [1268] = 936,
  [1269] = 935,
  [1270] = 1018,
  [1271] = 1011,
  [1272] = 914,
  [1273] = 908,
  [1274] = 924,
  [1275] = 1161,
  [1276] = 1121,
  [1277] = 1097,
  [1278] = 1004,
  [1279] = 898,
  [1280] = 904,
  [1281] = 938,
  [1282] = 1089,
  [1283] = 1126,
  [1284] = 1092,
  [1285] = 922,
  [1286] = 896,
  [1287] = 1059,
  [1288] = 911,
  [1289] = 1083,
  [1290] = 1091,
  [1291] = 1143,
  [1292] = 1146,
  [1293] = 910,
  [1294] = 1039,
  [1295] = 911,
  [1296] = 912,
  [1297] = 913,
  [1298] = 911,
  [1299] = 1101,
  [1300] = 1058,
  [1301] = 921,
  [1302] = 910,
  [1303] = 930,
  [1304] = 914,
  [1305] = 934,
  [1306] = 1122,
  [1307] = 1094,
  [1308] = 911,
  [1309] = 931,
  [1310] = 1074,
  [1311] = 1073,
  [1312] = 938,
  [1313] = 1082,
  [1314] = 915,
  [1315] = 1078,
  [1316] = 971,
  [1317] = 912,
  [1318] = 1141,
  [1319] = 1085,
  [1320] = 1165,
  [1321] = 908,
  [1322] = 1070,
  [1323] = 1178,
  [1324] = 896,
  [1325] = 918,
  [1326] = 911,
  [1327] = 936,
  [1328] = 1079,
  [1329] = 1177,
  [1330] = 924,
  [1331] = 1176,
  [1332] = 896,
  [1333] = 1174,
  [1334] = 911,
  [1335] = 908,
  [1336] = 1060,
  [1337] = 904,
  [1338] = 915,
  [1339] = 931,
  [1340] = 949,
  [1341] = 914,
  [1342] = 1086,
  [1343] = 1122,
  [1344] = 913,
  [1345] = 1172,
  [1346] = 904,
  [1347] = 1133,
  [1348] = 931,
  [1349] = 1114,
  [1350] = 1068,
  [1351] = 934,
  [1352] = 907,
  [1353] = 922,
  [1354] = 919,
  [1355] = 898,
  [1356] = 1152,
  [1357] = 896,
  [1358] = 920,
  [1359] = 914,
  [1360] = 1066,
  [1361] = 923,
  [1362] = 1055,
  [1363] = 916,
  [1364] = 904,
  [1365] = 925,
  [1366] = 1149,
  [1367] = 1125,
  [1368] = 1093,
  [1369] = 1163,
  [1370] = 930,
  [1371] = 1064,
  [1372] = 1179,
  [1373] = 1069,
  [1374] = 1117,
  [1375] = 1118,
  [1376] = 917,
  [1377] = 908,
  [1378] = 936,
  [1379] = 1154,
  [1380] = 1120,
  [1381] = 935,
  [1382] = 908,
  [1383] = 904,
  [1384] = 1155,
  [1385] = 913,
  [1386] = 1095,
  [1387] = 1387,
  [1388] = 898,
  [1389] = 924,
  [1390] = 927,
  [1391] = 910,
  [1392] = 1096,
  [1393] = 921,
  [1394] = 928,
  [1395] = 896,
  [1396] = 1098,
  [1397] = 1113,
  [1398] = 1169,
  [1399] = 914,
  [1400] = 918,
  [1401] = 907,
  [1402] = 911,
  [1403] = 1018,
  [1404] = 1011,
  [1405] = 923,
  [1406] = 915,
  [1407] = 1112,
  [1408] = 915,
  [1409] = 1170,
  [1410] = 1059,
  [1411] = 908,
  [1412] = 1127,
  [1413] = 1168,
  [1414] = 1111,
  [1415] = 916,
  [1416] = 907,
  [1417] = 1065,
  [1418] = 1181,
  [1419] = 896,
  [1420] = 912,
  [1421] = 1182,
  [1422] = 913,
  [1423] = 1160,
  [1424] = 1009,
  [1425] = 912,
  [1426] = 1007,
  [1427] = 898,
  [1428] = 1010,
  [1429] = 1103,
  [1430] = 1105,
  [1431] = 1046,
  [1432] = 907,
  [1433] = 914,
  [1434] = 1108,
  [1435] = 898,
  [1436] = 1183,
  [1437] = 949,
  [1438] = 917,
  [1439] = 910,
  [1440] = 915,
  [1441] = 919,
  [1442] = 1185,
  [1443] = 1054,
  [1444] = 920,
  [1445] = 1107,
  [1446] = 1047,
  [1447] = 1048,
  [1448] = 925,
  [1449] = 913,
  [1450] = 1087,
  [1451] = 922,
  [1452] = 907,
  [1453] = 912,
  [1454] = 1171,
  [1455] = 921,
  [1456] = 935,
  [1457] = 1110,
  [1458] = 1109,
  [1459] = 910,
  [1460] = 915,
  [1461] = 927,
  [1462] = 928,
  [1463] = 922,
  [1464] = 1086,
  [1465] = 1000,
  [1466] = 1058,
  [1467] = 922,
  [1468] = 918,
  [1469] = 934,
  [1470] = 911,
  [1471] = 936,
  [1472] = 935,
  [1473] = 928,
  [1474] = 954,
  [1475] = 921,
  [1476] = 927,
  [1477] = 1048,
  [1478] = 920,
  [1479] = 916,
  [1480] = 927,
  [1481] = 919,
  [1482] = 924,
  [1483] = 917,
  [1484] = 920,
  [1485] = 922,
  [1486] = 1047,
  [1487] = 931,
  [1488] = 1107,
  [1489] = 1022,
  [1490] = 1055,
  [1491] = 978,
  [1492] = 922,
  [1493] = 1060,
  [1494] = 928,
  [1495] = 919,
  [1496] = 938,
  [1497] = 966,
  [1498] = 1087,
  [1499] = 922,
  [1500] = 960,
  [1501] = 925,
  [1502] = 935,
  [1503] = 1094,
  [1504] = 924,
  [1505] = 922,
  [1506] = 1506,
  [1507] = 976,
  [1508] = 936,
  [1509] = 1387,
  [1510] = 921,
  [1511] = 916,
  [1512] = 1073,
  [1513] = 923,
  [1514] = 934,
  [1515] = 921,
  [1516] = 956,
  [1517] = 966,
  [1518] = 918,
  [1519] = 927,
  [1520] = 924,
  [1521] = 972,
  [1522] = 974,
  [1523] = 928,
  [1524] = 917,
  [1525] = 931,
  [1526] = 1526,
  [1527] = 920,
  [1528] = 922,
  [1529] = 1506,
  [1530] = 971,
  [1531] = 938,
  [1532] = 1074,
  [1533] = 918,
  [1534] = 949,
  [1535] = 986,
  [1536] = 936,
  [1537] = 1526,
  [1538] = 930,
  [1539] = 1083,
  [1540] = 998,
  [1541] = 1092,
  [1542] = 938,
  [1543] = 925,
  [1544] = 934,
  [1545] = 921,
  [1546] = 1022,
  [1547] = 1093,
  [1548] = 949,
  [1549] = 1526,
  [1550] = 930,
  [1551] = 935,
  [1552] = 1095,
  [1553] = 1120,
  [1554] = 1096,
  [1555] = 917,
  [1556] = 923,
  [1557] = 971,
  [1558] = 1141,
  [1559] = 928,
  [1560] = 916,
  [1561] = 1098,
  [1562] = 1091,
  [1563] = 1103,
  [1564] = 1105,
  [1565] = 1097,
  [1566] = 1046,
  [1567] = 918,
  [1568] = 1085,
  [1569] = 1000,
  [1570] = 1108,
  [1571] = 1082,
  [1572] = 919,
  [1573] = 930,
  [1574] = 927,
  [1575] = 1079,
  [1576] = 1109,
  [1577] = 1117,
  [1578] = 924,
  [1579] = 921,
  [1580] = 971,
  [1581] = 960,
  [1582] = 920,
  [1583] = 917,
  [1584] = 1118,
  [1585] = 978,
  [1586] = 920,
  [1587] = 925,
  [1588] = 1110,
  [1589] = 931,
  [1590] = 1111,
  [1591] = 1113,
  [1592] = 1114,
  [1593] = 924,
  [1594] = 1506,
  [1595] = 925,
  [1596] = 1054,
  [1597] = 922,
  [1598] = 917,
  [1599] = 956,
  [1600] = 1022,
  [1601] = 919,
  [1602] = 1133,
  [1603] = 949,
  [1604] = 919,
  [1605] = 1065,
  [1606] = 916,
  [1607] = 923,
  [1608] = 931,
  [1609] = 923,
  [1610] = 927,
  [1611] = 1143,
  [1612] = 1066,
  [1613] = 1068,
  [1614] = 1070,
  [1615] = 1506,
  [1616] = 928,
  [1617] = 938,
  [1618] = 1146,
  [1619] = 972,
  [1620] = 974,
  [1621] = 1078,
  [1622] = 935,
  [1623] = 954,
  [1624] = 1089,
  [1625] = 1064,
  [1626] = 1121,
  [1627] = 986,
  [1628] = 1101,
  [1629] = 935,
  [1630] = 936,
  [1631] = 971,
  [1632] = 936,
  [1633] = 934,
  [1634] = 930,
  [1635] = 1161,
  [1636] = 1165,
  [1637] = 1125,
  [1638] = 971,
  [1639] = 1149,
  [1640] = 1169,
  [1641] = 1152,
  [1642] = 1154,
  [1643] = 1155,
  [1644] = 1526,
  [1645] = 1171,
  [1646] = 998,
  [1647] = 1185,
  [1648] = 921,
  [1649] = 1183,
  [1650] = 1182,
  [1651] = 923,
  [1652] = 930,
  [1653] = 1181,
  [1654] = 1179,
  [1655] = 916,
  [1656] = 971,
  [1657] = 1178,
  [1658] = 1177,
  [1659] = 1176,
  [1660] = 1174,
  [1661] = 1126,
  [1662] = 1172,
  [1663] = 1069,
  [1664] = 934,
  [1665] = 976,
  [1666] = 1170,
  [1667] = 1168,
  [1668] = 1163,
  [1669] = 1160,
  [1670] = 938,
  [1671] = 931,
  [1672] = 1112,
  [1673] = 918,
  [1674] = 1127,
  [1675] = 925,
  [1676] = 1010,
  [1677] = 1007,
  [1678] = 971,
  [1679] = 986,
  [1680] = 922,
  [1681] = 976,
  [1682] = 1022,
  [1683] = 1011,
  [1684] = 971,
  [1685] = 978,
  [1686] = 976,
  [1687] = 1018,
  [1688] = 974,
  [1689] = 972,
  [1690] = 998,
  [1691] = 1022,
  [1692] = 956,
  [1693] = 911,
  [1694] = 915,
  [1695] = 954,
  [1696] = 956,
  [1697] = 896,
  [1698] = 915,
  [1699] = 1000,
  [1700] = 949,
  [1701] = 976,
  [1702] = 971,
  [1703] = 896,
  [1704] = 960,
  [1705] = 966,
  [1706] = 1039,
  [1707] = 1004,
  [1708] = 949,
  [1709] = 972,
  [1710] = 974,
  [1711] = 1000,
  [1712] = 949,
  [1713] = 986,
  [1714] = 1009,
  [1715] = 998,
  [1716] = 911,
  [1717] = 1022,
  [1718] = 978,
  [1719] = 978,
  [1720] = 1010,
  [1721] = 960,
  [1722] = 954,
  [1723] = 1007,
  [1724] = 971,
  [1725] = 1011,
  [1726] = 966,
  [1727] = 949,
  [1728] = 1018,
  [1729] = 954,
  [1730] = 971,
  [1731] = 896,
  [1732] = 971,
  [1733] = 915,
  [1734] = 960,
  [1735] = 956,
  [1736] = 1000,
  [1737] = 971,
  [1738] = 1022,
  [1739] = 966,
  [1740] = 949,
  [1741] = 974,
  [1742] = 1039,
  [1743] = 972,
  [1744] = 911,
  [1745] = 971,
  [1746] = 986,
  [1747] = 998,
  [1748] = 1022,
  [1749] = 1009,
  [1750] = 1122,
  [1751] = 1059,
  [1752] = 1004,
  [1753] = 1163,
  [1754] = 1000,
  [1755] = 1120,
  [1756] = 1094,
  [1757] = 896,
  [1758] = 960,
  [1759] = 978,
  [1760] = 1022,
  [1761] = 915,
  [1762] = 1058,
  [1763] = 1022,
  [1764] = 1000,
  [1765] = 976,
  [1766] = 954,
  [1767] = 1059,
  [1768] = 1122,
  [1769] = 956,
  [1770] = 1054,
  [1771] = 1086,
  [1772] = 960,
  [1773] = 1009,
  [1774] = 972,
  [1775] = 1087,
  [1776] = 974,
  [1777] = 1097,
  [1778] = 1112,
  [1779] = 1069,
  [1780] = 1117,
  [1781] = 1022,
  [1782] = 1118,
  [1783] = 986,
  [1784] = 976,
  [1785] = 971,
  [1786] = 911,
  [1787] = 998,
  [1788] = 921,
  [1789] = 971,
  [1790] = 1004,
  [1791] = 954,
  [1792] = 1010,
  [1793] = 1118,
  [1794] = 1007,
  [1795] = 1795,
  [1796] = 1039,
  [1797] = 966,
  [1798] = 1117,
  [1799] = 1011,
  [1800] = 1018,
  [1801] = 911,
  [1802] = 896,
  [1803] = 915,
  [1804] = 1064,
  [1805] = 1097,
  [1806] = 956,
  [1807] = 998,
  [1808] = 986,
  [1809] = 1094,
  [1810] = 974,
  [1811] = 1000,
  [1812] = 972,
  [1813] = 1087,
  [1814] = 1048,
  [1815] = 1047,
  [1816] = 1816,
  [1817] = 954,
  [1818] = 1107,
  [1819] = 1055,
  [1820] = 1816,
  [1821] = 1060,
  [1822] = 971,
  [1823] = 1073,
  [1824] = 1074,
  [1825] = 1083,
  [1826] = 1092,
  [1827] = 1093,
  [1828] = 1095,
  [1829] = 960,
  [1830] = 966,
  [1831] = 1096,
  [1832] = 1098,
  [1833] = 1103,
  [1834] = 1105,
  [1835] = 1046,
  [1836] = 1108,
  [1837] = 1109,
  [1838] = 1110,
  [1839] = 1111,
  [1840] = 915,
  [1841] = 1113,
  [1842] = 1114,
  [1843] = 971,
  [1844] = 1009,
  [1845] = 1022,
  [1846] = 1064,
  [1847] = 1121,
  [1848] = 1125,
  [1849] = 1058,
  [1850] = 1126,
  [1851] = 1127,
  [1852] = 1039,
  [1853] = 966,
  [1854] = 971,
  [1855] = 1004,
  [1856] = 971,
  [1857] = 978,
  [1858] = 1122,
  [1859] = 971,
  [1860] = 1018,
  [1861] = 1011,
  [1862] = 966,
  [1863] = 960,
  [1864] = 921,
  [1865] = 911,
  [1866] = 956,
  [1867] = 1009,
  [1868] = 1004,
  [1869] = 972,
  [1870] = 974,
  [1871] = 971,
  [1872] = 915,
  [1873] = 1122,
  [1874] = 1059,
  [1875] = 966,
  [1876] = 1007,
  [1877] = 954,
  [1878] = 971,
  [1879] = 971,
  [1880] = 978,
  [1881] = 1133,
  [1882] = 1010,
  [1883] = 1039,
  [1884] = 896,
  [1885] = 1143,
  [1886] = 1146,
  [1887] = 1059,
  [1888] = 1149,
  [1889] = 976,
  [1890] = 1152,
  [1891] = 1127,
  [1892] = 1154,
  [1893] = 1155,
  [1894] = 1126,
  [1895] = 1816,
  [1896] = 1160,
  [1897] = 1054,
  [1898] = 1086,
  [1899] = 1163,
  [1900] = 1168,
  [1901] = 911,
  [1902] = 1125,
  [1903] = 1170,
  [1904] = 986,
  [1905] = 1121,
  [1906] = 1120,
  [1907] = 998,
  [1908] = 1114,
  [1909] = 1133,
  [1910] = 976,
  [1911] = 1122,
  [1912] = 978,
  [1913] = 1113,
  [1914] = 1143,
  [1915] = 1022,
  [1916] = 1146,
  [1917] = 971,
  [1918] = 998,
  [1919] = 960,
  [1920] = 1149,
  [1921] = 1059,
  [1922] = 1152,
  [1923] = 1112,
  [1924] = 1122,
  [1925] = 986,
  [1926] = 1172,
  [1927] = 1174,
  [1928] = 1176,
  [1929] = 1177,
  [1930] = 1178,
  [1931] = 1154,
  [1932] = 1069,
  [1933] = 1155,
  [1934] = 1179,
  [1935] = 1181,
  [1936] = 1182,
  [1937] = 1111,
  [1938] = 1160,
  [1939] = 1168,
  [1940] = 1170,
  [1941] = 1110,
  [1942] = 1000,
  [1943] = 1183,
  [1944] = 976,
  [1945] = 1022,
  [1946] = 1185,
  [1947] = 1171,
  [1948] = 921,
  [1949] = 998,
  [1950] = 1169,
  [1951] = 1172,
  [1952] = 974,
  [1953] = 972,
  [1954] = 1174,
  [1955] = 986,
  [1956] = 1176,
  [1957] = 1177,
  [1958] = 1178,
  [1959] = 1109,
  [1960] = 1108,
  [1961] = 1165,
  [1962] = 1161,
  [1963] = 1046,
  [1964] = 1018,
  [1965] = 971,
  [1966] = 1059,
  [1967] = 1011,
  [1968] = 1179,
  [1969] = 1181,
  [1970] = 1182,
  [1971] = 1183,
  [1972] = 1185,
  [1973] = 1171,
  [1974] = 1101,
  [1975] = 1091,
  [1976] = 1000,
  [1977] = 1105,
  [1978] = 1103,
  [1979] = 1169,
  [1980] = 1098,
  [1981] = 1165,
  [1982] = 1089,
  [1983] = 1161,
  [1984] = 1122,
  [1985] = 1096,
  [1986] = 1095,
  [1987] = 1093,
  [1988] = 1092,
  [1989] = 1083,
  [1990] = 1074,
  [1991] = 971,
  [1992] = 1141,
  [1993] = 1073,
  [1994] = 974,
  [1995] = 1078,
  [1996] = 972,
  [1997] = 1007,
  [1998] = 1010,
  [1999] = 1101,
  [2000] = 956,
  [2001] = 1091,
  [2002] = 896,
  [2003] = 1070,
  [2004] = 1068,
  [2005] = 1816,
  [2006] = 1066,
  [2007] = 978,
  [2008] = 1089,
  [2009] = 1065,
  [2010] = 1141,
  [2011] = 1060,
  [2012] = 1055,
  [2013] = 1078,
  [2014] = 956,
  [2015] = 1085,
  [2016] = 1082,
  [2017] = 1070,
  [2018] = 1079,
  [2019] = 1068,
  [2020] = 1066,
  [2021] = 1065,
  [2022] = 1107,
  [2023] = 1085,
  [2024] = 1047,
  [2025] = 1079,
  [2026] = 1082,
  [2027] = 954,
  [2028] = 1059,
  [2029] = 1048,
  [2030] = 1010,
  [2031] = 1176,
  [2032] = 1141,
  [2033] = 1039,
  [2034] = 921,
  [2035] = 1004,
  [2036] = 1387,
  [2037] = 1127,
  [2038] = 1126,
  [2039] = 1122,
  [2040] = 1125,
  [2041] = 1118,
  [2042] = 1121,
  [2043] = 1085,
  [2044] = 1082,
  [2045] = 1079,
  [2046] = 1117,
  [2047] = 1009,
  [2048] = 1097,
  [2049] = 1795,
  [2050] = 1087,
  [2051] = 1114,
  [2052] = 880,
  [2053] = 1113,
  [2054] = 1111,
  [2055] = 1110,
  [2056] = 1065,
  [2057] = 2057,
  [2058] = 1066,
  [2059] = 1109,
  [2060] = 1068,
  [2061] = 1070,
  [2062] = 1059,
  [2063] = 1064,
  [2064] = 1078,
  [2065] = 1108,
  [2066] = 1046,
  [2067] = 1105,
  [2068] = 1103,
  [2069] = 1098,
  [2070] = 1096,
  [2071] = 1095,
  [2072] = 1093,
  [2073] = 1092,
  [2074] = 1083,
  [2075] = 1074,
  [2076] = 1073,
  [2077] = 1089,
  [2078] = 1091,
  [2079] = 1101,
  [2080] = 1059,
  [2081] = 1816,
  [2082] = 1161,
  [2083] = 1165,
  [2084] = 1009,
  [2085] = 1060,
  [2086] = 1055,
  [2087] = 1107,
  [2088] = 1048,
  [2089] = 1047,
  [2090] = 1039,
  [2091] = 1048,
  [2092] = 1059,
  [2093] = 907,
  [2094] = 2057,
  [2095] = 1009,
  [2096] = 1169,
  [2097] = 1171,
  [2098] = 1185,
  [2099] = 1183,
  [2100] = 1118,
  [2101] = 886,
  [2102] = 882,
  [2103] = 1182,
  [2104] = 1181,
  [2105] = 1179,
  [2106] = 879,
  [2107] = 1073,
  [2108] = 1074,
  [2109] = 1004,
  [2110] = 1178,
  [2111] = 1177,
  [2112] = 1176,
  [2113] = 1174,
  [2114] = 1083,
  [2115] = 1094,
  [2116] = 1092,
  [2117] = 1122,
  [2118] = 1172,
  [2119] = 1093,
  [2120] = 1018,
  [2121] = 1011,
  [2122] = 1095,
  [2123] = 911,
  [2124] = 1096,
  [2125] = 896,
  [2126] = 1170,
  [2127] = 1168,
  [2128] = 915,
  [2129] = 1069,
  [2130] = 1122,
  [2131] = 1112,
  [2132] = 1163,
  [2133] = 1098,
  [2134] = 911,
  [2135] = 1117,
  [2136] = 1160,
  [2137] = 1022,
  [2138] = 1103,
  [2139] = 1155,
  [2140] = 1154,
  [2141] = 1086,
  [2142] = 1054,
  [2143] = 1105,
  [2144] = 1007,
  [2145] = 1152,
  [2146] = 1149,
  [2147] = 1816,
  [2148] = 1046,
  [2149] = 1108,
  [2150] = 1010,
  [2151] = 1146,
  [2152] = 1143,
  [2153] = 1018,
  [2154] = 1816,
  [2155] = 1011,
  [2156] = 1004,
  [2157] = 1010,
  [2158] = 1133,
  [2159] = 1141,
  [2160] = 1064,
  [2161] = 1120,
  [2162] = 1007,
  [2163] = 1064,
  [2164] = 2057,
  [2165] = 1109,
  [2166] = 1059,
  [2167] = 1122,
  [2168] = 1085,
  [2169] = 1082,
  [2170] = 1097,
  [2171] = 1079,
  [2172] = 921,
  [2173] = 1058,
  [2174] = 1118,
  [2175] = 1007,
  [2176] = 896,
  [2177] = 1117,
  [2178] = 1127,
  [2179] = 1126,
  [2180] = 1011,
  [2181] = 1125,
  [2182] = 1010,
  [2183] = 1121,
  [2184] = 1018,
  [2185] = 1059,
  [2186] = 1009,
  [2187] = 1060,
  [2188] = 1009,
  [2189] = 1018,
  [2190] = 1011,
  [2191] = 1047,
  [2192] = 1107,
  [2193] = 1097,
  [2194] = 1114,
  [2195] = 1004,
  [2196] = 1113,
  [2197] = 1111,
  [2198] = 1110,
  [2199] = 1109,
  [2200] = 1108,
  [2201] = 1122,
  [2202] = 1039,
  [2203] = 1046,
  [2204] = 915,
  [2205] = 1065,
  [2206] = 1066,
  [2207] = 1068,
  [2208] = 1110,
  [2209] = 1058,
  [2210] = 1007,
  [2211] = 1087,
  [2212] = 1070,
  [2213] = 1120,
  [2214] = 1111,
  [2215] = 1141,
  [2216] = 1105,
  [2217] = 1103,
  [2218] = 1098,
  [2219] = 1096,
  [2220] = 1095,
  [2221] = 1093,
  [2222] = 1092,
  [2223] = 1083,
  [2224] = 1113,
  [2225] = 1074,
  [2226] = 1073,
  [2227] = 1078,
  [2228] = 1094,
  [2229] = 1060,
  [2230] = 1011,
  [2231] = 1018,
  [2232] = 1055,
  [2233] = 1107,
  [2234] = 1047,
  [2235] = 896,
  [2236] = 1816,
  [2237] = 1085,
  [2238] = 1082,
  [2239] = 1114,
  [2240] = 1079,
  [2241] = 1048,
  [2242] = 2057,
  [2243] = 971,
  [2244] = 911,
  [2245] = 921,
  [2246] = 1089,
  [2247] = 1091,
  [2248] = 1101,
  [2249] = 1059,
  [2250] = 1122,
  [2251] = 911,
  [2252] = 1094,
  [2253] = 1087,
  [2254] = 1004,
  [2255] = 1161,
  [2256] = 1165,
  [2257] = 1133,
  [2258] = 1055,
  [2259] = 1069,
  [2260] = 1112,
  [2261] = 896,
  [2262] = 971,
  [2263] = 1054,
  [2264] = 1169,
  [2265] = 1171,
  [2266] = 1185,
  [2267] = 1007,
  [2268] = 1816,
  [2269] = 971,
  [2270] = 1183,
  [2271] = 1182,
  [2272] = 1181,
  [2273] = 1179,
  [2274] = 1069,
  [2275] = 1143,
  [2276] = 904,
  [2277] = 1058,
  [2278] = 915,
  [2279] = 915,
  [2280] = 1146,
  [2281] = 896,
  [2282] = 1112,
  [2283] = 971,
  [2284] = 1816,
  [2285] = 1149,
  [2286] = 1065,
  [2287] = 1066,
  [2288] = 1068,
  [2289] = 1070,
  [2290] = 1152,
  [2291] = 1133,
  [2292] = 1078,
  [2293] = 1086,
  [2294] = 1154,
  [2295] = 1143,
  [2296] = 1146,
  [2297] = 1010,
  [2298] = 1149,
  [2299] = 1152,
  [2300] = 1155,
  [2301] = 1120,
  [2302] = 1127,
  [2303] = 1178,
  [2304] = 915,
  [2305] = 1177,
  [2306] = 1126,
  [2307] = 1089,
  [2308] = 1091,
  [2309] = 1101,
  [2310] = 1154,
  [2311] = 1054,
  [2312] = 1086,
  [2313] = 913,
  [2314] = 921,
  [2315] = 1155,
  [2316] = 1816,
  [2317] = 911,
  [2318] = 1160,
  [2319] = 1163,
  [2320] = 1125,
  [2321] = 1161,
  [2322] = 1165,
  [2323] = 1169,
  [2324] = 1171,
  [2325] = 1185,
  [2326] = 1183,
  [2327] = 1182,
  [2328] = 1181,
  [2329] = 1179,
  [2330] = 1168,
  [2331] = 1170,
  [2332] = 1039,
  [2333] = 1121,
  [2334] = 971,
  [2335] = 1178,
  [2336] = 1177,
  [2337] = 1176,
  [2338] = 1174,
  [2339] = 1172,
  [2340] = 1039,
  [2341] = 1172,
  [2342] = 1170,
  [2343] = 1168,
  [2344] = 1163,
  [2345] = 1160,
  [2346] = 1174,
  [2347] = 1065,
  [2348] = 907,
  [2349] = 1127,
  [2350] = 1126,
  [2351] = 1073,
  [2352] = 1074,
  [2353] = 1064,
  [2354] = 1133,
  [2355] = 1092,
  [2356] = 2057,
  [2357] = 1125,
  [2358] = 1083,
  [2359] = 1055,
  [2360] = 1121,
  [2361] = 925,
  [2362] = 1098,
  [2363] = 1058,
  [2364] = 1126,
  [2365] = 1121,
  [2366] = 1092,
  [2367] = 1064,
  [2368] = 1060,
  [2369] = 1093,
  [2370] = 1127,
  [2371] = 1095,
  [2372] = 1141,
  [2373] = 1125,
  [2374] = 1120,
  [2375] = 1047,
  [2376] = 1107,
  [2377] = 1096,
  [2378] = 1097,
  [2379] = 1141,
  [2380] = 1048,
  [2381] = 1069,
  [2382] = 1098,
  [2383] = 1114,
  [2384] = 1103,
  [2385] = 1105,
  [2386] = 1113,
  [2387] = 921,
  [2388] = 1141,
  [2389] = 921,
  [2390] = 1058,
  [2391] = 1143,
  [2392] = 1143,
  [2393] = 2393,
  [2394] = 1046,
  [2395] = 1108,
  [2396] = 1109,
  [2397] = 1110,
  [2398] = 1111,
  [2399] = 1111,
  [2400] = 2057,
  [2401] = 1112,
  [2402] = 921,
  [2403] = 1146,
  [2404] = 1113,
  [2405] = 1182,
  [2406] = 1114,
  [2407] = 1146,
  [2408] = 1064,
  [2409] = 1086,
  [2410] = 938,
  [2411] = 1054,
  [2412] = 1133,
  [2413] = 1085,
  [2414] = 1110,
  [2415] = 1109,
  [2416] = 1121,
  [2417] = 1125,
  [2418] = 1082,
  [2419] = 1079,
  [2420] = 1087,
  [2421] = 2421,
  [2422] = 1083,
  [2423] = 1181,
  [2424] = 1149,
  [2425] = 1152,
  [2426] = 1108,
  [2427] = 1085,
  [2428] = 1046,
  [2429] = 1126,
  [2430] = 1154,
  [2431] = 1155,
  [2432] = 1133,
  [2433] = 1105,
  [2434] = 1082,
  [2435] = 1127,
  [2436] = 1169,
  [2437] = 1103,
  [2438] = 1110,
  [2439] = 904,
  [2440] = 1097,
  [2441] = 1085,
  [2442] = 1096,
  [2443] = 1082,
  [2444] = 2444,
  [2445] = 2444,
  [2446] = 1074,
  [2447] = 1149,
  [2448] = 2393,
  [2449] = 2444,
  [2450] = 1095,
  [2451] = 1079,
  [2452] = 1079,
  [2453] = 1093,
  [2454] = 1092,
  [2455] = 1127,
  [2456] = 1126,
  [2457] = 1058,
  [2458] = 1114,
  [2459] = 1125,
  [2460] = 1121,
  [2461] = 1064,
  [2462] = 1094,
  [2463] = 1083,
  [2464] = 1074,
  [2465] = 1113,
  [2466] = 1387,
  [2467] = 1112,
  [2468] = 1073,
  [2469] = 1111,
  [2470] = 1110,
  [2471] = 1109,
  [2472] = 1171,
  [2473] = 1160,
  [2474] = 1163,
  [2475] = 1168,
  [2476] = 1170,
  [2477] = 1108,
  [2478] = 1172,
  [2479] = 1046,
  [2480] = 1152,
  [2481] = 2444,
  [2482] = 2393,
  [2483] = 1174,
  [2484] = 1120,
  [2485] = 2444,
  [2486] = 1066,
  [2487] = 1176,
  [2488] = 1177,
  [2489] = 1178,
  [2490] = 1118,
  [2491] = 1105,
  [2492] = 1068,
  [2493] = 1103,
  [2494] = 1098,
  [2495] = 1070,
  [2496] = 2393,
  [2497] = 1117,
  [2498] = 1096,
  [2499] = 1095,
  [2500] = 2444,
  [2501] = 1069,
  [2502] = 1078,
  [2503] = 2503,
  [2504] = 1089,
  [2505] = 1060,
  [2506] = 1055,
  [2507] = 1087,
  [2508] = 1048,
  [2509] = 1091,
  [2510] = 1101,
  [2511] = 921,
  [2512] = 1093,
  [2513] = 1047,
  [2514] = 1154,
  [2515] = 1107,
  [2516] = 1179,
  [2517] = 1181,
  [2518] = 1182,
  [2519] = 1183,
  [2520] = 1185,
  [2521] = 1133,
  [2522] = 1054,
  [2523] = 1055,
  [2524] = 1155,
  [2525] = 1143,
  [2526] = 1146,
  [2527] = 1117,
  [2528] = 1149,
  [2529] = 1152,
  [2530] = 1092,
  [2531] = 880,
  [2532] = 1086,
  [2533] = 1078,
  [2534] = 1083,
  [2535] = 1169,
  [2536] = 1165,
  [2537] = 1161,
  [2538] = 1118,
  [2539] = 1073,
  [2540] = 1161,
  [2541] = 2057,
  [2542] = 2393,
  [2543] = 1143,
  [2544] = 1112,
  [2545] = 1074,
  [2546] = 1095,
  [2547] = 1060,
  [2548] = 1087,
  [2549] = 1114,
  [2550] = 1118,
  [2551] = 1160,
  [2552] = 1073,
  [2553] = 1165,
  [2554] = 1154,
  [2555] = 1069,
  [2556] = 1127,
  [2557] = 1126,
  [2558] = 1155,
  [2559] = 2444,
  [2560] = 1117,
  [2561] = 1113,
  [2562] = 1179,
  [2563] = 1112,
  [2564] = 1111,
  [2565] = 1125,
  [2566] = 1097,
  [2567] = 1146,
  [2568] = 1163,
  [2569] = 1171,
  [2570] = 1121,
  [2571] = 2503,
  [2572] = 1185,
  [2573] = 2057,
  [2574] = 1183,
  [2575] = 1101,
  [2576] = 1091,
  [2577] = 1182,
  [2578] = 1089,
  [2579] = 1168,
  [2580] = 1181,
  [2581] = 1118,
  [2582] = 1120,
  [2583] = 1107,
  [2584] = 1054,
  [2585] = 1065,
  [2586] = 1170,
  [2587] = 2503,
  [2588] = 1114,
  [2589] = 1047,
  [2590] = 1117,
  [2591] = 1179,
  [2592] = 2592,
  [2593] = 1172,
  [2594] = 1070,
  [2595] = 1048,
  [2596] = 1068,
  [2597] = 1174,
  [2598] = 1176,
  [2599] = 1066,
  [2600] = 1149,
  [2601] = 1177,
  [2602] = 1178,
  [2603] = 1065,
  [2604] = 915,
  [2605] = 1152,
  [2606] = 1113,
  [2607] = 2503,
  [2608] = 1087,
  [2609] = 1078,
  [2610] = 1178,
  [2611] = 1177,
  [2612] = 1176,
  [2613] = 1174,
  [2614] = 1172,
  [2615] = 2057,
  [2616] = 896,
  [2617] = 1154,
  [2618] = 1155,
  [2619] = 1111,
  [2620] = 2620,
  [2621] = 1160,
  [2622] = 1178,
  [2623] = 1089,
  [2624] = 1094,
  [2625] = 1118,
  [2626] = 921,
  [2627] = 1179,
  [2628] = 1181,
  [2629] = 1182,
  [2630] = 1110,
  [2631] = 1183,
  [2632] = 1141,
  [2633] = 1109,
  [2634] = 1163,
  [2635] = 1185,
  [2636] = 1171,
  [2637] = 1177,
  [2638] = 2393,
  [2639] = 1091,
  [2640] = 1058,
  [2641] = 1097,
  [2642] = 1101,
  [2643] = 1170,
  [2644] = 910,
  [2645] = 1168,
  [2646] = 1169,
  [2647] = 1163,
  [2648] = 1160,
  [2649] = 1108,
  [2650] = 1094,
  [2651] = 2503,
  [2652] = 1046,
  [2653] = 1085,
  [2654] = 1082,
  [2655] = 1105,
  [2656] = 1079,
  [2657] = 1103,
  [2658] = 1155,
  [2659] = 1154,
  [2660] = 1109,
  [2661] = 1069,
  [2662] = 1165,
  [2663] = 1161,
  [2664] = 1101,
  [2665] = 1152,
  [2666] = 1149,
  [2667] = 1098,
  [2668] = 1094,
  [2669] = 1146,
  [2670] = 1108,
  [2671] = 1143,
  [2672] = 1086,
  [2673] = 886,
  [2674] = 1133,
  [2675] = 1168,
  [2676] = 1170,
  [2677] = 1046,
  [2678] = 1160,
  [2679] = 2057,
  [2680] = 1086,
  [2681] = 2057,
  [2682] = 913,
  [2683] = 1096,
  [2684] = 1161,
  [2685] = 1095,
  [2686] = 1093,
  [2687] = 1092,
  [2688] = 1163,
  [2689] = 1083,
  [2690] = 2503,
  [2691] = 1183,
  [2692] = 1066,
  [2693] = 1068,
  [2694] = 1168,
  [2695] = 1086,
  [2696] = 1070,
  [2697] = 1170,
  [2698] = 1816,
  [2699] = 1093,
  [2700] = 1065,
  [2701] = 1066,
  [2702] = 1068,
  [2703] = 1070,
  [2704] = 1074,
  [2705] = 1073,
  [2706] = 1078,
  [2707] = 1165,
  [2708] = 1105,
  [2709] = 1078,
  [2710] = 1103,
  [2711] = 1169,
  [2712] = 2393,
  [2713] = 1069,
  [2714] = 1097,
  [2715] = 2444,
  [2716] = 2444,
  [2717] = 1058,
  [2718] = 1060,
  [2719] = 1054,
  [2720] = 1171,
  [2721] = 1117,
  [2722] = 1089,
  [2723] = 1098,
  [2724] = 1091,
  [2725] = 1101,
  [2726] = 1120,
  [2727] = 1096,
  [2728] = 2393,
  [2729] = 2393,
  [2730] = 2444,
  [2731] = 1185,
  [2732] = 1055,
  [2733] = 1065,
  [2734] = 1091,
  [2735] = 1060,
  [2736] = 1816,
  [2737] = 1107,
  [2738] = 1047,
  [2739] = 882,
  [2740] = 1055,
  [2741] = 1048,
  [2742] = 1054,
  [2743] = 1112,
  [2744] = 1094,
  [2745] = 1107,
  [2746] = 1047,
  [2747] = 1048,
  [2748] = 1161,
  [2749] = 1165,
  [2750] = 1087,
  [2751] = 1066,
  [2752] = 1169,
  [2753] = 1172,
  [2754] = 2503,
  [2755] = 1171,
  [2756] = 1185,
  [2757] = 1183,
  [2758] = 1182,
  [2759] = 1181,
  [2760] = 1179,
  [2761] = 1068,
  [2762] = 879,
  [2763] = 1174,
  [2764] = 2393,
  [2765] = 1070,
  [2766] = 1141,
  [2767] = 1120,
  [2768] = 2503,
  [2769] = 1064,
  [2770] = 1176,
  [2771] = 1089,
  [2772] = 1178,
  [2773] = 1177,
  [2774] = 1176,
  [2775] = 1174,
  [2776] = 1172,
  [2777] = 1079,
  [2778] = 1082,
  [2779] = 1085,
  [2780] = 2780,
  [2781] = 915,
  [2782] = 2592,
  [2783] = 2057,
  [2784] = 2780,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 2785,
  [2789] = 936,
  [2790] = 912,
  [2791] = 925,
  [2792] = 2780,
  [2793] = 2785,
  [2794] = 2780,
  [2795] = 2785,
  [2796] = 910,
  [2797] = 2057,
  [2798] = 921,
  [2799] = 2785,
  [2800] = 2800,
  [2801] = 898,
  [2802] = 2785,
  [2803] = 2803,
  [2804] = 2785,
  [2805] = 2421,
  [2806] = 2806,
  [2807] = 930,
  [2808] = 2780,
  [2809] = 2780,
  [2810] = 2785,
  [2811] = 2785,
  [2812] = 2812,
  [2813] = 2785,
  [2814] = 2780,
  [2815] = 2780,
  [2816] = 2785,
  [2817] = 2817,
  [2818] = 938,
  [2819] = 2620,
  [2820] = 2820,
  [2821] = 896,
  [2822] = 2820,
  [2823] = 912,
  [2824] = 934,
  [2825] = 2803,
  [2826] = 918,
  [2827] = 919,
  [2828] = 898,
  [2829] = 2786,
  [2830] = 916,
  [2831] = 936,
  [2832] = 923,
  [2833] = 921,
  [2834] = 930,
  [2835] = 2787,
  [2836] = 927,
  [2837] = 928,
  [2838] = 2812,
  [2839] = 935,
  [2840] = 2800,
  [2841] = 924,
  [2842] = 917,
  [2843] = 920,
  [2844] = 2806,
  [2845] = 2817,
  [2846] = 917,
  [2847] = 918,
  [2848] = 919,
  [2849] = 916,
  [2850] = 923,
  [2851] = 934,
  [2852] = 924,
  [2853] = 927,
  [2854] = 920,
  [2855] = 935,
  [2856] = 928,
  [2857] = 2857,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2860,
  [2863] = 2861,
  [2864] = 2864,
  [2865] = 2857,
  [2866] = 2860,
  [2867] = 2860,
  [2868] = 2861,
  [2869] = 2869,
  [2870] = 2858,
  [2871] = 2859,
  [2872] = 2857,
  [2873] = 2858,
  [2874] = 2864,
  [2875] = 2859,
  [2876] = 2864,
  [2877] = 2857,
  [2878] = 2860,
  [2879] = 2858,
  [2880] = 2861,
  [2881] = 2861,
  [2882] = 2858,
  [2883] = 2869,
  [2884] = 2864,
  [2885] = 2857,
  [2886] = 2859,
  [2887] = 2860,
  [2888] = 2864,
  [2889] = 2864,
  [2890] = 2890,
  [2891] = 2861,
  [2892] = 2859,
  [2893] = 2858,
  [2894] = 2857,
  [2895] = 2864,
  [2896] = 2864,
  [2897] = 2858,
  [2898] = 2857,
  [2899] = 2858,
  [2900] = 2864,
  [2901] = 2869,
  [2902] = 2860,
  [2903] = 2859,
  [2904] = 2859,
  [2905] = 2857,
  [2906] = 2864,
  [2907] = 2864,
  [2908] = 2869,
  [2909] = 2857,
  [2910] = 2858,
  [2911] = 2869,
  [2912] = 2857,
  [2913] = 2861,
  [2914] = 2859,
  [2915] = 2864,
  [2916] = 2857,
  [2917] = 2859,
  [2918] = 2860,
  [2919] = 2861,
  [2920] = 2859,
  [2921] = 2869,
  [2922] = 2859,
  [2923] = 2869,
  [2924] = 2861,
  [2925] = 2858,
  [2926] = 2860,
  [2927] = 2860,
  [2928] = 2869,
  [2929] = 2857,
  [2930] = 2857,
  [2931] = 2861,
  [2932] = 2861,
  [2933] = 2869,
  [2934] = 2860,
  [2935] = 2869,
  [2936] = 2864,
  [2937] = 2860,
  [2938] = 2859,
  [2939] = 2858,
  [2940] = 2869,
  [2941] = 2858,
  [2942] = 2859,
  [2943] = 2858,
  [2944] = 2861,
  [2945] = 2869,
  [2946] = 2869,
  [2947] = 2861,
  [2948] = 2860,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2950,
  [2952] = 2952,
  [2953] = 2950,
  [2954] = 2950,
  [2955] = 2952,
  [2956] = 2952,
  [2957] = 2890,
  [2958] = 2952,
  [2959] = 2952,
  [2960] = 2960,
  [2961] = 2952,
  [2962] = 864,
  [2963] = 2950,
  [2964] = 2952,
  [2965] = 2950,
  [2966] = 2950,
  [2967] = 2952,
  [2968] = 2950,
  [2969] = 2969,
  [2970] = 2970,
  [2971] = 2971,
  [2972] = 2972,
  [2973] = 2969,
  [2974] = 2974,
  [2975] = 2972,
  [2976] = 2976,
  [2977] = 2977,
  [2978] = 2972,
  [2979] = 2971,
  [2980] = 2971,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 2981,
  [2984] = 2981,
  [2985] = 2981,
  [2986] = 2972,
  [2987] = 2972,
  [2988] = 2981,
  [2989] = 2989,
  [2990] = 2972,
  [2991] = 2971,
  [2992] = 2992,
  [2993] = 2971,
  [2994] = 2969,
  [2995] = 2981,
  [2996] = 2972,
  [2997] = 2972,
  [2998] = 2969,
  [2999] = 2981,
  [3000] = 2969,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 2969,
  [3004] = 2969,
  [3005] = 2981,
  [3006] = 2972,
  [3007] = 2981,
  [3008] = 2972,
  [3009] = 971,
  [3010] = 2981,
  [3011] = 2971,
  [3012] = 2971,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 2971,
  [3016] = 2971,
  [3017] = 2981,
  [3018] = 2971,
  [3019] = 2972,
  [3020] = 2981,
  [3021] = 2972,
  [3022] = 2972,
  [3023] = 2981,
  [3024] = 2972,
  [3025] = 2971,
  [3026] = 2981,
  [3027] = 2971,
  [3028] = 2971,
  [3029] = 2971,
  [3030] = 3030,
  [3031] = 2969,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3044,
  [3046] = 3040,
  [3047] = 3043,
  [3048] = 3040,
  [3049] = 3042,
  [3050] = 3034,
  [3051] = 3041,
  [3052] = 3034,
  [3053] = 3034,
  [3054] = 3036,
  [3055] = 3055,
  [3056] = 3056,
  [3057] = 3034,
  [3058] = 3040,
  [3059] = 3035,
  [3060] = 3035,
  [3061] = 3035,
  [3062] = 3035,
  [3063] = 3041,
  [3064] = 3041,
  [3065] = 3040,
  [3066] = 3066,
  [3067] = 3042,
  [3068] = 3034,
  [3069] = 3043,
  [3070] = 3070,
  [3071] = 3043,
  [3072] = 3044,
  [3073] = 3073,
  [3074] = 3036,
  [3075] = 3075,
  [3076] = 3070,
  [3077] = 3035,
  [3078] = 3044,
  [3079] = 3034,
  [3080] = 3036,
  [3081] = 3081,
  [3082] = 3040,
  [3083] = 3035,
  [3084] = 3044,
  [3085] = 3043,
  [3086] = 3066,
  [3087] = 3040,
  [3088] = 3036,
  [3089] = 3089,
  [3090] = 3070,
  [3091] = 3044,
  [3092] = 3092,
  [3093] = 3043,
  [3094] = 3094,
  [3095] = 3035,
  [3096] = 3035,
  [3097] = 3035,
  [3098] = 3042,
  [3099] = 3066,
  [3100] = 3042,
  [3101] = 3041,
  [3102] = 3066,
  [3103] = 3040,
  [3104] = 3035,
  [3105] = 3034,
  [3106] = 3036,
  [3107] = 3035,
  [3108] = 3040,
  [3109] = 3041,
  [3110] = 3042,
  [3111] = 3043,
  [3112] = 3044,
  [3113] = 3081,
  [3114] = 3033,
  [3115] = 3033,
  [3116] = 3116,
  [3117] = 3036,
  [3118] = 3041,
  [3119] = 3036,
  [3120] = 3043,
  [3121] = 3035,
  [3122] = 3040,
  [3123] = 3041,
  [3124] = 3044,
  [3125] = 3042,
  [3126] = 3043,
  [3127] = 3066,
  [3128] = 3044,
  [3129] = 3043,
  [3130] = 3130,
  [3131] = 3066,
  [3132] = 3132,
  [3133] = 3034,
  [3134] = 3134,
  [3135] = 3041,
  [3136] = 3041,
  [3137] = 3137,
  [3138] = 3042,
  [3139] = 3043,
  [3140] = 3140,
  [3141] = 3042,
  [3142] = 3044,
  [3143] = 3043,
  [3144] = 3042,
  [3145] = 3041,
  [3146] = 3044,
  [3147] = 3044,
  [3148] = 2976,
  [3149] = 3149,
  [3150] = 3036,
  [3151] = 3035,
  [3152] = 2974,
  [3153] = 3153,
  [3154] = 866,
  [3155] = 3155,
  [3156] = 3034,
  [3157] = 3042,
  [3158] = 3070,
  [3159] = 3041,
  [3160] = 3041,
  [3161] = 3042,
  [3162] = 3040,
  [3163] = 3035,
  [3164] = 3164,
  [3165] = 3040,
  [3166] = 3070,
  [3167] = 3043,
  [3168] = 3035,
  [3169] = 3066,
  [3170] = 3044,
  [3171] = 3070,
  [3172] = 3172,
  [3173] = 3173,
  [3174] = 3036,
  [3175] = 2970,
  [3176] = 3070,
  [3177] = 3034,
  [3178] = 3034,
  [3179] = 3070,
  [3180] = 2982,
  [3181] = 3034,
  [3182] = 3042,
  [3183] = 3013,
  [3184] = 3014,
  [3185] = 3040,
  [3186] = 3002,
  [3187] = 3066,
  [3188] = 971,
  [3189] = 3033,
  [3190] = 3032,
  [3191] = 2977,
  [3192] = 3056,
  [3193] = 3055,
  [3194] = 3089,
  [3195] = 3130,
  [3196] = 3132,
  [3197] = 3173,
  [3198] = 3140,
  [3199] = 3039,
  [3200] = 3038,
  [3201] = 3037,
  [3202] = 3149,
  [3203] = 3094,
  [3204] = 3092,
  [3205] = 3134,
  [3206] = 3075,
  [3207] = 3155,
  [3208] = 3164,
  [3209] = 3209,
  [3210] = 3210,
  [3211] = 3211,
  [3212] = 3212,
  [3213] = 3213,
  [3214] = 3214,
  [3215] = 3212,
  [3216] = 3209,
  [3217] = 3210,
  [3218] = 3213,
  [3219] = 3211,
  [3220] = 3220,
  [3221] = 913,
  [3222] = 904,
  [3223] = 880,
  [3224] = 3220,
  [3225] = 904,
  [3226] = 3214,
  [3227] = 882,
  [3228] = 907,
  [3229] = 886,
  [3230] = 879,
  [3231] = 913,
  [3232] = 879,
  [3233] = 882,
  [3234] = 886,
  [3235] = 907,
  [3236] = 880,
  [3237] = 896,
  [3238] = 879,
  [3239] = 3239,
  [3240] = 910,
  [3241] = 3241,
  [3242] = 896,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 915,
  [3247] = 904,
  [3248] = 915,
  [3249] = 3249,
  [3250] = 913,
  [3251] = 896,
  [3252] = 3252,
  [3253] = 882,
  [3254] = 3254,
  [3255] = 880,
  [3256] = 938,
  [3257] = 3257,
  [3258] = 907,
  [3259] = 925,
  [3260] = 886,
  [3261] = 3261,
  [3262] = 910,
  [3263] = 938,
  [3264] = 915,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 910,
  [3268] = 925,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 879,
  [3272] = 898,
  [3273] = 896,
  [3274] = 915,
  [3275] = 3241,
  [3276] = 921,
  [3277] = 898,
  [3278] = 886,
  [3279] = 896,
  [3280] = 3280,
  [3281] = 910,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 930,
  [3285] = 925,
  [3286] = 907,
  [3287] = 3287,
  [3288] = 3288,
  [3289] = 3254,
  [3290] = 912,
  [3291] = 912,
  [3292] = 930,
  [3293] = 936,
  [3294] = 3294,
  [3295] = 938,
  [3296] = 3296,
  [3297] = 915,
  [3298] = 3298,
  [3299] = 3265,
  [3300] = 921,
  [3301] = 880,
  [3302] = 921,
  [3303] = 3303,
  [3304] = 3304,
  [3305] = 910,
  [3306] = 3249,
  [3307] = 3307,
  [3308] = 3308,
  [3309] = 3266,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 913,
  [3313] = 936,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 904,
  [3317] = 882,
  [3318] = 3239,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 3320,
  [3322] = 910,
  [3323] = 3320,
  [3324] = 3320,
  [3325] = 917,
  [3326] = 3326,
  [3327] = 3294,
  [3328] = 3320,
  [3329] = 3308,
  [3330] = 3330,
  [3331] = 919,
  [3332] = 925,
  [3333] = 3298,
  [3334] = 930,
  [3335] = 921,
  [3336] = 3336,
  [3337] = 3320,
  [3338] = 918,
  [3339] = 3320,
  [3340] = 3320,
  [3341] = 3320,
  [3342] = 928,
  [3343] = 3320,
  [3344] = 920,
  [3345] = 3345,
  [3346] = 935,
  [3347] = 3320,
  [3348] = 896,
  [3349] = 3320,
  [3350] = 3320,
  [3351] = 3351,
  [3352] = 927,
  [3353] = 3353,
  [3354] = 3320,
  [3355] = 917,
  [3356] = 3320,
  [3357] = 3357,
  [3358] = 3320,
  [3359] = 916,
  [3360] = 924,
  [3361] = 3361,
  [3362] = 3320,
  [3363] = 934,
  [3364] = 3304,
  [3365] = 3365,
  [3366] = 921,
  [3367] = 927,
  [3368] = 3320,
  [3369] = 3320,
  [3370] = 3370,
  [3371] = 3283,
  [3372] = 928,
  [3373] = 3303,
  [3374] = 3320,
  [3375] = 3320,
  [3376] = 3269,
  [3377] = 919,
  [3378] = 3319,
  [3379] = 918,
  [3380] = 3282,
  [3381] = 3320,
  [3382] = 924,
  [3383] = 3320,
  [3384] = 935,
  [3385] = 923,
  [3386] = 915,
  [3387] = 3387,
  [3388] = 3287,
  [3389] = 3389,
  [3390] = 3320,
  [3391] = 3391,
  [3392] = 3320,
  [3393] = 3393,
  [3394] = 3320,
  [3395] = 938,
  [3396] = 3320,
  [3397] = 3311,
  [3398] = 3398,
  [3399] = 3320,
  [3400] = 936,
  [3401] = 923,
  [3402] = 934,
  [3403] = 3280,
  [3404] = 920,
  [3405] = 3320,
  [3406] = 3320,
  [3407] = 3296,
  [3408] = 3307,
  [3409] = 3315,
  [3410] = 3314,
  [3411] = 3310,
  [3412] = 3270,
  [3413] = 898,
  [3414] = 3320,
  [3415] = 3320,
  [3416] = 916,
  [3417] = 912,
  [3418] = 3320,
  [3419] = 3288,
  [3420] = 3420,
  [3421] = 3365,
  [3422] = 3387,
  [3423] = 3361,
  [3424] = 3420,
  [3425] = 3326,
  [3426] = 3391,
  [3427] = 3398,
  [3428] = 924,
  [3429] = 949,
  [3430] = 928,
  [3431] = 927,
  [3432] = 912,
  [3433] = 936,
  [3434] = 3336,
  [3435] = 3393,
  [3436] = 3389,
  [3437] = 935,
  [3438] = 930,
  [3439] = 3353,
  [3440] = 898,
  [3441] = 920,
  [3442] = 919,
  [3443] = 918,
  [3444] = 3370,
  [3445] = 916,
  [3446] = 923,
  [3447] = 3351,
  [3448] = 3345,
  [3449] = 921,
  [3450] = 917,
  [3451] = 3451,
  [3452] = 934,
  [3453] = 3451,
  [3454] = 3330,
  [3455] = 3357,
  [3456] = 3451,
  [3457] = 3451,
  [3458] = 966,
  [3459] = 928,
  [3460] = 976,
  [3461] = 960,
  [3462] = 3462,
  [3463] = 954,
  [3464] = 935,
  [3465] = 3462,
  [3466] = 920,
  [3467] = 3249,
  [3468] = 924,
  [3469] = 916,
  [3470] = 3462,
  [3471] = 917,
  [3472] = 927,
  [3473] = 3254,
  [3474] = 923,
  [3475] = 919,
  [3476] = 918,
  [3477] = 3477,
  [3478] = 3462,
  [3479] = 934,
  [3480] = 3265,
  [3481] = 3280,
  [3482] = 971,
  [3483] = 3287,
  [3484] = 3265,
  [3485] = 3254,
  [3486] = 3249,
  [3487] = 3288,
  [3488] = 1074,
  [3489] = 1093,
  [3490] = 1112,
  [3491] = 3357,
  [3492] = 1086,
  [3493] = 1054,
  [3494] = 971,
  [3495] = 3353,
  [3496] = 3265,
  [3497] = 1126,
  [3498] = 1048,
  [3499] = 1127,
  [3500] = 1047,
  [3501] = 1107,
  [3502] = 3249,
  [3503] = 1055,
  [3504] = 3280,
  [3505] = 1060,
  [3506] = 1114,
  [3507] = 1113,
  [3508] = 3288,
  [3509] = 1121,
  [3510] = 1073,
  [3511] = 1083,
  [3512] = 1111,
  [3513] = 3254,
  [3514] = 1110,
  [3515] = 1092,
  [3516] = 3287,
  [3517] = 1109,
  [3518] = 1125,
  [3519] = 1108,
  [3520] = 1046,
  [3521] = 1095,
  [3522] = 1069,
  [3523] = 1096,
  [3524] = 1098,
  [3525] = 1103,
  [3526] = 1105,
  [3527] = 3527,
  [3528] = 3357,
  [3529] = 3288,
  [3530] = 3280,
  [3531] = 971,
  [3532] = 3532,
  [3533] = 3353,
  [3534] = 3287,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3353,
  [3538] = 3357,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3544,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3546,
  [3550] = 3546,
  [3551] = 3546,
  [3552] = 3552,
  [3553] = 3546,
  [3554] = 3546,
  [3555] = 3546,
  [3556] = 3546,
  [3557] = 3544,
  [3558] = 3546,
  [3559] = 3545,
  [3560] = 3546,
  [3561] = 3546,
  [3562] = 3546,
  [3563] = 3546,
  [3564] = 864,
  [3565] = 864,
  [3566] = 864,
  [3567] = 866,
  [3568] = 864,
  [3569] = 866,
  [3570] = 866,
  [3571] = 866,
  [3572] = 864,
  [3573] = 3573,
  [3574] = 913,
  [3575] = 882,
  [3576] = 880,
  [3577] = 904,
  [3578] = 880,
  [3579] = 882,
  [3580] = 879,
  [3581] = 886,
  [3582] = 907,
  [3583] = 3583,
  [3584] = 907,
  [3585] = 866,
  [3586] = 3586,
  [3587] = 904,
  [3588] = 913,
  [3589] = 879,
  [3590] = 886,
  [3591] = 925,
  [3592] = 896,
  [3593] = 915,
  [3594] = 938,
  [3595] = 915,
  [3596] = 3596,
  [3597] = 925,
  [3598] = 938,
  [3599] = 910,
  [3600] = 896,
  [3601] = 910,
  [3602] = 936,
  [3603] = 930,
  [3604] = 898,
  [3605] = 936,
  [3606] = 898,
  [3607] = 930,
  [3608] = 921,
  [3609] = 912,
  [3610] = 949,
  [3611] = 912,
  [3612] = 3612,
  [3613] = 921,
  [3614] = 934,
  [3615] = 3615,
  [3616] = 882,
  [3617] = 920,
  [3618] = 3618,
  [3619] = 919,
  [3620] = 917,
  [3621] = 3618,
  [3622] = 935,
  [3623] = 918,
  [3624] = 966,
  [3625] = 916,
  [3626] = 923,
  [3627] = 924,
  [3628] = 3618,
  [3629] = 976,
  [3630] = 907,
  [3631] = 879,
  [3632] = 880,
  [3633] = 935,
  [3634] = 3634,
  [3635] = 928,
  [3636] = 927,
  [3637] = 928,
  [3638] = 927,
  [3639] = 911,
  [3640] = 934,
  [3641] = 923,
  [3642] = 913,
  [3643] = 924,
  [3644] = 3634,
  [3645] = 917,
  [3646] = 886,
  [3647] = 960,
  [3648] = 3634,
  [3649] = 920,
  [3650] = 915,
  [3651] = 916,
  [3652] = 954,
  [3653] = 904,
  [3654] = 918,
  [3655] = 919,
  [3656] = 896,
  [3657] = 938,
  [3658] = 921,
  [3659] = 882,
  [3660] = 886,
  [3661] = 925,
  [3662] = 949,
  [3663] = 3663,
  [3664] = 3573,
  [3665] = 915,
  [3666] = 3666,
  [3667] = 864,
  [3668] = 913,
  [3669] = 910,
  [3670] = 879,
  [3671] = 1064,
  [3672] = 907,
  [3673] = 904,
  [3674] = 896,
  [3675] = 880,
  [3676] = 949,
  [3677] = 1127,
  [3678] = 954,
  [3679] = 3596,
  [3680] = 1087,
  [3681] = 954,
  [3682] = 921,
  [3683] = 911,
  [3684] = 912,
  [3685] = 915,
  [3686] = 911,
  [3687] = 1121,
  [3688] = 3573,
  [3689] = 1118,
  [3690] = 3666,
  [3691] = 896,
  [3692] = 1120,
  [3693] = 898,
  [3694] = 930,
  [3695] = 960,
  [3696] = 976,
  [3697] = 966,
  [3698] = 3583,
  [3699] = 3586,
  [3700] = 976,
  [3701] = 938,
  [3702] = 1114,
  [3703] = 1113,
  [3704] = 936,
  [3705] = 1111,
  [3706] = 925,
  [3707] = 1110,
  [3708] = 960,
  [3709] = 3709,
  [3710] = 1109,
  [3711] = 1117,
  [3712] = 915,
  [3713] = 3713,
  [3714] = 1048,
  [3715] = 949,
  [3716] = 910,
  [3717] = 1108,
  [3718] = 1046,
  [3719] = 1105,
  [3720] = 1054,
  [3721] = 966,
  [3722] = 1103,
  [3723] = 1086,
  [3724] = 1098,
  [3725] = 1126,
  [3726] = 896,
  [3727] = 1096,
  [3728] = 915,
  [3729] = 910,
  [3730] = 1097,
  [3731] = 1095,
  [3732] = 1093,
  [3733] = 1092,
  [3734] = 1083,
  [3735] = 1094,
  [3736] = 1058,
  [3737] = 1074,
  [3738] = 1073,
  [3739] = 3739,
  [3740] = 1125,
  [3741] = 896,
  [3742] = 896,
  [3743] = 915,
  [3744] = 1060,
  [3745] = 1055,
  [3746] = 1112,
  [3747] = 1107,
  [3748] = 1069,
  [3749] = 1047,
  [3750] = 921,
  [3751] = 3751,
  [3752] = 920,
  [3753] = 3663,
  [3754] = 921,
  [3755] = 3751,
  [3756] = 921,
  [3757] = 3757,
  [3758] = 913,
  [3759] = 966,
  [3760] = 912,
  [3761] = 3761,
  [3762] = 918,
  [3763] = 1064,
  [3764] = 960,
  [3765] = 3751,
  [3766] = 898,
  [3767] = 954,
  [3768] = 3768,
  [3769] = 3663,
  [3770] = 923,
  [3771] = 3768,
  [3772] = 921,
  [3773] = 3768,
  [3774] = 935,
  [3775] = 3751,
  [3776] = 3751,
  [3777] = 3777,
  [3778] = 3751,
  [3779] = 976,
  [3780] = 928,
  [3781] = 3751,
  [3782] = 3586,
  [3783] = 904,
  [3784] = 3751,
  [3785] = 3785,
  [3786] = 934,
  [3787] = 3583,
  [3788] = 3751,
  [3789] = 930,
  [3790] = 927,
  [3791] = 916,
  [3792] = 866,
  [3793] = 911,
  [3794] = 3751,
  [3795] = 919,
  [3796] = 3751,
  [3797] = 3797,
  [3798] = 1064,
  [3799] = 3751,
  [3800] = 936,
  [3801] = 924,
  [3802] = 917,
  [3803] = 3751,
  [3804] = 3768,
  [3805] = 1113,
  [3806] = 3806,
  [3807] = 1047,
  [3808] = 1048,
  [3809] = 3809,
  [3810] = 1107,
  [3811] = 3811,
  [3812] = 1055,
  [3813] = 3813,
  [3814] = 1060,
  [3815] = 3815,
  [3816] = 3816,
  [3817] = 1069,
  [3818] = 927,
  [3819] = 3819,
  [3820] = 1058,
  [3821] = 1073,
  [3822] = 1074,
  [3823] = 1083,
  [3824] = 1092,
  [3825] = 1093,
  [3826] = 1095,
  [3827] = 1096,
  [3828] = 1098,
  [3829] = 1112,
  [3830] = 1103,
  [3831] = 1086,
  [3832] = 3832,
  [3833] = 1054,
  [3834] = 3834,
  [3835] = 1105,
  [3836] = 1046,
  [3837] = 1108,
  [3838] = 1109,
  [3839] = 1110,
  [3840] = 1111,
  [3841] = 3841,
  [3842] = 3842,
  [3843] = 1048,
  [3844] = 1114,
  [3845] = 1047,
  [3846] = 925,
  [3847] = 1107,
  [3848] = 1055,
  [3849] = 1069,
  [3850] = 1060,
  [3851] = 1112,
  [3852] = 1073,
  [3853] = 1120,
  [3854] = 1121,
  [3855] = 1094,
  [3856] = 1074,
  [3857] = 1125,
  [3858] = 1126,
  [3859] = 1083,
  [3860] = 1127,
  [3861] = 1092,
  [3862] = 1093,
  [3863] = 1095,
  [3864] = 1096,
  [3865] = 1098,
  [3866] = 1103,
  [3867] = 1105,
  [3868] = 1046,
  [3869] = 938,
  [3870] = 1108,
  [3871] = 1109,
  [3872] = 1110,
  [3873] = 3873,
  [3874] = 1111,
  [3875] = 3875,
  [3876] = 1086,
  [3877] = 918,
  [3878] = 1054,
  [3879] = 1113,
  [3880] = 1114,
  [3881] = 1127,
  [3882] = 1121,
  [3883] = 1125,
  [3884] = 1126,
  [3885] = 920,
  [3886] = 3886,
  [3887] = 3832,
  [3888] = 3875,
  [3889] = 3889,
  [3890] = 917,
  [3891] = 923,
  [3892] = 916,
  [3893] = 919,
  [3894] = 3832,
  [3895] = 3713,
  [3896] = 924,
  [3897] = 3897,
  [3898] = 1094,
  [3899] = 1097,
  [3900] = 3832,
  [3901] = 3901,
  [3902] = 1117,
  [3903] = 928,
  [3904] = 1118,
  [3905] = 1058,
  [3906] = 1120,
  [3907] = 3907,
  [3908] = 3908,
  [3909] = 1087,
  [3910] = 3910,
  [3911] = 3663,
  [3912] = 1064,
  [3913] = 935,
  [3914] = 1118,
  [3915] = 934,
  [3916] = 3886,
  [3917] = 1117,
  [3918] = 1097,
  [3919] = 1087,
  [3920] = 3920,
  [3921] = 3921,
  [3922] = 3922,
  [3923] = 3713,
  [3924] = 3924,
  [3925] = 3907,
  [3926] = 3926,
  [3927] = 1127,
  [3928] = 1087,
  [3929] = 3841,
  [3930] = 1086,
  [3931] = 3842,
  [3932] = 3816,
  [3933] = 1094,
  [3934] = 1113,
  [3935] = 3935,
  [3936] = 3936,
  [3937] = 3834,
  [3938] = 3815,
  [3939] = 3939,
  [3940] = 3924,
  [3941] = 1097,
  [3942] = 3942,
  [3943] = 1117,
  [3944] = 1126,
  [3945] = 3942,
  [3946] = 3939,
  [3947] = 1118,
  [3948] = 3819,
  [3949] = 3809,
  [3950] = 3950,
  [3951] = 3951,
  [3952] = 3942,
  [3953] = 3953,
  [3954] = 3954,
  [3955] = 3813,
  [3956] = 3713,
  [3957] = 3957,
  [3958] = 3958,
  [3959] = 3811,
  [3960] = 1112,
  [3961] = 3961,
  [3962] = 3962,
  [3963] = 1069,
  [3964] = 3942,
  [3965] = 1110,
  [3966] = 3966,
  [3967] = 3967,
  [3968] = 1058,
  [3969] = 3939,
  [3970] = 3939,
  [3971] = 1120,
  [3972] = 1125,
  [3973] = 1121,
  [3974] = 1048,
  [3975] = 3942,
  [3976] = 3942,
  [3977] = 3977,
  [3978] = 3939,
  [3979] = 1047,
  [3980] = 1107,
  [3981] = 1055,
  [3982] = 1060,
  [3983] = 3983,
  [3984] = 1073,
  [3985] = 3985,
  [3986] = 1114,
  [3987] = 1074,
  [3988] = 1054,
  [3989] = 930,
  [3990] = 1111,
  [3991] = 3942,
  [3992] = 3942,
  [3993] = 3939,
  [3994] = 1083,
  [3995] = 1092,
  [3996] = 1093,
  [3997] = 1095,
  [3998] = 1096,
  [3999] = 3999,
  [4000] = 1098,
  [4001] = 1103,
  [4002] = 1105,
  [4003] = 1046,
  [4004] = 3939,
  [4005] = 1108,
  [4006] = 3939,
  [4007] = 1109,
  [4008] = 949,
  [4009] = 4009,
  [4010] = 4009,
  [4011] = 4009,
  [4012] = 896,
  [4013] = 4009,
  [4014] = 4014,
  [4015] = 910,
  [4016] = 4009,
  [4017] = 915,
  [4018] = 4009,
  [4019] = 4009,
  [4020] = 4009,
  [4021] = 904,
  [4022] = 954,
  [4023] = 3797,
  [4024] = 966,
  [4025] = 960,
  [4026] = 921,
  [4027] = 913,
  [4028] = 2890,
  [4029] = 976,
  [4030] = 4030,
  [4031] = 907,
  [4032] = 3901,
  [4033] = 3910,
  [4034] = 2890,
  [4035] = 880,
  [4036] = 3908,
  [4037] = 2592,
  [4038] = 882,
  [4039] = 879,
  [4040] = 2620,
  [4041] = 904,
  [4042] = 864,
  [4043] = 3920,
  [4044] = 3921,
  [4045] = 925,
  [4046] = 886,
  [4047] = 3922,
  [4048] = 4048,
  [4049] = 3757,
  [4050] = 3806,
  [4051] = 3761,
  [4052] = 2421,
  [4053] = 3897,
  [4054] = 3761,
  [4055] = 3785,
  [4056] = 913,
  [4057] = 3785,
  [4058] = 938,
  [4059] = 3757,
  [4060] = 1127,
  [4061] = 886,
  [4062] = 3842,
  [4063] = 3834,
  [4064] = 3811,
  [4065] = 3889,
  [4066] = 2800,
  [4067] = 2786,
  [4068] = 3819,
  [4069] = 2803,
  [4070] = 2820,
  [4071] = 3813,
  [4072] = 2806,
  [4073] = 3886,
  [4074] = 3809,
  [4075] = 3873,
  [4076] = 1086,
  [4077] = 4077,
  [4078] = 3813,
  [4079] = 3811,
  [4080] = 3873,
  [4081] = 3907,
  [4082] = 3834,
  [4083] = 3886,
  [4084] = 3819,
  [4085] = 3809,
  [4086] = 3907,
  [4087] = 896,
  [4088] = 3873,
  [4089] = 1112,
  [4090] = 1069,
  [4091] = 3951,
  [4092] = 2620,
  [4093] = 3815,
  [4094] = 3950,
  [4095] = 880,
  [4096] = 3936,
  [4097] = 882,
  [4098] = 3875,
  [4099] = 3958,
  [4100] = 915,
  [4101] = 2421,
  [4102] = 3926,
  [4103] = 2592,
  [4104] = 3957,
  [4105] = 3875,
  [4106] = 930,
  [4107] = 879,
  [4108] = 4108,
  [4109] = 3967,
  [4110] = 3977,
  [4111] = 910,
  [4112] = 3935,
  [4113] = 938,
  [4114] = 4114,
  [4115] = 3841,
  [4116] = 913,
  [4117] = 925,
  [4118] = 4118,
  [4119] = 1126,
  [4120] = 1048,
  [4121] = 1047,
  [4122] = 1107,
  [4123] = 3816,
  [4124] = 1125,
  [4125] = 1121,
  [4126] = 1054,
  [4127] = 3842,
  [4128] = 1055,
  [4129] = 904,
  [4130] = 1060,
  [4131] = 3816,
  [4132] = 3841,
  [4133] = 3815,
  [4134] = 1114,
  [4135] = 3873,
  [4136] = 3889,
  [4137] = 1113,
  [4138] = 907,
  [4139] = 3961,
  [4140] = 1073,
  [4141] = 1074,
  [4142] = 1083,
  [4143] = 1092,
  [4144] = 1093,
  [4145] = 3953,
  [4146] = 3954,
  [4147] = 1095,
  [4148] = 1096,
  [4149] = 1098,
  [4150] = 3962,
  [4151] = 1103,
  [4152] = 1105,
  [4153] = 1046,
  [4154] = 1108,
  [4155] = 1109,
  [4156] = 1110,
  [4157] = 1111,
  [4158] = 3985,
  [4159] = 3983,
  [4160] = 915,
  [4161] = 2812,
  [4162] = 2817,
  [4163] = 4163,
  [4164] = 4164,
  [4165] = 4163,
  [4166] = 938,
  [4167] = 936,
  [4168] = 2800,
  [4169] = 4169,
  [4170] = 866,
  [4171] = 2786,
  [4172] = 912,
  [4173] = 4163,
  [4174] = 921,
  [4175] = 925,
  [4176] = 4163,
  [4177] = 910,
  [4178] = 2803,
  [4179] = 896,
  [4180] = 2820,
  [4181] = 2806,
  [4182] = 2787,
  [4183] = 898,
  [4184] = 930,
  [4185] = 2787,
  [4186] = 924,
  [4187] = 898,
  [4188] = 2817,
  [4189] = 930,
  [4190] = 934,
  [4191] = 2812,
  [4192] = 921,
  [4193] = 936,
  [4194] = 915,
  [4195] = 918,
  [4196] = 927,
  [4197] = 896,
  [4198] = 920,
  [4199] = 935,
  [4200] = 912,
  [4201] = 917,
  [4202] = 928,
  [4203] = 919,
  [4204] = 4204,
  [4205] = 923,
  [4206] = 916,
  [4207] = 918,
  [4208] = 919,
  [4209] = 4209,
  [4210] = 916,
  [4211] = 949,
  [4212] = 920,
  [4213] = 4213,
  [4214] = 919,
  [4215] = 934,
  [4216] = 935,
  [4217] = 917,
  [4218] = 927,
  [4219] = 924,
  [4220] = 923,
  [4221] = 864,
  [4222] = 4209,
  [4223] = 4209,
  [4224] = 928,
  [4225] = 4213,
  [4226] = 921,
  [4227] = 923,
  [4228] = 4209,
  [4229] = 4229,
  [4230] = 4213,
  [4231] = 916,
  [4232] = 4213,
  [4233] = 4233,
  [4234] = 4233,
  [4235] = 4235,
  [4236] = 4233,
  [4237] = 4233,
  [4238] = 4233,
  [4239] = 923,
  [4240] = 886,
  [4241] = 882,
  [4242] = 916,
  [4243] = 976,
  [4244] = 4233,
  [4245] = 919,
  [4246] = 4246,
  [4247] = 4247,
  [4248] = 4248,
  [4249] = 4249,
  [4250] = 4233,
  [4251] = 4251,
  [4252] = 4235,
  [4253] = 4233,
  [4254] = 4246,
  [4255] = 4249,
  [4256] = 954,
  [4257] = 879,
  [4258] = 4233,
  [4259] = 4233,
  [4260] = 4248,
  [4261] = 4248,
  [4262] = 904,
  [4263] = 960,
  [4264] = 915,
  [4265] = 4249,
  [4266] = 4233,
  [4267] = 4235,
  [4268] = 4248,
  [4269] = 966,
  [4270] = 4233,
  [4271] = 4246,
  [4272] = 880,
  [4273] = 4273,
  [4274] = 4233,
  [4275] = 913,
  [4276] = 4235,
  [4277] = 4249,
  [4278] = 910,
  [4279] = 907,
  [4280] = 4246,
  [4281] = 896,
  [4282] = 4282,
  [4283] = 880,
  [4284] = 907,
  [4285] = 913,
  [4286] = 907,
  [4287] = 882,
  [4288] = 4288,
  [4289] = 4289,
  [4290] = 2620,
  [4291] = 904,
  [4292] = 4292,
  [4293] = 904,
  [4294] = 925,
  [4295] = 915,
  [4296] = 4204,
  [4297] = 896,
  [4298] = 921,
  [4299] = 880,
  [4300] = 2592,
  [4301] = 2421,
  [4302] = 907,
  [4303] = 886,
  [4304] = 4304,
  [4305] = 913,
  [4306] = 4306,
  [4307] = 879,
  [4308] = 4308,
  [4309] = 904,
  [4310] = 938,
  [4311] = 882,
  [4312] = 913,
  [4313] = 4292,
  [4314] = 3875,
  [4315] = 910,
  [4316] = 3967,
  [4317] = 866,
  [4318] = 3886,
  [4319] = 3889,
  [4320] = 880,
  [4321] = 886,
  [4322] = 882,
  [4323] = 879,
  [4324] = 4030,
  [4325] = 879,
  [4326] = 4326,
  [4327] = 886,
  [4328] = 4328,
  [4329] = 4329,
  [4330] = 4328,
  [4331] = 4328,
  [4332] = 4332,
  [4333] = 4333,
  [4334] = 4334,
  [4335] = 4335,
  [4336] = 4336,
  [4337] = 4335,
  [4338] = 4333,
  [4339] = 4329,
  [4340] = 4340,
  [4341] = 4334,
  [4342] = 4342,
  [4343] = 4343,
  [4344] = 4333,
  [4345] = 4329,
  [4346] = 3985,
  [4347] = 3983,
  [4348] = 4348,
  [4349] = 4335,
  [4350] = 4333,
  [4351] = 4329,
  [4352] = 4340,
  [4353] = 4353,
  [4354] = 4348,
  [4355] = 4355,
  [4356] = 910,
  [4357] = 3875,
  [4358] = 4355,
  [4359] = 4359,
  [4360] = 1113,
  [4361] = 2620,
  [4362] = 4362,
  [4363] = 4340,
  [4364] = 910,
  [4365] = 4365,
  [4366] = 4332,
  [4367] = 4329,
  [4368] = 4333,
  [4369] = 1112,
  [4370] = 4333,
  [4371] = 4336,
  [4372] = 4328,
  [4373] = 4342,
  [4374] = 4329,
  [4375] = 4353,
  [4376] = 4348,
  [4377] = 925,
  [4378] = 4359,
  [4379] = 4379,
  [4380] = 4340,
  [4381] = 4329,
  [4382] = 4362,
  [4383] = 4328,
  [4384] = 4384,
  [4385] = 4340,
  [4386] = 4362,
  [4387] = 938,
  [4388] = 936,
  [4389] = 4343,
  [4390] = 4343,
  [4391] = 4329,
  [4392] = 4362,
  [4393] = 1111,
  [4394] = 1110,
  [4395] = 898,
  [4396] = 4396,
  [4397] = 4328,
  [4398] = 1109,
  [4399] = 4340,
  [4400] = 4333,
  [4401] = 4335,
  [4402] = 4379,
  [4403] = 912,
  [4404] = 4340,
  [4405] = 4335,
  [4406] = 4348,
  [4407] = 4407,
  [4408] = 4328,
  [4409] = 4379,
  [4410] = 4355,
  [4411] = 4328,
  [4412] = 1108,
  [4413] = 4413,
  [4414] = 4333,
  [4415] = 4359,
  [4416] = 4329,
  [4417] = 3954,
  [4418] = 4418,
  [4419] = 4328,
  [4420] = 3953,
  [4421] = 4421,
  [4422] = 3886,
  [4423] = 4340,
  [4424] = 4335,
  [4425] = 4353,
  [4426] = 4336,
  [4427] = 4427,
  [4428] = 938,
  [4429] = 4333,
  [4430] = 4328,
  [4431] = 4353,
  [4432] = 4342,
  [4433] = 4384,
  [4434] = 4340,
  [4435] = 1046,
  [4436] = 4328,
  [4437] = 4329,
  [4438] = 4384,
  [4439] = 4421,
  [4440] = 4440,
  [4441] = 4333,
  [4442] = 4421,
  [4443] = 4418,
  [4444] = 4384,
  [4445] = 4359,
  [4446] = 4336,
  [4447] = 925,
  [4448] = 4335,
  [4449] = 4353,
  [4450] = 4348,
  [4451] = 4328,
  [4452] = 4452,
  [4453] = 4342,
  [4454] = 4329,
  [4455] = 4328,
  [4456] = 1105,
  [4457] = 4340,
  [4458] = 1103,
  [4459] = 4332,
  [4460] = 4328,
  [4461] = 4396,
  [4462] = 1098,
  [4463] = 4335,
  [4464] = 4384,
  [4465] = 4328,
  [4466] = 4336,
  [4467] = 4379,
  [4468] = 4333,
  [4469] = 4355,
  [4470] = 1096,
  [4471] = 4471,
  [4472] = 1095,
  [4473] = 4333,
  [4474] = 4328,
  [4475] = 4475,
  [4476] = 4379,
  [4477] = 4477,
  [4478] = 4478,
  [4479] = 4329,
  [4480] = 4328,
  [4481] = 896,
  [4482] = 4328,
  [4483] = 4483,
  [4484] = 4484,
  [4485] = 4340,
  [4486] = 4332,
  [4487] = 4348,
  [4488] = 4340,
  [4489] = 915,
  [4490] = 4335,
  [4491] = 4348,
  [4492] = 4333,
  [4493] = 4328,
  [4494] = 4362,
  [4495] = 4329,
  [4496] = 4355,
  [4497] = 4333,
  [4498] = 4329,
  [4499] = 4348,
  [4500] = 4334,
  [4501] = 4396,
  [4502] = 4343,
  [4503] = 4348,
  [4504] = 4334,
  [4505] = 4340,
  [4506] = 930,
  [4507] = 4329,
  [4508] = 4508,
  [4509] = 4348,
  [4510] = 4328,
  [4511] = 4396,
  [4512] = 3889,
  [4513] = 4418,
  [4514] = 4340,
  [4515] = 4515,
  [4516] = 4328,
  [4517] = 4328,
  [4518] = 4365,
  [4519] = 4335,
  [4520] = 4332,
  [4521] = 4471,
  [4522] = 4477,
  [4523] = 4333,
  [4524] = 4340,
  [4525] = 4515,
  [4526] = 4336,
  [4527] = 4348,
  [4528] = 4335,
  [4529] = 4333,
  [4530] = 4329,
  [4531] = 4342,
  [4532] = 4340,
  [4533] = 4328,
  [4534] = 4384,
  [4535] = 4340,
  [4536] = 4329,
  [4537] = 4340,
  [4538] = 4329,
  [4539] = 4340,
  [4540] = 4333,
  [4541] = 4353,
  [4542] = 4328,
  [4543] = 4359,
  [4544] = 4333,
  [4545] = 4329,
  [4546] = 1092,
  [4547] = 4333,
  [4548] = 4359,
  [4549] = 4362,
  [4550] = 4340,
  [4551] = 4329,
  [4552] = 4362,
  [4553] = 4340,
  [4554] = 4329,
  [4555] = 4348,
  [4556] = 4329,
  [4557] = 4333,
  [4558] = 4340,
  [4559] = 4335,
  [4560] = 4340,
  [4561] = 1083,
  [4562] = 2592,
  [4563] = 4333,
  [4564] = 4359,
  [4565] = 1074,
  [4566] = 4335,
  [4567] = 4362,
  [4568] = 4340,
  [4569] = 4353,
  [4570] = 4570,
  [4571] = 1073,
  [4572] = 4340,
  [4573] = 4329,
  [4574] = 4333,
  [4575] = 4333,
  [4576] = 3254,
  [4577] = 1114,
  [4578] = 4340,
  [4579] = 3265,
  [4580] = 2806,
  [4581] = 3249,
  [4582] = 4329,
  [4583] = 4333,
  [4584] = 4584,
  [4585] = 4342,
  [4586] = 4335,
  [4587] = 4355,
  [4588] = 4329,
  [4589] = 4328,
  [4590] = 4348,
  [4591] = 4515,
  [4592] = 4477,
  [4593] = 2820,
  [4594] = 4471,
  [4595] = 4328,
  [4596] = 4359,
  [4597] = 4353,
  [4598] = 3220,
  [4599] = 4421,
  [4600] = 4328,
  [4601] = 4384,
  [4602] = 4342,
  [4603] = 4335,
  [4604] = 4333,
  [4605] = 4336,
  [4606] = 4332,
  [4607] = 4329,
  [4608] = 4334,
  [4609] = 4335,
  [4610] = 4340,
  [4611] = 2620,
  [4612] = 2803,
  [4613] = 4384,
  [4614] = 4334,
  [4615] = 1060,
  [4616] = 4335,
  [4617] = 4333,
  [4618] = 4333,
  [4619] = 4421,
  [4620] = 4329,
  [4621] = 4355,
  [4622] = 4418,
  [4623] = 1055,
  [4624] = 1054,
  [4625] = 4329,
  [4626] = 4340,
  [4627] = 1107,
  [4628] = 921,
  [4629] = 1047,
  [4630] = 2786,
  [4631] = 4355,
  [4632] = 1048,
  [4633] = 4328,
  [4634] = 2421,
  [4635] = 4336,
  [4636] = 910,
  [4637] = 1093,
  [4638] = 4384,
  [4639] = 938,
  [4640] = 4348,
  [4641] = 4355,
  [4642] = 4353,
  [4643] = 925,
  [4644] = 4332,
  [4645] = 3214,
  [4646] = 4452,
  [4647] = 4343,
  [4648] = 4384,
  [4649] = 4340,
  [4650] = 4348,
  [4651] = 4328,
  [4652] = 4379,
  [4653] = 2800,
  [4654] = 4335,
  [4655] = 4333,
  [4656] = 4421,
  [4657] = 2421,
  [4658] = 4335,
  [4659] = 4328,
  [4660] = 4379,
  [4661] = 896,
  [4662] = 4328,
  [4663] = 1121,
  [4664] = 1125,
  [4665] = 915,
  [4666] = 4666,
  [4667] = 2592,
  [4668] = 4365,
  [4669] = 4334,
  [4670] = 4421,
  [4671] = 4333,
  [4672] = 4329,
  [4673] = 4340,
  [4674] = 4342,
  [4675] = 4675,
  [4676] = 4384,
  [4677] = 4335,
  [4678] = 4340,
  [4679] = 4384,
  [4680] = 4384,
  [4681] = 4329,
  [4682] = 1069,
  [4683] = 4452,
  [4684] = 4684,
  [4685] = 4685,
  [4686] = 4333,
  [4687] = 4335,
  [4688] = 4340,
  [4689] = 4329,
  [4690] = 4328,
  [4691] = 971,
  [4692] = 4328,
  [4693] = 4355,
  [4694] = 1086,
  [4695] = 4471,
  [4696] = 4477,
  [4697] = 4379,
  [4698] = 4333,
  [4699] = 4515,
  [4700] = 1126,
  [4701] = 4334,
  [4702] = 4348,
  [4703] = 4333,
  [4704] = 4333,
  [4705] = 4418,
  [4706] = 915,
  [4707] = 896,
  [4708] = 4329,
  [4709] = 4329,
  [4710] = 4710,
  [4711] = 4355,
  [4712] = 4365,
  [4713] = 4340,
  [4714] = 4421,
  [4715] = 4336,
  [4716] = 4384,
  [4717] = 1127,
  [4718] = 4348,
  [4719] = 4332,
  [4720] = 4118,
  [4721] = 3265,
  [4722] = 2977,
  [4723] = 971,
  [4724] = 2982,
  [4725] = 3014,
  [4726] = 3002,
  [4727] = 3013,
  [4728] = 2974,
  [4729] = 2620,
  [4730] = 2976,
  [4731] = 2800,
  [4732] = 2786,
  [4733] = 921,
  [4734] = 2806,
  [4735] = 2820,
  [4736] = 2803,
  [4737] = 2803,
  [4738] = 4114,
  [4739] = 2786,
  [4740] = 2800,
  [4741] = 930,
  [4742] = 1058,
  [4743] = 3220,
  [4744] = 1087,
  [4745] = 3214,
  [4746] = 1097,
  [4747] = 1117,
  [4748] = 1118,
  [4749] = 3573,
  [4750] = 2820,
  [4751] = 3287,
  [4752] = 3288,
  [4753] = 3280,
  [4754] = 2970,
  [4755] = 3032,
  [4756] = 921,
  [4757] = 912,
  [4758] = 898,
  [4759] = 936,
  [4760] = 2806,
  [4761] = 3254,
  [4762] = 3249,
  [4763] = 921,
  [4764] = 2812,
  [4765] = 923,
  [4766] = 916,
  [4767] = 919,
  [4768] = 3573,
  [4769] = 936,
  [4770] = 898,
  [4771] = 912,
  [4772] = 2817,
  [4773] = 930,
  [4774] = 936,
  [4775] = 898,
  [4776] = 912,
  [4777] = 2787,
  [4778] = 918,
  [4779] = 920,
  [4780] = 924,
  [4781] = 930,
  [4782] = 927,
  [4783] = 928,
  [4784] = 935,
  [4785] = 934,
  [4786] = 4108,
  [4787] = 917,
  [4788] = 2592,
  [4789] = 2421,
  [4790] = 2812,
  [4791] = 3280,
  [4792] = 3586,
  [4793] = 3239,
  [4794] = 3294,
  [4795] = 3164,
  [4796] = 3134,
  [4797] = 3037,
  [4798] = 3038,
  [4799] = 3039,
  [4800] = 3241,
  [4801] = 2786,
  [4802] = 3140,
  [4803] = 3173,
  [4804] = 2820,
  [4805] = 3132,
  [4806] = 2800,
  [4807] = 3130,
  [4808] = 3089,
  [4809] = 3353,
  [4810] = 3056,
  [4811] = 3055,
  [4812] = 3266,
  [4813] = 3094,
  [4814] = 3583,
  [4815] = 3155,
  [4816] = 3149,
  [4817] = 3092,
  [4818] = 3075,
  [4819] = 2787,
  [4820] = 4820,
  [4821] = 2817,
  [4822] = 4822,
  [4823] = 4823,
  [4824] = 913,
  [4825] = 4825,
  [4826] = 2812,
  [4827] = 2806,
  [4828] = 904,
  [4829] = 913,
  [4830] = 904,
  [4831] = 879,
  [4832] = 882,
  [4833] = 886,
  [4834] = 3573,
  [4835] = 4835,
  [4836] = 880,
  [4837] = 907,
  [4838] = 4838,
  [4839] = 4839,
  [4840] = 2817,
  [4841] = 879,
  [4842] = 882,
  [4843] = 3583,
  [4844] = 886,
  [4845] = 880,
  [4846] = 2803,
  [4847] = 923,
  [4848] = 916,
  [4849] = 3573,
  [4850] = 919,
  [4851] = 907,
  [4852] = 923,
  [4853] = 916,
  [4854] = 918,
  [4855] = 919,
  [4856] = 2970,
  [4857] = 920,
  [4858] = 2982,
  [4859] = 917,
  [4860] = 924,
  [4861] = 3002,
  [4862] = 927,
  [4863] = 928,
  [4864] = 2977,
  [4865] = 935,
  [4866] = 934,
  [4867] = 923,
  [4868] = 3014,
  [4869] = 3586,
  [4870] = 3013,
  [4871] = 916,
  [4872] = 2974,
  [4873] = 2976,
  [4874] = 918,
  [4875] = 919,
  [4876] = 920,
  [4877] = 3357,
  [4878] = 924,
  [4879] = 3032,
  [4880] = 924,
  [4881] = 2787,
  [4882] = 4882,
  [4883] = 928,
  [4884] = 4884,
  [4885] = 918,
  [4886] = 920,
  [4887] = 917,
  [4888] = 935,
  [4889] = 927,
  [4890] = 927,
  [4891] = 928,
  [4892] = 934,
  [4893] = 935,
  [4894] = 934,
  [4895] = 917,
  [4896] = 4896,
  [4897] = 4897,
  [4898] = 4898,
  [4899] = 4899,
  [4900] = 3288,
  [4901] = 3287,
  [4902] = 3134,
  [4903] = 880,
  [4904] = 907,
  [4905] = 4835,
  [4906] = 882,
  [4907] = 4838,
  [4908] = 910,
  [4909] = 4839,
  [4910] = 886,
  [4911] = 904,
  [4912] = 3075,
  [4913] = 886,
  [4914] = 882,
  [4915] = 3586,
  [4916] = 913,
  [4917] = 3583,
  [4918] = 879,
  [4919] = 880,
  [4920] = 904,
  [4921] = 4825,
  [4922] = 3596,
  [4923] = 4823,
  [4924] = 913,
  [4925] = 4822,
  [4926] = 2817,
  [4927] = 4820,
  [4928] = 3573,
  [4929] = 907,
  [4930] = 3353,
  [4931] = 919,
  [4932] = 4896,
  [4933] = 4898,
  [4934] = 3357,
  [4935] = 3092,
  [4936] = 3149,
  [4937] = 3155,
  [4938] = 3094,
  [4939] = 3266,
  [4940] = 925,
  [4941] = 3583,
  [4942] = 3055,
  [4943] = 3056,
  [4944] = 3239,
  [4945] = 3089,
  [4946] = 3130,
  [4947] = 3132,
  [4948] = 3173,
  [4949] = 3140,
  [4950] = 3241,
  [4951] = 910,
  [4952] = 879,
  [4953] = 4899,
  [4954] = 2812,
  [4955] = 3038,
  [4956] = 4882,
  [4957] = 3037,
  [4958] = 3039,
  [4959] = 3586,
  [4960] = 915,
  [4961] = 925,
  [4962] = 3164,
  [4963] = 3294,
  [4964] = 923,
  [4965] = 938,
  [4966] = 3586,
  [4967] = 896,
  [4968] = 3583,
  [4969] = 938,
  [4970] = 2787,
  [4971] = 915,
  [4972] = 4884,
  [4973] = 896,
  [4974] = 916,
  [4975] = 4897,
  [4976] = 913,
  [4977] = 912,
  [4978] = 4978,
  [4979] = 949,
  [4980] = 921,
  [4981] = 936,
  [4982] = 912,
  [4983] = 930,
  [4984] = 904,
  [4985] = 4978,
  [4986] = 3797,
  [4987] = 4987,
  [4988] = 4988,
  [4989] = 930,
  [4990] = 898,
  [4991] = 921,
  [4992] = 898,
  [4993] = 864,
  [4994] = 4994,
  [4995] = 3596,
  [4996] = 4978,
  [4997] = 936,
  [4998] = 4998,
  [4999] = 910,
  [5000] = 910,
  [5001] = 960,
  [5002] = 896,
  [5003] = 915,
  [5004] = 4978,
  [5005] = 4978,
  [5006] = 938,
  [5007] = 925,
  [5008] = 4978,
  [5009] = 4978,
  [5010] = 896,
  [5011] = 925,
  [5012] = 4978,
  [5013] = 938,
  [5014] = 3596,
  [5015] = 915,
  [5016] = 5016,
  [5017] = 912,
  [5018] = 921,
  [5019] = 921,
  [5020] = 910,
  [5021] = 919,
  [5022] = 923,
  [5023] = 916,
  [5024] = 918,
  [5025] = 920,
  [5026] = 917,
  [5027] = 924,
  [5028] = 927,
  [5029] = 928,
  [5030] = 4204,
  [5031] = 5031,
  [5032] = 954,
  [5033] = 935,
  [5034] = 934,
  [5035] = 5035,
  [5036] = 5036,
  [5037] = 938,
  [5038] = 923,
  [5039] = 916,
  [5040] = 918,
  [5041] = 919,
  [5042] = 920,
  [5043] = 917,
  [5044] = 924,
  [5045] = 927,
  [5046] = 925,
  [5047] = 928,
  [5048] = 2890,
  [5049] = 966,
  [5050] = 5050,
  [5051] = 935,
  [5052] = 934,
  [5053] = 5053,
  [5054] = 3897,
  [5055] = 3901,
  [5056] = 915,
  [5057] = 3806,
  [5058] = 896,
  [5059] = 5059,
  [5060] = 3922,
  [5061] = 5061,
  [5062] = 936,
  [5063] = 898,
  [5064] = 976,
  [5065] = 3920,
  [5066] = 4030,
  [5067] = 930,
  [5068] = 898,
  [5069] = 3910,
  [5070] = 912,
  [5071] = 3908,
  [5072] = 930,
  [5073] = 5073,
  [5074] = 936,
  [5075] = 935,
  [5076] = 934,
  [5077] = 5077,
  [5078] = 916,
  [5079] = 923,
  [5080] = 918,
  [5081] = 919,
  [5082] = 920,
  [5083] = 928,
  [5084] = 927,
  [5085] = 917,
  [5086] = 924,
  [5087] = 920,
  [5088] = 917,
  [5089] = 919,
  [5090] = 927,
  [5091] = 928,
  [5092] = 935,
  [5093] = 918,
  [5094] = 934,
  [5095] = 916,
  [5096] = 924,
  [5097] = 5097,
  [5098] = 5098,
  [5099] = 923,
  [5100] = 866,
  [5101] = 921,
  [5102] = 5102,
  [5103] = 971,
  [5104] = 5098,
  [5105] = 913,
  [5106] = 2890,
  [5107] = 5107,
  [5108] = 930,
  [5109] = 5098,
  [5110] = 904,
  [5111] = 5111,
  [5112] = 5112,
  [5113] = 5113,
  [5114] = 5114,
  [5115] = 2974,
  [5116] = 2976,
  [5117] = 1127,
  [5118] = 3977,
  [5119] = 5113,
  [5120] = 971,
  [5121] = 5114,
  [5122] = 938,
  [5123] = 5114,
  [5124] = 5113,
  [5125] = 1073,
  [5126] = 5113,
  [5127] = 1074,
  [5128] = 5114,
  [5129] = 5114,
  [5130] = 4114,
  [5131] = 880,
  [5132] = 5113,
  [5133] = 3954,
  [5134] = 1069,
  [5135] = 1083,
  [5136] = 1092,
  [5137] = 5114,
  [5138] = 907,
  [5139] = 1093,
  [5140] = 1095,
  [5141] = 5113,
  [5142] = 1096,
  [5143] = 1098,
  [5144] = 5113,
  [5145] = 1103,
  [5146] = 1105,
  [5147] = 5113,
  [5148] = 1046,
  [5149] = 1108,
  [5150] = 1109,
  [5151] = 3013,
  [5152] = 5114,
  [5153] = 1055,
  [5154] = 5113,
  [5155] = 3953,
  [5156] = 5113,
  [5157] = 1110,
  [5158] = 5114,
  [5159] = 1111,
  [5160] = 4118,
  [5161] = 5114,
  [5162] = 3961,
  [5163] = 5114,
  [5164] = 1112,
  [5165] = 1054,
  [5166] = 5113,
  [5167] = 5113,
  [5168] = 3962,
  [5169] = 1107,
  [5170] = 1113,
  [5171] = 3014,
  [5172] = 1114,
  [5173] = 5113,
  [5174] = 1047,
  [5175] = 3950,
  [5176] = 1048,
  [5177] = 5177,
  [5178] = 5178,
  [5179] = 5179,
  [5180] = 925,
  [5181] = 5114,
  [5182] = 5113,
  [5183] = 3967,
  [5184] = 5114,
  [5185] = 3957,
  [5186] = 2890,
  [5187] = 5187,
  [5188] = 5188,
  [5189] = 3951,
  [5190] = 5114,
  [5191] = 5114,
  [5192] = 1121,
  [5193] = 1125,
  [5194] = 5113,
  [5195] = 5114,
  [5196] = 1126,
  [5197] = 5113,
  [5198] = 5113,
  [5199] = 5114,
  [5200] = 3983,
  [5201] = 5114,
  [5202] = 3985,
  [5203] = 3921,
  [5204] = 3935,
  [5205] = 5205,
  [5206] = 5206,
  [5207] = 3936,
  [5208] = 5208,
  [5209] = 2970,
  [5210] = 2982,
  [5211] = 5114,
  [5212] = 879,
  [5213] = 882,
  [5214] = 5113,
  [5215] = 5113,
  [5216] = 3926,
  [5217] = 3002,
  [5218] = 3958,
  [5219] = 886,
  [5220] = 1060,
  [5221] = 5113,
  [5222] = 5114,
  [5223] = 5114,
  [5224] = 5114,
  [5225] = 4108,
  [5226] = 3032,
  [5227] = 5113,
  [5228] = 5114,
  [5229] = 5229,
  [5230] = 5114,
  [5231] = 5113,
  [5232] = 5232,
  [5233] = 5113,
  [5234] = 2977,
  [5235] = 1086,
  [5236] = 3134,
  [5237] = 3014,
  [5238] = 5238,
  [5239] = 5239,
  [5240] = 3149,
  [5241] = 5241,
  [5242] = 5241,
  [5243] = 3092,
  [5244] = 2982,
  [5245] = 5241,
  [5246] = 5239,
  [5247] = 5239,
  [5248] = 5241,
  [5249] = 5239,
  [5250] = 910,
  [5251] = 3140,
  [5252] = 2970,
  [5253] = 5241,
  [5254] = 5239,
  [5255] = 915,
  [5256] = 5241,
  [5257] = 5239,
  [5258] = 3002,
  [5259] = 5241,
  [5260] = 896,
  [5261] = 960,
  [5262] = 5241,
  [5263] = 5239,
  [5264] = 5239,
  [5265] = 2976,
  [5266] = 5239,
  [5267] = 5241,
  [5268] = 5241,
  [5269] = 5241,
  [5270] = 5239,
  [5271] = 5241,
  [5272] = 949,
  [5273] = 3089,
  [5274] = 2974,
  [5275] = 5239,
  [5276] = 3155,
  [5277] = 3056,
  [5278] = 3130,
  [5279] = 5241,
  [5280] = 3055,
  [5281] = 5239,
  [5282] = 5241,
  [5283] = 5241,
  [5284] = 5241,
  [5285] = 3132,
  [5286] = 3013,
  [5287] = 5239,
  [5288] = 3014,
  [5289] = 5239,
  [5290] = 2890,
  [5291] = 3173,
  [5292] = 5239,
  [5293] = 5239,
  [5294] = 2976,
  [5295] = 2974,
  [5296] = 5241,
  [5297] = 910,
  [5298] = 5239,
  [5299] = 2977,
  [5300] = 3032,
  [5301] = 5239,
  [5302] = 5241,
  [5303] = 3094,
  [5304] = 930,
  [5305] = 3032,
  [5306] = 5239,
  [5307] = 5241,
  [5308] = 2977,
  [5309] = 971,
  [5310] = 5239,
  [5311] = 3164,
  [5312] = 3002,
  [5313] = 3039,
  [5314] = 3038,
  [5315] = 3075,
  [5316] = 5239,
  [5317] = 3037,
  [5318] = 5241,
  [5319] = 5239,
  [5320] = 5241,
  [5321] = 5241,
  [5322] = 5239,
  [5323] = 2982,
  [5324] = 3013,
  [5325] = 971,
  [5326] = 5241,
  [5327] = 2970,
  [5328] = 5238,
  [5329] = 3039,
  [5330] = 5330,
  [5331] = 3132,
  [5332] = 3130,
  [5333] = 3130,
  [5334] = 3140,
  [5335] = 904,
  [5336] = 3055,
  [5337] = 3056,
  [5338] = 2977,
  [5339] = 913,
  [5340] = 3757,
  [5341] = 3761,
  [5342] = 3134,
  [5343] = 5343,
  [5344] = 3785,
  [5345] = 3038,
  [5346] = 3075,
  [5347] = 3037,
  [5348] = 3089,
  [5349] = 3056,
  [5350] = 3134,
  [5351] = 5330,
  [5352] = 2970,
  [5353] = 5330,
  [5354] = 3075,
  [5355] = 3092,
  [5356] = 3055,
  [5357] = 3761,
  [5358] = 3037,
  [5359] = 3164,
  [5360] = 2976,
  [5361] = 3155,
  [5362] = 3149,
  [5363] = 3038,
  [5364] = 3173,
  [5365] = 3094,
  [5366] = 2982,
  [5367] = 3757,
  [5368] = 976,
  [5369] = 2974,
  [5370] = 912,
  [5371] = 3094,
  [5372] = 5372,
  [5373] = 954,
  [5374] = 3785,
  [5375] = 3785,
  [5376] = 5376,
  [5377] = 3013,
  [5378] = 936,
  [5379] = 3757,
  [5380] = 3002,
  [5381] = 3089,
  [5382] = 5330,
  [5383] = 3797,
  [5384] = 3761,
  [5385] = 3155,
  [5386] = 3014,
  [5387] = 3164,
  [5388] = 3149,
  [5389] = 921,
  [5390] = 3140,
  [5391] = 898,
  [5392] = 3092,
  [5393] = 3173,
  [5394] = 3039,
  [5395] = 3785,
  [5396] = 3032,
  [5397] = 3757,
  [5398] = 966,
  [5399] = 3761,
  [5400] = 5400,
  [5401] = 3132,
  [5402] = 5402,
  [5403] = 5403,
  [5404] = 928,
  [5405] = 3875,
  [5406] = 3873,
  [5407] = 5407,
  [5408] = 5408,
  [5409] = 3889,
  [5410] = 5410,
  [5411] = 5411,
  [5412] = 3039,
  [5413] = 3038,
  [5414] = 3037,
  [5415] = 3886,
  [5416] = 3815,
  [5417] = 918,
  [5418] = 5407,
  [5419] = 3886,
  [5420] = 3921,
  [5421] = 3889,
  [5422] = 5411,
  [5423] = 5408,
  [5424] = 5403,
  [5425] = 5403,
  [5426] = 5408,
  [5427] = 3816,
  [5428] = 5428,
  [5429] = 5407,
  [5430] = 5411,
  [5431] = 3134,
  [5432] = 5432,
  [5433] = 925,
  [5434] = 3842,
  [5435] = 3075,
  [5436] = 5403,
  [5437] = 5408,
  [5438] = 3841,
  [5439] = 5403,
  [5440] = 938,
  [5441] = 920,
  [5442] = 5407,
  [5443] = 5403,
  [5444] = 3907,
  [5445] = 3811,
  [5446] = 3813,
  [5447] = 3809,
  [5448] = 3819,
  [5449] = 3834,
  [5450] = 3094,
  [5451] = 3875,
  [5452] = 3886,
  [5453] = 3140,
  [5454] = 3173,
  [5455] = 5410,
  [5456] = 5403,
  [5457] = 5408,
  [5458] = 3132,
  [5459] = 3130,
  [5460] = 3089,
  [5461] = 5432,
  [5462] = 5462,
  [5463] = 5410,
  [5464] = 924,
  [5465] = 3056,
  [5466] = 3055,
  [5467] = 4204,
  [5468] = 3889,
  [5469] = 3873,
  [5470] = 3155,
  [5471] = 3149,
  [5472] = 5407,
  [5473] = 3092,
  [5474] = 4030,
  [5475] = 5410,
  [5476] = 3164,
  [5477] = 5477,
  [5478] = 5478,
  [5479] = 3886,
  [5480] = 5408,
  [5481] = 5481,
  [5482] = 3841,
  [5483] = 3842,
  [5484] = 917,
  [5485] = 5407,
  [5486] = 5403,
  [5487] = 5403,
  [5488] = 3834,
  [5489] = 5489,
  [5490] = 5411,
  [5491] = 5432,
  [5492] = 927,
  [5493] = 5407,
  [5494] = 5408,
  [5495] = 5403,
  [5496] = 5407,
  [5497] = 5403,
  [5498] = 5403,
  [5499] = 5408,
  [5500] = 5408,
  [5501] = 935,
  [5502] = 5403,
  [5503] = 5403,
  [5504] = 5403,
  [5505] = 3816,
  [5506] = 5403,
  [5507] = 5403,
  [5508] = 5410,
  [5509] = 3873,
  [5510] = 3841,
  [5511] = 5407,
  [5512] = 3815,
  [5513] = 5403,
  [5514] = 934,
  [5515] = 5403,
  [5516] = 5408,
  [5517] = 3886,
  [5518] = 5518,
  [5519] = 5403,
  [5520] = 5520,
  [5521] = 3819,
  [5522] = 3889,
  [5523] = 3809,
  [5524] = 5408,
  [5525] = 3897,
  [5526] = 3834,
  [5527] = 5407,
  [5528] = 3813,
  [5529] = 3819,
  [5530] = 3586,
  [5531] = 3809,
  [5532] = 5403,
  [5533] = 3901,
  [5534] = 5403,
  [5535] = 5535,
  [5536] = 3813,
  [5537] = 5407,
  [5538] = 5407,
  [5539] = 3920,
  [5540] = 5403,
  [5541] = 3761,
  [5542] = 5408,
  [5543] = 3907,
  [5544] = 3811,
  [5545] = 3811,
  [5546] = 3907,
  [5547] = 3757,
  [5548] = 5403,
  [5549] = 3815,
  [5550] = 3875,
  [5551] = 3842,
  [5552] = 5552,
  [5553] = 3816,
  [5554] = 3908,
  [5555] = 3886,
  [5556] = 5403,
  [5557] = 3875,
  [5558] = 5403,
  [5559] = 5408,
  [5560] = 3907,
  [5561] = 3811,
  [5562] = 5407,
  [5563] = 5410,
  [5564] = 3813,
  [5565] = 3809,
  [5566] = 3819,
  [5567] = 3834,
  [5568] = 5403,
  [5569] = 5410,
  [5570] = 3910,
  [5571] = 5403,
  [5572] = 5572,
  [5573] = 5403,
  [5574] = 5403,
  [5575] = 3875,
  [5576] = 3875,
  [5577] = 5432,
  [5578] = 5403,
  [5579] = 5407,
  [5580] = 5408,
  [5581] = 3815,
  [5582] = 3816,
  [5583] = 3841,
  [5584] = 5408,
  [5585] = 5408,
  [5586] = 5586,
  [5587] = 3842,
  [5588] = 3873,
  [5589] = 5407,
  [5590] = 5408,
  [5591] = 5407,
  [5592] = 5410,
  [5593] = 5403,
  [5594] = 5403,
  [5595] = 5407,
  [5596] = 3785,
  [5597] = 5597,
  [5598] = 5403,
  [5599] = 5432,
  [5600] = 5408,
  [5601] = 5432,
  [5602] = 3806,
  [5603] = 5408,
  [5604] = 3922,
  [5605] = 5408,
  [5606] = 3583,
  [5607] = 5607,
  [5608] = 5407,
  [5609] = 5407,
  [5610] = 5408,
  [5611] = 3875,
  [5612] = 3886,
  [5613] = 5407,
  [5614] = 5408,
  [5615] = 5408,
  [5616] = 5616,
  [5617] = 5407,
  [5618] = 5403,
  [5619] = 5407,
  [5620] = 5407,
  [5621] = 5621,
  [5622] = 1055,
  [5623] = 5623,
  [5624] = 5624,
  [5625] = 5625,
  [5626] = 5621,
  [5627] = 5627,
  [5628] = 5627,
  [5629] = 5629,
  [5630] = 3834,
  [5631] = 3819,
  [5632] = 5632,
  [5633] = 3967,
  [5634] = 5627,
  [5635] = 3809,
  [5636] = 3813,
  [5637] = 5637,
  [5638] = 3875,
  [5639] = 5639,
  [5640] = 3811,
  [5641] = 3926,
  [5642] = 3907,
  [5643] = 3886,
  [5644] = 5639,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 3875,
  [5648] = 3889,
  [5649] = 5627,
  [5650] = 5650,
  [5651] = 3815,
  [5652] = 3936,
  [5653] = 5627,
  [5654] = 5629,
  [5655] = 5655,
  [5656] = 3935,
  [5657] = 5627,
  [5658] = 3950,
  [5659] = 3951,
  [5660] = 3953,
  [5661] = 3954,
  [5662] = 3816,
  [5663] = 5627,
  [5664] = 5639,
  [5665] = 5627,
  [5666] = 5666,
  [5667] = 5637,
  [5668] = 5627,
  [5669] = 5627,
  [5670] = 5627,
  [5671] = 5639,
  [5672] = 3958,
  [5673] = 930,
  [5674] = 5627,
  [5675] = 5637,
  [5676] = 5676,
  [5677] = 5637,
  [5678] = 5639,
  [5679] = 5679,
  [5680] = 5655,
  [5681] = 5627,
  [5682] = 1086,
  [5683] = 1112,
  [5684] = 3815,
  [5685] = 5637,
  [5686] = 5639,
  [5687] = 1069,
  [5688] = 5676,
  [5689] = 5679,
  [5690] = 5637,
  [5691] = 5627,
  [5692] = 1048,
  [5693] = 1047,
  [5694] = 3816,
  [5695] = 1107,
  [5696] = 5637,
  [5697] = 5679,
  [5698] = 3983,
  [5699] = 5627,
  [5700] = 3985,
  [5701] = 5639,
  [5702] = 5639,
  [5703] = 5632,
  [5704] = 5627,
  [5705] = 5627,
  [5706] = 5625,
  [5707] = 5489,
  [5708] = 3886,
  [5709] = 5627,
  [5710] = 5645,
  [5711] = 5627,
  [5712] = 5676,
  [5713] = 5646,
  [5714] = 5714,
  [5715] = 3961,
  [5716] = 5627,
  [5717] = 3962,
  [5718] = 3811,
  [5719] = 5627,
  [5720] = 3813,
  [5721] = 3809,
  [5722] = 3815,
  [5723] = 3819,
  [5724] = 3834,
  [5725] = 3842,
  [5726] = 5627,
  [5727] = 1054,
  [5728] = 3811,
  [5729] = 5637,
  [5730] = 5676,
  [5731] = 1060,
  [5732] = 5732,
  [5733] = 5625,
  [5734] = 5621,
  [5735] = 1073,
  [5736] = 1046,
  [5737] = 1127,
  [5738] = 5632,
  [5739] = 5627,
  [5740] = 5740,
  [5741] = 5629,
  [5742] = 1126,
  [5743] = 5627,
  [5744] = 1125,
  [5745] = 3816,
  [5746] = 5637,
  [5747] = 4204,
  [5748] = 5748,
  [5749] = 5627,
  [5750] = 5627,
  [5751] = 1074,
  [5752] = 5627,
  [5753] = 1083,
  [5754] = 3841,
  [5755] = 3842,
  [5756] = 5655,
  [5757] = 1121,
  [5758] = 5632,
  [5759] = 1092,
  [5760] = 5627,
  [5761] = 5637,
  [5762] = 5762,
  [5763] = 1114,
  [5764] = 5627,
  [5765] = 5639,
  [5766] = 5621,
  [5767] = 3842,
  [5768] = 1113,
  [5769] = 3841,
  [5770] = 5637,
  [5771] = 5627,
  [5772] = 3907,
  [5773] = 3842,
  [5774] = 1111,
  [5775] = 1110,
  [5776] = 3811,
  [5777] = 5639,
  [5778] = 1109,
  [5779] = 5625,
  [5780] = 3841,
  [5781] = 3813,
  [5782] = 3809,
  [5783] = 5783,
  [5784] = 3977,
  [5785] = 1093,
  [5786] = 3819,
  [5787] = 5655,
  [5788] = 3834,
  [5789] = 1108,
  [5790] = 5627,
  [5791] = 3957,
  [5792] = 5639,
  [5793] = 3841,
  [5794] = 5679,
  [5795] = 3907,
  [5796] = 3873,
  [5797] = 5629,
  [5798] = 1105,
  [5799] = 5637,
  [5800] = 5637,
  [5801] = 3834,
  [5802] = 5627,
  [5803] = 3907,
  [5804] = 3815,
  [5805] = 3813,
  [5806] = 1095,
  [5807] = 3819,
  [5808] = 1103,
  [5809] = 3809,
  [5810] = 1098,
  [5811] = 5637,
  [5812] = 5627,
  [5813] = 3816,
  [5814] = 1096,
  [5815] = 4118,
  [5816] = 5816,
  [5817] = 3842,
  [5818] = 5818,
  [5819] = 5819,
  [5820] = 5820,
  [5821] = 3841,
  [5822] = 4108,
  [5823] = 5823,
  [5824] = 5824,
  [5825] = 5818,
  [5826] = 5826,
  [5827] = 5818,
  [5828] = 5826,
  [5829] = 5829,
  [5830] = 5826,
  [5831] = 5826,
  [5832] = 5826,
  [5833] = 3819,
  [5834] = 5818,
  [5835] = 5835,
  [5836] = 5826,
  [5837] = 5823,
  [5838] = 3809,
  [5839] = 3813,
  [5840] = 2620,
  [5841] = 3816,
  [5842] = 5823,
  [5843] = 5823,
  [5844] = 3811,
  [5845] = 5823,
  [5846] = 5846,
  [5847] = 5823,
  [5848] = 5823,
  [5849] = 3815,
  [5850] = 3211,
  [5851] = 3209,
  [5852] = 5645,
  [5853] = 5835,
  [5854] = 5823,
  [5855] = 5823,
  [5856] = 5856,
  [5857] = 3212,
  [5858] = 3210,
  [5859] = 5820,
  [5860] = 5826,
  [5861] = 5820,
  [5862] = 5823,
  [5863] = 5823,
  [5864] = 5823,
  [5865] = 5818,
  [5866] = 4114,
  [5867] = 5818,
  [5868] = 5868,
  [5869] = 3834,
  [5870] = 5646,
  [5871] = 5823,
  [5872] = 5823,
  [5873] = 5873,
  [5874] = 5818,
  [5875] = 3907,
  [5876] = 5823,
  [5877] = 5624,
  [5878] = 5826,
  [5879] = 5820,
  [5880] = 5818,
  [5881] = 3213,
  [5882] = 5823,
  [5883] = 5883,
  [5884] = 5884,
  [5885] = 5885,
  [5886] = 5886,
  [5887] = 5885,
  [5888] = 5888,
  [5889] = 5884,
  [5890] = 5885,
  [5891] = 3210,
  [5892] = 5885,
  [5893] = 5893,
  [5894] = 5888,
  [5895] = 5888,
  [5896] = 3213,
  [5897] = 5885,
  [5898] = 5883,
  [5899] = 3209,
  [5900] = 5888,
  [5901] = 5901,
  [5902] = 5888,
  [5903] = 5884,
  [5904] = 3211,
  [5905] = 5905,
  [5906] = 3212,
  [5907] = 5885,
  [5908] = 5884,
  [5909] = 5883,
  [5910] = 5884,
  [5911] = 5911,
  [5912] = 5888,
  [5913] = 5884,
  [5914] = 5888,
  [5915] = 5884,
  [5916] = 5885,
  [5917] = 3214,
  [5918] = 5918,
  [5919] = 5884,
  [5920] = 5646,
  [5921] = 5885,
  [5922] = 5888,
  [5923] = 5885,
  [5924] = 5885,
  [5925] = 5883,
  [5926] = 5885,
  [5927] = 5885,
  [5928] = 5885,
  [5929] = 5884,
  [5930] = 5930,
  [5931] = 3220,
  [5932] = 5932,
  [5933] = 5932,
  [5934] = 5934,
  [5935] = 5935,
  [5936] = 5936,
  [5937] = 5932,
  [5938] = 5646,
  [5939] = 5939,
  [5940] = 5905,
  [5941] = 5930,
  [5942] = 5932,
  [5943] = 3220,
  [5944] = 5932,
  [5945] = 5936,
  [5946] = 5932,
  [5947] = 5947,
  [5948] = 5936,
  [5949] = 5936,
  [5950] = 5936,
  [5951] = 3214,
  [5952] = 5947,
  [5953] = 5932,
  [5954] = 5939,
  [5955] = 5947,
  [5956] = 5947,
  [5957] = 5947,
  [5958] = 5939,
  [5959] = 5947,
  [5960] = 5936,
  [5961] = 5932,
  [5962] = 5936,
  [5963] = 5935,
  [5964] = 5947,
  [5965] = 5936,
  [5966] = 5935,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 5947,
  [5970] = 5970,
  [5971] = 5970,
  [5972] = 5970,
  [5973] = 5973,
  [5974] = 5974,
  [5975] = 5975,
  [5976] = 5970,
  [5977] = 5975,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5973,
  [5981] = 5981,
  [5982] = 949,
  [5983] = 5983,
  [5984] = 5970,
  [5985] = 960,
  [5986] = 5986,
  [5987] = 5970,
  [5988] = 5975,
  [5989] = 5970,
  [5990] = 5990,
  [5991] = 5975,
  [5992] = 5986,
  [5993] = 5986,
  [5994] = 5970,
  [5995] = 5995,
  [5996] = 5975,
  [5997] = 5990,
  [5998] = 5975,
  [5999] = 3220,
  [6000] = 5990,
  [6001] = 5981,
  [6002] = 5979,
  [6003] = 5973,
  [6004] = 5979,
  [6005] = 5990,
  [6006] = 5970,
  [6007] = 5975,
  [6008] = 5983,
  [6009] = 5975,
  [6010] = 5970,
  [6011] = 5970,
  [6012] = 5978,
  [6013] = 5986,
  [6014] = 5981,
  [6015] = 5975,
  [6016] = 5975,
  [6017] = 5978,
  [6018] = 5986,
  [6019] = 5975,
  [6020] = 5970,
  [6021] = 5970,
  [6022] = 5970,
  [6023] = 3214,
  [6024] = 5973,
  [6025] = 5981,
  [6026] = 5978,
  [6027] = 5978,
  [6028] = 5995,
  [6029] = 5981,
  [6030] = 5970,
  [6031] = 5978,
  [6032] = 5973,
  [6033] = 3241,
  [6034] = 5983,
  [6035] = 5973,
  [6036] = 5975,
  [6037] = 5990,
  [6038] = 5970,
  [6039] = 5970,
  [6040] = 5975,
  [6041] = 3266,
  [6042] = 5975,
  [6043] = 5975,
  [6044] = 5979,
  [6045] = 5995,
  [6046] = 5970,
  [6047] = 5986,
  [6048] = 5979,
  [6049] = 5981,
  [6050] = 5975,
  [6051] = 5973,
  [6052] = 5979,
  [6053] = 5975,
  [6054] = 5975,
  [6055] = 5970,
  [6056] = 6056,
  [6057] = 5995,
  [6058] = 5983,
  [6059] = 5975,
  [6060] = 5990,
  [6061] = 6061,
  [6062] = 5970,
  [6063] = 5995,
  [6064] = 5983,
  [6065] = 5975,
  [6066] = 5970,
  [6067] = 5986,
  [6068] = 5975,
  [6069] = 5970,
  [6070] = 5986,
  [6071] = 5970,
  [6072] = 5975,
  [6073] = 5986,
  [6074] = 5986,
  [6075] = 5981,
  [6076] = 5990,
  [6077] = 5986,
  [6078] = 5995,
  [6079] = 5986,
  [6080] = 5979,
  [6081] = 5990,
  [6082] = 5979,
  [6083] = 5970,
  [6084] = 5970,
  [6085] = 5975,
  [6086] = 5986,
  [6087] = 6087,
  [6088] = 5973,
  [6089] = 5995,
  [6090] = 5975,
  [6091] = 5986,
  [6092] = 5975,
  [6093] = 5975,
  [6094] = 5983,
  [6095] = 5986,
  [6096] = 5975,
  [6097] = 5970,
  [6098] = 5970,
  [6099] = 6099,
  [6100] = 5970,
  [6101] = 5983,
  [6102] = 5970,
  [6103] = 5970,
  [6104] = 5995,
  [6105] = 3797,
  [6106] = 5975,
  [6107] = 5986,
  [6108] = 5983,
  [6109] = 5970,
  [6110] = 5975,
  [6111] = 5975,
  [6112] = 5981,
  [6113] = 5970,
  [6114] = 3239,
  [6115] = 5970,
  [6116] = 5975,
  [6117] = 5975,
  [6118] = 5978,
  [6119] = 5975,
  [6120] = 5970,
  [6121] = 5975,
  [6122] = 5986,
  [6123] = 5983,
  [6124] = 5975,
  [6125] = 5970,
  [6126] = 5978,
  [6127] = 6127,
  [6128] = 3296,
  [6129] = 3307,
  [6130] = 6130,
  [6131] = 3315,
  [6132] = 6132,
  [6133] = 3308,
  [6134] = 3314,
  [6135] = 6135,
  [6136] = 6136,
  [6137] = 956,
  [6138] = 6138,
  [6139] = 3294,
  [6140] = 3270,
  [6141] = 6130,
  [6142] = 6135,
  [6143] = 6130,
  [6144] = 6144,
  [6145] = 6135,
  [6146] = 6132,
  [6147] = 6147,
  [6148] = 6132,
  [6149] = 3254,
  [6150] = 3239,
  [6151] = 6130,
  [6152] = 6152,
  [6153] = 6130,
  [6154] = 3254,
  [6155] = 6155,
  [6156] = 3249,
  [6157] = 6130,
  [6158] = 6152,
  [6159] = 3265,
  [6160] = 3265,
  [6161] = 6130,
  [6162] = 3241,
  [6163] = 3249,
  [6164] = 6136,
  [6165] = 6135,
  [6166] = 3283,
  [6167] = 6132,
  [6168] = 6136,
  [6169] = 998,
  [6170] = 6130,
  [6171] = 6171,
  [6172] = 986,
  [6173] = 6132,
  [6174] = 6174,
  [6175] = 6175,
  [6176] = 6176,
  [6177] = 6135,
  [6178] = 6136,
  [6179] = 3266,
  [6180] = 6180,
  [6181] = 6181,
  [6182] = 6138,
  [6183] = 6152,
  [6184] = 6130,
  [6185] = 3220,
  [6186] = 6132,
  [6187] = 6152,
  [6188] = 6136,
  [6189] = 3319,
  [6190] = 6132,
  [6191] = 6191,
  [6192] = 6147,
  [6193] = 6152,
  [6194] = 6194,
  [6195] = 6147,
  [6196] = 6147,
  [6197] = 6135,
  [6198] = 6130,
  [6199] = 3214,
  [6200] = 6138,
  [6201] = 3282,
  [6202] = 6202,
  [6203] = 3269,
  [6204] = 6135,
  [6205] = 6147,
  [6206] = 3304,
  [6207] = 3310,
  [6208] = 974,
  [6209] = 6147,
  [6210] = 6135,
  [6211] = 6132,
  [6212] = 3311,
  [6213] = 6213,
  [6214] = 3298,
  [6215] = 6147,
  [6216] = 6138,
  [6217] = 6217,
  [6218] = 6136,
  [6219] = 6152,
  [6220] = 6152,
  [6221] = 6221,
  [6222] = 6136,
  [6223] = 6152,
  [6224] = 6130,
  [6225] = 6130,
  [6226] = 966,
  [6227] = 6147,
  [6228] = 3303,
  [6229] = 6136,
  [6230] = 954,
  [6231] = 6130,
  [6232] = 972,
  [6233] = 976,
  [6234] = 6234,
  [6235] = 6235,
  [6236] = 3307,
  [6237] = 6235,
  [6238] = 6238,
  [6239] = 6239,
  [6240] = 6240,
  [6241] = 6241,
  [6242] = 6242,
  [6243] = 6241,
  [6244] = 3270,
  [6245] = 3314,
  [6246] = 6246,
  [6247] = 6247,
  [6248] = 6248,
  [6249] = 3315,
  [6250] = 3304,
  [6251] = 3283,
  [6252] = 6252,
  [6253] = 6253,
  [6254] = 6252,
  [6255] = 6235,
  [6256] = 6235,
  [6257] = 6240,
  [6258] = 6258,
  [6259] = 3296,
  [6260] = 6260,
  [6261] = 6261,
  [6262] = 6262,
  [6263] = 6263,
  [6264] = 6264,
  [6265] = 6265,
  [6266] = 6235,
  [6267] = 6253,
  [6268] = 6268,
  [6269] = 6269,
  [6270] = 6269,
  [6271] = 6235,
  [6272] = 6272,
  [6273] = 6235,
  [6274] = 6274,
  [6275] = 6248,
  [6276] = 6240,
  [6277] = 6277,
  [6278] = 6235,
  [6279] = 6234,
  [6280] = 6235,
  [6281] = 3269,
  [6282] = 6282,
  [6283] = 6242,
  [6284] = 6248,
  [6285] = 6235,
  [6286] = 6286,
  [6287] = 6239,
  [6288] = 6269,
  [6289] = 3761,
  [6290] = 6272,
  [6291] = 6291,
  [6292] = 971,
  [6293] = 1007,
  [6294] = 1010,
  [6295] = 3282,
  [6296] = 6235,
  [6297] = 6241,
  [6298] = 6263,
  [6299] = 6234,
  [6300] = 6248,
  [6301] = 3319,
  [6302] = 6235,
  [6303] = 6261,
  [6304] = 6241,
  [6305] = 3785,
  [6306] = 6239,
  [6307] = 3757,
  [6308] = 6253,
  [6309] = 6269,
  [6310] = 6310,
  [6311] = 6235,
  [6312] = 3280,
  [6313] = 6252,
  [6314] = 6282,
  [6315] = 6239,
  [6316] = 6247,
  [6317] = 6246,
  [6318] = 6264,
  [6319] = 6247,
  [6320] = 6320,
  [6321] = 6246,
  [6322] = 6252,
  [6323] = 6264,
  [6324] = 3287,
  [6325] = 6325,
  [6326] = 6246,
  [6327] = 6247,
  [6328] = 3288,
  [6329] = 3298,
  [6330] = 3310,
  [6331] = 3280,
  [6332] = 6332,
  [6333] = 6264,
  [6334] = 3308,
  [6335] = 6335,
  [6336] = 6235,
  [6337] = 6234,
  [6338] = 6338,
  [6339] = 6261,
  [6340] = 6340,
  [6341] = 6246,
  [6342] = 6252,
  [6343] = 6241,
  [6344] = 6344,
  [6345] = 6234,
  [6346] = 6235,
  [6347] = 6247,
  [6348] = 6235,
  [6349] = 6286,
  [6350] = 6269,
  [6351] = 6351,
  [6352] = 6264,
  [6353] = 6235,
  [6354] = 6291,
  [6355] = 6235,
  [6356] = 6263,
  [6357] = 6261,
  [6358] = 6358,
  [6359] = 6248,
  [6360] = 6234,
  [6361] = 6269,
  [6362] = 6263,
  [6363] = 6248,
  [6364] = 6241,
  [6365] = 6261,
  [6366] = 6241,
  [6367] = 6234,
  [6368] = 6269,
  [6369] = 6235,
  [6370] = 6235,
  [6371] = 6235,
  [6372] = 6248,
  [6373] = 6272,
  [6374] = 6252,
  [6375] = 6248,
  [6376] = 6235,
  [6377] = 6377,
  [6378] = 6235,
  [6379] = 6235,
  [6380] = 6380,
  [6381] = 6239,
  [6382] = 6263,
  [6383] = 6383,
  [6384] = 6384,
  [6385] = 6269,
  [6386] = 6386,
  [6387] = 6263,
  [6388] = 6246,
  [6389] = 6383,
  [6390] = 6310,
  [6391] = 6246,
  [6392] = 6235,
  [6393] = 6393,
  [6394] = 6234,
  [6395] = 6386,
  [6396] = 6247,
  [6397] = 6286,
  [6398] = 6247,
  [6399] = 6241,
  [6400] = 6246,
  [6401] = 6272,
  [6402] = 6235,
  [6403] = 3249,
  [6404] = 6246,
  [6405] = 6247,
  [6406] = 3265,
  [6407] = 6272,
  [6408] = 3287,
  [6409] = 6248,
  [6410] = 6410,
  [6411] = 6240,
  [6412] = 3254,
  [6413] = 6263,
  [6414] = 6253,
  [6415] = 6415,
  [6416] = 6416,
  [6417] = 6417,
  [6418] = 3294,
  [6419] = 6419,
  [6420] = 6282,
  [6421] = 6286,
  [6422] = 3241,
  [6423] = 6234,
  [6424] = 3303,
  [6425] = 6272,
  [6426] = 6247,
  [6427] = 6234,
  [6428] = 6269,
  [6429] = 3288,
  [6430] = 6386,
  [6431] = 6235,
  [6432] = 6274,
  [6433] = 6433,
  [6434] = 1011,
  [6435] = 1018,
  [6436] = 6436,
  [6437] = 6383,
  [6438] = 6310,
  [6439] = 910,
  [6440] = 6235,
  [6441] = 6248,
  [6442] = 3311,
  [6443] = 6253,
  [6444] = 6444,
  [6445] = 6380,
  [6446] = 6446,
  [6447] = 3249,
  [6448] = 6252,
  [6449] = 6449,
  [6450] = 3265,
  [6451] = 6264,
  [6452] = 3254,
  [6453] = 6286,
  [6454] = 6282,
  [6455] = 6272,
  [6456] = 6263,
  [6457] = 6286,
  [6458] = 6240,
  [6459] = 3266,
  [6460] = 6239,
  [6461] = 6248,
  [6462] = 6253,
  [6463] = 6235,
  [6464] = 6464,
  [6465] = 6248,
  [6466] = 6235,
  [6467] = 6261,
  [6468] = 6241,
  [6469] = 6234,
  [6470] = 6261,
  [6471] = 6240,
  [6472] = 6241,
  [6473] = 6239,
  [6474] = 6291,
  [6475] = 6235,
  [6476] = 6241,
  [6477] = 6269,
  [6478] = 6269,
  [6479] = 6234,
  [6480] = 6291,
  [6481] = 6235,
  [6482] = 6482,
  [6483] = 6263,
  [6484] = 6383,
  [6485] = 6386,
  [6486] = 6486,
  [6487] = 6282,
  [6488] = 6241,
  [6489] = 6240,
  [6490] = 6234,
  [6491] = 6274,
  [6492] = 6492,
  [6493] = 6247,
  [6494] = 6246,
  [6495] = 6235,
  [6496] = 6272,
  [6497] = 6253,
  [6498] = 6247,
  [6499] = 6248,
  [6500] = 6248,
  [6501] = 6393,
  [6502] = 6246,
  [6503] = 6253,
  [6504] = 6310,
  [6505] = 6235,
  [6506] = 6234,
  [6507] = 6234,
  [6508] = 6508,
  [6509] = 6386,
  [6510] = 910,
  [6511] = 6248,
  [6512] = 6282,
  [6513] = 6383,
  [6514] = 6514,
  [6515] = 6242,
  [6516] = 6516,
  [6517] = 6340,
  [6518] = 6286,
  [6519] = 6253,
  [6520] = 6264,
  [6521] = 6393,
  [6522] = 6241,
  [6523] = 6282,
  [6524] = 6253,
  [6525] = 6263,
  [6526] = 6239,
  [6527] = 6274,
  [6528] = 6263,
  [6529] = 6234,
  [6530] = 6282,
  [6531] = 6235,
  [6532] = 6242,
  [6533] = 6533,
  [6534] = 6248,
  [6535] = 6464,
  [6536] = 6248,
  [6537] = 6269,
  [6538] = 6538,
  [6539] = 6263,
  [6540] = 6286,
  [6541] = 6263,
  [6542] = 6542,
  [6543] = 6263,
  [6544] = 6252,
  [6545] = 6240,
  [6546] = 6246,
  [6547] = 6247,
  [6548] = 6264,
  [6549] = 6234,
  [6550] = 6234,
  [6551] = 6235,
  [6552] = 6263,
  [6553] = 3239,
  [6554] = 6248,
  [6555] = 6247,
  [6556] = 6393,
  [6557] = 6235,
  [6558] = 6246,
  [6559] = 6269,
  [6560] = 6261,
  [6561] = 1113,
  [6562] = 6562,
  [6563] = 6563,
  [6564] = 6564,
  [6565] = 6564,
  [6566] = 6562,
  [6567] = 6567,
  [6568] = 6568,
  [6569] = 6569,
  [6570] = 6570,
  [6571] = 6571,
  [6572] = 6572,
  [6573] = 6573,
  [6574] = 6574,
  [6575] = 6575,
  [6576] = 6576,
  [6577] = 6577,
  [6578] = 6578,
  [6579] = 6579,
  [6580] = 6580,
  [6581] = 6581,
  [6582] = 6582,
  [6583] = 6583,
  [6584] = 6584,
  [6585] = 6585,
  [6586] = 6586,
  [6587] = 6587,
  [6588] = 6588,
  [6589] = 6589,
  [6590] = 6590,
  [6591] = 6591,
  [6592] = 6592,
  [6593] = 6593,
  [6594] = 6563,
  [6595] = 6564,
  [6596] = 6596,
  [6597] = 6597,
  [6598] = 6598,
  [6599] = 6599,
  [6600] = 6600,
  [6601] = 6601,
  [6602] = 6563,
  [6603] = 6603,
  [6604] = 6563,
  [6605] = 6605,
  [6606] = 6606,
  [6607] = 6607,
  [6608] = 6608,
  [6609] = 6574,
  [6610] = 6564,
  [6611] = 6611,
  [6612] = 6612,
  [6613] = 6613,
  [6614] = 6614,
  [6615] = 6612,
  [6616] = 6601,
  [6617] = 6617,
  [6618] = 6618,
  [6619] = 6583,
  [6620] = 6562,
  [6621] = 6621,
  [6622] = 6622,
  [6623] = 6612,
  [6624] = 6583,
  [6625] = 6625,
  [6626] = 6626,
  [6627] = 6627,
  [6628] = 6612,
  [6629] = 4896,
  [6630] = 6583,
  [6631] = 6631,
  [6632] = 6564,
  [6633] = 4898,
  [6634] = 6634,
  [6635] = 6626,
  [6636] = 6636,
  [6637] = 6573,
  [6638] = 6625,
  [6639] = 6564,
  [6640] = 6640,
  [6641] = 6626,
  [6642] = 6642,
  [6643] = 6643,
  [6644] = 6644,
  [6645] = 6601,
  [6646] = 6613,
  [6647] = 6647,
  [6648] = 6573,
  [6649] = 6649,
  [6650] = 6564,
  [6651] = 6631,
  [6652] = 6626,
  [6653] = 6573,
  [6654] = 6654,
  [6655] = 6626,
  [6656] = 6656,
  [6657] = 6657,
  [6658] = 6563,
  [6659] = 4897,
  [6660] = 6592,
  [6661] = 6661,
  [6662] = 6573,
  [6663] = 6663,
  [6664] = 6590,
  [6665] = 6626,
  [6666] = 6589,
  [6667] = 6581,
  [6668] = 6668,
  [6669] = 6669,
  [6670] = 6670,
  [6671] = 6573,
  [6672] = 6672,
  [6673] = 6673,
  [6674] = 6674,
  [6675] = 6675,
  [6676] = 6562,
  [6677] = 6626,
  [6678] = 6618,
  [6679] = 6679,
  [6680] = 4882,
  [6681] = 6681,
  [6682] = 6617,
  [6683] = 6618,
  [6684] = 6562,
  [6685] = 6685,
  [6686] = 6686,
  [6687] = 6687,
  [6688] = 6573,
  [6689] = 6689,
  [6690] = 6690,
  [6691] = 6691,
  [6692] = 6626,
  [6693] = 6617,
  [6694] = 6694,
  [6695] = 6631,
  [6696] = 4839,
  [6697] = 6564,
  [6698] = 4838,
  [6699] = 6625,
  [6700] = 6573,
  [6701] = 4835,
  [6702] = 6702,
  [6703] = 6703,
  [6704] = 6626,
  [6705] = 6705,
  [6706] = 4825,
  [6707] = 6601,
  [6708] = 6613,
  [6709] = 4823,
  [6710] = 4822,
  [6711] = 6573,
  [6712] = 4820,
  [6713] = 6626,
  [6714] = 4169,
  [6715] = 3351,
  [6716] = 3393,
  [6717] = 3398,
  [6718] = 3294,
  [6719] = 6563,
  [6720] = 6587,
  [6721] = 6588,
  [6722] = 6592,
  [6723] = 6590,
  [6724] = 6589,
  [6725] = 3389,
  [6726] = 3326,
  [6727] = 6573,
  [6728] = 6647,
  [6729] = 6581,
  [6730] = 3370,
  [6731] = 3361,
  [6732] = 3336,
  [6733] = 3330,
  [6734] = 3387,
  [6735] = 3266,
  [6736] = 3345,
  [6737] = 6584,
  [6738] = 6626,
  [6739] = 3365,
  [6740] = 3239,
  [6741] = 3420,
  [6742] = 6574,
  [6743] = 6617,
  [6744] = 6618,
  [6745] = 6562,
  [6746] = 3241,
  [6747] = 6573,
  [6748] = 3357,
  [6749] = 3353,
  [6750] = 3353,
  [6751] = 3357,
  [6752] = 3288,
  [6753] = 6626,
  [6754] = 3287,
  [6755] = 3280,
  [6756] = 3287,
  [6757] = 6631,
  [6758] = 6564,
  [6759] = 3280,
  [6760] = 3288,
  [6761] = 1127,
  [6762] = 6644,
  [6763] = 1125,
  [6764] = 1121,
  [6765] = 6625,
  [6766] = 1114,
  [6767] = 1111,
  [6768] = 6573,
  [6769] = 1110,
  [6770] = 1109,
  [6771] = 6601,
  [6772] = 6613,
  [6773] = 1108,
  [6774] = 1046,
  [6775] = 1105,
  [6776] = 1103,
  [6777] = 1098,
  [6778] = 1096,
  [6779] = 1095,
  [6780] = 1093,
  [6781] = 1092,
  [6782] = 1083,
  [6783] = 1074,
  [6784] = 6563,
  [6785] = 1073,
  [6786] = 6592,
  [6787] = 6590,
  [6788] = 6589,
  [6789] = 1060,
  [6790] = 1055,
  [6791] = 1126,
  [6792] = 1047,
  [6793] = 6581,
  [6794] = 1048,
  [6795] = 1069,
  [6796] = 1112,
  [6797] = 1086,
  [6798] = 1054,
  [6799] = 6626,
  [6800] = 1107,
  [6801] = 6570,
  [6802] = 6574,
  [6803] = 6580,
  [6804] = 6581,
  [6805] = 6573,
  [6806] = 6574,
  [6807] = 6584,
  [6808] = 6617,
  [6809] = 6618,
  [6810] = 6562,
  [6811] = 6589,
  [6812] = 6590,
  [6813] = 6592,
  [6814] = 6563,
  [6815] = 6605,
  [6816] = 6569,
  [6817] = 6613,
  [6818] = 6601,
  [6819] = 6625,
  [6820] = 6627,
  [6821] = 6634,
  [6822] = 6631,
  [6823] = 6564,
  [6824] = 6644,
  [6825] = 6636,
  [6826] = 6640,
  [6827] = 6644,
  [6828] = 6625,
  [6829] = 6564,
  [6830] = 6631,
  [6831] = 6661,
  [6832] = 6601,
  [6833] = 6663,
  [6834] = 6669,
  [6835] = 6613,
  [6836] = 6670,
  [6837] = 6562,
  [6838] = 6618,
  [6839] = 6685,
  [6840] = 6687,
  [6841] = 6689,
  [6842] = 6690,
  [6843] = 6617,
  [6844] = 6703,
  [6845] = 6563,
  [6846] = 6622,
  [6847] = 6596,
  [6848] = 6570,
  [6849] = 6592,
  [6850] = 6574,
  [6851] = 6590,
  [6852] = 6589,
  [6853] = 6584,
  [6854] = 6581,
  [6855] = 6622,
  [6856] = 6596,
  [6857] = 6622,
  [6858] = 6596,
  [6859] = 6622,
  [6860] = 6596,
  [6861] = 6580,
  [6862] = 6581,
  [6863] = 6622,
  [6864] = 6596,
  [6865] = 6584,
  [6866] = 6569,
  [6867] = 6590,
  [6868] = 6574,
  [6869] = 6617,
  [6870] = 6592,
  [6871] = 6622,
  [6872] = 6618,
  [6873] = 6562,
  [6874] = 6563,
  [6875] = 6614,
  [6876] = 6596,
  [6877] = 6593,
  [6878] = 6591,
  [6879] = 6631,
  [6880] = 6605,
  [6881] = 6613,
  [6882] = 6601,
  [6883] = 6631,
  [6884] = 6564,
  [6885] = 6571,
  [6886] = 6625,
  [6887] = 6644,
  [6888] = 6627,
  [6889] = 6625,
  [6890] = 6622,
  [6891] = 6589,
  [6892] = 6614,
  [6893] = 6596,
  [6894] = 6593,
  [6895] = 6591,
  [6896] = 6634,
  [6897] = 6636,
  [6898] = 6601,
  [6899] = 6613,
  [6900] = 6640,
  [6901] = 6644,
  [6902] = 6564,
  [6903] = 6631,
  [6904] = 6571,
  [6905] = 6622,
  [6906] = 6614,
  [6907] = 6661,
  [6908] = 6663,
  [6909] = 6596,
  [6910] = 6669,
  [6911] = 6563,
  [6912] = 6593,
  [6913] = 6591,
  [6914] = 6670,
  [6915] = 6562,
  [6916] = 6618,
  [6917] = 6592,
  [6918] = 6590,
  [6919] = 6589,
  [6920] = 6579,
  [6921] = 6584,
  [6922] = 6685,
  [6923] = 6687,
  [6924] = 6689,
  [6925] = 6581,
  [6926] = 6571,
  [6927] = 6690,
  [6928] = 6617,
  [6929] = 6622,
  [6930] = 6614,
  [6931] = 6703,
  [6932] = 6596,
  [6933] = 6593,
  [6934] = 6591,
  [6935] = 6579,
  [6936] = 6569,
  [6937] = 6570,
  [6938] = 6574,
  [6939] = 6571,
  [6940] = 6654,
  [6941] = 6622,
  [6942] = 6574,
  [6943] = 6614,
  [6944] = 6596,
  [6945] = 6593,
  [6946] = 6591,
  [6947] = 6580,
  [6948] = 6581,
  [6949] = 6579,
  [6950] = 6584,
  [6951] = 6589,
  [6952] = 6590,
  [6953] = 6592,
  [6954] = 6571,
  [6955] = 6563,
  [6956] = 6703,
  [6957] = 6563,
  [6958] = 6617,
  [6959] = 6654,
  [6960] = 6690,
  [6961] = 6605,
  [6962] = 6622,
  [6963] = 6614,
  [6964] = 6689,
  [6965] = 6613,
  [6966] = 6606,
  [6967] = 6601,
  [6968] = 6687,
  [6969] = 6596,
  [6970] = 6593,
  [6971] = 6568,
  [6972] = 6618,
  [6973] = 6571,
  [6974] = 6562,
  [6975] = 6591,
  [6976] = 6670,
  [6977] = 6582,
  [6978] = 6625,
  [6979] = 6579,
  [6980] = 6634,
  [6981] = 6669,
  [6982] = 6663,
  [6983] = 6636,
  [6984] = 6640,
  [6985] = 6571,
  [6986] = 6579,
  [6987] = 6644,
  [6988] = 6564,
  [6989] = 6631,
  [6990] = 6625,
  [6991] = 6654,
  [6992] = 6622,
  [6993] = 6564,
  [6994] = 6644,
  [6995] = 6614,
  [6996] = 6606,
  [6997] = 6582,
  [6998] = 6663,
  [6999] = 6640,
  [7000] = 6669,
  [7001] = 6636,
  [7002] = 6634,
  [7003] = 6670,
  [7004] = 6596,
  [7005] = 6593,
  [7006] = 6591,
  [7007] = 6593,
  [7008] = 6644,
  [7009] = 6596,
  [7010] = 6591,
  [7011] = 6582,
  [7012] = 6562,
  [7013] = 6601,
  [7014] = 6613,
  [7015] = 6618,
  [7016] = 6687,
  [7017] = 6606,
  [7018] = 6579,
  [7019] = 6605,
  [7020] = 6689,
  [7021] = 6690,
  [7022] = 6617,
  [7023] = 6571,
  [7024] = 6614,
  [7025] = 6703,
  [7026] = 6654,
  [7027] = 6622,
  [7028] = 6622,
  [7029] = 6563,
  [7030] = 6614,
  [7031] = 6574,
  [7032] = 6592,
  [7033] = 6590,
  [7034] = 6589,
  [7035] = 6584,
  [7036] = 6581,
  [7037] = 6606,
  [7038] = 6596,
  [7039] = 6654,
  [7040] = 6593,
  [7041] = 6591,
  [7042] = 6582,
  [7043] = 6581,
  [7044] = 6579,
  [7045] = 6584,
  [7046] = 6589,
  [7047] = 6590,
  [7048] = 6592,
  [7049] = 6571,
  [7050] = 6574,
  [7051] = 6563,
  [7052] = 6605,
  [7053] = 6654,
  [7054] = 6613,
  [7055] = 6601,
  [7056] = 6622,
  [7057] = 6614,
  [7058] = 6606,
  [7059] = 6625,
  [7060] = 6703,
  [7061] = 6617,
  [7062] = 6690,
  [7063] = 6634,
  [7064] = 6689,
  [7065] = 6596,
  [7066] = 6687,
  [7067] = 6618,
  [7068] = 6562,
  [7069] = 6636,
  [7070] = 6670,
  [7071] = 6669,
  [7072] = 6663,
  [7073] = 6593,
  [7074] = 6591,
  [7075] = 6640,
  [7076] = 6582,
  [7077] = 6644,
  [7078] = 6631,
  [7079] = 6564,
  [7080] = 6564,
  [7081] = 6631,
  [7082] = 6640,
  [7083] = 6636,
  [7084] = 6634,
  [7085] = 6579,
  [7086] = 6625,
  [7087] = 6663,
  [7088] = 6669,
  [7089] = 6571,
  [7090] = 6601,
  [7091] = 6613,
  [7092] = 6568,
  [7093] = 6670,
  [7094] = 6605,
  [7095] = 6562,
  [7096] = 6618,
  [7097] = 6687,
  [7098] = 6568,
  [7099] = 6689,
  [7100] = 6571,
  [7101] = 6690,
  [7102] = 6563,
  [7103] = 6617,
  [7104] = 6703,
  [7105] = 6654,
  [7106] = 6574,
  [7107] = 6622,
  [7108] = 6592,
  [7109] = 6590,
  [7110] = 6589,
  [7111] = 6584,
  [7112] = 6579,
  [7113] = 6581,
  [7114] = 6614,
  [7115] = 6606,
  [7116] = 6581,
  [7117] = 6584,
  [7118] = 6596,
  [7119] = 6589,
  [7120] = 6593,
  [7121] = 6591,
  [7122] = 6590,
  [7123] = 6582,
  [7124] = 6592,
  [7125] = 6582,
  [7126] = 6571,
  [7127] = 6670,
  [7128] = 6669,
  [7129] = 6663,
  [7130] = 6591,
  [7131] = 6593,
  [7132] = 6640,
  [7133] = 6596,
  [7134] = 6574,
  [7135] = 6654,
  [7136] = 6563,
  [7137] = 6601,
  [7138] = 6636,
  [7139] = 6634,
  [7140] = 6613,
  [7141] = 6606,
  [7142] = 6625,
  [7143] = 6703,
  [7144] = 6617,
  [7145] = 6690,
  [7146] = 6605,
  [7147] = 6631,
  [7148] = 6614,
  [7149] = 6689,
  [7150] = 6568,
  [7151] = 6622,
  [7152] = 6564,
  [7153] = 6644,
  [7154] = 6687,
  [7155] = 6579,
  [7156] = 6618,
  [7157] = 7157,
  [7158] = 7158,
  [7159] = 7159,
  [7160] = 7160,
  [7161] = 7161,
  [7162] = 7162,
  [7163] = 7163,
  [7164] = 7164,
  [7165] = 7165,
  [7166] = 7166,
  [7167] = 7167,
  [7168] = 7168,
  [7169] = 7169,
  [7170] = 7170,
  [7171] = 7171,
  [7172] = 7172,
  [7173] = 7173,
  [7174] = 7174,
  [7175] = 7175,
  [7176] = 7176,
  [7177] = 7177,
  [7178] = 7163,
  [7179] = 7179,
  [7180] = 7180,
  [7181] = 7181,
  [7182] = 7182,
  [7183] = 7183,
  [7184] = 7184,
  [7185] = 7185,
  [7186] = 7186,
  [7187] = 7187,
  [7188] = 7188,
  [7189] = 7189,
  [7190] = 7190,
  [7191] = 7191,
  [7192] = 7192,
  [7193] = 7193,
  [7194] = 7194,
  [7195] = 7195,
  [7196] = 7196,
  [7197] = 7197,
  [7198] = 7198,
  [7199] = 7199,
  [7200] = 7200,
  [7201] = 7201,
  [7202] = 7202,
  [7203] = 7157,
  [7204] = 7204,
  [7205] = 7205,
  [7206] = 7206,
  [7207] = 7207,
  [7208] = 7208,
  [7209] = 7196,
  [7210] = 7210,
  [7211] = 7211,
  [7212] = 7212,
  [7213] = 7160,
  [7214] = 7161,
  [7215] = 7208,
  [7216] = 7207,
  [7217] = 7217,
  [7218] = 7218,
  [7219] = 7205,
  [7220] = 7220,
  [7221] = 7204,
  [7222] = 7222,
  [7223] = 7223,
  [7224] = 7224,
  [7225] = 7168,
  [7226] = 7223,
  [7227] = 7217,
  [7228] = 7212,
  [7229] = 7211,
  [7230] = 7171,
  [7231] = 7222,
  [7232] = 7159,
  [7233] = 7172,
  [7234] = 7201,
  [7235] = 7173,
  [7236] = 7162,
  [7237] = 7197,
  [7238] = 7175,
  [7239] = 7169,
  [7240] = 7164,
  [7241] = 7165,
  [7242] = 7166,
  [7243] = 7167,
  [7244] = 7177,
  [7245] = 7224,
  [7246] = 7217,
  [7247] = 7195,
  [7248] = 7182,
  [7249] = 7194,
  [7250] = 7210,
  [7251] = 7170,
  [7252] = 7185,
  [7253] = 7206,
  [7254] = 7174,
  [7255] = 7186,
  [7256] = 7157,
  [7257] = 7202,
  [7258] = 7188,
  [7259] = 7189,
  [7260] = 7200,
  [7261] = 7176,
  [7262] = 7220,
  [7263] = 7199,
  [7264] = 7198,
  [7265] = 7193,
  [7266] = 7192,
  [7267] = 7218,
  [7268] = 7194,
  [7269] = 7195,
  [7270] = 7196,
  [7271] = 7197,
  [7272] = 7180,
  [7273] = 7181,
  [7274] = 7191,
  [7275] = 7183,
  [7276] = 7201,
  [7277] = 7184,
  [7278] = 7190,
  [7279] = 7204,
  [7280] = 7187,
  [7281] = 7172,
  [7282] = 7207,
  [7283] = 7184,
  [7284] = 7187,
  [7285] = 7183,
  [7286] = 7160,
  [7287] = 7161,
  [7288] = 7181,
  [7289] = 7180,
  [7290] = 7218,
  [7291] = 7176,
  [7292] = 7174,
  [7293] = 7158,
  [7294] = 7190,
  [7295] = 7170,
  [7296] = 7168,
  [7297] = 7169,
  [7298] = 7191,
  [7299] = 7192,
  [7300] = 7171,
  [7301] = 7167,
  [7302] = 7193,
  [7303] = 7172,
  [7304] = 7166,
  [7305] = 7173,
  [7306] = 7189,
  [7307] = 7175,
  [7308] = 7188,
  [7309] = 7198,
  [7310] = 7199,
  [7311] = 7177,
  [7312] = 7165,
  [7313] = 7164,
  [7314] = 7200,
  [7315] = 7182,
  [7316] = 7202,
  [7317] = 7157,
  [7318] = 7185,
  [7319] = 7206,
  [7320] = 7186,
  [7321] = 7186,
  [7322] = 7210,
  [7323] = 7189,
  [7324] = 7163,
  [7325] = 7185,
  [7326] = 7162,
  [7327] = 7159,
  [7328] = 7194,
  [7329] = 7195,
  [7330] = 7196,
  [7331] = 7197,
  [7332] = 7211,
  [7333] = 7220,
  [7334] = 7212,
  [7335] = 7335,
  [7336] = 7201,
  [7337] = 7337,
  [7338] = 7182,
  [7339] = 7204,
  [7340] = 7222,
  [7341] = 7223,
  [7342] = 7207,
  [7343] = 7217,
  [7344] = 7224,
  [7345] = 7345,
  [7346] = 7160,
  [7347] = 7161,
  [7348] = 7224,
  [7349] = 7179,
  [7350] = 7212,
  [7351] = 7223,
  [7352] = 7211,
  [7353] = 7159,
  [7354] = 7162,
  [7355] = 7168,
  [7356] = 7177,
  [7357] = 7357,
  [7358] = 7222,
  [7359] = 7171,
  [7360] = 7175,
  [7361] = 7163,
  [7362] = 7172,
  [7363] = 7210,
  [7364] = 7173,
  [7365] = 7164,
  [7366] = 7175,
  [7367] = 7367,
  [7368] = 7165,
  [7369] = 7166,
  [7370] = 7177,
  [7371] = 7173,
  [7372] = 7167,
  [7373] = 7169,
  [7374] = 7182,
  [7375] = 7199,
  [7376] = 7222,
  [7377] = 7185,
  [7378] = 7186,
  [7379] = 7189,
  [7380] = 7206,
  [7381] = 7381,
  [7382] = 7171,
  [7383] = 7157,
  [7384] = 7194,
  [7385] = 7195,
  [7386] = 7196,
  [7387] = 7197,
  [7388] = 7170,
  [7389] = 7202,
  [7390] = 7200,
  [7391] = 7174,
  [7392] = 7201,
  [7393] = 7199,
  [7394] = 7168,
  [7395] = 7204,
  [7396] = 7198,
  [7397] = 7176,
  [7398] = 7207,
  [7399] = 7193,
  [7400] = 7160,
  [7401] = 7161,
  [7402] = 7192,
  [7403] = 7191,
  [7404] = 7404,
  [7405] = 7161,
  [7406] = 7160,
  [7407] = 7190,
  [7408] = 7220,
  [7409] = 7168,
  [7410] = 7187,
  [7411] = 7411,
  [7412] = 7218,
  [7413] = 7171,
  [7414] = 7208,
  [7415] = 7180,
  [7416] = 7172,
  [7417] = 7207,
  [7418] = 7173,
  [7419] = 7181,
  [7420] = 7175,
  [7421] = 7421,
  [7422] = 7183,
  [7423] = 7184,
  [7424] = 7177,
  [7425] = 7205,
  [7426] = 7204,
  [7427] = 7184,
  [7428] = 7182,
  [7429] = 7201,
  [7430] = 7430,
  [7431] = 7185,
  [7432] = 7186,
  [7433] = 7189,
  [7434] = 7183,
  [7435] = 7187,
  [7436] = 7181,
  [7437] = 7180,
  [7438] = 7194,
  [7439] = 7195,
  [7440] = 7196,
  [7441] = 7197,
  [7442] = 7218,
  [7443] = 7158,
  [7444] = 7197,
  [7445] = 7445,
  [7446] = 7201,
  [7447] = 7447,
  [7448] = 7448,
  [7449] = 7204,
  [7450] = 7190,
  [7451] = 7196,
  [7452] = 7207,
  [7453] = 7195,
  [7454] = 7160,
  [7455] = 7161,
  [7456] = 7194,
  [7457] = 7176,
  [7458] = 7191,
  [7459] = 7222,
  [7460] = 7192,
  [7461] = 7193,
  [7462] = 7222,
  [7463] = 7168,
  [7464] = 7222,
  [7465] = 7174,
  [7466] = 7198,
  [7467] = 7171,
  [7468] = 7222,
  [7469] = 7337,
  [7470] = 7172,
  [7471] = 7222,
  [7472] = 7173,
  [7473] = 7473,
  [7474] = 7175,
  [7475] = 7170,
  [7476] = 7200,
  [7477] = 7202,
  [7478] = 7177,
  [7479] = 7222,
  [7480] = 7222,
  [7481] = 7206,
  [7482] = 7182,
  [7483] = 7222,
  [7484] = 7210,
  [7485] = 7185,
  [7486] = 7186,
  [7487] = 7189,
  [7488] = 7222,
  [7489] = 7169,
  [7490] = 7222,
  [7491] = 7167,
  [7492] = 7194,
  [7493] = 7195,
  [7494] = 7196,
  [7495] = 7197,
  [7496] = 7496,
  [7497] = 7222,
  [7498] = 7166,
  [7499] = 7220,
  [7500] = 7201,
  [7501] = 7335,
  [7502] = 7169,
  [7503] = 7204,
  [7504] = 7190,
  [7505] = 7165,
  [7506] = 7207,
  [7507] = 7160,
  [7508] = 7161,
  [7509] = 7222,
  [7510] = 7164,
  [7511] = 7222,
  [7512] = 7222,
  [7513] = 7223,
  [7514] = 7224,
  [7515] = 7217,
  [7516] = 7171,
  [7517] = 7163,
  [7518] = 7212,
  [7519] = 7172,
  [7520] = 7222,
  [7521] = 7173,
  [7522] = 7211,
  [7523] = 7159,
  [7524] = 7177,
  [7525] = 7222,
  [7526] = 7162,
  [7527] = 7185,
  [7528] = 7162,
  [7529] = 7357,
  [7530] = 7222,
  [7531] = 7159,
  [7532] = 7194,
  [7533] = 7195,
  [7534] = 7196,
  [7535] = 7197,
  [7536] = 7222,
  [7537] = 7163,
  [7538] = 7211,
  [7539] = 7164,
  [7540] = 7201,
  [7541] = 7367,
  [7542] = 7165,
  [7543] = 7204,
  [7544] = 7166,
  [7545] = 7167,
  [7546] = 7207,
  [7547] = 7160,
  [7548] = 7161,
  [7549] = 7222,
  [7550] = 7212,
  [7551] = 7448,
  [7552] = 7222,
  [7553] = 7553,
  [7554] = 7345,
  [7555] = 7217,
  [7556] = 7171,
  [7557] = 7222,
  [7558] = 7558,
  [7559] = 7172,
  [7560] = 7224,
  [7561] = 7173,
  [7562] = 7381,
  [7563] = 7223,
  [7564] = 7177,
  [7565] = 7222,
  [7566] = 7162,
  [7567] = 7170,
  [7568] = 7222,
  [7569] = 7174,
  [7570] = 7194,
  [7571] = 7195,
  [7572] = 7196,
  [7573] = 7197,
  [7574] = 7222,
  [7575] = 7162,
  [7576] = 7218,
  [7577] = 7190,
  [7578] = 7201,
  [7579] = 7222,
  [7580] = 7176,
  [7581] = 7204,
  [7582] = 7404,
  [7583] = 7162,
  [7584] = 7207,
  [7585] = 7160,
  [7586] = 7161,
  [7587] = 7218,
  [7588] = 7210,
  [7589] = 7190,
  [7590] = 7206,
  [7591] = 7157,
  [7592] = 7411,
  [7593] = 7222,
  [7594] = 7171,
  [7595] = 7162,
  [7596] = 7218,
  [7597] = 7172,
  [7598] = 7218,
  [7599] = 7173,
  [7600] = 7180,
  [7601] = 7181,
  [7602] = 7177,
  [7603] = 7421,
  [7604] = 7202,
  [7605] = 7183,
  [7606] = 7184,
  [7607] = 7190,
  [7608] = 7194,
  [7609] = 7195,
  [7610] = 7196,
  [7611] = 7197,
  [7612] = 7200,
  [7613] = 7200,
  [7614] = 7430,
  [7615] = 7201,
  [7616] = 7187,
  [7617] = 7199,
  [7618] = 7204,
  [7619] = 7198,
  [7620] = 7222,
  [7621] = 7207,
  [7622] = 7160,
  [7623] = 7161,
  [7624] = 7162,
  [7625] = 7218,
  [7626] = 7158,
  [7627] = 7193,
  [7628] = 7445,
  [7629] = 7447,
  [7630] = 7171,
  [7631] = 7199,
  [7632] = 7200,
  [7633] = 7172,
  [7634] = 7192,
  [7635] = 7173,
  [7636] = 7191,
  [7637] = 7190,
  [7638] = 7177,
  [7639] = 7190,
  [7640] = 7222,
  [7641] = 7191,
  [7642] = 7192,
  [7643] = 7193,
  [7644] = 7194,
  [7645] = 7195,
  [7646] = 7196,
  [7647] = 7197,
  [7648] = 7162,
  [7649] = 7184,
  [7650] = 7198,
  [7651] = 7201,
  [7652] = 7199,
  [7653] = 7473,
  [7654] = 7204,
  [7655] = 7183,
  [7656] = 7200,
  [7657] = 7207,
  [7658] = 7160,
  [7659] = 7161,
  [7660] = 7218,
  [7661] = 7190,
  [7662] = 7202,
  [7663] = 7200,
  [7664] = 7157,
  [7665] = 7206,
  [7666] = 7171,
  [7667] = 7180,
  [7668] = 7218,
  [7669] = 7172,
  [7670] = 7176,
  [7671] = 7173,
  [7672] = 7210,
  [7673] = 7222,
  [7674] = 7177,
  [7675] = 7162,
  [7676] = 7194,
  [7677] = 7195,
  [7678] = 7196,
  [7679] = 7162,
  [7680] = 7496,
  [7681] = 7204,
  [7682] = 7159,
  [7683] = 7220,
  [7684] = 7218,
  [7685] = 7335,
  [7686] = 7172,
  [7687] = 7181,
  [7688] = 7337,
  [7689] = 7194,
  [7690] = 7195,
  [7691] = 7196,
  [7692] = 7190,
  [7693] = 7200,
  [7694] = 7204,
  [7695] = 7222,
  [7696] = 7212,
  [7697] = 7223,
  [7698] = 7217,
  [7699] = 7194,
  [7700] = 7195,
  [7701] = 7196,
  [7702] = 7224,
  [7703] = 7217,
  [7704] = 7204,
  [7705] = 7212,
  [7706] = 7224,
  [7707] = 7211,
  [7708] = 7223,
  [7709] = 7194,
  [7710] = 7195,
  [7711] = 7196,
  [7712] = 7159,
  [7713] = 7162,
  [7714] = 7204,
  [7715] = 7357,
  [7716] = 7222,
  [7717] = 7222,
  [7718] = 7194,
  [7719] = 7195,
  [7720] = 7196,
  [7721] = 7162,
  [7722] = 7218,
  [7723] = 7404,
  [7724] = 7190,
  [7725] = 7200,
  [7726] = 7194,
  [7727] = 7195,
  [7728] = 7163,
  [7729] = 7164,
  [7730] = 7367,
  [7731] = 7194,
  [7732] = 7195,
  [7733] = 7165,
  [7734] = 7166,
  [7735] = 7167,
  [7736] = 7194,
  [7737] = 7195,
  [7738] = 7169,
  [7739] = 7553,
  [7740] = 7345,
  [7741] = 7194,
  [7742] = 7195,
  [7743] = 7210,
  [7744] = 7558,
  [7745] = 7381,
  [7746] = 7194,
  [7747] = 7195,
  [7748] = 7206,
  [7749] = 7157,
  [7750] = 7170,
  [7751] = 7202,
  [7752] = 7174,
  [7753] = 7222,
  [7754] = 7162,
  [7755] = 7200,
  [7756] = 7190,
  [7757] = 7176,
  [7758] = 7199,
  [7759] = 7198,
  [7760] = 7218,
  [7761] = 7190,
  [7762] = 7411,
  [7763] = 7200,
  [7764] = 7218,
  [7765] = 7180,
  [7766] = 7181,
  [7767] = 7421,
  [7768] = 7183,
  [7769] = 7184,
  [7770] = 7193,
  [7771] = 7192,
  [7772] = 7191,
  [7773] = 7430,
  [7774] = 7187,
  [7775] = 7222,
  [7776] = 7162,
  [7777] = 7218,
  [7778] = 7220,
  [7779] = 7445,
  [7780] = 7447,
  [7781] = 7448,
  [7782] = 7218,
  [7783] = 7190,
  [7784] = 7184,
  [7785] = 7191,
  [7786] = 7192,
  [7787] = 7193,
  [7788] = 7190,
  [7789] = 7200,
  [7790] = 7198,
  [7791] = 7183,
  [7792] = 7473,
  [7793] = 7181,
  [7794] = 7200,
  [7795] = 7202,
  [7796] = 7157,
  [7797] = 7206,
  [7798] = 7180,
  [7799] = 7210,
  [7800] = 7218,
  [7801] = 7176,
  [7802] = 7222,
  [7803] = 7496,
  [7804] = 7162,
  [7805] = 7220,
  [7806] = 7335,
  [7807] = 7337,
  [7808] = 7218,
  [7809] = 7809,
  [7810] = 7810,
  [7811] = 7811,
  [7812] = 7812,
  [7813] = 7190,
  [7814] = 7200,
  [7815] = 7222,
  [7816] = 7223,
  [7817] = 7817,
  [7818] = 7818,
  [7819] = 7819,
  [7820] = 7820,
  [7821] = 7224,
  [7822] = 7217,
  [7823] = 7212,
  [7824] = 7211,
  [7825] = 7159,
  [7826] = 7162,
  [7827] = 7827,
  [7828] = 7828,
  [7829] = 7357,
  [7830] = 7162,
  [7831] = 7831,
  [7832] = 7159,
  [7833] = 7833,
  [7834] = 7834,
  [7835] = 7211,
  [7836] = 7836,
  [7837] = 7212,
  [7838] = 7838,
  [7839] = 7839,
  [7840] = 7217,
  [7841] = 7841,
  [7842] = 7842,
  [7843] = 7843,
  [7844] = 7222,
  [7845] = 7162,
  [7846] = 7846,
  [7847] = 7847,
  [7848] = 7224,
  [7849] = 7223,
  [7850] = 7222,
  [7851] = 7851,
  [7852] = 7852,
  [7853] = 7218,
  [7854] = 7211,
  [7855] = 7855,
  [7856] = 7190,
  [7857] = 7857,
  [7858] = 7858,
  [7859] = 7859,
  [7860] = 7200,
  [7861] = 7861,
  [7862] = 7210,
  [7863] = 7222,
  [7864] = 7162,
  [7865] = 7206,
  [7866] = 7157,
  [7867] = 7202,
  [7868] = 7218,
  [7869] = 7200,
  [7870] = 7190,
  [7871] = 7200,
  [7872] = 7199,
  [7873] = 7198,
  [7874] = 7193,
  [7875] = 7222,
  [7876] = 7809,
  [7877] = 7810,
  [7878] = 7811,
  [7879] = 7812,
  [7880] = 7162,
  [7881] = 7192,
  [7882] = 7191,
  [7883] = 7190,
  [7884] = 7817,
  [7885] = 7818,
  [7886] = 7819,
  [7887] = 7820,
  [7888] = 7198,
  [7889] = 7190,
  [7890] = 7192,
  [7891] = 7200,
  [7892] = 3353,
  [7893] = 7184,
  [7894] = 7827,
  [7895] = 7828,
  [7896] = 3357,
  [7897] = 1112,
  [7898] = 7831,
  [7899] = 7183,
  [7900] = 7833,
  [7901] = 7834,
  [7902] = 1054,
  [7903] = 7836,
  [7904] = 7181,
  [7905] = 7838,
  [7906] = 7839,
  [7907] = 7222,
  [7908] = 7841,
  [7909] = 7842,
  [7910] = 7843,
  [7911] = 7223,
  [7912] = 7224,
  [7913] = 7846,
  [7914] = 7847,
  [7915] = 7217,
  [7916] = 3336,
  [7917] = 7851,
  [7918] = 7852,
  [7919] = 3420,
  [7920] = 7180,
  [7921] = 7855,
  [7922] = 3345,
  [7923] = 7857,
  [7924] = 7858,
  [7925] = 7859,
  [7926] = 3387,
  [7927] = 7861,
  [7928] = 3330,
  [7929] = 3326,
  [7930] = 3361,
  [7931] = 7218,
  [7932] = 7809,
  [7933] = 7810,
  [7934] = 7811,
  [7935] = 7812,
  [7936] = 3365,
  [7937] = 3370,
  [7938] = 3389,
  [7939] = 7817,
  [7940] = 7818,
  [7941] = 7819,
  [7942] = 7820,
  [7943] = 3398,
  [7944] = 3393,
  [7945] = 3351,
  [7946] = 971,
  [7947] = 7176,
  [7948] = 7827,
  [7949] = 7828,
  [7950] = 7162,
  [7951] = 3294,
  [7952] = 7831,
  [7953] = 7162,
  [7954] = 7833,
  [7955] = 7834,
  [7956] = 7159,
  [7957] = 7836,
  [7958] = 7211,
  [7959] = 7838,
  [7960] = 7839,
  [7961] = 7218,
  [7962] = 7843,
  [7963] = 7190,
  [7964] = 7192,
  [7965] = 7846,
  [7966] = 7847,
  [7967] = 7200,
  [7968] = 7217,
  [7969] = 7851,
  [7970] = 7852,
  [7971] = 3310,
  [7972] = 7224,
  [7973] = 7855,
  [7974] = 1086,
  [7975] = 7857,
  [7976] = 7858,
  [7977] = 7859,
  [7978] = 7223,
  [7979] = 7861,
  [7980] = 7222,
  [7981] = 971,
  [7982] = 7222,
  [7983] = 7809,
  [7984] = 7810,
  [7985] = 7812,
  [7986] = 7223,
  [7987] = 7224,
  [7988] = 7217,
  [7989] = 7817,
  [7990] = 7820,
  [7991] = 7162,
  [7992] = 7210,
  [7993] = 3308,
  [7994] = 7206,
  [7995] = 7157,
  [7996] = 1069,
  [7997] = 7202,
  [7998] = 7831,
  [7999] = 7200,
  [8000] = 7834,
  [8001] = 8001,
  [8002] = 7199,
  [8003] = 7843,
  [8004] = 8004,
  [8005] = 7861,
  [8006] = 7846,
  [8007] = 7847,
  [8008] = 7163,
  [8009] = 7164,
  [8010] = 7218,
  [8011] = 7367,
  [8012] = 7855,
  [8013] = 8013,
  [8014] = 7858,
  [8015] = 7381,
  [8016] = 8016,
  [8017] = 7162,
  [8018] = 7809,
  [8019] = 7810,
  [8020] = 7812,
  [8021] = 7165,
  [8022] = 7166,
  [8023] = 7167,
  [8024] = 7817,
  [8025] = 7169,
  [8026] = 7553,
  [8027] = 7190,
  [8028] = 7192,
  [8029] = 7200,
  [8030] = 7193,
  [8031] = 8031,
  [8032] = 7831,
  [8033] = 8033,
  [8034] = 7834,
  [8035] = 7345,
  [8036] = 7192,
  [8037] = 7843,
  [8038] = 8038,
  [8039] = 8039,
  [8040] = 7846,
  [8041] = 7847,
  [8042] = 8042,
  [8043] = 7189,
  [8044] = 7191,
  [8045] = 7855,
  [8046] = 7222,
  [8047] = 7858,
  [8048] = 7223,
  [8049] = 7558,
  [8050] = 7224,
  [8051] = 7809,
  [8052] = 7810,
  [8053] = 7812,
  [8054] = 7217,
  [8055] = 7190,
  [8056] = 7188,
  [8057] = 7817,
  [8058] = 8058,
  [8059] = 8059,
  [8060] = 7200,
  [8061] = 8061,
  [8062] = 8062,
  [8063] = 7859,
  [8064] = 7182,
  [8065] = 7831,
  [8066] = 7184,
  [8067] = 7834,
  [8068] = 8068,
  [8069] = 7183,
  [8070] = 7843,
  [8071] = 7181,
  [8072] = 7858,
  [8073] = 7846,
  [8074] = 7847,
  [8075] = 8075,
  [8076] = 7180,
  [8077] = 8077,
  [8078] = 7855,
  [8079] = 7170,
  [8080] = 7858,
  [8081] = 7186,
  [8082] = 7218,
  [8083] = 7218,
  [8084] = 7809,
  [8085] = 7810,
  [8086] = 7812,
  [8087] = 7174,
  [8088] = 7176,
  [8089] = 7190,
  [8090] = 7817,
  [8091] = 7192,
  [8092] = 7200,
  [8093] = 7212,
  [8094] = 7857,
  [8095] = 8095,
  [8096] = 8096,
  [8097] = 7162,
  [8098] = 7831,
  [8099] = 7185,
  [8100] = 7834,
  [8101] = 7222,
  [8102] = 7223,
  [8103] = 7843,
  [8104] = 8104,
  [8105] = 7224,
  [8106] = 7846,
  [8107] = 7847,
  [8108] = 7176,
  [8109] = 8109,
  [8110] = 7217,
  [8111] = 7855,
  [8112] = 7159,
  [8113] = 7858,
  [8114] = 7211,
  [8115] = 7212,
  [8116] = 7162,
  [8117] = 7809,
  [8118] = 7810,
  [8119] = 7812,
  [8120] = 7404,
  [8121] = 7217,
  [8122] = 7224,
  [8123] = 7817,
  [8124] = 8124,
  [8125] = 8125,
  [8126] = 7855,
  [8127] = 7223,
  [8128] = 7222,
  [8129] = 7218,
  [8130] = 8130,
  [8131] = 8131,
  [8132] = 7411,
  [8133] = 7190,
  [8134] = 7809,
  [8135] = 7810,
  [8136] = 7812,
  [8137] = 7179,
  [8138] = 7192,
  [8139] = 8139,
  [8140] = 7817,
  [8141] = 7192,
  [8142] = 7210,
  [8143] = 7206,
  [8144] = 7218,
  [8145] = 7157,
  [8146] = 7222,
  [8147] = 7852,
  [8148] = 7177,
  [8149] = 7223,
  [8150] = 7809,
  [8151] = 7810,
  [8152] = 7812,
  [8153] = 7180,
  [8154] = 7851,
  [8155] = 7181,
  [8156] = 7817,
  [8157] = 7421,
  [8158] = 8158,
  [8159] = 7183,
  [8160] = 7184,
  [8161] = 7224,
  [8162] = 7217,
  [8163] = 7202,
  [8164] = 7200,
  [8165] = 7199,
  [8166] = 7809,
  [8167] = 7810,
  [8168] = 7812,
  [8169] = 8169,
  [8170] = 7162,
  [8171] = 7198,
  [8172] = 7817,
  [8173] = 7193,
  [8174] = 7430,
  [8175] = 7192,
  [8176] = 7191,
  [8177] = 8177,
  [8178] = 7187,
  [8179] = 7218,
  [8180] = 7183,
  [8181] = 7809,
  [8182] = 7810,
  [8183] = 7812,
  [8184] = 7847,
  [8185] = 7846,
  [8186] = 7175,
  [8187] = 7817,
  [8188] = 7843,
  [8189] = 7190,
  [8190] = 8190,
  [8191] = 7192,
  [8192] = 7193,
  [8193] = 7810,
  [8194] = 7158,
  [8195] = 8195,
  [8196] = 7810,
  [8197] = 8197,
  [8198] = 7810,
  [8199] = 7200,
  [8200] = 7810,
  [8201] = 8201,
  [8202] = 8202,
  [8203] = 8203,
  [8204] = 7445,
  [8205] = 7447,
  [8206] = 7448,
  [8207] = 7190,
  [8208] = 8208,
  [8209] = 7184,
  [8210] = 8210,
  [8211] = 7842,
  [8212] = 7183,
  [8213] = 7841,
  [8214] = 8214,
  [8215] = 8215,
  [8216] = 8216,
  [8217] = 7181,
  [8218] = 7190,
  [8219] = 8016,
  [8220] = 8216,
  [8221] = 7839,
  [8222] = 7838,
  [8223] = 8201,
  [8224] = 8202,
  [8225] = 7222,
  [8226] = 7223,
  [8227] = 7173,
  [8228] = 7180,
  [8229] = 8208,
  [8230] = 8210,
  [8231] = 7836,
  [8232] = 7224,
  [8233] = 7191,
  [8234] = 8216,
  [8235] = 7192,
  [8236] = 7217,
  [8237] = 8016,
  [8238] = 8201,
  [8239] = 8202,
  [8240] = 7218,
  [8241] = 7193,
  [8242] = 7172,
  [8243] = 7176,
  [8244] = 8208,
  [8245] = 8210,
  [8246] = 7162,
  [8247] = 7162,
  [8248] = 7217,
  [8249] = 8216,
  [8250] = 7224,
  [8251] = 7171,
  [8252] = 8016,
  [8253] = 8201,
  [8254] = 8202,
  [8255] = 7198,
  [8256] = 7199,
  [8257] = 7223,
  [8258] = 8201,
  [8259] = 8202,
  [8260] = 7218,
  [8261] = 7473,
  [8262] = 7183,
  [8263] = 8201,
  [8264] = 8202,
  [8265] = 7190,
  [8266] = 7834,
  [8267] = 7833,
  [8268] = 8201,
  [8269] = 8202,
  [8270] = 7206,
  [8271] = 7200,
  [8272] = 7831,
  [8273] = 8201,
  [8274] = 8202,
  [8275] = 7168,
  [8276] = 7193,
  [8277] = 8277,
  [8278] = 8201,
  [8279] = 8202,
  [8280] = 7200,
  [8281] = 7200,
  [8282] = 7200,
  [8283] = 8201,
  [8284] = 8202,
  [8285] = 7193,
  [8286] = 7192,
  [8287] = 7828,
  [8288] = 8201,
  [8289] = 8202,
  [8290] = 8290,
  [8291] = 8291,
  [8292] = 8210,
  [8293] = 8201,
  [8294] = 8202,
  [8295] = 7827,
  [8296] = 7202,
  [8297] = 7157,
  [8298] = 8298,
  [8299] = 7190,
  [8300] = 7222,
  [8301] = 7223,
  [8302] = 7210,
  [8303] = 7224,
  [8304] = 7217,
  [8305] = 7183,
  [8306] = 7218,
  [8307] = 7162,
  [8308] = 8308,
  [8309] = 7161,
  [8310] = 7160,
  [8311] = 8215,
  [8312] = 7162,
  [8313] = 8062,
  [8314] = 8039,
  [8315] = 8315,
  [8316] = 8316,
  [8317] = 7217,
  [8318] = 7224,
  [8319] = 7222,
  [8320] = 7496,
  [8321] = 7224,
  [8322] = 7220,
  [8323] = 7335,
  [8324] = 7337,
  [8325] = 8215,
  [8326] = 8062,
  [8327] = 8039,
  [8328] = 8208,
  [8329] = 7217,
  [8330] = 8215,
  [8331] = 8062,
  [8332] = 8039,
  [8333] = 7222,
  [8334] = 7820,
  [8335] = 7819,
  [8336] = 7208,
  [8337] = 7159,
  [8338] = 7207,
  [8339] = 7818,
  [8340] = 8340,
  [8341] = 8341,
  [8342] = 7223,
  [8343] = 7222,
  [8344] = 8344,
  [8345] = 7193,
  [8346] = 7223,
  [8347] = 7817,
  [8348] = 7218,
  [8349] = 7205,
  [8350] = 7222,
  [8351] = 7223,
  [8352] = 7224,
  [8353] = 7217,
  [8354] = 7204,
  [8355] = 7201,
  [8356] = 8356,
  [8357] = 7212,
  [8358] = 7211,
  [8359] = 8359,
  [8360] = 7218,
  [8361] = 8361,
  [8362] = 7812,
  [8363] = 7183,
  [8364] = 8364,
  [8365] = 7162,
  [8366] = 8366,
  [8367] = 7162,
  [8368] = 7190,
  [8369] = 7357,
  [8370] = 8370,
  [8371] = 7192,
  [8372] = 8372,
  [8373] = 7190,
  [8374] = 7197,
  [8375] = 8375,
  [8376] = 7192,
  [8377] = 8377,
  [8378] = 7811,
  [8379] = 7196,
  [8380] = 7195,
  [8381] = 7194,
  [8382] = 7193,
  [8383] = 7810,
  [8384] = 7809,
  [8385] = 7200,
  [8386] = 7183,
  [8387] = 8202,
  [8388] = 8201,
  [8389] = 7220,
  [8390] = 8390,
  [8391] = 8391,
  [8392] = 8392,
  [8393] = 8393,
  [8394] = 3420,
  [8395] = 8395,
  [8396] = 8396,
  [8397] = 8397,
};

static inline bool sym__non_escape_char_character_set_1(int32_t c) {
  return (c < 'f'
    ? (c < '\''
      ? (c < '"'
        ? c == 0
        : c <= '"')
      : (c <= '\'' || (c >= 'a' && c <= 'b')))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43520
    ? (c < 4197
      ? (c < 2730
        ? (c < 2036
          ? (c < 1015
            ? (c < 750
              ? (c < 216
                ? (c < 181
                  ? (c < 170
                    ? (c >= 'A' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || (c < 192
                    ? c == 186
                    : c <= 214)))
                : (c <= 246 || (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || c == 748))))
              : (c <= 750 || (c < 902
                ? (c < 891
                  ? (c < 886
                    ? (c >= 880 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 910
                  ? (c < 908
                    ? (c >= 904 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c >= 931 && c <= 1013)))))))
            : (c <= 1153 || (c < 1749
              ? (c < 1488
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c >= 1376 && c <= 1416)))
                : (c <= 1514 || (c < 1646
                  ? (c < 1568
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1610)
                  : (c <= 1647 || (c >= 1649 && c <= 1747)))))
              : (c <= 1749 || (c < 1808
                ? (c < 1786
                  ? (c < 1774
                    ? (c >= 1765 && c <= 1766)
                    : c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1969
                  ? (c < 1869
                    ? (c >= 1810 && c <= 1839)
                    : c <= 1957)
                  : (c <= 1969 || (c >= 1994 && c <= 2026)))))))))
          : (c <= 2037 || (c < 2486
            ? (c < 2308
              ? (c < 2112
                ? (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || (c < 2088
                    ? c == 2084
                    : c <= 2088)))
                : (c <= 2136 || (c < 2185
                  ? (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)
                  : (c <= 2190 || (c >= 2208 && c <= 2249)))))
              : (c <= 2361 || (c < 2437
                ? (c < 2392
                  ? (c < 2384
                    ? c == 2365
                    : c <= 2384)
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || c == 2482))))))
            : (c <= 2489 || (c < 2602
              ? (c < 2544
                ? (c < 2524
                  ? (c < 2510
                    ? c == 2493
                    : c <= 2510)
                  : (c <= 2525 || (c >= 2527 && c <= 2529)))
                : (c <= 2545 || (c < 2575
                  ? (c < 2565
                    ? c == 2556
                    : c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))))
              : (c <= 2608 || (c < 2654
                ? (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))
                : (c <= 2654 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2674 && c <= 2676)
                    : c <= 2701)
                  : (c <= 2705 || (c >= 2707 && c <= 2728)))))))))))
        : (c <= 2736 || (c < 3253
          ? (c < 2969
            ? (c < 2866
              ? (c < 2809
                ? (c < 2749
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2749 || (c < 2784
                    ? c == 2768
                    : c <= 2785)))
                : (c <= 2809 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))))
              : (c <= 2867 || (c < 2929
                ? (c < 2908
                  ? (c < 2877
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2877)
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2958
                  ? (c < 2949
                    ? c == 2947
                    : c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))))))
            : (c <= 2970 || (c < 3114
              ? (c < 2990
                ? (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))
                : (c <= 3001 || (c < 3086
                  ? (c < 3077
                    ? c == 3024
                    : c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3200
                ? (c < 3165
                  ? (c < 3160
                    ? c == 3133
                    : c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))))))))
          : (c <= 3257 || (c < 3713
            ? (c < 3423
              ? (c < 3342
                ? (c < 3296
                  ? (c < 3293
                    ? c == 3261
                    : c <= 3294)
                  : (c <= 3297 || (c < 3332
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3406
                  ? (c < 3389
                    ? (c >= 3346 && c <= 3386)
                    : c <= 3389)
                  : (c <= 3406 || (c >= 3412 && c <= 3414)))))
              : (c <= 3425 || (c < 3517
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))))))
            : (c <= 3714 || (c < 3804
              ? (c < 3751
                ? (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))
                : (c <= 3760 || (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))
              : (c <= 3807 || (c < 4096
                ? (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4186
                  ? (c < 4176
                    ? c == 4159
                    : c <= 4181)
                  : (c <= 4189 || c == 4193))))))))))))
      : (c <= 4198 || (c < 8144
        ? (c < 6272
          ? (c < 4824
            ? (c < 4696
              ? (c < 4301
                ? (c < 4238
                  ? (c < 4213
                    ? (c >= 4206 && c <= 4208)
                    : c <= 4225)
                  : (c <= 4238 || (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)))
                : (c <= 4301 || (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))))
              : (c <= 4696 || (c < 4786
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c >= 4808 && c <= 4822)))))))
            : (c <= 4880 || (c < 5870
              ? (c < 5112
                ? (c < 4992
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 5007 || (c >= 5024 && c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c >= 5792 && c <= 5866)))))
              : (c <= 5880 || (c < 5998
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5905)
                    : c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6067)
                    : c <= 6103)
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))))))))
          : (c <= 6312 || (c < 7357
            ? (c < 6917
              ? (c < 6528
                ? (c < 6400
                  ? (c < 6320
                    ? c == 6314
                    : c <= 6389)
                  : (c <= 6430 || (c < 6512
                    ? (c >= 6480 && c <= 6509)
                    : c <= 6516)))
                : (c <= 6571 || (c < 6688
                  ? (c < 6656
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6678)
                  : (c <= 6740 || c == 6823))))
              : (c <= 6963 || (c < 7168
                ? (c < 7086
                  ? (c < 7043
                    ? (c >= 6981 && c <= 6988)
                    : c <= 7072)
                  : (c <= 7087 || (c >= 7098 && c <= 7141)))
                : (c <= 7203 || (c < 7296
                  ? (c < 7258
                    ? (c >= 7245 && c <= 7247)
                    : c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))))))
            : (c <= 7359 || (c < 8016
              ? (c < 7424
                ? (c < 7413
                  ? (c < 7406
                    ? (c >= 7401 && c <= 7404)
                    : c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7680 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c >= 8008 && c <= 8013)))))
              : (c <= 8023 || (c < 8064
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c >= 8031 && c <= 8061)))
                : (c <= 8116 || (c < 8130
                  ? (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)
                  : (c <= 8132 || (c >= 8134 && c <= 8140)))))))))))
        : (c <= 8147 || (c < 12344
          ? (c < 11264
            ? (c < 8469
              ? (c < 8319
                ? (c < 8178
                  ? (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)
                  : (c <= 8180 || (c < 8305
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8305)))
                : (c <= 8319 || (c < 8455
                  ? (c < 8450
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8450)
                  : (c <= 8455 || (c >= 8458 && c <= 8467)))))
              : (c <= 8469 || (c < 8490
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || c == 8488))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c >= 8544 && c <= 8584)))))))
            : (c <= 11492 || (c < 11688
              ? (c < 11565
                ? (c < 11520
                  ? (c < 11506
                    ? (c >= 11499 && c <= 11502)
                    : c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11648
                  ? (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))))
              : (c <= 11694 || (c < 11728
                ? (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))
                : (c <= 11734 || (c < 12321
                  ? (c < 12293
                    ? (c >= 11736 && c <= 11742)
                    : c <= 12295)
                  : (c <= 12329 || (c >= 12337 && c <= 12341)))))))))
          : (c <= 12348 || (c < 42960
            ? (c < 42192
              ? (c < 12593
                ? (c < 12449
                  ? (c < 12445
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12447)
                  : (c <= 12538 || (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)))
                : (c <= 12686 || (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c >= 19968 && c <= 42124)))))
              : (c <= 42237 || (c < 42623
                ? (c < 42538
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42786
                  ? (c < 42775
                    ? (c >= 42656 && c <= 42735)
                    : c <= 42783)
                  : (c <= 42888 || (c >= 42891 && c <= 42954)))))))
            : (c <= 42961 || (c < 43259
              ? (c < 43015
                ? (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))
                : (c <= 43018 || (c < 43138
                  ? (c < 43072
                    ? (c >= 43020 && c <= 43042)
                    : c <= 43123)
                  : (c <= 43187 || (c >= 43250 && c <= 43255)))))
              : (c <= 43259 || (c < 43396
                ? (c < 43312
                  ? (c < 43274
                    ? (c >= 43261 && c <= 43262)
                    : c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43494
                  ? (c < 43488
                    ? c == 43471
                    : c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))))))))))))))
    : (c <= 43560 || (c < 70751
      ? (c < 66964
        ? (c < 65008
          ? (c < 43888
            ? (c < 43739
              ? (c < 43697
                ? (c < 43616
                  ? (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)
                  : (c <= 43638 || (c < 43646
                    ? c == 43642
                    : c <= 43695)))
                : (c <= 43697 || (c < 43712
                  ? (c < 43705
                    ? (c >= 43701 && c <= 43702)
                    : c <= 43709)
                  : (c <= 43712 || c == 43714))))
              : (c <= 43741 || (c < 43793
                ? (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43754)
                    : c <= 43764)
                  : (c <= 43782 || (c >= 43785 && c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))))))
            : (c <= 44002 || (c < 64298
              ? (c < 64112
                ? (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64285 || (c >= 64287 && c <= 64296)))))
              : (c <= 64310 || (c < 64326
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c >= 64323 && c <= 64324)))
                : (c <= 64433 || (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))))))))
          : (c <= 65017 || (c < 65616
            ? (c < 65440
              ? (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65345
                  ? (c < 65313
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65437)))))
              : (c <= 65470 || (c < 65536
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c >= 65498 && c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))))))
            : (c <= 65629 || (c < 66504
              ? (c < 66304
                ? (c < 66176
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66204 || (c >= 66208 && c <= 66256)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66421)
                  : (c <= 66461 || (c >= 66464 && c <= 66499)))))
              : (c <= 66511 || (c < 66816
                ? (c < 66736
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66771 || (c >= 66776 && c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))))))))))
        : (c <= 66965 || (c < 69248
          ? (c < 67840
            ? (c < 67584
              ? (c < 67392
                ? (c < 66995
                  ? (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)
                  : (c <= 67001 || (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)))
                : (c <= 67413 || (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c >= 67506 && c <= 67514)))))
              : (c <= 67589 || (c < 67647
                ? (c < 67639
                  ? (c < 67594
                    ? c == 67592
                    : c <= 67637)
                  : (c <= 67640 || c == 67644))
                : (c <= 67669 || (c < 67808
                  ? (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)
                  : (c <= 67826 || (c >= 67828 && c <= 67829)))))))
            : (c <= 67861 || (c < 68288
              ? (c < 68112
                ? (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || c == 68096))
                : (c <= 68115 || (c < 68192
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68220 || (c >= 68224 && c <= 68252)))))
              : (c <= 68295 || (c < 68480
                ? (c < 68416
                  ? (c < 68352
                    ? (c >= 68297 && c <= 68324)
                    : c <= 68405)
                  : (c <= 68437 || (c >= 68448 && c <= 68466)))
                : (c <= 68497 || (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c >= 68864 && c <= 68899)))))))))
          : (c <= 69289 || (c < 70108
            ? (c < 69763
              ? (c < 69552
                ? (c < 69415
                  ? (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)
                  : (c <= 69415 || (c < 69488
                    ? (c >= 69424 && c <= 69445)
                    : c <= 69505)))
                : (c <= 69572 || (c < 69745
                  ? (c < 69635
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69687)
                  : (c <= 69746 || c == 69749))))
              : (c <= 69807 || (c < 69968
                ? (c < 69956
                  ? (c < 69891
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69926)
                  : (c <= 69956 || c == 69959))
                : (c <= 70002 || (c < 70081
                  ? (c < 70019
                    ? c == 70006
                    : c <= 70066)
                  : (c <= 70084 || c == 70106))))))
            : (c <= 70108 || (c < 70415
              ? (c < 70282
                ? (c < 70272
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70187)
                  : (c <= 70278 || c == 70280))
                : (c <= 70285 || (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70366 || (c >= 70405 && c <= 70412)))))
              : (c <= 70416 || (c < 70461
                ? (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c >= 70453 && c <= 70457)))
                : (c <= 70461 || (c < 70656
                  ? (c < 70493
                    ? c == 70480
                    : c <= 70497)
                  : (c <= 70708 || (c >= 70727 && c <= 70730)))))))))))))
      : (c <= 70753 || (c < 119966
        ? (c < 73063
          ? (c < 72096
            ? (c < 71488
              ? (c < 71168
                ? (c < 70855
                  ? (c < 70852
                    ? (c >= 70784 && c <= 70831)
                    : c <= 70853)
                  : (c <= 70855 || (c < 71128
                    ? (c >= 71040 && c <= 71086)
                    : c <= 71131)))
                : (c <= 71215 || (c < 71352
                  ? (c < 71296
                    ? c == 71236
                    : c <= 71338)
                  : (c <= 71352 || (c >= 71424 && c <= 71450)))))
              : (c <= 71494 || (c < 71948
                ? (c < 71935
                  ? (c < 71840
                    ? (c >= 71680 && c <= 71723)
                    : c <= 71903)
                  : (c <= 71942 || c == 71945))
                : (c <= 71955 || (c < 71999
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71983)
                  : (c <= 71999 || c == 72001))))))
            : (c <= 72103 || (c < 72368
              ? (c < 72203
                ? (c < 72163
                  ? (c < 72161
                    ? (c >= 72106 && c <= 72144)
                    : c <= 72161)
                  : (c <= 72163 || c == 72192))
                : (c <= 72242 || (c < 72284
                  ? (c < 72272
                    ? c == 72250
                    : c <= 72272)
                  : (c <= 72329 || c == 72349))))
              : (c <= 72440 || (c < 72960
                ? (c < 72768
                  ? (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72750)
                  : (c <= 72768 || (c >= 72818 && c <= 72847)))
                : (c <= 72966 || (c < 73030
                  ? (c < 72971
                    ? (c >= 72968 && c <= 72969)
                    : c <= 73008)
                  : (c <= 73030 || (c >= 73056 && c <= 73061)))))))))
          : (c <= 73064 || (c < 94032
            ? (c < 92160
              ? (c < 74752
                ? (c < 73440
                  ? (c < 73112
                    ? (c >= 73066 && c <= 73097)
                    : c <= 73112)
                  : (c <= 73458 || (c < 73728
                    ? c == 73648
                    : c <= 74649)))
                : (c <= 74862 || (c < 77824
                  ? (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)
                  : (c <= 78894 || (c >= 82944 && c <= 83526)))))
              : (c <= 92728 || (c < 92992
                ? (c < 92880
                  ? (c < 92784
                    ? (c >= 92736 && c <= 92766)
                    : c <= 92862)
                  : (c <= 92909 || (c >= 92928 && c <= 92975)))
                : (c <= 92995 || (c < 93760
                  ? (c < 93053
                    ? (c >= 93027 && c <= 93047)
                    : c <= 93071)
                  : (c <= 93823 || (c >= 93952 && c <= 94026)))))))
            : (c <= 94032 || (c < 110592
              ? (c < 100352
                ? (c < 94179
                  ? (c < 94176
                    ? (c >= 94099 && c <= 94111)
                    : c <= 94177)
                  : (c <= 94179 || (c >= 94208 && c <= 100343)))
                : (c <= 101589 || (c < 110581
                  ? (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)
                  : (c <= 110587 || (c >= 110589 && c <= 110590)))))
              : (c <= 110882 || (c < 113776
                ? (c < 110960
                  ? (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)
                  : (c <= 111355 || (c >= 113664 && c <= 113770)))
                : (c <= 113788 || (c < 119808
                  ? (c < 113808
                    ? (c >= 113792 && c <= 113800)
                    : c <= 113817)
                  : (c <= 119892 || (c >= 119894 && c <= 119964)))))))))))
        : (c <= 119967 || (c < 126464
          ? (c < 120598
            ? (c < 120094
              ? (c < 119997
                ? (c < 119977
                  ? (c < 119973
                    ? c == 119970
                    : c <= 119974)
                  : (c <= 119980 || (c < 119995
                    ? (c >= 119982 && c <= 119993)
                    : c <= 119995)))
                : (c <= 120003 || (c < 120077
                  ? (c < 120071
                    ? (c >= 120005 && c <= 120069)
                    : c <= 120074)
                  : (c <= 120084 || (c >= 120086 && c <= 120092)))))
              : (c <= 120121 || (c < 120146
                ? (c < 120134
                  ? (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)
                  : (c <= 120134 || (c >= 120138 && c <= 120144)))
                : (c <= 120485 || (c < 120540
                  ? (c < 120514
                    ? (c >= 120488 && c <= 120512)
                    : c <= 120538)
                  : (c <= 120570 || (c >= 120572 && c <= 120596)))))))
            : (c <= 120628 || (c < 123214
              ? (c < 120746
                ? (c < 120688
                  ? (c < 120656
                    ? (c >= 120630 && c <= 120654)
                    : c <= 120686)
                  : (c <= 120712 || (c >= 120714 && c <= 120744)))
                : (c <= 120770 || (c < 123136
                  ? (c < 122624
                    ? (c >= 120772 && c <= 120779)
                    : c <= 122654)
                  : (c <= 123180 || (c >= 123191 && c <= 123197)))))
              : (c <= 123214 || (c < 124909
                ? (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123565)
                    : c <= 123627)
                  : (c <= 124902 || (c >= 124904 && c <= 124907)))
                : (c <= 124910 || (c < 125184
                  ? (c < 124928
                    ? (c >= 124912 && c <= 124926)
                    : c <= 125124)
                  : (c <= 125251 || c == 125259))))))))
          : (c <= 126467 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126500
                  ? (c < 126497
                    ? (c >= 126469 && c <= 126495)
                    : c <= 126498)
                  : (c <= 126500 || c == 126503))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Y')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '\''
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '\''
                    : c <= '9')
                  : (c <= 'Z' || (c < 'b'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(475);
      if (lookahead == '#') ADVANCE(450);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(444);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(560);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(501);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '^') ADVANCE(453);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(464);
      if (lookahead == '|') ADVANCE(393);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(339)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(647);
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '\\') SKIP(46)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      END_STATE();
    case 2:
      if (lookahead == '\r') SKIP(243)
      if (lookahead == 'n') SKIP(66)
      if (lookahead == 'u') ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(315);
      END_STATE();
    case 3:
      if (lookahead == '\r') ADVANCE(457);
      if (lookahead == 'n') ADVANCE(456);
      if (lookahead == 'u') ADVANCE(457);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(456);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(457);
      if (lookahead != 0) ADVANCE(457);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(280)
      if (lookahead == 'n') SKIP(131)
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(281)
      if (lookahead == 'n') SKIP(118)
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(288)
      if (lookahead == 'n') SKIP(134)
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(282)
      if (lookahead == 'n') SKIP(130)
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(246)
      if (lookahead == 'n') SKIP(143)
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(247)
      if (lookahead == 'n') SKIP(120)
      END_STATE();
    case 10:
      if (lookahead == '\r') SKIP(287)
      if (lookahead == 'n') SKIP(122)
      END_STATE();
    case 11:
      if (lookahead == '\r') SKIP(283)
      if (lookahead == 'n') SKIP(112)
      END_STATE();
    case 12:
      if (lookahead == '\r') SKIP(284)
      if (lookahead == 'n') SKIP(115)
      END_STATE();
    case 13:
      if (lookahead == '\r') SKIP(285)
      if (lookahead == 'n') SKIP(111)
      END_STATE();
    case 14:
      if (lookahead == '\r') SKIP(289)
      if (lookahead == 'n') SKIP(114)
      END_STATE();
    case 15:
      if (lookahead == '\r') SKIP(293)
      if (lookahead == 'n') SKIP(113)
      END_STATE();
    case 16:
      if (lookahead == '\r') SKIP(291)
      if (lookahead == 'n') SKIP(123)
      END_STATE();
    case 17:
      if (lookahead == '\r') SKIP(248)
      if (lookahead == 'n') SKIP(158)
      END_STATE();
    case 18:
      if (lookahead == '\r') SKIP(249)
      if (lookahead == 'n') SKIP(149)
      END_STATE();
    case 19:
      if (lookahead == '\r') SKIP(250)
      if (lookahead == 'n') SKIP(164)
      END_STATE();
    case 20:
      if (lookahead == '\r') SKIP(251)
      if (lookahead == 'n') SKIP(148)
      END_STATE();
    case 21:
      if (lookahead == '\r') SKIP(252)
      if (lookahead == 'n') SKIP(187)
      END_STATE();
    case 22:
      if (lookahead == '\r') SKIP(253)
      if (lookahead == 'n') SKIP(138)
      END_STATE();
    case 23:
      if (lookahead == '\r') SKIP(254)
      if (lookahead == 'n') SKIP(180)
      END_STATE();
    case 24:
      if (lookahead == '\r') SKIP(255)
      if (lookahead == 'n') SKIP(154)
      END_STATE();
    case 25:
      if (lookahead == '\r') SKIP(256)
      if (lookahead == 'n') SKIP(163)
      END_STATE();
    case 26:
      if (lookahead == '\r') SKIP(257)
      if (lookahead == 'n') SKIP(170)
      END_STATE();
    case 27:
      if (lookahead == '\r') SKIP(258)
      if (lookahead == 'n') SKIP(178)
      END_STATE();
    case 28:
      if (lookahead == '\r') SKIP(259)
      if (lookahead == 'n') SKIP(155)
      END_STATE();
    case 29:
      if (lookahead == '\r') SKIP(260)
      if (lookahead == 'n') SKIP(156)
      END_STATE();
    case 30:
      if (lookahead == '\r') SKIP(261)
      if (lookahead == 'n') SKIP(171)
      END_STATE();
    case 31:
      if (lookahead == '\r') SKIP(262)
      if (lookahead == 'n') SKIP(194)
      END_STATE();
    case 32:
      if (lookahead == '\r') SKIP(263)
      if (lookahead == 'n') SKIP(172)
      END_STATE();
    case 33:
      if (lookahead == '\r') SKIP(264)
      if (lookahead == 'n') SKIP(185)
      END_STATE();
    case 34:
      if (lookahead == '\r') SKIP(265)
      if (lookahead == 'n') SKIP(165)
      END_STATE();
    case 35:
      if (lookahead == '\r') SKIP(266)
      if (lookahead == 'n') SKIP(203)
      END_STATE();
    case 36:
      if (lookahead == '\r') SKIP(267)
      if (lookahead == 'n') SKIP(186)
      END_STATE();
    case 37:
      if (lookahead == '\r') SKIP(268)
      if (lookahead == 'n') SKIP(173)
      END_STATE();
    case 38:
      if (lookahead == '\r') SKIP(269)
      if (lookahead == 'n') SKIP(179)
      END_STATE();
    case 39:
      if (lookahead == '\r') SKIP(270)
      if (lookahead == 'n') SKIP(197)
      END_STATE();
    case 40:
      if (lookahead == '\r') SKIP(273)
      if (lookahead == 'n') SKIP(200)
      END_STATE();
    case 41:
      if (lookahead == '\r') SKIP(274)
      if (lookahead == 'n') SKIP(202)
      END_STATE();
    case 42:
      if (lookahead == '\r') SKIP(275)
      if (lookahead == 'n') SKIP(195)
      END_STATE();
    case 43:
      if (lookahead == '\r') SKIP(276)
      if (lookahead == 'n') SKIP(201)
      END_STATE();
    case 44:
      if (lookahead == '\r') SKIP(277)
      if (lookahead == 'n') SKIP(198)
      END_STATE();
    case 45:
      if (lookahead == '\r') SKIP(278)
      if (lookahead == 'n') SKIP(139)
      if (lookahead == 'u') ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(315);
      END_STATE();
    case 46:
      if (lookahead == '\r') SKIP(279)
      if (lookahead == 'n') SKIP(1)
      END_STATE();
    case 47:
      if (lookahead == '\r') SKIP(286)
      if (lookahead == 'n') SKIP(124)
      END_STATE();
    case 48:
      if (lookahead == '\r') SKIP(292)
      if (lookahead == 'n') SKIP(135)
      END_STATE();
    case 49:
      if (lookahead == '\r') SKIP(290)
      if (lookahead == 'n') SKIP(125)
      END_STATE();
    case 50:
      if (lookahead == '\r') SKIP(294)
      if (lookahead == 'n') SKIP(117)
      END_STATE();
    case 51:
      if (lookahead == '\r') SKIP(295)
      if (lookahead == 'n') SKIP(132)
      END_STATE();
    case 52:
      if (lookahead == '\r') SKIP(296)
      if (lookahead == 'n') SKIP(126)
      END_STATE();
    case 53:
      if (lookahead == '\r') SKIP(297)
      if (lookahead == 'n') SKIP(128)
      END_STATE();
    case 54:
      if (lookahead == '\r') SKIP(298)
      if (lookahead == 'n') SKIP(116)
      END_STATE();
    case 55:
      if (lookahead == '\r') SKIP(299)
      if (lookahead == 'n') SKIP(121)
      END_STATE();
    case 56:
      if (lookahead == '\r') SKIP(300)
      if (lookahead == 'n') SKIP(119)
      END_STATE();
    case 57:
      if (lookahead == '\r') SKIP(301)
      if (lookahead == 'n') SKIP(129)
      END_STATE();
    case 58:
      if (lookahead == '\r') SKIP(302)
      if (lookahead == 'n') SKIP(133)
      END_STATE();
    case 59:
      if (lookahead == '\r') SKIP(303)
      if (lookahead == 'n') SKIP(127)
      END_STATE();
    case 60:
      if (lookahead == ' ') ADVANCE(654);
      END_STATE();
    case 61:
      if (lookahead == ' ') ADVANCE(654);
      if (lookahead == 'e') ADVANCE(242);
      if (lookahead == 'i') ADVANCE(237);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(304);
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 62:
      if (lookahead == ' ') ADVANCE(654);
      if (lookahead == 'e') ADVANCE(242);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(304);
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 63:
      if (lookahead == ' ') ADVANCE(654);
      if (lookahead == 'i') ADVANCE(237);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(304);
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 64:
      if (lookahead == ' ') ADVANCE(654);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(304);
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 65:
      if (lookahead == ' ') ADVANCE(208);
      if (lookahead == ')') ADVANCE(482);
      if (('\t' <= lookahead && lookahead <= '\r')) ADVANCE(209);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 66:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(450);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(501);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '^') ADVANCE(453);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(393);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 67:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '^') ADVANCE(511);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(111)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 68:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(11)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(112)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 69:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(15)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(113)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 70:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(14)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(114)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 71:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(12)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(115)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 72:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(54)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(116)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 73:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(562);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(50)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(117)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 74:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(561);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 75:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 76:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 77:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 78:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 79:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(56)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(119)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 80:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(560);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(120)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 81:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(562);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(122)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 82:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(562);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(47)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(124)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 83:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(562);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(52)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(126)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 84:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(562);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(53)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(128)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 85:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(55)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(121)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 86:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(122)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 87:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(122)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 88:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(122)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 89:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(16)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(123)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 90:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(47)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(124)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 91:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(47)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(124)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 92:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(47)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(124)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 93:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(49)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(125)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 94:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(52)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(126)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 95:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(52)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(126)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 96:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(52)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(126)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 97:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(59)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(127)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 98:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(53)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(128)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 99:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(53)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(128)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 100:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(53)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(128)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 101:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(57)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(129)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 102:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(561);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(51)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(132)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 103:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(130)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 104:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(51)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(132)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 105:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(51)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(132)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 106:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(51)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(132)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 107:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(131)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 108:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(58)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(133)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 109:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(134)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 110:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(48)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(135)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 111:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '^') ADVANCE(511);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(111)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 112:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(11)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(112)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 113:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(15)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(113)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 114:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(14)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(114)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 115:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(12)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(115)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 116:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(54)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(116)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 117:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(50)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(117)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 118:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 119:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(56)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(119)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 120:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(120)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 121:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(55)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(121)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 122:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(122)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 123:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(16)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(123)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 124:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(47)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(124)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 125:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(49)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(125)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 126:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(52)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(126)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 127:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(59)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(127)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 128:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(53)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(128)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 129:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(57)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(129)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 130:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(130)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 131:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(131)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 132:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(51)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(132)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 133:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(58)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(133)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 134:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(502);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(134)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 135:
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(503);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(48)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(135)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 136:
      if (lookahead == '"') ADVANCE(465);
      END_STATE();
    case 137:
      if (lookahead == '"') ADVANCE(472);
      END_STATE();
    case 138:
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(450);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(383);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '[') ADVANCE(216);
      if (lookahead == '\\') SKIP(22)
      if (lookahead == '^') ADVANCE(452);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(138)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 139:
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '\\') ADVANCE(45);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(139)
      END_STATE();
    case 140:
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(461);
      if (lookahead == '(') ADVANCE(461);
      if (lookahead == '/') ADVANCE(461);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '{') ADVANCE(464);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r')) SKIP(139)
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(461);
      if (lookahead != 0 &&
          lookahead != 7 &&
          lookahead != 8) ADVANCE(461);
      END_STATE();
    case 141:
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(461);
      if (lookahead == '(') ADVANCE(461);
      if (lookahead == '/') ADVANCE(461);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r')) SKIP(139)
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(461);
      if (lookahead != 0 &&
          lookahead != 7 &&
          lookahead != 8) ADVANCE(461);
      END_STATE();
    case 142:
      if (lookahead == '"') ADVANCE(477);
      END_STATE();
    case 143:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == '-') ADVANCE(487);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(218);
      if (lookahead == '<') ADVANCE(448);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(143)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 144:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(20)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(148)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 145:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(20)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(148)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 146:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(20)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(148)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 147:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(20)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(148)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 148:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(20)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(148)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 149:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(18)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(149)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 150:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(24)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(154)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 151:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(24)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(154)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 152:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(24)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(154)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 153:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(24)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(154)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 154:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(24)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(154)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 155:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(374);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') SKIP(28)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(155)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 156:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(374);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') SKIP(29)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(156)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 157:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(206);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(17)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(158)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 158:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(17)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(158)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 159:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(25)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(163)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 160:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(25)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(163)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 161:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(25)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(163)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 162:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(25)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(163)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 163:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(25)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(163)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 164:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(19)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(164)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 165:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(34)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(165)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 166:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(170)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 167:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(170)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 168:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(170)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 169:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(170)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 170:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(170)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 171:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(373);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(30)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(171)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 172:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(373);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(401);
      if (lookahead == '\\') SKIP(32)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(172)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 173:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(37)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(173)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 174:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(27)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(178)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 175:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(27)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(178)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 176:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(27)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(178)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 177:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(27)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(178)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 178:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(27)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(178)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 179:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(221);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(38)
      if (lookahead == '^') ADVANCE(452);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(312);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(179)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 180:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(23)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(406);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(180)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 181:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(33)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(185)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(643);
      END_STATE();
    case 182:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(36)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(186)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 183:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(33)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(185)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 184:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(33)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(558);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(185)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 185:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(33)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(406);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(185)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 186:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(402);
      if (lookahead == '\\') SKIP(36)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(186)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 187:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(451);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(382);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(376);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(217);
      if (lookahead == '\\') SKIP(21)
      if (lookahead == '^') ADVANCE(452);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(187)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 188:
      if (lookahead == '"') ADVANCE(478);
      END_STATE();
    case 189:
      if (lookahead == '"') ADVANCE(468);
      if (lookahead == '#') ADVANCE(461);
      if (lookahead == '(') ADVANCE(461);
      if (lookahead == '/') ADVANCE(461);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r')) SKIP(139)
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(461);
      if (lookahead != 0 &&
          lookahead != 7 &&
          lookahead != 8) ADVANCE(461);
      END_STATE();
    case 190:
      if (lookahead == '"') ADVANCE(474);
      if (lookahead == '#') ADVANCE(461);
      if (lookahead == '(') ADVANCE(461);
      if (lookahead == '/') ADVANCE(461);
      if (lookahead == '\\') ADVANCE(470);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r')) SKIP(193)
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(461);
      if (lookahead != 0 &&
          lookahead != 7 &&
          lookahead != 8) ADVANCE(461);
      END_STATE();
    case 191:
      if (lookahead == '"') ADVANCE(471);
      END_STATE();
    case 192:
      if (lookahead == '"') ADVANCE(473);
      if (lookahead == '#') ADVANCE(461);
      if (lookahead == '(') ADVANCE(461);
      if (lookahead == '/') ADVANCE(461);
      if (lookahead == '\\') ADVANCE(470);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r')) SKIP(193)
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(461);
      if (lookahead != 0 &&
          lookahead != 7 &&
          lookahead != 8) ADVANCE(461);
      END_STATE();
    case 193:
      if (lookahead == '"') ADVANCE(191);
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '\\') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(193)
      END_STATE();
    case 194:
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(376);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '[') ADVANCE(217);
      if (lookahead == '\\') SKIP(31)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'l') ADVANCE(623);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(194)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 195:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(373);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') SKIP(42)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(195)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 196:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(559);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == 'L') ADVANCE(548);
      if (lookahead == 'U') ADVANCE(223);
      if (lookahead == '\\') SKIP(39)
      if (lookahead == 'a') ADVANCE(306);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'i') ADVANCE(271);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(542);
      if (lookahead == 'w') ADVANCE(239);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '|') ADVANCE(391);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(556);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(197)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 197:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '\\') SKIP(39)
      if (lookahead == 'a') ADVANCE(306);
      if (lookahead == 'i') ADVANCE(271);
      if (lookahead == 'w') ADVANCE(239);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(197)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 198:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '\\') SKIP(44)
      if (lookahead == 'a') ADVANCE(306);
      if (lookahead == 'i') ADVANCE(271);
      if (lookahead == 'w') ADVANCE(239);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(198)
      END_STATE();
    case 199:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '\\') SKIP(40)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == 'y') ADVANCE(528);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(200)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 200:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(371);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '\\') SKIP(40)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(200)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 201:
      if (lookahead == '#') ADVANCE(64);
      if (lookahead == '&') ADVANCE(395);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(373);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '[') ADVANCE(224);
      if (lookahead == '\\') SKIP(43)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(201)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 202:
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(376);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '[') ADVANCE(217);
      if (lookahead == '\\') SKIP(41)
      if (lookahead == '`') ADVANCE(227);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(202)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 203:
      if (lookahead == '#') ADVANCE(451);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(383);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == ':') ADVANCE(370);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '[') ADVANCE(217);
      if (lookahead == '\\') SKIP(35)
      if (lookahead == '^') ADVANCE(452);
      if (lookahead == '`') ADVANCE(227);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(203)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 204:
      if (lookahead == '#') ADVANCE(570);
      if (lookahead == '(') ADVANCE(573);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '\\') ADVANCE(580);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(572);
      if (lookahead != 0) ADVANCE(586);
      END_STATE();
    case 205:
      if (lookahead == '\'') ADVANCE(463);
      if (lookahead == '\\') ADVANCE(308);
      if (lookahead != 0 &&
          (lookahead < 7 || '\r' < lookahead)) ADVANCE(205);
      END_STATE();
    case 206:
      if (lookahead == ')') ADVANCE(591);
      END_STATE();
    case 207:
      if (lookahead == ')') ADVANCE(482);
      if (lookahead == '.') ADVANCE(65);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(209);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 208:
      if (lookahead == ')') ADVANCE(482);
      if (lookahead == '.') ADVANCE(213);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(209);
      END_STATE();
    case 209:
      if (lookahead == ')') ADVANCE(482);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(209);
      END_STATE();
    case 210:
      if (lookahead == ')') ADVANCE(482);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(209);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 211:
      if (lookahead == '*') ADVANCE(587);
      END_STATE();
    case 212:
      if (lookahead == '.') ADVANCE(207);
      if (lookahead == '?') ADVANCE(209);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(212);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 213:
      if (lookahead == '.') ADVANCE(209);
      END_STATE();
    case 214:
      if (lookahead == '.') ADVANCE(442);
      END_STATE();
    case 215:
      if (lookahead == '/') ADVANCE(593);
      END_STATE();
    case 216:
      if (lookahead == '<') ADVANCE(368);
      END_STATE();
    case 217:
      if (lookahead == '<') ADVANCE(368);
      if (lookahead == ']') ADVANCE(449);
      END_STATE();
    case 218:
      if (lookahead == '>') ADVANCE(423);
      END_STATE();
    case 219:
      if (lookahead == '>') ADVANCE(427);
      END_STATE();
    case 220:
      if (lookahead == '>') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 221:
      if (lookahead == '?') ADVANCE(388);
      END_STATE();
    case 222:
      if (lookahead == '@') ADVANCE(409);
      END_STATE();
    case 223:
      if (lookahead == 'L') ADVANCE(550);
      END_STATE();
    case 224:
      if (lookahead == ']') ADVANCE(449);
      END_STATE();
    case 225:
      if (lookahead == ']') ADVANCE(405);
      if (lookahead == '}') ADVANCE(420);
      END_STATE();
    case 226:
      if (lookahead == ']') ADVANCE(369);
      END_STATE();
    case 227:
      if (lookahead == '`') ADVANCE(329);
      END_STATE();
    case 228:
      if (lookahead == '`') ADVANCE(613);
      END_STATE();
    case 229:
      if (lookahead == '`') ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(229);
      END_STATE();
    case 230:
      if (lookahead == 'a') ADVANCE(232);
      END_STATE();
    case 231:
      if (lookahead == 'a') ADVANCE(305);
      END_STATE();
    case 232:
      if (lookahead == 'd') ADVANCE(651);
      END_STATE();
    case 233:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 234:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 235:
      if (lookahead == 'e') ADVANCE(657);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 237:
      if (lookahead == 'f') ADVANCE(655);
      END_STATE();
    case 238:
      if (lookahead == 'f') ADVANCE(656);
      END_STATE();
    case 239:
      if (lookahead == 'h') ADVANCE(236);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(244);
      if (lookahead == 'o') ADVANCE(230);
      END_STATE();
    case 241:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 242:
      if (lookahead == 'l') ADVANCE(307);
      if (lookahead == 'n') ADVANCE(233);
      END_STATE();
    case 243:
      if (lookahead == 'n') SKIP(66)
      END_STATE();
    case 244:
      if (lookahead == 'n') ADVANCE(234);
      END_STATE();
    case 245:
      if (lookahead == 'n') ADVANCE(644);
      END_STATE();
    case 246:
      if (lookahead == 'n') SKIP(143)
      END_STATE();
    case 247:
      if (lookahead == 'n') SKIP(120)
      END_STATE();
    case 248:
      if (lookahead == 'n') SKIP(158)
      END_STATE();
    case 249:
      if (lookahead == 'n') SKIP(149)
      END_STATE();
    case 250:
      if (lookahead == 'n') SKIP(164)
      END_STATE();
    case 251:
      if (lookahead == 'n') SKIP(148)
      END_STATE();
    case 252:
      if (lookahead == 'n') SKIP(187)
      END_STATE();
    case 253:
      if (lookahead == 'n') SKIP(138)
      END_STATE();
    case 254:
      if (lookahead == 'n') SKIP(180)
      END_STATE();
    case 255:
      if (lookahead == 'n') SKIP(154)
      END_STATE();
    case 256:
      if (lookahead == 'n') SKIP(163)
      END_STATE();
    case 257:
      if (lookahead == 'n') SKIP(170)
      END_STATE();
    case 258:
      if (lookahead == 'n') SKIP(178)
      END_STATE();
    case 259:
      if (lookahead == 'n') SKIP(155)
      END_STATE();
    case 260:
      if (lookahead == 'n') SKIP(156)
      END_STATE();
    case 261:
      if (lookahead == 'n') SKIP(171)
      END_STATE();
    case 262:
      if (lookahead == 'n') SKIP(194)
      END_STATE();
    case 263:
      if (lookahead == 'n') SKIP(172)
      END_STATE();
    case 264:
      if (lookahead == 'n') SKIP(185)
      END_STATE();
    case 265:
      if (lookahead == 'n') SKIP(165)
      END_STATE();
    case 266:
      if (lookahead == 'n') SKIP(203)
      END_STATE();
    case 267:
      if (lookahead == 'n') SKIP(186)
      END_STATE();
    case 268:
      if (lookahead == 'n') SKIP(173)
      END_STATE();
    case 269:
      if (lookahead == 'n') SKIP(179)
      END_STATE();
    case 270:
      if (lookahead == 'n') SKIP(197)
      END_STATE();
    case 271:
      if (lookahead == 'n') ADVANCE(425);
      END_STATE();
    case 272:
      if (lookahead == 'n') ADVANCE(438);
      END_STATE();
    case 273:
      if (lookahead == 'n') SKIP(200)
      END_STATE();
    case 274:
      if (lookahead == 'n') SKIP(202)
      END_STATE();
    case 275:
      if (lookahead == 'n') SKIP(195)
      END_STATE();
    case 276:
      if (lookahead == 'n') SKIP(201)
      END_STATE();
    case 277:
      if (lookahead == 'n') SKIP(198)
      END_STATE();
    case 278:
      if (lookahead == 'n') SKIP(139)
      END_STATE();
    case 279:
      if (lookahead == 'n') SKIP(1)
      END_STATE();
    case 280:
      if (lookahead == 'n') SKIP(131)
      END_STATE();
    case 281:
      if (lookahead == 'n') SKIP(118)
      END_STATE();
    case 282:
      if (lookahead == 'n') SKIP(130)
      END_STATE();
    case 283:
      if (lookahead == 'n') SKIP(112)
      END_STATE();
    case 284:
      if (lookahead == 'n') SKIP(115)
      END_STATE();
    case 285:
      if (lookahead == 'n') SKIP(111)
      END_STATE();
    case 286:
      if (lookahead == 'n') SKIP(124)
      END_STATE();
    case 287:
      if (lookahead == 'n') SKIP(122)
      END_STATE();
    case 288:
      if (lookahead == 'n') SKIP(134)
      END_STATE();
    case 289:
      if (lookahead == 'n') SKIP(114)
      END_STATE();
    case 290:
      if (lookahead == 'n') SKIP(125)
      END_STATE();
    case 291:
      if (lookahead == 'n') SKIP(123)
      END_STATE();
    case 292:
      if (lookahead == 'n') SKIP(135)
      END_STATE();
    case 293:
      if (lookahead == 'n') SKIP(113)
      END_STATE();
    case 294:
      if (lookahead == 'n') SKIP(117)
      END_STATE();
    case 295:
      if (lookahead == 'n') SKIP(132)
      END_STATE();
    case 296:
      if (lookahead == 'n') SKIP(126)
      END_STATE();
    case 297:
      if (lookahead == 'n') SKIP(128)
      END_STATE();
    case 298:
      if (lookahead == 'n') SKIP(116)
      END_STATE();
    case 299:
      if (lookahead == 'n') SKIP(121)
      END_STATE();
    case 300:
      if (lookahead == 'n') SKIP(119)
      END_STATE();
    case 301:
      if (lookahead == 'n') SKIP(129)
      END_STATE();
    case 302:
      if (lookahead == 'n') SKIP(133)
      END_STATE();
    case 303:
      if (lookahead == 'n') SKIP(127)
      END_STATE();
    case 304:
      if (lookahead == 'o') ADVANCE(309);
      END_STATE();
    case 305:
      if (lookahead == 'r') ADVANCE(245);
      END_STATE();
    case 306:
      if (lookahead == 's') ADVANCE(379);
      END_STATE();
    case 307:
      if (lookahead == 's') ADVANCE(235);
      END_STATE();
    case 308:
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(316);
      END_STATE();
    case 309:
      if (lookahead == 'w') ADVANCE(231);
      END_STATE();
    case 310:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(520);
      END_STATE();
    case 311:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(521);
      END_STATE();
    case 312:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 313:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(460);
      END_STATE();
    case 314:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 315:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(313);
      END_STATE();
    case 316:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(314);
      END_STATE();
    case 317:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(522);
      END_STATE();
    case 318:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(458);
      END_STATE();
    case 319:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(459);
      END_STATE();
    case 320:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(205);
      END_STATE();
    case 321:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(318);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(319);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(320);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(321);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(322);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(324);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 329:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '`') ADVANCE(229);
      END_STATE();
    case 330:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(357)
      if (lookahead == 'n') SKIP(353)
      END_STATE();
    case 331:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(361)
      if (lookahead == 'n') SKIP(349)
      END_STATE();
    case 332:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(358)
      if (lookahead == 'n') SKIP(354)
      END_STATE();
    case 333:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(362)
      if (lookahead == 'n') SKIP(348)
      END_STATE();
    case 334:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(359)
      if (lookahead == 'n') SKIP(356)
      END_STATE();
    case 335:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(360)
      if (lookahead == 'n') SKIP(355)
      END_STATE();
    case 336:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(363)
      if (lookahead == 'n') SKIP(352)
      END_STATE();
    case 337:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(364)
      if (lookahead == 'n') SKIP(351)
      END_STATE();
    case 338:
      if (eof) ADVANCE(366);
      if (lookahead == '\r') SKIP(365)
      if (lookahead == 'n') SKIP(350)
      END_STATE();
    case 339:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == '#') ADVANCE(450);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(454);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '>') ADVANCE(434);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(501);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '^') ADVANCE(453);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'w') ADVANCE(628);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(393);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(339)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 340:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') SKIP(333)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '^') ADVANCE(511);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(348)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 341:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(331)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(349)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 342:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(331)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(349)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 343:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(331)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'f') ADVANCE(553);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(349)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 344:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(331)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(349)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 345:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(338)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(350)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 346:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(562);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'M') ADVANCE(558);
      if (lookahead == 'U') ADVANCE(619);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(337)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'm') ADVANCE(557);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(555);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(351)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 347:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(440);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(432);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(336)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(352)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 348:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(445);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(447);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') SKIP(333)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '^') ADVANCE(511);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(348)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 349:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(331)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(349)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 350:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(415);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(338)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(394);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(350)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 351:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(417);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(337)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(351)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 352:
      if (eof) ADVANCE(366);
      if (lookahead == '!') ADVANCE(499);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(515);
      if (lookahead == '%') ADVANCE(494);
      if (lookahead == '&') ADVANCE(396);
      if (lookahead == '\'') ADVANCE(505);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(483);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(486);
      if (lookahead == '.') ADVANCE(416);
      if (lookahead == '/') ADVANCE(507);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(372);
      if (lookahead == '<') ADVANCE(506);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(509);
      if (lookahead == '?') ADVANCE(387);
      if (lookahead == '@') ADVANCE(504);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(336)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(511);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(352)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(643);
      END_STATE();
    case 353:
      if (eof) ADVANCE(366);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(487);
      if (lookahead == '.') ADVANCE(214);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(376);
      if (lookahead == ';') ADVANCE(398);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(330)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(392);
      if (lookahead == '}') ADVANCE(418);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(353)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 354:
      if (eof) ADVANCE(366);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == '-') ADVANCE(487);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(376);
      if (lookahead == '<') ADVANCE(448);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(226);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(399);
      if (lookahead == '\\') SKIP(332)
      if (lookahead == ']') ADVANCE(403);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '|') ADVANCE(225);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(354)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 355:
      if (eof) ADVANCE(366);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(493);
      if (lookahead == '&') ADVANCE(397);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == '+') ADVANCE(484);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(335)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'm') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(638);
      if (lookahead == 'y') ADVANCE(630);
      if (lookahead == '{') ADVANCE(407);
      if (lookahead == '~') ADVANCE(497);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(355)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 356:
      if (eof) ADVANCE(366);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '#') ADVANCE(62);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(381);
      if (lookahead == ')') ADVANCE(384);
      if (lookahead == '*') ADVANCE(443);
      if (lookahead == '+') ADVANCE(312);
      if (lookahead == ',') ADVANCE(385);
      if (lookahead == '-') ADVANCE(220);
      if (lookahead == '.') ADVANCE(414);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == ':') ADVANCE(221);
      if (lookahead == '<') ADVANCE(446);
      if (lookahead == '=') ADVANCE(367);
      if (lookahead == '>') ADVANCE(433);
      if (lookahead == '?') ADVANCE(386);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(400);
      if (lookahead == '\\') SKIP(334)
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(406);
      if (lookahead == '|') ADVANCE(391);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(356)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(643);
      END_STATE();
    case 357:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(353)
      END_STATE();
    case 358:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(354)
      END_STATE();
    case 359:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(356)
      END_STATE();
    case 360:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(355)
      END_STATE();
    case 361:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(349)
      END_STATE();
    case 362:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(348)
      END_STATE();
    case 363:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(352)
      END_STATE();
    case 364:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(351)
      END_STATE();
    case 365:
      if (eof) ADVANCE(366);
      if (lookahead == 'n') SKIP(350)
      END_STATE();
    case 366:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_LBRACK_LT);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_GT_RBRACK);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(390);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(390);
      if (lookahead == '=') ADVANCE(514);
      if (lookahead == '>') ADVANCE(423);
      if (lookahead == '?') ADVANCE(389);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(390);
      if (lookahead == '>') ADVANCE(423);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(390);
      if (lookahead == '>') ADVANCE(423);
      if (lookahead == '?') ADVANCE(388);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(390);
      if (lookahead == '?') ADVANCE(388);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '>') ADVANCE(423);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_let);
      if (lookahead == '!') ADVANCE(378);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_let_BANG);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_as);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(479);
      if (lookahead == '*') ADVANCE(588);
      if (lookahead == '.') ADVANCE(207);
      if (lookahead == '?') ADVANCE(209);
      if (lookahead == '|') ADVANCE(480);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(212);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('+' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(479);
      if (lookahead == '*') ADVANCE(587);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(587);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '<') ADVANCE(498);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('=' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '>') ADVANCE(424);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(481);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(481);
      if (lookahead == ']') ADVANCE(405);
      if (lookahead == '|') ADVANCE(512);
      if (lookahead == '}') ADVANCE(420);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(512);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(496);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(495);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '<') ADVANCE(368);
      if (lookahead == ']') ADVANCE(449);
      if (lookahead == '|') ADVANCE(404);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '<') ADVANCE(368);
      if (lookahead == '|') ADVANCE(404);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(449);
      if (lookahead == '|') ADVANCE(404);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '|') ADVANCE(404);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_LBRACK_PIPE);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACK);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(419);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_LT_AT);
      if (lookahead == '@') ADVANCE(412);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '?') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_LT_AT);
      if (lookahead == '@') ADVANCE(411);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_AT_GT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_LT_AT_AT);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_LT_AT_AT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_AT_AT_GT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(441);
      if (lookahead == '[') ADVANCE(431);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(437);
      if (lookahead == '[') ADVANCE(431);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '[') ADVANCE(431);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_return_BANG);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_yield_BANG);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_COLON_GT);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK_GT);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_in);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_match_BANG);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_DOT_LBRACK);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_use_BANG);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_do_BANG);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_when);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_DOT_DOT2);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_DOT_DOT3);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == ')') ADVANCE(591);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '-') ADVANCE(430);
      if (lookahead == '@') ADVANCE(408);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '.' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '?') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '@') ADVANCE(409);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == ' ') ADVANCE(654);
      if (lookahead == 'i') ADVANCE(237);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(304);
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == ' ') ADVANCE(654);
      if (lookahead == 'l') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(304);
      if (lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_EQ2);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym__escape_char);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym__non_escape_char);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(sym__unicodegraph_short);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(325);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(sym__unicodegraph_long);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(sym__trigraph);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(aux_sym__simple_string_char_token1);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(aux_sym_char_token1);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(aux_sym_char_token1);
      if (lookahead == 'B') ADVANCE(462);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE);
      if (lookahead == '"') ADVANCE(142);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(188);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == 'B') ADVANCE(476);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '\r') ADVANCE(457);
      if (!sym__non_escape_char_character_set_1(lookahead)) ADVANCE(457);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(aux_sym__verbatim_string_char_token1);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_AT_DQUOTE);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(471);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(471);
      if (lookahead == 'B') ADVANCE(476);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == 'B') ADVANCE(476);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_DQUOTEB);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_unit);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_LPAREN_PIPE);
      if (lookahead == ')') ADVANCE(482);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(209);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_PIPE_RPAREN);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym_op_identifier);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(490);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(489);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(492);
      if (lookahead == '>') ADVANCE(428);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(492);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(491);
      if (lookahead == '>') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(491);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '-') ADVANCE(516);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '=') ADVANCE(513);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '"') ADVANCE(472);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '@') ADVANCE(508);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '?') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '"') ADVANCE(472);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '"') ADVANCE(472);
      if (lookahead == '@') ADVANCE(508);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '?') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '"') ADVANCE(472);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '\'') ADVANCE(463);
      if (lookahead == '\\') ADVANCE(308);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(505);
      if (lookahead != 0 &&
          (lookahead < 7 || '\r' < lookahead)) ADVANCE(205);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '-') ADVANCE(430);
      if (lookahead == '@') ADVANCE(408);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '.' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '?') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '/') ADVANCE(592);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '>') ADVANCE(413);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == ']') ADVANCE(369);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '|') ADVANCE(512);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '"') ADVANCE(465);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_DASH);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '_') ADVANCE(519);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(310);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(311);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '_') ADVANCE(519);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_int);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(518);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(523);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(520);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(521);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(525);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(522);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(520);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_xint);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(521);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(sym_xint);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(522);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_y);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_y);
      if (lookahead == 'i') ADVANCE(624);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_y);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_uy);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_uy);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_s);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_s);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_us);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_us);
      if (lookahead == 'e') ADVANCE(615);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_us);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_l);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_l);
      if (lookahead == 'e') ADVANCE(639);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_l);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(551);
      if (lookahead == 'l') ADVANCE(543);
      if (lookahead == 'n') ADVANCE(547);
      if (lookahead == 's') ADVANCE(534);
      if (lookahead == 'y') ADVANCE(530);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(551);
      if (lookahead == 'l') ADVANCE(543);
      if (lookahead == 'n') ADVANCE(547);
      if (lookahead == 's') ADVANCE(535);
      if (lookahead == 'y') ADVANCE(530);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(550);
      if (lookahead == 'l') ADVANCE(539);
      if (lookahead == 'n') ADVANCE(546);
      if (lookahead == 's') ADVANCE(533);
      if (lookahead == 'y') ADVANCE(529);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_n);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_n);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_un);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_un);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_L);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_L);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(aux_sym_uint64_token1);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(aux_sym_uint64_token1);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_f);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_f);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(aux_sym_bignum_token1);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(aux_sym_bignum_token1);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      if (lookahead == 'a') ADVANCE(640);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(643);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_DOT2);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(441);
      if (lookahead == '[') ADVANCE(431);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(437);
      if (lookahead == '[') ADVANCE(431);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '[') ADVANCE(431);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(aux_sym_float_token1);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(563);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(563);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == ' ') ADVANCE(586);
      if (lookahead == 'l') ADVANCE(579);
      if (lookahead == 'n') ADVANCE(583);
      if (lookahead == 'r') ADVANCE(650);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == ' ') ADVANCE(586);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == '#') ADVANCE(570);
      if (lookahead == '(') ADVANCE(573);
      if (lookahead == '/') ADVANCE(574);
      if (lookahead == '\\') ADVANCE(580);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < '\n' || '\r' < lookahead)) ADVANCE(586);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == '*') ADVANCE(590);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == '/') ADVANCE(595);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'a') ADVANCE(577);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'a') ADVANCE(584);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'd') ADVANCE(653);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'e') ADVANCE(571);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'o') ADVANCE(575);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'n') ADVANCE(572);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'n') ADVANCE(578);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'n') ADVANCE(646);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'o') ADVANCE(585);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'r') ADVANCE(582);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead == 'w') ADVANCE(576);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(aux_sym_xml_doc_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      if (lookahead == ')') ADVANCE(482);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(209);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(210);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_STAR_RPAREN);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(567);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(511);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(566);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(568);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(569);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == ' ') ADVANCE(612);
      if (lookahead == 'l') ADVANCE(605);
      if (lookahead == 'n') ADVANCE(609);
      if (lookahead == 'r') ADVANCE(649);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == ' ') ADVANCE(612);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == '#') ADVANCE(596);
      if (lookahead == '(') ADVANCE(599);
      if (lookahead == '/') ADVANCE(600);
      if (lookahead == '\\') ADVANCE(606);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(598);
      if (lookahead != 0 &&
          (lookahead < '\n' || '\r' < lookahead)) ADVANCE(612);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == '*') ADVANCE(589);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == '/') ADVANCE(594);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'a') ADVANCE(603);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'a') ADVANCE(610);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'e') ADVANCE(597);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'i') ADVANCE(607);
      if (lookahead == 'o') ADVANCE(601);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'n') ADVANCE(598);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'n') ADVANCE(604);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'n') ADVANCE(645);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'o') ADVANCE(611);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'r') ADVANCE(608);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == 'w') ADVANCE(602);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(436);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(435);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(429);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(422);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(421);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(551);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(640);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(643);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(629);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(617);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(639);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(631);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(633);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(615);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(641);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(625);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(616);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(624);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(622);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(426);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(439);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(618);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(614);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(634);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(380);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(626);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(377);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(621);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(642);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(636);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(643);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(anon_sym_POUNDnowarn);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym_POUNDnowarn);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(anon_sym_POUNDnowarn);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(aux_sym_compiler_directive_decl_token1);
      if (lookahead == '\n') ADVANCE(647);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_POUNDr);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_POUNDr);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(anon_sym_POUNDr);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_POUNDload);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym_POUNDload);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(612);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym_POUNDload);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(586);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_POUNDif);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(anon_sym_POUNDendif);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym_POUNDelse);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'L') ADVANCE(1);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(24)
      END_STATE();
    case 1:
      if (lookahead == 'F') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == '\r') SKIP(26)
      if (lookahead == 'n') SKIP(24)
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 4:
      if (lookahead == 'b') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 's') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 6:
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'q') ADVANCE(36);
      if (lookahead == 'v') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(42);
      if (lookahead == 'l') ADVANCE(43);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(44);
      if (lookahead == 'f') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'f') ADVANCE(48);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'e') ADVANCE(54);
      if (lookahead == 'o') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(57);
      if (lookahead == 'p') ADVANCE(58);
      if (lookahead == 'r') ADVANCE(59);
      if (lookahead == 'v') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(65);
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      if (lookahead == 'r') ADVANCE(69);
      if (lookahead == 'y') ADVANCE(70);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(71);
      if (lookahead == 'p') ADVANCE(72);
      if (lookahead == 's') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 24:
      if (lookahead == '\\') SKIP(2)
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(78);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(24)
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 26:
      if (lookahead == 'n') SKIP(24)
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 28:
      if (lookahead == 'd') ADVANCE(80);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'g') ADVANCE(82);
      END_STATE();
    case 31:
      if (lookahead == 'm') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == 'f') ADVANCE(85);
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n') ADVANCE(87);
      if (lookahead == 'w') ADVANCE(88);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(89);
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(91);
      if (lookahead == 'u') ADVANCE(92);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(93);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(95);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(96);
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_id);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(102);
      if (lookahead == 'l') ADVANCE(103);
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 47:
      if (lookahead == 'z') ADVANCE(105);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_lf);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(108);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(110);
      END_STATE();
    case 54:
      if (lookahead == 'w') ADVANCE(111);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 56:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(117);
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 63:
      if (lookahead == 'b') ADVANCE(119);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(120);
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 66:
      if (lookahead == 'a') ADVANCE(123);
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 69:
      if (lookahead == 'u') ADVANCE(126);
      if (lookahead == 'y') ADVANCE(127);
      END_STATE();
    case 70:
      if (lookahead == 'p') ADVANCE(128);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(129);
      if (lookahead == 'm') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(131);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(47);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 83:
      if (lookahead == 'p') ADVANCE(140);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(142);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 88:
      if (lookahead == 'n') ADVANCE(145);
      END_STATE();
    case 89:
      if (lookahead == 'f') ADVANCE(146);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 92:
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(150);
      END_STATE();
    case 95:
      if (lookahead == 's') ADVANCE(151);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(152);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(153);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_fun);
      if (lookahead == 'c') ADVANCE(154);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 101:
      if (lookahead == 'b') ADVANCE(155);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 103:
      if (lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 105:
      if (lookahead == 'y') ADVANCE(159);
      END_STATE();
    case 106:
      if (lookahead == 'c') ADVANCE(160);
      END_STATE();
    case 107:
      if (lookahead == 'b') ADVANCE(161);
      END_STATE();
    case 108:
      if (lookahead == 'u') ADVANCE(162);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 114:
      if (lookahead == 'n') ADVANCE(166);
      END_STATE();
    case 115:
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(168);
      END_STATE();
    case 117:
      if (lookahead == 'v') ADVANCE(169);
      END_STATE();
    case 118:
      if (lookahead == 'p') ADVANCE(170);
      END_STATE();
    case 119:
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_rec);
      END_STATE();
    case 121:
      if (lookahead == 'u') ADVANCE(172);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 124:
      if (lookahead == 'u') ADVANCE(174);
      END_STATE();
    case 125:
      if (lookahead == 'n') ADVANCE(175);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(179);
      END_STATE();
    case 131:
      if (lookahead == 'a') ADVANCE(180);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_val);
      END_STATE();
    case 134:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 135:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 137:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 138:
      if (lookahead == 'm') ADVANCE(185);
      if (lookahead == 'r') ADVANCE(186);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(187);
      END_STATE();
    case 140:
      if (lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 141:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 142:
      if (lookahead == 'u') ADVANCE(190);
      END_STATE();
    case 143:
      if (lookahead == 'g') ADVANCE(191);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 145:
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 't') ADVANCE(193);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 149:
      if (lookahead == 'l') ADVANCE(194);
      END_STATE();
    case 150:
      if (lookahead == 't') ADVANCE(195);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 152:
      if (lookahead == 'd') ADVANCE(196);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 154:
      if (lookahead == 't') ADVANCE(198);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(200);
      END_STATE();
    case 157:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 158:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_lazy);
      END_STATE();
    case 160:
      if (lookahead == 'h') ADVANCE(203);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 163:
      if (lookahead == 'b') ADVANCE(206);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(207);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_open);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 168:
      if (lookahead == 'm') ADVANCE(209);
      END_STATE();
    case 169:
      if (lookahead == 'a') ADVANCE(210);
      END_STATE();
    case 170:
      if (lookahead == 'e') ADVANCE(211);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(213);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(215);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_bool);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_unit);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(216);
      END_STATE();
    case 180:
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(219);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(220);
      END_STATE();
    case 185:
      if (lookahead == 'b') ADVANCE(221);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(222);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 193:
      if (lookahead == 'o') ADVANCE(228);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(229);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 197:
      if (lookahead == 'l') ADVANCE(230);
      END_STATE();
    case 198:
      if (lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 199:
      if (lookahead == 'l') ADVANCE(232);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(233);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 202:
      if (lookahead == 'f') ADVANCE(235);
      if (lookahead == 'n') ADVANCE(236);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 204:
      if (lookahead == 'r') ADVANCE(237);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 206:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 207:
      if (lookahead == 'p') ADVANCE(240);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_param);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 211:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(244);
      END_STATE();
    case 213:
      if (lookahead == 'n') ADVANCE(245);
      END_STATE();
    case 214:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 216:
      if (lookahead == 'a') ADVANCE(248);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(249);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(251);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 223:
      if (lookahead == 'i') ADVANCE(252);
      END_STATE();
    case 224:
      if (lookahead == 'u') ADVANCE(253);
      END_STATE();
    case 225:
      if (lookahead == 't') ADVANCE(254);
      END_STATE();
    case 226:
      if (lookahead == 't') ADVANCE(255);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(256);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_downto);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 230:
      if (lookahead == 'y') ADVANCE(258);
      END_STATE();
    case 231:
      if (lookahead == 'o') ADVANCE(259);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(260);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 235:
      if (lookahead == 'a') ADVANCE(261);
      END_STATE();
    case 236:
      if (lookahead == 'a') ADVANCE(262);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_member);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 240:
      if (lookahead == 'a') ADVANCE(264);
      END_STATE();
    case 241:
      if (lookahead == 'd') ADVANCE(265);
      END_STATE();
    case 242:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 243:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym_access_modifier_token1);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 248:
      if (lookahead == 'g') ADVANCE(267);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_upcast);
      END_STATE();
    case 250:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 251:
      if (lookahead == 'y') ADVANCE(269);
      END_STATE();
    case 252:
      if (lookahead == 's') ADVANCE(270);
      END_STATE();
    case 253:
      if (lookahead == 'c') ADVANCE(271);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 255:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 257:
      if (lookahead == 'y') ADVANCE(274);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_inherit);
      END_STATE();
    case 261:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 262:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 264:
      if (lookahead == 'c') ADVANCE(277);
      END_STATE();
    case 265:
      if (lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 266:
      if (lookahead == 'y') ADVANCE(279);
      END_STATE();
    case 267:
      if (lookahead == 'e') ADVANCE(280);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 270:
      if (lookahead == 'o') ADVANCE(281);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_downcast);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_equality);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 280:
      if (lookahead == 'd') ADVANCE(285);
      END_STATE();
    case 281:
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 282:
      if (lookahead == 'o') ADVANCE(287);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_comparison);
      END_STATE();
    case 287:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 353, .external_lex_state = 2},
  [2] = {.lex_state = 344, .external_lex_state = 3},
  [3] = {.lex_state = 344, .external_lex_state = 3},
  [4] = {.lex_state = 344, .external_lex_state = 3},
  [5] = {.lex_state = 344, .external_lex_state = 3},
  [6] = {.lex_state = 344, .external_lex_state = 3},
  [7] = {.lex_state = 344, .external_lex_state = 3},
  [8] = {.lex_state = 344, .external_lex_state = 3},
  [9] = {.lex_state = 344, .external_lex_state = 3},
  [10] = {.lex_state = 344, .external_lex_state = 3},
  [11] = {.lex_state = 344, .external_lex_state = 3},
  [12] = {.lex_state = 344, .external_lex_state = 3},
  [13] = {.lex_state = 344, .external_lex_state = 3},
  [14] = {.lex_state = 344, .external_lex_state = 3},
  [15] = {.lex_state = 344, .external_lex_state = 3},
  [16] = {.lex_state = 344, .external_lex_state = 3},
  [17] = {.lex_state = 344, .external_lex_state = 3},
  [18] = {.lex_state = 344, .external_lex_state = 3},
  [19] = {.lex_state = 344, .external_lex_state = 3},
  [20] = {.lex_state = 344, .external_lex_state = 3},
  [21] = {.lex_state = 344, .external_lex_state = 4},
  [22] = {.lex_state = 344, .external_lex_state = 4},
  [23] = {.lex_state = 344, .external_lex_state = 3},
  [24] = {.lex_state = 344, .external_lex_state = 3},
  [25] = {.lex_state = 344, .external_lex_state = 3},
  [26] = {.lex_state = 344, .external_lex_state = 3},
  [27] = {.lex_state = 344, .external_lex_state = 4},
  [28] = {.lex_state = 344, .external_lex_state = 4},
  [29] = {.lex_state = 344, .external_lex_state = 4},
  [30] = {.lex_state = 344, .external_lex_state = 4},
  [31] = {.lex_state = 344, .external_lex_state = 4},
  [32] = {.lex_state = 344, .external_lex_state = 4},
  [33] = {.lex_state = 344, .external_lex_state = 3},
  [34] = {.lex_state = 344, .external_lex_state = 3},
  [35] = {.lex_state = 344, .external_lex_state = 3},
  [36] = {.lex_state = 344, .external_lex_state = 3},
  [37] = {.lex_state = 344, .external_lex_state = 3},
  [38] = {.lex_state = 344, .external_lex_state = 3},
  [39] = {.lex_state = 344, .external_lex_state = 4},
  [40] = {.lex_state = 344, .external_lex_state = 4},
  [41] = {.lex_state = 107, .external_lex_state = 4},
  [42] = {.lex_state = 344, .external_lex_state = 5},
  [43] = {.lex_state = 344, .external_lex_state = 5},
  [44] = {.lex_state = 107, .external_lex_state = 4},
  [45] = {.lex_state = 344, .external_lex_state = 5},
  [46] = {.lex_state = 107, .external_lex_state = 4},
  [47] = {.lex_state = 107, .external_lex_state = 4},
  [48] = {.lex_state = 107, .external_lex_state = 4},
  [49] = {.lex_state = 344, .external_lex_state = 5},
  [50] = {.lex_state = 344, .external_lex_state = 4},
  [51] = {.lex_state = 107, .external_lex_state = 4},
  [52] = {.lex_state = 107, .external_lex_state = 4},
  [53] = {.lex_state = 107, .external_lex_state = 4},
  [54] = {.lex_state = 107, .external_lex_state = 4},
  [55] = {.lex_state = 107, .external_lex_state = 4},
  [56] = {.lex_state = 344, .external_lex_state = 4},
  [57] = {.lex_state = 344, .external_lex_state = 3},
  [58] = {.lex_state = 78, .external_lex_state = 3},
  [59] = {.lex_state = 78, .external_lex_state = 3},
  [60] = {.lex_state = 78, .external_lex_state = 3},
  [61] = {.lex_state = 78, .external_lex_state = 3},
  [62] = {.lex_state = 78, .external_lex_state = 3},
  [63] = {.lex_state = 344, .external_lex_state = 3},
  [64] = {.lex_state = 344, .external_lex_state = 3},
  [65] = {.lex_state = 344, .external_lex_state = 3},
  [66] = {.lex_state = 344, .external_lex_state = 3},
  [67] = {.lex_state = 344, .external_lex_state = 3},
  [68] = {.lex_state = 344, .external_lex_state = 3},
  [69] = {.lex_state = 344, .external_lex_state = 3},
  [70] = {.lex_state = 344, .external_lex_state = 3},
  [71] = {.lex_state = 344, .external_lex_state = 3},
  [72] = {.lex_state = 344, .external_lex_state = 3},
  [73] = {.lex_state = 344, .external_lex_state = 4},
  [74] = {.lex_state = 344, .external_lex_state = 3},
  [75] = {.lex_state = 344, .external_lex_state = 3},
  [76] = {.lex_state = 344, .external_lex_state = 3},
  [77] = {.lex_state = 344, .external_lex_state = 4},
  [78] = {.lex_state = 344, .external_lex_state = 4},
  [79] = {.lex_state = 344, .external_lex_state = 3},
  [80] = {.lex_state = 344, .external_lex_state = 4},
  [81] = {.lex_state = 344, .external_lex_state = 3},
  [82] = {.lex_state = 344, .external_lex_state = 3},
  [83] = {.lex_state = 344, .external_lex_state = 3},
  [84] = {.lex_state = 344, .external_lex_state = 3},
  [85] = {.lex_state = 78, .external_lex_state = 3},
  [86] = {.lex_state = 344, .external_lex_state = 3},
  [87] = {.lex_state = 344, .external_lex_state = 4},
  [88] = {.lex_state = 344, .external_lex_state = 3},
  [89] = {.lex_state = 344, .external_lex_state = 5},
  [90] = {.lex_state = 344, .external_lex_state = 3},
  [91] = {.lex_state = 344, .external_lex_state = 3},
  [92] = {.lex_state = 344, .external_lex_state = 4},
  [93] = {.lex_state = 344, .external_lex_state = 3},
  [94] = {.lex_state = 344, .external_lex_state = 4},
  [95] = {.lex_state = 107, .external_lex_state = 3},
  [96] = {.lex_state = 78, .external_lex_state = 3},
  [97] = {.lex_state = 344, .external_lex_state = 3},
  [98] = {.lex_state = 344, .external_lex_state = 4},
  [99] = {.lex_state = 78, .external_lex_state = 3},
  [100] = {.lex_state = 344, .external_lex_state = 3},
  [101] = {.lex_state = 78, .external_lex_state = 3},
  [102] = {.lex_state = 344, .external_lex_state = 3},
  [103] = {.lex_state = 344, .external_lex_state = 3},
  [104] = {.lex_state = 344, .external_lex_state = 5},
  [105] = {.lex_state = 344, .external_lex_state = 4},
  [106] = {.lex_state = 344, .external_lex_state = 3},
  [107] = {.lex_state = 107, .external_lex_state = 3},
  [108] = {.lex_state = 344, .external_lex_state = 5},
  [109] = {.lex_state = 344, .external_lex_state = 5},
  [110] = {.lex_state = 344, .external_lex_state = 4},
  [111] = {.lex_state = 344, .external_lex_state = 4},
  [112] = {.lex_state = 344, .external_lex_state = 3},
  [113] = {.lex_state = 107, .external_lex_state = 3},
  [114] = {.lex_state = 344, .external_lex_state = 5},
  [115] = {.lex_state = 107, .external_lex_state = 3},
  [116] = {.lex_state = 78, .external_lex_state = 3},
  [117] = {.lex_state = 107, .external_lex_state = 3},
  [118] = {.lex_state = 107, .external_lex_state = 3},
  [119] = {.lex_state = 107, .external_lex_state = 3},
  [120] = {.lex_state = 344, .external_lex_state = 3},
  [121] = {.lex_state = 78, .external_lex_state = 3},
  [122] = {.lex_state = 344, .external_lex_state = 3},
  [123] = {.lex_state = 344, .external_lex_state = 4},
  [124] = {.lex_state = 344, .external_lex_state = 4},
  [125] = {.lex_state = 107, .external_lex_state = 3},
  [126] = {.lex_state = 344, .external_lex_state = 4},
  [127] = {.lex_state = 344, .external_lex_state = 4},
  [128] = {.lex_state = 344, .external_lex_state = 4},
  [129] = {.lex_state = 107, .external_lex_state = 3},
  [130] = {.lex_state = 344, .external_lex_state = 3},
  [131] = {.lex_state = 107, .external_lex_state = 3},
  [132] = {.lex_state = 344, .external_lex_state = 4},
  [133] = {.lex_state = 344, .external_lex_state = 4},
  [134] = {.lex_state = 344, .external_lex_state = 5},
  [135] = {.lex_state = 78, .external_lex_state = 3},
  [136] = {.lex_state = 344, .external_lex_state = 4},
  [137] = {.lex_state = 344, .external_lex_state = 5},
  [138] = {.lex_state = 344, .external_lex_state = 4},
  [139] = {.lex_state = 344, .external_lex_state = 5},
  [140] = {.lex_state = 344, .external_lex_state = 5},
  [141] = {.lex_state = 344, .external_lex_state = 5},
  [142] = {.lex_state = 344, .external_lex_state = 3},
  [143] = {.lex_state = 344, .external_lex_state = 3},
  [144] = {.lex_state = 344, .external_lex_state = 3},
  [145] = {.lex_state = 344, .external_lex_state = 4},
  [146] = {.lex_state = 344, .external_lex_state = 5},
  [147] = {.lex_state = 78, .external_lex_state = 3},
  [148] = {.lex_state = 78, .external_lex_state = 3},
  [149] = {.lex_state = 344, .external_lex_state = 4},
  [150] = {.lex_state = 347, .external_lex_state = 3},
  [151] = {.lex_state = 344, .external_lex_state = 4},
  [152] = {.lex_state = 344, .external_lex_state = 6},
  [153] = {.lex_state = 109, .external_lex_state = 3},
  [154] = {.lex_state = 344, .external_lex_state = 4},
  [155] = {.lex_state = 344, .external_lex_state = 3},
  [156] = {.lex_state = 344, .external_lex_state = 3},
  [157] = {.lex_state = 344, .external_lex_state = 4},
  [158] = {.lex_state = 78, .external_lex_state = 3},
  [159] = {.lex_state = 110, .external_lex_state = 3},
  [160] = {.lex_state = 344, .external_lex_state = 3},
  [161] = {.lex_state = 344, .external_lex_state = 6},
  [162] = {.lex_state = 344, .external_lex_state = 4},
  [163] = {.lex_state = 347, .external_lex_state = 3},
  [164] = {.lex_state = 347, .external_lex_state = 3},
  [165] = {.lex_state = 347, .external_lex_state = 3},
  [166] = {.lex_state = 344, .external_lex_state = 4},
  [167] = {.lex_state = 347, .external_lex_state = 3},
  [168] = {.lex_state = 344, .external_lex_state = 3},
  [169] = {.lex_state = 109, .external_lex_state = 3},
  [170] = {.lex_state = 344, .external_lex_state = 4},
  [171] = {.lex_state = 344, .external_lex_state = 3},
  [172] = {.lex_state = 110, .external_lex_state = 3},
  [173] = {.lex_state = 344, .external_lex_state = 3},
  [174] = {.lex_state = 110, .external_lex_state = 3},
  [175] = {.lex_state = 109, .external_lex_state = 3},
  [176] = {.lex_state = 344, .external_lex_state = 4},
  [177] = {.lex_state = 344, .external_lex_state = 4},
  [178] = {.lex_state = 344, .external_lex_state = 4},
  [179] = {.lex_state = 109, .external_lex_state = 3},
  [180] = {.lex_state = 109, .external_lex_state = 3},
  [181] = {.lex_state = 347, .external_lex_state = 3},
  [182] = {.lex_state = 109, .external_lex_state = 3},
  [183] = {.lex_state = 109, .external_lex_state = 3},
  [184] = {.lex_state = 347, .external_lex_state = 3},
  [185] = {.lex_state = 78, .external_lex_state = 3},
  [186] = {.lex_state = 109, .external_lex_state = 3},
  [187] = {.lex_state = 344, .external_lex_state = 3},
  [188] = {.lex_state = 347, .external_lex_state = 3},
  [189] = {.lex_state = 344, .external_lex_state = 4},
  [190] = {.lex_state = 109, .external_lex_state = 3},
  [191] = {.lex_state = 344, .external_lex_state = 4},
  [192] = {.lex_state = 103, .external_lex_state = 3},
  [193] = {.lex_state = 78, .external_lex_state = 3},
  [194] = {.lex_state = 103, .external_lex_state = 3},
  [195] = {.lex_state = 344, .external_lex_state = 4},
  [196] = {.lex_state = 344, .external_lex_state = 3},
  [197] = {.lex_state = 109, .external_lex_state = 3},
  [198] = {.lex_state = 344, .external_lex_state = 4},
  [199] = {.lex_state = 110, .external_lex_state = 3},
  [200] = {.lex_state = 109, .external_lex_state = 3},
  [201] = {.lex_state = 109, .external_lex_state = 3},
  [202] = {.lex_state = 103, .external_lex_state = 3},
  [203] = {.lex_state = 347, .external_lex_state = 3},
  [204] = {.lex_state = 344, .external_lex_state = 4},
  [205] = {.lex_state = 344, .external_lex_state = 4},
  [206] = {.lex_state = 344, .external_lex_state = 4},
  [207] = {.lex_state = 344, .external_lex_state = 4},
  [208] = {.lex_state = 78, .external_lex_state = 3},
  [209] = {.lex_state = 344, .external_lex_state = 4},
  [210] = {.lex_state = 347, .external_lex_state = 3},
  [211] = {.lex_state = 347, .external_lex_state = 3},
  [212] = {.lex_state = 344, .external_lex_state = 4},
  [213] = {.lex_state = 109, .external_lex_state = 3},
  [214] = {.lex_state = 344, .external_lex_state = 4},
  [215] = {.lex_state = 109, .external_lex_state = 3},
  [216] = {.lex_state = 110, .external_lex_state = 3},
  [217] = {.lex_state = 344, .external_lex_state = 3},
  [218] = {.lex_state = 344, .external_lex_state = 4},
  [219] = {.lex_state = 344, .external_lex_state = 4},
  [220] = {.lex_state = 344, .external_lex_state = 4},
  [221] = {.lex_state = 344, .external_lex_state = 4},
  [222] = {.lex_state = 78, .external_lex_state = 3},
  [223] = {.lex_state = 344, .external_lex_state = 3},
  [224] = {.lex_state = 344, .external_lex_state = 4},
  [225] = {.lex_state = 344, .external_lex_state = 4},
  [226] = {.lex_state = 344, .external_lex_state = 4},
  [227] = {.lex_state = 110, .external_lex_state = 3},
  [228] = {.lex_state = 344, .external_lex_state = 3},
  [229] = {.lex_state = 78, .external_lex_state = 3},
  [230] = {.lex_state = 344, .external_lex_state = 4},
  [231] = {.lex_state = 344, .external_lex_state = 4},
  [232] = {.lex_state = 344, .external_lex_state = 4},
  [233] = {.lex_state = 347, .external_lex_state = 3},
  [234] = {.lex_state = 109, .external_lex_state = 3},
  [235] = {.lex_state = 344, .external_lex_state = 3},
  [236] = {.lex_state = 110, .external_lex_state = 3},
  [237] = {.lex_state = 78, .external_lex_state = 3},
  [238] = {.lex_state = 344, .external_lex_state = 3},
  [239] = {.lex_state = 347, .external_lex_state = 3},
  [240] = {.lex_state = 347, .external_lex_state = 3},
  [241] = {.lex_state = 344, .external_lex_state = 3},
  [242] = {.lex_state = 344, .external_lex_state = 4},
  [243] = {.lex_state = 344, .external_lex_state = 4},
  [244] = {.lex_state = 344, .external_lex_state = 4},
  [245] = {.lex_state = 110, .external_lex_state = 3},
  [246] = {.lex_state = 110, .external_lex_state = 3},
  [247] = {.lex_state = 110, .external_lex_state = 3},
  [248] = {.lex_state = 344, .external_lex_state = 3},
  [249] = {.lex_state = 78, .external_lex_state = 3},
  [250] = {.lex_state = 103, .external_lex_state = 3},
  [251] = {.lex_state = 103, .external_lex_state = 3},
  [252] = {.lex_state = 344, .external_lex_state = 4},
  [253] = {.lex_state = 78, .external_lex_state = 3},
  [254] = {.lex_state = 344, .external_lex_state = 4},
  [255] = {.lex_state = 78, .external_lex_state = 3},
  [256] = {.lex_state = 344, .external_lex_state = 4},
  [257] = {.lex_state = 344, .external_lex_state = 3},
  [258] = {.lex_state = 103, .external_lex_state = 3},
  [259] = {.lex_state = 347, .external_lex_state = 3},
  [260] = {.lex_state = 344, .external_lex_state = 3},
  [261] = {.lex_state = 110, .external_lex_state = 3},
  [262] = {.lex_state = 103, .external_lex_state = 3},
  [263] = {.lex_state = 103, .external_lex_state = 3},
  [264] = {.lex_state = 78, .external_lex_state = 3},
  [265] = {.lex_state = 347, .external_lex_state = 3},
  [266] = {.lex_state = 109, .external_lex_state = 3},
  [267] = {.lex_state = 344, .external_lex_state = 4},
  [268] = {.lex_state = 110, .external_lex_state = 3},
  [269] = {.lex_state = 109, .external_lex_state = 3},
  [270] = {.lex_state = 344, .external_lex_state = 3},
  [271] = {.lex_state = 110, .external_lex_state = 3},
  [272] = {.lex_state = 344, .external_lex_state = 4},
  [273] = {.lex_state = 344, .external_lex_state = 4},
  [274] = {.lex_state = 103, .external_lex_state = 3},
  [275] = {.lex_state = 344, .external_lex_state = 4},
  [276] = {.lex_state = 347, .external_lex_state = 3},
  [277] = {.lex_state = 110, .external_lex_state = 3},
  [278] = {.lex_state = 344, .external_lex_state = 3},
  [279] = {.lex_state = 344, .external_lex_state = 4},
  [280] = {.lex_state = 78, .external_lex_state = 3},
  [281] = {.lex_state = 344, .external_lex_state = 4},
  [282] = {.lex_state = 347, .external_lex_state = 3},
  [283] = {.lex_state = 344, .external_lex_state = 4},
  [284] = {.lex_state = 344, .external_lex_state = 6},
  [285] = {.lex_state = 344, .external_lex_state = 6},
  [286] = {.lex_state = 344, .external_lex_state = 4},
  [287] = {.lex_state = 344, .external_lex_state = 4},
  [288] = {.lex_state = 344, .external_lex_state = 6},
  [289] = {.lex_state = 347, .external_lex_state = 3},
  [290] = {.lex_state = 347, .external_lex_state = 3},
  [291] = {.lex_state = 344, .external_lex_state = 4},
  [292] = {.lex_state = 78, .external_lex_state = 3},
  [293] = {.lex_state = 344, .external_lex_state = 4},
  [294] = {.lex_state = 347, .external_lex_state = 3},
  [295] = {.lex_state = 344, .external_lex_state = 4},
  [296] = {.lex_state = 78, .external_lex_state = 3},
  [297] = {.lex_state = 344, .external_lex_state = 3},
  [298] = {.lex_state = 110, .external_lex_state = 3},
  [299] = {.lex_state = 109, .external_lex_state = 3},
  [300] = {.lex_state = 347, .external_lex_state = 3},
  [301] = {.lex_state = 344, .external_lex_state = 4},
  [302] = {.lex_state = 344, .external_lex_state = 6},
  [303] = {.lex_state = 109, .external_lex_state = 3},
  [304] = {.lex_state = 344, .external_lex_state = 4},
  [305] = {.lex_state = 344, .external_lex_state = 3},
  [306] = {.lex_state = 110, .external_lex_state = 3},
  [307] = {.lex_state = 344, .external_lex_state = 4},
  [308] = {.lex_state = 109, .external_lex_state = 3},
  [309] = {.lex_state = 78, .external_lex_state = 3},
  [310] = {.lex_state = 110, .external_lex_state = 3},
  [311] = {.lex_state = 344, .external_lex_state = 3},
  [312] = {.lex_state = 344, .external_lex_state = 3},
  [313] = {.lex_state = 78, .external_lex_state = 3},
  [314] = {.lex_state = 344, .external_lex_state = 4},
  [315] = {.lex_state = 344, .external_lex_state = 4},
  [316] = {.lex_state = 344, .external_lex_state = 4},
  [317] = {.lex_state = 110, .external_lex_state = 3},
  [318] = {.lex_state = 109, .external_lex_state = 3},
  [319] = {.lex_state = 344, .external_lex_state = 3},
  [320] = {.lex_state = 344, .external_lex_state = 4},
  [321] = {.lex_state = 78, .external_lex_state = 3},
  [322] = {.lex_state = 344, .external_lex_state = 6},
  [323] = {.lex_state = 344, .external_lex_state = 4},
  [324] = {.lex_state = 347, .external_lex_state = 3},
  [325] = {.lex_state = 344, .external_lex_state = 3},
  [326] = {.lex_state = 344, .external_lex_state = 3},
  [327] = {.lex_state = 103, .external_lex_state = 3},
  [328] = {.lex_state = 110, .external_lex_state = 3},
  [329] = {.lex_state = 78, .external_lex_state = 3},
  [330] = {.lex_state = 344, .external_lex_state = 4},
  [331] = {.lex_state = 109, .external_lex_state = 3},
  [332] = {.lex_state = 78, .external_lex_state = 3},
  [333] = {.lex_state = 344, .external_lex_state = 4},
  [334] = {.lex_state = 78, .external_lex_state = 3},
  [335] = {.lex_state = 78, .external_lex_state = 3},
  [336] = {.lex_state = 110, .external_lex_state = 3},
  [337] = {.lex_state = 344, .external_lex_state = 3},
  [338] = {.lex_state = 344, .external_lex_state = 3},
  [339] = {.lex_state = 344, .external_lex_state = 3},
  [340] = {.lex_state = 344, .external_lex_state = 4},
  [341] = {.lex_state = 344, .external_lex_state = 4},
  [342] = {.lex_state = 344, .external_lex_state = 4},
  [343] = {.lex_state = 344, .external_lex_state = 4},
  [344] = {.lex_state = 344, .external_lex_state = 4},
  [345] = {.lex_state = 110, .external_lex_state = 3},
  [346] = {.lex_state = 344, .external_lex_state = 4},
  [347] = {.lex_state = 110, .external_lex_state = 3},
  [348] = {.lex_state = 344, .external_lex_state = 3},
  [349] = {.lex_state = 78, .external_lex_state = 3},
  [350] = {.lex_state = 344, .external_lex_state = 6},
  [351] = {.lex_state = 344, .external_lex_state = 6},
  [352] = {.lex_state = 347, .external_lex_state = 3},
  [353] = {.lex_state = 344, .external_lex_state = 3},
  [354] = {.lex_state = 347, .external_lex_state = 3},
  [355] = {.lex_state = 344, .external_lex_state = 6},
  [356] = {.lex_state = 344, .external_lex_state = 6},
  [357] = {.lex_state = 344, .external_lex_state = 6},
  [358] = {.lex_state = 347, .external_lex_state = 3},
  [359] = {.lex_state = 344, .external_lex_state = 3},
  [360] = {.lex_state = 344, .external_lex_state = 3},
  [361] = {.lex_state = 344, .external_lex_state = 3},
  [362] = {.lex_state = 344, .external_lex_state = 3},
  [363] = {.lex_state = 344, .external_lex_state = 3},
  [364] = {.lex_state = 344, .external_lex_state = 3},
  [365] = {.lex_state = 344, .external_lex_state = 3},
  [366] = {.lex_state = 344, .external_lex_state = 3},
  [367] = {.lex_state = 344, .external_lex_state = 3},
  [368] = {.lex_state = 344, .external_lex_state = 3},
  [369] = {.lex_state = 344, .external_lex_state = 3},
  [370] = {.lex_state = 344, .external_lex_state = 3},
  [371] = {.lex_state = 344, .external_lex_state = 3},
  [372] = {.lex_state = 344, .external_lex_state = 3},
  [373] = {.lex_state = 344, .external_lex_state = 3},
  [374] = {.lex_state = 344, .external_lex_state = 3},
  [375] = {.lex_state = 344, .external_lex_state = 3},
  [376] = {.lex_state = 344, .external_lex_state = 3},
  [377] = {.lex_state = 344, .external_lex_state = 3},
  [378] = {.lex_state = 344, .external_lex_state = 3},
  [379] = {.lex_state = 344, .external_lex_state = 3},
  [380] = {.lex_state = 344, .external_lex_state = 3},
  [381] = {.lex_state = 344, .external_lex_state = 3},
  [382] = {.lex_state = 344, .external_lex_state = 3},
  [383] = {.lex_state = 344, .external_lex_state = 3},
  [384] = {.lex_state = 344, .external_lex_state = 3},
  [385] = {.lex_state = 344, .external_lex_state = 3},
  [386] = {.lex_state = 353, .external_lex_state = 5},
  [387] = {.lex_state = 353, .external_lex_state = 5},
  [388] = {.lex_state = 353, .external_lex_state = 5},
  [389] = {.lex_state = 353, .external_lex_state = 5},
  [390] = {.lex_state = 353, .external_lex_state = 2},
  [391] = {.lex_state = 353, .external_lex_state = 2},
  [392] = {.lex_state = 353, .external_lex_state = 2},
  [393] = {.lex_state = 353, .external_lex_state = 2},
  [394] = {.lex_state = 353, .external_lex_state = 2},
  [395] = {.lex_state = 353, .external_lex_state = 2},
  [396] = {.lex_state = 353, .external_lex_state = 2},
  [397] = {.lex_state = 353, .external_lex_state = 7},
  [398] = {.lex_state = 353, .external_lex_state = 7},
  [399] = {.lex_state = 353, .external_lex_state = 7},
  [400] = {.lex_state = 353, .external_lex_state = 2},
  [401] = {.lex_state = 353, .external_lex_state = 7},
  [402] = {.lex_state = 353, .external_lex_state = 7},
  [403] = {.lex_state = 353, .external_lex_state = 7},
  [404] = {.lex_state = 353, .external_lex_state = 7},
  [405] = {.lex_state = 353, .external_lex_state = 2},
  [406] = {.lex_state = 353, .external_lex_state = 2},
  [407] = {.lex_state = 353, .external_lex_state = 7},
  [408] = {.lex_state = 353, .external_lex_state = 2},
  [409] = {.lex_state = 353, .external_lex_state = 2},
  [410] = {.lex_state = 353, .external_lex_state = 2},
  [411] = {.lex_state = 353, .external_lex_state = 7},
  [412] = {.lex_state = 353, .external_lex_state = 2},
  [413] = {.lex_state = 353, .external_lex_state = 7},
  [414] = {.lex_state = 353, .external_lex_state = 7},
  [415] = {.lex_state = 353, .external_lex_state = 7},
  [416] = {.lex_state = 353, .external_lex_state = 7},
  [417] = {.lex_state = 353, .external_lex_state = 2},
  [418] = {.lex_state = 353, .external_lex_state = 2},
  [419] = {.lex_state = 353, .external_lex_state = 2},
  [420] = {.lex_state = 353, .external_lex_state = 2},
  [421] = {.lex_state = 353, .external_lex_state = 2},
  [422] = {.lex_state = 353, .external_lex_state = 2},
  [423] = {.lex_state = 353, .external_lex_state = 2},
  [424] = {.lex_state = 353, .external_lex_state = 2},
  [425] = {.lex_state = 353, .external_lex_state = 2},
  [426] = {.lex_state = 353, .external_lex_state = 2},
  [427] = {.lex_state = 353, .external_lex_state = 2},
  [428] = {.lex_state = 353, .external_lex_state = 2},
  [429] = {.lex_state = 353, .external_lex_state = 2},
  [430] = {.lex_state = 353, .external_lex_state = 2},
  [431] = {.lex_state = 353, .external_lex_state = 2},
  [432] = {.lex_state = 353, .external_lex_state = 2},
  [433] = {.lex_state = 353, .external_lex_state = 2},
  [434] = {.lex_state = 353, .external_lex_state = 2},
  [435] = {.lex_state = 353, .external_lex_state = 3},
  [436] = {.lex_state = 354, .external_lex_state = 3},
  [437] = {.lex_state = 143, .external_lex_state = 2},
  [438] = {.lex_state = 143, .external_lex_state = 2},
  [439] = {.lex_state = 354, .external_lex_state = 7},
  [440] = {.lex_state = 354, .external_lex_state = 7},
  [441] = {.lex_state = 354, .external_lex_state = 7},
  [442] = {.lex_state = 353, .external_lex_state = 2},
  [443] = {.lex_state = 354, .external_lex_state = 2},
  [444] = {.lex_state = 354, .external_lex_state = 2},
  [445] = {.lex_state = 354, .external_lex_state = 2},
  [446] = {.lex_state = 354, .external_lex_state = 2},
  [447] = {.lex_state = 354, .external_lex_state = 2},
  [448] = {.lex_state = 353, .external_lex_state = 2},
  [449] = {.lex_state = 354, .external_lex_state = 2},
  [450] = {.lex_state = 354, .external_lex_state = 2},
  [451] = {.lex_state = 354, .external_lex_state = 2},
  [452] = {.lex_state = 353, .external_lex_state = 2},
  [453] = {.lex_state = 353, .external_lex_state = 2},
  [454] = {.lex_state = 354, .external_lex_state = 2},
  [455] = {.lex_state = 353, .external_lex_state = 2},
  [456] = {.lex_state = 354, .external_lex_state = 2},
  [457] = {.lex_state = 353, .external_lex_state = 2},
  [458] = {.lex_state = 353, .external_lex_state = 2},
  [459] = {.lex_state = 353, .external_lex_state = 2},
  [460] = {.lex_state = 354, .external_lex_state = 2},
  [461] = {.lex_state = 354, .external_lex_state = 2},
  [462] = {.lex_state = 353, .external_lex_state = 2},
  [463] = {.lex_state = 353, .external_lex_state = 2},
  [464] = {.lex_state = 354, .external_lex_state = 2},
  [465] = {.lex_state = 353, .external_lex_state = 2},
  [466] = {.lex_state = 353, .external_lex_state = 2},
  [467] = {.lex_state = 353, .external_lex_state = 2},
  [468] = {.lex_state = 354, .external_lex_state = 2},
  [469] = {.lex_state = 354, .external_lex_state = 2},
  [470] = {.lex_state = 353, .external_lex_state = 2},
  [471] = {.lex_state = 354, .external_lex_state = 2},
  [472] = {.lex_state = 354, .external_lex_state = 2},
  [473] = {.lex_state = 353, .external_lex_state = 5},
  [474] = {.lex_state = 353, .external_lex_state = 2},
  [475] = {.lex_state = 353, .external_lex_state = 5},
  [476] = {.lex_state = 353, .external_lex_state = 5},
  [477] = {.lex_state = 353, .external_lex_state = 2},
  [478] = {.lex_state = 353, .external_lex_state = 5},
  [479] = {.lex_state = 353, .external_lex_state = 5},
  [480] = {.lex_state = 353, .external_lex_state = 5},
  [481] = {.lex_state = 353, .external_lex_state = 7},
  [482] = {.lex_state = 353, .external_lex_state = 5},
  [483] = {.lex_state = 353, .external_lex_state = 2},
  [484] = {.lex_state = 353, .external_lex_state = 5},
  [485] = {.lex_state = 353, .external_lex_state = 5},
  [486] = {.lex_state = 353, .external_lex_state = 5},
  [487] = {.lex_state = 353, .external_lex_state = 5},
  [488] = {.lex_state = 353, .external_lex_state = 5},
  [489] = {.lex_state = 353, .external_lex_state = 2},
  [490] = {.lex_state = 353, .external_lex_state = 5},
  [491] = {.lex_state = 353, .external_lex_state = 2},
  [492] = {.lex_state = 353, .external_lex_state = 2},
  [493] = {.lex_state = 353, .external_lex_state = 2},
  [494] = {.lex_state = 353, .external_lex_state = 5},
  [495] = {.lex_state = 353, .external_lex_state = 5},
  [496] = {.lex_state = 353, .external_lex_state = 5},
  [497] = {.lex_state = 353, .external_lex_state = 2},
  [498] = {.lex_state = 353, .external_lex_state = 5},
  [499] = {.lex_state = 353, .external_lex_state = 2},
  [500] = {.lex_state = 353, .external_lex_state = 5},
  [501] = {.lex_state = 353, .external_lex_state = 2},
  [502] = {.lex_state = 353, .external_lex_state = 2},
  [503] = {.lex_state = 353, .external_lex_state = 2},
  [504] = {.lex_state = 353, .external_lex_state = 5},
  [505] = {.lex_state = 353, .external_lex_state = 5},
  [506] = {.lex_state = 353, .external_lex_state = 5},
  [507] = {.lex_state = 353, .external_lex_state = 5},
  [508] = {.lex_state = 353, .external_lex_state = 2},
  [509] = {.lex_state = 353, .external_lex_state = 5},
  [510] = {.lex_state = 353, .external_lex_state = 2},
  [511] = {.lex_state = 353, .external_lex_state = 5},
  [512] = {.lex_state = 353, .external_lex_state = 5},
  [513] = {.lex_state = 353, .external_lex_state = 5},
  [514] = {.lex_state = 353, .external_lex_state = 2},
  [515] = {.lex_state = 353, .external_lex_state = 2},
  [516] = {.lex_state = 353, .external_lex_state = 2},
  [517] = {.lex_state = 353, .external_lex_state = 2},
  [518] = {.lex_state = 353, .external_lex_state = 2},
  [519] = {.lex_state = 353, .external_lex_state = 2},
  [520] = {.lex_state = 353, .external_lex_state = 2},
  [521] = {.lex_state = 353, .external_lex_state = 5},
  [522] = {.lex_state = 353, .external_lex_state = 2},
  [523] = {.lex_state = 353, .external_lex_state = 2},
  [524] = {.lex_state = 353, .external_lex_state = 2},
  [525] = {.lex_state = 353, .external_lex_state = 2},
  [526] = {.lex_state = 353, .external_lex_state = 2},
  [527] = {.lex_state = 353, .external_lex_state = 2},
  [528] = {.lex_state = 353, .external_lex_state = 2},
  [529] = {.lex_state = 353, .external_lex_state = 2},
  [530] = {.lex_state = 353, .external_lex_state = 6},
  [531] = {.lex_state = 353, .external_lex_state = 6},
  [532] = {.lex_state = 353, .external_lex_state = 6},
  [533] = {.lex_state = 353, .external_lex_state = 2},
  [534] = {.lex_state = 353, .external_lex_state = 2},
  [535] = {.lex_state = 353, .external_lex_state = 8},
  [536] = {.lex_state = 353, .external_lex_state = 7},
  [537] = {.lex_state = 353, .external_lex_state = 9},
  [538] = {.lex_state = 353, .external_lex_state = 2},
  [539] = {.lex_state = 353, .external_lex_state = 2},
  [540] = {.lex_state = 353, .external_lex_state = 2},
  [541] = {.lex_state = 353, .external_lex_state = 2},
  [542] = {.lex_state = 353, .external_lex_state = 2},
  [543] = {.lex_state = 353, .external_lex_state = 2},
  [544] = {.lex_state = 353, .external_lex_state = 2},
  [545] = {.lex_state = 353, .external_lex_state = 2},
  [546] = {.lex_state = 353, .external_lex_state = 2},
  [547] = {.lex_state = 353, .external_lex_state = 2},
  [548] = {.lex_state = 353, .external_lex_state = 2},
  [549] = {.lex_state = 353, .external_lex_state = 2},
  [550] = {.lex_state = 353, .external_lex_state = 2},
  [551] = {.lex_state = 353, .external_lex_state = 2},
  [552] = {.lex_state = 353, .external_lex_state = 2},
  [553] = {.lex_state = 353, .external_lex_state = 2},
  [554] = {.lex_state = 353, .external_lex_state = 2},
  [555] = {.lex_state = 353, .external_lex_state = 2},
  [556] = {.lex_state = 353, .external_lex_state = 2},
  [557] = {.lex_state = 353, .external_lex_state = 2},
  [558] = {.lex_state = 353, .external_lex_state = 2},
  [559] = {.lex_state = 353, .external_lex_state = 2},
  [560] = {.lex_state = 353, .external_lex_state = 2},
  [561] = {.lex_state = 353, .external_lex_state = 2},
  [562] = {.lex_state = 353, .external_lex_state = 2},
  [563] = {.lex_state = 353, .external_lex_state = 2},
  [564] = {.lex_state = 353, .external_lex_state = 2},
  [565] = {.lex_state = 353, .external_lex_state = 2},
  [566] = {.lex_state = 353, .external_lex_state = 2},
  [567] = {.lex_state = 353, .external_lex_state = 2},
  [568] = {.lex_state = 353, .external_lex_state = 2},
  [569] = {.lex_state = 353, .external_lex_state = 2},
  [570] = {.lex_state = 353, .external_lex_state = 2},
  [571] = {.lex_state = 353, .external_lex_state = 2},
  [572] = {.lex_state = 353, .external_lex_state = 2},
  [573] = {.lex_state = 353, .external_lex_state = 2},
  [574] = {.lex_state = 353, .external_lex_state = 2},
  [575] = {.lex_state = 353, .external_lex_state = 2},
  [576] = {.lex_state = 353, .external_lex_state = 2},
  [577] = {.lex_state = 353, .external_lex_state = 2},
  [578] = {.lex_state = 353, .external_lex_state = 2},
  [579] = {.lex_state = 353, .external_lex_state = 2},
  [580] = {.lex_state = 353, .external_lex_state = 2},
  [581] = {.lex_state = 353, .external_lex_state = 2},
  [582] = {.lex_state = 353, .external_lex_state = 2},
  [583] = {.lex_state = 353, .external_lex_state = 2},
  [584] = {.lex_state = 353, .external_lex_state = 2},
  [585] = {.lex_state = 353, .external_lex_state = 2},
  [586] = {.lex_state = 353, .external_lex_state = 2},
  [587] = {.lex_state = 353, .external_lex_state = 2},
  [588] = {.lex_state = 353, .external_lex_state = 2},
  [589] = {.lex_state = 353, .external_lex_state = 2},
  [590] = {.lex_state = 353, .external_lex_state = 2},
  [591] = {.lex_state = 353, .external_lex_state = 2},
  [592] = {.lex_state = 353, .external_lex_state = 2},
  [593] = {.lex_state = 353, .external_lex_state = 2},
  [594] = {.lex_state = 353, .external_lex_state = 2},
  [595] = {.lex_state = 353, .external_lex_state = 2},
  [596] = {.lex_state = 353, .external_lex_state = 2},
  [597] = {.lex_state = 353, .external_lex_state = 2},
  [598] = {.lex_state = 353, .external_lex_state = 2},
  [599] = {.lex_state = 353, .external_lex_state = 2},
  [600] = {.lex_state = 353, .external_lex_state = 2},
  [601] = {.lex_state = 353, .external_lex_state = 2},
  [602] = {.lex_state = 353, .external_lex_state = 2},
  [603] = {.lex_state = 353, .external_lex_state = 2},
  [604] = {.lex_state = 353, .external_lex_state = 2},
  [605] = {.lex_state = 353, .external_lex_state = 2},
  [606] = {.lex_state = 353, .external_lex_state = 2},
  [607] = {.lex_state = 353, .external_lex_state = 2},
  [608] = {.lex_state = 353, .external_lex_state = 2},
  [609] = {.lex_state = 353, .external_lex_state = 2},
  [610] = {.lex_state = 353, .external_lex_state = 2},
  [611] = {.lex_state = 353, .external_lex_state = 2},
  [612] = {.lex_state = 353, .external_lex_state = 2},
  [613] = {.lex_state = 353, .external_lex_state = 2},
  [614] = {.lex_state = 353, .external_lex_state = 2},
  [615] = {.lex_state = 353, .external_lex_state = 2},
  [616] = {.lex_state = 353, .external_lex_state = 2},
  [617] = {.lex_state = 353, .external_lex_state = 2},
  [618] = {.lex_state = 353, .external_lex_state = 2},
  [619] = {.lex_state = 353, .external_lex_state = 2},
  [620] = {.lex_state = 353, .external_lex_state = 2},
  [621] = {.lex_state = 353, .external_lex_state = 2},
  [622] = {.lex_state = 353, .external_lex_state = 2},
  [623] = {.lex_state = 353, .external_lex_state = 2},
  [624] = {.lex_state = 353, .external_lex_state = 2},
  [625] = {.lex_state = 353, .external_lex_state = 2},
  [626] = {.lex_state = 353, .external_lex_state = 2},
  [627] = {.lex_state = 353, .external_lex_state = 2},
  [628] = {.lex_state = 353, .external_lex_state = 2},
  [629] = {.lex_state = 353, .external_lex_state = 2},
  [630] = {.lex_state = 353, .external_lex_state = 2},
  [631] = {.lex_state = 353, .external_lex_state = 2},
  [632] = {.lex_state = 353, .external_lex_state = 2},
  [633] = {.lex_state = 353, .external_lex_state = 2},
  [634] = {.lex_state = 353, .external_lex_state = 2},
  [635] = {.lex_state = 353, .external_lex_state = 2},
  [636] = {.lex_state = 353, .external_lex_state = 2},
  [637] = {.lex_state = 353, .external_lex_state = 2},
  [638] = {.lex_state = 353, .external_lex_state = 2},
  [639] = {.lex_state = 353, .external_lex_state = 2},
  [640] = {.lex_state = 353, .external_lex_state = 2},
  [641] = {.lex_state = 353, .external_lex_state = 2},
  [642] = {.lex_state = 353, .external_lex_state = 2},
  [643] = {.lex_state = 353, .external_lex_state = 2},
  [644] = {.lex_state = 353, .external_lex_state = 2},
  [645] = {.lex_state = 353, .external_lex_state = 2},
  [646] = {.lex_state = 353, .external_lex_state = 2},
  [647] = {.lex_state = 353, .external_lex_state = 2},
  [648] = {.lex_state = 353, .external_lex_state = 2},
  [649] = {.lex_state = 353, .external_lex_state = 2},
  [650] = {.lex_state = 353, .external_lex_state = 2},
  [651] = {.lex_state = 353, .external_lex_state = 2},
  [652] = {.lex_state = 353, .external_lex_state = 2},
  [653] = {.lex_state = 353, .external_lex_state = 2},
  [654] = {.lex_state = 353, .external_lex_state = 2},
  [655] = {.lex_state = 353, .external_lex_state = 2},
  [656] = {.lex_state = 353, .external_lex_state = 2},
  [657] = {.lex_state = 353, .external_lex_state = 2},
  [658] = {.lex_state = 353, .external_lex_state = 2},
  [659] = {.lex_state = 353, .external_lex_state = 2},
  [660] = {.lex_state = 353, .external_lex_state = 2},
  [661] = {.lex_state = 353, .external_lex_state = 2},
  [662] = {.lex_state = 353, .external_lex_state = 2},
  [663] = {.lex_state = 353, .external_lex_state = 2},
  [664] = {.lex_state = 353, .external_lex_state = 2},
  [665] = {.lex_state = 353, .external_lex_state = 2},
  [666] = {.lex_state = 353, .external_lex_state = 2},
  [667] = {.lex_state = 353, .external_lex_state = 2},
  [668] = {.lex_state = 353, .external_lex_state = 2},
  [669] = {.lex_state = 353, .external_lex_state = 2},
  [670] = {.lex_state = 353, .external_lex_state = 2},
  [671] = {.lex_state = 353, .external_lex_state = 2},
  [672] = {.lex_state = 353, .external_lex_state = 2},
  [673] = {.lex_state = 353, .external_lex_state = 2},
  [674] = {.lex_state = 353, .external_lex_state = 2},
  [675] = {.lex_state = 353, .external_lex_state = 2},
  [676] = {.lex_state = 353, .external_lex_state = 2},
  [677] = {.lex_state = 353, .external_lex_state = 2},
  [678] = {.lex_state = 353, .external_lex_state = 2},
  [679] = {.lex_state = 353, .external_lex_state = 2},
  [680] = {.lex_state = 353, .external_lex_state = 2},
  [681] = {.lex_state = 353, .external_lex_state = 2},
  [682] = {.lex_state = 353, .external_lex_state = 2},
  [683] = {.lex_state = 353, .external_lex_state = 2},
  [684] = {.lex_state = 353, .external_lex_state = 2},
  [685] = {.lex_state = 353, .external_lex_state = 2},
  [686] = {.lex_state = 353, .external_lex_state = 2},
  [687] = {.lex_state = 353, .external_lex_state = 2},
  [688] = {.lex_state = 353, .external_lex_state = 2},
  [689] = {.lex_state = 353, .external_lex_state = 2},
  [690] = {.lex_state = 353, .external_lex_state = 2},
  [691] = {.lex_state = 353, .external_lex_state = 2},
  [692] = {.lex_state = 353, .external_lex_state = 2},
  [693] = {.lex_state = 353, .external_lex_state = 2},
  [694] = {.lex_state = 353, .external_lex_state = 2},
  [695] = {.lex_state = 353, .external_lex_state = 2},
  [696] = {.lex_state = 353, .external_lex_state = 2},
  [697] = {.lex_state = 353, .external_lex_state = 2},
  [698] = {.lex_state = 353, .external_lex_state = 2},
  [699] = {.lex_state = 353, .external_lex_state = 2},
  [700] = {.lex_state = 353, .external_lex_state = 2},
  [701] = {.lex_state = 353, .external_lex_state = 2},
  [702] = {.lex_state = 353, .external_lex_state = 2},
  [703] = {.lex_state = 353, .external_lex_state = 2},
  [704] = {.lex_state = 353, .external_lex_state = 2},
  [705] = {.lex_state = 353, .external_lex_state = 2},
  [706] = {.lex_state = 353, .external_lex_state = 2},
  [707] = {.lex_state = 353, .external_lex_state = 2},
  [708] = {.lex_state = 353, .external_lex_state = 2},
  [709] = {.lex_state = 353, .external_lex_state = 2},
  [710] = {.lex_state = 353, .external_lex_state = 2},
  [711] = {.lex_state = 353, .external_lex_state = 2},
  [712] = {.lex_state = 353, .external_lex_state = 2},
  [713] = {.lex_state = 353, .external_lex_state = 2},
  [714] = {.lex_state = 353, .external_lex_state = 2},
  [715] = {.lex_state = 353, .external_lex_state = 2},
  [716] = {.lex_state = 353, .external_lex_state = 2},
  [717] = {.lex_state = 353, .external_lex_state = 2},
  [718] = {.lex_state = 353, .external_lex_state = 2},
  [719] = {.lex_state = 353, .external_lex_state = 2},
  [720] = {.lex_state = 353, .external_lex_state = 2},
  [721] = {.lex_state = 353, .external_lex_state = 2},
  [722] = {.lex_state = 353, .external_lex_state = 2},
  [723] = {.lex_state = 353, .external_lex_state = 2},
  [724] = {.lex_state = 353, .external_lex_state = 2},
  [725] = {.lex_state = 353, .external_lex_state = 2},
  [726] = {.lex_state = 353, .external_lex_state = 2},
  [727] = {.lex_state = 353, .external_lex_state = 2},
  [728] = {.lex_state = 353, .external_lex_state = 2},
  [729] = {.lex_state = 353, .external_lex_state = 2},
  [730] = {.lex_state = 353, .external_lex_state = 2},
  [731] = {.lex_state = 353, .external_lex_state = 2},
  [732] = {.lex_state = 353, .external_lex_state = 2},
  [733] = {.lex_state = 353, .external_lex_state = 2},
  [734] = {.lex_state = 353, .external_lex_state = 2},
  [735] = {.lex_state = 353, .external_lex_state = 2},
  [736] = {.lex_state = 353, .external_lex_state = 2},
  [737] = {.lex_state = 353, .external_lex_state = 2},
  [738] = {.lex_state = 353, .external_lex_state = 2},
  [739] = {.lex_state = 353, .external_lex_state = 2},
  [740] = {.lex_state = 353, .external_lex_state = 2},
  [741] = {.lex_state = 353, .external_lex_state = 2},
  [742] = {.lex_state = 353, .external_lex_state = 2},
  [743] = {.lex_state = 353, .external_lex_state = 2},
  [744] = {.lex_state = 353, .external_lex_state = 2},
  [745] = {.lex_state = 353, .external_lex_state = 2},
  [746] = {.lex_state = 353, .external_lex_state = 2},
  [747] = {.lex_state = 353, .external_lex_state = 2},
  [748] = {.lex_state = 353, .external_lex_state = 2},
  [749] = {.lex_state = 353, .external_lex_state = 2},
  [750] = {.lex_state = 353, .external_lex_state = 2},
  [751] = {.lex_state = 353, .external_lex_state = 2},
  [752] = {.lex_state = 353, .external_lex_state = 2},
  [753] = {.lex_state = 353, .external_lex_state = 2},
  [754] = {.lex_state = 353, .external_lex_state = 2},
  [755] = {.lex_state = 353, .external_lex_state = 2},
  [756] = {.lex_state = 353, .external_lex_state = 2},
  [757] = {.lex_state = 353, .external_lex_state = 2},
  [758] = {.lex_state = 353, .external_lex_state = 2},
  [759] = {.lex_state = 353, .external_lex_state = 2},
  [760] = {.lex_state = 353, .external_lex_state = 2},
  [761] = {.lex_state = 353, .external_lex_state = 2},
  [762] = {.lex_state = 353, .external_lex_state = 2},
  [763] = {.lex_state = 353, .external_lex_state = 2},
  [764] = {.lex_state = 353, .external_lex_state = 2},
  [765] = {.lex_state = 353, .external_lex_state = 2},
  [766] = {.lex_state = 353, .external_lex_state = 2},
  [767] = {.lex_state = 353, .external_lex_state = 2},
  [768] = {.lex_state = 353, .external_lex_state = 2},
  [769] = {.lex_state = 353, .external_lex_state = 2},
  [770] = {.lex_state = 353, .external_lex_state = 2},
  [771] = {.lex_state = 353, .external_lex_state = 2},
  [772] = {.lex_state = 353, .external_lex_state = 2},
  [773] = {.lex_state = 353, .external_lex_state = 2},
  [774] = {.lex_state = 353, .external_lex_state = 2},
  [775] = {.lex_state = 353, .external_lex_state = 2},
  [776] = {.lex_state = 353, .external_lex_state = 2},
  [777] = {.lex_state = 353, .external_lex_state = 2},
  [778] = {.lex_state = 353, .external_lex_state = 2},
  [779] = {.lex_state = 353, .external_lex_state = 2},
  [780] = {.lex_state = 353, .external_lex_state = 2},
  [781] = {.lex_state = 353, .external_lex_state = 2},
  [782] = {.lex_state = 353, .external_lex_state = 2},
  [783] = {.lex_state = 353, .external_lex_state = 2},
  [784] = {.lex_state = 353, .external_lex_state = 2},
  [785] = {.lex_state = 353, .external_lex_state = 2},
  [786] = {.lex_state = 353, .external_lex_state = 2},
  [787] = {.lex_state = 353, .external_lex_state = 2},
  [788] = {.lex_state = 353, .external_lex_state = 2},
  [789] = {.lex_state = 353, .external_lex_state = 2},
  [790] = {.lex_state = 353, .external_lex_state = 2},
  [791] = {.lex_state = 353, .external_lex_state = 2},
  [792] = {.lex_state = 353, .external_lex_state = 2},
  [793] = {.lex_state = 353, .external_lex_state = 2},
  [794] = {.lex_state = 353, .external_lex_state = 2},
  [795] = {.lex_state = 353, .external_lex_state = 2},
  [796] = {.lex_state = 353, .external_lex_state = 2},
  [797] = {.lex_state = 353, .external_lex_state = 2},
  [798] = {.lex_state = 353, .external_lex_state = 2},
  [799] = {.lex_state = 353, .external_lex_state = 2},
  [800] = {.lex_state = 353, .external_lex_state = 2},
  [801] = {.lex_state = 353, .external_lex_state = 2},
  [802] = {.lex_state = 353, .external_lex_state = 2},
  [803] = {.lex_state = 353, .external_lex_state = 2},
  [804] = {.lex_state = 353, .external_lex_state = 2},
  [805] = {.lex_state = 353, .external_lex_state = 2},
  [806] = {.lex_state = 353, .external_lex_state = 2},
  [807] = {.lex_state = 353, .external_lex_state = 2},
  [808] = {.lex_state = 353, .external_lex_state = 2},
  [809] = {.lex_state = 353, .external_lex_state = 2},
  [810] = {.lex_state = 353, .external_lex_state = 2},
  [811] = {.lex_state = 353, .external_lex_state = 2},
  [812] = {.lex_state = 353, .external_lex_state = 2},
  [813] = {.lex_state = 353, .external_lex_state = 2},
  [814] = {.lex_state = 353, .external_lex_state = 2},
  [815] = {.lex_state = 353, .external_lex_state = 2},
  [816] = {.lex_state = 353, .external_lex_state = 2},
  [817] = {.lex_state = 353, .external_lex_state = 2},
  [818] = {.lex_state = 353, .external_lex_state = 2},
  [819] = {.lex_state = 353, .external_lex_state = 2},
  [820] = {.lex_state = 353, .external_lex_state = 2},
  [821] = {.lex_state = 353, .external_lex_state = 2},
  [822] = {.lex_state = 353, .external_lex_state = 2},
  [823] = {.lex_state = 353, .external_lex_state = 2},
  [824] = {.lex_state = 353, .external_lex_state = 2},
  [825] = {.lex_state = 353, .external_lex_state = 2},
  [826] = {.lex_state = 353, .external_lex_state = 2},
  [827] = {.lex_state = 353, .external_lex_state = 2},
  [828] = {.lex_state = 353, .external_lex_state = 2},
  [829] = {.lex_state = 353, .external_lex_state = 2},
  [830] = {.lex_state = 353, .external_lex_state = 2},
  [831] = {.lex_state = 353, .external_lex_state = 2},
  [832] = {.lex_state = 353, .external_lex_state = 2},
  [833] = {.lex_state = 353, .external_lex_state = 2},
  [834] = {.lex_state = 353, .external_lex_state = 2},
  [835] = {.lex_state = 353, .external_lex_state = 2},
  [836] = {.lex_state = 353, .external_lex_state = 2},
  [837] = {.lex_state = 353, .external_lex_state = 2},
  [838] = {.lex_state = 353, .external_lex_state = 2},
  [839] = {.lex_state = 353, .external_lex_state = 2},
  [840] = {.lex_state = 353, .external_lex_state = 2},
  [841] = {.lex_state = 353, .external_lex_state = 2},
  [842] = {.lex_state = 353, .external_lex_state = 2},
  [843] = {.lex_state = 353, .external_lex_state = 2},
  [844] = {.lex_state = 353, .external_lex_state = 2},
  [845] = {.lex_state = 353, .external_lex_state = 2},
  [846] = {.lex_state = 353, .external_lex_state = 2},
  [847] = {.lex_state = 353, .external_lex_state = 2},
  [848] = {.lex_state = 353, .external_lex_state = 2},
  [849] = {.lex_state = 353, .external_lex_state = 2},
  [850] = {.lex_state = 353, .external_lex_state = 2},
  [851] = {.lex_state = 353, .external_lex_state = 2},
  [852] = {.lex_state = 353, .external_lex_state = 2},
  [853] = {.lex_state = 353, .external_lex_state = 2},
  [854] = {.lex_state = 353, .external_lex_state = 2},
  [855] = {.lex_state = 353, .external_lex_state = 2},
  [856] = {.lex_state = 353, .external_lex_state = 2},
  [857] = {.lex_state = 353, .external_lex_state = 2},
  [858] = {.lex_state = 353, .external_lex_state = 2},
  [859] = {.lex_state = 353, .external_lex_state = 2},
  [860] = {.lex_state = 353, .external_lex_state = 2},
  [861] = {.lex_state = 353, .external_lex_state = 2},
  [862] = {.lex_state = 353, .external_lex_state = 2},
  [863] = {.lex_state = 353, .external_lex_state = 2},
  [864] = {.lex_state = 346, .external_lex_state = 3},
  [865] = {.lex_state = 346, .external_lex_state = 3},
  [866] = {.lex_state = 341, .external_lex_state = 3},
  [867] = {.lex_state = 346, .external_lex_state = 4},
  [868] = {.lex_state = 346, .external_lex_state = 3},
  [869] = {.lex_state = 341, .external_lex_state = 3},
  [870] = {.lex_state = 341, .external_lex_state = 4},
  [871] = {.lex_state = 82, .external_lex_state = 4},
  [872] = {.lex_state = 341, .external_lex_state = 3},
  [873] = {.lex_state = 82, .external_lex_state = 3},
  [874] = {.lex_state = 346, .external_lex_state = 5},
  [875] = {.lex_state = 80, .external_lex_state = 3},
  [876] = {.lex_state = 80, .external_lex_state = 4},
  [877] = {.lex_state = 346, .external_lex_state = 4},
  [878] = {.lex_state = 74, .external_lex_state = 3},
  [879] = {.lex_state = 340, .external_lex_state = 3},
  [880] = {.lex_state = 340, .external_lex_state = 3},
  [881] = {.lex_state = 90, .external_lex_state = 4},
  [882] = {.lex_state = 340, .external_lex_state = 3},
  [883] = {.lex_state = 73, .external_lex_state = 3},
  [884] = {.lex_state = 102, .external_lex_state = 3},
  [885] = {.lex_state = 83, .external_lex_state = 3},
  [886] = {.lex_state = 340, .external_lex_state = 3},
  [887] = {.lex_state = 341, .external_lex_state = 4},
  [888] = {.lex_state = 81, .external_lex_state = 3},
  [889] = {.lex_state = 84, .external_lex_state = 3},
  [890] = {.lex_state = 340, .external_lex_state = 3},
  [891] = {.lex_state = 346, .external_lex_state = 6},
  [892] = {.lex_state = 90, .external_lex_state = 3},
  [893] = {.lex_state = 75, .external_lex_state = 3},
  [894] = {.lex_state = 341, .external_lex_state = 5},
  [895] = {.lex_state = 86, .external_lex_state = 3},
  [896] = {.lex_state = 340, .external_lex_state = 3},
  [897] = {.lex_state = 98, .external_lex_state = 3},
  [898] = {.lex_state = 340, .external_lex_state = 3},
  [899] = {.lex_state = 104, .external_lex_state = 3},
  [900] = {.lex_state = 340, .external_lex_state = 3},
  [901] = {.lex_state = 340, .external_lex_state = 3},
  [902] = {.lex_state = 340, .external_lex_state = 3},
  [903] = {.lex_state = 340, .external_lex_state = 3},
  [904] = {.lex_state = 340, .external_lex_state = 3},
  [905] = {.lex_state = 94, .external_lex_state = 3},
  [906] = {.lex_state = 341, .external_lex_state = 6},
  [907] = {.lex_state = 340, .external_lex_state = 3},
  [908] = {.lex_state = 344, .external_lex_state = 10},
  [909] = {.lex_state = 340, .external_lex_state = 3},
  [910] = {.lex_state = 340, .external_lex_state = 3},
  [911] = {.lex_state = 340, .external_lex_state = 3},
  [912] = {.lex_state = 340, .external_lex_state = 3},
  [913] = {.lex_state = 340, .external_lex_state = 3},
  [914] = {.lex_state = 344, .external_lex_state = 10},
  [915] = {.lex_state = 340, .external_lex_state = 3},
  [916] = {.lex_state = 340, .external_lex_state = 3},
  [917] = {.lex_state = 340, .external_lex_state = 3},
  [918] = {.lex_state = 340, .external_lex_state = 3},
  [919] = {.lex_state = 340, .external_lex_state = 3},
  [920] = {.lex_state = 340, .external_lex_state = 3},
  [921] = {.lex_state = 340, .external_lex_state = 3},
  [922] = {.lex_state = 340, .external_lex_state = 3},
  [923] = {.lex_state = 340, .external_lex_state = 3},
  [924] = {.lex_state = 340, .external_lex_state = 3},
  [925] = {.lex_state = 340, .external_lex_state = 3},
  [926] = {.lex_state = 340, .external_lex_state = 4},
  [927] = {.lex_state = 340, .external_lex_state = 3},
  [928] = {.lex_state = 340, .external_lex_state = 3},
  [929] = {.lex_state = 340, .external_lex_state = 4},
  [930] = {.lex_state = 340, .external_lex_state = 3},
  [931] = {.lex_state = 344, .external_lex_state = 10},
  [932] = {.lex_state = 340, .external_lex_state = 4},
  [933] = {.lex_state = 340, .external_lex_state = 4},
  [934] = {.lex_state = 340, .external_lex_state = 3},
  [935] = {.lex_state = 340, .external_lex_state = 3},
  [936] = {.lex_state = 340, .external_lex_state = 3},
  [937] = {.lex_state = 340, .external_lex_state = 4},
  [938] = {.lex_state = 340, .external_lex_state = 3},
  [939] = {.lex_state = 340, .external_lex_state = 3},
  [940] = {.lex_state = 340, .external_lex_state = 3},
  [941] = {.lex_state = 340, .external_lex_state = 3},
  [942] = {.lex_state = 340, .external_lex_state = 3},
  [943] = {.lex_state = 340, .external_lex_state = 3},
  [944] = {.lex_state = 340, .external_lex_state = 3},
  [945] = {.lex_state = 344, .external_lex_state = 10},
  [946] = {.lex_state = 340, .external_lex_state = 3},
  [947] = {.lex_state = 340, .external_lex_state = 3},
  [948] = {.lex_state = 340, .external_lex_state = 3},
  [949] = {.lex_state = 342, .external_lex_state = 3},
  [950] = {.lex_state = 344, .external_lex_state = 10},
  [951] = {.lex_state = 340, .external_lex_state = 3},
  [952] = {.lex_state = 340, .external_lex_state = 4},
  [953] = {.lex_state = 340, .external_lex_state = 4},
  [954] = {.lex_state = 343, .external_lex_state = 3},
  [955] = {.lex_state = 344, .external_lex_state = 10},
  [956] = {.lex_state = 345, .external_lex_state = 3},
  [957] = {.lex_state = 344, .external_lex_state = 11},
  [958] = {.lex_state = 340, .external_lex_state = 3},
  [959] = {.lex_state = 340, .external_lex_state = 4},
  [960] = {.lex_state = 343, .external_lex_state = 3},
  [961] = {.lex_state = 68, .external_lex_state = 4},
  [962] = {.lex_state = 340, .external_lex_state = 4},
  [963] = {.lex_state = 340, .external_lex_state = 3},
  [964] = {.lex_state = 340, .external_lex_state = 4},
  [965] = {.lex_state = 340, .external_lex_state = 4},
  [966] = {.lex_state = 343, .external_lex_state = 3},
  [967] = {.lex_state = 340, .external_lex_state = 3},
  [968] = {.lex_state = 68, .external_lex_state = 4},
  [969] = {.lex_state = 340, .external_lex_state = 4},
  [970] = {.lex_state = 340, .external_lex_state = 3},
  [971] = {.lex_state = 344, .external_lex_state = 3},
  [972] = {.lex_state = 345, .external_lex_state = 3},
  [973] = {.lex_state = 340, .external_lex_state = 4},
  [974] = {.lex_state = 345, .external_lex_state = 3},
  [975] = {.lex_state = 344, .external_lex_state = 11},
  [976] = {.lex_state = 343, .external_lex_state = 3},
  [977] = {.lex_state = 340, .external_lex_state = 3},
  [978] = {.lex_state = 344, .external_lex_state = 10},
  [979] = {.lex_state = 340, .external_lex_state = 3},
  [980] = {.lex_state = 340, .external_lex_state = 3},
  [981] = {.lex_state = 340, .external_lex_state = 3},
  [982] = {.lex_state = 340, .external_lex_state = 3},
  [983] = {.lex_state = 340, .external_lex_state = 3},
  [984] = {.lex_state = 340, .external_lex_state = 3},
  [985] = {.lex_state = 340, .external_lex_state = 3},
  [986] = {.lex_state = 345, .external_lex_state = 3},
  [987] = {.lex_state = 340, .external_lex_state = 4},
  [988] = {.lex_state = 68, .external_lex_state = 4},
  [989] = {.lex_state = 340, .external_lex_state = 4},
  [990] = {.lex_state = 340, .external_lex_state = 4},
  [991] = {.lex_state = 340, .external_lex_state = 4},
  [992] = {.lex_state = 68, .external_lex_state = 4},
  [993] = {.lex_state = 344, .external_lex_state = 10},
  [994] = {.lex_state = 340, .external_lex_state = 4},
  [995] = {.lex_state = 340, .external_lex_state = 3},
  [996] = {.lex_state = 68, .external_lex_state = 4},
  [997] = {.lex_state = 340, .external_lex_state = 3},
  [998] = {.lex_state = 345, .external_lex_state = 3},
  [999] = {.lex_state = 340, .external_lex_state = 3},
  [1000] = {.lex_state = 344, .external_lex_state = 10},
  [1001] = {.lex_state = 340, .external_lex_state = 3},
  [1002] = {.lex_state = 340, .external_lex_state = 4},
  [1003] = {.lex_state = 340, .external_lex_state = 5},
  [1004] = {.lex_state = 344, .external_lex_state = 3},
  [1005] = {.lex_state = 340, .external_lex_state = 4},
  [1006] = {.lex_state = 68, .external_lex_state = 3},
  [1007] = {.lex_state = 345, .external_lex_state = 3},
  [1008] = {.lex_state = 340, .external_lex_state = 4},
  [1009] = {.lex_state = 344, .external_lex_state = 3},
  [1010] = {.lex_state = 345, .external_lex_state = 3},
  [1011] = {.lex_state = 345, .external_lex_state = 3},
  [1012] = {.lex_state = 340, .external_lex_state = 5},
  [1013] = {.lex_state = 345, .external_lex_state = 3},
  [1014] = {.lex_state = 340, .external_lex_state = 4},
  [1015] = {.lex_state = 340, .external_lex_state = 4},
  [1016] = {.lex_state = 344, .external_lex_state = 3},
  [1017] = {.lex_state = 68, .external_lex_state = 3},
  [1018] = {.lex_state = 345, .external_lex_state = 3},
  [1019] = {.lex_state = 68, .external_lex_state = 3},
  [1020] = {.lex_state = 68, .external_lex_state = 3},
  [1021] = {.lex_state = 340, .external_lex_state = 4},
  [1022] = {.lex_state = 347, .external_lex_state = 3},
  [1023] = {.lex_state = 342, .external_lex_state = 3},
  [1024] = {.lex_state = 340, .external_lex_state = 4},
  [1025] = {.lex_state = 340, .external_lex_state = 4},
  [1026] = {.lex_state = 340, .external_lex_state = 4},
  [1027] = {.lex_state = 347, .external_lex_state = 3},
  [1028] = {.lex_state = 340, .external_lex_state = 4},
  [1029] = {.lex_state = 340, .external_lex_state = 4},
  [1030] = {.lex_state = 340, .external_lex_state = 5},
  [1031] = {.lex_state = 340, .external_lex_state = 4},
  [1032] = {.lex_state = 340, .external_lex_state = 4},
  [1033] = {.lex_state = 344, .external_lex_state = 3},
  [1034] = {.lex_state = 340, .external_lex_state = 4},
  [1035] = {.lex_state = 340, .external_lex_state = 5},
  [1036] = {.lex_state = 340, .external_lex_state = 4},
  [1037] = {.lex_state = 68, .external_lex_state = 3},
  [1038] = {.lex_state = 340, .external_lex_state = 4},
  [1039] = {.lex_state = 344, .external_lex_state = 3},
  [1040] = {.lex_state = 344, .external_lex_state = 3},
  [1041] = {.lex_state = 340, .external_lex_state = 5},
  [1042] = {.lex_state = 340, .external_lex_state = 4},
  [1043] = {.lex_state = 344, .external_lex_state = 11},
  [1044] = {.lex_state = 340, .external_lex_state = 4},
  [1045] = {.lex_state = 71, .external_lex_state = 3},
  [1046] = {.lex_state = 344, .external_lex_state = 3},
  [1047] = {.lex_state = 344, .external_lex_state = 3},
  [1048] = {.lex_state = 344, .external_lex_state = 3},
  [1049] = {.lex_state = 344, .external_lex_state = 11},
  [1050] = {.lex_state = 68, .external_lex_state = 4},
  [1051] = {.lex_state = 344, .external_lex_state = 11},
  [1052] = {.lex_state = 340, .external_lex_state = 4},
  [1053] = {.lex_state = 340, .external_lex_state = 4},
  [1054] = {.lex_state = 344, .external_lex_state = 3},
  [1055] = {.lex_state = 344, .external_lex_state = 3},
  [1056] = {.lex_state = 342, .external_lex_state = 4},
  [1057] = {.lex_state = 71, .external_lex_state = 3},
  [1058] = {.lex_state = 344, .external_lex_state = 3},
  [1059] = {.lex_state = 344, .external_lex_state = 3},
  [1060] = {.lex_state = 344, .external_lex_state = 3},
  [1061] = {.lex_state = 347, .external_lex_state = 3},
  [1062] = {.lex_state = 68, .external_lex_state = 4},
  [1063] = {.lex_state = 68, .external_lex_state = 4},
  [1064] = {.lex_state = 344, .external_lex_state = 3},
  [1065] = {.lex_state = 344, .external_lex_state = 3},
  [1066] = {.lex_state = 344, .external_lex_state = 3},
  [1067] = {.lex_state = 67, .external_lex_state = 3},
  [1068] = {.lex_state = 344, .external_lex_state = 3},
  [1069] = {.lex_state = 344, .external_lex_state = 3},
  [1070] = {.lex_state = 344, .external_lex_state = 3},
  [1071] = {.lex_state = 340, .external_lex_state = 4},
  [1072] = {.lex_state = 340, .external_lex_state = 4},
  [1073] = {.lex_state = 344, .external_lex_state = 3},
  [1074] = {.lex_state = 344, .external_lex_state = 3},
  [1075] = {.lex_state = 340, .external_lex_state = 6},
  [1076] = {.lex_state = 343, .external_lex_state = 3},
  [1077] = {.lex_state = 68, .external_lex_state = 4},
  [1078] = {.lex_state = 344, .external_lex_state = 3},
  [1079] = {.lex_state = 344, .external_lex_state = 3},
  [1080] = {.lex_state = 70, .external_lex_state = 3},
  [1081] = {.lex_state = 340, .external_lex_state = 4},
  [1082] = {.lex_state = 344, .external_lex_state = 3},
  [1083] = {.lex_state = 344, .external_lex_state = 3},
  [1084] = {.lex_state = 343, .external_lex_state = 3},
  [1085] = {.lex_state = 344, .external_lex_state = 3},
  [1086] = {.lex_state = 344, .external_lex_state = 3},
  [1087] = {.lex_state = 344, .external_lex_state = 3},
  [1088] = {.lex_state = 340, .external_lex_state = 4},
  [1089] = {.lex_state = 344, .external_lex_state = 3},
  [1090] = {.lex_state = 347, .external_lex_state = 3},
  [1091] = {.lex_state = 344, .external_lex_state = 3},
  [1092] = {.lex_state = 344, .external_lex_state = 3},
  [1093] = {.lex_state = 344, .external_lex_state = 3},
  [1094] = {.lex_state = 344, .external_lex_state = 3},
  [1095] = {.lex_state = 344, .external_lex_state = 3},
  [1096] = {.lex_state = 344, .external_lex_state = 3},
  [1097] = {.lex_state = 344, .external_lex_state = 3},
  [1098] = {.lex_state = 344, .external_lex_state = 3},
  [1099] = {.lex_state = 69, .external_lex_state = 3},
  [1100] = {.lex_state = 340, .external_lex_state = 6},
  [1101] = {.lex_state = 344, .external_lex_state = 3},
  [1102] = {.lex_state = 71, .external_lex_state = 3},
  [1103] = {.lex_state = 344, .external_lex_state = 3},
  [1104] = {.lex_state = 67, .external_lex_state = 3},
  [1105] = {.lex_state = 344, .external_lex_state = 3},
  [1106] = {.lex_state = 71, .external_lex_state = 3},
  [1107] = {.lex_state = 344, .external_lex_state = 3},
  [1108] = {.lex_state = 344, .external_lex_state = 3},
  [1109] = {.lex_state = 344, .external_lex_state = 3},
  [1110] = {.lex_state = 344, .external_lex_state = 3},
  [1111] = {.lex_state = 344, .external_lex_state = 3},
  [1112] = {.lex_state = 344, .external_lex_state = 3},
  [1113] = {.lex_state = 344, .external_lex_state = 3},
  [1114] = {.lex_state = 344, .external_lex_state = 3},
  [1115] = {.lex_state = 340, .external_lex_state = 4},
  [1116] = {.lex_state = 107, .external_lex_state = 11},
  [1117] = {.lex_state = 344, .external_lex_state = 3},
  [1118] = {.lex_state = 344, .external_lex_state = 3},
  [1119] = {.lex_state = 340, .external_lex_state = 4},
  [1120] = {.lex_state = 344, .external_lex_state = 3},
  [1121] = {.lex_state = 344, .external_lex_state = 3},
  [1122] = {.lex_state = 344, .external_lex_state = 3},
  [1123] = {.lex_state = 69, .external_lex_state = 3},
  [1124] = {.lex_state = 69, .external_lex_state = 3},
  [1125] = {.lex_state = 344, .external_lex_state = 3},
  [1126] = {.lex_state = 344, .external_lex_state = 3},
  [1127] = {.lex_state = 344, .external_lex_state = 3},
  [1128] = {.lex_state = 69, .external_lex_state = 3},
  [1129] = {.lex_state = 68, .external_lex_state = 4},
  [1130] = {.lex_state = 344, .external_lex_state = 10},
  [1131] = {.lex_state = 340, .external_lex_state = 6},
  [1132] = {.lex_state = 340, .external_lex_state = 6},
  [1133] = {.lex_state = 344, .external_lex_state = 3},
  [1134] = {.lex_state = 343, .external_lex_state = 3},
  [1135] = {.lex_state = 107, .external_lex_state = 11},
  [1136] = {.lex_state = 71, .external_lex_state = 3},
  [1137] = {.lex_state = 70, .external_lex_state = 3},
  [1138] = {.lex_state = 70, .external_lex_state = 3},
  [1139] = {.lex_state = 70, .external_lex_state = 3},
  [1140] = {.lex_state = 68, .external_lex_state = 4},
  [1141] = {.lex_state = 344, .external_lex_state = 3},
  [1142] = {.lex_state = 344, .external_lex_state = 10},
  [1143] = {.lex_state = 344, .external_lex_state = 3},
  [1144] = {.lex_state = 345, .external_lex_state = 3},
  [1145] = {.lex_state = 345, .external_lex_state = 3},
  [1146] = {.lex_state = 344, .external_lex_state = 3},
  [1147] = {.lex_state = 68, .external_lex_state = 4},
  [1148] = {.lex_state = 340, .external_lex_state = 6},
  [1149] = {.lex_state = 344, .external_lex_state = 3},
  [1150] = {.lex_state = 340, .external_lex_state = 4},
  [1151] = {.lex_state = 344, .external_lex_state = 3},
  [1152] = {.lex_state = 344, .external_lex_state = 3},
  [1153] = {.lex_state = 68, .external_lex_state = 4},
  [1154] = {.lex_state = 344, .external_lex_state = 3},
  [1155] = {.lex_state = 344, .external_lex_state = 3},
  [1156] = {.lex_state = 345, .external_lex_state = 3},
  [1157] = {.lex_state = 71, .external_lex_state = 3},
  [1158] = {.lex_state = 344, .external_lex_state = 10},
  [1159] = {.lex_state = 67, .external_lex_state = 3},
  [1160] = {.lex_state = 344, .external_lex_state = 3},
  [1161] = {.lex_state = 344, .external_lex_state = 3},
  [1162] = {.lex_state = 68, .external_lex_state = 4},
  [1163] = {.lex_state = 344, .external_lex_state = 3},
  [1164] = {.lex_state = 345, .external_lex_state = 3},
  [1165] = {.lex_state = 344, .external_lex_state = 3},
  [1166] = {.lex_state = 345, .external_lex_state = 3},
  [1167] = {.lex_state = 70, .external_lex_state = 3},
  [1168] = {.lex_state = 344, .external_lex_state = 3},
  [1169] = {.lex_state = 344, .external_lex_state = 3},
  [1170] = {.lex_state = 344, .external_lex_state = 3},
  [1171] = {.lex_state = 344, .external_lex_state = 3},
  [1172] = {.lex_state = 344, .external_lex_state = 3},
  [1173] = {.lex_state = 67, .external_lex_state = 3},
  [1174] = {.lex_state = 344, .external_lex_state = 3},
  [1175] = {.lex_state = 69, .external_lex_state = 3},
  [1176] = {.lex_state = 344, .external_lex_state = 3},
  [1177] = {.lex_state = 344, .external_lex_state = 3},
  [1178] = {.lex_state = 344, .external_lex_state = 3},
  [1179] = {.lex_state = 344, .external_lex_state = 3},
  [1180] = {.lex_state = 67, .external_lex_state = 3},
  [1181] = {.lex_state = 344, .external_lex_state = 3},
  [1182] = {.lex_state = 344, .external_lex_state = 3},
  [1183] = {.lex_state = 344, .external_lex_state = 3},
  [1184] = {.lex_state = 343, .external_lex_state = 3},
  [1185] = {.lex_state = 344, .external_lex_state = 3},
  [1186] = {.lex_state = 344, .external_lex_state = 11},
  [1187] = {.lex_state = 68, .external_lex_state = 3},
  [1188] = {.lex_state = 340, .external_lex_state = 4},
  [1189] = {.lex_state = 340, .external_lex_state = 5},
  [1190] = {.lex_state = 68, .external_lex_state = 4},
  [1191] = {.lex_state = 68, .external_lex_state = 4},
  [1192] = {.lex_state = 344, .external_lex_state = 11},
  [1193] = {.lex_state = 344, .external_lex_state = 3},
  [1194] = {.lex_state = 340, .external_lex_state = 4},
  [1195] = {.lex_state = 343, .external_lex_state = 4},
  [1196] = {.lex_state = 340, .external_lex_state = 4},
  [1197] = {.lex_state = 68, .external_lex_state = 3},
  [1198] = {.lex_state = 68, .external_lex_state = 3},
  [1199] = {.lex_state = 340, .external_lex_state = 4},
  [1200] = {.lex_state = 344, .external_lex_state = 11},
  [1201] = {.lex_state = 344, .external_lex_state = 3},
  [1202] = {.lex_state = 68, .external_lex_state = 4},
  [1203] = {.lex_state = 68, .external_lex_state = 4},
  [1204] = {.lex_state = 68, .external_lex_state = 4},
  [1205] = {.lex_state = 344, .external_lex_state = 11},
  [1206] = {.lex_state = 340, .external_lex_state = 4},
  [1207] = {.lex_state = 343, .external_lex_state = 4},
  [1208] = {.lex_state = 344, .external_lex_state = 3},
  [1209] = {.lex_state = 68, .external_lex_state = 4},
  [1210] = {.lex_state = 345, .external_lex_state = 3},
  [1211] = {.lex_state = 344, .external_lex_state = 3},
  [1212] = {.lex_state = 340, .external_lex_state = 5},
  [1213] = {.lex_state = 340, .external_lex_state = 4},
  [1214] = {.lex_state = 340, .external_lex_state = 4},
  [1215] = {.lex_state = 68, .external_lex_state = 4},
  [1216] = {.lex_state = 340, .external_lex_state = 4},
  [1217] = {.lex_state = 340, .external_lex_state = 4},
  [1218] = {.lex_state = 345, .external_lex_state = 4},
  [1219] = {.lex_state = 345, .external_lex_state = 4},
  [1220] = {.lex_state = 343, .external_lex_state = 4},
  [1221] = {.lex_state = 345, .external_lex_state = 4},
  [1222] = {.lex_state = 340, .external_lex_state = 4},
  [1223] = {.lex_state = 345, .external_lex_state = 4},
  [1224] = {.lex_state = 340, .external_lex_state = 5},
  [1225] = {.lex_state = 340, .external_lex_state = 5},
  [1226] = {.lex_state = 340, .external_lex_state = 5},
  [1227] = {.lex_state = 344, .external_lex_state = 3},
  [1228] = {.lex_state = 340, .external_lex_state = 5},
  [1229] = {.lex_state = 344, .external_lex_state = 12},
  [1230] = {.lex_state = 347, .external_lex_state = 4},
  [1231] = {.lex_state = 340, .external_lex_state = 4},
  [1232] = {.lex_state = 340, .external_lex_state = 5},
  [1233] = {.lex_state = 344, .external_lex_state = 12},
  [1234] = {.lex_state = 340, .external_lex_state = 4},
  [1235] = {.lex_state = 68, .external_lex_state = 4},
  [1236] = {.lex_state = 340, .external_lex_state = 5},
  [1237] = {.lex_state = 68, .external_lex_state = 3},
  [1238] = {.lex_state = 345, .external_lex_state = 4},
  [1239] = {.lex_state = 340, .external_lex_state = 4},
  [1240] = {.lex_state = 107, .external_lex_state = 10},
  [1241] = {.lex_state = 68, .external_lex_state = 4},
  [1242] = {.lex_state = 68, .external_lex_state = 3},
  [1243] = {.lex_state = 68, .external_lex_state = 4},
  [1244] = {.lex_state = 68, .external_lex_state = 4},
  [1245] = {.lex_state = 68, .external_lex_state = 4},
  [1246] = {.lex_state = 345, .external_lex_state = 3},
  [1247] = {.lex_state = 344, .external_lex_state = 3},
  [1248] = {.lex_state = 68, .external_lex_state = 4},
  [1249] = {.lex_state = 68, .external_lex_state = 3},
  [1250] = {.lex_state = 340, .external_lex_state = 4},
  [1251] = {.lex_state = 68, .external_lex_state = 3},
  [1252] = {.lex_state = 68, .external_lex_state = 4},
  [1253] = {.lex_state = 68, .external_lex_state = 4},
  [1254] = {.lex_state = 340, .external_lex_state = 4},
  [1255] = {.lex_state = 107, .external_lex_state = 11},
  [1256] = {.lex_state = 68, .external_lex_state = 3},
  [1257] = {.lex_state = 68, .external_lex_state = 4},
  [1258] = {.lex_state = 68, .external_lex_state = 3},
  [1259] = {.lex_state = 344, .external_lex_state = 3},
  [1260] = {.lex_state = 343, .external_lex_state = 4},
  [1261] = {.lex_state = 68, .external_lex_state = 4},
  [1262] = {.lex_state = 344, .external_lex_state = 3},
  [1263] = {.lex_state = 345, .external_lex_state = 3},
  [1264] = {.lex_state = 340, .external_lex_state = 3},
  [1265] = {.lex_state = 340, .external_lex_state = 5},
  [1266] = {.lex_state = 347, .external_lex_state = 4},
  [1267] = {.lex_state = 78, .external_lex_state = 10},
  [1268] = {.lex_state = 340, .external_lex_state = 4},
  [1269] = {.lex_state = 68, .external_lex_state = 4},
  [1270] = {.lex_state = 345, .external_lex_state = 3},
  [1271] = {.lex_state = 345, .external_lex_state = 3},
  [1272] = {.lex_state = 107, .external_lex_state = 10},
  [1273] = {.lex_state = 78, .external_lex_state = 10},
  [1274] = {.lex_state = 340, .external_lex_state = 4},
  [1275] = {.lex_state = 344, .external_lex_state = 3},
  [1276] = {.lex_state = 344, .external_lex_state = 3},
  [1277] = {.lex_state = 344, .external_lex_state = 3},
  [1278] = {.lex_state = 344, .external_lex_state = 4},
  [1279] = {.lex_state = 70, .external_lex_state = 3},
  [1280] = {.lex_state = 69, .external_lex_state = 3},
  [1281] = {.lex_state = 340, .external_lex_state = 5},
  [1282] = {.lex_state = 344, .external_lex_state = 3},
  [1283] = {.lex_state = 344, .external_lex_state = 3},
  [1284] = {.lex_state = 344, .external_lex_state = 3},
  [1285] = {.lex_state = 68, .external_lex_state = 3},
  [1286] = {.lex_state = 67, .external_lex_state = 3},
  [1287] = {.lex_state = 344, .external_lex_state = 4},
  [1288] = {.lex_state = 70, .external_lex_state = 3},
  [1289] = {.lex_state = 344, .external_lex_state = 3},
  [1290] = {.lex_state = 344, .external_lex_state = 3},
  [1291] = {.lex_state = 344, .external_lex_state = 3},
  [1292] = {.lex_state = 344, .external_lex_state = 3},
  [1293] = {.lex_state = 70, .external_lex_state = 3},
  [1294] = {.lex_state = 344, .external_lex_state = 4},
  [1295] = {.lex_state = 69, .external_lex_state = 3},
  [1296] = {.lex_state = 70, .external_lex_state = 3},
  [1297] = {.lex_state = 69, .external_lex_state = 3},
  [1298] = {.lex_state = 340, .external_lex_state = 6},
  [1299] = {.lex_state = 344, .external_lex_state = 3},
  [1300] = {.lex_state = 344, .external_lex_state = 3},
  [1301] = {.lex_state = 68, .external_lex_state = 3},
  [1302] = {.lex_state = 67, .external_lex_state = 3},
  [1303] = {.lex_state = 68, .external_lex_state = 3},
  [1304] = {.lex_state = 110, .external_lex_state = 10},
  [1305] = {.lex_state = 68, .external_lex_state = 3},
  [1306] = {.lex_state = 344, .external_lex_state = 3},
  [1307] = {.lex_state = 344, .external_lex_state = 3},
  [1308] = {.lex_state = 67, .external_lex_state = 3},
  [1309] = {.lex_state = 78, .external_lex_state = 10},
  [1310] = {.lex_state = 344, .external_lex_state = 3},
  [1311] = {.lex_state = 344, .external_lex_state = 3},
  [1312] = {.lex_state = 68, .external_lex_state = 3},
  [1313] = {.lex_state = 344, .external_lex_state = 3},
  [1314] = {.lex_state = 67, .external_lex_state = 3},
  [1315] = {.lex_state = 344, .external_lex_state = 3},
  [1316] = {.lex_state = 345, .external_lex_state = 4},
  [1317] = {.lex_state = 69, .external_lex_state = 3},
  [1318] = {.lex_state = 344, .external_lex_state = 3},
  [1319] = {.lex_state = 344, .external_lex_state = 3},
  [1320] = {.lex_state = 344, .external_lex_state = 3},
  [1321] = {.lex_state = 347, .external_lex_state = 10},
  [1322] = {.lex_state = 344, .external_lex_state = 3},
  [1323] = {.lex_state = 344, .external_lex_state = 3},
  [1324] = {.lex_state = 70, .external_lex_state = 3},
  [1325] = {.lex_state = 340, .external_lex_state = 5},
  [1326] = {.lex_state = 71, .external_lex_state = 3},
  [1327] = {.lex_state = 68, .external_lex_state = 3},
  [1328] = {.lex_state = 344, .external_lex_state = 3},
  [1329] = {.lex_state = 344, .external_lex_state = 3},
  [1330] = {.lex_state = 68, .external_lex_state = 3},
  [1331] = {.lex_state = 344, .external_lex_state = 3},
  [1332] = {.lex_state = 340, .external_lex_state = 6},
  [1333] = {.lex_state = 344, .external_lex_state = 3},
  [1334] = {.lex_state = 71, .external_lex_state = 3},
  [1335] = {.lex_state = 109, .external_lex_state = 10},
  [1336] = {.lex_state = 344, .external_lex_state = 3},
  [1337] = {.lex_state = 67, .external_lex_state = 3},
  [1338] = {.lex_state = 340, .external_lex_state = 6},
  [1339] = {.lex_state = 344, .external_lex_state = 12},
  [1340] = {.lex_state = 342, .external_lex_state = 4},
  [1341] = {.lex_state = 347, .external_lex_state = 10},
  [1342] = {.lex_state = 344, .external_lex_state = 3},
  [1343] = {.lex_state = 344, .external_lex_state = 4},
  [1344] = {.lex_state = 340, .external_lex_state = 6},
  [1345] = {.lex_state = 344, .external_lex_state = 3},
  [1346] = {.lex_state = 340, .external_lex_state = 6},
  [1347] = {.lex_state = 344, .external_lex_state = 3},
  [1348] = {.lex_state = 107, .external_lex_state = 10},
  [1349] = {.lex_state = 344, .external_lex_state = 3},
  [1350] = {.lex_state = 344, .external_lex_state = 3},
  [1351] = {.lex_state = 340, .external_lex_state = 5},
  [1352] = {.lex_state = 340, .external_lex_state = 6},
  [1353] = {.lex_state = 340, .external_lex_state = 5},
  [1354] = {.lex_state = 340, .external_lex_state = 5},
  [1355] = {.lex_state = 69, .external_lex_state = 3},
  [1356] = {.lex_state = 344, .external_lex_state = 3},
  [1357] = {.lex_state = 344, .external_lex_state = 4},
  [1358] = {.lex_state = 340, .external_lex_state = 5},
  [1359] = {.lex_state = 109, .external_lex_state = 10},
  [1360] = {.lex_state = 344, .external_lex_state = 3},
  [1361] = {.lex_state = 68, .external_lex_state = 3},
  [1362] = {.lex_state = 344, .external_lex_state = 3},
  [1363] = {.lex_state = 68, .external_lex_state = 3},
  [1364] = {.lex_state = 70, .external_lex_state = 3},
  [1365] = {.lex_state = 340, .external_lex_state = 5},
  [1366] = {.lex_state = 344, .external_lex_state = 3},
  [1367] = {.lex_state = 344, .external_lex_state = 3},
  [1368] = {.lex_state = 344, .external_lex_state = 3},
  [1369] = {.lex_state = 344, .external_lex_state = 3},
  [1370] = {.lex_state = 340, .external_lex_state = 5},
  [1371] = {.lex_state = 344, .external_lex_state = 3},
  [1372] = {.lex_state = 344, .external_lex_state = 3},
  [1373] = {.lex_state = 344, .external_lex_state = 3},
  [1374] = {.lex_state = 344, .external_lex_state = 3},
  [1375] = {.lex_state = 344, .external_lex_state = 3},
  [1376] = {.lex_state = 340, .external_lex_state = 5},
  [1377] = {.lex_state = 110, .external_lex_state = 10},
  [1378] = {.lex_state = 340, .external_lex_state = 5},
  [1379] = {.lex_state = 344, .external_lex_state = 3},
  [1380] = {.lex_state = 344, .external_lex_state = 3},
  [1381] = {.lex_state = 340, .external_lex_state = 5},
  [1382] = {.lex_state = 103, .external_lex_state = 10},
  [1383] = {.lex_state = 71, .external_lex_state = 3},
  [1384] = {.lex_state = 344, .external_lex_state = 3},
  [1385] = {.lex_state = 71, .external_lex_state = 3},
  [1386] = {.lex_state = 344, .external_lex_state = 3},
  [1387] = {.lex_state = 344, .external_lex_state = 3},
  [1388] = {.lex_state = 340, .external_lex_state = 6},
  [1389] = {.lex_state = 340, .external_lex_state = 5},
  [1390] = {.lex_state = 68, .external_lex_state = 3},
  [1391] = {.lex_state = 340, .external_lex_state = 6},
  [1392] = {.lex_state = 344, .external_lex_state = 3},
  [1393] = {.lex_state = 340, .external_lex_state = 5},
  [1394] = {.lex_state = 68, .external_lex_state = 3},
  [1395] = {.lex_state = 71, .external_lex_state = 3},
  [1396] = {.lex_state = 344, .external_lex_state = 3},
  [1397] = {.lex_state = 344, .external_lex_state = 3},
  [1398] = {.lex_state = 344, .external_lex_state = 3},
  [1399] = {.lex_state = 103, .external_lex_state = 10},
  [1400] = {.lex_state = 68, .external_lex_state = 3},
  [1401] = {.lex_state = 67, .external_lex_state = 3},
  [1402] = {.lex_state = 344, .external_lex_state = 4},
  [1403] = {.lex_state = 345, .external_lex_state = 4},
  [1404] = {.lex_state = 345, .external_lex_state = 4},
  [1405] = {.lex_state = 340, .external_lex_state = 5},
  [1406] = {.lex_state = 344, .external_lex_state = 4},
  [1407] = {.lex_state = 344, .external_lex_state = 3},
  [1408] = {.lex_state = 71, .external_lex_state = 3},
  [1409] = {.lex_state = 344, .external_lex_state = 3},
  [1410] = {.lex_state = 344, .external_lex_state = 3},
  [1411] = {.lex_state = 344, .external_lex_state = 13},
  [1412] = {.lex_state = 344, .external_lex_state = 3},
  [1413] = {.lex_state = 344, .external_lex_state = 3},
  [1414] = {.lex_state = 344, .external_lex_state = 3},
  [1415] = {.lex_state = 340, .external_lex_state = 5},
  [1416] = {.lex_state = 70, .external_lex_state = 3},
  [1417] = {.lex_state = 344, .external_lex_state = 3},
  [1418] = {.lex_state = 344, .external_lex_state = 3},
  [1419] = {.lex_state = 69, .external_lex_state = 3},
  [1420] = {.lex_state = 71, .external_lex_state = 3},
  [1421] = {.lex_state = 344, .external_lex_state = 3},
  [1422] = {.lex_state = 70, .external_lex_state = 3},
  [1423] = {.lex_state = 344, .external_lex_state = 3},
  [1424] = {.lex_state = 344, .external_lex_state = 4},
  [1425] = {.lex_state = 340, .external_lex_state = 6},
  [1426] = {.lex_state = 345, .external_lex_state = 4},
  [1427] = {.lex_state = 71, .external_lex_state = 3},
  [1428] = {.lex_state = 345, .external_lex_state = 4},
  [1429] = {.lex_state = 344, .external_lex_state = 3},
  [1430] = {.lex_state = 344, .external_lex_state = 3},
  [1431] = {.lex_state = 344, .external_lex_state = 3},
  [1432] = {.lex_state = 71, .external_lex_state = 3},
  [1433] = {.lex_state = 344, .external_lex_state = 13},
  [1434] = {.lex_state = 344, .external_lex_state = 3},
  [1435] = {.lex_state = 67, .external_lex_state = 3},
  [1436] = {.lex_state = 344, .external_lex_state = 3},
  [1437] = {.lex_state = 91, .external_lex_state = 4},
  [1438] = {.lex_state = 68, .external_lex_state = 3},
  [1439] = {.lex_state = 69, .external_lex_state = 3},
  [1440] = {.lex_state = 69, .external_lex_state = 3},
  [1441] = {.lex_state = 68, .external_lex_state = 3},
  [1442] = {.lex_state = 344, .external_lex_state = 3},
  [1443] = {.lex_state = 344, .external_lex_state = 3},
  [1444] = {.lex_state = 68, .external_lex_state = 3},
  [1445] = {.lex_state = 344, .external_lex_state = 3},
  [1446] = {.lex_state = 344, .external_lex_state = 3},
  [1447] = {.lex_state = 344, .external_lex_state = 3},
  [1448] = {.lex_state = 68, .external_lex_state = 3},
  [1449] = {.lex_state = 67, .external_lex_state = 3},
  [1450] = {.lex_state = 344, .external_lex_state = 3},
  [1451] = {.lex_state = 68, .external_lex_state = 3},
  [1452] = {.lex_state = 69, .external_lex_state = 3},
  [1453] = {.lex_state = 67, .external_lex_state = 3},
  [1454] = {.lex_state = 344, .external_lex_state = 3},
  [1455] = {.lex_state = 344, .external_lex_state = 3},
  [1456] = {.lex_state = 68, .external_lex_state = 3},
  [1457] = {.lex_state = 344, .external_lex_state = 3},
  [1458] = {.lex_state = 344, .external_lex_state = 3},
  [1459] = {.lex_state = 71, .external_lex_state = 3},
  [1460] = {.lex_state = 70, .external_lex_state = 3},
  [1461] = {.lex_state = 340, .external_lex_state = 5},
  [1462] = {.lex_state = 340, .external_lex_state = 5},
  [1463] = {.lex_state = 340, .external_lex_state = 3},
  [1464] = {.lex_state = 344, .external_lex_state = 4},
  [1465] = {.lex_state = 344, .external_lex_state = 11},
  [1466] = {.lex_state = 344, .external_lex_state = 4},
  [1467] = {.lex_state = 71, .external_lex_state = 3},
  [1468] = {.lex_state = 340, .external_lex_state = 6},
  [1469] = {.lex_state = 71, .external_lex_state = 3},
  [1470] = {.lex_state = 340, .external_lex_state = 3},
  [1471] = {.lex_state = 71, .external_lex_state = 3},
  [1472] = {.lex_state = 71, .external_lex_state = 3},
  [1473] = {.lex_state = 71, .external_lex_state = 3},
  [1474] = {.lex_state = 92, .external_lex_state = 4},
  [1475] = {.lex_state = 69, .external_lex_state = 3},
  [1476] = {.lex_state = 67, .external_lex_state = 3},
  [1477] = {.lex_state = 344, .external_lex_state = 4},
  [1478] = {.lex_state = 340, .external_lex_state = 6},
  [1479] = {.lex_state = 340, .external_lex_state = 6},
  [1480] = {.lex_state = 71, .external_lex_state = 3},
  [1481] = {.lex_state = 340, .external_lex_state = 6},
  [1482] = {.lex_state = 67, .external_lex_state = 3},
  [1483] = {.lex_state = 67, .external_lex_state = 3},
  [1484] = {.lex_state = 67, .external_lex_state = 3},
  [1485] = {.lex_state = 69, .external_lex_state = 3},
  [1486] = {.lex_state = 344, .external_lex_state = 4},
  [1487] = {.lex_state = 344, .external_lex_state = 13},
  [1488] = {.lex_state = 344, .external_lex_state = 4},
  [1489] = {.lex_state = 78, .external_lex_state = 4},
  [1490] = {.lex_state = 344, .external_lex_state = 4},
  [1491] = {.lex_state = 344, .external_lex_state = 11},
  [1492] = {.lex_state = 70, .external_lex_state = 3},
  [1493] = {.lex_state = 344, .external_lex_state = 4},
  [1494] = {.lex_state = 67, .external_lex_state = 3},
  [1495] = {.lex_state = 67, .external_lex_state = 3},
  [1496] = {.lex_state = 67, .external_lex_state = 3},
  [1497] = {.lex_state = 343, .external_lex_state = 4},
  [1498] = {.lex_state = 344, .external_lex_state = 4},
  [1499] = {.lex_state = 71, .external_lex_state = 3},
  [1500] = {.lex_state = 92, .external_lex_state = 4},
  [1501] = {.lex_state = 70, .external_lex_state = 3},
  [1502] = {.lex_state = 67, .external_lex_state = 3},
  [1503] = {.lex_state = 344, .external_lex_state = 4},
  [1504] = {.lex_state = 340, .external_lex_state = 6},
  [1505] = {.lex_state = 340, .external_lex_state = 4},
  [1506] = {.lex_state = 344, .external_lex_state = 4},
  [1507] = {.lex_state = 92, .external_lex_state = 4},
  [1508] = {.lex_state = 67, .external_lex_state = 3},
  [1509] = {.lex_state = 344, .external_lex_state = 4},
  [1510] = {.lex_state = 344, .external_lex_state = 4},
  [1511] = {.lex_state = 67, .external_lex_state = 3},
  [1512] = {.lex_state = 344, .external_lex_state = 4},
  [1513] = {.lex_state = 67, .external_lex_state = 3},
  [1514] = {.lex_state = 67, .external_lex_state = 3},
  [1515] = {.lex_state = 71, .external_lex_state = 3},
  [1516] = {.lex_state = 345, .external_lex_state = 4},
  [1517] = {.lex_state = 92, .external_lex_state = 4},
  [1518] = {.lex_state = 67, .external_lex_state = 3},
  [1519] = {.lex_state = 340, .external_lex_state = 6},
  [1520] = {.lex_state = 71, .external_lex_state = 3},
  [1521] = {.lex_state = 345, .external_lex_state = 4},
  [1522] = {.lex_state = 345, .external_lex_state = 4},
  [1523] = {.lex_state = 340, .external_lex_state = 6},
  [1524] = {.lex_state = 71, .external_lex_state = 3},
  [1525] = {.lex_state = 103, .external_lex_state = 10},
  [1526] = {.lex_state = 344, .external_lex_state = 4},
  [1527] = {.lex_state = 71, .external_lex_state = 3},
  [1528] = {.lex_state = 67, .external_lex_state = 3},
  [1529] = {.lex_state = 344, .external_lex_state = 4},
  [1530] = {.lex_state = 344, .external_lex_state = 11},
  [1531] = {.lex_state = 70, .external_lex_state = 3},
  [1532] = {.lex_state = 344, .external_lex_state = 4},
  [1533] = {.lex_state = 71, .external_lex_state = 3},
  [1534] = {.lex_state = 76, .external_lex_state = 3},
  [1535] = {.lex_state = 345, .external_lex_state = 4},
  [1536] = {.lex_state = 340, .external_lex_state = 6},
  [1537] = {.lex_state = 344, .external_lex_state = 4},
  [1538] = {.lex_state = 340, .external_lex_state = 6},
  [1539] = {.lex_state = 344, .external_lex_state = 4},
  [1540] = {.lex_state = 345, .external_lex_state = 4},
  [1541] = {.lex_state = 344, .external_lex_state = 4},
  [1542] = {.lex_state = 340, .external_lex_state = 6},
  [1543] = {.lex_state = 340, .external_lex_state = 6},
  [1544] = {.lex_state = 340, .external_lex_state = 6},
  [1545] = {.lex_state = 340, .external_lex_state = 6},
  [1546] = {.lex_state = 72, .external_lex_state = 4},
  [1547] = {.lex_state = 344, .external_lex_state = 4},
  [1548] = {.lex_state = 91, .external_lex_state = 3},
  [1549] = {.lex_state = 344, .external_lex_state = 4},
  [1550] = {.lex_state = 70, .external_lex_state = 3},
  [1551] = {.lex_state = 69, .external_lex_state = 3},
  [1552] = {.lex_state = 344, .external_lex_state = 4},
  [1553] = {.lex_state = 344, .external_lex_state = 4},
  [1554] = {.lex_state = 344, .external_lex_state = 4},
  [1555] = {.lex_state = 69, .external_lex_state = 3},
  [1556] = {.lex_state = 70, .external_lex_state = 3},
  [1557] = {.lex_state = 78, .external_lex_state = 4},
  [1558] = {.lex_state = 344, .external_lex_state = 4},
  [1559] = {.lex_state = 69, .external_lex_state = 3},
  [1560] = {.lex_state = 70, .external_lex_state = 3},
  [1561] = {.lex_state = 344, .external_lex_state = 4},
  [1562] = {.lex_state = 344, .external_lex_state = 4},
  [1563] = {.lex_state = 344, .external_lex_state = 4},
  [1564] = {.lex_state = 344, .external_lex_state = 4},
  [1565] = {.lex_state = 344, .external_lex_state = 4},
  [1566] = {.lex_state = 344, .external_lex_state = 4},
  [1567] = {.lex_state = 70, .external_lex_state = 3},
  [1568] = {.lex_state = 344, .external_lex_state = 4},
  [1569] = {.lex_state = 107, .external_lex_state = 11},
  [1570] = {.lex_state = 344, .external_lex_state = 4},
  [1571] = {.lex_state = 344, .external_lex_state = 4},
  [1572] = {.lex_state = 70, .external_lex_state = 3},
  [1573] = {.lex_state = 67, .external_lex_state = 3},
  [1574] = {.lex_state = 69, .external_lex_state = 3},
  [1575] = {.lex_state = 344, .external_lex_state = 4},
  [1576] = {.lex_state = 344, .external_lex_state = 4},
  [1577] = {.lex_state = 344, .external_lex_state = 4},
  [1578] = {.lex_state = 69, .external_lex_state = 3},
  [1579] = {.lex_state = 67, .external_lex_state = 3},
  [1580] = {.lex_state = 344, .external_lex_state = 4},
  [1581] = {.lex_state = 343, .external_lex_state = 4},
  [1582] = {.lex_state = 70, .external_lex_state = 3},
  [1583] = {.lex_state = 70, .external_lex_state = 3},
  [1584] = {.lex_state = 344, .external_lex_state = 4},
  [1585] = {.lex_state = 107, .external_lex_state = 11},
  [1586] = {.lex_state = 69, .external_lex_state = 3},
  [1587] = {.lex_state = 69, .external_lex_state = 3},
  [1588] = {.lex_state = 344, .external_lex_state = 4},
  [1589] = {.lex_state = 109, .external_lex_state = 10},
  [1590] = {.lex_state = 344, .external_lex_state = 4},
  [1591] = {.lex_state = 344, .external_lex_state = 4},
  [1592] = {.lex_state = 344, .external_lex_state = 4},
  [1593] = {.lex_state = 70, .external_lex_state = 3},
  [1594] = {.lex_state = 344, .external_lex_state = 4},
  [1595] = {.lex_state = 67, .external_lex_state = 3},
  [1596] = {.lex_state = 344, .external_lex_state = 4},
  [1597] = {.lex_state = 340, .external_lex_state = 6},
  [1598] = {.lex_state = 340, .external_lex_state = 6},
  [1599] = {.lex_state = 93, .external_lex_state = 4},
  [1600] = {.lex_state = 107, .external_lex_state = 4},
  [1601] = {.lex_state = 69, .external_lex_state = 3},
  [1602] = {.lex_state = 344, .external_lex_state = 4},
  [1603] = {.lex_state = 342, .external_lex_state = 5},
  [1604] = {.lex_state = 71, .external_lex_state = 3},
  [1605] = {.lex_state = 344, .external_lex_state = 4},
  [1606] = {.lex_state = 71, .external_lex_state = 3},
  [1607] = {.lex_state = 71, .external_lex_state = 3},
  [1608] = {.lex_state = 110, .external_lex_state = 10},
  [1609] = {.lex_state = 340, .external_lex_state = 6},
  [1610] = {.lex_state = 70, .external_lex_state = 3},
  [1611] = {.lex_state = 344, .external_lex_state = 4},
  [1612] = {.lex_state = 344, .external_lex_state = 4},
  [1613] = {.lex_state = 344, .external_lex_state = 4},
  [1614] = {.lex_state = 344, .external_lex_state = 4},
  [1615] = {.lex_state = 344, .external_lex_state = 4},
  [1616] = {.lex_state = 70, .external_lex_state = 3},
  [1617] = {.lex_state = 69, .external_lex_state = 3},
  [1618] = {.lex_state = 344, .external_lex_state = 4},
  [1619] = {.lex_state = 93, .external_lex_state = 4},
  [1620] = {.lex_state = 93, .external_lex_state = 4},
  [1621] = {.lex_state = 344, .external_lex_state = 4},
  [1622] = {.lex_state = 340, .external_lex_state = 6},
  [1623] = {.lex_state = 343, .external_lex_state = 4},
  [1624] = {.lex_state = 344, .external_lex_state = 4},
  [1625] = {.lex_state = 344, .external_lex_state = 4},
  [1626] = {.lex_state = 344, .external_lex_state = 4},
  [1627] = {.lex_state = 93, .external_lex_state = 4},
  [1628] = {.lex_state = 344, .external_lex_state = 4},
  [1629] = {.lex_state = 70, .external_lex_state = 3},
  [1630] = {.lex_state = 70, .external_lex_state = 3},
  [1631] = {.lex_state = 107, .external_lex_state = 11},
  [1632] = {.lex_state = 69, .external_lex_state = 3},
  [1633] = {.lex_state = 70, .external_lex_state = 3},
  [1634] = {.lex_state = 69, .external_lex_state = 3},
  [1635] = {.lex_state = 344, .external_lex_state = 4},
  [1636] = {.lex_state = 344, .external_lex_state = 4},
  [1637] = {.lex_state = 344, .external_lex_state = 4},
  [1638] = {.lex_state = 107, .external_lex_state = 4},
  [1639] = {.lex_state = 344, .external_lex_state = 4},
  [1640] = {.lex_state = 344, .external_lex_state = 4},
  [1641] = {.lex_state = 344, .external_lex_state = 4},
  [1642] = {.lex_state = 344, .external_lex_state = 4},
  [1643] = {.lex_state = 344, .external_lex_state = 4},
  [1644] = {.lex_state = 344, .external_lex_state = 4},
  [1645] = {.lex_state = 344, .external_lex_state = 4},
  [1646] = {.lex_state = 93, .external_lex_state = 4},
  [1647] = {.lex_state = 344, .external_lex_state = 4},
  [1648] = {.lex_state = 70, .external_lex_state = 3},
  [1649] = {.lex_state = 344, .external_lex_state = 4},
  [1650] = {.lex_state = 344, .external_lex_state = 4},
  [1651] = {.lex_state = 69, .external_lex_state = 3},
  [1652] = {.lex_state = 71, .external_lex_state = 3},
  [1653] = {.lex_state = 344, .external_lex_state = 4},
  [1654] = {.lex_state = 344, .external_lex_state = 4},
  [1655] = {.lex_state = 69, .external_lex_state = 3},
  [1656] = {.lex_state = 72, .external_lex_state = 4},
  [1657] = {.lex_state = 344, .external_lex_state = 4},
  [1658] = {.lex_state = 344, .external_lex_state = 4},
  [1659] = {.lex_state = 344, .external_lex_state = 4},
  [1660] = {.lex_state = 344, .external_lex_state = 4},
  [1661] = {.lex_state = 344, .external_lex_state = 4},
  [1662] = {.lex_state = 344, .external_lex_state = 4},
  [1663] = {.lex_state = 344, .external_lex_state = 4},
  [1664] = {.lex_state = 69, .external_lex_state = 3},
  [1665] = {.lex_state = 343, .external_lex_state = 4},
  [1666] = {.lex_state = 344, .external_lex_state = 4},
  [1667] = {.lex_state = 344, .external_lex_state = 4},
  [1668] = {.lex_state = 344, .external_lex_state = 4},
  [1669] = {.lex_state = 344, .external_lex_state = 4},
  [1670] = {.lex_state = 71, .external_lex_state = 3},
  [1671] = {.lex_state = 347, .external_lex_state = 10},
  [1672] = {.lex_state = 344, .external_lex_state = 4},
  [1673] = {.lex_state = 69, .external_lex_state = 3},
  [1674] = {.lex_state = 344, .external_lex_state = 4},
  [1675] = {.lex_state = 71, .external_lex_state = 3},
  [1676] = {.lex_state = 93, .external_lex_state = 4},
  [1677] = {.lex_state = 93, .external_lex_state = 4},
  [1678] = {.lex_state = 345, .external_lex_state = 4},
  [1679] = {.lex_state = 345, .external_lex_state = 5},
  [1680] = {.lex_state = 340, .external_lex_state = 3},
  [1681] = {.lex_state = 343, .external_lex_state = 5},
  [1682] = {.lex_state = 344, .external_lex_state = 3},
  [1683] = {.lex_state = 93, .external_lex_state = 4},
  [1684] = {.lex_state = 344, .external_lex_state = 12},
  [1685] = {.lex_state = 107, .external_lex_state = 10},
  [1686] = {.lex_state = 77, .external_lex_state = 3},
  [1687] = {.lex_state = 93, .external_lex_state = 4},
  [1688] = {.lex_state = 345, .external_lex_state = 5},
  [1689] = {.lex_state = 345, .external_lex_state = 5},
  [1690] = {.lex_state = 345, .external_lex_state = 5},
  [1691] = {.lex_state = 107, .external_lex_state = 3},
  [1692] = {.lex_state = 345, .external_lex_state = 5},
  [1693] = {.lex_state = 85, .external_lex_state = 4},
  [1694] = {.lex_state = 344, .external_lex_state = 4},
  [1695] = {.lex_state = 343, .external_lex_state = 5},
  [1696] = {.lex_state = 93, .external_lex_state = 3},
  [1697] = {.lex_state = 85, .external_lex_state = 4},
  [1698] = {.lex_state = 85, .external_lex_state = 4},
  [1699] = {.lex_state = 107, .external_lex_state = 10},
  [1700] = {.lex_state = 87, .external_lex_state = 3},
  [1701] = {.lex_state = 92, .external_lex_state = 3},
  [1702] = {.lex_state = 347, .external_lex_state = 5},
  [1703] = {.lex_state = 344, .external_lex_state = 4},
  [1704] = {.lex_state = 343, .external_lex_state = 5},
  [1705] = {.lex_state = 343, .external_lex_state = 5},
  [1706] = {.lex_state = 107, .external_lex_state = 4},
  [1707] = {.lex_state = 107, .external_lex_state = 4},
  [1708] = {.lex_state = 105, .external_lex_state = 3},
  [1709] = {.lex_state = 93, .external_lex_state = 3},
  [1710] = {.lex_state = 93, .external_lex_state = 3},
  [1711] = {.lex_state = 78, .external_lex_state = 10},
  [1712] = {.lex_state = 342, .external_lex_state = 6},
  [1713] = {.lex_state = 93, .external_lex_state = 3},
  [1714] = {.lex_state = 107, .external_lex_state = 4},
  [1715] = {.lex_state = 93, .external_lex_state = 3},
  [1716] = {.lex_state = 344, .external_lex_state = 4},
  [1717] = {.lex_state = 347, .external_lex_state = 5},
  [1718] = {.lex_state = 344, .external_lex_state = 12},
  [1719] = {.lex_state = 78, .external_lex_state = 10},
  [1720] = {.lex_state = 345, .external_lex_state = 4},
  [1721] = {.lex_state = 77, .external_lex_state = 3},
  [1722] = {.lex_state = 92, .external_lex_state = 3},
  [1723] = {.lex_state = 345, .external_lex_state = 4},
  [1724] = {.lex_state = 107, .external_lex_state = 3},
  [1725] = {.lex_state = 345, .external_lex_state = 4},
  [1726] = {.lex_state = 77, .external_lex_state = 3},
  [1727] = {.lex_state = 99, .external_lex_state = 3},
  [1728] = {.lex_state = 345, .external_lex_state = 4},
  [1729] = {.lex_state = 77, .external_lex_state = 3},
  [1730] = {.lex_state = 93, .external_lex_state = 4},
  [1731] = {.lex_state = 107, .external_lex_state = 4},
  [1732] = {.lex_state = 78, .external_lex_state = 10},
  [1733] = {.lex_state = 107, .external_lex_state = 4},
  [1734] = {.lex_state = 92, .external_lex_state = 3},
  [1735] = {.lex_state = 79, .external_lex_state = 3},
  [1736] = {.lex_state = 344, .external_lex_state = 12},
  [1737] = {.lex_state = 347, .external_lex_state = 4},
  [1738] = {.lex_state = 344, .external_lex_state = 4},
  [1739] = {.lex_state = 92, .external_lex_state = 3},
  [1740] = {.lex_state = 95, .external_lex_state = 3},
  [1741] = {.lex_state = 79, .external_lex_state = 3},
  [1742] = {.lex_state = 344, .external_lex_state = 4},
  [1743] = {.lex_state = 79, .external_lex_state = 3},
  [1744] = {.lex_state = 107, .external_lex_state = 4},
  [1745] = {.lex_state = 107, .external_lex_state = 10},
  [1746] = {.lex_state = 79, .external_lex_state = 3},
  [1747] = {.lex_state = 79, .external_lex_state = 3},
  [1748] = {.lex_state = 347, .external_lex_state = 4},
  [1749] = {.lex_state = 344, .external_lex_state = 4},
  [1750] = {.lex_state = 107, .external_lex_state = 4},
  [1751] = {.lex_state = 107, .external_lex_state = 4},
  [1752] = {.lex_state = 344, .external_lex_state = 4},
  [1753] = {.lex_state = 344, .external_lex_state = 4},
  [1754] = {.lex_state = 347, .external_lex_state = 10},
  [1755] = {.lex_state = 107, .external_lex_state = 4},
  [1756] = {.lex_state = 107, .external_lex_state = 4},
  [1757] = {.lex_state = 78, .external_lex_state = 3},
  [1758] = {.lex_state = 100, .external_lex_state = 3},
  [1759] = {.lex_state = 103, .external_lex_state = 10},
  [1760] = {.lex_state = 347, .external_lex_state = 6},
  [1761] = {.lex_state = 78, .external_lex_state = 3},
  [1762] = {.lex_state = 107, .external_lex_state = 4},
  [1763] = {.lex_state = 78, .external_lex_state = 3},
  [1764] = {.lex_state = 103, .external_lex_state = 10},
  [1765] = {.lex_state = 88, .external_lex_state = 3},
  [1766] = {.lex_state = 88, .external_lex_state = 3},
  [1767] = {.lex_state = 107, .external_lex_state = 3},
  [1768] = {.lex_state = 344, .external_lex_state = 5},
  [1769] = {.lex_state = 89, .external_lex_state = 3},
  [1770] = {.lex_state = 344, .external_lex_state = 4},
  [1771] = {.lex_state = 344, .external_lex_state = 4},
  [1772] = {.lex_state = 88, .external_lex_state = 3},
  [1773] = {.lex_state = 107, .external_lex_state = 3},
  [1774] = {.lex_state = 89, .external_lex_state = 3},
  [1775] = {.lex_state = 107, .external_lex_state = 4},
  [1776] = {.lex_state = 89, .external_lex_state = 3},
  [1777] = {.lex_state = 107, .external_lex_state = 4},
  [1778] = {.lex_state = 344, .external_lex_state = 4},
  [1779] = {.lex_state = 344, .external_lex_state = 4},
  [1780] = {.lex_state = 107, .external_lex_state = 4},
  [1781] = {.lex_state = 78, .external_lex_state = 3},
  [1782] = {.lex_state = 107, .external_lex_state = 4},
  [1783] = {.lex_state = 89, .external_lex_state = 3},
  [1784] = {.lex_state = 106, .external_lex_state = 3},
  [1785] = {.lex_state = 347, .external_lex_state = 6},
  [1786] = {.lex_state = 85, .external_lex_state = 3},
  [1787] = {.lex_state = 89, .external_lex_state = 3},
  [1788] = {.lex_state = 85, .external_lex_state = 4},
  [1789] = {.lex_state = 344, .external_lex_state = 13},
  [1790] = {.lex_state = 107, .external_lex_state = 3},
  [1791] = {.lex_state = 106, .external_lex_state = 3},
  [1792] = {.lex_state = 345, .external_lex_state = 5},
  [1793] = {.lex_state = 344, .external_lex_state = 4},
  [1794] = {.lex_state = 345, .external_lex_state = 5},
  [1795] = {.lex_state = 85, .external_lex_state = 4},
  [1796] = {.lex_state = 107, .external_lex_state = 3},
  [1797] = {.lex_state = 88, .external_lex_state = 3},
  [1798] = {.lex_state = 344, .external_lex_state = 4},
  [1799] = {.lex_state = 345, .external_lex_state = 5},
  [1800] = {.lex_state = 345, .external_lex_state = 5},
  [1801] = {.lex_state = 344, .external_lex_state = 5},
  [1802] = {.lex_state = 107, .external_lex_state = 3},
  [1803] = {.lex_state = 107, .external_lex_state = 3},
  [1804] = {.lex_state = 107, .external_lex_state = 4},
  [1805] = {.lex_state = 344, .external_lex_state = 4},
  [1806] = {.lex_state = 101, .external_lex_state = 3},
  [1807] = {.lex_state = 108, .external_lex_state = 3},
  [1808] = {.lex_state = 108, .external_lex_state = 3},
  [1809] = {.lex_state = 344, .external_lex_state = 4},
  [1810] = {.lex_state = 108, .external_lex_state = 3},
  [1811] = {.lex_state = 109, .external_lex_state = 10},
  [1812] = {.lex_state = 108, .external_lex_state = 3},
  [1813] = {.lex_state = 344, .external_lex_state = 4},
  [1814] = {.lex_state = 344, .external_lex_state = 4},
  [1815] = {.lex_state = 344, .external_lex_state = 4},
  [1816] = {.lex_state = 157},
  [1817] = {.lex_state = 100, .external_lex_state = 3},
  [1818] = {.lex_state = 344, .external_lex_state = 4},
  [1819] = {.lex_state = 344, .external_lex_state = 4},
  [1820] = {.lex_state = 149, .external_lex_state = 14},
  [1821] = {.lex_state = 344, .external_lex_state = 4},
  [1822] = {.lex_state = 345, .external_lex_state = 5},
  [1823] = {.lex_state = 344, .external_lex_state = 4},
  [1824] = {.lex_state = 344, .external_lex_state = 4},
  [1825] = {.lex_state = 344, .external_lex_state = 4},
  [1826] = {.lex_state = 344, .external_lex_state = 4},
  [1827] = {.lex_state = 344, .external_lex_state = 4},
  [1828] = {.lex_state = 344, .external_lex_state = 4},
  [1829] = {.lex_state = 106, .external_lex_state = 3},
  [1830] = {.lex_state = 100, .external_lex_state = 3},
  [1831] = {.lex_state = 344, .external_lex_state = 4},
  [1832] = {.lex_state = 344, .external_lex_state = 4},
  [1833] = {.lex_state = 344, .external_lex_state = 4},
  [1834] = {.lex_state = 344, .external_lex_state = 4},
  [1835] = {.lex_state = 344, .external_lex_state = 4},
  [1836] = {.lex_state = 344, .external_lex_state = 4},
  [1837] = {.lex_state = 344, .external_lex_state = 4},
  [1838] = {.lex_state = 344, .external_lex_state = 4},
  [1839] = {.lex_state = 344, .external_lex_state = 4},
  [1840] = {.lex_state = 85, .external_lex_state = 3},
  [1841] = {.lex_state = 344, .external_lex_state = 4},
  [1842] = {.lex_state = 344, .external_lex_state = 4},
  [1843] = {.lex_state = 103, .external_lex_state = 3},
  [1844] = {.lex_state = 78, .external_lex_state = 3},
  [1845] = {.lex_state = 109, .external_lex_state = 3},
  [1846] = {.lex_state = 344, .external_lex_state = 4},
  [1847] = {.lex_state = 344, .external_lex_state = 4},
  [1848] = {.lex_state = 344, .external_lex_state = 4},
  [1849] = {.lex_state = 344, .external_lex_state = 4},
  [1850] = {.lex_state = 344, .external_lex_state = 4},
  [1851] = {.lex_state = 344, .external_lex_state = 4},
  [1852] = {.lex_state = 344, .external_lex_state = 5},
  [1853] = {.lex_state = 343, .external_lex_state = 6},
  [1854] = {.lex_state = 93, .external_lex_state = 3},
  [1855] = {.lex_state = 344, .external_lex_state = 5},
  [1856] = {.lex_state = 103, .external_lex_state = 10},
  [1857] = {.lex_state = 109, .external_lex_state = 10},
  [1858] = {.lex_state = 344, .external_lex_state = 3},
  [1859] = {.lex_state = 79, .external_lex_state = 3},
  [1860] = {.lex_state = 93, .external_lex_state = 3},
  [1861] = {.lex_state = 93, .external_lex_state = 3},
  [1862] = {.lex_state = 106, .external_lex_state = 3},
  [1863] = {.lex_state = 343, .external_lex_state = 6},
  [1864] = {.lex_state = 107, .external_lex_state = 4},
  [1865] = {.lex_state = 107, .external_lex_state = 3},
  [1866] = {.lex_state = 108, .external_lex_state = 3},
  [1867] = {.lex_state = 344, .external_lex_state = 5},
  [1868] = {.lex_state = 78, .external_lex_state = 3},
  [1869] = {.lex_state = 101, .external_lex_state = 3},
  [1870] = {.lex_state = 101, .external_lex_state = 3},
  [1871] = {.lex_state = 110, .external_lex_state = 3},
  [1872] = {.lex_state = 344, .external_lex_state = 5},
  [1873] = {.lex_state = 344, .external_lex_state = 4},
  [1874] = {.lex_state = 344, .external_lex_state = 3},
  [1875] = {.lex_state = 96, .external_lex_state = 3},
  [1876] = {.lex_state = 93, .external_lex_state = 3},
  [1877] = {.lex_state = 343, .external_lex_state = 6},
  [1878] = {.lex_state = 78, .external_lex_state = 3},
  [1879] = {.lex_state = 347, .external_lex_state = 10},
  [1880] = {.lex_state = 110, .external_lex_state = 10},
  [1881] = {.lex_state = 107, .external_lex_state = 4},
  [1882] = {.lex_state = 93, .external_lex_state = 3},
  [1883] = {.lex_state = 78, .external_lex_state = 3},
  [1884] = {.lex_state = 85, .external_lex_state = 3},
  [1885] = {.lex_state = 107, .external_lex_state = 4},
  [1886] = {.lex_state = 107, .external_lex_state = 4},
  [1887] = {.lex_state = 344, .external_lex_state = 5},
  [1888] = {.lex_state = 107, .external_lex_state = 4},
  [1889] = {.lex_state = 343, .external_lex_state = 6},
  [1890] = {.lex_state = 107, .external_lex_state = 4},
  [1891] = {.lex_state = 107, .external_lex_state = 4},
  [1892] = {.lex_state = 107, .external_lex_state = 4},
  [1893] = {.lex_state = 107, .external_lex_state = 4},
  [1894] = {.lex_state = 107, .external_lex_state = 4},
  [1895] = {.lex_state = 149},
  [1896] = {.lex_state = 107, .external_lex_state = 4},
  [1897] = {.lex_state = 107, .external_lex_state = 4},
  [1898] = {.lex_state = 107, .external_lex_state = 4},
  [1899] = {.lex_state = 107, .external_lex_state = 4},
  [1900] = {.lex_state = 107, .external_lex_state = 4},
  [1901] = {.lex_state = 78, .external_lex_state = 3},
  [1902] = {.lex_state = 107, .external_lex_state = 4},
  [1903] = {.lex_state = 107, .external_lex_state = 4},
  [1904] = {.lex_state = 101, .external_lex_state = 3},
  [1905] = {.lex_state = 107, .external_lex_state = 4},
  [1906] = {.lex_state = 344, .external_lex_state = 4},
  [1907] = {.lex_state = 101, .external_lex_state = 3},
  [1908] = {.lex_state = 107, .external_lex_state = 4},
  [1909] = {.lex_state = 344, .external_lex_state = 4},
  [1910] = {.lex_state = 100, .external_lex_state = 3},
  [1911] = {.lex_state = 107, .external_lex_state = 3},
  [1912] = {.lex_state = 347, .external_lex_state = 10},
  [1913] = {.lex_state = 107, .external_lex_state = 4},
  [1914] = {.lex_state = 344, .external_lex_state = 4},
  [1915] = {.lex_state = 110, .external_lex_state = 3},
  [1916] = {.lex_state = 344, .external_lex_state = 4},
  [1917] = {.lex_state = 109, .external_lex_state = 10},
  [1918] = {.lex_state = 345, .external_lex_state = 6},
  [1919] = {.lex_state = 96, .external_lex_state = 3},
  [1920] = {.lex_state = 344, .external_lex_state = 4},
  [1921] = {.lex_state = 78, .external_lex_state = 3},
  [1922] = {.lex_state = 344, .external_lex_state = 4},
  [1923] = {.lex_state = 107, .external_lex_state = 4},
  [1924] = {.lex_state = 344, .external_lex_state = 4},
  [1925] = {.lex_state = 345, .external_lex_state = 6},
  [1926] = {.lex_state = 107, .external_lex_state = 4},
  [1927] = {.lex_state = 107, .external_lex_state = 4},
  [1928] = {.lex_state = 107, .external_lex_state = 4},
  [1929] = {.lex_state = 107, .external_lex_state = 4},
  [1930] = {.lex_state = 107, .external_lex_state = 4},
  [1931] = {.lex_state = 344, .external_lex_state = 4},
  [1932] = {.lex_state = 107, .external_lex_state = 4},
  [1933] = {.lex_state = 344, .external_lex_state = 4},
  [1934] = {.lex_state = 107, .external_lex_state = 4},
  [1935] = {.lex_state = 107, .external_lex_state = 4},
  [1936] = {.lex_state = 107, .external_lex_state = 4},
  [1937] = {.lex_state = 107, .external_lex_state = 4},
  [1938] = {.lex_state = 344, .external_lex_state = 4},
  [1939] = {.lex_state = 344, .external_lex_state = 4},
  [1940] = {.lex_state = 344, .external_lex_state = 4},
  [1941] = {.lex_state = 107, .external_lex_state = 4},
  [1942] = {.lex_state = 344, .external_lex_state = 13},
  [1943] = {.lex_state = 107, .external_lex_state = 4},
  [1944] = {.lex_state = 96, .external_lex_state = 3},
  [1945] = {.lex_state = 103, .external_lex_state = 3},
  [1946] = {.lex_state = 107, .external_lex_state = 4},
  [1947] = {.lex_state = 107, .external_lex_state = 4},
  [1948] = {.lex_state = 344, .external_lex_state = 4},
  [1949] = {.lex_state = 97, .external_lex_state = 3},
  [1950] = {.lex_state = 107, .external_lex_state = 4},
  [1951] = {.lex_state = 344, .external_lex_state = 4},
  [1952] = {.lex_state = 345, .external_lex_state = 6},
  [1953] = {.lex_state = 345, .external_lex_state = 6},
  [1954] = {.lex_state = 344, .external_lex_state = 4},
  [1955] = {.lex_state = 97, .external_lex_state = 3},
  [1956] = {.lex_state = 344, .external_lex_state = 4},
  [1957] = {.lex_state = 344, .external_lex_state = 4},
  [1958] = {.lex_state = 344, .external_lex_state = 4},
  [1959] = {.lex_state = 107, .external_lex_state = 4},
  [1960] = {.lex_state = 107, .external_lex_state = 4},
  [1961] = {.lex_state = 107, .external_lex_state = 4},
  [1962] = {.lex_state = 107, .external_lex_state = 4},
  [1963] = {.lex_state = 107, .external_lex_state = 4},
  [1964] = {.lex_state = 79, .external_lex_state = 3},
  [1965] = {.lex_state = 110, .external_lex_state = 10},
  [1966] = {.lex_state = 344, .external_lex_state = 4},
  [1967] = {.lex_state = 79, .external_lex_state = 3},
  [1968] = {.lex_state = 344, .external_lex_state = 4},
  [1969] = {.lex_state = 344, .external_lex_state = 4},
  [1970] = {.lex_state = 344, .external_lex_state = 4},
  [1971] = {.lex_state = 344, .external_lex_state = 4},
  [1972] = {.lex_state = 344, .external_lex_state = 4},
  [1973] = {.lex_state = 344, .external_lex_state = 4},
  [1974] = {.lex_state = 107, .external_lex_state = 4},
  [1975] = {.lex_state = 107, .external_lex_state = 4},
  [1976] = {.lex_state = 110, .external_lex_state = 10},
  [1977] = {.lex_state = 107, .external_lex_state = 4},
  [1978] = {.lex_state = 107, .external_lex_state = 4},
  [1979] = {.lex_state = 344, .external_lex_state = 4},
  [1980] = {.lex_state = 107, .external_lex_state = 4},
  [1981] = {.lex_state = 344, .external_lex_state = 4},
  [1982] = {.lex_state = 107, .external_lex_state = 4},
  [1983] = {.lex_state = 344, .external_lex_state = 4},
  [1984] = {.lex_state = 78, .external_lex_state = 3},
  [1985] = {.lex_state = 107, .external_lex_state = 4},
  [1986] = {.lex_state = 107, .external_lex_state = 4},
  [1987] = {.lex_state = 107, .external_lex_state = 4},
  [1988] = {.lex_state = 107, .external_lex_state = 4},
  [1989] = {.lex_state = 107, .external_lex_state = 4},
  [1990] = {.lex_state = 107, .external_lex_state = 4},
  [1991] = {.lex_state = 109, .external_lex_state = 3},
  [1992] = {.lex_state = 344, .external_lex_state = 4},
  [1993] = {.lex_state = 107, .external_lex_state = 4},
  [1994] = {.lex_state = 97, .external_lex_state = 3},
  [1995] = {.lex_state = 107, .external_lex_state = 4},
  [1996] = {.lex_state = 97, .external_lex_state = 3},
  [1997] = {.lex_state = 79, .external_lex_state = 3},
  [1998] = {.lex_state = 79, .external_lex_state = 3},
  [1999] = {.lex_state = 344, .external_lex_state = 4},
  [2000] = {.lex_state = 345, .external_lex_state = 6},
  [2001] = {.lex_state = 344, .external_lex_state = 4},
  [2002] = {.lex_state = 344, .external_lex_state = 5},
  [2003] = {.lex_state = 107, .external_lex_state = 4},
  [2004] = {.lex_state = 107, .external_lex_state = 4},
  [2005] = {.lex_state = 149},
  [2006] = {.lex_state = 107, .external_lex_state = 4},
  [2007] = {.lex_state = 344, .external_lex_state = 13},
  [2008] = {.lex_state = 344, .external_lex_state = 4},
  [2009] = {.lex_state = 107, .external_lex_state = 4},
  [2010] = {.lex_state = 107, .external_lex_state = 4},
  [2011] = {.lex_state = 107, .external_lex_state = 4},
  [2012] = {.lex_state = 107, .external_lex_state = 4},
  [2013] = {.lex_state = 344, .external_lex_state = 4},
  [2014] = {.lex_state = 97, .external_lex_state = 3},
  [2015] = {.lex_state = 344, .external_lex_state = 4},
  [2016] = {.lex_state = 344, .external_lex_state = 4},
  [2017] = {.lex_state = 344, .external_lex_state = 4},
  [2018] = {.lex_state = 344, .external_lex_state = 4},
  [2019] = {.lex_state = 344, .external_lex_state = 4},
  [2020] = {.lex_state = 344, .external_lex_state = 4},
  [2021] = {.lex_state = 344, .external_lex_state = 4},
  [2022] = {.lex_state = 107, .external_lex_state = 4},
  [2023] = {.lex_state = 107, .external_lex_state = 4},
  [2024] = {.lex_state = 107, .external_lex_state = 4},
  [2025] = {.lex_state = 107, .external_lex_state = 4},
  [2026] = {.lex_state = 107, .external_lex_state = 4},
  [2027] = {.lex_state = 96, .external_lex_state = 3},
  [2028] = {.lex_state = 344, .external_lex_state = 4},
  [2029] = {.lex_state = 107, .external_lex_state = 4},
  [2030] = {.lex_state = 108, .external_lex_state = 3},
  [2031] = {.lex_state = 78, .external_lex_state = 3},
  [2032] = {.lex_state = 107, .external_lex_state = 3},
  [2033] = {.lex_state = 103, .external_lex_state = 3},
  [2034] = {.lex_state = 78, .external_lex_state = 3},
  [2035] = {.lex_state = 103, .external_lex_state = 3},
  [2036] = {.lex_state = 344, .external_lex_state = 5},
  [2037] = {.lex_state = 107, .external_lex_state = 3},
  [2038] = {.lex_state = 107, .external_lex_state = 3},
  [2039] = {.lex_state = 110, .external_lex_state = 3},
  [2040] = {.lex_state = 107, .external_lex_state = 3},
  [2041] = {.lex_state = 78, .external_lex_state = 3},
  [2042] = {.lex_state = 107, .external_lex_state = 3},
  [2043] = {.lex_state = 107, .external_lex_state = 3},
  [2044] = {.lex_state = 107, .external_lex_state = 3},
  [2045] = {.lex_state = 107, .external_lex_state = 3},
  [2046] = {.lex_state = 78, .external_lex_state = 3},
  [2047] = {.lex_state = 103, .external_lex_state = 3},
  [2048] = {.lex_state = 78, .external_lex_state = 3},
  [2049] = {.lex_state = 85, .external_lex_state = 3},
  [2050] = {.lex_state = 78, .external_lex_state = 3},
  [2051] = {.lex_state = 107, .external_lex_state = 3},
  [2052] = {.lex_state = 354, .external_lex_state = 2},
  [2053] = {.lex_state = 107, .external_lex_state = 3},
  [2054] = {.lex_state = 107, .external_lex_state = 3},
  [2055] = {.lex_state = 107, .external_lex_state = 3},
  [2056] = {.lex_state = 107, .external_lex_state = 3},
  [2057] = {.lex_state = 149},
  [2058] = {.lex_state = 107, .external_lex_state = 3},
  [2059] = {.lex_state = 107, .external_lex_state = 3},
  [2060] = {.lex_state = 107, .external_lex_state = 3},
  [2061] = {.lex_state = 107, .external_lex_state = 3},
  [2062] = {.lex_state = 109, .external_lex_state = 3},
  [2063] = {.lex_state = 78, .external_lex_state = 3},
  [2064] = {.lex_state = 107, .external_lex_state = 3},
  [2065] = {.lex_state = 107, .external_lex_state = 3},
  [2066] = {.lex_state = 107, .external_lex_state = 3},
  [2067] = {.lex_state = 107, .external_lex_state = 3},
  [2068] = {.lex_state = 107, .external_lex_state = 3},
  [2069] = {.lex_state = 107, .external_lex_state = 3},
  [2070] = {.lex_state = 107, .external_lex_state = 3},
  [2071] = {.lex_state = 107, .external_lex_state = 3},
  [2072] = {.lex_state = 107, .external_lex_state = 3},
  [2073] = {.lex_state = 107, .external_lex_state = 3},
  [2074] = {.lex_state = 107, .external_lex_state = 3},
  [2075] = {.lex_state = 107, .external_lex_state = 3},
  [2076] = {.lex_state = 107, .external_lex_state = 3},
  [2077] = {.lex_state = 107, .external_lex_state = 3},
  [2078] = {.lex_state = 107, .external_lex_state = 3},
  [2079] = {.lex_state = 107, .external_lex_state = 3},
  [2080] = {.lex_state = 103, .external_lex_state = 3},
  [2081] = {.lex_state = 164},
  [2082] = {.lex_state = 107, .external_lex_state = 3},
  [2083] = {.lex_state = 107, .external_lex_state = 3},
  [2084] = {.lex_state = 347, .external_lex_state = 3},
  [2085] = {.lex_state = 107, .external_lex_state = 3},
  [2086] = {.lex_state = 107, .external_lex_state = 3},
  [2087] = {.lex_state = 107, .external_lex_state = 3},
  [2088] = {.lex_state = 344, .external_lex_state = 5},
  [2089] = {.lex_state = 107, .external_lex_state = 3},
  [2090] = {.lex_state = 344, .external_lex_state = 6},
  [2091] = {.lex_state = 107, .external_lex_state = 3},
  [2092] = {.lex_state = 347, .external_lex_state = 3},
  [2093] = {.lex_state = 354, .external_lex_state = 2},
  [2094] = {.lex_state = 149},
  [2095] = {.lex_state = 110, .external_lex_state = 3},
  [2096] = {.lex_state = 107, .external_lex_state = 3},
  [2097] = {.lex_state = 107, .external_lex_state = 3},
  [2098] = {.lex_state = 107, .external_lex_state = 3},
  [2099] = {.lex_state = 107, .external_lex_state = 3},
  [2100] = {.lex_state = 344, .external_lex_state = 5},
  [2101] = {.lex_state = 354, .external_lex_state = 2},
  [2102] = {.lex_state = 354, .external_lex_state = 2},
  [2103] = {.lex_state = 107, .external_lex_state = 3},
  [2104] = {.lex_state = 107, .external_lex_state = 3},
  [2105] = {.lex_state = 107, .external_lex_state = 3},
  [2106] = {.lex_state = 354, .external_lex_state = 2},
  [2107] = {.lex_state = 344, .external_lex_state = 5},
  [2108] = {.lex_state = 344, .external_lex_state = 5},
  [2109] = {.lex_state = 344, .external_lex_state = 6},
  [2110] = {.lex_state = 107, .external_lex_state = 3},
  [2111] = {.lex_state = 107, .external_lex_state = 3},
  [2112] = {.lex_state = 107, .external_lex_state = 3},
  [2113] = {.lex_state = 107, .external_lex_state = 3},
  [2114] = {.lex_state = 344, .external_lex_state = 5},
  [2115] = {.lex_state = 107, .external_lex_state = 3},
  [2116] = {.lex_state = 344, .external_lex_state = 5},
  [2117] = {.lex_state = 344, .external_lex_state = 6},
  [2118] = {.lex_state = 107, .external_lex_state = 3},
  [2119] = {.lex_state = 344, .external_lex_state = 5},
  [2120] = {.lex_state = 89, .external_lex_state = 3},
  [2121] = {.lex_state = 89, .external_lex_state = 3},
  [2122] = {.lex_state = 344, .external_lex_state = 5},
  [2123] = {.lex_state = 103, .external_lex_state = 3},
  [2124] = {.lex_state = 344, .external_lex_state = 5},
  [2125] = {.lex_state = 344, .external_lex_state = 6},
  [2126] = {.lex_state = 107, .external_lex_state = 3},
  [2127] = {.lex_state = 107, .external_lex_state = 3},
  [2128] = {.lex_state = 344, .external_lex_state = 6},
  [2129] = {.lex_state = 107, .external_lex_state = 3},
  [2130] = {.lex_state = 78, .external_lex_state = 3},
  [2131] = {.lex_state = 107, .external_lex_state = 3},
  [2132] = {.lex_state = 107, .external_lex_state = 3},
  [2133] = {.lex_state = 344, .external_lex_state = 5},
  [2134] = {.lex_state = 344, .external_lex_state = 6},
  [2135] = {.lex_state = 344, .external_lex_state = 5},
  [2136] = {.lex_state = 107, .external_lex_state = 3},
  [2137] = {.lex_state = 347, .external_lex_state = 3},
  [2138] = {.lex_state = 344, .external_lex_state = 5},
  [2139] = {.lex_state = 107, .external_lex_state = 3},
  [2140] = {.lex_state = 107, .external_lex_state = 3},
  [2141] = {.lex_state = 107, .external_lex_state = 3},
  [2142] = {.lex_state = 107, .external_lex_state = 3},
  [2143] = {.lex_state = 344, .external_lex_state = 5},
  [2144] = {.lex_state = 89, .external_lex_state = 3},
  [2145] = {.lex_state = 107, .external_lex_state = 3},
  [2146] = {.lex_state = 107, .external_lex_state = 3},
  [2147] = {.lex_state = 149},
  [2148] = {.lex_state = 344, .external_lex_state = 5},
  [2149] = {.lex_state = 344, .external_lex_state = 5},
  [2150] = {.lex_state = 101, .external_lex_state = 3},
  [2151] = {.lex_state = 107, .external_lex_state = 3},
  [2152] = {.lex_state = 107, .external_lex_state = 3},
  [2153] = {.lex_state = 97, .external_lex_state = 3},
  [2154] = {.lex_state = 157},
  [2155] = {.lex_state = 97, .external_lex_state = 3},
  [2156] = {.lex_state = 347, .external_lex_state = 3},
  [2157] = {.lex_state = 89, .external_lex_state = 3},
  [2158] = {.lex_state = 107, .external_lex_state = 3},
  [2159] = {.lex_state = 78, .external_lex_state = 3},
  [2160] = {.lex_state = 344, .external_lex_state = 5},
  [2161] = {.lex_state = 344, .external_lex_state = 5},
  [2162] = {.lex_state = 101, .external_lex_state = 3},
  [2163] = {.lex_state = 107, .external_lex_state = 3},
  [2164] = {.lex_state = 149, .external_lex_state = 14},
  [2165] = {.lex_state = 344, .external_lex_state = 5},
  [2166] = {.lex_state = 110, .external_lex_state = 3},
  [2167] = {.lex_state = 109, .external_lex_state = 3},
  [2168] = {.lex_state = 78, .external_lex_state = 3},
  [2169] = {.lex_state = 78, .external_lex_state = 3},
  [2170] = {.lex_state = 344, .external_lex_state = 5},
  [2171] = {.lex_state = 78, .external_lex_state = 3},
  [2172] = {.lex_state = 107, .external_lex_state = 3},
  [2173] = {.lex_state = 78, .external_lex_state = 3},
  [2174] = {.lex_state = 107, .external_lex_state = 3},
  [2175] = {.lex_state = 108, .external_lex_state = 3},
  [2176] = {.lex_state = 103, .external_lex_state = 3},
  [2177] = {.lex_state = 107, .external_lex_state = 3},
  [2178] = {.lex_state = 78, .external_lex_state = 3},
  [2179] = {.lex_state = 78, .external_lex_state = 3},
  [2180] = {.lex_state = 108, .external_lex_state = 3},
  [2181] = {.lex_state = 78, .external_lex_state = 3},
  [2182] = {.lex_state = 345, .external_lex_state = 6},
  [2183] = {.lex_state = 78, .external_lex_state = 3},
  [2184] = {.lex_state = 345, .external_lex_state = 6},
  [2185] = {.lex_state = 78, .external_lex_state = 3},
  [2186] = {.lex_state = 344, .external_lex_state = 6},
  [2187] = {.lex_state = 344, .external_lex_state = 5},
  [2188] = {.lex_state = 109, .external_lex_state = 3},
  [2189] = {.lex_state = 108, .external_lex_state = 3},
  [2190] = {.lex_state = 345, .external_lex_state = 6},
  [2191] = {.lex_state = 344, .external_lex_state = 5},
  [2192] = {.lex_state = 344, .external_lex_state = 5},
  [2193] = {.lex_state = 107, .external_lex_state = 3},
  [2194] = {.lex_state = 78, .external_lex_state = 3},
  [2195] = {.lex_state = 110, .external_lex_state = 3},
  [2196] = {.lex_state = 78, .external_lex_state = 3},
  [2197] = {.lex_state = 78, .external_lex_state = 3},
  [2198] = {.lex_state = 78, .external_lex_state = 3},
  [2199] = {.lex_state = 78, .external_lex_state = 3},
  [2200] = {.lex_state = 78, .external_lex_state = 3},
  [2201] = {.lex_state = 347, .external_lex_state = 3},
  [2202] = {.lex_state = 347, .external_lex_state = 3},
  [2203] = {.lex_state = 78, .external_lex_state = 3},
  [2204] = {.lex_state = 110, .external_lex_state = 3},
  [2205] = {.lex_state = 78, .external_lex_state = 3},
  [2206] = {.lex_state = 78, .external_lex_state = 3},
  [2207] = {.lex_state = 78, .external_lex_state = 3},
  [2208] = {.lex_state = 344, .external_lex_state = 5},
  [2209] = {.lex_state = 107, .external_lex_state = 3},
  [2210] = {.lex_state = 97, .external_lex_state = 3},
  [2211] = {.lex_state = 344, .external_lex_state = 5},
  [2212] = {.lex_state = 78, .external_lex_state = 3},
  [2213] = {.lex_state = 78, .external_lex_state = 3},
  [2214] = {.lex_state = 344, .external_lex_state = 5},
  [2215] = {.lex_state = 344, .external_lex_state = 5},
  [2216] = {.lex_state = 78, .external_lex_state = 3},
  [2217] = {.lex_state = 78, .external_lex_state = 3},
  [2218] = {.lex_state = 78, .external_lex_state = 3},
  [2219] = {.lex_state = 78, .external_lex_state = 3},
  [2220] = {.lex_state = 78, .external_lex_state = 3},
  [2221] = {.lex_state = 78, .external_lex_state = 3},
  [2222] = {.lex_state = 78, .external_lex_state = 3},
  [2223] = {.lex_state = 78, .external_lex_state = 3},
  [2224] = {.lex_state = 344, .external_lex_state = 5},
  [2225] = {.lex_state = 78, .external_lex_state = 3},
  [2226] = {.lex_state = 78, .external_lex_state = 3},
  [2227] = {.lex_state = 78, .external_lex_state = 3},
  [2228] = {.lex_state = 78, .external_lex_state = 3},
  [2229] = {.lex_state = 78, .external_lex_state = 3},
  [2230] = {.lex_state = 101, .external_lex_state = 3},
  [2231] = {.lex_state = 101, .external_lex_state = 3},
  [2232] = {.lex_state = 78, .external_lex_state = 3},
  [2233] = {.lex_state = 78, .external_lex_state = 3},
  [2234] = {.lex_state = 78, .external_lex_state = 3},
  [2235] = {.lex_state = 110, .external_lex_state = 3},
  [2236] = {.lex_state = 149},
  [2237] = {.lex_state = 344, .external_lex_state = 5},
  [2238] = {.lex_state = 344, .external_lex_state = 5},
  [2239] = {.lex_state = 344, .external_lex_state = 5},
  [2240] = {.lex_state = 344, .external_lex_state = 5},
  [2241] = {.lex_state = 78, .external_lex_state = 3},
  [2242] = {.lex_state = 157},
  [2243] = {.lex_state = 97, .external_lex_state = 3},
  [2244] = {.lex_state = 110, .external_lex_state = 3},
  [2245] = {.lex_state = 85, .external_lex_state = 3},
  [2246] = {.lex_state = 78, .external_lex_state = 3},
  [2247] = {.lex_state = 78, .external_lex_state = 3},
  [2248] = {.lex_state = 78, .external_lex_state = 3},
  [2249] = {.lex_state = 344, .external_lex_state = 6},
  [2250] = {.lex_state = 103, .external_lex_state = 3},
  [2251] = {.lex_state = 347, .external_lex_state = 3},
  [2252] = {.lex_state = 344, .external_lex_state = 5},
  [2253] = {.lex_state = 107, .external_lex_state = 3},
  [2254] = {.lex_state = 109, .external_lex_state = 3},
  [2255] = {.lex_state = 78, .external_lex_state = 3},
  [2256] = {.lex_state = 78, .external_lex_state = 3},
  [2257] = {.lex_state = 344, .external_lex_state = 5},
  [2258] = {.lex_state = 344, .external_lex_state = 5},
  [2259] = {.lex_state = 344, .external_lex_state = 5},
  [2260] = {.lex_state = 344, .external_lex_state = 5},
  [2261] = {.lex_state = 109, .external_lex_state = 3},
  [2262] = {.lex_state = 101, .external_lex_state = 3},
  [2263] = {.lex_state = 344, .external_lex_state = 5},
  [2264] = {.lex_state = 78, .external_lex_state = 3},
  [2265] = {.lex_state = 78, .external_lex_state = 3},
  [2266] = {.lex_state = 78, .external_lex_state = 3},
  [2267] = {.lex_state = 345, .external_lex_state = 6},
  [2268] = {.lex_state = 149},
  [2269] = {.lex_state = 89, .external_lex_state = 3},
  [2270] = {.lex_state = 78, .external_lex_state = 3},
  [2271] = {.lex_state = 78, .external_lex_state = 3},
  [2272] = {.lex_state = 78, .external_lex_state = 3},
  [2273] = {.lex_state = 78, .external_lex_state = 3},
  [2274] = {.lex_state = 78, .external_lex_state = 3},
  [2275] = {.lex_state = 344, .external_lex_state = 5},
  [2276] = {.lex_state = 354, .external_lex_state = 2},
  [2277] = {.lex_state = 344, .external_lex_state = 5},
  [2278] = {.lex_state = 347, .external_lex_state = 3},
  [2279] = {.lex_state = 103, .external_lex_state = 3},
  [2280] = {.lex_state = 344, .external_lex_state = 5},
  [2281] = {.lex_state = 347, .external_lex_state = 3},
  [2282] = {.lex_state = 78, .external_lex_state = 3},
  [2283] = {.lex_state = 108, .external_lex_state = 3},
  [2284] = {.lex_state = 149},
  [2285] = {.lex_state = 344, .external_lex_state = 5},
  [2286] = {.lex_state = 344, .external_lex_state = 5},
  [2287] = {.lex_state = 344, .external_lex_state = 5},
  [2288] = {.lex_state = 344, .external_lex_state = 5},
  [2289] = {.lex_state = 344, .external_lex_state = 5},
  [2290] = {.lex_state = 344, .external_lex_state = 5},
  [2291] = {.lex_state = 78, .external_lex_state = 3},
  [2292] = {.lex_state = 344, .external_lex_state = 5},
  [2293] = {.lex_state = 344, .external_lex_state = 5},
  [2294] = {.lex_state = 344, .external_lex_state = 5},
  [2295] = {.lex_state = 78, .external_lex_state = 3},
  [2296] = {.lex_state = 78, .external_lex_state = 3},
  [2297] = {.lex_state = 97, .external_lex_state = 3},
  [2298] = {.lex_state = 78, .external_lex_state = 3},
  [2299] = {.lex_state = 78, .external_lex_state = 3},
  [2300] = {.lex_state = 344, .external_lex_state = 5},
  [2301] = {.lex_state = 107, .external_lex_state = 3},
  [2302] = {.lex_state = 344, .external_lex_state = 5},
  [2303] = {.lex_state = 78, .external_lex_state = 3},
  [2304] = {.lex_state = 109, .external_lex_state = 3},
  [2305] = {.lex_state = 78, .external_lex_state = 3},
  [2306] = {.lex_state = 344, .external_lex_state = 5},
  [2307] = {.lex_state = 344, .external_lex_state = 5},
  [2308] = {.lex_state = 344, .external_lex_state = 5},
  [2309] = {.lex_state = 344, .external_lex_state = 5},
  [2310] = {.lex_state = 78, .external_lex_state = 3},
  [2311] = {.lex_state = 78, .external_lex_state = 3},
  [2312] = {.lex_state = 78, .external_lex_state = 3},
  [2313] = {.lex_state = 354, .external_lex_state = 2},
  [2314] = {.lex_state = 344, .external_lex_state = 5},
  [2315] = {.lex_state = 78, .external_lex_state = 3},
  [2316] = {.lex_state = 149},
  [2317] = {.lex_state = 109, .external_lex_state = 3},
  [2318] = {.lex_state = 78, .external_lex_state = 3},
  [2319] = {.lex_state = 78, .external_lex_state = 3},
  [2320] = {.lex_state = 344, .external_lex_state = 5},
  [2321] = {.lex_state = 344, .external_lex_state = 5},
  [2322] = {.lex_state = 344, .external_lex_state = 5},
  [2323] = {.lex_state = 344, .external_lex_state = 5},
  [2324] = {.lex_state = 344, .external_lex_state = 5},
  [2325] = {.lex_state = 344, .external_lex_state = 5},
  [2326] = {.lex_state = 344, .external_lex_state = 5},
  [2327] = {.lex_state = 344, .external_lex_state = 5},
  [2328] = {.lex_state = 344, .external_lex_state = 5},
  [2329] = {.lex_state = 344, .external_lex_state = 5},
  [2330] = {.lex_state = 78, .external_lex_state = 3},
  [2331] = {.lex_state = 78, .external_lex_state = 3},
  [2332] = {.lex_state = 110, .external_lex_state = 3},
  [2333] = {.lex_state = 344, .external_lex_state = 5},
  [2334] = {.lex_state = 345, .external_lex_state = 6},
  [2335] = {.lex_state = 344, .external_lex_state = 5},
  [2336] = {.lex_state = 344, .external_lex_state = 5},
  [2337] = {.lex_state = 344, .external_lex_state = 5},
  [2338] = {.lex_state = 344, .external_lex_state = 5},
  [2339] = {.lex_state = 344, .external_lex_state = 5},
  [2340] = {.lex_state = 109, .external_lex_state = 3},
  [2341] = {.lex_state = 78, .external_lex_state = 3},
  [2342] = {.lex_state = 344, .external_lex_state = 5},
  [2343] = {.lex_state = 344, .external_lex_state = 5},
  [2344] = {.lex_state = 344, .external_lex_state = 5},
  [2345] = {.lex_state = 344, .external_lex_state = 5},
  [2346] = {.lex_state = 78, .external_lex_state = 3},
  [2347] = {.lex_state = 344, .external_lex_state = 6},
  [2348] = {.lex_state = 354, .external_lex_state = 7},
  [2349] = {.lex_state = 347, .external_lex_state = 3},
  [2350] = {.lex_state = 347, .external_lex_state = 3},
  [2351] = {.lex_state = 344, .external_lex_state = 6},
  [2352] = {.lex_state = 344, .external_lex_state = 6},
  [2353] = {.lex_state = 109, .external_lex_state = 3},
  [2354] = {.lex_state = 109, .external_lex_state = 3},
  [2355] = {.lex_state = 110, .external_lex_state = 3},
  [2356] = {.lex_state = 149},
  [2357] = {.lex_state = 347, .external_lex_state = 3},
  [2358] = {.lex_state = 344, .external_lex_state = 6},
  [2359] = {.lex_state = 344, .external_lex_state = 6},
  [2360] = {.lex_state = 109, .external_lex_state = 3},
  [2361] = {.lex_state = 354, .external_lex_state = 2},
  [2362] = {.lex_state = 347, .external_lex_state = 3},
  [2363] = {.lex_state = 109, .external_lex_state = 3},
  [2364] = {.lex_state = 109, .external_lex_state = 3},
  [2365] = {.lex_state = 347, .external_lex_state = 3},
  [2366] = {.lex_state = 344, .external_lex_state = 6},
  [2367] = {.lex_state = 344, .external_lex_state = 6},
  [2368] = {.lex_state = 344, .external_lex_state = 6},
  [2369] = {.lex_state = 344, .external_lex_state = 6},
  [2370] = {.lex_state = 109, .external_lex_state = 3},
  [2371] = {.lex_state = 344, .external_lex_state = 6},
  [2372] = {.lex_state = 110, .external_lex_state = 3},
  [2373] = {.lex_state = 109, .external_lex_state = 3},
  [2374] = {.lex_state = 110, .external_lex_state = 3},
  [2375] = {.lex_state = 344, .external_lex_state = 6},
  [2376] = {.lex_state = 344, .external_lex_state = 6},
  [2377] = {.lex_state = 344, .external_lex_state = 6},
  [2378] = {.lex_state = 110, .external_lex_state = 3},
  [2379] = {.lex_state = 344, .external_lex_state = 6},
  [2380] = {.lex_state = 344, .external_lex_state = 6},
  [2381] = {.lex_state = 103, .external_lex_state = 3},
  [2382] = {.lex_state = 344, .external_lex_state = 6},
  [2383] = {.lex_state = 347, .external_lex_state = 3},
  [2384] = {.lex_state = 344, .external_lex_state = 6},
  [2385] = {.lex_state = 344, .external_lex_state = 6},
  [2386] = {.lex_state = 347, .external_lex_state = 3},
  [2387] = {.lex_state = 109, .external_lex_state = 3},
  [2388] = {.lex_state = 347, .external_lex_state = 3},
  [2389] = {.lex_state = 103, .external_lex_state = 3},
  [2390] = {.lex_state = 103, .external_lex_state = 3},
  [2391] = {.lex_state = 109, .external_lex_state = 3},
  [2392] = {.lex_state = 110, .external_lex_state = 3},
  [2393] = {.lex_state = 356},
  [2394] = {.lex_state = 344, .external_lex_state = 6},
  [2395] = {.lex_state = 344, .external_lex_state = 6},
  [2396] = {.lex_state = 344, .external_lex_state = 6},
  [2397] = {.lex_state = 344, .external_lex_state = 6},
  [2398] = {.lex_state = 344, .external_lex_state = 6},
  [2399] = {.lex_state = 347, .external_lex_state = 3},
  [2400] = {.lex_state = 149},
  [2401] = {.lex_state = 103, .external_lex_state = 3},
  [2402] = {.lex_state = 347, .external_lex_state = 3},
  [2403] = {.lex_state = 109, .external_lex_state = 3},
  [2404] = {.lex_state = 344, .external_lex_state = 6},
  [2405] = {.lex_state = 347, .external_lex_state = 3},
  [2406] = {.lex_state = 344, .external_lex_state = 6},
  [2407] = {.lex_state = 110, .external_lex_state = 3},
  [2408] = {.lex_state = 103, .external_lex_state = 3},
  [2409] = {.lex_state = 103, .external_lex_state = 3},
  [2410] = {.lex_state = 354, .external_lex_state = 2},
  [2411] = {.lex_state = 103, .external_lex_state = 3},
  [2412] = {.lex_state = 103, .external_lex_state = 3},
  [2413] = {.lex_state = 344, .external_lex_state = 6},
  [2414] = {.lex_state = 347, .external_lex_state = 3},
  [2415] = {.lex_state = 347, .external_lex_state = 3},
  [2416] = {.lex_state = 344, .external_lex_state = 6},
  [2417] = {.lex_state = 344, .external_lex_state = 6},
  [2418] = {.lex_state = 344, .external_lex_state = 6},
  [2419] = {.lex_state = 344, .external_lex_state = 6},
  [2420] = {.lex_state = 344, .external_lex_state = 6},
  [2421] = {.lex_state = 354, .external_lex_state = 2},
  [2422] = {.lex_state = 110, .external_lex_state = 3},
  [2423] = {.lex_state = 347, .external_lex_state = 3},
  [2424] = {.lex_state = 109, .external_lex_state = 3},
  [2425] = {.lex_state = 109, .external_lex_state = 3},
  [2426] = {.lex_state = 347, .external_lex_state = 3},
  [2427] = {.lex_state = 347, .external_lex_state = 3},
  [2428] = {.lex_state = 347, .external_lex_state = 3},
  [2429] = {.lex_state = 344, .external_lex_state = 6},
  [2430] = {.lex_state = 109, .external_lex_state = 3},
  [2431] = {.lex_state = 109, .external_lex_state = 3},
  [2432] = {.lex_state = 110, .external_lex_state = 3},
  [2433] = {.lex_state = 347, .external_lex_state = 3},
  [2434] = {.lex_state = 347, .external_lex_state = 3},
  [2435] = {.lex_state = 344, .external_lex_state = 6},
  [2436] = {.lex_state = 344, .external_lex_state = 6},
  [2437] = {.lex_state = 347, .external_lex_state = 3},
  [2438] = {.lex_state = 110, .external_lex_state = 3},
  [2439] = {.lex_state = 354, .external_lex_state = 7},
  [2440] = {.lex_state = 344, .external_lex_state = 6},
  [2441] = {.lex_state = 110, .external_lex_state = 3},
  [2442] = {.lex_state = 347, .external_lex_state = 3},
  [2443] = {.lex_state = 110, .external_lex_state = 3},
  [2444] = {.lex_state = 356},
  [2445] = {.lex_state = 356},
  [2446] = {.lex_state = 110, .external_lex_state = 3},
  [2447] = {.lex_state = 110, .external_lex_state = 3},
  [2448] = {.lex_state = 356},
  [2449] = {.lex_state = 356},
  [2450] = {.lex_state = 347, .external_lex_state = 3},
  [2451] = {.lex_state = 110, .external_lex_state = 3},
  [2452] = {.lex_state = 347, .external_lex_state = 3},
  [2453] = {.lex_state = 347, .external_lex_state = 3},
  [2454] = {.lex_state = 347, .external_lex_state = 3},
  [2455] = {.lex_state = 110, .external_lex_state = 3},
  [2456] = {.lex_state = 110, .external_lex_state = 3},
  [2457] = {.lex_state = 110, .external_lex_state = 3},
  [2458] = {.lex_state = 109, .external_lex_state = 3},
  [2459] = {.lex_state = 110, .external_lex_state = 3},
  [2460] = {.lex_state = 110, .external_lex_state = 3},
  [2461] = {.lex_state = 110, .external_lex_state = 3},
  [2462] = {.lex_state = 110, .external_lex_state = 3},
  [2463] = {.lex_state = 347, .external_lex_state = 3},
  [2464] = {.lex_state = 347, .external_lex_state = 3},
  [2465] = {.lex_state = 109, .external_lex_state = 3},
  [2466] = {.lex_state = 344, .external_lex_state = 6},
  [2467] = {.lex_state = 109, .external_lex_state = 3},
  [2468] = {.lex_state = 347, .external_lex_state = 3},
  [2469] = {.lex_state = 109, .external_lex_state = 3},
  [2470] = {.lex_state = 109, .external_lex_state = 3},
  [2471] = {.lex_state = 109, .external_lex_state = 3},
  [2472] = {.lex_state = 109, .external_lex_state = 3},
  [2473] = {.lex_state = 109, .external_lex_state = 3},
  [2474] = {.lex_state = 109, .external_lex_state = 3},
  [2475] = {.lex_state = 109, .external_lex_state = 3},
  [2476] = {.lex_state = 109, .external_lex_state = 3},
  [2477] = {.lex_state = 109, .external_lex_state = 3},
  [2478] = {.lex_state = 109, .external_lex_state = 3},
  [2479] = {.lex_state = 109, .external_lex_state = 3},
  [2480] = {.lex_state = 110, .external_lex_state = 3},
  [2481] = {.lex_state = 356},
  [2482] = {.lex_state = 356},
  [2483] = {.lex_state = 109, .external_lex_state = 3},
  [2484] = {.lex_state = 109, .external_lex_state = 3},
  [2485] = {.lex_state = 356},
  [2486] = {.lex_state = 344, .external_lex_state = 6},
  [2487] = {.lex_state = 109, .external_lex_state = 3},
  [2488] = {.lex_state = 109, .external_lex_state = 3},
  [2489] = {.lex_state = 109, .external_lex_state = 3},
  [2490] = {.lex_state = 109, .external_lex_state = 3},
  [2491] = {.lex_state = 109, .external_lex_state = 3},
  [2492] = {.lex_state = 344, .external_lex_state = 6},
  [2493] = {.lex_state = 109, .external_lex_state = 3},
  [2494] = {.lex_state = 109, .external_lex_state = 3},
  [2495] = {.lex_state = 344, .external_lex_state = 6},
  [2496] = {.lex_state = 356},
  [2497] = {.lex_state = 110, .external_lex_state = 3},
  [2498] = {.lex_state = 109, .external_lex_state = 3},
  [2499] = {.lex_state = 109, .external_lex_state = 3},
  [2500] = {.lex_state = 356},
  [2501] = {.lex_state = 344, .external_lex_state = 6},
  [2502] = {.lex_state = 344, .external_lex_state = 6},
  [2503] = {.lex_state = 356},
  [2504] = {.lex_state = 344, .external_lex_state = 6},
  [2505] = {.lex_state = 347, .external_lex_state = 3},
  [2506] = {.lex_state = 347, .external_lex_state = 3},
  [2507] = {.lex_state = 110, .external_lex_state = 3},
  [2508] = {.lex_state = 110, .external_lex_state = 3},
  [2509] = {.lex_state = 344, .external_lex_state = 6},
  [2510] = {.lex_state = 344, .external_lex_state = 6},
  [2511] = {.lex_state = 110, .external_lex_state = 3},
  [2512] = {.lex_state = 109, .external_lex_state = 3},
  [2513] = {.lex_state = 110, .external_lex_state = 3},
  [2514] = {.lex_state = 110, .external_lex_state = 3},
  [2515] = {.lex_state = 110, .external_lex_state = 3},
  [2516] = {.lex_state = 109, .external_lex_state = 3},
  [2517] = {.lex_state = 109, .external_lex_state = 3},
  [2518] = {.lex_state = 109, .external_lex_state = 3},
  [2519] = {.lex_state = 109, .external_lex_state = 3},
  [2520] = {.lex_state = 109, .external_lex_state = 3},
  [2521] = {.lex_state = 347, .external_lex_state = 3},
  [2522] = {.lex_state = 110, .external_lex_state = 3},
  [2523] = {.lex_state = 110, .external_lex_state = 3},
  [2524] = {.lex_state = 110, .external_lex_state = 3},
  [2525] = {.lex_state = 347, .external_lex_state = 3},
  [2526] = {.lex_state = 347, .external_lex_state = 3},
  [2527] = {.lex_state = 344, .external_lex_state = 6},
  [2528] = {.lex_state = 347, .external_lex_state = 3},
  [2529] = {.lex_state = 347, .external_lex_state = 3},
  [2530] = {.lex_state = 109, .external_lex_state = 3},
  [2531] = {.lex_state = 354, .external_lex_state = 7},
  [2532] = {.lex_state = 109, .external_lex_state = 3},
  [2533] = {.lex_state = 109, .external_lex_state = 3},
  [2534] = {.lex_state = 109, .external_lex_state = 3},
  [2535] = {.lex_state = 109, .external_lex_state = 3},
  [2536] = {.lex_state = 109, .external_lex_state = 3},
  [2537] = {.lex_state = 109, .external_lex_state = 3},
  [2538] = {.lex_state = 103, .external_lex_state = 3},
  [2539] = {.lex_state = 110, .external_lex_state = 3},
  [2540] = {.lex_state = 344, .external_lex_state = 6},
  [2541] = {.lex_state = 149},
  [2542] = {.lex_state = 356},
  [2543] = {.lex_state = 103, .external_lex_state = 3},
  [2544] = {.lex_state = 344, .external_lex_state = 6},
  [2545] = {.lex_state = 109, .external_lex_state = 3},
  [2546] = {.lex_state = 110, .external_lex_state = 3},
  [2547] = {.lex_state = 110, .external_lex_state = 3},
  [2548] = {.lex_state = 103, .external_lex_state = 3},
  [2549] = {.lex_state = 110, .external_lex_state = 3},
  [2550] = {.lex_state = 347, .external_lex_state = 3},
  [2551] = {.lex_state = 110, .external_lex_state = 3},
  [2552] = {.lex_state = 109, .external_lex_state = 3},
  [2553] = {.lex_state = 344, .external_lex_state = 6},
  [2554] = {.lex_state = 347, .external_lex_state = 3},
  [2555] = {.lex_state = 109, .external_lex_state = 3},
  [2556] = {.lex_state = 103, .external_lex_state = 3},
  [2557] = {.lex_state = 103, .external_lex_state = 3},
  [2558] = {.lex_state = 347, .external_lex_state = 3},
  [2559] = {.lex_state = 356},
  [2560] = {.lex_state = 347, .external_lex_state = 3},
  [2561] = {.lex_state = 110, .external_lex_state = 3},
  [2562] = {.lex_state = 344, .external_lex_state = 6},
  [2563] = {.lex_state = 110, .external_lex_state = 3},
  [2564] = {.lex_state = 110, .external_lex_state = 3},
  [2565] = {.lex_state = 103, .external_lex_state = 3},
  [2566] = {.lex_state = 347, .external_lex_state = 3},
  [2567] = {.lex_state = 103, .external_lex_state = 3},
  [2568] = {.lex_state = 110, .external_lex_state = 3},
  [2569] = {.lex_state = 344, .external_lex_state = 6},
  [2570] = {.lex_state = 103, .external_lex_state = 3},
  [2571] = {.lex_state = 356},
  [2572] = {.lex_state = 344, .external_lex_state = 6},
  [2573] = {.lex_state = 164},
  [2574] = {.lex_state = 344, .external_lex_state = 6},
  [2575] = {.lex_state = 109, .external_lex_state = 3},
  [2576] = {.lex_state = 109, .external_lex_state = 3},
  [2577] = {.lex_state = 344, .external_lex_state = 6},
  [2578] = {.lex_state = 109, .external_lex_state = 3},
  [2579] = {.lex_state = 110, .external_lex_state = 3},
  [2580] = {.lex_state = 344, .external_lex_state = 6},
  [2581] = {.lex_state = 110, .external_lex_state = 3},
  [2582] = {.lex_state = 344, .external_lex_state = 6},
  [2583] = {.lex_state = 347, .external_lex_state = 3},
  [2584] = {.lex_state = 347, .external_lex_state = 3},
  [2585] = {.lex_state = 110, .external_lex_state = 3},
  [2586] = {.lex_state = 110, .external_lex_state = 3},
  [2587] = {.lex_state = 356},
  [2588] = {.lex_state = 103, .external_lex_state = 3},
  [2589] = {.lex_state = 347, .external_lex_state = 3},
  [2590] = {.lex_state = 109, .external_lex_state = 3},
  [2591] = {.lex_state = 347, .external_lex_state = 3},
  [2592] = {.lex_state = 354, .external_lex_state = 2},
  [2593] = {.lex_state = 110, .external_lex_state = 3},
  [2594] = {.lex_state = 109, .external_lex_state = 3},
  [2595] = {.lex_state = 347, .external_lex_state = 3},
  [2596] = {.lex_state = 109, .external_lex_state = 3},
  [2597] = {.lex_state = 110, .external_lex_state = 3},
  [2598] = {.lex_state = 110, .external_lex_state = 3},
  [2599] = {.lex_state = 109, .external_lex_state = 3},
  [2600] = {.lex_state = 103, .external_lex_state = 3},
  [2601] = {.lex_state = 110, .external_lex_state = 3},
  [2602] = {.lex_state = 110, .external_lex_state = 3},
  [2603] = {.lex_state = 109, .external_lex_state = 3},
  [2604] = {.lex_state = 354, .external_lex_state = 2},
  [2605] = {.lex_state = 103, .external_lex_state = 3},
  [2606] = {.lex_state = 103, .external_lex_state = 3},
  [2607] = {.lex_state = 356},
  [2608] = {.lex_state = 347, .external_lex_state = 3},
  [2609] = {.lex_state = 347, .external_lex_state = 3},
  [2610] = {.lex_state = 344, .external_lex_state = 6},
  [2611] = {.lex_state = 344, .external_lex_state = 6},
  [2612] = {.lex_state = 344, .external_lex_state = 6},
  [2613] = {.lex_state = 344, .external_lex_state = 6},
  [2614] = {.lex_state = 344, .external_lex_state = 6},
  [2615] = {.lex_state = 149},
  [2616] = {.lex_state = 354, .external_lex_state = 2},
  [2617] = {.lex_state = 103, .external_lex_state = 3},
  [2618] = {.lex_state = 103, .external_lex_state = 3},
  [2619] = {.lex_state = 103, .external_lex_state = 3},
  [2620] = {.lex_state = 354, .external_lex_state = 2},
  [2621] = {.lex_state = 347, .external_lex_state = 3},
  [2622] = {.lex_state = 347, .external_lex_state = 3},
  [2623] = {.lex_state = 347, .external_lex_state = 3},
  [2624] = {.lex_state = 103, .external_lex_state = 3},
  [2625] = {.lex_state = 344, .external_lex_state = 6},
  [2626] = {.lex_state = 344, .external_lex_state = 6},
  [2627] = {.lex_state = 110, .external_lex_state = 3},
  [2628] = {.lex_state = 110, .external_lex_state = 3},
  [2629] = {.lex_state = 110, .external_lex_state = 3},
  [2630] = {.lex_state = 103, .external_lex_state = 3},
  [2631] = {.lex_state = 110, .external_lex_state = 3},
  [2632] = {.lex_state = 103, .external_lex_state = 3},
  [2633] = {.lex_state = 103, .external_lex_state = 3},
  [2634] = {.lex_state = 347, .external_lex_state = 3},
  [2635] = {.lex_state = 110, .external_lex_state = 3},
  [2636] = {.lex_state = 110, .external_lex_state = 3},
  [2637] = {.lex_state = 347, .external_lex_state = 3},
  [2638] = {.lex_state = 356},
  [2639] = {.lex_state = 347, .external_lex_state = 3},
  [2640] = {.lex_state = 347, .external_lex_state = 3},
  [2641] = {.lex_state = 109, .external_lex_state = 3},
  [2642] = {.lex_state = 347, .external_lex_state = 3},
  [2643] = {.lex_state = 344, .external_lex_state = 6},
  [2644] = {.lex_state = 354, .external_lex_state = 2},
  [2645] = {.lex_state = 344, .external_lex_state = 6},
  [2646] = {.lex_state = 110, .external_lex_state = 3},
  [2647] = {.lex_state = 344, .external_lex_state = 6},
  [2648] = {.lex_state = 344, .external_lex_state = 6},
  [2649] = {.lex_state = 103, .external_lex_state = 3},
  [2650] = {.lex_state = 109, .external_lex_state = 3},
  [2651] = {.lex_state = 356},
  [2652] = {.lex_state = 103, .external_lex_state = 3},
  [2653] = {.lex_state = 103, .external_lex_state = 3},
  [2654] = {.lex_state = 103, .external_lex_state = 3},
  [2655] = {.lex_state = 103, .external_lex_state = 3},
  [2656] = {.lex_state = 103, .external_lex_state = 3},
  [2657] = {.lex_state = 103, .external_lex_state = 3},
  [2658] = {.lex_state = 344, .external_lex_state = 6},
  [2659] = {.lex_state = 344, .external_lex_state = 6},
  [2660] = {.lex_state = 110, .external_lex_state = 3},
  [2661] = {.lex_state = 347, .external_lex_state = 3},
  [2662] = {.lex_state = 110, .external_lex_state = 3},
  [2663] = {.lex_state = 110, .external_lex_state = 3},
  [2664] = {.lex_state = 110, .external_lex_state = 3},
  [2665] = {.lex_state = 344, .external_lex_state = 6},
  [2666] = {.lex_state = 344, .external_lex_state = 6},
  [2667] = {.lex_state = 103, .external_lex_state = 3},
  [2668] = {.lex_state = 347, .external_lex_state = 3},
  [2669] = {.lex_state = 344, .external_lex_state = 6},
  [2670] = {.lex_state = 110, .external_lex_state = 3},
  [2671] = {.lex_state = 344, .external_lex_state = 6},
  [2672] = {.lex_state = 347, .external_lex_state = 3},
  [2673] = {.lex_state = 354, .external_lex_state = 7},
  [2674] = {.lex_state = 344, .external_lex_state = 6},
  [2675] = {.lex_state = 347, .external_lex_state = 3},
  [2676] = {.lex_state = 347, .external_lex_state = 3},
  [2677] = {.lex_state = 110, .external_lex_state = 3},
  [2678] = {.lex_state = 103, .external_lex_state = 3},
  [2679] = {.lex_state = 149},
  [2680] = {.lex_state = 344, .external_lex_state = 6},
  [2681] = {.lex_state = 157},
  [2682] = {.lex_state = 354, .external_lex_state = 7},
  [2683] = {.lex_state = 103, .external_lex_state = 3},
  [2684] = {.lex_state = 347, .external_lex_state = 3},
  [2685] = {.lex_state = 103, .external_lex_state = 3},
  [2686] = {.lex_state = 103, .external_lex_state = 3},
  [2687] = {.lex_state = 103, .external_lex_state = 3},
  [2688] = {.lex_state = 103, .external_lex_state = 3},
  [2689] = {.lex_state = 103, .external_lex_state = 3},
  [2690] = {.lex_state = 356},
  [2691] = {.lex_state = 347, .external_lex_state = 3},
  [2692] = {.lex_state = 110, .external_lex_state = 3},
  [2693] = {.lex_state = 110, .external_lex_state = 3},
  [2694] = {.lex_state = 103, .external_lex_state = 3},
  [2695] = {.lex_state = 110, .external_lex_state = 3},
  [2696] = {.lex_state = 110, .external_lex_state = 3},
  [2697] = {.lex_state = 103, .external_lex_state = 3},
  [2698] = {.lex_state = 149},
  [2699] = {.lex_state = 110, .external_lex_state = 3},
  [2700] = {.lex_state = 103, .external_lex_state = 3},
  [2701] = {.lex_state = 103, .external_lex_state = 3},
  [2702] = {.lex_state = 103, .external_lex_state = 3},
  [2703] = {.lex_state = 103, .external_lex_state = 3},
  [2704] = {.lex_state = 103, .external_lex_state = 3},
  [2705] = {.lex_state = 103, .external_lex_state = 3},
  [2706] = {.lex_state = 103, .external_lex_state = 3},
  [2707] = {.lex_state = 347, .external_lex_state = 3},
  [2708] = {.lex_state = 110, .external_lex_state = 3},
  [2709] = {.lex_state = 110, .external_lex_state = 3},
  [2710] = {.lex_state = 110, .external_lex_state = 3},
  [2711] = {.lex_state = 347, .external_lex_state = 3},
  [2712] = {.lex_state = 356},
  [2713] = {.lex_state = 110, .external_lex_state = 3},
  [2714] = {.lex_state = 103, .external_lex_state = 3},
  [2715] = {.lex_state = 356},
  [2716] = {.lex_state = 356},
  [2717] = {.lex_state = 344, .external_lex_state = 6},
  [2718] = {.lex_state = 103, .external_lex_state = 3},
  [2719] = {.lex_state = 344, .external_lex_state = 6},
  [2720] = {.lex_state = 347, .external_lex_state = 3},
  [2721] = {.lex_state = 103, .external_lex_state = 3},
  [2722] = {.lex_state = 103, .external_lex_state = 3},
  [2723] = {.lex_state = 110, .external_lex_state = 3},
  [2724] = {.lex_state = 103, .external_lex_state = 3},
  [2725] = {.lex_state = 103, .external_lex_state = 3},
  [2726] = {.lex_state = 103, .external_lex_state = 3},
  [2727] = {.lex_state = 110, .external_lex_state = 3},
  [2728] = {.lex_state = 356},
  [2729] = {.lex_state = 356},
  [2730] = {.lex_state = 356},
  [2731] = {.lex_state = 347, .external_lex_state = 3},
  [2732] = {.lex_state = 103, .external_lex_state = 3},
  [2733] = {.lex_state = 347, .external_lex_state = 3},
  [2734] = {.lex_state = 110, .external_lex_state = 3},
  [2735] = {.lex_state = 109, .external_lex_state = 3},
  [2736] = {.lex_state = 164},
  [2737] = {.lex_state = 103, .external_lex_state = 3},
  [2738] = {.lex_state = 103, .external_lex_state = 3},
  [2739] = {.lex_state = 354, .external_lex_state = 7},
  [2740] = {.lex_state = 109, .external_lex_state = 3},
  [2741] = {.lex_state = 103, .external_lex_state = 3},
  [2742] = {.lex_state = 109, .external_lex_state = 3},
  [2743] = {.lex_state = 347, .external_lex_state = 3},
  [2744] = {.lex_state = 344, .external_lex_state = 6},
  [2745] = {.lex_state = 109, .external_lex_state = 3},
  [2746] = {.lex_state = 109, .external_lex_state = 3},
  [2747] = {.lex_state = 109, .external_lex_state = 3},
  [2748] = {.lex_state = 103, .external_lex_state = 3},
  [2749] = {.lex_state = 103, .external_lex_state = 3},
  [2750] = {.lex_state = 109, .external_lex_state = 3},
  [2751] = {.lex_state = 347, .external_lex_state = 3},
  [2752] = {.lex_state = 103, .external_lex_state = 3},
  [2753] = {.lex_state = 347, .external_lex_state = 3},
  [2754] = {.lex_state = 356},
  [2755] = {.lex_state = 103, .external_lex_state = 3},
  [2756] = {.lex_state = 103, .external_lex_state = 3},
  [2757] = {.lex_state = 103, .external_lex_state = 3},
  [2758] = {.lex_state = 103, .external_lex_state = 3},
  [2759] = {.lex_state = 103, .external_lex_state = 3},
  [2760] = {.lex_state = 103, .external_lex_state = 3},
  [2761] = {.lex_state = 347, .external_lex_state = 3},
  [2762] = {.lex_state = 354, .external_lex_state = 7},
  [2763] = {.lex_state = 347, .external_lex_state = 3},
  [2764] = {.lex_state = 356},
  [2765] = {.lex_state = 347, .external_lex_state = 3},
  [2766] = {.lex_state = 109, .external_lex_state = 3},
  [2767] = {.lex_state = 347, .external_lex_state = 3},
  [2768] = {.lex_state = 356},
  [2769] = {.lex_state = 347, .external_lex_state = 3},
  [2770] = {.lex_state = 347, .external_lex_state = 3},
  [2771] = {.lex_state = 110, .external_lex_state = 3},
  [2772] = {.lex_state = 103, .external_lex_state = 3},
  [2773] = {.lex_state = 103, .external_lex_state = 3},
  [2774] = {.lex_state = 103, .external_lex_state = 3},
  [2775] = {.lex_state = 103, .external_lex_state = 3},
  [2776] = {.lex_state = 103, .external_lex_state = 3},
  [2777] = {.lex_state = 109, .external_lex_state = 3},
  [2778] = {.lex_state = 109, .external_lex_state = 3},
  [2779] = {.lex_state = 109, .external_lex_state = 3},
  [2780] = {.lex_state = 356},
  [2781] = {.lex_state = 354, .external_lex_state = 7},
  [2782] = {.lex_state = 354, .external_lex_state = 7},
  [2783] = {.lex_state = 149},
  [2784] = {.lex_state = 356},
  [2785] = {.lex_state = 356},
  [2786] = {.lex_state = 354, .external_lex_state = 2},
  [2787] = {.lex_state = 353, .external_lex_state = 2},
  [2788] = {.lex_state = 356},
  [2789] = {.lex_state = 354, .external_lex_state = 2},
  [2790] = {.lex_state = 354, .external_lex_state = 2},
  [2791] = {.lex_state = 354, .external_lex_state = 7},
  [2792] = {.lex_state = 356},
  [2793] = {.lex_state = 356},
  [2794] = {.lex_state = 356},
  [2795] = {.lex_state = 356},
  [2796] = {.lex_state = 354, .external_lex_state = 7},
  [2797] = {.lex_state = 164},
  [2798] = {.lex_state = 354, .external_lex_state = 2},
  [2799] = {.lex_state = 356},
  [2800] = {.lex_state = 354, .external_lex_state = 2},
  [2801] = {.lex_state = 354, .external_lex_state = 2},
  [2802] = {.lex_state = 356},
  [2803] = {.lex_state = 354, .external_lex_state = 2},
  [2804] = {.lex_state = 356},
  [2805] = {.lex_state = 354, .external_lex_state = 7},
  [2806] = {.lex_state = 354, .external_lex_state = 2},
  [2807] = {.lex_state = 354, .external_lex_state = 2},
  [2808] = {.lex_state = 356},
  [2809] = {.lex_state = 356},
  [2810] = {.lex_state = 356},
  [2811] = {.lex_state = 356},
  [2812] = {.lex_state = 353, .external_lex_state = 2},
  [2813] = {.lex_state = 356},
  [2814] = {.lex_state = 356},
  [2815] = {.lex_state = 356},
  [2816] = {.lex_state = 356},
  [2817] = {.lex_state = 353, .external_lex_state = 2},
  [2818] = {.lex_state = 354, .external_lex_state = 7},
  [2819] = {.lex_state = 354, .external_lex_state = 7},
  [2820] = {.lex_state = 354, .external_lex_state = 2},
  [2821] = {.lex_state = 354, .external_lex_state = 7},
  [2822] = {.lex_state = 354, .external_lex_state = 7},
  [2823] = {.lex_state = 354, .external_lex_state = 7},
  [2824] = {.lex_state = 354, .external_lex_state = 2},
  [2825] = {.lex_state = 354, .external_lex_state = 7},
  [2826] = {.lex_state = 354, .external_lex_state = 2},
  [2827] = {.lex_state = 354, .external_lex_state = 2},
  [2828] = {.lex_state = 354, .external_lex_state = 7},
  [2829] = {.lex_state = 354, .external_lex_state = 7},
  [2830] = {.lex_state = 354, .external_lex_state = 2},
  [2831] = {.lex_state = 354, .external_lex_state = 7},
  [2832] = {.lex_state = 354, .external_lex_state = 2},
  [2833] = {.lex_state = 354, .external_lex_state = 7},
  [2834] = {.lex_state = 354, .external_lex_state = 7},
  [2835] = {.lex_state = 353, .external_lex_state = 7},
  [2836] = {.lex_state = 354, .external_lex_state = 2},
  [2837] = {.lex_state = 354, .external_lex_state = 2},
  [2838] = {.lex_state = 353, .external_lex_state = 7},
  [2839] = {.lex_state = 354, .external_lex_state = 2},
  [2840] = {.lex_state = 354, .external_lex_state = 7},
  [2841] = {.lex_state = 354, .external_lex_state = 2},
  [2842] = {.lex_state = 354, .external_lex_state = 2},
  [2843] = {.lex_state = 354, .external_lex_state = 2},
  [2844] = {.lex_state = 354, .external_lex_state = 7},
  [2845] = {.lex_state = 353, .external_lex_state = 7},
  [2846] = {.lex_state = 354, .external_lex_state = 7},
  [2847] = {.lex_state = 354, .external_lex_state = 7},
  [2848] = {.lex_state = 354, .external_lex_state = 7},
  [2849] = {.lex_state = 354, .external_lex_state = 7},
  [2850] = {.lex_state = 354, .external_lex_state = 7},
  [2851] = {.lex_state = 354, .external_lex_state = 7},
  [2852] = {.lex_state = 354, .external_lex_state = 7},
  [2853] = {.lex_state = 354, .external_lex_state = 7},
  [2854] = {.lex_state = 354, .external_lex_state = 7},
  [2855] = {.lex_state = 354, .external_lex_state = 7},
  [2856] = {.lex_state = 354, .external_lex_state = 7},
  [2857] = {.lex_state = 356},
  [2858] = {.lex_state = 356},
  [2859] = {.lex_state = 356},
  [2860] = {.lex_state = 356},
  [2861] = {.lex_state = 356},
  [2862] = {.lex_state = 356},
  [2863] = {.lex_state = 356},
  [2864] = {.lex_state = 356},
  [2865] = {.lex_state = 356},
  [2866] = {.lex_state = 356},
  [2867] = {.lex_state = 356},
  [2868] = {.lex_state = 356},
  [2869] = {.lex_state = 356},
  [2870] = {.lex_state = 356},
  [2871] = {.lex_state = 356},
  [2872] = {.lex_state = 356},
  [2873] = {.lex_state = 356},
  [2874] = {.lex_state = 356},
  [2875] = {.lex_state = 356},
  [2876] = {.lex_state = 356},
  [2877] = {.lex_state = 356},
  [2878] = {.lex_state = 356},
  [2879] = {.lex_state = 356},
  [2880] = {.lex_state = 356},
  [2881] = {.lex_state = 356},
  [2882] = {.lex_state = 356},
  [2883] = {.lex_state = 356},
  [2884] = {.lex_state = 356},
  [2885] = {.lex_state = 356},
  [2886] = {.lex_state = 356},
  [2887] = {.lex_state = 356},
  [2888] = {.lex_state = 356},
  [2889] = {.lex_state = 356},
  [2890] = {.lex_state = 354, .external_lex_state = 2},
  [2891] = {.lex_state = 356},
  [2892] = {.lex_state = 356},
  [2893] = {.lex_state = 356},
  [2894] = {.lex_state = 356},
  [2895] = {.lex_state = 356},
  [2896] = {.lex_state = 356},
  [2897] = {.lex_state = 356},
  [2898] = {.lex_state = 356},
  [2899] = {.lex_state = 356},
  [2900] = {.lex_state = 356},
  [2901] = {.lex_state = 356},
  [2902] = {.lex_state = 356},
  [2903] = {.lex_state = 356},
  [2904] = {.lex_state = 356},
  [2905] = {.lex_state = 356},
  [2906] = {.lex_state = 356},
  [2907] = {.lex_state = 356},
  [2908] = {.lex_state = 356},
  [2909] = {.lex_state = 356},
  [2910] = {.lex_state = 356},
  [2911] = {.lex_state = 356},
  [2912] = {.lex_state = 356},
  [2913] = {.lex_state = 356},
  [2914] = {.lex_state = 356},
  [2915] = {.lex_state = 356},
  [2916] = {.lex_state = 356},
  [2917] = {.lex_state = 356},
  [2918] = {.lex_state = 356},
  [2919] = {.lex_state = 356},
  [2920] = {.lex_state = 356},
  [2921] = {.lex_state = 356},
  [2922] = {.lex_state = 356},
  [2923] = {.lex_state = 356},
  [2924] = {.lex_state = 356},
  [2925] = {.lex_state = 356},
  [2926] = {.lex_state = 356},
  [2927] = {.lex_state = 356},
  [2928] = {.lex_state = 356},
  [2929] = {.lex_state = 356},
  [2930] = {.lex_state = 356},
  [2931] = {.lex_state = 356},
  [2932] = {.lex_state = 356},
  [2933] = {.lex_state = 356},
  [2934] = {.lex_state = 356},
  [2935] = {.lex_state = 356},
  [2936] = {.lex_state = 356},
  [2937] = {.lex_state = 356},
  [2938] = {.lex_state = 356},
  [2939] = {.lex_state = 356},
  [2940] = {.lex_state = 356},
  [2941] = {.lex_state = 356},
  [2942] = {.lex_state = 356},
  [2943] = {.lex_state = 356},
  [2944] = {.lex_state = 356},
  [2945] = {.lex_state = 356},
  [2946] = {.lex_state = 356},
  [2947] = {.lex_state = 356},
  [2948] = {.lex_state = 356},
  [2949] = {.lex_state = 356},
  [2950] = {.lex_state = 356},
  [2951] = {.lex_state = 356},
  [2952] = {.lex_state = 356},
  [2953] = {.lex_state = 356},
  [2954] = {.lex_state = 356},
  [2955] = {.lex_state = 356},
  [2956] = {.lex_state = 356},
  [2957] = {.lex_state = 354, .external_lex_state = 7},
  [2958] = {.lex_state = 356},
  [2959] = {.lex_state = 356},
  [2960] = {.lex_state = 356},
  [2961] = {.lex_state = 356},
  [2962] = {.lex_state = 144, .external_lex_state = 2},
  [2963] = {.lex_state = 356},
  [2964] = {.lex_state = 356},
  [2965] = {.lex_state = 356},
  [2966] = {.lex_state = 356},
  [2967] = {.lex_state = 356},
  [2968] = {.lex_state = 356},
  [2969] = {.lex_state = 356},
  [2970] = {.lex_state = 353, .external_lex_state = 2},
  [2971] = {.lex_state = 356},
  [2972] = {.lex_state = 356},
  [2973] = {.lex_state = 356},
  [2974] = {.lex_state = 353, .external_lex_state = 2},
  [2975] = {.lex_state = 356},
  [2976] = {.lex_state = 353, .external_lex_state = 2},
  [2977] = {.lex_state = 353, .external_lex_state = 2},
  [2978] = {.lex_state = 356},
  [2979] = {.lex_state = 356},
  [2980] = {.lex_state = 356},
  [2981] = {.lex_state = 356},
  [2982] = {.lex_state = 353, .external_lex_state = 2},
  [2983] = {.lex_state = 356},
  [2984] = {.lex_state = 356},
  [2985] = {.lex_state = 356},
  [2986] = {.lex_state = 356},
  [2987] = {.lex_state = 356},
  [2988] = {.lex_state = 356},
  [2989] = {.lex_state = 356},
  [2990] = {.lex_state = 356},
  [2991] = {.lex_state = 356},
  [2992] = {.lex_state = 356},
  [2993] = {.lex_state = 356},
  [2994] = {.lex_state = 356},
  [2995] = {.lex_state = 356},
  [2996] = {.lex_state = 356},
  [2997] = {.lex_state = 356},
  [2998] = {.lex_state = 356},
  [2999] = {.lex_state = 356},
  [3000] = {.lex_state = 356},
  [3001] = {.lex_state = 356},
  [3002] = {.lex_state = 353, .external_lex_state = 2},
  [3003] = {.lex_state = 356},
  [3004] = {.lex_state = 356},
  [3005] = {.lex_state = 356},
  [3006] = {.lex_state = 356},
  [3007] = {.lex_state = 356},
  [3008] = {.lex_state = 356},
  [3009] = {.lex_state = 353, .external_lex_state = 2},
  [3010] = {.lex_state = 356},
  [3011] = {.lex_state = 356},
  [3012] = {.lex_state = 356},
  [3013] = {.lex_state = 353, .external_lex_state = 2},
  [3014] = {.lex_state = 353, .external_lex_state = 2},
  [3015] = {.lex_state = 356},
  [3016] = {.lex_state = 356},
  [3017] = {.lex_state = 356},
  [3018] = {.lex_state = 356},
  [3019] = {.lex_state = 356},
  [3020] = {.lex_state = 356},
  [3021] = {.lex_state = 356},
  [3022] = {.lex_state = 356},
  [3023] = {.lex_state = 356},
  [3024] = {.lex_state = 356},
  [3025] = {.lex_state = 356},
  [3026] = {.lex_state = 356},
  [3027] = {.lex_state = 356},
  [3028] = {.lex_state = 356},
  [3029] = {.lex_state = 356},
  [3030] = {.lex_state = 356, .external_lex_state = 15},
  [3031] = {.lex_state = 356},
  [3032] = {.lex_state = 353, .external_lex_state = 2},
  [3033] = {.lex_state = 356},
  [3034] = {.lex_state = 356},
  [3035] = {.lex_state = 356},
  [3036] = {.lex_state = 356},
  [3037] = {.lex_state = 353, .external_lex_state = 2},
  [3038] = {.lex_state = 353, .external_lex_state = 2},
  [3039] = {.lex_state = 353, .external_lex_state = 2},
  [3040] = {.lex_state = 356},
  [3041] = {.lex_state = 356},
  [3042] = {.lex_state = 356},
  [3043] = {.lex_state = 356},
  [3044] = {.lex_state = 356},
  [3045] = {.lex_state = 356},
  [3046] = {.lex_state = 356},
  [3047] = {.lex_state = 356},
  [3048] = {.lex_state = 356},
  [3049] = {.lex_state = 356},
  [3050] = {.lex_state = 356},
  [3051] = {.lex_state = 356},
  [3052] = {.lex_state = 356},
  [3053] = {.lex_state = 356},
  [3054] = {.lex_state = 356},
  [3055] = {.lex_state = 353, .external_lex_state = 2},
  [3056] = {.lex_state = 353, .external_lex_state = 2},
  [3057] = {.lex_state = 356},
  [3058] = {.lex_state = 356},
  [3059] = {.lex_state = 356},
  [3060] = {.lex_state = 356},
  [3061] = {.lex_state = 356},
  [3062] = {.lex_state = 356},
  [3063] = {.lex_state = 356},
  [3064] = {.lex_state = 356},
  [3065] = {.lex_state = 356},
  [3066] = {.lex_state = 356},
  [3067] = {.lex_state = 356},
  [3068] = {.lex_state = 356},
  [3069] = {.lex_state = 356},
  [3070] = {.lex_state = 356},
  [3071] = {.lex_state = 356},
  [3072] = {.lex_state = 356},
  [3073] = {.lex_state = 356},
  [3074] = {.lex_state = 356},
  [3075] = {.lex_state = 353, .external_lex_state = 2},
  [3076] = {.lex_state = 356},
  [3077] = {.lex_state = 356},
  [3078] = {.lex_state = 356},
  [3079] = {.lex_state = 356},
  [3080] = {.lex_state = 356},
  [3081] = {.lex_state = 356},
  [3082] = {.lex_state = 356},
  [3083] = {.lex_state = 356},
  [3084] = {.lex_state = 356},
  [3085] = {.lex_state = 356},
  [3086] = {.lex_state = 356},
  [3087] = {.lex_state = 356},
  [3088] = {.lex_state = 356},
  [3089] = {.lex_state = 353, .external_lex_state = 2},
  [3090] = {.lex_state = 356},
  [3091] = {.lex_state = 356},
  [3092] = {.lex_state = 353, .external_lex_state = 2},
  [3093] = {.lex_state = 356},
  [3094] = {.lex_state = 353, .external_lex_state = 2},
  [3095] = {.lex_state = 356},
  [3096] = {.lex_state = 356},
  [3097] = {.lex_state = 356},
  [3098] = {.lex_state = 356},
  [3099] = {.lex_state = 356},
  [3100] = {.lex_state = 356},
  [3101] = {.lex_state = 356},
  [3102] = {.lex_state = 356},
  [3103] = {.lex_state = 356},
  [3104] = {.lex_state = 356},
  [3105] = {.lex_state = 356},
  [3106] = {.lex_state = 356},
  [3107] = {.lex_state = 356},
  [3108] = {.lex_state = 356},
  [3109] = {.lex_state = 356},
  [3110] = {.lex_state = 356},
  [3111] = {.lex_state = 356},
  [3112] = {.lex_state = 356},
  [3113] = {.lex_state = 356},
  [3114] = {.lex_state = 356},
  [3115] = {.lex_state = 356},
  [3116] = {.lex_state = 356},
  [3117] = {.lex_state = 356},
  [3118] = {.lex_state = 356},
  [3119] = {.lex_state = 356},
  [3120] = {.lex_state = 356},
  [3121] = {.lex_state = 356},
  [3122] = {.lex_state = 356},
  [3123] = {.lex_state = 356},
  [3124] = {.lex_state = 356},
  [3125] = {.lex_state = 356},
  [3126] = {.lex_state = 356},
  [3127] = {.lex_state = 356},
  [3128] = {.lex_state = 356},
  [3129] = {.lex_state = 356},
  [3130] = {.lex_state = 353, .external_lex_state = 2},
  [3131] = {.lex_state = 356},
  [3132] = {.lex_state = 353, .external_lex_state = 2},
  [3133] = {.lex_state = 356},
  [3134] = {.lex_state = 353, .external_lex_state = 2},
  [3135] = {.lex_state = 356},
  [3136] = {.lex_state = 356},
  [3137] = {.lex_state = 356},
  [3138] = {.lex_state = 356},
  [3139] = {.lex_state = 356},
  [3140] = {.lex_state = 353, .external_lex_state = 2},
  [3141] = {.lex_state = 356},
  [3142] = {.lex_state = 356},
  [3143] = {.lex_state = 356},
  [3144] = {.lex_state = 356},
  [3145] = {.lex_state = 356},
  [3146] = {.lex_state = 356},
  [3147] = {.lex_state = 356},
  [3148] = {.lex_state = 353, .external_lex_state = 7},
  [3149] = {.lex_state = 353, .external_lex_state = 2},
  [3150] = {.lex_state = 356},
  [3151] = {.lex_state = 356},
  [3152] = {.lex_state = 353, .external_lex_state = 7},
  [3153] = {.lex_state = 356},
  [3154] = {.lex_state = 145, .external_lex_state = 2},
  [3155] = {.lex_state = 353, .external_lex_state = 2},
  [3156] = {.lex_state = 356},
  [3157] = {.lex_state = 356},
  [3158] = {.lex_state = 356},
  [3159] = {.lex_state = 356},
  [3160] = {.lex_state = 356},
  [3161] = {.lex_state = 356},
  [3162] = {.lex_state = 356},
  [3163] = {.lex_state = 356},
  [3164] = {.lex_state = 353, .external_lex_state = 2},
  [3165] = {.lex_state = 356},
  [3166] = {.lex_state = 356},
  [3167] = {.lex_state = 356},
  [3168] = {.lex_state = 356},
  [3169] = {.lex_state = 356},
  [3170] = {.lex_state = 356},
  [3171] = {.lex_state = 356},
  [3172] = {.lex_state = 356},
  [3173] = {.lex_state = 353, .external_lex_state = 2},
  [3174] = {.lex_state = 356},
  [3175] = {.lex_state = 353, .external_lex_state = 7},
  [3176] = {.lex_state = 356},
  [3177] = {.lex_state = 356},
  [3178] = {.lex_state = 356},
  [3179] = {.lex_state = 356},
  [3180] = {.lex_state = 353, .external_lex_state = 7},
  [3181] = {.lex_state = 356},
  [3182] = {.lex_state = 356},
  [3183] = {.lex_state = 353, .external_lex_state = 7},
  [3184] = {.lex_state = 353, .external_lex_state = 7},
  [3185] = {.lex_state = 356},
  [3186] = {.lex_state = 353, .external_lex_state = 7},
  [3187] = {.lex_state = 356},
  [3188] = {.lex_state = 353, .external_lex_state = 7},
  [3189] = {.lex_state = 356},
  [3190] = {.lex_state = 353, .external_lex_state = 7},
  [3191] = {.lex_state = 353, .external_lex_state = 7},
  [3192] = {.lex_state = 353, .external_lex_state = 7},
  [3193] = {.lex_state = 353, .external_lex_state = 7},
  [3194] = {.lex_state = 353, .external_lex_state = 7},
  [3195] = {.lex_state = 353, .external_lex_state = 7},
  [3196] = {.lex_state = 353, .external_lex_state = 7},
  [3197] = {.lex_state = 353, .external_lex_state = 7},
  [3198] = {.lex_state = 353, .external_lex_state = 7},
  [3199] = {.lex_state = 353, .external_lex_state = 7},
  [3200] = {.lex_state = 353, .external_lex_state = 7},
  [3201] = {.lex_state = 353, .external_lex_state = 7},
  [3202] = {.lex_state = 353, .external_lex_state = 7},
  [3203] = {.lex_state = 353, .external_lex_state = 7},
  [3204] = {.lex_state = 353, .external_lex_state = 7},
  [3205] = {.lex_state = 353, .external_lex_state = 7},
  [3206] = {.lex_state = 353, .external_lex_state = 7},
  [3207] = {.lex_state = 353, .external_lex_state = 7},
  [3208] = {.lex_state = 353, .external_lex_state = 7},
  [3209] = {.lex_state = 353, .external_lex_state = 2},
  [3210] = {.lex_state = 353, .external_lex_state = 2},
  [3211] = {.lex_state = 353, .external_lex_state = 2},
  [3212] = {.lex_state = 353, .external_lex_state = 2},
  [3213] = {.lex_state = 353, .external_lex_state = 2},
  [3214] = {.lex_state = 353, .external_lex_state = 2},
  [3215] = {.lex_state = 353, .external_lex_state = 7},
  [3216] = {.lex_state = 353, .external_lex_state = 7},
  [3217] = {.lex_state = 353, .external_lex_state = 7},
  [3218] = {.lex_state = 353, .external_lex_state = 7},
  [3219] = {.lex_state = 353, .external_lex_state = 7},
  [3220] = {.lex_state = 353, .external_lex_state = 2},
  [3221] = {.lex_state = 143, .external_lex_state = 2},
  [3222] = {.lex_state = 354, .external_lex_state = 3},
  [3223] = {.lex_state = 143, .external_lex_state = 2},
  [3224] = {.lex_state = 353, .external_lex_state = 7},
  [3225] = {.lex_state = 143, .external_lex_state = 2},
  [3226] = {.lex_state = 353, .external_lex_state = 7},
  [3227] = {.lex_state = 143, .external_lex_state = 2},
  [3228] = {.lex_state = 143, .external_lex_state = 2},
  [3229] = {.lex_state = 143, .external_lex_state = 2},
  [3230] = {.lex_state = 143, .external_lex_state = 2},
  [3231] = {.lex_state = 354, .external_lex_state = 3},
  [3232] = {.lex_state = 354, .external_lex_state = 3},
  [3233] = {.lex_state = 354, .external_lex_state = 3},
  [3234] = {.lex_state = 354, .external_lex_state = 3},
  [3235] = {.lex_state = 354, .external_lex_state = 3},
  [3236] = {.lex_state = 354, .external_lex_state = 3},
  [3237] = {.lex_state = 355, .external_lex_state = 2},
  [3238] = {.lex_state = 354, .external_lex_state = 7},
  [3239] = {.lex_state = 353, .external_lex_state = 2},
  [3240] = {.lex_state = 354, .external_lex_state = 3},
  [3241] = {.lex_state = 353, .external_lex_state = 2},
  [3242] = {.lex_state = 143, .external_lex_state = 2},
  [3243] = {.lex_state = 355, .external_lex_state = 2},
  [3244] = {.lex_state = 149},
  [3245] = {.lex_state = 355, .external_lex_state = 2},
  [3246] = {.lex_state = 354, .external_lex_state = 3},
  [3247] = {.lex_state = 354, .external_lex_state = 7},
  [3248] = {.lex_state = 143, .external_lex_state = 2},
  [3249] = {.lex_state = 353, .external_lex_state = 2},
  [3250] = {.lex_state = 354, .external_lex_state = 7},
  [3251] = {.lex_state = 354, .external_lex_state = 3},
  [3252] = {.lex_state = 149},
  [3253] = {.lex_state = 354, .external_lex_state = 7},
  [3254] = {.lex_state = 353, .external_lex_state = 2},
  [3255] = {.lex_state = 354, .external_lex_state = 7},
  [3256] = {.lex_state = 143, .external_lex_state = 2},
  [3257] = {.lex_state = 355, .external_lex_state = 2},
  [3258] = {.lex_state = 354, .external_lex_state = 7},
  [3259] = {.lex_state = 143, .external_lex_state = 2},
  [3260] = {.lex_state = 354, .external_lex_state = 7},
  [3261] = {.lex_state = 355, .external_lex_state = 2},
  [3262] = {.lex_state = 355, .external_lex_state = 2},
  [3263] = {.lex_state = 354, .external_lex_state = 3},
  [3264] = {.lex_state = 355, .external_lex_state = 2},
  [3265] = {.lex_state = 353, .external_lex_state = 2},
  [3266] = {.lex_state = 353, .external_lex_state = 2},
  [3267] = {.lex_state = 143, .external_lex_state = 2},
  [3268] = {.lex_state = 354, .external_lex_state = 3},
  [3269] = {.lex_state = 353, .external_lex_state = 2},
  [3270] = {.lex_state = 353, .external_lex_state = 2},
  [3271] = {.lex_state = 354, .external_lex_state = 2},
  [3272] = {.lex_state = 143, .external_lex_state = 2},
  [3273] = {.lex_state = 354, .external_lex_state = 7},
  [3274] = {.lex_state = 354, .external_lex_state = 7},
  [3275] = {.lex_state = 353, .external_lex_state = 7},
  [3276] = {.lex_state = 355, .external_lex_state = 2},
  [3277] = {.lex_state = 354, .external_lex_state = 3},
  [3278] = {.lex_state = 354, .external_lex_state = 2},
  [3279] = {.lex_state = 355, .external_lex_state = 7},
  [3280] = {.lex_state = 353, .external_lex_state = 2},
  [3281] = {.lex_state = 354, .external_lex_state = 7},
  [3282] = {.lex_state = 353, .external_lex_state = 2},
  [3283] = {.lex_state = 353, .external_lex_state = 2},
  [3284] = {.lex_state = 143, .external_lex_state = 2},
  [3285] = {.lex_state = 354, .external_lex_state = 7},
  [3286] = {.lex_state = 354, .external_lex_state = 2},
  [3287] = {.lex_state = 353, .external_lex_state = 2},
  [3288] = {.lex_state = 353, .external_lex_state = 2},
  [3289] = {.lex_state = 353, .external_lex_state = 7},
  [3290] = {.lex_state = 143, .external_lex_state = 2},
  [3291] = {.lex_state = 354, .external_lex_state = 3},
  [3292] = {.lex_state = 354, .external_lex_state = 3},
  [3293] = {.lex_state = 143, .external_lex_state = 2},
  [3294] = {.lex_state = 353, .external_lex_state = 2},
  [3295] = {.lex_state = 354, .external_lex_state = 7},
  [3296] = {.lex_state = 353, .external_lex_state = 2},
  [3297] = {.lex_state = 355, .external_lex_state = 7},
  [3298] = {.lex_state = 353, .external_lex_state = 2},
  [3299] = {.lex_state = 353, .external_lex_state = 7},
  [3300] = {.lex_state = 354, .external_lex_state = 3},
  [3301] = {.lex_state = 354, .external_lex_state = 2},
  [3302] = {.lex_state = 143, .external_lex_state = 2},
  [3303] = {.lex_state = 353, .external_lex_state = 2},
  [3304] = {.lex_state = 353, .external_lex_state = 2},
  [3305] = {.lex_state = 355, .external_lex_state = 7},
  [3306] = {.lex_state = 353, .external_lex_state = 7},
  [3307] = {.lex_state = 353, .external_lex_state = 2},
  [3308] = {.lex_state = 353, .external_lex_state = 2},
  [3309] = {.lex_state = 353, .external_lex_state = 7},
  [3310] = {.lex_state = 353, .external_lex_state = 2},
  [3311] = {.lex_state = 353, .external_lex_state = 2},
  [3312] = {.lex_state = 354, .external_lex_state = 2},
  [3313] = {.lex_state = 354, .external_lex_state = 3},
  [3314] = {.lex_state = 353, .external_lex_state = 2},
  [3315] = {.lex_state = 353, .external_lex_state = 2},
  [3316] = {.lex_state = 354, .external_lex_state = 2},
  [3317] = {.lex_state = 354, .external_lex_state = 2},
  [3318] = {.lex_state = 353, .external_lex_state = 7},
  [3319] = {.lex_state = 353, .external_lex_state = 2},
  [3320] = {.lex_state = 187},
  [3321] = {.lex_state = 187},
  [3322] = {.lex_state = 354, .external_lex_state = 2},
  [3323] = {.lex_state = 187},
  [3324] = {.lex_state = 187},
  [3325] = {.lex_state = 354, .external_lex_state = 3},
  [3326] = {.lex_state = 353, .external_lex_state = 2},
  [3327] = {.lex_state = 353, .external_lex_state = 7},
  [3328] = {.lex_state = 187},
  [3329] = {.lex_state = 353, .external_lex_state = 7},
  [3330] = {.lex_state = 353, .external_lex_state = 2},
  [3331] = {.lex_state = 354, .external_lex_state = 3},
  [3332] = {.lex_state = 354, .external_lex_state = 2},
  [3333] = {.lex_state = 353, .external_lex_state = 7},
  [3334] = {.lex_state = 354, .external_lex_state = 7},
  [3335] = {.lex_state = 355, .external_lex_state = 7},
  [3336] = {.lex_state = 353, .external_lex_state = 2},
  [3337] = {.lex_state = 187},
  [3338] = {.lex_state = 354, .external_lex_state = 3},
  [3339] = {.lex_state = 187},
  [3340] = {.lex_state = 187},
  [3341] = {.lex_state = 187},
  [3342] = {.lex_state = 143, .external_lex_state = 2},
  [3343] = {.lex_state = 187},
  [3344] = {.lex_state = 143, .external_lex_state = 2},
  [3345] = {.lex_state = 353, .external_lex_state = 2},
  [3346] = {.lex_state = 354, .external_lex_state = 3},
  [3347] = {.lex_state = 187},
  [3348] = {.lex_state = 354, .external_lex_state = 2},
  [3349] = {.lex_state = 187},
  [3350] = {.lex_state = 187},
  [3351] = {.lex_state = 353, .external_lex_state = 2},
  [3352] = {.lex_state = 143, .external_lex_state = 2},
  [3353] = {.lex_state = 353, .external_lex_state = 2},
  [3354] = {.lex_state = 187},
  [3355] = {.lex_state = 143, .external_lex_state = 2},
  [3356] = {.lex_state = 187},
  [3357] = {.lex_state = 353, .external_lex_state = 2},
  [3358] = {.lex_state = 187},
  [3359] = {.lex_state = 354, .external_lex_state = 3},
  [3360] = {.lex_state = 354, .external_lex_state = 3},
  [3361] = {.lex_state = 353, .external_lex_state = 2},
  [3362] = {.lex_state = 187},
  [3363] = {.lex_state = 143, .external_lex_state = 2},
  [3364] = {.lex_state = 353, .external_lex_state = 7},
  [3365] = {.lex_state = 353, .external_lex_state = 2},
  [3366] = {.lex_state = 354, .external_lex_state = 7},
  [3367] = {.lex_state = 354, .external_lex_state = 3},
  [3368] = {.lex_state = 187},
  [3369] = {.lex_state = 187},
  [3370] = {.lex_state = 353, .external_lex_state = 2},
  [3371] = {.lex_state = 353, .external_lex_state = 7},
  [3372] = {.lex_state = 354, .external_lex_state = 3},
  [3373] = {.lex_state = 353, .external_lex_state = 7},
  [3374] = {.lex_state = 187},
  [3375] = {.lex_state = 187},
  [3376] = {.lex_state = 353, .external_lex_state = 7},
  [3377] = {.lex_state = 143, .external_lex_state = 2},
  [3378] = {.lex_state = 353, .external_lex_state = 7},
  [3379] = {.lex_state = 143, .external_lex_state = 2},
  [3380] = {.lex_state = 353, .external_lex_state = 7},
  [3381] = {.lex_state = 187},
  [3382] = {.lex_state = 143, .external_lex_state = 2},
  [3383] = {.lex_state = 187},
  [3384] = {.lex_state = 143, .external_lex_state = 2},
  [3385] = {.lex_state = 354, .external_lex_state = 3},
  [3386] = {.lex_state = 354, .external_lex_state = 2},
  [3387] = {.lex_state = 353, .external_lex_state = 2},
  [3388] = {.lex_state = 353, .external_lex_state = 7},
  [3389] = {.lex_state = 353, .external_lex_state = 2},
  [3390] = {.lex_state = 187},
  [3391] = {.lex_state = 353, .external_lex_state = 2},
  [3392] = {.lex_state = 187},
  [3393] = {.lex_state = 353, .external_lex_state = 2},
  [3394] = {.lex_state = 187},
  [3395] = {.lex_state = 354, .external_lex_state = 2},
  [3396] = {.lex_state = 187},
  [3397] = {.lex_state = 353, .external_lex_state = 7},
  [3398] = {.lex_state = 353, .external_lex_state = 2},
  [3399] = {.lex_state = 187},
  [3400] = {.lex_state = 354, .external_lex_state = 7},
  [3401] = {.lex_state = 143, .external_lex_state = 2},
  [3402] = {.lex_state = 354, .external_lex_state = 3},
  [3403] = {.lex_state = 353, .external_lex_state = 7},
  [3404] = {.lex_state = 354, .external_lex_state = 3},
  [3405] = {.lex_state = 187},
  [3406] = {.lex_state = 187},
  [3407] = {.lex_state = 353, .external_lex_state = 7},
  [3408] = {.lex_state = 353, .external_lex_state = 7},
  [3409] = {.lex_state = 353, .external_lex_state = 7},
  [3410] = {.lex_state = 353, .external_lex_state = 7},
  [3411] = {.lex_state = 353, .external_lex_state = 7},
  [3412] = {.lex_state = 353, .external_lex_state = 7},
  [3413] = {.lex_state = 354, .external_lex_state = 7},
  [3414] = {.lex_state = 187},
  [3415] = {.lex_state = 187},
  [3416] = {.lex_state = 143, .external_lex_state = 2},
  [3417] = {.lex_state = 354, .external_lex_state = 7},
  [3418] = {.lex_state = 187},
  [3419] = {.lex_state = 353, .external_lex_state = 7},
  [3420] = {.lex_state = 353, .external_lex_state = 2},
  [3421] = {.lex_state = 353, .external_lex_state = 7},
  [3422] = {.lex_state = 353, .external_lex_state = 7},
  [3423] = {.lex_state = 353, .external_lex_state = 7},
  [3424] = {.lex_state = 353, .external_lex_state = 7},
  [3425] = {.lex_state = 353, .external_lex_state = 7},
  [3426] = {.lex_state = 353, .external_lex_state = 7},
  [3427] = {.lex_state = 353, .external_lex_state = 7},
  [3428] = {.lex_state = 354, .external_lex_state = 7},
  [3429] = {.lex_state = 146, .external_lex_state = 2},
  [3430] = {.lex_state = 354, .external_lex_state = 7},
  [3431] = {.lex_state = 354, .external_lex_state = 7},
  [3432] = {.lex_state = 354, .external_lex_state = 2},
  [3433] = {.lex_state = 354, .external_lex_state = 2},
  [3434] = {.lex_state = 353, .external_lex_state = 7},
  [3435] = {.lex_state = 353, .external_lex_state = 7},
  [3436] = {.lex_state = 353, .external_lex_state = 7},
  [3437] = {.lex_state = 354, .external_lex_state = 7},
  [3438] = {.lex_state = 354, .external_lex_state = 2},
  [3439] = {.lex_state = 353, .external_lex_state = 7},
  [3440] = {.lex_state = 354, .external_lex_state = 2},
  [3441] = {.lex_state = 354, .external_lex_state = 7},
  [3442] = {.lex_state = 354, .external_lex_state = 7},
  [3443] = {.lex_state = 354, .external_lex_state = 7},
  [3444] = {.lex_state = 353, .external_lex_state = 7},
  [3445] = {.lex_state = 354, .external_lex_state = 7},
  [3446] = {.lex_state = 354, .external_lex_state = 7},
  [3447] = {.lex_state = 353, .external_lex_state = 7},
  [3448] = {.lex_state = 353, .external_lex_state = 7},
  [3449] = {.lex_state = 354, .external_lex_state = 2},
  [3450] = {.lex_state = 354, .external_lex_state = 7},
  [3451] = {.lex_state = 187},
  [3452] = {.lex_state = 354, .external_lex_state = 7},
  [3453] = {.lex_state = 187},
  [3454] = {.lex_state = 353, .external_lex_state = 7},
  [3455] = {.lex_state = 353, .external_lex_state = 7},
  [3456] = {.lex_state = 187},
  [3457] = {.lex_state = 187},
  [3458] = {.lex_state = 147, .external_lex_state = 2},
  [3459] = {.lex_state = 354, .external_lex_state = 2},
  [3460] = {.lex_state = 147, .external_lex_state = 2},
  [3461] = {.lex_state = 147, .external_lex_state = 2},
  [3462] = {.lex_state = 138, .external_lex_state = 2},
  [3463] = {.lex_state = 147, .external_lex_state = 2},
  [3464] = {.lex_state = 354, .external_lex_state = 2},
  [3465] = {.lex_state = 138, .external_lex_state = 2},
  [3466] = {.lex_state = 354, .external_lex_state = 2},
  [3467] = {.lex_state = 353, .external_lex_state = 8},
  [3468] = {.lex_state = 354, .external_lex_state = 2},
  [3469] = {.lex_state = 354, .external_lex_state = 2},
  [3470] = {.lex_state = 138, .external_lex_state = 2},
  [3471] = {.lex_state = 354, .external_lex_state = 2},
  [3472] = {.lex_state = 354, .external_lex_state = 2},
  [3473] = {.lex_state = 353, .external_lex_state = 8},
  [3474] = {.lex_state = 354, .external_lex_state = 2},
  [3475] = {.lex_state = 354, .external_lex_state = 2},
  [3476] = {.lex_state = 354, .external_lex_state = 2},
  [3477] = {.lex_state = 187},
  [3478] = {.lex_state = 138, .external_lex_state = 2},
  [3479] = {.lex_state = 354, .external_lex_state = 2},
  [3480] = {.lex_state = 353, .external_lex_state = 8},
  [3481] = {.lex_state = 353, .external_lex_state = 8},
  [3482] = {.lex_state = 353, .external_lex_state = 8},
  [3483] = {.lex_state = 353, .external_lex_state = 8},
  [3484] = {.lex_state = 353, .external_lex_state = 9},
  [3485] = {.lex_state = 353, .external_lex_state = 9},
  [3486] = {.lex_state = 353, .external_lex_state = 9},
  [3487] = {.lex_state = 353, .external_lex_state = 8},
  [3488] = {.lex_state = 353, .external_lex_state = 2},
  [3489] = {.lex_state = 353, .external_lex_state = 2},
  [3490] = {.lex_state = 353, .external_lex_state = 2},
  [3491] = {.lex_state = 353, .external_lex_state = 8},
  [3492] = {.lex_state = 353, .external_lex_state = 2},
  [3493] = {.lex_state = 353, .external_lex_state = 2},
  [3494] = {.lex_state = 353, .external_lex_state = 9},
  [3495] = {.lex_state = 353, .external_lex_state = 8},
  [3496] = {.lex_state = 353, .external_lex_state = 2},
  [3497] = {.lex_state = 353, .external_lex_state = 2},
  [3498] = {.lex_state = 353, .external_lex_state = 2},
  [3499] = {.lex_state = 353, .external_lex_state = 2},
  [3500] = {.lex_state = 353, .external_lex_state = 2},
  [3501] = {.lex_state = 353, .external_lex_state = 2},
  [3502] = {.lex_state = 353, .external_lex_state = 2},
  [3503] = {.lex_state = 353, .external_lex_state = 2},
  [3504] = {.lex_state = 353, .external_lex_state = 9},
  [3505] = {.lex_state = 353, .external_lex_state = 2},
  [3506] = {.lex_state = 353, .external_lex_state = 2},
  [3507] = {.lex_state = 353, .external_lex_state = 2},
  [3508] = {.lex_state = 353, .external_lex_state = 9},
  [3509] = {.lex_state = 353, .external_lex_state = 2},
  [3510] = {.lex_state = 353, .external_lex_state = 2},
  [3511] = {.lex_state = 353, .external_lex_state = 2},
  [3512] = {.lex_state = 353, .external_lex_state = 2},
  [3513] = {.lex_state = 353, .external_lex_state = 2},
  [3514] = {.lex_state = 353, .external_lex_state = 2},
  [3515] = {.lex_state = 353, .external_lex_state = 2},
  [3516] = {.lex_state = 353, .external_lex_state = 9},
  [3517] = {.lex_state = 353, .external_lex_state = 2},
  [3518] = {.lex_state = 353, .external_lex_state = 2},
  [3519] = {.lex_state = 353, .external_lex_state = 2},
  [3520] = {.lex_state = 353, .external_lex_state = 2},
  [3521] = {.lex_state = 353, .external_lex_state = 2},
  [3522] = {.lex_state = 353, .external_lex_state = 2},
  [3523] = {.lex_state = 353, .external_lex_state = 2},
  [3524] = {.lex_state = 353, .external_lex_state = 2},
  [3525] = {.lex_state = 353, .external_lex_state = 2},
  [3526] = {.lex_state = 353, .external_lex_state = 2},
  [3527] = {.lex_state = 353, .external_lex_state = 2},
  [3528] = {.lex_state = 353, .external_lex_state = 9},
  [3529] = {.lex_state = 353, .external_lex_state = 2},
  [3530] = {.lex_state = 353, .external_lex_state = 2},
  [3531] = {.lex_state = 353, .external_lex_state = 2},
  [3532] = {.lex_state = 353, .external_lex_state = 2},
  [3533] = {.lex_state = 353, .external_lex_state = 9},
  [3534] = {.lex_state = 353, .external_lex_state = 2},
  [3535] = {.lex_state = 353, .external_lex_state = 2},
  [3536] = {.lex_state = 353, .external_lex_state = 2},
  [3537] = {.lex_state = 353, .external_lex_state = 2},
  [3538] = {.lex_state = 353, .external_lex_state = 2},
  [3539] = {.lex_state = 353, .external_lex_state = 2},
  [3540] = {.lex_state = 353, .external_lex_state = 2},
  [3541] = {.lex_state = 353, .external_lex_state = 2},
  [3542] = {.lex_state = 180},
  [3543] = {.lex_state = 180},
  [3544] = {.lex_state = 180},
  [3545] = {.lex_state = 180},
  [3546] = {.lex_state = 180},
  [3547] = {.lex_state = 180},
  [3548] = {.lex_state = 180},
  [3549] = {.lex_state = 180},
  [3550] = {.lex_state = 180},
  [3551] = {.lex_state = 180},
  [3552] = {.lex_state = 180},
  [3553] = {.lex_state = 180},
  [3554] = {.lex_state = 180},
  [3555] = {.lex_state = 180},
  [3556] = {.lex_state = 180},
  [3557] = {.lex_state = 180},
  [3558] = {.lex_state = 180},
  [3559] = {.lex_state = 180},
  [3560] = {.lex_state = 180},
  [3561] = {.lex_state = 180},
  [3562] = {.lex_state = 180},
  [3563] = {.lex_state = 180},
  [3564] = {.lex_state = 150},
  [3565] = {.lex_state = 159},
  [3566] = {.lex_state = 150, .external_lex_state = 14},
  [3567] = {.lex_state = 151},
  [3568] = {.lex_state = 166},
  [3569] = {.lex_state = 160},
  [3570] = {.lex_state = 151, .external_lex_state = 14},
  [3571] = {.lex_state = 167},
  [3572] = {.lex_state = 174},
  [3573] = {.lex_state = 155},
  [3574] = {.lex_state = 155},
  [3575] = {.lex_state = 156},
  [3576] = {.lex_state = 156},
  [3577] = {.lex_state = 156},
  [3578] = {.lex_state = 155},
  [3579] = {.lex_state = 155},
  [3580] = {.lex_state = 155},
  [3581] = {.lex_state = 156},
  [3582] = {.lex_state = 155},
  [3583] = {.lex_state = 156},
  [3584] = {.lex_state = 156},
  [3585] = {.lex_state = 175},
  [3586] = {.lex_state = 156},
  [3587] = {.lex_state = 155},
  [3588] = {.lex_state = 156},
  [3589] = {.lex_state = 156},
  [3590] = {.lex_state = 155},
  [3591] = {.lex_state = 156},
  [3592] = {.lex_state = 156},
  [3593] = {.lex_state = 155},
  [3594] = {.lex_state = 156},
  [3595] = {.lex_state = 156},
  [3596] = {.lex_state = 156},
  [3597] = {.lex_state = 155},
  [3598] = {.lex_state = 155},
  [3599] = {.lex_state = 156},
  [3600] = {.lex_state = 155},
  [3601] = {.lex_state = 155},
  [3602] = {.lex_state = 155},
  [3603] = {.lex_state = 155},
  [3604] = {.lex_state = 156},
  [3605] = {.lex_state = 156},
  [3606] = {.lex_state = 155},
  [3607] = {.lex_state = 156},
  [3608] = {.lex_state = 156},
  [3609] = {.lex_state = 155},
  [3610] = {.lex_state = 152},
  [3611] = {.lex_state = 156},
  [3612] = {.lex_state = 356},
  [3613] = {.lex_state = 155},
  [3614] = {.lex_state = 155},
  [3615] = {.lex_state = 356},
  [3616] = {.lex_state = 171},
  [3617] = {.lex_state = 155},
  [3618] = {.lex_state = 194, .external_lex_state = 5},
  [3619] = {.lex_state = 155},
  [3620] = {.lex_state = 156},
  [3621] = {.lex_state = 194, .external_lex_state = 5},
  [3622] = {.lex_state = 155},
  [3623] = {.lex_state = 155},
  [3624] = {.lex_state = 153},
  [3625] = {.lex_state = 155},
  [3626] = {.lex_state = 155},
  [3627] = {.lex_state = 155},
  [3628] = {.lex_state = 194, .external_lex_state = 5},
  [3629] = {.lex_state = 153},
  [3630] = {.lex_state = 171},
  [3631] = {.lex_state = 171},
  [3632] = {.lex_state = 171},
  [3633] = {.lex_state = 156},
  [3634] = {.lex_state = 194, .external_lex_state = 5},
  [3635] = {.lex_state = 156},
  [3636] = {.lex_state = 155},
  [3637] = {.lex_state = 155},
  [3638] = {.lex_state = 156},
  [3639] = {.lex_state = 149},
  [3640] = {.lex_state = 156},
  [3641] = {.lex_state = 156},
  [3642] = {.lex_state = 171},
  [3643] = {.lex_state = 156},
  [3644] = {.lex_state = 194, .external_lex_state = 5},
  [3645] = {.lex_state = 155},
  [3646] = {.lex_state = 171},
  [3647] = {.lex_state = 153},
  [3648] = {.lex_state = 194, .external_lex_state = 5},
  [3649] = {.lex_state = 156},
  [3650] = {.lex_state = 149},
  [3651] = {.lex_state = 156},
  [3652] = {.lex_state = 153},
  [3653] = {.lex_state = 171},
  [3654] = {.lex_state = 156},
  [3655] = {.lex_state = 156},
  [3656] = {.lex_state = 149},
  [3657] = {.lex_state = 171},
  [3658] = {.lex_state = 149},
  [3659] = {.lex_state = 172},
  [3660] = {.lex_state = 172},
  [3661] = {.lex_state = 171},
  [3662] = {.lex_state = 161},
  [3663] = {.lex_state = 149},
  [3664] = {.lex_state = 171},
  [3665] = {.lex_state = 171},
  [3666] = {.lex_state = 194, .external_lex_state = 5},
  [3667] = {.lex_state = 181},
  [3668] = {.lex_state = 172},
  [3669] = {.lex_state = 171},
  [3670] = {.lex_state = 172},
  [3671] = {.lex_state = 149},
  [3672] = {.lex_state = 172},
  [3673] = {.lex_state = 172},
  [3674] = {.lex_state = 171},
  [3675] = {.lex_state = 172},
  [3676] = {.lex_state = 152, .external_lex_state = 14},
  [3677] = {.lex_state = 149},
  [3678] = {.lex_state = 162},
  [3679] = {.lex_state = 172},
  [3680] = {.lex_state = 149},
  [3681] = {.lex_state = 153, .external_lex_state = 14},
  [3682] = {.lex_state = 171},
  [3683] = {.lex_state = 149, .external_lex_state = 14},
  [3684] = {.lex_state = 171},
  [3685] = {.lex_state = 172},
  [3686] = {.lex_state = 157},
  [3687] = {.lex_state = 149},
  [3688] = {.lex_state = 171},
  [3689] = {.lex_state = 149},
  [3690] = {.lex_state = 194, .external_lex_state = 6},
  [3691] = {.lex_state = 149, .external_lex_state = 14},
  [3692] = {.lex_state = 149},
  [3693] = {.lex_state = 171},
  [3694] = {.lex_state = 171},
  [3695] = {.lex_state = 153, .external_lex_state = 14},
  [3696] = {.lex_state = 153, .external_lex_state = 14},
  [3697] = {.lex_state = 162},
  [3698] = {.lex_state = 172},
  [3699] = {.lex_state = 172},
  [3700] = {.lex_state = 162},
  [3701] = {.lex_state = 172},
  [3702] = {.lex_state = 149},
  [3703] = {.lex_state = 149},
  [3704] = {.lex_state = 171},
  [3705] = {.lex_state = 149},
  [3706] = {.lex_state = 172},
  [3707] = {.lex_state = 149},
  [3708] = {.lex_state = 162},
  [3709] = {.lex_state = 194, .external_lex_state = 6},
  [3710] = {.lex_state = 149},
  [3711] = {.lex_state = 149},
  [3712] = {.lex_state = 164},
  [3713] = {.lex_state = 149},
  [3714] = {.lex_state = 149},
  [3715] = {.lex_state = 168},
  [3716] = {.lex_state = 149},
  [3717] = {.lex_state = 149},
  [3718] = {.lex_state = 149},
  [3719] = {.lex_state = 149},
  [3720] = {.lex_state = 149},
  [3721] = {.lex_state = 153, .external_lex_state = 14},
  [3722] = {.lex_state = 149},
  [3723] = {.lex_state = 149},
  [3724] = {.lex_state = 149},
  [3725] = {.lex_state = 149},
  [3726] = {.lex_state = 164},
  [3727] = {.lex_state = 149},
  [3728] = {.lex_state = 157},
  [3729] = {.lex_state = 172},
  [3730] = {.lex_state = 149},
  [3731] = {.lex_state = 149},
  [3732] = {.lex_state = 149},
  [3733] = {.lex_state = 149},
  [3734] = {.lex_state = 149},
  [3735] = {.lex_state = 149},
  [3736] = {.lex_state = 149},
  [3737] = {.lex_state = 149},
  [3738] = {.lex_state = 149},
  [3739] = {.lex_state = 194, .external_lex_state = 6},
  [3740] = {.lex_state = 149},
  [3741] = {.lex_state = 172},
  [3742] = {.lex_state = 157},
  [3743] = {.lex_state = 149, .external_lex_state = 14},
  [3744] = {.lex_state = 149},
  [3745] = {.lex_state = 149},
  [3746] = {.lex_state = 149},
  [3747] = {.lex_state = 149},
  [3748] = {.lex_state = 149},
  [3749] = {.lex_state = 149},
  [3750] = {.lex_state = 149, .external_lex_state = 14},
  [3751] = {.lex_state = 165},
  [3752] = {.lex_state = 171},
  [3753] = {.lex_state = 157},
  [3754] = {.lex_state = 172},
  [3755] = {.lex_state = 165},
  [3756] = {.lex_state = 157},
  [3757] = {.lex_state = 149},
  [3758] = {.lex_state = 149},
  [3759] = {.lex_state = 169},
  [3760] = {.lex_state = 172},
  [3761] = {.lex_state = 149},
  [3762] = {.lex_state = 171},
  [3763] = {.lex_state = 149, .external_lex_state = 14},
  [3764] = {.lex_state = 169},
  [3765] = {.lex_state = 165},
  [3766] = {.lex_state = 172},
  [3767] = {.lex_state = 169},
  [3768] = {.lex_state = 203},
  [3769] = {.lex_state = 149, .external_lex_state = 14},
  [3770] = {.lex_state = 171},
  [3771] = {.lex_state = 203},
  [3772] = {.lex_state = 164},
  [3773] = {.lex_state = 203},
  [3774] = {.lex_state = 171},
  [3775] = {.lex_state = 165},
  [3776] = {.lex_state = 165},
  [3777] = {.lex_state = 203},
  [3778] = {.lex_state = 165},
  [3779] = {.lex_state = 169},
  [3780] = {.lex_state = 171},
  [3781] = {.lex_state = 165},
  [3782] = {.lex_state = 172},
  [3783] = {.lex_state = 149},
  [3784] = {.lex_state = 165},
  [3785] = {.lex_state = 149},
  [3786] = {.lex_state = 171},
  [3787] = {.lex_state = 172},
  [3788] = {.lex_state = 165},
  [3789] = {.lex_state = 172},
  [3790] = {.lex_state = 171},
  [3791] = {.lex_state = 171},
  [3792] = {.lex_state = 182},
  [3793] = {.lex_state = 164},
  [3794] = {.lex_state = 165},
  [3795] = {.lex_state = 171},
  [3796] = {.lex_state = 165},
  [3797] = {.lex_state = 149},
  [3798] = {.lex_state = 157},
  [3799] = {.lex_state = 165},
  [3800] = {.lex_state = 172},
  [3801] = {.lex_state = 171},
  [3802] = {.lex_state = 171},
  [3803] = {.lex_state = 165},
  [3804] = {.lex_state = 203},
  [3805] = {.lex_state = 149, .external_lex_state = 14},
  [3806] = {.lex_state = 149},
  [3807] = {.lex_state = 149, .external_lex_state = 14},
  [3808] = {.lex_state = 149, .external_lex_state = 14},
  [3809] = {.lex_state = 149},
  [3810] = {.lex_state = 149, .external_lex_state = 14},
  [3811] = {.lex_state = 149},
  [3812] = {.lex_state = 149, .external_lex_state = 14},
  [3813] = {.lex_state = 149},
  [3814] = {.lex_state = 149, .external_lex_state = 14},
  [3815] = {.lex_state = 149},
  [3816] = {.lex_state = 149},
  [3817] = {.lex_state = 157},
  [3818] = {.lex_state = 172},
  [3819] = {.lex_state = 149},
  [3820] = {.lex_state = 157},
  [3821] = {.lex_state = 149, .external_lex_state = 14},
  [3822] = {.lex_state = 149, .external_lex_state = 14},
  [3823] = {.lex_state = 149, .external_lex_state = 14},
  [3824] = {.lex_state = 149, .external_lex_state = 14},
  [3825] = {.lex_state = 149, .external_lex_state = 14},
  [3826] = {.lex_state = 149, .external_lex_state = 14},
  [3827] = {.lex_state = 149, .external_lex_state = 14},
  [3828] = {.lex_state = 149, .external_lex_state = 14},
  [3829] = {.lex_state = 157},
  [3830] = {.lex_state = 149, .external_lex_state = 14},
  [3831] = {.lex_state = 157},
  [3832] = {.lex_state = 138, .external_lex_state = 2},
  [3833] = {.lex_state = 157},
  [3834] = {.lex_state = 149},
  [3835] = {.lex_state = 149, .external_lex_state = 14},
  [3836] = {.lex_state = 149, .external_lex_state = 14},
  [3837] = {.lex_state = 149, .external_lex_state = 14},
  [3838] = {.lex_state = 149, .external_lex_state = 14},
  [3839] = {.lex_state = 149, .external_lex_state = 14},
  [3840] = {.lex_state = 149, .external_lex_state = 14},
  [3841] = {.lex_state = 149},
  [3842] = {.lex_state = 149},
  [3843] = {.lex_state = 157},
  [3844] = {.lex_state = 149, .external_lex_state = 14},
  [3845] = {.lex_state = 157},
  [3846] = {.lex_state = 149},
  [3847] = {.lex_state = 157},
  [3848] = {.lex_state = 157},
  [3849] = {.lex_state = 149, .external_lex_state = 14},
  [3850] = {.lex_state = 157},
  [3851] = {.lex_state = 149, .external_lex_state = 14},
  [3852] = {.lex_state = 157},
  [3853] = {.lex_state = 149, .external_lex_state = 14},
  [3854] = {.lex_state = 149, .external_lex_state = 14},
  [3855] = {.lex_state = 157},
  [3856] = {.lex_state = 157},
  [3857] = {.lex_state = 149, .external_lex_state = 14},
  [3858] = {.lex_state = 149, .external_lex_state = 14},
  [3859] = {.lex_state = 157},
  [3860] = {.lex_state = 149, .external_lex_state = 14},
  [3861] = {.lex_state = 157},
  [3862] = {.lex_state = 157},
  [3863] = {.lex_state = 157},
  [3864] = {.lex_state = 157},
  [3865] = {.lex_state = 157},
  [3866] = {.lex_state = 157},
  [3867] = {.lex_state = 157},
  [3868] = {.lex_state = 157},
  [3869] = {.lex_state = 149},
  [3870] = {.lex_state = 157},
  [3871] = {.lex_state = 157},
  [3872] = {.lex_state = 157},
  [3873] = {.lex_state = 149},
  [3874] = {.lex_state = 157},
  [3875] = {.lex_state = 149},
  [3876] = {.lex_state = 149, .external_lex_state = 14},
  [3877] = {.lex_state = 172},
  [3878] = {.lex_state = 149, .external_lex_state = 14},
  [3879] = {.lex_state = 157},
  [3880] = {.lex_state = 157},
  [3881] = {.lex_state = 157},
  [3882] = {.lex_state = 157},
  [3883] = {.lex_state = 157},
  [3884] = {.lex_state = 157},
  [3885] = {.lex_state = 172},
  [3886] = {.lex_state = 149},
  [3887] = {.lex_state = 138, .external_lex_state = 2},
  [3888] = {.lex_state = 149},
  [3889] = {.lex_state = 149},
  [3890] = {.lex_state = 172},
  [3891] = {.lex_state = 172},
  [3892] = {.lex_state = 172},
  [3893] = {.lex_state = 172},
  [3894] = {.lex_state = 138, .external_lex_state = 2},
  [3895] = {.lex_state = 149, .external_lex_state = 14},
  [3896] = {.lex_state = 172},
  [3897] = {.lex_state = 149},
  [3898] = {.lex_state = 149, .external_lex_state = 14},
  [3899] = {.lex_state = 157},
  [3900] = {.lex_state = 138, .external_lex_state = 2},
  [3901] = {.lex_state = 149},
  [3902] = {.lex_state = 157},
  [3903] = {.lex_state = 172},
  [3904] = {.lex_state = 157},
  [3905] = {.lex_state = 149, .external_lex_state = 14},
  [3906] = {.lex_state = 157},
  [3907] = {.lex_state = 149},
  [3908] = {.lex_state = 149},
  [3909] = {.lex_state = 157},
  [3910] = {.lex_state = 149},
  [3911] = {.lex_state = 164},
  [3912] = {.lex_state = 164},
  [3913] = {.lex_state = 172},
  [3914] = {.lex_state = 149, .external_lex_state = 14},
  [3915] = {.lex_state = 172},
  [3916] = {.lex_state = 149},
  [3917] = {.lex_state = 149, .external_lex_state = 14},
  [3918] = {.lex_state = 149, .external_lex_state = 14},
  [3919] = {.lex_state = 149, .external_lex_state = 14},
  [3920] = {.lex_state = 149},
  [3921] = {.lex_state = 149},
  [3922] = {.lex_state = 149},
  [3923] = {.lex_state = 157},
  [3924] = {.lex_state = 138, .external_lex_state = 2},
  [3925] = {.lex_state = 149},
  [3926] = {.lex_state = 149},
  [3927] = {.lex_state = 164},
  [3928] = {.lex_state = 164},
  [3929] = {.lex_state = 149},
  [3930] = {.lex_state = 164},
  [3931] = {.lex_state = 149},
  [3932] = {.lex_state = 149},
  [3933] = {.lex_state = 164},
  [3934] = {.lex_state = 164},
  [3935] = {.lex_state = 149},
  [3936] = {.lex_state = 149},
  [3937] = {.lex_state = 149},
  [3938] = {.lex_state = 149},
  [3939] = {.lex_state = 203},
  [3940] = {.lex_state = 138, .external_lex_state = 2},
  [3941] = {.lex_state = 164},
  [3942] = {.lex_state = 203},
  [3943] = {.lex_state = 164},
  [3944] = {.lex_state = 164},
  [3945] = {.lex_state = 203},
  [3946] = {.lex_state = 203},
  [3947] = {.lex_state = 164},
  [3948] = {.lex_state = 149},
  [3949] = {.lex_state = 149},
  [3950] = {.lex_state = 149},
  [3951] = {.lex_state = 149},
  [3952] = {.lex_state = 203},
  [3953] = {.lex_state = 149},
  [3954] = {.lex_state = 149},
  [3955] = {.lex_state = 149},
  [3956] = {.lex_state = 164},
  [3957] = {.lex_state = 149},
  [3958] = {.lex_state = 149},
  [3959] = {.lex_state = 149},
  [3960] = {.lex_state = 164},
  [3961] = {.lex_state = 149},
  [3962] = {.lex_state = 149},
  [3963] = {.lex_state = 164},
  [3964] = {.lex_state = 203},
  [3965] = {.lex_state = 164},
  [3966] = {.lex_state = 149},
  [3967] = {.lex_state = 149},
  [3968] = {.lex_state = 164},
  [3969] = {.lex_state = 203},
  [3970] = {.lex_state = 203},
  [3971] = {.lex_state = 164},
  [3972] = {.lex_state = 164},
  [3973] = {.lex_state = 164},
  [3974] = {.lex_state = 164},
  [3975] = {.lex_state = 203},
  [3976] = {.lex_state = 203},
  [3977] = {.lex_state = 149},
  [3978] = {.lex_state = 203},
  [3979] = {.lex_state = 164},
  [3980] = {.lex_state = 164},
  [3981] = {.lex_state = 164},
  [3982] = {.lex_state = 164},
  [3983] = {.lex_state = 149},
  [3984] = {.lex_state = 164},
  [3985] = {.lex_state = 149},
  [3986] = {.lex_state = 164},
  [3987] = {.lex_state = 164},
  [3988] = {.lex_state = 164},
  [3989] = {.lex_state = 149},
  [3990] = {.lex_state = 164},
  [3991] = {.lex_state = 203},
  [3992] = {.lex_state = 203},
  [3993] = {.lex_state = 203},
  [3994] = {.lex_state = 164},
  [3995] = {.lex_state = 164},
  [3996] = {.lex_state = 164},
  [3997] = {.lex_state = 164},
  [3998] = {.lex_state = 164},
  [3999] = {.lex_state = 138, .external_lex_state = 2},
  [4000] = {.lex_state = 164},
  [4001] = {.lex_state = 164},
  [4002] = {.lex_state = 164},
  [4003] = {.lex_state = 164},
  [4004] = {.lex_state = 203},
  [4005] = {.lex_state = 164},
  [4006] = {.lex_state = 203},
  [4007] = {.lex_state = 164},
  [4008] = {.lex_state = 176},
  [4009] = {.lex_state = 203},
  [4010] = {.lex_state = 203},
  [4011] = {.lex_state = 203},
  [4012] = {.lex_state = 173},
  [4013] = {.lex_state = 203},
  [4014] = {.lex_state = 203},
  [4015] = {.lex_state = 173},
  [4016] = {.lex_state = 203},
  [4017] = {.lex_state = 173},
  [4018] = {.lex_state = 203},
  [4019] = {.lex_state = 203},
  [4020] = {.lex_state = 203},
  [4021] = {.lex_state = 173},
  [4022] = {.lex_state = 177},
  [4023] = {.lex_state = 173},
  [4024] = {.lex_state = 177},
  [4025] = {.lex_state = 177},
  [4026] = {.lex_state = 173},
  [4027] = {.lex_state = 173},
  [4028] = {.lex_state = 194, .external_lex_state = 5},
  [4029] = {.lex_state = 177},
  [4030] = {.lex_state = 179},
  [4031] = {.lex_state = 194, .external_lex_state = 5},
  [4032] = {.lex_state = 173},
  [4033] = {.lex_state = 173},
  [4034] = {.lex_state = 194, .external_lex_state = 6},
  [4035] = {.lex_state = 194, .external_lex_state = 5},
  [4036] = {.lex_state = 173},
  [4037] = {.lex_state = 194, .external_lex_state = 5},
  [4038] = {.lex_state = 194, .external_lex_state = 5},
  [4039] = {.lex_state = 194, .external_lex_state = 5},
  [4040] = {.lex_state = 194, .external_lex_state = 5},
  [4041] = {.lex_state = 194, .external_lex_state = 5},
  [4042] = {.lex_state = 196},
  [4043] = {.lex_state = 173},
  [4044] = {.lex_state = 173},
  [4045] = {.lex_state = 173},
  [4046] = {.lex_state = 194, .external_lex_state = 5},
  [4047] = {.lex_state = 173},
  [4048] = {.lex_state = 203},
  [4049] = {.lex_state = 173},
  [4050] = {.lex_state = 173},
  [4051] = {.lex_state = 173},
  [4052] = {.lex_state = 194, .external_lex_state = 5},
  [4053] = {.lex_state = 173},
  [4054] = {.lex_state = 173},
  [4055] = {.lex_state = 173},
  [4056] = {.lex_state = 194, .external_lex_state = 5},
  [4057] = {.lex_state = 173},
  [4058] = {.lex_state = 173},
  [4059] = {.lex_state = 173},
  [4060] = {.lex_state = 173},
  [4061] = {.lex_state = 194, .external_lex_state = 6},
  [4062] = {.lex_state = 173},
  [4063] = {.lex_state = 173},
  [4064] = {.lex_state = 173},
  [4065] = {.lex_state = 173},
  [4066] = {.lex_state = 194, .external_lex_state = 5},
  [4067] = {.lex_state = 194, .external_lex_state = 5},
  [4068] = {.lex_state = 173},
  [4069] = {.lex_state = 194, .external_lex_state = 5},
  [4070] = {.lex_state = 194, .external_lex_state = 5},
  [4071] = {.lex_state = 173},
  [4072] = {.lex_state = 194, .external_lex_state = 5},
  [4073] = {.lex_state = 173},
  [4074] = {.lex_state = 173},
  [4075] = {.lex_state = 173},
  [4076] = {.lex_state = 173},
  [4077] = {.lex_state = 356},
  [4078] = {.lex_state = 173},
  [4079] = {.lex_state = 173},
  [4080] = {.lex_state = 173},
  [4081] = {.lex_state = 173},
  [4082] = {.lex_state = 173},
  [4083] = {.lex_state = 173},
  [4084] = {.lex_state = 173},
  [4085] = {.lex_state = 173},
  [4086] = {.lex_state = 173},
  [4087] = {.lex_state = 194, .external_lex_state = 5},
  [4088] = {.lex_state = 173},
  [4089] = {.lex_state = 173},
  [4090] = {.lex_state = 173},
  [4091] = {.lex_state = 173},
  [4092] = {.lex_state = 194, .external_lex_state = 6},
  [4093] = {.lex_state = 173},
  [4094] = {.lex_state = 173},
  [4095] = {.lex_state = 194, .external_lex_state = 6},
  [4096] = {.lex_state = 173},
  [4097] = {.lex_state = 194, .external_lex_state = 6},
  [4098] = {.lex_state = 173},
  [4099] = {.lex_state = 173},
  [4100] = {.lex_state = 194, .external_lex_state = 5},
  [4101] = {.lex_state = 194, .external_lex_state = 6},
  [4102] = {.lex_state = 173},
  [4103] = {.lex_state = 194, .external_lex_state = 6},
  [4104] = {.lex_state = 173},
  [4105] = {.lex_state = 173},
  [4106] = {.lex_state = 173},
  [4107] = {.lex_state = 194, .external_lex_state = 6},
  [4108] = {.lex_state = 179},
  [4109] = {.lex_state = 173},
  [4110] = {.lex_state = 173},
  [4111] = {.lex_state = 194, .external_lex_state = 5},
  [4112] = {.lex_state = 173},
  [4113] = {.lex_state = 194, .external_lex_state = 5},
  [4114] = {.lex_state = 179},
  [4115] = {.lex_state = 173},
  [4116] = {.lex_state = 194, .external_lex_state = 6},
  [4117] = {.lex_state = 194, .external_lex_state = 5},
  [4118] = {.lex_state = 179},
  [4119] = {.lex_state = 173},
  [4120] = {.lex_state = 173},
  [4121] = {.lex_state = 173},
  [4122] = {.lex_state = 173},
  [4123] = {.lex_state = 173},
  [4124] = {.lex_state = 173},
  [4125] = {.lex_state = 173},
  [4126] = {.lex_state = 173},
  [4127] = {.lex_state = 173},
  [4128] = {.lex_state = 173},
  [4129] = {.lex_state = 194, .external_lex_state = 6},
  [4130] = {.lex_state = 173},
  [4131] = {.lex_state = 173},
  [4132] = {.lex_state = 173},
  [4133] = {.lex_state = 173},
  [4134] = {.lex_state = 173},
  [4135] = {.lex_state = 173},
  [4136] = {.lex_state = 173},
  [4137] = {.lex_state = 173},
  [4138] = {.lex_state = 194, .external_lex_state = 6},
  [4139] = {.lex_state = 173},
  [4140] = {.lex_state = 173},
  [4141] = {.lex_state = 173},
  [4142] = {.lex_state = 173},
  [4143] = {.lex_state = 173},
  [4144] = {.lex_state = 173},
  [4145] = {.lex_state = 173},
  [4146] = {.lex_state = 173},
  [4147] = {.lex_state = 173},
  [4148] = {.lex_state = 173},
  [4149] = {.lex_state = 173},
  [4150] = {.lex_state = 173},
  [4151] = {.lex_state = 173},
  [4152] = {.lex_state = 173},
  [4153] = {.lex_state = 173},
  [4154] = {.lex_state = 173},
  [4155] = {.lex_state = 173},
  [4156] = {.lex_state = 173},
  [4157] = {.lex_state = 173},
  [4158] = {.lex_state = 173},
  [4159] = {.lex_state = 173},
  [4160] = {.lex_state = 194, .external_lex_state = 6},
  [4161] = {.lex_state = 194, .external_lex_state = 5},
  [4162] = {.lex_state = 194, .external_lex_state = 5},
  [4163] = {.lex_state = 203},
  [4164] = {.lex_state = 356},
  [4165] = {.lex_state = 203},
  [4166] = {.lex_state = 194, .external_lex_state = 6},
  [4167] = {.lex_state = 194, .external_lex_state = 5},
  [4168] = {.lex_state = 194, .external_lex_state = 6},
  [4169] = {.lex_state = 179},
  [4170] = {.lex_state = 199},
  [4171] = {.lex_state = 194, .external_lex_state = 6},
  [4172] = {.lex_state = 194, .external_lex_state = 5},
  [4173] = {.lex_state = 203},
  [4174] = {.lex_state = 194, .external_lex_state = 5},
  [4175] = {.lex_state = 194, .external_lex_state = 6},
  [4176] = {.lex_state = 203},
  [4177] = {.lex_state = 194, .external_lex_state = 6},
  [4178] = {.lex_state = 194, .external_lex_state = 6},
  [4179] = {.lex_state = 194, .external_lex_state = 6},
  [4180] = {.lex_state = 194, .external_lex_state = 6},
  [4181] = {.lex_state = 194, .external_lex_state = 6},
  [4182] = {.lex_state = 194, .external_lex_state = 5},
  [4183] = {.lex_state = 194, .external_lex_state = 5},
  [4184] = {.lex_state = 194, .external_lex_state = 5},
  [4185] = {.lex_state = 194, .external_lex_state = 6},
  [4186] = {.lex_state = 194, .external_lex_state = 5},
  [4187] = {.lex_state = 194, .external_lex_state = 6},
  [4188] = {.lex_state = 194, .external_lex_state = 6},
  [4189] = {.lex_state = 194, .external_lex_state = 6},
  [4190] = {.lex_state = 194, .external_lex_state = 5},
  [4191] = {.lex_state = 194, .external_lex_state = 6},
  [4192] = {.lex_state = 194, .external_lex_state = 6},
  [4193] = {.lex_state = 194, .external_lex_state = 6},
  [4194] = {.lex_state = 203},
  [4195] = {.lex_state = 194, .external_lex_state = 5},
  [4196] = {.lex_state = 194, .external_lex_state = 5},
  [4197] = {.lex_state = 203},
  [4198] = {.lex_state = 194, .external_lex_state = 5},
  [4199] = {.lex_state = 194, .external_lex_state = 5},
  [4200] = {.lex_state = 194, .external_lex_state = 6},
  [4201] = {.lex_state = 194, .external_lex_state = 5},
  [4202] = {.lex_state = 194, .external_lex_state = 5},
  [4203] = {.lex_state = 194, .external_lex_state = 5},
  [4204] = {.lex_state = 356},
  [4205] = {.lex_state = 194, .external_lex_state = 5},
  [4206] = {.lex_state = 194, .external_lex_state = 5},
  [4207] = {.lex_state = 194, .external_lex_state = 6},
  [4208] = {.lex_state = 203},
  [4209] = {.lex_state = 356, .external_lex_state = 16},
  [4210] = {.lex_state = 194, .external_lex_state = 6},
  [4211] = {.lex_state = 183},
  [4212] = {.lex_state = 194, .external_lex_state = 6},
  [4213] = {.lex_state = 356, .external_lex_state = 16},
  [4214] = {.lex_state = 194, .external_lex_state = 6},
  [4215] = {.lex_state = 194, .external_lex_state = 6},
  [4216] = {.lex_state = 194, .external_lex_state = 6},
  [4217] = {.lex_state = 194, .external_lex_state = 6},
  [4218] = {.lex_state = 194, .external_lex_state = 6},
  [4219] = {.lex_state = 194, .external_lex_state = 6},
  [4220] = {.lex_state = 194, .external_lex_state = 6},
  [4221] = {.lex_state = 196, .external_lex_state = 14},
  [4222] = {.lex_state = 356, .external_lex_state = 16},
  [4223] = {.lex_state = 356, .external_lex_state = 16},
  [4224] = {.lex_state = 194, .external_lex_state = 6},
  [4225] = {.lex_state = 356, .external_lex_state = 16},
  [4226] = {.lex_state = 203},
  [4227] = {.lex_state = 203},
  [4228] = {.lex_state = 356, .external_lex_state = 16},
  [4229] = {.lex_state = 187, .external_lex_state = 16},
  [4230] = {.lex_state = 356, .external_lex_state = 16},
  [4231] = {.lex_state = 203},
  [4232] = {.lex_state = 356, .external_lex_state = 16},
  [4233] = {.lex_state = 203},
  [4234] = {.lex_state = 203},
  [4235] = {.lex_state = 187},
  [4236] = {.lex_state = 203},
  [4237] = {.lex_state = 203},
  [4238] = {.lex_state = 203},
  [4239] = {.lex_state = 356},
  [4240] = {.lex_state = 202, .external_lex_state = 17},
  [4241] = {.lex_state = 202, .external_lex_state = 17},
  [4242] = {.lex_state = 356},
  [4243] = {.lex_state = 184},
  [4244] = {.lex_state = 203},
  [4245] = {.lex_state = 356},
  [4246] = {.lex_state = 187},
  [4247] = {.lex_state = 203},
  [4248] = {.lex_state = 187},
  [4249] = {.lex_state = 187},
  [4250] = {.lex_state = 203},
  [4251] = {.lex_state = 203},
  [4252] = {.lex_state = 187},
  [4253] = {.lex_state = 203},
  [4254] = {.lex_state = 187},
  [4255] = {.lex_state = 187},
  [4256] = {.lex_state = 184},
  [4257] = {.lex_state = 202, .external_lex_state = 17},
  [4258] = {.lex_state = 203},
  [4259] = {.lex_state = 203},
  [4260] = {.lex_state = 187},
  [4261] = {.lex_state = 187},
  [4262] = {.lex_state = 202, .external_lex_state = 17},
  [4263] = {.lex_state = 184},
  [4264] = {.lex_state = 180},
  [4265] = {.lex_state = 187},
  [4266] = {.lex_state = 203},
  [4267] = {.lex_state = 187},
  [4268] = {.lex_state = 187},
  [4269] = {.lex_state = 184},
  [4270] = {.lex_state = 203},
  [4271] = {.lex_state = 187},
  [4272] = {.lex_state = 202, .external_lex_state = 17},
  [4273] = {.lex_state = 203},
  [4274] = {.lex_state = 203},
  [4275] = {.lex_state = 202, .external_lex_state = 17},
  [4276] = {.lex_state = 187},
  [4277] = {.lex_state = 187},
  [4278] = {.lex_state = 180},
  [4279] = {.lex_state = 202, .external_lex_state = 17},
  [4280] = {.lex_state = 187},
  [4281] = {.lex_state = 180},
  [4282] = {.lex_state = 203},
  [4283] = {.lex_state = 202, .external_lex_state = 18},
  [4284] = {.lex_state = 187, .external_lex_state = 16},
  [4285] = {.lex_state = 202, .external_lex_state = 18},
  [4286] = {.lex_state = 202, .external_lex_state = 18},
  [4287] = {.lex_state = 202, .external_lex_state = 18},
  [4288] = {.lex_state = 187, .external_lex_state = 16},
  [4289] = {.lex_state = 187, .external_lex_state = 16},
  [4290] = {.lex_state = 202, .external_lex_state = 17},
  [4291] = {.lex_state = 187, .external_lex_state = 14},
  [4292] = {.lex_state = 203},
  [4293] = {.lex_state = 202, .external_lex_state = 18},
  [4294] = {.lex_state = 202, .external_lex_state = 17},
  [4295] = {.lex_state = 202, .external_lex_state = 17},
  [4296] = {.lex_state = 138},
  [4297] = {.lex_state = 202, .external_lex_state = 17},
  [4298] = {.lex_state = 180},
  [4299] = {.lex_state = 187, .external_lex_state = 16},
  [4300] = {.lex_state = 202, .external_lex_state = 17},
  [4301] = {.lex_state = 202, .external_lex_state = 17},
  [4302] = {.lex_state = 187, .external_lex_state = 14},
  [4303] = {.lex_state = 187, .external_lex_state = 14},
  [4304] = {.lex_state = 187, .external_lex_state = 16},
  [4305] = {.lex_state = 187, .external_lex_state = 14},
  [4306] = {.lex_state = 203},
  [4307] = {.lex_state = 202, .external_lex_state = 18},
  [4308] = {.lex_state = 187, .external_lex_state = 16},
  [4309] = {.lex_state = 187, .external_lex_state = 16},
  [4310] = {.lex_state = 202, .external_lex_state = 17},
  [4311] = {.lex_state = 187, .external_lex_state = 14},
  [4312] = {.lex_state = 187, .external_lex_state = 16},
  [4313] = {.lex_state = 203},
  [4314] = {.lex_state = 180},
  [4315] = {.lex_state = 202, .external_lex_state = 17},
  [4316] = {.lex_state = 180},
  [4317] = {.lex_state = 175, .external_lex_state = 14},
  [4318] = {.lex_state = 180},
  [4319] = {.lex_state = 180},
  [4320] = {.lex_state = 187, .external_lex_state = 14},
  [4321] = {.lex_state = 187, .external_lex_state = 16},
  [4322] = {.lex_state = 187, .external_lex_state = 16},
  [4323] = {.lex_state = 187, .external_lex_state = 16},
  [4324] = {.lex_state = 138},
  [4325] = {.lex_state = 187, .external_lex_state = 14},
  [4326] = {.lex_state = 187, .external_lex_state = 16},
  [4327] = {.lex_state = 202, .external_lex_state = 18},
  [4328] = {.lex_state = 203},
  [4329] = {.lex_state = 203},
  [4330] = {.lex_state = 203},
  [4331] = {.lex_state = 203},
  [4332] = {.lex_state = 203},
  [4333] = {.lex_state = 203},
  [4334] = {.lex_state = 203},
  [4335] = {.lex_state = 203},
  [4336] = {.lex_state = 203},
  [4337] = {.lex_state = 203},
  [4338] = {.lex_state = 203},
  [4339] = {.lex_state = 203},
  [4340] = {.lex_state = 203},
  [4341] = {.lex_state = 203},
  [4342] = {.lex_state = 203},
  [4343] = {.lex_state = 356},
  [4344] = {.lex_state = 203},
  [4345] = {.lex_state = 203},
  [4346] = {.lex_state = 180},
  [4347] = {.lex_state = 180},
  [4348] = {.lex_state = 203},
  [4349] = {.lex_state = 203},
  [4350] = {.lex_state = 203},
  [4351] = {.lex_state = 203},
  [4352] = {.lex_state = 203},
  [4353] = {.lex_state = 203},
  [4354] = {.lex_state = 203},
  [4355] = {.lex_state = 203},
  [4356] = {.lex_state = 187, .external_lex_state = 14},
  [4357] = {.lex_state = 180},
  [4358] = {.lex_state = 203},
  [4359] = {.lex_state = 203},
  [4360] = {.lex_state = 180},
  [4361] = {.lex_state = 187, .external_lex_state = 14},
  [4362] = {.lex_state = 203},
  [4363] = {.lex_state = 203},
  [4364] = {.lex_state = 187, .external_lex_state = 16},
  [4365] = {.lex_state = 203},
  [4366] = {.lex_state = 203},
  [4367] = {.lex_state = 203},
  [4368] = {.lex_state = 203},
  [4369] = {.lex_state = 180},
  [4370] = {.lex_state = 203},
  [4371] = {.lex_state = 203},
  [4372] = {.lex_state = 203},
  [4373] = {.lex_state = 203},
  [4374] = {.lex_state = 203},
  [4375] = {.lex_state = 203},
  [4376] = {.lex_state = 203},
  [4377] = {.lex_state = 187, .external_lex_state = 14},
  [4378] = {.lex_state = 203},
  [4379] = {.lex_state = 203},
  [4380] = {.lex_state = 203},
  [4381] = {.lex_state = 203},
  [4382] = {.lex_state = 203},
  [4383] = {.lex_state = 203},
  [4384] = {.lex_state = 203},
  [4385] = {.lex_state = 203},
  [4386] = {.lex_state = 203},
  [4387] = {.lex_state = 187, .external_lex_state = 14},
  [4388] = {.lex_state = 202, .external_lex_state = 17},
  [4389] = {.lex_state = 356},
  [4390] = {.lex_state = 356},
  [4391] = {.lex_state = 203},
  [4392] = {.lex_state = 203},
  [4393] = {.lex_state = 180},
  [4394] = {.lex_state = 180},
  [4395] = {.lex_state = 202, .external_lex_state = 17},
  [4396] = {.lex_state = 203},
  [4397] = {.lex_state = 203},
  [4398] = {.lex_state = 180},
  [4399] = {.lex_state = 203},
  [4400] = {.lex_state = 203},
  [4401] = {.lex_state = 203},
  [4402] = {.lex_state = 203},
  [4403] = {.lex_state = 202, .external_lex_state = 17},
  [4404] = {.lex_state = 203},
  [4405] = {.lex_state = 203},
  [4406] = {.lex_state = 203},
  [4407] = {.lex_state = 180},
  [4408] = {.lex_state = 203},
  [4409] = {.lex_state = 203},
  [4410] = {.lex_state = 203},
  [4411] = {.lex_state = 203},
  [4412] = {.lex_state = 180},
  [4413] = {.lex_state = 180},
  [4414] = {.lex_state = 203},
  [4415] = {.lex_state = 203},
  [4416] = {.lex_state = 203},
  [4417] = {.lex_state = 180},
  [4418] = {.lex_state = 203},
  [4419] = {.lex_state = 203},
  [4420] = {.lex_state = 180},
  [4421] = {.lex_state = 203},
  [4422] = {.lex_state = 180},
  [4423] = {.lex_state = 203},
  [4424] = {.lex_state = 203},
  [4425] = {.lex_state = 203},
  [4426] = {.lex_state = 203},
  [4427] = {.lex_state = 203},
  [4428] = {.lex_state = 187, .external_lex_state = 16},
  [4429] = {.lex_state = 203},
  [4430] = {.lex_state = 203},
  [4431] = {.lex_state = 203},
  [4432] = {.lex_state = 203},
  [4433] = {.lex_state = 203},
  [4434] = {.lex_state = 203},
  [4435] = {.lex_state = 180},
  [4436] = {.lex_state = 203},
  [4437] = {.lex_state = 203},
  [4438] = {.lex_state = 203},
  [4439] = {.lex_state = 203},
  [4440] = {.lex_state = 180},
  [4441] = {.lex_state = 203},
  [4442] = {.lex_state = 203},
  [4443] = {.lex_state = 203},
  [4444] = {.lex_state = 203},
  [4445] = {.lex_state = 203},
  [4446] = {.lex_state = 203},
  [4447] = {.lex_state = 187, .external_lex_state = 16},
  [4448] = {.lex_state = 203},
  [4449] = {.lex_state = 203},
  [4450] = {.lex_state = 203},
  [4451] = {.lex_state = 203},
  [4452] = {.lex_state = 203},
  [4453] = {.lex_state = 203},
  [4454] = {.lex_state = 203},
  [4455] = {.lex_state = 203},
  [4456] = {.lex_state = 180},
  [4457] = {.lex_state = 203},
  [4458] = {.lex_state = 180},
  [4459] = {.lex_state = 203},
  [4460] = {.lex_state = 203},
  [4461] = {.lex_state = 203},
  [4462] = {.lex_state = 180},
  [4463] = {.lex_state = 203},
  [4464] = {.lex_state = 203},
  [4465] = {.lex_state = 203},
  [4466] = {.lex_state = 203},
  [4467] = {.lex_state = 203},
  [4468] = {.lex_state = 203},
  [4469] = {.lex_state = 203},
  [4470] = {.lex_state = 180},
  [4471] = {.lex_state = 203},
  [4472] = {.lex_state = 180},
  [4473] = {.lex_state = 203},
  [4474] = {.lex_state = 203},
  [4475] = {.lex_state = 203},
  [4476] = {.lex_state = 203},
  [4477] = {.lex_state = 203},
  [4478] = {.lex_state = 203},
  [4479] = {.lex_state = 203},
  [4480] = {.lex_state = 203},
  [4481] = {.lex_state = 187, .external_lex_state = 16},
  [4482] = {.lex_state = 203},
  [4483] = {.lex_state = 203},
  [4484] = {.lex_state = 203},
  [4485] = {.lex_state = 203},
  [4486] = {.lex_state = 203},
  [4487] = {.lex_state = 203},
  [4488] = {.lex_state = 203},
  [4489] = {.lex_state = 187, .external_lex_state = 16},
  [4490] = {.lex_state = 203},
  [4491] = {.lex_state = 203},
  [4492] = {.lex_state = 203},
  [4493] = {.lex_state = 203},
  [4494] = {.lex_state = 203},
  [4495] = {.lex_state = 203},
  [4496] = {.lex_state = 203},
  [4497] = {.lex_state = 203},
  [4498] = {.lex_state = 203},
  [4499] = {.lex_state = 203},
  [4500] = {.lex_state = 203},
  [4501] = {.lex_state = 203},
  [4502] = {.lex_state = 356},
  [4503] = {.lex_state = 203},
  [4504] = {.lex_state = 203},
  [4505] = {.lex_state = 203},
  [4506] = {.lex_state = 202, .external_lex_state = 17},
  [4507] = {.lex_state = 203},
  [4508] = {.lex_state = 203},
  [4509] = {.lex_state = 203},
  [4510] = {.lex_state = 203},
  [4511] = {.lex_state = 203},
  [4512] = {.lex_state = 180},
  [4513] = {.lex_state = 203},
  [4514] = {.lex_state = 203},
  [4515] = {.lex_state = 203},
  [4516] = {.lex_state = 203},
  [4517] = {.lex_state = 203},
  [4518] = {.lex_state = 203},
  [4519] = {.lex_state = 203},
  [4520] = {.lex_state = 203},
  [4521] = {.lex_state = 203},
  [4522] = {.lex_state = 203},
  [4523] = {.lex_state = 203},
  [4524] = {.lex_state = 203},
  [4525] = {.lex_state = 203},
  [4526] = {.lex_state = 203},
  [4527] = {.lex_state = 203},
  [4528] = {.lex_state = 203},
  [4529] = {.lex_state = 203},
  [4530] = {.lex_state = 203},
  [4531] = {.lex_state = 203},
  [4532] = {.lex_state = 203},
  [4533] = {.lex_state = 203},
  [4534] = {.lex_state = 203},
  [4535] = {.lex_state = 203},
  [4536] = {.lex_state = 203},
  [4537] = {.lex_state = 203},
  [4538] = {.lex_state = 203},
  [4539] = {.lex_state = 203},
  [4540] = {.lex_state = 203},
  [4541] = {.lex_state = 203},
  [4542] = {.lex_state = 203},
  [4543] = {.lex_state = 203},
  [4544] = {.lex_state = 203},
  [4545] = {.lex_state = 203},
  [4546] = {.lex_state = 180},
  [4547] = {.lex_state = 203},
  [4548] = {.lex_state = 203},
  [4549] = {.lex_state = 203},
  [4550] = {.lex_state = 203},
  [4551] = {.lex_state = 203},
  [4552] = {.lex_state = 203},
  [4553] = {.lex_state = 203},
  [4554] = {.lex_state = 203},
  [4555] = {.lex_state = 203},
  [4556] = {.lex_state = 203},
  [4557] = {.lex_state = 203},
  [4558] = {.lex_state = 203},
  [4559] = {.lex_state = 203},
  [4560] = {.lex_state = 203},
  [4561] = {.lex_state = 180},
  [4562] = {.lex_state = 187, .external_lex_state = 14},
  [4563] = {.lex_state = 203},
  [4564] = {.lex_state = 203},
  [4565] = {.lex_state = 180},
  [4566] = {.lex_state = 203},
  [4567] = {.lex_state = 203},
  [4568] = {.lex_state = 203},
  [4569] = {.lex_state = 203},
  [4570] = {.lex_state = 203},
  [4571] = {.lex_state = 180},
  [4572] = {.lex_state = 203},
  [4573] = {.lex_state = 203},
  [4574] = {.lex_state = 203},
  [4575] = {.lex_state = 203},
  [4576] = {.lex_state = 194, .external_lex_state = 5},
  [4577] = {.lex_state = 180},
  [4578] = {.lex_state = 203},
  [4579] = {.lex_state = 194, .external_lex_state = 5},
  [4580] = {.lex_state = 202, .external_lex_state = 17},
  [4581] = {.lex_state = 194, .external_lex_state = 5},
  [4582] = {.lex_state = 203},
  [4583] = {.lex_state = 203},
  [4584] = {.lex_state = 203},
  [4585] = {.lex_state = 203},
  [4586] = {.lex_state = 203},
  [4587] = {.lex_state = 203},
  [4588] = {.lex_state = 203},
  [4589] = {.lex_state = 203},
  [4590] = {.lex_state = 203},
  [4591] = {.lex_state = 203},
  [4592] = {.lex_state = 203},
  [4593] = {.lex_state = 202, .external_lex_state = 17},
  [4594] = {.lex_state = 203},
  [4595] = {.lex_state = 203},
  [4596] = {.lex_state = 203},
  [4597] = {.lex_state = 203},
  [4598] = {.lex_state = 194, .external_lex_state = 5},
  [4599] = {.lex_state = 203},
  [4600] = {.lex_state = 203},
  [4601] = {.lex_state = 203},
  [4602] = {.lex_state = 203},
  [4603] = {.lex_state = 203},
  [4604] = {.lex_state = 203},
  [4605] = {.lex_state = 203},
  [4606] = {.lex_state = 203},
  [4607] = {.lex_state = 203},
  [4608] = {.lex_state = 203},
  [4609] = {.lex_state = 203},
  [4610] = {.lex_state = 203},
  [4611] = {.lex_state = 202, .external_lex_state = 18},
  [4612] = {.lex_state = 202, .external_lex_state = 17},
  [4613] = {.lex_state = 203},
  [4614] = {.lex_state = 203},
  [4615] = {.lex_state = 180},
  [4616] = {.lex_state = 203},
  [4617] = {.lex_state = 203},
  [4618] = {.lex_state = 203},
  [4619] = {.lex_state = 203},
  [4620] = {.lex_state = 203},
  [4621] = {.lex_state = 203},
  [4622] = {.lex_state = 203},
  [4623] = {.lex_state = 180},
  [4624] = {.lex_state = 180},
  [4625] = {.lex_state = 203},
  [4626] = {.lex_state = 203},
  [4627] = {.lex_state = 180},
  [4628] = {.lex_state = 202, .external_lex_state = 17},
  [4629] = {.lex_state = 180},
  [4630] = {.lex_state = 202, .external_lex_state = 17},
  [4631] = {.lex_state = 203},
  [4632] = {.lex_state = 180},
  [4633] = {.lex_state = 203},
  [4634] = {.lex_state = 187, .external_lex_state = 14},
  [4635] = {.lex_state = 203},
  [4636] = {.lex_state = 202, .external_lex_state = 18},
  [4637] = {.lex_state = 180},
  [4638] = {.lex_state = 203},
  [4639] = {.lex_state = 202, .external_lex_state = 18},
  [4640] = {.lex_state = 203},
  [4641] = {.lex_state = 203},
  [4642] = {.lex_state = 203},
  [4643] = {.lex_state = 202, .external_lex_state = 18},
  [4644] = {.lex_state = 203},
  [4645] = {.lex_state = 194, .external_lex_state = 5},
  [4646] = {.lex_state = 203},
  [4647] = {.lex_state = 356},
  [4648] = {.lex_state = 203},
  [4649] = {.lex_state = 203},
  [4650] = {.lex_state = 203},
  [4651] = {.lex_state = 203},
  [4652] = {.lex_state = 203},
  [4653] = {.lex_state = 202, .external_lex_state = 17},
  [4654] = {.lex_state = 203},
  [4655] = {.lex_state = 203},
  [4656] = {.lex_state = 203},
  [4657] = {.lex_state = 202, .external_lex_state = 18},
  [4658] = {.lex_state = 203},
  [4659] = {.lex_state = 203},
  [4660] = {.lex_state = 203},
  [4661] = {.lex_state = 187, .external_lex_state = 14},
  [4662] = {.lex_state = 203},
  [4663] = {.lex_state = 180},
  [4664] = {.lex_state = 180},
  [4665] = {.lex_state = 187, .external_lex_state = 14},
  [4666] = {.lex_state = 203},
  [4667] = {.lex_state = 202, .external_lex_state = 18},
  [4668] = {.lex_state = 203},
  [4669] = {.lex_state = 203},
  [4670] = {.lex_state = 203},
  [4671] = {.lex_state = 203},
  [4672] = {.lex_state = 203},
  [4673] = {.lex_state = 203},
  [4674] = {.lex_state = 203},
  [4675] = {.lex_state = 203},
  [4676] = {.lex_state = 203},
  [4677] = {.lex_state = 203},
  [4678] = {.lex_state = 203},
  [4679] = {.lex_state = 203},
  [4680] = {.lex_state = 203},
  [4681] = {.lex_state = 203},
  [4682] = {.lex_state = 180},
  [4683] = {.lex_state = 203},
  [4684] = {.lex_state = 203},
  [4685] = {.lex_state = 203},
  [4686] = {.lex_state = 203},
  [4687] = {.lex_state = 203},
  [4688] = {.lex_state = 203},
  [4689] = {.lex_state = 203},
  [4690] = {.lex_state = 203},
  [4691] = {.lex_state = 194, .external_lex_state = 5},
  [4692] = {.lex_state = 203},
  [4693] = {.lex_state = 203},
  [4694] = {.lex_state = 180},
  [4695] = {.lex_state = 203},
  [4696] = {.lex_state = 203},
  [4697] = {.lex_state = 203},
  [4698] = {.lex_state = 203},
  [4699] = {.lex_state = 203},
  [4700] = {.lex_state = 180},
  [4701] = {.lex_state = 203},
  [4702] = {.lex_state = 203},
  [4703] = {.lex_state = 203},
  [4704] = {.lex_state = 203},
  [4705] = {.lex_state = 203},
  [4706] = {.lex_state = 202, .external_lex_state = 18},
  [4707] = {.lex_state = 202, .external_lex_state = 18},
  [4708] = {.lex_state = 203},
  [4709] = {.lex_state = 203},
  [4710] = {.lex_state = 203},
  [4711] = {.lex_state = 203},
  [4712] = {.lex_state = 203},
  [4713] = {.lex_state = 203},
  [4714] = {.lex_state = 203},
  [4715] = {.lex_state = 203},
  [4716] = {.lex_state = 203},
  [4717] = {.lex_state = 180},
  [4718] = {.lex_state = 203},
  [4719] = {.lex_state = 203},
  [4720] = {.lex_state = 138},
  [4721] = {.lex_state = 194, .external_lex_state = 6},
  [4722] = {.lex_state = 194, .external_lex_state = 5},
  [4723] = {.lex_state = 194, .external_lex_state = 6},
  [4724] = {.lex_state = 194, .external_lex_state = 5},
  [4725] = {.lex_state = 194, .external_lex_state = 5},
  [4726] = {.lex_state = 194, .external_lex_state = 5},
  [4727] = {.lex_state = 194, .external_lex_state = 5},
  [4728] = {.lex_state = 194, .external_lex_state = 5},
  [4729] = {.lex_state = 187, .external_lex_state = 16},
  [4730] = {.lex_state = 194, .external_lex_state = 5},
  [4731] = {.lex_state = 187, .external_lex_state = 14},
  [4732] = {.lex_state = 187, .external_lex_state = 14},
  [4733] = {.lex_state = 187, .external_lex_state = 14},
  [4734] = {.lex_state = 202, .external_lex_state = 18},
  [4735] = {.lex_state = 202, .external_lex_state = 18},
  [4736] = {.lex_state = 187, .external_lex_state = 14},
  [4737] = {.lex_state = 202, .external_lex_state = 18},
  [4738] = {.lex_state = 138},
  [4739] = {.lex_state = 202, .external_lex_state = 18},
  [4740] = {.lex_state = 202, .external_lex_state = 18},
  [4741] = {.lex_state = 202, .external_lex_state = 18},
  [4742] = {.lex_state = 180},
  [4743] = {.lex_state = 194, .external_lex_state = 6},
  [4744] = {.lex_state = 180},
  [4745] = {.lex_state = 194, .external_lex_state = 6},
  [4746] = {.lex_state = 180},
  [4747] = {.lex_state = 180},
  [4748] = {.lex_state = 180},
  [4749] = {.lex_state = 171},
  [4750] = {.lex_state = 187, .external_lex_state = 14},
  [4751] = {.lex_state = 194, .external_lex_state = 5},
  [4752] = {.lex_state = 194, .external_lex_state = 5},
  [4753] = {.lex_state = 194, .external_lex_state = 5},
  [4754] = {.lex_state = 194, .external_lex_state = 5},
  [4755] = {.lex_state = 194, .external_lex_state = 5},
  [4756] = {.lex_state = 202, .external_lex_state = 18},
  [4757] = {.lex_state = 202, .external_lex_state = 18},
  [4758] = {.lex_state = 202, .external_lex_state = 18},
  [4759] = {.lex_state = 202, .external_lex_state = 18},
  [4760] = {.lex_state = 187, .external_lex_state = 14},
  [4761] = {.lex_state = 194, .external_lex_state = 6},
  [4762] = {.lex_state = 194, .external_lex_state = 6},
  [4763] = {.lex_state = 187, .external_lex_state = 16},
  [4764] = {.lex_state = 356, .external_lex_state = 17},
  [4765] = {.lex_state = 202, .external_lex_state = 17},
  [4766] = {.lex_state = 202, .external_lex_state = 17},
  [4767] = {.lex_state = 202, .external_lex_state = 17},
  [4768] = {.lex_state = 171, .external_lex_state = 14},
  [4769] = {.lex_state = 187, .external_lex_state = 16},
  [4770] = {.lex_state = 187, .external_lex_state = 16},
  [4771] = {.lex_state = 187, .external_lex_state = 16},
  [4772] = {.lex_state = 356, .external_lex_state = 17},
  [4773] = {.lex_state = 187, .external_lex_state = 16},
  [4774] = {.lex_state = 187, .external_lex_state = 14},
  [4775] = {.lex_state = 187, .external_lex_state = 14},
  [4776] = {.lex_state = 187, .external_lex_state = 14},
  [4777] = {.lex_state = 356, .external_lex_state = 17},
  [4778] = {.lex_state = 202, .external_lex_state = 17},
  [4779] = {.lex_state = 202, .external_lex_state = 17},
  [4780] = {.lex_state = 202, .external_lex_state = 17},
  [4781] = {.lex_state = 187, .external_lex_state = 14},
  [4782] = {.lex_state = 202, .external_lex_state = 17},
  [4783] = {.lex_state = 202, .external_lex_state = 17},
  [4784] = {.lex_state = 202, .external_lex_state = 17},
  [4785] = {.lex_state = 202, .external_lex_state = 17},
  [4786] = {.lex_state = 138},
  [4787] = {.lex_state = 202, .external_lex_state = 17},
  [4788] = {.lex_state = 187, .external_lex_state = 16},
  [4789] = {.lex_state = 187, .external_lex_state = 16},
  [4790] = {.lex_state = 356, .external_lex_state = 14},
  [4791] = {.lex_state = 194, .external_lex_state = 6},
  [4792] = {.lex_state = 172, .external_lex_state = 14},
  [4793] = {.lex_state = 194, .external_lex_state = 5},
  [4794] = {.lex_state = 194, .external_lex_state = 5},
  [4795] = {.lex_state = 194, .external_lex_state = 5},
  [4796] = {.lex_state = 194, .external_lex_state = 5},
  [4797] = {.lex_state = 194, .external_lex_state = 5},
  [4798] = {.lex_state = 194, .external_lex_state = 5},
  [4799] = {.lex_state = 194, .external_lex_state = 5},
  [4800] = {.lex_state = 194, .external_lex_state = 5},
  [4801] = {.lex_state = 187, .external_lex_state = 16},
  [4802] = {.lex_state = 194, .external_lex_state = 5},
  [4803] = {.lex_state = 194, .external_lex_state = 5},
  [4804] = {.lex_state = 187, .external_lex_state = 16},
  [4805] = {.lex_state = 194, .external_lex_state = 5},
  [4806] = {.lex_state = 187, .external_lex_state = 16},
  [4807] = {.lex_state = 194, .external_lex_state = 5},
  [4808] = {.lex_state = 194, .external_lex_state = 5},
  [4809] = {.lex_state = 194, .external_lex_state = 5},
  [4810] = {.lex_state = 194, .external_lex_state = 5},
  [4811] = {.lex_state = 194, .external_lex_state = 5},
  [4812] = {.lex_state = 194, .external_lex_state = 5},
  [4813] = {.lex_state = 194, .external_lex_state = 5},
  [4814] = {.lex_state = 172, .external_lex_state = 14},
  [4815] = {.lex_state = 194, .external_lex_state = 5},
  [4816] = {.lex_state = 194, .external_lex_state = 5},
  [4817] = {.lex_state = 194, .external_lex_state = 5},
  [4818] = {.lex_state = 194, .external_lex_state = 5},
  [4819] = {.lex_state = 356, .external_lex_state = 18},
  [4820] = {.lex_state = 194, .external_lex_state = 5},
  [4821] = {.lex_state = 356, .external_lex_state = 18},
  [4822] = {.lex_state = 194, .external_lex_state = 5},
  [4823] = {.lex_state = 194, .external_lex_state = 5},
  [4824] = {.lex_state = 171, .external_lex_state = 14},
  [4825] = {.lex_state = 194, .external_lex_state = 5},
  [4826] = {.lex_state = 356, .external_lex_state = 18},
  [4827] = {.lex_state = 187, .external_lex_state = 16},
  [4828] = {.lex_state = 171, .external_lex_state = 14},
  [4829] = {.lex_state = 172, .external_lex_state = 14},
  [4830] = {.lex_state = 172, .external_lex_state = 14},
  [4831] = {.lex_state = 171, .external_lex_state = 14},
  [4832] = {.lex_state = 171, .external_lex_state = 14},
  [4833] = {.lex_state = 171, .external_lex_state = 14},
  [4834] = {.lex_state = 171},
  [4835] = {.lex_state = 194, .external_lex_state = 5},
  [4836] = {.lex_state = 171, .external_lex_state = 14},
  [4837] = {.lex_state = 171, .external_lex_state = 14},
  [4838] = {.lex_state = 194, .external_lex_state = 5},
  [4839] = {.lex_state = 194, .external_lex_state = 5},
  [4840] = {.lex_state = 356, .external_lex_state = 14},
  [4841] = {.lex_state = 172, .external_lex_state = 14},
  [4842] = {.lex_state = 172, .external_lex_state = 14},
  [4843] = {.lex_state = 172},
  [4844] = {.lex_state = 172, .external_lex_state = 14},
  [4845] = {.lex_state = 172, .external_lex_state = 14},
  [4846] = {.lex_state = 187, .external_lex_state = 16},
  [4847] = {.lex_state = 202, .external_lex_state = 18},
  [4848] = {.lex_state = 202, .external_lex_state = 18},
  [4849] = {.lex_state = 195},
  [4850] = {.lex_state = 202, .external_lex_state = 18},
  [4851] = {.lex_state = 172, .external_lex_state = 14},
  [4852] = {.lex_state = 187, .external_lex_state = 14},
  [4853] = {.lex_state = 187, .external_lex_state = 14},
  [4854] = {.lex_state = 187, .external_lex_state = 14},
  [4855] = {.lex_state = 187, .external_lex_state = 14},
  [4856] = {.lex_state = 194, .external_lex_state = 6},
  [4857] = {.lex_state = 187, .external_lex_state = 14},
  [4858] = {.lex_state = 194, .external_lex_state = 6},
  [4859] = {.lex_state = 187, .external_lex_state = 14},
  [4860] = {.lex_state = 187, .external_lex_state = 14},
  [4861] = {.lex_state = 194, .external_lex_state = 6},
  [4862] = {.lex_state = 187, .external_lex_state = 14},
  [4863] = {.lex_state = 187, .external_lex_state = 14},
  [4864] = {.lex_state = 194, .external_lex_state = 6},
  [4865] = {.lex_state = 187, .external_lex_state = 14},
  [4866] = {.lex_state = 187, .external_lex_state = 14},
  [4867] = {.lex_state = 187, .external_lex_state = 16},
  [4868] = {.lex_state = 194, .external_lex_state = 6},
  [4869] = {.lex_state = 172},
  [4870] = {.lex_state = 194, .external_lex_state = 6},
  [4871] = {.lex_state = 187, .external_lex_state = 16},
  [4872] = {.lex_state = 194, .external_lex_state = 6},
  [4873] = {.lex_state = 194, .external_lex_state = 6},
  [4874] = {.lex_state = 187, .external_lex_state = 16},
  [4875] = {.lex_state = 187, .external_lex_state = 16},
  [4876] = {.lex_state = 187, .external_lex_state = 16},
  [4877] = {.lex_state = 194, .external_lex_state = 5},
  [4878] = {.lex_state = 202, .external_lex_state = 18},
  [4879] = {.lex_state = 194, .external_lex_state = 6},
  [4880] = {.lex_state = 187, .external_lex_state = 16},
  [4881] = {.lex_state = 356, .external_lex_state = 14},
  [4882] = {.lex_state = 194, .external_lex_state = 5},
  [4883] = {.lex_state = 187, .external_lex_state = 16},
  [4884] = {.lex_state = 194, .external_lex_state = 5},
  [4885] = {.lex_state = 202, .external_lex_state = 18},
  [4886] = {.lex_state = 202, .external_lex_state = 18},
  [4887] = {.lex_state = 202, .external_lex_state = 18},
  [4888] = {.lex_state = 187, .external_lex_state = 16},
  [4889] = {.lex_state = 187, .external_lex_state = 16},
  [4890] = {.lex_state = 202, .external_lex_state = 18},
  [4891] = {.lex_state = 202, .external_lex_state = 18},
  [4892] = {.lex_state = 187, .external_lex_state = 16},
  [4893] = {.lex_state = 202, .external_lex_state = 18},
  [4894] = {.lex_state = 202, .external_lex_state = 18},
  [4895] = {.lex_state = 187, .external_lex_state = 16},
  [4896] = {.lex_state = 194, .external_lex_state = 5},
  [4897] = {.lex_state = 194, .external_lex_state = 5},
  [4898] = {.lex_state = 194, .external_lex_state = 5},
  [4899] = {.lex_state = 194, .external_lex_state = 5},
  [4900] = {.lex_state = 194, .external_lex_state = 6},
  [4901] = {.lex_state = 194, .external_lex_state = 6},
  [4902] = {.lex_state = 194, .external_lex_state = 6},
  [4903] = {.lex_state = 201},
  [4904] = {.lex_state = 195},
  [4905] = {.lex_state = 194, .external_lex_state = 6},
  [4906] = {.lex_state = 201},
  [4907] = {.lex_state = 194, .external_lex_state = 6},
  [4908] = {.lex_state = 172, .external_lex_state = 14},
  [4909] = {.lex_state = 194, .external_lex_state = 6},
  [4910] = {.lex_state = 201},
  [4911] = {.lex_state = 201},
  [4912] = {.lex_state = 194, .external_lex_state = 6},
  [4913] = {.lex_state = 195},
  [4914] = {.lex_state = 195},
  [4915] = {.lex_state = 201},
  [4916] = {.lex_state = 201},
  [4917] = {.lex_state = 201},
  [4918] = {.lex_state = 195},
  [4919] = {.lex_state = 195},
  [4920] = {.lex_state = 195},
  [4921] = {.lex_state = 194, .external_lex_state = 6},
  [4922] = {.lex_state = 172, .external_lex_state = 14},
  [4923] = {.lex_state = 194, .external_lex_state = 6},
  [4924] = {.lex_state = 195},
  [4925] = {.lex_state = 194, .external_lex_state = 6},
  [4926] = {.lex_state = 356, .external_lex_state = 16},
  [4927] = {.lex_state = 194, .external_lex_state = 6},
  [4928] = {.lex_state = 171},
  [4929] = {.lex_state = 201},
  [4930] = {.lex_state = 194, .external_lex_state = 6},
  [4931] = {.lex_state = 180},
  [4932] = {.lex_state = 194, .external_lex_state = 6},
  [4933] = {.lex_state = 194, .external_lex_state = 6},
  [4934] = {.lex_state = 194, .external_lex_state = 6},
  [4935] = {.lex_state = 194, .external_lex_state = 6},
  [4936] = {.lex_state = 194, .external_lex_state = 6},
  [4937] = {.lex_state = 194, .external_lex_state = 6},
  [4938] = {.lex_state = 194, .external_lex_state = 6},
  [4939] = {.lex_state = 194, .external_lex_state = 6},
  [4940] = {.lex_state = 172, .external_lex_state = 14},
  [4941] = {.lex_state = 171},
  [4942] = {.lex_state = 194, .external_lex_state = 6},
  [4943] = {.lex_state = 194, .external_lex_state = 6},
  [4944] = {.lex_state = 194, .external_lex_state = 6},
  [4945] = {.lex_state = 194, .external_lex_state = 6},
  [4946] = {.lex_state = 194, .external_lex_state = 6},
  [4947] = {.lex_state = 194, .external_lex_state = 6},
  [4948] = {.lex_state = 194, .external_lex_state = 6},
  [4949] = {.lex_state = 194, .external_lex_state = 6},
  [4950] = {.lex_state = 194, .external_lex_state = 6},
  [4951] = {.lex_state = 171, .external_lex_state = 14},
  [4952] = {.lex_state = 201},
  [4953] = {.lex_state = 194, .external_lex_state = 6},
  [4954] = {.lex_state = 356, .external_lex_state = 16},
  [4955] = {.lex_state = 194, .external_lex_state = 6},
  [4956] = {.lex_state = 194, .external_lex_state = 6},
  [4957] = {.lex_state = 194, .external_lex_state = 6},
  [4958] = {.lex_state = 194, .external_lex_state = 6},
  [4959] = {.lex_state = 171},
  [4960] = {.lex_state = 171, .external_lex_state = 14},
  [4961] = {.lex_state = 171, .external_lex_state = 14},
  [4962] = {.lex_state = 194, .external_lex_state = 6},
  [4963] = {.lex_state = 194, .external_lex_state = 6},
  [4964] = {.lex_state = 180},
  [4965] = {.lex_state = 171, .external_lex_state = 14},
  [4966] = {.lex_state = 172},
  [4967] = {.lex_state = 171, .external_lex_state = 14},
  [4968] = {.lex_state = 172},
  [4969] = {.lex_state = 172, .external_lex_state = 14},
  [4970] = {.lex_state = 356, .external_lex_state = 16},
  [4971] = {.lex_state = 172, .external_lex_state = 14},
  [4972] = {.lex_state = 194, .external_lex_state = 6},
  [4973] = {.lex_state = 172, .external_lex_state = 14},
  [4974] = {.lex_state = 180},
  [4975] = {.lex_state = 194, .external_lex_state = 6},
  [4976] = {.lex_state = 195},
  [4977] = {.lex_state = 172, .external_lex_state = 14},
  [4978] = {.lex_state = 356},
  [4979] = {.lex_state = 196},
  [4980] = {.lex_state = 172, .external_lex_state = 14},
  [4981] = {.lex_state = 171, .external_lex_state = 14},
  [4982] = {.lex_state = 171, .external_lex_state = 14},
  [4983] = {.lex_state = 172, .external_lex_state = 14},
  [4984] = {.lex_state = 195},
  [4985] = {.lex_state = 356},
  [4986] = {.lex_state = 195},
  [4987] = {.lex_state = 187, .external_lex_state = 16},
  [4988] = {.lex_state = 203},
  [4989] = {.lex_state = 171, .external_lex_state = 14},
  [4990] = {.lex_state = 171, .external_lex_state = 14},
  [4991] = {.lex_state = 171, .external_lex_state = 14},
  [4992] = {.lex_state = 172, .external_lex_state = 14},
  [4993] = {.lex_state = 196, .external_lex_state = 16},
  [4994] = {.lex_state = 203},
  [4995] = {.lex_state = 201},
  [4996] = {.lex_state = 356},
  [4997] = {.lex_state = 172, .external_lex_state = 14},
  [4998] = {.lex_state = 203},
  [4999] = {.lex_state = 201},
  [5000] = {.lex_state = 195},
  [5001] = {.lex_state = 196},
  [5002] = {.lex_state = 201},
  [5003] = {.lex_state = 195},
  [5004] = {.lex_state = 356},
  [5005] = {.lex_state = 356},
  [5006] = {.lex_state = 195},
  [5007] = {.lex_state = 195},
  [5008] = {.lex_state = 356},
  [5009] = {.lex_state = 356},
  [5010] = {.lex_state = 195},
  [5011] = {.lex_state = 201},
  [5012] = {.lex_state = 356},
  [5013] = {.lex_state = 201},
  [5014] = {.lex_state = 171},
  [5015] = {.lex_state = 201},
  [5016] = {.lex_state = 187, .external_lex_state = 16},
  [5017] = {.lex_state = 195},
  [5018] = {.lex_state = 201},
  [5019] = {.lex_state = 195},
  [5020] = {.lex_state = 198},
  [5021] = {.lex_state = 171, .external_lex_state = 14},
  [5022] = {.lex_state = 171, .external_lex_state = 14},
  [5023] = {.lex_state = 171, .external_lex_state = 14},
  [5024] = {.lex_state = 171, .external_lex_state = 14},
  [5025] = {.lex_state = 171, .external_lex_state = 14},
  [5026] = {.lex_state = 171, .external_lex_state = 14},
  [5027] = {.lex_state = 171, .external_lex_state = 14},
  [5028] = {.lex_state = 171, .external_lex_state = 14},
  [5029] = {.lex_state = 171, .external_lex_state = 14},
  [5030] = {.lex_state = 138},
  [5031] = {.lex_state = 203},
  [5032] = {.lex_state = 196},
  [5033] = {.lex_state = 171, .external_lex_state = 14},
  [5034] = {.lex_state = 171, .external_lex_state = 14},
  [5035] = {.lex_state = 203},
  [5036] = {.lex_state = 203},
  [5037] = {.lex_state = 195},
  [5038] = {.lex_state = 172, .external_lex_state = 14},
  [5039] = {.lex_state = 172, .external_lex_state = 14},
  [5040] = {.lex_state = 172, .external_lex_state = 14},
  [5041] = {.lex_state = 172, .external_lex_state = 14},
  [5042] = {.lex_state = 172, .external_lex_state = 14},
  [5043] = {.lex_state = 172, .external_lex_state = 14},
  [5044] = {.lex_state = 172, .external_lex_state = 14},
  [5045] = {.lex_state = 172, .external_lex_state = 14},
  [5046] = {.lex_state = 195},
  [5047] = {.lex_state = 172, .external_lex_state = 14},
  [5048] = {.lex_state = 202, .external_lex_state = 17},
  [5049] = {.lex_state = 196},
  [5050] = {.lex_state = 356, .external_lex_state = 16},
  [5051] = {.lex_state = 172, .external_lex_state = 14},
  [5052] = {.lex_state = 172, .external_lex_state = 14},
  [5053] = {.lex_state = 187, .external_lex_state = 16},
  [5054] = {.lex_state = 195},
  [5055] = {.lex_state = 195},
  [5056] = {.lex_state = 198},
  [5057] = {.lex_state = 195},
  [5058] = {.lex_state = 198},
  [5059] = {.lex_state = 138},
  [5060] = {.lex_state = 195},
  [5061] = {.lex_state = 356, .external_lex_state = 16},
  [5062] = {.lex_state = 201},
  [5063] = {.lex_state = 201},
  [5064] = {.lex_state = 196},
  [5065] = {.lex_state = 195},
  [5066] = {.lex_state = 138},
  [5067] = {.lex_state = 195},
  [5068] = {.lex_state = 195},
  [5069] = {.lex_state = 195},
  [5070] = {.lex_state = 201},
  [5071] = {.lex_state = 195},
  [5072] = {.lex_state = 201},
  [5073] = {.lex_state = 356, .external_lex_state = 16},
  [5074] = {.lex_state = 195},
  [5075] = {.lex_state = 195},
  [5076] = {.lex_state = 195},
  [5077] = {.lex_state = 356, .external_lex_state = 16},
  [5078] = {.lex_state = 201},
  [5079] = {.lex_state = 201},
  [5080] = {.lex_state = 201},
  [5081] = {.lex_state = 201},
  [5082] = {.lex_state = 201},
  [5083] = {.lex_state = 195},
  [5084] = {.lex_state = 195},
  [5085] = {.lex_state = 195},
  [5086] = {.lex_state = 195},
  [5087] = {.lex_state = 195},
  [5088] = {.lex_state = 201},
  [5089] = {.lex_state = 195},
  [5090] = {.lex_state = 201},
  [5091] = {.lex_state = 201},
  [5092] = {.lex_state = 201},
  [5093] = {.lex_state = 195},
  [5094] = {.lex_state = 201},
  [5095] = {.lex_state = 195},
  [5096] = {.lex_state = 201},
  [5097] = {.lex_state = 356, .external_lex_state = 16},
  [5098] = {.lex_state = 138},
  [5099] = {.lex_state = 195},
  [5100] = {.lex_state = 182, .external_lex_state = 16},
  [5101] = {.lex_state = 198},
  [5102] = {.lex_state = 356, .external_lex_state = 16},
  [5103] = {.lex_state = 356, .external_lex_state = 14},
  [5104] = {.lex_state = 138},
  [5105] = {.lex_state = 187},
  [5106] = {.lex_state = 202, .external_lex_state = 18},
  [5107] = {.lex_state = 356, .external_lex_state = 16},
  [5108] = {.lex_state = 196},
  [5109] = {.lex_state = 138},
  [5110] = {.lex_state = 187},
  [5111] = {.lex_state = 356, .external_lex_state = 16},
  [5112] = {.lex_state = 356, .external_lex_state = 16},
  [5113] = {.lex_state = 140, .external_lex_state = 19},
  [5114] = {.lex_state = 140, .external_lex_state = 19},
  [5115] = {.lex_state = 356, .external_lex_state = 17},
  [5116] = {.lex_state = 356, .external_lex_state = 17},
  [5117] = {.lex_state = 196},
  [5118] = {.lex_state = 196},
  [5119] = {.lex_state = 140, .external_lex_state = 19},
  [5120] = {.lex_state = 356, .external_lex_state = 17},
  [5121] = {.lex_state = 140, .external_lex_state = 19},
  [5122] = {.lex_state = 187},
  [5123] = {.lex_state = 140, .external_lex_state = 19},
  [5124] = {.lex_state = 140, .external_lex_state = 19},
  [5125] = {.lex_state = 196},
  [5126] = {.lex_state = 140, .external_lex_state = 19},
  [5127] = {.lex_state = 196},
  [5128] = {.lex_state = 140, .external_lex_state = 19},
  [5129] = {.lex_state = 140, .external_lex_state = 19},
  [5130] = {.lex_state = 138},
  [5131] = {.lex_state = 187},
  [5132] = {.lex_state = 140, .external_lex_state = 19},
  [5133] = {.lex_state = 196},
  [5134] = {.lex_state = 196},
  [5135] = {.lex_state = 196},
  [5136] = {.lex_state = 196},
  [5137] = {.lex_state = 140, .external_lex_state = 19},
  [5138] = {.lex_state = 187},
  [5139] = {.lex_state = 196},
  [5140] = {.lex_state = 196},
  [5141] = {.lex_state = 140, .external_lex_state = 19},
  [5142] = {.lex_state = 196},
  [5143] = {.lex_state = 196},
  [5144] = {.lex_state = 140, .external_lex_state = 19},
  [5145] = {.lex_state = 196},
  [5146] = {.lex_state = 196},
  [5147] = {.lex_state = 140, .external_lex_state = 19},
  [5148] = {.lex_state = 196},
  [5149] = {.lex_state = 196},
  [5150] = {.lex_state = 196},
  [5151] = {.lex_state = 356, .external_lex_state = 17},
  [5152] = {.lex_state = 140, .external_lex_state = 19},
  [5153] = {.lex_state = 196},
  [5154] = {.lex_state = 140, .external_lex_state = 19},
  [5155] = {.lex_state = 196},
  [5156] = {.lex_state = 140, .external_lex_state = 19},
  [5157] = {.lex_state = 196},
  [5158] = {.lex_state = 140, .external_lex_state = 19},
  [5159] = {.lex_state = 196},
  [5160] = {.lex_state = 138},
  [5161] = {.lex_state = 140, .external_lex_state = 19},
  [5162] = {.lex_state = 196},
  [5163] = {.lex_state = 140, .external_lex_state = 19},
  [5164] = {.lex_state = 196},
  [5165] = {.lex_state = 196},
  [5166] = {.lex_state = 140, .external_lex_state = 19},
  [5167] = {.lex_state = 140, .external_lex_state = 19},
  [5168] = {.lex_state = 196},
  [5169] = {.lex_state = 196},
  [5170] = {.lex_state = 196},
  [5171] = {.lex_state = 356, .external_lex_state = 17},
  [5172] = {.lex_state = 196},
  [5173] = {.lex_state = 140, .external_lex_state = 19},
  [5174] = {.lex_state = 196},
  [5175] = {.lex_state = 196},
  [5176] = {.lex_state = 196},
  [5177] = {.lex_state = 203},
  [5178] = {.lex_state = 203},
  [5179] = {.lex_state = 356, .external_lex_state = 16},
  [5180] = {.lex_state = 187},
  [5181] = {.lex_state = 140, .external_lex_state = 19},
  [5182] = {.lex_state = 140, .external_lex_state = 19},
  [5183] = {.lex_state = 196},
  [5184] = {.lex_state = 140, .external_lex_state = 19},
  [5185] = {.lex_state = 196},
  [5186] = {.lex_state = 187, .external_lex_state = 14},
  [5187] = {.lex_state = 140, .external_lex_state = 19},
  [5188] = {.lex_state = 356, .external_lex_state = 16},
  [5189] = {.lex_state = 196},
  [5190] = {.lex_state = 140, .external_lex_state = 19},
  [5191] = {.lex_state = 140, .external_lex_state = 19},
  [5192] = {.lex_state = 196},
  [5193] = {.lex_state = 196},
  [5194] = {.lex_state = 140, .external_lex_state = 19},
  [5195] = {.lex_state = 140, .external_lex_state = 19},
  [5196] = {.lex_state = 196},
  [5197] = {.lex_state = 140, .external_lex_state = 19},
  [5198] = {.lex_state = 140, .external_lex_state = 19},
  [5199] = {.lex_state = 140, .external_lex_state = 19},
  [5200] = {.lex_state = 196},
  [5201] = {.lex_state = 140, .external_lex_state = 19},
  [5202] = {.lex_state = 196},
  [5203] = {.lex_state = 196},
  [5204] = {.lex_state = 196},
  [5205] = {.lex_state = 203},
  [5206] = {.lex_state = 203},
  [5207] = {.lex_state = 196},
  [5208] = {.lex_state = 203},
  [5209] = {.lex_state = 356, .external_lex_state = 17},
  [5210] = {.lex_state = 356, .external_lex_state = 17},
  [5211] = {.lex_state = 140, .external_lex_state = 19},
  [5212] = {.lex_state = 187},
  [5213] = {.lex_state = 187},
  [5214] = {.lex_state = 140, .external_lex_state = 19},
  [5215] = {.lex_state = 140, .external_lex_state = 19},
  [5216] = {.lex_state = 196},
  [5217] = {.lex_state = 356, .external_lex_state = 17},
  [5218] = {.lex_state = 196},
  [5219] = {.lex_state = 187},
  [5220] = {.lex_state = 196},
  [5221] = {.lex_state = 140, .external_lex_state = 19},
  [5222] = {.lex_state = 140, .external_lex_state = 19},
  [5223] = {.lex_state = 140, .external_lex_state = 19},
  [5224] = {.lex_state = 140, .external_lex_state = 19},
  [5225] = {.lex_state = 138},
  [5226] = {.lex_state = 356, .external_lex_state = 17},
  [5227] = {.lex_state = 140, .external_lex_state = 19},
  [5228] = {.lex_state = 140, .external_lex_state = 19},
  [5229] = {.lex_state = 356, .external_lex_state = 16},
  [5230] = {.lex_state = 140, .external_lex_state = 19},
  [5231] = {.lex_state = 140, .external_lex_state = 19},
  [5232] = {.lex_state = 203},
  [5233] = {.lex_state = 140, .external_lex_state = 19},
  [5234] = {.lex_state = 356, .external_lex_state = 17},
  [5235] = {.lex_state = 196},
  [5236] = {.lex_state = 356, .external_lex_state = 17},
  [5237] = {.lex_state = 356, .external_lex_state = 14},
  [5238] = {.lex_state = 189, .external_lex_state = 19},
  [5239] = {.lex_state = 189, .external_lex_state = 19},
  [5240] = {.lex_state = 356, .external_lex_state = 17},
  [5241] = {.lex_state = 189, .external_lex_state = 19},
  [5242] = {.lex_state = 189, .external_lex_state = 19},
  [5243] = {.lex_state = 356, .external_lex_state = 17},
  [5244] = {.lex_state = 356, .external_lex_state = 14},
  [5245] = {.lex_state = 189, .external_lex_state = 19},
  [5246] = {.lex_state = 189, .external_lex_state = 19},
  [5247] = {.lex_state = 189, .external_lex_state = 19},
  [5248] = {.lex_state = 189, .external_lex_state = 19},
  [5249] = {.lex_state = 189, .external_lex_state = 19},
  [5250] = {.lex_state = 187},
  [5251] = {.lex_state = 356, .external_lex_state = 17},
  [5252] = {.lex_state = 356, .external_lex_state = 14},
  [5253] = {.lex_state = 189, .external_lex_state = 19},
  [5254] = {.lex_state = 189, .external_lex_state = 19},
  [5255] = {.lex_state = 198, .external_lex_state = 14},
  [5256] = {.lex_state = 189, .external_lex_state = 19},
  [5257] = {.lex_state = 189, .external_lex_state = 19},
  [5258] = {.lex_state = 356, .external_lex_state = 14},
  [5259] = {.lex_state = 189, .external_lex_state = 19},
  [5260] = {.lex_state = 198, .external_lex_state = 14},
  [5261] = {.lex_state = 196, .external_lex_state = 14},
  [5262] = {.lex_state = 189, .external_lex_state = 19},
  [5263] = {.lex_state = 189, .external_lex_state = 19},
  [5264] = {.lex_state = 189, .external_lex_state = 19},
  [5265] = {.lex_state = 356, .external_lex_state = 18},
  [5266] = {.lex_state = 189, .external_lex_state = 19},
  [5267] = {.lex_state = 189, .external_lex_state = 19},
  [5268] = {.lex_state = 189, .external_lex_state = 19},
  [5269] = {.lex_state = 189, .external_lex_state = 19},
  [5270] = {.lex_state = 189, .external_lex_state = 19},
  [5271] = {.lex_state = 189, .external_lex_state = 19},
  [5272] = {.lex_state = 196, .external_lex_state = 14},
  [5273] = {.lex_state = 356, .external_lex_state = 17},
  [5274] = {.lex_state = 356, .external_lex_state = 18},
  [5275] = {.lex_state = 189, .external_lex_state = 19},
  [5276] = {.lex_state = 356, .external_lex_state = 17},
  [5277] = {.lex_state = 356, .external_lex_state = 17},
  [5278] = {.lex_state = 356, .external_lex_state = 17},
  [5279] = {.lex_state = 189, .external_lex_state = 19},
  [5280] = {.lex_state = 356, .external_lex_state = 17},
  [5281] = {.lex_state = 189, .external_lex_state = 19},
  [5282] = {.lex_state = 189, .external_lex_state = 19},
  [5283] = {.lex_state = 189, .external_lex_state = 19},
  [5284] = {.lex_state = 189, .external_lex_state = 19},
  [5285] = {.lex_state = 356, .external_lex_state = 17},
  [5286] = {.lex_state = 356, .external_lex_state = 18},
  [5287] = {.lex_state = 189, .external_lex_state = 19},
  [5288] = {.lex_state = 356, .external_lex_state = 18},
  [5289] = {.lex_state = 189, .external_lex_state = 19},
  [5290] = {.lex_state = 187, .external_lex_state = 16},
  [5291] = {.lex_state = 356, .external_lex_state = 17},
  [5292] = {.lex_state = 189, .external_lex_state = 19},
  [5293] = {.lex_state = 189, .external_lex_state = 19},
  [5294] = {.lex_state = 356, .external_lex_state = 14},
  [5295] = {.lex_state = 356, .external_lex_state = 14},
  [5296] = {.lex_state = 189, .external_lex_state = 19},
  [5297] = {.lex_state = 198, .external_lex_state = 14},
  [5298] = {.lex_state = 189, .external_lex_state = 19},
  [5299] = {.lex_state = 356, .external_lex_state = 18},
  [5300] = {.lex_state = 356, .external_lex_state = 18},
  [5301] = {.lex_state = 189, .external_lex_state = 19},
  [5302] = {.lex_state = 189, .external_lex_state = 19},
  [5303] = {.lex_state = 356, .external_lex_state = 17},
  [5304] = {.lex_state = 187},
  [5305] = {.lex_state = 356, .external_lex_state = 14},
  [5306] = {.lex_state = 189, .external_lex_state = 19},
  [5307] = {.lex_state = 189, .external_lex_state = 19},
  [5308] = {.lex_state = 356, .external_lex_state = 14},
  [5309] = {.lex_state = 356, .external_lex_state = 18},
  [5310] = {.lex_state = 189, .external_lex_state = 19},
  [5311] = {.lex_state = 356, .external_lex_state = 17},
  [5312] = {.lex_state = 356, .external_lex_state = 18},
  [5313] = {.lex_state = 356, .external_lex_state = 17},
  [5314] = {.lex_state = 356, .external_lex_state = 17},
  [5315] = {.lex_state = 356, .external_lex_state = 17},
  [5316] = {.lex_state = 189, .external_lex_state = 19},
  [5317] = {.lex_state = 356, .external_lex_state = 17},
  [5318] = {.lex_state = 189, .external_lex_state = 19},
  [5319] = {.lex_state = 189, .external_lex_state = 19},
  [5320] = {.lex_state = 189, .external_lex_state = 19},
  [5321] = {.lex_state = 189, .external_lex_state = 19},
  [5322] = {.lex_state = 189, .external_lex_state = 19},
  [5323] = {.lex_state = 356, .external_lex_state = 18},
  [5324] = {.lex_state = 356, .external_lex_state = 14},
  [5325] = {.lex_state = 356, .external_lex_state = 16},
  [5326] = {.lex_state = 189, .external_lex_state = 19},
  [5327] = {.lex_state = 356, .external_lex_state = 18},
  [5328] = {.lex_state = 141, .external_lex_state = 19},
  [5329] = {.lex_state = 356, .external_lex_state = 14},
  [5330] = {.lex_state = 203},
  [5331] = {.lex_state = 356, .external_lex_state = 18},
  [5332] = {.lex_state = 356, .external_lex_state = 14},
  [5333] = {.lex_state = 356, .external_lex_state = 18},
  [5334] = {.lex_state = 356, .external_lex_state = 18},
  [5335] = {.lex_state = 172, .external_lex_state = 14},
  [5336] = {.lex_state = 356, .external_lex_state = 14},
  [5337] = {.lex_state = 356, .external_lex_state = 14},
  [5338] = {.lex_state = 356, .external_lex_state = 16},
  [5339] = {.lex_state = 172, .external_lex_state = 14},
  [5340] = {.lex_state = 171},
  [5341] = {.lex_state = 171},
  [5342] = {.lex_state = 356, .external_lex_state = 14},
  [5343] = {.lex_state = 196, .external_lex_state = 14},
  [5344] = {.lex_state = 171},
  [5345] = {.lex_state = 356, .external_lex_state = 18},
  [5346] = {.lex_state = 356, .external_lex_state = 14},
  [5347] = {.lex_state = 356, .external_lex_state = 18},
  [5348] = {.lex_state = 356, .external_lex_state = 18},
  [5349] = {.lex_state = 356, .external_lex_state = 18},
  [5350] = {.lex_state = 356, .external_lex_state = 18},
  [5351] = {.lex_state = 203},
  [5352] = {.lex_state = 356, .external_lex_state = 16},
  [5353] = {.lex_state = 203},
  [5354] = {.lex_state = 356, .external_lex_state = 18},
  [5355] = {.lex_state = 356, .external_lex_state = 14},
  [5356] = {.lex_state = 356, .external_lex_state = 18},
  [5357] = {.lex_state = 172},
  [5358] = {.lex_state = 356, .external_lex_state = 14},
  [5359] = {.lex_state = 356, .external_lex_state = 18},
  [5360] = {.lex_state = 356, .external_lex_state = 16},
  [5361] = {.lex_state = 356, .external_lex_state = 14},
  [5362] = {.lex_state = 356, .external_lex_state = 14},
  [5363] = {.lex_state = 356, .external_lex_state = 14},
  [5364] = {.lex_state = 356, .external_lex_state = 18},
  [5365] = {.lex_state = 356, .external_lex_state = 14},
  [5366] = {.lex_state = 356, .external_lex_state = 16},
  [5367] = {.lex_state = 172},
  [5368] = {.lex_state = 196, .external_lex_state = 14},
  [5369] = {.lex_state = 356, .external_lex_state = 16},
  [5370] = {.lex_state = 187},
  [5371] = {.lex_state = 356, .external_lex_state = 18},
  [5372] = {.lex_state = 196, .external_lex_state = 14},
  [5373] = {.lex_state = 196, .external_lex_state = 14},
  [5374] = {.lex_state = 172},
  [5375] = {.lex_state = 172, .external_lex_state = 14},
  [5376] = {.lex_state = 187},
  [5377] = {.lex_state = 356, .external_lex_state = 16},
  [5378] = {.lex_state = 187},
  [5379] = {.lex_state = 172},
  [5380] = {.lex_state = 356, .external_lex_state = 16},
  [5381] = {.lex_state = 356, .external_lex_state = 14},
  [5382] = {.lex_state = 203},
  [5383] = {.lex_state = 172, .external_lex_state = 14},
  [5384] = {.lex_state = 172},
  [5385] = {.lex_state = 356, .external_lex_state = 18},
  [5386] = {.lex_state = 356, .external_lex_state = 16},
  [5387] = {.lex_state = 356, .external_lex_state = 14},
  [5388] = {.lex_state = 356, .external_lex_state = 18},
  [5389] = {.lex_state = 198, .external_lex_state = 14},
  [5390] = {.lex_state = 356, .external_lex_state = 14},
  [5391] = {.lex_state = 187},
  [5392] = {.lex_state = 356, .external_lex_state = 18},
  [5393] = {.lex_state = 356, .external_lex_state = 14},
  [5394] = {.lex_state = 356, .external_lex_state = 18},
  [5395] = {.lex_state = 172},
  [5396] = {.lex_state = 356, .external_lex_state = 16},
  [5397] = {.lex_state = 172, .external_lex_state = 14},
  [5398] = {.lex_state = 196, .external_lex_state = 14},
  [5399] = {.lex_state = 172, .external_lex_state = 14},
  [5400] = {.lex_state = 141, .external_lex_state = 19},
  [5401] = {.lex_state = 356, .external_lex_state = 14},
  [5402] = {.lex_state = 141, .external_lex_state = 19},
  [5403] = {.lex_state = 187},
  [5404] = {.lex_state = 187},
  [5405] = {.lex_state = 196},
  [5406] = {.lex_state = 196, .external_lex_state = 14},
  [5407] = {.lex_state = 190, .external_lex_state = 19},
  [5408] = {.lex_state = 190, .external_lex_state = 19},
  [5409] = {.lex_state = 196, .external_lex_state = 14},
  [5410] = {.lex_state = 356},
  [5411] = {.lex_state = 356},
  [5412] = {.lex_state = 356, .external_lex_state = 16},
  [5413] = {.lex_state = 356, .external_lex_state = 16},
  [5414] = {.lex_state = 356, .external_lex_state = 16},
  [5415] = {.lex_state = 196},
  [5416] = {.lex_state = 196, .external_lex_state = 14},
  [5417] = {.lex_state = 187},
  [5418] = {.lex_state = 190, .external_lex_state = 19},
  [5419] = {.lex_state = 196, .external_lex_state = 14},
  [5420] = {.lex_state = 196, .external_lex_state = 14},
  [5421] = {.lex_state = 196},
  [5422] = {.lex_state = 356},
  [5423] = {.lex_state = 190, .external_lex_state = 19},
  [5424] = {.lex_state = 187},
  [5425] = {.lex_state = 187},
  [5426] = {.lex_state = 190, .external_lex_state = 19},
  [5427] = {.lex_state = 196, .external_lex_state = 14},
  [5428] = {.lex_state = 187},
  [5429] = {.lex_state = 190, .external_lex_state = 19},
  [5430] = {.lex_state = 356},
  [5431] = {.lex_state = 356, .external_lex_state = 16},
  [5432] = {.lex_state = 203},
  [5433] = {.lex_state = 172, .external_lex_state = 14},
  [5434] = {.lex_state = 196, .external_lex_state = 14},
  [5435] = {.lex_state = 356, .external_lex_state = 16},
  [5436] = {.lex_state = 187},
  [5437] = {.lex_state = 190, .external_lex_state = 19},
  [5438] = {.lex_state = 196, .external_lex_state = 14},
  [5439] = {.lex_state = 187},
  [5440] = {.lex_state = 172, .external_lex_state = 14},
  [5441] = {.lex_state = 187},
  [5442] = {.lex_state = 190, .external_lex_state = 19},
  [5443] = {.lex_state = 187},
  [5444] = {.lex_state = 196},
  [5445] = {.lex_state = 196},
  [5446] = {.lex_state = 196},
  [5447] = {.lex_state = 196},
  [5448] = {.lex_state = 196},
  [5449] = {.lex_state = 196},
  [5450] = {.lex_state = 356, .external_lex_state = 16},
  [5451] = {.lex_state = 196, .external_lex_state = 14},
  [5452] = {.lex_state = 196},
  [5453] = {.lex_state = 356, .external_lex_state = 16},
  [5454] = {.lex_state = 356, .external_lex_state = 16},
  [5455] = {.lex_state = 356},
  [5456] = {.lex_state = 187},
  [5457] = {.lex_state = 190, .external_lex_state = 19},
  [5458] = {.lex_state = 356, .external_lex_state = 16},
  [5459] = {.lex_state = 356, .external_lex_state = 16},
  [5460] = {.lex_state = 356, .external_lex_state = 16},
  [5461] = {.lex_state = 203},
  [5462] = {.lex_state = 196},
  [5463] = {.lex_state = 356},
  [5464] = {.lex_state = 187},
  [5465] = {.lex_state = 356, .external_lex_state = 16},
  [5466] = {.lex_state = 356, .external_lex_state = 16},
  [5467] = {.lex_state = 203},
  [5468] = {.lex_state = 196},
  [5469] = {.lex_state = 196},
  [5470] = {.lex_state = 356, .external_lex_state = 16},
  [5471] = {.lex_state = 356, .external_lex_state = 16},
  [5472] = {.lex_state = 190, .external_lex_state = 19},
  [5473] = {.lex_state = 356, .external_lex_state = 16},
  [5474] = {.lex_state = 203},
  [5475] = {.lex_state = 356},
  [5476] = {.lex_state = 356, .external_lex_state = 16},
  [5477] = {.lex_state = 187},
  [5478] = {.lex_state = 187},
  [5479] = {.lex_state = 196},
  [5480] = {.lex_state = 190, .external_lex_state = 19},
  [5481] = {.lex_state = 187},
  [5482] = {.lex_state = 196},
  [5483] = {.lex_state = 196},
  [5484] = {.lex_state = 187},
  [5485] = {.lex_state = 190, .external_lex_state = 19},
  [5486] = {.lex_state = 187},
  [5487] = {.lex_state = 187},
  [5488] = {.lex_state = 196},
  [5489] = {.lex_state = 190, .external_lex_state = 19},
  [5490] = {.lex_state = 356},
  [5491] = {.lex_state = 203},
  [5492] = {.lex_state = 187},
  [5493] = {.lex_state = 190, .external_lex_state = 19},
  [5494] = {.lex_state = 190, .external_lex_state = 19},
  [5495] = {.lex_state = 187},
  [5496] = {.lex_state = 190, .external_lex_state = 19},
  [5497] = {.lex_state = 187},
  [5498] = {.lex_state = 187},
  [5499] = {.lex_state = 190, .external_lex_state = 19},
  [5500] = {.lex_state = 190, .external_lex_state = 19},
  [5501] = {.lex_state = 187},
  [5502] = {.lex_state = 187},
  [5503] = {.lex_state = 187},
  [5504] = {.lex_state = 187},
  [5505] = {.lex_state = 196},
  [5506] = {.lex_state = 187},
  [5507] = {.lex_state = 187},
  [5508] = {.lex_state = 356},
  [5509] = {.lex_state = 196},
  [5510] = {.lex_state = 196},
  [5511] = {.lex_state = 190, .external_lex_state = 19},
  [5512] = {.lex_state = 196},
  [5513] = {.lex_state = 187},
  [5514] = {.lex_state = 187},
  [5515] = {.lex_state = 187},
  [5516] = {.lex_state = 190, .external_lex_state = 19},
  [5517] = {.lex_state = 196},
  [5518] = {.lex_state = 187, .external_lex_state = 14},
  [5519] = {.lex_state = 187},
  [5520] = {.lex_state = 196, .external_lex_state = 14},
  [5521] = {.lex_state = 196},
  [5522] = {.lex_state = 196},
  [5523] = {.lex_state = 196},
  [5524] = {.lex_state = 190, .external_lex_state = 19},
  [5525] = {.lex_state = 172, .external_lex_state = 14},
  [5526] = {.lex_state = 196, .external_lex_state = 14},
  [5527] = {.lex_state = 190, .external_lex_state = 19},
  [5528] = {.lex_state = 196},
  [5529] = {.lex_state = 196, .external_lex_state = 14},
  [5530] = {.lex_state = 187},
  [5531] = {.lex_state = 196, .external_lex_state = 14},
  [5532] = {.lex_state = 187},
  [5533] = {.lex_state = 172, .external_lex_state = 14},
  [5534] = {.lex_state = 187},
  [5535] = {.lex_state = 187, .external_lex_state = 14},
  [5536] = {.lex_state = 196, .external_lex_state = 14},
  [5537] = {.lex_state = 190, .external_lex_state = 19},
  [5538] = {.lex_state = 190, .external_lex_state = 19},
  [5539] = {.lex_state = 172, .external_lex_state = 14},
  [5540] = {.lex_state = 187},
  [5541] = {.lex_state = 201},
  [5542] = {.lex_state = 190, .external_lex_state = 19},
  [5543] = {.lex_state = 196},
  [5544] = {.lex_state = 196, .external_lex_state = 14},
  [5545] = {.lex_state = 196},
  [5546] = {.lex_state = 196, .external_lex_state = 14},
  [5547] = {.lex_state = 201},
  [5548] = {.lex_state = 187},
  [5549] = {.lex_state = 196},
  [5550] = {.lex_state = 196},
  [5551] = {.lex_state = 196},
  [5552] = {.lex_state = 187, .external_lex_state = 14},
  [5553] = {.lex_state = 196},
  [5554] = {.lex_state = 172, .external_lex_state = 14},
  [5555] = {.lex_state = 196},
  [5556] = {.lex_state = 187},
  [5557] = {.lex_state = 196},
  [5558] = {.lex_state = 187},
  [5559] = {.lex_state = 190, .external_lex_state = 19},
  [5560] = {.lex_state = 196},
  [5561] = {.lex_state = 196},
  [5562] = {.lex_state = 190, .external_lex_state = 19},
  [5563] = {.lex_state = 356},
  [5564] = {.lex_state = 196},
  [5565] = {.lex_state = 196},
  [5566] = {.lex_state = 196},
  [5567] = {.lex_state = 196},
  [5568] = {.lex_state = 187},
  [5569] = {.lex_state = 356},
  [5570] = {.lex_state = 172, .external_lex_state = 14},
  [5571] = {.lex_state = 187},
  [5572] = {.lex_state = 196},
  [5573] = {.lex_state = 187},
  [5574] = {.lex_state = 187},
  [5575] = {.lex_state = 196},
  [5576] = {.lex_state = 196},
  [5577] = {.lex_state = 203},
  [5578] = {.lex_state = 187},
  [5579] = {.lex_state = 190, .external_lex_state = 19},
  [5580] = {.lex_state = 190, .external_lex_state = 19},
  [5581] = {.lex_state = 196},
  [5582] = {.lex_state = 196},
  [5583] = {.lex_state = 196},
  [5584] = {.lex_state = 190, .external_lex_state = 19},
  [5585] = {.lex_state = 190, .external_lex_state = 19},
  [5586] = {.lex_state = 356, .external_lex_state = 16},
  [5587] = {.lex_state = 196},
  [5588] = {.lex_state = 196},
  [5589] = {.lex_state = 190, .external_lex_state = 19},
  [5590] = {.lex_state = 190, .external_lex_state = 19},
  [5591] = {.lex_state = 190, .external_lex_state = 19},
  [5592] = {.lex_state = 356},
  [5593] = {.lex_state = 187},
  [5594] = {.lex_state = 187},
  [5595] = {.lex_state = 190, .external_lex_state = 19},
  [5596] = {.lex_state = 201},
  [5597] = {.lex_state = 187, .external_lex_state = 14},
  [5598] = {.lex_state = 187},
  [5599] = {.lex_state = 203},
  [5600] = {.lex_state = 190, .external_lex_state = 19},
  [5601] = {.lex_state = 203},
  [5602] = {.lex_state = 172, .external_lex_state = 14},
  [5603] = {.lex_state = 190, .external_lex_state = 19},
  [5604] = {.lex_state = 172, .external_lex_state = 14},
  [5605] = {.lex_state = 190, .external_lex_state = 19},
  [5606] = {.lex_state = 187},
  [5607] = {.lex_state = 196},
  [5608] = {.lex_state = 190, .external_lex_state = 19},
  [5609] = {.lex_state = 190, .external_lex_state = 19},
  [5610] = {.lex_state = 190, .external_lex_state = 19},
  [5611] = {.lex_state = 196},
  [5612] = {.lex_state = 196},
  [5613] = {.lex_state = 190, .external_lex_state = 19},
  [5614] = {.lex_state = 190, .external_lex_state = 19},
  [5615] = {.lex_state = 190, .external_lex_state = 19},
  [5616] = {.lex_state = 356, .external_lex_state = 16},
  [5617] = {.lex_state = 190, .external_lex_state = 19},
  [5618] = {.lex_state = 187},
  [5619] = {.lex_state = 190, .external_lex_state = 19},
  [5620] = {.lex_state = 190, .external_lex_state = 19},
  [5621] = {.lex_state = 187},
  [5622] = {.lex_state = 196, .external_lex_state = 14},
  [5623] = {.lex_state = 140, .external_lex_state = 19},
  [5624] = {.lex_state = 189, .external_lex_state = 19},
  [5625] = {.lex_state = 187},
  [5626] = {.lex_state = 187},
  [5627] = {.lex_state = 187},
  [5628] = {.lex_state = 187},
  [5629] = {.lex_state = 187},
  [5630] = {.lex_state = 196},
  [5631] = {.lex_state = 196},
  [5632] = {.lex_state = 187},
  [5633] = {.lex_state = 196, .external_lex_state = 14},
  [5634] = {.lex_state = 187},
  [5635] = {.lex_state = 196},
  [5636] = {.lex_state = 196},
  [5637] = {.lex_state = 196},
  [5638] = {.lex_state = 196},
  [5639] = {.lex_state = 187},
  [5640] = {.lex_state = 196},
  [5641] = {.lex_state = 196, .external_lex_state = 14},
  [5642] = {.lex_state = 196},
  [5643] = {.lex_state = 196},
  [5644] = {.lex_state = 187},
  [5645] = {.lex_state = 140, .external_lex_state = 19},
  [5646] = {.lex_state = 140, .external_lex_state = 19},
  [5647] = {.lex_state = 196},
  [5648] = {.lex_state = 196},
  [5649] = {.lex_state = 187},
  [5650] = {.lex_state = 140, .external_lex_state = 19},
  [5651] = {.lex_state = 196},
  [5652] = {.lex_state = 196, .external_lex_state = 14},
  [5653] = {.lex_state = 187},
  [5654] = {.lex_state = 187},
  [5655] = {.lex_state = 203},
  [5656] = {.lex_state = 196, .external_lex_state = 14},
  [5657] = {.lex_state = 187},
  [5658] = {.lex_state = 196, .external_lex_state = 14},
  [5659] = {.lex_state = 196, .external_lex_state = 14},
  [5660] = {.lex_state = 196, .external_lex_state = 14},
  [5661] = {.lex_state = 196, .external_lex_state = 14},
  [5662] = {.lex_state = 196},
  [5663] = {.lex_state = 187},
  [5664] = {.lex_state = 187},
  [5665] = {.lex_state = 187},
  [5666] = {.lex_state = 192, .external_lex_state = 19},
  [5667] = {.lex_state = 196},
  [5668] = {.lex_state = 187},
  [5669] = {.lex_state = 187},
  [5670] = {.lex_state = 187},
  [5671] = {.lex_state = 187},
  [5672] = {.lex_state = 196, .external_lex_state = 14},
  [5673] = {.lex_state = 196, .external_lex_state = 14},
  [5674] = {.lex_state = 187},
  [5675] = {.lex_state = 196},
  [5676] = {.lex_state = 187, .external_lex_state = 16},
  [5677] = {.lex_state = 196},
  [5678] = {.lex_state = 187},
  [5679] = {.lex_state = 187},
  [5680] = {.lex_state = 203},
  [5681] = {.lex_state = 187},
  [5682] = {.lex_state = 196, .external_lex_state = 14},
  [5683] = {.lex_state = 196, .external_lex_state = 14},
  [5684] = {.lex_state = 196},
  [5685] = {.lex_state = 196},
  [5686] = {.lex_state = 187},
  [5687] = {.lex_state = 196, .external_lex_state = 14},
  [5688] = {.lex_state = 187, .external_lex_state = 16},
  [5689] = {.lex_state = 187},
  [5690] = {.lex_state = 196},
  [5691] = {.lex_state = 187},
  [5692] = {.lex_state = 196, .external_lex_state = 14},
  [5693] = {.lex_state = 196, .external_lex_state = 14},
  [5694] = {.lex_state = 196},
  [5695] = {.lex_state = 196, .external_lex_state = 14},
  [5696] = {.lex_state = 196},
  [5697] = {.lex_state = 187},
  [5698] = {.lex_state = 196, .external_lex_state = 14},
  [5699] = {.lex_state = 187},
  [5700] = {.lex_state = 196, .external_lex_state = 14},
  [5701] = {.lex_state = 187},
  [5702] = {.lex_state = 187},
  [5703] = {.lex_state = 187},
  [5704] = {.lex_state = 187},
  [5705] = {.lex_state = 187},
  [5706] = {.lex_state = 187},
  [5707] = {.lex_state = 192, .external_lex_state = 19},
  [5708] = {.lex_state = 196},
  [5709] = {.lex_state = 187},
  [5710] = {.lex_state = 189, .external_lex_state = 19},
  [5711] = {.lex_state = 187},
  [5712] = {.lex_state = 187, .external_lex_state = 16},
  [5713] = {.lex_state = 189, .external_lex_state = 19},
  [5714] = {.lex_state = 187},
  [5715] = {.lex_state = 196, .external_lex_state = 14},
  [5716] = {.lex_state = 187},
  [5717] = {.lex_state = 196, .external_lex_state = 14},
  [5718] = {.lex_state = 196},
  [5719] = {.lex_state = 187},
  [5720] = {.lex_state = 196},
  [5721] = {.lex_state = 196},
  [5722] = {.lex_state = 196},
  [5723] = {.lex_state = 196},
  [5724] = {.lex_state = 196},
  [5725] = {.lex_state = 196},
  [5726] = {.lex_state = 187},
  [5727] = {.lex_state = 196, .external_lex_state = 14},
  [5728] = {.lex_state = 196},
  [5729] = {.lex_state = 196},
  [5730] = {.lex_state = 187, .external_lex_state = 16},
  [5731] = {.lex_state = 196, .external_lex_state = 14},
  [5732] = {.lex_state = 187, .external_lex_state = 16},
  [5733] = {.lex_state = 187},
  [5734] = {.lex_state = 187},
  [5735] = {.lex_state = 196, .external_lex_state = 14},
  [5736] = {.lex_state = 196, .external_lex_state = 14},
  [5737] = {.lex_state = 196, .external_lex_state = 14},
  [5738] = {.lex_state = 187},
  [5739] = {.lex_state = 187},
  [5740] = {.lex_state = 192, .external_lex_state = 19},
  [5741] = {.lex_state = 187},
  [5742] = {.lex_state = 196, .external_lex_state = 14},
  [5743] = {.lex_state = 187},
  [5744] = {.lex_state = 196, .external_lex_state = 14},
  [5745] = {.lex_state = 196},
  [5746] = {.lex_state = 196},
  [5747] = {.lex_state = 187},
  [5748] = {.lex_state = 356},
  [5749] = {.lex_state = 187},
  [5750] = {.lex_state = 187},
  [5751] = {.lex_state = 196, .external_lex_state = 14},
  [5752] = {.lex_state = 187},
  [5753] = {.lex_state = 196, .external_lex_state = 14},
  [5754] = {.lex_state = 196},
  [5755] = {.lex_state = 196},
  [5756] = {.lex_state = 203},
  [5757] = {.lex_state = 196, .external_lex_state = 14},
  [5758] = {.lex_state = 187},
  [5759] = {.lex_state = 196, .external_lex_state = 14},
  [5760] = {.lex_state = 187},
  [5761] = {.lex_state = 196},
  [5762] = {.lex_state = 187},
  [5763] = {.lex_state = 196, .external_lex_state = 14},
  [5764] = {.lex_state = 187},
  [5765] = {.lex_state = 187},
  [5766] = {.lex_state = 187},
  [5767] = {.lex_state = 196},
  [5768] = {.lex_state = 196, .external_lex_state = 14},
  [5769] = {.lex_state = 196},
  [5770] = {.lex_state = 196},
  [5771] = {.lex_state = 187},
  [5772] = {.lex_state = 196},
  [5773] = {.lex_state = 196},
  [5774] = {.lex_state = 196, .external_lex_state = 14},
  [5775] = {.lex_state = 196, .external_lex_state = 14},
  [5776] = {.lex_state = 196},
  [5777] = {.lex_state = 187},
  [5778] = {.lex_state = 196, .external_lex_state = 14},
  [5779] = {.lex_state = 187},
  [5780] = {.lex_state = 196},
  [5781] = {.lex_state = 196},
  [5782] = {.lex_state = 196},
  [5783] = {.lex_state = 187},
  [5784] = {.lex_state = 196, .external_lex_state = 14},
  [5785] = {.lex_state = 196, .external_lex_state = 14},
  [5786] = {.lex_state = 196},
  [5787] = {.lex_state = 203},
  [5788] = {.lex_state = 196},
  [5789] = {.lex_state = 196, .external_lex_state = 14},
  [5790] = {.lex_state = 187},
  [5791] = {.lex_state = 196, .external_lex_state = 14},
  [5792] = {.lex_state = 187},
  [5793] = {.lex_state = 196},
  [5794] = {.lex_state = 187},
  [5795] = {.lex_state = 196},
  [5796] = {.lex_state = 196},
  [5797] = {.lex_state = 187},
  [5798] = {.lex_state = 196, .external_lex_state = 14},
  [5799] = {.lex_state = 196},
  [5800] = {.lex_state = 196},
  [5801] = {.lex_state = 196},
  [5802] = {.lex_state = 187},
  [5803] = {.lex_state = 196},
  [5804] = {.lex_state = 196},
  [5805] = {.lex_state = 196},
  [5806] = {.lex_state = 196, .external_lex_state = 14},
  [5807] = {.lex_state = 196},
  [5808] = {.lex_state = 196, .external_lex_state = 14},
  [5809] = {.lex_state = 196},
  [5810] = {.lex_state = 196, .external_lex_state = 14},
  [5811] = {.lex_state = 196},
  [5812] = {.lex_state = 187},
  [5813] = {.lex_state = 196},
  [5814] = {.lex_state = 196, .external_lex_state = 14},
  [5815] = {.lex_state = 203},
  [5816] = {.lex_state = 203},
  [5817] = {.lex_state = 196},
  [5818] = {.lex_state = 196},
  [5819] = {.lex_state = 187},
  [5820] = {.lex_state = 196},
  [5821] = {.lex_state = 196},
  [5822] = {.lex_state = 203},
  [5823] = {.lex_state = 196},
  [5824] = {.lex_state = 196},
  [5825] = {.lex_state = 196},
  [5826] = {.lex_state = 196},
  [5827] = {.lex_state = 196},
  [5828] = {.lex_state = 196},
  [5829] = {.lex_state = 196},
  [5830] = {.lex_state = 196},
  [5831] = {.lex_state = 196},
  [5832] = {.lex_state = 196},
  [5833] = {.lex_state = 196},
  [5834] = {.lex_state = 196},
  [5835] = {.lex_state = 196},
  [5836] = {.lex_state = 196},
  [5837] = {.lex_state = 196},
  [5838] = {.lex_state = 196},
  [5839] = {.lex_state = 196},
  [5840] = {.lex_state = 187},
  [5841] = {.lex_state = 196},
  [5842] = {.lex_state = 196},
  [5843] = {.lex_state = 196},
  [5844] = {.lex_state = 196},
  [5845] = {.lex_state = 196},
  [5846] = {.lex_state = 196},
  [5847] = {.lex_state = 196},
  [5848] = {.lex_state = 196},
  [5849] = {.lex_state = 196},
  [5850] = {.lex_state = 356, .external_lex_state = 17},
  [5851] = {.lex_state = 356, .external_lex_state = 17},
  [5852] = {.lex_state = 141, .external_lex_state = 19},
  [5853] = {.lex_state = 196},
  [5854] = {.lex_state = 196},
  [5855] = {.lex_state = 196},
  [5856] = {.lex_state = 187},
  [5857] = {.lex_state = 356, .external_lex_state = 17},
  [5858] = {.lex_state = 356, .external_lex_state = 17},
  [5859] = {.lex_state = 196},
  [5860] = {.lex_state = 196},
  [5861] = {.lex_state = 196},
  [5862] = {.lex_state = 196},
  [5863] = {.lex_state = 196},
  [5864] = {.lex_state = 196},
  [5865] = {.lex_state = 196},
  [5866] = {.lex_state = 203},
  [5867] = {.lex_state = 196},
  [5868] = {.lex_state = 196},
  [5869] = {.lex_state = 196},
  [5870] = {.lex_state = 141, .external_lex_state = 19},
  [5871] = {.lex_state = 196},
  [5872] = {.lex_state = 196},
  [5873] = {.lex_state = 187},
  [5874] = {.lex_state = 196},
  [5875] = {.lex_state = 196},
  [5876] = {.lex_state = 196},
  [5877] = {.lex_state = 141, .external_lex_state = 19},
  [5878] = {.lex_state = 196},
  [5879] = {.lex_state = 196},
  [5880] = {.lex_state = 196},
  [5881] = {.lex_state = 356, .external_lex_state = 17},
  [5882] = {.lex_state = 196},
  [5883] = {.lex_state = 138},
  [5884] = {.lex_state = 187},
  [5885] = {.lex_state = 356},
  [5886] = {.lex_state = 187},
  [5887] = {.lex_state = 356},
  [5888] = {.lex_state = 187},
  [5889] = {.lex_state = 187},
  [5890] = {.lex_state = 356},
  [5891] = {.lex_state = 356, .external_lex_state = 18},
  [5892] = {.lex_state = 356},
  [5893] = {.lex_state = 356},
  [5894] = {.lex_state = 187},
  [5895] = {.lex_state = 187},
  [5896] = {.lex_state = 356, .external_lex_state = 18},
  [5897] = {.lex_state = 356},
  [5898] = {.lex_state = 138},
  [5899] = {.lex_state = 356, .external_lex_state = 18},
  [5900] = {.lex_state = 187},
  [5901] = {.lex_state = 138},
  [5902] = {.lex_state = 187},
  [5903] = {.lex_state = 187},
  [5904] = {.lex_state = 356, .external_lex_state = 18},
  [5905] = {.lex_state = 190, .external_lex_state = 19},
  [5906] = {.lex_state = 356, .external_lex_state = 18},
  [5907] = {.lex_state = 356},
  [5908] = {.lex_state = 187},
  [5909] = {.lex_state = 138},
  [5910] = {.lex_state = 187},
  [5911] = {.lex_state = 187},
  [5912] = {.lex_state = 187},
  [5913] = {.lex_state = 187},
  [5914] = {.lex_state = 187},
  [5915] = {.lex_state = 187},
  [5916] = {.lex_state = 356},
  [5917] = {.lex_state = 356, .external_lex_state = 17},
  [5918] = {.lex_state = 356},
  [5919] = {.lex_state = 187},
  [5920] = {.lex_state = 190, .external_lex_state = 19},
  [5921] = {.lex_state = 356},
  [5922] = {.lex_state = 187},
  [5923] = {.lex_state = 356},
  [5924] = {.lex_state = 356},
  [5925] = {.lex_state = 138},
  [5926] = {.lex_state = 356},
  [5927] = {.lex_state = 356},
  [5928] = {.lex_state = 356},
  [5929] = {.lex_state = 187},
  [5930] = {.lex_state = 190, .external_lex_state = 19},
  [5931] = {.lex_state = 356, .external_lex_state = 17},
  [5932] = {.lex_state = 356},
  [5933] = {.lex_state = 356},
  [5934] = {.lex_state = 203},
  [5935] = {.lex_state = 138},
  [5936] = {.lex_state = 356},
  [5937] = {.lex_state = 356},
  [5938] = {.lex_state = 192, .external_lex_state = 19},
  [5939] = {.lex_state = 138},
  [5940] = {.lex_state = 192, .external_lex_state = 19},
  [5941] = {.lex_state = 192, .external_lex_state = 19},
  [5942] = {.lex_state = 356},
  [5943] = {.lex_state = 356, .external_lex_state = 18},
  [5944] = {.lex_state = 356},
  [5945] = {.lex_state = 356},
  [5946] = {.lex_state = 356},
  [5947] = {.lex_state = 356},
  [5948] = {.lex_state = 356},
  [5949] = {.lex_state = 356},
  [5950] = {.lex_state = 356},
  [5951] = {.lex_state = 356, .external_lex_state = 18},
  [5952] = {.lex_state = 356},
  [5953] = {.lex_state = 356},
  [5954] = {.lex_state = 138},
  [5955] = {.lex_state = 356},
  [5956] = {.lex_state = 356},
  [5957] = {.lex_state = 356},
  [5958] = {.lex_state = 138},
  [5959] = {.lex_state = 356},
  [5960] = {.lex_state = 356},
  [5961] = {.lex_state = 356},
  [5962] = {.lex_state = 356},
  [5963] = {.lex_state = 138},
  [5964] = {.lex_state = 356},
  [5965] = {.lex_state = 356},
  [5966] = {.lex_state = 138},
  [5967] = {.lex_state = 203},
  [5968] = {.lex_state = 356},
  [5969] = {.lex_state = 356},
  [5970] = {.lex_state = 196},
  [5971] = {.lex_state = 196},
  [5972] = {.lex_state = 196},
  [5973] = {.lex_state = 356},
  [5974] = {.lex_state = 356},
  [5975] = {.lex_state = 196},
  [5976] = {.lex_state = 196},
  [5977] = {.lex_state = 196},
  [5978] = {.lex_state = 356},
  [5979] = {.lex_state = 356},
  [5980] = {.lex_state = 356},
  [5981] = {.lex_state = 356},
  [5982] = {.lex_state = 196, .external_lex_state = 16},
  [5983] = {.lex_state = 187},
  [5984] = {.lex_state = 196},
  [5985] = {.lex_state = 196, .external_lex_state = 16},
  [5986] = {.lex_state = 356},
  [5987] = {.lex_state = 196},
  [5988] = {.lex_state = 196},
  [5989] = {.lex_state = 196},
  [5990] = {.lex_state = 356},
  [5991] = {.lex_state = 196},
  [5992] = {.lex_state = 356},
  [5993] = {.lex_state = 356},
  [5994] = {.lex_state = 196},
  [5995] = {.lex_state = 356},
  [5996] = {.lex_state = 196},
  [5997] = {.lex_state = 356},
  [5998] = {.lex_state = 196},
  [5999] = {.lex_state = 356, .external_lex_state = 14},
  [6000] = {.lex_state = 356},
  [6001] = {.lex_state = 356},
  [6002] = {.lex_state = 356},
  [6003] = {.lex_state = 356},
  [6004] = {.lex_state = 356},
  [6005] = {.lex_state = 356},
  [6006] = {.lex_state = 196},
  [6007] = {.lex_state = 196},
  [6008] = {.lex_state = 187},
  [6009] = {.lex_state = 196},
  [6010] = {.lex_state = 196},
  [6011] = {.lex_state = 196},
  [6012] = {.lex_state = 356},
  [6013] = {.lex_state = 356},
  [6014] = {.lex_state = 356},
  [6015] = {.lex_state = 196},
  [6016] = {.lex_state = 196},
  [6017] = {.lex_state = 356},
  [6018] = {.lex_state = 356},
  [6019] = {.lex_state = 196},
  [6020] = {.lex_state = 196},
  [6021] = {.lex_state = 196},
  [6022] = {.lex_state = 196},
  [6023] = {.lex_state = 356, .external_lex_state = 14},
  [6024] = {.lex_state = 356},
  [6025] = {.lex_state = 356},
  [6026] = {.lex_state = 356},
  [6027] = {.lex_state = 356},
  [6028] = {.lex_state = 356},
  [6029] = {.lex_state = 356},
  [6030] = {.lex_state = 196},
  [6031] = {.lex_state = 356},
  [6032] = {.lex_state = 356},
  [6033] = {.lex_state = 356, .external_lex_state = 17},
  [6034] = {.lex_state = 187},
  [6035] = {.lex_state = 356},
  [6036] = {.lex_state = 196},
  [6037] = {.lex_state = 356},
  [6038] = {.lex_state = 196},
  [6039] = {.lex_state = 196},
  [6040] = {.lex_state = 196},
  [6041] = {.lex_state = 356, .external_lex_state = 17},
  [6042] = {.lex_state = 196},
  [6043] = {.lex_state = 196},
  [6044] = {.lex_state = 356},
  [6045] = {.lex_state = 356},
  [6046] = {.lex_state = 196},
  [6047] = {.lex_state = 356},
  [6048] = {.lex_state = 356},
  [6049] = {.lex_state = 356},
  [6050] = {.lex_state = 196},
  [6051] = {.lex_state = 356},
  [6052] = {.lex_state = 356},
  [6053] = {.lex_state = 196},
  [6054] = {.lex_state = 196},
  [6055] = {.lex_state = 196},
  [6056] = {.lex_state = 1},
  [6057] = {.lex_state = 356},
  [6058] = {.lex_state = 187},
  [6059] = {.lex_state = 196},
  [6060] = {.lex_state = 356},
  [6061] = {.lex_state = 356},
  [6062] = {.lex_state = 196},
  [6063] = {.lex_state = 356},
  [6064] = {.lex_state = 187},
  [6065] = {.lex_state = 196},
  [6066] = {.lex_state = 196},
  [6067] = {.lex_state = 356},
  [6068] = {.lex_state = 196},
  [6069] = {.lex_state = 196},
  [6070] = {.lex_state = 356},
  [6071] = {.lex_state = 196},
  [6072] = {.lex_state = 196},
  [6073] = {.lex_state = 356},
  [6074] = {.lex_state = 356},
  [6075] = {.lex_state = 356},
  [6076] = {.lex_state = 356},
  [6077] = {.lex_state = 356},
  [6078] = {.lex_state = 356},
  [6079] = {.lex_state = 356},
  [6080] = {.lex_state = 356},
  [6081] = {.lex_state = 356},
  [6082] = {.lex_state = 356},
  [6083] = {.lex_state = 196},
  [6084] = {.lex_state = 196},
  [6085] = {.lex_state = 196},
  [6086] = {.lex_state = 356},
  [6087] = {.lex_state = 187},
  [6088] = {.lex_state = 356},
  [6089] = {.lex_state = 356},
  [6090] = {.lex_state = 196},
  [6091] = {.lex_state = 356},
  [6092] = {.lex_state = 196},
  [6093] = {.lex_state = 196},
  [6094] = {.lex_state = 187},
  [6095] = {.lex_state = 356},
  [6096] = {.lex_state = 196},
  [6097] = {.lex_state = 196},
  [6098] = {.lex_state = 196},
  [6099] = {.lex_state = 356},
  [6100] = {.lex_state = 196},
  [6101] = {.lex_state = 187},
  [6102] = {.lex_state = 196},
  [6103] = {.lex_state = 196},
  [6104] = {.lex_state = 356},
  [6105] = {.lex_state = 187},
  [6106] = {.lex_state = 196},
  [6107] = {.lex_state = 356},
  [6108] = {.lex_state = 187},
  [6109] = {.lex_state = 196},
  [6110] = {.lex_state = 196},
  [6111] = {.lex_state = 196},
  [6112] = {.lex_state = 356},
  [6113] = {.lex_state = 196},
  [6114] = {.lex_state = 356, .external_lex_state = 17},
  [6115] = {.lex_state = 196},
  [6116] = {.lex_state = 196},
  [6117] = {.lex_state = 196},
  [6118] = {.lex_state = 356},
  [6119] = {.lex_state = 196},
  [6120] = {.lex_state = 196},
  [6121] = {.lex_state = 196},
  [6122] = {.lex_state = 356},
  [6123] = {.lex_state = 187},
  [6124] = {.lex_state = 196},
  [6125] = {.lex_state = 196},
  [6126] = {.lex_state = 356},
  [6127] = {.lex_state = 356, .external_lex_state = 16},
  [6128] = {.lex_state = 356, .external_lex_state = 17},
  [6129] = {.lex_state = 356, .external_lex_state = 17},
  [6130] = {.lex_state = 356},
  [6131] = {.lex_state = 356, .external_lex_state = 17},
  [6132] = {.lex_state = 356},
  [6133] = {.lex_state = 356, .external_lex_state = 17},
  [6134] = {.lex_state = 356, .external_lex_state = 17},
  [6135] = {.lex_state = 356},
  [6136] = {.lex_state = 356},
  [6137] = {.lex_state = 353, .external_lex_state = 14},
  [6138] = {.lex_state = 356},
  [6139] = {.lex_state = 356, .external_lex_state = 17},
  [6140] = {.lex_state = 356, .external_lex_state = 17},
  [6141] = {.lex_state = 356},
  [6142] = {.lex_state = 356},
  [6143] = {.lex_state = 356},
  [6144] = {.lex_state = 196},
  [6145] = {.lex_state = 356},
  [6146] = {.lex_state = 356},
  [6147] = {.lex_state = 356},
  [6148] = {.lex_state = 356},
  [6149] = {.lex_state = 356, .external_lex_state = 17},
  [6150] = {.lex_state = 356, .external_lex_state = 18},
  [6151] = {.lex_state = 356},
  [6152] = {.lex_state = 356},
  [6153] = {.lex_state = 356},
  [6154] = {.lex_state = 356, .external_lex_state = 14},
  [6155] = {.lex_state = 356},
  [6156] = {.lex_state = 356, .external_lex_state = 17},
  [6157] = {.lex_state = 356},
  [6158] = {.lex_state = 356},
  [6159] = {.lex_state = 356, .external_lex_state = 14},
  [6160] = {.lex_state = 356, .external_lex_state = 17},
  [6161] = {.lex_state = 356},
  [6162] = {.lex_state = 356, .external_lex_state = 18},
  [6163] = {.lex_state = 356, .external_lex_state = 14},
  [6164] = {.lex_state = 356},
  [6165] = {.lex_state = 356},
  [6166] = {.lex_state = 356, .external_lex_state = 17},
  [6167] = {.lex_state = 356},
  [6168] = {.lex_state = 356},
  [6169] = {.lex_state = 353, .external_lex_state = 14},
  [6170] = {.lex_state = 356},
  [6171] = {.lex_state = 353, .external_lex_state = 14},
  [6172] = {.lex_state = 353, .external_lex_state = 14},
  [6173] = {.lex_state = 356},
  [6174] = {.lex_state = 353, .external_lex_state = 14},
  [6175] = {.lex_state = 356},
  [6176] = {.lex_state = 356, .external_lex_state = 16},
  [6177] = {.lex_state = 356},
  [6178] = {.lex_state = 356},
  [6179] = {.lex_state = 356, .external_lex_state = 18},
  [6180] = {.lex_state = 356},
  [6181] = {.lex_state = 356, .external_lex_state = 16},
  [6182] = {.lex_state = 356},
  [6183] = {.lex_state = 356},
  [6184] = {.lex_state = 356},
  [6185] = {.lex_state = 356, .external_lex_state = 16},
  [6186] = {.lex_state = 356},
  [6187] = {.lex_state = 356},
  [6188] = {.lex_state = 356},
  [6189] = {.lex_state = 356, .external_lex_state = 17},
  [6190] = {.lex_state = 356},
  [6191] = {.lex_state = 356},
  [6192] = {.lex_state = 356},
  [6193] = {.lex_state = 356},
  [6194] = {.lex_state = 353, .external_lex_state = 14},
  [6195] = {.lex_state = 356},
  [6196] = {.lex_state = 356},
  [6197] = {.lex_state = 356},
  [6198] = {.lex_state = 356},
  [6199] = {.lex_state = 356, .external_lex_state = 16},
  [6200] = {.lex_state = 356},
  [6201] = {.lex_state = 356, .external_lex_state = 17},
  [6202] = {.lex_state = 356, .external_lex_state = 16},
  [6203] = {.lex_state = 356, .external_lex_state = 17},
  [6204] = {.lex_state = 356},
  [6205] = {.lex_state = 356},
  [6206] = {.lex_state = 356, .external_lex_state = 17},
  [6207] = {.lex_state = 356, .external_lex_state = 17},
  [6208] = {.lex_state = 353, .external_lex_state = 14},
  [6209] = {.lex_state = 356},
  [6210] = {.lex_state = 356},
  [6211] = {.lex_state = 356},
  [6212] = {.lex_state = 356, .external_lex_state = 17},
  [6213] = {.lex_state = 356},
  [6214] = {.lex_state = 356, .external_lex_state = 17},
  [6215] = {.lex_state = 356},
  [6216] = {.lex_state = 356},
  [6217] = {.lex_state = 356},
  [6218] = {.lex_state = 356},
  [6219] = {.lex_state = 356},
  [6220] = {.lex_state = 356},
  [6221] = {.lex_state = 356},
  [6222] = {.lex_state = 356},
  [6223] = {.lex_state = 356},
  [6224] = {.lex_state = 356},
  [6225] = {.lex_state = 356},
  [6226] = {.lex_state = 196, .external_lex_state = 16},
  [6227] = {.lex_state = 356},
  [6228] = {.lex_state = 356, .external_lex_state = 17},
  [6229] = {.lex_state = 356},
  [6230] = {.lex_state = 196, .external_lex_state = 16},
  [6231] = {.lex_state = 356},
  [6232] = {.lex_state = 353, .external_lex_state = 14},
  [6233] = {.lex_state = 196, .external_lex_state = 16},
  [6234] = {.lex_state = 353},
  [6235] = {.lex_state = 187},
  [6236] = {.lex_state = 356, .external_lex_state = 18},
  [6237] = {.lex_state = 187},
  [6238] = {.lex_state = 353, .external_lex_state = 14},
  [6239] = {.lex_state = 356},
  [6240] = {.lex_state = 356},
  [6241] = {.lex_state = 356, .external_lex_state = 15},
  [6242] = {.lex_state = 353, .external_lex_state = 17},
  [6243] = {.lex_state = 356, .external_lex_state = 15},
  [6244] = {.lex_state = 356, .external_lex_state = 18},
  [6245] = {.lex_state = 356, .external_lex_state = 18},
  [6246] = {.lex_state = 353, .external_lex_state = 20},
  [6247] = {.lex_state = 354, .external_lex_state = 20},
  [6248] = {.lex_state = 353},
  [6249] = {.lex_state = 356, .external_lex_state = 18},
  [6250] = {.lex_state = 356, .external_lex_state = 18},
  [6251] = {.lex_state = 356, .external_lex_state = 18},
  [6252] = {.lex_state = 356},
  [6253] = {.lex_state = 356},
  [6254] = {.lex_state = 356},
  [6255] = {.lex_state = 187},
  [6256] = {.lex_state = 187},
  [6257] = {.lex_state = 356},
  [6258] = {.lex_state = 353, .external_lex_state = 14},
  [6259] = {.lex_state = 356, .external_lex_state = 18},
  [6260] = {.lex_state = 353},
  [6261] = {.lex_state = 356},
  [6262] = {.lex_state = 356},
  [6263] = {.lex_state = 356},
  [6264] = {.lex_state = 356},
  [6265] = {.lex_state = 353},
  [6266] = {.lex_state = 187},
  [6267] = {.lex_state = 356},
  [6268] = {.lex_state = 196},
  [6269] = {.lex_state = 353, .external_lex_state = 20},
  [6270] = {.lex_state = 353, .external_lex_state = 20},
  [6271] = {.lex_state = 187},
  [6272] = {.lex_state = 356},
  [6273] = {.lex_state = 187},
  [6274] = {.lex_state = 356},
  [6275] = {.lex_state = 353},
  [6276] = {.lex_state = 356},
  [6277] = {.lex_state = 353, .external_lex_state = 16},
  [6278] = {.lex_state = 187},
  [6279] = {.lex_state = 353},
  [6280] = {.lex_state = 187},
  [6281] = {.lex_state = 356, .external_lex_state = 18},
  [6282] = {.lex_state = 187},
  [6283] = {.lex_state = 353, .external_lex_state = 17},
  [6284] = {.lex_state = 353},
  [6285] = {.lex_state = 187},
  [6286] = {.lex_state = 356},
  [6287] = {.lex_state = 356},
  [6288] = {.lex_state = 353, .external_lex_state = 20},
  [6289] = {.lex_state = 356},
  [6290] = {.lex_state = 356},
  [6291] = {.lex_state = 354, .external_lex_state = 15},
  [6292] = {.lex_state = 356, .external_lex_state = 15},
  [6293] = {.lex_state = 353, .external_lex_state = 14},
  [6294] = {.lex_state = 353, .external_lex_state = 14},
  [6295] = {.lex_state = 356, .external_lex_state = 18},
  [6296] = {.lex_state = 187},
  [6297] = {.lex_state = 356, .external_lex_state = 15},
  [6298] = {.lex_state = 356},
  [6299] = {.lex_state = 353},
  [6300] = {.lex_state = 353},
  [6301] = {.lex_state = 356, .external_lex_state = 18},
  [6302] = {.lex_state = 187},
  [6303] = {.lex_state = 356},
  [6304] = {.lex_state = 356, .external_lex_state = 15},
  [6305] = {.lex_state = 356},
  [6306] = {.lex_state = 356},
  [6307] = {.lex_state = 356},
  [6308] = {.lex_state = 356},
  [6309] = {.lex_state = 353, .external_lex_state = 20},
  [6310] = {.lex_state = 354, .external_lex_state = 15},
  [6311] = {.lex_state = 187},
  [6312] = {.lex_state = 356, .external_lex_state = 17},
  [6313] = {.lex_state = 356},
  [6314] = {.lex_state = 187},
  [6315] = {.lex_state = 356},
  [6316] = {.lex_state = 354, .external_lex_state = 20},
  [6317] = {.lex_state = 353, .external_lex_state = 20},
  [6318] = {.lex_state = 356},
  [6319] = {.lex_state = 354, .external_lex_state = 20},
  [6320] = {.lex_state = 353, .external_lex_state = 16},
  [6321] = {.lex_state = 353, .external_lex_state = 20},
  [6322] = {.lex_state = 356},
  [6323] = {.lex_state = 356},
  [6324] = {.lex_state = 356, .external_lex_state = 14},
  [6325] = {.lex_state = 196},
  [6326] = {.lex_state = 353, .external_lex_state = 20},
  [6327] = {.lex_state = 354, .external_lex_state = 20},
  [6328] = {.lex_state = 356, .external_lex_state = 14},
  [6329] = {.lex_state = 356, .external_lex_state = 18},
  [6330] = {.lex_state = 356, .external_lex_state = 18},
  [6331] = {.lex_state = 356, .external_lex_state = 14},
  [6332] = {.lex_state = 356},
  [6333] = {.lex_state = 356},
  [6334] = {.lex_state = 356, .external_lex_state = 18},
  [6335] = {.lex_state = 353},
  [6336] = {.lex_state = 187},
  [6337] = {.lex_state = 353},
  [6338] = {.lex_state = 353, .external_lex_state = 14},
  [6339] = {.lex_state = 356},
  [6340] = {.lex_state = 353, .external_lex_state = 16},
  [6341] = {.lex_state = 353, .external_lex_state = 20},
  [6342] = {.lex_state = 356},
  [6343] = {.lex_state = 356, .external_lex_state = 15},
  [6344] = {.lex_state = 353, .external_lex_state = 14},
  [6345] = {.lex_state = 353},
  [6346] = {.lex_state = 187},
  [6347] = {.lex_state = 354, .external_lex_state = 20},
  [6348] = {.lex_state = 187},
  [6349] = {.lex_state = 356},
  [6350] = {.lex_state = 353, .external_lex_state = 20},
  [6351] = {.lex_state = 353},
  [6352] = {.lex_state = 356},
  [6353] = {.lex_state = 187},
  [6354] = {.lex_state = 354, .external_lex_state = 15},
  [6355] = {.lex_state = 187},
  [6356] = {.lex_state = 356},
  [6357] = {.lex_state = 356},
  [6358] = {.lex_state = 353, .external_lex_state = 14},
  [6359] = {.lex_state = 353},
  [6360] = {.lex_state = 353},
  [6361] = {.lex_state = 353, .external_lex_state = 20},
  [6362] = {.lex_state = 356},
  [6363] = {.lex_state = 353},
  [6364] = {.lex_state = 356, .external_lex_state = 15},
  [6365] = {.lex_state = 356},
  [6366] = {.lex_state = 356, .external_lex_state = 15},
  [6367] = {.lex_state = 353},
  [6368] = {.lex_state = 353, .external_lex_state = 20},
  [6369] = {.lex_state = 187},
  [6370] = {.lex_state = 187},
  [6371] = {.lex_state = 187},
  [6372] = {.lex_state = 353},
  [6373] = {.lex_state = 356},
  [6374] = {.lex_state = 356},
  [6375] = {.lex_state = 353},
  [6376] = {.lex_state = 187},
  [6377] = {.lex_state = 353, .external_lex_state = 16},
  [6378] = {.lex_state = 187},
  [6379] = {.lex_state = 187},
  [6380] = {.lex_state = 353},
  [6381] = {.lex_state = 356},
  [6382] = {.lex_state = 356},
  [6383] = {.lex_state = 354, .external_lex_state = 20},
  [6384] = {.lex_state = 353},
  [6385] = {.lex_state = 353, .external_lex_state = 20},
  [6386] = {.lex_state = 353, .external_lex_state = 20},
  [6387] = {.lex_state = 356},
  [6388] = {.lex_state = 353, .external_lex_state = 20},
  [6389] = {.lex_state = 354, .external_lex_state = 20},
  [6390] = {.lex_state = 354, .external_lex_state = 15},
  [6391] = {.lex_state = 353, .external_lex_state = 20},
  [6392] = {.lex_state = 187},
  [6393] = {.lex_state = 356},
  [6394] = {.lex_state = 353},
  [6395] = {.lex_state = 353, .external_lex_state = 20},
  [6396] = {.lex_state = 354, .external_lex_state = 20},
  [6397] = {.lex_state = 356},
  [6398] = {.lex_state = 354, .external_lex_state = 20},
  [6399] = {.lex_state = 356, .external_lex_state = 15},
  [6400] = {.lex_state = 353, .external_lex_state = 20},
  [6401] = {.lex_state = 356},
  [6402] = {.lex_state = 187},
  [6403] = {.lex_state = 356, .external_lex_state = 16},
  [6404] = {.lex_state = 353, .external_lex_state = 20},
  [6405] = {.lex_state = 354, .external_lex_state = 20},
  [6406] = {.lex_state = 356, .external_lex_state = 16},
  [6407] = {.lex_state = 356},
  [6408] = {.lex_state = 356, .external_lex_state = 17},
  [6409] = {.lex_state = 353},
  [6410] = {.lex_state = 196},
  [6411] = {.lex_state = 356},
  [6412] = {.lex_state = 356, .external_lex_state = 16},
  [6413] = {.lex_state = 356},
  [6414] = {.lex_state = 356},
  [6415] = {.lex_state = 354, .external_lex_state = 15},
  [6416] = {.lex_state = 196},
  [6417] = {.lex_state = 353},
  [6418] = {.lex_state = 356, .external_lex_state = 18},
  [6419] = {.lex_state = 353, .external_lex_state = 14},
  [6420] = {.lex_state = 187},
  [6421] = {.lex_state = 356},
  [6422] = {.lex_state = 356, .external_lex_state = 14},
  [6423] = {.lex_state = 353},
  [6424] = {.lex_state = 356, .external_lex_state = 18},
  [6425] = {.lex_state = 356},
  [6426] = {.lex_state = 354, .external_lex_state = 20},
  [6427] = {.lex_state = 353},
  [6428] = {.lex_state = 353, .external_lex_state = 20},
  [6429] = {.lex_state = 356, .external_lex_state = 17},
  [6430] = {.lex_state = 353, .external_lex_state = 20},
  [6431] = {.lex_state = 187},
  [6432] = {.lex_state = 356},
  [6433] = {.lex_state = 353},
  [6434] = {.lex_state = 353, .external_lex_state = 14},
  [6435] = {.lex_state = 353, .external_lex_state = 14},
  [6436] = {.lex_state = 353, .external_lex_state = 14},
  [6437] = {.lex_state = 354, .external_lex_state = 20},
  [6438] = {.lex_state = 354, .external_lex_state = 15},
  [6439] = {.lex_state = 354},
  [6440] = {.lex_state = 187},
  [6441] = {.lex_state = 353},
  [6442] = {.lex_state = 356, .external_lex_state = 18},
  [6443] = {.lex_state = 356},
  [6444] = {.lex_state = 196},
  [6445] = {.lex_state = 353, .external_lex_state = 16},
  [6446] = {.lex_state = 353, .external_lex_state = 14},
  [6447] = {.lex_state = 356, .external_lex_state = 18},
  [6448] = {.lex_state = 356},
  [6449] = {.lex_state = 353, .external_lex_state = 14},
  [6450] = {.lex_state = 356, .external_lex_state = 18},
  [6451] = {.lex_state = 356},
  [6452] = {.lex_state = 356, .external_lex_state = 18},
  [6453] = {.lex_state = 356},
  [6454] = {.lex_state = 187},
  [6455] = {.lex_state = 356},
  [6456] = {.lex_state = 356},
  [6457] = {.lex_state = 356},
  [6458] = {.lex_state = 356},
  [6459] = {.lex_state = 356, .external_lex_state = 14},
  [6460] = {.lex_state = 356},
  [6461] = {.lex_state = 353},
  [6462] = {.lex_state = 356},
  [6463] = {.lex_state = 187},
  [6464] = {.lex_state = 353},
  [6465] = {.lex_state = 353},
  [6466] = {.lex_state = 187},
  [6467] = {.lex_state = 356},
  [6468] = {.lex_state = 356, .external_lex_state = 15},
  [6469] = {.lex_state = 353},
  [6470] = {.lex_state = 356},
  [6471] = {.lex_state = 356},
  [6472] = {.lex_state = 356, .external_lex_state = 15},
  [6473] = {.lex_state = 356},
  [6474] = {.lex_state = 354, .external_lex_state = 15},
  [6475] = {.lex_state = 187},
  [6476] = {.lex_state = 356, .external_lex_state = 15},
  [6477] = {.lex_state = 353, .external_lex_state = 20},
  [6478] = {.lex_state = 353, .external_lex_state = 20},
  [6479] = {.lex_state = 353},
  [6480] = {.lex_state = 354, .external_lex_state = 15},
  [6481] = {.lex_state = 187},
  [6482] = {.lex_state = 196},
  [6483] = {.lex_state = 356},
  [6484] = {.lex_state = 354, .external_lex_state = 20},
  [6485] = {.lex_state = 353, .external_lex_state = 20},
  [6486] = {.lex_state = 353, .external_lex_state = 14},
  [6487] = {.lex_state = 187},
  [6488] = {.lex_state = 356, .external_lex_state = 15},
  [6489] = {.lex_state = 356},
  [6490] = {.lex_state = 353},
  [6491] = {.lex_state = 356},
  [6492] = {.lex_state = 149},
  [6493] = {.lex_state = 354, .external_lex_state = 20},
  [6494] = {.lex_state = 353, .external_lex_state = 20},
  [6495] = {.lex_state = 187},
  [6496] = {.lex_state = 356},
  [6497] = {.lex_state = 356},
  [6498] = {.lex_state = 354, .external_lex_state = 20},
  [6499] = {.lex_state = 353},
  [6500] = {.lex_state = 353},
  [6501] = {.lex_state = 356},
  [6502] = {.lex_state = 353, .external_lex_state = 20},
  [6503] = {.lex_state = 356},
  [6504] = {.lex_state = 354, .external_lex_state = 15},
  [6505] = {.lex_state = 187},
  [6506] = {.lex_state = 353},
  [6507] = {.lex_state = 353},
  [6508] = {.lex_state = 196},
  [6509] = {.lex_state = 353, .external_lex_state = 20},
  [6510] = {.lex_state = 143},
  [6511] = {.lex_state = 353},
  [6512] = {.lex_state = 187},
  [6513] = {.lex_state = 354, .external_lex_state = 20},
  [6514] = {.lex_state = 353},
  [6515] = {.lex_state = 353, .external_lex_state = 17},
  [6516] = {.lex_state = 353},
  [6517] = {.lex_state = 353},
  [6518] = {.lex_state = 356},
  [6519] = {.lex_state = 356},
  [6520] = {.lex_state = 356},
  [6521] = {.lex_state = 356},
  [6522] = {.lex_state = 356, .external_lex_state = 15},
  [6523] = {.lex_state = 187},
  [6524] = {.lex_state = 356},
  [6525] = {.lex_state = 356},
  [6526] = {.lex_state = 356},
  [6527] = {.lex_state = 356},
  [6528] = {.lex_state = 356},
  [6529] = {.lex_state = 353},
  [6530] = {.lex_state = 187},
  [6531] = {.lex_state = 187},
  [6532] = {.lex_state = 353, .external_lex_state = 17},
  [6533] = {.lex_state = 353, .external_lex_state = 14},
  [6534] = {.lex_state = 353},
  [6535] = {.lex_state = 353, .external_lex_state = 16},
  [6536] = {.lex_state = 353},
  [6537] = {.lex_state = 353, .external_lex_state = 20},
  [6538] = {.lex_state = 356},
  [6539] = {.lex_state = 356},
  [6540] = {.lex_state = 356},
  [6541] = {.lex_state = 356},
  [6542] = {.lex_state = 353, .external_lex_state = 14},
  [6543] = {.lex_state = 356},
  [6544] = {.lex_state = 356},
  [6545] = {.lex_state = 356},
  [6546] = {.lex_state = 353, .external_lex_state = 20},
  [6547] = {.lex_state = 354, .external_lex_state = 20},
  [6548] = {.lex_state = 356},
  [6549] = {.lex_state = 353},
  [6550] = {.lex_state = 353},
  [6551] = {.lex_state = 187},
  [6552] = {.lex_state = 356},
  [6553] = {.lex_state = 356, .external_lex_state = 14},
  [6554] = {.lex_state = 353},
  [6555] = {.lex_state = 354, .external_lex_state = 20},
  [6556] = {.lex_state = 356},
  [6557] = {.lex_state = 187},
  [6558] = {.lex_state = 353, .external_lex_state = 20},
  [6559] = {.lex_state = 353, .external_lex_state = 20},
  [6560] = {.lex_state = 356},
  [6561] = {.lex_state = 353, .external_lex_state = 16},
  [6562] = {.lex_state = 353, .external_lex_state = 20},
  [6563] = {.lex_state = 353, .external_lex_state = 20},
  [6564] = {.lex_state = 353, .external_lex_state = 20},
  [6565] = {.lex_state = 353, .external_lex_state = 20},
  [6566] = {.lex_state = 353, .external_lex_state = 20},
  [6567] = {.lex_state = 138},
  [6568] = {.lex_state = 138},
  [6569] = {.lex_state = 356},
  [6570] = {.lex_state = 353, .external_lex_state = 20},
  [6571] = {.lex_state = 353, .external_lex_state = 20},
  [6572] = {.lex_state = 353, .external_lex_state = 20},
  [6573] = {.lex_state = 353, .external_lex_state = 20},
  [6574] = {.lex_state = 353, .external_lex_state = 20},
  [6575] = {.lex_state = 356},
  [6576] = {.lex_state = 356},
  [6577] = {.lex_state = 356},
  [6578] = {.lex_state = 354, .external_lex_state = 15},
  [6579] = {.lex_state = 353},
  [6580] = {.lex_state = 353, .external_lex_state = 20},
  [6581] = {.lex_state = 353, .external_lex_state = 20},
  [6582] = {.lex_state = 356},
  [6583] = {.lex_state = 203},
  [6584] = {.lex_state = 353, .external_lex_state = 20},
  [6585] = {.lex_state = 353},
  [6586] = {.lex_state = 353},
  [6587] = {.lex_state = 353, .external_lex_state = 16},
  [6588] = {.lex_state = 353, .external_lex_state = 16},
  [6589] = {.lex_state = 353, .external_lex_state = 20},
  [6590] = {.lex_state = 353, .external_lex_state = 20},
  [6591] = {.lex_state = 356},
  [6592] = {.lex_state = 353, .external_lex_state = 20},
  [6593] = {.lex_state = 353, .external_lex_state = 21},
  [6594] = {.lex_state = 353, .external_lex_state = 20},
  [6595] = {.lex_state = 353, .external_lex_state = 20},
  [6596] = {.lex_state = 356},
  [6597] = {.lex_state = 356},
  [6598] = {.lex_state = 354, .external_lex_state = 15},
  [6599] = {.lex_state = 354, .external_lex_state = 15},
  [6600] = {.lex_state = 353},
  [6601] = {.lex_state = 353, .external_lex_state = 20},
  [6602] = {.lex_state = 353, .external_lex_state = 20},
  [6603] = {.lex_state = 353},
  [6604] = {.lex_state = 353, .external_lex_state = 20},
  [6605] = {.lex_state = 356},
  [6606] = {.lex_state = 356},
  [6607] = {.lex_state = 353},
  [6608] = {.lex_state = 353},
  [6609] = {.lex_state = 353, .external_lex_state = 20},
  [6610] = {.lex_state = 353, .external_lex_state = 20},
  [6611] = {.lex_state = 354},
  [6612] = {.lex_state = 203},
  [6613] = {.lex_state = 353, .external_lex_state = 20},
  [6614] = {.lex_state = 353, .external_lex_state = 21},
  [6615] = {.lex_state = 203},
  [6616] = {.lex_state = 353, .external_lex_state = 20},
  [6617] = {.lex_state = 353, .external_lex_state = 20},
  [6618] = {.lex_state = 353, .external_lex_state = 20},
  [6619] = {.lex_state = 203},
  [6620] = {.lex_state = 353, .external_lex_state = 20},
  [6621] = {.lex_state = 353},
  [6622] = {.lex_state = 356},
  [6623] = {.lex_state = 203},
  [6624] = {.lex_state = 203},
  [6625] = {.lex_state = 353, .external_lex_state = 20},
  [6626] = {.lex_state = 353, .external_lex_state = 20},
  [6627] = {.lex_state = 353, .external_lex_state = 20},
  [6628] = {.lex_state = 203},
  [6629] = {.lex_state = 353, .external_lex_state = 14},
  [6630] = {.lex_state = 203},
  [6631] = {.lex_state = 353, .external_lex_state = 20},
  [6632] = {.lex_state = 353, .external_lex_state = 20},
  [6633] = {.lex_state = 353, .external_lex_state = 14},
  [6634] = {.lex_state = 353, .external_lex_state = 20},
  [6635] = {.lex_state = 353, .external_lex_state = 20},
  [6636] = {.lex_state = 353, .external_lex_state = 20},
  [6637] = {.lex_state = 353, .external_lex_state = 20},
  [6638] = {.lex_state = 353, .external_lex_state = 20},
  [6639] = {.lex_state = 353, .external_lex_state = 20},
  [6640] = {.lex_state = 356},
  [6641] = {.lex_state = 353, .external_lex_state = 20},
  [6642] = {.lex_state = 353},
  [6643] = {.lex_state = 354},
  [6644] = {.lex_state = 353, .external_lex_state = 20},
  [6645] = {.lex_state = 353, .external_lex_state = 20},
  [6646] = {.lex_state = 353, .external_lex_state = 20},
  [6647] = {.lex_state = 353, .external_lex_state = 16},
  [6648] = {.lex_state = 353, .external_lex_state = 20},
  [6649] = {.lex_state = 353, .external_lex_state = 14},
  [6650] = {.lex_state = 353, .external_lex_state = 20},
  [6651] = {.lex_state = 353, .external_lex_state = 20},
  [6652] = {.lex_state = 353, .external_lex_state = 20},
  [6653] = {.lex_state = 353, .external_lex_state = 20},
  [6654] = {.lex_state = 353},
  [6655] = {.lex_state = 353, .external_lex_state = 20},
  [6656] = {.lex_state = 353},
  [6657] = {.lex_state = 353},
  [6658] = {.lex_state = 353, .external_lex_state = 20},
  [6659] = {.lex_state = 353, .external_lex_state = 14},
  [6660] = {.lex_state = 353, .external_lex_state = 20},
  [6661] = {.lex_state = 353, .external_lex_state = 20},
  [6662] = {.lex_state = 353, .external_lex_state = 20},
  [6663] = {.lex_state = 353, .external_lex_state = 20},
  [6664] = {.lex_state = 353, .external_lex_state = 20},
  [6665] = {.lex_state = 353, .external_lex_state = 20},
  [6666] = {.lex_state = 353, .external_lex_state = 20},
  [6667] = {.lex_state = 353, .external_lex_state = 20},
  [6668] = {.lex_state = 353},
  [6669] = {.lex_state = 356},
  [6670] = {.lex_state = 353, .external_lex_state = 20},
  [6671] = {.lex_state = 353, .external_lex_state = 20},
  [6672] = {.lex_state = 353},
  [6673] = {.lex_state = 354},
  [6674] = {.lex_state = 356},
  [6675] = {.lex_state = 356},
  [6676] = {.lex_state = 353, .external_lex_state = 20},
  [6677] = {.lex_state = 353, .external_lex_state = 20},
  [6678] = {.lex_state = 353, .external_lex_state = 20},
  [6679] = {.lex_state = 356},
  [6680] = {.lex_state = 353, .external_lex_state = 14},
  [6681] = {.lex_state = 353, .external_lex_state = 16},
  [6682] = {.lex_state = 353, .external_lex_state = 20},
  [6683] = {.lex_state = 353, .external_lex_state = 20},
  [6684] = {.lex_state = 353, .external_lex_state = 20},
  [6685] = {.lex_state = 353, .external_lex_state = 20},
  [6686] = {.lex_state = 353, .external_lex_state = 14},
  [6687] = {.lex_state = 356},
  [6688] = {.lex_state = 353, .external_lex_state = 20},
  [6689] = {.lex_state = 353, .external_lex_state = 20},
  [6690] = {.lex_state = 356},
  [6691] = {.lex_state = 354},
  [6692] = {.lex_state = 353, .external_lex_state = 20},
  [6693] = {.lex_state = 353, .external_lex_state = 20},
  [6694] = {.lex_state = 353, .external_lex_state = 16},
  [6695] = {.lex_state = 353, .external_lex_state = 20},
  [6696] = {.lex_state = 353, .external_lex_state = 14},
  [6697] = {.lex_state = 353, .external_lex_state = 20},
  [6698] = {.lex_state = 353, .external_lex_state = 14},
  [6699] = {.lex_state = 353, .external_lex_state = 20},
  [6700] = {.lex_state = 353, .external_lex_state = 20},
  [6701] = {.lex_state = 353, .external_lex_state = 14},
  [6702] = {.lex_state = 353},
  [6703] = {.lex_state = 356},
  [6704] = {.lex_state = 353, .external_lex_state = 20},
  [6705] = {.lex_state = 353, .external_lex_state = 14},
  [6706] = {.lex_state = 353, .external_lex_state = 14},
  [6707] = {.lex_state = 353, .external_lex_state = 20},
  [6708] = {.lex_state = 353, .external_lex_state = 20},
  [6709] = {.lex_state = 353, .external_lex_state = 14},
  [6710] = {.lex_state = 353, .external_lex_state = 14},
  [6711] = {.lex_state = 353, .external_lex_state = 20},
  [6712] = {.lex_state = 353, .external_lex_state = 14},
  [6713] = {.lex_state = 353, .external_lex_state = 20},
  [6714] = {.lex_state = 203},
  [6715] = {.lex_state = 353, .external_lex_state = 17},
  [6716] = {.lex_state = 353, .external_lex_state = 17},
  [6717] = {.lex_state = 353, .external_lex_state = 17},
  [6718] = {.lex_state = 353, .external_lex_state = 14},
  [6719] = {.lex_state = 353, .external_lex_state = 20},
  [6720] = {.lex_state = 353},
  [6721] = {.lex_state = 353},
  [6722] = {.lex_state = 353, .external_lex_state = 20},
  [6723] = {.lex_state = 353, .external_lex_state = 20},
  [6724] = {.lex_state = 353, .external_lex_state = 20},
  [6725] = {.lex_state = 353, .external_lex_state = 17},
  [6726] = {.lex_state = 353, .external_lex_state = 17},
  [6727] = {.lex_state = 353, .external_lex_state = 20},
  [6728] = {.lex_state = 353},
  [6729] = {.lex_state = 353, .external_lex_state = 20},
  [6730] = {.lex_state = 353, .external_lex_state = 17},
  [6731] = {.lex_state = 353, .external_lex_state = 17},
  [6732] = {.lex_state = 353, .external_lex_state = 17},
  [6733] = {.lex_state = 353, .external_lex_state = 17},
  [6734] = {.lex_state = 353, .external_lex_state = 17},
  [6735] = {.lex_state = 356, .external_lex_state = 16},
  [6736] = {.lex_state = 353, .external_lex_state = 17},
  [6737] = {.lex_state = 353, .external_lex_state = 20},
  [6738] = {.lex_state = 353, .external_lex_state = 20},
  [6739] = {.lex_state = 353, .external_lex_state = 17},
  [6740] = {.lex_state = 356, .external_lex_state = 16},
  [6741] = {.lex_state = 353, .external_lex_state = 17},
  [6742] = {.lex_state = 353, .external_lex_state = 20},
  [6743] = {.lex_state = 353, .external_lex_state = 20},
  [6744] = {.lex_state = 353, .external_lex_state = 20},
  [6745] = {.lex_state = 353, .external_lex_state = 20},
  [6746] = {.lex_state = 356, .external_lex_state = 16},
  [6747] = {.lex_state = 353, .external_lex_state = 20},
  [6748] = {.lex_state = 353, .external_lex_state = 14},
  [6749] = {.lex_state = 353, .external_lex_state = 14},
  [6750] = {.lex_state = 353, .external_lex_state = 17},
  [6751] = {.lex_state = 353, .external_lex_state = 17},
  [6752] = {.lex_state = 356, .external_lex_state = 16},
  [6753] = {.lex_state = 353, .external_lex_state = 20},
  [6754] = {.lex_state = 356, .external_lex_state = 16},
  [6755] = {.lex_state = 356, .external_lex_state = 16},
  [6756] = {.lex_state = 356, .external_lex_state = 18},
  [6757] = {.lex_state = 353, .external_lex_state = 20},
  [6758] = {.lex_state = 353, .external_lex_state = 20},
  [6759] = {.lex_state = 356, .external_lex_state = 18},
  [6760] = {.lex_state = 356, .external_lex_state = 18},
  [6761] = {.lex_state = 353, .external_lex_state = 16},
  [6762] = {.lex_state = 353, .external_lex_state = 20},
  [6763] = {.lex_state = 353, .external_lex_state = 16},
  [6764] = {.lex_state = 353, .external_lex_state = 16},
  [6765] = {.lex_state = 353, .external_lex_state = 20},
  [6766] = {.lex_state = 353, .external_lex_state = 16},
  [6767] = {.lex_state = 353, .external_lex_state = 16},
  [6768] = {.lex_state = 353, .external_lex_state = 20},
  [6769] = {.lex_state = 353, .external_lex_state = 16},
  [6770] = {.lex_state = 353, .external_lex_state = 16},
  [6771] = {.lex_state = 353, .external_lex_state = 20},
  [6772] = {.lex_state = 353, .external_lex_state = 20},
  [6773] = {.lex_state = 353, .external_lex_state = 16},
  [6774] = {.lex_state = 353, .external_lex_state = 16},
  [6775] = {.lex_state = 353, .external_lex_state = 16},
  [6776] = {.lex_state = 353, .external_lex_state = 16},
  [6777] = {.lex_state = 353, .external_lex_state = 16},
  [6778] = {.lex_state = 353, .external_lex_state = 16},
  [6779] = {.lex_state = 353, .external_lex_state = 16},
  [6780] = {.lex_state = 353, .external_lex_state = 16},
  [6781] = {.lex_state = 353, .external_lex_state = 16},
  [6782] = {.lex_state = 353, .external_lex_state = 16},
  [6783] = {.lex_state = 353, .external_lex_state = 16},
  [6784] = {.lex_state = 353, .external_lex_state = 20},
  [6785] = {.lex_state = 353, .external_lex_state = 16},
  [6786] = {.lex_state = 353, .external_lex_state = 20},
  [6787] = {.lex_state = 353, .external_lex_state = 20},
  [6788] = {.lex_state = 353, .external_lex_state = 20},
  [6789] = {.lex_state = 353, .external_lex_state = 16},
  [6790] = {.lex_state = 353, .external_lex_state = 16},
  [6791] = {.lex_state = 353, .external_lex_state = 16},
  [6792] = {.lex_state = 353, .external_lex_state = 16},
  [6793] = {.lex_state = 353, .external_lex_state = 20},
  [6794] = {.lex_state = 353, .external_lex_state = 16},
  [6795] = {.lex_state = 353, .external_lex_state = 16},
  [6796] = {.lex_state = 353, .external_lex_state = 16},
  [6797] = {.lex_state = 353, .external_lex_state = 16},
  [6798] = {.lex_state = 353, .external_lex_state = 16},
  [6799] = {.lex_state = 353, .external_lex_state = 20},
  [6800] = {.lex_state = 353, .external_lex_state = 16},
  [6801] = {.lex_state = 353, .external_lex_state = 20},
  [6802] = {.lex_state = 353, .external_lex_state = 20},
  [6803] = {.lex_state = 353, .external_lex_state = 20},
  [6804] = {.lex_state = 353, .external_lex_state = 20},
  [6805] = {.lex_state = 353, .external_lex_state = 20},
  [6806] = {.lex_state = 353, .external_lex_state = 20},
  [6807] = {.lex_state = 353, .external_lex_state = 20},
  [6808] = {.lex_state = 353, .external_lex_state = 20},
  [6809] = {.lex_state = 353, .external_lex_state = 20},
  [6810] = {.lex_state = 353, .external_lex_state = 20},
  [6811] = {.lex_state = 353, .external_lex_state = 20},
  [6812] = {.lex_state = 353, .external_lex_state = 20},
  [6813] = {.lex_state = 353, .external_lex_state = 20},
  [6814] = {.lex_state = 353, .external_lex_state = 20},
  [6815] = {.lex_state = 356},
  [6816] = {.lex_state = 356},
  [6817] = {.lex_state = 353, .external_lex_state = 20},
  [6818] = {.lex_state = 353, .external_lex_state = 20},
  [6819] = {.lex_state = 353, .external_lex_state = 20},
  [6820] = {.lex_state = 353, .external_lex_state = 20},
  [6821] = {.lex_state = 353, .external_lex_state = 20},
  [6822] = {.lex_state = 353, .external_lex_state = 20},
  [6823] = {.lex_state = 353, .external_lex_state = 20},
  [6824] = {.lex_state = 353, .external_lex_state = 20},
  [6825] = {.lex_state = 353, .external_lex_state = 20},
  [6826] = {.lex_state = 356},
  [6827] = {.lex_state = 353, .external_lex_state = 20},
  [6828] = {.lex_state = 353, .external_lex_state = 20},
  [6829] = {.lex_state = 353, .external_lex_state = 20},
  [6830] = {.lex_state = 353, .external_lex_state = 20},
  [6831] = {.lex_state = 353, .external_lex_state = 20},
  [6832] = {.lex_state = 353, .external_lex_state = 20},
  [6833] = {.lex_state = 353, .external_lex_state = 20},
  [6834] = {.lex_state = 356},
  [6835] = {.lex_state = 353, .external_lex_state = 20},
  [6836] = {.lex_state = 353, .external_lex_state = 20},
  [6837] = {.lex_state = 353, .external_lex_state = 20},
  [6838] = {.lex_state = 353, .external_lex_state = 20},
  [6839] = {.lex_state = 353, .external_lex_state = 20},
  [6840] = {.lex_state = 356},
  [6841] = {.lex_state = 353, .external_lex_state = 20},
  [6842] = {.lex_state = 356},
  [6843] = {.lex_state = 353, .external_lex_state = 20},
  [6844] = {.lex_state = 356},
  [6845] = {.lex_state = 353, .external_lex_state = 20},
  [6846] = {.lex_state = 356},
  [6847] = {.lex_state = 356},
  [6848] = {.lex_state = 353, .external_lex_state = 20},
  [6849] = {.lex_state = 353, .external_lex_state = 20},
  [6850] = {.lex_state = 353, .external_lex_state = 20},
  [6851] = {.lex_state = 353, .external_lex_state = 20},
  [6852] = {.lex_state = 353, .external_lex_state = 20},
  [6853] = {.lex_state = 353, .external_lex_state = 20},
  [6854] = {.lex_state = 353, .external_lex_state = 20},
  [6855] = {.lex_state = 356},
  [6856] = {.lex_state = 356},
  [6857] = {.lex_state = 356},
  [6858] = {.lex_state = 356},
  [6859] = {.lex_state = 356},
  [6860] = {.lex_state = 356},
  [6861] = {.lex_state = 353, .external_lex_state = 20},
  [6862] = {.lex_state = 353, .external_lex_state = 20},
  [6863] = {.lex_state = 356},
  [6864] = {.lex_state = 356},
  [6865] = {.lex_state = 353, .external_lex_state = 20},
  [6866] = {.lex_state = 356},
  [6867] = {.lex_state = 353, .external_lex_state = 20},
  [6868] = {.lex_state = 353, .external_lex_state = 20},
  [6869] = {.lex_state = 353, .external_lex_state = 20},
  [6870] = {.lex_state = 353, .external_lex_state = 20},
  [6871] = {.lex_state = 356},
  [6872] = {.lex_state = 353, .external_lex_state = 20},
  [6873] = {.lex_state = 353, .external_lex_state = 20},
  [6874] = {.lex_state = 353, .external_lex_state = 20},
  [6875] = {.lex_state = 353, .external_lex_state = 21},
  [6876] = {.lex_state = 356},
  [6877] = {.lex_state = 353, .external_lex_state = 21},
  [6878] = {.lex_state = 356},
  [6879] = {.lex_state = 353, .external_lex_state = 20},
  [6880] = {.lex_state = 356},
  [6881] = {.lex_state = 353, .external_lex_state = 20},
  [6882] = {.lex_state = 353, .external_lex_state = 20},
  [6883] = {.lex_state = 353, .external_lex_state = 20},
  [6884] = {.lex_state = 353, .external_lex_state = 20},
  [6885] = {.lex_state = 353, .external_lex_state = 20},
  [6886] = {.lex_state = 353, .external_lex_state = 20},
  [6887] = {.lex_state = 353, .external_lex_state = 20},
  [6888] = {.lex_state = 353, .external_lex_state = 20},
  [6889] = {.lex_state = 353, .external_lex_state = 20},
  [6890] = {.lex_state = 356},
  [6891] = {.lex_state = 353, .external_lex_state = 20},
  [6892] = {.lex_state = 353, .external_lex_state = 21},
  [6893] = {.lex_state = 356},
  [6894] = {.lex_state = 353, .external_lex_state = 21},
  [6895] = {.lex_state = 356},
  [6896] = {.lex_state = 353, .external_lex_state = 20},
  [6897] = {.lex_state = 353, .external_lex_state = 20},
  [6898] = {.lex_state = 353, .external_lex_state = 20},
  [6899] = {.lex_state = 353, .external_lex_state = 20},
  [6900] = {.lex_state = 356},
  [6901] = {.lex_state = 353, .external_lex_state = 20},
  [6902] = {.lex_state = 353, .external_lex_state = 20},
  [6903] = {.lex_state = 353, .external_lex_state = 20},
  [6904] = {.lex_state = 353, .external_lex_state = 20},
  [6905] = {.lex_state = 356},
  [6906] = {.lex_state = 353, .external_lex_state = 21},
  [6907] = {.lex_state = 353, .external_lex_state = 20},
  [6908] = {.lex_state = 353, .external_lex_state = 20},
  [6909] = {.lex_state = 356},
  [6910] = {.lex_state = 356},
  [6911] = {.lex_state = 353, .external_lex_state = 20},
  [6912] = {.lex_state = 353, .external_lex_state = 21},
  [6913] = {.lex_state = 356},
  [6914] = {.lex_state = 353, .external_lex_state = 20},
  [6915] = {.lex_state = 353, .external_lex_state = 20},
  [6916] = {.lex_state = 353, .external_lex_state = 20},
  [6917] = {.lex_state = 353, .external_lex_state = 20},
  [6918] = {.lex_state = 353, .external_lex_state = 20},
  [6919] = {.lex_state = 353, .external_lex_state = 20},
  [6920] = {.lex_state = 353},
  [6921] = {.lex_state = 353, .external_lex_state = 20},
  [6922] = {.lex_state = 353, .external_lex_state = 20},
  [6923] = {.lex_state = 356},
  [6924] = {.lex_state = 353, .external_lex_state = 20},
  [6925] = {.lex_state = 353, .external_lex_state = 20},
  [6926] = {.lex_state = 353, .external_lex_state = 20},
  [6927] = {.lex_state = 356},
  [6928] = {.lex_state = 353, .external_lex_state = 20},
  [6929] = {.lex_state = 356},
  [6930] = {.lex_state = 353, .external_lex_state = 21},
  [6931] = {.lex_state = 356},
  [6932] = {.lex_state = 356},
  [6933] = {.lex_state = 353, .external_lex_state = 21},
  [6934] = {.lex_state = 356},
  [6935] = {.lex_state = 353},
  [6936] = {.lex_state = 356},
  [6937] = {.lex_state = 353, .external_lex_state = 20},
  [6938] = {.lex_state = 353, .external_lex_state = 20},
  [6939] = {.lex_state = 353, .external_lex_state = 20},
  [6940] = {.lex_state = 353},
  [6941] = {.lex_state = 356},
  [6942] = {.lex_state = 353, .external_lex_state = 20},
  [6943] = {.lex_state = 353, .external_lex_state = 21},
  [6944] = {.lex_state = 356},
  [6945] = {.lex_state = 353, .external_lex_state = 21},
  [6946] = {.lex_state = 356},
  [6947] = {.lex_state = 353, .external_lex_state = 20},
  [6948] = {.lex_state = 353, .external_lex_state = 20},
  [6949] = {.lex_state = 353},
  [6950] = {.lex_state = 353, .external_lex_state = 20},
  [6951] = {.lex_state = 353, .external_lex_state = 20},
  [6952] = {.lex_state = 353, .external_lex_state = 20},
  [6953] = {.lex_state = 353, .external_lex_state = 20},
  [6954] = {.lex_state = 353, .external_lex_state = 20},
  [6955] = {.lex_state = 353, .external_lex_state = 20},
  [6956] = {.lex_state = 356},
  [6957] = {.lex_state = 353, .external_lex_state = 20},
  [6958] = {.lex_state = 353, .external_lex_state = 20},
  [6959] = {.lex_state = 353},
  [6960] = {.lex_state = 356},
  [6961] = {.lex_state = 356},
  [6962] = {.lex_state = 356},
  [6963] = {.lex_state = 353, .external_lex_state = 21},
  [6964] = {.lex_state = 353, .external_lex_state = 20},
  [6965] = {.lex_state = 353, .external_lex_state = 20},
  [6966] = {.lex_state = 356},
  [6967] = {.lex_state = 353, .external_lex_state = 20},
  [6968] = {.lex_state = 356},
  [6969] = {.lex_state = 356},
  [6970] = {.lex_state = 353, .external_lex_state = 21},
  [6971] = {.lex_state = 138},
  [6972] = {.lex_state = 353, .external_lex_state = 20},
  [6973] = {.lex_state = 353, .external_lex_state = 20},
  [6974] = {.lex_state = 353, .external_lex_state = 20},
  [6975] = {.lex_state = 356},
  [6976] = {.lex_state = 353, .external_lex_state = 20},
  [6977] = {.lex_state = 356},
  [6978] = {.lex_state = 353, .external_lex_state = 20},
  [6979] = {.lex_state = 353},
  [6980] = {.lex_state = 353, .external_lex_state = 20},
  [6981] = {.lex_state = 356},
  [6982] = {.lex_state = 353, .external_lex_state = 20},
  [6983] = {.lex_state = 353, .external_lex_state = 20},
  [6984] = {.lex_state = 356},
  [6985] = {.lex_state = 353, .external_lex_state = 20},
  [6986] = {.lex_state = 353},
  [6987] = {.lex_state = 353, .external_lex_state = 20},
  [6988] = {.lex_state = 353, .external_lex_state = 20},
  [6989] = {.lex_state = 353, .external_lex_state = 20},
  [6990] = {.lex_state = 353, .external_lex_state = 20},
  [6991] = {.lex_state = 353},
  [6992] = {.lex_state = 356},
  [6993] = {.lex_state = 353, .external_lex_state = 20},
  [6994] = {.lex_state = 353, .external_lex_state = 20},
  [6995] = {.lex_state = 353, .external_lex_state = 21},
  [6996] = {.lex_state = 356},
  [6997] = {.lex_state = 356},
  [6998] = {.lex_state = 353, .external_lex_state = 20},
  [6999] = {.lex_state = 356},
  [7000] = {.lex_state = 356},
  [7001] = {.lex_state = 353, .external_lex_state = 20},
  [7002] = {.lex_state = 353, .external_lex_state = 20},
  [7003] = {.lex_state = 353, .external_lex_state = 20},
  [7004] = {.lex_state = 356},
  [7005] = {.lex_state = 353, .external_lex_state = 21},
  [7006] = {.lex_state = 356},
  [7007] = {.lex_state = 353, .external_lex_state = 21},
  [7008] = {.lex_state = 353, .external_lex_state = 20},
  [7009] = {.lex_state = 356},
  [7010] = {.lex_state = 356},
  [7011] = {.lex_state = 356},
  [7012] = {.lex_state = 353, .external_lex_state = 20},
  [7013] = {.lex_state = 353, .external_lex_state = 20},
  [7014] = {.lex_state = 353, .external_lex_state = 20},
  [7015] = {.lex_state = 353, .external_lex_state = 20},
  [7016] = {.lex_state = 356},
  [7017] = {.lex_state = 356},
  [7018] = {.lex_state = 353},
  [7019] = {.lex_state = 356},
  [7020] = {.lex_state = 353, .external_lex_state = 20},
  [7021] = {.lex_state = 356},
  [7022] = {.lex_state = 353, .external_lex_state = 20},
  [7023] = {.lex_state = 353, .external_lex_state = 20},
  [7024] = {.lex_state = 353, .external_lex_state = 21},
  [7025] = {.lex_state = 356},
  [7026] = {.lex_state = 353},
  [7027] = {.lex_state = 356},
  [7028] = {.lex_state = 356},
  [7029] = {.lex_state = 353, .external_lex_state = 20},
  [7030] = {.lex_state = 353, .external_lex_state = 21},
  [7031] = {.lex_state = 353, .external_lex_state = 20},
  [7032] = {.lex_state = 353, .external_lex_state = 20},
  [7033] = {.lex_state = 353, .external_lex_state = 20},
  [7034] = {.lex_state = 353, .external_lex_state = 20},
  [7035] = {.lex_state = 353, .external_lex_state = 20},
  [7036] = {.lex_state = 353, .external_lex_state = 20},
  [7037] = {.lex_state = 356},
  [7038] = {.lex_state = 356},
  [7039] = {.lex_state = 353},
  [7040] = {.lex_state = 353, .external_lex_state = 21},
  [7041] = {.lex_state = 356},
  [7042] = {.lex_state = 356},
  [7043] = {.lex_state = 353, .external_lex_state = 20},
  [7044] = {.lex_state = 353},
  [7045] = {.lex_state = 353, .external_lex_state = 20},
  [7046] = {.lex_state = 353, .external_lex_state = 20},
  [7047] = {.lex_state = 353, .external_lex_state = 20},
  [7048] = {.lex_state = 353, .external_lex_state = 20},
  [7049] = {.lex_state = 353, .external_lex_state = 20},
  [7050] = {.lex_state = 353, .external_lex_state = 20},
  [7051] = {.lex_state = 353, .external_lex_state = 20},
  [7052] = {.lex_state = 356},
  [7053] = {.lex_state = 353},
  [7054] = {.lex_state = 353, .external_lex_state = 20},
  [7055] = {.lex_state = 353, .external_lex_state = 20},
  [7056] = {.lex_state = 356},
  [7057] = {.lex_state = 353, .external_lex_state = 21},
  [7058] = {.lex_state = 356},
  [7059] = {.lex_state = 353, .external_lex_state = 20},
  [7060] = {.lex_state = 356},
  [7061] = {.lex_state = 353, .external_lex_state = 20},
  [7062] = {.lex_state = 356},
  [7063] = {.lex_state = 353, .external_lex_state = 20},
  [7064] = {.lex_state = 353, .external_lex_state = 20},
  [7065] = {.lex_state = 356},
  [7066] = {.lex_state = 356},
  [7067] = {.lex_state = 353, .external_lex_state = 20},
  [7068] = {.lex_state = 353, .external_lex_state = 20},
  [7069] = {.lex_state = 353, .external_lex_state = 20},
  [7070] = {.lex_state = 353, .external_lex_state = 20},
  [7071] = {.lex_state = 356},
  [7072] = {.lex_state = 353, .external_lex_state = 20},
  [7073] = {.lex_state = 353, .external_lex_state = 21},
  [7074] = {.lex_state = 356},
  [7075] = {.lex_state = 356},
  [7076] = {.lex_state = 356},
  [7077] = {.lex_state = 353, .external_lex_state = 20},
  [7078] = {.lex_state = 353, .external_lex_state = 20},
  [7079] = {.lex_state = 353, .external_lex_state = 20},
  [7080] = {.lex_state = 353, .external_lex_state = 20},
  [7081] = {.lex_state = 353, .external_lex_state = 20},
  [7082] = {.lex_state = 356},
  [7083] = {.lex_state = 353, .external_lex_state = 20},
  [7084] = {.lex_state = 353, .external_lex_state = 20},
  [7085] = {.lex_state = 353},
  [7086] = {.lex_state = 353, .external_lex_state = 20},
  [7087] = {.lex_state = 353, .external_lex_state = 20},
  [7088] = {.lex_state = 356},
  [7089] = {.lex_state = 353, .external_lex_state = 20},
  [7090] = {.lex_state = 353, .external_lex_state = 20},
  [7091] = {.lex_state = 353, .external_lex_state = 20},
  [7092] = {.lex_state = 138},
  [7093] = {.lex_state = 353, .external_lex_state = 20},
  [7094] = {.lex_state = 356},
  [7095] = {.lex_state = 353, .external_lex_state = 20},
  [7096] = {.lex_state = 353, .external_lex_state = 20},
  [7097] = {.lex_state = 356},
  [7098] = {.lex_state = 138},
  [7099] = {.lex_state = 353, .external_lex_state = 20},
  [7100] = {.lex_state = 353, .external_lex_state = 20},
  [7101] = {.lex_state = 356},
  [7102] = {.lex_state = 353, .external_lex_state = 20},
  [7103] = {.lex_state = 353, .external_lex_state = 20},
  [7104] = {.lex_state = 356},
  [7105] = {.lex_state = 353},
  [7106] = {.lex_state = 353, .external_lex_state = 20},
  [7107] = {.lex_state = 356},
  [7108] = {.lex_state = 353, .external_lex_state = 20},
  [7109] = {.lex_state = 353, .external_lex_state = 20},
  [7110] = {.lex_state = 353, .external_lex_state = 20},
  [7111] = {.lex_state = 353, .external_lex_state = 20},
  [7112] = {.lex_state = 353},
  [7113] = {.lex_state = 353, .external_lex_state = 20},
  [7114] = {.lex_state = 353, .external_lex_state = 21},
  [7115] = {.lex_state = 356},
  [7116] = {.lex_state = 353, .external_lex_state = 20},
  [7117] = {.lex_state = 353, .external_lex_state = 20},
  [7118] = {.lex_state = 356},
  [7119] = {.lex_state = 353, .external_lex_state = 20},
  [7120] = {.lex_state = 353, .external_lex_state = 21},
  [7121] = {.lex_state = 356},
  [7122] = {.lex_state = 353, .external_lex_state = 20},
  [7123] = {.lex_state = 356},
  [7124] = {.lex_state = 353, .external_lex_state = 20},
  [7125] = {.lex_state = 356},
  [7126] = {.lex_state = 353, .external_lex_state = 20},
  [7127] = {.lex_state = 353, .external_lex_state = 20},
  [7128] = {.lex_state = 356},
  [7129] = {.lex_state = 353, .external_lex_state = 20},
  [7130] = {.lex_state = 356},
  [7131] = {.lex_state = 353, .external_lex_state = 21},
  [7132] = {.lex_state = 356},
  [7133] = {.lex_state = 356},
  [7134] = {.lex_state = 353, .external_lex_state = 20},
  [7135] = {.lex_state = 353},
  [7136] = {.lex_state = 353, .external_lex_state = 20},
  [7137] = {.lex_state = 353, .external_lex_state = 20},
  [7138] = {.lex_state = 353, .external_lex_state = 20},
  [7139] = {.lex_state = 353, .external_lex_state = 20},
  [7140] = {.lex_state = 353, .external_lex_state = 20},
  [7141] = {.lex_state = 356},
  [7142] = {.lex_state = 353, .external_lex_state = 20},
  [7143] = {.lex_state = 356},
  [7144] = {.lex_state = 353, .external_lex_state = 20},
  [7145] = {.lex_state = 356},
  [7146] = {.lex_state = 356},
  [7147] = {.lex_state = 353, .external_lex_state = 20},
  [7148] = {.lex_state = 353, .external_lex_state = 21},
  [7149] = {.lex_state = 353, .external_lex_state = 20},
  [7150] = {.lex_state = 138},
  [7151] = {.lex_state = 356},
  [7152] = {.lex_state = 353, .external_lex_state = 20},
  [7153] = {.lex_state = 353, .external_lex_state = 20},
  [7154] = {.lex_state = 356},
  [7155] = {.lex_state = 353},
  [7156] = {.lex_state = 353, .external_lex_state = 20},
  [7157] = {.lex_state = 353},
  [7158] = {.lex_state = 353, .external_lex_state = 16},
  [7159] = {.lex_state = 353},
  [7160] = {.lex_state = 353, .external_lex_state = 16},
  [7161] = {.lex_state = 353, .external_lex_state = 16},
  [7162] = {.lex_state = 356},
  [7163] = {.lex_state = 356},
  [7164] = {.lex_state = 356},
  [7165] = {.lex_state = 356},
  [7166] = {.lex_state = 356},
  [7167] = {.lex_state = 356},
  [7168] = {.lex_state = 353},
  [7169] = {.lex_state = 356},
  [7170] = {.lex_state = 353, .external_lex_state = 16},
  [7171] = {.lex_state = 356},
  [7172] = {.lex_state = 353},
  [7173] = {.lex_state = 353, .external_lex_state = 16},
  [7174] = {.lex_state = 353, .external_lex_state = 16},
  [7175] = {.lex_state = 353},
  [7176] = {.lex_state = 353, .external_lex_state = 16},
  [7177] = {.lex_state = 356, .external_lex_state = 22},
  [7178] = {.lex_state = 356},
  [7179] = {.lex_state = 1},
  [7180] = {.lex_state = 353},
  [7181] = {.lex_state = 353, .external_lex_state = 18},
  [7182] = {.lex_state = 353},
  [7183] = {.lex_state = 353},
  [7184] = {.lex_state = 353, .external_lex_state = 16},
  [7185] = {.lex_state = 353},
  [7186] = {.lex_state = 353},
  [7187] = {.lex_state = 353},
  [7188] = {.lex_state = 353},
  [7189] = {.lex_state = 353},
  [7190] = {.lex_state = 353},
  [7191] = {.lex_state = 353, .external_lex_state = 18},
  [7192] = {.lex_state = 138},
  [7193] = {.lex_state = 353},
  [7194] = {.lex_state = 353, .external_lex_state = 23},
  [7195] = {.lex_state = 353, .external_lex_state = 23},
  [7196] = {.lex_state = 356},
  [7197] = {.lex_state = 356, .external_lex_state = 22},
  [7198] = {.lex_state = 354},
  [7199] = {.lex_state = 353},
  [7200] = {.lex_state = 353},
  [7201] = {.lex_state = 353},
  [7202] = {.lex_state = 353},
  [7203] = {.lex_state = 353},
  [7204] = {.lex_state = 353},
  [7205] = {.lex_state = 1},
  [7206] = {.lex_state = 353},
  [7207] = {.lex_state = 1},
  [7208] = {.lex_state = 356},
  [7209] = {.lex_state = 356},
  [7210] = {.lex_state = 353, .external_lex_state = 16},
  [7211] = {.lex_state = 353},
  [7212] = {.lex_state = 354},
  [7213] = {.lex_state = 353, .external_lex_state = 16},
  [7214] = {.lex_state = 353, .external_lex_state = 16},
  [7215] = {.lex_state = 356},
  [7216] = {.lex_state = 1},
  [7217] = {.lex_state = 353},
  [7218] = {.lex_state = 353},
  [7219] = {.lex_state = 1},
  [7220] = {.lex_state = 353},
  [7221] = {.lex_state = 353},
  [7222] = {.lex_state = 356},
  [7223] = {.lex_state = 138},
  [7224] = {.lex_state = 353},
  [7225] = {.lex_state = 353},
  [7226] = {.lex_state = 138},
  [7227] = {.lex_state = 353},
  [7228] = {.lex_state = 354},
  [7229] = {.lex_state = 353},
  [7230] = {.lex_state = 356},
  [7231] = {.lex_state = 356},
  [7232] = {.lex_state = 353},
  [7233] = {.lex_state = 353},
  [7234] = {.lex_state = 353},
  [7235] = {.lex_state = 353, .external_lex_state = 16},
  [7236] = {.lex_state = 356},
  [7237] = {.lex_state = 356, .external_lex_state = 22},
  [7238] = {.lex_state = 353},
  [7239] = {.lex_state = 356},
  [7240] = {.lex_state = 356},
  [7241] = {.lex_state = 356},
  [7242] = {.lex_state = 356},
  [7243] = {.lex_state = 356},
  [7244] = {.lex_state = 356, .external_lex_state = 22},
  [7245] = {.lex_state = 353},
  [7246] = {.lex_state = 353},
  [7247] = {.lex_state = 353, .external_lex_state = 23},
  [7248] = {.lex_state = 353},
  [7249] = {.lex_state = 353, .external_lex_state = 23},
  [7250] = {.lex_state = 353, .external_lex_state = 16},
  [7251] = {.lex_state = 353, .external_lex_state = 16},
  [7252] = {.lex_state = 353},
  [7253] = {.lex_state = 353},
  [7254] = {.lex_state = 353, .external_lex_state = 16},
  [7255] = {.lex_state = 353},
  [7256] = {.lex_state = 353},
  [7257] = {.lex_state = 353},
  [7258] = {.lex_state = 353},
  [7259] = {.lex_state = 353},
  [7260] = {.lex_state = 353},
  [7261] = {.lex_state = 353, .external_lex_state = 16},
  [7262] = {.lex_state = 353},
  [7263] = {.lex_state = 353},
  [7264] = {.lex_state = 354},
  [7265] = {.lex_state = 353},
  [7266] = {.lex_state = 138},
  [7267] = {.lex_state = 353},
  [7268] = {.lex_state = 353, .external_lex_state = 23},
  [7269] = {.lex_state = 353, .external_lex_state = 23},
  [7270] = {.lex_state = 356},
  [7271] = {.lex_state = 356, .external_lex_state = 22},
  [7272] = {.lex_state = 353},
  [7273] = {.lex_state = 353, .external_lex_state = 18},
  [7274] = {.lex_state = 353, .external_lex_state = 18},
  [7275] = {.lex_state = 353},
  [7276] = {.lex_state = 353},
  [7277] = {.lex_state = 353, .external_lex_state = 16},
  [7278] = {.lex_state = 353},
  [7279] = {.lex_state = 353},
  [7280] = {.lex_state = 353},
  [7281] = {.lex_state = 353},
  [7282] = {.lex_state = 1},
  [7283] = {.lex_state = 353, .external_lex_state = 16},
  [7284] = {.lex_state = 353},
  [7285] = {.lex_state = 353},
  [7286] = {.lex_state = 353, .external_lex_state = 16},
  [7287] = {.lex_state = 353, .external_lex_state = 16},
  [7288] = {.lex_state = 353, .external_lex_state = 18},
  [7289] = {.lex_state = 353},
  [7290] = {.lex_state = 353},
  [7291] = {.lex_state = 353, .external_lex_state = 16},
  [7292] = {.lex_state = 353, .external_lex_state = 16},
  [7293] = {.lex_state = 353, .external_lex_state = 16},
  [7294] = {.lex_state = 353},
  [7295] = {.lex_state = 353, .external_lex_state = 16},
  [7296] = {.lex_state = 353},
  [7297] = {.lex_state = 356},
  [7298] = {.lex_state = 353, .external_lex_state = 18},
  [7299] = {.lex_state = 138},
  [7300] = {.lex_state = 356},
  [7301] = {.lex_state = 356},
  [7302] = {.lex_state = 353},
  [7303] = {.lex_state = 353},
  [7304] = {.lex_state = 356},
  [7305] = {.lex_state = 353, .external_lex_state = 16},
  [7306] = {.lex_state = 353},
  [7307] = {.lex_state = 353},
  [7308] = {.lex_state = 353},
  [7309] = {.lex_state = 354},
  [7310] = {.lex_state = 353},
  [7311] = {.lex_state = 356, .external_lex_state = 22},
  [7312] = {.lex_state = 356},
  [7313] = {.lex_state = 356},
  [7314] = {.lex_state = 353},
  [7315] = {.lex_state = 353},
  [7316] = {.lex_state = 353},
  [7317] = {.lex_state = 353},
  [7318] = {.lex_state = 353},
  [7319] = {.lex_state = 353},
  [7320] = {.lex_state = 353},
  [7321] = {.lex_state = 353},
  [7322] = {.lex_state = 353, .external_lex_state = 16},
  [7323] = {.lex_state = 353},
  [7324] = {.lex_state = 356},
  [7325] = {.lex_state = 353},
  [7326] = {.lex_state = 356},
  [7327] = {.lex_state = 353},
  [7328] = {.lex_state = 353, .external_lex_state = 23},
  [7329] = {.lex_state = 353, .external_lex_state = 23},
  [7330] = {.lex_state = 356},
  [7331] = {.lex_state = 356, .external_lex_state = 22},
  [7332] = {.lex_state = 353},
  [7333] = {.lex_state = 353},
  [7334] = {.lex_state = 354},
  [7335] = {.lex_state = 354},
  [7336] = {.lex_state = 353},
  [7337] = {.lex_state = 353},
  [7338] = {.lex_state = 353},
  [7339] = {.lex_state = 353},
  [7340] = {.lex_state = 356},
  [7341] = {.lex_state = 138},
  [7342] = {.lex_state = 1},
  [7343] = {.lex_state = 353},
  [7344] = {.lex_state = 353},
  [7345] = {.lex_state = 353},
  [7346] = {.lex_state = 353, .external_lex_state = 16},
  [7347] = {.lex_state = 353, .external_lex_state = 16},
  [7348] = {.lex_state = 353},
  [7349] = {.lex_state = 1},
  [7350] = {.lex_state = 354},
  [7351] = {.lex_state = 138},
  [7352] = {.lex_state = 353},
  [7353] = {.lex_state = 353},
  [7354] = {.lex_state = 356},
  [7355] = {.lex_state = 353},
  [7356] = {.lex_state = 356, .external_lex_state = 22},
  [7357] = {.lex_state = 1},
  [7358] = {.lex_state = 356},
  [7359] = {.lex_state = 356},
  [7360] = {.lex_state = 353},
  [7361] = {.lex_state = 356},
  [7362] = {.lex_state = 353},
  [7363] = {.lex_state = 353, .external_lex_state = 16},
  [7364] = {.lex_state = 353, .external_lex_state = 16},
  [7365] = {.lex_state = 356},
  [7366] = {.lex_state = 353},
  [7367] = {.lex_state = 353, .external_lex_state = 16},
  [7368] = {.lex_state = 356},
  [7369] = {.lex_state = 356},
  [7370] = {.lex_state = 356, .external_lex_state = 22},
  [7371] = {.lex_state = 353, .external_lex_state = 16},
  [7372] = {.lex_state = 356},
  [7373] = {.lex_state = 356},
  [7374] = {.lex_state = 353},
  [7375] = {.lex_state = 353},
  [7376] = {.lex_state = 356},
  [7377] = {.lex_state = 353},
  [7378] = {.lex_state = 353},
  [7379] = {.lex_state = 353},
  [7380] = {.lex_state = 353},
  [7381] = {.lex_state = 356},
  [7382] = {.lex_state = 356},
  [7383] = {.lex_state = 353},
  [7384] = {.lex_state = 353, .external_lex_state = 23},
  [7385] = {.lex_state = 353, .external_lex_state = 23},
  [7386] = {.lex_state = 356},
  [7387] = {.lex_state = 356, .external_lex_state = 22},
  [7388] = {.lex_state = 353, .external_lex_state = 16},
  [7389] = {.lex_state = 353},
  [7390] = {.lex_state = 353},
  [7391] = {.lex_state = 353, .external_lex_state = 16},
  [7392] = {.lex_state = 353},
  [7393] = {.lex_state = 353},
  [7394] = {.lex_state = 353},
  [7395] = {.lex_state = 353},
  [7396] = {.lex_state = 354},
  [7397] = {.lex_state = 353, .external_lex_state = 16},
  [7398] = {.lex_state = 1},
  [7399] = {.lex_state = 353},
  [7400] = {.lex_state = 353, .external_lex_state = 16},
  [7401] = {.lex_state = 353, .external_lex_state = 16},
  [7402] = {.lex_state = 138},
  [7403] = {.lex_state = 353, .external_lex_state = 18},
  [7404] = {.lex_state = 353, .external_lex_state = 16},
  [7405] = {.lex_state = 353, .external_lex_state = 16},
  [7406] = {.lex_state = 353, .external_lex_state = 16},
  [7407] = {.lex_state = 353},
  [7408] = {.lex_state = 353},
  [7409] = {.lex_state = 353},
  [7410] = {.lex_state = 353},
  [7411] = {.lex_state = 353, .external_lex_state = 16},
  [7412] = {.lex_state = 353},
  [7413] = {.lex_state = 356},
  [7414] = {.lex_state = 356},
  [7415] = {.lex_state = 353},
  [7416] = {.lex_state = 353},
  [7417] = {.lex_state = 1},
  [7418] = {.lex_state = 353, .external_lex_state = 16},
  [7419] = {.lex_state = 353, .external_lex_state = 18},
  [7420] = {.lex_state = 353},
  [7421] = {.lex_state = 353, .external_lex_state = 18},
  [7422] = {.lex_state = 353},
  [7423] = {.lex_state = 353, .external_lex_state = 16},
  [7424] = {.lex_state = 356, .external_lex_state = 22},
  [7425] = {.lex_state = 1},
  [7426] = {.lex_state = 353},
  [7427] = {.lex_state = 353, .external_lex_state = 16},
  [7428] = {.lex_state = 353},
  [7429] = {.lex_state = 353},
  [7430] = {.lex_state = 353},
  [7431] = {.lex_state = 353},
  [7432] = {.lex_state = 353},
  [7433] = {.lex_state = 353},
  [7434] = {.lex_state = 353},
  [7435] = {.lex_state = 353},
  [7436] = {.lex_state = 353, .external_lex_state = 18},
  [7437] = {.lex_state = 353},
  [7438] = {.lex_state = 353, .external_lex_state = 23},
  [7439] = {.lex_state = 353, .external_lex_state = 23},
  [7440] = {.lex_state = 356},
  [7441] = {.lex_state = 356, .external_lex_state = 22},
  [7442] = {.lex_state = 353},
  [7443] = {.lex_state = 353, .external_lex_state = 16},
  [7444] = {.lex_state = 356, .external_lex_state = 22},
  [7445] = {.lex_state = 353, .external_lex_state = 16},
  [7446] = {.lex_state = 353},
  [7447] = {.lex_state = 353, .external_lex_state = 16},
  [7448] = {.lex_state = 353, .external_lex_state = 16},
  [7449] = {.lex_state = 353},
  [7450] = {.lex_state = 353},
  [7451] = {.lex_state = 356},
  [7452] = {.lex_state = 1},
  [7453] = {.lex_state = 353, .external_lex_state = 23},
  [7454] = {.lex_state = 353, .external_lex_state = 16},
  [7455] = {.lex_state = 353, .external_lex_state = 16},
  [7456] = {.lex_state = 353, .external_lex_state = 23},
  [7457] = {.lex_state = 353, .external_lex_state = 16},
  [7458] = {.lex_state = 353, .external_lex_state = 18},
  [7459] = {.lex_state = 356},
  [7460] = {.lex_state = 138},
  [7461] = {.lex_state = 353},
  [7462] = {.lex_state = 356},
  [7463] = {.lex_state = 353},
  [7464] = {.lex_state = 356},
  [7465] = {.lex_state = 353, .external_lex_state = 16},
  [7466] = {.lex_state = 354},
  [7467] = {.lex_state = 356},
  [7468] = {.lex_state = 356},
  [7469] = {.lex_state = 353},
  [7470] = {.lex_state = 353},
  [7471] = {.lex_state = 356},
  [7472] = {.lex_state = 353, .external_lex_state = 16},
  [7473] = {.lex_state = 356},
  [7474] = {.lex_state = 353},
  [7475] = {.lex_state = 353, .external_lex_state = 16},
  [7476] = {.lex_state = 353},
  [7477] = {.lex_state = 353},
  [7478] = {.lex_state = 356, .external_lex_state = 22},
  [7479] = {.lex_state = 356},
  [7480] = {.lex_state = 356},
  [7481] = {.lex_state = 353},
  [7482] = {.lex_state = 353},
  [7483] = {.lex_state = 356},
  [7484] = {.lex_state = 353, .external_lex_state = 16},
  [7485] = {.lex_state = 353},
  [7486] = {.lex_state = 353},
  [7487] = {.lex_state = 353},
  [7488] = {.lex_state = 356},
  [7489] = {.lex_state = 356},
  [7490] = {.lex_state = 356},
  [7491] = {.lex_state = 356},
  [7492] = {.lex_state = 353, .external_lex_state = 23},
  [7493] = {.lex_state = 353, .external_lex_state = 23},
  [7494] = {.lex_state = 356},
  [7495] = {.lex_state = 356, .external_lex_state = 22},
  [7496] = {.lex_state = 356},
  [7497] = {.lex_state = 356},
  [7498] = {.lex_state = 356},
  [7499] = {.lex_state = 353},
  [7500] = {.lex_state = 353},
  [7501] = {.lex_state = 354},
  [7502] = {.lex_state = 356},
  [7503] = {.lex_state = 353},
  [7504] = {.lex_state = 353},
  [7505] = {.lex_state = 356},
  [7506] = {.lex_state = 1},
  [7507] = {.lex_state = 353, .external_lex_state = 16},
  [7508] = {.lex_state = 353, .external_lex_state = 16},
  [7509] = {.lex_state = 356},
  [7510] = {.lex_state = 356},
  [7511] = {.lex_state = 356},
  [7512] = {.lex_state = 356},
  [7513] = {.lex_state = 138},
  [7514] = {.lex_state = 353},
  [7515] = {.lex_state = 353},
  [7516] = {.lex_state = 356},
  [7517] = {.lex_state = 356},
  [7518] = {.lex_state = 354},
  [7519] = {.lex_state = 353},
  [7520] = {.lex_state = 356},
  [7521] = {.lex_state = 353, .external_lex_state = 16},
  [7522] = {.lex_state = 353},
  [7523] = {.lex_state = 353},
  [7524] = {.lex_state = 356, .external_lex_state = 22},
  [7525] = {.lex_state = 356},
  [7526] = {.lex_state = 356},
  [7527] = {.lex_state = 353},
  [7528] = {.lex_state = 356},
  [7529] = {.lex_state = 1},
  [7530] = {.lex_state = 356},
  [7531] = {.lex_state = 353},
  [7532] = {.lex_state = 353, .external_lex_state = 23},
  [7533] = {.lex_state = 353, .external_lex_state = 23},
  [7534] = {.lex_state = 356},
  [7535] = {.lex_state = 356, .external_lex_state = 22},
  [7536] = {.lex_state = 356},
  [7537] = {.lex_state = 356},
  [7538] = {.lex_state = 353},
  [7539] = {.lex_state = 356},
  [7540] = {.lex_state = 353},
  [7541] = {.lex_state = 353, .external_lex_state = 16},
  [7542] = {.lex_state = 356},
  [7543] = {.lex_state = 353},
  [7544] = {.lex_state = 356},
  [7545] = {.lex_state = 356},
  [7546] = {.lex_state = 1},
  [7547] = {.lex_state = 353, .external_lex_state = 16},
  [7548] = {.lex_state = 353, .external_lex_state = 16},
  [7549] = {.lex_state = 356},
  [7550] = {.lex_state = 354},
  [7551] = {.lex_state = 353, .external_lex_state = 16},
  [7552] = {.lex_state = 356},
  [7553] = {.lex_state = 353, .external_lex_state = 18},
  [7554] = {.lex_state = 353},
  [7555] = {.lex_state = 353},
  [7556] = {.lex_state = 356},
  [7557] = {.lex_state = 356},
  [7558] = {.lex_state = 353, .external_lex_state = 18},
  [7559] = {.lex_state = 353},
  [7560] = {.lex_state = 353},
  [7561] = {.lex_state = 353, .external_lex_state = 16},
  [7562] = {.lex_state = 356},
  [7563] = {.lex_state = 138},
  [7564] = {.lex_state = 356, .external_lex_state = 22},
  [7565] = {.lex_state = 356},
  [7566] = {.lex_state = 356},
  [7567] = {.lex_state = 353, .external_lex_state = 16},
  [7568] = {.lex_state = 356},
  [7569] = {.lex_state = 353, .external_lex_state = 16},
  [7570] = {.lex_state = 353, .external_lex_state = 23},
  [7571] = {.lex_state = 353, .external_lex_state = 23},
  [7572] = {.lex_state = 356},
  [7573] = {.lex_state = 356, .external_lex_state = 22},
  [7574] = {.lex_state = 356},
  [7575] = {.lex_state = 356},
  [7576] = {.lex_state = 353},
  [7577] = {.lex_state = 353},
  [7578] = {.lex_state = 353},
  [7579] = {.lex_state = 356},
  [7580] = {.lex_state = 353, .external_lex_state = 16},
  [7581] = {.lex_state = 353},
  [7582] = {.lex_state = 353, .external_lex_state = 16},
  [7583] = {.lex_state = 356},
  [7584] = {.lex_state = 1},
  [7585] = {.lex_state = 353, .external_lex_state = 16},
  [7586] = {.lex_state = 353, .external_lex_state = 16},
  [7587] = {.lex_state = 353},
  [7588] = {.lex_state = 353, .external_lex_state = 16},
  [7589] = {.lex_state = 353},
  [7590] = {.lex_state = 353},
  [7591] = {.lex_state = 353},
  [7592] = {.lex_state = 353, .external_lex_state = 16},
  [7593] = {.lex_state = 356},
  [7594] = {.lex_state = 356},
  [7595] = {.lex_state = 356},
  [7596] = {.lex_state = 353},
  [7597] = {.lex_state = 353},
  [7598] = {.lex_state = 353},
  [7599] = {.lex_state = 353, .external_lex_state = 16},
  [7600] = {.lex_state = 353},
  [7601] = {.lex_state = 353, .external_lex_state = 18},
  [7602] = {.lex_state = 356, .external_lex_state = 22},
  [7603] = {.lex_state = 353, .external_lex_state = 18},
  [7604] = {.lex_state = 353},
  [7605] = {.lex_state = 353},
  [7606] = {.lex_state = 353, .external_lex_state = 16},
  [7607] = {.lex_state = 353},
  [7608] = {.lex_state = 353, .external_lex_state = 23},
  [7609] = {.lex_state = 353, .external_lex_state = 23},
  [7610] = {.lex_state = 356},
  [7611] = {.lex_state = 356, .external_lex_state = 22},
  [7612] = {.lex_state = 353},
  [7613] = {.lex_state = 353},
  [7614] = {.lex_state = 353},
  [7615] = {.lex_state = 353},
  [7616] = {.lex_state = 353},
  [7617] = {.lex_state = 353},
  [7618] = {.lex_state = 353},
  [7619] = {.lex_state = 354},
  [7620] = {.lex_state = 356},
  [7621] = {.lex_state = 1},
  [7622] = {.lex_state = 353, .external_lex_state = 16},
  [7623] = {.lex_state = 353, .external_lex_state = 16},
  [7624] = {.lex_state = 356},
  [7625] = {.lex_state = 353},
  [7626] = {.lex_state = 353, .external_lex_state = 16},
  [7627] = {.lex_state = 353},
  [7628] = {.lex_state = 353, .external_lex_state = 16},
  [7629] = {.lex_state = 353, .external_lex_state = 16},
  [7630] = {.lex_state = 356},
  [7631] = {.lex_state = 353},
  [7632] = {.lex_state = 353},
  [7633] = {.lex_state = 353},
  [7634] = {.lex_state = 138},
  [7635] = {.lex_state = 353, .external_lex_state = 16},
  [7636] = {.lex_state = 353, .external_lex_state = 18},
  [7637] = {.lex_state = 353},
  [7638] = {.lex_state = 356, .external_lex_state = 22},
  [7639] = {.lex_state = 353},
  [7640] = {.lex_state = 356},
  [7641] = {.lex_state = 353, .external_lex_state = 18},
  [7642] = {.lex_state = 138},
  [7643] = {.lex_state = 353},
  [7644] = {.lex_state = 353, .external_lex_state = 23},
  [7645] = {.lex_state = 353, .external_lex_state = 23},
  [7646] = {.lex_state = 356},
  [7647] = {.lex_state = 356, .external_lex_state = 22},
  [7648] = {.lex_state = 356},
  [7649] = {.lex_state = 353, .external_lex_state = 16},
  [7650] = {.lex_state = 354},
  [7651] = {.lex_state = 353},
  [7652] = {.lex_state = 353},
  [7653] = {.lex_state = 356},
  [7654] = {.lex_state = 353},
  [7655] = {.lex_state = 353},
  [7656] = {.lex_state = 353},
  [7657] = {.lex_state = 1},
  [7658] = {.lex_state = 353, .external_lex_state = 16},
  [7659] = {.lex_state = 353, .external_lex_state = 16},
  [7660] = {.lex_state = 353},
  [7661] = {.lex_state = 353},
  [7662] = {.lex_state = 353},
  [7663] = {.lex_state = 353},
  [7664] = {.lex_state = 353},
  [7665] = {.lex_state = 353},
  [7666] = {.lex_state = 356},
  [7667] = {.lex_state = 353},
  [7668] = {.lex_state = 353},
  [7669] = {.lex_state = 353},
  [7670] = {.lex_state = 353, .external_lex_state = 16},
  [7671] = {.lex_state = 353, .external_lex_state = 16},
  [7672] = {.lex_state = 353, .external_lex_state = 16},
  [7673] = {.lex_state = 356},
  [7674] = {.lex_state = 356, .external_lex_state = 22},
  [7675] = {.lex_state = 356},
  [7676] = {.lex_state = 353, .external_lex_state = 23},
  [7677] = {.lex_state = 353, .external_lex_state = 23},
  [7678] = {.lex_state = 356},
  [7679] = {.lex_state = 356},
  [7680] = {.lex_state = 356},
  [7681] = {.lex_state = 353},
  [7682] = {.lex_state = 353},
  [7683] = {.lex_state = 353},
  [7684] = {.lex_state = 353},
  [7685] = {.lex_state = 354},
  [7686] = {.lex_state = 353},
  [7687] = {.lex_state = 353, .external_lex_state = 18},
  [7688] = {.lex_state = 353},
  [7689] = {.lex_state = 353, .external_lex_state = 23},
  [7690] = {.lex_state = 353, .external_lex_state = 23},
  [7691] = {.lex_state = 356},
  [7692] = {.lex_state = 353},
  [7693] = {.lex_state = 353},
  [7694] = {.lex_state = 353},
  [7695] = {.lex_state = 356},
  [7696] = {.lex_state = 354},
  [7697] = {.lex_state = 138},
  [7698] = {.lex_state = 353},
  [7699] = {.lex_state = 353, .external_lex_state = 23},
  [7700] = {.lex_state = 353, .external_lex_state = 23},
  [7701] = {.lex_state = 356},
  [7702] = {.lex_state = 353},
  [7703] = {.lex_state = 353},
  [7704] = {.lex_state = 353},
  [7705] = {.lex_state = 354},
  [7706] = {.lex_state = 353},
  [7707] = {.lex_state = 353},
  [7708] = {.lex_state = 138},
  [7709] = {.lex_state = 353, .external_lex_state = 23},
  [7710] = {.lex_state = 353, .external_lex_state = 23},
  [7711] = {.lex_state = 356},
  [7712] = {.lex_state = 353},
  [7713] = {.lex_state = 356},
  [7714] = {.lex_state = 353},
  [7715] = {.lex_state = 1},
  [7716] = {.lex_state = 356},
  [7717] = {.lex_state = 356},
  [7718] = {.lex_state = 353, .external_lex_state = 23},
  [7719] = {.lex_state = 353, .external_lex_state = 23},
  [7720] = {.lex_state = 356},
  [7721] = {.lex_state = 356},
  [7722] = {.lex_state = 353},
  [7723] = {.lex_state = 353, .external_lex_state = 16},
  [7724] = {.lex_state = 353},
  [7725] = {.lex_state = 353},
  [7726] = {.lex_state = 353, .external_lex_state = 23},
  [7727] = {.lex_state = 353, .external_lex_state = 23},
  [7728] = {.lex_state = 356},
  [7729] = {.lex_state = 356},
  [7730] = {.lex_state = 353, .external_lex_state = 16},
  [7731] = {.lex_state = 353, .external_lex_state = 23},
  [7732] = {.lex_state = 353, .external_lex_state = 23},
  [7733] = {.lex_state = 356},
  [7734] = {.lex_state = 356},
  [7735] = {.lex_state = 356},
  [7736] = {.lex_state = 353, .external_lex_state = 23},
  [7737] = {.lex_state = 353, .external_lex_state = 23},
  [7738] = {.lex_state = 356},
  [7739] = {.lex_state = 353, .external_lex_state = 18},
  [7740] = {.lex_state = 353},
  [7741] = {.lex_state = 353, .external_lex_state = 23},
  [7742] = {.lex_state = 353, .external_lex_state = 23},
  [7743] = {.lex_state = 353, .external_lex_state = 16},
  [7744] = {.lex_state = 353, .external_lex_state = 18},
  [7745] = {.lex_state = 356},
  [7746] = {.lex_state = 353, .external_lex_state = 23},
  [7747] = {.lex_state = 353, .external_lex_state = 23},
  [7748] = {.lex_state = 353},
  [7749] = {.lex_state = 353},
  [7750] = {.lex_state = 353, .external_lex_state = 16},
  [7751] = {.lex_state = 353},
  [7752] = {.lex_state = 353, .external_lex_state = 16},
  [7753] = {.lex_state = 356},
  [7754] = {.lex_state = 356},
  [7755] = {.lex_state = 353},
  [7756] = {.lex_state = 353},
  [7757] = {.lex_state = 353, .external_lex_state = 16},
  [7758] = {.lex_state = 353},
  [7759] = {.lex_state = 354},
  [7760] = {.lex_state = 353},
  [7761] = {.lex_state = 353},
  [7762] = {.lex_state = 353, .external_lex_state = 16},
  [7763] = {.lex_state = 353},
  [7764] = {.lex_state = 353},
  [7765] = {.lex_state = 353},
  [7766] = {.lex_state = 353, .external_lex_state = 18},
  [7767] = {.lex_state = 353, .external_lex_state = 18},
  [7768] = {.lex_state = 353},
  [7769] = {.lex_state = 353, .external_lex_state = 16},
  [7770] = {.lex_state = 353},
  [7771] = {.lex_state = 138},
  [7772] = {.lex_state = 353, .external_lex_state = 18},
  [7773] = {.lex_state = 353},
  [7774] = {.lex_state = 353},
  [7775] = {.lex_state = 356},
  [7776] = {.lex_state = 356},
  [7777] = {.lex_state = 353},
  [7778] = {.lex_state = 353},
  [7779] = {.lex_state = 353, .external_lex_state = 16},
  [7780] = {.lex_state = 353, .external_lex_state = 16},
  [7781] = {.lex_state = 353, .external_lex_state = 16},
  [7782] = {.lex_state = 353},
  [7783] = {.lex_state = 353},
  [7784] = {.lex_state = 353, .external_lex_state = 16},
  [7785] = {.lex_state = 353, .external_lex_state = 18},
  [7786] = {.lex_state = 138},
  [7787] = {.lex_state = 353},
  [7788] = {.lex_state = 353},
  [7789] = {.lex_state = 353},
  [7790] = {.lex_state = 354},
  [7791] = {.lex_state = 353},
  [7792] = {.lex_state = 356},
  [7793] = {.lex_state = 353, .external_lex_state = 18},
  [7794] = {.lex_state = 353},
  [7795] = {.lex_state = 353},
  [7796] = {.lex_state = 353},
  [7797] = {.lex_state = 353},
  [7798] = {.lex_state = 353},
  [7799] = {.lex_state = 353, .external_lex_state = 16},
  [7800] = {.lex_state = 353},
  [7801] = {.lex_state = 353, .external_lex_state = 16},
  [7802] = {.lex_state = 356},
  [7803] = {.lex_state = 356},
  [7804] = {.lex_state = 356},
  [7805] = {.lex_state = 353},
  [7806] = {.lex_state = 354},
  [7807] = {.lex_state = 353},
  [7808] = {.lex_state = 353},
  [7809] = {.lex_state = 353, .external_lex_state = 20},
  [7810] = {.lex_state = 356},
  [7811] = {.lex_state = 356},
  [7812] = {.lex_state = 356},
  [7813] = {.lex_state = 353},
  [7814] = {.lex_state = 353},
  [7815] = {.lex_state = 356},
  [7816] = {.lex_state = 138},
  [7817] = {.lex_state = 353, .external_lex_state = 20},
  [7818] = {.lex_state = 353, .external_lex_state = 20},
  [7819] = {.lex_state = 353, .external_lex_state = 20},
  [7820] = {.lex_state = 353, .external_lex_state = 20},
  [7821] = {.lex_state = 353},
  [7822] = {.lex_state = 353},
  [7823] = {.lex_state = 354},
  [7824] = {.lex_state = 353},
  [7825] = {.lex_state = 353},
  [7826] = {.lex_state = 356},
  [7827] = {.lex_state = 353},
  [7828] = {.lex_state = 353, .external_lex_state = 20},
  [7829] = {.lex_state = 1},
  [7830] = {.lex_state = 356},
  [7831] = {.lex_state = 356},
  [7832] = {.lex_state = 353},
  [7833] = {.lex_state = 353, .external_lex_state = 20},
  [7834] = {.lex_state = 356},
  [7835] = {.lex_state = 353},
  [7836] = {.lex_state = 353, .external_lex_state = 20},
  [7837] = {.lex_state = 354},
  [7838] = {.lex_state = 353},
  [7839] = {.lex_state = 353},
  [7840] = {.lex_state = 353},
  [7841] = {.lex_state = 353, .external_lex_state = 20},
  [7842] = {.lex_state = 356},
  [7843] = {.lex_state = 353, .external_lex_state = 20},
  [7844] = {.lex_state = 356},
  [7845] = {.lex_state = 356},
  [7846] = {.lex_state = 356},
  [7847] = {.lex_state = 353, .external_lex_state = 20},
  [7848] = {.lex_state = 353},
  [7849] = {.lex_state = 138},
  [7850] = {.lex_state = 356},
  [7851] = {.lex_state = 353, .external_lex_state = 20},
  [7852] = {.lex_state = 353},
  [7853] = {.lex_state = 353},
  [7854] = {.lex_state = 353},
  [7855] = {.lex_state = 356},
  [7856] = {.lex_state = 353},
  [7857] = {.lex_state = 353, .external_lex_state = 16},
  [7858] = {.lex_state = 356},
  [7859] = {.lex_state = 157},
  [7860] = {.lex_state = 353},
  [7861] = {.lex_state = 353},
  [7862] = {.lex_state = 353, .external_lex_state = 16},
  [7863] = {.lex_state = 356},
  [7864] = {.lex_state = 356},
  [7865] = {.lex_state = 353},
  [7866] = {.lex_state = 353},
  [7867] = {.lex_state = 353},
  [7868] = {.lex_state = 353},
  [7869] = {.lex_state = 353},
  [7870] = {.lex_state = 353},
  [7871] = {.lex_state = 353},
  [7872] = {.lex_state = 353},
  [7873] = {.lex_state = 354},
  [7874] = {.lex_state = 353},
  [7875] = {.lex_state = 356},
  [7876] = {.lex_state = 353, .external_lex_state = 20},
  [7877] = {.lex_state = 356},
  [7878] = {.lex_state = 356},
  [7879] = {.lex_state = 356},
  [7880] = {.lex_state = 356},
  [7881] = {.lex_state = 138},
  [7882] = {.lex_state = 353, .external_lex_state = 18},
  [7883] = {.lex_state = 353},
  [7884] = {.lex_state = 353, .external_lex_state = 20},
  [7885] = {.lex_state = 353, .external_lex_state = 20},
  [7886] = {.lex_state = 353, .external_lex_state = 20},
  [7887] = {.lex_state = 353, .external_lex_state = 20},
  [7888] = {.lex_state = 354},
  [7889] = {.lex_state = 353},
  [7890] = {.lex_state = 138},
  [7891] = {.lex_state = 353},
  [7892] = {.lex_state = 353, .external_lex_state = 18},
  [7893] = {.lex_state = 353, .external_lex_state = 16},
  [7894] = {.lex_state = 353},
  [7895] = {.lex_state = 353, .external_lex_state = 20},
  [7896] = {.lex_state = 353, .external_lex_state = 18},
  [7897] = {.lex_state = 1},
  [7898] = {.lex_state = 356},
  [7899] = {.lex_state = 353},
  [7900] = {.lex_state = 353, .external_lex_state = 20},
  [7901] = {.lex_state = 356},
  [7902] = {.lex_state = 1},
  [7903] = {.lex_state = 353, .external_lex_state = 20},
  [7904] = {.lex_state = 353, .external_lex_state = 18},
  [7905] = {.lex_state = 353},
  [7906] = {.lex_state = 353},
  [7907] = {.lex_state = 356},
  [7908] = {.lex_state = 353, .external_lex_state = 20},
  [7909] = {.lex_state = 356},
  [7910] = {.lex_state = 353, .external_lex_state = 20},
  [7911] = {.lex_state = 138},
  [7912] = {.lex_state = 353},
  [7913] = {.lex_state = 356},
  [7914] = {.lex_state = 353, .external_lex_state = 20},
  [7915] = {.lex_state = 353},
  [7916] = {.lex_state = 353, .external_lex_state = 18},
  [7917] = {.lex_state = 353, .external_lex_state = 20},
  [7918] = {.lex_state = 353},
  [7919] = {.lex_state = 353, .external_lex_state = 18},
  [7920] = {.lex_state = 353},
  [7921] = {.lex_state = 356},
  [7922] = {.lex_state = 353, .external_lex_state = 18},
  [7923] = {.lex_state = 353, .external_lex_state = 16},
  [7924] = {.lex_state = 356},
  [7925] = {.lex_state = 157},
  [7926] = {.lex_state = 353, .external_lex_state = 18},
  [7927] = {.lex_state = 353},
  [7928] = {.lex_state = 353, .external_lex_state = 18},
  [7929] = {.lex_state = 353, .external_lex_state = 18},
  [7930] = {.lex_state = 353, .external_lex_state = 18},
  [7931] = {.lex_state = 353},
  [7932] = {.lex_state = 353, .external_lex_state = 20},
  [7933] = {.lex_state = 356},
  [7934] = {.lex_state = 356},
  [7935] = {.lex_state = 356},
  [7936] = {.lex_state = 353, .external_lex_state = 18},
  [7937] = {.lex_state = 353, .external_lex_state = 18},
  [7938] = {.lex_state = 353, .external_lex_state = 18},
  [7939] = {.lex_state = 353, .external_lex_state = 20},
  [7940] = {.lex_state = 353, .external_lex_state = 20},
  [7941] = {.lex_state = 353, .external_lex_state = 20},
  [7942] = {.lex_state = 353, .external_lex_state = 20},
  [7943] = {.lex_state = 353, .external_lex_state = 18},
  [7944] = {.lex_state = 353, .external_lex_state = 18},
  [7945] = {.lex_state = 353, .external_lex_state = 18},
  [7946] = {.lex_state = 356, .external_lex_state = 22},
  [7947] = {.lex_state = 353, .external_lex_state = 16},
  [7948] = {.lex_state = 353},
  [7949] = {.lex_state = 353, .external_lex_state = 20},
  [7950] = {.lex_state = 356},
  [7951] = {.lex_state = 353, .external_lex_state = 16},
  [7952] = {.lex_state = 356},
  [7953] = {.lex_state = 356},
  [7954] = {.lex_state = 353, .external_lex_state = 20},
  [7955] = {.lex_state = 356},
  [7956] = {.lex_state = 353},
  [7957] = {.lex_state = 353, .external_lex_state = 20},
  [7958] = {.lex_state = 353},
  [7959] = {.lex_state = 353},
  [7960] = {.lex_state = 353},
  [7961] = {.lex_state = 353},
  [7962] = {.lex_state = 353, .external_lex_state = 20},
  [7963] = {.lex_state = 353},
  [7964] = {.lex_state = 138},
  [7965] = {.lex_state = 356},
  [7966] = {.lex_state = 353, .external_lex_state = 20},
  [7967] = {.lex_state = 353},
  [7968] = {.lex_state = 353},
  [7969] = {.lex_state = 353, .external_lex_state = 20},
  [7970] = {.lex_state = 353},
  [7971] = {.lex_state = 353, .external_lex_state = 16},
  [7972] = {.lex_state = 353},
  [7973] = {.lex_state = 356},
  [7974] = {.lex_state = 1},
  [7975] = {.lex_state = 353, .external_lex_state = 16},
  [7976] = {.lex_state = 356},
  [7977] = {.lex_state = 157},
  [7978] = {.lex_state = 138},
  [7979] = {.lex_state = 353},
  [7980] = {.lex_state = 356},
  [7981] = {.lex_state = 353},
  [7982] = {.lex_state = 356},
  [7983] = {.lex_state = 353, .external_lex_state = 20},
  [7984] = {.lex_state = 356},
  [7985] = {.lex_state = 356},
  [7986] = {.lex_state = 138},
  [7987] = {.lex_state = 353},
  [7988] = {.lex_state = 353},
  [7989] = {.lex_state = 353, .external_lex_state = 20},
  [7990] = {.lex_state = 353, .external_lex_state = 20},
  [7991] = {.lex_state = 356},
  [7992] = {.lex_state = 353, .external_lex_state = 16},
  [7993] = {.lex_state = 353, .external_lex_state = 16},
  [7994] = {.lex_state = 353},
  [7995] = {.lex_state = 353},
  [7996] = {.lex_state = 1},
  [7997] = {.lex_state = 353},
  [7998] = {.lex_state = 356},
  [7999] = {.lex_state = 353},
  [8000] = {.lex_state = 356},
  [8001] = {.lex_state = 353},
  [8002] = {.lex_state = 353},
  [8003] = {.lex_state = 353, .external_lex_state = 20},
  [8004] = {.lex_state = 353},
  [8005] = {.lex_state = 353},
  [8006] = {.lex_state = 356},
  [8007] = {.lex_state = 353, .external_lex_state = 20},
  [8008] = {.lex_state = 356},
  [8009] = {.lex_state = 356},
  [8010] = {.lex_state = 353},
  [8011] = {.lex_state = 353, .external_lex_state = 16},
  [8012] = {.lex_state = 356},
  [8013] = {.lex_state = 353},
  [8014] = {.lex_state = 356},
  [8015] = {.lex_state = 356},
  [8016] = {.lex_state = 356},
  [8017] = {.lex_state = 356},
  [8018] = {.lex_state = 353, .external_lex_state = 20},
  [8019] = {.lex_state = 356},
  [8020] = {.lex_state = 356},
  [8021] = {.lex_state = 356},
  [8022] = {.lex_state = 356},
  [8023] = {.lex_state = 356},
  [8024] = {.lex_state = 353, .external_lex_state = 20},
  [8025] = {.lex_state = 356},
  [8026] = {.lex_state = 353, .external_lex_state = 18},
  [8027] = {.lex_state = 353},
  [8028] = {.lex_state = 138},
  [8029] = {.lex_state = 353},
  [8030] = {.lex_state = 353},
  [8031] = {.lex_state = 356},
  [8032] = {.lex_state = 356},
  [8033] = {.lex_state = 353},
  [8034] = {.lex_state = 356},
  [8035] = {.lex_state = 353},
  [8036] = {.lex_state = 138},
  [8037] = {.lex_state = 353, .external_lex_state = 20},
  [8038] = {.lex_state = 356},
  [8039] = {.lex_state = 353},
  [8040] = {.lex_state = 356},
  [8041] = {.lex_state = 353, .external_lex_state = 20},
  [8042] = {.lex_state = 353},
  [8043] = {.lex_state = 353},
  [8044] = {.lex_state = 353, .external_lex_state = 18},
  [8045] = {.lex_state = 356},
  [8046] = {.lex_state = 356},
  [8047] = {.lex_state = 356},
  [8048] = {.lex_state = 138},
  [8049] = {.lex_state = 353, .external_lex_state = 18},
  [8050] = {.lex_state = 353},
  [8051] = {.lex_state = 353, .external_lex_state = 20},
  [8052] = {.lex_state = 356},
  [8053] = {.lex_state = 356},
  [8054] = {.lex_state = 353},
  [8055] = {.lex_state = 353},
  [8056] = {.lex_state = 353},
  [8057] = {.lex_state = 353, .external_lex_state = 20},
  [8058] = {.lex_state = 356},
  [8059] = {.lex_state = 353},
  [8060] = {.lex_state = 353},
  [8061] = {.lex_state = 353},
  [8062] = {.lex_state = 157},
  [8063] = {.lex_state = 157},
  [8064] = {.lex_state = 353},
  [8065] = {.lex_state = 356},
  [8066] = {.lex_state = 353, .external_lex_state = 16},
  [8067] = {.lex_state = 356},
  [8068] = {.lex_state = 353, .external_lex_state = 16},
  [8069] = {.lex_state = 353},
  [8070] = {.lex_state = 353, .external_lex_state = 20},
  [8071] = {.lex_state = 353, .external_lex_state = 18},
  [8072] = {.lex_state = 356},
  [8073] = {.lex_state = 356},
  [8074] = {.lex_state = 353, .external_lex_state = 20},
  [8075] = {.lex_state = 353},
  [8076] = {.lex_state = 353},
  [8077] = {.lex_state = 353},
  [8078] = {.lex_state = 356},
  [8079] = {.lex_state = 353, .external_lex_state = 16},
  [8080] = {.lex_state = 356},
  [8081] = {.lex_state = 353},
  [8082] = {.lex_state = 353},
  [8083] = {.lex_state = 353},
  [8084] = {.lex_state = 353, .external_lex_state = 20},
  [8085] = {.lex_state = 356},
  [8086] = {.lex_state = 356},
  [8087] = {.lex_state = 353, .external_lex_state = 16},
  [8088] = {.lex_state = 353, .external_lex_state = 16},
  [8089] = {.lex_state = 353},
  [8090] = {.lex_state = 353, .external_lex_state = 20},
  [8091] = {.lex_state = 138},
  [8092] = {.lex_state = 353},
  [8093] = {.lex_state = 354},
  [8094] = {.lex_state = 353, .external_lex_state = 16},
  [8095] = {.lex_state = 356},
  [8096] = {.lex_state = 353},
  [8097] = {.lex_state = 356},
  [8098] = {.lex_state = 356},
  [8099] = {.lex_state = 353},
  [8100] = {.lex_state = 356},
  [8101] = {.lex_state = 356},
  [8102] = {.lex_state = 138},
  [8103] = {.lex_state = 353, .external_lex_state = 20},
  [8104] = {.lex_state = 353, .external_lex_state = 18},
  [8105] = {.lex_state = 353},
  [8106] = {.lex_state = 356},
  [8107] = {.lex_state = 353, .external_lex_state = 20},
  [8108] = {.lex_state = 353, .external_lex_state = 16},
  [8109] = {.lex_state = 353, .external_lex_state = 16},
  [8110] = {.lex_state = 353},
  [8111] = {.lex_state = 356},
  [8112] = {.lex_state = 353},
  [8113] = {.lex_state = 356},
  [8114] = {.lex_state = 353},
  [8115] = {.lex_state = 354},
  [8116] = {.lex_state = 356},
  [8117] = {.lex_state = 353, .external_lex_state = 20},
  [8118] = {.lex_state = 356},
  [8119] = {.lex_state = 356},
  [8120] = {.lex_state = 353, .external_lex_state = 16},
  [8121] = {.lex_state = 353},
  [8122] = {.lex_state = 353},
  [8123] = {.lex_state = 353, .external_lex_state = 20},
  [8124] = {.lex_state = 353},
  [8125] = {.lex_state = 356},
  [8126] = {.lex_state = 356},
  [8127] = {.lex_state = 138},
  [8128] = {.lex_state = 356},
  [8129] = {.lex_state = 353},
  [8130] = {.lex_state = 353},
  [8131] = {.lex_state = 353},
  [8132] = {.lex_state = 353, .external_lex_state = 16},
  [8133] = {.lex_state = 353},
  [8134] = {.lex_state = 353, .external_lex_state = 20},
  [8135] = {.lex_state = 356},
  [8136] = {.lex_state = 356},
  [8137] = {.lex_state = 1},
  [8138] = {.lex_state = 138},
  [8139] = {.lex_state = 356},
  [8140] = {.lex_state = 353, .external_lex_state = 20},
  [8141] = {.lex_state = 138},
  [8142] = {.lex_state = 353, .external_lex_state = 16},
  [8143] = {.lex_state = 353},
  [8144] = {.lex_state = 353},
  [8145] = {.lex_state = 353},
  [8146] = {.lex_state = 356},
  [8147] = {.lex_state = 353},
  [8148] = {.lex_state = 356, .external_lex_state = 22},
  [8149] = {.lex_state = 138},
  [8150] = {.lex_state = 353, .external_lex_state = 20},
  [8151] = {.lex_state = 356},
  [8152] = {.lex_state = 356},
  [8153] = {.lex_state = 353},
  [8154] = {.lex_state = 353, .external_lex_state = 20},
  [8155] = {.lex_state = 353, .external_lex_state = 18},
  [8156] = {.lex_state = 353, .external_lex_state = 20},
  [8157] = {.lex_state = 353, .external_lex_state = 18},
  [8158] = {.lex_state = 356},
  [8159] = {.lex_state = 353},
  [8160] = {.lex_state = 353, .external_lex_state = 16},
  [8161] = {.lex_state = 353},
  [8162] = {.lex_state = 353},
  [8163] = {.lex_state = 353},
  [8164] = {.lex_state = 353},
  [8165] = {.lex_state = 353},
  [8166] = {.lex_state = 353, .external_lex_state = 20},
  [8167] = {.lex_state = 356},
  [8168] = {.lex_state = 356},
  [8169] = {.lex_state = 356},
  [8170] = {.lex_state = 356},
  [8171] = {.lex_state = 354},
  [8172] = {.lex_state = 353, .external_lex_state = 20},
  [8173] = {.lex_state = 353},
  [8174] = {.lex_state = 353},
  [8175] = {.lex_state = 138},
  [8176] = {.lex_state = 353, .external_lex_state = 18},
  [8177] = {.lex_state = 353, .external_lex_state = 20},
  [8178] = {.lex_state = 353},
  [8179] = {.lex_state = 353},
  [8180] = {.lex_state = 353},
  [8181] = {.lex_state = 353, .external_lex_state = 20},
  [8182] = {.lex_state = 356},
  [8183] = {.lex_state = 356},
  [8184] = {.lex_state = 353, .external_lex_state = 20},
  [8185] = {.lex_state = 356},
  [8186] = {.lex_state = 353},
  [8187] = {.lex_state = 353, .external_lex_state = 20},
  [8188] = {.lex_state = 353, .external_lex_state = 20},
  [8189] = {.lex_state = 353},
  [8190] = {.lex_state = 356},
  [8191] = {.lex_state = 138},
  [8192] = {.lex_state = 353},
  [8193] = {.lex_state = 356},
  [8194] = {.lex_state = 353, .external_lex_state = 16},
  [8195] = {.lex_state = 353},
  [8196] = {.lex_state = 356},
  [8197] = {.lex_state = 356},
  [8198] = {.lex_state = 356},
  [8199] = {.lex_state = 353},
  [8200] = {.lex_state = 356},
  [8201] = {.lex_state = 353, .external_lex_state = 20},
  [8202] = {.lex_state = 353, .external_lex_state = 20},
  [8203] = {.lex_state = 353, .external_lex_state = 16},
  [8204] = {.lex_state = 353, .external_lex_state = 16},
  [8205] = {.lex_state = 353, .external_lex_state = 16},
  [8206] = {.lex_state = 353, .external_lex_state = 16},
  [8207] = {.lex_state = 353},
  [8208] = {.lex_state = 353},
  [8209] = {.lex_state = 353, .external_lex_state = 16},
  [8210] = {.lex_state = 356},
  [8211] = {.lex_state = 356},
  [8212] = {.lex_state = 353},
  [8213] = {.lex_state = 353, .external_lex_state = 20},
  [8214] = {.lex_state = 356},
  [8215] = {.lex_state = 353, .external_lex_state = 20},
  [8216] = {.lex_state = 356},
  [8217] = {.lex_state = 353, .external_lex_state = 18},
  [8218] = {.lex_state = 353},
  [8219] = {.lex_state = 356},
  [8220] = {.lex_state = 356},
  [8221] = {.lex_state = 353},
  [8222] = {.lex_state = 353},
  [8223] = {.lex_state = 353, .external_lex_state = 20},
  [8224] = {.lex_state = 353, .external_lex_state = 20},
  [8225] = {.lex_state = 356},
  [8226] = {.lex_state = 138},
  [8227] = {.lex_state = 353, .external_lex_state = 16},
  [8228] = {.lex_state = 353},
  [8229] = {.lex_state = 353},
  [8230] = {.lex_state = 356},
  [8231] = {.lex_state = 353, .external_lex_state = 20},
  [8232] = {.lex_state = 353},
  [8233] = {.lex_state = 353, .external_lex_state = 18},
  [8234] = {.lex_state = 356},
  [8235] = {.lex_state = 138},
  [8236] = {.lex_state = 353},
  [8237] = {.lex_state = 356},
  [8238] = {.lex_state = 353, .external_lex_state = 20},
  [8239] = {.lex_state = 353, .external_lex_state = 20},
  [8240] = {.lex_state = 353},
  [8241] = {.lex_state = 353},
  [8242] = {.lex_state = 353},
  [8243] = {.lex_state = 353, .external_lex_state = 16},
  [8244] = {.lex_state = 353},
  [8245] = {.lex_state = 356},
  [8246] = {.lex_state = 356},
  [8247] = {.lex_state = 356},
  [8248] = {.lex_state = 353},
  [8249] = {.lex_state = 356},
  [8250] = {.lex_state = 353},
  [8251] = {.lex_state = 356},
  [8252] = {.lex_state = 356},
  [8253] = {.lex_state = 353, .external_lex_state = 20},
  [8254] = {.lex_state = 353, .external_lex_state = 20},
  [8255] = {.lex_state = 354},
  [8256] = {.lex_state = 353},
  [8257] = {.lex_state = 138},
  [8258] = {.lex_state = 353, .external_lex_state = 20},
  [8259] = {.lex_state = 353, .external_lex_state = 20},
  [8260] = {.lex_state = 353},
  [8261] = {.lex_state = 356},
  [8262] = {.lex_state = 353},
  [8263] = {.lex_state = 353, .external_lex_state = 20},
  [8264] = {.lex_state = 353, .external_lex_state = 20},
  [8265] = {.lex_state = 353},
  [8266] = {.lex_state = 356},
  [8267] = {.lex_state = 353, .external_lex_state = 20},
  [8268] = {.lex_state = 353, .external_lex_state = 20},
  [8269] = {.lex_state = 353, .external_lex_state = 20},
  [8270] = {.lex_state = 353},
  [8271] = {.lex_state = 353},
  [8272] = {.lex_state = 356},
  [8273] = {.lex_state = 353, .external_lex_state = 20},
  [8274] = {.lex_state = 353, .external_lex_state = 20},
  [8275] = {.lex_state = 353},
  [8276] = {.lex_state = 353},
  [8277] = {.lex_state = 356},
  [8278] = {.lex_state = 353, .external_lex_state = 20},
  [8279] = {.lex_state = 353, .external_lex_state = 20},
  [8280] = {.lex_state = 353},
  [8281] = {.lex_state = 353},
  [8282] = {.lex_state = 353},
  [8283] = {.lex_state = 353, .external_lex_state = 20},
  [8284] = {.lex_state = 353, .external_lex_state = 20},
  [8285] = {.lex_state = 353},
  [8286] = {.lex_state = 138},
  [8287] = {.lex_state = 353, .external_lex_state = 20},
  [8288] = {.lex_state = 353, .external_lex_state = 20},
  [8289] = {.lex_state = 353, .external_lex_state = 20},
  [8290] = {.lex_state = 353, .external_lex_state = 24},
  [8291] = {.lex_state = 598},
  [8292] = {.lex_state = 356},
  [8293] = {.lex_state = 353, .external_lex_state = 20},
  [8294] = {.lex_state = 353, .external_lex_state = 20},
  [8295] = {.lex_state = 353},
  [8296] = {.lex_state = 353},
  [8297] = {.lex_state = 353},
  [8298] = {.lex_state = 356},
  [8299] = {.lex_state = 353},
  [8300] = {.lex_state = 356},
  [8301] = {.lex_state = 138},
  [8302] = {.lex_state = 353, .external_lex_state = 16},
  [8303] = {.lex_state = 353},
  [8304] = {.lex_state = 353},
  [8305] = {.lex_state = 353},
  [8306] = {.lex_state = 353},
  [8307] = {.lex_state = 356},
  [8308] = {.lex_state = 143},
  [8309] = {.lex_state = 353, .external_lex_state = 16},
  [8310] = {.lex_state = 353, .external_lex_state = 16},
  [8311] = {.lex_state = 353, .external_lex_state = 20},
  [8312] = {.lex_state = 356},
  [8313] = {.lex_state = 157},
  [8314] = {.lex_state = 353},
  [8315] = {.lex_state = 353, .external_lex_state = 16},
  [8316] = {.lex_state = 353, .external_lex_state = 16},
  [8317] = {.lex_state = 353},
  [8318] = {.lex_state = 353},
  [8319] = {.lex_state = 356},
  [8320] = {.lex_state = 356},
  [8321] = {.lex_state = 353},
  [8322] = {.lex_state = 353},
  [8323] = {.lex_state = 354},
  [8324] = {.lex_state = 353},
  [8325] = {.lex_state = 353, .external_lex_state = 20},
  [8326] = {.lex_state = 157},
  [8327] = {.lex_state = 353},
  [8328] = {.lex_state = 353},
  [8329] = {.lex_state = 353},
  [8330] = {.lex_state = 353, .external_lex_state = 20},
  [8331] = {.lex_state = 157},
  [8332] = {.lex_state = 353},
  [8333] = {.lex_state = 356},
  [8334] = {.lex_state = 353, .external_lex_state = 20},
  [8335] = {.lex_state = 353, .external_lex_state = 20},
  [8336] = {.lex_state = 356},
  [8337] = {.lex_state = 353},
  [8338] = {.lex_state = 1},
  [8339] = {.lex_state = 353, .external_lex_state = 20},
  [8340] = {.lex_state = 1},
  [8341] = {.lex_state = 1},
  [8342] = {.lex_state = 138},
  [8343] = {.lex_state = 356},
  [8344] = {.lex_state = 138},
  [8345] = {.lex_state = 353},
  [8346] = {.lex_state = 138},
  [8347] = {.lex_state = 353, .external_lex_state = 20},
  [8348] = {.lex_state = 353},
  [8349] = {.lex_state = 1},
  [8350] = {.lex_state = 356},
  [8351] = {.lex_state = 138},
  [8352] = {.lex_state = 353},
  [8353] = {.lex_state = 353},
  [8354] = {.lex_state = 353},
  [8355] = {.lex_state = 353},
  [8356] = {.lex_state = 356, .external_lex_state = 22},
  [8357] = {.lex_state = 354},
  [8358] = {.lex_state = 353},
  [8359] = {.lex_state = 204},
  [8360] = {.lex_state = 353},
  [8361] = {.lex_state = 356},
  [8362] = {.lex_state = 356},
  [8363] = {.lex_state = 353},
  [8364] = {.lex_state = 353},
  [8365] = {.lex_state = 356},
  [8366] = {.lex_state = 353},
  [8367] = {.lex_state = 356},
  [8368] = {.lex_state = 353},
  [8369] = {.lex_state = 1},
  [8370] = {.lex_state = 1},
  [8371] = {.lex_state = 138},
  [8372] = {.lex_state = 157},
  [8373] = {.lex_state = 353},
  [8374] = {.lex_state = 356, .external_lex_state = 22},
  [8375] = {.lex_state = 353},
  [8376] = {.lex_state = 138},
  [8377] = {.lex_state = 353},
  [8378] = {.lex_state = 356},
  [8379] = {.lex_state = 356},
  [8380] = {.lex_state = 353, .external_lex_state = 23},
  [8381] = {.lex_state = 353, .external_lex_state = 23},
  [8382] = {.lex_state = 353},
  [8383] = {.lex_state = 356},
  [8384] = {.lex_state = 353, .external_lex_state = 20},
  [8385] = {.lex_state = 353},
  [8386] = {.lex_state = 353},
  [8387] = {.lex_state = 353, .external_lex_state = 20},
  [8388] = {.lex_state = 353, .external_lex_state = 20},
  [8389] = {.lex_state = 353},
  [8390] = {(TSStateId)(-1)},
  [8391] = {(TSStateId)(-1)},
  [8392] = {(TSStateId)(-1)},
  [8393] = {(TSStateId)(-1)},
  [8394] = {(TSStateId)(-1)},
  [8395] = {(TSStateId)(-1)},
  [8396] = {(TSStateId)(-1)},
  [8397] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_xml_doc] = STATE(0),
    [sym_block_comment] = STATE(0),
    [sym_line_comment] = STATE(0),
    [sym_compiler_directive_decl] = STATE(0),
    [sym_fsi_directive_decl] = STATE(0),
    [sym_preproc_line] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_rec] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_LBRACK_LT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_let_BANG] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [aux_sym_access_modifier_token1] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_LT_AT] = ACTIONS(1),
    [anon_sym_AT_GT] = ACTIONS(1),
    [anon_sym_LT_AT_AT] = ACTIONS(1),
    [anon_sym_AT_AT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_return_BANG] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_yield_BANG] = ACTIONS(1),
    [anon_sym_lazy] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_upcast] = ACTIONS(1),
    [anon_sym_downcast] = ACTIONS(1),
    [anon_sym_COLON_GT] = ACTIONS(1),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_downto] = ACTIONS(1),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_fun] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_match_BANG] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_DOT_LBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_use_BANG] = ACTIONS(1),
    [anon_sym_do_BANG] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT2] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_unit] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_equality] = ACTIONS(1),
    [anon_sym_comparison] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_member] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_id] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_val] = ACTIONS(1),
    [anon_sym_inherit] = ACTIONS(1),
    [anon_sym_EQ2] = ACTIONS(1),
    [sym__unicodegraph_short] = ACTIONS(1),
    [sym__unicodegraph_long] = ACTIONS(1),
    [sym__trigraph] = ACTIONS(1),
    [aux_sym_char_token1] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_AT_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_DQUOTEB] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [sym_bool] = ACTIONS(1),
    [sym_unit] = ACTIONS(1),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RPAREN] = ACTIONS(1),
    [sym_op_identifier] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_DOT] = ACTIONS(1),
    [anon_sym_DASH_DOT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [aux_sym_prefix_op_token1] = ACTIONS(1),
    [aux_sym_infix_op_token1] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(1),
    [sym_int] = ACTIONS(1),
    [sym_xint] = ACTIONS(1),
    [anon_sym_y] = ACTIONS(1),
    [anon_sym_uy] = ACTIONS(1),
    [anon_sym_s] = ACTIONS(1),
    [anon_sym_us] = ACTIONS(1),
    [anon_sym_l] = ACTIONS(1),
    [aux_sym_uint32_token1] = ACTIONS(1),
    [anon_sym_n] = ACTIONS(1),
    [anon_sym_un] = ACTIONS(1),
    [anon_sym_L] = ACTIONS(1),
    [aux_sym_uint64_token1] = ACTIONS(1),
    [anon_sym_f] = ACTIONS(1),
    [anon_sym_lf] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [aux_sym_bignum_token1] = ACTIONS(1),
    [aux_sym_decimal_token1] = ACTIONS(1),
    [anon_sym_DOT2] = ACTIONS(1),
    [aux_sym_float_token1] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_STAR_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__triple_quoted_content] = ACTIONS(1),
    [sym_block_comment_content] = ACTIONS(1),
    [sym__inside_string_marker] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_file] = STATE(8377),
    [sym_namespace] = STATE(6575),
    [sym_named_module] = STATE(8375),
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5901),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(1),
    [sym_block_comment] = STATE(1),
    [sym_line_comment] = STATE(1),
    [sym_compiler_directive_decl] = STATE(1),
    [sym_fsi_directive_decl] = STATE(1),
    [sym_preproc_line] = STATE(1),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat1] = STATE(6191),
    [aux_sym_file_repeat2] = STATE(412),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(15),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [2] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(2),
    [sym_block_comment] = STATE(2),
    [sym_line_comment] = STATE(2),
    [sym_compiler_directive_decl] = STATE(2),
    [sym_fsi_directive_decl] = STATE(2),
    [sym_preproc_line] = STATE(2),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(147),
    [anon_sym_downto] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(147),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(123),
  },
  [3] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(3),
    [sym_block_comment] = STATE(3),
    [sym_line_comment] = STATE(3),
    [sym_compiler_directive_decl] = STATE(3),
    [sym_fsi_directive_decl] = STATE(3),
    [sym_preproc_line] = STATE(3),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(219),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(223),
    [anon_sym_downto] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(223),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [4] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(4),
    [sym_block_comment] = STATE(4),
    [sym_line_comment] = STATE(4),
    [sym_compiler_directive_decl] = STATE(4),
    [sym_fsi_directive_decl] = STATE(4),
    [sym_preproc_line] = STATE(4),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_GT_RBRACK] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_RBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(229),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_to] = ACTIONS(227),
    [anon_sym_downto] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_end] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [5] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(5),
    [sym_block_comment] = STATE(5),
    [sym_line_comment] = STATE(5),
    [sym_compiler_directive_decl] = STATE(5),
    [sym_fsi_directive_decl] = STATE(5),
    [sym_preproc_line] = STATE(5),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(231),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(233),
    [anon_sym_downto] = ACTIONS(233),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(233),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [6] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(6),
    [sym_block_comment] = STATE(6),
    [sym_line_comment] = STATE(6),
    [sym_compiler_directive_decl] = STATE(6),
    [sym_fsi_directive_decl] = STATE(6),
    [sym_preproc_line] = STATE(6),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_GT_RBRACK] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(237),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_with] = ACTIONS(235),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_to] = ACTIONS(235),
    [anon_sym_downto] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [7] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(7),
    [sym_block_comment] = STATE(7),
    [sym_line_comment] = STATE(7),
    [sym_compiler_directive_decl] = STATE(7),
    [sym_fsi_directive_decl] = STATE(7),
    [sym_preproc_line] = STATE(7),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_GT_RBRACK] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_to] = ACTIONS(239),
    [anon_sym_downto] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_end] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [8] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(8),
    [sym_block_comment] = STATE(8),
    [sym_line_comment] = STATE(8),
    [sym_compiler_directive_decl] = STATE(8),
    [sym_fsi_directive_decl] = STATE(8),
    [sym_preproc_line] = STATE(8),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(243),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(245),
    [anon_sym_downto] = ACTIONS(245),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(243),
  },
  [9] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(9),
    [sym_block_comment] = STATE(9),
    [sym_line_comment] = STATE(9),
    [sym_compiler_directive_decl] = STATE(9),
    [sym_fsi_directive_decl] = STATE(9),
    [sym_preproc_line] = STATE(9),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(247),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(249),
    [anon_sym_downto] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(249),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [10] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(10),
    [sym_block_comment] = STATE(10),
    [sym_line_comment] = STATE(10),
    [sym_compiler_directive_decl] = STATE(10),
    [sym_fsi_directive_decl] = STATE(10),
    [sym_preproc_line] = STATE(10),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(251),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(251),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(253),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(253),
    [anon_sym_downto] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(251),
  },
  [11] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(11),
    [sym_block_comment] = STATE(11),
    [sym_line_comment] = STATE(11),
    [sym_compiler_directive_decl] = STATE(11),
    [sym_fsi_directive_decl] = STATE(11),
    [sym_preproc_line] = STATE(11),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(241),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(241),
    [anon_sym_POUNDload] = ACTIONS(241),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [12] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(12),
    [sym_block_comment] = STATE(12),
    [sym_line_comment] = STATE(12),
    [sym_compiler_directive_decl] = STATE(12),
    [sym_fsi_directive_decl] = STATE(12),
    [sym_preproc_line] = STATE(12),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(147),
    [anon_sym_module] = ACTIONS(147),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(147),
    [anon_sym_LBRACK_LT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(147),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(123),
    [anon_sym_POUNDload] = ACTIONS(123),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(123),
  },
  [13] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(13),
    [sym_block_comment] = STATE(13),
    [sym_line_comment] = STATE(13),
    [sym_compiler_directive_decl] = STATE(13),
    [sym_fsi_directive_decl] = STATE(13),
    [sym_preproc_line] = STATE(13),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(247),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(249),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(247),
    [anon_sym_POUNDload] = ACTIONS(247),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(295),
  },
  [14] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(14),
    [sym_block_comment] = STATE(14),
    [sym_line_comment] = STATE(14),
    [sym_compiler_directive_decl] = STATE(14),
    [sym_fsi_directive_decl] = STATE(14),
    [sym_preproc_line] = STATE(14),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(235),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_open] = ACTIONS(235),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_type] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [15] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(15),
    [sym_block_comment] = STATE(15),
    [sym_line_comment] = STATE(15),
    [sym_compiler_directive_decl] = STATE(15),
    [sym_fsi_directive_decl] = STATE(15),
    [sym_preproc_line] = STATE(15),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(219),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(223),
    [anon_sym_module] = ACTIONS(223),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(219),
    [anon_sym_POUNDload] = ACTIONS(219),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(295),
  },
  [16] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(16),
    [sym_block_comment] = STATE(16),
    [sym_line_comment] = STATE(16),
    [sym_compiler_directive_decl] = STATE(16),
    [sym_fsi_directive_decl] = STATE(16),
    [sym_preproc_line] = STATE(16),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(251),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(253),
    [anon_sym_module] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(253),
    [anon_sym_LBRACK_LT] = ACTIONS(251),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(253),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(251),
    [anon_sym_POUNDload] = ACTIONS(251),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(251),
  },
  [17] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(17),
    [sym_block_comment] = STATE(17),
    [sym_line_comment] = STATE(17),
    [sym_compiler_directive_decl] = STATE(17),
    [sym_fsi_directive_decl] = STATE(17),
    [sym_preproc_line] = STATE(17),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(243),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(243),
  },
  [18] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(18),
    [sym_block_comment] = STATE(18),
    [sym_line_comment] = STATE(18),
    [sym_compiler_directive_decl] = STATE(18),
    [sym_fsi_directive_decl] = STATE(18),
    [sym_preproc_line] = STATE(18),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(231),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(295),
  },
  [19] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(19),
    [sym_block_comment] = STATE(19),
    [sym_line_comment] = STATE(19),
    [sym_compiler_directive_decl] = STATE(19),
    [sym_fsi_directive_decl] = STATE(19),
    [sym_preproc_line] = STATE(19),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(229),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_module] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_open] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(229),
    [anon_sym_POUNDload] = ACTIONS(229),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [20] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(854),
    [sym_infix_op] = STATE(707),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(20),
    [sym_block_comment] = STATE(20),
    [sym_line_comment] = STATE(20),
    [sym_compiler_directive_decl] = STATE(20),
    [sym_fsi_directive_decl] = STATE(20),
    [sym_preproc_line] = STATE(20),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1208),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(297),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(299),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(299),
    [anon_sym_LBRACK_LT] = ACTIONS(297),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(277),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(297),
    [anon_sym_POUNDload] = ACTIONS(297),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(295),
  },
  [21] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(21),
    [sym_block_comment] = STATE(21),
    [sym_line_comment] = STATE(21),
    [sym_compiler_directive_decl] = STATE(21),
    [sym_fsi_directive_decl] = STATE(21),
    [sym_preproc_line] = STATE(21),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(299),
    [anon_sym_LBRACK_LT] = ACTIONS(297),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(297),
    [anon_sym_POUNDload] = ACTIONS(297),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(389),
    [sym__dedent] = ACTIONS(297),
  },
  [22] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(22),
    [sym_block_comment] = STATE(22),
    [sym_line_comment] = STATE(22),
    [sym_compiler_directive_decl] = STATE(22),
    [sym_fsi_directive_decl] = STATE(22),
    [sym_preproc_line] = STATE(22),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_open] = ACTIONS(235),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_type] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [23] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(23),
    [sym_block_comment] = STATE(23),
    [sym_line_comment] = STATE(23),
    [sym_compiler_directive_decl] = STATE(23),
    [sym_fsi_directive_decl] = STATE(23),
    [sym_preproc_line] = STATE(23),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(219),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(223),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(219),
    [anon_sym_POUNDload] = ACTIONS(219),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(395),
  },
  [24] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(24),
    [sym_block_comment] = STATE(24),
    [sym_line_comment] = STATE(24),
    [sym_compiler_directive_decl] = STATE(24),
    [sym_fsi_directive_decl] = STATE(24),
    [sym_preproc_line] = STATE(24),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_open] = ACTIONS(235),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_type] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [25] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(25),
    [sym_block_comment] = STATE(25),
    [sym_line_comment] = STATE(25),
    [sym_compiler_directive_decl] = STATE(25),
    [sym_fsi_directive_decl] = STATE(25),
    [sym_preproc_line] = STATE(25),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(147),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(147),
    [anon_sym_LBRACK_LT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(147),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(123),
    [anon_sym_POUNDload] = ACTIONS(123),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(123),
  },
  [26] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(26),
    [sym_block_comment] = STATE(26),
    [sym_line_comment] = STATE(26),
    [sym_compiler_directive_decl] = STATE(26),
    [sym_fsi_directive_decl] = STATE(26),
    [sym_preproc_line] = STATE(26),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(243),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(243),
  },
  [27] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(27),
    [sym_block_comment] = STATE(27),
    [sym_line_comment] = STATE(27),
    [sym_compiler_directive_decl] = STATE(27),
    [sym_fsi_directive_decl] = STATE(27),
    [sym_preproc_line] = STATE(27),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(223),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(219),
    [anon_sym_POUNDload] = ACTIONS(219),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(389),
    [sym__dedent] = ACTIONS(219),
  },
  [28] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(28),
    [sym_block_comment] = STATE(28),
    [sym_line_comment] = STATE(28),
    [sym_compiler_directive_decl] = STATE(28),
    [sym_fsi_directive_decl] = STATE(28),
    [sym_preproc_line] = STATE(28),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(147),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(147),
    [anon_sym_LBRACK_LT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(147),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(123),
    [anon_sym_POUNDload] = ACTIONS(123),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(123),
    [sym__dedent] = ACTIONS(123),
  },
  [29] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(29),
    [sym_block_comment] = STATE(29),
    [sym_line_comment] = STATE(29),
    [sym_compiler_directive_decl] = STATE(29),
    [sym_fsi_directive_decl] = STATE(29),
    [sym_preproc_line] = STATE(29),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(253),
    [anon_sym_LBRACK_LT] = ACTIONS(251),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(253),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(251),
    [anon_sym_POUNDload] = ACTIONS(251),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(251),
    [sym__dedent] = ACTIONS(251),
  },
  [30] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(30),
    [sym_block_comment] = STATE(30),
    [sym_line_comment] = STATE(30),
    [sym_compiler_directive_decl] = STATE(30),
    [sym_fsi_directive_decl] = STATE(30),
    [sym_preproc_line] = STATE(30),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(249),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(247),
    [anon_sym_POUNDload] = ACTIONS(247),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(389),
    [sym__dedent] = ACTIONS(247),
  },
  [31] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(31),
    [sym_block_comment] = STATE(31),
    [sym_line_comment] = STATE(31),
    [sym_compiler_directive_decl] = STATE(31),
    [sym_fsi_directive_decl] = STATE(31),
    [sym_preproc_line] = STATE(31),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(389),
    [sym__dedent] = ACTIONS(231),
  },
  [32] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(32),
    [sym_block_comment] = STATE(32),
    [sym_line_comment] = STATE(32),
    [sym_compiler_directive_decl] = STATE(32),
    [sym_fsi_directive_decl] = STATE(32),
    [sym_preproc_line] = STATE(32),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(323),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_COLON_GT] = ACTIONS(333),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_LT_DASH] = ACTIONS(349),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_LPAREN2] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [33] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(33),
    [sym_block_comment] = STATE(33),
    [sym_line_comment] = STATE(33),
    [sym_compiler_directive_decl] = STATE(33),
    [sym_fsi_directive_decl] = STATE(33),
    [sym_preproc_line] = STATE(33),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(251),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(253),
    [anon_sym_LBRACK_LT] = ACTIONS(251),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(253),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(251),
    [anon_sym_POUNDload] = ACTIONS(251),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(251),
  },
  [34] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(34),
    [sym_block_comment] = STATE(34),
    [sym_line_comment] = STATE(34),
    [sym_compiler_directive_decl] = STATE(34),
    [sym_fsi_directive_decl] = STATE(34),
    [sym_preproc_line] = STATE(34),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(241),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(241),
    [anon_sym_POUNDload] = ACTIONS(241),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [35] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym_line_comment] = STATE(35),
    [sym_compiler_directive_decl] = STATE(35),
    [sym_fsi_directive_decl] = STATE(35),
    [sym_preproc_line] = STATE(35),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(229),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_module] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_open] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(229),
    [anon_sym_POUNDload] = ACTIONS(229),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [36] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym_line_comment] = STATE(36),
    [sym_compiler_directive_decl] = STATE(36),
    [sym_fsi_directive_decl] = STATE(36),
    [sym_preproc_line] = STATE(36),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(231),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(395),
  },
  [37] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym_line_comment] = STATE(37),
    [sym_compiler_directive_decl] = STATE(37),
    [sym_fsi_directive_decl] = STATE(37),
    [sym_preproc_line] = STATE(37),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(297),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(299),
    [anon_sym_LBRACK_LT] = ACTIONS(297),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(297),
    [anon_sym_POUNDload] = ACTIONS(297),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(395),
  },
  [38] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(790),
    [sym_infix_op] = STATE(851),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym_line_comment] = STATE(38),
    [sym_compiler_directive_decl] = STATE(38),
    [sym_fsi_directive_decl] = STATE(38),
    [sym_preproc_line] = STATE(38),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_sequential_expression_repeat1] = STATE(1410),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(247),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_open] = ACTIONS(249),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_COLON_GT] = ACTIONS(275),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(393),
    [anon_sym_DOT_LBRACK] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(95),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(285),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(247),
    [anon_sym_POUNDload] = ACTIONS(247),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
    [sym__newline] = ACTIONS(395),
  },
  [39] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym_line_comment] = STATE(39),
    [sym_compiler_directive_decl] = STATE(39),
    [sym_fsi_directive_decl] = STATE(39),
    [sym_preproc_line] = STATE(39),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(241),
    [anon_sym_POUNDload] = ACTIONS(241),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
    [sym__dedent] = ACTIONS(241),
  },
  [40] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(729),
    [sym_infix_op] = STATE(666),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym_line_comment] = STATE(40),
    [sym_compiler_directive_decl] = STATE(40),
    [sym_fsi_directive_decl] = STATE(40),
    [sym_preproc_line] = STATE(40),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1287),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_module] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_open] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(229),
    [anon_sym_POUNDload] = ACTIONS(229),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
    [sym__dedent] = ACTIONS(229),
  },
  [41] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym_line_comment] = STATE(41),
    [sym_compiler_directive_decl] = STATE(41),
    [sym_fsi_directive_decl] = STATE(41),
    [sym_preproc_line] = STATE(41),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_as] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
    [sym__dedent] = ACTIONS(241),
  },
  [42] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym_line_comment] = STATE(42),
    [sym_compiler_directive_decl] = STATE(42),
    [sym_fsi_directive_decl] = STATE(42),
    [sym_preproc_line] = STATE(42),
    [sym_preproc_else] = STATE(7767),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(493),
    [anon_sym_POUNDelse] = ACTIONS(496),
    [sym__newline] = ACTIONS(499),
  },
  [43] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym_line_comment] = STATE(43),
    [sym_compiler_directive_decl] = STATE(43),
    [sym_fsi_directive_decl] = STATE(43),
    [sym_preproc_line] = STATE(43),
    [sym_preproc_else] = STATE(8157),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(501),
    [anon_sym_POUNDelse] = ACTIONS(496),
    [sym__newline] = ACTIONS(499),
  },
  [44] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym_line_comment] = STATE(44),
    [sym_compiler_directive_decl] = STATE(44),
    [sym_fsi_directive_decl] = STATE(44),
    [sym_preproc_line] = STATE(44),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_as] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_with] = ACTIONS(235),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [45] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym_line_comment] = STATE(45),
    [sym_compiler_directive_decl] = STATE(45),
    [sym_fsi_directive_decl] = STATE(45),
    [sym_preproc_line] = STATE(45),
    [sym_preproc_else] = STATE(7421),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(504),
    [anon_sym_POUNDelse] = ACTIONS(496),
    [sym__newline] = ACTIONS(499),
  },
  [46] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym_line_comment] = STATE(46),
    [sym_compiler_directive_decl] = STATE(46),
    [sym_fsi_directive_decl] = STATE(46),
    [sym_preproc_line] = STATE(46),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_COLON_GT] = ACTIONS(537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_LT_DASH] = ACTIONS(553),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_LPAREN2] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
    [sym__newline] = ACTIONS(589),
    [sym__dedent] = ACTIONS(219),
  },
  [47] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym_line_comment] = STATE(47),
    [sym_compiler_directive_decl] = STATE(47),
    [sym_fsi_directive_decl] = STATE(47),
    [sym_preproc_line] = STATE(47),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_as] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
    [sym__dedent] = ACTIONS(229),
  },
  [48] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym_line_comment] = STATE(48),
    [sym_compiler_directive_decl] = STATE(48),
    [sym_fsi_directive_decl] = STATE(48),
    [sym_preproc_line] = STATE(48),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_as] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
    [sym__dedent] = ACTIONS(241),
  },
  [49] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym_line_comment] = STATE(49),
    [sym_compiler_directive_decl] = STATE(49),
    [sym_fsi_directive_decl] = STATE(49),
    [sym_preproc_line] = STATE(49),
    [sym_preproc_else] = STATE(7603),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(591),
    [anon_sym_POUNDelse] = ACTIONS(496),
    [sym__newline] = ACTIONS(499),
  },
  [50] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym_line_comment] = STATE(50),
    [sym_compiler_directive_decl] = STATE(50),
    [sym_fsi_directive_decl] = STATE(50),
    [sym_preproc_line] = STATE(50),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__list_elements_repeat1] = STATE(6533),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(684),
    [sym__dedent] = ACTIONS(686),
  },
  [51] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym_line_comment] = STATE(51),
    [sym_compiler_directive_decl] = STATE(51),
    [sym_fsi_directive_decl] = STATE(51),
    [sym_preproc_line] = STATE(51),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_COLON_GT] = ACTIONS(537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_LT_DASH] = ACTIONS(553),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_LPAREN2] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [52] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym_line_comment] = STATE(52),
    [sym_compiler_directive_decl] = STATE(52),
    [sym_fsi_directive_decl] = STATE(52),
    [sym_preproc_line] = STATE(52),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_COLON_GT] = ACTIONS(537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_LT_DASH] = ACTIONS(553),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_LPAREN2] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
    [sym__newline] = ACTIONS(589),
    [sym__dedent] = ACTIONS(231),
  },
  [53] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym_line_comment] = STATE(53),
    [sym_compiler_directive_decl] = STATE(53),
    [sym_fsi_directive_decl] = STATE(53),
    [sym_preproc_line] = STATE(53),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_COLON_GT] = ACTIONS(537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_LT_DASH] = ACTIONS(553),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_LPAREN2] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
    [sym__newline] = ACTIONS(123),
    [sym__dedent] = ACTIONS(123),
  },
  [54] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym_line_comment] = STATE(54),
    [sym_compiler_directive_decl] = STATE(54),
    [sym_fsi_directive_decl] = STATE(54),
    [sym_preproc_line] = STATE(54),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(253),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_COLON_GT] = ACTIONS(537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_LT_DASH] = ACTIONS(553),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_LPAREN2] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
    [sym__newline] = ACTIONS(251),
    [sym__dedent] = ACTIONS(251),
  },
  [55] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(671),
    [sym_infix_op] = STATE(579),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym_line_comment] = STATE(55),
    [sym_compiler_directive_decl] = STATE(55),
    [sym_fsi_directive_decl] = STATE(55),
    [sym_preproc_line] = STATE(55),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_sequential_expression_repeat1] = STATE(1751),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_COLON_GT] = ACTIONS(537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_LT_DASH] = ACTIONS(553),
    [anon_sym_DOT_LBRACK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_LPAREN2] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
    [sym__newline] = ACTIONS(589),
    [sym__dedent] = ACTIONS(247),
  },
  [56] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym_line_comment] = STATE(56),
    [sym_compiler_directive_decl] = STATE(56),
    [sym_fsi_directive_decl] = STATE(56),
    [sym_preproc_line] = STATE(56),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(123),
    [sym__dedent] = ACTIONS(123),
  },
  [57] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym_line_comment] = STATE(57),
    [sym_compiler_directive_decl] = STATE(57),
    [sym_fsi_directive_decl] = STATE(57),
    [sym_preproc_line] = STATE(57),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(710),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [58] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym_line_comment] = STATE(58),
    [sym_compiler_directive_decl] = STATE(58),
    [sym_fsi_directive_decl] = STATE(58),
    [sym_preproc_line] = STATE(58),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(233),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(818),
  },
  [59] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym_line_comment] = STATE(59),
    [sym_compiler_directive_decl] = STATE(59),
    [sym_fsi_directive_decl] = STATE(59),
    [sym_preproc_line] = STATE(59),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(249),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(818),
  },
  [60] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym_line_comment] = STATE(60),
    [sym_compiler_directive_decl] = STATE(60),
    [sym_fsi_directive_decl] = STATE(60),
    [sym_preproc_line] = STATE(60),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(251),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(251),
  },
  [61] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym_line_comment] = STATE(61),
    [sym_compiler_directive_decl] = STATE(61),
    [sym_fsi_directive_decl] = STATE(61),
    [sym_preproc_line] = STATE(61),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(147),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(123),
  },
  [62] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym_line_comment] = STATE(62),
    [sym_compiler_directive_decl] = STATE(62),
    [sym_fsi_directive_decl] = STATE(62),
    [sym_preproc_line] = STATE(62),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(219),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(818),
  },
  [63] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym_line_comment] = STATE(63),
    [sym_compiler_directive_decl] = STATE(63),
    [sym_fsi_directive_decl] = STATE(63),
    [sym_preproc_line] = STATE(63),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(820),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [64] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym_line_comment] = STATE(64),
    [sym_compiler_directive_decl] = STATE(64),
    [sym_fsi_directive_decl] = STATE(64),
    [sym_preproc_line] = STATE(64),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(822),
    [anon_sym_downto] = ACTIONS(822),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [65] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym_line_comment] = STATE(65),
    [sym_compiler_directive_decl] = STATE(65),
    [sym_fsi_directive_decl] = STATE(65),
    [sym_preproc_line] = STATE(65),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(824),
    [anon_sym_downto] = ACTIONS(824),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [66] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym_line_comment] = STATE(66),
    [sym_compiler_directive_decl] = STATE(66),
    [sym_fsi_directive_decl] = STATE(66),
    [sym_preproc_line] = STATE(66),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(826),
    [anon_sym_downto] = ACTIONS(826),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [67] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(67),
    [sym_block_comment] = STATE(67),
    [sym_line_comment] = STATE(67),
    [sym_compiler_directive_decl] = STATE(67),
    [sym_fsi_directive_decl] = STATE(67),
    [sym_preproc_line] = STATE(67),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(243),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(243),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(243),
  },
  [68] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(68),
    [sym_block_comment] = STATE(68),
    [sym_line_comment] = STATE(68),
    [sym_compiler_directive_decl] = STATE(68),
    [sym_fsi_directive_decl] = STATE(68),
    [sym_preproc_line] = STATE(68),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(828),
    [anon_sym_downto] = ACTIONS(828),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [69] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(69),
    [sym_block_comment] = STATE(69),
    [sym_line_comment] = STATE(69),
    [sym_compiler_directive_decl] = STATE(69),
    [sym_fsi_directive_decl] = STATE(69),
    [sym_preproc_line] = STATE(69),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(830),
    [anon_sym_downto] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [70] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(70),
    [sym_block_comment] = STATE(70),
    [sym_line_comment] = STATE(70),
    [sym_compiler_directive_decl] = STATE(70),
    [sym_fsi_directive_decl] = STATE(70),
    [sym_preproc_line] = STATE(70),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(832),
    [anon_sym_downto] = ACTIONS(832),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [71] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(71),
    [sym_block_comment] = STATE(71),
    [sym_line_comment] = STATE(71),
    [sym_compiler_directive_decl] = STATE(71),
    [sym_fsi_directive_decl] = STATE(71),
    [sym_preproc_line] = STATE(71),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(834),
    [anon_sym_downto] = ACTIONS(834),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [72] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(72),
    [sym_block_comment] = STATE(72),
    [sym_line_comment] = STATE(72),
    [sym_compiler_directive_decl] = STATE(72),
    [sym_fsi_directive_decl] = STATE(72),
    [sym_preproc_line] = STATE(72),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(231),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(231),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [73] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(73),
    [sym_block_comment] = STATE(73),
    [sym_line_comment] = STATE(73),
    [sym_compiler_directive_decl] = STATE(73),
    [sym_fsi_directive_decl] = STATE(73),
    [sym_preproc_line] = STATE(73),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__list_elements_repeat1] = STATE(6449),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(836),
    [sym__dedent] = ACTIONS(838),
  },
  [74] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(74),
    [sym_block_comment] = STATE(74),
    [sym_line_comment] = STATE(74),
    [sym_compiler_directive_decl] = STATE(74),
    [sym_fsi_directive_decl] = STATE(74),
    [sym_preproc_line] = STATE(74),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [75] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(75),
    [sym_block_comment] = STATE(75),
    [sym_line_comment] = STATE(75),
    [sym_compiler_directive_decl] = STATE(75),
    [sym_fsi_directive_decl] = STATE(75),
    [sym_preproc_line] = STATE(75),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(842),
    [anon_sym_downto] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [76] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(76),
    [sym_block_comment] = STATE(76),
    [sym_line_comment] = STATE(76),
    [sym_compiler_directive_decl] = STATE(76),
    [sym_fsi_directive_decl] = STATE(76),
    [sym_preproc_line] = STATE(76),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(844),
    [anon_sym_downto] = ACTIONS(844),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [77] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(77),
    [sym_block_comment] = STATE(77),
    [sym_line_comment] = STATE(77),
    [sym_compiler_directive_decl] = STATE(77),
    [sym_fsi_directive_decl] = STATE(77),
    [sym_preproc_line] = STATE(77),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
    [sym__dedent] = ACTIONS(229),
  },
  [78] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(78),
    [sym_block_comment] = STATE(78),
    [sym_line_comment] = STATE(78),
    [sym_compiler_directive_decl] = STATE(78),
    [sym_fsi_directive_decl] = STATE(78),
    [sym_preproc_line] = STATE(78),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
    [sym__dedent] = ACTIONS(241),
  },
  [79] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(79),
    [sym_block_comment] = STATE(79),
    [sym_line_comment] = STATE(79),
    [sym_compiler_directive_decl] = STATE(79),
    [sym_fsi_directive_decl] = STATE(79),
    [sym_preproc_line] = STATE(79),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [80] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(80),
    [sym_block_comment] = STATE(80),
    [sym_line_comment] = STATE(80),
    [sym_compiler_directive_decl] = STATE(80),
    [sym_fsi_directive_decl] = STATE(80),
    [sym_preproc_line] = STATE(80),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_with] = ACTIONS(235),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [81] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(81),
    [sym_block_comment] = STATE(81),
    [sym_line_comment] = STATE(81),
    [sym_compiler_directive_decl] = STATE(81),
    [sym_fsi_directive_decl] = STATE(81),
    [sym_preproc_line] = STATE(81),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_RBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_DOT_DOT2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [82] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(82),
    [sym_block_comment] = STATE(82),
    [sym_line_comment] = STATE(82),
    [sym_compiler_directive_decl] = STATE(82),
    [sym_fsi_directive_decl] = STATE(82),
    [sym_preproc_line] = STATE(82),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(848),
    [anon_sym_downto] = ACTIONS(848),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [83] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(83),
    [sym_block_comment] = STATE(83),
    [sym_line_comment] = STATE(83),
    [sym_compiler_directive_decl] = STATE(83),
    [sym_fsi_directive_decl] = STATE(83),
    [sym_preproc_line] = STATE(83),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(850),
    [anon_sym_downto] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [84] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(84),
    [sym_block_comment] = STATE(84),
    [sym_line_comment] = STATE(84),
    [sym_compiler_directive_decl] = STATE(84),
    [sym_fsi_directive_decl] = STATE(84),
    [sym_preproc_line] = STATE(84),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(852),
    [anon_sym_downto] = ACTIONS(852),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [85] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(85),
    [sym_block_comment] = STATE(85),
    [sym_line_comment] = STATE(85),
    [sym_compiler_directive_decl] = STATE(85),
    [sym_fsi_directive_decl] = STATE(85),
    [sym_preproc_line] = STATE(85),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(858),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(818),
  },
  [86] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(86),
    [sym_block_comment] = STATE(86),
    [sym_line_comment] = STATE(86),
    [sym_compiler_directive_decl] = STATE(86),
    [sym_fsi_directive_decl] = STATE(86),
    [sym_preproc_line] = STATE(86),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_DOT_DOT2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [87] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(87),
    [sym_block_comment] = STATE(87),
    [sym_line_comment] = STATE(87),
    [sym_compiler_directive_decl] = STATE(87),
    [sym_fsi_directive_decl] = STATE(87),
    [sym_preproc_line] = STATE(87),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(860),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(864),
  },
  [88] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(88),
    [sym_block_comment] = STATE(88),
    [sym_line_comment] = STATE(88),
    [sym_compiler_directive_decl] = STATE(88),
    [sym_fsi_directive_decl] = STATE(88),
    [sym_preproc_line] = STATE(88),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(866),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [89] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(89),
    [sym_block_comment] = STATE(89),
    [sym_line_comment] = STATE(89),
    [sym_compiler_directive_decl] = STATE(89),
    [sym_fsi_directive_decl] = STATE(89),
    [sym_preproc_line] = STATE(89),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(868),
    [anon_sym_POUNDelse] = ACTIONS(868),
    [sym__newline] = ACTIONS(499),
  },
  [90] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(90),
    [sym_block_comment] = STATE(90),
    [sym_line_comment] = STATE(90),
    [sym_compiler_directive_decl] = STATE(90),
    [sym_fsi_directive_decl] = STATE(90),
    [sym_preproc_line] = STATE(90),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(870),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [91] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(91),
    [sym_block_comment] = STATE(91),
    [sym_line_comment] = STATE(91),
    [sym_compiler_directive_decl] = STATE(91),
    [sym_fsi_directive_decl] = STATE(91),
    [sym_preproc_line] = STATE(91),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_to] = ACTIONS(872),
    [anon_sym_downto] = ACTIONS(872),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [92] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(92),
    [sym_block_comment] = STATE(92),
    [sym_line_comment] = STATE(92),
    [sym_compiler_directive_decl] = STATE(92),
    [sym_fsi_directive_decl] = STATE(92),
    [sym_preproc_line] = STATE(92),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(247),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(874),
    [sym__dedent] = ACTIONS(874),
  },
  [93] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(93),
    [sym_block_comment] = STATE(93),
    [sym_line_comment] = STATE(93),
    [sym_compiler_directive_decl] = STATE(93),
    [sym_fsi_directive_decl] = STATE(93),
    [sym_preproc_line] = STATE(93),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(247),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(247),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [94] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(94),
    [sym_block_comment] = STATE(94),
    [sym_line_comment] = STATE(94),
    [sym_compiler_directive_decl] = STATE(94),
    [sym_fsi_directive_decl] = STATE(94),
    [sym_preproc_line] = STATE(94),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(876),
    [sym__dedent] = ACTIONS(878),
  },
  [95] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(95),
    [sym_block_comment] = STATE(95),
    [sym_line_comment] = STATE(95),
    [sym_compiler_directive_decl] = STATE(95),
    [sym_fsi_directive_decl] = STATE(95),
    [sym_preproc_line] = STATE(95),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_as] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [96] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(96),
    [sym_block_comment] = STATE(96),
    [sym_line_comment] = STATE(96),
    [sym_compiler_directive_decl] = STATE(96),
    [sym_fsi_directive_decl] = STATE(96),
    [sym_preproc_line] = STATE(96),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_DASH_GT] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_DOT_DOT] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [97] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(97),
    [sym_block_comment] = STATE(97),
    [sym_line_comment] = STATE(97),
    [sym_compiler_directive_decl] = STATE(97),
    [sym_fsi_directive_decl] = STATE(97),
    [sym_preproc_line] = STATE(97),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(251),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(251),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(251),
  },
  [98] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(98),
    [sym_block_comment] = STATE(98),
    [sym_line_comment] = STATE(98),
    [sym_compiler_directive_decl] = STATE(98),
    [sym_fsi_directive_decl] = STATE(98),
    [sym_preproc_line] = STATE(98),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [99] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(99),
    [sym_block_comment] = STATE(99),
    [sym_line_comment] = STATE(99),
    [sym_compiler_directive_decl] = STATE(99),
    [sym_fsi_directive_decl] = STATE(99),
    [sym_preproc_line] = STATE(99),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_DOT_DOT] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [100] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(100),
    [sym_block_comment] = STATE(100),
    [sym_line_comment] = STATE(100),
    [sym_compiler_directive_decl] = STATE(100),
    [sym_fsi_directive_decl] = STATE(100),
    [sym_preproc_line] = STATE(100),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(886),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [101] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(101),
    [sym_block_comment] = STATE(101),
    [sym_line_comment] = STATE(101),
    [sym_compiler_directive_decl] = STATE(101),
    [sym_fsi_directive_decl] = STATE(101),
    [sym_preproc_line] = STATE(101),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [102] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(102),
    [sym_block_comment] = STATE(102),
    [sym_line_comment] = STATE(102),
    [sym_compiler_directive_decl] = STATE(102),
    [sym_fsi_directive_decl] = STATE(102),
    [sym_preproc_line] = STATE(102),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(123),
  },
  [103] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(103),
    [sym_block_comment] = STATE(103),
    [sym_line_comment] = STATE(103),
    [sym_compiler_directive_decl] = STATE(103),
    [sym_fsi_directive_decl] = STATE(103),
    [sym_preproc_line] = STATE(103),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_DOT_DOT2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [104] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(104),
    [sym_block_comment] = STATE(104),
    [sym_line_comment] = STATE(104),
    [sym_compiler_directive_decl] = STATE(104),
    [sym_fsi_directive_decl] = STATE(104),
    [sym_preproc_line] = STATE(104),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(888),
    [anon_sym_POUNDelse] = ACTIONS(888),
    [sym__newline] = ACTIONS(499),
  },
  [105] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(105),
    [sym_block_comment] = STATE(105),
    [sym_line_comment] = STATE(105),
    [sym_compiler_directive_decl] = STATE(105),
    [sym_fsi_directive_decl] = STATE(105),
    [sym_preproc_line] = STATE(105),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(231),
  },
  [106] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(106),
    [sym_block_comment] = STATE(106),
    [sym_line_comment] = STATE(106),
    [sym_compiler_directive_decl] = STATE(106),
    [sym_fsi_directive_decl] = STATE(106),
    [sym_preproc_line] = STATE(106),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(890),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [107] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(107),
    [sym_block_comment] = STATE(107),
    [sym_line_comment] = STATE(107),
    [sym_compiler_directive_decl] = STATE(107),
    [sym_fsi_directive_decl] = STATE(107),
    [sym_preproc_line] = STATE(107),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_COLON_GT] = ACTIONS(922),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_LT_DASH] = ACTIONS(938),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(962),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
    [sym__newline] = ACTIONS(974),
  },
  [108] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(108),
    [sym_block_comment] = STATE(108),
    [sym_line_comment] = STATE(108),
    [sym_compiler_directive_decl] = STATE(108),
    [sym_fsi_directive_decl] = STATE(108),
    [sym_preproc_line] = STATE(108),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [anon_sym_POUNDendif] = ACTIONS(229),
    [anon_sym_POUNDelse] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [109] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(109),
    [sym_block_comment] = STATE(109),
    [sym_line_comment] = STATE(109),
    [sym_compiler_directive_decl] = STATE(109),
    [sym_fsi_directive_decl] = STATE(109),
    [sym_preproc_line] = STATE(109),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [anon_sym_POUNDendif] = ACTIONS(241),
    [anon_sym_POUNDelse] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [110] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(110),
    [sym_block_comment] = STATE(110),
    [sym_line_comment] = STATE(110),
    [sym_compiler_directive_decl] = STATE(110),
    [sym_fsi_directive_decl] = STATE(110),
    [sym_preproc_line] = STATE(110),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(247),
  },
  [111] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(111),
    [sym_block_comment] = STATE(111),
    [sym_line_comment] = STATE(111),
    [sym_compiler_directive_decl] = STATE(111),
    [sym_fsi_directive_decl] = STATE(111),
    [sym_preproc_line] = STATE(111),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(253),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(251),
    [sym__dedent] = ACTIONS(251),
  },
  [112] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(112),
    [sym_block_comment] = STATE(112),
    [sym_line_comment] = STATE(112),
    [sym_compiler_directive_decl] = STATE(112),
    [sym_fsi_directive_decl] = STATE(112),
    [sym_preproc_line] = STATE(112),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [113] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(113),
    [sym_block_comment] = STATE(113),
    [sym_line_comment] = STATE(113),
    [sym_compiler_directive_decl] = STATE(113),
    [sym_fsi_directive_decl] = STATE(113),
    [sym_preproc_line] = STATE(113),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_COLON_GT] = ACTIONS(922),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_LT_DASH] = ACTIONS(938),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(962),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
    [sym__newline] = ACTIONS(123),
  },
  [114] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(114),
    [sym_block_comment] = STATE(114),
    [sym_line_comment] = STATE(114),
    [sym_compiler_directive_decl] = STATE(114),
    [sym_fsi_directive_decl] = STATE(114),
    [sym_preproc_line] = STATE(114),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [anon_sym_POUNDendif] = ACTIONS(237),
    [anon_sym_POUNDelse] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [115] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(115),
    [sym_block_comment] = STATE(115),
    [sym_line_comment] = STATE(115),
    [sym_compiler_directive_decl] = STATE(115),
    [sym_fsi_directive_decl] = STATE(115),
    [sym_preproc_line] = STATE(115),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(253),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_COLON_GT] = ACTIONS(922),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_LT_DASH] = ACTIONS(938),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(962),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
    [sym__newline] = ACTIONS(251),
  },
  [116] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(116),
    [sym_block_comment] = STATE(116),
    [sym_line_comment] = STATE(116),
    [sym_compiler_directive_decl] = STATE(116),
    [sym_fsi_directive_decl] = STATE(116),
    [sym_preproc_line] = STATE(116),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(978),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(858),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(818),
  },
  [117] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(117),
    [sym_block_comment] = STATE(117),
    [sym_line_comment] = STATE(117),
    [sym_compiler_directive_decl] = STATE(117),
    [sym_fsi_directive_decl] = STATE(117),
    [sym_preproc_line] = STATE(117),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_COLON_GT] = ACTIONS(922),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_LT_DASH] = ACTIONS(938),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(962),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
    [sym__newline] = ACTIONS(974),
  },
  [118] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(118),
    [sym_block_comment] = STATE(118),
    [sym_line_comment] = STATE(118),
    [sym_compiler_directive_decl] = STATE(118),
    [sym_fsi_directive_decl] = STATE(118),
    [sym_preproc_line] = STATE(118),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_COLON_GT] = ACTIONS(922),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_LT_DASH] = ACTIONS(938),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(962),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
    [sym__newline] = ACTIONS(974),
  },
  [119] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(119),
    [sym_block_comment] = STATE(119),
    [sym_line_comment] = STATE(119),
    [sym_compiler_directive_decl] = STATE(119),
    [sym_fsi_directive_decl] = STATE(119),
    [sym_preproc_line] = STATE(119),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_COLON_GT] = ACTIONS(922),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_LT_DASH] = ACTIONS(938),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(962),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
    [sym__newline] = ACTIONS(243),
  },
  [120] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(120),
    [sym_block_comment] = STATE(120),
    [sym_line_comment] = STATE(120),
    [sym_compiler_directive_decl] = STATE(120),
    [sym_fsi_directive_decl] = STATE(120),
    [sym_preproc_line] = STATE(120),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [121] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(121),
    [sym_block_comment] = STATE(121),
    [sym_line_comment] = STATE(121),
    [sym_compiler_directive_decl] = STATE(121),
    [sym_fsi_directive_decl] = STATE(121),
    [sym_preproc_line] = STATE(121),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(245),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(243),
  },
  [122] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(122),
    [sym_block_comment] = STATE(122),
    [sym_line_comment] = STATE(122),
    [sym_compiler_directive_decl] = STATE(122),
    [sym_fsi_directive_decl] = STATE(122),
    [sym_preproc_line] = STATE(122),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(982),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [123] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(123),
    [sym_block_comment] = STATE(123),
    [sym_line_comment] = STATE(123),
    [sym_compiler_directive_decl] = STATE(123),
    [sym_fsi_directive_decl] = STATE(123),
    [sym_preproc_line] = STATE(123),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_DOT_DOT2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
    [sym__dedent] = ACTIONS(229),
  },
  [124] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(124),
    [sym_block_comment] = STATE(124),
    [sym_line_comment] = STATE(124),
    [sym_compiler_directive_decl] = STATE(124),
    [sym_fsi_directive_decl] = STATE(124),
    [sym_preproc_line] = STATE(124),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_with] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(219),
  },
  [125] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(125),
    [sym_block_comment] = STATE(125),
    [sym_line_comment] = STATE(125),
    [sym_compiler_directive_decl] = STATE(125),
    [sym_fsi_directive_decl] = STATE(125),
    [sym_preproc_line] = STATE(125),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_as] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_with] = ACTIONS(235),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [126] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(126),
    [sym_block_comment] = STATE(126),
    [sym_line_comment] = STATE(126),
    [sym_compiler_directive_decl] = STATE(126),
    [sym_fsi_directive_decl] = STATE(126),
    [sym_preproc_line] = STATE(126),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_DOT_DOT2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
    [sym__dedent] = ACTIONS(241),
  },
  [127] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(127),
    [sym_block_comment] = STATE(127),
    [sym_line_comment] = STATE(127),
    [sym_compiler_directive_decl] = STATE(127),
    [sym_fsi_directive_decl] = STATE(127),
    [sym_preproc_line] = STATE(127),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_DOT_DOT2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [128] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(128),
    [sym_block_comment] = STATE(128),
    [sym_line_comment] = STATE(128),
    [sym_compiler_directive_decl] = STATE(128),
    [sym_fsi_directive_decl] = STATE(128),
    [sym_preproc_line] = STATE(128),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(243),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [129] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(129),
    [sym_block_comment] = STATE(129),
    [sym_line_comment] = STATE(129),
    [sym_compiler_directive_decl] = STATE(129),
    [sym_fsi_directive_decl] = STATE(129),
    [sym_preproc_line] = STATE(129),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_as] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [130] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(130),
    [sym_block_comment] = STATE(130),
    [sym_line_comment] = STATE(130),
    [sym_compiler_directive_decl] = STATE(130),
    [sym_fsi_directive_decl] = STATE(130),
    [sym_preproc_line] = STATE(130),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [131] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(822),
    [sym_infix_op] = STATE(816),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(131),
    [sym_block_comment] = STATE(131),
    [sym_line_comment] = STATE(131),
    [sym_compiler_directive_decl] = STATE(131),
    [sym_fsi_directive_decl] = STATE(131),
    [sym_preproc_line] = STATE(131),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_sequential_expression_repeat1] = STATE(1767),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_as] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [132] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(132),
    [sym_block_comment] = STATE(132),
    [sym_line_comment] = STATE(132),
    [sym_compiler_directive_decl] = STATE(132),
    [sym_fsi_directive_decl] = STATE(132),
    [sym_preproc_line] = STATE(132),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(231),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(876),
    [sym__dedent] = ACTIONS(231),
  },
  [133] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(133),
    [sym_block_comment] = STATE(133),
    [sym_line_comment] = STATE(133),
    [sym_compiler_directive_decl] = STATE(133),
    [sym_fsi_directive_decl] = STATE(133),
    [sym_preproc_line] = STATE(133),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(247),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(876),
    [sym__dedent] = ACTIONS(247),
  },
  [134] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(134),
    [sym_block_comment] = STATE(134),
    [sym_line_comment] = STATE(134),
    [sym_compiler_directive_decl] = STATE(134),
    [sym_fsi_directive_decl] = STATE(134),
    [sym_preproc_line] = STATE(134),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(219),
    [anon_sym_POUNDelse] = ACTIONS(219),
    [sym__newline] = ACTIONS(499),
  },
  [135] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(744),
    [sym_infix_op] = STATE(774),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(135),
    [sym_block_comment] = STATE(135),
    [sym_line_comment] = STATE(135),
    [sym_compiler_directive_decl] = STATE(135),
    [sym_fsi_directive_decl] = STATE(135),
    [sym_preproc_line] = STATE(135),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(1921),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_COLON_GT] = ACTIONS(762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(986),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(778),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_DOT_DOT] = ACTIONS(988),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(818),
  },
  [136] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(136),
    [sym_block_comment] = STATE(136),
    [sym_line_comment] = STATE(136),
    [sym_compiler_directive_decl] = STATE(136),
    [sym_fsi_directive_decl] = STATE(136),
    [sym_preproc_line] = STATE(136),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(251),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(251),
    [sym__dedent] = ACTIONS(251),
  },
  [137] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(137),
    [sym_block_comment] = STATE(137),
    [sym_line_comment] = STATE(137),
    [sym_compiler_directive_decl] = STATE(137),
    [sym_fsi_directive_decl] = STATE(137),
    [sym_preproc_line] = STATE(137),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(123),
    [anon_sym_POUNDelse] = ACTIONS(123),
    [sym__newline] = ACTIONS(123),
  },
  [138] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(138),
    [sym_block_comment] = STATE(138),
    [sym_line_comment] = STATE(138),
    [sym_compiler_directive_decl] = STATE(138),
    [sym_fsi_directive_decl] = STATE(138),
    [sym_preproc_line] = STATE(138),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(123),
    [sym__dedent] = ACTIONS(123),
  },
  [139] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(139),
    [sym_block_comment] = STATE(139),
    [sym_line_comment] = STATE(139),
    [sym_compiler_directive_decl] = STATE(139),
    [sym_fsi_directive_decl] = STATE(139),
    [sym_preproc_line] = STATE(139),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(251),
    [anon_sym_POUNDelse] = ACTIONS(251),
    [sym__newline] = ACTIONS(251),
  },
  [140] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(140),
    [sym_block_comment] = STATE(140),
    [sym_line_comment] = STATE(140),
    [sym_compiler_directive_decl] = STATE(140),
    [sym_fsi_directive_decl] = STATE(140),
    [sym_preproc_line] = STATE(140),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(247),
    [anon_sym_POUNDelse] = ACTIONS(247),
    [sym__newline] = ACTIONS(499),
  },
  [141] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(141),
    [sym_block_comment] = STATE(141),
    [sym_line_comment] = STATE(141),
    [sym_compiler_directive_decl] = STATE(141),
    [sym_fsi_directive_decl] = STATE(141),
    [sym_preproc_line] = STATE(141),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [anon_sym_POUNDelse] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [142] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(142),
    [sym_block_comment] = STATE(142),
    [sym_line_comment] = STATE(142),
    [sym_compiler_directive_decl] = STATE(142),
    [sym_fsi_directive_decl] = STATE(142),
    [sym_preproc_line] = STATE(142),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(990),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [143] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(143),
    [sym_block_comment] = STATE(143),
    [sym_line_comment] = STATE(143),
    [sym_compiler_directive_decl] = STATE(143),
    [sym_fsi_directive_decl] = STATE(143),
    [sym_preproc_line] = STATE(143),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [144] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(599),
    [sym_infix_op] = STATE(696),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(144),
    [sym_block_comment] = STATE(144),
    [sym_line_comment] = STATE(144),
    [sym_compiler_directive_decl] = STATE(144),
    [sym_fsi_directive_decl] = STATE(144),
    [sym_preproc_line] = STATE(144),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1874),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(219),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(718),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(219),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(728),
  },
  [145] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(760),
    [sym_infix_op] = STATE(609),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(145),
    [sym_block_comment] = STATE(145),
    [sym_line_comment] = STATE(145),
    [sym_compiler_directive_decl] = STATE(145),
    [sym_fsi_directive_decl] = STATE(145),
    [sym_preproc_line] = STATE(145),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(1966),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(642),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_DOT_DOT2] = ACTIONS(219),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(876),
    [sym__dedent] = ACTIONS(219),
  },
  [146] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(700),
    [sym_infix_op] = STATE(588),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym_line_comment] = STATE(146),
    [sym_compiler_directive_decl] = STATE(146),
    [sym_fsi_directive_decl] = STATE(146),
    [sym_preproc_line] = STATE(146),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_sequential_expression_repeat1] = STATE(1887),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_COLON_GT] = ACTIONS(437),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_LT_DASH] = ACTIONS(453),
    [anon_sym_DOT_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_LPAREN2] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(481),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [anon_sym_POUNDelse] = ACTIONS(231),
    [sym__newline] = ACTIONS(499),
  },
  [147] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym_line_comment] = STATE(147),
    [sym_compiler_directive_decl] = STATE(147),
    [sym_fsi_directive_decl] = STATE(147),
    [sym_preproc_line] = STATE(147),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1006),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [148] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(148),
    [sym_block_comment] = STATE(148),
    [sym_line_comment] = STATE(148),
    [sym_compiler_directive_decl] = STATE(148),
    [sym_fsi_directive_decl] = STATE(148),
    [sym_preproc_line] = STATE(148),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1018),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [149] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(149),
    [sym_block_comment] = STATE(149),
    [sym_line_comment] = STATE(149),
    [sym_compiler_directive_decl] = STATE(149),
    [sym_fsi_directive_decl] = STATE(149),
    [sym_preproc_line] = STATE(149),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1020),
  },
  [150] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(150),
    [sym_block_comment] = STATE(150),
    [sym_line_comment] = STATE(150),
    [sym_compiler_directive_decl] = STATE(150),
    [sym_fsi_directive_decl] = STATE(150),
    [sym_preproc_line] = STATE(150),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [151] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym_line_comment] = STATE(151),
    [sym_compiler_directive_decl] = STATE(151),
    [sym_fsi_directive_decl] = STATE(151),
    [sym_preproc_line] = STATE(151),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1112),
  },
  [152] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym_line_comment] = STATE(152),
    [sym_compiler_directive_decl] = STATE(152),
    [sym_fsi_directive_decl] = STATE(152),
    [sym_preproc_line] = STATE(152),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(888),
    [sym__newline] = ACTIONS(1202),
  },
  [153] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym_line_comment] = STATE(153),
    [sym_compiler_directive_decl] = STATE(153),
    [sym_fsi_directive_decl] = STATE(153),
    [sym_preproc_line] = STATE(153),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(223),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [154] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(154),
    [sym_block_comment] = STATE(154),
    [sym_line_comment] = STATE(154),
    [sym_compiler_directive_decl] = STATE(154),
    [sym_fsi_directive_decl] = STATE(154),
    [sym_preproc_line] = STATE(154),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1294),
  },
  [155] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(155),
    [sym_block_comment] = STATE(155),
    [sym_line_comment] = STATE(155),
    [sym_compiler_directive_decl] = STATE(155),
    [sym_fsi_directive_decl] = STATE(155),
    [sym_preproc_line] = STATE(155),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [156] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(156),
    [sym_block_comment] = STATE(156),
    [sym_line_comment] = STATE(156),
    [sym_compiler_directive_decl] = STATE(156),
    [sym_fsi_directive_decl] = STATE(156),
    [sym_preproc_line] = STATE(156),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1300),
  },
  [157] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym_line_comment] = STATE(157),
    [sym_compiler_directive_decl] = STATE(157),
    [sym_fsi_directive_decl] = STATE(157),
    [sym_preproc_line] = STATE(157),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1302),
  },
  [158] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(158),
    [sym_block_comment] = STATE(158),
    [sym_line_comment] = STATE(158),
    [sym_compiler_directive_decl] = STATE(158),
    [sym_fsi_directive_decl] = STATE(158),
    [sym_preproc_line] = STATE(158),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [159] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(159),
    [sym_block_comment] = STATE(159),
    [sym_line_comment] = STATE(159),
    [sym_compiler_directive_decl] = STATE(159),
    [sym_fsi_directive_decl] = STATE(159),
    [sym_preproc_line] = STATE(159),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [160] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(160),
    [sym_block_comment] = STATE(160),
    [sym_line_comment] = STATE(160),
    [sym_compiler_directive_decl] = STATE(160),
    [sym_fsi_directive_decl] = STATE(160),
    [sym_preproc_line] = STATE(160),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1396),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [161] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(161),
    [sym_block_comment] = STATE(161),
    [sym_line_comment] = STATE(161),
    [sym_compiler_directive_decl] = STATE(161),
    [sym_fsi_directive_decl] = STATE(161),
    [sym_preproc_line] = STATE(161),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(868),
    [sym__newline] = ACTIONS(1202),
  },
  [162] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(162),
    [sym_block_comment] = STATE(162),
    [sym_line_comment] = STATE(162),
    [sym_compiler_directive_decl] = STATE(162),
    [sym_fsi_directive_decl] = STATE(162),
    [sym_preproc_line] = STATE(162),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1398),
  },
  [163] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(163),
    [sym_block_comment] = STATE(163),
    [sym_line_comment] = STATE(163),
    [sym_compiler_directive_decl] = STATE(163),
    [sym_fsi_directive_decl] = STATE(163),
    [sym_preproc_line] = STATE(163),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [164] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym_line_comment] = STATE(164),
    [sym_compiler_directive_decl] = STATE(164),
    [sym_fsi_directive_decl] = STATE(164),
    [sym_preproc_line] = STATE(164),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(251),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(251),
  },
  [165] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(165),
    [sym_block_comment] = STATE(165),
    [sym_line_comment] = STATE(165),
    [sym_compiler_directive_decl] = STATE(165),
    [sym_fsi_directive_decl] = STATE(165),
    [sym_preproc_line] = STATE(165),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(123),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(123),
  },
  [166] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(166),
    [sym_block_comment] = STATE(166),
    [sym_line_comment] = STATE(166),
    [sym_compiler_directive_decl] = STATE(166),
    [sym_fsi_directive_decl] = STATE(166),
    [sym_preproc_line] = STATE(166),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1400),
  },
  [167] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(167),
    [sym_block_comment] = STATE(167),
    [sym_line_comment] = STATE(167),
    [sym_compiler_directive_decl] = STATE(167),
    [sym_fsi_directive_decl] = STATE(167),
    [sym_preproc_line] = STATE(167),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [168] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(168),
    [sym_block_comment] = STATE(168),
    [sym_line_comment] = STATE(168),
    [sym_compiler_directive_decl] = STATE(168),
    [sym_fsi_directive_decl] = STATE(168),
    [sym_preproc_line] = STATE(168),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(1406),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [169] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(169),
    [sym_block_comment] = STATE(169),
    [sym_line_comment] = STATE(169),
    [sym_compiler_directive_decl] = STATE(169),
    [sym_fsi_directive_decl] = STATE(169),
    [sym_preproc_line] = STATE(169),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1408),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [170] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(170),
    [sym_block_comment] = STATE(170),
    [sym_line_comment] = STATE(170),
    [sym_compiler_directive_decl] = STATE(170),
    [sym_fsi_directive_decl] = STATE(170),
    [sym_preproc_line] = STATE(170),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1410),
  },
  [171] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym_line_comment] = STATE(171),
    [sym_compiler_directive_decl] = STATE(171),
    [sym_fsi_directive_decl] = STATE(171),
    [sym_preproc_line] = STATE(171),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1412),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [172] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(172),
    [sym_block_comment] = STATE(172),
    [sym_line_comment] = STATE(172),
    [sym_compiler_directive_decl] = STATE(172),
    [sym_fsi_directive_decl] = STATE(172),
    [sym_preproc_line] = STATE(172),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [173] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(173),
    [sym_block_comment] = STATE(173),
    [sym_line_comment] = STATE(173),
    [sym_compiler_directive_decl] = STATE(173),
    [sym_fsi_directive_decl] = STATE(173),
    [sym_preproc_line] = STATE(173),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [174] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym_line_comment] = STATE(174),
    [sym_compiler_directive_decl] = STATE(174),
    [sym_fsi_directive_decl] = STATE(174),
    [sym_preproc_line] = STATE(174),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1416),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [175] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(175),
    [sym_block_comment] = STATE(175),
    [sym_line_comment] = STATE(175),
    [sym_compiler_directive_decl] = STATE(175),
    [sym_fsi_directive_decl] = STATE(175),
    [sym_preproc_line] = STATE(175),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1416),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [176] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(176),
    [sym_block_comment] = STATE(176),
    [sym_line_comment] = STATE(176),
    [sym_compiler_directive_decl] = STATE(176),
    [sym_fsi_directive_decl] = STATE(176),
    [sym_preproc_line] = STATE(176),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1418),
  },
  [177] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(177),
    [sym_block_comment] = STATE(177),
    [sym_line_comment] = STATE(177),
    [sym_compiler_directive_decl] = STATE(177),
    [sym_fsi_directive_decl] = STATE(177),
    [sym_preproc_line] = STATE(177),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1420),
  },
  [178] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(178),
    [sym_block_comment] = STATE(178),
    [sym_line_comment] = STATE(178),
    [sym_compiler_directive_decl] = STATE(178),
    [sym_fsi_directive_decl] = STATE(178),
    [sym_preproc_line] = STATE(178),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1422),
  },
  [179] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(179),
    [sym_block_comment] = STATE(179),
    [sym_line_comment] = STATE(179),
    [sym_compiler_directive_decl] = STATE(179),
    [sym_fsi_directive_decl] = STATE(179),
    [sym_preproc_line] = STATE(179),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_AT_GT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [180] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym_line_comment] = STATE(180),
    [sym_compiler_directive_decl] = STATE(180),
    [sym_fsi_directive_decl] = STATE(180),
    [sym_preproc_line] = STATE(180),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(147),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(123),
  },
  [181] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(181),
    [sym_block_comment] = STATE(181),
    [sym_line_comment] = STATE(181),
    [sym_compiler_directive_decl] = STATE(181),
    [sym_fsi_directive_decl] = STATE(181),
    [sym_preproc_line] = STATE(181),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(219),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [182] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym_line_comment] = STATE(182),
    [sym_compiler_directive_decl] = STATE(182),
    [sym_fsi_directive_decl] = STATE(182),
    [sym_preproc_line] = STATE(182),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(253),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(251),
  },
  [183] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(183),
    [sym_block_comment] = STATE(183),
    [sym_line_comment] = STATE(183),
    [sym_compiler_directive_decl] = STATE(183),
    [sym_fsi_directive_decl] = STATE(183),
    [sym_preproc_line] = STATE(183),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(249),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [184] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(184),
    [sym_block_comment] = STATE(184),
    [sym_line_comment] = STATE(184),
    [sym_compiler_directive_decl] = STATE(184),
    [sym_fsi_directive_decl] = STATE(184),
    [sym_preproc_line] = STATE(184),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [185] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(185),
    [sym_block_comment] = STATE(185),
    [sym_line_comment] = STATE(185),
    [sym_compiler_directive_decl] = STATE(185),
    [sym_fsi_directive_decl] = STATE(185),
    [sym_preproc_line] = STATE(185),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1426),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [186] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(186),
    [sym_block_comment] = STATE(186),
    [sym_line_comment] = STATE(186),
    [sym_compiler_directive_decl] = STATE(186),
    [sym_fsi_directive_decl] = STATE(186),
    [sym_preproc_line] = STATE(186),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_AT_GT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [187] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(187),
    [sym_block_comment] = STATE(187),
    [sym_line_comment] = STATE(187),
    [sym_compiler_directive_decl] = STATE(187),
    [sym_fsi_directive_decl] = STATE(187),
    [sym_preproc_line] = STATE(187),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1430),
  },
  [188] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(188),
    [sym_block_comment] = STATE(188),
    [sym_line_comment] = STATE(188),
    [sym_compiler_directive_decl] = STATE(188),
    [sym_fsi_directive_decl] = STATE(188),
    [sym_preproc_line] = STATE(188),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [189] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(189),
    [sym_block_comment] = STATE(189),
    [sym_line_comment] = STATE(189),
    [sym_compiler_directive_decl] = STATE(189),
    [sym_fsi_directive_decl] = STATE(189),
    [sym_preproc_line] = STATE(189),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1434),
  },
  [190] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(190),
    [sym_block_comment] = STATE(190),
    [sym_line_comment] = STATE(190),
    [sym_compiler_directive_decl] = STATE(190),
    [sym_fsi_directive_decl] = STATE(190),
    [sym_preproc_line] = STATE(190),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1436),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [191] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(191),
    [sym_block_comment] = STATE(191),
    [sym_line_comment] = STATE(191),
    [sym_compiler_directive_decl] = STATE(191),
    [sym_fsi_directive_decl] = STATE(191),
    [sym_preproc_line] = STATE(191),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1438),
  },
  [192] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(192),
    [sym_block_comment] = STATE(192),
    [sym_line_comment] = STATE(192),
    [sym_compiler_directive_decl] = STATE(192),
    [sym_fsi_directive_decl] = STATE(192),
    [sym_preproc_line] = STATE(192),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(227),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [193] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(193),
    [sym_block_comment] = STATE(193),
    [sym_line_comment] = STATE(193),
    [sym_compiler_directive_decl] = STATE(193),
    [sym_fsi_directive_decl] = STATE(193),
    [sym_preproc_line] = STATE(193),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1446),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [194] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(194),
    [sym_block_comment] = STATE(194),
    [sym_line_comment] = STATE(194),
    [sym_compiler_directive_decl] = STATE(194),
    [sym_fsi_directive_decl] = STATE(194),
    [sym_preproc_line] = STATE(194),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [195] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(195),
    [sym_block_comment] = STATE(195),
    [sym_line_comment] = STATE(195),
    [sym_compiler_directive_decl] = STATE(195),
    [sym_fsi_directive_decl] = STATE(195),
    [sym_preproc_line] = STATE(195),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1448),
  },
  [196] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(196),
    [sym_block_comment] = STATE(196),
    [sym_line_comment] = STATE(196),
    [sym_compiler_directive_decl] = STATE(196),
    [sym_fsi_directive_decl] = STATE(196),
    [sym_preproc_line] = STATE(196),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [197] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(197),
    [sym_block_comment] = STATE(197),
    [sym_line_comment] = STATE(197),
    [sym_compiler_directive_decl] = STATE(197),
    [sym_fsi_directive_decl] = STATE(197),
    [sym_preproc_line] = STATE(197),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_AT_GT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [198] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(198),
    [sym_block_comment] = STATE(198),
    [sym_line_comment] = STATE(198),
    [sym_compiler_directive_decl] = STATE(198),
    [sym_fsi_directive_decl] = STATE(198),
    [sym_preproc_line] = STATE(198),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1452),
  },
  [199] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym_line_comment] = STATE(199),
    [sym_compiler_directive_decl] = STATE(199),
    [sym_fsi_directive_decl] = STATE(199),
    [sym_preproc_line] = STATE(199),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [200] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym_line_comment] = STATE(200),
    [sym_compiler_directive_decl] = STATE(200),
    [sym_fsi_directive_decl] = STATE(200),
    [sym_preproc_line] = STATE(200),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(233),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [201] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym_line_comment] = STATE(201),
    [sym_compiler_directive_decl] = STATE(201),
    [sym_fsi_directive_decl] = STATE(201),
    [sym_preproc_line] = STATE(201),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1454),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [202] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(202),
    [sym_block_comment] = STATE(202),
    [sym_line_comment] = STATE(202),
    [sym_compiler_directive_decl] = STATE(202),
    [sym_fsi_directive_decl] = STATE(202),
    [sym_preproc_line] = STATE(202),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [203] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(203),
    [sym_block_comment] = STATE(203),
    [sym_line_comment] = STATE(203),
    [sym_compiler_directive_decl] = STATE(203),
    [sym_fsi_directive_decl] = STATE(203),
    [sym_preproc_line] = STATE(203),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1456),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [204] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(204),
    [sym_block_comment] = STATE(204),
    [sym_line_comment] = STATE(204),
    [sym_compiler_directive_decl] = STATE(204),
    [sym_fsi_directive_decl] = STATE(204),
    [sym_preproc_line] = STATE(204),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1458),
  },
  [205] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(205),
    [sym_block_comment] = STATE(205),
    [sym_line_comment] = STATE(205),
    [sym_compiler_directive_decl] = STATE(205),
    [sym_fsi_directive_decl] = STATE(205),
    [sym_preproc_line] = STATE(205),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1460),
  },
  [206] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(206),
    [sym_block_comment] = STATE(206),
    [sym_line_comment] = STATE(206),
    [sym_compiler_directive_decl] = STATE(206),
    [sym_fsi_directive_decl] = STATE(206),
    [sym_preproc_line] = STATE(206),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1462),
  },
  [207] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(207),
    [sym_block_comment] = STATE(207),
    [sym_line_comment] = STATE(207),
    [sym_compiler_directive_decl] = STATE(207),
    [sym_fsi_directive_decl] = STATE(207),
    [sym_preproc_line] = STATE(207),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1464),
  },
  [208] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym_line_comment] = STATE(208),
    [sym_compiler_directive_decl] = STATE(208),
    [sym_fsi_directive_decl] = STATE(208),
    [sym_preproc_line] = STATE(208),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1466),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [209] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(209),
    [sym_block_comment] = STATE(209),
    [sym_line_comment] = STATE(209),
    [sym_compiler_directive_decl] = STATE(209),
    [sym_fsi_directive_decl] = STATE(209),
    [sym_preproc_line] = STATE(209),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1468),
  },
  [210] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(210),
    [sym_block_comment] = STATE(210),
    [sym_line_comment] = STATE(210),
    [sym_compiler_directive_decl] = STATE(210),
    [sym_fsi_directive_decl] = STATE(210),
    [sym_preproc_line] = STATE(210),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(243),
  },
  [211] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(211),
    [sym_block_comment] = STATE(211),
    [sym_line_comment] = STATE(211),
    [sym_compiler_directive_decl] = STATE(211),
    [sym_fsi_directive_decl] = STATE(211),
    [sym_preproc_line] = STATE(211),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [212] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(212),
    [sym_block_comment] = STATE(212),
    [sym_line_comment] = STATE(212),
    [sym_compiler_directive_decl] = STATE(212),
    [sym_fsi_directive_decl] = STATE(212),
    [sym_preproc_line] = STATE(212),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1472),
  },
  [213] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(213),
    [sym_block_comment] = STATE(213),
    [sym_line_comment] = STATE(213),
    [sym_compiler_directive_decl] = STATE(213),
    [sym_fsi_directive_decl] = STATE(213),
    [sym_preproc_line] = STATE(213),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(245),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(243),
  },
  [214] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(214),
    [sym_block_comment] = STATE(214),
    [sym_line_comment] = STATE(214),
    [sym_compiler_directive_decl] = STATE(214),
    [sym_fsi_directive_decl] = STATE(214),
    [sym_preproc_line] = STATE(214),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1474),
  },
  [215] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(215),
    [sym_block_comment] = STATE(215),
    [sym_line_comment] = STATE(215),
    [sym_compiler_directive_decl] = STATE(215),
    [sym_fsi_directive_decl] = STATE(215),
    [sym_preproc_line] = STATE(215),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1476),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [216] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym_line_comment] = STATE(216),
    [sym_compiler_directive_decl] = STATE(216),
    [sym_fsi_directive_decl] = STATE(216),
    [sym_preproc_line] = STATE(216),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1476),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [217] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(217),
    [sym_block_comment] = STATE(217),
    [sym_line_comment] = STATE(217),
    [sym_compiler_directive_decl] = STATE(217),
    [sym_fsi_directive_decl] = STATE(217),
    [sym_preproc_line] = STATE(217),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1478),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [218] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym_line_comment] = STATE(218),
    [sym_compiler_directive_decl] = STATE(218),
    [sym_fsi_directive_decl] = STATE(218),
    [sym_preproc_line] = STATE(218),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1480),
  },
  [219] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(219),
    [sym_block_comment] = STATE(219),
    [sym_line_comment] = STATE(219),
    [sym_compiler_directive_decl] = STATE(219),
    [sym_fsi_directive_decl] = STATE(219),
    [sym_preproc_line] = STATE(219),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1482),
  },
  [220] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym_line_comment] = STATE(220),
    [sym_compiler_directive_decl] = STATE(220),
    [sym_fsi_directive_decl] = STATE(220),
    [sym_preproc_line] = STATE(220),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1484),
  },
  [221] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym_line_comment] = STATE(221),
    [sym_compiler_directive_decl] = STATE(221),
    [sym_fsi_directive_decl] = STATE(221),
    [sym_preproc_line] = STATE(221),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(874),
    [sym__dedent] = ACTIONS(874),
  },
  [222] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(222),
    [sym_block_comment] = STATE(222),
    [sym_line_comment] = STATE(222),
    [sym_compiler_directive_decl] = STATE(222),
    [sym_fsi_directive_decl] = STATE(222),
    [sym_preproc_line] = STATE(222),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1486),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [223] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(223),
    [sym_block_comment] = STATE(223),
    [sym_line_comment] = STATE(223),
    [sym_compiler_directive_decl] = STATE(223),
    [sym_fsi_directive_decl] = STATE(223),
    [sym_preproc_line] = STATE(223),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1490),
  },
  [224] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(224),
    [sym_block_comment] = STATE(224),
    [sym_line_comment] = STATE(224),
    [sym_compiler_directive_decl] = STATE(224),
    [sym_fsi_directive_decl] = STATE(224),
    [sym_preproc_line] = STATE(224),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1492),
  },
  [225] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(225),
    [sym_block_comment] = STATE(225),
    [sym_line_comment] = STATE(225),
    [sym_compiler_directive_decl] = STATE(225),
    [sym_fsi_directive_decl] = STATE(225),
    [sym_preproc_line] = STATE(225),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1494),
  },
  [226] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(226),
    [sym_block_comment] = STATE(226),
    [sym_line_comment] = STATE(226),
    [sym_compiler_directive_decl] = STATE(226),
    [sym_fsi_directive_decl] = STATE(226),
    [sym_preproc_line] = STATE(226),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1496),
  },
  [227] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(227),
    [sym_block_comment] = STATE(227),
    [sym_line_comment] = STATE(227),
    [sym_compiler_directive_decl] = STATE(227),
    [sym_fsi_directive_decl] = STATE(227),
    [sym_preproc_line] = STATE(227),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [228] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(228),
    [sym_block_comment] = STATE(228),
    [sym_line_comment] = STATE(228),
    [sym_compiler_directive_decl] = STATE(228),
    [sym_fsi_directive_decl] = STATE(228),
    [sym_preproc_line] = STATE(228),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1498),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1500),
  },
  [229] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(229),
    [sym_block_comment] = STATE(229),
    [sym_line_comment] = STATE(229),
    [sym_compiler_directive_decl] = STATE(229),
    [sym_fsi_directive_decl] = STATE(229),
    [sym_preproc_line] = STATE(229),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1502),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [230] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(230),
    [sym_block_comment] = STATE(230),
    [sym_line_comment] = STATE(230),
    [sym_compiler_directive_decl] = STATE(230),
    [sym_fsi_directive_decl] = STATE(230),
    [sym_preproc_line] = STATE(230),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1504),
  },
  [231] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym_line_comment] = STATE(231),
    [sym_compiler_directive_decl] = STATE(231),
    [sym_fsi_directive_decl] = STATE(231),
    [sym_preproc_line] = STATE(231),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1506),
  },
  [232] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(232),
    [sym_block_comment] = STATE(232),
    [sym_line_comment] = STATE(232),
    [sym_compiler_directive_decl] = STATE(232),
    [sym_fsi_directive_decl] = STATE(232),
    [sym_preproc_line] = STATE(232),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1508),
  },
  [233] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(233),
    [sym_block_comment] = STATE(233),
    [sym_line_comment] = STATE(233),
    [sym_compiler_directive_decl] = STATE(233),
    [sym_fsi_directive_decl] = STATE(233),
    [sym_preproc_line] = STATE(233),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [234] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(234),
    [sym_block_comment] = STATE(234),
    [sym_line_comment] = STATE(234),
    [sym_compiler_directive_decl] = STATE(234),
    [sym_fsi_directive_decl] = STATE(234),
    [sym_preproc_line] = STATE(234),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1512),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [235] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(235),
    [sym_block_comment] = STATE(235),
    [sym_line_comment] = STATE(235),
    [sym_compiler_directive_decl] = STATE(235),
    [sym_fsi_directive_decl] = STATE(235),
    [sym_preproc_line] = STATE(235),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [236] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(236),
    [sym_block_comment] = STATE(236),
    [sym_line_comment] = STATE(236),
    [sym_compiler_directive_decl] = STATE(236),
    [sym_fsi_directive_decl] = STATE(236),
    [sym_preproc_line] = STATE(236),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1512),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [237] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(237),
    [sym_block_comment] = STATE(237),
    [sym_line_comment] = STATE(237),
    [sym_compiler_directive_decl] = STATE(237),
    [sym_fsi_directive_decl] = STATE(237),
    [sym_preproc_line] = STATE(237),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [238] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(238),
    [sym_block_comment] = STATE(238),
    [sym_line_comment] = STATE(238),
    [sym_compiler_directive_decl] = STATE(238),
    [sym_fsi_directive_decl] = STATE(238),
    [sym_preproc_line] = STATE(238),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1518),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1520),
  },
  [239] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(239),
    [sym_block_comment] = STATE(239),
    [sym_line_comment] = STATE(239),
    [sym_compiler_directive_decl] = STATE(239),
    [sym_fsi_directive_decl] = STATE(239),
    [sym_preproc_line] = STATE(239),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [240] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(240),
    [sym_block_comment] = STATE(240),
    [sym_line_comment] = STATE(240),
    [sym_compiler_directive_decl] = STATE(240),
    [sym_fsi_directive_decl] = STATE(240),
    [sym_preproc_line] = STATE(240),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [241] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(241),
    [sym_block_comment] = STATE(241),
    [sym_line_comment] = STATE(241),
    [sym_compiler_directive_decl] = STATE(241),
    [sym_fsi_directive_decl] = STATE(241),
    [sym_preproc_line] = STATE(241),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1526),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [242] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_line_comment] = STATE(242),
    [sym_compiler_directive_decl] = STATE(242),
    [sym_fsi_directive_decl] = STATE(242),
    [sym_preproc_line] = STATE(242),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1528),
  },
  [243] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym_line_comment] = STATE(243),
    [sym_compiler_directive_decl] = STATE(243),
    [sym_fsi_directive_decl] = STATE(243),
    [sym_preproc_line] = STATE(243),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1530),
  },
  [244] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(244),
    [sym_block_comment] = STATE(244),
    [sym_line_comment] = STATE(244),
    [sym_compiler_directive_decl] = STATE(244),
    [sym_fsi_directive_decl] = STATE(244),
    [sym_preproc_line] = STATE(244),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1532),
  },
  [245] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(245),
    [sym_block_comment] = STATE(245),
    [sym_line_comment] = STATE(245),
    [sym_compiler_directive_decl] = STATE(245),
    [sym_fsi_directive_decl] = STATE(245),
    [sym_preproc_line] = STATE(245),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_AT_AT_GT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [246] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(246),
    [sym_block_comment] = STATE(246),
    [sym_line_comment] = STATE(246),
    [sym_compiler_directive_decl] = STATE(246),
    [sym_fsi_directive_decl] = STATE(246),
    [sym_preproc_line] = STATE(246),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(147),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(123),
  },
  [247] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_line_comment] = STATE(247),
    [sym_compiler_directive_decl] = STATE(247),
    [sym_fsi_directive_decl] = STATE(247),
    [sym_preproc_line] = STATE(247),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(253),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(251),
  },
  [248] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(248),
    [sym_block_comment] = STATE(248),
    [sym_line_comment] = STATE(248),
    [sym_compiler_directive_decl] = STATE(248),
    [sym_fsi_directive_decl] = STATE(248),
    [sym_preproc_line] = STATE(248),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_GT_RBRACK] = ACTIONS(1534),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1534),
  },
  [249] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(249),
    [sym_block_comment] = STATE(249),
    [sym_line_comment] = STATE(249),
    [sym_compiler_directive_decl] = STATE(249),
    [sym_fsi_directive_decl] = STATE(249),
    [sym_preproc_line] = STATE(249),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(1536),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1536),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [250] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_line_comment] = STATE(250),
    [sym_compiler_directive_decl] = STATE(250),
    [sym_fsi_directive_decl] = STATE(250),
    [sym_preproc_line] = STATE(250),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(245),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(243),
  },
  [251] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_line_comment] = STATE(251),
    [sym_compiler_directive_decl] = STATE(251),
    [sym_fsi_directive_decl] = STATE(251),
    [sym_preproc_line] = STATE(251),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(1620),
  },
  [252] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_line_comment] = STATE(252),
    [sym_compiler_directive_decl] = STATE(252),
    [sym_fsi_directive_decl] = STATE(252),
    [sym_preproc_line] = STATE(252),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1622),
  },
  [253] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_line_comment] = STATE(253),
    [sym_compiler_directive_decl] = STATE(253),
    [sym_fsi_directive_decl] = STATE(253),
    [sym_preproc_line] = STATE(253),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_DASH_GT] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [254] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_line_comment] = STATE(254),
    [sym_compiler_directive_decl] = STATE(254),
    [sym_fsi_directive_decl] = STATE(254),
    [sym_preproc_line] = STATE(254),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1624),
  },
  [255] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_line_comment] = STATE(255),
    [sym_compiler_directive_decl] = STATE(255),
    [sym_fsi_directive_decl] = STATE(255),
    [sym_preproc_line] = STATE(255),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_DASH_GT] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [256] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_line_comment] = STATE(256),
    [sym_compiler_directive_decl] = STATE(256),
    [sym_fsi_directive_decl] = STATE(256),
    [sym_preproc_line] = STATE(256),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1626),
  },
  [257] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(257),
    [sym_block_comment] = STATE(257),
    [sym_line_comment] = STATE(257),
    [sym_compiler_directive_decl] = STATE(257),
    [sym_fsi_directive_decl] = STATE(257),
    [sym_preproc_line] = STATE(257),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1628),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1630),
  },
  [258] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_line_comment] = STATE(258),
    [sym_compiler_directive_decl] = STATE(258),
    [sym_fsi_directive_decl] = STATE(258),
    [sym_preproc_line] = STATE(258),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(1620),
  },
  [259] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(259),
    [sym_block_comment] = STATE(259),
    [sym_line_comment] = STATE(259),
    [sym_compiler_directive_decl] = STATE(259),
    [sym_fsi_directive_decl] = STATE(259),
    [sym_preproc_line] = STATE(259),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1632),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [260] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym_line_comment] = STATE(260),
    [sym_compiler_directive_decl] = STATE(260),
    [sym_fsi_directive_decl] = STATE(260),
    [sym_preproc_line] = STATE(260),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1634),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [261] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(261),
    [sym_block_comment] = STATE(261),
    [sym_line_comment] = STATE(261),
    [sym_compiler_directive_decl] = STATE(261),
    [sym_fsi_directive_decl] = STATE(261),
    [sym_preproc_line] = STATE(261),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [262] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym_line_comment] = STATE(262),
    [sym_compiler_directive_decl] = STATE(262),
    [sym_fsi_directive_decl] = STATE(262),
    [sym_preproc_line] = STATE(262),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(253),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(251),
  },
  [263] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym_line_comment] = STATE(263),
    [sym_compiler_directive_decl] = STATE(263),
    [sym_fsi_directive_decl] = STATE(263),
    [sym_preproc_line] = STATE(263),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(123),
  },
  [264] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym_line_comment] = STATE(264),
    [sym_compiler_directive_decl] = STATE(264),
    [sym_fsi_directive_decl] = STATE(264),
    [sym_preproc_line] = STATE(264),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [265] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym_line_comment] = STATE(265),
    [sym_compiler_directive_decl] = STATE(265),
    [sym_fsi_directive_decl] = STATE(265),
    [sym_preproc_line] = STATE(265),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [266] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym_line_comment] = STATE(266),
    [sym_compiler_directive_decl] = STATE(266),
    [sym_fsi_directive_decl] = STATE(266),
    [sym_preproc_line] = STATE(266),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1640),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [267] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym_line_comment] = STATE(267),
    [sym_compiler_directive_decl] = STATE(267),
    [sym_fsi_directive_decl] = STATE(267),
    [sym_preproc_line] = STATE(267),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1406),
  },
  [268] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym_line_comment] = STATE(268),
    [sym_compiler_directive_decl] = STATE(268),
    [sym_fsi_directive_decl] = STATE(268),
    [sym_preproc_line] = STATE(268),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1640),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [269] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym_line_comment] = STATE(269),
    [sym_compiler_directive_decl] = STATE(269),
    [sym_fsi_directive_decl] = STATE(269),
    [sym_preproc_line] = STATE(269),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1636),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [270] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym_line_comment] = STATE(270),
    [sym_compiler_directive_decl] = STATE(270),
    [sym_fsi_directive_decl] = STATE(270),
    [sym_preproc_line] = STATE(270),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1642),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [271] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(271),
    [sym_block_comment] = STATE(271),
    [sym_line_comment] = STATE(271),
    [sym_compiler_directive_decl] = STATE(271),
    [sym_fsi_directive_decl] = STATE(271),
    [sym_preproc_line] = STATE(271),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(249),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [272] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym_line_comment] = STATE(272),
    [sym_compiler_directive_decl] = STATE(272),
    [sym_fsi_directive_decl] = STATE(272),
    [sym_preproc_line] = STATE(272),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1644),
  },
  [273] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym_line_comment] = STATE(273),
    [sym_compiler_directive_decl] = STATE(273),
    [sym_fsi_directive_decl] = STATE(273),
    [sym_preproc_line] = STATE(273),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1646),
  },
  [274] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym_line_comment] = STATE(274),
    [sym_compiler_directive_decl] = STATE(274),
    [sym_fsi_directive_decl] = STATE(274),
    [sym_preproc_line] = STATE(274),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(223),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(1620),
  },
  [275] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym_line_comment] = STATE(275),
    [sym_compiler_directive_decl] = STATE(275),
    [sym_fsi_directive_decl] = STATE(275),
    [sym_preproc_line] = STATE(275),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1648),
  },
  [276] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym_line_comment] = STATE(276),
    [sym_compiler_directive_decl] = STATE(276),
    [sym_fsi_directive_decl] = STATE(276),
    [sym_preproc_line] = STATE(276),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [277] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym_line_comment] = STATE(277),
    [sym_compiler_directive_decl] = STATE(277),
    [sym_fsi_directive_decl] = STATE(277),
    [sym_preproc_line] = STATE(277),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_AT_AT_GT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [278] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym_line_comment] = STATE(278),
    [sym_compiler_directive_decl] = STATE(278),
    [sym_fsi_directive_decl] = STATE(278),
    [sym_preproc_line] = STATE(278),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1652),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1654),
  },
  [279] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym_line_comment] = STATE(279),
    [sym_compiler_directive_decl] = STATE(279),
    [sym_fsi_directive_decl] = STATE(279),
    [sym_preproc_line] = STATE(279),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1656),
  },
  [280] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym_line_comment] = STATE(280),
    [sym_compiler_directive_decl] = STATE(280),
    [sym_fsi_directive_decl] = STATE(280),
    [sym_preproc_line] = STATE(280),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1658),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [281] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(281),
    [sym_block_comment] = STATE(281),
    [sym_line_comment] = STATE(281),
    [sym_compiler_directive_decl] = STATE(281),
    [sym_fsi_directive_decl] = STATE(281),
    [sym_preproc_line] = STATE(281),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1660),
  },
  [282] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(282),
    [sym_block_comment] = STATE(282),
    [sym_line_comment] = STATE(282),
    [sym_compiler_directive_decl] = STATE(282),
    [sym_fsi_directive_decl] = STATE(282),
    [sym_preproc_line] = STATE(282),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1662),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [283] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym_line_comment] = STATE(283),
    [sym_compiler_directive_decl] = STATE(283),
    [sym_fsi_directive_decl] = STATE(283),
    [sym_preproc_line] = STATE(283),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1664),
  },
  [284] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym_line_comment] = STATE(284),
    [sym_compiler_directive_decl] = STATE(284),
    [sym_fsi_directive_decl] = STATE(284),
    [sym_preproc_line] = STATE(284),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [anon_sym_POUNDendif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [285] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym_line_comment] = STATE(285),
    [sym_compiler_directive_decl] = STATE(285),
    [sym_fsi_directive_decl] = STATE(285),
    [sym_preproc_line] = STATE(285),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [anon_sym_POUNDendif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [286] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym_line_comment] = STATE(286),
    [sym_compiler_directive_decl] = STATE(286),
    [sym_fsi_directive_decl] = STATE(286),
    [sym_preproc_line] = STATE(286),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1666),
  },
  [287] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(287),
    [sym_block_comment] = STATE(287),
    [sym_line_comment] = STATE(287),
    [sym_compiler_directive_decl] = STATE(287),
    [sym_fsi_directive_decl] = STATE(287),
    [sym_preproc_line] = STATE(287),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1668),
  },
  [288] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(288),
    [sym_block_comment] = STATE(288),
    [sym_line_comment] = STATE(288),
    [sym_compiler_directive_decl] = STATE(288),
    [sym_fsi_directive_decl] = STATE(288),
    [sym_preproc_line] = STATE(288),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(1670),
    [sym__newline] = ACTIONS(1202),
  },
  [289] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(289),
    [sym_block_comment] = STATE(289),
    [sym_line_comment] = STATE(289),
    [sym_compiler_directive_decl] = STATE(289),
    [sym_fsi_directive_decl] = STATE(289),
    [sym_preproc_line] = STATE(289),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1672),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [290] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(290),
    [sym_block_comment] = STATE(290),
    [sym_line_comment] = STATE(290),
    [sym_compiler_directive_decl] = STATE(290),
    [sym_fsi_directive_decl] = STATE(290),
    [sym_preproc_line] = STATE(290),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [291] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_line_comment] = STATE(291),
    [sym_compiler_directive_decl] = STATE(291),
    [sym_fsi_directive_decl] = STATE(291),
    [sym_preproc_line] = STATE(291),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1676),
  },
  [292] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym_line_comment] = STATE(292),
    [sym_compiler_directive_decl] = STATE(292),
    [sym_fsi_directive_decl] = STATE(292),
    [sym_preproc_line] = STATE(292),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1678),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [293] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym_line_comment] = STATE(293),
    [sym_compiler_directive_decl] = STATE(293),
    [sym_fsi_directive_decl] = STATE(293),
    [sym_preproc_line] = STATE(293),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(874),
    [sym__dedent] = ACTIONS(874),
  },
  [294] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym_line_comment] = STATE(294),
    [sym_compiler_directive_decl] = STATE(294),
    [sym_fsi_directive_decl] = STATE(294),
    [sym_preproc_line] = STATE(294),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1680),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [295] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(295),
    [sym_block_comment] = STATE(295),
    [sym_line_comment] = STATE(295),
    [sym_compiler_directive_decl] = STATE(295),
    [sym_fsi_directive_decl] = STATE(295),
    [sym_preproc_line] = STATE(295),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1682),
  },
  [296] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym_line_comment] = STATE(296),
    [sym_compiler_directive_decl] = STATE(296),
    [sym_fsi_directive_decl] = STATE(296),
    [sym_preproc_line] = STATE(296),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1684),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [297] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(297),
    [sym_block_comment] = STATE(297),
    [sym_line_comment] = STATE(297),
    [sym_compiler_directive_decl] = STATE(297),
    [sym_fsi_directive_decl] = STATE(297),
    [sym_preproc_line] = STATE(297),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1686),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [298] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym_line_comment] = STATE(298),
    [sym_compiler_directive_decl] = STATE(298),
    [sym_fsi_directive_decl] = STATE(298),
    [sym_preproc_line] = STATE(298),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [299] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym_line_comment] = STATE(299),
    [sym_compiler_directive_decl] = STATE(299),
    [sym_fsi_directive_decl] = STATE(299),
    [sym_preproc_line] = STATE(299),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1690),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [300] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym_line_comment] = STATE(300),
    [sym_compiler_directive_decl] = STATE(300),
    [sym_fsi_directive_decl] = STATE(300),
    [sym_preproc_line] = STATE(300),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [301] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym_line_comment] = STATE(301),
    [sym_compiler_directive_decl] = STATE(301),
    [sym_fsi_directive_decl] = STATE(301),
    [sym_preproc_line] = STATE(301),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1694),
  },
  [302] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym_line_comment] = STATE(302),
    [sym_compiler_directive_decl] = STATE(302),
    [sym_fsi_directive_decl] = STATE(302),
    [sym_preproc_line] = STATE(302),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [anon_sym_POUNDendif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [303] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(303),
    [sym_block_comment] = STATE(303),
    [sym_line_comment] = STATE(303),
    [sym_compiler_directive_decl] = STATE(303),
    [sym_fsi_directive_decl] = STATE(303),
    [sym_preproc_line] = STATE(303),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1688),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [304] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym_line_comment] = STATE(304),
    [sym_compiler_directive_decl] = STATE(304),
    [sym_fsi_directive_decl] = STATE(304),
    [sym_preproc_line] = STATE(304),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1696),
  },
  [305] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym_line_comment] = STATE(305),
    [sym_compiler_directive_decl] = STATE(305),
    [sym_fsi_directive_decl] = STATE(305),
    [sym_preproc_line] = STATE(305),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1698),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1700),
  },
  [306] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym_line_comment] = STATE(306),
    [sym_compiler_directive_decl] = STATE(306),
    [sym_fsi_directive_decl] = STATE(306),
    [sym_preproc_line] = STATE(306),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1690),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [307] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym_line_comment] = STATE(307),
    [sym_compiler_directive_decl] = STATE(307),
    [sym_fsi_directive_decl] = STATE(307),
    [sym_preproc_line] = STATE(307),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1702),
  },
  [308] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym_line_comment] = STATE(308),
    [sym_compiler_directive_decl] = STATE(308),
    [sym_fsi_directive_decl] = STATE(308),
    [sym_preproc_line] = STATE(308),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1704),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [309] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym_line_comment] = STATE(309),
    [sym_compiler_directive_decl] = STATE(309),
    [sym_fsi_directive_decl] = STATE(309),
    [sym_preproc_line] = STATE(309),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(245),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(243),
  },
  [310] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym_line_comment] = STATE(310),
    [sym_compiler_directive_decl] = STATE(310),
    [sym_fsi_directive_decl] = STATE(310),
    [sym_preproc_line] = STATE(310),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1704),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [311] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(311),
    [sym_block_comment] = STATE(311),
    [sym_line_comment] = STATE(311),
    [sym_compiler_directive_decl] = STATE(311),
    [sym_fsi_directive_decl] = STATE(311),
    [sym_preproc_line] = STATE(311),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1706),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [312] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(312),
    [sym_block_comment] = STATE(312),
    [sym_line_comment] = STATE(312),
    [sym_compiler_directive_decl] = STATE(312),
    [sym_fsi_directive_decl] = STATE(312),
    [sym_preproc_line] = STATE(312),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1708),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [313] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(313),
    [sym_block_comment] = STATE(313),
    [sym_line_comment] = STATE(313),
    [sym_compiler_directive_decl] = STATE(313),
    [sym_fsi_directive_decl] = STATE(313),
    [sym_preproc_line] = STATE(313),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(233),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [314] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym_line_comment] = STATE(314),
    [sym_compiler_directive_decl] = STATE(314),
    [sym_fsi_directive_decl] = STATE(314),
    [sym_preproc_line] = STATE(314),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1710),
  },
  [315] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym_line_comment] = STATE(315),
    [sym_compiler_directive_decl] = STATE(315),
    [sym_fsi_directive_decl] = STATE(315),
    [sym_preproc_line] = STATE(315),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1712),
  },
  [316] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym_line_comment] = STATE(316),
    [sym_compiler_directive_decl] = STATE(316),
    [sym_fsi_directive_decl] = STATE(316),
    [sym_preproc_line] = STATE(316),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1714),
  },
  [317] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym_line_comment] = STATE(317),
    [sym_compiler_directive_decl] = STATE(317),
    [sym_fsi_directive_decl] = STATE(317),
    [sym_preproc_line] = STATE(317),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1716),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [318] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym_line_comment] = STATE(318),
    [sym_compiler_directive_decl] = STATE(318),
    [sym_fsi_directive_decl] = STATE(318),
    [sym_preproc_line] = STATE(318),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1716),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [319] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(319),
    [sym_block_comment] = STATE(319),
    [sym_line_comment] = STATE(319),
    [sym_compiler_directive_decl] = STATE(319),
    [sym_fsi_directive_decl] = STATE(319),
    [sym_preproc_line] = STATE(319),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1718),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1720),
  },
  [320] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(320),
    [sym_block_comment] = STATE(320),
    [sym_line_comment] = STATE(320),
    [sym_compiler_directive_decl] = STATE(320),
    [sym_fsi_directive_decl] = STATE(320),
    [sym_preproc_line] = STATE(320),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1722),
  },
  [321] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(321),
    [sym_block_comment] = STATE(321),
    [sym_line_comment] = STATE(321),
    [sym_compiler_directive_decl] = STATE(321),
    [sym_fsi_directive_decl] = STATE(321),
    [sym_preproc_line] = STATE(321),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [322] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(322),
    [sym_block_comment] = STATE(322),
    [sym_line_comment] = STATE(322),
    [sym_compiler_directive_decl] = STATE(322),
    [sym_fsi_directive_decl] = STATE(322),
    [sym_preproc_line] = STATE(322),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(219),
    [sym__newline] = ACTIONS(1202),
  },
  [323] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(323),
    [sym_block_comment] = STATE(323),
    [sym_line_comment] = STATE(323),
    [sym_compiler_directive_decl] = STATE(323),
    [sym_fsi_directive_decl] = STATE(323),
    [sym_preproc_line] = STATE(323),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1726),
  },
  [324] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(324),
    [sym_block_comment] = STATE(324),
    [sym_line_comment] = STATE(324),
    [sym_compiler_directive_decl] = STATE(324),
    [sym_fsi_directive_decl] = STATE(324),
    [sym_preproc_line] = STATE(324),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1728),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1024),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_COLON_GT] = ACTIONS(1054),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_LT_DASH] = ACTIONS(1070),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(1098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
    [sym__newline] = ACTIONS(1110),
  },
  [325] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(325),
    [sym_block_comment] = STATE(325),
    [sym_line_comment] = STATE(325),
    [sym_compiler_directive_decl] = STATE(325),
    [sym_fsi_directive_decl] = STATE(325),
    [sym_preproc_line] = STATE(325),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [326] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(326),
    [sym_block_comment] = STATE(326),
    [sym_line_comment] = STATE(326),
    [sym_compiler_directive_decl] = STATE(326),
    [sym_fsi_directive_decl] = STATE(326),
    [sym_preproc_line] = STATE(326),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1732),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1734),
  },
  [327] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(734),
    [sym_infix_op] = STATE(638),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(327),
    [sym_block_comment] = STATE(327),
    [sym_line_comment] = STATE(327),
    [sym_compiler_directive_decl] = STATE(327),
    [sym_fsi_directive_decl] = STATE(327),
    [sym_preproc_line] = STATE(327),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_sequential_expression_repeat1] = STATE(2080),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_COLON_GT] = ACTIONS(1568),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_LT_DASH] = ACTIONS(1584),
    [anon_sym_DOT_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1736),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_LPAREN2] = ACTIONS(1594),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(1608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
    [sym__newline] = ACTIONS(1620),
  },
  [328] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(328),
    [sym_block_comment] = STATE(328),
    [sym_line_comment] = STATE(328),
    [sym_compiler_directive_decl] = STATE(328),
    [sym_fsi_directive_decl] = STATE(328),
    [sym_preproc_line] = STATE(328),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(245),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(243),
  },
  [329] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(329),
    [sym_block_comment] = STATE(329),
    [sym_line_comment] = STATE(329),
    [sym_compiler_directive_decl] = STATE(329),
    [sym_fsi_directive_decl] = STATE(329),
    [sym_preproc_line] = STATE(329),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(249),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [330] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(330),
    [sym_block_comment] = STATE(330),
    [sym_line_comment] = STATE(330),
    [sym_compiler_directive_decl] = STATE(330),
    [sym_fsi_directive_decl] = STATE(330),
    [sym_preproc_line] = STATE(330),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1738),
  },
  [331] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(796),
    [sym_infix_op] = STATE(801),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(331),
    [sym_block_comment] = STATE(331),
    [sym_line_comment] = STATE(331),
    [sym_compiler_directive_decl] = STATE(331),
    [sym_fsi_directive_decl] = STATE(331),
    [sym_preproc_line] = STATE(331),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_AT_GT] = ACTIONS(1740),
    [anon_sym_LT_AT_AT] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_COLON_GT] = ACTIONS(1236),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_LT_DASH] = ACTIONS(1252),
    [anon_sym_DOT_LBRACK] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1266),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(1280),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
    [sym__newline] = ACTIONS(1292),
  },
  [332] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(332),
    [sym_block_comment] = STATE(332),
    [sym_line_comment] = STATE(332),
    [sym_compiler_directive_decl] = STATE(332),
    [sym_fsi_directive_decl] = STATE(332),
    [sym_preproc_line] = STATE(332),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(251),
  },
  [333] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(333),
    [sym_block_comment] = STATE(333),
    [sym_line_comment] = STATE(333),
    [sym_compiler_directive_decl] = STATE(333),
    [sym_fsi_directive_decl] = STATE(333),
    [sym_preproc_line] = STATE(333),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1742),
  },
  [334] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(334),
    [sym_block_comment] = STATE(334),
    [sym_line_comment] = STATE(334),
    [sym_compiler_directive_decl] = STATE(334),
    [sym_fsi_directive_decl] = STATE(334),
    [sym_preproc_line] = STATE(334),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(147),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(123),
  },
  [335] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(335),
    [sym_block_comment] = STATE(335),
    [sym_line_comment] = STATE(335),
    [sym_compiler_directive_decl] = STATE(335),
    [sym_fsi_directive_decl] = STATE(335),
    [sym_preproc_line] = STATE(335),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(1744),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [336] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(336),
    [sym_block_comment] = STATE(336),
    [sym_line_comment] = STATE(336),
    [sym_compiler_directive_decl] = STATE(336),
    [sym_fsi_directive_decl] = STATE(336),
    [sym_preproc_line] = STATE(336),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(1740),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [337] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(337),
    [sym_block_comment] = STATE(337),
    [sym_line_comment] = STATE(337),
    [sym_compiler_directive_decl] = STATE(337),
    [sym_fsi_directive_decl] = STATE(337),
    [sym_preproc_line] = STATE(337),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_end] = ACTIONS(1746),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [338] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(338),
    [sym_block_comment] = STATE(338),
    [sym_line_comment] = STATE(338),
    [sym_compiler_directive_decl] = STATE(338),
    [sym_fsi_directive_decl] = STATE(338),
    [sym_preproc_line] = STATE(338),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(860),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [339] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(339),
    [sym_block_comment] = STATE(339),
    [sym_line_comment] = STATE(339),
    [sym_compiler_directive_decl] = STATE(339),
    [sym_fsi_directive_decl] = STATE(339),
    [sym_preproc_line] = STATE(339),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1750),
  },
  [340] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(340),
    [sym_block_comment] = STATE(340),
    [sym_line_comment] = STATE(340),
    [sym_compiler_directive_decl] = STATE(340),
    [sym_fsi_directive_decl] = STATE(340),
    [sym_preproc_line] = STATE(340),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(1752),
    [sym__dedent] = ACTIONS(1752),
  },
  [341] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(341),
    [sym_block_comment] = STATE(341),
    [sym_line_comment] = STATE(341),
    [sym_compiler_directive_decl] = STATE(341),
    [sym_fsi_directive_decl] = STATE(341),
    [sym_preproc_line] = STATE(341),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1754),
  },
  [342] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(342),
    [sym_block_comment] = STATE(342),
    [sym_line_comment] = STATE(342),
    [sym_compiler_directive_decl] = STATE(342),
    [sym_fsi_directive_decl] = STATE(342),
    [sym_preproc_line] = STATE(342),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1756),
  },
  [343] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(343),
    [sym_block_comment] = STATE(343),
    [sym_line_comment] = STATE(343),
    [sym_compiler_directive_decl] = STATE(343),
    [sym_fsi_directive_decl] = STATE(343),
    [sym_preproc_line] = STATE(343),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1758),
  },
  [344] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(344),
    [sym_block_comment] = STATE(344),
    [sym_line_comment] = STATE(344),
    [sym_compiler_directive_decl] = STATE(344),
    [sym_fsi_directive_decl] = STATE(344),
    [sym_preproc_line] = STATE(344),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1760),
  },
  [345] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(345),
    [sym_block_comment] = STATE(345),
    [sym_line_comment] = STATE(345),
    [sym_compiler_directive_decl] = STATE(345),
    [sym_fsi_directive_decl] = STATE(345),
    [sym_preproc_line] = STATE(345),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(1328),
    [anon_sym_AT_AT_GT] = ACTIONS(233),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_COLON_GT] = ACTIONS(1338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_LT_DASH] = ACTIONS(1354),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(1382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1394),
  },
  [346] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(806),
    [sym_infix_op] = STATE(804),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(346),
    [sym_block_comment] = STATE(346),
    [sym_line_comment] = STATE(346),
    [sym_compiler_directive_decl] = STATE(346),
    [sym_fsi_directive_decl] = STATE(346),
    [sym_preproc_line] = STATE(346),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_sequential_expression_repeat1] = STATE(2028),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(596),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(612),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(616),
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_COLON_GT] = ACTIONS(626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_LT_DASH] = ACTIONS(698),
    [anon_sym_DOT_LBRACK] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(862),
    [sym__dedent] = ACTIONS(1296),
  },
  [347] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(685),
    [sym_infix_op] = STATE(759),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(347),
    [sym_block_comment] = STATE(347),
    [sym_line_comment] = STATE(347),
    [sym_compiler_directive_decl] = STATE(347),
    [sym_fsi_directive_decl] = STATE(347),
    [sym_preproc_line] = STATE(347),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_sequential_expression_repeat1] = STATE(2166),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_AT_AT_GT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [348] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(348),
    [sym_block_comment] = STATE(348),
    [sym_line_comment] = STATE(348),
    [sym_compiler_directive_decl] = STATE(348),
    [sym_fsi_directive_decl] = STATE(348),
    [sym_preproc_line] = STATE(348),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1762),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1764),
  },
  [349] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(571),
    [sym_infix_op] = STATE(772),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(349),
    [sym_block_comment] = STATE(349),
    [sym_line_comment] = STATE(349),
    [sym_compiler_directive_decl] = STATE(349),
    [sym_fsi_directive_decl] = STATE(349),
    [sym_preproc_line] = STATE(349),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_sequential_expression_repeat1] = STATE(2185),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_COLON_GT] = ACTIONS(1002),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_LT_DASH] = ACTIONS(1008),
    [anon_sym_DOT_LBRACK] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_LPAREN2] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
    [sym__newline] = ACTIONS(1016),
  },
  [350] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(350),
    [sym_block_comment] = STATE(350),
    [sym_line_comment] = STATE(350),
    [sym_compiler_directive_decl] = STATE(350),
    [sym_fsi_directive_decl] = STATE(350),
    [sym_preproc_line] = STATE(350),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [351] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(351),
    [sym_block_comment] = STATE(351),
    [sym_line_comment] = STATE(351),
    [sym_compiler_directive_decl] = STATE(351),
    [sym_fsi_directive_decl] = STATE(351),
    [sym_preproc_line] = STATE(351),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [sym__newline] = ACTIONS(1202),
  },
  [352] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(352),
    [sym_block_comment] = STATE(352),
    [sym_line_comment] = STATE(352),
    [sym_compiler_directive_decl] = STATE(352),
    [sym_fsi_directive_decl] = STATE(352),
    [sym_preproc_line] = STATE(352),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_let] = ACTIONS(227),
    [anon_sym_let_BANG] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_null] = ACTIONS(227),
    [anon_sym_QMARK] = ACTIONS(227),
    [anon_sym_COLON_QMARK] = ACTIONS(227),
    [anon_sym_COLON_COLON] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(227),
    [anon_sym_LT_AT_AT] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(229),
    [anon_sym_new] = ACTIONS(227),
    [anon_sym_return_BANG] = ACTIONS(229),
    [anon_sym_yield] = ACTIONS(227),
    [anon_sym_yield_BANG] = ACTIONS(229),
    [anon_sym_lazy] = ACTIONS(227),
    [anon_sym_assert] = ACTIONS(227),
    [anon_sym_upcast] = ACTIONS(227),
    [anon_sym_downcast] = ACTIONS(227),
    [anon_sym_COLON_GT] = ACTIONS(229),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(227),
    [anon_sym_match] = ACTIONS(227),
    [anon_sym_match_BANG] = ACTIONS(229),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LT_DASH] = ACTIONS(227),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(227),
    [anon_sym_use_BANG] = ACTIONS(229),
    [anon_sym_do_BANG] = ACTIONS(229),
    [anon_sym_DOT_DOT] = ACTIONS(229),
    [anon_sym_begin] = ACTIONS(227),
    [anon_sym_LPAREN2] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(227),
    [aux_sym_char_token1] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_AT_DQUOTE] = ACTIONS(229),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [sym_bool] = ACTIONS(227),
    [sym_unit] = ACTIONS(227),
    [anon_sym_LPAREN_PIPE] = ACTIONS(227),
    [sym_op_identifier] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS_DOT] = ACTIONS(227),
    [anon_sym_DASH_DOT] = ACTIONS(227),
    [anon_sym_PERCENT] = ACTIONS(227),
    [anon_sym_AMP_AMP] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(229),
    [aux_sym_prefix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [anon_sym_PIPE_PIPE] = ACTIONS(227),
    [anon_sym_BANG_EQ] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_DOLLAR] = ACTIONS(227),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(227),
    [sym_int] = ACTIONS(227),
    [sym_xint] = ACTIONS(229),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(229),
    [sym__newline] = ACTIONS(229),
  },
  [353] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(353),
    [sym_block_comment] = STATE(353),
    [sym_line_comment] = STATE(353),
    [sym_compiler_directive_decl] = STATE(353),
    [sym_fsi_directive_decl] = STATE(353),
    [sym_preproc_line] = STATE(353),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(1766),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(1768),
  },
  [354] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(354),
    [sym_block_comment] = STATE(354),
    [sym_line_comment] = STATE(354),
    [sym_compiler_directive_decl] = STATE(354),
    [sym_fsi_directive_decl] = STATE(354),
    [sym_preproc_line] = STATE(354),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_COLON_QMARK] = ACTIONS(239),
    [anon_sym_COLON_COLON] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(241),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(241),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(241),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(241),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(239),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(241),
    [anon_sym_DOT_DOT] = ACTIONS(241),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(241),
    [anon_sym_or] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(241),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(239),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(241),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(239),
    [anon_sym_PIPE_PIPE] = ACTIONS(239),
    [anon_sym_BANG_EQ] = ACTIONS(239),
    [anon_sym_COLON_EQ] = ACTIONS(241),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(239),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(241),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(241),
    [sym__newline] = ACTIONS(241),
  },
  [355] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(355),
    [sym_block_comment] = STATE(355),
    [sym_line_comment] = STATE(355),
    [sym_compiler_directive_decl] = STATE(355),
    [sym_fsi_directive_decl] = STATE(355),
    [sym_preproc_line] = STATE(355),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(247),
    [sym__newline] = ACTIONS(1202),
  },
  [356] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(356),
    [sym_block_comment] = STATE(356),
    [sym_line_comment] = STATE(356),
    [sym_compiler_directive_decl] = STATE(356),
    [sym_fsi_directive_decl] = STATE(356),
    [sym_preproc_line] = STATE(356),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(251),
    [sym__newline] = ACTIONS(251),
  },
  [357] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(844),
    [sym_infix_op] = STATE(771),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(357),
    [sym_block_comment] = STATE(357),
    [sym_line_comment] = STATE(357),
    [sym_compiler_directive_decl] = STATE(357),
    [sym_fsi_directive_decl] = STATE(357),
    [sym_preproc_line] = STATE(357),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_sequential_expression_repeat1] = STATE(2249),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(1116),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_COLON_GT] = ACTIONS(1146),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_LT_DASH] = ACTIONS(1162),
    [anon_sym_DOT_LBRACK] = ACTIONS(1164),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(1190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(123),
    [sym__newline] = ACTIONS(123),
  },
  [358] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(860),
    [sym_infix_op] = STATE(815),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(358),
    [sym_block_comment] = STATE(358),
    [sym_line_comment] = STATE(358),
    [sym_compiler_directive_decl] = STATE(358),
    [sym_fsi_directive_decl] = STATE(358),
    [sym_preproc_line] = STATE(358),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_sequential_expression_repeat1] = STATE(2092),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_return] = ACTIONS(235),
    [anon_sym_do] = ACTIONS(235),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_let_BANG] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_null] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(235),
    [anon_sym_COLON_QMARK] = ACTIONS(235),
    [anon_sym_COLON_COLON] = ACTIONS(237),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_LT_AT] = ACTIONS(235),
    [anon_sym_LT_AT_AT] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(235),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(235),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(235),
    [anon_sym_assert] = ACTIONS(235),
    [anon_sym_upcast] = ACTIONS(235),
    [anon_sym_downcast] = ACTIONS(235),
    [anon_sym_COLON_GT] = ACTIONS(237),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_fun] = ACTIONS(235),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(235),
    [anon_sym_DOT_LBRACK] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_use] = ACTIONS(235),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(235),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_or] = ACTIONS(235),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(235),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(235),
    [sym_unit] = ACTIONS(235),
    [anon_sym_LPAREN_PIPE] = ACTIONS(235),
    [sym_op_identifier] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_PLUS_DOT] = ACTIONS(235),
    [anon_sym_DASH_DOT] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(235),
    [aux_sym_infix_op_token1] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_COLON_EQ] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(235),
    [sym_int] = ACTIONS(235),
    [sym_xint] = ACTIONS(237),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [359] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(359),
    [sym_block_comment] = STATE(359),
    [sym_line_comment] = STATE(359),
    [sym_compiler_directive_decl] = STATE(359),
    [sym_fsi_directive_decl] = STATE(359),
    [sym_preproc_line] = STATE(359),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1536),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [360] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(360),
    [sym_block_comment] = STATE(360),
    [sym_line_comment] = STATE(360),
    [sym_compiler_directive_decl] = STATE(360),
    [sym_fsi_directive_decl] = STATE(360),
    [sym_preproc_line] = STATE(360),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1770),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [361] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(361),
    [sym_block_comment] = STATE(361),
    [sym_line_comment] = STATE(361),
    [sym_compiler_directive_decl] = STATE(361),
    [sym_fsi_directive_decl] = STATE(361),
    [sym_preproc_line] = STATE(361),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1772),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [362] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(362),
    [sym_block_comment] = STATE(362),
    [sym_line_comment] = STATE(362),
    [sym_compiler_directive_decl] = STATE(362),
    [sym_fsi_directive_decl] = STATE(362),
    [sym_preproc_line] = STATE(362),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1774),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [363] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(363),
    [sym_block_comment] = STATE(363),
    [sym_line_comment] = STATE(363),
    [sym_compiler_directive_decl] = STATE(363),
    [sym_fsi_directive_decl] = STATE(363),
    [sym_preproc_line] = STATE(363),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1776),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [364] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(364),
    [sym_block_comment] = STATE(364),
    [sym_line_comment] = STATE(364),
    [sym_compiler_directive_decl] = STATE(364),
    [sym_fsi_directive_decl] = STATE(364),
    [sym_preproc_line] = STATE(364),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1778),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [365] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(365),
    [sym_block_comment] = STATE(365),
    [sym_line_comment] = STATE(365),
    [sym_compiler_directive_decl] = STATE(365),
    [sym_fsi_directive_decl] = STATE(365),
    [sym_preproc_line] = STATE(365),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1780),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [366] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(366),
    [sym_block_comment] = STATE(366),
    [sym_line_comment] = STATE(366),
    [sym_compiler_directive_decl] = STATE(366),
    [sym_fsi_directive_decl] = STATE(366),
    [sym_preproc_line] = STATE(366),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1782),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [367] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(367),
    [sym_block_comment] = STATE(367),
    [sym_line_comment] = STATE(367),
    [sym_compiler_directive_decl] = STATE(367),
    [sym_fsi_directive_decl] = STATE(367),
    [sym_preproc_line] = STATE(367),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1784),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [368] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(368),
    [sym_block_comment] = STATE(368),
    [sym_line_comment] = STATE(368),
    [sym_compiler_directive_decl] = STATE(368),
    [sym_fsi_directive_decl] = STATE(368),
    [sym_preproc_line] = STATE(368),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1786),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [369] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(369),
    [sym_block_comment] = STATE(369),
    [sym_line_comment] = STATE(369),
    [sym_compiler_directive_decl] = STATE(369),
    [sym_fsi_directive_decl] = STATE(369),
    [sym_preproc_line] = STATE(369),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1788),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [370] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(370),
    [sym_block_comment] = STATE(370),
    [sym_line_comment] = STATE(370),
    [sym_compiler_directive_decl] = STATE(370),
    [sym_fsi_directive_decl] = STATE(370),
    [sym_preproc_line] = STATE(370),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1790),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [371] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(371),
    [sym_block_comment] = STATE(371),
    [sym_line_comment] = STATE(371),
    [sym_compiler_directive_decl] = STATE(371),
    [sym_fsi_directive_decl] = STATE(371),
    [sym_preproc_line] = STATE(371),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [372] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(372),
    [sym_block_comment] = STATE(372),
    [sym_line_comment] = STATE(372),
    [sym_compiler_directive_decl] = STATE(372),
    [sym_fsi_directive_decl] = STATE(372),
    [sym_preproc_line] = STATE(372),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1794),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [373] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(373),
    [sym_block_comment] = STATE(373),
    [sym_line_comment] = STATE(373),
    [sym_compiler_directive_decl] = STATE(373),
    [sym_fsi_directive_decl] = STATE(373),
    [sym_preproc_line] = STATE(373),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1796),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [374] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(374),
    [sym_block_comment] = STATE(374),
    [sym_line_comment] = STATE(374),
    [sym_compiler_directive_decl] = STATE(374),
    [sym_fsi_directive_decl] = STATE(374),
    [sym_preproc_line] = STATE(374),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1798),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [375] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(375),
    [sym_block_comment] = STATE(375),
    [sym_line_comment] = STATE(375),
    [sym_compiler_directive_decl] = STATE(375),
    [sym_fsi_directive_decl] = STATE(375),
    [sym_preproc_line] = STATE(375),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1800),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [376] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(376),
    [sym_block_comment] = STATE(376),
    [sym_line_comment] = STATE(376),
    [sym_compiler_directive_decl] = STATE(376),
    [sym_fsi_directive_decl] = STATE(376),
    [sym_preproc_line] = STATE(376),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1802),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [377] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(377),
    [sym_block_comment] = STATE(377),
    [sym_line_comment] = STATE(377),
    [sym_compiler_directive_decl] = STATE(377),
    [sym_fsi_directive_decl] = STATE(377),
    [sym_preproc_line] = STATE(377),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1804),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [378] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(378),
    [sym_block_comment] = STATE(378),
    [sym_line_comment] = STATE(378),
    [sym_compiler_directive_decl] = STATE(378),
    [sym_fsi_directive_decl] = STATE(378),
    [sym_preproc_line] = STATE(378),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1806),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [379] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(379),
    [sym_block_comment] = STATE(379),
    [sym_line_comment] = STATE(379),
    [sym_compiler_directive_decl] = STATE(379),
    [sym_fsi_directive_decl] = STATE(379),
    [sym_preproc_line] = STATE(379),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1808),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [380] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(380),
    [sym_block_comment] = STATE(380),
    [sym_line_comment] = STATE(380),
    [sym_compiler_directive_decl] = STATE(380),
    [sym_fsi_directive_decl] = STATE(380),
    [sym_preproc_line] = STATE(380),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1810),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [381] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(381),
    [sym_block_comment] = STATE(381),
    [sym_line_comment] = STATE(381),
    [sym_compiler_directive_decl] = STATE(381),
    [sym_fsi_directive_decl] = STATE(381),
    [sym_preproc_line] = STATE(381),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [382] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(382),
    [sym_block_comment] = STATE(382),
    [sym_line_comment] = STATE(382),
    [sym_compiler_directive_decl] = STATE(382),
    [sym_fsi_directive_decl] = STATE(382),
    [sym_preproc_line] = STATE(382),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1814),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [383] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(383),
    [sym_block_comment] = STATE(383),
    [sym_line_comment] = STATE(383),
    [sym_compiler_directive_decl] = STATE(383),
    [sym_fsi_directive_decl] = STATE(383),
    [sym_preproc_line] = STATE(383),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1816),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [384] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(384),
    [sym_block_comment] = STATE(384),
    [sym_line_comment] = STATE(384),
    [sym_compiler_directive_decl] = STATE(384),
    [sym_fsi_directive_decl] = STATE(384),
    [sym_preproc_line] = STATE(384),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [385] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3536),
    [sym_prefix_op] = STATE(753),
    [sym_infix_op] = STATE(802),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(385),
    [sym_block_comment] = STATE(385),
    [sym_line_comment] = STATE(385),
    [sym_compiler_directive_decl] = STATE(385),
    [sym_fsi_directive_decl] = STATE(385),
    [sym_preproc_line] = STATE(385),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_sequential_expression_repeat1] = STATE(1059),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(1820),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(141),
    [anon_sym_COLON_QMARK] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(205),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(41),
    [anon_sym_DASH_DOT] = ACTIONS(41),
    [anon_sym_PERCENT] = ACTIONS(41),
    [anon_sym_AMP_AMP] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(211),
    [aux_sym_infix_op_token1] = ACTIONS(141),
    [anon_sym_PIPE_PIPE] = ACTIONS(141),
    [anon_sym_BANG_EQ] = ACTIONS(141),
    [anon_sym_COLON_EQ] = ACTIONS(121),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(141),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(225),
  },
  [386] = {
    [sym_module_abbrev] = STATE(6515),
    [sym_module_defn] = STATE(6515),
    [sym_import_decl] = STATE(6515),
    [sym_attributes] = STATE(5898),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(6515),
    [sym_do] = STATE(6725),
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(43),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_type_definition] = STATE(6515),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(386),
    [sym_block_comment] = STATE(386),
    [sym_line_comment] = STATE(386),
    [sym_compiler_directive_decl] = STATE(386),
    [sym_fsi_directive_decl] = STATE(386),
    [sym_preproc_line] = STATE(386),
    [sym_preproc_if] = STATE(6515),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8233),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_module] = ACTIONS(1822),
    [anon_sym_open] = ACTIONS(1824),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(1826),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1830),
    [anon_sym_let_BANG] = ACTIONS(1832),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(1842),
    [anon_sym_POUNDload] = ACTIONS(1842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1844),
    [anon_sym_POUNDendif] = ACTIONS(1846),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [387] = {
    [sym_module_abbrev] = STATE(6532),
    [sym_module_defn] = STATE(6532),
    [sym_import_decl] = STATE(6532),
    [sym_attributes] = STATE(5898),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(6532),
    [sym_do] = STATE(6725),
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(45),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_type_definition] = STATE(6532),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(387),
    [sym_block_comment] = STATE(387),
    [sym_line_comment] = STATE(387),
    [sym_compiler_directive_decl] = STATE(387),
    [sym_fsi_directive_decl] = STATE(387),
    [sym_preproc_line] = STATE(387),
    [sym_preproc_if] = STATE(6532),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8044),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(476),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_module] = ACTIONS(1822),
    [anon_sym_open] = ACTIONS(1824),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(1826),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1830),
    [anon_sym_let_BANG] = ACTIONS(1832),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(1842),
    [anon_sym_POUNDload] = ACTIONS(1842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1844),
    [anon_sym_POUNDendif] = ACTIONS(1852),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [388] = {
    [sym_module_abbrev] = STATE(6283),
    [sym_module_defn] = STATE(6283),
    [sym_import_decl] = STATE(6283),
    [sym_attributes] = STATE(5898),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(6283),
    [sym_do] = STATE(6725),
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(49),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_type_definition] = STATE(6283),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(388),
    [sym_block_comment] = STATE(388),
    [sym_line_comment] = STATE(388),
    [sym_compiler_directive_decl] = STATE(388),
    [sym_fsi_directive_decl] = STATE(388),
    [sym_preproc_line] = STATE(388),
    [sym_preproc_if] = STATE(6283),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7403),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(495),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_module] = ACTIONS(1822),
    [anon_sym_open] = ACTIONS(1824),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(1826),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1830),
    [anon_sym_let_BANG] = ACTIONS(1832),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(1842),
    [anon_sym_POUNDload] = ACTIONS(1842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1844),
    [anon_sym_POUNDendif] = ACTIONS(1854),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [389] = {
    [sym_module_abbrev] = STATE(6242),
    [sym_module_defn] = STATE(6242),
    [sym_import_decl] = STATE(6242),
    [sym_attributes] = STATE(5898),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(6242),
    [sym_do] = STATE(6725),
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(42),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_type_definition] = STATE(6242),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(389),
    [sym_block_comment] = STATE(389),
    [sym_line_comment] = STATE(389),
    [sym_compiler_directive_decl] = STATE(389),
    [sym_fsi_directive_decl] = STATE(389),
    [sym_preproc_line] = STATE(389),
    [sym_preproc_if] = STATE(6242),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7274),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(498),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_module] = ACTIONS(1822),
    [anon_sym_open] = ACTIONS(1824),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(1826),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1830),
    [anon_sym_let_BANG] = ACTIONS(1832),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(1842),
    [anon_sym_POUNDload] = ACTIONS(1842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1844),
    [anon_sym_POUNDendif] = ACTIONS(1856),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [390] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(390),
    [sym_block_comment] = STATE(390),
    [sym_line_comment] = STATE(390),
    [sym_compiler_directive_decl] = STATE(390),
    [sym_fsi_directive_decl] = STATE(390),
    [sym_preproc_line] = STATE(390),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(394),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(1860),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [391] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(391),
    [sym_block_comment] = STATE(391),
    [sym_line_comment] = STATE(391),
    [sym_compiler_directive_decl] = STATE(391),
    [sym_fsi_directive_decl] = STATE(391),
    [sym_preproc_line] = STATE(391),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(391),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(1864),
    [sym_identifier] = ACTIONS(1866),
    [anon_sym_namespace] = ACTIONS(1869),
    [anon_sym_module] = ACTIONS(1871),
    [anon_sym_open] = ACTIONS(1874),
    [anon_sym_LBRACK_LT] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(1880),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_do] = ACTIONS(1886),
    [anon_sym_let] = ACTIONS(1889),
    [anon_sym_let_BANG] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_null] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1910),
    [anon_sym_LT_AT] = ACTIONS(1913),
    [anon_sym_LT_AT_AT] = ACTIONS(1916),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1919),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_return_BANG] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1880),
    [anon_sym_yield_BANG] = ACTIONS(1925),
    [anon_sym_lazy] = ACTIONS(1880),
    [anon_sym_assert] = ACTIONS(1880),
    [anon_sym_upcast] = ACTIONS(1880),
    [anon_sym_downcast] = ACTIONS(1880),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_fun] = ACTIONS(1937),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_match] = ACTIONS(1943),
    [anon_sym_match_BANG] = ACTIONS(1946),
    [anon_sym_function] = ACTIONS(1949),
    [anon_sym_use] = ACTIONS(1952),
    [anon_sym_use_BANG] = ACTIONS(1955),
    [anon_sym_do_BANG] = ACTIONS(1958),
    [anon_sym_begin] = ACTIONS(1961),
    [aux_sym_char_token1] = ACTIONS(1964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [anon_sym_AT_DQUOTE] = ACTIONS(1973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1979),
    [sym_bool] = ACTIONS(1982),
    [sym_unit] = ACTIONS(1985),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1988),
    [sym_op_identifier] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_DOT] = ACTIONS(1994),
    [anon_sym_DASH_DOT] = ACTIONS(1994),
    [anon_sym_PERCENT] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1997),
    [aux_sym_prefix_op_token1] = ACTIONS(2000),
    [sym_int] = ACTIONS(2003),
    [sym_xint] = ACTIONS(2006),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2009),
    [anon_sym_POUNDload] = ACTIONS(2009),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2012),
  },
  [392] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(392),
    [sym_block_comment] = STATE(392),
    [sym_line_comment] = STATE(392),
    [sym_compiler_directive_decl] = STATE(392),
    [sym_fsi_directive_decl] = STATE(392),
    [sym_preproc_line] = STATE(392),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(391),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2015),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [393] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(393),
    [sym_block_comment] = STATE(393),
    [sym_line_comment] = STATE(393),
    [sym_compiler_directive_decl] = STATE(393),
    [sym_fsi_directive_decl] = STATE(393),
    [sym_preproc_line] = STATE(393),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(395),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2019),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(2021),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [394] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(394),
    [sym_block_comment] = STATE(394),
    [sym_line_comment] = STATE(394),
    [sym_compiler_directive_decl] = STATE(394),
    [sym_fsi_directive_decl] = STATE(394),
    [sym_preproc_line] = STATE(394),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(391),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2023),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [395] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(395),
    [sym_block_comment] = STATE(395),
    [sym_line_comment] = STATE(395),
    [sym_compiler_directive_decl] = STATE(395),
    [sym_fsi_directive_decl] = STATE(395),
    [sym_preproc_line] = STATE(395),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(391),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2027),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(2029),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [396] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(462),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(396),
    [sym_block_comment] = STATE(396),
    [sym_line_comment] = STATE(396),
    [sym_compiler_directive_decl] = STATE(396),
    [sym_fsi_directive_decl] = STATE(396),
    [sym_preproc_line] = STATE(396),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(392),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2031),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(2033),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [397] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(397),
    [sym_block_comment] = STATE(397),
    [sym_line_comment] = STATE(397),
    [sym_compiler_directive_decl] = STATE(397),
    [sym_fsi_directive_decl] = STATE(397),
    [sym_preproc_line] = STATE(397),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2059),
  },
  [398] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(398),
    [sym_block_comment] = STATE(398),
    [sym_line_comment] = STATE(398),
    [sym_compiler_directive_decl] = STATE(398),
    [sym_fsi_directive_decl] = STATE(398),
    [sym_preproc_line] = STATE(398),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2061),
  },
  [399] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(399),
    [sym_block_comment] = STATE(399),
    [sym_line_comment] = STATE(399),
    [sym_compiler_directive_decl] = STATE(399),
    [sym_fsi_directive_decl] = STATE(399),
    [sym_preproc_line] = STATE(399),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2063),
  },
  [400] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(400),
    [sym_block_comment] = STATE(400),
    [sym_line_comment] = STATE(400),
    [sym_compiler_directive_decl] = STATE(400),
    [sym_fsi_directive_decl] = STATE(400),
    [sym_preproc_line] = STATE(400),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(400),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(1864),
    [sym_identifier] = ACTIONS(1866),
    [anon_sym_module] = ACTIONS(1871),
    [anon_sym_open] = ACTIONS(1874),
    [anon_sym_LBRACK_LT] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_do] = ACTIONS(1886),
    [anon_sym_let] = ACTIONS(1889),
    [anon_sym_let_BANG] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_null] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1910),
    [anon_sym_LT_AT] = ACTIONS(1913),
    [anon_sym_LT_AT_AT] = ACTIONS(1916),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1919),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_return_BANG] = ACTIONS(2071),
    [anon_sym_yield] = ACTIONS(2065),
    [anon_sym_yield_BANG] = ACTIONS(2071),
    [anon_sym_lazy] = ACTIONS(2065),
    [anon_sym_assert] = ACTIONS(2065),
    [anon_sym_upcast] = ACTIONS(2065),
    [anon_sym_downcast] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_fun] = ACTIONS(1937),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_match] = ACTIONS(1943),
    [anon_sym_match_BANG] = ACTIONS(1946),
    [anon_sym_function] = ACTIONS(1949),
    [anon_sym_use] = ACTIONS(2074),
    [anon_sym_use_BANG] = ACTIONS(2077),
    [anon_sym_do_BANG] = ACTIONS(1958),
    [anon_sym_begin] = ACTIONS(1961),
    [aux_sym_char_token1] = ACTIONS(1964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [anon_sym_AT_DQUOTE] = ACTIONS(1973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1979),
    [sym_bool] = ACTIONS(1982),
    [sym_unit] = ACTIONS(1985),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1988),
    [sym_op_identifier] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_DOT] = ACTIONS(1994),
    [anon_sym_DASH_DOT] = ACTIONS(1994),
    [anon_sym_PERCENT] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1997),
    [aux_sym_prefix_op_token1] = ACTIONS(2000),
    [sym_int] = ACTIONS(2080),
    [sym_xint] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2009),
    [anon_sym_POUNDload] = ACTIONS(2009),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2012),
  },
  [401] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(401),
    [sym_block_comment] = STATE(401),
    [sym_line_comment] = STATE(401),
    [sym_compiler_directive_decl] = STATE(401),
    [sym_fsi_directive_decl] = STATE(401),
    [sym_preproc_line] = STATE(401),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_open] = ACTIONS(2092),
    [anon_sym_LBRACK_LT] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_do] = ACTIONS(2101),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_let_BANG] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_null] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(2116),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2119),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_LT_AT] = ACTIONS(2125),
    [anon_sym_LT_AT_AT] = ACTIONS(2128),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2134),
    [anon_sym_return_BANG] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2095),
    [anon_sym_yield_BANG] = ACTIONS(2137),
    [anon_sym_lazy] = ACTIONS(2095),
    [anon_sym_assert] = ACTIONS(2095),
    [anon_sym_upcast] = ACTIONS(2095),
    [anon_sym_downcast] = ACTIONS(2095),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2143),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_fun] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_match] = ACTIONS(2152),
    [anon_sym_match_BANG] = ACTIONS(2155),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_use] = ACTIONS(2161),
    [anon_sym_use_BANG] = ACTIONS(2164),
    [anon_sym_do_BANG] = ACTIONS(2167),
    [anon_sym_begin] = ACTIONS(2170),
    [aux_sym_char_token1] = ACTIONS(2173),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2179),
    [anon_sym_AT_DQUOTE] = ACTIONS(2182),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2188),
    [sym_bool] = ACTIONS(2191),
    [sym_unit] = ACTIONS(2194),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2197),
    [sym_op_identifier] = ACTIONS(2200),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_DOT] = ACTIONS(1994),
    [anon_sym_DASH_DOT] = ACTIONS(1994),
    [anon_sym_PERCENT] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1997),
    [aux_sym_prefix_op_token1] = ACTIONS(2000),
    [sym_int] = ACTIONS(2203),
    [sym_xint] = ACTIONS(2206),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2209),
    [anon_sym_POUNDload] = ACTIONS(2209),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2212),
    [sym__dedent] = ACTIONS(1864),
  },
  [402] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(402),
    [sym_block_comment] = STATE(402),
    [sym_line_comment] = STATE(402),
    [sym_compiler_directive_decl] = STATE(402),
    [sym_fsi_directive_decl] = STATE(402),
    [sym_preproc_line] = STATE(402),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2215),
  },
  [403] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(403),
    [sym_block_comment] = STATE(403),
    [sym_line_comment] = STATE(403),
    [sym_compiler_directive_decl] = STATE(403),
    [sym_fsi_directive_decl] = STATE(403),
    [sym_preproc_line] = STATE(403),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2217),
  },
  [404] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(404),
    [sym_block_comment] = STATE(404),
    [sym_line_comment] = STATE(404),
    [sym_compiler_directive_decl] = STATE(404),
    [sym_fsi_directive_decl] = STATE(404),
    [sym_preproc_line] = STATE(404),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2219),
  },
  [405] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(405),
    [sym_block_comment] = STATE(405),
    [sym_line_comment] = STATE(405),
    [sym_compiler_directive_decl] = STATE(405),
    [sym_fsi_directive_decl] = STATE(405),
    [sym_preproc_line] = STATE(405),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(417),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2221),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [406] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(406),
    [sym_block_comment] = STATE(406),
    [sym_line_comment] = STATE(406),
    [sym_compiler_directive_decl] = STATE(406),
    [sym_fsi_directive_decl] = STATE(406),
    [sym_preproc_line] = STATE(406),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(408),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [407] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(407),
    [sym_block_comment] = STATE(407),
    [sym_line_comment] = STATE(407),
    [sym_compiler_directive_decl] = STATE(407),
    [sym_fsi_directive_decl] = STATE(407),
    [sym_preproc_line] = STATE(407),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2225),
  },
  [408] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(408),
    [sym_block_comment] = STATE(408),
    [sym_line_comment] = STATE(408),
    [sym_compiler_directive_decl] = STATE(408),
    [sym_fsi_directive_decl] = STATE(408),
    [sym_preproc_line] = STATE(408),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(400),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2227),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [409] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(409),
    [sym_block_comment] = STATE(409),
    [sym_line_comment] = STATE(409),
    [sym_compiler_directive_decl] = STATE(409),
    [sym_fsi_directive_decl] = STATE(409),
    [sym_preproc_line] = STATE(409),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(400),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [410] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(410),
    [sym_block_comment] = STATE(410),
    [sym_line_comment] = STATE(410),
    [sym_compiler_directive_decl] = STATE(410),
    [sym_fsi_directive_decl] = STATE(410),
    [sym_preproc_line] = STATE(410),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(409),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2231),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [411] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(411),
    [sym_block_comment] = STATE(411),
    [sym_line_comment] = STATE(411),
    [sym_compiler_directive_decl] = STATE(411),
    [sym_fsi_directive_decl] = STATE(411),
    [sym_preproc_line] = STATE(411),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2233),
  },
  [412] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(412),
    [sym_block_comment] = STATE(412),
    [sym_line_comment] = STATE(412),
    [sym_compiler_directive_decl] = STATE(412),
    [sym_fsi_directive_decl] = STATE(412),
    [sym_preproc_line] = STATE(412),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(400),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [413] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(413),
    [sym_block_comment] = STATE(413),
    [sym_line_comment] = STATE(413),
    [sym_compiler_directive_decl] = STATE(413),
    [sym_fsi_directive_decl] = STATE(413),
    [sym_preproc_line] = STATE(413),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2237),
  },
  [414] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(414),
    [sym_block_comment] = STATE(414),
    [sym_line_comment] = STATE(414),
    [sym_compiler_directive_decl] = STATE(414),
    [sym_fsi_directive_decl] = STATE(414),
    [sym_preproc_line] = STATE(414),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2239),
  },
  [415] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(415),
    [sym_block_comment] = STATE(415),
    [sym_line_comment] = STATE(415),
    [sym_compiler_directive_decl] = STATE(415),
    [sym_fsi_directive_decl] = STATE(415),
    [sym_preproc_line] = STATE(415),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2241),
  },
  [416] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(416),
    [sym_block_comment] = STATE(416),
    [sym_line_comment] = STATE(416),
    [sym_compiler_directive_decl] = STATE(416),
    [sym_fsi_directive_decl] = STATE(416),
    [sym_preproc_line] = STATE(416),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(401),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
    [sym__dedent] = ACTIONS(2243),
  },
  [417] = {
    [sym_module_abbrev] = STATE(3391),
    [sym_module_defn] = STATE(3391),
    [sym_import_decl] = STATE(3391),
    [sym_attributes] = STATE(5883),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3391),
    [sym_do] = STATE(3389),
    [sym_function_or_value_defn] = STATE(510),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_definition] = STATE(3391),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(417),
    [sym_block_comment] = STATE(417),
    [sym_line_comment] = STATE(417),
    [sym_compiler_directive_decl] = STATE(417),
    [sym_fsi_directive_decl] = STATE(417),
    [sym_preproc_line] = STATE(417),
    [sym_preproc_if] = STATE(3391),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_file_repeat2] = STATE(400),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2245),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_open] = ACTIONS(23),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_let_BANG] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [418] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(418),
    [sym_block_comment] = STATE(418),
    [sym_line_comment] = STATE(418),
    [sym_compiler_directive_decl] = STATE(418),
    [sym_fsi_directive_decl] = STATE(418),
    [sym_preproc_line] = STATE(418),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(411),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [419] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1529),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(419),
    [sym_block_comment] = STATE(419),
    [sym_line_comment] = STATE(419),
    [sym_compiler_directive_decl] = STATE(419),
    [sym_fsi_directive_decl] = STATE(419),
    [sym_preproc_line] = STATE(419),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(402),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [420] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1506),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(420),
    [sym_block_comment] = STATE(420),
    [sym_line_comment] = STATE(420),
    [sym_compiler_directive_decl] = STATE(420),
    [sym_fsi_directive_decl] = STATE(420),
    [sym_preproc_line] = STATE(420),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(416),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [421] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1615),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(421),
    [sym_block_comment] = STATE(421),
    [sym_line_comment] = STATE(421),
    [sym_compiler_directive_decl] = STATE(421),
    [sym_fsi_directive_decl] = STATE(421),
    [sym_preproc_line] = STATE(421),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(403),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [422] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(422),
    [sym_block_comment] = STATE(422),
    [sym_line_comment] = STATE(422),
    [sym_compiler_directive_decl] = STATE(422),
    [sym_fsi_directive_decl] = STATE(422),
    [sym_preproc_line] = STATE(422),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(413),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [423] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1537),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(423),
    [sym_block_comment] = STATE(423),
    [sym_line_comment] = STATE(423),
    [sym_compiler_directive_decl] = STATE(423),
    [sym_fsi_directive_decl] = STATE(423),
    [sym_preproc_line] = STATE(423),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(414),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [424] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(424),
    [sym_block_comment] = STATE(424),
    [sym_line_comment] = STATE(424),
    [sym_compiler_directive_decl] = STATE(424),
    [sym_fsi_directive_decl] = STATE(424),
    [sym_preproc_line] = STATE(424),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(414),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [425] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1594),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(425),
    [sym_block_comment] = STATE(425),
    [sym_line_comment] = STATE(425),
    [sym_compiler_directive_decl] = STATE(425),
    [sym_fsi_directive_decl] = STATE(425),
    [sym_preproc_line] = STATE(425),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(397),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [426] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(426),
    [sym_block_comment] = STATE(426),
    [sym_line_comment] = STATE(426),
    [sym_compiler_directive_decl] = STATE(426),
    [sym_fsi_directive_decl] = STATE(426),
    [sym_preproc_line] = STATE(426),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(404),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [427] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1526),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(427),
    [sym_block_comment] = STATE(427),
    [sym_line_comment] = STATE(427),
    [sym_compiler_directive_decl] = STATE(427),
    [sym_fsi_directive_decl] = STATE(427),
    [sym_preproc_line] = STATE(427),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(415),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [428] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(428),
    [sym_block_comment] = STATE(428),
    [sym_line_comment] = STATE(428),
    [sym_compiler_directive_decl] = STATE(428),
    [sym_fsi_directive_decl] = STATE(428),
    [sym_preproc_line] = STATE(428),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(415),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [429] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(429),
    [sym_block_comment] = STATE(429),
    [sym_line_comment] = STATE(429),
    [sym_compiler_directive_decl] = STATE(429),
    [sym_fsi_directive_decl] = STATE(429),
    [sym_preproc_line] = STATE(429),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(407),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [430] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym_line_comment] = STATE(430),
    [sym_compiler_directive_decl] = STATE(430),
    [sym_fsi_directive_decl] = STATE(430),
    [sym_preproc_line] = STATE(430),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(399),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [431] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(431),
    [sym_block_comment] = STATE(431),
    [sym_line_comment] = STATE(431),
    [sym_compiler_directive_decl] = STATE(431),
    [sym_fsi_directive_decl] = STATE(431),
    [sym_preproc_line] = STATE(431),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(398),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [432] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1549),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym_line_comment] = STATE(432),
    [sym_compiler_directive_decl] = STATE(432),
    [sym_fsi_directive_decl] = STATE(432),
    [sym_preproc_line] = STATE(432),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(411),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [433] = {
    [sym_module_abbrev] = STATE(3426),
    [sym_module_defn] = STATE(3426),
    [sym_import_decl] = STATE(3426),
    [sym_attributes] = STATE(5909),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(3426),
    [sym_do] = STATE(3436),
    [sym_function_or_value_defn] = STATE(481),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_definition] = STATE(3426),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1644),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(433),
    [sym_block_comment] = STATE(433),
    [sym_line_comment] = STATE(433),
    [sym_compiler_directive_decl] = STATE(433),
    [sym_fsi_directive_decl] = STATE(433),
    [sym_preproc_line] = STATE(433),
    [sym_preproc_if] = STATE(3426),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_file_repeat2] = STATE(404),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_open] = ACTIONS(2037),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_let_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2055),
    [anon_sym_POUNDload] = ACTIONS(2055),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2057),
  },
  [434] = {
    [sym_module_abbrev] = STATE(8104),
    [sym_module_defn] = STATE(8104),
    [sym_import_decl] = STATE(8104),
    [sym_attributes] = STATE(5925),
    [sym_attribute_set] = STATE(4720),
    [sym_value_declaration] = STATE(8104),
    [sym_do] = STATE(7938),
    [sym_function_or_value_defn] = STATE(537),
    [sym__expression] = STATE(288),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_type_definition] = STATE(8104),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(434),
    [sym_block_comment] = STATE(434),
    [sym_line_comment] = STATE(434),
    [sym_compiler_directive_decl] = STATE(434),
    [sym_fsi_directive_decl] = STATE(434),
    [sym_preproc_line] = STATE(434),
    [sym_preproc_if] = STATE(8104),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_module] = ACTIONS(2247),
    [anon_sym_open] = ACTIONS(2249),
    [anon_sym_LBRACK_LT] = ACTIONS(25),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2253),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_let_BANG] = ACTIONS(2257),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2267),
    [anon_sym_POUNDload] = ACTIONS(2267),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2269),
  },
  [435] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(50),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym__list_elements] = STATE(8316),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(8316),
    [sym_short_comp_expression] = STATE(8315),
    [sym_slice_ranges] = STATE(8316),
    [sym__slice_range_special] = STATE(6588),
    [sym_slice_range] = STATE(6340),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(435),
    [sym_block_comment] = STATE(435),
    [sym_line_comment] = STATE(435),
    [sym_compiler_directive_decl] = STATE(435),
    [sym_fsi_directive_decl] = STATE(435),
    [sym_preproc_line] = STATE(435),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_DOT_DOT3] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2279),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__newline] = ACTIONS(2285),
  },
  [436] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(248),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_type_arguments] = STATE(3367),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1463),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(436),
    [sym_block_comment] = STATE(436),
    [sym_line_comment] = STATE(436),
    [sym_compiler_directive_decl] = STATE(436),
    [sym_fsi_directive_decl] = STATE(436),
    [sym_preproc_line] = STATE(436),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym__compound_type_repeat1] = STATE(3277),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2287),
    [anon_sym_GT_RBRACK] = ACTIONS(2289),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LT2] = ACTIONS(2299),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2301),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
    [sym__newline] = ACTIONS(2289),
  },
  [437] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(41),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_type_arguments] = STATE(3352),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1235),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(437),
    [sym_block_comment] = STATE(437),
    [sym_line_comment] = STATE(437),
    [sym_compiler_directive_decl] = STATE(437),
    [sym_fsi_directive_decl] = STATE(437),
    [sym_preproc_line] = STATE(437),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym__compound_type_repeat1] = STATE(3272),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2307),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(2309),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(2309),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_DASH_GT] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(2319),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [438] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(95),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_type_arguments] = STATE(3352),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(1285),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(438),
    [sym_block_comment] = STATE(438),
    [sym_line_comment] = STATE(438),
    [sym_compiler_directive_decl] = STATE(438),
    [sym_fsi_directive_decl] = STATE(438),
    [sym_preproc_line] = STATE(438),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym__compound_type_repeat1] = STATE(3272),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2327),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(2309),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(2309),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_DASH_GT] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(2319),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [439] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(212),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_type_arguments] = STATE(3431),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1505),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(439),
    [sym_block_comment] = STATE(439),
    [sym_line_comment] = STATE(439),
    [sym_compiler_directive_decl] = STATE(439),
    [sym_fsi_directive_decl] = STATE(439),
    [sym_preproc_line] = STATE(439),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__dedent] = ACTIONS(2347),
  },
  [440] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(225),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_type_arguments] = STATE(3431),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1505),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(440),
    [sym_block_comment] = STATE(440),
    [sym_line_comment] = STATE(440),
    [sym_compiler_directive_decl] = STATE(440),
    [sym_fsi_directive_decl] = STATE(440),
    [sym_preproc_line] = STATE(440),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__dedent] = ACTIONS(2349),
  },
  [441] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(256),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_type_arguments] = STATE(3431),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1505),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(441),
    [sym_block_comment] = STATE(441),
    [sym_line_comment] = STATE(441),
    [sym_compiler_directive_decl] = STATE(441),
    [sym_fsi_directive_decl] = STATE(441),
    [sym_preproc_line] = STATE(441),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__dedent] = ACTIONS(2351),
  },
  [442] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7213),
    [sym_object_expression] = STATE(7213),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7235),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7213),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(442),
    [sym_block_comment] = STATE(442),
    [sym_line_comment] = STATE(442),
    [sym_compiler_directive_decl] = STATE(442),
    [sym_fsi_directive_decl] = STATE(442),
    [sym_preproc_line] = STATE(442),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [443] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(99),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(1499),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(443),
    [sym_block_comment] = STATE(443),
    [sym_line_comment] = STATE(443),
    [sym_compiler_directive_decl] = STATE(443),
    [sym_fsi_directive_decl] = STATE(443),
    [sym_preproc_line] = STATE(443),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2359),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [444] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(129),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(1451),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(444),
    [sym_block_comment] = STATE(444),
    [sym_line_comment] = STATE(444),
    [sym_compiler_directive_decl] = STATE(444),
    [sym_fsi_directive_decl] = STATE(444),
    [sym_preproc_line] = STATE(444),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2327),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [445] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(48),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1252),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(445),
    [sym_block_comment] = STATE(445),
    [sym_line_comment] = STATE(445),
    [sym_compiler_directive_decl] = STATE(445),
    [sym_fsi_directive_decl] = STATE(445),
    [sym_preproc_line] = STATE(445),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2307),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [446] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(194),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(1528),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(446),
    [sym_block_comment] = STATE(446),
    [sym_line_comment] = STATE(446),
    [sym_compiler_directive_decl] = STATE(446),
    [sym_fsi_directive_decl] = STATE(446),
    [sym_preproc_line] = STATE(446),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [447] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(354),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(1467),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(447),
    [sym_block_comment] = STATE(447),
    [sym_line_comment] = STATE(447),
    [sym_compiler_directive_decl] = STATE(447),
    [sym_fsi_directive_decl] = STATE(447),
    [sym_preproc_line] = STATE(447),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2387),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [448] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7547),
    [sym_object_expression] = STATE(7547),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7561),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7547),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(448),
    [sym_block_comment] = STATE(448),
    [sym_line_comment] = STATE(448),
    [sym_compiler_directive_decl] = STATE(448),
    [sym_fsi_directive_decl] = STATE(448),
    [sym_preproc_line] = STATE(448),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [449] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(982),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym_line_comment] = STATE(449),
    [sym_compiler_directive_decl] = STATE(449),
    [sym_fsi_directive_decl] = STATE(449),
    [sym_preproc_line] = STATE(449),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [450] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1222),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(450),
    [sym_block_comment] = STATE(450),
    [sym_line_comment] = STATE(450),
    [sym_compiler_directive_decl] = STATE(450),
    [sym_fsi_directive_decl] = STATE(450),
    [sym_preproc_line] = STATE(450),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [451] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(1353),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym_line_comment] = STATE(451),
    [sym_compiler_directive_decl] = STATE(451),
    [sym_fsi_directive_decl] = STATE(451),
    [sym_preproc_line] = STATE(451),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [452] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7286),
    [sym_object_expression] = STATE(7286),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7305),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7286),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(452),
    [sym_block_comment] = STATE(452),
    [sym_line_comment] = STATE(452),
    [sym_compiler_directive_decl] = STATE(452),
    [sym_fsi_directive_decl] = STATE(452),
    [sym_preproc_line] = STATE(452),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [453] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7454),
    [sym_object_expression] = STATE(7454),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7472),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7454),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(453),
    [sym_block_comment] = STATE(453),
    [sym_line_comment] = STATE(453),
    [sym_compiler_directive_decl] = STATE(453),
    [sym_fsi_directive_decl] = STATE(453),
    [sym_preproc_line] = STATE(453),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [454] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(11),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(982),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(454),
    [sym_block_comment] = STATE(454),
    [sym_line_comment] = STATE(454),
    [sym_compiler_directive_decl] = STATE(454),
    [sym_fsi_directive_decl] = STATE(454),
    [sym_preproc_line] = STATE(454),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [455] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(8310),
    [sym_object_expression] = STATE(8310),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(8227),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(8310),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(455),
    [sym_block_comment] = STATE(455),
    [sym_line_comment] = STATE(455),
    [sym_compiler_directive_decl] = STATE(455),
    [sym_fsi_directive_decl] = STATE(455),
    [sym_preproc_line] = STATE(455),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [456] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(39),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1026),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(456),
    [sym_block_comment] = STATE(456),
    [sym_line_comment] = STATE(456),
    [sym_compiler_directive_decl] = STATE(456),
    [sym_fsi_directive_decl] = STATE(456),
    [sym_preproc_line] = STATE(456),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [457] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7585),
    [sym_object_expression] = STATE(7585),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7599),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7585),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(457),
    [sym_block_comment] = STATE(457),
    [sym_line_comment] = STATE(457),
    [sym_compiler_directive_decl] = STATE(457),
    [sym_fsi_directive_decl] = STATE(457),
    [sym_preproc_line] = STATE(457),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [458] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7507),
    [sym_object_expression] = STATE(7507),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7521),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7507),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym_line_comment] = STATE(458),
    [sym_compiler_directive_decl] = STATE(458),
    [sym_fsi_directive_decl] = STATE(458),
    [sym_preproc_line] = STATE(458),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [459] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7346),
    [sym_object_expression] = STATE(7346),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7364),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7346),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym_line_comment] = STATE(459),
    [sym_compiler_directive_decl] = STATE(459),
    [sym_fsi_directive_decl] = STATE(459),
    [sym_preproc_line] = STATE(459),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [460] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(1485),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(460),
    [sym_block_comment] = STATE(460),
    [sym_line_comment] = STATE(460),
    [sym_compiler_directive_decl] = STATE(460),
    [sym_fsi_directive_decl] = STATE(460),
    [sym_preproc_line] = STATE(460),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2403),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [461] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(7),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(922),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(461),
    [sym_block_comment] = STATE(461),
    [sym_line_comment] = STATE(461),
    [sym_compiler_directive_decl] = STATE(461),
    [sym_fsi_directive_decl] = STATE(461),
    [sym_preproc_line] = STATE(461),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2287),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [462] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym_line_comment] = STATE(462),
    [sym_compiler_directive_decl] = STATE(462),
    [sym_fsi_directive_decl] = STATE(462),
    [sym_preproc_line] = STATE(462),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2413),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_namespace] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_open] = ACTIONS(2415),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2415),
    [anon_sym_AMP] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_LT_AT] = ACTIONS(2415),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2415),
    [anon_sym_assert] = ACTIONS(2415),
    [anon_sym_upcast] = ACTIONS(2415),
    [anon_sym_downcast] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_fun] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_match] = ACTIONS(2415),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_use] = ACTIONS(2415),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2415),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2415),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2415),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2415),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2413),
    [anon_sym_POUNDload] = ACTIONS(2413),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2413),
  },
  [463] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7622),
    [sym_object_expression] = STATE(7622),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7635),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7622),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(463),
    [sym_block_comment] = STATE(463),
    [sym_line_comment] = STATE(463),
    [sym_compiler_directive_decl] = STATE(463),
    [sym_fsi_directive_decl] = STATE(463),
    [sym_preproc_line] = STATE(463),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [464] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(285),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(1597),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(464),
    [sym_block_comment] = STATE(464),
    [sym_line_comment] = STATE(464),
    [sym_compiler_directive_decl] = STATE(464),
    [sym_fsi_directive_decl] = STATE(464),
    [sym_preproc_line] = STATE(464),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [465] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7406),
    [sym_object_expression] = STATE(7406),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7371),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7406),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym_line_comment] = STATE(465),
    [sym_compiler_directive_decl] = STATE(465),
    [sym_fsi_directive_decl] = STATE(465),
    [sym_preproc_line] = STATE(465),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [466] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7400),
    [sym_object_expression] = STATE(7400),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7418),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7400),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(466),
    [sym_block_comment] = STATE(466),
    [sym_line_comment] = STATE(466),
    [sym_compiler_directive_decl] = STATE(466),
    [sym_fsi_directive_decl] = STATE(466),
    [sym_preproc_line] = STATE(466),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [467] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7160),
    [sym_object_expression] = STATE(7160),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7173),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7160),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(467),
    [sym_block_comment] = STATE(467),
    [sym_line_comment] = STATE(467),
    [sym_compiler_directive_decl] = STATE(467),
    [sym_fsi_directive_decl] = STATE(467),
    [sym_preproc_line] = STATE(467),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [468] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(277),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(1492),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(468),
    [sym_block_comment] = STATE(468),
    [sym_line_comment] = STATE(468),
    [sym_compiler_directive_decl] = STATE(468),
    [sym_fsi_directive_decl] = STATE(468),
    [sym_preproc_line] = STATE(468),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2419),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [469] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(86),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(922),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(469),
    [sym_block_comment] = STATE(469),
    [sym_line_comment] = STATE(469),
    [sym_compiler_directive_decl] = STATE(469),
    [sym_fsi_directive_decl] = STATE(469),
    [sym_preproc_line] = STATE(469),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2287),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [470] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_with_field_expression] = STATE(7658),
    [sym_object_expression] = STATE(7658),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__comp_or_range_expression] = STATE(7671),
    [sym_short_comp_expression] = STATE(8315),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7658),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1795),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(470),
    [sym_block_comment] = STATE(470),
    [sym_line_comment] = STATE(470),
    [sym_compiler_directive_decl] = STATE(470),
    [sym_fsi_directive_decl] = STATE(470),
    [sym_preproc_line] = STATE(470),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [471] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(78),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1222),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(471),
    [sym_block_comment] = STATE(471),
    [sym_line_comment] = STATE(471),
    [sym_compiler_directive_decl] = STATE(471),
    [sym_fsi_directive_decl] = STATE(471),
    [sym_preproc_line] = STATE(471),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [472] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(255),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_type_arguments] = STATE(3472),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(1680),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym_line_comment] = STATE(472),
    [sym_compiler_directive_decl] = STATE(472),
    [sym_fsi_directive_decl] = STATE(472),
    [sym_preproc_line] = STATE(472),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [473] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(473),
    [sym_block_comment] = STATE(473),
    [sym_line_comment] = STATE(473),
    [sym_compiler_directive_decl] = STATE(473),
    [sym_fsi_directive_decl] = STATE(473),
    [sym_preproc_line] = STATE(473),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7274),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(498),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(1856),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [474] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7865),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(474),
    [sym_block_comment] = STATE(474),
    [sym_line_comment] = STATE(474),
    [sym_compiler_directive_decl] = STATE(474),
    [sym_fsi_directive_decl] = STATE(474),
    [sym_preproc_line] = STATE(474),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [475] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(475),
    [sym_block_comment] = STATE(475),
    [sym_line_comment] = STATE(475),
    [sym_compiler_directive_decl] = STATE(475),
    [sym_fsi_directive_decl] = STATE(475),
    [sym_preproc_line] = STATE(475),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7181),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2435),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [476] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(476),
    [sym_block_comment] = STATE(476),
    [sym_line_comment] = STATE(476),
    [sym_compiler_directive_decl] = STATE(476),
    [sym_fsi_directive_decl] = STATE(476),
    [sym_preproc_line] = STATE(476),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8071),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2437),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [477] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7994),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(477),
    [sym_block_comment] = STATE(477),
    [sym_line_comment] = STATE(477),
    [sym_compiler_directive_decl] = STATE(477),
    [sym_fsi_directive_decl] = STATE(477),
    [sym_preproc_line] = STATE(477),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [478] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(478),
    [sym_block_comment] = STATE(478),
    [sym_line_comment] = STATE(478),
    [sym_compiler_directive_decl] = STATE(478),
    [sym_fsi_directive_decl] = STATE(478),
    [sym_preproc_line] = STATE(478),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7403),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(495),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(1854),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [479] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(479),
    [sym_block_comment] = STATE(479),
    [sym_line_comment] = STATE(479),
    [sym_compiler_directive_decl] = STATE(479),
    [sym_fsi_directive_decl] = STATE(479),
    [sym_preproc_line] = STATE(479),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7904),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2439),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [480] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(480),
    [sym_block_comment] = STATE(480),
    [sym_line_comment] = STATE(480),
    [sym_compiler_directive_decl] = STATE(480),
    [sym_fsi_directive_decl] = STATE(480),
    [sym_preproc_line] = STATE(480),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7601),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2441),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [481] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(31),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(481),
    [sym_block_comment] = STATE(481),
    [sym_line_comment] = STATE(481),
    [sym_compiler_directive_decl] = STATE(481),
    [sym_fsi_directive_decl] = STATE(481),
    [sym_preproc_line] = STATE(481),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_open] = ACTIONS(2415),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2415),
    [anon_sym_AMP] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_LT_AT] = ACTIONS(2415),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2415),
    [anon_sym_assert] = ACTIONS(2415),
    [anon_sym_upcast] = ACTIONS(2415),
    [anon_sym_downcast] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_fun] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_match] = ACTIONS(2415),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_use] = ACTIONS(2415),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2415),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2415),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2415),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2415),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2413),
    [anon_sym_POUNDload] = ACTIONS(2413),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [482] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(482),
    [sym_block_comment] = STATE(482),
    [sym_line_comment] = STATE(482),
    [sym_compiler_directive_decl] = STATE(482),
    [sym_fsi_directive_decl] = STATE(482),
    [sym_preproc_line] = STATE(482),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7298),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(496),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2443),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [483] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(112),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7748),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(483),
    [sym_block_comment] = STATE(483),
    [sym_line_comment] = STATE(483),
    [sym_compiler_directive_decl] = STATE(483),
    [sym_fsi_directive_decl] = STATE(483),
    [sym_preproc_line] = STATE(483),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [484] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(484),
    [sym_block_comment] = STATE(484),
    [sym_line_comment] = STATE(484),
    [sym_compiler_directive_decl] = STATE(484),
    [sym_fsi_directive_decl] = STATE(484),
    [sym_preproc_line] = STATE(484),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7793),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2445),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [485] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(485),
    [sym_block_comment] = STATE(485),
    [sym_line_comment] = STATE(485),
    [sym_compiler_directive_decl] = STATE(485),
    [sym_fsi_directive_decl] = STATE(485),
    [sym_preproc_line] = STATE(485),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7772),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(484),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2447),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [486] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(486),
    [sym_block_comment] = STATE(486),
    [sym_line_comment] = STATE(486),
    [sym_compiler_directive_decl] = STATE(486),
    [sym_fsi_directive_decl] = STATE(486),
    [sym_preproc_line] = STATE(486),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7641),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(480),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2449),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [487] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(487),
    [sym_block_comment] = STATE(487),
    [sym_line_comment] = STATE(487),
    [sym_compiler_directive_decl] = STATE(487),
    [sym_fsi_directive_decl] = STATE(487),
    [sym_preproc_line] = STATE(487),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7882),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(479),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2451),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [488] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(488),
    [sym_block_comment] = STATE(488),
    [sym_line_comment] = STATE(488),
    [sym_compiler_directive_decl] = STATE(488),
    [sym_fsi_directive_decl] = STATE(488),
    [sym_preproc_line] = STATE(488),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2453),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [489] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(57),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7481),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(489),
    [sym_block_comment] = STATE(489),
    [sym_line_comment] = STATE(489),
    [sym_compiler_directive_decl] = STATE(489),
    [sym_fsi_directive_decl] = STATE(489),
    [sym_preproc_line] = STATE(489),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [490] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(490),
    [sym_block_comment] = STATE(490),
    [sym_line_comment] = STATE(490),
    [sym_compiler_directive_decl] = STATE(490),
    [sym_fsi_directive_decl] = STATE(490),
    [sym_preproc_line] = STATE(490),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8155),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2455),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [491] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(90),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(8143),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(491),
    [sym_block_comment] = STATE(491),
    [sym_line_comment] = STATE(491),
    [sym_compiler_directive_decl] = STATE(491),
    [sym_fsi_directive_decl] = STATE(491),
    [sym_preproc_line] = STATE(491),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [492] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(79),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(8270),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(492),
    [sym_block_comment] = STATE(492),
    [sym_line_comment] = STATE(492),
    [sym_compiler_directive_decl] = STATE(492),
    [sym_fsi_directive_decl] = STATE(492),
    [sym_preproc_line] = STATE(492),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [493] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(63),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7797),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(493),
    [sym_block_comment] = STATE(493),
    [sym_line_comment] = STATE(493),
    [sym_compiler_directive_decl] = STATE(493),
    [sym_fsi_directive_decl] = STATE(493),
    [sym_preproc_line] = STATE(493),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [494] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(494),
    [sym_block_comment] = STATE(494),
    [sym_line_comment] = STATE(494),
    [sym_compiler_directive_decl] = STATE(494),
    [sym_fsi_directive_decl] = STATE(494),
    [sym_preproc_line] = STATE(494),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7785),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(488),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2457),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [495] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(495),
    [sym_block_comment] = STATE(495),
    [sym_line_comment] = STATE(495),
    [sym_compiler_directive_decl] = STATE(495),
    [sym_fsi_directive_decl] = STATE(495),
    [sym_preproc_line] = STATE(495),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7436),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2459),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [496] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(496),
    [sym_block_comment] = STATE(496),
    [sym_line_comment] = STATE(496),
    [sym_compiler_directive_decl] = STATE(496),
    [sym_fsi_directive_decl] = STATE(496),
    [sym_preproc_line] = STATE(496),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7273),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2461),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [497] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7206),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(497),
    [sym_block_comment] = STATE(497),
    [sym_line_comment] = STATE(497),
    [sym_compiler_directive_decl] = STATE(497),
    [sym_fsi_directive_decl] = STATE(497),
    [sym_preproc_line] = STATE(497),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [498] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(498),
    [sym_block_comment] = STATE(498),
    [sym_line_comment] = STATE(498),
    [sym_compiler_directive_decl] = STATE(498),
    [sym_fsi_directive_decl] = STATE(498),
    [sym_preproc_line] = STATE(498),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7288),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2463),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [499] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(74),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7380),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(499),
    [sym_block_comment] = STATE(499),
    [sym_line_comment] = STATE(499),
    [sym_compiler_directive_decl] = STATE(499),
    [sym_fsi_directive_decl] = STATE(499),
    [sym_preproc_line] = STATE(499),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [500] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(500),
    [sym_block_comment] = STATE(500),
    [sym_line_comment] = STATE(500),
    [sym_compiler_directive_decl] = STATE(500),
    [sym_fsi_directive_decl] = STATE(500),
    [sym_preproc_line] = STATE(500),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7419),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2465),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [501] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7665),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(501),
    [sym_block_comment] = STATE(501),
    [sym_line_comment] = STATE(501),
    [sym_compiler_directive_decl] = STATE(501),
    [sym_fsi_directive_decl] = STATE(501),
    [sym_preproc_line] = STATE(501),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [502] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(130),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7319),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(502),
    [sym_block_comment] = STATE(502),
    [sym_line_comment] = STATE(502),
    [sym_compiler_directive_decl] = STATE(502),
    [sym_fsi_directive_decl] = STATE(502),
    [sym_preproc_line] = STATE(502),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [503] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(106),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7253),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(503),
    [sym_block_comment] = STATE(503),
    [sym_line_comment] = STATE(503),
    [sym_compiler_directive_decl] = STATE(503),
    [sym_fsi_directive_decl] = STATE(503),
    [sym_preproc_line] = STATE(503),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [504] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(504),
    [sym_block_comment] = STATE(504),
    [sym_line_comment] = STATE(504),
    [sym_compiler_directive_decl] = STATE(504),
    [sym_fsi_directive_decl] = STATE(504),
    [sym_preproc_line] = STATE(504),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8233),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(1846),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [505] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(505),
    [sym_block_comment] = STATE(505),
    [sym_line_comment] = STATE(505),
    [sym_compiler_directive_decl] = STATE(505),
    [sym_fsi_directive_decl] = STATE(505),
    [sym_preproc_line] = STATE(505),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7191),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(475),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2467),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [506] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(506),
    [sym_block_comment] = STATE(506),
    [sym_line_comment] = STATE(506),
    [sym_compiler_directive_decl] = STATE(506),
    [sym_fsi_directive_decl] = STATE(506),
    [sym_preproc_line] = STATE(506),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8217),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2469),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [507] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(507),
    [sym_block_comment] = STATE(507),
    [sym_line_comment] = STATE(507),
    [sym_compiler_directive_decl] = STATE(507),
    [sym_fsi_directive_decl] = STATE(507),
    [sym_preproc_line] = STATE(507),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7687),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2471),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [508] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_slice_ranges] = STATE(7590),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6517),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(508),
    [sym_block_comment] = STATE(508),
    [sym_line_comment] = STATE(508),
    [sym_compiler_directive_decl] = STATE(508),
    [sym_fsi_directive_decl] = STATE(508),
    [sym_preproc_line] = STATE(508),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [509] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(509),
    [sym_block_comment] = STATE(509),
    [sym_line_comment] = STATE(509),
    [sym_compiler_directive_decl] = STATE(509),
    [sym_fsi_directive_decl] = STATE(509),
    [sym_preproc_line] = STATE(509),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7458),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2473),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [510] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(36),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(510),
    [sym_block_comment] = STATE(510),
    [sym_line_comment] = STATE(510),
    [sym_compiler_directive_decl] = STATE(510),
    [sym_fsi_directive_decl] = STATE(510),
    [sym_preproc_line] = STATE(510),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [ts_builtin_sym_end] = ACTIONS(2413),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_open] = ACTIONS(2415),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2415),
    [anon_sym_AMP] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_LT_AT] = ACTIONS(2415),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2415),
    [anon_sym_assert] = ACTIONS(2415),
    [anon_sym_upcast] = ACTIONS(2415),
    [anon_sym_downcast] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_fun] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_match] = ACTIONS(2415),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_use] = ACTIONS(2415),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2415),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2415),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2415),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2415),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2413),
    [anon_sym_POUNDload] = ACTIONS(2413),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2413),
  },
  [511] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(511),
    [sym_block_comment] = STATE(511),
    [sym_line_comment] = STATE(511),
    [sym_compiler_directive_decl] = STATE(511),
    [sym_fsi_directive_decl] = STATE(511),
    [sym_preproc_line] = STATE(511),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(7636),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(507),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2475),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [512] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(512),
    [sym_block_comment] = STATE(512),
    [sym_line_comment] = STATE(512),
    [sym_compiler_directive_decl] = STATE(512),
    [sym_fsi_directive_decl] = STATE(512),
    [sym_preproc_line] = STATE(512),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8044),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(476),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(1852),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [513] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(513),
    [sym_block_comment] = STATE(513),
    [sym_line_comment] = STATE(513),
    [sym_compiler_directive_decl] = STATE(513),
    [sym_fsi_directive_decl] = STATE(513),
    [sym_preproc_line] = STATE(513),
    [sym_preproc_if_in_expression] = STATE(2215),
    [sym_preproc_else_in_expression] = STATE(8176),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(506),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2477),
    [anon_sym_POUNDelse] = ACTIONS(1848),
    [sym__newline] = ACTIONS(1850),
  },
  [514] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7160),
    [sym_object_expression] = STATE(7160),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7160),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(514),
    [sym_block_comment] = STATE(514),
    [sym_line_comment] = STATE(514),
    [sym_compiler_directive_decl] = STATE(514),
    [sym_fsi_directive_decl] = STATE(514),
    [sym_preproc_line] = STATE(514),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [515] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7346),
    [sym_object_expression] = STATE(7346),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7346),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(515),
    [sym_block_comment] = STATE(515),
    [sym_line_comment] = STATE(515),
    [sym_compiler_directive_decl] = STATE(515),
    [sym_fsi_directive_decl] = STATE(515),
    [sym_preproc_line] = STATE(515),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [516] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7400),
    [sym_object_expression] = STATE(7400),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7400),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(516),
    [sym_block_comment] = STATE(516),
    [sym_line_comment] = STATE(516),
    [sym_compiler_directive_decl] = STATE(516),
    [sym_fsi_directive_decl] = STATE(516),
    [sym_preproc_line] = STATE(516),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [517] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7213),
    [sym_object_expression] = STATE(7213),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7213),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(517),
    [sym_block_comment] = STATE(517),
    [sym_line_comment] = STATE(517),
    [sym_compiler_directive_decl] = STATE(517),
    [sym_fsi_directive_decl] = STATE(517),
    [sym_preproc_line] = STATE(517),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [518] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(94),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym__slice_range_special] = STATE(6588),
    [sym_slice_range] = STATE(6647),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(518),
    [sym_block_comment] = STATE(518),
    [sym_line_comment] = STATE(518),
    [sym_compiler_directive_decl] = STATE(518),
    [sym_fsi_directive_decl] = STATE(518),
    [sym_preproc_line] = STATE(518),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_DOT_DOT3] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2279),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [519] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(8310),
    [sym_object_expression] = STATE(8310),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(8310),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(519),
    [sym_block_comment] = STATE(519),
    [sym_line_comment] = STATE(519),
    [sym_compiler_directive_decl] = STATE(519),
    [sym_fsi_directive_decl] = STATE(519),
    [sym_preproc_line] = STATE(519),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [520] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7585),
    [sym_object_expression] = STATE(7585),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7585),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(520),
    [sym_block_comment] = STATE(520),
    [sym_line_comment] = STATE(520),
    [sym_compiler_directive_decl] = STATE(520),
    [sym_fsi_directive_decl] = STATE(520),
    [sym_preproc_line] = STATE(520),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [521] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(521),
    [sym_block_comment] = STATE(521),
    [sym_line_comment] = STATE(521),
    [sym_compiler_directive_decl] = STATE(521),
    [sym_fsi_directive_decl] = STATE(521),
    [sym_preproc_line] = STATE(521),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_let] = ACTIONS(2492),
    [anon_sym_let_BANG] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_null] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2513),
    [anon_sym_LT_AT] = ACTIONS(2516),
    [anon_sym_LT_AT_AT] = ACTIONS(2519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2525),
    [anon_sym_return_BANG] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_yield_BANG] = ACTIONS(2528),
    [anon_sym_lazy] = ACTIONS(2486),
    [anon_sym_assert] = ACTIONS(2486),
    [anon_sym_upcast] = ACTIONS(2486),
    [anon_sym_downcast] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_fun] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2543),
    [anon_sym_match] = ACTIONS(2546),
    [anon_sym_match_BANG] = ACTIONS(2549),
    [anon_sym_function] = ACTIONS(2552),
    [anon_sym_use] = ACTIONS(2555),
    [anon_sym_use_BANG] = ACTIONS(2558),
    [anon_sym_do_BANG] = ACTIONS(2561),
    [anon_sym_begin] = ACTIONS(2564),
    [aux_sym_char_token1] = ACTIONS(2567),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2573),
    [anon_sym_AT_DQUOTE] = ACTIONS(2576),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2582),
    [sym_bool] = ACTIONS(2585),
    [sym_unit] = ACTIONS(2588),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2591),
    [sym_op_identifier] = ACTIONS(2594),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS_DOT] = ACTIONS(2597),
    [anon_sym_DASH_DOT] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_TILDE] = ACTIONS(2600),
    [aux_sym_prefix_op_token1] = ACTIONS(2603),
    [sym_int] = ACTIONS(2606),
    [sym_xint] = ACTIONS(2609),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2612),
    [anon_sym_POUNDendif] = ACTIONS(888),
    [anon_sym_POUNDelse] = ACTIONS(888),
    [sym__newline] = ACTIONS(2615),
  },
  [522] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7622),
    [sym_object_expression] = STATE(7622),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7622),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(522),
    [sym_block_comment] = STATE(522),
    [sym_line_comment] = STATE(522),
    [sym_compiler_directive_decl] = STATE(522),
    [sym_fsi_directive_decl] = STATE(522),
    [sym_preproc_line] = STATE(522),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [523] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7507),
    [sym_object_expression] = STATE(7507),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7507),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(523),
    [sym_block_comment] = STATE(523),
    [sym_line_comment] = STATE(523),
    [sym_compiler_directive_decl] = STATE(523),
    [sym_fsi_directive_decl] = STATE(523),
    [sym_preproc_line] = STATE(523),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [524] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7286),
    [sym_object_expression] = STATE(7286),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7286),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(524),
    [sym_block_comment] = STATE(524),
    [sym_line_comment] = STATE(524),
    [sym_compiler_directive_decl] = STATE(524),
    [sym_fsi_directive_decl] = STATE(524),
    [sym_preproc_line] = STATE(524),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [525] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7547),
    [sym_object_expression] = STATE(7547),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7547),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(525),
    [sym_block_comment] = STATE(525),
    [sym_line_comment] = STATE(525),
    [sym_compiler_directive_decl] = STATE(525),
    [sym_fsi_directive_decl] = STATE(525),
    [sym_preproc_line] = STATE(525),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [526] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7406),
    [sym_object_expression] = STATE(7406),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7406),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(526),
    [sym_block_comment] = STATE(526),
    [sym_line_comment] = STATE(526),
    [sym_compiler_directive_decl] = STATE(526),
    [sym_fsi_directive_decl] = STATE(526),
    [sym_preproc_line] = STATE(526),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [527] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7454),
    [sym_object_expression] = STATE(7454),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7454),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(527),
    [sym_block_comment] = STATE(527),
    [sym_line_comment] = STATE(527),
    [sym_compiler_directive_decl] = STATE(527),
    [sym_fsi_directive_decl] = STATE(527),
    [sym_preproc_line] = STATE(527),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [528] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(143),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym__slice_range_special] = STATE(6721),
    [sym_slice_range] = STATE(6728),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(528),
    [sym_block_comment] = STATE(528),
    [sym_line_comment] = STATE(528),
    [sym_compiler_directive_decl] = STATE(528),
    [sym_fsi_directive_decl] = STATE(528),
    [sym_preproc_line] = STATE(528),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_DOT_DOT3] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2433),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [529] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_with_field_expression] = STATE(7658),
    [sym_object_expression] = STATE(7658),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_field_initializer] = STATE(6344),
    [sym_field_initializers] = STATE(7658),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(2049),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(529),
    [sym_block_comment] = STATE(529),
    [sym_line_comment] = STATE(529),
    [sym_compiler_directive_decl] = STATE(529),
    [sym_fsi_directive_decl] = STATE(529),
    [sym_preproc_line] = STATE(529),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [530] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(161),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(530),
    [sym_block_comment] = STATE(530),
    [sym_line_comment] = STATE(530),
    [sym_compiler_directive_decl] = STATE(530),
    [sym_fsi_directive_decl] = STATE(530),
    [sym_preproc_line] = STATE(530),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(532),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(2618),
    [sym__newline] = ACTIONS(2620),
  },
  [531] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(161),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(531),
    [sym_block_comment] = STATE(531),
    [sym_line_comment] = STATE(531),
    [sym_compiler_directive_decl] = STATE(531),
    [sym_fsi_directive_decl] = STATE(531),
    [sym_preproc_line] = STATE(531),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(531),
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2492),
    [anon_sym_let_BANG] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_null] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_LT_AT] = ACTIONS(2646),
    [anon_sym_LT_AT_AT] = ACTIONS(2649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2652),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_return_BANG] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2625),
    [anon_sym_yield_BANG] = ACTIONS(2658),
    [anon_sym_lazy] = ACTIONS(2625),
    [anon_sym_assert] = ACTIONS(2625),
    [anon_sym_upcast] = ACTIONS(2625),
    [anon_sym_downcast] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_fun] = ACTIONS(2667),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_match] = ACTIONS(2673),
    [anon_sym_match_BANG] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(2679),
    [anon_sym_use] = ACTIONS(2682),
    [anon_sym_use_BANG] = ACTIONS(2685),
    [anon_sym_do_BANG] = ACTIONS(2688),
    [anon_sym_begin] = ACTIONS(2691),
    [aux_sym_char_token1] = ACTIONS(2694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_AT_DQUOTE] = ACTIONS(2703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2709),
    [sym_bool] = ACTIONS(2712),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2718),
    [sym_op_identifier] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS_DOT] = ACTIONS(2597),
    [anon_sym_DASH_DOT] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_TILDE] = ACTIONS(2600),
    [aux_sym_prefix_op_token1] = ACTIONS(2603),
    [sym_int] = ACTIONS(2724),
    [sym_xint] = ACTIONS(2727),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2730),
    [anon_sym_POUNDendif] = ACTIONS(888),
    [sym__newline] = ACTIONS(2733),
  },
  [532] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(161),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(532),
    [sym_block_comment] = STATE(532),
    [sym_line_comment] = STATE(532),
    [sym_compiler_directive_decl] = STATE(532),
    [sym_fsi_directive_decl] = STATE(532),
    [sym_preproc_line] = STATE(532),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(531),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(2736),
    [sym__newline] = ACTIONS(2620),
  },
  [533] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(155),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(533),
    [sym_block_comment] = STATE(533),
    [sym_line_comment] = STATE(533),
    [sym_compiler_directive_decl] = STATE(533),
    [sym_fsi_directive_decl] = STATE(533),
    [sym_preproc_line] = STATE(533),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_RBRACK] = ACTIONS(2738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [534] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(327),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(534),
    [sym_block_comment] = STATE(534),
    [sym_line_comment] = STATE(534),
    [sym_compiler_directive_decl] = STATE(534),
    [sym_fsi_directive_decl] = STATE(534),
    [sym_preproc_line] = STATE(534),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_GT] = ACTIONS(2740),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [535] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(146),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(535),
    [sym_block_comment] = STATE(535),
    [sym_line_comment] = STATE(535),
    [sym_compiler_directive_decl] = STATE(535),
    [sym_fsi_directive_decl] = STATE(535),
    [sym_preproc_line] = STATE(535),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [anon_sym_POUNDelse] = ACTIONS(2413),
  },
  [536] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(536),
    [sym_block_comment] = STATE(536),
    [sym_line_comment] = STATE(536),
    [sym_compiler_directive_decl] = STATE(536),
    [sym_fsi_directive_decl] = STATE(536),
    [sym_preproc_line] = STATE(536),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
    [sym__dedent] = ACTIONS(2738),
  },
  [537] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(351),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(537),
    [sym_block_comment] = STATE(537),
    [sym_line_comment] = STATE(537),
    [sym_compiler_directive_decl] = STATE(537),
    [sym_fsi_directive_decl] = STATE(537),
    [sym_preproc_line] = STATE(537),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
    [anon_sym_POUNDendif] = ACTIONS(2413),
  },
  [538] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(538),
    [sym_block_comment] = STATE(538),
    [sym_line_comment] = STATE(538),
    [sym_compiler_directive_decl] = STATE(538),
    [sym_fsi_directive_decl] = STATE(538),
    [sym_preproc_line] = STATE(538),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [539] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7300),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(539),
    [sym_block_comment] = STATE(539),
    [sym_line_comment] = STATE(539),
    [sym_compiler_directive_decl] = STATE(539),
    [sym_fsi_directive_decl] = STATE(539),
    [sym_preproc_line] = STATE(539),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [540] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(540),
    [sym_block_comment] = STATE(540),
    [sym_line_comment] = STATE(540),
    [sym_compiler_directive_decl] = STATE(540),
    [sym_fsi_directive_decl] = STATE(540),
    [sym_preproc_line] = STATE(540),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [541] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(116),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_range_expression] = STATE(6674),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(541),
    [sym_block_comment] = STATE(541),
    [sym_line_comment] = STATE(541),
    [sym_compiler_directive_decl] = STATE(541),
    [sym_fsi_directive_decl] = STATE(541),
    [sym_preproc_line] = STATE(541),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [542] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(542),
    [sym_block_comment] = STATE(542),
    [sym_line_comment] = STATE(542),
    [sym_compiler_directive_decl] = STATE(542),
    [sym_fsi_directive_decl] = STATE(542),
    [sym_preproc_line] = STATE(542),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2746),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [543] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(276),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7556),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(543),
    [sym_block_comment] = STATE(543),
    [sym_line_comment] = STATE(543),
    [sym_compiler_directive_decl] = STATE(543),
    [sym_fsi_directive_decl] = STATE(543),
    [sym_preproc_line] = STATE(543),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [544] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(544),
    [sym_block_comment] = STATE(544),
    [sym_line_comment] = STATE(544),
    [sym_compiler_directive_decl] = STATE(544),
    [sym_fsi_directive_decl] = STATE(544),
    [sym_preproc_line] = STATE(544),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [545] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(545),
    [sym_block_comment] = STATE(545),
    [sym_line_comment] = STATE(545),
    [sym_compiler_directive_decl] = STATE(545),
    [sym_fsi_directive_decl] = STATE(545),
    [sym_preproc_line] = STATE(545),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [546] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(265),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7230),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(546),
    [sym_block_comment] = STATE(546),
    [sym_line_comment] = STATE(546),
    [sym_compiler_directive_decl] = STATE(546),
    [sym_fsi_directive_decl] = STATE(546),
    [sym_preproc_line] = STATE(546),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [547] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7413),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(547),
    [sym_block_comment] = STATE(547),
    [sym_line_comment] = STATE(547),
    [sym_compiler_directive_decl] = STATE(547),
    [sym_fsi_directive_decl] = STATE(547),
    [sym_preproc_line] = STATE(547),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [548] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(211),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7230),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(548),
    [sym_block_comment] = STATE(548),
    [sym_line_comment] = STATE(548),
    [sym_compiler_directive_decl] = STATE(548),
    [sym_fsi_directive_decl] = STATE(548),
    [sym_preproc_line] = STATE(548),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [549] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(294),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7467),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(549),
    [sym_block_comment] = STATE(549),
    [sym_line_comment] = STATE(549),
    [sym_compiler_directive_decl] = STATE(549),
    [sym_fsi_directive_decl] = STATE(549),
    [sym_preproc_line] = STATE(549),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [550] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(550),
    [sym_block_comment] = STATE(550),
    [sym_line_comment] = STATE(550),
    [sym_compiler_directive_decl] = STATE(550),
    [sym_fsi_directive_decl] = STATE(550),
    [sym_preproc_line] = STATE(550),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [551] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(300),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7171),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(551),
    [sym_block_comment] = STATE(551),
    [sym_line_comment] = STATE(551),
    [sym_compiler_directive_decl] = STATE(551),
    [sym_fsi_directive_decl] = STATE(551),
    [sym_preproc_line] = STATE(551),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [552] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(282),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(8251),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(552),
    [sym_block_comment] = STATE(552),
    [sym_line_comment] = STATE(552),
    [sym_compiler_directive_decl] = STATE(552),
    [sym_fsi_directive_decl] = STATE(552),
    [sym_preproc_line] = STATE(552),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [553] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(324),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7594),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(553),
    [sym_block_comment] = STATE(553),
    [sym_line_comment] = STATE(553),
    [sym_compiler_directive_decl] = STATE(553),
    [sym_fsi_directive_decl] = STATE(553),
    [sym_preproc_line] = STATE(553),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [554] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(554),
    [sym_block_comment] = STATE(554),
    [sym_line_comment] = STATE(554),
    [sym_compiler_directive_decl] = STATE(554),
    [sym_fsi_directive_decl] = STATE(554),
    [sym_preproc_line] = STATE(554),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2754),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [555] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(555),
    [sym_block_comment] = STATE(555),
    [sym_line_comment] = STATE(555),
    [sym_compiler_directive_decl] = STATE(555),
    [sym_fsi_directive_decl] = STATE(555),
    [sym_preproc_line] = STATE(555),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [556] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(259),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7382),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(556),
    [sym_block_comment] = STATE(556),
    [sym_line_comment] = STATE(556),
    [sym_compiler_directive_decl] = STATE(556),
    [sym_fsi_directive_decl] = STATE(556),
    [sym_preproc_line] = STATE(556),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [557] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(289),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7630),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(557),
    [sym_block_comment] = STATE(557),
    [sym_line_comment] = STATE(557),
    [sym_compiler_directive_decl] = STATE(557),
    [sym_fsi_directive_decl] = STATE(557),
    [sym_preproc_line] = STATE(557),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [558] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(240),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7594),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(558),
    [sym_block_comment] = STATE(558),
    [sym_line_comment] = STATE(558),
    [sym_compiler_directive_decl] = STATE(558),
    [sym_fsi_directive_decl] = STATE(558),
    [sym_preproc_line] = STATE(558),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [559] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(559),
    [sym_block_comment] = STATE(559),
    [sym_line_comment] = STATE(559),
    [sym_compiler_directive_decl] = STATE(559),
    [sym_fsi_directive_decl] = STATE(559),
    [sym_preproc_line] = STATE(559),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [560] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(85),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_range_expression] = STATE(6674),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(560),
    [sym_block_comment] = STATE(560),
    [sym_line_comment] = STATE(560),
    [sym_compiler_directive_decl] = STATE(560),
    [sym_fsi_directive_decl] = STATE(560),
    [sym_preproc_line] = STATE(560),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [561] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(184),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7666),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(561),
    [sym_block_comment] = STATE(561),
    [sym_line_comment] = STATE(561),
    [sym_compiler_directive_decl] = STATE(561),
    [sym_fsi_directive_decl] = STATE(561),
    [sym_preproc_line] = STATE(561),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [562] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(562),
    [sym_block_comment] = STATE(562),
    [sym_line_comment] = STATE(562),
    [sym_compiler_directive_decl] = STATE(562),
    [sym_fsi_directive_decl] = STATE(562),
    [sym_preproc_line] = STATE(562),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [563] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(563),
    [sym_block_comment] = STATE(563),
    [sym_line_comment] = STATE(563),
    [sym_compiler_directive_decl] = STATE(563),
    [sym_fsi_directive_decl] = STATE(563),
    [sym_preproc_line] = STATE(563),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [564] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(564),
    [sym_block_comment] = STATE(564),
    [sym_line_comment] = STATE(564),
    [sym_compiler_directive_decl] = STATE(564),
    [sym_fsi_directive_decl] = STATE(564),
    [sym_preproc_line] = STATE(564),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [565] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(233),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7516),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(565),
    [sym_block_comment] = STATE(565),
    [sym_line_comment] = STATE(565),
    [sym_compiler_directive_decl] = STATE(565),
    [sym_fsi_directive_decl] = STATE(565),
    [sym_preproc_line] = STATE(565),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [566] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(566),
    [sym_block_comment] = STATE(566),
    [sym_line_comment] = STATE(566),
    [sym_compiler_directive_decl] = STATE(566),
    [sym_fsi_directive_decl] = STATE(566),
    [sym_preproc_line] = STATE(566),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(2766),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [567] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(203),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7300),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(567),
    [sym_block_comment] = STATE(567),
    [sym_line_comment] = STATE(567),
    [sym_compiler_directive_decl] = STATE(567),
    [sym_fsi_directive_decl] = STATE(567),
    [sym_preproc_line] = STATE(567),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [568] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(188),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_range_expression] = STATE(7359),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(568),
    [sym_block_comment] = STATE(568),
    [sym_line_comment] = STATE(568),
    [sym_compiler_directive_decl] = STATE(568),
    [sym_fsi_directive_decl] = STATE(568),
    [sym_preproc_line] = STATE(568),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [569] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(214),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(569),
    [sym_block_comment] = STATE(569),
    [sym_line_comment] = STATE(569),
    [sym_compiler_directive_decl] = STATE(569),
    [sym_fsi_directive_decl] = STATE(569),
    [sym_preproc_line] = STATE(569),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [570] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(198),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(570),
    [sym_block_comment] = STATE(570),
    [sym_line_comment] = STATE(570),
    [sym_compiler_directive_decl] = STATE(570),
    [sym_fsi_directive_decl] = STATE(570),
    [sym_preproc_line] = STATE(570),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [571] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(571),
    [sym_block_comment] = STATE(571),
    [sym_line_comment] = STATE(571),
    [sym_compiler_directive_decl] = STATE(571),
    [sym_fsi_directive_decl] = STATE(571),
    [sym_preproc_line] = STATE(571),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [572] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(65),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(572),
    [sym_block_comment] = STATE(572),
    [sym_line_comment] = STATE(572),
    [sym_compiler_directive_decl] = STATE(572),
    [sym_fsi_directive_decl] = STATE(572),
    [sym_preproc_line] = STATE(572),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [573] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(38),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(573),
    [sym_block_comment] = STATE(573),
    [sym_line_comment] = STATE(573),
    [sym_compiler_directive_decl] = STATE(573),
    [sym_fsi_directive_decl] = STATE(573),
    [sym_preproc_line] = STATE(573),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [574] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(64),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(574),
    [sym_block_comment] = STATE(574),
    [sym_line_comment] = STATE(574),
    [sym_compiler_directive_decl] = STATE(574),
    [sym_fsi_directive_decl] = STATE(574),
    [sym_preproc_line] = STATE(574),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [575] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(46),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(575),
    [sym_block_comment] = STATE(575),
    [sym_line_comment] = STATE(575),
    [sym_compiler_directive_decl] = STATE(575),
    [sym_fsi_directive_decl] = STATE(575),
    [sym_preproc_line] = STATE(575),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [576] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(371),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(576),
    [sym_block_comment] = STATE(576),
    [sym_line_comment] = STATE(576),
    [sym_compiler_directive_decl] = STATE(576),
    [sym_fsi_directive_decl] = STATE(576),
    [sym_preproc_line] = STATE(576),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [577] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(344),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(577),
    [sym_block_comment] = STATE(577),
    [sym_line_comment] = STATE(577),
    [sym_compiler_directive_decl] = STATE(577),
    [sym_fsi_directive_decl] = STATE(577),
    [sym_preproc_line] = STATE(577),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [578] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(145),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(578),
    [sym_block_comment] = STATE(578),
    [sym_line_comment] = STATE(578),
    [sym_compiler_directive_decl] = STATE(578),
    [sym_fsi_directive_decl] = STATE(578),
    [sym_preproc_line] = STATE(578),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [579] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(44),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(579),
    [sym_block_comment] = STATE(579),
    [sym_line_comment] = STATE(579),
    [sym_compiler_directive_decl] = STATE(579),
    [sym_fsi_directive_decl] = STATE(579),
    [sym_preproc_line] = STATE(579),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [580] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(53),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(580),
    [sym_block_comment] = STATE(580),
    [sym_line_comment] = STATE(580),
    [sym_compiler_directive_decl] = STATE(580),
    [sym_fsi_directive_decl] = STATE(580),
    [sym_preproc_line] = STATE(580),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [581] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(378),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(581),
    [sym_block_comment] = STATE(581),
    [sym_line_comment] = STATE(581),
    [sym_compiler_directive_decl] = STATE(581),
    [sym_fsi_directive_decl] = STATE(581),
    [sym_preproc_line] = STATE(581),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [582] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(54),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(582),
    [sym_block_comment] = STATE(582),
    [sym_line_comment] = STATE(582),
    [sym_compiler_directive_decl] = STATE(582),
    [sym_fsi_directive_decl] = STATE(582),
    [sym_preproc_line] = STATE(582),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [583] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(55),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(583),
    [sym_block_comment] = STATE(583),
    [sym_line_comment] = STATE(583),
    [sym_compiler_directive_decl] = STATE(583),
    [sym_fsi_directive_decl] = STATE(583),
    [sym_preproc_line] = STATE(583),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [584] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(228),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(584),
    [sym_block_comment] = STATE(584),
    [sym_line_comment] = STATE(584),
    [sym_compiler_directive_decl] = STATE(584),
    [sym_fsi_directive_decl] = STATE(584),
    [sym_preproc_line] = STATE(584),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [585] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(251),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(585),
    [sym_block_comment] = STATE(585),
    [sym_line_comment] = STATE(585),
    [sym_compiler_directive_decl] = STATE(585),
    [sym_fsi_directive_decl] = STATE(585),
    [sym_preproc_line] = STATE(585),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [586] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(341),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(586),
    [sym_block_comment] = STATE(586),
    [sym_line_comment] = STATE(586),
    [sym_compiler_directive_decl] = STATE(586),
    [sym_fsi_directive_decl] = STATE(586),
    [sym_preproc_line] = STATE(586),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [587] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(52),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(587),
    [sym_block_comment] = STATE(587),
    [sym_line_comment] = STATE(587),
    [sym_compiler_directive_decl] = STATE(587),
    [sym_fsi_directive_decl] = STATE(587),
    [sym_preproc_line] = STATE(587),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [588] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(114),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(588),
    [sym_block_comment] = STATE(588),
    [sym_line_comment] = STATE(588),
    [sym_compiler_directive_decl] = STATE(588),
    [sym_fsi_directive_decl] = STATE(588),
    [sym_preproc_line] = STATE(588),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [589] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(323),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(589),
    [sym_block_comment] = STATE(589),
    [sym_line_comment] = STATE(589),
    [sym_compiler_directive_decl] = STATE(589),
    [sym_fsi_directive_decl] = STATE(589),
    [sym_preproc_line] = STATE(589),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [590] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(315),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(590),
    [sym_block_comment] = STATE(590),
    [sym_line_comment] = STATE(590),
    [sym_compiler_directive_decl] = STATE(590),
    [sym_fsi_directive_decl] = STATE(590),
    [sym_preproc_line] = STATE(590),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [591] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(66),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(591),
    [sym_block_comment] = STATE(591),
    [sym_line_comment] = STATE(591),
    [sym_compiler_directive_decl] = STATE(591),
    [sym_fsi_directive_decl] = STATE(591),
    [sym_preproc_line] = STATE(591),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [592] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(349),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(592),
    [sym_block_comment] = STATE(592),
    [sym_line_comment] = STATE(592),
    [sym_compiler_directive_decl] = STATE(592),
    [sym_fsi_directive_decl] = STATE(592),
    [sym_preproc_line] = STATE(592),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [593] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(372),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(593),
    [sym_block_comment] = STATE(593),
    [sym_line_comment] = STATE(593),
    [sym_compiler_directive_decl] = STATE(593),
    [sym_fsi_directive_decl] = STATE(593),
    [sym_preproc_line] = STATE(593),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [594] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(180),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(594),
    [sym_block_comment] = STATE(594),
    [sym_line_comment] = STATE(594),
    [sym_compiler_directive_decl] = STATE(594),
    [sym_fsi_directive_decl] = STATE(594),
    [sym_preproc_line] = STATE(594),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [595] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(325),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(595),
    [sym_block_comment] = STATE(595),
    [sym_line_comment] = STATE(595),
    [sym_compiler_directive_decl] = STATE(595),
    [sym_fsi_directive_decl] = STATE(595),
    [sym_preproc_line] = STATE(595),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [596] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(596),
    [sym_block_comment] = STATE(596),
    [sym_line_comment] = STATE(596),
    [sym_compiler_directive_decl] = STATE(596),
    [sym_fsi_directive_decl] = STATE(596),
    [sym_preproc_line] = STATE(596),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [597] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(71),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(597),
    [sym_block_comment] = STATE(597),
    [sym_line_comment] = STATE(597),
    [sym_compiler_directive_decl] = STATE(597),
    [sym_fsi_directive_decl] = STATE(597),
    [sym_preproc_line] = STATE(597),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [598] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(258),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(598),
    [sym_block_comment] = STATE(598),
    [sym_line_comment] = STATE(598),
    [sym_compiler_directive_decl] = STATE(598),
    [sym_fsi_directive_decl] = STATE(598),
    [sym_preproc_line] = STATE(598),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [599] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(67),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(599),
    [sym_block_comment] = STATE(599),
    [sym_line_comment] = STATE(599),
    [sym_compiler_directive_decl] = STATE(599),
    [sym_fsi_directive_decl] = STATE(599),
    [sym_preproc_line] = STATE(599),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [600] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(160),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(600),
    [sym_block_comment] = STATE(600),
    [sym_line_comment] = STATE(600),
    [sym_compiler_directive_decl] = STATE(600),
    [sym_fsi_directive_decl] = STATE(600),
    [sym_preproc_line] = STATE(600),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [601] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(244),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(601),
    [sym_block_comment] = STATE(601),
    [sym_line_comment] = STATE(601),
    [sym_compiler_directive_decl] = STATE(601),
    [sym_fsi_directive_decl] = STATE(601),
    [sym_preproc_line] = STATE(601),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [602] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(152),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(602),
    [sym_block_comment] = STATE(602),
    [sym_line_comment] = STATE(602),
    [sym_compiler_directive_decl] = STATE(602),
    [sym_fsi_directive_decl] = STATE(602),
    [sym_preproc_line] = STATE(602),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [603] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(333),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(603),
    [sym_block_comment] = STATE(603),
    [sym_line_comment] = STATE(603),
    [sym_compiler_directive_decl] = STATE(603),
    [sym_fsi_directive_decl] = STATE(603),
    [sym_preproc_line] = STATE(603),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [604] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(139),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(604),
    [sym_block_comment] = STATE(604),
    [sym_line_comment] = STATE(604),
    [sym_compiler_directive_decl] = STATE(604),
    [sym_fsi_directive_decl] = STATE(604),
    [sym_preproc_line] = STATE(604),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [605] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(243),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(605),
    [sym_block_comment] = STATE(605),
    [sym_line_comment] = STATE(605),
    [sym_compiler_directive_decl] = STATE(605),
    [sym_fsi_directive_decl] = STATE(605),
    [sym_preproc_line] = STATE(605),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [606] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(242),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(606),
    [sym_block_comment] = STATE(606),
    [sym_line_comment] = STATE(606),
    [sym_compiler_directive_decl] = STATE(606),
    [sym_fsi_directive_decl] = STATE(606),
    [sym_preproc_line] = STATE(606),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [607] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(231),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(607),
    [sym_block_comment] = STATE(607),
    [sym_line_comment] = STATE(607),
    [sym_compiler_directive_decl] = STATE(607),
    [sym_fsi_directive_decl] = STATE(607),
    [sym_preproc_line] = STATE(607),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [608] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(339),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(608),
    [sym_block_comment] = STATE(608),
    [sym_line_comment] = STATE(608),
    [sym_compiler_directive_decl] = STATE(608),
    [sym_fsi_directive_decl] = STATE(608),
    [sym_preproc_line] = STATE(608),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [609] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(127),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(609),
    [sym_block_comment] = STATE(609),
    [sym_line_comment] = STATE(609),
    [sym_compiler_directive_decl] = STATE(609),
    [sym_fsi_directive_decl] = STATE(609),
    [sym_preproc_line] = STATE(609),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [610] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(138),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(610),
    [sym_block_comment] = STATE(610),
    [sym_line_comment] = STATE(610),
    [sym_compiler_directive_decl] = STATE(610),
    [sym_fsi_directive_decl] = STATE(610),
    [sym_preproc_line] = STATE(610),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [611] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(230),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(611),
    [sym_block_comment] = STATE(611),
    [sym_line_comment] = STATE(611),
    [sym_compiler_directive_decl] = STATE(611),
    [sym_fsi_directive_decl] = STATE(611),
    [sym_preproc_line] = STATE(611),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [612] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(136),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(612),
    [sym_block_comment] = STATE(612),
    [sym_line_comment] = STATE(612),
    [sym_compiler_directive_decl] = STATE(612),
    [sym_fsi_directive_decl] = STATE(612),
    [sym_preproc_line] = STATE(612),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [613] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(280),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(613),
    [sym_block_comment] = STATE(613),
    [sym_line_comment] = STATE(613),
    [sym_compiler_directive_decl] = STATE(613),
    [sym_fsi_directive_decl] = STATE(613),
    [sym_preproc_line] = STATE(613),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [614] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(133),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(614),
    [sym_block_comment] = STATE(614),
    [sym_line_comment] = STATE(614),
    [sym_compiler_directive_decl] = STATE(614),
    [sym_fsi_directive_decl] = STATE(614),
    [sym_preproc_line] = STATE(614),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [615] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(140),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(615),
    [sym_block_comment] = STATE(615),
    [sym_line_comment] = STATE(615),
    [sym_compiler_directive_decl] = STATE(615),
    [sym_fsi_directive_decl] = STATE(615),
    [sym_preproc_line] = STATE(615),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [616] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(360),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(616),
    [sym_block_comment] = STATE(616),
    [sym_line_comment] = STATE(616),
    [sym_compiler_directive_decl] = STATE(616),
    [sym_fsi_directive_decl] = STATE(616),
    [sym_preproc_line] = STATE(616),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [617] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(321),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(617),
    [sym_block_comment] = STATE(617),
    [sym_line_comment] = STATE(617),
    [sym_compiler_directive_decl] = STATE(617),
    [sym_fsi_directive_decl] = STATE(617),
    [sym_preproc_line] = STATE(617),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [618] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(296),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(618),
    [sym_block_comment] = STATE(618),
    [sym_line_comment] = STATE(618),
    [sym_compiler_directive_decl] = STATE(618),
    [sym_fsi_directive_decl] = STATE(618),
    [sym_preproc_line] = STATE(618),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [619] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(224),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(619),
    [sym_block_comment] = STATE(619),
    [sym_line_comment] = STATE(619),
    [sym_compiler_directive_decl] = STATE(619),
    [sym_fsi_directive_decl] = STATE(619),
    [sym_preproc_line] = STATE(619),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [620] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(320),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(620),
    [sym_block_comment] = STATE(620),
    [sym_line_comment] = STATE(620),
    [sym_compiler_directive_decl] = STATE(620),
    [sym_fsi_directive_decl] = STATE(620),
    [sym_preproc_line] = STATE(620),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [621] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(220),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(621),
    [sym_block_comment] = STATE(621),
    [sym_line_comment] = STATE(621),
    [sym_compiler_directive_decl] = STATE(621),
    [sym_fsi_directive_decl] = STATE(621),
    [sym_preproc_line] = STATE(621),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [622] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(303),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(622),
    [sym_block_comment] = STATE(622),
    [sym_line_comment] = STATE(622),
    [sym_compiler_directive_decl] = STATE(622),
    [sym_fsi_directive_decl] = STATE(622),
    [sym_preproc_line] = STATE(622),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [623] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(298),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(623),
    [sym_block_comment] = STATE(623),
    [sym_line_comment] = STATE(623),
    [sym_compiler_directive_decl] = STATE(623),
    [sym_fsi_directive_decl] = STATE(623),
    [sym_preproc_line] = STATE(623),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [624] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(297),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(624),
    [sym_block_comment] = STATE(624),
    [sym_line_comment] = STATE(624),
    [sym_compiler_directive_decl] = STATE(624),
    [sym_fsi_directive_decl] = STATE(624),
    [sym_preproc_line] = STATE(624),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [625] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(266),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(625),
    [sym_block_comment] = STATE(625),
    [sym_line_comment] = STATE(625),
    [sym_compiler_directive_decl] = STATE(625),
    [sym_fsi_directive_decl] = STATE(625),
    [sym_preproc_line] = STATE(625),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [626] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(135),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(626),
    [sym_block_comment] = STATE(626),
    [sym_line_comment] = STATE(626),
    [sym_compiler_directive_decl] = STATE(626),
    [sym_fsi_directive_decl] = STATE(626),
    [sym_preproc_line] = STATE(626),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [627] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(221),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(627),
    [sym_block_comment] = STATE(627),
    [sym_line_comment] = STATE(627),
    [sym_compiler_directive_decl] = STATE(627),
    [sym_fsi_directive_decl] = STATE(627),
    [sym_preproc_line] = STATE(627),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [628] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(262),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(628),
    [sym_block_comment] = STATE(628),
    [sym_line_comment] = STATE(628),
    [sym_compiler_directive_decl] = STATE(628),
    [sym_fsi_directive_decl] = STATE(628),
    [sym_preproc_line] = STATE(628),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [629] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(287),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(629),
    [sym_block_comment] = STATE(629),
    [sym_line_comment] = STATE(629),
    [sym_compiler_directive_decl] = STATE(629),
    [sym_fsi_directive_decl] = STATE(629),
    [sym_preproc_line] = STATE(629),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [630] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(146),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(630),
    [sym_block_comment] = STATE(630),
    [sym_line_comment] = STATE(630),
    [sym_compiler_directive_decl] = STATE(630),
    [sym_fsi_directive_decl] = STATE(630),
    [sym_preproc_line] = STATE(630),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [631] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(365),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(631),
    [sym_block_comment] = STATE(631),
    [sym_line_comment] = STATE(631),
    [sym_compiler_directive_decl] = STATE(631),
    [sym_fsi_directive_decl] = STATE(631),
    [sym_preproc_line] = STATE(631),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [632] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(27),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(632),
    [sym_block_comment] = STATE(632),
    [sym_line_comment] = STATE(632),
    [sym_compiler_directive_decl] = STATE(632),
    [sym_fsi_directive_decl] = STATE(632),
    [sym_preproc_line] = STATE(632),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [633] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(633),
    [sym_block_comment] = STATE(633),
    [sym_line_comment] = STATE(633),
    [sym_compiler_directive_decl] = STATE(633),
    [sym_fsi_directive_decl] = STATE(633),
    [sym_preproc_line] = STATE(633),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [634] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(379),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(634),
    [sym_block_comment] = STATE(634),
    [sym_line_comment] = STATE(634),
    [sym_compiler_directive_decl] = STATE(634),
    [sym_fsi_directive_decl] = STATE(634),
    [sym_preproc_line] = STATE(634),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [635] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(635),
    [sym_block_comment] = STATE(635),
    [sym_line_comment] = STATE(635),
    [sym_compiler_directive_decl] = STATE(635),
    [sym_fsi_directive_decl] = STATE(635),
    [sym_preproc_line] = STATE(635),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [636] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(382),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(636),
    [sym_block_comment] = STATE(636),
    [sym_line_comment] = STATE(636),
    [sym_compiler_directive_decl] = STATE(636),
    [sym_fsi_directive_decl] = STATE(636),
    [sym_preproc_line] = STATE(636),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [637] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(263),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(637),
    [sym_block_comment] = STATE(637),
    [sym_line_comment] = STATE(637),
    [sym_compiler_directive_decl] = STATE(637),
    [sym_fsi_directive_decl] = STATE(637),
    [sym_preproc_line] = STATE(637),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [638] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(202),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(638),
    [sym_block_comment] = STATE(638),
    [sym_line_comment] = STATE(638),
    [sym_compiler_directive_decl] = STATE(638),
    [sym_fsi_directive_decl] = STATE(638),
    [sym_preproc_line] = STATE(638),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [639] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(204),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(639),
    [sym_block_comment] = STATE(639),
    [sym_line_comment] = STATE(639),
    [sym_compiler_directive_decl] = STATE(639),
    [sym_fsi_directive_decl] = STATE(639),
    [sym_preproc_line] = STATE(639),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [640] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(189),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(640),
    [sym_block_comment] = STATE(640),
    [sym_line_comment] = STATE(640),
    [sym_compiler_directive_decl] = STATE(640),
    [sym_fsi_directive_decl] = STATE(640),
    [sym_preproc_line] = STATE(640),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [641] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(182),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(641),
    [sym_block_comment] = STATE(641),
    [sym_line_comment] = STATE(641),
    [sym_compiler_directive_decl] = STATE(641),
    [sym_fsi_directive_decl] = STATE(641),
    [sym_preproc_line] = STATE(641),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [642] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(166),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(642),
    [sym_block_comment] = STATE(642),
    [sym_line_comment] = STATE(642),
    [sym_compiler_directive_decl] = STATE(642),
    [sym_fsi_directive_decl] = STATE(642),
    [sym_preproc_line] = STATE(642),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [643] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(274),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(643),
    [sym_block_comment] = STATE(643),
    [sym_line_comment] = STATE(643),
    [sym_compiler_directive_decl] = STATE(643),
    [sym_fsi_directive_decl] = STATE(643),
    [sym_preproc_line] = STATE(643),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [644] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(644),
    [sym_block_comment] = STATE(644),
    [sym_line_comment] = STATE(644),
    [sym_compiler_directive_decl] = STATE(644),
    [sym_fsi_directive_decl] = STATE(644),
    [sym_preproc_line] = STATE(644),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [645] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(376),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(645),
    [sym_block_comment] = STATE(645),
    [sym_line_comment] = STATE(645),
    [sym_compiler_directive_decl] = STATE(645),
    [sym_fsi_directive_decl] = STATE(645),
    [sym_preproc_line] = STATE(645),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [646] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(193),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(646),
    [sym_block_comment] = STATE(646),
    [sym_line_comment] = STATE(646),
    [sym_compiler_directive_decl] = STATE(646),
    [sym_fsi_directive_decl] = STATE(646),
    [sym_preproc_line] = STATE(646),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [647] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(164),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(647),
    [sym_block_comment] = STATE(647),
    [sym_line_comment] = STATE(647),
    [sym_compiler_directive_decl] = STATE(647),
    [sym_fsi_directive_decl] = STATE(647),
    [sym_preproc_line] = STATE(647),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [648] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(148),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(648),
    [sym_block_comment] = STATE(648),
    [sym_line_comment] = STATE(648),
    [sym_compiler_directive_decl] = STATE(648),
    [sym_fsi_directive_decl] = STATE(648),
    [sym_preproc_line] = STATE(648),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [649] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(91),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(649),
    [sym_block_comment] = STATE(649),
    [sym_line_comment] = STATE(649),
    [sym_compiler_directive_decl] = STATE(649),
    [sym_fsi_directive_decl] = STATE(649),
    [sym_preproc_line] = STATE(649),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [650] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(268),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(650),
    [sym_block_comment] = STATE(650),
    [sym_line_comment] = STATE(650),
    [sym_compiler_directive_decl] = STATE(650),
    [sym_fsi_directive_decl] = STATE(650),
    [sym_preproc_line] = STATE(650),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [651] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(304),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(651),
    [sym_block_comment] = STATE(651),
    [sym_line_comment] = STATE(651),
    [sym_compiler_directive_decl] = STATE(651),
    [sym_fsi_directive_decl] = STATE(651),
    [sym_preproc_line] = STATE(651),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [652] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(157),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(652),
    [sym_block_comment] = STATE(652),
    [sym_line_comment] = STATE(652),
    [sym_compiler_directive_decl] = STATE(652),
    [sym_fsi_directive_decl] = STATE(652),
    [sym_preproc_line] = STATE(652),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [653] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(156),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(653),
    [sym_block_comment] = STATE(653),
    [sym_line_comment] = STATE(653),
    [sym_compiler_directive_decl] = STATE(653),
    [sym_fsi_directive_decl] = STATE(653),
    [sym_preproc_line] = STATE(653),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [654] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(154),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(654),
    [sym_block_comment] = STATE(654),
    [sym_line_comment] = STATE(654),
    [sym_compiler_directive_decl] = STATE(654),
    [sym_fsi_directive_decl] = STATE(654),
    [sym_preproc_line] = STATE(654),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [655] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(151),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(655),
    [sym_block_comment] = STATE(655),
    [sym_line_comment] = STATE(655),
    [sym_compiler_directive_decl] = STATE(655),
    [sym_fsi_directive_decl] = STATE(655),
    [sym_preproc_line] = STATE(655),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [656] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(223),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(656),
    [sym_block_comment] = STATE(656),
    [sym_line_comment] = STATE(656),
    [sym_compiler_directive_decl] = STATE(656),
    [sym_fsi_directive_decl] = STATE(656),
    [sym_preproc_line] = STATE(656),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [657] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(149),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(657),
    [sym_block_comment] = STATE(657),
    [sym_line_comment] = STATE(657),
    [sym_compiler_directive_decl] = STATE(657),
    [sym_fsi_directive_decl] = STATE(657),
    [sym_preproc_line] = STATE(657),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [658] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(658),
    [sym_block_comment] = STATE(658),
    [sym_line_comment] = STATE(658),
    [sym_compiler_directive_decl] = STATE(658),
    [sym_fsi_directive_decl] = STATE(658),
    [sym_preproc_line] = STATE(658),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [659] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(159),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(659),
    [sym_block_comment] = STATE(659),
    [sym_line_comment] = STATE(659),
    [sym_compiler_directive_decl] = STATE(659),
    [sym_fsi_directive_decl] = STATE(659),
    [sym_preproc_line] = STATE(659),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [660] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(132),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(660),
    [sym_block_comment] = STATE(660),
    [sym_line_comment] = STATE(660),
    [sym_compiler_directive_decl] = STATE(660),
    [sym_fsi_directive_decl] = STATE(660),
    [sym_preproc_line] = STATE(660),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [661] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(23),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(661),
    [sym_block_comment] = STATE(661),
    [sym_line_comment] = STATE(661),
    [sym_compiler_directive_decl] = STATE(661),
    [sym_fsi_directive_decl] = STATE(661),
    [sym_preproc_line] = STATE(661),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [662] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(163),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(662),
    [sym_block_comment] = STATE(662),
    [sym_line_comment] = STATE(662),
    [sym_compiler_directive_decl] = STATE(662),
    [sym_fsi_directive_decl] = STATE(662),
    [sym_preproc_line] = STATE(662),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [663] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(115),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(663),
    [sym_block_comment] = STATE(663),
    [sym_line_comment] = STATE(663),
    [sym_compiler_directive_decl] = STATE(663),
    [sym_fsi_directive_decl] = STATE(663),
    [sym_preproc_line] = STATE(663),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [664] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(144),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(664),
    [sym_block_comment] = STATE(664),
    [sym_line_comment] = STATE(664),
    [sym_compiler_directive_decl] = STATE(664),
    [sym_fsi_directive_decl] = STATE(664),
    [sym_preproc_line] = STATE(664),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [665] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(665),
    [sym_block_comment] = STATE(665),
    [sym_line_comment] = STATE(665),
    [sym_compiler_directive_decl] = STATE(665),
    [sym_fsi_directive_decl] = STATE(665),
    [sym_preproc_line] = STATE(665),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [666] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(22),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(666),
    [sym_block_comment] = STATE(666),
    [sym_line_comment] = STATE(666),
    [sym_compiler_directive_decl] = STATE(666),
    [sym_fsi_directive_decl] = STATE(666),
    [sym_preproc_line] = STATE(666),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [667] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(293),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(667),
    [sym_block_comment] = STATE(667),
    [sym_line_comment] = STATE(667),
    [sym_compiler_directive_decl] = STATE(667),
    [sym_fsi_directive_decl] = STATE(667),
    [sym_preproc_line] = STATE(667),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [668] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(335),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(668),
    [sym_block_comment] = STATE(668),
    [sym_line_comment] = STATE(668),
    [sym_compiler_directive_decl] = STATE(668),
    [sym_fsi_directive_decl] = STATE(668),
    [sym_preproc_line] = STATE(668),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [669] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(82),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(669),
    [sym_block_comment] = STATE(669),
    [sym_line_comment] = STATE(669),
    [sym_compiler_directive_decl] = STATE(669),
    [sym_fsi_directive_decl] = STATE(669),
    [sym_preproc_line] = STATE(669),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [670] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(670),
    [sym_block_comment] = STATE(670),
    [sym_line_comment] = STATE(670),
    [sym_compiler_directive_decl] = STATE(670),
    [sym_fsi_directive_decl] = STATE(670),
    [sym_preproc_line] = STATE(670),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [671] = {
    [sym_function_or_value_defn] = STATE(587),
    [sym__expression] = STATE(51),
    [sym_literal_expression] = STATE(2010),
    [sym_long_identifier_or_op] = STATE(2010),
    [sym_tuple_expression] = STATE(2010),
    [sym_brace_expression] = STATE(2010),
    [sym_anon_record_expression] = STATE(2010),
    [sym_prefixed_expression] = STATE(2010),
    [sym_typecast_expression] = STATE(2010),
    [sym_for_expression] = STATE(2010),
    [sym_while_expression] = STATE(2010),
    [sym__if_branch] = STATE(7647),
    [sym_if_expression] = STATE(2010),
    [sym_fun_expression] = STATE(2010),
    [sym_try_expression] = STATE(2010),
    [sym_match_expression] = STATE(2010),
    [sym_function_expression] = STATE(2010),
    [sym_object_instantiation_expression] = STATE(2010),
    [sym_mutate_expression] = STATE(2010),
    [sym_index_expression] = STATE(2010),
    [sym_dot_expression] = STATE(2010),
    [sym_typed_expression] = STATE(2010),
    [sym_declaration_expression] = STATE(2010),
    [sym_do_expression] = STATE(2010),
    [sym_list_expression] = STATE(2010),
    [sym_array_expression] = STATE(2010),
    [sym_begin_end_expression] = STATE(2010),
    [sym_paren_expression] = STATE(2010),
    [sym_application_expression] = STATE(2010),
    [sym_infix_expression] = STATE(2010),
    [sym_ce_expression] = STATE(2010),
    [sym_sequential_expression] = STATE(2010),
    [sym_char] = STATE(1894),
    [sym_format_string] = STATE(1902),
    [sym__string_literal] = STATE(1902),
    [sym_string] = STATE(1894),
    [sym_verbatim_string] = STATE(1894),
    [sym_bytearray] = STATE(1894),
    [sym_verbatim_bytearray] = STATE(1894),
    [sym_format_triple_quoted_string] = STATE(1905),
    [sym_triple_quoted_string] = STATE(1894),
    [sym_const] = STATE(2010),
    [sym_long_identifier] = STATE(1804),
    [sym_active_pattern] = STATE(1762),
    [sym__identifier_or_op] = STATE(1755),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(671),
    [sym_sbyte] = STATE(1894),
    [sym_byte] = STATE(1894),
    [sym_int16] = STATE(1894),
    [sym_uint16] = STATE(1894),
    [sym_int32] = STATE(1894),
    [sym_uint32] = STATE(1894),
    [sym_nativeint] = STATE(1894),
    [sym_unativeint] = STATE(1894),
    [sym_int64] = STATE(1894),
    [sym_uint64] = STATE(1894),
    [sym_ieee32] = STATE(1894),
    [sym_ieee64] = STATE(1894),
    [sym_bignum] = STATE(1894),
    [sym_decimal] = STATE(1894),
    [sym_float] = STATE(1517),
    [sym_xml_doc] = STATE(671),
    [sym_block_comment] = STATE(671),
    [sym_line_comment] = STATE(671),
    [sym_compiler_directive_decl] = STATE(671),
    [sym_fsi_directive_decl] = STATE(671),
    [sym_preproc_line] = STATE(671),
    [sym_preproc_if_in_expression] = STATE(2010),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_null] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT_AT] = ACTIONS(527),
    [anon_sym_LT_AT_AT] = ACTIONS(2313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(533),
    [anon_sym_return_BANG] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_yield_BANG] = ACTIONS(535),
    [anon_sym_lazy] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(511),
    [anon_sym_upcast] = ACTIONS(511),
    [anon_sym_downcast] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(545),
    [anon_sym_match] = ACTIONS(547),
    [anon_sym_match_BANG] = ACTIONS(549),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_use] = ACTIONS(555),
    [anon_sym_use_BANG] = ACTIONS(557),
    [anon_sym_do_BANG] = ACTIONS(559),
    [anon_sym_begin] = ACTIONS(561),
    [aux_sym_char_token1] = ACTIONS(565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_AT_DQUOTE] = ACTIONS(571),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [sym_bool] = ACTIONS(577),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(579),
    [sym_op_identifier] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(583),
    [sym_xint] = ACTIONS(585),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(587),
  },
  [672] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(229),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(672),
    [sym_block_comment] = STATE(672),
    [sym_line_comment] = STATE(672),
    [sym_compiler_directive_decl] = STATE(672),
    [sym_fsi_directive_decl] = STATE(672),
    [sym_preproc_line] = STATE(672),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [673] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(295),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(673),
    [sym_block_comment] = STATE(673),
    [sym_line_comment] = STATE(673),
    [sym_compiler_directive_decl] = STATE(673),
    [sym_fsi_directive_decl] = STATE(673),
    [sym_preproc_line] = STATE(673),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [674] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(362),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(674),
    [sym_block_comment] = STATE(674),
    [sym_line_comment] = STATE(674),
    [sym_compiler_directive_decl] = STATE(674),
    [sym_fsi_directive_decl] = STATE(674),
    [sym_preproc_line] = STATE(674),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [675] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(206),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(675),
    [sym_block_comment] = STATE(675),
    [sym_line_comment] = STATE(675),
    [sym_compiler_directive_decl] = STATE(675),
    [sym_fsi_directive_decl] = STATE(675),
    [sym_preproc_line] = STATE(675),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [676] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(117),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(676),
    [sym_block_comment] = STATE(676),
    [sym_line_comment] = STATE(676),
    [sym_compiler_directive_decl] = STATE(676),
    [sym_fsi_directive_decl] = STATE(676),
    [sym_preproc_line] = STATE(676),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [677] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(373),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(677),
    [sym_block_comment] = STATE(677),
    [sym_line_comment] = STATE(677),
    [sym_compiler_directive_decl] = STATE(677),
    [sym_fsi_directive_decl] = STATE(677),
    [sym_preproc_line] = STATE(677),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [678] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(105),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(678),
    [sym_block_comment] = STATE(678),
    [sym_line_comment] = STATE(678),
    [sym_compiler_directive_decl] = STATE(678),
    [sym_fsi_directive_decl] = STATE(678),
    [sym_preproc_line] = STATE(678),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [679] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(205),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(679),
    [sym_block_comment] = STATE(679),
    [sym_line_comment] = STATE(679),
    [sym_compiler_directive_decl] = STATE(679),
    [sym_fsi_directive_decl] = STATE(679),
    [sym_preproc_line] = STATE(679),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [680] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(178),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(680),
    [sym_block_comment] = STATE(680),
    [sym_line_comment] = STATE(680),
    [sym_compiler_directive_decl] = STATE(680),
    [sym_fsi_directive_decl] = STATE(680),
    [sym_preproc_line] = STATE(680),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [681] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(383),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(681),
    [sym_block_comment] = STATE(681),
    [sym_line_comment] = STATE(681),
    [sym_compiler_directive_decl] = STATE(681),
    [sym_fsi_directive_decl] = STATE(681),
    [sym_preproc_line] = STATE(681),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [682] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(370),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(682),
    [sym_block_comment] = STATE(682),
    [sym_line_comment] = STATE(682),
    [sym_compiler_directive_decl] = STATE(682),
    [sym_fsi_directive_decl] = STATE(682),
    [sym_preproc_line] = STATE(682),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [683] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(290),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(683),
    [sym_block_comment] = STATE(683),
    [sym_line_comment] = STATE(683),
    [sym_compiler_directive_decl] = STATE(683),
    [sym_fsi_directive_decl] = STATE(683),
    [sym_preproc_line] = STATE(683),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [684] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(237),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(684),
    [sym_block_comment] = STATE(684),
    [sym_line_comment] = STATE(684),
    [sym_compiler_directive_decl] = STATE(684),
    [sym_fsi_directive_decl] = STATE(684),
    [sym_preproc_line] = STATE(684),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [685] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(328),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(685),
    [sym_block_comment] = STATE(685),
    [sym_line_comment] = STATE(685),
    [sym_compiler_directive_decl] = STATE(685),
    [sym_fsi_directive_decl] = STATE(685),
    [sym_preproc_line] = STATE(685),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [686] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(29),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(686),
    [sym_block_comment] = STATE(686),
    [sym_line_comment] = STATE(686),
    [sym_compiler_directive_decl] = STATE(686),
    [sym_fsi_directive_decl] = STATE(686),
    [sym_preproc_line] = STATE(686),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [687] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(199),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(687),
    [sym_block_comment] = STATE(687),
    [sym_line_comment] = STATE(687),
    [sym_compiler_directive_decl] = STATE(687),
    [sym_fsi_directive_decl] = STATE(687),
    [sym_preproc_line] = STATE(687),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [688] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(201),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(688),
    [sym_block_comment] = STATE(688),
    [sym_line_comment] = STATE(688),
    [sym_compiler_directive_decl] = STATE(688),
    [sym_fsi_directive_decl] = STATE(688),
    [sym_preproc_line] = STATE(688),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [689] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(275),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(689),
    [sym_block_comment] = STATE(689),
    [sym_line_comment] = STATE(689),
    [sym_compiler_directive_decl] = STATE(689),
    [sym_fsi_directive_decl] = STATE(689),
    [sym_preproc_line] = STATE(689),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [690] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(30),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(690),
    [sym_block_comment] = STATE(690),
    [sym_line_comment] = STATE(690),
    [sym_compiler_directive_decl] = STATE(690),
    [sym_fsi_directive_decl] = STATE(690),
    [sym_preproc_line] = STATE(690),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [691] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(272),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(691),
    [sym_block_comment] = STATE(691),
    [sym_line_comment] = STATE(691),
    [sym_compiler_directive_decl] = STATE(691),
    [sym_fsi_directive_decl] = STATE(691),
    [sym_preproc_line] = STATE(691),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [692] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(232),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(692),
    [sym_block_comment] = STATE(692),
    [sym_line_comment] = STATE(692),
    [sym_compiler_directive_decl] = STATE(692),
    [sym_fsi_directive_decl] = STATE(692),
    [sym_preproc_line] = STATE(692),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [693] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(252),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(693),
    [sym_block_comment] = STATE(693),
    [sym_line_comment] = STATE(693),
    [sym_compiler_directive_decl] = STATE(693),
    [sym_fsi_directive_decl] = STATE(693),
    [sym_preproc_line] = STATE(693),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [694] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(314),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(694),
    [sym_block_comment] = STATE(694),
    [sym_line_comment] = STATE(694),
    [sym_compiler_directive_decl] = STATE(694),
    [sym_fsi_directive_decl] = STATE(694),
    [sym_preproc_line] = STATE(694),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [695] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(695),
    [sym_block_comment] = STATE(695),
    [sym_line_comment] = STATE(695),
    [sym_compiler_directive_decl] = STATE(695),
    [sym_fsi_directive_decl] = STATE(695),
    [sym_preproc_line] = STATE(695),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [696] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(103),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(696),
    [sym_block_comment] = STATE(696),
    [sym_line_comment] = STATE(696),
    [sym_compiler_directive_decl] = STATE(696),
    [sym_fsi_directive_decl] = STATE(696),
    [sym_preproc_line] = STATE(696),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [697] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(697),
    [sym_block_comment] = STATE(697),
    [sym_line_comment] = STATE(697),
    [sym_compiler_directive_decl] = STATE(697),
    [sym_fsi_directive_decl] = STATE(697),
    [sym_preproc_line] = STATE(697),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [698] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(218),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(698),
    [sym_block_comment] = STATE(698),
    [sym_line_comment] = STATE(698),
    [sym_compiler_directive_decl] = STATE(698),
    [sym_fsi_directive_decl] = STATE(698),
    [sym_preproc_line] = STATE(698),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [699] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(699),
    [sym_block_comment] = STATE(699),
    [sym_line_comment] = STATE(699),
    [sym_compiler_directive_decl] = STATE(699),
    [sym_fsi_directive_decl] = STATE(699),
    [sym_preproc_line] = STATE(699),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [700] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(141),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(700),
    [sym_block_comment] = STATE(700),
    [sym_line_comment] = STATE(700),
    [sym_compiler_directive_decl] = STATE(700),
    [sym_fsi_directive_decl] = STATE(700),
    [sym_preproc_line] = STATE(700),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [701] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(13),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(701),
    [sym_block_comment] = STATE(701),
    [sym_line_comment] = STATE(701),
    [sym_compiler_directive_decl] = STATE(701),
    [sym_fsi_directive_decl] = STATE(701),
    [sym_preproc_line] = STATE(701),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [702] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(16),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(702),
    [sym_block_comment] = STATE(702),
    [sym_line_comment] = STATE(702),
    [sym_compiler_directive_decl] = STATE(702),
    [sym_fsi_directive_decl] = STATE(702),
    [sym_preproc_line] = STATE(702),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [703] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(33),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(703),
    [sym_block_comment] = STATE(703),
    [sym_line_comment] = STATE(703),
    [sym_compiler_directive_decl] = STATE(703),
    [sym_fsi_directive_decl] = STATE(703),
    [sym_preproc_line] = STATE(703),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [704] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(208),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(704),
    [sym_block_comment] = STATE(704),
    [sym_line_comment] = STATE(704),
    [sym_compiler_directive_decl] = STATE(704),
    [sym_fsi_directive_decl] = STATE(704),
    [sym_preproc_line] = STATE(704),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [705] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(267),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(705),
    [sym_block_comment] = STATE(705),
    [sym_line_comment] = STATE(705),
    [sym_compiler_directive_decl] = STATE(705),
    [sym_fsi_directive_decl] = STATE(705),
    [sym_preproc_line] = STATE(705),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [706] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(12),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(706),
    [sym_block_comment] = STATE(706),
    [sym_line_comment] = STATE(706),
    [sym_compiler_directive_decl] = STATE(706),
    [sym_fsi_directive_decl] = STATE(706),
    [sym_preproc_line] = STATE(706),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [707] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(14),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(707),
    [sym_block_comment] = STATE(707),
    [sym_line_comment] = STATE(707),
    [sym_compiler_directive_decl] = STATE(707),
    [sym_fsi_directive_decl] = STATE(707),
    [sym_preproc_line] = STATE(707),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [708] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(168),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(708),
    [sym_block_comment] = STATE(708),
    [sym_line_comment] = STATE(708),
    [sym_compiler_directive_decl] = STATE(708),
    [sym_fsi_directive_decl] = STATE(708),
    [sym_preproc_line] = STATE(708),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [709] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(270),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(709),
    [sym_block_comment] = STATE(709),
    [sym_line_comment] = STATE(709),
    [sym_compiler_directive_decl] = STATE(709),
    [sym_fsi_directive_decl] = STATE(709),
    [sym_preproc_line] = STATE(709),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [710] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(187),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(710),
    [sym_block_comment] = STATE(710),
    [sym_line_comment] = STATE(710),
    [sym_compiler_directive_decl] = STATE(710),
    [sym_fsi_directive_decl] = STATE(710),
    [sym_preproc_line] = STATE(710),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [711] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(73),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(711),
    [sym_block_comment] = STATE(711),
    [sym_line_comment] = STATE(711),
    [sym_compiler_directive_decl] = STATE(711),
    [sym_fsi_directive_decl] = STATE(711),
    [sym_preproc_line] = STATE(711),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [712] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(712),
    [sym_block_comment] = STATE(712),
    [sym_line_comment] = STATE(712),
    [sym_compiler_directive_decl] = STATE(712),
    [sym_fsi_directive_decl] = STATE(712),
    [sym_preproc_line] = STATE(712),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [713] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(381),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(713),
    [sym_block_comment] = STATE(713),
    [sym_line_comment] = STATE(713),
    [sym_compiler_directive_decl] = STATE(713),
    [sym_fsi_directive_decl] = STATE(713),
    [sym_preproc_line] = STATE(713),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [714] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(714),
    [sym_block_comment] = STATE(714),
    [sym_line_comment] = STATE(714),
    [sym_compiler_directive_decl] = STATE(714),
    [sym_fsi_directive_decl] = STATE(714),
    [sym_preproc_line] = STATE(714),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [715] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(234),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(715),
    [sym_block_comment] = STATE(715),
    [sym_line_comment] = STATE(715),
    [sym_compiler_directive_decl] = STATE(715),
    [sym_fsi_directive_decl] = STATE(715),
    [sym_preproc_line] = STATE(715),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [716] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(236),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(716),
    [sym_block_comment] = STATE(716),
    [sym_line_comment] = STATE(716),
    [sym_compiler_directive_decl] = STATE(716),
    [sym_fsi_directive_decl] = STATE(716),
    [sym_preproc_line] = STATE(716),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [717] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(216),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(717),
    [sym_block_comment] = STATE(717),
    [sym_line_comment] = STATE(717),
    [sym_compiler_directive_decl] = STATE(717),
    [sym_fsi_directive_decl] = STATE(717),
    [sym_preproc_line] = STATE(717),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [718] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(366),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(718),
    [sym_block_comment] = STATE(718),
    [sym_line_comment] = STATE(718),
    [sym_compiler_directive_decl] = STATE(718),
    [sym_fsi_directive_decl] = STATE(718),
    [sym_preproc_line] = STATE(718),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [719] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(241),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(719),
    [sym_block_comment] = STATE(719),
    [sym_line_comment] = STATE(719),
    [sym_compiler_directive_decl] = STATE(719),
    [sym_fsi_directive_decl] = STATE(719),
    [sym_preproc_line] = STATE(719),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [720] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(215),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(720),
    [sym_block_comment] = STATE(720),
    [sym_line_comment] = STATE(720),
    [sym_compiler_directive_decl] = STATE(720),
    [sym_fsi_directive_decl] = STATE(720),
    [sym_preproc_line] = STATE(720),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [721] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(364),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(721),
    [sym_block_comment] = STATE(721),
    [sym_line_comment] = STATE(721),
    [sym_compiler_directive_decl] = STATE(721),
    [sym_fsi_directive_decl] = STATE(721),
    [sym_preproc_line] = STATE(721),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [722] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(368),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(722),
    [sym_block_comment] = STATE(722),
    [sym_line_comment] = STATE(722),
    [sym_compiler_directive_decl] = STATE(722),
    [sym_fsi_directive_decl] = STATE(722),
    [sym_preproc_line] = STATE(722),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [723] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(181),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(723),
    [sym_block_comment] = STATE(723),
    [sym_line_comment] = STATE(723),
    [sym_compiler_directive_decl] = STATE(723),
    [sym_fsi_directive_decl] = STATE(723),
    [sym_preproc_line] = STATE(723),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [724] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(380),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(724),
    [sym_block_comment] = STATE(724),
    [sym_line_comment] = STATE(724),
    [sym_compiler_directive_decl] = STATE(724),
    [sym_fsi_directive_decl] = STATE(724),
    [sym_preproc_line] = STATE(724),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [725] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(291),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(725),
    [sym_block_comment] = STATE(725),
    [sym_line_comment] = STATE(725),
    [sym_compiler_directive_decl] = STATE(725),
    [sym_fsi_directive_decl] = STATE(725),
    [sym_preproc_line] = STATE(725),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [726] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(190),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(726),
    [sym_block_comment] = STATE(726),
    [sym_line_comment] = STATE(726),
    [sym_compiler_directive_decl] = STATE(726),
    [sym_fsi_directive_decl] = STATE(726),
    [sym_preproc_line] = STATE(726),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [727] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(727),
    [sym_block_comment] = STATE(727),
    [sym_line_comment] = STATE(727),
    [sym_compiler_directive_decl] = STATE(727),
    [sym_fsi_directive_decl] = STATE(727),
    [sym_preproc_line] = STATE(727),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [728] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(222),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(728),
    [sym_block_comment] = STATE(728),
    [sym_line_comment] = STATE(728),
    [sym_compiler_directive_decl] = STATE(728),
    [sym_fsi_directive_decl] = STATE(728),
    [sym_preproc_line] = STATE(728),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [729] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(32),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(729),
    [sym_block_comment] = STATE(729),
    [sym_line_comment] = STATE(729),
    [sym_compiler_directive_decl] = STATE(729),
    [sym_fsi_directive_decl] = STATE(729),
    [sym_preproc_line] = STATE(729),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [730] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(730),
    [sym_block_comment] = STATE(730),
    [sym_line_comment] = STATE(730),
    [sym_compiler_directive_decl] = STATE(730),
    [sym_fsi_directive_decl] = STATE(730),
    [sym_preproc_line] = STATE(730),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [731] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(249),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(731),
    [sym_block_comment] = STATE(731),
    [sym_line_comment] = STATE(731),
    [sym_compiler_directive_decl] = STATE(731),
    [sym_fsi_directive_decl] = STATE(731),
    [sym_preproc_line] = STATE(731),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [732] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(273),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(732),
    [sym_block_comment] = STATE(732),
    [sym_line_comment] = STATE(732),
    [sym_compiler_directive_decl] = STATE(732),
    [sym_fsi_directive_decl] = STATE(732),
    [sym_preproc_line] = STATE(732),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [733] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(235),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(733),
    [sym_block_comment] = STATE(733),
    [sym_line_comment] = STATE(733),
    [sym_compiler_directive_decl] = STATE(733),
    [sym_fsi_directive_decl] = STATE(733),
    [sym_preproc_line] = STATE(733),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [734] = {
    [sym_function_or_value_defn] = STATE(585),
    [sym__expression] = STATE(250),
    [sym_literal_expression] = STATE(2632),
    [sym_long_identifier_or_op] = STATE(2632),
    [sym_tuple_expression] = STATE(2632),
    [sym_brace_expression] = STATE(2632),
    [sym_anon_record_expression] = STATE(2632),
    [sym_prefixed_expression] = STATE(2632),
    [sym_typecast_expression] = STATE(2632),
    [sym_for_expression] = STATE(2632),
    [sym_while_expression] = STATE(2632),
    [sym__if_branch] = STATE(7495),
    [sym_if_expression] = STATE(2632),
    [sym_fun_expression] = STATE(2632),
    [sym_try_expression] = STATE(2632),
    [sym_match_expression] = STATE(2632),
    [sym_function_expression] = STATE(2632),
    [sym_object_instantiation_expression] = STATE(2632),
    [sym_mutate_expression] = STATE(2632),
    [sym_index_expression] = STATE(2632),
    [sym_dot_expression] = STATE(2632),
    [sym_typed_expression] = STATE(2632),
    [sym_declaration_expression] = STATE(2632),
    [sym_do_expression] = STATE(2632),
    [sym_list_expression] = STATE(2632),
    [sym_array_expression] = STATE(2632),
    [sym_begin_end_expression] = STATE(2632),
    [sym_paren_expression] = STATE(2632),
    [sym_application_expression] = STATE(2632),
    [sym_infix_expression] = STATE(2632),
    [sym_ce_expression] = STATE(2632),
    [sym_sequential_expression] = STATE(2632),
    [sym_char] = STATE(2557),
    [sym_format_string] = STATE(2565),
    [sym__string_literal] = STATE(2565),
    [sym_string] = STATE(2557),
    [sym_verbatim_string] = STATE(2557),
    [sym_bytearray] = STATE(2557),
    [sym_verbatim_bytearray] = STATE(2557),
    [sym_format_triple_quoted_string] = STATE(2570),
    [sym_triple_quoted_string] = STATE(2557),
    [sym_const] = STATE(2632),
    [sym_long_identifier] = STATE(2408),
    [sym_active_pattern] = STATE(2390),
    [sym__identifier_or_op] = STATE(2726),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(734),
    [sym_sbyte] = STATE(2557),
    [sym_byte] = STATE(2557),
    [sym_int16] = STATE(2557),
    [sym_uint16] = STATE(2557),
    [sym_int32] = STATE(2557),
    [sym_uint32] = STATE(2557),
    [sym_nativeint] = STATE(2557),
    [sym_unativeint] = STATE(2557),
    [sym_int64] = STATE(2557),
    [sym_uint64] = STATE(2557),
    [sym_ieee32] = STATE(2557),
    [sym_ieee64] = STATE(2557),
    [sym_bignum] = STATE(2557),
    [sym_decimal] = STATE(2557),
    [sym_float] = STATE(1797),
    [sym_xml_doc] = STATE(734),
    [sym_block_comment] = STATE(734),
    [sym_line_comment] = STATE(734),
    [sym_compiler_directive_decl] = STATE(734),
    [sym_fsi_directive_decl] = STATE(734),
    [sym_preproc_line] = STATE(734),
    [sym_preproc_if_in_expression] = STATE(2632),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_LT_AT] = ACTIONS(1558),
    [anon_sym_LT_AT_AT] = ACTIONS(2381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_return_BANG] = ACTIONS(1566),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_yield_BANG] = ACTIONS(1566),
    [anon_sym_lazy] = ACTIONS(1542),
    [anon_sym_assert] = ACTIONS(1542),
    [anon_sym_upcast] = ACTIONS(1542),
    [anon_sym_downcast] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1578),
    [anon_sym_match_BANG] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1582),
    [anon_sym_use] = ACTIONS(1586),
    [anon_sym_use_BANG] = ACTIONS(1588),
    [anon_sym_do_BANG] = ACTIONS(1590),
    [anon_sym_begin] = ACTIONS(1592),
    [aux_sym_char_token1] = ACTIONS(1596),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_AT_DQUOTE] = ACTIONS(1602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1606),
    [sym_bool] = ACTIONS(1608),
    [sym_unit] = ACTIONS(2383),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1610),
    [sym_op_identifier] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1614),
    [sym_xint] = ACTIONS(1616),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1618),
  },
  [735] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(68),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(735),
    [sym_block_comment] = STATE(735),
    [sym_line_comment] = STATE(735),
    [sym_compiler_directive_decl] = STATE(735),
    [sym_fsi_directive_decl] = STATE(735),
    [sym_preproc_line] = STATE(735),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [736] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(281),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(736),
    [sym_block_comment] = STATE(736),
    [sym_line_comment] = STATE(736),
    [sym_compiler_directive_decl] = STATE(736),
    [sym_fsi_directive_decl] = STATE(736),
    [sym_preproc_line] = STATE(736),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [737] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(92),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(737),
    [sym_block_comment] = STATE(737),
    [sym_line_comment] = STATE(737),
    [sym_compiler_directive_decl] = STATE(737),
    [sym_fsi_directive_decl] = STATE(737),
    [sym_preproc_line] = STATE(737),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [738] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(191),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(738),
    [sym_block_comment] = STATE(738),
    [sym_line_comment] = STATE(738),
    [sym_compiler_directive_decl] = STATE(738),
    [sym_fsi_directive_decl] = STATE(738),
    [sym_preproc_line] = STATE(738),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [739] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(177),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(739),
    [sym_block_comment] = STATE(739),
    [sym_line_comment] = STATE(739),
    [sym_compiler_directive_decl] = STATE(739),
    [sym_fsi_directive_decl] = STATE(739),
    [sym_preproc_line] = STATE(739),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [740] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(353),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(740),
    [sym_block_comment] = STATE(740),
    [sym_line_comment] = STATE(740),
    [sym_compiler_directive_decl] = STATE(740),
    [sym_fsi_directive_decl] = STATE(740),
    [sym_preproc_line] = STATE(740),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [741] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(70),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(741),
    [sym_block_comment] = STATE(741),
    [sym_line_comment] = STATE(741),
    [sym_compiler_directive_decl] = STATE(741),
    [sym_fsi_directive_decl] = STATE(741),
    [sym_preproc_line] = STATE(741),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [742] = {
    [sym_function_or_value_defn] = STATE(742),
    [sym__expression] = STATE(31),
    [sym_literal_expression] = STATE(1558),
    [sym_long_identifier_or_op] = STATE(1558),
    [sym_tuple_expression] = STATE(1558),
    [sym_brace_expression] = STATE(1558),
    [sym_anon_record_expression] = STATE(1558),
    [sym_prefixed_expression] = STATE(1558),
    [sym_typecast_expression] = STATE(1558),
    [sym_for_expression] = STATE(1558),
    [sym_while_expression] = STATE(1558),
    [sym__if_branch] = STATE(7441),
    [sym_if_expression] = STATE(1558),
    [sym_fun_expression] = STATE(1558),
    [sym_try_expression] = STATE(1558),
    [sym_match_expression] = STATE(1558),
    [sym_function_expression] = STATE(1558),
    [sym_object_instantiation_expression] = STATE(1558),
    [sym_mutate_expression] = STATE(1558),
    [sym_index_expression] = STATE(1558),
    [sym_dot_expression] = STATE(1558),
    [sym_typed_expression] = STATE(1558),
    [sym_declaration_expression] = STATE(1558),
    [sym_do_expression] = STATE(1558),
    [sym_list_expression] = STATE(1558),
    [sym_array_expression] = STATE(1558),
    [sym_begin_end_expression] = STATE(1558),
    [sym_paren_expression] = STATE(1558),
    [sym_application_expression] = STATE(1558),
    [sym_infix_expression] = STATE(1558),
    [sym_ce_expression] = STATE(1558),
    [sym_sequential_expression] = STATE(1558),
    [sym_char] = STATE(1661),
    [sym_format_string] = STATE(1637),
    [sym__string_literal] = STATE(1637),
    [sym_string] = STATE(1661),
    [sym_verbatim_string] = STATE(1661),
    [sym_bytearray] = STATE(1661),
    [sym_verbatim_bytearray] = STATE(1661),
    [sym_format_triple_quoted_string] = STATE(1626),
    [sym_triple_quoted_string] = STATE(1661),
    [sym_const] = STATE(1558),
    [sym_long_identifier] = STATE(1625),
    [sym_active_pattern] = STATE(1466),
    [sym__identifier_or_op] = STATE(1553),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(729),
    [sym_sbyte] = STATE(1661),
    [sym_byte] = STATE(1661),
    [sym_int16] = STATE(1661),
    [sym_uint16] = STATE(1661),
    [sym_int32] = STATE(1661),
    [sym_uint32] = STATE(1661),
    [sym_nativeint] = STATE(1661),
    [sym_unativeint] = STATE(1661),
    [sym_int64] = STATE(1661),
    [sym_uint64] = STATE(1661),
    [sym_ieee32] = STATE(1661),
    [sym_ieee64] = STATE(1661),
    [sym_bignum] = STATE(1661),
    [sym_decimal] = STATE(1661),
    [sym_float] = STATE(1260),
    [sym_xml_doc] = STATE(742),
    [sym_block_comment] = STATE(742),
    [sym_line_comment] = STATE(742),
    [sym_compiler_directive_decl] = STATE(742),
    [sym_fsi_directive_decl] = STATE(742),
    [sym_preproc_line] = STATE(742),
    [sym_preproc_if_in_expression] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(315),
    [anon_sym_LBRACK_PIPE] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_LT_AT] = ACTIONS(321),
    [anon_sym_LT_AT_AT] = ACTIONS(2049),
    [anon_sym_LBRACE_PIPE] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_return_BANG] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(305),
    [anon_sym_yield_BANG] = ACTIONS(331),
    [anon_sym_lazy] = ACTIONS(305),
    [anon_sym_assert] = ACTIONS(305),
    [anon_sym_upcast] = ACTIONS(305),
    [anon_sym_downcast] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(335),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(339),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_match] = ACTIONS(343),
    [anon_sym_match_BANG] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(347),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_use_BANG] = ACTIONS(357),
    [anon_sym_do_BANG] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [aux_sym_char_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_AT_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(375),
    [sym_bool] = ACTIONS(377),
    [sym_unit] = ACTIONS(2051),
    [anon_sym_LPAREN_PIPE] = ACTIONS(379),
    [sym_op_identifier] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(383),
    [sym_xint] = ACTIONS(385),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(387),
  },
  [743] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(153),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(743),
    [sym_block_comment] = STATE(743),
    [sym_line_comment] = STATE(743),
    [sym_compiler_directive_decl] = STATE(743),
    [sym_fsi_directive_decl] = STATE(743),
    [sym_preproc_line] = STATE(743),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [744] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(121),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(744),
    [sym_block_comment] = STATE(744),
    [sym_line_comment] = STATE(744),
    [sym_compiler_directive_decl] = STATE(744),
    [sym_fsi_directive_decl] = STATE(744),
    [sym_preproc_line] = STATE(744),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [745] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(745),
    [sym_block_comment] = STATE(745),
    [sym_line_comment] = STATE(745),
    [sym_compiler_directive_decl] = STATE(745),
    [sym_fsi_directive_decl] = STATE(745),
    [sym_preproc_line] = STATE(745),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [746] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(318),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(746),
    [sym_block_comment] = STATE(746),
    [sym_line_comment] = STATE(746),
    [sym_compiler_directive_decl] = STATE(746),
    [sym_fsi_directive_decl] = STATE(746),
    [sym_preproc_line] = STATE(746),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [747] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(374),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(747),
    [sym_block_comment] = STATE(747),
    [sym_line_comment] = STATE(747),
    [sym_compiler_directive_decl] = STATE(747),
    [sym_fsi_directive_decl] = STATE(747),
    [sym_preproc_line] = STATE(747),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [748] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(283),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(748),
    [sym_block_comment] = STATE(748),
    [sym_line_comment] = STATE(748),
    [sym_compiler_directive_decl] = STATE(748),
    [sym_fsi_directive_decl] = STATE(748),
    [sym_preproc_line] = STATE(748),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [749] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(15),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(749),
    [sym_block_comment] = STATE(749),
    [sym_line_comment] = STATE(749),
    [sym_compiler_directive_decl] = STATE(749),
    [sym_fsi_directive_decl] = STATE(749),
    [sym_preproc_line] = STATE(749),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [750] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(317),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(750),
    [sym_block_comment] = STATE(750),
    [sym_line_comment] = STATE(750),
    [sym_compiler_directive_decl] = STATE(750),
    [sym_fsi_directive_decl] = STATE(750),
    [sym_preproc_line] = STATE(750),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [751] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(301),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(751),
    [sym_block_comment] = STATE(751),
    [sym_line_comment] = STATE(751),
    [sym_compiler_directive_decl] = STATE(751),
    [sym_fsi_directive_decl] = STATE(751),
    [sym_preproc_line] = STATE(751),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [752] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(195),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(752),
    [sym_block_comment] = STATE(752),
    [sym_line_comment] = STATE(752),
    [sym_compiler_directive_decl] = STATE(752),
    [sym_fsi_directive_decl] = STATE(752),
    [sym_preproc_line] = STATE(752),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [753] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(8),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(753),
    [sym_block_comment] = STATE(753),
    [sym_line_comment] = STATE(753),
    [sym_compiler_directive_decl] = STATE(753),
    [sym_fsi_directive_decl] = STATE(753),
    [sym_preproc_line] = STATE(753),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [754] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(351),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(754),
    [sym_block_comment] = STATE(754),
    [sym_line_comment] = STATE(754),
    [sym_compiler_directive_decl] = STATE(754),
    [sym_fsi_directive_decl] = STATE(754),
    [sym_preproc_line] = STATE(754),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [755] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(97),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(755),
    [sym_block_comment] = STATE(755),
    [sym_line_comment] = STATE(755),
    [sym_compiler_directive_decl] = STATE(755),
    [sym_fsi_directive_decl] = STATE(755),
    [sym_preproc_line] = STATE(755),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [756] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(93),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(756),
    [sym_block_comment] = STATE(756),
    [sym_line_comment] = STATE(756),
    [sym_compiler_directive_decl] = STATE(756),
    [sym_fsi_directive_decl] = STATE(756),
    [sym_preproc_line] = STATE(756),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [757] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(361),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(757),
    [sym_block_comment] = STATE(757),
    [sym_line_comment] = STATE(757),
    [sym_compiler_directive_decl] = STATE(757),
    [sym_fsi_directive_decl] = STATE(757),
    [sym_preproc_line] = STATE(757),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [758] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(355),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(758),
    [sym_block_comment] = STATE(758),
    [sym_line_comment] = STATE(758),
    [sym_compiler_directive_decl] = STATE(758),
    [sym_fsi_directive_decl] = STATE(758),
    [sym_preproc_line] = STATE(758),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [759] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(245),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(759),
    [sym_block_comment] = STATE(759),
    [sym_line_comment] = STATE(759),
    [sym_compiler_directive_decl] = STATE(759),
    [sym_fsi_directive_decl] = STATE(759),
    [sym_preproc_line] = STATE(759),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [760] = {
    [sym_function_or_value_defn] = STATE(660),
    [sym__expression] = STATE(128),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(760),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(760),
    [sym_block_comment] = STATE(760),
    [sym_line_comment] = STATE(760),
    [sym_compiler_directive_decl] = STATE(760),
    [sym_fsi_directive_decl] = STATE(760),
    [sym_preproc_line] = STATE(760),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_return_BANG] = ACTIONS(624),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_yield_BANG] = ACTIONS(624),
    [anon_sym_lazy] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(598),
    [anon_sym_upcast] = ACTIONS(598),
    [anon_sym_downcast] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(648),
    [anon_sym_use_BANG] = ACTIONS(650),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(678),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [761] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(363),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(761),
    [sym_block_comment] = STATE(761),
    [sym_line_comment] = STATE(761),
    [sym_compiler_directive_decl] = STATE(761),
    [sym_fsi_directive_decl] = STATE(761),
    [sym_preproc_line] = STATE(761),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [762] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(292),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(762),
    [sym_block_comment] = STATE(762),
    [sym_line_comment] = STATE(762),
    [sym_compiler_directive_decl] = STATE(762),
    [sym_fsi_directive_decl] = STATE(762),
    [sym_preproc_line] = STATE(762),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [763] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(356),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(763),
    [sym_block_comment] = STATE(763),
    [sym_line_comment] = STATE(763),
    [sym_compiler_directive_decl] = STATE(763),
    [sym_fsi_directive_decl] = STATE(763),
    [sym_preproc_line] = STATE(763),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [764] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(246),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(764),
    [sym_block_comment] = STATE(764),
    [sym_line_comment] = STATE(764),
    [sym_compiler_directive_decl] = STATE(764),
    [sym_fsi_directive_decl] = STATE(764),
    [sym_preproc_line] = STATE(764),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [765] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(247),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(765),
    [sym_block_comment] = STATE(765),
    [sym_line_comment] = STATE(765),
    [sym_compiler_directive_decl] = STATE(765),
    [sym_fsi_directive_decl] = STATE(765),
    [sym_preproc_line] = STATE(765),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [766] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(271),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(766),
    [sym_block_comment] = STATE(766),
    [sym_line_comment] = STATE(766),
    [sym_compiler_directive_decl] = STATE(766),
    [sym_fsi_directive_decl] = STATE(766),
    [sym_preproc_line] = STATE(766),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [767] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(357),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(767),
    [sym_block_comment] = STATE(767),
    [sym_line_comment] = STATE(767),
    [sym_compiler_directive_decl] = STATE(767),
    [sym_fsi_directive_decl] = STATE(767),
    [sym_preproc_line] = STATE(767),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [768] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(158),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(768),
    [sym_block_comment] = STATE(768),
    [sym_line_comment] = STATE(768),
    [sym_compiler_directive_decl] = STATE(768),
    [sym_fsi_directive_decl] = STATE(768),
    [sym_preproc_line] = STATE(768),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [769] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(369),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(769),
    [sym_block_comment] = STATE(769),
    [sym_line_comment] = STATE(769),
    [sym_compiler_directive_decl] = STATE(769),
    [sym_fsi_directive_decl] = STATE(769),
    [sym_preproc_line] = STATE(769),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [770] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(62),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(770),
    [sym_block_comment] = STATE(770),
    [sym_line_comment] = STATE(770),
    [sym_compiler_directive_decl] = STATE(770),
    [sym_fsi_directive_decl] = STATE(770),
    [sym_preproc_line] = STATE(770),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [771] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(302),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(771),
    [sym_block_comment] = STATE(771),
    [sym_line_comment] = STATE(771),
    [sym_compiler_directive_decl] = STATE(771),
    [sym_fsi_directive_decl] = STATE(771),
    [sym_preproc_line] = STATE(771),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [772] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(264),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(772),
    [sym_block_comment] = STATE(772),
    [sym_line_comment] = STATE(772),
    [sym_compiler_directive_decl] = STATE(772),
    [sym_fsi_directive_decl] = STATE(772),
    [sym_preproc_line] = STATE(772),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [773] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(348),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(773),
    [sym_block_comment] = STATE(773),
    [sym_line_comment] = STATE(773),
    [sym_compiler_directive_decl] = STATE(773),
    [sym_fsi_directive_decl] = STATE(773),
    [sym_preproc_line] = STATE(773),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [774] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(774),
    [sym_block_comment] = STATE(774),
    [sym_line_comment] = STATE(774),
    [sym_compiler_directive_decl] = STATE(774),
    [sym_fsi_directive_decl] = STATE(774),
    [sym_preproc_line] = STATE(774),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [775] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(61),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym_line_comment] = STATE(775),
    [sym_compiler_directive_decl] = STATE(775),
    [sym_fsi_directive_decl] = STATE(775),
    [sym_preproc_line] = STATE(775),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [776] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(60),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym_line_comment] = STATE(776),
    [sym_compiler_directive_decl] = STATE(776),
    [sym_fsi_directive_decl] = STATE(776),
    [sym_preproc_line] = STATE(776),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [777] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym_line_comment] = STATE(777),
    [sym_compiler_directive_decl] = STATE(777),
    [sym_fsi_directive_decl] = STATE(777),
    [sym_preproc_line] = STATE(777),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [778] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(107),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(778),
    [sym_block_comment] = STATE(778),
    [sym_line_comment] = STATE(778),
    [sym_compiler_directive_decl] = STATE(778),
    [sym_fsi_directive_decl] = STATE(778),
    [sym_preproc_line] = STATE(778),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [779] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(322),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(779),
    [sym_block_comment] = STATE(779),
    [sym_line_comment] = STATE(779),
    [sym_compiler_directive_decl] = STATE(779),
    [sym_fsi_directive_decl] = STATE(779),
    [sym_preproc_line] = STATE(779),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [780] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym_line_comment] = STATE(780),
    [sym_compiler_directive_decl] = STATE(780),
    [sym_fsi_directive_decl] = STATE(780),
    [sym_preproc_line] = STATE(780),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [781] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym_line_comment] = STATE(781),
    [sym_compiler_directive_decl] = STATE(781),
    [sym_fsi_directive_decl] = STATE(781),
    [sym_preproc_line] = STATE(781),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [782] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(334),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(782),
    [sym_block_comment] = STATE(782),
    [sym_line_comment] = STATE(782),
    [sym_compiler_directive_decl] = STATE(782),
    [sym_fsi_directive_decl] = STATE(782),
    [sym_preproc_line] = STATE(782),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [783] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(332),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(783),
    [sym_block_comment] = STATE(783),
    [sym_line_comment] = STATE(783),
    [sym_compiler_directive_decl] = STATE(783),
    [sym_fsi_directive_decl] = STATE(783),
    [sym_preproc_line] = STATE(783),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [784] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(238),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(784),
    [sym_block_comment] = STATE(784),
    [sym_line_comment] = STATE(784),
    [sym_compiler_directive_decl] = STATE(784),
    [sym_fsi_directive_decl] = STATE(784),
    [sym_preproc_line] = STATE(784),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [785] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(308),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(785),
    [sym_block_comment] = STATE(785),
    [sym_line_comment] = STATE(785),
    [sym_compiler_directive_decl] = STATE(785),
    [sym_fsi_directive_decl] = STATE(785),
    [sym_preproc_line] = STATE(785),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [786] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(5),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(786),
    [sym_block_comment] = STATE(786),
    [sym_line_comment] = STATE(786),
    [sym_compiler_directive_decl] = STATE(786),
    [sym_fsi_directive_decl] = STATE(786),
    [sym_preproc_line] = STATE(786),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [787] = {
    [sym_function_or_value_defn] = STATE(787),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(744),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(787),
    [sym_block_comment] = STATE(787),
    [sym_line_comment] = STATE(787),
    [sym_compiler_directive_decl] = STATE(787),
    [sym_fsi_directive_decl] = STATE(787),
    [sym_preproc_line] = STATE(787),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_return_BANG] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_yield_BANG] = ACTIONS(760),
    [anon_sym_lazy] = ACTIONS(734),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_upcast] = ACTIONS(734),
    [anon_sym_downcast] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_use_BANG] = ACTIONS(786),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(812),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [788] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(36),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(788),
    [sym_block_comment] = STATE(788),
    [sym_line_comment] = STATE(788),
    [sym_compiler_directive_decl] = STATE(788),
    [sym_fsi_directive_decl] = STATE(788),
    [sym_preproc_line] = STATE(788),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [789] = {
    [sym_function_or_value_defn] = STATE(789),
    [sym__expression] = STATE(72),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(599),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(789),
    [sym_block_comment] = STATE(789),
    [sym_line_comment] = STATE(789),
    [sym_compiler_directive_decl] = STATE(789),
    [sym_fsi_directive_decl] = STATE(789),
    [sym_preproc_line] = STATE(789),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_return_BANG] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_yield_BANG] = ACTIONS(714),
    [anon_sym_lazy] = ACTIONS(706),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_upcast] = ACTIONS(706),
    [anon_sym_downcast] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_use_BANG] = ACTIONS(722),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(726),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [790] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(26),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym_line_comment] = STATE(790),
    [sym_compiler_directive_decl] = STATE(790),
    [sym_fsi_directive_decl] = STATE(790),
    [sym_preproc_line] = STATE(790),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [791] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(310),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym_line_comment] = STATE(791),
    [sym_compiler_directive_decl] = STATE(791),
    [sym_fsi_directive_decl] = STATE(791),
    [sym_preproc_line] = STATE(791),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [792] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(134),
    [sym_literal_expression] = STATE(2215),
    [sym_long_identifier_or_op] = STATE(2215),
    [sym_tuple_expression] = STATE(2215),
    [sym_brace_expression] = STATE(2215),
    [sym_anon_record_expression] = STATE(2215),
    [sym_prefixed_expression] = STATE(2215),
    [sym_typecast_expression] = STATE(2215),
    [sym_for_expression] = STATE(2215),
    [sym_while_expression] = STATE(2215),
    [sym__if_branch] = STATE(7387),
    [sym_if_expression] = STATE(2215),
    [sym_fun_expression] = STATE(2215),
    [sym_try_expression] = STATE(2215),
    [sym_match_expression] = STATE(2215),
    [sym_function_expression] = STATE(2215),
    [sym_object_instantiation_expression] = STATE(2215),
    [sym_mutate_expression] = STATE(2215),
    [sym_index_expression] = STATE(2215),
    [sym_dot_expression] = STATE(2215),
    [sym_typed_expression] = STATE(2215),
    [sym_declaration_expression] = STATE(2215),
    [sym_do_expression] = STATE(2215),
    [sym_list_expression] = STATE(2215),
    [sym_array_expression] = STATE(2215),
    [sym_begin_end_expression] = STATE(2215),
    [sym_paren_expression] = STATE(2215),
    [sym_application_expression] = STATE(2215),
    [sym_infix_expression] = STATE(2215),
    [sym_ce_expression] = STATE(2215),
    [sym_sequential_expression] = STATE(2215),
    [sym_char] = STATE(2306),
    [sym_format_string] = STATE(2320),
    [sym__string_literal] = STATE(2320),
    [sym_string] = STATE(2306),
    [sym_verbatim_string] = STATE(2306),
    [sym_bytearray] = STATE(2306),
    [sym_verbatim_bytearray] = STATE(2306),
    [sym_format_triple_quoted_string] = STATE(2333),
    [sym_triple_quoted_string] = STATE(2306),
    [sym_const] = STATE(2215),
    [sym_long_identifier] = STATE(2160),
    [sym_active_pattern] = STATE(2277),
    [sym__identifier_or_op] = STATE(2161),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(700),
    [sym_sbyte] = STATE(2306),
    [sym_byte] = STATE(2306),
    [sym_int16] = STATE(2306),
    [sym_uint16] = STATE(2306),
    [sym_int32] = STATE(2306),
    [sym_uint32] = STATE(2306),
    [sym_nativeint] = STATE(2306),
    [sym_unativeint] = STATE(2306),
    [sym_int64] = STATE(2306),
    [sym_uint64] = STATE(2306),
    [sym_ieee32] = STATE(2306),
    [sym_ieee64] = STATE(2306),
    [sym_bignum] = STATE(2306),
    [sym_decimal] = STATE(2306),
    [sym_float] = STATE(1705),
    [sym_xml_doc] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym_line_comment] = STATE(792),
    [sym_compiler_directive_decl] = STATE(792),
    [sym_fsi_directive_decl] = STATE(792),
    [sym_preproc_line] = STATE(792),
    [sym_preproc_if_in_expression] = STATE(2215),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(409),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_null] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_LT_AT] = ACTIONS(425),
    [anon_sym_LT_AT_AT] = ACTIONS(1836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_return_BANG] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(409),
    [anon_sym_yield_BANG] = ACTIONS(435),
    [anon_sym_lazy] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(409),
    [anon_sym_upcast] = ACTIONS(409),
    [anon_sym_downcast] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(447),
    [anon_sym_match_BANG] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_use] = ACTIONS(459),
    [anon_sym_use_BANG] = ACTIONS(461),
    [anon_sym_do_BANG] = ACTIONS(463),
    [anon_sym_begin] = ACTIONS(465),
    [aux_sym_char_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_AT_DQUOTE] = ACTIONS(475),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(477),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(479),
    [sym_bool] = ACTIONS(481),
    [sym_unit] = ACTIONS(1838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(483),
    [sym_op_identifier] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(487),
    [sym_xint] = ACTIONS(489),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(491),
  },
  [793] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym_line_comment] = STATE(793),
    [sym_compiler_directive_decl] = STATE(793),
    [sym_fsi_directive_decl] = STATE(793),
    [sym_preproc_line] = STATE(793),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [794] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(200),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(794),
    [sym_block_comment] = STATE(794),
    [sym_line_comment] = STATE(794),
    [sym_compiler_directive_decl] = STATE(794),
    [sym_fsi_directive_decl] = STATE(794),
    [sym_preproc_line] = STATE(794),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [795] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(367),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym_line_comment] = STATE(795),
    [sym_compiler_directive_decl] = STATE(795),
    [sym_fsi_directive_decl] = STATE(795),
    [sym_preproc_line] = STATE(795),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [796] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(213),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(796),
    [sym_block_comment] = STATE(796),
    [sym_line_comment] = STATE(796),
    [sym_compiler_directive_decl] = STATE(796),
    [sym_fsi_directive_decl] = STATE(796),
    [sym_preproc_line] = STATE(796),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [797] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(110),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym_line_comment] = STATE(797),
    [sym_compiler_directive_decl] = STATE(797),
    [sym_fsi_directive_decl] = STATE(797),
    [sym_preproc_line] = STATE(797),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [798] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(111),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym_line_comment] = STATE(798),
    [sym_compiler_directive_decl] = STATE(798),
    [sym_fsi_directive_decl] = STATE(798),
    [sym_preproc_line] = STATE(798),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [799] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(170),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(799),
    [sym_block_comment] = STATE(799),
    [sym_line_comment] = STATE(799),
    [sym_compiler_directive_decl] = STATE(799),
    [sym_fsi_directive_decl] = STATE(799),
    [sym_preproc_line] = STATE(799),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [800] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(800),
    [sym_block_comment] = STATE(800),
    [sym_line_comment] = STATE(800),
    [sym_compiler_directive_decl] = STATE(800),
    [sym_fsi_directive_decl] = STATE(800),
    [sym_preproc_line] = STATE(800),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [801] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(179),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym_line_comment] = STATE(801),
    [sym_compiler_directive_decl] = STATE(801),
    [sym_fsi_directive_decl] = STATE(801),
    [sym_preproc_line] = STATE(801),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [802] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym_line_comment] = STATE(802),
    [sym_compiler_directive_decl] = STATE(802),
    [sym_fsi_directive_decl] = STATE(802),
    [sym_preproc_line] = STATE(802),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [803] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(345),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym_line_comment] = STATE(803),
    [sym_compiler_directive_decl] = STATE(803),
    [sym_fsi_directive_decl] = STATE(803),
    [sym_preproc_line] = STATE(803),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [804] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(80),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym_line_comment] = STATE(804),
    [sym_compiler_directive_decl] = STATE(804),
    [sym_fsi_directive_decl] = STATE(804),
    [sym_preproc_line] = STATE(804),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [805] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(377),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym_line_comment] = STATE(805),
    [sym_compiler_directive_decl] = STATE(805),
    [sym_fsi_directive_decl] = STATE(805),
    [sym_preproc_line] = STATE(805),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [806] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym_line_comment] = STATE(806),
    [sym_compiler_directive_decl] = STATE(806),
    [sym_fsi_directive_decl] = STATE(806),
    [sym_preproc_line] = STATE(806),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [807] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(329),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym_line_comment] = STATE(807),
    [sym_compiler_directive_decl] = STATE(807),
    [sym_fsi_directive_decl] = STATE(807),
    [sym_preproc_line] = STATE(807),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [808] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(257),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym_line_comment] = STATE(808),
    [sym_compiler_directive_decl] = STATE(808),
    [sym_fsi_directive_decl] = STATE(808),
    [sym_preproc_line] = STATE(808),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [809] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(286),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym_line_comment] = STATE(809),
    [sym_compiler_directive_decl] = STATE(809),
    [sym_fsi_directive_decl] = STATE(809),
    [sym_preproc_line] = STATE(809),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [810] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(279),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym_line_comment] = STATE(810),
    [sym_compiler_directive_decl] = STATE(810),
    [sym_fsi_directive_decl] = STATE(810),
    [sym_preproc_line] = STATE(810),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [811] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(343),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym_line_comment] = STATE(811),
    [sym_compiler_directive_decl] = STATE(811),
    [sym_fsi_directive_decl] = STATE(811),
    [sym_preproc_line] = STATE(811),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [812] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym_line_comment] = STATE(812),
    [sym_compiler_directive_decl] = STATE(812),
    [sym_fsi_directive_decl] = STATE(812),
    [sym_preproc_line] = STATE(812),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [813] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(75),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym_line_comment] = STATE(813),
    [sym_compiler_directive_decl] = STATE(813),
    [sym_fsi_directive_decl] = STATE(813),
    [sym_preproc_line] = STATE(813),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [814] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(124),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym_line_comment] = STATE(814),
    [sym_compiler_directive_decl] = STATE(814),
    [sym_fsi_directive_decl] = STATE(814),
    [sym_preproc_line] = STATE(814),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [815] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(815),
    [sym_block_comment] = STATE(815),
    [sym_line_comment] = STATE(815),
    [sym_compiler_directive_decl] = STATE(815),
    [sym_fsi_directive_decl] = STATE(815),
    [sym_preproc_line] = STATE(815),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [816] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(125),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym_line_comment] = STATE(816),
    [sym_compiler_directive_decl] = STATE(816),
    [sym_fsi_directive_decl] = STATE(816),
    [sym_preproc_line] = STATE(816),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [817] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(330),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(817),
    [sym_block_comment] = STATE(817),
    [sym_line_comment] = STATE(817),
    [sym_compiler_directive_decl] = STATE(817),
    [sym_fsi_directive_decl] = STATE(817),
    [sym_preproc_line] = STATE(817),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [818] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(185),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym_line_comment] = STATE(818),
    [sym_compiler_directive_decl] = STATE(818),
    [sym_fsi_directive_decl] = STATE(818),
    [sym_preproc_line] = STATE(818),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [819] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(196),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym_line_comment] = STATE(819),
    [sym_compiler_directive_decl] = STATE(819),
    [sym_fsi_directive_decl] = STATE(819),
    [sym_preproc_line] = STATE(819),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [820] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(306),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(820),
    [sym_block_comment] = STATE(820),
    [sym_line_comment] = STATE(820),
    [sym_compiler_directive_decl] = STATE(820),
    [sym_fsi_directive_decl] = STATE(820),
    [sym_preproc_line] = STATE(820),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [821] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(299),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym_line_comment] = STATE(821),
    [sym_compiler_directive_decl] = STATE(821),
    [sym_fsi_directive_decl] = STATE(821),
    [sym_preproc_line] = STATE(821),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [822] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(119),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(822),
    [sym_block_comment] = STATE(822),
    [sym_line_comment] = STATE(822),
    [sym_compiler_directive_decl] = STATE(822),
    [sym_fsi_directive_decl] = STATE(822),
    [sym_preproc_line] = STATE(822),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [823] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(83),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym_line_comment] = STATE(823),
    [sym_compiler_directive_decl] = STATE(823),
    [sym_fsi_directive_decl] = STATE(823),
    [sym_preproc_line] = STATE(823),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [824] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(342),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym_line_comment] = STATE(824),
    [sym_compiler_directive_decl] = STATE(824),
    [sym_fsi_directive_decl] = STATE(824),
    [sym_preproc_line] = STATE(824),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [825] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(278),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(825),
    [sym_block_comment] = STATE(825),
    [sym_line_comment] = STATE(825),
    [sym_compiler_directive_decl] = STATE(825),
    [sym_fsi_directive_decl] = STATE(825),
    [sym_preproc_line] = STATE(825),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [826] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(359),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(826),
    [sym_block_comment] = STATE(826),
    [sym_line_comment] = STATE(826),
    [sym_compiler_directive_decl] = STATE(826),
    [sym_fsi_directive_decl] = STATE(826),
    [sym_preproc_line] = STATE(826),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [827] = {
    [sym_function_or_value_defn] = STATE(745),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2032),
    [sym_long_identifier_or_op] = STATE(2032),
    [sym_tuple_expression] = STATE(2032),
    [sym_brace_expression] = STATE(2032),
    [sym_anon_record_expression] = STATE(2032),
    [sym_prefixed_expression] = STATE(2032),
    [sym_typecast_expression] = STATE(2032),
    [sym_for_expression] = STATE(2032),
    [sym_while_expression] = STATE(2032),
    [sym__if_branch] = STATE(7535),
    [sym_if_expression] = STATE(2032),
    [sym_fun_expression] = STATE(2032),
    [sym_try_expression] = STATE(2032),
    [sym_match_expression] = STATE(2032),
    [sym_function_expression] = STATE(2032),
    [sym_object_instantiation_expression] = STATE(2032),
    [sym_mutate_expression] = STATE(2032),
    [sym_index_expression] = STATE(2032),
    [sym_dot_expression] = STATE(2032),
    [sym_typed_expression] = STATE(2032),
    [sym_declaration_expression] = STATE(2032),
    [sym_do_expression] = STATE(2032),
    [sym_list_expression] = STATE(2032),
    [sym_array_expression] = STATE(2032),
    [sym_begin_end_expression] = STATE(2032),
    [sym_paren_expression] = STATE(2032),
    [sym_application_expression] = STATE(2032),
    [sym_infix_expression] = STATE(2032),
    [sym_ce_expression] = STATE(2032),
    [sym_sequential_expression] = STATE(2032),
    [sym_char] = STATE(2038),
    [sym_format_string] = STATE(2040),
    [sym__string_literal] = STATE(2040),
    [sym_string] = STATE(2038),
    [sym_verbatim_string] = STATE(2038),
    [sym_bytearray] = STATE(2038),
    [sym_verbatim_bytearray] = STATE(2038),
    [sym_format_triple_quoted_string] = STATE(2042),
    [sym_triple_quoted_string] = STATE(2038),
    [sym_const] = STATE(2032),
    [sym_long_identifier] = STATE(2163),
    [sym_active_pattern] = STATE(2209),
    [sym__identifier_or_op] = STATE(2301),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(822),
    [sym_sbyte] = STATE(2038),
    [sym_byte] = STATE(2038),
    [sym_int16] = STATE(2038),
    [sym_uint16] = STATE(2038),
    [sym_int32] = STATE(2038),
    [sym_uint32] = STATE(2038),
    [sym_nativeint] = STATE(2038),
    [sym_unativeint] = STATE(2038),
    [sym_int64] = STATE(2038),
    [sym_uint64] = STATE(2038),
    [sym_ieee32] = STATE(2038),
    [sym_ieee64] = STATE(2038),
    [sym_bignum] = STATE(2038),
    [sym_decimal] = STATE(2038),
    [sym_float] = STATE(1739),
    [sym_xml_doc] = STATE(827),
    [sym_block_comment] = STATE(827),
    [sym_line_comment] = STATE(827),
    [sym_compiler_directive_decl] = STATE(827),
    [sym_fsi_directive_decl] = STATE(827),
    [sym_preproc_line] = STATE(827),
    [sym_preproc_if_in_expression] = STATE(2032),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_LT_AT] = ACTIONS(912),
    [anon_sym_LT_AT_AT] = ACTIONS(2331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_return_BANG] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_yield_BANG] = ACTIONS(920),
    [anon_sym_lazy] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_upcast] = ACTIONS(896),
    [anon_sym_downcast] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_match_BANG] = ACTIONS(934),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_use] = ACTIONS(940),
    [anon_sym_use_BANG] = ACTIONS(942),
    [anon_sym_do_BANG] = ACTIONS(944),
    [anon_sym_begin] = ACTIONS(946),
    [aux_sym_char_token1] = ACTIONS(950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_AT_DQUOTE] = ACTIONS(956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(960),
    [sym_bool] = ACTIONS(962),
    [sym_unit] = ACTIONS(2333),
    [anon_sym_LPAREN_PIPE] = ACTIONS(964),
    [sym_op_identifier] = ACTIONS(2335),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(968),
    [sym_xint] = ACTIONS(970),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(972),
  },
  [828] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(165),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(828),
    [sym_block_comment] = STATE(828),
    [sym_line_comment] = STATE(828),
    [sym_compiler_directive_decl] = STATE(828),
    [sym_fsi_directive_decl] = STATE(828),
    [sym_preproc_line] = STATE(828),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [829] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(337),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(829),
    [sym_block_comment] = STATE(829),
    [sym_line_comment] = STATE(829),
    [sym_compiler_directive_decl] = STATE(829),
    [sym_fsi_directive_decl] = STATE(829),
    [sym_preproc_line] = STATE(829),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [830] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(336),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(830),
    [sym_block_comment] = STATE(830),
    [sym_line_comment] = STATE(830),
    [sym_compiler_directive_decl] = STATE(830),
    [sym_fsi_directive_decl] = STATE(830),
    [sym_preproc_line] = STATE(830),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [831] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(147),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(831),
    [sym_block_comment] = STATE(831),
    [sym_line_comment] = STATE(831),
    [sym_compiler_directive_decl] = STATE(831),
    [sym_fsi_directive_decl] = STATE(831),
    [sym_preproc_line] = STATE(831),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [832] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(305),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(832),
    [sym_block_comment] = STATE(832),
    [sym_line_comment] = STATE(832),
    [sym_compiler_directive_decl] = STATE(832),
    [sym_fsi_directive_decl] = STATE(832),
    [sym_preproc_line] = STATE(832),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [833] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(162),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(833),
    [sym_block_comment] = STATE(833),
    [sym_line_comment] = STATE(833),
    [sym_compiler_directive_decl] = STATE(833),
    [sym_fsi_directive_decl] = STATE(833),
    [sym_preproc_line] = STATE(833),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [834] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(331),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(834),
    [sym_block_comment] = STATE(834),
    [sym_line_comment] = STATE(834),
    [sym_compiler_directive_decl] = STATE(834),
    [sym_fsi_directive_decl] = STATE(834),
    [sym_preproc_line] = STATE(834),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [835] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(171),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(835),
    [sym_block_comment] = STATE(835),
    [sym_line_comment] = STATE(835),
    [sym_compiler_directive_decl] = STATE(835),
    [sym_fsi_directive_decl] = STATE(835),
    [sym_preproc_line] = STATE(835),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [836] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(174),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(836),
    [sym_block_comment] = STATE(836),
    [sym_line_comment] = STATE(836),
    [sym_compiler_directive_decl] = STATE(836),
    [sym_fsi_directive_decl] = STATE(836),
    [sym_preproc_line] = STATE(836),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [837] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(313),
    [sym_literal_expression] = STATE(2159),
    [sym_long_identifier_or_op] = STATE(2159),
    [sym_tuple_expression] = STATE(2159),
    [sym_brace_expression] = STATE(2159),
    [sym_anon_record_expression] = STATE(2159),
    [sym_prefixed_expression] = STATE(2159),
    [sym_typecast_expression] = STATE(2159),
    [sym_for_expression] = STATE(2159),
    [sym_while_expression] = STATE(2159),
    [sym__if_branch] = STATE(7573),
    [sym_if_expression] = STATE(2159),
    [sym_fun_expression] = STATE(2159),
    [sym_try_expression] = STATE(2159),
    [sym_match_expression] = STATE(2159),
    [sym_function_expression] = STATE(2159),
    [sym_object_instantiation_expression] = STATE(2159),
    [sym_mutate_expression] = STATE(2159),
    [sym_index_expression] = STATE(2159),
    [sym_dot_expression] = STATE(2159),
    [sym_typed_expression] = STATE(2159),
    [sym_declaration_expression] = STATE(2159),
    [sym_do_expression] = STATE(2159),
    [sym_list_expression] = STATE(2159),
    [sym_array_expression] = STATE(2159),
    [sym_begin_end_expression] = STATE(2159),
    [sym_paren_expression] = STATE(2159),
    [sym_application_expression] = STATE(2159),
    [sym_infix_expression] = STATE(2159),
    [sym_ce_expression] = STATE(2159),
    [sym_sequential_expression] = STATE(2159),
    [sym_char] = STATE(2179),
    [sym_format_string] = STATE(2181),
    [sym__string_literal] = STATE(2181),
    [sym_string] = STATE(2179),
    [sym_verbatim_string] = STATE(2179),
    [sym_bytearray] = STATE(2179),
    [sym_verbatim_bytearray] = STATE(2179),
    [sym_format_triple_quoted_string] = STATE(2183),
    [sym_triple_quoted_string] = STATE(2179),
    [sym_const] = STATE(2159),
    [sym_long_identifier] = STATE(2063),
    [sym_active_pattern] = STATE(2173),
    [sym__identifier_or_op] = STATE(2213),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(571),
    [sym_sbyte] = STATE(2179),
    [sym_byte] = STATE(2179),
    [sym_int16] = STATE(2179),
    [sym_uint16] = STATE(2179),
    [sym_int32] = STATE(2179),
    [sym_uint32] = STATE(2179),
    [sym_nativeint] = STATE(2179),
    [sym_unativeint] = STATE(2179),
    [sym_int64] = STATE(2179),
    [sym_uint64] = STATE(2179),
    [sym_ieee32] = STATE(2179),
    [sym_ieee64] = STATE(2179),
    [sym_bignum] = STATE(2179),
    [sym_decimal] = STATE(2179),
    [sym_float] = STATE(1726),
    [sym_xml_doc] = STATE(837),
    [sym_block_comment] = STATE(837),
    [sym_line_comment] = STATE(837),
    [sym_compiler_directive_decl] = STATE(837),
    [sym_fsi_directive_decl] = STATE(837),
    [sym_preproc_line] = STATE(837),
    [sym_preproc_if_in_expression] = STATE(2159),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_null] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(746),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LT_AT] = ACTIONS(750),
    [anon_sym_LT_AT_AT] = ACTIONS(2363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_return_BANG] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(994),
    [anon_sym_yield_BANG] = ACTIONS(1000),
    [anon_sym_lazy] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_upcast] = ACTIONS(994),
    [anon_sym_downcast] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_match_BANG] = ACTIONS(774),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_use_BANG] = ACTIONS(1012),
    [anon_sym_do_BANG] = ACTIONS(788),
    [anon_sym_begin] = ACTIONS(790),
    [aux_sym_char_token1] = ACTIONS(794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_AT_DQUOTE] = ACTIONS(800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(804),
    [sym_bool] = ACTIONS(806),
    [sym_unit] = ACTIONS(2373),
    [anon_sym_LPAREN_PIPE] = ACTIONS(808),
    [sym_op_identifier] = ACTIONS(2375),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1014),
    [sym_xint] = ACTIONS(814),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(816),
  },
  [838] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(169),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(838),
    [sym_block_comment] = STATE(838),
    [sym_line_comment] = STATE(838),
    [sym_compiler_directive_decl] = STATE(838),
    [sym_fsi_directive_decl] = STATE(838),
    [sym_preproc_line] = STATE(838),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [839] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(311),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(839),
    [sym_block_comment] = STATE(839),
    [sym_line_comment] = STATE(839),
    [sym_compiler_directive_decl] = STATE(839),
    [sym_fsi_directive_decl] = STATE(839),
    [sym_preproc_line] = STATE(839),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [840] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(840),
    [sym_block_comment] = STATE(840),
    [sym_line_comment] = STATE(840),
    [sym_compiler_directive_decl] = STATE(840),
    [sym_fsi_directive_decl] = STATE(840),
    [sym_preproc_line] = STATE(840),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [841] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(175),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(841),
    [sym_block_comment] = STATE(841),
    [sym_line_comment] = STATE(841),
    [sym_compiler_directive_decl] = STATE(841),
    [sym_fsi_directive_decl] = STATE(841),
    [sym_preproc_line] = STATE(841),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [842] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(173),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(842),
    [sym_block_comment] = STATE(842),
    [sym_line_comment] = STATE(842),
    [sym_compiler_directive_decl] = STATE(842),
    [sym_fsi_directive_decl] = STATE(842),
    [sym_preproc_line] = STATE(842),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [843] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(316),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(843),
    [sym_block_comment] = STATE(843),
    [sym_line_comment] = STATE(843),
    [sym_compiler_directive_decl] = STATE(843),
    [sym_fsi_directive_decl] = STATE(843),
    [sym_preproc_line] = STATE(843),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [844] = {
    [sym_function_or_value_defn] = STATE(754),
    [sym__expression] = STATE(350),
    [sym_literal_expression] = STATE(2379),
    [sym_long_identifier_or_op] = STATE(2379),
    [sym_tuple_expression] = STATE(2379),
    [sym_brace_expression] = STATE(2379),
    [sym_anon_record_expression] = STATE(2379),
    [sym_prefixed_expression] = STATE(2379),
    [sym_typecast_expression] = STATE(2379),
    [sym_for_expression] = STATE(2379),
    [sym_while_expression] = STATE(2379),
    [sym__if_branch] = STATE(7611),
    [sym_if_expression] = STATE(2379),
    [sym_fun_expression] = STATE(2379),
    [sym_try_expression] = STATE(2379),
    [sym_match_expression] = STATE(2379),
    [sym_function_expression] = STATE(2379),
    [sym_object_instantiation_expression] = STATE(2379),
    [sym_mutate_expression] = STATE(2379),
    [sym_index_expression] = STATE(2379),
    [sym_dot_expression] = STATE(2379),
    [sym_typed_expression] = STATE(2379),
    [sym_declaration_expression] = STATE(2379),
    [sym_do_expression] = STATE(2379),
    [sym_list_expression] = STATE(2379),
    [sym_array_expression] = STATE(2379),
    [sym_begin_end_expression] = STATE(2379),
    [sym_paren_expression] = STATE(2379),
    [sym_application_expression] = STATE(2379),
    [sym_infix_expression] = STATE(2379),
    [sym_ce_expression] = STATE(2379),
    [sym_sequential_expression] = STATE(2379),
    [sym_char] = STATE(2429),
    [sym_format_string] = STATE(2417),
    [sym__string_literal] = STATE(2417),
    [sym_string] = STATE(2429),
    [sym_verbatim_string] = STATE(2429),
    [sym_bytearray] = STATE(2429),
    [sym_verbatim_bytearray] = STATE(2429),
    [sym_format_triple_quoted_string] = STATE(2416),
    [sym_triple_quoted_string] = STATE(2429),
    [sym_const] = STATE(2379),
    [sym_long_identifier] = STATE(2367),
    [sym_active_pattern] = STATE(2717),
    [sym__identifier_or_op] = STATE(2582),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(844),
    [sym_sbyte] = STATE(2429),
    [sym_byte] = STATE(2429),
    [sym_int16] = STATE(2429),
    [sym_uint16] = STATE(2429),
    [sym_int32] = STATE(2429),
    [sym_uint32] = STATE(2429),
    [sym_nativeint] = STATE(2429),
    [sym_unativeint] = STATE(2429),
    [sym_int64] = STATE(2429),
    [sym_uint64] = STATE(2429),
    [sym_ieee32] = STATE(2429),
    [sym_ieee64] = STATE(2429),
    [sym_bignum] = STATE(2429),
    [sym_decimal] = STATE(2429),
    [sym_float] = STATE(1853),
    [sym_xml_doc] = STATE(844),
    [sym_block_comment] = STATE(844),
    [sym_line_comment] = STATE(844),
    [sym_compiler_directive_decl] = STATE(844),
    [sym_fsi_directive_decl] = STATE(844),
    [sym_preproc_line] = STATE(844),
    [sym_preproc_if_in_expression] = STATE(2379),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_LT_AT] = ACTIONS(1134),
    [anon_sym_LT_AT_AT] = ACTIONS(2261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_return_BANG] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1118),
    [anon_sym_yield_BANG] = ACTIONS(1144),
    [anon_sym_lazy] = ACTIONS(1118),
    [anon_sym_assert] = ACTIONS(1118),
    [anon_sym_upcast] = ACTIONS(1118),
    [anon_sym_downcast] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1154),
    [anon_sym_match] = ACTIONS(1156),
    [anon_sym_match_BANG] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_use] = ACTIONS(1168),
    [anon_sym_use_BANG] = ACTIONS(1170),
    [anon_sym_do_BANG] = ACTIONS(1172),
    [anon_sym_begin] = ACTIONS(1174),
    [aux_sym_char_token1] = ACTIONS(1178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_AT_DQUOTE] = ACTIONS(1184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [sym_bool] = ACTIONS(1190),
    [sym_unit] = ACTIONS(2263),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1192),
    [sym_op_identifier] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1196),
    [sym_xint] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1200),
  },
  [845] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(254),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(845),
    [sym_block_comment] = STATE(845),
    [sym_line_comment] = STATE(845),
    [sym_compiler_directive_decl] = STATE(845),
    [sym_fsi_directive_decl] = STATE(845),
    [sym_preproc_line] = STATE(845),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [846] = {
    [sym_function_or_value_defn] = STATE(678),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(1992),
    [sym_long_identifier_or_op] = STATE(1992),
    [sym_tuple_expression] = STATE(1992),
    [sym_brace_expression] = STATE(1992),
    [sym_anon_record_expression] = STATE(1992),
    [sym_prefixed_expression] = STATE(1992),
    [sym_typecast_expression] = STATE(1992),
    [sym_for_expression] = STATE(1992),
    [sym_while_expression] = STATE(1992),
    [sym__if_branch] = STATE(7271),
    [sym_if_expression] = STATE(1992),
    [sym_fun_expression] = STATE(1992),
    [sym_try_expression] = STATE(1992),
    [sym_match_expression] = STATE(1992),
    [sym_function_expression] = STATE(1992),
    [sym_object_instantiation_expression] = STATE(1992),
    [sym_mutate_expression] = STATE(1992),
    [sym_index_expression] = STATE(1992),
    [sym_dot_expression] = STATE(1992),
    [sym_typed_expression] = STATE(1992),
    [sym_declaration_expression] = STATE(1992),
    [sym_do_expression] = STATE(1992),
    [sym_list_expression] = STATE(1992),
    [sym_array_expression] = STATE(1992),
    [sym_begin_end_expression] = STATE(1992),
    [sym_paren_expression] = STATE(1992),
    [sym_application_expression] = STATE(1992),
    [sym_infix_expression] = STATE(1992),
    [sym_ce_expression] = STATE(1992),
    [sym_sequential_expression] = STATE(1992),
    [sym_char] = STATE(1850),
    [sym_format_string] = STATE(1848),
    [sym__string_literal] = STATE(1848),
    [sym_string] = STATE(1850),
    [sym_verbatim_string] = STATE(1850),
    [sym_bytearray] = STATE(1850),
    [sym_verbatim_bytearray] = STATE(1850),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1850),
    [sym_const] = STATE(1992),
    [sym_long_identifier] = STATE(1846),
    [sym_active_pattern] = STATE(1849),
    [sym__identifier_or_op] = STATE(1906),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(806),
    [sym_sbyte] = STATE(1850),
    [sym_byte] = STATE(1850),
    [sym_int16] = STATE(1850),
    [sym_uint16] = STATE(1850),
    [sym_int32] = STATE(1850),
    [sym_uint32] = STATE(1850),
    [sym_nativeint] = STATE(1850),
    [sym_unativeint] = STATE(1850),
    [sym_int64] = STATE(1850),
    [sym_uint64] = STATE(1850),
    [sym_ieee32] = STATE(1850),
    [sym_ieee64] = STATE(1850),
    [sym_bignum] = STATE(1850),
    [sym_decimal] = STATE(1850),
    [sym_float] = STATE(1497),
    [sym_xml_doc] = STATE(846),
    [sym_block_comment] = STATE(846),
    [sym_line_comment] = STATE(846),
    [sym_compiler_directive_decl] = STATE(846),
    [sym_fsi_directive_decl] = STATE(846),
    [sym_preproc_line] = STATE(846),
    [sym_preproc_if_in_expression] = STATE(1992),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_null] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_LT_AT] = ACTIONS(614),
    [anon_sym_LT_AT_AT] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(692),
    [anon_sym_return_BANG] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(688),
    [anon_sym_yield_BANG] = ACTIONS(694),
    [anon_sym_lazy] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(688),
    [anon_sym_upcast] = ACTIONS(688),
    [anon_sym_downcast] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_match_BANG] = ACTIONS(638),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(700),
    [anon_sym_use_BANG] = ACTIONS(702),
    [anon_sym_do_BANG] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(654),
    [aux_sym_char_token1] = ACTIONS(660),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_AT_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [sym_bool] = ACTIONS(672),
    [sym_unit] = ACTIONS(2281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(674),
    [sym_op_identifier] = ACTIONS(2283),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(704),
    [sym_xint] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(682),
  },
  [847] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(384),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(847),
    [sym_block_comment] = STATE(847),
    [sym_line_comment] = STATE(847),
    [sym_compiler_directive_decl] = STATE(847),
    [sym_fsi_directive_decl] = STATE(847),
    [sym_preproc_line] = STATE(847),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [848] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(848),
    [sym_block_comment] = STATE(848),
    [sym_line_comment] = STATE(848),
    [sym_compiler_directive_decl] = STATE(848),
    [sym_fsi_directive_decl] = STATE(848),
    [sym_preproc_line] = STATE(848),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [849] = {
    [sym_function_or_value_defn] = STATE(803),
    [sym__expression] = STATE(261),
    [sym_literal_expression] = STATE(2372),
    [sym_long_identifier_or_op] = STATE(2372),
    [sym_tuple_expression] = STATE(2372),
    [sym_brace_expression] = STATE(2372),
    [sym_anon_record_expression] = STATE(2372),
    [sym_prefixed_expression] = STATE(2372),
    [sym_typecast_expression] = STATE(2372),
    [sym_for_expression] = STATE(2372),
    [sym_while_expression] = STATE(2372),
    [sym__if_branch] = STATE(7237),
    [sym_if_expression] = STATE(2372),
    [sym_fun_expression] = STATE(2372),
    [sym_try_expression] = STATE(2372),
    [sym_match_expression] = STATE(2372),
    [sym_function_expression] = STATE(2372),
    [sym_object_instantiation_expression] = STATE(2372),
    [sym_mutate_expression] = STATE(2372),
    [sym_index_expression] = STATE(2372),
    [sym_dot_expression] = STATE(2372),
    [sym_typed_expression] = STATE(2372),
    [sym_declaration_expression] = STATE(2372),
    [sym_do_expression] = STATE(2372),
    [sym_list_expression] = STATE(2372),
    [sym_array_expression] = STATE(2372),
    [sym_begin_end_expression] = STATE(2372),
    [sym_paren_expression] = STATE(2372),
    [sym_application_expression] = STATE(2372),
    [sym_infix_expression] = STATE(2372),
    [sym_ce_expression] = STATE(2372),
    [sym_sequential_expression] = STATE(2372),
    [sym_char] = STATE(2456),
    [sym_format_string] = STATE(2459),
    [sym__string_literal] = STATE(2459),
    [sym_string] = STATE(2456),
    [sym_verbatim_string] = STATE(2456),
    [sym_bytearray] = STATE(2456),
    [sym_verbatim_bytearray] = STATE(2456),
    [sym_format_triple_quoted_string] = STATE(2460),
    [sym_triple_quoted_string] = STATE(2456),
    [sym_const] = STATE(2372),
    [sym_long_identifier] = STATE(2461),
    [sym_active_pattern] = STATE(2457),
    [sym__identifier_or_op] = STATE(2374),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(685),
    [sym_sbyte] = STATE(2456),
    [sym_byte] = STATE(2456),
    [sym_int16] = STATE(2456),
    [sym_uint16] = STATE(2456),
    [sym_int32] = STATE(2456),
    [sym_uint32] = STATE(2456),
    [sym_nativeint] = STATE(2456),
    [sym_unativeint] = STATE(2456),
    [sym_int64] = STATE(2456),
    [sym_uint64] = STATE(2456),
    [sym_ieee32] = STATE(2456),
    [sym_ieee64] = STATE(2456),
    [sym_bignum] = STATE(2456),
    [sym_decimal] = STATE(2456),
    [sym_float] = STATE(1830),
    [sym_xml_doc] = STATE(849),
    [sym_block_comment] = STATE(849),
    [sym_line_comment] = STATE(849),
    [sym_compiler_directive_decl] = STATE(849),
    [sym_fsi_directive_decl] = STATE(849),
    [sym_preproc_line] = STATE(849),
    [sym_preproc_if_in_expression] = STATE(2372),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_LT_AT] = ACTIONS(1326),
    [anon_sym_LT_AT_AT] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_return_BANG] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_yield_BANG] = ACTIONS(1336),
    [anon_sym_lazy] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_upcast] = ACTIONS(1310),
    [anon_sym_downcast] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1348),
    [anon_sym_match_BANG] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_use_BANG] = ACTIONS(1362),
    [anon_sym_do_BANG] = ACTIONS(1364),
    [anon_sym_begin] = ACTIONS(1366),
    [aux_sym_char_token1] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [anon_sym_AT_DQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1380),
    [sym_bool] = ACTIONS(1382),
    [sym_unit] = ACTIONS(2425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1384),
    [sym_op_identifier] = ACTIONS(2427),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1388),
    [sym_xint] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1392),
  },
  [850] = {
    [sym_function_or_value_defn] = STATE(794),
    [sym__expression] = STATE(269),
    [sym_literal_expression] = STATE(2766),
    [sym_long_identifier_or_op] = STATE(2766),
    [sym_tuple_expression] = STATE(2766),
    [sym_brace_expression] = STATE(2766),
    [sym_anon_record_expression] = STATE(2766),
    [sym_prefixed_expression] = STATE(2766),
    [sym_typecast_expression] = STATE(2766),
    [sym_for_expression] = STATE(2766),
    [sym_while_expression] = STATE(2766),
    [sym__if_branch] = STATE(7444),
    [sym_if_expression] = STATE(2766),
    [sym_fun_expression] = STATE(2766),
    [sym_try_expression] = STATE(2766),
    [sym_match_expression] = STATE(2766),
    [sym_function_expression] = STATE(2766),
    [sym_object_instantiation_expression] = STATE(2766),
    [sym_mutate_expression] = STATE(2766),
    [sym_index_expression] = STATE(2766),
    [sym_dot_expression] = STATE(2766),
    [sym_typed_expression] = STATE(2766),
    [sym_declaration_expression] = STATE(2766),
    [sym_do_expression] = STATE(2766),
    [sym_list_expression] = STATE(2766),
    [sym_array_expression] = STATE(2766),
    [sym_begin_end_expression] = STATE(2766),
    [sym_paren_expression] = STATE(2766),
    [sym_application_expression] = STATE(2766),
    [sym_infix_expression] = STATE(2766),
    [sym_ce_expression] = STATE(2766),
    [sym_sequential_expression] = STATE(2766),
    [sym_char] = STATE(2364),
    [sym_format_string] = STATE(2373),
    [sym__string_literal] = STATE(2373),
    [sym_string] = STATE(2364),
    [sym_verbatim_string] = STATE(2364),
    [sym_bytearray] = STATE(2364),
    [sym_verbatim_bytearray] = STATE(2364),
    [sym_format_triple_quoted_string] = STATE(2360),
    [sym_triple_quoted_string] = STATE(2364),
    [sym_const] = STATE(2766),
    [sym_long_identifier] = STATE(2353),
    [sym_active_pattern] = STATE(2363),
    [sym__identifier_or_op] = STATE(2484),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(796),
    [sym_sbyte] = STATE(2364),
    [sym_byte] = STATE(2364),
    [sym_int16] = STATE(2364),
    [sym_uint16] = STATE(2364),
    [sym_int32] = STATE(2364),
    [sym_uint32] = STATE(2364),
    [sym_nativeint] = STATE(2364),
    [sym_unativeint] = STATE(2364),
    [sym_int64] = STATE(2364),
    [sym_uint64] = STATE(2364),
    [sym_ieee32] = STATE(2364),
    [sym_ieee64] = STATE(2364),
    [sym_bignum] = STATE(2364),
    [sym_decimal] = STATE(2364),
    [sym_float] = STATE(1875),
    [sym_xml_doc] = STATE(850),
    [sym_block_comment] = STATE(850),
    [sym_line_comment] = STATE(850),
    [sym_compiler_directive_decl] = STATE(850),
    [sym_fsi_directive_decl] = STATE(850),
    [sym_preproc_line] = STATE(850),
    [sym_preproc_if_in_expression] = STATE(2766),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1212),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_LT_AT] = ACTIONS(1224),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_return_BANG] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_yield_BANG] = ACTIONS(1234),
    [anon_sym_lazy] = ACTIONS(1208),
    [anon_sym_assert] = ACTIONS(1208),
    [anon_sym_upcast] = ACTIONS(1208),
    [anon_sym_downcast] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_match_BANG] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_use_BANG] = ACTIONS(1260),
    [anon_sym_do_BANG] = ACTIONS(1262),
    [anon_sym_begin] = ACTIONS(1264),
    [aux_sym_char_token1] = ACTIONS(1268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1272),
    [anon_sym_AT_DQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1278),
    [sym_bool] = ACTIONS(1280),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1282),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1286),
    [sym_xint] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1290),
  },
  [851] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(24),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(851),
    [sym_block_comment] = STATE(851),
    [sym_line_comment] = STATE(851),
    [sym_compiler_directive_decl] = STATE(851),
    [sym_fsi_directive_decl] = STATE(851),
    [sym_preproc_line] = STATE(851),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [852] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(2),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(852),
    [sym_block_comment] = STATE(852),
    [sym_line_comment] = STATE(852),
    [sym_compiler_directive_decl] = STATE(852),
    [sym_fsi_directive_decl] = STATE(852),
    [sym_preproc_line] = STATE(852),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [853] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(69),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(853),
    [sym_block_comment] = STATE(853),
    [sym_line_comment] = STATE(853),
    [sym_compiler_directive_decl] = STATE(853),
    [sym_fsi_directive_decl] = STATE(853),
    [sym_preproc_line] = STATE(853),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [854] = {
    [sym_function_or_value_defn] = STATE(780),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(854),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(854),
    [sym_block_comment] = STATE(854),
    [sym_line_comment] = STATE(854),
    [sym_compiler_directive_decl] = STATE(854),
    [sym_fsi_directive_decl] = STATE(854),
    [sym_preproc_line] = STATE(854),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(263),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_upcast] = ACTIONS(263),
    [anon_sym_downcast] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(279),
    [anon_sym_use_BANG] = ACTIONS(281),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(287),
    [sym_xint] = ACTIONS(289),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [855] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(84),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(855),
    [sym_block_comment] = STATE(855),
    [sym_line_comment] = STATE(855),
    [sym_compiler_directive_decl] = STATE(855),
    [sym_fsi_directive_decl] = STATE(855),
    [sym_preproc_line] = STATE(855),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [856] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(856),
    [sym_block_comment] = STATE(856),
    [sym_line_comment] = STATE(856),
    [sym_compiler_directive_decl] = STATE(856),
    [sym_fsi_directive_decl] = STATE(856),
    [sym_preproc_line] = STATE(856),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [857] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(385),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(857),
    [sym_block_comment] = STATE(857),
    [sym_line_comment] = STATE(857),
    [sym_compiler_directive_decl] = STATE(857),
    [sym_fsi_directive_decl] = STATE(857),
    [sym_preproc_line] = STATE(857),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [858] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(150),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(858),
    [sym_block_comment] = STATE(858),
    [sym_line_comment] = STATE(858),
    [sym_compiler_directive_decl] = STATE(858),
    [sym_fsi_directive_decl] = STATE(858),
    [sym_preproc_line] = STATE(858),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [859] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(319),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(859),
    [sym_block_comment] = STATE(859),
    [sym_line_comment] = STATE(859),
    [sym_compiler_directive_decl] = STATE(859),
    [sym_fsi_directive_decl] = STATE(859),
    [sym_preproc_line] = STATE(859),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [860] = {
    [sym_function_or_value_defn] = STATE(858),
    [sym__expression] = STATE(210),
    [sym_literal_expression] = STATE(2388),
    [sym_long_identifier_or_op] = STATE(2388),
    [sym_tuple_expression] = STATE(2388),
    [sym_brace_expression] = STATE(2388),
    [sym_anon_record_expression] = STATE(2388),
    [sym_prefixed_expression] = STATE(2388),
    [sym_typecast_expression] = STATE(2388),
    [sym_for_expression] = STATE(2388),
    [sym_while_expression] = STATE(2388),
    [sym__if_branch] = STATE(7331),
    [sym_if_expression] = STATE(2388),
    [sym_fun_expression] = STATE(2388),
    [sym_try_expression] = STATE(2388),
    [sym_match_expression] = STATE(2388),
    [sym_function_expression] = STATE(2388),
    [sym_object_instantiation_expression] = STATE(2388),
    [sym_mutate_expression] = STATE(2388),
    [sym_index_expression] = STATE(2388),
    [sym_dot_expression] = STATE(2388),
    [sym_typed_expression] = STATE(2388),
    [sym_declaration_expression] = STATE(2388),
    [sym_do_expression] = STATE(2388),
    [sym_list_expression] = STATE(2388),
    [sym_array_expression] = STATE(2388),
    [sym_begin_end_expression] = STATE(2388),
    [sym_paren_expression] = STATE(2388),
    [sym_application_expression] = STATE(2388),
    [sym_infix_expression] = STATE(2388),
    [sym_ce_expression] = STATE(2388),
    [sym_sequential_expression] = STATE(2388),
    [sym_char] = STATE(2350),
    [sym_format_string] = STATE(2357),
    [sym__string_literal] = STATE(2357),
    [sym_string] = STATE(2350),
    [sym_verbatim_string] = STATE(2350),
    [sym_bytearray] = STATE(2350),
    [sym_verbatim_bytearray] = STATE(2350),
    [sym_format_triple_quoted_string] = STATE(2365),
    [sym_triple_quoted_string] = STATE(2350),
    [sym_const] = STATE(2388),
    [sym_long_identifier] = STATE(2769),
    [sym_active_pattern] = STATE(2640),
    [sym__identifier_or_op] = STATE(2767),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(860),
    [sym_sbyte] = STATE(2350),
    [sym_byte] = STATE(2350),
    [sym_int16] = STATE(2350),
    [sym_uint16] = STATE(2350),
    [sym_int32] = STATE(2350),
    [sym_uint32] = STATE(2350),
    [sym_nativeint] = STATE(2350),
    [sym_unativeint] = STATE(2350),
    [sym_int64] = STATE(2350),
    [sym_uint64] = STATE(2350),
    [sym_ieee32] = STATE(2350),
    [sym_ieee64] = STATE(2350),
    [sym_bignum] = STATE(2350),
    [sym_decimal] = STATE(2350),
    [sym_float] = STATE(1862),
    [sym_xml_doc] = STATE(860),
    [sym_block_comment] = STATE(860),
    [sym_line_comment] = STATE(860),
    [sym_compiler_directive_decl] = STATE(860),
    [sym_fsi_directive_decl] = STATE(860),
    [sym_preproc_line] = STATE(860),
    [sym_preproc_if_in_expression] = STATE(2388),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(2389),
    [anon_sym_LT_AT] = ACTIONS(1042),
    [anon_sym_LT_AT_AT] = ACTIONS(2391),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_return_BANG] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_yield_BANG] = ACTIONS(1052),
    [anon_sym_lazy] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_upcast] = ACTIONS(1026),
    [anon_sym_downcast] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1058),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_match_BANG] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1076),
    [anon_sym_use_BANG] = ACTIONS(1078),
    [anon_sym_do_BANG] = ACTIONS(1080),
    [anon_sym_begin] = ACTIONS(1082),
    [aux_sym_char_token1] = ACTIONS(1086),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_AT_DQUOTE] = ACTIONS(1092),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1096),
    [sym_bool] = ACTIONS(1098),
    [sym_unit] = ACTIONS(2393),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1100),
    [sym_op_identifier] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(1104),
    [sym_xint] = ACTIONS(1106),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(1108),
  },
  [861] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(10),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(861),
    [sym_block_comment] = STATE(861),
    [sym_line_comment] = STATE(861),
    [sym_compiler_directive_decl] = STATE(861),
    [sym_fsi_directive_decl] = STATE(861),
    [sym_preproc_line] = STATE(861),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [862] = {
    [sym_function_or_value_defn] = STATE(788),
    [sym__expression] = STATE(25),
    [sym_literal_expression] = STATE(1318),
    [sym_long_identifier_or_op] = STATE(1318),
    [sym_tuple_expression] = STATE(1318),
    [sym_brace_expression] = STATE(1318),
    [sym_anon_record_expression] = STATE(1318),
    [sym_prefixed_expression] = STATE(1318),
    [sym_typecast_expression] = STATE(1318),
    [sym_for_expression] = STATE(1318),
    [sym_while_expression] = STATE(1318),
    [sym__if_branch] = STATE(8374),
    [sym_if_expression] = STATE(1318),
    [sym_fun_expression] = STATE(1318),
    [sym_try_expression] = STATE(1318),
    [sym_match_expression] = STATE(1318),
    [sym_function_expression] = STATE(1318),
    [sym_object_instantiation_expression] = STATE(1318),
    [sym_mutate_expression] = STATE(1318),
    [sym_index_expression] = STATE(1318),
    [sym_dot_expression] = STATE(1318),
    [sym_typed_expression] = STATE(1318),
    [sym_declaration_expression] = STATE(1318),
    [sym_do_expression] = STATE(1318),
    [sym_list_expression] = STATE(1318),
    [sym_array_expression] = STATE(1318),
    [sym_begin_end_expression] = STATE(1318),
    [sym_paren_expression] = STATE(1318),
    [sym_application_expression] = STATE(1318),
    [sym_infix_expression] = STATE(1318),
    [sym_ce_expression] = STATE(1318),
    [sym_sequential_expression] = STATE(1318),
    [sym_char] = STATE(1283),
    [sym_format_string] = STATE(1367),
    [sym__string_literal] = STATE(1367),
    [sym_string] = STATE(1283),
    [sym_verbatim_string] = STATE(1283),
    [sym_bytearray] = STATE(1283),
    [sym_verbatim_bytearray] = STATE(1283),
    [sym_format_triple_quoted_string] = STATE(1276),
    [sym_triple_quoted_string] = STATE(1283),
    [sym_const] = STATE(1318),
    [sym_long_identifier] = STATE(1371),
    [sym_active_pattern] = STATE(1300),
    [sym__identifier_or_op] = STATE(1380),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(790),
    [sym_sbyte] = STATE(1283),
    [sym_byte] = STATE(1283),
    [sym_int16] = STATE(1283),
    [sym_uint16] = STATE(1283),
    [sym_int32] = STATE(1283),
    [sym_uint32] = STATE(1283),
    [sym_nativeint] = STATE(1283),
    [sym_unativeint] = STATE(1283),
    [sym_int64] = STATE(1283),
    [sym_uint64] = STATE(1283),
    [sym_ieee32] = STATE(1283),
    [sym_ieee64] = STATE(1283),
    [sym_bignum] = STATE(1283),
    [sym_decimal] = STATE(1283),
    [sym_float] = STATE(1084),
    [sym_xml_doc] = STATE(862),
    [sym_block_comment] = STATE(862),
    [sym_line_comment] = STATE(862),
    [sym_compiler_directive_decl] = STATE(862),
    [sym_fsi_directive_decl] = STATE(862),
    [sym_preproc_line] = STATE(862),
    [sym_preproc_if_in_expression] = STATE(1318),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(27),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(43),
    [anon_sym_LBRACK_PIPE] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_LT_AT] = ACTIONS(49),
    [anon_sym_LT_AT_AT] = ACTIONS(51),
    [anon_sym_LBRACE_PIPE] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(55),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(27),
    [anon_sym_upcast] = ACTIONS(27),
    [anon_sym_downcast] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(83),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_AT_DQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(91),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [sym_bool] = ACTIONS(95),
    [sym_unit] = ACTIONS(97),
    [anon_sym_LPAREN_PIPE] = ACTIONS(99),
    [sym_op_identifier] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(109),
    [sym_xint] = ACTIONS(111),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(291),
  },
  [863] = {
    [sym_function_or_value_defn] = STATE(786),
    [sym__expression] = STATE(375),
    [sym_literal_expression] = STATE(1141),
    [sym_long_identifier_or_op] = STATE(1141),
    [sym_tuple_expression] = STATE(1141),
    [sym_brace_expression] = STATE(1141),
    [sym_anon_record_expression] = STATE(1141),
    [sym_prefixed_expression] = STATE(1141),
    [sym_typecast_expression] = STATE(1141),
    [sym_for_expression] = STATE(1141),
    [sym_while_expression] = STATE(1141),
    [sym__if_branch] = STATE(7197),
    [sym_if_expression] = STATE(1141),
    [sym_fun_expression] = STATE(1141),
    [sym_try_expression] = STATE(1141),
    [sym_match_expression] = STATE(1141),
    [sym_function_expression] = STATE(1141),
    [sym_object_instantiation_expression] = STATE(1141),
    [sym_mutate_expression] = STATE(1141),
    [sym_index_expression] = STATE(1141),
    [sym_dot_expression] = STATE(1141),
    [sym_typed_expression] = STATE(1141),
    [sym_declaration_expression] = STATE(1141),
    [sym_do_expression] = STATE(1141),
    [sym_list_expression] = STATE(1141),
    [sym_array_expression] = STATE(1141),
    [sym_begin_end_expression] = STATE(1141),
    [sym_paren_expression] = STATE(1141),
    [sym_application_expression] = STATE(1141),
    [sym_infix_expression] = STATE(1141),
    [sym_ce_expression] = STATE(1141),
    [sym_sequential_expression] = STATE(1141),
    [sym_char] = STATE(1126),
    [sym_format_string] = STATE(1125),
    [sym__string_literal] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_verbatim_string] = STATE(1126),
    [sym_bytearray] = STATE(1126),
    [sym_verbatim_bytearray] = STATE(1126),
    [sym_format_triple_quoted_string] = STATE(1121),
    [sym_triple_quoted_string] = STATE(1126),
    [sym_const] = STATE(1141),
    [sym_long_identifier] = STATE(1064),
    [sym_active_pattern] = STATE(1058),
    [sym__identifier_or_op] = STATE(1120),
    [sym__infix_or_prefix_op] = STATE(3539),
    [sym_prefix_op] = STATE(753),
    [sym_sbyte] = STATE(1126),
    [sym_byte] = STATE(1126),
    [sym_int16] = STATE(1126),
    [sym_uint16] = STATE(1126),
    [sym_int32] = STATE(1126),
    [sym_uint32] = STATE(1126),
    [sym_nativeint] = STATE(1126),
    [sym_unativeint] = STATE(1126),
    [sym_int64] = STATE(1126),
    [sym_uint64] = STATE(1126),
    [sym_ieee32] = STATE(1126),
    [sym_ieee64] = STATE(1126),
    [sym_bignum] = STATE(1126),
    [sym_decimal] = STATE(1126),
    [sym_float] = STATE(966),
    [sym_xml_doc] = STATE(863),
    [sym_block_comment] = STATE(863),
    [sym_line_comment] = STATE(863),
    [sym_compiler_directive_decl] = STATE(863),
    [sym_fsi_directive_decl] = STATE(863),
    [sym_preproc_line] = STATE(863),
    [sym_preproc_if_in_expression] = STATE(1141),
    [aux_sym_prefix_op_repeat1] = STATE(3527),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(131),
    [anon_sym_let_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_null] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_LBRACK_PIPE] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_LT_AT] = ACTIONS(149),
    [anon_sym_LT_AT_AT] = ACTIONS(2293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(127),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(127),
    [anon_sym_assert] = ACTIONS(127),
    [anon_sym_upcast] = ACTIONS(127),
    [anon_sym_downcast] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(2303),
    [anon_sym_LPAREN_PIPE] = ACTIONS(207),
    [sym_op_identifier] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_PLUS_DOT] = ACTIONS(103),
    [anon_sym_DASH_DOT] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(105),
    [aux_sym_prefix_op_token1] = ACTIONS(107),
    [sym_int] = ACTIONS(213),
    [sym_xint] = ACTIONS(215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(217),
  },
  [864] = {
    [sym_xml_doc] = STATE(864),
    [sym_block_comment] = STATE(864),
    [sym_line_comment] = STATE(864),
    [sym_compiler_directive_decl] = STATE(864),
    [sym_fsi_directive_decl] = STATE(864),
    [sym_preproc_line] = STATE(864),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_GT_RBRACK] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_to] = ACTIONS(2768),
    [anon_sym_downto] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_end] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2772),
    [anon_sym_uy] = ACTIONS(2774),
    [anon_sym_s] = ACTIONS(2776),
    [anon_sym_us] = ACTIONS(2778),
    [anon_sym_l] = ACTIONS(2780),
    [aux_sym_uint32_token1] = ACTIONS(2782),
    [anon_sym_n] = ACTIONS(2784),
    [anon_sym_un] = ACTIONS(2786),
    [anon_sym_L] = ACTIONS(2788),
    [aux_sym_uint64_token1] = ACTIONS(2790),
    [aux_sym_bignum_token1] = ACTIONS(2792),
    [aux_sym_decimal_token1] = ACTIONS(2794),
    [anon_sym_DOT2] = ACTIONS(2796),
    [aux_sym_float_token1] = ACTIONS(2798),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [865] = {
    [sym_xml_doc] = STATE(865),
    [sym_block_comment] = STATE(865),
    [sym_line_comment] = STATE(865),
    [sym_compiler_directive_decl] = STATE(865),
    [sym_fsi_directive_decl] = STATE(865),
    [sym_preproc_line] = STATE(865),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2800),
    [anon_sym_uy] = ACTIONS(2802),
    [anon_sym_s] = ACTIONS(2804),
    [anon_sym_us] = ACTIONS(2806),
    [anon_sym_l] = ACTIONS(2808),
    [aux_sym_uint32_token1] = ACTIONS(2810),
    [anon_sym_n] = ACTIONS(2812),
    [anon_sym_un] = ACTIONS(2814),
    [anon_sym_L] = ACTIONS(2816),
    [aux_sym_uint64_token1] = ACTIONS(2818),
    [aux_sym_bignum_token1] = ACTIONS(2820),
    [aux_sym_decimal_token1] = ACTIONS(2822),
    [anon_sym_DOT2] = ACTIONS(2824),
    [aux_sym_float_token1] = ACTIONS(2826),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [866] = {
    [sym_xml_doc] = STATE(866),
    [sym_block_comment] = STATE(866),
    [sym_line_comment] = STATE(866),
    [sym_compiler_directive_decl] = STATE(866),
    [sym_fsi_directive_decl] = STATE(866),
    [sym_preproc_line] = STATE(866),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_GT_RBRACK] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_to] = ACTIONS(2768),
    [anon_sym_downto] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_end] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2772),
    [anon_sym_uy] = ACTIONS(2774),
    [anon_sym_s] = ACTIONS(2776),
    [anon_sym_us] = ACTIONS(2778),
    [anon_sym_l] = ACTIONS(2780),
    [aux_sym_uint32_token1] = ACTIONS(2782),
    [anon_sym_n] = ACTIONS(2784),
    [anon_sym_un] = ACTIONS(2786),
    [anon_sym_L] = ACTIONS(2788),
    [aux_sym_uint64_token1] = ACTIONS(2790),
    [anon_sym_lf] = ACTIONS(2828),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [867] = {
    [sym_xml_doc] = STATE(867),
    [sym_block_comment] = STATE(867),
    [sym_line_comment] = STATE(867),
    [sym_compiler_directive_decl] = STATE(867),
    [sym_fsi_directive_decl] = STATE(867),
    [sym_preproc_line] = STATE(867),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2832),
    [anon_sym_uy] = ACTIONS(2834),
    [anon_sym_s] = ACTIONS(2836),
    [anon_sym_us] = ACTIONS(2838),
    [anon_sym_l] = ACTIONS(2840),
    [aux_sym_uint32_token1] = ACTIONS(2842),
    [anon_sym_n] = ACTIONS(2844),
    [anon_sym_un] = ACTIONS(2846),
    [anon_sym_L] = ACTIONS(2848),
    [aux_sym_uint64_token1] = ACTIONS(2850),
    [aux_sym_bignum_token1] = ACTIONS(2852),
    [aux_sym_decimal_token1] = ACTIONS(2854),
    [anon_sym_DOT2] = ACTIONS(2856),
    [aux_sym_float_token1] = ACTIONS(2858),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [868] = {
    [sym_xml_doc] = STATE(868),
    [sym_block_comment] = STATE(868),
    [sym_line_comment] = STATE(868),
    [sym_compiler_directive_decl] = STATE(868),
    [sym_fsi_directive_decl] = STATE(868),
    [sym_preproc_line] = STATE(868),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2800),
    [anon_sym_uy] = ACTIONS(2802),
    [anon_sym_s] = ACTIONS(2804),
    [anon_sym_us] = ACTIONS(2806),
    [anon_sym_l] = ACTIONS(2808),
    [aux_sym_uint32_token1] = ACTIONS(2810),
    [anon_sym_n] = ACTIONS(2812),
    [anon_sym_un] = ACTIONS(2814),
    [anon_sym_L] = ACTIONS(2816),
    [aux_sym_uint64_token1] = ACTIONS(2818),
    [aux_sym_bignum_token1] = ACTIONS(2820),
    [aux_sym_decimal_token1] = ACTIONS(2822),
    [anon_sym_DOT2] = ACTIONS(2824),
    [aux_sym_float_token1] = ACTIONS(2826),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [869] = {
    [sym_xml_doc] = STATE(869),
    [sym_block_comment] = STATE(869),
    [sym_line_comment] = STATE(869),
    [sym_compiler_directive_decl] = STATE(869),
    [sym_fsi_directive_decl] = STATE(869),
    [sym_preproc_line] = STATE(869),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2800),
    [anon_sym_uy] = ACTIONS(2802),
    [anon_sym_s] = ACTIONS(2804),
    [anon_sym_us] = ACTIONS(2806),
    [anon_sym_l] = ACTIONS(2808),
    [aux_sym_uint32_token1] = ACTIONS(2810),
    [anon_sym_n] = ACTIONS(2812),
    [anon_sym_un] = ACTIONS(2814),
    [anon_sym_L] = ACTIONS(2816),
    [aux_sym_uint64_token1] = ACTIONS(2818),
    [anon_sym_lf] = ACTIONS(2860),
    [anon_sym_LF] = ACTIONS(2862),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [870] = {
    [sym_xml_doc] = STATE(870),
    [sym_block_comment] = STATE(870),
    [sym_line_comment] = STATE(870),
    [sym_compiler_directive_decl] = STATE(870),
    [sym_fsi_directive_decl] = STATE(870),
    [sym_preproc_line] = STATE(870),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2832),
    [anon_sym_uy] = ACTIONS(2834),
    [anon_sym_s] = ACTIONS(2836),
    [anon_sym_us] = ACTIONS(2838),
    [anon_sym_l] = ACTIONS(2840),
    [aux_sym_uint32_token1] = ACTIONS(2842),
    [anon_sym_n] = ACTIONS(2844),
    [anon_sym_un] = ACTIONS(2846),
    [anon_sym_L] = ACTIONS(2848),
    [aux_sym_uint64_token1] = ACTIONS(2850),
    [anon_sym_lf] = ACTIONS(2864),
    [anon_sym_LF] = ACTIONS(2866),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [871] = {
    [sym_xml_doc] = STATE(871),
    [sym_block_comment] = STATE(871),
    [sym_line_comment] = STATE(871),
    [sym_compiler_directive_decl] = STATE(871),
    [sym_fsi_directive_decl] = STATE(871),
    [sym_preproc_line] = STATE(871),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2868),
    [anon_sym_uy] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2872),
    [anon_sym_us] = ACTIONS(2874),
    [anon_sym_l] = ACTIONS(2876),
    [aux_sym_uint32_token1] = ACTIONS(2878),
    [anon_sym_n] = ACTIONS(2880),
    [anon_sym_un] = ACTIONS(2882),
    [anon_sym_L] = ACTIONS(2884),
    [aux_sym_uint64_token1] = ACTIONS(2886),
    [aux_sym_bignum_token1] = ACTIONS(2888),
    [aux_sym_decimal_token1] = ACTIONS(2890),
    [anon_sym_DOT2] = ACTIONS(2892),
    [aux_sym_float_token1] = ACTIONS(2894),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [872] = {
    [sym_xml_doc] = STATE(872),
    [sym_block_comment] = STATE(872),
    [sym_line_comment] = STATE(872),
    [sym_compiler_directive_decl] = STATE(872),
    [sym_fsi_directive_decl] = STATE(872),
    [sym_preproc_line] = STATE(872),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2800),
    [anon_sym_uy] = ACTIONS(2802),
    [anon_sym_s] = ACTIONS(2804),
    [anon_sym_us] = ACTIONS(2806),
    [anon_sym_l] = ACTIONS(2808),
    [aux_sym_uint32_token1] = ACTIONS(2810),
    [anon_sym_n] = ACTIONS(2812),
    [anon_sym_un] = ACTIONS(2814),
    [anon_sym_L] = ACTIONS(2816),
    [aux_sym_uint64_token1] = ACTIONS(2818),
    [anon_sym_lf] = ACTIONS(2860),
    [anon_sym_LF] = ACTIONS(2862),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [873] = {
    [sym_xml_doc] = STATE(873),
    [sym_block_comment] = STATE(873),
    [sym_line_comment] = STATE(873),
    [sym_compiler_directive_decl] = STATE(873),
    [sym_fsi_directive_decl] = STATE(873),
    [sym_preproc_line] = STATE(873),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2896),
    [anon_sym_uy] = ACTIONS(2898),
    [anon_sym_s] = ACTIONS(2900),
    [anon_sym_us] = ACTIONS(2902),
    [anon_sym_l] = ACTIONS(2904),
    [aux_sym_uint32_token1] = ACTIONS(2906),
    [anon_sym_n] = ACTIONS(2908),
    [anon_sym_un] = ACTIONS(2910),
    [anon_sym_L] = ACTIONS(2912),
    [aux_sym_uint64_token1] = ACTIONS(2914),
    [aux_sym_bignum_token1] = ACTIONS(2916),
    [aux_sym_decimal_token1] = ACTIONS(2918),
    [anon_sym_DOT2] = ACTIONS(2920),
    [aux_sym_float_token1] = ACTIONS(2922),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [874] = {
    [sym_xml_doc] = STATE(874),
    [sym_block_comment] = STATE(874),
    [sym_line_comment] = STATE(874),
    [sym_compiler_directive_decl] = STATE(874),
    [sym_fsi_directive_decl] = STATE(874),
    [sym_preproc_line] = STATE(874),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2924),
    [anon_sym_uy] = ACTIONS(2926),
    [anon_sym_s] = ACTIONS(2928),
    [anon_sym_us] = ACTIONS(2930),
    [anon_sym_l] = ACTIONS(2932),
    [aux_sym_uint32_token1] = ACTIONS(2934),
    [anon_sym_n] = ACTIONS(2936),
    [anon_sym_un] = ACTIONS(2938),
    [anon_sym_L] = ACTIONS(2940),
    [aux_sym_uint64_token1] = ACTIONS(2942),
    [aux_sym_bignum_token1] = ACTIONS(2944),
    [aux_sym_decimal_token1] = ACTIONS(2946),
    [anon_sym_DOT2] = ACTIONS(2948),
    [aux_sym_float_token1] = ACTIONS(2950),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [anon_sym_POUNDelse] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [875] = {
    [sym_xml_doc] = STATE(875),
    [sym_block_comment] = STATE(875),
    [sym_line_comment] = STATE(875),
    [sym_compiler_directive_decl] = STATE(875),
    [sym_fsi_directive_decl] = STATE(875),
    [sym_preproc_line] = STATE(875),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2772),
    [anon_sym_uy] = ACTIONS(2774),
    [anon_sym_s] = ACTIONS(2776),
    [anon_sym_us] = ACTIONS(2778),
    [anon_sym_l] = ACTIONS(2780),
    [aux_sym_uint32_token1] = ACTIONS(2782),
    [anon_sym_n] = ACTIONS(2784),
    [anon_sym_un] = ACTIONS(2786),
    [anon_sym_L] = ACTIONS(2788),
    [aux_sym_uint64_token1] = ACTIONS(2790),
    [aux_sym_bignum_token1] = ACTIONS(2792),
    [aux_sym_decimal_token1] = ACTIONS(2794),
    [anon_sym_DOT2] = ACTIONS(2796),
    [aux_sym_float_token1] = ACTIONS(2798),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [876] = {
    [sym_xml_doc] = STATE(876),
    [sym_block_comment] = STATE(876),
    [sym_line_comment] = STATE(876),
    [sym_compiler_directive_decl] = STATE(876),
    [sym_fsi_directive_decl] = STATE(876),
    [sym_preproc_line] = STATE(876),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2952),
    [anon_sym_uy] = ACTIONS(2954),
    [anon_sym_s] = ACTIONS(2956),
    [anon_sym_us] = ACTIONS(2958),
    [anon_sym_l] = ACTIONS(2960),
    [aux_sym_uint32_token1] = ACTIONS(2962),
    [anon_sym_n] = ACTIONS(2964),
    [anon_sym_un] = ACTIONS(2966),
    [anon_sym_L] = ACTIONS(2968),
    [aux_sym_uint64_token1] = ACTIONS(2970),
    [aux_sym_bignum_token1] = ACTIONS(2972),
    [aux_sym_decimal_token1] = ACTIONS(2974),
    [anon_sym_DOT2] = ACTIONS(2976),
    [aux_sym_float_token1] = ACTIONS(2978),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [877] = {
    [sym_xml_doc] = STATE(877),
    [sym_block_comment] = STATE(877),
    [sym_line_comment] = STATE(877),
    [sym_compiler_directive_decl] = STATE(877),
    [sym_fsi_directive_decl] = STATE(877),
    [sym_preproc_line] = STATE(877),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2952),
    [anon_sym_uy] = ACTIONS(2954),
    [anon_sym_s] = ACTIONS(2956),
    [anon_sym_us] = ACTIONS(2958),
    [anon_sym_l] = ACTIONS(2960),
    [aux_sym_uint32_token1] = ACTIONS(2962),
    [anon_sym_n] = ACTIONS(2964),
    [anon_sym_un] = ACTIONS(2966),
    [anon_sym_L] = ACTIONS(2968),
    [aux_sym_uint64_token1] = ACTIONS(2970),
    [aux_sym_bignum_token1] = ACTIONS(2972),
    [aux_sym_decimal_token1] = ACTIONS(2974),
    [anon_sym_DOT2] = ACTIONS(2976),
    [aux_sym_float_token1] = ACTIONS(2978),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [878] = {
    [sym_xml_doc] = STATE(878),
    [sym_block_comment] = STATE(878),
    [sym_line_comment] = STATE(878),
    [sym_compiler_directive_decl] = STATE(878),
    [sym_fsi_directive_decl] = STATE(878),
    [sym_preproc_line] = STATE(878),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_DASH_GT] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2980),
    [anon_sym_uy] = ACTIONS(2982),
    [anon_sym_s] = ACTIONS(2984),
    [anon_sym_us] = ACTIONS(2986),
    [anon_sym_l] = ACTIONS(2988),
    [aux_sym_uint32_token1] = ACTIONS(2990),
    [anon_sym_n] = ACTIONS(2992),
    [anon_sym_un] = ACTIONS(2994),
    [anon_sym_L] = ACTIONS(2996),
    [aux_sym_uint64_token1] = ACTIONS(2998),
    [aux_sym_bignum_token1] = ACTIONS(3000),
    [aux_sym_decimal_token1] = ACTIONS(3002),
    [anon_sym_DOT2] = ACTIONS(3004),
    [aux_sym_float_token1] = ACTIONS(3006),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [879] = {
    [sym_type_arguments] = STATE(927),
    [sym_long_identifier] = STATE(917),
    [sym_xml_doc] = STATE(879),
    [sym_block_comment] = STATE(879),
    [sym_line_comment] = STATE(879),
    [sym_compiler_directive_decl] = STATE(879),
    [sym_fsi_directive_decl] = STATE(879),
    [sym_preproc_line] = STATE(879),
    [aux_sym__compound_type_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_GT_RBRACK] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3010),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_to] = ACTIONS(3012),
    [anon_sym_downto] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_end] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_DOT_DOT2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3018),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [880] = {
    [sym_type_arguments] = STATE(927),
    [sym_long_identifier] = STATE(917),
    [sym_xml_doc] = STATE(880),
    [sym_block_comment] = STATE(880),
    [sym_line_comment] = STATE(880),
    [sym_compiler_directive_decl] = STATE(880),
    [sym_fsi_directive_decl] = STATE(880),
    [sym_preproc_line] = STATE(880),
    [aux_sym__compound_type_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_GT_RBRACK] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_RBRACK] = ACTIONS(3022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_to] = ACTIONS(3024),
    [anon_sym_downto] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_end] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_DOT_DOT2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3018),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [881] = {
    [sym_xml_doc] = STATE(881),
    [sym_block_comment] = STATE(881),
    [sym_line_comment] = STATE(881),
    [sym_compiler_directive_decl] = STATE(881),
    [sym_fsi_directive_decl] = STATE(881),
    [sym_preproc_line] = STATE(881),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2868),
    [anon_sym_uy] = ACTIONS(2870),
    [anon_sym_s] = ACTIONS(2872),
    [anon_sym_us] = ACTIONS(2874),
    [anon_sym_l] = ACTIONS(2876),
    [aux_sym_uint32_token1] = ACTIONS(2878),
    [anon_sym_n] = ACTIONS(2880),
    [anon_sym_un] = ACTIONS(2882),
    [anon_sym_L] = ACTIONS(2884),
    [aux_sym_uint64_token1] = ACTIONS(2886),
    [anon_sym_lf] = ACTIONS(3026),
    [anon_sym_LF] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [882] = {
    [sym_type_arguments] = STATE(927),
    [sym_long_identifier] = STATE(917),
    [sym_xml_doc] = STATE(882),
    [sym_block_comment] = STATE(882),
    [sym_line_comment] = STATE(882),
    [sym_compiler_directive_decl] = STATE(882),
    [sym_fsi_directive_decl] = STATE(882),
    [sym_preproc_line] = STATE(882),
    [aux_sym__compound_type_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_GT_RBRACK] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_RBRACK] = ACTIONS(3030),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_to] = ACTIONS(3032),
    [anon_sym_downto] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_end] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_DOT_DOT2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3018),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [883] = {
    [sym_xml_doc] = STATE(883),
    [sym_block_comment] = STATE(883),
    [sym_line_comment] = STATE(883),
    [sym_compiler_directive_decl] = STATE(883),
    [sym_fsi_directive_decl] = STATE(883),
    [sym_preproc_line] = STATE(883),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_DASH_GT] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2980),
    [anon_sym_uy] = ACTIONS(2982),
    [anon_sym_s] = ACTIONS(2984),
    [anon_sym_us] = ACTIONS(2986),
    [anon_sym_l] = ACTIONS(2988),
    [aux_sym_uint32_token1] = ACTIONS(2990),
    [anon_sym_n] = ACTIONS(2992),
    [anon_sym_un] = ACTIONS(2994),
    [anon_sym_L] = ACTIONS(2996),
    [aux_sym_uint64_token1] = ACTIONS(2998),
    [aux_sym_bignum_token1] = ACTIONS(3000),
    [aux_sym_decimal_token1] = ACTIONS(3002),
    [anon_sym_DOT2] = ACTIONS(3004),
    [aux_sym_float_token1] = ACTIONS(3006),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [884] = {
    [sym_xml_doc] = STATE(884),
    [sym_block_comment] = STATE(884),
    [sym_line_comment] = STATE(884),
    [sym_compiler_directive_decl] = STATE(884),
    [sym_fsi_directive_decl] = STATE(884),
    [sym_preproc_line] = STATE(884),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3034),
    [anon_sym_uy] = ACTIONS(3036),
    [anon_sym_s] = ACTIONS(3038),
    [anon_sym_us] = ACTIONS(3040),
    [anon_sym_l] = ACTIONS(3042),
    [aux_sym_uint32_token1] = ACTIONS(3044),
    [anon_sym_n] = ACTIONS(3046),
    [anon_sym_un] = ACTIONS(3048),
    [anon_sym_L] = ACTIONS(3050),
    [aux_sym_uint64_token1] = ACTIONS(3052),
    [aux_sym_bignum_token1] = ACTIONS(3054),
    [aux_sym_decimal_token1] = ACTIONS(3056),
    [anon_sym_DOT2] = ACTIONS(3058),
    [aux_sym_float_token1] = ACTIONS(3060),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [885] = {
    [sym_xml_doc] = STATE(885),
    [sym_block_comment] = STATE(885),
    [sym_line_comment] = STATE(885),
    [sym_compiler_directive_decl] = STATE(885),
    [sym_fsi_directive_decl] = STATE(885),
    [sym_preproc_line] = STATE(885),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_AT_GT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3062),
    [anon_sym_uy] = ACTIONS(3064),
    [anon_sym_s] = ACTIONS(3066),
    [anon_sym_us] = ACTIONS(3068),
    [anon_sym_l] = ACTIONS(3070),
    [aux_sym_uint32_token1] = ACTIONS(3072),
    [anon_sym_n] = ACTIONS(3074),
    [anon_sym_un] = ACTIONS(3076),
    [anon_sym_L] = ACTIONS(3078),
    [aux_sym_uint64_token1] = ACTIONS(3080),
    [aux_sym_bignum_token1] = ACTIONS(3082),
    [aux_sym_decimal_token1] = ACTIONS(3084),
    [anon_sym_DOT2] = ACTIONS(3086),
    [aux_sym_float_token1] = ACTIONS(3088),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [886] = {
    [sym_type_arguments] = STATE(927),
    [sym_long_identifier] = STATE(917),
    [sym_xml_doc] = STATE(886),
    [sym_block_comment] = STATE(886),
    [sym_line_comment] = STATE(886),
    [sym_compiler_directive_decl] = STATE(886),
    [sym_fsi_directive_decl] = STATE(886),
    [sym_preproc_line] = STATE(886),
    [aux_sym__compound_type_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_GT_RBRACK] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_RBRACK] = ACTIONS(3090),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_to] = ACTIONS(3092),
    [anon_sym_downto] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_DOT_DOT2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3018),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [887] = {
    [sym_xml_doc] = STATE(887),
    [sym_block_comment] = STATE(887),
    [sym_line_comment] = STATE(887),
    [sym_compiler_directive_decl] = STATE(887),
    [sym_fsi_directive_decl] = STATE(887),
    [sym_preproc_line] = STATE(887),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2952),
    [anon_sym_uy] = ACTIONS(2954),
    [anon_sym_s] = ACTIONS(2956),
    [anon_sym_us] = ACTIONS(2958),
    [anon_sym_l] = ACTIONS(2960),
    [aux_sym_uint32_token1] = ACTIONS(2962),
    [anon_sym_n] = ACTIONS(2964),
    [anon_sym_un] = ACTIONS(2966),
    [anon_sym_L] = ACTIONS(2968),
    [aux_sym_uint64_token1] = ACTIONS(2970),
    [anon_sym_lf] = ACTIONS(3094),
    [anon_sym_LF] = ACTIONS(3096),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [888] = {
    [sym_xml_doc] = STATE(888),
    [sym_block_comment] = STATE(888),
    [sym_line_comment] = STATE(888),
    [sym_compiler_directive_decl] = STATE(888),
    [sym_fsi_directive_decl] = STATE(888),
    [sym_preproc_line] = STATE(888),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_GT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3098),
    [anon_sym_uy] = ACTIONS(3100),
    [anon_sym_s] = ACTIONS(3102),
    [anon_sym_us] = ACTIONS(3104),
    [anon_sym_l] = ACTIONS(3106),
    [aux_sym_uint32_token1] = ACTIONS(3108),
    [anon_sym_n] = ACTIONS(3110),
    [anon_sym_un] = ACTIONS(3112),
    [anon_sym_L] = ACTIONS(3114),
    [aux_sym_uint64_token1] = ACTIONS(3116),
    [aux_sym_bignum_token1] = ACTIONS(3118),
    [aux_sym_decimal_token1] = ACTIONS(3120),
    [anon_sym_DOT2] = ACTIONS(3122),
    [aux_sym_float_token1] = ACTIONS(3124),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [889] = {
    [sym_xml_doc] = STATE(889),
    [sym_block_comment] = STATE(889),
    [sym_line_comment] = STATE(889),
    [sym_compiler_directive_decl] = STATE(889),
    [sym_fsi_directive_decl] = STATE(889),
    [sym_preproc_line] = STATE(889),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_AT_AT_GT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3126),
    [anon_sym_uy] = ACTIONS(3128),
    [anon_sym_s] = ACTIONS(3130),
    [anon_sym_us] = ACTIONS(3132),
    [anon_sym_l] = ACTIONS(3134),
    [aux_sym_uint32_token1] = ACTIONS(3136),
    [anon_sym_n] = ACTIONS(3138),
    [anon_sym_un] = ACTIONS(3140),
    [anon_sym_L] = ACTIONS(3142),
    [aux_sym_uint64_token1] = ACTIONS(3144),
    [aux_sym_bignum_token1] = ACTIONS(3146),
    [aux_sym_decimal_token1] = ACTIONS(3148),
    [anon_sym_DOT2] = ACTIONS(3150),
    [aux_sym_float_token1] = ACTIONS(3152),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [890] = {
    [sym_type_arguments] = STATE(927),
    [sym_long_identifier] = STATE(917),
    [sym_xml_doc] = STATE(890),
    [sym_block_comment] = STATE(890),
    [sym_line_comment] = STATE(890),
    [sym_compiler_directive_decl] = STATE(890),
    [sym_fsi_directive_decl] = STATE(890),
    [sym_preproc_line] = STATE(890),
    [aux_sym__compound_type_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_GT_RBRACK] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_RBRACK] = ACTIONS(3156),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_to] = ACTIONS(3154),
    [anon_sym_downto] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_end] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_DOT_DOT2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3018),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [891] = {
    [sym_xml_doc] = STATE(891),
    [sym_block_comment] = STATE(891),
    [sym_line_comment] = STATE(891),
    [sym_compiler_directive_decl] = STATE(891),
    [sym_fsi_directive_decl] = STATE(891),
    [sym_preproc_line] = STATE(891),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3158),
    [anon_sym_uy] = ACTIONS(3160),
    [anon_sym_s] = ACTIONS(3162),
    [anon_sym_us] = ACTIONS(3164),
    [anon_sym_l] = ACTIONS(3166),
    [aux_sym_uint32_token1] = ACTIONS(3168),
    [anon_sym_n] = ACTIONS(3170),
    [anon_sym_un] = ACTIONS(3172),
    [anon_sym_L] = ACTIONS(3174),
    [aux_sym_uint64_token1] = ACTIONS(3176),
    [aux_sym_bignum_token1] = ACTIONS(3178),
    [aux_sym_decimal_token1] = ACTIONS(3180),
    [anon_sym_DOT2] = ACTIONS(3182),
    [aux_sym_float_token1] = ACTIONS(3184),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [892] = {
    [sym_xml_doc] = STATE(892),
    [sym_block_comment] = STATE(892),
    [sym_line_comment] = STATE(892),
    [sym_compiler_directive_decl] = STATE(892),
    [sym_fsi_directive_decl] = STATE(892),
    [sym_preproc_line] = STATE(892),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2896),
    [anon_sym_uy] = ACTIONS(2898),
    [anon_sym_s] = ACTIONS(2900),
    [anon_sym_us] = ACTIONS(2902),
    [anon_sym_l] = ACTIONS(2904),
    [aux_sym_uint32_token1] = ACTIONS(2906),
    [anon_sym_n] = ACTIONS(2908),
    [anon_sym_un] = ACTIONS(2910),
    [anon_sym_L] = ACTIONS(2912),
    [aux_sym_uint64_token1] = ACTIONS(2914),
    [anon_sym_lf] = ACTIONS(3186),
    [anon_sym_LF] = ACTIONS(3188),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [893] = {
    [sym_xml_doc] = STATE(893),
    [sym_block_comment] = STATE(893),
    [sym_line_comment] = STATE(893),
    [sym_compiler_directive_decl] = STATE(893),
    [sym_fsi_directive_decl] = STATE(893),
    [sym_preproc_line] = STATE(893),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_DASH_GT] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2980),
    [anon_sym_uy] = ACTIONS(2982),
    [anon_sym_s] = ACTIONS(2984),
    [anon_sym_us] = ACTIONS(2986),
    [anon_sym_l] = ACTIONS(2988),
    [aux_sym_uint32_token1] = ACTIONS(2990),
    [anon_sym_n] = ACTIONS(2992),
    [anon_sym_un] = ACTIONS(2994),
    [anon_sym_L] = ACTIONS(2996),
    [aux_sym_uint64_token1] = ACTIONS(2998),
    [anon_sym_lf] = ACTIONS(3190),
    [anon_sym_LF] = ACTIONS(3192),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [894] = {
    [sym_xml_doc] = STATE(894),
    [sym_block_comment] = STATE(894),
    [sym_line_comment] = STATE(894),
    [sym_compiler_directive_decl] = STATE(894),
    [sym_fsi_directive_decl] = STATE(894),
    [sym_preproc_line] = STATE(894),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(2924),
    [anon_sym_uy] = ACTIONS(2926),
    [anon_sym_s] = ACTIONS(2928),
    [anon_sym_us] = ACTIONS(2930),
    [anon_sym_l] = ACTIONS(2932),
    [aux_sym_uint32_token1] = ACTIONS(2934),
    [anon_sym_n] = ACTIONS(2936),
    [anon_sym_un] = ACTIONS(2938),
    [anon_sym_L] = ACTIONS(2940),
    [aux_sym_uint64_token1] = ACTIONS(2942),
    [anon_sym_lf] = ACTIONS(3194),
    [anon_sym_LF] = ACTIONS(3196),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [anon_sym_POUNDelse] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [895] = {
    [sym_xml_doc] = STATE(895),
    [sym_block_comment] = STATE(895),
    [sym_line_comment] = STATE(895),
    [sym_compiler_directive_decl] = STATE(895),
    [sym_fsi_directive_decl] = STATE(895),
    [sym_preproc_line] = STATE(895),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_GT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3098),
    [anon_sym_uy] = ACTIONS(3100),
    [anon_sym_s] = ACTIONS(3102),
    [anon_sym_us] = ACTIONS(3104),
    [anon_sym_l] = ACTIONS(3106),
    [aux_sym_uint32_token1] = ACTIONS(3108),
    [anon_sym_n] = ACTIONS(3110),
    [anon_sym_un] = ACTIONS(3112),
    [anon_sym_L] = ACTIONS(3114),
    [aux_sym_uint64_token1] = ACTIONS(3116),
    [anon_sym_lf] = ACTIONS(3198),
    [anon_sym_LF] = ACTIONS(3200),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [896] = {
    [sym_xml_doc] = STATE(896),
    [sym_block_comment] = STATE(896),
    [sym_line_comment] = STATE(896),
    [sym_compiler_directive_decl] = STATE(896),
    [sym_fsi_directive_decl] = STATE(896),
    [sym_preproc_line] = STATE(896),
    [aux_sym_long_identifier_repeat1] = STATE(915),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_GT_RBRACK] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_to] = ACTIONS(3202),
    [anon_sym_downto] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_end] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_DOT_DOT2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [897] = {
    [sym_xml_doc] = STATE(897),
    [sym_block_comment] = STATE(897),
    [sym_line_comment] = STATE(897),
    [sym_compiler_directive_decl] = STATE(897),
    [sym_fsi_directive_decl] = STATE(897),
    [sym_preproc_line] = STATE(897),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_AT_AT_GT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3126),
    [anon_sym_uy] = ACTIONS(3128),
    [anon_sym_s] = ACTIONS(3130),
    [anon_sym_us] = ACTIONS(3132),
    [anon_sym_l] = ACTIONS(3134),
    [aux_sym_uint32_token1] = ACTIONS(3136),
    [anon_sym_n] = ACTIONS(3138),
    [anon_sym_un] = ACTIONS(3140),
    [anon_sym_L] = ACTIONS(3142),
    [aux_sym_uint64_token1] = ACTIONS(3144),
    [anon_sym_lf] = ACTIONS(3208),
    [anon_sym_LF] = ACTIONS(3210),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [898] = {
    [sym_xml_doc] = STATE(898),
    [sym_block_comment] = STATE(898),
    [sym_line_comment] = STATE(898),
    [sym_compiler_directive_decl] = STATE(898),
    [sym_fsi_directive_decl] = STATE(898),
    [sym_preproc_line] = STATE(898),
    [aux_sym__compound_type_repeat1] = STATE(912),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_GT_RBRACK] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_RBRACK] = ACTIONS(3214),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_to] = ACTIONS(3212),
    [anon_sym_downto] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_end] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_DOT_DOT2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [899] = {
    [sym_xml_doc] = STATE(899),
    [sym_block_comment] = STATE(899),
    [sym_line_comment] = STATE(899),
    [sym_compiler_directive_decl] = STATE(899),
    [sym_fsi_directive_decl] = STATE(899),
    [sym_preproc_line] = STATE(899),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3034),
    [anon_sym_uy] = ACTIONS(3036),
    [anon_sym_s] = ACTIONS(3038),
    [anon_sym_us] = ACTIONS(3040),
    [anon_sym_l] = ACTIONS(3042),
    [aux_sym_uint32_token1] = ACTIONS(3044),
    [anon_sym_n] = ACTIONS(3046),
    [anon_sym_un] = ACTIONS(3048),
    [anon_sym_L] = ACTIONS(3050),
    [aux_sym_uint64_token1] = ACTIONS(3052),
    [anon_sym_lf] = ACTIONS(3216),
    [anon_sym_LF] = ACTIONS(3218),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [900] = {
    [sym_type_arguments] = STATE(970),
    [sym_long_identifier] = STATE(985),
    [sym_xml_doc] = STATE(900),
    [sym_block_comment] = STATE(900),
    [sym_line_comment] = STATE(900),
    [sym_compiler_directive_decl] = STATE(900),
    [sym_fsi_directive_decl] = STATE(900),
    [sym_preproc_line] = STATE(900),
    [aux_sym__compound_type_repeat1] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(3090),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_open] = ACTIONS(3092),
    [anon_sym_LBRACK_LT] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_type] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LT2] = ACTIONS(3226),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3090),
    [anon_sym_POUNDload] = ACTIONS(3090),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [901] = {
    [sym_type_arguments] = STATE(970),
    [sym_long_identifier] = STATE(985),
    [sym_xml_doc] = STATE(901),
    [sym_block_comment] = STATE(901),
    [sym_line_comment] = STATE(901),
    [sym_compiler_directive_decl] = STATE(901),
    [sym_fsi_directive_decl] = STATE(901),
    [sym_preproc_line] = STATE(901),
    [aux_sym__compound_type_repeat1] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LT2] = ACTIONS(3226),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [902] = {
    [sym_type_arguments] = STATE(970),
    [sym_long_identifier] = STATE(985),
    [sym_xml_doc] = STATE(902),
    [sym_block_comment] = STATE(902),
    [sym_line_comment] = STATE(902),
    [sym_compiler_directive_decl] = STATE(902),
    [sym_fsi_directive_decl] = STATE(902),
    [sym_preproc_line] = STATE(902),
    [aux_sym__compound_type_repeat1] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(3156),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_module] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_open] = ACTIONS(3154),
    [anon_sym_LBRACK_LT] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_type] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LT2] = ACTIONS(3226),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3156),
    [anon_sym_POUNDload] = ACTIONS(3156),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [903] = {
    [sym_type_arguments] = STATE(970),
    [sym_long_identifier] = STATE(985),
    [sym_xml_doc] = STATE(903),
    [sym_block_comment] = STATE(903),
    [sym_line_comment] = STATE(903),
    [sym_compiler_directive_decl] = STATE(903),
    [sym_fsi_directive_decl] = STATE(903),
    [sym_preproc_line] = STATE(903),
    [aux_sym__compound_type_repeat1] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_open] = ACTIONS(3012),
    [anon_sym_LBRACK_LT] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LT2] = ACTIONS(3226),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3010),
    [anon_sym_POUNDload] = ACTIONS(3010),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [904] = {
    [sym_xml_doc] = STATE(904),
    [sym_block_comment] = STATE(904),
    [sym_line_comment] = STATE(904),
    [sym_compiler_directive_decl] = STATE(904),
    [sym_fsi_directive_decl] = STATE(904),
    [sym_preproc_line] = STATE(904),
    [aux_sym_type_argument_repeat1] = STATE(913),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_GT_RBRACK] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_RBRACK] = ACTIONS(3232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_to] = ACTIONS(3230),
    [anon_sym_downto] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_end] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_DOT_DOT2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [905] = {
    [sym_xml_doc] = STATE(905),
    [sym_block_comment] = STATE(905),
    [sym_line_comment] = STATE(905),
    [sym_compiler_directive_decl] = STATE(905),
    [sym_fsi_directive_decl] = STATE(905),
    [sym_preproc_line] = STATE(905),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_AT_GT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3062),
    [anon_sym_uy] = ACTIONS(3064),
    [anon_sym_s] = ACTIONS(3066),
    [anon_sym_us] = ACTIONS(3068),
    [anon_sym_l] = ACTIONS(3070),
    [aux_sym_uint32_token1] = ACTIONS(3072),
    [anon_sym_n] = ACTIONS(3074),
    [anon_sym_un] = ACTIONS(3076),
    [anon_sym_L] = ACTIONS(3078),
    [aux_sym_uint64_token1] = ACTIONS(3080),
    [anon_sym_lf] = ACTIONS(3234),
    [anon_sym_LF] = ACTIONS(3236),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [906] = {
    [sym_xml_doc] = STATE(906),
    [sym_block_comment] = STATE(906),
    [sym_line_comment] = STATE(906),
    [sym_compiler_directive_decl] = STATE(906),
    [sym_fsi_directive_decl] = STATE(906),
    [sym_preproc_line] = STATE(906),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(3158),
    [anon_sym_uy] = ACTIONS(3160),
    [anon_sym_s] = ACTIONS(3162),
    [anon_sym_us] = ACTIONS(3164),
    [anon_sym_l] = ACTIONS(3166),
    [aux_sym_uint32_token1] = ACTIONS(3168),
    [anon_sym_n] = ACTIONS(3170),
    [anon_sym_un] = ACTIONS(3172),
    [anon_sym_L] = ACTIONS(3174),
    [aux_sym_uint64_token1] = ACTIONS(3176),
    [anon_sym_lf] = ACTIONS(3238),
    [anon_sym_LF] = ACTIONS(3240),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [907] = {
    [sym_xml_doc] = STATE(907),
    [sym_block_comment] = STATE(907),
    [sym_line_comment] = STATE(907),
    [sym_compiler_directive_decl] = STATE(907),
    [sym_fsi_directive_decl] = STATE(907),
    [sym_preproc_line] = STATE(907),
    [aux_sym_type_argument_repeat1] = STATE(904),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_GT_RBRACK] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_RBRACK] = ACTIONS(3244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_to] = ACTIONS(3242),
    [anon_sym_downto] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_end] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_DOT_DOT2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3246),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [908] = {
    [sym__else_expression] = STATE(1179),
    [sym_elif_expression] = STATE(1000),
    [sym_xml_doc] = STATE(908),
    [sym_block_comment] = STATE(908),
    [sym_line_comment] = STATE(908),
    [sym_compiler_directive_decl] = STATE(908),
    [sym_fsi_directive_decl] = STATE(908),
    [sym_preproc_line] = STATE(908),
    [aux_sym_if_expression_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_GT_RBRACK] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_RBRACK] = ACTIONS(3251),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_to] = ACTIONS(3249),
    [anon_sym_downto] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_elif] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_end] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_DOT_DOT2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [909] = {
    [sym_type_arguments] = STATE(970),
    [sym_long_identifier] = STATE(985),
    [sym_xml_doc] = STATE(909),
    [sym_block_comment] = STATE(909),
    [sym_line_comment] = STATE(909),
    [sym_compiler_directive_decl] = STATE(909),
    [sym_fsi_directive_decl] = STATE(909),
    [sym_preproc_line] = STATE(909),
    [aux_sym__compound_type_repeat1] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_module] = ACTIONS(3024),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_open] = ACTIONS(3024),
    [anon_sym_LBRACK_LT] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_type] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LT2] = ACTIONS(3226),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3228),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3022),
    [anon_sym_POUNDload] = ACTIONS(3022),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [910] = {
    [sym_xml_doc] = STATE(910),
    [sym_block_comment] = STATE(910),
    [sym_line_comment] = STATE(910),
    [sym_compiler_directive_decl] = STATE(910),
    [sym_fsi_directive_decl] = STATE(910),
    [sym_preproc_line] = STATE(910),
    [aux_sym_long_identifier_repeat1] = STATE(896),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_GT_RBRACK] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_RBRACK] = ACTIONS(3259),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_to] = ACTIONS(3257),
    [anon_sym_downto] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_end] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_DOT_DOT2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [911] = {
    [sym_xml_doc] = STATE(911),
    [sym_block_comment] = STATE(911),
    [sym_line_comment] = STATE(911),
    [sym_compiler_directive_decl] = STATE(911),
    [sym_fsi_directive_decl] = STATE(911),
    [sym_preproc_line] = STATE(911),
    [aux_sym_long_identifier_repeat1] = STATE(896),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_GT_RBRACK] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3264),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_to] = ACTIONS(3261),
    [anon_sym_downto] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_end] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_DOT_DOT2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [912] = {
    [sym_xml_doc] = STATE(912),
    [sym_block_comment] = STATE(912),
    [sym_line_comment] = STATE(912),
    [sym_compiler_directive_decl] = STATE(912),
    [sym_fsi_directive_decl] = STATE(912),
    [sym_preproc_line] = STATE(912),
    [aux_sym__compound_type_repeat1] = STATE(912),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_GT_RBRACK] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_RBRACK] = ACTIONS(3030),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_to] = ACTIONS(3032),
    [anon_sym_downto] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_end] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_DOT_DOT2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3271),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [913] = {
    [sym_xml_doc] = STATE(913),
    [sym_block_comment] = STATE(913),
    [sym_line_comment] = STATE(913),
    [sym_compiler_directive_decl] = STATE(913),
    [sym_fsi_directive_decl] = STATE(913),
    [sym_preproc_line] = STATE(913),
    [aux_sym_type_argument_repeat1] = STATE(913),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_GT_RBRACK] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_RBRACK] = ACTIONS(3276),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_to] = ACTIONS(3274),
    [anon_sym_downto] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_end] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_DOT_DOT2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3278),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [914] = {
    [sym__else_expression] = STATE(1160),
    [sym_elif_expression] = STATE(1000),
    [sym_xml_doc] = STATE(914),
    [sym_block_comment] = STATE(914),
    [sym_line_comment] = STATE(914),
    [sym_compiler_directive_decl] = STATE(914),
    [sym_fsi_directive_decl] = STATE(914),
    [sym_preproc_line] = STATE(914),
    [aux_sym_if_expression_repeat1] = STATE(931),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_GT_RBRACK] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_RBRACK] = ACTIONS(3283),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_to] = ACTIONS(3281),
    [anon_sym_downto] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_elif] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_end] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_DOT_DOT2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [915] = {
    [sym_xml_doc] = STATE(915),
    [sym_block_comment] = STATE(915),
    [sym_line_comment] = STATE(915),
    [sym_compiler_directive_decl] = STATE(915),
    [sym_fsi_directive_decl] = STATE(915),
    [sym_preproc_line] = STATE(915),
    [aux_sym_long_identifier_repeat1] = STATE(915),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_GT_RBRACK] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_to] = ACTIONS(3285),
    [anon_sym_downto] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_end] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [916] = {
    [sym_xml_doc] = STATE(916),
    [sym_block_comment] = STATE(916),
    [sym_line_comment] = STATE(916),
    [sym_compiler_directive_decl] = STATE(916),
    [sym_fsi_directive_decl] = STATE(916),
    [sym_preproc_line] = STATE(916),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_GT_RBRACK] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_RBRACK] = ACTIONS(3294),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_to] = ACTIONS(3292),
    [anon_sym_downto] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_end] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_DOT_DOT2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [917] = {
    [sym_xml_doc] = STATE(917),
    [sym_block_comment] = STATE(917),
    [sym_line_comment] = STATE(917),
    [sym_compiler_directive_decl] = STATE(917),
    [sym_fsi_directive_decl] = STATE(917),
    [sym_preproc_line] = STATE(917),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_GT_RBRACK] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_RBRACK] = ACTIONS(3298),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_to] = ACTIONS(3296),
    [anon_sym_downto] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_end] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_DOT_DOT2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [918] = {
    [sym_xml_doc] = STATE(918),
    [sym_block_comment] = STATE(918),
    [sym_line_comment] = STATE(918),
    [sym_compiler_directive_decl] = STATE(918),
    [sym_fsi_directive_decl] = STATE(918),
    [sym_preproc_line] = STATE(918),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_GT_RBRACK] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_RBRACK] = ACTIONS(3302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_to] = ACTIONS(3300),
    [anon_sym_downto] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_end] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_DOT_DOT2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [919] = {
    [sym_xml_doc] = STATE(919),
    [sym_block_comment] = STATE(919),
    [sym_line_comment] = STATE(919),
    [sym_compiler_directive_decl] = STATE(919),
    [sym_fsi_directive_decl] = STATE(919),
    [sym_preproc_line] = STATE(919),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_GT_RBRACK] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_RBRACK] = ACTIONS(3306),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_to] = ACTIONS(3304),
    [anon_sym_downto] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_end] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_DOT_DOT2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [920] = {
    [sym_xml_doc] = STATE(920),
    [sym_block_comment] = STATE(920),
    [sym_line_comment] = STATE(920),
    [sym_compiler_directive_decl] = STATE(920),
    [sym_fsi_directive_decl] = STATE(920),
    [sym_preproc_line] = STATE(920),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_GT_RBRACK] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_to] = ACTIONS(3308),
    [anon_sym_downto] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_end] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_DOT_DOT2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [921] = {
    [sym_xml_doc] = STATE(921),
    [sym_block_comment] = STATE(921),
    [sym_line_comment] = STATE(921),
    [sym_compiler_directive_decl] = STATE(921),
    [sym_fsi_directive_decl] = STATE(921),
    [sym_preproc_line] = STATE(921),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_GT_RBRACK] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_to] = ACTIONS(3285),
    [anon_sym_downto] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_end] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [922] = {
    [sym_xml_doc] = STATE(922),
    [sym_block_comment] = STATE(922),
    [sym_line_comment] = STATE(922),
    [sym_compiler_directive_decl] = STATE(922),
    [sym_fsi_directive_decl] = STATE(922),
    [sym_preproc_line] = STATE(922),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_GT_RBRACK] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_RBRACK] = ACTIONS(3312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_to] = ACTIONS(3314),
    [anon_sym_downto] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_end] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_DOT_DOT2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [923] = {
    [sym_xml_doc] = STATE(923),
    [sym_block_comment] = STATE(923),
    [sym_line_comment] = STATE(923),
    [sym_compiler_directive_decl] = STATE(923),
    [sym_fsi_directive_decl] = STATE(923),
    [sym_preproc_line] = STATE(923),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_GT_RBRACK] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_RBRACK] = ACTIONS(3320),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_to] = ACTIONS(3318),
    [anon_sym_downto] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_end] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_DOT_DOT2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [924] = {
    [sym_xml_doc] = STATE(924),
    [sym_block_comment] = STATE(924),
    [sym_line_comment] = STATE(924),
    [sym_compiler_directive_decl] = STATE(924),
    [sym_fsi_directive_decl] = STATE(924),
    [sym_preproc_line] = STATE(924),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_GT_RBRACK] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_RBRACK] = ACTIONS(3324),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_to] = ACTIONS(3322),
    [anon_sym_downto] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_end] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_DOT_DOT2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [925] = {
    [sym_xml_doc] = STATE(925),
    [sym_block_comment] = STATE(925),
    [sym_line_comment] = STATE(925),
    [sym_compiler_directive_decl] = STATE(925),
    [sym_fsi_directive_decl] = STATE(925),
    [sym_preproc_line] = STATE(925),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_GT_RBRACK] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_RBRACK] = ACTIONS(3276),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_to] = ACTIONS(3274),
    [anon_sym_downto] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_end] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_DOT_DOT2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [926] = {
    [sym_type_arguments] = STATE(1024),
    [sym_long_identifier] = STATE(1038),
    [sym_xml_doc] = STATE(926),
    [sym_block_comment] = STATE(926),
    [sym_line_comment] = STATE(926),
    [sym_compiler_directive_decl] = STATE(926),
    [sym_fsi_directive_decl] = STATE(926),
    [sym_preproc_line] = STATE(926),
    [aux_sym__compound_type_repeat1] = STATE(959),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3024),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_open] = ACTIONS(3024),
    [anon_sym_LBRACK_LT] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_type] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LT2] = ACTIONS(3332),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3334),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3022),
    [anon_sym_POUNDload] = ACTIONS(3022),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
    [sym__dedent] = ACTIONS(3022),
  },
  [927] = {
    [sym_xml_doc] = STATE(927),
    [sym_block_comment] = STATE(927),
    [sym_line_comment] = STATE(927),
    [sym_compiler_directive_decl] = STATE(927),
    [sym_fsi_directive_decl] = STATE(927),
    [sym_preproc_line] = STATE(927),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_GT_RBRACK] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3338),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_to] = ACTIONS(3336),
    [anon_sym_downto] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_end] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_DOT_DOT2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [928] = {
    [sym_xml_doc] = STATE(928),
    [sym_block_comment] = STATE(928),
    [sym_line_comment] = STATE(928),
    [sym_compiler_directive_decl] = STATE(928),
    [sym_fsi_directive_decl] = STATE(928),
    [sym_preproc_line] = STATE(928),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_GT_RBRACK] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_RBRACK] = ACTIONS(3342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_to] = ACTIONS(3340),
    [anon_sym_downto] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_end] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_DOT_DOT2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [929] = {
    [sym_type_arguments] = STATE(1024),
    [sym_long_identifier] = STATE(1038),
    [sym_xml_doc] = STATE(929),
    [sym_block_comment] = STATE(929),
    [sym_line_comment] = STATE(929),
    [sym_compiler_directive_decl] = STATE(929),
    [sym_fsi_directive_decl] = STATE(929),
    [sym_preproc_line] = STATE(929),
    [aux_sym__compound_type_repeat1] = STATE(959),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_open] = ACTIONS(3012),
    [anon_sym_LBRACK_LT] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LT2] = ACTIONS(3332),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3334),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3010),
    [anon_sym_POUNDload] = ACTIONS(3010),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
    [sym__dedent] = ACTIONS(3010),
  },
  [930] = {
    [sym_xml_doc] = STATE(930),
    [sym_block_comment] = STATE(930),
    [sym_line_comment] = STATE(930),
    [sym_compiler_directive_decl] = STATE(930),
    [sym_fsi_directive_decl] = STATE(930),
    [sym_preproc_line] = STATE(930),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_GT_RBRACK] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_RBRACK] = ACTIONS(3244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_to] = ACTIONS(3242),
    [anon_sym_downto] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_end] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_DOT_DOT2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [931] = {
    [sym_elif_expression] = STATE(1000),
    [sym_xml_doc] = STATE(931),
    [sym_block_comment] = STATE(931),
    [sym_line_comment] = STATE(931),
    [sym_compiler_directive_decl] = STATE(931),
    [sym_fsi_directive_decl] = STATE(931),
    [sym_preproc_line] = STATE(931),
    [aux_sym_if_expression_repeat1] = STATE(931),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_GT_RBRACK] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_RBRACK] = ACTIONS(3346),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_to] = ACTIONS(3344),
    [anon_sym_downto] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_end] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_DOT_DOT2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [932] = {
    [sym_type_arguments] = STATE(1024),
    [sym_long_identifier] = STATE(1038),
    [sym_xml_doc] = STATE(932),
    [sym_block_comment] = STATE(932),
    [sym_line_comment] = STATE(932),
    [sym_compiler_directive_decl] = STATE(932),
    [sym_fsi_directive_decl] = STATE(932),
    [sym_preproc_line] = STATE(932),
    [aux_sym__compound_type_repeat1] = STATE(959),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_module] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_open] = ACTIONS(3154),
    [anon_sym_LBRACK_LT] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_type] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LT2] = ACTIONS(3332),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3334),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3156),
    [anon_sym_POUNDload] = ACTIONS(3156),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
    [sym__dedent] = ACTIONS(3156),
  },
  [933] = {
    [sym_type_arguments] = STATE(1024),
    [sym_long_identifier] = STATE(1038),
    [sym_xml_doc] = STATE(933),
    [sym_block_comment] = STATE(933),
    [sym_line_comment] = STATE(933),
    [sym_compiler_directive_decl] = STATE(933),
    [sym_fsi_directive_decl] = STATE(933),
    [sym_preproc_line] = STATE(933),
    [aux_sym__compound_type_repeat1] = STATE(959),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_open] = ACTIONS(3092),
    [anon_sym_LBRACK_LT] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_type] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LT2] = ACTIONS(3332),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3334),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3090),
    [anon_sym_POUNDload] = ACTIONS(3090),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
    [sym__dedent] = ACTIONS(3090),
  },
  [934] = {
    [sym_xml_doc] = STATE(934),
    [sym_block_comment] = STATE(934),
    [sym_line_comment] = STATE(934),
    [sym_compiler_directive_decl] = STATE(934),
    [sym_fsi_directive_decl] = STATE(934),
    [sym_preproc_line] = STATE(934),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_GT_RBRACK] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_RBRACK] = ACTIONS(3353),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_to] = ACTIONS(3351),
    [anon_sym_downto] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_end] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_DOT_DOT2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [935] = {
    [sym_xml_doc] = STATE(935),
    [sym_block_comment] = STATE(935),
    [sym_line_comment] = STATE(935),
    [sym_compiler_directive_decl] = STATE(935),
    [sym_fsi_directive_decl] = STATE(935),
    [sym_preproc_line] = STATE(935),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_GT_RBRACK] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_RBRACK] = ACTIONS(3357),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_to] = ACTIONS(3355),
    [anon_sym_downto] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_end] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_DOT_DOT2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(3359),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [936] = {
    [sym_xml_doc] = STATE(936),
    [sym_block_comment] = STATE(936),
    [sym_line_comment] = STATE(936),
    [sym_compiler_directive_decl] = STATE(936),
    [sym_fsi_directive_decl] = STATE(936),
    [sym_preproc_line] = STATE(936),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_GT_RBRACK] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_RBRACK] = ACTIONS(3353),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_to] = ACTIONS(3351),
    [anon_sym_downto] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_end] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_DOT_DOT2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [937] = {
    [sym_type_arguments] = STATE(1024),
    [sym_long_identifier] = STATE(1038),
    [sym_xml_doc] = STATE(937),
    [sym_block_comment] = STATE(937),
    [sym_line_comment] = STATE(937),
    [sym_compiler_directive_decl] = STATE(937),
    [sym_fsi_directive_decl] = STATE(937),
    [sym_preproc_line] = STATE(937),
    [aux_sym__compound_type_repeat1] = STATE(959),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LT2] = ACTIONS(3332),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3334),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [938] = {
    [sym_xml_doc] = STATE(938),
    [sym_block_comment] = STATE(938),
    [sym_line_comment] = STATE(938),
    [sym_compiler_directive_decl] = STATE(938),
    [sym_fsi_directive_decl] = STATE(938),
    [sym_preproc_line] = STATE(938),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_GT_RBRACK] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_RBRACK] = ACTIONS(3363),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_to] = ACTIONS(3361),
    [anon_sym_downto] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_end] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_DOT_DOT2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [939] = {
    [sym_xml_doc] = STATE(939),
    [sym_block_comment] = STATE(939),
    [sym_line_comment] = STATE(939),
    [sym_compiler_directive_decl] = STATE(939),
    [sym_fsi_directive_decl] = STATE(939),
    [sym_preproc_line] = STATE(939),
    [aux_sym_long_identifier_repeat1] = STATE(947),
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_namespace] = ACTIONS(3261),
    [anon_sym_module] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_open] = ACTIONS(3261),
    [anon_sym_LBRACK_LT] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3365),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3264),
    [anon_sym_POUNDload] = ACTIONS(3264),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [940] = {
    [sym_xml_doc] = STATE(940),
    [sym_block_comment] = STATE(940),
    [sym_line_comment] = STATE(940),
    [sym_compiler_directive_decl] = STATE(940),
    [sym_fsi_directive_decl] = STATE(940),
    [sym_preproc_line] = STATE(940),
    [aux_sym_type_argument_repeat1] = STATE(944),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3369),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [941] = {
    [sym_xml_doc] = STATE(941),
    [sym_block_comment] = STATE(941),
    [sym_line_comment] = STATE(941),
    [sym_compiler_directive_decl] = STATE(941),
    [sym_fsi_directive_decl] = STATE(941),
    [sym_preproc_line] = STATE(941),
    [aux_sym_long_identifier_repeat1] = STATE(941),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [942] = {
    [sym_xml_doc] = STATE(942),
    [sym_block_comment] = STATE(942),
    [sym_line_comment] = STATE(942),
    [sym_compiler_directive_decl] = STATE(942),
    [sym_fsi_directive_decl] = STATE(942),
    [sym_preproc_line] = STATE(942),
    [aux_sym_type_argument_repeat1] = STATE(942),
    [ts_builtin_sym_end] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3375),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [943] = {
    [sym_xml_doc] = STATE(943),
    [sym_block_comment] = STATE(943),
    [sym_line_comment] = STATE(943),
    [sym_compiler_directive_decl] = STATE(943),
    [sym_fsi_directive_decl] = STATE(943),
    [sym_preproc_line] = STATE(943),
    [aux_sym__compound_type_repeat1] = STATE(946),
    [ts_builtin_sym_end] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_open] = ACTIONS(3212),
    [anon_sym_LBRACK_LT] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3214),
    [anon_sym_POUNDload] = ACTIONS(3214),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [944] = {
    [sym_xml_doc] = STATE(944),
    [sym_block_comment] = STATE(944),
    [sym_line_comment] = STATE(944),
    [sym_compiler_directive_decl] = STATE(944),
    [sym_fsi_directive_decl] = STATE(944),
    [sym_preproc_line] = STATE(944),
    [aux_sym_type_argument_repeat1] = STATE(942),
    [ts_builtin_sym_end] = ACTIONS(3232),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_open] = ACTIONS(3230),
    [anon_sym_LBRACK_LT] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3232),
    [anon_sym_POUNDload] = ACTIONS(3232),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [945] = {
    [sym__else_expression] = STATE(1372),
    [sym_elif_expression] = STATE(1158),
    [sym_xml_doc] = STATE(945),
    [sym_block_comment] = STATE(945),
    [sym_line_comment] = STATE(945),
    [sym_compiler_directive_decl] = STATE(945),
    [sym_fsi_directive_decl] = STATE(945),
    [sym_preproc_line] = STATE(945),
    [aux_sym_if_expression_repeat1] = STATE(950),
    [ts_builtin_sym_end] = ACTIONS(3251),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_open] = ACTIONS(3249),
    [anon_sym_LBRACK_LT] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_elif] = ACTIONS(3380),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3251),
    [anon_sym_POUNDload] = ACTIONS(3251),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [946] = {
    [sym_xml_doc] = STATE(946),
    [sym_block_comment] = STATE(946),
    [sym_line_comment] = STATE(946),
    [sym_compiler_directive_decl] = STATE(946),
    [sym_fsi_directive_decl] = STATE(946),
    [sym_preproc_line] = STATE(946),
    [aux_sym__compound_type_repeat1] = STATE(946),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3382),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [947] = {
    [sym_xml_doc] = STATE(947),
    [sym_block_comment] = STATE(947),
    [sym_line_comment] = STATE(947),
    [sym_compiler_directive_decl] = STATE(947),
    [sym_fsi_directive_decl] = STATE(947),
    [sym_preproc_line] = STATE(947),
    [aux_sym_long_identifier_repeat1] = STATE(941),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3385),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [948] = {
    [sym_xml_doc] = STATE(948),
    [sym_block_comment] = STATE(948),
    [sym_line_comment] = STATE(948),
    [sym_compiler_directive_decl] = STATE(948),
    [sym_fsi_directive_decl] = STATE(948),
    [sym_preproc_line] = STATE(948),
    [aux_sym_long_identifier_repeat1] = STATE(947),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3385),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [949] = {
    [sym_xml_doc] = STATE(949),
    [sym_block_comment] = STATE(949),
    [sym_line_comment] = STATE(949),
    [sym_compiler_directive_decl] = STATE(949),
    [sym_fsi_directive_decl] = STATE(949),
    [sym_preproc_line] = STATE(949),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_GT_RBRACK] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_RBRACK] = ACTIONS(3389),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_to] = ACTIONS(3387),
    [anon_sym_downto] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_end] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_DOT_DOT2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(3391),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [950] = {
    [sym__else_expression] = STATE(1423),
    [sym_elif_expression] = STATE(1158),
    [sym_xml_doc] = STATE(950),
    [sym_block_comment] = STATE(950),
    [sym_line_comment] = STATE(950),
    [sym_compiler_directive_decl] = STATE(950),
    [sym_fsi_directive_decl] = STATE(950),
    [sym_preproc_line] = STATE(950),
    [aux_sym_if_expression_repeat1] = STATE(955),
    [ts_builtin_sym_end] = ACTIONS(3283),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_open] = ACTIONS(3281),
    [anon_sym_LBRACK_LT] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3378),
    [anon_sym_elif] = ACTIONS(3380),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3283),
    [anon_sym_POUNDload] = ACTIONS(3283),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [951] = {
    [sym_xml_doc] = STATE(951),
    [sym_block_comment] = STATE(951),
    [sym_line_comment] = STATE(951),
    [sym_compiler_directive_decl] = STATE(951),
    [sym_fsi_directive_decl] = STATE(951),
    [sym_preproc_line] = STATE(951),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_namespace] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_open] = ACTIONS(3300),
    [anon_sym_LBRACK_LT] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3302),
    [anon_sym_POUNDload] = ACTIONS(3302),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [952] = {
    [sym_xml_doc] = STATE(952),
    [sym_block_comment] = STATE(952),
    [sym_line_comment] = STATE(952),
    [sym_compiler_directive_decl] = STATE(952),
    [sym_fsi_directive_decl] = STATE(952),
    [sym_preproc_line] = STATE(952),
    [aux_sym_type_argument_repeat1] = STATE(994),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_open] = ACTIONS(3230),
    [anon_sym_LBRACK_LT] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3232),
    [anon_sym_POUNDload] = ACTIONS(3232),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
    [sym__dedent] = ACTIONS(3232),
  },
  [953] = {
    [sym_type_arguments] = STATE(1250),
    [sym_long_identifier] = STATE(1206),
    [sym_xml_doc] = STATE(953),
    [sym_block_comment] = STATE(953),
    [sym_line_comment] = STATE(953),
    [sym_compiler_directive_decl] = STATE(953),
    [sym_fsi_directive_decl] = STATE(953),
    [sym_preproc_line] = STATE(953),
    [aux_sym__compound_type_repeat1] = STATE(1150),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_DOT_DOT2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_LT2] = ACTIONS(3397),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3399),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
    [sym__dedent] = ACTIONS(3156),
  },
  [954] = {
    [sym_xml_doc] = STATE(954),
    [sym_block_comment] = STATE(954),
    [sym_line_comment] = STATE(954),
    [sym_compiler_directive_decl] = STATE(954),
    [sym_fsi_directive_decl] = STATE(954),
    [sym_preproc_line] = STATE(954),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_GT_RBRACK] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_RBRACK] = ACTIONS(3389),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_to] = ACTIONS(3387),
    [anon_sym_downto] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_end] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_DOT_DOT2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [955] = {
    [sym_elif_expression] = STATE(1158),
    [sym_xml_doc] = STATE(955),
    [sym_block_comment] = STATE(955),
    [sym_line_comment] = STATE(955),
    [sym_compiler_directive_decl] = STATE(955),
    [sym_fsi_directive_decl] = STATE(955),
    [sym_preproc_line] = STATE(955),
    [aux_sym_if_expression_repeat1] = STATE(955),
    [ts_builtin_sym_end] = ACTIONS(3346),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_module] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_open] = ACTIONS(3344),
    [anon_sym_LBRACK_LT] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_type] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3346),
    [anon_sym_POUNDload] = ACTIONS(3346),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [956] = {
    [sym_xml_doc] = STATE(956),
    [sym_block_comment] = STATE(956),
    [sym_line_comment] = STATE(956),
    [sym_compiler_directive_decl] = STATE(956),
    [sym_fsi_directive_decl] = STATE(956),
    [sym_preproc_line] = STATE(956),
    [aux_sym_rules_repeat1] = STATE(974),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_GT_RBRACK] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_RBRACK] = ACTIONS(3406),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_with] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_to] = ACTIONS(3404),
    [anon_sym_downto] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_end] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_DOT_DOT2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(3410),
  },
  [957] = {
    [sym__else_expression] = STATE(1669),
    [sym_elif_expression] = STATE(1192),
    [sym_xml_doc] = STATE(957),
    [sym_block_comment] = STATE(957),
    [sym_line_comment] = STATE(957),
    [sym_compiler_directive_decl] = STATE(957),
    [sym_fsi_directive_decl] = STATE(957),
    [sym_preproc_line] = STATE(957),
    [aux_sym_if_expression_repeat1] = STATE(1043),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_open] = ACTIONS(3281),
    [anon_sym_LBRACK_LT] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_elif] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3283),
    [anon_sym_POUNDload] = ACTIONS(3283),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
    [sym__dedent] = ACTIONS(3283),
  },
  [958] = {
    [sym_xml_doc] = STATE(958),
    [sym_block_comment] = STATE(958),
    [sym_line_comment] = STATE(958),
    [sym_compiler_directive_decl] = STATE(958),
    [sym_fsi_directive_decl] = STATE(958),
    [sym_preproc_line] = STATE(958),
    [ts_builtin_sym_end] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_open] = ACTIONS(3361),
    [anon_sym_LBRACK_LT] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3363),
    [anon_sym_POUNDload] = ACTIONS(3363),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [959] = {
    [sym_xml_doc] = STATE(959),
    [sym_block_comment] = STATE(959),
    [sym_line_comment] = STATE(959),
    [sym_compiler_directive_decl] = STATE(959),
    [sym_fsi_directive_decl] = STATE(959),
    [sym_preproc_line] = STATE(959),
    [aux_sym__compound_type_repeat1] = STATE(965),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_open] = ACTIONS(3212),
    [anon_sym_LBRACK_LT] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3214),
    [anon_sym_POUNDload] = ACTIONS(3214),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
    [sym__dedent] = ACTIONS(3214),
  },
  [960] = {
    [sym_xml_doc] = STATE(960),
    [sym_block_comment] = STATE(960),
    [sym_line_comment] = STATE(960),
    [sym_compiler_directive_decl] = STATE(960),
    [sym_fsi_directive_decl] = STATE(960),
    [sym_preproc_line] = STATE(960),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_GT_RBRACK] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_RBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_to] = ACTIONS(3417),
    [anon_sym_downto] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_end] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_DOT_DOT2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(3421),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [961] = {
    [sym_type_arguments] = STATE(1248),
    [sym_long_identifier] = STATE(1191),
    [sym_xml_doc] = STATE(961),
    [sym_block_comment] = STATE(961),
    [sym_line_comment] = STATE(961),
    [sym_compiler_directive_decl] = STATE(961),
    [sym_fsi_directive_decl] = STATE(961),
    [sym_preproc_line] = STATE(961),
    [aux_sym__compound_type_repeat1] = STATE(1062),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3154),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3429),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
    [sym__dedent] = ACTIONS(3156),
  },
  [962] = {
    [sym_type_arguments] = STATE(1250),
    [sym_long_identifier] = STATE(1206),
    [sym_xml_doc] = STATE(962),
    [sym_block_comment] = STATE(962),
    [sym_line_comment] = STATE(962),
    [sym_compiler_directive_decl] = STATE(962),
    [sym_fsi_directive_decl] = STATE(962),
    [sym_preproc_line] = STATE(962),
    [aux_sym__compound_type_repeat1] = STATE(1150),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_DOT_DOT2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_LT2] = ACTIONS(3397),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3399),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
    [sym__dedent] = ACTIONS(3010),
  },
  [963] = {
    [sym_xml_doc] = STATE(963),
    [sym_block_comment] = STATE(963),
    [sym_line_comment] = STATE(963),
    [sym_compiler_directive_decl] = STATE(963),
    [sym_fsi_directive_decl] = STATE(963),
    [sym_preproc_line] = STATE(963),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [964] = {
    [sym_type_arguments] = STATE(1250),
    [sym_long_identifier] = STATE(1206),
    [sym_xml_doc] = STATE(964),
    [sym_block_comment] = STATE(964),
    [sym_line_comment] = STATE(964),
    [sym_compiler_directive_decl] = STATE(964),
    [sym_fsi_directive_decl] = STATE(964),
    [sym_preproc_line] = STATE(964),
    [aux_sym__compound_type_repeat1] = STATE(1150),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_DOT_DOT2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_LT2] = ACTIONS(3397),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3399),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [965] = {
    [sym_xml_doc] = STATE(965),
    [sym_block_comment] = STATE(965),
    [sym_line_comment] = STATE(965),
    [sym_compiler_directive_decl] = STATE(965),
    [sym_fsi_directive_decl] = STATE(965),
    [sym_preproc_line] = STATE(965),
    [aux_sym__compound_type_repeat1] = STATE(965),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [966] = {
    [sym_xml_doc] = STATE(966),
    [sym_block_comment] = STATE(966),
    [sym_line_comment] = STATE(966),
    [sym_compiler_directive_decl] = STATE(966),
    [sym_fsi_directive_decl] = STATE(966),
    [sym_preproc_line] = STATE(966),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_GT_RBRACK] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_to] = ACTIONS(2768),
    [anon_sym_downto] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_end] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(2828),
    [aux_sym_decimal_token1] = ACTIONS(2794),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [967] = {
    [sym_xml_doc] = STATE(967),
    [sym_block_comment] = STATE(967),
    [sym_line_comment] = STATE(967),
    [sym_compiler_directive_decl] = STATE(967),
    [sym_fsi_directive_decl] = STATE(967),
    [sym_preproc_line] = STATE(967),
    [ts_builtin_sym_end] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_open] = ACTIONS(3340),
    [anon_sym_LBRACK_LT] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3342),
    [anon_sym_POUNDload] = ACTIONS(3342),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [968] = {
    [sym_type_arguments] = STATE(1248),
    [sym_long_identifier] = STATE(1191),
    [sym_xml_doc] = STATE(968),
    [sym_block_comment] = STATE(968),
    [sym_line_comment] = STATE(968),
    [sym_compiler_directive_decl] = STATE(968),
    [sym_fsi_directive_decl] = STATE(968),
    [sym_preproc_line] = STATE(968),
    [aux_sym__compound_type_repeat1] = STATE(1062),
    [sym_identifier] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3429),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
    [sym__dedent] = ACTIONS(3022),
  },
  [969] = {
    [sym_type_arguments] = STATE(1250),
    [sym_long_identifier] = STATE(1206),
    [sym_xml_doc] = STATE(969),
    [sym_block_comment] = STATE(969),
    [sym_line_comment] = STATE(969),
    [sym_compiler_directive_decl] = STATE(969),
    [sym_fsi_directive_decl] = STATE(969),
    [sym_preproc_line] = STATE(969),
    [aux_sym__compound_type_repeat1] = STATE(1150),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_DOT_DOT2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_LT2] = ACTIONS(3397),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3399),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
    [sym__dedent] = ACTIONS(3090),
  },
  [970] = {
    [sym_xml_doc] = STATE(970),
    [sym_block_comment] = STATE(970),
    [sym_line_comment] = STATE(970),
    [sym_compiler_directive_decl] = STATE(970),
    [sym_fsi_directive_decl] = STATE(970),
    [sym_preproc_line] = STATE(970),
    [ts_builtin_sym_end] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_module] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_open] = ACTIONS(3336),
    [anon_sym_LBRACK_LT] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_type] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3338),
    [anon_sym_POUNDload] = ACTIONS(3338),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [971] = {
    [sym_xml_doc] = STATE(971),
    [sym_block_comment] = STATE(971),
    [sym_line_comment] = STATE(971),
    [sym_compiler_directive_decl] = STATE(971),
    [sym_fsi_directive_decl] = STATE(971),
    [sym_preproc_line] = STATE(971),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_GT_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_to] = ACTIONS(3438),
    [anon_sym_downto] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3438),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_end] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [972] = {
    [sym_xml_doc] = STATE(972),
    [sym_block_comment] = STATE(972),
    [sym_line_comment] = STATE(972),
    [sym_compiler_directive_decl] = STATE(972),
    [sym_fsi_directive_decl] = STATE(972),
    [sym_preproc_line] = STATE(972),
    [aux_sym_rules_repeat1] = STATE(986),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_GT_RBRACK] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_RBRACK] = ACTIONS(3444),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_to] = ACTIONS(3442),
    [anon_sym_downto] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_end] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_DOT_DOT2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(3446),
  },
  [973] = {
    [sym_xml_doc] = STATE(973),
    [sym_block_comment] = STATE(973),
    [sym_line_comment] = STATE(973),
    [sym_compiler_directive_decl] = STATE(973),
    [sym_fsi_directive_decl] = STATE(973),
    [sym_preproc_line] = STATE(973),
    [aux_sym_long_identifier_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3449),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [974] = {
    [sym_xml_doc] = STATE(974),
    [sym_block_comment] = STATE(974),
    [sym_line_comment] = STATE(974),
    [sym_compiler_directive_decl] = STATE(974),
    [sym_fsi_directive_decl] = STATE(974),
    [sym_preproc_line] = STATE(974),
    [aux_sym_rules_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_GT_RBRACK] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_RBRACK] = ACTIONS(3444),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_to] = ACTIONS(3442),
    [anon_sym_downto] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_end] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_DOT_DOT2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(3446),
  },
  [975] = {
    [sym__else_expression] = STATE(1654),
    [sym_elif_expression] = STATE(1192),
    [sym_xml_doc] = STATE(975),
    [sym_block_comment] = STATE(975),
    [sym_line_comment] = STATE(975),
    [sym_compiler_directive_decl] = STATE(975),
    [sym_fsi_directive_decl] = STATE(975),
    [sym_preproc_line] = STATE(975),
    [aux_sym_if_expression_repeat1] = STATE(957),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_open] = ACTIONS(3249),
    [anon_sym_LBRACK_LT] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_elif] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3251),
    [anon_sym_POUNDload] = ACTIONS(3251),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
    [sym__dedent] = ACTIONS(3251),
  },
  [976] = {
    [sym_xml_doc] = STATE(976),
    [sym_block_comment] = STATE(976),
    [sym_line_comment] = STATE(976),
    [sym_compiler_directive_decl] = STATE(976),
    [sym_fsi_directive_decl] = STATE(976),
    [sym_preproc_line] = STATE(976),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_GT_RBRACK] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_RBRACK] = ACTIONS(3453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_to] = ACTIONS(3451),
    [anon_sym_downto] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_end] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_DOT_DOT2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [977] = {
    [sym_xml_doc] = STATE(977),
    [sym_block_comment] = STATE(977),
    [sym_line_comment] = STATE(977),
    [sym_compiler_directive_decl] = STATE(977),
    [sym_fsi_directive_decl] = STATE(977),
    [sym_preproc_line] = STATE(977),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [978] = {
    [sym_xml_doc] = STATE(978),
    [sym_block_comment] = STATE(978),
    [sym_line_comment] = STATE(978),
    [sym_compiler_directive_decl] = STATE(978),
    [sym_fsi_directive_decl] = STATE(978),
    [sym_preproc_line] = STATE(978),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_GT_RBRACK] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_RBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_to] = ACTIONS(3455),
    [anon_sym_downto] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_end] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_DOT_DOT2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [979] = {
    [sym_xml_doc] = STATE(979),
    [sym_block_comment] = STATE(979),
    [sym_line_comment] = STATE(979),
    [sym_compiler_directive_decl] = STATE(979),
    [sym_fsi_directive_decl] = STATE(979),
    [sym_preproc_line] = STATE(979),
    [ts_builtin_sym_end] = ACTIONS(3357),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_open] = ACTIONS(3355),
    [anon_sym_LBRACK_LT] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(3459),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3357),
    [anon_sym_POUNDload] = ACTIONS(3357),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [980] = {
    [sym_xml_doc] = STATE(980),
    [sym_block_comment] = STATE(980),
    [sym_line_comment] = STATE(980),
    [sym_compiler_directive_decl] = STATE(980),
    [sym_fsi_directive_decl] = STATE(980),
    [sym_preproc_line] = STATE(980),
    [ts_builtin_sym_end] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [981] = {
    [sym_xml_doc] = STATE(981),
    [sym_block_comment] = STATE(981),
    [sym_line_comment] = STATE(981),
    [sym_compiler_directive_decl] = STATE(981),
    [sym_fsi_directive_decl] = STATE(981),
    [sym_preproc_line] = STATE(981),
    [ts_builtin_sym_end] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [982] = {
    [sym_xml_doc] = STATE(982),
    [sym_block_comment] = STATE(982),
    [sym_line_comment] = STATE(982),
    [sym_compiler_directive_decl] = STATE(982),
    [sym_fsi_directive_decl] = STATE(982),
    [sym_preproc_line] = STATE(982),
    [ts_builtin_sym_end] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [983] = {
    [sym_xml_doc] = STATE(983),
    [sym_block_comment] = STATE(983),
    [sym_line_comment] = STATE(983),
    [sym_compiler_directive_decl] = STATE(983),
    [sym_fsi_directive_decl] = STATE(983),
    [sym_preproc_line] = STATE(983),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_namespace] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_open] = ACTIONS(3304),
    [anon_sym_LBRACK_LT] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3306),
    [anon_sym_POUNDload] = ACTIONS(3306),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [984] = {
    [sym_xml_doc] = STATE(984),
    [sym_block_comment] = STATE(984),
    [sym_line_comment] = STATE(984),
    [sym_compiler_directive_decl] = STATE(984),
    [sym_fsi_directive_decl] = STATE(984),
    [sym_preproc_line] = STATE(984),
    [ts_builtin_sym_end] = ACTIONS(3324),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_open] = ACTIONS(3322),
    [anon_sym_LBRACK_LT] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3324),
    [anon_sym_POUNDload] = ACTIONS(3324),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [985] = {
    [sym_xml_doc] = STATE(985),
    [sym_block_comment] = STATE(985),
    [sym_line_comment] = STATE(985),
    [sym_compiler_directive_decl] = STATE(985),
    [sym_fsi_directive_decl] = STATE(985),
    [sym_preproc_line] = STATE(985),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_open] = ACTIONS(3296),
    [anon_sym_LBRACK_LT] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3298),
    [anon_sym_POUNDload] = ACTIONS(3298),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [986] = {
    [sym_xml_doc] = STATE(986),
    [sym_block_comment] = STATE(986),
    [sym_line_comment] = STATE(986),
    [sym_compiler_directive_decl] = STATE(986),
    [sym_fsi_directive_decl] = STATE(986),
    [sym_preproc_line] = STATE(986),
    [aux_sym_rules_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_GT_RBRACK] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_RBRACK] = ACTIONS(3465),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_RBRACE] = ACTIONS(3465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_with] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_to] = ACTIONS(3463),
    [anon_sym_downto] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_end] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_DOT_DOT2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(3467),
  },
  [987] = {
    [sym_xml_doc] = STATE(987),
    [sym_block_comment] = STATE(987),
    [sym_line_comment] = STATE(987),
    [sym_compiler_directive_decl] = STATE(987),
    [sym_fsi_directive_decl] = STATE(987),
    [sym_preproc_line] = STATE(987),
    [aux_sym_long_identifier_repeat1] = STATE(990),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3449),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [988] = {
    [sym_type_arguments] = STATE(1248),
    [sym_long_identifier] = STATE(1191),
    [sym_xml_doc] = STATE(988),
    [sym_block_comment] = STATE(988),
    [sym_line_comment] = STATE(988),
    [sym_compiler_directive_decl] = STATE(988),
    [sym_fsi_directive_decl] = STATE(988),
    [sym_preproc_line] = STATE(988),
    [aux_sym__compound_type_repeat1] = STATE(1062),
    [sym_identifier] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_as] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3429),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
    [sym__dedent] = ACTIONS(3010),
  },
  [989] = {
    [sym_xml_doc] = STATE(989),
    [sym_block_comment] = STATE(989),
    [sym_line_comment] = STATE(989),
    [sym_compiler_directive_decl] = STATE(989),
    [sym_fsi_directive_decl] = STATE(989),
    [sym_preproc_line] = STATE(989),
    [aux_sym_long_identifier_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_module] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_open] = ACTIONS(3261),
    [anon_sym_LBRACK_LT] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3264),
    [anon_sym_POUNDload] = ACTIONS(3264),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [990] = {
    [sym_xml_doc] = STATE(990),
    [sym_block_comment] = STATE(990),
    [sym_line_comment] = STATE(990),
    [sym_compiler_directive_decl] = STATE(990),
    [sym_fsi_directive_decl] = STATE(990),
    [sym_preproc_line] = STATE(990),
    [aux_sym_long_identifier_repeat1] = STATE(990),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [991] = {
    [sym_xml_doc] = STATE(991),
    [sym_block_comment] = STATE(991),
    [sym_line_comment] = STATE(991),
    [sym_compiler_directive_decl] = STATE(991),
    [sym_fsi_directive_decl] = STATE(991),
    [sym_preproc_line] = STATE(991),
    [aux_sym_type_argument_repeat1] = STATE(952),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3477),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [992] = {
    [sym_type_arguments] = STATE(1248),
    [sym_long_identifier] = STATE(1191),
    [sym_xml_doc] = STATE(992),
    [sym_block_comment] = STATE(992),
    [sym_line_comment] = STATE(992),
    [sym_compiler_directive_decl] = STATE(992),
    [sym_fsi_directive_decl] = STATE(992),
    [sym_preproc_line] = STATE(992),
    [aux_sym__compound_type_repeat1] = STATE(1062),
    [sym_identifier] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3429),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [993] = {
    [sym_xml_doc] = STATE(993),
    [sym_block_comment] = STATE(993),
    [sym_line_comment] = STATE(993),
    [sym_compiler_directive_decl] = STATE(993),
    [sym_fsi_directive_decl] = STATE(993),
    [sym_preproc_line] = STATE(993),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_GT_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_to] = ACTIONS(3438),
    [anon_sym_downto] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_end] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [994] = {
    [sym_xml_doc] = STATE(994),
    [sym_block_comment] = STATE(994),
    [sym_line_comment] = STATE(994),
    [sym_compiler_directive_decl] = STATE(994),
    [sym_fsi_directive_decl] = STATE(994),
    [sym_preproc_line] = STATE(994),
    [aux_sym_type_argument_repeat1] = STATE(994),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [995] = {
    [sym_xml_doc] = STATE(995),
    [sym_block_comment] = STATE(995),
    [sym_line_comment] = STATE(995),
    [sym_compiler_directive_decl] = STATE(995),
    [sym_fsi_directive_decl] = STATE(995),
    [sym_preproc_line] = STATE(995),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_open] = ACTIONS(3308),
    [anon_sym_LBRACK_LT] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3310),
    [anon_sym_POUNDload] = ACTIONS(3310),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [996] = {
    [sym_type_arguments] = STATE(1248),
    [sym_long_identifier] = STATE(1191),
    [sym_xml_doc] = STATE(996),
    [sym_block_comment] = STATE(996),
    [sym_line_comment] = STATE(996),
    [sym_compiler_directive_decl] = STATE(996),
    [sym_fsi_directive_decl] = STATE(996),
    [sym_preproc_line] = STATE(996),
    [aux_sym__compound_type_repeat1] = STATE(1062),
    [sym_identifier] = ACTIONS(3436),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_as] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3429),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
    [sym__dedent] = ACTIONS(3090),
  },
  [997] = {
    [sym_xml_doc] = STATE(997),
    [sym_block_comment] = STATE(997),
    [sym_line_comment] = STATE(997),
    [sym_compiler_directive_decl] = STATE(997),
    [sym_fsi_directive_decl] = STATE(997),
    [sym_preproc_line] = STATE(997),
    [ts_builtin_sym_end] = ACTIONS(3320),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_open] = ACTIONS(3318),
    [anon_sym_LBRACK_LT] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3320),
    [anon_sym_POUNDload] = ACTIONS(3320),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [998] = {
    [sym_xml_doc] = STATE(998),
    [sym_block_comment] = STATE(998),
    [sym_line_comment] = STATE(998),
    [sym_compiler_directive_decl] = STATE(998),
    [sym_fsi_directive_decl] = STATE(998),
    [sym_preproc_line] = STATE(998),
    [aux_sym_rules_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_to] = ACTIONS(3483),
    [anon_sym_downto] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_end] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3490),
  },
  [999] = {
    [sym_xml_doc] = STATE(999),
    [sym_block_comment] = STATE(999),
    [sym_line_comment] = STATE(999),
    [sym_compiler_directive_decl] = STATE(999),
    [sym_fsi_directive_decl] = STATE(999),
    [sym_preproc_line] = STATE(999),
    [ts_builtin_sym_end] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1000] = {
    [sym_xml_doc] = STATE(1000),
    [sym_block_comment] = STATE(1000),
    [sym_line_comment] = STATE(1000),
    [sym_compiler_directive_decl] = STATE(1000),
    [sym_fsi_directive_decl] = STATE(1000),
    [sym_preproc_line] = STATE(1000),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_GT_RBRACK] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_with] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_to] = ACTIONS(3493),
    [anon_sym_downto] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_end] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_DOT_DOT2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1001] = {
    [sym_xml_doc] = STATE(1001),
    [sym_block_comment] = STATE(1001),
    [sym_line_comment] = STATE(1001),
    [sym_compiler_directive_decl] = STATE(1001),
    [sym_fsi_directive_decl] = STATE(1001),
    [sym_preproc_line] = STATE(1001),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_namespace] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_open] = ACTIONS(3292),
    [anon_sym_LBRACK_LT] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3294),
    [anon_sym_POUNDload] = ACTIONS(3294),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1002] = {
    [sym_type_arguments] = STATE(1250),
    [sym_long_identifier] = STATE(1206),
    [sym_xml_doc] = STATE(1002),
    [sym_block_comment] = STATE(1002),
    [sym_line_comment] = STATE(1002),
    [sym_compiler_directive_decl] = STATE(1002),
    [sym_fsi_directive_decl] = STATE(1002),
    [sym_preproc_line] = STATE(1002),
    [aux_sym__compound_type_repeat1] = STATE(1150),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_DOT_DOT2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_LT2] = ACTIONS(3397),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3399),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
    [sym__dedent] = ACTIONS(3022),
  },
  [1003] = {
    [sym_type_arguments] = STATE(1461),
    [sym_long_identifier] = STATE(1376),
    [sym_xml_doc] = STATE(1003),
    [sym_block_comment] = STATE(1003),
    [sym_line_comment] = STATE(1003),
    [sym_compiler_directive_decl] = STATE(1003),
    [sym_fsi_directive_decl] = STATE(1003),
    [sym_preproc_line] = STATE(1003),
    [aux_sym__compound_type_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LT2] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [anon_sym_POUNDendif] = ACTIONS(3022),
    [anon_sym_POUNDelse] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1004] = {
    [sym_xml_doc] = STATE(1004),
    [sym_block_comment] = STATE(1004),
    [sym_line_comment] = STATE(1004),
    [sym_compiler_directive_decl] = STATE(1004),
    [sym_fsi_directive_decl] = STATE(1004),
    [sym_preproc_line] = STATE(1004),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_GT_RBRACK] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_RBRACK] = ACTIONS(3509),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_to] = ACTIONS(3507),
    [anon_sym_downto] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_end] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1005] = {
    [sym_xml_doc] = STATE(1005),
    [sym_block_comment] = STATE(1005),
    [sym_line_comment] = STATE(1005),
    [sym_compiler_directive_decl] = STATE(1005),
    [sym_fsi_directive_decl] = STATE(1005),
    [sym_preproc_line] = STATE(1005),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_open] = ACTIONS(3292),
    [anon_sym_LBRACK_LT] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3294),
    [anon_sym_POUNDload] = ACTIONS(3294),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
    [sym__dedent] = ACTIONS(3294),
  },
  [1006] = {
    [sym_type_arguments] = STATE(1390),
    [sym_long_identifier] = STATE(1438),
    [sym_xml_doc] = STATE(1006),
    [sym_block_comment] = STATE(1006),
    [sym_line_comment] = STATE(1006),
    [sym_compiler_directive_decl] = STATE(1006),
    [sym_fsi_directive_decl] = STATE(1006),
    [sym_preproc_line] = STATE(1006),
    [aux_sym__compound_type_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(3513),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1007] = {
    [sym_xml_doc] = STATE(1007),
    [sym_block_comment] = STATE(1007),
    [sym_line_comment] = STATE(1007),
    [sym_compiler_directive_decl] = STATE(1007),
    [sym_fsi_directive_decl] = STATE(1007),
    [sym_preproc_line] = STATE(1007),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_GT_RBRACK] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_RBRACK] = ACTIONS(3525),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_to] = ACTIONS(3523),
    [anon_sym_downto] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_end] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_DOT_DOT2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1008] = {
    [sym_xml_doc] = STATE(1008),
    [sym_block_comment] = STATE(1008),
    [sym_line_comment] = STATE(1008),
    [sym_compiler_directive_decl] = STATE(1008),
    [sym_fsi_directive_decl] = STATE(1008),
    [sym_preproc_line] = STATE(1008),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [1009] = {
    [sym_xml_doc] = STATE(1009),
    [sym_block_comment] = STATE(1009),
    [sym_line_comment] = STATE(1009),
    [sym_compiler_directive_decl] = STATE(1009),
    [sym_fsi_directive_decl] = STATE(1009),
    [sym_preproc_line] = STATE(1009),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_GT_RBRACK] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_RBRACK] = ACTIONS(3529),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_to] = ACTIONS(3527),
    [anon_sym_downto] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_end] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_DOT_DOT2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1010] = {
    [sym_xml_doc] = STATE(1010),
    [sym_block_comment] = STATE(1010),
    [sym_line_comment] = STATE(1010),
    [sym_compiler_directive_decl] = STATE(1010),
    [sym_fsi_directive_decl] = STATE(1010),
    [sym_preproc_line] = STATE(1010),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_GT_RBRACK] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_RBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_to] = ACTIONS(3533),
    [anon_sym_downto] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_end] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_DOT_DOT2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [1011] = {
    [sym_xml_doc] = STATE(1011),
    [sym_block_comment] = STATE(1011),
    [sym_line_comment] = STATE(1011),
    [sym_compiler_directive_decl] = STATE(1011),
    [sym_fsi_directive_decl] = STATE(1011),
    [sym_preproc_line] = STATE(1011),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_to] = ACTIONS(3483),
    [anon_sym_downto] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_end] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1012] = {
    [sym_type_arguments] = STATE(1461),
    [sym_long_identifier] = STATE(1376),
    [sym_xml_doc] = STATE(1012),
    [sym_block_comment] = STATE(1012),
    [sym_line_comment] = STATE(1012),
    [sym_compiler_directive_decl] = STATE(1012),
    [sym_fsi_directive_decl] = STATE(1012),
    [sym_preproc_line] = STATE(1012),
    [aux_sym__compound_type_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LT2] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [anon_sym_POUNDendif] = ACTIONS(3156),
    [anon_sym_POUNDelse] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1013] = {
    [sym_xml_doc] = STATE(1013),
    [sym_block_comment] = STATE(1013),
    [sym_line_comment] = STATE(1013),
    [sym_compiler_directive_decl] = STATE(1013),
    [sym_fsi_directive_decl] = STATE(1013),
    [sym_preproc_line] = STATE(1013),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_GT_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_to] = ACTIONS(3438),
    [anon_sym_downto] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_end] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1014] = {
    [sym_xml_doc] = STATE(1014),
    [sym_block_comment] = STATE(1014),
    [sym_line_comment] = STATE(1014),
    [sym_compiler_directive_decl] = STATE(1014),
    [sym_fsi_directive_decl] = STATE(1014),
    [sym_preproc_line] = STATE(1014),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_open] = ACTIONS(3355),
    [anon_sym_LBRACK_LT] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(3537),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3357),
    [anon_sym_POUNDload] = ACTIONS(3357),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
    [sym__dedent] = ACTIONS(3357),
  },
  [1015] = {
    [sym_xml_doc] = STATE(1015),
    [sym_block_comment] = STATE(1015),
    [sym_line_comment] = STATE(1015),
    [sym_compiler_directive_decl] = STATE(1015),
    [sym_fsi_directive_decl] = STATE(1015),
    [sym_preproc_line] = STATE(1015),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1016] = {
    [sym_xml_doc] = STATE(1016),
    [sym_block_comment] = STATE(1016),
    [sym_line_comment] = STATE(1016),
    [sym_compiler_directive_decl] = STATE(1016),
    [sym_fsi_directive_decl] = STATE(1016),
    [sym_preproc_line] = STATE(1016),
    [aux_sym_long_identifier_repeat1] = STATE(1016),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_GT_RBRACK] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_to] = ACTIONS(3285),
    [anon_sym_downto] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_end] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1017] = {
    [sym_type_arguments] = STATE(1390),
    [sym_long_identifier] = STATE(1438),
    [sym_xml_doc] = STATE(1017),
    [sym_block_comment] = STATE(1017),
    [sym_line_comment] = STATE(1017),
    [sym_compiler_directive_decl] = STATE(1017),
    [sym_fsi_directive_decl] = STATE(1017),
    [sym_preproc_line] = STATE(1017),
    [aux_sym__compound_type_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(3513),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_as] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1018] = {
    [sym_xml_doc] = STATE(1018),
    [sym_block_comment] = STATE(1018),
    [sym_line_comment] = STATE(1018),
    [sym_compiler_directive_decl] = STATE(1018),
    [sym_fsi_directive_decl] = STATE(1018),
    [sym_preproc_line] = STATE(1018),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_GT_RBRACK] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_RBRACK] = ACTIONS(3544),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3544),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_with] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_to] = ACTIONS(3542),
    [anon_sym_downto] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_end] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_DOT_DOT2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [1019] = {
    [sym_type_arguments] = STATE(1390),
    [sym_long_identifier] = STATE(1438),
    [sym_xml_doc] = STATE(1019),
    [sym_block_comment] = STATE(1019),
    [sym_line_comment] = STATE(1019),
    [sym_compiler_directive_decl] = STATE(1019),
    [sym_fsi_directive_decl] = STATE(1019),
    [sym_preproc_line] = STATE(1019),
    [aux_sym__compound_type_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3154),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1020] = {
    [sym_type_arguments] = STATE(1390),
    [sym_long_identifier] = STATE(1438),
    [sym_xml_doc] = STATE(1020),
    [sym_block_comment] = STATE(1020),
    [sym_line_comment] = STATE(1020),
    [sym_compiler_directive_decl] = STATE(1020),
    [sym_fsi_directive_decl] = STATE(1020),
    [sym_preproc_line] = STATE(1020),
    [aux_sym__compound_type_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(3513),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1021] = {
    [sym_xml_doc] = STATE(1021),
    [sym_block_comment] = STATE(1021),
    [sym_line_comment] = STATE(1021),
    [sym_compiler_directive_decl] = STATE(1021),
    [sym_fsi_directive_decl] = STATE(1021),
    [sym_preproc_line] = STATE(1021),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_open] = ACTIONS(3318),
    [anon_sym_LBRACK_LT] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3320),
    [anon_sym_POUNDload] = ACTIONS(3320),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
    [sym__dedent] = ACTIONS(3320),
  },
  [1022] = {
    [sym_xml_doc] = STATE(1022),
    [sym_block_comment] = STATE(1022),
    [sym_line_comment] = STATE(1022),
    [sym_compiler_directive_decl] = STATE(1022),
    [sym_fsi_directive_decl] = STATE(1022),
    [sym_preproc_line] = STATE(1022),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_GT_RBRACK] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_RBRACK] = ACTIONS(3509),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_to] = ACTIONS(3507),
    [anon_sym_downto] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_end] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1023] = {
    [sym_xml_doc] = STATE(1023),
    [sym_block_comment] = STATE(1023),
    [sym_line_comment] = STATE(1023),
    [sym_compiler_directive_decl] = STATE(1023),
    [sym_fsi_directive_decl] = STATE(1023),
    [sym_preproc_line] = STATE(1023),
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_open] = ACTIONS(3387),
    [anon_sym_LBRACK_LT] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(3548),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3389),
    [anon_sym_POUNDload] = ACTIONS(3389),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1024] = {
    [sym_xml_doc] = STATE(1024),
    [sym_block_comment] = STATE(1024),
    [sym_line_comment] = STATE(1024),
    [sym_compiler_directive_decl] = STATE(1024),
    [sym_fsi_directive_decl] = STATE(1024),
    [sym_preproc_line] = STATE(1024),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_module] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_open] = ACTIONS(3336),
    [anon_sym_LBRACK_LT] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_type] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3338),
    [anon_sym_POUNDload] = ACTIONS(3338),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
    [sym__dedent] = ACTIONS(3338),
  },
  [1025] = {
    [sym_xml_doc] = STATE(1025),
    [sym_block_comment] = STATE(1025),
    [sym_line_comment] = STATE(1025),
    [sym_compiler_directive_decl] = STATE(1025),
    [sym_fsi_directive_decl] = STATE(1025),
    [sym_preproc_line] = STATE(1025),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [1026] = {
    [sym_xml_doc] = STATE(1026),
    [sym_block_comment] = STATE(1026),
    [sym_line_comment] = STATE(1026),
    [sym_compiler_directive_decl] = STATE(1026),
    [sym_fsi_directive_decl] = STATE(1026),
    [sym_preproc_line] = STATE(1026),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1027] = {
    [sym_xml_doc] = STATE(1027),
    [sym_block_comment] = STATE(1027),
    [sym_line_comment] = STATE(1027),
    [sym_compiler_directive_decl] = STATE(1027),
    [sym_fsi_directive_decl] = STATE(1027),
    [sym_preproc_line] = STATE(1027),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_GT_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_to] = ACTIONS(3438),
    [anon_sym_downto] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_end] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1028] = {
    [sym_xml_doc] = STATE(1028),
    [sym_block_comment] = STATE(1028),
    [sym_line_comment] = STATE(1028),
    [sym_compiler_directive_decl] = STATE(1028),
    [sym_fsi_directive_decl] = STATE(1028),
    [sym_preproc_line] = STATE(1028),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [1029] = {
    [sym_xml_doc] = STATE(1029),
    [sym_block_comment] = STATE(1029),
    [sym_line_comment] = STATE(1029),
    [sym_compiler_directive_decl] = STATE(1029),
    [sym_fsi_directive_decl] = STATE(1029),
    [sym_preproc_line] = STATE(1029),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_open] = ACTIONS(3300),
    [anon_sym_LBRACK_LT] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3302),
    [anon_sym_POUNDload] = ACTIONS(3302),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
    [sym__dedent] = ACTIONS(3302),
  },
  [1030] = {
    [sym_type_arguments] = STATE(1461),
    [sym_long_identifier] = STATE(1376),
    [sym_xml_doc] = STATE(1030),
    [sym_block_comment] = STATE(1030),
    [sym_line_comment] = STATE(1030),
    [sym_compiler_directive_decl] = STATE(1030),
    [sym_fsi_directive_decl] = STATE(1030),
    [sym_preproc_line] = STATE(1030),
    [aux_sym__compound_type_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LT2] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [anon_sym_POUNDendif] = ACTIONS(3090),
    [anon_sym_POUNDelse] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1031] = {
    [sym_xml_doc] = STATE(1031),
    [sym_block_comment] = STATE(1031),
    [sym_line_comment] = STATE(1031),
    [sym_compiler_directive_decl] = STATE(1031),
    [sym_fsi_directive_decl] = STATE(1031),
    [sym_preproc_line] = STATE(1031),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_open] = ACTIONS(3304),
    [anon_sym_LBRACK_LT] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3306),
    [anon_sym_POUNDload] = ACTIONS(3306),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
    [sym__dedent] = ACTIONS(3306),
  },
  [1032] = {
    [sym_xml_doc] = STATE(1032),
    [sym_block_comment] = STATE(1032),
    [sym_line_comment] = STATE(1032),
    [sym_compiler_directive_decl] = STATE(1032),
    [sym_fsi_directive_decl] = STATE(1032),
    [sym_preproc_line] = STATE(1032),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_open] = ACTIONS(3340),
    [anon_sym_LBRACK_LT] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3342),
    [anon_sym_POUNDload] = ACTIONS(3342),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
    [sym__dedent] = ACTIONS(3342),
  },
  [1033] = {
    [sym_xml_doc] = STATE(1033),
    [sym_block_comment] = STATE(1033),
    [sym_line_comment] = STATE(1033),
    [sym_compiler_directive_decl] = STATE(1033),
    [sym_fsi_directive_decl] = STATE(1033),
    [sym_preproc_line] = STATE(1033),
    [aux_sym_long_identifier_repeat1] = STATE(1016),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_GT_RBRACK] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_to] = ACTIONS(3202),
    [anon_sym_downto] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_end] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_DOT_DOT2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1034] = {
    [sym_xml_doc] = STATE(1034),
    [sym_block_comment] = STATE(1034),
    [sym_line_comment] = STATE(1034),
    [sym_compiler_directive_decl] = STATE(1034),
    [sym_fsi_directive_decl] = STATE(1034),
    [sym_preproc_line] = STATE(1034),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [1035] = {
    [sym_type_arguments] = STATE(1461),
    [sym_long_identifier] = STATE(1376),
    [sym_xml_doc] = STATE(1035),
    [sym_block_comment] = STATE(1035),
    [sym_line_comment] = STATE(1035),
    [sym_compiler_directive_decl] = STATE(1035),
    [sym_fsi_directive_decl] = STATE(1035),
    [sym_preproc_line] = STATE(1035),
    [aux_sym__compound_type_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LT2] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [anon_sym_POUNDendif] = ACTIONS(3030),
    [anon_sym_POUNDelse] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1036] = {
    [sym_xml_doc] = STATE(1036),
    [sym_block_comment] = STATE(1036),
    [sym_line_comment] = STATE(1036),
    [sym_compiler_directive_decl] = STATE(1036),
    [sym_fsi_directive_decl] = STATE(1036),
    [sym_preproc_line] = STATE(1036),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_open] = ACTIONS(3322),
    [anon_sym_LBRACK_LT] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3324),
    [anon_sym_POUNDload] = ACTIONS(3324),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
    [sym__dedent] = ACTIONS(3324),
  },
  [1037] = {
    [sym_type_arguments] = STATE(1390),
    [sym_long_identifier] = STATE(1438),
    [sym_xml_doc] = STATE(1037),
    [sym_block_comment] = STATE(1037),
    [sym_line_comment] = STATE(1037),
    [sym_compiler_directive_decl] = STATE(1037),
    [sym_fsi_directive_decl] = STATE(1037),
    [sym_preproc_line] = STATE(1037),
    [aux_sym__compound_type_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(3513),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_as] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1038] = {
    [sym_xml_doc] = STATE(1038),
    [sym_block_comment] = STATE(1038),
    [sym_line_comment] = STATE(1038),
    [sym_compiler_directive_decl] = STATE(1038),
    [sym_fsi_directive_decl] = STATE(1038),
    [sym_preproc_line] = STATE(1038),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_open] = ACTIONS(3296),
    [anon_sym_LBRACK_LT] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3298),
    [anon_sym_POUNDload] = ACTIONS(3298),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
    [sym__dedent] = ACTIONS(3298),
  },
  [1039] = {
    [sym_xml_doc] = STATE(1039),
    [sym_block_comment] = STATE(1039),
    [sym_line_comment] = STATE(1039),
    [sym_compiler_directive_decl] = STATE(1039),
    [sym_fsi_directive_decl] = STATE(1039),
    [sym_preproc_line] = STATE(1039),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_GT_RBRACK] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_RBRACK] = ACTIONS(3556),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_with] = ACTIONS(3554),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_to] = ACTIONS(3554),
    [anon_sym_downto] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_end] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_DOT_DOT2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [1040] = {
    [sym_xml_doc] = STATE(1040),
    [sym_block_comment] = STATE(1040),
    [sym_line_comment] = STATE(1040),
    [sym_compiler_directive_decl] = STATE(1040),
    [sym_fsi_directive_decl] = STATE(1040),
    [sym_preproc_line] = STATE(1040),
    [aux_sym_long_identifier_repeat1] = STATE(1033),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_GT_RBRACK] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_RBRACK] = ACTIONS(3264),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_to] = ACTIONS(3261),
    [anon_sym_downto] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_end] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_DOT_DOT2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1041] = {
    [sym_type_arguments] = STATE(1461),
    [sym_long_identifier] = STATE(1376),
    [sym_xml_doc] = STATE(1041),
    [sym_block_comment] = STATE(1041),
    [sym_line_comment] = STATE(1041),
    [sym_compiler_directive_decl] = STATE(1041),
    [sym_fsi_directive_decl] = STATE(1041),
    [sym_preproc_line] = STATE(1041),
    [aux_sym__compound_type_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(3497),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LT2] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [anon_sym_POUNDendif] = ACTIONS(3010),
    [anon_sym_POUNDelse] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1042] = {
    [sym_xml_doc] = STATE(1042),
    [sym_block_comment] = STATE(1042),
    [sym_line_comment] = STATE(1042),
    [sym_compiler_directive_decl] = STATE(1042),
    [sym_fsi_directive_decl] = STATE(1042),
    [sym_preproc_line] = STATE(1042),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_open] = ACTIONS(3361),
    [anon_sym_LBRACK_LT] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3363),
    [anon_sym_POUNDload] = ACTIONS(3363),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
    [sym__dedent] = ACTIONS(3363),
  },
  [1043] = {
    [sym_elif_expression] = STATE(1192),
    [sym_xml_doc] = STATE(1043),
    [sym_block_comment] = STATE(1043),
    [sym_line_comment] = STATE(1043),
    [sym_compiler_directive_decl] = STATE(1043),
    [sym_fsi_directive_decl] = STATE(1043),
    [sym_preproc_line] = STATE(1043),
    [aux_sym_if_expression_repeat1] = STATE(1043),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_module] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_open] = ACTIONS(3344),
    [anon_sym_LBRACK_LT] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_type] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3346),
    [anon_sym_POUNDload] = ACTIONS(3346),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
    [sym__dedent] = ACTIONS(3346),
  },
  [1044] = {
    [sym_xml_doc] = STATE(1044),
    [sym_block_comment] = STATE(1044),
    [sym_line_comment] = STATE(1044),
    [sym_compiler_directive_decl] = STATE(1044),
    [sym_fsi_directive_decl] = STATE(1044),
    [sym_preproc_line] = STATE(1044),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_open] = ACTIONS(3308),
    [anon_sym_LBRACK_LT] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3310),
    [anon_sym_POUNDload] = ACTIONS(3310),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
    [sym__dedent] = ACTIONS(3310),
  },
  [1045] = {
    [sym_type_arguments] = STATE(1480),
    [sym_long_identifier] = STATE(1524),
    [sym_xml_doc] = STATE(1045),
    [sym_block_comment] = STATE(1045),
    [sym_line_comment] = STATE(1045),
    [sym_compiler_directive_decl] = STATE(1045),
    [sym_fsi_directive_decl] = STATE(1045),
    [sym_preproc_line] = STATE(1045),
    [aux_sym__compound_type_repeat1] = STATE(1427),
    [sym_identifier] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_DOT_DOT] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3573),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1046] = {
    [sym_xml_doc] = STATE(1046),
    [sym_block_comment] = STATE(1046),
    [sym_line_comment] = STATE(1046),
    [sym_compiler_directive_decl] = STATE(1046),
    [sym_fsi_directive_decl] = STATE(1046),
    [sym_preproc_line] = STATE(1046),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_GT_RBRACK] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_RBRACK] = ACTIONS(3579),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_with] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_to] = ACTIONS(3577),
    [anon_sym_downto] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_end] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_DOT_DOT2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [1047] = {
    [sym_xml_doc] = STATE(1047),
    [sym_block_comment] = STATE(1047),
    [sym_line_comment] = STATE(1047),
    [sym_compiler_directive_decl] = STATE(1047),
    [sym_fsi_directive_decl] = STATE(1047),
    [sym_preproc_line] = STATE(1047),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_GT_RBRACK] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_RBRACK] = ACTIONS(3583),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_with] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_to] = ACTIONS(3581),
    [anon_sym_downto] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_end] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_DOT_DOT2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [1048] = {
    [sym_xml_doc] = STATE(1048),
    [sym_block_comment] = STATE(1048),
    [sym_line_comment] = STATE(1048),
    [sym_compiler_directive_decl] = STATE(1048),
    [sym_fsi_directive_decl] = STATE(1048),
    [sym_preproc_line] = STATE(1048),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_GT_RBRACK] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_RBRACK] = ACTIONS(3587),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_with] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_to] = ACTIONS(3585),
    [anon_sym_downto] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_end] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_DOT_DOT2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [1049] = {
    [sym__else_expression] = STATE(1968),
    [sym_elif_expression] = STATE(1465),
    [sym_xml_doc] = STATE(1049),
    [sym_block_comment] = STATE(1049),
    [sym_line_comment] = STATE(1049),
    [sym_compiler_directive_decl] = STATE(1049),
    [sym_fsi_directive_decl] = STATE(1049),
    [sym_preproc_line] = STATE(1049),
    [aux_sym_if_expression_repeat1] = STATE(1051),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3589),
    [anon_sym_elif] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_DOT_DOT2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
    [sym__dedent] = ACTIONS(3251),
  },
  [1050] = {
    [sym_xml_doc] = STATE(1050),
    [sym_block_comment] = STATE(1050),
    [sym_line_comment] = STATE(1050),
    [sym_compiler_directive_decl] = STATE(1050),
    [sym_fsi_directive_decl] = STATE(1050),
    [sym_preproc_line] = STATE(1050),
    [aux_sym__compound_type_repeat1] = STATE(1050),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3593),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [1051] = {
    [sym__else_expression] = STATE(1938),
    [sym_elif_expression] = STATE(1465),
    [sym_xml_doc] = STATE(1051),
    [sym_block_comment] = STATE(1051),
    [sym_line_comment] = STATE(1051),
    [sym_compiler_directive_decl] = STATE(1051),
    [sym_fsi_directive_decl] = STATE(1051),
    [sym_preproc_line] = STATE(1051),
    [aux_sym_if_expression_repeat1] = STATE(1205),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3589),
    [anon_sym_elif] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_DOT_DOT2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
    [sym__dedent] = ACTIONS(3283),
  },
  [1052] = {
    [sym_xml_doc] = STATE(1052),
    [sym_block_comment] = STATE(1052),
    [sym_line_comment] = STATE(1052),
    [sym_compiler_directive_decl] = STATE(1052),
    [sym_fsi_directive_decl] = STATE(1052),
    [sym_preproc_line] = STATE(1052),
    [aux_sym_type_argument_repeat1] = STATE(1072),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_DOT_DOT2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
    [sym__dedent] = ACTIONS(3232),
  },
  [1053] = {
    [sym_xml_doc] = STATE(1053),
    [sym_block_comment] = STATE(1053),
    [sym_line_comment] = STATE(1053),
    [sym_compiler_directive_decl] = STATE(1053),
    [sym_fsi_directive_decl] = STATE(1053),
    [sym_preproc_line] = STATE(1053),
    [aux_sym_long_identifier_repeat1] = STATE(1071),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3596),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_DOT_DOT2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [1054] = {
    [sym_xml_doc] = STATE(1054),
    [sym_block_comment] = STATE(1054),
    [sym_line_comment] = STATE(1054),
    [sym_compiler_directive_decl] = STATE(1054),
    [sym_fsi_directive_decl] = STATE(1054),
    [sym_preproc_line] = STATE(1054),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_GT_RBRACK] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_RBRACK] = ACTIONS(3600),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_with] = ACTIONS(3598),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_to] = ACTIONS(3598),
    [anon_sym_downto] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_end] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_DOT_DOT2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [1055] = {
    [sym_xml_doc] = STATE(1055),
    [sym_block_comment] = STATE(1055),
    [sym_line_comment] = STATE(1055),
    [sym_compiler_directive_decl] = STATE(1055),
    [sym_fsi_directive_decl] = STATE(1055),
    [sym_preproc_line] = STATE(1055),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_GT_RBRACK] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_to] = ACTIONS(3602),
    [anon_sym_downto] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_end] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_DOT_DOT2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [1056] = {
    [sym_xml_doc] = STATE(1056),
    [sym_block_comment] = STATE(1056),
    [sym_line_comment] = STATE(1056),
    [sym_compiler_directive_decl] = STATE(1056),
    [sym_fsi_directive_decl] = STATE(1056),
    [sym_preproc_line] = STATE(1056),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_open] = ACTIONS(3387),
    [anon_sym_LBRACK_LT] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(3606),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3389),
    [anon_sym_POUNDload] = ACTIONS(3389),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
    [sym__dedent] = ACTIONS(3389),
  },
  [1057] = {
    [sym_type_arguments] = STATE(1480),
    [sym_long_identifier] = STATE(1524),
    [sym_xml_doc] = STATE(1057),
    [sym_block_comment] = STATE(1057),
    [sym_line_comment] = STATE(1057),
    [sym_compiler_directive_decl] = STATE(1057),
    [sym_fsi_directive_decl] = STATE(1057),
    [sym_preproc_line] = STATE(1057),
    [aux_sym__compound_type_repeat1] = STATE(1427),
    [sym_identifier] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_DOT_DOT] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3573),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1058] = {
    [sym_xml_doc] = STATE(1058),
    [sym_block_comment] = STATE(1058),
    [sym_line_comment] = STATE(1058),
    [sym_compiler_directive_decl] = STATE(1058),
    [sym_fsi_directive_decl] = STATE(1058),
    [sym_preproc_line] = STATE(1058),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_GT_RBRACK] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_with] = ACTIONS(3608),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_to] = ACTIONS(3608),
    [anon_sym_downto] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_end] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_DOT_DOT2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [1059] = {
    [sym_xml_doc] = STATE(1059),
    [sym_block_comment] = STATE(1059),
    [sym_line_comment] = STATE(1059),
    [sym_compiler_directive_decl] = STATE(1059),
    [sym_fsi_directive_decl] = STATE(1059),
    [sym_preproc_line] = STATE(1059),
    [aux_sym_sequential_expression_repeat1] = STATE(1122),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_GT_RBRACK] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_RBRACK] = ACTIONS(3614),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_RBRACE] = ACTIONS(3614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_with] = ACTIONS(3612),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_to] = ACTIONS(3612),
    [anon_sym_downto] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_end] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1060] = {
    [sym_xml_doc] = STATE(1060),
    [sym_block_comment] = STATE(1060),
    [sym_line_comment] = STATE(1060),
    [sym_compiler_directive_decl] = STATE(1060),
    [sym_fsi_directive_decl] = STATE(1060),
    [sym_preproc_line] = STATE(1060),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_GT_RBRACK] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_RBRACK] = ACTIONS(3618),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3616),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_to] = ACTIONS(3616),
    [anon_sym_downto] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_end] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_DOT_DOT2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [1061] = {
    [sym_xml_doc] = STATE(1061),
    [sym_block_comment] = STATE(1061),
    [sym_line_comment] = STATE(1061),
    [sym_compiler_directive_decl] = STATE(1061),
    [sym_fsi_directive_decl] = STATE(1061),
    [sym_preproc_line] = STATE(1061),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_namespace] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1062] = {
    [sym_xml_doc] = STATE(1062),
    [sym_block_comment] = STATE(1062),
    [sym_line_comment] = STATE(1062),
    [sym_compiler_directive_decl] = STATE(1062),
    [sym_fsi_directive_decl] = STATE(1062),
    [sym_preproc_line] = STATE(1062),
    [aux_sym__compound_type_repeat1] = STATE(1050),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_as] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
    [sym__dedent] = ACTIONS(3214),
  },
  [1063] = {
    [sym_xml_doc] = STATE(1063),
    [sym_block_comment] = STATE(1063),
    [sym_line_comment] = STATE(1063),
    [sym_compiler_directive_decl] = STATE(1063),
    [sym_fsi_directive_decl] = STATE(1063),
    [sym_preproc_line] = STATE(1063),
    [aux_sym_type_argument_repeat1] = STATE(1077),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_as] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
    [sym__dedent] = ACTIONS(3232),
  },
  [1064] = {
    [sym_xml_doc] = STATE(1064),
    [sym_block_comment] = STATE(1064),
    [sym_line_comment] = STATE(1064),
    [sym_compiler_directive_decl] = STATE(1064),
    [sym_fsi_directive_decl] = STATE(1064),
    [sym_preproc_line] = STATE(1064),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_GT_RBRACK] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_RBRACK] = ACTIONS(3312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_to] = ACTIONS(3314),
    [anon_sym_downto] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_end] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_DOT_DOT2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [1065] = {
    [sym_xml_doc] = STATE(1065),
    [sym_block_comment] = STATE(1065),
    [sym_line_comment] = STATE(1065),
    [sym_compiler_directive_decl] = STATE(1065),
    [sym_fsi_directive_decl] = STATE(1065),
    [sym_preproc_line] = STATE(1065),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_GT_RBRACK] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_RBRACK] = ACTIONS(3622),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_RBRACE] = ACTIONS(3622),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_with] = ACTIONS(3620),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_to] = ACTIONS(3620),
    [anon_sym_downto] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_end] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_DOT_DOT2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [1066] = {
    [sym_xml_doc] = STATE(1066),
    [sym_block_comment] = STATE(1066),
    [sym_line_comment] = STATE(1066),
    [sym_compiler_directive_decl] = STATE(1066),
    [sym_fsi_directive_decl] = STATE(1066),
    [sym_preproc_line] = STATE(1066),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_GT_RBRACK] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_RBRACK] = ACTIONS(3626),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_RBRACE] = ACTIONS(3626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_with] = ACTIONS(3624),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_to] = ACTIONS(3624),
    [anon_sym_downto] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_end] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_DOT_DOT2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [1067] = {
    [sym_type_arguments] = STATE(1476),
    [sym_long_identifier] = STATE(1483),
    [sym_xml_doc] = STATE(1067),
    [sym_block_comment] = STATE(1067),
    [sym_line_comment] = STATE(1067),
    [sym_compiler_directive_decl] = STATE(1067),
    [sym_fsi_directive_decl] = STATE(1067),
    [sym_preproc_line] = STATE(1067),
    [aux_sym__compound_type_repeat1] = STATE(1435),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_LT2] = ACTIONS(3634),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3636),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1068] = {
    [sym_xml_doc] = STATE(1068),
    [sym_block_comment] = STATE(1068),
    [sym_line_comment] = STATE(1068),
    [sym_compiler_directive_decl] = STATE(1068),
    [sym_fsi_directive_decl] = STATE(1068),
    [sym_preproc_line] = STATE(1068),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_GT_RBRACK] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_RBRACK] = ACTIONS(3640),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_RBRACE] = ACTIONS(3640),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_with] = ACTIONS(3638),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_to] = ACTIONS(3638),
    [anon_sym_downto] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_end] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_DOT_DOT2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [1069] = {
    [sym_xml_doc] = STATE(1069),
    [sym_block_comment] = STATE(1069),
    [sym_line_comment] = STATE(1069),
    [sym_compiler_directive_decl] = STATE(1069),
    [sym_fsi_directive_decl] = STATE(1069),
    [sym_preproc_line] = STATE(1069),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_GT_RBRACK] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_RBRACK] = ACTIONS(3644),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_RBRACE] = ACTIONS(3644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_with] = ACTIONS(3642),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_to] = ACTIONS(3642),
    [anon_sym_downto] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_end] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_DOT_DOT2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [1070] = {
    [sym_xml_doc] = STATE(1070),
    [sym_block_comment] = STATE(1070),
    [sym_line_comment] = STATE(1070),
    [sym_compiler_directive_decl] = STATE(1070),
    [sym_fsi_directive_decl] = STATE(1070),
    [sym_preproc_line] = STATE(1070),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_GT_RBRACK] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_RBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_RBRACE] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_to] = ACTIONS(3646),
    [anon_sym_downto] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_end] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_DOT_DOT2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [1071] = {
    [sym_xml_doc] = STATE(1071),
    [sym_block_comment] = STATE(1071),
    [sym_line_comment] = STATE(1071),
    [sym_compiler_directive_decl] = STATE(1071),
    [sym_fsi_directive_decl] = STATE(1071),
    [sym_preproc_line] = STATE(1071),
    [aux_sym_long_identifier_repeat1] = STATE(1071),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3650),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1072] = {
    [sym_xml_doc] = STATE(1072),
    [sym_block_comment] = STATE(1072),
    [sym_line_comment] = STATE(1072),
    [sym_compiler_directive_decl] = STATE(1072),
    [sym_fsi_directive_decl] = STATE(1072),
    [sym_preproc_line] = STATE(1072),
    [aux_sym_type_argument_repeat1] = STATE(1072),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_DOT_DOT2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3653),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [1073] = {
    [sym_xml_doc] = STATE(1073),
    [sym_block_comment] = STATE(1073),
    [sym_line_comment] = STATE(1073),
    [sym_compiler_directive_decl] = STATE(1073),
    [sym_fsi_directive_decl] = STATE(1073),
    [sym_preproc_line] = STATE(1073),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_GT_RBRACK] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_RBRACK] = ACTIONS(3658),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_RBRACE] = ACTIONS(3658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_with] = ACTIONS(3656),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_to] = ACTIONS(3656),
    [anon_sym_downto] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_end] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_DOT_DOT2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [1074] = {
    [sym_xml_doc] = STATE(1074),
    [sym_block_comment] = STATE(1074),
    [sym_line_comment] = STATE(1074),
    [sym_compiler_directive_decl] = STATE(1074),
    [sym_fsi_directive_decl] = STATE(1074),
    [sym_preproc_line] = STATE(1074),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_GT_RBRACK] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_RBRACK] = ACTIONS(3662),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_RBRACE] = ACTIONS(3662),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_with] = ACTIONS(3660),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_to] = ACTIONS(3660),
    [anon_sym_downto] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_end] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_DOT_DOT2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [1075] = {
    [sym_type_arguments] = STATE(1519),
    [sym_long_identifier] = STATE(1598),
    [sym_xml_doc] = STATE(1075),
    [sym_block_comment] = STATE(1075),
    [sym_line_comment] = STATE(1075),
    [sym_compiler_directive_decl] = STATE(1075),
    [sym_fsi_directive_decl] = STATE(1075),
    [sym_preproc_line] = STATE(1075),
    [aux_sym__compound_type_repeat1] = STATE(1388),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_LT2] = ACTIONS(3668),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [anon_sym_POUNDendif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1076] = {
    [sym_xml_doc] = STATE(1076),
    [sym_block_comment] = STATE(1076),
    [sym_line_comment] = STATE(1076),
    [sym_compiler_directive_decl] = STATE(1076),
    [sym_fsi_directive_decl] = STATE(1076),
    [sym_preproc_line] = STATE(1076),
    [ts_builtin_sym_end] = ACTIONS(3453),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3453),
    [anon_sym_POUNDload] = ACTIONS(3453),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1077] = {
    [sym_xml_doc] = STATE(1077),
    [sym_block_comment] = STATE(1077),
    [sym_line_comment] = STATE(1077),
    [sym_compiler_directive_decl] = STATE(1077),
    [sym_fsi_directive_decl] = STATE(1077),
    [sym_preproc_line] = STATE(1077),
    [aux_sym_type_argument_repeat1] = STATE(1077),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3672),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [1078] = {
    [sym_xml_doc] = STATE(1078),
    [sym_block_comment] = STATE(1078),
    [sym_line_comment] = STATE(1078),
    [sym_compiler_directive_decl] = STATE(1078),
    [sym_fsi_directive_decl] = STATE(1078),
    [sym_preproc_line] = STATE(1078),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_GT_RBRACK] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_RBRACK] = ACTIONS(3677),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_with] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_to] = ACTIONS(3675),
    [anon_sym_downto] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_end] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_DOT_DOT2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [1079] = {
    [sym_xml_doc] = STATE(1079),
    [sym_block_comment] = STATE(1079),
    [sym_line_comment] = STATE(1079),
    [sym_compiler_directive_decl] = STATE(1079),
    [sym_fsi_directive_decl] = STATE(1079),
    [sym_preproc_line] = STATE(1079),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_GT_RBRACK] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_RBRACK] = ACTIONS(3546),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_with] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_to] = ACTIONS(3679),
    [anon_sym_downto] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_end] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_DOT_DOT2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [1080] = {
    [sym_type_arguments] = STATE(1610),
    [sym_long_identifier] = STATE(1583),
    [sym_xml_doc] = STATE(1080),
    [sym_block_comment] = STATE(1080),
    [sym_line_comment] = STATE(1080),
    [sym_compiler_directive_decl] = STATE(1080),
    [sym_fsi_directive_decl] = STATE(1080),
    [sym_preproc_line] = STATE(1080),
    [aux_sym__compound_type_repeat1] = STATE(1279),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_AT_AT_GT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_LT2] = ACTIONS(3685),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3687),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1081] = {
    [sym_xml_doc] = STATE(1081),
    [sym_block_comment] = STATE(1081),
    [sym_line_comment] = STATE(1081),
    [sym_compiler_directive_decl] = STATE(1081),
    [sym_fsi_directive_decl] = STATE(1081),
    [sym_preproc_line] = STATE(1081),
    [aux_sym_long_identifier_repeat1] = STATE(1053),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3596),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_DOT_DOT2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [1082] = {
    [sym_xml_doc] = STATE(1082),
    [sym_block_comment] = STATE(1082),
    [sym_line_comment] = STATE(1082),
    [sym_compiler_directive_decl] = STATE(1082),
    [sym_fsi_directive_decl] = STATE(1082),
    [sym_preproc_line] = STATE(1082),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_GT_RBRACK] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_RBRACK] = ACTIONS(3691),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_with] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_to] = ACTIONS(3689),
    [anon_sym_downto] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_end] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_DOT_DOT2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [1083] = {
    [sym_xml_doc] = STATE(1083),
    [sym_block_comment] = STATE(1083),
    [sym_line_comment] = STATE(1083),
    [sym_compiler_directive_decl] = STATE(1083),
    [sym_fsi_directive_decl] = STATE(1083),
    [sym_preproc_line] = STATE(1083),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_GT_RBRACK] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_RBRACK] = ACTIONS(3695),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_to] = ACTIONS(3693),
    [anon_sym_downto] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_end] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_DOT_DOT2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [1084] = {
    [sym_xml_doc] = STATE(1084),
    [sym_block_comment] = STATE(1084),
    [sym_line_comment] = STATE(1084),
    [sym_compiler_directive_decl] = STATE(1084),
    [sym_fsi_directive_decl] = STATE(1084),
    [sym_preproc_line] = STATE(1084),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(2860),
    [aux_sym_decimal_token1] = ACTIONS(2822),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1085] = {
    [sym_xml_doc] = STATE(1085),
    [sym_block_comment] = STATE(1085),
    [sym_line_comment] = STATE(1085),
    [sym_compiler_directive_decl] = STATE(1085),
    [sym_fsi_directive_decl] = STATE(1085),
    [sym_preproc_line] = STATE(1085),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_GT_RBRACK] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_to] = ACTIONS(3697),
    [anon_sym_downto] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_end] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_DOT_DOT2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [1086] = {
    [sym_xml_doc] = STATE(1086),
    [sym_block_comment] = STATE(1086),
    [sym_line_comment] = STATE(1086),
    [sym_compiler_directive_decl] = STATE(1086),
    [sym_fsi_directive_decl] = STATE(1086),
    [sym_preproc_line] = STATE(1086),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_GT_RBRACK] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3703),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_to] = ACTIONS(3701),
    [anon_sym_downto] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_end] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_DOT_DOT2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [1087] = {
    [sym_xml_doc] = STATE(1087),
    [sym_block_comment] = STATE(1087),
    [sym_line_comment] = STATE(1087),
    [sym_compiler_directive_decl] = STATE(1087),
    [sym_fsi_directive_decl] = STATE(1087),
    [sym_preproc_line] = STATE(1087),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_GT_RBRACK] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3707),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_with] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_to] = ACTIONS(3705),
    [anon_sym_downto] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_end] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_DOT_DOT2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [1088] = {
    [sym_xml_doc] = STATE(1088),
    [sym_block_comment] = STATE(1088),
    [sym_line_comment] = STATE(1088),
    [sym_compiler_directive_decl] = STATE(1088),
    [sym_fsi_directive_decl] = STATE(1088),
    [sym_preproc_line] = STATE(1088),
    [aux_sym_type_argument_repeat1] = STATE(1052),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_DOT_DOT2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3709),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [1089] = {
    [sym_xml_doc] = STATE(1089),
    [sym_block_comment] = STATE(1089),
    [sym_line_comment] = STATE(1089),
    [sym_compiler_directive_decl] = STATE(1089),
    [sym_fsi_directive_decl] = STATE(1089),
    [sym_preproc_line] = STATE(1089),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_GT_RBRACK] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_RBRACK] = ACTIONS(3714),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_RBRACE] = ACTIONS(3714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_with] = ACTIONS(3712),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_to] = ACTIONS(3712),
    [anon_sym_downto] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_end] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_DOT_DOT2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [1090] = {
    [sym_xml_doc] = STATE(1090),
    [sym_block_comment] = STATE(1090),
    [sym_line_comment] = STATE(1090),
    [sym_compiler_directive_decl] = STATE(1090),
    [sym_fsi_directive_decl] = STATE(1090),
    [sym_preproc_line] = STATE(1090),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_open] = ACTIONS(3507),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1091] = {
    [sym_xml_doc] = STATE(1091),
    [sym_block_comment] = STATE(1091),
    [sym_line_comment] = STATE(1091),
    [sym_compiler_directive_decl] = STATE(1091),
    [sym_fsi_directive_decl] = STATE(1091),
    [sym_preproc_line] = STATE(1091),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_GT_RBRACK] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_RBRACK] = ACTIONS(3720),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_with] = ACTIONS(3718),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_to] = ACTIONS(3718),
    [anon_sym_downto] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_end] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_DOT_DOT2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [1092] = {
    [sym_xml_doc] = STATE(1092),
    [sym_block_comment] = STATE(1092),
    [sym_line_comment] = STATE(1092),
    [sym_compiler_directive_decl] = STATE(1092),
    [sym_fsi_directive_decl] = STATE(1092),
    [sym_preproc_line] = STATE(1092),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_GT_RBRACK] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_RBRACK] = ACTIONS(3724),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3724),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_with] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_to] = ACTIONS(3722),
    [anon_sym_downto] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_end] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_DOT_DOT2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [1093] = {
    [sym_xml_doc] = STATE(1093),
    [sym_block_comment] = STATE(1093),
    [sym_line_comment] = STATE(1093),
    [sym_compiler_directive_decl] = STATE(1093),
    [sym_fsi_directive_decl] = STATE(1093),
    [sym_preproc_line] = STATE(1093),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_GT_RBRACK] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_RBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_RBRACE] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_to] = ACTIONS(3726),
    [anon_sym_downto] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_end] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_DOT_DOT2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [1094] = {
    [sym_xml_doc] = STATE(1094),
    [sym_block_comment] = STATE(1094),
    [sym_line_comment] = STATE(1094),
    [sym_compiler_directive_decl] = STATE(1094),
    [sym_fsi_directive_decl] = STATE(1094),
    [sym_preproc_line] = STATE(1094),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_GT_RBRACK] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_RBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_RBRACE] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_to] = ACTIONS(3730),
    [anon_sym_downto] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_end] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_DOT_DOT2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [1095] = {
    [sym_xml_doc] = STATE(1095),
    [sym_block_comment] = STATE(1095),
    [sym_line_comment] = STATE(1095),
    [sym_compiler_directive_decl] = STATE(1095),
    [sym_fsi_directive_decl] = STATE(1095),
    [sym_preproc_line] = STATE(1095),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_GT_RBRACK] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_RBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_to] = ACTIONS(3734),
    [anon_sym_downto] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_end] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_DOT_DOT2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [1096] = {
    [sym_xml_doc] = STATE(1096),
    [sym_block_comment] = STATE(1096),
    [sym_line_comment] = STATE(1096),
    [sym_compiler_directive_decl] = STATE(1096),
    [sym_fsi_directive_decl] = STATE(1096),
    [sym_preproc_line] = STATE(1096),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_GT_RBRACK] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_RBRACK] = ACTIONS(3740),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_RBRACE] = ACTIONS(3740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3738),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_to] = ACTIONS(3738),
    [anon_sym_downto] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_end] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_DOT_DOT2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [1097] = {
    [sym_xml_doc] = STATE(1097),
    [sym_block_comment] = STATE(1097),
    [sym_line_comment] = STATE(1097),
    [sym_compiler_directive_decl] = STATE(1097),
    [sym_fsi_directive_decl] = STATE(1097),
    [sym_preproc_line] = STATE(1097),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_GT_RBRACK] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_with] = ACTIONS(3742),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_to] = ACTIONS(3742),
    [anon_sym_downto] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_end] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_DOT_DOT2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [1098] = {
    [sym_xml_doc] = STATE(1098),
    [sym_block_comment] = STATE(1098),
    [sym_line_comment] = STATE(1098),
    [sym_compiler_directive_decl] = STATE(1098),
    [sym_fsi_directive_decl] = STATE(1098),
    [sym_preproc_line] = STATE(1098),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_GT_RBRACK] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_RBRACK] = ACTIONS(3748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_RBRACE] = ACTIONS(3748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_with] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_to] = ACTIONS(3746),
    [anon_sym_downto] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_end] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_DOT_DOT2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [1099] = {
    [sym_type_arguments] = STATE(1574),
    [sym_long_identifier] = STATE(1555),
    [sym_xml_doc] = STATE(1099),
    [sym_block_comment] = STATE(1099),
    [sym_line_comment] = STATE(1099),
    [sym_compiler_directive_decl] = STATE(1099),
    [sym_fsi_directive_decl] = STATE(1099),
    [sym_preproc_line] = STATE(1099),
    [aux_sym__compound_type_repeat1] = STATE(1355),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_AT_GT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LT2] = ACTIONS(3756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1100] = {
    [sym_type_arguments] = STATE(1519),
    [sym_long_identifier] = STATE(1598),
    [sym_xml_doc] = STATE(1100),
    [sym_block_comment] = STATE(1100),
    [sym_line_comment] = STATE(1100),
    [sym_compiler_directive_decl] = STATE(1100),
    [sym_fsi_directive_decl] = STATE(1100),
    [sym_preproc_line] = STATE(1100),
    [aux_sym__compound_type_repeat1] = STATE(1388),
    [sym_identifier] = ACTIONS(3760),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_LT2] = ACTIONS(3668),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [anon_sym_POUNDendif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1101] = {
    [sym_xml_doc] = STATE(1101),
    [sym_block_comment] = STATE(1101),
    [sym_line_comment] = STATE(1101),
    [sym_compiler_directive_decl] = STATE(1101),
    [sym_fsi_directive_decl] = STATE(1101),
    [sym_preproc_line] = STATE(1101),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_GT_RBRACK] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_RBRACK] = ACTIONS(3764),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_RBRACE] = ACTIONS(3764),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_with] = ACTIONS(3762),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_to] = ACTIONS(3762),
    [anon_sym_downto] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_end] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_DOT_DOT2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [1102] = {
    [sym_type_arguments] = STATE(1480),
    [sym_long_identifier] = STATE(1524),
    [sym_xml_doc] = STATE(1102),
    [sym_block_comment] = STATE(1102),
    [sym_line_comment] = STATE(1102),
    [sym_compiler_directive_decl] = STATE(1102),
    [sym_fsi_directive_decl] = STATE(1102),
    [sym_preproc_line] = STATE(1102),
    [aux_sym__compound_type_repeat1] = STATE(1427),
    [sym_identifier] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3573),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1103] = {
    [sym_xml_doc] = STATE(1103),
    [sym_block_comment] = STATE(1103),
    [sym_line_comment] = STATE(1103),
    [sym_compiler_directive_decl] = STATE(1103),
    [sym_fsi_directive_decl] = STATE(1103),
    [sym_preproc_line] = STATE(1103),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_GT_RBRACK] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_RBRACK] = ACTIONS(3768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_with] = ACTIONS(3766),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_to] = ACTIONS(3766),
    [anon_sym_downto] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_end] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_DOT_DOT2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [1104] = {
    [sym_type_arguments] = STATE(1476),
    [sym_long_identifier] = STATE(1483),
    [sym_xml_doc] = STATE(1104),
    [sym_block_comment] = STATE(1104),
    [sym_line_comment] = STATE(1104),
    [sym_compiler_directive_decl] = STATE(1104),
    [sym_fsi_directive_decl] = STATE(1104),
    [sym_preproc_line] = STATE(1104),
    [aux_sym__compound_type_repeat1] = STATE(1435),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3154),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_LT2] = ACTIONS(3634),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3636),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1105] = {
    [sym_xml_doc] = STATE(1105),
    [sym_block_comment] = STATE(1105),
    [sym_line_comment] = STATE(1105),
    [sym_compiler_directive_decl] = STATE(1105),
    [sym_fsi_directive_decl] = STATE(1105),
    [sym_preproc_line] = STATE(1105),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_GT_RBRACK] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_RBRACK] = ACTIONS(3772),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_RBRACE] = ACTIONS(3772),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_with] = ACTIONS(3770),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_to] = ACTIONS(3770),
    [anon_sym_downto] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_end] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_DOT_DOT2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1106] = {
    [sym_type_arguments] = STATE(1480),
    [sym_long_identifier] = STATE(1524),
    [sym_xml_doc] = STATE(1106),
    [sym_block_comment] = STATE(1106),
    [sym_line_comment] = STATE(1106),
    [sym_compiler_directive_decl] = STATE(1106),
    [sym_fsi_directive_decl] = STATE(1106),
    [sym_preproc_line] = STATE(1106),
    [aux_sym__compound_type_repeat1] = STATE(1427),
    [sym_identifier] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_DOT_DOT] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3573),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1107] = {
    [sym_xml_doc] = STATE(1107),
    [sym_block_comment] = STATE(1107),
    [sym_line_comment] = STATE(1107),
    [sym_compiler_directive_decl] = STATE(1107),
    [sym_fsi_directive_decl] = STATE(1107),
    [sym_preproc_line] = STATE(1107),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_GT_RBRACK] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_RBRACK] = ACTIONS(3776),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_to] = ACTIONS(3774),
    [anon_sym_downto] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_end] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_DOT_DOT2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [1108] = {
    [sym_xml_doc] = STATE(1108),
    [sym_block_comment] = STATE(1108),
    [sym_line_comment] = STATE(1108),
    [sym_compiler_directive_decl] = STATE(1108),
    [sym_fsi_directive_decl] = STATE(1108),
    [sym_preproc_line] = STATE(1108),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_GT_RBRACK] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_RBRACK] = ACTIONS(3780),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_RBRACE] = ACTIONS(3780),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_with] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_to] = ACTIONS(3778),
    [anon_sym_downto] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_end] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_DOT_DOT2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [1109] = {
    [sym_xml_doc] = STATE(1109),
    [sym_block_comment] = STATE(1109),
    [sym_line_comment] = STATE(1109),
    [sym_compiler_directive_decl] = STATE(1109),
    [sym_fsi_directive_decl] = STATE(1109),
    [sym_preproc_line] = STATE(1109),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_GT_RBRACK] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_with] = ACTIONS(3782),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_to] = ACTIONS(3782),
    [anon_sym_downto] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_end] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_DOT_DOT2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [1110] = {
    [sym_xml_doc] = STATE(1110),
    [sym_block_comment] = STATE(1110),
    [sym_line_comment] = STATE(1110),
    [sym_compiler_directive_decl] = STATE(1110),
    [sym_fsi_directive_decl] = STATE(1110),
    [sym_preproc_line] = STATE(1110),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_GT_RBRACK] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_RBRACK] = ACTIONS(3788),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_with] = ACTIONS(3786),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_to] = ACTIONS(3786),
    [anon_sym_downto] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_end] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_DOT_DOT2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [1111] = {
    [sym_xml_doc] = STATE(1111),
    [sym_block_comment] = STATE(1111),
    [sym_line_comment] = STATE(1111),
    [sym_compiler_directive_decl] = STATE(1111),
    [sym_fsi_directive_decl] = STATE(1111),
    [sym_preproc_line] = STATE(1111),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_GT_RBRACK] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_RBRACK] = ACTIONS(3792),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_RBRACE] = ACTIONS(3792),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_with] = ACTIONS(3790),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_to] = ACTIONS(3790),
    [anon_sym_downto] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_end] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_DOT_DOT2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [1112] = {
    [sym_xml_doc] = STATE(1112),
    [sym_block_comment] = STATE(1112),
    [sym_line_comment] = STATE(1112),
    [sym_compiler_directive_decl] = STATE(1112),
    [sym_fsi_directive_decl] = STATE(1112),
    [sym_preproc_line] = STATE(1112),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_GT_RBRACK] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_RBRACK] = ACTIONS(3796),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_with] = ACTIONS(3794),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_to] = ACTIONS(3794),
    [anon_sym_downto] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_end] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_DOT_DOT2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [1113] = {
    [sym_xml_doc] = STATE(1113),
    [sym_block_comment] = STATE(1113),
    [sym_line_comment] = STATE(1113),
    [sym_compiler_directive_decl] = STATE(1113),
    [sym_fsi_directive_decl] = STATE(1113),
    [sym_preproc_line] = STATE(1113),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_GT_RBRACK] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_RBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_RBRACE] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_to] = ACTIONS(3798),
    [anon_sym_downto] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_end] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_DOT_DOT2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [1114] = {
    [sym_xml_doc] = STATE(1114),
    [sym_block_comment] = STATE(1114),
    [sym_line_comment] = STATE(1114),
    [sym_compiler_directive_decl] = STATE(1114),
    [sym_fsi_directive_decl] = STATE(1114),
    [sym_preproc_line] = STATE(1114),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_GT_RBRACK] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_RBRACK] = ACTIONS(3804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_RBRACE] = ACTIONS(3804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_with] = ACTIONS(3802),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_to] = ACTIONS(3802),
    [anon_sym_downto] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_end] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_DOT_DOT2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [1115] = {
    [sym_xml_doc] = STATE(1115),
    [sym_block_comment] = STATE(1115),
    [sym_line_comment] = STATE(1115),
    [sym_compiler_directive_decl] = STATE(1115),
    [sym_fsi_directive_decl] = STATE(1115),
    [sym_preproc_line] = STATE(1115),
    [aux_sym_long_identifier_repeat1] = STATE(1053),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3806),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_DOT_DOT2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [1116] = {
    [sym__else_expression] = STATE(1934),
    [sym_elif_expression] = STATE(1569),
    [sym_xml_doc] = STATE(1116),
    [sym_block_comment] = STATE(1116),
    [sym_line_comment] = STATE(1116),
    [sym_compiler_directive_decl] = STATE(1116),
    [sym_fsi_directive_decl] = STATE(1116),
    [sym_preproc_line] = STATE(1116),
    [aux_sym_if_expression_repeat1] = STATE(1135),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_as] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3810),
    [anon_sym_elif] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
    [sym__dedent] = ACTIONS(3251),
  },
  [1117] = {
    [sym_xml_doc] = STATE(1117),
    [sym_block_comment] = STATE(1117),
    [sym_line_comment] = STATE(1117),
    [sym_compiler_directive_decl] = STATE(1117),
    [sym_fsi_directive_decl] = STATE(1117),
    [sym_preproc_line] = STATE(1117),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_GT_RBRACK] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_RBRACK] = ACTIONS(3816),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3816),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_with] = ACTIONS(3814),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_to] = ACTIONS(3814),
    [anon_sym_downto] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_end] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_DOT_DOT2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [1118] = {
    [sym_xml_doc] = STATE(1118),
    [sym_block_comment] = STATE(1118),
    [sym_line_comment] = STATE(1118),
    [sym_compiler_directive_decl] = STATE(1118),
    [sym_fsi_directive_decl] = STATE(1118),
    [sym_preproc_line] = STATE(1118),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_GT_RBRACK] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_RBRACK] = ACTIONS(3820),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3820),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_with] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_to] = ACTIONS(3818),
    [anon_sym_downto] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_end] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_DOT_DOT2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [1119] = {
    [sym_xml_doc] = STATE(1119),
    [sym_block_comment] = STATE(1119),
    [sym_line_comment] = STATE(1119),
    [sym_compiler_directive_decl] = STATE(1119),
    [sym_fsi_directive_decl] = STATE(1119),
    [sym_preproc_line] = STATE(1119),
    [aux_sym__compound_type_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_DOT_DOT2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [1120] = {
    [sym_xml_doc] = STATE(1120),
    [sym_block_comment] = STATE(1120),
    [sym_line_comment] = STATE(1120),
    [sym_compiler_directive_decl] = STATE(1120),
    [sym_fsi_directive_decl] = STATE(1120),
    [sym_preproc_line] = STATE(1120),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_GT_RBRACK] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_RBRACK] = ACTIONS(3312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_to] = ACTIONS(3314),
    [anon_sym_downto] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_end] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_DOT_DOT2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [1121] = {
    [sym_xml_doc] = STATE(1121),
    [sym_block_comment] = STATE(1121),
    [sym_line_comment] = STATE(1121),
    [sym_compiler_directive_decl] = STATE(1121),
    [sym_fsi_directive_decl] = STATE(1121),
    [sym_preproc_line] = STATE(1121),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_GT_RBRACK] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_RBRACK] = ACTIONS(3827),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_with] = ACTIONS(3825),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_to] = ACTIONS(3825),
    [anon_sym_downto] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_end] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_DOT_DOT2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [1122] = {
    [sym_xml_doc] = STATE(1122),
    [sym_block_comment] = STATE(1122),
    [sym_line_comment] = STATE(1122),
    [sym_compiler_directive_decl] = STATE(1122),
    [sym_fsi_directive_decl] = STATE(1122),
    [sym_preproc_line] = STATE(1122),
    [aux_sym_sequential_expression_repeat1] = STATE(1122),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_GT_RBRACK] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_RBRACK] = ACTIONS(3831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(3831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_with] = ACTIONS(3829),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_to] = ACTIONS(3829),
    [anon_sym_downto] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_end] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(3833),
  },
  [1123] = {
    [sym_type_arguments] = STATE(1574),
    [sym_long_identifier] = STATE(1555),
    [sym_xml_doc] = STATE(1123),
    [sym_block_comment] = STATE(1123),
    [sym_line_comment] = STATE(1123),
    [sym_compiler_directive_decl] = STATE(1123),
    [sym_fsi_directive_decl] = STATE(1123),
    [sym_preproc_line] = STATE(1123),
    [aux_sym__compound_type_repeat1] = STATE(1355),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_AT_GT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LT2] = ACTIONS(3756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1124] = {
    [sym_type_arguments] = STATE(1574),
    [sym_long_identifier] = STATE(1555),
    [sym_xml_doc] = STATE(1124),
    [sym_block_comment] = STATE(1124),
    [sym_line_comment] = STATE(1124),
    [sym_compiler_directive_decl] = STATE(1124),
    [sym_fsi_directive_decl] = STATE(1124),
    [sym_preproc_line] = STATE(1124),
    [aux_sym__compound_type_repeat1] = STATE(1355),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_AT_GT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LT2] = ACTIONS(3756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1125] = {
    [sym_xml_doc] = STATE(1125),
    [sym_block_comment] = STATE(1125),
    [sym_line_comment] = STATE(1125),
    [sym_compiler_directive_decl] = STATE(1125),
    [sym_fsi_directive_decl] = STATE(1125),
    [sym_preproc_line] = STATE(1125),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_GT_RBRACK] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_RBRACK] = ACTIONS(3838),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_RBRACE] = ACTIONS(3838),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_with] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_to] = ACTIONS(3836),
    [anon_sym_downto] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_end] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_DOT_DOT2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [1126] = {
    [sym_xml_doc] = STATE(1126),
    [sym_block_comment] = STATE(1126),
    [sym_line_comment] = STATE(1126),
    [sym_compiler_directive_decl] = STATE(1126),
    [sym_fsi_directive_decl] = STATE(1126),
    [sym_preproc_line] = STATE(1126),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_GT_RBRACK] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_to] = ACTIONS(2768),
    [anon_sym_downto] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_end] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1127] = {
    [sym_xml_doc] = STATE(1127),
    [sym_block_comment] = STATE(1127),
    [sym_line_comment] = STATE(1127),
    [sym_compiler_directive_decl] = STATE(1127),
    [sym_fsi_directive_decl] = STATE(1127),
    [sym_preproc_line] = STATE(1127),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_GT_RBRACK] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_RBRACK] = ACTIONS(3842),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_with] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_to] = ACTIONS(3840),
    [anon_sym_downto] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_end] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_DOT_DOT2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [1128] = {
    [sym_type_arguments] = STATE(1574),
    [sym_long_identifier] = STATE(1555),
    [sym_xml_doc] = STATE(1128),
    [sym_block_comment] = STATE(1128),
    [sym_line_comment] = STATE(1128),
    [sym_compiler_directive_decl] = STATE(1128),
    [sym_fsi_directive_decl] = STATE(1128),
    [sym_preproc_line] = STATE(1128),
    [aux_sym__compound_type_repeat1] = STATE(1355),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_AT_GT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LT2] = ACTIONS(3756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1129] = {
    [sym_xml_doc] = STATE(1129),
    [sym_block_comment] = STATE(1129),
    [sym_line_comment] = STATE(1129),
    [sym_compiler_directive_decl] = STATE(1129),
    [sym_fsi_directive_decl] = STATE(1129),
    [sym_preproc_line] = STATE(1129),
    [aux_sym_type_argument_repeat1] = STATE(1063),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3844),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [1130] = {
    [sym_xml_doc] = STATE(1130),
    [sym_block_comment] = STATE(1130),
    [sym_line_comment] = STATE(1130),
    [sym_compiler_directive_decl] = STATE(1130),
    [sym_fsi_directive_decl] = STATE(1130),
    [sym_preproc_line] = STATE(1130),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_namespace] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1131] = {
    [sym_type_arguments] = STATE(1519),
    [sym_long_identifier] = STATE(1598),
    [sym_xml_doc] = STATE(1131),
    [sym_block_comment] = STATE(1131),
    [sym_line_comment] = STATE(1131),
    [sym_compiler_directive_decl] = STATE(1131),
    [sym_fsi_directive_decl] = STATE(1131),
    [sym_preproc_line] = STATE(1131),
    [aux_sym__compound_type_repeat1] = STATE(1388),
    [sym_identifier] = ACTIONS(3760),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_LT2] = ACTIONS(3668),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [anon_sym_POUNDendif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1132] = {
    [sym_type_arguments] = STATE(1519),
    [sym_long_identifier] = STATE(1598),
    [sym_xml_doc] = STATE(1132),
    [sym_block_comment] = STATE(1132),
    [sym_line_comment] = STATE(1132),
    [sym_compiler_directive_decl] = STATE(1132),
    [sym_fsi_directive_decl] = STATE(1132),
    [sym_preproc_line] = STATE(1132),
    [aux_sym__compound_type_repeat1] = STATE(1388),
    [sym_identifier] = ACTIONS(3760),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_LT2] = ACTIONS(3668),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [anon_sym_POUNDendif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1133] = {
    [sym_xml_doc] = STATE(1133),
    [sym_block_comment] = STATE(1133),
    [sym_line_comment] = STATE(1133),
    [sym_compiler_directive_decl] = STATE(1133),
    [sym_fsi_directive_decl] = STATE(1133),
    [sym_preproc_line] = STATE(1133),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_GT_RBRACK] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_RBRACK] = ACTIONS(3849),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_with] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_to] = ACTIONS(3847),
    [anon_sym_downto] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_end] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_DOT_DOT2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [1134] = {
    [sym_xml_doc] = STATE(1134),
    [sym_block_comment] = STATE(1134),
    [sym_line_comment] = STATE(1134),
    [sym_compiler_directive_decl] = STATE(1134),
    [sym_fsi_directive_decl] = STATE(1134),
    [sym_preproc_line] = STATE(1134),
    [ts_builtin_sym_end] = ACTIONS(3419),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_open] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_type] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(3851),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3419),
    [anon_sym_POUNDload] = ACTIONS(3419),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1135] = {
    [sym__else_expression] = STATE(1896),
    [sym_elif_expression] = STATE(1569),
    [sym_xml_doc] = STATE(1135),
    [sym_block_comment] = STATE(1135),
    [sym_line_comment] = STATE(1135),
    [sym_compiler_directive_decl] = STATE(1135),
    [sym_fsi_directive_decl] = STATE(1135),
    [sym_preproc_line] = STATE(1135),
    [aux_sym_if_expression_repeat1] = STATE(1255),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3810),
    [anon_sym_elif] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
    [sym__dedent] = ACTIONS(3283),
  },
  [1136] = {
    [sym_type_arguments] = STATE(1480),
    [sym_long_identifier] = STATE(1524),
    [sym_xml_doc] = STATE(1136),
    [sym_block_comment] = STATE(1136),
    [sym_line_comment] = STATE(1136),
    [sym_compiler_directive_decl] = STATE(1136),
    [sym_fsi_directive_decl] = STATE(1136),
    [sym_preproc_line] = STATE(1136),
    [aux_sym__compound_type_repeat1] = STATE(1427),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_DOT_DOT] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3573),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1137] = {
    [sym_type_arguments] = STATE(1610),
    [sym_long_identifier] = STATE(1583),
    [sym_xml_doc] = STATE(1137),
    [sym_block_comment] = STATE(1137),
    [sym_line_comment] = STATE(1137),
    [sym_compiler_directive_decl] = STATE(1137),
    [sym_fsi_directive_decl] = STATE(1137),
    [sym_preproc_line] = STATE(1137),
    [aux_sym__compound_type_repeat1] = STATE(1279),
    [sym_identifier] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_AT_AT_GT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_LT2] = ACTIONS(3685),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3687),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1138] = {
    [sym_type_arguments] = STATE(1610),
    [sym_long_identifier] = STATE(1583),
    [sym_xml_doc] = STATE(1138),
    [sym_block_comment] = STATE(1138),
    [sym_line_comment] = STATE(1138),
    [sym_compiler_directive_decl] = STATE(1138),
    [sym_fsi_directive_decl] = STATE(1138),
    [sym_preproc_line] = STATE(1138),
    [aux_sym__compound_type_repeat1] = STATE(1279),
    [sym_identifier] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_AT_AT_GT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_LT2] = ACTIONS(3685),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3687),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1139] = {
    [sym_type_arguments] = STATE(1610),
    [sym_long_identifier] = STATE(1583),
    [sym_xml_doc] = STATE(1139),
    [sym_block_comment] = STATE(1139),
    [sym_line_comment] = STATE(1139),
    [sym_compiler_directive_decl] = STATE(1139),
    [sym_fsi_directive_decl] = STATE(1139),
    [sym_preproc_line] = STATE(1139),
    [aux_sym__compound_type_repeat1] = STATE(1279),
    [sym_identifier] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_AT_AT_GT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_LT2] = ACTIONS(3685),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3687),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1140] = {
    [sym_xml_doc] = STATE(1140),
    [sym_block_comment] = STATE(1140),
    [sym_line_comment] = STATE(1140),
    [sym_compiler_directive_decl] = STATE(1140),
    [sym_fsi_directive_decl] = STATE(1140),
    [sym_preproc_line] = STATE(1140),
    [aux_sym_long_identifier_repeat1] = STATE(1162),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [1141] = {
    [sym_xml_doc] = STATE(1141),
    [sym_block_comment] = STATE(1141),
    [sym_line_comment] = STATE(1141),
    [sym_compiler_directive_decl] = STATE(1141),
    [sym_fsi_directive_decl] = STATE(1141),
    [sym_preproc_line] = STATE(1141),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_GT_RBRACK] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_RBRACK] = ACTIONS(3861),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_with] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_to] = ACTIONS(3859),
    [anon_sym_downto] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_end] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_DOT_DOT2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [1142] = {
    [sym_xml_doc] = STATE(1142),
    [sym_block_comment] = STATE(1142),
    [sym_line_comment] = STATE(1142),
    [sym_compiler_directive_decl] = STATE(1142),
    [sym_fsi_directive_decl] = STATE(1142),
    [sym_preproc_line] = STATE(1142),
    [ts_builtin_sym_end] = ACTIONS(3457),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_module] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_open] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_type] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3457),
    [anon_sym_POUNDload] = ACTIONS(3457),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1143] = {
    [sym_xml_doc] = STATE(1143),
    [sym_block_comment] = STATE(1143),
    [sym_line_comment] = STATE(1143),
    [sym_compiler_directive_decl] = STATE(1143),
    [sym_fsi_directive_decl] = STATE(1143),
    [sym_preproc_line] = STATE(1143),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_GT_RBRACK] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_RBRACK] = ACTIONS(3865),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_to] = ACTIONS(3863),
    [anon_sym_downto] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_end] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_DOT_DOT2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [1144] = {
    [sym_xml_doc] = STATE(1144),
    [sym_block_comment] = STATE(1144),
    [sym_line_comment] = STATE(1144),
    [sym_compiler_directive_decl] = STATE(1144),
    [sym_fsi_directive_decl] = STATE(1144),
    [sym_preproc_line] = STATE(1144),
    [aux_sym_rules_repeat1] = STATE(1144),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_module] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3483),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_type] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3870),
  },
  [1145] = {
    [sym_xml_doc] = STATE(1145),
    [sym_block_comment] = STATE(1145),
    [sym_line_comment] = STATE(1145),
    [sym_compiler_directive_decl] = STATE(1145),
    [sym_fsi_directive_decl] = STATE(1145),
    [sym_preproc_line] = STATE(1145),
    [aux_sym_rules_repeat1] = STATE(1144),
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_module] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_open] = ACTIONS(3463),
    [anon_sym_LBRACK_LT] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_type] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3465),
    [anon_sym_POUNDload] = ACTIONS(3465),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(3875),
  },
  [1146] = {
    [sym_xml_doc] = STATE(1146),
    [sym_block_comment] = STATE(1146),
    [sym_line_comment] = STATE(1146),
    [sym_compiler_directive_decl] = STATE(1146),
    [sym_fsi_directive_decl] = STATE(1146),
    [sym_preproc_line] = STATE(1146),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_GT_RBRACK] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_with] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_to] = ACTIONS(3878),
    [anon_sym_downto] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_end] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_DOT_DOT2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [1147] = {
    [sym_xml_doc] = STATE(1147),
    [sym_block_comment] = STATE(1147),
    [sym_line_comment] = STATE(1147),
    [sym_compiler_directive_decl] = STATE(1147),
    [sym_fsi_directive_decl] = STATE(1147),
    [sym_preproc_line] = STATE(1147),
    [aux_sym_long_identifier_repeat1] = STATE(1162),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3882),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [1148] = {
    [sym_type_arguments] = STATE(1519),
    [sym_long_identifier] = STATE(1598),
    [sym_xml_doc] = STATE(1148),
    [sym_block_comment] = STATE(1148),
    [sym_line_comment] = STATE(1148),
    [sym_compiler_directive_decl] = STATE(1148),
    [sym_fsi_directive_decl] = STATE(1148),
    [sym_preproc_line] = STATE(1148),
    [aux_sym__compound_type_repeat1] = STATE(1388),
    [sym_identifier] = ACTIONS(3760),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3664),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_LT2] = ACTIONS(3668),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [anon_sym_POUNDendif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1149] = {
    [sym_xml_doc] = STATE(1149),
    [sym_block_comment] = STATE(1149),
    [sym_line_comment] = STATE(1149),
    [sym_compiler_directive_decl] = STATE(1149),
    [sym_fsi_directive_decl] = STATE(1149),
    [sym_preproc_line] = STATE(1149),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_GT_RBRACK] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_RBRACK] = ACTIONS(3886),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_RBRACE] = ACTIONS(3886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_with] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_to] = ACTIONS(3884),
    [anon_sym_downto] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_end] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_DOT_DOT2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [1150] = {
    [sym_xml_doc] = STATE(1150),
    [sym_block_comment] = STATE(1150),
    [sym_line_comment] = STATE(1150),
    [sym_compiler_directive_decl] = STATE(1150),
    [sym_fsi_directive_decl] = STATE(1150),
    [sym_preproc_line] = STATE(1150),
    [aux_sym__compound_type_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_DOT_DOT2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
    [sym__dedent] = ACTIONS(3214),
  },
  [1151] = {
    [sym_xml_doc] = STATE(1151),
    [sym_block_comment] = STATE(1151),
    [sym_line_comment] = STATE(1151),
    [sym_compiler_directive_decl] = STATE(1151),
    [sym_fsi_directive_decl] = STATE(1151),
    [sym_preproc_line] = STATE(1151),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_GT_RBRACK] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_to] = ACTIONS(3285),
    [anon_sym_downto] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_end] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1152] = {
    [sym_xml_doc] = STATE(1152),
    [sym_block_comment] = STATE(1152),
    [sym_line_comment] = STATE(1152),
    [sym_compiler_directive_decl] = STATE(1152),
    [sym_fsi_directive_decl] = STATE(1152),
    [sym_preproc_line] = STATE(1152),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_GT_RBRACK] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_RBRACK] = ACTIONS(3890),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_RBRACE] = ACTIONS(3890),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_with] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_to] = ACTIONS(3888),
    [anon_sym_downto] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_end] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_DOT_DOT2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [1153] = {
    [sym_xml_doc] = STATE(1153),
    [sym_block_comment] = STATE(1153),
    [sym_line_comment] = STATE(1153),
    [sym_compiler_directive_decl] = STATE(1153),
    [sym_fsi_directive_decl] = STATE(1153),
    [sym_preproc_line] = STATE(1153),
    [aux_sym_long_identifier_repeat1] = STATE(1153),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3892),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1154] = {
    [sym_xml_doc] = STATE(1154),
    [sym_block_comment] = STATE(1154),
    [sym_line_comment] = STATE(1154),
    [sym_compiler_directive_decl] = STATE(1154),
    [sym_fsi_directive_decl] = STATE(1154),
    [sym_preproc_line] = STATE(1154),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_GT_RBRACK] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_with] = ACTIONS(3895),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_to] = ACTIONS(3895),
    [anon_sym_downto] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_end] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_DOT_DOT2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [1155] = {
    [sym_xml_doc] = STATE(1155),
    [sym_block_comment] = STATE(1155),
    [sym_line_comment] = STATE(1155),
    [sym_compiler_directive_decl] = STATE(1155),
    [sym_fsi_directive_decl] = STATE(1155),
    [sym_preproc_line] = STATE(1155),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_GT_RBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3899),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_to] = ACTIONS(3899),
    [anon_sym_downto] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_end] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_DOT_DOT2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [1156] = {
    [sym_xml_doc] = STATE(1156),
    [sym_block_comment] = STATE(1156),
    [sym_line_comment] = STATE(1156),
    [sym_compiler_directive_decl] = STATE(1156),
    [sym_fsi_directive_decl] = STATE(1156),
    [sym_preproc_line] = STATE(1156),
    [aux_sym_rules_repeat1] = STATE(1164),
    [ts_builtin_sym_end] = ACTIONS(3406),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_namespace] = ACTIONS(3404),
    [anon_sym_module] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_open] = ACTIONS(3404),
    [anon_sym_LBRACK_LT] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_type] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3406),
    [anon_sym_POUNDload] = ACTIONS(3406),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(3903),
  },
  [1157] = {
    [sym_type_arguments] = STATE(1480),
    [sym_long_identifier] = STATE(1524),
    [sym_xml_doc] = STATE(1157),
    [sym_block_comment] = STATE(1157),
    [sym_line_comment] = STATE(1157),
    [sym_compiler_directive_decl] = STATE(1157),
    [sym_fsi_directive_decl] = STATE(1157),
    [sym_preproc_line] = STATE(1157),
    [aux_sym__compound_type_repeat1] = STATE(1427),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3569),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_DOT_DOT] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3573),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3575),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1158] = {
    [sym_xml_doc] = STATE(1158),
    [sym_block_comment] = STATE(1158),
    [sym_line_comment] = STATE(1158),
    [sym_compiler_directive_decl] = STATE(1158),
    [sym_fsi_directive_decl] = STATE(1158),
    [sym_preproc_line] = STATE(1158),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3493),
    [anon_sym_module] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_open] = ACTIONS(3493),
    [anon_sym_LBRACK_LT] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_type] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3495),
    [anon_sym_POUNDload] = ACTIONS(3495),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1159] = {
    [sym_type_arguments] = STATE(1476),
    [sym_long_identifier] = STATE(1483),
    [sym_xml_doc] = STATE(1159),
    [sym_block_comment] = STATE(1159),
    [sym_line_comment] = STATE(1159),
    [sym_compiler_directive_decl] = STATE(1159),
    [sym_fsi_directive_decl] = STATE(1159),
    [sym_preproc_line] = STATE(1159),
    [aux_sym__compound_type_repeat1] = STATE(1435),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_COLON_GT] = ACTIONS(3010),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_LT_DASH] = ACTIONS(3012),
    [anon_sym_DOT_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_LT2] = ACTIONS(3634),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3636),
    [anon_sym_or] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3012),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3012),
    [anon_sym_DASH_DOT] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3012),
    [aux_sym_infix_op_token1] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_COLON_EQ] = ACTIONS(3010),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3012),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [1160] = {
    [sym_xml_doc] = STATE(1160),
    [sym_block_comment] = STATE(1160),
    [sym_line_comment] = STATE(1160),
    [sym_compiler_directive_decl] = STATE(1160),
    [sym_fsi_directive_decl] = STATE(1160),
    [sym_preproc_line] = STATE(1160),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_GT_RBRACK] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_RBRACK] = ACTIONS(3908),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_RBRACE] = ACTIONS(3908),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_with] = ACTIONS(3906),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_to] = ACTIONS(3906),
    [anon_sym_downto] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_end] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_DOT_DOT2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [1161] = {
    [sym_xml_doc] = STATE(1161),
    [sym_block_comment] = STATE(1161),
    [sym_line_comment] = STATE(1161),
    [sym_compiler_directive_decl] = STATE(1161),
    [sym_fsi_directive_decl] = STATE(1161),
    [sym_preproc_line] = STATE(1161),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_GT_RBRACK] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_RBRACK] = ACTIONS(3912),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_RBRACE] = ACTIONS(3912),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_with] = ACTIONS(3910),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_to] = ACTIONS(3910),
    [anon_sym_downto] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_end] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_DOT_DOT2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [1162] = {
    [sym_xml_doc] = STATE(1162),
    [sym_block_comment] = STATE(1162),
    [sym_line_comment] = STATE(1162),
    [sym_compiler_directive_decl] = STATE(1162),
    [sym_fsi_directive_decl] = STATE(1162),
    [sym_preproc_line] = STATE(1162),
    [aux_sym_long_identifier_repeat1] = STATE(1153),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3882),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [1163] = {
    [sym_xml_doc] = STATE(1163),
    [sym_block_comment] = STATE(1163),
    [sym_line_comment] = STATE(1163),
    [sym_compiler_directive_decl] = STATE(1163),
    [sym_fsi_directive_decl] = STATE(1163),
    [sym_preproc_line] = STATE(1163),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_GT_RBRACK] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_RBRACK] = ACTIONS(3916),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_RBRACE] = ACTIONS(3916),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_with] = ACTIONS(3914),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_to] = ACTIONS(3914),
    [anon_sym_downto] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_end] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_DOT_DOT2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [1164] = {
    [sym_xml_doc] = STATE(1164),
    [sym_block_comment] = STATE(1164),
    [sym_line_comment] = STATE(1164),
    [sym_compiler_directive_decl] = STATE(1164),
    [sym_fsi_directive_decl] = STATE(1164),
    [sym_preproc_line] = STATE(1164),
    [aux_sym_rules_repeat1] = STATE(1144),
    [ts_builtin_sym_end] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_namespace] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_open] = ACTIONS(3442),
    [anon_sym_LBRACK_LT] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_type] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3444),
    [anon_sym_POUNDload] = ACTIONS(3444),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(3918),
  },
  [1165] = {
    [sym_xml_doc] = STATE(1165),
    [sym_block_comment] = STATE(1165),
    [sym_line_comment] = STATE(1165),
    [sym_compiler_directive_decl] = STATE(1165),
    [sym_fsi_directive_decl] = STATE(1165),
    [sym_preproc_line] = STATE(1165),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_GT_RBRACK] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_RBRACK] = ACTIONS(3923),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3923),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_to] = ACTIONS(3921),
    [anon_sym_downto] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_end] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_DOT_DOT2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [1166] = {
    [sym_xml_doc] = STATE(1166),
    [sym_block_comment] = STATE(1166),
    [sym_line_comment] = STATE(1166),
    [sym_compiler_directive_decl] = STATE(1166),
    [sym_fsi_directive_decl] = STATE(1166),
    [sym_preproc_line] = STATE(1166),
    [aux_sym_rules_repeat1] = STATE(1145),
    [ts_builtin_sym_end] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_namespace] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_open] = ACTIONS(3442),
    [anon_sym_LBRACK_LT] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_type] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3444),
    [anon_sym_POUNDload] = ACTIONS(3444),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(3918),
  },
  [1167] = {
    [sym_type_arguments] = STATE(1610),
    [sym_long_identifier] = STATE(1583),
    [sym_xml_doc] = STATE(1167),
    [sym_block_comment] = STATE(1167),
    [sym_line_comment] = STATE(1167),
    [sym_compiler_directive_decl] = STATE(1167),
    [sym_fsi_directive_decl] = STATE(1167),
    [sym_preproc_line] = STATE(1167),
    [aux_sym__compound_type_repeat1] = STATE(1279),
    [sym_identifier] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_QMARK] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3024),
    [anon_sym_AT_AT_GT] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_COLON_GT] = ACTIONS(3022),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_LT_DASH] = ACTIONS(3024),
    [anon_sym_DOT_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_LT2] = ACTIONS(3685),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3687),
    [anon_sym_or] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3024),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3024),
    [anon_sym_DASH_DOT] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3024),
    [aux_sym_infix_op_token1] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_COLON_EQ] = ACTIONS(3022),
    [anon_sym_DOLLAR] = ACTIONS(3024),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3024),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [1168] = {
    [sym_xml_doc] = STATE(1168),
    [sym_block_comment] = STATE(1168),
    [sym_line_comment] = STATE(1168),
    [sym_compiler_directive_decl] = STATE(1168),
    [sym_fsi_directive_decl] = STATE(1168),
    [sym_preproc_line] = STATE(1168),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_GT_RBRACK] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_to] = ACTIONS(3925),
    [anon_sym_downto] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_end] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_DOT_DOT2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [1169] = {
    [sym_xml_doc] = STATE(1169),
    [sym_block_comment] = STATE(1169),
    [sym_line_comment] = STATE(1169),
    [sym_compiler_directive_decl] = STATE(1169),
    [sym_fsi_directive_decl] = STATE(1169),
    [sym_preproc_line] = STATE(1169),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_GT_RBRACK] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_to] = ACTIONS(3929),
    [anon_sym_downto] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_end] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_DOT_DOT2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [1170] = {
    [sym_xml_doc] = STATE(1170),
    [sym_block_comment] = STATE(1170),
    [sym_line_comment] = STATE(1170),
    [sym_compiler_directive_decl] = STATE(1170),
    [sym_fsi_directive_decl] = STATE(1170),
    [sym_preproc_line] = STATE(1170),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_GT_RBRACK] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_RBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_RBRACE] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_to] = ACTIONS(3933),
    [anon_sym_downto] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_end] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_DOT_DOT2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [1171] = {
    [sym_xml_doc] = STATE(1171),
    [sym_block_comment] = STATE(1171),
    [sym_line_comment] = STATE(1171),
    [sym_compiler_directive_decl] = STATE(1171),
    [sym_fsi_directive_decl] = STATE(1171),
    [sym_preproc_line] = STATE(1171),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_GT_RBRACK] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_RBRACK] = ACTIONS(3939),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_RBRACE] = ACTIONS(3939),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_with] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_to] = ACTIONS(3937),
    [anon_sym_downto] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_end] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_DOT_DOT2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [1172] = {
    [sym_xml_doc] = STATE(1172),
    [sym_block_comment] = STATE(1172),
    [sym_line_comment] = STATE(1172),
    [sym_compiler_directive_decl] = STATE(1172),
    [sym_fsi_directive_decl] = STATE(1172),
    [sym_preproc_line] = STATE(1172),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_GT_RBRACK] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3943),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_with] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_to] = ACTIONS(3941),
    [anon_sym_downto] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_end] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_DOT_DOT2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [1173] = {
    [sym_type_arguments] = STATE(1476),
    [sym_long_identifier] = STATE(1483),
    [sym_xml_doc] = STATE(1173),
    [sym_block_comment] = STATE(1173),
    [sym_line_comment] = STATE(1173),
    [sym_compiler_directive_decl] = STATE(1173),
    [sym_fsi_directive_decl] = STATE(1173),
    [sym_preproc_line] = STATE(1173),
    [aux_sym__compound_type_repeat1] = STATE(1435),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_LT2] = ACTIONS(3634),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3636),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1174] = {
    [sym_xml_doc] = STATE(1174),
    [sym_block_comment] = STATE(1174),
    [sym_line_comment] = STATE(1174),
    [sym_compiler_directive_decl] = STATE(1174),
    [sym_fsi_directive_decl] = STATE(1174),
    [sym_preproc_line] = STATE(1174),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_GT_RBRACK] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_RBRACK] = ACTIONS(3947),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_with] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_to] = ACTIONS(3945),
    [anon_sym_downto] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_end] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_DOT_DOT2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [1175] = {
    [sym_type_arguments] = STATE(1574),
    [sym_long_identifier] = STATE(1555),
    [sym_xml_doc] = STATE(1175),
    [sym_block_comment] = STATE(1175),
    [sym_line_comment] = STATE(1175),
    [sym_compiler_directive_decl] = STATE(1175),
    [sym_fsi_directive_decl] = STATE(1175),
    [sym_preproc_line] = STATE(1175),
    [aux_sym__compound_type_repeat1] = STATE(1355),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_AT_GT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LT2] = ACTIONS(3756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1176] = {
    [sym_xml_doc] = STATE(1176),
    [sym_block_comment] = STATE(1176),
    [sym_line_comment] = STATE(1176),
    [sym_compiler_directive_decl] = STATE(1176),
    [sym_fsi_directive_decl] = STATE(1176),
    [sym_preproc_line] = STATE(1176),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_GT_RBRACK] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_RBRACK] = ACTIONS(3951),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_with] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_to] = ACTIONS(3949),
    [anon_sym_downto] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_end] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_DOT_DOT2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [1177] = {
    [sym_xml_doc] = STATE(1177),
    [sym_block_comment] = STATE(1177),
    [sym_line_comment] = STATE(1177),
    [sym_compiler_directive_decl] = STATE(1177),
    [sym_fsi_directive_decl] = STATE(1177),
    [sym_preproc_line] = STATE(1177),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_GT_RBRACK] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_RBRACK] = ACTIONS(3955),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_with] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_to] = ACTIONS(3953),
    [anon_sym_downto] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_end] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_DOT_DOT2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [1178] = {
    [sym_xml_doc] = STATE(1178),
    [sym_block_comment] = STATE(1178),
    [sym_line_comment] = STATE(1178),
    [sym_compiler_directive_decl] = STATE(1178),
    [sym_fsi_directive_decl] = STATE(1178),
    [sym_preproc_line] = STATE(1178),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_GT_RBRACK] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_RBRACK] = ACTIONS(3959),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_with] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_to] = ACTIONS(3957),
    [anon_sym_downto] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_end] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_DOT_DOT2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [1179] = {
    [sym_xml_doc] = STATE(1179),
    [sym_block_comment] = STATE(1179),
    [sym_line_comment] = STATE(1179),
    [sym_compiler_directive_decl] = STATE(1179),
    [sym_fsi_directive_decl] = STATE(1179),
    [sym_preproc_line] = STATE(1179),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_GT_RBRACK] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_RBRACK] = ACTIONS(3963),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_RBRACE] = ACTIONS(3963),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_with] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_to] = ACTIONS(3961),
    [anon_sym_downto] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_end] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_DOT_DOT2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [1180] = {
    [sym_type_arguments] = STATE(1476),
    [sym_long_identifier] = STATE(1483),
    [sym_xml_doc] = STATE(1180),
    [sym_block_comment] = STATE(1180),
    [sym_line_comment] = STATE(1180),
    [sym_compiler_directive_decl] = STATE(1180),
    [sym_fsi_directive_decl] = STATE(1180),
    [sym_preproc_line] = STATE(1180),
    [aux_sym__compound_type_repeat1] = STATE(1435),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_COLON] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3090),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_QMARK] = ACTIONS(3092),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_COLON_GT] = ACTIONS(3090),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3630),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_LT_DASH] = ACTIONS(3092),
    [anon_sym_DOT_LBRACK] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_GT] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_LPAREN2] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_LT2] = ACTIONS(3634),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3636),
    [anon_sym_or] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3092),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3092),
    [anon_sym_DASH_DOT] = ACTIONS(3092),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3092),
    [aux_sym_infix_op_token1] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_COLON_EQ] = ACTIONS(3090),
    [anon_sym_DOLLAR] = ACTIONS(3092),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3092),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [1181] = {
    [sym_xml_doc] = STATE(1181),
    [sym_block_comment] = STATE(1181),
    [sym_line_comment] = STATE(1181),
    [sym_compiler_directive_decl] = STATE(1181),
    [sym_fsi_directive_decl] = STATE(1181),
    [sym_preproc_line] = STATE(1181),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_GT_RBRACK] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_RBRACK] = ACTIONS(3967),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_with] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_to] = ACTIONS(3965),
    [anon_sym_downto] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_end] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_DOT_DOT2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [1182] = {
    [sym_xml_doc] = STATE(1182),
    [sym_block_comment] = STATE(1182),
    [sym_line_comment] = STATE(1182),
    [sym_compiler_directive_decl] = STATE(1182),
    [sym_fsi_directive_decl] = STATE(1182),
    [sym_preproc_line] = STATE(1182),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_GT_RBRACK] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3971),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3971),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_with] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_to] = ACTIONS(3969),
    [anon_sym_downto] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_end] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_DOT_DOT2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [1183] = {
    [sym_xml_doc] = STATE(1183),
    [sym_block_comment] = STATE(1183),
    [sym_line_comment] = STATE(1183),
    [sym_compiler_directive_decl] = STATE(1183),
    [sym_fsi_directive_decl] = STATE(1183),
    [sym_preproc_line] = STATE(1183),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_GT_RBRACK] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(3975),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_to] = ACTIONS(3973),
    [anon_sym_downto] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_end] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_DOT_DOT2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [1184] = {
    [sym_xml_doc] = STATE(1184),
    [sym_block_comment] = STATE(1184),
    [sym_line_comment] = STATE(1184),
    [sym_compiler_directive_decl] = STATE(1184),
    [sym_fsi_directive_decl] = STATE(1184),
    [sym_preproc_line] = STATE(1184),
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_open] = ACTIONS(3387),
    [anon_sym_LBRACK_LT] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3389),
    [anon_sym_POUNDload] = ACTIONS(3389),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1185] = {
    [sym_xml_doc] = STATE(1185),
    [sym_block_comment] = STATE(1185),
    [sym_line_comment] = STATE(1185),
    [sym_compiler_directive_decl] = STATE(1185),
    [sym_fsi_directive_decl] = STATE(1185),
    [sym_preproc_line] = STATE(1185),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_GT_RBRACK] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_RBRACK] = ACTIONS(3979),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_with] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_to] = ACTIONS(3977),
    [anon_sym_downto] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_end] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_DOT_DOT2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [1186] = {
    [sym_xml_doc] = STATE(1186),
    [sym_block_comment] = STATE(1186),
    [sym_line_comment] = STATE(1186),
    [sym_compiler_directive_decl] = STATE(1186),
    [sym_fsi_directive_decl] = STATE(1186),
    [sym_preproc_line] = STATE(1186),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_module] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_open] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_type] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3457),
    [anon_sym_POUNDload] = ACTIONS(3457),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
    [sym__dedent] = ACTIONS(3457),
  },
  [1187] = {
    [sym_xml_doc] = STATE(1187),
    [sym_block_comment] = STATE(1187),
    [sym_line_comment] = STATE(1187),
    [sym_compiler_directive_decl] = STATE(1187),
    [sym_fsi_directive_decl] = STATE(1187),
    [sym_preproc_line] = STATE(1187),
    [aux_sym_type_argument_repeat1] = STATE(1197),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_as] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1188] = {
    [sym_xml_doc] = STATE(1188),
    [sym_block_comment] = STATE(1188),
    [sym_line_comment] = STATE(1188),
    [sym_compiler_directive_decl] = STATE(1188),
    [sym_fsi_directive_decl] = STATE(1188),
    [sym_preproc_line] = STATE(1188),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_DOT_DOT2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
    [sym__dedent] = ACTIONS(3320),
  },
  [1189] = {
    [sym_xml_doc] = STATE(1189),
    [sym_block_comment] = STATE(1189),
    [sym_line_comment] = STATE(1189),
    [sym_compiler_directive_decl] = STATE(1189),
    [sym_fsi_directive_decl] = STATE(1189),
    [sym_preproc_line] = STATE(1189),
    [aux_sym_long_identifier_repeat1] = STATE(1224),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [anon_sym_POUNDendif] = ACTIONS(3259),
    [anon_sym_POUNDelse] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1190] = {
    [sym_xml_doc] = STATE(1190),
    [sym_block_comment] = STATE(1190),
    [sym_line_comment] = STATE(1190),
    [sym_compiler_directive_decl] = STATE(1190),
    [sym_fsi_directive_decl] = STATE(1190),
    [sym_preproc_line] = STATE(1190),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
    [sym__dedent] = ACTIONS(3324),
  },
  [1191] = {
    [sym_xml_doc] = STATE(1191),
    [sym_block_comment] = STATE(1191),
    [sym_line_comment] = STATE(1191),
    [sym_compiler_directive_decl] = STATE(1191),
    [sym_fsi_directive_decl] = STATE(1191),
    [sym_preproc_line] = STATE(1191),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
    [sym__dedent] = ACTIONS(3298),
  },
  [1192] = {
    [sym_xml_doc] = STATE(1192),
    [sym_block_comment] = STATE(1192),
    [sym_line_comment] = STATE(1192),
    [sym_compiler_directive_decl] = STATE(1192),
    [sym_fsi_directive_decl] = STATE(1192),
    [sym_preproc_line] = STATE(1192),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_module] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_open] = ACTIONS(3493),
    [anon_sym_LBRACK_LT] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_type] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3495),
    [anon_sym_POUNDload] = ACTIONS(3495),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
  },
  [1193] = {
    [sym_xml_doc] = STATE(1193),
    [sym_block_comment] = STATE(1193),
    [sym_line_comment] = STATE(1193),
    [sym_compiler_directive_decl] = STATE(1193),
    [sym_fsi_directive_decl] = STATE(1193),
    [sym_preproc_line] = STATE(1193),
    [aux_sym_sequential_expression_repeat1] = STATE(1193),
    [ts_builtin_sym_end] = ACTIONS(3831),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_namespace] = ACTIONS(3829),
    [anon_sym_module] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_open] = ACTIONS(3829),
    [anon_sym_LBRACK_LT] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_type] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3831),
    [anon_sym_POUNDload] = ACTIONS(3831),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(3983),
  },
  [1194] = {
    [sym_xml_doc] = STATE(1194),
    [sym_block_comment] = STATE(1194),
    [sym_line_comment] = STATE(1194),
    [sym_compiler_directive_decl] = STATE(1194),
    [sym_fsi_directive_decl] = STATE(1194),
    [sym_preproc_line] = STATE(1194),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_DOT_DOT2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [1195] = {
    [sym_xml_doc] = STATE(1195),
    [sym_block_comment] = STATE(1195),
    [sym_line_comment] = STATE(1195),
    [sym_compiler_directive_decl] = STATE(1195),
    [sym_fsi_directive_decl] = STATE(1195),
    [sym_preproc_line] = STATE(1195),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3453),
    [anon_sym_POUNDload] = ACTIONS(3453),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
    [sym__dedent] = ACTIONS(3453),
  },
  [1196] = {
    [sym_xml_doc] = STATE(1196),
    [sym_block_comment] = STATE(1196),
    [sym_line_comment] = STATE(1196),
    [sym_compiler_directive_decl] = STATE(1196),
    [sym_fsi_directive_decl] = STATE(1196),
    [sym_preproc_line] = STATE(1196),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_DOT_DOT2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
    [sym__dedent] = ACTIONS(3363),
  },
  [1197] = {
    [sym_xml_doc] = STATE(1197),
    [sym_block_comment] = STATE(1197),
    [sym_line_comment] = STATE(1197),
    [sym_compiler_directive_decl] = STATE(1197),
    [sym_fsi_directive_decl] = STATE(1197),
    [sym_preproc_line] = STATE(1197),
    [aux_sym_type_argument_repeat1] = STATE(1197),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3986),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1198] = {
    [sym_xml_doc] = STATE(1198),
    [sym_block_comment] = STATE(1198),
    [sym_line_comment] = STATE(1198),
    [sym_compiler_directive_decl] = STATE(1198),
    [sym_fsi_directive_decl] = STATE(1198),
    [sym_preproc_line] = STATE(1198),
    [aux_sym_long_identifier_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(3989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1199] = {
    [sym_xml_doc] = STATE(1199),
    [sym_block_comment] = STATE(1199),
    [sym_line_comment] = STATE(1199),
    [sym_compiler_directive_decl] = STATE(1199),
    [sym_fsi_directive_decl] = STATE(1199),
    [sym_preproc_line] = STATE(1199),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_DOT_DOT2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
    [sym__dedent] = ACTIONS(3342),
  },
  [1200] = {
    [sym_xml_doc] = STATE(1200),
    [sym_block_comment] = STATE(1200),
    [sym_line_comment] = STATE(1200),
    [sym_compiler_directive_decl] = STATE(1200),
    [sym_fsi_directive_decl] = STATE(1200),
    [sym_preproc_line] = STATE(1200),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1201] = {
    [sym_xml_doc] = STATE(1201),
    [sym_block_comment] = STATE(1201),
    [sym_line_comment] = STATE(1201),
    [sym_compiler_directive_decl] = STATE(1201),
    [sym_fsi_directive_decl] = STATE(1201),
    [sym_preproc_line] = STATE(1201),
    [ts_builtin_sym_end] = ACTIONS(3556),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_namespace] = ACTIONS(3554),
    [anon_sym_module] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_open] = ACTIONS(3554),
    [anon_sym_LBRACK_LT] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_type] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(3991),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3556),
    [anon_sym_POUNDload] = ACTIONS(3556),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [1202] = {
    [sym_xml_doc] = STATE(1202),
    [sym_block_comment] = STATE(1202),
    [sym_line_comment] = STATE(1202),
    [sym_compiler_directive_decl] = STATE(1202),
    [sym_fsi_directive_decl] = STATE(1202),
    [sym_preproc_line] = STATE(1202),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
    [sym__dedent] = ACTIONS(3310),
  },
  [1203] = {
    [sym_xml_doc] = STATE(1203),
    [sym_block_comment] = STATE(1203),
    [sym_line_comment] = STATE(1203),
    [sym_compiler_directive_decl] = STATE(1203),
    [sym_fsi_directive_decl] = STATE(1203),
    [sym_preproc_line] = STATE(1203),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [1204] = {
    [sym_xml_doc] = STATE(1204),
    [sym_block_comment] = STATE(1204),
    [sym_line_comment] = STATE(1204),
    [sym_compiler_directive_decl] = STATE(1204),
    [sym_fsi_directive_decl] = STATE(1204),
    [sym_preproc_line] = STATE(1204),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
    [sym__dedent] = ACTIONS(3302),
  },
  [1205] = {
    [sym_elif_expression] = STATE(1465),
    [sym_xml_doc] = STATE(1205),
    [sym_block_comment] = STATE(1205),
    [sym_line_comment] = STATE(1205),
    [sym_compiler_directive_decl] = STATE(1205),
    [sym_fsi_directive_decl] = STATE(1205),
    [sym_preproc_line] = STATE(1205),
    [aux_sym_if_expression_repeat1] = STATE(1205),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(3993),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_DOT_DOT2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
    [sym__dedent] = ACTIONS(3346),
  },
  [1206] = {
    [sym_xml_doc] = STATE(1206),
    [sym_block_comment] = STATE(1206),
    [sym_line_comment] = STATE(1206),
    [sym_compiler_directive_decl] = STATE(1206),
    [sym_fsi_directive_decl] = STATE(1206),
    [sym_preproc_line] = STATE(1206),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_DOT_DOT2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
    [sym__dedent] = ACTIONS(3298),
  },
  [1207] = {
    [sym_xml_doc] = STATE(1207),
    [sym_block_comment] = STATE(1207),
    [sym_line_comment] = STATE(1207),
    [sym_compiler_directive_decl] = STATE(1207),
    [sym_fsi_directive_decl] = STATE(1207),
    [sym_preproc_line] = STATE(1207),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_open] = ACTIONS(3387),
    [anon_sym_LBRACK_LT] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3389),
    [anon_sym_POUNDload] = ACTIONS(3389),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
    [sym__dedent] = ACTIONS(3389),
  },
  [1208] = {
    [sym_xml_doc] = STATE(1208),
    [sym_block_comment] = STATE(1208),
    [sym_line_comment] = STATE(1208),
    [sym_compiler_directive_decl] = STATE(1208),
    [sym_fsi_directive_decl] = STATE(1208),
    [sym_preproc_line] = STATE(1208),
    [aux_sym_sequential_expression_repeat1] = STATE(1193),
    [ts_builtin_sym_end] = ACTIONS(3614),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3612),
    [anon_sym_module] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_open] = ACTIONS(3612),
    [anon_sym_LBRACK_LT] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_type] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3614),
    [anon_sym_POUNDload] = ACTIONS(3614),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1209] = {
    [sym_xml_doc] = STATE(1209),
    [sym_block_comment] = STATE(1209),
    [sym_line_comment] = STATE(1209),
    [sym_compiler_directive_decl] = STATE(1209),
    [sym_fsi_directive_decl] = STATE(1209),
    [sym_preproc_line] = STATE(1209),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_as] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
    [sym__dedent] = ACTIONS(3363),
  },
  [1210] = {
    [sym_xml_doc] = STATE(1210),
    [sym_block_comment] = STATE(1210),
    [sym_line_comment] = STATE(1210),
    [sym_compiler_directive_decl] = STATE(1210),
    [sym_fsi_directive_decl] = STATE(1210),
    [sym_preproc_line] = STATE(1210),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_namespace] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1211] = {
    [sym_xml_doc] = STATE(1211),
    [sym_block_comment] = STATE(1211),
    [sym_line_comment] = STATE(1211),
    [sym_compiler_directive_decl] = STATE(1211),
    [sym_fsi_directive_decl] = STATE(1211),
    [sym_preproc_line] = STATE(1211),
    [aux_sym_long_identifier_repeat1] = STATE(1211),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1212] = {
    [sym_xml_doc] = STATE(1212),
    [sym_block_comment] = STATE(1212),
    [sym_line_comment] = STATE(1212),
    [sym_compiler_directive_decl] = STATE(1212),
    [sym_fsi_directive_decl] = STATE(1212),
    [sym_preproc_line] = STATE(1212),
    [aux_sym__compound_type_repeat1] = STATE(1236),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [anon_sym_POUNDendif] = ACTIONS(3214),
    [anon_sym_POUNDelse] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1213] = {
    [sym_xml_doc] = STATE(1213),
    [sym_block_comment] = STATE(1213),
    [sym_line_comment] = STATE(1213),
    [sym_compiler_directive_decl] = STATE(1213),
    [sym_fsi_directive_decl] = STATE(1213),
    [sym_preproc_line] = STATE(1213),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_DOT_DOT2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
    [sym__dedent] = ACTIONS(3302),
  },
  [1214] = {
    [sym_xml_doc] = STATE(1214),
    [sym_block_comment] = STATE(1214),
    [sym_line_comment] = STATE(1214),
    [sym_compiler_directive_decl] = STATE(1214),
    [sym_fsi_directive_decl] = STATE(1214),
    [sym_preproc_line] = STATE(1214),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1215] = {
    [sym_xml_doc] = STATE(1215),
    [sym_block_comment] = STATE(1215),
    [sym_line_comment] = STATE(1215),
    [sym_compiler_directive_decl] = STATE(1215),
    [sym_fsi_directive_decl] = STATE(1215),
    [sym_preproc_line] = STATE(1215),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [1216] = {
    [sym_xml_doc] = STATE(1216),
    [sym_block_comment] = STATE(1216),
    [sym_line_comment] = STATE(1216),
    [sym_compiler_directive_decl] = STATE(1216),
    [sym_fsi_directive_decl] = STATE(1216),
    [sym_preproc_line] = STATE(1216),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_DOT_DOT2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [1217] = {
    [sym_xml_doc] = STATE(1217),
    [sym_block_comment] = STATE(1217),
    [sym_line_comment] = STATE(1217),
    [sym_compiler_directive_decl] = STATE(1217),
    [sym_fsi_directive_decl] = STATE(1217),
    [sym_preproc_line] = STATE(1217),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_DOT_DOT2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
    [sym__dedent] = ACTIONS(3294),
  },
  [1218] = {
    [sym_xml_doc] = STATE(1218),
    [sym_block_comment] = STATE(1218),
    [sym_line_comment] = STATE(1218),
    [sym_compiler_directive_decl] = STATE(1218),
    [sym_fsi_directive_decl] = STATE(1218),
    [sym_preproc_line] = STATE(1218),
    [aux_sym_rules_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_module] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3483),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_type] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3999),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4002),
    [sym__dedent] = ACTIONS(3485),
  },
  [1219] = {
    [sym_xml_doc] = STATE(1219),
    [sym_block_comment] = STATE(1219),
    [sym_line_comment] = STATE(1219),
    [sym_compiler_directive_decl] = STATE(1219),
    [sym_fsi_directive_decl] = STATE(1219),
    [sym_preproc_line] = STATE(1219),
    [aux_sym_rules_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_module] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_open] = ACTIONS(3463),
    [anon_sym_LBRACK_LT] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_type] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3465),
    [anon_sym_POUNDload] = ACTIONS(3465),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4007),
    [sym__dedent] = ACTIONS(3465),
  },
  [1220] = {
    [sym_xml_doc] = STATE(1220),
    [sym_block_comment] = STATE(1220),
    [sym_line_comment] = STATE(1220),
    [sym_compiler_directive_decl] = STATE(1220),
    [sym_fsi_directive_decl] = STATE(1220),
    [sym_preproc_line] = STATE(1220),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_open] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_type] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4010),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3419),
    [anon_sym_POUNDload] = ACTIONS(3419),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
    [sym__dedent] = ACTIONS(3419),
  },
  [1221] = {
    [sym_xml_doc] = STATE(1221),
    [sym_block_comment] = STATE(1221),
    [sym_line_comment] = STATE(1221),
    [sym_compiler_directive_decl] = STATE(1221),
    [sym_fsi_directive_decl] = STATE(1221),
    [sym_preproc_line] = STATE(1221),
    [aux_sym_rules_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_open] = ACTIONS(3442),
    [anon_sym_LBRACK_LT] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_type] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3444),
    [anon_sym_POUNDload] = ACTIONS(3444),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4012),
    [sym__dedent] = ACTIONS(3444),
  },
  [1222] = {
    [sym_xml_doc] = STATE(1222),
    [sym_block_comment] = STATE(1222),
    [sym_line_comment] = STATE(1222),
    [sym_compiler_directive_decl] = STATE(1222),
    [sym_fsi_directive_decl] = STATE(1222),
    [sym_preproc_line] = STATE(1222),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_DOT_DOT2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1223] = {
    [sym_xml_doc] = STATE(1223),
    [sym_block_comment] = STATE(1223),
    [sym_line_comment] = STATE(1223),
    [sym_compiler_directive_decl] = STATE(1223),
    [sym_fsi_directive_decl] = STATE(1223),
    [sym_preproc_line] = STATE(1223),
    [aux_sym_rules_repeat1] = STATE(1219),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_open] = ACTIONS(3442),
    [anon_sym_LBRACK_LT] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_type] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3444),
    [anon_sym_POUNDload] = ACTIONS(3444),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4012),
    [sym__dedent] = ACTIONS(3444),
  },
  [1224] = {
    [sym_xml_doc] = STATE(1224),
    [sym_block_comment] = STATE(1224),
    [sym_line_comment] = STATE(1224),
    [sym_compiler_directive_decl] = STATE(1224),
    [sym_fsi_directive_decl] = STATE(1224),
    [sym_preproc_line] = STATE(1224),
    [aux_sym_long_identifier_repeat1] = STATE(1228),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [anon_sym_POUNDendif] = ACTIONS(3204),
    [anon_sym_POUNDelse] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1225] = {
    [sym_xml_doc] = STATE(1225),
    [sym_block_comment] = STATE(1225),
    [sym_line_comment] = STATE(1225),
    [sym_compiler_directive_decl] = STATE(1225),
    [sym_fsi_directive_decl] = STATE(1225),
    [sym_preproc_line] = STATE(1225),
    [aux_sym_long_identifier_repeat1] = STATE(1224),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [anon_sym_POUNDendif] = ACTIONS(3264),
    [anon_sym_POUNDelse] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1226] = {
    [sym_xml_doc] = STATE(1226),
    [sym_block_comment] = STATE(1226),
    [sym_line_comment] = STATE(1226),
    [sym_compiler_directive_decl] = STATE(1226),
    [sym_fsi_directive_decl] = STATE(1226),
    [sym_preproc_line] = STATE(1226),
    [aux_sym_type_argument_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(4021),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [anon_sym_POUNDendif] = ACTIONS(3276),
    [anon_sym_POUNDelse] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1227] = {
    [sym_xml_doc] = STATE(1227),
    [sym_block_comment] = STATE(1227),
    [sym_line_comment] = STATE(1227),
    [sym_compiler_directive_decl] = STATE(1227),
    [sym_fsi_directive_decl] = STATE(1227),
    [sym_preproc_line] = STATE(1227),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_open] = ACTIONS(3507),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1228] = {
    [sym_xml_doc] = STATE(1228),
    [sym_block_comment] = STATE(1228),
    [sym_line_comment] = STATE(1228),
    [sym_compiler_directive_decl] = STATE(1228),
    [sym_fsi_directive_decl] = STATE(1228),
    [sym_preproc_line] = STATE(1228),
    [aux_sym_long_identifier_repeat1] = STATE(1228),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [anon_sym_POUNDelse] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1229] = {
    [sym__else_expression] = STATE(2329),
    [sym_elif_expression] = STATE(1736),
    [sym_xml_doc] = STATE(1229),
    [sym_block_comment] = STATE(1229),
    [sym_line_comment] = STATE(1229),
    [sym_compiler_directive_decl] = STATE(1229),
    [sym_fsi_directive_decl] = STATE(1229),
    [sym_preproc_line] = STATE(1229),
    [aux_sym_if_expression_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4027),
    [anon_sym_elif] = ACTIONS(4029),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [anon_sym_POUNDendif] = ACTIONS(3251),
    [anon_sym_POUNDelse] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1230] = {
    [sym_xml_doc] = STATE(1230),
    [sym_block_comment] = STATE(1230),
    [sym_line_comment] = STATE(1230),
    [sym_compiler_directive_decl] = STATE(1230),
    [sym_fsi_directive_decl] = STATE(1230),
    [sym_preproc_line] = STATE(1230),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1231] = {
    [sym_xml_doc] = STATE(1231),
    [sym_block_comment] = STATE(1231),
    [sym_line_comment] = STATE(1231),
    [sym_compiler_directive_decl] = STATE(1231),
    [sym_fsi_directive_decl] = STATE(1231),
    [sym_preproc_line] = STATE(1231),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_DOT_DOT2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [1232] = {
    [sym_xml_doc] = STATE(1232),
    [sym_block_comment] = STATE(1232),
    [sym_line_comment] = STATE(1232),
    [sym_compiler_directive_decl] = STATE(1232),
    [sym_fsi_directive_decl] = STATE(1232),
    [sym_preproc_line] = STATE(1232),
    [aux_sym_type_argument_repeat1] = STATE(1265),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4031),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [anon_sym_POUNDendif] = ACTIONS(3244),
    [anon_sym_POUNDelse] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1233] = {
    [sym__else_expression] = STATE(2345),
    [sym_elif_expression] = STATE(1736),
    [sym_xml_doc] = STATE(1233),
    [sym_block_comment] = STATE(1233),
    [sym_line_comment] = STATE(1233),
    [sym_compiler_directive_decl] = STATE(1233),
    [sym_fsi_directive_decl] = STATE(1233),
    [sym_preproc_line] = STATE(1233),
    [aux_sym_if_expression_repeat1] = STATE(1339),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4027),
    [anon_sym_elif] = ACTIONS(4029),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [anon_sym_POUNDendif] = ACTIONS(3283),
    [anon_sym_POUNDelse] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1234] = {
    [sym_xml_doc] = STATE(1234),
    [sym_block_comment] = STATE(1234),
    [sym_line_comment] = STATE(1234),
    [sym_compiler_directive_decl] = STATE(1234),
    [sym_fsi_directive_decl] = STATE(1234),
    [sym_preproc_line] = STATE(1234),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_DOT_DOT2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
    [sym__dedent] = ACTIONS(3306),
  },
  [1235] = {
    [sym_xml_doc] = STATE(1235),
    [sym_block_comment] = STATE(1235),
    [sym_line_comment] = STATE(1235),
    [sym_compiler_directive_decl] = STATE(1235),
    [sym_fsi_directive_decl] = STATE(1235),
    [sym_preproc_line] = STATE(1235),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1236] = {
    [sym_xml_doc] = STATE(1236),
    [sym_block_comment] = STATE(1236),
    [sym_line_comment] = STATE(1236),
    [sym_compiler_directive_decl] = STATE(1236),
    [sym_fsi_directive_decl] = STATE(1236),
    [sym_preproc_line] = STATE(1236),
    [aux_sym__compound_type_repeat1] = STATE(1236),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4036),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [anon_sym_POUNDendif] = ACTIONS(3030),
    [anon_sym_POUNDelse] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1237] = {
    [sym_xml_doc] = STATE(1237),
    [sym_block_comment] = STATE(1237),
    [sym_line_comment] = STATE(1237),
    [sym_compiler_directive_decl] = STATE(1237),
    [sym_fsi_directive_decl] = STATE(1237),
    [sym_preproc_line] = STATE(1237),
    [aux_sym_long_identifier_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1238] = {
    [sym_xml_doc] = STATE(1238),
    [sym_block_comment] = STATE(1238),
    [sym_line_comment] = STATE(1238),
    [sym_compiler_directive_decl] = STATE(1238),
    [sym_fsi_directive_decl] = STATE(1238),
    [sym_preproc_line] = STATE(1238),
    [aux_sym_rules_repeat1] = STATE(1221),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_module] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_open] = ACTIONS(3404),
    [anon_sym_LBRACK_LT] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_type] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3406),
    [anon_sym_POUNDload] = ACTIONS(3406),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4043),
    [sym__dedent] = ACTIONS(3406),
  },
  [1239] = {
    [sym_xml_doc] = STATE(1239),
    [sym_block_comment] = STATE(1239),
    [sym_line_comment] = STATE(1239),
    [sym_compiler_directive_decl] = STATE(1239),
    [sym_fsi_directive_decl] = STATE(1239),
    [sym_preproc_line] = STATE(1239),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_DOT_DOT2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
    [sym__dedent] = ACTIONS(3310),
  },
  [1240] = {
    [sym__else_expression] = STATE(2105),
    [sym_elif_expression] = STATE(1699),
    [sym_xml_doc] = STATE(1240),
    [sym_block_comment] = STATE(1240),
    [sym_line_comment] = STATE(1240),
    [sym_compiler_directive_decl] = STATE(1240),
    [sym_fsi_directive_decl] = STATE(1240),
    [sym_preproc_line] = STATE(1240),
    [aux_sym_if_expression_repeat1] = STATE(1272),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_as] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4046),
    [anon_sym_elif] = ACTIONS(4048),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1241] = {
    [sym_xml_doc] = STATE(1241),
    [sym_block_comment] = STATE(1241),
    [sym_line_comment] = STATE(1241),
    [sym_compiler_directive_decl] = STATE(1241),
    [sym_fsi_directive_decl] = STATE(1241),
    [sym_preproc_line] = STATE(1241),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
    [sym__dedent] = ACTIONS(3306),
  },
  [1242] = {
    [sym_xml_doc] = STATE(1242),
    [sym_block_comment] = STATE(1242),
    [sym_line_comment] = STATE(1242),
    [sym_compiler_directive_decl] = STATE(1242),
    [sym_fsi_directive_decl] = STATE(1242),
    [sym_preproc_line] = STATE(1242),
    [aux_sym__compound_type_repeat1] = STATE(1251),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_as] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1243] = {
    [sym_xml_doc] = STATE(1243),
    [sym_block_comment] = STATE(1243),
    [sym_line_comment] = STATE(1243),
    [sym_compiler_directive_decl] = STATE(1243),
    [sym_fsi_directive_decl] = STATE(1243),
    [sym_preproc_line] = STATE(1243),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
    [sym__dedent] = ACTIONS(3294),
  },
  [1244] = {
    [sym_xml_doc] = STATE(1244),
    [sym_block_comment] = STATE(1244),
    [sym_line_comment] = STATE(1244),
    [sym_compiler_directive_decl] = STATE(1244),
    [sym_fsi_directive_decl] = STATE(1244),
    [sym_preproc_line] = STATE(1244),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1245] = {
    [sym_xml_doc] = STATE(1245),
    [sym_block_comment] = STATE(1245),
    [sym_line_comment] = STATE(1245),
    [sym_compiler_directive_decl] = STATE(1245),
    [sym_fsi_directive_decl] = STATE(1245),
    [sym_preproc_line] = STATE(1245),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
    [sym__dedent] = ACTIONS(3320),
  },
  [1246] = {
    [sym_xml_doc] = STATE(1246),
    [sym_block_comment] = STATE(1246),
    [sym_line_comment] = STATE(1246),
    [sym_compiler_directive_decl] = STATE(1246),
    [sym_fsi_directive_decl] = STATE(1246),
    [sym_preproc_line] = STATE(1246),
    [ts_builtin_sym_end] = ACTIONS(3535),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3533),
    [anon_sym_module] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_open] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_type] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3535),
    [anon_sym_POUNDload] = ACTIONS(3535),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [1247] = {
    [sym_xml_doc] = STATE(1247),
    [sym_block_comment] = STATE(1247),
    [sym_line_comment] = STATE(1247),
    [sym_compiler_directive_decl] = STATE(1247),
    [sym_fsi_directive_decl] = STATE(1247),
    [sym_preproc_line] = STATE(1247),
    [aux_sym_long_identifier_repeat1] = STATE(1211),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1248] = {
    [sym_xml_doc] = STATE(1248),
    [sym_block_comment] = STATE(1248),
    [sym_line_comment] = STATE(1248),
    [sym_compiler_directive_decl] = STATE(1248),
    [sym_fsi_directive_decl] = STATE(1248),
    [sym_preproc_line] = STATE(1248),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
    [sym__dedent] = ACTIONS(3338),
  },
  [1249] = {
    [sym_xml_doc] = STATE(1249),
    [sym_block_comment] = STATE(1249),
    [sym_line_comment] = STATE(1249),
    [sym_compiler_directive_decl] = STATE(1249),
    [sym_fsi_directive_decl] = STATE(1249),
    [sym_preproc_line] = STATE(1249),
    [aux_sym_long_identifier_repeat1] = STATE(1258),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1250] = {
    [sym_xml_doc] = STATE(1250),
    [sym_block_comment] = STATE(1250),
    [sym_line_comment] = STATE(1250),
    [sym_compiler_directive_decl] = STATE(1250),
    [sym_fsi_directive_decl] = STATE(1250),
    [sym_preproc_line] = STATE(1250),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_DOT_DOT2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
    [sym__dedent] = ACTIONS(3338),
  },
  [1251] = {
    [sym_xml_doc] = STATE(1251),
    [sym_block_comment] = STATE(1251),
    [sym_line_comment] = STATE(1251),
    [sym_compiler_directive_decl] = STATE(1251),
    [sym_fsi_directive_decl] = STATE(1251),
    [sym_preproc_line] = STATE(1251),
    [aux_sym__compound_type_repeat1] = STATE(1251),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4052),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1252] = {
    [sym_xml_doc] = STATE(1252),
    [sym_block_comment] = STATE(1252),
    [sym_line_comment] = STATE(1252),
    [sym_compiler_directive_decl] = STATE(1252),
    [sym_fsi_directive_decl] = STATE(1252),
    [sym_preproc_line] = STATE(1252),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1253] = {
    [sym_xml_doc] = STATE(1253),
    [sym_block_comment] = STATE(1253),
    [sym_line_comment] = STATE(1253),
    [sym_compiler_directive_decl] = STATE(1253),
    [sym_fsi_directive_decl] = STATE(1253),
    [sym_preproc_line] = STATE(1253),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
    [sym__dedent] = ACTIONS(3342),
  },
  [1254] = {
    [sym_xml_doc] = STATE(1254),
    [sym_block_comment] = STATE(1254),
    [sym_line_comment] = STATE(1254),
    [sym_compiler_directive_decl] = STATE(1254),
    [sym_fsi_directive_decl] = STATE(1254),
    [sym_preproc_line] = STATE(1254),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_DOT_DOT2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4055),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
    [sym__dedent] = ACTIONS(3357),
  },
  [1255] = {
    [sym_elif_expression] = STATE(1569),
    [sym_xml_doc] = STATE(1255),
    [sym_block_comment] = STATE(1255),
    [sym_line_comment] = STATE(1255),
    [sym_compiler_directive_decl] = STATE(1255),
    [sym_fsi_directive_decl] = STATE(1255),
    [sym_preproc_line] = STATE(1255),
    [aux_sym_if_expression_repeat1] = STATE(1255),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4057),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
    [sym__dedent] = ACTIONS(3346),
  },
  [1256] = {
    [sym_xml_doc] = STATE(1256),
    [sym_block_comment] = STATE(1256),
    [sym_line_comment] = STATE(1256),
    [sym_compiler_directive_decl] = STATE(1256),
    [sym_fsi_directive_decl] = STATE(1256),
    [sym_preproc_line] = STATE(1256),
    [aux_sym_type_argument_repeat1] = STATE(1187),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4060),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1257] = {
    [sym_xml_doc] = STATE(1257),
    [sym_block_comment] = STATE(1257),
    [sym_line_comment] = STATE(1257),
    [sym_compiler_directive_decl] = STATE(1257),
    [sym_fsi_directive_decl] = STATE(1257),
    [sym_preproc_line] = STATE(1257),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [1258] = {
    [sym_xml_doc] = STATE(1258),
    [sym_block_comment] = STATE(1258),
    [sym_line_comment] = STATE(1258),
    [sym_compiler_directive_decl] = STATE(1258),
    [sym_fsi_directive_decl] = STATE(1258),
    [sym_preproc_line] = STATE(1258),
    [aux_sym_long_identifier_repeat1] = STATE(1258),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1259] = {
    [sym_xml_doc] = STATE(1259),
    [sym_block_comment] = STATE(1259),
    [sym_line_comment] = STATE(1259),
    [sym_compiler_directive_decl] = STATE(1259),
    [sym_fsi_directive_decl] = STATE(1259),
    [sym_preproc_line] = STATE(1259),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_open] = ACTIONS(3527),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3529),
    [anon_sym_POUNDload] = ACTIONS(3529),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1260] = {
    [sym_xml_doc] = STATE(1260),
    [sym_block_comment] = STATE(1260),
    [sym_line_comment] = STATE(1260),
    [sym_compiler_directive_decl] = STATE(1260),
    [sym_fsi_directive_decl] = STATE(1260),
    [sym_preproc_line] = STATE(1260),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(2864),
    [aux_sym_decimal_token1] = ACTIONS(2854),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [1261] = {
    [sym_xml_doc] = STATE(1261),
    [sym_block_comment] = STATE(1261),
    [sym_line_comment] = STATE(1261),
    [sym_compiler_directive_decl] = STATE(1261),
    [sym_fsi_directive_decl] = STATE(1261),
    [sym_preproc_line] = STATE(1261),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [1262] = {
    [sym_xml_doc] = STATE(1262),
    [sym_block_comment] = STATE(1262),
    [sym_line_comment] = STATE(1262),
    [sym_compiler_directive_decl] = STATE(1262),
    [sym_fsi_directive_decl] = STATE(1262),
    [sym_preproc_line] = STATE(1262),
    [aux_sym_long_identifier_repeat1] = STATE(1247),
    [ts_builtin_sym_end] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_namespace] = ACTIONS(3261),
    [anon_sym_module] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_open] = ACTIONS(3261),
    [anon_sym_LBRACK_LT] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4068),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3264),
    [anon_sym_POUNDload] = ACTIONS(3264),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1263] = {
    [sym_xml_doc] = STATE(1263),
    [sym_block_comment] = STATE(1263),
    [sym_line_comment] = STATE(1263),
    [sym_compiler_directive_decl] = STATE(1263),
    [sym_fsi_directive_decl] = STATE(1263),
    [sym_preproc_line] = STATE(1263),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_open] = ACTIONS(3523),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_type] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3525),
    [anon_sym_POUNDload] = ACTIONS(3525),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1264] = {
    [sym_type_arguments] = STATE(927),
    [sym_long_identifier] = STATE(917),
    [sym_xml_doc] = STATE(1264),
    [sym_block_comment] = STATE(1264),
    [sym_line_comment] = STATE(1264),
    [sym_compiler_directive_decl] = STATE(1264),
    [sym_fsi_directive_decl] = STATE(1264),
    [sym_preproc_line] = STATE(1264),
    [aux_sym__compound_type_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_let_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_null] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_QMARK] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_LT_AT] = ACTIONS(3154),
    [anon_sym_LT_AT_AT] = ACTIONS(3154),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_return_BANG] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_yield_BANG] = ACTIONS(3156),
    [anon_sym_lazy] = ACTIONS(3154),
    [anon_sym_assert] = ACTIONS(3154),
    [anon_sym_upcast] = ACTIONS(3154),
    [anon_sym_downcast] = ACTIONS(3154),
    [anon_sym_COLON_GT] = ACTIONS(3156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_fun] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_match] = ACTIONS(3154),
    [anon_sym_match_BANG] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_LT_DASH] = ACTIONS(3154),
    [anon_sym_DOT_LBRACK] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_use] = ACTIONS(3154),
    [anon_sym_use_BANG] = ACTIONS(3156),
    [anon_sym_do_BANG] = ACTIONS(3156),
    [anon_sym_begin] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_LT2] = ACTIONS(3018),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3154),
    [aux_sym_char_token1] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_AT_DQUOTE] = ACTIONS(3156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3156),
    [sym_bool] = ACTIONS(3154),
    [sym_unit] = ACTIONS(3154),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3154),
    [sym_op_identifier] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_DOT] = ACTIONS(3154),
    [anon_sym_DASH_DOT] = ACTIONS(3154),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3156),
    [aux_sym_prefix_op_token1] = ACTIONS(3154),
    [aux_sym_infix_op_token1] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3154),
    [anon_sym_COLON_EQ] = ACTIONS(3156),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3154),
    [sym_int] = ACTIONS(3154),
    [sym_xint] = ACTIONS(3156),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3156),
    [sym__newline] = ACTIONS(3156),
  },
  [1265] = {
    [sym_xml_doc] = STATE(1265),
    [sym_block_comment] = STATE(1265),
    [sym_line_comment] = STATE(1265),
    [sym_compiler_directive_decl] = STATE(1265),
    [sym_fsi_directive_decl] = STATE(1265),
    [sym_preproc_line] = STATE(1265),
    [aux_sym_type_argument_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [anon_sym_POUNDendif] = ACTIONS(3232),
    [anon_sym_POUNDelse] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1266] = {
    [sym_xml_doc] = STATE(1266),
    [sym_block_comment] = STATE(1266),
    [sym_line_comment] = STATE(1266),
    [sym_compiler_directive_decl] = STATE(1266),
    [sym_fsi_directive_decl] = STATE(1266),
    [sym_preproc_line] = STATE(1266),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_open] = ACTIONS(3507),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4072),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1267] = {
    [sym__else_expression] = STATE(2318),
    [sym_elif_expression] = STATE(1711),
    [sym_xml_doc] = STATE(1267),
    [sym_block_comment] = STATE(1267),
    [sym_line_comment] = STATE(1267),
    [sym_compiler_directive_decl] = STATE(1267),
    [sym_fsi_directive_decl] = STATE(1267),
    [sym_preproc_line] = STATE(1267),
    [aux_sym_if_expression_repeat1] = STATE(1309),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_elif] = ACTIONS(4076),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_DASH_GT] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1268] = {
    [sym_xml_doc] = STATE(1268),
    [sym_block_comment] = STATE(1268),
    [sym_line_comment] = STATE(1268),
    [sym_compiler_directive_decl] = STATE(1268),
    [sym_fsi_directive_decl] = STATE(1268),
    [sym_preproc_line] = STATE(1268),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_DOT_DOT2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [1269] = {
    [sym_xml_doc] = STATE(1269),
    [sym_block_comment] = STATE(1269),
    [sym_line_comment] = STATE(1269),
    [sym_compiler_directive_decl] = STATE(1269),
    [sym_fsi_directive_decl] = STATE(1269),
    [sym_preproc_line] = STATE(1269),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_as] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
    [sym__dedent] = ACTIONS(3357),
  },
  [1270] = {
    [sym_xml_doc] = STATE(1270),
    [sym_block_comment] = STATE(1270),
    [sym_line_comment] = STATE(1270),
    [sym_compiler_directive_decl] = STATE(1270),
    [sym_fsi_directive_decl] = STATE(1270),
    [sym_preproc_line] = STATE(1270),
    [ts_builtin_sym_end] = ACTIONS(3544),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_namespace] = ACTIONS(3542),
    [anon_sym_module] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_open] = ACTIONS(3542),
    [anon_sym_LBRACK_LT] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_type] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3544),
    [anon_sym_POUNDload] = ACTIONS(3544),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [1271] = {
    [sym_xml_doc] = STATE(1271),
    [sym_block_comment] = STATE(1271),
    [sym_line_comment] = STATE(1271),
    [sym_compiler_directive_decl] = STATE(1271),
    [sym_fsi_directive_decl] = STATE(1271),
    [sym_preproc_line] = STATE(1271),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_module] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3483),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_type] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1272] = {
    [sym__else_expression] = STATE(2136),
    [sym_elif_expression] = STATE(1699),
    [sym_xml_doc] = STATE(1272),
    [sym_block_comment] = STATE(1272),
    [sym_line_comment] = STATE(1272),
    [sym_compiler_directive_decl] = STATE(1272),
    [sym_fsi_directive_decl] = STATE(1272),
    [sym_preproc_line] = STATE(1272),
    [aux_sym_if_expression_repeat1] = STATE(1348),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4046),
    [anon_sym_elif] = ACTIONS(4048),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1273] = {
    [sym__else_expression] = STATE(2273),
    [sym_elif_expression] = STATE(1711),
    [sym_xml_doc] = STATE(1273),
    [sym_block_comment] = STATE(1273),
    [sym_line_comment] = STATE(1273),
    [sym_compiler_directive_decl] = STATE(1273),
    [sym_fsi_directive_decl] = STATE(1273),
    [sym_preproc_line] = STATE(1273),
    [aux_sym_if_expression_repeat1] = STATE(1267),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_elif] = ACTIONS(4076),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_DASH_GT] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1274] = {
    [sym_xml_doc] = STATE(1274),
    [sym_block_comment] = STATE(1274),
    [sym_line_comment] = STATE(1274),
    [sym_compiler_directive_decl] = STATE(1274),
    [sym_fsi_directive_decl] = STATE(1274),
    [sym_preproc_line] = STATE(1274),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_DOT_DOT2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
    [sym__dedent] = ACTIONS(3324),
  },
  [1275] = {
    [sym_xml_doc] = STATE(1275),
    [sym_block_comment] = STATE(1275),
    [sym_line_comment] = STATE(1275),
    [sym_compiler_directive_decl] = STATE(1275),
    [sym_fsi_directive_decl] = STATE(1275),
    [sym_preproc_line] = STATE(1275),
    [ts_builtin_sym_end] = ACTIONS(3912),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_namespace] = ACTIONS(3910),
    [anon_sym_module] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_open] = ACTIONS(3910),
    [anon_sym_LBRACK_LT] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_type] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3912),
    [anon_sym_POUNDload] = ACTIONS(3912),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [1276] = {
    [sym_xml_doc] = STATE(1276),
    [sym_block_comment] = STATE(1276),
    [sym_line_comment] = STATE(1276),
    [sym_compiler_directive_decl] = STATE(1276),
    [sym_fsi_directive_decl] = STATE(1276),
    [sym_preproc_line] = STATE(1276),
    [ts_builtin_sym_end] = ACTIONS(3827),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_namespace] = ACTIONS(3825),
    [anon_sym_module] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_open] = ACTIONS(3825),
    [anon_sym_LBRACK_LT] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_type] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3827),
    [anon_sym_POUNDload] = ACTIONS(3827),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [1277] = {
    [sym_xml_doc] = STATE(1277),
    [sym_block_comment] = STATE(1277),
    [sym_line_comment] = STATE(1277),
    [sym_compiler_directive_decl] = STATE(1277),
    [sym_fsi_directive_decl] = STATE(1277),
    [sym_preproc_line] = STATE(1277),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_namespace] = ACTIONS(3742),
    [anon_sym_module] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_open] = ACTIONS(3742),
    [anon_sym_LBRACK_LT] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_type] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3744),
    [anon_sym_POUNDload] = ACTIONS(3744),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [1278] = {
    [sym_xml_doc] = STATE(1278),
    [sym_block_comment] = STATE(1278),
    [sym_line_comment] = STATE(1278),
    [sym_compiler_directive_decl] = STATE(1278),
    [sym_fsi_directive_decl] = STATE(1278),
    [sym_preproc_line] = STATE(1278),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_open] = ACTIONS(3507),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4072),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1279] = {
    [sym_xml_doc] = STATE(1279),
    [sym_block_comment] = STATE(1279),
    [sym_line_comment] = STATE(1279),
    [sym_compiler_directive_decl] = STATE(1279),
    [sym_fsi_directive_decl] = STATE(1279),
    [sym_preproc_line] = STATE(1279),
    [aux_sym__compound_type_repeat1] = STATE(1296),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_AT_AT_GT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1280] = {
    [sym_xml_doc] = STATE(1280),
    [sym_block_comment] = STATE(1280),
    [sym_line_comment] = STATE(1280),
    [sym_compiler_directive_decl] = STATE(1280),
    [sym_fsi_directive_decl] = STATE(1280),
    [sym_preproc_line] = STATE(1280),
    [aux_sym_type_argument_repeat1] = STATE(1297),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_AT_GT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1281] = {
    [sym_xml_doc] = STATE(1281),
    [sym_block_comment] = STATE(1281),
    [sym_line_comment] = STATE(1281),
    [sym_compiler_directive_decl] = STATE(1281),
    [sym_fsi_directive_decl] = STATE(1281),
    [sym_preproc_line] = STATE(1281),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [anon_sym_POUNDendif] = ACTIONS(3363),
    [anon_sym_POUNDelse] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1282] = {
    [sym_xml_doc] = STATE(1282),
    [sym_block_comment] = STATE(1282),
    [sym_line_comment] = STATE(1282),
    [sym_compiler_directive_decl] = STATE(1282),
    [sym_fsi_directive_decl] = STATE(1282),
    [sym_preproc_line] = STATE(1282),
    [ts_builtin_sym_end] = ACTIONS(3714),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_namespace] = ACTIONS(3712),
    [anon_sym_module] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_open] = ACTIONS(3712),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3714),
    [anon_sym_POUNDload] = ACTIONS(3714),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [1283] = {
    [sym_xml_doc] = STATE(1283),
    [sym_block_comment] = STATE(1283),
    [sym_line_comment] = STATE(1283),
    [sym_compiler_directive_decl] = STATE(1283),
    [sym_fsi_directive_decl] = STATE(1283),
    [sym_preproc_line] = STATE(1283),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1284] = {
    [sym_xml_doc] = STATE(1284),
    [sym_block_comment] = STATE(1284),
    [sym_line_comment] = STATE(1284),
    [sym_compiler_directive_decl] = STATE(1284),
    [sym_fsi_directive_decl] = STATE(1284),
    [sym_preproc_line] = STATE(1284),
    [ts_builtin_sym_end] = ACTIONS(3724),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_namespace] = ACTIONS(3722),
    [anon_sym_module] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_open] = ACTIONS(3722),
    [anon_sym_LBRACK_LT] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_type] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3724),
    [anon_sym_POUNDload] = ACTIONS(3724),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [1285] = {
    [sym_xml_doc] = STATE(1285),
    [sym_block_comment] = STATE(1285),
    [sym_line_comment] = STATE(1285),
    [sym_compiler_directive_decl] = STATE(1285),
    [sym_fsi_directive_decl] = STATE(1285),
    [sym_preproc_line] = STATE(1285),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1286] = {
    [sym_xml_doc] = STATE(1286),
    [sym_block_comment] = STATE(1286),
    [sym_line_comment] = STATE(1286),
    [sym_compiler_directive_decl] = STATE(1286),
    [sym_fsi_directive_decl] = STATE(1286),
    [sym_preproc_line] = STATE(1286),
    [aux_sym_long_identifier_repeat1] = STATE(1314),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1287] = {
    [sym_xml_doc] = STATE(1287),
    [sym_block_comment] = STATE(1287),
    [sym_line_comment] = STATE(1287),
    [sym_compiler_directive_decl] = STATE(1287),
    [sym_fsi_directive_decl] = STATE(1287),
    [sym_preproc_line] = STATE(1287),
    [aux_sym_sequential_expression_repeat1] = STATE(1343),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_module] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_open] = ACTIONS(3612),
    [anon_sym_LBRACK_LT] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_type] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3614),
    [anon_sym_POUNDload] = ACTIONS(3614),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
    [sym__dedent] = ACTIONS(3614),
  },
  [1288] = {
    [sym_xml_doc] = STATE(1288),
    [sym_block_comment] = STATE(1288),
    [sym_line_comment] = STATE(1288),
    [sym_compiler_directive_decl] = STATE(1288),
    [sym_fsi_directive_decl] = STATE(1288),
    [sym_preproc_line] = STATE(1288),
    [aux_sym_long_identifier_repeat1] = STATE(1324),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_AT_AT_GT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1289] = {
    [sym_xml_doc] = STATE(1289),
    [sym_block_comment] = STATE(1289),
    [sym_line_comment] = STATE(1289),
    [sym_compiler_directive_decl] = STATE(1289),
    [sym_fsi_directive_decl] = STATE(1289),
    [sym_preproc_line] = STATE(1289),
    [ts_builtin_sym_end] = ACTIONS(3695),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_module] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_open] = ACTIONS(3693),
    [anon_sym_LBRACK_LT] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3695),
    [anon_sym_POUNDload] = ACTIONS(3695),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [1290] = {
    [sym_xml_doc] = STATE(1290),
    [sym_block_comment] = STATE(1290),
    [sym_line_comment] = STATE(1290),
    [sym_compiler_directive_decl] = STATE(1290),
    [sym_fsi_directive_decl] = STATE(1290),
    [sym_preproc_line] = STATE(1290),
    [ts_builtin_sym_end] = ACTIONS(3720),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_namespace] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_open] = ACTIONS(3718),
    [anon_sym_LBRACK_LT] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_type] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3720),
    [anon_sym_POUNDload] = ACTIONS(3720),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [1291] = {
    [sym_xml_doc] = STATE(1291),
    [sym_block_comment] = STATE(1291),
    [sym_line_comment] = STATE(1291),
    [sym_compiler_directive_decl] = STATE(1291),
    [sym_fsi_directive_decl] = STATE(1291),
    [sym_preproc_line] = STATE(1291),
    [ts_builtin_sym_end] = ACTIONS(3865),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_namespace] = ACTIONS(3863),
    [anon_sym_module] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_open] = ACTIONS(3863),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_type] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3865),
    [anon_sym_POUNDload] = ACTIONS(3865),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [1292] = {
    [sym_xml_doc] = STATE(1292),
    [sym_block_comment] = STATE(1292),
    [sym_line_comment] = STATE(1292),
    [sym_compiler_directive_decl] = STATE(1292),
    [sym_fsi_directive_decl] = STATE(1292),
    [sym_preproc_line] = STATE(1292),
    [ts_builtin_sym_end] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_namespace] = ACTIONS(3878),
    [anon_sym_module] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_open] = ACTIONS(3878),
    [anon_sym_LBRACK_LT] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3880),
    [anon_sym_POUNDload] = ACTIONS(3880),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [1293] = {
    [sym_xml_doc] = STATE(1293),
    [sym_block_comment] = STATE(1293),
    [sym_line_comment] = STATE(1293),
    [sym_compiler_directive_decl] = STATE(1293),
    [sym_fsi_directive_decl] = STATE(1293),
    [sym_preproc_line] = STATE(1293),
    [aux_sym_long_identifier_repeat1] = STATE(1324),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_AT_AT_GT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(4088),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1294] = {
    [sym_xml_doc] = STATE(1294),
    [sym_block_comment] = STATE(1294),
    [sym_line_comment] = STATE(1294),
    [sym_compiler_directive_decl] = STATE(1294),
    [sym_fsi_directive_decl] = STATE(1294),
    [sym_preproc_line] = STATE(1294),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_module] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_open] = ACTIONS(3554),
    [anon_sym_LBRACK_LT] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_type] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4090),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3556),
    [anon_sym_POUNDload] = ACTIONS(3556),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
    [sym__dedent] = ACTIONS(3556),
  },
  [1295] = {
    [sym_xml_doc] = STATE(1295),
    [sym_block_comment] = STATE(1295),
    [sym_line_comment] = STATE(1295),
    [sym_compiler_directive_decl] = STATE(1295),
    [sym_fsi_directive_decl] = STATE(1295),
    [sym_preproc_line] = STATE(1295),
    [aux_sym_long_identifier_repeat1] = STATE(1419),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_AT_GT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4092),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1296] = {
    [sym_xml_doc] = STATE(1296),
    [sym_block_comment] = STATE(1296),
    [sym_line_comment] = STATE(1296),
    [sym_compiler_directive_decl] = STATE(1296),
    [sym_fsi_directive_decl] = STATE(1296),
    [sym_preproc_line] = STATE(1296),
    [aux_sym__compound_type_repeat1] = STATE(1296),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_AT_AT_GT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4096),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1297] = {
    [sym_xml_doc] = STATE(1297),
    [sym_block_comment] = STATE(1297),
    [sym_line_comment] = STATE(1297),
    [sym_compiler_directive_decl] = STATE(1297),
    [sym_fsi_directive_decl] = STATE(1297),
    [sym_preproc_line] = STATE(1297),
    [aux_sym_type_argument_repeat1] = STATE(1297),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_AT_GT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1298] = {
    [sym_xml_doc] = STATE(1298),
    [sym_block_comment] = STATE(1298),
    [sym_line_comment] = STATE(1298),
    [sym_compiler_directive_decl] = STATE(1298),
    [sym_fsi_directive_decl] = STATE(1298),
    [sym_preproc_line] = STATE(1298),
    [aux_sym_long_identifier_repeat1] = STATE(1332),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [anon_sym_POUNDendif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1299] = {
    [sym_xml_doc] = STATE(1299),
    [sym_block_comment] = STATE(1299),
    [sym_line_comment] = STATE(1299),
    [sym_compiler_directive_decl] = STATE(1299),
    [sym_fsi_directive_decl] = STATE(1299),
    [sym_preproc_line] = STATE(1299),
    [ts_builtin_sym_end] = ACTIONS(3764),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_namespace] = ACTIONS(3762),
    [anon_sym_module] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_open] = ACTIONS(3762),
    [anon_sym_LBRACK_LT] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_type] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3764),
    [anon_sym_POUNDload] = ACTIONS(3764),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [1300] = {
    [sym_xml_doc] = STATE(1300),
    [sym_block_comment] = STATE(1300),
    [sym_line_comment] = STATE(1300),
    [sym_compiler_directive_decl] = STATE(1300),
    [sym_fsi_directive_decl] = STATE(1300),
    [sym_preproc_line] = STATE(1300),
    [ts_builtin_sym_end] = ACTIONS(3610),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_namespace] = ACTIONS(3608),
    [anon_sym_module] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_open] = ACTIONS(3608),
    [anon_sym_LBRACK_LT] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_type] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3610),
    [anon_sym_POUNDload] = ACTIONS(3610),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [1301] = {
    [sym_xml_doc] = STATE(1301),
    [sym_block_comment] = STATE(1301),
    [sym_line_comment] = STATE(1301),
    [sym_compiler_directive_decl] = STATE(1301),
    [sym_fsi_directive_decl] = STATE(1301),
    [sym_preproc_line] = STATE(1301),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1302] = {
    [sym_xml_doc] = STATE(1302),
    [sym_block_comment] = STATE(1302),
    [sym_line_comment] = STATE(1302),
    [sym_compiler_directive_decl] = STATE(1302),
    [sym_fsi_directive_decl] = STATE(1302),
    [sym_preproc_line] = STATE(1302),
    [aux_sym_long_identifier_repeat1] = STATE(1286),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_GT] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1303] = {
    [sym_xml_doc] = STATE(1303),
    [sym_block_comment] = STATE(1303),
    [sym_line_comment] = STATE(1303),
    [sym_compiler_directive_decl] = STATE(1303),
    [sym_fsi_directive_decl] = STATE(1303),
    [sym_preproc_line] = STATE(1303),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1304] = {
    [sym__else_expression] = STATE(2551),
    [sym_elif_expression] = STATE(1976),
    [sym_xml_doc] = STATE(1304),
    [sym_block_comment] = STATE(1304),
    [sym_line_comment] = STATE(1304),
    [sym_compiler_directive_decl] = STATE(1304),
    [sym_fsi_directive_decl] = STATE(1304),
    [sym_preproc_line] = STATE(1304),
    [aux_sym_if_expression_repeat1] = STATE(1608),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_AT_AT_GT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4106),
    [anon_sym_elif] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1305] = {
    [sym_xml_doc] = STATE(1305),
    [sym_block_comment] = STATE(1305),
    [sym_line_comment] = STATE(1305),
    [sym_compiler_directive_decl] = STATE(1305),
    [sym_fsi_directive_decl] = STATE(1305),
    [sym_preproc_line] = STATE(1305),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1306] = {
    [sym_xml_doc] = STATE(1306),
    [sym_block_comment] = STATE(1306),
    [sym_line_comment] = STATE(1306),
    [sym_compiler_directive_decl] = STATE(1306),
    [sym_fsi_directive_decl] = STATE(1306),
    [sym_preproc_line] = STATE(1306),
    [aux_sym_sequential_expression_repeat1] = STATE(1306),
    [ts_builtin_sym_end] = ACTIONS(3831),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_module] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_open] = ACTIONS(3829),
    [anon_sym_LBRACK_LT] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_type] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3831),
    [anon_sym_POUNDload] = ACTIONS(3831),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4110),
  },
  [1307] = {
    [sym_xml_doc] = STATE(1307),
    [sym_block_comment] = STATE(1307),
    [sym_line_comment] = STATE(1307),
    [sym_compiler_directive_decl] = STATE(1307),
    [sym_fsi_directive_decl] = STATE(1307),
    [sym_preproc_line] = STATE(1307),
    [ts_builtin_sym_end] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_namespace] = ACTIONS(3730),
    [anon_sym_module] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_open] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_type] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3732),
    [anon_sym_POUNDload] = ACTIONS(3732),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [1308] = {
    [sym_xml_doc] = STATE(1308),
    [sym_block_comment] = STATE(1308),
    [sym_line_comment] = STATE(1308),
    [sym_compiler_directive_decl] = STATE(1308),
    [sym_fsi_directive_decl] = STATE(1308),
    [sym_preproc_line] = STATE(1308),
    [aux_sym_long_identifier_repeat1] = STATE(1286),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_GT] = ACTIONS(3261),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1309] = {
    [sym_elif_expression] = STATE(1711),
    [sym_xml_doc] = STATE(1309),
    [sym_block_comment] = STATE(1309),
    [sym_line_comment] = STATE(1309),
    [sym_compiler_directive_decl] = STATE(1309),
    [sym_fsi_directive_decl] = STATE(1309),
    [sym_preproc_line] = STATE(1309),
    [aux_sym_if_expression_repeat1] = STATE(1309),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4117),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_DASH_GT] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_DOT_DOT] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1310] = {
    [sym_xml_doc] = STATE(1310),
    [sym_block_comment] = STATE(1310),
    [sym_line_comment] = STATE(1310),
    [sym_compiler_directive_decl] = STATE(1310),
    [sym_fsi_directive_decl] = STATE(1310),
    [sym_preproc_line] = STATE(1310),
    [ts_builtin_sym_end] = ACTIONS(3662),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_namespace] = ACTIONS(3660),
    [anon_sym_module] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_open] = ACTIONS(3660),
    [anon_sym_LBRACK_LT] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_type] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3662),
    [anon_sym_POUNDload] = ACTIONS(3662),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [1311] = {
    [sym_xml_doc] = STATE(1311),
    [sym_block_comment] = STATE(1311),
    [sym_line_comment] = STATE(1311),
    [sym_compiler_directive_decl] = STATE(1311),
    [sym_fsi_directive_decl] = STATE(1311),
    [sym_preproc_line] = STATE(1311),
    [ts_builtin_sym_end] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_namespace] = ACTIONS(3656),
    [anon_sym_module] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_open] = ACTIONS(3656),
    [anon_sym_LBRACK_LT] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_type] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3658),
    [anon_sym_POUNDload] = ACTIONS(3658),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [1312] = {
    [sym_xml_doc] = STATE(1312),
    [sym_block_comment] = STATE(1312),
    [sym_line_comment] = STATE(1312),
    [sym_compiler_directive_decl] = STATE(1312),
    [sym_fsi_directive_decl] = STATE(1312),
    [sym_preproc_line] = STATE(1312),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_as] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1313] = {
    [sym_xml_doc] = STATE(1313),
    [sym_block_comment] = STATE(1313),
    [sym_line_comment] = STATE(1313),
    [sym_compiler_directive_decl] = STATE(1313),
    [sym_fsi_directive_decl] = STATE(1313),
    [sym_preproc_line] = STATE(1313),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_namespace] = ACTIONS(3689),
    [anon_sym_module] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_open] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_type] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3691),
    [anon_sym_POUNDload] = ACTIONS(3691),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [1314] = {
    [sym_xml_doc] = STATE(1314),
    [sym_block_comment] = STATE(1314),
    [sym_line_comment] = STATE(1314),
    [sym_compiler_directive_decl] = STATE(1314),
    [sym_fsi_directive_decl] = STATE(1314),
    [sym_preproc_line] = STATE(1314),
    [aux_sym_long_identifier_repeat1] = STATE(1314),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1315] = {
    [sym_xml_doc] = STATE(1315),
    [sym_block_comment] = STATE(1315),
    [sym_line_comment] = STATE(1315),
    [sym_compiler_directive_decl] = STATE(1315),
    [sym_fsi_directive_decl] = STATE(1315),
    [sym_preproc_line] = STATE(1315),
    [ts_builtin_sym_end] = ACTIONS(3677),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_namespace] = ACTIONS(3675),
    [anon_sym_module] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_open] = ACTIONS(3675),
    [anon_sym_LBRACK_LT] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_type] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3677),
    [anon_sym_POUNDload] = ACTIONS(3677),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [1316] = {
    [sym_xml_doc] = STATE(1316),
    [sym_block_comment] = STATE(1316),
    [sym_line_comment] = STATE(1316),
    [sym_compiler_directive_decl] = STATE(1316),
    [sym_fsi_directive_decl] = STATE(1316),
    [sym_preproc_line] = STATE(1316),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1317] = {
    [sym_xml_doc] = STATE(1317),
    [sym_block_comment] = STATE(1317),
    [sym_line_comment] = STATE(1317),
    [sym_compiler_directive_decl] = STATE(1317),
    [sym_fsi_directive_decl] = STATE(1317),
    [sym_preproc_line] = STATE(1317),
    [aux_sym__compound_type_repeat1] = STATE(1317),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_AT_GT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4123),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1318] = {
    [sym_xml_doc] = STATE(1318),
    [sym_block_comment] = STATE(1318),
    [sym_line_comment] = STATE(1318),
    [sym_compiler_directive_decl] = STATE(1318),
    [sym_fsi_directive_decl] = STATE(1318),
    [sym_preproc_line] = STATE(1318),
    [ts_builtin_sym_end] = ACTIONS(3861),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_namespace] = ACTIONS(3859),
    [anon_sym_module] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_open] = ACTIONS(3859),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_type] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3861),
    [anon_sym_POUNDload] = ACTIONS(3861),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [1319] = {
    [sym_xml_doc] = STATE(1319),
    [sym_block_comment] = STATE(1319),
    [sym_line_comment] = STATE(1319),
    [sym_compiler_directive_decl] = STATE(1319),
    [sym_fsi_directive_decl] = STATE(1319),
    [sym_preproc_line] = STATE(1319),
    [ts_builtin_sym_end] = ACTIONS(3699),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_namespace] = ACTIONS(3697),
    [anon_sym_module] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_open] = ACTIONS(3697),
    [anon_sym_LBRACK_LT] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_type] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3699),
    [anon_sym_POUNDload] = ACTIONS(3699),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [1320] = {
    [sym_xml_doc] = STATE(1320),
    [sym_block_comment] = STATE(1320),
    [sym_line_comment] = STATE(1320),
    [sym_compiler_directive_decl] = STATE(1320),
    [sym_fsi_directive_decl] = STATE(1320),
    [sym_preproc_line] = STATE(1320),
    [ts_builtin_sym_end] = ACTIONS(3923),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_namespace] = ACTIONS(3921),
    [anon_sym_module] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_open] = ACTIONS(3921),
    [anon_sym_LBRACK_LT] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_type] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3923),
    [anon_sym_POUNDload] = ACTIONS(3923),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [1321] = {
    [sym__else_expression] = STATE(2591),
    [sym_elif_expression] = STATE(1754),
    [sym_xml_doc] = STATE(1321),
    [sym_block_comment] = STATE(1321),
    [sym_line_comment] = STATE(1321),
    [sym_compiler_directive_decl] = STATE(1321),
    [sym_fsi_directive_decl] = STATE(1321),
    [sym_preproc_line] = STATE(1321),
    [aux_sym_if_expression_repeat1] = STATE(1341),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4126),
    [anon_sym_elif] = ACTIONS(4128),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_DOT_DOT] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1322] = {
    [sym_xml_doc] = STATE(1322),
    [sym_block_comment] = STATE(1322),
    [sym_line_comment] = STATE(1322),
    [sym_compiler_directive_decl] = STATE(1322),
    [sym_fsi_directive_decl] = STATE(1322),
    [sym_preproc_line] = STATE(1322),
    [ts_builtin_sym_end] = ACTIONS(3648),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_namespace] = ACTIONS(3646),
    [anon_sym_module] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_open] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_type] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3648),
    [anon_sym_POUNDload] = ACTIONS(3648),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [1323] = {
    [sym_xml_doc] = STATE(1323),
    [sym_block_comment] = STATE(1323),
    [sym_line_comment] = STATE(1323),
    [sym_compiler_directive_decl] = STATE(1323),
    [sym_fsi_directive_decl] = STATE(1323),
    [sym_preproc_line] = STATE(1323),
    [ts_builtin_sym_end] = ACTIONS(3959),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_namespace] = ACTIONS(3957),
    [anon_sym_module] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_open] = ACTIONS(3957),
    [anon_sym_LBRACK_LT] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_type] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3959),
    [anon_sym_POUNDload] = ACTIONS(3959),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [1324] = {
    [sym_xml_doc] = STATE(1324),
    [sym_block_comment] = STATE(1324),
    [sym_line_comment] = STATE(1324),
    [sym_compiler_directive_decl] = STATE(1324),
    [sym_fsi_directive_decl] = STATE(1324),
    [sym_preproc_line] = STATE(1324),
    [aux_sym_long_identifier_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_AT_AT_GT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4088),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1325] = {
    [sym_xml_doc] = STATE(1325),
    [sym_block_comment] = STATE(1325),
    [sym_line_comment] = STATE(1325),
    [sym_compiler_directive_decl] = STATE(1325),
    [sym_fsi_directive_decl] = STATE(1325),
    [sym_preproc_line] = STATE(1325),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [anon_sym_POUNDendif] = ACTIONS(3302),
    [anon_sym_POUNDelse] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1326] = {
    [sym_xml_doc] = STATE(1326),
    [sym_block_comment] = STATE(1326),
    [sym_line_comment] = STATE(1326),
    [sym_compiler_directive_decl] = STATE(1326),
    [sym_fsi_directive_decl] = STATE(1326),
    [sym_preproc_line] = STATE(1326),
    [aux_sym_long_identifier_repeat1] = STATE(1395),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_DOT_DOT] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1327] = {
    [sym_xml_doc] = STATE(1327),
    [sym_block_comment] = STATE(1327),
    [sym_line_comment] = STATE(1327),
    [sym_compiler_directive_decl] = STATE(1327),
    [sym_fsi_directive_decl] = STATE(1327),
    [sym_preproc_line] = STATE(1327),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1328] = {
    [sym_xml_doc] = STATE(1328),
    [sym_block_comment] = STATE(1328),
    [sym_line_comment] = STATE(1328),
    [sym_compiler_directive_decl] = STATE(1328),
    [sym_fsi_directive_decl] = STATE(1328),
    [sym_preproc_line] = STATE(1328),
    [ts_builtin_sym_end] = ACTIONS(3546),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_namespace] = ACTIONS(3679),
    [anon_sym_module] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_open] = ACTIONS(3679),
    [anon_sym_LBRACK_LT] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_type] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3546),
    [anon_sym_POUNDload] = ACTIONS(3546),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [1329] = {
    [sym_xml_doc] = STATE(1329),
    [sym_block_comment] = STATE(1329),
    [sym_line_comment] = STATE(1329),
    [sym_compiler_directive_decl] = STATE(1329),
    [sym_fsi_directive_decl] = STATE(1329),
    [sym_preproc_line] = STATE(1329),
    [ts_builtin_sym_end] = ACTIONS(3955),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_module] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_open] = ACTIONS(3953),
    [anon_sym_LBRACK_LT] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_type] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3955),
    [anon_sym_POUNDload] = ACTIONS(3955),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [1330] = {
    [sym_xml_doc] = STATE(1330),
    [sym_block_comment] = STATE(1330),
    [sym_line_comment] = STATE(1330),
    [sym_compiler_directive_decl] = STATE(1330),
    [sym_fsi_directive_decl] = STATE(1330),
    [sym_preproc_line] = STATE(1330),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1331] = {
    [sym_xml_doc] = STATE(1331),
    [sym_block_comment] = STATE(1331),
    [sym_line_comment] = STATE(1331),
    [sym_compiler_directive_decl] = STATE(1331),
    [sym_fsi_directive_decl] = STATE(1331),
    [sym_preproc_line] = STATE(1331),
    [ts_builtin_sym_end] = ACTIONS(3951),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_module] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_open] = ACTIONS(3949),
    [anon_sym_LBRACK_LT] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_type] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3951),
    [anon_sym_POUNDload] = ACTIONS(3951),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [1332] = {
    [sym_xml_doc] = STATE(1332),
    [sym_block_comment] = STATE(1332),
    [sym_line_comment] = STATE(1332),
    [sym_compiler_directive_decl] = STATE(1332),
    [sym_fsi_directive_decl] = STATE(1332),
    [sym_preproc_line] = STATE(1332),
    [aux_sym_long_identifier_repeat1] = STATE(1338),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [anon_sym_POUNDendif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1333] = {
    [sym_xml_doc] = STATE(1333),
    [sym_block_comment] = STATE(1333),
    [sym_line_comment] = STATE(1333),
    [sym_compiler_directive_decl] = STATE(1333),
    [sym_fsi_directive_decl] = STATE(1333),
    [sym_preproc_line] = STATE(1333),
    [ts_builtin_sym_end] = ACTIONS(3947),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_namespace] = ACTIONS(3945),
    [anon_sym_module] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_open] = ACTIONS(3945),
    [anon_sym_LBRACK_LT] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_type] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3947),
    [anon_sym_POUNDload] = ACTIONS(3947),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [1334] = {
    [sym_xml_doc] = STATE(1334),
    [sym_block_comment] = STATE(1334),
    [sym_line_comment] = STATE(1334),
    [sym_compiler_directive_decl] = STATE(1334),
    [sym_fsi_directive_decl] = STATE(1334),
    [sym_preproc_line] = STATE(1334),
    [aux_sym_long_identifier_repeat1] = STATE(1395),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_DOT_DOT] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1335] = {
    [sym__else_expression] = STATE(2516),
    [sym_elif_expression] = STATE(1811),
    [sym_xml_doc] = STATE(1335),
    [sym_block_comment] = STATE(1335),
    [sym_line_comment] = STATE(1335),
    [sym_compiler_directive_decl] = STATE(1335),
    [sym_fsi_directive_decl] = STATE(1335),
    [sym_preproc_line] = STATE(1335),
    [aux_sym_if_expression_repeat1] = STATE(1359),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_AT_GT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4136),
    [anon_sym_elif] = ACTIONS(4138),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1336] = {
    [sym_xml_doc] = STATE(1336),
    [sym_block_comment] = STATE(1336),
    [sym_line_comment] = STATE(1336),
    [sym_compiler_directive_decl] = STATE(1336),
    [sym_fsi_directive_decl] = STATE(1336),
    [sym_preproc_line] = STATE(1336),
    [ts_builtin_sym_end] = ACTIONS(3618),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3616),
    [anon_sym_module] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_open] = ACTIONS(3616),
    [anon_sym_LBRACK_LT] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3618),
    [anon_sym_POUNDload] = ACTIONS(3618),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [1337] = {
    [sym_xml_doc] = STATE(1337),
    [sym_block_comment] = STATE(1337),
    [sym_line_comment] = STATE(1337),
    [sym_compiler_directive_decl] = STATE(1337),
    [sym_fsi_directive_decl] = STATE(1337),
    [sym_preproc_line] = STATE(1337),
    [aux_sym_type_argument_repeat1] = STATE(1449),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_GT] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1338] = {
    [sym_xml_doc] = STATE(1338),
    [sym_block_comment] = STATE(1338),
    [sym_line_comment] = STATE(1338),
    [sym_compiler_directive_decl] = STATE(1338),
    [sym_fsi_directive_decl] = STATE(1338),
    [sym_preproc_line] = STATE(1338),
    [aux_sym_long_identifier_repeat1] = STATE(1338),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1339] = {
    [sym_elif_expression] = STATE(1736),
    [sym_xml_doc] = STATE(1339),
    [sym_block_comment] = STATE(1339),
    [sym_line_comment] = STATE(1339),
    [sym_compiler_directive_decl] = STATE(1339),
    [sym_fsi_directive_decl] = STATE(1339),
    [sym_preproc_line] = STATE(1339),
    [aux_sym_if_expression_repeat1] = STATE(1339),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4143),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [anon_sym_POUNDendif] = ACTIONS(3346),
    [anon_sym_POUNDelse] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1340] = {
    [sym_xml_doc] = STATE(1340),
    [sym_block_comment] = STATE(1340),
    [sym_line_comment] = STATE(1340),
    [sym_compiler_directive_decl] = STATE(1340),
    [sym_fsi_directive_decl] = STATE(1340),
    [sym_preproc_line] = STATE(1340),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_DOT_DOT2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4146),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
    [sym__dedent] = ACTIONS(3389),
  },
  [1341] = {
    [sym__else_expression] = STATE(2621),
    [sym_elif_expression] = STATE(1754),
    [sym_xml_doc] = STATE(1341),
    [sym_block_comment] = STATE(1341),
    [sym_line_comment] = STATE(1341),
    [sym_compiler_directive_decl] = STATE(1341),
    [sym_fsi_directive_decl] = STATE(1341),
    [sym_preproc_line] = STATE(1341),
    [aux_sym_if_expression_repeat1] = STATE(1671),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4126),
    [anon_sym_elif] = ACTIONS(4128),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_DOT_DOT] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1342] = {
    [sym_xml_doc] = STATE(1342),
    [sym_block_comment] = STATE(1342),
    [sym_line_comment] = STATE(1342),
    [sym_compiler_directive_decl] = STATE(1342),
    [sym_fsi_directive_decl] = STATE(1342),
    [sym_preproc_line] = STATE(1342),
    [ts_builtin_sym_end] = ACTIONS(3703),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_namespace] = ACTIONS(3701),
    [anon_sym_module] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_open] = ACTIONS(3701),
    [anon_sym_LBRACK_LT] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_type] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3703),
    [anon_sym_POUNDload] = ACTIONS(3703),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [1343] = {
    [sym_xml_doc] = STATE(1343),
    [sym_block_comment] = STATE(1343),
    [sym_line_comment] = STATE(1343),
    [sym_compiler_directive_decl] = STATE(1343),
    [sym_fsi_directive_decl] = STATE(1343),
    [sym_preproc_line] = STATE(1343),
    [aux_sym_sequential_expression_repeat1] = STATE(1343),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_module] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_open] = ACTIONS(3829),
    [anon_sym_LBRACK_LT] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_type] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3831),
    [anon_sym_POUNDload] = ACTIONS(3831),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4148),
    [sym__dedent] = ACTIONS(3831),
  },
  [1344] = {
    [sym_xml_doc] = STATE(1344),
    [sym_block_comment] = STATE(1344),
    [sym_line_comment] = STATE(1344),
    [sym_compiler_directive_decl] = STATE(1344),
    [sym_fsi_directive_decl] = STATE(1344),
    [sym_preproc_line] = STATE(1344),
    [aux_sym_type_argument_repeat1] = STATE(1344),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [anon_sym_POUNDendif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1345] = {
    [sym_xml_doc] = STATE(1345),
    [sym_block_comment] = STATE(1345),
    [sym_line_comment] = STATE(1345),
    [sym_compiler_directive_decl] = STATE(1345),
    [sym_fsi_directive_decl] = STATE(1345),
    [sym_preproc_line] = STATE(1345),
    [ts_builtin_sym_end] = ACTIONS(3943),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_namespace] = ACTIONS(3941),
    [anon_sym_module] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_open] = ACTIONS(3941),
    [anon_sym_LBRACK_LT] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_type] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3943),
    [anon_sym_POUNDload] = ACTIONS(3943),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [1346] = {
    [sym_xml_doc] = STATE(1346),
    [sym_block_comment] = STATE(1346),
    [sym_line_comment] = STATE(1346),
    [sym_compiler_directive_decl] = STATE(1346),
    [sym_fsi_directive_decl] = STATE(1346),
    [sym_preproc_line] = STATE(1346),
    [aux_sym_type_argument_repeat1] = STATE(1344),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [anon_sym_POUNDendif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1347] = {
    [sym_xml_doc] = STATE(1347),
    [sym_block_comment] = STATE(1347),
    [sym_line_comment] = STATE(1347),
    [sym_compiler_directive_decl] = STATE(1347),
    [sym_fsi_directive_decl] = STATE(1347),
    [sym_preproc_line] = STATE(1347),
    [ts_builtin_sym_end] = ACTIONS(3849),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_namespace] = ACTIONS(3847),
    [anon_sym_module] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_open] = ACTIONS(3847),
    [anon_sym_LBRACK_LT] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_type] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3849),
    [anon_sym_POUNDload] = ACTIONS(3849),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [1348] = {
    [sym_elif_expression] = STATE(1699),
    [sym_xml_doc] = STATE(1348),
    [sym_block_comment] = STATE(1348),
    [sym_line_comment] = STATE(1348),
    [sym_compiler_directive_decl] = STATE(1348),
    [sym_fsi_directive_decl] = STATE(1348),
    [sym_preproc_line] = STATE(1348),
    [aux_sym_if_expression_repeat1] = STATE(1348),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_as] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4154),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1349] = {
    [sym_xml_doc] = STATE(1349),
    [sym_block_comment] = STATE(1349),
    [sym_line_comment] = STATE(1349),
    [sym_compiler_directive_decl] = STATE(1349),
    [sym_fsi_directive_decl] = STATE(1349),
    [sym_preproc_line] = STATE(1349),
    [ts_builtin_sym_end] = ACTIONS(3804),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_namespace] = ACTIONS(3802),
    [anon_sym_module] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_open] = ACTIONS(3802),
    [anon_sym_LBRACK_LT] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_type] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3804),
    [anon_sym_POUNDload] = ACTIONS(3804),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [1350] = {
    [sym_xml_doc] = STATE(1350),
    [sym_block_comment] = STATE(1350),
    [sym_line_comment] = STATE(1350),
    [sym_compiler_directive_decl] = STATE(1350),
    [sym_fsi_directive_decl] = STATE(1350),
    [sym_preproc_line] = STATE(1350),
    [ts_builtin_sym_end] = ACTIONS(3640),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_namespace] = ACTIONS(3638),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_open] = ACTIONS(3638),
    [anon_sym_LBRACK_LT] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_type] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3640),
    [anon_sym_POUNDload] = ACTIONS(3640),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [1351] = {
    [sym_xml_doc] = STATE(1351),
    [sym_block_comment] = STATE(1351),
    [sym_line_comment] = STATE(1351),
    [sym_compiler_directive_decl] = STATE(1351),
    [sym_fsi_directive_decl] = STATE(1351),
    [sym_preproc_line] = STATE(1351),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [anon_sym_POUNDendif] = ACTIONS(3353),
    [anon_sym_POUNDelse] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1352] = {
    [sym_xml_doc] = STATE(1352),
    [sym_block_comment] = STATE(1352),
    [sym_line_comment] = STATE(1352),
    [sym_compiler_directive_decl] = STATE(1352),
    [sym_fsi_directive_decl] = STATE(1352),
    [sym_preproc_line] = STATE(1352),
    [aux_sym_type_argument_repeat1] = STATE(1346),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4157),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [anon_sym_POUNDendif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1353] = {
    [sym_xml_doc] = STATE(1353),
    [sym_block_comment] = STATE(1353),
    [sym_line_comment] = STATE(1353),
    [sym_compiler_directive_decl] = STATE(1353),
    [sym_fsi_directive_decl] = STATE(1353),
    [sym_preproc_line] = STATE(1353),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [anon_sym_POUNDendif] = ACTIONS(3312),
    [anon_sym_POUNDelse] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [1354] = {
    [sym_xml_doc] = STATE(1354),
    [sym_block_comment] = STATE(1354),
    [sym_line_comment] = STATE(1354),
    [sym_compiler_directive_decl] = STATE(1354),
    [sym_fsi_directive_decl] = STATE(1354),
    [sym_preproc_line] = STATE(1354),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [anon_sym_POUNDendif] = ACTIONS(3306),
    [anon_sym_POUNDelse] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1355] = {
    [sym_xml_doc] = STATE(1355),
    [sym_block_comment] = STATE(1355),
    [sym_line_comment] = STATE(1355),
    [sym_compiler_directive_decl] = STATE(1355),
    [sym_fsi_directive_decl] = STATE(1355),
    [sym_preproc_line] = STATE(1355),
    [aux_sym__compound_type_repeat1] = STATE(1317),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_AT_GT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1356] = {
    [sym_xml_doc] = STATE(1356),
    [sym_block_comment] = STATE(1356),
    [sym_line_comment] = STATE(1356),
    [sym_compiler_directive_decl] = STATE(1356),
    [sym_fsi_directive_decl] = STATE(1356),
    [sym_preproc_line] = STATE(1356),
    [ts_builtin_sym_end] = ACTIONS(3890),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_namespace] = ACTIONS(3888),
    [anon_sym_module] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_open] = ACTIONS(3888),
    [anon_sym_LBRACK_LT] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_type] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3890),
    [anon_sym_POUNDload] = ACTIONS(3890),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [1357] = {
    [sym_xml_doc] = STATE(1357),
    [sym_block_comment] = STATE(1357),
    [sym_line_comment] = STATE(1357),
    [sym_compiler_directive_decl] = STATE(1357),
    [sym_fsi_directive_decl] = STATE(1357),
    [sym_preproc_line] = STATE(1357),
    [aux_sym_long_identifier_repeat1] = STATE(1406),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [1358] = {
    [sym_xml_doc] = STATE(1358),
    [sym_block_comment] = STATE(1358),
    [sym_line_comment] = STATE(1358),
    [sym_compiler_directive_decl] = STATE(1358),
    [sym_fsi_directive_decl] = STATE(1358),
    [sym_preproc_line] = STATE(1358),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [anon_sym_POUNDendif] = ACTIONS(3310),
    [anon_sym_POUNDelse] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1359] = {
    [sym__else_expression] = STATE(2473),
    [sym_elif_expression] = STATE(1811),
    [sym_xml_doc] = STATE(1359),
    [sym_block_comment] = STATE(1359),
    [sym_line_comment] = STATE(1359),
    [sym_compiler_directive_decl] = STATE(1359),
    [sym_fsi_directive_decl] = STATE(1359),
    [sym_preproc_line] = STATE(1359),
    [aux_sym_if_expression_repeat1] = STATE(1589),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_AT_GT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4136),
    [anon_sym_elif] = ACTIONS(4138),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1360] = {
    [sym_xml_doc] = STATE(1360),
    [sym_block_comment] = STATE(1360),
    [sym_line_comment] = STATE(1360),
    [sym_compiler_directive_decl] = STATE(1360),
    [sym_fsi_directive_decl] = STATE(1360),
    [sym_preproc_line] = STATE(1360),
    [ts_builtin_sym_end] = ACTIONS(3626),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_namespace] = ACTIONS(3624),
    [anon_sym_module] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_open] = ACTIONS(3624),
    [anon_sym_LBRACK_LT] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_type] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3626),
    [anon_sym_POUNDload] = ACTIONS(3626),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [1361] = {
    [sym_xml_doc] = STATE(1361),
    [sym_block_comment] = STATE(1361),
    [sym_line_comment] = STATE(1361),
    [sym_compiler_directive_decl] = STATE(1361),
    [sym_fsi_directive_decl] = STATE(1361),
    [sym_preproc_line] = STATE(1361),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1362] = {
    [sym_xml_doc] = STATE(1362),
    [sym_block_comment] = STATE(1362),
    [sym_line_comment] = STATE(1362),
    [sym_compiler_directive_decl] = STATE(1362),
    [sym_fsi_directive_decl] = STATE(1362),
    [sym_preproc_line] = STATE(1362),
    [ts_builtin_sym_end] = ACTIONS(3604),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_namespace] = ACTIONS(3602),
    [anon_sym_module] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_open] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_type] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3604),
    [anon_sym_POUNDload] = ACTIONS(3604),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [1363] = {
    [sym_xml_doc] = STATE(1363),
    [sym_block_comment] = STATE(1363),
    [sym_line_comment] = STATE(1363),
    [sym_compiler_directive_decl] = STATE(1363),
    [sym_fsi_directive_decl] = STATE(1363),
    [sym_preproc_line] = STATE(1363),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1364] = {
    [sym_xml_doc] = STATE(1364),
    [sym_block_comment] = STATE(1364),
    [sym_line_comment] = STATE(1364),
    [sym_compiler_directive_decl] = STATE(1364),
    [sym_fsi_directive_decl] = STATE(1364),
    [sym_preproc_line] = STATE(1364),
    [aux_sym_type_argument_repeat1] = STATE(1422),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_AT_AT_GT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1365] = {
    [sym_xml_doc] = STATE(1365),
    [sym_block_comment] = STATE(1365),
    [sym_line_comment] = STATE(1365),
    [sym_compiler_directive_decl] = STATE(1365),
    [sym_fsi_directive_decl] = STATE(1365),
    [sym_preproc_line] = STATE(1365),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [anon_sym_POUNDendif] = ACTIONS(3276),
    [anon_sym_POUNDelse] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1366] = {
    [sym_xml_doc] = STATE(1366),
    [sym_block_comment] = STATE(1366),
    [sym_line_comment] = STATE(1366),
    [sym_compiler_directive_decl] = STATE(1366),
    [sym_fsi_directive_decl] = STATE(1366),
    [sym_preproc_line] = STATE(1366),
    [ts_builtin_sym_end] = ACTIONS(3886),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_namespace] = ACTIONS(3884),
    [anon_sym_module] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_open] = ACTIONS(3884),
    [anon_sym_LBRACK_LT] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_type] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3886),
    [anon_sym_POUNDload] = ACTIONS(3886),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [1367] = {
    [sym_xml_doc] = STATE(1367),
    [sym_block_comment] = STATE(1367),
    [sym_line_comment] = STATE(1367),
    [sym_compiler_directive_decl] = STATE(1367),
    [sym_fsi_directive_decl] = STATE(1367),
    [sym_preproc_line] = STATE(1367),
    [ts_builtin_sym_end] = ACTIONS(3838),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_namespace] = ACTIONS(3836),
    [anon_sym_module] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_open] = ACTIONS(3836),
    [anon_sym_LBRACK_LT] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_type] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3838),
    [anon_sym_POUNDload] = ACTIONS(3838),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [1368] = {
    [sym_xml_doc] = STATE(1368),
    [sym_block_comment] = STATE(1368),
    [sym_line_comment] = STATE(1368),
    [sym_compiler_directive_decl] = STATE(1368),
    [sym_fsi_directive_decl] = STATE(1368),
    [sym_preproc_line] = STATE(1368),
    [ts_builtin_sym_end] = ACTIONS(3728),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_namespace] = ACTIONS(3726),
    [anon_sym_module] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_open] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_type] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3728),
    [anon_sym_POUNDload] = ACTIONS(3728),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [1369] = {
    [sym_xml_doc] = STATE(1369),
    [sym_block_comment] = STATE(1369),
    [sym_line_comment] = STATE(1369),
    [sym_compiler_directive_decl] = STATE(1369),
    [sym_fsi_directive_decl] = STATE(1369),
    [sym_preproc_line] = STATE(1369),
    [ts_builtin_sym_end] = ACTIONS(3916),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_namespace] = ACTIONS(3914),
    [anon_sym_module] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_open] = ACTIONS(3914),
    [anon_sym_LBRACK_LT] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_type] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3916),
    [anon_sym_POUNDload] = ACTIONS(3916),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [1370] = {
    [sym_xml_doc] = STATE(1370),
    [sym_block_comment] = STATE(1370),
    [sym_line_comment] = STATE(1370),
    [sym_compiler_directive_decl] = STATE(1370),
    [sym_fsi_directive_decl] = STATE(1370),
    [sym_preproc_line] = STATE(1370),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [anon_sym_POUNDendif] = ACTIONS(3244),
    [anon_sym_POUNDelse] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1371] = {
    [sym_xml_doc] = STATE(1371),
    [sym_block_comment] = STATE(1371),
    [sym_line_comment] = STATE(1371),
    [sym_compiler_directive_decl] = STATE(1371),
    [sym_fsi_directive_decl] = STATE(1371),
    [sym_preproc_line] = STATE(1371),
    [ts_builtin_sym_end] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [1372] = {
    [sym_xml_doc] = STATE(1372),
    [sym_block_comment] = STATE(1372),
    [sym_line_comment] = STATE(1372),
    [sym_compiler_directive_decl] = STATE(1372),
    [sym_fsi_directive_decl] = STATE(1372),
    [sym_preproc_line] = STATE(1372),
    [ts_builtin_sym_end] = ACTIONS(3963),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_namespace] = ACTIONS(3961),
    [anon_sym_module] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_open] = ACTIONS(3961),
    [anon_sym_LBRACK_LT] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_type] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3963),
    [anon_sym_POUNDload] = ACTIONS(3963),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [1373] = {
    [sym_xml_doc] = STATE(1373),
    [sym_block_comment] = STATE(1373),
    [sym_line_comment] = STATE(1373),
    [sym_compiler_directive_decl] = STATE(1373),
    [sym_fsi_directive_decl] = STATE(1373),
    [sym_preproc_line] = STATE(1373),
    [ts_builtin_sym_end] = ACTIONS(3644),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_namespace] = ACTIONS(3642),
    [anon_sym_module] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_open] = ACTIONS(3642),
    [anon_sym_LBRACK_LT] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_type] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3644),
    [anon_sym_POUNDload] = ACTIONS(3644),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [1374] = {
    [sym_xml_doc] = STATE(1374),
    [sym_block_comment] = STATE(1374),
    [sym_line_comment] = STATE(1374),
    [sym_compiler_directive_decl] = STATE(1374),
    [sym_fsi_directive_decl] = STATE(1374),
    [sym_preproc_line] = STATE(1374),
    [ts_builtin_sym_end] = ACTIONS(3816),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_namespace] = ACTIONS(3814),
    [anon_sym_module] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_open] = ACTIONS(3814),
    [anon_sym_LBRACK_LT] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_type] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3816),
    [anon_sym_POUNDload] = ACTIONS(3816),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [1375] = {
    [sym_xml_doc] = STATE(1375),
    [sym_block_comment] = STATE(1375),
    [sym_line_comment] = STATE(1375),
    [sym_compiler_directive_decl] = STATE(1375),
    [sym_fsi_directive_decl] = STATE(1375),
    [sym_preproc_line] = STATE(1375),
    [ts_builtin_sym_end] = ACTIONS(3820),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_namespace] = ACTIONS(3818),
    [anon_sym_module] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_open] = ACTIONS(3818),
    [anon_sym_LBRACK_LT] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_type] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3820),
    [anon_sym_POUNDload] = ACTIONS(3820),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [1376] = {
    [sym_xml_doc] = STATE(1376),
    [sym_block_comment] = STATE(1376),
    [sym_line_comment] = STATE(1376),
    [sym_compiler_directive_decl] = STATE(1376),
    [sym_fsi_directive_decl] = STATE(1376),
    [sym_preproc_line] = STATE(1376),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [anon_sym_POUNDendif] = ACTIONS(3298),
    [anon_sym_POUNDelse] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1377] = {
    [sym__else_expression] = STATE(2627),
    [sym_elif_expression] = STATE(1976),
    [sym_xml_doc] = STATE(1377),
    [sym_block_comment] = STATE(1377),
    [sym_line_comment] = STATE(1377),
    [sym_compiler_directive_decl] = STATE(1377),
    [sym_fsi_directive_decl] = STATE(1377),
    [sym_preproc_line] = STATE(1377),
    [aux_sym_if_expression_repeat1] = STATE(1304),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_AT_AT_GT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4106),
    [anon_sym_elif] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1378] = {
    [sym_xml_doc] = STATE(1378),
    [sym_block_comment] = STATE(1378),
    [sym_line_comment] = STATE(1378),
    [sym_compiler_directive_decl] = STATE(1378),
    [sym_fsi_directive_decl] = STATE(1378),
    [sym_preproc_line] = STATE(1378),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [anon_sym_POUNDendif] = ACTIONS(3353),
    [anon_sym_POUNDelse] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1379] = {
    [sym_xml_doc] = STATE(1379),
    [sym_block_comment] = STATE(1379),
    [sym_line_comment] = STATE(1379),
    [sym_compiler_directive_decl] = STATE(1379),
    [sym_fsi_directive_decl] = STATE(1379),
    [sym_preproc_line] = STATE(1379),
    [ts_builtin_sym_end] = ACTIONS(3897),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_namespace] = ACTIONS(3895),
    [anon_sym_module] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_open] = ACTIONS(3895),
    [anon_sym_LBRACK_LT] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_type] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3897),
    [anon_sym_POUNDload] = ACTIONS(3897),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [1380] = {
    [sym_xml_doc] = STATE(1380),
    [sym_block_comment] = STATE(1380),
    [sym_line_comment] = STATE(1380),
    [sym_compiler_directive_decl] = STATE(1380),
    [sym_fsi_directive_decl] = STATE(1380),
    [sym_preproc_line] = STATE(1380),
    [ts_builtin_sym_end] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [1381] = {
    [sym_xml_doc] = STATE(1381),
    [sym_block_comment] = STATE(1381),
    [sym_line_comment] = STATE(1381),
    [sym_compiler_directive_decl] = STATE(1381),
    [sym_fsi_directive_decl] = STATE(1381),
    [sym_preproc_line] = STATE(1381),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4164),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [anon_sym_POUNDendif] = ACTIONS(3357),
    [anon_sym_POUNDelse] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1382] = {
    [sym__else_expression] = STATE(2760),
    [sym_elif_expression] = STATE(1764),
    [sym_xml_doc] = STATE(1382),
    [sym_block_comment] = STATE(1382),
    [sym_line_comment] = STATE(1382),
    [sym_compiler_directive_decl] = STATE(1382),
    [sym_fsi_directive_decl] = STATE(1382),
    [sym_preproc_line] = STATE(1382),
    [aux_sym_if_expression_repeat1] = STATE(1399),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4166),
    [anon_sym_elif] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_GT] = ACTIONS(3249),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1383] = {
    [sym_xml_doc] = STATE(1383),
    [sym_block_comment] = STATE(1383),
    [sym_line_comment] = STATE(1383),
    [sym_compiler_directive_decl] = STATE(1383),
    [sym_fsi_directive_decl] = STATE(1383),
    [sym_preproc_line] = STATE(1383),
    [aux_sym_type_argument_repeat1] = STATE(1385),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_EQ] = ACTIONS(3232),
    [anon_sym_COLON] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_QMARK] = ACTIONS(3230),
    [anon_sym_COLON_COLON] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3230),
    [anon_sym_DOT] = ACTIONS(3230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_LT_DASH] = ACTIONS(3230),
    [anon_sym_DOT_LBRACK] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_DOT_DOT] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3230),
    [anon_sym_DASH_DOT] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3230),
    [aux_sym_infix_op_token1] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_COLON_EQ] = ACTIONS(3232),
    [anon_sym_DOLLAR] = ACTIONS(3230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3230),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [1384] = {
    [sym_xml_doc] = STATE(1384),
    [sym_block_comment] = STATE(1384),
    [sym_line_comment] = STATE(1384),
    [sym_compiler_directive_decl] = STATE(1384),
    [sym_fsi_directive_decl] = STATE(1384),
    [sym_preproc_line] = STATE(1384),
    [ts_builtin_sym_end] = ACTIONS(3901),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_namespace] = ACTIONS(3899),
    [anon_sym_module] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_open] = ACTIONS(3899),
    [anon_sym_LBRACK_LT] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_type] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3901),
    [anon_sym_POUNDload] = ACTIONS(3901),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [1385] = {
    [sym_xml_doc] = STATE(1385),
    [sym_block_comment] = STATE(1385),
    [sym_line_comment] = STATE(1385),
    [sym_compiler_directive_decl] = STATE(1385),
    [sym_fsi_directive_decl] = STATE(1385),
    [sym_preproc_line] = STATE(1385),
    [aux_sym_type_argument_repeat1] = STATE(1385),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_DOT_DOT] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1386] = {
    [sym_xml_doc] = STATE(1386),
    [sym_block_comment] = STATE(1386),
    [sym_line_comment] = STATE(1386),
    [sym_compiler_directive_decl] = STATE(1386),
    [sym_fsi_directive_decl] = STATE(1386),
    [sym_preproc_line] = STATE(1386),
    [ts_builtin_sym_end] = ACTIONS(3736),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_namespace] = ACTIONS(3734),
    [anon_sym_module] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_open] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_type] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3736),
    [anon_sym_POUNDload] = ACTIONS(3736),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [1387] = {
    [sym_xml_doc] = STATE(1387),
    [sym_block_comment] = STATE(1387),
    [sym_line_comment] = STATE(1387),
    [sym_compiler_directive_decl] = STATE(1387),
    [sym_fsi_directive_decl] = STATE(1387),
    [sym_preproc_line] = STATE(1387),
    [ts_builtin_sym_end] = ACTIONS(4173),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_namespace] = ACTIONS(4175),
    [anon_sym_module] = ACTIONS(4175),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_open] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(4173),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(4175),
    [anon_sym_type] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4175),
    [anon_sym_let] = ACTIONS(4175),
    [anon_sym_let_BANG] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4173),
    [anon_sym_LBRACE] = ACTIONS(4175),
    [anon_sym_LT_AT] = ACTIONS(4175),
    [anon_sym_LT_AT_AT] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4173),
    [anon_sym_new] = ACTIONS(4175),
    [anon_sym_return_BANG] = ACTIONS(4173),
    [anon_sym_yield] = ACTIONS(4175),
    [anon_sym_yield_BANG] = ACTIONS(4173),
    [anon_sym_lazy] = ACTIONS(4175),
    [anon_sym_assert] = ACTIONS(4175),
    [anon_sym_upcast] = ACTIONS(4175),
    [anon_sym_downcast] = ACTIONS(4175),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(4175),
    [anon_sym_while] = ACTIONS(4175),
    [anon_sym_if] = ACTIONS(4175),
    [anon_sym_fun] = ACTIONS(4175),
    [anon_sym_try] = ACTIONS(4175),
    [anon_sym_match] = ACTIONS(4175),
    [anon_sym_match_BANG] = ACTIONS(4173),
    [anon_sym_function] = ACTIONS(4175),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(4175),
    [anon_sym_use_BANG] = ACTIONS(4173),
    [anon_sym_do_BANG] = ACTIONS(4173),
    [anon_sym_begin] = ACTIONS(4175),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(4175),
    [anon_sym_AT_DQUOTE] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [sym_bool] = ACTIONS(4175),
    [sym_unit] = ACTIONS(4175),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4175),
    [sym_op_identifier] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_PLUS_DOT] = ACTIONS(4175),
    [anon_sym_DASH_DOT] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_TILDE] = ACTIONS(4173),
    [aux_sym_prefix_op_token1] = ACTIONS(4175),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(4175),
    [sym_xint] = ACTIONS(4173),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4173),
    [anon_sym_POUNDload] = ACTIONS(4173),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4173),
    [sym__newline] = ACTIONS(3546),
  },
  [1388] = {
    [sym_xml_doc] = STATE(1388),
    [sym_block_comment] = STATE(1388),
    [sym_line_comment] = STATE(1388),
    [sym_compiler_directive_decl] = STATE(1388),
    [sym_fsi_directive_decl] = STATE(1388),
    [sym_preproc_line] = STATE(1388),
    [aux_sym__compound_type_repeat1] = STATE(1425),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3666),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [anon_sym_POUNDendif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1389] = {
    [sym_xml_doc] = STATE(1389),
    [sym_block_comment] = STATE(1389),
    [sym_line_comment] = STATE(1389),
    [sym_compiler_directive_decl] = STATE(1389),
    [sym_fsi_directive_decl] = STATE(1389),
    [sym_preproc_line] = STATE(1389),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [anon_sym_POUNDendif] = ACTIONS(3324),
    [anon_sym_POUNDelse] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1390] = {
    [sym_xml_doc] = STATE(1390),
    [sym_block_comment] = STATE(1390),
    [sym_line_comment] = STATE(1390),
    [sym_compiler_directive_decl] = STATE(1390),
    [sym_fsi_directive_decl] = STATE(1390),
    [sym_preproc_line] = STATE(1390),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1391] = {
    [sym_xml_doc] = STATE(1391),
    [sym_block_comment] = STATE(1391),
    [sym_line_comment] = STATE(1391),
    [sym_compiler_directive_decl] = STATE(1391),
    [sym_fsi_directive_decl] = STATE(1391),
    [sym_preproc_line] = STATE(1391),
    [aux_sym_long_identifier_repeat1] = STATE(1332),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [anon_sym_POUNDendif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1392] = {
    [sym_xml_doc] = STATE(1392),
    [sym_block_comment] = STATE(1392),
    [sym_line_comment] = STATE(1392),
    [sym_compiler_directive_decl] = STATE(1392),
    [sym_fsi_directive_decl] = STATE(1392),
    [sym_preproc_line] = STATE(1392),
    [ts_builtin_sym_end] = ACTIONS(3740),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_namespace] = ACTIONS(3738),
    [anon_sym_module] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_open] = ACTIONS(3738),
    [anon_sym_LBRACK_LT] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_type] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3740),
    [anon_sym_POUNDload] = ACTIONS(3740),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [1393] = {
    [sym_xml_doc] = STATE(1393),
    [sym_block_comment] = STATE(1393),
    [sym_line_comment] = STATE(1393),
    [sym_compiler_directive_decl] = STATE(1393),
    [sym_fsi_directive_decl] = STATE(1393),
    [sym_preproc_line] = STATE(1393),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [anon_sym_POUNDelse] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1394] = {
    [sym_xml_doc] = STATE(1394),
    [sym_block_comment] = STATE(1394),
    [sym_line_comment] = STATE(1394),
    [sym_compiler_directive_decl] = STATE(1394),
    [sym_fsi_directive_decl] = STATE(1394),
    [sym_preproc_line] = STATE(1394),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1395] = {
    [sym_xml_doc] = STATE(1395),
    [sym_block_comment] = STATE(1395),
    [sym_line_comment] = STATE(1395),
    [sym_compiler_directive_decl] = STATE(1395),
    [sym_fsi_directive_decl] = STATE(1395),
    [sym_preproc_line] = STATE(1395),
    [aux_sym_long_identifier_repeat1] = STATE(1408),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4177),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_DOT_DOT] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1396] = {
    [sym_xml_doc] = STATE(1396),
    [sym_block_comment] = STATE(1396),
    [sym_line_comment] = STATE(1396),
    [sym_compiler_directive_decl] = STATE(1396),
    [sym_fsi_directive_decl] = STATE(1396),
    [sym_preproc_line] = STATE(1396),
    [ts_builtin_sym_end] = ACTIONS(3748),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_namespace] = ACTIONS(3746),
    [anon_sym_module] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_open] = ACTIONS(3746),
    [anon_sym_LBRACK_LT] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_type] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3748),
    [anon_sym_POUNDload] = ACTIONS(3748),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [1397] = {
    [sym_xml_doc] = STATE(1397),
    [sym_block_comment] = STATE(1397),
    [sym_line_comment] = STATE(1397),
    [sym_compiler_directive_decl] = STATE(1397),
    [sym_fsi_directive_decl] = STATE(1397),
    [sym_preproc_line] = STATE(1397),
    [ts_builtin_sym_end] = ACTIONS(3800),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_namespace] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_open] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_type] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3800),
    [anon_sym_POUNDload] = ACTIONS(3800),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [1398] = {
    [sym_xml_doc] = STATE(1398),
    [sym_block_comment] = STATE(1398),
    [sym_line_comment] = STATE(1398),
    [sym_compiler_directive_decl] = STATE(1398),
    [sym_fsi_directive_decl] = STATE(1398),
    [sym_preproc_line] = STATE(1398),
    [ts_builtin_sym_end] = ACTIONS(3931),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_namespace] = ACTIONS(3929),
    [anon_sym_module] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_open] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_type] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3931),
    [anon_sym_POUNDload] = ACTIONS(3931),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [1399] = {
    [sym__else_expression] = STATE(2678),
    [sym_elif_expression] = STATE(1764),
    [sym_xml_doc] = STATE(1399),
    [sym_block_comment] = STATE(1399),
    [sym_line_comment] = STATE(1399),
    [sym_compiler_directive_decl] = STATE(1399),
    [sym_fsi_directive_decl] = STATE(1399),
    [sym_preproc_line] = STATE(1399),
    [aux_sym_if_expression_repeat1] = STATE(1525),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4166),
    [anon_sym_elif] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3281),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1400] = {
    [sym_xml_doc] = STATE(1400),
    [sym_block_comment] = STATE(1400),
    [sym_line_comment] = STATE(1400),
    [sym_compiler_directive_decl] = STATE(1400),
    [sym_fsi_directive_decl] = STATE(1400),
    [sym_preproc_line] = STATE(1400),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1401] = {
    [sym_xml_doc] = STATE(1401),
    [sym_block_comment] = STATE(1401),
    [sym_line_comment] = STATE(1401),
    [sym_compiler_directive_decl] = STATE(1401),
    [sym_fsi_directive_decl] = STATE(1401),
    [sym_preproc_line] = STATE(1401),
    [aux_sym_type_argument_repeat1] = STATE(1337),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4179),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1402] = {
    [sym_xml_doc] = STATE(1402),
    [sym_block_comment] = STATE(1402),
    [sym_line_comment] = STATE(1402),
    [sym_compiler_directive_decl] = STATE(1402),
    [sym_fsi_directive_decl] = STATE(1402),
    [sym_preproc_line] = STATE(1402),
    [aux_sym_long_identifier_repeat1] = STATE(1357),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_module] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_open] = ACTIONS(3261),
    [anon_sym_LBRACK_LT] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3264),
    [anon_sym_POUNDload] = ACTIONS(3264),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [1403] = {
    [sym_xml_doc] = STATE(1403),
    [sym_block_comment] = STATE(1403),
    [sym_line_comment] = STATE(1403),
    [sym_compiler_directive_decl] = STATE(1403),
    [sym_fsi_directive_decl] = STATE(1403),
    [sym_preproc_line] = STATE(1403),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_module] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_open] = ACTIONS(3542),
    [anon_sym_LBRACK_LT] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_type] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3544),
    [anon_sym_POUNDload] = ACTIONS(3544),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
    [sym__dedent] = ACTIONS(3544),
  },
  [1404] = {
    [sym_xml_doc] = STATE(1404),
    [sym_block_comment] = STATE(1404),
    [sym_line_comment] = STATE(1404),
    [sym_compiler_directive_decl] = STATE(1404),
    [sym_fsi_directive_decl] = STATE(1404),
    [sym_preproc_line] = STATE(1404),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_module] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3483),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_type] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1405] = {
    [sym_xml_doc] = STATE(1405),
    [sym_block_comment] = STATE(1405),
    [sym_line_comment] = STATE(1405),
    [sym_compiler_directive_decl] = STATE(1405),
    [sym_fsi_directive_decl] = STATE(1405),
    [sym_preproc_line] = STATE(1405),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [anon_sym_POUNDendif] = ACTIONS(3320),
    [anon_sym_POUNDelse] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1406] = {
    [sym_xml_doc] = STATE(1406),
    [sym_block_comment] = STATE(1406),
    [sym_line_comment] = STATE(1406),
    [sym_compiler_directive_decl] = STATE(1406),
    [sym_fsi_directive_decl] = STATE(1406),
    [sym_preproc_line] = STATE(1406),
    [aux_sym_long_identifier_repeat1] = STATE(1406),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1407] = {
    [sym_xml_doc] = STATE(1407),
    [sym_block_comment] = STATE(1407),
    [sym_line_comment] = STATE(1407),
    [sym_compiler_directive_decl] = STATE(1407),
    [sym_fsi_directive_decl] = STATE(1407),
    [sym_preproc_line] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(3796),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_namespace] = ACTIONS(3794),
    [anon_sym_module] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_open] = ACTIONS(3794),
    [anon_sym_LBRACK_LT] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_type] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3796),
    [anon_sym_POUNDload] = ACTIONS(3796),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [1408] = {
    [sym_xml_doc] = STATE(1408),
    [sym_block_comment] = STATE(1408),
    [sym_line_comment] = STATE(1408),
    [sym_compiler_directive_decl] = STATE(1408),
    [sym_fsi_directive_decl] = STATE(1408),
    [sym_preproc_line] = STATE(1408),
    [aux_sym_long_identifier_repeat1] = STATE(1408),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4189),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1409] = {
    [sym_xml_doc] = STATE(1409),
    [sym_block_comment] = STATE(1409),
    [sym_line_comment] = STATE(1409),
    [sym_compiler_directive_decl] = STATE(1409),
    [sym_fsi_directive_decl] = STATE(1409),
    [sym_preproc_line] = STATE(1409),
    [ts_builtin_sym_end] = ACTIONS(3935),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_namespace] = ACTIONS(3933),
    [anon_sym_module] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_open] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_type] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3935),
    [anon_sym_POUNDload] = ACTIONS(3935),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [1410] = {
    [sym_xml_doc] = STATE(1410),
    [sym_block_comment] = STATE(1410),
    [sym_line_comment] = STATE(1410),
    [sym_compiler_directive_decl] = STATE(1410),
    [sym_fsi_directive_decl] = STATE(1410),
    [sym_preproc_line] = STATE(1410),
    [aux_sym_sequential_expression_repeat1] = STATE(1306),
    [ts_builtin_sym_end] = ACTIONS(3614),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_module] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_open] = ACTIONS(3612),
    [anon_sym_LBRACK_LT] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_type] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3614),
    [anon_sym_POUNDload] = ACTIONS(3614),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1411] = {
    [sym__else_expression] = STATE(2562),
    [sym_elif_expression] = STATE(1942),
    [sym_xml_doc] = STATE(1411),
    [sym_block_comment] = STATE(1411),
    [sym_line_comment] = STATE(1411),
    [sym_compiler_directive_decl] = STATE(1411),
    [sym_fsi_directive_decl] = STATE(1411),
    [sym_preproc_line] = STATE(1411),
    [aux_sym_if_expression_repeat1] = STATE(1433),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3251),
    [anon_sym_COLON] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_let_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_COMMA] = ACTIONS(3251),
    [anon_sym_null] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_QMARK] = ACTIONS(3249),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_LT_AT] = ACTIONS(3249),
    [anon_sym_LT_AT_AT] = ACTIONS(3249),
    [anon_sym_DOT] = ACTIONS(3249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_return_BANG] = ACTIONS(3251),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_yield_BANG] = ACTIONS(3251),
    [anon_sym_lazy] = ACTIONS(3249),
    [anon_sym_assert] = ACTIONS(3249),
    [anon_sym_upcast] = ACTIONS(3249),
    [anon_sym_downcast] = ACTIONS(3249),
    [anon_sym_COLON_GT] = ACTIONS(3251),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3251),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(4192),
    [anon_sym_elif] = ACTIONS(4194),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_fun] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_match] = ACTIONS(3249),
    [anon_sym_match_BANG] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_LT_DASH] = ACTIONS(3249),
    [anon_sym_DOT_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_use] = ACTIONS(3249),
    [anon_sym_use_BANG] = ACTIONS(3251),
    [anon_sym_do_BANG] = ACTIONS(3251),
    [anon_sym_begin] = ACTIONS(3249),
    [anon_sym_LPAREN2] = ACTIONS(3251),
    [anon_sym_or] = ACTIONS(3249),
    [aux_sym_char_token1] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_AT_DQUOTE] = ACTIONS(3251),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3251),
    [sym_bool] = ACTIONS(3249),
    [sym_unit] = ACTIONS(3249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3249),
    [sym_op_identifier] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_PLUS_DOT] = ACTIONS(3249),
    [anon_sym_DASH_DOT] = ACTIONS(3249),
    [anon_sym_PERCENT] = ACTIONS(3249),
    [anon_sym_AMP_AMP] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3251),
    [aux_sym_prefix_op_token1] = ACTIONS(3249),
    [aux_sym_infix_op_token1] = ACTIONS(3249),
    [anon_sym_PIPE_PIPE] = ACTIONS(3249),
    [anon_sym_BANG_EQ] = ACTIONS(3249),
    [anon_sym_COLON_EQ] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3249),
    [sym_int] = ACTIONS(3249),
    [sym_xint] = ACTIONS(3251),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3251),
    [anon_sym_POUNDendif] = ACTIONS(3251),
    [sym__newline] = ACTIONS(3251),
  },
  [1412] = {
    [sym_xml_doc] = STATE(1412),
    [sym_block_comment] = STATE(1412),
    [sym_line_comment] = STATE(1412),
    [sym_compiler_directive_decl] = STATE(1412),
    [sym_fsi_directive_decl] = STATE(1412),
    [sym_preproc_line] = STATE(1412),
    [ts_builtin_sym_end] = ACTIONS(3842),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_namespace] = ACTIONS(3840),
    [anon_sym_module] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_open] = ACTIONS(3840),
    [anon_sym_LBRACK_LT] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_type] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3842),
    [anon_sym_POUNDload] = ACTIONS(3842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [1413] = {
    [sym_xml_doc] = STATE(1413),
    [sym_block_comment] = STATE(1413),
    [sym_line_comment] = STATE(1413),
    [sym_compiler_directive_decl] = STATE(1413),
    [sym_fsi_directive_decl] = STATE(1413),
    [sym_preproc_line] = STATE(1413),
    [ts_builtin_sym_end] = ACTIONS(3927),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_namespace] = ACTIONS(3925),
    [anon_sym_module] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_open] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_type] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3927),
    [anon_sym_POUNDload] = ACTIONS(3927),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [1414] = {
    [sym_xml_doc] = STATE(1414),
    [sym_block_comment] = STATE(1414),
    [sym_line_comment] = STATE(1414),
    [sym_compiler_directive_decl] = STATE(1414),
    [sym_fsi_directive_decl] = STATE(1414),
    [sym_preproc_line] = STATE(1414),
    [ts_builtin_sym_end] = ACTIONS(3792),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_namespace] = ACTIONS(3790),
    [anon_sym_module] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_open] = ACTIONS(3790),
    [anon_sym_LBRACK_LT] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_type] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3792),
    [anon_sym_POUNDload] = ACTIONS(3792),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [1415] = {
    [sym_xml_doc] = STATE(1415),
    [sym_block_comment] = STATE(1415),
    [sym_line_comment] = STATE(1415),
    [sym_compiler_directive_decl] = STATE(1415),
    [sym_fsi_directive_decl] = STATE(1415),
    [sym_preproc_line] = STATE(1415),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [anon_sym_POUNDendif] = ACTIONS(3294),
    [anon_sym_POUNDelse] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1416] = {
    [sym_xml_doc] = STATE(1416),
    [sym_block_comment] = STATE(1416),
    [sym_line_comment] = STATE(1416),
    [sym_compiler_directive_decl] = STATE(1416),
    [sym_fsi_directive_decl] = STATE(1416),
    [sym_preproc_line] = STATE(1416),
    [aux_sym_type_argument_repeat1] = STATE(1364),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_AT_AT_GT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4196),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1417] = {
    [sym_xml_doc] = STATE(1417),
    [sym_block_comment] = STATE(1417),
    [sym_line_comment] = STATE(1417),
    [sym_compiler_directive_decl] = STATE(1417),
    [sym_fsi_directive_decl] = STATE(1417),
    [sym_preproc_line] = STATE(1417),
    [ts_builtin_sym_end] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_namespace] = ACTIONS(3620),
    [anon_sym_module] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_open] = ACTIONS(3620),
    [anon_sym_LBRACK_LT] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_type] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3622),
    [anon_sym_POUNDload] = ACTIONS(3622),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [1418] = {
    [sym_xml_doc] = STATE(1418),
    [sym_block_comment] = STATE(1418),
    [sym_line_comment] = STATE(1418),
    [sym_compiler_directive_decl] = STATE(1418),
    [sym_fsi_directive_decl] = STATE(1418),
    [sym_preproc_line] = STATE(1418),
    [ts_builtin_sym_end] = ACTIONS(3967),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_namespace] = ACTIONS(3965),
    [anon_sym_module] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_open] = ACTIONS(3965),
    [anon_sym_LBRACK_LT] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_type] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3967),
    [anon_sym_POUNDload] = ACTIONS(3967),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [1419] = {
    [sym_xml_doc] = STATE(1419),
    [sym_block_comment] = STATE(1419),
    [sym_line_comment] = STATE(1419),
    [sym_compiler_directive_decl] = STATE(1419),
    [sym_fsi_directive_decl] = STATE(1419),
    [sym_preproc_line] = STATE(1419),
    [aux_sym_long_identifier_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_AT_GT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1420] = {
    [sym_xml_doc] = STATE(1420),
    [sym_block_comment] = STATE(1420),
    [sym_line_comment] = STATE(1420),
    [sym_compiler_directive_decl] = STATE(1420),
    [sym_fsi_directive_decl] = STATE(1420),
    [sym_preproc_line] = STATE(1420),
    [aux_sym__compound_type_repeat1] = STATE(1420),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_DOT_DOT] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1421] = {
    [sym_xml_doc] = STATE(1421),
    [sym_block_comment] = STATE(1421),
    [sym_line_comment] = STATE(1421),
    [sym_compiler_directive_decl] = STATE(1421),
    [sym_fsi_directive_decl] = STATE(1421),
    [sym_preproc_line] = STATE(1421),
    [ts_builtin_sym_end] = ACTIONS(3971),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_namespace] = ACTIONS(3969),
    [anon_sym_module] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_open] = ACTIONS(3969),
    [anon_sym_LBRACK_LT] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_type] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3971),
    [anon_sym_POUNDload] = ACTIONS(3971),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [1422] = {
    [sym_xml_doc] = STATE(1422),
    [sym_block_comment] = STATE(1422),
    [sym_line_comment] = STATE(1422),
    [sym_compiler_directive_decl] = STATE(1422),
    [sym_fsi_directive_decl] = STATE(1422),
    [sym_preproc_line] = STATE(1422),
    [aux_sym_type_argument_repeat1] = STATE(1422),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_AT_AT_GT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(4204),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1423] = {
    [sym_xml_doc] = STATE(1423),
    [sym_block_comment] = STATE(1423),
    [sym_line_comment] = STATE(1423),
    [sym_compiler_directive_decl] = STATE(1423),
    [sym_fsi_directive_decl] = STATE(1423),
    [sym_preproc_line] = STATE(1423),
    [ts_builtin_sym_end] = ACTIONS(3908),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_namespace] = ACTIONS(3906),
    [anon_sym_module] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_open] = ACTIONS(3906),
    [anon_sym_LBRACK_LT] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_type] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3908),
    [anon_sym_POUNDload] = ACTIONS(3908),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [1424] = {
    [sym_xml_doc] = STATE(1424),
    [sym_block_comment] = STATE(1424),
    [sym_line_comment] = STATE(1424),
    [sym_compiler_directive_decl] = STATE(1424),
    [sym_fsi_directive_decl] = STATE(1424),
    [sym_preproc_line] = STATE(1424),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_open] = ACTIONS(3527),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4207),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3529),
    [anon_sym_POUNDload] = ACTIONS(3529),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [1425] = {
    [sym_xml_doc] = STATE(1425),
    [sym_block_comment] = STATE(1425),
    [sym_line_comment] = STATE(1425),
    [sym_compiler_directive_decl] = STATE(1425),
    [sym_fsi_directive_decl] = STATE(1425),
    [sym_preproc_line] = STATE(1425),
    [aux_sym__compound_type_repeat1] = STATE(1425),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4209),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [anon_sym_POUNDendif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1426] = {
    [sym_xml_doc] = STATE(1426),
    [sym_block_comment] = STATE(1426),
    [sym_line_comment] = STATE(1426),
    [sym_compiler_directive_decl] = STATE(1426),
    [sym_fsi_directive_decl] = STATE(1426),
    [sym_preproc_line] = STATE(1426),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_open] = ACTIONS(3523),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_type] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3525),
    [anon_sym_POUNDload] = ACTIONS(3525),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [1427] = {
    [sym_xml_doc] = STATE(1427),
    [sym_block_comment] = STATE(1427),
    [sym_line_comment] = STATE(1427),
    [sym_compiler_directive_decl] = STATE(1427),
    [sym_fsi_directive_decl] = STATE(1427),
    [sym_preproc_line] = STATE(1427),
    [aux_sym__compound_type_repeat1] = STATE(1420),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_DOT_DOT] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1428] = {
    [sym_xml_doc] = STATE(1428),
    [sym_block_comment] = STATE(1428),
    [sym_line_comment] = STATE(1428),
    [sym_compiler_directive_decl] = STATE(1428),
    [sym_fsi_directive_decl] = STATE(1428),
    [sym_preproc_line] = STATE(1428),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_module] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_open] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_type] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3535),
    [anon_sym_POUNDload] = ACTIONS(3535),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
    [sym__dedent] = ACTIONS(3535),
  },
  [1429] = {
    [sym_xml_doc] = STATE(1429),
    [sym_block_comment] = STATE(1429),
    [sym_line_comment] = STATE(1429),
    [sym_compiler_directive_decl] = STATE(1429),
    [sym_fsi_directive_decl] = STATE(1429),
    [sym_preproc_line] = STATE(1429),
    [ts_builtin_sym_end] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_namespace] = ACTIONS(3766),
    [anon_sym_module] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_open] = ACTIONS(3766),
    [anon_sym_LBRACK_LT] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_type] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3768),
    [anon_sym_POUNDload] = ACTIONS(3768),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [1430] = {
    [sym_xml_doc] = STATE(1430),
    [sym_block_comment] = STATE(1430),
    [sym_line_comment] = STATE(1430),
    [sym_compiler_directive_decl] = STATE(1430),
    [sym_fsi_directive_decl] = STATE(1430),
    [sym_preproc_line] = STATE(1430),
    [ts_builtin_sym_end] = ACTIONS(3772),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_namespace] = ACTIONS(3770),
    [anon_sym_module] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_open] = ACTIONS(3770),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_type] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3772),
    [anon_sym_POUNDload] = ACTIONS(3772),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1431] = {
    [sym_xml_doc] = STATE(1431),
    [sym_block_comment] = STATE(1431),
    [sym_line_comment] = STATE(1431),
    [sym_compiler_directive_decl] = STATE(1431),
    [sym_fsi_directive_decl] = STATE(1431),
    [sym_preproc_line] = STATE(1431),
    [ts_builtin_sym_end] = ACTIONS(3579),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_namespace] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_open] = ACTIONS(3577),
    [anon_sym_LBRACK_LT] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3579),
    [anon_sym_POUNDload] = ACTIONS(3579),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [1432] = {
    [sym_xml_doc] = STATE(1432),
    [sym_block_comment] = STATE(1432),
    [sym_line_comment] = STATE(1432),
    [sym_compiler_directive_decl] = STATE(1432),
    [sym_fsi_directive_decl] = STATE(1432),
    [sym_preproc_line] = STATE(1432),
    [aux_sym_type_argument_repeat1] = STATE(1383),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_DOT_DOT] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1433] = {
    [sym__else_expression] = STATE(2648),
    [sym_elif_expression] = STATE(1942),
    [sym_xml_doc] = STATE(1433),
    [sym_block_comment] = STATE(1433),
    [sym_line_comment] = STATE(1433),
    [sym_compiler_directive_decl] = STATE(1433),
    [sym_fsi_directive_decl] = STATE(1433),
    [sym_preproc_line] = STATE(1433),
    [aux_sym_if_expression_repeat1] = STATE(1487),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_let_BANG] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_null] = ACTIONS(3281),
    [anon_sym_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3281),
    [anon_sym_COLON_COLON] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_LT_AT] = ACTIONS(3281),
    [anon_sym_LT_AT_AT] = ACTIONS(3281),
    [anon_sym_DOT] = ACTIONS(3281),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_return_BANG] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_yield_BANG] = ACTIONS(3283),
    [anon_sym_lazy] = ACTIONS(3281),
    [anon_sym_assert] = ACTIONS(3281),
    [anon_sym_upcast] = ACTIONS(3281),
    [anon_sym_downcast] = ACTIONS(3281),
    [anon_sym_COLON_GT] = ACTIONS(3283),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(4192),
    [anon_sym_elif] = ACTIONS(4194),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_fun] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_match] = ACTIONS(3281),
    [anon_sym_match_BANG] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_LT_DASH] = ACTIONS(3281),
    [anon_sym_DOT_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_use] = ACTIONS(3281),
    [anon_sym_use_BANG] = ACTIONS(3283),
    [anon_sym_do_BANG] = ACTIONS(3283),
    [anon_sym_begin] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(3283),
    [anon_sym_or] = ACTIONS(3281),
    [aux_sym_char_token1] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_AT_DQUOTE] = ACTIONS(3283),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3283),
    [sym_bool] = ACTIONS(3281),
    [sym_unit] = ACTIONS(3281),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3281),
    [sym_op_identifier] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_PLUS_DOT] = ACTIONS(3281),
    [anon_sym_DASH_DOT] = ACTIONS(3281),
    [anon_sym_PERCENT] = ACTIONS(3281),
    [anon_sym_AMP_AMP] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3283),
    [aux_sym_prefix_op_token1] = ACTIONS(3281),
    [aux_sym_infix_op_token1] = ACTIONS(3281),
    [anon_sym_PIPE_PIPE] = ACTIONS(3281),
    [anon_sym_BANG_EQ] = ACTIONS(3281),
    [anon_sym_COLON_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(3281),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3281),
    [sym_int] = ACTIONS(3281),
    [sym_xint] = ACTIONS(3283),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3283),
    [anon_sym_POUNDendif] = ACTIONS(3283),
    [sym__newline] = ACTIONS(3283),
  },
  [1434] = {
    [sym_xml_doc] = STATE(1434),
    [sym_block_comment] = STATE(1434),
    [sym_line_comment] = STATE(1434),
    [sym_compiler_directive_decl] = STATE(1434),
    [sym_fsi_directive_decl] = STATE(1434),
    [sym_preproc_line] = STATE(1434),
    [ts_builtin_sym_end] = ACTIONS(3780),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_namespace] = ACTIONS(3778),
    [anon_sym_module] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_open] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_type] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3780),
    [anon_sym_POUNDload] = ACTIONS(3780),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [1435] = {
    [sym_xml_doc] = STATE(1435),
    [sym_block_comment] = STATE(1435),
    [sym_line_comment] = STATE(1435),
    [sym_compiler_directive_decl] = STATE(1435),
    [sym_fsi_directive_decl] = STATE(1435),
    [sym_preproc_line] = STATE(1435),
    [aux_sym__compound_type_repeat1] = STATE(1453),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3214),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_QMARK] = ACTIONS(3212),
    [anon_sym_COLON_COLON] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_COLON_GT] = ACTIONS(3214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_LT_DASH] = ACTIONS(3212),
    [anon_sym_DOT_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_GT] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_LPAREN2] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_or] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3212),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3212),
    [anon_sym_DASH_DOT] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3212),
    [aux_sym_infix_op_token1] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_COLON_EQ] = ACTIONS(3214),
    [anon_sym_DOLLAR] = ACTIONS(3212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3212),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [1436] = {
    [sym_xml_doc] = STATE(1436),
    [sym_block_comment] = STATE(1436),
    [sym_line_comment] = STATE(1436),
    [sym_compiler_directive_decl] = STATE(1436),
    [sym_fsi_directive_decl] = STATE(1436),
    [sym_preproc_line] = STATE(1436),
    [ts_builtin_sym_end] = ACTIONS(3975),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_namespace] = ACTIONS(3973),
    [anon_sym_module] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_open] = ACTIONS(3973),
    [anon_sym_LBRACK_LT] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_type] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3975),
    [anon_sym_POUNDload] = ACTIONS(3975),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [1437] = {
    [sym_xml_doc] = STATE(1437),
    [sym_block_comment] = STATE(1437),
    [sym_line_comment] = STATE(1437),
    [sym_compiler_directive_decl] = STATE(1437),
    [sym_fsi_directive_decl] = STATE(1437),
    [sym_preproc_line] = STATE(1437),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4215),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
    [sym__dedent] = ACTIONS(3389),
  },
  [1438] = {
    [sym_xml_doc] = STATE(1438),
    [sym_block_comment] = STATE(1438),
    [sym_line_comment] = STATE(1438),
    [sym_compiler_directive_decl] = STATE(1438),
    [sym_fsi_directive_decl] = STATE(1438),
    [sym_preproc_line] = STATE(1438),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1439] = {
    [sym_xml_doc] = STATE(1439),
    [sym_block_comment] = STATE(1439),
    [sym_line_comment] = STATE(1439),
    [sym_compiler_directive_decl] = STATE(1439),
    [sym_fsi_directive_decl] = STATE(1439),
    [sym_preproc_line] = STATE(1439),
    [aux_sym_long_identifier_repeat1] = STATE(1419),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_AT_GT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1440] = {
    [sym_xml_doc] = STATE(1440),
    [sym_block_comment] = STATE(1440),
    [sym_line_comment] = STATE(1440),
    [sym_compiler_directive_decl] = STATE(1440),
    [sym_fsi_directive_decl] = STATE(1440),
    [sym_preproc_line] = STATE(1440),
    [aux_sym_long_identifier_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_AT_GT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4217),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1441] = {
    [sym_xml_doc] = STATE(1441),
    [sym_block_comment] = STATE(1441),
    [sym_line_comment] = STATE(1441),
    [sym_compiler_directive_decl] = STATE(1441),
    [sym_fsi_directive_decl] = STATE(1441),
    [sym_preproc_line] = STATE(1441),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1442] = {
    [sym_xml_doc] = STATE(1442),
    [sym_block_comment] = STATE(1442),
    [sym_line_comment] = STATE(1442),
    [sym_compiler_directive_decl] = STATE(1442),
    [sym_fsi_directive_decl] = STATE(1442),
    [sym_preproc_line] = STATE(1442),
    [ts_builtin_sym_end] = ACTIONS(3979),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_module] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_open] = ACTIONS(3977),
    [anon_sym_LBRACK_LT] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_type] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3979),
    [anon_sym_POUNDload] = ACTIONS(3979),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [1443] = {
    [sym_xml_doc] = STATE(1443),
    [sym_block_comment] = STATE(1443),
    [sym_line_comment] = STATE(1443),
    [sym_compiler_directive_decl] = STATE(1443),
    [sym_fsi_directive_decl] = STATE(1443),
    [sym_preproc_line] = STATE(1443),
    [ts_builtin_sym_end] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_namespace] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_open] = ACTIONS(3598),
    [anon_sym_LBRACK_LT] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_type] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3600),
    [anon_sym_POUNDload] = ACTIONS(3600),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [1444] = {
    [sym_xml_doc] = STATE(1444),
    [sym_block_comment] = STATE(1444),
    [sym_line_comment] = STATE(1444),
    [sym_compiler_directive_decl] = STATE(1444),
    [sym_fsi_directive_decl] = STATE(1444),
    [sym_preproc_line] = STATE(1444),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1445] = {
    [sym_xml_doc] = STATE(1445),
    [sym_block_comment] = STATE(1445),
    [sym_line_comment] = STATE(1445),
    [sym_compiler_directive_decl] = STATE(1445),
    [sym_fsi_directive_decl] = STATE(1445),
    [sym_preproc_line] = STATE(1445),
    [ts_builtin_sym_end] = ACTIONS(3776),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_namespace] = ACTIONS(3774),
    [anon_sym_module] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_open] = ACTIONS(3774),
    [anon_sym_LBRACK_LT] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_type] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3776),
    [anon_sym_POUNDload] = ACTIONS(3776),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [1446] = {
    [sym_xml_doc] = STATE(1446),
    [sym_block_comment] = STATE(1446),
    [sym_line_comment] = STATE(1446),
    [sym_compiler_directive_decl] = STATE(1446),
    [sym_fsi_directive_decl] = STATE(1446),
    [sym_preproc_line] = STATE(1446),
    [ts_builtin_sym_end] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_module] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_open] = ACTIONS(3581),
    [anon_sym_LBRACK_LT] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_type] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3583),
    [anon_sym_POUNDload] = ACTIONS(3583),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [1447] = {
    [sym_xml_doc] = STATE(1447),
    [sym_block_comment] = STATE(1447),
    [sym_line_comment] = STATE(1447),
    [sym_compiler_directive_decl] = STATE(1447),
    [sym_fsi_directive_decl] = STATE(1447),
    [sym_preproc_line] = STATE(1447),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_module] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_open] = ACTIONS(3585),
    [anon_sym_LBRACK_LT] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_type] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3587),
    [anon_sym_POUNDload] = ACTIONS(3587),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [1448] = {
    [sym_xml_doc] = STATE(1448),
    [sym_block_comment] = STATE(1448),
    [sym_line_comment] = STATE(1448),
    [sym_compiler_directive_decl] = STATE(1448),
    [sym_fsi_directive_decl] = STATE(1448),
    [sym_preproc_line] = STATE(1448),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1449] = {
    [sym_xml_doc] = STATE(1449),
    [sym_block_comment] = STATE(1449),
    [sym_line_comment] = STATE(1449),
    [sym_compiler_directive_decl] = STATE(1449),
    [sym_fsi_directive_decl] = STATE(1449),
    [sym_preproc_line] = STATE(1449),
    [aux_sym_type_argument_repeat1] = STATE(1449),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1450] = {
    [sym_xml_doc] = STATE(1450),
    [sym_block_comment] = STATE(1450),
    [sym_line_comment] = STATE(1450),
    [sym_compiler_directive_decl] = STATE(1450),
    [sym_fsi_directive_decl] = STATE(1450),
    [sym_preproc_line] = STATE(1450),
    [ts_builtin_sym_end] = ACTIONS(3707),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_namespace] = ACTIONS(3705),
    [anon_sym_module] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_open] = ACTIONS(3705),
    [anon_sym_LBRACK_LT] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_type] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3707),
    [anon_sym_POUNDload] = ACTIONS(3707),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [1451] = {
    [sym_xml_doc] = STATE(1451),
    [sym_block_comment] = STATE(1451),
    [sym_line_comment] = STATE(1451),
    [sym_compiler_directive_decl] = STATE(1451),
    [sym_fsi_directive_decl] = STATE(1451),
    [sym_preproc_line] = STATE(1451),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1452] = {
    [sym_xml_doc] = STATE(1452),
    [sym_block_comment] = STATE(1452),
    [sym_line_comment] = STATE(1452),
    [sym_compiler_directive_decl] = STATE(1452),
    [sym_fsi_directive_decl] = STATE(1452),
    [sym_preproc_line] = STATE(1452),
    [aux_sym_type_argument_repeat1] = STATE(1280),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_AT_GT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(4223),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1453] = {
    [sym_xml_doc] = STATE(1453),
    [sym_block_comment] = STATE(1453),
    [sym_line_comment] = STATE(1453),
    [sym_compiler_directive_decl] = STATE(1453),
    [sym_fsi_directive_decl] = STATE(1453),
    [sym_preproc_line] = STATE(1453),
    [aux_sym__compound_type_repeat1] = STATE(1453),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3030),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_QMARK] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3032),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_COLON_GT] = ACTIONS(3030),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_LT_DASH] = ACTIONS(3032),
    [anon_sym_DOT_LBRACK] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(4226),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3032),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3032),
    [anon_sym_DASH_DOT] = ACTIONS(3032),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3032),
    [aux_sym_infix_op_token1] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_COLON_EQ] = ACTIONS(3030),
    [anon_sym_DOLLAR] = ACTIONS(3032),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3032),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [1454] = {
    [sym_xml_doc] = STATE(1454),
    [sym_block_comment] = STATE(1454),
    [sym_line_comment] = STATE(1454),
    [sym_compiler_directive_decl] = STATE(1454),
    [sym_fsi_directive_decl] = STATE(1454),
    [sym_preproc_line] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_namespace] = ACTIONS(3937),
    [anon_sym_module] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_open] = ACTIONS(3937),
    [anon_sym_LBRACK_LT] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_type] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3939),
    [anon_sym_POUNDload] = ACTIONS(3939),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [1455] = {
    [sym_xml_doc] = STATE(1455),
    [sym_block_comment] = STATE(1455),
    [sym_line_comment] = STATE(1455),
    [sym_compiler_directive_decl] = STATE(1455),
    [sym_fsi_directive_decl] = STATE(1455),
    [sym_preproc_line] = STATE(1455),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1456] = {
    [sym_xml_doc] = STATE(1456),
    [sym_block_comment] = STATE(1456),
    [sym_line_comment] = STATE(1456),
    [sym_compiler_directive_decl] = STATE(1456),
    [sym_fsi_directive_decl] = STATE(1456),
    [sym_preproc_line] = STATE(1456),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_as] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4229),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1457] = {
    [sym_xml_doc] = STATE(1457),
    [sym_block_comment] = STATE(1457),
    [sym_line_comment] = STATE(1457),
    [sym_compiler_directive_decl] = STATE(1457),
    [sym_fsi_directive_decl] = STATE(1457),
    [sym_preproc_line] = STATE(1457),
    [ts_builtin_sym_end] = ACTIONS(3788),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_namespace] = ACTIONS(3786),
    [anon_sym_module] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_open] = ACTIONS(3786),
    [anon_sym_LBRACK_LT] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_type] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3788),
    [anon_sym_POUNDload] = ACTIONS(3788),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [1458] = {
    [sym_xml_doc] = STATE(1458),
    [sym_block_comment] = STATE(1458),
    [sym_line_comment] = STATE(1458),
    [sym_compiler_directive_decl] = STATE(1458),
    [sym_fsi_directive_decl] = STATE(1458),
    [sym_preproc_line] = STATE(1458),
    [ts_builtin_sym_end] = ACTIONS(3784),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_namespace] = ACTIONS(3782),
    [anon_sym_module] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_open] = ACTIONS(3782),
    [anon_sym_LBRACK_LT] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_type] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3784),
    [anon_sym_POUNDload] = ACTIONS(3784),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [1459] = {
    [sym_xml_doc] = STATE(1459),
    [sym_block_comment] = STATE(1459),
    [sym_line_comment] = STATE(1459),
    [sym_compiler_directive_decl] = STATE(1459),
    [sym_fsi_directive_decl] = STATE(1459),
    [sym_preproc_line] = STATE(1459),
    [aux_sym_long_identifier_repeat1] = STATE(1395),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3259),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3257),
    [anon_sym_DOT] = ACTIONS(4177),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_COLON_GT] = ACTIONS(3259),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3259),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_LT_DASH] = ACTIONS(3257),
    [anon_sym_DOT_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_DOT_DOT] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_LPAREN2] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3257),
    [anon_sym_DASH_DOT] = ACTIONS(3257),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_AMP_AMP] = ACTIONS(3257),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3257),
    [aux_sym_infix_op_token1] = ACTIONS(3257),
    [anon_sym_PIPE_PIPE] = ACTIONS(3257),
    [anon_sym_BANG_EQ] = ACTIONS(3257),
    [anon_sym_COLON_EQ] = ACTIONS(3259),
    [anon_sym_DOLLAR] = ACTIONS(3257),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3257),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [1460] = {
    [sym_xml_doc] = STATE(1460),
    [sym_block_comment] = STATE(1460),
    [sym_line_comment] = STATE(1460),
    [sym_compiler_directive_decl] = STATE(1460),
    [sym_fsi_directive_decl] = STATE(1460),
    [sym_preproc_line] = STATE(1460),
    [aux_sym_long_identifier_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_AT_AT_GT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1461] = {
    [sym_xml_doc] = STATE(1461),
    [sym_block_comment] = STATE(1461),
    [sym_line_comment] = STATE(1461),
    [sym_compiler_directive_decl] = STATE(1461),
    [sym_fsi_directive_decl] = STATE(1461),
    [sym_preproc_line] = STATE(1461),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [anon_sym_POUNDendif] = ACTIONS(3338),
    [anon_sym_POUNDelse] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1462] = {
    [sym_xml_doc] = STATE(1462),
    [sym_block_comment] = STATE(1462),
    [sym_line_comment] = STATE(1462),
    [sym_compiler_directive_decl] = STATE(1462),
    [sym_fsi_directive_decl] = STATE(1462),
    [sym_preproc_line] = STATE(1462),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [anon_sym_POUNDendif] = ACTIONS(3342),
    [anon_sym_POUNDelse] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1463] = {
    [sym_xml_doc] = STATE(1463),
    [sym_block_comment] = STATE(1463),
    [sym_line_comment] = STATE(1463),
    [sym_compiler_directive_decl] = STATE(1463),
    [sym_fsi_directive_decl] = STATE(1463),
    [sym_preproc_line] = STATE(1463),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_GT_RBRACK] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1464] = {
    [sym_xml_doc] = STATE(1464),
    [sym_block_comment] = STATE(1464),
    [sym_line_comment] = STATE(1464),
    [sym_compiler_directive_decl] = STATE(1464),
    [sym_fsi_directive_decl] = STATE(1464),
    [sym_preproc_line] = STATE(1464),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_module] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_open] = ACTIONS(3701),
    [anon_sym_LBRACK_LT] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_type] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3703),
    [anon_sym_POUNDload] = ACTIONS(3703),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
    [sym__dedent] = ACTIONS(3703),
  },
  [1465] = {
    [sym_xml_doc] = STATE(1465),
    [sym_block_comment] = STATE(1465),
    [sym_line_comment] = STATE(1465),
    [sym_compiler_directive_decl] = STATE(1465),
    [sym_fsi_directive_decl] = STATE(1465),
    [sym_preproc_line] = STATE(1465),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_with] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_DOT_DOT2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
  },
  [1466] = {
    [sym_xml_doc] = STATE(1466),
    [sym_block_comment] = STATE(1466),
    [sym_line_comment] = STATE(1466),
    [sym_compiler_directive_decl] = STATE(1466),
    [sym_fsi_directive_decl] = STATE(1466),
    [sym_preproc_line] = STATE(1466),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_module] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_open] = ACTIONS(3608),
    [anon_sym_LBRACK_LT] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_type] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3610),
    [anon_sym_POUNDload] = ACTIONS(3610),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
    [sym__dedent] = ACTIONS(3610),
  },
  [1467] = {
    [sym_xml_doc] = STATE(1467),
    [sym_block_comment] = STATE(1467),
    [sym_line_comment] = STATE(1467),
    [sym_compiler_directive_decl] = STATE(1467),
    [sym_fsi_directive_decl] = STATE(1467),
    [sym_preproc_line] = STATE(1467),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4234),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1468] = {
    [sym_xml_doc] = STATE(1468),
    [sym_block_comment] = STATE(1468),
    [sym_line_comment] = STATE(1468),
    [sym_compiler_directive_decl] = STATE(1468),
    [sym_fsi_directive_decl] = STATE(1468),
    [sym_preproc_line] = STATE(1468),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [anon_sym_POUNDendif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1469] = {
    [sym_xml_doc] = STATE(1469),
    [sym_block_comment] = STATE(1469),
    [sym_line_comment] = STATE(1469),
    [sym_compiler_directive_decl] = STATE(1469),
    [sym_fsi_directive_decl] = STATE(1469),
    [sym_preproc_line] = STATE(1469),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1470] = {
    [sym_xml_doc] = STATE(1470),
    [sym_block_comment] = STATE(1470),
    [sym_line_comment] = STATE(1470),
    [sym_compiler_directive_decl] = STATE(1470),
    [sym_fsi_directive_decl] = STATE(1470),
    [sym_preproc_line] = STATE(1470),
    [aux_sym_long_identifier_repeat1] = STATE(896),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3267),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1471] = {
    [sym_xml_doc] = STATE(1471),
    [sym_block_comment] = STATE(1471),
    [sym_line_comment] = STATE(1471),
    [sym_compiler_directive_decl] = STATE(1471),
    [sym_fsi_directive_decl] = STATE(1471),
    [sym_preproc_line] = STATE(1471),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1472] = {
    [sym_xml_doc] = STATE(1472),
    [sym_block_comment] = STATE(1472),
    [sym_line_comment] = STATE(1472),
    [sym_compiler_directive_decl] = STATE(1472),
    [sym_fsi_directive_decl] = STATE(1472),
    [sym_preproc_line] = STATE(1472),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_DOT_DOT] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4236),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1473] = {
    [sym_xml_doc] = STATE(1473),
    [sym_block_comment] = STATE(1473),
    [sym_line_comment] = STATE(1473),
    [sym_compiler_directive_decl] = STATE(1473),
    [sym_fsi_directive_decl] = STATE(1473),
    [sym_preproc_line] = STATE(1473),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_DOT_DOT] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1474] = {
    [sym_xml_doc] = STATE(1474),
    [sym_block_comment] = STATE(1474),
    [sym_line_comment] = STATE(1474),
    [sym_compiler_directive_decl] = STATE(1474),
    [sym_fsi_directive_decl] = STATE(1474),
    [sym_preproc_line] = STATE(1474),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
    [sym__dedent] = ACTIONS(3389),
  },
  [1475] = {
    [sym_xml_doc] = STATE(1475),
    [sym_block_comment] = STATE(1475),
    [sym_line_comment] = STATE(1475),
    [sym_compiler_directive_decl] = STATE(1475),
    [sym_fsi_directive_decl] = STATE(1475),
    [sym_preproc_line] = STATE(1475),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_AT_GT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1476] = {
    [sym_xml_doc] = STATE(1476),
    [sym_block_comment] = STATE(1476),
    [sym_line_comment] = STATE(1476),
    [sym_compiler_directive_decl] = STATE(1476),
    [sym_fsi_directive_decl] = STATE(1476),
    [sym_preproc_line] = STATE(1476),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_GT] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1477] = {
    [sym_xml_doc] = STATE(1477),
    [sym_block_comment] = STATE(1477),
    [sym_line_comment] = STATE(1477),
    [sym_compiler_directive_decl] = STATE(1477),
    [sym_fsi_directive_decl] = STATE(1477),
    [sym_preproc_line] = STATE(1477),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_module] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_open] = ACTIONS(3585),
    [anon_sym_LBRACK_LT] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_type] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3587),
    [anon_sym_POUNDload] = ACTIONS(3587),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
    [sym__dedent] = ACTIONS(3587),
  },
  [1478] = {
    [sym_xml_doc] = STATE(1478),
    [sym_block_comment] = STATE(1478),
    [sym_line_comment] = STATE(1478),
    [sym_compiler_directive_decl] = STATE(1478),
    [sym_fsi_directive_decl] = STATE(1478),
    [sym_preproc_line] = STATE(1478),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [anon_sym_POUNDendif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1479] = {
    [sym_xml_doc] = STATE(1479),
    [sym_block_comment] = STATE(1479),
    [sym_line_comment] = STATE(1479),
    [sym_compiler_directive_decl] = STATE(1479),
    [sym_fsi_directive_decl] = STATE(1479),
    [sym_preproc_line] = STATE(1479),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [anon_sym_POUNDendif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1480] = {
    [sym_xml_doc] = STATE(1480),
    [sym_block_comment] = STATE(1480),
    [sym_line_comment] = STATE(1480),
    [sym_compiler_directive_decl] = STATE(1480),
    [sym_fsi_directive_decl] = STATE(1480),
    [sym_preproc_line] = STATE(1480),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_DOT_DOT] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1481] = {
    [sym_xml_doc] = STATE(1481),
    [sym_block_comment] = STATE(1481),
    [sym_line_comment] = STATE(1481),
    [sym_compiler_directive_decl] = STATE(1481),
    [sym_fsi_directive_decl] = STATE(1481),
    [sym_preproc_line] = STATE(1481),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [anon_sym_POUNDendif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1482] = {
    [sym_xml_doc] = STATE(1482),
    [sym_block_comment] = STATE(1482),
    [sym_line_comment] = STATE(1482),
    [sym_compiler_directive_decl] = STATE(1482),
    [sym_fsi_directive_decl] = STATE(1482),
    [sym_preproc_line] = STATE(1482),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1483] = {
    [sym_xml_doc] = STATE(1483),
    [sym_block_comment] = STATE(1483),
    [sym_line_comment] = STATE(1483),
    [sym_compiler_directive_decl] = STATE(1483),
    [sym_fsi_directive_decl] = STATE(1483),
    [sym_preproc_line] = STATE(1483),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_GT] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1484] = {
    [sym_xml_doc] = STATE(1484),
    [sym_block_comment] = STATE(1484),
    [sym_line_comment] = STATE(1484),
    [sym_compiler_directive_decl] = STATE(1484),
    [sym_fsi_directive_decl] = STATE(1484),
    [sym_preproc_line] = STATE(1484),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1485] = {
    [sym_xml_doc] = STATE(1485),
    [sym_block_comment] = STATE(1485),
    [sym_line_comment] = STATE(1485),
    [sym_compiler_directive_decl] = STATE(1485),
    [sym_fsi_directive_decl] = STATE(1485),
    [sym_preproc_line] = STATE(1485),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_AT_GT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1486] = {
    [sym_xml_doc] = STATE(1486),
    [sym_block_comment] = STATE(1486),
    [sym_line_comment] = STATE(1486),
    [sym_compiler_directive_decl] = STATE(1486),
    [sym_fsi_directive_decl] = STATE(1486),
    [sym_preproc_line] = STATE(1486),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_module] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_open] = ACTIONS(3581),
    [anon_sym_LBRACK_LT] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_type] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3583),
    [anon_sym_POUNDload] = ACTIONS(3583),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
    [sym__dedent] = ACTIONS(3583),
  },
  [1487] = {
    [sym_elif_expression] = STATE(1942),
    [sym_xml_doc] = STATE(1487),
    [sym_block_comment] = STATE(1487),
    [sym_line_comment] = STATE(1487),
    [sym_compiler_directive_decl] = STATE(1487),
    [sym_fsi_directive_decl] = STATE(1487),
    [sym_preproc_line] = STATE(1487),
    [aux_sym_if_expression_repeat1] = STATE(1487),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [anon_sym_POUNDendif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1488] = {
    [sym_xml_doc] = STATE(1488),
    [sym_block_comment] = STATE(1488),
    [sym_line_comment] = STATE(1488),
    [sym_compiler_directive_decl] = STATE(1488),
    [sym_fsi_directive_decl] = STATE(1488),
    [sym_preproc_line] = STATE(1488),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_module] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_open] = ACTIONS(3774),
    [anon_sym_LBRACK_LT] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_type] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3776),
    [anon_sym_POUNDload] = ACTIONS(3776),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
    [sym__dedent] = ACTIONS(3776),
  },
  [1489] = {
    [sym_xml_doc] = STATE(1489),
    [sym_block_comment] = STATE(1489),
    [sym_line_comment] = STATE(1489),
    [sym_compiler_directive_decl] = STATE(1489),
    [sym_fsi_directive_decl] = STATE(1489),
    [sym_preproc_line] = STATE(1489),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4243),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_DASH_GT] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1490] = {
    [sym_xml_doc] = STATE(1490),
    [sym_block_comment] = STATE(1490),
    [sym_line_comment] = STATE(1490),
    [sym_compiler_directive_decl] = STATE(1490),
    [sym_fsi_directive_decl] = STATE(1490),
    [sym_preproc_line] = STATE(1490),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_module] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_open] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_type] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3604),
    [anon_sym_POUNDload] = ACTIONS(3604),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
    [sym__dedent] = ACTIONS(3604),
  },
  [1491] = {
    [sym_xml_doc] = STATE(1491),
    [sym_block_comment] = STATE(1491),
    [sym_line_comment] = STATE(1491),
    [sym_compiler_directive_decl] = STATE(1491),
    [sym_fsi_directive_decl] = STATE(1491),
    [sym_preproc_line] = STATE(1491),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_DOT_DOT2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
    [sym__dedent] = ACTIONS(3457),
  },
  [1492] = {
    [sym_xml_doc] = STATE(1492),
    [sym_block_comment] = STATE(1492),
    [sym_line_comment] = STATE(1492),
    [sym_compiler_directive_decl] = STATE(1492),
    [sym_fsi_directive_decl] = STATE(1492),
    [sym_preproc_line] = STATE(1492),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_AT_AT_GT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4245),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1493] = {
    [sym_xml_doc] = STATE(1493),
    [sym_block_comment] = STATE(1493),
    [sym_line_comment] = STATE(1493),
    [sym_compiler_directive_decl] = STATE(1493),
    [sym_fsi_directive_decl] = STATE(1493),
    [sym_preproc_line] = STATE(1493),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_module] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_open] = ACTIONS(3616),
    [anon_sym_LBRACK_LT] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3618),
    [anon_sym_POUNDload] = ACTIONS(3618),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
    [sym__dedent] = ACTIONS(3618),
  },
  [1494] = {
    [sym_xml_doc] = STATE(1494),
    [sym_block_comment] = STATE(1494),
    [sym_line_comment] = STATE(1494),
    [sym_compiler_directive_decl] = STATE(1494),
    [sym_fsi_directive_decl] = STATE(1494),
    [sym_preproc_line] = STATE(1494),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_GT] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1495] = {
    [sym_xml_doc] = STATE(1495),
    [sym_block_comment] = STATE(1495),
    [sym_line_comment] = STATE(1495),
    [sym_compiler_directive_decl] = STATE(1495),
    [sym_fsi_directive_decl] = STATE(1495),
    [sym_preproc_line] = STATE(1495),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1496] = {
    [sym_xml_doc] = STATE(1496),
    [sym_block_comment] = STATE(1496),
    [sym_line_comment] = STATE(1496),
    [sym_compiler_directive_decl] = STATE(1496),
    [sym_fsi_directive_decl] = STATE(1496),
    [sym_preproc_line] = STATE(1496),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_GT] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1497] = {
    [sym_xml_doc] = STATE(1497),
    [sym_block_comment] = STATE(1497),
    [sym_line_comment] = STATE(1497),
    [sym_compiler_directive_decl] = STATE(1497),
    [sym_fsi_directive_decl] = STATE(1497),
    [sym_preproc_line] = STATE(1497),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3094),
    [aux_sym_decimal_token1] = ACTIONS(2974),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [1498] = {
    [sym_xml_doc] = STATE(1498),
    [sym_block_comment] = STATE(1498),
    [sym_line_comment] = STATE(1498),
    [sym_compiler_directive_decl] = STATE(1498),
    [sym_fsi_directive_decl] = STATE(1498),
    [sym_preproc_line] = STATE(1498),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_module] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_open] = ACTIONS(3705),
    [anon_sym_LBRACK_LT] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_type] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3707),
    [anon_sym_POUNDload] = ACTIONS(3707),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
    [sym__dedent] = ACTIONS(3707),
  },
  [1499] = {
    [sym_xml_doc] = STATE(1499),
    [sym_block_comment] = STATE(1499),
    [sym_line_comment] = STATE(1499),
    [sym_compiler_directive_decl] = STATE(1499),
    [sym_fsi_directive_decl] = STATE(1499),
    [sym_preproc_line] = STATE(1499),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4247),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1500] = {
    [sym_xml_doc] = STATE(1500),
    [sym_block_comment] = STATE(1500),
    [sym_line_comment] = STATE(1500),
    [sym_compiler_directive_decl] = STATE(1500),
    [sym_fsi_directive_decl] = STATE(1500),
    [sym_preproc_line] = STATE(1500),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_as] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4249),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
    [sym__dedent] = ACTIONS(3419),
  },
  [1501] = {
    [sym_xml_doc] = STATE(1501),
    [sym_block_comment] = STATE(1501),
    [sym_line_comment] = STATE(1501),
    [sym_compiler_directive_decl] = STATE(1501),
    [sym_fsi_directive_decl] = STATE(1501),
    [sym_preproc_line] = STATE(1501),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_AT_AT_GT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1502] = {
    [sym_xml_doc] = STATE(1502),
    [sym_block_comment] = STATE(1502),
    [sym_line_comment] = STATE(1502),
    [sym_compiler_directive_decl] = STATE(1502),
    [sym_fsi_directive_decl] = STATE(1502),
    [sym_preproc_line] = STATE(1502),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_GT] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4251),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1503] = {
    [sym_xml_doc] = STATE(1503),
    [sym_block_comment] = STATE(1503),
    [sym_line_comment] = STATE(1503),
    [sym_compiler_directive_decl] = STATE(1503),
    [sym_fsi_directive_decl] = STATE(1503),
    [sym_preproc_line] = STATE(1503),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_module] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_open] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_type] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3732),
    [anon_sym_POUNDload] = ACTIONS(3732),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
    [sym__dedent] = ACTIONS(3732),
  },
  [1504] = {
    [sym_xml_doc] = STATE(1504),
    [sym_block_comment] = STATE(1504),
    [sym_line_comment] = STATE(1504),
    [sym_compiler_directive_decl] = STATE(1504),
    [sym_fsi_directive_decl] = STATE(1504),
    [sym_preproc_line] = STATE(1504),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [anon_sym_POUNDendif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1505] = {
    [sym_xml_doc] = STATE(1505),
    [sym_block_comment] = STATE(1505),
    [sym_line_comment] = STATE(1505),
    [sym_compiler_directive_decl] = STATE(1505),
    [sym_fsi_directive_decl] = STATE(1505),
    [sym_preproc_line] = STATE(1505),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3298),
  },
  [1506] = {
    [sym_xml_doc] = STATE(1506),
    [sym_block_comment] = STATE(1506),
    [sym_line_comment] = STATE(1506),
    [sym_compiler_directive_decl] = STATE(1506),
    [sym_fsi_directive_decl] = STATE(1506),
    [sym_preproc_line] = STATE(1506),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4253),
  },
  [1507] = {
    [sym_xml_doc] = STATE(1507),
    [sym_block_comment] = STATE(1507),
    [sym_line_comment] = STATE(1507),
    [sym_compiler_directive_decl] = STATE(1507),
    [sym_fsi_directive_decl] = STATE(1507),
    [sym_preproc_line] = STATE(1507),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_as] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
    [sym__dedent] = ACTIONS(3453),
  },
  [1508] = {
    [sym_xml_doc] = STATE(1508),
    [sym_block_comment] = STATE(1508),
    [sym_line_comment] = STATE(1508),
    [sym_compiler_directive_decl] = STATE(1508),
    [sym_fsi_directive_decl] = STATE(1508),
    [sym_preproc_line] = STATE(1508),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_GT] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1509] = {
    [sym_xml_doc] = STATE(1509),
    [sym_block_comment] = STATE(1509),
    [sym_line_comment] = STATE(1509),
    [sym_compiler_directive_decl] = STATE(1509),
    [sym_fsi_directive_decl] = STATE(1509),
    [sym_preproc_line] = STATE(1509),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_module] = ACTIONS(4175),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_open] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(4173),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(4175),
    [anon_sym_type] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4175),
    [anon_sym_let] = ACTIONS(4175),
    [anon_sym_let_BANG] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4173),
    [anon_sym_LBRACE] = ACTIONS(4175),
    [anon_sym_LT_AT] = ACTIONS(4175),
    [anon_sym_LT_AT_AT] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4173),
    [anon_sym_new] = ACTIONS(4175),
    [anon_sym_return_BANG] = ACTIONS(4173),
    [anon_sym_yield] = ACTIONS(4175),
    [anon_sym_yield_BANG] = ACTIONS(4173),
    [anon_sym_lazy] = ACTIONS(4175),
    [anon_sym_assert] = ACTIONS(4175),
    [anon_sym_upcast] = ACTIONS(4175),
    [anon_sym_downcast] = ACTIONS(4175),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(4175),
    [anon_sym_while] = ACTIONS(4175),
    [anon_sym_if] = ACTIONS(4175),
    [anon_sym_fun] = ACTIONS(4175),
    [anon_sym_try] = ACTIONS(4175),
    [anon_sym_match] = ACTIONS(4175),
    [anon_sym_match_BANG] = ACTIONS(4173),
    [anon_sym_function] = ACTIONS(4175),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(4175),
    [anon_sym_use_BANG] = ACTIONS(4173),
    [anon_sym_do_BANG] = ACTIONS(4173),
    [anon_sym_begin] = ACTIONS(4175),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(4175),
    [anon_sym_AT_DQUOTE] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [sym_bool] = ACTIONS(4175),
    [sym_unit] = ACTIONS(4175),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4175),
    [sym_op_identifier] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_PLUS_DOT] = ACTIONS(4175),
    [anon_sym_DASH_DOT] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_TILDE] = ACTIONS(4173),
    [aux_sym_prefix_op_token1] = ACTIONS(4175),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(4175),
    [sym_xint] = ACTIONS(4173),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4173),
    [anon_sym_POUNDload] = ACTIONS(4173),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4173),
    [sym__newline] = ACTIONS(3546),
    [sym__dedent] = ACTIONS(4173),
  },
  [1510] = {
    [sym_xml_doc] = STATE(1510),
    [sym_block_comment] = STATE(1510),
    [sym_line_comment] = STATE(1510),
    [sym_compiler_directive_decl] = STATE(1510),
    [sym_fsi_directive_decl] = STATE(1510),
    [sym_preproc_line] = STATE(1510),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1511] = {
    [sym_xml_doc] = STATE(1511),
    [sym_block_comment] = STATE(1511),
    [sym_line_comment] = STATE(1511),
    [sym_compiler_directive_decl] = STATE(1511),
    [sym_fsi_directive_decl] = STATE(1511),
    [sym_preproc_line] = STATE(1511),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1512] = {
    [sym_xml_doc] = STATE(1512),
    [sym_block_comment] = STATE(1512),
    [sym_line_comment] = STATE(1512),
    [sym_compiler_directive_decl] = STATE(1512),
    [sym_fsi_directive_decl] = STATE(1512),
    [sym_preproc_line] = STATE(1512),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_module] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_open] = ACTIONS(3656),
    [anon_sym_LBRACK_LT] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_type] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3658),
    [anon_sym_POUNDload] = ACTIONS(3658),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
    [sym__dedent] = ACTIONS(3658),
  },
  [1513] = {
    [sym_xml_doc] = STATE(1513),
    [sym_block_comment] = STATE(1513),
    [sym_line_comment] = STATE(1513),
    [sym_compiler_directive_decl] = STATE(1513),
    [sym_fsi_directive_decl] = STATE(1513),
    [sym_preproc_line] = STATE(1513),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1514] = {
    [sym_xml_doc] = STATE(1514),
    [sym_block_comment] = STATE(1514),
    [sym_line_comment] = STATE(1514),
    [sym_compiler_directive_decl] = STATE(1514),
    [sym_fsi_directive_decl] = STATE(1514),
    [sym_preproc_line] = STATE(1514),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_GT] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1515] = {
    [sym_xml_doc] = STATE(1515),
    [sym_block_comment] = STATE(1515),
    [sym_line_comment] = STATE(1515),
    [sym_compiler_directive_decl] = STATE(1515),
    [sym_fsi_directive_decl] = STATE(1515),
    [sym_preproc_line] = STATE(1515),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1516] = {
    [sym_xml_doc] = STATE(1516),
    [sym_block_comment] = STATE(1516),
    [sym_line_comment] = STATE(1516),
    [sym_compiler_directive_decl] = STATE(1516),
    [sym_fsi_directive_decl] = STATE(1516),
    [sym_preproc_line] = STATE(1516),
    [aux_sym_rules_repeat1] = STATE(1522),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4255),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_with] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_DOT_DOT2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4257),
    [sym__dedent] = ACTIONS(3406),
  },
  [1517] = {
    [sym_xml_doc] = STATE(1517),
    [sym_block_comment] = STATE(1517),
    [sym_line_comment] = STATE(1517),
    [sym_compiler_directive_decl] = STATE(1517),
    [sym_fsi_directive_decl] = STATE(1517),
    [sym_preproc_line] = STATE(1517),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3026),
    [aux_sym_decimal_token1] = ACTIONS(2890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [1518] = {
    [sym_xml_doc] = STATE(1518),
    [sym_block_comment] = STATE(1518),
    [sym_line_comment] = STATE(1518),
    [sym_compiler_directive_decl] = STATE(1518),
    [sym_fsi_directive_decl] = STATE(1518),
    [sym_preproc_line] = STATE(1518),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1519] = {
    [sym_xml_doc] = STATE(1519),
    [sym_block_comment] = STATE(1519),
    [sym_line_comment] = STATE(1519),
    [sym_compiler_directive_decl] = STATE(1519),
    [sym_fsi_directive_decl] = STATE(1519),
    [sym_preproc_line] = STATE(1519),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [anon_sym_POUNDendif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1520] = {
    [sym_xml_doc] = STATE(1520),
    [sym_block_comment] = STATE(1520),
    [sym_line_comment] = STATE(1520),
    [sym_compiler_directive_decl] = STATE(1520),
    [sym_fsi_directive_decl] = STATE(1520),
    [sym_preproc_line] = STATE(1520),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_DOT_DOT] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1521] = {
    [sym_xml_doc] = STATE(1521),
    [sym_block_comment] = STATE(1521),
    [sym_line_comment] = STATE(1521),
    [sym_compiler_directive_decl] = STATE(1521),
    [sym_fsi_directive_decl] = STATE(1521),
    [sym_preproc_line] = STATE(1521),
    [aux_sym_rules_repeat1] = STATE(1535),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4255),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_DOT_DOT2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4260),
    [sym__dedent] = ACTIONS(3444),
  },
  [1522] = {
    [sym_xml_doc] = STATE(1522),
    [sym_block_comment] = STATE(1522),
    [sym_line_comment] = STATE(1522),
    [sym_compiler_directive_decl] = STATE(1522),
    [sym_fsi_directive_decl] = STATE(1522),
    [sym_preproc_line] = STATE(1522),
    [aux_sym_rules_repeat1] = STATE(1540),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4255),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_DOT_DOT2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4260),
    [sym__dedent] = ACTIONS(3444),
  },
  [1523] = {
    [sym_xml_doc] = STATE(1523),
    [sym_block_comment] = STATE(1523),
    [sym_line_comment] = STATE(1523),
    [sym_compiler_directive_decl] = STATE(1523),
    [sym_fsi_directive_decl] = STATE(1523),
    [sym_preproc_line] = STATE(1523),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [anon_sym_POUNDendif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1524] = {
    [sym_xml_doc] = STATE(1524),
    [sym_block_comment] = STATE(1524),
    [sym_line_comment] = STATE(1524),
    [sym_compiler_directive_decl] = STATE(1524),
    [sym_fsi_directive_decl] = STATE(1524),
    [sym_preproc_line] = STATE(1524),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_DOT_DOT] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1525] = {
    [sym_elif_expression] = STATE(1764),
    [sym_xml_doc] = STATE(1525),
    [sym_block_comment] = STATE(1525),
    [sym_line_comment] = STATE(1525),
    [sym_compiler_directive_decl] = STATE(1525),
    [sym_fsi_directive_decl] = STATE(1525),
    [sym_preproc_line] = STATE(1525),
    [aux_sym_if_expression_repeat1] = STATE(1525),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4263),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3344),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1526] = {
    [sym_xml_doc] = STATE(1526),
    [sym_block_comment] = STATE(1526),
    [sym_line_comment] = STATE(1526),
    [sym_compiler_directive_decl] = STATE(1526),
    [sym_fsi_directive_decl] = STATE(1526),
    [sym_preproc_line] = STATE(1526),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4266),
  },
  [1527] = {
    [sym_xml_doc] = STATE(1527),
    [sym_block_comment] = STATE(1527),
    [sym_line_comment] = STATE(1527),
    [sym_compiler_directive_decl] = STATE(1527),
    [sym_fsi_directive_decl] = STATE(1527),
    [sym_preproc_line] = STATE(1527),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1528] = {
    [sym_xml_doc] = STATE(1528),
    [sym_block_comment] = STATE(1528),
    [sym_line_comment] = STATE(1528),
    [sym_compiler_directive_decl] = STATE(1528),
    [sym_fsi_directive_decl] = STATE(1528),
    [sym_preproc_line] = STATE(1528),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4268),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1529] = {
    [sym_xml_doc] = STATE(1529),
    [sym_block_comment] = STATE(1529),
    [sym_line_comment] = STATE(1529),
    [sym_compiler_directive_decl] = STATE(1529),
    [sym_fsi_directive_decl] = STATE(1529),
    [sym_preproc_line] = STATE(1529),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4270),
  },
  [1530] = {
    [sym_xml_doc] = STATE(1530),
    [sym_block_comment] = STATE(1530),
    [sym_line_comment] = STATE(1530),
    [sym_compiler_directive_decl] = STATE(1530),
    [sym_fsi_directive_decl] = STATE(1530),
    [sym_preproc_line] = STATE(1530),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1531] = {
    [sym_xml_doc] = STATE(1531),
    [sym_block_comment] = STATE(1531),
    [sym_line_comment] = STATE(1531),
    [sym_compiler_directive_decl] = STATE(1531),
    [sym_fsi_directive_decl] = STATE(1531),
    [sym_preproc_line] = STATE(1531),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_AT_AT_GT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1532] = {
    [sym_xml_doc] = STATE(1532),
    [sym_block_comment] = STATE(1532),
    [sym_line_comment] = STATE(1532),
    [sym_compiler_directive_decl] = STATE(1532),
    [sym_fsi_directive_decl] = STATE(1532),
    [sym_preproc_line] = STATE(1532),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_module] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_open] = ACTIONS(3660),
    [anon_sym_LBRACK_LT] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_type] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3662),
    [anon_sym_POUNDload] = ACTIONS(3662),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
    [sym__dedent] = ACTIONS(3662),
  },
  [1533] = {
    [sym_xml_doc] = STATE(1533),
    [sym_block_comment] = STATE(1533),
    [sym_line_comment] = STATE(1533),
    [sym_compiler_directive_decl] = STATE(1533),
    [sym_fsi_directive_decl] = STATE(1533),
    [sym_preproc_line] = STATE(1533),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_DOT_DOT] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1534] = {
    [sym_xml_doc] = STATE(1534),
    [sym_block_comment] = STATE(1534),
    [sym_line_comment] = STATE(1534),
    [sym_compiler_directive_decl] = STATE(1534),
    [sym_fsi_directive_decl] = STATE(1534),
    [sym_preproc_line] = STATE(1534),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_DASH_GT] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4272),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1535] = {
    [sym_xml_doc] = STATE(1535),
    [sym_block_comment] = STATE(1535),
    [sym_line_comment] = STATE(1535),
    [sym_compiler_directive_decl] = STATE(1535),
    [sym_fsi_directive_decl] = STATE(1535),
    [sym_preproc_line] = STATE(1535),
    [aux_sym_rules_repeat1] = STATE(1540),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4255),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_with] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_DOT_DOT2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4274),
    [sym__dedent] = ACTIONS(3465),
  },
  [1536] = {
    [sym_xml_doc] = STATE(1536),
    [sym_block_comment] = STATE(1536),
    [sym_line_comment] = STATE(1536),
    [sym_compiler_directive_decl] = STATE(1536),
    [sym_fsi_directive_decl] = STATE(1536),
    [sym_preproc_line] = STATE(1536),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [anon_sym_POUNDendif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1537] = {
    [sym_xml_doc] = STATE(1537),
    [sym_block_comment] = STATE(1537),
    [sym_line_comment] = STATE(1537),
    [sym_compiler_directive_decl] = STATE(1537),
    [sym_fsi_directive_decl] = STATE(1537),
    [sym_preproc_line] = STATE(1537),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4277),
  },
  [1538] = {
    [sym_xml_doc] = STATE(1538),
    [sym_block_comment] = STATE(1538),
    [sym_line_comment] = STATE(1538),
    [sym_compiler_directive_decl] = STATE(1538),
    [sym_fsi_directive_decl] = STATE(1538),
    [sym_preproc_line] = STATE(1538),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [anon_sym_POUNDendif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1539] = {
    [sym_xml_doc] = STATE(1539),
    [sym_block_comment] = STATE(1539),
    [sym_line_comment] = STATE(1539),
    [sym_compiler_directive_decl] = STATE(1539),
    [sym_fsi_directive_decl] = STATE(1539),
    [sym_preproc_line] = STATE(1539),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_module] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_open] = ACTIONS(3693),
    [anon_sym_LBRACK_LT] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3695),
    [anon_sym_POUNDload] = ACTIONS(3695),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
    [sym__dedent] = ACTIONS(3695),
  },
  [1540] = {
    [sym_xml_doc] = STATE(1540),
    [sym_block_comment] = STATE(1540),
    [sym_line_comment] = STATE(1540),
    [sym_compiler_directive_decl] = STATE(1540),
    [sym_fsi_directive_decl] = STATE(1540),
    [sym_preproc_line] = STATE(1540),
    [aux_sym_rules_repeat1] = STATE(1540),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4279),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4282),
    [sym__dedent] = ACTIONS(3485),
  },
  [1541] = {
    [sym_xml_doc] = STATE(1541),
    [sym_block_comment] = STATE(1541),
    [sym_line_comment] = STATE(1541),
    [sym_compiler_directive_decl] = STATE(1541),
    [sym_fsi_directive_decl] = STATE(1541),
    [sym_preproc_line] = STATE(1541),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_module] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_open] = ACTIONS(3722),
    [anon_sym_LBRACK_LT] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_type] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3724),
    [anon_sym_POUNDload] = ACTIONS(3724),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
    [sym__dedent] = ACTIONS(3724),
  },
  [1542] = {
    [sym_xml_doc] = STATE(1542),
    [sym_block_comment] = STATE(1542),
    [sym_line_comment] = STATE(1542),
    [sym_compiler_directive_decl] = STATE(1542),
    [sym_fsi_directive_decl] = STATE(1542),
    [sym_preproc_line] = STATE(1542),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [anon_sym_POUNDendif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1543] = {
    [sym_xml_doc] = STATE(1543),
    [sym_block_comment] = STATE(1543),
    [sym_line_comment] = STATE(1543),
    [sym_compiler_directive_decl] = STATE(1543),
    [sym_fsi_directive_decl] = STATE(1543),
    [sym_preproc_line] = STATE(1543),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [anon_sym_POUNDendif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1544] = {
    [sym_xml_doc] = STATE(1544),
    [sym_block_comment] = STATE(1544),
    [sym_line_comment] = STATE(1544),
    [sym_compiler_directive_decl] = STATE(1544),
    [sym_fsi_directive_decl] = STATE(1544),
    [sym_preproc_line] = STATE(1544),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [anon_sym_POUNDendif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1545] = {
    [sym_xml_doc] = STATE(1545),
    [sym_block_comment] = STATE(1545),
    [sym_line_comment] = STATE(1545),
    [sym_compiler_directive_decl] = STATE(1545),
    [sym_fsi_directive_decl] = STATE(1545),
    [sym_preproc_line] = STATE(1545),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1546] = {
    [sym_xml_doc] = STATE(1546),
    [sym_block_comment] = STATE(1546),
    [sym_line_comment] = STATE(1546),
    [sym_compiler_directive_decl] = STATE(1546),
    [sym_fsi_directive_decl] = STATE(1546),
    [sym_preproc_line] = STATE(1546),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4243),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_DASH_GT] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3679),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1547] = {
    [sym_xml_doc] = STATE(1547),
    [sym_block_comment] = STATE(1547),
    [sym_line_comment] = STATE(1547),
    [sym_compiler_directive_decl] = STATE(1547),
    [sym_fsi_directive_decl] = STATE(1547),
    [sym_preproc_line] = STATE(1547),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_module] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_open] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_type] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3728),
    [anon_sym_POUNDload] = ACTIONS(3728),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
    [sym__dedent] = ACTIONS(3728),
  },
  [1548] = {
    [sym_xml_doc] = STATE(1548),
    [sym_block_comment] = STATE(1548),
    [sym_line_comment] = STATE(1548),
    [sym_compiler_directive_decl] = STATE(1548),
    [sym_fsi_directive_decl] = STATE(1548),
    [sym_preproc_line] = STATE(1548),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4285),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1549] = {
    [sym_xml_doc] = STATE(1549),
    [sym_block_comment] = STATE(1549),
    [sym_line_comment] = STATE(1549),
    [sym_compiler_directive_decl] = STATE(1549),
    [sym_fsi_directive_decl] = STATE(1549),
    [sym_preproc_line] = STATE(1549),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4287),
  },
  [1550] = {
    [sym_xml_doc] = STATE(1550),
    [sym_block_comment] = STATE(1550),
    [sym_line_comment] = STATE(1550),
    [sym_compiler_directive_decl] = STATE(1550),
    [sym_fsi_directive_decl] = STATE(1550),
    [sym_preproc_line] = STATE(1550),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_AT_AT_GT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1551] = {
    [sym_xml_doc] = STATE(1551),
    [sym_block_comment] = STATE(1551),
    [sym_line_comment] = STATE(1551),
    [sym_compiler_directive_decl] = STATE(1551),
    [sym_fsi_directive_decl] = STATE(1551),
    [sym_preproc_line] = STATE(1551),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_AT_GT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4289),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1552] = {
    [sym_xml_doc] = STATE(1552),
    [sym_block_comment] = STATE(1552),
    [sym_line_comment] = STATE(1552),
    [sym_compiler_directive_decl] = STATE(1552),
    [sym_fsi_directive_decl] = STATE(1552),
    [sym_preproc_line] = STATE(1552),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_module] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_open] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_type] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3736),
    [anon_sym_POUNDload] = ACTIONS(3736),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
    [sym__dedent] = ACTIONS(3736),
  },
  [1553] = {
    [sym_xml_doc] = STATE(1553),
    [sym_block_comment] = STATE(1553),
    [sym_line_comment] = STATE(1553),
    [sym_compiler_directive_decl] = STATE(1553),
    [sym_fsi_directive_decl] = STATE(1553),
    [sym_preproc_line] = STATE(1553),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1554] = {
    [sym_xml_doc] = STATE(1554),
    [sym_block_comment] = STATE(1554),
    [sym_line_comment] = STATE(1554),
    [sym_compiler_directive_decl] = STATE(1554),
    [sym_fsi_directive_decl] = STATE(1554),
    [sym_preproc_line] = STATE(1554),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_module] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_open] = ACTIONS(3738),
    [anon_sym_LBRACK_LT] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_type] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3740),
    [anon_sym_POUNDload] = ACTIONS(3740),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
    [sym__dedent] = ACTIONS(3740),
  },
  [1555] = {
    [sym_xml_doc] = STATE(1555),
    [sym_block_comment] = STATE(1555),
    [sym_line_comment] = STATE(1555),
    [sym_compiler_directive_decl] = STATE(1555),
    [sym_fsi_directive_decl] = STATE(1555),
    [sym_preproc_line] = STATE(1555),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_AT_GT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1556] = {
    [sym_xml_doc] = STATE(1556),
    [sym_block_comment] = STATE(1556),
    [sym_line_comment] = STATE(1556),
    [sym_compiler_directive_decl] = STATE(1556),
    [sym_fsi_directive_decl] = STATE(1556),
    [sym_preproc_line] = STATE(1556),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_AT_AT_GT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1557] = {
    [sym_xml_doc] = STATE(1557),
    [sym_block_comment] = STATE(1557),
    [sym_line_comment] = STATE(1557),
    [sym_compiler_directive_decl] = STATE(1557),
    [sym_fsi_directive_decl] = STATE(1557),
    [sym_preproc_line] = STATE(1557),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1558] = {
    [sym_xml_doc] = STATE(1558),
    [sym_block_comment] = STATE(1558),
    [sym_line_comment] = STATE(1558),
    [sym_compiler_directive_decl] = STATE(1558),
    [sym_fsi_directive_decl] = STATE(1558),
    [sym_preproc_line] = STATE(1558),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_module] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_open] = ACTIONS(3859),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_type] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3861),
    [anon_sym_POUNDload] = ACTIONS(3861),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
    [sym__dedent] = ACTIONS(3861),
  },
  [1559] = {
    [sym_xml_doc] = STATE(1559),
    [sym_block_comment] = STATE(1559),
    [sym_line_comment] = STATE(1559),
    [sym_compiler_directive_decl] = STATE(1559),
    [sym_fsi_directive_decl] = STATE(1559),
    [sym_preproc_line] = STATE(1559),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_AT_GT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1560] = {
    [sym_xml_doc] = STATE(1560),
    [sym_block_comment] = STATE(1560),
    [sym_line_comment] = STATE(1560),
    [sym_compiler_directive_decl] = STATE(1560),
    [sym_fsi_directive_decl] = STATE(1560),
    [sym_preproc_line] = STATE(1560),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_AT_AT_GT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1561] = {
    [sym_xml_doc] = STATE(1561),
    [sym_block_comment] = STATE(1561),
    [sym_line_comment] = STATE(1561),
    [sym_compiler_directive_decl] = STATE(1561),
    [sym_fsi_directive_decl] = STATE(1561),
    [sym_preproc_line] = STATE(1561),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_module] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_open] = ACTIONS(3746),
    [anon_sym_LBRACK_LT] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_type] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3748),
    [anon_sym_POUNDload] = ACTIONS(3748),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
    [sym__dedent] = ACTIONS(3748),
  },
  [1562] = {
    [sym_xml_doc] = STATE(1562),
    [sym_block_comment] = STATE(1562),
    [sym_line_comment] = STATE(1562),
    [sym_compiler_directive_decl] = STATE(1562),
    [sym_fsi_directive_decl] = STATE(1562),
    [sym_preproc_line] = STATE(1562),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_open] = ACTIONS(3718),
    [anon_sym_LBRACK_LT] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_type] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3720),
    [anon_sym_POUNDload] = ACTIONS(3720),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
    [sym__dedent] = ACTIONS(3720),
  },
  [1563] = {
    [sym_xml_doc] = STATE(1563),
    [sym_block_comment] = STATE(1563),
    [sym_line_comment] = STATE(1563),
    [sym_compiler_directive_decl] = STATE(1563),
    [sym_fsi_directive_decl] = STATE(1563),
    [sym_preproc_line] = STATE(1563),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_module] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_open] = ACTIONS(3766),
    [anon_sym_LBRACK_LT] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_type] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3768),
    [anon_sym_POUNDload] = ACTIONS(3768),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
    [sym__dedent] = ACTIONS(3768),
  },
  [1564] = {
    [sym_xml_doc] = STATE(1564),
    [sym_block_comment] = STATE(1564),
    [sym_line_comment] = STATE(1564),
    [sym_compiler_directive_decl] = STATE(1564),
    [sym_fsi_directive_decl] = STATE(1564),
    [sym_preproc_line] = STATE(1564),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_module] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_open] = ACTIONS(3770),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_type] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3772),
    [anon_sym_POUNDload] = ACTIONS(3772),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
    [sym__dedent] = ACTIONS(3772),
  },
  [1565] = {
    [sym_xml_doc] = STATE(1565),
    [sym_block_comment] = STATE(1565),
    [sym_line_comment] = STATE(1565),
    [sym_compiler_directive_decl] = STATE(1565),
    [sym_fsi_directive_decl] = STATE(1565),
    [sym_preproc_line] = STATE(1565),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_module] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_open] = ACTIONS(3742),
    [anon_sym_LBRACK_LT] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_type] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3744),
    [anon_sym_POUNDload] = ACTIONS(3744),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
    [sym__dedent] = ACTIONS(3744),
  },
  [1566] = {
    [sym_xml_doc] = STATE(1566),
    [sym_block_comment] = STATE(1566),
    [sym_line_comment] = STATE(1566),
    [sym_compiler_directive_decl] = STATE(1566),
    [sym_fsi_directive_decl] = STATE(1566),
    [sym_preproc_line] = STATE(1566),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_open] = ACTIONS(3577),
    [anon_sym_LBRACK_LT] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3579),
    [anon_sym_POUNDload] = ACTIONS(3579),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
    [sym__dedent] = ACTIONS(3579),
  },
  [1567] = {
    [sym_xml_doc] = STATE(1567),
    [sym_block_comment] = STATE(1567),
    [sym_line_comment] = STATE(1567),
    [sym_compiler_directive_decl] = STATE(1567),
    [sym_fsi_directive_decl] = STATE(1567),
    [sym_preproc_line] = STATE(1567),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_AT_AT_GT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1568] = {
    [sym_xml_doc] = STATE(1568),
    [sym_block_comment] = STATE(1568),
    [sym_line_comment] = STATE(1568),
    [sym_compiler_directive_decl] = STATE(1568),
    [sym_fsi_directive_decl] = STATE(1568),
    [sym_preproc_line] = STATE(1568),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_module] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_open] = ACTIONS(3697),
    [anon_sym_LBRACK_LT] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_type] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3699),
    [anon_sym_POUNDload] = ACTIONS(3699),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
    [sym__dedent] = ACTIONS(3699),
  },
  [1569] = {
    [sym_xml_doc] = STATE(1569),
    [sym_block_comment] = STATE(1569),
    [sym_line_comment] = STATE(1569),
    [sym_compiler_directive_decl] = STATE(1569),
    [sym_fsi_directive_decl] = STATE(1569),
    [sym_preproc_line] = STATE(1569),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_as] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_with] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
  },
  [1570] = {
    [sym_xml_doc] = STATE(1570),
    [sym_block_comment] = STATE(1570),
    [sym_line_comment] = STATE(1570),
    [sym_compiler_directive_decl] = STATE(1570),
    [sym_fsi_directive_decl] = STATE(1570),
    [sym_preproc_line] = STATE(1570),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_module] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_open] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_type] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3780),
    [anon_sym_POUNDload] = ACTIONS(3780),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
    [sym__dedent] = ACTIONS(3780),
  },
  [1571] = {
    [sym_xml_doc] = STATE(1571),
    [sym_block_comment] = STATE(1571),
    [sym_line_comment] = STATE(1571),
    [sym_compiler_directive_decl] = STATE(1571),
    [sym_fsi_directive_decl] = STATE(1571),
    [sym_preproc_line] = STATE(1571),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_module] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_open] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_type] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3691),
    [anon_sym_POUNDload] = ACTIONS(3691),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
    [sym__dedent] = ACTIONS(3691),
  },
  [1572] = {
    [sym_xml_doc] = STATE(1572),
    [sym_block_comment] = STATE(1572),
    [sym_line_comment] = STATE(1572),
    [sym_compiler_directive_decl] = STATE(1572),
    [sym_fsi_directive_decl] = STATE(1572),
    [sym_preproc_line] = STATE(1572),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_AT_AT_GT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1573] = {
    [sym_xml_doc] = STATE(1573),
    [sym_block_comment] = STATE(1573),
    [sym_line_comment] = STATE(1573),
    [sym_compiler_directive_decl] = STATE(1573),
    [sym_fsi_directive_decl] = STATE(1573),
    [sym_preproc_line] = STATE(1573),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1574] = {
    [sym_xml_doc] = STATE(1574),
    [sym_block_comment] = STATE(1574),
    [sym_line_comment] = STATE(1574),
    [sym_compiler_directive_decl] = STATE(1574),
    [sym_fsi_directive_decl] = STATE(1574),
    [sym_preproc_line] = STATE(1574),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_AT_GT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1575] = {
    [sym_xml_doc] = STATE(1575),
    [sym_block_comment] = STATE(1575),
    [sym_line_comment] = STATE(1575),
    [sym_compiler_directive_decl] = STATE(1575),
    [sym_fsi_directive_decl] = STATE(1575),
    [sym_preproc_line] = STATE(1575),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_module] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_open] = ACTIONS(3679),
    [anon_sym_LBRACK_LT] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_type] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3546),
    [anon_sym_POUNDload] = ACTIONS(3546),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
    [sym__dedent] = ACTIONS(3546),
  },
  [1576] = {
    [sym_xml_doc] = STATE(1576),
    [sym_block_comment] = STATE(1576),
    [sym_line_comment] = STATE(1576),
    [sym_compiler_directive_decl] = STATE(1576),
    [sym_fsi_directive_decl] = STATE(1576),
    [sym_preproc_line] = STATE(1576),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_module] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_open] = ACTIONS(3782),
    [anon_sym_LBRACK_LT] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_type] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3784),
    [anon_sym_POUNDload] = ACTIONS(3784),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
    [sym__dedent] = ACTIONS(3784),
  },
  [1577] = {
    [sym_xml_doc] = STATE(1577),
    [sym_block_comment] = STATE(1577),
    [sym_line_comment] = STATE(1577),
    [sym_compiler_directive_decl] = STATE(1577),
    [sym_fsi_directive_decl] = STATE(1577),
    [sym_preproc_line] = STATE(1577),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_module] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_open] = ACTIONS(3814),
    [anon_sym_LBRACK_LT] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_type] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3816),
    [anon_sym_POUNDload] = ACTIONS(3816),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
    [sym__dedent] = ACTIONS(3816),
  },
  [1578] = {
    [sym_xml_doc] = STATE(1578),
    [sym_block_comment] = STATE(1578),
    [sym_line_comment] = STATE(1578),
    [sym_compiler_directive_decl] = STATE(1578),
    [sym_fsi_directive_decl] = STATE(1578),
    [sym_preproc_line] = STATE(1578),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_AT_GT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1579] = {
    [sym_xml_doc] = STATE(1579),
    [sym_block_comment] = STATE(1579),
    [sym_line_comment] = STATE(1579),
    [sym_compiler_directive_decl] = STATE(1579),
    [sym_fsi_directive_decl] = STATE(1579),
    [sym_preproc_line] = STATE(1579),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1580] = {
    [sym_xml_doc] = STATE(1580),
    [sym_block_comment] = STATE(1580),
    [sym_line_comment] = STATE(1580),
    [sym_compiler_directive_decl] = STATE(1580),
    [sym_fsi_directive_decl] = STATE(1580),
    [sym_preproc_line] = STATE(1580),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3438),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1581] = {
    [sym_xml_doc] = STATE(1581),
    [sym_block_comment] = STATE(1581),
    [sym_line_comment] = STATE(1581),
    [sym_compiler_directive_decl] = STATE(1581),
    [sym_fsi_directive_decl] = STATE(1581),
    [sym_preproc_line] = STATE(1581),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_DOT_DOT2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4291),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
    [sym__dedent] = ACTIONS(3419),
  },
  [1582] = {
    [sym_xml_doc] = STATE(1582),
    [sym_block_comment] = STATE(1582),
    [sym_line_comment] = STATE(1582),
    [sym_compiler_directive_decl] = STATE(1582),
    [sym_fsi_directive_decl] = STATE(1582),
    [sym_preproc_line] = STATE(1582),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_AT_AT_GT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1583] = {
    [sym_xml_doc] = STATE(1583),
    [sym_block_comment] = STATE(1583),
    [sym_line_comment] = STATE(1583),
    [sym_compiler_directive_decl] = STATE(1583),
    [sym_fsi_directive_decl] = STATE(1583),
    [sym_preproc_line] = STATE(1583),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_AT_AT_GT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1584] = {
    [sym_xml_doc] = STATE(1584),
    [sym_block_comment] = STATE(1584),
    [sym_line_comment] = STATE(1584),
    [sym_compiler_directive_decl] = STATE(1584),
    [sym_fsi_directive_decl] = STATE(1584),
    [sym_preproc_line] = STATE(1584),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_module] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_open] = ACTIONS(3818),
    [anon_sym_LBRACK_LT] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_type] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3820),
    [anon_sym_POUNDload] = ACTIONS(3820),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
    [sym__dedent] = ACTIONS(3820),
  },
  [1585] = {
    [sym_xml_doc] = STATE(1585),
    [sym_block_comment] = STATE(1585),
    [sym_line_comment] = STATE(1585),
    [sym_compiler_directive_decl] = STATE(1585),
    [sym_fsi_directive_decl] = STATE(1585),
    [sym_preproc_line] = STATE(1585),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_as] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
    [sym__dedent] = ACTIONS(3457),
  },
  [1586] = {
    [sym_xml_doc] = STATE(1586),
    [sym_block_comment] = STATE(1586),
    [sym_line_comment] = STATE(1586),
    [sym_compiler_directive_decl] = STATE(1586),
    [sym_fsi_directive_decl] = STATE(1586),
    [sym_preproc_line] = STATE(1586),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_COLON] = ACTIONS(3310),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_AT_GT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_COLON_GT] = ACTIONS(3310),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3310),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_LT_DASH] = ACTIONS(3308),
    [anon_sym_DOT_LBRACK] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3308),
    [anon_sym_DASH_DOT] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3308),
    [aux_sym_infix_op_token1] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3308),
    [anon_sym_BANG_EQ] = ACTIONS(3308),
    [anon_sym_COLON_EQ] = ACTIONS(3310),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3308),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [1587] = {
    [sym_xml_doc] = STATE(1587),
    [sym_block_comment] = STATE(1587),
    [sym_line_comment] = STATE(1587),
    [sym_compiler_directive_decl] = STATE(1587),
    [sym_fsi_directive_decl] = STATE(1587),
    [sym_preproc_line] = STATE(1587),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_AT_GT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1588] = {
    [sym_xml_doc] = STATE(1588),
    [sym_block_comment] = STATE(1588),
    [sym_line_comment] = STATE(1588),
    [sym_compiler_directive_decl] = STATE(1588),
    [sym_fsi_directive_decl] = STATE(1588),
    [sym_preproc_line] = STATE(1588),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_module] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_open] = ACTIONS(3786),
    [anon_sym_LBRACK_LT] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_type] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3788),
    [anon_sym_POUNDload] = ACTIONS(3788),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
    [sym__dedent] = ACTIONS(3788),
  },
  [1589] = {
    [sym_elif_expression] = STATE(1811),
    [sym_xml_doc] = STATE(1589),
    [sym_block_comment] = STATE(1589),
    [sym_line_comment] = STATE(1589),
    [sym_compiler_directive_decl] = STATE(1589),
    [sym_fsi_directive_decl] = STATE(1589),
    [sym_preproc_line] = STATE(1589),
    [aux_sym_if_expression_repeat1] = STATE(1589),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_AT_GT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4293),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1590] = {
    [sym_xml_doc] = STATE(1590),
    [sym_block_comment] = STATE(1590),
    [sym_line_comment] = STATE(1590),
    [sym_compiler_directive_decl] = STATE(1590),
    [sym_fsi_directive_decl] = STATE(1590),
    [sym_preproc_line] = STATE(1590),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_module] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_open] = ACTIONS(3790),
    [anon_sym_LBRACK_LT] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_type] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3792),
    [anon_sym_POUNDload] = ACTIONS(3792),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
    [sym__dedent] = ACTIONS(3792),
  },
  [1591] = {
    [sym_xml_doc] = STATE(1591),
    [sym_block_comment] = STATE(1591),
    [sym_line_comment] = STATE(1591),
    [sym_compiler_directive_decl] = STATE(1591),
    [sym_fsi_directive_decl] = STATE(1591),
    [sym_preproc_line] = STATE(1591),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_open] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_type] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3800),
    [anon_sym_POUNDload] = ACTIONS(3800),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
    [sym__dedent] = ACTIONS(3800),
  },
  [1592] = {
    [sym_xml_doc] = STATE(1592),
    [sym_block_comment] = STATE(1592),
    [sym_line_comment] = STATE(1592),
    [sym_compiler_directive_decl] = STATE(1592),
    [sym_fsi_directive_decl] = STATE(1592),
    [sym_preproc_line] = STATE(1592),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_module] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_open] = ACTIONS(3802),
    [anon_sym_LBRACK_LT] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_type] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3804),
    [anon_sym_POUNDload] = ACTIONS(3804),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
    [sym__dedent] = ACTIONS(3804),
  },
  [1593] = {
    [sym_xml_doc] = STATE(1593),
    [sym_block_comment] = STATE(1593),
    [sym_line_comment] = STATE(1593),
    [sym_compiler_directive_decl] = STATE(1593),
    [sym_fsi_directive_decl] = STATE(1593),
    [sym_preproc_line] = STATE(1593),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3322),
    [anon_sym_AT_AT_GT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_COLON_GT] = ACTIONS(3324),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_LT_DASH] = ACTIONS(3322),
    [anon_sym_DOT_LBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_LPAREN2] = ACTIONS(3324),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3322),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3322),
    [anon_sym_DASH_DOT] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3322),
    [aux_sym_infix_op_token1] = ACTIONS(3322),
    [anon_sym_PIPE_PIPE] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_COLON_EQ] = ACTIONS(3324),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3322),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [1594] = {
    [sym_xml_doc] = STATE(1594),
    [sym_block_comment] = STATE(1594),
    [sym_line_comment] = STATE(1594),
    [sym_compiler_directive_decl] = STATE(1594),
    [sym_fsi_directive_decl] = STATE(1594),
    [sym_preproc_line] = STATE(1594),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4296),
  },
  [1595] = {
    [sym_xml_doc] = STATE(1595),
    [sym_block_comment] = STATE(1595),
    [sym_line_comment] = STATE(1595),
    [sym_compiler_directive_decl] = STATE(1595),
    [sym_fsi_directive_decl] = STATE(1595),
    [sym_preproc_line] = STATE(1595),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1596] = {
    [sym_xml_doc] = STATE(1596),
    [sym_block_comment] = STATE(1596),
    [sym_line_comment] = STATE(1596),
    [sym_compiler_directive_decl] = STATE(1596),
    [sym_fsi_directive_decl] = STATE(1596),
    [sym_preproc_line] = STATE(1596),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_open] = ACTIONS(3598),
    [anon_sym_LBRACK_LT] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_type] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3600),
    [anon_sym_POUNDload] = ACTIONS(3600),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
    [sym__dedent] = ACTIONS(3600),
  },
  [1597] = {
    [sym_xml_doc] = STATE(1597),
    [sym_block_comment] = STATE(1597),
    [sym_line_comment] = STATE(1597),
    [sym_compiler_directive_decl] = STATE(1597),
    [sym_fsi_directive_decl] = STATE(1597),
    [sym_preproc_line] = STATE(1597),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [anon_sym_POUNDendif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [1598] = {
    [sym_xml_doc] = STATE(1598),
    [sym_block_comment] = STATE(1598),
    [sym_line_comment] = STATE(1598),
    [sym_compiler_directive_decl] = STATE(1598),
    [sym_fsi_directive_decl] = STATE(1598),
    [sym_preproc_line] = STATE(1598),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3298),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_COLON] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3298),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3296),
    [anon_sym_DOT_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3296),
    [anon_sym_COLON_EQ] = ACTIONS(3298),
    [anon_sym_DOLLAR] = ACTIONS(3296),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3296),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [anon_sym_POUNDendif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [1599] = {
    [sym_xml_doc] = STATE(1599),
    [sym_block_comment] = STATE(1599),
    [sym_line_comment] = STATE(1599),
    [sym_compiler_directive_decl] = STATE(1599),
    [sym_fsi_directive_decl] = STATE(1599),
    [sym_preproc_line] = STATE(1599),
    [aux_sym_rules_repeat1] = STATE(1620),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(3404),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_with] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4302),
    [sym__dedent] = ACTIONS(3406),
  },
  [1600] = {
    [sym_xml_doc] = STATE(1600),
    [sym_block_comment] = STATE(1600),
    [sym_line_comment] = STATE(1600),
    [sym_compiler_directive_decl] = STATE(1600),
    [sym_fsi_directive_decl] = STATE(1600),
    [sym_preproc_line] = STATE(1600),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4305),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1601] = {
    [sym_xml_doc] = STATE(1601),
    [sym_block_comment] = STATE(1601),
    [sym_line_comment] = STATE(1601),
    [sym_compiler_directive_decl] = STATE(1601),
    [sym_fsi_directive_decl] = STATE(1601),
    [sym_preproc_line] = STATE(1601),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_AT_GT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1602] = {
    [sym_xml_doc] = STATE(1602),
    [sym_block_comment] = STATE(1602),
    [sym_line_comment] = STATE(1602),
    [sym_compiler_directive_decl] = STATE(1602),
    [sym_fsi_directive_decl] = STATE(1602),
    [sym_preproc_line] = STATE(1602),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_module] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_open] = ACTIONS(3847),
    [anon_sym_LBRACK_LT] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_type] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3849),
    [anon_sym_POUNDload] = ACTIONS(3849),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
    [sym__dedent] = ACTIONS(3849),
  },
  [1603] = {
    [sym_xml_doc] = STATE(1603),
    [sym_block_comment] = STATE(1603),
    [sym_line_comment] = STATE(1603),
    [sym_compiler_directive_decl] = STATE(1603),
    [sym_fsi_directive_decl] = STATE(1603),
    [sym_preproc_line] = STATE(1603),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4307),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [anon_sym_POUNDendif] = ACTIONS(3389),
    [anon_sym_POUNDelse] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1604] = {
    [sym_xml_doc] = STATE(1604),
    [sym_block_comment] = STATE(1604),
    [sym_line_comment] = STATE(1604),
    [sym_compiler_directive_decl] = STATE(1604),
    [sym_fsi_directive_decl] = STATE(1604),
    [sym_preproc_line] = STATE(1604),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_COLON_GT] = ACTIONS(3306),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_LT_DASH] = ACTIONS(3304),
    [anon_sym_DOT_LBRACK] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_DOT_DOT] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3304),
    [anon_sym_DASH_DOT] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3304),
    [aux_sym_infix_op_token1] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_COLON_EQ] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3304),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3304),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [1605] = {
    [sym_xml_doc] = STATE(1605),
    [sym_block_comment] = STATE(1605),
    [sym_line_comment] = STATE(1605),
    [sym_compiler_directive_decl] = STATE(1605),
    [sym_fsi_directive_decl] = STATE(1605),
    [sym_preproc_line] = STATE(1605),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_module] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_open] = ACTIONS(3620),
    [anon_sym_LBRACK_LT] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_type] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3622),
    [anon_sym_POUNDload] = ACTIONS(3622),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
    [sym__dedent] = ACTIONS(3622),
  },
  [1606] = {
    [sym_xml_doc] = STATE(1606),
    [sym_block_comment] = STATE(1606),
    [sym_line_comment] = STATE(1606),
    [sym_compiler_directive_decl] = STATE(1606),
    [sym_fsi_directive_decl] = STATE(1606),
    [sym_preproc_line] = STATE(1606),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_DOT_DOT] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1607] = {
    [sym_xml_doc] = STATE(1607),
    [sym_block_comment] = STATE(1607),
    [sym_line_comment] = STATE(1607),
    [sym_compiler_directive_decl] = STATE(1607),
    [sym_fsi_directive_decl] = STATE(1607),
    [sym_preproc_line] = STATE(1607),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_DOT_DOT] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1608] = {
    [sym_elif_expression] = STATE(1976),
    [sym_xml_doc] = STATE(1608),
    [sym_block_comment] = STATE(1608),
    [sym_line_comment] = STATE(1608),
    [sym_compiler_directive_decl] = STATE(1608),
    [sym_fsi_directive_decl] = STATE(1608),
    [sym_preproc_line] = STATE(1608),
    [aux_sym_if_expression_repeat1] = STATE(1608),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_AT_AT_GT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4309),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1609] = {
    [sym_xml_doc] = STATE(1609),
    [sym_block_comment] = STATE(1609),
    [sym_line_comment] = STATE(1609),
    [sym_compiler_directive_decl] = STATE(1609),
    [sym_fsi_directive_decl] = STATE(1609),
    [sym_preproc_line] = STATE(1609),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [anon_sym_POUNDendif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1610] = {
    [sym_xml_doc] = STATE(1610),
    [sym_block_comment] = STATE(1610),
    [sym_line_comment] = STATE(1610),
    [sym_compiler_directive_decl] = STATE(1610),
    [sym_fsi_directive_decl] = STATE(1610),
    [sym_preproc_line] = STATE(1610),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_QMARK] = ACTIONS(3336),
    [anon_sym_COLON_COLON] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3336),
    [anon_sym_AT_AT_GT] = ACTIONS(3336),
    [anon_sym_DOT] = ACTIONS(3336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_COLON_GT] = ACTIONS(3338),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_LT_DASH] = ACTIONS(3336),
    [anon_sym_DOT_LBRACK] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_LPAREN2] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3336),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_or] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3336),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3336),
    [anon_sym_DASH_DOT] = ACTIONS(3336),
    [anon_sym_PERCENT] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3336),
    [aux_sym_infix_op_token1] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_COLON_EQ] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3336),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [1611] = {
    [sym_xml_doc] = STATE(1611),
    [sym_block_comment] = STATE(1611),
    [sym_line_comment] = STATE(1611),
    [sym_compiler_directive_decl] = STATE(1611),
    [sym_fsi_directive_decl] = STATE(1611),
    [sym_preproc_line] = STATE(1611),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_module] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_open] = ACTIONS(3863),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_type] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3865),
    [anon_sym_POUNDload] = ACTIONS(3865),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
    [sym__dedent] = ACTIONS(3865),
  },
  [1612] = {
    [sym_xml_doc] = STATE(1612),
    [sym_block_comment] = STATE(1612),
    [sym_line_comment] = STATE(1612),
    [sym_compiler_directive_decl] = STATE(1612),
    [sym_fsi_directive_decl] = STATE(1612),
    [sym_preproc_line] = STATE(1612),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_module] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_open] = ACTIONS(3624),
    [anon_sym_LBRACK_LT] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_type] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3626),
    [anon_sym_POUNDload] = ACTIONS(3626),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
    [sym__dedent] = ACTIONS(3626),
  },
  [1613] = {
    [sym_xml_doc] = STATE(1613),
    [sym_block_comment] = STATE(1613),
    [sym_line_comment] = STATE(1613),
    [sym_compiler_directive_decl] = STATE(1613),
    [sym_fsi_directive_decl] = STATE(1613),
    [sym_preproc_line] = STATE(1613),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_open] = ACTIONS(3638),
    [anon_sym_LBRACK_LT] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_type] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3640),
    [anon_sym_POUNDload] = ACTIONS(3640),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
    [sym__dedent] = ACTIONS(3640),
  },
  [1614] = {
    [sym_xml_doc] = STATE(1614),
    [sym_block_comment] = STATE(1614),
    [sym_line_comment] = STATE(1614),
    [sym_compiler_directive_decl] = STATE(1614),
    [sym_fsi_directive_decl] = STATE(1614),
    [sym_preproc_line] = STATE(1614),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_module] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_open] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_type] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3648),
    [anon_sym_POUNDload] = ACTIONS(3648),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
    [sym__dedent] = ACTIONS(3648),
  },
  [1615] = {
    [sym_xml_doc] = STATE(1615),
    [sym_block_comment] = STATE(1615),
    [sym_line_comment] = STATE(1615),
    [sym_compiler_directive_decl] = STATE(1615),
    [sym_fsi_directive_decl] = STATE(1615),
    [sym_preproc_line] = STATE(1615),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4312),
  },
  [1616] = {
    [sym_xml_doc] = STATE(1616),
    [sym_block_comment] = STATE(1616),
    [sym_line_comment] = STATE(1616),
    [sym_compiler_directive_decl] = STATE(1616),
    [sym_fsi_directive_decl] = STATE(1616),
    [sym_preproc_line] = STATE(1616),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_QMARK] = ACTIONS(3340),
    [anon_sym_COLON_COLON] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3340),
    [anon_sym_AT_AT_GT] = ACTIONS(3340),
    [anon_sym_DOT] = ACTIONS(3340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_COLON_GT] = ACTIONS(3342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_LT_DASH] = ACTIONS(3340),
    [anon_sym_DOT_LBRACK] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3340),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_or] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3340),
    [anon_sym_DASH_DOT] = ACTIONS(3340),
    [anon_sym_PERCENT] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3340),
    [aux_sym_infix_op_token1] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_COLON_EQ] = ACTIONS(3342),
    [anon_sym_DOLLAR] = ACTIONS(3340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3340),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [1617] = {
    [sym_xml_doc] = STATE(1617),
    [sym_block_comment] = STATE(1617),
    [sym_line_comment] = STATE(1617),
    [sym_compiler_directive_decl] = STATE(1617),
    [sym_fsi_directive_decl] = STATE(1617),
    [sym_preproc_line] = STATE(1617),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_AT_GT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1618] = {
    [sym_xml_doc] = STATE(1618),
    [sym_block_comment] = STATE(1618),
    [sym_line_comment] = STATE(1618),
    [sym_compiler_directive_decl] = STATE(1618),
    [sym_fsi_directive_decl] = STATE(1618),
    [sym_preproc_line] = STATE(1618),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_module] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_open] = ACTIONS(3878),
    [anon_sym_LBRACK_LT] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3880),
    [anon_sym_POUNDload] = ACTIONS(3880),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
    [sym__dedent] = ACTIONS(3880),
  },
  [1619] = {
    [sym_xml_doc] = STATE(1619),
    [sym_block_comment] = STATE(1619),
    [sym_line_comment] = STATE(1619),
    [sym_compiler_directive_decl] = STATE(1619),
    [sym_fsi_directive_decl] = STATE(1619),
    [sym_preproc_line] = STATE(1619),
    [aux_sym_rules_repeat1] = STATE(1627),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_as] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4314),
    [sym__dedent] = ACTIONS(3444),
  },
  [1620] = {
    [sym_xml_doc] = STATE(1620),
    [sym_block_comment] = STATE(1620),
    [sym_line_comment] = STATE(1620),
    [sym_compiler_directive_decl] = STATE(1620),
    [sym_fsi_directive_decl] = STATE(1620),
    [sym_preproc_line] = STATE(1620),
    [aux_sym_rules_repeat1] = STATE(1646),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_as] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4314),
    [sym__dedent] = ACTIONS(3444),
  },
  [1621] = {
    [sym_xml_doc] = STATE(1621),
    [sym_block_comment] = STATE(1621),
    [sym_line_comment] = STATE(1621),
    [sym_compiler_directive_decl] = STATE(1621),
    [sym_fsi_directive_decl] = STATE(1621),
    [sym_preproc_line] = STATE(1621),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_module] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_open] = ACTIONS(3675),
    [anon_sym_LBRACK_LT] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_type] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3677),
    [anon_sym_POUNDload] = ACTIONS(3677),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
    [sym__dedent] = ACTIONS(3677),
  },
  [1622] = {
    [sym_xml_doc] = STATE(1622),
    [sym_block_comment] = STATE(1622),
    [sym_line_comment] = STATE(1622),
    [sym_compiler_directive_decl] = STATE(1622),
    [sym_fsi_directive_decl] = STATE(1622),
    [sym_preproc_line] = STATE(1622),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4317),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [anon_sym_POUNDendif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1623] = {
    [sym_xml_doc] = STATE(1623),
    [sym_block_comment] = STATE(1623),
    [sym_line_comment] = STATE(1623),
    [sym_compiler_directive_decl] = STATE(1623),
    [sym_fsi_directive_decl] = STATE(1623),
    [sym_preproc_line] = STATE(1623),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_DOT_DOT2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
    [sym__dedent] = ACTIONS(3389),
  },
  [1624] = {
    [sym_xml_doc] = STATE(1624),
    [sym_block_comment] = STATE(1624),
    [sym_line_comment] = STATE(1624),
    [sym_compiler_directive_decl] = STATE(1624),
    [sym_fsi_directive_decl] = STATE(1624),
    [sym_preproc_line] = STATE(1624),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_module] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_open] = ACTIONS(3712),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3714),
    [anon_sym_POUNDload] = ACTIONS(3714),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
    [sym__dedent] = ACTIONS(3714),
  },
  [1625] = {
    [sym_xml_doc] = STATE(1625),
    [sym_block_comment] = STATE(1625),
    [sym_line_comment] = STATE(1625),
    [sym_compiler_directive_decl] = STATE(1625),
    [sym_fsi_directive_decl] = STATE(1625),
    [sym_preproc_line] = STATE(1625),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1626] = {
    [sym_xml_doc] = STATE(1626),
    [sym_block_comment] = STATE(1626),
    [sym_line_comment] = STATE(1626),
    [sym_compiler_directive_decl] = STATE(1626),
    [sym_fsi_directive_decl] = STATE(1626),
    [sym_preproc_line] = STATE(1626),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_module] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_open] = ACTIONS(3825),
    [anon_sym_LBRACK_LT] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_type] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3827),
    [anon_sym_POUNDload] = ACTIONS(3827),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
    [sym__dedent] = ACTIONS(3827),
  },
  [1627] = {
    [sym_xml_doc] = STATE(1627),
    [sym_block_comment] = STATE(1627),
    [sym_line_comment] = STATE(1627),
    [sym_compiler_directive_decl] = STATE(1627),
    [sym_fsi_directive_decl] = STATE(1627),
    [sym_preproc_line] = STATE(1627),
    [aux_sym_rules_repeat1] = STATE(1646),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_as] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4300),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_with] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4319),
    [sym__dedent] = ACTIONS(3465),
  },
  [1628] = {
    [sym_xml_doc] = STATE(1628),
    [sym_block_comment] = STATE(1628),
    [sym_line_comment] = STATE(1628),
    [sym_compiler_directive_decl] = STATE(1628),
    [sym_fsi_directive_decl] = STATE(1628),
    [sym_preproc_line] = STATE(1628),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_module] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_open] = ACTIONS(3762),
    [anon_sym_LBRACK_LT] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_type] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3764),
    [anon_sym_POUNDload] = ACTIONS(3764),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
    [sym__dedent] = ACTIONS(3764),
  },
  [1629] = {
    [sym_xml_doc] = STATE(1629),
    [sym_block_comment] = STATE(1629),
    [sym_line_comment] = STATE(1629),
    [sym_compiler_directive_decl] = STATE(1629),
    [sym_fsi_directive_decl] = STATE(1629),
    [sym_preproc_line] = STATE(1629),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_COLON] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3355),
    [anon_sym_AT_AT_GT] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_COLON_GT] = ACTIONS(3357),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_LT_DASH] = ACTIONS(3355),
    [anon_sym_DOT_LBRACK] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_LPAREN2] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_LT2] = ACTIONS(4322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_or] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3355),
    [anon_sym_DASH_DOT] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3355),
    [aux_sym_infix_op_token1] = ACTIONS(3355),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_BANG_EQ] = ACTIONS(3355),
    [anon_sym_COLON_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3355),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3355),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [1630] = {
    [sym_xml_doc] = STATE(1630),
    [sym_block_comment] = STATE(1630),
    [sym_line_comment] = STATE(1630),
    [sym_compiler_directive_decl] = STATE(1630),
    [sym_fsi_directive_decl] = STATE(1630),
    [sym_preproc_line] = STATE(1630),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_AT_AT_GT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1631] = {
    [sym_xml_doc] = STATE(1631),
    [sym_block_comment] = STATE(1631),
    [sym_line_comment] = STATE(1631),
    [sym_compiler_directive_decl] = STATE(1631),
    [sym_fsi_directive_decl] = STATE(1631),
    [sym_preproc_line] = STATE(1631),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1632] = {
    [sym_xml_doc] = STATE(1632),
    [sym_block_comment] = STATE(1632),
    [sym_line_comment] = STATE(1632),
    [sym_compiler_directive_decl] = STATE(1632),
    [sym_fsi_directive_decl] = STATE(1632),
    [sym_preproc_line] = STATE(1632),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_AT_GT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1633] = {
    [sym_xml_doc] = STATE(1633),
    [sym_block_comment] = STATE(1633),
    [sym_line_comment] = STATE(1633),
    [sym_compiler_directive_decl] = STATE(1633),
    [sym_fsi_directive_decl] = STATE(1633),
    [sym_preproc_line] = STATE(1633),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_AT_AT_GT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1634] = {
    [sym_xml_doc] = STATE(1634),
    [sym_block_comment] = STATE(1634),
    [sym_line_comment] = STATE(1634),
    [sym_compiler_directive_decl] = STATE(1634),
    [sym_fsi_directive_decl] = STATE(1634),
    [sym_preproc_line] = STATE(1634),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_AT_GT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1635] = {
    [sym_xml_doc] = STATE(1635),
    [sym_block_comment] = STATE(1635),
    [sym_line_comment] = STATE(1635),
    [sym_compiler_directive_decl] = STATE(1635),
    [sym_fsi_directive_decl] = STATE(1635),
    [sym_preproc_line] = STATE(1635),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_module] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_open] = ACTIONS(3910),
    [anon_sym_LBRACK_LT] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_type] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3912),
    [anon_sym_POUNDload] = ACTIONS(3912),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
    [sym__dedent] = ACTIONS(3912),
  },
  [1636] = {
    [sym_xml_doc] = STATE(1636),
    [sym_block_comment] = STATE(1636),
    [sym_line_comment] = STATE(1636),
    [sym_compiler_directive_decl] = STATE(1636),
    [sym_fsi_directive_decl] = STATE(1636),
    [sym_preproc_line] = STATE(1636),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_module] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_open] = ACTIONS(3921),
    [anon_sym_LBRACK_LT] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_type] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3923),
    [anon_sym_POUNDload] = ACTIONS(3923),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
    [sym__dedent] = ACTIONS(3923),
  },
  [1637] = {
    [sym_xml_doc] = STATE(1637),
    [sym_block_comment] = STATE(1637),
    [sym_line_comment] = STATE(1637),
    [sym_compiler_directive_decl] = STATE(1637),
    [sym_fsi_directive_decl] = STATE(1637),
    [sym_preproc_line] = STATE(1637),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_module] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_open] = ACTIONS(3836),
    [anon_sym_LBRACK_LT] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_type] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3838),
    [anon_sym_POUNDload] = ACTIONS(3838),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
    [sym__dedent] = ACTIONS(3838),
  },
  [1638] = {
    [sym_xml_doc] = STATE(1638),
    [sym_block_comment] = STATE(1638),
    [sym_line_comment] = STATE(1638),
    [sym_compiler_directive_decl] = STATE(1638),
    [sym_fsi_directive_decl] = STATE(1638),
    [sym_preproc_line] = STATE(1638),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1639] = {
    [sym_xml_doc] = STATE(1639),
    [sym_block_comment] = STATE(1639),
    [sym_line_comment] = STATE(1639),
    [sym_compiler_directive_decl] = STATE(1639),
    [sym_fsi_directive_decl] = STATE(1639),
    [sym_preproc_line] = STATE(1639),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_module] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_open] = ACTIONS(3884),
    [anon_sym_LBRACK_LT] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_type] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3886),
    [anon_sym_POUNDload] = ACTIONS(3886),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
    [sym__dedent] = ACTIONS(3886),
  },
  [1640] = {
    [sym_xml_doc] = STATE(1640),
    [sym_block_comment] = STATE(1640),
    [sym_line_comment] = STATE(1640),
    [sym_compiler_directive_decl] = STATE(1640),
    [sym_fsi_directive_decl] = STATE(1640),
    [sym_preproc_line] = STATE(1640),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_module] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_open] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_type] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3931),
    [anon_sym_POUNDload] = ACTIONS(3931),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
    [sym__dedent] = ACTIONS(3931),
  },
  [1641] = {
    [sym_xml_doc] = STATE(1641),
    [sym_block_comment] = STATE(1641),
    [sym_line_comment] = STATE(1641),
    [sym_compiler_directive_decl] = STATE(1641),
    [sym_fsi_directive_decl] = STATE(1641),
    [sym_preproc_line] = STATE(1641),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_module] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_open] = ACTIONS(3888),
    [anon_sym_LBRACK_LT] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_type] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3890),
    [anon_sym_POUNDload] = ACTIONS(3890),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
    [sym__dedent] = ACTIONS(3890),
  },
  [1642] = {
    [sym_xml_doc] = STATE(1642),
    [sym_block_comment] = STATE(1642),
    [sym_line_comment] = STATE(1642),
    [sym_compiler_directive_decl] = STATE(1642),
    [sym_fsi_directive_decl] = STATE(1642),
    [sym_preproc_line] = STATE(1642),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_module] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_open] = ACTIONS(3895),
    [anon_sym_LBRACK_LT] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_type] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3897),
    [anon_sym_POUNDload] = ACTIONS(3897),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
    [sym__dedent] = ACTIONS(3897),
  },
  [1643] = {
    [sym_xml_doc] = STATE(1643),
    [sym_block_comment] = STATE(1643),
    [sym_line_comment] = STATE(1643),
    [sym_compiler_directive_decl] = STATE(1643),
    [sym_fsi_directive_decl] = STATE(1643),
    [sym_preproc_line] = STATE(1643),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_module] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_open] = ACTIONS(3899),
    [anon_sym_LBRACK_LT] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_type] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3901),
    [anon_sym_POUNDload] = ACTIONS(3901),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
    [sym__dedent] = ACTIONS(3901),
  },
  [1644] = {
    [sym_xml_doc] = STATE(1644),
    [sym_block_comment] = STATE(1644),
    [sym_line_comment] = STATE(1644),
    [sym_compiler_directive_decl] = STATE(1644),
    [sym_fsi_directive_decl] = STATE(1644),
    [sym_preproc_line] = STATE(1644),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_open] = ACTIONS(3314),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3312),
    [anon_sym_POUNDload] = ACTIONS(3312),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(4324),
  },
  [1645] = {
    [sym_xml_doc] = STATE(1645),
    [sym_block_comment] = STATE(1645),
    [sym_line_comment] = STATE(1645),
    [sym_compiler_directive_decl] = STATE(1645),
    [sym_fsi_directive_decl] = STATE(1645),
    [sym_preproc_line] = STATE(1645),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_module] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_open] = ACTIONS(3937),
    [anon_sym_LBRACK_LT] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_type] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3939),
    [anon_sym_POUNDload] = ACTIONS(3939),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
    [sym__dedent] = ACTIONS(3939),
  },
  [1646] = {
    [sym_xml_doc] = STATE(1646),
    [sym_block_comment] = STATE(1646),
    [sym_line_comment] = STATE(1646),
    [sym_compiler_directive_decl] = STATE(1646),
    [sym_fsi_directive_decl] = STATE(1646),
    [sym_preproc_line] = STATE(1646),
    [aux_sym_rules_repeat1] = STATE(1646),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4326),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4329),
    [sym__dedent] = ACTIONS(3485),
  },
  [1647] = {
    [sym_xml_doc] = STATE(1647),
    [sym_block_comment] = STATE(1647),
    [sym_line_comment] = STATE(1647),
    [sym_compiler_directive_decl] = STATE(1647),
    [sym_fsi_directive_decl] = STATE(1647),
    [sym_preproc_line] = STATE(1647),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_module] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_open] = ACTIONS(3977),
    [anon_sym_LBRACK_LT] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_type] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3979),
    [anon_sym_POUNDload] = ACTIONS(3979),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
    [sym__dedent] = ACTIONS(3979),
  },
  [1648] = {
    [sym_xml_doc] = STATE(1648),
    [sym_block_comment] = STATE(1648),
    [sym_line_comment] = STATE(1648),
    [sym_compiler_directive_decl] = STATE(1648),
    [sym_fsi_directive_decl] = STATE(1648),
    [sym_preproc_line] = STATE(1648),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_AT_AT_GT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1649] = {
    [sym_xml_doc] = STATE(1649),
    [sym_block_comment] = STATE(1649),
    [sym_line_comment] = STATE(1649),
    [sym_compiler_directive_decl] = STATE(1649),
    [sym_fsi_directive_decl] = STATE(1649),
    [sym_preproc_line] = STATE(1649),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_module] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_open] = ACTIONS(3973),
    [anon_sym_LBRACK_LT] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_type] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3975),
    [anon_sym_POUNDload] = ACTIONS(3975),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
    [sym__dedent] = ACTIONS(3975),
  },
  [1650] = {
    [sym_xml_doc] = STATE(1650),
    [sym_block_comment] = STATE(1650),
    [sym_line_comment] = STATE(1650),
    [sym_compiler_directive_decl] = STATE(1650),
    [sym_fsi_directive_decl] = STATE(1650),
    [sym_preproc_line] = STATE(1650),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_module] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_open] = ACTIONS(3969),
    [anon_sym_LBRACK_LT] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_type] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3971),
    [anon_sym_POUNDload] = ACTIONS(3971),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
    [sym__dedent] = ACTIONS(3971),
  },
  [1651] = {
    [sym_xml_doc] = STATE(1651),
    [sym_block_comment] = STATE(1651),
    [sym_line_comment] = STATE(1651),
    [sym_compiler_directive_decl] = STATE(1651),
    [sym_fsi_directive_decl] = STATE(1651),
    [sym_preproc_line] = STATE(1651),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_EQ] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_QMARK] = ACTIONS(3318),
    [anon_sym_COLON_COLON] = ACTIONS(3320),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_AT_GT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_COLON_GT] = ACTIONS(3320),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_LT_DASH] = ACTIONS(3318),
    [anon_sym_DOT_LBRACK] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3318),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3318),
    [anon_sym_DASH_DOT] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3318),
    [aux_sym_infix_op_token1] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_COLON_EQ] = ACTIONS(3320),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3318),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [1652] = {
    [sym_xml_doc] = STATE(1652),
    [sym_block_comment] = STATE(1652),
    [sym_line_comment] = STATE(1652),
    [sym_compiler_directive_decl] = STATE(1652),
    [sym_fsi_directive_decl] = STATE(1652),
    [sym_preproc_line] = STATE(1652),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_EQ] = ACTIONS(3244),
    [anon_sym_COLON] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_QMARK] = ACTIONS(3242),
    [anon_sym_COLON_COLON] = ACTIONS(3244),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3242),
    [anon_sym_DOT] = ACTIONS(3242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_LT_DASH] = ACTIONS(3242),
    [anon_sym_DOT_LBRACK] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_DOT_DOT] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_LPAREN2] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3242),
    [anon_sym_DASH_DOT] = ACTIONS(3242),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3242),
    [aux_sym_infix_op_token1] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3242),
    [anon_sym_COLON_EQ] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(3242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3242),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [1653] = {
    [sym_xml_doc] = STATE(1653),
    [sym_block_comment] = STATE(1653),
    [sym_line_comment] = STATE(1653),
    [sym_compiler_directive_decl] = STATE(1653),
    [sym_fsi_directive_decl] = STATE(1653),
    [sym_preproc_line] = STATE(1653),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_module] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_open] = ACTIONS(3965),
    [anon_sym_LBRACK_LT] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_type] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3967),
    [anon_sym_POUNDload] = ACTIONS(3967),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
    [sym__dedent] = ACTIONS(3967),
  },
  [1654] = {
    [sym_xml_doc] = STATE(1654),
    [sym_block_comment] = STATE(1654),
    [sym_line_comment] = STATE(1654),
    [sym_compiler_directive_decl] = STATE(1654),
    [sym_fsi_directive_decl] = STATE(1654),
    [sym_preproc_line] = STATE(1654),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_module] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_open] = ACTIONS(3961),
    [anon_sym_LBRACK_LT] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_type] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3963),
    [anon_sym_POUNDload] = ACTIONS(3963),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
    [sym__dedent] = ACTIONS(3963),
  },
  [1655] = {
    [sym_xml_doc] = STATE(1655),
    [sym_block_comment] = STATE(1655),
    [sym_line_comment] = STATE(1655),
    [sym_compiler_directive_decl] = STATE(1655),
    [sym_fsi_directive_decl] = STATE(1655),
    [sym_preproc_line] = STATE(1655),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_QMARK] = ACTIONS(3292),
    [anon_sym_COLON_COLON] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_AT_GT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_COLON_GT] = ACTIONS(3294),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_LT_DASH] = ACTIONS(3292),
    [anon_sym_DOT_LBRACK] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_or] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3292),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3292),
    [anon_sym_DASH_DOT] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3292),
    [aux_sym_infix_op_token1] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_COLON_EQ] = ACTIONS(3294),
    [anon_sym_DOLLAR] = ACTIONS(3292),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3292),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [1656] = {
    [sym_xml_doc] = STATE(1656),
    [sym_block_comment] = STATE(1656),
    [sym_line_comment] = STATE(1656),
    [sym_compiler_directive_decl] = STATE(1656),
    [sym_fsi_directive_decl] = STATE(1656),
    [sym_preproc_line] = STATE(1656),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3438),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1657] = {
    [sym_xml_doc] = STATE(1657),
    [sym_block_comment] = STATE(1657),
    [sym_line_comment] = STATE(1657),
    [sym_compiler_directive_decl] = STATE(1657),
    [sym_fsi_directive_decl] = STATE(1657),
    [sym_preproc_line] = STATE(1657),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_module] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_open] = ACTIONS(3957),
    [anon_sym_LBRACK_LT] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_type] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3959),
    [anon_sym_POUNDload] = ACTIONS(3959),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
    [sym__dedent] = ACTIONS(3959),
  },
  [1658] = {
    [sym_xml_doc] = STATE(1658),
    [sym_block_comment] = STATE(1658),
    [sym_line_comment] = STATE(1658),
    [sym_compiler_directive_decl] = STATE(1658),
    [sym_fsi_directive_decl] = STATE(1658),
    [sym_preproc_line] = STATE(1658),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_module] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_open] = ACTIONS(3953),
    [anon_sym_LBRACK_LT] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_type] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3955),
    [anon_sym_POUNDload] = ACTIONS(3955),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
    [sym__dedent] = ACTIONS(3955),
  },
  [1659] = {
    [sym_xml_doc] = STATE(1659),
    [sym_block_comment] = STATE(1659),
    [sym_line_comment] = STATE(1659),
    [sym_compiler_directive_decl] = STATE(1659),
    [sym_fsi_directive_decl] = STATE(1659),
    [sym_preproc_line] = STATE(1659),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_module] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_open] = ACTIONS(3949),
    [anon_sym_LBRACK_LT] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_type] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3951),
    [anon_sym_POUNDload] = ACTIONS(3951),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
    [sym__dedent] = ACTIONS(3951),
  },
  [1660] = {
    [sym_xml_doc] = STATE(1660),
    [sym_block_comment] = STATE(1660),
    [sym_line_comment] = STATE(1660),
    [sym_compiler_directive_decl] = STATE(1660),
    [sym_fsi_directive_decl] = STATE(1660),
    [sym_preproc_line] = STATE(1660),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_module] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_open] = ACTIONS(3945),
    [anon_sym_LBRACK_LT] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_type] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3947),
    [anon_sym_POUNDload] = ACTIONS(3947),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
    [sym__dedent] = ACTIONS(3947),
  },
  [1661] = {
    [sym_xml_doc] = STATE(1661),
    [sym_block_comment] = STATE(1661),
    [sym_line_comment] = STATE(1661),
    [sym_compiler_directive_decl] = STATE(1661),
    [sym_fsi_directive_decl] = STATE(1661),
    [sym_preproc_line] = STATE(1661),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_open] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2770),
    [anon_sym_POUNDload] = ACTIONS(2770),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [1662] = {
    [sym_xml_doc] = STATE(1662),
    [sym_block_comment] = STATE(1662),
    [sym_line_comment] = STATE(1662),
    [sym_compiler_directive_decl] = STATE(1662),
    [sym_fsi_directive_decl] = STATE(1662),
    [sym_preproc_line] = STATE(1662),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_module] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_open] = ACTIONS(3941),
    [anon_sym_LBRACK_LT] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_type] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3943),
    [anon_sym_POUNDload] = ACTIONS(3943),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
    [sym__dedent] = ACTIONS(3943),
  },
  [1663] = {
    [sym_xml_doc] = STATE(1663),
    [sym_block_comment] = STATE(1663),
    [sym_line_comment] = STATE(1663),
    [sym_compiler_directive_decl] = STATE(1663),
    [sym_fsi_directive_decl] = STATE(1663),
    [sym_preproc_line] = STATE(1663),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_module] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_open] = ACTIONS(3642),
    [anon_sym_LBRACK_LT] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_type] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3644),
    [anon_sym_POUNDload] = ACTIONS(3644),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
    [sym__dedent] = ACTIONS(3644),
  },
  [1664] = {
    [sym_xml_doc] = STATE(1664),
    [sym_block_comment] = STATE(1664),
    [sym_line_comment] = STATE(1664),
    [sym_compiler_directive_decl] = STATE(1664),
    [sym_fsi_directive_decl] = STATE(1664),
    [sym_preproc_line] = STATE(1664),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_EQ] = ACTIONS(3353),
    [anon_sym_COLON] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_QMARK] = ACTIONS(3351),
    [anon_sym_COLON_COLON] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_AT_GT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(3353),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_LT_DASH] = ACTIONS(3351),
    [anon_sym_DOT_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_LPAREN2] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_or] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3351),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3351),
    [anon_sym_DASH_DOT] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3351),
    [aux_sym_infix_op_token1] = ACTIONS(3351),
    [anon_sym_PIPE_PIPE] = ACTIONS(3351),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_COLON_EQ] = ACTIONS(3353),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3351),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [1665] = {
    [sym_xml_doc] = STATE(1665),
    [sym_block_comment] = STATE(1665),
    [sym_line_comment] = STATE(1665),
    [sym_compiler_directive_decl] = STATE(1665),
    [sym_fsi_directive_decl] = STATE(1665),
    [sym_preproc_line] = STATE(1665),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_DOT_DOT2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
    [sym__dedent] = ACTIONS(3453),
  },
  [1666] = {
    [sym_xml_doc] = STATE(1666),
    [sym_block_comment] = STATE(1666),
    [sym_line_comment] = STATE(1666),
    [sym_compiler_directive_decl] = STATE(1666),
    [sym_fsi_directive_decl] = STATE(1666),
    [sym_preproc_line] = STATE(1666),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_module] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_open] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_type] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3935),
    [anon_sym_POUNDload] = ACTIONS(3935),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
    [sym__dedent] = ACTIONS(3935),
  },
  [1667] = {
    [sym_xml_doc] = STATE(1667),
    [sym_block_comment] = STATE(1667),
    [sym_line_comment] = STATE(1667),
    [sym_compiler_directive_decl] = STATE(1667),
    [sym_fsi_directive_decl] = STATE(1667),
    [sym_preproc_line] = STATE(1667),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_module] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_open] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_type] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3927),
    [anon_sym_POUNDload] = ACTIONS(3927),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
    [sym__dedent] = ACTIONS(3927),
  },
  [1668] = {
    [sym_xml_doc] = STATE(1668),
    [sym_block_comment] = STATE(1668),
    [sym_line_comment] = STATE(1668),
    [sym_compiler_directive_decl] = STATE(1668),
    [sym_fsi_directive_decl] = STATE(1668),
    [sym_preproc_line] = STATE(1668),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_module] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_open] = ACTIONS(3914),
    [anon_sym_LBRACK_LT] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_type] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3916),
    [anon_sym_POUNDload] = ACTIONS(3916),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
    [sym__dedent] = ACTIONS(3916),
  },
  [1669] = {
    [sym_xml_doc] = STATE(1669),
    [sym_block_comment] = STATE(1669),
    [sym_line_comment] = STATE(1669),
    [sym_compiler_directive_decl] = STATE(1669),
    [sym_fsi_directive_decl] = STATE(1669),
    [sym_preproc_line] = STATE(1669),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_module] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_open] = ACTIONS(3906),
    [anon_sym_LBRACK_LT] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_type] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3908),
    [anon_sym_POUNDload] = ACTIONS(3908),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
    [sym__dedent] = ACTIONS(3908),
  },
  [1670] = {
    [sym_xml_doc] = STATE(1670),
    [sym_block_comment] = STATE(1670),
    [sym_line_comment] = STATE(1670),
    [sym_compiler_directive_decl] = STATE(1670),
    [sym_fsi_directive_decl] = STATE(1670),
    [sym_preproc_line] = STATE(1670),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_LT_DASH] = ACTIONS(3361),
    [anon_sym_DOT_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_DOT_DOT] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_LPAREN2] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3361),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3361),
    [anon_sym_DASH_DOT] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3361),
    [aux_sym_infix_op_token1] = ACTIONS(3361),
    [anon_sym_PIPE_PIPE] = ACTIONS(3361),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_COLON_EQ] = ACTIONS(3363),
    [anon_sym_DOLLAR] = ACTIONS(3361),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3361),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [1671] = {
    [sym_elif_expression] = STATE(1754),
    [sym_xml_doc] = STATE(1671),
    [sym_block_comment] = STATE(1671),
    [sym_line_comment] = STATE(1671),
    [sym_compiler_directive_decl] = STATE(1671),
    [sym_fsi_directive_decl] = STATE(1671),
    [sym_preproc_line] = STATE(1671),
    [aux_sym_if_expression_repeat1] = STATE(1671),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_let_BANG] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_null] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_QMARK] = ACTIONS(3344),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_AMP] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_LT_AT] = ACTIONS(3344),
    [anon_sym_LT_AT_AT] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_return_BANG] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_yield_BANG] = ACTIONS(3346),
    [anon_sym_lazy] = ACTIONS(3344),
    [anon_sym_assert] = ACTIONS(3344),
    [anon_sym_upcast] = ACTIONS(3344),
    [anon_sym_downcast] = ACTIONS(3344),
    [anon_sym_COLON_GT] = ACTIONS(3346),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_elif] = ACTIONS(4332),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_fun] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_match] = ACTIONS(3344),
    [anon_sym_match_BANG] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_LT_DASH] = ACTIONS(3344),
    [anon_sym_DOT_LBRACK] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_use] = ACTIONS(3344),
    [anon_sym_use_BANG] = ACTIONS(3346),
    [anon_sym_do_BANG] = ACTIONS(3346),
    [anon_sym_DOT_DOT] = ACTIONS(3346),
    [anon_sym_begin] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3344),
    [aux_sym_char_token1] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_AT_DQUOTE] = ACTIONS(3346),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3346),
    [sym_bool] = ACTIONS(3344),
    [sym_unit] = ACTIONS(3344),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3344),
    [sym_op_identifier] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_PLUS_DOT] = ACTIONS(3344),
    [anon_sym_DASH_DOT] = ACTIONS(3344),
    [anon_sym_PERCENT] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3346),
    [aux_sym_prefix_op_token1] = ACTIONS(3344),
    [aux_sym_infix_op_token1] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(3344),
    [anon_sym_COLON_EQ] = ACTIONS(3346),
    [anon_sym_DOLLAR] = ACTIONS(3344),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3344),
    [sym_int] = ACTIONS(3344),
    [sym_xint] = ACTIONS(3346),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3346),
    [sym__newline] = ACTIONS(3346),
  },
  [1672] = {
    [sym_xml_doc] = STATE(1672),
    [sym_block_comment] = STATE(1672),
    [sym_line_comment] = STATE(1672),
    [sym_compiler_directive_decl] = STATE(1672),
    [sym_fsi_directive_decl] = STATE(1672),
    [sym_preproc_line] = STATE(1672),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_module] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_open] = ACTIONS(3794),
    [anon_sym_LBRACK_LT] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_type] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3796),
    [anon_sym_POUNDload] = ACTIONS(3796),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
    [sym__dedent] = ACTIONS(3796),
  },
  [1673] = {
    [sym_xml_doc] = STATE(1673),
    [sym_block_comment] = STATE(1673),
    [sym_line_comment] = STATE(1673),
    [sym_compiler_directive_decl] = STATE(1673),
    [sym_fsi_directive_decl] = STATE(1673),
    [sym_preproc_line] = STATE(1673),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_QMARK] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_AT_GT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_COLON_GT] = ACTIONS(3302),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_LT_DASH] = ACTIONS(3300),
    [anon_sym_DOT_LBRACK] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_LPAREN2] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3300),
    [anon_sym_DASH_DOT] = ACTIONS(3300),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3300),
    [aux_sym_infix_op_token1] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_COLON_EQ] = ACTIONS(3302),
    [anon_sym_DOLLAR] = ACTIONS(3300),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3300),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [1674] = {
    [sym_xml_doc] = STATE(1674),
    [sym_block_comment] = STATE(1674),
    [sym_line_comment] = STATE(1674),
    [sym_compiler_directive_decl] = STATE(1674),
    [sym_fsi_directive_decl] = STATE(1674),
    [sym_preproc_line] = STATE(1674),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_module] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_open] = ACTIONS(3840),
    [anon_sym_LBRACK_LT] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_type] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3842),
    [anon_sym_POUNDload] = ACTIONS(3842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
    [sym__dedent] = ACTIONS(3842),
  },
  [1675] = {
    [sym_xml_doc] = STATE(1675),
    [sym_block_comment] = STATE(1675),
    [sym_line_comment] = STATE(1675),
    [sym_compiler_directive_decl] = STATE(1675),
    [sym_fsi_directive_decl] = STATE(1675),
    [sym_preproc_line] = STATE(1675),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_EQ] = ACTIONS(3276),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_COLON] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3274),
    [anon_sym_DOT] = ACTIONS(3274),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_LT_DASH] = ACTIONS(3274),
    [anon_sym_DOT_LBRACK] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_DOT_DOT] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3274),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3274),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3274),
    [anon_sym_DASH_DOT] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3274),
    [aux_sym_infix_op_token1] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3274),
    [anon_sym_COLON_EQ] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(3274),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3274),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [1676] = {
    [sym_xml_doc] = STATE(1676),
    [sym_block_comment] = STATE(1676),
    [sym_line_comment] = STATE(1676),
    [sym_compiler_directive_decl] = STATE(1676),
    [sym_fsi_directive_decl] = STATE(1676),
    [sym_preproc_line] = STATE(1676),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
    [sym__dedent] = ACTIONS(3535),
  },
  [1677] = {
    [sym_xml_doc] = STATE(1677),
    [sym_block_comment] = STATE(1677),
    [sym_line_comment] = STATE(1677),
    [sym_compiler_directive_decl] = STATE(1677),
    [sym_fsi_directive_decl] = STATE(1677),
    [sym_preproc_line] = STATE(1677),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [1678] = {
    [sym_xml_doc] = STATE(1678),
    [sym_block_comment] = STATE(1678),
    [sym_line_comment] = STATE(1678),
    [sym_compiler_directive_decl] = STATE(1678),
    [sym_fsi_directive_decl] = STATE(1678),
    [sym_preproc_line] = STATE(1678),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_DOT_DOT2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1679] = {
    [sym_xml_doc] = STATE(1679),
    [sym_block_comment] = STATE(1679),
    [sym_line_comment] = STATE(1679),
    [sym_compiler_directive_decl] = STATE(1679),
    [sym_fsi_directive_decl] = STATE(1679),
    [sym_preproc_line] = STATE(1679),
    [aux_sym_rules_repeat1] = STATE(1690),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [anon_sym_POUNDendif] = ACTIONS(3465),
    [anon_sym_POUNDelse] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4337),
  },
  [1680] = {
    [sym_xml_doc] = STATE(1680),
    [sym_block_comment] = STATE(1680),
    [sym_line_comment] = STATE(1680),
    [sym_compiler_directive_decl] = STATE(1680),
    [sym_fsi_directive_decl] = STATE(1680),
    [sym_preproc_line] = STATE(1680),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(4247),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3296),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3296),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3296),
    [anon_sym_DASH_DOT] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3296),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3312),
  },
  [1681] = {
    [sym_xml_doc] = STATE(1681),
    [sym_block_comment] = STATE(1681),
    [sym_line_comment] = STATE(1681),
    [sym_compiler_directive_decl] = STATE(1681),
    [sym_fsi_directive_decl] = STATE(1681),
    [sym_preproc_line] = STATE(1681),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [anon_sym_POUNDendif] = ACTIONS(3453),
    [anon_sym_POUNDelse] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1682] = {
    [sym_xml_doc] = STATE(1682),
    [sym_block_comment] = STATE(1682),
    [sym_line_comment] = STATE(1682),
    [sym_compiler_directive_decl] = STATE(1682),
    [sym_fsi_directive_decl] = STATE(1682),
    [sym_preproc_line] = STATE(1682),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_RBRACK] = ACTIONS(3509),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3679),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1683] = {
    [sym_xml_doc] = STATE(1683),
    [sym_block_comment] = STATE(1683),
    [sym_line_comment] = STATE(1683),
    [sym_compiler_directive_decl] = STATE(1683),
    [sym_fsi_directive_decl] = STATE(1683),
    [sym_preproc_line] = STATE(1683),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1684] = {
    [sym_xml_doc] = STATE(1684),
    [sym_block_comment] = STATE(1684),
    [sym_line_comment] = STATE(1684),
    [sym_compiler_directive_decl] = STATE(1684),
    [sym_fsi_directive_decl] = STATE(1684),
    [sym_preproc_line] = STATE(1684),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [anon_sym_POUNDelse] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1685] = {
    [sym_xml_doc] = STATE(1685),
    [sym_block_comment] = STATE(1685),
    [sym_line_comment] = STATE(1685),
    [sym_compiler_directive_decl] = STATE(1685),
    [sym_fsi_directive_decl] = STATE(1685),
    [sym_preproc_line] = STATE(1685),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_as] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1686] = {
    [sym_xml_doc] = STATE(1686),
    [sym_block_comment] = STATE(1686),
    [sym_line_comment] = STATE(1686),
    [sym_compiler_directive_decl] = STATE(1686),
    [sym_fsi_directive_decl] = STATE(1686),
    [sym_preproc_line] = STATE(1686),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_DOT_DOT] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1687] = {
    [sym_xml_doc] = STATE(1687),
    [sym_block_comment] = STATE(1687),
    [sym_line_comment] = STATE(1687),
    [sym_compiler_directive_decl] = STATE(1687),
    [sym_fsi_directive_decl] = STATE(1687),
    [sym_preproc_line] = STATE(1687),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_as] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_with] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
    [sym__dedent] = ACTIONS(3544),
  },
  [1688] = {
    [sym_xml_doc] = STATE(1688),
    [sym_block_comment] = STATE(1688),
    [sym_line_comment] = STATE(1688),
    [sym_compiler_directive_decl] = STATE(1688),
    [sym_fsi_directive_decl] = STATE(1688),
    [sym_preproc_line] = STATE(1688),
    [aux_sym_rules_repeat1] = STATE(1690),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [anon_sym_POUNDendif] = ACTIONS(3444),
    [anon_sym_POUNDelse] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4340),
  },
  [1689] = {
    [sym_xml_doc] = STATE(1689),
    [sym_block_comment] = STATE(1689),
    [sym_line_comment] = STATE(1689),
    [sym_compiler_directive_decl] = STATE(1689),
    [sym_fsi_directive_decl] = STATE(1689),
    [sym_preproc_line] = STATE(1689),
    [aux_sym_rules_repeat1] = STATE(1679),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [anon_sym_POUNDendif] = ACTIONS(3444),
    [anon_sym_POUNDelse] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4340),
  },
  [1690] = {
    [sym_xml_doc] = STATE(1690),
    [sym_block_comment] = STATE(1690),
    [sym_line_comment] = STATE(1690),
    [sym_compiler_directive_decl] = STATE(1690),
    [sym_fsi_directive_decl] = STATE(1690),
    [sym_preproc_line] = STATE(1690),
    [aux_sym_rules_repeat1] = STATE(1690),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4346),
  },
  [1691] = {
    [sym_xml_doc] = STATE(1691),
    [sym_block_comment] = STATE(1691),
    [sym_line_comment] = STATE(1691),
    [sym_compiler_directive_decl] = STATE(1691),
    [sym_fsi_directive_decl] = STATE(1691),
    [sym_preproc_line] = STATE(1691),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4349),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1692] = {
    [sym_xml_doc] = STATE(1692),
    [sym_block_comment] = STATE(1692),
    [sym_line_comment] = STATE(1692),
    [sym_compiler_directive_decl] = STATE(1692),
    [sym_fsi_directive_decl] = STATE(1692),
    [sym_preproc_line] = STATE(1692),
    [aux_sym_rules_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [anon_sym_POUNDendif] = ACTIONS(3406),
    [anon_sym_POUNDelse] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4351),
  },
  [1693] = {
    [sym_xml_doc] = STATE(1693),
    [sym_block_comment] = STATE(1693),
    [sym_line_comment] = STATE(1693),
    [sym_compiler_directive_decl] = STATE(1693),
    [sym_fsi_directive_decl] = STATE(1693),
    [sym_preproc_line] = STATE(1693),
    [aux_sym_long_identifier_repeat1] = STATE(1697),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3261),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4354),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [anon_sym_EQ2] = ACTIONS(3259),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [1694] = {
    [sym_xml_doc] = STATE(1694),
    [sym_block_comment] = STATE(1694),
    [sym_line_comment] = STATE(1694),
    [sym_compiler_directive_decl] = STATE(1694),
    [sym_fsi_directive_decl] = STATE(1694),
    [sym_preproc_line] = STATE(1694),
    [aux_sym_long_identifier_repeat1] = STATE(1694),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4358),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1695] = {
    [sym_xml_doc] = STATE(1695),
    [sym_block_comment] = STATE(1695),
    [sym_line_comment] = STATE(1695),
    [sym_compiler_directive_decl] = STATE(1695),
    [sym_fsi_directive_decl] = STATE(1695),
    [sym_preproc_line] = STATE(1695),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [anon_sym_POUNDendif] = ACTIONS(3389),
    [anon_sym_POUNDelse] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1696] = {
    [sym_xml_doc] = STATE(1696),
    [sym_block_comment] = STATE(1696),
    [sym_line_comment] = STATE(1696),
    [sym_compiler_directive_decl] = STATE(1696),
    [sym_fsi_directive_decl] = STATE(1696),
    [sym_preproc_line] = STATE(1696),
    [aux_sym_rules_repeat1] = STATE(1710),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(3404),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4361),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_with] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4363),
  },
  [1697] = {
    [sym_xml_doc] = STATE(1697),
    [sym_block_comment] = STATE(1697),
    [sym_line_comment] = STATE(1697),
    [sym_compiler_directive_decl] = STATE(1697),
    [sym_fsi_directive_decl] = STATE(1697),
    [sym_preproc_line] = STATE(1697),
    [aux_sym_long_identifier_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4366),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [anon_sym_EQ2] = ACTIONS(3204),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [1698] = {
    [sym_xml_doc] = STATE(1698),
    [sym_block_comment] = STATE(1698),
    [sym_line_comment] = STATE(1698),
    [sym_compiler_directive_decl] = STATE(1698),
    [sym_fsi_directive_decl] = STATE(1698),
    [sym_preproc_line] = STATE(1698),
    [aux_sym_long_identifier_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3285),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [anon_sym_EQ2] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1699] = {
    [sym_xml_doc] = STATE(1699),
    [sym_block_comment] = STATE(1699),
    [sym_line_comment] = STATE(1699),
    [sym_compiler_directive_decl] = STATE(1699),
    [sym_fsi_directive_decl] = STATE(1699),
    [sym_preproc_line] = STATE(1699),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_as] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_with] = ACTIONS(3493),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1700] = {
    [sym_xml_doc] = STATE(1700),
    [sym_block_comment] = STATE(1700),
    [sym_line_comment] = STATE(1700),
    [sym_compiler_directive_decl] = STATE(1700),
    [sym_fsi_directive_decl] = STATE(1700),
    [sym_preproc_line] = STATE(1700),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4371),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1701] = {
    [sym_xml_doc] = STATE(1701),
    [sym_block_comment] = STATE(1701),
    [sym_line_comment] = STATE(1701),
    [sym_compiler_directive_decl] = STATE(1701),
    [sym_fsi_directive_decl] = STATE(1701),
    [sym_preproc_line] = STATE(1701),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_as] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1702] = {
    [sym_xml_doc] = STATE(1702),
    [sym_block_comment] = STATE(1702),
    [sym_line_comment] = STATE(1702),
    [sym_compiler_directive_decl] = STATE(1702),
    [sym_fsi_directive_decl] = STATE(1702),
    [sym_preproc_line] = STATE(1702),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [anon_sym_POUNDelse] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1703] = {
    [sym_xml_doc] = STATE(1703),
    [sym_block_comment] = STATE(1703),
    [sym_line_comment] = STATE(1703),
    [sym_compiler_directive_decl] = STATE(1703),
    [sym_fsi_directive_decl] = STATE(1703),
    [sym_preproc_line] = STATE(1703),
    [aux_sym_long_identifier_repeat1] = STATE(1694),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4373),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_DOT_DOT2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [1704] = {
    [sym_xml_doc] = STATE(1704),
    [sym_block_comment] = STATE(1704),
    [sym_line_comment] = STATE(1704),
    [sym_compiler_directive_decl] = STATE(1704),
    [sym_fsi_directive_decl] = STATE(1704),
    [sym_preproc_line] = STATE(1704),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4375),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [anon_sym_POUNDendif] = ACTIONS(3419),
    [anon_sym_POUNDelse] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1705] = {
    [sym_xml_doc] = STATE(1705),
    [sym_block_comment] = STATE(1705),
    [sym_line_comment] = STATE(1705),
    [sym_compiler_directive_decl] = STATE(1705),
    [sym_fsi_directive_decl] = STATE(1705),
    [sym_preproc_line] = STATE(1705),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3194),
    [aux_sym_decimal_token1] = ACTIONS(2946),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [anon_sym_POUNDelse] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1706] = {
    [sym_xml_doc] = STATE(1706),
    [sym_block_comment] = STATE(1706),
    [sym_line_comment] = STATE(1706),
    [sym_compiler_directive_decl] = STATE(1706),
    [sym_fsi_directive_decl] = STATE(1706),
    [sym_preproc_line] = STATE(1706),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_as] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_with] = ACTIONS(3554),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4377),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
    [sym__dedent] = ACTIONS(3556),
  },
  [1707] = {
    [sym_xml_doc] = STATE(1707),
    [sym_block_comment] = STATE(1707),
    [sym_line_comment] = STATE(1707),
    [sym_compiler_directive_decl] = STATE(1707),
    [sym_fsi_directive_decl] = STATE(1707),
    [sym_preproc_line] = STATE(1707),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4305),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1708] = {
    [sym_xml_doc] = STATE(1708),
    [sym_block_comment] = STATE(1708),
    [sym_line_comment] = STATE(1708),
    [sym_compiler_directive_decl] = STATE(1708),
    [sym_fsi_directive_decl] = STATE(1708),
    [sym_preproc_line] = STATE(1708),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4379),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1709] = {
    [sym_xml_doc] = STATE(1709),
    [sym_block_comment] = STATE(1709),
    [sym_line_comment] = STATE(1709),
    [sym_compiler_directive_decl] = STATE(1709),
    [sym_fsi_directive_decl] = STATE(1709),
    [sym_preproc_line] = STATE(1709),
    [aux_sym_rules_repeat1] = STATE(1713),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_as] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4361),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4381),
  },
  [1710] = {
    [sym_xml_doc] = STATE(1710),
    [sym_block_comment] = STATE(1710),
    [sym_line_comment] = STATE(1710),
    [sym_compiler_directive_decl] = STATE(1710),
    [sym_fsi_directive_decl] = STATE(1710),
    [sym_preproc_line] = STATE(1710),
    [aux_sym_rules_repeat1] = STATE(1715),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_as] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4361),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4381),
  },
  [1711] = {
    [sym_xml_doc] = STATE(1711),
    [sym_block_comment] = STATE(1711),
    [sym_line_comment] = STATE(1711),
    [sym_compiler_directive_decl] = STATE(1711),
    [sym_fsi_directive_decl] = STATE(1711),
    [sym_preproc_line] = STATE(1711),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_DASH_GT] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1712] = {
    [sym_xml_doc] = STATE(1712),
    [sym_block_comment] = STATE(1712),
    [sym_line_comment] = STATE(1712),
    [sym_compiler_directive_decl] = STATE(1712),
    [sym_fsi_directive_decl] = STATE(1712),
    [sym_preproc_line] = STATE(1712),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4384),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [anon_sym_POUNDendif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1713] = {
    [sym_xml_doc] = STATE(1713),
    [sym_block_comment] = STATE(1713),
    [sym_line_comment] = STATE(1713),
    [sym_compiler_directive_decl] = STATE(1713),
    [sym_fsi_directive_decl] = STATE(1713),
    [sym_preproc_line] = STATE(1713),
    [aux_sym_rules_repeat1] = STATE(1715),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_as] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4361),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_with] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4386),
  },
  [1714] = {
    [sym_xml_doc] = STATE(1714),
    [sym_block_comment] = STATE(1714),
    [sym_line_comment] = STATE(1714),
    [sym_compiler_directive_decl] = STATE(1714),
    [sym_fsi_directive_decl] = STATE(1714),
    [sym_preproc_line] = STATE(1714),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4389),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [1715] = {
    [sym_xml_doc] = STATE(1715),
    [sym_block_comment] = STATE(1715),
    [sym_line_comment] = STATE(1715),
    [sym_compiler_directive_decl] = STATE(1715),
    [sym_fsi_directive_decl] = STATE(1715),
    [sym_preproc_line] = STATE(1715),
    [aux_sym_rules_repeat1] = STATE(1715),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4391),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4394),
  },
  [1716] = {
    [sym_xml_doc] = STATE(1716),
    [sym_block_comment] = STATE(1716),
    [sym_line_comment] = STATE(1716),
    [sym_compiler_directive_decl] = STATE(1716),
    [sym_fsi_directive_decl] = STATE(1716),
    [sym_preproc_line] = STATE(1716),
    [aux_sym_long_identifier_repeat1] = STATE(1703),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_DOT_DOT2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [1717] = {
    [sym_xml_doc] = STATE(1717),
    [sym_block_comment] = STATE(1717),
    [sym_line_comment] = STATE(1717),
    [sym_compiler_directive_decl] = STATE(1717),
    [sym_fsi_directive_decl] = STATE(1717),
    [sym_preproc_line] = STATE(1717),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4401),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [anon_sym_POUNDelse] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1718] = {
    [sym_xml_doc] = STATE(1718),
    [sym_block_comment] = STATE(1718),
    [sym_line_comment] = STATE(1718),
    [sym_compiler_directive_decl] = STATE(1718),
    [sym_fsi_directive_decl] = STATE(1718),
    [sym_preproc_line] = STATE(1718),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [anon_sym_POUNDendif] = ACTIONS(3457),
    [anon_sym_POUNDelse] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1719] = {
    [sym_xml_doc] = STATE(1719),
    [sym_block_comment] = STATE(1719),
    [sym_line_comment] = STATE(1719),
    [sym_compiler_directive_decl] = STATE(1719),
    [sym_fsi_directive_decl] = STATE(1719),
    [sym_preproc_line] = STATE(1719),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_DASH_GT] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_DOT_DOT] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1720] = {
    [sym_xml_doc] = STATE(1720),
    [sym_block_comment] = STATE(1720),
    [sym_line_comment] = STATE(1720),
    [sym_compiler_directive_decl] = STATE(1720),
    [sym_fsi_directive_decl] = STATE(1720),
    [sym_preproc_line] = STATE(1720),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_DOT_DOT2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
    [sym__dedent] = ACTIONS(3535),
  },
  [1721] = {
    [sym_xml_doc] = STATE(1721),
    [sym_block_comment] = STATE(1721),
    [sym_line_comment] = STATE(1721),
    [sym_compiler_directive_decl] = STATE(1721),
    [sym_fsi_directive_decl] = STATE(1721),
    [sym_preproc_line] = STATE(1721),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_DASH_GT] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_DOT_DOT] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4403),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1722] = {
    [sym_xml_doc] = STATE(1722),
    [sym_block_comment] = STATE(1722),
    [sym_line_comment] = STATE(1722),
    [sym_compiler_directive_decl] = STATE(1722),
    [sym_fsi_directive_decl] = STATE(1722),
    [sym_preproc_line] = STATE(1722),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1723] = {
    [sym_xml_doc] = STATE(1723),
    [sym_block_comment] = STATE(1723),
    [sym_line_comment] = STATE(1723),
    [sym_compiler_directive_decl] = STATE(1723),
    [sym_fsi_directive_decl] = STATE(1723),
    [sym_preproc_line] = STATE(1723),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_DOT_DOT2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [1724] = {
    [sym_xml_doc] = STATE(1724),
    [sym_block_comment] = STATE(1724),
    [sym_line_comment] = STATE(1724),
    [sym_compiler_directive_decl] = STATE(1724),
    [sym_fsi_directive_decl] = STATE(1724),
    [sym_preproc_line] = STATE(1724),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1725] = {
    [sym_xml_doc] = STATE(1725),
    [sym_block_comment] = STATE(1725),
    [sym_line_comment] = STATE(1725),
    [sym_compiler_directive_decl] = STATE(1725),
    [sym_fsi_directive_decl] = STATE(1725),
    [sym_preproc_line] = STATE(1725),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1726] = {
    [sym_xml_doc] = STATE(1726),
    [sym_block_comment] = STATE(1726),
    [sym_line_comment] = STATE(1726),
    [sym_compiler_directive_decl] = STATE(1726),
    [sym_fsi_directive_decl] = STATE(1726),
    [sym_preproc_line] = STATE(1726),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_DASH_GT] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3190),
    [aux_sym_decimal_token1] = ACTIONS(3002),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1727] = {
    [sym_xml_doc] = STATE(1727),
    [sym_block_comment] = STATE(1727),
    [sym_line_comment] = STATE(1727),
    [sym_compiler_directive_decl] = STATE(1727),
    [sym_fsi_directive_decl] = STATE(1727),
    [sym_preproc_line] = STATE(1727),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_AT_AT_GT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4405),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1728] = {
    [sym_xml_doc] = STATE(1728),
    [sym_block_comment] = STATE(1728),
    [sym_line_comment] = STATE(1728),
    [sym_compiler_directive_decl] = STATE(1728),
    [sym_fsi_directive_decl] = STATE(1728),
    [sym_preproc_line] = STATE(1728),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_with] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_DOT_DOT2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
    [sym__dedent] = ACTIONS(3544),
  },
  [1729] = {
    [sym_xml_doc] = STATE(1729),
    [sym_block_comment] = STATE(1729),
    [sym_line_comment] = STATE(1729),
    [sym_compiler_directive_decl] = STATE(1729),
    [sym_fsi_directive_decl] = STATE(1729),
    [sym_preproc_line] = STATE(1729),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_DASH_GT] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1730] = {
    [sym_xml_doc] = STATE(1730),
    [sym_block_comment] = STATE(1730),
    [sym_line_comment] = STATE(1730),
    [sym_compiler_directive_decl] = STATE(1730),
    [sym_fsi_directive_decl] = STATE(1730),
    [sym_preproc_line] = STATE(1730),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1731] = {
    [sym_xml_doc] = STATE(1731),
    [sym_block_comment] = STATE(1731),
    [sym_line_comment] = STATE(1731),
    [sym_compiler_directive_decl] = STATE(1731),
    [sym_fsi_directive_decl] = STATE(1731),
    [sym_preproc_line] = STATE(1731),
    [aux_sym_long_identifier_repeat1] = STATE(1733),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [1732] = {
    [sym_xml_doc] = STATE(1732),
    [sym_block_comment] = STATE(1732),
    [sym_line_comment] = STATE(1732),
    [sym_compiler_directive_decl] = STATE(1732),
    [sym_fsi_directive_decl] = STATE(1732),
    [sym_preproc_line] = STATE(1732),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1733] = {
    [sym_xml_doc] = STATE(1733),
    [sym_block_comment] = STATE(1733),
    [sym_line_comment] = STATE(1733),
    [sym_compiler_directive_decl] = STATE(1733),
    [sym_fsi_directive_decl] = STATE(1733),
    [sym_preproc_line] = STATE(1733),
    [aux_sym_long_identifier_repeat1] = STATE(1733),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1734] = {
    [sym_xml_doc] = STATE(1734),
    [sym_block_comment] = STATE(1734),
    [sym_line_comment] = STATE(1734),
    [sym_compiler_directive_decl] = STATE(1734),
    [sym_fsi_directive_decl] = STATE(1734),
    [sym_preproc_line] = STATE(1734),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_as] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4412),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1735] = {
    [sym_xml_doc] = STATE(1735),
    [sym_block_comment] = STATE(1735),
    [sym_line_comment] = STATE(1735),
    [sym_compiler_directive_decl] = STATE(1735),
    [sym_fsi_directive_decl] = STATE(1735),
    [sym_preproc_line] = STATE(1735),
    [aux_sym_rules_repeat1] = STATE(1741),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_DASH_GT] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_DOT_DOT] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4416),
  },
  [1736] = {
    [sym_xml_doc] = STATE(1736),
    [sym_block_comment] = STATE(1736),
    [sym_line_comment] = STATE(1736),
    [sym_compiler_directive_decl] = STATE(1736),
    [sym_fsi_directive_decl] = STATE(1736),
    [sym_preproc_line] = STATE(1736),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [anon_sym_POUNDendif] = ACTIONS(3495),
    [anon_sym_POUNDelse] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1737] = {
    [sym_xml_doc] = STATE(1737),
    [sym_block_comment] = STATE(1737),
    [sym_line_comment] = STATE(1737),
    [sym_compiler_directive_decl] = STATE(1737),
    [sym_fsi_directive_decl] = STATE(1737),
    [sym_preproc_line] = STATE(1737),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [1738] = {
    [sym_xml_doc] = STATE(1738),
    [sym_block_comment] = STATE(1738),
    [sym_line_comment] = STATE(1738),
    [sym_compiler_directive_decl] = STATE(1738),
    [sym_fsi_directive_decl] = STATE(1738),
    [sym_preproc_line] = STATE(1738),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4243),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3679),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1739] = {
    [sym_xml_doc] = STATE(1739),
    [sym_block_comment] = STATE(1739),
    [sym_line_comment] = STATE(1739),
    [sym_compiler_directive_decl] = STATE(1739),
    [sym_fsi_directive_decl] = STATE(1739),
    [sym_preproc_line] = STATE(1739),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3186),
    [aux_sym_decimal_token1] = ACTIONS(2918),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1740] = {
    [sym_xml_doc] = STATE(1740),
    [sym_block_comment] = STATE(1740),
    [sym_line_comment] = STATE(1740),
    [sym_compiler_directive_decl] = STATE(1740),
    [sym_fsi_directive_decl] = STATE(1740),
    [sym_preproc_line] = STATE(1740),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_AT_GT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(4419),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1741] = {
    [sym_xml_doc] = STATE(1741),
    [sym_block_comment] = STATE(1741),
    [sym_line_comment] = STATE(1741),
    [sym_compiler_directive_decl] = STATE(1741),
    [sym_fsi_directive_decl] = STATE(1741),
    [sym_preproc_line] = STATE(1741),
    [aux_sym_rules_repeat1] = STATE(1747),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_DASH_GT] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4421),
  },
  [1742] = {
    [sym_xml_doc] = STATE(1742),
    [sym_block_comment] = STATE(1742),
    [sym_line_comment] = STATE(1742),
    [sym_compiler_directive_decl] = STATE(1742),
    [sym_fsi_directive_decl] = STATE(1742),
    [sym_preproc_line] = STATE(1742),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_with] = ACTIONS(3554),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4424),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_DOT_DOT2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
    [sym__dedent] = ACTIONS(3556),
  },
  [1743] = {
    [sym_xml_doc] = STATE(1743),
    [sym_block_comment] = STATE(1743),
    [sym_line_comment] = STATE(1743),
    [sym_compiler_directive_decl] = STATE(1743),
    [sym_fsi_directive_decl] = STATE(1743),
    [sym_preproc_line] = STATE(1743),
    [aux_sym_rules_repeat1] = STATE(1746),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_DASH_GT] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4421),
  },
  [1744] = {
    [sym_xml_doc] = STATE(1744),
    [sym_block_comment] = STATE(1744),
    [sym_line_comment] = STATE(1744),
    [sym_compiler_directive_decl] = STATE(1744),
    [sym_fsi_directive_decl] = STATE(1744),
    [sym_preproc_line] = STATE(1744),
    [aux_sym_long_identifier_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
    [sym__dedent] = ACTIONS(3264),
  },
  [1745] = {
    [sym_xml_doc] = STATE(1745),
    [sym_block_comment] = STATE(1745),
    [sym_line_comment] = STATE(1745),
    [sym_compiler_directive_decl] = STATE(1745),
    [sym_fsi_directive_decl] = STATE(1745),
    [sym_preproc_line] = STATE(1745),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1746] = {
    [sym_xml_doc] = STATE(1746),
    [sym_block_comment] = STATE(1746),
    [sym_line_comment] = STATE(1746),
    [sym_compiler_directive_decl] = STATE(1746),
    [sym_fsi_directive_decl] = STATE(1746),
    [sym_preproc_line] = STATE(1746),
    [aux_sym_rules_repeat1] = STATE(1747),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_DASH_GT] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_DOT_DOT] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4430),
  },
  [1747] = {
    [sym_xml_doc] = STATE(1747),
    [sym_block_comment] = STATE(1747),
    [sym_line_comment] = STATE(1747),
    [sym_compiler_directive_decl] = STATE(1747),
    [sym_fsi_directive_decl] = STATE(1747),
    [sym_preproc_line] = STATE(1747),
    [aux_sym_rules_repeat1] = STATE(1747),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_DASH_GT] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4436),
  },
  [1748] = {
    [sym_xml_doc] = STATE(1748),
    [sym_block_comment] = STATE(1748),
    [sym_line_comment] = STATE(1748),
    [sym_compiler_directive_decl] = STATE(1748),
    [sym_fsi_directive_decl] = STATE(1748),
    [sym_preproc_line] = STATE(1748),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4243),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1749] = {
    [sym_xml_doc] = STATE(1749),
    [sym_block_comment] = STATE(1749),
    [sym_line_comment] = STATE(1749),
    [sym_compiler_directive_decl] = STATE(1749),
    [sym_fsi_directive_decl] = STATE(1749),
    [sym_preproc_line] = STATE(1749),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4439),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_DOT_DOT2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [1750] = {
    [sym_xml_doc] = STATE(1750),
    [sym_block_comment] = STATE(1750),
    [sym_line_comment] = STATE(1750),
    [sym_compiler_directive_decl] = STATE(1750),
    [sym_fsi_directive_decl] = STATE(1750),
    [sym_preproc_line] = STATE(1750),
    [aux_sym_sequential_expression_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_as] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_with] = ACTIONS(3829),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4441),
    [sym__dedent] = ACTIONS(3831),
  },
  [1751] = {
    [sym_xml_doc] = STATE(1751),
    [sym_block_comment] = STATE(1751),
    [sym_line_comment] = STATE(1751),
    [sym_compiler_directive_decl] = STATE(1751),
    [sym_fsi_directive_decl] = STATE(1751),
    [sym_preproc_line] = STATE(1751),
    [aux_sym_sequential_expression_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_with] = ACTIONS(3612),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
    [sym__dedent] = ACTIONS(3614),
  },
  [1752] = {
    [sym_xml_doc] = STATE(1752),
    [sym_block_comment] = STATE(1752),
    [sym_line_comment] = STATE(1752),
    [sym_compiler_directive_decl] = STATE(1752),
    [sym_fsi_directive_decl] = STATE(1752),
    [sym_preproc_line] = STATE(1752),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4243),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1753] = {
    [sym_xml_doc] = STATE(1753),
    [sym_block_comment] = STATE(1753),
    [sym_line_comment] = STATE(1753),
    [sym_compiler_directive_decl] = STATE(1753),
    [sym_fsi_directive_decl] = STATE(1753),
    [sym_preproc_line] = STATE(1753),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_with] = ACTIONS(3914),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_DOT_DOT2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
    [sym__dedent] = ACTIONS(3916),
  },
  [1754] = {
    [sym_xml_doc] = STATE(1754),
    [sym_block_comment] = STATE(1754),
    [sym_line_comment] = STATE(1754),
    [sym_compiler_directive_decl] = STATE(1754),
    [sym_fsi_directive_decl] = STATE(1754),
    [sym_preproc_line] = STATE(1754),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1755] = {
    [sym_xml_doc] = STATE(1755),
    [sym_block_comment] = STATE(1755),
    [sym_line_comment] = STATE(1755),
    [sym_compiler_directive_decl] = STATE(1755),
    [sym_fsi_directive_decl] = STATE(1755),
    [sym_preproc_line] = STATE(1755),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1756] = {
    [sym_xml_doc] = STATE(1756),
    [sym_block_comment] = STATE(1756),
    [sym_line_comment] = STATE(1756),
    [sym_compiler_directive_decl] = STATE(1756),
    [sym_fsi_directive_decl] = STATE(1756),
    [sym_preproc_line] = STATE(1756),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
    [sym__dedent] = ACTIONS(3732),
  },
  [1757] = {
    [sym_xml_doc] = STATE(1757),
    [sym_block_comment] = STATE(1757),
    [sym_line_comment] = STATE(1757),
    [sym_compiler_directive_decl] = STATE(1757),
    [sym_fsi_directive_decl] = STATE(1757),
    [sym_preproc_line] = STATE(1757),
    [aux_sym_long_identifier_repeat1] = STATE(1761),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_DOT_DOT] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1758] = {
    [sym_xml_doc] = STATE(1758),
    [sym_block_comment] = STATE(1758),
    [sym_line_comment] = STATE(1758),
    [sym_compiler_directive_decl] = STATE(1758),
    [sym_fsi_directive_decl] = STATE(1758),
    [sym_preproc_line] = STATE(1758),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_AT_AT_GT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4446),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1759] = {
    [sym_xml_doc] = STATE(1759),
    [sym_block_comment] = STATE(1759),
    [sym_line_comment] = STATE(1759),
    [sym_compiler_directive_decl] = STATE(1759),
    [sym_fsi_directive_decl] = STATE(1759),
    [sym_preproc_line] = STATE(1759),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_GT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1760] = {
    [sym_xml_doc] = STATE(1760),
    [sym_block_comment] = STATE(1760),
    [sym_line_comment] = STATE(1760),
    [sym_compiler_directive_decl] = STATE(1760),
    [sym_fsi_directive_decl] = STATE(1760),
    [sym_preproc_line] = STATE(1760),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4448),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1761] = {
    [sym_xml_doc] = STATE(1761),
    [sym_block_comment] = STATE(1761),
    [sym_line_comment] = STATE(1761),
    [sym_compiler_directive_decl] = STATE(1761),
    [sym_fsi_directive_decl] = STATE(1761),
    [sym_preproc_line] = STATE(1761),
    [aux_sym_long_identifier_repeat1] = STATE(1761),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1762] = {
    [sym_xml_doc] = STATE(1762),
    [sym_block_comment] = STATE(1762),
    [sym_line_comment] = STATE(1762),
    [sym_compiler_directive_decl] = STATE(1762),
    [sym_fsi_directive_decl] = STATE(1762),
    [sym_preproc_line] = STATE(1762),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3608),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_with] = ACTIONS(3608),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
    [sym__dedent] = ACTIONS(3610),
  },
  [1763] = {
    [sym_xml_doc] = STATE(1763),
    [sym_block_comment] = STATE(1763),
    [sym_line_comment] = STATE(1763),
    [sym_compiler_directive_decl] = STATE(1763),
    [sym_fsi_directive_decl] = STATE(1763),
    [sym_preproc_line] = STATE(1763),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4453),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_DASH_GT] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1764] = {
    [sym_xml_doc] = STATE(1764),
    [sym_block_comment] = STATE(1764),
    [sym_line_comment] = STATE(1764),
    [sym_compiler_directive_decl] = STATE(1764),
    [sym_fsi_directive_decl] = STATE(1764),
    [sym_preproc_line] = STATE(1764),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1765] = {
    [sym_xml_doc] = STATE(1765),
    [sym_block_comment] = STATE(1765),
    [sym_line_comment] = STATE(1765),
    [sym_compiler_directive_decl] = STATE(1765),
    [sym_fsi_directive_decl] = STATE(1765),
    [sym_preproc_line] = STATE(1765),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_GT] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1766] = {
    [sym_xml_doc] = STATE(1766),
    [sym_block_comment] = STATE(1766),
    [sym_line_comment] = STATE(1766),
    [sym_compiler_directive_decl] = STATE(1766),
    [sym_fsi_directive_decl] = STATE(1766),
    [sym_preproc_line] = STATE(1766),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1767] = {
    [sym_xml_doc] = STATE(1767),
    [sym_block_comment] = STATE(1767),
    [sym_line_comment] = STATE(1767),
    [sym_compiler_directive_decl] = STATE(1767),
    [sym_fsi_directive_decl] = STATE(1767),
    [sym_preproc_line] = STATE(1767),
    [aux_sym_sequential_expression_repeat1] = STATE(1911),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_with] = ACTIONS(3612),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1768] = {
    [sym_xml_doc] = STATE(1768),
    [sym_block_comment] = STATE(1768),
    [sym_line_comment] = STATE(1768),
    [sym_compiler_directive_decl] = STATE(1768),
    [sym_fsi_directive_decl] = STATE(1768),
    [sym_preproc_line] = STATE(1768),
    [aux_sym_sequential_expression_repeat1] = STATE(1768),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [anon_sym_POUNDendif] = ACTIONS(3831),
    [anon_sym_POUNDelse] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4455),
  },
  [1769] = {
    [sym_xml_doc] = STATE(1769),
    [sym_block_comment] = STATE(1769),
    [sym_line_comment] = STATE(1769),
    [sym_compiler_directive_decl] = STATE(1769),
    [sym_fsi_directive_decl] = STATE(1769),
    [sym_preproc_line] = STATE(1769),
    [aux_sym_rules_repeat1] = STATE(1776),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4460),
  },
  [1770] = {
    [sym_xml_doc] = STATE(1770),
    [sym_block_comment] = STATE(1770),
    [sym_line_comment] = STATE(1770),
    [sym_compiler_directive_decl] = STATE(1770),
    [sym_fsi_directive_decl] = STATE(1770),
    [sym_preproc_line] = STATE(1770),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_with] = ACTIONS(3598),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_DOT_DOT2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
    [sym__dedent] = ACTIONS(3600),
  },
  [1771] = {
    [sym_xml_doc] = STATE(1771),
    [sym_block_comment] = STATE(1771),
    [sym_line_comment] = STATE(1771),
    [sym_compiler_directive_decl] = STATE(1771),
    [sym_fsi_directive_decl] = STATE(1771),
    [sym_preproc_line] = STATE(1771),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_DOT_DOT2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
    [sym__dedent] = ACTIONS(3703),
  },
  [1772] = {
    [sym_xml_doc] = STATE(1772),
    [sym_block_comment] = STATE(1772),
    [sym_line_comment] = STATE(1772),
    [sym_compiler_directive_decl] = STATE(1772),
    [sym_fsi_directive_decl] = STATE(1772),
    [sym_preproc_line] = STATE(1772),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4463),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1773] = {
    [sym_xml_doc] = STATE(1773),
    [sym_block_comment] = STATE(1773),
    [sym_line_comment] = STATE(1773),
    [sym_compiler_directive_decl] = STATE(1773),
    [sym_fsi_directive_decl] = STATE(1773),
    [sym_preproc_line] = STATE(1773),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4465),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1774] = {
    [sym_xml_doc] = STATE(1774),
    [sym_block_comment] = STATE(1774),
    [sym_line_comment] = STATE(1774),
    [sym_compiler_directive_decl] = STATE(1774),
    [sym_fsi_directive_decl] = STATE(1774),
    [sym_preproc_line] = STATE(1774),
    [aux_sym_rules_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4467),
  },
  [1775] = {
    [sym_xml_doc] = STATE(1775),
    [sym_block_comment] = STATE(1775),
    [sym_line_comment] = STATE(1775),
    [sym_compiler_directive_decl] = STATE(1775),
    [sym_fsi_directive_decl] = STATE(1775),
    [sym_preproc_line] = STATE(1775),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_as] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_with] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
    [sym__dedent] = ACTIONS(3707),
  },
  [1776] = {
    [sym_xml_doc] = STATE(1776),
    [sym_block_comment] = STATE(1776),
    [sym_line_comment] = STATE(1776),
    [sym_compiler_directive_decl] = STATE(1776),
    [sym_fsi_directive_decl] = STATE(1776),
    [sym_preproc_line] = STATE(1776),
    [aux_sym_rules_repeat1] = STATE(1787),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4467),
  },
  [1777] = {
    [sym_xml_doc] = STATE(1777),
    [sym_block_comment] = STATE(1777),
    [sym_line_comment] = STATE(1777),
    [sym_compiler_directive_decl] = STATE(1777),
    [sym_fsi_directive_decl] = STATE(1777),
    [sym_preproc_line] = STATE(1777),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_with] = ACTIONS(3742),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
    [sym__dedent] = ACTIONS(3744),
  },
  [1778] = {
    [sym_xml_doc] = STATE(1778),
    [sym_block_comment] = STATE(1778),
    [sym_line_comment] = STATE(1778),
    [sym_compiler_directive_decl] = STATE(1778),
    [sym_fsi_directive_decl] = STATE(1778),
    [sym_preproc_line] = STATE(1778),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_with] = ACTIONS(3794),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_DOT_DOT2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
    [sym__dedent] = ACTIONS(3796),
  },
  [1779] = {
    [sym_xml_doc] = STATE(1779),
    [sym_block_comment] = STATE(1779),
    [sym_line_comment] = STATE(1779),
    [sym_compiler_directive_decl] = STATE(1779),
    [sym_fsi_directive_decl] = STATE(1779),
    [sym_preproc_line] = STATE(1779),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_with] = ACTIONS(3642),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_DOT_DOT2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
    [sym__dedent] = ACTIONS(3644),
  },
  [1780] = {
    [sym_xml_doc] = STATE(1780),
    [sym_block_comment] = STATE(1780),
    [sym_line_comment] = STATE(1780),
    [sym_compiler_directive_decl] = STATE(1780),
    [sym_fsi_directive_decl] = STATE(1780),
    [sym_preproc_line] = STATE(1780),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_with] = ACTIONS(3814),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
    [sym__dedent] = ACTIONS(3816),
  },
  [1781] = {
    [sym_xml_doc] = STATE(1781),
    [sym_block_comment] = STATE(1781),
    [sym_line_comment] = STATE(1781),
    [sym_compiler_directive_decl] = STATE(1781),
    [sym_fsi_directive_decl] = STATE(1781),
    [sym_preproc_line] = STATE(1781),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4453),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_DASH_GT] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1782] = {
    [sym_xml_doc] = STATE(1782),
    [sym_block_comment] = STATE(1782),
    [sym_line_comment] = STATE(1782),
    [sym_compiler_directive_decl] = STATE(1782),
    [sym_fsi_directive_decl] = STATE(1782),
    [sym_preproc_line] = STATE(1782),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_with] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
    [sym__dedent] = ACTIONS(3820),
  },
  [1783] = {
    [sym_xml_doc] = STATE(1783),
    [sym_block_comment] = STATE(1783),
    [sym_line_comment] = STATE(1783),
    [sym_compiler_directive_decl] = STATE(1783),
    [sym_fsi_directive_decl] = STATE(1783),
    [sym_preproc_line] = STATE(1783),
    [aux_sym_rules_repeat1] = STATE(1787),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_GT] = ACTIONS(3463),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4470),
  },
  [1784] = {
    [sym_xml_doc] = STATE(1784),
    [sym_block_comment] = STATE(1784),
    [sym_line_comment] = STATE(1784),
    [sym_compiler_directive_decl] = STATE(1784),
    [sym_fsi_directive_decl] = STATE(1784),
    [sym_preproc_line] = STATE(1784),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_DOT_DOT] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1785] = {
    [sym_xml_doc] = STATE(1785),
    [sym_block_comment] = STATE(1785),
    [sym_line_comment] = STATE(1785),
    [sym_compiler_directive_decl] = STATE(1785),
    [sym_fsi_directive_decl] = STATE(1785),
    [sym_preproc_line] = STATE(1785),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1786] = {
    [sym_xml_doc] = STATE(1786),
    [sym_block_comment] = STATE(1786),
    [sym_line_comment] = STATE(1786),
    [sym_compiler_directive_decl] = STATE(1786),
    [sym_fsi_directive_decl] = STATE(1786),
    [sym_preproc_line] = STATE(1786),
    [aux_sym_long_identifier_repeat1] = STATE(1884),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3261),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4473),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [anon_sym_EQ2] = ACTIONS(3259),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1787] = {
    [sym_xml_doc] = STATE(1787),
    [sym_block_comment] = STATE(1787),
    [sym_line_comment] = STATE(1787),
    [sym_compiler_directive_decl] = STATE(1787),
    [sym_fsi_directive_decl] = STATE(1787),
    [sym_preproc_line] = STATE(1787),
    [aux_sym_rules_repeat1] = STATE(1787),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4477),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3483),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4480),
  },
  [1788] = {
    [sym_xml_doc] = STATE(1788),
    [sym_block_comment] = STATE(1788),
    [sym_line_comment] = STATE(1788),
    [sym_compiler_directive_decl] = STATE(1788),
    [sym_fsi_directive_decl] = STATE(1788),
    [sym_preproc_line] = STATE(1788),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3285),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [anon_sym_EQ2] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1789] = {
    [sym_xml_doc] = STATE(1789),
    [sym_block_comment] = STATE(1789),
    [sym_line_comment] = STATE(1789),
    [sym_compiler_directive_decl] = STATE(1789),
    [sym_fsi_directive_decl] = STATE(1789),
    [sym_preproc_line] = STATE(1789),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1790] = {
    [sym_xml_doc] = STATE(1790),
    [sym_block_comment] = STATE(1790),
    [sym_line_comment] = STATE(1790),
    [sym_compiler_directive_decl] = STATE(1790),
    [sym_fsi_directive_decl] = STATE(1790),
    [sym_preproc_line] = STATE(1790),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_with] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4349),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1791] = {
    [sym_xml_doc] = STATE(1791),
    [sym_block_comment] = STATE(1791),
    [sym_line_comment] = STATE(1791),
    [sym_compiler_directive_decl] = STATE(1791),
    [sym_fsi_directive_decl] = STATE(1791),
    [sym_preproc_line] = STATE(1791),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1792] = {
    [sym_xml_doc] = STATE(1792),
    [sym_block_comment] = STATE(1792),
    [sym_line_comment] = STATE(1792),
    [sym_compiler_directive_decl] = STATE(1792),
    [sym_fsi_directive_decl] = STATE(1792),
    [sym_preproc_line] = STATE(1792),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [anon_sym_POUNDendif] = ACTIONS(3535),
    [anon_sym_POUNDelse] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [1793] = {
    [sym_xml_doc] = STATE(1793),
    [sym_block_comment] = STATE(1793),
    [sym_line_comment] = STATE(1793),
    [sym_compiler_directive_decl] = STATE(1793),
    [sym_fsi_directive_decl] = STATE(1793),
    [sym_preproc_line] = STATE(1793),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_with] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_DOT_DOT2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
    [sym__dedent] = ACTIONS(3820),
  },
  [1794] = {
    [sym_xml_doc] = STATE(1794),
    [sym_block_comment] = STATE(1794),
    [sym_line_comment] = STATE(1794),
    [sym_compiler_directive_decl] = STATE(1794),
    [sym_fsi_directive_decl] = STATE(1794),
    [sym_preproc_line] = STATE(1794),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [anon_sym_POUNDendif] = ACTIONS(3525),
    [anon_sym_POUNDelse] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1795] = {
    [sym_xml_doc] = STATE(1795),
    [sym_block_comment] = STATE(1795),
    [sym_line_comment] = STATE(1795),
    [sym_compiler_directive_decl] = STATE(1795),
    [sym_fsi_directive_decl] = STATE(1795),
    [sym_preproc_line] = STATE(1795),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3314),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [anon_sym_EQ2] = ACTIONS(4483),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1796] = {
    [sym_xml_doc] = STATE(1796),
    [sym_block_comment] = STATE(1796),
    [sym_line_comment] = STATE(1796),
    [sym_compiler_directive_decl] = STATE(1796),
    [sym_fsi_directive_decl] = STATE(1796),
    [sym_preproc_line] = STATE(1796),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_as] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_with] = ACTIONS(3554),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4485),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [1797] = {
    [sym_xml_doc] = STATE(1797),
    [sym_block_comment] = STATE(1797),
    [sym_line_comment] = STATE(1797),
    [sym_compiler_directive_decl] = STATE(1797),
    [sym_fsi_directive_decl] = STATE(1797),
    [sym_preproc_line] = STATE(1797),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_GT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3198),
    [aux_sym_decimal_token1] = ACTIONS(3120),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1798] = {
    [sym_xml_doc] = STATE(1798),
    [sym_block_comment] = STATE(1798),
    [sym_line_comment] = STATE(1798),
    [sym_compiler_directive_decl] = STATE(1798),
    [sym_fsi_directive_decl] = STATE(1798),
    [sym_preproc_line] = STATE(1798),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_with] = ACTIONS(3814),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_DOT_DOT2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
    [sym__dedent] = ACTIONS(3816),
  },
  [1799] = {
    [sym_xml_doc] = STATE(1799),
    [sym_block_comment] = STATE(1799),
    [sym_line_comment] = STATE(1799),
    [sym_compiler_directive_decl] = STATE(1799),
    [sym_fsi_directive_decl] = STATE(1799),
    [sym_preproc_line] = STATE(1799),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1800] = {
    [sym_xml_doc] = STATE(1800),
    [sym_block_comment] = STATE(1800),
    [sym_line_comment] = STATE(1800),
    [sym_compiler_directive_decl] = STATE(1800),
    [sym_fsi_directive_decl] = STATE(1800),
    [sym_preproc_line] = STATE(1800),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [anon_sym_POUNDendif] = ACTIONS(3544),
    [anon_sym_POUNDelse] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [1801] = {
    [sym_xml_doc] = STATE(1801),
    [sym_block_comment] = STATE(1801),
    [sym_line_comment] = STATE(1801),
    [sym_compiler_directive_decl] = STATE(1801),
    [sym_fsi_directive_decl] = STATE(1801),
    [sym_preproc_line] = STATE(1801),
    [aux_sym_long_identifier_repeat1] = STATE(2002),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [anon_sym_POUNDendif] = ACTIONS(3264),
    [anon_sym_POUNDelse] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1802] = {
    [sym_xml_doc] = STATE(1802),
    [sym_block_comment] = STATE(1802),
    [sym_line_comment] = STATE(1802),
    [sym_compiler_directive_decl] = STATE(1802),
    [sym_fsi_directive_decl] = STATE(1802),
    [sym_preproc_line] = STATE(1802),
    [aux_sym_long_identifier_repeat1] = STATE(1803),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4491),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1803] = {
    [sym_xml_doc] = STATE(1803),
    [sym_block_comment] = STATE(1803),
    [sym_line_comment] = STATE(1803),
    [sym_compiler_directive_decl] = STATE(1803),
    [sym_fsi_directive_decl] = STATE(1803),
    [sym_preproc_line] = STATE(1803),
    [aux_sym_long_identifier_repeat1] = STATE(1803),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1804] = {
    [sym_xml_doc] = STATE(1804),
    [sym_block_comment] = STATE(1804),
    [sym_line_comment] = STATE(1804),
    [sym_compiler_directive_decl] = STATE(1804),
    [sym_fsi_directive_decl] = STATE(1804),
    [sym_preproc_line] = STATE(1804),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4034),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1805] = {
    [sym_xml_doc] = STATE(1805),
    [sym_block_comment] = STATE(1805),
    [sym_line_comment] = STATE(1805),
    [sym_compiler_directive_decl] = STATE(1805),
    [sym_fsi_directive_decl] = STATE(1805),
    [sym_preproc_line] = STATE(1805),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_with] = ACTIONS(3742),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_DOT_DOT2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
    [sym__dedent] = ACTIONS(3744),
  },
  [1806] = {
    [sym_xml_doc] = STATE(1806),
    [sym_block_comment] = STATE(1806),
    [sym_line_comment] = STATE(1806),
    [sym_compiler_directive_decl] = STATE(1806),
    [sym_fsi_directive_decl] = STATE(1806),
    [sym_preproc_line] = STATE(1806),
    [aux_sym_rules_repeat1] = STATE(1870),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_AT_AT_GT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4498),
  },
  [1807] = {
    [sym_xml_doc] = STATE(1807),
    [sym_block_comment] = STATE(1807),
    [sym_line_comment] = STATE(1807),
    [sym_compiler_directive_decl] = STATE(1807),
    [sym_fsi_directive_decl] = STATE(1807),
    [sym_preproc_line] = STATE(1807),
    [aux_sym_rules_repeat1] = STATE(1807),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4501),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4504),
  },
  [1808] = {
    [sym_xml_doc] = STATE(1808),
    [sym_block_comment] = STATE(1808),
    [sym_line_comment] = STATE(1808),
    [sym_compiler_directive_decl] = STATE(1808),
    [sym_fsi_directive_decl] = STATE(1808),
    [sym_preproc_line] = STATE(1808),
    [aux_sym_rules_repeat1] = STATE(1807),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_DOT_DOT] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4509),
  },
  [1809] = {
    [sym_xml_doc] = STATE(1809),
    [sym_block_comment] = STATE(1809),
    [sym_line_comment] = STATE(1809),
    [sym_compiler_directive_decl] = STATE(1809),
    [sym_fsi_directive_decl] = STATE(1809),
    [sym_preproc_line] = STATE(1809),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_DOT_DOT2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
    [sym__dedent] = ACTIONS(3732),
  },
  [1810] = {
    [sym_xml_doc] = STATE(1810),
    [sym_block_comment] = STATE(1810),
    [sym_line_comment] = STATE(1810),
    [sym_compiler_directive_decl] = STATE(1810),
    [sym_fsi_directive_decl] = STATE(1810),
    [sym_preproc_line] = STATE(1810),
    [aux_sym_rules_repeat1] = STATE(1807),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4512),
  },
  [1811] = {
    [sym_xml_doc] = STATE(1811),
    [sym_block_comment] = STATE(1811),
    [sym_line_comment] = STATE(1811),
    [sym_compiler_directive_decl] = STATE(1811),
    [sym_fsi_directive_decl] = STATE(1811),
    [sym_preproc_line] = STATE(1811),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_AT_GT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1812] = {
    [sym_xml_doc] = STATE(1812),
    [sym_block_comment] = STATE(1812),
    [sym_line_comment] = STATE(1812),
    [sym_compiler_directive_decl] = STATE(1812),
    [sym_fsi_directive_decl] = STATE(1812),
    [sym_preproc_line] = STATE(1812),
    [aux_sym_rules_repeat1] = STATE(1808),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_DOT_DOT] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4512),
  },
  [1813] = {
    [sym_xml_doc] = STATE(1813),
    [sym_block_comment] = STATE(1813),
    [sym_line_comment] = STATE(1813),
    [sym_compiler_directive_decl] = STATE(1813),
    [sym_fsi_directive_decl] = STATE(1813),
    [sym_preproc_line] = STATE(1813),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_with] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_DOT_DOT2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
    [sym__dedent] = ACTIONS(3707),
  },
  [1814] = {
    [sym_xml_doc] = STATE(1814),
    [sym_block_comment] = STATE(1814),
    [sym_line_comment] = STATE(1814),
    [sym_compiler_directive_decl] = STATE(1814),
    [sym_fsi_directive_decl] = STATE(1814),
    [sym_preproc_line] = STATE(1814),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_with] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_DOT_DOT2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
    [sym__dedent] = ACTIONS(3587),
  },
  [1815] = {
    [sym_xml_doc] = STATE(1815),
    [sym_block_comment] = STATE(1815),
    [sym_line_comment] = STATE(1815),
    [sym_compiler_directive_decl] = STATE(1815),
    [sym_fsi_directive_decl] = STATE(1815),
    [sym_preproc_line] = STATE(1815),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_with] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_DOT_DOT2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
    [sym__dedent] = ACTIONS(3583),
  },
  [1816] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5583),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2242),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(3884),
    [sym_format_string] = STATE(3883),
    [sym__string_literal] = STATE(3883),
    [sym_string] = STATE(3884),
    [sym_verbatim_string] = STATE(3884),
    [sym_bytearray] = STATE(3884),
    [sym_verbatim_bytearray] = STATE(3884),
    [sym_format_triple_quoted_string] = STATE(3882),
    [sym_triple_quoted_string] = STATE(3884),
    [sym_const] = STATE(3923),
    [sym_long_identifier] = STATE(3753),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(3884),
    [sym_byte] = STATE(3884),
    [sym_int16] = STATE(3884),
    [sym_uint16] = STATE(3884),
    [sym_int32] = STATE(3884),
    [sym_uint32] = STATE(3884),
    [sym_nativeint] = STATE(3884),
    [sym_unativeint] = STATE(3884),
    [sym_int64] = STATE(3884),
    [sym_uint64] = STATE(3884),
    [sym_ieee32] = STATE(3884),
    [sym_ieee64] = STATE(3884),
    [sym_bignum] = STATE(3884),
    [sym_decimal] = STATE(3884),
    [sym_float] = STATE(3697),
    [sym_xml_doc] = STATE(1816),
    [sym_block_comment] = STATE(1816),
    [sym_line_comment] = STATE(1816),
    [sym_compiler_directive_decl] = STATE(1816),
    [sym_fsi_directive_decl] = STATE(1816),
    [sym_preproc_line] = STATE(1816),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4525),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [anon_sym_DASH_GT] = ACTIONS(4523),
    [anon_sym_when] = ACTIONS(4519),
    [aux_sym_char_token1] = ACTIONS(4539),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4541),
    [anon_sym_DQUOTE] = ACTIONS(4543),
    [anon_sym_AT_DQUOTE] = ACTIONS(4545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4547),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4549),
    [sym_bool] = ACTIONS(4551),
    [sym_unit] = ACTIONS(4553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4559),
    [sym_xint] = ACTIONS(4561),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [1817] = {
    [sym_xml_doc] = STATE(1817),
    [sym_block_comment] = STATE(1817),
    [sym_line_comment] = STATE(1817),
    [sym_compiler_directive_decl] = STATE(1817),
    [sym_fsi_directive_decl] = STATE(1817),
    [sym_preproc_line] = STATE(1817),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_AT_AT_GT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1818] = {
    [sym_xml_doc] = STATE(1818),
    [sym_block_comment] = STATE(1818),
    [sym_line_comment] = STATE(1818),
    [sym_compiler_directive_decl] = STATE(1818),
    [sym_fsi_directive_decl] = STATE(1818),
    [sym_preproc_line] = STATE(1818),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_DOT_DOT2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
    [sym__dedent] = ACTIONS(3776),
  },
  [1819] = {
    [sym_xml_doc] = STATE(1819),
    [sym_block_comment] = STATE(1819),
    [sym_line_comment] = STATE(1819),
    [sym_compiler_directive_decl] = STATE(1819),
    [sym_fsi_directive_decl] = STATE(1819),
    [sym_preproc_line] = STATE(1819),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_DOT_DOT2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
    [sym__dedent] = ACTIONS(3604),
  },
  [1820] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5438),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym__pattern_param] = STATE(2164),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(3858),
    [sym_format_string] = STATE(3857),
    [sym__string_literal] = STATE(3857),
    [sym_string] = STATE(3858),
    [sym_verbatim_string] = STATE(3858),
    [sym_bytearray] = STATE(3858),
    [sym_verbatim_bytearray] = STATE(3858),
    [sym_format_triple_quoted_string] = STATE(3854),
    [sym_triple_quoted_string] = STATE(3858),
    [sym_const] = STATE(3895),
    [sym_long_identifier] = STATE(3769),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(3858),
    [sym_byte] = STATE(3858),
    [sym_int16] = STATE(3858),
    [sym_uint16] = STATE(3858),
    [sym_int32] = STATE(3858),
    [sym_uint32] = STATE(3858),
    [sym_nativeint] = STATE(3858),
    [sym_unativeint] = STATE(3858),
    [sym_int64] = STATE(3858),
    [sym_uint64] = STATE(3858),
    [sym_ieee32] = STATE(3858),
    [sym_ieee64] = STATE(3858),
    [sym_bignum] = STATE(3858),
    [sym_decimal] = STATE(3858),
    [sym_float] = STATE(3721),
    [sym_xml_doc] = STATE(1820),
    [sym_block_comment] = STATE(1820),
    [sym_line_comment] = STATE(1820),
    [sym_compiler_directive_decl] = STATE(1820),
    [sym_fsi_directive_decl] = STATE(1820),
    [sym_preproc_line] = STATE(1820),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4567),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4581),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4583),
    [anon_sym_DQUOTE] = ACTIONS(4585),
    [anon_sym_AT_DQUOTE] = ACTIONS(4587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4589),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4591),
    [sym_bool] = ACTIONS(4593),
    [sym_unit] = ACTIONS(4595),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4601),
    [sym_xint] = ACTIONS(4603),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [sym__newline] = ACTIONS(4523),
    [sym__dedent] = ACTIONS(4523),
  },
  [1821] = {
    [sym_xml_doc] = STATE(1821),
    [sym_block_comment] = STATE(1821),
    [sym_line_comment] = STATE(1821),
    [sym_compiler_directive_decl] = STATE(1821),
    [sym_fsi_directive_decl] = STATE(1821),
    [sym_preproc_line] = STATE(1821),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3616),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_DOT_DOT2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
    [sym__dedent] = ACTIONS(3618),
  },
  [1822] = {
    [sym_xml_doc] = STATE(1822),
    [sym_block_comment] = STATE(1822),
    [sym_line_comment] = STATE(1822),
    [sym_compiler_directive_decl] = STATE(1822),
    [sym_fsi_directive_decl] = STATE(1822),
    [sym_preproc_line] = STATE(1822),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [anon_sym_POUNDelse] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1823] = {
    [sym_xml_doc] = STATE(1823),
    [sym_block_comment] = STATE(1823),
    [sym_line_comment] = STATE(1823),
    [sym_compiler_directive_decl] = STATE(1823),
    [sym_fsi_directive_decl] = STATE(1823),
    [sym_preproc_line] = STATE(1823),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_with] = ACTIONS(3656),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_DOT_DOT2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
    [sym__dedent] = ACTIONS(3658),
  },
  [1824] = {
    [sym_xml_doc] = STATE(1824),
    [sym_block_comment] = STATE(1824),
    [sym_line_comment] = STATE(1824),
    [sym_compiler_directive_decl] = STATE(1824),
    [sym_fsi_directive_decl] = STATE(1824),
    [sym_preproc_line] = STATE(1824),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_with] = ACTIONS(3660),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_DOT_DOT2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
    [sym__dedent] = ACTIONS(3662),
  },
  [1825] = {
    [sym_xml_doc] = STATE(1825),
    [sym_block_comment] = STATE(1825),
    [sym_line_comment] = STATE(1825),
    [sym_compiler_directive_decl] = STATE(1825),
    [sym_fsi_directive_decl] = STATE(1825),
    [sym_preproc_line] = STATE(1825),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_DOT_DOT2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
    [sym__dedent] = ACTIONS(3695),
  },
  [1826] = {
    [sym_xml_doc] = STATE(1826),
    [sym_block_comment] = STATE(1826),
    [sym_line_comment] = STATE(1826),
    [sym_compiler_directive_decl] = STATE(1826),
    [sym_fsi_directive_decl] = STATE(1826),
    [sym_preproc_line] = STATE(1826),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_with] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_DOT_DOT2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
    [sym__dedent] = ACTIONS(3724),
  },
  [1827] = {
    [sym_xml_doc] = STATE(1827),
    [sym_block_comment] = STATE(1827),
    [sym_line_comment] = STATE(1827),
    [sym_compiler_directive_decl] = STATE(1827),
    [sym_fsi_directive_decl] = STATE(1827),
    [sym_preproc_line] = STATE(1827),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_DOT_DOT2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
    [sym__dedent] = ACTIONS(3728),
  },
  [1828] = {
    [sym_xml_doc] = STATE(1828),
    [sym_block_comment] = STATE(1828),
    [sym_line_comment] = STATE(1828),
    [sym_compiler_directive_decl] = STATE(1828),
    [sym_fsi_directive_decl] = STATE(1828),
    [sym_preproc_line] = STATE(1828),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_DOT_DOT2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
    [sym__dedent] = ACTIONS(3736),
  },
  [1829] = {
    [sym_xml_doc] = STATE(1829),
    [sym_block_comment] = STATE(1829),
    [sym_line_comment] = STATE(1829),
    [sym_compiler_directive_decl] = STATE(1829),
    [sym_fsi_directive_decl] = STATE(1829),
    [sym_preproc_line] = STATE(1829),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_DOT_DOT] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4605),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1830] = {
    [sym_xml_doc] = STATE(1830),
    [sym_block_comment] = STATE(1830),
    [sym_line_comment] = STATE(1830),
    [sym_compiler_directive_decl] = STATE(1830),
    [sym_fsi_directive_decl] = STATE(1830),
    [sym_preproc_line] = STATE(1830),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_AT_AT_GT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3208),
    [aux_sym_decimal_token1] = ACTIONS(3148),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1831] = {
    [sym_xml_doc] = STATE(1831),
    [sym_block_comment] = STATE(1831),
    [sym_line_comment] = STATE(1831),
    [sym_compiler_directive_decl] = STATE(1831),
    [sym_fsi_directive_decl] = STATE(1831),
    [sym_preproc_line] = STATE(1831),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3738),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_DOT_DOT2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
    [sym__dedent] = ACTIONS(3740),
  },
  [1832] = {
    [sym_xml_doc] = STATE(1832),
    [sym_block_comment] = STATE(1832),
    [sym_line_comment] = STATE(1832),
    [sym_compiler_directive_decl] = STATE(1832),
    [sym_fsi_directive_decl] = STATE(1832),
    [sym_preproc_line] = STATE(1832),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_with] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_DOT_DOT2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
    [sym__dedent] = ACTIONS(3748),
  },
  [1833] = {
    [sym_xml_doc] = STATE(1833),
    [sym_block_comment] = STATE(1833),
    [sym_line_comment] = STATE(1833),
    [sym_compiler_directive_decl] = STATE(1833),
    [sym_fsi_directive_decl] = STATE(1833),
    [sym_preproc_line] = STATE(1833),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_with] = ACTIONS(3766),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_DOT_DOT2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
    [sym__dedent] = ACTIONS(3768),
  },
  [1834] = {
    [sym_xml_doc] = STATE(1834),
    [sym_block_comment] = STATE(1834),
    [sym_line_comment] = STATE(1834),
    [sym_compiler_directive_decl] = STATE(1834),
    [sym_fsi_directive_decl] = STATE(1834),
    [sym_preproc_line] = STATE(1834),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_with] = ACTIONS(3770),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_DOT_DOT2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
    [sym__dedent] = ACTIONS(3772),
  },
  [1835] = {
    [sym_xml_doc] = STATE(1835),
    [sym_block_comment] = STATE(1835),
    [sym_line_comment] = STATE(1835),
    [sym_compiler_directive_decl] = STATE(1835),
    [sym_fsi_directive_decl] = STATE(1835),
    [sym_preproc_line] = STATE(1835),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_with] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_DOT_DOT2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
    [sym__dedent] = ACTIONS(3579),
  },
  [1836] = {
    [sym_xml_doc] = STATE(1836),
    [sym_block_comment] = STATE(1836),
    [sym_line_comment] = STATE(1836),
    [sym_compiler_directive_decl] = STATE(1836),
    [sym_fsi_directive_decl] = STATE(1836),
    [sym_preproc_line] = STATE(1836),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_with] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_DOT_DOT2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
    [sym__dedent] = ACTIONS(3780),
  },
  [1837] = {
    [sym_xml_doc] = STATE(1837),
    [sym_block_comment] = STATE(1837),
    [sym_line_comment] = STATE(1837),
    [sym_compiler_directive_decl] = STATE(1837),
    [sym_fsi_directive_decl] = STATE(1837),
    [sym_preproc_line] = STATE(1837),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_with] = ACTIONS(3782),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_DOT_DOT2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
    [sym__dedent] = ACTIONS(3784),
  },
  [1838] = {
    [sym_xml_doc] = STATE(1838),
    [sym_block_comment] = STATE(1838),
    [sym_line_comment] = STATE(1838),
    [sym_compiler_directive_decl] = STATE(1838),
    [sym_fsi_directive_decl] = STATE(1838),
    [sym_preproc_line] = STATE(1838),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_with] = ACTIONS(3786),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_DOT_DOT2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
    [sym__dedent] = ACTIONS(3788),
  },
  [1839] = {
    [sym_xml_doc] = STATE(1839),
    [sym_block_comment] = STATE(1839),
    [sym_line_comment] = STATE(1839),
    [sym_compiler_directive_decl] = STATE(1839),
    [sym_fsi_directive_decl] = STATE(1839),
    [sym_preproc_line] = STATE(1839),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_with] = ACTIONS(3790),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_DOT_DOT2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
    [sym__dedent] = ACTIONS(3792),
  },
  [1840] = {
    [sym_xml_doc] = STATE(1840),
    [sym_block_comment] = STATE(1840),
    [sym_line_comment] = STATE(1840),
    [sym_compiler_directive_decl] = STATE(1840),
    [sym_fsi_directive_decl] = STATE(1840),
    [sym_preproc_line] = STATE(1840),
    [aux_sym_long_identifier_repeat1] = STATE(1840),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3285),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4607),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [anon_sym_EQ2] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1841] = {
    [sym_xml_doc] = STATE(1841),
    [sym_block_comment] = STATE(1841),
    [sym_line_comment] = STATE(1841),
    [sym_compiler_directive_decl] = STATE(1841),
    [sym_fsi_directive_decl] = STATE(1841),
    [sym_preproc_line] = STATE(1841),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_DOT_DOT2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
    [sym__dedent] = ACTIONS(3800),
  },
  [1842] = {
    [sym_xml_doc] = STATE(1842),
    [sym_block_comment] = STATE(1842),
    [sym_line_comment] = STATE(1842),
    [sym_compiler_directive_decl] = STATE(1842),
    [sym_fsi_directive_decl] = STATE(1842),
    [sym_preproc_line] = STATE(1842),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_with] = ACTIONS(3802),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_DOT_DOT2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
    [sym__dedent] = ACTIONS(3804),
  },
  [1843] = {
    [sym_xml_doc] = STATE(1843),
    [sym_block_comment] = STATE(1843),
    [sym_line_comment] = STATE(1843),
    [sym_compiler_directive_decl] = STATE(1843),
    [sym_fsi_directive_decl] = STATE(1843),
    [sym_preproc_line] = STATE(1843),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1844] = {
    [sym_xml_doc] = STATE(1844),
    [sym_block_comment] = STATE(1844),
    [sym_line_comment] = STATE(1844),
    [sym_compiler_directive_decl] = STATE(1844),
    [sym_fsi_directive_decl] = STATE(1844),
    [sym_preproc_line] = STATE(1844),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4610),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1845] = {
    [sym_xml_doc] = STATE(1845),
    [sym_block_comment] = STATE(1845),
    [sym_line_comment] = STATE(1845),
    [sym_compiler_directive_decl] = STATE(1845),
    [sym_fsi_directive_decl] = STATE(1845),
    [sym_preproc_line] = STATE(1845),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_AT_GT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4612),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1846] = {
    [sym_xml_doc] = STATE(1846),
    [sym_block_comment] = STATE(1846),
    [sym_line_comment] = STATE(1846),
    [sym_compiler_directive_decl] = STATE(1846),
    [sym_fsi_directive_decl] = STATE(1846),
    [sym_preproc_line] = STATE(1846),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_DOT_DOT2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1847] = {
    [sym_xml_doc] = STATE(1847),
    [sym_block_comment] = STATE(1847),
    [sym_line_comment] = STATE(1847),
    [sym_compiler_directive_decl] = STATE(1847),
    [sym_fsi_directive_decl] = STATE(1847),
    [sym_preproc_line] = STATE(1847),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_with] = ACTIONS(3825),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_DOT_DOT2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
    [sym__dedent] = ACTIONS(3827),
  },
  [1848] = {
    [sym_xml_doc] = STATE(1848),
    [sym_block_comment] = STATE(1848),
    [sym_line_comment] = STATE(1848),
    [sym_compiler_directive_decl] = STATE(1848),
    [sym_fsi_directive_decl] = STATE(1848),
    [sym_preproc_line] = STATE(1848),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_with] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_DOT_DOT2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
    [sym__dedent] = ACTIONS(3838),
  },
  [1849] = {
    [sym_xml_doc] = STATE(1849),
    [sym_block_comment] = STATE(1849),
    [sym_line_comment] = STATE(1849),
    [sym_compiler_directive_decl] = STATE(1849),
    [sym_fsi_directive_decl] = STATE(1849),
    [sym_preproc_line] = STATE(1849),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_with] = ACTIONS(3608),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_DOT_DOT2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
    [sym__dedent] = ACTIONS(3610),
  },
  [1850] = {
    [sym_xml_doc] = STATE(1850),
    [sym_block_comment] = STATE(1850),
    [sym_line_comment] = STATE(1850),
    [sym_compiler_directive_decl] = STATE(1850),
    [sym_fsi_directive_decl] = STATE(1850),
    [sym_preproc_line] = STATE(1850),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [1851] = {
    [sym_xml_doc] = STATE(1851),
    [sym_block_comment] = STATE(1851),
    [sym_line_comment] = STATE(1851),
    [sym_compiler_directive_decl] = STATE(1851),
    [sym_fsi_directive_decl] = STATE(1851),
    [sym_preproc_line] = STATE(1851),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_with] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_DOT_DOT2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
    [sym__dedent] = ACTIONS(3842),
  },
  [1852] = {
    [sym_xml_doc] = STATE(1852),
    [sym_block_comment] = STATE(1852),
    [sym_line_comment] = STATE(1852),
    [sym_compiler_directive_decl] = STATE(1852),
    [sym_fsi_directive_decl] = STATE(1852),
    [sym_preproc_line] = STATE(1852),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4614),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [anon_sym_POUNDendif] = ACTIONS(3556),
    [anon_sym_POUNDelse] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [1853] = {
    [sym_xml_doc] = STATE(1853),
    [sym_block_comment] = STATE(1853),
    [sym_line_comment] = STATE(1853),
    [sym_compiler_directive_decl] = STATE(1853),
    [sym_fsi_directive_decl] = STATE(1853),
    [sym_preproc_line] = STATE(1853),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3238),
    [aux_sym_decimal_token1] = ACTIONS(3180),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1854] = {
    [sym_xml_doc] = STATE(1854),
    [sym_block_comment] = STATE(1854),
    [sym_line_comment] = STATE(1854),
    [sym_compiler_directive_decl] = STATE(1854),
    [sym_fsi_directive_decl] = STATE(1854),
    [sym_preproc_line] = STATE(1854),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1855] = {
    [sym_xml_doc] = STATE(1855),
    [sym_block_comment] = STATE(1855),
    [sym_line_comment] = STATE(1855),
    [sym_compiler_directive_decl] = STATE(1855),
    [sym_fsi_directive_decl] = STATE(1855),
    [sym_preproc_line] = STATE(1855),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4401),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [anon_sym_POUNDelse] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1856] = {
    [sym_xml_doc] = STATE(1856),
    [sym_block_comment] = STATE(1856),
    [sym_line_comment] = STATE(1856),
    [sym_compiler_directive_decl] = STATE(1856),
    [sym_fsi_directive_decl] = STATE(1856),
    [sym_preproc_line] = STATE(1856),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1857] = {
    [sym_xml_doc] = STATE(1857),
    [sym_block_comment] = STATE(1857),
    [sym_line_comment] = STATE(1857),
    [sym_compiler_directive_decl] = STATE(1857),
    [sym_fsi_directive_decl] = STATE(1857),
    [sym_preproc_line] = STATE(1857),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_AT_GT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1858] = {
    [sym_xml_doc] = STATE(1858),
    [sym_block_comment] = STATE(1858),
    [sym_line_comment] = STATE(1858),
    [sym_compiler_directive_decl] = STATE(1858),
    [sym_fsi_directive_decl] = STATE(1858),
    [sym_preproc_line] = STATE(1858),
    [aux_sym_sequential_expression_repeat1] = STATE(1858),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_RBRACK] = ACTIONS(3831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_DOT_DOT2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4616),
  },
  [1859] = {
    [sym_xml_doc] = STATE(1859),
    [sym_block_comment] = STATE(1859),
    [sym_line_comment] = STATE(1859),
    [sym_compiler_directive_decl] = STATE(1859),
    [sym_fsi_directive_decl] = STATE(1859),
    [sym_preproc_line] = STATE(1859),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1860] = {
    [sym_xml_doc] = STATE(1860),
    [sym_block_comment] = STATE(1860),
    [sym_line_comment] = STATE(1860),
    [sym_compiler_directive_decl] = STATE(1860),
    [sym_fsi_directive_decl] = STATE(1860),
    [sym_preproc_line] = STATE(1860),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_as] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_with] = ACTIONS(3542),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [1861] = {
    [sym_xml_doc] = STATE(1861),
    [sym_block_comment] = STATE(1861),
    [sym_line_comment] = STATE(1861),
    [sym_compiler_directive_decl] = STATE(1861),
    [sym_fsi_directive_decl] = STATE(1861),
    [sym_preproc_line] = STATE(1861),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_with] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1862] = {
    [sym_xml_doc] = STATE(1862),
    [sym_block_comment] = STATE(1862),
    [sym_line_comment] = STATE(1862),
    [sym_compiler_directive_decl] = STATE(1862),
    [sym_fsi_directive_decl] = STATE(1862),
    [sym_preproc_line] = STATE(1862),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3216),
    [aux_sym_decimal_token1] = ACTIONS(3056),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1863] = {
    [sym_xml_doc] = STATE(1863),
    [sym_block_comment] = STATE(1863),
    [sym_line_comment] = STATE(1863),
    [sym_compiler_directive_decl] = STATE(1863),
    [sym_fsi_directive_decl] = STATE(1863),
    [sym_preproc_line] = STATE(1863),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4619),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [anon_sym_POUNDendif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1864] = {
    [sym_xml_doc] = STATE(1864),
    [sym_block_comment] = STATE(1864),
    [sym_line_comment] = STATE(1864),
    [sym_compiler_directive_decl] = STATE(1864),
    [sym_fsi_directive_decl] = STATE(1864),
    [sym_preproc_line] = STATE(1864),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1865] = {
    [sym_xml_doc] = STATE(1865),
    [sym_block_comment] = STATE(1865),
    [sym_line_comment] = STATE(1865),
    [sym_compiler_directive_decl] = STATE(1865),
    [sym_fsi_directive_decl] = STATE(1865),
    [sym_preproc_line] = STATE(1865),
    [aux_sym_long_identifier_repeat1] = STATE(1802),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4621),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1866] = {
    [sym_xml_doc] = STATE(1866),
    [sym_block_comment] = STATE(1866),
    [sym_line_comment] = STATE(1866),
    [sym_compiler_directive_decl] = STATE(1866),
    [sym_fsi_directive_decl] = STATE(1866),
    [sym_preproc_line] = STATE(1866),
    [aux_sym_rules_repeat1] = STATE(1810),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4507),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_DOT_DOT] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4625),
  },
  [1867] = {
    [sym_xml_doc] = STATE(1867),
    [sym_block_comment] = STATE(1867),
    [sym_line_comment] = STATE(1867),
    [sym_compiler_directive_decl] = STATE(1867),
    [sym_fsi_directive_decl] = STATE(1867),
    [sym_preproc_line] = STATE(1867),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4628),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [anon_sym_POUNDendif] = ACTIONS(3529),
    [anon_sym_POUNDelse] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1868] = {
    [sym_xml_doc] = STATE(1868),
    [sym_block_comment] = STATE(1868),
    [sym_line_comment] = STATE(1868),
    [sym_compiler_directive_decl] = STATE(1868),
    [sym_fsi_directive_decl] = STATE(1868),
    [sym_preproc_line] = STATE(1868),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4453),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_DASH_GT] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1869] = {
    [sym_xml_doc] = STATE(1869),
    [sym_block_comment] = STATE(1869),
    [sym_line_comment] = STATE(1869),
    [sym_compiler_directive_decl] = STATE(1869),
    [sym_fsi_directive_decl] = STATE(1869),
    [sym_preproc_line] = STATE(1869),
    [aux_sym_rules_repeat1] = STATE(1904),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_AT_AT_GT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4630),
  },
  [1870] = {
    [sym_xml_doc] = STATE(1870),
    [sym_block_comment] = STATE(1870),
    [sym_line_comment] = STATE(1870),
    [sym_compiler_directive_decl] = STATE(1870),
    [sym_fsi_directive_decl] = STATE(1870),
    [sym_preproc_line] = STATE(1870),
    [aux_sym_rules_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_AT_AT_GT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4630),
  },
  [1871] = {
    [sym_xml_doc] = STATE(1871),
    [sym_block_comment] = STATE(1871),
    [sym_line_comment] = STATE(1871),
    [sym_compiler_directive_decl] = STATE(1871),
    [sym_fsi_directive_decl] = STATE(1871),
    [sym_preproc_line] = STATE(1871),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_AT_AT_GT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1872] = {
    [sym_xml_doc] = STATE(1872),
    [sym_block_comment] = STATE(1872),
    [sym_line_comment] = STATE(1872),
    [sym_compiler_directive_decl] = STATE(1872),
    [sym_fsi_directive_decl] = STATE(1872),
    [sym_preproc_line] = STATE(1872),
    [aux_sym_long_identifier_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4633),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [anon_sym_POUNDelse] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [1873] = {
    [sym_xml_doc] = STATE(1873),
    [sym_block_comment] = STATE(1873),
    [sym_line_comment] = STATE(1873),
    [sym_compiler_directive_decl] = STATE(1873),
    [sym_fsi_directive_decl] = STATE(1873),
    [sym_preproc_line] = STATE(1873),
    [aux_sym_sequential_expression_repeat1] = STATE(1873),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_with] = ACTIONS(3829),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4636),
    [sym__dedent] = ACTIONS(3831),
  },
  [1874] = {
    [sym_xml_doc] = STATE(1874),
    [sym_block_comment] = STATE(1874),
    [sym_line_comment] = STATE(1874),
    [sym_compiler_directive_decl] = STATE(1874),
    [sym_fsi_directive_decl] = STATE(1874),
    [sym_preproc_line] = STATE(1874),
    [aux_sym_sequential_expression_repeat1] = STATE(1858),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_RBRACK] = ACTIONS(3614),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_DOT_DOT2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1875] = {
    [sym_xml_doc] = STATE(1875),
    [sym_block_comment] = STATE(1875),
    [sym_line_comment] = STATE(1875),
    [sym_compiler_directive_decl] = STATE(1875),
    [sym_fsi_directive_decl] = STATE(1875),
    [sym_preproc_line] = STATE(1875),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_AT_GT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(3234),
    [aux_sym_decimal_token1] = ACTIONS(3084),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [1876] = {
    [sym_xml_doc] = STATE(1876),
    [sym_block_comment] = STATE(1876),
    [sym_line_comment] = STATE(1876),
    [sym_compiler_directive_decl] = STATE(1876),
    [sym_fsi_directive_decl] = STATE(1876),
    [sym_preproc_line] = STATE(1876),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1877] = {
    [sym_xml_doc] = STATE(1877),
    [sym_block_comment] = STATE(1877),
    [sym_line_comment] = STATE(1877),
    [sym_compiler_directive_decl] = STATE(1877),
    [sym_fsi_directive_decl] = STATE(1877),
    [sym_preproc_line] = STATE(1877),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [anon_sym_POUNDendif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [1878] = {
    [sym_xml_doc] = STATE(1878),
    [sym_block_comment] = STATE(1878),
    [sym_line_comment] = STATE(1878),
    [sym_compiler_directive_decl] = STATE(1878),
    [sym_fsi_directive_decl] = STATE(1878),
    [sym_preproc_line] = STATE(1878),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1879] = {
    [sym_xml_doc] = STATE(1879),
    [sym_block_comment] = STATE(1879),
    [sym_line_comment] = STATE(1879),
    [sym_compiler_directive_decl] = STATE(1879),
    [sym_fsi_directive_decl] = STATE(1879),
    [sym_preproc_line] = STATE(1879),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1880] = {
    [sym_xml_doc] = STATE(1880),
    [sym_block_comment] = STATE(1880),
    [sym_line_comment] = STATE(1880),
    [sym_compiler_directive_decl] = STATE(1880),
    [sym_fsi_directive_decl] = STATE(1880),
    [sym_preproc_line] = STATE(1880),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_AT_AT_GT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1881] = {
    [sym_xml_doc] = STATE(1881),
    [sym_block_comment] = STATE(1881),
    [sym_line_comment] = STATE(1881),
    [sym_compiler_directive_decl] = STATE(1881),
    [sym_fsi_directive_decl] = STATE(1881),
    [sym_preproc_line] = STATE(1881),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_as] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_with] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
    [sym__dedent] = ACTIONS(3849),
  },
  [1882] = {
    [sym_xml_doc] = STATE(1882),
    [sym_block_comment] = STATE(1882),
    [sym_line_comment] = STATE(1882),
    [sym_compiler_directive_decl] = STATE(1882),
    [sym_fsi_directive_decl] = STATE(1882),
    [sym_preproc_line] = STATE(1882),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [1883] = {
    [sym_xml_doc] = STATE(1883),
    [sym_block_comment] = STATE(1883),
    [sym_line_comment] = STATE(1883),
    [sym_compiler_directive_decl] = STATE(1883),
    [sym_fsi_directive_decl] = STATE(1883),
    [sym_preproc_line] = STATE(1883),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4639),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_DOT_DOT] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [1884] = {
    [sym_xml_doc] = STATE(1884),
    [sym_block_comment] = STATE(1884),
    [sym_line_comment] = STATE(1884),
    [sym_compiler_directive_decl] = STATE(1884),
    [sym_fsi_directive_decl] = STATE(1884),
    [sym_preproc_line] = STATE(1884),
    [aux_sym_long_identifier_repeat1] = STATE(1840),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [anon_sym_EQ2] = ACTIONS(3204),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [1885] = {
    [sym_xml_doc] = STATE(1885),
    [sym_block_comment] = STATE(1885),
    [sym_line_comment] = STATE(1885),
    [sym_compiler_directive_decl] = STATE(1885),
    [sym_fsi_directive_decl] = STATE(1885),
    [sym_preproc_line] = STATE(1885),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_as] = ACTIONS(3863),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
    [sym__dedent] = ACTIONS(3865),
  },
  [1886] = {
    [sym_xml_doc] = STATE(1886),
    [sym_block_comment] = STATE(1886),
    [sym_line_comment] = STATE(1886),
    [sym_compiler_directive_decl] = STATE(1886),
    [sym_fsi_directive_decl] = STATE(1886),
    [sym_preproc_line] = STATE(1886),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_with] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
    [sym__dedent] = ACTIONS(3880),
  },
  [1887] = {
    [sym_xml_doc] = STATE(1887),
    [sym_block_comment] = STATE(1887),
    [sym_line_comment] = STATE(1887),
    [sym_compiler_directive_decl] = STATE(1887),
    [sym_fsi_directive_decl] = STATE(1887),
    [sym_preproc_line] = STATE(1887),
    [aux_sym_sequential_expression_repeat1] = STATE(1768),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [anon_sym_POUNDendif] = ACTIONS(3614),
    [anon_sym_POUNDelse] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1888] = {
    [sym_xml_doc] = STATE(1888),
    [sym_block_comment] = STATE(1888),
    [sym_line_comment] = STATE(1888),
    [sym_compiler_directive_decl] = STATE(1888),
    [sym_fsi_directive_decl] = STATE(1888),
    [sym_preproc_line] = STATE(1888),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_as] = ACTIONS(3884),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_with] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
    [sym__dedent] = ACTIONS(3886),
  },
  [1889] = {
    [sym_xml_doc] = STATE(1889),
    [sym_block_comment] = STATE(1889),
    [sym_line_comment] = STATE(1889),
    [sym_compiler_directive_decl] = STATE(1889),
    [sym_fsi_directive_decl] = STATE(1889),
    [sym_preproc_line] = STATE(1889),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [anon_sym_POUNDendif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1890] = {
    [sym_xml_doc] = STATE(1890),
    [sym_block_comment] = STATE(1890),
    [sym_line_comment] = STATE(1890),
    [sym_compiler_directive_decl] = STATE(1890),
    [sym_fsi_directive_decl] = STATE(1890),
    [sym_preproc_line] = STATE(1890),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_as] = ACTIONS(3888),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_with] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
    [sym__dedent] = ACTIONS(3890),
  },
  [1891] = {
    [sym_xml_doc] = STATE(1891),
    [sym_block_comment] = STATE(1891),
    [sym_line_comment] = STATE(1891),
    [sym_compiler_directive_decl] = STATE(1891),
    [sym_fsi_directive_decl] = STATE(1891),
    [sym_preproc_line] = STATE(1891),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_as] = ACTIONS(3840),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_with] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
    [sym__dedent] = ACTIONS(3842),
  },
  [1892] = {
    [sym_xml_doc] = STATE(1892),
    [sym_block_comment] = STATE(1892),
    [sym_line_comment] = STATE(1892),
    [sym_compiler_directive_decl] = STATE(1892),
    [sym_fsi_directive_decl] = STATE(1892),
    [sym_preproc_line] = STATE(1892),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_as] = ACTIONS(3895),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_with] = ACTIONS(3895),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
    [sym__dedent] = ACTIONS(3897),
  },
  [1893] = {
    [sym_xml_doc] = STATE(1893),
    [sym_block_comment] = STATE(1893),
    [sym_line_comment] = STATE(1893),
    [sym_compiler_directive_decl] = STATE(1893),
    [sym_fsi_directive_decl] = STATE(1893),
    [sym_preproc_line] = STATE(1893),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3899),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3899),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
    [sym__dedent] = ACTIONS(3901),
  },
  [1894] = {
    [sym_xml_doc] = STATE(1894),
    [sym_block_comment] = STATE(1894),
    [sym_line_comment] = STATE(1894),
    [sym_compiler_directive_decl] = STATE(1894),
    [sym_fsi_directive_decl] = STATE(1894),
    [sym_preproc_line] = STATE(1894),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
    [sym__dedent] = ACTIONS(2770),
  },
  [1895] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5482),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2057),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(1895),
    [sym_block_comment] = STATE(1895),
    [sym_line_comment] = STATE(1895),
    [sym_compiler_directive_decl] = STATE(1895),
    [sym_fsi_directive_decl] = STATE(1895),
    [sym_preproc_line] = STATE(1895),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4645),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [anon_sym_LT2] = ACTIONS(4523),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [1896] = {
    [sym_xml_doc] = STATE(1896),
    [sym_block_comment] = STATE(1896),
    [sym_line_comment] = STATE(1896),
    [sym_compiler_directive_decl] = STATE(1896),
    [sym_fsi_directive_decl] = STATE(1896),
    [sym_preproc_line] = STATE(1896),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_as] = ACTIONS(3906),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_with] = ACTIONS(3906),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
    [sym__dedent] = ACTIONS(3908),
  },
  [1897] = {
    [sym_xml_doc] = STATE(1897),
    [sym_block_comment] = STATE(1897),
    [sym_line_comment] = STATE(1897),
    [sym_compiler_directive_decl] = STATE(1897),
    [sym_fsi_directive_decl] = STATE(1897),
    [sym_preproc_line] = STATE(1897),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_as] = ACTIONS(3598),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_with] = ACTIONS(3598),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
    [sym__dedent] = ACTIONS(3600),
  },
  [1898] = {
    [sym_xml_doc] = STATE(1898),
    [sym_block_comment] = STATE(1898),
    [sym_line_comment] = STATE(1898),
    [sym_compiler_directive_decl] = STATE(1898),
    [sym_fsi_directive_decl] = STATE(1898),
    [sym_preproc_line] = STATE(1898),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
    [sym__dedent] = ACTIONS(3703),
  },
  [1899] = {
    [sym_xml_doc] = STATE(1899),
    [sym_block_comment] = STATE(1899),
    [sym_line_comment] = STATE(1899),
    [sym_compiler_directive_decl] = STATE(1899),
    [sym_fsi_directive_decl] = STATE(1899),
    [sym_preproc_line] = STATE(1899),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_as] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_with] = ACTIONS(3914),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
    [sym__dedent] = ACTIONS(3916),
  },
  [1900] = {
    [sym_xml_doc] = STATE(1900),
    [sym_block_comment] = STATE(1900),
    [sym_line_comment] = STATE(1900),
    [sym_compiler_directive_decl] = STATE(1900),
    [sym_fsi_directive_decl] = STATE(1900),
    [sym_preproc_line] = STATE(1900),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_as] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
    [sym__dedent] = ACTIONS(3927),
  },
  [1901] = {
    [sym_xml_doc] = STATE(1901),
    [sym_block_comment] = STATE(1901),
    [sym_line_comment] = STATE(1901),
    [sym_compiler_directive_decl] = STATE(1901),
    [sym_fsi_directive_decl] = STATE(1901),
    [sym_preproc_line] = STATE(1901),
    [aux_sym_long_identifier_repeat1] = STATE(1757),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4677),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_DASH_GT] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_DOT_DOT] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [1902] = {
    [sym_xml_doc] = STATE(1902),
    [sym_block_comment] = STATE(1902),
    [sym_line_comment] = STATE(1902),
    [sym_compiler_directive_decl] = STATE(1902),
    [sym_fsi_directive_decl] = STATE(1902),
    [sym_preproc_line] = STATE(1902),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_as] = ACTIONS(3836),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_with] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
    [sym__dedent] = ACTIONS(3838),
  },
  [1903] = {
    [sym_xml_doc] = STATE(1903),
    [sym_block_comment] = STATE(1903),
    [sym_line_comment] = STATE(1903),
    [sym_compiler_directive_decl] = STATE(1903),
    [sym_fsi_directive_decl] = STATE(1903),
    [sym_preproc_line] = STATE(1903),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
    [sym__dedent] = ACTIONS(3935),
  },
  [1904] = {
    [sym_xml_doc] = STATE(1904),
    [sym_block_comment] = STATE(1904),
    [sym_line_comment] = STATE(1904),
    [sym_compiler_directive_decl] = STATE(1904),
    [sym_fsi_directive_decl] = STATE(1904),
    [sym_preproc_line] = STATE(1904),
    [aux_sym_rules_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_AT_AT_GT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4681),
  },
  [1905] = {
    [sym_xml_doc] = STATE(1905),
    [sym_block_comment] = STATE(1905),
    [sym_line_comment] = STATE(1905),
    [sym_compiler_directive_decl] = STATE(1905),
    [sym_fsi_directive_decl] = STATE(1905),
    [sym_preproc_line] = STATE(1905),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_as] = ACTIONS(3825),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_with] = ACTIONS(3825),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
    [sym__dedent] = ACTIONS(3827),
  },
  [1906] = {
    [sym_xml_doc] = STATE(1906),
    [sym_block_comment] = STATE(1906),
    [sym_line_comment] = STATE(1906),
    [sym_compiler_directive_decl] = STATE(1906),
    [sym_fsi_directive_decl] = STATE(1906),
    [sym_preproc_line] = STATE(1906),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_DOT_DOT2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
    [sym__dedent] = ACTIONS(3312),
  },
  [1907] = {
    [sym_xml_doc] = STATE(1907),
    [sym_block_comment] = STATE(1907),
    [sym_line_comment] = STATE(1907),
    [sym_compiler_directive_decl] = STATE(1907),
    [sym_fsi_directive_decl] = STATE(1907),
    [sym_preproc_line] = STATE(1907),
    [aux_sym_rules_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_AT_AT_GT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4687),
  },
  [1908] = {
    [sym_xml_doc] = STATE(1908),
    [sym_block_comment] = STATE(1908),
    [sym_line_comment] = STATE(1908),
    [sym_compiler_directive_decl] = STATE(1908),
    [sym_fsi_directive_decl] = STATE(1908),
    [sym_preproc_line] = STATE(1908),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_as] = ACTIONS(3802),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_with] = ACTIONS(3802),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
    [sym__dedent] = ACTIONS(3804),
  },
  [1909] = {
    [sym_xml_doc] = STATE(1909),
    [sym_block_comment] = STATE(1909),
    [sym_line_comment] = STATE(1909),
    [sym_compiler_directive_decl] = STATE(1909),
    [sym_fsi_directive_decl] = STATE(1909),
    [sym_preproc_line] = STATE(1909),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_with] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_DOT_DOT2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
    [sym__dedent] = ACTIONS(3849),
  },
  [1910] = {
    [sym_xml_doc] = STATE(1910),
    [sym_block_comment] = STATE(1910),
    [sym_line_comment] = STATE(1910),
    [sym_compiler_directive_decl] = STATE(1910),
    [sym_fsi_directive_decl] = STATE(1910),
    [sym_preproc_line] = STATE(1910),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_AT_AT_GT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1911] = {
    [sym_xml_doc] = STATE(1911),
    [sym_block_comment] = STATE(1911),
    [sym_line_comment] = STATE(1911),
    [sym_compiler_directive_decl] = STATE(1911),
    [sym_fsi_directive_decl] = STATE(1911),
    [sym_preproc_line] = STATE(1911),
    [aux_sym_sequential_expression_repeat1] = STATE(1911),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_as] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_with] = ACTIONS(3829),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4690),
  },
  [1912] = {
    [sym_xml_doc] = STATE(1912),
    [sym_block_comment] = STATE(1912),
    [sym_line_comment] = STATE(1912),
    [sym_compiler_directive_decl] = STATE(1912),
    [sym_fsi_directive_decl] = STATE(1912),
    [sym_preproc_line] = STATE(1912),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_DOT_DOT] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [1913] = {
    [sym_xml_doc] = STATE(1913),
    [sym_block_comment] = STATE(1913),
    [sym_line_comment] = STATE(1913),
    [sym_compiler_directive_decl] = STATE(1913),
    [sym_fsi_directive_decl] = STATE(1913),
    [sym_preproc_line] = STATE(1913),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
    [sym__dedent] = ACTIONS(3800),
  },
  [1914] = {
    [sym_xml_doc] = STATE(1914),
    [sym_block_comment] = STATE(1914),
    [sym_line_comment] = STATE(1914),
    [sym_compiler_directive_decl] = STATE(1914),
    [sym_fsi_directive_decl] = STATE(1914),
    [sym_preproc_line] = STATE(1914),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_DOT_DOT2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
    [sym__dedent] = ACTIONS(3865),
  },
  [1915] = {
    [sym_xml_doc] = STATE(1915),
    [sym_block_comment] = STATE(1915),
    [sym_line_comment] = STATE(1915),
    [sym_compiler_directive_decl] = STATE(1915),
    [sym_fsi_directive_decl] = STATE(1915),
    [sym_preproc_line] = STATE(1915),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_AT_AT_GT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4693),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1916] = {
    [sym_xml_doc] = STATE(1916),
    [sym_block_comment] = STATE(1916),
    [sym_line_comment] = STATE(1916),
    [sym_compiler_directive_decl] = STATE(1916),
    [sym_fsi_directive_decl] = STATE(1916),
    [sym_preproc_line] = STATE(1916),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_with] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_DOT_DOT2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
    [sym__dedent] = ACTIONS(3880),
  },
  [1917] = {
    [sym_xml_doc] = STATE(1917),
    [sym_block_comment] = STATE(1917),
    [sym_line_comment] = STATE(1917),
    [sym_compiler_directive_decl] = STATE(1917),
    [sym_fsi_directive_decl] = STATE(1917),
    [sym_preproc_line] = STATE(1917),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_AT_GT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1918] = {
    [sym_xml_doc] = STATE(1918),
    [sym_block_comment] = STATE(1918),
    [sym_line_comment] = STATE(1918),
    [sym_compiler_directive_decl] = STATE(1918),
    [sym_fsi_directive_decl] = STATE(1918),
    [sym_preproc_line] = STATE(1918),
    [aux_sym_rules_repeat1] = STATE(1918),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4695),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4698),
  },
  [1919] = {
    [sym_xml_doc] = STATE(1919),
    [sym_block_comment] = STATE(1919),
    [sym_line_comment] = STATE(1919),
    [sym_compiler_directive_decl] = STATE(1919),
    [sym_fsi_directive_decl] = STATE(1919),
    [sym_preproc_line] = STATE(1919),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_EQ] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_QMARK] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_AT_GT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_COLON_GT] = ACTIONS(3419),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_LT_DASH] = ACTIONS(3417),
    [anon_sym_DOT_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [anon_sym_PIPE_PIPE] = ACTIONS(3417),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_COLON_EQ] = ACTIONS(3419),
    [anon_sym_DOLLAR] = ACTIONS(3417),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3417),
    [sym_int] = ACTIONS(4701),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
    [sym__newline] = ACTIONS(3419),
  },
  [1920] = {
    [sym_xml_doc] = STATE(1920),
    [sym_block_comment] = STATE(1920),
    [sym_line_comment] = STATE(1920),
    [sym_compiler_directive_decl] = STATE(1920),
    [sym_fsi_directive_decl] = STATE(1920),
    [sym_preproc_line] = STATE(1920),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_with] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_DOT_DOT2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
    [sym__dedent] = ACTIONS(3886),
  },
  [1921] = {
    [sym_xml_doc] = STATE(1921),
    [sym_block_comment] = STATE(1921),
    [sym_line_comment] = STATE(1921),
    [sym_compiler_directive_decl] = STATE(1921),
    [sym_fsi_directive_decl] = STATE(1921),
    [sym_preproc_line] = STATE(1921),
    [aux_sym_sequential_expression_repeat1] = STATE(1984),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_DASH_GT] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_DOT_DOT] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [1922] = {
    [sym_xml_doc] = STATE(1922),
    [sym_block_comment] = STATE(1922),
    [sym_line_comment] = STATE(1922),
    [sym_compiler_directive_decl] = STATE(1922),
    [sym_fsi_directive_decl] = STATE(1922),
    [sym_preproc_line] = STATE(1922),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_with] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_DOT_DOT2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
    [sym__dedent] = ACTIONS(3890),
  },
  [1923] = {
    [sym_xml_doc] = STATE(1923),
    [sym_block_comment] = STATE(1923),
    [sym_line_comment] = STATE(1923),
    [sym_compiler_directive_decl] = STATE(1923),
    [sym_fsi_directive_decl] = STATE(1923),
    [sym_preproc_line] = STATE(1923),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_as] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_with] = ACTIONS(3794),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
    [sym__dedent] = ACTIONS(3796),
  },
  [1924] = {
    [sym_xml_doc] = STATE(1924),
    [sym_block_comment] = STATE(1924),
    [sym_line_comment] = STATE(1924),
    [sym_compiler_directive_decl] = STATE(1924),
    [sym_fsi_directive_decl] = STATE(1924),
    [sym_preproc_line] = STATE(1924),
    [aux_sym_sequential_expression_repeat1] = STATE(1924),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_DOT_DOT2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4703),
    [sym__dedent] = ACTIONS(3831),
  },
  [1925] = {
    [sym_xml_doc] = STATE(1925),
    [sym_block_comment] = STATE(1925),
    [sym_line_comment] = STATE(1925),
    [sym_compiler_directive_decl] = STATE(1925),
    [sym_fsi_directive_decl] = STATE(1925),
    [sym_preproc_line] = STATE(1925),
    [aux_sym_rules_repeat1] = STATE(1918),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [anon_sym_POUNDendif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4708),
  },
  [1926] = {
    [sym_xml_doc] = STATE(1926),
    [sym_block_comment] = STATE(1926),
    [sym_line_comment] = STATE(1926),
    [sym_compiler_directive_decl] = STATE(1926),
    [sym_fsi_directive_decl] = STATE(1926),
    [sym_preproc_line] = STATE(1926),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_as] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_with] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
    [sym__dedent] = ACTIONS(3943),
  },
  [1927] = {
    [sym_xml_doc] = STATE(1927),
    [sym_block_comment] = STATE(1927),
    [sym_line_comment] = STATE(1927),
    [sym_compiler_directive_decl] = STATE(1927),
    [sym_fsi_directive_decl] = STATE(1927),
    [sym_preproc_line] = STATE(1927),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_as] = ACTIONS(3945),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_with] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
    [sym__dedent] = ACTIONS(3947),
  },
  [1928] = {
    [sym_xml_doc] = STATE(1928),
    [sym_block_comment] = STATE(1928),
    [sym_line_comment] = STATE(1928),
    [sym_compiler_directive_decl] = STATE(1928),
    [sym_fsi_directive_decl] = STATE(1928),
    [sym_preproc_line] = STATE(1928),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_as] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_with] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
    [sym__dedent] = ACTIONS(3951),
  },
  [1929] = {
    [sym_xml_doc] = STATE(1929),
    [sym_block_comment] = STATE(1929),
    [sym_line_comment] = STATE(1929),
    [sym_compiler_directive_decl] = STATE(1929),
    [sym_fsi_directive_decl] = STATE(1929),
    [sym_preproc_line] = STATE(1929),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_as] = ACTIONS(3953),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_with] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
    [sym__dedent] = ACTIONS(3955),
  },
  [1930] = {
    [sym_xml_doc] = STATE(1930),
    [sym_block_comment] = STATE(1930),
    [sym_line_comment] = STATE(1930),
    [sym_compiler_directive_decl] = STATE(1930),
    [sym_fsi_directive_decl] = STATE(1930),
    [sym_preproc_line] = STATE(1930),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_as] = ACTIONS(3957),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_with] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
    [sym__dedent] = ACTIONS(3959),
  },
  [1931] = {
    [sym_xml_doc] = STATE(1931),
    [sym_block_comment] = STATE(1931),
    [sym_line_comment] = STATE(1931),
    [sym_compiler_directive_decl] = STATE(1931),
    [sym_fsi_directive_decl] = STATE(1931),
    [sym_preproc_line] = STATE(1931),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_with] = ACTIONS(3895),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_DOT_DOT2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
    [sym__dedent] = ACTIONS(3897),
  },
  [1932] = {
    [sym_xml_doc] = STATE(1932),
    [sym_block_comment] = STATE(1932),
    [sym_line_comment] = STATE(1932),
    [sym_compiler_directive_decl] = STATE(1932),
    [sym_fsi_directive_decl] = STATE(1932),
    [sym_preproc_line] = STATE(1932),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_as] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_with] = ACTIONS(3642),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
    [sym__dedent] = ACTIONS(3644),
  },
  [1933] = {
    [sym_xml_doc] = STATE(1933),
    [sym_block_comment] = STATE(1933),
    [sym_line_comment] = STATE(1933),
    [sym_compiler_directive_decl] = STATE(1933),
    [sym_fsi_directive_decl] = STATE(1933),
    [sym_preproc_line] = STATE(1933),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3899),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_DOT_DOT2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
    [sym__dedent] = ACTIONS(3901),
  },
  [1934] = {
    [sym_xml_doc] = STATE(1934),
    [sym_block_comment] = STATE(1934),
    [sym_line_comment] = STATE(1934),
    [sym_compiler_directive_decl] = STATE(1934),
    [sym_fsi_directive_decl] = STATE(1934),
    [sym_preproc_line] = STATE(1934),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3961),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_with] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
    [sym__dedent] = ACTIONS(3963),
  },
  [1935] = {
    [sym_xml_doc] = STATE(1935),
    [sym_block_comment] = STATE(1935),
    [sym_line_comment] = STATE(1935),
    [sym_compiler_directive_decl] = STATE(1935),
    [sym_fsi_directive_decl] = STATE(1935),
    [sym_preproc_line] = STATE(1935),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3965),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_with] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
    [sym__dedent] = ACTIONS(3967),
  },
  [1936] = {
    [sym_xml_doc] = STATE(1936),
    [sym_block_comment] = STATE(1936),
    [sym_line_comment] = STATE(1936),
    [sym_compiler_directive_decl] = STATE(1936),
    [sym_fsi_directive_decl] = STATE(1936),
    [sym_preproc_line] = STATE(1936),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_with] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
    [sym__dedent] = ACTIONS(3971),
  },
  [1937] = {
    [sym_xml_doc] = STATE(1937),
    [sym_block_comment] = STATE(1937),
    [sym_line_comment] = STATE(1937),
    [sym_compiler_directive_decl] = STATE(1937),
    [sym_fsi_directive_decl] = STATE(1937),
    [sym_preproc_line] = STATE(1937),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_as] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_with] = ACTIONS(3790),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
    [sym__dedent] = ACTIONS(3792),
  },
  [1938] = {
    [sym_xml_doc] = STATE(1938),
    [sym_block_comment] = STATE(1938),
    [sym_line_comment] = STATE(1938),
    [sym_compiler_directive_decl] = STATE(1938),
    [sym_fsi_directive_decl] = STATE(1938),
    [sym_preproc_line] = STATE(1938),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_with] = ACTIONS(3906),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_DOT_DOT2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
    [sym__dedent] = ACTIONS(3908),
  },
  [1939] = {
    [sym_xml_doc] = STATE(1939),
    [sym_block_comment] = STATE(1939),
    [sym_line_comment] = STATE(1939),
    [sym_compiler_directive_decl] = STATE(1939),
    [sym_fsi_directive_decl] = STATE(1939),
    [sym_preproc_line] = STATE(1939),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_DOT_DOT2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
    [sym__dedent] = ACTIONS(3927),
  },
  [1940] = {
    [sym_xml_doc] = STATE(1940),
    [sym_block_comment] = STATE(1940),
    [sym_line_comment] = STATE(1940),
    [sym_compiler_directive_decl] = STATE(1940),
    [sym_fsi_directive_decl] = STATE(1940),
    [sym_preproc_line] = STATE(1940),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_DOT_DOT2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
    [sym__dedent] = ACTIONS(3935),
  },
  [1941] = {
    [sym_xml_doc] = STATE(1941),
    [sym_block_comment] = STATE(1941),
    [sym_line_comment] = STATE(1941),
    [sym_compiler_directive_decl] = STATE(1941),
    [sym_fsi_directive_decl] = STATE(1941),
    [sym_preproc_line] = STATE(1941),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_as] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_with] = ACTIONS(3786),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
    [sym__dedent] = ACTIONS(3788),
  },
  [1942] = {
    [sym_xml_doc] = STATE(1942),
    [sym_block_comment] = STATE(1942),
    [sym_line_comment] = STATE(1942),
    [sym_compiler_directive_decl] = STATE(1942),
    [sym_fsi_directive_decl] = STATE(1942),
    [sym_preproc_line] = STATE(1942),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [anon_sym_POUNDendif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1943] = {
    [sym_xml_doc] = STATE(1943),
    [sym_block_comment] = STATE(1943),
    [sym_line_comment] = STATE(1943),
    [sym_compiler_directive_decl] = STATE(1943),
    [sym_fsi_directive_decl] = STATE(1943),
    [sym_preproc_line] = STATE(1943),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
    [sym__dedent] = ACTIONS(3975),
  },
  [1944] = {
    [sym_xml_doc] = STATE(1944),
    [sym_block_comment] = STATE(1944),
    [sym_line_comment] = STATE(1944),
    [sym_compiler_directive_decl] = STATE(1944),
    [sym_fsi_directive_decl] = STATE(1944),
    [sym_preproc_line] = STATE(1944),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_AT_GT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3453),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3453),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3451),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3453),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
    [sym__newline] = ACTIONS(3453),
  },
  [1945] = {
    [sym_xml_doc] = STATE(1945),
    [sym_block_comment] = STATE(1945),
    [sym_line_comment] = STATE(1945),
    [sym_compiler_directive_decl] = STATE(1945),
    [sym_fsi_directive_decl] = STATE(1945),
    [sym_preproc_line] = STATE(1945),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4711),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1946] = {
    [sym_xml_doc] = STATE(1946),
    [sym_block_comment] = STATE(1946),
    [sym_line_comment] = STATE(1946),
    [sym_compiler_directive_decl] = STATE(1946),
    [sym_fsi_directive_decl] = STATE(1946),
    [sym_preproc_line] = STATE(1946),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_with] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
    [sym__dedent] = ACTIONS(3979),
  },
  [1947] = {
    [sym_xml_doc] = STATE(1947),
    [sym_block_comment] = STATE(1947),
    [sym_line_comment] = STATE(1947),
    [sym_compiler_directive_decl] = STATE(1947),
    [sym_fsi_directive_decl] = STATE(1947),
    [sym_preproc_line] = STATE(1947),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_as] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_with] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
    [sym__dedent] = ACTIONS(3939),
  },
  [1948] = {
    [sym_xml_doc] = STATE(1948),
    [sym_block_comment] = STATE(1948),
    [sym_line_comment] = STATE(1948),
    [sym_compiler_directive_decl] = STATE(1948),
    [sym_fsi_directive_decl] = STATE(1948),
    [sym_preproc_line] = STATE(1948),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_DOT_DOT2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [1949] = {
    [sym_xml_doc] = STATE(1949),
    [sym_block_comment] = STATE(1949),
    [sym_line_comment] = STATE(1949),
    [sym_compiler_directive_decl] = STATE(1949),
    [sym_fsi_directive_decl] = STATE(1949),
    [sym_preproc_line] = STATE(1949),
    [aux_sym_rules_repeat1] = STATE(1949),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_AT_GT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(4716),
  },
  [1950] = {
    [sym_xml_doc] = STATE(1950),
    [sym_block_comment] = STATE(1950),
    [sym_line_comment] = STATE(1950),
    [sym_compiler_directive_decl] = STATE(1950),
    [sym_fsi_directive_decl] = STATE(1950),
    [sym_preproc_line] = STATE(1950),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
    [sym__dedent] = ACTIONS(3931),
  },
  [1951] = {
    [sym_xml_doc] = STATE(1951),
    [sym_block_comment] = STATE(1951),
    [sym_line_comment] = STATE(1951),
    [sym_compiler_directive_decl] = STATE(1951),
    [sym_fsi_directive_decl] = STATE(1951),
    [sym_preproc_line] = STATE(1951),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_with] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_DOT_DOT2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
    [sym__dedent] = ACTIONS(3943),
  },
  [1952] = {
    [sym_xml_doc] = STATE(1952),
    [sym_block_comment] = STATE(1952),
    [sym_line_comment] = STATE(1952),
    [sym_compiler_directive_decl] = STATE(1952),
    [sym_fsi_directive_decl] = STATE(1952),
    [sym_preproc_line] = STATE(1952),
    [aux_sym_rules_repeat1] = STATE(1918),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [anon_sym_POUNDendif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4719),
  },
  [1953] = {
    [sym_xml_doc] = STATE(1953),
    [sym_block_comment] = STATE(1953),
    [sym_line_comment] = STATE(1953),
    [sym_compiler_directive_decl] = STATE(1953),
    [sym_fsi_directive_decl] = STATE(1953),
    [sym_preproc_line] = STATE(1953),
    [aux_sym_rules_repeat1] = STATE(1925),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [anon_sym_POUNDendif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4719),
  },
  [1954] = {
    [sym_xml_doc] = STATE(1954),
    [sym_block_comment] = STATE(1954),
    [sym_line_comment] = STATE(1954),
    [sym_compiler_directive_decl] = STATE(1954),
    [sym_fsi_directive_decl] = STATE(1954),
    [sym_preproc_line] = STATE(1954),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_with] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_DOT_DOT2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
    [sym__dedent] = ACTIONS(3947),
  },
  [1955] = {
    [sym_xml_doc] = STATE(1955),
    [sym_block_comment] = STATE(1955),
    [sym_line_comment] = STATE(1955),
    [sym_compiler_directive_decl] = STATE(1955),
    [sym_fsi_directive_decl] = STATE(1955),
    [sym_preproc_line] = STATE(1955),
    [aux_sym_rules_repeat1] = STATE(1949),
    [sym_identifier] = ACTIONS(3463),
    [anon_sym_EQ] = ACTIONS(3465),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_let_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3465),
    [anon_sym_null] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_QMARK] = ACTIONS(3463),
    [anon_sym_COLON_COLON] = ACTIONS(3465),
    [anon_sym_PIPE] = ACTIONS(4722),
    [anon_sym_AMP] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3463),
    [anon_sym_LT_AT] = ACTIONS(3463),
    [anon_sym_AT_GT] = ACTIONS(3463),
    [anon_sym_LT_AT_AT] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3465),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_return_BANG] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_yield_BANG] = ACTIONS(3465),
    [anon_sym_lazy] = ACTIONS(3463),
    [anon_sym_assert] = ACTIONS(3463),
    [anon_sym_upcast] = ACTIONS(3463),
    [anon_sym_downcast] = ACTIONS(3463),
    [anon_sym_COLON_GT] = ACTIONS(3465),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3465),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_fun] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_match] = ACTIONS(3463),
    [anon_sym_match_BANG] = ACTIONS(3465),
    [anon_sym_function] = ACTIONS(3463),
    [anon_sym_LT_DASH] = ACTIONS(3463),
    [anon_sym_DOT_LBRACK] = ACTIONS(3465),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_use] = ACTIONS(3463),
    [anon_sym_use_BANG] = ACTIONS(3465),
    [anon_sym_do_BANG] = ACTIONS(3465),
    [anon_sym_begin] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3465),
    [anon_sym_or] = ACTIONS(3463),
    [aux_sym_char_token1] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_AT_DQUOTE] = ACTIONS(3465),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3465),
    [sym_bool] = ACTIONS(3463),
    [sym_unit] = ACTIONS(3463),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3463),
    [sym_op_identifier] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_PLUS_DOT] = ACTIONS(3463),
    [anon_sym_DASH_DOT] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [aux_sym_prefix_op_token1] = ACTIONS(3463),
    [aux_sym_infix_op_token1] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3463),
    [anon_sym_COLON_EQ] = ACTIONS(3465),
    [anon_sym_DOLLAR] = ACTIONS(3463),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3463),
    [sym_int] = ACTIONS(3463),
    [sym_xint] = ACTIONS(3465),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3465),
    [sym__newline] = ACTIONS(4724),
  },
  [1956] = {
    [sym_xml_doc] = STATE(1956),
    [sym_block_comment] = STATE(1956),
    [sym_line_comment] = STATE(1956),
    [sym_compiler_directive_decl] = STATE(1956),
    [sym_fsi_directive_decl] = STATE(1956),
    [sym_preproc_line] = STATE(1956),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_with] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_DOT_DOT2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
    [sym__dedent] = ACTIONS(3951),
  },
  [1957] = {
    [sym_xml_doc] = STATE(1957),
    [sym_block_comment] = STATE(1957),
    [sym_line_comment] = STATE(1957),
    [sym_compiler_directive_decl] = STATE(1957),
    [sym_fsi_directive_decl] = STATE(1957),
    [sym_preproc_line] = STATE(1957),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_with] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_DOT_DOT2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
    [sym__dedent] = ACTIONS(3955),
  },
  [1958] = {
    [sym_xml_doc] = STATE(1958),
    [sym_block_comment] = STATE(1958),
    [sym_line_comment] = STATE(1958),
    [sym_compiler_directive_decl] = STATE(1958),
    [sym_fsi_directive_decl] = STATE(1958),
    [sym_preproc_line] = STATE(1958),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_with] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_DOT_DOT2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
    [sym__dedent] = ACTIONS(3959),
  },
  [1959] = {
    [sym_xml_doc] = STATE(1959),
    [sym_block_comment] = STATE(1959),
    [sym_line_comment] = STATE(1959),
    [sym_compiler_directive_decl] = STATE(1959),
    [sym_fsi_directive_decl] = STATE(1959),
    [sym_preproc_line] = STATE(1959),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_as] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_with] = ACTIONS(3782),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
    [sym__dedent] = ACTIONS(3784),
  },
  [1960] = {
    [sym_xml_doc] = STATE(1960),
    [sym_block_comment] = STATE(1960),
    [sym_line_comment] = STATE(1960),
    [sym_compiler_directive_decl] = STATE(1960),
    [sym_fsi_directive_decl] = STATE(1960),
    [sym_preproc_line] = STATE(1960),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_with] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
    [sym__dedent] = ACTIONS(3780),
  },
  [1961] = {
    [sym_xml_doc] = STATE(1961),
    [sym_block_comment] = STATE(1961),
    [sym_line_comment] = STATE(1961),
    [sym_compiler_directive_decl] = STATE(1961),
    [sym_fsi_directive_decl] = STATE(1961),
    [sym_preproc_line] = STATE(1961),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
    [sym__dedent] = ACTIONS(3923),
  },
  [1962] = {
    [sym_xml_doc] = STATE(1962),
    [sym_block_comment] = STATE(1962),
    [sym_line_comment] = STATE(1962),
    [sym_compiler_directive_decl] = STATE(1962),
    [sym_fsi_directive_decl] = STATE(1962),
    [sym_preproc_line] = STATE(1962),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_as] = ACTIONS(3910),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_with] = ACTIONS(3910),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
    [sym__dedent] = ACTIONS(3912),
  },
  [1963] = {
    [sym_xml_doc] = STATE(1963),
    [sym_block_comment] = STATE(1963),
    [sym_line_comment] = STATE(1963),
    [sym_compiler_directive_decl] = STATE(1963),
    [sym_fsi_directive_decl] = STATE(1963),
    [sym_preproc_line] = STATE(1963),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_as] = ACTIONS(3577),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_with] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
    [sym__dedent] = ACTIONS(3579),
  },
  [1964] = {
    [sym_xml_doc] = STATE(1964),
    [sym_block_comment] = STATE(1964),
    [sym_line_comment] = STATE(1964),
    [sym_compiler_directive_decl] = STATE(1964),
    [sym_fsi_directive_decl] = STATE(1964),
    [sym_preproc_line] = STATE(1964),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_DOT_DOT] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [1965] = {
    [sym_xml_doc] = STATE(1965),
    [sym_block_comment] = STATE(1965),
    [sym_line_comment] = STATE(1965),
    [sym_compiler_directive_decl] = STATE(1965),
    [sym_fsi_directive_decl] = STATE(1965),
    [sym_preproc_line] = STATE(1965),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_AT_AT_GT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_elif] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1966] = {
    [sym_xml_doc] = STATE(1966),
    [sym_block_comment] = STATE(1966),
    [sym_line_comment] = STATE(1966),
    [sym_compiler_directive_decl] = STATE(1966),
    [sym_fsi_directive_decl] = STATE(1966),
    [sym_preproc_line] = STATE(1966),
    [aux_sym_sequential_expression_repeat1] = STATE(1924),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_DOT_DOT2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
    [sym__dedent] = ACTIONS(3614),
  },
  [1967] = {
    [sym_xml_doc] = STATE(1967),
    [sym_block_comment] = STATE(1967),
    [sym_line_comment] = STATE(1967),
    [sym_compiler_directive_decl] = STATE(1967),
    [sym_fsi_directive_decl] = STATE(1967),
    [sym_preproc_line] = STATE(1967),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_DASH_GT] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1968] = {
    [sym_xml_doc] = STATE(1968),
    [sym_block_comment] = STATE(1968),
    [sym_line_comment] = STATE(1968),
    [sym_compiler_directive_decl] = STATE(1968),
    [sym_fsi_directive_decl] = STATE(1968),
    [sym_preproc_line] = STATE(1968),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_with] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_DOT_DOT2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
    [sym__dedent] = ACTIONS(3963),
  },
  [1969] = {
    [sym_xml_doc] = STATE(1969),
    [sym_block_comment] = STATE(1969),
    [sym_line_comment] = STATE(1969),
    [sym_compiler_directive_decl] = STATE(1969),
    [sym_fsi_directive_decl] = STATE(1969),
    [sym_preproc_line] = STATE(1969),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_with] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_DOT_DOT2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
    [sym__dedent] = ACTIONS(3967),
  },
  [1970] = {
    [sym_xml_doc] = STATE(1970),
    [sym_block_comment] = STATE(1970),
    [sym_line_comment] = STATE(1970),
    [sym_compiler_directive_decl] = STATE(1970),
    [sym_fsi_directive_decl] = STATE(1970),
    [sym_preproc_line] = STATE(1970),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_with] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_DOT_DOT2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
    [sym__dedent] = ACTIONS(3971),
  },
  [1971] = {
    [sym_xml_doc] = STATE(1971),
    [sym_block_comment] = STATE(1971),
    [sym_line_comment] = STATE(1971),
    [sym_compiler_directive_decl] = STATE(1971),
    [sym_fsi_directive_decl] = STATE(1971),
    [sym_preproc_line] = STATE(1971),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_DOT_DOT2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
    [sym__dedent] = ACTIONS(3975),
  },
  [1972] = {
    [sym_xml_doc] = STATE(1972),
    [sym_block_comment] = STATE(1972),
    [sym_line_comment] = STATE(1972),
    [sym_compiler_directive_decl] = STATE(1972),
    [sym_fsi_directive_decl] = STATE(1972),
    [sym_preproc_line] = STATE(1972),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_with] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_DOT_DOT2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
    [sym__dedent] = ACTIONS(3979),
  },
  [1973] = {
    [sym_xml_doc] = STATE(1973),
    [sym_block_comment] = STATE(1973),
    [sym_line_comment] = STATE(1973),
    [sym_compiler_directive_decl] = STATE(1973),
    [sym_fsi_directive_decl] = STATE(1973),
    [sym_preproc_line] = STATE(1973),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_with] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_DOT_DOT2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
    [sym__dedent] = ACTIONS(3939),
  },
  [1974] = {
    [sym_xml_doc] = STATE(1974),
    [sym_block_comment] = STATE(1974),
    [sym_line_comment] = STATE(1974),
    [sym_compiler_directive_decl] = STATE(1974),
    [sym_fsi_directive_decl] = STATE(1974),
    [sym_preproc_line] = STATE(1974),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_as] = ACTIONS(3762),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_with] = ACTIONS(3762),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
    [sym__dedent] = ACTIONS(3764),
  },
  [1975] = {
    [sym_xml_doc] = STATE(1975),
    [sym_block_comment] = STATE(1975),
    [sym_line_comment] = STATE(1975),
    [sym_compiler_directive_decl] = STATE(1975),
    [sym_fsi_directive_decl] = STATE(1975),
    [sym_preproc_line] = STATE(1975),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_as] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_with] = ACTIONS(3718),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
    [sym__dedent] = ACTIONS(3720),
  },
  [1976] = {
    [sym_xml_doc] = STATE(1976),
    [sym_block_comment] = STATE(1976),
    [sym_line_comment] = STATE(1976),
    [sym_compiler_directive_decl] = STATE(1976),
    [sym_fsi_directive_decl] = STATE(1976),
    [sym_preproc_line] = STATE(1976),
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_EQ] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_do] = ACTIONS(3493),
    [anon_sym_let] = ACTIONS(3493),
    [anon_sym_let_BANG] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_null] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_COLON_COLON] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_LT_AT] = ACTIONS(3493),
    [anon_sym_LT_AT_AT] = ACTIONS(3493),
    [anon_sym_AT_AT_GT] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_return_BANG] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3493),
    [anon_sym_yield_BANG] = ACTIONS(3495),
    [anon_sym_lazy] = ACTIONS(3493),
    [anon_sym_assert] = ACTIONS(3493),
    [anon_sym_upcast] = ACTIONS(3493),
    [anon_sym_downcast] = ACTIONS(3493),
    [anon_sym_COLON_GT] = ACTIONS(3495),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3493),
    [anon_sym_while] = ACTIONS(3493),
    [anon_sym_else] = ACTIONS(3493),
    [anon_sym_elif] = ACTIONS(3493),
    [anon_sym_if] = ACTIONS(3493),
    [anon_sym_fun] = ACTIONS(3493),
    [anon_sym_try] = ACTIONS(3493),
    [anon_sym_match] = ACTIONS(3493),
    [anon_sym_match_BANG] = ACTIONS(3495),
    [anon_sym_function] = ACTIONS(3493),
    [anon_sym_LT_DASH] = ACTIONS(3493),
    [anon_sym_DOT_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3495),
    [anon_sym_use] = ACTIONS(3493),
    [anon_sym_use_BANG] = ACTIONS(3495),
    [anon_sym_do_BANG] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3493),
    [anon_sym_LPAREN2] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3493),
    [aux_sym_char_token1] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_AT_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3495),
    [sym_bool] = ACTIONS(3493),
    [sym_unit] = ACTIONS(3493),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3493),
    [sym_op_identifier] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PLUS_DOT] = ACTIONS(3493),
    [anon_sym_DASH_DOT] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3495),
    [aux_sym_prefix_op_token1] = ACTIONS(3493),
    [aux_sym_infix_op_token1] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3493),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3493),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3493),
    [sym_int] = ACTIONS(3493),
    [sym_xint] = ACTIONS(3495),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3495),
    [sym__newline] = ACTIONS(3495),
  },
  [1977] = {
    [sym_xml_doc] = STATE(1977),
    [sym_block_comment] = STATE(1977),
    [sym_line_comment] = STATE(1977),
    [sym_compiler_directive_decl] = STATE(1977),
    [sym_fsi_directive_decl] = STATE(1977),
    [sym_preproc_line] = STATE(1977),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_with] = ACTIONS(3770),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
    [sym__dedent] = ACTIONS(3772),
  },
  [1978] = {
    [sym_xml_doc] = STATE(1978),
    [sym_block_comment] = STATE(1978),
    [sym_line_comment] = STATE(1978),
    [sym_compiler_directive_decl] = STATE(1978),
    [sym_fsi_directive_decl] = STATE(1978),
    [sym_preproc_line] = STATE(1978),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_with] = ACTIONS(3766),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
    [sym__dedent] = ACTIONS(3768),
  },
  [1979] = {
    [sym_xml_doc] = STATE(1979),
    [sym_block_comment] = STATE(1979),
    [sym_line_comment] = STATE(1979),
    [sym_compiler_directive_decl] = STATE(1979),
    [sym_fsi_directive_decl] = STATE(1979),
    [sym_preproc_line] = STATE(1979),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_DOT_DOT2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
    [sym__dedent] = ACTIONS(3931),
  },
  [1980] = {
    [sym_xml_doc] = STATE(1980),
    [sym_block_comment] = STATE(1980),
    [sym_line_comment] = STATE(1980),
    [sym_compiler_directive_decl] = STATE(1980),
    [sym_fsi_directive_decl] = STATE(1980),
    [sym_preproc_line] = STATE(1980),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_with] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
    [sym__dedent] = ACTIONS(3748),
  },
  [1981] = {
    [sym_xml_doc] = STATE(1981),
    [sym_block_comment] = STATE(1981),
    [sym_line_comment] = STATE(1981),
    [sym_compiler_directive_decl] = STATE(1981),
    [sym_fsi_directive_decl] = STATE(1981),
    [sym_preproc_line] = STATE(1981),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_DOT_DOT2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
    [sym__dedent] = ACTIONS(3923),
  },
  [1982] = {
    [sym_xml_doc] = STATE(1982),
    [sym_block_comment] = STATE(1982),
    [sym_line_comment] = STATE(1982),
    [sym_compiler_directive_decl] = STATE(1982),
    [sym_fsi_directive_decl] = STATE(1982),
    [sym_preproc_line] = STATE(1982),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_as] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_with] = ACTIONS(3712),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
    [sym__dedent] = ACTIONS(3714),
  },
  [1983] = {
    [sym_xml_doc] = STATE(1983),
    [sym_block_comment] = STATE(1983),
    [sym_line_comment] = STATE(1983),
    [sym_compiler_directive_decl] = STATE(1983),
    [sym_fsi_directive_decl] = STATE(1983),
    [sym_preproc_line] = STATE(1983),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_with] = ACTIONS(3910),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_DOT_DOT2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
    [sym__dedent] = ACTIONS(3912),
  },
  [1984] = {
    [sym_xml_doc] = STATE(1984),
    [sym_block_comment] = STATE(1984),
    [sym_line_comment] = STATE(1984),
    [sym_compiler_directive_decl] = STATE(1984),
    [sym_fsi_directive_decl] = STATE(1984),
    [sym_preproc_line] = STATE(1984),
    [aux_sym_sequential_expression_repeat1] = STATE(1984),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_DASH_GT] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4727),
  },
  [1985] = {
    [sym_xml_doc] = STATE(1985),
    [sym_block_comment] = STATE(1985),
    [sym_line_comment] = STATE(1985),
    [sym_compiler_directive_decl] = STATE(1985),
    [sym_fsi_directive_decl] = STATE(1985),
    [sym_preproc_line] = STATE(1985),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_as] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3738),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
    [sym__dedent] = ACTIONS(3740),
  },
  [1986] = {
    [sym_xml_doc] = STATE(1986),
    [sym_block_comment] = STATE(1986),
    [sym_line_comment] = STATE(1986),
    [sym_compiler_directive_decl] = STATE(1986),
    [sym_fsi_directive_decl] = STATE(1986),
    [sym_preproc_line] = STATE(1986),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
    [sym__dedent] = ACTIONS(3736),
  },
  [1987] = {
    [sym_xml_doc] = STATE(1987),
    [sym_block_comment] = STATE(1987),
    [sym_line_comment] = STATE(1987),
    [sym_compiler_directive_decl] = STATE(1987),
    [sym_fsi_directive_decl] = STATE(1987),
    [sym_preproc_line] = STATE(1987),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_as] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
    [sym__dedent] = ACTIONS(3728),
  },
  [1988] = {
    [sym_xml_doc] = STATE(1988),
    [sym_block_comment] = STATE(1988),
    [sym_line_comment] = STATE(1988),
    [sym_compiler_directive_decl] = STATE(1988),
    [sym_fsi_directive_decl] = STATE(1988),
    [sym_preproc_line] = STATE(1988),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_as] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_with] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
    [sym__dedent] = ACTIONS(3724),
  },
  [1989] = {
    [sym_xml_doc] = STATE(1989),
    [sym_block_comment] = STATE(1989),
    [sym_line_comment] = STATE(1989),
    [sym_compiler_directive_decl] = STATE(1989),
    [sym_fsi_directive_decl] = STATE(1989),
    [sym_preproc_line] = STATE(1989),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_as] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
    [sym__dedent] = ACTIONS(3695),
  },
  [1990] = {
    [sym_xml_doc] = STATE(1990),
    [sym_block_comment] = STATE(1990),
    [sym_line_comment] = STATE(1990),
    [sym_compiler_directive_decl] = STATE(1990),
    [sym_fsi_directive_decl] = STATE(1990),
    [sym_preproc_line] = STATE(1990),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_with] = ACTIONS(3660),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
    [sym__dedent] = ACTIONS(3662),
  },
  [1991] = {
    [sym_xml_doc] = STATE(1991),
    [sym_block_comment] = STATE(1991),
    [sym_line_comment] = STATE(1991),
    [sym_compiler_directive_decl] = STATE(1991),
    [sym_fsi_directive_decl] = STATE(1991),
    [sym_preproc_line] = STATE(1991),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_AT_GT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_done] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [1992] = {
    [sym_xml_doc] = STATE(1992),
    [sym_block_comment] = STATE(1992),
    [sym_line_comment] = STATE(1992),
    [sym_compiler_directive_decl] = STATE(1992),
    [sym_fsi_directive_decl] = STATE(1992),
    [sym_preproc_line] = STATE(1992),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_with] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_DOT_DOT2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
    [sym__dedent] = ACTIONS(3861),
  },
  [1993] = {
    [sym_xml_doc] = STATE(1993),
    [sym_block_comment] = STATE(1993),
    [sym_line_comment] = STATE(1993),
    [sym_compiler_directive_decl] = STATE(1993),
    [sym_fsi_directive_decl] = STATE(1993),
    [sym_preproc_line] = STATE(1993),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_as] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_with] = ACTIONS(3656),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
    [sym__dedent] = ACTIONS(3658),
  },
  [1994] = {
    [sym_xml_doc] = STATE(1994),
    [sym_block_comment] = STATE(1994),
    [sym_line_comment] = STATE(1994),
    [sym_compiler_directive_decl] = STATE(1994),
    [sym_fsi_directive_decl] = STATE(1994),
    [sym_preproc_line] = STATE(1994),
    [aux_sym_rules_repeat1] = STATE(1949),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4722),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_AT_GT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4730),
  },
  [1995] = {
    [sym_xml_doc] = STATE(1995),
    [sym_block_comment] = STATE(1995),
    [sym_line_comment] = STATE(1995),
    [sym_compiler_directive_decl] = STATE(1995),
    [sym_fsi_directive_decl] = STATE(1995),
    [sym_preproc_line] = STATE(1995),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_as] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_with] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
    [sym__dedent] = ACTIONS(3677),
  },
  [1996] = {
    [sym_xml_doc] = STATE(1996),
    [sym_block_comment] = STATE(1996),
    [sym_line_comment] = STATE(1996),
    [sym_compiler_directive_decl] = STATE(1996),
    [sym_fsi_directive_decl] = STATE(1996),
    [sym_preproc_line] = STATE(1996),
    [aux_sym_rules_repeat1] = STATE(1955),
    [sym_identifier] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_return] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_let_BANG] = ACTIONS(3444),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3444),
    [anon_sym_null] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_QMARK] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(4722),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_LT_AT] = ACTIONS(3442),
    [anon_sym_AT_GT] = ACTIONS(3442),
    [anon_sym_LT_AT_AT] = ACTIONS(3442),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3442),
    [anon_sym_return_BANG] = ACTIONS(3444),
    [anon_sym_yield] = ACTIONS(3442),
    [anon_sym_yield_BANG] = ACTIONS(3444),
    [anon_sym_lazy] = ACTIONS(3442),
    [anon_sym_assert] = ACTIONS(3442),
    [anon_sym_upcast] = ACTIONS(3442),
    [anon_sym_downcast] = ACTIONS(3442),
    [anon_sym_COLON_GT] = ACTIONS(3444),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3442),
    [anon_sym_while] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3442),
    [anon_sym_fun] = ACTIONS(3442),
    [anon_sym_try] = ACTIONS(3442),
    [anon_sym_match] = ACTIONS(3442),
    [anon_sym_match_BANG] = ACTIONS(3444),
    [anon_sym_function] = ACTIONS(3442),
    [anon_sym_LT_DASH] = ACTIONS(3442),
    [anon_sym_DOT_LBRACK] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_use] = ACTIONS(3442),
    [anon_sym_use_BANG] = ACTIONS(3444),
    [anon_sym_do_BANG] = ACTIONS(3444),
    [anon_sym_begin] = ACTIONS(3442),
    [anon_sym_LPAREN2] = ACTIONS(3444),
    [anon_sym_or] = ACTIONS(3442),
    [aux_sym_char_token1] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [anon_sym_AT_DQUOTE] = ACTIONS(3444),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3444),
    [sym_bool] = ACTIONS(3442),
    [sym_unit] = ACTIONS(3442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3442),
    [sym_op_identifier] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_DOT] = ACTIONS(3442),
    [anon_sym_DASH_DOT] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3444),
    [aux_sym_prefix_op_token1] = ACTIONS(3442),
    [aux_sym_infix_op_token1] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_COLON_EQ] = ACTIONS(3444),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3442),
    [sym_int] = ACTIONS(3442),
    [sym_xint] = ACTIONS(3444),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3444),
    [sym__newline] = ACTIONS(4730),
  },
  [1997] = {
    [sym_xml_doc] = STATE(1997),
    [sym_block_comment] = STATE(1997),
    [sym_line_comment] = STATE(1997),
    [sym_compiler_directive_decl] = STATE(1997),
    [sym_fsi_directive_decl] = STATE(1997),
    [sym_preproc_line] = STATE(1997),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_DOT_DOT] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1998] = {
    [sym_xml_doc] = STATE(1998),
    [sym_block_comment] = STATE(1998),
    [sym_line_comment] = STATE(1998),
    [sym_compiler_directive_decl] = STATE(1998),
    [sym_fsi_directive_decl] = STATE(1998),
    [sym_preproc_line] = STATE(1998),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_DASH_GT] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_DOT_DOT] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [1999] = {
    [sym_xml_doc] = STATE(1999),
    [sym_block_comment] = STATE(1999),
    [sym_line_comment] = STATE(1999),
    [sym_compiler_directive_decl] = STATE(1999),
    [sym_fsi_directive_decl] = STATE(1999),
    [sym_preproc_line] = STATE(1999),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_with] = ACTIONS(3762),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_DOT_DOT2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
    [sym__dedent] = ACTIONS(3764),
  },
  [2000] = {
    [sym_xml_doc] = STATE(2000),
    [sym_block_comment] = STATE(2000),
    [sym_line_comment] = STATE(2000),
    [sym_compiler_directive_decl] = STATE(2000),
    [sym_fsi_directive_decl] = STATE(2000),
    [sym_preproc_line] = STATE(2000),
    [aux_sym_rules_repeat1] = STATE(1952),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [anon_sym_POUNDendif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4733),
  },
  [2001] = {
    [sym_xml_doc] = STATE(2001),
    [sym_block_comment] = STATE(2001),
    [sym_line_comment] = STATE(2001),
    [sym_compiler_directive_decl] = STATE(2001),
    [sym_fsi_directive_decl] = STATE(2001),
    [sym_preproc_line] = STATE(2001),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_with] = ACTIONS(3718),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_DOT_DOT2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
    [sym__dedent] = ACTIONS(3720),
  },
  [2002] = {
    [sym_xml_doc] = STATE(2002),
    [sym_block_comment] = STATE(2002),
    [sym_line_comment] = STATE(2002),
    [sym_compiler_directive_decl] = STATE(2002),
    [sym_fsi_directive_decl] = STATE(2002),
    [sym_preproc_line] = STATE(2002),
    [aux_sym_long_identifier_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [anon_sym_POUNDendif] = ACTIONS(3204),
    [anon_sym_POUNDelse] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [2003] = {
    [sym_xml_doc] = STATE(2003),
    [sym_block_comment] = STATE(2003),
    [sym_line_comment] = STATE(2003),
    [sym_compiler_directive_decl] = STATE(2003),
    [sym_fsi_directive_decl] = STATE(2003),
    [sym_preproc_line] = STATE(2003),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_as] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
    [sym__dedent] = ACTIONS(3648),
  },
  [2004] = {
    [sym_xml_doc] = STATE(2004),
    [sym_block_comment] = STATE(2004),
    [sym_line_comment] = STATE(2004),
    [sym_compiler_directive_decl] = STATE(2004),
    [sym_fsi_directive_decl] = STATE(2004),
    [sym_preproc_line] = STATE(2004),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_as] = ACTIONS(3638),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_with] = ACTIONS(3638),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
    [sym__dedent] = ACTIONS(3640),
  },
  [2005] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5510),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2094),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2005),
    [sym_block_comment] = STATE(2005),
    [sym_line_comment] = STATE(2005),
    [sym_compiler_directive_decl] = STATE(2005),
    [sym_fsi_directive_decl] = STATE(2005),
    [sym_preproc_line] = STATE(2005),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(4523),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4645),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2006] = {
    [sym_xml_doc] = STATE(2006),
    [sym_block_comment] = STATE(2006),
    [sym_line_comment] = STATE(2006),
    [sym_compiler_directive_decl] = STATE(2006),
    [sym_fsi_directive_decl] = STATE(2006),
    [sym_preproc_line] = STATE(2006),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3624),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_with] = ACTIONS(3624),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
    [sym__dedent] = ACTIONS(3626),
  },
  [2007] = {
    [sym_xml_doc] = STATE(2007),
    [sym_block_comment] = STATE(2007),
    [sym_line_comment] = STATE(2007),
    [sym_compiler_directive_decl] = STATE(2007),
    [sym_fsi_directive_decl] = STATE(2007),
    [sym_preproc_line] = STATE(2007),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(3457),
    [anon_sym_COLON] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_let_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_null] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_QMARK] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3455),
    [anon_sym_LT_AT_AT] = ACTIONS(3455),
    [anon_sym_DOT] = ACTIONS(3455),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3457),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_return_BANG] = ACTIONS(3457),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_yield_BANG] = ACTIONS(3457),
    [anon_sym_lazy] = ACTIONS(3455),
    [anon_sym_assert] = ACTIONS(3455),
    [anon_sym_upcast] = ACTIONS(3455),
    [anon_sym_downcast] = ACTIONS(3455),
    [anon_sym_COLON_GT] = ACTIONS(3457),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_elif] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_fun] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_match] = ACTIONS(3455),
    [anon_sym_match_BANG] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_LT_DASH] = ACTIONS(3455),
    [anon_sym_DOT_LBRACK] = ACTIONS(3457),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3455),
    [anon_sym_use_BANG] = ACTIONS(3457),
    [anon_sym_do_BANG] = ACTIONS(3457),
    [anon_sym_begin] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3455),
    [aux_sym_char_token1] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_AT_DQUOTE] = ACTIONS(3457),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3457),
    [sym_bool] = ACTIONS(3455),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3455),
    [sym_op_identifier] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS_DOT] = ACTIONS(3455),
    [anon_sym_DASH_DOT] = ACTIONS(3455),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [aux_sym_prefix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_COLON_EQ] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(3455),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3455),
    [sym_int] = ACTIONS(3455),
    [sym_xint] = ACTIONS(3457),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3457),
    [anon_sym_POUNDendif] = ACTIONS(3457),
    [sym__newline] = ACTIONS(3457),
  },
  [2008] = {
    [sym_xml_doc] = STATE(2008),
    [sym_block_comment] = STATE(2008),
    [sym_line_comment] = STATE(2008),
    [sym_compiler_directive_decl] = STATE(2008),
    [sym_fsi_directive_decl] = STATE(2008),
    [sym_preproc_line] = STATE(2008),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_with] = ACTIONS(3712),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_DOT_DOT2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
    [sym__dedent] = ACTIONS(3714),
  },
  [2009] = {
    [sym_xml_doc] = STATE(2009),
    [sym_block_comment] = STATE(2009),
    [sym_line_comment] = STATE(2009),
    [sym_compiler_directive_decl] = STATE(2009),
    [sym_fsi_directive_decl] = STATE(2009),
    [sym_preproc_line] = STATE(2009),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_as] = ACTIONS(3620),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_with] = ACTIONS(3620),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
    [sym__dedent] = ACTIONS(3622),
  },
  [2010] = {
    [sym_xml_doc] = STATE(2010),
    [sym_block_comment] = STATE(2010),
    [sym_line_comment] = STATE(2010),
    [sym_compiler_directive_decl] = STATE(2010),
    [sym_fsi_directive_decl] = STATE(2010),
    [sym_preproc_line] = STATE(2010),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_as] = ACTIONS(3859),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_with] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
    [sym__dedent] = ACTIONS(3861),
  },
  [2011] = {
    [sym_xml_doc] = STATE(2011),
    [sym_block_comment] = STATE(2011),
    [sym_line_comment] = STATE(2011),
    [sym_compiler_directive_decl] = STATE(2011),
    [sym_fsi_directive_decl] = STATE(2011),
    [sym_preproc_line] = STATE(2011),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_as] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3616),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
    [sym__dedent] = ACTIONS(3618),
  },
  [2012] = {
    [sym_xml_doc] = STATE(2012),
    [sym_block_comment] = STATE(2012),
    [sym_line_comment] = STATE(2012),
    [sym_compiler_directive_decl] = STATE(2012),
    [sym_fsi_directive_decl] = STATE(2012),
    [sym_preproc_line] = STATE(2012),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_as] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
    [sym__dedent] = ACTIONS(3604),
  },
  [2013] = {
    [sym_xml_doc] = STATE(2013),
    [sym_block_comment] = STATE(2013),
    [sym_line_comment] = STATE(2013),
    [sym_compiler_directive_decl] = STATE(2013),
    [sym_fsi_directive_decl] = STATE(2013),
    [sym_preproc_line] = STATE(2013),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_with] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_DOT_DOT2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
    [sym__dedent] = ACTIONS(3677),
  },
  [2014] = {
    [sym_xml_doc] = STATE(2014),
    [sym_block_comment] = STATE(2014),
    [sym_line_comment] = STATE(2014),
    [sym_compiler_directive_decl] = STATE(2014),
    [sym_fsi_directive_decl] = STATE(2014),
    [sym_preproc_line] = STATE(2014),
    [aux_sym_rules_repeat1] = STATE(1994),
    [sym_identifier] = ACTIONS(3404),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3404),
    [anon_sym_return] = ACTIONS(3404),
    [anon_sym_do] = ACTIONS(3404),
    [anon_sym_let] = ACTIONS(3404),
    [anon_sym_let_BANG] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_null] = ACTIONS(3404),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_QMARK] = ACTIONS(3404),
    [anon_sym_COLON_COLON] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(4722),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3406),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_LT_AT] = ACTIONS(3404),
    [anon_sym_AT_GT] = ACTIONS(3404),
    [anon_sym_LT_AT_AT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3406),
    [anon_sym_new] = ACTIONS(3404),
    [anon_sym_return_BANG] = ACTIONS(3406),
    [anon_sym_yield] = ACTIONS(3404),
    [anon_sym_yield_BANG] = ACTIONS(3406),
    [anon_sym_lazy] = ACTIONS(3404),
    [anon_sym_assert] = ACTIONS(3404),
    [anon_sym_upcast] = ACTIONS(3404),
    [anon_sym_downcast] = ACTIONS(3404),
    [anon_sym_COLON_GT] = ACTIONS(3406),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3406),
    [anon_sym_for] = ACTIONS(3404),
    [anon_sym_while] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3404),
    [anon_sym_fun] = ACTIONS(3404),
    [anon_sym_try] = ACTIONS(3404),
    [anon_sym_match] = ACTIONS(3404),
    [anon_sym_match_BANG] = ACTIONS(3406),
    [anon_sym_function] = ACTIONS(3404),
    [anon_sym_LT_DASH] = ACTIONS(3404),
    [anon_sym_DOT_LBRACK] = ACTIONS(3406),
    [anon_sym_LT] = ACTIONS(3406),
    [anon_sym_use] = ACTIONS(3404),
    [anon_sym_use_BANG] = ACTIONS(3406),
    [anon_sym_do_BANG] = ACTIONS(3406),
    [anon_sym_begin] = ACTIONS(3404),
    [anon_sym_LPAREN2] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3404),
    [aux_sym_char_token1] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [anon_sym_AT_DQUOTE] = ACTIONS(3406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3406),
    [sym_bool] = ACTIONS(3404),
    [sym_unit] = ACTIONS(3404),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3404),
    [sym_op_identifier] = ACTIONS(3404),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_DOT] = ACTIONS(3404),
    [anon_sym_DASH_DOT] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3406),
    [aux_sym_prefix_op_token1] = ACTIONS(3404),
    [aux_sym_infix_op_token1] = ACTIONS(3404),
    [anon_sym_PIPE_PIPE] = ACTIONS(3404),
    [anon_sym_BANG_EQ] = ACTIONS(3404),
    [anon_sym_COLON_EQ] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(3404),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3404),
    [sym_int] = ACTIONS(3404),
    [sym_xint] = ACTIONS(3406),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3406),
    [sym__newline] = ACTIONS(4742),
  },
  [2015] = {
    [sym_xml_doc] = STATE(2015),
    [sym_block_comment] = STATE(2015),
    [sym_line_comment] = STATE(2015),
    [sym_compiler_directive_decl] = STATE(2015),
    [sym_fsi_directive_decl] = STATE(2015),
    [sym_preproc_line] = STATE(2015),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_DOT_DOT2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
    [sym__dedent] = ACTIONS(3699),
  },
  [2016] = {
    [sym_xml_doc] = STATE(2016),
    [sym_block_comment] = STATE(2016),
    [sym_line_comment] = STATE(2016),
    [sym_compiler_directive_decl] = STATE(2016),
    [sym_fsi_directive_decl] = STATE(2016),
    [sym_preproc_line] = STATE(2016),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_with] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_DOT_DOT2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
    [sym__dedent] = ACTIONS(3691),
  },
  [2017] = {
    [sym_xml_doc] = STATE(2017),
    [sym_block_comment] = STATE(2017),
    [sym_line_comment] = STATE(2017),
    [sym_compiler_directive_decl] = STATE(2017),
    [sym_fsi_directive_decl] = STATE(2017),
    [sym_preproc_line] = STATE(2017),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_DOT_DOT2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
    [sym__dedent] = ACTIONS(3648),
  },
  [2018] = {
    [sym_xml_doc] = STATE(2018),
    [sym_block_comment] = STATE(2018),
    [sym_line_comment] = STATE(2018),
    [sym_compiler_directive_decl] = STATE(2018),
    [sym_fsi_directive_decl] = STATE(2018),
    [sym_preproc_line] = STATE(2018),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_with] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_DOT_DOT2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
    [sym__dedent] = ACTIONS(3546),
  },
  [2019] = {
    [sym_xml_doc] = STATE(2019),
    [sym_block_comment] = STATE(2019),
    [sym_line_comment] = STATE(2019),
    [sym_compiler_directive_decl] = STATE(2019),
    [sym_fsi_directive_decl] = STATE(2019),
    [sym_preproc_line] = STATE(2019),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_with] = ACTIONS(3638),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_DOT_DOT2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
    [sym__dedent] = ACTIONS(3640),
  },
  [2020] = {
    [sym_xml_doc] = STATE(2020),
    [sym_block_comment] = STATE(2020),
    [sym_line_comment] = STATE(2020),
    [sym_compiler_directive_decl] = STATE(2020),
    [sym_fsi_directive_decl] = STATE(2020),
    [sym_preproc_line] = STATE(2020),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_with] = ACTIONS(3624),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_DOT_DOT2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
    [sym__dedent] = ACTIONS(3626),
  },
  [2021] = {
    [sym_xml_doc] = STATE(2021),
    [sym_block_comment] = STATE(2021),
    [sym_line_comment] = STATE(2021),
    [sym_compiler_directive_decl] = STATE(2021),
    [sym_fsi_directive_decl] = STATE(2021),
    [sym_preproc_line] = STATE(2021),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_with] = ACTIONS(3620),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_DOT_DOT2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
    [sym__dedent] = ACTIONS(3622),
  },
  [2022] = {
    [sym_xml_doc] = STATE(2022),
    [sym_block_comment] = STATE(2022),
    [sym_line_comment] = STATE(2022),
    [sym_compiler_directive_decl] = STATE(2022),
    [sym_fsi_directive_decl] = STATE(2022),
    [sym_preproc_line] = STATE(2022),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
    [sym__dedent] = ACTIONS(3776),
  },
  [2023] = {
    [sym_xml_doc] = STATE(2023),
    [sym_block_comment] = STATE(2023),
    [sym_line_comment] = STATE(2023),
    [sym_compiler_directive_decl] = STATE(2023),
    [sym_fsi_directive_decl] = STATE(2023),
    [sym_preproc_line] = STATE(2023),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_as] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
    [sym__dedent] = ACTIONS(3699),
  },
  [2024] = {
    [sym_xml_doc] = STATE(2024),
    [sym_block_comment] = STATE(2024),
    [sym_line_comment] = STATE(2024),
    [sym_compiler_directive_decl] = STATE(2024),
    [sym_fsi_directive_decl] = STATE(2024),
    [sym_preproc_line] = STATE(2024),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_as] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_with] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
    [sym__dedent] = ACTIONS(3583),
  },
  [2025] = {
    [sym_xml_doc] = STATE(2025),
    [sym_block_comment] = STATE(2025),
    [sym_line_comment] = STATE(2025),
    [sym_compiler_directive_decl] = STATE(2025),
    [sym_fsi_directive_decl] = STATE(2025),
    [sym_preproc_line] = STATE(2025),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_as] = ACTIONS(3679),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_with] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
    [sym__dedent] = ACTIONS(3546),
  },
  [2026] = {
    [sym_xml_doc] = STATE(2026),
    [sym_block_comment] = STATE(2026),
    [sym_line_comment] = STATE(2026),
    [sym_compiler_directive_decl] = STATE(2026),
    [sym_fsi_directive_decl] = STATE(2026),
    [sym_preproc_line] = STATE(2026),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_as] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_with] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
    [sym__dedent] = ACTIONS(3691),
  },
  [2027] = {
    [sym_xml_doc] = STATE(2027),
    [sym_block_comment] = STATE(2027),
    [sym_line_comment] = STATE(2027),
    [sym_compiler_directive_decl] = STATE(2027),
    [sym_fsi_directive_decl] = STATE(2027),
    [sym_preproc_line] = STATE(2027),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_COLON] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_QMARK] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_AT_GT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3387),
    [anon_sym_DOT] = ACTIONS(3387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_COLON_GT] = ACTIONS(3389),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_LT_DASH] = ACTIONS(3387),
    [anon_sym_DOT_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_or] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3387),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3387),
    [anon_sym_DASH_DOT] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3387),
    [aux_sym_infix_op_token1] = ACTIONS(3387),
    [anon_sym_PIPE_PIPE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_COLON_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3387),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
    [sym__newline] = ACTIONS(3389),
  },
  [2028] = {
    [sym_xml_doc] = STATE(2028),
    [sym_block_comment] = STATE(2028),
    [sym_line_comment] = STATE(2028),
    [sym_compiler_directive_decl] = STATE(2028),
    [sym_fsi_directive_decl] = STATE(2028),
    [sym_preproc_line] = STATE(2028),
    [aux_sym_sequential_expression_repeat1] = STATE(1873),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_with] = ACTIONS(3612),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
    [sym__dedent] = ACTIONS(3614),
  },
  [2029] = {
    [sym_xml_doc] = STATE(2029),
    [sym_block_comment] = STATE(2029),
    [sym_line_comment] = STATE(2029),
    [sym_compiler_directive_decl] = STATE(2029),
    [sym_fsi_directive_decl] = STATE(2029),
    [sym_preproc_line] = STATE(2029),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_as] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_with] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
    [sym__dedent] = ACTIONS(3587),
  },
  [2030] = {
    [sym_xml_doc] = STATE(2030),
    [sym_block_comment] = STATE(2030),
    [sym_line_comment] = STATE(2030),
    [sym_compiler_directive_decl] = STATE(2030),
    [sym_fsi_directive_decl] = STATE(2030),
    [sym_preproc_line] = STATE(2030),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_DOT_DOT] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [2031] = {
    [sym_xml_doc] = STATE(2031),
    [sym_block_comment] = STATE(2031),
    [sym_line_comment] = STATE(2031),
    [sym_compiler_directive_decl] = STATE(2031),
    [sym_fsi_directive_decl] = STATE(2031),
    [sym_preproc_line] = STATE(2031),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_DOT_DOT] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2032] = {
    [sym_xml_doc] = STATE(2032),
    [sym_block_comment] = STATE(2032),
    [sym_line_comment] = STATE(2032),
    [sym_compiler_directive_decl] = STATE(2032),
    [sym_fsi_directive_decl] = STATE(2032),
    [sym_preproc_line] = STATE(2032),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_as] = ACTIONS(3859),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_with] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2033] = {
    [sym_xml_doc] = STATE(2033),
    [sym_block_comment] = STATE(2033),
    [sym_line_comment] = STATE(2033),
    [sym_compiler_directive_decl] = STATE(2033),
    [sym_fsi_directive_decl] = STATE(2033),
    [sym_preproc_line] = STATE(2033),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4745),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_GT] = ACTIONS(3554),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [2034] = {
    [sym_xml_doc] = STATE(2034),
    [sym_block_comment] = STATE(2034),
    [sym_line_comment] = STATE(2034),
    [sym_compiler_directive_decl] = STATE(2034),
    [sym_fsi_directive_decl] = STATE(2034),
    [sym_preproc_line] = STATE(2034),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2035] = {
    [sym_xml_doc] = STATE(2035),
    [sym_block_comment] = STATE(2035),
    [sym_line_comment] = STATE(2035),
    [sym_compiler_directive_decl] = STATE(2035),
    [sym_fsi_directive_decl] = STATE(2035),
    [sym_preproc_line] = STATE(2035),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4711),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2036] = {
    [sym_xml_doc] = STATE(2036),
    [sym_block_comment] = STATE(2036),
    [sym_line_comment] = STATE(2036),
    [sym_compiler_directive_decl] = STATE(2036),
    [sym_fsi_directive_decl] = STATE(2036),
    [sym_preproc_line] = STATE(2036),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [anon_sym_POUNDendif] = ACTIONS(4173),
    [anon_sym_POUNDelse] = ACTIONS(4173),
    [sym__newline] = ACTIONS(3546),
  },
  [2037] = {
    [sym_xml_doc] = STATE(2037),
    [sym_block_comment] = STATE(2037),
    [sym_line_comment] = STATE(2037),
    [sym_compiler_directive_decl] = STATE(2037),
    [sym_fsi_directive_decl] = STATE(2037),
    [sym_preproc_line] = STATE(2037),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_as] = ACTIONS(3840),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_with] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2038] = {
    [sym_xml_doc] = STATE(2038),
    [sym_block_comment] = STATE(2038),
    [sym_line_comment] = STATE(2038),
    [sym_compiler_directive_decl] = STATE(2038),
    [sym_fsi_directive_decl] = STATE(2038),
    [sym_preproc_line] = STATE(2038),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_as] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2039] = {
    [sym_xml_doc] = STATE(2039),
    [sym_block_comment] = STATE(2039),
    [sym_line_comment] = STATE(2039),
    [sym_compiler_directive_decl] = STATE(2039),
    [sym_fsi_directive_decl] = STATE(2039),
    [sym_preproc_line] = STATE(2039),
    [aux_sym_sequential_expression_repeat1] = STATE(2039),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_AT_AT_GT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4747),
  },
  [2040] = {
    [sym_xml_doc] = STATE(2040),
    [sym_block_comment] = STATE(2040),
    [sym_line_comment] = STATE(2040),
    [sym_compiler_directive_decl] = STATE(2040),
    [sym_fsi_directive_decl] = STATE(2040),
    [sym_preproc_line] = STATE(2040),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_as] = ACTIONS(3836),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_with] = ACTIONS(3836),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2041] = {
    [sym_xml_doc] = STATE(2041),
    [sym_block_comment] = STATE(2041),
    [sym_line_comment] = STATE(2041),
    [sym_compiler_directive_decl] = STATE(2041),
    [sym_fsi_directive_decl] = STATE(2041),
    [sym_preproc_line] = STATE(2041),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_DASH_GT] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_DOT_DOT] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2042] = {
    [sym_xml_doc] = STATE(2042),
    [sym_block_comment] = STATE(2042),
    [sym_line_comment] = STATE(2042),
    [sym_compiler_directive_decl] = STATE(2042),
    [sym_fsi_directive_decl] = STATE(2042),
    [sym_preproc_line] = STATE(2042),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_as] = ACTIONS(3825),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_with] = ACTIONS(3825),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2043] = {
    [sym_xml_doc] = STATE(2043),
    [sym_block_comment] = STATE(2043),
    [sym_line_comment] = STATE(2043),
    [sym_compiler_directive_decl] = STATE(2043),
    [sym_fsi_directive_decl] = STATE(2043),
    [sym_preproc_line] = STATE(2043),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_as] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2044] = {
    [sym_xml_doc] = STATE(2044),
    [sym_block_comment] = STATE(2044),
    [sym_line_comment] = STATE(2044),
    [sym_compiler_directive_decl] = STATE(2044),
    [sym_fsi_directive_decl] = STATE(2044),
    [sym_preproc_line] = STATE(2044),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_as] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_with] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2045] = {
    [sym_xml_doc] = STATE(2045),
    [sym_block_comment] = STATE(2045),
    [sym_line_comment] = STATE(2045),
    [sym_compiler_directive_decl] = STATE(2045),
    [sym_fsi_directive_decl] = STATE(2045),
    [sym_preproc_line] = STATE(2045),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_as] = ACTIONS(3679),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_with] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2046] = {
    [sym_xml_doc] = STATE(2046),
    [sym_block_comment] = STATE(2046),
    [sym_line_comment] = STATE(2046),
    [sym_compiler_directive_decl] = STATE(2046),
    [sym_fsi_directive_decl] = STATE(2046),
    [sym_preproc_line] = STATE(2046),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_DASH_GT] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_DOT_DOT] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2047] = {
    [sym_xml_doc] = STATE(2047),
    [sym_block_comment] = STATE(2047),
    [sym_line_comment] = STATE(2047),
    [sym_compiler_directive_decl] = STATE(2047),
    [sym_fsi_directive_decl] = STATE(2047),
    [sym_preproc_line] = STATE(2047),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4750),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2048] = {
    [sym_xml_doc] = STATE(2048),
    [sym_block_comment] = STATE(2048),
    [sym_line_comment] = STATE(2048),
    [sym_compiler_directive_decl] = STATE(2048),
    [sym_fsi_directive_decl] = STATE(2048),
    [sym_preproc_line] = STATE(2048),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_DASH_GT] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2049] = {
    [sym_xml_doc] = STATE(2049),
    [sym_block_comment] = STATE(2049),
    [sym_line_comment] = STATE(2049),
    [sym_compiler_directive_decl] = STATE(2049),
    [sym_fsi_directive_decl] = STATE(2049),
    [sym_preproc_line] = STATE(2049),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3314),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [anon_sym_EQ2] = ACTIONS(4483),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2050] = {
    [sym_xml_doc] = STATE(2050),
    [sym_block_comment] = STATE(2050),
    [sym_line_comment] = STATE(2050),
    [sym_compiler_directive_decl] = STATE(2050),
    [sym_fsi_directive_decl] = STATE(2050),
    [sym_preproc_line] = STATE(2050),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_DASH_GT] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2051] = {
    [sym_xml_doc] = STATE(2051),
    [sym_block_comment] = STATE(2051),
    [sym_line_comment] = STATE(2051),
    [sym_compiler_directive_decl] = STATE(2051),
    [sym_fsi_directive_decl] = STATE(2051),
    [sym_preproc_line] = STATE(2051),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_as] = ACTIONS(3802),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_with] = ACTIONS(3802),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2052] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2052),
    [sym_block_comment] = STATE(2052),
    [sym_line_comment] = STATE(2052),
    [sym_compiler_directive_decl] = STATE(2052),
    [sym_fsi_directive_decl] = STATE(2052),
    [sym_preproc_line] = STATE(2052),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_module] = ACTIONS(3024),
    [anon_sym_open] = ACTIONS(3024),
    [anon_sym_LBRACK_LT] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_type] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_and] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [aux_sym_access_modifier_token1] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_member] = ACTIONS(3024),
    [anon_sym_interface] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_override] = ACTIONS(3024),
    [anon_sym_val] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3022),
    [anon_sym_DASH_DOT] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3022),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3022),
    [anon_sym_POUNDload] = ACTIONS(3022),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
  },
  [2053] = {
    [sym_xml_doc] = STATE(2053),
    [sym_block_comment] = STATE(2053),
    [sym_line_comment] = STATE(2053),
    [sym_compiler_directive_decl] = STATE(2053),
    [sym_fsi_directive_decl] = STATE(2053),
    [sym_preproc_line] = STATE(2053),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_as] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2054] = {
    [sym_xml_doc] = STATE(2054),
    [sym_block_comment] = STATE(2054),
    [sym_line_comment] = STATE(2054),
    [sym_compiler_directive_decl] = STATE(2054),
    [sym_fsi_directive_decl] = STATE(2054),
    [sym_preproc_line] = STATE(2054),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_as] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_with] = ACTIONS(3790),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2055] = {
    [sym_xml_doc] = STATE(2055),
    [sym_block_comment] = STATE(2055),
    [sym_line_comment] = STATE(2055),
    [sym_compiler_directive_decl] = STATE(2055),
    [sym_fsi_directive_decl] = STATE(2055),
    [sym_preproc_line] = STATE(2055),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_as] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_with] = ACTIONS(3786),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2056] = {
    [sym_xml_doc] = STATE(2056),
    [sym_block_comment] = STATE(2056),
    [sym_line_comment] = STATE(2056),
    [sym_compiler_directive_decl] = STATE(2056),
    [sym_fsi_directive_decl] = STATE(2056),
    [sym_preproc_line] = STATE(2056),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_as] = ACTIONS(3620),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_with] = ACTIONS(3620),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2057] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5444),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2057),
    [sym_block_comment] = STATE(2057),
    [sym_line_comment] = STATE(2057),
    [sym_compiler_directive_decl] = STATE(2057),
    [sym_fsi_directive_decl] = STATE(2057),
    [sym_preproc_line] = STATE(2057),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [anon_sym_LT2] = ACTIONS(4762),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2058] = {
    [sym_xml_doc] = STATE(2058),
    [sym_block_comment] = STATE(2058),
    [sym_line_comment] = STATE(2058),
    [sym_compiler_directive_decl] = STATE(2058),
    [sym_fsi_directive_decl] = STATE(2058),
    [sym_preproc_line] = STATE(2058),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3624),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_with] = ACTIONS(3624),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2059] = {
    [sym_xml_doc] = STATE(2059),
    [sym_block_comment] = STATE(2059),
    [sym_line_comment] = STATE(2059),
    [sym_compiler_directive_decl] = STATE(2059),
    [sym_fsi_directive_decl] = STATE(2059),
    [sym_preproc_line] = STATE(2059),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_as] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_with] = ACTIONS(3782),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2060] = {
    [sym_xml_doc] = STATE(2060),
    [sym_block_comment] = STATE(2060),
    [sym_line_comment] = STATE(2060),
    [sym_compiler_directive_decl] = STATE(2060),
    [sym_fsi_directive_decl] = STATE(2060),
    [sym_preproc_line] = STATE(2060),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_as] = ACTIONS(3638),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_with] = ACTIONS(3638),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2061] = {
    [sym_xml_doc] = STATE(2061),
    [sym_block_comment] = STATE(2061),
    [sym_line_comment] = STATE(2061),
    [sym_compiler_directive_decl] = STATE(2061),
    [sym_fsi_directive_decl] = STATE(2061),
    [sym_preproc_line] = STATE(2061),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_as] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2062] = {
    [sym_xml_doc] = STATE(2062),
    [sym_block_comment] = STATE(2062),
    [sym_line_comment] = STATE(2062),
    [sym_compiler_directive_decl] = STATE(2062),
    [sym_fsi_directive_decl] = STATE(2062),
    [sym_preproc_line] = STATE(2062),
    [aux_sym_sequential_expression_repeat1] = STATE(2167),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_AT_GT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [2063] = {
    [sym_xml_doc] = STATE(2063),
    [sym_block_comment] = STATE(2063),
    [sym_line_comment] = STATE(2063),
    [sym_compiler_directive_decl] = STATE(2063),
    [sym_fsi_directive_decl] = STATE(2063),
    [sym_preproc_line] = STATE(2063),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4247),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_DASH_GT] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2064] = {
    [sym_xml_doc] = STATE(2064),
    [sym_block_comment] = STATE(2064),
    [sym_line_comment] = STATE(2064),
    [sym_compiler_directive_decl] = STATE(2064),
    [sym_fsi_directive_decl] = STATE(2064),
    [sym_preproc_line] = STATE(2064),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_as] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_with] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2065] = {
    [sym_xml_doc] = STATE(2065),
    [sym_block_comment] = STATE(2065),
    [sym_line_comment] = STATE(2065),
    [sym_compiler_directive_decl] = STATE(2065),
    [sym_fsi_directive_decl] = STATE(2065),
    [sym_preproc_line] = STATE(2065),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_as] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_with] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2066] = {
    [sym_xml_doc] = STATE(2066),
    [sym_block_comment] = STATE(2066),
    [sym_line_comment] = STATE(2066),
    [sym_compiler_directive_decl] = STATE(2066),
    [sym_fsi_directive_decl] = STATE(2066),
    [sym_preproc_line] = STATE(2066),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_as] = ACTIONS(3577),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_with] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2067] = {
    [sym_xml_doc] = STATE(2067),
    [sym_block_comment] = STATE(2067),
    [sym_line_comment] = STATE(2067),
    [sym_compiler_directive_decl] = STATE(2067),
    [sym_fsi_directive_decl] = STATE(2067),
    [sym_preproc_line] = STATE(2067),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_with] = ACTIONS(3770),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2068] = {
    [sym_xml_doc] = STATE(2068),
    [sym_block_comment] = STATE(2068),
    [sym_line_comment] = STATE(2068),
    [sym_compiler_directive_decl] = STATE(2068),
    [sym_fsi_directive_decl] = STATE(2068),
    [sym_preproc_line] = STATE(2068),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_with] = ACTIONS(3766),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2069] = {
    [sym_xml_doc] = STATE(2069),
    [sym_block_comment] = STATE(2069),
    [sym_line_comment] = STATE(2069),
    [sym_compiler_directive_decl] = STATE(2069),
    [sym_fsi_directive_decl] = STATE(2069),
    [sym_preproc_line] = STATE(2069),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_with] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2070] = {
    [sym_xml_doc] = STATE(2070),
    [sym_block_comment] = STATE(2070),
    [sym_line_comment] = STATE(2070),
    [sym_compiler_directive_decl] = STATE(2070),
    [sym_fsi_directive_decl] = STATE(2070),
    [sym_preproc_line] = STATE(2070),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_as] = ACTIONS(3738),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3738),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2071] = {
    [sym_xml_doc] = STATE(2071),
    [sym_block_comment] = STATE(2071),
    [sym_line_comment] = STATE(2071),
    [sym_compiler_directive_decl] = STATE(2071),
    [sym_fsi_directive_decl] = STATE(2071),
    [sym_preproc_line] = STATE(2071),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_as] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2072] = {
    [sym_xml_doc] = STATE(2072),
    [sym_block_comment] = STATE(2072),
    [sym_line_comment] = STATE(2072),
    [sym_compiler_directive_decl] = STATE(2072),
    [sym_fsi_directive_decl] = STATE(2072),
    [sym_preproc_line] = STATE(2072),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_as] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2073] = {
    [sym_xml_doc] = STATE(2073),
    [sym_block_comment] = STATE(2073),
    [sym_line_comment] = STATE(2073),
    [sym_compiler_directive_decl] = STATE(2073),
    [sym_fsi_directive_decl] = STATE(2073),
    [sym_preproc_line] = STATE(2073),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_as] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_with] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2074] = {
    [sym_xml_doc] = STATE(2074),
    [sym_block_comment] = STATE(2074),
    [sym_line_comment] = STATE(2074),
    [sym_compiler_directive_decl] = STATE(2074),
    [sym_fsi_directive_decl] = STATE(2074),
    [sym_preproc_line] = STATE(2074),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_as] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2075] = {
    [sym_xml_doc] = STATE(2075),
    [sym_block_comment] = STATE(2075),
    [sym_line_comment] = STATE(2075),
    [sym_compiler_directive_decl] = STATE(2075),
    [sym_fsi_directive_decl] = STATE(2075),
    [sym_preproc_line] = STATE(2075),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_as] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_with] = ACTIONS(3660),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2076] = {
    [sym_xml_doc] = STATE(2076),
    [sym_block_comment] = STATE(2076),
    [sym_line_comment] = STATE(2076),
    [sym_compiler_directive_decl] = STATE(2076),
    [sym_fsi_directive_decl] = STATE(2076),
    [sym_preproc_line] = STATE(2076),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_as] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_with] = ACTIONS(3656),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2077] = {
    [sym_xml_doc] = STATE(2077),
    [sym_block_comment] = STATE(2077),
    [sym_line_comment] = STATE(2077),
    [sym_compiler_directive_decl] = STATE(2077),
    [sym_fsi_directive_decl] = STATE(2077),
    [sym_preproc_line] = STATE(2077),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_as] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_with] = ACTIONS(3712),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2078] = {
    [sym_xml_doc] = STATE(2078),
    [sym_block_comment] = STATE(2078),
    [sym_line_comment] = STATE(2078),
    [sym_compiler_directive_decl] = STATE(2078),
    [sym_fsi_directive_decl] = STATE(2078),
    [sym_preproc_line] = STATE(2078),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_as] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_with] = ACTIONS(3718),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2079] = {
    [sym_xml_doc] = STATE(2079),
    [sym_block_comment] = STATE(2079),
    [sym_line_comment] = STATE(2079),
    [sym_compiler_directive_decl] = STATE(2079),
    [sym_fsi_directive_decl] = STATE(2079),
    [sym_preproc_line] = STATE(2079),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_as] = ACTIONS(3762),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_with] = ACTIONS(3762),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2080] = {
    [sym_xml_doc] = STATE(2080),
    [sym_block_comment] = STATE(2080),
    [sym_line_comment] = STATE(2080),
    [sym_compiler_directive_decl] = STATE(2080),
    [sym_fsi_directive_decl] = STATE(2080),
    [sym_preproc_line] = STATE(2080),
    [aux_sym_sequential_expression_repeat1] = STATE(2250),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_GT] = ACTIONS(3612),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [2081] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5754),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2573),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(3944),
    [sym_format_string] = STATE(3972),
    [sym__string_literal] = STATE(3972),
    [sym_string] = STATE(3944),
    [sym_verbatim_string] = STATE(3944),
    [sym_bytearray] = STATE(3944),
    [sym_verbatim_bytearray] = STATE(3944),
    [sym_format_triple_quoted_string] = STATE(3973),
    [sym_triple_quoted_string] = STATE(3944),
    [sym_const] = STATE(3956),
    [sym_long_identifier] = STATE(3911),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(3944),
    [sym_byte] = STATE(3944),
    [sym_int16] = STATE(3944),
    [sym_uint16] = STATE(3944),
    [sym_int32] = STATE(3944),
    [sym_uint32] = STATE(3944),
    [sym_nativeint] = STATE(3944),
    [sym_unativeint] = STATE(3944),
    [sym_int64] = STATE(3944),
    [sym_uint64] = STATE(3944),
    [sym_ieee32] = STATE(3944),
    [sym_ieee64] = STATE(3944),
    [sym_bignum] = STATE(3944),
    [sym_decimal] = STATE(3944),
    [sym_float] = STATE(3759),
    [sym_xml_doc] = STATE(2081),
    [sym_block_comment] = STATE(2081),
    [sym_line_comment] = STATE(2081),
    [sym_compiler_directive_decl] = STATE(2081),
    [sym_fsi_directive_decl] = STATE(2081),
    [sym_preproc_line] = STATE(2081),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4790),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [anon_sym_in] = ACTIONS(4519),
    [aux_sym_char_token1] = ACTIONS(4798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4800),
    [anon_sym_DQUOTE] = ACTIONS(4802),
    [anon_sym_AT_DQUOTE] = ACTIONS(4804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4808),
    [sym_bool] = ACTIONS(4810),
    [sym_unit] = ACTIONS(4812),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4818),
    [sym_xint] = ACTIONS(4820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2082] = {
    [sym_xml_doc] = STATE(2082),
    [sym_block_comment] = STATE(2082),
    [sym_line_comment] = STATE(2082),
    [sym_compiler_directive_decl] = STATE(2082),
    [sym_fsi_directive_decl] = STATE(2082),
    [sym_preproc_line] = STATE(2082),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_as] = ACTIONS(3910),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_with] = ACTIONS(3910),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2083] = {
    [sym_xml_doc] = STATE(2083),
    [sym_block_comment] = STATE(2083),
    [sym_line_comment] = STATE(2083),
    [sym_compiler_directive_decl] = STATE(2083),
    [sym_fsi_directive_decl] = STATE(2083),
    [sym_preproc_line] = STATE(2083),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2084] = {
    [sym_xml_doc] = STATE(2084),
    [sym_block_comment] = STATE(2084),
    [sym_line_comment] = STATE(2084),
    [sym_compiler_directive_decl] = STATE(2084),
    [sym_fsi_directive_decl] = STATE(2084),
    [sym_preproc_line] = STATE(2084),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4822),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2085] = {
    [sym_xml_doc] = STATE(2085),
    [sym_block_comment] = STATE(2085),
    [sym_line_comment] = STATE(2085),
    [sym_compiler_directive_decl] = STATE(2085),
    [sym_fsi_directive_decl] = STATE(2085),
    [sym_preproc_line] = STATE(2085),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_as] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3616),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2086] = {
    [sym_xml_doc] = STATE(2086),
    [sym_block_comment] = STATE(2086),
    [sym_line_comment] = STATE(2086),
    [sym_compiler_directive_decl] = STATE(2086),
    [sym_fsi_directive_decl] = STATE(2086),
    [sym_preproc_line] = STATE(2086),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_as] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2087] = {
    [sym_xml_doc] = STATE(2087),
    [sym_block_comment] = STATE(2087),
    [sym_line_comment] = STATE(2087),
    [sym_compiler_directive_decl] = STATE(2087),
    [sym_fsi_directive_decl] = STATE(2087),
    [sym_preproc_line] = STATE(2087),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2088] = {
    [sym_xml_doc] = STATE(2088),
    [sym_block_comment] = STATE(2088),
    [sym_line_comment] = STATE(2088),
    [sym_compiler_directive_decl] = STATE(2088),
    [sym_fsi_directive_decl] = STATE(2088),
    [sym_preproc_line] = STATE(2088),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [anon_sym_POUNDendif] = ACTIONS(3587),
    [anon_sym_POUNDelse] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2089] = {
    [sym_xml_doc] = STATE(2089),
    [sym_block_comment] = STATE(2089),
    [sym_line_comment] = STATE(2089),
    [sym_compiler_directive_decl] = STATE(2089),
    [sym_fsi_directive_decl] = STATE(2089),
    [sym_preproc_line] = STATE(2089),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_as] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_with] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2090] = {
    [sym_xml_doc] = STATE(2090),
    [sym_block_comment] = STATE(2090),
    [sym_line_comment] = STATE(2090),
    [sym_compiler_directive_decl] = STATE(2090),
    [sym_fsi_directive_decl] = STATE(2090),
    [sym_preproc_line] = STATE(2090),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4824),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [anon_sym_POUNDendif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [2091] = {
    [sym_xml_doc] = STATE(2091),
    [sym_block_comment] = STATE(2091),
    [sym_line_comment] = STATE(2091),
    [sym_compiler_directive_decl] = STATE(2091),
    [sym_fsi_directive_decl] = STATE(2091),
    [sym_preproc_line] = STATE(2091),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_as] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_with] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2092] = {
    [sym_xml_doc] = STATE(2092),
    [sym_block_comment] = STATE(2092),
    [sym_line_comment] = STATE(2092),
    [sym_compiler_directive_decl] = STATE(2092),
    [sym_fsi_directive_decl] = STATE(2092),
    [sym_preproc_line] = STATE(2092),
    [aux_sym_sequential_expression_repeat1] = STATE(2201),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_DOT_DOT] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [2093] = {
    [sym_xml_doc] = STATE(2093),
    [sym_block_comment] = STATE(2093),
    [sym_line_comment] = STATE(2093),
    [sym_compiler_directive_decl] = STATE(2093),
    [sym_fsi_directive_decl] = STATE(2093),
    [sym_preproc_line] = STATE(2093),
    [aux_sym_type_argument_repeat1] = STATE(2276),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_and] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [aux_sym_access_modifier_token1] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_member] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_abstract] = ACTIONS(3242),
    [anon_sym_override] = ACTIONS(3242),
    [anon_sym_val] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
  },
  [2094] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5543),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2094),
    [sym_block_comment] = STATE(2094),
    [sym_line_comment] = STATE(2094),
    [sym_compiler_directive_decl] = STATE(2094),
    [sym_fsi_directive_decl] = STATE(2094),
    [sym_preproc_line] = STATE(2094),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(4762),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2095] = {
    [sym_xml_doc] = STATE(2095),
    [sym_block_comment] = STATE(2095),
    [sym_line_comment] = STATE(2095),
    [sym_compiler_directive_decl] = STATE(2095),
    [sym_fsi_directive_decl] = STATE(2095),
    [sym_preproc_line] = STATE(2095),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_AT_AT_GT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4828),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2096] = {
    [sym_xml_doc] = STATE(2096),
    [sym_block_comment] = STATE(2096),
    [sym_line_comment] = STATE(2096),
    [sym_compiler_directive_decl] = STATE(2096),
    [sym_fsi_directive_decl] = STATE(2096),
    [sym_preproc_line] = STATE(2096),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2097] = {
    [sym_xml_doc] = STATE(2097),
    [sym_block_comment] = STATE(2097),
    [sym_line_comment] = STATE(2097),
    [sym_compiler_directive_decl] = STATE(2097),
    [sym_fsi_directive_decl] = STATE(2097),
    [sym_preproc_line] = STATE(2097),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_as] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_with] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2098] = {
    [sym_xml_doc] = STATE(2098),
    [sym_block_comment] = STATE(2098),
    [sym_line_comment] = STATE(2098),
    [sym_compiler_directive_decl] = STATE(2098),
    [sym_fsi_directive_decl] = STATE(2098),
    [sym_preproc_line] = STATE(2098),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_with] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2099] = {
    [sym_xml_doc] = STATE(2099),
    [sym_block_comment] = STATE(2099),
    [sym_line_comment] = STATE(2099),
    [sym_compiler_directive_decl] = STATE(2099),
    [sym_fsi_directive_decl] = STATE(2099),
    [sym_preproc_line] = STATE(2099),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2100] = {
    [sym_xml_doc] = STATE(2100),
    [sym_block_comment] = STATE(2100),
    [sym_line_comment] = STATE(2100),
    [sym_compiler_directive_decl] = STATE(2100),
    [sym_fsi_directive_decl] = STATE(2100),
    [sym_preproc_line] = STATE(2100),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [anon_sym_POUNDendif] = ACTIONS(3820),
    [anon_sym_POUNDelse] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2101] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2101),
    [sym_block_comment] = STATE(2101),
    [sym_line_comment] = STATE(2101),
    [sym_compiler_directive_decl] = STATE(2101),
    [sym_fsi_directive_decl] = STATE(2101),
    [sym_preproc_line] = STATE(2101),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(3090),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_open] = ACTIONS(3092),
    [anon_sym_LBRACK_LT] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_type] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [aux_sym_access_modifier_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_member] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_abstract] = ACTIONS(3092),
    [anon_sym_override] = ACTIONS(3092),
    [anon_sym_val] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3090),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3090),
    [anon_sym_DASH_DOT] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3090),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3090),
    [anon_sym_POUNDload] = ACTIONS(3090),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
  },
  [2102] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2102),
    [sym_block_comment] = STATE(2102),
    [sym_line_comment] = STATE(2102),
    [sym_compiler_directive_decl] = STATE(2102),
    [sym_fsi_directive_decl] = STATE(2102),
    [sym_preproc_line] = STATE(2102),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [aux_sym_access_modifier_token1] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_member] = ACTIONS(3032),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_val] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
  },
  [2103] = {
    [sym_xml_doc] = STATE(2103),
    [sym_block_comment] = STATE(2103),
    [sym_line_comment] = STATE(2103),
    [sym_compiler_directive_decl] = STATE(2103),
    [sym_fsi_directive_decl] = STATE(2103),
    [sym_preproc_line] = STATE(2103),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_with] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2104] = {
    [sym_xml_doc] = STATE(2104),
    [sym_block_comment] = STATE(2104),
    [sym_line_comment] = STATE(2104),
    [sym_compiler_directive_decl] = STATE(2104),
    [sym_fsi_directive_decl] = STATE(2104),
    [sym_preproc_line] = STATE(2104),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3965),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_with] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2105] = {
    [sym_xml_doc] = STATE(2105),
    [sym_block_comment] = STATE(2105),
    [sym_line_comment] = STATE(2105),
    [sym_compiler_directive_decl] = STATE(2105),
    [sym_fsi_directive_decl] = STATE(2105),
    [sym_preproc_line] = STATE(2105),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3961),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_with] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2106] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2106),
    [sym_block_comment] = STATE(2106),
    [sym_line_comment] = STATE(2106),
    [sym_compiler_directive_decl] = STATE(2106),
    [sym_fsi_directive_decl] = STATE(2106),
    [sym_preproc_line] = STATE(2106),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_open] = ACTIONS(3012),
    [anon_sym_LBRACK_LT] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [aux_sym_access_modifier_token1] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_member] = ACTIONS(3012),
    [anon_sym_interface] = ACTIONS(3012),
    [anon_sym_abstract] = ACTIONS(3012),
    [anon_sym_override] = ACTIONS(3012),
    [anon_sym_val] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3010),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3010),
    [anon_sym_DASH_DOT] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3010),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3010),
    [anon_sym_POUNDload] = ACTIONS(3010),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
  },
  [2107] = {
    [sym_xml_doc] = STATE(2107),
    [sym_block_comment] = STATE(2107),
    [sym_line_comment] = STATE(2107),
    [sym_compiler_directive_decl] = STATE(2107),
    [sym_fsi_directive_decl] = STATE(2107),
    [sym_preproc_line] = STATE(2107),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [anon_sym_POUNDendif] = ACTIONS(3658),
    [anon_sym_POUNDelse] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2108] = {
    [sym_xml_doc] = STATE(2108),
    [sym_block_comment] = STATE(2108),
    [sym_line_comment] = STATE(2108),
    [sym_compiler_directive_decl] = STATE(2108),
    [sym_fsi_directive_decl] = STATE(2108),
    [sym_preproc_line] = STATE(2108),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [anon_sym_POUNDendif] = ACTIONS(3662),
    [anon_sym_POUNDelse] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2109] = {
    [sym_xml_doc] = STATE(2109),
    [sym_block_comment] = STATE(2109),
    [sym_line_comment] = STATE(2109),
    [sym_compiler_directive_decl] = STATE(2109),
    [sym_fsi_directive_decl] = STATE(2109),
    [sym_preproc_line] = STATE(2109),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4448),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2110] = {
    [sym_xml_doc] = STATE(2110),
    [sym_block_comment] = STATE(2110),
    [sym_line_comment] = STATE(2110),
    [sym_compiler_directive_decl] = STATE(2110),
    [sym_fsi_directive_decl] = STATE(2110),
    [sym_preproc_line] = STATE(2110),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_as] = ACTIONS(3957),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_with] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2111] = {
    [sym_xml_doc] = STATE(2111),
    [sym_block_comment] = STATE(2111),
    [sym_line_comment] = STATE(2111),
    [sym_compiler_directive_decl] = STATE(2111),
    [sym_fsi_directive_decl] = STATE(2111),
    [sym_preproc_line] = STATE(2111),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_as] = ACTIONS(3953),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_with] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2112] = {
    [sym_xml_doc] = STATE(2112),
    [sym_block_comment] = STATE(2112),
    [sym_line_comment] = STATE(2112),
    [sym_compiler_directive_decl] = STATE(2112),
    [sym_fsi_directive_decl] = STATE(2112),
    [sym_preproc_line] = STATE(2112),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_as] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_with] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2113] = {
    [sym_xml_doc] = STATE(2113),
    [sym_block_comment] = STATE(2113),
    [sym_line_comment] = STATE(2113),
    [sym_compiler_directive_decl] = STATE(2113),
    [sym_fsi_directive_decl] = STATE(2113),
    [sym_preproc_line] = STATE(2113),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_as] = ACTIONS(3945),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_with] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2114] = {
    [sym_xml_doc] = STATE(2114),
    [sym_block_comment] = STATE(2114),
    [sym_line_comment] = STATE(2114),
    [sym_compiler_directive_decl] = STATE(2114),
    [sym_fsi_directive_decl] = STATE(2114),
    [sym_preproc_line] = STATE(2114),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [anon_sym_POUNDendif] = ACTIONS(3695),
    [anon_sym_POUNDelse] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2115] = {
    [sym_xml_doc] = STATE(2115),
    [sym_block_comment] = STATE(2115),
    [sym_line_comment] = STATE(2115),
    [sym_compiler_directive_decl] = STATE(2115),
    [sym_fsi_directive_decl] = STATE(2115),
    [sym_preproc_line] = STATE(2115),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2116] = {
    [sym_xml_doc] = STATE(2116),
    [sym_block_comment] = STATE(2116),
    [sym_line_comment] = STATE(2116),
    [sym_compiler_directive_decl] = STATE(2116),
    [sym_fsi_directive_decl] = STATE(2116),
    [sym_preproc_line] = STATE(2116),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [anon_sym_POUNDendif] = ACTIONS(3724),
    [anon_sym_POUNDelse] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2117] = {
    [sym_xml_doc] = STATE(2117),
    [sym_block_comment] = STATE(2117),
    [sym_line_comment] = STATE(2117),
    [sym_compiler_directive_decl] = STATE(2117),
    [sym_fsi_directive_decl] = STATE(2117),
    [sym_preproc_line] = STATE(2117),
    [aux_sym_sequential_expression_repeat1] = STATE(2117),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [anon_sym_POUNDendif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4830),
  },
  [2118] = {
    [sym_xml_doc] = STATE(2118),
    [sym_block_comment] = STATE(2118),
    [sym_line_comment] = STATE(2118),
    [sym_compiler_directive_decl] = STATE(2118),
    [sym_fsi_directive_decl] = STATE(2118),
    [sym_preproc_line] = STATE(2118),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_as] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_with] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2119] = {
    [sym_xml_doc] = STATE(2119),
    [sym_block_comment] = STATE(2119),
    [sym_line_comment] = STATE(2119),
    [sym_compiler_directive_decl] = STATE(2119),
    [sym_fsi_directive_decl] = STATE(2119),
    [sym_preproc_line] = STATE(2119),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [anon_sym_POUNDendif] = ACTIONS(3728),
    [anon_sym_POUNDelse] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2120] = {
    [sym_xml_doc] = STATE(2120),
    [sym_block_comment] = STATE(2120),
    [sym_line_comment] = STATE(2120),
    [sym_compiler_directive_decl] = STATE(2120),
    [sym_fsi_directive_decl] = STATE(2120),
    [sym_preproc_line] = STATE(2120),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_GT] = ACTIONS(3542),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [2121] = {
    [sym_xml_doc] = STATE(2121),
    [sym_block_comment] = STATE(2121),
    [sym_line_comment] = STATE(2121),
    [sym_compiler_directive_decl] = STATE(2121),
    [sym_fsi_directive_decl] = STATE(2121),
    [sym_preproc_line] = STATE(2121),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3483),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2122] = {
    [sym_xml_doc] = STATE(2122),
    [sym_block_comment] = STATE(2122),
    [sym_line_comment] = STATE(2122),
    [sym_compiler_directive_decl] = STATE(2122),
    [sym_fsi_directive_decl] = STATE(2122),
    [sym_preproc_line] = STATE(2122),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [anon_sym_POUNDendif] = ACTIONS(3736),
    [anon_sym_POUNDelse] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2123] = {
    [sym_xml_doc] = STATE(2123),
    [sym_block_comment] = STATE(2123),
    [sym_line_comment] = STATE(2123),
    [sym_compiler_directive_decl] = STATE(2123),
    [sym_fsi_directive_decl] = STATE(2123),
    [sym_preproc_line] = STATE(2123),
    [aux_sym_long_identifier_repeat1] = STATE(2176),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_GT] = ACTIONS(3261),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [2124] = {
    [sym_xml_doc] = STATE(2124),
    [sym_block_comment] = STATE(2124),
    [sym_line_comment] = STATE(2124),
    [sym_compiler_directive_decl] = STATE(2124),
    [sym_fsi_directive_decl] = STATE(2124),
    [sym_preproc_line] = STATE(2124),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [anon_sym_POUNDendif] = ACTIONS(3740),
    [anon_sym_POUNDelse] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2125] = {
    [sym_xml_doc] = STATE(2125),
    [sym_block_comment] = STATE(2125),
    [sym_line_comment] = STATE(2125),
    [sym_compiler_directive_decl] = STATE(2125),
    [sym_fsi_directive_decl] = STATE(2125),
    [sym_preproc_line] = STATE(2125),
    [aux_sym_long_identifier_repeat1] = STATE(2128),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4837),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [anon_sym_POUNDendif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [2126] = {
    [sym_xml_doc] = STATE(2126),
    [sym_block_comment] = STATE(2126),
    [sym_line_comment] = STATE(2126),
    [sym_compiler_directive_decl] = STATE(2126),
    [sym_fsi_directive_decl] = STATE(2126),
    [sym_preproc_line] = STATE(2126),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_as] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2127] = {
    [sym_xml_doc] = STATE(2127),
    [sym_block_comment] = STATE(2127),
    [sym_line_comment] = STATE(2127),
    [sym_compiler_directive_decl] = STATE(2127),
    [sym_fsi_directive_decl] = STATE(2127),
    [sym_preproc_line] = STATE(2127),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_as] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2128] = {
    [sym_xml_doc] = STATE(2128),
    [sym_block_comment] = STATE(2128),
    [sym_line_comment] = STATE(2128),
    [sym_compiler_directive_decl] = STATE(2128),
    [sym_fsi_directive_decl] = STATE(2128),
    [sym_preproc_line] = STATE(2128),
    [aux_sym_long_identifier_repeat1] = STATE(2128),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2129] = {
    [sym_xml_doc] = STATE(2129),
    [sym_block_comment] = STATE(2129),
    [sym_line_comment] = STATE(2129),
    [sym_compiler_directive_decl] = STATE(2129),
    [sym_fsi_directive_decl] = STATE(2129),
    [sym_preproc_line] = STATE(2129),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_as] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_with] = ACTIONS(3642),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2130] = {
    [sym_xml_doc] = STATE(2130),
    [sym_block_comment] = STATE(2130),
    [sym_line_comment] = STATE(2130),
    [sym_compiler_directive_decl] = STATE(2130),
    [sym_fsi_directive_decl] = STATE(2130),
    [sym_preproc_line] = STATE(2130),
    [aux_sym_sequential_expression_repeat1] = STATE(2130),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_DASH_GT] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4842),
  },
  [2131] = {
    [sym_xml_doc] = STATE(2131),
    [sym_block_comment] = STATE(2131),
    [sym_line_comment] = STATE(2131),
    [sym_compiler_directive_decl] = STATE(2131),
    [sym_fsi_directive_decl] = STATE(2131),
    [sym_preproc_line] = STATE(2131),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_as] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_with] = ACTIONS(3794),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2132] = {
    [sym_xml_doc] = STATE(2132),
    [sym_block_comment] = STATE(2132),
    [sym_line_comment] = STATE(2132),
    [sym_compiler_directive_decl] = STATE(2132),
    [sym_fsi_directive_decl] = STATE(2132),
    [sym_preproc_line] = STATE(2132),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_as] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_with] = ACTIONS(3914),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2133] = {
    [sym_xml_doc] = STATE(2133),
    [sym_block_comment] = STATE(2133),
    [sym_line_comment] = STATE(2133),
    [sym_compiler_directive_decl] = STATE(2133),
    [sym_fsi_directive_decl] = STATE(2133),
    [sym_preproc_line] = STATE(2133),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [anon_sym_POUNDendif] = ACTIONS(3748),
    [anon_sym_POUNDelse] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2134] = {
    [sym_xml_doc] = STATE(2134),
    [sym_block_comment] = STATE(2134),
    [sym_line_comment] = STATE(2134),
    [sym_compiler_directive_decl] = STATE(2134),
    [sym_fsi_directive_decl] = STATE(2134),
    [sym_preproc_line] = STATE(2134),
    [aux_sym_long_identifier_repeat1] = STATE(2125),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [anon_sym_POUNDendif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [2135] = {
    [sym_xml_doc] = STATE(2135),
    [sym_block_comment] = STATE(2135),
    [sym_line_comment] = STATE(2135),
    [sym_compiler_directive_decl] = STATE(2135),
    [sym_fsi_directive_decl] = STATE(2135),
    [sym_preproc_line] = STATE(2135),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [anon_sym_POUNDendif] = ACTIONS(3816),
    [anon_sym_POUNDelse] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2136] = {
    [sym_xml_doc] = STATE(2136),
    [sym_block_comment] = STATE(2136),
    [sym_line_comment] = STATE(2136),
    [sym_compiler_directive_decl] = STATE(2136),
    [sym_fsi_directive_decl] = STATE(2136),
    [sym_preproc_line] = STATE(2136),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_as] = ACTIONS(3906),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_with] = ACTIONS(3906),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2137] = {
    [sym_xml_doc] = STATE(2137),
    [sym_block_comment] = STATE(2137),
    [sym_line_comment] = STATE(2137),
    [sym_compiler_directive_decl] = STATE(2137),
    [sym_fsi_directive_decl] = STATE(2137),
    [sym_preproc_line] = STATE(2137),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4849),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2138] = {
    [sym_xml_doc] = STATE(2138),
    [sym_block_comment] = STATE(2138),
    [sym_line_comment] = STATE(2138),
    [sym_compiler_directive_decl] = STATE(2138),
    [sym_fsi_directive_decl] = STATE(2138),
    [sym_preproc_line] = STATE(2138),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [anon_sym_POUNDendif] = ACTIONS(3768),
    [anon_sym_POUNDelse] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2139] = {
    [sym_xml_doc] = STATE(2139),
    [sym_block_comment] = STATE(2139),
    [sym_line_comment] = STATE(2139),
    [sym_compiler_directive_decl] = STATE(2139),
    [sym_fsi_directive_decl] = STATE(2139),
    [sym_preproc_line] = STATE(2139),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3899),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_with] = ACTIONS(3899),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2140] = {
    [sym_xml_doc] = STATE(2140),
    [sym_block_comment] = STATE(2140),
    [sym_line_comment] = STATE(2140),
    [sym_compiler_directive_decl] = STATE(2140),
    [sym_fsi_directive_decl] = STATE(2140),
    [sym_preproc_line] = STATE(2140),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_as] = ACTIONS(3895),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_with] = ACTIONS(3895),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2141] = {
    [sym_xml_doc] = STATE(2141),
    [sym_block_comment] = STATE(2141),
    [sym_line_comment] = STATE(2141),
    [sym_compiler_directive_decl] = STATE(2141),
    [sym_fsi_directive_decl] = STATE(2141),
    [sym_preproc_line] = STATE(2141),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_as] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_with] = ACTIONS(3701),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2142] = {
    [sym_xml_doc] = STATE(2142),
    [sym_block_comment] = STATE(2142),
    [sym_line_comment] = STATE(2142),
    [sym_compiler_directive_decl] = STATE(2142),
    [sym_fsi_directive_decl] = STATE(2142),
    [sym_preproc_line] = STATE(2142),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_as] = ACTIONS(3598),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_with] = ACTIONS(3598),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2143] = {
    [sym_xml_doc] = STATE(2143),
    [sym_block_comment] = STATE(2143),
    [sym_line_comment] = STATE(2143),
    [sym_compiler_directive_decl] = STATE(2143),
    [sym_fsi_directive_decl] = STATE(2143),
    [sym_preproc_line] = STATE(2143),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [anon_sym_POUNDendif] = ACTIONS(3772),
    [anon_sym_POUNDelse] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2144] = {
    [sym_xml_doc] = STATE(2144),
    [sym_block_comment] = STATE(2144),
    [sym_line_comment] = STATE(2144),
    [sym_compiler_directive_decl] = STATE(2144),
    [sym_fsi_directive_decl] = STATE(2144),
    [sym_preproc_line] = STATE(2144),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_GT] = ACTIONS(3523),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2145] = {
    [sym_xml_doc] = STATE(2145),
    [sym_block_comment] = STATE(2145),
    [sym_line_comment] = STATE(2145),
    [sym_compiler_directive_decl] = STATE(2145),
    [sym_fsi_directive_decl] = STATE(2145),
    [sym_preproc_line] = STATE(2145),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_as] = ACTIONS(3888),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_with] = ACTIONS(3888),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2146] = {
    [sym_xml_doc] = STATE(2146),
    [sym_block_comment] = STATE(2146),
    [sym_line_comment] = STATE(2146),
    [sym_compiler_directive_decl] = STATE(2146),
    [sym_fsi_directive_decl] = STATE(2146),
    [sym_preproc_line] = STATE(2146),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_as] = ACTIONS(3884),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_with] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2147] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3841),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym__pattern_param] = STATE(2615),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2147),
    [sym_block_comment] = STATE(2147),
    [sym_line_comment] = STATE(2147),
    [sym_compiler_directive_decl] = STATE(2147),
    [sym_fsi_directive_decl] = STATE(2147),
    [sym_preproc_line] = STATE(2147),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4519),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4523),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4519),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4519),
    [anon_sym__] = ACTIONS(4519),
    [anon_sym_QMARK] = ACTIONS(4523),
    [anon_sym_COLON_QMARK] = ACTIONS(4523),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4523),
    [anon_sym_LBRACE] = ACTIONS(4523),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4519),
    [anon_sym_DQUOTE] = ACTIONS(4519),
    [anon_sym_AT_DQUOTE] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [sym_bool] = ACTIONS(4519),
    [sym_unit] = ACTIONS(4523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4519),
    [sym_op_identifier] = ACTIONS(4523),
    [sym_int] = ACTIONS(4519),
    [sym_xint] = ACTIONS(4523),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2148] = {
    [sym_xml_doc] = STATE(2148),
    [sym_block_comment] = STATE(2148),
    [sym_line_comment] = STATE(2148),
    [sym_compiler_directive_decl] = STATE(2148),
    [sym_fsi_directive_decl] = STATE(2148),
    [sym_preproc_line] = STATE(2148),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [anon_sym_POUNDendif] = ACTIONS(3579),
    [anon_sym_POUNDelse] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2149] = {
    [sym_xml_doc] = STATE(2149),
    [sym_block_comment] = STATE(2149),
    [sym_line_comment] = STATE(2149),
    [sym_compiler_directive_decl] = STATE(2149),
    [sym_fsi_directive_decl] = STATE(2149),
    [sym_preproc_line] = STATE(2149),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [anon_sym_POUNDendif] = ACTIONS(3780),
    [anon_sym_POUNDelse] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2150] = {
    [sym_xml_doc] = STATE(2150),
    [sym_block_comment] = STATE(2150),
    [sym_line_comment] = STATE(2150),
    [sym_compiler_directive_decl] = STATE(2150),
    [sym_fsi_directive_decl] = STATE(2150),
    [sym_preproc_line] = STATE(2150),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_AT_AT_GT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [2151] = {
    [sym_xml_doc] = STATE(2151),
    [sym_block_comment] = STATE(2151),
    [sym_line_comment] = STATE(2151),
    [sym_compiler_directive_decl] = STATE(2151),
    [sym_fsi_directive_decl] = STATE(2151),
    [sym_preproc_line] = STATE(2151),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_with] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2152] = {
    [sym_xml_doc] = STATE(2152),
    [sym_block_comment] = STATE(2152),
    [sym_line_comment] = STATE(2152),
    [sym_compiler_directive_decl] = STATE(2152),
    [sym_fsi_directive_decl] = STATE(2152),
    [sym_preproc_line] = STATE(2152),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_as] = ACTIONS(3863),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2153] = {
    [sym_xml_doc] = STATE(2153),
    [sym_block_comment] = STATE(2153),
    [sym_line_comment] = STATE(2153),
    [sym_compiler_directive_decl] = STATE(2153),
    [sym_fsi_directive_decl] = STATE(2153),
    [sym_preproc_line] = STATE(2153),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_AT_GT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [2154] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5780),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2681),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(3884),
    [sym_format_string] = STATE(3883),
    [sym__string_literal] = STATE(3883),
    [sym_string] = STATE(3884),
    [sym_verbatim_string] = STATE(3884),
    [sym_bytearray] = STATE(3884),
    [sym_verbatim_bytearray] = STATE(3884),
    [sym_format_triple_quoted_string] = STATE(3882),
    [sym_triple_quoted_string] = STATE(3884),
    [sym_const] = STATE(3923),
    [sym_long_identifier] = STATE(3753),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(3884),
    [sym_byte] = STATE(3884),
    [sym_int16] = STATE(3884),
    [sym_uint16] = STATE(3884),
    [sym_int32] = STATE(3884),
    [sym_uint32] = STATE(3884),
    [sym_nativeint] = STATE(3884),
    [sym_unativeint] = STATE(3884),
    [sym_int64] = STATE(3884),
    [sym_uint64] = STATE(3884),
    [sym_ieee32] = STATE(3884),
    [sym_ieee64] = STATE(3884),
    [sym_bignum] = STATE(3884),
    [sym_decimal] = STATE(3884),
    [sym_float] = STATE(3697),
    [sym_xml_doc] = STATE(2154),
    [sym_block_comment] = STATE(2154),
    [sym_line_comment] = STATE(2154),
    [sym_compiler_directive_decl] = STATE(2154),
    [sym_fsi_directive_decl] = STATE(2154),
    [sym_preproc_line] = STATE(2154),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4525),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [anon_sym_DASH_GT] = ACTIONS(4523),
    [anon_sym_when] = ACTIONS(4519),
    [aux_sym_char_token1] = ACTIONS(4539),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4541),
    [anon_sym_DQUOTE] = ACTIONS(4543),
    [anon_sym_AT_DQUOTE] = ACTIONS(4545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4547),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4549),
    [sym_bool] = ACTIONS(4551),
    [sym_unit] = ACTIONS(4553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4559),
    [sym_xint] = ACTIONS(4561),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2155] = {
    [sym_xml_doc] = STATE(2155),
    [sym_block_comment] = STATE(2155),
    [sym_line_comment] = STATE(2155),
    [sym_compiler_directive_decl] = STATE(2155),
    [sym_fsi_directive_decl] = STATE(2155),
    [sym_preproc_line] = STATE(2155),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_AT_GT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2156] = {
    [sym_xml_doc] = STATE(2156),
    [sym_block_comment] = STATE(2156),
    [sym_line_comment] = STATE(2156),
    [sym_compiler_directive_decl] = STATE(2156),
    [sym_fsi_directive_decl] = STATE(2156),
    [sym_preproc_line] = STATE(2156),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4849),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2157] = {
    [sym_xml_doc] = STATE(2157),
    [sym_block_comment] = STATE(2157),
    [sym_line_comment] = STATE(2157),
    [sym_compiler_directive_decl] = STATE(2157),
    [sym_fsi_directive_decl] = STATE(2157),
    [sym_preproc_line] = STATE(2157),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [2158] = {
    [sym_xml_doc] = STATE(2158),
    [sym_block_comment] = STATE(2158),
    [sym_line_comment] = STATE(2158),
    [sym_compiler_directive_decl] = STATE(2158),
    [sym_fsi_directive_decl] = STATE(2158),
    [sym_preproc_line] = STATE(2158),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_as] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_with] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2159] = {
    [sym_xml_doc] = STATE(2159),
    [sym_block_comment] = STATE(2159),
    [sym_line_comment] = STATE(2159),
    [sym_compiler_directive_decl] = STATE(2159),
    [sym_fsi_directive_decl] = STATE(2159),
    [sym_preproc_line] = STATE(2159),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_DASH_GT] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2160] = {
    [sym_xml_doc] = STATE(2160),
    [sym_block_comment] = STATE(2160),
    [sym_line_comment] = STATE(2160),
    [sym_compiler_directive_decl] = STATE(2160),
    [sym_fsi_directive_decl] = STATE(2160),
    [sym_preproc_line] = STATE(2160),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [anon_sym_POUNDendif] = ACTIONS(3312),
    [anon_sym_POUNDelse] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2161] = {
    [sym_xml_doc] = STATE(2161),
    [sym_block_comment] = STATE(2161),
    [sym_line_comment] = STATE(2161),
    [sym_compiler_directive_decl] = STATE(2161),
    [sym_fsi_directive_decl] = STATE(2161),
    [sym_preproc_line] = STATE(2161),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [anon_sym_POUNDendif] = ACTIONS(3312),
    [anon_sym_POUNDelse] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2162] = {
    [sym_xml_doc] = STATE(2162),
    [sym_block_comment] = STATE(2162),
    [sym_line_comment] = STATE(2162),
    [sym_compiler_directive_decl] = STATE(2162),
    [sym_fsi_directive_decl] = STATE(2162),
    [sym_preproc_line] = STATE(2162),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_AT_AT_GT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2163] = {
    [sym_xml_doc] = STATE(2163),
    [sym_block_comment] = STATE(2163),
    [sym_line_comment] = STATE(2163),
    [sym_compiler_directive_decl] = STATE(2163),
    [sym_fsi_directive_decl] = STATE(2163),
    [sym_preproc_line] = STATE(2163),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2164] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5546),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(2164),
    [sym_block_comment] = STATE(2164),
    [sym_line_comment] = STATE(2164),
    [sym_compiler_directive_decl] = STATE(2164),
    [sym_fsi_directive_decl] = STATE(2164),
    [sym_preproc_line] = STATE(2164),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [sym__newline] = ACTIONS(4762),
    [sym__dedent] = ACTIONS(4762),
  },
  [2165] = {
    [sym_xml_doc] = STATE(2165),
    [sym_block_comment] = STATE(2165),
    [sym_line_comment] = STATE(2165),
    [sym_compiler_directive_decl] = STATE(2165),
    [sym_fsi_directive_decl] = STATE(2165),
    [sym_preproc_line] = STATE(2165),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [anon_sym_POUNDendif] = ACTIONS(3784),
    [anon_sym_POUNDelse] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2166] = {
    [sym_xml_doc] = STATE(2166),
    [sym_block_comment] = STATE(2166),
    [sym_line_comment] = STATE(2166),
    [sym_compiler_directive_decl] = STATE(2166),
    [sym_fsi_directive_decl] = STATE(2166),
    [sym_preproc_line] = STATE(2166),
    [aux_sym_sequential_expression_repeat1] = STATE(2039),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_AT_AT_GT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [2167] = {
    [sym_xml_doc] = STATE(2167),
    [sym_block_comment] = STATE(2167),
    [sym_line_comment] = STATE(2167),
    [sym_compiler_directive_decl] = STATE(2167),
    [sym_fsi_directive_decl] = STATE(2167),
    [sym_preproc_line] = STATE(2167),
    [aux_sym_sequential_expression_repeat1] = STATE(2167),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_AT_GT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4877),
  },
  [2168] = {
    [sym_xml_doc] = STATE(2168),
    [sym_block_comment] = STATE(2168),
    [sym_line_comment] = STATE(2168),
    [sym_compiler_directive_decl] = STATE(2168),
    [sym_fsi_directive_decl] = STATE(2168),
    [sym_preproc_line] = STATE(2168),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_DASH_GT] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2169] = {
    [sym_xml_doc] = STATE(2169),
    [sym_block_comment] = STATE(2169),
    [sym_line_comment] = STATE(2169),
    [sym_compiler_directive_decl] = STATE(2169),
    [sym_fsi_directive_decl] = STATE(2169),
    [sym_preproc_line] = STATE(2169),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_DASH_GT] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2170] = {
    [sym_xml_doc] = STATE(2170),
    [sym_block_comment] = STATE(2170),
    [sym_line_comment] = STATE(2170),
    [sym_compiler_directive_decl] = STATE(2170),
    [sym_fsi_directive_decl] = STATE(2170),
    [sym_preproc_line] = STATE(2170),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [anon_sym_POUNDendif] = ACTIONS(3744),
    [anon_sym_POUNDelse] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2171] = {
    [sym_xml_doc] = STATE(2171),
    [sym_block_comment] = STATE(2171),
    [sym_line_comment] = STATE(2171),
    [sym_compiler_directive_decl] = STATE(2171),
    [sym_fsi_directive_decl] = STATE(2171),
    [sym_preproc_line] = STATE(2171),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_DASH_GT] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2172] = {
    [sym_xml_doc] = STATE(2172),
    [sym_block_comment] = STATE(2172),
    [sym_line_comment] = STATE(2172),
    [sym_compiler_directive_decl] = STATE(2172),
    [sym_fsi_directive_decl] = STATE(2172),
    [sym_preproc_line] = STATE(2172),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2173] = {
    [sym_xml_doc] = STATE(2173),
    [sym_block_comment] = STATE(2173),
    [sym_line_comment] = STATE(2173),
    [sym_compiler_directive_decl] = STATE(2173),
    [sym_fsi_directive_decl] = STATE(2173),
    [sym_preproc_line] = STATE(2173),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_DASH_GT] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_DOT_DOT] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2174] = {
    [sym_xml_doc] = STATE(2174),
    [sym_block_comment] = STATE(2174),
    [sym_line_comment] = STATE(2174),
    [sym_compiler_directive_decl] = STATE(2174),
    [sym_fsi_directive_decl] = STATE(2174),
    [sym_preproc_line] = STATE(2174),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_with] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2175] = {
    [sym_xml_doc] = STATE(2175),
    [sym_block_comment] = STATE(2175),
    [sym_line_comment] = STATE(2175),
    [sym_compiler_directive_decl] = STATE(2175),
    [sym_fsi_directive_decl] = STATE(2175),
    [sym_preproc_line] = STATE(2175),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_DOT_DOT] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2176] = {
    [sym_xml_doc] = STATE(2176),
    [sym_block_comment] = STATE(2176),
    [sym_line_comment] = STATE(2176),
    [sym_compiler_directive_decl] = STATE(2176),
    [sym_fsi_directive_decl] = STATE(2176),
    [sym_preproc_line] = STATE(2176),
    [aux_sym_long_identifier_repeat1] = STATE(2279),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4880),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [2177] = {
    [sym_xml_doc] = STATE(2177),
    [sym_block_comment] = STATE(2177),
    [sym_line_comment] = STATE(2177),
    [sym_compiler_directive_decl] = STATE(2177),
    [sym_fsi_directive_decl] = STATE(2177),
    [sym_preproc_line] = STATE(2177),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_with] = ACTIONS(3814),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2178] = {
    [sym_xml_doc] = STATE(2178),
    [sym_block_comment] = STATE(2178),
    [sym_line_comment] = STATE(2178),
    [sym_compiler_directive_decl] = STATE(2178),
    [sym_fsi_directive_decl] = STATE(2178),
    [sym_preproc_line] = STATE(2178),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_DASH_GT] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_DOT_DOT] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2179] = {
    [sym_xml_doc] = STATE(2179),
    [sym_block_comment] = STATE(2179),
    [sym_line_comment] = STATE(2179),
    [sym_compiler_directive_decl] = STATE(2179),
    [sym_fsi_directive_decl] = STATE(2179),
    [sym_preproc_line] = STATE(2179),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_DASH_GT] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2180] = {
    [sym_xml_doc] = STATE(2180),
    [sym_block_comment] = STATE(2180),
    [sym_line_comment] = STATE(2180),
    [sym_compiler_directive_decl] = STATE(2180),
    [sym_fsi_directive_decl] = STATE(2180),
    [sym_preproc_line] = STATE(2180),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2181] = {
    [sym_xml_doc] = STATE(2181),
    [sym_block_comment] = STATE(2181),
    [sym_line_comment] = STATE(2181),
    [sym_compiler_directive_decl] = STATE(2181),
    [sym_fsi_directive_decl] = STATE(2181),
    [sym_preproc_line] = STATE(2181),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_DASH_GT] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_DOT_DOT] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2182] = {
    [sym_xml_doc] = STATE(2182),
    [sym_block_comment] = STATE(2182),
    [sym_line_comment] = STATE(2182),
    [sym_compiler_directive_decl] = STATE(2182),
    [sym_fsi_directive_decl] = STATE(2182),
    [sym_preproc_line] = STATE(2182),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [anon_sym_POUNDendif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [2183] = {
    [sym_xml_doc] = STATE(2183),
    [sym_block_comment] = STATE(2183),
    [sym_line_comment] = STATE(2183),
    [sym_compiler_directive_decl] = STATE(2183),
    [sym_fsi_directive_decl] = STATE(2183),
    [sym_preproc_line] = STATE(2183),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_DASH_GT] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2184] = {
    [sym_xml_doc] = STATE(2184),
    [sym_block_comment] = STATE(2184),
    [sym_line_comment] = STATE(2184),
    [sym_compiler_directive_decl] = STATE(2184),
    [sym_fsi_directive_decl] = STATE(2184),
    [sym_preproc_line] = STATE(2184),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [anon_sym_POUNDendif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [2185] = {
    [sym_xml_doc] = STATE(2185),
    [sym_block_comment] = STATE(2185),
    [sym_line_comment] = STATE(2185),
    [sym_compiler_directive_decl] = STATE(2185),
    [sym_fsi_directive_decl] = STATE(2185),
    [sym_preproc_line] = STATE(2185),
    [aux_sym_sequential_expression_repeat1] = STATE(2130),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_DASH_GT] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [2186] = {
    [sym_xml_doc] = STATE(2186),
    [sym_block_comment] = STATE(2186),
    [sym_line_comment] = STATE(2186),
    [sym_compiler_directive_decl] = STATE(2186),
    [sym_fsi_directive_decl] = STATE(2186),
    [sym_preproc_line] = STATE(2186),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4882),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [anon_sym_POUNDendif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2187] = {
    [sym_xml_doc] = STATE(2187),
    [sym_block_comment] = STATE(2187),
    [sym_line_comment] = STATE(2187),
    [sym_compiler_directive_decl] = STATE(2187),
    [sym_fsi_directive_decl] = STATE(2187),
    [sym_preproc_line] = STATE(2187),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [anon_sym_POUNDendif] = ACTIONS(3618),
    [anon_sym_POUNDelse] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2188] = {
    [sym_xml_doc] = STATE(2188),
    [sym_block_comment] = STATE(2188),
    [sym_line_comment] = STATE(2188),
    [sym_compiler_directive_decl] = STATE(2188),
    [sym_fsi_directive_decl] = STATE(2188),
    [sym_preproc_line] = STATE(2188),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_AT_GT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_done] = ACTIONS(4884),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3527),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2189] = {
    [sym_xml_doc] = STATE(2189),
    [sym_block_comment] = STATE(2189),
    [sym_line_comment] = STATE(2189),
    [sym_compiler_directive_decl] = STATE(2189),
    [sym_fsi_directive_decl] = STATE(2189),
    [sym_preproc_line] = STATE(2189),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_DOT_DOT] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [2190] = {
    [sym_xml_doc] = STATE(2190),
    [sym_block_comment] = STATE(2190),
    [sym_line_comment] = STATE(2190),
    [sym_compiler_directive_decl] = STATE(2190),
    [sym_fsi_directive_decl] = STATE(2190),
    [sym_preproc_line] = STATE(2190),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2191] = {
    [sym_xml_doc] = STATE(2191),
    [sym_block_comment] = STATE(2191),
    [sym_line_comment] = STATE(2191),
    [sym_compiler_directive_decl] = STATE(2191),
    [sym_fsi_directive_decl] = STATE(2191),
    [sym_preproc_line] = STATE(2191),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [anon_sym_POUNDendif] = ACTIONS(3583),
    [anon_sym_POUNDelse] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2192] = {
    [sym_xml_doc] = STATE(2192),
    [sym_block_comment] = STATE(2192),
    [sym_line_comment] = STATE(2192),
    [sym_compiler_directive_decl] = STATE(2192),
    [sym_fsi_directive_decl] = STATE(2192),
    [sym_preproc_line] = STATE(2192),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [anon_sym_POUNDendif] = ACTIONS(3776),
    [anon_sym_POUNDelse] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2193] = {
    [sym_xml_doc] = STATE(2193),
    [sym_block_comment] = STATE(2193),
    [sym_line_comment] = STATE(2193),
    [sym_compiler_directive_decl] = STATE(2193),
    [sym_fsi_directive_decl] = STATE(2193),
    [sym_preproc_line] = STATE(2193),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3742),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_with] = ACTIONS(3742),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2194] = {
    [sym_xml_doc] = STATE(2194),
    [sym_block_comment] = STATE(2194),
    [sym_line_comment] = STATE(2194),
    [sym_compiler_directive_decl] = STATE(2194),
    [sym_fsi_directive_decl] = STATE(2194),
    [sym_preproc_line] = STATE(2194),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_DOT_DOT] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2195] = {
    [sym_xml_doc] = STATE(2195),
    [sym_block_comment] = STATE(2195),
    [sym_line_comment] = STATE(2195),
    [sym_compiler_directive_decl] = STATE(2195),
    [sym_fsi_directive_decl] = STATE(2195),
    [sym_preproc_line] = STATE(2195),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_AT_AT_GT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4693),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2196] = {
    [sym_xml_doc] = STATE(2196),
    [sym_block_comment] = STATE(2196),
    [sym_line_comment] = STATE(2196),
    [sym_compiler_directive_decl] = STATE(2196),
    [sym_fsi_directive_decl] = STATE(2196),
    [sym_preproc_line] = STATE(2196),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_DASH_GT] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2197] = {
    [sym_xml_doc] = STATE(2197),
    [sym_block_comment] = STATE(2197),
    [sym_line_comment] = STATE(2197),
    [sym_compiler_directive_decl] = STATE(2197),
    [sym_fsi_directive_decl] = STATE(2197),
    [sym_preproc_line] = STATE(2197),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_DASH_GT] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2198] = {
    [sym_xml_doc] = STATE(2198),
    [sym_block_comment] = STATE(2198),
    [sym_line_comment] = STATE(2198),
    [sym_compiler_directive_decl] = STATE(2198),
    [sym_fsi_directive_decl] = STATE(2198),
    [sym_preproc_line] = STATE(2198),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_DASH_GT] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_DOT_DOT] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2199] = {
    [sym_xml_doc] = STATE(2199),
    [sym_block_comment] = STATE(2199),
    [sym_line_comment] = STATE(2199),
    [sym_compiler_directive_decl] = STATE(2199),
    [sym_fsi_directive_decl] = STATE(2199),
    [sym_preproc_line] = STATE(2199),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_DASH_GT] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_DOT_DOT] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2200] = {
    [sym_xml_doc] = STATE(2200),
    [sym_block_comment] = STATE(2200),
    [sym_line_comment] = STATE(2200),
    [sym_compiler_directive_decl] = STATE(2200),
    [sym_fsi_directive_decl] = STATE(2200),
    [sym_preproc_line] = STATE(2200),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_DASH_GT] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_DOT_DOT] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2201] = {
    [sym_xml_doc] = STATE(2201),
    [sym_block_comment] = STATE(2201),
    [sym_line_comment] = STATE(2201),
    [sym_compiler_directive_decl] = STATE(2201),
    [sym_fsi_directive_decl] = STATE(2201),
    [sym_preproc_line] = STATE(2201),
    [aux_sym_sequential_expression_repeat1] = STATE(2201),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4886),
  },
  [2202] = {
    [sym_xml_doc] = STATE(2202),
    [sym_block_comment] = STATE(2202),
    [sym_line_comment] = STATE(2202),
    [sym_compiler_directive_decl] = STATE(2202),
    [sym_fsi_directive_decl] = STATE(2202),
    [sym_preproc_line] = STATE(2202),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4889),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_DOT_DOT] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [2203] = {
    [sym_xml_doc] = STATE(2203),
    [sym_block_comment] = STATE(2203),
    [sym_line_comment] = STATE(2203),
    [sym_compiler_directive_decl] = STATE(2203),
    [sym_fsi_directive_decl] = STATE(2203),
    [sym_preproc_line] = STATE(2203),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_DASH_GT] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_DOT_DOT] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2204] = {
    [sym_xml_doc] = STATE(2204),
    [sym_block_comment] = STATE(2204),
    [sym_line_comment] = STATE(2204),
    [sym_compiler_directive_decl] = STATE(2204),
    [sym_fsi_directive_decl] = STATE(2204),
    [sym_preproc_line] = STATE(2204),
    [aux_sym_long_identifier_repeat1] = STATE(2204),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_AT_AT_GT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2205] = {
    [sym_xml_doc] = STATE(2205),
    [sym_block_comment] = STATE(2205),
    [sym_line_comment] = STATE(2205),
    [sym_compiler_directive_decl] = STATE(2205),
    [sym_fsi_directive_decl] = STATE(2205),
    [sym_preproc_line] = STATE(2205),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_DASH_GT] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_DOT_DOT] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2206] = {
    [sym_xml_doc] = STATE(2206),
    [sym_block_comment] = STATE(2206),
    [sym_line_comment] = STATE(2206),
    [sym_compiler_directive_decl] = STATE(2206),
    [sym_fsi_directive_decl] = STATE(2206),
    [sym_preproc_line] = STATE(2206),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_DASH_GT] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_DOT_DOT] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2207] = {
    [sym_xml_doc] = STATE(2207),
    [sym_block_comment] = STATE(2207),
    [sym_line_comment] = STATE(2207),
    [sym_compiler_directive_decl] = STATE(2207),
    [sym_fsi_directive_decl] = STATE(2207),
    [sym_preproc_line] = STATE(2207),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_DASH_GT] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_DOT_DOT] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2208] = {
    [sym_xml_doc] = STATE(2208),
    [sym_block_comment] = STATE(2208),
    [sym_line_comment] = STATE(2208),
    [sym_compiler_directive_decl] = STATE(2208),
    [sym_fsi_directive_decl] = STATE(2208),
    [sym_preproc_line] = STATE(2208),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [anon_sym_POUNDendif] = ACTIONS(3788),
    [anon_sym_POUNDelse] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2209] = {
    [sym_xml_doc] = STATE(2209),
    [sym_block_comment] = STATE(2209),
    [sym_line_comment] = STATE(2209),
    [sym_compiler_directive_decl] = STATE(2209),
    [sym_fsi_directive_decl] = STATE(2209),
    [sym_preproc_line] = STATE(2209),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3608),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_with] = ACTIONS(3608),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2210] = {
    [sym_xml_doc] = STATE(2210),
    [sym_block_comment] = STATE(2210),
    [sym_line_comment] = STATE(2210),
    [sym_compiler_directive_decl] = STATE(2210),
    [sym_fsi_directive_decl] = STATE(2210),
    [sym_preproc_line] = STATE(2210),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_AT_GT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2211] = {
    [sym_xml_doc] = STATE(2211),
    [sym_block_comment] = STATE(2211),
    [sym_line_comment] = STATE(2211),
    [sym_compiler_directive_decl] = STATE(2211),
    [sym_fsi_directive_decl] = STATE(2211),
    [sym_preproc_line] = STATE(2211),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [anon_sym_POUNDendif] = ACTIONS(3707),
    [anon_sym_POUNDelse] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2212] = {
    [sym_xml_doc] = STATE(2212),
    [sym_block_comment] = STATE(2212),
    [sym_line_comment] = STATE(2212),
    [sym_compiler_directive_decl] = STATE(2212),
    [sym_fsi_directive_decl] = STATE(2212),
    [sym_preproc_line] = STATE(2212),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_DASH_GT] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2213] = {
    [sym_xml_doc] = STATE(2213),
    [sym_block_comment] = STATE(2213),
    [sym_line_comment] = STATE(2213),
    [sym_compiler_directive_decl] = STATE(2213),
    [sym_fsi_directive_decl] = STATE(2213),
    [sym_preproc_line] = STATE(2213),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_DASH_GT] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2214] = {
    [sym_xml_doc] = STATE(2214),
    [sym_block_comment] = STATE(2214),
    [sym_line_comment] = STATE(2214),
    [sym_compiler_directive_decl] = STATE(2214),
    [sym_fsi_directive_decl] = STATE(2214),
    [sym_preproc_line] = STATE(2214),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [anon_sym_POUNDendif] = ACTIONS(3792),
    [anon_sym_POUNDelse] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2215] = {
    [sym_xml_doc] = STATE(2215),
    [sym_block_comment] = STATE(2215),
    [sym_line_comment] = STATE(2215),
    [sym_compiler_directive_decl] = STATE(2215),
    [sym_fsi_directive_decl] = STATE(2215),
    [sym_preproc_line] = STATE(2215),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [anon_sym_POUNDendif] = ACTIONS(3861),
    [anon_sym_POUNDelse] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2216] = {
    [sym_xml_doc] = STATE(2216),
    [sym_block_comment] = STATE(2216),
    [sym_line_comment] = STATE(2216),
    [sym_compiler_directive_decl] = STATE(2216),
    [sym_fsi_directive_decl] = STATE(2216),
    [sym_preproc_line] = STATE(2216),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_DASH_GT] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_DOT_DOT] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2217] = {
    [sym_xml_doc] = STATE(2217),
    [sym_block_comment] = STATE(2217),
    [sym_line_comment] = STATE(2217),
    [sym_compiler_directive_decl] = STATE(2217),
    [sym_fsi_directive_decl] = STATE(2217),
    [sym_preproc_line] = STATE(2217),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_DOT_DOT] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2218] = {
    [sym_xml_doc] = STATE(2218),
    [sym_block_comment] = STATE(2218),
    [sym_line_comment] = STATE(2218),
    [sym_compiler_directive_decl] = STATE(2218),
    [sym_fsi_directive_decl] = STATE(2218),
    [sym_preproc_line] = STATE(2218),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_DASH_GT] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_DOT_DOT] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2219] = {
    [sym_xml_doc] = STATE(2219),
    [sym_block_comment] = STATE(2219),
    [sym_line_comment] = STATE(2219),
    [sym_compiler_directive_decl] = STATE(2219),
    [sym_fsi_directive_decl] = STATE(2219),
    [sym_preproc_line] = STATE(2219),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_DASH_GT] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_DOT_DOT] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2220] = {
    [sym_xml_doc] = STATE(2220),
    [sym_block_comment] = STATE(2220),
    [sym_line_comment] = STATE(2220),
    [sym_compiler_directive_decl] = STATE(2220),
    [sym_fsi_directive_decl] = STATE(2220),
    [sym_preproc_line] = STATE(2220),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_DASH_GT] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_DOT_DOT] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2221] = {
    [sym_xml_doc] = STATE(2221),
    [sym_block_comment] = STATE(2221),
    [sym_line_comment] = STATE(2221),
    [sym_compiler_directive_decl] = STATE(2221),
    [sym_fsi_directive_decl] = STATE(2221),
    [sym_preproc_line] = STATE(2221),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_DASH_GT] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_DOT_DOT] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2222] = {
    [sym_xml_doc] = STATE(2222),
    [sym_block_comment] = STATE(2222),
    [sym_line_comment] = STATE(2222),
    [sym_compiler_directive_decl] = STATE(2222),
    [sym_fsi_directive_decl] = STATE(2222),
    [sym_preproc_line] = STATE(2222),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_DASH_GT] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_DOT_DOT] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2223] = {
    [sym_xml_doc] = STATE(2223),
    [sym_block_comment] = STATE(2223),
    [sym_line_comment] = STATE(2223),
    [sym_compiler_directive_decl] = STATE(2223),
    [sym_fsi_directive_decl] = STATE(2223),
    [sym_preproc_line] = STATE(2223),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_DASH_GT] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2224] = {
    [sym_xml_doc] = STATE(2224),
    [sym_block_comment] = STATE(2224),
    [sym_line_comment] = STATE(2224),
    [sym_compiler_directive_decl] = STATE(2224),
    [sym_fsi_directive_decl] = STATE(2224),
    [sym_preproc_line] = STATE(2224),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [anon_sym_POUNDendif] = ACTIONS(3800),
    [anon_sym_POUNDelse] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2225] = {
    [sym_xml_doc] = STATE(2225),
    [sym_block_comment] = STATE(2225),
    [sym_line_comment] = STATE(2225),
    [sym_compiler_directive_decl] = STATE(2225),
    [sym_fsi_directive_decl] = STATE(2225),
    [sym_preproc_line] = STATE(2225),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_DASH_GT] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2226] = {
    [sym_xml_doc] = STATE(2226),
    [sym_block_comment] = STATE(2226),
    [sym_line_comment] = STATE(2226),
    [sym_compiler_directive_decl] = STATE(2226),
    [sym_fsi_directive_decl] = STATE(2226),
    [sym_preproc_line] = STATE(2226),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_DASH_GT] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_DOT_DOT] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2227] = {
    [sym_xml_doc] = STATE(2227),
    [sym_block_comment] = STATE(2227),
    [sym_line_comment] = STATE(2227),
    [sym_compiler_directive_decl] = STATE(2227),
    [sym_fsi_directive_decl] = STATE(2227),
    [sym_preproc_line] = STATE(2227),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_DASH_GT] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_DOT_DOT] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2228] = {
    [sym_xml_doc] = STATE(2228),
    [sym_block_comment] = STATE(2228),
    [sym_line_comment] = STATE(2228),
    [sym_compiler_directive_decl] = STATE(2228),
    [sym_fsi_directive_decl] = STATE(2228),
    [sym_preproc_line] = STATE(2228),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_DASH_GT] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_DOT_DOT] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2229] = {
    [sym_xml_doc] = STATE(2229),
    [sym_block_comment] = STATE(2229),
    [sym_line_comment] = STATE(2229),
    [sym_compiler_directive_decl] = STATE(2229),
    [sym_fsi_directive_decl] = STATE(2229),
    [sym_preproc_line] = STATE(2229),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_DASH_GT] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2230] = {
    [sym_xml_doc] = STATE(2230),
    [sym_block_comment] = STATE(2230),
    [sym_line_comment] = STATE(2230),
    [sym_compiler_directive_decl] = STATE(2230),
    [sym_fsi_directive_decl] = STATE(2230),
    [sym_preproc_line] = STATE(2230),
    [sym_identifier] = ACTIONS(3483),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3483),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_QMARK] = ACTIONS(3483),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_LT_AT] = ACTIONS(3483),
    [anon_sym_LT_AT_AT] = ACTIONS(3483),
    [anon_sym_AT_AT_GT] = ACTIONS(3483),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3483),
    [anon_sym_assert] = ACTIONS(3483),
    [anon_sym_upcast] = ACTIONS(3483),
    [anon_sym_downcast] = ACTIONS(3483),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_fun] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_match] = ACTIONS(3483),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3483),
    [anon_sym_LT_DASH] = ACTIONS(3483),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3483),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3483),
    [anon_sym_LPAREN2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3483),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3483),
    [sym_unit] = ACTIONS(3483),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3483),
    [sym_op_identifier] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_PLUS_DOT] = ACTIONS(3483),
    [anon_sym_DASH_DOT] = ACTIONS(3483),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3483),
    [aux_sym_infix_op_token1] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3483),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3483),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3483),
    [sym_int] = ACTIONS(3483),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2231] = {
    [sym_xml_doc] = STATE(2231),
    [sym_block_comment] = STATE(2231),
    [sym_line_comment] = STATE(2231),
    [sym_compiler_directive_decl] = STATE(2231),
    [sym_fsi_directive_decl] = STATE(2231),
    [sym_preproc_line] = STATE(2231),
    [sym_identifier] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_return] = ACTIONS(3542),
    [anon_sym_do] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_let_BANG] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_null] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_LT_AT] = ACTIONS(3542),
    [anon_sym_LT_AT_AT] = ACTIONS(3542),
    [anon_sym_AT_AT_GT] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3544),
    [anon_sym_new] = ACTIONS(3542),
    [anon_sym_return_BANG] = ACTIONS(3544),
    [anon_sym_yield] = ACTIONS(3542),
    [anon_sym_yield_BANG] = ACTIONS(3544),
    [anon_sym_lazy] = ACTIONS(3542),
    [anon_sym_assert] = ACTIONS(3542),
    [anon_sym_upcast] = ACTIONS(3542),
    [anon_sym_downcast] = ACTIONS(3542),
    [anon_sym_COLON_GT] = ACTIONS(3544),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3544),
    [anon_sym_for] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_fun] = ACTIONS(3542),
    [anon_sym_try] = ACTIONS(3542),
    [anon_sym_match] = ACTIONS(3542),
    [anon_sym_match_BANG] = ACTIONS(3544),
    [anon_sym_function] = ACTIONS(3542),
    [anon_sym_LT_DASH] = ACTIONS(3542),
    [anon_sym_DOT_LBRACK] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_use] = ACTIONS(3542),
    [anon_sym_use_BANG] = ACTIONS(3544),
    [anon_sym_do_BANG] = ACTIONS(3544),
    [anon_sym_begin] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3544),
    [anon_sym_or] = ACTIONS(3542),
    [aux_sym_char_token1] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_AT_DQUOTE] = ACTIONS(3544),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3544),
    [sym_bool] = ACTIONS(3542),
    [sym_unit] = ACTIONS(3542),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3542),
    [sym_op_identifier] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_DOT] = ACTIONS(3542),
    [anon_sym_DASH_DOT] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3544),
    [aux_sym_prefix_op_token1] = ACTIONS(3542),
    [aux_sym_infix_op_token1] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOLLAR] = ACTIONS(3542),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3542),
    [sym_int] = ACTIONS(3542),
    [sym_xint] = ACTIONS(3544),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3544),
    [sym__newline] = ACTIONS(3544),
  },
  [2232] = {
    [sym_xml_doc] = STATE(2232),
    [sym_block_comment] = STATE(2232),
    [sym_line_comment] = STATE(2232),
    [sym_compiler_directive_decl] = STATE(2232),
    [sym_fsi_directive_decl] = STATE(2232),
    [sym_preproc_line] = STATE(2232),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_DASH_GT] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_DOT_DOT] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2233] = {
    [sym_xml_doc] = STATE(2233),
    [sym_block_comment] = STATE(2233),
    [sym_line_comment] = STATE(2233),
    [sym_compiler_directive_decl] = STATE(2233),
    [sym_fsi_directive_decl] = STATE(2233),
    [sym_preproc_line] = STATE(2233),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_DASH_GT] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_DOT_DOT] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2234] = {
    [sym_xml_doc] = STATE(2234),
    [sym_block_comment] = STATE(2234),
    [sym_line_comment] = STATE(2234),
    [sym_compiler_directive_decl] = STATE(2234),
    [sym_fsi_directive_decl] = STATE(2234),
    [sym_preproc_line] = STATE(2234),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_DASH_GT] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_DOT_DOT] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2235] = {
    [sym_xml_doc] = STATE(2235),
    [sym_block_comment] = STATE(2235),
    [sym_line_comment] = STATE(2235),
    [sym_compiler_directive_decl] = STATE(2235),
    [sym_fsi_directive_decl] = STATE(2235),
    [sym_preproc_line] = STATE(2235),
    [aux_sym_long_identifier_repeat1] = STATE(2204),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_AT_AT_GT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4894),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [2236] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4132),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym__pattern_param] = STATE(2400),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2236),
    [sym_block_comment] = STATE(2236),
    [sym_line_comment] = STATE(2236),
    [sym_compiler_directive_decl] = STATE(2236),
    [sym_fsi_directive_decl] = STATE(2236),
    [sym_preproc_line] = STATE(2236),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4519),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4519),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4519),
    [anon_sym__] = ACTIONS(4519),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4523),
    [anon_sym_LBRACE] = ACTIONS(4523),
    [anon_sym_DASH_GT] = ACTIONS(4523),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4519),
    [anon_sym_DQUOTE] = ACTIONS(4519),
    [anon_sym_AT_DQUOTE] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [sym_bool] = ACTIONS(4519),
    [sym_unit] = ACTIONS(4523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4519),
    [sym_xint] = ACTIONS(4523),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2237] = {
    [sym_xml_doc] = STATE(2237),
    [sym_block_comment] = STATE(2237),
    [sym_line_comment] = STATE(2237),
    [sym_compiler_directive_decl] = STATE(2237),
    [sym_fsi_directive_decl] = STATE(2237),
    [sym_preproc_line] = STATE(2237),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [anon_sym_POUNDendif] = ACTIONS(3699),
    [anon_sym_POUNDelse] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2238] = {
    [sym_xml_doc] = STATE(2238),
    [sym_block_comment] = STATE(2238),
    [sym_line_comment] = STATE(2238),
    [sym_compiler_directive_decl] = STATE(2238),
    [sym_fsi_directive_decl] = STATE(2238),
    [sym_preproc_line] = STATE(2238),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [anon_sym_POUNDelse] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2239] = {
    [sym_xml_doc] = STATE(2239),
    [sym_block_comment] = STATE(2239),
    [sym_line_comment] = STATE(2239),
    [sym_compiler_directive_decl] = STATE(2239),
    [sym_fsi_directive_decl] = STATE(2239),
    [sym_preproc_line] = STATE(2239),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [anon_sym_POUNDendif] = ACTIONS(3804),
    [anon_sym_POUNDelse] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2240] = {
    [sym_xml_doc] = STATE(2240),
    [sym_block_comment] = STATE(2240),
    [sym_line_comment] = STATE(2240),
    [sym_compiler_directive_decl] = STATE(2240),
    [sym_fsi_directive_decl] = STATE(2240),
    [sym_preproc_line] = STATE(2240),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [anon_sym_POUNDendif] = ACTIONS(3546),
    [anon_sym_POUNDelse] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2241] = {
    [sym_xml_doc] = STATE(2241),
    [sym_block_comment] = STATE(2241),
    [sym_line_comment] = STATE(2241),
    [sym_compiler_directive_decl] = STATE(2241),
    [sym_fsi_directive_decl] = STATE(2241),
    [sym_preproc_line] = STATE(2241),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_DASH_GT] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_DOT_DOT] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2242] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5560),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2242),
    [sym_block_comment] = STATE(2242),
    [sym_line_comment] = STATE(2242),
    [sym_compiler_directive_decl] = STATE(2242),
    [sym_fsi_directive_decl] = STATE(2242),
    [sym_preproc_line] = STATE(2242),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [anon_sym_DASH_GT] = ACTIONS(4762),
    [anon_sym_when] = ACTIONS(4764),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2243] = {
    [sym_xml_doc] = STATE(2243),
    [sym_block_comment] = STATE(2243),
    [sym_line_comment] = STATE(2243),
    [sym_compiler_directive_decl] = STATE(2243),
    [sym_fsi_directive_decl] = STATE(2243),
    [sym_preproc_line] = STATE(2243),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_AT_GT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [2244] = {
    [sym_xml_doc] = STATE(2244),
    [sym_block_comment] = STATE(2244),
    [sym_line_comment] = STATE(2244),
    [sym_compiler_directive_decl] = STATE(2244),
    [sym_fsi_directive_decl] = STATE(2244),
    [sym_preproc_line] = STATE(2244),
    [aux_sym_long_identifier_repeat1] = STATE(2235),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_AT_AT_GT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [2245] = {
    [sym_xml_doc] = STATE(2245),
    [sym_block_comment] = STATE(2245),
    [sym_line_comment] = STATE(2245),
    [sym_compiler_directive_decl] = STATE(2245),
    [sym_fsi_directive_decl] = STATE(2245),
    [sym_preproc_line] = STATE(2245),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3285),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [anon_sym_EQ2] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2246] = {
    [sym_xml_doc] = STATE(2246),
    [sym_block_comment] = STATE(2246),
    [sym_line_comment] = STATE(2246),
    [sym_compiler_directive_decl] = STATE(2246),
    [sym_fsi_directive_decl] = STATE(2246),
    [sym_preproc_line] = STATE(2246),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_DASH_GT] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_DOT_DOT] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2247] = {
    [sym_xml_doc] = STATE(2247),
    [sym_block_comment] = STATE(2247),
    [sym_line_comment] = STATE(2247),
    [sym_compiler_directive_decl] = STATE(2247),
    [sym_fsi_directive_decl] = STATE(2247),
    [sym_preproc_line] = STATE(2247),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_DOT_DOT] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2248] = {
    [sym_xml_doc] = STATE(2248),
    [sym_block_comment] = STATE(2248),
    [sym_line_comment] = STATE(2248),
    [sym_compiler_directive_decl] = STATE(2248),
    [sym_fsi_directive_decl] = STATE(2248),
    [sym_preproc_line] = STATE(2248),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_DOT_DOT] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2249] = {
    [sym_xml_doc] = STATE(2249),
    [sym_block_comment] = STATE(2249),
    [sym_line_comment] = STATE(2249),
    [sym_compiler_directive_decl] = STATE(2249),
    [sym_fsi_directive_decl] = STATE(2249),
    [sym_preproc_line] = STATE(2249),
    [aux_sym_sequential_expression_repeat1] = STATE(2117),
    [sym_identifier] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(3614),
    [anon_sym_COLON] = ACTIONS(3612),
    [anon_sym_return] = ACTIONS(3612),
    [anon_sym_do] = ACTIONS(3612),
    [anon_sym_let] = ACTIONS(3612),
    [anon_sym_let_BANG] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_COMMA] = ACTIONS(3614),
    [anon_sym_null] = ACTIONS(3612),
    [anon_sym_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_QMARK] = ACTIONS(3612),
    [anon_sym_COLON_COLON] = ACTIONS(3614),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(3612),
    [anon_sym_LT_AT] = ACTIONS(3612),
    [anon_sym_LT_AT_AT] = ACTIONS(3612),
    [anon_sym_DOT] = ACTIONS(3612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3612),
    [anon_sym_return_BANG] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3612),
    [anon_sym_yield_BANG] = ACTIONS(3614),
    [anon_sym_lazy] = ACTIONS(3612),
    [anon_sym_assert] = ACTIONS(3612),
    [anon_sym_upcast] = ACTIONS(3612),
    [anon_sym_downcast] = ACTIONS(3612),
    [anon_sym_COLON_GT] = ACTIONS(3614),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3614),
    [anon_sym_for] = ACTIONS(3612),
    [anon_sym_while] = ACTIONS(3612),
    [anon_sym_if] = ACTIONS(3612),
    [anon_sym_fun] = ACTIONS(3612),
    [anon_sym_try] = ACTIONS(3612),
    [anon_sym_match] = ACTIONS(3612),
    [anon_sym_match_BANG] = ACTIONS(3614),
    [anon_sym_function] = ACTIONS(3612),
    [anon_sym_LT_DASH] = ACTIONS(3612),
    [anon_sym_DOT_LBRACK] = ACTIONS(3614),
    [anon_sym_LT] = ACTIONS(3614),
    [anon_sym_use] = ACTIONS(3612),
    [anon_sym_use_BANG] = ACTIONS(3614),
    [anon_sym_do_BANG] = ACTIONS(3614),
    [anon_sym_begin] = ACTIONS(3612),
    [anon_sym_LPAREN2] = ACTIONS(3614),
    [anon_sym_or] = ACTIONS(3612),
    [aux_sym_char_token1] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(3612),
    [anon_sym_AT_DQUOTE] = ACTIONS(3614),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3614),
    [sym_bool] = ACTIONS(3612),
    [sym_unit] = ACTIONS(3612),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3612),
    [sym_op_identifier] = ACTIONS(3612),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(3612),
    [anon_sym_PLUS_DOT] = ACTIONS(3612),
    [anon_sym_DASH_DOT] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3612),
    [anon_sym_AMP_AMP] = ACTIONS(3612),
    [anon_sym_TILDE] = ACTIONS(3614),
    [aux_sym_prefix_op_token1] = ACTIONS(3612),
    [aux_sym_infix_op_token1] = ACTIONS(3612),
    [anon_sym_PIPE_PIPE] = ACTIONS(3612),
    [anon_sym_BANG_EQ] = ACTIONS(3612),
    [anon_sym_COLON_EQ] = ACTIONS(3614),
    [anon_sym_DOLLAR] = ACTIONS(3612),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3612),
    [sym_int] = ACTIONS(3612),
    [sym_xint] = ACTIONS(3614),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3614),
    [anon_sym_POUNDendif] = ACTIONS(3614),
    [sym__newline] = ACTIONS(3614),
  },
  [2250] = {
    [sym_xml_doc] = STATE(2250),
    [sym_block_comment] = STATE(2250),
    [sym_line_comment] = STATE(2250),
    [sym_compiler_directive_decl] = STATE(2250),
    [sym_fsi_directive_decl] = STATE(2250),
    [sym_preproc_line] = STATE(2250),
    [aux_sym_sequential_expression_repeat1] = STATE(2250),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3829),
    [anon_sym_do] = ACTIONS(3829),
    [anon_sym_let] = ACTIONS(3829),
    [anon_sym_let_BANG] = ACTIONS(3831),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_null] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_LT_AT] = ACTIONS(3829),
    [anon_sym_LT_AT_AT] = ACTIONS(3829),
    [anon_sym_DOT] = ACTIONS(3829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3829),
    [anon_sym_return_BANG] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3829),
    [anon_sym_yield_BANG] = ACTIONS(3831),
    [anon_sym_lazy] = ACTIONS(3829),
    [anon_sym_assert] = ACTIONS(3829),
    [anon_sym_upcast] = ACTIONS(3829),
    [anon_sym_downcast] = ACTIONS(3829),
    [anon_sym_COLON_GT] = ACTIONS(3831),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3829),
    [anon_sym_while] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(3829),
    [anon_sym_fun] = ACTIONS(3829),
    [anon_sym_try] = ACTIONS(3829),
    [anon_sym_match] = ACTIONS(3829),
    [anon_sym_match_BANG] = ACTIONS(3831),
    [anon_sym_function] = ACTIONS(3829),
    [anon_sym_LT_DASH] = ACTIONS(3829),
    [anon_sym_DOT_LBRACK] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_GT] = ACTIONS(3829),
    [anon_sym_use] = ACTIONS(3829),
    [anon_sym_use_BANG] = ACTIONS(3831),
    [anon_sym_do_BANG] = ACTIONS(3831),
    [anon_sym_begin] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(3831),
    [anon_sym_or] = ACTIONS(3829),
    [aux_sym_char_token1] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_AT_DQUOTE] = ACTIONS(3831),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3831),
    [sym_bool] = ACTIONS(3829),
    [sym_unit] = ACTIONS(3829),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3829),
    [sym_op_identifier] = ACTIONS(3829),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_PLUS_DOT] = ACTIONS(3829),
    [anon_sym_DASH_DOT] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3831),
    [aux_sym_prefix_op_token1] = ACTIONS(3829),
    [aux_sym_infix_op_token1] = ACTIONS(3829),
    [anon_sym_PIPE_PIPE] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_COLON_EQ] = ACTIONS(3831),
    [anon_sym_DOLLAR] = ACTIONS(3829),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3829),
    [sym_int] = ACTIONS(3829),
    [sym_xint] = ACTIONS(3831),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3831),
    [sym__newline] = ACTIONS(4904),
  },
  [2251] = {
    [sym_xml_doc] = STATE(2251),
    [sym_block_comment] = STATE(2251),
    [sym_line_comment] = STATE(2251),
    [sym_compiler_directive_decl] = STATE(2251),
    [sym_fsi_directive_decl] = STATE(2251),
    [sym_preproc_line] = STATE(2251),
    [aux_sym_long_identifier_repeat1] = STATE(2281),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_DOT_DOT] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [2252] = {
    [sym_xml_doc] = STATE(2252),
    [sym_block_comment] = STATE(2252),
    [sym_line_comment] = STATE(2252),
    [sym_compiler_directive_decl] = STATE(2252),
    [sym_fsi_directive_decl] = STATE(2252),
    [sym_preproc_line] = STATE(2252),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [anon_sym_POUNDendif] = ACTIONS(3732),
    [anon_sym_POUNDelse] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2253] = {
    [sym_xml_doc] = STATE(2253),
    [sym_block_comment] = STATE(2253),
    [sym_line_comment] = STATE(2253),
    [sym_compiler_directive_decl] = STATE(2253),
    [sym_fsi_directive_decl] = STATE(2253),
    [sym_preproc_line] = STATE(2253),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_as] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_with] = ACTIONS(3705),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2254] = {
    [sym_xml_doc] = STATE(2254),
    [sym_block_comment] = STATE(2254),
    [sym_line_comment] = STATE(2254),
    [sym_compiler_directive_decl] = STATE(2254),
    [sym_fsi_directive_decl] = STATE(2254),
    [sym_preproc_line] = STATE(2254),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_QMARK] = ACTIONS(3507),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_LT_AT] = ACTIONS(3507),
    [anon_sym_AT_GT] = ACTIONS(3507),
    [anon_sym_LT_AT_AT] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3507),
    [anon_sym_assert] = ACTIONS(3507),
    [anon_sym_upcast] = ACTIONS(3507),
    [anon_sym_downcast] = ACTIONS(3507),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_done] = ACTIONS(4612),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_fun] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_match] = ACTIONS(3507),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3507),
    [anon_sym_LT_DASH] = ACTIONS(3507),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3507),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_LPAREN2] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3507),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3507),
    [sym_unit] = ACTIONS(3507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3507),
    [sym_op_identifier] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_PLUS_DOT] = ACTIONS(3507),
    [anon_sym_DASH_DOT] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3507),
    [aux_sym_infix_op_token1] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3507),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3507),
    [sym_int] = ACTIONS(3507),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2255] = {
    [sym_xml_doc] = STATE(2255),
    [sym_block_comment] = STATE(2255),
    [sym_line_comment] = STATE(2255),
    [sym_compiler_directive_decl] = STATE(2255),
    [sym_fsi_directive_decl] = STATE(2255),
    [sym_preproc_line] = STATE(2255),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_DASH_GT] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_DOT_DOT] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2256] = {
    [sym_xml_doc] = STATE(2256),
    [sym_block_comment] = STATE(2256),
    [sym_line_comment] = STATE(2256),
    [sym_compiler_directive_decl] = STATE(2256),
    [sym_fsi_directive_decl] = STATE(2256),
    [sym_preproc_line] = STATE(2256),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_DASH_GT] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_DOT_DOT] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2257] = {
    [sym_xml_doc] = STATE(2257),
    [sym_block_comment] = STATE(2257),
    [sym_line_comment] = STATE(2257),
    [sym_compiler_directive_decl] = STATE(2257),
    [sym_fsi_directive_decl] = STATE(2257),
    [sym_preproc_line] = STATE(2257),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [anon_sym_POUNDendif] = ACTIONS(3849),
    [anon_sym_POUNDelse] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2258] = {
    [sym_xml_doc] = STATE(2258),
    [sym_block_comment] = STATE(2258),
    [sym_line_comment] = STATE(2258),
    [sym_compiler_directive_decl] = STATE(2258),
    [sym_fsi_directive_decl] = STATE(2258),
    [sym_preproc_line] = STATE(2258),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [anon_sym_POUNDendif] = ACTIONS(3604),
    [anon_sym_POUNDelse] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2259] = {
    [sym_xml_doc] = STATE(2259),
    [sym_block_comment] = STATE(2259),
    [sym_line_comment] = STATE(2259),
    [sym_compiler_directive_decl] = STATE(2259),
    [sym_fsi_directive_decl] = STATE(2259),
    [sym_preproc_line] = STATE(2259),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [anon_sym_POUNDendif] = ACTIONS(3644),
    [anon_sym_POUNDelse] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2260] = {
    [sym_xml_doc] = STATE(2260),
    [sym_block_comment] = STATE(2260),
    [sym_line_comment] = STATE(2260),
    [sym_compiler_directive_decl] = STATE(2260),
    [sym_fsi_directive_decl] = STATE(2260),
    [sym_preproc_line] = STATE(2260),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [anon_sym_POUNDendif] = ACTIONS(3796),
    [anon_sym_POUNDelse] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2261] = {
    [sym_xml_doc] = STATE(2261),
    [sym_block_comment] = STATE(2261),
    [sym_line_comment] = STATE(2261),
    [sym_compiler_directive_decl] = STATE(2261),
    [sym_fsi_directive_decl] = STATE(2261),
    [sym_preproc_line] = STATE(2261),
    [aux_sym_long_identifier_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_AT_GT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [2262] = {
    [sym_xml_doc] = STATE(2262),
    [sym_block_comment] = STATE(2262),
    [sym_line_comment] = STATE(2262),
    [sym_compiler_directive_decl] = STATE(2262),
    [sym_fsi_directive_decl] = STATE(2262),
    [sym_preproc_line] = STATE(2262),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_AT_AT_GT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [2263] = {
    [sym_xml_doc] = STATE(2263),
    [sym_block_comment] = STATE(2263),
    [sym_line_comment] = STATE(2263),
    [sym_compiler_directive_decl] = STATE(2263),
    [sym_fsi_directive_decl] = STATE(2263),
    [sym_preproc_line] = STATE(2263),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [anon_sym_POUNDendif] = ACTIONS(3600),
    [anon_sym_POUNDelse] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2264] = {
    [sym_xml_doc] = STATE(2264),
    [sym_block_comment] = STATE(2264),
    [sym_line_comment] = STATE(2264),
    [sym_compiler_directive_decl] = STATE(2264),
    [sym_fsi_directive_decl] = STATE(2264),
    [sym_preproc_line] = STATE(2264),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_DASH_GT] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2265] = {
    [sym_xml_doc] = STATE(2265),
    [sym_block_comment] = STATE(2265),
    [sym_line_comment] = STATE(2265),
    [sym_compiler_directive_decl] = STATE(2265),
    [sym_fsi_directive_decl] = STATE(2265),
    [sym_preproc_line] = STATE(2265),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_DASH_GT] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_DOT_DOT] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2266] = {
    [sym_xml_doc] = STATE(2266),
    [sym_block_comment] = STATE(2266),
    [sym_line_comment] = STATE(2266),
    [sym_compiler_directive_decl] = STATE(2266),
    [sym_fsi_directive_decl] = STATE(2266),
    [sym_preproc_line] = STATE(2266),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_DASH_GT] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_DOT_DOT] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2267] = {
    [sym_xml_doc] = STATE(2267),
    [sym_block_comment] = STATE(2267),
    [sym_line_comment] = STATE(2267),
    [sym_compiler_directive_decl] = STATE(2267),
    [sym_fsi_directive_decl] = STATE(2267),
    [sym_preproc_line] = STATE(2267),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [anon_sym_POUNDendif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2268] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4115),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym__pattern_param] = STATE(2541),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2268),
    [sym_block_comment] = STATE(2268),
    [sym_line_comment] = STATE(2268),
    [sym_compiler_directive_decl] = STATE(2268),
    [sym_fsi_directive_decl] = STATE(2268),
    [sym_preproc_line] = STATE(2268),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4519),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4519),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4519),
    [anon_sym__] = ACTIONS(4519),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_SEMI] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4523),
    [anon_sym_LBRACE] = ACTIONS(4523),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4519),
    [anon_sym_DQUOTE] = ACTIONS(4519),
    [anon_sym_AT_DQUOTE] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [sym_bool] = ACTIONS(4519),
    [sym_unit] = ACTIONS(4523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4519),
    [sym_xint] = ACTIONS(4523),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2269] = {
    [sym_xml_doc] = STATE(2269),
    [sym_block_comment] = STATE(2269),
    [sym_line_comment] = STATE(2269),
    [sym_compiler_directive_decl] = STATE(2269),
    [sym_fsi_directive_decl] = STATE(2269),
    [sym_preproc_line] = STATE(2269),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_GT] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [2270] = {
    [sym_xml_doc] = STATE(2270),
    [sym_block_comment] = STATE(2270),
    [sym_line_comment] = STATE(2270),
    [sym_compiler_directive_decl] = STATE(2270),
    [sym_fsi_directive_decl] = STATE(2270),
    [sym_preproc_line] = STATE(2270),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_DASH_GT] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2271] = {
    [sym_xml_doc] = STATE(2271),
    [sym_block_comment] = STATE(2271),
    [sym_line_comment] = STATE(2271),
    [sym_compiler_directive_decl] = STATE(2271),
    [sym_fsi_directive_decl] = STATE(2271),
    [sym_preproc_line] = STATE(2271),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_DASH_GT] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_DOT_DOT] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2272] = {
    [sym_xml_doc] = STATE(2272),
    [sym_block_comment] = STATE(2272),
    [sym_line_comment] = STATE(2272),
    [sym_compiler_directive_decl] = STATE(2272),
    [sym_fsi_directive_decl] = STATE(2272),
    [sym_preproc_line] = STATE(2272),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_DASH_GT] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_DOT_DOT] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2273] = {
    [sym_xml_doc] = STATE(2273),
    [sym_block_comment] = STATE(2273),
    [sym_line_comment] = STATE(2273),
    [sym_compiler_directive_decl] = STATE(2273),
    [sym_fsi_directive_decl] = STATE(2273),
    [sym_preproc_line] = STATE(2273),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_DASH_GT] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_DOT_DOT] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2274] = {
    [sym_xml_doc] = STATE(2274),
    [sym_block_comment] = STATE(2274),
    [sym_line_comment] = STATE(2274),
    [sym_compiler_directive_decl] = STATE(2274),
    [sym_fsi_directive_decl] = STATE(2274),
    [sym_preproc_line] = STATE(2274),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_DASH_GT] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_DOT_DOT] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2275] = {
    [sym_xml_doc] = STATE(2275),
    [sym_block_comment] = STATE(2275),
    [sym_line_comment] = STATE(2275),
    [sym_compiler_directive_decl] = STATE(2275),
    [sym_fsi_directive_decl] = STATE(2275),
    [sym_preproc_line] = STATE(2275),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [anon_sym_POUNDendif] = ACTIONS(3865),
    [anon_sym_POUNDelse] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2276] = {
    [sym_xml_doc] = STATE(2276),
    [sym_block_comment] = STATE(2276),
    [sym_line_comment] = STATE(2276),
    [sym_compiler_directive_decl] = STATE(2276),
    [sym_fsi_directive_decl] = STATE(2276),
    [sym_preproc_line] = STATE(2276),
    [aux_sym_type_argument_repeat1] = STATE(2313),
    [ts_builtin_sym_end] = ACTIONS(3232),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_open] = ACTIONS(3230),
    [anon_sym_LBRACK_LT] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_and] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [aux_sym_access_modifier_token1] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_member] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(3230),
    [anon_sym_override] = ACTIONS(3230),
    [anon_sym_val] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3232),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3232),
    [anon_sym_DASH_DOT] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3232),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3232),
    [anon_sym_POUNDload] = ACTIONS(3232),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
  },
  [2277] = {
    [sym_xml_doc] = STATE(2277),
    [sym_block_comment] = STATE(2277),
    [sym_line_comment] = STATE(2277),
    [sym_compiler_directive_decl] = STATE(2277),
    [sym_fsi_directive_decl] = STATE(2277),
    [sym_preproc_line] = STATE(2277),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [anon_sym_POUNDendif] = ACTIONS(3610),
    [anon_sym_POUNDelse] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2278] = {
    [sym_xml_doc] = STATE(2278),
    [sym_block_comment] = STATE(2278),
    [sym_line_comment] = STATE(2278),
    [sym_compiler_directive_decl] = STATE(2278),
    [sym_fsi_directive_decl] = STATE(2278),
    [sym_preproc_line] = STATE(2278),
    [aux_sym_long_identifier_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4915),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2279] = {
    [sym_xml_doc] = STATE(2279),
    [sym_block_comment] = STATE(2279),
    [sym_line_comment] = STATE(2279),
    [sym_compiler_directive_decl] = STATE(2279),
    [sym_fsi_directive_decl] = STATE(2279),
    [sym_preproc_line] = STATE(2279),
    [aux_sym_long_identifier_repeat1] = STATE(2279),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2280] = {
    [sym_xml_doc] = STATE(2280),
    [sym_block_comment] = STATE(2280),
    [sym_line_comment] = STATE(2280),
    [sym_compiler_directive_decl] = STATE(2280),
    [sym_fsi_directive_decl] = STATE(2280),
    [sym_preproc_line] = STATE(2280),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [anon_sym_POUNDendif] = ACTIONS(3880),
    [anon_sym_POUNDelse] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2281] = {
    [sym_xml_doc] = STATE(2281),
    [sym_block_comment] = STATE(2281),
    [sym_line_comment] = STATE(2281),
    [sym_compiler_directive_decl] = STATE(2281),
    [sym_fsi_directive_decl] = STATE(2281),
    [sym_preproc_line] = STATE(2281),
    [aux_sym_long_identifier_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_QMARK] = ACTIONS(3202),
    [anon_sym_COLON_COLON] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(4921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_COLON_GT] = ACTIONS(3204),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_LT_DASH] = ACTIONS(3202),
    [anon_sym_DOT_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_DOT_DOT] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_LPAREN2] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3202),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3202),
    [anon_sym_DASH_DOT] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3202),
    [aux_sym_infix_op_token1] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_COLON_EQ] = ACTIONS(3204),
    [anon_sym_DOLLAR] = ACTIONS(3202),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3202),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [2282] = {
    [sym_xml_doc] = STATE(2282),
    [sym_block_comment] = STATE(2282),
    [sym_line_comment] = STATE(2282),
    [sym_compiler_directive_decl] = STATE(2282),
    [sym_fsi_directive_decl] = STATE(2282),
    [sym_preproc_line] = STATE(2282),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_DASH_GT] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_DOT_DOT] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2283] = {
    [sym_xml_doc] = STATE(2283),
    [sym_block_comment] = STATE(2283),
    [sym_line_comment] = STATE(2283),
    [sym_compiler_directive_decl] = STATE(2283),
    [sym_fsi_directive_decl] = STATE(2283),
    [sym_preproc_line] = STATE(2283),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [2284] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5769),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2356),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2284),
    [sym_block_comment] = STATE(2284),
    [sym_line_comment] = STATE(2284),
    [sym_compiler_directive_decl] = STATE(2284),
    [sym_fsi_directive_decl] = STATE(2284),
    [sym_preproc_line] = STATE(2284),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4645),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [anon_sym_LT2] = ACTIONS(4523),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2285] = {
    [sym_xml_doc] = STATE(2285),
    [sym_block_comment] = STATE(2285),
    [sym_line_comment] = STATE(2285),
    [sym_compiler_directive_decl] = STATE(2285),
    [sym_fsi_directive_decl] = STATE(2285),
    [sym_preproc_line] = STATE(2285),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [anon_sym_POUNDendif] = ACTIONS(3886),
    [anon_sym_POUNDelse] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2286] = {
    [sym_xml_doc] = STATE(2286),
    [sym_block_comment] = STATE(2286),
    [sym_line_comment] = STATE(2286),
    [sym_compiler_directive_decl] = STATE(2286),
    [sym_fsi_directive_decl] = STATE(2286),
    [sym_preproc_line] = STATE(2286),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [anon_sym_POUNDendif] = ACTIONS(3622),
    [anon_sym_POUNDelse] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2287] = {
    [sym_xml_doc] = STATE(2287),
    [sym_block_comment] = STATE(2287),
    [sym_line_comment] = STATE(2287),
    [sym_compiler_directive_decl] = STATE(2287),
    [sym_fsi_directive_decl] = STATE(2287),
    [sym_preproc_line] = STATE(2287),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [anon_sym_POUNDendif] = ACTIONS(3626),
    [anon_sym_POUNDelse] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2288] = {
    [sym_xml_doc] = STATE(2288),
    [sym_block_comment] = STATE(2288),
    [sym_line_comment] = STATE(2288),
    [sym_compiler_directive_decl] = STATE(2288),
    [sym_fsi_directive_decl] = STATE(2288),
    [sym_preproc_line] = STATE(2288),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [anon_sym_POUNDendif] = ACTIONS(3640),
    [anon_sym_POUNDelse] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2289] = {
    [sym_xml_doc] = STATE(2289),
    [sym_block_comment] = STATE(2289),
    [sym_line_comment] = STATE(2289),
    [sym_compiler_directive_decl] = STATE(2289),
    [sym_fsi_directive_decl] = STATE(2289),
    [sym_preproc_line] = STATE(2289),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [anon_sym_POUNDendif] = ACTIONS(3648),
    [anon_sym_POUNDelse] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2290] = {
    [sym_xml_doc] = STATE(2290),
    [sym_block_comment] = STATE(2290),
    [sym_line_comment] = STATE(2290),
    [sym_compiler_directive_decl] = STATE(2290),
    [sym_fsi_directive_decl] = STATE(2290),
    [sym_preproc_line] = STATE(2290),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [anon_sym_POUNDendif] = ACTIONS(3890),
    [anon_sym_POUNDelse] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2291] = {
    [sym_xml_doc] = STATE(2291),
    [sym_block_comment] = STATE(2291),
    [sym_line_comment] = STATE(2291),
    [sym_compiler_directive_decl] = STATE(2291),
    [sym_fsi_directive_decl] = STATE(2291),
    [sym_preproc_line] = STATE(2291),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_DASH_GT] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2292] = {
    [sym_xml_doc] = STATE(2292),
    [sym_block_comment] = STATE(2292),
    [sym_line_comment] = STATE(2292),
    [sym_compiler_directive_decl] = STATE(2292),
    [sym_fsi_directive_decl] = STATE(2292),
    [sym_preproc_line] = STATE(2292),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [anon_sym_POUNDendif] = ACTIONS(3677),
    [anon_sym_POUNDelse] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2293] = {
    [sym_xml_doc] = STATE(2293),
    [sym_block_comment] = STATE(2293),
    [sym_line_comment] = STATE(2293),
    [sym_compiler_directive_decl] = STATE(2293),
    [sym_fsi_directive_decl] = STATE(2293),
    [sym_preproc_line] = STATE(2293),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [anon_sym_POUNDendif] = ACTIONS(3703),
    [anon_sym_POUNDelse] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2294] = {
    [sym_xml_doc] = STATE(2294),
    [sym_block_comment] = STATE(2294),
    [sym_line_comment] = STATE(2294),
    [sym_compiler_directive_decl] = STATE(2294),
    [sym_fsi_directive_decl] = STATE(2294),
    [sym_preproc_line] = STATE(2294),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [anon_sym_POUNDendif] = ACTIONS(3897),
    [anon_sym_POUNDelse] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2295] = {
    [sym_xml_doc] = STATE(2295),
    [sym_block_comment] = STATE(2295),
    [sym_line_comment] = STATE(2295),
    [sym_compiler_directive_decl] = STATE(2295),
    [sym_fsi_directive_decl] = STATE(2295),
    [sym_preproc_line] = STATE(2295),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_DASH_GT] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_DOT_DOT] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2296] = {
    [sym_xml_doc] = STATE(2296),
    [sym_block_comment] = STATE(2296),
    [sym_line_comment] = STATE(2296),
    [sym_compiler_directive_decl] = STATE(2296),
    [sym_fsi_directive_decl] = STATE(2296),
    [sym_preproc_line] = STATE(2296),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_DASH_GT] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_DOT_DOT] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2297] = {
    [sym_xml_doc] = STATE(2297),
    [sym_block_comment] = STATE(2297),
    [sym_line_comment] = STATE(2297),
    [sym_compiler_directive_decl] = STATE(2297),
    [sym_fsi_directive_decl] = STATE(2297),
    [sym_preproc_line] = STATE(2297),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_let_BANG] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_QMARK] = ACTIONS(3533),
    [anon_sym_COLON_COLON] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3533),
    [anon_sym_AT_GT] = ACTIONS(3533),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_return_BANG] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3533),
    [anon_sym_yield_BANG] = ACTIONS(3535),
    [anon_sym_lazy] = ACTIONS(3533),
    [anon_sym_assert] = ACTIONS(3533),
    [anon_sym_upcast] = ACTIONS(3533),
    [anon_sym_downcast] = ACTIONS(3533),
    [anon_sym_COLON_GT] = ACTIONS(3535),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_fun] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_match] = ACTIONS(3533),
    [anon_sym_match_BANG] = ACTIONS(3535),
    [anon_sym_function] = ACTIONS(3533),
    [anon_sym_LT_DASH] = ACTIONS(3533),
    [anon_sym_DOT_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3533),
    [anon_sym_use_BANG] = ACTIONS(3535),
    [anon_sym_do_BANG] = ACTIONS(3535),
    [anon_sym_begin] = ACTIONS(3533),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_AT_DQUOTE] = ACTIONS(3535),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3535),
    [sym_bool] = ACTIONS(3533),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3533),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3535),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [anon_sym_PIPE_PIPE] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_COLON_EQ] = ACTIONS(3535),
    [anon_sym_DOLLAR] = ACTIONS(3533),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3533),
    [sym_int] = ACTIONS(3533),
    [sym_xint] = ACTIONS(3535),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3535),
    [sym__newline] = ACTIONS(3535),
  },
  [2298] = {
    [sym_xml_doc] = STATE(2298),
    [sym_block_comment] = STATE(2298),
    [sym_line_comment] = STATE(2298),
    [sym_compiler_directive_decl] = STATE(2298),
    [sym_fsi_directive_decl] = STATE(2298),
    [sym_preproc_line] = STATE(2298),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_DASH_GT] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_DOT_DOT] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2299] = {
    [sym_xml_doc] = STATE(2299),
    [sym_block_comment] = STATE(2299),
    [sym_line_comment] = STATE(2299),
    [sym_compiler_directive_decl] = STATE(2299),
    [sym_fsi_directive_decl] = STATE(2299),
    [sym_preproc_line] = STATE(2299),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_DASH_GT] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_DOT_DOT] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2300] = {
    [sym_xml_doc] = STATE(2300),
    [sym_block_comment] = STATE(2300),
    [sym_line_comment] = STATE(2300),
    [sym_compiler_directive_decl] = STATE(2300),
    [sym_fsi_directive_decl] = STATE(2300),
    [sym_preproc_line] = STATE(2300),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [anon_sym_POUNDendif] = ACTIONS(3901),
    [anon_sym_POUNDelse] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2301] = {
    [sym_xml_doc] = STATE(2301),
    [sym_block_comment] = STATE(2301),
    [sym_line_comment] = STATE(2301),
    [sym_compiler_directive_decl] = STATE(2301),
    [sym_fsi_directive_decl] = STATE(2301),
    [sym_preproc_line] = STATE(2301),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2302] = {
    [sym_xml_doc] = STATE(2302),
    [sym_block_comment] = STATE(2302),
    [sym_line_comment] = STATE(2302),
    [sym_compiler_directive_decl] = STATE(2302),
    [sym_fsi_directive_decl] = STATE(2302),
    [sym_preproc_line] = STATE(2302),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [anon_sym_POUNDendif] = ACTIONS(3842),
    [anon_sym_POUNDelse] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2303] = {
    [sym_xml_doc] = STATE(2303),
    [sym_block_comment] = STATE(2303),
    [sym_line_comment] = STATE(2303),
    [sym_compiler_directive_decl] = STATE(2303),
    [sym_fsi_directive_decl] = STATE(2303),
    [sym_preproc_line] = STATE(2303),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_DASH_GT] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_DOT_DOT] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2304] = {
    [sym_xml_doc] = STATE(2304),
    [sym_block_comment] = STATE(2304),
    [sym_line_comment] = STATE(2304),
    [sym_compiler_directive_decl] = STATE(2304),
    [sym_fsi_directive_decl] = STATE(2304),
    [sym_preproc_line] = STATE(2304),
    [aux_sym_long_identifier_repeat1] = STATE(2304),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_AT_GT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(4927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2305] = {
    [sym_xml_doc] = STATE(2305),
    [sym_block_comment] = STATE(2305),
    [sym_line_comment] = STATE(2305),
    [sym_compiler_directive_decl] = STATE(2305),
    [sym_fsi_directive_decl] = STATE(2305),
    [sym_preproc_line] = STATE(2305),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_DASH_GT] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_DOT_DOT] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2306] = {
    [sym_xml_doc] = STATE(2306),
    [sym_block_comment] = STATE(2306),
    [sym_line_comment] = STATE(2306),
    [sym_compiler_directive_decl] = STATE(2306),
    [sym_fsi_directive_decl] = STATE(2306),
    [sym_preproc_line] = STATE(2306),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [anon_sym_POUNDelse] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2307] = {
    [sym_xml_doc] = STATE(2307),
    [sym_block_comment] = STATE(2307),
    [sym_line_comment] = STATE(2307),
    [sym_compiler_directive_decl] = STATE(2307),
    [sym_fsi_directive_decl] = STATE(2307),
    [sym_preproc_line] = STATE(2307),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [anon_sym_POUNDendif] = ACTIONS(3714),
    [anon_sym_POUNDelse] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2308] = {
    [sym_xml_doc] = STATE(2308),
    [sym_block_comment] = STATE(2308),
    [sym_line_comment] = STATE(2308),
    [sym_compiler_directive_decl] = STATE(2308),
    [sym_fsi_directive_decl] = STATE(2308),
    [sym_preproc_line] = STATE(2308),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [anon_sym_POUNDendif] = ACTIONS(3720),
    [anon_sym_POUNDelse] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2309] = {
    [sym_xml_doc] = STATE(2309),
    [sym_block_comment] = STATE(2309),
    [sym_line_comment] = STATE(2309),
    [sym_compiler_directive_decl] = STATE(2309),
    [sym_fsi_directive_decl] = STATE(2309),
    [sym_preproc_line] = STATE(2309),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [anon_sym_POUNDendif] = ACTIONS(3764),
    [anon_sym_POUNDelse] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2310] = {
    [sym_xml_doc] = STATE(2310),
    [sym_block_comment] = STATE(2310),
    [sym_line_comment] = STATE(2310),
    [sym_compiler_directive_decl] = STATE(2310),
    [sym_fsi_directive_decl] = STATE(2310),
    [sym_preproc_line] = STATE(2310),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_DASH_GT] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_DOT_DOT] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2311] = {
    [sym_xml_doc] = STATE(2311),
    [sym_block_comment] = STATE(2311),
    [sym_line_comment] = STATE(2311),
    [sym_compiler_directive_decl] = STATE(2311),
    [sym_fsi_directive_decl] = STATE(2311),
    [sym_preproc_line] = STATE(2311),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_DASH_GT] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_DOT_DOT] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2312] = {
    [sym_xml_doc] = STATE(2312),
    [sym_block_comment] = STATE(2312),
    [sym_line_comment] = STATE(2312),
    [sym_compiler_directive_decl] = STATE(2312),
    [sym_fsi_directive_decl] = STATE(2312),
    [sym_preproc_line] = STATE(2312),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2313] = {
    [sym_xml_doc] = STATE(2313),
    [sym_block_comment] = STATE(2313),
    [sym_line_comment] = STATE(2313),
    [sym_compiler_directive_decl] = STATE(2313),
    [sym_fsi_directive_decl] = STATE(2313),
    [sym_preproc_line] = STATE(2313),
    [aux_sym_type_argument_repeat1] = STATE(2313),
    [ts_builtin_sym_end] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_and] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [aux_sym_access_modifier_token1] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(4930),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_member] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_val] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
  },
  [2314] = {
    [sym_xml_doc] = STATE(2314),
    [sym_block_comment] = STATE(2314),
    [sym_line_comment] = STATE(2314),
    [sym_compiler_directive_decl] = STATE(2314),
    [sym_fsi_directive_decl] = STATE(2314),
    [sym_preproc_line] = STATE(2314),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [anon_sym_POUNDelse] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2315] = {
    [sym_xml_doc] = STATE(2315),
    [sym_block_comment] = STATE(2315),
    [sym_line_comment] = STATE(2315),
    [sym_compiler_directive_decl] = STATE(2315),
    [sym_fsi_directive_decl] = STATE(2315),
    [sym_preproc_line] = STATE(2315),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_DASH_GT] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2316] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5793),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2679),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2316),
    [sym_block_comment] = STATE(2316),
    [sym_line_comment] = STATE(2316),
    [sym_compiler_directive_decl] = STATE(2316),
    [sym_fsi_directive_decl] = STATE(2316),
    [sym_preproc_line] = STATE(2316),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(4523),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4645),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2317] = {
    [sym_xml_doc] = STATE(2317),
    [sym_block_comment] = STATE(2317),
    [sym_line_comment] = STATE(2317),
    [sym_compiler_directive_decl] = STATE(2317),
    [sym_fsi_directive_decl] = STATE(2317),
    [sym_preproc_line] = STATE(2317),
    [aux_sym_long_identifier_repeat1] = STATE(2261),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_COLON] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_let_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_null] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_QMARK] = ACTIONS(3261),
    [anon_sym_COLON_COLON] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_LT_AT] = ACTIONS(3261),
    [anon_sym_AT_GT] = ACTIONS(3261),
    [anon_sym_LT_AT_AT] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(4937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_return_BANG] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_yield_BANG] = ACTIONS(3264),
    [anon_sym_lazy] = ACTIONS(3261),
    [anon_sym_assert] = ACTIONS(3261),
    [anon_sym_upcast] = ACTIONS(3261),
    [anon_sym_downcast] = ACTIONS(3261),
    [anon_sym_COLON_GT] = ACTIONS(3264),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_fun] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_match_BANG] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_LT_DASH] = ACTIONS(3261),
    [anon_sym_DOT_LBRACK] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_use_BANG] = ACTIONS(3264),
    [anon_sym_do_BANG] = ACTIONS(3264),
    [anon_sym_begin] = ACTIONS(3261),
    [anon_sym_LPAREN2] = ACTIONS(3264),
    [anon_sym_or] = ACTIONS(3261),
    [aux_sym_char_token1] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3261),
    [anon_sym_AT_DQUOTE] = ACTIONS(3264),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3264),
    [sym_bool] = ACTIONS(3261),
    [sym_unit] = ACTIONS(3261),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3261),
    [sym_op_identifier] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PLUS_DOT] = ACTIONS(3261),
    [anon_sym_DASH_DOT] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_AMP_AMP] = ACTIONS(3261),
    [anon_sym_TILDE] = ACTIONS(3264),
    [aux_sym_prefix_op_token1] = ACTIONS(3261),
    [aux_sym_infix_op_token1] = ACTIONS(3261),
    [anon_sym_PIPE_PIPE] = ACTIONS(3261),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_COLON_EQ] = ACTIONS(3264),
    [anon_sym_DOLLAR] = ACTIONS(3261),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3261),
    [sym_int] = ACTIONS(3261),
    [sym_xint] = ACTIONS(3264),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3264),
    [sym__newline] = ACTIONS(3264),
  },
  [2318] = {
    [sym_xml_doc] = STATE(2318),
    [sym_block_comment] = STATE(2318),
    [sym_line_comment] = STATE(2318),
    [sym_compiler_directive_decl] = STATE(2318),
    [sym_fsi_directive_decl] = STATE(2318),
    [sym_preproc_line] = STATE(2318),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_DASH_GT] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_DOT_DOT] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2319] = {
    [sym_xml_doc] = STATE(2319),
    [sym_block_comment] = STATE(2319),
    [sym_line_comment] = STATE(2319),
    [sym_compiler_directive_decl] = STATE(2319),
    [sym_fsi_directive_decl] = STATE(2319),
    [sym_preproc_line] = STATE(2319),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_DASH_GT] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_DOT_DOT] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2320] = {
    [sym_xml_doc] = STATE(2320),
    [sym_block_comment] = STATE(2320),
    [sym_line_comment] = STATE(2320),
    [sym_compiler_directive_decl] = STATE(2320),
    [sym_fsi_directive_decl] = STATE(2320),
    [sym_preproc_line] = STATE(2320),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [anon_sym_POUNDendif] = ACTIONS(3838),
    [anon_sym_POUNDelse] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2321] = {
    [sym_xml_doc] = STATE(2321),
    [sym_block_comment] = STATE(2321),
    [sym_line_comment] = STATE(2321),
    [sym_compiler_directive_decl] = STATE(2321),
    [sym_fsi_directive_decl] = STATE(2321),
    [sym_preproc_line] = STATE(2321),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [anon_sym_POUNDendif] = ACTIONS(3912),
    [anon_sym_POUNDelse] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2322] = {
    [sym_xml_doc] = STATE(2322),
    [sym_block_comment] = STATE(2322),
    [sym_line_comment] = STATE(2322),
    [sym_compiler_directive_decl] = STATE(2322),
    [sym_fsi_directive_decl] = STATE(2322),
    [sym_preproc_line] = STATE(2322),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [anon_sym_POUNDendif] = ACTIONS(3923),
    [anon_sym_POUNDelse] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2323] = {
    [sym_xml_doc] = STATE(2323),
    [sym_block_comment] = STATE(2323),
    [sym_line_comment] = STATE(2323),
    [sym_compiler_directive_decl] = STATE(2323),
    [sym_fsi_directive_decl] = STATE(2323),
    [sym_preproc_line] = STATE(2323),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [anon_sym_POUNDendif] = ACTIONS(3931),
    [anon_sym_POUNDelse] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2324] = {
    [sym_xml_doc] = STATE(2324),
    [sym_block_comment] = STATE(2324),
    [sym_line_comment] = STATE(2324),
    [sym_compiler_directive_decl] = STATE(2324),
    [sym_fsi_directive_decl] = STATE(2324),
    [sym_preproc_line] = STATE(2324),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [anon_sym_POUNDendif] = ACTIONS(3939),
    [anon_sym_POUNDelse] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2325] = {
    [sym_xml_doc] = STATE(2325),
    [sym_block_comment] = STATE(2325),
    [sym_line_comment] = STATE(2325),
    [sym_compiler_directive_decl] = STATE(2325),
    [sym_fsi_directive_decl] = STATE(2325),
    [sym_preproc_line] = STATE(2325),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [anon_sym_POUNDendif] = ACTIONS(3979),
    [anon_sym_POUNDelse] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2326] = {
    [sym_xml_doc] = STATE(2326),
    [sym_block_comment] = STATE(2326),
    [sym_line_comment] = STATE(2326),
    [sym_compiler_directive_decl] = STATE(2326),
    [sym_fsi_directive_decl] = STATE(2326),
    [sym_preproc_line] = STATE(2326),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [anon_sym_POUNDendif] = ACTIONS(3975),
    [anon_sym_POUNDelse] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2327] = {
    [sym_xml_doc] = STATE(2327),
    [sym_block_comment] = STATE(2327),
    [sym_line_comment] = STATE(2327),
    [sym_compiler_directive_decl] = STATE(2327),
    [sym_fsi_directive_decl] = STATE(2327),
    [sym_preproc_line] = STATE(2327),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [anon_sym_POUNDendif] = ACTIONS(3971),
    [anon_sym_POUNDelse] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2328] = {
    [sym_xml_doc] = STATE(2328),
    [sym_block_comment] = STATE(2328),
    [sym_line_comment] = STATE(2328),
    [sym_compiler_directive_decl] = STATE(2328),
    [sym_fsi_directive_decl] = STATE(2328),
    [sym_preproc_line] = STATE(2328),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [anon_sym_POUNDendif] = ACTIONS(3967),
    [anon_sym_POUNDelse] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2329] = {
    [sym_xml_doc] = STATE(2329),
    [sym_block_comment] = STATE(2329),
    [sym_line_comment] = STATE(2329),
    [sym_compiler_directive_decl] = STATE(2329),
    [sym_fsi_directive_decl] = STATE(2329),
    [sym_preproc_line] = STATE(2329),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [anon_sym_POUNDendif] = ACTIONS(3963),
    [anon_sym_POUNDelse] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2330] = {
    [sym_xml_doc] = STATE(2330),
    [sym_block_comment] = STATE(2330),
    [sym_line_comment] = STATE(2330),
    [sym_compiler_directive_decl] = STATE(2330),
    [sym_fsi_directive_decl] = STATE(2330),
    [sym_preproc_line] = STATE(2330),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_DASH_GT] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2331] = {
    [sym_xml_doc] = STATE(2331),
    [sym_block_comment] = STATE(2331),
    [sym_line_comment] = STATE(2331),
    [sym_compiler_directive_decl] = STATE(2331),
    [sym_fsi_directive_decl] = STATE(2331),
    [sym_preproc_line] = STATE(2331),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_DASH_GT] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_DOT_DOT] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2332] = {
    [sym_xml_doc] = STATE(2332),
    [sym_block_comment] = STATE(2332),
    [sym_line_comment] = STATE(2332),
    [sym_compiler_directive_decl] = STATE(2332),
    [sym_fsi_directive_decl] = STATE(2332),
    [sym_preproc_line] = STATE(2332),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_AT_AT_GT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4941),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [2333] = {
    [sym_xml_doc] = STATE(2333),
    [sym_block_comment] = STATE(2333),
    [sym_line_comment] = STATE(2333),
    [sym_compiler_directive_decl] = STATE(2333),
    [sym_fsi_directive_decl] = STATE(2333),
    [sym_preproc_line] = STATE(2333),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [anon_sym_POUNDendif] = ACTIONS(3827),
    [anon_sym_POUNDelse] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2334] = {
    [sym_xml_doc] = STATE(2334),
    [sym_block_comment] = STATE(2334),
    [sym_line_comment] = STATE(2334),
    [sym_compiler_directive_decl] = STATE(2334),
    [sym_fsi_directive_decl] = STATE(2334),
    [sym_preproc_line] = STATE(2334),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_QMARK] = ACTIONS(3438),
    [anon_sym_COLON_COLON] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3438),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_COLON_GT] = ACTIONS(3440),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_LT_DASH] = ACTIONS(3438),
    [anon_sym_DOT_LBRACK] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_LPAREN2] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3438),
    [anon_sym_DASH_DOT] = ACTIONS(3438),
    [anon_sym_PERCENT] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3438),
    [aux_sym_infix_op_token1] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_COLON_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(3438),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3438),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [sym__newline] = ACTIONS(3440),
  },
  [2335] = {
    [sym_xml_doc] = STATE(2335),
    [sym_block_comment] = STATE(2335),
    [sym_line_comment] = STATE(2335),
    [sym_compiler_directive_decl] = STATE(2335),
    [sym_fsi_directive_decl] = STATE(2335),
    [sym_preproc_line] = STATE(2335),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [anon_sym_POUNDendif] = ACTIONS(3959),
    [anon_sym_POUNDelse] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2336] = {
    [sym_xml_doc] = STATE(2336),
    [sym_block_comment] = STATE(2336),
    [sym_line_comment] = STATE(2336),
    [sym_compiler_directive_decl] = STATE(2336),
    [sym_fsi_directive_decl] = STATE(2336),
    [sym_preproc_line] = STATE(2336),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [anon_sym_POUNDendif] = ACTIONS(3955),
    [anon_sym_POUNDelse] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2337] = {
    [sym_xml_doc] = STATE(2337),
    [sym_block_comment] = STATE(2337),
    [sym_line_comment] = STATE(2337),
    [sym_compiler_directive_decl] = STATE(2337),
    [sym_fsi_directive_decl] = STATE(2337),
    [sym_preproc_line] = STATE(2337),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [anon_sym_POUNDendif] = ACTIONS(3951),
    [anon_sym_POUNDelse] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2338] = {
    [sym_xml_doc] = STATE(2338),
    [sym_block_comment] = STATE(2338),
    [sym_line_comment] = STATE(2338),
    [sym_compiler_directive_decl] = STATE(2338),
    [sym_fsi_directive_decl] = STATE(2338),
    [sym_preproc_line] = STATE(2338),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [anon_sym_POUNDendif] = ACTIONS(3947),
    [anon_sym_POUNDelse] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2339] = {
    [sym_xml_doc] = STATE(2339),
    [sym_block_comment] = STATE(2339),
    [sym_line_comment] = STATE(2339),
    [sym_compiler_directive_decl] = STATE(2339),
    [sym_fsi_directive_decl] = STATE(2339),
    [sym_preproc_line] = STATE(2339),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [anon_sym_POUNDendif] = ACTIONS(3943),
    [anon_sym_POUNDelse] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2340] = {
    [sym_xml_doc] = STATE(2340),
    [sym_block_comment] = STATE(2340),
    [sym_line_comment] = STATE(2340),
    [sym_compiler_directive_decl] = STATE(2340),
    [sym_fsi_directive_decl] = STATE(2340),
    [sym_preproc_line] = STATE(2340),
    [sym_identifier] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_let] = ACTIONS(3554),
    [anon_sym_let_BANG] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_null] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_QMARK] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_LT_AT] = ACTIONS(3554),
    [anon_sym_AT_GT] = ACTIONS(3554),
    [anon_sym_LT_AT_AT] = ACTIONS(3554),
    [anon_sym_DOT] = ACTIONS(3554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3554),
    [anon_sym_return_BANG] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3554),
    [anon_sym_yield_BANG] = ACTIONS(3556),
    [anon_sym_lazy] = ACTIONS(3554),
    [anon_sym_assert] = ACTIONS(3554),
    [anon_sym_upcast] = ACTIONS(3554),
    [anon_sym_downcast] = ACTIONS(3554),
    [anon_sym_COLON_GT] = ACTIONS(3556),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_done] = ACTIONS(4943),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_fun] = ACTIONS(3554),
    [anon_sym_try] = ACTIONS(3554),
    [anon_sym_match] = ACTIONS(3554),
    [anon_sym_match_BANG] = ACTIONS(3556),
    [anon_sym_function] = ACTIONS(3554),
    [anon_sym_LT_DASH] = ACTIONS(3554),
    [anon_sym_DOT_LBRACK] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3556),
    [anon_sym_use] = ACTIONS(3554),
    [anon_sym_use_BANG] = ACTIONS(3556),
    [anon_sym_do_BANG] = ACTIONS(3556),
    [anon_sym_begin] = ACTIONS(3554),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_or] = ACTIONS(3554),
    [aux_sym_char_token1] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [anon_sym_AT_DQUOTE] = ACTIONS(3556),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3556),
    [sym_bool] = ACTIONS(3554),
    [sym_unit] = ACTIONS(3554),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3554),
    [sym_op_identifier] = ACTIONS(3554),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_DOT] = ACTIONS(3554),
    [anon_sym_DASH_DOT] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3556),
    [aux_sym_prefix_op_token1] = ACTIONS(3554),
    [aux_sym_infix_op_token1] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_COLON_EQ] = ACTIONS(3556),
    [anon_sym_DOLLAR] = ACTIONS(3554),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3554),
    [sym_int] = ACTIONS(3554),
    [sym_xint] = ACTIONS(3556),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3556),
    [sym__newline] = ACTIONS(3556),
  },
  [2341] = {
    [sym_xml_doc] = STATE(2341),
    [sym_block_comment] = STATE(2341),
    [sym_line_comment] = STATE(2341),
    [sym_compiler_directive_decl] = STATE(2341),
    [sym_fsi_directive_decl] = STATE(2341),
    [sym_preproc_line] = STATE(2341),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_DOT_DOT] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2342] = {
    [sym_xml_doc] = STATE(2342),
    [sym_block_comment] = STATE(2342),
    [sym_line_comment] = STATE(2342),
    [sym_compiler_directive_decl] = STATE(2342),
    [sym_fsi_directive_decl] = STATE(2342),
    [sym_preproc_line] = STATE(2342),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [anon_sym_POUNDendif] = ACTIONS(3935),
    [anon_sym_POUNDelse] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2343] = {
    [sym_xml_doc] = STATE(2343),
    [sym_block_comment] = STATE(2343),
    [sym_line_comment] = STATE(2343),
    [sym_compiler_directive_decl] = STATE(2343),
    [sym_fsi_directive_decl] = STATE(2343),
    [sym_preproc_line] = STATE(2343),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [anon_sym_POUNDendif] = ACTIONS(3927),
    [anon_sym_POUNDelse] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2344] = {
    [sym_xml_doc] = STATE(2344),
    [sym_block_comment] = STATE(2344),
    [sym_line_comment] = STATE(2344),
    [sym_compiler_directive_decl] = STATE(2344),
    [sym_fsi_directive_decl] = STATE(2344),
    [sym_preproc_line] = STATE(2344),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [anon_sym_POUNDendif] = ACTIONS(3916),
    [anon_sym_POUNDelse] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2345] = {
    [sym_xml_doc] = STATE(2345),
    [sym_block_comment] = STATE(2345),
    [sym_line_comment] = STATE(2345),
    [sym_compiler_directive_decl] = STATE(2345),
    [sym_fsi_directive_decl] = STATE(2345),
    [sym_preproc_line] = STATE(2345),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [anon_sym_POUNDendif] = ACTIONS(3908),
    [anon_sym_POUNDelse] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2346] = {
    [sym_xml_doc] = STATE(2346),
    [sym_block_comment] = STATE(2346),
    [sym_line_comment] = STATE(2346),
    [sym_compiler_directive_decl] = STATE(2346),
    [sym_fsi_directive_decl] = STATE(2346),
    [sym_preproc_line] = STATE(2346),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_DASH_GT] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2347] = {
    [sym_xml_doc] = STATE(2347),
    [sym_block_comment] = STATE(2347),
    [sym_line_comment] = STATE(2347),
    [sym_compiler_directive_decl] = STATE(2347),
    [sym_fsi_directive_decl] = STATE(2347),
    [sym_preproc_line] = STATE(2347),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [anon_sym_POUNDendif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2348] = {
    [sym_xml_doc] = STATE(2348),
    [sym_block_comment] = STATE(2348),
    [sym_line_comment] = STATE(2348),
    [sym_compiler_directive_decl] = STATE(2348),
    [sym_fsi_directive_decl] = STATE(2348),
    [sym_preproc_line] = STATE(2348),
    [aux_sym_type_argument_repeat1] = STATE(2439),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_and] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [aux_sym_access_modifier_token1] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_member] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_abstract] = ACTIONS(3242),
    [anon_sym_override] = ACTIONS(3242),
    [anon_sym_val] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [2349] = {
    [sym_xml_doc] = STATE(2349),
    [sym_block_comment] = STATE(2349),
    [sym_line_comment] = STATE(2349),
    [sym_compiler_directive_decl] = STATE(2349),
    [sym_fsi_directive_decl] = STATE(2349),
    [sym_preproc_line] = STATE(2349),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_DOT_DOT] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2350] = {
    [sym_xml_doc] = STATE(2350),
    [sym_block_comment] = STATE(2350),
    [sym_line_comment] = STATE(2350),
    [sym_compiler_directive_decl] = STATE(2350),
    [sym_fsi_directive_decl] = STATE(2350),
    [sym_preproc_line] = STATE(2350),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2351] = {
    [sym_xml_doc] = STATE(2351),
    [sym_block_comment] = STATE(2351),
    [sym_line_comment] = STATE(2351),
    [sym_compiler_directive_decl] = STATE(2351),
    [sym_fsi_directive_decl] = STATE(2351),
    [sym_preproc_line] = STATE(2351),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [anon_sym_POUNDendif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2352] = {
    [sym_xml_doc] = STATE(2352),
    [sym_block_comment] = STATE(2352),
    [sym_line_comment] = STATE(2352),
    [sym_compiler_directive_decl] = STATE(2352),
    [sym_fsi_directive_decl] = STATE(2352),
    [sym_preproc_line] = STATE(2352),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [anon_sym_POUNDendif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2353] = {
    [sym_xml_doc] = STATE(2353),
    [sym_block_comment] = STATE(2353),
    [sym_line_comment] = STATE(2353),
    [sym_compiler_directive_decl] = STATE(2353),
    [sym_fsi_directive_decl] = STATE(2353),
    [sym_preproc_line] = STATE(2353),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_AT_GT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2354] = {
    [sym_xml_doc] = STATE(2354),
    [sym_block_comment] = STATE(2354),
    [sym_line_comment] = STATE(2354),
    [sym_compiler_directive_decl] = STATE(2354),
    [sym_fsi_directive_decl] = STATE(2354),
    [sym_preproc_line] = STATE(2354),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_AT_GT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2355] = {
    [sym_xml_doc] = STATE(2355),
    [sym_block_comment] = STATE(2355),
    [sym_line_comment] = STATE(2355),
    [sym_compiler_directive_decl] = STATE(2355),
    [sym_fsi_directive_decl] = STATE(2355),
    [sym_preproc_line] = STATE(2355),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_AT_AT_GT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2356] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5642),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2356),
    [sym_block_comment] = STATE(2356),
    [sym_line_comment] = STATE(2356),
    [sym_compiler_directive_decl] = STATE(2356),
    [sym_fsi_directive_decl] = STATE(2356),
    [sym_preproc_line] = STATE(2356),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [anon_sym_LT2] = ACTIONS(4762),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2357] = {
    [sym_xml_doc] = STATE(2357),
    [sym_block_comment] = STATE(2357),
    [sym_line_comment] = STATE(2357),
    [sym_compiler_directive_decl] = STATE(2357),
    [sym_fsi_directive_decl] = STATE(2357),
    [sym_preproc_line] = STATE(2357),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_DOT_DOT] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2358] = {
    [sym_xml_doc] = STATE(2358),
    [sym_block_comment] = STATE(2358),
    [sym_line_comment] = STATE(2358),
    [sym_compiler_directive_decl] = STATE(2358),
    [sym_fsi_directive_decl] = STATE(2358),
    [sym_preproc_line] = STATE(2358),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [anon_sym_POUNDendif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2359] = {
    [sym_xml_doc] = STATE(2359),
    [sym_block_comment] = STATE(2359),
    [sym_line_comment] = STATE(2359),
    [sym_compiler_directive_decl] = STATE(2359),
    [sym_fsi_directive_decl] = STATE(2359),
    [sym_preproc_line] = STATE(2359),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [anon_sym_POUNDendif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2360] = {
    [sym_xml_doc] = STATE(2360),
    [sym_block_comment] = STATE(2360),
    [sym_line_comment] = STATE(2360),
    [sym_compiler_directive_decl] = STATE(2360),
    [sym_fsi_directive_decl] = STATE(2360),
    [sym_preproc_line] = STATE(2360),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_AT_GT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2361] = {
    [sym_xml_doc] = STATE(2361),
    [sym_block_comment] = STATE(2361),
    [sym_line_comment] = STATE(2361),
    [sym_compiler_directive_decl] = STATE(2361),
    [sym_fsi_directive_decl] = STATE(2361),
    [sym_preproc_line] = STATE(2361),
    [ts_builtin_sym_end] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_and] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [aux_sym_access_modifier_token1] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_member] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_val] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
  },
  [2362] = {
    [sym_xml_doc] = STATE(2362),
    [sym_block_comment] = STATE(2362),
    [sym_line_comment] = STATE(2362),
    [sym_compiler_directive_decl] = STATE(2362),
    [sym_fsi_directive_decl] = STATE(2362),
    [sym_preproc_line] = STATE(2362),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_DOT_DOT] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2363] = {
    [sym_xml_doc] = STATE(2363),
    [sym_block_comment] = STATE(2363),
    [sym_line_comment] = STATE(2363),
    [sym_compiler_directive_decl] = STATE(2363),
    [sym_fsi_directive_decl] = STATE(2363),
    [sym_preproc_line] = STATE(2363),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_AT_GT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2364] = {
    [sym_xml_doc] = STATE(2364),
    [sym_block_comment] = STATE(2364),
    [sym_line_comment] = STATE(2364),
    [sym_compiler_directive_decl] = STATE(2364),
    [sym_fsi_directive_decl] = STATE(2364),
    [sym_preproc_line] = STATE(2364),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_AT_GT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2365] = {
    [sym_xml_doc] = STATE(2365),
    [sym_block_comment] = STATE(2365),
    [sym_line_comment] = STATE(2365),
    [sym_compiler_directive_decl] = STATE(2365),
    [sym_fsi_directive_decl] = STATE(2365),
    [sym_preproc_line] = STATE(2365),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_DOT_DOT] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2366] = {
    [sym_xml_doc] = STATE(2366),
    [sym_block_comment] = STATE(2366),
    [sym_line_comment] = STATE(2366),
    [sym_compiler_directive_decl] = STATE(2366),
    [sym_fsi_directive_decl] = STATE(2366),
    [sym_preproc_line] = STATE(2366),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [anon_sym_POUNDendif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2367] = {
    [sym_xml_doc] = STATE(2367),
    [sym_block_comment] = STATE(2367),
    [sym_line_comment] = STATE(2367),
    [sym_compiler_directive_decl] = STATE(2367),
    [sym_fsi_directive_decl] = STATE(2367),
    [sym_preproc_line] = STATE(2367),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [anon_sym_POUNDendif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2368] = {
    [sym_xml_doc] = STATE(2368),
    [sym_block_comment] = STATE(2368),
    [sym_line_comment] = STATE(2368),
    [sym_compiler_directive_decl] = STATE(2368),
    [sym_fsi_directive_decl] = STATE(2368),
    [sym_preproc_line] = STATE(2368),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [anon_sym_POUNDendif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2369] = {
    [sym_xml_doc] = STATE(2369),
    [sym_block_comment] = STATE(2369),
    [sym_line_comment] = STATE(2369),
    [sym_compiler_directive_decl] = STATE(2369),
    [sym_fsi_directive_decl] = STATE(2369),
    [sym_preproc_line] = STATE(2369),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [anon_sym_POUNDendif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2370] = {
    [sym_xml_doc] = STATE(2370),
    [sym_block_comment] = STATE(2370),
    [sym_line_comment] = STATE(2370),
    [sym_compiler_directive_decl] = STATE(2370),
    [sym_fsi_directive_decl] = STATE(2370),
    [sym_preproc_line] = STATE(2370),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_AT_GT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2371] = {
    [sym_xml_doc] = STATE(2371),
    [sym_block_comment] = STATE(2371),
    [sym_line_comment] = STATE(2371),
    [sym_compiler_directive_decl] = STATE(2371),
    [sym_fsi_directive_decl] = STATE(2371),
    [sym_preproc_line] = STATE(2371),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [anon_sym_POUNDendif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2372] = {
    [sym_xml_doc] = STATE(2372),
    [sym_block_comment] = STATE(2372),
    [sym_line_comment] = STATE(2372),
    [sym_compiler_directive_decl] = STATE(2372),
    [sym_fsi_directive_decl] = STATE(2372),
    [sym_preproc_line] = STATE(2372),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_AT_AT_GT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2373] = {
    [sym_xml_doc] = STATE(2373),
    [sym_block_comment] = STATE(2373),
    [sym_line_comment] = STATE(2373),
    [sym_compiler_directive_decl] = STATE(2373),
    [sym_fsi_directive_decl] = STATE(2373),
    [sym_preproc_line] = STATE(2373),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_AT_GT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2374] = {
    [sym_xml_doc] = STATE(2374),
    [sym_block_comment] = STATE(2374),
    [sym_line_comment] = STATE(2374),
    [sym_compiler_directive_decl] = STATE(2374),
    [sym_fsi_directive_decl] = STATE(2374),
    [sym_preproc_line] = STATE(2374),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_AT_AT_GT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2375] = {
    [sym_xml_doc] = STATE(2375),
    [sym_block_comment] = STATE(2375),
    [sym_line_comment] = STATE(2375),
    [sym_compiler_directive_decl] = STATE(2375),
    [sym_fsi_directive_decl] = STATE(2375),
    [sym_preproc_line] = STATE(2375),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [anon_sym_POUNDendif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2376] = {
    [sym_xml_doc] = STATE(2376),
    [sym_block_comment] = STATE(2376),
    [sym_line_comment] = STATE(2376),
    [sym_compiler_directive_decl] = STATE(2376),
    [sym_fsi_directive_decl] = STATE(2376),
    [sym_preproc_line] = STATE(2376),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [anon_sym_POUNDendif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2377] = {
    [sym_xml_doc] = STATE(2377),
    [sym_block_comment] = STATE(2377),
    [sym_line_comment] = STATE(2377),
    [sym_compiler_directive_decl] = STATE(2377),
    [sym_fsi_directive_decl] = STATE(2377),
    [sym_preproc_line] = STATE(2377),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [anon_sym_POUNDendif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2378] = {
    [sym_xml_doc] = STATE(2378),
    [sym_block_comment] = STATE(2378),
    [sym_line_comment] = STATE(2378),
    [sym_compiler_directive_decl] = STATE(2378),
    [sym_fsi_directive_decl] = STATE(2378),
    [sym_preproc_line] = STATE(2378),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_AT_AT_GT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2379] = {
    [sym_xml_doc] = STATE(2379),
    [sym_block_comment] = STATE(2379),
    [sym_line_comment] = STATE(2379),
    [sym_compiler_directive_decl] = STATE(2379),
    [sym_fsi_directive_decl] = STATE(2379),
    [sym_preproc_line] = STATE(2379),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [anon_sym_POUNDendif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2380] = {
    [sym_xml_doc] = STATE(2380),
    [sym_block_comment] = STATE(2380),
    [sym_line_comment] = STATE(2380),
    [sym_compiler_directive_decl] = STATE(2380),
    [sym_fsi_directive_decl] = STATE(2380),
    [sym_preproc_line] = STATE(2380),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [anon_sym_POUNDendif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2381] = {
    [sym_xml_doc] = STATE(2381),
    [sym_block_comment] = STATE(2381),
    [sym_line_comment] = STATE(2381),
    [sym_compiler_directive_decl] = STATE(2381),
    [sym_fsi_directive_decl] = STATE(2381),
    [sym_preproc_line] = STATE(2381),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_GT] = ACTIONS(3642),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2382] = {
    [sym_xml_doc] = STATE(2382),
    [sym_block_comment] = STATE(2382),
    [sym_line_comment] = STATE(2382),
    [sym_compiler_directive_decl] = STATE(2382),
    [sym_fsi_directive_decl] = STATE(2382),
    [sym_preproc_line] = STATE(2382),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [anon_sym_POUNDendif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2383] = {
    [sym_xml_doc] = STATE(2383),
    [sym_block_comment] = STATE(2383),
    [sym_line_comment] = STATE(2383),
    [sym_compiler_directive_decl] = STATE(2383),
    [sym_fsi_directive_decl] = STATE(2383),
    [sym_preproc_line] = STATE(2383),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_DOT_DOT] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2384] = {
    [sym_xml_doc] = STATE(2384),
    [sym_block_comment] = STATE(2384),
    [sym_line_comment] = STATE(2384),
    [sym_compiler_directive_decl] = STATE(2384),
    [sym_fsi_directive_decl] = STATE(2384),
    [sym_preproc_line] = STATE(2384),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [anon_sym_POUNDendif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2385] = {
    [sym_xml_doc] = STATE(2385),
    [sym_block_comment] = STATE(2385),
    [sym_line_comment] = STATE(2385),
    [sym_compiler_directive_decl] = STATE(2385),
    [sym_fsi_directive_decl] = STATE(2385),
    [sym_preproc_line] = STATE(2385),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [anon_sym_POUNDendif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2386] = {
    [sym_xml_doc] = STATE(2386),
    [sym_block_comment] = STATE(2386),
    [sym_line_comment] = STATE(2386),
    [sym_compiler_directive_decl] = STATE(2386),
    [sym_fsi_directive_decl] = STATE(2386),
    [sym_preproc_line] = STATE(2386),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_DOT_DOT] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2387] = {
    [sym_xml_doc] = STATE(2387),
    [sym_block_comment] = STATE(2387),
    [sym_line_comment] = STATE(2387),
    [sym_compiler_directive_decl] = STATE(2387),
    [sym_fsi_directive_decl] = STATE(2387),
    [sym_preproc_line] = STATE(2387),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_AT_GT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2388] = {
    [sym_xml_doc] = STATE(2388),
    [sym_block_comment] = STATE(2388),
    [sym_line_comment] = STATE(2388),
    [sym_compiler_directive_decl] = STATE(2388),
    [sym_fsi_directive_decl] = STATE(2388),
    [sym_preproc_line] = STATE(2388),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2389] = {
    [sym_xml_doc] = STATE(2389),
    [sym_block_comment] = STATE(2389),
    [sym_line_comment] = STATE(2389),
    [sym_compiler_directive_decl] = STATE(2389),
    [sym_fsi_directive_decl] = STATE(2389),
    [sym_preproc_line] = STATE(2389),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2390] = {
    [sym_xml_doc] = STATE(2390),
    [sym_block_comment] = STATE(2390),
    [sym_line_comment] = STATE(2390),
    [sym_compiler_directive_decl] = STATE(2390),
    [sym_fsi_directive_decl] = STATE(2390),
    [sym_preproc_line] = STATE(2390),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3608),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2391] = {
    [sym_xml_doc] = STATE(2391),
    [sym_block_comment] = STATE(2391),
    [sym_line_comment] = STATE(2391),
    [sym_compiler_directive_decl] = STATE(2391),
    [sym_fsi_directive_decl] = STATE(2391),
    [sym_preproc_line] = STATE(2391),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_AT_GT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2392] = {
    [sym_xml_doc] = STATE(2392),
    [sym_block_comment] = STATE(2392),
    [sym_line_comment] = STATE(2392),
    [sym_compiler_directive_decl] = STATE(2392),
    [sym_fsi_directive_decl] = STATE(2392),
    [sym_preproc_line] = STATE(2392),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_AT_AT_GT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2393] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3538),
    [sym_function_declaration_left] = STATE(6986),
    [sym_value_declaration_left] = STATE(6986),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2393),
    [sym_block_comment] = STATE(2393),
    [sym_line_comment] = STATE(2393),
    [sym_compiler_directive_decl] = STATE(2393),
    [sym_fsi_directive_decl] = STATE(2393),
    [sym_preproc_line] = STATE(2393),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4947),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2394] = {
    [sym_xml_doc] = STATE(2394),
    [sym_block_comment] = STATE(2394),
    [sym_line_comment] = STATE(2394),
    [sym_compiler_directive_decl] = STATE(2394),
    [sym_fsi_directive_decl] = STATE(2394),
    [sym_preproc_line] = STATE(2394),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [anon_sym_POUNDendif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2395] = {
    [sym_xml_doc] = STATE(2395),
    [sym_block_comment] = STATE(2395),
    [sym_line_comment] = STATE(2395),
    [sym_compiler_directive_decl] = STATE(2395),
    [sym_fsi_directive_decl] = STATE(2395),
    [sym_preproc_line] = STATE(2395),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [anon_sym_POUNDendif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2396] = {
    [sym_xml_doc] = STATE(2396),
    [sym_block_comment] = STATE(2396),
    [sym_line_comment] = STATE(2396),
    [sym_compiler_directive_decl] = STATE(2396),
    [sym_fsi_directive_decl] = STATE(2396),
    [sym_preproc_line] = STATE(2396),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [anon_sym_POUNDendif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2397] = {
    [sym_xml_doc] = STATE(2397),
    [sym_block_comment] = STATE(2397),
    [sym_line_comment] = STATE(2397),
    [sym_compiler_directive_decl] = STATE(2397),
    [sym_fsi_directive_decl] = STATE(2397),
    [sym_preproc_line] = STATE(2397),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [anon_sym_POUNDendif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2398] = {
    [sym_xml_doc] = STATE(2398),
    [sym_block_comment] = STATE(2398),
    [sym_line_comment] = STATE(2398),
    [sym_compiler_directive_decl] = STATE(2398),
    [sym_fsi_directive_decl] = STATE(2398),
    [sym_preproc_line] = STATE(2398),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [anon_sym_POUNDendif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2399] = {
    [sym_xml_doc] = STATE(2399),
    [sym_block_comment] = STATE(2399),
    [sym_line_comment] = STATE(2399),
    [sym_compiler_directive_decl] = STATE(2399),
    [sym_fsi_directive_decl] = STATE(2399),
    [sym_preproc_line] = STATE(2399),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2400] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4081),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(2400),
    [sym_block_comment] = STATE(2400),
    [sym_line_comment] = STATE(2400),
    [sym_compiler_directive_decl] = STATE(2400),
    [sym_fsi_directive_decl] = STATE(2400),
    [sym_preproc_line] = STATE(2400),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4764),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4764),
    [anon_sym__] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4762),
    [anon_sym_LBRACE] = ACTIONS(4762),
    [anon_sym_DASH_GT] = ACTIONS(4762),
    [aux_sym_char_token1] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4764),
    [anon_sym_DQUOTE] = ACTIONS(4764),
    [anon_sym_AT_DQUOTE] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [sym_bool] = ACTIONS(4764),
    [sym_unit] = ACTIONS(4762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4764),
    [sym_xint] = ACTIONS(4762),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2401] = {
    [sym_xml_doc] = STATE(2401),
    [sym_block_comment] = STATE(2401),
    [sym_line_comment] = STATE(2401),
    [sym_compiler_directive_decl] = STATE(2401),
    [sym_fsi_directive_decl] = STATE(2401),
    [sym_preproc_line] = STATE(2401),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_GT] = ACTIONS(3794),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2402] = {
    [sym_xml_doc] = STATE(2402),
    [sym_block_comment] = STATE(2402),
    [sym_line_comment] = STATE(2402),
    [sym_compiler_directive_decl] = STATE(2402),
    [sym_fsi_directive_decl] = STATE(2402),
    [sym_preproc_line] = STATE(2402),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2403] = {
    [sym_xml_doc] = STATE(2403),
    [sym_block_comment] = STATE(2403),
    [sym_line_comment] = STATE(2403),
    [sym_compiler_directive_decl] = STATE(2403),
    [sym_fsi_directive_decl] = STATE(2403),
    [sym_preproc_line] = STATE(2403),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_AT_GT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2404] = {
    [sym_xml_doc] = STATE(2404),
    [sym_block_comment] = STATE(2404),
    [sym_line_comment] = STATE(2404),
    [sym_compiler_directive_decl] = STATE(2404),
    [sym_fsi_directive_decl] = STATE(2404),
    [sym_preproc_line] = STATE(2404),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [anon_sym_POUNDendif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2405] = {
    [sym_xml_doc] = STATE(2405),
    [sym_block_comment] = STATE(2405),
    [sym_line_comment] = STATE(2405),
    [sym_compiler_directive_decl] = STATE(2405),
    [sym_fsi_directive_decl] = STATE(2405),
    [sym_preproc_line] = STATE(2405),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_DOT_DOT] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2406] = {
    [sym_xml_doc] = STATE(2406),
    [sym_block_comment] = STATE(2406),
    [sym_line_comment] = STATE(2406),
    [sym_compiler_directive_decl] = STATE(2406),
    [sym_fsi_directive_decl] = STATE(2406),
    [sym_preproc_line] = STATE(2406),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [anon_sym_POUNDendif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2407] = {
    [sym_xml_doc] = STATE(2407),
    [sym_block_comment] = STATE(2407),
    [sym_line_comment] = STATE(2407),
    [sym_compiler_directive_decl] = STATE(2407),
    [sym_fsi_directive_decl] = STATE(2407),
    [sym_preproc_line] = STATE(2407),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_AT_AT_GT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2408] = {
    [sym_xml_doc] = STATE(2408),
    [sym_block_comment] = STATE(2408),
    [sym_line_comment] = STATE(2408),
    [sym_compiler_directive_decl] = STATE(2408),
    [sym_fsi_directive_decl] = STATE(2408),
    [sym_preproc_line] = STATE(2408),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4268),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2409] = {
    [sym_xml_doc] = STATE(2409),
    [sym_block_comment] = STATE(2409),
    [sym_line_comment] = STATE(2409),
    [sym_compiler_directive_decl] = STATE(2409),
    [sym_fsi_directive_decl] = STATE(2409),
    [sym_preproc_line] = STATE(2409),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(3701),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2410] = {
    [sym_xml_doc] = STATE(2410),
    [sym_block_comment] = STATE(2410),
    [sym_line_comment] = STATE(2410),
    [sym_compiler_directive_decl] = STATE(2410),
    [sym_fsi_directive_decl] = STATE(2410),
    [sym_preproc_line] = STATE(2410),
    [ts_builtin_sym_end] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_open] = ACTIONS(3361),
    [anon_sym_LBRACK_LT] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_and] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [aux_sym_access_modifier_token1] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_or] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_member] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_val] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3363),
    [anon_sym_DASH_DOT] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3363),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3363),
    [anon_sym_POUNDload] = ACTIONS(3363),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
  },
  [2411] = {
    [sym_xml_doc] = STATE(2411),
    [sym_block_comment] = STATE(2411),
    [sym_line_comment] = STATE(2411),
    [sym_compiler_directive_decl] = STATE(2411),
    [sym_fsi_directive_decl] = STATE(2411),
    [sym_preproc_line] = STATE(2411),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2412] = {
    [sym_xml_doc] = STATE(2412),
    [sym_block_comment] = STATE(2412),
    [sym_line_comment] = STATE(2412),
    [sym_compiler_directive_decl] = STATE(2412),
    [sym_fsi_directive_decl] = STATE(2412),
    [sym_preproc_line] = STATE(2412),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2413] = {
    [sym_xml_doc] = STATE(2413),
    [sym_block_comment] = STATE(2413),
    [sym_line_comment] = STATE(2413),
    [sym_compiler_directive_decl] = STATE(2413),
    [sym_fsi_directive_decl] = STATE(2413),
    [sym_preproc_line] = STATE(2413),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [anon_sym_POUNDendif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2414] = {
    [sym_xml_doc] = STATE(2414),
    [sym_block_comment] = STATE(2414),
    [sym_line_comment] = STATE(2414),
    [sym_compiler_directive_decl] = STATE(2414),
    [sym_fsi_directive_decl] = STATE(2414),
    [sym_preproc_line] = STATE(2414),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_DOT_DOT] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2415] = {
    [sym_xml_doc] = STATE(2415),
    [sym_block_comment] = STATE(2415),
    [sym_line_comment] = STATE(2415),
    [sym_compiler_directive_decl] = STATE(2415),
    [sym_fsi_directive_decl] = STATE(2415),
    [sym_preproc_line] = STATE(2415),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_DOT_DOT] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2416] = {
    [sym_xml_doc] = STATE(2416),
    [sym_block_comment] = STATE(2416),
    [sym_line_comment] = STATE(2416),
    [sym_compiler_directive_decl] = STATE(2416),
    [sym_fsi_directive_decl] = STATE(2416),
    [sym_preproc_line] = STATE(2416),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [anon_sym_POUNDendif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2417] = {
    [sym_xml_doc] = STATE(2417),
    [sym_block_comment] = STATE(2417),
    [sym_line_comment] = STATE(2417),
    [sym_compiler_directive_decl] = STATE(2417),
    [sym_fsi_directive_decl] = STATE(2417),
    [sym_preproc_line] = STATE(2417),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [anon_sym_POUNDendif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2418] = {
    [sym_xml_doc] = STATE(2418),
    [sym_block_comment] = STATE(2418),
    [sym_line_comment] = STATE(2418),
    [sym_compiler_directive_decl] = STATE(2418),
    [sym_fsi_directive_decl] = STATE(2418),
    [sym_preproc_line] = STATE(2418),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2419] = {
    [sym_xml_doc] = STATE(2419),
    [sym_block_comment] = STATE(2419),
    [sym_line_comment] = STATE(2419),
    [sym_compiler_directive_decl] = STATE(2419),
    [sym_fsi_directive_decl] = STATE(2419),
    [sym_preproc_line] = STATE(2419),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [anon_sym_POUNDendif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2420] = {
    [sym_xml_doc] = STATE(2420),
    [sym_block_comment] = STATE(2420),
    [sym_line_comment] = STATE(2420),
    [sym_compiler_directive_decl] = STATE(2420),
    [sym_fsi_directive_decl] = STATE(2420),
    [sym_preproc_line] = STATE(2420),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [anon_sym_POUNDendif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2421] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2421),
    [sym_block_comment] = STATE(2421),
    [sym_line_comment] = STATE(2421),
    [sym_compiler_directive_decl] = STATE(2421),
    [sym_fsi_directive_decl] = STATE(2421),
    [sym_preproc_line] = STATE(2421),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(4955),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(4957),
    [anon_sym_module] = ACTIONS(4957),
    [anon_sym_open] = ACTIONS(4957),
    [anon_sym_LBRACK_LT] = ACTIONS(4955),
    [anon_sym_return] = ACTIONS(4957),
    [anon_sym_type] = ACTIONS(4957),
    [anon_sym_do] = ACTIONS(4957),
    [anon_sym_and] = ACTIONS(4957),
    [anon_sym_let] = ACTIONS(4957),
    [anon_sym_let_BANG] = ACTIONS(4955),
    [aux_sym_access_modifier_token1] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(4957),
    [anon_sym_null] = ACTIONS(4957),
    [anon_sym_AMP] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_LT_AT] = ACTIONS(4957),
    [anon_sym_LT_AT_AT] = ACTIONS(4955),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4955),
    [anon_sym_with] = ACTIONS(4957),
    [anon_sym_new] = ACTIONS(4957),
    [anon_sym_return_BANG] = ACTIONS(4955),
    [anon_sym_yield] = ACTIONS(4957),
    [anon_sym_yield_BANG] = ACTIONS(4955),
    [anon_sym_lazy] = ACTIONS(4957),
    [anon_sym_assert] = ACTIONS(4957),
    [anon_sym_upcast] = ACTIONS(4957),
    [anon_sym_downcast] = ACTIONS(4957),
    [anon_sym_for] = ACTIONS(4957),
    [anon_sym_while] = ACTIONS(4957),
    [anon_sym_if] = ACTIONS(4957),
    [anon_sym_fun] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [anon_sym_try] = ACTIONS(4957),
    [anon_sym_match] = ACTIONS(4957),
    [anon_sym_match_BANG] = ACTIONS(4955),
    [anon_sym_function] = ACTIONS(4957),
    [anon_sym_use] = ACTIONS(4957),
    [anon_sym_use_BANG] = ACTIONS(4955),
    [anon_sym_do_BANG] = ACTIONS(4955),
    [anon_sym_begin] = ACTIONS(4957),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(4957),
    [anon_sym_static] = ACTIONS(4957),
    [anon_sym_member] = ACTIONS(4957),
    [anon_sym_abstract] = ACTIONS(4957),
    [anon_sym_override] = ACTIONS(4957),
    [anon_sym_val] = ACTIONS(4957),
    [aux_sym_char_token1] = ACTIONS(4955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4957),
    [anon_sym_DQUOTE] = ACTIONS(4957),
    [anon_sym_AT_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4955),
    [sym_bool] = ACTIONS(4957),
    [sym_unit] = ACTIONS(4955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4957),
    [sym_op_identifier] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_DOT] = ACTIONS(4955),
    [anon_sym_DASH_DOT] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [aux_sym_prefix_op_token1] = ACTIONS(4955),
    [sym_int] = ACTIONS(4957),
    [sym_xint] = ACTIONS(4955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4955),
    [anon_sym_POUNDload] = ACTIONS(4955),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4955),
  },
  [2422] = {
    [sym_xml_doc] = STATE(2422),
    [sym_block_comment] = STATE(2422),
    [sym_line_comment] = STATE(2422),
    [sym_compiler_directive_decl] = STATE(2422),
    [sym_fsi_directive_decl] = STATE(2422),
    [sym_preproc_line] = STATE(2422),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_AT_AT_GT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2423] = {
    [sym_xml_doc] = STATE(2423),
    [sym_block_comment] = STATE(2423),
    [sym_line_comment] = STATE(2423),
    [sym_compiler_directive_decl] = STATE(2423),
    [sym_fsi_directive_decl] = STATE(2423),
    [sym_preproc_line] = STATE(2423),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_DOT_DOT] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2424] = {
    [sym_xml_doc] = STATE(2424),
    [sym_block_comment] = STATE(2424),
    [sym_line_comment] = STATE(2424),
    [sym_compiler_directive_decl] = STATE(2424),
    [sym_fsi_directive_decl] = STATE(2424),
    [sym_preproc_line] = STATE(2424),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_AT_GT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2425] = {
    [sym_xml_doc] = STATE(2425),
    [sym_block_comment] = STATE(2425),
    [sym_line_comment] = STATE(2425),
    [sym_compiler_directive_decl] = STATE(2425),
    [sym_fsi_directive_decl] = STATE(2425),
    [sym_preproc_line] = STATE(2425),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_AT_GT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2426] = {
    [sym_xml_doc] = STATE(2426),
    [sym_block_comment] = STATE(2426),
    [sym_line_comment] = STATE(2426),
    [sym_compiler_directive_decl] = STATE(2426),
    [sym_fsi_directive_decl] = STATE(2426),
    [sym_preproc_line] = STATE(2426),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_DOT_DOT] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2427] = {
    [sym_xml_doc] = STATE(2427),
    [sym_block_comment] = STATE(2427),
    [sym_line_comment] = STATE(2427),
    [sym_compiler_directive_decl] = STATE(2427),
    [sym_fsi_directive_decl] = STATE(2427),
    [sym_preproc_line] = STATE(2427),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2428] = {
    [sym_xml_doc] = STATE(2428),
    [sym_block_comment] = STATE(2428),
    [sym_line_comment] = STATE(2428),
    [sym_compiler_directive_decl] = STATE(2428),
    [sym_fsi_directive_decl] = STATE(2428),
    [sym_preproc_line] = STATE(2428),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_DOT_DOT] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2429] = {
    [sym_xml_doc] = STATE(2429),
    [sym_block_comment] = STATE(2429),
    [sym_line_comment] = STATE(2429),
    [sym_compiler_directive_decl] = STATE(2429),
    [sym_fsi_directive_decl] = STATE(2429),
    [sym_preproc_line] = STATE(2429),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [anon_sym_POUNDendif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2430] = {
    [sym_xml_doc] = STATE(2430),
    [sym_block_comment] = STATE(2430),
    [sym_line_comment] = STATE(2430),
    [sym_compiler_directive_decl] = STATE(2430),
    [sym_fsi_directive_decl] = STATE(2430),
    [sym_preproc_line] = STATE(2430),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_AT_GT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2431] = {
    [sym_xml_doc] = STATE(2431),
    [sym_block_comment] = STATE(2431),
    [sym_line_comment] = STATE(2431),
    [sym_compiler_directive_decl] = STATE(2431),
    [sym_fsi_directive_decl] = STATE(2431),
    [sym_preproc_line] = STATE(2431),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_AT_GT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2432] = {
    [sym_xml_doc] = STATE(2432),
    [sym_block_comment] = STATE(2432),
    [sym_line_comment] = STATE(2432),
    [sym_compiler_directive_decl] = STATE(2432),
    [sym_fsi_directive_decl] = STATE(2432),
    [sym_preproc_line] = STATE(2432),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_AT_AT_GT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2433] = {
    [sym_xml_doc] = STATE(2433),
    [sym_block_comment] = STATE(2433),
    [sym_line_comment] = STATE(2433),
    [sym_compiler_directive_decl] = STATE(2433),
    [sym_fsi_directive_decl] = STATE(2433),
    [sym_preproc_line] = STATE(2433),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_DOT_DOT] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2434] = {
    [sym_xml_doc] = STATE(2434),
    [sym_block_comment] = STATE(2434),
    [sym_line_comment] = STATE(2434),
    [sym_compiler_directive_decl] = STATE(2434),
    [sym_fsi_directive_decl] = STATE(2434),
    [sym_preproc_line] = STATE(2434),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2435] = {
    [sym_xml_doc] = STATE(2435),
    [sym_block_comment] = STATE(2435),
    [sym_line_comment] = STATE(2435),
    [sym_compiler_directive_decl] = STATE(2435),
    [sym_fsi_directive_decl] = STATE(2435),
    [sym_preproc_line] = STATE(2435),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [anon_sym_POUNDendif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2436] = {
    [sym_xml_doc] = STATE(2436),
    [sym_block_comment] = STATE(2436),
    [sym_line_comment] = STATE(2436),
    [sym_compiler_directive_decl] = STATE(2436),
    [sym_fsi_directive_decl] = STATE(2436),
    [sym_preproc_line] = STATE(2436),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [anon_sym_POUNDendif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2437] = {
    [sym_xml_doc] = STATE(2437),
    [sym_block_comment] = STATE(2437),
    [sym_line_comment] = STATE(2437),
    [sym_compiler_directive_decl] = STATE(2437),
    [sym_fsi_directive_decl] = STATE(2437),
    [sym_preproc_line] = STATE(2437),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_DOT_DOT] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2438] = {
    [sym_xml_doc] = STATE(2438),
    [sym_block_comment] = STATE(2438),
    [sym_line_comment] = STATE(2438),
    [sym_compiler_directive_decl] = STATE(2438),
    [sym_fsi_directive_decl] = STATE(2438),
    [sym_preproc_line] = STATE(2438),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_AT_AT_GT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2439] = {
    [sym_xml_doc] = STATE(2439),
    [sym_block_comment] = STATE(2439),
    [sym_line_comment] = STATE(2439),
    [sym_compiler_directive_decl] = STATE(2439),
    [sym_fsi_directive_decl] = STATE(2439),
    [sym_preproc_line] = STATE(2439),
    [aux_sym_type_argument_repeat1] = STATE(2682),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_open] = ACTIONS(3230),
    [anon_sym_LBRACK_LT] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_and] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [aux_sym_access_modifier_token1] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_member] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(3230),
    [anon_sym_override] = ACTIONS(3230),
    [anon_sym_val] = ACTIONS(3230),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3232),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3232),
    [anon_sym_DASH_DOT] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3232),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3232),
    [anon_sym_POUNDload] = ACTIONS(3232),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__dedent] = ACTIONS(3232),
  },
  [2440] = {
    [sym_xml_doc] = STATE(2440),
    [sym_block_comment] = STATE(2440),
    [sym_line_comment] = STATE(2440),
    [sym_compiler_directive_decl] = STATE(2440),
    [sym_fsi_directive_decl] = STATE(2440),
    [sym_preproc_line] = STATE(2440),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [anon_sym_POUNDendif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2441] = {
    [sym_xml_doc] = STATE(2441),
    [sym_block_comment] = STATE(2441),
    [sym_line_comment] = STATE(2441),
    [sym_compiler_directive_decl] = STATE(2441),
    [sym_fsi_directive_decl] = STATE(2441),
    [sym_preproc_line] = STATE(2441),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_AT_AT_GT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2442] = {
    [sym_xml_doc] = STATE(2442),
    [sym_block_comment] = STATE(2442),
    [sym_line_comment] = STATE(2442),
    [sym_compiler_directive_decl] = STATE(2442),
    [sym_fsi_directive_decl] = STATE(2442),
    [sym_preproc_line] = STATE(2442),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_DOT_DOT] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2443] = {
    [sym_xml_doc] = STATE(2443),
    [sym_block_comment] = STATE(2443),
    [sym_line_comment] = STATE(2443),
    [sym_compiler_directive_decl] = STATE(2443),
    [sym_fsi_directive_decl] = STATE(2443),
    [sym_preproc_line] = STATE(2443),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_AT_AT_GT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2444] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(6750),
    [sym__function_or_value_defn_body] = STATE(6156),
    [sym_function_declaration_left] = STATE(7044),
    [sym_value_declaration_left] = STATE(7044),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2444),
    [sym_block_comment] = STATE(2444),
    [sym_line_comment] = STATE(2444),
    [sym_compiler_directive_decl] = STATE(2444),
    [sym_fsi_directive_decl] = STATE(2444),
    [sym_preproc_line] = STATE(2444),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2445] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(3537),
    [sym__function_or_value_defn_body] = STATE(3502),
    [sym_function_declaration_left] = STATE(6986),
    [sym_value_declaration_left] = STATE(6986),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2445),
    [sym_block_comment] = STATE(2445),
    [sym_line_comment] = STATE(2445),
    [sym_compiler_directive_decl] = STATE(2445),
    [sym_fsi_directive_decl] = STATE(2445),
    [sym_preproc_line] = STATE(2445),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2446] = {
    [sym_xml_doc] = STATE(2446),
    [sym_block_comment] = STATE(2446),
    [sym_line_comment] = STATE(2446),
    [sym_compiler_directive_decl] = STATE(2446),
    [sym_fsi_directive_decl] = STATE(2446),
    [sym_preproc_line] = STATE(2446),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_AT_AT_GT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2447] = {
    [sym_xml_doc] = STATE(2447),
    [sym_block_comment] = STATE(2447),
    [sym_line_comment] = STATE(2447),
    [sym_compiler_directive_decl] = STATE(2447),
    [sym_fsi_directive_decl] = STATE(2447),
    [sym_preproc_line] = STATE(2447),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_AT_AT_GT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2448] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(6751),
    [sym_function_declaration_left] = STATE(7044),
    [sym_value_declaration_left] = STATE(7044),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2448),
    [sym_block_comment] = STATE(2448),
    [sym_line_comment] = STATE(2448),
    [sym_compiler_directive_decl] = STATE(2448),
    [sym_fsi_directive_decl] = STATE(2448),
    [sym_preproc_line] = STATE(2448),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4961),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2449] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(6749),
    [sym__function_or_value_defn_body] = STATE(6163),
    [sym_function_declaration_left] = STATE(7085),
    [sym_value_declaration_left] = STATE(7085),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2449),
    [sym_block_comment] = STATE(2449),
    [sym_line_comment] = STATE(2449),
    [sym_compiler_directive_decl] = STATE(2449),
    [sym_fsi_directive_decl] = STATE(2449),
    [sym_preproc_line] = STATE(2449),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2450] = {
    [sym_xml_doc] = STATE(2450),
    [sym_block_comment] = STATE(2450),
    [sym_line_comment] = STATE(2450),
    [sym_compiler_directive_decl] = STATE(2450),
    [sym_fsi_directive_decl] = STATE(2450),
    [sym_preproc_line] = STATE(2450),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_DOT_DOT] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2451] = {
    [sym_xml_doc] = STATE(2451),
    [sym_block_comment] = STATE(2451),
    [sym_line_comment] = STATE(2451),
    [sym_compiler_directive_decl] = STATE(2451),
    [sym_fsi_directive_decl] = STATE(2451),
    [sym_preproc_line] = STATE(2451),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_AT_AT_GT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2452] = {
    [sym_xml_doc] = STATE(2452),
    [sym_block_comment] = STATE(2452),
    [sym_line_comment] = STATE(2452),
    [sym_compiler_directive_decl] = STATE(2452),
    [sym_fsi_directive_decl] = STATE(2452),
    [sym_preproc_line] = STATE(2452),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2453] = {
    [sym_xml_doc] = STATE(2453),
    [sym_block_comment] = STATE(2453),
    [sym_line_comment] = STATE(2453),
    [sym_compiler_directive_decl] = STATE(2453),
    [sym_fsi_directive_decl] = STATE(2453),
    [sym_preproc_line] = STATE(2453),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_DOT_DOT] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2454] = {
    [sym_xml_doc] = STATE(2454),
    [sym_block_comment] = STATE(2454),
    [sym_line_comment] = STATE(2454),
    [sym_compiler_directive_decl] = STATE(2454),
    [sym_fsi_directive_decl] = STATE(2454),
    [sym_preproc_line] = STATE(2454),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_DOT_DOT] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2455] = {
    [sym_xml_doc] = STATE(2455),
    [sym_block_comment] = STATE(2455),
    [sym_line_comment] = STATE(2455),
    [sym_compiler_directive_decl] = STATE(2455),
    [sym_fsi_directive_decl] = STATE(2455),
    [sym_preproc_line] = STATE(2455),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_AT_AT_GT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2456] = {
    [sym_xml_doc] = STATE(2456),
    [sym_block_comment] = STATE(2456),
    [sym_line_comment] = STATE(2456),
    [sym_compiler_directive_decl] = STATE(2456),
    [sym_fsi_directive_decl] = STATE(2456),
    [sym_preproc_line] = STATE(2456),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_AT_AT_GT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2457] = {
    [sym_xml_doc] = STATE(2457),
    [sym_block_comment] = STATE(2457),
    [sym_line_comment] = STATE(2457),
    [sym_compiler_directive_decl] = STATE(2457),
    [sym_fsi_directive_decl] = STATE(2457),
    [sym_preproc_line] = STATE(2457),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_AT_AT_GT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2458] = {
    [sym_xml_doc] = STATE(2458),
    [sym_block_comment] = STATE(2458),
    [sym_line_comment] = STATE(2458),
    [sym_compiler_directive_decl] = STATE(2458),
    [sym_fsi_directive_decl] = STATE(2458),
    [sym_preproc_line] = STATE(2458),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_AT_GT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2459] = {
    [sym_xml_doc] = STATE(2459),
    [sym_block_comment] = STATE(2459),
    [sym_line_comment] = STATE(2459),
    [sym_compiler_directive_decl] = STATE(2459),
    [sym_fsi_directive_decl] = STATE(2459),
    [sym_preproc_line] = STATE(2459),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_AT_AT_GT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2460] = {
    [sym_xml_doc] = STATE(2460),
    [sym_block_comment] = STATE(2460),
    [sym_line_comment] = STATE(2460),
    [sym_compiler_directive_decl] = STATE(2460),
    [sym_fsi_directive_decl] = STATE(2460),
    [sym_preproc_line] = STATE(2460),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_AT_AT_GT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2461] = {
    [sym_xml_doc] = STATE(2461),
    [sym_block_comment] = STATE(2461),
    [sym_line_comment] = STATE(2461),
    [sym_compiler_directive_decl] = STATE(2461),
    [sym_fsi_directive_decl] = STATE(2461),
    [sym_preproc_line] = STATE(2461),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_AT_AT_GT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4245),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2462] = {
    [sym_xml_doc] = STATE(2462),
    [sym_block_comment] = STATE(2462),
    [sym_line_comment] = STATE(2462),
    [sym_compiler_directive_decl] = STATE(2462),
    [sym_fsi_directive_decl] = STATE(2462),
    [sym_preproc_line] = STATE(2462),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_AT_AT_GT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2463] = {
    [sym_xml_doc] = STATE(2463),
    [sym_block_comment] = STATE(2463),
    [sym_line_comment] = STATE(2463),
    [sym_compiler_directive_decl] = STATE(2463),
    [sym_fsi_directive_decl] = STATE(2463),
    [sym_preproc_line] = STATE(2463),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2464] = {
    [sym_xml_doc] = STATE(2464),
    [sym_block_comment] = STATE(2464),
    [sym_line_comment] = STATE(2464),
    [sym_compiler_directive_decl] = STATE(2464),
    [sym_fsi_directive_decl] = STATE(2464),
    [sym_preproc_line] = STATE(2464),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_DOT_DOT] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2465] = {
    [sym_xml_doc] = STATE(2465),
    [sym_block_comment] = STATE(2465),
    [sym_line_comment] = STATE(2465),
    [sym_compiler_directive_decl] = STATE(2465),
    [sym_fsi_directive_decl] = STATE(2465),
    [sym_preproc_line] = STATE(2465),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_AT_GT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2466] = {
    [sym_xml_doc] = STATE(2466),
    [sym_block_comment] = STATE(2466),
    [sym_line_comment] = STATE(2466),
    [sym_compiler_directive_decl] = STATE(2466),
    [sym_fsi_directive_decl] = STATE(2466),
    [sym_preproc_line] = STATE(2466),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [anon_sym_POUNDendif] = ACTIONS(4173),
    [sym__newline] = ACTIONS(3546),
  },
  [2467] = {
    [sym_xml_doc] = STATE(2467),
    [sym_block_comment] = STATE(2467),
    [sym_line_comment] = STATE(2467),
    [sym_compiler_directive_decl] = STATE(2467),
    [sym_fsi_directive_decl] = STATE(2467),
    [sym_preproc_line] = STATE(2467),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_AT_GT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2468] = {
    [sym_xml_doc] = STATE(2468),
    [sym_block_comment] = STATE(2468),
    [sym_line_comment] = STATE(2468),
    [sym_compiler_directive_decl] = STATE(2468),
    [sym_fsi_directive_decl] = STATE(2468),
    [sym_preproc_line] = STATE(2468),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_DOT_DOT] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2469] = {
    [sym_xml_doc] = STATE(2469),
    [sym_block_comment] = STATE(2469),
    [sym_line_comment] = STATE(2469),
    [sym_compiler_directive_decl] = STATE(2469),
    [sym_fsi_directive_decl] = STATE(2469),
    [sym_preproc_line] = STATE(2469),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_AT_GT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2470] = {
    [sym_xml_doc] = STATE(2470),
    [sym_block_comment] = STATE(2470),
    [sym_line_comment] = STATE(2470),
    [sym_compiler_directive_decl] = STATE(2470),
    [sym_fsi_directive_decl] = STATE(2470),
    [sym_preproc_line] = STATE(2470),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_AT_GT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2471] = {
    [sym_xml_doc] = STATE(2471),
    [sym_block_comment] = STATE(2471),
    [sym_line_comment] = STATE(2471),
    [sym_compiler_directive_decl] = STATE(2471),
    [sym_fsi_directive_decl] = STATE(2471),
    [sym_preproc_line] = STATE(2471),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_AT_GT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2472] = {
    [sym_xml_doc] = STATE(2472),
    [sym_block_comment] = STATE(2472),
    [sym_line_comment] = STATE(2472),
    [sym_compiler_directive_decl] = STATE(2472),
    [sym_fsi_directive_decl] = STATE(2472),
    [sym_preproc_line] = STATE(2472),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_AT_GT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2473] = {
    [sym_xml_doc] = STATE(2473),
    [sym_block_comment] = STATE(2473),
    [sym_line_comment] = STATE(2473),
    [sym_compiler_directive_decl] = STATE(2473),
    [sym_fsi_directive_decl] = STATE(2473),
    [sym_preproc_line] = STATE(2473),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_AT_GT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2474] = {
    [sym_xml_doc] = STATE(2474),
    [sym_block_comment] = STATE(2474),
    [sym_line_comment] = STATE(2474),
    [sym_compiler_directive_decl] = STATE(2474),
    [sym_fsi_directive_decl] = STATE(2474),
    [sym_preproc_line] = STATE(2474),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_AT_GT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2475] = {
    [sym_xml_doc] = STATE(2475),
    [sym_block_comment] = STATE(2475),
    [sym_line_comment] = STATE(2475),
    [sym_compiler_directive_decl] = STATE(2475),
    [sym_fsi_directive_decl] = STATE(2475),
    [sym_preproc_line] = STATE(2475),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_AT_GT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2476] = {
    [sym_xml_doc] = STATE(2476),
    [sym_block_comment] = STATE(2476),
    [sym_line_comment] = STATE(2476),
    [sym_compiler_directive_decl] = STATE(2476),
    [sym_fsi_directive_decl] = STATE(2476),
    [sym_preproc_line] = STATE(2476),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_AT_GT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2477] = {
    [sym_xml_doc] = STATE(2477),
    [sym_block_comment] = STATE(2477),
    [sym_line_comment] = STATE(2477),
    [sym_compiler_directive_decl] = STATE(2477),
    [sym_fsi_directive_decl] = STATE(2477),
    [sym_preproc_line] = STATE(2477),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_AT_GT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2478] = {
    [sym_xml_doc] = STATE(2478),
    [sym_block_comment] = STATE(2478),
    [sym_line_comment] = STATE(2478),
    [sym_compiler_directive_decl] = STATE(2478),
    [sym_fsi_directive_decl] = STATE(2478),
    [sym_preproc_line] = STATE(2478),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_AT_GT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2479] = {
    [sym_xml_doc] = STATE(2479),
    [sym_block_comment] = STATE(2479),
    [sym_line_comment] = STATE(2479),
    [sym_compiler_directive_decl] = STATE(2479),
    [sym_fsi_directive_decl] = STATE(2479),
    [sym_preproc_line] = STATE(2479),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_AT_GT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2480] = {
    [sym_xml_doc] = STATE(2480),
    [sym_block_comment] = STATE(2480),
    [sym_line_comment] = STATE(2480),
    [sym_compiler_directive_decl] = STATE(2480),
    [sym_fsi_directive_decl] = STATE(2480),
    [sym_preproc_line] = STATE(2480),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_AT_AT_GT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2481] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(3495),
    [sym__function_or_value_defn_body] = STATE(3467),
    [sym_function_declaration_left] = STATE(7112),
    [sym_value_declaration_left] = STATE(7112),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2481),
    [sym_block_comment] = STATE(2481),
    [sym_line_comment] = STATE(2481),
    [sym_compiler_directive_decl] = STATE(2481),
    [sym_fsi_directive_decl] = STATE(2481),
    [sym_preproc_line] = STATE(2481),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2482] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(4877),
    [sym_function_declaration_left] = STATE(6935),
    [sym_value_declaration_left] = STATE(6935),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2482),
    [sym_block_comment] = STATE(2482),
    [sym_line_comment] = STATE(2482),
    [sym_compiler_directive_decl] = STATE(2482),
    [sym_fsi_directive_decl] = STATE(2482),
    [sym_preproc_line] = STATE(2482),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4963),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2483] = {
    [sym_xml_doc] = STATE(2483),
    [sym_block_comment] = STATE(2483),
    [sym_line_comment] = STATE(2483),
    [sym_compiler_directive_decl] = STATE(2483),
    [sym_fsi_directive_decl] = STATE(2483),
    [sym_preproc_line] = STATE(2483),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_AT_GT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2484] = {
    [sym_xml_doc] = STATE(2484),
    [sym_block_comment] = STATE(2484),
    [sym_line_comment] = STATE(2484),
    [sym_compiler_directive_decl] = STATE(2484),
    [sym_fsi_directive_decl] = STATE(2484),
    [sym_preproc_line] = STATE(2484),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_AT_GT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2485] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(3353),
    [sym__function_or_value_defn_body] = STATE(3249),
    [sym_function_declaration_left] = STATE(6579),
    [sym_value_declaration_left] = STATE(6579),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2485),
    [sym_block_comment] = STATE(2485),
    [sym_line_comment] = STATE(2485),
    [sym_compiler_directive_decl] = STATE(2485),
    [sym_fsi_directive_decl] = STATE(2485),
    [sym_preproc_line] = STATE(2485),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2486] = {
    [sym_xml_doc] = STATE(2486),
    [sym_block_comment] = STATE(2486),
    [sym_line_comment] = STATE(2486),
    [sym_compiler_directive_decl] = STATE(2486),
    [sym_fsi_directive_decl] = STATE(2486),
    [sym_preproc_line] = STATE(2486),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [anon_sym_POUNDendif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2487] = {
    [sym_xml_doc] = STATE(2487),
    [sym_block_comment] = STATE(2487),
    [sym_line_comment] = STATE(2487),
    [sym_compiler_directive_decl] = STATE(2487),
    [sym_fsi_directive_decl] = STATE(2487),
    [sym_preproc_line] = STATE(2487),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_AT_GT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2488] = {
    [sym_xml_doc] = STATE(2488),
    [sym_block_comment] = STATE(2488),
    [sym_line_comment] = STATE(2488),
    [sym_compiler_directive_decl] = STATE(2488),
    [sym_fsi_directive_decl] = STATE(2488),
    [sym_preproc_line] = STATE(2488),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_AT_GT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2489] = {
    [sym_xml_doc] = STATE(2489),
    [sym_block_comment] = STATE(2489),
    [sym_line_comment] = STATE(2489),
    [sym_compiler_directive_decl] = STATE(2489),
    [sym_fsi_directive_decl] = STATE(2489),
    [sym_preproc_line] = STATE(2489),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_AT_GT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2490] = {
    [sym_xml_doc] = STATE(2490),
    [sym_block_comment] = STATE(2490),
    [sym_line_comment] = STATE(2490),
    [sym_compiler_directive_decl] = STATE(2490),
    [sym_fsi_directive_decl] = STATE(2490),
    [sym_preproc_line] = STATE(2490),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_AT_GT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2491] = {
    [sym_xml_doc] = STATE(2491),
    [sym_block_comment] = STATE(2491),
    [sym_line_comment] = STATE(2491),
    [sym_compiler_directive_decl] = STATE(2491),
    [sym_fsi_directive_decl] = STATE(2491),
    [sym_preproc_line] = STATE(2491),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_AT_GT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2492] = {
    [sym_xml_doc] = STATE(2492),
    [sym_block_comment] = STATE(2492),
    [sym_line_comment] = STATE(2492),
    [sym_compiler_directive_decl] = STATE(2492),
    [sym_fsi_directive_decl] = STATE(2492),
    [sym_preproc_line] = STATE(2492),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [anon_sym_POUNDendif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2493] = {
    [sym_xml_doc] = STATE(2493),
    [sym_block_comment] = STATE(2493),
    [sym_line_comment] = STATE(2493),
    [sym_compiler_directive_decl] = STATE(2493),
    [sym_fsi_directive_decl] = STATE(2493),
    [sym_preproc_line] = STATE(2493),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_AT_GT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2494] = {
    [sym_xml_doc] = STATE(2494),
    [sym_block_comment] = STATE(2494),
    [sym_line_comment] = STATE(2494),
    [sym_compiler_directive_decl] = STATE(2494),
    [sym_fsi_directive_decl] = STATE(2494),
    [sym_preproc_line] = STATE(2494),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_AT_GT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2495] = {
    [sym_xml_doc] = STATE(2495),
    [sym_block_comment] = STATE(2495),
    [sym_line_comment] = STATE(2495),
    [sym_compiler_directive_decl] = STATE(2495),
    [sym_fsi_directive_decl] = STATE(2495),
    [sym_preproc_line] = STATE(2495),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [anon_sym_POUNDendif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2496] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3455),
    [sym_function_declaration_left] = STATE(7155),
    [sym_value_declaration_left] = STATE(7155),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2496),
    [sym_block_comment] = STATE(2496),
    [sym_line_comment] = STATE(2496),
    [sym_compiler_directive_decl] = STATE(2496),
    [sym_fsi_directive_decl] = STATE(2496),
    [sym_preproc_line] = STATE(2496),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4965),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2497] = {
    [sym_xml_doc] = STATE(2497),
    [sym_block_comment] = STATE(2497),
    [sym_line_comment] = STATE(2497),
    [sym_compiler_directive_decl] = STATE(2497),
    [sym_fsi_directive_decl] = STATE(2497),
    [sym_preproc_line] = STATE(2497),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_AT_AT_GT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2498] = {
    [sym_xml_doc] = STATE(2498),
    [sym_block_comment] = STATE(2498),
    [sym_line_comment] = STATE(2498),
    [sym_compiler_directive_decl] = STATE(2498),
    [sym_fsi_directive_decl] = STATE(2498),
    [sym_preproc_line] = STATE(2498),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_AT_GT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2499] = {
    [sym_xml_doc] = STATE(2499),
    [sym_block_comment] = STATE(2499),
    [sym_line_comment] = STATE(2499),
    [sym_compiler_directive_decl] = STATE(2499),
    [sym_fsi_directive_decl] = STATE(2499),
    [sym_preproc_line] = STATE(2499),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_AT_GT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2500] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(3439),
    [sym__function_or_value_defn_body] = STATE(3306),
    [sym_function_declaration_left] = STATE(7155),
    [sym_value_declaration_left] = STATE(7155),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2500),
    [sym_block_comment] = STATE(2500),
    [sym_line_comment] = STATE(2500),
    [sym_compiler_directive_decl] = STATE(2500),
    [sym_fsi_directive_decl] = STATE(2500),
    [sym_preproc_line] = STATE(2500),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2501] = {
    [sym_xml_doc] = STATE(2501),
    [sym_block_comment] = STATE(2501),
    [sym_line_comment] = STATE(2501),
    [sym_compiler_directive_decl] = STATE(2501),
    [sym_fsi_directive_decl] = STATE(2501),
    [sym_preproc_line] = STATE(2501),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [anon_sym_POUNDendif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2502] = {
    [sym_xml_doc] = STATE(2502),
    [sym_block_comment] = STATE(2502),
    [sym_line_comment] = STATE(2502),
    [sym_compiler_directive_decl] = STATE(2502),
    [sym_fsi_directive_decl] = STATE(2502),
    [sym_preproc_line] = STATE(2502),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [anon_sym_POUNDendif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2503] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7569),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2503),
    [sym_block_comment] = STATE(2503),
    [sym_line_comment] = STATE(2503),
    [sym_compiler_directive_decl] = STATE(2503),
    [sym_fsi_directive_decl] = STATE(2503),
    [sym_preproc_line] = STATE(2503),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2504] = {
    [sym_xml_doc] = STATE(2504),
    [sym_block_comment] = STATE(2504),
    [sym_line_comment] = STATE(2504),
    [sym_compiler_directive_decl] = STATE(2504),
    [sym_fsi_directive_decl] = STATE(2504),
    [sym_preproc_line] = STATE(2504),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [anon_sym_POUNDendif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2505] = {
    [sym_xml_doc] = STATE(2505),
    [sym_block_comment] = STATE(2505),
    [sym_line_comment] = STATE(2505),
    [sym_compiler_directive_decl] = STATE(2505),
    [sym_fsi_directive_decl] = STATE(2505),
    [sym_preproc_line] = STATE(2505),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2506] = {
    [sym_xml_doc] = STATE(2506),
    [sym_block_comment] = STATE(2506),
    [sym_line_comment] = STATE(2506),
    [sym_compiler_directive_decl] = STATE(2506),
    [sym_fsi_directive_decl] = STATE(2506),
    [sym_preproc_line] = STATE(2506),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_DOT_DOT] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2507] = {
    [sym_xml_doc] = STATE(2507),
    [sym_block_comment] = STATE(2507),
    [sym_line_comment] = STATE(2507),
    [sym_compiler_directive_decl] = STATE(2507),
    [sym_fsi_directive_decl] = STATE(2507),
    [sym_preproc_line] = STATE(2507),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_AT_AT_GT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2508] = {
    [sym_xml_doc] = STATE(2508),
    [sym_block_comment] = STATE(2508),
    [sym_line_comment] = STATE(2508),
    [sym_compiler_directive_decl] = STATE(2508),
    [sym_fsi_directive_decl] = STATE(2508),
    [sym_preproc_line] = STATE(2508),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_AT_AT_GT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2509] = {
    [sym_xml_doc] = STATE(2509),
    [sym_block_comment] = STATE(2509),
    [sym_line_comment] = STATE(2509),
    [sym_compiler_directive_decl] = STATE(2509),
    [sym_fsi_directive_decl] = STATE(2509),
    [sym_preproc_line] = STATE(2509),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [anon_sym_POUNDendif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2510] = {
    [sym_xml_doc] = STATE(2510),
    [sym_block_comment] = STATE(2510),
    [sym_line_comment] = STATE(2510),
    [sym_compiler_directive_decl] = STATE(2510),
    [sym_fsi_directive_decl] = STATE(2510),
    [sym_preproc_line] = STATE(2510),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [anon_sym_POUNDendif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2511] = {
    [sym_xml_doc] = STATE(2511),
    [sym_block_comment] = STATE(2511),
    [sym_line_comment] = STATE(2511),
    [sym_compiler_directive_decl] = STATE(2511),
    [sym_fsi_directive_decl] = STATE(2511),
    [sym_preproc_line] = STATE(2511),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_AT_AT_GT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2512] = {
    [sym_xml_doc] = STATE(2512),
    [sym_block_comment] = STATE(2512),
    [sym_line_comment] = STATE(2512),
    [sym_compiler_directive_decl] = STATE(2512),
    [sym_fsi_directive_decl] = STATE(2512),
    [sym_preproc_line] = STATE(2512),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_AT_GT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2513] = {
    [sym_xml_doc] = STATE(2513),
    [sym_block_comment] = STATE(2513),
    [sym_line_comment] = STATE(2513),
    [sym_compiler_directive_decl] = STATE(2513),
    [sym_fsi_directive_decl] = STATE(2513),
    [sym_preproc_line] = STATE(2513),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_AT_AT_GT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2514] = {
    [sym_xml_doc] = STATE(2514),
    [sym_block_comment] = STATE(2514),
    [sym_line_comment] = STATE(2514),
    [sym_compiler_directive_decl] = STATE(2514),
    [sym_fsi_directive_decl] = STATE(2514),
    [sym_preproc_line] = STATE(2514),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_AT_AT_GT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2515] = {
    [sym_xml_doc] = STATE(2515),
    [sym_block_comment] = STATE(2515),
    [sym_line_comment] = STATE(2515),
    [sym_compiler_directive_decl] = STATE(2515),
    [sym_fsi_directive_decl] = STATE(2515),
    [sym_preproc_line] = STATE(2515),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_AT_AT_GT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2516] = {
    [sym_xml_doc] = STATE(2516),
    [sym_block_comment] = STATE(2516),
    [sym_line_comment] = STATE(2516),
    [sym_compiler_directive_decl] = STATE(2516),
    [sym_fsi_directive_decl] = STATE(2516),
    [sym_preproc_line] = STATE(2516),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_AT_GT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2517] = {
    [sym_xml_doc] = STATE(2517),
    [sym_block_comment] = STATE(2517),
    [sym_line_comment] = STATE(2517),
    [sym_compiler_directive_decl] = STATE(2517),
    [sym_fsi_directive_decl] = STATE(2517),
    [sym_preproc_line] = STATE(2517),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_AT_GT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2518] = {
    [sym_xml_doc] = STATE(2518),
    [sym_block_comment] = STATE(2518),
    [sym_line_comment] = STATE(2518),
    [sym_compiler_directive_decl] = STATE(2518),
    [sym_fsi_directive_decl] = STATE(2518),
    [sym_preproc_line] = STATE(2518),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_AT_GT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2519] = {
    [sym_xml_doc] = STATE(2519),
    [sym_block_comment] = STATE(2519),
    [sym_line_comment] = STATE(2519),
    [sym_compiler_directive_decl] = STATE(2519),
    [sym_fsi_directive_decl] = STATE(2519),
    [sym_preproc_line] = STATE(2519),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_AT_GT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2520] = {
    [sym_xml_doc] = STATE(2520),
    [sym_block_comment] = STATE(2520),
    [sym_line_comment] = STATE(2520),
    [sym_compiler_directive_decl] = STATE(2520),
    [sym_fsi_directive_decl] = STATE(2520),
    [sym_preproc_line] = STATE(2520),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_AT_GT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2521] = {
    [sym_xml_doc] = STATE(2521),
    [sym_block_comment] = STATE(2521),
    [sym_line_comment] = STATE(2521),
    [sym_compiler_directive_decl] = STATE(2521),
    [sym_fsi_directive_decl] = STATE(2521),
    [sym_preproc_line] = STATE(2521),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_DOT_DOT] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2522] = {
    [sym_xml_doc] = STATE(2522),
    [sym_block_comment] = STATE(2522),
    [sym_line_comment] = STATE(2522),
    [sym_compiler_directive_decl] = STATE(2522),
    [sym_fsi_directive_decl] = STATE(2522),
    [sym_preproc_line] = STATE(2522),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_AT_AT_GT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2523] = {
    [sym_xml_doc] = STATE(2523),
    [sym_block_comment] = STATE(2523),
    [sym_line_comment] = STATE(2523),
    [sym_compiler_directive_decl] = STATE(2523),
    [sym_fsi_directive_decl] = STATE(2523),
    [sym_preproc_line] = STATE(2523),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_AT_AT_GT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2524] = {
    [sym_xml_doc] = STATE(2524),
    [sym_block_comment] = STATE(2524),
    [sym_line_comment] = STATE(2524),
    [sym_compiler_directive_decl] = STATE(2524),
    [sym_fsi_directive_decl] = STATE(2524),
    [sym_preproc_line] = STATE(2524),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_AT_AT_GT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2525] = {
    [sym_xml_doc] = STATE(2525),
    [sym_block_comment] = STATE(2525),
    [sym_line_comment] = STATE(2525),
    [sym_compiler_directive_decl] = STATE(2525),
    [sym_fsi_directive_decl] = STATE(2525),
    [sym_preproc_line] = STATE(2525),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_DOT_DOT] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2526] = {
    [sym_xml_doc] = STATE(2526),
    [sym_block_comment] = STATE(2526),
    [sym_line_comment] = STATE(2526),
    [sym_compiler_directive_decl] = STATE(2526),
    [sym_fsi_directive_decl] = STATE(2526),
    [sym_preproc_line] = STATE(2526),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_DOT_DOT] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2527] = {
    [sym_xml_doc] = STATE(2527),
    [sym_block_comment] = STATE(2527),
    [sym_line_comment] = STATE(2527),
    [sym_compiler_directive_decl] = STATE(2527),
    [sym_fsi_directive_decl] = STATE(2527),
    [sym_preproc_line] = STATE(2527),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [anon_sym_POUNDendif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2528] = {
    [sym_xml_doc] = STATE(2528),
    [sym_block_comment] = STATE(2528),
    [sym_line_comment] = STATE(2528),
    [sym_compiler_directive_decl] = STATE(2528),
    [sym_fsi_directive_decl] = STATE(2528),
    [sym_preproc_line] = STATE(2528),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_DOT_DOT] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2529] = {
    [sym_xml_doc] = STATE(2529),
    [sym_block_comment] = STATE(2529),
    [sym_line_comment] = STATE(2529),
    [sym_compiler_directive_decl] = STATE(2529),
    [sym_fsi_directive_decl] = STATE(2529),
    [sym_preproc_line] = STATE(2529),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_DOT_DOT] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2530] = {
    [sym_xml_doc] = STATE(2530),
    [sym_block_comment] = STATE(2530),
    [sym_line_comment] = STATE(2530),
    [sym_compiler_directive_decl] = STATE(2530),
    [sym_fsi_directive_decl] = STATE(2530),
    [sym_preproc_line] = STATE(2530),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_AT_GT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2531] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2531),
    [sym_block_comment] = STATE(2531),
    [sym_line_comment] = STATE(2531),
    [sym_compiler_directive_decl] = STATE(2531),
    [sym_fsi_directive_decl] = STATE(2531),
    [sym_preproc_line] = STATE(2531),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(3024),
    [anon_sym_open] = ACTIONS(3024),
    [anon_sym_LBRACK_LT] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_type] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_and] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [aux_sym_access_modifier_token1] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_member] = ACTIONS(3024),
    [anon_sym_interface] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_override] = ACTIONS(3024),
    [anon_sym_val] = ACTIONS(3024),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3022),
    [anon_sym_DASH_DOT] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3022),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3022),
    [anon_sym_POUNDload] = ACTIONS(3022),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__dedent] = ACTIONS(3022),
  },
  [2532] = {
    [sym_xml_doc] = STATE(2532),
    [sym_block_comment] = STATE(2532),
    [sym_line_comment] = STATE(2532),
    [sym_compiler_directive_decl] = STATE(2532),
    [sym_fsi_directive_decl] = STATE(2532),
    [sym_preproc_line] = STATE(2532),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_AT_GT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2533] = {
    [sym_xml_doc] = STATE(2533),
    [sym_block_comment] = STATE(2533),
    [sym_line_comment] = STATE(2533),
    [sym_compiler_directive_decl] = STATE(2533),
    [sym_fsi_directive_decl] = STATE(2533),
    [sym_preproc_line] = STATE(2533),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_AT_GT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2534] = {
    [sym_xml_doc] = STATE(2534),
    [sym_block_comment] = STATE(2534),
    [sym_line_comment] = STATE(2534),
    [sym_compiler_directive_decl] = STATE(2534),
    [sym_fsi_directive_decl] = STATE(2534),
    [sym_preproc_line] = STATE(2534),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_AT_GT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2535] = {
    [sym_xml_doc] = STATE(2535),
    [sym_block_comment] = STATE(2535),
    [sym_line_comment] = STATE(2535),
    [sym_compiler_directive_decl] = STATE(2535),
    [sym_fsi_directive_decl] = STATE(2535),
    [sym_preproc_line] = STATE(2535),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_AT_GT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2536] = {
    [sym_xml_doc] = STATE(2536),
    [sym_block_comment] = STATE(2536),
    [sym_line_comment] = STATE(2536),
    [sym_compiler_directive_decl] = STATE(2536),
    [sym_fsi_directive_decl] = STATE(2536),
    [sym_preproc_line] = STATE(2536),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_AT_GT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2537] = {
    [sym_xml_doc] = STATE(2537),
    [sym_block_comment] = STATE(2537),
    [sym_line_comment] = STATE(2537),
    [sym_compiler_directive_decl] = STATE(2537),
    [sym_fsi_directive_decl] = STATE(2537),
    [sym_preproc_line] = STATE(2537),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_AT_GT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2538] = {
    [sym_xml_doc] = STATE(2538),
    [sym_block_comment] = STATE(2538),
    [sym_line_comment] = STATE(2538),
    [sym_compiler_directive_decl] = STATE(2538),
    [sym_fsi_directive_decl] = STATE(2538),
    [sym_preproc_line] = STATE(2538),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_GT] = ACTIONS(3818),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2539] = {
    [sym_xml_doc] = STATE(2539),
    [sym_block_comment] = STATE(2539),
    [sym_line_comment] = STATE(2539),
    [sym_compiler_directive_decl] = STATE(2539),
    [sym_fsi_directive_decl] = STATE(2539),
    [sym_preproc_line] = STATE(2539),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_AT_AT_GT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2540] = {
    [sym_xml_doc] = STATE(2540),
    [sym_block_comment] = STATE(2540),
    [sym_line_comment] = STATE(2540),
    [sym_compiler_directive_decl] = STATE(2540),
    [sym_fsi_directive_decl] = STATE(2540),
    [sym_preproc_line] = STATE(2540),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [anon_sym_POUNDendif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2541] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4086),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(2541),
    [sym_block_comment] = STATE(2541),
    [sym_line_comment] = STATE(2541),
    [sym_compiler_directive_decl] = STATE(2541),
    [sym_fsi_directive_decl] = STATE(2541),
    [sym_preproc_line] = STATE(2541),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4764),
    [anon_sym__] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4762),
    [anon_sym_LBRACE] = ACTIONS(4762),
    [aux_sym_char_token1] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4764),
    [anon_sym_DQUOTE] = ACTIONS(4764),
    [anon_sym_AT_DQUOTE] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [sym_bool] = ACTIONS(4764),
    [sym_unit] = ACTIONS(4762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4764),
    [sym_xint] = ACTIONS(4762),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2542] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(6748),
    [sym_function_declaration_left] = STATE(7085),
    [sym_value_declaration_left] = STATE(7085),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2542),
    [sym_block_comment] = STATE(2542),
    [sym_line_comment] = STATE(2542),
    [sym_compiler_directive_decl] = STATE(2542),
    [sym_fsi_directive_decl] = STATE(2542),
    [sym_preproc_line] = STATE(2542),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4977),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2543] = {
    [sym_xml_doc] = STATE(2543),
    [sym_block_comment] = STATE(2543),
    [sym_line_comment] = STATE(2543),
    [sym_compiler_directive_decl] = STATE(2543),
    [sym_fsi_directive_decl] = STATE(2543),
    [sym_preproc_line] = STATE(2543),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_GT] = ACTIONS(3863),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2544] = {
    [sym_xml_doc] = STATE(2544),
    [sym_block_comment] = STATE(2544),
    [sym_line_comment] = STATE(2544),
    [sym_compiler_directive_decl] = STATE(2544),
    [sym_fsi_directive_decl] = STATE(2544),
    [sym_preproc_line] = STATE(2544),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [anon_sym_POUNDendif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2545] = {
    [sym_xml_doc] = STATE(2545),
    [sym_block_comment] = STATE(2545),
    [sym_line_comment] = STATE(2545),
    [sym_compiler_directive_decl] = STATE(2545),
    [sym_fsi_directive_decl] = STATE(2545),
    [sym_preproc_line] = STATE(2545),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_AT_GT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2546] = {
    [sym_xml_doc] = STATE(2546),
    [sym_block_comment] = STATE(2546),
    [sym_line_comment] = STATE(2546),
    [sym_compiler_directive_decl] = STATE(2546),
    [sym_fsi_directive_decl] = STATE(2546),
    [sym_preproc_line] = STATE(2546),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_AT_AT_GT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2547] = {
    [sym_xml_doc] = STATE(2547),
    [sym_block_comment] = STATE(2547),
    [sym_line_comment] = STATE(2547),
    [sym_compiler_directive_decl] = STATE(2547),
    [sym_fsi_directive_decl] = STATE(2547),
    [sym_preproc_line] = STATE(2547),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_AT_AT_GT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2548] = {
    [sym_xml_doc] = STATE(2548),
    [sym_block_comment] = STATE(2548),
    [sym_line_comment] = STATE(2548),
    [sym_compiler_directive_decl] = STATE(2548),
    [sym_fsi_directive_decl] = STATE(2548),
    [sym_preproc_line] = STATE(2548),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_GT] = ACTIONS(3705),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2549] = {
    [sym_xml_doc] = STATE(2549),
    [sym_block_comment] = STATE(2549),
    [sym_line_comment] = STATE(2549),
    [sym_compiler_directive_decl] = STATE(2549),
    [sym_fsi_directive_decl] = STATE(2549),
    [sym_preproc_line] = STATE(2549),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_AT_AT_GT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2550] = {
    [sym_xml_doc] = STATE(2550),
    [sym_block_comment] = STATE(2550),
    [sym_line_comment] = STATE(2550),
    [sym_compiler_directive_decl] = STATE(2550),
    [sym_fsi_directive_decl] = STATE(2550),
    [sym_preproc_line] = STATE(2550),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_DOT_DOT] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2551] = {
    [sym_xml_doc] = STATE(2551),
    [sym_block_comment] = STATE(2551),
    [sym_line_comment] = STATE(2551),
    [sym_compiler_directive_decl] = STATE(2551),
    [sym_fsi_directive_decl] = STATE(2551),
    [sym_preproc_line] = STATE(2551),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_AT_AT_GT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2552] = {
    [sym_xml_doc] = STATE(2552),
    [sym_block_comment] = STATE(2552),
    [sym_line_comment] = STATE(2552),
    [sym_compiler_directive_decl] = STATE(2552),
    [sym_fsi_directive_decl] = STATE(2552),
    [sym_preproc_line] = STATE(2552),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_AT_GT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2553] = {
    [sym_xml_doc] = STATE(2553),
    [sym_block_comment] = STATE(2553),
    [sym_line_comment] = STATE(2553),
    [sym_compiler_directive_decl] = STATE(2553),
    [sym_fsi_directive_decl] = STATE(2553),
    [sym_preproc_line] = STATE(2553),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [anon_sym_POUNDendif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2554] = {
    [sym_xml_doc] = STATE(2554),
    [sym_block_comment] = STATE(2554),
    [sym_line_comment] = STATE(2554),
    [sym_compiler_directive_decl] = STATE(2554),
    [sym_fsi_directive_decl] = STATE(2554),
    [sym_preproc_line] = STATE(2554),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_DOT_DOT] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2555] = {
    [sym_xml_doc] = STATE(2555),
    [sym_block_comment] = STATE(2555),
    [sym_line_comment] = STATE(2555),
    [sym_compiler_directive_decl] = STATE(2555),
    [sym_fsi_directive_decl] = STATE(2555),
    [sym_preproc_line] = STATE(2555),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_AT_GT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2556] = {
    [sym_xml_doc] = STATE(2556),
    [sym_block_comment] = STATE(2556),
    [sym_line_comment] = STATE(2556),
    [sym_compiler_directive_decl] = STATE(2556),
    [sym_fsi_directive_decl] = STATE(2556),
    [sym_preproc_line] = STATE(2556),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_EQ] = ACTIONS(3842),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_QMARK] = ACTIONS(3840),
    [anon_sym_COLON_COLON] = ACTIONS(3842),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3840),
    [anon_sym_DOT] = ACTIONS(3840),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_COLON_GT] = ACTIONS(3842),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3842),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_LT_DASH] = ACTIONS(3840),
    [anon_sym_DOT_LBRACK] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3842),
    [anon_sym_GT] = ACTIONS(3840),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [anon_sym_LPAREN2] = ACTIONS(3842),
    [anon_sym_or] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3840),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3840),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3840),
    [anon_sym_DASH_DOT] = ACTIONS(3840),
    [anon_sym_PERCENT] = ACTIONS(3840),
    [anon_sym_AMP_AMP] = ACTIONS(3840),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3840),
    [aux_sym_infix_op_token1] = ACTIONS(3840),
    [anon_sym_PIPE_PIPE] = ACTIONS(3840),
    [anon_sym_BANG_EQ] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOLLAR] = ACTIONS(3840),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3840),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
    [sym__newline] = ACTIONS(3842),
  },
  [2557] = {
    [sym_xml_doc] = STATE(2557),
    [sym_block_comment] = STATE(2557),
    [sym_line_comment] = STATE(2557),
    [sym_compiler_directive_decl] = STATE(2557),
    [sym_fsi_directive_decl] = STATE(2557),
    [sym_preproc_line] = STATE(2557),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_QMARK] = ACTIONS(2768),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2768),
    [anon_sym_DOT] = ACTIONS(2768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_COLON_GT] = ACTIONS(2770),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_LT_DASH] = ACTIONS(2768),
    [anon_sym_DOT_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_GT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2768),
    [anon_sym_DASH_DOT] = ACTIONS(2768),
    [anon_sym_PERCENT] = ACTIONS(2768),
    [anon_sym_AMP_AMP] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [anon_sym_PIPE_PIPE] = ACTIONS(2768),
    [anon_sym_BANG_EQ] = ACTIONS(2768),
    [anon_sym_COLON_EQ] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2768),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2768),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
    [sym__newline] = ACTIONS(2770),
  },
  [2558] = {
    [sym_xml_doc] = STATE(2558),
    [sym_block_comment] = STATE(2558),
    [sym_line_comment] = STATE(2558),
    [sym_compiler_directive_decl] = STATE(2558),
    [sym_fsi_directive_decl] = STATE(2558),
    [sym_preproc_line] = STATE(2558),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_DOT_DOT] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2559] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(4809),
    [sym__function_or_value_defn_body] = STATE(4581),
    [sym_function_declaration_left] = STATE(6935),
    [sym_value_declaration_left] = STATE(6935),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2559),
    [sym_block_comment] = STATE(2559),
    [sym_line_comment] = STATE(2559),
    [sym_compiler_directive_decl] = STATE(2559),
    [sym_fsi_directive_decl] = STATE(2559),
    [sym_preproc_line] = STATE(2559),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2560] = {
    [sym_xml_doc] = STATE(2560),
    [sym_block_comment] = STATE(2560),
    [sym_line_comment] = STATE(2560),
    [sym_compiler_directive_decl] = STATE(2560),
    [sym_fsi_directive_decl] = STATE(2560),
    [sym_preproc_line] = STATE(2560),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_DOT_DOT] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2561] = {
    [sym_xml_doc] = STATE(2561),
    [sym_block_comment] = STATE(2561),
    [sym_line_comment] = STATE(2561),
    [sym_compiler_directive_decl] = STATE(2561),
    [sym_fsi_directive_decl] = STATE(2561),
    [sym_preproc_line] = STATE(2561),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_AT_AT_GT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2562] = {
    [sym_xml_doc] = STATE(2562),
    [sym_block_comment] = STATE(2562),
    [sym_line_comment] = STATE(2562),
    [sym_compiler_directive_decl] = STATE(2562),
    [sym_fsi_directive_decl] = STATE(2562),
    [sym_preproc_line] = STATE(2562),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [anon_sym_POUNDendif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2563] = {
    [sym_xml_doc] = STATE(2563),
    [sym_block_comment] = STATE(2563),
    [sym_line_comment] = STATE(2563),
    [sym_compiler_directive_decl] = STATE(2563),
    [sym_fsi_directive_decl] = STATE(2563),
    [sym_preproc_line] = STATE(2563),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_AT_AT_GT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2564] = {
    [sym_xml_doc] = STATE(2564),
    [sym_block_comment] = STATE(2564),
    [sym_line_comment] = STATE(2564),
    [sym_compiler_directive_decl] = STATE(2564),
    [sym_fsi_directive_decl] = STATE(2564),
    [sym_preproc_line] = STATE(2564),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_AT_AT_GT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2565] = {
    [sym_xml_doc] = STATE(2565),
    [sym_block_comment] = STATE(2565),
    [sym_line_comment] = STATE(2565),
    [sym_compiler_directive_decl] = STATE(2565),
    [sym_fsi_directive_decl] = STATE(2565),
    [sym_preproc_line] = STATE(2565),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(3838),
    [anon_sym_COLON] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_QMARK] = ACTIONS(3836),
    [anon_sym_COLON_COLON] = ACTIONS(3838),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3836),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_COLON_GT] = ACTIONS(3838),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3838),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_LT_DASH] = ACTIONS(3836),
    [anon_sym_DOT_LBRACK] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3838),
    [anon_sym_GT] = ACTIONS(3836),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [anon_sym_LPAREN2] = ACTIONS(3838),
    [anon_sym_or] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3836),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3836),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3836),
    [anon_sym_DASH_DOT] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3836),
    [aux_sym_infix_op_token1] = ACTIONS(3836),
    [anon_sym_PIPE_PIPE] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_COLON_EQ] = ACTIONS(3838),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3836),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
    [sym__newline] = ACTIONS(3838),
  },
  [2566] = {
    [sym_xml_doc] = STATE(2566),
    [sym_block_comment] = STATE(2566),
    [sym_line_comment] = STATE(2566),
    [sym_compiler_directive_decl] = STATE(2566),
    [sym_fsi_directive_decl] = STATE(2566),
    [sym_preproc_line] = STATE(2566),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2567] = {
    [sym_xml_doc] = STATE(2567),
    [sym_block_comment] = STATE(2567),
    [sym_line_comment] = STATE(2567),
    [sym_compiler_directive_decl] = STATE(2567),
    [sym_fsi_directive_decl] = STATE(2567),
    [sym_preproc_line] = STATE(2567),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_GT] = ACTIONS(3878),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2568] = {
    [sym_xml_doc] = STATE(2568),
    [sym_block_comment] = STATE(2568),
    [sym_line_comment] = STATE(2568),
    [sym_compiler_directive_decl] = STATE(2568),
    [sym_fsi_directive_decl] = STATE(2568),
    [sym_preproc_line] = STATE(2568),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_AT_AT_GT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2569] = {
    [sym_xml_doc] = STATE(2569),
    [sym_block_comment] = STATE(2569),
    [sym_line_comment] = STATE(2569),
    [sym_compiler_directive_decl] = STATE(2569),
    [sym_fsi_directive_decl] = STATE(2569),
    [sym_preproc_line] = STATE(2569),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [anon_sym_POUNDendif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2570] = {
    [sym_xml_doc] = STATE(2570),
    [sym_block_comment] = STATE(2570),
    [sym_line_comment] = STATE(2570),
    [sym_compiler_directive_decl] = STATE(2570),
    [sym_fsi_directive_decl] = STATE(2570),
    [sym_preproc_line] = STATE(2570),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_QMARK] = ACTIONS(3825),
    [anon_sym_COLON_COLON] = ACTIONS(3827),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_COLON_GT] = ACTIONS(3827),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_LT_DASH] = ACTIONS(3825),
    [anon_sym_DOT_LBRACK] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3825),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [anon_sym_LPAREN2] = ACTIONS(3827),
    [anon_sym_or] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3825),
    [anon_sym_DASH_DOT] = ACTIONS(3825),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_AMP_AMP] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3825),
    [aux_sym_infix_op_token1] = ACTIONS(3825),
    [anon_sym_PIPE_PIPE] = ACTIONS(3825),
    [anon_sym_BANG_EQ] = ACTIONS(3825),
    [anon_sym_COLON_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(3825),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3825),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
    [sym__newline] = ACTIONS(3827),
  },
  [2571] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7391),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2571),
    [sym_block_comment] = STATE(2571),
    [sym_line_comment] = STATE(2571),
    [sym_compiler_directive_decl] = STATE(2571),
    [sym_fsi_directive_decl] = STATE(2571),
    [sym_preproc_line] = STATE(2571),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2572] = {
    [sym_xml_doc] = STATE(2572),
    [sym_block_comment] = STATE(2572),
    [sym_line_comment] = STATE(2572),
    [sym_compiler_directive_decl] = STATE(2572),
    [sym_fsi_directive_decl] = STATE(2572),
    [sym_preproc_line] = STATE(2572),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [anon_sym_POUNDendif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2573] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5795),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2573),
    [sym_block_comment] = STATE(2573),
    [sym_line_comment] = STATE(2573),
    [sym_compiler_directive_decl] = STATE(2573),
    [sym_fsi_directive_decl] = STATE(2573),
    [sym_preproc_line] = STATE(2573),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [anon_sym_in] = ACTIONS(4764),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2574] = {
    [sym_xml_doc] = STATE(2574),
    [sym_block_comment] = STATE(2574),
    [sym_line_comment] = STATE(2574),
    [sym_compiler_directive_decl] = STATE(2574),
    [sym_fsi_directive_decl] = STATE(2574),
    [sym_preproc_line] = STATE(2574),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [anon_sym_POUNDendif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2575] = {
    [sym_xml_doc] = STATE(2575),
    [sym_block_comment] = STATE(2575),
    [sym_line_comment] = STATE(2575),
    [sym_compiler_directive_decl] = STATE(2575),
    [sym_fsi_directive_decl] = STATE(2575),
    [sym_preproc_line] = STATE(2575),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_AT_GT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2576] = {
    [sym_xml_doc] = STATE(2576),
    [sym_block_comment] = STATE(2576),
    [sym_line_comment] = STATE(2576),
    [sym_compiler_directive_decl] = STATE(2576),
    [sym_fsi_directive_decl] = STATE(2576),
    [sym_preproc_line] = STATE(2576),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_AT_GT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2577] = {
    [sym_xml_doc] = STATE(2577),
    [sym_block_comment] = STATE(2577),
    [sym_line_comment] = STATE(2577),
    [sym_compiler_directive_decl] = STATE(2577),
    [sym_fsi_directive_decl] = STATE(2577),
    [sym_preproc_line] = STATE(2577),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [anon_sym_POUNDendif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2578] = {
    [sym_xml_doc] = STATE(2578),
    [sym_block_comment] = STATE(2578),
    [sym_line_comment] = STATE(2578),
    [sym_compiler_directive_decl] = STATE(2578),
    [sym_fsi_directive_decl] = STATE(2578),
    [sym_preproc_line] = STATE(2578),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_AT_GT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2579] = {
    [sym_xml_doc] = STATE(2579),
    [sym_block_comment] = STATE(2579),
    [sym_line_comment] = STATE(2579),
    [sym_compiler_directive_decl] = STATE(2579),
    [sym_fsi_directive_decl] = STATE(2579),
    [sym_preproc_line] = STATE(2579),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_AT_AT_GT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2580] = {
    [sym_xml_doc] = STATE(2580),
    [sym_block_comment] = STATE(2580),
    [sym_line_comment] = STATE(2580),
    [sym_compiler_directive_decl] = STATE(2580),
    [sym_fsi_directive_decl] = STATE(2580),
    [sym_preproc_line] = STATE(2580),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [anon_sym_POUNDendif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2581] = {
    [sym_xml_doc] = STATE(2581),
    [sym_block_comment] = STATE(2581),
    [sym_line_comment] = STATE(2581),
    [sym_compiler_directive_decl] = STATE(2581),
    [sym_fsi_directive_decl] = STATE(2581),
    [sym_preproc_line] = STATE(2581),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_AT_AT_GT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2582] = {
    [sym_xml_doc] = STATE(2582),
    [sym_block_comment] = STATE(2582),
    [sym_line_comment] = STATE(2582),
    [sym_compiler_directive_decl] = STATE(2582),
    [sym_fsi_directive_decl] = STATE(2582),
    [sym_preproc_line] = STATE(2582),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [anon_sym_POUNDendif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2583] = {
    [sym_xml_doc] = STATE(2583),
    [sym_block_comment] = STATE(2583),
    [sym_line_comment] = STATE(2583),
    [sym_compiler_directive_decl] = STATE(2583),
    [sym_fsi_directive_decl] = STATE(2583),
    [sym_preproc_line] = STATE(2583),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_DOT_DOT] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2584] = {
    [sym_xml_doc] = STATE(2584),
    [sym_block_comment] = STATE(2584),
    [sym_line_comment] = STATE(2584),
    [sym_compiler_directive_decl] = STATE(2584),
    [sym_fsi_directive_decl] = STATE(2584),
    [sym_preproc_line] = STATE(2584),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_DOT_DOT] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2585] = {
    [sym_xml_doc] = STATE(2585),
    [sym_block_comment] = STATE(2585),
    [sym_line_comment] = STATE(2585),
    [sym_compiler_directive_decl] = STATE(2585),
    [sym_fsi_directive_decl] = STATE(2585),
    [sym_preproc_line] = STATE(2585),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_AT_AT_GT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2586] = {
    [sym_xml_doc] = STATE(2586),
    [sym_block_comment] = STATE(2586),
    [sym_line_comment] = STATE(2586),
    [sym_compiler_directive_decl] = STATE(2586),
    [sym_fsi_directive_decl] = STATE(2586),
    [sym_preproc_line] = STATE(2586),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_AT_AT_GT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2587] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7465),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2587),
    [sym_block_comment] = STATE(2587),
    [sym_line_comment] = STATE(2587),
    [sym_compiler_directive_decl] = STATE(2587),
    [sym_fsi_directive_decl] = STATE(2587),
    [sym_preproc_line] = STATE(2587),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2588] = {
    [sym_xml_doc] = STATE(2588),
    [sym_block_comment] = STATE(2588),
    [sym_line_comment] = STATE(2588),
    [sym_compiler_directive_decl] = STATE(2588),
    [sym_fsi_directive_decl] = STATE(2588),
    [sym_preproc_line] = STATE(2588),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_QMARK] = ACTIONS(3802),
    [anon_sym_COLON_COLON] = ACTIONS(3804),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3802),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_COLON_GT] = ACTIONS(3804),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_LT_DASH] = ACTIONS(3802),
    [anon_sym_DOT_LBRACK] = ACTIONS(3804),
    [anon_sym_LT] = ACTIONS(3804),
    [anon_sym_GT] = ACTIONS(3802),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3804),
    [anon_sym_or] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3802),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3802),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3802),
    [anon_sym_DASH_DOT] = ACTIONS(3802),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3802),
    [aux_sym_infix_op_token1] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_COLON_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(3802),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3802),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
    [sym__newline] = ACTIONS(3804),
  },
  [2589] = {
    [sym_xml_doc] = STATE(2589),
    [sym_block_comment] = STATE(2589),
    [sym_line_comment] = STATE(2589),
    [sym_compiler_directive_decl] = STATE(2589),
    [sym_fsi_directive_decl] = STATE(2589),
    [sym_preproc_line] = STATE(2589),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_DOT_DOT] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2590] = {
    [sym_xml_doc] = STATE(2590),
    [sym_block_comment] = STATE(2590),
    [sym_line_comment] = STATE(2590),
    [sym_compiler_directive_decl] = STATE(2590),
    [sym_fsi_directive_decl] = STATE(2590),
    [sym_preproc_line] = STATE(2590),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_AT_GT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2591] = {
    [sym_xml_doc] = STATE(2591),
    [sym_block_comment] = STATE(2591),
    [sym_line_comment] = STATE(2591),
    [sym_compiler_directive_decl] = STATE(2591),
    [sym_fsi_directive_decl] = STATE(2591),
    [sym_preproc_line] = STATE(2591),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_DOT_DOT] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2592] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2592),
    [sym_block_comment] = STATE(2592),
    [sym_line_comment] = STATE(2592),
    [sym_compiler_directive_decl] = STATE(2592),
    [sym_fsi_directive_decl] = STATE(2592),
    [sym_preproc_line] = STATE(2592),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(4979),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(4981),
    [anon_sym_module] = ACTIONS(4981),
    [anon_sym_open] = ACTIONS(4981),
    [anon_sym_LBRACK_LT] = ACTIONS(4979),
    [anon_sym_return] = ACTIONS(4981),
    [anon_sym_type] = ACTIONS(4981),
    [anon_sym_do] = ACTIONS(4981),
    [anon_sym_and] = ACTIONS(4981),
    [anon_sym_let] = ACTIONS(4981),
    [anon_sym_let_BANG] = ACTIONS(4979),
    [aux_sym_access_modifier_token1] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4981),
    [anon_sym_null] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4981),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4979),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_LT_AT] = ACTIONS(4981),
    [anon_sym_LT_AT_AT] = ACTIONS(4979),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4979),
    [anon_sym_with] = ACTIONS(4981),
    [anon_sym_new] = ACTIONS(4981),
    [anon_sym_return_BANG] = ACTIONS(4979),
    [anon_sym_yield] = ACTIONS(4981),
    [anon_sym_yield_BANG] = ACTIONS(4979),
    [anon_sym_lazy] = ACTIONS(4981),
    [anon_sym_assert] = ACTIONS(4981),
    [anon_sym_upcast] = ACTIONS(4981),
    [anon_sym_downcast] = ACTIONS(4981),
    [anon_sym_for] = ACTIONS(4981),
    [anon_sym_while] = ACTIONS(4981),
    [anon_sym_if] = ACTIONS(4981),
    [anon_sym_fun] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [anon_sym_try] = ACTIONS(4981),
    [anon_sym_match] = ACTIONS(4981),
    [anon_sym_match_BANG] = ACTIONS(4979),
    [anon_sym_function] = ACTIONS(4981),
    [anon_sym_use] = ACTIONS(4981),
    [anon_sym_use_BANG] = ACTIONS(4979),
    [anon_sym_do_BANG] = ACTIONS(4979),
    [anon_sym_begin] = ACTIONS(4981),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(4981),
    [anon_sym_static] = ACTIONS(4981),
    [anon_sym_member] = ACTIONS(4981),
    [anon_sym_abstract] = ACTIONS(4981),
    [anon_sym_override] = ACTIONS(4981),
    [anon_sym_val] = ACTIONS(4981),
    [aux_sym_char_token1] = ACTIONS(4979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4981),
    [anon_sym_DQUOTE] = ACTIONS(4981),
    [anon_sym_AT_DQUOTE] = ACTIONS(4979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4979),
    [sym_bool] = ACTIONS(4981),
    [sym_unit] = ACTIONS(4979),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4981),
    [sym_op_identifier] = ACTIONS(4979),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_DOT] = ACTIONS(4979),
    [anon_sym_DASH_DOT] = ACTIONS(4979),
    [anon_sym_PERCENT] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4979),
    [anon_sym_TILDE] = ACTIONS(4979),
    [aux_sym_prefix_op_token1] = ACTIONS(4979),
    [sym_int] = ACTIONS(4981),
    [sym_xint] = ACTIONS(4979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4979),
    [anon_sym_POUNDload] = ACTIONS(4979),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4979),
  },
  [2593] = {
    [sym_xml_doc] = STATE(2593),
    [sym_block_comment] = STATE(2593),
    [sym_line_comment] = STATE(2593),
    [sym_compiler_directive_decl] = STATE(2593),
    [sym_fsi_directive_decl] = STATE(2593),
    [sym_preproc_line] = STATE(2593),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_AT_AT_GT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2594] = {
    [sym_xml_doc] = STATE(2594),
    [sym_block_comment] = STATE(2594),
    [sym_line_comment] = STATE(2594),
    [sym_compiler_directive_decl] = STATE(2594),
    [sym_fsi_directive_decl] = STATE(2594),
    [sym_preproc_line] = STATE(2594),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_AT_GT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2595] = {
    [sym_xml_doc] = STATE(2595),
    [sym_block_comment] = STATE(2595),
    [sym_line_comment] = STATE(2595),
    [sym_compiler_directive_decl] = STATE(2595),
    [sym_fsi_directive_decl] = STATE(2595),
    [sym_preproc_line] = STATE(2595),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_DOT_DOT] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2596] = {
    [sym_xml_doc] = STATE(2596),
    [sym_block_comment] = STATE(2596),
    [sym_line_comment] = STATE(2596),
    [sym_compiler_directive_decl] = STATE(2596),
    [sym_fsi_directive_decl] = STATE(2596),
    [sym_preproc_line] = STATE(2596),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_AT_GT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2597] = {
    [sym_xml_doc] = STATE(2597),
    [sym_block_comment] = STATE(2597),
    [sym_line_comment] = STATE(2597),
    [sym_compiler_directive_decl] = STATE(2597),
    [sym_fsi_directive_decl] = STATE(2597),
    [sym_preproc_line] = STATE(2597),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_AT_AT_GT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2598] = {
    [sym_xml_doc] = STATE(2598),
    [sym_block_comment] = STATE(2598),
    [sym_line_comment] = STATE(2598),
    [sym_compiler_directive_decl] = STATE(2598),
    [sym_fsi_directive_decl] = STATE(2598),
    [sym_preproc_line] = STATE(2598),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_AT_AT_GT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2599] = {
    [sym_xml_doc] = STATE(2599),
    [sym_block_comment] = STATE(2599),
    [sym_line_comment] = STATE(2599),
    [sym_compiler_directive_decl] = STATE(2599),
    [sym_fsi_directive_decl] = STATE(2599),
    [sym_preproc_line] = STATE(2599),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_AT_GT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2600] = {
    [sym_xml_doc] = STATE(2600),
    [sym_block_comment] = STATE(2600),
    [sym_line_comment] = STATE(2600),
    [sym_compiler_directive_decl] = STATE(2600),
    [sym_fsi_directive_decl] = STATE(2600),
    [sym_preproc_line] = STATE(2600),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_GT] = ACTIONS(3884),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2601] = {
    [sym_xml_doc] = STATE(2601),
    [sym_block_comment] = STATE(2601),
    [sym_line_comment] = STATE(2601),
    [sym_compiler_directive_decl] = STATE(2601),
    [sym_fsi_directive_decl] = STATE(2601),
    [sym_preproc_line] = STATE(2601),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_AT_AT_GT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2602] = {
    [sym_xml_doc] = STATE(2602),
    [sym_block_comment] = STATE(2602),
    [sym_line_comment] = STATE(2602),
    [sym_compiler_directive_decl] = STATE(2602),
    [sym_fsi_directive_decl] = STATE(2602),
    [sym_preproc_line] = STATE(2602),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_AT_AT_GT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2603] = {
    [sym_xml_doc] = STATE(2603),
    [sym_block_comment] = STATE(2603),
    [sym_line_comment] = STATE(2603),
    [sym_compiler_directive_decl] = STATE(2603),
    [sym_fsi_directive_decl] = STATE(2603),
    [sym_preproc_line] = STATE(2603),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_AT_GT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2604] = {
    [sym_xml_doc] = STATE(2604),
    [sym_block_comment] = STATE(2604),
    [sym_line_comment] = STATE(2604),
    [sym_compiler_directive_decl] = STATE(2604),
    [sym_fsi_directive_decl] = STATE(2604),
    [sym_preproc_line] = STATE(2604),
    [aux_sym_long_identifier_repeat1] = STATE(2604),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_and] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [aux_sym_access_modifier_token1] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(4983),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_member] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_val] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [2605] = {
    [sym_xml_doc] = STATE(2605),
    [sym_block_comment] = STATE(2605),
    [sym_line_comment] = STATE(2605),
    [sym_compiler_directive_decl] = STATE(2605),
    [sym_fsi_directive_decl] = STATE(2605),
    [sym_preproc_line] = STATE(2605),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_GT] = ACTIONS(3888),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2606] = {
    [sym_xml_doc] = STATE(2606),
    [sym_block_comment] = STATE(2606),
    [sym_line_comment] = STATE(2606),
    [sym_compiler_directive_decl] = STATE(2606),
    [sym_fsi_directive_decl] = STATE(2606),
    [sym_preproc_line] = STATE(2606),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_EQ] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3798),
    [anon_sym_DOT] = ACTIONS(3798),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_COLON_GT] = ACTIONS(3800),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_LT_DASH] = ACTIONS(3798),
    [anon_sym_DOT_LBRACK] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3798),
    [anon_sym_DASH_DOT] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3798),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
    [sym__newline] = ACTIONS(3800),
  },
  [2607] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7752),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2607),
    [sym_block_comment] = STATE(2607),
    [sym_line_comment] = STATE(2607),
    [sym_compiler_directive_decl] = STATE(2607),
    [sym_fsi_directive_decl] = STATE(2607),
    [sym_preproc_line] = STATE(2607),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2608] = {
    [sym_xml_doc] = STATE(2608),
    [sym_block_comment] = STATE(2608),
    [sym_line_comment] = STATE(2608),
    [sym_compiler_directive_decl] = STATE(2608),
    [sym_fsi_directive_decl] = STATE(2608),
    [sym_preproc_line] = STATE(2608),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2609] = {
    [sym_xml_doc] = STATE(2609),
    [sym_block_comment] = STATE(2609),
    [sym_line_comment] = STATE(2609),
    [sym_compiler_directive_decl] = STATE(2609),
    [sym_fsi_directive_decl] = STATE(2609),
    [sym_preproc_line] = STATE(2609),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_DOT_DOT] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2610] = {
    [sym_xml_doc] = STATE(2610),
    [sym_block_comment] = STATE(2610),
    [sym_line_comment] = STATE(2610),
    [sym_compiler_directive_decl] = STATE(2610),
    [sym_fsi_directive_decl] = STATE(2610),
    [sym_preproc_line] = STATE(2610),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [anon_sym_POUNDendif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2611] = {
    [sym_xml_doc] = STATE(2611),
    [sym_block_comment] = STATE(2611),
    [sym_line_comment] = STATE(2611),
    [sym_compiler_directive_decl] = STATE(2611),
    [sym_fsi_directive_decl] = STATE(2611),
    [sym_preproc_line] = STATE(2611),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [anon_sym_POUNDendif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2612] = {
    [sym_xml_doc] = STATE(2612),
    [sym_block_comment] = STATE(2612),
    [sym_line_comment] = STATE(2612),
    [sym_compiler_directive_decl] = STATE(2612),
    [sym_fsi_directive_decl] = STATE(2612),
    [sym_preproc_line] = STATE(2612),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [anon_sym_POUNDendif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2613] = {
    [sym_xml_doc] = STATE(2613),
    [sym_block_comment] = STATE(2613),
    [sym_line_comment] = STATE(2613),
    [sym_compiler_directive_decl] = STATE(2613),
    [sym_fsi_directive_decl] = STATE(2613),
    [sym_preproc_line] = STATE(2613),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [anon_sym_POUNDendif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2614] = {
    [sym_xml_doc] = STATE(2614),
    [sym_block_comment] = STATE(2614),
    [sym_line_comment] = STATE(2614),
    [sym_compiler_directive_decl] = STATE(2614),
    [sym_fsi_directive_decl] = STATE(2614),
    [sym_preproc_line] = STATE(2614),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [anon_sym_POUNDendif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2615] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3907),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2615),
    [sym_block_comment] = STATE(2615),
    [sym_line_comment] = STATE(2615),
    [sym_compiler_directive_decl] = STATE(2615),
    [sym_fsi_directive_decl] = STATE(2615),
    [sym_preproc_line] = STATE(2615),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4762),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4764),
    [anon_sym__] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4762),
    [anon_sym_COLON_QMARK] = ACTIONS(4762),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_SEMI] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4762),
    [anon_sym_LBRACE] = ACTIONS(4762),
    [aux_sym_char_token1] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4764),
    [anon_sym_DQUOTE] = ACTIONS(4764),
    [anon_sym_AT_DQUOTE] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [sym_bool] = ACTIONS(4764),
    [sym_unit] = ACTIONS(4762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4764),
    [sym_op_identifier] = ACTIONS(4762),
    [sym_int] = ACTIONS(4764),
    [sym_xint] = ACTIONS(4762),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2616] = {
    [sym_xml_doc] = STATE(2616),
    [sym_block_comment] = STATE(2616),
    [sym_line_comment] = STATE(2616),
    [sym_compiler_directive_decl] = STATE(2616),
    [sym_fsi_directive_decl] = STATE(2616),
    [sym_preproc_line] = STATE(2616),
    [aux_sym_long_identifier_repeat1] = STATE(2604),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_and] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [aux_sym_access_modifier_token1] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4986),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_default] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_member] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_val] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
  },
  [2617] = {
    [sym_xml_doc] = STATE(2617),
    [sym_block_comment] = STATE(2617),
    [sym_line_comment] = STATE(2617),
    [sym_compiler_directive_decl] = STATE(2617),
    [sym_fsi_directive_decl] = STATE(2617),
    [sym_preproc_line] = STATE(2617),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2618] = {
    [sym_xml_doc] = STATE(2618),
    [sym_block_comment] = STATE(2618),
    [sym_line_comment] = STATE(2618),
    [sym_compiler_directive_decl] = STATE(2618),
    [sym_fsi_directive_decl] = STATE(2618),
    [sym_preproc_line] = STATE(2618),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2619] = {
    [sym_xml_doc] = STATE(2619),
    [sym_block_comment] = STATE(2619),
    [sym_line_comment] = STATE(2619),
    [sym_compiler_directive_decl] = STATE(2619),
    [sym_fsi_directive_decl] = STATE(2619),
    [sym_preproc_line] = STATE(2619),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_COLON] = ACTIONS(3792),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3790),
    [anon_sym_DOT] = ACTIONS(3790),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_COLON_GT] = ACTIONS(3792),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_LT_DASH] = ACTIONS(3790),
    [anon_sym_DOT_LBRACK] = ACTIONS(3792),
    [anon_sym_LT] = ACTIONS(3792),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [anon_sym_LPAREN2] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3790),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3790),
    [anon_sym_DASH_DOT] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3790),
    [aux_sym_infix_op_token1] = ACTIONS(3790),
    [anon_sym_PIPE_PIPE] = ACTIONS(3790),
    [anon_sym_BANG_EQ] = ACTIONS(3790),
    [anon_sym_COLON_EQ] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3790),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
    [sym__newline] = ACTIONS(3792),
  },
  [2620] = {
    [sym_xml_doc] = STATE(2620),
    [sym_block_comment] = STATE(2620),
    [sym_line_comment] = STATE(2620),
    [sym_compiler_directive_decl] = STATE(2620),
    [sym_fsi_directive_decl] = STATE(2620),
    [sym_preproc_line] = STATE(2620),
    [aux_sym_long_identifier_repeat1] = STATE(2616),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_and] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [aux_sym_access_modifier_token1] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(4986),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_member] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_val] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [2621] = {
    [sym_xml_doc] = STATE(2621),
    [sym_block_comment] = STATE(2621),
    [sym_line_comment] = STATE(2621),
    [sym_compiler_directive_decl] = STATE(2621),
    [sym_fsi_directive_decl] = STATE(2621),
    [sym_preproc_line] = STATE(2621),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_DOT_DOT] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2622] = {
    [sym_xml_doc] = STATE(2622),
    [sym_block_comment] = STATE(2622),
    [sym_line_comment] = STATE(2622),
    [sym_compiler_directive_decl] = STATE(2622),
    [sym_fsi_directive_decl] = STATE(2622),
    [sym_preproc_line] = STATE(2622),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_DOT_DOT] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2623] = {
    [sym_xml_doc] = STATE(2623),
    [sym_block_comment] = STATE(2623),
    [sym_line_comment] = STATE(2623),
    [sym_compiler_directive_decl] = STATE(2623),
    [sym_fsi_directive_decl] = STATE(2623),
    [sym_preproc_line] = STATE(2623),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_DOT_DOT] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2624] = {
    [sym_xml_doc] = STATE(2624),
    [sym_block_comment] = STATE(2624),
    [sym_line_comment] = STATE(2624),
    [sym_compiler_directive_decl] = STATE(2624),
    [sym_fsi_directive_decl] = STATE(2624),
    [sym_preproc_line] = STATE(2624),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_GT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2625] = {
    [sym_xml_doc] = STATE(2625),
    [sym_block_comment] = STATE(2625),
    [sym_line_comment] = STATE(2625),
    [sym_compiler_directive_decl] = STATE(2625),
    [sym_fsi_directive_decl] = STATE(2625),
    [sym_preproc_line] = STATE(2625),
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_let_BANG] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_null] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_QMARK] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_LT_AT] = ACTIONS(3818),
    [anon_sym_LT_AT_AT] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_return_BANG] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_yield_BANG] = ACTIONS(3820),
    [anon_sym_lazy] = ACTIONS(3818),
    [anon_sym_assert] = ACTIONS(3818),
    [anon_sym_upcast] = ACTIONS(3818),
    [anon_sym_downcast] = ACTIONS(3818),
    [anon_sym_COLON_GT] = ACTIONS(3820),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_fun] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_match] = ACTIONS(3818),
    [anon_sym_match_BANG] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3818),
    [anon_sym_LT_DASH] = ACTIONS(3818),
    [anon_sym_DOT_LBRACK] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_use] = ACTIONS(3818),
    [anon_sym_use_BANG] = ACTIONS(3820),
    [anon_sym_do_BANG] = ACTIONS(3820),
    [anon_sym_begin] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_or] = ACTIONS(3818),
    [aux_sym_char_token1] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_AT_DQUOTE] = ACTIONS(3820),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3820),
    [sym_bool] = ACTIONS(3818),
    [sym_unit] = ACTIONS(3818),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3818),
    [sym_op_identifier] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_DOT] = ACTIONS(3818),
    [anon_sym_DASH_DOT] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3820),
    [aux_sym_prefix_op_token1] = ACTIONS(3818),
    [aux_sym_infix_op_token1] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3818),
    [anon_sym_COLON_EQ] = ACTIONS(3820),
    [anon_sym_DOLLAR] = ACTIONS(3818),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3818),
    [sym_int] = ACTIONS(3818),
    [sym_xint] = ACTIONS(3820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3820),
    [anon_sym_POUNDendif] = ACTIONS(3820),
    [sym__newline] = ACTIONS(3820),
  },
  [2626] = {
    [sym_xml_doc] = STATE(2626),
    [sym_block_comment] = STATE(2626),
    [sym_line_comment] = STATE(2626),
    [sym_compiler_directive_decl] = STATE(2626),
    [sym_fsi_directive_decl] = STATE(2626),
    [sym_preproc_line] = STATE(2626),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_QMARK] = ACTIONS(3285),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3285),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_COLON_GT] = ACTIONS(3287),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_LT_DASH] = ACTIONS(3285),
    [anon_sym_DOT_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_or] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3285),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3285),
    [anon_sym_DASH_DOT] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3285),
    [aux_sym_infix_op_token1] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_COLON_EQ] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3285),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3285),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [anon_sym_POUNDendif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [2627] = {
    [sym_xml_doc] = STATE(2627),
    [sym_block_comment] = STATE(2627),
    [sym_line_comment] = STATE(2627),
    [sym_compiler_directive_decl] = STATE(2627),
    [sym_fsi_directive_decl] = STATE(2627),
    [sym_preproc_line] = STATE(2627),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_AT_AT_GT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2628] = {
    [sym_xml_doc] = STATE(2628),
    [sym_block_comment] = STATE(2628),
    [sym_line_comment] = STATE(2628),
    [sym_compiler_directive_decl] = STATE(2628),
    [sym_fsi_directive_decl] = STATE(2628),
    [sym_preproc_line] = STATE(2628),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_AT_AT_GT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2629] = {
    [sym_xml_doc] = STATE(2629),
    [sym_block_comment] = STATE(2629),
    [sym_line_comment] = STATE(2629),
    [sym_compiler_directive_decl] = STATE(2629),
    [sym_fsi_directive_decl] = STATE(2629),
    [sym_preproc_line] = STATE(2629),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_AT_AT_GT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2630] = {
    [sym_xml_doc] = STATE(2630),
    [sym_block_comment] = STATE(2630),
    [sym_line_comment] = STATE(2630),
    [sym_compiler_directive_decl] = STATE(2630),
    [sym_fsi_directive_decl] = STATE(2630),
    [sym_preproc_line] = STATE(2630),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_QMARK] = ACTIONS(3786),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_COLON_GT] = ACTIONS(3788),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_LT_DASH] = ACTIONS(3786),
    [anon_sym_DOT_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [anon_sym_LPAREN2] = ACTIONS(3788),
    [anon_sym_or] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3786),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3786),
    [anon_sym_DASH_DOT] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3786),
    [aux_sym_infix_op_token1] = ACTIONS(3786),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_COLON_EQ] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3786),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3786),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
    [sym__newline] = ACTIONS(3788),
  },
  [2631] = {
    [sym_xml_doc] = STATE(2631),
    [sym_block_comment] = STATE(2631),
    [sym_line_comment] = STATE(2631),
    [sym_compiler_directive_decl] = STATE(2631),
    [sym_fsi_directive_decl] = STATE(2631),
    [sym_preproc_line] = STATE(2631),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_AT_AT_GT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2632] = {
    [sym_xml_doc] = STATE(2632),
    [sym_block_comment] = STATE(2632),
    [sym_line_comment] = STATE(2632),
    [sym_compiler_directive_decl] = STATE(2632),
    [sym_fsi_directive_decl] = STATE(2632),
    [sym_preproc_line] = STATE(2632),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_GT] = ACTIONS(3859),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2633] = {
    [sym_xml_doc] = STATE(2633),
    [sym_block_comment] = STATE(2633),
    [sym_line_comment] = STATE(2633),
    [sym_compiler_directive_decl] = STATE(2633),
    [sym_fsi_directive_decl] = STATE(2633),
    [sym_preproc_line] = STATE(2633),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_GT] = ACTIONS(3782),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2634] = {
    [sym_xml_doc] = STATE(2634),
    [sym_block_comment] = STATE(2634),
    [sym_line_comment] = STATE(2634),
    [sym_compiler_directive_decl] = STATE(2634),
    [sym_fsi_directive_decl] = STATE(2634),
    [sym_preproc_line] = STATE(2634),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_DOT_DOT] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2635] = {
    [sym_xml_doc] = STATE(2635),
    [sym_block_comment] = STATE(2635),
    [sym_line_comment] = STATE(2635),
    [sym_compiler_directive_decl] = STATE(2635),
    [sym_fsi_directive_decl] = STATE(2635),
    [sym_preproc_line] = STATE(2635),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_AT_AT_GT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2636] = {
    [sym_xml_doc] = STATE(2636),
    [sym_block_comment] = STATE(2636),
    [sym_line_comment] = STATE(2636),
    [sym_compiler_directive_decl] = STATE(2636),
    [sym_fsi_directive_decl] = STATE(2636),
    [sym_preproc_line] = STATE(2636),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_AT_AT_GT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2637] = {
    [sym_xml_doc] = STATE(2637),
    [sym_block_comment] = STATE(2637),
    [sym_line_comment] = STATE(2637),
    [sym_compiler_directive_decl] = STATE(2637),
    [sym_fsi_directive_decl] = STATE(2637),
    [sym_preproc_line] = STATE(2637),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_DOT_DOT] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2638] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3357),
    [sym_function_declaration_left] = STATE(6579),
    [sym_value_declaration_left] = STATE(6579),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2638),
    [sym_block_comment] = STATE(2638),
    [sym_line_comment] = STATE(2638),
    [sym_compiler_directive_decl] = STATE(2638),
    [sym_fsi_directive_decl] = STATE(2638),
    [sym_preproc_line] = STATE(2638),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4990),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2639] = {
    [sym_xml_doc] = STATE(2639),
    [sym_block_comment] = STATE(2639),
    [sym_line_comment] = STATE(2639),
    [sym_compiler_directive_decl] = STATE(2639),
    [sym_fsi_directive_decl] = STATE(2639),
    [sym_preproc_line] = STATE(2639),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_DOT_DOT] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2640] = {
    [sym_xml_doc] = STATE(2640),
    [sym_block_comment] = STATE(2640),
    [sym_line_comment] = STATE(2640),
    [sym_compiler_directive_decl] = STATE(2640),
    [sym_fsi_directive_decl] = STATE(2640),
    [sym_preproc_line] = STATE(2640),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_DOT_DOT] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2641] = {
    [sym_xml_doc] = STATE(2641),
    [sym_block_comment] = STATE(2641),
    [sym_line_comment] = STATE(2641),
    [sym_compiler_directive_decl] = STATE(2641),
    [sym_fsi_directive_decl] = STATE(2641),
    [sym_preproc_line] = STATE(2641),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_AT_GT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2642] = {
    [sym_xml_doc] = STATE(2642),
    [sym_block_comment] = STATE(2642),
    [sym_line_comment] = STATE(2642),
    [sym_compiler_directive_decl] = STATE(2642),
    [sym_fsi_directive_decl] = STATE(2642),
    [sym_preproc_line] = STATE(2642),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_DOT_DOT] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2643] = {
    [sym_xml_doc] = STATE(2643),
    [sym_block_comment] = STATE(2643),
    [sym_line_comment] = STATE(2643),
    [sym_compiler_directive_decl] = STATE(2643),
    [sym_fsi_directive_decl] = STATE(2643),
    [sym_preproc_line] = STATE(2643),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [anon_sym_POUNDendif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2644] = {
    [sym_xml_doc] = STATE(2644),
    [sym_block_comment] = STATE(2644),
    [sym_line_comment] = STATE(2644),
    [sym_compiler_directive_decl] = STATE(2644),
    [sym_fsi_directive_decl] = STATE(2644),
    [sym_preproc_line] = STATE(2644),
    [aux_sym_long_identifier_repeat1] = STATE(2616),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_and] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [aux_sym_access_modifier_token1] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(4986),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_member] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_val] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [2645] = {
    [sym_xml_doc] = STATE(2645),
    [sym_block_comment] = STATE(2645),
    [sym_line_comment] = STATE(2645),
    [sym_compiler_directive_decl] = STATE(2645),
    [sym_fsi_directive_decl] = STATE(2645),
    [sym_preproc_line] = STATE(2645),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [anon_sym_POUNDendif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2646] = {
    [sym_xml_doc] = STATE(2646),
    [sym_block_comment] = STATE(2646),
    [sym_line_comment] = STATE(2646),
    [sym_compiler_directive_decl] = STATE(2646),
    [sym_fsi_directive_decl] = STATE(2646),
    [sym_preproc_line] = STATE(2646),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_AT_AT_GT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2647] = {
    [sym_xml_doc] = STATE(2647),
    [sym_block_comment] = STATE(2647),
    [sym_line_comment] = STATE(2647),
    [sym_compiler_directive_decl] = STATE(2647),
    [sym_fsi_directive_decl] = STATE(2647),
    [sym_preproc_line] = STATE(2647),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [anon_sym_POUNDendif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2648] = {
    [sym_xml_doc] = STATE(2648),
    [sym_block_comment] = STATE(2648),
    [sym_line_comment] = STATE(2648),
    [sym_compiler_directive_decl] = STATE(2648),
    [sym_fsi_directive_decl] = STATE(2648),
    [sym_preproc_line] = STATE(2648),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [anon_sym_POUNDendif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2649] = {
    [sym_xml_doc] = STATE(2649),
    [sym_block_comment] = STATE(2649),
    [sym_line_comment] = STATE(2649),
    [sym_compiler_directive_decl] = STATE(2649),
    [sym_fsi_directive_decl] = STATE(2649),
    [sym_preproc_line] = STATE(2649),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2650] = {
    [sym_xml_doc] = STATE(2650),
    [sym_block_comment] = STATE(2650),
    [sym_line_comment] = STATE(2650),
    [sym_compiler_directive_decl] = STATE(2650),
    [sym_fsi_directive_decl] = STATE(2650),
    [sym_preproc_line] = STATE(2650),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_AT_GT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2651] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(8087),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2651),
    [sym_block_comment] = STATE(2651),
    [sym_line_comment] = STATE(2651),
    [sym_compiler_directive_decl] = STATE(2651),
    [sym_fsi_directive_decl] = STATE(2651),
    [sym_preproc_line] = STATE(2651),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2652] = {
    [sym_xml_doc] = STATE(2652),
    [sym_block_comment] = STATE(2652),
    [sym_line_comment] = STATE(2652),
    [sym_compiler_directive_decl] = STATE(2652),
    [sym_fsi_directive_decl] = STATE(2652),
    [sym_preproc_line] = STATE(2652),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2653] = {
    [sym_xml_doc] = STATE(2653),
    [sym_block_comment] = STATE(2653),
    [sym_line_comment] = STATE(2653),
    [sym_compiler_directive_decl] = STATE(2653),
    [sym_fsi_directive_decl] = STATE(2653),
    [sym_preproc_line] = STATE(2653),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_GT] = ACTIONS(3697),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2654] = {
    [sym_xml_doc] = STATE(2654),
    [sym_block_comment] = STATE(2654),
    [sym_line_comment] = STATE(2654),
    [sym_compiler_directive_decl] = STATE(2654),
    [sym_fsi_directive_decl] = STATE(2654),
    [sym_preproc_line] = STATE(2654),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_GT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2655] = {
    [sym_xml_doc] = STATE(2655),
    [sym_block_comment] = STATE(2655),
    [sym_line_comment] = STATE(2655),
    [sym_compiler_directive_decl] = STATE(2655),
    [sym_fsi_directive_decl] = STATE(2655),
    [sym_preproc_line] = STATE(2655),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3770),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2656] = {
    [sym_xml_doc] = STATE(2656),
    [sym_block_comment] = STATE(2656),
    [sym_line_comment] = STATE(2656),
    [sym_compiler_directive_decl] = STATE(2656),
    [sym_fsi_directive_decl] = STATE(2656),
    [sym_preproc_line] = STATE(2656),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_GT] = ACTIONS(3679),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2657] = {
    [sym_xml_doc] = STATE(2657),
    [sym_block_comment] = STATE(2657),
    [sym_line_comment] = STATE(2657),
    [sym_compiler_directive_decl] = STATE(2657),
    [sym_fsi_directive_decl] = STATE(2657),
    [sym_preproc_line] = STATE(2657),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2658] = {
    [sym_xml_doc] = STATE(2658),
    [sym_block_comment] = STATE(2658),
    [sym_line_comment] = STATE(2658),
    [sym_compiler_directive_decl] = STATE(2658),
    [sym_fsi_directive_decl] = STATE(2658),
    [sym_preproc_line] = STATE(2658),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_EQ] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_return] = ACTIONS(3899),
    [anon_sym_do] = ACTIONS(3899),
    [anon_sym_let] = ACTIONS(3899),
    [anon_sym_let_BANG] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_null] = ACTIONS(3899),
    [anon_sym_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_COLON] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_LT_AT] = ACTIONS(3899),
    [anon_sym_LT_AT_AT] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3899),
    [anon_sym_return_BANG] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(3899),
    [anon_sym_yield_BANG] = ACTIONS(3901),
    [anon_sym_lazy] = ACTIONS(3899),
    [anon_sym_assert] = ACTIONS(3899),
    [anon_sym_upcast] = ACTIONS(3899),
    [anon_sym_downcast] = ACTIONS(3899),
    [anon_sym_COLON_GT] = ACTIONS(3901),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3899),
    [anon_sym_while] = ACTIONS(3899),
    [anon_sym_if] = ACTIONS(3899),
    [anon_sym_fun] = ACTIONS(3899),
    [anon_sym_try] = ACTIONS(3899),
    [anon_sym_match] = ACTIONS(3899),
    [anon_sym_match_BANG] = ACTIONS(3901),
    [anon_sym_function] = ACTIONS(3899),
    [anon_sym_LT_DASH] = ACTIONS(3899),
    [anon_sym_DOT_LBRACK] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3901),
    [anon_sym_use] = ACTIONS(3899),
    [anon_sym_use_BANG] = ACTIONS(3901),
    [anon_sym_do_BANG] = ACTIONS(3901),
    [anon_sym_begin] = ACTIONS(3899),
    [anon_sym_LPAREN2] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3899),
    [aux_sym_char_token1] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [anon_sym_AT_DQUOTE] = ACTIONS(3901),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3901),
    [sym_bool] = ACTIONS(3899),
    [sym_unit] = ACTIONS(3899),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3899),
    [sym_op_identifier] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_DOT] = ACTIONS(3899),
    [anon_sym_DASH_DOT] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3901),
    [aux_sym_prefix_op_token1] = ACTIONS(3899),
    [aux_sym_infix_op_token1] = ACTIONS(3899),
    [anon_sym_PIPE_PIPE] = ACTIONS(3899),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_COLON_EQ] = ACTIONS(3901),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3899),
    [sym_int] = ACTIONS(3899),
    [sym_xint] = ACTIONS(3901),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3901),
    [anon_sym_POUNDendif] = ACTIONS(3901),
    [sym__newline] = ACTIONS(3901),
  },
  [2659] = {
    [sym_xml_doc] = STATE(2659),
    [sym_block_comment] = STATE(2659),
    [sym_line_comment] = STATE(2659),
    [sym_compiler_directive_decl] = STATE(2659),
    [sym_fsi_directive_decl] = STATE(2659),
    [sym_preproc_line] = STATE(2659),
    [sym_identifier] = ACTIONS(3895),
    [anon_sym_EQ] = ACTIONS(3897),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_return] = ACTIONS(3895),
    [anon_sym_do] = ACTIONS(3895),
    [anon_sym_let] = ACTIONS(3895),
    [anon_sym_let_BANG] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_null] = ACTIONS(3895),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_COLON] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_LT_AT] = ACTIONS(3895),
    [anon_sym_LT_AT_AT] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_return_BANG] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(3895),
    [anon_sym_yield_BANG] = ACTIONS(3897),
    [anon_sym_lazy] = ACTIONS(3895),
    [anon_sym_assert] = ACTIONS(3895),
    [anon_sym_upcast] = ACTIONS(3895),
    [anon_sym_downcast] = ACTIONS(3895),
    [anon_sym_COLON_GT] = ACTIONS(3897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3895),
    [anon_sym_while] = ACTIONS(3895),
    [anon_sym_if] = ACTIONS(3895),
    [anon_sym_fun] = ACTIONS(3895),
    [anon_sym_try] = ACTIONS(3895),
    [anon_sym_match] = ACTIONS(3895),
    [anon_sym_match_BANG] = ACTIONS(3897),
    [anon_sym_function] = ACTIONS(3895),
    [anon_sym_LT_DASH] = ACTIONS(3895),
    [anon_sym_DOT_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3897),
    [anon_sym_use] = ACTIONS(3895),
    [anon_sym_use_BANG] = ACTIONS(3897),
    [anon_sym_do_BANG] = ACTIONS(3897),
    [anon_sym_begin] = ACTIONS(3895),
    [anon_sym_LPAREN2] = ACTIONS(3897),
    [anon_sym_or] = ACTIONS(3895),
    [aux_sym_char_token1] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_AT_DQUOTE] = ACTIONS(3897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3897),
    [sym_bool] = ACTIONS(3895),
    [sym_unit] = ACTIONS(3895),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3895),
    [sym_op_identifier] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_DOT] = ACTIONS(3895),
    [anon_sym_DASH_DOT] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3897),
    [aux_sym_prefix_op_token1] = ACTIONS(3895),
    [aux_sym_infix_op_token1] = ACTIONS(3895),
    [anon_sym_PIPE_PIPE] = ACTIONS(3895),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_COLON_EQ] = ACTIONS(3897),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3895),
    [sym_int] = ACTIONS(3895),
    [sym_xint] = ACTIONS(3897),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3897),
    [anon_sym_POUNDendif] = ACTIONS(3897),
    [sym__newline] = ACTIONS(3897),
  },
  [2660] = {
    [sym_xml_doc] = STATE(2660),
    [sym_block_comment] = STATE(2660),
    [sym_line_comment] = STATE(2660),
    [sym_compiler_directive_decl] = STATE(2660),
    [sym_fsi_directive_decl] = STATE(2660),
    [sym_preproc_line] = STATE(2660),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_QMARK] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3782),
    [anon_sym_AT_AT_GT] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_COLON_GT] = ACTIONS(3784),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_LT_DASH] = ACTIONS(3782),
    [anon_sym_DOT_LBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3784),
    [anon_sym_or] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3782),
    [anon_sym_DASH_DOT] = ACTIONS(3782),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3782),
    [aux_sym_infix_op_token1] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_COLON_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(3782),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3782),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
    [sym__newline] = ACTIONS(3784),
  },
  [2661] = {
    [sym_xml_doc] = STATE(2661),
    [sym_block_comment] = STATE(2661),
    [sym_line_comment] = STATE(2661),
    [sym_compiler_directive_decl] = STATE(2661),
    [sym_fsi_directive_decl] = STATE(2661),
    [sym_preproc_line] = STATE(2661),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_DOT_DOT] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2662] = {
    [sym_xml_doc] = STATE(2662),
    [sym_block_comment] = STATE(2662),
    [sym_line_comment] = STATE(2662),
    [sym_compiler_directive_decl] = STATE(2662),
    [sym_fsi_directive_decl] = STATE(2662),
    [sym_preproc_line] = STATE(2662),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_AT_AT_GT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2663] = {
    [sym_xml_doc] = STATE(2663),
    [sym_block_comment] = STATE(2663),
    [sym_line_comment] = STATE(2663),
    [sym_compiler_directive_decl] = STATE(2663),
    [sym_fsi_directive_decl] = STATE(2663),
    [sym_preproc_line] = STATE(2663),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_AT_AT_GT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2664] = {
    [sym_xml_doc] = STATE(2664),
    [sym_block_comment] = STATE(2664),
    [sym_line_comment] = STATE(2664),
    [sym_compiler_directive_decl] = STATE(2664),
    [sym_fsi_directive_decl] = STATE(2664),
    [sym_preproc_line] = STATE(2664),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_AT_AT_GT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2665] = {
    [sym_xml_doc] = STATE(2665),
    [sym_block_comment] = STATE(2665),
    [sym_line_comment] = STATE(2665),
    [sym_compiler_directive_decl] = STATE(2665),
    [sym_fsi_directive_decl] = STATE(2665),
    [sym_preproc_line] = STATE(2665),
    [sym_identifier] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3888),
    [anon_sym_return] = ACTIONS(3888),
    [anon_sym_do] = ACTIONS(3888),
    [anon_sym_let] = ACTIONS(3888),
    [anon_sym_let_BANG] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_null] = ACTIONS(3888),
    [anon_sym_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_QMARK] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_AMP] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3888),
    [anon_sym_LT_AT] = ACTIONS(3888),
    [anon_sym_LT_AT_AT] = ACTIONS(3888),
    [anon_sym_DOT] = ACTIONS(3888),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3888),
    [anon_sym_return_BANG] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3888),
    [anon_sym_yield_BANG] = ACTIONS(3890),
    [anon_sym_lazy] = ACTIONS(3888),
    [anon_sym_assert] = ACTIONS(3888),
    [anon_sym_upcast] = ACTIONS(3888),
    [anon_sym_downcast] = ACTIONS(3888),
    [anon_sym_COLON_GT] = ACTIONS(3890),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3890),
    [anon_sym_for] = ACTIONS(3888),
    [anon_sym_while] = ACTIONS(3888),
    [anon_sym_if] = ACTIONS(3888),
    [anon_sym_fun] = ACTIONS(3888),
    [anon_sym_try] = ACTIONS(3888),
    [anon_sym_match] = ACTIONS(3888),
    [anon_sym_match_BANG] = ACTIONS(3890),
    [anon_sym_function] = ACTIONS(3888),
    [anon_sym_LT_DASH] = ACTIONS(3888),
    [anon_sym_DOT_LBRACK] = ACTIONS(3890),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_use] = ACTIONS(3888),
    [anon_sym_use_BANG] = ACTIONS(3890),
    [anon_sym_do_BANG] = ACTIONS(3890),
    [anon_sym_begin] = ACTIONS(3888),
    [anon_sym_LPAREN2] = ACTIONS(3890),
    [anon_sym_or] = ACTIONS(3888),
    [aux_sym_char_token1] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3888),
    [anon_sym_DQUOTE] = ACTIONS(3888),
    [anon_sym_AT_DQUOTE] = ACTIONS(3890),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3890),
    [sym_bool] = ACTIONS(3888),
    [sym_unit] = ACTIONS(3888),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3888),
    [sym_op_identifier] = ACTIONS(3888),
    [anon_sym_PLUS] = ACTIONS(3888),
    [anon_sym_DASH] = ACTIONS(3888),
    [anon_sym_PLUS_DOT] = ACTIONS(3888),
    [anon_sym_DASH_DOT] = ACTIONS(3888),
    [anon_sym_PERCENT] = ACTIONS(3888),
    [anon_sym_AMP_AMP] = ACTIONS(3888),
    [anon_sym_TILDE] = ACTIONS(3890),
    [aux_sym_prefix_op_token1] = ACTIONS(3888),
    [aux_sym_infix_op_token1] = ACTIONS(3888),
    [anon_sym_PIPE_PIPE] = ACTIONS(3888),
    [anon_sym_BANG_EQ] = ACTIONS(3888),
    [anon_sym_COLON_EQ] = ACTIONS(3890),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3888),
    [sym_int] = ACTIONS(3888),
    [sym_xint] = ACTIONS(3890),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3890),
    [anon_sym_POUNDendif] = ACTIONS(3890),
    [sym__newline] = ACTIONS(3890),
  },
  [2666] = {
    [sym_xml_doc] = STATE(2666),
    [sym_block_comment] = STATE(2666),
    [sym_line_comment] = STATE(2666),
    [sym_compiler_directive_decl] = STATE(2666),
    [sym_fsi_directive_decl] = STATE(2666),
    [sym_preproc_line] = STATE(2666),
    [sym_identifier] = ACTIONS(3884),
    [anon_sym_EQ] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3884),
    [anon_sym_return] = ACTIONS(3884),
    [anon_sym_do] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_let_BANG] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_null] = ACTIONS(3884),
    [anon_sym_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_QMARK] = ACTIONS(3884),
    [anon_sym_COLON_COLON] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3884),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_LT_AT] = ACTIONS(3884),
    [anon_sym_LT_AT_AT] = ACTIONS(3884),
    [anon_sym_DOT] = ACTIONS(3884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3886),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_return_BANG] = ACTIONS(3886),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_yield_BANG] = ACTIONS(3886),
    [anon_sym_lazy] = ACTIONS(3884),
    [anon_sym_assert] = ACTIONS(3884),
    [anon_sym_upcast] = ACTIONS(3884),
    [anon_sym_downcast] = ACTIONS(3884),
    [anon_sym_COLON_GT] = ACTIONS(3886),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3886),
    [anon_sym_for] = ACTIONS(3884),
    [anon_sym_while] = ACTIONS(3884),
    [anon_sym_if] = ACTIONS(3884),
    [anon_sym_fun] = ACTIONS(3884),
    [anon_sym_try] = ACTIONS(3884),
    [anon_sym_match] = ACTIONS(3884),
    [anon_sym_match_BANG] = ACTIONS(3886),
    [anon_sym_function] = ACTIONS(3884),
    [anon_sym_LT_DASH] = ACTIONS(3884),
    [anon_sym_DOT_LBRACK] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_use] = ACTIONS(3884),
    [anon_sym_use_BANG] = ACTIONS(3886),
    [anon_sym_do_BANG] = ACTIONS(3886),
    [anon_sym_begin] = ACTIONS(3884),
    [anon_sym_LPAREN2] = ACTIONS(3886),
    [anon_sym_or] = ACTIONS(3884),
    [aux_sym_char_token1] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3884),
    [anon_sym_DQUOTE] = ACTIONS(3884),
    [anon_sym_AT_DQUOTE] = ACTIONS(3886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3886),
    [sym_bool] = ACTIONS(3884),
    [sym_unit] = ACTIONS(3884),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3884),
    [sym_op_identifier] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS_DOT] = ACTIONS(3884),
    [anon_sym_DASH_DOT] = ACTIONS(3884),
    [anon_sym_PERCENT] = ACTIONS(3884),
    [anon_sym_AMP_AMP] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [aux_sym_prefix_op_token1] = ACTIONS(3884),
    [aux_sym_infix_op_token1] = ACTIONS(3884),
    [anon_sym_PIPE_PIPE] = ACTIONS(3884),
    [anon_sym_BANG_EQ] = ACTIONS(3884),
    [anon_sym_COLON_EQ] = ACTIONS(3886),
    [anon_sym_DOLLAR] = ACTIONS(3884),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3884),
    [sym_int] = ACTIONS(3884),
    [sym_xint] = ACTIONS(3886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3886),
    [anon_sym_POUNDendif] = ACTIONS(3886),
    [sym__newline] = ACTIONS(3886),
  },
  [2667] = {
    [sym_xml_doc] = STATE(2667),
    [sym_block_comment] = STATE(2667),
    [sym_line_comment] = STATE(2667),
    [sym_compiler_directive_decl] = STATE(2667),
    [sym_fsi_directive_decl] = STATE(2667),
    [sym_preproc_line] = STATE(2667),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2668] = {
    [sym_xml_doc] = STATE(2668),
    [sym_block_comment] = STATE(2668),
    [sym_line_comment] = STATE(2668),
    [sym_compiler_directive_decl] = STATE(2668),
    [sym_fsi_directive_decl] = STATE(2668),
    [sym_preproc_line] = STATE(2668),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_DOT_DOT] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2669] = {
    [sym_xml_doc] = STATE(2669),
    [sym_block_comment] = STATE(2669),
    [sym_line_comment] = STATE(2669),
    [sym_compiler_directive_decl] = STATE(2669),
    [sym_fsi_directive_decl] = STATE(2669),
    [sym_preproc_line] = STATE(2669),
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3878),
    [anon_sym_let_BANG] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_null] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_LT_AT] = ACTIONS(3878),
    [anon_sym_LT_AT_AT] = ACTIONS(3878),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_return_BANG] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3878),
    [anon_sym_yield_BANG] = ACTIONS(3880),
    [anon_sym_lazy] = ACTIONS(3878),
    [anon_sym_assert] = ACTIONS(3878),
    [anon_sym_upcast] = ACTIONS(3878),
    [anon_sym_downcast] = ACTIONS(3878),
    [anon_sym_COLON_GT] = ACTIONS(3880),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3880),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_fun] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_match] = ACTIONS(3878),
    [anon_sym_match_BANG] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3878),
    [anon_sym_LT_DASH] = ACTIONS(3878),
    [anon_sym_DOT_LBRACK] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3880),
    [anon_sym_use] = ACTIONS(3878),
    [anon_sym_use_BANG] = ACTIONS(3880),
    [anon_sym_do_BANG] = ACTIONS(3880),
    [anon_sym_begin] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_or] = ACTIONS(3878),
    [aux_sym_char_token1] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_AT_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3880),
    [sym_bool] = ACTIONS(3878),
    [sym_unit] = ACTIONS(3878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3878),
    [sym_op_identifier] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS_DOT] = ACTIONS(3878),
    [anon_sym_DASH_DOT] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_TILDE] = ACTIONS(3880),
    [aux_sym_prefix_op_token1] = ACTIONS(3878),
    [aux_sym_infix_op_token1] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3878),
    [anon_sym_COLON_EQ] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(3878),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3878),
    [sym_int] = ACTIONS(3878),
    [sym_xint] = ACTIONS(3880),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3880),
    [anon_sym_POUNDendif] = ACTIONS(3880),
    [sym__newline] = ACTIONS(3880),
  },
  [2670] = {
    [sym_xml_doc] = STATE(2670),
    [sym_block_comment] = STATE(2670),
    [sym_line_comment] = STATE(2670),
    [sym_compiler_directive_decl] = STATE(2670),
    [sym_fsi_directive_decl] = STATE(2670),
    [sym_preproc_line] = STATE(2670),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(3780),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3778),
    [anon_sym_AT_AT_GT] = ACTIONS(3778),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_COLON_GT] = ACTIONS(3780),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3780),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_LT_DASH] = ACTIONS(3778),
    [anon_sym_DOT_LBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [anon_sym_LPAREN2] = ACTIONS(3780),
    [anon_sym_or] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3778),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3778),
    [anon_sym_DASH_DOT] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_AMP_AMP] = ACTIONS(3778),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [anon_sym_PIPE_PIPE] = ACTIONS(3778),
    [anon_sym_BANG_EQ] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3778),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
    [sym__newline] = ACTIONS(3780),
  },
  [2671] = {
    [sym_xml_doc] = STATE(2671),
    [sym_block_comment] = STATE(2671),
    [sym_line_comment] = STATE(2671),
    [sym_compiler_directive_decl] = STATE(2671),
    [sym_fsi_directive_decl] = STATE(2671),
    [sym_preproc_line] = STATE(2671),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3863),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [anon_sym_POUNDendif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2672] = {
    [sym_xml_doc] = STATE(2672),
    [sym_block_comment] = STATE(2672),
    [sym_line_comment] = STATE(2672),
    [sym_compiler_directive_decl] = STATE(2672),
    [sym_fsi_directive_decl] = STATE(2672),
    [sym_preproc_line] = STATE(2672),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_DOT_DOT] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2673] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2673),
    [sym_block_comment] = STATE(2673),
    [sym_line_comment] = STATE(2673),
    [sym_compiler_directive_decl] = STATE(2673),
    [sym_fsi_directive_decl] = STATE(2673),
    [sym_preproc_line] = STATE(2673),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_open] = ACTIONS(3092),
    [anon_sym_LBRACK_LT] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_type] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [aux_sym_access_modifier_token1] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_member] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_abstract] = ACTIONS(3092),
    [anon_sym_override] = ACTIONS(3092),
    [anon_sym_val] = ACTIONS(3092),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3090),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3090),
    [anon_sym_DASH_DOT] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3090),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3090),
    [anon_sym_POUNDload] = ACTIONS(3090),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__dedent] = ACTIONS(3090),
  },
  [2674] = {
    [sym_xml_doc] = STATE(2674),
    [sym_block_comment] = STATE(2674),
    [sym_line_comment] = STATE(2674),
    [sym_compiler_directive_decl] = STATE(2674),
    [sym_fsi_directive_decl] = STATE(2674),
    [sym_preproc_line] = STATE(2674),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_let_BANG] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_null] = ACTIONS(3847),
    [anon_sym_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_COLON] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_LT_AT] = ACTIONS(3847),
    [anon_sym_LT_AT_AT] = ACTIONS(3847),
    [anon_sym_DOT] = ACTIONS(3847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_return_BANG] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_yield_BANG] = ACTIONS(3849),
    [anon_sym_lazy] = ACTIONS(3847),
    [anon_sym_assert] = ACTIONS(3847),
    [anon_sym_upcast] = ACTIONS(3847),
    [anon_sym_downcast] = ACTIONS(3847),
    [anon_sym_COLON_GT] = ACTIONS(3849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_fun] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_match] = ACTIONS(3847),
    [anon_sym_match_BANG] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3847),
    [anon_sym_LT_DASH] = ACTIONS(3847),
    [anon_sym_DOT_LBRACK] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3849),
    [anon_sym_use] = ACTIONS(3847),
    [anon_sym_use_BANG] = ACTIONS(3849),
    [anon_sym_do_BANG] = ACTIONS(3849),
    [anon_sym_begin] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(3849),
    [anon_sym_or] = ACTIONS(3847),
    [aux_sym_char_token1] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_AT_DQUOTE] = ACTIONS(3849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3849),
    [sym_bool] = ACTIONS(3847),
    [sym_unit] = ACTIONS(3847),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3847),
    [sym_op_identifier] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_DOT] = ACTIONS(3847),
    [anon_sym_DASH_DOT] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [aux_sym_prefix_op_token1] = ACTIONS(3847),
    [aux_sym_infix_op_token1] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3847),
    [anon_sym_BANG_EQ] = ACTIONS(3847),
    [anon_sym_COLON_EQ] = ACTIONS(3849),
    [anon_sym_DOLLAR] = ACTIONS(3847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3847),
    [sym_int] = ACTIONS(3847),
    [sym_xint] = ACTIONS(3849),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3849),
    [anon_sym_POUNDendif] = ACTIONS(3849),
    [sym__newline] = ACTIONS(3849),
  },
  [2675] = {
    [sym_xml_doc] = STATE(2675),
    [sym_block_comment] = STATE(2675),
    [sym_line_comment] = STATE(2675),
    [sym_compiler_directive_decl] = STATE(2675),
    [sym_fsi_directive_decl] = STATE(2675),
    [sym_preproc_line] = STATE(2675),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2676] = {
    [sym_xml_doc] = STATE(2676),
    [sym_block_comment] = STATE(2676),
    [sym_line_comment] = STATE(2676),
    [sym_compiler_directive_decl] = STATE(2676),
    [sym_fsi_directive_decl] = STATE(2676),
    [sym_preproc_line] = STATE(2676),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_DOT_DOT] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2677] = {
    [sym_xml_doc] = STATE(2677),
    [sym_block_comment] = STATE(2677),
    [sym_line_comment] = STATE(2677),
    [sym_compiler_directive_decl] = STATE(2677),
    [sym_fsi_directive_decl] = STATE(2677),
    [sym_preproc_line] = STATE(2677),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3577),
    [anon_sym_AT_AT_GT] = ACTIONS(3577),
    [anon_sym_DOT] = ACTIONS(3577),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_COLON_GT] = ACTIONS(3579),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_LT_DASH] = ACTIONS(3577),
    [anon_sym_DOT_LBRACK] = ACTIONS(3579),
    [anon_sym_LT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_or] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3577),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3577),
    [anon_sym_DASH_DOT] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_AMP_AMP] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3577),
    [aux_sym_infix_op_token1] = ACTIONS(3577),
    [anon_sym_PIPE_PIPE] = ACTIONS(3577),
    [anon_sym_BANG_EQ] = ACTIONS(3577),
    [anon_sym_COLON_EQ] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3577),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
    [sym__newline] = ACTIONS(3579),
  },
  [2678] = {
    [sym_xml_doc] = STATE(2678),
    [sym_block_comment] = STATE(2678),
    [sym_line_comment] = STATE(2678),
    [sym_compiler_directive_decl] = STATE(2678),
    [sym_fsi_directive_decl] = STATE(2678),
    [sym_preproc_line] = STATE(2678),
    [sym_identifier] = ACTIONS(3906),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_return] = ACTIONS(3906),
    [anon_sym_do] = ACTIONS(3906),
    [anon_sym_let] = ACTIONS(3906),
    [anon_sym_let_BANG] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_COMMA] = ACTIONS(3908),
    [anon_sym_null] = ACTIONS(3906),
    [anon_sym_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_COLON] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(3906),
    [anon_sym_LT_AT] = ACTIONS(3906),
    [anon_sym_LT_AT_AT] = ACTIONS(3906),
    [anon_sym_DOT] = ACTIONS(3906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_return_BANG] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3906),
    [anon_sym_yield_BANG] = ACTIONS(3908),
    [anon_sym_lazy] = ACTIONS(3906),
    [anon_sym_assert] = ACTIONS(3906),
    [anon_sym_upcast] = ACTIONS(3906),
    [anon_sym_downcast] = ACTIONS(3906),
    [anon_sym_COLON_GT] = ACTIONS(3908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3906),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_if] = ACTIONS(3906),
    [anon_sym_fun] = ACTIONS(3906),
    [anon_sym_try] = ACTIONS(3906),
    [anon_sym_match] = ACTIONS(3906),
    [anon_sym_match_BANG] = ACTIONS(3908),
    [anon_sym_function] = ACTIONS(3906),
    [anon_sym_LT_DASH] = ACTIONS(3906),
    [anon_sym_DOT_LBRACK] = ACTIONS(3908),
    [anon_sym_LT] = ACTIONS(3908),
    [anon_sym_GT] = ACTIONS(3906),
    [anon_sym_use] = ACTIONS(3906),
    [anon_sym_use_BANG] = ACTIONS(3908),
    [anon_sym_do_BANG] = ACTIONS(3908),
    [anon_sym_begin] = ACTIONS(3906),
    [anon_sym_LPAREN2] = ACTIONS(3908),
    [anon_sym_or] = ACTIONS(3906),
    [aux_sym_char_token1] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3906),
    [anon_sym_DQUOTE] = ACTIONS(3906),
    [anon_sym_AT_DQUOTE] = ACTIONS(3908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [sym_bool] = ACTIONS(3906),
    [sym_unit] = ACTIONS(3906),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3906),
    [sym_op_identifier] = ACTIONS(3906),
    [anon_sym_PLUS] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [anon_sym_PLUS_DOT] = ACTIONS(3906),
    [anon_sym_DASH_DOT] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_AMP_AMP] = ACTIONS(3906),
    [anon_sym_TILDE] = ACTIONS(3908),
    [aux_sym_prefix_op_token1] = ACTIONS(3906),
    [aux_sym_infix_op_token1] = ACTIONS(3906),
    [anon_sym_PIPE_PIPE] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_COLON_EQ] = ACTIONS(3908),
    [anon_sym_DOLLAR] = ACTIONS(3906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3906),
    [sym_int] = ACTIONS(3906),
    [sym_xint] = ACTIONS(3908),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3908),
    [sym__newline] = ACTIONS(3908),
  },
  [2679] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5803),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2679),
    [sym_block_comment] = STATE(2679),
    [sym_line_comment] = STATE(2679),
    [sym_compiler_directive_decl] = STATE(2679),
    [sym_fsi_directive_decl] = STATE(2679),
    [sym_preproc_line] = STATE(2679),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(4762),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2680] = {
    [sym_xml_doc] = STATE(2680),
    [sym_block_comment] = STATE(2680),
    [sym_line_comment] = STATE(2680),
    [sym_compiler_directive_decl] = STATE(2680),
    [sym_fsi_directive_decl] = STATE(2680),
    [sym_preproc_line] = STATE(2680),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [anon_sym_POUNDendif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2681] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5772),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2681),
    [sym_block_comment] = STATE(2681),
    [sym_line_comment] = STATE(2681),
    [sym_compiler_directive_decl] = STATE(2681),
    [sym_fsi_directive_decl] = STATE(2681),
    [sym_preproc_line] = STATE(2681),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [anon_sym_DASH_GT] = ACTIONS(4762),
    [anon_sym_when] = ACTIONS(4764),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2682] = {
    [sym_xml_doc] = STATE(2682),
    [sym_block_comment] = STATE(2682),
    [sym_line_comment] = STATE(2682),
    [sym_compiler_directive_decl] = STATE(2682),
    [sym_fsi_directive_decl] = STATE(2682),
    [sym_preproc_line] = STATE(2682),
    [aux_sym_type_argument_repeat1] = STATE(2682),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_and] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [aux_sym_access_modifier_token1] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_member] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_val] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [2683] = {
    [sym_xml_doc] = STATE(2683),
    [sym_block_comment] = STATE(2683),
    [sym_line_comment] = STATE(2683),
    [sym_compiler_directive_decl] = STATE(2683),
    [sym_fsi_directive_decl] = STATE(2683),
    [sym_preproc_line] = STATE(2683),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2684] = {
    [sym_xml_doc] = STATE(2684),
    [sym_block_comment] = STATE(2684),
    [sym_line_comment] = STATE(2684),
    [sym_compiler_directive_decl] = STATE(2684),
    [sym_fsi_directive_decl] = STATE(2684),
    [sym_preproc_line] = STATE(2684),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_DOT_DOT] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2685] = {
    [sym_xml_doc] = STATE(2685),
    [sym_block_comment] = STATE(2685),
    [sym_line_comment] = STATE(2685),
    [sym_compiler_directive_decl] = STATE(2685),
    [sym_fsi_directive_decl] = STATE(2685),
    [sym_preproc_line] = STATE(2685),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_QMARK] = ACTIONS(3734),
    [anon_sym_COLON_COLON] = ACTIONS(3736),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3734),
    [anon_sym_DOT] = ACTIONS(3734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_COLON_GT] = ACTIONS(3736),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3736),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_LT_DASH] = ACTIONS(3734),
    [anon_sym_DOT_LBRACK] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3734),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3734),
    [anon_sym_DASH_DOT] = ACTIONS(3734),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3734),
    [anon_sym_COLON_EQ] = ACTIONS(3736),
    [anon_sym_DOLLAR] = ACTIONS(3734),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3734),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
    [sym__newline] = ACTIONS(3736),
  },
  [2686] = {
    [sym_xml_doc] = STATE(2686),
    [sym_block_comment] = STATE(2686),
    [sym_line_comment] = STATE(2686),
    [sym_compiler_directive_decl] = STATE(2686),
    [sym_fsi_directive_decl] = STATE(2686),
    [sym_preproc_line] = STATE(2686),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_GT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2687] = {
    [sym_xml_doc] = STATE(2687),
    [sym_block_comment] = STATE(2687),
    [sym_line_comment] = STATE(2687),
    [sym_compiler_directive_decl] = STATE(2687),
    [sym_fsi_directive_decl] = STATE(2687),
    [sym_preproc_line] = STATE(2687),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_COLON] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_QMARK] = ACTIONS(3722),
    [anon_sym_COLON_COLON] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3722),
    [anon_sym_DOT] = ACTIONS(3722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_COLON_GT] = ACTIONS(3724),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3724),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_LT_DASH] = ACTIONS(3722),
    [anon_sym_DOT_LBRACK] = ACTIONS(3724),
    [anon_sym_LT] = ACTIONS(3724),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_LPAREN2] = ACTIONS(3724),
    [anon_sym_or] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3722),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3722),
    [anon_sym_DASH_DOT] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3722),
    [aux_sym_infix_op_token1] = ACTIONS(3722),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_COLON_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
    [sym__newline] = ACTIONS(3724),
  },
  [2688] = {
    [sym_xml_doc] = STATE(2688),
    [sym_block_comment] = STATE(2688),
    [sym_line_comment] = STATE(2688),
    [sym_compiler_directive_decl] = STATE(2688),
    [sym_fsi_directive_decl] = STATE(2688),
    [sym_preproc_line] = STATE(2688),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_EQ] = ACTIONS(3916),
    [anon_sym_COLON] = ACTIONS(3914),
    [anon_sym_return] = ACTIONS(3914),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_let_BANG] = ACTIONS(3916),
    [anon_sym_LPAREN] = ACTIONS(3914),
    [anon_sym_COMMA] = ACTIONS(3916),
    [anon_sym_null] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_QMARK] = ACTIONS(3914),
    [anon_sym_COLON_COLON] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3916),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_LT_AT] = ACTIONS(3914),
    [anon_sym_LT_AT_AT] = ACTIONS(3914),
    [anon_sym_DOT] = ACTIONS(3914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3916),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_return_BANG] = ACTIONS(3916),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_yield_BANG] = ACTIONS(3916),
    [anon_sym_lazy] = ACTIONS(3914),
    [anon_sym_assert] = ACTIONS(3914),
    [anon_sym_upcast] = ACTIONS(3914),
    [anon_sym_downcast] = ACTIONS(3914),
    [anon_sym_COLON_GT] = ACTIONS(3916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3916),
    [anon_sym_for] = ACTIONS(3914),
    [anon_sym_while] = ACTIONS(3914),
    [anon_sym_if] = ACTIONS(3914),
    [anon_sym_fun] = ACTIONS(3914),
    [anon_sym_try] = ACTIONS(3914),
    [anon_sym_match] = ACTIONS(3914),
    [anon_sym_match_BANG] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(3914),
    [anon_sym_LT_DASH] = ACTIONS(3914),
    [anon_sym_DOT_LBRACK] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(3916),
    [anon_sym_GT] = ACTIONS(3914),
    [anon_sym_use] = ACTIONS(3914),
    [anon_sym_use_BANG] = ACTIONS(3916),
    [anon_sym_do_BANG] = ACTIONS(3916),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(3916),
    [anon_sym_or] = ACTIONS(3914),
    [aux_sym_char_token1] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3914),
    [anon_sym_DQUOTE] = ACTIONS(3914),
    [anon_sym_AT_DQUOTE] = ACTIONS(3916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3916),
    [sym_bool] = ACTIONS(3914),
    [sym_unit] = ACTIONS(3914),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3914),
    [sym_op_identifier] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_PLUS_DOT] = ACTIONS(3914),
    [anon_sym_DASH_DOT] = ACTIONS(3914),
    [anon_sym_PERCENT] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3916),
    [aux_sym_prefix_op_token1] = ACTIONS(3914),
    [aux_sym_infix_op_token1] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [anon_sym_BANG_EQ] = ACTIONS(3914),
    [anon_sym_COLON_EQ] = ACTIONS(3916),
    [anon_sym_DOLLAR] = ACTIONS(3914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3914),
    [sym_int] = ACTIONS(3914),
    [sym_xint] = ACTIONS(3916),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3916),
    [sym__newline] = ACTIONS(3916),
  },
  [2689] = {
    [sym_xml_doc] = STATE(2689),
    [sym_block_comment] = STATE(2689),
    [sym_line_comment] = STATE(2689),
    [sym_compiler_directive_decl] = STATE(2689),
    [sym_fsi_directive_decl] = STATE(2689),
    [sym_preproc_line] = STATE(2689),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3695),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3695),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3695),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_GT] = ACTIONS(3693),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3695),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3693),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
    [sym__newline] = ACTIONS(3695),
  },
  [2690] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7292),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2690),
    [sym_block_comment] = STATE(2690),
    [sym_line_comment] = STATE(2690),
    [sym_compiler_directive_decl] = STATE(2690),
    [sym_fsi_directive_decl] = STATE(2690),
    [sym_preproc_line] = STATE(2690),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2691] = {
    [sym_xml_doc] = STATE(2691),
    [sym_block_comment] = STATE(2691),
    [sym_line_comment] = STATE(2691),
    [sym_compiler_directive_decl] = STATE(2691),
    [sym_fsi_directive_decl] = STATE(2691),
    [sym_preproc_line] = STATE(2691),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2692] = {
    [sym_xml_doc] = STATE(2692),
    [sym_block_comment] = STATE(2692),
    [sym_line_comment] = STATE(2692),
    [sym_compiler_directive_decl] = STATE(2692),
    [sym_fsi_directive_decl] = STATE(2692),
    [sym_preproc_line] = STATE(2692),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_AT_AT_GT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2693] = {
    [sym_xml_doc] = STATE(2693),
    [sym_block_comment] = STATE(2693),
    [sym_line_comment] = STATE(2693),
    [sym_compiler_directive_decl] = STATE(2693),
    [sym_fsi_directive_decl] = STATE(2693),
    [sym_preproc_line] = STATE(2693),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_AT_AT_GT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2694] = {
    [sym_xml_doc] = STATE(2694),
    [sym_block_comment] = STATE(2694),
    [sym_line_comment] = STATE(2694),
    [sym_compiler_directive_decl] = STATE(2694),
    [sym_fsi_directive_decl] = STATE(2694),
    [sym_preproc_line] = STATE(2694),
    [sym_identifier] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_return] = ACTIONS(3925),
    [anon_sym_do] = ACTIONS(3925),
    [anon_sym_let] = ACTIONS(3925),
    [anon_sym_let_BANG] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_null] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_COLON] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3925),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3925),
    [anon_sym_return_BANG] = ACTIONS(3927),
    [anon_sym_yield] = ACTIONS(3925),
    [anon_sym_yield_BANG] = ACTIONS(3927),
    [anon_sym_lazy] = ACTIONS(3925),
    [anon_sym_assert] = ACTIONS(3925),
    [anon_sym_upcast] = ACTIONS(3925),
    [anon_sym_downcast] = ACTIONS(3925),
    [anon_sym_COLON_GT] = ACTIONS(3927),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3925),
    [anon_sym_while] = ACTIONS(3925),
    [anon_sym_if] = ACTIONS(3925),
    [anon_sym_fun] = ACTIONS(3925),
    [anon_sym_try] = ACTIONS(3925),
    [anon_sym_match] = ACTIONS(3925),
    [anon_sym_match_BANG] = ACTIONS(3927),
    [anon_sym_function] = ACTIONS(3925),
    [anon_sym_LT_DASH] = ACTIONS(3925),
    [anon_sym_DOT_LBRACK] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3925),
    [anon_sym_use_BANG] = ACTIONS(3927),
    [anon_sym_do_BANG] = ACTIONS(3927),
    [anon_sym_begin] = ACTIONS(3925),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3925),
    [aux_sym_char_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_AT_DQUOTE] = ACTIONS(3927),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3927),
    [sym_bool] = ACTIONS(3925),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3925),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3927),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3925),
    [anon_sym_COLON_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3925),
    [sym_int] = ACTIONS(3925),
    [sym_xint] = ACTIONS(3927),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3927),
    [sym__newline] = ACTIONS(3927),
  },
  [2695] = {
    [sym_xml_doc] = STATE(2695),
    [sym_block_comment] = STATE(2695),
    [sym_line_comment] = STATE(2695),
    [sym_compiler_directive_decl] = STATE(2695),
    [sym_fsi_directive_decl] = STATE(2695),
    [sym_preproc_line] = STATE(2695),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(3703),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_COLON] = ACTIONS(3703),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3701),
    [anon_sym_AT_AT_GT] = ACTIONS(3701),
    [anon_sym_DOT] = ACTIONS(3701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_COLON_GT] = ACTIONS(3703),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_LT_DASH] = ACTIONS(3701),
    [anon_sym_DOT_LBRACK] = ACTIONS(3703),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [anon_sym_LPAREN2] = ACTIONS(3703),
    [anon_sym_or] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3701),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3701),
    [anon_sym_DASH_DOT] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3701),
    [aux_sym_infix_op_token1] = ACTIONS(3701),
    [anon_sym_PIPE_PIPE] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3701),
    [anon_sym_COLON_EQ] = ACTIONS(3703),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3701),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
    [sym__newline] = ACTIONS(3703),
  },
  [2696] = {
    [sym_xml_doc] = STATE(2696),
    [sym_block_comment] = STATE(2696),
    [sym_line_comment] = STATE(2696),
    [sym_compiler_directive_decl] = STATE(2696),
    [sym_fsi_directive_decl] = STATE(2696),
    [sym_preproc_line] = STATE(2696),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_AT_AT_GT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2697] = {
    [sym_xml_doc] = STATE(2697),
    [sym_block_comment] = STATE(2697),
    [sym_line_comment] = STATE(2697),
    [sym_compiler_directive_decl] = STATE(2697),
    [sym_fsi_directive_decl] = STATE(2697),
    [sym_preproc_line] = STATE(2697),
    [sym_identifier] = ACTIONS(3933),
    [anon_sym_EQ] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_return] = ACTIONS(3933),
    [anon_sym_do] = ACTIONS(3933),
    [anon_sym_let] = ACTIONS(3933),
    [anon_sym_let_BANG] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3935),
    [anon_sym_null] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_COLON] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3933),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_DOT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3933),
    [anon_sym_return_BANG] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3933),
    [anon_sym_yield_BANG] = ACTIONS(3935),
    [anon_sym_lazy] = ACTIONS(3933),
    [anon_sym_assert] = ACTIONS(3933),
    [anon_sym_upcast] = ACTIONS(3933),
    [anon_sym_downcast] = ACTIONS(3933),
    [anon_sym_COLON_GT] = ACTIONS(3935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3933),
    [anon_sym_while] = ACTIONS(3933),
    [anon_sym_if] = ACTIONS(3933),
    [anon_sym_fun] = ACTIONS(3933),
    [anon_sym_try] = ACTIONS(3933),
    [anon_sym_match] = ACTIONS(3933),
    [anon_sym_match_BANG] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3933),
    [anon_sym_LT_DASH] = ACTIONS(3933),
    [anon_sym_DOT_LBRACK] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3935),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3933),
    [anon_sym_use_BANG] = ACTIONS(3935),
    [anon_sym_do_BANG] = ACTIONS(3935),
    [anon_sym_begin] = ACTIONS(3933),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3933),
    [aux_sym_char_token1] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [anon_sym_AT_DQUOTE] = ACTIONS(3935),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3935),
    [sym_bool] = ACTIONS(3933),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3933),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3935),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [anon_sym_PIPE_PIPE] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_COLON_EQ] = ACTIONS(3935),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3933),
    [sym_int] = ACTIONS(3933),
    [sym_xint] = ACTIONS(3935),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3935),
    [sym__newline] = ACTIONS(3935),
  },
  [2698] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3929),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym__pattern_param] = STATE(2783),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3713),
    [sym_long_identifier] = STATE(3663),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2698),
    [sym_block_comment] = STATE(2698),
    [sym_line_comment] = STATE(2698),
    [sym_compiler_directive_decl] = STATE(2698),
    [sym_fsi_directive_decl] = STATE(2698),
    [sym_preproc_line] = STATE(2698),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4519),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_LBRACK_LT] = ACTIONS(4523),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4519),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4519),
    [anon_sym__] = ACTIONS(4519),
    [anon_sym_QMARK] = ACTIONS(4523),
    [anon_sym_COLON_QMARK] = ACTIONS(4523),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4523),
    [anon_sym_LBRACE] = ACTIONS(4523),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4519),
    [anon_sym_DQUOTE] = ACTIONS(4519),
    [anon_sym_AT_DQUOTE] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4523),
    [sym_bool] = ACTIONS(4519),
    [sym_unit] = ACTIONS(4523),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4519),
    [sym_op_identifier] = ACTIONS(4523),
    [sym_int] = ACTIONS(4519),
    [sym_xint] = ACTIONS(4523),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2699] = {
    [sym_xml_doc] = STATE(2699),
    [sym_block_comment] = STATE(2699),
    [sym_line_comment] = STATE(2699),
    [sym_compiler_directive_decl] = STATE(2699),
    [sym_fsi_directive_decl] = STATE(2699),
    [sym_preproc_line] = STATE(2699),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(3728),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_QMARK] = ACTIONS(3726),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_AT_AT_GT] = ACTIONS(3726),
    [anon_sym_DOT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_COLON_GT] = ACTIONS(3728),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_LT_DASH] = ACTIONS(3726),
    [anon_sym_DOT_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [anon_sym_PIPE_PIPE] = ACTIONS(3726),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_COLON_EQ] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3726),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3726),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
    [sym__newline] = ACTIONS(3728),
  },
  [2700] = {
    [sym_xml_doc] = STATE(2700),
    [sym_block_comment] = STATE(2700),
    [sym_line_comment] = STATE(2700),
    [sym_compiler_directive_decl] = STATE(2700),
    [sym_fsi_directive_decl] = STATE(2700),
    [sym_preproc_line] = STATE(2700),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_GT] = ACTIONS(3620),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2701] = {
    [sym_xml_doc] = STATE(2701),
    [sym_block_comment] = STATE(2701),
    [sym_line_comment] = STATE(2701),
    [sym_compiler_directive_decl] = STATE(2701),
    [sym_fsi_directive_decl] = STATE(2701),
    [sym_preproc_line] = STATE(2701),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_GT] = ACTIONS(3624),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2702] = {
    [sym_xml_doc] = STATE(2702),
    [sym_block_comment] = STATE(2702),
    [sym_line_comment] = STATE(2702),
    [sym_compiler_directive_decl] = STATE(2702),
    [sym_fsi_directive_decl] = STATE(2702),
    [sym_preproc_line] = STATE(2702),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3638),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2703] = {
    [sym_xml_doc] = STATE(2703),
    [sym_block_comment] = STATE(2703),
    [sym_line_comment] = STATE(2703),
    [sym_compiler_directive_decl] = STATE(2703),
    [sym_fsi_directive_decl] = STATE(2703),
    [sym_preproc_line] = STATE(2703),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_GT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2704] = {
    [sym_xml_doc] = STATE(2704),
    [sym_block_comment] = STATE(2704),
    [sym_line_comment] = STATE(2704),
    [sym_compiler_directive_decl] = STATE(2704),
    [sym_fsi_directive_decl] = STATE(2704),
    [sym_preproc_line] = STATE(2704),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_QMARK] = ACTIONS(3660),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3660),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_COLON_GT] = ACTIONS(3662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3662),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_LT_DASH] = ACTIONS(3660),
    [anon_sym_DOT_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_GT] = ACTIONS(3660),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [anon_sym_LPAREN2] = ACTIONS(3662),
    [anon_sym_or] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3660),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3660),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3660),
    [anon_sym_DASH_DOT] = ACTIONS(3660),
    [anon_sym_PERCENT] = ACTIONS(3660),
    [anon_sym_AMP_AMP] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3660),
    [aux_sym_infix_op_token1] = ACTIONS(3660),
    [anon_sym_PIPE_PIPE] = ACTIONS(3660),
    [anon_sym_BANG_EQ] = ACTIONS(3660),
    [anon_sym_COLON_EQ] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3660),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3660),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
    [sym__newline] = ACTIONS(3662),
  },
  [2705] = {
    [sym_xml_doc] = STATE(2705),
    [sym_block_comment] = STATE(2705),
    [sym_line_comment] = STATE(2705),
    [sym_compiler_directive_decl] = STATE(2705),
    [sym_fsi_directive_decl] = STATE(2705),
    [sym_preproc_line] = STATE(2705),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_EQ] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_QMARK] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3656),
    [anon_sym_DOT] = ACTIONS(3656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_COLON_GT] = ACTIONS(3658),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3658),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_LT_DASH] = ACTIONS(3656),
    [anon_sym_DOT_LBRACK] = ACTIONS(3658),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_GT] = ACTIONS(3656),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(3658),
    [anon_sym_or] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3656),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3656),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3656),
    [anon_sym_DASH_DOT] = ACTIONS(3656),
    [anon_sym_PERCENT] = ACTIONS(3656),
    [anon_sym_AMP_AMP] = ACTIONS(3656),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3656),
    [aux_sym_infix_op_token1] = ACTIONS(3656),
    [anon_sym_PIPE_PIPE] = ACTIONS(3656),
    [anon_sym_BANG_EQ] = ACTIONS(3656),
    [anon_sym_COLON_EQ] = ACTIONS(3658),
    [anon_sym_DOLLAR] = ACTIONS(3656),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3656),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
    [sym__newline] = ACTIONS(3658),
  },
  [2706] = {
    [sym_xml_doc] = STATE(2706),
    [sym_block_comment] = STATE(2706),
    [sym_line_comment] = STATE(2706),
    [sym_compiler_directive_decl] = STATE(2706),
    [sym_fsi_directive_decl] = STATE(2706),
    [sym_preproc_line] = STATE(2706),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2707] = {
    [sym_xml_doc] = STATE(2707),
    [sym_block_comment] = STATE(2707),
    [sym_line_comment] = STATE(2707),
    [sym_compiler_directive_decl] = STATE(2707),
    [sym_fsi_directive_decl] = STATE(2707),
    [sym_preproc_line] = STATE(2707),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_DOT_DOT] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2708] = {
    [sym_xml_doc] = STATE(2708),
    [sym_block_comment] = STATE(2708),
    [sym_line_comment] = STATE(2708),
    [sym_compiler_directive_decl] = STATE(2708),
    [sym_fsi_directive_decl] = STATE(2708),
    [sym_preproc_line] = STATE(2708),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_QMARK] = ACTIONS(3770),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3770),
    [anon_sym_AT_AT_GT] = ACTIONS(3770),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_LT_DASH] = ACTIONS(3770),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [anon_sym_LPAREN2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3770),
    [anon_sym_DASH_DOT] = ACTIONS(3770),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3770),
    [aux_sym_infix_op_token1] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3770),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3770),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2709] = {
    [sym_xml_doc] = STATE(2709),
    [sym_block_comment] = STATE(2709),
    [sym_line_comment] = STATE(2709),
    [sym_compiler_directive_decl] = STATE(2709),
    [sym_fsi_directive_decl] = STATE(2709),
    [sym_preproc_line] = STATE(2709),
    [sym_identifier] = ACTIONS(3675),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_let_BANG] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_null] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_COLON_COLON] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_LT_AT] = ACTIONS(3675),
    [anon_sym_LT_AT_AT] = ACTIONS(3675),
    [anon_sym_AT_AT_GT] = ACTIONS(3675),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_return_BANG] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_yield_BANG] = ACTIONS(3677),
    [anon_sym_lazy] = ACTIONS(3675),
    [anon_sym_assert] = ACTIONS(3675),
    [anon_sym_upcast] = ACTIONS(3675),
    [anon_sym_downcast] = ACTIONS(3675),
    [anon_sym_COLON_GT] = ACTIONS(3677),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_fun] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_match] = ACTIONS(3675),
    [anon_sym_match_BANG] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3675),
    [anon_sym_LT_DASH] = ACTIONS(3675),
    [anon_sym_DOT_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_use] = ACTIONS(3675),
    [anon_sym_use_BANG] = ACTIONS(3677),
    [anon_sym_do_BANG] = ACTIONS(3677),
    [anon_sym_begin] = ACTIONS(3675),
    [anon_sym_LPAREN2] = ACTIONS(3677),
    [anon_sym_or] = ACTIONS(3675),
    [aux_sym_char_token1] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_AT_DQUOTE] = ACTIONS(3677),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3677),
    [sym_bool] = ACTIONS(3675),
    [sym_unit] = ACTIONS(3675),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3675),
    [sym_op_identifier] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_DOT] = ACTIONS(3675),
    [anon_sym_DASH_DOT] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [aux_sym_prefix_op_token1] = ACTIONS(3675),
    [aux_sym_infix_op_token1] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(3675),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3675),
    [sym_int] = ACTIONS(3675),
    [sym_xint] = ACTIONS(3677),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3677),
    [sym__newline] = ACTIONS(3677),
  },
  [2710] = {
    [sym_xml_doc] = STATE(2710),
    [sym_block_comment] = STATE(2710),
    [sym_line_comment] = STATE(2710),
    [sym_compiler_directive_decl] = STATE(2710),
    [sym_fsi_directive_decl] = STATE(2710),
    [sym_preproc_line] = STATE(2710),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_QMARK] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3766),
    [anon_sym_AT_AT_GT] = ACTIONS(3766),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_COLON_GT] = ACTIONS(3768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_LT_DASH] = ACTIONS(3766),
    [anon_sym_DOT_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [anon_sym_LPAREN2] = ACTIONS(3768),
    [anon_sym_or] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3766),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3766),
    [anon_sym_DASH_DOT] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3766),
    [aux_sym_infix_op_token1] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3766),
    [anon_sym_COLON_EQ] = ACTIONS(3768),
    [anon_sym_DOLLAR] = ACTIONS(3766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3766),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
    [sym__newline] = ACTIONS(3768),
  },
  [2711] = {
    [sym_xml_doc] = STATE(2711),
    [sym_block_comment] = STATE(2711),
    [sym_line_comment] = STATE(2711),
    [sym_compiler_directive_decl] = STATE(2711),
    [sym_fsi_directive_decl] = STATE(2711),
    [sym_preproc_line] = STATE(2711),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_DOT_DOT] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2712] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3491),
    [sym_function_declaration_left] = STATE(7112),
    [sym_value_declaration_left] = STATE(7112),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2712),
    [sym_block_comment] = STATE(2712),
    [sym_line_comment] = STATE(2712),
    [sym_compiler_directive_decl] = STATE(2712),
    [sym_fsi_directive_decl] = STATE(2712),
    [sym_preproc_line] = STATE(2712),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4995),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2713] = {
    [sym_xml_doc] = STATE(2713),
    [sym_block_comment] = STATE(2713),
    [sym_line_comment] = STATE(2713),
    [sym_compiler_directive_decl] = STATE(2713),
    [sym_fsi_directive_decl] = STATE(2713),
    [sym_preproc_line] = STATE(2713),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3644),
    [anon_sym_COLON] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3642),
    [anon_sym_COLON_COLON] = ACTIONS(3644),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3642),
    [anon_sym_AT_AT_GT] = ACTIONS(3642),
    [anon_sym_DOT] = ACTIONS(3642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_COLON_GT] = ACTIONS(3644),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_LT_DASH] = ACTIONS(3642),
    [anon_sym_DOT_LBRACK] = ACTIONS(3644),
    [anon_sym_LT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(3644),
    [anon_sym_or] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3642),
    [anon_sym_DASH_DOT] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3642),
    [aux_sym_infix_op_token1] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_COLON_EQ] = ACTIONS(3644),
    [anon_sym_DOLLAR] = ACTIONS(3642),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3642),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
    [sym__newline] = ACTIONS(3644),
  },
  [2714] = {
    [sym_xml_doc] = STATE(2714),
    [sym_block_comment] = STATE(2714),
    [sym_line_comment] = STATE(2714),
    [sym_compiler_directive_decl] = STATE(2714),
    [sym_fsi_directive_decl] = STATE(2714),
    [sym_preproc_line] = STATE(2714),
    [sym_identifier] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_return] = ACTIONS(3742),
    [anon_sym_do] = ACTIONS(3742),
    [anon_sym_let] = ACTIONS(3742),
    [anon_sym_let_BANG] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3742),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_null] = ACTIONS(3742),
    [anon_sym_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_COLON_COLON] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(3742),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3742),
    [anon_sym_LT_AT] = ACTIONS(3742),
    [anon_sym_LT_AT_AT] = ACTIONS(3742),
    [anon_sym_DOT] = ACTIONS(3742),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3742),
    [anon_sym_return_BANG] = ACTIONS(3744),
    [anon_sym_yield] = ACTIONS(3742),
    [anon_sym_yield_BANG] = ACTIONS(3744),
    [anon_sym_lazy] = ACTIONS(3742),
    [anon_sym_assert] = ACTIONS(3742),
    [anon_sym_upcast] = ACTIONS(3742),
    [anon_sym_downcast] = ACTIONS(3742),
    [anon_sym_COLON_GT] = ACTIONS(3744),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(3742),
    [anon_sym_if] = ACTIONS(3742),
    [anon_sym_fun] = ACTIONS(3742),
    [anon_sym_try] = ACTIONS(3742),
    [anon_sym_match] = ACTIONS(3742),
    [anon_sym_match_BANG] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3742),
    [anon_sym_LT_DASH] = ACTIONS(3742),
    [anon_sym_DOT_LBRACK] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3742),
    [anon_sym_use] = ACTIONS(3742),
    [anon_sym_use_BANG] = ACTIONS(3744),
    [anon_sym_do_BANG] = ACTIONS(3744),
    [anon_sym_begin] = ACTIONS(3742),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3742),
    [aux_sym_char_token1] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(3742),
    [anon_sym_AT_DQUOTE] = ACTIONS(3744),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3744),
    [sym_bool] = ACTIONS(3742),
    [sym_unit] = ACTIONS(3742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3742),
    [sym_op_identifier] = ACTIONS(3742),
    [anon_sym_PLUS] = ACTIONS(3742),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_PLUS_DOT] = ACTIONS(3742),
    [anon_sym_DASH_DOT] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_TILDE] = ACTIONS(3744),
    [aux_sym_prefix_op_token1] = ACTIONS(3742),
    [aux_sym_infix_op_token1] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_BANG_EQ] = ACTIONS(3742),
    [anon_sym_COLON_EQ] = ACTIONS(3744),
    [anon_sym_DOLLAR] = ACTIONS(3742),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3742),
    [sym_int] = ACTIONS(3742),
    [sym_xint] = ACTIONS(3744),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3744),
    [sym__newline] = ACTIONS(3744),
  },
  [2715] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(4930),
    [sym__function_or_value_defn_body] = STATE(4762),
    [sym_function_declaration_left] = STATE(6920),
    [sym_value_declaration_left] = STATE(6920),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2715),
    [sym_block_comment] = STATE(2715),
    [sym_line_comment] = STATE(2715),
    [sym_compiler_directive_decl] = STATE(2715),
    [sym_fsi_directive_decl] = STATE(2715),
    [sym_preproc_line] = STATE(2715),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2716] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7892),
    [sym__function_or_value_defn_body] = STATE(6447),
    [sym_function_declaration_left] = STATE(6949),
    [sym_value_declaration_left] = STATE(6949),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2716),
    [sym_block_comment] = STATE(2716),
    [sym_line_comment] = STATE(2716),
    [sym_compiler_directive_decl] = STATE(2716),
    [sym_fsi_directive_decl] = STATE(2716),
    [sym_preproc_line] = STATE(2716),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2717] = {
    [sym_xml_doc] = STATE(2717),
    [sym_block_comment] = STATE(2717),
    [sym_line_comment] = STATE(2717),
    [sym_compiler_directive_decl] = STATE(2717),
    [sym_fsi_directive_decl] = STATE(2717),
    [sym_preproc_line] = STATE(2717),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_return] = ACTIONS(3608),
    [anon_sym_do] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_let_BANG] = ACTIONS(3610),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_null] = ACTIONS(3608),
    [anon_sym_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_QMARK] = ACTIONS(3608),
    [anon_sym_COLON_COLON] = ACTIONS(3610),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3608),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3610),
    [anon_sym_LBRACE] = ACTIONS(3608),
    [anon_sym_LT_AT] = ACTIONS(3608),
    [anon_sym_LT_AT_AT] = ACTIONS(3608),
    [anon_sym_DOT] = ACTIONS(3608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3610),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_return_BANG] = ACTIONS(3610),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_yield_BANG] = ACTIONS(3610),
    [anon_sym_lazy] = ACTIONS(3608),
    [anon_sym_assert] = ACTIONS(3608),
    [anon_sym_upcast] = ACTIONS(3608),
    [anon_sym_downcast] = ACTIONS(3608),
    [anon_sym_COLON_GT] = ACTIONS(3610),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3610),
    [anon_sym_for] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_fun] = ACTIONS(3608),
    [anon_sym_try] = ACTIONS(3608),
    [anon_sym_match] = ACTIONS(3608),
    [anon_sym_match_BANG] = ACTIONS(3610),
    [anon_sym_function] = ACTIONS(3608),
    [anon_sym_LT_DASH] = ACTIONS(3608),
    [anon_sym_DOT_LBRACK] = ACTIONS(3610),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_use] = ACTIONS(3608),
    [anon_sym_use_BANG] = ACTIONS(3610),
    [anon_sym_do_BANG] = ACTIONS(3610),
    [anon_sym_begin] = ACTIONS(3608),
    [anon_sym_LPAREN2] = ACTIONS(3610),
    [anon_sym_or] = ACTIONS(3608),
    [aux_sym_char_token1] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(3608),
    [anon_sym_AT_DQUOTE] = ACTIONS(3610),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3610),
    [sym_bool] = ACTIONS(3608),
    [sym_unit] = ACTIONS(3608),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3608),
    [sym_op_identifier] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3608),
    [anon_sym_PLUS_DOT] = ACTIONS(3608),
    [anon_sym_DASH_DOT] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_AMP_AMP] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3610),
    [aux_sym_prefix_op_token1] = ACTIONS(3608),
    [aux_sym_infix_op_token1] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3608),
    [anon_sym_BANG_EQ] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3608),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3608),
    [sym_int] = ACTIONS(3608),
    [sym_xint] = ACTIONS(3610),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3610),
    [anon_sym_POUNDendif] = ACTIONS(3610),
    [sym__newline] = ACTIONS(3610),
  },
  [2718] = {
    [sym_xml_doc] = STATE(2718),
    [sym_block_comment] = STATE(2718),
    [sym_line_comment] = STATE(2718),
    [sym_compiler_directive_decl] = STATE(2718),
    [sym_fsi_directive_decl] = STATE(2718),
    [sym_preproc_line] = STATE(2718),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_GT] = ACTIONS(3616),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2719] = {
    [sym_xml_doc] = STATE(2719),
    [sym_block_comment] = STATE(2719),
    [sym_line_comment] = STATE(2719),
    [sym_compiler_directive_decl] = STATE(2719),
    [sym_fsi_directive_decl] = STATE(2719),
    [sym_preproc_line] = STATE(2719),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [anon_sym_POUNDendif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2720] = {
    [sym_xml_doc] = STATE(2720),
    [sym_block_comment] = STATE(2720),
    [sym_line_comment] = STATE(2720),
    [sym_compiler_directive_decl] = STATE(2720),
    [sym_fsi_directive_decl] = STATE(2720),
    [sym_preproc_line] = STATE(2720),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_DOT_DOT] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2721] = {
    [sym_xml_doc] = STATE(2721),
    [sym_block_comment] = STATE(2721),
    [sym_line_comment] = STATE(2721),
    [sym_compiler_directive_decl] = STATE(2721),
    [sym_fsi_directive_decl] = STATE(2721),
    [sym_preproc_line] = STATE(2721),
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_EQ] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_let_BANG] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_null] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(3816),
    [anon_sym_AMP] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_LT_AT] = ACTIONS(3814),
    [anon_sym_LT_AT_AT] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3814),
    [anon_sym_return_BANG] = ACTIONS(3816),
    [anon_sym_yield] = ACTIONS(3814),
    [anon_sym_yield_BANG] = ACTIONS(3816),
    [anon_sym_lazy] = ACTIONS(3814),
    [anon_sym_assert] = ACTIONS(3814),
    [anon_sym_upcast] = ACTIONS(3814),
    [anon_sym_downcast] = ACTIONS(3814),
    [anon_sym_COLON_GT] = ACTIONS(3816),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_fun] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_match] = ACTIONS(3814),
    [anon_sym_match_BANG] = ACTIONS(3816),
    [anon_sym_function] = ACTIONS(3814),
    [anon_sym_LT_DASH] = ACTIONS(3814),
    [anon_sym_DOT_LBRACK] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_GT] = ACTIONS(3814),
    [anon_sym_use] = ACTIONS(3814),
    [anon_sym_use_BANG] = ACTIONS(3816),
    [anon_sym_do_BANG] = ACTIONS(3816),
    [anon_sym_begin] = ACTIONS(3814),
    [anon_sym_LPAREN2] = ACTIONS(3816),
    [anon_sym_or] = ACTIONS(3814),
    [aux_sym_char_token1] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [anon_sym_AT_DQUOTE] = ACTIONS(3816),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3816),
    [sym_bool] = ACTIONS(3814),
    [sym_unit] = ACTIONS(3814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3814),
    [sym_op_identifier] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_DOT] = ACTIONS(3814),
    [anon_sym_DASH_DOT] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [aux_sym_prefix_op_token1] = ACTIONS(3814),
    [aux_sym_infix_op_token1] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3814),
    [anon_sym_COLON_EQ] = ACTIONS(3816),
    [anon_sym_DOLLAR] = ACTIONS(3814),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3814),
    [sym_int] = ACTIONS(3814),
    [sym_xint] = ACTIONS(3816),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3816),
    [sym__newline] = ACTIONS(3816),
  },
  [2722] = {
    [sym_xml_doc] = STATE(2722),
    [sym_block_comment] = STATE(2722),
    [sym_line_comment] = STATE(2722),
    [sym_compiler_directive_decl] = STATE(2722),
    [sym_fsi_directive_decl] = STATE(2722),
    [sym_preproc_line] = STATE(2722),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3712),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2723] = {
    [sym_xml_doc] = STATE(2723),
    [sym_block_comment] = STATE(2723),
    [sym_line_comment] = STATE(2723),
    [sym_compiler_directive_decl] = STATE(2723),
    [sym_fsi_directive_decl] = STATE(2723),
    [sym_preproc_line] = STATE(2723),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3746),
    [anon_sym_AT_AT_GT] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_COLON_GT] = ACTIONS(3748),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3748),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_LT_DASH] = ACTIONS(3746),
    [anon_sym_DOT_LBRACK] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [anon_sym_LPAREN2] = ACTIONS(3748),
    [anon_sym_or] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3746),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3746),
    [anon_sym_DASH_DOT] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3746),
    [aux_sym_infix_op_token1] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_COLON_EQ] = ACTIONS(3748),
    [anon_sym_DOLLAR] = ACTIONS(3746),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3746),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
    [sym__newline] = ACTIONS(3748),
  },
  [2724] = {
    [sym_xml_doc] = STATE(2724),
    [sym_block_comment] = STATE(2724),
    [sym_line_comment] = STATE(2724),
    [sym_compiler_directive_decl] = STATE(2724),
    [sym_fsi_directive_decl] = STATE(2724),
    [sym_preproc_line] = STATE(2724),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2725] = {
    [sym_xml_doc] = STATE(2725),
    [sym_block_comment] = STATE(2725),
    [sym_line_comment] = STATE(2725),
    [sym_compiler_directive_decl] = STATE(2725),
    [sym_fsi_directive_decl] = STATE(2725),
    [sym_preproc_line] = STATE(2725),
    [sym_identifier] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_return] = ACTIONS(3762),
    [anon_sym_do] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3762),
    [anon_sym_let_BANG] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_null] = ACTIONS(3762),
    [anon_sym_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_COLON_COLON] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_LT_AT] = ACTIONS(3762),
    [anon_sym_LT_AT_AT] = ACTIONS(3762),
    [anon_sym_DOT] = ACTIONS(3762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3762),
    [anon_sym_return_BANG] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3762),
    [anon_sym_yield_BANG] = ACTIONS(3764),
    [anon_sym_lazy] = ACTIONS(3762),
    [anon_sym_assert] = ACTIONS(3762),
    [anon_sym_upcast] = ACTIONS(3762),
    [anon_sym_downcast] = ACTIONS(3762),
    [anon_sym_COLON_GT] = ACTIONS(3764),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3762),
    [anon_sym_while] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3762),
    [anon_sym_fun] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3762),
    [anon_sym_match] = ACTIONS(3762),
    [anon_sym_match_BANG] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3762),
    [anon_sym_LT_DASH] = ACTIONS(3762),
    [anon_sym_DOT_LBRACK] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3764),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_use] = ACTIONS(3762),
    [anon_sym_use_BANG] = ACTIONS(3764),
    [anon_sym_do_BANG] = ACTIONS(3764),
    [anon_sym_begin] = ACTIONS(3762),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3762),
    [aux_sym_char_token1] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_AT_DQUOTE] = ACTIONS(3764),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3764),
    [sym_bool] = ACTIONS(3762),
    [sym_unit] = ACTIONS(3762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3762),
    [sym_op_identifier] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS_DOT] = ACTIONS(3762),
    [anon_sym_DASH_DOT] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3764),
    [aux_sym_prefix_op_token1] = ACTIONS(3762),
    [aux_sym_infix_op_token1] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3762),
    [anon_sym_BANG_EQ] = ACTIONS(3762),
    [anon_sym_COLON_EQ] = ACTIONS(3764),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3762),
    [sym_int] = ACTIONS(3762),
    [sym_xint] = ACTIONS(3764),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3764),
    [sym__newline] = ACTIONS(3764),
  },
  [2726] = {
    [sym_xml_doc] = STATE(2726),
    [sym_block_comment] = STATE(2726),
    [sym_line_comment] = STATE(2726),
    [sym_compiler_directive_decl] = STATE(2726),
    [sym_fsi_directive_decl] = STATE(2726),
    [sym_preproc_line] = STATE(2726),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2727] = {
    [sym_xml_doc] = STATE(2727),
    [sym_block_comment] = STATE(2727),
    [sym_line_comment] = STATE(2727),
    [sym_compiler_directive_decl] = STATE(2727),
    [sym_fsi_directive_decl] = STATE(2727),
    [sym_preproc_line] = STATE(2727),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_QMARK] = ACTIONS(3738),
    [anon_sym_COLON_COLON] = ACTIONS(3740),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3738),
    [anon_sym_AT_AT_GT] = ACTIONS(3738),
    [anon_sym_DOT] = ACTIONS(3738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_COLON_GT] = ACTIONS(3740),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_LT_DASH] = ACTIONS(3738),
    [anon_sym_DOT_LBRACK] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3740),
    [anon_sym_or] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3738),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3738),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3738),
    [anon_sym_DASH_DOT] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3738),
    [aux_sym_infix_op_token1] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [anon_sym_BANG_EQ] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOLLAR] = ACTIONS(3738),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3738),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
    [sym__newline] = ACTIONS(3740),
  },
  [2728] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(7896),
    [sym_function_declaration_left] = STATE(6949),
    [sym_value_declaration_left] = STATE(6949),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2728),
    [sym_block_comment] = STATE(2728),
    [sym_line_comment] = STATE(2728),
    [sym_compiler_directive_decl] = STATE(2728),
    [sym_fsi_directive_decl] = STATE(2728),
    [sym_preproc_line] = STATE(2728),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4997),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2729] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3528),
    [sym_function_declaration_left] = STATE(6979),
    [sym_value_declaration_left] = STATE(6979),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2729),
    [sym_block_comment] = STATE(2729),
    [sym_line_comment] = STATE(2729),
    [sym_compiler_directive_decl] = STATE(2729),
    [sym_fsi_directive_decl] = STATE(2729),
    [sym_preproc_line] = STATE(2729),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(4999),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2730] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(3533),
    [sym__function_or_value_defn_body] = STATE(3486),
    [sym_function_declaration_left] = STATE(6979),
    [sym_value_declaration_left] = STATE(6979),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2730),
    [sym_block_comment] = STATE(2730),
    [sym_line_comment] = STATE(2730),
    [sym_compiler_directive_decl] = STATE(2730),
    [sym_fsi_directive_decl] = STATE(2730),
    [sym_preproc_line] = STATE(2730),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2731] = {
    [sym_xml_doc] = STATE(2731),
    [sym_block_comment] = STATE(2731),
    [sym_line_comment] = STATE(2731),
    [sym_compiler_directive_decl] = STATE(2731),
    [sym_fsi_directive_decl] = STATE(2731),
    [sym_preproc_line] = STATE(2731),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_DOT_DOT] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2732] = {
    [sym_xml_doc] = STATE(2732),
    [sym_block_comment] = STATE(2732),
    [sym_line_comment] = STATE(2732),
    [sym_compiler_directive_decl] = STATE(2732),
    [sym_fsi_directive_decl] = STATE(2732),
    [sym_preproc_line] = STATE(2732),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2733] = {
    [sym_xml_doc] = STATE(2733),
    [sym_block_comment] = STATE(2733),
    [sym_line_comment] = STATE(2733),
    [sym_compiler_directive_decl] = STATE(2733),
    [sym_fsi_directive_decl] = STATE(2733),
    [sym_preproc_line] = STATE(2733),
    [sym_identifier] = ACTIONS(3620),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3620),
    [anon_sym_return] = ACTIONS(3620),
    [anon_sym_do] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_let_BANG] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3620),
    [anon_sym_COMMA] = ACTIONS(3622),
    [anon_sym_null] = ACTIONS(3620),
    [anon_sym_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_QMARK] = ACTIONS(3620),
    [anon_sym_COLON_COLON] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3620),
    [anon_sym_LT_AT] = ACTIONS(3620),
    [anon_sym_LT_AT_AT] = ACTIONS(3620),
    [anon_sym_DOT] = ACTIONS(3620),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_return_BANG] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_yield_BANG] = ACTIONS(3622),
    [anon_sym_lazy] = ACTIONS(3620),
    [anon_sym_assert] = ACTIONS(3620),
    [anon_sym_upcast] = ACTIONS(3620),
    [anon_sym_downcast] = ACTIONS(3620),
    [anon_sym_COLON_GT] = ACTIONS(3622),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3620),
    [anon_sym_while] = ACTIONS(3620),
    [anon_sym_if] = ACTIONS(3620),
    [anon_sym_fun] = ACTIONS(3620),
    [anon_sym_try] = ACTIONS(3620),
    [anon_sym_match] = ACTIONS(3620),
    [anon_sym_match_BANG] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3620),
    [anon_sym_LT_DASH] = ACTIONS(3620),
    [anon_sym_DOT_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_use] = ACTIONS(3620),
    [anon_sym_use_BANG] = ACTIONS(3622),
    [anon_sym_do_BANG] = ACTIONS(3622),
    [anon_sym_DOT_DOT] = ACTIONS(3622),
    [anon_sym_begin] = ACTIONS(3620),
    [anon_sym_LPAREN2] = ACTIONS(3622),
    [anon_sym_or] = ACTIONS(3620),
    [aux_sym_char_token1] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(3620),
    [anon_sym_AT_DQUOTE] = ACTIONS(3622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3622),
    [sym_bool] = ACTIONS(3620),
    [sym_unit] = ACTIONS(3620),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3620),
    [sym_op_identifier] = ACTIONS(3620),
    [anon_sym_PLUS] = ACTIONS(3620),
    [anon_sym_DASH] = ACTIONS(3620),
    [anon_sym_PLUS_DOT] = ACTIONS(3620),
    [anon_sym_DASH_DOT] = ACTIONS(3620),
    [anon_sym_PERCENT] = ACTIONS(3620),
    [anon_sym_AMP_AMP] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3622),
    [aux_sym_prefix_op_token1] = ACTIONS(3620),
    [aux_sym_infix_op_token1] = ACTIONS(3620),
    [anon_sym_PIPE_PIPE] = ACTIONS(3620),
    [anon_sym_BANG_EQ] = ACTIONS(3620),
    [anon_sym_COLON_EQ] = ACTIONS(3622),
    [anon_sym_DOLLAR] = ACTIONS(3620),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3620),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(3622),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3622),
    [sym__newline] = ACTIONS(3622),
  },
  [2734] = {
    [sym_xml_doc] = STATE(2734),
    [sym_block_comment] = STATE(2734),
    [sym_line_comment] = STATE(2734),
    [sym_compiler_directive_decl] = STATE(2734),
    [sym_fsi_directive_decl] = STATE(2734),
    [sym_preproc_line] = STATE(2734),
    [sym_identifier] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(3720),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_return] = ACTIONS(3718),
    [anon_sym_do] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_let_BANG] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_QMARK] = ACTIONS(3718),
    [anon_sym_COLON_COLON] = ACTIONS(3720),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE] = ACTIONS(3718),
    [anon_sym_LT_AT] = ACTIONS(3718),
    [anon_sym_LT_AT_AT] = ACTIONS(3718),
    [anon_sym_AT_AT_GT] = ACTIONS(3718),
    [anon_sym_DOT] = ACTIONS(3718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_return_BANG] = ACTIONS(3720),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_yield_BANG] = ACTIONS(3720),
    [anon_sym_lazy] = ACTIONS(3718),
    [anon_sym_assert] = ACTIONS(3718),
    [anon_sym_upcast] = ACTIONS(3718),
    [anon_sym_downcast] = ACTIONS(3718),
    [anon_sym_COLON_GT] = ACTIONS(3720),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3720),
    [anon_sym_for] = ACTIONS(3718),
    [anon_sym_while] = ACTIONS(3718),
    [anon_sym_if] = ACTIONS(3718),
    [anon_sym_fun] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3718),
    [anon_sym_match] = ACTIONS(3718),
    [anon_sym_match_BANG] = ACTIONS(3720),
    [anon_sym_function] = ACTIONS(3718),
    [anon_sym_LT_DASH] = ACTIONS(3718),
    [anon_sym_DOT_LBRACK] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_use] = ACTIONS(3718),
    [anon_sym_use_BANG] = ACTIONS(3720),
    [anon_sym_do_BANG] = ACTIONS(3720),
    [anon_sym_begin] = ACTIONS(3718),
    [anon_sym_LPAREN2] = ACTIONS(3720),
    [anon_sym_or] = ACTIONS(3718),
    [aux_sym_char_token1] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(3718),
    [anon_sym_AT_DQUOTE] = ACTIONS(3720),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3720),
    [sym_bool] = ACTIONS(3718),
    [sym_unit] = ACTIONS(3718),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3718),
    [sym_op_identifier] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(3718),
    [anon_sym_PLUS_DOT] = ACTIONS(3718),
    [anon_sym_DASH_DOT] = ACTIONS(3718),
    [anon_sym_PERCENT] = ACTIONS(3718),
    [anon_sym_AMP_AMP] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [aux_sym_prefix_op_token1] = ACTIONS(3718),
    [aux_sym_infix_op_token1] = ACTIONS(3718),
    [anon_sym_PIPE_PIPE] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOLLAR] = ACTIONS(3718),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3718),
    [sym_int] = ACTIONS(3718),
    [sym_xint] = ACTIONS(3720),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3720),
    [sym__newline] = ACTIONS(3720),
  },
  [2735] = {
    [sym_xml_doc] = STATE(2735),
    [sym_block_comment] = STATE(2735),
    [sym_line_comment] = STATE(2735),
    [sym_compiler_directive_decl] = STATE(2735),
    [sym_fsi_directive_decl] = STATE(2735),
    [sym_preproc_line] = STATE(2735),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_EQ] = ACTIONS(3618),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_AT_GT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3616),
    [anon_sym_DOT] = ACTIONS(3616),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_COLON_GT] = ACTIONS(3618),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_LT_DASH] = ACTIONS(3616),
    [anon_sym_DOT_LBRACK] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [anon_sym_LPAREN2] = ACTIONS(3618),
    [anon_sym_or] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3616),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3616),
    [anon_sym_DASH_DOT] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_AMP_AMP] = ACTIONS(3616),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3616),
    [aux_sym_infix_op_token1] = ACTIONS(3616),
    [anon_sym_PIPE_PIPE] = ACTIONS(3616),
    [anon_sym_BANG_EQ] = ACTIONS(3616),
    [anon_sym_COLON_EQ] = ACTIONS(3618),
    [anon_sym_DOLLAR] = ACTIONS(3616),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3616),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
    [sym__newline] = ACTIONS(3618),
  },
  [2736] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5821),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym__pattern_param] = STATE(2797),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(3944),
    [sym_format_string] = STATE(3972),
    [sym__string_literal] = STATE(3972),
    [sym_string] = STATE(3944),
    [sym_verbatim_string] = STATE(3944),
    [sym_bytearray] = STATE(3944),
    [sym_verbatim_bytearray] = STATE(3944),
    [sym_format_triple_quoted_string] = STATE(3973),
    [sym_triple_quoted_string] = STATE(3944),
    [sym_const] = STATE(3956),
    [sym_long_identifier] = STATE(3911),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(3944),
    [sym_byte] = STATE(3944),
    [sym_int16] = STATE(3944),
    [sym_uint16] = STATE(3944),
    [sym_int32] = STATE(3944),
    [sym_uint32] = STATE(3944),
    [sym_nativeint] = STATE(3944),
    [sym_unativeint] = STATE(3944),
    [sym_int64] = STATE(3944),
    [sym_uint64] = STATE(3944),
    [sym_ieee32] = STATE(3944),
    [sym_ieee64] = STATE(3944),
    [sym_bignum] = STATE(3944),
    [sym_decimal] = STATE(3944),
    [sym_float] = STATE(3759),
    [sym_xml_doc] = STATE(2736),
    [sym_block_comment] = STATE(2736),
    [sym_line_comment] = STATE(2736),
    [sym_compiler_directive_decl] = STATE(2736),
    [sym_fsi_directive_decl] = STATE(2736),
    [sym_preproc_line] = STATE(2736),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4523),
    [anon_sym_null] = ACTIONS(4790),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(4523),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_in] = ACTIONS(4519),
    [aux_sym_char_token1] = ACTIONS(4798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4800),
    [anon_sym_DQUOTE] = ACTIONS(4802),
    [anon_sym_AT_DQUOTE] = ACTIONS(4804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4808),
    [sym_bool] = ACTIONS(4810),
    [sym_unit] = ACTIONS(4812),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4818),
    [sym_xint] = ACTIONS(4820),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2737] = {
    [sym_xml_doc] = STATE(2737),
    [sym_block_comment] = STATE(2737),
    [sym_line_comment] = STATE(2737),
    [sym_compiler_directive_decl] = STATE(2737),
    [sym_fsi_directive_decl] = STATE(2737),
    [sym_preproc_line] = STATE(2737),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_GT] = ACTIONS(3774),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2738] = {
    [sym_xml_doc] = STATE(2738),
    [sym_block_comment] = STATE(2738),
    [sym_line_comment] = STATE(2738),
    [sym_compiler_directive_decl] = STATE(2738),
    [sym_fsi_directive_decl] = STATE(2738),
    [sym_preproc_line] = STATE(2738),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_GT] = ACTIONS(3581),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2739] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2739),
    [sym_block_comment] = STATE(2739),
    [sym_line_comment] = STATE(2739),
    [sym_compiler_directive_decl] = STATE(2739),
    [sym_fsi_directive_decl] = STATE(2739),
    [sym_preproc_line] = STATE(2739),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [aux_sym_access_modifier_token1] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_member] = ACTIONS(3032),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_val] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [2740] = {
    [sym_xml_doc] = STATE(2740),
    [sym_block_comment] = STATE(2740),
    [sym_line_comment] = STATE(2740),
    [sym_compiler_directive_decl] = STATE(2740),
    [sym_fsi_directive_decl] = STATE(2740),
    [sym_preproc_line] = STATE(2740),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_COLON_COLON] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_AT_GT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_DOT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_COLON_GT] = ACTIONS(3604),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_LT_DASH] = ACTIONS(3602),
    [anon_sym_DOT_LBRACK] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_COLON_EQ] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3602),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3602),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
    [sym__newline] = ACTIONS(3604),
  },
  [2741] = {
    [sym_xml_doc] = STATE(2741),
    [sym_block_comment] = STATE(2741),
    [sym_line_comment] = STATE(2741),
    [sym_compiler_directive_decl] = STATE(2741),
    [sym_fsi_directive_decl] = STATE(2741),
    [sym_preproc_line] = STATE(2741),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2742] = {
    [sym_xml_doc] = STATE(2742),
    [sym_block_comment] = STATE(2742),
    [sym_line_comment] = STATE(2742),
    [sym_compiler_directive_decl] = STATE(2742),
    [sym_fsi_directive_decl] = STATE(2742),
    [sym_preproc_line] = STATE(2742),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_EQ] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_QMARK] = ACTIONS(3598),
    [anon_sym_COLON_COLON] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_AT_GT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3598),
    [anon_sym_DOT] = ACTIONS(3598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_COLON_GT] = ACTIONS(3600),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_LT_DASH] = ACTIONS(3598),
    [anon_sym_DOT_LBRACK] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [anon_sym_LPAREN2] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3598),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3598),
    [anon_sym_DASH_DOT] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_AMP_AMP] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3598),
    [aux_sym_infix_op_token1] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3598),
    [anon_sym_BANG_EQ] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3598),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
    [sym__newline] = ACTIONS(3600),
  },
  [2743] = {
    [sym_xml_doc] = STATE(2743),
    [sym_block_comment] = STATE(2743),
    [sym_line_comment] = STATE(2743),
    [sym_compiler_directive_decl] = STATE(2743),
    [sym_fsi_directive_decl] = STATE(2743),
    [sym_preproc_line] = STATE(2743),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_COLON_COLON] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3794),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_COLON_GT] = ACTIONS(3796),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_LT_DASH] = ACTIONS(3794),
    [anon_sym_DOT_LBRACK] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_DOT_DOT] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3794),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3794),
    [anon_sym_DASH_DOT] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3794),
    [aux_sym_infix_op_token1] = ACTIONS(3794),
    [anon_sym_PIPE_PIPE] = ACTIONS(3794),
    [anon_sym_BANG_EQ] = ACTIONS(3794),
    [anon_sym_COLON_EQ] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3794),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
    [sym__newline] = ACTIONS(3796),
  },
  [2744] = {
    [sym_xml_doc] = STATE(2744),
    [sym_block_comment] = STATE(2744),
    [sym_line_comment] = STATE(2744),
    [sym_compiler_directive_decl] = STATE(2744),
    [sym_fsi_directive_decl] = STATE(2744),
    [sym_preproc_line] = STATE(2744),
    [sym_identifier] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_return] = ACTIONS(3730),
    [anon_sym_do] = ACTIONS(3730),
    [anon_sym_let] = ACTIONS(3730),
    [anon_sym_let_BANG] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_null] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_COLON_COLON] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3732),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3730),
    [anon_sym_LT_AT_AT] = ACTIONS(3730),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3732),
    [anon_sym_new] = ACTIONS(3730),
    [anon_sym_return_BANG] = ACTIONS(3732),
    [anon_sym_yield] = ACTIONS(3730),
    [anon_sym_yield_BANG] = ACTIONS(3732),
    [anon_sym_lazy] = ACTIONS(3730),
    [anon_sym_assert] = ACTIONS(3730),
    [anon_sym_upcast] = ACTIONS(3730),
    [anon_sym_downcast] = ACTIONS(3730),
    [anon_sym_COLON_GT] = ACTIONS(3732),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3732),
    [anon_sym_for] = ACTIONS(3730),
    [anon_sym_while] = ACTIONS(3730),
    [anon_sym_if] = ACTIONS(3730),
    [anon_sym_fun] = ACTIONS(3730),
    [anon_sym_try] = ACTIONS(3730),
    [anon_sym_match] = ACTIONS(3730),
    [anon_sym_match_BANG] = ACTIONS(3732),
    [anon_sym_function] = ACTIONS(3730),
    [anon_sym_LT_DASH] = ACTIONS(3730),
    [anon_sym_DOT_LBRACK] = ACTIONS(3732),
    [anon_sym_LT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3730),
    [anon_sym_use_BANG] = ACTIONS(3732),
    [anon_sym_do_BANG] = ACTIONS(3732),
    [anon_sym_begin] = ACTIONS(3730),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3730),
    [aux_sym_char_token1] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_AT_DQUOTE] = ACTIONS(3732),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3732),
    [sym_bool] = ACTIONS(3730),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3730),
    [sym_op_identifier] = ACTIONS(3730),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_PLUS_DOT] = ACTIONS(3730),
    [anon_sym_DASH_DOT] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_AMP_AMP] = ACTIONS(3730),
    [anon_sym_TILDE] = ACTIONS(3732),
    [aux_sym_prefix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [anon_sym_PIPE_PIPE] = ACTIONS(3730),
    [anon_sym_BANG_EQ] = ACTIONS(3730),
    [anon_sym_COLON_EQ] = ACTIONS(3732),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3730),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(3732),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3732),
    [anon_sym_POUNDendif] = ACTIONS(3732),
    [sym__newline] = ACTIONS(3732),
  },
  [2745] = {
    [sym_xml_doc] = STATE(2745),
    [sym_block_comment] = STATE(2745),
    [sym_line_comment] = STATE(2745),
    [sym_compiler_directive_decl] = STATE(2745),
    [sym_fsi_directive_decl] = STATE(2745),
    [sym_preproc_line] = STATE(2745),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3776),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_AT_GT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3776),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3776),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3776),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3774),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3776),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
    [sym__newline] = ACTIONS(3776),
  },
  [2746] = {
    [sym_xml_doc] = STATE(2746),
    [sym_block_comment] = STATE(2746),
    [sym_line_comment] = STATE(2746),
    [sym_compiler_directive_decl] = STATE(2746),
    [sym_fsi_directive_decl] = STATE(2746),
    [sym_preproc_line] = STATE(2746),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3583),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_QMARK] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_AT_GT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(3581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_COLON_GT] = ACTIONS(3583),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_LT_DASH] = ACTIONS(3581),
    [anon_sym_DOT_LBRACK] = ACTIONS(3583),
    [anon_sym_LT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_or] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3581),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3581),
    [anon_sym_DASH_DOT] = ACTIONS(3581),
    [anon_sym_PERCENT] = ACTIONS(3581),
    [anon_sym_AMP_AMP] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3581),
    [aux_sym_infix_op_token1] = ACTIONS(3581),
    [anon_sym_PIPE_PIPE] = ACTIONS(3581),
    [anon_sym_BANG_EQ] = ACTIONS(3581),
    [anon_sym_COLON_EQ] = ACTIONS(3583),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3581),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
    [sym__newline] = ACTIONS(3583),
  },
  [2747] = {
    [sym_xml_doc] = STATE(2747),
    [sym_block_comment] = STATE(2747),
    [sym_line_comment] = STATE(2747),
    [sym_compiler_directive_decl] = STATE(2747),
    [sym_fsi_directive_decl] = STATE(2747),
    [sym_preproc_line] = STATE(2747),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_AT_GT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3585),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_COLON_GT] = ACTIONS(3587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_LT_DASH] = ACTIONS(3585),
    [anon_sym_DOT_LBRACK] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3585),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3585),
    [anon_sym_DASH_DOT] = ACTIONS(3585),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3585),
    [aux_sym_infix_op_token1] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_COLON_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3585),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
    [sym__newline] = ACTIONS(3587),
  },
  [2748] = {
    [sym_xml_doc] = STATE(2748),
    [sym_block_comment] = STATE(2748),
    [sym_line_comment] = STATE(2748),
    [sym_compiler_directive_decl] = STATE(2748),
    [sym_fsi_directive_decl] = STATE(2748),
    [sym_preproc_line] = STATE(2748),
    [sym_identifier] = ACTIONS(3910),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_COLON] = ACTIONS(3910),
    [anon_sym_return] = ACTIONS(3910),
    [anon_sym_do] = ACTIONS(3910),
    [anon_sym_let] = ACTIONS(3910),
    [anon_sym_let_BANG] = ACTIONS(3912),
    [anon_sym_LPAREN] = ACTIONS(3910),
    [anon_sym_COMMA] = ACTIONS(3912),
    [anon_sym_null] = ACTIONS(3910),
    [anon_sym_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_QMARK] = ACTIONS(3910),
    [anon_sym_COLON_COLON] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(3910),
    [anon_sym_LBRACK] = ACTIONS(3910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3912),
    [anon_sym_LBRACE] = ACTIONS(3910),
    [anon_sym_LT_AT] = ACTIONS(3910),
    [anon_sym_LT_AT_AT] = ACTIONS(3910),
    [anon_sym_DOT] = ACTIONS(3910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3912),
    [anon_sym_new] = ACTIONS(3910),
    [anon_sym_return_BANG] = ACTIONS(3912),
    [anon_sym_yield] = ACTIONS(3910),
    [anon_sym_yield_BANG] = ACTIONS(3912),
    [anon_sym_lazy] = ACTIONS(3910),
    [anon_sym_assert] = ACTIONS(3910),
    [anon_sym_upcast] = ACTIONS(3910),
    [anon_sym_downcast] = ACTIONS(3910),
    [anon_sym_COLON_GT] = ACTIONS(3912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3912),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3910),
    [anon_sym_if] = ACTIONS(3910),
    [anon_sym_fun] = ACTIONS(3910),
    [anon_sym_try] = ACTIONS(3910),
    [anon_sym_match] = ACTIONS(3910),
    [anon_sym_match_BANG] = ACTIONS(3912),
    [anon_sym_function] = ACTIONS(3910),
    [anon_sym_LT_DASH] = ACTIONS(3910),
    [anon_sym_DOT_LBRACK] = ACTIONS(3912),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_GT] = ACTIONS(3910),
    [anon_sym_use] = ACTIONS(3910),
    [anon_sym_use_BANG] = ACTIONS(3912),
    [anon_sym_do_BANG] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3910),
    [anon_sym_LPAREN2] = ACTIONS(3912),
    [anon_sym_or] = ACTIONS(3910),
    [aux_sym_char_token1] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3910),
    [anon_sym_DQUOTE] = ACTIONS(3910),
    [anon_sym_AT_DQUOTE] = ACTIONS(3912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3912),
    [sym_bool] = ACTIONS(3910),
    [sym_unit] = ACTIONS(3910),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3910),
    [sym_op_identifier] = ACTIONS(3910),
    [anon_sym_PLUS] = ACTIONS(3910),
    [anon_sym_DASH] = ACTIONS(3910),
    [anon_sym_PLUS_DOT] = ACTIONS(3910),
    [anon_sym_DASH_DOT] = ACTIONS(3910),
    [anon_sym_PERCENT] = ACTIONS(3910),
    [anon_sym_AMP_AMP] = ACTIONS(3910),
    [anon_sym_TILDE] = ACTIONS(3912),
    [aux_sym_prefix_op_token1] = ACTIONS(3910),
    [aux_sym_infix_op_token1] = ACTIONS(3910),
    [anon_sym_PIPE_PIPE] = ACTIONS(3910),
    [anon_sym_BANG_EQ] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(3910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3910),
    [sym_int] = ACTIONS(3910),
    [sym_xint] = ACTIONS(3912),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3912),
    [sym__newline] = ACTIONS(3912),
  },
  [2749] = {
    [sym_xml_doc] = STATE(2749),
    [sym_block_comment] = STATE(2749),
    [sym_line_comment] = STATE(2749),
    [sym_compiler_directive_decl] = STATE(2749),
    [sym_fsi_directive_decl] = STATE(2749),
    [sym_preproc_line] = STATE(2749),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3923),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3923),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3923),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3923),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3923),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3921),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3923),
    [anon_sym_do_BANG] = ACTIONS(3923),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3923),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3923),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3921),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3923),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3923),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3923),
    [sym__newline] = ACTIONS(3923),
  },
  [2750] = {
    [sym_xml_doc] = STATE(2750),
    [sym_block_comment] = STATE(2750),
    [sym_line_comment] = STATE(2750),
    [sym_compiler_directive_decl] = STATE(2750),
    [sym_fsi_directive_decl] = STATE(2750),
    [sym_preproc_line] = STATE(2750),
    [sym_identifier] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3705),
    [anon_sym_do] = ACTIONS(3705),
    [anon_sym_let] = ACTIONS(3705),
    [anon_sym_let_BANG] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3707),
    [anon_sym_null] = ACTIONS(3705),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_COLON_COLON] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_LT_AT] = ACTIONS(3705),
    [anon_sym_AT_GT] = ACTIONS(3705),
    [anon_sym_LT_AT_AT] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3705),
    [anon_sym_return_BANG] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3705),
    [anon_sym_yield_BANG] = ACTIONS(3707),
    [anon_sym_lazy] = ACTIONS(3705),
    [anon_sym_assert] = ACTIONS(3705),
    [anon_sym_upcast] = ACTIONS(3705),
    [anon_sym_downcast] = ACTIONS(3705),
    [anon_sym_COLON_GT] = ACTIONS(3707),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3705),
    [anon_sym_while] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(3705),
    [anon_sym_fun] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3705),
    [anon_sym_match] = ACTIONS(3705),
    [anon_sym_match_BANG] = ACTIONS(3707),
    [anon_sym_function] = ACTIONS(3705),
    [anon_sym_LT_DASH] = ACTIONS(3705),
    [anon_sym_DOT_LBRACK] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3705),
    [anon_sym_use_BANG] = ACTIONS(3707),
    [anon_sym_do_BANG] = ACTIONS(3707),
    [anon_sym_begin] = ACTIONS(3705),
    [anon_sym_LPAREN2] = ACTIONS(3707),
    [anon_sym_or] = ACTIONS(3705),
    [aux_sym_char_token1] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_AT_DQUOTE] = ACTIONS(3707),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3707),
    [sym_bool] = ACTIONS(3705),
    [sym_unit] = ACTIONS(3705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3705),
    [sym_op_identifier] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_DOT] = ACTIONS(3705),
    [anon_sym_DASH_DOT] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3707),
    [aux_sym_prefix_op_token1] = ACTIONS(3705),
    [aux_sym_infix_op_token1] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_COLON_EQ] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3705),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3705),
    [sym_int] = ACTIONS(3705),
    [sym_xint] = ACTIONS(3707),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3707),
    [sym__newline] = ACTIONS(3707),
  },
  [2751] = {
    [sym_xml_doc] = STATE(2751),
    [sym_block_comment] = STATE(2751),
    [sym_line_comment] = STATE(2751),
    [sym_compiler_directive_decl] = STATE(2751),
    [sym_fsi_directive_decl] = STATE(2751),
    [sym_preproc_line] = STATE(2751),
    [sym_identifier] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_return] = ACTIONS(3624),
    [anon_sym_do] = ACTIONS(3624),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_let_BANG] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_COMMA] = ACTIONS(3626),
    [anon_sym_null] = ACTIONS(3624),
    [anon_sym_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_COLON_COLON] = ACTIONS(3626),
    [anon_sym_AMP] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(3624),
    [anon_sym_LT_AT] = ACTIONS(3624),
    [anon_sym_LT_AT_AT] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(3624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3624),
    [anon_sym_return_BANG] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3624),
    [anon_sym_yield_BANG] = ACTIONS(3626),
    [anon_sym_lazy] = ACTIONS(3624),
    [anon_sym_assert] = ACTIONS(3624),
    [anon_sym_upcast] = ACTIONS(3624),
    [anon_sym_downcast] = ACTIONS(3624),
    [anon_sym_COLON_GT] = ACTIONS(3626),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3626),
    [anon_sym_for] = ACTIONS(3624),
    [anon_sym_while] = ACTIONS(3624),
    [anon_sym_if] = ACTIONS(3624),
    [anon_sym_fun] = ACTIONS(3624),
    [anon_sym_try] = ACTIONS(3624),
    [anon_sym_match] = ACTIONS(3624),
    [anon_sym_match_BANG] = ACTIONS(3626),
    [anon_sym_function] = ACTIONS(3624),
    [anon_sym_LT_DASH] = ACTIONS(3624),
    [anon_sym_DOT_LBRACK] = ACTIONS(3626),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_use] = ACTIONS(3624),
    [anon_sym_use_BANG] = ACTIONS(3626),
    [anon_sym_do_BANG] = ACTIONS(3626),
    [anon_sym_DOT_DOT] = ACTIONS(3626),
    [anon_sym_begin] = ACTIONS(3624),
    [anon_sym_LPAREN2] = ACTIONS(3626),
    [anon_sym_or] = ACTIONS(3624),
    [aux_sym_char_token1] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_AT_DQUOTE] = ACTIONS(3626),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3626),
    [sym_bool] = ACTIONS(3624),
    [sym_unit] = ACTIONS(3624),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3624),
    [sym_op_identifier] = ACTIONS(3624),
    [anon_sym_PLUS] = ACTIONS(3624),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_PLUS_DOT] = ACTIONS(3624),
    [anon_sym_DASH_DOT] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_AMP_AMP] = ACTIONS(3624),
    [anon_sym_TILDE] = ACTIONS(3626),
    [aux_sym_prefix_op_token1] = ACTIONS(3624),
    [aux_sym_infix_op_token1] = ACTIONS(3624),
    [anon_sym_PIPE_PIPE] = ACTIONS(3624),
    [anon_sym_BANG_EQ] = ACTIONS(3624),
    [anon_sym_COLON_EQ] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3624),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3624),
    [sym_int] = ACTIONS(3624),
    [sym_xint] = ACTIONS(3626),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3626),
    [sym__newline] = ACTIONS(3626),
  },
  [2752] = {
    [sym_xml_doc] = STATE(2752),
    [sym_block_comment] = STATE(2752),
    [sym_line_comment] = STATE(2752),
    [sym_compiler_directive_decl] = STATE(2752),
    [sym_fsi_directive_decl] = STATE(2752),
    [sym_preproc_line] = STATE(2752),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_return] = ACTIONS(3929),
    [anon_sym_do] = ACTIONS(3929),
    [anon_sym_let] = ACTIONS(3929),
    [anon_sym_let_BANG] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_null] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3929),
    [anon_sym_COLON_COLON] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3929),
    [anon_sym_LT_AT_AT] = ACTIONS(3929),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3929),
    [anon_sym_return_BANG] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3929),
    [anon_sym_yield_BANG] = ACTIONS(3931),
    [anon_sym_lazy] = ACTIONS(3929),
    [anon_sym_assert] = ACTIONS(3929),
    [anon_sym_upcast] = ACTIONS(3929),
    [anon_sym_downcast] = ACTIONS(3929),
    [anon_sym_COLON_GT] = ACTIONS(3931),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3929),
    [anon_sym_while] = ACTIONS(3929),
    [anon_sym_if] = ACTIONS(3929),
    [anon_sym_fun] = ACTIONS(3929),
    [anon_sym_try] = ACTIONS(3929),
    [anon_sym_match] = ACTIONS(3929),
    [anon_sym_match_BANG] = ACTIONS(3931),
    [anon_sym_function] = ACTIONS(3929),
    [anon_sym_LT_DASH] = ACTIONS(3929),
    [anon_sym_DOT_LBRACK] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3929),
    [anon_sym_use_BANG] = ACTIONS(3931),
    [anon_sym_do_BANG] = ACTIONS(3931),
    [anon_sym_begin] = ACTIONS(3929),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3929),
    [aux_sym_char_token1] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [anon_sym_AT_DQUOTE] = ACTIONS(3931),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3931),
    [sym_bool] = ACTIONS(3929),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3929),
    [sym_op_identifier] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_DOT] = ACTIONS(3929),
    [anon_sym_DASH_DOT] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3931),
    [aux_sym_prefix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_COLON_EQ] = ACTIONS(3931),
    [anon_sym_DOLLAR] = ACTIONS(3929),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3929),
    [sym_int] = ACTIONS(3929),
    [sym_xint] = ACTIONS(3931),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3931),
    [sym__newline] = ACTIONS(3931),
  },
  [2753] = {
    [sym_xml_doc] = STATE(2753),
    [sym_block_comment] = STATE(2753),
    [sym_line_comment] = STATE(2753),
    [sym_compiler_directive_decl] = STATE(2753),
    [sym_fsi_directive_decl] = STATE(2753),
    [sym_preproc_line] = STATE(2753),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_DOT_DOT] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2754] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7174),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2754),
    [sym_block_comment] = STATE(2754),
    [sym_line_comment] = STATE(2754),
    [sym_compiler_directive_decl] = STATE(2754),
    [sym_fsi_directive_decl] = STATE(2754),
    [sym_preproc_line] = STATE(2754),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2755] = {
    [sym_xml_doc] = STATE(2755),
    [sym_block_comment] = STATE(2755),
    [sym_line_comment] = STATE(2755),
    [sym_compiler_directive_decl] = STATE(2755),
    [sym_fsi_directive_decl] = STATE(2755),
    [sym_preproc_line] = STATE(2755),
    [sym_identifier] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3937),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_let_BANG] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_null] = ACTIONS(3937),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_COLON_COLON] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_LT_AT] = ACTIONS(3937),
    [anon_sym_LT_AT_AT] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_return_BANG] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_yield_BANG] = ACTIONS(3939),
    [anon_sym_lazy] = ACTIONS(3937),
    [anon_sym_assert] = ACTIONS(3937),
    [anon_sym_upcast] = ACTIONS(3937),
    [anon_sym_downcast] = ACTIONS(3937),
    [anon_sym_COLON_GT] = ACTIONS(3939),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3939),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_fun] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_match] = ACTIONS(3937),
    [anon_sym_match_BANG] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3937),
    [anon_sym_LT_DASH] = ACTIONS(3937),
    [anon_sym_DOT_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_use] = ACTIONS(3937),
    [anon_sym_use_BANG] = ACTIONS(3939),
    [anon_sym_do_BANG] = ACTIONS(3939),
    [anon_sym_begin] = ACTIONS(3937),
    [anon_sym_LPAREN2] = ACTIONS(3939),
    [anon_sym_or] = ACTIONS(3937),
    [aux_sym_char_token1] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_AT_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3939),
    [sym_bool] = ACTIONS(3937),
    [sym_unit] = ACTIONS(3937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3937),
    [sym_op_identifier] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_DOT] = ACTIONS(3937),
    [anon_sym_DASH_DOT] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [aux_sym_prefix_op_token1] = ACTIONS(3937),
    [aux_sym_infix_op_token1] = ACTIONS(3937),
    [anon_sym_PIPE_PIPE] = ACTIONS(3937),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_COLON_EQ] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3937),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3937),
    [sym_int] = ACTIONS(3937),
    [sym_xint] = ACTIONS(3939),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3939),
    [sym__newline] = ACTIONS(3939),
  },
  [2756] = {
    [sym_xml_doc] = STATE(2756),
    [sym_block_comment] = STATE(2756),
    [sym_line_comment] = STATE(2756),
    [sym_compiler_directive_decl] = STATE(2756),
    [sym_fsi_directive_decl] = STATE(2756),
    [sym_preproc_line] = STATE(2756),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_let_BANG] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_null] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3979),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_LT_AT] = ACTIONS(3977),
    [anon_sym_LT_AT_AT] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3977),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3979),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_return_BANG] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_yield_BANG] = ACTIONS(3979),
    [anon_sym_lazy] = ACTIONS(3977),
    [anon_sym_assert] = ACTIONS(3977),
    [anon_sym_upcast] = ACTIONS(3977),
    [anon_sym_downcast] = ACTIONS(3977),
    [anon_sym_COLON_GT] = ACTIONS(3979),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3979),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_fun] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_match_BANG] = ACTIONS(3979),
    [anon_sym_function] = ACTIONS(3977),
    [anon_sym_LT_DASH] = ACTIONS(3977),
    [anon_sym_DOT_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_use_BANG] = ACTIONS(3979),
    [anon_sym_do_BANG] = ACTIONS(3979),
    [anon_sym_begin] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_or] = ACTIONS(3977),
    [aux_sym_char_token1] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_AT_DQUOTE] = ACTIONS(3979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3979),
    [sym_bool] = ACTIONS(3977),
    [sym_unit] = ACTIONS(3977),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3977),
    [sym_op_identifier] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS_DOT] = ACTIONS(3977),
    [anon_sym_DASH_DOT] = ACTIONS(3977),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_AMP_AMP] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [aux_sym_prefix_op_token1] = ACTIONS(3977),
    [aux_sym_infix_op_token1] = ACTIONS(3977),
    [anon_sym_PIPE_PIPE] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_COLON_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(3977),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3977),
    [sym_int] = ACTIONS(3977),
    [sym_xint] = ACTIONS(3979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3979),
    [sym__newline] = ACTIONS(3979),
  },
  [2757] = {
    [sym_xml_doc] = STATE(2757),
    [sym_block_comment] = STATE(2757),
    [sym_line_comment] = STATE(2757),
    [sym_compiler_directive_decl] = STATE(2757),
    [sym_fsi_directive_decl] = STATE(2757),
    [sym_preproc_line] = STATE(2757),
    [sym_identifier] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_let_BANG] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_null] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_QMARK] = ACTIONS(3973),
    [anon_sym_COLON_COLON] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3975),
    [anon_sym_LBRACE] = ACTIONS(3973),
    [anon_sym_LT_AT] = ACTIONS(3973),
    [anon_sym_LT_AT_AT] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3975),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_return_BANG] = ACTIONS(3975),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_yield_BANG] = ACTIONS(3975),
    [anon_sym_lazy] = ACTIONS(3973),
    [anon_sym_assert] = ACTIONS(3973),
    [anon_sym_upcast] = ACTIONS(3973),
    [anon_sym_downcast] = ACTIONS(3973),
    [anon_sym_COLON_GT] = ACTIONS(3975),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_fun] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_match] = ACTIONS(3973),
    [anon_sym_match_BANG] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3973),
    [anon_sym_LT_DASH] = ACTIONS(3973),
    [anon_sym_DOT_LBRACK] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3973),
    [anon_sym_use] = ACTIONS(3973),
    [anon_sym_use_BANG] = ACTIONS(3975),
    [anon_sym_do_BANG] = ACTIONS(3975),
    [anon_sym_begin] = ACTIONS(3973),
    [anon_sym_LPAREN2] = ACTIONS(3975),
    [anon_sym_or] = ACTIONS(3973),
    [aux_sym_char_token1] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3973),
    [anon_sym_AT_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3975),
    [sym_bool] = ACTIONS(3973),
    [sym_unit] = ACTIONS(3973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3973),
    [sym_op_identifier] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_PLUS_DOT] = ACTIONS(3973),
    [anon_sym_DASH_DOT] = ACTIONS(3973),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_AMP_AMP] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [aux_sym_prefix_op_token1] = ACTIONS(3973),
    [aux_sym_infix_op_token1] = ACTIONS(3973),
    [anon_sym_PIPE_PIPE] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_COLON_EQ] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3973),
    [sym_int] = ACTIONS(3973),
    [sym_xint] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3975),
    [sym__newline] = ACTIONS(3975),
  },
  [2758] = {
    [sym_xml_doc] = STATE(2758),
    [sym_block_comment] = STATE(2758),
    [sym_line_comment] = STATE(2758),
    [sym_compiler_directive_decl] = STATE(2758),
    [sym_fsi_directive_decl] = STATE(2758),
    [sym_preproc_line] = STATE(2758),
    [sym_identifier] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_let_BANG] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_null] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_QMARK] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_LT_AT] = ACTIONS(3969),
    [anon_sym_LT_AT_AT] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_return_BANG] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_yield_BANG] = ACTIONS(3971),
    [anon_sym_lazy] = ACTIONS(3969),
    [anon_sym_assert] = ACTIONS(3969),
    [anon_sym_upcast] = ACTIONS(3969),
    [anon_sym_downcast] = ACTIONS(3969),
    [anon_sym_COLON_GT] = ACTIONS(3971),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_fun] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_match] = ACTIONS(3969),
    [anon_sym_match_BANG] = ACTIONS(3971),
    [anon_sym_function] = ACTIONS(3969),
    [anon_sym_LT_DASH] = ACTIONS(3969),
    [anon_sym_DOT_LBRACK] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3969),
    [anon_sym_use] = ACTIONS(3969),
    [anon_sym_use_BANG] = ACTIONS(3971),
    [anon_sym_do_BANG] = ACTIONS(3971),
    [anon_sym_begin] = ACTIONS(3969),
    [anon_sym_LPAREN2] = ACTIONS(3971),
    [anon_sym_or] = ACTIONS(3969),
    [aux_sym_char_token1] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_AT_DQUOTE] = ACTIONS(3971),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3971),
    [sym_bool] = ACTIONS(3969),
    [sym_unit] = ACTIONS(3969),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3969),
    [sym_op_identifier] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_DOT] = ACTIONS(3969),
    [anon_sym_DASH_DOT] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [aux_sym_prefix_op_token1] = ACTIONS(3969),
    [aux_sym_infix_op_token1] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3969),
    [anon_sym_COLON_EQ] = ACTIONS(3971),
    [anon_sym_DOLLAR] = ACTIONS(3969),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3969),
    [sym_int] = ACTIONS(3969),
    [sym_xint] = ACTIONS(3971),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3971),
    [sym__newline] = ACTIONS(3971),
  },
  [2759] = {
    [sym_xml_doc] = STATE(2759),
    [sym_block_comment] = STATE(2759),
    [sym_line_comment] = STATE(2759),
    [sym_compiler_directive_decl] = STATE(2759),
    [sym_fsi_directive_decl] = STATE(2759),
    [sym_preproc_line] = STATE(2759),
    [sym_identifier] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_let_BANG] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_null] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_COLON_COLON] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_LT_AT] = ACTIONS(3965),
    [anon_sym_LT_AT_AT] = ACTIONS(3965),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_return_BANG] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_yield_BANG] = ACTIONS(3967),
    [anon_sym_lazy] = ACTIONS(3965),
    [anon_sym_assert] = ACTIONS(3965),
    [anon_sym_upcast] = ACTIONS(3965),
    [anon_sym_downcast] = ACTIONS(3965),
    [anon_sym_COLON_GT] = ACTIONS(3967),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_fun] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_match] = ACTIONS(3965),
    [anon_sym_match_BANG] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3965),
    [anon_sym_LT_DASH] = ACTIONS(3965),
    [anon_sym_DOT_LBRACK] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3965),
    [anon_sym_use] = ACTIONS(3965),
    [anon_sym_use_BANG] = ACTIONS(3967),
    [anon_sym_do_BANG] = ACTIONS(3967),
    [anon_sym_begin] = ACTIONS(3965),
    [anon_sym_LPAREN2] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3965),
    [aux_sym_char_token1] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [anon_sym_AT_DQUOTE] = ACTIONS(3967),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3967),
    [sym_bool] = ACTIONS(3965),
    [sym_unit] = ACTIONS(3965),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3965),
    [sym_op_identifier] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_DOT] = ACTIONS(3965),
    [anon_sym_DASH_DOT] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [aux_sym_prefix_op_token1] = ACTIONS(3965),
    [aux_sym_infix_op_token1] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_COLON_EQ] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(3965),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3965),
    [sym_int] = ACTIONS(3965),
    [sym_xint] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3967),
    [sym__newline] = ACTIONS(3967),
  },
  [2760] = {
    [sym_xml_doc] = STATE(2760),
    [sym_block_comment] = STATE(2760),
    [sym_line_comment] = STATE(2760),
    [sym_compiler_directive_decl] = STATE(2760),
    [sym_fsi_directive_decl] = STATE(2760),
    [sym_preproc_line] = STATE(2760),
    [sym_identifier] = ACTIONS(3961),
    [anon_sym_EQ] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_let_BANG] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_null] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_QMARK] = ACTIONS(3961),
    [anon_sym_COLON_COLON] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3961),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_LT_AT] = ACTIONS(3961),
    [anon_sym_LT_AT_AT] = ACTIONS(3961),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_return_BANG] = ACTIONS(3963),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_yield_BANG] = ACTIONS(3963),
    [anon_sym_lazy] = ACTIONS(3961),
    [anon_sym_assert] = ACTIONS(3961),
    [anon_sym_upcast] = ACTIONS(3961),
    [anon_sym_downcast] = ACTIONS(3961),
    [anon_sym_COLON_GT] = ACTIONS(3963),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_fun] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_match] = ACTIONS(3961),
    [anon_sym_match_BANG] = ACTIONS(3963),
    [anon_sym_function] = ACTIONS(3961),
    [anon_sym_LT_DASH] = ACTIONS(3961),
    [anon_sym_DOT_LBRACK] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_use] = ACTIONS(3961),
    [anon_sym_use_BANG] = ACTIONS(3963),
    [anon_sym_do_BANG] = ACTIONS(3963),
    [anon_sym_begin] = ACTIONS(3961),
    [anon_sym_LPAREN2] = ACTIONS(3963),
    [anon_sym_or] = ACTIONS(3961),
    [aux_sym_char_token1] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3961),
    [anon_sym_AT_DQUOTE] = ACTIONS(3963),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3963),
    [sym_bool] = ACTIONS(3961),
    [sym_unit] = ACTIONS(3961),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3961),
    [sym_op_identifier] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_PLUS_DOT] = ACTIONS(3961),
    [anon_sym_DASH_DOT] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [aux_sym_prefix_op_token1] = ACTIONS(3961),
    [aux_sym_infix_op_token1] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_COLON_EQ] = ACTIONS(3963),
    [anon_sym_DOLLAR] = ACTIONS(3961),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3961),
    [sym_int] = ACTIONS(3961),
    [sym_xint] = ACTIONS(3963),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3963),
    [sym__newline] = ACTIONS(3963),
  },
  [2761] = {
    [sym_xml_doc] = STATE(2761),
    [sym_block_comment] = STATE(2761),
    [sym_line_comment] = STATE(2761),
    [sym_compiler_directive_decl] = STATE(2761),
    [sym_fsi_directive_decl] = STATE(2761),
    [sym_preproc_line] = STATE(2761),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3638),
    [anon_sym_return] = ACTIONS(3638),
    [anon_sym_do] = ACTIONS(3638),
    [anon_sym_let] = ACTIONS(3638),
    [anon_sym_let_BANG] = ACTIONS(3640),
    [anon_sym_LPAREN] = ACTIONS(3638),
    [anon_sym_COMMA] = ACTIONS(3640),
    [anon_sym_null] = ACTIONS(3638),
    [anon_sym_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_QMARK] = ACTIONS(3638),
    [anon_sym_COLON_COLON] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3638),
    [anon_sym_LBRACK] = ACTIONS(3638),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3638),
    [anon_sym_LT_AT] = ACTIONS(3638),
    [anon_sym_LT_AT_AT] = ACTIONS(3638),
    [anon_sym_DOT] = ACTIONS(3638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3638),
    [anon_sym_return_BANG] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3638),
    [anon_sym_yield_BANG] = ACTIONS(3640),
    [anon_sym_lazy] = ACTIONS(3638),
    [anon_sym_assert] = ACTIONS(3638),
    [anon_sym_upcast] = ACTIONS(3638),
    [anon_sym_downcast] = ACTIONS(3638),
    [anon_sym_COLON_GT] = ACTIONS(3640),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3640),
    [anon_sym_for] = ACTIONS(3638),
    [anon_sym_while] = ACTIONS(3638),
    [anon_sym_if] = ACTIONS(3638),
    [anon_sym_fun] = ACTIONS(3638),
    [anon_sym_try] = ACTIONS(3638),
    [anon_sym_match] = ACTIONS(3638),
    [anon_sym_match_BANG] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3638),
    [anon_sym_LT_DASH] = ACTIONS(3638),
    [anon_sym_DOT_LBRACK] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_use] = ACTIONS(3638),
    [anon_sym_use_BANG] = ACTIONS(3640),
    [anon_sym_do_BANG] = ACTIONS(3640),
    [anon_sym_DOT_DOT] = ACTIONS(3640),
    [anon_sym_begin] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(3640),
    [anon_sym_or] = ACTIONS(3638),
    [aux_sym_char_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(3638),
    [anon_sym_AT_DQUOTE] = ACTIONS(3640),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3640),
    [sym_bool] = ACTIONS(3638),
    [sym_unit] = ACTIONS(3638),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3638),
    [sym_op_identifier] = ACTIONS(3638),
    [anon_sym_PLUS] = ACTIONS(3638),
    [anon_sym_DASH] = ACTIONS(3638),
    [anon_sym_PLUS_DOT] = ACTIONS(3638),
    [anon_sym_DASH_DOT] = ACTIONS(3638),
    [anon_sym_PERCENT] = ACTIONS(3638),
    [anon_sym_AMP_AMP] = ACTIONS(3638),
    [anon_sym_TILDE] = ACTIONS(3640),
    [aux_sym_prefix_op_token1] = ACTIONS(3638),
    [aux_sym_infix_op_token1] = ACTIONS(3638),
    [anon_sym_PIPE_PIPE] = ACTIONS(3638),
    [anon_sym_BANG_EQ] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3638),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3638),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(3640),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3640),
    [sym__newline] = ACTIONS(3640),
  },
  [2762] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2762),
    [sym_block_comment] = STATE(2762),
    [sym_line_comment] = STATE(2762),
    [sym_compiler_directive_decl] = STATE(2762),
    [sym_fsi_directive_decl] = STATE(2762),
    [sym_preproc_line] = STATE(2762),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_open] = ACTIONS(3012),
    [anon_sym_LBRACK_LT] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [aux_sym_access_modifier_token1] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_member] = ACTIONS(3012),
    [anon_sym_interface] = ACTIONS(3012),
    [anon_sym_abstract] = ACTIONS(3012),
    [anon_sym_override] = ACTIONS(3012),
    [anon_sym_val] = ACTIONS(3012),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3010),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3010),
    [anon_sym_DASH_DOT] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3010),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3010),
    [anon_sym_POUNDload] = ACTIONS(3010),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__dedent] = ACTIONS(3010),
  },
  [2763] = {
    [sym_xml_doc] = STATE(2763),
    [sym_block_comment] = STATE(2763),
    [sym_line_comment] = STATE(2763),
    [sym_compiler_directive_decl] = STATE(2763),
    [sym_fsi_directive_decl] = STATE(2763),
    [sym_preproc_line] = STATE(2763),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2764] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(4934),
    [sym_function_declaration_left] = STATE(6920),
    [sym_value_declaration_left] = STATE(6920),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2764),
    [sym_block_comment] = STATE(2764),
    [sym_line_comment] = STATE(2764),
    [sym_compiler_directive_decl] = STATE(2764),
    [sym_fsi_directive_decl] = STATE(2764),
    [sym_preproc_line] = STATE(2764),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_rec] = ACTIONS(5005),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2765] = {
    [sym_xml_doc] = STATE(2765),
    [sym_block_comment] = STATE(2765),
    [sym_line_comment] = STATE(2765),
    [sym_compiler_directive_decl] = STATE(2765),
    [sym_fsi_directive_decl] = STATE(2765),
    [sym_preproc_line] = STATE(2765),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_let] = ACTIONS(3646),
    [anon_sym_let_BANG] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_null] = ACTIONS(3646),
    [anon_sym_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_QMARK] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3646),
    [anon_sym_LT_AT_AT] = ACTIONS(3646),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_return_BANG] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_yield_BANG] = ACTIONS(3648),
    [anon_sym_lazy] = ACTIONS(3646),
    [anon_sym_assert] = ACTIONS(3646),
    [anon_sym_upcast] = ACTIONS(3646),
    [anon_sym_downcast] = ACTIONS(3646),
    [anon_sym_COLON_GT] = ACTIONS(3648),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_fun] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_match] = ACTIONS(3646),
    [anon_sym_match_BANG] = ACTIONS(3648),
    [anon_sym_function] = ACTIONS(3646),
    [anon_sym_LT_DASH] = ACTIONS(3646),
    [anon_sym_DOT_LBRACK] = ACTIONS(3648),
    [anon_sym_LT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3646),
    [anon_sym_use_BANG] = ACTIONS(3648),
    [anon_sym_do_BANG] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3648),
    [anon_sym_begin] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3646),
    [aux_sym_char_token1] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE] = ACTIONS(3646),
    [anon_sym_AT_DQUOTE] = ACTIONS(3648),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3648),
    [sym_bool] = ACTIONS(3646),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3646),
    [sym_op_identifier] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS_DOT] = ACTIONS(3646),
    [anon_sym_DASH_DOT] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_TILDE] = ACTIONS(3648),
    [aux_sym_prefix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3646),
    [anon_sym_COLON_EQ] = ACTIONS(3648),
    [anon_sym_DOLLAR] = ACTIONS(3646),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3646),
    [sym_int] = ACTIONS(3646),
    [sym_xint] = ACTIONS(3648),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3648),
    [sym__newline] = ACTIONS(3648),
  },
  [2766] = {
    [sym_xml_doc] = STATE(2766),
    [sym_block_comment] = STATE(2766),
    [sym_line_comment] = STATE(2766),
    [sym_compiler_directive_decl] = STATE(2766),
    [sym_fsi_directive_decl] = STATE(2766),
    [sym_preproc_line] = STATE(2766),
    [sym_identifier] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3859),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3859),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3859),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_QMARK] = ACTIONS(3859),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_LT_AT] = ACTIONS(3859),
    [anon_sym_AT_GT] = ACTIONS(3859),
    [anon_sym_LT_AT_AT] = ACTIONS(3859),
    [anon_sym_DOT] = ACTIONS(3859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3859),
    [anon_sym_assert] = ACTIONS(3859),
    [anon_sym_upcast] = ACTIONS(3859),
    [anon_sym_downcast] = ACTIONS(3859),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_fun] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_match] = ACTIONS(3859),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3859),
    [anon_sym_LT_DASH] = ACTIONS(3859),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3859),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3859),
    [anon_sym_LPAREN2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3859),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3859),
    [sym_unit] = ACTIONS(3859),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3859),
    [sym_op_identifier] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_DOT] = ACTIONS(3859),
    [anon_sym_DASH_DOT] = ACTIONS(3859),
    [anon_sym_PERCENT] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3859),
    [aux_sym_infix_op_token1] = ACTIONS(3859),
    [anon_sym_PIPE_PIPE] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3859),
    [sym_int] = ACTIONS(3859),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2767] = {
    [sym_xml_doc] = STATE(2767),
    [sym_block_comment] = STATE(2767),
    [sym_line_comment] = STATE(2767),
    [sym_compiler_directive_decl] = STATE(2767),
    [sym_fsi_directive_decl] = STATE(2767),
    [sym_preproc_line] = STATE(2767),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2768] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defns] = STATE(7254),
    [sym__function_or_value_defn_body] = STATE(6403),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2768),
    [sym_block_comment] = STATE(2768),
    [sym_line_comment] = STATE(2768),
    [sym_compiler_directive_decl] = STATE(2768),
    [sym_fsi_directive_decl] = STATE(2768),
    [sym_preproc_line] = STATE(2768),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2769] = {
    [sym_xml_doc] = STATE(2769),
    [sym_block_comment] = STATE(2769),
    [sym_line_comment] = STATE(2769),
    [sym_compiler_directive_decl] = STATE(2769),
    [sym_fsi_directive_decl] = STATE(2769),
    [sym_preproc_line] = STATE(2769),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_let_BANG] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_LT_AT] = ACTIONS(3314),
    [anon_sym_LT_AT_AT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(4234),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_return_BANG] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_yield_BANG] = ACTIONS(3312),
    [anon_sym_lazy] = ACTIONS(3314),
    [anon_sym_assert] = ACTIONS(3314),
    [anon_sym_upcast] = ACTIONS(3314),
    [anon_sym_downcast] = ACTIONS(3314),
    [anon_sym_COLON_GT] = ACTIONS(3312),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_fun] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_match] = ACTIONS(3314),
    [anon_sym_match_BANG] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_LT_DASH] = ACTIONS(3314),
    [anon_sym_DOT_LBRACK] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_use] = ACTIONS(3314),
    [anon_sym_use_BANG] = ACTIONS(3312),
    [anon_sym_do_BANG] = ACTIONS(3312),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_begin] = ACTIONS(3314),
    [anon_sym_LPAREN2] = ACTIONS(3312),
    [anon_sym_or] = ACTIONS(3314),
    [aux_sym_char_token1] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_AT_DQUOTE] = ACTIONS(3312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3312),
    [sym_bool] = ACTIONS(3314),
    [sym_unit] = ACTIONS(3314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_PLUS_DOT] = ACTIONS(3314),
    [anon_sym_DASH_DOT] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3312),
    [aux_sym_prefix_op_token1] = ACTIONS(3314),
    [aux_sym_infix_op_token1] = ACTIONS(3314),
    [anon_sym_PIPE_PIPE] = ACTIONS(3314),
    [anon_sym_BANG_EQ] = ACTIONS(3314),
    [anon_sym_COLON_EQ] = ACTIONS(3312),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3314),
    [sym_int] = ACTIONS(3314),
    [sym_xint] = ACTIONS(3312),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3312),
    [sym__newline] = ACTIONS(3312),
  },
  [2770] = {
    [sym_xml_doc] = STATE(2770),
    [sym_block_comment] = STATE(2770),
    [sym_line_comment] = STATE(2770),
    [sym_compiler_directive_decl] = STATE(2770),
    [sym_fsi_directive_decl] = STATE(2770),
    [sym_preproc_line] = STATE(2770),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_DOT_DOT] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2771] = {
    [sym_xml_doc] = STATE(2771),
    [sym_block_comment] = STATE(2771),
    [sym_line_comment] = STATE(2771),
    [sym_compiler_directive_decl] = STATE(2771),
    [sym_fsi_directive_decl] = STATE(2771),
    [sym_preproc_line] = STATE(2771),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_return] = ACTIONS(3712),
    [anon_sym_do] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_let_BANG] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_null] = ACTIONS(3712),
    [anon_sym_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LT_AT] = ACTIONS(3712),
    [anon_sym_LT_AT_AT] = ACTIONS(3712),
    [anon_sym_AT_AT_GT] = ACTIONS(3712),
    [anon_sym_DOT] = ACTIONS(3712),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3714),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_return_BANG] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_yield_BANG] = ACTIONS(3714),
    [anon_sym_lazy] = ACTIONS(3712),
    [anon_sym_assert] = ACTIONS(3712),
    [anon_sym_upcast] = ACTIONS(3712),
    [anon_sym_downcast] = ACTIONS(3712),
    [anon_sym_COLON_GT] = ACTIONS(3714),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3712),
    [anon_sym_while] = ACTIONS(3712),
    [anon_sym_if] = ACTIONS(3712),
    [anon_sym_fun] = ACTIONS(3712),
    [anon_sym_try] = ACTIONS(3712),
    [anon_sym_match] = ACTIONS(3712),
    [anon_sym_match_BANG] = ACTIONS(3714),
    [anon_sym_function] = ACTIONS(3712),
    [anon_sym_LT_DASH] = ACTIONS(3712),
    [anon_sym_DOT_LBRACK] = ACTIONS(3714),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_use] = ACTIONS(3712),
    [anon_sym_use_BANG] = ACTIONS(3714),
    [anon_sym_do_BANG] = ACTIONS(3714),
    [anon_sym_begin] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(3714),
    [anon_sym_or] = ACTIONS(3712),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(3712),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3712),
    [sym_unit] = ACTIONS(3712),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3712),
    [sym_op_identifier] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_PLUS_DOT] = ACTIONS(3712),
    [anon_sym_DASH_DOT] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_AMP_AMP] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3714),
    [aux_sym_prefix_op_token1] = ACTIONS(3712),
    [aux_sym_infix_op_token1] = ACTIONS(3712),
    [anon_sym_PIPE_PIPE] = ACTIONS(3712),
    [anon_sym_BANG_EQ] = ACTIONS(3712),
    [anon_sym_COLON_EQ] = ACTIONS(3714),
    [anon_sym_DOLLAR] = ACTIONS(3712),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3712),
    [sym_int] = ACTIONS(3712),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3714),
    [sym__newline] = ACTIONS(3714),
  },
  [2772] = {
    [sym_xml_doc] = STATE(2772),
    [sym_block_comment] = STATE(2772),
    [sym_line_comment] = STATE(2772),
    [sym_compiler_directive_decl] = STATE(2772),
    [sym_fsi_directive_decl] = STATE(2772),
    [sym_preproc_line] = STATE(2772),
    [sym_identifier] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3957),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_let_BANG] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3959),
    [anon_sym_null] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_COLON_COLON] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_LT_AT] = ACTIONS(3957),
    [anon_sym_LT_AT_AT] = ACTIONS(3957),
    [anon_sym_DOT] = ACTIONS(3957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_return_BANG] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_yield_BANG] = ACTIONS(3959),
    [anon_sym_lazy] = ACTIONS(3957),
    [anon_sym_assert] = ACTIONS(3957),
    [anon_sym_upcast] = ACTIONS(3957),
    [anon_sym_downcast] = ACTIONS(3957),
    [anon_sym_COLON_GT] = ACTIONS(3959),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3959),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_fun] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_match] = ACTIONS(3957),
    [anon_sym_match_BANG] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3957),
    [anon_sym_LT_DASH] = ACTIONS(3957),
    [anon_sym_DOT_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3959),
    [anon_sym_GT] = ACTIONS(3957),
    [anon_sym_use] = ACTIONS(3957),
    [anon_sym_use_BANG] = ACTIONS(3959),
    [anon_sym_do_BANG] = ACTIONS(3959),
    [anon_sym_begin] = ACTIONS(3957),
    [anon_sym_LPAREN2] = ACTIONS(3959),
    [anon_sym_or] = ACTIONS(3957),
    [aux_sym_char_token1] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_AT_DQUOTE] = ACTIONS(3959),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3959),
    [sym_bool] = ACTIONS(3957),
    [sym_unit] = ACTIONS(3957),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3957),
    [sym_op_identifier] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_PLUS_DOT] = ACTIONS(3957),
    [anon_sym_DASH_DOT] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [aux_sym_prefix_op_token1] = ACTIONS(3957),
    [aux_sym_infix_op_token1] = ACTIONS(3957),
    [anon_sym_PIPE_PIPE] = ACTIONS(3957),
    [anon_sym_BANG_EQ] = ACTIONS(3957),
    [anon_sym_COLON_EQ] = ACTIONS(3959),
    [anon_sym_DOLLAR] = ACTIONS(3957),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3957),
    [sym_int] = ACTIONS(3957),
    [sym_xint] = ACTIONS(3959),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3959),
    [sym__newline] = ACTIONS(3959),
  },
  [2773] = {
    [sym_xml_doc] = STATE(2773),
    [sym_block_comment] = STATE(2773),
    [sym_line_comment] = STATE(2773),
    [sym_compiler_directive_decl] = STATE(2773),
    [sym_fsi_directive_decl] = STATE(2773),
    [sym_preproc_line] = STATE(2773),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_let_BANG] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3955),
    [anon_sym_null] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3955),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LT_AT] = ACTIONS(3953),
    [anon_sym_LT_AT_AT] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3955),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_return_BANG] = ACTIONS(3955),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_yield_BANG] = ACTIONS(3955),
    [anon_sym_lazy] = ACTIONS(3953),
    [anon_sym_assert] = ACTIONS(3953),
    [anon_sym_upcast] = ACTIONS(3953),
    [anon_sym_downcast] = ACTIONS(3953),
    [anon_sym_COLON_GT] = ACTIONS(3955),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3955),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_fun] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_match] = ACTIONS(3953),
    [anon_sym_match_BANG] = ACTIONS(3955),
    [anon_sym_function] = ACTIONS(3953),
    [anon_sym_LT_DASH] = ACTIONS(3953),
    [anon_sym_DOT_LBRACK] = ACTIONS(3955),
    [anon_sym_LT] = ACTIONS(3955),
    [anon_sym_GT] = ACTIONS(3953),
    [anon_sym_use] = ACTIONS(3953),
    [anon_sym_use_BANG] = ACTIONS(3955),
    [anon_sym_do_BANG] = ACTIONS(3955),
    [anon_sym_begin] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_or] = ACTIONS(3953),
    [aux_sym_char_token1] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [anon_sym_AT_DQUOTE] = ACTIONS(3955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3955),
    [sym_bool] = ACTIONS(3953),
    [sym_unit] = ACTIONS(3953),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3953),
    [sym_op_identifier] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_DOT] = ACTIONS(3953),
    [anon_sym_DASH_DOT] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [aux_sym_prefix_op_token1] = ACTIONS(3953),
    [aux_sym_infix_op_token1] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3953),
    [anon_sym_COLON_EQ] = ACTIONS(3955),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3953),
    [sym_int] = ACTIONS(3953),
    [sym_xint] = ACTIONS(3955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3955),
    [sym__newline] = ACTIONS(3955),
  },
  [2774] = {
    [sym_xml_doc] = STATE(2774),
    [sym_block_comment] = STATE(2774),
    [sym_line_comment] = STATE(2774),
    [sym_compiler_directive_decl] = STATE(2774),
    [sym_fsi_directive_decl] = STATE(2774),
    [sym_preproc_line] = STATE(2774),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_let_BANG] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_null] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_QMARK] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LT_AT] = ACTIONS(3949),
    [anon_sym_LT_AT_AT] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_return_BANG] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_yield_BANG] = ACTIONS(3951),
    [anon_sym_lazy] = ACTIONS(3949),
    [anon_sym_assert] = ACTIONS(3949),
    [anon_sym_upcast] = ACTIONS(3949),
    [anon_sym_downcast] = ACTIONS(3949),
    [anon_sym_COLON_GT] = ACTIONS(3951),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_fun] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_match] = ACTIONS(3949),
    [anon_sym_match_BANG] = ACTIONS(3951),
    [anon_sym_function] = ACTIONS(3949),
    [anon_sym_LT_DASH] = ACTIONS(3949),
    [anon_sym_DOT_LBRACK] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_GT] = ACTIONS(3949),
    [anon_sym_use] = ACTIONS(3949),
    [anon_sym_use_BANG] = ACTIONS(3951),
    [anon_sym_do_BANG] = ACTIONS(3951),
    [anon_sym_begin] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_or] = ACTIONS(3949),
    [aux_sym_char_token1] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [anon_sym_AT_DQUOTE] = ACTIONS(3951),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3951),
    [sym_bool] = ACTIONS(3949),
    [sym_unit] = ACTIONS(3949),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3949),
    [sym_op_identifier] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_DOT] = ACTIONS(3949),
    [anon_sym_DASH_DOT] = ACTIONS(3949),
    [anon_sym_PERCENT] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [aux_sym_prefix_op_token1] = ACTIONS(3949),
    [aux_sym_infix_op_token1] = ACTIONS(3949),
    [anon_sym_PIPE_PIPE] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3949),
    [anon_sym_COLON_EQ] = ACTIONS(3951),
    [anon_sym_DOLLAR] = ACTIONS(3949),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3949),
    [sym_int] = ACTIONS(3949),
    [sym_xint] = ACTIONS(3951),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3951),
    [sym__newline] = ACTIONS(3951),
  },
  [2775] = {
    [sym_xml_doc] = STATE(2775),
    [sym_block_comment] = STATE(2775),
    [sym_line_comment] = STATE(2775),
    [sym_compiler_directive_decl] = STATE(2775),
    [sym_fsi_directive_decl] = STATE(2775),
    [sym_preproc_line] = STATE(2775),
    [sym_identifier] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3945),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_let_BANG] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3945),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_null] = ACTIONS(3945),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_QMARK] = ACTIONS(3945),
    [anon_sym_COLON_COLON] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3945),
    [anon_sym_LT_AT] = ACTIONS(3945),
    [anon_sym_LT_AT_AT] = ACTIONS(3945),
    [anon_sym_DOT] = ACTIONS(3945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_return_BANG] = ACTIONS(3947),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_yield_BANG] = ACTIONS(3947),
    [anon_sym_lazy] = ACTIONS(3945),
    [anon_sym_assert] = ACTIONS(3945),
    [anon_sym_upcast] = ACTIONS(3945),
    [anon_sym_downcast] = ACTIONS(3945),
    [anon_sym_COLON_GT] = ACTIONS(3947),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_fun] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_match] = ACTIONS(3945),
    [anon_sym_match_BANG] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3945),
    [anon_sym_LT_DASH] = ACTIONS(3945),
    [anon_sym_DOT_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_use] = ACTIONS(3945),
    [anon_sym_use_BANG] = ACTIONS(3947),
    [anon_sym_do_BANG] = ACTIONS(3947),
    [anon_sym_begin] = ACTIONS(3945),
    [anon_sym_LPAREN2] = ACTIONS(3947),
    [anon_sym_or] = ACTIONS(3945),
    [aux_sym_char_token1] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3945),
    [anon_sym_AT_DQUOTE] = ACTIONS(3947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3947),
    [sym_bool] = ACTIONS(3945),
    [sym_unit] = ACTIONS(3945),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3945),
    [sym_op_identifier] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_PLUS_DOT] = ACTIONS(3945),
    [anon_sym_DASH_DOT] = ACTIONS(3945),
    [anon_sym_PERCENT] = ACTIONS(3945),
    [anon_sym_AMP_AMP] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [aux_sym_prefix_op_token1] = ACTIONS(3945),
    [aux_sym_infix_op_token1] = ACTIONS(3945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3945),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_COLON_EQ] = ACTIONS(3947),
    [anon_sym_DOLLAR] = ACTIONS(3945),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3945),
    [sym_int] = ACTIONS(3945),
    [sym_xint] = ACTIONS(3947),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3947),
    [sym__newline] = ACTIONS(3947),
  },
  [2776] = {
    [sym_xml_doc] = STATE(2776),
    [sym_block_comment] = STATE(2776),
    [sym_line_comment] = STATE(2776),
    [sym_compiler_directive_decl] = STATE(2776),
    [sym_fsi_directive_decl] = STATE(2776),
    [sym_preproc_line] = STATE(2776),
    [sym_identifier] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_let_BANG] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_null] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_COLON] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_LT_AT] = ACTIONS(3941),
    [anon_sym_LT_AT_AT] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_return_BANG] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_yield_BANG] = ACTIONS(3943),
    [anon_sym_lazy] = ACTIONS(3941),
    [anon_sym_assert] = ACTIONS(3941),
    [anon_sym_upcast] = ACTIONS(3941),
    [anon_sym_downcast] = ACTIONS(3941),
    [anon_sym_COLON_GT] = ACTIONS(3943),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3943),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_fun] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_match] = ACTIONS(3941),
    [anon_sym_match_BANG] = ACTIONS(3943),
    [anon_sym_function] = ACTIONS(3941),
    [anon_sym_LT_DASH] = ACTIONS(3941),
    [anon_sym_DOT_LBRACK] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_use] = ACTIONS(3941),
    [anon_sym_use_BANG] = ACTIONS(3943),
    [anon_sym_do_BANG] = ACTIONS(3943),
    [anon_sym_begin] = ACTIONS(3941),
    [anon_sym_LPAREN2] = ACTIONS(3943),
    [anon_sym_or] = ACTIONS(3941),
    [aux_sym_char_token1] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_AT_DQUOTE] = ACTIONS(3943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3943),
    [sym_bool] = ACTIONS(3941),
    [sym_unit] = ACTIONS(3941),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3941),
    [sym_op_identifier] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_PLUS_DOT] = ACTIONS(3941),
    [anon_sym_DASH_DOT] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [aux_sym_prefix_op_token1] = ACTIONS(3941),
    [aux_sym_infix_op_token1] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_COLON_EQ] = ACTIONS(3943),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3941),
    [sym_int] = ACTIONS(3941),
    [sym_xint] = ACTIONS(3943),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3943),
    [sym__newline] = ACTIONS(3943),
  },
  [2777] = {
    [sym_xml_doc] = STATE(2777),
    [sym_block_comment] = STATE(2777),
    [sym_line_comment] = STATE(2777),
    [sym_compiler_directive_decl] = STATE(2777),
    [sym_fsi_directive_decl] = STATE(2777),
    [sym_preproc_line] = STATE(2777),
    [sym_identifier] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_let_BANG] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_null] = ACTIONS(3679),
    [anon_sym_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_COLON] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT_AT] = ACTIONS(3679),
    [anon_sym_AT_GT] = ACTIONS(3679),
    [anon_sym_LT_AT_AT] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3546),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_return_BANG] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_yield_BANG] = ACTIONS(3546),
    [anon_sym_lazy] = ACTIONS(3679),
    [anon_sym_assert] = ACTIONS(3679),
    [anon_sym_upcast] = ACTIONS(3679),
    [anon_sym_downcast] = ACTIONS(3679),
    [anon_sym_COLON_GT] = ACTIONS(3546),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_fun] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_match] = ACTIONS(3679),
    [anon_sym_match_BANG] = ACTIONS(3546),
    [anon_sym_function] = ACTIONS(3679),
    [anon_sym_LT_DASH] = ACTIONS(3679),
    [anon_sym_DOT_LBRACK] = ACTIONS(3546),
    [anon_sym_LT] = ACTIONS(3546),
    [anon_sym_use] = ACTIONS(3679),
    [anon_sym_use_BANG] = ACTIONS(3546),
    [anon_sym_do_BANG] = ACTIONS(3546),
    [anon_sym_begin] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3679),
    [aux_sym_char_token1] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_AT_DQUOTE] = ACTIONS(3546),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3546),
    [sym_bool] = ACTIONS(3679),
    [sym_unit] = ACTIONS(3679),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3679),
    [sym_op_identifier] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_DOT] = ACTIONS(3679),
    [anon_sym_DASH_DOT] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3546),
    [aux_sym_prefix_op_token1] = ACTIONS(3679),
    [aux_sym_infix_op_token1] = ACTIONS(3679),
    [anon_sym_PIPE_PIPE] = ACTIONS(3679),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_COLON_EQ] = ACTIONS(3546),
    [anon_sym_DOLLAR] = ACTIONS(3679),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3679),
    [sym_int] = ACTIONS(3679),
    [sym_xint] = ACTIONS(3546),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3546),
    [sym__newline] = ACTIONS(3546),
  },
  [2778] = {
    [sym_xml_doc] = STATE(2778),
    [sym_block_comment] = STATE(2778),
    [sym_line_comment] = STATE(2778),
    [sym_compiler_directive_decl] = STATE(2778),
    [sym_fsi_directive_decl] = STATE(2778),
    [sym_preproc_line] = STATE(2778),
    [sym_identifier] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3689),
    [anon_sym_do] = ACTIONS(3689),
    [anon_sym_let] = ACTIONS(3689),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_QMARK] = ACTIONS(3689),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(3689),
    [anon_sym_AT_GT] = ACTIONS(3689),
    [anon_sym_LT_AT_AT] = ACTIONS(3689),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3689),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3689),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3689),
    [anon_sym_assert] = ACTIONS(3689),
    [anon_sym_upcast] = ACTIONS(3689),
    [anon_sym_downcast] = ACTIONS(3689),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3689),
    [anon_sym_while] = ACTIONS(3689),
    [anon_sym_if] = ACTIONS(3689),
    [anon_sym_fun] = ACTIONS(3689),
    [anon_sym_try] = ACTIONS(3689),
    [anon_sym_match] = ACTIONS(3689),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3689),
    [anon_sym_LT_DASH] = ACTIONS(3689),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3689),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3689),
    [anon_sym_LPAREN2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3689),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3689),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3689),
    [sym_op_identifier] = ACTIONS(3689),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_PLUS_DOT] = ACTIONS(3689),
    [anon_sym_DASH_DOT] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3689),
    [sym_int] = ACTIONS(3689),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3691),
  },
  [2779] = {
    [sym_xml_doc] = STATE(2779),
    [sym_block_comment] = STATE(2779),
    [sym_line_comment] = STATE(2779),
    [sym_compiler_directive_decl] = STATE(2779),
    [sym_fsi_directive_decl] = STATE(2779),
    [sym_preproc_line] = STATE(2779),
    [sym_identifier] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_do] = ACTIONS(3697),
    [anon_sym_let] = ACTIONS(3697),
    [anon_sym_let_BANG] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_null] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_QMARK] = ACTIONS(3697),
    [anon_sym_COLON_COLON] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_LT_AT] = ACTIONS(3697),
    [anon_sym_AT_GT] = ACTIONS(3697),
    [anon_sym_LT_AT_AT] = ACTIONS(3697),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3697),
    [anon_sym_return_BANG] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_yield_BANG] = ACTIONS(3699),
    [anon_sym_lazy] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_upcast] = ACTIONS(3697),
    [anon_sym_downcast] = ACTIONS(3697),
    [anon_sym_COLON_GT] = ACTIONS(3699),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_fun] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_match] = ACTIONS(3697),
    [anon_sym_match_BANG] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3697),
    [anon_sym_LT_DASH] = ACTIONS(3697),
    [anon_sym_DOT_LBRACK] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_use] = ACTIONS(3697),
    [anon_sym_use_BANG] = ACTIONS(3699),
    [anon_sym_do_BANG] = ACTIONS(3699),
    [anon_sym_begin] = ACTIONS(3697),
    [anon_sym_LPAREN2] = ACTIONS(3699),
    [anon_sym_or] = ACTIONS(3697),
    [aux_sym_char_token1] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_AT_DQUOTE] = ACTIONS(3699),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3699),
    [sym_bool] = ACTIONS(3697),
    [sym_unit] = ACTIONS(3697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3697),
    [sym_op_identifier] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_DOT] = ACTIONS(3697),
    [anon_sym_DASH_DOT] = ACTIONS(3697),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3699),
    [aux_sym_prefix_op_token1] = ACTIONS(3697),
    [aux_sym_infix_op_token1] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3697),
    [anon_sym_COLON_EQ] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3697),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3697),
    [sym_int] = ACTIONS(3697),
    [sym_xint] = ACTIONS(3699),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3699),
    [sym__newline] = ACTIONS(3699),
  },
  [2780] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(2994),
    [sym__method_defn] = STATE(5314),
    [sym__property_defn] = STATE(5313),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2780),
    [sym_block_comment] = STATE(2780),
    [sym_line_comment] = STATE(2780),
    [sym_compiler_directive_decl] = STATE(2780),
    [sym_fsi_directive_decl] = STATE(2780),
    [sym_preproc_line] = STATE(2780),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2954),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5007),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5025),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2781] = {
    [sym_xml_doc] = STATE(2781),
    [sym_block_comment] = STATE(2781),
    [sym_line_comment] = STATE(2781),
    [sym_compiler_directive_decl] = STATE(2781),
    [sym_fsi_directive_decl] = STATE(2781),
    [sym_preproc_line] = STATE(2781),
    [aux_sym_long_identifier_repeat1] = STATE(2781),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_and] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [aux_sym_access_modifier_token1] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_member] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_val] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [2782] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2782),
    [sym_block_comment] = STATE(2782),
    [sym_line_comment] = STATE(2782),
    [sym_compiler_directive_decl] = STATE(2782),
    [sym_fsi_directive_decl] = STATE(2782),
    [sym_preproc_line] = STATE(2782),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(4981),
    [anon_sym_open] = ACTIONS(4981),
    [anon_sym_LBRACK_LT] = ACTIONS(4979),
    [anon_sym_return] = ACTIONS(4981),
    [anon_sym_type] = ACTIONS(4981),
    [anon_sym_do] = ACTIONS(4981),
    [anon_sym_and] = ACTIONS(4981),
    [anon_sym_let] = ACTIONS(4981),
    [anon_sym_let_BANG] = ACTIONS(4979),
    [aux_sym_access_modifier_token1] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4981),
    [anon_sym_null] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4981),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4979),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_LT_AT] = ACTIONS(4981),
    [anon_sym_LT_AT_AT] = ACTIONS(4979),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4979),
    [anon_sym_with] = ACTIONS(4981),
    [anon_sym_new] = ACTIONS(4981),
    [anon_sym_return_BANG] = ACTIONS(4979),
    [anon_sym_yield] = ACTIONS(4981),
    [anon_sym_yield_BANG] = ACTIONS(4979),
    [anon_sym_lazy] = ACTIONS(4981),
    [anon_sym_assert] = ACTIONS(4981),
    [anon_sym_upcast] = ACTIONS(4981),
    [anon_sym_downcast] = ACTIONS(4981),
    [anon_sym_for] = ACTIONS(4981),
    [anon_sym_while] = ACTIONS(4981),
    [anon_sym_if] = ACTIONS(4981),
    [anon_sym_fun] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [anon_sym_try] = ACTIONS(4981),
    [anon_sym_match] = ACTIONS(4981),
    [anon_sym_match_BANG] = ACTIONS(4979),
    [anon_sym_function] = ACTIONS(4981),
    [anon_sym_use] = ACTIONS(4981),
    [anon_sym_use_BANG] = ACTIONS(4979),
    [anon_sym_do_BANG] = ACTIONS(4979),
    [anon_sym_begin] = ACTIONS(4981),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(4981),
    [anon_sym_static] = ACTIONS(4981),
    [anon_sym_member] = ACTIONS(4981),
    [anon_sym_abstract] = ACTIONS(4981),
    [anon_sym_override] = ACTIONS(4981),
    [anon_sym_val] = ACTIONS(4981),
    [aux_sym_char_token1] = ACTIONS(4979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4981),
    [anon_sym_DQUOTE] = ACTIONS(4981),
    [anon_sym_AT_DQUOTE] = ACTIONS(4979),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4979),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4979),
    [sym_bool] = ACTIONS(4981),
    [sym_unit] = ACTIONS(4979),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4981),
    [sym_op_identifier] = ACTIONS(4979),
    [anon_sym_PLUS] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_DOT] = ACTIONS(4979),
    [anon_sym_DASH_DOT] = ACTIONS(4979),
    [anon_sym_PERCENT] = ACTIONS(4979),
    [anon_sym_AMP_AMP] = ACTIONS(4979),
    [anon_sym_TILDE] = ACTIONS(4979),
    [aux_sym_prefix_op_token1] = ACTIONS(4979),
    [sym_int] = ACTIONS(4981),
    [sym_xint] = ACTIONS(4979),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4979),
    [anon_sym_POUNDload] = ACTIONS(4979),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4979),
    [sym__dedent] = ACTIONS(4979),
  },
  [2783] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3925),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2783),
    [sym_block_comment] = STATE(2783),
    [sym_line_comment] = STATE(2783),
    [sym_compiler_directive_decl] = STATE(2783),
    [sym_fsi_directive_decl] = STATE(2783),
    [sym_preproc_line] = STATE(2783),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(4762),
    [anon_sym_LBRACK_LT] = ACTIONS(4762),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4764),
    [anon_sym__] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4762),
    [anon_sym_COLON_QMARK] = ACTIONS(4762),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4762),
    [anon_sym_LBRACE] = ACTIONS(4762),
    [aux_sym_char_token1] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4764),
    [anon_sym_DQUOTE] = ACTIONS(4764),
    [anon_sym_AT_DQUOTE] = ACTIONS(4762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4762),
    [sym_bool] = ACTIONS(4764),
    [sym_unit] = ACTIONS(4762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4764),
    [sym_op_identifier] = ACTIONS(4762),
    [sym_int] = ACTIONS(4764),
    [sym_xint] = ACTIONS(4762),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2784] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(2998),
    [sym__method_defn] = STATE(3200),
    [sym__property_defn] = STATE(3199),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2784),
    [sym_block_comment] = STATE(2784),
    [sym_line_comment] = STATE(2784),
    [sym_compiler_directive_decl] = STATE(2784),
    [sym_fsi_directive_decl] = STATE(2784),
    [sym_preproc_line] = STATE(2784),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5032),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5034),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2785] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(6328),
    [sym_function_declaration_left] = STATE(7085),
    [sym_value_declaration_left] = STATE(7085),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2785),
    [sym_block_comment] = STATE(2785),
    [sym_line_comment] = STATE(2785),
    [sym_compiler_directive_decl] = STATE(2785),
    [sym_fsi_directive_decl] = STATE(2785),
    [sym_preproc_line] = STATE(2785),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2786] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2786),
    [sym_block_comment] = STATE(2786),
    [sym_line_comment] = STATE(2786),
    [sym_compiler_directive_decl] = STATE(2786),
    [sym_fsi_directive_decl] = STATE(2786),
    [sym_preproc_line] = STATE(2786),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(5036),
    [sym_identifier] = ACTIONS(5038),
    [anon_sym_namespace] = ACTIONS(5038),
    [anon_sym_module] = ACTIONS(5038),
    [anon_sym_open] = ACTIONS(5038),
    [anon_sym_LBRACK_LT] = ACTIONS(5036),
    [anon_sym_return] = ACTIONS(5038),
    [anon_sym_type] = ACTIONS(5038),
    [anon_sym_do] = ACTIONS(5038),
    [anon_sym_and] = ACTIONS(5038),
    [anon_sym_let] = ACTIONS(5038),
    [anon_sym_let_BANG] = ACTIONS(5036),
    [aux_sym_access_modifier_token1] = ACTIONS(5036),
    [anon_sym_LPAREN] = ACTIONS(5038),
    [anon_sym_null] = ACTIONS(5038),
    [anon_sym_AMP] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(5038),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(5038),
    [anon_sym_LT_AT] = ACTIONS(5038),
    [anon_sym_LT_AT_AT] = ACTIONS(5036),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5036),
    [anon_sym_new] = ACTIONS(5038),
    [anon_sym_return_BANG] = ACTIONS(5036),
    [anon_sym_yield] = ACTIONS(5038),
    [anon_sym_yield_BANG] = ACTIONS(5036),
    [anon_sym_lazy] = ACTIONS(5038),
    [anon_sym_assert] = ACTIONS(5038),
    [anon_sym_upcast] = ACTIONS(5038),
    [anon_sym_downcast] = ACTIONS(5038),
    [anon_sym_for] = ACTIONS(5038),
    [anon_sym_while] = ACTIONS(5038),
    [anon_sym_if] = ACTIONS(5038),
    [anon_sym_fun] = ACTIONS(5038),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(5038),
    [anon_sym_match] = ACTIONS(5038),
    [anon_sym_match_BANG] = ACTIONS(5036),
    [anon_sym_function] = ACTIONS(5038),
    [anon_sym_use] = ACTIONS(5038),
    [anon_sym_use_BANG] = ACTIONS(5036),
    [anon_sym_do_BANG] = ACTIONS(5036),
    [anon_sym_begin] = ACTIONS(5038),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(5038),
    [anon_sym_static] = ACTIONS(5038),
    [anon_sym_member] = ACTIONS(5038),
    [anon_sym_abstract] = ACTIONS(5038),
    [anon_sym_override] = ACTIONS(5038),
    [anon_sym_val] = ACTIONS(5038),
    [aux_sym_char_token1] = ACTIONS(5036),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5038),
    [anon_sym_DQUOTE] = ACTIONS(5038),
    [anon_sym_AT_DQUOTE] = ACTIONS(5036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5036),
    [sym_bool] = ACTIONS(5038),
    [sym_unit] = ACTIONS(5036),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5038),
    [sym_op_identifier] = ACTIONS(5036),
    [anon_sym_PLUS] = ACTIONS(5038),
    [anon_sym_DASH] = ACTIONS(5038),
    [anon_sym_PLUS_DOT] = ACTIONS(5036),
    [anon_sym_DASH_DOT] = ACTIONS(5036),
    [anon_sym_PERCENT] = ACTIONS(5036),
    [anon_sym_AMP_AMP] = ACTIONS(5036),
    [anon_sym_TILDE] = ACTIONS(5036),
    [aux_sym_prefix_op_token1] = ACTIONS(5036),
    [sym_int] = ACTIONS(5038),
    [sym_xint] = ACTIONS(5036),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5036),
    [anon_sym_POUNDload] = ACTIONS(5036),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5036),
  },
  [2787] = {
    [sym_attributes] = STATE(5463),
    [sym_attribute_set] = STATE(4720),
    [sym_access_modifier] = STATE(8266),
    [sym_member_defn] = STATE(3134),
    [sym_additional_constr_defn] = STATE(3164),
    [sym_xml_doc] = STATE(2787),
    [sym_block_comment] = STATE(2787),
    [sym_line_comment] = STATE(2787),
    [sym_compiler_directive_decl] = STATE(2787),
    [sym_fsi_directive_decl] = STATE(2787),
    [sym_preproc_line] = STATE(2787),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym__member_defns_repeat1] = STATE(2817),
    [ts_builtin_sym_end] = ACTIONS(5040),
    [sym_identifier] = ACTIONS(5042),
    [anon_sym_namespace] = ACTIONS(5042),
    [anon_sym_module] = ACTIONS(5042),
    [anon_sym_open] = ACTIONS(5042),
    [anon_sym_LBRACK_LT] = ACTIONS(5040),
    [anon_sym_return] = ACTIONS(5042),
    [anon_sym_type] = ACTIONS(5042),
    [anon_sym_do] = ACTIONS(5042),
    [anon_sym_and] = ACTIONS(5042),
    [anon_sym_let] = ACTIONS(5042),
    [anon_sym_let_BANG] = ACTIONS(5040),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_null] = ACTIONS(5042),
    [anon_sym_AMP] = ACTIONS(5042),
    [anon_sym_LBRACK] = ACTIONS(5042),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5040),
    [anon_sym_LBRACE] = ACTIONS(5042),
    [anon_sym_LT_AT] = ACTIONS(5042),
    [anon_sym_LT_AT_AT] = ACTIONS(5040),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5040),
    [anon_sym_new] = ACTIONS(5042),
    [anon_sym_return_BANG] = ACTIONS(5040),
    [anon_sym_yield] = ACTIONS(5042),
    [anon_sym_yield_BANG] = ACTIONS(5040),
    [anon_sym_lazy] = ACTIONS(5042),
    [anon_sym_assert] = ACTIONS(5042),
    [anon_sym_upcast] = ACTIONS(5042),
    [anon_sym_downcast] = ACTIONS(5042),
    [anon_sym_for] = ACTIONS(5042),
    [anon_sym_while] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(5042),
    [anon_sym_fun] = ACTIONS(5042),
    [anon_sym_try] = ACTIONS(5042),
    [anon_sym_match] = ACTIONS(5042),
    [anon_sym_match_BANG] = ACTIONS(5040),
    [anon_sym_function] = ACTIONS(5042),
    [anon_sym_use] = ACTIONS(5042),
    [anon_sym_use_BANG] = ACTIONS(5040),
    [anon_sym_do_BANG] = ACTIONS(5040),
    [anon_sym_begin] = ACTIONS(5042),
    [anon_sym_default] = ACTIONS(5044),
    [anon_sym_static] = ACTIONS(5046),
    [anon_sym_member] = ACTIONS(5048),
    [anon_sym_abstract] = ACTIONS(5050),
    [anon_sym_override] = ACTIONS(5044),
    [anon_sym_val] = ACTIONS(5052),
    [aux_sym_char_token1] = ACTIONS(5040),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [anon_sym_AT_DQUOTE] = ACTIONS(5040),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5040),
    [sym_bool] = ACTIONS(5042),
    [sym_unit] = ACTIONS(5040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5042),
    [sym_op_identifier] = ACTIONS(5040),
    [anon_sym_PLUS] = ACTIONS(5042),
    [anon_sym_DASH] = ACTIONS(5042),
    [anon_sym_PLUS_DOT] = ACTIONS(5040),
    [anon_sym_DASH_DOT] = ACTIONS(5040),
    [anon_sym_PERCENT] = ACTIONS(5040),
    [anon_sym_AMP_AMP] = ACTIONS(5040),
    [anon_sym_TILDE] = ACTIONS(5040),
    [aux_sym_prefix_op_token1] = ACTIONS(5040),
    [sym_int] = ACTIONS(5042),
    [sym_xint] = ACTIONS(5040),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5040),
    [anon_sym_POUNDload] = ACTIONS(5040),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5040),
  },
  [2788] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(4752),
    [sym_function_declaration_left] = STATE(6935),
    [sym_value_declaration_left] = STATE(6935),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2788),
    [sym_block_comment] = STATE(2788),
    [sym_line_comment] = STATE(2788),
    [sym_compiler_directive_decl] = STATE(2788),
    [sym_fsi_directive_decl] = STATE(2788),
    [sym_preproc_line] = STATE(2788),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2789] = {
    [sym_xml_doc] = STATE(2789),
    [sym_block_comment] = STATE(2789),
    [sym_line_comment] = STATE(2789),
    [sym_compiler_directive_decl] = STATE(2789),
    [sym_fsi_directive_decl] = STATE(2789),
    [sym_preproc_line] = STATE(2789),
    [ts_builtin_sym_end] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_and] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [aux_sym_access_modifier_token1] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(5054),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_member] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_val] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
  },
  [2790] = {
    [sym_xml_doc] = STATE(2790),
    [sym_block_comment] = STATE(2790),
    [sym_line_comment] = STATE(2790),
    [sym_compiler_directive_decl] = STATE(2790),
    [sym_fsi_directive_decl] = STATE(2790),
    [sym_preproc_line] = STATE(2790),
    [aux_sym__compound_type_repeat1] = STATE(2790),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [aux_sym_access_modifier_token1] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(5056),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_member] = ACTIONS(3032),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_val] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
  },
  [2791] = {
    [sym_xml_doc] = STATE(2791),
    [sym_block_comment] = STATE(2791),
    [sym_line_comment] = STATE(2791),
    [sym_compiler_directive_decl] = STATE(2791),
    [sym_fsi_directive_decl] = STATE(2791),
    [sym_preproc_line] = STATE(2791),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_open] = ACTIONS(3274),
    [anon_sym_LBRACK_LT] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_and] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [aux_sym_access_modifier_token1] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3274),
    [anon_sym_or] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_member] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_val] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3276),
    [anon_sym_POUNDload] = ACTIONS(3276),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [2792] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(3003),
    [sym__method_defn] = STATE(5345),
    [sym__property_defn] = STATE(5394),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2792),
    [sym_block_comment] = STATE(2792),
    [sym_line_comment] = STATE(2792),
    [sym_compiler_directive_decl] = STATE(2792),
    [sym_fsi_directive_decl] = STATE(2792),
    [sym_preproc_line] = STATE(2792),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2966),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5061),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2793] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(6429),
    [sym_function_declaration_left] = STATE(7044),
    [sym_value_declaration_left] = STATE(7044),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2793),
    [sym_block_comment] = STATE(2793),
    [sym_line_comment] = STATE(2793),
    [sym_compiler_directive_decl] = STATE(2793),
    [sym_fsi_directive_decl] = STATE(2793),
    [sym_preproc_line] = STATE(2793),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2794] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(3004),
    [sym__method_defn] = STATE(5363),
    [sym__property_defn] = STATE(5329),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2794),
    [sym_block_comment] = STATE(2794),
    [sym_line_comment] = STATE(2794),
    [sym_compiler_directive_decl] = STATE(2794),
    [sym_fsi_directive_decl] = STATE(2794),
    [sym_preproc_line] = STATE(2794),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2963),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5063),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5065),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2795] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3529),
    [sym_function_declaration_left] = STATE(6986),
    [sym_value_declaration_left] = STATE(6986),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2795),
    [sym_block_comment] = STATE(2795),
    [sym_line_comment] = STATE(2795),
    [sym_compiler_directive_decl] = STATE(2795),
    [sym_fsi_directive_decl] = STATE(2795),
    [sym_preproc_line] = STATE(2795),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2796] = {
    [sym_xml_doc] = STATE(2796),
    [sym_block_comment] = STATE(2796),
    [sym_line_comment] = STATE(2796),
    [sym_compiler_directive_decl] = STATE(2796),
    [sym_fsi_directive_decl] = STATE(2796),
    [sym_preproc_line] = STATE(2796),
    [aux_sym_long_identifier_repeat1] = STATE(2821),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_and] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [aux_sym_access_modifier_token1] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_member] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_val] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [2797] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5875),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2797),
    [sym_block_comment] = STATE(2797),
    [sym_line_comment] = STATE(2797),
    [sym_compiler_directive_decl] = STATE(2797),
    [sym_fsi_directive_decl] = STATE(2797),
    [sym_preproc_line] = STATE(2797),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_COMMA] = ACTIONS(4762),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(4762),
    [anon_sym_PIPE] = ACTIONS(4762),
    [anon_sym_AMP] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_in] = ACTIONS(4764),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2798] = {
    [sym_xml_doc] = STATE(2798),
    [sym_block_comment] = STATE(2798),
    [sym_line_comment] = STATE(2798),
    [sym_compiler_directive_decl] = STATE(2798),
    [sym_fsi_directive_decl] = STATE(2798),
    [sym_preproc_line] = STATE(2798),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_and] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [aux_sym_access_modifier_token1] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_member] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_val] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [2799] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3419),
    [sym_function_declaration_left] = STATE(7155),
    [sym_value_declaration_left] = STATE(7155),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2799),
    [sym_block_comment] = STATE(2799),
    [sym_line_comment] = STATE(2799),
    [sym_compiler_directive_decl] = STATE(2799),
    [sym_fsi_directive_decl] = STATE(2799),
    [sym_preproc_line] = STATE(2799),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2800] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2800),
    [sym_block_comment] = STATE(2800),
    [sym_line_comment] = STATE(2800),
    [sym_compiler_directive_decl] = STATE(2800),
    [sym_fsi_directive_decl] = STATE(2800),
    [sym_preproc_line] = STATE(2800),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(5069),
    [sym_identifier] = ACTIONS(5071),
    [anon_sym_namespace] = ACTIONS(5071),
    [anon_sym_module] = ACTIONS(5071),
    [anon_sym_open] = ACTIONS(5071),
    [anon_sym_LBRACK_LT] = ACTIONS(5069),
    [anon_sym_return] = ACTIONS(5071),
    [anon_sym_type] = ACTIONS(5071),
    [anon_sym_do] = ACTIONS(5071),
    [anon_sym_and] = ACTIONS(5071),
    [anon_sym_let] = ACTIONS(5071),
    [anon_sym_let_BANG] = ACTIONS(5069),
    [aux_sym_access_modifier_token1] = ACTIONS(5069),
    [anon_sym_LPAREN] = ACTIONS(5071),
    [anon_sym_null] = ACTIONS(5071),
    [anon_sym_AMP] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5069),
    [anon_sym_LBRACE] = ACTIONS(5071),
    [anon_sym_LT_AT] = ACTIONS(5071),
    [anon_sym_LT_AT_AT] = ACTIONS(5069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5069),
    [anon_sym_new] = ACTIONS(5071),
    [anon_sym_return_BANG] = ACTIONS(5069),
    [anon_sym_yield] = ACTIONS(5071),
    [anon_sym_yield_BANG] = ACTIONS(5069),
    [anon_sym_lazy] = ACTIONS(5071),
    [anon_sym_assert] = ACTIONS(5071),
    [anon_sym_upcast] = ACTIONS(5071),
    [anon_sym_downcast] = ACTIONS(5071),
    [anon_sym_for] = ACTIONS(5071),
    [anon_sym_while] = ACTIONS(5071),
    [anon_sym_if] = ACTIONS(5071),
    [anon_sym_fun] = ACTIONS(5071),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(5071),
    [anon_sym_match] = ACTIONS(5071),
    [anon_sym_match_BANG] = ACTIONS(5069),
    [anon_sym_function] = ACTIONS(5071),
    [anon_sym_use] = ACTIONS(5071),
    [anon_sym_use_BANG] = ACTIONS(5069),
    [anon_sym_do_BANG] = ACTIONS(5069),
    [anon_sym_begin] = ACTIONS(5071),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_member] = ACTIONS(5071),
    [anon_sym_abstract] = ACTIONS(5071),
    [anon_sym_override] = ACTIONS(5071),
    [anon_sym_val] = ACTIONS(5071),
    [aux_sym_char_token1] = ACTIONS(5069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5071),
    [anon_sym_DQUOTE] = ACTIONS(5071),
    [anon_sym_AT_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5069),
    [sym_bool] = ACTIONS(5071),
    [sym_unit] = ACTIONS(5069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5071),
    [sym_op_identifier] = ACTIONS(5069),
    [anon_sym_PLUS] = ACTIONS(5071),
    [anon_sym_DASH] = ACTIONS(5071),
    [anon_sym_PLUS_DOT] = ACTIONS(5069),
    [anon_sym_DASH_DOT] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_TILDE] = ACTIONS(5069),
    [aux_sym_prefix_op_token1] = ACTIONS(5069),
    [sym_int] = ACTIONS(5071),
    [sym_xint] = ACTIONS(5069),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5069),
    [anon_sym_POUNDload] = ACTIONS(5069),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5069),
  },
  [2801] = {
    [sym_xml_doc] = STATE(2801),
    [sym_block_comment] = STATE(2801),
    [sym_line_comment] = STATE(2801),
    [sym_compiler_directive_decl] = STATE(2801),
    [sym_fsi_directive_decl] = STATE(2801),
    [sym_preproc_line] = STATE(2801),
    [aux_sym__compound_type_repeat1] = STATE(2790),
    [ts_builtin_sym_end] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_open] = ACTIONS(3212),
    [anon_sym_LBRACK_LT] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_and] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [aux_sym_access_modifier_token1] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_member] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_override] = ACTIONS(3212),
    [anon_sym_val] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3214),
    [anon_sym_DASH_DOT] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3214),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3214),
    [anon_sym_POUNDload] = ACTIONS(3214),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
  },
  [2802] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(6760),
    [sym_function_declaration_left] = STATE(6949),
    [sym_value_declaration_left] = STATE(6949),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2802),
    [sym_block_comment] = STATE(2802),
    [sym_line_comment] = STATE(2802),
    [sym_compiler_directive_decl] = STATE(2802),
    [sym_fsi_directive_decl] = STATE(2802),
    [sym_preproc_line] = STATE(2802),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2803] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2803),
    [sym_block_comment] = STATE(2803),
    [sym_line_comment] = STATE(2803),
    [sym_compiler_directive_decl] = STATE(2803),
    [sym_fsi_directive_decl] = STATE(2803),
    [sym_preproc_line] = STATE(2803),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [sym_identifier] = ACTIONS(5075),
    [anon_sym_namespace] = ACTIONS(5075),
    [anon_sym_module] = ACTIONS(5075),
    [anon_sym_open] = ACTIONS(5075),
    [anon_sym_LBRACK_LT] = ACTIONS(5073),
    [anon_sym_return] = ACTIONS(5075),
    [anon_sym_type] = ACTIONS(5075),
    [anon_sym_do] = ACTIONS(5075),
    [anon_sym_and] = ACTIONS(5075),
    [anon_sym_let] = ACTIONS(5075),
    [anon_sym_let_BANG] = ACTIONS(5073),
    [aux_sym_access_modifier_token1] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5075),
    [anon_sym_null] = ACTIONS(5075),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5073),
    [anon_sym_LBRACE] = ACTIONS(5075),
    [anon_sym_LT_AT] = ACTIONS(5075),
    [anon_sym_LT_AT_AT] = ACTIONS(5073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5073),
    [anon_sym_new] = ACTIONS(5075),
    [anon_sym_return_BANG] = ACTIONS(5073),
    [anon_sym_yield] = ACTIONS(5075),
    [anon_sym_yield_BANG] = ACTIONS(5073),
    [anon_sym_lazy] = ACTIONS(5075),
    [anon_sym_assert] = ACTIONS(5075),
    [anon_sym_upcast] = ACTIONS(5075),
    [anon_sym_downcast] = ACTIONS(5075),
    [anon_sym_for] = ACTIONS(5075),
    [anon_sym_while] = ACTIONS(5075),
    [anon_sym_if] = ACTIONS(5075),
    [anon_sym_fun] = ACTIONS(5075),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(5075),
    [anon_sym_match] = ACTIONS(5075),
    [anon_sym_match_BANG] = ACTIONS(5073),
    [anon_sym_function] = ACTIONS(5075),
    [anon_sym_use] = ACTIONS(5075),
    [anon_sym_use_BANG] = ACTIONS(5073),
    [anon_sym_do_BANG] = ACTIONS(5073),
    [anon_sym_begin] = ACTIONS(5075),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_member] = ACTIONS(5075),
    [anon_sym_abstract] = ACTIONS(5075),
    [anon_sym_override] = ACTIONS(5075),
    [anon_sym_val] = ACTIONS(5075),
    [aux_sym_char_token1] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_AT_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [sym_bool] = ACTIONS(5075),
    [sym_unit] = ACTIONS(5073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5075),
    [sym_op_identifier] = ACTIONS(5073),
    [anon_sym_PLUS] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_PLUS_DOT] = ACTIONS(5073),
    [anon_sym_DASH_DOT] = ACTIONS(5073),
    [anon_sym_PERCENT] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [aux_sym_prefix_op_token1] = ACTIONS(5073),
    [sym_int] = ACTIONS(5075),
    [sym_xint] = ACTIONS(5073),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5073),
    [anon_sym_POUNDload] = ACTIONS(5073),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5073),
  },
  [2804] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(4900),
    [sym_function_declaration_left] = STATE(6920),
    [sym_value_declaration_left] = STATE(6920),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2804),
    [sym_block_comment] = STATE(2804),
    [sym_line_comment] = STATE(2804),
    [sym_compiler_directive_decl] = STATE(2804),
    [sym_fsi_directive_decl] = STATE(2804),
    [sym_preproc_line] = STATE(2804),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2805] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2805),
    [sym_block_comment] = STATE(2805),
    [sym_line_comment] = STATE(2805),
    [sym_compiler_directive_decl] = STATE(2805),
    [sym_fsi_directive_decl] = STATE(2805),
    [sym_preproc_line] = STATE(2805),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(4957),
    [anon_sym_open] = ACTIONS(4957),
    [anon_sym_LBRACK_LT] = ACTIONS(4955),
    [anon_sym_return] = ACTIONS(4957),
    [anon_sym_type] = ACTIONS(4957),
    [anon_sym_do] = ACTIONS(4957),
    [anon_sym_and] = ACTIONS(4957),
    [anon_sym_let] = ACTIONS(4957),
    [anon_sym_let_BANG] = ACTIONS(4955),
    [aux_sym_access_modifier_token1] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(4957),
    [anon_sym_null] = ACTIONS(4957),
    [anon_sym_AMP] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_LT_AT] = ACTIONS(4957),
    [anon_sym_LT_AT_AT] = ACTIONS(4955),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4955),
    [anon_sym_with] = ACTIONS(4957),
    [anon_sym_new] = ACTIONS(4957),
    [anon_sym_return_BANG] = ACTIONS(4955),
    [anon_sym_yield] = ACTIONS(4957),
    [anon_sym_yield_BANG] = ACTIONS(4955),
    [anon_sym_lazy] = ACTIONS(4957),
    [anon_sym_assert] = ACTIONS(4957),
    [anon_sym_upcast] = ACTIONS(4957),
    [anon_sym_downcast] = ACTIONS(4957),
    [anon_sym_for] = ACTIONS(4957),
    [anon_sym_while] = ACTIONS(4957),
    [anon_sym_if] = ACTIONS(4957),
    [anon_sym_fun] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [anon_sym_try] = ACTIONS(4957),
    [anon_sym_match] = ACTIONS(4957),
    [anon_sym_match_BANG] = ACTIONS(4955),
    [anon_sym_function] = ACTIONS(4957),
    [anon_sym_use] = ACTIONS(4957),
    [anon_sym_use_BANG] = ACTIONS(4955),
    [anon_sym_do_BANG] = ACTIONS(4955),
    [anon_sym_begin] = ACTIONS(4957),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(4957),
    [anon_sym_static] = ACTIONS(4957),
    [anon_sym_member] = ACTIONS(4957),
    [anon_sym_abstract] = ACTIONS(4957),
    [anon_sym_override] = ACTIONS(4957),
    [anon_sym_val] = ACTIONS(4957),
    [aux_sym_char_token1] = ACTIONS(4955),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4957),
    [anon_sym_DQUOTE] = ACTIONS(4957),
    [anon_sym_AT_DQUOTE] = ACTIONS(4955),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4955),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4955),
    [sym_bool] = ACTIONS(4957),
    [sym_unit] = ACTIONS(4955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4957),
    [sym_op_identifier] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_DOT] = ACTIONS(4955),
    [anon_sym_DASH_DOT] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [aux_sym_prefix_op_token1] = ACTIONS(4955),
    [sym_int] = ACTIONS(4957),
    [sym_xint] = ACTIONS(4955),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4955),
    [anon_sym_POUNDload] = ACTIONS(4955),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4955),
    [sym__dedent] = ACTIONS(4955),
  },
  [2806] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2806),
    [sym_block_comment] = STATE(2806),
    [sym_line_comment] = STATE(2806),
    [sym_compiler_directive_decl] = STATE(2806),
    [sym_fsi_directive_decl] = STATE(2806),
    [sym_preproc_line] = STATE(2806),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(5077),
    [sym_identifier] = ACTIONS(5079),
    [anon_sym_namespace] = ACTIONS(5079),
    [anon_sym_module] = ACTIONS(5079),
    [anon_sym_open] = ACTIONS(5079),
    [anon_sym_LBRACK_LT] = ACTIONS(5077),
    [anon_sym_return] = ACTIONS(5079),
    [anon_sym_type] = ACTIONS(5079),
    [anon_sym_do] = ACTIONS(5079),
    [anon_sym_and] = ACTIONS(5079),
    [anon_sym_let] = ACTIONS(5079),
    [anon_sym_let_BANG] = ACTIONS(5077),
    [aux_sym_access_modifier_token1] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(5079),
    [anon_sym_null] = ACTIONS(5079),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5077),
    [anon_sym_LBRACE] = ACTIONS(5079),
    [anon_sym_LT_AT] = ACTIONS(5079),
    [anon_sym_LT_AT_AT] = ACTIONS(5077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5077),
    [anon_sym_new] = ACTIONS(5079),
    [anon_sym_return_BANG] = ACTIONS(5077),
    [anon_sym_yield] = ACTIONS(5079),
    [anon_sym_yield_BANG] = ACTIONS(5077),
    [anon_sym_lazy] = ACTIONS(5079),
    [anon_sym_assert] = ACTIONS(5079),
    [anon_sym_upcast] = ACTIONS(5079),
    [anon_sym_downcast] = ACTIONS(5079),
    [anon_sym_for] = ACTIONS(5079),
    [anon_sym_while] = ACTIONS(5079),
    [anon_sym_if] = ACTIONS(5079),
    [anon_sym_fun] = ACTIONS(5079),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(5079),
    [anon_sym_match] = ACTIONS(5079),
    [anon_sym_match_BANG] = ACTIONS(5077),
    [anon_sym_function] = ACTIONS(5079),
    [anon_sym_use] = ACTIONS(5079),
    [anon_sym_use_BANG] = ACTIONS(5077),
    [anon_sym_do_BANG] = ACTIONS(5077),
    [anon_sym_begin] = ACTIONS(5079),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_member] = ACTIONS(5079),
    [anon_sym_abstract] = ACTIONS(5079),
    [anon_sym_override] = ACTIONS(5079),
    [anon_sym_val] = ACTIONS(5079),
    [aux_sym_char_token1] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5079),
    [anon_sym_DQUOTE] = ACTIONS(5079),
    [anon_sym_AT_DQUOTE] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [sym_bool] = ACTIONS(5079),
    [sym_unit] = ACTIONS(5077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5079),
    [sym_op_identifier] = ACTIONS(5077),
    [anon_sym_PLUS] = ACTIONS(5079),
    [anon_sym_DASH] = ACTIONS(5079),
    [anon_sym_PLUS_DOT] = ACTIONS(5077),
    [anon_sym_DASH_DOT] = ACTIONS(5077),
    [anon_sym_PERCENT] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [aux_sym_prefix_op_token1] = ACTIONS(5077),
    [sym_int] = ACTIONS(5079),
    [sym_xint] = ACTIONS(5077),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5077),
    [anon_sym_POUNDload] = ACTIONS(5077),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5077),
  },
  [2807] = {
    [sym_xml_doc] = STATE(2807),
    [sym_block_comment] = STATE(2807),
    [sym_line_comment] = STATE(2807),
    [sym_compiler_directive_decl] = STATE(2807),
    [sym_fsi_directive_decl] = STATE(2807),
    [sym_preproc_line] = STATE(2807),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_and] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [aux_sym_access_modifier_token1] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_member] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_abstract] = ACTIONS(3242),
    [anon_sym_override] = ACTIONS(3242),
    [anon_sym_val] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
  },
  [2808] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(3031),
    [sym__method_defn] = STATE(3038),
    [sym__property_defn] = STATE(3039),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2808),
    [sym_block_comment] = STATE(2808),
    [sym_line_comment] = STATE(2808),
    [sym_compiler_directive_decl] = STATE(2808),
    [sym_fsi_directive_decl] = STATE(2808),
    [sym_preproc_line] = STATE(2808),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2953),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5081),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5083),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2809] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(2973),
    [sym__method_defn] = STATE(4955),
    [sym__property_defn] = STATE(4958),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2809),
    [sym_block_comment] = STATE(2809),
    [sym_line_comment] = STATE(2809),
    [sym_compiler_directive_decl] = STATE(2809),
    [sym_fsi_directive_decl] = STATE(2809),
    [sym_preproc_line] = STATE(2809),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2965),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5085),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5087),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2810] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3487),
    [sym_function_declaration_left] = STATE(7112),
    [sym_value_declaration_left] = STATE(7112),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2810),
    [sym_block_comment] = STATE(2810),
    [sym_line_comment] = STATE(2810),
    [sym_compiler_directive_decl] = STATE(2810),
    [sym_fsi_directive_decl] = STATE(2810),
    [sym_preproc_line] = STATE(2810),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2811] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3508),
    [sym_function_declaration_left] = STATE(6979),
    [sym_value_declaration_left] = STATE(6979),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2811),
    [sym_block_comment] = STATE(2811),
    [sym_line_comment] = STATE(2811),
    [sym_compiler_directive_decl] = STATE(2811),
    [sym_fsi_directive_decl] = STATE(2811),
    [sym_preproc_line] = STATE(2811),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2812] = {
    [sym_attributes] = STATE(5463),
    [sym_attribute_set] = STATE(4720),
    [sym_access_modifier] = STATE(8266),
    [sym_member_defn] = STATE(3134),
    [sym_additional_constr_defn] = STATE(3164),
    [sym_xml_doc] = STATE(2812),
    [sym_block_comment] = STATE(2812),
    [sym_line_comment] = STATE(2812),
    [sym_compiler_directive_decl] = STATE(2812),
    [sym_fsi_directive_decl] = STATE(2812),
    [sym_preproc_line] = STATE(2812),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym__member_defns_repeat1] = STATE(2812),
    [ts_builtin_sym_end] = ACTIONS(5089),
    [sym_identifier] = ACTIONS(5091),
    [anon_sym_namespace] = ACTIONS(5091),
    [anon_sym_module] = ACTIONS(5091),
    [anon_sym_open] = ACTIONS(5091),
    [anon_sym_LBRACK_LT] = ACTIONS(5093),
    [anon_sym_return] = ACTIONS(5091),
    [anon_sym_type] = ACTIONS(5091),
    [anon_sym_do] = ACTIONS(5091),
    [anon_sym_and] = ACTIONS(5091),
    [anon_sym_let] = ACTIONS(5091),
    [anon_sym_let_BANG] = ACTIONS(5089),
    [aux_sym_access_modifier_token1] = ACTIONS(5096),
    [anon_sym_LPAREN] = ACTIONS(5091),
    [anon_sym_null] = ACTIONS(5091),
    [anon_sym_AMP] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5089),
    [anon_sym_LBRACE] = ACTIONS(5091),
    [anon_sym_LT_AT] = ACTIONS(5091),
    [anon_sym_LT_AT_AT] = ACTIONS(5089),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5089),
    [anon_sym_new] = ACTIONS(5099),
    [anon_sym_return_BANG] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(5091),
    [anon_sym_yield_BANG] = ACTIONS(5089),
    [anon_sym_lazy] = ACTIONS(5091),
    [anon_sym_assert] = ACTIONS(5091),
    [anon_sym_upcast] = ACTIONS(5091),
    [anon_sym_downcast] = ACTIONS(5091),
    [anon_sym_for] = ACTIONS(5091),
    [anon_sym_while] = ACTIONS(5091),
    [anon_sym_if] = ACTIONS(5091),
    [anon_sym_fun] = ACTIONS(5091),
    [anon_sym_try] = ACTIONS(5091),
    [anon_sym_match] = ACTIONS(5091),
    [anon_sym_match_BANG] = ACTIONS(5089),
    [anon_sym_function] = ACTIONS(5091),
    [anon_sym_use] = ACTIONS(5091),
    [anon_sym_use_BANG] = ACTIONS(5089),
    [anon_sym_do_BANG] = ACTIONS(5089),
    [anon_sym_begin] = ACTIONS(5091),
    [anon_sym_default] = ACTIONS(5102),
    [anon_sym_static] = ACTIONS(5105),
    [anon_sym_member] = ACTIONS(5108),
    [anon_sym_abstract] = ACTIONS(5111),
    [anon_sym_override] = ACTIONS(5102),
    [anon_sym_val] = ACTIONS(5114),
    [aux_sym_char_token1] = ACTIONS(5089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5091),
    [anon_sym_DQUOTE] = ACTIONS(5091),
    [anon_sym_AT_DQUOTE] = ACTIONS(5089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5089),
    [sym_bool] = ACTIONS(5091),
    [sym_unit] = ACTIONS(5089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5091),
    [sym_op_identifier] = ACTIONS(5089),
    [anon_sym_PLUS] = ACTIONS(5091),
    [anon_sym_DASH] = ACTIONS(5091),
    [anon_sym_PLUS_DOT] = ACTIONS(5089),
    [anon_sym_DASH_DOT] = ACTIONS(5089),
    [anon_sym_PERCENT] = ACTIONS(5089),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5089),
    [aux_sym_prefix_op_token1] = ACTIONS(5089),
    [sym_int] = ACTIONS(5091),
    [sym_xint] = ACTIONS(5089),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5089),
    [anon_sym_POUNDload] = ACTIONS(5089),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5089),
  },
  [2813] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(6752),
    [sym_function_declaration_left] = STATE(7018),
    [sym_value_declaration_left] = STATE(7018),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2813),
    [sym_block_comment] = STATE(2813),
    [sym_line_comment] = STATE(2813),
    [sym_compiler_directive_decl] = STATE(2813),
    [sym_fsi_directive_decl] = STATE(2813),
    [sym_preproc_line] = STATE(2813),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2814] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(3000),
    [sym__method_defn] = STATE(5413),
    [sym__property_defn] = STATE(5412),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2814),
    [sym_block_comment] = STATE(2814),
    [sym_line_comment] = STATE(2814),
    [sym_compiler_directive_decl] = STATE(2814),
    [sym_fsi_directive_decl] = STATE(2814),
    [sym_preproc_line] = STATE(2814),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2950),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5119),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2815] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_type_arguments] = STATE(2969),
    [sym__method_defn] = STATE(4798),
    [sym__property_defn] = STATE(4799),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2815),
    [sym_block_comment] = STATE(2815),
    [sym_line_comment] = STATE(2815),
    [sym_compiler_directive_decl] = STATE(2815),
    [sym_fsi_directive_decl] = STATE(2815),
    [sym_preproc_line] = STATE(2815),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2951),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [anon_sym_with] = ACTIONS(5123),
    [anon_sym_LT2] = ACTIONS(5027),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2816] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym__function_or_value_defn_body] = STATE(3288),
    [sym_function_declaration_left] = STATE(6579),
    [sym_value_declaration_left] = STATE(6579),
    [sym_access_modifier] = STATE(3153),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5607),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3252),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2816),
    [sym_block_comment] = STATE(2816),
    [sym_line_comment] = STATE(2816),
    [sym_compiler_directive_decl] = STATE(2816),
    [sym_fsi_directive_decl] = STATE(2816),
    [sym_preproc_line] = STATE(2816),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4951),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2817] = {
    [sym_attributes] = STATE(5463),
    [sym_attribute_set] = STATE(4720),
    [sym_access_modifier] = STATE(8266),
    [sym_member_defn] = STATE(3134),
    [sym_additional_constr_defn] = STATE(3164),
    [sym_xml_doc] = STATE(2817),
    [sym_block_comment] = STATE(2817),
    [sym_line_comment] = STATE(2817),
    [sym_compiler_directive_decl] = STATE(2817),
    [sym_fsi_directive_decl] = STATE(2817),
    [sym_preproc_line] = STATE(2817),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym__member_defns_repeat1] = STATE(2812),
    [ts_builtin_sym_end] = ACTIONS(5125),
    [sym_identifier] = ACTIONS(5127),
    [anon_sym_namespace] = ACTIONS(5127),
    [anon_sym_module] = ACTIONS(5127),
    [anon_sym_open] = ACTIONS(5127),
    [anon_sym_LBRACK_LT] = ACTIONS(5125),
    [anon_sym_return] = ACTIONS(5127),
    [anon_sym_type] = ACTIONS(5127),
    [anon_sym_do] = ACTIONS(5127),
    [anon_sym_and] = ACTIONS(5127),
    [anon_sym_let] = ACTIONS(5127),
    [anon_sym_let_BANG] = ACTIONS(5125),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5127),
    [anon_sym_null] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_LT_AT] = ACTIONS(5127),
    [anon_sym_LT_AT_AT] = ACTIONS(5125),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5125),
    [anon_sym_new] = ACTIONS(5127),
    [anon_sym_return_BANG] = ACTIONS(5125),
    [anon_sym_yield] = ACTIONS(5127),
    [anon_sym_yield_BANG] = ACTIONS(5125),
    [anon_sym_lazy] = ACTIONS(5127),
    [anon_sym_assert] = ACTIONS(5127),
    [anon_sym_upcast] = ACTIONS(5127),
    [anon_sym_downcast] = ACTIONS(5127),
    [anon_sym_for] = ACTIONS(5127),
    [anon_sym_while] = ACTIONS(5127),
    [anon_sym_if] = ACTIONS(5127),
    [anon_sym_fun] = ACTIONS(5127),
    [anon_sym_try] = ACTIONS(5127),
    [anon_sym_match] = ACTIONS(5127),
    [anon_sym_match_BANG] = ACTIONS(5125),
    [anon_sym_function] = ACTIONS(5127),
    [anon_sym_use] = ACTIONS(5127),
    [anon_sym_use_BANG] = ACTIONS(5125),
    [anon_sym_do_BANG] = ACTIONS(5125),
    [anon_sym_begin] = ACTIONS(5127),
    [anon_sym_default] = ACTIONS(5044),
    [anon_sym_static] = ACTIONS(5046),
    [anon_sym_member] = ACTIONS(5048),
    [anon_sym_abstract] = ACTIONS(5050),
    [anon_sym_override] = ACTIONS(5044),
    [anon_sym_val] = ACTIONS(5052),
    [aux_sym_char_token1] = ACTIONS(5125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5127),
    [anon_sym_DQUOTE] = ACTIONS(5127),
    [anon_sym_AT_DQUOTE] = ACTIONS(5125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5125),
    [sym_bool] = ACTIONS(5127),
    [sym_unit] = ACTIONS(5125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5127),
    [sym_op_identifier] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_DOT] = ACTIONS(5125),
    [anon_sym_DASH_DOT] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_TILDE] = ACTIONS(5125),
    [aux_sym_prefix_op_token1] = ACTIONS(5125),
    [sym_int] = ACTIONS(5127),
    [sym_xint] = ACTIONS(5125),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5125),
    [anon_sym_POUNDload] = ACTIONS(5125),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5125),
  },
  [2818] = {
    [sym_xml_doc] = STATE(2818),
    [sym_block_comment] = STATE(2818),
    [sym_line_comment] = STATE(2818),
    [sym_compiler_directive_decl] = STATE(2818),
    [sym_fsi_directive_decl] = STATE(2818),
    [sym_preproc_line] = STATE(2818),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_open] = ACTIONS(3361),
    [anon_sym_LBRACK_LT] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_and] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [aux_sym_access_modifier_token1] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_or] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_member] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_val] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3363),
    [anon_sym_DASH_DOT] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3363),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3363),
    [anon_sym_POUNDload] = ACTIONS(3363),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__dedent] = ACTIONS(3363),
  },
  [2819] = {
    [sym_xml_doc] = STATE(2819),
    [sym_block_comment] = STATE(2819),
    [sym_line_comment] = STATE(2819),
    [sym_compiler_directive_decl] = STATE(2819),
    [sym_fsi_directive_decl] = STATE(2819),
    [sym_preproc_line] = STATE(2819),
    [aux_sym_long_identifier_repeat1] = STATE(2821),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_and] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [aux_sym_access_modifier_token1] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_member] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_val] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [2820] = {
    [sym_type_arguments] = STATE(2836),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2820),
    [sym_block_comment] = STATE(2820),
    [sym_line_comment] = STATE(2820),
    [sym_compiler_directive_decl] = STATE(2820),
    [sym_fsi_directive_decl] = STATE(2820),
    [sym_preproc_line] = STATE(2820),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym_identifier] = ACTIONS(5131),
    [anon_sym_namespace] = ACTIONS(5131),
    [anon_sym_module] = ACTIONS(5131),
    [anon_sym_open] = ACTIONS(5131),
    [anon_sym_LBRACK_LT] = ACTIONS(5129),
    [anon_sym_return] = ACTIONS(5131),
    [anon_sym_type] = ACTIONS(5131),
    [anon_sym_do] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5131),
    [anon_sym_let] = ACTIONS(5131),
    [anon_sym_let_BANG] = ACTIONS(5129),
    [aux_sym_access_modifier_token1] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5131),
    [anon_sym_null] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5131),
    [anon_sym_LT_AT] = ACTIONS(5131),
    [anon_sym_LT_AT_AT] = ACTIONS(5129),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5129),
    [anon_sym_new] = ACTIONS(5131),
    [anon_sym_return_BANG] = ACTIONS(5129),
    [anon_sym_yield] = ACTIONS(5131),
    [anon_sym_yield_BANG] = ACTIONS(5129),
    [anon_sym_lazy] = ACTIONS(5131),
    [anon_sym_assert] = ACTIONS(5131),
    [anon_sym_upcast] = ACTIONS(5131),
    [anon_sym_downcast] = ACTIONS(5131),
    [anon_sym_for] = ACTIONS(5131),
    [anon_sym_while] = ACTIONS(5131),
    [anon_sym_if] = ACTIONS(5131),
    [anon_sym_fun] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(5131),
    [anon_sym_match] = ACTIONS(5131),
    [anon_sym_match_BANG] = ACTIONS(5129),
    [anon_sym_function] = ACTIONS(5131),
    [anon_sym_use] = ACTIONS(5131),
    [anon_sym_use_BANG] = ACTIONS(5129),
    [anon_sym_do_BANG] = ACTIONS(5129),
    [anon_sym_begin] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_default] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_member] = ACTIONS(5131),
    [anon_sym_abstract] = ACTIONS(5131),
    [anon_sym_override] = ACTIONS(5131),
    [anon_sym_val] = ACTIONS(5131),
    [aux_sym_char_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [anon_sym_AT_DQUOTE] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [sym_bool] = ACTIONS(5131),
    [sym_unit] = ACTIONS(5129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5131),
    [sym_op_identifier] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_DOT] = ACTIONS(5129),
    [anon_sym_DASH_DOT] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [aux_sym_prefix_op_token1] = ACTIONS(5129),
    [sym_int] = ACTIONS(5131),
    [sym_xint] = ACTIONS(5129),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5129),
    [anon_sym_POUNDload] = ACTIONS(5129),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5129),
  },
  [2821] = {
    [sym_xml_doc] = STATE(2821),
    [sym_block_comment] = STATE(2821),
    [sym_line_comment] = STATE(2821),
    [sym_compiler_directive_decl] = STATE(2821),
    [sym_fsi_directive_decl] = STATE(2821),
    [sym_preproc_line] = STATE(2821),
    [aux_sym_long_identifier_repeat1] = STATE(2781),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_and] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [aux_sym_access_modifier_token1] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [anon_sym_default] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_member] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_val] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [2822] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2822),
    [sym_block_comment] = STATE(2822),
    [sym_line_comment] = STATE(2822),
    [sym_compiler_directive_decl] = STATE(2822),
    [sym_fsi_directive_decl] = STATE(2822),
    [sym_preproc_line] = STATE(2822),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(5131),
    [anon_sym_module] = ACTIONS(5131),
    [anon_sym_open] = ACTIONS(5131),
    [anon_sym_LBRACK_LT] = ACTIONS(5129),
    [anon_sym_return] = ACTIONS(5131),
    [anon_sym_type] = ACTIONS(5131),
    [anon_sym_do] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5131),
    [anon_sym_let] = ACTIONS(5131),
    [anon_sym_let_BANG] = ACTIONS(5129),
    [aux_sym_access_modifier_token1] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5131),
    [anon_sym_null] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5131),
    [anon_sym_LT_AT] = ACTIONS(5131),
    [anon_sym_LT_AT_AT] = ACTIONS(5129),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5129),
    [anon_sym_new] = ACTIONS(5131),
    [anon_sym_return_BANG] = ACTIONS(5129),
    [anon_sym_yield] = ACTIONS(5131),
    [anon_sym_yield_BANG] = ACTIONS(5129),
    [anon_sym_lazy] = ACTIONS(5131),
    [anon_sym_assert] = ACTIONS(5131),
    [anon_sym_upcast] = ACTIONS(5131),
    [anon_sym_downcast] = ACTIONS(5131),
    [anon_sym_for] = ACTIONS(5131),
    [anon_sym_while] = ACTIONS(5131),
    [anon_sym_if] = ACTIONS(5131),
    [anon_sym_fun] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(5131),
    [anon_sym_match] = ACTIONS(5131),
    [anon_sym_match_BANG] = ACTIONS(5129),
    [anon_sym_function] = ACTIONS(5131),
    [anon_sym_use] = ACTIONS(5131),
    [anon_sym_use_BANG] = ACTIONS(5129),
    [anon_sym_do_BANG] = ACTIONS(5129),
    [anon_sym_begin] = ACTIONS(5131),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_member] = ACTIONS(5131),
    [anon_sym_abstract] = ACTIONS(5131),
    [anon_sym_override] = ACTIONS(5131),
    [anon_sym_val] = ACTIONS(5131),
    [aux_sym_char_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [anon_sym_AT_DQUOTE] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [sym_bool] = ACTIONS(5131),
    [sym_unit] = ACTIONS(5129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5131),
    [sym_op_identifier] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_DOT] = ACTIONS(5129),
    [anon_sym_DASH_DOT] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [aux_sym_prefix_op_token1] = ACTIONS(5129),
    [sym_int] = ACTIONS(5131),
    [sym_xint] = ACTIONS(5129),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5129),
    [anon_sym_POUNDload] = ACTIONS(5129),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5129),
    [sym__dedent] = ACTIONS(5129),
  },
  [2823] = {
    [sym_xml_doc] = STATE(2823),
    [sym_block_comment] = STATE(2823),
    [sym_line_comment] = STATE(2823),
    [sym_compiler_directive_decl] = STATE(2823),
    [sym_fsi_directive_decl] = STATE(2823),
    [sym_preproc_line] = STATE(2823),
    [aux_sym__compound_type_repeat1] = STATE(2823),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_open] = ACTIONS(3032),
    [anon_sym_LBRACK_LT] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [aux_sym_access_modifier_token1] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_member] = ACTIONS(3032),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_val] = ACTIONS(3032),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3030),
    [anon_sym_POUNDload] = ACTIONS(3030),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [2824] = {
    [sym_xml_doc] = STATE(2824),
    [sym_block_comment] = STATE(2824),
    [sym_line_comment] = STATE(2824),
    [sym_compiler_directive_decl] = STATE(2824),
    [sym_fsi_directive_decl] = STATE(2824),
    [sym_preproc_line] = STATE(2824),
    [ts_builtin_sym_end] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_and] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [aux_sym_access_modifier_token1] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_member] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_val] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
  },
  [2825] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2825),
    [sym_block_comment] = STATE(2825),
    [sym_line_comment] = STATE(2825),
    [sym_compiler_directive_decl] = STATE(2825),
    [sym_fsi_directive_decl] = STATE(2825),
    [sym_preproc_line] = STATE(2825),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(5075),
    [anon_sym_module] = ACTIONS(5075),
    [anon_sym_open] = ACTIONS(5075),
    [anon_sym_LBRACK_LT] = ACTIONS(5073),
    [anon_sym_return] = ACTIONS(5075),
    [anon_sym_type] = ACTIONS(5075),
    [anon_sym_do] = ACTIONS(5075),
    [anon_sym_and] = ACTIONS(5075),
    [anon_sym_let] = ACTIONS(5075),
    [anon_sym_let_BANG] = ACTIONS(5073),
    [aux_sym_access_modifier_token1] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5075),
    [anon_sym_null] = ACTIONS(5075),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5073),
    [anon_sym_LBRACE] = ACTIONS(5075),
    [anon_sym_LT_AT] = ACTIONS(5075),
    [anon_sym_LT_AT_AT] = ACTIONS(5073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5073),
    [anon_sym_new] = ACTIONS(5075),
    [anon_sym_return_BANG] = ACTIONS(5073),
    [anon_sym_yield] = ACTIONS(5075),
    [anon_sym_yield_BANG] = ACTIONS(5073),
    [anon_sym_lazy] = ACTIONS(5075),
    [anon_sym_assert] = ACTIONS(5075),
    [anon_sym_upcast] = ACTIONS(5075),
    [anon_sym_downcast] = ACTIONS(5075),
    [anon_sym_for] = ACTIONS(5075),
    [anon_sym_while] = ACTIONS(5075),
    [anon_sym_if] = ACTIONS(5075),
    [anon_sym_fun] = ACTIONS(5075),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(5075),
    [anon_sym_match] = ACTIONS(5075),
    [anon_sym_match_BANG] = ACTIONS(5073),
    [anon_sym_function] = ACTIONS(5075),
    [anon_sym_use] = ACTIONS(5075),
    [anon_sym_use_BANG] = ACTIONS(5073),
    [anon_sym_do_BANG] = ACTIONS(5073),
    [anon_sym_begin] = ACTIONS(5075),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_member] = ACTIONS(5075),
    [anon_sym_abstract] = ACTIONS(5075),
    [anon_sym_override] = ACTIONS(5075),
    [anon_sym_val] = ACTIONS(5075),
    [aux_sym_char_token1] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_AT_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [sym_bool] = ACTIONS(5075),
    [sym_unit] = ACTIONS(5073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5075),
    [sym_op_identifier] = ACTIONS(5073),
    [anon_sym_PLUS] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_PLUS_DOT] = ACTIONS(5073),
    [anon_sym_DASH_DOT] = ACTIONS(5073),
    [anon_sym_PERCENT] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [aux_sym_prefix_op_token1] = ACTIONS(5073),
    [sym_int] = ACTIONS(5075),
    [sym_xint] = ACTIONS(5073),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5073),
    [anon_sym_POUNDload] = ACTIONS(5073),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5073),
    [sym__dedent] = ACTIONS(5073),
  },
  [2826] = {
    [sym_xml_doc] = STATE(2826),
    [sym_block_comment] = STATE(2826),
    [sym_line_comment] = STATE(2826),
    [sym_compiler_directive_decl] = STATE(2826),
    [sym_fsi_directive_decl] = STATE(2826),
    [sym_preproc_line] = STATE(2826),
    [ts_builtin_sym_end] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_namespace] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_open] = ACTIONS(3300),
    [anon_sym_LBRACK_LT] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_and] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [aux_sym_access_modifier_token1] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3300),
    [anon_sym_member] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_abstract] = ACTIONS(3300),
    [anon_sym_override] = ACTIONS(3300),
    [anon_sym_val] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3302),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3302),
    [anon_sym_DASH_DOT] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3302),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3302),
    [anon_sym_POUNDload] = ACTIONS(3302),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
  },
  [2827] = {
    [sym_xml_doc] = STATE(2827),
    [sym_block_comment] = STATE(2827),
    [sym_line_comment] = STATE(2827),
    [sym_compiler_directive_decl] = STATE(2827),
    [sym_fsi_directive_decl] = STATE(2827),
    [sym_preproc_line] = STATE(2827),
    [ts_builtin_sym_end] = ACTIONS(3306),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_namespace] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_open] = ACTIONS(3304),
    [anon_sym_LBRACK_LT] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_and] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [aux_sym_access_modifier_token1] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_default] = ACTIONS(3304),
    [anon_sym_static] = ACTIONS(3304),
    [anon_sym_member] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_abstract] = ACTIONS(3304),
    [anon_sym_override] = ACTIONS(3304),
    [anon_sym_val] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3306),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3306),
    [anon_sym_DASH_DOT] = ACTIONS(3306),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3306),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3306),
    [anon_sym_POUNDload] = ACTIONS(3306),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
  },
  [2828] = {
    [sym_xml_doc] = STATE(2828),
    [sym_block_comment] = STATE(2828),
    [sym_line_comment] = STATE(2828),
    [sym_compiler_directive_decl] = STATE(2828),
    [sym_fsi_directive_decl] = STATE(2828),
    [sym_preproc_line] = STATE(2828),
    [aux_sym__compound_type_repeat1] = STATE(2823),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_open] = ACTIONS(3212),
    [anon_sym_LBRACK_LT] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_and] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [aux_sym_access_modifier_token1] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_member] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_override] = ACTIONS(3212),
    [anon_sym_val] = ACTIONS(3212),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3214),
    [anon_sym_DASH_DOT] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3214),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3214),
    [anon_sym_POUNDload] = ACTIONS(3214),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__dedent] = ACTIONS(3214),
  },
  [2829] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2829),
    [sym_block_comment] = STATE(2829),
    [sym_line_comment] = STATE(2829),
    [sym_compiler_directive_decl] = STATE(2829),
    [sym_fsi_directive_decl] = STATE(2829),
    [sym_preproc_line] = STATE(2829),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(5038),
    [anon_sym_module] = ACTIONS(5038),
    [anon_sym_open] = ACTIONS(5038),
    [anon_sym_LBRACK_LT] = ACTIONS(5036),
    [anon_sym_return] = ACTIONS(5038),
    [anon_sym_type] = ACTIONS(5038),
    [anon_sym_do] = ACTIONS(5038),
    [anon_sym_and] = ACTIONS(5038),
    [anon_sym_let] = ACTIONS(5038),
    [anon_sym_let_BANG] = ACTIONS(5036),
    [aux_sym_access_modifier_token1] = ACTIONS(5036),
    [anon_sym_LPAREN] = ACTIONS(5038),
    [anon_sym_null] = ACTIONS(5038),
    [anon_sym_AMP] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(5038),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(5038),
    [anon_sym_LT_AT] = ACTIONS(5038),
    [anon_sym_LT_AT_AT] = ACTIONS(5036),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5036),
    [anon_sym_new] = ACTIONS(5038),
    [anon_sym_return_BANG] = ACTIONS(5036),
    [anon_sym_yield] = ACTIONS(5038),
    [anon_sym_yield_BANG] = ACTIONS(5036),
    [anon_sym_lazy] = ACTIONS(5038),
    [anon_sym_assert] = ACTIONS(5038),
    [anon_sym_upcast] = ACTIONS(5038),
    [anon_sym_downcast] = ACTIONS(5038),
    [anon_sym_for] = ACTIONS(5038),
    [anon_sym_while] = ACTIONS(5038),
    [anon_sym_if] = ACTIONS(5038),
    [anon_sym_fun] = ACTIONS(5038),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(5038),
    [anon_sym_match] = ACTIONS(5038),
    [anon_sym_match_BANG] = ACTIONS(5036),
    [anon_sym_function] = ACTIONS(5038),
    [anon_sym_use] = ACTIONS(5038),
    [anon_sym_use_BANG] = ACTIONS(5036),
    [anon_sym_do_BANG] = ACTIONS(5036),
    [anon_sym_begin] = ACTIONS(5038),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(5038),
    [anon_sym_static] = ACTIONS(5038),
    [anon_sym_member] = ACTIONS(5038),
    [anon_sym_abstract] = ACTIONS(5038),
    [anon_sym_override] = ACTIONS(5038),
    [anon_sym_val] = ACTIONS(5038),
    [aux_sym_char_token1] = ACTIONS(5036),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5038),
    [anon_sym_DQUOTE] = ACTIONS(5038),
    [anon_sym_AT_DQUOTE] = ACTIONS(5036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5036),
    [sym_bool] = ACTIONS(5038),
    [sym_unit] = ACTIONS(5036),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5038),
    [sym_op_identifier] = ACTIONS(5036),
    [anon_sym_PLUS] = ACTIONS(5038),
    [anon_sym_DASH] = ACTIONS(5038),
    [anon_sym_PLUS_DOT] = ACTIONS(5036),
    [anon_sym_DASH_DOT] = ACTIONS(5036),
    [anon_sym_PERCENT] = ACTIONS(5036),
    [anon_sym_AMP_AMP] = ACTIONS(5036),
    [anon_sym_TILDE] = ACTIONS(5036),
    [aux_sym_prefix_op_token1] = ACTIONS(5036),
    [sym_int] = ACTIONS(5038),
    [sym_xint] = ACTIONS(5036),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5036),
    [anon_sym_POUNDload] = ACTIONS(5036),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5036),
    [sym__dedent] = ACTIONS(5036),
  },
  [2830] = {
    [sym_xml_doc] = STATE(2830),
    [sym_block_comment] = STATE(2830),
    [sym_line_comment] = STATE(2830),
    [sym_compiler_directive_decl] = STATE(2830),
    [sym_fsi_directive_decl] = STATE(2830),
    [sym_preproc_line] = STATE(2830),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_namespace] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_open] = ACTIONS(3292),
    [anon_sym_LBRACK_LT] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_and] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [aux_sym_access_modifier_token1] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_default] = ACTIONS(3292),
    [anon_sym_static] = ACTIONS(3292),
    [anon_sym_member] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_abstract] = ACTIONS(3292),
    [anon_sym_override] = ACTIONS(3292),
    [anon_sym_val] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3294),
    [anon_sym_DASH_DOT] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3294),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3294),
    [anon_sym_POUNDload] = ACTIONS(3294),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
  },
  [2831] = {
    [sym_xml_doc] = STATE(2831),
    [sym_block_comment] = STATE(2831),
    [sym_line_comment] = STATE(2831),
    [sym_compiler_directive_decl] = STATE(2831),
    [sym_fsi_directive_decl] = STATE(2831),
    [sym_preproc_line] = STATE(2831),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_and] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [aux_sym_access_modifier_token1] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(5136),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_member] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_val] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [2832] = {
    [sym_xml_doc] = STATE(2832),
    [sym_block_comment] = STATE(2832),
    [sym_line_comment] = STATE(2832),
    [sym_compiler_directive_decl] = STATE(2832),
    [sym_fsi_directive_decl] = STATE(2832),
    [sym_preproc_line] = STATE(2832),
    [ts_builtin_sym_end] = ACTIONS(3320),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_open] = ACTIONS(3318),
    [anon_sym_LBRACK_LT] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_and] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [aux_sym_access_modifier_token1] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_member] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_abstract] = ACTIONS(3318),
    [anon_sym_override] = ACTIONS(3318),
    [anon_sym_val] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3320),
    [anon_sym_DASH_DOT] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3320),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3320),
    [anon_sym_POUNDload] = ACTIONS(3320),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
  },
  [2833] = {
    [sym_xml_doc] = STATE(2833),
    [sym_block_comment] = STATE(2833),
    [sym_line_comment] = STATE(2833),
    [sym_compiler_directive_decl] = STATE(2833),
    [sym_fsi_directive_decl] = STATE(2833),
    [sym_preproc_line] = STATE(2833),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_and] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [aux_sym_access_modifier_token1] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_member] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_val] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [2834] = {
    [sym_xml_doc] = STATE(2834),
    [sym_block_comment] = STATE(2834),
    [sym_line_comment] = STATE(2834),
    [sym_compiler_directive_decl] = STATE(2834),
    [sym_fsi_directive_decl] = STATE(2834),
    [sym_preproc_line] = STATE(2834),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_open] = ACTIONS(3242),
    [anon_sym_LBRACK_LT] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_and] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [aux_sym_access_modifier_token1] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_member] = ACTIONS(3242),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_abstract] = ACTIONS(3242),
    [anon_sym_override] = ACTIONS(3242),
    [anon_sym_val] = ACTIONS(3242),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3244),
    [anon_sym_POUNDload] = ACTIONS(3244),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [2835] = {
    [sym_attributes] = STATE(5563),
    [sym_attribute_set] = STATE(4720),
    [sym_access_modifier] = STATE(8000),
    [sym_member_defn] = STATE(3205),
    [sym_additional_constr_defn] = STATE(3208),
    [sym_xml_doc] = STATE(2835),
    [sym_block_comment] = STATE(2835),
    [sym_line_comment] = STATE(2835),
    [sym_compiler_directive_decl] = STATE(2835),
    [sym_fsi_directive_decl] = STATE(2835),
    [sym_preproc_line] = STATE(2835),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym__member_defns_repeat1] = STATE(2845),
    [sym_identifier] = ACTIONS(5042),
    [anon_sym_module] = ACTIONS(5042),
    [anon_sym_open] = ACTIONS(5042),
    [anon_sym_LBRACK_LT] = ACTIONS(5040),
    [anon_sym_return] = ACTIONS(5042),
    [anon_sym_type] = ACTIONS(5042),
    [anon_sym_do] = ACTIONS(5042),
    [anon_sym_and] = ACTIONS(5042),
    [anon_sym_let] = ACTIONS(5042),
    [anon_sym_let_BANG] = ACTIONS(5040),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5042),
    [anon_sym_null] = ACTIONS(5042),
    [anon_sym_AMP] = ACTIONS(5042),
    [anon_sym_LBRACK] = ACTIONS(5042),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5040),
    [anon_sym_LBRACE] = ACTIONS(5042),
    [anon_sym_LT_AT] = ACTIONS(5042),
    [anon_sym_LT_AT_AT] = ACTIONS(5040),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5040),
    [anon_sym_new] = ACTIONS(5042),
    [anon_sym_return_BANG] = ACTIONS(5040),
    [anon_sym_yield] = ACTIONS(5042),
    [anon_sym_yield_BANG] = ACTIONS(5040),
    [anon_sym_lazy] = ACTIONS(5042),
    [anon_sym_assert] = ACTIONS(5042),
    [anon_sym_upcast] = ACTIONS(5042),
    [anon_sym_downcast] = ACTIONS(5042),
    [anon_sym_for] = ACTIONS(5042),
    [anon_sym_while] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(5042),
    [anon_sym_fun] = ACTIONS(5042),
    [anon_sym_try] = ACTIONS(5042),
    [anon_sym_match] = ACTIONS(5042),
    [anon_sym_match_BANG] = ACTIONS(5040),
    [anon_sym_function] = ACTIONS(5042),
    [anon_sym_use] = ACTIONS(5042),
    [anon_sym_use_BANG] = ACTIONS(5040),
    [anon_sym_do_BANG] = ACTIONS(5040),
    [anon_sym_begin] = ACTIONS(5042),
    [anon_sym_default] = ACTIONS(5138),
    [anon_sym_static] = ACTIONS(5140),
    [anon_sym_member] = ACTIONS(5142),
    [anon_sym_abstract] = ACTIONS(5144),
    [anon_sym_override] = ACTIONS(5138),
    [anon_sym_val] = ACTIONS(5146),
    [aux_sym_char_token1] = ACTIONS(5040),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [anon_sym_AT_DQUOTE] = ACTIONS(5040),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5040),
    [sym_bool] = ACTIONS(5042),
    [sym_unit] = ACTIONS(5040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5042),
    [sym_op_identifier] = ACTIONS(5040),
    [anon_sym_PLUS] = ACTIONS(5042),
    [anon_sym_DASH] = ACTIONS(5042),
    [anon_sym_PLUS_DOT] = ACTIONS(5040),
    [anon_sym_DASH_DOT] = ACTIONS(5040),
    [anon_sym_PERCENT] = ACTIONS(5040),
    [anon_sym_AMP_AMP] = ACTIONS(5040),
    [anon_sym_TILDE] = ACTIONS(5040),
    [aux_sym_prefix_op_token1] = ACTIONS(5040),
    [sym_int] = ACTIONS(5042),
    [sym_xint] = ACTIONS(5040),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5040),
    [anon_sym_POUNDload] = ACTIONS(5040),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5040),
    [sym__dedent] = ACTIONS(5040),
  },
  [2836] = {
    [sym_xml_doc] = STATE(2836),
    [sym_block_comment] = STATE(2836),
    [sym_line_comment] = STATE(2836),
    [sym_compiler_directive_decl] = STATE(2836),
    [sym_fsi_directive_decl] = STATE(2836),
    [sym_preproc_line] = STATE(2836),
    [ts_builtin_sym_end] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_namespace] = ACTIONS(3336),
    [anon_sym_module] = ACTIONS(3336),
    [anon_sym_open] = ACTIONS(3336),
    [anon_sym_LBRACK_LT] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_type] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_and] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [aux_sym_access_modifier_token1] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_member] = ACTIONS(3336),
    [anon_sym_interface] = ACTIONS(3336),
    [anon_sym_abstract] = ACTIONS(3336),
    [anon_sym_override] = ACTIONS(3336),
    [anon_sym_val] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3338),
    [anon_sym_DASH_DOT] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3338),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3338),
    [anon_sym_POUNDload] = ACTIONS(3338),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
  },
  [2837] = {
    [sym_xml_doc] = STATE(2837),
    [sym_block_comment] = STATE(2837),
    [sym_line_comment] = STATE(2837),
    [sym_compiler_directive_decl] = STATE(2837),
    [sym_fsi_directive_decl] = STATE(2837),
    [sym_preproc_line] = STATE(2837),
    [ts_builtin_sym_end] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_open] = ACTIONS(3340),
    [anon_sym_LBRACK_LT] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_and] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [aux_sym_access_modifier_token1] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_member] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_abstract] = ACTIONS(3340),
    [anon_sym_override] = ACTIONS(3340),
    [anon_sym_val] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3342),
    [anon_sym_DASH_DOT] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3342),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3342),
    [anon_sym_POUNDload] = ACTIONS(3342),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
  },
  [2838] = {
    [sym_attributes] = STATE(5563),
    [sym_attribute_set] = STATE(4720),
    [sym_access_modifier] = STATE(8000),
    [sym_member_defn] = STATE(3205),
    [sym_additional_constr_defn] = STATE(3208),
    [sym_xml_doc] = STATE(2838),
    [sym_block_comment] = STATE(2838),
    [sym_line_comment] = STATE(2838),
    [sym_compiler_directive_decl] = STATE(2838),
    [sym_fsi_directive_decl] = STATE(2838),
    [sym_preproc_line] = STATE(2838),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym__member_defns_repeat1] = STATE(2838),
    [sym_identifier] = ACTIONS(5091),
    [anon_sym_module] = ACTIONS(5091),
    [anon_sym_open] = ACTIONS(5091),
    [anon_sym_LBRACK_LT] = ACTIONS(5093),
    [anon_sym_return] = ACTIONS(5091),
    [anon_sym_type] = ACTIONS(5091),
    [anon_sym_do] = ACTIONS(5091),
    [anon_sym_and] = ACTIONS(5091),
    [anon_sym_let] = ACTIONS(5091),
    [anon_sym_let_BANG] = ACTIONS(5089),
    [aux_sym_access_modifier_token1] = ACTIONS(5096),
    [anon_sym_LPAREN] = ACTIONS(5091),
    [anon_sym_null] = ACTIONS(5091),
    [anon_sym_AMP] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5089),
    [anon_sym_LBRACE] = ACTIONS(5091),
    [anon_sym_LT_AT] = ACTIONS(5091),
    [anon_sym_LT_AT_AT] = ACTIONS(5089),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5089),
    [anon_sym_new] = ACTIONS(5148),
    [anon_sym_return_BANG] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(5091),
    [anon_sym_yield_BANG] = ACTIONS(5089),
    [anon_sym_lazy] = ACTIONS(5091),
    [anon_sym_assert] = ACTIONS(5091),
    [anon_sym_upcast] = ACTIONS(5091),
    [anon_sym_downcast] = ACTIONS(5091),
    [anon_sym_for] = ACTIONS(5091),
    [anon_sym_while] = ACTIONS(5091),
    [anon_sym_if] = ACTIONS(5091),
    [anon_sym_fun] = ACTIONS(5091),
    [anon_sym_try] = ACTIONS(5091),
    [anon_sym_match] = ACTIONS(5091),
    [anon_sym_match_BANG] = ACTIONS(5089),
    [anon_sym_function] = ACTIONS(5091),
    [anon_sym_use] = ACTIONS(5091),
    [anon_sym_use_BANG] = ACTIONS(5089),
    [anon_sym_do_BANG] = ACTIONS(5089),
    [anon_sym_begin] = ACTIONS(5091),
    [anon_sym_default] = ACTIONS(5151),
    [anon_sym_static] = ACTIONS(5154),
    [anon_sym_member] = ACTIONS(5157),
    [anon_sym_abstract] = ACTIONS(5160),
    [anon_sym_override] = ACTIONS(5151),
    [anon_sym_val] = ACTIONS(5163),
    [aux_sym_char_token1] = ACTIONS(5089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5091),
    [anon_sym_DQUOTE] = ACTIONS(5091),
    [anon_sym_AT_DQUOTE] = ACTIONS(5089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5089),
    [sym_bool] = ACTIONS(5091),
    [sym_unit] = ACTIONS(5089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5091),
    [sym_op_identifier] = ACTIONS(5089),
    [anon_sym_PLUS] = ACTIONS(5091),
    [anon_sym_DASH] = ACTIONS(5091),
    [anon_sym_PLUS_DOT] = ACTIONS(5089),
    [anon_sym_DASH_DOT] = ACTIONS(5089),
    [anon_sym_PERCENT] = ACTIONS(5089),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5089),
    [aux_sym_prefix_op_token1] = ACTIONS(5089),
    [sym_int] = ACTIONS(5091),
    [sym_xint] = ACTIONS(5089),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5089),
    [anon_sym_POUNDload] = ACTIONS(5089),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5089),
    [sym__dedent] = ACTIONS(5089),
  },
  [2839] = {
    [sym_xml_doc] = STATE(2839),
    [sym_block_comment] = STATE(2839),
    [sym_line_comment] = STATE(2839),
    [sym_compiler_directive_decl] = STATE(2839),
    [sym_fsi_directive_decl] = STATE(2839),
    [sym_preproc_line] = STATE(2839),
    [ts_builtin_sym_end] = ACTIONS(3357),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_open] = ACTIONS(3355),
    [anon_sym_LBRACK_LT] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_and] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [aux_sym_access_modifier_token1] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LT2] = ACTIONS(5166),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_member] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_val] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3357),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3357),
    [anon_sym_DASH_DOT] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3357),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3357),
    [anon_sym_POUNDload] = ACTIONS(3357),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
  },
  [2840] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2840),
    [sym_block_comment] = STATE(2840),
    [sym_line_comment] = STATE(2840),
    [sym_compiler_directive_decl] = STATE(2840),
    [sym_fsi_directive_decl] = STATE(2840),
    [sym_preproc_line] = STATE(2840),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(5071),
    [anon_sym_module] = ACTIONS(5071),
    [anon_sym_open] = ACTIONS(5071),
    [anon_sym_LBRACK_LT] = ACTIONS(5069),
    [anon_sym_return] = ACTIONS(5071),
    [anon_sym_type] = ACTIONS(5071),
    [anon_sym_do] = ACTIONS(5071),
    [anon_sym_and] = ACTIONS(5071),
    [anon_sym_let] = ACTIONS(5071),
    [anon_sym_let_BANG] = ACTIONS(5069),
    [aux_sym_access_modifier_token1] = ACTIONS(5069),
    [anon_sym_LPAREN] = ACTIONS(5071),
    [anon_sym_null] = ACTIONS(5071),
    [anon_sym_AMP] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5069),
    [anon_sym_LBRACE] = ACTIONS(5071),
    [anon_sym_LT_AT] = ACTIONS(5071),
    [anon_sym_LT_AT_AT] = ACTIONS(5069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5069),
    [anon_sym_new] = ACTIONS(5071),
    [anon_sym_return_BANG] = ACTIONS(5069),
    [anon_sym_yield] = ACTIONS(5071),
    [anon_sym_yield_BANG] = ACTIONS(5069),
    [anon_sym_lazy] = ACTIONS(5071),
    [anon_sym_assert] = ACTIONS(5071),
    [anon_sym_upcast] = ACTIONS(5071),
    [anon_sym_downcast] = ACTIONS(5071),
    [anon_sym_for] = ACTIONS(5071),
    [anon_sym_while] = ACTIONS(5071),
    [anon_sym_if] = ACTIONS(5071),
    [anon_sym_fun] = ACTIONS(5071),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(5071),
    [anon_sym_match] = ACTIONS(5071),
    [anon_sym_match_BANG] = ACTIONS(5069),
    [anon_sym_function] = ACTIONS(5071),
    [anon_sym_use] = ACTIONS(5071),
    [anon_sym_use_BANG] = ACTIONS(5069),
    [anon_sym_do_BANG] = ACTIONS(5069),
    [anon_sym_begin] = ACTIONS(5071),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_member] = ACTIONS(5071),
    [anon_sym_abstract] = ACTIONS(5071),
    [anon_sym_override] = ACTIONS(5071),
    [anon_sym_val] = ACTIONS(5071),
    [aux_sym_char_token1] = ACTIONS(5069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5071),
    [anon_sym_DQUOTE] = ACTIONS(5071),
    [anon_sym_AT_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5069),
    [sym_bool] = ACTIONS(5071),
    [sym_unit] = ACTIONS(5069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5071),
    [sym_op_identifier] = ACTIONS(5069),
    [anon_sym_PLUS] = ACTIONS(5071),
    [anon_sym_DASH] = ACTIONS(5071),
    [anon_sym_PLUS_DOT] = ACTIONS(5069),
    [anon_sym_DASH_DOT] = ACTIONS(5069),
    [anon_sym_PERCENT] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_TILDE] = ACTIONS(5069),
    [aux_sym_prefix_op_token1] = ACTIONS(5069),
    [sym_int] = ACTIONS(5071),
    [sym_xint] = ACTIONS(5069),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5069),
    [anon_sym_POUNDload] = ACTIONS(5069),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5069),
    [sym__dedent] = ACTIONS(5069),
  },
  [2841] = {
    [sym_xml_doc] = STATE(2841),
    [sym_block_comment] = STATE(2841),
    [sym_line_comment] = STATE(2841),
    [sym_compiler_directive_decl] = STATE(2841),
    [sym_fsi_directive_decl] = STATE(2841),
    [sym_preproc_line] = STATE(2841),
    [ts_builtin_sym_end] = ACTIONS(3324),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_open] = ACTIONS(3322),
    [anon_sym_LBRACK_LT] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_and] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [aux_sym_access_modifier_token1] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_member] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_abstract] = ACTIONS(3322),
    [anon_sym_override] = ACTIONS(3322),
    [anon_sym_val] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3324),
    [anon_sym_DASH_DOT] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3324),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3324),
    [anon_sym_POUNDload] = ACTIONS(3324),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
  },
  [2842] = {
    [sym_xml_doc] = STATE(2842),
    [sym_block_comment] = STATE(2842),
    [sym_line_comment] = STATE(2842),
    [sym_compiler_directive_decl] = STATE(2842),
    [sym_fsi_directive_decl] = STATE(2842),
    [sym_preproc_line] = STATE(2842),
    [ts_builtin_sym_end] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_open] = ACTIONS(3296),
    [anon_sym_LBRACK_LT] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_and] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [aux_sym_access_modifier_token1] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3296),
    [anon_sym_static] = ACTIONS(3296),
    [anon_sym_member] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_abstract] = ACTIONS(3296),
    [anon_sym_override] = ACTIONS(3296),
    [anon_sym_val] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3298),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3298),
    [anon_sym_DASH_DOT] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3298),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3298),
    [anon_sym_POUNDload] = ACTIONS(3298),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
  },
  [2843] = {
    [sym_xml_doc] = STATE(2843),
    [sym_block_comment] = STATE(2843),
    [sym_line_comment] = STATE(2843),
    [sym_compiler_directive_decl] = STATE(2843),
    [sym_fsi_directive_decl] = STATE(2843),
    [sym_preproc_line] = STATE(2843),
    [ts_builtin_sym_end] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_open] = ACTIONS(3308),
    [anon_sym_LBRACK_LT] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_and] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [aux_sym_access_modifier_token1] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_member] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_abstract] = ACTIONS(3308),
    [anon_sym_override] = ACTIONS(3308),
    [anon_sym_val] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3310),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3310),
    [anon_sym_DASH_DOT] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3310),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3310),
    [anon_sym_POUNDload] = ACTIONS(3310),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
  },
  [2844] = {
    [sym_type_arguments] = STATE(2853),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2844),
    [sym_block_comment] = STATE(2844),
    [sym_line_comment] = STATE(2844),
    [sym_compiler_directive_decl] = STATE(2844),
    [sym_fsi_directive_decl] = STATE(2844),
    [sym_preproc_line] = STATE(2844),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(5079),
    [anon_sym_module] = ACTIONS(5079),
    [anon_sym_open] = ACTIONS(5079),
    [anon_sym_LBRACK_LT] = ACTIONS(5077),
    [anon_sym_return] = ACTIONS(5079),
    [anon_sym_type] = ACTIONS(5079),
    [anon_sym_do] = ACTIONS(5079),
    [anon_sym_and] = ACTIONS(5079),
    [anon_sym_let] = ACTIONS(5079),
    [anon_sym_let_BANG] = ACTIONS(5077),
    [aux_sym_access_modifier_token1] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(5079),
    [anon_sym_null] = ACTIONS(5079),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5077),
    [anon_sym_LBRACE] = ACTIONS(5079),
    [anon_sym_LT_AT] = ACTIONS(5079),
    [anon_sym_LT_AT_AT] = ACTIONS(5077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5077),
    [anon_sym_new] = ACTIONS(5079),
    [anon_sym_return_BANG] = ACTIONS(5077),
    [anon_sym_yield] = ACTIONS(5079),
    [anon_sym_yield_BANG] = ACTIONS(5077),
    [anon_sym_lazy] = ACTIONS(5079),
    [anon_sym_assert] = ACTIONS(5079),
    [anon_sym_upcast] = ACTIONS(5079),
    [anon_sym_downcast] = ACTIONS(5079),
    [anon_sym_for] = ACTIONS(5079),
    [anon_sym_while] = ACTIONS(5079),
    [anon_sym_if] = ACTIONS(5079),
    [anon_sym_fun] = ACTIONS(5079),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(5079),
    [anon_sym_match] = ACTIONS(5079),
    [anon_sym_match_BANG] = ACTIONS(5077),
    [anon_sym_function] = ACTIONS(5079),
    [anon_sym_use] = ACTIONS(5079),
    [anon_sym_use_BANG] = ACTIONS(5077),
    [anon_sym_do_BANG] = ACTIONS(5077),
    [anon_sym_begin] = ACTIONS(5079),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_member] = ACTIONS(5079),
    [anon_sym_abstract] = ACTIONS(5079),
    [anon_sym_override] = ACTIONS(5079),
    [anon_sym_val] = ACTIONS(5079),
    [aux_sym_char_token1] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5079),
    [anon_sym_DQUOTE] = ACTIONS(5079),
    [anon_sym_AT_DQUOTE] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [sym_bool] = ACTIONS(5079),
    [sym_unit] = ACTIONS(5077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5079),
    [sym_op_identifier] = ACTIONS(5077),
    [anon_sym_PLUS] = ACTIONS(5079),
    [anon_sym_DASH] = ACTIONS(5079),
    [anon_sym_PLUS_DOT] = ACTIONS(5077),
    [anon_sym_DASH_DOT] = ACTIONS(5077),
    [anon_sym_PERCENT] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [aux_sym_prefix_op_token1] = ACTIONS(5077),
    [sym_int] = ACTIONS(5079),
    [sym_xint] = ACTIONS(5077),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5077),
    [anon_sym_POUNDload] = ACTIONS(5077),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5077),
    [sym__dedent] = ACTIONS(5077),
  },
  [2845] = {
    [sym_attributes] = STATE(5563),
    [sym_attribute_set] = STATE(4720),
    [sym_access_modifier] = STATE(8000),
    [sym_member_defn] = STATE(3205),
    [sym_additional_constr_defn] = STATE(3208),
    [sym_xml_doc] = STATE(2845),
    [sym_block_comment] = STATE(2845),
    [sym_line_comment] = STATE(2845),
    [sym_compiler_directive_decl] = STATE(2845),
    [sym_fsi_directive_decl] = STATE(2845),
    [sym_preproc_line] = STATE(2845),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym__member_defns_repeat1] = STATE(2838),
    [sym_identifier] = ACTIONS(5127),
    [anon_sym_module] = ACTIONS(5127),
    [anon_sym_open] = ACTIONS(5127),
    [anon_sym_LBRACK_LT] = ACTIONS(5125),
    [anon_sym_return] = ACTIONS(5127),
    [anon_sym_type] = ACTIONS(5127),
    [anon_sym_do] = ACTIONS(5127),
    [anon_sym_and] = ACTIONS(5127),
    [anon_sym_let] = ACTIONS(5127),
    [anon_sym_let_BANG] = ACTIONS(5125),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5127),
    [anon_sym_null] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_LT_AT] = ACTIONS(5127),
    [anon_sym_LT_AT_AT] = ACTIONS(5125),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5125),
    [anon_sym_new] = ACTIONS(5127),
    [anon_sym_return_BANG] = ACTIONS(5125),
    [anon_sym_yield] = ACTIONS(5127),
    [anon_sym_yield_BANG] = ACTIONS(5125),
    [anon_sym_lazy] = ACTIONS(5127),
    [anon_sym_assert] = ACTIONS(5127),
    [anon_sym_upcast] = ACTIONS(5127),
    [anon_sym_downcast] = ACTIONS(5127),
    [anon_sym_for] = ACTIONS(5127),
    [anon_sym_while] = ACTIONS(5127),
    [anon_sym_if] = ACTIONS(5127),
    [anon_sym_fun] = ACTIONS(5127),
    [anon_sym_try] = ACTIONS(5127),
    [anon_sym_match] = ACTIONS(5127),
    [anon_sym_match_BANG] = ACTIONS(5125),
    [anon_sym_function] = ACTIONS(5127),
    [anon_sym_use] = ACTIONS(5127),
    [anon_sym_use_BANG] = ACTIONS(5125),
    [anon_sym_do_BANG] = ACTIONS(5125),
    [anon_sym_begin] = ACTIONS(5127),
    [anon_sym_default] = ACTIONS(5138),
    [anon_sym_static] = ACTIONS(5140),
    [anon_sym_member] = ACTIONS(5142),
    [anon_sym_abstract] = ACTIONS(5144),
    [anon_sym_override] = ACTIONS(5138),
    [anon_sym_val] = ACTIONS(5146),
    [aux_sym_char_token1] = ACTIONS(5125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5127),
    [anon_sym_DQUOTE] = ACTIONS(5127),
    [anon_sym_AT_DQUOTE] = ACTIONS(5125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5125),
    [sym_bool] = ACTIONS(5127),
    [sym_unit] = ACTIONS(5125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5127),
    [sym_op_identifier] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_DOT] = ACTIONS(5125),
    [anon_sym_DASH_DOT] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_TILDE] = ACTIONS(5125),
    [aux_sym_prefix_op_token1] = ACTIONS(5125),
    [sym_int] = ACTIONS(5127),
    [sym_xint] = ACTIONS(5125),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5125),
    [anon_sym_POUNDload] = ACTIONS(5125),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5125),
    [sym__dedent] = ACTIONS(5125),
  },
  [2846] = {
    [sym_xml_doc] = STATE(2846),
    [sym_block_comment] = STATE(2846),
    [sym_line_comment] = STATE(2846),
    [sym_compiler_directive_decl] = STATE(2846),
    [sym_fsi_directive_decl] = STATE(2846),
    [sym_preproc_line] = STATE(2846),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_open] = ACTIONS(3296),
    [anon_sym_LBRACK_LT] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_and] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [aux_sym_access_modifier_token1] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3296),
    [anon_sym_static] = ACTIONS(3296),
    [anon_sym_member] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_abstract] = ACTIONS(3296),
    [anon_sym_override] = ACTIONS(3296),
    [anon_sym_val] = ACTIONS(3296),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3298),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3298),
    [anon_sym_DASH_DOT] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3298),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3298),
    [anon_sym_POUNDload] = ACTIONS(3298),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__dedent] = ACTIONS(3298),
  },
  [2847] = {
    [sym_xml_doc] = STATE(2847),
    [sym_block_comment] = STATE(2847),
    [sym_line_comment] = STATE(2847),
    [sym_compiler_directive_decl] = STATE(2847),
    [sym_fsi_directive_decl] = STATE(2847),
    [sym_preproc_line] = STATE(2847),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_open] = ACTIONS(3300),
    [anon_sym_LBRACK_LT] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_and] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [aux_sym_access_modifier_token1] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3300),
    [anon_sym_member] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_abstract] = ACTIONS(3300),
    [anon_sym_override] = ACTIONS(3300),
    [anon_sym_val] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3302),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3302),
    [anon_sym_DASH_DOT] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3302),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3302),
    [anon_sym_POUNDload] = ACTIONS(3302),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__dedent] = ACTIONS(3302),
  },
  [2848] = {
    [sym_xml_doc] = STATE(2848),
    [sym_block_comment] = STATE(2848),
    [sym_line_comment] = STATE(2848),
    [sym_compiler_directive_decl] = STATE(2848),
    [sym_fsi_directive_decl] = STATE(2848),
    [sym_preproc_line] = STATE(2848),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_open] = ACTIONS(3304),
    [anon_sym_LBRACK_LT] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_and] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [aux_sym_access_modifier_token1] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [anon_sym_default] = ACTIONS(3304),
    [anon_sym_static] = ACTIONS(3304),
    [anon_sym_member] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_abstract] = ACTIONS(3304),
    [anon_sym_override] = ACTIONS(3304),
    [anon_sym_val] = ACTIONS(3304),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3306),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3306),
    [anon_sym_DASH_DOT] = ACTIONS(3306),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3306),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3306),
    [anon_sym_POUNDload] = ACTIONS(3306),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__dedent] = ACTIONS(3306),
  },
  [2849] = {
    [sym_xml_doc] = STATE(2849),
    [sym_block_comment] = STATE(2849),
    [sym_line_comment] = STATE(2849),
    [sym_compiler_directive_decl] = STATE(2849),
    [sym_fsi_directive_decl] = STATE(2849),
    [sym_preproc_line] = STATE(2849),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_open] = ACTIONS(3292),
    [anon_sym_LBRACK_LT] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_and] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [aux_sym_access_modifier_token1] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [anon_sym_default] = ACTIONS(3292),
    [anon_sym_static] = ACTIONS(3292),
    [anon_sym_member] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_abstract] = ACTIONS(3292),
    [anon_sym_override] = ACTIONS(3292),
    [anon_sym_val] = ACTIONS(3292),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3294),
    [anon_sym_DASH_DOT] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3294),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3294),
    [anon_sym_POUNDload] = ACTIONS(3294),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__dedent] = ACTIONS(3294),
  },
  [2850] = {
    [sym_xml_doc] = STATE(2850),
    [sym_block_comment] = STATE(2850),
    [sym_line_comment] = STATE(2850),
    [sym_compiler_directive_decl] = STATE(2850),
    [sym_fsi_directive_decl] = STATE(2850),
    [sym_preproc_line] = STATE(2850),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_open] = ACTIONS(3318),
    [anon_sym_LBRACK_LT] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_and] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [aux_sym_access_modifier_token1] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_member] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_abstract] = ACTIONS(3318),
    [anon_sym_override] = ACTIONS(3318),
    [anon_sym_val] = ACTIONS(3318),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3320),
    [anon_sym_DASH_DOT] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3320),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3320),
    [anon_sym_POUNDload] = ACTIONS(3320),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__dedent] = ACTIONS(3320),
  },
  [2851] = {
    [sym_xml_doc] = STATE(2851),
    [sym_block_comment] = STATE(2851),
    [sym_line_comment] = STATE(2851),
    [sym_compiler_directive_decl] = STATE(2851),
    [sym_fsi_directive_decl] = STATE(2851),
    [sym_preproc_line] = STATE(2851),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_open] = ACTIONS(3351),
    [anon_sym_LBRACK_LT] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_and] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [aux_sym_access_modifier_token1] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_member] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_val] = ACTIONS(3351),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3353),
    [anon_sym_POUNDload] = ACTIONS(3353),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [2852] = {
    [sym_xml_doc] = STATE(2852),
    [sym_block_comment] = STATE(2852),
    [sym_line_comment] = STATE(2852),
    [sym_compiler_directive_decl] = STATE(2852),
    [sym_fsi_directive_decl] = STATE(2852),
    [sym_preproc_line] = STATE(2852),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_open] = ACTIONS(3322),
    [anon_sym_LBRACK_LT] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_and] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [aux_sym_access_modifier_token1] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_member] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_abstract] = ACTIONS(3322),
    [anon_sym_override] = ACTIONS(3322),
    [anon_sym_val] = ACTIONS(3322),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3324),
    [anon_sym_DASH_DOT] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3324),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3324),
    [anon_sym_POUNDload] = ACTIONS(3324),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__dedent] = ACTIONS(3324),
  },
  [2853] = {
    [sym_xml_doc] = STATE(2853),
    [sym_block_comment] = STATE(2853),
    [sym_line_comment] = STATE(2853),
    [sym_compiler_directive_decl] = STATE(2853),
    [sym_fsi_directive_decl] = STATE(2853),
    [sym_preproc_line] = STATE(2853),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_module] = ACTIONS(3336),
    [anon_sym_open] = ACTIONS(3336),
    [anon_sym_LBRACK_LT] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_type] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_and] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [aux_sym_access_modifier_token1] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3336),
    [anon_sym_static] = ACTIONS(3336),
    [anon_sym_member] = ACTIONS(3336),
    [anon_sym_interface] = ACTIONS(3336),
    [anon_sym_abstract] = ACTIONS(3336),
    [anon_sym_override] = ACTIONS(3336),
    [anon_sym_val] = ACTIONS(3336),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3338),
    [anon_sym_DASH_DOT] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3338),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3338),
    [anon_sym_POUNDload] = ACTIONS(3338),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__dedent] = ACTIONS(3338),
  },
  [2854] = {
    [sym_xml_doc] = STATE(2854),
    [sym_block_comment] = STATE(2854),
    [sym_line_comment] = STATE(2854),
    [sym_compiler_directive_decl] = STATE(2854),
    [sym_fsi_directive_decl] = STATE(2854),
    [sym_preproc_line] = STATE(2854),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_open] = ACTIONS(3308),
    [anon_sym_LBRACK_LT] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_and] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [aux_sym_access_modifier_token1] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_member] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_abstract] = ACTIONS(3308),
    [anon_sym_override] = ACTIONS(3308),
    [anon_sym_val] = ACTIONS(3308),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3310),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3310),
    [anon_sym_DASH_DOT] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3310),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3310),
    [anon_sym_POUNDload] = ACTIONS(3310),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__dedent] = ACTIONS(3310),
  },
  [2855] = {
    [sym_xml_doc] = STATE(2855),
    [sym_block_comment] = STATE(2855),
    [sym_line_comment] = STATE(2855),
    [sym_compiler_directive_decl] = STATE(2855),
    [sym_fsi_directive_decl] = STATE(2855),
    [sym_preproc_line] = STATE(2855),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_open] = ACTIONS(3355),
    [anon_sym_LBRACK_LT] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_and] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [aux_sym_access_modifier_token1] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LT2] = ACTIONS(5168),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_member] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_val] = ACTIONS(3355),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3357),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3357),
    [anon_sym_DASH_DOT] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3357),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3357),
    [anon_sym_POUNDload] = ACTIONS(3357),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__dedent] = ACTIONS(3357),
  },
  [2856] = {
    [sym_xml_doc] = STATE(2856),
    [sym_block_comment] = STATE(2856),
    [sym_line_comment] = STATE(2856),
    [sym_compiler_directive_decl] = STATE(2856),
    [sym_fsi_directive_decl] = STATE(2856),
    [sym_preproc_line] = STATE(2856),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_open] = ACTIONS(3340),
    [anon_sym_LBRACK_LT] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_and] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [aux_sym_access_modifier_token1] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_member] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_abstract] = ACTIONS(3340),
    [anon_sym_override] = ACTIONS(3340),
    [anon_sym_val] = ACTIONS(3340),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3342),
    [anon_sym_DASH_DOT] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3342),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3342),
    [anon_sym_POUNDload] = ACTIONS(3342),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__dedent] = ACTIONS(3342),
  },
  [2857] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7580),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2857),
    [sym_block_comment] = STATE(2857),
    [sym_line_comment] = STATE(2857),
    [sym_compiler_directive_decl] = STATE(2857),
    [sym_fsi_directive_decl] = STATE(2857),
    [sym_preproc_line] = STATE(2857),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2858] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7862),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2858),
    [sym_block_comment] = STATE(2858),
    [sym_line_comment] = STATE(2858),
    [sym_compiler_directive_decl] = STATE(2858),
    [sym_fsi_directive_decl] = STATE(2858),
    [sym_preproc_line] = STATE(2858),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2859] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7423),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2859),
    [sym_block_comment] = STATE(2859),
    [sym_line_comment] = STATE(2859),
    [sym_compiler_directive_decl] = STATE(2859),
    [sym_fsi_directive_decl] = STATE(2859),
    [sym_preproc_line] = STATE(2859),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2860] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2014),
    [sym_rules] = STATE(2478),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2860),
    [sym_block_comment] = STATE(2860),
    [sym_line_comment] = STATE(2860),
    [sym_compiler_directive_decl] = STATE(2860),
    [sym_fsi_directive_decl] = STATE(2860),
    [sym_preproc_line] = STATE(2860),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2861] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2014),
    [sym_rules] = STATE(2483),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2861),
    [sym_block_comment] = STATE(2861),
    [sym_line_comment] = STATE(2861),
    [sym_compiler_directive_decl] = STATE(2861),
    [sym_fsi_directive_decl] = STATE(2861),
    [sym_preproc_line] = STATE(2861),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2862] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1735),
    [sym_rules] = STATE(2341),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2862),
    [sym_block_comment] = STATE(2862),
    [sym_line_comment] = STATE(2862),
    [sym_compiler_directive_decl] = STATE(2862),
    [sym_fsi_directive_decl] = STATE(2862),
    [sym_preproc_line] = STATE(2862),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2863] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1696),
    [sym_rules] = STATE(2113),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2863),
    [sym_block_comment] = STATE(2863),
    [sym_line_comment] = STATE(2863),
    [sym_compiler_directive_decl] = STATE(2863),
    [sym_fsi_directive_decl] = STATE(2863),
    [sym_preproc_line] = STATE(2863),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2864] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(956),
    [sym_rules] = STATE(1165),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2864),
    [sym_block_comment] = STATE(2864),
    [sym_line_comment] = STATE(2864),
    [sym_compiler_directive_decl] = STATE(2864),
    [sym_fsi_directive_decl] = STATE(2864),
    [sym_preproc_line] = STATE(2864),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5178),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2865] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7670),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2865),
    [sym_block_comment] = STATE(2865),
    [sym_line_comment] = STATE(2865),
    [sym_compiler_directive_decl] = STATE(2865),
    [sym_fsi_directive_decl] = STATE(2865),
    [sym_preproc_line] = STATE(2865),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2866] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1599),
    [sym_rules] = STATE(1926),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2866),
    [sym_block_comment] = STATE(2866),
    [sym_line_comment] = STATE(2866),
    [sym_compiler_directive_decl] = STATE(2866),
    [sym_fsi_directive_decl] = STATE(2866),
    [sym_preproc_line] = STATE(2866),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2867] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1692),
    [sym_rules] = STATE(2339),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2867),
    [sym_block_comment] = STATE(2867),
    [sym_line_comment] = STATE(2867),
    [sym_compiler_directive_decl] = STATE(2867),
    [sym_fsi_directive_decl] = STATE(2867),
    [sym_preproc_line] = STATE(2867),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2868] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1692),
    [sym_rules] = STATE(2338),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2868),
    [sym_block_comment] = STATE(2868),
    [sym_line_comment] = STATE(2868),
    [sym_compiler_directive_decl] = STATE(2868),
    [sym_fsi_directive_decl] = STATE(2868),
    [sym_preproc_line] = STATE(2868),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2869] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1156),
    [sym_rules] = STATE(1384),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2869),
    [sym_block_comment] = STATE(2869),
    [sym_line_comment] = STATE(2869),
    [sym_compiler_directive_decl] = STATE(2869),
    [sym_fsi_directive_decl] = STATE(2869),
    [sym_preproc_line] = STATE(2869),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2870] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7210),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2870),
    [sym_block_comment] = STATE(2870),
    [sym_line_comment] = STATE(2870),
    [sym_compiler_directive_decl] = STATE(2870),
    [sym_fsi_directive_decl] = STATE(2870),
    [sym_preproc_line] = STATE(2870),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2871] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7184),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2871),
    [sym_block_comment] = STATE(2871),
    [sym_line_comment] = STATE(2871),
    [sym_compiler_directive_decl] = STATE(2871),
    [sym_fsi_directive_decl] = STATE(2871),
    [sym_preproc_line] = STATE(2871),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2872] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8108),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2872),
    [sym_block_comment] = STATE(2872),
    [sym_line_comment] = STATE(2872),
    [sym_compiler_directive_decl] = STATE(2872),
    [sym_fsi_directive_decl] = STATE(2872),
    [sym_preproc_line] = STATE(2872),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2873] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7588),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2873),
    [sym_block_comment] = STATE(2873),
    [sym_line_comment] = STATE(2873),
    [sym_compiler_directive_decl] = STATE(2873),
    [sym_fsi_directive_decl] = STATE(2873),
    [sym_preproc_line] = STATE(2873),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2874] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1696),
    [sym_rules] = STATE(2083),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2874),
    [sym_block_comment] = STATE(2874),
    [sym_line_comment] = STATE(2874),
    [sym_compiler_directive_decl] = STATE(2874),
    [sym_fsi_directive_decl] = STATE(2874),
    [sym_preproc_line] = STATE(2874),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2875] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7649),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2875),
    [sym_block_comment] = STATE(2875),
    [sym_line_comment] = STATE(2875),
    [sym_compiler_directive_decl] = STATE(2875),
    [sym_fsi_directive_decl] = STATE(2875),
    [sym_preproc_line] = STATE(2875),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2876] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2014),
    [sym_rules] = STATE(2536),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2876),
    [sym_block_comment] = STATE(2876),
    [sym_line_comment] = STATE(2876),
    [sym_compiler_directive_decl] = STATE(2876),
    [sym_fsi_directive_decl] = STATE(2876),
    [sym_preproc_line] = STATE(2876),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2877] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7176),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2877),
    [sym_block_comment] = STATE(2877),
    [sym_line_comment] = STATE(2877),
    [sym_compiler_directive_decl] = STATE(2877),
    [sym_fsi_directive_decl] = STATE(2877),
    [sym_preproc_line] = STATE(2877),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2878] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1696),
    [sym_rules] = STATE(2118),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2878),
    [sym_block_comment] = STATE(2878),
    [sym_line_comment] = STATE(2878),
    [sym_compiler_directive_decl] = STATE(2878),
    [sym_fsi_directive_decl] = STATE(2878),
    [sym_preproc_line] = STATE(2878),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2879] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7743),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2879),
    [sym_block_comment] = STATE(2879),
    [sym_line_comment] = STATE(2879),
    [sym_compiler_directive_decl] = STATE(2879),
    [sym_fsi_directive_decl] = STATE(2879),
    [sym_preproc_line] = STATE(2879),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2880] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1599),
    [sym_rules] = STATE(1927),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2880),
    [sym_block_comment] = STATE(2880),
    [sym_line_comment] = STATE(2880),
    [sym_compiler_directive_decl] = STATE(2880),
    [sym_fsi_directive_decl] = STATE(2880),
    [sym_preproc_line] = STATE(2880),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2881] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1735),
    [sym_rules] = STATE(2346),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2881),
    [sym_block_comment] = STATE(2881),
    [sym_line_comment] = STATE(2881),
    [sym_compiler_directive_decl] = STATE(2881),
    [sym_fsi_directive_decl] = STATE(2881),
    [sym_preproc_line] = STATE(2881),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2882] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7250),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2882),
    [sym_block_comment] = STATE(2882),
    [sym_line_comment] = STATE(2882),
    [sym_compiler_directive_decl] = STATE(2882),
    [sym_fsi_directive_decl] = STATE(2882),
    [sym_preproc_line] = STATE(2882),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2883] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1769),
    [sym_rules] = STATE(2618),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2883),
    [sym_block_comment] = STATE(2883),
    [sym_line_comment] = STATE(2883),
    [sym_compiler_directive_decl] = STATE(2883),
    [sym_fsi_directive_decl] = STATE(2883),
    [sym_preproc_line] = STATE(2883),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5186),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2884] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1735),
    [sym_rules] = STATE(2256),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2884),
    [sym_block_comment] = STATE(2884),
    [sym_line_comment] = STATE(2884),
    [sym_compiler_directive_decl] = STATE(2884),
    [sym_fsi_directive_decl] = STATE(2884),
    [sym_preproc_line] = STATE(2884),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2885] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7397),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2885),
    [sym_block_comment] = STATE(2885),
    [sym_line_comment] = STATE(2885),
    [sym_compiler_directive_decl] = STATE(2885),
    [sym_fsi_directive_decl] = STATE(2885),
    [sym_preproc_line] = STATE(2885),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2886] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7784),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2886),
    [sym_block_comment] = STATE(2886),
    [sym_line_comment] = STATE(2886),
    [sym_compiler_directive_decl] = STATE(2886),
    [sym_fsi_directive_decl] = STATE(2886),
    [sym_preproc_line] = STATE(2886),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2887] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1769),
    [sym_rules] = STATE(2776),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2887),
    [sym_block_comment] = STATE(2887),
    [sym_line_comment] = STATE(2887),
    [sym_compiler_directive_decl] = STATE(2887),
    [sym_fsi_directive_decl] = STATE(2887),
    [sym_preproc_line] = STATE(2887),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5186),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2888] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1692),
    [sym_rules] = STATE(2322),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2888),
    [sym_block_comment] = STATE(2888),
    [sym_line_comment] = STATE(2888),
    [sym_compiler_directive_decl] = STATE(2888),
    [sym_fsi_directive_decl] = STATE(2888),
    [sym_preproc_line] = STATE(2888),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2889] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1156),
    [sym_rules] = STATE(1320),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2889),
    [sym_block_comment] = STATE(2889),
    [sym_line_comment] = STATE(2889),
    [sym_compiler_directive_decl] = STATE(2889),
    [sym_fsi_directive_decl] = STATE(2889),
    [sym_preproc_line] = STATE(2889),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2890] = {
    [sym_type_arguments] = STATE(2836),
    [sym__object_members] = STATE(3241),
    [sym_long_identifier] = STATE(2842),
    [sym_xml_doc] = STATE(2890),
    [sym_block_comment] = STATE(2890),
    [sym_line_comment] = STATE(2890),
    [sym_compiler_directive_decl] = STATE(2890),
    [sym_fsi_directive_decl] = STATE(2890),
    [sym_preproc_line] = STATE(2890),
    [aux_sym__compound_type_repeat1] = STATE(2801),
    [ts_builtin_sym_end] = ACTIONS(5188),
    [sym_identifier] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(5190),
    [anon_sym_open] = ACTIONS(5190),
    [anon_sym_LBRACK_LT] = ACTIONS(5188),
    [anon_sym_return] = ACTIONS(5190),
    [anon_sym_type] = ACTIONS(5190),
    [anon_sym_do] = ACTIONS(5190),
    [anon_sym_and] = ACTIONS(5190),
    [anon_sym_let] = ACTIONS(5190),
    [anon_sym_let_BANG] = ACTIONS(5188),
    [anon_sym_LPAREN] = ACTIONS(5190),
    [anon_sym_null] = ACTIONS(5190),
    [anon_sym_AMP] = ACTIONS(5190),
    [anon_sym_LBRACK] = ACTIONS(5190),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5188),
    [anon_sym_LBRACE] = ACTIONS(5190),
    [anon_sym_LT_AT] = ACTIONS(5190),
    [anon_sym_LT_AT_AT] = ACTIONS(5188),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5188),
    [anon_sym_with] = ACTIONS(5192),
    [anon_sym_new] = ACTIONS(5190),
    [anon_sym_return_BANG] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_yield_BANG] = ACTIONS(5188),
    [anon_sym_lazy] = ACTIONS(5190),
    [anon_sym_assert] = ACTIONS(5190),
    [anon_sym_upcast] = ACTIONS(5190),
    [anon_sym_downcast] = ACTIONS(5190),
    [anon_sym_for] = ACTIONS(5190),
    [anon_sym_while] = ACTIONS(5190),
    [anon_sym_if] = ACTIONS(5190),
    [anon_sym_fun] = ACTIONS(5190),
    [anon_sym_DASH_GT] = ACTIONS(4754),
    [anon_sym_try] = ACTIONS(5190),
    [anon_sym_match] = ACTIONS(5190),
    [anon_sym_match_BANG] = ACTIONS(5188),
    [anon_sym_function] = ACTIONS(5190),
    [anon_sym_use] = ACTIONS(5190),
    [anon_sym_use_BANG] = ACTIONS(5188),
    [anon_sym_do_BANG] = ACTIONS(5188),
    [anon_sym_begin] = ACTIONS(5190),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_LT2] = ACTIONS(4758),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4760),
    [anon_sym_interface] = ACTIONS(5190),
    [aux_sym_char_token1] = ACTIONS(5188),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5190),
    [anon_sym_DQUOTE] = ACTIONS(5190),
    [anon_sym_AT_DQUOTE] = ACTIONS(5188),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5188),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5188),
    [sym_bool] = ACTIONS(5190),
    [sym_unit] = ACTIONS(5188),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5190),
    [sym_op_identifier] = ACTIONS(5188),
    [anon_sym_PLUS] = ACTIONS(5190),
    [anon_sym_DASH] = ACTIONS(5190),
    [anon_sym_PLUS_DOT] = ACTIONS(5188),
    [anon_sym_DASH_DOT] = ACTIONS(5188),
    [anon_sym_PERCENT] = ACTIONS(5188),
    [anon_sym_AMP_AMP] = ACTIONS(5188),
    [anon_sym_TILDE] = ACTIONS(5188),
    [aux_sym_prefix_op_token1] = ACTIONS(5188),
    [sym_int] = ACTIONS(5190),
    [sym_xint] = ACTIONS(5188),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5188),
    [anon_sym_POUNDload] = ACTIONS(5188),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5188),
  },
  [2891] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1769),
    [sym_rules] = STATE(2775),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2891),
    [sym_block_comment] = STATE(2891),
    [sym_line_comment] = STATE(2891),
    [sym_compiler_directive_decl] = STATE(2891),
    [sym_fsi_directive_decl] = STATE(2891),
    [sym_preproc_line] = STATE(2891),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5186),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2892] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7283),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2892),
    [sym_block_comment] = STATE(2892),
    [sym_line_comment] = STATE(2892),
    [sym_compiler_directive_decl] = STATE(2892),
    [sym_fsi_directive_decl] = STATE(2892),
    [sym_preproc_line] = STATE(2892),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2893] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7672),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2893),
    [sym_block_comment] = STATE(2893),
    [sym_line_comment] = STATE(2893),
    [sym_compiler_directive_decl] = STATE(2893),
    [sym_fsi_directive_decl] = STATE(2893),
    [sym_preproc_line] = STATE(2893),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2894] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7801),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2894),
    [sym_block_comment] = STATE(2894),
    [sym_line_comment] = STATE(2894),
    [sym_compiler_directive_decl] = STATE(2894),
    [sym_fsi_directive_decl] = STATE(2894),
    [sym_preproc_line] = STATE(2894),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2895] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1599),
    [sym_rules] = STATE(1961),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2895),
    [sym_block_comment] = STATE(2895),
    [sym_line_comment] = STATE(2895),
    [sym_compiler_directive_decl] = STATE(2895),
    [sym_fsi_directive_decl] = STATE(2895),
    [sym_preproc_line] = STATE(2895),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2896] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2000),
    [sym_rules] = STATE(2553),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2896),
    [sym_block_comment] = STATE(2896),
    [sym_line_comment] = STATE(2896),
    [sym_compiler_directive_decl] = STATE(2896),
    [sym_fsi_directive_decl] = STATE(2896),
    [sym_preproc_line] = STATE(2896),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2897] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8302),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2897),
    [sym_block_comment] = STATE(2897),
    [sym_line_comment] = STATE(2897),
    [sym_compiler_directive_decl] = STATE(2897),
    [sym_fsi_directive_decl] = STATE(2897),
    [sym_preproc_line] = STATE(2897),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2898] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7457),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2898),
    [sym_block_comment] = STATE(2898),
    [sym_line_comment] = STATE(2898),
    [sym_compiler_directive_decl] = STATE(2898),
    [sym_fsi_directive_decl] = STATE(2898),
    [sym_preproc_line] = STATE(2898),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2899] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8142),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2899),
    [sym_block_comment] = STATE(2899),
    [sym_line_comment] = STATE(2899),
    [sym_compiler_directive_decl] = STATE(2899),
    [sym_fsi_directive_decl] = STATE(2899),
    [sym_preproc_line] = STATE(2899),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2900] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1516),
    [sym_rules] = STATE(1981),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2900),
    [sym_block_comment] = STATE(2900),
    [sym_line_comment] = STATE(2900),
    [sym_compiler_directive_decl] = STATE(2900),
    [sym_fsi_directive_decl] = STATE(2900),
    [sym_preproc_line] = STATE(2900),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2901] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1599),
    [sym_rules] = STATE(1893),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2901),
    [sym_block_comment] = STATE(2901),
    [sym_line_comment] = STATE(2901),
    [sym_compiler_directive_decl] = STATE(2901),
    [sym_fsi_directive_decl] = STATE(2901),
    [sym_preproc_line] = STATE(2901),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2902] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1238),
    [sym_rules] = STATE(1662),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2902),
    [sym_block_comment] = STATE(2902),
    [sym_line_comment] = STATE(2902),
    [sym_compiler_directive_decl] = STATE(2902),
    [sym_fsi_directive_decl] = STATE(2902),
    [sym_preproc_line] = STATE(2902),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2903] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7893),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2903),
    [sym_block_comment] = STATE(2903),
    [sym_line_comment] = STATE(2903),
    [sym_compiler_directive_decl] = STATE(2903),
    [sym_fsi_directive_decl] = STATE(2903),
    [sym_preproc_line] = STATE(2903),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2904] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7427),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2904),
    [sym_block_comment] = STATE(2904),
    [sym_line_comment] = STATE(2904),
    [sym_compiler_directive_decl] = STATE(2904),
    [sym_fsi_directive_decl] = STATE(2904),
    [sym_preproc_line] = STATE(2904),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2905] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7947),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2905),
    [sym_block_comment] = STATE(2905),
    [sym_line_comment] = STATE(2905),
    [sym_compiler_directive_decl] = STATE(2905),
    [sym_fsi_directive_decl] = STATE(2905),
    [sym_preproc_line] = STATE(2905),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2906] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1806),
    [sym_rules] = STATE(2662),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2906),
    [sym_block_comment] = STATE(2906),
    [sym_line_comment] = STATE(2906),
    [sym_compiler_directive_decl] = STATE(2906),
    [sym_fsi_directive_decl] = STATE(2906),
    [sym_preproc_line] = STATE(2906),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2907] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1866),
    [sym_rules] = STATE(2707),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2907),
    [sym_block_comment] = STATE(2907),
    [sym_line_comment] = STATE(2907),
    [sym_compiler_directive_decl] = STATE(2907),
    [sym_fsi_directive_decl] = STATE(2907),
    [sym_preproc_line] = STATE(2907),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5202),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2908] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1806),
    [sym_rules] = STATE(2524),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2908),
    [sym_block_comment] = STATE(2908),
    [sym_line_comment] = STATE(2908),
    [sym_compiler_directive_decl] = STATE(2908),
    [sym_fsi_directive_decl] = STATE(2908),
    [sym_preproc_line] = STATE(2908),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2909] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7291),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2909),
    [sym_block_comment] = STATE(2909),
    [sym_line_comment] = STATE(2909),
    [sym_compiler_directive_decl] = STATE(2909),
    [sym_fsi_directive_decl] = STATE(2909),
    [sym_preproc_line] = STATE(2909),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2910] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7992),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2910),
    [sym_block_comment] = STATE(2910),
    [sym_line_comment] = STATE(2910),
    [sym_compiler_directive_decl] = STATE(2910),
    [sym_fsi_directive_decl] = STATE(2910),
    [sym_preproc_line] = STATE(2910),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2911] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(956),
    [sym_rules] = STATE(1155),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2911),
    [sym_block_comment] = STATE(2911),
    [sym_line_comment] = STATE(2911),
    [sym_compiler_directive_decl] = STATE(2911),
    [sym_fsi_directive_decl] = STATE(2911),
    [sym_preproc_line] = STATE(2911),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5178),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2912] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8243),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2912),
    [sym_block_comment] = STATE(2912),
    [sym_line_comment] = STATE(2912),
    [sym_compiler_directive_decl] = STATE(2912),
    [sym_fsi_directive_decl] = STATE(2912),
    [sym_preproc_line] = STATE(2912),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2913] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(956),
    [sym_rules] = STATE(1174),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2913),
    [sym_block_comment] = STATE(2913),
    [sym_line_comment] = STATE(2913),
    [sym_compiler_directive_decl] = STATE(2913),
    [sym_fsi_directive_decl] = STATE(2913),
    [sym_preproc_line] = STATE(2913),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5178),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2914] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8066),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2914),
    [sym_block_comment] = STATE(2914),
    [sym_line_comment] = STATE(2914),
    [sym_compiler_directive_decl] = STATE(2914),
    [sym_fsi_directive_decl] = STATE(2914),
    [sym_preproc_line] = STATE(2914),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2915] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1769),
    [sym_rules] = STATE(2749),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2915),
    [sym_block_comment] = STATE(2915),
    [sym_line_comment] = STATE(2915),
    [sym_compiler_directive_decl] = STATE(2915),
    [sym_fsi_directive_decl] = STATE(2915),
    [sym_preproc_line] = STATE(2915),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5186),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2916] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8088),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2916),
    [sym_block_comment] = STATE(2916),
    [sym_line_comment] = STATE(2916),
    [sym_compiler_directive_decl] = STATE(2916),
    [sym_fsi_directive_decl] = STATE(2916),
    [sym_preproc_line] = STATE(2916),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2917] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8209),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2917),
    [sym_block_comment] = STATE(2917),
    [sym_line_comment] = STATE(2917),
    [sym_compiler_directive_decl] = STATE(2917),
    [sym_fsi_directive_decl] = STATE(2917),
    [sym_preproc_line] = STATE(2917),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2918] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1806),
    [sym_rules] = STATE(2593),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2918),
    [sym_block_comment] = STATE(2918),
    [sym_line_comment] = STATE(2918),
    [sym_compiler_directive_decl] = STATE(2918),
    [sym_fsi_directive_decl] = STATE(2918),
    [sym_preproc_line] = STATE(2918),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2919] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1806),
    [sym_rules] = STATE(2597),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2919),
    [sym_block_comment] = STATE(2919),
    [sym_line_comment] = STATE(2919),
    [sym_compiler_directive_decl] = STATE(2919),
    [sym_fsi_directive_decl] = STATE(2919),
    [sym_preproc_line] = STATE(2919),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5200),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2920] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(8160),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2920),
    [sym_block_comment] = STATE(2920),
    [sym_line_comment] = STATE(2920),
    [sym_compiler_directive_decl] = STATE(2920),
    [sym_fsi_directive_decl] = STATE(2920),
    [sym_preproc_line] = STATE(2920),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2921] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1696),
    [sym_rules] = STATE(2139),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2921),
    [sym_block_comment] = STATE(2921),
    [sym_line_comment] = STATE(2921),
    [sym_compiler_directive_decl] = STATE(2921),
    [sym_fsi_directive_decl] = STATE(2921),
    [sym_preproc_line] = STATE(2921),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2922] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7606),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2922),
    [sym_block_comment] = STATE(2922),
    [sym_line_comment] = STATE(2922),
    [sym_compiler_directive_decl] = STATE(2922),
    [sym_fsi_directive_decl] = STATE(2922),
    [sym_preproc_line] = STATE(2922),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2923] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1692),
    [sym_rules] = STATE(2300),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2923),
    [sym_block_comment] = STATE(2923),
    [sym_line_comment] = STATE(2923),
    [sym_compiler_directive_decl] = STATE(2923),
    [sym_fsi_directive_decl] = STATE(2923),
    [sym_preproc_line] = STATE(2923),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2924] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2000),
    [sym_rules] = STATE(2613),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2924),
    [sym_block_comment] = STATE(2924),
    [sym_line_comment] = STATE(2924),
    [sym_compiler_directive_decl] = STATE(2924),
    [sym_fsi_directive_decl] = STATE(2924),
    [sym_preproc_line] = STATE(2924),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2925] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7484),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2925),
    [sym_block_comment] = STATE(2925),
    [sym_line_comment] = STATE(2925),
    [sym_compiler_directive_decl] = STATE(2925),
    [sym_fsi_directive_decl] = STATE(2925),
    [sym_preproc_line] = STATE(2925),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2926] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2000),
    [sym_rules] = STATE(2614),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2926),
    [sym_block_comment] = STATE(2926),
    [sym_line_comment] = STATE(2926),
    [sym_compiler_directive_decl] = STATE(2926),
    [sym_fsi_directive_decl] = STATE(2926),
    [sym_preproc_line] = STATE(2926),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2927] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1156),
    [sym_rules] = STATE(1345),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2927),
    [sym_block_comment] = STATE(2927),
    [sym_line_comment] = STATE(2927),
    [sym_compiler_directive_decl] = STATE(2927),
    [sym_fsi_directive_decl] = STATE(2927),
    [sym_preproc_line] = STATE(2927),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2928] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1735),
    [sym_rules] = STATE(2315),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2928),
    [sym_block_comment] = STATE(2928),
    [sym_line_comment] = STATE(2928),
    [sym_compiler_directive_decl] = STATE(2928),
    [sym_fsi_directive_decl] = STATE(2928),
    [sym_preproc_line] = STATE(2928),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2929] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7261),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2929),
    [sym_block_comment] = STATE(2929),
    [sym_line_comment] = STATE(2929),
    [sym_compiler_directive_decl] = STATE(2929),
    [sym_fsi_directive_decl] = STATE(2929),
    [sym_preproc_line] = STATE(2929),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2930] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7757),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2930),
    [sym_block_comment] = STATE(2930),
    [sym_line_comment] = STATE(2930),
    [sym_compiler_directive_decl] = STATE(2930),
    [sym_fsi_directive_decl] = STATE(2930),
    [sym_preproc_line] = STATE(2930),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2931] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1156),
    [sym_rules] = STATE(1333),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2931),
    [sym_block_comment] = STATE(2931),
    [sym_line_comment] = STATE(2931),
    [sym_compiler_directive_decl] = STATE(2931),
    [sym_fsi_directive_decl] = STATE(2931),
    [sym_preproc_line] = STATE(2931),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2932] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1516),
    [sym_rules] = STATE(1954),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2932),
    [sym_block_comment] = STATE(2932),
    [sym_line_comment] = STATE(2932),
    [sym_compiler_directive_decl] = STATE(2932),
    [sym_fsi_directive_decl] = STATE(2932),
    [sym_preproc_line] = STATE(2932),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2933] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1516),
    [sym_rules] = STATE(1933),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2933),
    [sym_block_comment] = STATE(2933),
    [sym_line_comment] = STATE(2933),
    [sym_compiler_directive_decl] = STATE(2933),
    [sym_fsi_directive_decl] = STATE(2933),
    [sym_preproc_line] = STATE(2933),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2934] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(956),
    [sym_rules] = STATE(1172),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2934),
    [sym_block_comment] = STATE(2934),
    [sym_line_comment] = STATE(2934),
    [sym_compiler_directive_decl] = STATE(2934),
    [sym_fsi_directive_decl] = STATE(2934),
    [sym_preproc_line] = STATE(2934),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5178),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2935] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1238),
    [sym_rules] = STATE(1643),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2935),
    [sym_block_comment] = STATE(2935),
    [sym_line_comment] = STATE(2935),
    [sym_compiler_directive_decl] = STATE(2935),
    [sym_fsi_directive_decl] = STATE(2935),
    [sym_preproc_line] = STATE(2935),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2936] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1238),
    [sym_rules] = STATE(1636),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2936),
    [sym_block_comment] = STATE(2936),
    [sym_line_comment] = STATE(2936),
    [sym_compiler_directive_decl] = STATE(2936),
    [sym_fsi_directive_decl] = STATE(2936),
    [sym_preproc_line] = STATE(2936),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2937] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1516),
    [sym_rules] = STATE(1951),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2937),
    [sym_block_comment] = STATE(2937),
    [sym_line_comment] = STATE(2937),
    [sym_compiler_directive_decl] = STATE(2937),
    [sym_fsi_directive_decl] = STATE(2937),
    [sym_preproc_line] = STATE(2937),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2938] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7277),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2938),
    [sym_block_comment] = STATE(2938),
    [sym_line_comment] = STATE(2938),
    [sym_compiler_directive_decl] = STATE(2938),
    [sym_fsi_directive_decl] = STATE(2938),
    [sym_preproc_line] = STATE(2938),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2939] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7799),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2939),
    [sym_block_comment] = STATE(2939),
    [sym_line_comment] = STATE(2939),
    [sym_compiler_directive_decl] = STATE(2939),
    [sym_fsi_directive_decl] = STATE(2939),
    [sym_preproc_line] = STATE(2939),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2940] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2000),
    [sym_rules] = STATE(2658),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2940),
    [sym_block_comment] = STATE(2940),
    [sym_line_comment] = STATE(2940),
    [sym_compiler_directive_decl] = STATE(2940),
    [sym_fsi_directive_decl] = STATE(2940),
    [sym_preproc_line] = STATE(2940),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2941] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7363),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2941),
    [sym_block_comment] = STATE(2941),
    [sym_line_comment] = STATE(2941),
    [sym_compiler_directive_decl] = STATE(2941),
    [sym_fsi_directive_decl] = STATE(2941),
    [sym_preproc_line] = STATE(2941),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2942] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7769),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2942),
    [sym_block_comment] = STATE(2942),
    [sym_line_comment] = STATE(2942),
    [sym_compiler_directive_decl] = STATE(2942),
    [sym_fsi_directive_decl] = STATE(2942),
    [sym_preproc_line] = STATE(2942),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2943] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6137),
    [sym_rules] = STATE(7322),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2943),
    [sym_block_comment] = STATE(2943),
    [sym_line_comment] = STATE(2943),
    [sym_compiler_directive_decl] = STATE(2943),
    [sym_fsi_directive_decl] = STATE(2943),
    [sym_preproc_line] = STATE(2943),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2944] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1866),
    [sym_rules] = STATE(2763),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2944),
    [sym_block_comment] = STATE(2944),
    [sym_line_comment] = STATE(2944),
    [sym_compiler_directive_decl] = STATE(2944),
    [sym_fsi_directive_decl] = STATE(2944),
    [sym_preproc_line] = STATE(2944),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5202),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2945] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1866),
    [sym_rules] = STATE(2558),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2945),
    [sym_block_comment] = STATE(2945),
    [sym_line_comment] = STATE(2945),
    [sym_compiler_directive_decl] = STATE(2945),
    [sym_fsi_directive_decl] = STATE(2945),
    [sym_preproc_line] = STATE(2945),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5202),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2946] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2014),
    [sym_rules] = STATE(2431),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2946),
    [sym_block_comment] = STATE(2946),
    [sym_line_comment] = STATE(2946),
    [sym_compiler_directive_decl] = STATE(2946),
    [sym_fsi_directive_decl] = STATE(2946),
    [sym_preproc_line] = STATE(2946),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2947] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1238),
    [sym_rules] = STATE(1660),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2947),
    [sym_block_comment] = STATE(2947),
    [sym_line_comment] = STATE(2947),
    [sym_compiler_directive_decl] = STATE(2947),
    [sym_fsi_directive_decl] = STATE(2947),
    [sym_preproc_line] = STATE(2947),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2948] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1866),
    [sym_rules] = STATE(2753),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2948),
    [sym_block_comment] = STATE(2948),
    [sym_line_comment] = STATE(2948),
    [sym_compiler_directive_decl] = STATE(2948),
    [sym_fsi_directive_decl] = STATE(2948),
    [sym_preproc_line] = STATE(2948),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_PIPE] = ACTIONS(5202),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2949] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2949),
    [sym_block_comment] = STATE(2949),
    [sym_line_comment] = STATE(2949),
    [sym_compiler_directive_decl] = STATE(2949),
    [sym_fsi_directive_decl] = STATE(2949),
    [sym_preproc_line] = STATE(2949),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(5204),
    [anon_sym_EQ] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5212),
    [anon_sym_null] = ACTIONS(5215),
    [anon_sym__] = ACTIONS(5218),
    [anon_sym_QMARK] = ACTIONS(5221),
    [anon_sym_COLON_QMARK] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5230),
    [anon_sym_LBRACE] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5236),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5239),
    [anon_sym_DQUOTE] = ACTIONS(5242),
    [anon_sym_AT_DQUOTE] = ACTIONS(5245),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5251),
    [sym_bool] = ACTIONS(5254),
    [sym_unit] = ACTIONS(5257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5260),
    [sym_op_identifier] = ACTIONS(5263),
    [sym_int] = ACTIONS(5266),
    [sym_xint] = ACTIONS(5269),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2950] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2950),
    [sym_block_comment] = STATE(2950),
    [sym_line_comment] = STATE(2950),
    [sym_compiler_directive_decl] = STATE(2950),
    [sym_fsi_directive_decl] = STATE(2950),
    [sym_preproc_line] = STATE(2950),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5272),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2951] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2951),
    [sym_block_comment] = STATE(2951),
    [sym_line_comment] = STATE(2951),
    [sym_compiler_directive_decl] = STATE(2951),
    [sym_fsi_directive_decl] = STATE(2951),
    [sym_preproc_line] = STATE(2951),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5274),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2952] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2952),
    [sym_block_comment] = STATE(2952),
    [sym_line_comment] = STATE(2952),
    [sym_compiler_directive_decl] = STATE(2952),
    [sym_fsi_directive_decl] = STATE(2952),
    [sym_preproc_line] = STATE(2952),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2953] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2953),
    [sym_block_comment] = STATE(2953),
    [sym_line_comment] = STATE(2953),
    [sym_compiler_directive_decl] = STATE(2953),
    [sym_fsi_directive_decl] = STATE(2953),
    [sym_preproc_line] = STATE(2953),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5278),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2954] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2954),
    [sym_block_comment] = STATE(2954),
    [sym_line_comment] = STATE(2954),
    [sym_compiler_directive_decl] = STATE(2954),
    [sym_fsi_directive_decl] = STATE(2954),
    [sym_preproc_line] = STATE(2954),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5280),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2955] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2955),
    [sym_block_comment] = STATE(2955),
    [sym_line_comment] = STATE(2955),
    [sym_compiler_directive_decl] = STATE(2955),
    [sym_fsi_directive_decl] = STATE(2955),
    [sym_preproc_line] = STATE(2955),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5282),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2956] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2956),
    [sym_block_comment] = STATE(2956),
    [sym_line_comment] = STATE(2956),
    [sym_compiler_directive_decl] = STATE(2956),
    [sym_fsi_directive_decl] = STATE(2956),
    [sym_preproc_line] = STATE(2956),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5284),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2957] = {
    [sym_type_arguments] = STATE(2853),
    [sym__object_members] = STATE(3275),
    [sym_long_identifier] = STATE(2846),
    [sym_xml_doc] = STATE(2957),
    [sym_block_comment] = STATE(2957),
    [sym_line_comment] = STATE(2957),
    [sym_compiler_directive_decl] = STATE(2957),
    [sym_fsi_directive_decl] = STATE(2957),
    [sym_preproc_line] = STATE(2957),
    [aux_sym__compound_type_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(5190),
    [anon_sym_open] = ACTIONS(5190),
    [anon_sym_LBRACK_LT] = ACTIONS(5188),
    [anon_sym_return] = ACTIONS(5190),
    [anon_sym_type] = ACTIONS(5190),
    [anon_sym_do] = ACTIONS(5190),
    [anon_sym_and] = ACTIONS(5190),
    [anon_sym_let] = ACTIONS(5190),
    [anon_sym_let_BANG] = ACTIONS(5188),
    [anon_sym_LPAREN] = ACTIONS(5190),
    [anon_sym_null] = ACTIONS(5190),
    [anon_sym_AMP] = ACTIONS(5190),
    [anon_sym_LBRACK] = ACTIONS(5190),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5188),
    [anon_sym_LBRACE] = ACTIONS(5190),
    [anon_sym_LT_AT] = ACTIONS(5190),
    [anon_sym_LT_AT_AT] = ACTIONS(5188),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5188),
    [anon_sym_with] = ACTIONS(5286),
    [anon_sym_new] = ACTIONS(5190),
    [anon_sym_return_BANG] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_yield_BANG] = ACTIONS(5188),
    [anon_sym_lazy] = ACTIONS(5190),
    [anon_sym_assert] = ACTIONS(5190),
    [anon_sym_upcast] = ACTIONS(5190),
    [anon_sym_downcast] = ACTIONS(5190),
    [anon_sym_for] = ACTIONS(5190),
    [anon_sym_while] = ACTIONS(5190),
    [anon_sym_if] = ACTIONS(5190),
    [anon_sym_fun] = ACTIONS(5190),
    [anon_sym_DASH_GT] = ACTIONS(4969),
    [anon_sym_try] = ACTIONS(5190),
    [anon_sym_match] = ACTIONS(5190),
    [anon_sym_match_BANG] = ACTIONS(5188),
    [anon_sym_function] = ACTIONS(5190),
    [anon_sym_use] = ACTIONS(5190),
    [anon_sym_use_BANG] = ACTIONS(5188),
    [anon_sym_do_BANG] = ACTIONS(5188),
    [anon_sym_begin] = ACTIONS(5190),
    [anon_sym_STAR] = ACTIONS(4971),
    [anon_sym_LT2] = ACTIONS(4973),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4975),
    [anon_sym_interface] = ACTIONS(5190),
    [aux_sym_char_token1] = ACTIONS(5188),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5190),
    [anon_sym_DQUOTE] = ACTIONS(5190),
    [anon_sym_AT_DQUOTE] = ACTIONS(5188),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5188),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5188),
    [sym_bool] = ACTIONS(5190),
    [sym_unit] = ACTIONS(5188),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5190),
    [sym_op_identifier] = ACTIONS(5188),
    [anon_sym_PLUS] = ACTIONS(5190),
    [anon_sym_DASH] = ACTIONS(5190),
    [anon_sym_PLUS_DOT] = ACTIONS(5188),
    [anon_sym_DASH_DOT] = ACTIONS(5188),
    [anon_sym_PERCENT] = ACTIONS(5188),
    [anon_sym_AMP_AMP] = ACTIONS(5188),
    [anon_sym_TILDE] = ACTIONS(5188),
    [aux_sym_prefix_op_token1] = ACTIONS(5188),
    [sym_int] = ACTIONS(5190),
    [sym_xint] = ACTIONS(5188),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5188),
    [anon_sym_POUNDload] = ACTIONS(5188),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5188),
    [sym__dedent] = ACTIONS(5188),
  },
  [2958] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2958),
    [sym_block_comment] = STATE(2958),
    [sym_line_comment] = STATE(2958),
    [sym_compiler_directive_decl] = STATE(2958),
    [sym_fsi_directive_decl] = STATE(2958),
    [sym_preproc_line] = STATE(2958),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5288),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2959] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2959),
    [sym_block_comment] = STATE(2959),
    [sym_line_comment] = STATE(2959),
    [sym_compiler_directive_decl] = STATE(2959),
    [sym_fsi_directive_decl] = STATE(2959),
    [sym_preproc_line] = STATE(2959),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5290),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2960] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_access_modifier] = STATE(3116),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5572),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2960),
    [sym_block_comment] = STATE(2960),
    [sym_line_comment] = STATE(2960),
    [sym_compiler_directive_decl] = STATE(2960),
    [sym_fsi_directive_decl] = STATE(2960),
    [sym_preproc_line] = STATE(2960),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2961] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2961),
    [sym_block_comment] = STATE(2961),
    [sym_line_comment] = STATE(2961),
    [sym_compiler_directive_decl] = STATE(2961),
    [sym_fsi_directive_decl] = STATE(2961),
    [sym_preproc_line] = STATE(2961),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5292),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2962] = {
    [sym_xml_doc] = STATE(2962),
    [sym_block_comment] = STATE(2962),
    [sym_line_comment] = STATE(2962),
    [sym_compiler_directive_decl] = STATE(2962),
    [sym_fsi_directive_decl] = STATE(2962),
    [sym_preproc_line] = STATE(2962),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(5294),
    [anon_sym_uy] = ACTIONS(5296),
    [anon_sym_s] = ACTIONS(5298),
    [anon_sym_us] = ACTIONS(5300),
    [anon_sym_l] = ACTIONS(5302),
    [aux_sym_uint32_token1] = ACTIONS(5304),
    [anon_sym_n] = ACTIONS(5306),
    [anon_sym_un] = ACTIONS(5308),
    [anon_sym_L] = ACTIONS(5310),
    [aux_sym_uint64_token1] = ACTIONS(5312),
    [aux_sym_bignum_token1] = ACTIONS(5314),
    [aux_sym_decimal_token1] = ACTIONS(5316),
    [anon_sym_DOT2] = ACTIONS(5318),
    [aux_sym_float_token1] = ACTIONS(5320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
  },
  [2963] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2963),
    [sym_block_comment] = STATE(2963),
    [sym_line_comment] = STATE(2963),
    [sym_compiler_directive_decl] = STATE(2963),
    [sym_fsi_directive_decl] = STATE(2963),
    [sym_preproc_line] = STATE(2963),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5322),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2964] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2964),
    [sym_block_comment] = STATE(2964),
    [sym_line_comment] = STATE(2964),
    [sym_compiler_directive_decl] = STATE(2964),
    [sym_fsi_directive_decl] = STATE(2964),
    [sym_preproc_line] = STATE(2964),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5324),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2965] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2965),
    [sym_block_comment] = STATE(2965),
    [sym_line_comment] = STATE(2965),
    [sym_compiler_directive_decl] = STATE(2965),
    [sym_fsi_directive_decl] = STATE(2965),
    [sym_preproc_line] = STATE(2965),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5326),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2966] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2966),
    [sym_block_comment] = STATE(2966),
    [sym_line_comment] = STATE(2966),
    [sym_compiler_directive_decl] = STATE(2966),
    [sym_fsi_directive_decl] = STATE(2966),
    [sym_preproc_line] = STATE(2966),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5328),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2967] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2967),
    [sym_block_comment] = STATE(2967),
    [sym_line_comment] = STATE(2967),
    [sym_compiler_directive_decl] = STATE(2967),
    [sym_fsi_directive_decl] = STATE(2967),
    [sym_preproc_line] = STATE(2967),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5330),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2968] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2968),
    [sym_block_comment] = STATE(2968),
    [sym_line_comment] = STATE(2968),
    [sym_compiler_directive_decl] = STATE(2968),
    [sym_fsi_directive_decl] = STATE(2968),
    [sym_preproc_line] = STATE(2968),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2949),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_EQ] = ACTIONS(5332),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2969] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2969),
    [sym_block_comment] = STATE(2969),
    [sym_line_comment] = STATE(2969),
    [sym_compiler_directive_decl] = STATE(2969),
    [sym_fsi_directive_decl] = STATE(2969),
    [sym_preproc_line] = STATE(2969),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2952),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2970] = {
    [sym_xml_doc] = STATE(2970),
    [sym_block_comment] = STATE(2970),
    [sym_line_comment] = STATE(2970),
    [sym_compiler_directive_decl] = STATE(2970),
    [sym_fsi_directive_decl] = STATE(2970),
    [sym_preproc_line] = STATE(2970),
    [ts_builtin_sym_end] = ACTIONS(5334),
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_namespace] = ACTIONS(5336),
    [anon_sym_module] = ACTIONS(5336),
    [anon_sym_open] = ACTIONS(5336),
    [anon_sym_LBRACK_LT] = ACTIONS(5334),
    [anon_sym_return] = ACTIONS(5336),
    [anon_sym_type] = ACTIONS(5336),
    [anon_sym_do] = ACTIONS(5336),
    [anon_sym_and] = ACTIONS(5336),
    [anon_sym_let] = ACTIONS(5336),
    [anon_sym_let_BANG] = ACTIONS(5334),
    [aux_sym_access_modifier_token1] = ACTIONS(5334),
    [anon_sym_LPAREN] = ACTIONS(5336),
    [anon_sym_null] = ACTIONS(5336),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_LBRACK] = ACTIONS(5336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(5336),
    [anon_sym_LT_AT] = ACTIONS(5336),
    [anon_sym_LT_AT_AT] = ACTIONS(5334),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5334),
    [anon_sym_with] = ACTIONS(5338),
    [anon_sym_new] = ACTIONS(5336),
    [anon_sym_return_BANG] = ACTIONS(5334),
    [anon_sym_yield] = ACTIONS(5336),
    [anon_sym_yield_BANG] = ACTIONS(5334),
    [anon_sym_lazy] = ACTIONS(5336),
    [anon_sym_assert] = ACTIONS(5336),
    [anon_sym_upcast] = ACTIONS(5336),
    [anon_sym_downcast] = ACTIONS(5336),
    [anon_sym_for] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(5336),
    [anon_sym_if] = ACTIONS(5336),
    [anon_sym_fun] = ACTIONS(5336),
    [anon_sym_try] = ACTIONS(5336),
    [anon_sym_match] = ACTIONS(5336),
    [anon_sym_match_BANG] = ACTIONS(5334),
    [anon_sym_function] = ACTIONS(5336),
    [anon_sym_use] = ACTIONS(5336),
    [anon_sym_use_BANG] = ACTIONS(5334),
    [anon_sym_do_BANG] = ACTIONS(5334),
    [anon_sym_begin] = ACTIONS(5336),
    [anon_sym_default] = ACTIONS(5336),
    [anon_sym_static] = ACTIONS(5336),
    [anon_sym_member] = ACTIONS(5336),
    [anon_sym_abstract] = ACTIONS(5336),
    [anon_sym_override] = ACTIONS(5336),
    [anon_sym_val] = ACTIONS(5336),
    [aux_sym_char_token1] = ACTIONS(5334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5336),
    [anon_sym_DQUOTE] = ACTIONS(5336),
    [anon_sym_AT_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5334),
    [sym_bool] = ACTIONS(5336),
    [sym_unit] = ACTIONS(5334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5336),
    [sym_op_identifier] = ACTIONS(5334),
    [anon_sym_PLUS] = ACTIONS(5336),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_PLUS_DOT] = ACTIONS(5334),
    [anon_sym_DASH_DOT] = ACTIONS(5334),
    [anon_sym_PERCENT] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_TILDE] = ACTIONS(5334),
    [aux_sym_prefix_op_token1] = ACTIONS(5334),
    [sym_int] = ACTIONS(5336),
    [sym_xint] = ACTIONS(5334),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5334),
    [anon_sym_POUNDload] = ACTIONS(5334),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5334),
  },
  [2971] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2230),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2971),
    [sym_block_comment] = STATE(2971),
    [sym_line_comment] = STATE(2971),
    [sym_compiler_directive_decl] = STATE(2971),
    [sym_fsi_directive_decl] = STATE(2971),
    [sym_preproc_line] = STATE(2971),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2972] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1677),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2972),
    [sym_block_comment] = STATE(2972),
    [sym_line_comment] = STATE(2972),
    [sym_compiler_directive_decl] = STATE(2972),
    [sym_fsi_directive_decl] = STATE(2972),
    [sym_preproc_line] = STATE(2972),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2973] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2973),
    [sym_block_comment] = STATE(2973),
    [sym_line_comment] = STATE(2973),
    [sym_compiler_directive_decl] = STATE(2973),
    [sym_fsi_directive_decl] = STATE(2973),
    [sym_preproc_line] = STATE(2973),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2956),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2974] = {
    [sym_xml_doc] = STATE(2974),
    [sym_block_comment] = STATE(2974),
    [sym_line_comment] = STATE(2974),
    [sym_compiler_directive_decl] = STATE(2974),
    [sym_fsi_directive_decl] = STATE(2974),
    [sym_preproc_line] = STATE(2974),
    [ts_builtin_sym_end] = ACTIONS(5340),
    [sym_identifier] = ACTIONS(5342),
    [anon_sym_namespace] = ACTIONS(5342),
    [anon_sym_module] = ACTIONS(5342),
    [anon_sym_open] = ACTIONS(5342),
    [anon_sym_LBRACK_LT] = ACTIONS(5340),
    [anon_sym_return] = ACTIONS(5342),
    [anon_sym_type] = ACTIONS(5342),
    [anon_sym_do] = ACTIONS(5342),
    [anon_sym_and] = ACTIONS(5342),
    [anon_sym_let] = ACTIONS(5342),
    [anon_sym_let_BANG] = ACTIONS(5340),
    [aux_sym_access_modifier_token1] = ACTIONS(5340),
    [anon_sym_LPAREN] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5344),
    [anon_sym_null] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_LT_AT] = ACTIONS(5342),
    [anon_sym_LT_AT_AT] = ACTIONS(5340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5340),
    [anon_sym_new] = ACTIONS(5342),
    [anon_sym_return_BANG] = ACTIONS(5340),
    [anon_sym_yield] = ACTIONS(5342),
    [anon_sym_yield_BANG] = ACTIONS(5340),
    [anon_sym_lazy] = ACTIONS(5342),
    [anon_sym_assert] = ACTIONS(5342),
    [anon_sym_upcast] = ACTIONS(5342),
    [anon_sym_downcast] = ACTIONS(5342),
    [anon_sym_for] = ACTIONS(5342),
    [anon_sym_while] = ACTIONS(5342),
    [anon_sym_if] = ACTIONS(5342),
    [anon_sym_fun] = ACTIONS(5342),
    [anon_sym_try] = ACTIONS(5342),
    [anon_sym_match] = ACTIONS(5342),
    [anon_sym_match_BANG] = ACTIONS(5340),
    [anon_sym_function] = ACTIONS(5342),
    [anon_sym_use] = ACTIONS(5342),
    [anon_sym_use_BANG] = ACTIONS(5340),
    [anon_sym_do_BANG] = ACTIONS(5340),
    [anon_sym_begin] = ACTIONS(5342),
    [anon_sym_default] = ACTIONS(5342),
    [anon_sym_static] = ACTIONS(5342),
    [anon_sym_member] = ACTIONS(5342),
    [anon_sym_abstract] = ACTIONS(5342),
    [anon_sym_override] = ACTIONS(5342),
    [anon_sym_val] = ACTIONS(5342),
    [aux_sym_char_token1] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5342),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_AT_DQUOTE] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [sym_bool] = ACTIONS(5342),
    [sym_unit] = ACTIONS(5340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5342),
    [sym_op_identifier] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_DOT] = ACTIONS(5340),
    [anon_sym_DASH_DOT] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5340),
    [anon_sym_AMP_AMP] = ACTIONS(5340),
    [anon_sym_TILDE] = ACTIONS(5340),
    [aux_sym_prefix_op_token1] = ACTIONS(5340),
    [sym_int] = ACTIONS(5342),
    [sym_xint] = ACTIONS(5340),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5340),
    [anon_sym_POUNDload] = ACTIONS(5340),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5340),
  },
  [2975] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2144),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2975),
    [sym_block_comment] = STATE(2975),
    [sym_line_comment] = STATE(2975),
    [sym_compiler_directive_decl] = STATE(2975),
    [sym_fsi_directive_decl] = STATE(2975),
    [sym_preproc_line] = STATE(2975),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2976] = {
    [sym_xml_doc] = STATE(2976),
    [sym_block_comment] = STATE(2976),
    [sym_line_comment] = STATE(2976),
    [sym_compiler_directive_decl] = STATE(2976),
    [sym_fsi_directive_decl] = STATE(2976),
    [sym_preproc_line] = STATE(2976),
    [ts_builtin_sym_end] = ACTIONS(5340),
    [sym_identifier] = ACTIONS(5342),
    [anon_sym_namespace] = ACTIONS(5342),
    [anon_sym_module] = ACTIONS(5342),
    [anon_sym_open] = ACTIONS(5342),
    [anon_sym_LBRACK_LT] = ACTIONS(5340),
    [anon_sym_return] = ACTIONS(5342),
    [anon_sym_type] = ACTIONS(5342),
    [anon_sym_do] = ACTIONS(5342),
    [anon_sym_and] = ACTIONS(5342),
    [anon_sym_let] = ACTIONS(5342),
    [anon_sym_let_BANG] = ACTIONS(5340),
    [aux_sym_access_modifier_token1] = ACTIONS(5340),
    [anon_sym_LPAREN] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_null] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_LT_AT] = ACTIONS(5342),
    [anon_sym_LT_AT_AT] = ACTIONS(5340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5340),
    [anon_sym_new] = ACTIONS(5342),
    [anon_sym_return_BANG] = ACTIONS(5340),
    [anon_sym_yield] = ACTIONS(5342),
    [anon_sym_yield_BANG] = ACTIONS(5340),
    [anon_sym_lazy] = ACTIONS(5342),
    [anon_sym_assert] = ACTIONS(5342),
    [anon_sym_upcast] = ACTIONS(5342),
    [anon_sym_downcast] = ACTIONS(5342),
    [anon_sym_for] = ACTIONS(5342),
    [anon_sym_while] = ACTIONS(5342),
    [anon_sym_if] = ACTIONS(5342),
    [anon_sym_fun] = ACTIONS(5342),
    [anon_sym_try] = ACTIONS(5342),
    [anon_sym_match] = ACTIONS(5342),
    [anon_sym_match_BANG] = ACTIONS(5340),
    [anon_sym_function] = ACTIONS(5342),
    [anon_sym_use] = ACTIONS(5342),
    [anon_sym_use_BANG] = ACTIONS(5340),
    [anon_sym_do_BANG] = ACTIONS(5340),
    [anon_sym_begin] = ACTIONS(5342),
    [anon_sym_default] = ACTIONS(5342),
    [anon_sym_static] = ACTIONS(5342),
    [anon_sym_member] = ACTIONS(5342),
    [anon_sym_abstract] = ACTIONS(5342),
    [anon_sym_override] = ACTIONS(5342),
    [anon_sym_val] = ACTIONS(5342),
    [aux_sym_char_token1] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5342),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_AT_DQUOTE] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [sym_bool] = ACTIONS(5342),
    [sym_unit] = ACTIONS(5340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5342),
    [sym_op_identifier] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_DOT] = ACTIONS(5340),
    [anon_sym_DASH_DOT] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5340),
    [anon_sym_AMP_AMP] = ACTIONS(5340),
    [anon_sym_TILDE] = ACTIONS(5340),
    [aux_sym_prefix_op_token1] = ACTIONS(5340),
    [sym_int] = ACTIONS(5342),
    [sym_xint] = ACTIONS(5340),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5340),
    [anon_sym_POUNDload] = ACTIONS(5340),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5340),
  },
  [2977] = {
    [sym_xml_doc] = STATE(2977),
    [sym_block_comment] = STATE(2977),
    [sym_line_comment] = STATE(2977),
    [sym_compiler_directive_decl] = STATE(2977),
    [sym_fsi_directive_decl] = STATE(2977),
    [sym_preproc_line] = STATE(2977),
    [ts_builtin_sym_end] = ACTIONS(5348),
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_namespace] = ACTIONS(5350),
    [anon_sym_module] = ACTIONS(5350),
    [anon_sym_open] = ACTIONS(5350),
    [anon_sym_LBRACK_LT] = ACTIONS(5348),
    [anon_sym_return] = ACTIONS(5350),
    [anon_sym_type] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_let] = ACTIONS(5350),
    [anon_sym_let_BANG] = ACTIONS(5348),
    [aux_sym_access_modifier_token1] = ACTIONS(5348),
    [anon_sym_LPAREN] = ACTIONS(5350),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_null] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5348),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_LT_AT] = ACTIONS(5350),
    [anon_sym_LT_AT_AT] = ACTIONS(5348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5348),
    [anon_sym_new] = ACTIONS(5350),
    [anon_sym_return_BANG] = ACTIONS(5348),
    [anon_sym_yield] = ACTIONS(5350),
    [anon_sym_yield_BANG] = ACTIONS(5348),
    [anon_sym_lazy] = ACTIONS(5350),
    [anon_sym_assert] = ACTIONS(5350),
    [anon_sym_upcast] = ACTIONS(5350),
    [anon_sym_downcast] = ACTIONS(5350),
    [anon_sym_for] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_fun] = ACTIONS(5350),
    [anon_sym_try] = ACTIONS(5350),
    [anon_sym_match] = ACTIONS(5350),
    [anon_sym_match_BANG] = ACTIONS(5348),
    [anon_sym_function] = ACTIONS(5350),
    [anon_sym_use] = ACTIONS(5350),
    [anon_sym_use_BANG] = ACTIONS(5348),
    [anon_sym_do_BANG] = ACTIONS(5348),
    [anon_sym_begin] = ACTIONS(5350),
    [anon_sym_default] = ACTIONS(5350),
    [anon_sym_static] = ACTIONS(5350),
    [anon_sym_member] = ACTIONS(5350),
    [anon_sym_abstract] = ACTIONS(5350),
    [anon_sym_override] = ACTIONS(5350),
    [anon_sym_val] = ACTIONS(5350),
    [aux_sym_char_token1] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5350),
    [anon_sym_DQUOTE] = ACTIONS(5350),
    [anon_sym_AT_DQUOTE] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [sym_bool] = ACTIONS(5350),
    [sym_unit] = ACTIONS(5348),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5350),
    [sym_op_identifier] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS_DOT] = ACTIONS(5348),
    [anon_sym_DASH_DOT] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [aux_sym_prefix_op_token1] = ACTIONS(5348),
    [sym_int] = ACTIONS(5350),
    [sym_xint] = ACTIONS(5348),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5348),
    [anon_sym_POUNDload] = ACTIONS(5348),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5348),
  },
  [2978] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1007),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2978),
    [sym_block_comment] = STATE(2978),
    [sym_line_comment] = STATE(2978),
    [sym_compiler_directive_decl] = STATE(2978),
    [sym_fsi_directive_decl] = STATE(2978),
    [sym_preproc_line] = STATE(2978),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2979] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2155),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2979),
    [sym_block_comment] = STATE(2979),
    [sym_line_comment] = STATE(2979),
    [sym_compiler_directive_decl] = STATE(2979),
    [sym_fsi_directive_decl] = STATE(2979),
    [sym_preproc_line] = STATE(2979),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2980] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6434),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2980),
    [sym_block_comment] = STATE(2980),
    [sym_line_comment] = STATE(2980),
    [sym_compiler_directive_decl] = STATE(2980),
    [sym_fsi_directive_decl] = STATE(2980),
    [sym_preproc_line] = STATE(2980),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2981] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1521),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2981),
    [sym_block_comment] = STATE(2981),
    [sym_line_comment] = STATE(2981),
    [sym_compiler_directive_decl] = STATE(2981),
    [sym_fsi_directive_decl] = STATE(2981),
    [sym_preproc_line] = STATE(2981),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2982] = {
    [sym_xml_doc] = STATE(2982),
    [sym_block_comment] = STATE(2982),
    [sym_line_comment] = STATE(2982),
    [sym_compiler_directive_decl] = STATE(2982),
    [sym_fsi_directive_decl] = STATE(2982),
    [sym_preproc_line] = STATE(2982),
    [ts_builtin_sym_end] = ACTIONS(5354),
    [sym_identifier] = ACTIONS(5356),
    [anon_sym_namespace] = ACTIONS(5356),
    [anon_sym_module] = ACTIONS(5356),
    [anon_sym_open] = ACTIONS(5356),
    [anon_sym_LBRACK_LT] = ACTIONS(5354),
    [anon_sym_return] = ACTIONS(5356),
    [anon_sym_type] = ACTIONS(5356),
    [anon_sym_do] = ACTIONS(5356),
    [anon_sym_and] = ACTIONS(5356),
    [anon_sym_let] = ACTIONS(5356),
    [anon_sym_let_BANG] = ACTIONS(5354),
    [aux_sym_access_modifier_token1] = ACTIONS(5354),
    [anon_sym_LPAREN] = ACTIONS(5356),
    [anon_sym_null] = ACTIONS(5356),
    [anon_sym_AMP] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(5356),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(5356),
    [anon_sym_LT_AT] = ACTIONS(5356),
    [anon_sym_LT_AT_AT] = ACTIONS(5354),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5354),
    [anon_sym_with] = ACTIONS(5358),
    [anon_sym_new] = ACTIONS(5356),
    [anon_sym_return_BANG] = ACTIONS(5354),
    [anon_sym_yield] = ACTIONS(5356),
    [anon_sym_yield_BANG] = ACTIONS(5354),
    [anon_sym_lazy] = ACTIONS(5356),
    [anon_sym_assert] = ACTIONS(5356),
    [anon_sym_upcast] = ACTIONS(5356),
    [anon_sym_downcast] = ACTIONS(5356),
    [anon_sym_for] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_fun] = ACTIONS(5356),
    [anon_sym_try] = ACTIONS(5356),
    [anon_sym_match] = ACTIONS(5356),
    [anon_sym_match_BANG] = ACTIONS(5354),
    [anon_sym_function] = ACTIONS(5356),
    [anon_sym_use] = ACTIONS(5356),
    [anon_sym_use_BANG] = ACTIONS(5354),
    [anon_sym_do_BANG] = ACTIONS(5354),
    [anon_sym_begin] = ACTIONS(5356),
    [anon_sym_default] = ACTIONS(5356),
    [anon_sym_static] = ACTIONS(5356),
    [anon_sym_member] = ACTIONS(5356),
    [anon_sym_abstract] = ACTIONS(5356),
    [anon_sym_override] = ACTIONS(5356),
    [anon_sym_val] = ACTIONS(5356),
    [aux_sym_char_token1] = ACTIONS(5354),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE] = ACTIONS(5356),
    [anon_sym_AT_DQUOTE] = ACTIONS(5354),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5354),
    [sym_bool] = ACTIONS(5356),
    [sym_unit] = ACTIONS(5354),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5356),
    [sym_op_identifier] = ACTIONS(5354),
    [anon_sym_PLUS] = ACTIONS(5356),
    [anon_sym_DASH] = ACTIONS(5356),
    [anon_sym_PLUS_DOT] = ACTIONS(5354),
    [anon_sym_DASH_DOT] = ACTIONS(5354),
    [anon_sym_PERCENT] = ACTIONS(5354),
    [anon_sym_AMP_AMP] = ACTIONS(5354),
    [anon_sym_TILDE] = ACTIONS(5354),
    [aux_sym_prefix_op_token1] = ACTIONS(5354),
    [sym_int] = ACTIONS(5356),
    [sym_xint] = ACTIONS(5354),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5354),
    [anon_sym_POUNDload] = ACTIONS(5354),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5354),
  },
  [2983] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1223),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2983),
    [sym_block_comment] = STATE(2983),
    [sym_line_comment] = STATE(2983),
    [sym_compiler_directive_decl] = STATE(2983),
    [sym_fsi_directive_decl] = STATE(2983),
    [sym_preproc_line] = STATE(2983),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2984] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1996),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2984),
    [sym_block_comment] = STATE(2984),
    [sym_line_comment] = STATE(2984),
    [sym_compiler_directive_decl] = STATE(2984),
    [sym_fsi_directive_decl] = STATE(2984),
    [sym_preproc_line] = STATE(2984),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2985] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6232),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2985),
    [sym_block_comment] = STATE(2985),
    [sym_line_comment] = STATE(2985),
    [sym_compiler_directive_decl] = STATE(2985),
    [sym_fsi_directive_decl] = STATE(2985),
    [sym_preproc_line] = STATE(2985),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2986] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2162),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2986),
    [sym_block_comment] = STATE(2986),
    [sym_line_comment] = STATE(2986),
    [sym_compiler_directive_decl] = STATE(2986),
    [sym_fsi_directive_decl] = STATE(2986),
    [sym_preproc_line] = STATE(2986),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2987] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5811),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2210),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2987),
    [sym_block_comment] = STATE(2987),
    [sym_line_comment] = STATE(2987),
    [sym_compiler_directive_decl] = STATE(2987),
    [sym_fsi_directive_decl] = STATE(2987),
    [sym_preproc_line] = STATE(2987),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2988] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1953),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2988),
    [sym_block_comment] = STATE(2988),
    [sym_line_comment] = STATE(2988),
    [sym_compiler_directive_decl] = STATE(2988),
    [sym_fsi_directive_decl] = STATE(2988),
    [sym_preproc_line] = STATE(2988),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2989] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5829),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2989),
    [sym_block_comment] = STATE(2989),
    [sym_line_comment] = STATE(2989),
    [sym_compiler_directive_decl] = STATE(2989),
    [sym_fsi_directive_decl] = STATE(2989),
    [sym_preproc_line] = STATE(2989),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2990] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2175),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2990),
    [sym_block_comment] = STATE(2990),
    [sym_line_comment] = STATE(2990),
    [sym_compiler_directive_decl] = STATE(2990),
    [sym_fsi_directive_decl] = STATE(2990),
    [sym_preproc_line] = STATE(2990),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2991] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1011),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2991),
    [sym_block_comment] = STATE(2991),
    [sym_line_comment] = STATE(2991),
    [sym_compiler_directive_decl] = STATE(2991),
    [sym_fsi_directive_decl] = STATE(2991),
    [sym_preproc_line] = STATE(2991),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2992] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5846),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2992),
    [sym_block_comment] = STATE(2992),
    [sym_line_comment] = STATE(2992),
    [sym_compiler_directive_decl] = STATE(2992),
    [sym_fsi_directive_decl] = STATE(2992),
    [sym_preproc_line] = STATE(2992),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(5362),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2993] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1967),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2993),
    [sym_block_comment] = STATE(2993),
    [sym_line_comment] = STATE(2993),
    [sym_compiler_directive_decl] = STATE(2993),
    [sym_fsi_directive_decl] = STATE(2993),
    [sym_preproc_line] = STATE(2993),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2994] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2994),
    [sym_block_comment] = STATE(2994),
    [sym_line_comment] = STATE(2994),
    [sym_compiler_directive_decl] = STATE(2994),
    [sym_fsi_directive_decl] = STATE(2994),
    [sym_preproc_line] = STATE(2994),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2955),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2995] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5696),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(972),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2995),
    [sym_block_comment] = STATE(2995),
    [sym_line_comment] = STATE(2995),
    [sym_compiler_directive_decl] = STATE(2995),
    [sym_fsi_directive_decl] = STATE(2995),
    [sym_preproc_line] = STATE(2995),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2996] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1794),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2996),
    [sym_block_comment] = STATE(2996),
    [sym_line_comment] = STATE(2996),
    [sym_compiler_directive_decl] = STATE(2996),
    [sym_fsi_directive_decl] = STATE(2996),
    [sym_preproc_line] = STATE(2996),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2997] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1723),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2997),
    [sym_block_comment] = STATE(2997),
    [sym_line_comment] = STATE(2997),
    [sym_compiler_directive_decl] = STATE(2997),
    [sym_fsi_directive_decl] = STATE(2997),
    [sym_preproc_line] = STATE(2997),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2998] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(2998),
    [sym_block_comment] = STATE(2998),
    [sym_line_comment] = STATE(2998),
    [sym_compiler_directive_decl] = STATE(2998),
    [sym_fsi_directive_decl] = STATE(2998),
    [sym_preproc_line] = STATE(2998),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2967),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [2999] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1743),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(2999),
    [sym_block_comment] = STATE(2999),
    [sym_line_comment] = STATE(2999),
    [sym_compiler_directive_decl] = STATE(2999),
    [sym_fsi_directive_decl] = STATE(2999),
    [sym_preproc_line] = STATE(2999),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3000] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3000),
    [sym_block_comment] = STATE(3000),
    [sym_line_comment] = STATE(3000),
    [sym_compiler_directive_decl] = STATE(3000),
    [sym_fsi_directive_decl] = STATE(3000),
    [sym_preproc_line] = STATE(3000),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3001] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5868),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3001),
    [sym_block_comment] = STATE(3001),
    [sym_line_comment] = STATE(3001),
    [sym_compiler_directive_decl] = STATE(3001),
    [sym_fsi_directive_decl] = STATE(3001),
    [sym_preproc_line] = STATE(3001),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3002] = {
    [sym_xml_doc] = STATE(3002),
    [sym_block_comment] = STATE(3002),
    [sym_line_comment] = STATE(3002),
    [sym_compiler_directive_decl] = STATE(3002),
    [sym_fsi_directive_decl] = STATE(3002),
    [sym_preproc_line] = STATE(3002),
    [ts_builtin_sym_end] = ACTIONS(5366),
    [sym_identifier] = ACTIONS(5368),
    [anon_sym_namespace] = ACTIONS(5368),
    [anon_sym_module] = ACTIONS(5368),
    [anon_sym_open] = ACTIONS(5368),
    [anon_sym_LBRACK_LT] = ACTIONS(5366),
    [anon_sym_return] = ACTIONS(5368),
    [anon_sym_type] = ACTIONS(5368),
    [anon_sym_do] = ACTIONS(5368),
    [anon_sym_and] = ACTIONS(5368),
    [anon_sym_let] = ACTIONS(5368),
    [anon_sym_let_BANG] = ACTIONS(5366),
    [aux_sym_access_modifier_token1] = ACTIONS(5366),
    [anon_sym_LPAREN] = ACTIONS(5368),
    [anon_sym_null] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_LBRACK] = ACTIONS(5368),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5368),
    [anon_sym_LT_AT] = ACTIONS(5368),
    [anon_sym_LT_AT_AT] = ACTIONS(5366),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5366),
    [anon_sym_with] = ACTIONS(5370),
    [anon_sym_new] = ACTIONS(5368),
    [anon_sym_return_BANG] = ACTIONS(5366),
    [anon_sym_yield] = ACTIONS(5368),
    [anon_sym_yield_BANG] = ACTIONS(5366),
    [anon_sym_lazy] = ACTIONS(5368),
    [anon_sym_assert] = ACTIONS(5368),
    [anon_sym_upcast] = ACTIONS(5368),
    [anon_sym_downcast] = ACTIONS(5368),
    [anon_sym_for] = ACTIONS(5368),
    [anon_sym_while] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(5368),
    [anon_sym_fun] = ACTIONS(5368),
    [anon_sym_try] = ACTIONS(5368),
    [anon_sym_match] = ACTIONS(5368),
    [anon_sym_match_BANG] = ACTIONS(5366),
    [anon_sym_function] = ACTIONS(5368),
    [anon_sym_use] = ACTIONS(5368),
    [anon_sym_use_BANG] = ACTIONS(5366),
    [anon_sym_do_BANG] = ACTIONS(5366),
    [anon_sym_begin] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_member] = ACTIONS(5368),
    [anon_sym_abstract] = ACTIONS(5368),
    [anon_sym_override] = ACTIONS(5368),
    [anon_sym_val] = ACTIONS(5368),
    [aux_sym_char_token1] = ACTIONS(5366),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5368),
    [anon_sym_DQUOTE] = ACTIONS(5368),
    [anon_sym_AT_DQUOTE] = ACTIONS(5366),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5366),
    [sym_bool] = ACTIONS(5368),
    [sym_unit] = ACTIONS(5366),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5368),
    [sym_op_identifier] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_PLUS_DOT] = ACTIONS(5366),
    [anon_sym_DASH_DOT] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5366),
    [anon_sym_AMP_AMP] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(5366),
    [aux_sym_prefix_op_token1] = ACTIONS(5366),
    [sym_int] = ACTIONS(5368),
    [sym_xint] = ACTIONS(5366),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5366),
    [anon_sym_POUNDload] = ACTIONS(5366),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5366),
  },
  [3003] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3003),
    [sym_block_comment] = STATE(3003),
    [sym_line_comment] = STATE(3003),
    [sym_compiler_directive_decl] = STATE(3003),
    [sym_fsi_directive_decl] = STATE(3003),
    [sym_preproc_line] = STATE(3003),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2961),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3004] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3004),
    [sym_block_comment] = STATE(3004),
    [sym_line_comment] = STATE(3004),
    [sym_compiler_directive_decl] = STATE(3004),
    [sym_fsi_directive_decl] = STATE(3004),
    [sym_preproc_line] = STATE(3004),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2964),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3005] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1619),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3005),
    [sym_block_comment] = STATE(3005),
    [sym_line_comment] = STATE(3005),
    [sym_compiler_directive_decl] = STATE(3005),
    [sym_fsi_directive_decl] = STATE(3005),
    [sym_preproc_line] = STATE(3005),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3006] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5729),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1997),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3006),
    [sym_block_comment] = STATE(3006),
    [sym_line_comment] = STATE(3006),
    [sym_compiler_directive_decl] = STATE(3006),
    [sym_fsi_directive_decl] = STATE(3006),
    [sym_preproc_line] = STATE(3006),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3007] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1689),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3007),
    [sym_block_comment] = STATE(3007),
    [sym_line_comment] = STATE(3007),
    [sym_compiler_directive_decl] = STATE(3007),
    [sym_fsi_directive_decl] = STATE(3007),
    [sym_preproc_line] = STATE(3007),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3008] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1876),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3008),
    [sym_block_comment] = STATE(3008),
    [sym_line_comment] = STATE(3008),
    [sym_compiler_directive_decl] = STATE(3008),
    [sym_fsi_directive_decl] = STATE(3008),
    [sym_preproc_line] = STATE(3008),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3009] = {
    [sym_xml_doc] = STATE(3009),
    [sym_block_comment] = STATE(3009),
    [sym_line_comment] = STATE(3009),
    [sym_compiler_directive_decl] = STATE(3009),
    [sym_fsi_directive_decl] = STATE(3009),
    [sym_preproc_line] = STATE(3009),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_namespace] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [aux_sym_access_modifier_token1] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_default] = ACTIONS(3438),
    [anon_sym_static] = ACTIONS(3438),
    [anon_sym_member] = ACTIONS(3438),
    [anon_sym_abstract] = ACTIONS(3438),
    [anon_sym_override] = ACTIONS(3438),
    [anon_sym_val] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3440),
    [anon_sym_DASH_DOT] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3440),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
  },
  [3010] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5690),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1869),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3010),
    [sym_block_comment] = STATE(3010),
    [sym_line_comment] = STATE(3010),
    [sym_compiler_directive_decl] = STATE(3010),
    [sym_fsi_directive_decl] = STATE(3010),
    [sym_preproc_line] = STATE(3010),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3011] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5667),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1799),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3011),
    [sym_block_comment] = STATE(3011),
    [sym_line_comment] = STATE(3011),
    [sym_compiler_directive_decl] = STATE(3011),
    [sym_fsi_directive_decl] = STATE(3011),
    [sym_preproc_line] = STATE(3011),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3012] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1861),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3012),
    [sym_block_comment] = STATE(3012),
    [sym_line_comment] = STATE(3012),
    [sym_compiler_directive_decl] = STATE(3012),
    [sym_fsi_directive_decl] = STATE(3012),
    [sym_preproc_line] = STATE(3012),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3013] = {
    [sym_xml_doc] = STATE(3013),
    [sym_block_comment] = STATE(3013),
    [sym_line_comment] = STATE(3013),
    [sym_compiler_directive_decl] = STATE(3013),
    [sym_fsi_directive_decl] = STATE(3013),
    [sym_preproc_line] = STATE(3013),
    [ts_builtin_sym_end] = ACTIONS(5372),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_namespace] = ACTIONS(5374),
    [anon_sym_module] = ACTIONS(5374),
    [anon_sym_open] = ACTIONS(5374),
    [anon_sym_LBRACK_LT] = ACTIONS(5372),
    [anon_sym_return] = ACTIONS(5374),
    [anon_sym_type] = ACTIONS(5374),
    [anon_sym_do] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_let] = ACTIONS(5374),
    [anon_sym_let_BANG] = ACTIONS(5372),
    [aux_sym_access_modifier_token1] = ACTIONS(5372),
    [anon_sym_LPAREN] = ACTIONS(5374),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_null] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5372),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_LT_AT] = ACTIONS(5374),
    [anon_sym_LT_AT_AT] = ACTIONS(5372),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5372),
    [anon_sym_new] = ACTIONS(5374),
    [anon_sym_return_BANG] = ACTIONS(5372),
    [anon_sym_yield] = ACTIONS(5374),
    [anon_sym_yield_BANG] = ACTIONS(5372),
    [anon_sym_lazy] = ACTIONS(5374),
    [anon_sym_assert] = ACTIONS(5374),
    [anon_sym_upcast] = ACTIONS(5374),
    [anon_sym_downcast] = ACTIONS(5374),
    [anon_sym_for] = ACTIONS(5374),
    [anon_sym_while] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_fun] = ACTIONS(5374),
    [anon_sym_try] = ACTIONS(5374),
    [anon_sym_match] = ACTIONS(5374),
    [anon_sym_match_BANG] = ACTIONS(5372),
    [anon_sym_function] = ACTIONS(5374),
    [anon_sym_use] = ACTIONS(5374),
    [anon_sym_use_BANG] = ACTIONS(5372),
    [anon_sym_do_BANG] = ACTIONS(5372),
    [anon_sym_begin] = ACTIONS(5374),
    [anon_sym_default] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_member] = ACTIONS(5374),
    [anon_sym_abstract] = ACTIONS(5374),
    [anon_sym_override] = ACTIONS(5374),
    [anon_sym_val] = ACTIONS(5374),
    [aux_sym_char_token1] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5374),
    [anon_sym_DQUOTE] = ACTIONS(5374),
    [anon_sym_AT_DQUOTE] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [sym_bool] = ACTIONS(5374),
    [sym_unit] = ACTIONS(5372),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5374),
    [sym_op_identifier] = ACTIONS(5372),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS_DOT] = ACTIONS(5372),
    [anon_sym_DASH_DOT] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [aux_sym_prefix_op_token1] = ACTIONS(5372),
    [sym_int] = ACTIONS(5374),
    [sym_xint] = ACTIONS(5372),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5372),
    [anon_sym_POUNDload] = ACTIONS(5372),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5372),
  },
  [3014] = {
    [sym_xml_doc] = STATE(3014),
    [sym_block_comment] = STATE(3014),
    [sym_line_comment] = STATE(3014),
    [sym_compiler_directive_decl] = STATE(3014),
    [sym_fsi_directive_decl] = STATE(3014),
    [sym_preproc_line] = STATE(3014),
    [ts_builtin_sym_end] = ACTIONS(5372),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_namespace] = ACTIONS(5374),
    [anon_sym_module] = ACTIONS(5374),
    [anon_sym_open] = ACTIONS(5374),
    [anon_sym_LBRACK_LT] = ACTIONS(5372),
    [anon_sym_return] = ACTIONS(5374),
    [anon_sym_type] = ACTIONS(5374),
    [anon_sym_do] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_let] = ACTIONS(5374),
    [anon_sym_let_BANG] = ACTIONS(5372),
    [aux_sym_access_modifier_token1] = ACTIONS(5372),
    [anon_sym_LPAREN] = ACTIONS(5374),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_null] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5372),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_LT_AT] = ACTIONS(5374),
    [anon_sym_LT_AT_AT] = ACTIONS(5372),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5372),
    [anon_sym_new] = ACTIONS(5374),
    [anon_sym_return_BANG] = ACTIONS(5372),
    [anon_sym_yield] = ACTIONS(5374),
    [anon_sym_yield_BANG] = ACTIONS(5372),
    [anon_sym_lazy] = ACTIONS(5374),
    [anon_sym_assert] = ACTIONS(5374),
    [anon_sym_upcast] = ACTIONS(5374),
    [anon_sym_downcast] = ACTIONS(5374),
    [anon_sym_for] = ACTIONS(5374),
    [anon_sym_while] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_fun] = ACTIONS(5374),
    [anon_sym_try] = ACTIONS(5374),
    [anon_sym_match] = ACTIONS(5374),
    [anon_sym_match_BANG] = ACTIONS(5372),
    [anon_sym_function] = ACTIONS(5374),
    [anon_sym_use] = ACTIONS(5374),
    [anon_sym_use_BANG] = ACTIONS(5372),
    [anon_sym_do_BANG] = ACTIONS(5372),
    [anon_sym_begin] = ACTIONS(5374),
    [anon_sym_default] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_member] = ACTIONS(5374),
    [anon_sym_abstract] = ACTIONS(5374),
    [anon_sym_override] = ACTIONS(5374),
    [anon_sym_val] = ACTIONS(5374),
    [aux_sym_char_token1] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5374),
    [anon_sym_DQUOTE] = ACTIONS(5374),
    [anon_sym_AT_DQUOTE] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [sym_bool] = ACTIONS(5374),
    [sym_unit] = ACTIONS(5372),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5374),
    [sym_op_identifier] = ACTIONS(5372),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS_DOT] = ACTIONS(5372),
    [anon_sym_DASH_DOT] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [aux_sym_prefix_op_token1] = ACTIONS(5372),
    [sym_int] = ACTIONS(5374),
    [sym_xint] = ACTIONS(5372),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5372),
    [anon_sym_POUNDload] = ACTIONS(5372),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5372),
  },
  [3015] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1271),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3015),
    [sym_block_comment] = STATE(3015),
    [sym_line_comment] = STATE(3015),
    [sym_compiler_directive_decl] = STATE(3015),
    [sym_fsi_directive_decl] = STATE(3015),
    [sym_preproc_line] = STATE(3015),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3016] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1404),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3016),
    [sym_block_comment] = STATE(3016),
    [sym_line_comment] = STATE(3016),
    [sym_compiler_directive_decl] = STATE(3016),
    [sym_fsi_directive_decl] = STATE(3016),
    [sym_preproc_line] = STATE(3016),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3017] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1812),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3017),
    [sym_block_comment] = STATE(3017),
    [sym_line_comment] = STATE(3017),
    [sym_compiler_directive_decl] = STATE(3017),
    [sym_fsi_directive_decl] = STATE(3017),
    [sym_preproc_line] = STATE(3017),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3018] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2121),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3018),
    [sym_block_comment] = STATE(3018),
    [sym_line_comment] = STATE(3018),
    [sym_compiler_directive_decl] = STATE(3018),
    [sym_fsi_directive_decl] = STATE(3018),
    [sym_preproc_line] = STATE(3018),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3019] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1263),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3019),
    [sym_block_comment] = STATE(3019),
    [sym_line_comment] = STATE(3019),
    [sym_compiler_directive_decl] = STATE(3019),
    [sym_fsi_directive_decl] = STATE(3019),
    [sym_preproc_line] = STATE(3019),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3020] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5675),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1709),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3020),
    [sym_block_comment] = STATE(3020),
    [sym_line_comment] = STATE(3020),
    [sym_compiler_directive_decl] = STATE(3020),
    [sym_fsi_directive_decl] = STATE(3020),
    [sym_preproc_line] = STATE(3020),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3021] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5761),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1426),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3021),
    [sym_block_comment] = STATE(3021),
    [sym_line_comment] = STATE(3021),
    [sym_compiler_directive_decl] = STATE(3021),
    [sym_fsi_directive_decl] = STATE(3021),
    [sym_preproc_line] = STATE(3021),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3022] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2267),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3022),
    [sym_block_comment] = STATE(3022),
    [sym_line_comment] = STATE(3022),
    [sym_compiler_directive_decl] = STATE(3022),
    [sym_fsi_directive_decl] = STATE(3022),
    [sym_preproc_line] = STATE(3022),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3023] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5685),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1166),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3023),
    [sym_block_comment] = STATE(3023),
    [sym_line_comment] = STATE(3023),
    [sym_compiler_directive_decl] = STATE(3023),
    [sym_fsi_directive_decl] = STATE(3023),
    [sym_preproc_line] = STATE(3023),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3024] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5770),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(6293),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3024),
    [sym_block_comment] = STATE(3024),
    [sym_line_comment] = STATE(3024),
    [sym_compiler_directive_decl] = STATE(3024),
    [sym_fsi_directive_decl] = STATE(3024),
    [sym_preproc_line] = STATE(3024),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3025] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5800),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1725),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3025),
    [sym_block_comment] = STATE(3025),
    [sym_line_comment] = STATE(3025),
    [sym_compiler_directive_decl] = STATE(3025),
    [sym_fsi_directive_decl] = STATE(3025),
    [sym_preproc_line] = STATE(3025),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3026] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5637),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1774),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3026),
    [sym_block_comment] = STATE(3026),
    [sym_line_comment] = STATE(3026),
    [sym_compiler_directive_decl] = STATE(3026),
    [sym_fsi_directive_decl] = STATE(3026),
    [sym_preproc_line] = STATE(3026),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3027] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5677),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2180),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3027),
    [sym_block_comment] = STATE(3027),
    [sym_line_comment] = STATE(3027),
    [sym_compiler_directive_decl] = STATE(3027),
    [sym_fsi_directive_decl] = STATE(3027),
    [sym_preproc_line] = STATE(3027),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3028] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5799),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(2190),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3028),
    [sym_block_comment] = STATE(3028),
    [sym_line_comment] = STATE(3028),
    [sym_compiler_directive_decl] = STATE(3028),
    [sym_fsi_directive_decl] = STATE(3028),
    [sym_preproc_line] = STATE(3028),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3029] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5746),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_rule] = STATE(1683),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3029),
    [sym_block_comment] = STATE(3029),
    [sym_line_comment] = STATE(3029),
    [sym_compiler_directive_decl] = STATE(3029),
    [sym_fsi_directive_decl] = STATE(3029),
    [sym_preproc_line] = STATE(3029),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3030] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5372),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3030),
    [sym_block_comment] = STATE(3030),
    [sym_line_comment] = STATE(3030),
    [sym_compiler_directive_decl] = STATE(3030),
    [sym_fsi_directive_decl] = STATE(3030),
    [sym_preproc_line] = STATE(3030),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [sym__newline] = ACTIONS(5380),
  },
  [3031] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3966),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3031),
    [sym_block_comment] = STATE(3031),
    [sym_line_comment] = STATE(3031),
    [sym_compiler_directive_decl] = STATE(3031),
    [sym_fsi_directive_decl] = STATE(3031),
    [sym_preproc_line] = STATE(3031),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [aux_sym__method_defn_repeat1] = STATE(2958),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3032] = {
    [sym_xml_doc] = STATE(3032),
    [sym_block_comment] = STATE(3032),
    [sym_line_comment] = STATE(3032),
    [sym_compiler_directive_decl] = STATE(3032),
    [sym_fsi_directive_decl] = STATE(3032),
    [sym_preproc_line] = STATE(3032),
    [ts_builtin_sym_end] = ACTIONS(5348),
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_namespace] = ACTIONS(5350),
    [anon_sym_module] = ACTIONS(5350),
    [anon_sym_open] = ACTIONS(5350),
    [anon_sym_LBRACK_LT] = ACTIONS(5348),
    [anon_sym_return] = ACTIONS(5350),
    [anon_sym_type] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_let] = ACTIONS(5350),
    [anon_sym_let_BANG] = ACTIONS(5348),
    [aux_sym_access_modifier_token1] = ACTIONS(5348),
    [anon_sym_LPAREN] = ACTIONS(5350),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_null] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5348),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_LT_AT] = ACTIONS(5350),
    [anon_sym_LT_AT_AT] = ACTIONS(5348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5348),
    [anon_sym_new] = ACTIONS(5350),
    [anon_sym_return_BANG] = ACTIONS(5348),
    [anon_sym_yield] = ACTIONS(5350),
    [anon_sym_yield_BANG] = ACTIONS(5348),
    [anon_sym_lazy] = ACTIONS(5350),
    [anon_sym_assert] = ACTIONS(5350),
    [anon_sym_upcast] = ACTIONS(5350),
    [anon_sym_downcast] = ACTIONS(5350),
    [anon_sym_for] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_fun] = ACTIONS(5350),
    [anon_sym_try] = ACTIONS(5350),
    [anon_sym_match] = ACTIONS(5350),
    [anon_sym_match_BANG] = ACTIONS(5348),
    [anon_sym_function] = ACTIONS(5350),
    [anon_sym_use] = ACTIONS(5350),
    [anon_sym_use_BANG] = ACTIONS(5348),
    [anon_sym_do_BANG] = ACTIONS(5348),
    [anon_sym_begin] = ACTIONS(5350),
    [anon_sym_default] = ACTIONS(5350),
    [anon_sym_static] = ACTIONS(5350),
    [anon_sym_member] = ACTIONS(5350),
    [anon_sym_abstract] = ACTIONS(5350),
    [anon_sym_override] = ACTIONS(5350),
    [anon_sym_val] = ACTIONS(5350),
    [aux_sym_char_token1] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5350),
    [anon_sym_DQUOTE] = ACTIONS(5350),
    [anon_sym_AT_DQUOTE] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [sym_bool] = ACTIONS(5350),
    [sym_unit] = ACTIONS(5348),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5350),
    [sym_op_identifier] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS_DOT] = ACTIONS(5348),
    [anon_sym_DASH_DOT] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [aux_sym_prefix_op_token1] = ACTIONS(5348),
    [sym_int] = ACTIONS(5350),
    [sym_xint] = ACTIONS(5348),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5348),
    [anon_sym_POUNDload] = ACTIONS(5348),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5348),
  },
  [3033] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5820),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3033),
    [sym_block_comment] = STATE(3033),
    [sym_line_comment] = STATE(3033),
    [sym_compiler_directive_decl] = STATE(3033),
    [sym_fsi_directive_decl] = STATE(3033),
    [sym_preproc_line] = STATE(3033),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3034] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5804),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3034),
    [sym_block_comment] = STATE(3034),
    [sym_line_comment] = STATE(3034),
    [sym_compiler_directive_decl] = STATE(3034),
    [sym_fsi_directive_decl] = STATE(3034),
    [sym_preproc_line] = STATE(3034),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3035] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5823),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3035),
    [sym_block_comment] = STATE(3035),
    [sym_line_comment] = STATE(3035),
    [sym_compiler_directive_decl] = STATE(3035),
    [sym_fsi_directive_decl] = STATE(3035),
    [sym_preproc_line] = STATE(3035),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5384),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3036] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3873),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3036),
    [sym_block_comment] = STATE(3036),
    [sym_line_comment] = STATE(3036),
    [sym_compiler_directive_decl] = STATE(3036),
    [sym_fsi_directive_decl] = STATE(3036),
    [sym_preproc_line] = STATE(3036),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3037] = {
    [sym_xml_doc] = STATE(3037),
    [sym_block_comment] = STATE(3037),
    [sym_line_comment] = STATE(3037),
    [sym_compiler_directive_decl] = STATE(3037),
    [sym_fsi_directive_decl] = STATE(3037),
    [sym_preproc_line] = STATE(3037),
    [ts_builtin_sym_end] = ACTIONS(5390),
    [sym_identifier] = ACTIONS(5392),
    [anon_sym_namespace] = ACTIONS(5392),
    [anon_sym_module] = ACTIONS(5392),
    [anon_sym_open] = ACTIONS(5392),
    [anon_sym_LBRACK_LT] = ACTIONS(5390),
    [anon_sym_return] = ACTIONS(5392),
    [anon_sym_type] = ACTIONS(5392),
    [anon_sym_do] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_let] = ACTIONS(5392),
    [anon_sym_let_BANG] = ACTIONS(5390),
    [aux_sym_access_modifier_token1] = ACTIONS(5390),
    [anon_sym_LPAREN] = ACTIONS(5392),
    [anon_sym_null] = ACTIONS(5392),
    [anon_sym_AMP] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(5392),
    [anon_sym_LT_AT] = ACTIONS(5392),
    [anon_sym_LT_AT_AT] = ACTIONS(5390),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5390),
    [anon_sym_new] = ACTIONS(5392),
    [anon_sym_return_BANG] = ACTIONS(5390),
    [anon_sym_yield] = ACTIONS(5392),
    [anon_sym_yield_BANG] = ACTIONS(5390),
    [anon_sym_lazy] = ACTIONS(5392),
    [anon_sym_assert] = ACTIONS(5392),
    [anon_sym_upcast] = ACTIONS(5392),
    [anon_sym_downcast] = ACTIONS(5392),
    [anon_sym_for] = ACTIONS(5392),
    [anon_sym_while] = ACTIONS(5392),
    [anon_sym_if] = ACTIONS(5392),
    [anon_sym_fun] = ACTIONS(5392),
    [anon_sym_try] = ACTIONS(5392),
    [anon_sym_match] = ACTIONS(5392),
    [anon_sym_match_BANG] = ACTIONS(5390),
    [anon_sym_function] = ACTIONS(5392),
    [anon_sym_use] = ACTIONS(5392),
    [anon_sym_use_BANG] = ACTIONS(5390),
    [anon_sym_do_BANG] = ACTIONS(5390),
    [anon_sym_begin] = ACTIONS(5392),
    [anon_sym_default] = ACTIONS(5392),
    [anon_sym_static] = ACTIONS(5392),
    [anon_sym_member] = ACTIONS(5392),
    [anon_sym_abstract] = ACTIONS(5392),
    [anon_sym_override] = ACTIONS(5392),
    [anon_sym_val] = ACTIONS(5392),
    [aux_sym_char_token1] = ACTIONS(5390),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5392),
    [anon_sym_DQUOTE] = ACTIONS(5392),
    [anon_sym_AT_DQUOTE] = ACTIONS(5390),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5390),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5390),
    [sym_bool] = ACTIONS(5392),
    [sym_unit] = ACTIONS(5390),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5392),
    [sym_op_identifier] = ACTIONS(5390),
    [anon_sym_PLUS] = ACTIONS(5392),
    [anon_sym_DASH] = ACTIONS(5392),
    [anon_sym_PLUS_DOT] = ACTIONS(5390),
    [anon_sym_DASH_DOT] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_TILDE] = ACTIONS(5390),
    [aux_sym_prefix_op_token1] = ACTIONS(5390),
    [sym_int] = ACTIONS(5392),
    [sym_xint] = ACTIONS(5390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5390),
    [anon_sym_POUNDload] = ACTIONS(5390),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5390),
  },
  [3038] = {
    [sym_xml_doc] = STATE(3038),
    [sym_block_comment] = STATE(3038),
    [sym_line_comment] = STATE(3038),
    [sym_compiler_directive_decl] = STATE(3038),
    [sym_fsi_directive_decl] = STATE(3038),
    [sym_preproc_line] = STATE(3038),
    [ts_builtin_sym_end] = ACTIONS(5394),
    [sym_identifier] = ACTIONS(5396),
    [anon_sym_namespace] = ACTIONS(5396),
    [anon_sym_module] = ACTIONS(5396),
    [anon_sym_open] = ACTIONS(5396),
    [anon_sym_LBRACK_LT] = ACTIONS(5394),
    [anon_sym_return] = ACTIONS(5396),
    [anon_sym_type] = ACTIONS(5396),
    [anon_sym_do] = ACTIONS(5396),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_let] = ACTIONS(5396),
    [anon_sym_let_BANG] = ACTIONS(5394),
    [aux_sym_access_modifier_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_null] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5394),
    [anon_sym_LBRACE] = ACTIONS(5396),
    [anon_sym_LT_AT] = ACTIONS(5396),
    [anon_sym_LT_AT_AT] = ACTIONS(5394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5394),
    [anon_sym_new] = ACTIONS(5396),
    [anon_sym_return_BANG] = ACTIONS(5394),
    [anon_sym_yield] = ACTIONS(5396),
    [anon_sym_yield_BANG] = ACTIONS(5394),
    [anon_sym_lazy] = ACTIONS(5396),
    [anon_sym_assert] = ACTIONS(5396),
    [anon_sym_upcast] = ACTIONS(5396),
    [anon_sym_downcast] = ACTIONS(5396),
    [anon_sym_for] = ACTIONS(5396),
    [anon_sym_while] = ACTIONS(5396),
    [anon_sym_if] = ACTIONS(5396),
    [anon_sym_fun] = ACTIONS(5396),
    [anon_sym_try] = ACTIONS(5396),
    [anon_sym_match] = ACTIONS(5396),
    [anon_sym_match_BANG] = ACTIONS(5394),
    [anon_sym_function] = ACTIONS(5396),
    [anon_sym_use] = ACTIONS(5396),
    [anon_sym_use_BANG] = ACTIONS(5394),
    [anon_sym_do_BANG] = ACTIONS(5394),
    [anon_sym_begin] = ACTIONS(5396),
    [anon_sym_default] = ACTIONS(5396),
    [anon_sym_static] = ACTIONS(5396),
    [anon_sym_member] = ACTIONS(5396),
    [anon_sym_abstract] = ACTIONS(5396),
    [anon_sym_override] = ACTIONS(5396),
    [anon_sym_val] = ACTIONS(5396),
    [aux_sym_char_token1] = ACTIONS(5394),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5396),
    [anon_sym_DQUOTE] = ACTIONS(5396),
    [anon_sym_AT_DQUOTE] = ACTIONS(5394),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5394),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5394),
    [sym_bool] = ACTIONS(5396),
    [sym_unit] = ACTIONS(5394),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5396),
    [sym_op_identifier] = ACTIONS(5394),
    [anon_sym_PLUS] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5396),
    [anon_sym_PLUS_DOT] = ACTIONS(5394),
    [anon_sym_DASH_DOT] = ACTIONS(5394),
    [anon_sym_PERCENT] = ACTIONS(5394),
    [anon_sym_AMP_AMP] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5394),
    [aux_sym_prefix_op_token1] = ACTIONS(5394),
    [sym_int] = ACTIONS(5396),
    [sym_xint] = ACTIONS(5394),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5394),
    [anon_sym_POUNDload] = ACTIONS(5394),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5394),
  },
  [3039] = {
    [sym_xml_doc] = STATE(3039),
    [sym_block_comment] = STATE(3039),
    [sym_line_comment] = STATE(3039),
    [sym_compiler_directive_decl] = STATE(3039),
    [sym_fsi_directive_decl] = STATE(3039),
    [sym_preproc_line] = STATE(3039),
    [ts_builtin_sym_end] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5400),
    [anon_sym_namespace] = ACTIONS(5400),
    [anon_sym_module] = ACTIONS(5400),
    [anon_sym_open] = ACTIONS(5400),
    [anon_sym_LBRACK_LT] = ACTIONS(5398),
    [anon_sym_return] = ACTIONS(5400),
    [anon_sym_type] = ACTIONS(5400),
    [anon_sym_do] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_let] = ACTIONS(5400),
    [anon_sym_let_BANG] = ACTIONS(5398),
    [aux_sym_access_modifier_token1] = ACTIONS(5398),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_null] = ACTIONS(5400),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5398),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_LT_AT] = ACTIONS(5400),
    [anon_sym_LT_AT_AT] = ACTIONS(5398),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5398),
    [anon_sym_new] = ACTIONS(5400),
    [anon_sym_return_BANG] = ACTIONS(5398),
    [anon_sym_yield] = ACTIONS(5400),
    [anon_sym_yield_BANG] = ACTIONS(5398),
    [anon_sym_lazy] = ACTIONS(5400),
    [anon_sym_assert] = ACTIONS(5400),
    [anon_sym_upcast] = ACTIONS(5400),
    [anon_sym_downcast] = ACTIONS(5400),
    [anon_sym_for] = ACTIONS(5400),
    [anon_sym_while] = ACTIONS(5400),
    [anon_sym_if] = ACTIONS(5400),
    [anon_sym_fun] = ACTIONS(5400),
    [anon_sym_try] = ACTIONS(5400),
    [anon_sym_match] = ACTIONS(5400),
    [anon_sym_match_BANG] = ACTIONS(5398),
    [anon_sym_function] = ACTIONS(5400),
    [anon_sym_use] = ACTIONS(5400),
    [anon_sym_use_BANG] = ACTIONS(5398),
    [anon_sym_do_BANG] = ACTIONS(5398),
    [anon_sym_begin] = ACTIONS(5400),
    [anon_sym_default] = ACTIONS(5400),
    [anon_sym_static] = ACTIONS(5400),
    [anon_sym_member] = ACTIONS(5400),
    [anon_sym_abstract] = ACTIONS(5400),
    [anon_sym_override] = ACTIONS(5400),
    [anon_sym_val] = ACTIONS(5400),
    [aux_sym_char_token1] = ACTIONS(5398),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5400),
    [anon_sym_DQUOTE] = ACTIONS(5400),
    [anon_sym_AT_DQUOTE] = ACTIONS(5398),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5398),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5398),
    [sym_bool] = ACTIONS(5400),
    [sym_unit] = ACTIONS(5398),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5400),
    [sym_op_identifier] = ACTIONS(5398),
    [anon_sym_PLUS] = ACTIONS(5400),
    [anon_sym_DASH] = ACTIONS(5400),
    [anon_sym_PLUS_DOT] = ACTIONS(5398),
    [anon_sym_DASH_DOT] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_AMP_AMP] = ACTIONS(5398),
    [anon_sym_TILDE] = ACTIONS(5398),
    [aux_sym_prefix_op_token1] = ACTIONS(5398),
    [sym_int] = ACTIONS(5400),
    [sym_xint] = ACTIONS(5398),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5398),
    [anon_sym_POUNDload] = ACTIONS(5398),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5398),
  },
  [3040] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5662),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3040),
    [sym_block_comment] = STATE(3040),
    [sym_line_comment] = STATE(3040),
    [sym_compiler_directive_decl] = STATE(3040),
    [sym_fsi_directive_decl] = STATE(3040),
    [sym_preproc_line] = STATE(3040),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3041] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4063),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3041),
    [sym_block_comment] = STATE(3041),
    [sym_line_comment] = STATE(3041),
    [sym_compiler_directive_decl] = STATE(3041),
    [sym_fsi_directive_decl] = STATE(3041),
    [sym_preproc_line] = STATE(3041),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3042] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4068),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3042),
    [sym_block_comment] = STATE(3042),
    [sym_line_comment] = STATE(3042),
    [sym_compiler_directive_decl] = STATE(3042),
    [sym_fsi_directive_decl] = STATE(3042),
    [sym_preproc_line] = STATE(3042),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3043] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4074),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3043),
    [sym_block_comment] = STATE(3043),
    [sym_line_comment] = STATE(3043),
    [sym_compiler_directive_decl] = STATE(3043),
    [sym_fsi_directive_decl] = STATE(3043),
    [sym_preproc_line] = STATE(3043),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3044] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4078),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3044),
    [sym_block_comment] = STATE(3044),
    [sym_line_comment] = STATE(3044),
    [sym_compiler_directive_decl] = STATE(3044),
    [sym_fsi_directive_decl] = STATE(3044),
    [sym_preproc_line] = STATE(3044),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3045] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5446),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3045),
    [sym_block_comment] = STATE(3045),
    [sym_line_comment] = STATE(3045),
    [sym_compiler_directive_decl] = STATE(3045),
    [sym_fsi_directive_decl] = STATE(3045),
    [sym_preproc_line] = STATE(3045),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3046] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5694),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3046),
    [sym_block_comment] = STATE(3046),
    [sym_line_comment] = STATE(3046),
    [sym_compiler_directive_decl] = STATE(3046),
    [sym_fsi_directive_decl] = STATE(3046),
    [sym_preproc_line] = STATE(3046),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3047] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5447),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3047),
    [sym_block_comment] = STATE(3047),
    [sym_line_comment] = STATE(3047),
    [sym_compiler_directive_decl] = STATE(3047),
    [sym_fsi_directive_decl] = STATE(3047),
    [sym_preproc_line] = STATE(3047),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3048] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4123),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3048),
    [sym_block_comment] = STATE(3048),
    [sym_line_comment] = STATE(3048),
    [sym_compiler_directive_decl] = STATE(3048),
    [sym_fsi_directive_decl] = STATE(3048),
    [sym_preproc_line] = STATE(3048),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3049] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5448),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3049),
    [sym_block_comment] = STATE(3049),
    [sym_line_comment] = STATE(3049),
    [sym_compiler_directive_decl] = STATE(3049),
    [sym_fsi_directive_decl] = STATE(3049),
    [sym_preproc_line] = STATE(3049),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3050] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4093),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3050),
    [sym_block_comment] = STATE(3050),
    [sym_line_comment] = STATE(3050),
    [sym_compiler_directive_decl] = STATE(3050),
    [sym_fsi_directive_decl] = STATE(3050),
    [sym_preproc_line] = STATE(3050),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3051] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5449),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3051),
    [sym_block_comment] = STATE(3051),
    [sym_line_comment] = STATE(3051),
    [sym_compiler_directive_decl] = STATE(3051),
    [sym_fsi_directive_decl] = STATE(3051),
    [sym_preproc_line] = STATE(3051),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3052] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5651),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3052),
    [sym_block_comment] = STATE(3052),
    [sym_line_comment] = STATE(3052),
    [sym_compiler_directive_decl] = STATE(3052),
    [sym_fsi_directive_decl] = STATE(3052),
    [sym_preproc_line] = STATE(3052),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3053] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4133),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3053),
    [sym_block_comment] = STATE(3053),
    [sym_line_comment] = STATE(3053),
    [sym_compiler_directive_decl] = STATE(3053),
    [sym_fsi_directive_decl] = STATE(3053),
    [sym_preproc_line] = STATE(3053),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3054] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4080),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3054),
    [sym_block_comment] = STATE(3054),
    [sym_line_comment] = STATE(3054),
    [sym_compiler_directive_decl] = STATE(3054),
    [sym_fsi_directive_decl] = STATE(3054),
    [sym_preproc_line] = STATE(3054),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3055] = {
    [sym_xml_doc] = STATE(3055),
    [sym_block_comment] = STATE(3055),
    [sym_line_comment] = STATE(3055),
    [sym_compiler_directive_decl] = STATE(3055),
    [sym_fsi_directive_decl] = STATE(3055),
    [sym_preproc_line] = STATE(3055),
    [ts_builtin_sym_end] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5438),
    [anon_sym_namespace] = ACTIONS(5438),
    [anon_sym_module] = ACTIONS(5438),
    [anon_sym_open] = ACTIONS(5438),
    [anon_sym_LBRACK_LT] = ACTIONS(5436),
    [anon_sym_return] = ACTIONS(5438),
    [anon_sym_type] = ACTIONS(5438),
    [anon_sym_do] = ACTIONS(5438),
    [anon_sym_and] = ACTIONS(5438),
    [anon_sym_let] = ACTIONS(5438),
    [anon_sym_let_BANG] = ACTIONS(5436),
    [aux_sym_access_modifier_token1] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5438),
    [anon_sym_null] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_LBRACK] = ACTIONS(5438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5438),
    [anon_sym_LT_AT] = ACTIONS(5438),
    [anon_sym_LT_AT_AT] = ACTIONS(5436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5436),
    [anon_sym_new] = ACTIONS(5438),
    [anon_sym_return_BANG] = ACTIONS(5436),
    [anon_sym_yield] = ACTIONS(5438),
    [anon_sym_yield_BANG] = ACTIONS(5436),
    [anon_sym_lazy] = ACTIONS(5438),
    [anon_sym_assert] = ACTIONS(5438),
    [anon_sym_upcast] = ACTIONS(5438),
    [anon_sym_downcast] = ACTIONS(5438),
    [anon_sym_for] = ACTIONS(5438),
    [anon_sym_while] = ACTIONS(5438),
    [anon_sym_if] = ACTIONS(5438),
    [anon_sym_fun] = ACTIONS(5438),
    [anon_sym_try] = ACTIONS(5438),
    [anon_sym_match] = ACTIONS(5438),
    [anon_sym_match_BANG] = ACTIONS(5436),
    [anon_sym_function] = ACTIONS(5438),
    [anon_sym_use] = ACTIONS(5438),
    [anon_sym_use_BANG] = ACTIONS(5436),
    [anon_sym_do_BANG] = ACTIONS(5436),
    [anon_sym_begin] = ACTIONS(5438),
    [anon_sym_default] = ACTIONS(5438),
    [anon_sym_static] = ACTIONS(5438),
    [anon_sym_member] = ACTIONS(5438),
    [anon_sym_abstract] = ACTIONS(5438),
    [anon_sym_override] = ACTIONS(5438),
    [anon_sym_val] = ACTIONS(5438),
    [aux_sym_char_token1] = ACTIONS(5436),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5438),
    [anon_sym_DQUOTE] = ACTIONS(5438),
    [anon_sym_AT_DQUOTE] = ACTIONS(5436),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5436),
    [sym_bool] = ACTIONS(5438),
    [sym_unit] = ACTIONS(5436),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5438),
    [sym_op_identifier] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_PLUS_DOT] = ACTIONS(5436),
    [anon_sym_DASH_DOT] = ACTIONS(5436),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_TILDE] = ACTIONS(5436),
    [aux_sym_prefix_op_token1] = ACTIONS(5436),
    [sym_int] = ACTIONS(5438),
    [sym_xint] = ACTIONS(5436),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5436),
    [anon_sym_POUNDload] = ACTIONS(5436),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5436),
  },
  [3056] = {
    [sym_xml_doc] = STATE(3056),
    [sym_block_comment] = STATE(3056),
    [sym_line_comment] = STATE(3056),
    [sym_compiler_directive_decl] = STATE(3056),
    [sym_fsi_directive_decl] = STATE(3056),
    [sym_preproc_line] = STATE(3056),
    [ts_builtin_sym_end] = ACTIONS(5440),
    [sym_identifier] = ACTIONS(5442),
    [anon_sym_namespace] = ACTIONS(5442),
    [anon_sym_module] = ACTIONS(5442),
    [anon_sym_open] = ACTIONS(5442),
    [anon_sym_LBRACK_LT] = ACTIONS(5440),
    [anon_sym_return] = ACTIONS(5442),
    [anon_sym_type] = ACTIONS(5442),
    [anon_sym_do] = ACTIONS(5442),
    [anon_sym_and] = ACTIONS(5442),
    [anon_sym_let] = ACTIONS(5442),
    [anon_sym_let_BANG] = ACTIONS(5440),
    [aux_sym_access_modifier_token1] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5442),
    [anon_sym_null] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LBRACK] = ACTIONS(5442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(5442),
    [anon_sym_LT_AT] = ACTIONS(5442),
    [anon_sym_LT_AT_AT] = ACTIONS(5440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5440),
    [anon_sym_new] = ACTIONS(5442),
    [anon_sym_return_BANG] = ACTIONS(5440),
    [anon_sym_yield] = ACTIONS(5442),
    [anon_sym_yield_BANG] = ACTIONS(5440),
    [anon_sym_lazy] = ACTIONS(5442),
    [anon_sym_assert] = ACTIONS(5442),
    [anon_sym_upcast] = ACTIONS(5442),
    [anon_sym_downcast] = ACTIONS(5442),
    [anon_sym_for] = ACTIONS(5442),
    [anon_sym_while] = ACTIONS(5442),
    [anon_sym_if] = ACTIONS(5442),
    [anon_sym_fun] = ACTIONS(5442),
    [anon_sym_try] = ACTIONS(5442),
    [anon_sym_match] = ACTIONS(5442),
    [anon_sym_match_BANG] = ACTIONS(5440),
    [anon_sym_function] = ACTIONS(5442),
    [anon_sym_use] = ACTIONS(5442),
    [anon_sym_use_BANG] = ACTIONS(5440),
    [anon_sym_do_BANG] = ACTIONS(5440),
    [anon_sym_begin] = ACTIONS(5442),
    [anon_sym_default] = ACTIONS(5442),
    [anon_sym_static] = ACTIONS(5442),
    [anon_sym_member] = ACTIONS(5442),
    [anon_sym_abstract] = ACTIONS(5442),
    [anon_sym_override] = ACTIONS(5442),
    [anon_sym_val] = ACTIONS(5442),
    [aux_sym_char_token1] = ACTIONS(5440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5442),
    [anon_sym_DQUOTE] = ACTIONS(5442),
    [anon_sym_AT_DQUOTE] = ACTIONS(5440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5440),
    [sym_bool] = ACTIONS(5442),
    [sym_unit] = ACTIONS(5440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5442),
    [sym_op_identifier] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS_DOT] = ACTIONS(5440),
    [anon_sym_DASH_DOT] = ACTIONS(5440),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_TILDE] = ACTIONS(5440),
    [aux_sym_prefix_op_token1] = ACTIONS(5440),
    [sym_int] = ACTIONS(5442),
    [sym_xint] = ACTIONS(5440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5440),
    [anon_sym_POUNDload] = ACTIONS(5440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5440),
  },
  [3057] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5416),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3057),
    [sym_block_comment] = STATE(3057),
    [sym_line_comment] = STATE(3057),
    [sym_compiler_directive_decl] = STATE(3057),
    [sym_fsi_directive_decl] = STATE(3057),
    [sym_preproc_line] = STATE(3057),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3058] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4131),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3058),
    [sym_block_comment] = STATE(3058),
    [sym_line_comment] = STATE(3058),
    [sym_compiler_directive_decl] = STATE(3058),
    [sym_fsi_directive_decl] = STATE(3058),
    [sym_preproc_line] = STATE(3058),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3059] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5876),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3059),
    [sym_block_comment] = STATE(3059),
    [sym_line_comment] = STATE(3059),
    [sym_compiler_directive_decl] = STATE(3059),
    [sym_fsi_directive_decl] = STATE(3059),
    [sym_preproc_line] = STATE(3059),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5444),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3060] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5882),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3060),
    [sym_block_comment] = STATE(3060),
    [sym_line_comment] = STATE(3060),
    [sym_compiler_directive_decl] = STATE(3060),
    [sym_fsi_directive_decl] = STATE(3060),
    [sym_preproc_line] = STATE(3060),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5446),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3061] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5871),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3061),
    [sym_block_comment] = STATE(3061),
    [sym_line_comment] = STATE(3061),
    [sym_compiler_directive_decl] = STATE(3061),
    [sym_fsi_directive_decl] = STATE(3061),
    [sym_preproc_line] = STATE(3061),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5448),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3062] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5864),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3062),
    [sym_block_comment] = STATE(3062),
    [sym_line_comment] = STATE(3062),
    [sym_compiler_directive_decl] = STATE(3062),
    [sym_fsi_directive_decl] = STATE(3062),
    [sym_preproc_line] = STATE(3062),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3063] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4082),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3063),
    [sym_block_comment] = STATE(3063),
    [sym_line_comment] = STATE(3063),
    [sym_compiler_directive_decl] = STATE(3063),
    [sym_fsi_directive_decl] = STATE(3063),
    [sym_preproc_line] = STATE(3063),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3064] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5630),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3064),
    [sym_block_comment] = STATE(3064),
    [sym_line_comment] = STATE(3064),
    [sym_compiler_directive_decl] = STATE(3064),
    [sym_fsi_directive_decl] = STATE(3064),
    [sym_preproc_line] = STATE(3064),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3065] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5582),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3065),
    [sym_block_comment] = STATE(3065),
    [sym_line_comment] = STATE(3065),
    [sym_compiler_directive_decl] = STATE(3065),
    [sym_fsi_directive_decl] = STATE(3065),
    [sym_preproc_line] = STATE(3065),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3066] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5834),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3066),
    [sym_block_comment] = STATE(3066),
    [sym_line_comment] = STATE(3066),
    [sym_compiler_directive_decl] = STATE(3066),
    [sym_fsi_directive_decl] = STATE(3066),
    [sym_preproc_line] = STATE(3066),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3067] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5631),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3067),
    [sym_block_comment] = STATE(3067),
    [sym_line_comment] = STATE(3067),
    [sym_compiler_directive_decl] = STATE(3067),
    [sym_fsi_directive_decl] = STATE(3067),
    [sym_preproc_line] = STATE(3067),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3068] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5684),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3068),
    [sym_block_comment] = STATE(3068),
    [sym_line_comment] = STATE(3068),
    [sym_compiler_directive_decl] = STATE(3068),
    [sym_fsi_directive_decl] = STATE(3068),
    [sym_preproc_line] = STATE(3068),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3069] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5635),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3069),
    [sym_block_comment] = STATE(3069),
    [sym_line_comment] = STATE(3069),
    [sym_compiler_directive_decl] = STATE(3069),
    [sym_fsi_directive_decl] = STATE(3069),
    [sym_preproc_line] = STATE(3069),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3070] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5831),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3070),
    [sym_block_comment] = STATE(3070),
    [sym_line_comment] = STATE(3070),
    [sym_compiler_directive_decl] = STATE(3070),
    [sym_fsi_directive_decl] = STATE(3070),
    [sym_preproc_line] = STATE(3070),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3071] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4085),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3071),
    [sym_block_comment] = STATE(3071),
    [sym_line_comment] = STATE(3071),
    [sym_compiler_directive_decl] = STATE(3071),
    [sym_fsi_directive_decl] = STATE(3071),
    [sym_preproc_line] = STATE(3071),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3072] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4071),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3072),
    [sym_block_comment] = STATE(3072),
    [sym_line_comment] = STATE(3072),
    [sym_compiler_directive_decl] = STATE(3072),
    [sym_fsi_directive_decl] = STATE(3072),
    [sym_preproc_line] = STATE(3072),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3073] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5520),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3073),
    [sym_block_comment] = STATE(3073),
    [sym_line_comment] = STATE(3073),
    [sym_compiler_directive_decl] = STATE(3073),
    [sym_fsi_directive_decl] = STATE(3073),
    [sym_preproc_line] = STATE(3073),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3074] = {
    [sym_attributes] = STATE(3048),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4135),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2236),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3074),
    [sym_block_comment] = STATE(3074),
    [sym_line_comment] = STATE(3074),
    [sym_compiler_directive_decl] = STATE(3074),
    [sym_fsi_directive_decl] = STATE(3074),
    [sym_preproc_line] = STATE(3074),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3075] = {
    [sym_xml_doc] = STATE(3075),
    [sym_block_comment] = STATE(3075),
    [sym_line_comment] = STATE(3075),
    [sym_compiler_directive_decl] = STATE(3075),
    [sym_fsi_directive_decl] = STATE(3075),
    [sym_preproc_line] = STATE(3075),
    [ts_builtin_sym_end] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5454),
    [anon_sym_namespace] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5454),
    [anon_sym_open] = ACTIONS(5454),
    [anon_sym_LBRACK_LT] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5454),
    [anon_sym_type] = ACTIONS(5454),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_let] = ACTIONS(5454),
    [anon_sym_let_BANG] = ACTIONS(5452),
    [aux_sym_access_modifier_token1] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5454),
    [anon_sym_null] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_LT_AT] = ACTIONS(5454),
    [anon_sym_LT_AT_AT] = ACTIONS(5452),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5452),
    [anon_sym_new] = ACTIONS(5454),
    [anon_sym_return_BANG] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5454),
    [anon_sym_yield_BANG] = ACTIONS(5452),
    [anon_sym_lazy] = ACTIONS(5454),
    [anon_sym_assert] = ACTIONS(5454),
    [anon_sym_upcast] = ACTIONS(5454),
    [anon_sym_downcast] = ACTIONS(5454),
    [anon_sym_for] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_fun] = ACTIONS(5454),
    [anon_sym_try] = ACTIONS(5454),
    [anon_sym_match] = ACTIONS(5454),
    [anon_sym_match_BANG] = ACTIONS(5452),
    [anon_sym_function] = ACTIONS(5454),
    [anon_sym_use] = ACTIONS(5454),
    [anon_sym_use_BANG] = ACTIONS(5452),
    [anon_sym_do_BANG] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5454),
    [anon_sym_default] = ACTIONS(5454),
    [anon_sym_static] = ACTIONS(5454),
    [anon_sym_member] = ACTIONS(5454),
    [anon_sym_abstract] = ACTIONS(5454),
    [anon_sym_override] = ACTIONS(5454),
    [anon_sym_val] = ACTIONS(5454),
    [aux_sym_char_token1] = ACTIONS(5452),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5454),
    [anon_sym_DQUOTE] = ACTIONS(5454),
    [anon_sym_AT_DQUOTE] = ACTIONS(5452),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5452),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5452),
    [sym_bool] = ACTIONS(5454),
    [sym_unit] = ACTIONS(5452),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5454),
    [sym_op_identifier] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_PLUS_DOT] = ACTIONS(5452),
    [anon_sym_DASH_DOT] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(5452),
    [aux_sym_prefix_op_token1] = ACTIONS(5452),
    [sym_int] = ACTIONS(5454),
    [sym_xint] = ACTIONS(5452),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5452),
    [anon_sym_POUNDload] = ACTIONS(5452),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5452),
  },
  [3076] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5828),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3076),
    [sym_block_comment] = STATE(3076),
    [sym_line_comment] = STATE(3076),
    [sym_compiler_directive_decl] = STATE(3076),
    [sym_fsi_directive_decl] = STATE(3076),
    [sym_preproc_line] = STATE(3076),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3077] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5855),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3077),
    [sym_block_comment] = STATE(3077),
    [sym_line_comment] = STATE(3077),
    [sym_compiler_directive_decl] = STATE(3077),
    [sym_fsi_directive_decl] = STATE(3077),
    [sym_preproc_line] = STATE(3077),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5456),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3078] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5636),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3078),
    [sym_block_comment] = STATE(3078),
    [sym_line_comment] = STATE(3078),
    [sym_compiler_directive_decl] = STATE(3078),
    [sym_fsi_directive_decl] = STATE(3078),
    [sym_preproc_line] = STATE(3078),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3079] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5549),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3079),
    [sym_block_comment] = STATE(3079),
    [sym_line_comment] = STATE(3079),
    [sym_compiler_directive_decl] = STATE(3079),
    [sym_fsi_directive_decl] = STATE(3079),
    [sym_preproc_line] = STATE(3079),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3080] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5796),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3080),
    [sym_block_comment] = STATE(3080),
    [sym_line_comment] = STATE(3080),
    [sym_compiler_directive_decl] = STATE(3080),
    [sym_fsi_directive_decl] = STATE(3080),
    [sym_preproc_line] = STATE(3080),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3081] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5853),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3081),
    [sym_block_comment] = STATE(3081),
    [sym_line_comment] = STATE(3081),
    [sym_compiler_directive_decl] = STATE(3081),
    [sym_fsi_directive_decl] = STATE(3081),
    [sym_preproc_line] = STATE(3081),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3082] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5505),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3082),
    [sym_block_comment] = STATE(3082),
    [sym_line_comment] = STATE(3082),
    [sym_compiler_directive_decl] = STATE(3082),
    [sym_fsi_directive_decl] = STATE(3082),
    [sym_preproc_line] = STATE(3082),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3083] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5848),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3083),
    [sym_block_comment] = STATE(3083),
    [sym_line_comment] = STATE(3083),
    [sym_compiler_directive_decl] = STATE(3083),
    [sym_fsi_directive_decl] = STATE(3083),
    [sym_preproc_line] = STATE(3083),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3084] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3813),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3084),
    [sym_block_comment] = STATE(3084),
    [sym_line_comment] = STATE(3084),
    [sym_compiler_directive_decl] = STATE(3084),
    [sym_fsi_directive_decl] = STATE(3084),
    [sym_preproc_line] = STATE(3084),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3085] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3809),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3085),
    [sym_block_comment] = STATE(3085),
    [sym_line_comment] = STATE(3085),
    [sym_compiler_directive_decl] = STATE(3085),
    [sym_fsi_directive_decl] = STATE(3085),
    [sym_preproc_line] = STATE(3085),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3086] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5825),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3086),
    [sym_block_comment] = STATE(3086),
    [sym_line_comment] = STATE(3086),
    [sym_compiler_directive_decl] = STATE(3086),
    [sym_fsi_directive_decl] = STATE(3086),
    [sym_preproc_line] = STATE(3086),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3087] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5427),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3087),
    [sym_block_comment] = STATE(3087),
    [sym_line_comment] = STATE(3087),
    [sym_compiler_directive_decl] = STATE(3087),
    [sym_fsi_directive_decl] = STATE(3087),
    [sym_preproc_line] = STATE(3087),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3088] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4088),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3088),
    [sym_block_comment] = STATE(3088),
    [sym_line_comment] = STATE(3088),
    [sym_compiler_directive_decl] = STATE(3088),
    [sym_fsi_directive_decl] = STATE(3088),
    [sym_preproc_line] = STATE(3088),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3089] = {
    [sym_xml_doc] = STATE(3089),
    [sym_block_comment] = STATE(3089),
    [sym_line_comment] = STATE(3089),
    [sym_compiler_directive_decl] = STATE(3089),
    [sym_fsi_directive_decl] = STATE(3089),
    [sym_preproc_line] = STATE(3089),
    [ts_builtin_sym_end] = ACTIONS(5462),
    [sym_identifier] = ACTIONS(5464),
    [anon_sym_namespace] = ACTIONS(5464),
    [anon_sym_module] = ACTIONS(5464),
    [anon_sym_open] = ACTIONS(5464),
    [anon_sym_LBRACK_LT] = ACTIONS(5462),
    [anon_sym_return] = ACTIONS(5464),
    [anon_sym_type] = ACTIONS(5464),
    [anon_sym_do] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_let_BANG] = ACTIONS(5462),
    [aux_sym_access_modifier_token1] = ACTIONS(5462),
    [anon_sym_LPAREN] = ACTIONS(5464),
    [anon_sym_null] = ACTIONS(5464),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5462),
    [anon_sym_LBRACE] = ACTIONS(5464),
    [anon_sym_LT_AT] = ACTIONS(5464),
    [anon_sym_LT_AT_AT] = ACTIONS(5462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5462),
    [anon_sym_new] = ACTIONS(5464),
    [anon_sym_return_BANG] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(5464),
    [anon_sym_yield_BANG] = ACTIONS(5462),
    [anon_sym_lazy] = ACTIONS(5464),
    [anon_sym_assert] = ACTIONS(5464),
    [anon_sym_upcast] = ACTIONS(5464),
    [anon_sym_downcast] = ACTIONS(5464),
    [anon_sym_for] = ACTIONS(5464),
    [anon_sym_while] = ACTIONS(5464),
    [anon_sym_if] = ACTIONS(5464),
    [anon_sym_fun] = ACTIONS(5464),
    [anon_sym_try] = ACTIONS(5464),
    [anon_sym_match] = ACTIONS(5464),
    [anon_sym_match_BANG] = ACTIONS(5462),
    [anon_sym_function] = ACTIONS(5464),
    [anon_sym_use] = ACTIONS(5464),
    [anon_sym_use_BANG] = ACTIONS(5462),
    [anon_sym_do_BANG] = ACTIONS(5462),
    [anon_sym_begin] = ACTIONS(5464),
    [anon_sym_default] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_member] = ACTIONS(5464),
    [anon_sym_abstract] = ACTIONS(5464),
    [anon_sym_override] = ACTIONS(5464),
    [anon_sym_val] = ACTIONS(5464),
    [aux_sym_char_token1] = ACTIONS(5462),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(5464),
    [anon_sym_AT_DQUOTE] = ACTIONS(5462),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5462),
    [sym_bool] = ACTIONS(5464),
    [sym_unit] = ACTIONS(5462),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5464),
    [sym_op_identifier] = ACTIONS(5462),
    [anon_sym_PLUS] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5464),
    [anon_sym_PLUS_DOT] = ACTIONS(5462),
    [anon_sym_DASH_DOT] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [aux_sym_prefix_op_token1] = ACTIONS(5462),
    [sym_int] = ACTIONS(5464),
    [sym_xint] = ACTIONS(5462),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5462),
    [anon_sym_POUNDload] = ACTIONS(5462),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5462),
  },
  [3090] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5830),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3090),
    [sym_block_comment] = STATE(3090),
    [sym_line_comment] = STATE(3090),
    [sym_compiler_directive_decl] = STATE(3090),
    [sym_fsi_directive_decl] = STATE(3090),
    [sym_preproc_line] = STATE(3090),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3091] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5528),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3091),
    [sym_block_comment] = STATE(3091),
    [sym_line_comment] = STATE(3091),
    [sym_compiler_directive_decl] = STATE(3091),
    [sym_fsi_directive_decl] = STATE(3091),
    [sym_preproc_line] = STATE(3091),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3092] = {
    [sym_xml_doc] = STATE(3092),
    [sym_block_comment] = STATE(3092),
    [sym_line_comment] = STATE(3092),
    [sym_compiler_directive_decl] = STATE(3092),
    [sym_fsi_directive_decl] = STATE(3092),
    [sym_preproc_line] = STATE(3092),
    [ts_builtin_sym_end] = ACTIONS(5466),
    [sym_identifier] = ACTIONS(5468),
    [anon_sym_namespace] = ACTIONS(5468),
    [anon_sym_module] = ACTIONS(5468),
    [anon_sym_open] = ACTIONS(5468),
    [anon_sym_LBRACK_LT] = ACTIONS(5466),
    [anon_sym_return] = ACTIONS(5468),
    [anon_sym_type] = ACTIONS(5468),
    [anon_sym_do] = ACTIONS(5468),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_let] = ACTIONS(5468),
    [anon_sym_let_BANG] = ACTIONS(5466),
    [aux_sym_access_modifier_token1] = ACTIONS(5466),
    [anon_sym_LPAREN] = ACTIONS(5468),
    [anon_sym_null] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5466),
    [anon_sym_LBRACE] = ACTIONS(5468),
    [anon_sym_LT_AT] = ACTIONS(5468),
    [anon_sym_LT_AT_AT] = ACTIONS(5466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5466),
    [anon_sym_new] = ACTIONS(5468),
    [anon_sym_return_BANG] = ACTIONS(5466),
    [anon_sym_yield] = ACTIONS(5468),
    [anon_sym_yield_BANG] = ACTIONS(5466),
    [anon_sym_lazy] = ACTIONS(5468),
    [anon_sym_assert] = ACTIONS(5468),
    [anon_sym_upcast] = ACTIONS(5468),
    [anon_sym_downcast] = ACTIONS(5468),
    [anon_sym_for] = ACTIONS(5468),
    [anon_sym_while] = ACTIONS(5468),
    [anon_sym_if] = ACTIONS(5468),
    [anon_sym_fun] = ACTIONS(5468),
    [anon_sym_try] = ACTIONS(5468),
    [anon_sym_match] = ACTIONS(5468),
    [anon_sym_match_BANG] = ACTIONS(5466),
    [anon_sym_function] = ACTIONS(5468),
    [anon_sym_use] = ACTIONS(5468),
    [anon_sym_use_BANG] = ACTIONS(5466),
    [anon_sym_do_BANG] = ACTIONS(5466),
    [anon_sym_begin] = ACTIONS(5468),
    [anon_sym_default] = ACTIONS(5468),
    [anon_sym_static] = ACTIONS(5468),
    [anon_sym_member] = ACTIONS(5468),
    [anon_sym_abstract] = ACTIONS(5468),
    [anon_sym_override] = ACTIONS(5468),
    [anon_sym_val] = ACTIONS(5468),
    [aux_sym_char_token1] = ACTIONS(5466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5468),
    [anon_sym_DQUOTE] = ACTIONS(5468),
    [anon_sym_AT_DQUOTE] = ACTIONS(5466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5466),
    [sym_bool] = ACTIONS(5468),
    [sym_unit] = ACTIONS(5466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5468),
    [sym_op_identifier] = ACTIONS(5466),
    [anon_sym_PLUS] = ACTIONS(5468),
    [anon_sym_DASH] = ACTIONS(5468),
    [anon_sym_PLUS_DOT] = ACTIONS(5466),
    [anon_sym_DASH_DOT] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [aux_sym_prefix_op_token1] = ACTIONS(5466),
    [sym_int] = ACTIONS(5468),
    [sym_xint] = ACTIONS(5466),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5466),
    [anon_sym_POUNDload] = ACTIONS(5466),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5466),
  },
  [3093] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5523),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3093),
    [sym_block_comment] = STATE(3093),
    [sym_line_comment] = STATE(3093),
    [sym_compiler_directive_decl] = STATE(3093),
    [sym_fsi_directive_decl] = STATE(3093),
    [sym_preproc_line] = STATE(3093),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3094] = {
    [sym_xml_doc] = STATE(3094),
    [sym_block_comment] = STATE(3094),
    [sym_line_comment] = STATE(3094),
    [sym_compiler_directive_decl] = STATE(3094),
    [sym_fsi_directive_decl] = STATE(3094),
    [sym_preproc_line] = STATE(3094),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [sym_identifier] = ACTIONS(5075),
    [anon_sym_namespace] = ACTIONS(5075),
    [anon_sym_module] = ACTIONS(5075),
    [anon_sym_open] = ACTIONS(5075),
    [anon_sym_LBRACK_LT] = ACTIONS(5073),
    [anon_sym_return] = ACTIONS(5075),
    [anon_sym_type] = ACTIONS(5075),
    [anon_sym_do] = ACTIONS(5075),
    [anon_sym_and] = ACTIONS(5075),
    [anon_sym_let] = ACTIONS(5075),
    [anon_sym_let_BANG] = ACTIONS(5073),
    [aux_sym_access_modifier_token1] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5075),
    [anon_sym_null] = ACTIONS(5075),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5073),
    [anon_sym_LBRACE] = ACTIONS(5075),
    [anon_sym_LT_AT] = ACTIONS(5075),
    [anon_sym_LT_AT_AT] = ACTIONS(5073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5073),
    [anon_sym_new] = ACTIONS(5075),
    [anon_sym_return_BANG] = ACTIONS(5073),
    [anon_sym_yield] = ACTIONS(5075),
    [anon_sym_yield_BANG] = ACTIONS(5073),
    [anon_sym_lazy] = ACTIONS(5075),
    [anon_sym_assert] = ACTIONS(5075),
    [anon_sym_upcast] = ACTIONS(5075),
    [anon_sym_downcast] = ACTIONS(5075),
    [anon_sym_for] = ACTIONS(5075),
    [anon_sym_while] = ACTIONS(5075),
    [anon_sym_if] = ACTIONS(5075),
    [anon_sym_fun] = ACTIONS(5075),
    [anon_sym_try] = ACTIONS(5075),
    [anon_sym_match] = ACTIONS(5075),
    [anon_sym_match_BANG] = ACTIONS(5073),
    [anon_sym_function] = ACTIONS(5075),
    [anon_sym_use] = ACTIONS(5075),
    [anon_sym_use_BANG] = ACTIONS(5073),
    [anon_sym_do_BANG] = ACTIONS(5073),
    [anon_sym_begin] = ACTIONS(5075),
    [anon_sym_default] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_member] = ACTIONS(5075),
    [anon_sym_abstract] = ACTIONS(5075),
    [anon_sym_override] = ACTIONS(5075),
    [anon_sym_val] = ACTIONS(5075),
    [aux_sym_char_token1] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_AT_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [sym_bool] = ACTIONS(5075),
    [sym_unit] = ACTIONS(5073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5075),
    [sym_op_identifier] = ACTIONS(5073),
    [anon_sym_PLUS] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_PLUS_DOT] = ACTIONS(5073),
    [anon_sym_DASH_DOT] = ACTIONS(5073),
    [anon_sym_PERCENT] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [aux_sym_prefix_op_token1] = ACTIONS(5073),
    [sym_int] = ACTIONS(5075),
    [sym_xint] = ACTIONS(5073),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5073),
    [anon_sym_POUNDload] = ACTIONS(5073),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5073),
  },
  [3095] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5845),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3095),
    [sym_block_comment] = STATE(3095),
    [sym_line_comment] = STATE(3095),
    [sym_compiler_directive_decl] = STATE(3095),
    [sym_fsi_directive_decl] = STATE(3095),
    [sym_preproc_line] = STATE(3095),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3096] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5843),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3096),
    [sym_block_comment] = STATE(3096),
    [sym_line_comment] = STATE(3096),
    [sym_compiler_directive_decl] = STATE(3096),
    [sym_fsi_directive_decl] = STATE(3096),
    [sym_preproc_line] = STATE(3096),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5472),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3097] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5842),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3097),
    [sym_block_comment] = STATE(3097),
    [sym_line_comment] = STATE(3097),
    [sym_compiler_directive_decl] = STATE(3097),
    [sym_fsi_directive_decl] = STATE(3097),
    [sym_preproc_line] = STATE(3097),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3098] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5521),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3098),
    [sym_block_comment] = STATE(3098),
    [sym_line_comment] = STATE(3098),
    [sym_compiler_directive_decl] = STATE(3098),
    [sym_fsi_directive_decl] = STATE(3098),
    [sym_preproc_line] = STATE(3098),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3099] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5865),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3099),
    [sym_block_comment] = STATE(3099),
    [sym_line_comment] = STATE(3099),
    [sym_compiler_directive_decl] = STATE(3099),
    [sym_fsi_directive_decl] = STATE(3099),
    [sym_preproc_line] = STATE(3099),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3100] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3819),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3100),
    [sym_block_comment] = STATE(3100),
    [sym_line_comment] = STATE(3100),
    [sym_compiler_directive_decl] = STATE(3100),
    [sym_fsi_directive_decl] = STATE(3100),
    [sym_preproc_line] = STATE(3100),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3101] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3834),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3101),
    [sym_block_comment] = STATE(3101),
    [sym_line_comment] = STATE(3101),
    [sym_compiler_directive_decl] = STATE(3101),
    [sym_fsi_directive_decl] = STATE(3101),
    [sym_preproc_line] = STATE(3101),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3102] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5818),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3102),
    [sym_block_comment] = STATE(3102),
    [sym_line_comment] = STATE(3102),
    [sym_compiler_directive_decl] = STATE(3102),
    [sym_fsi_directive_decl] = STATE(3102),
    [sym_preproc_line] = STATE(3102),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3103] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3816),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3103),
    [sym_block_comment] = STATE(3103),
    [sym_line_comment] = STATE(3103),
    [sym_compiler_directive_decl] = STATE(3103),
    [sym_fsi_directive_decl] = STATE(3103),
    [sym_preproc_line] = STATE(3103),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3104] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5872),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3104),
    [sym_block_comment] = STATE(3104),
    [sym_line_comment] = STATE(3104),
    [sym_compiler_directive_decl] = STATE(3104),
    [sym_fsi_directive_decl] = STATE(3104),
    [sym_preproc_line] = STATE(3104),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5474),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3105] = {
    [sym_attributes] = STATE(3103),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3815),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2147),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3105),
    [sym_block_comment] = STATE(3105),
    [sym_line_comment] = STATE(3105),
    [sym_compiler_directive_decl] = STATE(3105),
    [sym_fsi_directive_decl] = STATE(3105),
    [sym_preproc_line] = STATE(3105),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3106] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4075),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3106),
    [sym_block_comment] = STATE(3106),
    [sym_line_comment] = STATE(3106),
    [sym_compiler_directive_decl] = STATE(3106),
    [sym_fsi_directive_decl] = STATE(3106),
    [sym_preproc_line] = STATE(3106),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3107] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5837),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3107),
    [sym_block_comment] = STATE(3107),
    [sym_line_comment] = STATE(3107),
    [sym_compiler_directive_decl] = STATE(3107),
    [sym_fsi_directive_decl] = STATE(3107),
    [sym_preproc_line] = STATE(3107),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5476),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3108] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5553),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3108),
    [sym_block_comment] = STATE(3108),
    [sym_line_comment] = STATE(3108),
    [sym_compiler_directive_decl] = STATE(3108),
    [sym_fsi_directive_decl] = STATE(3108),
    [sym_preproc_line] = STATE(3108),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3109] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5567),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3109),
    [sym_block_comment] = STATE(3109),
    [sym_line_comment] = STATE(3109),
    [sym_compiler_directive_decl] = STATE(3109),
    [sym_fsi_directive_decl] = STATE(3109),
    [sym_preproc_line] = STATE(3109),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3110] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5566),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3110),
    [sym_block_comment] = STATE(3110),
    [sym_line_comment] = STATE(3110),
    [sym_compiler_directive_decl] = STATE(3110),
    [sym_fsi_directive_decl] = STATE(3110),
    [sym_preproc_line] = STATE(3110),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3111] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5565),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3111),
    [sym_block_comment] = STATE(3111),
    [sym_line_comment] = STATE(3111),
    [sym_compiler_directive_decl] = STATE(3111),
    [sym_fsi_directive_decl] = STATE(3111),
    [sym_preproc_line] = STATE(3111),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3112] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5564),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3112),
    [sym_block_comment] = STATE(3112),
    [sym_line_comment] = STATE(3112),
    [sym_compiler_directive_decl] = STATE(3112),
    [sym_fsi_directive_decl] = STATE(3112),
    [sym_preproc_line] = STATE(3112),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3113] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5835),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3113),
    [sym_block_comment] = STATE(3113),
    [sym_line_comment] = STATE(3113),
    [sym_compiler_directive_decl] = STATE(3113),
    [sym_fsi_directive_decl] = STATE(3113),
    [sym_preproc_line] = STATE(3113),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3114] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5861),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3114),
    [sym_block_comment] = STATE(3114),
    [sym_line_comment] = STATE(3114),
    [sym_compiler_directive_decl] = STATE(3114),
    [sym_fsi_directive_decl] = STATE(3114),
    [sym_preproc_line] = STATE(3114),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3115] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5879),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3115),
    [sym_block_comment] = STATE(3115),
    [sym_line_comment] = STATE(3115),
    [sym_compiler_directive_decl] = STATE(3115),
    [sym_fsi_directive_decl] = STATE(3115),
    [sym_preproc_line] = STATE(3115),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3116] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5462),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3116),
    [sym_block_comment] = STATE(3116),
    [sym_line_comment] = STATE(3116),
    [sym_compiler_directive_decl] = STATE(3116),
    [sym_fsi_directive_decl] = STATE(3116),
    [sym_preproc_line] = STATE(3116),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3117] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5406),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3117),
    [sym_block_comment] = STATE(3117),
    [sym_line_comment] = STATE(3117),
    [sym_compiler_directive_decl] = STATE(3117),
    [sym_fsi_directive_decl] = STATE(3117),
    [sym_preproc_line] = STATE(3117),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3118] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5488),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3118),
    [sym_block_comment] = STATE(3118),
    [sym_line_comment] = STATE(3118),
    [sym_compiler_directive_decl] = STATE(3118),
    [sym_fsi_directive_decl] = STATE(3118),
    [sym_preproc_line] = STATE(3118),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3119] = {
    [sym_attributes] = STATE(3108),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5509),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2005),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3119),
    [sym_block_comment] = STATE(3119),
    [sym_line_comment] = STATE(3119),
    [sym_compiler_directive_decl] = STATE(3119),
    [sym_fsi_directive_decl] = STATE(3119),
    [sym_preproc_line] = STATE(3119),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4738),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4740),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3120] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5809),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3120),
    [sym_block_comment] = STATE(3120),
    [sym_line_comment] = STATE(3120),
    [sym_compiler_directive_decl] = STATE(3120),
    [sym_fsi_directive_decl] = STATE(3120),
    [sym_preproc_line] = STATE(3120),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3121] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5854),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3121),
    [sym_block_comment] = STATE(3121),
    [sym_line_comment] = STATE(3121),
    [sym_compiler_directive_decl] = STATE(3121),
    [sym_fsi_directive_decl] = STATE(3121),
    [sym_preproc_line] = STATE(3121),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3122] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5813),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3122),
    [sym_block_comment] = STATE(3122),
    [sym_line_comment] = STATE(3122),
    [sym_compiler_directive_decl] = STATE(3122),
    [sym_fsi_directive_decl] = STATE(3122),
    [sym_preproc_line] = STATE(3122),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3123] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5724),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3123),
    [sym_block_comment] = STATE(3123),
    [sym_line_comment] = STATE(3123),
    [sym_compiler_directive_decl] = STATE(3123),
    [sym_fsi_directive_decl] = STATE(3123),
    [sym_preproc_line] = STATE(3123),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3124] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5536),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3124),
    [sym_block_comment] = STATE(3124),
    [sym_line_comment] = STATE(3124),
    [sym_compiler_directive_decl] = STATE(3124),
    [sym_fsi_directive_decl] = STATE(3124),
    [sym_preproc_line] = STATE(3124),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3125] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5723),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3125),
    [sym_block_comment] = STATE(3125),
    [sym_line_comment] = STATE(3125),
    [sym_compiler_directive_decl] = STATE(3125),
    [sym_fsi_directive_decl] = STATE(3125),
    [sym_preproc_line] = STATE(3125),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3126] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5531),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3126),
    [sym_block_comment] = STATE(3126),
    [sym_line_comment] = STATE(3126),
    [sym_compiler_directive_decl] = STATE(3126),
    [sym_fsi_directive_decl] = STATE(3126),
    [sym_preproc_line] = STATE(3126),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3127] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5874),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3127),
    [sym_block_comment] = STATE(3127),
    [sym_line_comment] = STATE(3127),
    [sym_compiler_directive_decl] = STATE(3127),
    [sym_fsi_directive_decl] = STATE(3127),
    [sym_preproc_line] = STATE(3127),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3128] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5839),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3128),
    [sym_block_comment] = STATE(3128),
    [sym_line_comment] = STATE(3128),
    [sym_compiler_directive_decl] = STATE(3128),
    [sym_fsi_directive_decl] = STATE(3128),
    [sym_preproc_line] = STATE(3128),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3129] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5838),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3129),
    [sym_block_comment] = STATE(3129),
    [sym_line_comment] = STATE(3129),
    [sym_compiler_directive_decl] = STATE(3129),
    [sym_fsi_directive_decl] = STATE(3129),
    [sym_preproc_line] = STATE(3129),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3130] = {
    [sym_xml_doc] = STATE(3130),
    [sym_block_comment] = STATE(3130),
    [sym_line_comment] = STATE(3130),
    [sym_compiler_directive_decl] = STATE(3130),
    [sym_fsi_directive_decl] = STATE(3130),
    [sym_preproc_line] = STATE(3130),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym_identifier] = ACTIONS(5131),
    [anon_sym_namespace] = ACTIONS(5131),
    [anon_sym_module] = ACTIONS(5131),
    [anon_sym_open] = ACTIONS(5131),
    [anon_sym_LBRACK_LT] = ACTIONS(5129),
    [anon_sym_return] = ACTIONS(5131),
    [anon_sym_type] = ACTIONS(5131),
    [anon_sym_do] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5131),
    [anon_sym_let] = ACTIONS(5131),
    [anon_sym_let_BANG] = ACTIONS(5129),
    [aux_sym_access_modifier_token1] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5131),
    [anon_sym_null] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5131),
    [anon_sym_LT_AT] = ACTIONS(5131),
    [anon_sym_LT_AT_AT] = ACTIONS(5129),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5129),
    [anon_sym_new] = ACTIONS(5131),
    [anon_sym_return_BANG] = ACTIONS(5129),
    [anon_sym_yield] = ACTIONS(5131),
    [anon_sym_yield_BANG] = ACTIONS(5129),
    [anon_sym_lazy] = ACTIONS(5131),
    [anon_sym_assert] = ACTIONS(5131),
    [anon_sym_upcast] = ACTIONS(5131),
    [anon_sym_downcast] = ACTIONS(5131),
    [anon_sym_for] = ACTIONS(5131),
    [anon_sym_while] = ACTIONS(5131),
    [anon_sym_if] = ACTIONS(5131),
    [anon_sym_fun] = ACTIONS(5131),
    [anon_sym_try] = ACTIONS(5131),
    [anon_sym_match] = ACTIONS(5131),
    [anon_sym_match_BANG] = ACTIONS(5129),
    [anon_sym_function] = ACTIONS(5131),
    [anon_sym_use] = ACTIONS(5131),
    [anon_sym_use_BANG] = ACTIONS(5129),
    [anon_sym_do_BANG] = ACTIONS(5129),
    [anon_sym_begin] = ACTIONS(5131),
    [anon_sym_default] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_member] = ACTIONS(5131),
    [anon_sym_abstract] = ACTIONS(5131),
    [anon_sym_override] = ACTIONS(5131),
    [anon_sym_val] = ACTIONS(5131),
    [aux_sym_char_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [anon_sym_AT_DQUOTE] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [sym_bool] = ACTIONS(5131),
    [sym_unit] = ACTIONS(5129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5131),
    [sym_op_identifier] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_DOT] = ACTIONS(5129),
    [anon_sym_DASH_DOT] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [aux_sym_prefix_op_token1] = ACTIONS(5129),
    [sym_int] = ACTIONS(5131),
    [sym_xint] = ACTIONS(5129),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5129),
    [anon_sym_POUNDload] = ACTIONS(5129),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5129),
  },
  [3131] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5880),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3131),
    [sym_block_comment] = STATE(3131),
    [sym_line_comment] = STATE(3131),
    [sym_compiler_directive_decl] = STATE(3131),
    [sym_fsi_directive_decl] = STATE(3131),
    [sym_preproc_line] = STATE(3131),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3132] = {
    [sym_xml_doc] = STATE(3132),
    [sym_block_comment] = STATE(3132),
    [sym_line_comment] = STATE(3132),
    [sym_compiler_directive_decl] = STATE(3132),
    [sym_fsi_directive_decl] = STATE(3132),
    [sym_preproc_line] = STATE(3132),
    [ts_builtin_sym_end] = ACTIONS(5478),
    [sym_identifier] = ACTIONS(5480),
    [anon_sym_namespace] = ACTIONS(5480),
    [anon_sym_module] = ACTIONS(5480),
    [anon_sym_open] = ACTIONS(5480),
    [anon_sym_LBRACK_LT] = ACTIONS(5478),
    [anon_sym_return] = ACTIONS(5480),
    [anon_sym_type] = ACTIONS(5480),
    [anon_sym_do] = ACTIONS(5480),
    [anon_sym_and] = ACTIONS(5480),
    [anon_sym_let] = ACTIONS(5480),
    [anon_sym_let_BANG] = ACTIONS(5478),
    [aux_sym_access_modifier_token1] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(5480),
    [anon_sym_null] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5478),
    [anon_sym_LBRACE] = ACTIONS(5480),
    [anon_sym_LT_AT] = ACTIONS(5480),
    [anon_sym_LT_AT_AT] = ACTIONS(5478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5478),
    [anon_sym_new] = ACTIONS(5480),
    [anon_sym_return_BANG] = ACTIONS(5478),
    [anon_sym_yield] = ACTIONS(5480),
    [anon_sym_yield_BANG] = ACTIONS(5478),
    [anon_sym_lazy] = ACTIONS(5480),
    [anon_sym_assert] = ACTIONS(5480),
    [anon_sym_upcast] = ACTIONS(5480),
    [anon_sym_downcast] = ACTIONS(5480),
    [anon_sym_for] = ACTIONS(5480),
    [anon_sym_while] = ACTIONS(5480),
    [anon_sym_if] = ACTIONS(5480),
    [anon_sym_fun] = ACTIONS(5480),
    [anon_sym_try] = ACTIONS(5480),
    [anon_sym_match] = ACTIONS(5480),
    [anon_sym_match_BANG] = ACTIONS(5478),
    [anon_sym_function] = ACTIONS(5480),
    [anon_sym_use] = ACTIONS(5480),
    [anon_sym_use_BANG] = ACTIONS(5478),
    [anon_sym_do_BANG] = ACTIONS(5478),
    [anon_sym_begin] = ACTIONS(5480),
    [anon_sym_default] = ACTIONS(5480),
    [anon_sym_static] = ACTIONS(5480),
    [anon_sym_member] = ACTIONS(5480),
    [anon_sym_abstract] = ACTIONS(5480),
    [anon_sym_override] = ACTIONS(5480),
    [anon_sym_val] = ACTIONS(5480),
    [aux_sym_char_token1] = ACTIONS(5478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(5480),
    [anon_sym_AT_DQUOTE] = ACTIONS(5478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5478),
    [sym_bool] = ACTIONS(5480),
    [sym_unit] = ACTIONS(5478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5480),
    [sym_op_identifier] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_PLUS_DOT] = ACTIONS(5478),
    [anon_sym_DASH_DOT] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(5478),
    [anon_sym_TILDE] = ACTIONS(5478),
    [aux_sym_prefix_op_token1] = ACTIONS(5478),
    [sym_int] = ACTIONS(5480),
    [sym_xint] = ACTIONS(5478),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5478),
    [anon_sym_POUNDload] = ACTIONS(5478),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5478),
  },
  [3133] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5581),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3133),
    [sym_block_comment] = STATE(3133),
    [sym_line_comment] = STATE(3133),
    [sym_compiler_directive_decl] = STATE(3133),
    [sym_fsi_directive_decl] = STATE(3133),
    [sym_preproc_line] = STATE(3133),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3134] = {
    [sym_xml_doc] = STATE(3134),
    [sym_block_comment] = STATE(3134),
    [sym_line_comment] = STATE(3134),
    [sym_compiler_directive_decl] = STATE(3134),
    [sym_fsi_directive_decl] = STATE(3134),
    [sym_preproc_line] = STATE(3134),
    [ts_builtin_sym_end] = ACTIONS(5482),
    [sym_identifier] = ACTIONS(5484),
    [anon_sym_namespace] = ACTIONS(5484),
    [anon_sym_module] = ACTIONS(5484),
    [anon_sym_open] = ACTIONS(5484),
    [anon_sym_LBRACK_LT] = ACTIONS(5482),
    [anon_sym_return] = ACTIONS(5484),
    [anon_sym_type] = ACTIONS(5484),
    [anon_sym_do] = ACTIONS(5484),
    [anon_sym_and] = ACTIONS(5484),
    [anon_sym_let] = ACTIONS(5484),
    [anon_sym_let_BANG] = ACTIONS(5482),
    [aux_sym_access_modifier_token1] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5484),
    [anon_sym_null] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5482),
    [anon_sym_LBRACE] = ACTIONS(5484),
    [anon_sym_LT_AT] = ACTIONS(5484),
    [anon_sym_LT_AT_AT] = ACTIONS(5482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5482),
    [anon_sym_new] = ACTIONS(5484),
    [anon_sym_return_BANG] = ACTIONS(5482),
    [anon_sym_yield] = ACTIONS(5484),
    [anon_sym_yield_BANG] = ACTIONS(5482),
    [anon_sym_lazy] = ACTIONS(5484),
    [anon_sym_assert] = ACTIONS(5484),
    [anon_sym_upcast] = ACTIONS(5484),
    [anon_sym_downcast] = ACTIONS(5484),
    [anon_sym_for] = ACTIONS(5484),
    [anon_sym_while] = ACTIONS(5484),
    [anon_sym_if] = ACTIONS(5484),
    [anon_sym_fun] = ACTIONS(5484),
    [anon_sym_try] = ACTIONS(5484),
    [anon_sym_match] = ACTIONS(5484),
    [anon_sym_match_BANG] = ACTIONS(5482),
    [anon_sym_function] = ACTIONS(5484),
    [anon_sym_use] = ACTIONS(5484),
    [anon_sym_use_BANG] = ACTIONS(5482),
    [anon_sym_do_BANG] = ACTIONS(5482),
    [anon_sym_begin] = ACTIONS(5484),
    [anon_sym_default] = ACTIONS(5484),
    [anon_sym_static] = ACTIONS(5484),
    [anon_sym_member] = ACTIONS(5484),
    [anon_sym_abstract] = ACTIONS(5484),
    [anon_sym_override] = ACTIONS(5484),
    [anon_sym_val] = ACTIONS(5484),
    [aux_sym_char_token1] = ACTIONS(5482),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5484),
    [anon_sym_DQUOTE] = ACTIONS(5484),
    [anon_sym_AT_DQUOTE] = ACTIONS(5482),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5482),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5482),
    [sym_bool] = ACTIONS(5484),
    [sym_unit] = ACTIONS(5482),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5484),
    [sym_op_identifier] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_PLUS_DOT] = ACTIONS(5482),
    [anon_sym_DASH_DOT] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_TILDE] = ACTIONS(5482),
    [aux_sym_prefix_op_token1] = ACTIONS(5482),
    [sym_int] = ACTIONS(5484),
    [sym_xint] = ACTIONS(5482),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5482),
    [anon_sym_POUNDload] = ACTIONS(5482),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5482),
  },
  [3135] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5801),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3135),
    [sym_block_comment] = STATE(3135),
    [sym_line_comment] = STATE(3135),
    [sym_compiler_directive_decl] = STATE(3135),
    [sym_fsi_directive_decl] = STATE(3135),
    [sym_preproc_line] = STATE(3135),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3136] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5526),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3136),
    [sym_block_comment] = STATE(3136),
    [sym_line_comment] = STATE(3136),
    [sym_compiler_directive_decl] = STATE(3136),
    [sym_fsi_directive_decl] = STATE(3136),
    [sym_preproc_line] = STATE(3136),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3137] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5824),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3137),
    [sym_block_comment] = STATE(3137),
    [sym_line_comment] = STATE(3137),
    [sym_compiler_directive_decl] = STATE(3137),
    [sym_fsi_directive_decl] = STATE(3137),
    [sym_preproc_line] = STATE(3137),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3138] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5833),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3138),
    [sym_block_comment] = STATE(3138),
    [sym_line_comment] = STATE(3138),
    [sym_compiler_directive_decl] = STATE(3138),
    [sym_fsi_directive_decl] = STATE(3138),
    [sym_preproc_line] = STATE(3138),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3139] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5721),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3139),
    [sym_block_comment] = STATE(3139),
    [sym_line_comment] = STATE(3139),
    [sym_compiler_directive_decl] = STATE(3139),
    [sym_fsi_directive_decl] = STATE(3139),
    [sym_preproc_line] = STATE(3139),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3140] = {
    [sym_xml_doc] = STATE(3140),
    [sym_block_comment] = STATE(3140),
    [sym_line_comment] = STATE(3140),
    [sym_compiler_directive_decl] = STATE(3140),
    [sym_fsi_directive_decl] = STATE(3140),
    [sym_preproc_line] = STATE(3140),
    [ts_builtin_sym_end] = ACTIONS(5486),
    [sym_identifier] = ACTIONS(5488),
    [anon_sym_namespace] = ACTIONS(5488),
    [anon_sym_module] = ACTIONS(5488),
    [anon_sym_open] = ACTIONS(5488),
    [anon_sym_LBRACK_LT] = ACTIONS(5486),
    [anon_sym_return] = ACTIONS(5488),
    [anon_sym_type] = ACTIONS(5488),
    [anon_sym_do] = ACTIONS(5488),
    [anon_sym_and] = ACTIONS(5488),
    [anon_sym_let] = ACTIONS(5488),
    [anon_sym_let_BANG] = ACTIONS(5486),
    [aux_sym_access_modifier_token1] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_null] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5486),
    [anon_sym_LBRACE] = ACTIONS(5488),
    [anon_sym_LT_AT] = ACTIONS(5488),
    [anon_sym_LT_AT_AT] = ACTIONS(5486),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5486),
    [anon_sym_new] = ACTIONS(5488),
    [anon_sym_return_BANG] = ACTIONS(5486),
    [anon_sym_yield] = ACTIONS(5488),
    [anon_sym_yield_BANG] = ACTIONS(5486),
    [anon_sym_lazy] = ACTIONS(5488),
    [anon_sym_assert] = ACTIONS(5488),
    [anon_sym_upcast] = ACTIONS(5488),
    [anon_sym_downcast] = ACTIONS(5488),
    [anon_sym_for] = ACTIONS(5488),
    [anon_sym_while] = ACTIONS(5488),
    [anon_sym_if] = ACTIONS(5488),
    [anon_sym_fun] = ACTIONS(5488),
    [anon_sym_try] = ACTIONS(5488),
    [anon_sym_match] = ACTIONS(5488),
    [anon_sym_match_BANG] = ACTIONS(5486),
    [anon_sym_function] = ACTIONS(5488),
    [anon_sym_use] = ACTIONS(5488),
    [anon_sym_use_BANG] = ACTIONS(5486),
    [anon_sym_do_BANG] = ACTIONS(5486),
    [anon_sym_begin] = ACTIONS(5488),
    [anon_sym_default] = ACTIONS(5488),
    [anon_sym_static] = ACTIONS(5488),
    [anon_sym_member] = ACTIONS(5488),
    [anon_sym_abstract] = ACTIONS(5488),
    [anon_sym_override] = ACTIONS(5488),
    [anon_sym_val] = ACTIONS(5488),
    [aux_sym_char_token1] = ACTIONS(5486),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5488),
    [anon_sym_DQUOTE] = ACTIONS(5488),
    [anon_sym_AT_DQUOTE] = ACTIONS(5486),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5486),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5486),
    [sym_bool] = ACTIONS(5488),
    [sym_unit] = ACTIONS(5486),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5488),
    [sym_op_identifier] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_PLUS_DOT] = ACTIONS(5486),
    [anon_sym_DASH_DOT] = ACTIONS(5486),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_TILDE] = ACTIONS(5486),
    [aux_sym_prefix_op_token1] = ACTIONS(5486),
    [sym_int] = ACTIONS(5488),
    [sym_xint] = ACTIONS(5486),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5486),
    [anon_sym_POUNDload] = ACTIONS(5486),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5486),
  },
  [3141] = {
    [sym_attributes] = STATE(3058),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(4150),
    [sym__pattern] = STATE(4084),
    [sym_optional_pattern] = STATE(4150),
    [sym_type_check_pattern] = STATE(4150),
    [sym_attribute_pattern] = STATE(4150),
    [sym_paren_pattern] = STATE(4150),
    [sym_as_pattern] = STATE(4150),
    [sym_cons_pattern] = STATE(4150),
    [sym_disjunct_pattern] = STATE(4150),
    [sym_conjunct_pattern] = STATE(4150),
    [sym_typed_pattern] = STATE(4150),
    [sym_list_pattern] = STATE(4150),
    [sym_array_pattern] = STATE(4150),
    [sym_record_pattern] = STATE(4150),
    [sym_identifier_pattern] = STATE(4150),
    [sym_long_identifier_or_op] = STATE(2268),
    [sym_char] = STATE(4119),
    [sym_format_string] = STATE(4124),
    [sym__string_literal] = STATE(4124),
    [sym_string] = STATE(4119),
    [sym_verbatim_string] = STATE(4119),
    [sym_bytearray] = STATE(4119),
    [sym_verbatim_bytearray] = STATE(4119),
    [sym_format_triple_quoted_string] = STATE(4125),
    [sym_triple_quoted_string] = STATE(4119),
    [sym_const] = STATE(4150),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(4119),
    [sym_byte] = STATE(4119),
    [sym_int16] = STATE(4119),
    [sym_uint16] = STATE(4119),
    [sym_int32] = STATE(4119),
    [sym_uint32] = STATE(4119),
    [sym_nativeint] = STATE(4119),
    [sym_unativeint] = STATE(4119),
    [sym_int64] = STATE(4119),
    [sym_uint64] = STATE(4119),
    [sym_ieee32] = STATE(4119),
    [sym_ieee64] = STATE(4119),
    [sym_bignum] = STATE(4119),
    [sym_decimal] = STATE(4119),
    [sym_float] = STATE(4024),
    [sym_xml_doc] = STATE(3141),
    [sym_block_comment] = STATE(3141),
    [sym_line_comment] = STATE(3141),
    [sym_compiler_directive_decl] = STATE(3141),
    [sym_fsi_directive_decl] = STATE(3141),
    [sym_preproc_line] = STATE(3141),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5402),
    [anon_sym_null] = ACTIONS(5404),
    [anon_sym__] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(4913),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5434),
    [aux_sym_char_token1] = ACTIONS(5414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5416),
    [anon_sym_DQUOTE] = ACTIONS(5418),
    [anon_sym_AT_DQUOTE] = ACTIONS(5420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5422),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5424),
    [sym_bool] = ACTIONS(5426),
    [sym_unit] = ACTIONS(5428),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(5430),
    [sym_xint] = ACTIONS(5432),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3142] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3955),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3142),
    [sym_block_comment] = STATE(3142),
    [sym_line_comment] = STATE(3142),
    [sym_compiler_directive_decl] = STATE(3142),
    [sym_fsi_directive_decl] = STATE(3142),
    [sym_preproc_line] = STATE(3142),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3143] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3949),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3143),
    [sym_block_comment] = STATE(3143),
    [sym_line_comment] = STATE(3143),
    [sym_compiler_directive_decl] = STATE(3143),
    [sym_fsi_directive_decl] = STATE(3143),
    [sym_preproc_line] = STATE(3143),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3144] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3948),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3144),
    [sym_block_comment] = STATE(3144),
    [sym_line_comment] = STATE(3144),
    [sym_compiler_directive_decl] = STATE(3144),
    [sym_fsi_directive_decl] = STATE(3144),
    [sym_preproc_line] = STATE(3144),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3145] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3937),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3145),
    [sym_block_comment] = STATE(3145),
    [sym_line_comment] = STATE(3145),
    [sym_compiler_directive_decl] = STATE(3145),
    [sym_fsi_directive_decl] = STATE(3145),
    [sym_preproc_line] = STATE(3145),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3146] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5805),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3146),
    [sym_block_comment] = STATE(3146),
    [sym_line_comment] = STATE(3146),
    [sym_compiler_directive_decl] = STATE(3146),
    [sym_fsi_directive_decl] = STATE(3146),
    [sym_preproc_line] = STATE(3146),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3147] = {
    [sym_attributes] = STATE(3046),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5720),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2081),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3147),
    [sym_block_comment] = STATE(3147),
    [sym_line_comment] = STATE(3147),
    [sym_compiler_directive_decl] = STATE(3147),
    [sym_fsi_directive_decl] = STATE(3147),
    [sym_preproc_line] = STATE(3147),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4792),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3148] = {
    [sym_xml_doc] = STATE(3148),
    [sym_block_comment] = STATE(3148),
    [sym_line_comment] = STATE(3148),
    [sym_compiler_directive_decl] = STATE(3148),
    [sym_fsi_directive_decl] = STATE(3148),
    [sym_preproc_line] = STATE(3148),
    [sym_identifier] = ACTIONS(5342),
    [anon_sym_module] = ACTIONS(5342),
    [anon_sym_open] = ACTIONS(5342),
    [anon_sym_LBRACK_LT] = ACTIONS(5340),
    [anon_sym_return] = ACTIONS(5342),
    [anon_sym_type] = ACTIONS(5342),
    [anon_sym_do] = ACTIONS(5342),
    [anon_sym_and] = ACTIONS(5342),
    [anon_sym_let] = ACTIONS(5342),
    [anon_sym_let_BANG] = ACTIONS(5340),
    [aux_sym_access_modifier_token1] = ACTIONS(5340),
    [anon_sym_LPAREN] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_null] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_LT_AT] = ACTIONS(5342),
    [anon_sym_LT_AT_AT] = ACTIONS(5340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5340),
    [anon_sym_new] = ACTIONS(5342),
    [anon_sym_return_BANG] = ACTIONS(5340),
    [anon_sym_yield] = ACTIONS(5342),
    [anon_sym_yield_BANG] = ACTIONS(5340),
    [anon_sym_lazy] = ACTIONS(5342),
    [anon_sym_assert] = ACTIONS(5342),
    [anon_sym_upcast] = ACTIONS(5342),
    [anon_sym_downcast] = ACTIONS(5342),
    [anon_sym_for] = ACTIONS(5342),
    [anon_sym_while] = ACTIONS(5342),
    [anon_sym_if] = ACTIONS(5342),
    [anon_sym_fun] = ACTIONS(5342),
    [anon_sym_try] = ACTIONS(5342),
    [anon_sym_match] = ACTIONS(5342),
    [anon_sym_match_BANG] = ACTIONS(5340),
    [anon_sym_function] = ACTIONS(5342),
    [anon_sym_use] = ACTIONS(5342),
    [anon_sym_use_BANG] = ACTIONS(5340),
    [anon_sym_do_BANG] = ACTIONS(5340),
    [anon_sym_begin] = ACTIONS(5342),
    [anon_sym_default] = ACTIONS(5342),
    [anon_sym_static] = ACTIONS(5342),
    [anon_sym_member] = ACTIONS(5342),
    [anon_sym_abstract] = ACTIONS(5342),
    [anon_sym_override] = ACTIONS(5342),
    [anon_sym_val] = ACTIONS(5342),
    [aux_sym_char_token1] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5342),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_AT_DQUOTE] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [sym_bool] = ACTIONS(5342),
    [sym_unit] = ACTIONS(5340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5342),
    [sym_op_identifier] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_DOT] = ACTIONS(5340),
    [anon_sym_DASH_DOT] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5340),
    [anon_sym_AMP_AMP] = ACTIONS(5340),
    [anon_sym_TILDE] = ACTIONS(5340),
    [aux_sym_prefix_op_token1] = ACTIONS(5340),
    [sym_int] = ACTIONS(5342),
    [sym_xint] = ACTIONS(5340),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5340),
    [anon_sym_POUNDload] = ACTIONS(5340),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5340),
    [sym__dedent] = ACTIONS(5340),
  },
  [3149] = {
    [sym_xml_doc] = STATE(3149),
    [sym_block_comment] = STATE(3149),
    [sym_line_comment] = STATE(3149),
    [sym_compiler_directive_decl] = STATE(3149),
    [sym_fsi_directive_decl] = STATE(3149),
    [sym_preproc_line] = STATE(3149),
    [ts_builtin_sym_end] = ACTIONS(5492),
    [sym_identifier] = ACTIONS(5494),
    [anon_sym_namespace] = ACTIONS(5494),
    [anon_sym_module] = ACTIONS(5494),
    [anon_sym_open] = ACTIONS(5494),
    [anon_sym_LBRACK_LT] = ACTIONS(5492),
    [anon_sym_return] = ACTIONS(5494),
    [anon_sym_type] = ACTIONS(5494),
    [anon_sym_do] = ACTIONS(5494),
    [anon_sym_and] = ACTIONS(5494),
    [anon_sym_let] = ACTIONS(5494),
    [anon_sym_let_BANG] = ACTIONS(5492),
    [aux_sym_access_modifier_token1] = ACTIONS(5492),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym_AMP] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5492),
    [anon_sym_LBRACE] = ACTIONS(5494),
    [anon_sym_LT_AT] = ACTIONS(5494),
    [anon_sym_LT_AT_AT] = ACTIONS(5492),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5492),
    [anon_sym_new] = ACTIONS(5494),
    [anon_sym_return_BANG] = ACTIONS(5492),
    [anon_sym_yield] = ACTIONS(5494),
    [anon_sym_yield_BANG] = ACTIONS(5492),
    [anon_sym_lazy] = ACTIONS(5494),
    [anon_sym_assert] = ACTIONS(5494),
    [anon_sym_upcast] = ACTIONS(5494),
    [anon_sym_downcast] = ACTIONS(5494),
    [anon_sym_for] = ACTIONS(5494),
    [anon_sym_while] = ACTIONS(5494),
    [anon_sym_if] = ACTIONS(5494),
    [anon_sym_fun] = ACTIONS(5494),
    [anon_sym_try] = ACTIONS(5494),
    [anon_sym_match] = ACTIONS(5494),
    [anon_sym_match_BANG] = ACTIONS(5492),
    [anon_sym_function] = ACTIONS(5494),
    [anon_sym_use] = ACTIONS(5494),
    [anon_sym_use_BANG] = ACTIONS(5492),
    [anon_sym_do_BANG] = ACTIONS(5492),
    [anon_sym_begin] = ACTIONS(5494),
    [anon_sym_default] = ACTIONS(5494),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_member] = ACTIONS(5494),
    [anon_sym_abstract] = ACTIONS(5494),
    [anon_sym_override] = ACTIONS(5494),
    [anon_sym_val] = ACTIONS(5494),
    [aux_sym_char_token1] = ACTIONS(5492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5494),
    [anon_sym_DQUOTE] = ACTIONS(5494),
    [anon_sym_AT_DQUOTE] = ACTIONS(5492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5492),
    [sym_bool] = ACTIONS(5494),
    [sym_unit] = ACTIONS(5492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5494),
    [sym_op_identifier] = ACTIONS(5492),
    [anon_sym_PLUS] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_PLUS_DOT] = ACTIONS(5492),
    [anon_sym_DASH_DOT] = ACTIONS(5492),
    [anon_sym_PERCENT] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [aux_sym_prefix_op_token1] = ACTIONS(5492),
    [sym_int] = ACTIONS(5494),
    [sym_xint] = ACTIONS(5492),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5492),
    [anon_sym_POUNDload] = ACTIONS(5492),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5492),
  },
  [3150] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5588),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3150),
    [sym_block_comment] = STATE(3150),
    [sym_line_comment] = STATE(3150),
    [sym_compiler_directive_decl] = STATE(3150),
    [sym_fsi_directive_decl] = STATE(3150),
    [sym_preproc_line] = STATE(3150),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3151] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5863),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3151),
    [sym_block_comment] = STATE(3151),
    [sym_line_comment] = STATE(3151),
    [sym_compiler_directive_decl] = STATE(3151),
    [sym_fsi_directive_decl] = STATE(3151),
    [sym_preproc_line] = STATE(3151),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5474),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3152] = {
    [sym_xml_doc] = STATE(3152),
    [sym_block_comment] = STATE(3152),
    [sym_line_comment] = STATE(3152),
    [sym_compiler_directive_decl] = STATE(3152),
    [sym_fsi_directive_decl] = STATE(3152),
    [sym_preproc_line] = STATE(3152),
    [sym_identifier] = ACTIONS(5342),
    [anon_sym_module] = ACTIONS(5342),
    [anon_sym_open] = ACTIONS(5342),
    [anon_sym_LBRACK_LT] = ACTIONS(5340),
    [anon_sym_return] = ACTIONS(5342),
    [anon_sym_type] = ACTIONS(5342),
    [anon_sym_do] = ACTIONS(5342),
    [anon_sym_and] = ACTIONS(5342),
    [anon_sym_let] = ACTIONS(5342),
    [anon_sym_let_BANG] = ACTIONS(5340),
    [aux_sym_access_modifier_token1] = ACTIONS(5340),
    [anon_sym_LPAREN] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_null] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_LT_AT] = ACTIONS(5342),
    [anon_sym_LT_AT_AT] = ACTIONS(5340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5340),
    [anon_sym_new] = ACTIONS(5342),
    [anon_sym_return_BANG] = ACTIONS(5340),
    [anon_sym_yield] = ACTIONS(5342),
    [anon_sym_yield_BANG] = ACTIONS(5340),
    [anon_sym_lazy] = ACTIONS(5342),
    [anon_sym_assert] = ACTIONS(5342),
    [anon_sym_upcast] = ACTIONS(5342),
    [anon_sym_downcast] = ACTIONS(5342),
    [anon_sym_for] = ACTIONS(5342),
    [anon_sym_while] = ACTIONS(5342),
    [anon_sym_if] = ACTIONS(5342),
    [anon_sym_fun] = ACTIONS(5342),
    [anon_sym_try] = ACTIONS(5342),
    [anon_sym_match] = ACTIONS(5342),
    [anon_sym_match_BANG] = ACTIONS(5340),
    [anon_sym_function] = ACTIONS(5342),
    [anon_sym_use] = ACTIONS(5342),
    [anon_sym_use_BANG] = ACTIONS(5340),
    [anon_sym_do_BANG] = ACTIONS(5340),
    [anon_sym_begin] = ACTIONS(5342),
    [anon_sym_default] = ACTIONS(5342),
    [anon_sym_static] = ACTIONS(5342),
    [anon_sym_member] = ACTIONS(5342),
    [anon_sym_abstract] = ACTIONS(5342),
    [anon_sym_override] = ACTIONS(5342),
    [anon_sym_val] = ACTIONS(5342),
    [aux_sym_char_token1] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5342),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_AT_DQUOTE] = ACTIONS(5340),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5340),
    [sym_bool] = ACTIONS(5342),
    [sym_unit] = ACTIONS(5340),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5342),
    [sym_op_identifier] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_DOT] = ACTIONS(5340),
    [anon_sym_DASH_DOT] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5340),
    [anon_sym_AMP_AMP] = ACTIONS(5340),
    [anon_sym_TILDE] = ACTIONS(5340),
    [aux_sym_prefix_op_token1] = ACTIONS(5340),
    [sym_int] = ACTIONS(5342),
    [sym_xint] = ACTIONS(5340),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5340),
    [anon_sym_POUNDload] = ACTIONS(5340),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5340),
    [sym__dedent] = ACTIONS(5340),
  },
  [3153] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5572),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3244),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3153),
    [sym_block_comment] = STATE(3153),
    [sym_line_comment] = STATE(3153),
    [sym_compiler_directive_decl] = STATE(3153),
    [sym_fsi_directive_decl] = STATE(3153),
    [sym_preproc_line] = STATE(3153),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3154] = {
    [sym_xml_doc] = STATE(3154),
    [sym_block_comment] = STATE(3154),
    [sym_line_comment] = STATE(3154),
    [sym_compiler_directive_decl] = STATE(3154),
    [sym_fsi_directive_decl] = STATE(3154),
    [sym_preproc_line] = STATE(3154),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_y] = ACTIONS(5294),
    [anon_sym_uy] = ACTIONS(5296),
    [anon_sym_s] = ACTIONS(5298),
    [anon_sym_us] = ACTIONS(5300),
    [anon_sym_l] = ACTIONS(5302),
    [aux_sym_uint32_token1] = ACTIONS(5304),
    [anon_sym_n] = ACTIONS(5306),
    [anon_sym_un] = ACTIONS(5308),
    [anon_sym_L] = ACTIONS(5310),
    [aux_sym_uint64_token1] = ACTIONS(5312),
    [anon_sym_lf] = ACTIONS(5498),
    [anon_sym_LF] = ACTIONS(5500),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
  },
  [3155] = {
    [sym_xml_doc] = STATE(3155),
    [sym_block_comment] = STATE(3155),
    [sym_line_comment] = STATE(3155),
    [sym_compiler_directive_decl] = STATE(3155),
    [sym_fsi_directive_decl] = STATE(3155),
    [sym_preproc_line] = STATE(3155),
    [ts_builtin_sym_end] = ACTIONS(5502),
    [sym_identifier] = ACTIONS(5504),
    [anon_sym_namespace] = ACTIONS(5504),
    [anon_sym_module] = ACTIONS(5504),
    [anon_sym_open] = ACTIONS(5504),
    [anon_sym_LBRACK_LT] = ACTIONS(5502),
    [anon_sym_return] = ACTIONS(5504),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_do] = ACTIONS(5504),
    [anon_sym_and] = ACTIONS(5504),
    [anon_sym_let] = ACTIONS(5504),
    [anon_sym_let_BANG] = ACTIONS(5502),
    [aux_sym_access_modifier_token1] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_null] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5504),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_LT_AT] = ACTIONS(5504),
    [anon_sym_LT_AT_AT] = ACTIONS(5502),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5502),
    [anon_sym_new] = ACTIONS(5504),
    [anon_sym_return_BANG] = ACTIONS(5502),
    [anon_sym_yield] = ACTIONS(5504),
    [anon_sym_yield_BANG] = ACTIONS(5502),
    [anon_sym_lazy] = ACTIONS(5504),
    [anon_sym_assert] = ACTIONS(5504),
    [anon_sym_upcast] = ACTIONS(5504),
    [anon_sym_downcast] = ACTIONS(5504),
    [anon_sym_for] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_fun] = ACTIONS(5504),
    [anon_sym_try] = ACTIONS(5504),
    [anon_sym_match] = ACTIONS(5504),
    [anon_sym_match_BANG] = ACTIONS(5502),
    [anon_sym_function] = ACTIONS(5504),
    [anon_sym_use] = ACTIONS(5504),
    [anon_sym_use_BANG] = ACTIONS(5502),
    [anon_sym_do_BANG] = ACTIONS(5502),
    [anon_sym_begin] = ACTIONS(5504),
    [anon_sym_default] = ACTIONS(5504),
    [anon_sym_static] = ACTIONS(5504),
    [anon_sym_member] = ACTIONS(5504),
    [anon_sym_abstract] = ACTIONS(5504),
    [anon_sym_override] = ACTIONS(5504),
    [anon_sym_val] = ACTIONS(5504),
    [aux_sym_char_token1] = ACTIONS(5502),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5504),
    [anon_sym_DQUOTE] = ACTIONS(5504),
    [anon_sym_AT_DQUOTE] = ACTIONS(5502),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5502),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5502),
    [sym_bool] = ACTIONS(5504),
    [sym_unit] = ACTIONS(5502),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5504),
    [sym_op_identifier] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_DOT] = ACTIONS(5502),
    [anon_sym_DASH_DOT] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_TILDE] = ACTIONS(5502),
    [aux_sym_prefix_op_token1] = ACTIONS(5502),
    [sym_int] = ACTIONS(5504),
    [sym_xint] = ACTIONS(5502),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5502),
    [anon_sym_POUNDload] = ACTIONS(5502),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5502),
  },
  [3156] = {
    [sym_attributes] = STATE(3082),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5512),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1816),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3156),
    [sym_block_comment] = STATE(3156),
    [sym_line_comment] = STATE(3156),
    [sym_compiler_directive_decl] = STATE(3156),
    [sym_fsi_directive_decl] = STATE(3156),
    [sym_preproc_line] = STATE(3156),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4529),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4537),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3157] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5807),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3157),
    [sym_block_comment] = STATE(3157),
    [sym_line_comment] = STATE(3157),
    [sym_compiler_directive_decl] = STATE(3157),
    [sym_fsi_directive_decl] = STATE(3157),
    [sym_preproc_line] = STATE(3157),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3158] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5836),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3158),
    [sym_block_comment] = STATE(3158),
    [sym_line_comment] = STATE(3158),
    [sym_compiler_directive_decl] = STATE(3158),
    [sym_fsi_directive_decl] = STATE(3158),
    [sym_preproc_line] = STATE(3158),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3159] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5869),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3159),
    [sym_block_comment] = STATE(3159),
    [sym_line_comment] = STATE(3159),
    [sym_compiler_directive_decl] = STATE(3159),
    [sym_fsi_directive_decl] = STATE(3159),
    [sym_preproc_line] = STATE(3159),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3160] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5788),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3160),
    [sym_block_comment] = STATE(3160),
    [sym_line_comment] = STATE(3160),
    [sym_compiler_directive_decl] = STATE(3160),
    [sym_fsi_directive_decl] = STATE(3160),
    [sym_preproc_line] = STATE(3160),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3161] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5786),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3161),
    [sym_block_comment] = STATE(3161),
    [sym_line_comment] = STATE(3161),
    [sym_compiler_directive_decl] = STATE(3161),
    [sym_fsi_directive_decl] = STATE(3161),
    [sym_preproc_line] = STATE(3161),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3162] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5745),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3162),
    [sym_block_comment] = STATE(3162),
    [sym_line_comment] = STATE(3162),
    [sym_compiler_directive_decl] = STATE(3162),
    [sym_fsi_directive_decl] = STATE(3162),
    [sym_preproc_line] = STATE(3162),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3163] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5862),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3163),
    [sym_block_comment] = STATE(3163),
    [sym_line_comment] = STATE(3163),
    [sym_compiler_directive_decl] = STATE(3163),
    [sym_fsi_directive_decl] = STATE(3163),
    [sym_preproc_line] = STATE(3163),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3164] = {
    [sym_xml_doc] = STATE(3164),
    [sym_block_comment] = STATE(3164),
    [sym_line_comment] = STATE(3164),
    [sym_compiler_directive_decl] = STATE(3164),
    [sym_fsi_directive_decl] = STATE(3164),
    [sym_preproc_line] = STATE(3164),
    [ts_builtin_sym_end] = ACTIONS(5506),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_namespace] = ACTIONS(5508),
    [anon_sym_module] = ACTIONS(5508),
    [anon_sym_open] = ACTIONS(5508),
    [anon_sym_LBRACK_LT] = ACTIONS(5506),
    [anon_sym_return] = ACTIONS(5508),
    [anon_sym_type] = ACTIONS(5508),
    [anon_sym_do] = ACTIONS(5508),
    [anon_sym_and] = ACTIONS(5508),
    [anon_sym_let] = ACTIONS(5508),
    [anon_sym_let_BANG] = ACTIONS(5506),
    [aux_sym_access_modifier_token1] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5508),
    [anon_sym_null] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5506),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_LT_AT] = ACTIONS(5508),
    [anon_sym_LT_AT_AT] = ACTIONS(5506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5506),
    [anon_sym_new] = ACTIONS(5508),
    [anon_sym_return_BANG] = ACTIONS(5506),
    [anon_sym_yield] = ACTIONS(5508),
    [anon_sym_yield_BANG] = ACTIONS(5506),
    [anon_sym_lazy] = ACTIONS(5508),
    [anon_sym_assert] = ACTIONS(5508),
    [anon_sym_upcast] = ACTIONS(5508),
    [anon_sym_downcast] = ACTIONS(5508),
    [anon_sym_for] = ACTIONS(5508),
    [anon_sym_while] = ACTIONS(5508),
    [anon_sym_if] = ACTIONS(5508),
    [anon_sym_fun] = ACTIONS(5508),
    [anon_sym_try] = ACTIONS(5508),
    [anon_sym_match] = ACTIONS(5508),
    [anon_sym_match_BANG] = ACTIONS(5506),
    [anon_sym_function] = ACTIONS(5508),
    [anon_sym_use] = ACTIONS(5508),
    [anon_sym_use_BANG] = ACTIONS(5506),
    [anon_sym_do_BANG] = ACTIONS(5506),
    [anon_sym_begin] = ACTIONS(5508),
    [anon_sym_default] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_member] = ACTIONS(5508),
    [anon_sym_abstract] = ACTIONS(5508),
    [anon_sym_override] = ACTIONS(5508),
    [anon_sym_val] = ACTIONS(5508),
    [aux_sym_char_token1] = ACTIONS(5506),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5508),
    [anon_sym_DQUOTE] = ACTIONS(5508),
    [anon_sym_AT_DQUOTE] = ACTIONS(5506),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5506),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5506),
    [sym_bool] = ACTIONS(5508),
    [sym_unit] = ACTIONS(5506),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5508),
    [sym_op_identifier] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_DOT] = ACTIONS(5506),
    [anon_sym_DASH_DOT] = ACTIONS(5506),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [aux_sym_prefix_op_token1] = ACTIONS(5506),
    [sym_int] = ACTIONS(5508),
    [sym_xint] = ACTIONS(5506),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5506),
    [anon_sym_POUNDload] = ACTIONS(5506),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5506),
  },
  [3165] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5841),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3165),
    [sym_block_comment] = STATE(3165),
    [sym_line_comment] = STATE(3165),
    [sym_compiler_directive_decl] = STATE(3165),
    [sym_fsi_directive_decl] = STATE(3165),
    [sym_preproc_line] = STATE(3165),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3166] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5826),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3166),
    [sym_block_comment] = STATE(3166),
    [sym_line_comment] = STATE(3166),
    [sym_compiler_directive_decl] = STATE(3166),
    [sym_fsi_directive_decl] = STATE(3166),
    [sym_preproc_line] = STATE(3166),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3167] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5782),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3167),
    [sym_block_comment] = STATE(3167),
    [sym_line_comment] = STATE(3167),
    [sym_compiler_directive_decl] = STATE(3167),
    [sym_fsi_directive_decl] = STATE(3167),
    [sym_preproc_line] = STATE(3167),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3168] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5847),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3168),
    [sym_block_comment] = STATE(3168),
    [sym_line_comment] = STATE(3168),
    [sym_compiler_directive_decl] = STATE(3168),
    [sym_fsi_directive_decl] = STATE(3168),
    [sym_preproc_line] = STATE(3168),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(5510),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3169] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5827),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3169),
    [sym_block_comment] = STATE(3169),
    [sym_line_comment] = STATE(3169),
    [sym_compiler_directive_decl] = STATE(3169),
    [sym_fsi_directive_decl] = STATE(3169),
    [sym_preproc_line] = STATE(3169),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3170] = {
    [sym_attributes] = STATE(3122),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5781),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2154),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3798),
    [sym_active_pattern] = STATE(3820),
    [sym__identifier_or_op] = STATE(3906),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3170),
    [sym_block_comment] = STATE(3170),
    [sym_line_comment] = STATE(3170),
    [sym_compiler_directive_decl] = STATE(3170),
    [sym_fsi_directive_decl] = STATE(3170),
    [sym_preproc_line] = STATE(3170),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4515),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4851),
    [anon_sym_COLON_QMARK] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4555),
    [sym_op_identifier] = ACTIONS(4557),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3171] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5878),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3171),
    [sym_block_comment] = STATE(3171),
    [sym_line_comment] = STATE(3171),
    [sym_compiler_directive_decl] = STATE(3171),
    [sym_fsi_directive_decl] = STATE(3171),
    [sym_preproc_line] = STATE(3171),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3172] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5343),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3172),
    [sym_block_comment] = STATE(3172),
    [sym_line_comment] = STATE(3172),
    [sym_compiler_directive_decl] = STATE(3172),
    [sym_fsi_directive_decl] = STATE(3172),
    [sym_preproc_line] = STATE(3172),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3173] = {
    [sym_xml_doc] = STATE(3173),
    [sym_block_comment] = STATE(3173),
    [sym_line_comment] = STATE(3173),
    [sym_compiler_directive_decl] = STATE(3173),
    [sym_fsi_directive_decl] = STATE(3173),
    [sym_preproc_line] = STATE(3173),
    [ts_builtin_sym_end] = ACTIONS(5077),
    [sym_identifier] = ACTIONS(5079),
    [anon_sym_namespace] = ACTIONS(5079),
    [anon_sym_module] = ACTIONS(5079),
    [anon_sym_open] = ACTIONS(5079),
    [anon_sym_LBRACK_LT] = ACTIONS(5077),
    [anon_sym_return] = ACTIONS(5079),
    [anon_sym_type] = ACTIONS(5079),
    [anon_sym_do] = ACTIONS(5079),
    [anon_sym_and] = ACTIONS(5079),
    [anon_sym_let] = ACTIONS(5079),
    [anon_sym_let_BANG] = ACTIONS(5077),
    [aux_sym_access_modifier_token1] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(5079),
    [anon_sym_null] = ACTIONS(5079),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5077),
    [anon_sym_LBRACE] = ACTIONS(5079),
    [anon_sym_LT_AT] = ACTIONS(5079),
    [anon_sym_LT_AT_AT] = ACTIONS(5077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5077),
    [anon_sym_new] = ACTIONS(5079),
    [anon_sym_return_BANG] = ACTIONS(5077),
    [anon_sym_yield] = ACTIONS(5079),
    [anon_sym_yield_BANG] = ACTIONS(5077),
    [anon_sym_lazy] = ACTIONS(5079),
    [anon_sym_assert] = ACTIONS(5079),
    [anon_sym_upcast] = ACTIONS(5079),
    [anon_sym_downcast] = ACTIONS(5079),
    [anon_sym_for] = ACTIONS(5079),
    [anon_sym_while] = ACTIONS(5079),
    [anon_sym_if] = ACTIONS(5079),
    [anon_sym_fun] = ACTIONS(5079),
    [anon_sym_try] = ACTIONS(5079),
    [anon_sym_match] = ACTIONS(5079),
    [anon_sym_match_BANG] = ACTIONS(5077),
    [anon_sym_function] = ACTIONS(5079),
    [anon_sym_use] = ACTIONS(5079),
    [anon_sym_use_BANG] = ACTIONS(5077),
    [anon_sym_do_BANG] = ACTIONS(5077),
    [anon_sym_begin] = ACTIONS(5079),
    [anon_sym_default] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_member] = ACTIONS(5079),
    [anon_sym_abstract] = ACTIONS(5079),
    [anon_sym_override] = ACTIONS(5079),
    [anon_sym_val] = ACTIONS(5079),
    [aux_sym_char_token1] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5079),
    [anon_sym_DQUOTE] = ACTIONS(5079),
    [anon_sym_AT_DQUOTE] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [sym_bool] = ACTIONS(5079),
    [sym_unit] = ACTIONS(5077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5079),
    [sym_op_identifier] = ACTIONS(5077),
    [anon_sym_PLUS] = ACTIONS(5079),
    [anon_sym_DASH] = ACTIONS(5079),
    [anon_sym_PLUS_DOT] = ACTIONS(5077),
    [anon_sym_DASH_DOT] = ACTIONS(5077),
    [anon_sym_PERCENT] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [aux_sym_prefix_op_token1] = ACTIONS(5077),
    [sym_int] = ACTIONS(5079),
    [sym_xint] = ACTIONS(5077),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5077),
    [anon_sym_POUNDload] = ACTIONS(5077),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5077),
  },
  [3174] = {
    [sym_attributes] = STATE(3065),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5469),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(1895),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3174),
    [sym_block_comment] = STATE(3174),
    [sym_line_comment] = STATE(3174),
    [sym_compiler_directive_decl] = STATE(3174),
    [sym_fsi_directive_decl] = STATE(3174),
    [sym_preproc_line] = STATE(3174),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4651),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3175] = {
    [sym_xml_doc] = STATE(3175),
    [sym_block_comment] = STATE(3175),
    [sym_line_comment] = STATE(3175),
    [sym_compiler_directive_decl] = STATE(3175),
    [sym_fsi_directive_decl] = STATE(3175),
    [sym_preproc_line] = STATE(3175),
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_module] = ACTIONS(5336),
    [anon_sym_open] = ACTIONS(5336),
    [anon_sym_LBRACK_LT] = ACTIONS(5334),
    [anon_sym_return] = ACTIONS(5336),
    [anon_sym_type] = ACTIONS(5336),
    [anon_sym_do] = ACTIONS(5336),
    [anon_sym_and] = ACTIONS(5336),
    [anon_sym_let] = ACTIONS(5336),
    [anon_sym_let_BANG] = ACTIONS(5334),
    [aux_sym_access_modifier_token1] = ACTIONS(5334),
    [anon_sym_LPAREN] = ACTIONS(5336),
    [anon_sym_null] = ACTIONS(5336),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_LBRACK] = ACTIONS(5336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(5336),
    [anon_sym_LT_AT] = ACTIONS(5336),
    [anon_sym_LT_AT_AT] = ACTIONS(5334),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5334),
    [anon_sym_with] = ACTIONS(5512),
    [anon_sym_new] = ACTIONS(5336),
    [anon_sym_return_BANG] = ACTIONS(5334),
    [anon_sym_yield] = ACTIONS(5336),
    [anon_sym_yield_BANG] = ACTIONS(5334),
    [anon_sym_lazy] = ACTIONS(5336),
    [anon_sym_assert] = ACTIONS(5336),
    [anon_sym_upcast] = ACTIONS(5336),
    [anon_sym_downcast] = ACTIONS(5336),
    [anon_sym_for] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(5336),
    [anon_sym_if] = ACTIONS(5336),
    [anon_sym_fun] = ACTIONS(5336),
    [anon_sym_try] = ACTIONS(5336),
    [anon_sym_match] = ACTIONS(5336),
    [anon_sym_match_BANG] = ACTIONS(5334),
    [anon_sym_function] = ACTIONS(5336),
    [anon_sym_use] = ACTIONS(5336),
    [anon_sym_use_BANG] = ACTIONS(5334),
    [anon_sym_do_BANG] = ACTIONS(5334),
    [anon_sym_begin] = ACTIONS(5336),
    [anon_sym_default] = ACTIONS(5336),
    [anon_sym_static] = ACTIONS(5336),
    [anon_sym_member] = ACTIONS(5336),
    [anon_sym_abstract] = ACTIONS(5336),
    [anon_sym_override] = ACTIONS(5336),
    [anon_sym_val] = ACTIONS(5336),
    [aux_sym_char_token1] = ACTIONS(5334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5336),
    [anon_sym_DQUOTE] = ACTIONS(5336),
    [anon_sym_AT_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5334),
    [sym_bool] = ACTIONS(5336),
    [sym_unit] = ACTIONS(5334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5336),
    [sym_op_identifier] = ACTIONS(5334),
    [anon_sym_PLUS] = ACTIONS(5336),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_PLUS_DOT] = ACTIONS(5334),
    [anon_sym_DASH_DOT] = ACTIONS(5334),
    [anon_sym_PERCENT] = ACTIONS(5334),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_TILDE] = ACTIONS(5334),
    [aux_sym_prefix_op_token1] = ACTIONS(5334),
    [sym_int] = ACTIONS(5336),
    [sym_xint] = ACTIONS(5334),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5334),
    [anon_sym_POUNDload] = ACTIONS(5334),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5334),
    [sym__dedent] = ACTIONS(5334),
  },
  [3176] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5860),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3176),
    [sym_block_comment] = STATE(3176),
    [sym_line_comment] = STATE(3176),
    [sym_compiler_directive_decl] = STATE(3176),
    [sym_fsi_directive_decl] = STATE(3176),
    [sym_preproc_line] = STATE(3176),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3177] = {
    [sym_attributes] = STATE(3162),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5722),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2284),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3177),
    [sym_block_comment] = STATE(3177),
    [sym_line_comment] = STATE(3177),
    [sym_compiler_directive_decl] = STATE(3177),
    [sym_fsi_directive_decl] = STATE(3177),
    [sym_preproc_line] = STATE(3177),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4923),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4925),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3178] = {
    [sym_attributes] = STATE(3165),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5849),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2736),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3912),
    [sym_active_pattern] = STATE(3968),
    [sym__identifier_or_op] = STATE(3971),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3178),
    [sym_block_comment] = STATE(3178),
    [sym_line_comment] = STATE(3178),
    [sym_compiler_directive_decl] = STATE(3178),
    [sym_fsi_directive_decl] = STATE(3178),
    [sym_preproc_line] = STATE(3178),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(5001),
    [anon_sym_COLON_QMARK] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4814),
    [sym_op_identifier] = ACTIONS(4816),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3179] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5832),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3179),
    [sym_block_comment] = STATE(3179),
    [sym_line_comment] = STATE(3179),
    [sym_compiler_directive_decl] = STATE(3179),
    [sym_fsi_directive_decl] = STATE(3179),
    [sym_preproc_line] = STATE(3179),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3180] = {
    [sym_xml_doc] = STATE(3180),
    [sym_block_comment] = STATE(3180),
    [sym_line_comment] = STATE(3180),
    [sym_compiler_directive_decl] = STATE(3180),
    [sym_fsi_directive_decl] = STATE(3180),
    [sym_preproc_line] = STATE(3180),
    [sym_identifier] = ACTIONS(5356),
    [anon_sym_module] = ACTIONS(5356),
    [anon_sym_open] = ACTIONS(5356),
    [anon_sym_LBRACK_LT] = ACTIONS(5354),
    [anon_sym_return] = ACTIONS(5356),
    [anon_sym_type] = ACTIONS(5356),
    [anon_sym_do] = ACTIONS(5356),
    [anon_sym_and] = ACTIONS(5356),
    [anon_sym_let] = ACTIONS(5356),
    [anon_sym_let_BANG] = ACTIONS(5354),
    [aux_sym_access_modifier_token1] = ACTIONS(5354),
    [anon_sym_LPAREN] = ACTIONS(5356),
    [anon_sym_null] = ACTIONS(5356),
    [anon_sym_AMP] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(5356),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(5356),
    [anon_sym_LT_AT] = ACTIONS(5356),
    [anon_sym_LT_AT_AT] = ACTIONS(5354),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5354),
    [anon_sym_with] = ACTIONS(5514),
    [anon_sym_new] = ACTIONS(5356),
    [anon_sym_return_BANG] = ACTIONS(5354),
    [anon_sym_yield] = ACTIONS(5356),
    [anon_sym_yield_BANG] = ACTIONS(5354),
    [anon_sym_lazy] = ACTIONS(5356),
    [anon_sym_assert] = ACTIONS(5356),
    [anon_sym_upcast] = ACTIONS(5356),
    [anon_sym_downcast] = ACTIONS(5356),
    [anon_sym_for] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_fun] = ACTIONS(5356),
    [anon_sym_try] = ACTIONS(5356),
    [anon_sym_match] = ACTIONS(5356),
    [anon_sym_match_BANG] = ACTIONS(5354),
    [anon_sym_function] = ACTIONS(5356),
    [anon_sym_use] = ACTIONS(5356),
    [anon_sym_use_BANG] = ACTIONS(5354),
    [anon_sym_do_BANG] = ACTIONS(5354),
    [anon_sym_begin] = ACTIONS(5356),
    [anon_sym_default] = ACTIONS(5356),
    [anon_sym_static] = ACTIONS(5356),
    [anon_sym_member] = ACTIONS(5356),
    [anon_sym_abstract] = ACTIONS(5356),
    [anon_sym_override] = ACTIONS(5356),
    [anon_sym_val] = ACTIONS(5356),
    [aux_sym_char_token1] = ACTIONS(5354),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5356),
    [anon_sym_DQUOTE] = ACTIONS(5356),
    [anon_sym_AT_DQUOTE] = ACTIONS(5354),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5354),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5354),
    [sym_bool] = ACTIONS(5356),
    [sym_unit] = ACTIONS(5354),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5356),
    [sym_op_identifier] = ACTIONS(5354),
    [anon_sym_PLUS] = ACTIONS(5356),
    [anon_sym_DASH] = ACTIONS(5356),
    [anon_sym_PLUS_DOT] = ACTIONS(5354),
    [anon_sym_DASH_DOT] = ACTIONS(5354),
    [anon_sym_PERCENT] = ACTIONS(5354),
    [anon_sym_AMP_AMP] = ACTIONS(5354),
    [anon_sym_TILDE] = ACTIONS(5354),
    [aux_sym_prefix_op_token1] = ACTIONS(5354),
    [sym_int] = ACTIONS(5356),
    [sym_xint] = ACTIONS(5354),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5354),
    [anon_sym_POUNDload] = ACTIONS(5354),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5354),
    [sym__dedent] = ACTIONS(5354),
  },
  [3181] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3938),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3181),
    [sym_block_comment] = STATE(3181),
    [sym_line_comment] = STATE(3181),
    [sym_compiler_directive_decl] = STATE(3181),
    [sym_fsi_directive_decl] = STATE(3181),
    [sym_preproc_line] = STATE(3181),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3182] = {
    [sym_attributes] = STATE(3087),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5717),
    [sym__pattern] = STATE(5529),
    [sym_optional_pattern] = STATE(5717),
    [sym_type_check_pattern] = STATE(5717),
    [sym_attribute_pattern] = STATE(5717),
    [sym_paren_pattern] = STATE(5717),
    [sym_as_pattern] = STATE(5717),
    [sym_cons_pattern] = STATE(5717),
    [sym_disjunct_pattern] = STATE(5717),
    [sym_conjunct_pattern] = STATE(5717),
    [sym_typed_pattern] = STATE(5717),
    [sym_list_pattern] = STATE(5717),
    [sym_array_pattern] = STATE(5717),
    [sym_record_pattern] = STATE(5717),
    [sym_identifier_pattern] = STATE(5717),
    [sym_long_identifier_or_op] = STATE(1820),
    [sym_char] = STATE(5742),
    [sym_format_string] = STATE(5744),
    [sym__string_literal] = STATE(5744),
    [sym_string] = STATE(5742),
    [sym_verbatim_string] = STATE(5742),
    [sym_bytearray] = STATE(5742),
    [sym_verbatim_bytearray] = STATE(5742),
    [sym_format_triple_quoted_string] = STATE(5757),
    [sym_triple_quoted_string] = STATE(5742),
    [sym_const] = STATE(5717),
    [sym_long_identifier] = STATE(3763),
    [sym_active_pattern] = STATE(3905),
    [sym__identifier_or_op] = STATE(3853),
    [sym_sbyte] = STATE(5742),
    [sym_byte] = STATE(5742),
    [sym_int16] = STATE(5742),
    [sym_uint16] = STATE(5742),
    [sym_int32] = STATE(5742),
    [sym_uint32] = STATE(5742),
    [sym_nativeint] = STATE(5742),
    [sym_unativeint] = STATE(5742),
    [sym_int64] = STATE(5742),
    [sym_uint64] = STATE(5742),
    [sym_ieee32] = STATE(5742),
    [sym_ieee64] = STATE(5742),
    [sym_bignum] = STATE(5742),
    [sym_decimal] = STATE(5742),
    [sym_float] = STATE(5398),
    [sym_xml_doc] = STATE(3182),
    [sym_block_comment] = STATE(3182),
    [sym_line_comment] = STATE(3182),
    [sym_compiler_directive_decl] = STATE(3182),
    [sym_fsi_directive_decl] = STATE(3182),
    [sym_preproc_line] = STATE(3182),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4565),
    [anon_sym_null] = ACTIONS(4855),
    [anon_sym__] = ACTIONS(4569),
    [anon_sym_QMARK] = ACTIONS(4571),
    [anon_sym_COLON_QMARK] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [aux_sym_char_token1] = ACTIONS(4857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_AT_DQUOTE] = ACTIONS(4863),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4869),
    [sym_unit] = ACTIONS(4871),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4597),
    [sym_op_identifier] = ACTIONS(4599),
    [sym_int] = ACTIONS(4873),
    [sym_xint] = ACTIONS(4875),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3183] = {
    [sym_xml_doc] = STATE(3183),
    [sym_block_comment] = STATE(3183),
    [sym_line_comment] = STATE(3183),
    [sym_compiler_directive_decl] = STATE(3183),
    [sym_fsi_directive_decl] = STATE(3183),
    [sym_preproc_line] = STATE(3183),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_module] = ACTIONS(5374),
    [anon_sym_open] = ACTIONS(5374),
    [anon_sym_LBRACK_LT] = ACTIONS(5372),
    [anon_sym_return] = ACTIONS(5374),
    [anon_sym_type] = ACTIONS(5374),
    [anon_sym_do] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_let] = ACTIONS(5374),
    [anon_sym_let_BANG] = ACTIONS(5372),
    [aux_sym_access_modifier_token1] = ACTIONS(5372),
    [anon_sym_LPAREN] = ACTIONS(5374),
    [anon_sym_COMMA] = ACTIONS(5516),
    [anon_sym_null] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5372),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_LT_AT] = ACTIONS(5374),
    [anon_sym_LT_AT_AT] = ACTIONS(5372),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5372),
    [anon_sym_new] = ACTIONS(5374),
    [anon_sym_return_BANG] = ACTIONS(5372),
    [anon_sym_yield] = ACTIONS(5374),
    [anon_sym_yield_BANG] = ACTIONS(5372),
    [anon_sym_lazy] = ACTIONS(5374),
    [anon_sym_assert] = ACTIONS(5374),
    [anon_sym_upcast] = ACTIONS(5374),
    [anon_sym_downcast] = ACTIONS(5374),
    [anon_sym_for] = ACTIONS(5374),
    [anon_sym_while] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_fun] = ACTIONS(5374),
    [anon_sym_try] = ACTIONS(5374),
    [anon_sym_match] = ACTIONS(5374),
    [anon_sym_match_BANG] = ACTIONS(5372),
    [anon_sym_function] = ACTIONS(5374),
    [anon_sym_use] = ACTIONS(5374),
    [anon_sym_use_BANG] = ACTIONS(5372),
    [anon_sym_do_BANG] = ACTIONS(5372),
    [anon_sym_begin] = ACTIONS(5374),
    [anon_sym_default] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_member] = ACTIONS(5374),
    [anon_sym_abstract] = ACTIONS(5374),
    [anon_sym_override] = ACTIONS(5374),
    [anon_sym_val] = ACTIONS(5374),
    [aux_sym_char_token1] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5374),
    [anon_sym_DQUOTE] = ACTIONS(5374),
    [anon_sym_AT_DQUOTE] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [sym_bool] = ACTIONS(5374),
    [sym_unit] = ACTIONS(5372),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5374),
    [sym_op_identifier] = ACTIONS(5372),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS_DOT] = ACTIONS(5372),
    [anon_sym_DASH_DOT] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [aux_sym_prefix_op_token1] = ACTIONS(5372),
    [sym_int] = ACTIONS(5374),
    [sym_xint] = ACTIONS(5372),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5372),
    [anon_sym_POUNDload] = ACTIONS(5372),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5372),
    [sym__dedent] = ACTIONS(5372),
  },
  [3184] = {
    [sym_xml_doc] = STATE(3184),
    [sym_block_comment] = STATE(3184),
    [sym_line_comment] = STATE(3184),
    [sym_compiler_directive_decl] = STATE(3184),
    [sym_fsi_directive_decl] = STATE(3184),
    [sym_preproc_line] = STATE(3184),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_module] = ACTIONS(5374),
    [anon_sym_open] = ACTIONS(5374),
    [anon_sym_LBRACK_LT] = ACTIONS(5372),
    [anon_sym_return] = ACTIONS(5374),
    [anon_sym_type] = ACTIONS(5374),
    [anon_sym_do] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_let] = ACTIONS(5374),
    [anon_sym_let_BANG] = ACTIONS(5372),
    [aux_sym_access_modifier_token1] = ACTIONS(5372),
    [anon_sym_LPAREN] = ACTIONS(5374),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_null] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5372),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_LT_AT] = ACTIONS(5374),
    [anon_sym_LT_AT_AT] = ACTIONS(5372),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5372),
    [anon_sym_new] = ACTIONS(5374),
    [anon_sym_return_BANG] = ACTIONS(5372),
    [anon_sym_yield] = ACTIONS(5374),
    [anon_sym_yield_BANG] = ACTIONS(5372),
    [anon_sym_lazy] = ACTIONS(5374),
    [anon_sym_assert] = ACTIONS(5374),
    [anon_sym_upcast] = ACTIONS(5374),
    [anon_sym_downcast] = ACTIONS(5374),
    [anon_sym_for] = ACTIONS(5374),
    [anon_sym_while] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_fun] = ACTIONS(5374),
    [anon_sym_try] = ACTIONS(5374),
    [anon_sym_match] = ACTIONS(5374),
    [anon_sym_match_BANG] = ACTIONS(5372),
    [anon_sym_function] = ACTIONS(5374),
    [anon_sym_use] = ACTIONS(5374),
    [anon_sym_use_BANG] = ACTIONS(5372),
    [anon_sym_do_BANG] = ACTIONS(5372),
    [anon_sym_begin] = ACTIONS(5374),
    [anon_sym_default] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_member] = ACTIONS(5374),
    [anon_sym_abstract] = ACTIONS(5374),
    [anon_sym_override] = ACTIONS(5374),
    [anon_sym_val] = ACTIONS(5374),
    [aux_sym_char_token1] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5374),
    [anon_sym_DQUOTE] = ACTIONS(5374),
    [anon_sym_AT_DQUOTE] = ACTIONS(5372),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5372),
    [sym_bool] = ACTIONS(5374),
    [sym_unit] = ACTIONS(5372),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5374),
    [sym_op_identifier] = ACTIONS(5372),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS_DOT] = ACTIONS(5372),
    [anon_sym_DASH_DOT] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [aux_sym_prefix_op_token1] = ACTIONS(5372),
    [sym_int] = ACTIONS(5374),
    [sym_xint] = ACTIONS(5372),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5372),
    [anon_sym_POUNDload] = ACTIONS(5372),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5372),
    [sym__dedent] = ACTIONS(5372),
  },
  [3185] = {
    [sym_attributes] = STATE(3185),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(3962),
    [sym__pattern] = STATE(3932),
    [sym_optional_pattern] = STATE(3962),
    [sym_type_check_pattern] = STATE(3962),
    [sym_attribute_pattern] = STATE(3962),
    [sym_paren_pattern] = STATE(3962),
    [sym_as_pattern] = STATE(3962),
    [sym_cons_pattern] = STATE(3962),
    [sym_disjunct_pattern] = STATE(3962),
    [sym_conjunct_pattern] = STATE(3962),
    [sym_typed_pattern] = STATE(3962),
    [sym_list_pattern] = STATE(3962),
    [sym_array_pattern] = STATE(3962),
    [sym_record_pattern] = STATE(3962),
    [sym_identifier_pattern] = STATE(3962),
    [sym_long_identifier_or_op] = STATE(2698),
    [sym_char] = STATE(3725),
    [sym_format_string] = STATE(3740),
    [sym__string_literal] = STATE(3740),
    [sym_string] = STATE(3725),
    [sym_verbatim_string] = STATE(3725),
    [sym_bytearray] = STATE(3725),
    [sym_verbatim_bytearray] = STATE(3725),
    [sym_format_triple_quoted_string] = STATE(3687),
    [sym_triple_quoted_string] = STATE(3725),
    [sym_const] = STATE(3962),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(3725),
    [sym_byte] = STATE(3725),
    [sym_int16] = STATE(3725),
    [sym_uint16] = STATE(3725),
    [sym_int32] = STATE(3725),
    [sym_uint32] = STATE(3725),
    [sym_nativeint] = STATE(3725),
    [sym_unativeint] = STATE(3725),
    [sym_int64] = STATE(3725),
    [sym_uint64] = STATE(3725),
    [sym_ieee32] = STATE(3725),
    [sym_ieee64] = STATE(3725),
    [sym_bignum] = STATE(3725),
    [sym_decimal] = STATE(3725),
    [sym_float] = STATE(3624),
    [sym_xml_doc] = STATE(3185),
    [sym_block_comment] = STATE(3185),
    [sym_line_comment] = STATE(3185),
    [sym_compiler_directive_decl] = STATE(3185),
    [sym_fsi_directive_decl] = STATE(3185),
    [sym_preproc_line] = STATE(3185),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_null] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5015),
    [anon_sym_COLON_QMARK] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5021),
    [anon_sym_LBRACE] = ACTIONS(5023),
    [aux_sym_char_token1] = ACTIONS(4653),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4655),
    [anon_sym_DQUOTE] = ACTIONS(4657),
    [anon_sym_AT_DQUOTE] = ACTIONS(4659),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4663),
    [sym_bool] = ACTIONS(4665),
    [sym_unit] = ACTIONS(4667),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4673),
    [sym_xint] = ACTIONS(4675),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3186] = {
    [sym_xml_doc] = STATE(3186),
    [sym_block_comment] = STATE(3186),
    [sym_line_comment] = STATE(3186),
    [sym_compiler_directive_decl] = STATE(3186),
    [sym_fsi_directive_decl] = STATE(3186),
    [sym_preproc_line] = STATE(3186),
    [sym_identifier] = ACTIONS(5368),
    [anon_sym_module] = ACTIONS(5368),
    [anon_sym_open] = ACTIONS(5368),
    [anon_sym_LBRACK_LT] = ACTIONS(5366),
    [anon_sym_return] = ACTIONS(5368),
    [anon_sym_type] = ACTIONS(5368),
    [anon_sym_do] = ACTIONS(5368),
    [anon_sym_and] = ACTIONS(5368),
    [anon_sym_let] = ACTIONS(5368),
    [anon_sym_let_BANG] = ACTIONS(5366),
    [aux_sym_access_modifier_token1] = ACTIONS(5366),
    [anon_sym_LPAREN] = ACTIONS(5368),
    [anon_sym_null] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_LBRACK] = ACTIONS(5368),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5368),
    [anon_sym_LT_AT] = ACTIONS(5368),
    [anon_sym_LT_AT_AT] = ACTIONS(5366),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5366),
    [anon_sym_with] = ACTIONS(5520),
    [anon_sym_new] = ACTIONS(5368),
    [anon_sym_return_BANG] = ACTIONS(5366),
    [anon_sym_yield] = ACTIONS(5368),
    [anon_sym_yield_BANG] = ACTIONS(5366),
    [anon_sym_lazy] = ACTIONS(5368),
    [anon_sym_assert] = ACTIONS(5368),
    [anon_sym_upcast] = ACTIONS(5368),
    [anon_sym_downcast] = ACTIONS(5368),
    [anon_sym_for] = ACTIONS(5368),
    [anon_sym_while] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(5368),
    [anon_sym_fun] = ACTIONS(5368),
    [anon_sym_try] = ACTIONS(5368),
    [anon_sym_match] = ACTIONS(5368),
    [anon_sym_match_BANG] = ACTIONS(5366),
    [anon_sym_function] = ACTIONS(5368),
    [anon_sym_use] = ACTIONS(5368),
    [anon_sym_use_BANG] = ACTIONS(5366),
    [anon_sym_do_BANG] = ACTIONS(5366),
    [anon_sym_begin] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_member] = ACTIONS(5368),
    [anon_sym_abstract] = ACTIONS(5368),
    [anon_sym_override] = ACTIONS(5368),
    [anon_sym_val] = ACTIONS(5368),
    [aux_sym_char_token1] = ACTIONS(5366),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5368),
    [anon_sym_DQUOTE] = ACTIONS(5368),
    [anon_sym_AT_DQUOTE] = ACTIONS(5366),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5366),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5366),
    [sym_bool] = ACTIONS(5368),
    [sym_unit] = ACTIONS(5366),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5368),
    [sym_op_identifier] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_PLUS_DOT] = ACTIONS(5366),
    [anon_sym_DASH_DOT] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5366),
    [anon_sym_AMP_AMP] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(5366),
    [aux_sym_prefix_op_token1] = ACTIONS(5366),
    [sym_int] = ACTIONS(5368),
    [sym_xint] = ACTIONS(5366),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5366),
    [anon_sym_POUNDload] = ACTIONS(5366),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5366),
    [sym__dedent] = ACTIONS(5366),
  },
  [3187] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5867),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3187),
    [sym_block_comment] = STATE(3187),
    [sym_line_comment] = STATE(3187),
    [sym_compiler_directive_decl] = STATE(3187),
    [sym_fsi_directive_decl] = STATE(3187),
    [sym_preproc_line] = STATE(3187),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3188] = {
    [sym_xml_doc] = STATE(3188),
    [sym_block_comment] = STATE(3188),
    [sym_line_comment] = STATE(3188),
    [sym_compiler_directive_decl] = STATE(3188),
    [sym_fsi_directive_decl] = STATE(3188),
    [sym_preproc_line] = STATE(3188),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_open] = ACTIONS(3438),
    [anon_sym_LBRACK_LT] = ACTIONS(3440),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [aux_sym_access_modifier_token1] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [anon_sym_default] = ACTIONS(3438),
    [anon_sym_static] = ACTIONS(3438),
    [anon_sym_member] = ACTIONS(3438),
    [anon_sym_abstract] = ACTIONS(3438),
    [anon_sym_override] = ACTIONS(3438),
    [anon_sym_val] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3440),
    [anon_sym_DASH_DOT] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3440),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3440),
    [anon_sym_POUNDload] = ACTIONS(3440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [sym__dedent] = ACTIONS(3440),
  },
  [3189] = {
    [sym_attributes] = STATE(3040),
    [sym_attribute_set] = STATE(4118),
    [sym_repeat_pattern] = STATE(5168),
    [sym__pattern] = STATE(5859),
    [sym_optional_pattern] = STATE(5168),
    [sym_type_check_pattern] = STATE(5168),
    [sym_attribute_pattern] = STATE(5168),
    [sym_paren_pattern] = STATE(5168),
    [sym_as_pattern] = STATE(5168),
    [sym_cons_pattern] = STATE(5168),
    [sym_disjunct_pattern] = STATE(5168),
    [sym_conjunct_pattern] = STATE(5168),
    [sym_typed_pattern] = STATE(5168),
    [sym_list_pattern] = STATE(5168),
    [sym_array_pattern] = STATE(5168),
    [sym_record_pattern] = STATE(5168),
    [sym_identifier_pattern] = STATE(5168),
    [sym_long_identifier_or_op] = STATE(2316),
    [sym_char] = STATE(5196),
    [sym_format_string] = STATE(5193),
    [sym__string_literal] = STATE(5193),
    [sym_string] = STATE(5196),
    [sym_verbatim_string] = STATE(5196),
    [sym_bytearray] = STATE(5196),
    [sym_verbatim_bytearray] = STATE(5196),
    [sym_format_triple_quoted_string] = STATE(5192),
    [sym_triple_quoted_string] = STATE(5196),
    [sym_const] = STATE(5168),
    [sym_long_identifier] = STATE(3671),
    [sym_active_pattern] = STATE(3736),
    [sym__identifier_or_op] = STATE(3692),
    [sym_sbyte] = STATE(5196),
    [sym_byte] = STATE(5196),
    [sym_int16] = STATE(5196),
    [sym_uint16] = STATE(5196),
    [sym_int32] = STATE(5196),
    [sym_uint32] = STATE(5196),
    [sym_nativeint] = STATE(5196),
    [sym_unativeint] = STATE(5196),
    [sym_int64] = STATE(5196),
    [sym_uint64] = STATE(5196),
    [sym_ieee32] = STATE(5196),
    [sym_ieee64] = STATE(5196),
    [sym_bignum] = STATE(5196),
    [sym_decimal] = STATE(5196),
    [sym_float] = STATE(5049),
    [sym_xml_doc] = STATE(3189),
    [sym_block_comment] = STATE(3189),
    [sym_line_comment] = STATE(3189),
    [sym_compiler_directive_decl] = STATE(3189),
    [sym_fsi_directive_decl] = STATE(3189),
    [sym_preproc_line] = STATE(3189),
    [aux_sym_attributes_repeat1] = STATE(4204),
    [sym_identifier] = ACTIONS(4643),
    [anon_sym_LBRACK_LT] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_null] = ACTIONS(4766),
    [anon_sym__] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4933),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [aux_sym_char_token1] = ACTIONS(4768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_AT_DQUOTE] = ACTIONS(4774),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4778),
    [sym_bool] = ACTIONS(4780),
    [sym_unit] = ACTIONS(4782),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4669),
    [sym_op_identifier] = ACTIONS(4671),
    [sym_int] = ACTIONS(4784),
    [sym_xint] = ACTIONS(4786),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3190] = {
    [sym_xml_doc] = STATE(3190),
    [sym_block_comment] = STATE(3190),
    [sym_line_comment] = STATE(3190),
    [sym_compiler_directive_decl] = STATE(3190),
    [sym_fsi_directive_decl] = STATE(3190),
    [sym_preproc_line] = STATE(3190),
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_module] = ACTIONS(5350),
    [anon_sym_open] = ACTIONS(5350),
    [anon_sym_LBRACK_LT] = ACTIONS(5348),
    [anon_sym_return] = ACTIONS(5350),
    [anon_sym_type] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_let] = ACTIONS(5350),
    [anon_sym_let_BANG] = ACTIONS(5348),
    [aux_sym_access_modifier_token1] = ACTIONS(5348),
    [anon_sym_LPAREN] = ACTIONS(5350),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_null] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5348),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_LT_AT] = ACTIONS(5350),
    [anon_sym_LT_AT_AT] = ACTIONS(5348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5348),
    [anon_sym_new] = ACTIONS(5350),
    [anon_sym_return_BANG] = ACTIONS(5348),
    [anon_sym_yield] = ACTIONS(5350),
    [anon_sym_yield_BANG] = ACTIONS(5348),
    [anon_sym_lazy] = ACTIONS(5350),
    [anon_sym_assert] = ACTIONS(5350),
    [anon_sym_upcast] = ACTIONS(5350),
    [anon_sym_downcast] = ACTIONS(5350),
    [anon_sym_for] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_fun] = ACTIONS(5350),
    [anon_sym_try] = ACTIONS(5350),
    [anon_sym_match] = ACTIONS(5350),
    [anon_sym_match_BANG] = ACTIONS(5348),
    [anon_sym_function] = ACTIONS(5350),
    [anon_sym_use] = ACTIONS(5350),
    [anon_sym_use_BANG] = ACTIONS(5348),
    [anon_sym_do_BANG] = ACTIONS(5348),
    [anon_sym_begin] = ACTIONS(5350),
    [anon_sym_default] = ACTIONS(5350),
    [anon_sym_static] = ACTIONS(5350),
    [anon_sym_member] = ACTIONS(5350),
    [anon_sym_abstract] = ACTIONS(5350),
    [anon_sym_override] = ACTIONS(5350),
    [anon_sym_val] = ACTIONS(5350),
    [aux_sym_char_token1] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5350),
    [anon_sym_DQUOTE] = ACTIONS(5350),
    [anon_sym_AT_DQUOTE] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [sym_bool] = ACTIONS(5350),
    [sym_unit] = ACTIONS(5348),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5350),
    [sym_op_identifier] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS_DOT] = ACTIONS(5348),
    [anon_sym_DASH_DOT] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [aux_sym_prefix_op_token1] = ACTIONS(5348),
    [sym_int] = ACTIONS(5350),
    [sym_xint] = ACTIONS(5348),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5348),
    [anon_sym_POUNDload] = ACTIONS(5348),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5348),
    [sym__dedent] = ACTIONS(5348),
  },
  [3191] = {
    [sym_xml_doc] = STATE(3191),
    [sym_block_comment] = STATE(3191),
    [sym_line_comment] = STATE(3191),
    [sym_compiler_directive_decl] = STATE(3191),
    [sym_fsi_directive_decl] = STATE(3191),
    [sym_preproc_line] = STATE(3191),
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_module] = ACTIONS(5350),
    [anon_sym_open] = ACTIONS(5350),
    [anon_sym_LBRACK_LT] = ACTIONS(5348),
    [anon_sym_return] = ACTIONS(5350),
    [anon_sym_type] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_let] = ACTIONS(5350),
    [anon_sym_let_BANG] = ACTIONS(5348),
    [aux_sym_access_modifier_token1] = ACTIONS(5348),
    [anon_sym_LPAREN] = ACTIONS(5350),
    [anon_sym_COMMA] = ACTIONS(5524),
    [anon_sym_null] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5348),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_LT_AT] = ACTIONS(5350),
    [anon_sym_LT_AT_AT] = ACTIONS(5348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5348),
    [anon_sym_new] = ACTIONS(5350),
    [anon_sym_return_BANG] = ACTIONS(5348),
    [anon_sym_yield] = ACTIONS(5350),
    [anon_sym_yield_BANG] = ACTIONS(5348),
    [anon_sym_lazy] = ACTIONS(5350),
    [anon_sym_assert] = ACTIONS(5350),
    [anon_sym_upcast] = ACTIONS(5350),
    [anon_sym_downcast] = ACTIONS(5350),
    [anon_sym_for] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_fun] = ACTIONS(5350),
    [anon_sym_try] = ACTIONS(5350),
    [anon_sym_match] = ACTIONS(5350),
    [anon_sym_match_BANG] = ACTIONS(5348),
    [anon_sym_function] = ACTIONS(5350),
    [anon_sym_use] = ACTIONS(5350),
    [anon_sym_use_BANG] = ACTIONS(5348),
    [anon_sym_do_BANG] = ACTIONS(5348),
    [anon_sym_begin] = ACTIONS(5350),
    [anon_sym_default] = ACTIONS(5350),
    [anon_sym_static] = ACTIONS(5350),
    [anon_sym_member] = ACTIONS(5350),
    [anon_sym_abstract] = ACTIONS(5350),
    [anon_sym_override] = ACTIONS(5350),
    [anon_sym_val] = ACTIONS(5350),
    [aux_sym_char_token1] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5350),
    [anon_sym_DQUOTE] = ACTIONS(5350),
    [anon_sym_AT_DQUOTE] = ACTIONS(5348),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5348),
    [sym_bool] = ACTIONS(5350),
    [sym_unit] = ACTIONS(5348),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5350),
    [sym_op_identifier] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS_DOT] = ACTIONS(5348),
    [anon_sym_DASH_DOT] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [aux_sym_prefix_op_token1] = ACTIONS(5348),
    [sym_int] = ACTIONS(5350),
    [sym_xint] = ACTIONS(5348),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5348),
    [anon_sym_POUNDload] = ACTIONS(5348),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5348),
    [sym__dedent] = ACTIONS(5348),
  },
  [3192] = {
    [sym_xml_doc] = STATE(3192),
    [sym_block_comment] = STATE(3192),
    [sym_line_comment] = STATE(3192),
    [sym_compiler_directive_decl] = STATE(3192),
    [sym_fsi_directive_decl] = STATE(3192),
    [sym_preproc_line] = STATE(3192),
    [sym_identifier] = ACTIONS(5442),
    [anon_sym_module] = ACTIONS(5442),
    [anon_sym_open] = ACTIONS(5442),
    [anon_sym_LBRACK_LT] = ACTIONS(5440),
    [anon_sym_return] = ACTIONS(5442),
    [anon_sym_type] = ACTIONS(5442),
    [anon_sym_do] = ACTIONS(5442),
    [anon_sym_and] = ACTIONS(5442),
    [anon_sym_let] = ACTIONS(5442),
    [anon_sym_let_BANG] = ACTIONS(5440),
    [aux_sym_access_modifier_token1] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5442),
    [anon_sym_null] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LBRACK] = ACTIONS(5442),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(5442),
    [anon_sym_LT_AT] = ACTIONS(5442),
    [anon_sym_LT_AT_AT] = ACTIONS(5440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5440),
    [anon_sym_new] = ACTIONS(5442),
    [anon_sym_return_BANG] = ACTIONS(5440),
    [anon_sym_yield] = ACTIONS(5442),
    [anon_sym_yield_BANG] = ACTIONS(5440),
    [anon_sym_lazy] = ACTIONS(5442),
    [anon_sym_assert] = ACTIONS(5442),
    [anon_sym_upcast] = ACTIONS(5442),
    [anon_sym_downcast] = ACTIONS(5442),
    [anon_sym_for] = ACTIONS(5442),
    [anon_sym_while] = ACTIONS(5442),
    [anon_sym_if] = ACTIONS(5442),
    [anon_sym_fun] = ACTIONS(5442),
    [anon_sym_try] = ACTIONS(5442),
    [anon_sym_match] = ACTIONS(5442),
    [anon_sym_match_BANG] = ACTIONS(5440),
    [anon_sym_function] = ACTIONS(5442),
    [anon_sym_use] = ACTIONS(5442),
    [anon_sym_use_BANG] = ACTIONS(5440),
    [anon_sym_do_BANG] = ACTIONS(5440),
    [anon_sym_begin] = ACTIONS(5442),
    [anon_sym_default] = ACTIONS(5442),
    [anon_sym_static] = ACTIONS(5442),
    [anon_sym_member] = ACTIONS(5442),
    [anon_sym_abstract] = ACTIONS(5442),
    [anon_sym_override] = ACTIONS(5442),
    [anon_sym_val] = ACTIONS(5442),
    [aux_sym_char_token1] = ACTIONS(5440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5442),
    [anon_sym_DQUOTE] = ACTIONS(5442),
    [anon_sym_AT_DQUOTE] = ACTIONS(5440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5440),
    [sym_bool] = ACTIONS(5442),
    [sym_unit] = ACTIONS(5440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5442),
    [sym_op_identifier] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS_DOT] = ACTIONS(5440),
    [anon_sym_DASH_DOT] = ACTIONS(5440),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_TILDE] = ACTIONS(5440),
    [aux_sym_prefix_op_token1] = ACTIONS(5440),
    [sym_int] = ACTIONS(5442),
    [sym_xint] = ACTIONS(5440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5440),
    [anon_sym_POUNDload] = ACTIONS(5440),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5440),
    [sym__dedent] = ACTIONS(5440),
  },
  [3193] = {
    [sym_xml_doc] = STATE(3193),
    [sym_block_comment] = STATE(3193),
    [sym_line_comment] = STATE(3193),
    [sym_compiler_directive_decl] = STATE(3193),
    [sym_fsi_directive_decl] = STATE(3193),
    [sym_preproc_line] = STATE(3193),
    [sym_identifier] = ACTIONS(5438),
    [anon_sym_module] = ACTIONS(5438),
    [anon_sym_open] = ACTIONS(5438),
    [anon_sym_LBRACK_LT] = ACTIONS(5436),
    [anon_sym_return] = ACTIONS(5438),
    [anon_sym_type] = ACTIONS(5438),
    [anon_sym_do] = ACTIONS(5438),
    [anon_sym_and] = ACTIONS(5438),
    [anon_sym_let] = ACTIONS(5438),
    [anon_sym_let_BANG] = ACTIONS(5436),
    [aux_sym_access_modifier_token1] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5438),
    [anon_sym_null] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_LBRACK] = ACTIONS(5438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5438),
    [anon_sym_LT_AT] = ACTIONS(5438),
    [anon_sym_LT_AT_AT] = ACTIONS(5436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5436),
    [anon_sym_new] = ACTIONS(5438),
    [anon_sym_return_BANG] = ACTIONS(5436),
    [anon_sym_yield] = ACTIONS(5438),
    [anon_sym_yield_BANG] = ACTIONS(5436),
    [anon_sym_lazy] = ACTIONS(5438),
    [anon_sym_assert] = ACTIONS(5438),
    [anon_sym_upcast] = ACTIONS(5438),
    [anon_sym_downcast] = ACTIONS(5438),
    [anon_sym_for] = ACTIONS(5438),
    [anon_sym_while] = ACTIONS(5438),
    [anon_sym_if] = ACTIONS(5438),
    [anon_sym_fun] = ACTIONS(5438),
    [anon_sym_try] = ACTIONS(5438),
    [anon_sym_match] = ACTIONS(5438),
    [anon_sym_match_BANG] = ACTIONS(5436),
    [anon_sym_function] = ACTIONS(5438),
    [anon_sym_use] = ACTIONS(5438),
    [anon_sym_use_BANG] = ACTIONS(5436),
    [anon_sym_do_BANG] = ACTIONS(5436),
    [anon_sym_begin] = ACTIONS(5438),
    [anon_sym_default] = ACTIONS(5438),
    [anon_sym_static] = ACTIONS(5438),
    [anon_sym_member] = ACTIONS(5438),
    [anon_sym_abstract] = ACTIONS(5438),
    [anon_sym_override] = ACTIONS(5438),
    [anon_sym_val] = ACTIONS(5438),
    [aux_sym_char_token1] = ACTIONS(5436),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5438),
    [anon_sym_DQUOTE] = ACTIONS(5438),
    [anon_sym_AT_DQUOTE] = ACTIONS(5436),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5436),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5436),
    [sym_bool] = ACTIONS(5438),
    [sym_unit] = ACTIONS(5436),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5438),
    [sym_op_identifier] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_PLUS_DOT] = ACTIONS(5436),
    [anon_sym_DASH_DOT] = ACTIONS(5436),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_TILDE] = ACTIONS(5436),
    [aux_sym_prefix_op_token1] = ACTIONS(5436),
    [sym_int] = ACTIONS(5438),
    [sym_xint] = ACTIONS(5436),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5436),
    [anon_sym_POUNDload] = ACTIONS(5436),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5436),
    [sym__dedent] = ACTIONS(5436),
  },
  [3194] = {
    [sym_xml_doc] = STATE(3194),
    [sym_block_comment] = STATE(3194),
    [sym_line_comment] = STATE(3194),
    [sym_compiler_directive_decl] = STATE(3194),
    [sym_fsi_directive_decl] = STATE(3194),
    [sym_preproc_line] = STATE(3194),
    [sym_identifier] = ACTIONS(5464),
    [anon_sym_module] = ACTIONS(5464),
    [anon_sym_open] = ACTIONS(5464),
    [anon_sym_LBRACK_LT] = ACTIONS(5462),
    [anon_sym_return] = ACTIONS(5464),
    [anon_sym_type] = ACTIONS(5464),
    [anon_sym_do] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_let_BANG] = ACTIONS(5462),
    [aux_sym_access_modifier_token1] = ACTIONS(5462),
    [anon_sym_LPAREN] = ACTIONS(5464),
    [anon_sym_null] = ACTIONS(5464),
    [anon_sym_AMP] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5462),
    [anon_sym_LBRACE] = ACTIONS(5464),
    [anon_sym_LT_AT] = ACTIONS(5464),
    [anon_sym_LT_AT_AT] = ACTIONS(5462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5462),
    [anon_sym_new] = ACTIONS(5464),
    [anon_sym_return_BANG] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(5464),
    [anon_sym_yield_BANG] = ACTIONS(5462),
    [anon_sym_lazy] = ACTIONS(5464),
    [anon_sym_assert] = ACTIONS(5464),
    [anon_sym_upcast] = ACTIONS(5464),
    [anon_sym_downcast] = ACTIONS(5464),
    [anon_sym_for] = ACTIONS(5464),
    [anon_sym_while] = ACTIONS(5464),
    [anon_sym_if] = ACTIONS(5464),
    [anon_sym_fun] = ACTIONS(5464),
    [anon_sym_try] = ACTIONS(5464),
    [anon_sym_match] = ACTIONS(5464),
    [anon_sym_match_BANG] = ACTIONS(5462),
    [anon_sym_function] = ACTIONS(5464),
    [anon_sym_use] = ACTIONS(5464),
    [anon_sym_use_BANG] = ACTIONS(5462),
    [anon_sym_do_BANG] = ACTIONS(5462),
    [anon_sym_begin] = ACTIONS(5464),
    [anon_sym_default] = ACTIONS(5464),
    [anon_sym_static] = ACTIONS(5464),
    [anon_sym_member] = ACTIONS(5464),
    [anon_sym_abstract] = ACTIONS(5464),
    [anon_sym_override] = ACTIONS(5464),
    [anon_sym_val] = ACTIONS(5464),
    [aux_sym_char_token1] = ACTIONS(5462),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(5464),
    [anon_sym_AT_DQUOTE] = ACTIONS(5462),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5462),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5462),
    [sym_bool] = ACTIONS(5464),
    [sym_unit] = ACTIONS(5462),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5464),
    [sym_op_identifier] = ACTIONS(5462),
    [anon_sym_PLUS] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5464),
    [anon_sym_PLUS_DOT] = ACTIONS(5462),
    [anon_sym_DASH_DOT] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(5462),
    [aux_sym_prefix_op_token1] = ACTIONS(5462),
    [sym_int] = ACTIONS(5464),
    [sym_xint] = ACTIONS(5462),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5462),
    [anon_sym_POUNDload] = ACTIONS(5462),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5462),
    [sym__dedent] = ACTIONS(5462),
  },
  [3195] = {
    [sym_xml_doc] = STATE(3195),
    [sym_block_comment] = STATE(3195),
    [sym_line_comment] = STATE(3195),
    [sym_compiler_directive_decl] = STATE(3195),
    [sym_fsi_directive_decl] = STATE(3195),
    [sym_preproc_line] = STATE(3195),
    [sym_identifier] = ACTIONS(5131),
    [anon_sym_module] = ACTIONS(5131),
    [anon_sym_open] = ACTIONS(5131),
    [anon_sym_LBRACK_LT] = ACTIONS(5129),
    [anon_sym_return] = ACTIONS(5131),
    [anon_sym_type] = ACTIONS(5131),
    [anon_sym_do] = ACTIONS(5131),
    [anon_sym_and] = ACTIONS(5131),
    [anon_sym_let] = ACTIONS(5131),
    [anon_sym_let_BANG] = ACTIONS(5129),
    [aux_sym_access_modifier_token1] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5131),
    [anon_sym_null] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5131),
    [anon_sym_LT_AT] = ACTIONS(5131),
    [anon_sym_LT_AT_AT] = ACTIONS(5129),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5129),
    [anon_sym_new] = ACTIONS(5131),
    [anon_sym_return_BANG] = ACTIONS(5129),
    [anon_sym_yield] = ACTIONS(5131),
    [anon_sym_yield_BANG] = ACTIONS(5129),
    [anon_sym_lazy] = ACTIONS(5131),
    [anon_sym_assert] = ACTIONS(5131),
    [anon_sym_upcast] = ACTIONS(5131),
    [anon_sym_downcast] = ACTIONS(5131),
    [anon_sym_for] = ACTIONS(5131),
    [anon_sym_while] = ACTIONS(5131),
    [anon_sym_if] = ACTIONS(5131),
    [anon_sym_fun] = ACTIONS(5131),
    [anon_sym_try] = ACTIONS(5131),
    [anon_sym_match] = ACTIONS(5131),
    [anon_sym_match_BANG] = ACTIONS(5129),
    [anon_sym_function] = ACTIONS(5131),
    [anon_sym_use] = ACTIONS(5131),
    [anon_sym_use_BANG] = ACTIONS(5129),
    [anon_sym_do_BANG] = ACTIONS(5129),
    [anon_sym_begin] = ACTIONS(5131),
    [anon_sym_default] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_member] = ACTIONS(5131),
    [anon_sym_abstract] = ACTIONS(5131),
    [anon_sym_override] = ACTIONS(5131),
    [anon_sym_val] = ACTIONS(5131),
    [aux_sym_char_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [anon_sym_AT_DQUOTE] = ACTIONS(5129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5129),
    [sym_bool] = ACTIONS(5131),
    [sym_unit] = ACTIONS(5129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5131),
    [sym_op_identifier] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_DOT] = ACTIONS(5129),
    [anon_sym_DASH_DOT] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [aux_sym_prefix_op_token1] = ACTIONS(5129),
    [sym_int] = ACTIONS(5131),
    [sym_xint] = ACTIONS(5129),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5129),
    [anon_sym_POUNDload] = ACTIONS(5129),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5129),
    [sym__dedent] = ACTIONS(5129),
  },
  [3196] = {
    [sym_xml_doc] = STATE(3196),
    [sym_block_comment] = STATE(3196),
    [sym_line_comment] = STATE(3196),
    [sym_compiler_directive_decl] = STATE(3196),
    [sym_fsi_directive_decl] = STATE(3196),
    [sym_preproc_line] = STATE(3196),
    [sym_identifier] = ACTIONS(5480),
    [anon_sym_module] = ACTIONS(5480),
    [anon_sym_open] = ACTIONS(5480),
    [anon_sym_LBRACK_LT] = ACTIONS(5478),
    [anon_sym_return] = ACTIONS(5480),
    [anon_sym_type] = ACTIONS(5480),
    [anon_sym_do] = ACTIONS(5480),
    [anon_sym_and] = ACTIONS(5480),
    [anon_sym_let] = ACTIONS(5480),
    [anon_sym_let_BANG] = ACTIONS(5478),
    [aux_sym_access_modifier_token1] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(5480),
    [anon_sym_null] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5478),
    [anon_sym_LBRACE] = ACTIONS(5480),
    [anon_sym_LT_AT] = ACTIONS(5480),
    [anon_sym_LT_AT_AT] = ACTIONS(5478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5478),
    [anon_sym_new] = ACTIONS(5480),
    [anon_sym_return_BANG] = ACTIONS(5478),
    [anon_sym_yield] = ACTIONS(5480),
    [anon_sym_yield_BANG] = ACTIONS(5478),
    [anon_sym_lazy] = ACTIONS(5480),
    [anon_sym_assert] = ACTIONS(5480),
    [anon_sym_upcast] = ACTIONS(5480),
    [anon_sym_downcast] = ACTIONS(5480),
    [anon_sym_for] = ACTIONS(5480),
    [anon_sym_while] = ACTIONS(5480),
    [anon_sym_if] = ACTIONS(5480),
    [anon_sym_fun] = ACTIONS(5480),
    [anon_sym_try] = ACTIONS(5480),
    [anon_sym_match] = ACTIONS(5480),
    [anon_sym_match_BANG] = ACTIONS(5478),
    [anon_sym_function] = ACTIONS(5480),
    [anon_sym_use] = ACTIONS(5480),
    [anon_sym_use_BANG] = ACTIONS(5478),
    [anon_sym_do_BANG] = ACTIONS(5478),
    [anon_sym_begin] = ACTIONS(5480),
    [anon_sym_default] = ACTIONS(5480),
    [anon_sym_static] = ACTIONS(5480),
    [anon_sym_member] = ACTIONS(5480),
    [anon_sym_abstract] = ACTIONS(5480),
    [anon_sym_override] = ACTIONS(5480),
    [anon_sym_val] = ACTIONS(5480),
    [aux_sym_char_token1] = ACTIONS(5478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(5480),
    [anon_sym_AT_DQUOTE] = ACTIONS(5478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5478),
    [sym_bool] = ACTIONS(5480),
    [sym_unit] = ACTIONS(5478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5480),
    [sym_op_identifier] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5480),
    [anon_sym_PLUS_DOT] = ACTIONS(5478),
    [anon_sym_DASH_DOT] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(5478),
    [anon_sym_TILDE] = ACTIONS(5478),
    [aux_sym_prefix_op_token1] = ACTIONS(5478),
    [sym_int] = ACTIONS(5480),
    [sym_xint] = ACTIONS(5478),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5478),
    [anon_sym_POUNDload] = ACTIONS(5478),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5478),
    [sym__dedent] = ACTIONS(5478),
  },
  [3197] = {
    [sym_xml_doc] = STATE(3197),
    [sym_block_comment] = STATE(3197),
    [sym_line_comment] = STATE(3197),
    [sym_compiler_directive_decl] = STATE(3197),
    [sym_fsi_directive_decl] = STATE(3197),
    [sym_preproc_line] = STATE(3197),
    [sym_identifier] = ACTIONS(5079),
    [anon_sym_module] = ACTIONS(5079),
    [anon_sym_open] = ACTIONS(5079),
    [anon_sym_LBRACK_LT] = ACTIONS(5077),
    [anon_sym_return] = ACTIONS(5079),
    [anon_sym_type] = ACTIONS(5079),
    [anon_sym_do] = ACTIONS(5079),
    [anon_sym_and] = ACTIONS(5079),
    [anon_sym_let] = ACTIONS(5079),
    [anon_sym_let_BANG] = ACTIONS(5077),
    [aux_sym_access_modifier_token1] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(5079),
    [anon_sym_null] = ACTIONS(5079),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5077),
    [anon_sym_LBRACE] = ACTIONS(5079),
    [anon_sym_LT_AT] = ACTIONS(5079),
    [anon_sym_LT_AT_AT] = ACTIONS(5077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5077),
    [anon_sym_new] = ACTIONS(5079),
    [anon_sym_return_BANG] = ACTIONS(5077),
    [anon_sym_yield] = ACTIONS(5079),
    [anon_sym_yield_BANG] = ACTIONS(5077),
    [anon_sym_lazy] = ACTIONS(5079),
    [anon_sym_assert] = ACTIONS(5079),
    [anon_sym_upcast] = ACTIONS(5079),
    [anon_sym_downcast] = ACTIONS(5079),
    [anon_sym_for] = ACTIONS(5079),
    [anon_sym_while] = ACTIONS(5079),
    [anon_sym_if] = ACTIONS(5079),
    [anon_sym_fun] = ACTIONS(5079),
    [anon_sym_try] = ACTIONS(5079),
    [anon_sym_match] = ACTIONS(5079),
    [anon_sym_match_BANG] = ACTIONS(5077),
    [anon_sym_function] = ACTIONS(5079),
    [anon_sym_use] = ACTIONS(5079),
    [anon_sym_use_BANG] = ACTIONS(5077),
    [anon_sym_do_BANG] = ACTIONS(5077),
    [anon_sym_begin] = ACTIONS(5079),
    [anon_sym_default] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_member] = ACTIONS(5079),
    [anon_sym_abstract] = ACTIONS(5079),
    [anon_sym_override] = ACTIONS(5079),
    [anon_sym_val] = ACTIONS(5079),
    [aux_sym_char_token1] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5079),
    [anon_sym_DQUOTE] = ACTIONS(5079),
    [anon_sym_AT_DQUOTE] = ACTIONS(5077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5077),
    [sym_bool] = ACTIONS(5079),
    [sym_unit] = ACTIONS(5077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5079),
    [sym_op_identifier] = ACTIONS(5077),
    [anon_sym_PLUS] = ACTIONS(5079),
    [anon_sym_DASH] = ACTIONS(5079),
    [anon_sym_PLUS_DOT] = ACTIONS(5077),
    [anon_sym_DASH_DOT] = ACTIONS(5077),
    [anon_sym_PERCENT] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [aux_sym_prefix_op_token1] = ACTIONS(5077),
    [sym_int] = ACTIONS(5079),
    [sym_xint] = ACTIONS(5077),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5077),
    [anon_sym_POUNDload] = ACTIONS(5077),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5077),
    [sym__dedent] = ACTIONS(5077),
  },
  [3198] = {
    [sym_xml_doc] = STATE(3198),
    [sym_block_comment] = STATE(3198),
    [sym_line_comment] = STATE(3198),
    [sym_compiler_directive_decl] = STATE(3198),
    [sym_fsi_directive_decl] = STATE(3198),
    [sym_preproc_line] = STATE(3198),
    [sym_identifier] = ACTIONS(5488),
    [anon_sym_module] = ACTIONS(5488),
    [anon_sym_open] = ACTIONS(5488),
    [anon_sym_LBRACK_LT] = ACTIONS(5486),
    [anon_sym_return] = ACTIONS(5488),
    [anon_sym_type] = ACTIONS(5488),
    [anon_sym_do] = ACTIONS(5488),
    [anon_sym_and] = ACTIONS(5488),
    [anon_sym_let] = ACTIONS(5488),
    [anon_sym_let_BANG] = ACTIONS(5486),
    [aux_sym_access_modifier_token1] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_null] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5486),
    [anon_sym_LBRACE] = ACTIONS(5488),
    [anon_sym_LT_AT] = ACTIONS(5488),
    [anon_sym_LT_AT_AT] = ACTIONS(5486),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5486),
    [anon_sym_new] = ACTIONS(5488),
    [anon_sym_return_BANG] = ACTIONS(5486),
    [anon_sym_yield] = ACTIONS(5488),
    [anon_sym_yield_BANG] = ACTIONS(5486),
    [anon_sym_lazy] = ACTIONS(5488),
    [anon_sym_assert] = ACTIONS(5488),
    [anon_sym_upcast] = ACTIONS(5488),
    [anon_sym_downcast] = ACTIONS(5488),
    [anon_sym_for] = ACTIONS(5488),
    [anon_sym_while] = ACTIONS(5488),
    [anon_sym_if] = ACTIONS(5488),
    [anon_sym_fun] = ACTIONS(5488),
    [anon_sym_try] = ACTIONS(5488),
    [anon_sym_match] = ACTIONS(5488),
    [anon_sym_match_BANG] = ACTIONS(5486),
    [anon_sym_function] = ACTIONS(5488),
    [anon_sym_use] = ACTIONS(5488),
    [anon_sym_use_BANG] = ACTIONS(5486),
    [anon_sym_do_BANG] = ACTIONS(5486),
    [anon_sym_begin] = ACTIONS(5488),
    [anon_sym_default] = ACTIONS(5488),
    [anon_sym_static] = ACTIONS(5488),
    [anon_sym_member] = ACTIONS(5488),
    [anon_sym_abstract] = ACTIONS(5488),
    [anon_sym_override] = ACTIONS(5488),
    [anon_sym_val] = ACTIONS(5488),
    [aux_sym_char_token1] = ACTIONS(5486),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5488),
    [anon_sym_DQUOTE] = ACTIONS(5488),
    [anon_sym_AT_DQUOTE] = ACTIONS(5486),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5486),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5486),
    [sym_bool] = ACTIONS(5488),
    [sym_unit] = ACTIONS(5486),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5488),
    [sym_op_identifier] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_PLUS_DOT] = ACTIONS(5486),
    [anon_sym_DASH_DOT] = ACTIONS(5486),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_TILDE] = ACTIONS(5486),
    [aux_sym_prefix_op_token1] = ACTIONS(5486),
    [sym_int] = ACTIONS(5488),
    [sym_xint] = ACTIONS(5486),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5486),
    [anon_sym_POUNDload] = ACTIONS(5486),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5486),
    [sym__dedent] = ACTIONS(5486),
  },
  [3199] = {
    [sym_xml_doc] = STATE(3199),
    [sym_block_comment] = STATE(3199),
    [sym_line_comment] = STATE(3199),
    [sym_compiler_directive_decl] = STATE(3199),
    [sym_fsi_directive_decl] = STATE(3199),
    [sym_preproc_line] = STATE(3199),
    [sym_identifier] = ACTIONS(5400),
    [anon_sym_module] = ACTIONS(5400),
    [anon_sym_open] = ACTIONS(5400),
    [anon_sym_LBRACK_LT] = ACTIONS(5398),
    [anon_sym_return] = ACTIONS(5400),
    [anon_sym_type] = ACTIONS(5400),
    [anon_sym_do] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_let] = ACTIONS(5400),
    [anon_sym_let_BANG] = ACTIONS(5398),
    [aux_sym_access_modifier_token1] = ACTIONS(5398),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_null] = ACTIONS(5400),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5398),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_LT_AT] = ACTIONS(5400),
    [anon_sym_LT_AT_AT] = ACTIONS(5398),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5398),
    [anon_sym_new] = ACTIONS(5400),
    [anon_sym_return_BANG] = ACTIONS(5398),
    [anon_sym_yield] = ACTIONS(5400),
    [anon_sym_yield_BANG] = ACTIONS(5398),
    [anon_sym_lazy] = ACTIONS(5400),
    [anon_sym_assert] = ACTIONS(5400),
    [anon_sym_upcast] = ACTIONS(5400),
    [anon_sym_downcast] = ACTIONS(5400),
    [anon_sym_for] = ACTIONS(5400),
    [anon_sym_while] = ACTIONS(5400),
    [anon_sym_if] = ACTIONS(5400),
    [anon_sym_fun] = ACTIONS(5400),
    [anon_sym_try] = ACTIONS(5400),
    [anon_sym_match] = ACTIONS(5400),
    [anon_sym_match_BANG] = ACTIONS(5398),
    [anon_sym_function] = ACTIONS(5400),
    [anon_sym_use] = ACTIONS(5400),
    [anon_sym_use_BANG] = ACTIONS(5398),
    [anon_sym_do_BANG] = ACTIONS(5398),
    [anon_sym_begin] = ACTIONS(5400),
    [anon_sym_default] = ACTIONS(5400),
    [anon_sym_static] = ACTIONS(5400),
    [anon_sym_member] = ACTIONS(5400),
    [anon_sym_abstract] = ACTIONS(5400),
    [anon_sym_override] = ACTIONS(5400),
    [anon_sym_val] = ACTIONS(5400),
    [aux_sym_char_token1] = ACTIONS(5398),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5400),
    [anon_sym_DQUOTE] = ACTIONS(5400),
    [anon_sym_AT_DQUOTE] = ACTIONS(5398),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5398),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5398),
    [sym_bool] = ACTIONS(5400),
    [sym_unit] = ACTIONS(5398),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5400),
    [sym_op_identifier] = ACTIONS(5398),
    [anon_sym_PLUS] = ACTIONS(5400),
    [anon_sym_DASH] = ACTIONS(5400),
    [anon_sym_PLUS_DOT] = ACTIONS(5398),
    [anon_sym_DASH_DOT] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_AMP_AMP] = ACTIONS(5398),
    [anon_sym_TILDE] = ACTIONS(5398),
    [aux_sym_prefix_op_token1] = ACTIONS(5398),
    [sym_int] = ACTIONS(5400),
    [sym_xint] = ACTIONS(5398),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5398),
    [anon_sym_POUNDload] = ACTIONS(5398),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5398),
    [sym__dedent] = ACTIONS(5398),
  },
  [3200] = {
    [sym_xml_doc] = STATE(3200),
    [sym_block_comment] = STATE(3200),
    [sym_line_comment] = STATE(3200),
    [sym_compiler_directive_decl] = STATE(3200),
    [sym_fsi_directive_decl] = STATE(3200),
    [sym_preproc_line] = STATE(3200),
    [sym_identifier] = ACTIONS(5396),
    [anon_sym_module] = ACTIONS(5396),
    [anon_sym_open] = ACTIONS(5396),
    [anon_sym_LBRACK_LT] = ACTIONS(5394),
    [anon_sym_return] = ACTIONS(5396),
    [anon_sym_type] = ACTIONS(5396),
    [anon_sym_do] = ACTIONS(5396),
    [anon_sym_and] = ACTIONS(5396),
    [anon_sym_let] = ACTIONS(5396),
    [anon_sym_let_BANG] = ACTIONS(5394),
    [aux_sym_access_modifier_token1] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_null] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5394),
    [anon_sym_LBRACE] = ACTIONS(5396),
    [anon_sym_LT_AT] = ACTIONS(5396),
    [anon_sym_LT_AT_AT] = ACTIONS(5394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5394),
    [anon_sym_new] = ACTIONS(5396),
    [anon_sym_return_BANG] = ACTIONS(5394),
    [anon_sym_yield] = ACTIONS(5396),
    [anon_sym_yield_BANG] = ACTIONS(5394),
    [anon_sym_lazy] = ACTIONS(5396),
    [anon_sym_assert] = ACTIONS(5396),
    [anon_sym_upcast] = ACTIONS(5396),
    [anon_sym_downcast] = ACTIONS(5396),
    [anon_sym_for] = ACTIONS(5396),
    [anon_sym_while] = ACTIONS(5396),
    [anon_sym_if] = ACTIONS(5396),
    [anon_sym_fun] = ACTIONS(5396),
    [anon_sym_try] = ACTIONS(5396),
    [anon_sym_match] = ACTIONS(5396),
    [anon_sym_match_BANG] = ACTIONS(5394),
    [anon_sym_function] = ACTIONS(5396),
    [anon_sym_use] = ACTIONS(5396),
    [anon_sym_use_BANG] = ACTIONS(5394),
    [anon_sym_do_BANG] = ACTIONS(5394),
    [anon_sym_begin] = ACTIONS(5396),
    [anon_sym_default] = ACTIONS(5396),
    [anon_sym_static] = ACTIONS(5396),
    [anon_sym_member] = ACTIONS(5396),
    [anon_sym_abstract] = ACTIONS(5396),
    [anon_sym_override] = ACTIONS(5396),
    [anon_sym_val] = ACTIONS(5396),
    [aux_sym_char_token1] = ACTIONS(5394),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5396),
    [anon_sym_DQUOTE] = ACTIONS(5396),
    [anon_sym_AT_DQUOTE] = ACTIONS(5394),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5394),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5394),
    [sym_bool] = ACTIONS(5396),
    [sym_unit] = ACTIONS(5394),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5396),
    [sym_op_identifier] = ACTIONS(5394),
    [anon_sym_PLUS] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5396),
    [anon_sym_PLUS_DOT] = ACTIONS(5394),
    [anon_sym_DASH_DOT] = ACTIONS(5394),
    [anon_sym_PERCENT] = ACTIONS(5394),
    [anon_sym_AMP_AMP] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5394),
    [aux_sym_prefix_op_token1] = ACTIONS(5394),
    [sym_int] = ACTIONS(5396),
    [sym_xint] = ACTIONS(5394),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5394),
    [anon_sym_POUNDload] = ACTIONS(5394),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5394),
    [sym__dedent] = ACTIONS(5394),
  },
  [3201] = {
    [sym_xml_doc] = STATE(3201),
    [sym_block_comment] = STATE(3201),
    [sym_line_comment] = STATE(3201),
    [sym_compiler_directive_decl] = STATE(3201),
    [sym_fsi_directive_decl] = STATE(3201),
    [sym_preproc_line] = STATE(3201),
    [sym_identifier] = ACTIONS(5392),
    [anon_sym_module] = ACTIONS(5392),
    [anon_sym_open] = ACTIONS(5392),
    [anon_sym_LBRACK_LT] = ACTIONS(5390),
    [anon_sym_return] = ACTIONS(5392),
    [anon_sym_type] = ACTIONS(5392),
    [anon_sym_do] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_let] = ACTIONS(5392),
    [anon_sym_let_BANG] = ACTIONS(5390),
    [aux_sym_access_modifier_token1] = ACTIONS(5390),
    [anon_sym_LPAREN] = ACTIONS(5392),
    [anon_sym_null] = ACTIONS(5392),
    [anon_sym_AMP] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(5392),
    [anon_sym_LT_AT] = ACTIONS(5392),
    [anon_sym_LT_AT_AT] = ACTIONS(5390),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5390),
    [anon_sym_new] = ACTIONS(5392),
    [anon_sym_return_BANG] = ACTIONS(5390),
    [anon_sym_yield] = ACTIONS(5392),
    [anon_sym_yield_BANG] = ACTIONS(5390),
    [anon_sym_lazy] = ACTIONS(5392),
    [anon_sym_assert] = ACTIONS(5392),
    [anon_sym_upcast] = ACTIONS(5392),
    [anon_sym_downcast] = ACTIONS(5392),
    [anon_sym_for] = ACTIONS(5392),
    [anon_sym_while] = ACTIONS(5392),
    [anon_sym_if] = ACTIONS(5392),
    [anon_sym_fun] = ACTIONS(5392),
    [anon_sym_try] = ACTIONS(5392),
    [anon_sym_match] = ACTIONS(5392),
    [anon_sym_match_BANG] = ACTIONS(5390),
    [anon_sym_function] = ACTIONS(5392),
    [anon_sym_use] = ACTIONS(5392),
    [anon_sym_use_BANG] = ACTIONS(5390),
    [anon_sym_do_BANG] = ACTIONS(5390),
    [anon_sym_begin] = ACTIONS(5392),
    [anon_sym_default] = ACTIONS(5392),
    [anon_sym_static] = ACTIONS(5392),
    [anon_sym_member] = ACTIONS(5392),
    [anon_sym_abstract] = ACTIONS(5392),
    [anon_sym_override] = ACTIONS(5392),
    [anon_sym_val] = ACTIONS(5392),
    [aux_sym_char_token1] = ACTIONS(5390),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5392),
    [anon_sym_DQUOTE] = ACTIONS(5392),
    [anon_sym_AT_DQUOTE] = ACTIONS(5390),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5390),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5390),
    [sym_bool] = ACTIONS(5392),
    [sym_unit] = ACTIONS(5390),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5392),
    [sym_op_identifier] = ACTIONS(5390),
    [anon_sym_PLUS] = ACTIONS(5392),
    [anon_sym_DASH] = ACTIONS(5392),
    [anon_sym_PLUS_DOT] = ACTIONS(5390),
    [anon_sym_DASH_DOT] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_TILDE] = ACTIONS(5390),
    [aux_sym_prefix_op_token1] = ACTIONS(5390),
    [sym_int] = ACTIONS(5392),
    [sym_xint] = ACTIONS(5390),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5390),
    [anon_sym_POUNDload] = ACTIONS(5390),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5390),
    [sym__dedent] = ACTIONS(5390),
  },
  [3202] = {
    [sym_xml_doc] = STATE(3202),
    [sym_block_comment] = STATE(3202),
    [sym_line_comment] = STATE(3202),
    [sym_compiler_directive_decl] = STATE(3202),
    [sym_fsi_directive_decl] = STATE(3202),
    [sym_preproc_line] = STATE(3202),
    [sym_identifier] = ACTIONS(5494),
    [anon_sym_module] = ACTIONS(5494),
    [anon_sym_open] = ACTIONS(5494),
    [anon_sym_LBRACK_LT] = ACTIONS(5492),
    [anon_sym_return] = ACTIONS(5494),
    [anon_sym_type] = ACTIONS(5494),
    [anon_sym_do] = ACTIONS(5494),
    [anon_sym_and] = ACTIONS(5494),
    [anon_sym_let] = ACTIONS(5494),
    [anon_sym_let_BANG] = ACTIONS(5492),
    [aux_sym_access_modifier_token1] = ACTIONS(5492),
    [anon_sym_LPAREN] = ACTIONS(5494),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym_AMP] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5492),
    [anon_sym_LBRACE] = ACTIONS(5494),
    [anon_sym_LT_AT] = ACTIONS(5494),
    [anon_sym_LT_AT_AT] = ACTIONS(5492),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5492),
    [anon_sym_new] = ACTIONS(5494),
    [anon_sym_return_BANG] = ACTIONS(5492),
    [anon_sym_yield] = ACTIONS(5494),
    [anon_sym_yield_BANG] = ACTIONS(5492),
    [anon_sym_lazy] = ACTIONS(5494),
    [anon_sym_assert] = ACTIONS(5494),
    [anon_sym_upcast] = ACTIONS(5494),
    [anon_sym_downcast] = ACTIONS(5494),
    [anon_sym_for] = ACTIONS(5494),
    [anon_sym_while] = ACTIONS(5494),
    [anon_sym_if] = ACTIONS(5494),
    [anon_sym_fun] = ACTIONS(5494),
    [anon_sym_try] = ACTIONS(5494),
    [anon_sym_match] = ACTIONS(5494),
    [anon_sym_match_BANG] = ACTIONS(5492),
    [anon_sym_function] = ACTIONS(5494),
    [anon_sym_use] = ACTIONS(5494),
    [anon_sym_use_BANG] = ACTIONS(5492),
    [anon_sym_do_BANG] = ACTIONS(5492),
    [anon_sym_begin] = ACTIONS(5494),
    [anon_sym_default] = ACTIONS(5494),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_member] = ACTIONS(5494),
    [anon_sym_abstract] = ACTIONS(5494),
    [anon_sym_override] = ACTIONS(5494),
    [anon_sym_val] = ACTIONS(5494),
    [aux_sym_char_token1] = ACTIONS(5492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5494),
    [anon_sym_DQUOTE] = ACTIONS(5494),
    [anon_sym_AT_DQUOTE] = ACTIONS(5492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5492),
    [sym_bool] = ACTIONS(5494),
    [sym_unit] = ACTIONS(5492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5494),
    [sym_op_identifier] = ACTIONS(5492),
    [anon_sym_PLUS] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_PLUS_DOT] = ACTIONS(5492),
    [anon_sym_DASH_DOT] = ACTIONS(5492),
    [anon_sym_PERCENT] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [aux_sym_prefix_op_token1] = ACTIONS(5492),
    [sym_int] = ACTIONS(5494),
    [sym_xint] = ACTIONS(5492),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5492),
    [anon_sym_POUNDload] = ACTIONS(5492),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5492),
    [sym__dedent] = ACTIONS(5492),
  },
  [3203] = {
    [sym_xml_doc] = STATE(3203),
    [sym_block_comment] = STATE(3203),
    [sym_line_comment] = STATE(3203),
    [sym_compiler_directive_decl] = STATE(3203),
    [sym_fsi_directive_decl] = STATE(3203),
    [sym_preproc_line] = STATE(3203),
    [sym_identifier] = ACTIONS(5075),
    [anon_sym_module] = ACTIONS(5075),
    [anon_sym_open] = ACTIONS(5075),
    [anon_sym_LBRACK_LT] = ACTIONS(5073),
    [anon_sym_return] = ACTIONS(5075),
    [anon_sym_type] = ACTIONS(5075),
    [anon_sym_do] = ACTIONS(5075),
    [anon_sym_and] = ACTIONS(5075),
    [anon_sym_let] = ACTIONS(5075),
    [anon_sym_let_BANG] = ACTIONS(5073),
    [aux_sym_access_modifier_token1] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5075),
    [anon_sym_null] = ACTIONS(5075),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5073),
    [anon_sym_LBRACE] = ACTIONS(5075),
    [anon_sym_LT_AT] = ACTIONS(5075),
    [anon_sym_LT_AT_AT] = ACTIONS(5073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5073),
    [anon_sym_new] = ACTIONS(5075),
    [anon_sym_return_BANG] = ACTIONS(5073),
    [anon_sym_yield] = ACTIONS(5075),
    [anon_sym_yield_BANG] = ACTIONS(5073),
    [anon_sym_lazy] = ACTIONS(5075),
    [anon_sym_assert] = ACTIONS(5075),
    [anon_sym_upcast] = ACTIONS(5075),
    [anon_sym_downcast] = ACTIONS(5075),
    [anon_sym_for] = ACTIONS(5075),
    [anon_sym_while] = ACTIONS(5075),
    [anon_sym_if] = ACTIONS(5075),
    [anon_sym_fun] = ACTIONS(5075),
    [anon_sym_try] = ACTIONS(5075),
    [anon_sym_match] = ACTIONS(5075),
    [anon_sym_match_BANG] = ACTIONS(5073),
    [anon_sym_function] = ACTIONS(5075),
    [anon_sym_use] = ACTIONS(5075),
    [anon_sym_use_BANG] = ACTIONS(5073),
    [anon_sym_do_BANG] = ACTIONS(5073),
    [anon_sym_begin] = ACTIONS(5075),
    [anon_sym_default] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_member] = ACTIONS(5075),
    [anon_sym_abstract] = ACTIONS(5075),
    [anon_sym_override] = ACTIONS(5075),
    [anon_sym_val] = ACTIONS(5075),
    [aux_sym_char_token1] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_AT_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5073),
    [sym_bool] = ACTIONS(5075),
    [sym_unit] = ACTIONS(5073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5075),
    [sym_op_identifier] = ACTIONS(5073),
    [anon_sym_PLUS] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_PLUS_DOT] = ACTIONS(5073),
    [anon_sym_DASH_DOT] = ACTIONS(5073),
    [anon_sym_PERCENT] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [aux_sym_prefix_op_token1] = ACTIONS(5073),
    [sym_int] = ACTIONS(5075),
    [sym_xint] = ACTIONS(5073),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5073),
    [anon_sym_POUNDload] = ACTIONS(5073),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5073),
    [sym__dedent] = ACTIONS(5073),
  },
  [3204] = {
    [sym_xml_doc] = STATE(3204),
    [sym_block_comment] = STATE(3204),
    [sym_line_comment] = STATE(3204),
    [sym_compiler_directive_decl] = STATE(3204),
    [sym_fsi_directive_decl] = STATE(3204),
    [sym_preproc_line] = STATE(3204),
    [sym_identifier] = ACTIONS(5468),
    [anon_sym_module] = ACTIONS(5468),
    [anon_sym_open] = ACTIONS(5468),
    [anon_sym_LBRACK_LT] = ACTIONS(5466),
    [anon_sym_return] = ACTIONS(5468),
    [anon_sym_type] = ACTIONS(5468),
    [anon_sym_do] = ACTIONS(5468),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_let] = ACTIONS(5468),
    [anon_sym_let_BANG] = ACTIONS(5466),
    [aux_sym_access_modifier_token1] = ACTIONS(5466),
    [anon_sym_LPAREN] = ACTIONS(5468),
    [anon_sym_null] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5466),
    [anon_sym_LBRACE] = ACTIONS(5468),
    [anon_sym_LT_AT] = ACTIONS(5468),
    [anon_sym_LT_AT_AT] = ACTIONS(5466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5466),
    [anon_sym_new] = ACTIONS(5468),
    [anon_sym_return_BANG] = ACTIONS(5466),
    [anon_sym_yield] = ACTIONS(5468),
    [anon_sym_yield_BANG] = ACTIONS(5466),
    [anon_sym_lazy] = ACTIONS(5468),
    [anon_sym_assert] = ACTIONS(5468),
    [anon_sym_upcast] = ACTIONS(5468),
    [anon_sym_downcast] = ACTIONS(5468),
    [anon_sym_for] = ACTIONS(5468),
    [anon_sym_while] = ACTIONS(5468),
    [anon_sym_if] = ACTIONS(5468),
    [anon_sym_fun] = ACTIONS(5468),
    [anon_sym_try] = ACTIONS(5468),
    [anon_sym_match] = ACTIONS(5468),
    [anon_sym_match_BANG] = ACTIONS(5466),
    [anon_sym_function] = ACTIONS(5468),
    [anon_sym_use] = ACTIONS(5468),
    [anon_sym_use_BANG] = ACTIONS(5466),
    [anon_sym_do_BANG] = ACTIONS(5466),
    [anon_sym_begin] = ACTIONS(5468),
    [anon_sym_default] = ACTIONS(5468),
    [anon_sym_static] = ACTIONS(5468),
    [anon_sym_member] = ACTIONS(5468),
    [anon_sym_abstract] = ACTIONS(5468),
    [anon_sym_override] = ACTIONS(5468),
    [anon_sym_val] = ACTIONS(5468),
    [aux_sym_char_token1] = ACTIONS(5466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5468),
    [anon_sym_DQUOTE] = ACTIONS(5468),
    [anon_sym_AT_DQUOTE] = ACTIONS(5466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5466),
    [sym_bool] = ACTIONS(5468),
    [sym_unit] = ACTIONS(5466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5468),
    [sym_op_identifier] = ACTIONS(5466),
    [anon_sym_PLUS] = ACTIONS(5468),
    [anon_sym_DASH] = ACTIONS(5468),
    [anon_sym_PLUS_DOT] = ACTIONS(5466),
    [anon_sym_DASH_DOT] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [aux_sym_prefix_op_token1] = ACTIONS(5466),
    [sym_int] = ACTIONS(5468),
    [sym_xint] = ACTIONS(5466),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5466),
    [anon_sym_POUNDload] = ACTIONS(5466),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5466),
    [sym__dedent] = ACTIONS(5466),
  },
  [3205] = {
    [sym_xml_doc] = STATE(3205),
    [sym_block_comment] = STATE(3205),
    [sym_line_comment] = STATE(3205),
    [sym_compiler_directive_decl] = STATE(3205),
    [sym_fsi_directive_decl] = STATE(3205),
    [sym_preproc_line] = STATE(3205),
    [sym_identifier] = ACTIONS(5484),
    [anon_sym_module] = ACTIONS(5484),
    [anon_sym_open] = ACTIONS(5484),
    [anon_sym_LBRACK_LT] = ACTIONS(5482),
    [anon_sym_return] = ACTIONS(5484),
    [anon_sym_type] = ACTIONS(5484),
    [anon_sym_do] = ACTIONS(5484),
    [anon_sym_and] = ACTIONS(5484),
    [anon_sym_let] = ACTIONS(5484),
    [anon_sym_let_BANG] = ACTIONS(5482),
    [aux_sym_access_modifier_token1] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5484),
    [anon_sym_null] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5482),
    [anon_sym_LBRACE] = ACTIONS(5484),
    [anon_sym_LT_AT] = ACTIONS(5484),
    [anon_sym_LT_AT_AT] = ACTIONS(5482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5482),
    [anon_sym_new] = ACTIONS(5484),
    [anon_sym_return_BANG] = ACTIONS(5482),
    [anon_sym_yield] = ACTIONS(5484),
    [anon_sym_yield_BANG] = ACTIONS(5482),
    [anon_sym_lazy] = ACTIONS(5484),
    [anon_sym_assert] = ACTIONS(5484),
    [anon_sym_upcast] = ACTIONS(5484),
    [anon_sym_downcast] = ACTIONS(5484),
    [anon_sym_for] = ACTIONS(5484),
    [anon_sym_while] = ACTIONS(5484),
    [anon_sym_if] = ACTIONS(5484),
    [anon_sym_fun] = ACTIONS(5484),
    [anon_sym_try] = ACTIONS(5484),
    [anon_sym_match] = ACTIONS(5484),
    [anon_sym_match_BANG] = ACTIONS(5482),
    [anon_sym_function] = ACTIONS(5484),
    [anon_sym_use] = ACTIONS(5484),
    [anon_sym_use_BANG] = ACTIONS(5482),
    [anon_sym_do_BANG] = ACTIONS(5482),
    [anon_sym_begin] = ACTIONS(5484),
    [anon_sym_default] = ACTIONS(5484),
    [anon_sym_static] = ACTIONS(5484),
    [anon_sym_member] = ACTIONS(5484),
    [anon_sym_abstract] = ACTIONS(5484),
    [anon_sym_override] = ACTIONS(5484),
    [anon_sym_val] = ACTIONS(5484),
    [aux_sym_char_token1] = ACTIONS(5482),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5484),
    [anon_sym_DQUOTE] = ACTIONS(5484),
    [anon_sym_AT_DQUOTE] = ACTIONS(5482),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5482),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5482),
    [sym_bool] = ACTIONS(5484),
    [sym_unit] = ACTIONS(5482),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5484),
    [sym_op_identifier] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_PLUS_DOT] = ACTIONS(5482),
    [anon_sym_DASH_DOT] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_TILDE] = ACTIONS(5482),
    [aux_sym_prefix_op_token1] = ACTIONS(5482),
    [sym_int] = ACTIONS(5484),
    [sym_xint] = ACTIONS(5482),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5482),
    [anon_sym_POUNDload] = ACTIONS(5482),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5482),
    [sym__dedent] = ACTIONS(5482),
  },
  [3206] = {
    [sym_xml_doc] = STATE(3206),
    [sym_block_comment] = STATE(3206),
    [sym_line_comment] = STATE(3206),
    [sym_compiler_directive_decl] = STATE(3206),
    [sym_fsi_directive_decl] = STATE(3206),
    [sym_preproc_line] = STATE(3206),
    [sym_identifier] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5454),
    [anon_sym_open] = ACTIONS(5454),
    [anon_sym_LBRACK_LT] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5454),
    [anon_sym_type] = ACTIONS(5454),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_let] = ACTIONS(5454),
    [anon_sym_let_BANG] = ACTIONS(5452),
    [aux_sym_access_modifier_token1] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5454),
    [anon_sym_null] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_LT_AT] = ACTIONS(5454),
    [anon_sym_LT_AT_AT] = ACTIONS(5452),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5452),
    [anon_sym_new] = ACTIONS(5454),
    [anon_sym_return_BANG] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5454),
    [anon_sym_yield_BANG] = ACTIONS(5452),
    [anon_sym_lazy] = ACTIONS(5454),
    [anon_sym_assert] = ACTIONS(5454),
    [anon_sym_upcast] = ACTIONS(5454),
    [anon_sym_downcast] = ACTIONS(5454),
    [anon_sym_for] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_fun] = ACTIONS(5454),
    [anon_sym_try] = ACTIONS(5454),
    [anon_sym_match] = ACTIONS(5454),
    [anon_sym_match_BANG] = ACTIONS(5452),
    [anon_sym_function] = ACTIONS(5454),
    [anon_sym_use] = ACTIONS(5454),
    [anon_sym_use_BANG] = ACTIONS(5452),
    [anon_sym_do_BANG] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5454),
    [anon_sym_default] = ACTIONS(5454),
    [anon_sym_static] = ACTIONS(5454),
    [anon_sym_member] = ACTIONS(5454),
    [anon_sym_abstract] = ACTIONS(5454),
    [anon_sym_override] = ACTIONS(5454),
    [anon_sym_val] = ACTIONS(5454),
    [aux_sym_char_token1] = ACTIONS(5452),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5454),
    [anon_sym_DQUOTE] = ACTIONS(5454),
    [anon_sym_AT_DQUOTE] = ACTIONS(5452),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5452),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5452),
    [sym_bool] = ACTIONS(5454),
    [sym_unit] = ACTIONS(5452),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5454),
    [sym_op_identifier] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_PLUS_DOT] = ACTIONS(5452),
    [anon_sym_DASH_DOT] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(5452),
    [aux_sym_prefix_op_token1] = ACTIONS(5452),
    [sym_int] = ACTIONS(5454),
    [sym_xint] = ACTIONS(5452),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5452),
    [anon_sym_POUNDload] = ACTIONS(5452),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5452),
    [sym__dedent] = ACTIONS(5452),
  },
  [3207] = {
    [sym_xml_doc] = STATE(3207),
    [sym_block_comment] = STATE(3207),
    [sym_line_comment] = STATE(3207),
    [sym_compiler_directive_decl] = STATE(3207),
    [sym_fsi_directive_decl] = STATE(3207),
    [sym_preproc_line] = STATE(3207),
    [sym_identifier] = ACTIONS(5504),
    [anon_sym_module] = ACTIONS(5504),
    [anon_sym_open] = ACTIONS(5504),
    [anon_sym_LBRACK_LT] = ACTIONS(5502),
    [anon_sym_return] = ACTIONS(5504),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_do] = ACTIONS(5504),
    [anon_sym_and] = ACTIONS(5504),
    [anon_sym_let] = ACTIONS(5504),
    [anon_sym_let_BANG] = ACTIONS(5502),
    [aux_sym_access_modifier_token1] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_null] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5504),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_LT_AT] = ACTIONS(5504),
    [anon_sym_LT_AT_AT] = ACTIONS(5502),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5502),
    [anon_sym_new] = ACTIONS(5504),
    [anon_sym_return_BANG] = ACTIONS(5502),
    [anon_sym_yield] = ACTIONS(5504),
    [anon_sym_yield_BANG] = ACTIONS(5502),
    [anon_sym_lazy] = ACTIONS(5504),
    [anon_sym_assert] = ACTIONS(5504),
    [anon_sym_upcast] = ACTIONS(5504),
    [anon_sym_downcast] = ACTIONS(5504),
    [anon_sym_for] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_fun] = ACTIONS(5504),
    [anon_sym_try] = ACTIONS(5504),
    [anon_sym_match] = ACTIONS(5504),
    [anon_sym_match_BANG] = ACTIONS(5502),
    [anon_sym_function] = ACTIONS(5504),
    [anon_sym_use] = ACTIONS(5504),
    [anon_sym_use_BANG] = ACTIONS(5502),
    [anon_sym_do_BANG] = ACTIONS(5502),
    [anon_sym_begin] = ACTIONS(5504),
    [anon_sym_default] = ACTIONS(5504),
    [anon_sym_static] = ACTIONS(5504),
    [anon_sym_member] = ACTIONS(5504),
    [anon_sym_abstract] = ACTIONS(5504),
    [anon_sym_override] = ACTIONS(5504),
    [anon_sym_val] = ACTIONS(5504),
    [aux_sym_char_token1] = ACTIONS(5502),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5504),
    [anon_sym_DQUOTE] = ACTIONS(5504),
    [anon_sym_AT_DQUOTE] = ACTIONS(5502),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5502),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5502),
    [sym_bool] = ACTIONS(5504),
    [sym_unit] = ACTIONS(5502),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5504),
    [sym_op_identifier] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_DOT] = ACTIONS(5502),
    [anon_sym_DASH_DOT] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_TILDE] = ACTIONS(5502),
    [aux_sym_prefix_op_token1] = ACTIONS(5502),
    [sym_int] = ACTIONS(5504),
    [sym_xint] = ACTIONS(5502),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5502),
    [anon_sym_POUNDload] = ACTIONS(5502),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5502),
    [sym__dedent] = ACTIONS(5502),
  },
  [3208] = {
    [sym_xml_doc] = STATE(3208),
    [sym_block_comment] = STATE(3208),
    [sym_line_comment] = STATE(3208),
    [sym_compiler_directive_decl] = STATE(3208),
    [sym_fsi_directive_decl] = STATE(3208),
    [sym_preproc_line] = STATE(3208),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_module] = ACTIONS(5508),
    [anon_sym_open] = ACTIONS(5508),
    [anon_sym_LBRACK_LT] = ACTIONS(5506),
    [anon_sym_return] = ACTIONS(5508),
    [anon_sym_type] = ACTIONS(5508),
    [anon_sym_do] = ACTIONS(5508),
    [anon_sym_and] = ACTIONS(5508),
    [anon_sym_let] = ACTIONS(5508),
    [anon_sym_let_BANG] = ACTIONS(5506),
    [aux_sym_access_modifier_token1] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5508),
    [anon_sym_null] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5506),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_LT_AT] = ACTIONS(5508),
    [anon_sym_LT_AT_AT] = ACTIONS(5506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5506),
    [anon_sym_new] = ACTIONS(5508),
    [anon_sym_return_BANG] = ACTIONS(5506),
    [anon_sym_yield] = ACTIONS(5508),
    [anon_sym_yield_BANG] = ACTIONS(5506),
    [anon_sym_lazy] = ACTIONS(5508),
    [anon_sym_assert] = ACTIONS(5508),
    [anon_sym_upcast] = ACTIONS(5508),
    [anon_sym_downcast] = ACTIONS(5508),
    [anon_sym_for] = ACTIONS(5508),
    [anon_sym_while] = ACTIONS(5508),
    [anon_sym_if] = ACTIONS(5508),
    [anon_sym_fun] = ACTIONS(5508),
    [anon_sym_try] = ACTIONS(5508),
    [anon_sym_match] = ACTIONS(5508),
    [anon_sym_match_BANG] = ACTIONS(5506),
    [anon_sym_function] = ACTIONS(5508),
    [anon_sym_use] = ACTIONS(5508),
    [anon_sym_use_BANG] = ACTIONS(5506),
    [anon_sym_do_BANG] = ACTIONS(5506),
    [anon_sym_begin] = ACTIONS(5508),
    [anon_sym_default] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_member] = ACTIONS(5508),
    [anon_sym_abstract] = ACTIONS(5508),
    [anon_sym_override] = ACTIONS(5508),
    [anon_sym_val] = ACTIONS(5508),
    [aux_sym_char_token1] = ACTIONS(5506),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5508),
    [anon_sym_DQUOTE] = ACTIONS(5508),
    [anon_sym_AT_DQUOTE] = ACTIONS(5506),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5506),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5506),
    [sym_bool] = ACTIONS(5508),
    [sym_unit] = ACTIONS(5506),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5508),
    [sym_op_identifier] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_DOT] = ACTIONS(5506),
    [anon_sym_DASH_DOT] = ACTIONS(5506),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [aux_sym_prefix_op_token1] = ACTIONS(5506),
    [sym_int] = ACTIONS(5508),
    [sym_xint] = ACTIONS(5506),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5506),
    [anon_sym_POUNDload] = ACTIONS(5506),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5506),
    [sym__dedent] = ACTIONS(5506),
  },
  [3209] = {
    [sym_attributes] = STATE(8336),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3209),
    [sym_block_comment] = STATE(3209),
    [sym_line_comment] = STATE(3209),
    [sym_compiler_directive_decl] = STATE(3209),
    [sym_fsi_directive_decl] = STATE(3209),
    [sym_preproc_line] = STATE(3209),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3211),
    [ts_builtin_sym_end] = ACTIONS(5526),
    [sym_identifier] = ACTIONS(5528),
    [anon_sym_namespace] = ACTIONS(5528),
    [anon_sym_module] = ACTIONS(5528),
    [anon_sym_open] = ACTIONS(5528),
    [anon_sym_LBRACK_LT] = ACTIONS(5526),
    [anon_sym_return] = ACTIONS(5528),
    [anon_sym_type] = ACTIONS(5528),
    [anon_sym_do] = ACTIONS(5528),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_let] = ACTIONS(5528),
    [anon_sym_let_BANG] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5528),
    [anon_sym_null] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5528),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5526),
    [anon_sym_LBRACE] = ACTIONS(5528),
    [anon_sym_LT_AT] = ACTIONS(5528),
    [anon_sym_LT_AT_AT] = ACTIONS(5526),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5526),
    [anon_sym_new] = ACTIONS(5528),
    [anon_sym_return_BANG] = ACTIONS(5526),
    [anon_sym_yield] = ACTIONS(5528),
    [anon_sym_yield_BANG] = ACTIONS(5526),
    [anon_sym_lazy] = ACTIONS(5528),
    [anon_sym_assert] = ACTIONS(5528),
    [anon_sym_upcast] = ACTIONS(5528),
    [anon_sym_downcast] = ACTIONS(5528),
    [anon_sym_for] = ACTIONS(5528),
    [anon_sym_while] = ACTIONS(5528),
    [anon_sym_if] = ACTIONS(5528),
    [anon_sym_fun] = ACTIONS(5528),
    [anon_sym_try] = ACTIONS(5528),
    [anon_sym_match] = ACTIONS(5528),
    [anon_sym_match_BANG] = ACTIONS(5526),
    [anon_sym_function] = ACTIONS(5528),
    [anon_sym_use] = ACTIONS(5528),
    [anon_sym_use_BANG] = ACTIONS(5526),
    [anon_sym_do_BANG] = ACTIONS(5526),
    [anon_sym_begin] = ACTIONS(5528),
    [aux_sym_char_token1] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_AT_DQUOTE] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [sym_bool] = ACTIONS(5528),
    [sym_unit] = ACTIONS(5526),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5528),
    [sym_op_identifier] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_PLUS_DOT] = ACTIONS(5526),
    [anon_sym_DASH_DOT] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_TILDE] = ACTIONS(5526),
    [aux_sym_prefix_op_token1] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5526),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5526),
    [anon_sym_POUNDload] = ACTIONS(5526),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5526),
  },
  [3210] = {
    [sym_attributes] = STATE(8336),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3210),
    [sym_block_comment] = STATE(3210),
    [sym_line_comment] = STATE(3210),
    [sym_compiler_directive_decl] = STATE(3210),
    [sym_fsi_directive_decl] = STATE(3210),
    [sym_preproc_line] = STATE(3210),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3213),
    [ts_builtin_sym_end] = ACTIONS(5532),
    [sym_identifier] = ACTIONS(5534),
    [anon_sym_namespace] = ACTIONS(5534),
    [anon_sym_module] = ACTIONS(5534),
    [anon_sym_open] = ACTIONS(5534),
    [anon_sym_LBRACK_LT] = ACTIONS(5532),
    [anon_sym_return] = ACTIONS(5534),
    [anon_sym_type] = ACTIONS(5534),
    [anon_sym_do] = ACTIONS(5534),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_let] = ACTIONS(5534),
    [anon_sym_let_BANG] = ACTIONS(5532),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [anon_sym_null] = ACTIONS(5534),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5532),
    [anon_sym_LBRACE] = ACTIONS(5534),
    [anon_sym_LT_AT] = ACTIONS(5534),
    [anon_sym_LT_AT_AT] = ACTIONS(5532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5532),
    [anon_sym_new] = ACTIONS(5534),
    [anon_sym_return_BANG] = ACTIONS(5532),
    [anon_sym_yield] = ACTIONS(5534),
    [anon_sym_yield_BANG] = ACTIONS(5532),
    [anon_sym_lazy] = ACTIONS(5534),
    [anon_sym_assert] = ACTIONS(5534),
    [anon_sym_upcast] = ACTIONS(5534),
    [anon_sym_downcast] = ACTIONS(5534),
    [anon_sym_for] = ACTIONS(5534),
    [anon_sym_while] = ACTIONS(5534),
    [anon_sym_if] = ACTIONS(5534),
    [anon_sym_fun] = ACTIONS(5534),
    [anon_sym_try] = ACTIONS(5534),
    [anon_sym_match] = ACTIONS(5534),
    [anon_sym_match_BANG] = ACTIONS(5532),
    [anon_sym_function] = ACTIONS(5534),
    [anon_sym_use] = ACTIONS(5534),
    [anon_sym_use_BANG] = ACTIONS(5532),
    [anon_sym_do_BANG] = ACTIONS(5532),
    [anon_sym_begin] = ACTIONS(5534),
    [aux_sym_char_token1] = ACTIONS(5532),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_AT_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5532),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5532),
    [sym_bool] = ACTIONS(5534),
    [sym_unit] = ACTIONS(5532),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5534),
    [sym_op_identifier] = ACTIONS(5532),
    [anon_sym_PLUS] = ACTIONS(5534),
    [anon_sym_DASH] = ACTIONS(5534),
    [anon_sym_PLUS_DOT] = ACTIONS(5532),
    [anon_sym_DASH_DOT] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [aux_sym_prefix_op_token1] = ACTIONS(5532),
    [sym_int] = ACTIONS(5534),
    [sym_xint] = ACTIONS(5532),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5532),
    [anon_sym_POUNDload] = ACTIONS(5532),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5532),
  },
  [3211] = {
    [sym_attributes] = STATE(8336),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3211),
    [sym_block_comment] = STATE(3211),
    [sym_line_comment] = STATE(3211),
    [sym_compiler_directive_decl] = STATE(3211),
    [sym_fsi_directive_decl] = STATE(3211),
    [sym_preproc_line] = STATE(3211),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3212),
    [ts_builtin_sym_end] = ACTIONS(5536),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_namespace] = ACTIONS(5538),
    [anon_sym_module] = ACTIONS(5538),
    [anon_sym_open] = ACTIONS(5538),
    [anon_sym_LBRACK_LT] = ACTIONS(5536),
    [anon_sym_return] = ACTIONS(5538),
    [anon_sym_type] = ACTIONS(5538),
    [anon_sym_do] = ACTIONS(5538),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_let] = ACTIONS(5538),
    [anon_sym_let_BANG] = ACTIONS(5536),
    [anon_sym_LPAREN] = ACTIONS(5538),
    [anon_sym_null] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5536),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LT_AT] = ACTIONS(5538),
    [anon_sym_LT_AT_AT] = ACTIONS(5536),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5536),
    [anon_sym_new] = ACTIONS(5538),
    [anon_sym_return_BANG] = ACTIONS(5536),
    [anon_sym_yield] = ACTIONS(5538),
    [anon_sym_yield_BANG] = ACTIONS(5536),
    [anon_sym_lazy] = ACTIONS(5538),
    [anon_sym_assert] = ACTIONS(5538),
    [anon_sym_upcast] = ACTIONS(5538),
    [anon_sym_downcast] = ACTIONS(5538),
    [anon_sym_for] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(5538),
    [anon_sym_if] = ACTIONS(5538),
    [anon_sym_fun] = ACTIONS(5538),
    [anon_sym_try] = ACTIONS(5538),
    [anon_sym_match] = ACTIONS(5538),
    [anon_sym_match_BANG] = ACTIONS(5536),
    [anon_sym_function] = ACTIONS(5538),
    [anon_sym_use] = ACTIONS(5538),
    [anon_sym_use_BANG] = ACTIONS(5536),
    [anon_sym_do_BANG] = ACTIONS(5536),
    [anon_sym_begin] = ACTIONS(5538),
    [aux_sym_char_token1] = ACTIONS(5536),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_AT_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5536),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5536),
    [sym_bool] = ACTIONS(5538),
    [sym_unit] = ACTIONS(5536),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5538),
    [sym_op_identifier] = ACTIONS(5536),
    [anon_sym_PLUS] = ACTIONS(5538),
    [anon_sym_DASH] = ACTIONS(5538),
    [anon_sym_PLUS_DOT] = ACTIONS(5536),
    [anon_sym_DASH_DOT] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_TILDE] = ACTIONS(5536),
    [aux_sym_prefix_op_token1] = ACTIONS(5536),
    [sym_int] = ACTIONS(5538),
    [sym_xint] = ACTIONS(5536),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5536),
    [anon_sym_POUNDload] = ACTIONS(5536),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5536),
  },
  [3212] = {
    [sym_attributes] = STATE(8336),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3212),
    [sym_block_comment] = STATE(3212),
    [sym_line_comment] = STATE(3212),
    [sym_compiler_directive_decl] = STATE(3212),
    [sym_fsi_directive_decl] = STATE(3212),
    [sym_preproc_line] = STATE(3212),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3212),
    [ts_builtin_sym_end] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5542),
    [anon_sym_namespace] = ACTIONS(5542),
    [anon_sym_module] = ACTIONS(5542),
    [anon_sym_open] = ACTIONS(5542),
    [anon_sym_LBRACK_LT] = ACTIONS(5544),
    [anon_sym_return] = ACTIONS(5542),
    [anon_sym_type] = ACTIONS(5542),
    [anon_sym_do] = ACTIONS(5542),
    [anon_sym_and] = ACTIONS(5547),
    [anon_sym_let] = ACTIONS(5542),
    [anon_sym_let_BANG] = ACTIONS(5540),
    [anon_sym_LPAREN] = ACTIONS(5542),
    [anon_sym_null] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_LT_AT] = ACTIONS(5542),
    [anon_sym_LT_AT_AT] = ACTIONS(5540),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5540),
    [anon_sym_new] = ACTIONS(5542),
    [anon_sym_return_BANG] = ACTIONS(5540),
    [anon_sym_yield] = ACTIONS(5542),
    [anon_sym_yield_BANG] = ACTIONS(5540),
    [anon_sym_lazy] = ACTIONS(5542),
    [anon_sym_assert] = ACTIONS(5542),
    [anon_sym_upcast] = ACTIONS(5542),
    [anon_sym_downcast] = ACTIONS(5542),
    [anon_sym_for] = ACTIONS(5542),
    [anon_sym_while] = ACTIONS(5542),
    [anon_sym_if] = ACTIONS(5542),
    [anon_sym_fun] = ACTIONS(5542),
    [anon_sym_try] = ACTIONS(5542),
    [anon_sym_match] = ACTIONS(5542),
    [anon_sym_match_BANG] = ACTIONS(5540),
    [anon_sym_function] = ACTIONS(5542),
    [anon_sym_use] = ACTIONS(5542),
    [anon_sym_use_BANG] = ACTIONS(5540),
    [anon_sym_do_BANG] = ACTIONS(5540),
    [anon_sym_begin] = ACTIONS(5542),
    [aux_sym_char_token1] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_AT_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [sym_bool] = ACTIONS(5542),
    [sym_unit] = ACTIONS(5540),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5542),
    [sym_op_identifier] = ACTIONS(5540),
    [anon_sym_PLUS] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_PLUS_DOT] = ACTIONS(5540),
    [anon_sym_DASH_DOT] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [aux_sym_prefix_op_token1] = ACTIONS(5540),
    [sym_int] = ACTIONS(5542),
    [sym_xint] = ACTIONS(5540),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5540),
    [anon_sym_POUNDload] = ACTIONS(5540),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5540),
  },
  [3213] = {
    [sym_attributes] = STATE(8336),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3213),
    [sym_block_comment] = STATE(3213),
    [sym_line_comment] = STATE(3213),
    [sym_compiler_directive_decl] = STATE(3213),
    [sym_fsi_directive_decl] = STATE(3213),
    [sym_preproc_line] = STATE(3213),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3212),
    [ts_builtin_sym_end] = ACTIONS(5526),
    [sym_identifier] = ACTIONS(5528),
    [anon_sym_namespace] = ACTIONS(5528),
    [anon_sym_module] = ACTIONS(5528),
    [anon_sym_open] = ACTIONS(5528),
    [anon_sym_LBRACK_LT] = ACTIONS(5526),
    [anon_sym_return] = ACTIONS(5528),
    [anon_sym_type] = ACTIONS(5528),
    [anon_sym_do] = ACTIONS(5528),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_let] = ACTIONS(5528),
    [anon_sym_let_BANG] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5528),
    [anon_sym_null] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5528),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5526),
    [anon_sym_LBRACE] = ACTIONS(5528),
    [anon_sym_LT_AT] = ACTIONS(5528),
    [anon_sym_LT_AT_AT] = ACTIONS(5526),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5526),
    [anon_sym_new] = ACTIONS(5528),
    [anon_sym_return_BANG] = ACTIONS(5526),
    [anon_sym_yield] = ACTIONS(5528),
    [anon_sym_yield_BANG] = ACTIONS(5526),
    [anon_sym_lazy] = ACTIONS(5528),
    [anon_sym_assert] = ACTIONS(5528),
    [anon_sym_upcast] = ACTIONS(5528),
    [anon_sym_downcast] = ACTIONS(5528),
    [anon_sym_for] = ACTIONS(5528),
    [anon_sym_while] = ACTIONS(5528),
    [anon_sym_if] = ACTIONS(5528),
    [anon_sym_fun] = ACTIONS(5528),
    [anon_sym_try] = ACTIONS(5528),
    [anon_sym_match] = ACTIONS(5528),
    [anon_sym_match_BANG] = ACTIONS(5526),
    [anon_sym_function] = ACTIONS(5528),
    [anon_sym_use] = ACTIONS(5528),
    [anon_sym_use_BANG] = ACTIONS(5526),
    [anon_sym_do_BANG] = ACTIONS(5526),
    [anon_sym_begin] = ACTIONS(5528),
    [aux_sym_char_token1] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_AT_DQUOTE] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [sym_bool] = ACTIONS(5528),
    [sym_unit] = ACTIONS(5526),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5528),
    [sym_op_identifier] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_PLUS_DOT] = ACTIONS(5526),
    [anon_sym_DASH_DOT] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_TILDE] = ACTIONS(5526),
    [aux_sym_prefix_op_token1] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5526),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5526),
    [anon_sym_POUNDload] = ACTIONS(5526),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5526),
  },
  [3214] = {
    [sym_interface_implementation] = STATE(3239),
    [sym_xml_doc] = STATE(3214),
    [sym_block_comment] = STATE(3214),
    [sym_line_comment] = STATE(3214),
    [sym_compiler_directive_decl] = STATE(3214),
    [sym_fsi_directive_decl] = STATE(3214),
    [sym_preproc_line] = STATE(3214),
    [aux_sym__object_expression_inner_repeat1] = STATE(3214),
    [ts_builtin_sym_end] = ACTIONS(5550),
    [sym_identifier] = ACTIONS(5552),
    [anon_sym_namespace] = ACTIONS(5552),
    [anon_sym_module] = ACTIONS(5552),
    [anon_sym_open] = ACTIONS(5552),
    [anon_sym_LBRACK_LT] = ACTIONS(5550),
    [anon_sym_return] = ACTIONS(5552),
    [anon_sym_type] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5552),
    [anon_sym_and] = ACTIONS(5552),
    [anon_sym_let] = ACTIONS(5552),
    [anon_sym_let_BANG] = ACTIONS(5550),
    [anon_sym_LPAREN] = ACTIONS(5552),
    [anon_sym_null] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5550),
    [anon_sym_LBRACE] = ACTIONS(5552),
    [anon_sym_LT_AT] = ACTIONS(5552),
    [anon_sym_LT_AT_AT] = ACTIONS(5550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5550),
    [anon_sym_new] = ACTIONS(5552),
    [anon_sym_return_BANG] = ACTIONS(5550),
    [anon_sym_yield] = ACTIONS(5552),
    [anon_sym_yield_BANG] = ACTIONS(5550),
    [anon_sym_lazy] = ACTIONS(5552),
    [anon_sym_assert] = ACTIONS(5552),
    [anon_sym_upcast] = ACTIONS(5552),
    [anon_sym_downcast] = ACTIONS(5552),
    [anon_sym_for] = ACTIONS(5552),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_if] = ACTIONS(5552),
    [anon_sym_fun] = ACTIONS(5552),
    [anon_sym_try] = ACTIONS(5552),
    [anon_sym_match] = ACTIONS(5552),
    [anon_sym_match_BANG] = ACTIONS(5550),
    [anon_sym_function] = ACTIONS(5552),
    [anon_sym_use] = ACTIONS(5552),
    [anon_sym_use_BANG] = ACTIONS(5550),
    [anon_sym_do_BANG] = ACTIONS(5550),
    [anon_sym_begin] = ACTIONS(5552),
    [anon_sym_interface] = ACTIONS(5554),
    [aux_sym_char_token1] = ACTIONS(5550),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5552),
    [anon_sym_DQUOTE] = ACTIONS(5552),
    [anon_sym_AT_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5550),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5550),
    [sym_bool] = ACTIONS(5552),
    [sym_unit] = ACTIONS(5550),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5552),
    [sym_op_identifier] = ACTIONS(5550),
    [anon_sym_PLUS] = ACTIONS(5552),
    [anon_sym_DASH] = ACTIONS(5552),
    [anon_sym_PLUS_DOT] = ACTIONS(5550),
    [anon_sym_DASH_DOT] = ACTIONS(5550),
    [anon_sym_PERCENT] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_TILDE] = ACTIONS(5550),
    [aux_sym_prefix_op_token1] = ACTIONS(5550),
    [sym_int] = ACTIONS(5552),
    [sym_xint] = ACTIONS(5550),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5550),
    [anon_sym_POUNDload] = ACTIONS(5550),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5550),
  },
  [3215] = {
    [sym_attributes] = STATE(7215),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3215),
    [sym_block_comment] = STATE(3215),
    [sym_line_comment] = STATE(3215),
    [sym_compiler_directive_decl] = STATE(3215),
    [sym_fsi_directive_decl] = STATE(3215),
    [sym_preproc_line] = STATE(3215),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3215),
    [sym_identifier] = ACTIONS(5542),
    [anon_sym_module] = ACTIONS(5542),
    [anon_sym_open] = ACTIONS(5542),
    [anon_sym_LBRACK_LT] = ACTIONS(5544),
    [anon_sym_return] = ACTIONS(5542),
    [anon_sym_type] = ACTIONS(5542),
    [anon_sym_do] = ACTIONS(5542),
    [anon_sym_and] = ACTIONS(5557),
    [anon_sym_let] = ACTIONS(5542),
    [anon_sym_let_BANG] = ACTIONS(5540),
    [anon_sym_LPAREN] = ACTIONS(5542),
    [anon_sym_null] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_LT_AT] = ACTIONS(5542),
    [anon_sym_LT_AT_AT] = ACTIONS(5540),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5540),
    [anon_sym_new] = ACTIONS(5542),
    [anon_sym_return_BANG] = ACTIONS(5540),
    [anon_sym_yield] = ACTIONS(5542),
    [anon_sym_yield_BANG] = ACTIONS(5540),
    [anon_sym_lazy] = ACTIONS(5542),
    [anon_sym_assert] = ACTIONS(5542),
    [anon_sym_upcast] = ACTIONS(5542),
    [anon_sym_downcast] = ACTIONS(5542),
    [anon_sym_for] = ACTIONS(5542),
    [anon_sym_while] = ACTIONS(5542),
    [anon_sym_if] = ACTIONS(5542),
    [anon_sym_fun] = ACTIONS(5542),
    [anon_sym_try] = ACTIONS(5542),
    [anon_sym_match] = ACTIONS(5542),
    [anon_sym_match_BANG] = ACTIONS(5540),
    [anon_sym_function] = ACTIONS(5542),
    [anon_sym_use] = ACTIONS(5542),
    [anon_sym_use_BANG] = ACTIONS(5540),
    [anon_sym_do_BANG] = ACTIONS(5540),
    [anon_sym_begin] = ACTIONS(5542),
    [aux_sym_char_token1] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_AT_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [sym_bool] = ACTIONS(5542),
    [sym_unit] = ACTIONS(5540),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5542),
    [sym_op_identifier] = ACTIONS(5540),
    [anon_sym_PLUS] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_PLUS_DOT] = ACTIONS(5540),
    [anon_sym_DASH_DOT] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [aux_sym_prefix_op_token1] = ACTIONS(5540),
    [sym_int] = ACTIONS(5542),
    [sym_xint] = ACTIONS(5540),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5540),
    [anon_sym_POUNDload] = ACTIONS(5540),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5540),
    [sym__dedent] = ACTIONS(5540),
  },
  [3216] = {
    [sym_attributes] = STATE(7215),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3216),
    [sym_block_comment] = STATE(3216),
    [sym_line_comment] = STATE(3216),
    [sym_compiler_directive_decl] = STATE(3216),
    [sym_fsi_directive_decl] = STATE(3216),
    [sym_preproc_line] = STATE(3216),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3219),
    [sym_identifier] = ACTIONS(5528),
    [anon_sym_module] = ACTIONS(5528),
    [anon_sym_open] = ACTIONS(5528),
    [anon_sym_LBRACK_LT] = ACTIONS(5526),
    [anon_sym_return] = ACTIONS(5528),
    [anon_sym_type] = ACTIONS(5528),
    [anon_sym_do] = ACTIONS(5528),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5528),
    [anon_sym_let_BANG] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5528),
    [anon_sym_null] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5528),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5526),
    [anon_sym_LBRACE] = ACTIONS(5528),
    [anon_sym_LT_AT] = ACTIONS(5528),
    [anon_sym_LT_AT_AT] = ACTIONS(5526),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5526),
    [anon_sym_new] = ACTIONS(5528),
    [anon_sym_return_BANG] = ACTIONS(5526),
    [anon_sym_yield] = ACTIONS(5528),
    [anon_sym_yield_BANG] = ACTIONS(5526),
    [anon_sym_lazy] = ACTIONS(5528),
    [anon_sym_assert] = ACTIONS(5528),
    [anon_sym_upcast] = ACTIONS(5528),
    [anon_sym_downcast] = ACTIONS(5528),
    [anon_sym_for] = ACTIONS(5528),
    [anon_sym_while] = ACTIONS(5528),
    [anon_sym_if] = ACTIONS(5528),
    [anon_sym_fun] = ACTIONS(5528),
    [anon_sym_try] = ACTIONS(5528),
    [anon_sym_match] = ACTIONS(5528),
    [anon_sym_match_BANG] = ACTIONS(5526),
    [anon_sym_function] = ACTIONS(5528),
    [anon_sym_use] = ACTIONS(5528),
    [anon_sym_use_BANG] = ACTIONS(5526),
    [anon_sym_do_BANG] = ACTIONS(5526),
    [anon_sym_begin] = ACTIONS(5528),
    [aux_sym_char_token1] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_AT_DQUOTE] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [sym_bool] = ACTIONS(5528),
    [sym_unit] = ACTIONS(5526),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5528),
    [sym_op_identifier] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_PLUS_DOT] = ACTIONS(5526),
    [anon_sym_DASH_DOT] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_TILDE] = ACTIONS(5526),
    [aux_sym_prefix_op_token1] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5526),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5526),
    [anon_sym_POUNDload] = ACTIONS(5526),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5526),
    [sym__dedent] = ACTIONS(5526),
  },
  [3217] = {
    [sym_attributes] = STATE(7215),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3217),
    [sym_block_comment] = STATE(3217),
    [sym_line_comment] = STATE(3217),
    [sym_compiler_directive_decl] = STATE(3217),
    [sym_fsi_directive_decl] = STATE(3217),
    [sym_preproc_line] = STATE(3217),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3218),
    [sym_identifier] = ACTIONS(5534),
    [anon_sym_module] = ACTIONS(5534),
    [anon_sym_open] = ACTIONS(5534),
    [anon_sym_LBRACK_LT] = ACTIONS(5532),
    [anon_sym_return] = ACTIONS(5534),
    [anon_sym_type] = ACTIONS(5534),
    [anon_sym_do] = ACTIONS(5534),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5534),
    [anon_sym_let_BANG] = ACTIONS(5532),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [anon_sym_null] = ACTIONS(5534),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5532),
    [anon_sym_LBRACE] = ACTIONS(5534),
    [anon_sym_LT_AT] = ACTIONS(5534),
    [anon_sym_LT_AT_AT] = ACTIONS(5532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5532),
    [anon_sym_new] = ACTIONS(5534),
    [anon_sym_return_BANG] = ACTIONS(5532),
    [anon_sym_yield] = ACTIONS(5534),
    [anon_sym_yield_BANG] = ACTIONS(5532),
    [anon_sym_lazy] = ACTIONS(5534),
    [anon_sym_assert] = ACTIONS(5534),
    [anon_sym_upcast] = ACTIONS(5534),
    [anon_sym_downcast] = ACTIONS(5534),
    [anon_sym_for] = ACTIONS(5534),
    [anon_sym_while] = ACTIONS(5534),
    [anon_sym_if] = ACTIONS(5534),
    [anon_sym_fun] = ACTIONS(5534),
    [anon_sym_try] = ACTIONS(5534),
    [anon_sym_match] = ACTIONS(5534),
    [anon_sym_match_BANG] = ACTIONS(5532),
    [anon_sym_function] = ACTIONS(5534),
    [anon_sym_use] = ACTIONS(5534),
    [anon_sym_use_BANG] = ACTIONS(5532),
    [anon_sym_do_BANG] = ACTIONS(5532),
    [anon_sym_begin] = ACTIONS(5534),
    [aux_sym_char_token1] = ACTIONS(5532),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_AT_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5532),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5532),
    [sym_bool] = ACTIONS(5534),
    [sym_unit] = ACTIONS(5532),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5534),
    [sym_op_identifier] = ACTIONS(5532),
    [anon_sym_PLUS] = ACTIONS(5534),
    [anon_sym_DASH] = ACTIONS(5534),
    [anon_sym_PLUS_DOT] = ACTIONS(5532),
    [anon_sym_DASH_DOT] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [aux_sym_prefix_op_token1] = ACTIONS(5532),
    [sym_int] = ACTIONS(5534),
    [sym_xint] = ACTIONS(5532),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5532),
    [anon_sym_POUNDload] = ACTIONS(5532),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5532),
    [sym__dedent] = ACTIONS(5532),
  },
  [3218] = {
    [sym_attributes] = STATE(7215),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3218),
    [sym_block_comment] = STATE(3218),
    [sym_line_comment] = STATE(3218),
    [sym_compiler_directive_decl] = STATE(3218),
    [sym_fsi_directive_decl] = STATE(3218),
    [sym_preproc_line] = STATE(3218),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3215),
    [sym_identifier] = ACTIONS(5528),
    [anon_sym_module] = ACTIONS(5528),
    [anon_sym_open] = ACTIONS(5528),
    [anon_sym_LBRACK_LT] = ACTIONS(5526),
    [anon_sym_return] = ACTIONS(5528),
    [anon_sym_type] = ACTIONS(5528),
    [anon_sym_do] = ACTIONS(5528),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5528),
    [anon_sym_let_BANG] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5528),
    [anon_sym_null] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5528),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5526),
    [anon_sym_LBRACE] = ACTIONS(5528),
    [anon_sym_LT_AT] = ACTIONS(5528),
    [anon_sym_LT_AT_AT] = ACTIONS(5526),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5526),
    [anon_sym_new] = ACTIONS(5528),
    [anon_sym_return_BANG] = ACTIONS(5526),
    [anon_sym_yield] = ACTIONS(5528),
    [anon_sym_yield_BANG] = ACTIONS(5526),
    [anon_sym_lazy] = ACTIONS(5528),
    [anon_sym_assert] = ACTIONS(5528),
    [anon_sym_upcast] = ACTIONS(5528),
    [anon_sym_downcast] = ACTIONS(5528),
    [anon_sym_for] = ACTIONS(5528),
    [anon_sym_while] = ACTIONS(5528),
    [anon_sym_if] = ACTIONS(5528),
    [anon_sym_fun] = ACTIONS(5528),
    [anon_sym_try] = ACTIONS(5528),
    [anon_sym_match] = ACTIONS(5528),
    [anon_sym_match_BANG] = ACTIONS(5526),
    [anon_sym_function] = ACTIONS(5528),
    [anon_sym_use] = ACTIONS(5528),
    [anon_sym_use_BANG] = ACTIONS(5526),
    [anon_sym_do_BANG] = ACTIONS(5526),
    [anon_sym_begin] = ACTIONS(5528),
    [aux_sym_char_token1] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5528),
    [anon_sym_DQUOTE] = ACTIONS(5528),
    [anon_sym_AT_DQUOTE] = ACTIONS(5526),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5526),
    [sym_bool] = ACTIONS(5528),
    [sym_unit] = ACTIONS(5526),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5528),
    [sym_op_identifier] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_PLUS_DOT] = ACTIONS(5526),
    [anon_sym_DASH_DOT] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_TILDE] = ACTIONS(5526),
    [aux_sym_prefix_op_token1] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5526),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5526),
    [anon_sym_POUNDload] = ACTIONS(5526),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5526),
    [sym__dedent] = ACTIONS(5526),
  },
  [3219] = {
    [sym_attributes] = STATE(7215),
    [sym_attribute_set] = STATE(4720),
    [sym_xml_doc] = STATE(3219),
    [sym_block_comment] = STATE(3219),
    [sym_line_comment] = STATE(3219),
    [sym_compiler_directive_decl] = STATE(3219),
    [sym_fsi_directive_decl] = STATE(3219),
    [sym_preproc_line] = STATE(3219),
    [aux_sym_attributes_repeat1] = STATE(4296),
    [aux_sym_type_definition_repeat1] = STATE(3215),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_module] = ACTIONS(5538),
    [anon_sym_open] = ACTIONS(5538),
    [anon_sym_LBRACK_LT] = ACTIONS(5536),
    [anon_sym_return] = ACTIONS(5538),
    [anon_sym_type] = ACTIONS(5538),
    [anon_sym_do] = ACTIONS(5538),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_let] = ACTIONS(5538),
    [anon_sym_let_BANG] = ACTIONS(5536),
    [anon_sym_LPAREN] = ACTIONS(5538),
    [anon_sym_null] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5536),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LT_AT] = ACTIONS(5538),
    [anon_sym_LT_AT_AT] = ACTIONS(5536),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5536),
    [anon_sym_new] = ACTIONS(5538),
    [anon_sym_return_BANG] = ACTIONS(5536),
    [anon_sym_yield] = ACTIONS(5538),
    [anon_sym_yield_BANG] = ACTIONS(5536),
    [anon_sym_lazy] = ACTIONS(5538),
    [anon_sym_assert] = ACTIONS(5538),
    [anon_sym_upcast] = ACTIONS(5538),
    [anon_sym_downcast] = ACTIONS(5538),
    [anon_sym_for] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(5538),
    [anon_sym_if] = ACTIONS(5538),
    [anon_sym_fun] = ACTIONS(5538),
    [anon_sym_try] = ACTIONS(5538),
    [anon_sym_match] = ACTIONS(5538),
    [anon_sym_match_BANG] = ACTIONS(5536),
    [anon_sym_function] = ACTIONS(5538),
    [anon_sym_use] = ACTIONS(5538),
    [anon_sym_use_BANG] = ACTIONS(5536),
    [anon_sym_do_BANG] = ACTIONS(5536),
    [anon_sym_begin] = ACTIONS(5538),
    [aux_sym_char_token1] = ACTIONS(5536),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_AT_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5536),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5536),
    [sym_bool] = ACTIONS(5538),
    [sym_unit] = ACTIONS(5536),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5538),
    [sym_op_identifier] = ACTIONS(5536),
    [anon_sym_PLUS] = ACTIONS(5538),
    [anon_sym_DASH] = ACTIONS(5538),
    [anon_sym_PLUS_DOT] = ACTIONS(5536),
    [anon_sym_DASH_DOT] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_TILDE] = ACTIONS(5536),
    [aux_sym_prefix_op_token1] = ACTIONS(5536),
    [sym_int] = ACTIONS(5538),
    [sym_xint] = ACTIONS(5536),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5536),
    [anon_sym_POUNDload] = ACTIONS(5536),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5536),
    [sym__dedent] = ACTIONS(5536),
  },
  [3220] = {
    [sym_interface_implementation] = STATE(3239),
    [sym_xml_doc] = STATE(3220),
    [sym_block_comment] = STATE(3220),
    [sym_line_comment] = STATE(3220),
    [sym_compiler_directive_decl] = STATE(3220),
    [sym_fsi_directive_decl] = STATE(3220),
    [sym_preproc_line] = STATE(3220),
    [aux_sym__object_expression_inner_repeat1] = STATE(3214),
    [ts_builtin_sym_end] = ACTIONS(5562),
    [sym_identifier] = ACTIONS(5564),
    [anon_sym_namespace] = ACTIONS(5564),
    [anon_sym_module] = ACTIONS(5564),
    [anon_sym_open] = ACTIONS(5564),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_return] = ACTIONS(5564),
    [anon_sym_type] = ACTIONS(5564),
    [anon_sym_do] = ACTIONS(5564),
    [anon_sym_and] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_let_BANG] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_LT_AT] = ACTIONS(5564),
    [anon_sym_LT_AT_AT] = ACTIONS(5562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5562),
    [anon_sym_new] = ACTIONS(5564),
    [anon_sym_return_BANG] = ACTIONS(5562),
    [anon_sym_yield] = ACTIONS(5564),
    [anon_sym_yield_BANG] = ACTIONS(5562),
    [anon_sym_lazy] = ACTIONS(5564),
    [anon_sym_assert] = ACTIONS(5564),
    [anon_sym_upcast] = ACTIONS(5564),
    [anon_sym_downcast] = ACTIONS(5564),
    [anon_sym_for] = ACTIONS(5564),
    [anon_sym_while] = ACTIONS(5564),
    [anon_sym_if] = ACTIONS(5564),
    [anon_sym_fun] = ACTIONS(5564),
    [anon_sym_try] = ACTIONS(5564),
    [anon_sym_match] = ACTIONS(5564),
    [anon_sym_match_BANG] = ACTIONS(5562),
    [anon_sym_function] = ACTIONS(5564),
    [anon_sym_use] = ACTIONS(5564),
    [anon_sym_use_BANG] = ACTIONS(5562),
    [anon_sym_do_BANG] = ACTIONS(5562),
    [anon_sym_begin] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5566),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5564),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5564),
    [sym_op_identifier] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_PLUS_DOT] = ACTIONS(5562),
    [anon_sym_DASH_DOT] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [aux_sym_prefix_op_token1] = ACTIONS(5562),
    [sym_int] = ACTIONS(5564),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5562),
    [anon_sym_POUNDload] = ACTIONS(5562),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5562),
  },
  [3221] = {
    [sym_xml_doc] = STATE(3221),
    [sym_block_comment] = STATE(3221),
    [sym_line_comment] = STATE(3221),
    [sym_compiler_directive_decl] = STATE(3221),
    [sym_fsi_directive_decl] = STATE(3221),
    [sym_preproc_line] = STATE(3221),
    [aux_sym_type_argument_repeat1] = STATE(3221),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(5568),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
  },
  [3222] = {
    [sym_xml_doc] = STATE(3222),
    [sym_block_comment] = STATE(3222),
    [sym_line_comment] = STATE(3222),
    [sym_compiler_directive_decl] = STATE(3222),
    [sym_fsi_directive_decl] = STATE(3222),
    [sym_preproc_line] = STATE(3222),
    [aux_sym_type_argument_repeat1] = STATE(3231),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_GT_RBRACK] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(5571),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3232),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3232),
    [anon_sym_DASH_DOT] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3232),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__newline] = ACTIONS(3232),
  },
  [3223] = {
    [sym_type_arguments] = STATE(3352),
    [sym_long_identifier] = STATE(3355),
    [sym_xml_doc] = STATE(3223),
    [sym_block_comment] = STATE(3223),
    [sym_line_comment] = STATE(3223),
    [sym_compiler_directive_decl] = STATE(3223),
    [sym_fsi_directive_decl] = STATE(3223),
    [sym_preproc_line] = STATE(3223),
    [aux_sym__compound_type_repeat1] = STATE(3272),
    [sym_identifier] = ACTIONS(5573),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(2319),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3022),
    [anon_sym_DASH_DOT] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3022),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
  },
  [3224] = {
    [sym_interface_implementation] = STATE(3318),
    [sym_xml_doc] = STATE(3224),
    [sym_block_comment] = STATE(3224),
    [sym_line_comment] = STATE(3224),
    [sym_compiler_directive_decl] = STATE(3224),
    [sym_fsi_directive_decl] = STATE(3224),
    [sym_preproc_line] = STATE(3224),
    [aux_sym__object_expression_inner_repeat1] = STATE(3226),
    [sym_identifier] = ACTIONS(5564),
    [anon_sym_module] = ACTIONS(5564),
    [anon_sym_open] = ACTIONS(5564),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_return] = ACTIONS(5564),
    [anon_sym_type] = ACTIONS(5564),
    [anon_sym_do] = ACTIONS(5564),
    [anon_sym_and] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_let_BANG] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_LT_AT] = ACTIONS(5564),
    [anon_sym_LT_AT_AT] = ACTIONS(5562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5562),
    [anon_sym_new] = ACTIONS(5564),
    [anon_sym_return_BANG] = ACTIONS(5562),
    [anon_sym_yield] = ACTIONS(5564),
    [anon_sym_yield_BANG] = ACTIONS(5562),
    [anon_sym_lazy] = ACTIONS(5564),
    [anon_sym_assert] = ACTIONS(5564),
    [anon_sym_upcast] = ACTIONS(5564),
    [anon_sym_downcast] = ACTIONS(5564),
    [anon_sym_for] = ACTIONS(5564),
    [anon_sym_while] = ACTIONS(5564),
    [anon_sym_if] = ACTIONS(5564),
    [anon_sym_fun] = ACTIONS(5564),
    [anon_sym_try] = ACTIONS(5564),
    [anon_sym_match] = ACTIONS(5564),
    [anon_sym_match_BANG] = ACTIONS(5562),
    [anon_sym_function] = ACTIONS(5564),
    [anon_sym_use] = ACTIONS(5564),
    [anon_sym_use_BANG] = ACTIONS(5562),
    [anon_sym_do_BANG] = ACTIONS(5562),
    [anon_sym_begin] = ACTIONS(5564),
    [anon_sym_interface] = ACTIONS(5575),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5564),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5564),
    [sym_op_identifier] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_PLUS_DOT] = ACTIONS(5562),
    [anon_sym_DASH_DOT] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [aux_sym_prefix_op_token1] = ACTIONS(5562),
    [sym_int] = ACTIONS(5564),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5562),
    [anon_sym_POUNDload] = ACTIONS(5562),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5562),
    [sym__dedent] = ACTIONS(5562),
  },
  [3225] = {
    [sym_xml_doc] = STATE(3225),
    [sym_block_comment] = STATE(3225),
    [sym_line_comment] = STATE(3225),
    [sym_compiler_directive_decl] = STATE(3225),
    [sym_fsi_directive_decl] = STATE(3225),
    [sym_preproc_line] = STATE(3225),
    [aux_sym_type_argument_repeat1] = STATE(3221),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_as] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(5577),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3232),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3232),
    [anon_sym_DASH_DOT] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3232),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
  },
  [3226] = {
    [sym_interface_implementation] = STATE(3318),
    [sym_xml_doc] = STATE(3226),
    [sym_block_comment] = STATE(3226),
    [sym_line_comment] = STATE(3226),
    [sym_compiler_directive_decl] = STATE(3226),
    [sym_fsi_directive_decl] = STATE(3226),
    [sym_preproc_line] = STATE(3226),
    [aux_sym__object_expression_inner_repeat1] = STATE(3226),
    [sym_identifier] = ACTIONS(5552),
    [anon_sym_module] = ACTIONS(5552),
    [anon_sym_open] = ACTIONS(5552),
    [anon_sym_LBRACK_LT] = ACTIONS(5550),
    [anon_sym_return] = ACTIONS(5552),
    [anon_sym_type] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5552),
    [anon_sym_and] = ACTIONS(5552),
    [anon_sym_let] = ACTIONS(5552),
    [anon_sym_let_BANG] = ACTIONS(5550),
    [anon_sym_LPAREN] = ACTIONS(5552),
    [anon_sym_null] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5552),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5550),
    [anon_sym_LBRACE] = ACTIONS(5552),
    [anon_sym_LT_AT] = ACTIONS(5552),
    [anon_sym_LT_AT_AT] = ACTIONS(5550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5550),
    [anon_sym_new] = ACTIONS(5552),
    [anon_sym_return_BANG] = ACTIONS(5550),
    [anon_sym_yield] = ACTIONS(5552),
    [anon_sym_yield_BANG] = ACTIONS(5550),
    [anon_sym_lazy] = ACTIONS(5552),
    [anon_sym_assert] = ACTIONS(5552),
    [anon_sym_upcast] = ACTIONS(5552),
    [anon_sym_downcast] = ACTIONS(5552),
    [anon_sym_for] = ACTIONS(5552),
    [anon_sym_while] = ACTIONS(5552),
    [anon_sym_if] = ACTIONS(5552),
    [anon_sym_fun] = ACTIONS(5552),
    [anon_sym_try] = ACTIONS(5552),
    [anon_sym_match] = ACTIONS(5552),
    [anon_sym_match_BANG] = ACTIONS(5550),
    [anon_sym_function] = ACTIONS(5552),
    [anon_sym_use] = ACTIONS(5552),
    [anon_sym_use_BANG] = ACTIONS(5550),
    [anon_sym_do_BANG] = ACTIONS(5550),
    [anon_sym_begin] = ACTIONS(5552),
    [anon_sym_interface] = ACTIONS(5579),
    [aux_sym_char_token1] = ACTIONS(5550),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5552),
    [anon_sym_DQUOTE] = ACTIONS(5552),
    [anon_sym_AT_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5550),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5550),
    [sym_bool] = ACTIONS(5552),
    [sym_unit] = ACTIONS(5550),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5552),
    [sym_op_identifier] = ACTIONS(5550),
    [anon_sym_PLUS] = ACTIONS(5552),
    [anon_sym_DASH] = ACTIONS(5552),
    [anon_sym_PLUS_DOT] = ACTIONS(5550),
    [anon_sym_DASH_DOT] = ACTIONS(5550),
    [anon_sym_PERCENT] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_TILDE] = ACTIONS(5550),
    [aux_sym_prefix_op_token1] = ACTIONS(5550),
    [sym_int] = ACTIONS(5552),
    [sym_xint] = ACTIONS(5550),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5550),
    [anon_sym_POUNDload] = ACTIONS(5550),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5550),
    [sym__dedent] = ACTIONS(5550),
  },
  [3227] = {
    [sym_type_arguments] = STATE(3352),
    [sym_long_identifier] = STATE(3355),
    [sym_xml_doc] = STATE(3227),
    [sym_block_comment] = STATE(3227),
    [sym_line_comment] = STATE(3227),
    [sym_compiler_directive_decl] = STATE(3227),
    [sym_fsi_directive_decl] = STATE(3227),
    [sym_preproc_line] = STATE(3227),
    [aux_sym__compound_type_repeat1] = STATE(3272),
    [sym_identifier] = ACTIONS(5573),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(2319),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
  },
  [3228] = {
    [sym_xml_doc] = STATE(3228),
    [sym_block_comment] = STATE(3228),
    [sym_line_comment] = STATE(3228),
    [sym_compiler_directive_decl] = STATE(3228),
    [sym_fsi_directive_decl] = STATE(3228),
    [sym_preproc_line] = STATE(3228),
    [aux_sym_type_argument_repeat1] = STATE(3225),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(5577),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
  },
  [3229] = {
    [sym_type_arguments] = STATE(3352),
    [sym_long_identifier] = STATE(3355),
    [sym_xml_doc] = STATE(3229),
    [sym_block_comment] = STATE(3229),
    [sym_line_comment] = STATE(3229),
    [sym_compiler_directive_decl] = STATE(3229),
    [sym_fsi_directive_decl] = STATE(3229),
    [sym_preproc_line] = STATE(3229),
    [aux_sym__compound_type_repeat1] = STATE(3272),
    [sym_identifier] = ACTIONS(5573),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_as] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(2319),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3090),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3090),
    [anon_sym_DASH_DOT] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3090),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
  },
  [3230] = {
    [sym_type_arguments] = STATE(3352),
    [sym_long_identifier] = STATE(3355),
    [sym_xml_doc] = STATE(3230),
    [sym_block_comment] = STATE(3230),
    [sym_line_comment] = STATE(3230),
    [sym_compiler_directive_decl] = STATE(3230),
    [sym_fsi_directive_decl] = STATE(3230),
    [sym_preproc_line] = STATE(3230),
    [aux_sym__compound_type_repeat1] = STATE(3272),
    [sym_identifier] = ACTIONS(5573),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_as] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(2319),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3010),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3010),
    [anon_sym_DASH_DOT] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3010),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
  },
  [3231] = {
    [sym_xml_doc] = STATE(3231),
    [sym_block_comment] = STATE(3231),
    [sym_line_comment] = STATE(3231),
    [sym_compiler_directive_decl] = STATE(3231),
    [sym_fsi_directive_decl] = STATE(3231),
    [sym_preproc_line] = STATE(3231),
    [aux_sym_type_argument_repeat1] = STATE(3231),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_GT_RBRACK] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(5582),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [3232] = {
    [sym_type_arguments] = STATE(3367),
    [sym_long_identifier] = STATE(3325),
    [sym_xml_doc] = STATE(3232),
    [sym_block_comment] = STATE(3232),
    [sym_line_comment] = STATE(3232),
    [sym_compiler_directive_decl] = STATE(3232),
    [sym_fsi_directive_decl] = STATE(3232),
    [sym_preproc_line] = STATE(3232),
    [aux_sym__compound_type_repeat1] = STATE(3277),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_GT_RBRACK] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LT2] = ACTIONS(2299),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2301),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3010),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3010),
    [anon_sym_DASH_DOT] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3010),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__newline] = ACTIONS(3010),
  },
  [3233] = {
    [sym_type_arguments] = STATE(3367),
    [sym_long_identifier] = STATE(3325),
    [sym_xml_doc] = STATE(3233),
    [sym_block_comment] = STATE(3233),
    [sym_line_comment] = STATE(3233),
    [sym_compiler_directive_decl] = STATE(3233),
    [sym_fsi_directive_decl] = STATE(3233),
    [sym_preproc_line] = STATE(3233),
    [aux_sym__compound_type_repeat1] = STATE(3277),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_GT_RBRACK] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LT2] = ACTIONS(2299),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2301),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [3234] = {
    [sym_type_arguments] = STATE(3367),
    [sym_long_identifier] = STATE(3325),
    [sym_xml_doc] = STATE(3234),
    [sym_block_comment] = STATE(3234),
    [sym_line_comment] = STATE(3234),
    [sym_compiler_directive_decl] = STATE(3234),
    [sym_fsi_directive_decl] = STATE(3234),
    [sym_preproc_line] = STATE(3234),
    [aux_sym__compound_type_repeat1] = STATE(3277),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_GT_RBRACK] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LT2] = ACTIONS(2299),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2301),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3090),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3090),
    [anon_sym_DASH_DOT] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3090),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__newline] = ACTIONS(3090),
  },
  [3235] = {
    [sym_xml_doc] = STATE(3235),
    [sym_block_comment] = STATE(3235),
    [sym_line_comment] = STATE(3235),
    [sym_compiler_directive_decl] = STATE(3235),
    [sym_fsi_directive_decl] = STATE(3235),
    [sym_preproc_line] = STATE(3235),
    [aux_sym_type_argument_repeat1] = STATE(3222),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_GT_RBRACK] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(5571),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [3236] = {
    [sym_type_arguments] = STATE(3367),
    [sym_long_identifier] = STATE(3325),
    [sym_xml_doc] = STATE(3236),
    [sym_block_comment] = STATE(3236),
    [sym_line_comment] = STATE(3236),
    [sym_compiler_directive_decl] = STATE(3236),
    [sym_fsi_directive_decl] = STATE(3236),
    [sym_preproc_line] = STATE(3236),
    [aux_sym__compound_type_repeat1] = STATE(3277),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_GT_RBRACK] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(2295),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LT2] = ACTIONS(2299),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2301),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3022),
    [anon_sym_DASH_DOT] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3022),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__newline] = ACTIONS(3022),
  },
  [3237] = {
    [sym_xml_doc] = STATE(3237),
    [sym_block_comment] = STATE(3237),
    [sym_line_comment] = STATE(3237),
    [sym_compiler_directive_decl] = STATE(3237),
    [sym_fsi_directive_decl] = STATE(3237),
    [sym_preproc_line] = STATE(3237),
    [aux_sym_long_identifier_repeat1] = STATE(3264),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
  },
  [3238] = {
    [sym_type_arguments] = STATE(3431),
    [sym_long_identifier] = STATE(3450),
    [sym_xml_doc] = STATE(3238),
    [sym_block_comment] = STATE(3238),
    [sym_line_comment] = STATE(3238),
    [sym_compiler_directive_decl] = STATE(3238),
    [sym_fsi_directive_decl] = STATE(3238),
    [sym_preproc_line] = STATE(3238),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3010),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3010),
    [anon_sym_DASH_DOT] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3010),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
    [sym__dedent] = ACTIONS(3010),
  },
  [3239] = {
    [sym_xml_doc] = STATE(3239),
    [sym_block_comment] = STATE(3239),
    [sym_line_comment] = STATE(3239),
    [sym_compiler_directive_decl] = STATE(3239),
    [sym_fsi_directive_decl] = STATE(3239),
    [sym_preproc_line] = STATE(3239),
    [ts_builtin_sym_end] = ACTIONS(5591),
    [sym_identifier] = ACTIONS(5593),
    [anon_sym_namespace] = ACTIONS(5593),
    [anon_sym_module] = ACTIONS(5593),
    [anon_sym_open] = ACTIONS(5593),
    [anon_sym_LBRACK_LT] = ACTIONS(5591),
    [anon_sym_return] = ACTIONS(5593),
    [anon_sym_type] = ACTIONS(5593),
    [anon_sym_do] = ACTIONS(5593),
    [anon_sym_and] = ACTIONS(5593),
    [anon_sym_let] = ACTIONS(5593),
    [anon_sym_let_BANG] = ACTIONS(5591),
    [anon_sym_LPAREN] = ACTIONS(5593),
    [anon_sym_null] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5593),
    [anon_sym_LBRACK] = ACTIONS(5593),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5591),
    [anon_sym_LBRACE] = ACTIONS(5593),
    [anon_sym_LT_AT] = ACTIONS(5593),
    [anon_sym_LT_AT_AT] = ACTIONS(5591),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5591),
    [anon_sym_new] = ACTIONS(5593),
    [anon_sym_return_BANG] = ACTIONS(5591),
    [anon_sym_yield] = ACTIONS(5593),
    [anon_sym_yield_BANG] = ACTIONS(5591),
    [anon_sym_lazy] = ACTIONS(5593),
    [anon_sym_assert] = ACTIONS(5593),
    [anon_sym_upcast] = ACTIONS(5593),
    [anon_sym_downcast] = ACTIONS(5593),
    [anon_sym_for] = ACTIONS(5593),
    [anon_sym_while] = ACTIONS(5593),
    [anon_sym_if] = ACTIONS(5593),
    [anon_sym_fun] = ACTIONS(5593),
    [anon_sym_try] = ACTIONS(5593),
    [anon_sym_match] = ACTIONS(5593),
    [anon_sym_match_BANG] = ACTIONS(5591),
    [anon_sym_function] = ACTIONS(5593),
    [anon_sym_use] = ACTIONS(5593),
    [anon_sym_use_BANG] = ACTIONS(5591),
    [anon_sym_do_BANG] = ACTIONS(5591),
    [anon_sym_begin] = ACTIONS(5593),
    [anon_sym_interface] = ACTIONS(5593),
    [aux_sym_char_token1] = ACTIONS(5591),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5593),
    [anon_sym_DQUOTE] = ACTIONS(5593),
    [anon_sym_AT_DQUOTE] = ACTIONS(5591),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5591),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5591),
    [sym_bool] = ACTIONS(5593),
    [sym_unit] = ACTIONS(5591),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5593),
    [sym_op_identifier] = ACTIONS(5591),
    [anon_sym_PLUS] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5593),
    [anon_sym_PLUS_DOT] = ACTIONS(5591),
    [anon_sym_DASH_DOT] = ACTIONS(5591),
    [anon_sym_PERCENT] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_TILDE] = ACTIONS(5591),
    [aux_sym_prefix_op_token1] = ACTIONS(5591),
    [sym_int] = ACTIONS(5593),
    [sym_xint] = ACTIONS(5591),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5591),
    [anon_sym_POUNDload] = ACTIONS(5591),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5591),
  },
  [3240] = {
    [sym_xml_doc] = STATE(3240),
    [sym_block_comment] = STATE(3240),
    [sym_line_comment] = STATE(3240),
    [sym_compiler_directive_decl] = STATE(3240),
    [sym_fsi_directive_decl] = STATE(3240),
    [sym_preproc_line] = STATE(3240),
    [aux_sym_long_identifier_repeat1] = STATE(3251),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_GT_RBRACK] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__newline] = ACTIONS(3259),
  },
  [3241] = {
    [sym_xml_doc] = STATE(3241),
    [sym_block_comment] = STATE(3241),
    [sym_line_comment] = STATE(3241),
    [sym_compiler_directive_decl] = STATE(3241),
    [sym_fsi_directive_decl] = STATE(3241),
    [sym_preproc_line] = STATE(3241),
    [ts_builtin_sym_end] = ACTIONS(5597),
    [sym_identifier] = ACTIONS(5599),
    [anon_sym_namespace] = ACTIONS(5599),
    [anon_sym_module] = ACTIONS(5599),
    [anon_sym_open] = ACTIONS(5599),
    [anon_sym_LBRACK_LT] = ACTIONS(5597),
    [anon_sym_return] = ACTIONS(5599),
    [anon_sym_type] = ACTIONS(5599),
    [anon_sym_do] = ACTIONS(5599),
    [anon_sym_and] = ACTIONS(5599),
    [anon_sym_let] = ACTIONS(5599),
    [anon_sym_let_BANG] = ACTIONS(5597),
    [anon_sym_LPAREN] = ACTIONS(5599),
    [anon_sym_null] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5597),
    [anon_sym_LBRACE] = ACTIONS(5599),
    [anon_sym_LT_AT] = ACTIONS(5599),
    [anon_sym_LT_AT_AT] = ACTIONS(5597),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5597),
    [anon_sym_new] = ACTIONS(5599),
    [anon_sym_return_BANG] = ACTIONS(5597),
    [anon_sym_yield] = ACTIONS(5599),
    [anon_sym_yield_BANG] = ACTIONS(5597),
    [anon_sym_lazy] = ACTIONS(5599),
    [anon_sym_assert] = ACTIONS(5599),
    [anon_sym_upcast] = ACTIONS(5599),
    [anon_sym_downcast] = ACTIONS(5599),
    [anon_sym_for] = ACTIONS(5599),
    [anon_sym_while] = ACTIONS(5599),
    [anon_sym_if] = ACTIONS(5599),
    [anon_sym_fun] = ACTIONS(5599),
    [anon_sym_try] = ACTIONS(5599),
    [anon_sym_match] = ACTIONS(5599),
    [anon_sym_match_BANG] = ACTIONS(5597),
    [anon_sym_function] = ACTIONS(5599),
    [anon_sym_use] = ACTIONS(5599),
    [anon_sym_use_BANG] = ACTIONS(5597),
    [anon_sym_do_BANG] = ACTIONS(5597),
    [anon_sym_begin] = ACTIONS(5599),
    [anon_sym_interface] = ACTIONS(5599),
    [aux_sym_char_token1] = ACTIONS(5597),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5599),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_AT_DQUOTE] = ACTIONS(5597),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5597),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5597),
    [sym_bool] = ACTIONS(5599),
    [sym_unit] = ACTIONS(5597),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5599),
    [sym_op_identifier] = ACTIONS(5597),
    [anon_sym_PLUS] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(5599),
    [anon_sym_PLUS_DOT] = ACTIONS(5597),
    [anon_sym_DASH_DOT] = ACTIONS(5597),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [aux_sym_prefix_op_token1] = ACTIONS(5597),
    [sym_int] = ACTIONS(5599),
    [sym_xint] = ACTIONS(5597),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5597),
    [anon_sym_POUNDload] = ACTIONS(5597),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5597),
  },
  [3242] = {
    [sym_xml_doc] = STATE(3242),
    [sym_block_comment] = STATE(3242),
    [sym_line_comment] = STATE(3242),
    [sym_compiler_directive_decl] = STATE(3242),
    [sym_fsi_directive_decl] = STATE(3242),
    [sym_preproc_line] = STATE(3242),
    [aux_sym_long_identifier_repeat1] = STATE(3248),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5601),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
  },
  [3243] = {
    [sym_xml_doc] = STATE(3243),
    [sym_block_comment] = STATE(3243),
    [sym_line_comment] = STATE(3243),
    [sym_compiler_directive_decl] = STATE(3243),
    [sym_fsi_directive_decl] = STATE(3243),
    [sym_preproc_line] = STATE(3243),
    [aux_sym_long_identifier_repeat1] = STATE(3237),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(5603),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3244] = {
    [sym_argument_patterns] = STATE(6607),
    [sym__atomic_pattern] = STATE(4407),
    [sym_list_pattern] = STATE(4440),
    [sym_array_pattern] = STATE(4440),
    [sym_record_pattern] = STATE(4440),
    [sym_type_arguments] = STATE(3552),
    [sym_char] = STATE(4700),
    [sym_format_string] = STATE(4664),
    [sym__string_literal] = STATE(4664),
    [sym_string] = STATE(4700),
    [sym_verbatim_string] = STATE(4700),
    [sym_bytearray] = STATE(4700),
    [sym_verbatim_bytearray] = STATE(4700),
    [sym_format_triple_quoted_string] = STATE(4663),
    [sym_triple_quoted_string] = STATE(4700),
    [sym_const] = STATE(4440),
    [sym_long_identifier] = STATE(4440),
    [sym_sbyte] = STATE(4700),
    [sym_byte] = STATE(4700),
    [sym_int16] = STATE(4700),
    [sym_uint16] = STATE(4700),
    [sym_int32] = STATE(4700),
    [sym_uint32] = STATE(4700),
    [sym_nativeint] = STATE(4700),
    [sym_unativeint] = STATE(4700),
    [sym_int64] = STATE(4700),
    [sym_uint64] = STATE(4700),
    [sym_ieee32] = STATE(4700),
    [sym_ieee64] = STATE(4700),
    [sym_bignum] = STATE(4700),
    [sym_decimal] = STATE(4700),
    [sym_float] = STATE(4269),
    [sym_xml_doc] = STATE(3244),
    [sym_block_comment] = STATE(3244),
    [sym_line_comment] = STATE(3244),
    [sym_compiler_directive_decl] = STATE(3244),
    [sym_fsi_directive_decl] = STATE(3244),
    [sym_preproc_line] = STATE(3244),
    [aux_sym_argument_patterns_repeat1] = STATE(3545),
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(5607),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(5609),
    [anon_sym__] = ACTIONS(5609),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_COLON_QMARK] = ACTIONS(3312),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5613),
    [anon_sym_LBRACE] = ACTIONS(5615),
    [anon_sym_LT2] = ACTIONS(5617),
    [aux_sym_char_token1] = ACTIONS(5619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5623),
    [anon_sym_AT_DQUOTE] = ACTIONS(5625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5629),
    [sym_bool] = ACTIONS(5631),
    [sym_unit] = ACTIONS(5633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3312),
    [sym_int] = ACTIONS(5635),
    [sym_xint] = ACTIONS(5637),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3245] = {
    [sym_xml_doc] = STATE(3245),
    [sym_block_comment] = STATE(3245),
    [sym_line_comment] = STATE(3245),
    [sym_compiler_directive_decl] = STATE(3245),
    [sym_fsi_directive_decl] = STATE(3245),
    [sym_preproc_line] = STATE(3245),
    [aux_sym_long_identifier_repeat1] = STATE(3237),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(5639),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3246] = {
    [sym_xml_doc] = STATE(3246),
    [sym_block_comment] = STATE(3246),
    [sym_line_comment] = STATE(3246),
    [sym_compiler_directive_decl] = STATE(3246),
    [sym_fsi_directive_decl] = STATE(3246),
    [sym_preproc_line] = STATE(3246),
    [aux_sym_long_identifier_repeat1] = STATE(3246),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_GT_RBRACK] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [3247] = {
    [sym_xml_doc] = STATE(3247),
    [sym_block_comment] = STATE(3247),
    [sym_line_comment] = STATE(3247),
    [sym_compiler_directive_decl] = STATE(3247),
    [sym_fsi_directive_decl] = STATE(3247),
    [sym_preproc_line] = STATE(3247),
    [aux_sym_type_argument_repeat1] = STATE(3250),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(5644),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3232),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3232),
    [anon_sym_DASH_DOT] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3232),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
    [sym__dedent] = ACTIONS(3232),
  },
  [3248] = {
    [sym_xml_doc] = STATE(3248),
    [sym_block_comment] = STATE(3248),
    [sym_line_comment] = STATE(3248),
    [sym_compiler_directive_decl] = STATE(3248),
    [sym_fsi_directive_decl] = STATE(3248),
    [sym_preproc_line] = STATE(3248),
    [aux_sym_long_identifier_repeat1] = STATE(3248),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [3249] = {
    [sym_xml_doc] = STATE(3249),
    [sym_block_comment] = STATE(3249),
    [sym_line_comment] = STATE(3249),
    [sym_compiler_directive_decl] = STATE(3249),
    [sym_fsi_directive_decl] = STATE(3249),
    [sym_preproc_line] = STATE(3249),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3265),
    [ts_builtin_sym_end] = ACTIONS(5649),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_namespace] = ACTIONS(5651),
    [anon_sym_module] = ACTIONS(5651),
    [anon_sym_open] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5649),
    [anon_sym_return] = ACTIONS(5651),
    [anon_sym_type] = ACTIONS(5651),
    [anon_sym_do] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(5653),
    [anon_sym_let] = ACTIONS(5651),
    [anon_sym_let_BANG] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(5651),
    [anon_sym_null] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_LBRACK] = ACTIONS(5651),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5651),
    [anon_sym_LT_AT] = ACTIONS(5651),
    [anon_sym_LT_AT_AT] = ACTIONS(5649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5649),
    [anon_sym_new] = ACTIONS(5651),
    [anon_sym_return_BANG] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(5651),
    [anon_sym_yield_BANG] = ACTIONS(5649),
    [anon_sym_lazy] = ACTIONS(5651),
    [anon_sym_assert] = ACTIONS(5651),
    [anon_sym_upcast] = ACTIONS(5651),
    [anon_sym_downcast] = ACTIONS(5651),
    [anon_sym_for] = ACTIONS(5651),
    [anon_sym_while] = ACTIONS(5651),
    [anon_sym_if] = ACTIONS(5651),
    [anon_sym_fun] = ACTIONS(5651),
    [anon_sym_try] = ACTIONS(5651),
    [anon_sym_match] = ACTIONS(5651),
    [anon_sym_match_BANG] = ACTIONS(5649),
    [anon_sym_function] = ACTIONS(5651),
    [anon_sym_use] = ACTIONS(5651),
    [anon_sym_use_BANG] = ACTIONS(5649),
    [anon_sym_do_BANG] = ACTIONS(5649),
    [anon_sym_begin] = ACTIONS(5651),
    [aux_sym_char_token1] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(5651),
    [anon_sym_AT_DQUOTE] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [sym_bool] = ACTIONS(5651),
    [sym_unit] = ACTIONS(5649),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5651),
    [sym_op_identifier] = ACTIONS(5649),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS_DOT] = ACTIONS(5649),
    [anon_sym_DASH_DOT] = ACTIONS(5649),
    [anon_sym_PERCENT] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_TILDE] = ACTIONS(5649),
    [aux_sym_prefix_op_token1] = ACTIONS(5649),
    [sym_int] = ACTIONS(5651),
    [sym_xint] = ACTIONS(5649),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5649),
    [anon_sym_POUNDload] = ACTIONS(5649),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5649),
  },
  [3250] = {
    [sym_xml_doc] = STATE(3250),
    [sym_block_comment] = STATE(3250),
    [sym_line_comment] = STATE(3250),
    [sym_compiler_directive_decl] = STATE(3250),
    [sym_fsi_directive_decl] = STATE(3250),
    [sym_preproc_line] = STATE(3250),
    [aux_sym_type_argument_repeat1] = STATE(3250),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(5655),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [3251] = {
    [sym_xml_doc] = STATE(3251),
    [sym_block_comment] = STATE(3251),
    [sym_line_comment] = STATE(3251),
    [sym_compiler_directive_decl] = STATE(3251),
    [sym_fsi_directive_decl] = STATE(3251),
    [sym_preproc_line] = STATE(3251),
    [aux_sym_long_identifier_repeat1] = STATE(3246),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_GT_RBRACK] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__newline] = ACTIONS(3204),
  },
  [3252] = {
    [sym_argument_patterns] = STATE(6586),
    [sym__atomic_pattern] = STATE(4407),
    [sym_list_pattern] = STATE(4440),
    [sym_array_pattern] = STATE(4440),
    [sym_record_pattern] = STATE(4440),
    [sym_type_arguments] = STATE(3547),
    [sym_char] = STATE(4700),
    [sym_format_string] = STATE(4664),
    [sym__string_literal] = STATE(4664),
    [sym_string] = STATE(4700),
    [sym_verbatim_string] = STATE(4700),
    [sym_bytearray] = STATE(4700),
    [sym_verbatim_bytearray] = STATE(4700),
    [sym_format_triple_quoted_string] = STATE(4663),
    [sym_triple_quoted_string] = STATE(4700),
    [sym_const] = STATE(4440),
    [sym_long_identifier] = STATE(4440),
    [sym_sbyte] = STATE(4700),
    [sym_byte] = STATE(4700),
    [sym_int16] = STATE(4700),
    [sym_uint16] = STATE(4700),
    [sym_int32] = STATE(4700),
    [sym_uint32] = STATE(4700),
    [sym_nativeint] = STATE(4700),
    [sym_unativeint] = STATE(4700),
    [sym_int64] = STATE(4700),
    [sym_uint64] = STATE(4700),
    [sym_ieee32] = STATE(4700),
    [sym_ieee64] = STATE(4700),
    [sym_bignum] = STATE(4700),
    [sym_decimal] = STATE(4700),
    [sym_float] = STATE(4269),
    [sym_xml_doc] = STATE(3252),
    [sym_block_comment] = STATE(3252),
    [sym_line_comment] = STATE(3252),
    [sym_compiler_directive_decl] = STATE(3252),
    [sym_fsi_directive_decl] = STATE(3252),
    [sym_preproc_line] = STATE(3252),
    [aux_sym_argument_patterns_repeat1] = STATE(3545),
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_LBRACK_LT] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_as] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(5607),
    [anon_sym_COMMA] = ACTIONS(3312),
    [anon_sym_null] = ACTIONS(5609),
    [anon_sym__] = ACTIONS(5609),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_COLON_QMARK] = ACTIONS(3312),
    [anon_sym_COLON_COLON] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5613),
    [anon_sym_LBRACE] = ACTIONS(5615),
    [anon_sym_LT2] = ACTIONS(5617),
    [aux_sym_char_token1] = ACTIONS(5619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE] = ACTIONS(5623),
    [anon_sym_AT_DQUOTE] = ACTIONS(5625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5629),
    [sym_bool] = ACTIONS(5631),
    [sym_unit] = ACTIONS(5633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3314),
    [sym_op_identifier] = ACTIONS(3312),
    [sym_int] = ACTIONS(5635),
    [sym_xint] = ACTIONS(5637),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3253] = {
    [sym_type_arguments] = STATE(3431),
    [sym_long_identifier] = STATE(3450),
    [sym_xml_doc] = STATE(3253),
    [sym_block_comment] = STATE(3253),
    [sym_line_comment] = STATE(3253),
    [sym_compiler_directive_decl] = STATE(3253),
    [sym_fsi_directive_decl] = STATE(3253),
    [sym_preproc_line] = STATE(3253),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [3254] = {
    [sym_xml_doc] = STATE(3254),
    [sym_block_comment] = STATE(3254),
    [sym_line_comment] = STATE(3254),
    [sym_compiler_directive_decl] = STATE(3254),
    [sym_fsi_directive_decl] = STATE(3254),
    [sym_preproc_line] = STATE(3254),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3254),
    [ts_builtin_sym_end] = ACTIONS(5658),
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_namespace] = ACTIONS(5660),
    [anon_sym_module] = ACTIONS(5660),
    [anon_sym_open] = ACTIONS(5660),
    [anon_sym_LBRACK_LT] = ACTIONS(5658),
    [anon_sym_return] = ACTIONS(5660),
    [anon_sym_type] = ACTIONS(5660),
    [anon_sym_do] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5662),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_let_BANG] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_null] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5658),
    [anon_sym_LBRACE] = ACTIONS(5660),
    [anon_sym_LT_AT] = ACTIONS(5660),
    [anon_sym_LT_AT_AT] = ACTIONS(5658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5658),
    [anon_sym_new] = ACTIONS(5660),
    [anon_sym_return_BANG] = ACTIONS(5658),
    [anon_sym_yield] = ACTIONS(5660),
    [anon_sym_yield_BANG] = ACTIONS(5658),
    [anon_sym_lazy] = ACTIONS(5660),
    [anon_sym_assert] = ACTIONS(5660),
    [anon_sym_upcast] = ACTIONS(5660),
    [anon_sym_downcast] = ACTIONS(5660),
    [anon_sym_for] = ACTIONS(5660),
    [anon_sym_while] = ACTIONS(5660),
    [anon_sym_if] = ACTIONS(5660),
    [anon_sym_fun] = ACTIONS(5660),
    [anon_sym_try] = ACTIONS(5660),
    [anon_sym_match] = ACTIONS(5660),
    [anon_sym_match_BANG] = ACTIONS(5658),
    [anon_sym_function] = ACTIONS(5660),
    [anon_sym_use] = ACTIONS(5660),
    [anon_sym_use_BANG] = ACTIONS(5658),
    [anon_sym_do_BANG] = ACTIONS(5658),
    [anon_sym_begin] = ACTIONS(5660),
    [aux_sym_char_token1] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5660),
    [anon_sym_AT_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [sym_bool] = ACTIONS(5660),
    [sym_unit] = ACTIONS(5658),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5660),
    [sym_op_identifier] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_DOT] = ACTIONS(5658),
    [anon_sym_DASH_DOT] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_TILDE] = ACTIONS(5658),
    [aux_sym_prefix_op_token1] = ACTIONS(5658),
    [sym_int] = ACTIONS(5660),
    [sym_xint] = ACTIONS(5658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5658),
    [anon_sym_POUNDload] = ACTIONS(5658),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5658),
  },
  [3255] = {
    [sym_type_arguments] = STATE(3431),
    [sym_long_identifier] = STATE(3450),
    [sym_xml_doc] = STATE(3255),
    [sym_block_comment] = STATE(3255),
    [sym_line_comment] = STATE(3255),
    [sym_compiler_directive_decl] = STATE(3255),
    [sym_fsi_directive_decl] = STATE(3255),
    [sym_preproc_line] = STATE(3255),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3022),
    [anon_sym_DASH_DOT] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3022),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
    [sym__dedent] = ACTIONS(3022),
  },
  [3256] = {
    [sym_xml_doc] = STATE(3256),
    [sym_block_comment] = STATE(3256),
    [sym_line_comment] = STATE(3256),
    [sym_compiler_directive_decl] = STATE(3256),
    [sym_fsi_directive_decl] = STATE(3256),
    [sym_preproc_line] = STATE(3256),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_as] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3363),
    [anon_sym_DASH_DOT] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3363),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
  },
  [3257] = {
    [sym_xml_doc] = STATE(3257),
    [sym_block_comment] = STATE(3257),
    [sym_line_comment] = STATE(3257),
    [sym_compiler_directive_decl] = STATE(3257),
    [sym_fsi_directive_decl] = STATE(3257),
    [sym_preproc_line] = STATE(3257),
    [aux_sym_long_identifier_repeat1] = STATE(3237),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3258] = {
    [sym_xml_doc] = STATE(3258),
    [sym_block_comment] = STATE(3258),
    [sym_line_comment] = STATE(3258),
    [sym_compiler_directive_decl] = STATE(3258),
    [sym_fsi_directive_decl] = STATE(3258),
    [sym_preproc_line] = STATE(3258),
    [aux_sym_type_argument_repeat1] = STATE(3247),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(5644),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [3259] = {
    [sym_xml_doc] = STATE(3259),
    [sym_block_comment] = STATE(3259),
    [sym_line_comment] = STATE(3259),
    [sym_compiler_directive_decl] = STATE(3259),
    [sym_fsi_directive_decl] = STATE(3259),
    [sym_preproc_line] = STATE(3259),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
  },
  [3260] = {
    [sym_type_arguments] = STATE(3431),
    [sym_long_identifier] = STATE(3450),
    [sym_xml_doc] = STATE(3260),
    [sym_block_comment] = STATE(3260),
    [sym_line_comment] = STATE(3260),
    [sym_compiler_directive_decl] = STATE(3260),
    [sym_fsi_directive_decl] = STATE(3260),
    [sym_preproc_line] = STATE(3260),
    [aux_sym__compound_type_repeat1] = STATE(3413),
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(2339),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(2343),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2345),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3090),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3090),
    [anon_sym_DASH_DOT] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3090),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
    [sym__dedent] = ACTIONS(3090),
  },
  [3261] = {
    [sym_xml_doc] = STATE(3261),
    [sym_block_comment] = STATE(3261),
    [sym_line_comment] = STATE(3261),
    [sym_compiler_directive_decl] = STATE(3261),
    [sym_fsi_directive_decl] = STATE(3261),
    [sym_preproc_line] = STATE(3261),
    [aux_sym_long_identifier_repeat1] = STATE(3237),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_EQ] = ACTIONS(5667),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3262] = {
    [sym_xml_doc] = STATE(3262),
    [sym_block_comment] = STATE(3262),
    [sym_line_comment] = STATE(3262),
    [sym_compiler_directive_decl] = STATE(3262),
    [sym_fsi_directive_decl] = STATE(3262),
    [sym_preproc_line] = STATE(3262),
    [aux_sym_long_identifier_repeat1] = STATE(3237),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3263] = {
    [sym_xml_doc] = STATE(3263),
    [sym_block_comment] = STATE(3263),
    [sym_line_comment] = STATE(3263),
    [sym_compiler_directive_decl] = STATE(3263),
    [sym_fsi_directive_decl] = STATE(3263),
    [sym_preproc_line] = STATE(3263),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_GT_RBRACK] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3363),
    [anon_sym_DASH_DOT] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3363),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__newline] = ACTIONS(3363),
  },
  [3264] = {
    [sym_xml_doc] = STATE(3264),
    [sym_block_comment] = STATE(3264),
    [sym_line_comment] = STATE(3264),
    [sym_compiler_directive_decl] = STATE(3264),
    [sym_fsi_directive_decl] = STATE(3264),
    [sym_preproc_line] = STATE(3264),
    [aux_sym_long_identifier_repeat1] = STATE(3264),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [3265] = {
    [sym_xml_doc] = STATE(3265),
    [sym_block_comment] = STATE(3265),
    [sym_line_comment] = STATE(3265),
    [sym_compiler_directive_decl] = STATE(3265),
    [sym_fsi_directive_decl] = STATE(3265),
    [sym_preproc_line] = STATE(3265),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3254),
    [ts_builtin_sym_end] = ACTIONS(5672),
    [sym_identifier] = ACTIONS(5674),
    [anon_sym_namespace] = ACTIONS(5674),
    [anon_sym_module] = ACTIONS(5674),
    [anon_sym_open] = ACTIONS(5674),
    [anon_sym_LBRACK_LT] = ACTIONS(5672),
    [anon_sym_return] = ACTIONS(5674),
    [anon_sym_type] = ACTIONS(5674),
    [anon_sym_do] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(5653),
    [anon_sym_let] = ACTIONS(5674),
    [anon_sym_let_BANG] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5674),
    [anon_sym_null] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_LT_AT] = ACTIONS(5674),
    [anon_sym_LT_AT_AT] = ACTIONS(5672),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5672),
    [anon_sym_new] = ACTIONS(5674),
    [anon_sym_return_BANG] = ACTIONS(5672),
    [anon_sym_yield] = ACTIONS(5674),
    [anon_sym_yield_BANG] = ACTIONS(5672),
    [anon_sym_lazy] = ACTIONS(5674),
    [anon_sym_assert] = ACTIONS(5674),
    [anon_sym_upcast] = ACTIONS(5674),
    [anon_sym_downcast] = ACTIONS(5674),
    [anon_sym_for] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5674),
    [anon_sym_if] = ACTIONS(5674),
    [anon_sym_fun] = ACTIONS(5674),
    [anon_sym_try] = ACTIONS(5674),
    [anon_sym_match] = ACTIONS(5674),
    [anon_sym_match_BANG] = ACTIONS(5672),
    [anon_sym_function] = ACTIONS(5674),
    [anon_sym_use] = ACTIONS(5674),
    [anon_sym_use_BANG] = ACTIONS(5672),
    [anon_sym_do_BANG] = ACTIONS(5672),
    [anon_sym_begin] = ACTIONS(5674),
    [aux_sym_char_token1] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [anon_sym_AT_DQUOTE] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [sym_bool] = ACTIONS(5674),
    [sym_unit] = ACTIONS(5672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5674),
    [sym_op_identifier] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_DOT] = ACTIONS(5672),
    [anon_sym_DASH_DOT] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5672),
    [aux_sym_prefix_op_token1] = ACTIONS(5672),
    [sym_int] = ACTIONS(5674),
    [sym_xint] = ACTIONS(5672),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5672),
    [anon_sym_POUNDload] = ACTIONS(5672),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5672),
  },
  [3266] = {
    [sym_xml_doc] = STATE(3266),
    [sym_block_comment] = STATE(3266),
    [sym_line_comment] = STATE(3266),
    [sym_compiler_directive_decl] = STATE(3266),
    [sym_fsi_directive_decl] = STATE(3266),
    [sym_preproc_line] = STATE(3266),
    [ts_builtin_sym_end] = ACTIONS(5676),
    [sym_identifier] = ACTIONS(5678),
    [anon_sym_namespace] = ACTIONS(5678),
    [anon_sym_module] = ACTIONS(5678),
    [anon_sym_open] = ACTIONS(5678),
    [anon_sym_LBRACK_LT] = ACTIONS(5676),
    [anon_sym_return] = ACTIONS(5678),
    [anon_sym_type] = ACTIONS(5678),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_and] = ACTIONS(5678),
    [anon_sym_let] = ACTIONS(5678),
    [anon_sym_let_BANG] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5678),
    [anon_sym_null] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5676),
    [anon_sym_LBRACE] = ACTIONS(5678),
    [anon_sym_LT_AT] = ACTIONS(5678),
    [anon_sym_LT_AT_AT] = ACTIONS(5676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5676),
    [anon_sym_new] = ACTIONS(5678),
    [anon_sym_return_BANG] = ACTIONS(5676),
    [anon_sym_yield] = ACTIONS(5678),
    [anon_sym_yield_BANG] = ACTIONS(5676),
    [anon_sym_lazy] = ACTIONS(5678),
    [anon_sym_assert] = ACTIONS(5678),
    [anon_sym_upcast] = ACTIONS(5678),
    [anon_sym_downcast] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5678),
    [anon_sym_while] = ACTIONS(5678),
    [anon_sym_if] = ACTIONS(5678),
    [anon_sym_fun] = ACTIONS(5678),
    [anon_sym_try] = ACTIONS(5678),
    [anon_sym_match] = ACTIONS(5678),
    [anon_sym_match_BANG] = ACTIONS(5676),
    [anon_sym_function] = ACTIONS(5678),
    [anon_sym_use] = ACTIONS(5678),
    [anon_sym_use_BANG] = ACTIONS(5676),
    [anon_sym_do_BANG] = ACTIONS(5676),
    [anon_sym_begin] = ACTIONS(5678),
    [anon_sym_interface] = ACTIONS(5678),
    [aux_sym_char_token1] = ACTIONS(5676),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5678),
    [anon_sym_DQUOTE] = ACTIONS(5678),
    [anon_sym_AT_DQUOTE] = ACTIONS(5676),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5676),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5676),
    [sym_bool] = ACTIONS(5678),
    [sym_unit] = ACTIONS(5676),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5678),
    [sym_op_identifier] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_PLUS_DOT] = ACTIONS(5676),
    [anon_sym_DASH_DOT] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5676),
    [aux_sym_prefix_op_token1] = ACTIONS(5676),
    [sym_int] = ACTIONS(5678),
    [sym_xint] = ACTIONS(5676),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5676),
    [anon_sym_POUNDload] = ACTIONS(5676),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5676),
  },
  [3267] = {
    [sym_xml_doc] = STATE(3267),
    [sym_block_comment] = STATE(3267),
    [sym_line_comment] = STATE(3267),
    [sym_compiler_directive_decl] = STATE(3267),
    [sym_fsi_directive_decl] = STATE(3267),
    [sym_preproc_line] = STATE(3267),
    [aux_sym_long_identifier_repeat1] = STATE(3242),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_as] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5601),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3268] = {
    [sym_xml_doc] = STATE(3268),
    [sym_block_comment] = STATE(3268),
    [sym_line_comment] = STATE(3268),
    [sym_compiler_directive_decl] = STATE(3268),
    [sym_fsi_directive_decl] = STATE(3268),
    [sym_preproc_line] = STATE(3268),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_GT_RBRACK] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__newline] = ACTIONS(3276),
  },
  [3269] = {
    [sym_xml_doc] = STATE(3269),
    [sym_block_comment] = STATE(3269),
    [sym_line_comment] = STATE(3269),
    [sym_compiler_directive_decl] = STATE(3269),
    [sym_fsi_directive_decl] = STATE(3269),
    [sym_preproc_line] = STATE(3269),
    [ts_builtin_sym_end] = ACTIONS(5680),
    [sym_identifier] = ACTIONS(5682),
    [anon_sym_namespace] = ACTIONS(5682),
    [anon_sym_module] = ACTIONS(5682),
    [anon_sym_open] = ACTIONS(5682),
    [anon_sym_LBRACK_LT] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_type] = ACTIONS(5682),
    [anon_sym_do] = ACTIONS(5682),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_let_BANG] = ACTIONS(5680),
    [anon_sym_LPAREN] = ACTIONS(5682),
    [anon_sym_null] = ACTIONS(5682),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5680),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_LT_AT] = ACTIONS(5682),
    [anon_sym_LT_AT_AT] = ACTIONS(5680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5680),
    [anon_sym_new] = ACTIONS(5682),
    [anon_sym_return_BANG] = ACTIONS(5680),
    [anon_sym_yield] = ACTIONS(5682),
    [anon_sym_yield_BANG] = ACTIONS(5680),
    [anon_sym_lazy] = ACTIONS(5682),
    [anon_sym_assert] = ACTIONS(5682),
    [anon_sym_upcast] = ACTIONS(5682),
    [anon_sym_downcast] = ACTIONS(5682),
    [anon_sym_for] = ACTIONS(5682),
    [anon_sym_while] = ACTIONS(5682),
    [anon_sym_if] = ACTIONS(5682),
    [anon_sym_fun] = ACTIONS(5682),
    [anon_sym_try] = ACTIONS(5682),
    [anon_sym_match] = ACTIONS(5682),
    [anon_sym_match_BANG] = ACTIONS(5680),
    [anon_sym_function] = ACTIONS(5682),
    [anon_sym_use] = ACTIONS(5682),
    [anon_sym_use_BANG] = ACTIONS(5680),
    [anon_sym_do_BANG] = ACTIONS(5680),
    [anon_sym_begin] = ACTIONS(5682),
    [aux_sym_char_token1] = ACTIONS(5680),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5682),
    [anon_sym_DQUOTE] = ACTIONS(5682),
    [anon_sym_AT_DQUOTE] = ACTIONS(5680),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5680),
    [sym_bool] = ACTIONS(5682),
    [sym_unit] = ACTIONS(5680),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5682),
    [sym_op_identifier] = ACTIONS(5680),
    [anon_sym_PLUS] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_DOT] = ACTIONS(5680),
    [anon_sym_DASH_DOT] = ACTIONS(5680),
    [anon_sym_PERCENT] = ACTIONS(5680),
    [anon_sym_AMP_AMP] = ACTIONS(5680),
    [anon_sym_TILDE] = ACTIONS(5680),
    [aux_sym_prefix_op_token1] = ACTIONS(5680),
    [sym_int] = ACTIONS(5682),
    [sym_xint] = ACTIONS(5680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5680),
    [anon_sym_POUNDload] = ACTIONS(5680),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5680),
  },
  [3270] = {
    [sym_xml_doc] = STATE(3270),
    [sym_block_comment] = STATE(3270),
    [sym_line_comment] = STATE(3270),
    [sym_compiler_directive_decl] = STATE(3270),
    [sym_fsi_directive_decl] = STATE(3270),
    [sym_preproc_line] = STATE(3270),
    [ts_builtin_sym_end] = ACTIONS(5684),
    [sym_identifier] = ACTIONS(5686),
    [anon_sym_namespace] = ACTIONS(5686),
    [anon_sym_module] = ACTIONS(5686),
    [anon_sym_open] = ACTIONS(5686),
    [anon_sym_LBRACK_LT] = ACTIONS(5684),
    [anon_sym_return] = ACTIONS(5686),
    [anon_sym_type] = ACTIONS(5686),
    [anon_sym_do] = ACTIONS(5686),
    [anon_sym_and] = ACTIONS(5686),
    [anon_sym_let] = ACTIONS(5686),
    [anon_sym_let_BANG] = ACTIONS(5684),
    [anon_sym_LPAREN] = ACTIONS(5686),
    [anon_sym_null] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5684),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_LT_AT] = ACTIONS(5686),
    [anon_sym_LT_AT_AT] = ACTIONS(5684),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5684),
    [anon_sym_new] = ACTIONS(5686),
    [anon_sym_return_BANG] = ACTIONS(5684),
    [anon_sym_yield] = ACTIONS(5686),
    [anon_sym_yield_BANG] = ACTIONS(5684),
    [anon_sym_lazy] = ACTIONS(5686),
    [anon_sym_assert] = ACTIONS(5686),
    [anon_sym_upcast] = ACTIONS(5686),
    [anon_sym_downcast] = ACTIONS(5686),
    [anon_sym_for] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_fun] = ACTIONS(5686),
    [anon_sym_try] = ACTIONS(5686),
    [anon_sym_match] = ACTIONS(5686),
    [anon_sym_match_BANG] = ACTIONS(5684),
    [anon_sym_function] = ACTIONS(5686),
    [anon_sym_use] = ACTIONS(5686),
    [anon_sym_use_BANG] = ACTIONS(5684),
    [anon_sym_do_BANG] = ACTIONS(5684),
    [anon_sym_begin] = ACTIONS(5686),
    [aux_sym_char_token1] = ACTIONS(5684),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5686),
    [anon_sym_DQUOTE] = ACTIONS(5686),
    [anon_sym_AT_DQUOTE] = ACTIONS(5684),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5684),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5684),
    [sym_bool] = ACTIONS(5686),
    [sym_unit] = ACTIONS(5684),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5686),
    [sym_op_identifier] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_DOT] = ACTIONS(5684),
    [anon_sym_DASH_DOT] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5684),
    [aux_sym_prefix_op_token1] = ACTIONS(5684),
    [sym_int] = ACTIONS(5686),
    [sym_xint] = ACTIONS(5684),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5684),
    [anon_sym_POUNDload] = ACTIONS(5684),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5684),
  },
  [3271] = {
    [sym_type_arguments] = STATE(3472),
    [sym_long_identifier] = STATE(3471),
    [sym_xml_doc] = STATE(3271),
    [sym_block_comment] = STATE(3271),
    [sym_line_comment] = STATE(3271),
    [sym_compiler_directive_decl] = STATE(3271),
    [sym_fsi_directive_decl] = STATE(3271),
    [sym_preproc_line] = STATE(3271),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_let_BANG] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_null] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_LT_AT] = ACTIONS(3012),
    [anon_sym_LT_AT_AT] = ACTIONS(3010),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_return_BANG] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_yield_BANG] = ACTIONS(3010),
    [anon_sym_lazy] = ACTIONS(3012),
    [anon_sym_assert] = ACTIONS(3012),
    [anon_sym_upcast] = ACTIONS(3012),
    [anon_sym_downcast] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_fun] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_match] = ACTIONS(3012),
    [anon_sym_match_BANG] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_use] = ACTIONS(3012),
    [anon_sym_use_BANG] = ACTIONS(3010),
    [anon_sym_do_BANG] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_AT_DQUOTE] = ACTIONS(3010),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3010),
    [sym_bool] = ACTIONS(3012),
    [sym_unit] = ACTIONS(3010),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3012),
    [sym_op_identifier] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_DOT] = ACTIONS(3010),
    [anon_sym_DASH_DOT] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [aux_sym_prefix_op_token1] = ACTIONS(3010),
    [sym_int] = ACTIONS(3012),
    [sym_xint] = ACTIONS(3010),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3010),
  },
  [3272] = {
    [sym_xml_doc] = STATE(3272),
    [sym_block_comment] = STATE(3272),
    [sym_line_comment] = STATE(3272),
    [sym_compiler_directive_decl] = STATE(3272),
    [sym_fsi_directive_decl] = STATE(3272),
    [sym_preproc_line] = STATE(3272),
    [aux_sym__compound_type_repeat1] = STATE(3290),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_as] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3214),
    [anon_sym_DASH_DOT] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3214),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
  },
  [3273] = {
    [sym_xml_doc] = STATE(3273),
    [sym_block_comment] = STATE(3273),
    [sym_line_comment] = STATE(3273),
    [sym_compiler_directive_decl] = STATE(3273),
    [sym_fsi_directive_decl] = STATE(3273),
    [sym_preproc_line] = STATE(3273),
    [aux_sym_long_identifier_repeat1] = STATE(3274),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [3274] = {
    [sym_xml_doc] = STATE(3274),
    [sym_block_comment] = STATE(3274),
    [sym_line_comment] = STATE(3274),
    [sym_compiler_directive_decl] = STATE(3274),
    [sym_fsi_directive_decl] = STATE(3274),
    [sym_preproc_line] = STATE(3274),
    [aux_sym_long_identifier_repeat1] = STATE(3274),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5692),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [3275] = {
    [sym_xml_doc] = STATE(3275),
    [sym_block_comment] = STATE(3275),
    [sym_line_comment] = STATE(3275),
    [sym_compiler_directive_decl] = STATE(3275),
    [sym_fsi_directive_decl] = STATE(3275),
    [sym_preproc_line] = STATE(3275),
    [sym_identifier] = ACTIONS(5599),
    [anon_sym_module] = ACTIONS(5599),
    [anon_sym_open] = ACTIONS(5599),
    [anon_sym_LBRACK_LT] = ACTIONS(5597),
    [anon_sym_return] = ACTIONS(5599),
    [anon_sym_type] = ACTIONS(5599),
    [anon_sym_do] = ACTIONS(5599),
    [anon_sym_and] = ACTIONS(5599),
    [anon_sym_let] = ACTIONS(5599),
    [anon_sym_let_BANG] = ACTIONS(5597),
    [anon_sym_LPAREN] = ACTIONS(5599),
    [anon_sym_null] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5597),
    [anon_sym_LBRACE] = ACTIONS(5599),
    [anon_sym_LT_AT] = ACTIONS(5599),
    [anon_sym_LT_AT_AT] = ACTIONS(5597),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5597),
    [anon_sym_new] = ACTIONS(5599),
    [anon_sym_return_BANG] = ACTIONS(5597),
    [anon_sym_yield] = ACTIONS(5599),
    [anon_sym_yield_BANG] = ACTIONS(5597),
    [anon_sym_lazy] = ACTIONS(5599),
    [anon_sym_assert] = ACTIONS(5599),
    [anon_sym_upcast] = ACTIONS(5599),
    [anon_sym_downcast] = ACTIONS(5599),
    [anon_sym_for] = ACTIONS(5599),
    [anon_sym_while] = ACTIONS(5599),
    [anon_sym_if] = ACTIONS(5599),
    [anon_sym_fun] = ACTIONS(5599),
    [anon_sym_try] = ACTIONS(5599),
    [anon_sym_match] = ACTIONS(5599),
    [anon_sym_match_BANG] = ACTIONS(5597),
    [anon_sym_function] = ACTIONS(5599),
    [anon_sym_use] = ACTIONS(5599),
    [anon_sym_use_BANG] = ACTIONS(5597),
    [anon_sym_do_BANG] = ACTIONS(5597),
    [anon_sym_begin] = ACTIONS(5599),
    [anon_sym_interface] = ACTIONS(5599),
    [aux_sym_char_token1] = ACTIONS(5597),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5599),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_AT_DQUOTE] = ACTIONS(5597),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5597),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5597),
    [sym_bool] = ACTIONS(5599),
    [sym_unit] = ACTIONS(5597),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5599),
    [sym_op_identifier] = ACTIONS(5597),
    [anon_sym_PLUS] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(5599),
    [anon_sym_PLUS_DOT] = ACTIONS(5597),
    [anon_sym_DASH_DOT] = ACTIONS(5597),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [aux_sym_prefix_op_token1] = ACTIONS(5597),
    [sym_int] = ACTIONS(5599),
    [sym_xint] = ACTIONS(5597),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5597),
    [anon_sym_POUNDload] = ACTIONS(5597),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5597),
    [sym__dedent] = ACTIONS(5597),
  },
  [3276] = {
    [sym_xml_doc] = STATE(3276),
    [sym_block_comment] = STATE(3276),
    [sym_line_comment] = STATE(3276),
    [sym_compiler_directive_decl] = STATE(3276),
    [sym_fsi_directive_decl] = STATE(3276),
    [sym_preproc_line] = STATE(3276),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [3277] = {
    [sym_xml_doc] = STATE(3277),
    [sym_block_comment] = STATE(3277),
    [sym_line_comment] = STATE(3277),
    [sym_compiler_directive_decl] = STATE(3277),
    [sym_fsi_directive_decl] = STATE(3277),
    [sym_preproc_line] = STATE(3277),
    [aux_sym__compound_type_repeat1] = STATE(3291),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_GT_RBRACK] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3214),
    [anon_sym_DASH_DOT] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3214),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__newline] = ACTIONS(3214),
  },
  [3278] = {
    [sym_type_arguments] = STATE(3472),
    [sym_long_identifier] = STATE(3471),
    [sym_xml_doc] = STATE(3278),
    [sym_block_comment] = STATE(3278),
    [sym_line_comment] = STATE(3278),
    [sym_compiler_directive_decl] = STATE(3278),
    [sym_fsi_directive_decl] = STATE(3278),
    [sym_preproc_line] = STATE(3278),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_let_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_null] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_LT_AT] = ACTIONS(3092),
    [anon_sym_LT_AT_AT] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_return_BANG] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_yield_BANG] = ACTIONS(3090),
    [anon_sym_lazy] = ACTIONS(3092),
    [anon_sym_assert] = ACTIONS(3092),
    [anon_sym_upcast] = ACTIONS(3092),
    [anon_sym_downcast] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_fun] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_match_BANG] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_use] = ACTIONS(3092),
    [anon_sym_use_BANG] = ACTIONS(3090),
    [anon_sym_do_BANG] = ACTIONS(3090),
    [anon_sym_begin] = ACTIONS(3092),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_AT_DQUOTE] = ACTIONS(3090),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3090),
    [sym_bool] = ACTIONS(3092),
    [sym_unit] = ACTIONS(3090),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3092),
    [sym_op_identifier] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_DOT] = ACTIONS(3090),
    [anon_sym_DASH_DOT] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [aux_sym_prefix_op_token1] = ACTIONS(3090),
    [sym_int] = ACTIONS(3092),
    [sym_xint] = ACTIONS(3090),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3090),
  },
  [3279] = {
    [sym_xml_doc] = STATE(3279),
    [sym_block_comment] = STATE(3279),
    [sym_line_comment] = STATE(3279),
    [sym_compiler_directive_decl] = STATE(3279),
    [sym_fsi_directive_decl] = STATE(3279),
    [sym_preproc_line] = STATE(3279),
    [aux_sym_long_identifier_repeat1] = STATE(3297),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_open] = ACTIONS(3202),
    [anon_sym_LBRACK_LT] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5695),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3204),
    [anon_sym_POUNDload] = ACTIONS(3204),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
    [sym__dedent] = ACTIONS(3204),
  },
  [3280] = {
    [sym_xml_doc] = STATE(3280),
    [sym_block_comment] = STATE(3280),
    [sym_line_comment] = STATE(3280),
    [sym_compiler_directive_decl] = STATE(3280),
    [sym_fsi_directive_decl] = STATE(3280),
    [sym_preproc_line] = STATE(3280),
    [ts_builtin_sym_end] = ACTIONS(5697),
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_namespace] = ACTIONS(5699),
    [anon_sym_module] = ACTIONS(5699),
    [anon_sym_open] = ACTIONS(5699),
    [anon_sym_LBRACK_LT] = ACTIONS(5697),
    [anon_sym_return] = ACTIONS(5699),
    [anon_sym_type] = ACTIONS(5699),
    [anon_sym_do] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_let] = ACTIONS(5699),
    [anon_sym_let_BANG] = ACTIONS(5697),
    [anon_sym_LPAREN] = ACTIONS(5699),
    [anon_sym_null] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5697),
    [anon_sym_LBRACE] = ACTIONS(5699),
    [anon_sym_LT_AT] = ACTIONS(5699),
    [anon_sym_LT_AT_AT] = ACTIONS(5697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5699),
    [anon_sym_return_BANG] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5699),
    [anon_sym_yield_BANG] = ACTIONS(5697),
    [anon_sym_lazy] = ACTIONS(5699),
    [anon_sym_assert] = ACTIONS(5699),
    [anon_sym_upcast] = ACTIONS(5699),
    [anon_sym_downcast] = ACTIONS(5699),
    [anon_sym_for] = ACTIONS(5699),
    [anon_sym_while] = ACTIONS(5699),
    [anon_sym_if] = ACTIONS(5699),
    [anon_sym_fun] = ACTIONS(5699),
    [anon_sym_try] = ACTIONS(5699),
    [anon_sym_match] = ACTIONS(5699),
    [anon_sym_match_BANG] = ACTIONS(5697),
    [anon_sym_function] = ACTIONS(5699),
    [anon_sym_use] = ACTIONS(5699),
    [anon_sym_use_BANG] = ACTIONS(5697),
    [anon_sym_do_BANG] = ACTIONS(5697),
    [anon_sym_begin] = ACTIONS(5699),
    [aux_sym_char_token1] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [anon_sym_AT_DQUOTE] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [sym_bool] = ACTIONS(5699),
    [sym_unit] = ACTIONS(5697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5699),
    [sym_op_identifier] = ACTIONS(5697),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS_DOT] = ACTIONS(5697),
    [anon_sym_DASH_DOT] = ACTIONS(5697),
    [anon_sym_PERCENT] = ACTIONS(5697),
    [anon_sym_AMP_AMP] = ACTIONS(5697),
    [anon_sym_TILDE] = ACTIONS(5697),
    [aux_sym_prefix_op_token1] = ACTIONS(5697),
    [sym_int] = ACTIONS(5699),
    [sym_xint] = ACTIONS(5697),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5697),
    [anon_sym_POUNDload] = ACTIONS(5697),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5697),
  },
  [3281] = {
    [sym_xml_doc] = STATE(3281),
    [sym_block_comment] = STATE(3281),
    [sym_line_comment] = STATE(3281),
    [sym_compiler_directive_decl] = STATE(3281),
    [sym_fsi_directive_decl] = STATE(3281),
    [sym_preproc_line] = STATE(3281),
    [aux_sym_long_identifier_repeat1] = STATE(3273),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [3282] = {
    [sym_xml_doc] = STATE(3282),
    [sym_block_comment] = STATE(3282),
    [sym_line_comment] = STATE(3282),
    [sym_compiler_directive_decl] = STATE(3282),
    [sym_fsi_directive_decl] = STATE(3282),
    [sym_preproc_line] = STATE(3282),
    [ts_builtin_sym_end] = ACTIONS(5701),
    [sym_identifier] = ACTIONS(5703),
    [anon_sym_namespace] = ACTIONS(5703),
    [anon_sym_module] = ACTIONS(5703),
    [anon_sym_open] = ACTIONS(5703),
    [anon_sym_LBRACK_LT] = ACTIONS(5701),
    [anon_sym_return] = ACTIONS(5703),
    [anon_sym_type] = ACTIONS(5703),
    [anon_sym_do] = ACTIONS(5703),
    [anon_sym_and] = ACTIONS(5703),
    [anon_sym_let] = ACTIONS(5703),
    [anon_sym_let_BANG] = ACTIONS(5701),
    [anon_sym_LPAREN] = ACTIONS(5703),
    [anon_sym_null] = ACTIONS(5703),
    [anon_sym_AMP] = ACTIONS(5703),
    [anon_sym_LBRACK] = ACTIONS(5703),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5701),
    [anon_sym_LBRACE] = ACTIONS(5703),
    [anon_sym_LT_AT] = ACTIONS(5703),
    [anon_sym_LT_AT_AT] = ACTIONS(5701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5701),
    [anon_sym_new] = ACTIONS(5703),
    [anon_sym_return_BANG] = ACTIONS(5701),
    [anon_sym_yield] = ACTIONS(5703),
    [anon_sym_yield_BANG] = ACTIONS(5701),
    [anon_sym_lazy] = ACTIONS(5703),
    [anon_sym_assert] = ACTIONS(5703),
    [anon_sym_upcast] = ACTIONS(5703),
    [anon_sym_downcast] = ACTIONS(5703),
    [anon_sym_for] = ACTIONS(5703),
    [anon_sym_while] = ACTIONS(5703),
    [anon_sym_if] = ACTIONS(5703),
    [anon_sym_fun] = ACTIONS(5703),
    [anon_sym_try] = ACTIONS(5703),
    [anon_sym_match] = ACTIONS(5703),
    [anon_sym_match_BANG] = ACTIONS(5701),
    [anon_sym_function] = ACTIONS(5703),
    [anon_sym_use] = ACTIONS(5703),
    [anon_sym_use_BANG] = ACTIONS(5701),
    [anon_sym_do_BANG] = ACTIONS(5701),
    [anon_sym_begin] = ACTIONS(5703),
    [aux_sym_char_token1] = ACTIONS(5701),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5703),
    [anon_sym_DQUOTE] = ACTIONS(5703),
    [anon_sym_AT_DQUOTE] = ACTIONS(5701),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5701),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5701),
    [sym_bool] = ACTIONS(5703),
    [sym_unit] = ACTIONS(5701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5703),
    [sym_op_identifier] = ACTIONS(5701),
    [anon_sym_PLUS] = ACTIONS(5703),
    [anon_sym_DASH] = ACTIONS(5703),
    [anon_sym_PLUS_DOT] = ACTIONS(5701),
    [anon_sym_DASH_DOT] = ACTIONS(5701),
    [anon_sym_PERCENT] = ACTIONS(5701),
    [anon_sym_AMP_AMP] = ACTIONS(5701),
    [anon_sym_TILDE] = ACTIONS(5701),
    [aux_sym_prefix_op_token1] = ACTIONS(5701),
    [sym_int] = ACTIONS(5703),
    [sym_xint] = ACTIONS(5701),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5701),
    [anon_sym_POUNDload] = ACTIONS(5701),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5701),
  },
  [3283] = {
    [sym_xml_doc] = STATE(3283),
    [sym_block_comment] = STATE(3283),
    [sym_line_comment] = STATE(3283),
    [sym_compiler_directive_decl] = STATE(3283),
    [sym_fsi_directive_decl] = STATE(3283),
    [sym_preproc_line] = STATE(3283),
    [ts_builtin_sym_end] = ACTIONS(5705),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_namespace] = ACTIONS(5707),
    [anon_sym_module] = ACTIONS(5707),
    [anon_sym_open] = ACTIONS(5707),
    [anon_sym_LBRACK_LT] = ACTIONS(5705),
    [anon_sym_return] = ACTIONS(5707),
    [anon_sym_type] = ACTIONS(5707),
    [anon_sym_do] = ACTIONS(5707),
    [anon_sym_and] = ACTIONS(5707),
    [anon_sym_let] = ACTIONS(5707),
    [anon_sym_let_BANG] = ACTIONS(5705),
    [anon_sym_LPAREN] = ACTIONS(5707),
    [anon_sym_null] = ACTIONS(5707),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5705),
    [anon_sym_LBRACE] = ACTIONS(5707),
    [anon_sym_LT_AT] = ACTIONS(5707),
    [anon_sym_LT_AT_AT] = ACTIONS(5705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5705),
    [anon_sym_new] = ACTIONS(5707),
    [anon_sym_return_BANG] = ACTIONS(5705),
    [anon_sym_yield] = ACTIONS(5707),
    [anon_sym_yield_BANG] = ACTIONS(5705),
    [anon_sym_lazy] = ACTIONS(5707),
    [anon_sym_assert] = ACTIONS(5707),
    [anon_sym_upcast] = ACTIONS(5707),
    [anon_sym_downcast] = ACTIONS(5707),
    [anon_sym_for] = ACTIONS(5707),
    [anon_sym_while] = ACTIONS(5707),
    [anon_sym_if] = ACTIONS(5707),
    [anon_sym_fun] = ACTIONS(5707),
    [anon_sym_try] = ACTIONS(5707),
    [anon_sym_match] = ACTIONS(5707),
    [anon_sym_match_BANG] = ACTIONS(5705),
    [anon_sym_function] = ACTIONS(5707),
    [anon_sym_use] = ACTIONS(5707),
    [anon_sym_use_BANG] = ACTIONS(5705),
    [anon_sym_do_BANG] = ACTIONS(5705),
    [anon_sym_begin] = ACTIONS(5707),
    [aux_sym_char_token1] = ACTIONS(5705),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5707),
    [anon_sym_DQUOTE] = ACTIONS(5707),
    [anon_sym_AT_DQUOTE] = ACTIONS(5705),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5705),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5705),
    [sym_bool] = ACTIONS(5707),
    [sym_unit] = ACTIONS(5705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5707),
    [sym_op_identifier] = ACTIONS(5705),
    [anon_sym_PLUS] = ACTIONS(5707),
    [anon_sym_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_DOT] = ACTIONS(5705),
    [anon_sym_DASH_DOT] = ACTIONS(5705),
    [anon_sym_PERCENT] = ACTIONS(5705),
    [anon_sym_AMP_AMP] = ACTIONS(5705),
    [anon_sym_TILDE] = ACTIONS(5705),
    [aux_sym_prefix_op_token1] = ACTIONS(5705),
    [sym_int] = ACTIONS(5707),
    [sym_xint] = ACTIONS(5705),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5705),
    [anon_sym_POUNDload] = ACTIONS(5705),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5705),
  },
  [3284] = {
    [sym_xml_doc] = STATE(3284),
    [sym_block_comment] = STATE(3284),
    [sym_line_comment] = STATE(3284),
    [sym_compiler_directive_decl] = STATE(3284),
    [sym_fsi_directive_decl] = STATE(3284),
    [sym_preproc_line] = STATE(3284),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
  },
  [3285] = {
    [sym_xml_doc] = STATE(3285),
    [sym_block_comment] = STATE(3285),
    [sym_line_comment] = STATE(3285),
    [sym_compiler_directive_decl] = STATE(3285),
    [sym_fsi_directive_decl] = STATE(3285),
    [sym_preproc_line] = STATE(3285),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
    [sym__dedent] = ACTIONS(3276),
  },
  [3286] = {
    [sym_xml_doc] = STATE(3286),
    [sym_block_comment] = STATE(3286),
    [sym_line_comment] = STATE(3286),
    [sym_compiler_directive_decl] = STATE(3286),
    [sym_fsi_directive_decl] = STATE(3286),
    [sym_preproc_line] = STATE(3286),
    [aux_sym_type_argument_repeat1] = STATE(3316),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(5709),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
  },
  [3287] = {
    [sym_xml_doc] = STATE(3287),
    [sym_block_comment] = STATE(3287),
    [sym_line_comment] = STATE(3287),
    [sym_compiler_directive_decl] = STATE(3287),
    [sym_fsi_directive_decl] = STATE(3287),
    [sym_preproc_line] = STATE(3287),
    [ts_builtin_sym_end] = ACTIONS(5711),
    [sym_identifier] = ACTIONS(5713),
    [anon_sym_namespace] = ACTIONS(5713),
    [anon_sym_module] = ACTIONS(5713),
    [anon_sym_open] = ACTIONS(5713),
    [anon_sym_LBRACK_LT] = ACTIONS(5711),
    [anon_sym_return] = ACTIONS(5713),
    [anon_sym_type] = ACTIONS(5713),
    [anon_sym_do] = ACTIONS(5713),
    [anon_sym_and] = ACTIONS(5713),
    [anon_sym_let] = ACTIONS(5713),
    [anon_sym_let_BANG] = ACTIONS(5711),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_null] = ACTIONS(5713),
    [anon_sym_AMP] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5711),
    [anon_sym_LBRACE] = ACTIONS(5713),
    [anon_sym_LT_AT] = ACTIONS(5713),
    [anon_sym_LT_AT_AT] = ACTIONS(5711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5711),
    [anon_sym_new] = ACTIONS(5713),
    [anon_sym_return_BANG] = ACTIONS(5711),
    [anon_sym_yield] = ACTIONS(5713),
    [anon_sym_yield_BANG] = ACTIONS(5711),
    [anon_sym_lazy] = ACTIONS(5713),
    [anon_sym_assert] = ACTIONS(5713),
    [anon_sym_upcast] = ACTIONS(5713),
    [anon_sym_downcast] = ACTIONS(5713),
    [anon_sym_for] = ACTIONS(5713),
    [anon_sym_while] = ACTIONS(5713),
    [anon_sym_if] = ACTIONS(5713),
    [anon_sym_fun] = ACTIONS(5713),
    [anon_sym_try] = ACTIONS(5713),
    [anon_sym_match] = ACTIONS(5713),
    [anon_sym_match_BANG] = ACTIONS(5711),
    [anon_sym_function] = ACTIONS(5713),
    [anon_sym_use] = ACTIONS(5713),
    [anon_sym_use_BANG] = ACTIONS(5711),
    [anon_sym_do_BANG] = ACTIONS(5711),
    [anon_sym_begin] = ACTIONS(5713),
    [aux_sym_char_token1] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5713),
    [anon_sym_DQUOTE] = ACTIONS(5713),
    [anon_sym_AT_DQUOTE] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [sym_bool] = ACTIONS(5713),
    [sym_unit] = ACTIONS(5711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5713),
    [sym_op_identifier] = ACTIONS(5711),
    [anon_sym_PLUS] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_DOT] = ACTIONS(5711),
    [anon_sym_DASH_DOT] = ACTIONS(5711),
    [anon_sym_PERCENT] = ACTIONS(5711),
    [anon_sym_AMP_AMP] = ACTIONS(5711),
    [anon_sym_TILDE] = ACTIONS(5711),
    [aux_sym_prefix_op_token1] = ACTIONS(5711),
    [sym_int] = ACTIONS(5713),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5711),
    [anon_sym_POUNDload] = ACTIONS(5711),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5711),
  },
  [3288] = {
    [sym_xml_doc] = STATE(3288),
    [sym_block_comment] = STATE(3288),
    [sym_line_comment] = STATE(3288),
    [sym_compiler_directive_decl] = STATE(3288),
    [sym_fsi_directive_decl] = STATE(3288),
    [sym_preproc_line] = STATE(3288),
    [ts_builtin_sym_end] = ACTIONS(5715),
    [sym_identifier] = ACTIONS(5717),
    [anon_sym_namespace] = ACTIONS(5717),
    [anon_sym_module] = ACTIONS(5717),
    [anon_sym_open] = ACTIONS(5717),
    [anon_sym_LBRACK_LT] = ACTIONS(5715),
    [anon_sym_return] = ACTIONS(5717),
    [anon_sym_type] = ACTIONS(5717),
    [anon_sym_do] = ACTIONS(5717),
    [anon_sym_and] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_let_BANG] = ACTIONS(5715),
    [anon_sym_LPAREN] = ACTIONS(5717),
    [anon_sym_null] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5715),
    [anon_sym_LBRACE] = ACTIONS(5717),
    [anon_sym_LT_AT] = ACTIONS(5717),
    [anon_sym_LT_AT_AT] = ACTIONS(5715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5715),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_return_BANG] = ACTIONS(5715),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_yield_BANG] = ACTIONS(5715),
    [anon_sym_lazy] = ACTIONS(5717),
    [anon_sym_assert] = ACTIONS(5717),
    [anon_sym_upcast] = ACTIONS(5717),
    [anon_sym_downcast] = ACTIONS(5717),
    [anon_sym_for] = ACTIONS(5717),
    [anon_sym_while] = ACTIONS(5717),
    [anon_sym_if] = ACTIONS(5717),
    [anon_sym_fun] = ACTIONS(5717),
    [anon_sym_try] = ACTIONS(5717),
    [anon_sym_match] = ACTIONS(5717),
    [anon_sym_match_BANG] = ACTIONS(5715),
    [anon_sym_function] = ACTIONS(5717),
    [anon_sym_use] = ACTIONS(5717),
    [anon_sym_use_BANG] = ACTIONS(5715),
    [anon_sym_do_BANG] = ACTIONS(5715),
    [anon_sym_begin] = ACTIONS(5717),
    [aux_sym_char_token1] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5717),
    [anon_sym_DQUOTE] = ACTIONS(5717),
    [anon_sym_AT_DQUOTE] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [sym_bool] = ACTIONS(5717),
    [sym_unit] = ACTIONS(5715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5717),
    [sym_op_identifier] = ACTIONS(5715),
    [anon_sym_PLUS] = ACTIONS(5717),
    [anon_sym_DASH] = ACTIONS(5717),
    [anon_sym_PLUS_DOT] = ACTIONS(5715),
    [anon_sym_DASH_DOT] = ACTIONS(5715),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_AMP_AMP] = ACTIONS(5715),
    [anon_sym_TILDE] = ACTIONS(5715),
    [aux_sym_prefix_op_token1] = ACTIONS(5715),
    [sym_int] = ACTIONS(5717),
    [sym_xint] = ACTIONS(5715),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5715),
    [anon_sym_POUNDload] = ACTIONS(5715),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5715),
  },
  [3289] = {
    [sym_xml_doc] = STATE(3289),
    [sym_block_comment] = STATE(3289),
    [sym_line_comment] = STATE(3289),
    [sym_compiler_directive_decl] = STATE(3289),
    [sym_fsi_directive_decl] = STATE(3289),
    [sym_preproc_line] = STATE(3289),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_module] = ACTIONS(5660),
    [anon_sym_open] = ACTIONS(5660),
    [anon_sym_LBRACK_LT] = ACTIONS(5658),
    [anon_sym_return] = ACTIONS(5660),
    [anon_sym_type] = ACTIONS(5660),
    [anon_sym_do] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5719),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_let_BANG] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_null] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5658),
    [anon_sym_LBRACE] = ACTIONS(5660),
    [anon_sym_LT_AT] = ACTIONS(5660),
    [anon_sym_LT_AT_AT] = ACTIONS(5658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5658),
    [anon_sym_new] = ACTIONS(5660),
    [anon_sym_return_BANG] = ACTIONS(5658),
    [anon_sym_yield] = ACTIONS(5660),
    [anon_sym_yield_BANG] = ACTIONS(5658),
    [anon_sym_lazy] = ACTIONS(5660),
    [anon_sym_assert] = ACTIONS(5660),
    [anon_sym_upcast] = ACTIONS(5660),
    [anon_sym_downcast] = ACTIONS(5660),
    [anon_sym_for] = ACTIONS(5660),
    [anon_sym_while] = ACTIONS(5660),
    [anon_sym_if] = ACTIONS(5660),
    [anon_sym_fun] = ACTIONS(5660),
    [anon_sym_try] = ACTIONS(5660),
    [anon_sym_match] = ACTIONS(5660),
    [anon_sym_match_BANG] = ACTIONS(5658),
    [anon_sym_function] = ACTIONS(5660),
    [anon_sym_use] = ACTIONS(5660),
    [anon_sym_use_BANG] = ACTIONS(5658),
    [anon_sym_do_BANG] = ACTIONS(5658),
    [anon_sym_begin] = ACTIONS(5660),
    [aux_sym_char_token1] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5660),
    [anon_sym_AT_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [sym_bool] = ACTIONS(5660),
    [sym_unit] = ACTIONS(5658),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5660),
    [sym_op_identifier] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_DOT] = ACTIONS(5658),
    [anon_sym_DASH_DOT] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_TILDE] = ACTIONS(5658),
    [aux_sym_prefix_op_token1] = ACTIONS(5658),
    [sym_int] = ACTIONS(5660),
    [sym_xint] = ACTIONS(5658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5658),
    [anon_sym_POUNDload] = ACTIONS(5658),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5658),
    [sym__dedent] = ACTIONS(5658),
  },
  [3290] = {
    [sym_xml_doc] = STATE(3290),
    [sym_block_comment] = STATE(3290),
    [sym_line_comment] = STATE(3290),
    [sym_compiler_directive_decl] = STATE(3290),
    [sym_fsi_directive_decl] = STATE(3290),
    [sym_preproc_line] = STATE(3290),
    [aux_sym__compound_type_repeat1] = STATE(3290),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(5722),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
  },
  [3291] = {
    [sym_xml_doc] = STATE(3291),
    [sym_block_comment] = STATE(3291),
    [sym_line_comment] = STATE(3291),
    [sym_compiler_directive_decl] = STATE(3291),
    [sym_fsi_directive_decl] = STATE(3291),
    [sym_preproc_line] = STATE(3291),
    [aux_sym__compound_type_repeat1] = STATE(3291),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_GT_RBRACK] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__newline] = ACTIONS(3030),
  },
  [3292] = {
    [sym_xml_doc] = STATE(3292),
    [sym_block_comment] = STATE(3292),
    [sym_line_comment] = STATE(3292),
    [sym_compiler_directive_decl] = STATE(3292),
    [sym_fsi_directive_decl] = STATE(3292),
    [sym_preproc_line] = STATE(3292),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_GT_RBRACK] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__newline] = ACTIONS(3244),
  },
  [3293] = {
    [sym_xml_doc] = STATE(3293),
    [sym_block_comment] = STATE(3293),
    [sym_line_comment] = STATE(3293),
    [sym_compiler_directive_decl] = STATE(3293),
    [sym_fsi_directive_decl] = STATE(3293),
    [sym_preproc_line] = STATE(3293),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(5728),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
  },
  [3294] = {
    [sym_xml_doc] = STATE(3294),
    [sym_block_comment] = STATE(3294),
    [sym_line_comment] = STATE(3294),
    [sym_compiler_directive_decl] = STATE(3294),
    [sym_fsi_directive_decl] = STATE(3294),
    [sym_preproc_line] = STATE(3294),
    [ts_builtin_sym_end] = ACTIONS(5562),
    [sym_identifier] = ACTIONS(5564),
    [anon_sym_namespace] = ACTIONS(5564),
    [anon_sym_module] = ACTIONS(5564),
    [anon_sym_open] = ACTIONS(5564),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_return] = ACTIONS(5564),
    [anon_sym_type] = ACTIONS(5564),
    [anon_sym_do] = ACTIONS(5564),
    [anon_sym_and] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_let_BANG] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_LT_AT] = ACTIONS(5564),
    [anon_sym_LT_AT_AT] = ACTIONS(5562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5562),
    [anon_sym_new] = ACTIONS(5564),
    [anon_sym_return_BANG] = ACTIONS(5562),
    [anon_sym_yield] = ACTIONS(5564),
    [anon_sym_yield_BANG] = ACTIONS(5562),
    [anon_sym_lazy] = ACTIONS(5564),
    [anon_sym_assert] = ACTIONS(5564),
    [anon_sym_upcast] = ACTIONS(5564),
    [anon_sym_downcast] = ACTIONS(5564),
    [anon_sym_for] = ACTIONS(5564),
    [anon_sym_while] = ACTIONS(5564),
    [anon_sym_if] = ACTIONS(5564),
    [anon_sym_fun] = ACTIONS(5564),
    [anon_sym_try] = ACTIONS(5564),
    [anon_sym_match] = ACTIONS(5564),
    [anon_sym_match_BANG] = ACTIONS(5562),
    [anon_sym_function] = ACTIONS(5564),
    [anon_sym_use] = ACTIONS(5564),
    [anon_sym_use_BANG] = ACTIONS(5562),
    [anon_sym_do_BANG] = ACTIONS(5562),
    [anon_sym_begin] = ACTIONS(5564),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5564),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5564),
    [sym_op_identifier] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_PLUS_DOT] = ACTIONS(5562),
    [anon_sym_DASH_DOT] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [aux_sym_prefix_op_token1] = ACTIONS(5562),
    [sym_int] = ACTIONS(5564),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5562),
    [anon_sym_POUNDload] = ACTIONS(5562),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5562),
  },
  [3295] = {
    [sym_xml_doc] = STATE(3295),
    [sym_block_comment] = STATE(3295),
    [sym_line_comment] = STATE(3295),
    [sym_compiler_directive_decl] = STATE(3295),
    [sym_fsi_directive_decl] = STATE(3295),
    [sym_preproc_line] = STATE(3295),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3363),
    [anon_sym_DASH_DOT] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3363),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
    [sym__dedent] = ACTIONS(3363),
  },
  [3296] = {
    [sym_xml_doc] = STATE(3296),
    [sym_block_comment] = STATE(3296),
    [sym_line_comment] = STATE(3296),
    [sym_compiler_directive_decl] = STATE(3296),
    [sym_fsi_directive_decl] = STATE(3296),
    [sym_preproc_line] = STATE(3296),
    [ts_builtin_sym_end] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_namespace] = ACTIONS(5732),
    [anon_sym_module] = ACTIONS(5732),
    [anon_sym_open] = ACTIONS(5732),
    [anon_sym_LBRACK_LT] = ACTIONS(5730),
    [anon_sym_return] = ACTIONS(5732),
    [anon_sym_type] = ACTIONS(5732),
    [anon_sym_do] = ACTIONS(5732),
    [anon_sym_and] = ACTIONS(5732),
    [anon_sym_let] = ACTIONS(5732),
    [anon_sym_let_BANG] = ACTIONS(5730),
    [anon_sym_LPAREN] = ACTIONS(5732),
    [anon_sym_null] = ACTIONS(5732),
    [anon_sym_AMP] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5730),
    [anon_sym_LBRACE] = ACTIONS(5732),
    [anon_sym_LT_AT] = ACTIONS(5732),
    [anon_sym_LT_AT_AT] = ACTIONS(5730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5730),
    [anon_sym_new] = ACTIONS(5732),
    [anon_sym_return_BANG] = ACTIONS(5730),
    [anon_sym_yield] = ACTIONS(5732),
    [anon_sym_yield_BANG] = ACTIONS(5730),
    [anon_sym_lazy] = ACTIONS(5732),
    [anon_sym_assert] = ACTIONS(5732),
    [anon_sym_upcast] = ACTIONS(5732),
    [anon_sym_downcast] = ACTIONS(5732),
    [anon_sym_for] = ACTIONS(5732),
    [anon_sym_while] = ACTIONS(5732),
    [anon_sym_if] = ACTIONS(5732),
    [anon_sym_fun] = ACTIONS(5732),
    [anon_sym_try] = ACTIONS(5732),
    [anon_sym_match] = ACTIONS(5732),
    [anon_sym_match_BANG] = ACTIONS(5730),
    [anon_sym_function] = ACTIONS(5732),
    [anon_sym_use] = ACTIONS(5732),
    [anon_sym_use_BANG] = ACTIONS(5730),
    [anon_sym_do_BANG] = ACTIONS(5730),
    [anon_sym_begin] = ACTIONS(5732),
    [aux_sym_char_token1] = ACTIONS(5730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5732),
    [anon_sym_DQUOTE] = ACTIONS(5732),
    [anon_sym_AT_DQUOTE] = ACTIONS(5730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5730),
    [sym_bool] = ACTIONS(5732),
    [sym_unit] = ACTIONS(5730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5732),
    [sym_op_identifier] = ACTIONS(5730),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_DASH] = ACTIONS(5732),
    [anon_sym_PLUS_DOT] = ACTIONS(5730),
    [anon_sym_DASH_DOT] = ACTIONS(5730),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5730),
    [aux_sym_prefix_op_token1] = ACTIONS(5730),
    [sym_int] = ACTIONS(5732),
    [sym_xint] = ACTIONS(5730),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5730),
    [anon_sym_POUNDload] = ACTIONS(5730),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5730),
  },
  [3297] = {
    [sym_xml_doc] = STATE(3297),
    [sym_block_comment] = STATE(3297),
    [sym_line_comment] = STATE(3297),
    [sym_compiler_directive_decl] = STATE(3297),
    [sym_fsi_directive_decl] = STATE(3297),
    [sym_preproc_line] = STATE(3297),
    [aux_sym_long_identifier_repeat1] = STATE(3297),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [3298] = {
    [sym_xml_doc] = STATE(3298),
    [sym_block_comment] = STATE(3298),
    [sym_line_comment] = STATE(3298),
    [sym_compiler_directive_decl] = STATE(3298),
    [sym_fsi_directive_decl] = STATE(3298),
    [sym_preproc_line] = STATE(3298),
    [ts_builtin_sym_end] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5542),
    [anon_sym_namespace] = ACTIONS(5542),
    [anon_sym_module] = ACTIONS(5542),
    [anon_sym_open] = ACTIONS(5542),
    [anon_sym_LBRACK_LT] = ACTIONS(5540),
    [anon_sym_return] = ACTIONS(5542),
    [anon_sym_type] = ACTIONS(5542),
    [anon_sym_do] = ACTIONS(5542),
    [anon_sym_and] = ACTIONS(5542),
    [anon_sym_let] = ACTIONS(5542),
    [anon_sym_let_BANG] = ACTIONS(5540),
    [anon_sym_LPAREN] = ACTIONS(5542),
    [anon_sym_null] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_LT_AT] = ACTIONS(5542),
    [anon_sym_LT_AT_AT] = ACTIONS(5540),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5540),
    [anon_sym_new] = ACTIONS(5542),
    [anon_sym_return_BANG] = ACTIONS(5540),
    [anon_sym_yield] = ACTIONS(5542),
    [anon_sym_yield_BANG] = ACTIONS(5540),
    [anon_sym_lazy] = ACTIONS(5542),
    [anon_sym_assert] = ACTIONS(5542),
    [anon_sym_upcast] = ACTIONS(5542),
    [anon_sym_downcast] = ACTIONS(5542),
    [anon_sym_for] = ACTIONS(5542),
    [anon_sym_while] = ACTIONS(5542),
    [anon_sym_if] = ACTIONS(5542),
    [anon_sym_fun] = ACTIONS(5542),
    [anon_sym_try] = ACTIONS(5542),
    [anon_sym_match] = ACTIONS(5542),
    [anon_sym_match_BANG] = ACTIONS(5540),
    [anon_sym_function] = ACTIONS(5542),
    [anon_sym_use] = ACTIONS(5542),
    [anon_sym_use_BANG] = ACTIONS(5540),
    [anon_sym_do_BANG] = ACTIONS(5540),
    [anon_sym_begin] = ACTIONS(5542),
    [aux_sym_char_token1] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_AT_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [sym_bool] = ACTIONS(5542),
    [sym_unit] = ACTIONS(5540),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5542),
    [sym_op_identifier] = ACTIONS(5540),
    [anon_sym_PLUS] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_PLUS_DOT] = ACTIONS(5540),
    [anon_sym_DASH_DOT] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [aux_sym_prefix_op_token1] = ACTIONS(5540),
    [sym_int] = ACTIONS(5542),
    [sym_xint] = ACTIONS(5540),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5540),
    [anon_sym_POUNDload] = ACTIONS(5540),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5540),
  },
  [3299] = {
    [sym_xml_doc] = STATE(3299),
    [sym_block_comment] = STATE(3299),
    [sym_line_comment] = STATE(3299),
    [sym_compiler_directive_decl] = STATE(3299),
    [sym_fsi_directive_decl] = STATE(3299),
    [sym_preproc_line] = STATE(3299),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(5674),
    [anon_sym_module] = ACTIONS(5674),
    [anon_sym_open] = ACTIONS(5674),
    [anon_sym_LBRACK_LT] = ACTIONS(5672),
    [anon_sym_return] = ACTIONS(5674),
    [anon_sym_type] = ACTIONS(5674),
    [anon_sym_do] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(5737),
    [anon_sym_let] = ACTIONS(5674),
    [anon_sym_let_BANG] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5674),
    [anon_sym_null] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_LT_AT] = ACTIONS(5674),
    [anon_sym_LT_AT_AT] = ACTIONS(5672),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5672),
    [anon_sym_new] = ACTIONS(5674),
    [anon_sym_return_BANG] = ACTIONS(5672),
    [anon_sym_yield] = ACTIONS(5674),
    [anon_sym_yield_BANG] = ACTIONS(5672),
    [anon_sym_lazy] = ACTIONS(5674),
    [anon_sym_assert] = ACTIONS(5674),
    [anon_sym_upcast] = ACTIONS(5674),
    [anon_sym_downcast] = ACTIONS(5674),
    [anon_sym_for] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5674),
    [anon_sym_if] = ACTIONS(5674),
    [anon_sym_fun] = ACTIONS(5674),
    [anon_sym_try] = ACTIONS(5674),
    [anon_sym_match] = ACTIONS(5674),
    [anon_sym_match_BANG] = ACTIONS(5672),
    [anon_sym_function] = ACTIONS(5674),
    [anon_sym_use] = ACTIONS(5674),
    [anon_sym_use_BANG] = ACTIONS(5672),
    [anon_sym_do_BANG] = ACTIONS(5672),
    [anon_sym_begin] = ACTIONS(5674),
    [aux_sym_char_token1] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [anon_sym_AT_DQUOTE] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [sym_bool] = ACTIONS(5674),
    [sym_unit] = ACTIONS(5672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5674),
    [sym_op_identifier] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_DOT] = ACTIONS(5672),
    [anon_sym_DASH_DOT] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5672),
    [aux_sym_prefix_op_token1] = ACTIONS(5672),
    [sym_int] = ACTIONS(5674),
    [sym_xint] = ACTIONS(5672),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5672),
    [anon_sym_POUNDload] = ACTIONS(5672),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5672),
    [sym__dedent] = ACTIONS(5672),
  },
  [3300] = {
    [sym_xml_doc] = STATE(3300),
    [sym_block_comment] = STATE(3300),
    [sym_line_comment] = STATE(3300),
    [sym_compiler_directive_decl] = STATE(3300),
    [sym_fsi_directive_decl] = STATE(3300),
    [sym_preproc_line] = STATE(3300),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_GT_RBRACK] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__newline] = ACTIONS(3287),
  },
  [3301] = {
    [sym_type_arguments] = STATE(3472),
    [sym_long_identifier] = STATE(3471),
    [sym_xml_doc] = STATE(3301),
    [sym_block_comment] = STATE(3301),
    [sym_line_comment] = STATE(3301),
    [sym_compiler_directive_decl] = STATE(3301),
    [sym_fsi_directive_decl] = STATE(3301),
    [sym_preproc_line] = STATE(3301),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_let_BANG] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_null] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_LT_AT] = ACTIONS(3024),
    [anon_sym_LT_AT_AT] = ACTIONS(3022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_return_BANG] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_yield_BANG] = ACTIONS(3022),
    [anon_sym_lazy] = ACTIONS(3024),
    [anon_sym_assert] = ACTIONS(3024),
    [anon_sym_upcast] = ACTIONS(3024),
    [anon_sym_downcast] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_fun] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_match] = ACTIONS(3024),
    [anon_sym_match_BANG] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_use] = ACTIONS(3024),
    [anon_sym_use_BANG] = ACTIONS(3022),
    [anon_sym_do_BANG] = ACTIONS(3022),
    [anon_sym_begin] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_AT_DQUOTE] = ACTIONS(3022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3022),
    [sym_bool] = ACTIONS(3024),
    [sym_unit] = ACTIONS(3022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3024),
    [sym_op_identifier] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_DOT] = ACTIONS(3022),
    [anon_sym_DASH_DOT] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [aux_sym_prefix_op_token1] = ACTIONS(3022),
    [sym_int] = ACTIONS(3024),
    [sym_xint] = ACTIONS(3022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3022),
  },
  [3302] = {
    [sym_xml_doc] = STATE(3302),
    [sym_block_comment] = STATE(3302),
    [sym_line_comment] = STATE(3302),
    [sym_compiler_directive_decl] = STATE(3302),
    [sym_fsi_directive_decl] = STATE(3302),
    [sym_preproc_line] = STATE(3302),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [3303] = {
    [sym_xml_doc] = STATE(3303),
    [sym_block_comment] = STATE(3303),
    [sym_line_comment] = STATE(3303),
    [sym_compiler_directive_decl] = STATE(3303),
    [sym_fsi_directive_decl] = STATE(3303),
    [sym_preproc_line] = STATE(3303),
    [ts_builtin_sym_end] = ACTIONS(5739),
    [sym_identifier] = ACTIONS(5741),
    [anon_sym_namespace] = ACTIONS(5741),
    [anon_sym_module] = ACTIONS(5741),
    [anon_sym_open] = ACTIONS(5741),
    [anon_sym_LBRACK_LT] = ACTIONS(5739),
    [anon_sym_return] = ACTIONS(5741),
    [anon_sym_type] = ACTIONS(5741),
    [anon_sym_do] = ACTIONS(5741),
    [anon_sym_and] = ACTIONS(5741),
    [anon_sym_let] = ACTIONS(5741),
    [anon_sym_let_BANG] = ACTIONS(5739),
    [anon_sym_LPAREN] = ACTIONS(5741),
    [anon_sym_null] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5741),
    [anon_sym_LBRACK] = ACTIONS(5741),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5739),
    [anon_sym_LBRACE] = ACTIONS(5741),
    [anon_sym_LT_AT] = ACTIONS(5741),
    [anon_sym_LT_AT_AT] = ACTIONS(5739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5739),
    [anon_sym_new] = ACTIONS(5741),
    [anon_sym_return_BANG] = ACTIONS(5739),
    [anon_sym_yield] = ACTIONS(5741),
    [anon_sym_yield_BANG] = ACTIONS(5739),
    [anon_sym_lazy] = ACTIONS(5741),
    [anon_sym_assert] = ACTIONS(5741),
    [anon_sym_upcast] = ACTIONS(5741),
    [anon_sym_downcast] = ACTIONS(5741),
    [anon_sym_for] = ACTIONS(5741),
    [anon_sym_while] = ACTIONS(5741),
    [anon_sym_if] = ACTIONS(5741),
    [anon_sym_fun] = ACTIONS(5741),
    [anon_sym_try] = ACTIONS(5741),
    [anon_sym_match] = ACTIONS(5741),
    [anon_sym_match_BANG] = ACTIONS(5739),
    [anon_sym_function] = ACTIONS(5741),
    [anon_sym_use] = ACTIONS(5741),
    [anon_sym_use_BANG] = ACTIONS(5739),
    [anon_sym_do_BANG] = ACTIONS(5739),
    [anon_sym_begin] = ACTIONS(5741),
    [aux_sym_char_token1] = ACTIONS(5739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5741),
    [anon_sym_DQUOTE] = ACTIONS(5741),
    [anon_sym_AT_DQUOTE] = ACTIONS(5739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5739),
    [sym_bool] = ACTIONS(5741),
    [sym_unit] = ACTIONS(5739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5741),
    [sym_op_identifier] = ACTIONS(5739),
    [anon_sym_PLUS] = ACTIONS(5741),
    [anon_sym_DASH] = ACTIONS(5741),
    [anon_sym_PLUS_DOT] = ACTIONS(5739),
    [anon_sym_DASH_DOT] = ACTIONS(5739),
    [anon_sym_PERCENT] = ACTIONS(5739),
    [anon_sym_AMP_AMP] = ACTIONS(5739),
    [anon_sym_TILDE] = ACTIONS(5739),
    [aux_sym_prefix_op_token1] = ACTIONS(5739),
    [sym_int] = ACTIONS(5741),
    [sym_xint] = ACTIONS(5739),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5739),
    [anon_sym_POUNDload] = ACTIONS(5739),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5739),
  },
  [3304] = {
    [sym_xml_doc] = STATE(3304),
    [sym_block_comment] = STATE(3304),
    [sym_line_comment] = STATE(3304),
    [sym_compiler_directive_decl] = STATE(3304),
    [sym_fsi_directive_decl] = STATE(3304),
    [sym_preproc_line] = STATE(3304),
    [ts_builtin_sym_end] = ACTIONS(5743),
    [sym_identifier] = ACTIONS(5745),
    [anon_sym_namespace] = ACTIONS(5745),
    [anon_sym_module] = ACTIONS(5745),
    [anon_sym_open] = ACTIONS(5745),
    [anon_sym_LBRACK_LT] = ACTIONS(5743),
    [anon_sym_return] = ACTIONS(5745),
    [anon_sym_type] = ACTIONS(5745),
    [anon_sym_do] = ACTIONS(5745),
    [anon_sym_and] = ACTIONS(5745),
    [anon_sym_let] = ACTIONS(5745),
    [anon_sym_let_BANG] = ACTIONS(5743),
    [anon_sym_LPAREN] = ACTIONS(5745),
    [anon_sym_null] = ACTIONS(5745),
    [anon_sym_AMP] = ACTIONS(5745),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_LT_AT] = ACTIONS(5745),
    [anon_sym_LT_AT_AT] = ACTIONS(5743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5743),
    [anon_sym_new] = ACTIONS(5745),
    [anon_sym_return_BANG] = ACTIONS(5743),
    [anon_sym_yield] = ACTIONS(5745),
    [anon_sym_yield_BANG] = ACTIONS(5743),
    [anon_sym_lazy] = ACTIONS(5745),
    [anon_sym_assert] = ACTIONS(5745),
    [anon_sym_upcast] = ACTIONS(5745),
    [anon_sym_downcast] = ACTIONS(5745),
    [anon_sym_for] = ACTIONS(5745),
    [anon_sym_while] = ACTIONS(5745),
    [anon_sym_if] = ACTIONS(5745),
    [anon_sym_fun] = ACTIONS(5745),
    [anon_sym_try] = ACTIONS(5745),
    [anon_sym_match] = ACTIONS(5745),
    [anon_sym_match_BANG] = ACTIONS(5743),
    [anon_sym_function] = ACTIONS(5745),
    [anon_sym_use] = ACTIONS(5745),
    [anon_sym_use_BANG] = ACTIONS(5743),
    [anon_sym_do_BANG] = ACTIONS(5743),
    [anon_sym_begin] = ACTIONS(5745),
    [aux_sym_char_token1] = ACTIONS(5743),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5745),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5743),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5743),
    [sym_bool] = ACTIONS(5745),
    [sym_unit] = ACTIONS(5743),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5745),
    [sym_op_identifier] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_DOT] = ACTIONS(5743),
    [anon_sym_DASH_DOT] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_AMP_AMP] = ACTIONS(5743),
    [anon_sym_TILDE] = ACTIONS(5743),
    [aux_sym_prefix_op_token1] = ACTIONS(5743),
    [sym_int] = ACTIONS(5745),
    [sym_xint] = ACTIONS(5743),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5743),
    [anon_sym_POUNDload] = ACTIONS(5743),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5743),
  },
  [3305] = {
    [sym_xml_doc] = STATE(3305),
    [sym_block_comment] = STATE(3305),
    [sym_line_comment] = STATE(3305),
    [sym_compiler_directive_decl] = STATE(3305),
    [sym_fsi_directive_decl] = STATE(3305),
    [sym_preproc_line] = STATE(3305),
    [aux_sym_long_identifier_repeat1] = STATE(3279),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_open] = ACTIONS(3257),
    [anon_sym_LBRACK_LT] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5695),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3259),
    [anon_sym_POUNDload] = ACTIONS(3259),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
    [sym__dedent] = ACTIONS(3259),
  },
  [3306] = {
    [sym_xml_doc] = STATE(3306),
    [sym_block_comment] = STATE(3306),
    [sym_line_comment] = STATE(3306),
    [sym_compiler_directive_decl] = STATE(3306),
    [sym_fsi_directive_decl] = STATE(3306),
    [sym_preproc_line] = STATE(3306),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_module] = ACTIONS(5651),
    [anon_sym_open] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5649),
    [anon_sym_return] = ACTIONS(5651),
    [anon_sym_type] = ACTIONS(5651),
    [anon_sym_do] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(5737),
    [anon_sym_let] = ACTIONS(5651),
    [anon_sym_let_BANG] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(5651),
    [anon_sym_null] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_LBRACK] = ACTIONS(5651),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5651),
    [anon_sym_LT_AT] = ACTIONS(5651),
    [anon_sym_LT_AT_AT] = ACTIONS(5649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5649),
    [anon_sym_new] = ACTIONS(5651),
    [anon_sym_return_BANG] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(5651),
    [anon_sym_yield_BANG] = ACTIONS(5649),
    [anon_sym_lazy] = ACTIONS(5651),
    [anon_sym_assert] = ACTIONS(5651),
    [anon_sym_upcast] = ACTIONS(5651),
    [anon_sym_downcast] = ACTIONS(5651),
    [anon_sym_for] = ACTIONS(5651),
    [anon_sym_while] = ACTIONS(5651),
    [anon_sym_if] = ACTIONS(5651),
    [anon_sym_fun] = ACTIONS(5651),
    [anon_sym_try] = ACTIONS(5651),
    [anon_sym_match] = ACTIONS(5651),
    [anon_sym_match_BANG] = ACTIONS(5649),
    [anon_sym_function] = ACTIONS(5651),
    [anon_sym_use] = ACTIONS(5651),
    [anon_sym_use_BANG] = ACTIONS(5649),
    [anon_sym_do_BANG] = ACTIONS(5649),
    [anon_sym_begin] = ACTIONS(5651),
    [aux_sym_char_token1] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(5651),
    [anon_sym_AT_DQUOTE] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [sym_bool] = ACTIONS(5651),
    [sym_unit] = ACTIONS(5649),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5651),
    [sym_op_identifier] = ACTIONS(5649),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS_DOT] = ACTIONS(5649),
    [anon_sym_DASH_DOT] = ACTIONS(5649),
    [anon_sym_PERCENT] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_TILDE] = ACTIONS(5649),
    [aux_sym_prefix_op_token1] = ACTIONS(5649),
    [sym_int] = ACTIONS(5651),
    [sym_xint] = ACTIONS(5649),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5649),
    [anon_sym_POUNDload] = ACTIONS(5649),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5649),
    [sym__dedent] = ACTIONS(5649),
  },
  [3307] = {
    [sym_xml_doc] = STATE(3307),
    [sym_block_comment] = STATE(3307),
    [sym_line_comment] = STATE(3307),
    [sym_compiler_directive_decl] = STATE(3307),
    [sym_fsi_directive_decl] = STATE(3307),
    [sym_preproc_line] = STATE(3307),
    [ts_builtin_sym_end] = ACTIONS(5747),
    [sym_identifier] = ACTIONS(5749),
    [anon_sym_namespace] = ACTIONS(5749),
    [anon_sym_module] = ACTIONS(5749),
    [anon_sym_open] = ACTIONS(5749),
    [anon_sym_LBRACK_LT] = ACTIONS(5747),
    [anon_sym_return] = ACTIONS(5749),
    [anon_sym_type] = ACTIONS(5749),
    [anon_sym_do] = ACTIONS(5749),
    [anon_sym_and] = ACTIONS(5749),
    [anon_sym_let] = ACTIONS(5749),
    [anon_sym_let_BANG] = ACTIONS(5747),
    [anon_sym_LPAREN] = ACTIONS(5749),
    [anon_sym_null] = ACTIONS(5749),
    [anon_sym_AMP] = ACTIONS(5749),
    [anon_sym_LBRACK] = ACTIONS(5749),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5747),
    [anon_sym_LBRACE] = ACTIONS(5749),
    [anon_sym_LT_AT] = ACTIONS(5749),
    [anon_sym_LT_AT_AT] = ACTIONS(5747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5747),
    [anon_sym_new] = ACTIONS(5749),
    [anon_sym_return_BANG] = ACTIONS(5747),
    [anon_sym_yield] = ACTIONS(5749),
    [anon_sym_yield_BANG] = ACTIONS(5747),
    [anon_sym_lazy] = ACTIONS(5749),
    [anon_sym_assert] = ACTIONS(5749),
    [anon_sym_upcast] = ACTIONS(5749),
    [anon_sym_downcast] = ACTIONS(5749),
    [anon_sym_for] = ACTIONS(5749),
    [anon_sym_while] = ACTIONS(5749),
    [anon_sym_if] = ACTIONS(5749),
    [anon_sym_fun] = ACTIONS(5749),
    [anon_sym_try] = ACTIONS(5749),
    [anon_sym_match] = ACTIONS(5749),
    [anon_sym_match_BANG] = ACTIONS(5747),
    [anon_sym_function] = ACTIONS(5749),
    [anon_sym_use] = ACTIONS(5749),
    [anon_sym_use_BANG] = ACTIONS(5747),
    [anon_sym_do_BANG] = ACTIONS(5747),
    [anon_sym_begin] = ACTIONS(5749),
    [aux_sym_char_token1] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE] = ACTIONS(5749),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5747),
    [sym_bool] = ACTIONS(5749),
    [sym_unit] = ACTIONS(5747),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5749),
    [sym_op_identifier] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(5749),
    [anon_sym_PLUS_DOT] = ACTIONS(5747),
    [anon_sym_DASH_DOT] = ACTIONS(5747),
    [anon_sym_PERCENT] = ACTIONS(5747),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_TILDE] = ACTIONS(5747),
    [aux_sym_prefix_op_token1] = ACTIONS(5747),
    [sym_int] = ACTIONS(5749),
    [sym_xint] = ACTIONS(5747),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5747),
    [anon_sym_POUNDload] = ACTIONS(5747),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5747),
  },
  [3308] = {
    [sym_xml_doc] = STATE(3308),
    [sym_block_comment] = STATE(3308),
    [sym_line_comment] = STATE(3308),
    [sym_compiler_directive_decl] = STATE(3308),
    [sym_fsi_directive_decl] = STATE(3308),
    [sym_preproc_line] = STATE(3308),
    [ts_builtin_sym_end] = ACTIONS(5751),
    [sym_identifier] = ACTIONS(5753),
    [anon_sym_namespace] = ACTIONS(5753),
    [anon_sym_module] = ACTIONS(5753),
    [anon_sym_open] = ACTIONS(5753),
    [anon_sym_LBRACK_LT] = ACTIONS(5751),
    [anon_sym_return] = ACTIONS(5753),
    [anon_sym_type] = ACTIONS(5753),
    [anon_sym_do] = ACTIONS(5753),
    [anon_sym_and] = ACTIONS(5753),
    [anon_sym_let] = ACTIONS(5753),
    [anon_sym_let_BANG] = ACTIONS(5751),
    [anon_sym_LPAREN] = ACTIONS(5753),
    [anon_sym_null] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5753),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5751),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_LT_AT] = ACTIONS(5753),
    [anon_sym_LT_AT_AT] = ACTIONS(5751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5751),
    [anon_sym_new] = ACTIONS(5753),
    [anon_sym_return_BANG] = ACTIONS(5751),
    [anon_sym_yield] = ACTIONS(5753),
    [anon_sym_yield_BANG] = ACTIONS(5751),
    [anon_sym_lazy] = ACTIONS(5753),
    [anon_sym_assert] = ACTIONS(5753),
    [anon_sym_upcast] = ACTIONS(5753),
    [anon_sym_downcast] = ACTIONS(5753),
    [anon_sym_for] = ACTIONS(5753),
    [anon_sym_while] = ACTIONS(5753),
    [anon_sym_if] = ACTIONS(5753),
    [anon_sym_fun] = ACTIONS(5753),
    [anon_sym_try] = ACTIONS(5753),
    [anon_sym_match] = ACTIONS(5753),
    [anon_sym_match_BANG] = ACTIONS(5751),
    [anon_sym_function] = ACTIONS(5753),
    [anon_sym_use] = ACTIONS(5753),
    [anon_sym_use_BANG] = ACTIONS(5751),
    [anon_sym_do_BANG] = ACTIONS(5751),
    [anon_sym_begin] = ACTIONS(5753),
    [aux_sym_char_token1] = ACTIONS(5751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5753),
    [anon_sym_DQUOTE] = ACTIONS(5753),
    [anon_sym_AT_DQUOTE] = ACTIONS(5751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5753),
    [sym_op_identifier] = ACTIONS(5751),
    [anon_sym_PLUS] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_DOT] = ACTIONS(5751),
    [anon_sym_DASH_DOT] = ACTIONS(5751),
    [anon_sym_PERCENT] = ACTIONS(5751),
    [anon_sym_AMP_AMP] = ACTIONS(5751),
    [anon_sym_TILDE] = ACTIONS(5751),
    [aux_sym_prefix_op_token1] = ACTIONS(5751),
    [sym_int] = ACTIONS(5753),
    [sym_xint] = ACTIONS(5751),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5751),
    [anon_sym_POUNDload] = ACTIONS(5751),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5751),
  },
  [3309] = {
    [sym_xml_doc] = STATE(3309),
    [sym_block_comment] = STATE(3309),
    [sym_line_comment] = STATE(3309),
    [sym_compiler_directive_decl] = STATE(3309),
    [sym_fsi_directive_decl] = STATE(3309),
    [sym_preproc_line] = STATE(3309),
    [sym_identifier] = ACTIONS(5678),
    [anon_sym_module] = ACTIONS(5678),
    [anon_sym_open] = ACTIONS(5678),
    [anon_sym_LBRACK_LT] = ACTIONS(5676),
    [anon_sym_return] = ACTIONS(5678),
    [anon_sym_type] = ACTIONS(5678),
    [anon_sym_do] = ACTIONS(5678),
    [anon_sym_and] = ACTIONS(5678),
    [anon_sym_let] = ACTIONS(5678),
    [anon_sym_let_BANG] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5678),
    [anon_sym_null] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5676),
    [anon_sym_LBRACE] = ACTIONS(5678),
    [anon_sym_LT_AT] = ACTIONS(5678),
    [anon_sym_LT_AT_AT] = ACTIONS(5676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5676),
    [anon_sym_new] = ACTIONS(5678),
    [anon_sym_return_BANG] = ACTIONS(5676),
    [anon_sym_yield] = ACTIONS(5678),
    [anon_sym_yield_BANG] = ACTIONS(5676),
    [anon_sym_lazy] = ACTIONS(5678),
    [anon_sym_assert] = ACTIONS(5678),
    [anon_sym_upcast] = ACTIONS(5678),
    [anon_sym_downcast] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(5678),
    [anon_sym_while] = ACTIONS(5678),
    [anon_sym_if] = ACTIONS(5678),
    [anon_sym_fun] = ACTIONS(5678),
    [anon_sym_try] = ACTIONS(5678),
    [anon_sym_match] = ACTIONS(5678),
    [anon_sym_match_BANG] = ACTIONS(5676),
    [anon_sym_function] = ACTIONS(5678),
    [anon_sym_use] = ACTIONS(5678),
    [anon_sym_use_BANG] = ACTIONS(5676),
    [anon_sym_do_BANG] = ACTIONS(5676),
    [anon_sym_begin] = ACTIONS(5678),
    [anon_sym_interface] = ACTIONS(5678),
    [aux_sym_char_token1] = ACTIONS(5676),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5678),
    [anon_sym_DQUOTE] = ACTIONS(5678),
    [anon_sym_AT_DQUOTE] = ACTIONS(5676),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5676),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5676),
    [sym_bool] = ACTIONS(5678),
    [sym_unit] = ACTIONS(5676),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5678),
    [sym_op_identifier] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_PLUS_DOT] = ACTIONS(5676),
    [anon_sym_DASH_DOT] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5676),
    [aux_sym_prefix_op_token1] = ACTIONS(5676),
    [sym_int] = ACTIONS(5678),
    [sym_xint] = ACTIONS(5676),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5676),
    [anon_sym_POUNDload] = ACTIONS(5676),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5676),
    [sym__dedent] = ACTIONS(5676),
  },
  [3310] = {
    [sym_xml_doc] = STATE(3310),
    [sym_block_comment] = STATE(3310),
    [sym_line_comment] = STATE(3310),
    [sym_compiler_directive_decl] = STATE(3310),
    [sym_fsi_directive_decl] = STATE(3310),
    [sym_preproc_line] = STATE(3310),
    [ts_builtin_sym_end] = ACTIONS(5755),
    [sym_identifier] = ACTIONS(5757),
    [anon_sym_namespace] = ACTIONS(5757),
    [anon_sym_module] = ACTIONS(5757),
    [anon_sym_open] = ACTIONS(5757),
    [anon_sym_LBRACK_LT] = ACTIONS(5755),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_type] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_and] = ACTIONS(5757),
    [anon_sym_let] = ACTIONS(5757),
    [anon_sym_let_BANG] = ACTIONS(5755),
    [anon_sym_LPAREN] = ACTIONS(5757),
    [anon_sym_null] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5757),
    [anon_sym_LBRACK] = ACTIONS(5757),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5757),
    [anon_sym_LT_AT] = ACTIONS(5757),
    [anon_sym_LT_AT_AT] = ACTIONS(5755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5755),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_return_BANG] = ACTIONS(5755),
    [anon_sym_yield] = ACTIONS(5757),
    [anon_sym_yield_BANG] = ACTIONS(5755),
    [anon_sym_lazy] = ACTIONS(5757),
    [anon_sym_assert] = ACTIONS(5757),
    [anon_sym_upcast] = ACTIONS(5757),
    [anon_sym_downcast] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_fun] = ACTIONS(5757),
    [anon_sym_try] = ACTIONS(5757),
    [anon_sym_match] = ACTIONS(5757),
    [anon_sym_match_BANG] = ACTIONS(5755),
    [anon_sym_function] = ACTIONS(5757),
    [anon_sym_use] = ACTIONS(5757),
    [anon_sym_use_BANG] = ACTIONS(5755),
    [anon_sym_do_BANG] = ACTIONS(5755),
    [anon_sym_begin] = ACTIONS(5757),
    [aux_sym_char_token1] = ACTIONS(5755),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5757),
    [anon_sym_DQUOTE] = ACTIONS(5757),
    [anon_sym_AT_DQUOTE] = ACTIONS(5755),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5755),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5755),
    [sym_bool] = ACTIONS(5757),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5757),
    [sym_op_identifier] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_PLUS_DOT] = ACTIONS(5755),
    [anon_sym_DASH_DOT] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_AMP_AMP] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [aux_sym_prefix_op_token1] = ACTIONS(5755),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5755),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5755),
    [anon_sym_POUNDload] = ACTIONS(5755),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5755),
  },
  [3311] = {
    [sym_xml_doc] = STATE(3311),
    [sym_block_comment] = STATE(3311),
    [sym_line_comment] = STATE(3311),
    [sym_compiler_directive_decl] = STATE(3311),
    [sym_fsi_directive_decl] = STATE(3311),
    [sym_preproc_line] = STATE(3311),
    [ts_builtin_sym_end] = ACTIONS(5759),
    [sym_identifier] = ACTIONS(5761),
    [anon_sym_namespace] = ACTIONS(5761),
    [anon_sym_module] = ACTIONS(5761),
    [anon_sym_open] = ACTIONS(5761),
    [anon_sym_LBRACK_LT] = ACTIONS(5759),
    [anon_sym_return] = ACTIONS(5761),
    [anon_sym_type] = ACTIONS(5761),
    [anon_sym_do] = ACTIONS(5761),
    [anon_sym_and] = ACTIONS(5761),
    [anon_sym_let] = ACTIONS(5761),
    [anon_sym_let_BANG] = ACTIONS(5759),
    [anon_sym_LPAREN] = ACTIONS(5761),
    [anon_sym_null] = ACTIONS(5761),
    [anon_sym_AMP] = ACTIONS(5761),
    [anon_sym_LBRACK] = ACTIONS(5761),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5759),
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_LT_AT] = ACTIONS(5761),
    [anon_sym_LT_AT_AT] = ACTIONS(5759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5759),
    [anon_sym_new] = ACTIONS(5761),
    [anon_sym_return_BANG] = ACTIONS(5759),
    [anon_sym_yield] = ACTIONS(5761),
    [anon_sym_yield_BANG] = ACTIONS(5759),
    [anon_sym_lazy] = ACTIONS(5761),
    [anon_sym_assert] = ACTIONS(5761),
    [anon_sym_upcast] = ACTIONS(5761),
    [anon_sym_downcast] = ACTIONS(5761),
    [anon_sym_for] = ACTIONS(5761),
    [anon_sym_while] = ACTIONS(5761),
    [anon_sym_if] = ACTIONS(5761),
    [anon_sym_fun] = ACTIONS(5761),
    [anon_sym_try] = ACTIONS(5761),
    [anon_sym_match] = ACTIONS(5761),
    [anon_sym_match_BANG] = ACTIONS(5759),
    [anon_sym_function] = ACTIONS(5761),
    [anon_sym_use] = ACTIONS(5761),
    [anon_sym_use_BANG] = ACTIONS(5759),
    [anon_sym_do_BANG] = ACTIONS(5759),
    [anon_sym_begin] = ACTIONS(5761),
    [aux_sym_char_token1] = ACTIONS(5759),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5761),
    [anon_sym_DQUOTE] = ACTIONS(5761),
    [anon_sym_AT_DQUOTE] = ACTIONS(5759),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5759),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5759),
    [sym_bool] = ACTIONS(5761),
    [sym_unit] = ACTIONS(5759),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5761),
    [sym_op_identifier] = ACTIONS(5759),
    [anon_sym_PLUS] = ACTIONS(5761),
    [anon_sym_DASH] = ACTIONS(5761),
    [anon_sym_PLUS_DOT] = ACTIONS(5759),
    [anon_sym_DASH_DOT] = ACTIONS(5759),
    [anon_sym_PERCENT] = ACTIONS(5759),
    [anon_sym_AMP_AMP] = ACTIONS(5759),
    [anon_sym_TILDE] = ACTIONS(5759),
    [aux_sym_prefix_op_token1] = ACTIONS(5759),
    [sym_int] = ACTIONS(5761),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5759),
    [anon_sym_POUNDload] = ACTIONS(5759),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5759),
  },
  [3312] = {
    [sym_xml_doc] = STATE(3312),
    [sym_block_comment] = STATE(3312),
    [sym_line_comment] = STATE(3312),
    [sym_compiler_directive_decl] = STATE(3312),
    [sym_fsi_directive_decl] = STATE(3312),
    [sym_preproc_line] = STATE(3312),
    [aux_sym_type_argument_repeat1] = STATE(3312),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(5763),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
  },
  [3313] = {
    [sym_xml_doc] = STATE(3313),
    [sym_block_comment] = STATE(3313),
    [sym_line_comment] = STATE(3313),
    [sym_compiler_directive_decl] = STATE(3313),
    [sym_fsi_directive_decl] = STATE(3313),
    [sym_preproc_line] = STATE(3313),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_GT_RBRACK] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(5766),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [3314] = {
    [sym_xml_doc] = STATE(3314),
    [sym_block_comment] = STATE(3314),
    [sym_line_comment] = STATE(3314),
    [sym_compiler_directive_decl] = STATE(3314),
    [sym_fsi_directive_decl] = STATE(3314),
    [sym_preproc_line] = STATE(3314),
    [ts_builtin_sym_end] = ACTIONS(5768),
    [sym_identifier] = ACTIONS(5770),
    [anon_sym_namespace] = ACTIONS(5770),
    [anon_sym_module] = ACTIONS(5770),
    [anon_sym_open] = ACTIONS(5770),
    [anon_sym_LBRACK_LT] = ACTIONS(5768),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_type] = ACTIONS(5770),
    [anon_sym_do] = ACTIONS(5770),
    [anon_sym_and] = ACTIONS(5770),
    [anon_sym_let] = ACTIONS(5770),
    [anon_sym_let_BANG] = ACTIONS(5768),
    [anon_sym_LPAREN] = ACTIONS(5770),
    [anon_sym_null] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5770),
    [anon_sym_LT_AT] = ACTIONS(5770),
    [anon_sym_LT_AT_AT] = ACTIONS(5768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5768),
    [anon_sym_new] = ACTIONS(5770),
    [anon_sym_return_BANG] = ACTIONS(5768),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_yield_BANG] = ACTIONS(5768),
    [anon_sym_lazy] = ACTIONS(5770),
    [anon_sym_assert] = ACTIONS(5770),
    [anon_sym_upcast] = ACTIONS(5770),
    [anon_sym_downcast] = ACTIONS(5770),
    [anon_sym_for] = ACTIONS(5770),
    [anon_sym_while] = ACTIONS(5770),
    [anon_sym_if] = ACTIONS(5770),
    [anon_sym_fun] = ACTIONS(5770),
    [anon_sym_try] = ACTIONS(5770),
    [anon_sym_match] = ACTIONS(5770),
    [anon_sym_match_BANG] = ACTIONS(5768),
    [anon_sym_function] = ACTIONS(5770),
    [anon_sym_use] = ACTIONS(5770),
    [anon_sym_use_BANG] = ACTIONS(5768),
    [anon_sym_do_BANG] = ACTIONS(5768),
    [anon_sym_begin] = ACTIONS(5770),
    [aux_sym_char_token1] = ACTIONS(5768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [anon_sym_AT_DQUOTE] = ACTIONS(5768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5768),
    [sym_bool] = ACTIONS(5770),
    [sym_unit] = ACTIONS(5768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5770),
    [sym_op_identifier] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_PLUS_DOT] = ACTIONS(5768),
    [anon_sym_DASH_DOT] = ACTIONS(5768),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_AMP_AMP] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5768),
    [aux_sym_prefix_op_token1] = ACTIONS(5768),
    [sym_int] = ACTIONS(5770),
    [sym_xint] = ACTIONS(5768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5768),
    [anon_sym_POUNDload] = ACTIONS(5768),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5768),
  },
  [3315] = {
    [sym_xml_doc] = STATE(3315),
    [sym_block_comment] = STATE(3315),
    [sym_line_comment] = STATE(3315),
    [sym_compiler_directive_decl] = STATE(3315),
    [sym_fsi_directive_decl] = STATE(3315),
    [sym_preproc_line] = STATE(3315),
    [ts_builtin_sym_end] = ACTIONS(5772),
    [sym_identifier] = ACTIONS(5774),
    [anon_sym_namespace] = ACTIONS(5774),
    [anon_sym_module] = ACTIONS(5774),
    [anon_sym_open] = ACTIONS(5774),
    [anon_sym_LBRACK_LT] = ACTIONS(5772),
    [anon_sym_return] = ACTIONS(5774),
    [anon_sym_type] = ACTIONS(5774),
    [anon_sym_do] = ACTIONS(5774),
    [anon_sym_and] = ACTIONS(5774),
    [anon_sym_let] = ACTIONS(5774),
    [anon_sym_let_BANG] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_null] = ACTIONS(5774),
    [anon_sym_AMP] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5772),
    [anon_sym_LBRACE] = ACTIONS(5774),
    [anon_sym_LT_AT] = ACTIONS(5774),
    [anon_sym_LT_AT_AT] = ACTIONS(5772),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5772),
    [anon_sym_new] = ACTIONS(5774),
    [anon_sym_return_BANG] = ACTIONS(5772),
    [anon_sym_yield] = ACTIONS(5774),
    [anon_sym_yield_BANG] = ACTIONS(5772),
    [anon_sym_lazy] = ACTIONS(5774),
    [anon_sym_assert] = ACTIONS(5774),
    [anon_sym_upcast] = ACTIONS(5774),
    [anon_sym_downcast] = ACTIONS(5774),
    [anon_sym_for] = ACTIONS(5774),
    [anon_sym_while] = ACTIONS(5774),
    [anon_sym_if] = ACTIONS(5774),
    [anon_sym_fun] = ACTIONS(5774),
    [anon_sym_try] = ACTIONS(5774),
    [anon_sym_match] = ACTIONS(5774),
    [anon_sym_match_BANG] = ACTIONS(5772),
    [anon_sym_function] = ACTIONS(5774),
    [anon_sym_use] = ACTIONS(5774),
    [anon_sym_use_BANG] = ACTIONS(5772),
    [anon_sym_do_BANG] = ACTIONS(5772),
    [anon_sym_begin] = ACTIONS(5774),
    [aux_sym_char_token1] = ACTIONS(5772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5774),
    [anon_sym_DQUOTE] = ACTIONS(5774),
    [anon_sym_AT_DQUOTE] = ACTIONS(5772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5772),
    [sym_bool] = ACTIONS(5774),
    [sym_unit] = ACTIONS(5772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5774),
    [sym_op_identifier] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_PLUS_DOT] = ACTIONS(5772),
    [anon_sym_DASH_DOT] = ACTIONS(5772),
    [anon_sym_PERCENT] = ACTIONS(5772),
    [anon_sym_AMP_AMP] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5772),
    [aux_sym_prefix_op_token1] = ACTIONS(5772),
    [sym_int] = ACTIONS(5774),
    [sym_xint] = ACTIONS(5772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5772),
    [anon_sym_POUNDload] = ACTIONS(5772),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5772),
  },
  [3316] = {
    [sym_xml_doc] = STATE(3316),
    [sym_block_comment] = STATE(3316),
    [sym_line_comment] = STATE(3316),
    [sym_compiler_directive_decl] = STATE(3316),
    [sym_fsi_directive_decl] = STATE(3316),
    [sym_preproc_line] = STATE(3316),
    [aux_sym_type_argument_repeat1] = STATE(3312),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_let_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_null] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_LT_AT] = ACTIONS(3230),
    [anon_sym_LT_AT_AT] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_return_BANG] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_yield_BANG] = ACTIONS(3232),
    [anon_sym_lazy] = ACTIONS(3230),
    [anon_sym_assert] = ACTIONS(3230),
    [anon_sym_upcast] = ACTIONS(3230),
    [anon_sym_downcast] = ACTIONS(3230),
    [anon_sym_COLON_GT] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_fun] = ACTIONS(3230),
    [anon_sym_DASH_GT] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_match] = ACTIONS(3230),
    [anon_sym_match_BANG] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_use] = ACTIONS(3230),
    [anon_sym_use_BANG] = ACTIONS(3232),
    [anon_sym_do_BANG] = ACTIONS(3232),
    [anon_sym_begin] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_LT2] = ACTIONS(3230),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3232),
    [anon_sym_or] = ACTIONS(5709),
    [aux_sym_char_token1] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3232),
    [sym_bool] = ACTIONS(3230),
    [sym_unit] = ACTIONS(3232),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3230),
    [sym_op_identifier] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_PLUS_DOT] = ACTIONS(3232),
    [anon_sym_DASH_DOT] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [aux_sym_prefix_op_token1] = ACTIONS(3232),
    [sym_int] = ACTIONS(3230),
    [sym_xint] = ACTIONS(3232),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3232),
  },
  [3317] = {
    [sym_type_arguments] = STATE(3472),
    [sym_long_identifier] = STATE(3471),
    [sym_xml_doc] = STATE(3317),
    [sym_block_comment] = STATE(3317),
    [sym_line_comment] = STATE(3317),
    [sym_compiler_directive_decl] = STATE(3317),
    [sym_fsi_directive_decl] = STATE(3317),
    [sym_preproc_line] = STATE(3317),
    [aux_sym__compound_type_repeat1] = STATE(3440),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(2369),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2371),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
  },
  [3318] = {
    [sym_xml_doc] = STATE(3318),
    [sym_block_comment] = STATE(3318),
    [sym_line_comment] = STATE(3318),
    [sym_compiler_directive_decl] = STATE(3318),
    [sym_fsi_directive_decl] = STATE(3318),
    [sym_preproc_line] = STATE(3318),
    [sym_identifier] = ACTIONS(5593),
    [anon_sym_module] = ACTIONS(5593),
    [anon_sym_open] = ACTIONS(5593),
    [anon_sym_LBRACK_LT] = ACTIONS(5591),
    [anon_sym_return] = ACTIONS(5593),
    [anon_sym_type] = ACTIONS(5593),
    [anon_sym_do] = ACTIONS(5593),
    [anon_sym_and] = ACTIONS(5593),
    [anon_sym_let] = ACTIONS(5593),
    [anon_sym_let_BANG] = ACTIONS(5591),
    [anon_sym_LPAREN] = ACTIONS(5593),
    [anon_sym_null] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5593),
    [anon_sym_LBRACK] = ACTIONS(5593),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5591),
    [anon_sym_LBRACE] = ACTIONS(5593),
    [anon_sym_LT_AT] = ACTIONS(5593),
    [anon_sym_LT_AT_AT] = ACTIONS(5591),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5591),
    [anon_sym_new] = ACTIONS(5593),
    [anon_sym_return_BANG] = ACTIONS(5591),
    [anon_sym_yield] = ACTIONS(5593),
    [anon_sym_yield_BANG] = ACTIONS(5591),
    [anon_sym_lazy] = ACTIONS(5593),
    [anon_sym_assert] = ACTIONS(5593),
    [anon_sym_upcast] = ACTIONS(5593),
    [anon_sym_downcast] = ACTIONS(5593),
    [anon_sym_for] = ACTIONS(5593),
    [anon_sym_while] = ACTIONS(5593),
    [anon_sym_if] = ACTIONS(5593),
    [anon_sym_fun] = ACTIONS(5593),
    [anon_sym_try] = ACTIONS(5593),
    [anon_sym_match] = ACTIONS(5593),
    [anon_sym_match_BANG] = ACTIONS(5591),
    [anon_sym_function] = ACTIONS(5593),
    [anon_sym_use] = ACTIONS(5593),
    [anon_sym_use_BANG] = ACTIONS(5591),
    [anon_sym_do_BANG] = ACTIONS(5591),
    [anon_sym_begin] = ACTIONS(5593),
    [anon_sym_interface] = ACTIONS(5593),
    [aux_sym_char_token1] = ACTIONS(5591),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5593),
    [anon_sym_DQUOTE] = ACTIONS(5593),
    [anon_sym_AT_DQUOTE] = ACTIONS(5591),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5591),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5591),
    [sym_bool] = ACTIONS(5593),
    [sym_unit] = ACTIONS(5591),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5593),
    [sym_op_identifier] = ACTIONS(5591),
    [anon_sym_PLUS] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5593),
    [anon_sym_PLUS_DOT] = ACTIONS(5591),
    [anon_sym_DASH_DOT] = ACTIONS(5591),
    [anon_sym_PERCENT] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_TILDE] = ACTIONS(5591),
    [aux_sym_prefix_op_token1] = ACTIONS(5591),
    [sym_int] = ACTIONS(5593),
    [sym_xint] = ACTIONS(5591),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5591),
    [anon_sym_POUNDload] = ACTIONS(5591),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5591),
    [sym__dedent] = ACTIONS(5591),
  },
  [3319] = {
    [sym_xml_doc] = STATE(3319),
    [sym_block_comment] = STATE(3319),
    [sym_line_comment] = STATE(3319),
    [sym_compiler_directive_decl] = STATE(3319),
    [sym_fsi_directive_decl] = STATE(3319),
    [sym_preproc_line] = STATE(3319),
    [ts_builtin_sym_end] = ACTIONS(5776),
    [sym_identifier] = ACTIONS(5778),
    [anon_sym_namespace] = ACTIONS(5778),
    [anon_sym_module] = ACTIONS(5778),
    [anon_sym_open] = ACTIONS(5778),
    [anon_sym_LBRACK_LT] = ACTIONS(5776),
    [anon_sym_return] = ACTIONS(5778),
    [anon_sym_type] = ACTIONS(5778),
    [anon_sym_do] = ACTIONS(5778),
    [anon_sym_and] = ACTIONS(5778),
    [anon_sym_let] = ACTIONS(5778),
    [anon_sym_let_BANG] = ACTIONS(5776),
    [anon_sym_LPAREN] = ACTIONS(5778),
    [anon_sym_null] = ACTIONS(5778),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5776),
    [anon_sym_LBRACE] = ACTIONS(5778),
    [anon_sym_LT_AT] = ACTIONS(5778),
    [anon_sym_LT_AT_AT] = ACTIONS(5776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5776),
    [anon_sym_new] = ACTIONS(5778),
    [anon_sym_return_BANG] = ACTIONS(5776),
    [anon_sym_yield] = ACTIONS(5778),
    [anon_sym_yield_BANG] = ACTIONS(5776),
    [anon_sym_lazy] = ACTIONS(5778),
    [anon_sym_assert] = ACTIONS(5778),
    [anon_sym_upcast] = ACTIONS(5778),
    [anon_sym_downcast] = ACTIONS(5778),
    [anon_sym_for] = ACTIONS(5778),
    [anon_sym_while] = ACTIONS(5778),
    [anon_sym_if] = ACTIONS(5778),
    [anon_sym_fun] = ACTIONS(5778),
    [anon_sym_try] = ACTIONS(5778),
    [anon_sym_match] = ACTIONS(5778),
    [anon_sym_match_BANG] = ACTIONS(5776),
    [anon_sym_function] = ACTIONS(5778),
    [anon_sym_use] = ACTIONS(5778),
    [anon_sym_use_BANG] = ACTIONS(5776),
    [anon_sym_do_BANG] = ACTIONS(5776),
    [anon_sym_begin] = ACTIONS(5778),
    [aux_sym_char_token1] = ACTIONS(5776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5778),
    [anon_sym_DQUOTE] = ACTIONS(5778),
    [anon_sym_AT_DQUOTE] = ACTIONS(5776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5776),
    [sym_bool] = ACTIONS(5778),
    [sym_unit] = ACTIONS(5776),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5778),
    [sym_op_identifier] = ACTIONS(5776),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS_DOT] = ACTIONS(5776),
    [anon_sym_DASH_DOT] = ACTIONS(5776),
    [anon_sym_PERCENT] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_TILDE] = ACTIONS(5776),
    [aux_sym_prefix_op_token1] = ACTIONS(5776),
    [sym_int] = ACTIONS(5778),
    [sym_xint] = ACTIONS(5776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5776),
    [anon_sym_POUNDload] = ACTIONS(5776),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5776),
  },
  [3320] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7260),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3320),
    [sym_block_comment] = STATE(3320),
    [sym_line_comment] = STATE(3320),
    [sym_compiler_directive_decl] = STATE(3320),
    [sym_fsi_directive_decl] = STATE(3320),
    [sym_preproc_line] = STATE(3320),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3321] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7967),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3321),
    [sym_block_comment] = STATE(3321),
    [sym_line_comment] = STATE(3321),
    [sym_compiler_directive_decl] = STATE(3321),
    [sym_fsi_directive_decl] = STATE(3321),
    [sym_preproc_line] = STATE(3321),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3322] = {
    [sym_xml_doc] = STATE(3322),
    [sym_block_comment] = STATE(3322),
    [sym_line_comment] = STATE(3322),
    [sym_compiler_directive_decl] = STATE(3322),
    [sym_fsi_directive_decl] = STATE(3322),
    [sym_preproc_line] = STATE(3322),
    [aux_sym_long_identifier_repeat1] = STATE(3348),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_let_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_null] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3257),
    [anon_sym_LT_AT] = ACTIONS(3257),
    [anon_sym_LT_AT_AT] = ACTIONS(3259),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3259),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_return_BANG] = ACTIONS(3259),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_yield_BANG] = ACTIONS(3259),
    [anon_sym_lazy] = ACTIONS(3257),
    [anon_sym_assert] = ACTIONS(3257),
    [anon_sym_upcast] = ACTIONS(3257),
    [anon_sym_downcast] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_fun] = ACTIONS(3257),
    [anon_sym_DASH_GT] = ACTIONS(3259),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_match_BANG] = ACTIONS(3259),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_use_BANG] = ACTIONS(3259),
    [anon_sym_do_BANG] = ACTIONS(3259),
    [anon_sym_begin] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_LT2] = ACTIONS(3257),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3259),
    [aux_sym_char_token1] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3257),
    [anon_sym_AT_DQUOTE] = ACTIONS(3259),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3259),
    [sym_bool] = ACTIONS(3257),
    [sym_unit] = ACTIONS(3259),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3257),
    [sym_op_identifier] = ACTIONS(3259),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_PLUS_DOT] = ACTIONS(3259),
    [anon_sym_DASH_DOT] = ACTIONS(3259),
    [anon_sym_PERCENT] = ACTIONS(3259),
    [anon_sym_AMP_AMP] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [aux_sym_prefix_op_token1] = ACTIONS(3259),
    [sym_int] = ACTIONS(3257),
    [sym_xint] = ACTIONS(3259),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3259),
  },
  [3323] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8271),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3323),
    [sym_block_comment] = STATE(3323),
    [sym_line_comment] = STATE(3323),
    [sym_compiler_directive_decl] = STATE(3323),
    [sym_fsi_directive_decl] = STATE(3323),
    [sym_preproc_line] = STATE(3323),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3324] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7871),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3324),
    [sym_block_comment] = STATE(3324),
    [sym_line_comment] = STATE(3324),
    [sym_compiler_directive_decl] = STATE(3324),
    [sym_fsi_directive_decl] = STATE(3324),
    [sym_preproc_line] = STATE(3324),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5820),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3325] = {
    [sym_xml_doc] = STATE(3325),
    [sym_block_comment] = STATE(3325),
    [sym_line_comment] = STATE(3325),
    [sym_compiler_directive_decl] = STATE(3325),
    [sym_fsi_directive_decl] = STATE(3325),
    [sym_preproc_line] = STATE(3325),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_GT_RBRACK] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3298),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3298),
    [anon_sym_DASH_DOT] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3298),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__newline] = ACTIONS(3298),
  },
  [3326] = {
    [sym_xml_doc] = STATE(3326),
    [sym_block_comment] = STATE(3326),
    [sym_line_comment] = STATE(3326),
    [sym_compiler_directive_decl] = STATE(3326),
    [sym_fsi_directive_decl] = STATE(3326),
    [sym_preproc_line] = STATE(3326),
    [ts_builtin_sym_end] = ACTIONS(4173),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_namespace] = ACTIONS(4175),
    [anon_sym_module] = ACTIONS(4175),
    [anon_sym_open] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(4173),
    [anon_sym_return] = ACTIONS(4175),
    [anon_sym_type] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4175),
    [anon_sym_let] = ACTIONS(4175),
    [anon_sym_let_BANG] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_null] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4173),
    [anon_sym_LBRACE] = ACTIONS(4175),
    [anon_sym_LT_AT] = ACTIONS(4175),
    [anon_sym_LT_AT_AT] = ACTIONS(4173),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4173),
    [anon_sym_new] = ACTIONS(4175),
    [anon_sym_return_BANG] = ACTIONS(4173),
    [anon_sym_yield] = ACTIONS(4175),
    [anon_sym_yield_BANG] = ACTIONS(4173),
    [anon_sym_lazy] = ACTIONS(4175),
    [anon_sym_assert] = ACTIONS(4175),
    [anon_sym_upcast] = ACTIONS(4175),
    [anon_sym_downcast] = ACTIONS(4175),
    [anon_sym_for] = ACTIONS(4175),
    [anon_sym_while] = ACTIONS(4175),
    [anon_sym_if] = ACTIONS(4175),
    [anon_sym_fun] = ACTIONS(4175),
    [anon_sym_try] = ACTIONS(4175),
    [anon_sym_match] = ACTIONS(4175),
    [anon_sym_match_BANG] = ACTIONS(4173),
    [anon_sym_function] = ACTIONS(4175),
    [anon_sym_use] = ACTIONS(4175),
    [anon_sym_use_BANG] = ACTIONS(4173),
    [anon_sym_do_BANG] = ACTIONS(4173),
    [anon_sym_begin] = ACTIONS(4175),
    [aux_sym_char_token1] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(4175),
    [anon_sym_AT_DQUOTE] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [sym_bool] = ACTIONS(4175),
    [sym_unit] = ACTIONS(4173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4175),
    [sym_op_identifier] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_PLUS_DOT] = ACTIONS(4173),
    [anon_sym_DASH_DOT] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4173),
    [anon_sym_TILDE] = ACTIONS(4173),
    [aux_sym_prefix_op_token1] = ACTIONS(4173),
    [sym_int] = ACTIONS(4175),
    [sym_xint] = ACTIONS(4173),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4173),
    [anon_sym_POUNDload] = ACTIONS(4173),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4173),
  },
  [3327] = {
    [sym_xml_doc] = STATE(3327),
    [sym_block_comment] = STATE(3327),
    [sym_line_comment] = STATE(3327),
    [sym_compiler_directive_decl] = STATE(3327),
    [sym_fsi_directive_decl] = STATE(3327),
    [sym_preproc_line] = STATE(3327),
    [sym_identifier] = ACTIONS(5564),
    [anon_sym_module] = ACTIONS(5564),
    [anon_sym_open] = ACTIONS(5564),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_return] = ACTIONS(5564),
    [anon_sym_type] = ACTIONS(5564),
    [anon_sym_do] = ACTIONS(5564),
    [anon_sym_and] = ACTIONS(5564),
    [anon_sym_let] = ACTIONS(5564),
    [anon_sym_let_BANG] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_LT_AT] = ACTIONS(5564),
    [anon_sym_LT_AT_AT] = ACTIONS(5562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5562),
    [anon_sym_new] = ACTIONS(5564),
    [anon_sym_return_BANG] = ACTIONS(5562),
    [anon_sym_yield] = ACTIONS(5564),
    [anon_sym_yield_BANG] = ACTIONS(5562),
    [anon_sym_lazy] = ACTIONS(5564),
    [anon_sym_assert] = ACTIONS(5564),
    [anon_sym_upcast] = ACTIONS(5564),
    [anon_sym_downcast] = ACTIONS(5564),
    [anon_sym_for] = ACTIONS(5564),
    [anon_sym_while] = ACTIONS(5564),
    [anon_sym_if] = ACTIONS(5564),
    [anon_sym_fun] = ACTIONS(5564),
    [anon_sym_try] = ACTIONS(5564),
    [anon_sym_match] = ACTIONS(5564),
    [anon_sym_match_BANG] = ACTIONS(5562),
    [anon_sym_function] = ACTIONS(5564),
    [anon_sym_use] = ACTIONS(5564),
    [anon_sym_use_BANG] = ACTIONS(5562),
    [anon_sym_do_BANG] = ACTIONS(5562),
    [anon_sym_begin] = ACTIONS(5564),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5564),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5564),
    [sym_op_identifier] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_PLUS_DOT] = ACTIONS(5562),
    [anon_sym_DASH_DOT] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_TILDE] = ACTIONS(5562),
    [aux_sym_prefix_op_token1] = ACTIONS(5562),
    [sym_int] = ACTIONS(5564),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5562),
    [anon_sym_POUNDload] = ACTIONS(5562),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5562),
    [sym__dedent] = ACTIONS(5562),
  },
  [3328] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7612),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3328),
    [sym_block_comment] = STATE(3328),
    [sym_line_comment] = STATE(3328),
    [sym_compiler_directive_decl] = STATE(3328),
    [sym_fsi_directive_decl] = STATE(3328),
    [sym_preproc_line] = STATE(3328),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3329] = {
    [sym_xml_doc] = STATE(3329),
    [sym_block_comment] = STATE(3329),
    [sym_line_comment] = STATE(3329),
    [sym_compiler_directive_decl] = STATE(3329),
    [sym_fsi_directive_decl] = STATE(3329),
    [sym_preproc_line] = STATE(3329),
    [sym_identifier] = ACTIONS(5753),
    [anon_sym_module] = ACTIONS(5753),
    [anon_sym_open] = ACTIONS(5753),
    [anon_sym_LBRACK_LT] = ACTIONS(5751),
    [anon_sym_return] = ACTIONS(5753),
    [anon_sym_type] = ACTIONS(5753),
    [anon_sym_do] = ACTIONS(5753),
    [anon_sym_and] = ACTIONS(5753),
    [anon_sym_let] = ACTIONS(5753),
    [anon_sym_let_BANG] = ACTIONS(5751),
    [anon_sym_LPAREN] = ACTIONS(5753),
    [anon_sym_null] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5753),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5751),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_LT_AT] = ACTIONS(5753),
    [anon_sym_LT_AT_AT] = ACTIONS(5751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5751),
    [anon_sym_new] = ACTIONS(5753),
    [anon_sym_return_BANG] = ACTIONS(5751),
    [anon_sym_yield] = ACTIONS(5753),
    [anon_sym_yield_BANG] = ACTIONS(5751),
    [anon_sym_lazy] = ACTIONS(5753),
    [anon_sym_assert] = ACTIONS(5753),
    [anon_sym_upcast] = ACTIONS(5753),
    [anon_sym_downcast] = ACTIONS(5753),
    [anon_sym_for] = ACTIONS(5753),
    [anon_sym_while] = ACTIONS(5753),
    [anon_sym_if] = ACTIONS(5753),
    [anon_sym_fun] = ACTIONS(5753),
    [anon_sym_try] = ACTIONS(5753),
    [anon_sym_match] = ACTIONS(5753),
    [anon_sym_match_BANG] = ACTIONS(5751),
    [anon_sym_function] = ACTIONS(5753),
    [anon_sym_use] = ACTIONS(5753),
    [anon_sym_use_BANG] = ACTIONS(5751),
    [anon_sym_do_BANG] = ACTIONS(5751),
    [anon_sym_begin] = ACTIONS(5753),
    [aux_sym_char_token1] = ACTIONS(5751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5753),
    [anon_sym_DQUOTE] = ACTIONS(5753),
    [anon_sym_AT_DQUOTE] = ACTIONS(5751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5753),
    [sym_op_identifier] = ACTIONS(5751),
    [anon_sym_PLUS] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_DOT] = ACTIONS(5751),
    [anon_sym_DASH_DOT] = ACTIONS(5751),
    [anon_sym_PERCENT] = ACTIONS(5751),
    [anon_sym_AMP_AMP] = ACTIONS(5751),
    [anon_sym_TILDE] = ACTIONS(5751),
    [aux_sym_prefix_op_token1] = ACTIONS(5751),
    [sym_int] = ACTIONS(5753),
    [sym_xint] = ACTIONS(5751),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5751),
    [anon_sym_POUNDload] = ACTIONS(5751),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5751),
    [sym__dedent] = ACTIONS(5751),
  },
  [3330] = {
    [sym_xml_doc] = STATE(3330),
    [sym_block_comment] = STATE(3330),
    [sym_line_comment] = STATE(3330),
    [sym_compiler_directive_decl] = STATE(3330),
    [sym_fsi_directive_decl] = STATE(3330),
    [sym_preproc_line] = STATE(3330),
    [ts_builtin_sym_end] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_namespace] = ACTIONS(5826),
    [anon_sym_module] = ACTIONS(5826),
    [anon_sym_open] = ACTIONS(5826),
    [anon_sym_LBRACK_LT] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5826),
    [anon_sym_type] = ACTIONS(5826),
    [anon_sym_do] = ACTIONS(5826),
    [anon_sym_let] = ACTIONS(5826),
    [anon_sym_let_BANG] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5826),
    [anon_sym_null] = ACTIONS(5826),
    [anon_sym_AMP] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5826),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(5826),
    [anon_sym_LT_AT] = ACTIONS(5826),
    [anon_sym_LT_AT_AT] = ACTIONS(5824),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5824),
    [anon_sym_new] = ACTIONS(5826),
    [anon_sym_return_BANG] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5826),
    [anon_sym_yield_BANG] = ACTIONS(5824),
    [anon_sym_lazy] = ACTIONS(5826),
    [anon_sym_assert] = ACTIONS(5826),
    [anon_sym_upcast] = ACTIONS(5826),
    [anon_sym_downcast] = ACTIONS(5826),
    [anon_sym_for] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(5826),
    [anon_sym_if] = ACTIONS(5826),
    [anon_sym_fun] = ACTIONS(5826),
    [anon_sym_try] = ACTIONS(5826),
    [anon_sym_match] = ACTIONS(5826),
    [anon_sym_match_BANG] = ACTIONS(5824),
    [anon_sym_function] = ACTIONS(5826),
    [anon_sym_use] = ACTIONS(5826),
    [anon_sym_use_BANG] = ACTIONS(5824),
    [anon_sym_do_BANG] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5826),
    [aux_sym_char_token1] = ACTIONS(5824),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5826),
    [anon_sym_DQUOTE] = ACTIONS(5826),
    [anon_sym_AT_DQUOTE] = ACTIONS(5824),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5824),
    [sym_bool] = ACTIONS(5826),
    [sym_unit] = ACTIONS(5824),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5826),
    [sym_op_identifier] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [anon_sym_PLUS_DOT] = ACTIONS(5824),
    [anon_sym_DASH_DOT] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5824),
    [aux_sym_prefix_op_token1] = ACTIONS(5824),
    [sym_int] = ACTIONS(5826),
    [sym_xint] = ACTIONS(5824),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5824),
    [anon_sym_POUNDload] = ACTIONS(5824),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5824),
  },
  [3331] = {
    [sym_xml_doc] = STATE(3331),
    [sym_block_comment] = STATE(3331),
    [sym_line_comment] = STATE(3331),
    [sym_compiler_directive_decl] = STATE(3331),
    [sym_fsi_directive_decl] = STATE(3331),
    [sym_preproc_line] = STATE(3331),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_GT_RBRACK] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3306),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3306),
    [anon_sym_DASH_DOT] = ACTIONS(3306),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3306),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__newline] = ACTIONS(3306),
  },
  [3332] = {
    [sym_xml_doc] = STATE(3332),
    [sym_block_comment] = STATE(3332),
    [sym_line_comment] = STATE(3332),
    [sym_compiler_directive_decl] = STATE(3332),
    [sym_fsi_directive_decl] = STATE(3332),
    [sym_preproc_line] = STATE(3332),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_let_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_null] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_LT_AT] = ACTIONS(3274),
    [anon_sym_LT_AT_AT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_return_BANG] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_yield_BANG] = ACTIONS(3276),
    [anon_sym_lazy] = ACTIONS(3274),
    [anon_sym_assert] = ACTIONS(3274),
    [anon_sym_upcast] = ACTIONS(3274),
    [anon_sym_downcast] = ACTIONS(3274),
    [anon_sym_COLON_GT] = ACTIONS(3276),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_fun] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3276),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_match] = ACTIONS(3274),
    [anon_sym_match_BANG] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_use] = ACTIONS(3274),
    [anon_sym_use_BANG] = ACTIONS(3276),
    [anon_sym_do_BANG] = ACTIONS(3276),
    [anon_sym_begin] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_LT2] = ACTIONS(3274),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3276),
    [anon_sym_or] = ACTIONS(3274),
    [aux_sym_char_token1] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_AT_DQUOTE] = ACTIONS(3276),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3276),
    [sym_bool] = ACTIONS(3274),
    [sym_unit] = ACTIONS(3276),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3274),
    [sym_op_identifier] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_PLUS_DOT] = ACTIONS(3276),
    [anon_sym_DASH_DOT] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3276),
    [aux_sym_prefix_op_token1] = ACTIONS(3276),
    [sym_int] = ACTIONS(3274),
    [sym_xint] = ACTIONS(3276),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3276),
  },
  [3333] = {
    [sym_xml_doc] = STATE(3333),
    [sym_block_comment] = STATE(3333),
    [sym_line_comment] = STATE(3333),
    [sym_compiler_directive_decl] = STATE(3333),
    [sym_fsi_directive_decl] = STATE(3333),
    [sym_preproc_line] = STATE(3333),
    [sym_identifier] = ACTIONS(5542),
    [anon_sym_module] = ACTIONS(5542),
    [anon_sym_open] = ACTIONS(5542),
    [anon_sym_LBRACK_LT] = ACTIONS(5540),
    [anon_sym_return] = ACTIONS(5542),
    [anon_sym_type] = ACTIONS(5542),
    [anon_sym_do] = ACTIONS(5542),
    [anon_sym_and] = ACTIONS(5542),
    [anon_sym_let] = ACTIONS(5542),
    [anon_sym_let_BANG] = ACTIONS(5540),
    [anon_sym_LPAREN] = ACTIONS(5542),
    [anon_sym_null] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5540),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_LT_AT] = ACTIONS(5542),
    [anon_sym_LT_AT_AT] = ACTIONS(5540),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5540),
    [anon_sym_new] = ACTIONS(5542),
    [anon_sym_return_BANG] = ACTIONS(5540),
    [anon_sym_yield] = ACTIONS(5542),
    [anon_sym_yield_BANG] = ACTIONS(5540),
    [anon_sym_lazy] = ACTIONS(5542),
    [anon_sym_assert] = ACTIONS(5542),
    [anon_sym_upcast] = ACTIONS(5542),
    [anon_sym_downcast] = ACTIONS(5542),
    [anon_sym_for] = ACTIONS(5542),
    [anon_sym_while] = ACTIONS(5542),
    [anon_sym_if] = ACTIONS(5542),
    [anon_sym_fun] = ACTIONS(5542),
    [anon_sym_try] = ACTIONS(5542),
    [anon_sym_match] = ACTIONS(5542),
    [anon_sym_match_BANG] = ACTIONS(5540),
    [anon_sym_function] = ACTIONS(5542),
    [anon_sym_use] = ACTIONS(5542),
    [anon_sym_use_BANG] = ACTIONS(5540),
    [anon_sym_do_BANG] = ACTIONS(5540),
    [anon_sym_begin] = ACTIONS(5542),
    [aux_sym_char_token1] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_AT_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5540),
    [sym_bool] = ACTIONS(5542),
    [sym_unit] = ACTIONS(5540),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5542),
    [sym_op_identifier] = ACTIONS(5540),
    [anon_sym_PLUS] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_PLUS_DOT] = ACTIONS(5540),
    [anon_sym_DASH_DOT] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_TILDE] = ACTIONS(5540),
    [aux_sym_prefix_op_token1] = ACTIONS(5540),
    [sym_int] = ACTIONS(5542),
    [sym_xint] = ACTIONS(5540),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5540),
    [anon_sym_POUNDload] = ACTIONS(5540),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5540),
    [sym__dedent] = ACTIONS(5540),
  },
  [3334] = {
    [sym_xml_doc] = STATE(3334),
    [sym_block_comment] = STATE(3334),
    [sym_line_comment] = STATE(3334),
    [sym_compiler_directive_decl] = STATE(3334),
    [sym_fsi_directive_decl] = STATE(3334),
    [sym_preproc_line] = STATE(3334),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
    [sym__dedent] = ACTIONS(3244),
  },
  [3335] = {
    [sym_xml_doc] = STATE(3335),
    [sym_block_comment] = STATE(3335),
    [sym_line_comment] = STATE(3335),
    [sym_compiler_directive_decl] = STATE(3335),
    [sym_fsi_directive_decl] = STATE(3335),
    [sym_preproc_line] = STATE(3335),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_open] = ACTIONS(3285),
    [anon_sym_LBRACK_LT] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3287),
    [anon_sym_POUNDload] = ACTIONS(3287),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [3336] = {
    [sym_xml_doc] = STATE(3336),
    [sym_block_comment] = STATE(3336),
    [sym_line_comment] = STATE(3336),
    [sym_compiler_directive_decl] = STATE(3336),
    [sym_fsi_directive_decl] = STATE(3336),
    [sym_preproc_line] = STATE(3336),
    [ts_builtin_sym_end] = ACTIONS(5828),
    [sym_identifier] = ACTIONS(5830),
    [anon_sym_namespace] = ACTIONS(5830),
    [anon_sym_module] = ACTIONS(5830),
    [anon_sym_open] = ACTIONS(5830),
    [anon_sym_LBRACK_LT] = ACTIONS(5828),
    [anon_sym_return] = ACTIONS(5830),
    [anon_sym_type] = ACTIONS(5830),
    [anon_sym_do] = ACTIONS(5830),
    [anon_sym_let] = ACTIONS(5830),
    [anon_sym_let_BANG] = ACTIONS(5828),
    [anon_sym_LPAREN] = ACTIONS(5830),
    [anon_sym_null] = ACTIONS(5830),
    [anon_sym_AMP] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5830),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5828),
    [anon_sym_LBRACE] = ACTIONS(5830),
    [anon_sym_LT_AT] = ACTIONS(5830),
    [anon_sym_LT_AT_AT] = ACTIONS(5828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(5830),
    [anon_sym_return_BANG] = ACTIONS(5828),
    [anon_sym_yield] = ACTIONS(5830),
    [anon_sym_yield_BANG] = ACTIONS(5828),
    [anon_sym_lazy] = ACTIONS(5830),
    [anon_sym_assert] = ACTIONS(5830),
    [anon_sym_upcast] = ACTIONS(5830),
    [anon_sym_downcast] = ACTIONS(5830),
    [anon_sym_for] = ACTIONS(5830),
    [anon_sym_while] = ACTIONS(5830),
    [anon_sym_if] = ACTIONS(5830),
    [anon_sym_fun] = ACTIONS(5830),
    [anon_sym_try] = ACTIONS(5830),
    [anon_sym_match] = ACTIONS(5830),
    [anon_sym_match_BANG] = ACTIONS(5828),
    [anon_sym_function] = ACTIONS(5830),
    [anon_sym_use] = ACTIONS(5830),
    [anon_sym_use_BANG] = ACTIONS(5828),
    [anon_sym_do_BANG] = ACTIONS(5828),
    [anon_sym_begin] = ACTIONS(5830),
    [aux_sym_char_token1] = ACTIONS(5828),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5830),
    [anon_sym_DQUOTE] = ACTIONS(5830),
    [anon_sym_AT_DQUOTE] = ACTIONS(5828),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5828),
    [sym_bool] = ACTIONS(5830),
    [sym_unit] = ACTIONS(5828),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5830),
    [sym_op_identifier] = ACTIONS(5828),
    [anon_sym_PLUS] = ACTIONS(5830),
    [anon_sym_DASH] = ACTIONS(5830),
    [anon_sym_PLUS_DOT] = ACTIONS(5828),
    [anon_sym_DASH_DOT] = ACTIONS(5828),
    [anon_sym_PERCENT] = ACTIONS(5828),
    [anon_sym_AMP_AMP] = ACTIONS(5828),
    [anon_sym_TILDE] = ACTIONS(5828),
    [aux_sym_prefix_op_token1] = ACTIONS(5828),
    [sym_int] = ACTIONS(5830),
    [sym_xint] = ACTIONS(5828),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5828),
    [anon_sym_POUNDload] = ACTIONS(5828),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5828),
  },
  [3337] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8281),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3337),
    [sym_block_comment] = STATE(3337),
    [sym_line_comment] = STATE(3337),
    [sym_compiler_directive_decl] = STATE(3337),
    [sym_fsi_directive_decl] = STATE(3337),
    [sym_preproc_line] = STATE(3337),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5832),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3338] = {
    [sym_xml_doc] = STATE(3338),
    [sym_block_comment] = STATE(3338),
    [sym_line_comment] = STATE(3338),
    [sym_compiler_directive_decl] = STATE(3338),
    [sym_fsi_directive_decl] = STATE(3338),
    [sym_preproc_line] = STATE(3338),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_GT_RBRACK] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3302),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3302),
    [anon_sym_DASH_DOT] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3302),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__newline] = ACTIONS(3302),
  },
  [3339] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7390),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3339),
    [sym_block_comment] = STATE(3339),
    [sym_line_comment] = STATE(3339),
    [sym_compiler_directive_decl] = STATE(3339),
    [sym_fsi_directive_decl] = STATE(3339),
    [sym_preproc_line] = STATE(3339),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3340] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7869),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3340),
    [sym_block_comment] = STATE(3340),
    [sym_line_comment] = STATE(3340),
    [sym_compiler_directive_decl] = STATE(3340),
    [sym_fsi_directive_decl] = STATE(3340),
    [sym_preproc_line] = STATE(3340),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5836),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3341] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8280),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3341),
    [sym_block_comment] = STATE(3341),
    [sym_line_comment] = STATE(3341),
    [sym_compiler_directive_decl] = STATE(3341),
    [sym_fsi_directive_decl] = STATE(3341),
    [sym_preproc_line] = STATE(3341),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3342] = {
    [sym_xml_doc] = STATE(3342),
    [sym_block_comment] = STATE(3342),
    [sym_line_comment] = STATE(3342),
    [sym_compiler_directive_decl] = STATE(3342),
    [sym_fsi_directive_decl] = STATE(3342),
    [sym_preproc_line] = STATE(3342),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_as] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3342),
    [anon_sym_DASH_DOT] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3342),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
  },
  [3343] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8029),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3343),
    [sym_block_comment] = STATE(3343),
    [sym_line_comment] = STATE(3343),
    [sym_compiler_directive_decl] = STATE(3343),
    [sym_fsi_directive_decl] = STATE(3343),
    [sym_preproc_line] = STATE(3343),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5840),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3344] = {
    [sym_xml_doc] = STATE(3344),
    [sym_block_comment] = STATE(3344),
    [sym_line_comment] = STATE(3344),
    [sym_compiler_directive_decl] = STATE(3344),
    [sym_fsi_directive_decl] = STATE(3344),
    [sym_preproc_line] = STATE(3344),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_as] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3310),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3310),
    [anon_sym_DASH_DOT] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3310),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
  },
  [3345] = {
    [sym_xml_doc] = STATE(3345),
    [sym_block_comment] = STATE(3345),
    [sym_line_comment] = STATE(3345),
    [sym_compiler_directive_decl] = STATE(3345),
    [sym_fsi_directive_decl] = STATE(3345),
    [sym_preproc_line] = STATE(3345),
    [ts_builtin_sym_end] = ACTIONS(5842),
    [sym_identifier] = ACTIONS(5844),
    [anon_sym_namespace] = ACTIONS(5844),
    [anon_sym_module] = ACTIONS(5844),
    [anon_sym_open] = ACTIONS(5844),
    [anon_sym_LBRACK_LT] = ACTIONS(5842),
    [anon_sym_return] = ACTIONS(5844),
    [anon_sym_type] = ACTIONS(5844),
    [anon_sym_do] = ACTIONS(5844),
    [anon_sym_let] = ACTIONS(5844),
    [anon_sym_let_BANG] = ACTIONS(5842),
    [anon_sym_LPAREN] = ACTIONS(5844),
    [anon_sym_null] = ACTIONS(5844),
    [anon_sym_AMP] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5842),
    [anon_sym_LBRACE] = ACTIONS(5844),
    [anon_sym_LT_AT] = ACTIONS(5844),
    [anon_sym_LT_AT_AT] = ACTIONS(5842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5842),
    [anon_sym_new] = ACTIONS(5844),
    [anon_sym_return_BANG] = ACTIONS(5842),
    [anon_sym_yield] = ACTIONS(5844),
    [anon_sym_yield_BANG] = ACTIONS(5842),
    [anon_sym_lazy] = ACTIONS(5844),
    [anon_sym_assert] = ACTIONS(5844),
    [anon_sym_upcast] = ACTIONS(5844),
    [anon_sym_downcast] = ACTIONS(5844),
    [anon_sym_for] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_fun] = ACTIONS(5844),
    [anon_sym_try] = ACTIONS(5844),
    [anon_sym_match] = ACTIONS(5844),
    [anon_sym_match_BANG] = ACTIONS(5842),
    [anon_sym_function] = ACTIONS(5844),
    [anon_sym_use] = ACTIONS(5844),
    [anon_sym_use_BANG] = ACTIONS(5842),
    [anon_sym_do_BANG] = ACTIONS(5842),
    [anon_sym_begin] = ACTIONS(5844),
    [aux_sym_char_token1] = ACTIONS(5842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5844),
    [anon_sym_DQUOTE] = ACTIONS(5844),
    [anon_sym_AT_DQUOTE] = ACTIONS(5842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5842),
    [sym_bool] = ACTIONS(5844),
    [sym_unit] = ACTIONS(5842),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5844),
    [sym_op_identifier] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_PLUS_DOT] = ACTIONS(5842),
    [anon_sym_DASH_DOT] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5842),
    [aux_sym_prefix_op_token1] = ACTIONS(5842),
    [sym_int] = ACTIONS(5844),
    [sym_xint] = ACTIONS(5842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5842),
    [anon_sym_POUNDload] = ACTIONS(5842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5842),
  },
  [3346] = {
    [sym_xml_doc] = STATE(3346),
    [sym_block_comment] = STATE(3346),
    [sym_line_comment] = STATE(3346),
    [sym_compiler_directive_decl] = STATE(3346),
    [sym_fsi_directive_decl] = STATE(3346),
    [sym_preproc_line] = STATE(3346),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_GT_RBRACK] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LT2] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3357),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3357),
    [anon_sym_DASH_DOT] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3357),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__newline] = ACTIONS(3357),
  },
  [3347] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8060),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3347),
    [sym_block_comment] = STATE(3347),
    [sym_line_comment] = STATE(3347),
    [sym_compiler_directive_decl] = STATE(3347),
    [sym_fsi_directive_decl] = STATE(3347),
    [sym_preproc_line] = STATE(3347),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5848),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3348] = {
    [sym_xml_doc] = STATE(3348),
    [sym_block_comment] = STATE(3348),
    [sym_line_comment] = STATE(3348),
    [sym_compiler_directive_decl] = STATE(3348),
    [sym_fsi_directive_decl] = STATE(3348),
    [sym_preproc_line] = STATE(3348),
    [aux_sym_long_identifier_repeat1] = STATE(3386),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_let_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_null] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_LT_AT] = ACTIONS(3202),
    [anon_sym_LT_AT_AT] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_return_BANG] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_yield_BANG] = ACTIONS(3204),
    [anon_sym_lazy] = ACTIONS(3202),
    [anon_sym_assert] = ACTIONS(3202),
    [anon_sym_upcast] = ACTIONS(3202),
    [anon_sym_downcast] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_fun] = ACTIONS(3202),
    [anon_sym_DASH_GT] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_match] = ACTIONS(3202),
    [anon_sym_match_BANG] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_use] = ACTIONS(3202),
    [anon_sym_use_BANG] = ACTIONS(3204),
    [anon_sym_do_BANG] = ACTIONS(3204),
    [anon_sym_begin] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_LT2] = ACTIONS(3202),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3204),
    [aux_sym_char_token1] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_AT_DQUOTE] = ACTIONS(3204),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3204),
    [sym_bool] = ACTIONS(3202),
    [sym_unit] = ACTIONS(3204),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3202),
    [sym_op_identifier] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PLUS_DOT] = ACTIONS(3204),
    [anon_sym_DASH_DOT] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [aux_sym_prefix_op_token1] = ACTIONS(3204),
    [sym_int] = ACTIONS(3202),
    [sym_xint] = ACTIONS(3204),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3204),
  },
  [3349] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7755),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3349),
    [sym_block_comment] = STATE(3349),
    [sym_line_comment] = STATE(3349),
    [sym_compiler_directive_decl] = STATE(3349),
    [sym_fsi_directive_decl] = STATE(3349),
    [sym_preproc_line] = STATE(3349),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5850),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3350] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7763),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3350),
    [sym_block_comment] = STATE(3350),
    [sym_line_comment] = STATE(3350),
    [sym_compiler_directive_decl] = STATE(3350),
    [sym_fsi_directive_decl] = STATE(3350),
    [sym_preproc_line] = STATE(3350),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3351] = {
    [sym_xml_doc] = STATE(3351),
    [sym_block_comment] = STATE(3351),
    [sym_line_comment] = STATE(3351),
    [sym_compiler_directive_decl] = STATE(3351),
    [sym_fsi_directive_decl] = STATE(3351),
    [sym_preproc_line] = STATE(3351),
    [ts_builtin_sym_end] = ACTIONS(5854),
    [sym_identifier] = ACTIONS(5856),
    [anon_sym_namespace] = ACTIONS(5856),
    [anon_sym_module] = ACTIONS(5856),
    [anon_sym_open] = ACTIONS(5856),
    [anon_sym_LBRACK_LT] = ACTIONS(5854),
    [anon_sym_return] = ACTIONS(5856),
    [anon_sym_type] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_let] = ACTIONS(5856),
    [anon_sym_let_BANG] = ACTIONS(5854),
    [anon_sym_LPAREN] = ACTIONS(5856),
    [anon_sym_null] = ACTIONS(5856),
    [anon_sym_AMP] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5854),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_LT_AT] = ACTIONS(5856),
    [anon_sym_LT_AT_AT] = ACTIONS(5854),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5854),
    [anon_sym_new] = ACTIONS(5856),
    [anon_sym_return_BANG] = ACTIONS(5854),
    [anon_sym_yield] = ACTIONS(5856),
    [anon_sym_yield_BANG] = ACTIONS(5854),
    [anon_sym_lazy] = ACTIONS(5856),
    [anon_sym_assert] = ACTIONS(5856),
    [anon_sym_upcast] = ACTIONS(5856),
    [anon_sym_downcast] = ACTIONS(5856),
    [anon_sym_for] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_fun] = ACTIONS(5856),
    [anon_sym_try] = ACTIONS(5856),
    [anon_sym_match] = ACTIONS(5856),
    [anon_sym_match_BANG] = ACTIONS(5854),
    [anon_sym_function] = ACTIONS(5856),
    [anon_sym_use] = ACTIONS(5856),
    [anon_sym_use_BANG] = ACTIONS(5854),
    [anon_sym_do_BANG] = ACTIONS(5854),
    [anon_sym_begin] = ACTIONS(5856),
    [aux_sym_char_token1] = ACTIONS(5854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5856),
    [anon_sym_DQUOTE] = ACTIONS(5856),
    [anon_sym_AT_DQUOTE] = ACTIONS(5854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5854),
    [sym_bool] = ACTIONS(5856),
    [sym_unit] = ACTIONS(5854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5856),
    [sym_op_identifier] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5856),
    [anon_sym_PLUS_DOT] = ACTIONS(5854),
    [anon_sym_DASH_DOT] = ACTIONS(5854),
    [anon_sym_PERCENT] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_TILDE] = ACTIONS(5854),
    [aux_sym_prefix_op_token1] = ACTIONS(5854),
    [sym_int] = ACTIONS(5856),
    [sym_xint] = ACTIONS(5854),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5854),
    [anon_sym_POUNDload] = ACTIONS(5854),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5854),
  },
  [3352] = {
    [sym_xml_doc] = STATE(3352),
    [sym_block_comment] = STATE(3352),
    [sym_line_comment] = STATE(3352),
    [sym_compiler_directive_decl] = STATE(3352),
    [sym_fsi_directive_decl] = STATE(3352),
    [sym_preproc_line] = STATE(3352),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3338),
    [anon_sym_DASH_DOT] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3338),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
  },
  [3353] = {
    [sym_xml_doc] = STATE(3353),
    [sym_block_comment] = STATE(3353),
    [sym_line_comment] = STATE(3353),
    [sym_compiler_directive_decl] = STATE(3353),
    [sym_fsi_directive_decl] = STATE(3353),
    [sym_preproc_line] = STATE(3353),
    [ts_builtin_sym_end] = ACTIONS(5858),
    [sym_identifier] = ACTIONS(5860),
    [anon_sym_namespace] = ACTIONS(5860),
    [anon_sym_module] = ACTIONS(5860),
    [anon_sym_open] = ACTIONS(5860),
    [anon_sym_LBRACK_LT] = ACTIONS(5858),
    [anon_sym_return] = ACTIONS(5860),
    [anon_sym_type] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_let] = ACTIONS(5860),
    [anon_sym_let_BANG] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_null] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_LT_AT] = ACTIONS(5860),
    [anon_sym_LT_AT_AT] = ACTIONS(5858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5858),
    [anon_sym_new] = ACTIONS(5860),
    [anon_sym_return_BANG] = ACTIONS(5858),
    [anon_sym_yield] = ACTIONS(5860),
    [anon_sym_yield_BANG] = ACTIONS(5858),
    [anon_sym_lazy] = ACTIONS(5860),
    [anon_sym_assert] = ACTIONS(5860),
    [anon_sym_upcast] = ACTIONS(5860),
    [anon_sym_downcast] = ACTIONS(5860),
    [anon_sym_for] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_fun] = ACTIONS(5860),
    [anon_sym_try] = ACTIONS(5860),
    [anon_sym_match] = ACTIONS(5860),
    [anon_sym_match_BANG] = ACTIONS(5858),
    [anon_sym_function] = ACTIONS(5860),
    [anon_sym_use] = ACTIONS(5860),
    [anon_sym_use_BANG] = ACTIONS(5858),
    [anon_sym_do_BANG] = ACTIONS(5858),
    [anon_sym_begin] = ACTIONS(5860),
    [aux_sym_char_token1] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5860),
    [anon_sym_DQUOTE] = ACTIONS(5860),
    [anon_sym_AT_DQUOTE] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [sym_bool] = ACTIONS(5860),
    [sym_unit] = ACTIONS(5858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5860),
    [sym_op_identifier] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_PLUS_DOT] = ACTIONS(5858),
    [anon_sym_DASH_DOT] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_TILDE] = ACTIONS(5858),
    [aux_sym_prefix_op_token1] = ACTIONS(5858),
    [sym_int] = ACTIONS(5860),
    [sym_xint] = ACTIONS(5858),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5858),
    [anon_sym_POUNDload] = ACTIONS(5858),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5858),
  },
  [3354] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7656),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3354),
    [sym_block_comment] = STATE(3354),
    [sym_line_comment] = STATE(3354),
    [sym_compiler_directive_decl] = STATE(3354),
    [sym_fsi_directive_decl] = STATE(3354),
    [sym_preproc_line] = STATE(3354),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3355] = {
    [sym_xml_doc] = STATE(3355),
    [sym_block_comment] = STATE(3355),
    [sym_line_comment] = STATE(3355),
    [sym_compiler_directive_decl] = STATE(3355),
    [sym_fsi_directive_decl] = STATE(3355),
    [sym_preproc_line] = STATE(3355),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3298),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3298),
    [anon_sym_DASH_DOT] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3298),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
  },
  [3356] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7794),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3356),
    [sym_block_comment] = STATE(3356),
    [sym_line_comment] = STATE(3356),
    [sym_compiler_directive_decl] = STATE(3356),
    [sym_fsi_directive_decl] = STATE(3356),
    [sym_preproc_line] = STATE(3356),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5864),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3357] = {
    [sym_xml_doc] = STATE(3357),
    [sym_block_comment] = STATE(3357),
    [sym_line_comment] = STATE(3357),
    [sym_compiler_directive_decl] = STATE(3357),
    [sym_fsi_directive_decl] = STATE(3357),
    [sym_preproc_line] = STATE(3357),
    [ts_builtin_sym_end] = ACTIONS(5866),
    [sym_identifier] = ACTIONS(5868),
    [anon_sym_namespace] = ACTIONS(5868),
    [anon_sym_module] = ACTIONS(5868),
    [anon_sym_open] = ACTIONS(5868),
    [anon_sym_LBRACK_LT] = ACTIONS(5866),
    [anon_sym_return] = ACTIONS(5868),
    [anon_sym_type] = ACTIONS(5868),
    [anon_sym_do] = ACTIONS(5868),
    [anon_sym_let] = ACTIONS(5868),
    [anon_sym_let_BANG] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5868),
    [anon_sym_null] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5868),
    [anon_sym_LT_AT] = ACTIONS(5868),
    [anon_sym_LT_AT_AT] = ACTIONS(5866),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5866),
    [anon_sym_new] = ACTIONS(5868),
    [anon_sym_return_BANG] = ACTIONS(5866),
    [anon_sym_yield] = ACTIONS(5868),
    [anon_sym_yield_BANG] = ACTIONS(5866),
    [anon_sym_lazy] = ACTIONS(5868),
    [anon_sym_assert] = ACTIONS(5868),
    [anon_sym_upcast] = ACTIONS(5868),
    [anon_sym_downcast] = ACTIONS(5868),
    [anon_sym_for] = ACTIONS(5868),
    [anon_sym_while] = ACTIONS(5868),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_fun] = ACTIONS(5868),
    [anon_sym_try] = ACTIONS(5868),
    [anon_sym_match] = ACTIONS(5868),
    [anon_sym_match_BANG] = ACTIONS(5866),
    [anon_sym_function] = ACTIONS(5868),
    [anon_sym_use] = ACTIONS(5868),
    [anon_sym_use_BANG] = ACTIONS(5866),
    [anon_sym_do_BANG] = ACTIONS(5866),
    [anon_sym_begin] = ACTIONS(5868),
    [aux_sym_char_token1] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5868),
    [anon_sym_DQUOTE] = ACTIONS(5868),
    [anon_sym_AT_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [sym_bool] = ACTIONS(5868),
    [sym_unit] = ACTIONS(5866),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5868),
    [sym_op_identifier] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_DOT] = ACTIONS(5866),
    [anon_sym_DASH_DOT] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(5866),
    [anon_sym_TILDE] = ACTIONS(5866),
    [aux_sym_prefix_op_token1] = ACTIONS(5866),
    [sym_int] = ACTIONS(5868),
    [sym_xint] = ACTIONS(5866),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5866),
    [anon_sym_POUNDload] = ACTIONS(5866),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5866),
  },
  [3358] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8164),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3358),
    [sym_block_comment] = STATE(3358),
    [sym_line_comment] = STATE(3358),
    [sym_compiler_directive_decl] = STATE(3358),
    [sym_fsi_directive_decl] = STATE(3358),
    [sym_preproc_line] = STATE(3358),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3359] = {
    [sym_xml_doc] = STATE(3359),
    [sym_block_comment] = STATE(3359),
    [sym_line_comment] = STATE(3359),
    [sym_compiler_directive_decl] = STATE(3359),
    [sym_fsi_directive_decl] = STATE(3359),
    [sym_preproc_line] = STATE(3359),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_GT_RBRACK] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3294),
    [anon_sym_DASH_DOT] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3294),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__newline] = ACTIONS(3294),
  },
  [3360] = {
    [sym_xml_doc] = STATE(3360),
    [sym_block_comment] = STATE(3360),
    [sym_line_comment] = STATE(3360),
    [sym_compiler_directive_decl] = STATE(3360),
    [sym_fsi_directive_decl] = STATE(3360),
    [sym_preproc_line] = STATE(3360),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_GT_RBRACK] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3324),
    [anon_sym_DASH_DOT] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3324),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__newline] = ACTIONS(3324),
  },
  [3361] = {
    [sym_xml_doc] = STATE(3361),
    [sym_block_comment] = STATE(3361),
    [sym_line_comment] = STATE(3361),
    [sym_compiler_directive_decl] = STATE(3361),
    [sym_fsi_directive_decl] = STATE(3361),
    [sym_preproc_line] = STATE(3361),
    [ts_builtin_sym_end] = ACTIONS(5872),
    [sym_identifier] = ACTIONS(5874),
    [anon_sym_namespace] = ACTIONS(5874),
    [anon_sym_module] = ACTIONS(5874),
    [anon_sym_open] = ACTIONS(5874),
    [anon_sym_LBRACK_LT] = ACTIONS(5872),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_type] = ACTIONS(5874),
    [anon_sym_do] = ACTIONS(5874),
    [anon_sym_let] = ACTIONS(5874),
    [anon_sym_let_BANG] = ACTIONS(5872),
    [anon_sym_LPAREN] = ACTIONS(5874),
    [anon_sym_null] = ACTIONS(5874),
    [anon_sym_AMP] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5874),
    [anon_sym_LT_AT] = ACTIONS(5874),
    [anon_sym_LT_AT_AT] = ACTIONS(5872),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5872),
    [anon_sym_new] = ACTIONS(5874),
    [anon_sym_return_BANG] = ACTIONS(5872),
    [anon_sym_yield] = ACTIONS(5874),
    [anon_sym_yield_BANG] = ACTIONS(5872),
    [anon_sym_lazy] = ACTIONS(5874),
    [anon_sym_assert] = ACTIONS(5874),
    [anon_sym_upcast] = ACTIONS(5874),
    [anon_sym_downcast] = ACTIONS(5874),
    [anon_sym_for] = ACTIONS(5874),
    [anon_sym_while] = ACTIONS(5874),
    [anon_sym_if] = ACTIONS(5874),
    [anon_sym_fun] = ACTIONS(5874),
    [anon_sym_try] = ACTIONS(5874),
    [anon_sym_match] = ACTIONS(5874),
    [anon_sym_match_BANG] = ACTIONS(5872),
    [anon_sym_function] = ACTIONS(5874),
    [anon_sym_use] = ACTIONS(5874),
    [anon_sym_use_BANG] = ACTIONS(5872),
    [anon_sym_do_BANG] = ACTIONS(5872),
    [anon_sym_begin] = ACTIONS(5874),
    [aux_sym_char_token1] = ACTIONS(5872),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5874),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_AT_DQUOTE] = ACTIONS(5872),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5872),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5872),
    [sym_bool] = ACTIONS(5874),
    [sym_unit] = ACTIONS(5872),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5874),
    [sym_op_identifier] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_PLUS_DOT] = ACTIONS(5872),
    [anon_sym_DASH_DOT] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_AMP_AMP] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5872),
    [aux_sym_prefix_op_token1] = ACTIONS(5872),
    [sym_int] = ACTIONS(5874),
    [sym_xint] = ACTIONS(5872),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5872),
    [anon_sym_POUNDload] = ACTIONS(5872),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5872),
  },
  [3362] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7999),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3362),
    [sym_block_comment] = STATE(3362),
    [sym_line_comment] = STATE(3362),
    [sym_compiler_directive_decl] = STATE(3362),
    [sym_fsi_directive_decl] = STATE(3362),
    [sym_preproc_line] = STATE(3362),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3363] = {
    [sym_xml_doc] = STATE(3363),
    [sym_block_comment] = STATE(3363),
    [sym_line_comment] = STATE(3363),
    [sym_compiler_directive_decl] = STATE(3363),
    [sym_fsi_directive_decl] = STATE(3363),
    [sym_preproc_line] = STATE(3363),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
  },
  [3364] = {
    [sym_xml_doc] = STATE(3364),
    [sym_block_comment] = STATE(3364),
    [sym_line_comment] = STATE(3364),
    [sym_compiler_directive_decl] = STATE(3364),
    [sym_fsi_directive_decl] = STATE(3364),
    [sym_preproc_line] = STATE(3364),
    [sym_identifier] = ACTIONS(5745),
    [anon_sym_module] = ACTIONS(5745),
    [anon_sym_open] = ACTIONS(5745),
    [anon_sym_LBRACK_LT] = ACTIONS(5743),
    [anon_sym_return] = ACTIONS(5745),
    [anon_sym_type] = ACTIONS(5745),
    [anon_sym_do] = ACTIONS(5745),
    [anon_sym_and] = ACTIONS(5745),
    [anon_sym_let] = ACTIONS(5745),
    [anon_sym_let_BANG] = ACTIONS(5743),
    [anon_sym_LPAREN] = ACTIONS(5745),
    [anon_sym_null] = ACTIONS(5745),
    [anon_sym_AMP] = ACTIONS(5745),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_LT_AT] = ACTIONS(5745),
    [anon_sym_LT_AT_AT] = ACTIONS(5743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5743),
    [anon_sym_new] = ACTIONS(5745),
    [anon_sym_return_BANG] = ACTIONS(5743),
    [anon_sym_yield] = ACTIONS(5745),
    [anon_sym_yield_BANG] = ACTIONS(5743),
    [anon_sym_lazy] = ACTIONS(5745),
    [anon_sym_assert] = ACTIONS(5745),
    [anon_sym_upcast] = ACTIONS(5745),
    [anon_sym_downcast] = ACTIONS(5745),
    [anon_sym_for] = ACTIONS(5745),
    [anon_sym_while] = ACTIONS(5745),
    [anon_sym_if] = ACTIONS(5745),
    [anon_sym_fun] = ACTIONS(5745),
    [anon_sym_try] = ACTIONS(5745),
    [anon_sym_match] = ACTIONS(5745),
    [anon_sym_match_BANG] = ACTIONS(5743),
    [anon_sym_function] = ACTIONS(5745),
    [anon_sym_use] = ACTIONS(5745),
    [anon_sym_use_BANG] = ACTIONS(5743),
    [anon_sym_do_BANG] = ACTIONS(5743),
    [anon_sym_begin] = ACTIONS(5745),
    [aux_sym_char_token1] = ACTIONS(5743),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5745),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5743),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5743),
    [sym_bool] = ACTIONS(5745),
    [sym_unit] = ACTIONS(5743),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5745),
    [sym_op_identifier] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_DOT] = ACTIONS(5743),
    [anon_sym_DASH_DOT] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_AMP_AMP] = ACTIONS(5743),
    [anon_sym_TILDE] = ACTIONS(5743),
    [aux_sym_prefix_op_token1] = ACTIONS(5743),
    [sym_int] = ACTIONS(5745),
    [sym_xint] = ACTIONS(5743),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5743),
    [anon_sym_POUNDload] = ACTIONS(5743),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5743),
    [sym__dedent] = ACTIONS(5743),
  },
  [3365] = {
    [sym_xml_doc] = STATE(3365),
    [sym_block_comment] = STATE(3365),
    [sym_line_comment] = STATE(3365),
    [sym_compiler_directive_decl] = STATE(3365),
    [sym_fsi_directive_decl] = STATE(3365),
    [sym_preproc_line] = STATE(3365),
    [ts_builtin_sym_end] = ACTIONS(5878),
    [sym_identifier] = ACTIONS(5880),
    [anon_sym_namespace] = ACTIONS(5880),
    [anon_sym_module] = ACTIONS(5880),
    [anon_sym_open] = ACTIONS(5880),
    [anon_sym_LBRACK_LT] = ACTIONS(5878),
    [anon_sym_return] = ACTIONS(5880),
    [anon_sym_type] = ACTIONS(5880),
    [anon_sym_do] = ACTIONS(5880),
    [anon_sym_let] = ACTIONS(5880),
    [anon_sym_let_BANG] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5880),
    [anon_sym_null] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5880),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5878),
    [anon_sym_LBRACE] = ACTIONS(5880),
    [anon_sym_LT_AT] = ACTIONS(5880),
    [anon_sym_LT_AT_AT] = ACTIONS(5878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5878),
    [anon_sym_new] = ACTIONS(5880),
    [anon_sym_return_BANG] = ACTIONS(5878),
    [anon_sym_yield] = ACTIONS(5880),
    [anon_sym_yield_BANG] = ACTIONS(5878),
    [anon_sym_lazy] = ACTIONS(5880),
    [anon_sym_assert] = ACTIONS(5880),
    [anon_sym_upcast] = ACTIONS(5880),
    [anon_sym_downcast] = ACTIONS(5880),
    [anon_sym_for] = ACTIONS(5880),
    [anon_sym_while] = ACTIONS(5880),
    [anon_sym_if] = ACTIONS(5880),
    [anon_sym_fun] = ACTIONS(5880),
    [anon_sym_try] = ACTIONS(5880),
    [anon_sym_match] = ACTIONS(5880),
    [anon_sym_match_BANG] = ACTIONS(5878),
    [anon_sym_function] = ACTIONS(5880),
    [anon_sym_use] = ACTIONS(5880),
    [anon_sym_use_BANG] = ACTIONS(5878),
    [anon_sym_do_BANG] = ACTIONS(5878),
    [anon_sym_begin] = ACTIONS(5880),
    [aux_sym_char_token1] = ACTIONS(5878),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5880),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_AT_DQUOTE] = ACTIONS(5878),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5878),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5878),
    [sym_bool] = ACTIONS(5880),
    [sym_unit] = ACTIONS(5878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5880),
    [sym_op_identifier] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_PLUS_DOT] = ACTIONS(5878),
    [anon_sym_DASH_DOT] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5878),
    [anon_sym_TILDE] = ACTIONS(5878),
    [aux_sym_prefix_op_token1] = ACTIONS(5878),
    [sym_int] = ACTIONS(5880),
    [sym_xint] = ACTIONS(5878),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5878),
    [anon_sym_POUNDload] = ACTIONS(5878),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5878),
  },
  [3366] = {
    [sym_xml_doc] = STATE(3366),
    [sym_block_comment] = STATE(3366),
    [sym_line_comment] = STATE(3366),
    [sym_compiler_directive_decl] = STATE(3366),
    [sym_fsi_directive_decl] = STATE(3366),
    [sym_preproc_line] = STATE(3366),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
    [sym__dedent] = ACTIONS(3287),
  },
  [3367] = {
    [sym_xml_doc] = STATE(3367),
    [sym_block_comment] = STATE(3367),
    [sym_line_comment] = STATE(3367),
    [sym_compiler_directive_decl] = STATE(3367),
    [sym_fsi_directive_decl] = STATE(3367),
    [sym_preproc_line] = STATE(3367),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_GT_RBRACK] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3338),
    [anon_sym_DASH_DOT] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3338),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__newline] = ACTIONS(3338),
  },
  [3368] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7613),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3368),
    [sym_block_comment] = STATE(3368),
    [sym_line_comment] = STATE(3368),
    [sym_compiler_directive_decl] = STATE(3368),
    [sym_fsi_directive_decl] = STATE(3368),
    [sym_preproc_line] = STATE(3368),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5882),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3369] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7663),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3369),
    [sym_block_comment] = STATE(3369),
    [sym_line_comment] = STATE(3369),
    [sym_compiler_directive_decl] = STATE(3369),
    [sym_fsi_directive_decl] = STATE(3369),
    [sym_preproc_line] = STATE(3369),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3370] = {
    [sym_xml_doc] = STATE(3370),
    [sym_block_comment] = STATE(3370),
    [sym_line_comment] = STATE(3370),
    [sym_compiler_directive_decl] = STATE(3370),
    [sym_fsi_directive_decl] = STATE(3370),
    [sym_preproc_line] = STATE(3370),
    [ts_builtin_sym_end] = ACTIONS(5886),
    [sym_identifier] = ACTIONS(5888),
    [anon_sym_namespace] = ACTIONS(5888),
    [anon_sym_module] = ACTIONS(5888),
    [anon_sym_open] = ACTIONS(5888),
    [anon_sym_LBRACK_LT] = ACTIONS(5886),
    [anon_sym_return] = ACTIONS(5888),
    [anon_sym_type] = ACTIONS(5888),
    [anon_sym_do] = ACTIONS(5888),
    [anon_sym_let] = ACTIONS(5888),
    [anon_sym_let_BANG] = ACTIONS(5886),
    [anon_sym_LPAREN] = ACTIONS(5888),
    [anon_sym_null] = ACTIONS(5888),
    [anon_sym_AMP] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5886),
    [anon_sym_LBRACE] = ACTIONS(5888),
    [anon_sym_LT_AT] = ACTIONS(5888),
    [anon_sym_LT_AT_AT] = ACTIONS(5886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5886),
    [anon_sym_new] = ACTIONS(5888),
    [anon_sym_return_BANG] = ACTIONS(5886),
    [anon_sym_yield] = ACTIONS(5888),
    [anon_sym_yield_BANG] = ACTIONS(5886),
    [anon_sym_lazy] = ACTIONS(5888),
    [anon_sym_assert] = ACTIONS(5888),
    [anon_sym_upcast] = ACTIONS(5888),
    [anon_sym_downcast] = ACTIONS(5888),
    [anon_sym_for] = ACTIONS(5888),
    [anon_sym_while] = ACTIONS(5888),
    [anon_sym_if] = ACTIONS(5888),
    [anon_sym_fun] = ACTIONS(5888),
    [anon_sym_try] = ACTIONS(5888),
    [anon_sym_match] = ACTIONS(5888),
    [anon_sym_match_BANG] = ACTIONS(5886),
    [anon_sym_function] = ACTIONS(5888),
    [anon_sym_use] = ACTIONS(5888),
    [anon_sym_use_BANG] = ACTIONS(5886),
    [anon_sym_do_BANG] = ACTIONS(5886),
    [anon_sym_begin] = ACTIONS(5888),
    [aux_sym_char_token1] = ACTIONS(5886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5888),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_AT_DQUOTE] = ACTIONS(5886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5886),
    [sym_bool] = ACTIONS(5888),
    [sym_unit] = ACTIONS(5886),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5888),
    [sym_op_identifier] = ACTIONS(5886),
    [anon_sym_PLUS] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_PLUS_DOT] = ACTIONS(5886),
    [anon_sym_DASH_DOT] = ACTIONS(5886),
    [anon_sym_PERCENT] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5886),
    [aux_sym_prefix_op_token1] = ACTIONS(5886),
    [sym_int] = ACTIONS(5888),
    [sym_xint] = ACTIONS(5886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5886),
    [anon_sym_POUNDload] = ACTIONS(5886),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5886),
  },
  [3371] = {
    [sym_xml_doc] = STATE(3371),
    [sym_block_comment] = STATE(3371),
    [sym_line_comment] = STATE(3371),
    [sym_compiler_directive_decl] = STATE(3371),
    [sym_fsi_directive_decl] = STATE(3371),
    [sym_preproc_line] = STATE(3371),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_module] = ACTIONS(5707),
    [anon_sym_open] = ACTIONS(5707),
    [anon_sym_LBRACK_LT] = ACTIONS(5705),
    [anon_sym_return] = ACTIONS(5707),
    [anon_sym_type] = ACTIONS(5707),
    [anon_sym_do] = ACTIONS(5707),
    [anon_sym_and] = ACTIONS(5707),
    [anon_sym_let] = ACTIONS(5707),
    [anon_sym_let_BANG] = ACTIONS(5705),
    [anon_sym_LPAREN] = ACTIONS(5707),
    [anon_sym_null] = ACTIONS(5707),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5705),
    [anon_sym_LBRACE] = ACTIONS(5707),
    [anon_sym_LT_AT] = ACTIONS(5707),
    [anon_sym_LT_AT_AT] = ACTIONS(5705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5705),
    [anon_sym_new] = ACTIONS(5707),
    [anon_sym_return_BANG] = ACTIONS(5705),
    [anon_sym_yield] = ACTIONS(5707),
    [anon_sym_yield_BANG] = ACTIONS(5705),
    [anon_sym_lazy] = ACTIONS(5707),
    [anon_sym_assert] = ACTIONS(5707),
    [anon_sym_upcast] = ACTIONS(5707),
    [anon_sym_downcast] = ACTIONS(5707),
    [anon_sym_for] = ACTIONS(5707),
    [anon_sym_while] = ACTIONS(5707),
    [anon_sym_if] = ACTIONS(5707),
    [anon_sym_fun] = ACTIONS(5707),
    [anon_sym_try] = ACTIONS(5707),
    [anon_sym_match] = ACTIONS(5707),
    [anon_sym_match_BANG] = ACTIONS(5705),
    [anon_sym_function] = ACTIONS(5707),
    [anon_sym_use] = ACTIONS(5707),
    [anon_sym_use_BANG] = ACTIONS(5705),
    [anon_sym_do_BANG] = ACTIONS(5705),
    [anon_sym_begin] = ACTIONS(5707),
    [aux_sym_char_token1] = ACTIONS(5705),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5707),
    [anon_sym_DQUOTE] = ACTIONS(5707),
    [anon_sym_AT_DQUOTE] = ACTIONS(5705),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5705),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5705),
    [sym_bool] = ACTIONS(5707),
    [sym_unit] = ACTIONS(5705),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5707),
    [sym_op_identifier] = ACTIONS(5705),
    [anon_sym_PLUS] = ACTIONS(5707),
    [anon_sym_DASH] = ACTIONS(5707),
    [anon_sym_PLUS_DOT] = ACTIONS(5705),
    [anon_sym_DASH_DOT] = ACTIONS(5705),
    [anon_sym_PERCENT] = ACTIONS(5705),
    [anon_sym_AMP_AMP] = ACTIONS(5705),
    [anon_sym_TILDE] = ACTIONS(5705),
    [aux_sym_prefix_op_token1] = ACTIONS(5705),
    [sym_int] = ACTIONS(5707),
    [sym_xint] = ACTIONS(5705),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5705),
    [anon_sym_POUNDload] = ACTIONS(5705),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5705),
    [sym__dedent] = ACTIONS(5705),
  },
  [3372] = {
    [sym_xml_doc] = STATE(3372),
    [sym_block_comment] = STATE(3372),
    [sym_line_comment] = STATE(3372),
    [sym_compiler_directive_decl] = STATE(3372),
    [sym_fsi_directive_decl] = STATE(3372),
    [sym_preproc_line] = STATE(3372),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_GT_RBRACK] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3342),
    [anon_sym_DASH_DOT] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3342),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__newline] = ACTIONS(3342),
  },
  [3373] = {
    [sym_xml_doc] = STATE(3373),
    [sym_block_comment] = STATE(3373),
    [sym_line_comment] = STATE(3373),
    [sym_compiler_directive_decl] = STATE(3373),
    [sym_fsi_directive_decl] = STATE(3373),
    [sym_preproc_line] = STATE(3373),
    [sym_identifier] = ACTIONS(5741),
    [anon_sym_module] = ACTIONS(5741),
    [anon_sym_open] = ACTIONS(5741),
    [anon_sym_LBRACK_LT] = ACTIONS(5739),
    [anon_sym_return] = ACTIONS(5741),
    [anon_sym_type] = ACTIONS(5741),
    [anon_sym_do] = ACTIONS(5741),
    [anon_sym_and] = ACTIONS(5741),
    [anon_sym_let] = ACTIONS(5741),
    [anon_sym_let_BANG] = ACTIONS(5739),
    [anon_sym_LPAREN] = ACTIONS(5741),
    [anon_sym_null] = ACTIONS(5741),
    [anon_sym_AMP] = ACTIONS(5741),
    [anon_sym_LBRACK] = ACTIONS(5741),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5739),
    [anon_sym_LBRACE] = ACTIONS(5741),
    [anon_sym_LT_AT] = ACTIONS(5741),
    [anon_sym_LT_AT_AT] = ACTIONS(5739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5739),
    [anon_sym_new] = ACTIONS(5741),
    [anon_sym_return_BANG] = ACTIONS(5739),
    [anon_sym_yield] = ACTIONS(5741),
    [anon_sym_yield_BANG] = ACTIONS(5739),
    [anon_sym_lazy] = ACTIONS(5741),
    [anon_sym_assert] = ACTIONS(5741),
    [anon_sym_upcast] = ACTIONS(5741),
    [anon_sym_downcast] = ACTIONS(5741),
    [anon_sym_for] = ACTIONS(5741),
    [anon_sym_while] = ACTIONS(5741),
    [anon_sym_if] = ACTIONS(5741),
    [anon_sym_fun] = ACTIONS(5741),
    [anon_sym_try] = ACTIONS(5741),
    [anon_sym_match] = ACTIONS(5741),
    [anon_sym_match_BANG] = ACTIONS(5739),
    [anon_sym_function] = ACTIONS(5741),
    [anon_sym_use] = ACTIONS(5741),
    [anon_sym_use_BANG] = ACTIONS(5739),
    [anon_sym_do_BANG] = ACTIONS(5739),
    [anon_sym_begin] = ACTIONS(5741),
    [aux_sym_char_token1] = ACTIONS(5739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5741),
    [anon_sym_DQUOTE] = ACTIONS(5741),
    [anon_sym_AT_DQUOTE] = ACTIONS(5739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5739),
    [sym_bool] = ACTIONS(5741),
    [sym_unit] = ACTIONS(5739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5741),
    [sym_op_identifier] = ACTIONS(5739),
    [anon_sym_PLUS] = ACTIONS(5741),
    [anon_sym_DASH] = ACTIONS(5741),
    [anon_sym_PLUS_DOT] = ACTIONS(5739),
    [anon_sym_DASH_DOT] = ACTIONS(5739),
    [anon_sym_PERCENT] = ACTIONS(5739),
    [anon_sym_AMP_AMP] = ACTIONS(5739),
    [anon_sym_TILDE] = ACTIONS(5739),
    [aux_sym_prefix_op_token1] = ACTIONS(5739),
    [sym_int] = ACTIONS(5741),
    [sym_xint] = ACTIONS(5739),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5739),
    [anon_sym_POUNDload] = ACTIONS(5739),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5739),
    [sym__dedent] = ACTIONS(5739),
  },
  [3374] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7200),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3374),
    [sym_block_comment] = STATE(3374),
    [sym_line_comment] = STATE(3374),
    [sym_compiler_directive_decl] = STATE(3374),
    [sym_fsi_directive_decl] = STATE(3374),
    [sym_preproc_line] = STATE(3374),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3375] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7476),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3375),
    [sym_block_comment] = STATE(3375),
    [sym_line_comment] = STATE(3375),
    [sym_compiler_directive_decl] = STATE(3375),
    [sym_fsi_directive_decl] = STATE(3375),
    [sym_preproc_line] = STATE(3375),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3376] = {
    [sym_xml_doc] = STATE(3376),
    [sym_block_comment] = STATE(3376),
    [sym_line_comment] = STATE(3376),
    [sym_compiler_directive_decl] = STATE(3376),
    [sym_fsi_directive_decl] = STATE(3376),
    [sym_preproc_line] = STATE(3376),
    [sym_identifier] = ACTIONS(5682),
    [anon_sym_module] = ACTIONS(5682),
    [anon_sym_open] = ACTIONS(5682),
    [anon_sym_LBRACK_LT] = ACTIONS(5680),
    [anon_sym_return] = ACTIONS(5682),
    [anon_sym_type] = ACTIONS(5682),
    [anon_sym_do] = ACTIONS(5682),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_let] = ACTIONS(5682),
    [anon_sym_let_BANG] = ACTIONS(5680),
    [anon_sym_LPAREN] = ACTIONS(5682),
    [anon_sym_null] = ACTIONS(5682),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5680),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_LT_AT] = ACTIONS(5682),
    [anon_sym_LT_AT_AT] = ACTIONS(5680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5680),
    [anon_sym_new] = ACTIONS(5682),
    [anon_sym_return_BANG] = ACTIONS(5680),
    [anon_sym_yield] = ACTIONS(5682),
    [anon_sym_yield_BANG] = ACTIONS(5680),
    [anon_sym_lazy] = ACTIONS(5682),
    [anon_sym_assert] = ACTIONS(5682),
    [anon_sym_upcast] = ACTIONS(5682),
    [anon_sym_downcast] = ACTIONS(5682),
    [anon_sym_for] = ACTIONS(5682),
    [anon_sym_while] = ACTIONS(5682),
    [anon_sym_if] = ACTIONS(5682),
    [anon_sym_fun] = ACTIONS(5682),
    [anon_sym_try] = ACTIONS(5682),
    [anon_sym_match] = ACTIONS(5682),
    [anon_sym_match_BANG] = ACTIONS(5680),
    [anon_sym_function] = ACTIONS(5682),
    [anon_sym_use] = ACTIONS(5682),
    [anon_sym_use_BANG] = ACTIONS(5680),
    [anon_sym_do_BANG] = ACTIONS(5680),
    [anon_sym_begin] = ACTIONS(5682),
    [aux_sym_char_token1] = ACTIONS(5680),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5682),
    [anon_sym_DQUOTE] = ACTIONS(5682),
    [anon_sym_AT_DQUOTE] = ACTIONS(5680),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5680),
    [sym_bool] = ACTIONS(5682),
    [sym_unit] = ACTIONS(5680),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5682),
    [sym_op_identifier] = ACTIONS(5680),
    [anon_sym_PLUS] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_DOT] = ACTIONS(5680),
    [anon_sym_DASH_DOT] = ACTIONS(5680),
    [anon_sym_PERCENT] = ACTIONS(5680),
    [anon_sym_AMP_AMP] = ACTIONS(5680),
    [anon_sym_TILDE] = ACTIONS(5680),
    [aux_sym_prefix_op_token1] = ACTIONS(5680),
    [sym_int] = ACTIONS(5682),
    [sym_xint] = ACTIONS(5680),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5680),
    [anon_sym_POUNDload] = ACTIONS(5680),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5680),
    [sym__dedent] = ACTIONS(5680),
  },
  [3377] = {
    [sym_xml_doc] = STATE(3377),
    [sym_block_comment] = STATE(3377),
    [sym_line_comment] = STATE(3377),
    [sym_compiler_directive_decl] = STATE(3377),
    [sym_fsi_directive_decl] = STATE(3377),
    [sym_preproc_line] = STATE(3377),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_as] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3306),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3306),
    [anon_sym_DASH_DOT] = ACTIONS(3306),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3306),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
  },
  [3378] = {
    [sym_xml_doc] = STATE(3378),
    [sym_block_comment] = STATE(3378),
    [sym_line_comment] = STATE(3378),
    [sym_compiler_directive_decl] = STATE(3378),
    [sym_fsi_directive_decl] = STATE(3378),
    [sym_preproc_line] = STATE(3378),
    [sym_identifier] = ACTIONS(5778),
    [anon_sym_module] = ACTIONS(5778),
    [anon_sym_open] = ACTIONS(5778),
    [anon_sym_LBRACK_LT] = ACTIONS(5776),
    [anon_sym_return] = ACTIONS(5778),
    [anon_sym_type] = ACTIONS(5778),
    [anon_sym_do] = ACTIONS(5778),
    [anon_sym_and] = ACTIONS(5778),
    [anon_sym_let] = ACTIONS(5778),
    [anon_sym_let_BANG] = ACTIONS(5776),
    [anon_sym_LPAREN] = ACTIONS(5778),
    [anon_sym_null] = ACTIONS(5778),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5776),
    [anon_sym_LBRACE] = ACTIONS(5778),
    [anon_sym_LT_AT] = ACTIONS(5778),
    [anon_sym_LT_AT_AT] = ACTIONS(5776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5776),
    [anon_sym_new] = ACTIONS(5778),
    [anon_sym_return_BANG] = ACTIONS(5776),
    [anon_sym_yield] = ACTIONS(5778),
    [anon_sym_yield_BANG] = ACTIONS(5776),
    [anon_sym_lazy] = ACTIONS(5778),
    [anon_sym_assert] = ACTIONS(5778),
    [anon_sym_upcast] = ACTIONS(5778),
    [anon_sym_downcast] = ACTIONS(5778),
    [anon_sym_for] = ACTIONS(5778),
    [anon_sym_while] = ACTIONS(5778),
    [anon_sym_if] = ACTIONS(5778),
    [anon_sym_fun] = ACTIONS(5778),
    [anon_sym_try] = ACTIONS(5778),
    [anon_sym_match] = ACTIONS(5778),
    [anon_sym_match_BANG] = ACTIONS(5776),
    [anon_sym_function] = ACTIONS(5778),
    [anon_sym_use] = ACTIONS(5778),
    [anon_sym_use_BANG] = ACTIONS(5776),
    [anon_sym_do_BANG] = ACTIONS(5776),
    [anon_sym_begin] = ACTIONS(5778),
    [aux_sym_char_token1] = ACTIONS(5776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5778),
    [anon_sym_DQUOTE] = ACTIONS(5778),
    [anon_sym_AT_DQUOTE] = ACTIONS(5776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5776),
    [sym_bool] = ACTIONS(5778),
    [sym_unit] = ACTIONS(5776),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5778),
    [sym_op_identifier] = ACTIONS(5776),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS_DOT] = ACTIONS(5776),
    [anon_sym_DASH_DOT] = ACTIONS(5776),
    [anon_sym_PERCENT] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_TILDE] = ACTIONS(5776),
    [aux_sym_prefix_op_token1] = ACTIONS(5776),
    [sym_int] = ACTIONS(5778),
    [sym_xint] = ACTIONS(5776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5776),
    [anon_sym_POUNDload] = ACTIONS(5776),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5776),
    [sym__dedent] = ACTIONS(5776),
  },
  [3379] = {
    [sym_xml_doc] = STATE(3379),
    [sym_block_comment] = STATE(3379),
    [sym_line_comment] = STATE(3379),
    [sym_compiler_directive_decl] = STATE(3379),
    [sym_fsi_directive_decl] = STATE(3379),
    [sym_preproc_line] = STATE(3379),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_as] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3302),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3302),
    [anon_sym_DASH_DOT] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3302),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
  },
  [3380] = {
    [sym_xml_doc] = STATE(3380),
    [sym_block_comment] = STATE(3380),
    [sym_line_comment] = STATE(3380),
    [sym_compiler_directive_decl] = STATE(3380),
    [sym_fsi_directive_decl] = STATE(3380),
    [sym_preproc_line] = STATE(3380),
    [sym_identifier] = ACTIONS(5703),
    [anon_sym_module] = ACTIONS(5703),
    [anon_sym_open] = ACTIONS(5703),
    [anon_sym_LBRACK_LT] = ACTIONS(5701),
    [anon_sym_return] = ACTIONS(5703),
    [anon_sym_type] = ACTIONS(5703),
    [anon_sym_do] = ACTIONS(5703),
    [anon_sym_and] = ACTIONS(5703),
    [anon_sym_let] = ACTIONS(5703),
    [anon_sym_let_BANG] = ACTIONS(5701),
    [anon_sym_LPAREN] = ACTIONS(5703),
    [anon_sym_null] = ACTIONS(5703),
    [anon_sym_AMP] = ACTIONS(5703),
    [anon_sym_LBRACK] = ACTIONS(5703),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5701),
    [anon_sym_LBRACE] = ACTIONS(5703),
    [anon_sym_LT_AT] = ACTIONS(5703),
    [anon_sym_LT_AT_AT] = ACTIONS(5701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5701),
    [anon_sym_new] = ACTIONS(5703),
    [anon_sym_return_BANG] = ACTIONS(5701),
    [anon_sym_yield] = ACTIONS(5703),
    [anon_sym_yield_BANG] = ACTIONS(5701),
    [anon_sym_lazy] = ACTIONS(5703),
    [anon_sym_assert] = ACTIONS(5703),
    [anon_sym_upcast] = ACTIONS(5703),
    [anon_sym_downcast] = ACTIONS(5703),
    [anon_sym_for] = ACTIONS(5703),
    [anon_sym_while] = ACTIONS(5703),
    [anon_sym_if] = ACTIONS(5703),
    [anon_sym_fun] = ACTIONS(5703),
    [anon_sym_try] = ACTIONS(5703),
    [anon_sym_match] = ACTIONS(5703),
    [anon_sym_match_BANG] = ACTIONS(5701),
    [anon_sym_function] = ACTIONS(5703),
    [anon_sym_use] = ACTIONS(5703),
    [anon_sym_use_BANG] = ACTIONS(5701),
    [anon_sym_do_BANG] = ACTIONS(5701),
    [anon_sym_begin] = ACTIONS(5703),
    [aux_sym_char_token1] = ACTIONS(5701),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5703),
    [anon_sym_DQUOTE] = ACTIONS(5703),
    [anon_sym_AT_DQUOTE] = ACTIONS(5701),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5701),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5701),
    [sym_bool] = ACTIONS(5703),
    [sym_unit] = ACTIONS(5701),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5703),
    [sym_op_identifier] = ACTIONS(5701),
    [anon_sym_PLUS] = ACTIONS(5703),
    [anon_sym_DASH] = ACTIONS(5703),
    [anon_sym_PLUS_DOT] = ACTIONS(5701),
    [anon_sym_DASH_DOT] = ACTIONS(5701),
    [anon_sym_PERCENT] = ACTIONS(5701),
    [anon_sym_AMP_AMP] = ACTIONS(5701),
    [anon_sym_TILDE] = ACTIONS(5701),
    [aux_sym_prefix_op_token1] = ACTIONS(5701),
    [sym_int] = ACTIONS(5703),
    [sym_xint] = ACTIONS(5701),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5701),
    [anon_sym_POUNDload] = ACTIONS(5701),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5701),
    [sym__dedent] = ACTIONS(5701),
  },
  [3381] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7314),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3381),
    [sym_block_comment] = STATE(3381),
    [sym_line_comment] = STATE(3381),
    [sym_compiler_directive_decl] = STATE(3381),
    [sym_fsi_directive_decl] = STATE(3381),
    [sym_preproc_line] = STATE(3381),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5894),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3382] = {
    [sym_xml_doc] = STATE(3382),
    [sym_block_comment] = STATE(3382),
    [sym_line_comment] = STATE(3382),
    [sym_compiler_directive_decl] = STATE(3382),
    [sym_fsi_directive_decl] = STATE(3382),
    [sym_preproc_line] = STATE(3382),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_as] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3324),
    [anon_sym_DASH_DOT] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3324),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
  },
  [3383] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7632),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3383),
    [sym_block_comment] = STATE(3383),
    [sym_line_comment] = STATE(3383),
    [sym_compiler_directive_decl] = STATE(3383),
    [sym_fsi_directive_decl] = STATE(3383),
    [sym_preproc_line] = STATE(3383),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3384] = {
    [sym_xml_doc] = STATE(3384),
    [sym_block_comment] = STATE(3384),
    [sym_line_comment] = STATE(3384),
    [sym_compiler_directive_decl] = STATE(3384),
    [sym_fsi_directive_decl] = STATE(3384),
    [sym_preproc_line] = STATE(3384),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_as] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LT2] = ACTIONS(5898),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3357),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3357),
    [anon_sym_DASH_DOT] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3357),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
  },
  [3385] = {
    [sym_xml_doc] = STATE(3385),
    [sym_block_comment] = STATE(3385),
    [sym_line_comment] = STATE(3385),
    [sym_compiler_directive_decl] = STATE(3385),
    [sym_fsi_directive_decl] = STATE(3385),
    [sym_preproc_line] = STATE(3385),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_GT_RBRACK] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3320),
    [anon_sym_DASH_DOT] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3320),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__newline] = ACTIONS(3320),
  },
  [3386] = {
    [sym_xml_doc] = STATE(3386),
    [sym_block_comment] = STATE(3386),
    [sym_line_comment] = STATE(3386),
    [sym_compiler_directive_decl] = STATE(3386),
    [sym_fsi_directive_decl] = STATE(3386),
    [sym_preproc_line] = STATE(3386),
    [aux_sym_long_identifier_repeat1] = STATE(3386),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(5900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [3387] = {
    [sym_xml_doc] = STATE(3387),
    [sym_block_comment] = STATE(3387),
    [sym_line_comment] = STATE(3387),
    [sym_compiler_directive_decl] = STATE(3387),
    [sym_fsi_directive_decl] = STATE(3387),
    [sym_preproc_line] = STATE(3387),
    [ts_builtin_sym_end] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_namespace] = ACTIONS(5905),
    [anon_sym_module] = ACTIONS(5905),
    [anon_sym_open] = ACTIONS(5905),
    [anon_sym_LBRACK_LT] = ACTIONS(5903),
    [anon_sym_return] = ACTIONS(5905),
    [anon_sym_type] = ACTIONS(5905),
    [anon_sym_do] = ACTIONS(5905),
    [anon_sym_let] = ACTIONS(5905),
    [anon_sym_let_BANG] = ACTIONS(5903),
    [anon_sym_LPAREN] = ACTIONS(5905),
    [anon_sym_null] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5905),
    [anon_sym_LBRACK] = ACTIONS(5905),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5905),
    [anon_sym_LT_AT] = ACTIONS(5905),
    [anon_sym_LT_AT_AT] = ACTIONS(5903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5903),
    [anon_sym_new] = ACTIONS(5905),
    [anon_sym_return_BANG] = ACTIONS(5903),
    [anon_sym_yield] = ACTIONS(5905),
    [anon_sym_yield_BANG] = ACTIONS(5903),
    [anon_sym_lazy] = ACTIONS(5905),
    [anon_sym_assert] = ACTIONS(5905),
    [anon_sym_upcast] = ACTIONS(5905),
    [anon_sym_downcast] = ACTIONS(5905),
    [anon_sym_for] = ACTIONS(5905),
    [anon_sym_while] = ACTIONS(5905),
    [anon_sym_if] = ACTIONS(5905),
    [anon_sym_fun] = ACTIONS(5905),
    [anon_sym_try] = ACTIONS(5905),
    [anon_sym_match] = ACTIONS(5905),
    [anon_sym_match_BANG] = ACTIONS(5903),
    [anon_sym_function] = ACTIONS(5905),
    [anon_sym_use] = ACTIONS(5905),
    [anon_sym_use_BANG] = ACTIONS(5903),
    [anon_sym_do_BANG] = ACTIONS(5903),
    [anon_sym_begin] = ACTIONS(5905),
    [aux_sym_char_token1] = ACTIONS(5903),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5905),
    [anon_sym_DQUOTE] = ACTIONS(5905),
    [anon_sym_AT_DQUOTE] = ACTIONS(5903),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5903),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5903),
    [sym_bool] = ACTIONS(5905),
    [sym_unit] = ACTIONS(5903),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5905),
    [sym_op_identifier] = ACTIONS(5903),
    [anon_sym_PLUS] = ACTIONS(5905),
    [anon_sym_DASH] = ACTIONS(5905),
    [anon_sym_PLUS_DOT] = ACTIONS(5903),
    [anon_sym_DASH_DOT] = ACTIONS(5903),
    [anon_sym_PERCENT] = ACTIONS(5903),
    [anon_sym_AMP_AMP] = ACTIONS(5903),
    [anon_sym_TILDE] = ACTIONS(5903),
    [aux_sym_prefix_op_token1] = ACTIONS(5903),
    [sym_int] = ACTIONS(5905),
    [sym_xint] = ACTIONS(5903),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5903),
    [anon_sym_POUNDload] = ACTIONS(5903),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5903),
  },
  [3388] = {
    [sym_xml_doc] = STATE(3388),
    [sym_block_comment] = STATE(3388),
    [sym_line_comment] = STATE(3388),
    [sym_compiler_directive_decl] = STATE(3388),
    [sym_fsi_directive_decl] = STATE(3388),
    [sym_preproc_line] = STATE(3388),
    [sym_identifier] = ACTIONS(5713),
    [anon_sym_module] = ACTIONS(5713),
    [anon_sym_open] = ACTIONS(5713),
    [anon_sym_LBRACK_LT] = ACTIONS(5711),
    [anon_sym_return] = ACTIONS(5713),
    [anon_sym_type] = ACTIONS(5713),
    [anon_sym_do] = ACTIONS(5713),
    [anon_sym_and] = ACTIONS(5713),
    [anon_sym_let] = ACTIONS(5713),
    [anon_sym_let_BANG] = ACTIONS(5711),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_null] = ACTIONS(5713),
    [anon_sym_AMP] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5711),
    [anon_sym_LBRACE] = ACTIONS(5713),
    [anon_sym_LT_AT] = ACTIONS(5713),
    [anon_sym_LT_AT_AT] = ACTIONS(5711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5711),
    [anon_sym_new] = ACTIONS(5713),
    [anon_sym_return_BANG] = ACTIONS(5711),
    [anon_sym_yield] = ACTIONS(5713),
    [anon_sym_yield_BANG] = ACTIONS(5711),
    [anon_sym_lazy] = ACTIONS(5713),
    [anon_sym_assert] = ACTIONS(5713),
    [anon_sym_upcast] = ACTIONS(5713),
    [anon_sym_downcast] = ACTIONS(5713),
    [anon_sym_for] = ACTIONS(5713),
    [anon_sym_while] = ACTIONS(5713),
    [anon_sym_if] = ACTIONS(5713),
    [anon_sym_fun] = ACTIONS(5713),
    [anon_sym_try] = ACTIONS(5713),
    [anon_sym_match] = ACTIONS(5713),
    [anon_sym_match_BANG] = ACTIONS(5711),
    [anon_sym_function] = ACTIONS(5713),
    [anon_sym_use] = ACTIONS(5713),
    [anon_sym_use_BANG] = ACTIONS(5711),
    [anon_sym_do_BANG] = ACTIONS(5711),
    [anon_sym_begin] = ACTIONS(5713),
    [aux_sym_char_token1] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5713),
    [anon_sym_DQUOTE] = ACTIONS(5713),
    [anon_sym_AT_DQUOTE] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [sym_bool] = ACTIONS(5713),
    [sym_unit] = ACTIONS(5711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5713),
    [sym_op_identifier] = ACTIONS(5711),
    [anon_sym_PLUS] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_DOT] = ACTIONS(5711),
    [anon_sym_DASH_DOT] = ACTIONS(5711),
    [anon_sym_PERCENT] = ACTIONS(5711),
    [anon_sym_AMP_AMP] = ACTIONS(5711),
    [anon_sym_TILDE] = ACTIONS(5711),
    [aux_sym_prefix_op_token1] = ACTIONS(5711),
    [sym_int] = ACTIONS(5713),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5711),
    [anon_sym_POUNDload] = ACTIONS(5711),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5711),
    [sym__dedent] = ACTIONS(5711),
  },
  [3389] = {
    [sym_xml_doc] = STATE(3389),
    [sym_block_comment] = STATE(3389),
    [sym_line_comment] = STATE(3389),
    [sym_compiler_directive_decl] = STATE(3389),
    [sym_fsi_directive_decl] = STATE(3389),
    [sym_preproc_line] = STATE(3389),
    [ts_builtin_sym_end] = ACTIONS(2413),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_namespace] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_open] = ACTIONS(2415),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2415),
    [anon_sym_AMP] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_LT_AT] = ACTIONS(2415),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2415),
    [anon_sym_assert] = ACTIONS(2415),
    [anon_sym_upcast] = ACTIONS(2415),
    [anon_sym_downcast] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_fun] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_match] = ACTIONS(2415),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_use] = ACTIONS(2415),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2415),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2415),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2415),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2415),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2413),
    [anon_sym_POUNDload] = ACTIONS(2413),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2413),
  },
  [3390] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7860),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3390),
    [sym_block_comment] = STATE(3390),
    [sym_line_comment] = STATE(3390),
    [sym_compiler_directive_decl] = STATE(3390),
    [sym_fsi_directive_decl] = STATE(3390),
    [sym_preproc_line] = STATE(3390),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3391] = {
    [sym_xml_doc] = STATE(3391),
    [sym_block_comment] = STATE(3391),
    [sym_line_comment] = STATE(3391),
    [sym_compiler_directive_decl] = STATE(3391),
    [sym_fsi_directive_decl] = STATE(3391),
    [sym_preproc_line] = STATE(3391),
    [ts_builtin_sym_end] = ACTIONS(297),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_namespace] = ACTIONS(299),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_open] = ACTIONS(299),
    [anon_sym_LBRACK_LT] = ACTIONS(297),
    [anon_sym_return] = ACTIONS(299),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(299),
    [anon_sym_let] = ACTIONS(299),
    [anon_sym_let_BANG] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LBRACK_PIPE] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_LT_AT] = ACTIONS(299),
    [anon_sym_LT_AT_AT] = ACTIONS(297),
    [anon_sym_LBRACE_PIPE] = ACTIONS(297),
    [anon_sym_new] = ACTIONS(299),
    [anon_sym_return_BANG] = ACTIONS(297),
    [anon_sym_yield] = ACTIONS(299),
    [anon_sym_yield_BANG] = ACTIONS(297),
    [anon_sym_lazy] = ACTIONS(299),
    [anon_sym_assert] = ACTIONS(299),
    [anon_sym_upcast] = ACTIONS(299),
    [anon_sym_downcast] = ACTIONS(299),
    [anon_sym_for] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_fun] = ACTIONS(299),
    [anon_sym_try] = ACTIONS(299),
    [anon_sym_match] = ACTIONS(299),
    [anon_sym_match_BANG] = ACTIONS(297),
    [anon_sym_function] = ACTIONS(299),
    [anon_sym_use] = ACTIONS(299),
    [anon_sym_use_BANG] = ACTIONS(297),
    [anon_sym_do_BANG] = ACTIONS(297),
    [anon_sym_begin] = ACTIONS(299),
    [aux_sym_char_token1] = ACTIONS(297),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [anon_sym_AT_DQUOTE] = ACTIONS(297),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(297),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(297),
    [sym_bool] = ACTIONS(299),
    [sym_unit] = ACTIONS(297),
    [anon_sym_LPAREN_PIPE] = ACTIONS(299),
    [sym_op_identifier] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(299),
    [anon_sym_DASH] = ACTIONS(299),
    [anon_sym_PLUS_DOT] = ACTIONS(297),
    [anon_sym_DASH_DOT] = ACTIONS(297),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(297),
    [aux_sym_prefix_op_token1] = ACTIONS(297),
    [sym_int] = ACTIONS(299),
    [sym_xint] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(297),
    [anon_sym_POUNDload] = ACTIONS(297),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(297),
  },
  [3392] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8199),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3392),
    [sym_block_comment] = STATE(3392),
    [sym_line_comment] = STATE(3392),
    [sym_compiler_directive_decl] = STATE(3392),
    [sym_fsi_directive_decl] = STATE(3392),
    [sym_preproc_line] = STATE(3392),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5909),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3393] = {
    [sym_xml_doc] = STATE(3393),
    [sym_block_comment] = STATE(3393),
    [sym_line_comment] = STATE(3393),
    [sym_compiler_directive_decl] = STATE(3393),
    [sym_fsi_directive_decl] = STATE(3393),
    [sym_preproc_line] = STATE(3393),
    [ts_builtin_sym_end] = ACTIONS(5911),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_namespace] = ACTIONS(5913),
    [anon_sym_module] = ACTIONS(5913),
    [anon_sym_open] = ACTIONS(5913),
    [anon_sym_LBRACK_LT] = ACTIONS(5911),
    [anon_sym_return] = ACTIONS(5913),
    [anon_sym_type] = ACTIONS(5913),
    [anon_sym_do] = ACTIONS(5913),
    [anon_sym_let] = ACTIONS(5913),
    [anon_sym_let_BANG] = ACTIONS(5911),
    [anon_sym_LPAREN] = ACTIONS(5913),
    [anon_sym_null] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_LBRACK] = ACTIONS(5913),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5911),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_LT_AT] = ACTIONS(5913),
    [anon_sym_LT_AT_AT] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5911),
    [anon_sym_new] = ACTIONS(5913),
    [anon_sym_return_BANG] = ACTIONS(5911),
    [anon_sym_yield] = ACTIONS(5913),
    [anon_sym_yield_BANG] = ACTIONS(5911),
    [anon_sym_lazy] = ACTIONS(5913),
    [anon_sym_assert] = ACTIONS(5913),
    [anon_sym_upcast] = ACTIONS(5913),
    [anon_sym_downcast] = ACTIONS(5913),
    [anon_sym_for] = ACTIONS(5913),
    [anon_sym_while] = ACTIONS(5913),
    [anon_sym_if] = ACTIONS(5913),
    [anon_sym_fun] = ACTIONS(5913),
    [anon_sym_try] = ACTIONS(5913),
    [anon_sym_match] = ACTIONS(5913),
    [anon_sym_match_BANG] = ACTIONS(5911),
    [anon_sym_function] = ACTIONS(5913),
    [anon_sym_use] = ACTIONS(5913),
    [anon_sym_use_BANG] = ACTIONS(5911),
    [anon_sym_do_BANG] = ACTIONS(5911),
    [anon_sym_begin] = ACTIONS(5913),
    [aux_sym_char_token1] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5913),
    [anon_sym_DQUOTE] = ACTIONS(5913),
    [anon_sym_AT_DQUOTE] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [sym_bool] = ACTIONS(5913),
    [sym_unit] = ACTIONS(5911),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5913),
    [sym_op_identifier] = ACTIONS(5911),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS_DOT] = ACTIONS(5911),
    [anon_sym_DASH_DOT] = ACTIONS(5911),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5911),
    [aux_sym_prefix_op_token1] = ACTIONS(5911),
    [sym_int] = ACTIONS(5913),
    [sym_xint] = ACTIONS(5911),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5911),
    [anon_sym_POUNDload] = ACTIONS(5911),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5911),
  },
  [3394] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8282),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3394),
    [sym_block_comment] = STATE(3394),
    [sym_line_comment] = STATE(3394),
    [sym_compiler_directive_decl] = STATE(3394),
    [sym_fsi_directive_decl] = STATE(3394),
    [sym_preproc_line] = STATE(3394),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5915),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3395] = {
    [sym_xml_doc] = STATE(3395),
    [sym_block_comment] = STATE(3395),
    [sym_line_comment] = STATE(3395),
    [sym_compiler_directive_decl] = STATE(3395),
    [sym_fsi_directive_decl] = STATE(3395),
    [sym_preproc_line] = STATE(3395),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_let_BANG] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_null] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_LT_AT] = ACTIONS(3361),
    [anon_sym_LT_AT_AT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_return_BANG] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_yield_BANG] = ACTIONS(3363),
    [anon_sym_lazy] = ACTIONS(3361),
    [anon_sym_assert] = ACTIONS(3361),
    [anon_sym_upcast] = ACTIONS(3361),
    [anon_sym_downcast] = ACTIONS(3361),
    [anon_sym_COLON_GT] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_fun] = ACTIONS(3361),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_match] = ACTIONS(3361),
    [anon_sym_match_BANG] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_use] = ACTIONS(3361),
    [anon_sym_use_BANG] = ACTIONS(3363),
    [anon_sym_do_BANG] = ACTIONS(3363),
    [anon_sym_begin] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_LT2] = ACTIONS(3361),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3363),
    [anon_sym_or] = ACTIONS(3361),
    [aux_sym_char_token1] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_AT_DQUOTE] = ACTIONS(3363),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3363),
    [sym_bool] = ACTIONS(3361),
    [sym_unit] = ACTIONS(3363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3361),
    [sym_op_identifier] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PLUS_DOT] = ACTIONS(3363),
    [anon_sym_DASH_DOT] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [aux_sym_prefix_op_token1] = ACTIONS(3363),
    [sym_int] = ACTIONS(3361),
    [sym_xint] = ACTIONS(3363),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3363),
  },
  [3396] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8092),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3396),
    [sym_block_comment] = STATE(3396),
    [sym_line_comment] = STATE(3396),
    [sym_compiler_directive_decl] = STATE(3396),
    [sym_fsi_directive_decl] = STATE(3396),
    [sym_preproc_line] = STATE(3396),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3397] = {
    [sym_xml_doc] = STATE(3397),
    [sym_block_comment] = STATE(3397),
    [sym_line_comment] = STATE(3397),
    [sym_compiler_directive_decl] = STATE(3397),
    [sym_fsi_directive_decl] = STATE(3397),
    [sym_preproc_line] = STATE(3397),
    [sym_identifier] = ACTIONS(5761),
    [anon_sym_module] = ACTIONS(5761),
    [anon_sym_open] = ACTIONS(5761),
    [anon_sym_LBRACK_LT] = ACTIONS(5759),
    [anon_sym_return] = ACTIONS(5761),
    [anon_sym_type] = ACTIONS(5761),
    [anon_sym_do] = ACTIONS(5761),
    [anon_sym_and] = ACTIONS(5761),
    [anon_sym_let] = ACTIONS(5761),
    [anon_sym_let_BANG] = ACTIONS(5759),
    [anon_sym_LPAREN] = ACTIONS(5761),
    [anon_sym_null] = ACTIONS(5761),
    [anon_sym_AMP] = ACTIONS(5761),
    [anon_sym_LBRACK] = ACTIONS(5761),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5759),
    [anon_sym_LBRACE] = ACTIONS(5761),
    [anon_sym_LT_AT] = ACTIONS(5761),
    [anon_sym_LT_AT_AT] = ACTIONS(5759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5759),
    [anon_sym_new] = ACTIONS(5761),
    [anon_sym_return_BANG] = ACTIONS(5759),
    [anon_sym_yield] = ACTIONS(5761),
    [anon_sym_yield_BANG] = ACTIONS(5759),
    [anon_sym_lazy] = ACTIONS(5761),
    [anon_sym_assert] = ACTIONS(5761),
    [anon_sym_upcast] = ACTIONS(5761),
    [anon_sym_downcast] = ACTIONS(5761),
    [anon_sym_for] = ACTIONS(5761),
    [anon_sym_while] = ACTIONS(5761),
    [anon_sym_if] = ACTIONS(5761),
    [anon_sym_fun] = ACTIONS(5761),
    [anon_sym_try] = ACTIONS(5761),
    [anon_sym_match] = ACTIONS(5761),
    [anon_sym_match_BANG] = ACTIONS(5759),
    [anon_sym_function] = ACTIONS(5761),
    [anon_sym_use] = ACTIONS(5761),
    [anon_sym_use_BANG] = ACTIONS(5759),
    [anon_sym_do_BANG] = ACTIONS(5759),
    [anon_sym_begin] = ACTIONS(5761),
    [aux_sym_char_token1] = ACTIONS(5759),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5761),
    [anon_sym_DQUOTE] = ACTIONS(5761),
    [anon_sym_AT_DQUOTE] = ACTIONS(5759),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5759),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5759),
    [sym_bool] = ACTIONS(5761),
    [sym_unit] = ACTIONS(5759),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5761),
    [sym_op_identifier] = ACTIONS(5759),
    [anon_sym_PLUS] = ACTIONS(5761),
    [anon_sym_DASH] = ACTIONS(5761),
    [anon_sym_PLUS_DOT] = ACTIONS(5759),
    [anon_sym_DASH_DOT] = ACTIONS(5759),
    [anon_sym_PERCENT] = ACTIONS(5759),
    [anon_sym_AMP_AMP] = ACTIONS(5759),
    [anon_sym_TILDE] = ACTIONS(5759),
    [aux_sym_prefix_op_token1] = ACTIONS(5759),
    [sym_int] = ACTIONS(5761),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5759),
    [anon_sym_POUNDload] = ACTIONS(5759),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5759),
    [sym__dedent] = ACTIONS(5759),
  },
  [3398] = {
    [sym_xml_doc] = STATE(3398),
    [sym_block_comment] = STATE(3398),
    [sym_line_comment] = STATE(3398),
    [sym_compiler_directive_decl] = STATE(3398),
    [sym_fsi_directive_decl] = STATE(3398),
    [sym_preproc_line] = STATE(3398),
    [ts_builtin_sym_end] = ACTIONS(5911),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_namespace] = ACTIONS(5913),
    [anon_sym_module] = ACTIONS(5913),
    [anon_sym_open] = ACTIONS(5913),
    [anon_sym_LBRACK_LT] = ACTIONS(5911),
    [anon_sym_return] = ACTIONS(5913),
    [anon_sym_type] = ACTIONS(5913),
    [anon_sym_do] = ACTIONS(5913),
    [anon_sym_let] = ACTIONS(5913),
    [anon_sym_let_BANG] = ACTIONS(5911),
    [anon_sym_LPAREN] = ACTIONS(5913),
    [anon_sym_null] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_LBRACK] = ACTIONS(5913),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5911),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_LT_AT] = ACTIONS(5913),
    [anon_sym_LT_AT_AT] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5911),
    [anon_sym_new] = ACTIONS(5913),
    [anon_sym_return_BANG] = ACTIONS(5911),
    [anon_sym_yield] = ACTIONS(5913),
    [anon_sym_yield_BANG] = ACTIONS(5911),
    [anon_sym_lazy] = ACTIONS(5913),
    [anon_sym_assert] = ACTIONS(5913),
    [anon_sym_upcast] = ACTIONS(5913),
    [anon_sym_downcast] = ACTIONS(5913),
    [anon_sym_for] = ACTIONS(5913),
    [anon_sym_while] = ACTIONS(5913),
    [anon_sym_if] = ACTIONS(5913),
    [anon_sym_fun] = ACTIONS(5913),
    [anon_sym_try] = ACTIONS(5913),
    [anon_sym_match] = ACTIONS(5913),
    [anon_sym_match_BANG] = ACTIONS(5911),
    [anon_sym_function] = ACTIONS(5913),
    [anon_sym_use] = ACTIONS(5913),
    [anon_sym_use_BANG] = ACTIONS(5911),
    [anon_sym_do_BANG] = ACTIONS(5911),
    [anon_sym_begin] = ACTIONS(5913),
    [aux_sym_char_token1] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5913),
    [anon_sym_DQUOTE] = ACTIONS(5913),
    [anon_sym_AT_DQUOTE] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [sym_bool] = ACTIONS(5913),
    [sym_unit] = ACTIONS(5911),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5913),
    [sym_op_identifier] = ACTIONS(5911),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS_DOT] = ACTIONS(5911),
    [anon_sym_DASH_DOT] = ACTIONS(5911),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5911),
    [aux_sym_prefix_op_token1] = ACTIONS(5911),
    [sym_int] = ACTIONS(5913),
    [sym_xint] = ACTIONS(5911),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5911),
    [anon_sym_POUNDload] = ACTIONS(5911),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5911),
  },
  [3399] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7693),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3399),
    [sym_block_comment] = STATE(3399),
    [sym_line_comment] = STATE(3399),
    [sym_compiler_directive_decl] = STATE(3399),
    [sym_fsi_directive_decl] = STATE(3399),
    [sym_preproc_line] = STATE(3399),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5919),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3400] = {
    [sym_xml_doc] = STATE(3400),
    [sym_block_comment] = STATE(3400),
    [sym_line_comment] = STATE(3400),
    [sym_compiler_directive_decl] = STATE(3400),
    [sym_fsi_directive_decl] = STATE(3400),
    [sym_preproc_line] = STATE(3400),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(5921),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [3401] = {
    [sym_xml_doc] = STATE(3401),
    [sym_block_comment] = STATE(3401),
    [sym_line_comment] = STATE(3401),
    [sym_compiler_directive_decl] = STATE(3401),
    [sym_fsi_directive_decl] = STATE(3401),
    [sym_preproc_line] = STATE(3401),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3320),
    [anon_sym_DASH_DOT] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3320),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
  },
  [3402] = {
    [sym_xml_doc] = STATE(3402),
    [sym_block_comment] = STATE(3402),
    [sym_line_comment] = STATE(3402),
    [sym_compiler_directive_decl] = STATE(3402),
    [sym_fsi_directive_decl] = STATE(3402),
    [sym_preproc_line] = STATE(3402),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_GT_RBRACK] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__newline] = ACTIONS(3353),
  },
  [3403] = {
    [sym_xml_doc] = STATE(3403),
    [sym_block_comment] = STATE(3403),
    [sym_line_comment] = STATE(3403),
    [sym_compiler_directive_decl] = STATE(3403),
    [sym_fsi_directive_decl] = STATE(3403),
    [sym_preproc_line] = STATE(3403),
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_module] = ACTIONS(5699),
    [anon_sym_open] = ACTIONS(5699),
    [anon_sym_LBRACK_LT] = ACTIONS(5697),
    [anon_sym_return] = ACTIONS(5699),
    [anon_sym_type] = ACTIONS(5699),
    [anon_sym_do] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_let] = ACTIONS(5699),
    [anon_sym_let_BANG] = ACTIONS(5697),
    [anon_sym_LPAREN] = ACTIONS(5699),
    [anon_sym_null] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5697),
    [anon_sym_LBRACE] = ACTIONS(5699),
    [anon_sym_LT_AT] = ACTIONS(5699),
    [anon_sym_LT_AT_AT] = ACTIONS(5697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5699),
    [anon_sym_return_BANG] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5699),
    [anon_sym_yield_BANG] = ACTIONS(5697),
    [anon_sym_lazy] = ACTIONS(5699),
    [anon_sym_assert] = ACTIONS(5699),
    [anon_sym_upcast] = ACTIONS(5699),
    [anon_sym_downcast] = ACTIONS(5699),
    [anon_sym_for] = ACTIONS(5699),
    [anon_sym_while] = ACTIONS(5699),
    [anon_sym_if] = ACTIONS(5699),
    [anon_sym_fun] = ACTIONS(5699),
    [anon_sym_try] = ACTIONS(5699),
    [anon_sym_match] = ACTIONS(5699),
    [anon_sym_match_BANG] = ACTIONS(5697),
    [anon_sym_function] = ACTIONS(5699),
    [anon_sym_use] = ACTIONS(5699),
    [anon_sym_use_BANG] = ACTIONS(5697),
    [anon_sym_do_BANG] = ACTIONS(5697),
    [anon_sym_begin] = ACTIONS(5699),
    [aux_sym_char_token1] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [anon_sym_AT_DQUOTE] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [sym_bool] = ACTIONS(5699),
    [sym_unit] = ACTIONS(5697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5699),
    [sym_op_identifier] = ACTIONS(5697),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS_DOT] = ACTIONS(5697),
    [anon_sym_DASH_DOT] = ACTIONS(5697),
    [anon_sym_PERCENT] = ACTIONS(5697),
    [anon_sym_AMP_AMP] = ACTIONS(5697),
    [anon_sym_TILDE] = ACTIONS(5697),
    [aux_sym_prefix_op_token1] = ACTIONS(5697),
    [sym_int] = ACTIONS(5699),
    [sym_xint] = ACTIONS(5697),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5697),
    [anon_sym_POUNDload] = ACTIONS(5697),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5697),
    [sym__dedent] = ACTIONS(5697),
  },
  [3404] = {
    [sym_xml_doc] = STATE(3404),
    [sym_block_comment] = STATE(3404),
    [sym_line_comment] = STATE(3404),
    [sym_compiler_directive_decl] = STATE(3404),
    [sym_fsi_directive_decl] = STATE(3404),
    [sym_preproc_line] = STATE(3404),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_GT_RBRACK] = ACTIONS(3310),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3310),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3310),
    [anon_sym_DASH_DOT] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3310),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__newline] = ACTIONS(3310),
  },
  [3405] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7891),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3405),
    [sym_block_comment] = STATE(3405),
    [sym_line_comment] = STATE(3405),
    [sym_compiler_directive_decl] = STATE(3405),
    [sym_fsi_directive_decl] = STATE(3405),
    [sym_preproc_line] = STATE(3405),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5923),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3406] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8385),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3406),
    [sym_block_comment] = STATE(3406),
    [sym_line_comment] = STATE(3406),
    [sym_compiler_directive_decl] = STATE(3406),
    [sym_fsi_directive_decl] = STATE(3406),
    [sym_preproc_line] = STATE(3406),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3407] = {
    [sym_xml_doc] = STATE(3407),
    [sym_block_comment] = STATE(3407),
    [sym_line_comment] = STATE(3407),
    [sym_compiler_directive_decl] = STATE(3407),
    [sym_fsi_directive_decl] = STATE(3407),
    [sym_preproc_line] = STATE(3407),
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_module] = ACTIONS(5732),
    [anon_sym_open] = ACTIONS(5732),
    [anon_sym_LBRACK_LT] = ACTIONS(5730),
    [anon_sym_return] = ACTIONS(5732),
    [anon_sym_type] = ACTIONS(5732),
    [anon_sym_do] = ACTIONS(5732),
    [anon_sym_and] = ACTIONS(5732),
    [anon_sym_let] = ACTIONS(5732),
    [anon_sym_let_BANG] = ACTIONS(5730),
    [anon_sym_LPAREN] = ACTIONS(5732),
    [anon_sym_null] = ACTIONS(5732),
    [anon_sym_AMP] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5730),
    [anon_sym_LBRACE] = ACTIONS(5732),
    [anon_sym_LT_AT] = ACTIONS(5732),
    [anon_sym_LT_AT_AT] = ACTIONS(5730),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5730),
    [anon_sym_new] = ACTIONS(5732),
    [anon_sym_return_BANG] = ACTIONS(5730),
    [anon_sym_yield] = ACTIONS(5732),
    [anon_sym_yield_BANG] = ACTIONS(5730),
    [anon_sym_lazy] = ACTIONS(5732),
    [anon_sym_assert] = ACTIONS(5732),
    [anon_sym_upcast] = ACTIONS(5732),
    [anon_sym_downcast] = ACTIONS(5732),
    [anon_sym_for] = ACTIONS(5732),
    [anon_sym_while] = ACTIONS(5732),
    [anon_sym_if] = ACTIONS(5732),
    [anon_sym_fun] = ACTIONS(5732),
    [anon_sym_try] = ACTIONS(5732),
    [anon_sym_match] = ACTIONS(5732),
    [anon_sym_match_BANG] = ACTIONS(5730),
    [anon_sym_function] = ACTIONS(5732),
    [anon_sym_use] = ACTIONS(5732),
    [anon_sym_use_BANG] = ACTIONS(5730),
    [anon_sym_do_BANG] = ACTIONS(5730),
    [anon_sym_begin] = ACTIONS(5732),
    [aux_sym_char_token1] = ACTIONS(5730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5732),
    [anon_sym_DQUOTE] = ACTIONS(5732),
    [anon_sym_AT_DQUOTE] = ACTIONS(5730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5730),
    [sym_bool] = ACTIONS(5732),
    [sym_unit] = ACTIONS(5730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5732),
    [sym_op_identifier] = ACTIONS(5730),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_DASH] = ACTIONS(5732),
    [anon_sym_PLUS_DOT] = ACTIONS(5730),
    [anon_sym_DASH_DOT] = ACTIONS(5730),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5730),
    [aux_sym_prefix_op_token1] = ACTIONS(5730),
    [sym_int] = ACTIONS(5732),
    [sym_xint] = ACTIONS(5730),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5730),
    [anon_sym_POUNDload] = ACTIONS(5730),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5730),
    [sym__dedent] = ACTIONS(5730),
  },
  [3408] = {
    [sym_xml_doc] = STATE(3408),
    [sym_block_comment] = STATE(3408),
    [sym_line_comment] = STATE(3408),
    [sym_compiler_directive_decl] = STATE(3408),
    [sym_fsi_directive_decl] = STATE(3408),
    [sym_preproc_line] = STATE(3408),
    [sym_identifier] = ACTIONS(5749),
    [anon_sym_module] = ACTIONS(5749),
    [anon_sym_open] = ACTIONS(5749),
    [anon_sym_LBRACK_LT] = ACTIONS(5747),
    [anon_sym_return] = ACTIONS(5749),
    [anon_sym_type] = ACTIONS(5749),
    [anon_sym_do] = ACTIONS(5749),
    [anon_sym_and] = ACTIONS(5749),
    [anon_sym_let] = ACTIONS(5749),
    [anon_sym_let_BANG] = ACTIONS(5747),
    [anon_sym_LPAREN] = ACTIONS(5749),
    [anon_sym_null] = ACTIONS(5749),
    [anon_sym_AMP] = ACTIONS(5749),
    [anon_sym_LBRACK] = ACTIONS(5749),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5747),
    [anon_sym_LBRACE] = ACTIONS(5749),
    [anon_sym_LT_AT] = ACTIONS(5749),
    [anon_sym_LT_AT_AT] = ACTIONS(5747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5747),
    [anon_sym_new] = ACTIONS(5749),
    [anon_sym_return_BANG] = ACTIONS(5747),
    [anon_sym_yield] = ACTIONS(5749),
    [anon_sym_yield_BANG] = ACTIONS(5747),
    [anon_sym_lazy] = ACTIONS(5749),
    [anon_sym_assert] = ACTIONS(5749),
    [anon_sym_upcast] = ACTIONS(5749),
    [anon_sym_downcast] = ACTIONS(5749),
    [anon_sym_for] = ACTIONS(5749),
    [anon_sym_while] = ACTIONS(5749),
    [anon_sym_if] = ACTIONS(5749),
    [anon_sym_fun] = ACTIONS(5749),
    [anon_sym_try] = ACTIONS(5749),
    [anon_sym_match] = ACTIONS(5749),
    [anon_sym_match_BANG] = ACTIONS(5747),
    [anon_sym_function] = ACTIONS(5749),
    [anon_sym_use] = ACTIONS(5749),
    [anon_sym_use_BANG] = ACTIONS(5747),
    [anon_sym_do_BANG] = ACTIONS(5747),
    [anon_sym_begin] = ACTIONS(5749),
    [aux_sym_char_token1] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE] = ACTIONS(5749),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5747),
    [sym_bool] = ACTIONS(5749),
    [sym_unit] = ACTIONS(5747),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5749),
    [sym_op_identifier] = ACTIONS(5747),
    [anon_sym_PLUS] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(5749),
    [anon_sym_PLUS_DOT] = ACTIONS(5747),
    [anon_sym_DASH_DOT] = ACTIONS(5747),
    [anon_sym_PERCENT] = ACTIONS(5747),
    [anon_sym_AMP_AMP] = ACTIONS(5747),
    [anon_sym_TILDE] = ACTIONS(5747),
    [aux_sym_prefix_op_token1] = ACTIONS(5747),
    [sym_int] = ACTIONS(5749),
    [sym_xint] = ACTIONS(5747),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5747),
    [anon_sym_POUNDload] = ACTIONS(5747),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5747),
    [sym__dedent] = ACTIONS(5747),
  },
  [3409] = {
    [sym_xml_doc] = STATE(3409),
    [sym_block_comment] = STATE(3409),
    [sym_line_comment] = STATE(3409),
    [sym_compiler_directive_decl] = STATE(3409),
    [sym_fsi_directive_decl] = STATE(3409),
    [sym_preproc_line] = STATE(3409),
    [sym_identifier] = ACTIONS(5774),
    [anon_sym_module] = ACTIONS(5774),
    [anon_sym_open] = ACTIONS(5774),
    [anon_sym_LBRACK_LT] = ACTIONS(5772),
    [anon_sym_return] = ACTIONS(5774),
    [anon_sym_type] = ACTIONS(5774),
    [anon_sym_do] = ACTIONS(5774),
    [anon_sym_and] = ACTIONS(5774),
    [anon_sym_let] = ACTIONS(5774),
    [anon_sym_let_BANG] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5774),
    [anon_sym_null] = ACTIONS(5774),
    [anon_sym_AMP] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5772),
    [anon_sym_LBRACE] = ACTIONS(5774),
    [anon_sym_LT_AT] = ACTIONS(5774),
    [anon_sym_LT_AT_AT] = ACTIONS(5772),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5772),
    [anon_sym_new] = ACTIONS(5774),
    [anon_sym_return_BANG] = ACTIONS(5772),
    [anon_sym_yield] = ACTIONS(5774),
    [anon_sym_yield_BANG] = ACTIONS(5772),
    [anon_sym_lazy] = ACTIONS(5774),
    [anon_sym_assert] = ACTIONS(5774),
    [anon_sym_upcast] = ACTIONS(5774),
    [anon_sym_downcast] = ACTIONS(5774),
    [anon_sym_for] = ACTIONS(5774),
    [anon_sym_while] = ACTIONS(5774),
    [anon_sym_if] = ACTIONS(5774),
    [anon_sym_fun] = ACTIONS(5774),
    [anon_sym_try] = ACTIONS(5774),
    [anon_sym_match] = ACTIONS(5774),
    [anon_sym_match_BANG] = ACTIONS(5772),
    [anon_sym_function] = ACTIONS(5774),
    [anon_sym_use] = ACTIONS(5774),
    [anon_sym_use_BANG] = ACTIONS(5772),
    [anon_sym_do_BANG] = ACTIONS(5772),
    [anon_sym_begin] = ACTIONS(5774),
    [aux_sym_char_token1] = ACTIONS(5772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5774),
    [anon_sym_DQUOTE] = ACTIONS(5774),
    [anon_sym_AT_DQUOTE] = ACTIONS(5772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5772),
    [sym_bool] = ACTIONS(5774),
    [sym_unit] = ACTIONS(5772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5774),
    [sym_op_identifier] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_PLUS_DOT] = ACTIONS(5772),
    [anon_sym_DASH_DOT] = ACTIONS(5772),
    [anon_sym_PERCENT] = ACTIONS(5772),
    [anon_sym_AMP_AMP] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5772),
    [aux_sym_prefix_op_token1] = ACTIONS(5772),
    [sym_int] = ACTIONS(5774),
    [sym_xint] = ACTIONS(5772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5772),
    [anon_sym_POUNDload] = ACTIONS(5772),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5772),
    [sym__dedent] = ACTIONS(5772),
  },
  [3410] = {
    [sym_xml_doc] = STATE(3410),
    [sym_block_comment] = STATE(3410),
    [sym_line_comment] = STATE(3410),
    [sym_compiler_directive_decl] = STATE(3410),
    [sym_fsi_directive_decl] = STATE(3410),
    [sym_preproc_line] = STATE(3410),
    [sym_identifier] = ACTIONS(5770),
    [anon_sym_module] = ACTIONS(5770),
    [anon_sym_open] = ACTIONS(5770),
    [anon_sym_LBRACK_LT] = ACTIONS(5768),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_type] = ACTIONS(5770),
    [anon_sym_do] = ACTIONS(5770),
    [anon_sym_and] = ACTIONS(5770),
    [anon_sym_let] = ACTIONS(5770),
    [anon_sym_let_BANG] = ACTIONS(5768),
    [anon_sym_LPAREN] = ACTIONS(5770),
    [anon_sym_null] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5770),
    [anon_sym_LT_AT] = ACTIONS(5770),
    [anon_sym_LT_AT_AT] = ACTIONS(5768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5768),
    [anon_sym_new] = ACTIONS(5770),
    [anon_sym_return_BANG] = ACTIONS(5768),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_yield_BANG] = ACTIONS(5768),
    [anon_sym_lazy] = ACTIONS(5770),
    [anon_sym_assert] = ACTIONS(5770),
    [anon_sym_upcast] = ACTIONS(5770),
    [anon_sym_downcast] = ACTIONS(5770),
    [anon_sym_for] = ACTIONS(5770),
    [anon_sym_while] = ACTIONS(5770),
    [anon_sym_if] = ACTIONS(5770),
    [anon_sym_fun] = ACTIONS(5770),
    [anon_sym_try] = ACTIONS(5770),
    [anon_sym_match] = ACTIONS(5770),
    [anon_sym_match_BANG] = ACTIONS(5768),
    [anon_sym_function] = ACTIONS(5770),
    [anon_sym_use] = ACTIONS(5770),
    [anon_sym_use_BANG] = ACTIONS(5768),
    [anon_sym_do_BANG] = ACTIONS(5768),
    [anon_sym_begin] = ACTIONS(5770),
    [aux_sym_char_token1] = ACTIONS(5768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [anon_sym_AT_DQUOTE] = ACTIONS(5768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5768),
    [sym_bool] = ACTIONS(5770),
    [sym_unit] = ACTIONS(5768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5770),
    [sym_op_identifier] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_PLUS_DOT] = ACTIONS(5768),
    [anon_sym_DASH_DOT] = ACTIONS(5768),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_AMP_AMP] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5768),
    [aux_sym_prefix_op_token1] = ACTIONS(5768),
    [sym_int] = ACTIONS(5770),
    [sym_xint] = ACTIONS(5768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5768),
    [anon_sym_POUNDload] = ACTIONS(5768),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5768),
    [sym__dedent] = ACTIONS(5768),
  },
  [3411] = {
    [sym_xml_doc] = STATE(3411),
    [sym_block_comment] = STATE(3411),
    [sym_line_comment] = STATE(3411),
    [sym_compiler_directive_decl] = STATE(3411),
    [sym_fsi_directive_decl] = STATE(3411),
    [sym_preproc_line] = STATE(3411),
    [sym_identifier] = ACTIONS(5757),
    [anon_sym_module] = ACTIONS(5757),
    [anon_sym_open] = ACTIONS(5757),
    [anon_sym_LBRACK_LT] = ACTIONS(5755),
    [anon_sym_return] = ACTIONS(5757),
    [anon_sym_type] = ACTIONS(5757),
    [anon_sym_do] = ACTIONS(5757),
    [anon_sym_and] = ACTIONS(5757),
    [anon_sym_let] = ACTIONS(5757),
    [anon_sym_let_BANG] = ACTIONS(5755),
    [anon_sym_LPAREN] = ACTIONS(5757),
    [anon_sym_null] = ACTIONS(5757),
    [anon_sym_AMP] = ACTIONS(5757),
    [anon_sym_LBRACK] = ACTIONS(5757),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5757),
    [anon_sym_LT_AT] = ACTIONS(5757),
    [anon_sym_LT_AT_AT] = ACTIONS(5755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5755),
    [anon_sym_new] = ACTIONS(5757),
    [anon_sym_return_BANG] = ACTIONS(5755),
    [anon_sym_yield] = ACTIONS(5757),
    [anon_sym_yield_BANG] = ACTIONS(5755),
    [anon_sym_lazy] = ACTIONS(5757),
    [anon_sym_assert] = ACTIONS(5757),
    [anon_sym_upcast] = ACTIONS(5757),
    [anon_sym_downcast] = ACTIONS(5757),
    [anon_sym_for] = ACTIONS(5757),
    [anon_sym_while] = ACTIONS(5757),
    [anon_sym_if] = ACTIONS(5757),
    [anon_sym_fun] = ACTIONS(5757),
    [anon_sym_try] = ACTIONS(5757),
    [anon_sym_match] = ACTIONS(5757),
    [anon_sym_match_BANG] = ACTIONS(5755),
    [anon_sym_function] = ACTIONS(5757),
    [anon_sym_use] = ACTIONS(5757),
    [anon_sym_use_BANG] = ACTIONS(5755),
    [anon_sym_do_BANG] = ACTIONS(5755),
    [anon_sym_begin] = ACTIONS(5757),
    [aux_sym_char_token1] = ACTIONS(5755),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5757),
    [anon_sym_DQUOTE] = ACTIONS(5757),
    [anon_sym_AT_DQUOTE] = ACTIONS(5755),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5755),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5755),
    [sym_bool] = ACTIONS(5757),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5757),
    [sym_op_identifier] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [anon_sym_PLUS_DOT] = ACTIONS(5755),
    [anon_sym_DASH_DOT] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_AMP_AMP] = ACTIONS(5755),
    [anon_sym_TILDE] = ACTIONS(5755),
    [aux_sym_prefix_op_token1] = ACTIONS(5755),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5755),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5755),
    [anon_sym_POUNDload] = ACTIONS(5755),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5755),
    [sym__dedent] = ACTIONS(5755),
  },
  [3412] = {
    [sym_xml_doc] = STATE(3412),
    [sym_block_comment] = STATE(3412),
    [sym_line_comment] = STATE(3412),
    [sym_compiler_directive_decl] = STATE(3412),
    [sym_fsi_directive_decl] = STATE(3412),
    [sym_preproc_line] = STATE(3412),
    [sym_identifier] = ACTIONS(5686),
    [anon_sym_module] = ACTIONS(5686),
    [anon_sym_open] = ACTIONS(5686),
    [anon_sym_LBRACK_LT] = ACTIONS(5684),
    [anon_sym_return] = ACTIONS(5686),
    [anon_sym_type] = ACTIONS(5686),
    [anon_sym_do] = ACTIONS(5686),
    [anon_sym_and] = ACTIONS(5686),
    [anon_sym_let] = ACTIONS(5686),
    [anon_sym_let_BANG] = ACTIONS(5684),
    [anon_sym_LPAREN] = ACTIONS(5686),
    [anon_sym_null] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5684),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_LT_AT] = ACTIONS(5686),
    [anon_sym_LT_AT_AT] = ACTIONS(5684),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5684),
    [anon_sym_new] = ACTIONS(5686),
    [anon_sym_return_BANG] = ACTIONS(5684),
    [anon_sym_yield] = ACTIONS(5686),
    [anon_sym_yield_BANG] = ACTIONS(5684),
    [anon_sym_lazy] = ACTIONS(5686),
    [anon_sym_assert] = ACTIONS(5686),
    [anon_sym_upcast] = ACTIONS(5686),
    [anon_sym_downcast] = ACTIONS(5686),
    [anon_sym_for] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_fun] = ACTIONS(5686),
    [anon_sym_try] = ACTIONS(5686),
    [anon_sym_match] = ACTIONS(5686),
    [anon_sym_match_BANG] = ACTIONS(5684),
    [anon_sym_function] = ACTIONS(5686),
    [anon_sym_use] = ACTIONS(5686),
    [anon_sym_use_BANG] = ACTIONS(5684),
    [anon_sym_do_BANG] = ACTIONS(5684),
    [anon_sym_begin] = ACTIONS(5686),
    [aux_sym_char_token1] = ACTIONS(5684),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5686),
    [anon_sym_DQUOTE] = ACTIONS(5686),
    [anon_sym_AT_DQUOTE] = ACTIONS(5684),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5684),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5684),
    [sym_bool] = ACTIONS(5686),
    [sym_unit] = ACTIONS(5684),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5686),
    [sym_op_identifier] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_DOT] = ACTIONS(5684),
    [anon_sym_DASH_DOT] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5684),
    [aux_sym_prefix_op_token1] = ACTIONS(5684),
    [sym_int] = ACTIONS(5686),
    [sym_xint] = ACTIONS(5684),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5684),
    [anon_sym_POUNDload] = ACTIONS(5684),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5684),
    [sym__dedent] = ACTIONS(5684),
  },
  [3413] = {
    [sym_xml_doc] = STATE(3413),
    [sym_block_comment] = STATE(3413),
    [sym_line_comment] = STATE(3413),
    [sym_compiler_directive_decl] = STATE(3413),
    [sym_fsi_directive_decl] = STATE(3413),
    [sym_preproc_line] = STATE(3413),
    [aux_sym__compound_type_repeat1] = STATE(3417),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3214),
    [anon_sym_DASH_DOT] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3214),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
    [sym__dedent] = ACTIONS(3214),
  },
  [3414] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7814),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3414),
    [sym_block_comment] = STATE(3414),
    [sym_line_comment] = STATE(3414),
    [sym_compiler_directive_decl] = STATE(3414),
    [sym_fsi_directive_decl] = STATE(3414),
    [sym_preproc_line] = STATE(3414),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5927),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3415] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7725),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3415),
    [sym_block_comment] = STATE(3415),
    [sym_line_comment] = STATE(3415),
    [sym_compiler_directive_decl] = STATE(3415),
    [sym_fsi_directive_decl] = STATE(3415),
    [sym_preproc_line] = STATE(3415),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5929),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3416] = {
    [sym_xml_doc] = STATE(3416),
    [sym_block_comment] = STATE(3416),
    [sym_line_comment] = STATE(3416),
    [sym_compiler_directive_decl] = STATE(3416),
    [sym_fsi_directive_decl] = STATE(3416),
    [sym_preproc_line] = STATE(3416),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3294),
    [anon_sym_DASH_DOT] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3294),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
  },
  [3417] = {
    [sym_xml_doc] = STATE(3417),
    [sym_block_comment] = STATE(3417),
    [sym_line_comment] = STATE(3417),
    [sym_compiler_directive_decl] = STATE(3417),
    [sym_fsi_directive_decl] = STATE(3417),
    [sym_preproc_line] = STATE(3417),
    [aux_sym__compound_type_repeat1] = STATE(3417),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(5931),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
    [sym__dedent] = ACTIONS(3030),
  },
  [3418] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7789),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3418),
    [sym_block_comment] = STATE(3418),
    [sym_line_comment] = STATE(3418),
    [sym_compiler_directive_decl] = STATE(3418),
    [sym_fsi_directive_decl] = STATE(3418),
    [sym_preproc_line] = STATE(3418),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3419] = {
    [sym_xml_doc] = STATE(3419),
    [sym_block_comment] = STATE(3419),
    [sym_line_comment] = STATE(3419),
    [sym_compiler_directive_decl] = STATE(3419),
    [sym_fsi_directive_decl] = STATE(3419),
    [sym_preproc_line] = STATE(3419),
    [sym_identifier] = ACTIONS(5717),
    [anon_sym_module] = ACTIONS(5717),
    [anon_sym_open] = ACTIONS(5717),
    [anon_sym_LBRACK_LT] = ACTIONS(5715),
    [anon_sym_return] = ACTIONS(5717),
    [anon_sym_type] = ACTIONS(5717),
    [anon_sym_do] = ACTIONS(5717),
    [anon_sym_and] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_let_BANG] = ACTIONS(5715),
    [anon_sym_LPAREN] = ACTIONS(5717),
    [anon_sym_null] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5715),
    [anon_sym_LBRACE] = ACTIONS(5717),
    [anon_sym_LT_AT] = ACTIONS(5717),
    [anon_sym_LT_AT_AT] = ACTIONS(5715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5715),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_return_BANG] = ACTIONS(5715),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_yield_BANG] = ACTIONS(5715),
    [anon_sym_lazy] = ACTIONS(5717),
    [anon_sym_assert] = ACTIONS(5717),
    [anon_sym_upcast] = ACTIONS(5717),
    [anon_sym_downcast] = ACTIONS(5717),
    [anon_sym_for] = ACTIONS(5717),
    [anon_sym_while] = ACTIONS(5717),
    [anon_sym_if] = ACTIONS(5717),
    [anon_sym_fun] = ACTIONS(5717),
    [anon_sym_try] = ACTIONS(5717),
    [anon_sym_match] = ACTIONS(5717),
    [anon_sym_match_BANG] = ACTIONS(5715),
    [anon_sym_function] = ACTIONS(5717),
    [anon_sym_use] = ACTIONS(5717),
    [anon_sym_use_BANG] = ACTIONS(5715),
    [anon_sym_do_BANG] = ACTIONS(5715),
    [anon_sym_begin] = ACTIONS(5717),
    [aux_sym_char_token1] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5717),
    [anon_sym_DQUOTE] = ACTIONS(5717),
    [anon_sym_AT_DQUOTE] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [sym_bool] = ACTIONS(5717),
    [sym_unit] = ACTIONS(5715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5717),
    [sym_op_identifier] = ACTIONS(5715),
    [anon_sym_PLUS] = ACTIONS(5717),
    [anon_sym_DASH] = ACTIONS(5717),
    [anon_sym_PLUS_DOT] = ACTIONS(5715),
    [anon_sym_DASH_DOT] = ACTIONS(5715),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_AMP_AMP] = ACTIONS(5715),
    [anon_sym_TILDE] = ACTIONS(5715),
    [aux_sym_prefix_op_token1] = ACTIONS(5715),
    [sym_int] = ACTIONS(5717),
    [sym_xint] = ACTIONS(5715),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5715),
    [anon_sym_POUNDload] = ACTIONS(5715),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5715),
    [sym__dedent] = ACTIONS(5715),
  },
  [3420] = {
    [sym_xml_doc] = STATE(3420),
    [sym_block_comment] = STATE(3420),
    [sym_line_comment] = STATE(3420),
    [sym_compiler_directive_decl] = STATE(3420),
    [sym_fsi_directive_decl] = STATE(3420),
    [sym_preproc_line] = STATE(3420),
    [ts_builtin_sym_end] = ACTIONS(5936),
    [sym_identifier] = ACTIONS(5938),
    [anon_sym_namespace] = ACTIONS(5938),
    [anon_sym_module] = ACTIONS(5938),
    [anon_sym_open] = ACTIONS(5938),
    [anon_sym_LBRACK_LT] = ACTIONS(5936),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_type] = ACTIONS(5938),
    [anon_sym_do] = ACTIONS(5938),
    [anon_sym_let] = ACTIONS(5938),
    [anon_sym_let_BANG] = ACTIONS(5936),
    [anon_sym_LPAREN] = ACTIONS(5938),
    [anon_sym_null] = ACTIONS(5938),
    [anon_sym_AMP] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5938),
    [anon_sym_LT_AT] = ACTIONS(5938),
    [anon_sym_LT_AT_AT] = ACTIONS(5936),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5936),
    [anon_sym_new] = ACTIONS(5938),
    [anon_sym_return_BANG] = ACTIONS(5936),
    [anon_sym_yield] = ACTIONS(5938),
    [anon_sym_yield_BANG] = ACTIONS(5936),
    [anon_sym_lazy] = ACTIONS(5938),
    [anon_sym_assert] = ACTIONS(5938),
    [anon_sym_upcast] = ACTIONS(5938),
    [anon_sym_downcast] = ACTIONS(5938),
    [anon_sym_for] = ACTIONS(5938),
    [anon_sym_while] = ACTIONS(5938),
    [anon_sym_if] = ACTIONS(5938),
    [anon_sym_fun] = ACTIONS(5938),
    [anon_sym_try] = ACTIONS(5938),
    [anon_sym_match] = ACTIONS(5938),
    [anon_sym_match_BANG] = ACTIONS(5936),
    [anon_sym_function] = ACTIONS(5938),
    [anon_sym_use] = ACTIONS(5938),
    [anon_sym_use_BANG] = ACTIONS(5936),
    [anon_sym_do_BANG] = ACTIONS(5936),
    [anon_sym_begin] = ACTIONS(5938),
    [aux_sym_char_token1] = ACTIONS(5936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5938),
    [anon_sym_DQUOTE] = ACTIONS(5938),
    [anon_sym_AT_DQUOTE] = ACTIONS(5936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5936),
    [sym_bool] = ACTIONS(5938),
    [sym_unit] = ACTIONS(5936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5938),
    [sym_op_identifier] = ACTIONS(5936),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(5938),
    [anon_sym_PLUS_DOT] = ACTIONS(5936),
    [anon_sym_DASH_DOT] = ACTIONS(5936),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_AMP_AMP] = ACTIONS(5936),
    [anon_sym_TILDE] = ACTIONS(5936),
    [aux_sym_prefix_op_token1] = ACTIONS(5936),
    [sym_int] = ACTIONS(5938),
    [sym_xint] = ACTIONS(5936),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5936),
    [anon_sym_POUNDload] = ACTIONS(5936),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5936),
  },
  [3421] = {
    [sym_xml_doc] = STATE(3421),
    [sym_block_comment] = STATE(3421),
    [sym_line_comment] = STATE(3421),
    [sym_compiler_directive_decl] = STATE(3421),
    [sym_fsi_directive_decl] = STATE(3421),
    [sym_preproc_line] = STATE(3421),
    [sym_identifier] = ACTIONS(5880),
    [anon_sym_module] = ACTIONS(5880),
    [anon_sym_open] = ACTIONS(5880),
    [anon_sym_LBRACK_LT] = ACTIONS(5878),
    [anon_sym_return] = ACTIONS(5880),
    [anon_sym_type] = ACTIONS(5880),
    [anon_sym_do] = ACTIONS(5880),
    [anon_sym_let] = ACTIONS(5880),
    [anon_sym_let_BANG] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5880),
    [anon_sym_null] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5880),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5878),
    [anon_sym_LBRACE] = ACTIONS(5880),
    [anon_sym_LT_AT] = ACTIONS(5880),
    [anon_sym_LT_AT_AT] = ACTIONS(5878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5878),
    [anon_sym_new] = ACTIONS(5880),
    [anon_sym_return_BANG] = ACTIONS(5878),
    [anon_sym_yield] = ACTIONS(5880),
    [anon_sym_yield_BANG] = ACTIONS(5878),
    [anon_sym_lazy] = ACTIONS(5880),
    [anon_sym_assert] = ACTIONS(5880),
    [anon_sym_upcast] = ACTIONS(5880),
    [anon_sym_downcast] = ACTIONS(5880),
    [anon_sym_for] = ACTIONS(5880),
    [anon_sym_while] = ACTIONS(5880),
    [anon_sym_if] = ACTIONS(5880),
    [anon_sym_fun] = ACTIONS(5880),
    [anon_sym_try] = ACTIONS(5880),
    [anon_sym_match] = ACTIONS(5880),
    [anon_sym_match_BANG] = ACTIONS(5878),
    [anon_sym_function] = ACTIONS(5880),
    [anon_sym_use] = ACTIONS(5880),
    [anon_sym_use_BANG] = ACTIONS(5878),
    [anon_sym_do_BANG] = ACTIONS(5878),
    [anon_sym_begin] = ACTIONS(5880),
    [aux_sym_char_token1] = ACTIONS(5878),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5880),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_AT_DQUOTE] = ACTIONS(5878),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5878),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5878),
    [sym_bool] = ACTIONS(5880),
    [sym_unit] = ACTIONS(5878),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5880),
    [sym_op_identifier] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_PLUS_DOT] = ACTIONS(5878),
    [anon_sym_DASH_DOT] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5878),
    [anon_sym_TILDE] = ACTIONS(5878),
    [aux_sym_prefix_op_token1] = ACTIONS(5878),
    [sym_int] = ACTIONS(5880),
    [sym_xint] = ACTIONS(5878),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5878),
    [anon_sym_POUNDload] = ACTIONS(5878),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5878),
    [sym__dedent] = ACTIONS(5878),
  },
  [3422] = {
    [sym_xml_doc] = STATE(3422),
    [sym_block_comment] = STATE(3422),
    [sym_line_comment] = STATE(3422),
    [sym_compiler_directive_decl] = STATE(3422),
    [sym_fsi_directive_decl] = STATE(3422),
    [sym_preproc_line] = STATE(3422),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_module] = ACTIONS(5905),
    [anon_sym_open] = ACTIONS(5905),
    [anon_sym_LBRACK_LT] = ACTIONS(5903),
    [anon_sym_return] = ACTIONS(5905),
    [anon_sym_type] = ACTIONS(5905),
    [anon_sym_do] = ACTIONS(5905),
    [anon_sym_let] = ACTIONS(5905),
    [anon_sym_let_BANG] = ACTIONS(5903),
    [anon_sym_LPAREN] = ACTIONS(5905),
    [anon_sym_null] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5905),
    [anon_sym_LBRACK] = ACTIONS(5905),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5905),
    [anon_sym_LT_AT] = ACTIONS(5905),
    [anon_sym_LT_AT_AT] = ACTIONS(5903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5903),
    [anon_sym_new] = ACTIONS(5905),
    [anon_sym_return_BANG] = ACTIONS(5903),
    [anon_sym_yield] = ACTIONS(5905),
    [anon_sym_yield_BANG] = ACTIONS(5903),
    [anon_sym_lazy] = ACTIONS(5905),
    [anon_sym_assert] = ACTIONS(5905),
    [anon_sym_upcast] = ACTIONS(5905),
    [anon_sym_downcast] = ACTIONS(5905),
    [anon_sym_for] = ACTIONS(5905),
    [anon_sym_while] = ACTIONS(5905),
    [anon_sym_if] = ACTIONS(5905),
    [anon_sym_fun] = ACTIONS(5905),
    [anon_sym_try] = ACTIONS(5905),
    [anon_sym_match] = ACTIONS(5905),
    [anon_sym_match_BANG] = ACTIONS(5903),
    [anon_sym_function] = ACTIONS(5905),
    [anon_sym_use] = ACTIONS(5905),
    [anon_sym_use_BANG] = ACTIONS(5903),
    [anon_sym_do_BANG] = ACTIONS(5903),
    [anon_sym_begin] = ACTIONS(5905),
    [aux_sym_char_token1] = ACTIONS(5903),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5905),
    [anon_sym_DQUOTE] = ACTIONS(5905),
    [anon_sym_AT_DQUOTE] = ACTIONS(5903),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5903),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5903),
    [sym_bool] = ACTIONS(5905),
    [sym_unit] = ACTIONS(5903),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5905),
    [sym_op_identifier] = ACTIONS(5903),
    [anon_sym_PLUS] = ACTIONS(5905),
    [anon_sym_DASH] = ACTIONS(5905),
    [anon_sym_PLUS_DOT] = ACTIONS(5903),
    [anon_sym_DASH_DOT] = ACTIONS(5903),
    [anon_sym_PERCENT] = ACTIONS(5903),
    [anon_sym_AMP_AMP] = ACTIONS(5903),
    [anon_sym_TILDE] = ACTIONS(5903),
    [aux_sym_prefix_op_token1] = ACTIONS(5903),
    [sym_int] = ACTIONS(5905),
    [sym_xint] = ACTIONS(5903),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5903),
    [anon_sym_POUNDload] = ACTIONS(5903),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5903),
    [sym__dedent] = ACTIONS(5903),
  },
  [3423] = {
    [sym_xml_doc] = STATE(3423),
    [sym_block_comment] = STATE(3423),
    [sym_line_comment] = STATE(3423),
    [sym_compiler_directive_decl] = STATE(3423),
    [sym_fsi_directive_decl] = STATE(3423),
    [sym_preproc_line] = STATE(3423),
    [sym_identifier] = ACTIONS(5874),
    [anon_sym_module] = ACTIONS(5874),
    [anon_sym_open] = ACTIONS(5874),
    [anon_sym_LBRACK_LT] = ACTIONS(5872),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_type] = ACTIONS(5874),
    [anon_sym_do] = ACTIONS(5874),
    [anon_sym_let] = ACTIONS(5874),
    [anon_sym_let_BANG] = ACTIONS(5872),
    [anon_sym_LPAREN] = ACTIONS(5874),
    [anon_sym_null] = ACTIONS(5874),
    [anon_sym_AMP] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5874),
    [anon_sym_LT_AT] = ACTIONS(5874),
    [anon_sym_LT_AT_AT] = ACTIONS(5872),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5872),
    [anon_sym_new] = ACTIONS(5874),
    [anon_sym_return_BANG] = ACTIONS(5872),
    [anon_sym_yield] = ACTIONS(5874),
    [anon_sym_yield_BANG] = ACTIONS(5872),
    [anon_sym_lazy] = ACTIONS(5874),
    [anon_sym_assert] = ACTIONS(5874),
    [anon_sym_upcast] = ACTIONS(5874),
    [anon_sym_downcast] = ACTIONS(5874),
    [anon_sym_for] = ACTIONS(5874),
    [anon_sym_while] = ACTIONS(5874),
    [anon_sym_if] = ACTIONS(5874),
    [anon_sym_fun] = ACTIONS(5874),
    [anon_sym_try] = ACTIONS(5874),
    [anon_sym_match] = ACTIONS(5874),
    [anon_sym_match_BANG] = ACTIONS(5872),
    [anon_sym_function] = ACTIONS(5874),
    [anon_sym_use] = ACTIONS(5874),
    [anon_sym_use_BANG] = ACTIONS(5872),
    [anon_sym_do_BANG] = ACTIONS(5872),
    [anon_sym_begin] = ACTIONS(5874),
    [aux_sym_char_token1] = ACTIONS(5872),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5874),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_AT_DQUOTE] = ACTIONS(5872),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5872),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5872),
    [sym_bool] = ACTIONS(5874),
    [sym_unit] = ACTIONS(5872),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5874),
    [sym_op_identifier] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_PLUS_DOT] = ACTIONS(5872),
    [anon_sym_DASH_DOT] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_AMP_AMP] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5872),
    [aux_sym_prefix_op_token1] = ACTIONS(5872),
    [sym_int] = ACTIONS(5874),
    [sym_xint] = ACTIONS(5872),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5872),
    [anon_sym_POUNDload] = ACTIONS(5872),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5872),
    [sym__dedent] = ACTIONS(5872),
  },
  [3424] = {
    [sym_xml_doc] = STATE(3424),
    [sym_block_comment] = STATE(3424),
    [sym_line_comment] = STATE(3424),
    [sym_compiler_directive_decl] = STATE(3424),
    [sym_fsi_directive_decl] = STATE(3424),
    [sym_preproc_line] = STATE(3424),
    [sym_identifier] = ACTIONS(5938),
    [anon_sym_module] = ACTIONS(5938),
    [anon_sym_open] = ACTIONS(5938),
    [anon_sym_LBRACK_LT] = ACTIONS(5936),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_type] = ACTIONS(5938),
    [anon_sym_do] = ACTIONS(5938),
    [anon_sym_let] = ACTIONS(5938),
    [anon_sym_let_BANG] = ACTIONS(5936),
    [anon_sym_LPAREN] = ACTIONS(5938),
    [anon_sym_null] = ACTIONS(5938),
    [anon_sym_AMP] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5938),
    [anon_sym_LT_AT] = ACTIONS(5938),
    [anon_sym_LT_AT_AT] = ACTIONS(5936),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5936),
    [anon_sym_new] = ACTIONS(5938),
    [anon_sym_return_BANG] = ACTIONS(5936),
    [anon_sym_yield] = ACTIONS(5938),
    [anon_sym_yield_BANG] = ACTIONS(5936),
    [anon_sym_lazy] = ACTIONS(5938),
    [anon_sym_assert] = ACTIONS(5938),
    [anon_sym_upcast] = ACTIONS(5938),
    [anon_sym_downcast] = ACTIONS(5938),
    [anon_sym_for] = ACTIONS(5938),
    [anon_sym_while] = ACTIONS(5938),
    [anon_sym_if] = ACTIONS(5938),
    [anon_sym_fun] = ACTIONS(5938),
    [anon_sym_try] = ACTIONS(5938),
    [anon_sym_match] = ACTIONS(5938),
    [anon_sym_match_BANG] = ACTIONS(5936),
    [anon_sym_function] = ACTIONS(5938),
    [anon_sym_use] = ACTIONS(5938),
    [anon_sym_use_BANG] = ACTIONS(5936),
    [anon_sym_do_BANG] = ACTIONS(5936),
    [anon_sym_begin] = ACTIONS(5938),
    [aux_sym_char_token1] = ACTIONS(5936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5938),
    [anon_sym_DQUOTE] = ACTIONS(5938),
    [anon_sym_AT_DQUOTE] = ACTIONS(5936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5936),
    [sym_bool] = ACTIONS(5938),
    [sym_unit] = ACTIONS(5936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5938),
    [sym_op_identifier] = ACTIONS(5936),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(5938),
    [anon_sym_PLUS_DOT] = ACTIONS(5936),
    [anon_sym_DASH_DOT] = ACTIONS(5936),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_AMP_AMP] = ACTIONS(5936),
    [anon_sym_TILDE] = ACTIONS(5936),
    [aux_sym_prefix_op_token1] = ACTIONS(5936),
    [sym_int] = ACTIONS(5938),
    [sym_xint] = ACTIONS(5936),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5936),
    [anon_sym_POUNDload] = ACTIONS(5936),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5936),
    [sym__dedent] = ACTIONS(5936),
  },
  [3425] = {
    [sym_xml_doc] = STATE(3425),
    [sym_block_comment] = STATE(3425),
    [sym_line_comment] = STATE(3425),
    [sym_compiler_directive_decl] = STATE(3425),
    [sym_fsi_directive_decl] = STATE(3425),
    [sym_preproc_line] = STATE(3425),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_module] = ACTIONS(4175),
    [anon_sym_open] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(4173),
    [anon_sym_return] = ACTIONS(4175),
    [anon_sym_type] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4175),
    [anon_sym_let] = ACTIONS(4175),
    [anon_sym_let_BANG] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_null] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4173),
    [anon_sym_LBRACE] = ACTIONS(4175),
    [anon_sym_LT_AT] = ACTIONS(4175),
    [anon_sym_LT_AT_AT] = ACTIONS(4173),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4173),
    [anon_sym_new] = ACTIONS(4175),
    [anon_sym_return_BANG] = ACTIONS(4173),
    [anon_sym_yield] = ACTIONS(4175),
    [anon_sym_yield_BANG] = ACTIONS(4173),
    [anon_sym_lazy] = ACTIONS(4175),
    [anon_sym_assert] = ACTIONS(4175),
    [anon_sym_upcast] = ACTIONS(4175),
    [anon_sym_downcast] = ACTIONS(4175),
    [anon_sym_for] = ACTIONS(4175),
    [anon_sym_while] = ACTIONS(4175),
    [anon_sym_if] = ACTIONS(4175),
    [anon_sym_fun] = ACTIONS(4175),
    [anon_sym_try] = ACTIONS(4175),
    [anon_sym_match] = ACTIONS(4175),
    [anon_sym_match_BANG] = ACTIONS(4173),
    [anon_sym_function] = ACTIONS(4175),
    [anon_sym_use] = ACTIONS(4175),
    [anon_sym_use_BANG] = ACTIONS(4173),
    [anon_sym_do_BANG] = ACTIONS(4173),
    [anon_sym_begin] = ACTIONS(4175),
    [aux_sym_char_token1] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(4175),
    [anon_sym_AT_DQUOTE] = ACTIONS(4173),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4173),
    [sym_bool] = ACTIONS(4175),
    [sym_unit] = ACTIONS(4173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4175),
    [sym_op_identifier] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_PLUS_DOT] = ACTIONS(4173),
    [anon_sym_DASH_DOT] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4173),
    [anon_sym_TILDE] = ACTIONS(4173),
    [aux_sym_prefix_op_token1] = ACTIONS(4173),
    [sym_int] = ACTIONS(4175),
    [sym_xint] = ACTIONS(4173),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4173),
    [anon_sym_POUNDload] = ACTIONS(4173),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(4173),
    [sym__dedent] = ACTIONS(4173),
  },
  [3426] = {
    [sym_xml_doc] = STATE(3426),
    [sym_block_comment] = STATE(3426),
    [sym_line_comment] = STATE(3426),
    [sym_compiler_directive_decl] = STATE(3426),
    [sym_fsi_directive_decl] = STATE(3426),
    [sym_preproc_line] = STATE(3426),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_open] = ACTIONS(299),
    [anon_sym_LBRACK_LT] = ACTIONS(297),
    [anon_sym_return] = ACTIONS(299),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(299),
    [anon_sym_let] = ACTIONS(299),
    [anon_sym_let_BANG] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LBRACK_PIPE] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_LT_AT] = ACTIONS(299),
    [anon_sym_LT_AT_AT] = ACTIONS(297),
    [anon_sym_LBRACE_PIPE] = ACTIONS(297),
    [anon_sym_new] = ACTIONS(299),
    [anon_sym_return_BANG] = ACTIONS(297),
    [anon_sym_yield] = ACTIONS(299),
    [anon_sym_yield_BANG] = ACTIONS(297),
    [anon_sym_lazy] = ACTIONS(299),
    [anon_sym_assert] = ACTIONS(299),
    [anon_sym_upcast] = ACTIONS(299),
    [anon_sym_downcast] = ACTIONS(299),
    [anon_sym_for] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_fun] = ACTIONS(299),
    [anon_sym_try] = ACTIONS(299),
    [anon_sym_match] = ACTIONS(299),
    [anon_sym_match_BANG] = ACTIONS(297),
    [anon_sym_function] = ACTIONS(299),
    [anon_sym_use] = ACTIONS(299),
    [anon_sym_use_BANG] = ACTIONS(297),
    [anon_sym_do_BANG] = ACTIONS(297),
    [anon_sym_begin] = ACTIONS(299),
    [aux_sym_char_token1] = ACTIONS(297),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [anon_sym_AT_DQUOTE] = ACTIONS(297),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(297),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(297),
    [sym_bool] = ACTIONS(299),
    [sym_unit] = ACTIONS(297),
    [anon_sym_LPAREN_PIPE] = ACTIONS(299),
    [sym_op_identifier] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(299),
    [anon_sym_DASH] = ACTIONS(299),
    [anon_sym_PLUS_DOT] = ACTIONS(297),
    [anon_sym_DASH_DOT] = ACTIONS(297),
    [anon_sym_PERCENT] = ACTIONS(297),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(297),
    [aux_sym_prefix_op_token1] = ACTIONS(297),
    [sym_int] = ACTIONS(299),
    [sym_xint] = ACTIONS(297),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(297),
    [anon_sym_POUNDload] = ACTIONS(297),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(297),
    [sym__dedent] = ACTIONS(297),
  },
  [3427] = {
    [sym_xml_doc] = STATE(3427),
    [sym_block_comment] = STATE(3427),
    [sym_line_comment] = STATE(3427),
    [sym_compiler_directive_decl] = STATE(3427),
    [sym_fsi_directive_decl] = STATE(3427),
    [sym_preproc_line] = STATE(3427),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_module] = ACTIONS(5913),
    [anon_sym_open] = ACTIONS(5913),
    [anon_sym_LBRACK_LT] = ACTIONS(5911),
    [anon_sym_return] = ACTIONS(5913),
    [anon_sym_type] = ACTIONS(5913),
    [anon_sym_do] = ACTIONS(5913),
    [anon_sym_let] = ACTIONS(5913),
    [anon_sym_let_BANG] = ACTIONS(5911),
    [anon_sym_LPAREN] = ACTIONS(5913),
    [anon_sym_null] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_LBRACK] = ACTIONS(5913),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5911),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_LT_AT] = ACTIONS(5913),
    [anon_sym_LT_AT_AT] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5911),
    [anon_sym_new] = ACTIONS(5913),
    [anon_sym_return_BANG] = ACTIONS(5911),
    [anon_sym_yield] = ACTIONS(5913),
    [anon_sym_yield_BANG] = ACTIONS(5911),
    [anon_sym_lazy] = ACTIONS(5913),
    [anon_sym_assert] = ACTIONS(5913),
    [anon_sym_upcast] = ACTIONS(5913),
    [anon_sym_downcast] = ACTIONS(5913),
    [anon_sym_for] = ACTIONS(5913),
    [anon_sym_while] = ACTIONS(5913),
    [anon_sym_if] = ACTIONS(5913),
    [anon_sym_fun] = ACTIONS(5913),
    [anon_sym_try] = ACTIONS(5913),
    [anon_sym_match] = ACTIONS(5913),
    [anon_sym_match_BANG] = ACTIONS(5911),
    [anon_sym_function] = ACTIONS(5913),
    [anon_sym_use] = ACTIONS(5913),
    [anon_sym_use_BANG] = ACTIONS(5911),
    [anon_sym_do_BANG] = ACTIONS(5911),
    [anon_sym_begin] = ACTIONS(5913),
    [aux_sym_char_token1] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5913),
    [anon_sym_DQUOTE] = ACTIONS(5913),
    [anon_sym_AT_DQUOTE] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [sym_bool] = ACTIONS(5913),
    [sym_unit] = ACTIONS(5911),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5913),
    [sym_op_identifier] = ACTIONS(5911),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS_DOT] = ACTIONS(5911),
    [anon_sym_DASH_DOT] = ACTIONS(5911),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5911),
    [aux_sym_prefix_op_token1] = ACTIONS(5911),
    [sym_int] = ACTIONS(5913),
    [sym_xint] = ACTIONS(5911),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5911),
    [anon_sym_POUNDload] = ACTIONS(5911),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5911),
    [sym__dedent] = ACTIONS(5911),
  },
  [3428] = {
    [sym_xml_doc] = STATE(3428),
    [sym_block_comment] = STATE(3428),
    [sym_line_comment] = STATE(3428),
    [sym_compiler_directive_decl] = STATE(3428),
    [sym_fsi_directive_decl] = STATE(3428),
    [sym_preproc_line] = STATE(3428),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3324),
    [anon_sym_DASH_DOT] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3324),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
    [sym__dedent] = ACTIONS(3324),
  },
  [3429] = {
    [sym_xml_doc] = STATE(3429),
    [sym_block_comment] = STATE(3429),
    [sym_line_comment] = STATE(3429),
    [sym_compiler_directive_decl] = STATE(3429),
    [sym_fsi_directive_decl] = STATE(3429),
    [sym_preproc_line] = STATE(3429),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_GT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3389),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3389),
    [anon_sym_DASH_DOT] = ACTIONS(3389),
    [anon_sym_PERCENT] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3389),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [aux_sym_float_token1] = ACTIONS(5940),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
  },
  [3430] = {
    [sym_xml_doc] = STATE(3430),
    [sym_block_comment] = STATE(3430),
    [sym_line_comment] = STATE(3430),
    [sym_compiler_directive_decl] = STATE(3430),
    [sym_fsi_directive_decl] = STATE(3430),
    [sym_preproc_line] = STATE(3430),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3342),
    [anon_sym_DASH_DOT] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3342),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
    [sym__dedent] = ACTIONS(3342),
  },
  [3431] = {
    [sym_xml_doc] = STATE(3431),
    [sym_block_comment] = STATE(3431),
    [sym_line_comment] = STATE(3431),
    [sym_compiler_directive_decl] = STATE(3431),
    [sym_fsi_directive_decl] = STATE(3431),
    [sym_preproc_line] = STATE(3431),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3338),
    [anon_sym_DASH_DOT] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3338),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
    [sym__dedent] = ACTIONS(3338),
  },
  [3432] = {
    [sym_xml_doc] = STATE(3432),
    [sym_block_comment] = STATE(3432),
    [sym_line_comment] = STATE(3432),
    [sym_compiler_directive_decl] = STATE(3432),
    [sym_fsi_directive_decl] = STATE(3432),
    [sym_preproc_line] = STATE(3432),
    [aux_sym__compound_type_repeat1] = STATE(3432),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_let_BANG] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_null] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_LT_AT] = ACTIONS(3032),
    [anon_sym_LT_AT_AT] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_return_BANG] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_yield_BANG] = ACTIONS(3030),
    [anon_sym_lazy] = ACTIONS(3032),
    [anon_sym_assert] = ACTIONS(3032),
    [anon_sym_upcast] = ACTIONS(3032),
    [anon_sym_downcast] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_fun] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_match] = ACTIONS(3032),
    [anon_sym_match_BANG] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_use] = ACTIONS(3032),
    [anon_sym_use_BANG] = ACTIONS(3030),
    [anon_sym_do_BANG] = ACTIONS(3030),
    [anon_sym_begin] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(5942),
    [anon_sym_LT2] = ACTIONS(3032),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3030),
    [aux_sym_char_token1] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_AT_DQUOTE] = ACTIONS(3030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3030),
    [sym_bool] = ACTIONS(3032),
    [sym_unit] = ACTIONS(3030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3032),
    [sym_op_identifier] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_DOT] = ACTIONS(3030),
    [anon_sym_DASH_DOT] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [aux_sym_prefix_op_token1] = ACTIONS(3030),
    [sym_int] = ACTIONS(3032),
    [sym_xint] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3030),
  },
  [3433] = {
    [sym_xml_doc] = STATE(3433),
    [sym_block_comment] = STATE(3433),
    [sym_line_comment] = STATE(3433),
    [sym_compiler_directive_decl] = STATE(3433),
    [sym_fsi_directive_decl] = STATE(3433),
    [sym_preproc_line] = STATE(3433),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_COLON_GT] = ACTIONS(5945),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
  },
  [3434] = {
    [sym_xml_doc] = STATE(3434),
    [sym_block_comment] = STATE(3434),
    [sym_line_comment] = STATE(3434),
    [sym_compiler_directive_decl] = STATE(3434),
    [sym_fsi_directive_decl] = STATE(3434),
    [sym_preproc_line] = STATE(3434),
    [sym_identifier] = ACTIONS(5830),
    [anon_sym_module] = ACTIONS(5830),
    [anon_sym_open] = ACTIONS(5830),
    [anon_sym_LBRACK_LT] = ACTIONS(5828),
    [anon_sym_return] = ACTIONS(5830),
    [anon_sym_type] = ACTIONS(5830),
    [anon_sym_do] = ACTIONS(5830),
    [anon_sym_let] = ACTIONS(5830),
    [anon_sym_let_BANG] = ACTIONS(5828),
    [anon_sym_LPAREN] = ACTIONS(5830),
    [anon_sym_null] = ACTIONS(5830),
    [anon_sym_AMP] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5830),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5828),
    [anon_sym_LBRACE] = ACTIONS(5830),
    [anon_sym_LT_AT] = ACTIONS(5830),
    [anon_sym_LT_AT_AT] = ACTIONS(5828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5828),
    [anon_sym_new] = ACTIONS(5830),
    [anon_sym_return_BANG] = ACTIONS(5828),
    [anon_sym_yield] = ACTIONS(5830),
    [anon_sym_yield_BANG] = ACTIONS(5828),
    [anon_sym_lazy] = ACTIONS(5830),
    [anon_sym_assert] = ACTIONS(5830),
    [anon_sym_upcast] = ACTIONS(5830),
    [anon_sym_downcast] = ACTIONS(5830),
    [anon_sym_for] = ACTIONS(5830),
    [anon_sym_while] = ACTIONS(5830),
    [anon_sym_if] = ACTIONS(5830),
    [anon_sym_fun] = ACTIONS(5830),
    [anon_sym_try] = ACTIONS(5830),
    [anon_sym_match] = ACTIONS(5830),
    [anon_sym_match_BANG] = ACTIONS(5828),
    [anon_sym_function] = ACTIONS(5830),
    [anon_sym_use] = ACTIONS(5830),
    [anon_sym_use_BANG] = ACTIONS(5828),
    [anon_sym_do_BANG] = ACTIONS(5828),
    [anon_sym_begin] = ACTIONS(5830),
    [aux_sym_char_token1] = ACTIONS(5828),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5830),
    [anon_sym_DQUOTE] = ACTIONS(5830),
    [anon_sym_AT_DQUOTE] = ACTIONS(5828),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5828),
    [sym_bool] = ACTIONS(5830),
    [sym_unit] = ACTIONS(5828),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5830),
    [sym_op_identifier] = ACTIONS(5828),
    [anon_sym_PLUS] = ACTIONS(5830),
    [anon_sym_DASH] = ACTIONS(5830),
    [anon_sym_PLUS_DOT] = ACTIONS(5828),
    [anon_sym_DASH_DOT] = ACTIONS(5828),
    [anon_sym_PERCENT] = ACTIONS(5828),
    [anon_sym_AMP_AMP] = ACTIONS(5828),
    [anon_sym_TILDE] = ACTIONS(5828),
    [aux_sym_prefix_op_token1] = ACTIONS(5828),
    [sym_int] = ACTIONS(5830),
    [sym_xint] = ACTIONS(5828),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5828),
    [anon_sym_POUNDload] = ACTIONS(5828),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5828),
    [sym__dedent] = ACTIONS(5828),
  },
  [3435] = {
    [sym_xml_doc] = STATE(3435),
    [sym_block_comment] = STATE(3435),
    [sym_line_comment] = STATE(3435),
    [sym_compiler_directive_decl] = STATE(3435),
    [sym_fsi_directive_decl] = STATE(3435),
    [sym_preproc_line] = STATE(3435),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_module] = ACTIONS(5913),
    [anon_sym_open] = ACTIONS(5913),
    [anon_sym_LBRACK_LT] = ACTIONS(5911),
    [anon_sym_return] = ACTIONS(5913),
    [anon_sym_type] = ACTIONS(5913),
    [anon_sym_do] = ACTIONS(5913),
    [anon_sym_let] = ACTIONS(5913),
    [anon_sym_let_BANG] = ACTIONS(5911),
    [anon_sym_LPAREN] = ACTIONS(5913),
    [anon_sym_null] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_LBRACK] = ACTIONS(5913),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5911),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_LT_AT] = ACTIONS(5913),
    [anon_sym_LT_AT_AT] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5911),
    [anon_sym_new] = ACTIONS(5913),
    [anon_sym_return_BANG] = ACTIONS(5911),
    [anon_sym_yield] = ACTIONS(5913),
    [anon_sym_yield_BANG] = ACTIONS(5911),
    [anon_sym_lazy] = ACTIONS(5913),
    [anon_sym_assert] = ACTIONS(5913),
    [anon_sym_upcast] = ACTIONS(5913),
    [anon_sym_downcast] = ACTIONS(5913),
    [anon_sym_for] = ACTIONS(5913),
    [anon_sym_while] = ACTIONS(5913),
    [anon_sym_if] = ACTIONS(5913),
    [anon_sym_fun] = ACTIONS(5913),
    [anon_sym_try] = ACTIONS(5913),
    [anon_sym_match] = ACTIONS(5913),
    [anon_sym_match_BANG] = ACTIONS(5911),
    [anon_sym_function] = ACTIONS(5913),
    [anon_sym_use] = ACTIONS(5913),
    [anon_sym_use_BANG] = ACTIONS(5911),
    [anon_sym_do_BANG] = ACTIONS(5911),
    [anon_sym_begin] = ACTIONS(5913),
    [aux_sym_char_token1] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5913),
    [anon_sym_DQUOTE] = ACTIONS(5913),
    [anon_sym_AT_DQUOTE] = ACTIONS(5911),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5911),
    [sym_bool] = ACTIONS(5913),
    [sym_unit] = ACTIONS(5911),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5913),
    [sym_op_identifier] = ACTIONS(5911),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS_DOT] = ACTIONS(5911),
    [anon_sym_DASH_DOT] = ACTIONS(5911),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_TILDE] = ACTIONS(5911),
    [aux_sym_prefix_op_token1] = ACTIONS(5911),
    [sym_int] = ACTIONS(5913),
    [sym_xint] = ACTIONS(5911),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5911),
    [anon_sym_POUNDload] = ACTIONS(5911),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5911),
    [sym__dedent] = ACTIONS(5911),
  },
  [3436] = {
    [sym_xml_doc] = STATE(3436),
    [sym_block_comment] = STATE(3436),
    [sym_line_comment] = STATE(3436),
    [sym_compiler_directive_decl] = STATE(3436),
    [sym_fsi_directive_decl] = STATE(3436),
    [sym_preproc_line] = STATE(3436),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_open] = ACTIONS(2415),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2415),
    [anon_sym_AMP] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_LT_AT] = ACTIONS(2415),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2415),
    [anon_sym_assert] = ACTIONS(2415),
    [anon_sym_upcast] = ACTIONS(2415),
    [anon_sym_downcast] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_fun] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_match] = ACTIONS(2415),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_use] = ACTIONS(2415),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2415),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2415),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2415),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2415),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2413),
    [anon_sym_POUNDload] = ACTIONS(2413),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [3437] = {
    [sym_xml_doc] = STATE(3437),
    [sym_block_comment] = STATE(3437),
    [sym_line_comment] = STATE(3437),
    [sym_compiler_directive_decl] = STATE(3437),
    [sym_fsi_directive_decl] = STATE(3437),
    [sym_preproc_line] = STATE(3437),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LT2] = ACTIONS(5947),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3357),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3357),
    [anon_sym_DASH_DOT] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3357),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
    [sym__dedent] = ACTIONS(3357),
  },
  [3438] = {
    [sym_xml_doc] = STATE(3438),
    [sym_block_comment] = STATE(3438),
    [sym_line_comment] = STATE(3438),
    [sym_compiler_directive_decl] = STATE(3438),
    [sym_fsi_directive_decl] = STATE(3438),
    [sym_preproc_line] = STATE(3438),
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_let_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_null] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3242),
    [anon_sym_LT_AT] = ACTIONS(3242),
    [anon_sym_LT_AT_AT] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3244),
    [anon_sym_new] = ACTIONS(3242),
    [anon_sym_return_BANG] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3242),
    [anon_sym_yield_BANG] = ACTIONS(3244),
    [anon_sym_lazy] = ACTIONS(3242),
    [anon_sym_assert] = ACTIONS(3242),
    [anon_sym_upcast] = ACTIONS(3242),
    [anon_sym_downcast] = ACTIONS(3242),
    [anon_sym_COLON_GT] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3242),
    [anon_sym_fun] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_match] = ACTIONS(3242),
    [anon_sym_match_BANG] = ACTIONS(3244),
    [anon_sym_function] = ACTIONS(3242),
    [anon_sym_use] = ACTIONS(3242),
    [anon_sym_use_BANG] = ACTIONS(3244),
    [anon_sym_do_BANG] = ACTIONS(3244),
    [anon_sym_begin] = ACTIONS(3242),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [aux_sym_char_token1] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_AT_DQUOTE] = ACTIONS(3244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3244),
    [sym_bool] = ACTIONS(3242),
    [sym_unit] = ACTIONS(3244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3242),
    [sym_op_identifier] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_PLUS_DOT] = ACTIONS(3244),
    [anon_sym_DASH_DOT] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3244),
    [anon_sym_TILDE] = ACTIONS(3244),
    [aux_sym_prefix_op_token1] = ACTIONS(3244),
    [sym_int] = ACTIONS(3242),
    [sym_xint] = ACTIONS(3244),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3244),
  },
  [3439] = {
    [sym_xml_doc] = STATE(3439),
    [sym_block_comment] = STATE(3439),
    [sym_line_comment] = STATE(3439),
    [sym_compiler_directive_decl] = STATE(3439),
    [sym_fsi_directive_decl] = STATE(3439),
    [sym_preproc_line] = STATE(3439),
    [sym_identifier] = ACTIONS(5860),
    [anon_sym_module] = ACTIONS(5860),
    [anon_sym_open] = ACTIONS(5860),
    [anon_sym_LBRACK_LT] = ACTIONS(5858),
    [anon_sym_return] = ACTIONS(5860),
    [anon_sym_type] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_let] = ACTIONS(5860),
    [anon_sym_let_BANG] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_null] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_LT_AT] = ACTIONS(5860),
    [anon_sym_LT_AT_AT] = ACTIONS(5858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5858),
    [anon_sym_new] = ACTIONS(5860),
    [anon_sym_return_BANG] = ACTIONS(5858),
    [anon_sym_yield] = ACTIONS(5860),
    [anon_sym_yield_BANG] = ACTIONS(5858),
    [anon_sym_lazy] = ACTIONS(5860),
    [anon_sym_assert] = ACTIONS(5860),
    [anon_sym_upcast] = ACTIONS(5860),
    [anon_sym_downcast] = ACTIONS(5860),
    [anon_sym_for] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_fun] = ACTIONS(5860),
    [anon_sym_try] = ACTIONS(5860),
    [anon_sym_match] = ACTIONS(5860),
    [anon_sym_match_BANG] = ACTIONS(5858),
    [anon_sym_function] = ACTIONS(5860),
    [anon_sym_use] = ACTIONS(5860),
    [anon_sym_use_BANG] = ACTIONS(5858),
    [anon_sym_do_BANG] = ACTIONS(5858),
    [anon_sym_begin] = ACTIONS(5860),
    [aux_sym_char_token1] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5860),
    [anon_sym_DQUOTE] = ACTIONS(5860),
    [anon_sym_AT_DQUOTE] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [sym_bool] = ACTIONS(5860),
    [sym_unit] = ACTIONS(5858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5860),
    [sym_op_identifier] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_PLUS_DOT] = ACTIONS(5858),
    [anon_sym_DASH_DOT] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_TILDE] = ACTIONS(5858),
    [aux_sym_prefix_op_token1] = ACTIONS(5858),
    [sym_int] = ACTIONS(5860),
    [sym_xint] = ACTIONS(5858),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5858),
    [anon_sym_POUNDload] = ACTIONS(5858),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5858),
    [sym__dedent] = ACTIONS(5858),
  },
  [3440] = {
    [sym_xml_doc] = STATE(3440),
    [sym_block_comment] = STATE(3440),
    [sym_line_comment] = STATE(3440),
    [sym_compiler_directive_decl] = STATE(3440),
    [sym_fsi_directive_decl] = STATE(3440),
    [sym_preproc_line] = STATE(3440),
    [aux_sym__compound_type_repeat1] = STATE(3432),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_let_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_null] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_LT_AT] = ACTIONS(3212),
    [anon_sym_LT_AT_AT] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_return_BANG] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_yield_BANG] = ACTIONS(3214),
    [anon_sym_lazy] = ACTIONS(3212),
    [anon_sym_assert] = ACTIONS(3212),
    [anon_sym_upcast] = ACTIONS(3212),
    [anon_sym_downcast] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_fun] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_match] = ACTIONS(3212),
    [anon_sym_match_BANG] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_use] = ACTIONS(3212),
    [anon_sym_use_BANG] = ACTIONS(3214),
    [anon_sym_do_BANG] = ACTIONS(3214),
    [anon_sym_begin] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(2367),
    [anon_sym_LT2] = ACTIONS(3212),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3214),
    [aux_sym_char_token1] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3214),
    [sym_bool] = ACTIONS(3212),
    [sym_unit] = ACTIONS(3214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3212),
    [sym_op_identifier] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_DOT] = ACTIONS(3214),
    [anon_sym_DASH_DOT] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [aux_sym_prefix_op_token1] = ACTIONS(3214),
    [sym_int] = ACTIONS(3212),
    [sym_xint] = ACTIONS(3214),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3214),
  },
  [3441] = {
    [sym_xml_doc] = STATE(3441),
    [sym_block_comment] = STATE(3441),
    [sym_line_comment] = STATE(3441),
    [sym_compiler_directive_decl] = STATE(3441),
    [sym_fsi_directive_decl] = STATE(3441),
    [sym_preproc_line] = STATE(3441),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3310),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3310),
    [anon_sym_DASH_DOT] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3310),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
    [sym__dedent] = ACTIONS(3310),
  },
  [3442] = {
    [sym_xml_doc] = STATE(3442),
    [sym_block_comment] = STATE(3442),
    [sym_line_comment] = STATE(3442),
    [sym_compiler_directive_decl] = STATE(3442),
    [sym_fsi_directive_decl] = STATE(3442),
    [sym_preproc_line] = STATE(3442),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3306),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3306),
    [anon_sym_DASH_DOT] = ACTIONS(3306),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3306),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
    [sym__dedent] = ACTIONS(3306),
  },
  [3443] = {
    [sym_xml_doc] = STATE(3443),
    [sym_block_comment] = STATE(3443),
    [sym_line_comment] = STATE(3443),
    [sym_compiler_directive_decl] = STATE(3443),
    [sym_fsi_directive_decl] = STATE(3443),
    [sym_preproc_line] = STATE(3443),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3302),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3302),
    [anon_sym_DASH_DOT] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3302),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
    [sym__dedent] = ACTIONS(3302),
  },
  [3444] = {
    [sym_xml_doc] = STATE(3444),
    [sym_block_comment] = STATE(3444),
    [sym_line_comment] = STATE(3444),
    [sym_compiler_directive_decl] = STATE(3444),
    [sym_fsi_directive_decl] = STATE(3444),
    [sym_preproc_line] = STATE(3444),
    [sym_identifier] = ACTIONS(5888),
    [anon_sym_module] = ACTIONS(5888),
    [anon_sym_open] = ACTIONS(5888),
    [anon_sym_LBRACK_LT] = ACTIONS(5886),
    [anon_sym_return] = ACTIONS(5888),
    [anon_sym_type] = ACTIONS(5888),
    [anon_sym_do] = ACTIONS(5888),
    [anon_sym_let] = ACTIONS(5888),
    [anon_sym_let_BANG] = ACTIONS(5886),
    [anon_sym_LPAREN] = ACTIONS(5888),
    [anon_sym_null] = ACTIONS(5888),
    [anon_sym_AMP] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5886),
    [anon_sym_LBRACE] = ACTIONS(5888),
    [anon_sym_LT_AT] = ACTIONS(5888),
    [anon_sym_LT_AT_AT] = ACTIONS(5886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5886),
    [anon_sym_new] = ACTIONS(5888),
    [anon_sym_return_BANG] = ACTIONS(5886),
    [anon_sym_yield] = ACTIONS(5888),
    [anon_sym_yield_BANG] = ACTIONS(5886),
    [anon_sym_lazy] = ACTIONS(5888),
    [anon_sym_assert] = ACTIONS(5888),
    [anon_sym_upcast] = ACTIONS(5888),
    [anon_sym_downcast] = ACTIONS(5888),
    [anon_sym_for] = ACTIONS(5888),
    [anon_sym_while] = ACTIONS(5888),
    [anon_sym_if] = ACTIONS(5888),
    [anon_sym_fun] = ACTIONS(5888),
    [anon_sym_try] = ACTIONS(5888),
    [anon_sym_match] = ACTIONS(5888),
    [anon_sym_match_BANG] = ACTIONS(5886),
    [anon_sym_function] = ACTIONS(5888),
    [anon_sym_use] = ACTIONS(5888),
    [anon_sym_use_BANG] = ACTIONS(5886),
    [anon_sym_do_BANG] = ACTIONS(5886),
    [anon_sym_begin] = ACTIONS(5888),
    [aux_sym_char_token1] = ACTIONS(5886),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5888),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_AT_DQUOTE] = ACTIONS(5886),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5886),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5886),
    [sym_bool] = ACTIONS(5888),
    [sym_unit] = ACTIONS(5886),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5888),
    [sym_op_identifier] = ACTIONS(5886),
    [anon_sym_PLUS] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_PLUS_DOT] = ACTIONS(5886),
    [anon_sym_DASH_DOT] = ACTIONS(5886),
    [anon_sym_PERCENT] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5886),
    [aux_sym_prefix_op_token1] = ACTIONS(5886),
    [sym_int] = ACTIONS(5888),
    [sym_xint] = ACTIONS(5886),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5886),
    [anon_sym_POUNDload] = ACTIONS(5886),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5886),
    [sym__dedent] = ACTIONS(5886),
  },
  [3445] = {
    [sym_xml_doc] = STATE(3445),
    [sym_block_comment] = STATE(3445),
    [sym_line_comment] = STATE(3445),
    [sym_compiler_directive_decl] = STATE(3445),
    [sym_fsi_directive_decl] = STATE(3445),
    [sym_preproc_line] = STATE(3445),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3294),
    [anon_sym_DASH_DOT] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3294),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
    [sym__dedent] = ACTIONS(3294),
  },
  [3446] = {
    [sym_xml_doc] = STATE(3446),
    [sym_block_comment] = STATE(3446),
    [sym_line_comment] = STATE(3446),
    [sym_compiler_directive_decl] = STATE(3446),
    [sym_fsi_directive_decl] = STATE(3446),
    [sym_preproc_line] = STATE(3446),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3320),
    [anon_sym_DASH_DOT] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3320),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
    [sym__dedent] = ACTIONS(3320),
  },
  [3447] = {
    [sym_xml_doc] = STATE(3447),
    [sym_block_comment] = STATE(3447),
    [sym_line_comment] = STATE(3447),
    [sym_compiler_directive_decl] = STATE(3447),
    [sym_fsi_directive_decl] = STATE(3447),
    [sym_preproc_line] = STATE(3447),
    [sym_identifier] = ACTIONS(5856),
    [anon_sym_module] = ACTIONS(5856),
    [anon_sym_open] = ACTIONS(5856),
    [anon_sym_LBRACK_LT] = ACTIONS(5854),
    [anon_sym_return] = ACTIONS(5856),
    [anon_sym_type] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_let] = ACTIONS(5856),
    [anon_sym_let_BANG] = ACTIONS(5854),
    [anon_sym_LPAREN] = ACTIONS(5856),
    [anon_sym_null] = ACTIONS(5856),
    [anon_sym_AMP] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5854),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_LT_AT] = ACTIONS(5856),
    [anon_sym_LT_AT_AT] = ACTIONS(5854),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5854),
    [anon_sym_new] = ACTIONS(5856),
    [anon_sym_return_BANG] = ACTIONS(5854),
    [anon_sym_yield] = ACTIONS(5856),
    [anon_sym_yield_BANG] = ACTIONS(5854),
    [anon_sym_lazy] = ACTIONS(5856),
    [anon_sym_assert] = ACTIONS(5856),
    [anon_sym_upcast] = ACTIONS(5856),
    [anon_sym_downcast] = ACTIONS(5856),
    [anon_sym_for] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_fun] = ACTIONS(5856),
    [anon_sym_try] = ACTIONS(5856),
    [anon_sym_match] = ACTIONS(5856),
    [anon_sym_match_BANG] = ACTIONS(5854),
    [anon_sym_function] = ACTIONS(5856),
    [anon_sym_use] = ACTIONS(5856),
    [anon_sym_use_BANG] = ACTIONS(5854),
    [anon_sym_do_BANG] = ACTIONS(5854),
    [anon_sym_begin] = ACTIONS(5856),
    [aux_sym_char_token1] = ACTIONS(5854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5856),
    [anon_sym_DQUOTE] = ACTIONS(5856),
    [anon_sym_AT_DQUOTE] = ACTIONS(5854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5854),
    [sym_bool] = ACTIONS(5856),
    [sym_unit] = ACTIONS(5854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5856),
    [sym_op_identifier] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5856),
    [anon_sym_PLUS_DOT] = ACTIONS(5854),
    [anon_sym_DASH_DOT] = ACTIONS(5854),
    [anon_sym_PERCENT] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_TILDE] = ACTIONS(5854),
    [aux_sym_prefix_op_token1] = ACTIONS(5854),
    [sym_int] = ACTIONS(5856),
    [sym_xint] = ACTIONS(5854),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5854),
    [anon_sym_POUNDload] = ACTIONS(5854),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5854),
    [sym__dedent] = ACTIONS(5854),
  },
  [3448] = {
    [sym_xml_doc] = STATE(3448),
    [sym_block_comment] = STATE(3448),
    [sym_line_comment] = STATE(3448),
    [sym_compiler_directive_decl] = STATE(3448),
    [sym_fsi_directive_decl] = STATE(3448),
    [sym_preproc_line] = STATE(3448),
    [sym_identifier] = ACTIONS(5844),
    [anon_sym_module] = ACTIONS(5844),
    [anon_sym_open] = ACTIONS(5844),
    [anon_sym_LBRACK_LT] = ACTIONS(5842),
    [anon_sym_return] = ACTIONS(5844),
    [anon_sym_type] = ACTIONS(5844),
    [anon_sym_do] = ACTIONS(5844),
    [anon_sym_let] = ACTIONS(5844),
    [anon_sym_let_BANG] = ACTIONS(5842),
    [anon_sym_LPAREN] = ACTIONS(5844),
    [anon_sym_null] = ACTIONS(5844),
    [anon_sym_AMP] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5842),
    [anon_sym_LBRACE] = ACTIONS(5844),
    [anon_sym_LT_AT] = ACTIONS(5844),
    [anon_sym_LT_AT_AT] = ACTIONS(5842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5842),
    [anon_sym_new] = ACTIONS(5844),
    [anon_sym_return_BANG] = ACTIONS(5842),
    [anon_sym_yield] = ACTIONS(5844),
    [anon_sym_yield_BANG] = ACTIONS(5842),
    [anon_sym_lazy] = ACTIONS(5844),
    [anon_sym_assert] = ACTIONS(5844),
    [anon_sym_upcast] = ACTIONS(5844),
    [anon_sym_downcast] = ACTIONS(5844),
    [anon_sym_for] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_fun] = ACTIONS(5844),
    [anon_sym_try] = ACTIONS(5844),
    [anon_sym_match] = ACTIONS(5844),
    [anon_sym_match_BANG] = ACTIONS(5842),
    [anon_sym_function] = ACTIONS(5844),
    [anon_sym_use] = ACTIONS(5844),
    [anon_sym_use_BANG] = ACTIONS(5842),
    [anon_sym_do_BANG] = ACTIONS(5842),
    [anon_sym_begin] = ACTIONS(5844),
    [aux_sym_char_token1] = ACTIONS(5842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5844),
    [anon_sym_DQUOTE] = ACTIONS(5844),
    [anon_sym_AT_DQUOTE] = ACTIONS(5842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5842),
    [sym_bool] = ACTIONS(5844),
    [sym_unit] = ACTIONS(5842),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5844),
    [sym_op_identifier] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_PLUS_DOT] = ACTIONS(5842),
    [anon_sym_DASH_DOT] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5842),
    [aux_sym_prefix_op_token1] = ACTIONS(5842),
    [sym_int] = ACTIONS(5844),
    [sym_xint] = ACTIONS(5842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5842),
    [anon_sym_POUNDload] = ACTIONS(5842),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5842),
    [sym__dedent] = ACTIONS(5842),
  },
  [3449] = {
    [sym_xml_doc] = STATE(3449),
    [sym_block_comment] = STATE(3449),
    [sym_line_comment] = STATE(3449),
    [sym_compiler_directive_decl] = STATE(3449),
    [sym_fsi_directive_decl] = STATE(3449),
    [sym_preproc_line] = STATE(3449),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_let_BANG] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_null] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_LT_AT] = ACTIONS(3285),
    [anon_sym_LT_AT_AT] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_return_BANG] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_yield_BANG] = ACTIONS(3287),
    [anon_sym_lazy] = ACTIONS(3285),
    [anon_sym_assert] = ACTIONS(3285),
    [anon_sym_upcast] = ACTIONS(3285),
    [anon_sym_downcast] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_fun] = ACTIONS(3285),
    [anon_sym_DASH_GT] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_match] = ACTIONS(3285),
    [anon_sym_match_BANG] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_use] = ACTIONS(3285),
    [anon_sym_use_BANG] = ACTIONS(3287),
    [anon_sym_do_BANG] = ACTIONS(3287),
    [anon_sym_begin] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_LT2] = ACTIONS(3285),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3287),
    [aux_sym_char_token1] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_AT_DQUOTE] = ACTIONS(3287),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [sym_bool] = ACTIONS(3285),
    [sym_unit] = ACTIONS(3287),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3285),
    [sym_op_identifier] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_PLUS_DOT] = ACTIONS(3287),
    [anon_sym_DASH_DOT] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [aux_sym_prefix_op_token1] = ACTIONS(3287),
    [sym_int] = ACTIONS(3285),
    [sym_xint] = ACTIONS(3287),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3287),
  },
  [3450] = {
    [sym_xml_doc] = STATE(3450),
    [sym_block_comment] = STATE(3450),
    [sym_line_comment] = STATE(3450),
    [sym_compiler_directive_decl] = STATE(3450),
    [sym_fsi_directive_decl] = STATE(3450),
    [sym_preproc_line] = STATE(3450),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3298),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3298),
    [anon_sym_DASH_DOT] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3298),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
    [sym__dedent] = ACTIONS(3298),
  },
  [3451] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7773),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3451),
    [sym_block_comment] = STATE(3451),
    [sym_line_comment] = STATE(3451),
    [sym_compiler_directive_decl] = STATE(3451),
    [sym_fsi_directive_decl] = STATE(3451),
    [sym_preproc_line] = STATE(3451),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3452] = {
    [sym_xml_doc] = STATE(3452),
    [sym_block_comment] = STATE(3452),
    [sym_line_comment] = STATE(3452),
    [sym_compiler_directive_decl] = STATE(3452),
    [sym_fsi_directive_decl] = STATE(3452),
    [sym_preproc_line] = STATE(3452),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
    [sym__dedent] = ACTIONS(3353),
  },
  [3453] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7430),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3453),
    [sym_block_comment] = STATE(3453),
    [sym_line_comment] = STATE(3453),
    [sym_compiler_directive_decl] = STATE(3453),
    [sym_fsi_directive_decl] = STATE(3453),
    [sym_preproc_line] = STATE(3453),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3454] = {
    [sym_xml_doc] = STATE(3454),
    [sym_block_comment] = STATE(3454),
    [sym_line_comment] = STATE(3454),
    [sym_compiler_directive_decl] = STATE(3454),
    [sym_fsi_directive_decl] = STATE(3454),
    [sym_preproc_line] = STATE(3454),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_module] = ACTIONS(5826),
    [anon_sym_open] = ACTIONS(5826),
    [anon_sym_LBRACK_LT] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5826),
    [anon_sym_type] = ACTIONS(5826),
    [anon_sym_do] = ACTIONS(5826),
    [anon_sym_let] = ACTIONS(5826),
    [anon_sym_let_BANG] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5826),
    [anon_sym_null] = ACTIONS(5826),
    [anon_sym_AMP] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5826),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(5826),
    [anon_sym_LT_AT] = ACTIONS(5826),
    [anon_sym_LT_AT_AT] = ACTIONS(5824),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5824),
    [anon_sym_new] = ACTIONS(5826),
    [anon_sym_return_BANG] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5826),
    [anon_sym_yield_BANG] = ACTIONS(5824),
    [anon_sym_lazy] = ACTIONS(5826),
    [anon_sym_assert] = ACTIONS(5826),
    [anon_sym_upcast] = ACTIONS(5826),
    [anon_sym_downcast] = ACTIONS(5826),
    [anon_sym_for] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(5826),
    [anon_sym_if] = ACTIONS(5826),
    [anon_sym_fun] = ACTIONS(5826),
    [anon_sym_try] = ACTIONS(5826),
    [anon_sym_match] = ACTIONS(5826),
    [anon_sym_match_BANG] = ACTIONS(5824),
    [anon_sym_function] = ACTIONS(5826),
    [anon_sym_use] = ACTIONS(5826),
    [anon_sym_use_BANG] = ACTIONS(5824),
    [anon_sym_do_BANG] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5826),
    [aux_sym_char_token1] = ACTIONS(5824),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5826),
    [anon_sym_DQUOTE] = ACTIONS(5826),
    [anon_sym_AT_DQUOTE] = ACTIONS(5824),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5824),
    [sym_bool] = ACTIONS(5826),
    [sym_unit] = ACTIONS(5824),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5826),
    [sym_op_identifier] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [anon_sym_PLUS_DOT] = ACTIONS(5824),
    [anon_sym_DASH_DOT] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5824),
    [aux_sym_prefix_op_token1] = ACTIONS(5824),
    [sym_int] = ACTIONS(5826),
    [sym_xint] = ACTIONS(5824),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5824),
    [anon_sym_POUNDload] = ACTIONS(5824),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5824),
    [sym__dedent] = ACTIONS(5824),
  },
  [3455] = {
    [sym_xml_doc] = STATE(3455),
    [sym_block_comment] = STATE(3455),
    [sym_line_comment] = STATE(3455),
    [sym_compiler_directive_decl] = STATE(3455),
    [sym_fsi_directive_decl] = STATE(3455),
    [sym_preproc_line] = STATE(3455),
    [sym_identifier] = ACTIONS(5868),
    [anon_sym_module] = ACTIONS(5868),
    [anon_sym_open] = ACTIONS(5868),
    [anon_sym_LBRACK_LT] = ACTIONS(5866),
    [anon_sym_return] = ACTIONS(5868),
    [anon_sym_type] = ACTIONS(5868),
    [anon_sym_do] = ACTIONS(5868),
    [anon_sym_let] = ACTIONS(5868),
    [anon_sym_let_BANG] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5868),
    [anon_sym_null] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5868),
    [anon_sym_LT_AT] = ACTIONS(5868),
    [anon_sym_LT_AT_AT] = ACTIONS(5866),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5866),
    [anon_sym_new] = ACTIONS(5868),
    [anon_sym_return_BANG] = ACTIONS(5866),
    [anon_sym_yield] = ACTIONS(5868),
    [anon_sym_yield_BANG] = ACTIONS(5866),
    [anon_sym_lazy] = ACTIONS(5868),
    [anon_sym_assert] = ACTIONS(5868),
    [anon_sym_upcast] = ACTIONS(5868),
    [anon_sym_downcast] = ACTIONS(5868),
    [anon_sym_for] = ACTIONS(5868),
    [anon_sym_while] = ACTIONS(5868),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_fun] = ACTIONS(5868),
    [anon_sym_try] = ACTIONS(5868),
    [anon_sym_match] = ACTIONS(5868),
    [anon_sym_match_BANG] = ACTIONS(5866),
    [anon_sym_function] = ACTIONS(5868),
    [anon_sym_use] = ACTIONS(5868),
    [anon_sym_use_BANG] = ACTIONS(5866),
    [anon_sym_do_BANG] = ACTIONS(5866),
    [anon_sym_begin] = ACTIONS(5868),
    [aux_sym_char_token1] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5868),
    [anon_sym_DQUOTE] = ACTIONS(5868),
    [anon_sym_AT_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [sym_bool] = ACTIONS(5868),
    [sym_unit] = ACTIONS(5866),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5868),
    [sym_op_identifier] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_DOT] = ACTIONS(5866),
    [anon_sym_DASH_DOT] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(5866),
    [anon_sym_TILDE] = ACTIONS(5866),
    [aux_sym_prefix_op_token1] = ACTIONS(5866),
    [sym_int] = ACTIONS(5868),
    [sym_xint] = ACTIONS(5866),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5866),
    [anon_sym_POUNDload] = ACTIONS(5866),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5866),
    [sym__dedent] = ACTIONS(5866),
  },
  [3456] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(8174),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3456),
    [sym_block_comment] = STATE(3456),
    [sym_line_comment] = STATE(3456),
    [sym_compiler_directive_decl] = STATE(3456),
    [sym_fsi_directive_decl] = STATE(3456),
    [sym_preproc_line] = STATE(3456),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3457] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6433),
    [sym_type_attributes] = STATE(7614),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3457),
    [sym_block_comment] = STATE(3457),
    [sym_line_comment] = STATE(3457),
    [sym_compiler_directive_decl] = STATE(3457),
    [sym_fsi_directive_decl] = STATE(3457),
    [sym_preproc_line] = STATE(3457),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3458] = {
    [sym_xml_doc] = STATE(3458),
    [sym_block_comment] = STATE(3458),
    [sym_line_comment] = STATE(3458),
    [sym_compiler_directive_decl] = STATE(3458),
    [sym_fsi_directive_decl] = STATE(3458),
    [sym_preproc_line] = STATE(3458),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_f] = ACTIONS(5498),
    [aux_sym_decimal_token1] = ACTIONS(5316),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
  },
  [3459] = {
    [sym_xml_doc] = STATE(3459),
    [sym_block_comment] = STATE(3459),
    [sym_line_comment] = STATE(3459),
    [sym_compiler_directive_decl] = STATE(3459),
    [sym_fsi_directive_decl] = STATE(3459),
    [sym_preproc_line] = STATE(3459),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_let_BANG] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_null] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_LT_AT] = ACTIONS(3340),
    [anon_sym_LT_AT_AT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_return_BANG] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_yield_BANG] = ACTIONS(3342),
    [anon_sym_lazy] = ACTIONS(3340),
    [anon_sym_assert] = ACTIONS(3340),
    [anon_sym_upcast] = ACTIONS(3340),
    [anon_sym_downcast] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_fun] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_match] = ACTIONS(3340),
    [anon_sym_match_BANG] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_use] = ACTIONS(3340),
    [anon_sym_use_BANG] = ACTIONS(3342),
    [anon_sym_do_BANG] = ACTIONS(3342),
    [anon_sym_begin] = ACTIONS(3340),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_LT2] = ACTIONS(3340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3342),
    [aux_sym_char_token1] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_AT_DQUOTE] = ACTIONS(3342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3342),
    [sym_bool] = ACTIONS(3340),
    [sym_unit] = ACTIONS(3342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3340),
    [sym_op_identifier] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_PLUS_DOT] = ACTIONS(3342),
    [anon_sym_DASH_DOT] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_AMP_AMP] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [aux_sym_prefix_op_token1] = ACTIONS(3342),
    [sym_int] = ACTIONS(3340),
    [sym_xint] = ACTIONS(3342),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3342),
  },
  [3460] = {
    [sym_xml_doc] = STATE(3460),
    [sym_block_comment] = STATE(3460),
    [sym_line_comment] = STATE(3460),
    [sym_compiler_directive_decl] = STATE(3460),
    [sym_fsi_directive_decl] = STATE(3460),
    [sym_preproc_line] = STATE(3460),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3453),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_GT] = ACTIONS(3453),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3453),
    [anon_sym_do_BANG] = ACTIONS(3453),
    [anon_sym_begin] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3453),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3453),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3453),
    [anon_sym_DASH_DOT] = ACTIONS(3453),
    [anon_sym_PERCENT] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [aux_sym_prefix_op_token1] = ACTIONS(3453),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3453),
    [anon_sym_f] = ACTIONS(3451),
    [aux_sym_decimal_token1] = ACTIONS(3451),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3453),
  },
  [3461] = {
    [sym_xml_doc] = STATE(3461),
    [sym_block_comment] = STATE(3461),
    [sym_line_comment] = STATE(3461),
    [sym_compiler_directive_decl] = STATE(3461),
    [sym_fsi_directive_decl] = STATE(3461),
    [sym_preproc_line] = STATE(3461),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_let_BANG] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3417),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_return_BANG] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_yield_BANG] = ACTIONS(3419),
    [anon_sym_lazy] = ACTIONS(3417),
    [anon_sym_assert] = ACTIONS(3417),
    [anon_sym_upcast] = ACTIONS(3417),
    [anon_sym_downcast] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_fun] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_match] = ACTIONS(3417),
    [anon_sym_match_BANG] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3417),
    [anon_sym_use_BANG] = ACTIONS(3419),
    [anon_sym_do_BANG] = ACTIONS(3419),
    [anon_sym_begin] = ACTIONS(3417),
    [aux_sym_char_token1] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_AT_DQUOTE] = ACTIONS(3419),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3419),
    [sym_bool] = ACTIONS(3417),
    [sym_unit] = ACTIONS(3419),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3417),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [sym_int] = ACTIONS(5949),
    [sym_xint] = ACTIONS(3419),
    [anon_sym_f] = ACTIONS(3417),
    [aux_sym_decimal_token1] = ACTIONS(3417),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3419),
  },
  [3462] = {
    [sym_attributes] = STATE(5059),
    [sym_attribute_set] = STATE(5160),
    [sym_function_or_value_defn] = STATE(6629),
    [sym_access_modifier] = STATE(7834),
    [sym_type] = STATE(5730),
    [sym__simple_type] = STATE(4892),
    [sym__generic_type] = STATE(4892),
    [sym__paren_type] = STATE(4892),
    [sym__function_type] = STATE(4892),
    [sym__compound_type] = STATE(4892),
    [sym__postfix_type] = STATE(4892),
    [sym__list_type] = STATE(4892),
    [sym__static_type] = STATE(4892),
    [sym__constrained_type] = STATE(4892),
    [sym__flexible_type] = STATE(4892),
    [sym__static_type_identifier] = STATE(4284),
    [sym_type_argument] = STATE(4769),
    [sym_delegate_signature] = STATE(7551),
    [sym__class_type_body_inner] = STATE(6486),
    [sym__class_type_body] = STATE(7629),
    [sym_enum_type_cases] = STATE(7628),
    [sym_enum_type_case] = STATE(8203),
    [sym_union_type_cases] = STATE(4228),
    [sym_union_type_case] = STATE(5097),
    [sym__class_function_or_value_defn] = STATE(6633),
    [sym__type_defn_elements] = STATE(6633),
    [sym_interface_implementation] = STATE(6553),
    [sym__member_defns] = STATE(6718),
    [sym_member_defn] = STATE(4881),
    [sym_additional_constr_defn] = STATE(5387),
    [sym_class_inherits_decl] = STATE(6633),
    [sym_long_identifier] = STATE(4888),
    [sym_xml_doc] = STATE(3462),
    [sym_block_comment] = STATE(3462),
    [sym_line_comment] = STATE(3462),
    [sym_compiler_directive_decl] = STATE(3462),
    [sym_fsi_directive_decl] = STATE(3462),
    [sym_preproc_line] = STATE(3462),
    [sym_preproc_if_in_class_definition] = STATE(6633),
    [aux_sym_attributes_repeat1] = STATE(5030),
    [aux_sym__object_expression_inner_repeat1] = STATE(5999),
    [sym_identifier] = ACTIONS(5951),
    [anon_sym_LBRACK_LT] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5955),
    [anon_sym_let] = ACTIONS(5957),
    [anon_sym_let_BANG] = ACTIONS(5959),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_PIPE] = ACTIONS(5965),
    [anon_sym_LBRACE] = ACTIONS(5967),
    [anon_sym_new] = ACTIONS(5969),
    [anon_sym_POUND] = ACTIONS(5971),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_SQUOTE] = ACTIONS(5973),
    [anon_sym_delegate] = ACTIONS(5975),
    [anon_sym_default] = ACTIONS(5977),
    [anon_sym_static] = ACTIONS(5979),
    [anon_sym_member] = ACTIONS(5981),
    [anon_sym_interface] = ACTIONS(5983),
    [anon_sym_abstract] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5977),
    [anon_sym_val] = ACTIONS(5987),
    [anon_sym_inherit] = ACTIONS(5989),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5991),
  },
  [3463] = {
    [sym_xml_doc] = STATE(3463),
    [sym_block_comment] = STATE(3463),
    [sym_line_comment] = STATE(3463),
    [sym_compiler_directive_decl] = STATE(3463),
    [sym_fsi_directive_decl] = STATE(3463),
    [sym_preproc_line] = STATE(3463),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_let_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_null] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_LT_AT] = ACTIONS(3387),
    [anon_sym_LT_AT_AT] = ACTIONS(3389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_return_BANG] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_yield_BANG] = ACTIONS(3389),
    [anon_sym_lazy] = ACTIONS(3387),
    [anon_sym_assert] = ACTIONS(3387),
    [anon_sym_upcast] = ACTIONS(3387),
    [anon_sym_downcast] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_fun] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_match_BANG] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_GT] = ACTIONS(3389),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_use_BANG] = ACTIONS(3389),
    [anon_sym_do_BANG] = ACTIONS(3389),
    [anon_sym_begin] = ACTIONS(3387),
    [aux_sym_char_token1] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_AT_DQUOTE] = ACTIONS(3389),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3389),
    [sym_bool] = ACTIONS(3387),
    [sym_unit] = ACTIONS(3389),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3387),
    [sym_op_identifier] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_DOT] = ACTIONS(3389),
    [anon_sym_DASH_DOT] = ACTIONS(3389),
    [anon_sym_PERCENT] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [aux_sym_prefix_op_token1] = ACTIONS(3389),
    [sym_int] = ACTIONS(3387),
    [sym_xint] = ACTIONS(3389),
    [anon_sym_f] = ACTIONS(3387),
    [aux_sym_decimal_token1] = ACTIONS(3387),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3389),
  },
  [3464] = {
    [sym_xml_doc] = STATE(3464),
    [sym_block_comment] = STATE(3464),
    [sym_line_comment] = STATE(3464),
    [sym_compiler_directive_decl] = STATE(3464),
    [sym_fsi_directive_decl] = STATE(3464),
    [sym_preproc_line] = STATE(3464),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_let_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_null] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_LT_AT] = ACTIONS(3355),
    [anon_sym_LT_AT_AT] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_return_BANG] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_yield_BANG] = ACTIONS(3357),
    [anon_sym_lazy] = ACTIONS(3355),
    [anon_sym_assert] = ACTIONS(3355),
    [anon_sym_upcast] = ACTIONS(3355),
    [anon_sym_downcast] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_fun] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_match] = ACTIONS(3355),
    [anon_sym_match_BANG] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_use] = ACTIONS(3355),
    [anon_sym_use_BANG] = ACTIONS(3357),
    [anon_sym_do_BANG] = ACTIONS(3357),
    [anon_sym_begin] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LT2] = ACTIONS(5993),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3357),
    [aux_sym_char_token1] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_AT_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3357),
    [sym_bool] = ACTIONS(3355),
    [sym_unit] = ACTIONS(3357),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3355),
    [sym_op_identifier] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_PLUS_DOT] = ACTIONS(3357),
    [anon_sym_DASH_DOT] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [aux_sym_prefix_op_token1] = ACTIONS(3357),
    [sym_int] = ACTIONS(3355),
    [sym_xint] = ACTIONS(3357),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3357),
  },
  [3465] = {
    [sym_attributes] = STATE(5059),
    [sym_attribute_set] = STATE(5160),
    [sym_function_or_value_defn] = STATE(6629),
    [sym_access_modifier] = STATE(7834),
    [sym_type] = STATE(5676),
    [sym__simple_type] = STATE(4892),
    [sym__generic_type] = STATE(4892),
    [sym__paren_type] = STATE(4892),
    [sym__function_type] = STATE(4892),
    [sym__compound_type] = STATE(4892),
    [sym__postfix_type] = STATE(4892),
    [sym__list_type] = STATE(4892),
    [sym__static_type] = STATE(4892),
    [sym__constrained_type] = STATE(4892),
    [sym__flexible_type] = STATE(4892),
    [sym__static_type_identifier] = STATE(4284),
    [sym_type_argument] = STATE(4769),
    [sym_delegate_signature] = STATE(7448),
    [sym__class_type_body_inner] = STATE(6486),
    [sym__class_type_body] = STATE(7447),
    [sym_enum_type_cases] = STATE(7445),
    [sym_enum_type_case] = STATE(8203),
    [sym_union_type_cases] = STATE(4222),
    [sym_union_type_case] = STATE(5097),
    [sym__class_function_or_value_defn] = STATE(6633),
    [sym__type_defn_elements] = STATE(6633),
    [sym_interface_implementation] = STATE(6553),
    [sym__member_defns] = STATE(6718),
    [sym_member_defn] = STATE(4881),
    [sym_additional_constr_defn] = STATE(5387),
    [sym_class_inherits_decl] = STATE(6633),
    [sym_long_identifier] = STATE(4888),
    [sym_xml_doc] = STATE(3465),
    [sym_block_comment] = STATE(3465),
    [sym_line_comment] = STATE(3465),
    [sym_compiler_directive_decl] = STATE(3465),
    [sym_fsi_directive_decl] = STATE(3465),
    [sym_preproc_line] = STATE(3465),
    [sym_preproc_if_in_class_definition] = STATE(6633),
    [aux_sym_attributes_repeat1] = STATE(5030),
    [aux_sym__object_expression_inner_repeat1] = STATE(5999),
    [sym_identifier] = ACTIONS(5951),
    [anon_sym_LBRACK_LT] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5955),
    [anon_sym_let] = ACTIONS(5957),
    [anon_sym_let_BANG] = ACTIONS(5959),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_PIPE] = ACTIONS(5965),
    [anon_sym_LBRACE] = ACTIONS(5995),
    [anon_sym_new] = ACTIONS(5969),
    [anon_sym_POUND] = ACTIONS(5971),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_SQUOTE] = ACTIONS(5973),
    [anon_sym_delegate] = ACTIONS(5975),
    [anon_sym_default] = ACTIONS(5977),
    [anon_sym_static] = ACTIONS(5979),
    [anon_sym_member] = ACTIONS(5981),
    [anon_sym_interface] = ACTIONS(5983),
    [anon_sym_abstract] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5977),
    [anon_sym_val] = ACTIONS(5987),
    [anon_sym_inherit] = ACTIONS(5989),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5991),
  },
  [3466] = {
    [sym_xml_doc] = STATE(3466),
    [sym_block_comment] = STATE(3466),
    [sym_line_comment] = STATE(3466),
    [sym_compiler_directive_decl] = STATE(3466),
    [sym_fsi_directive_decl] = STATE(3466),
    [sym_preproc_line] = STATE(3466),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_let_BANG] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_null] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_LT_AT] = ACTIONS(3308),
    [anon_sym_LT_AT_AT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_return_BANG] = ACTIONS(3310),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_yield_BANG] = ACTIONS(3310),
    [anon_sym_lazy] = ACTIONS(3308),
    [anon_sym_assert] = ACTIONS(3308),
    [anon_sym_upcast] = ACTIONS(3308),
    [anon_sym_downcast] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_fun] = ACTIONS(3308),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_match] = ACTIONS(3308),
    [anon_sym_match_BANG] = ACTIONS(3310),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_use] = ACTIONS(3308),
    [anon_sym_use_BANG] = ACTIONS(3310),
    [anon_sym_do_BANG] = ACTIONS(3310),
    [anon_sym_begin] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3310),
    [anon_sym_LT2] = ACTIONS(3308),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3310),
    [aux_sym_char_token1] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_AT_DQUOTE] = ACTIONS(3310),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3310),
    [sym_bool] = ACTIONS(3308),
    [sym_unit] = ACTIONS(3310),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3308),
    [sym_op_identifier] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_PLUS_DOT] = ACTIONS(3310),
    [anon_sym_DASH_DOT] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_TILDE] = ACTIONS(3310),
    [aux_sym_prefix_op_token1] = ACTIONS(3310),
    [sym_int] = ACTIONS(3308),
    [sym_xint] = ACTIONS(3310),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3310),
  },
  [3467] = {
    [sym_xml_doc] = STATE(3467),
    [sym_block_comment] = STATE(3467),
    [sym_line_comment] = STATE(3467),
    [sym_compiler_directive_decl] = STATE(3467),
    [sym_fsi_directive_decl] = STATE(3467),
    [sym_preproc_line] = STATE(3467),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_return] = ACTIONS(5651),
    [anon_sym_do] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(5997),
    [anon_sym_let] = ACTIONS(5651),
    [anon_sym_let_BANG] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(5651),
    [anon_sym_null] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_LBRACK] = ACTIONS(5651),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5651),
    [anon_sym_LT_AT] = ACTIONS(5651),
    [anon_sym_LT_AT_AT] = ACTIONS(5649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5649),
    [anon_sym_new] = ACTIONS(5651),
    [anon_sym_return_BANG] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(5651),
    [anon_sym_yield_BANG] = ACTIONS(5649),
    [anon_sym_lazy] = ACTIONS(5651),
    [anon_sym_assert] = ACTIONS(5651),
    [anon_sym_upcast] = ACTIONS(5651),
    [anon_sym_downcast] = ACTIONS(5651),
    [anon_sym_for] = ACTIONS(5651),
    [anon_sym_while] = ACTIONS(5651),
    [anon_sym_if] = ACTIONS(5651),
    [anon_sym_fun] = ACTIONS(5651),
    [anon_sym_try] = ACTIONS(5651),
    [anon_sym_match] = ACTIONS(5651),
    [anon_sym_match_BANG] = ACTIONS(5649),
    [anon_sym_function] = ACTIONS(5651),
    [anon_sym_use] = ACTIONS(5651),
    [anon_sym_use_BANG] = ACTIONS(5649),
    [anon_sym_do_BANG] = ACTIONS(5649),
    [anon_sym_begin] = ACTIONS(5651),
    [aux_sym_char_token1] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(5651),
    [anon_sym_AT_DQUOTE] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [sym_bool] = ACTIONS(5651),
    [sym_unit] = ACTIONS(5649),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5651),
    [sym_op_identifier] = ACTIONS(5649),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS_DOT] = ACTIONS(5649),
    [anon_sym_DASH_DOT] = ACTIONS(5649),
    [anon_sym_PERCENT] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_TILDE] = ACTIONS(5649),
    [aux_sym_prefix_op_token1] = ACTIONS(5649),
    [sym_int] = ACTIONS(5651),
    [sym_xint] = ACTIONS(5649),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5649),
    [anon_sym_POUNDendif] = ACTIONS(5649),
    [anon_sym_POUNDelse] = ACTIONS(5649),
  },
  [3468] = {
    [sym_xml_doc] = STATE(3468),
    [sym_block_comment] = STATE(3468),
    [sym_line_comment] = STATE(3468),
    [sym_compiler_directive_decl] = STATE(3468),
    [sym_fsi_directive_decl] = STATE(3468),
    [sym_preproc_line] = STATE(3468),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_let_BANG] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_null] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_LT_AT] = ACTIONS(3322),
    [anon_sym_LT_AT_AT] = ACTIONS(3324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_return_BANG] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_yield_BANG] = ACTIONS(3324),
    [anon_sym_lazy] = ACTIONS(3322),
    [anon_sym_assert] = ACTIONS(3322),
    [anon_sym_upcast] = ACTIONS(3322),
    [anon_sym_downcast] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_fun] = ACTIONS(3322),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_match] = ACTIONS(3322),
    [anon_sym_match_BANG] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_use] = ACTIONS(3322),
    [anon_sym_use_BANG] = ACTIONS(3324),
    [anon_sym_do_BANG] = ACTIONS(3324),
    [anon_sym_begin] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3324),
    [anon_sym_LT2] = ACTIONS(3322),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3324),
    [aux_sym_char_token1] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_AT_DQUOTE] = ACTIONS(3324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3324),
    [sym_bool] = ACTIONS(3322),
    [sym_unit] = ACTIONS(3324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3322),
    [sym_op_identifier] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_PLUS_DOT] = ACTIONS(3324),
    [anon_sym_DASH_DOT] = ACTIONS(3324),
    [anon_sym_PERCENT] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [aux_sym_prefix_op_token1] = ACTIONS(3324),
    [sym_int] = ACTIONS(3322),
    [sym_xint] = ACTIONS(3324),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3324),
  },
  [3469] = {
    [sym_xml_doc] = STATE(3469),
    [sym_block_comment] = STATE(3469),
    [sym_line_comment] = STATE(3469),
    [sym_compiler_directive_decl] = STATE(3469),
    [sym_fsi_directive_decl] = STATE(3469),
    [sym_preproc_line] = STATE(3469),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_let_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_null] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_LT_AT] = ACTIONS(3292),
    [anon_sym_LT_AT_AT] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_return_BANG] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_yield_BANG] = ACTIONS(3294),
    [anon_sym_lazy] = ACTIONS(3292),
    [anon_sym_assert] = ACTIONS(3292),
    [anon_sym_upcast] = ACTIONS(3292),
    [anon_sym_downcast] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_fun] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_match] = ACTIONS(3292),
    [anon_sym_match_BANG] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_use] = ACTIONS(3292),
    [anon_sym_use_BANG] = ACTIONS(3294),
    [anon_sym_do_BANG] = ACTIONS(3294),
    [anon_sym_begin] = ACTIONS(3292),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_LT2] = ACTIONS(3292),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3294),
    [aux_sym_char_token1] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_AT_DQUOTE] = ACTIONS(3294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3294),
    [sym_bool] = ACTIONS(3292),
    [sym_unit] = ACTIONS(3294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3292),
    [sym_op_identifier] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_PLUS_DOT] = ACTIONS(3294),
    [anon_sym_DASH_DOT] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [aux_sym_prefix_op_token1] = ACTIONS(3294),
    [sym_int] = ACTIONS(3292),
    [sym_xint] = ACTIONS(3294),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3294),
  },
  [3470] = {
    [sym_attributes] = STATE(5059),
    [sym_attribute_set] = STATE(5160),
    [sym_function_or_value_defn] = STATE(6629),
    [sym_access_modifier] = STATE(7834),
    [sym_type] = STATE(5712),
    [sym__simple_type] = STATE(4892),
    [sym__generic_type] = STATE(4892),
    [sym__paren_type] = STATE(4892),
    [sym__function_type] = STATE(4892),
    [sym__compound_type] = STATE(4892),
    [sym__postfix_type] = STATE(4892),
    [sym__list_type] = STATE(4892),
    [sym__static_type] = STATE(4892),
    [sym__constrained_type] = STATE(4892),
    [sym__flexible_type] = STATE(4892),
    [sym__static_type_identifier] = STATE(4284),
    [sym_type_argument] = STATE(4769),
    [sym_delegate_signature] = STATE(7781),
    [sym__class_type_body_inner] = STATE(6486),
    [sym__class_type_body] = STATE(7780),
    [sym_enum_type_cases] = STATE(7779),
    [sym_enum_type_case] = STATE(8203),
    [sym_union_type_cases] = STATE(4223),
    [sym_union_type_case] = STATE(5097),
    [sym__class_function_or_value_defn] = STATE(6633),
    [sym__type_defn_elements] = STATE(6633),
    [sym_interface_implementation] = STATE(6553),
    [sym__member_defns] = STATE(6718),
    [sym_member_defn] = STATE(4881),
    [sym_additional_constr_defn] = STATE(5387),
    [sym_class_inherits_decl] = STATE(6633),
    [sym_long_identifier] = STATE(4888),
    [sym_xml_doc] = STATE(3470),
    [sym_block_comment] = STATE(3470),
    [sym_line_comment] = STATE(3470),
    [sym_compiler_directive_decl] = STATE(3470),
    [sym_fsi_directive_decl] = STATE(3470),
    [sym_preproc_line] = STATE(3470),
    [sym_preproc_if_in_class_definition] = STATE(6633),
    [aux_sym_attributes_repeat1] = STATE(5030),
    [aux_sym__object_expression_inner_repeat1] = STATE(5999),
    [sym_identifier] = ACTIONS(5951),
    [anon_sym_LBRACK_LT] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5955),
    [anon_sym_let] = ACTIONS(5957),
    [anon_sym_let_BANG] = ACTIONS(5959),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_PIPE] = ACTIONS(5965),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [anon_sym_new] = ACTIONS(5969),
    [anon_sym_POUND] = ACTIONS(5971),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_SQUOTE] = ACTIONS(5973),
    [anon_sym_delegate] = ACTIONS(5975),
    [anon_sym_default] = ACTIONS(5977),
    [anon_sym_static] = ACTIONS(5979),
    [anon_sym_member] = ACTIONS(5981),
    [anon_sym_interface] = ACTIONS(5983),
    [anon_sym_abstract] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5977),
    [anon_sym_val] = ACTIONS(5987),
    [anon_sym_inherit] = ACTIONS(5989),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5991),
  },
  [3471] = {
    [sym_xml_doc] = STATE(3471),
    [sym_block_comment] = STATE(3471),
    [sym_line_comment] = STATE(3471),
    [sym_compiler_directive_decl] = STATE(3471),
    [sym_fsi_directive_decl] = STATE(3471),
    [sym_preproc_line] = STATE(3471),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_let_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_null] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT_AT] = ACTIONS(3296),
    [anon_sym_LT_AT_AT] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_return_BANG] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_yield_BANG] = ACTIONS(3298),
    [anon_sym_lazy] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_upcast] = ACTIONS(3296),
    [anon_sym_downcast] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_fun] = ACTIONS(3296),
    [anon_sym_DASH_GT] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_match] = ACTIONS(3296),
    [anon_sym_match_BANG] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_use] = ACTIONS(3296),
    [anon_sym_use_BANG] = ACTIONS(3298),
    [anon_sym_do_BANG] = ACTIONS(3298),
    [anon_sym_begin] = ACTIONS(3296),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_LT2] = ACTIONS(3296),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3298),
    [aux_sym_char_token1] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_AT_DQUOTE] = ACTIONS(3298),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3298),
    [sym_bool] = ACTIONS(3296),
    [sym_unit] = ACTIONS(3298),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3296),
    [sym_op_identifier] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_PLUS_DOT] = ACTIONS(3298),
    [anon_sym_DASH_DOT] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [aux_sym_prefix_op_token1] = ACTIONS(3298),
    [sym_int] = ACTIONS(3296),
    [sym_xint] = ACTIONS(3298),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3298),
  },
  [3472] = {
    [sym_xml_doc] = STATE(3472),
    [sym_block_comment] = STATE(3472),
    [sym_line_comment] = STATE(3472),
    [sym_compiler_directive_decl] = STATE(3472),
    [sym_fsi_directive_decl] = STATE(3472),
    [sym_preproc_line] = STATE(3472),
    [sym_identifier] = ACTIONS(3336),
    [anon_sym_return] = ACTIONS(3336),
    [anon_sym_do] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_let_BANG] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_null] = ACTIONS(3336),
    [anon_sym_AMP] = ACTIONS(3336),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3336),
    [anon_sym_LT_AT] = ACTIONS(3336),
    [anon_sym_LT_AT_AT] = ACTIONS(3338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3336),
    [anon_sym_return_BANG] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3336),
    [anon_sym_yield_BANG] = ACTIONS(3338),
    [anon_sym_lazy] = ACTIONS(3336),
    [anon_sym_assert] = ACTIONS(3336),
    [anon_sym_upcast] = ACTIONS(3336),
    [anon_sym_downcast] = ACTIONS(3336),
    [anon_sym_for] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(3336),
    [anon_sym_if] = ACTIONS(3336),
    [anon_sym_fun] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3336),
    [anon_sym_match] = ACTIONS(3336),
    [anon_sym_match_BANG] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3336),
    [anon_sym_use] = ACTIONS(3336),
    [anon_sym_use_BANG] = ACTIONS(3338),
    [anon_sym_do_BANG] = ACTIONS(3338),
    [anon_sym_begin] = ACTIONS(3336),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_LT2] = ACTIONS(3336),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3338),
    [aux_sym_char_token1] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(3336),
    [anon_sym_AT_DQUOTE] = ACTIONS(3338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3338),
    [sym_bool] = ACTIONS(3336),
    [sym_unit] = ACTIONS(3338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3336),
    [sym_op_identifier] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3336),
    [anon_sym_DASH] = ACTIONS(3336),
    [anon_sym_PLUS_DOT] = ACTIONS(3338),
    [anon_sym_DASH_DOT] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_AMP_AMP] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [aux_sym_prefix_op_token1] = ACTIONS(3338),
    [sym_int] = ACTIONS(3336),
    [sym_xint] = ACTIONS(3338),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3338),
  },
  [3473] = {
    [sym_xml_doc] = STATE(3473),
    [sym_block_comment] = STATE(3473),
    [sym_line_comment] = STATE(3473),
    [sym_compiler_directive_decl] = STATE(3473),
    [sym_fsi_directive_decl] = STATE(3473),
    [sym_preproc_line] = STATE(3473),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3473),
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_return] = ACTIONS(5660),
    [anon_sym_do] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(6001),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_let_BANG] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_null] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5658),
    [anon_sym_LBRACE] = ACTIONS(5660),
    [anon_sym_LT_AT] = ACTIONS(5660),
    [anon_sym_LT_AT_AT] = ACTIONS(5658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5658),
    [anon_sym_new] = ACTIONS(5660),
    [anon_sym_return_BANG] = ACTIONS(5658),
    [anon_sym_yield] = ACTIONS(5660),
    [anon_sym_yield_BANG] = ACTIONS(5658),
    [anon_sym_lazy] = ACTIONS(5660),
    [anon_sym_assert] = ACTIONS(5660),
    [anon_sym_upcast] = ACTIONS(5660),
    [anon_sym_downcast] = ACTIONS(5660),
    [anon_sym_for] = ACTIONS(5660),
    [anon_sym_while] = ACTIONS(5660),
    [anon_sym_if] = ACTIONS(5660),
    [anon_sym_fun] = ACTIONS(5660),
    [anon_sym_try] = ACTIONS(5660),
    [anon_sym_match] = ACTIONS(5660),
    [anon_sym_match_BANG] = ACTIONS(5658),
    [anon_sym_function] = ACTIONS(5660),
    [anon_sym_use] = ACTIONS(5660),
    [anon_sym_use_BANG] = ACTIONS(5658),
    [anon_sym_do_BANG] = ACTIONS(5658),
    [anon_sym_begin] = ACTIONS(5660),
    [aux_sym_char_token1] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5660),
    [anon_sym_AT_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [sym_bool] = ACTIONS(5660),
    [sym_unit] = ACTIONS(5658),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5660),
    [sym_op_identifier] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_DOT] = ACTIONS(5658),
    [anon_sym_DASH_DOT] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_TILDE] = ACTIONS(5658),
    [aux_sym_prefix_op_token1] = ACTIONS(5658),
    [sym_int] = ACTIONS(5660),
    [sym_xint] = ACTIONS(5658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5658),
    [anon_sym_POUNDendif] = ACTIONS(5658),
    [anon_sym_POUNDelse] = ACTIONS(5658),
  },
  [3474] = {
    [sym_xml_doc] = STATE(3474),
    [sym_block_comment] = STATE(3474),
    [sym_line_comment] = STATE(3474),
    [sym_compiler_directive_decl] = STATE(3474),
    [sym_fsi_directive_decl] = STATE(3474),
    [sym_preproc_line] = STATE(3474),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_let_BANG] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_null] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_LT_AT] = ACTIONS(3318),
    [anon_sym_LT_AT_AT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_return_BANG] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_yield_BANG] = ACTIONS(3320),
    [anon_sym_lazy] = ACTIONS(3318),
    [anon_sym_assert] = ACTIONS(3318),
    [anon_sym_upcast] = ACTIONS(3318),
    [anon_sym_downcast] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_fun] = ACTIONS(3318),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_match] = ACTIONS(3318),
    [anon_sym_match_BANG] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_use] = ACTIONS(3318),
    [anon_sym_use_BANG] = ACTIONS(3320),
    [anon_sym_do_BANG] = ACTIONS(3320),
    [anon_sym_begin] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LT2] = ACTIONS(3318),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3320),
    [aux_sym_char_token1] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_AT_DQUOTE] = ACTIONS(3320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3320),
    [sym_bool] = ACTIONS(3318),
    [sym_unit] = ACTIONS(3320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3318),
    [sym_op_identifier] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_PLUS_DOT] = ACTIONS(3320),
    [anon_sym_DASH_DOT] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [aux_sym_prefix_op_token1] = ACTIONS(3320),
    [sym_int] = ACTIONS(3318),
    [sym_xint] = ACTIONS(3320),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3320),
  },
  [3475] = {
    [sym_xml_doc] = STATE(3475),
    [sym_block_comment] = STATE(3475),
    [sym_line_comment] = STATE(3475),
    [sym_compiler_directive_decl] = STATE(3475),
    [sym_fsi_directive_decl] = STATE(3475),
    [sym_preproc_line] = STATE(3475),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_let_BANG] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_null] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_LT_AT] = ACTIONS(3304),
    [anon_sym_LT_AT_AT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_return_BANG] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_yield_BANG] = ACTIONS(3306),
    [anon_sym_lazy] = ACTIONS(3304),
    [anon_sym_assert] = ACTIONS(3304),
    [anon_sym_upcast] = ACTIONS(3304),
    [anon_sym_downcast] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_fun] = ACTIONS(3304),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_match] = ACTIONS(3304),
    [anon_sym_match_BANG] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_use] = ACTIONS(3304),
    [anon_sym_use_BANG] = ACTIONS(3306),
    [anon_sym_do_BANG] = ACTIONS(3306),
    [anon_sym_begin] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3306),
    [anon_sym_LT2] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3306),
    [aux_sym_char_token1] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_AT_DQUOTE] = ACTIONS(3306),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3306),
    [sym_bool] = ACTIONS(3304),
    [sym_unit] = ACTIONS(3306),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3304),
    [sym_op_identifier] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_DOT] = ACTIONS(3306),
    [anon_sym_DASH_DOT] = ACTIONS(3306),
    [anon_sym_PERCENT] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [aux_sym_prefix_op_token1] = ACTIONS(3306),
    [sym_int] = ACTIONS(3304),
    [sym_xint] = ACTIONS(3306),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3306),
  },
  [3476] = {
    [sym_xml_doc] = STATE(3476),
    [sym_block_comment] = STATE(3476),
    [sym_line_comment] = STATE(3476),
    [sym_compiler_directive_decl] = STATE(3476),
    [sym_fsi_directive_decl] = STATE(3476),
    [sym_preproc_line] = STATE(3476),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_let_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_null] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_LT_AT] = ACTIONS(3300),
    [anon_sym_LT_AT_AT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_return_BANG] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_yield_BANG] = ACTIONS(3302),
    [anon_sym_lazy] = ACTIONS(3300),
    [anon_sym_assert] = ACTIONS(3300),
    [anon_sym_upcast] = ACTIONS(3300),
    [anon_sym_downcast] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_fun] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_match] = ACTIONS(3300),
    [anon_sym_match_BANG] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_use] = ACTIONS(3300),
    [anon_sym_use_BANG] = ACTIONS(3302),
    [anon_sym_do_BANG] = ACTIONS(3302),
    [anon_sym_begin] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LT2] = ACTIONS(3300),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3302),
    [aux_sym_char_token1] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_AT_DQUOTE] = ACTIONS(3302),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3302),
    [sym_bool] = ACTIONS(3300),
    [sym_unit] = ACTIONS(3302),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3300),
    [sym_op_identifier] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_DOT] = ACTIONS(3302),
    [anon_sym_DASH_DOT] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [aux_sym_prefix_op_token1] = ACTIONS(3302),
    [sym_int] = ACTIONS(3300),
    [sym_xint] = ACTIONS(3302),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3302),
  },
  [3477] = {
    [sym_type] = STATE(5477),
    [sym__simple_type] = STATE(5514),
    [sym__generic_type] = STATE(5514),
    [sym__paren_type] = STATE(5514),
    [sym__function_type] = STATE(5514),
    [sym__compound_type] = STATE(5514),
    [sym__postfix_type] = STATE(5514),
    [sym__list_type] = STATE(5514),
    [sym__static_type] = STATE(5514),
    [sym__constrained_type] = STATE(5514),
    [sym__flexible_type] = STATE(5514),
    [sym__static_type_identifier] = STATE(5138),
    [sym__static_parameter] = STATE(6600),
    [sym_named_static_parameter] = STATE(6603),
    [sym_static_parameter_value] = STATE(6603),
    [sym_type_attribute] = STATE(6668),
    [sym_type_argument] = STATE(5378),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3518),
    [sym__string_literal] = STATE(3518),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3509),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(534),
    [sym_long_identifier] = STATE(5501),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3458),
    [sym_xml_doc] = STATE(3477),
    [sym_block_comment] = STATE(3477),
    [sym_line_comment] = STATE(3477),
    [sym_compiler_directive_decl] = STATE(3477),
    [sym_fsi_directive_decl] = STATE(3477),
    [sym_preproc_line] = STATE(3477),
    [sym_identifier] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5784),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [aux_sym_char_token1] = ACTIONS(5792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5794),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_AT_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5802),
    [sym_bool] = ACTIONS(5804),
    [sym_unit] = ACTIONS(5806),
    [sym_int] = ACTIONS(5808),
    [sym_xint] = ACTIONS(5810),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
  },
  [3478] = {
    [sym_attributes] = STATE(5059),
    [sym_attribute_set] = STATE(5160),
    [sym_function_or_value_defn] = STATE(6629),
    [sym_access_modifier] = STATE(7834),
    [sym_type] = STATE(5688),
    [sym__simple_type] = STATE(4892),
    [sym__generic_type] = STATE(4892),
    [sym__paren_type] = STATE(4892),
    [sym__function_type] = STATE(4892),
    [sym__compound_type] = STATE(4892),
    [sym__postfix_type] = STATE(4892),
    [sym__list_type] = STATE(4892),
    [sym__static_type] = STATE(4892),
    [sym__constrained_type] = STATE(4892),
    [sym__flexible_type] = STATE(4892),
    [sym__static_type_identifier] = STATE(4284),
    [sym_type_argument] = STATE(4769),
    [sym_delegate_signature] = STATE(8206),
    [sym__class_type_body_inner] = STATE(6486),
    [sym__class_type_body] = STATE(8205),
    [sym_enum_type_cases] = STATE(8204),
    [sym_enum_type_case] = STATE(8203),
    [sym_union_type_cases] = STATE(4209),
    [sym_union_type_case] = STATE(5097),
    [sym__class_function_or_value_defn] = STATE(6633),
    [sym__type_defn_elements] = STATE(6633),
    [sym_interface_implementation] = STATE(6553),
    [sym__member_defns] = STATE(6718),
    [sym_member_defn] = STATE(4881),
    [sym_additional_constr_defn] = STATE(5387),
    [sym_class_inherits_decl] = STATE(6633),
    [sym_long_identifier] = STATE(4888),
    [sym_xml_doc] = STATE(3478),
    [sym_block_comment] = STATE(3478),
    [sym_line_comment] = STATE(3478),
    [sym_compiler_directive_decl] = STATE(3478),
    [sym_fsi_directive_decl] = STATE(3478),
    [sym_preproc_line] = STATE(3478),
    [sym_preproc_if_in_class_definition] = STATE(6633),
    [aux_sym_attributes_repeat1] = STATE(5030),
    [aux_sym__object_expression_inner_repeat1] = STATE(5999),
    [sym_identifier] = ACTIONS(5951),
    [anon_sym_LBRACK_LT] = ACTIONS(5953),
    [anon_sym_do] = ACTIONS(5955),
    [anon_sym_let] = ACTIONS(5957),
    [anon_sym_let_BANG] = ACTIONS(5959),
    [aux_sym_access_modifier_token1] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_PIPE] = ACTIONS(5965),
    [anon_sym_LBRACE] = ACTIONS(6004),
    [anon_sym_new] = ACTIONS(5969),
    [anon_sym_POUND] = ACTIONS(5971),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_SQUOTE] = ACTIONS(5973),
    [anon_sym_delegate] = ACTIONS(5975),
    [anon_sym_default] = ACTIONS(5977),
    [anon_sym_static] = ACTIONS(5979),
    [anon_sym_member] = ACTIONS(5981),
    [anon_sym_interface] = ACTIONS(5983),
    [anon_sym_abstract] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5977),
    [anon_sym_val] = ACTIONS(5987),
    [anon_sym_inherit] = ACTIONS(5989),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5812),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5991),
  },
  [3479] = {
    [sym_xml_doc] = STATE(3479),
    [sym_block_comment] = STATE(3479),
    [sym_line_comment] = STATE(3479),
    [sym_compiler_directive_decl] = STATE(3479),
    [sym_fsi_directive_decl] = STATE(3479),
    [sym_preproc_line] = STATE(3479),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_let_BANG] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_null] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_LT_AT] = ACTIONS(3351),
    [anon_sym_LT_AT_AT] = ACTIONS(3353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_return_BANG] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_yield_BANG] = ACTIONS(3353),
    [anon_sym_lazy] = ACTIONS(3351),
    [anon_sym_assert] = ACTIONS(3351),
    [anon_sym_upcast] = ACTIONS(3351),
    [anon_sym_downcast] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_fun] = ACTIONS(3351),
    [anon_sym_DASH_GT] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_match] = ACTIONS(3351),
    [anon_sym_match_BANG] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_use] = ACTIONS(3351),
    [anon_sym_use_BANG] = ACTIONS(3353),
    [anon_sym_do_BANG] = ACTIONS(3353),
    [anon_sym_begin] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LT2] = ACTIONS(3351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3353),
    [aux_sym_char_token1] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_AT_DQUOTE] = ACTIONS(3353),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3353),
    [sym_bool] = ACTIONS(3351),
    [sym_unit] = ACTIONS(3353),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3351),
    [sym_op_identifier] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PLUS_DOT] = ACTIONS(3353),
    [anon_sym_DASH_DOT] = ACTIONS(3353),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [aux_sym_prefix_op_token1] = ACTIONS(3353),
    [sym_int] = ACTIONS(3351),
    [sym_xint] = ACTIONS(3353),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3353),
  },
  [3480] = {
    [sym_xml_doc] = STATE(3480),
    [sym_block_comment] = STATE(3480),
    [sym_line_comment] = STATE(3480),
    [sym_compiler_directive_decl] = STATE(3480),
    [sym_fsi_directive_decl] = STATE(3480),
    [sym_preproc_line] = STATE(3480),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3473),
    [sym_identifier] = ACTIONS(5674),
    [anon_sym_return] = ACTIONS(5674),
    [anon_sym_do] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(5997),
    [anon_sym_let] = ACTIONS(5674),
    [anon_sym_let_BANG] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5674),
    [anon_sym_null] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_LT_AT] = ACTIONS(5674),
    [anon_sym_LT_AT_AT] = ACTIONS(5672),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5672),
    [anon_sym_new] = ACTIONS(5674),
    [anon_sym_return_BANG] = ACTIONS(5672),
    [anon_sym_yield] = ACTIONS(5674),
    [anon_sym_yield_BANG] = ACTIONS(5672),
    [anon_sym_lazy] = ACTIONS(5674),
    [anon_sym_assert] = ACTIONS(5674),
    [anon_sym_upcast] = ACTIONS(5674),
    [anon_sym_downcast] = ACTIONS(5674),
    [anon_sym_for] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5674),
    [anon_sym_if] = ACTIONS(5674),
    [anon_sym_fun] = ACTIONS(5674),
    [anon_sym_try] = ACTIONS(5674),
    [anon_sym_match] = ACTIONS(5674),
    [anon_sym_match_BANG] = ACTIONS(5672),
    [anon_sym_function] = ACTIONS(5674),
    [anon_sym_use] = ACTIONS(5674),
    [anon_sym_use_BANG] = ACTIONS(5672),
    [anon_sym_do_BANG] = ACTIONS(5672),
    [anon_sym_begin] = ACTIONS(5674),
    [aux_sym_char_token1] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [anon_sym_AT_DQUOTE] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [sym_bool] = ACTIONS(5674),
    [sym_unit] = ACTIONS(5672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5674),
    [sym_op_identifier] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_DOT] = ACTIONS(5672),
    [anon_sym_DASH_DOT] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5672),
    [aux_sym_prefix_op_token1] = ACTIONS(5672),
    [sym_int] = ACTIONS(5674),
    [sym_xint] = ACTIONS(5672),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5672),
    [anon_sym_POUNDendif] = ACTIONS(5672),
    [anon_sym_POUNDelse] = ACTIONS(5672),
  },
  [3481] = {
    [sym_xml_doc] = STATE(3481),
    [sym_block_comment] = STATE(3481),
    [sym_line_comment] = STATE(3481),
    [sym_compiler_directive_decl] = STATE(3481),
    [sym_fsi_directive_decl] = STATE(3481),
    [sym_preproc_line] = STATE(3481),
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_return] = ACTIONS(5699),
    [anon_sym_do] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_let] = ACTIONS(5699),
    [anon_sym_let_BANG] = ACTIONS(5697),
    [anon_sym_LPAREN] = ACTIONS(5699),
    [anon_sym_null] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5697),
    [anon_sym_LBRACE] = ACTIONS(5699),
    [anon_sym_LT_AT] = ACTIONS(5699),
    [anon_sym_LT_AT_AT] = ACTIONS(5697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5699),
    [anon_sym_return_BANG] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5699),
    [anon_sym_yield_BANG] = ACTIONS(5697),
    [anon_sym_lazy] = ACTIONS(5699),
    [anon_sym_assert] = ACTIONS(5699),
    [anon_sym_upcast] = ACTIONS(5699),
    [anon_sym_downcast] = ACTIONS(5699),
    [anon_sym_for] = ACTIONS(5699),
    [anon_sym_while] = ACTIONS(5699),
    [anon_sym_if] = ACTIONS(5699),
    [anon_sym_fun] = ACTIONS(5699),
    [anon_sym_try] = ACTIONS(5699),
    [anon_sym_match] = ACTIONS(5699),
    [anon_sym_match_BANG] = ACTIONS(5697),
    [anon_sym_function] = ACTIONS(5699),
    [anon_sym_use] = ACTIONS(5699),
    [anon_sym_use_BANG] = ACTIONS(5697),
    [anon_sym_do_BANG] = ACTIONS(5697),
    [anon_sym_begin] = ACTIONS(5699),
    [aux_sym_char_token1] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [anon_sym_AT_DQUOTE] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [sym_bool] = ACTIONS(5699),
    [sym_unit] = ACTIONS(5697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5699),
    [sym_op_identifier] = ACTIONS(5697),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS_DOT] = ACTIONS(5697),
    [anon_sym_DASH_DOT] = ACTIONS(5697),
    [anon_sym_PERCENT] = ACTIONS(5697),
    [anon_sym_AMP_AMP] = ACTIONS(5697),
    [anon_sym_TILDE] = ACTIONS(5697),
    [aux_sym_prefix_op_token1] = ACTIONS(5697),
    [sym_int] = ACTIONS(5699),
    [sym_xint] = ACTIONS(5697),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5697),
    [anon_sym_POUNDendif] = ACTIONS(5697),
    [anon_sym_POUNDelse] = ACTIONS(5697),
  },
  [3482] = {
    [sym_xml_doc] = STATE(3482),
    [sym_block_comment] = STATE(3482),
    [sym_line_comment] = STATE(3482),
    [sym_compiler_directive_decl] = STATE(3482),
    [sym_fsi_directive_decl] = STATE(3482),
    [sym_preproc_line] = STATE(3482),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3440),
    [anon_sym_DASH_DOT] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3440),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
    [anon_sym_POUNDelse] = ACTIONS(3440),
  },
  [3483] = {
    [sym_xml_doc] = STATE(3483),
    [sym_block_comment] = STATE(3483),
    [sym_line_comment] = STATE(3483),
    [sym_compiler_directive_decl] = STATE(3483),
    [sym_fsi_directive_decl] = STATE(3483),
    [sym_preproc_line] = STATE(3483),
    [sym_identifier] = ACTIONS(5713),
    [anon_sym_return] = ACTIONS(5713),
    [anon_sym_do] = ACTIONS(5713),
    [anon_sym_and] = ACTIONS(5713),
    [anon_sym_let] = ACTIONS(5713),
    [anon_sym_let_BANG] = ACTIONS(5711),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_null] = ACTIONS(5713),
    [anon_sym_AMP] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5711),
    [anon_sym_LBRACE] = ACTIONS(5713),
    [anon_sym_LT_AT] = ACTIONS(5713),
    [anon_sym_LT_AT_AT] = ACTIONS(5711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5711),
    [anon_sym_new] = ACTIONS(5713),
    [anon_sym_return_BANG] = ACTIONS(5711),
    [anon_sym_yield] = ACTIONS(5713),
    [anon_sym_yield_BANG] = ACTIONS(5711),
    [anon_sym_lazy] = ACTIONS(5713),
    [anon_sym_assert] = ACTIONS(5713),
    [anon_sym_upcast] = ACTIONS(5713),
    [anon_sym_downcast] = ACTIONS(5713),
    [anon_sym_for] = ACTIONS(5713),
    [anon_sym_while] = ACTIONS(5713),
    [anon_sym_if] = ACTIONS(5713),
    [anon_sym_fun] = ACTIONS(5713),
    [anon_sym_try] = ACTIONS(5713),
    [anon_sym_match] = ACTIONS(5713),
    [anon_sym_match_BANG] = ACTIONS(5711),
    [anon_sym_function] = ACTIONS(5713),
    [anon_sym_use] = ACTIONS(5713),
    [anon_sym_use_BANG] = ACTIONS(5711),
    [anon_sym_do_BANG] = ACTIONS(5711),
    [anon_sym_begin] = ACTIONS(5713),
    [aux_sym_char_token1] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5713),
    [anon_sym_DQUOTE] = ACTIONS(5713),
    [anon_sym_AT_DQUOTE] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [sym_bool] = ACTIONS(5713),
    [sym_unit] = ACTIONS(5711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5713),
    [sym_op_identifier] = ACTIONS(5711),
    [anon_sym_PLUS] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_DOT] = ACTIONS(5711),
    [anon_sym_DASH_DOT] = ACTIONS(5711),
    [anon_sym_PERCENT] = ACTIONS(5711),
    [anon_sym_AMP_AMP] = ACTIONS(5711),
    [anon_sym_TILDE] = ACTIONS(5711),
    [aux_sym_prefix_op_token1] = ACTIONS(5711),
    [sym_int] = ACTIONS(5713),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5711),
    [anon_sym_POUNDendif] = ACTIONS(5711),
    [anon_sym_POUNDelse] = ACTIONS(5711),
  },
  [3484] = {
    [sym_xml_doc] = STATE(3484),
    [sym_block_comment] = STATE(3484),
    [sym_line_comment] = STATE(3484),
    [sym_compiler_directive_decl] = STATE(3484),
    [sym_fsi_directive_decl] = STATE(3484),
    [sym_preproc_line] = STATE(3484),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3485),
    [sym_identifier] = ACTIONS(5674),
    [anon_sym_return] = ACTIONS(5674),
    [anon_sym_do] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(6006),
    [anon_sym_let] = ACTIONS(5674),
    [anon_sym_let_BANG] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5674),
    [anon_sym_null] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_LT_AT] = ACTIONS(5674),
    [anon_sym_LT_AT_AT] = ACTIONS(5672),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5672),
    [anon_sym_new] = ACTIONS(5674),
    [anon_sym_return_BANG] = ACTIONS(5672),
    [anon_sym_yield] = ACTIONS(5674),
    [anon_sym_yield_BANG] = ACTIONS(5672),
    [anon_sym_lazy] = ACTIONS(5674),
    [anon_sym_assert] = ACTIONS(5674),
    [anon_sym_upcast] = ACTIONS(5674),
    [anon_sym_downcast] = ACTIONS(5674),
    [anon_sym_for] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5674),
    [anon_sym_if] = ACTIONS(5674),
    [anon_sym_fun] = ACTIONS(5674),
    [anon_sym_try] = ACTIONS(5674),
    [anon_sym_match] = ACTIONS(5674),
    [anon_sym_match_BANG] = ACTIONS(5672),
    [anon_sym_function] = ACTIONS(5674),
    [anon_sym_use] = ACTIONS(5674),
    [anon_sym_use_BANG] = ACTIONS(5672),
    [anon_sym_do_BANG] = ACTIONS(5672),
    [anon_sym_begin] = ACTIONS(5674),
    [aux_sym_char_token1] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [anon_sym_AT_DQUOTE] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [sym_bool] = ACTIONS(5674),
    [sym_unit] = ACTIONS(5672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5674),
    [sym_op_identifier] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_DOT] = ACTIONS(5672),
    [anon_sym_DASH_DOT] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5672),
    [aux_sym_prefix_op_token1] = ACTIONS(5672),
    [sym_int] = ACTIONS(5674),
    [sym_xint] = ACTIONS(5672),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5672),
    [anon_sym_POUNDendif] = ACTIONS(5672),
  },
  [3485] = {
    [sym_xml_doc] = STATE(3485),
    [sym_block_comment] = STATE(3485),
    [sym_line_comment] = STATE(3485),
    [sym_compiler_directive_decl] = STATE(3485),
    [sym_fsi_directive_decl] = STATE(3485),
    [sym_preproc_line] = STATE(3485),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3485),
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_return] = ACTIONS(5660),
    [anon_sym_do] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(6008),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_let_BANG] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_null] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5658),
    [anon_sym_LBRACE] = ACTIONS(5660),
    [anon_sym_LT_AT] = ACTIONS(5660),
    [anon_sym_LT_AT_AT] = ACTIONS(5658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5658),
    [anon_sym_new] = ACTIONS(5660),
    [anon_sym_return_BANG] = ACTIONS(5658),
    [anon_sym_yield] = ACTIONS(5660),
    [anon_sym_yield_BANG] = ACTIONS(5658),
    [anon_sym_lazy] = ACTIONS(5660),
    [anon_sym_assert] = ACTIONS(5660),
    [anon_sym_upcast] = ACTIONS(5660),
    [anon_sym_downcast] = ACTIONS(5660),
    [anon_sym_for] = ACTIONS(5660),
    [anon_sym_while] = ACTIONS(5660),
    [anon_sym_if] = ACTIONS(5660),
    [anon_sym_fun] = ACTIONS(5660),
    [anon_sym_try] = ACTIONS(5660),
    [anon_sym_match] = ACTIONS(5660),
    [anon_sym_match_BANG] = ACTIONS(5658),
    [anon_sym_function] = ACTIONS(5660),
    [anon_sym_use] = ACTIONS(5660),
    [anon_sym_use_BANG] = ACTIONS(5658),
    [anon_sym_do_BANG] = ACTIONS(5658),
    [anon_sym_begin] = ACTIONS(5660),
    [aux_sym_char_token1] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5660),
    [anon_sym_AT_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [sym_bool] = ACTIONS(5660),
    [sym_unit] = ACTIONS(5658),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5660),
    [sym_op_identifier] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_DOT] = ACTIONS(5658),
    [anon_sym_DASH_DOT] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_TILDE] = ACTIONS(5658),
    [aux_sym_prefix_op_token1] = ACTIONS(5658),
    [sym_int] = ACTIONS(5660),
    [sym_xint] = ACTIONS(5658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5658),
    [anon_sym_POUNDendif] = ACTIONS(5658),
  },
  [3486] = {
    [sym_xml_doc] = STATE(3486),
    [sym_block_comment] = STATE(3486),
    [sym_line_comment] = STATE(3486),
    [sym_compiler_directive_decl] = STATE(3486),
    [sym_fsi_directive_decl] = STATE(3486),
    [sym_preproc_line] = STATE(3486),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3484),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_return] = ACTIONS(5651),
    [anon_sym_do] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(6006),
    [anon_sym_let] = ACTIONS(5651),
    [anon_sym_let_BANG] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(5651),
    [anon_sym_null] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_LBRACK] = ACTIONS(5651),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5651),
    [anon_sym_LT_AT] = ACTIONS(5651),
    [anon_sym_LT_AT_AT] = ACTIONS(5649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5649),
    [anon_sym_new] = ACTIONS(5651),
    [anon_sym_return_BANG] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(5651),
    [anon_sym_yield_BANG] = ACTIONS(5649),
    [anon_sym_lazy] = ACTIONS(5651),
    [anon_sym_assert] = ACTIONS(5651),
    [anon_sym_upcast] = ACTIONS(5651),
    [anon_sym_downcast] = ACTIONS(5651),
    [anon_sym_for] = ACTIONS(5651),
    [anon_sym_while] = ACTIONS(5651),
    [anon_sym_if] = ACTIONS(5651),
    [anon_sym_fun] = ACTIONS(5651),
    [anon_sym_try] = ACTIONS(5651),
    [anon_sym_match] = ACTIONS(5651),
    [anon_sym_match_BANG] = ACTIONS(5649),
    [anon_sym_function] = ACTIONS(5651),
    [anon_sym_use] = ACTIONS(5651),
    [anon_sym_use_BANG] = ACTIONS(5649),
    [anon_sym_do_BANG] = ACTIONS(5649),
    [anon_sym_begin] = ACTIONS(5651),
    [aux_sym_char_token1] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(5651),
    [anon_sym_AT_DQUOTE] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [sym_bool] = ACTIONS(5651),
    [sym_unit] = ACTIONS(5649),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5651),
    [sym_op_identifier] = ACTIONS(5649),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS_DOT] = ACTIONS(5649),
    [anon_sym_DASH_DOT] = ACTIONS(5649),
    [anon_sym_PERCENT] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_TILDE] = ACTIONS(5649),
    [aux_sym_prefix_op_token1] = ACTIONS(5649),
    [sym_int] = ACTIONS(5651),
    [sym_xint] = ACTIONS(5649),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5649),
    [anon_sym_POUNDendif] = ACTIONS(5649),
  },
  [3487] = {
    [sym_xml_doc] = STATE(3487),
    [sym_block_comment] = STATE(3487),
    [sym_line_comment] = STATE(3487),
    [sym_compiler_directive_decl] = STATE(3487),
    [sym_fsi_directive_decl] = STATE(3487),
    [sym_preproc_line] = STATE(3487),
    [sym_identifier] = ACTIONS(5717),
    [anon_sym_return] = ACTIONS(5717),
    [anon_sym_do] = ACTIONS(5717),
    [anon_sym_and] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_let_BANG] = ACTIONS(5715),
    [anon_sym_LPAREN] = ACTIONS(5717),
    [anon_sym_null] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5715),
    [anon_sym_LBRACE] = ACTIONS(5717),
    [anon_sym_LT_AT] = ACTIONS(5717),
    [anon_sym_LT_AT_AT] = ACTIONS(5715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5715),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_return_BANG] = ACTIONS(5715),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_yield_BANG] = ACTIONS(5715),
    [anon_sym_lazy] = ACTIONS(5717),
    [anon_sym_assert] = ACTIONS(5717),
    [anon_sym_upcast] = ACTIONS(5717),
    [anon_sym_downcast] = ACTIONS(5717),
    [anon_sym_for] = ACTIONS(5717),
    [anon_sym_while] = ACTIONS(5717),
    [anon_sym_if] = ACTIONS(5717),
    [anon_sym_fun] = ACTIONS(5717),
    [anon_sym_try] = ACTIONS(5717),
    [anon_sym_match] = ACTIONS(5717),
    [anon_sym_match_BANG] = ACTIONS(5715),
    [anon_sym_function] = ACTIONS(5717),
    [anon_sym_use] = ACTIONS(5717),
    [anon_sym_use_BANG] = ACTIONS(5715),
    [anon_sym_do_BANG] = ACTIONS(5715),
    [anon_sym_begin] = ACTIONS(5717),
    [aux_sym_char_token1] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5717),
    [anon_sym_DQUOTE] = ACTIONS(5717),
    [anon_sym_AT_DQUOTE] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [sym_bool] = ACTIONS(5717),
    [sym_unit] = ACTIONS(5715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5717),
    [sym_op_identifier] = ACTIONS(5715),
    [anon_sym_PLUS] = ACTIONS(5717),
    [anon_sym_DASH] = ACTIONS(5717),
    [anon_sym_PLUS_DOT] = ACTIONS(5715),
    [anon_sym_DASH_DOT] = ACTIONS(5715),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_AMP_AMP] = ACTIONS(5715),
    [anon_sym_TILDE] = ACTIONS(5715),
    [aux_sym_prefix_op_token1] = ACTIONS(5715),
    [sym_int] = ACTIONS(5717),
    [sym_xint] = ACTIONS(5715),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5715),
    [anon_sym_POUNDendif] = ACTIONS(5715),
    [anon_sym_POUNDelse] = ACTIONS(5715),
  },
  [3488] = {
    [sym_xml_doc] = STATE(3488),
    [sym_block_comment] = STATE(3488),
    [sym_line_comment] = STATE(3488),
    [sym_compiler_directive_decl] = STATE(3488),
    [sym_fsi_directive_decl] = STATE(3488),
    [sym_preproc_line] = STATE(3488),
    [sym_identifier] = ACTIONS(3660),
    [anon_sym_return] = ACTIONS(3660),
    [anon_sym_do] = ACTIONS(3660),
    [anon_sym_let] = ACTIONS(3660),
    [anon_sym_let_BANG] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_null] = ACTIONS(3660),
    [anon_sym_AMP] = ACTIONS(3660),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_LT_AT] = ACTIONS(3660),
    [anon_sym_LT_AT_AT] = ACTIONS(3662),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3660),
    [anon_sym_return_BANG] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3660),
    [anon_sym_yield_BANG] = ACTIONS(3662),
    [anon_sym_lazy] = ACTIONS(3660),
    [anon_sym_assert] = ACTIONS(3660),
    [anon_sym_upcast] = ACTIONS(3660),
    [anon_sym_downcast] = ACTIONS(3660),
    [anon_sym_for] = ACTIONS(3660),
    [anon_sym_while] = ACTIONS(3660),
    [anon_sym_if] = ACTIONS(3660),
    [anon_sym_fun] = ACTIONS(3660),
    [anon_sym_try] = ACTIONS(3660),
    [anon_sym_match] = ACTIONS(3660),
    [anon_sym_match_BANG] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3660),
    [anon_sym_GT] = ACTIONS(3662),
    [anon_sym_use] = ACTIONS(3660),
    [anon_sym_use_BANG] = ACTIONS(3662),
    [anon_sym_do_BANG] = ACTIONS(3662),
    [anon_sym_begin] = ACTIONS(3660),
    [aux_sym_char_token1] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3660),
    [anon_sym_AT_DQUOTE] = ACTIONS(3662),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3662),
    [sym_bool] = ACTIONS(3660),
    [sym_unit] = ACTIONS(3662),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3660),
    [sym_op_identifier] = ACTIONS(3662),
    [anon_sym_PLUS] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3660),
    [anon_sym_PLUS_DOT] = ACTIONS(3662),
    [anon_sym_DASH_DOT] = ACTIONS(3662),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3662),
    [anon_sym_TILDE] = ACTIONS(3662),
    [aux_sym_prefix_op_token1] = ACTIONS(3662),
    [sym_int] = ACTIONS(3660),
    [sym_xint] = ACTIONS(3662),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3662),
  },
  [3489] = {
    [sym_xml_doc] = STATE(3489),
    [sym_block_comment] = STATE(3489),
    [sym_line_comment] = STATE(3489),
    [sym_compiler_directive_decl] = STATE(3489),
    [sym_fsi_directive_decl] = STATE(3489),
    [sym_preproc_line] = STATE(3489),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_return] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3726),
    [anon_sym_let] = ACTIONS(3726),
    [anon_sym_let_BANG] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_null] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3726),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3726),
    [anon_sym_return_BANG] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3726),
    [anon_sym_yield_BANG] = ACTIONS(3728),
    [anon_sym_lazy] = ACTIONS(3726),
    [anon_sym_assert] = ACTIONS(3726),
    [anon_sym_upcast] = ACTIONS(3726),
    [anon_sym_downcast] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3726),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_if] = ACTIONS(3726),
    [anon_sym_fun] = ACTIONS(3726),
    [anon_sym_try] = ACTIONS(3726),
    [anon_sym_match] = ACTIONS(3726),
    [anon_sym_match_BANG] = ACTIONS(3728),
    [anon_sym_function] = ACTIONS(3726),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3726),
    [anon_sym_use_BANG] = ACTIONS(3728),
    [anon_sym_do_BANG] = ACTIONS(3728),
    [anon_sym_begin] = ACTIONS(3726),
    [aux_sym_char_token1] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(3726),
    [anon_sym_AT_DQUOTE] = ACTIONS(3728),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3728),
    [sym_bool] = ACTIONS(3726),
    [sym_unit] = ACTIONS(3728),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3726),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3726),
    [anon_sym_DASH] = ACTIONS(3726),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3728),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [sym_int] = ACTIONS(3726),
    [sym_xint] = ACTIONS(3728),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3728),
  },
  [3490] = {
    [sym_xml_doc] = STATE(3490),
    [sym_block_comment] = STATE(3490),
    [sym_line_comment] = STATE(3490),
    [sym_compiler_directive_decl] = STATE(3490),
    [sym_fsi_directive_decl] = STATE(3490),
    [sym_preproc_line] = STATE(3490),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_return] = ACTIONS(3794),
    [anon_sym_do] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_let_BANG] = ACTIONS(3796),
    [anon_sym_LPAREN] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_null] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_LT_AT] = ACTIONS(3794),
    [anon_sym_LT_AT_AT] = ACTIONS(3796),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_return_BANG] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_yield_BANG] = ACTIONS(3796),
    [anon_sym_lazy] = ACTIONS(3794),
    [anon_sym_assert] = ACTIONS(3794),
    [anon_sym_upcast] = ACTIONS(3794),
    [anon_sym_downcast] = ACTIONS(3794),
    [anon_sym_for] = ACTIONS(3794),
    [anon_sym_while] = ACTIONS(3794),
    [anon_sym_if] = ACTIONS(3794),
    [anon_sym_fun] = ACTIONS(3794),
    [anon_sym_try] = ACTIONS(3794),
    [anon_sym_match] = ACTIONS(3794),
    [anon_sym_match_BANG] = ACTIONS(3796),
    [anon_sym_function] = ACTIONS(3794),
    [anon_sym_GT] = ACTIONS(3796),
    [anon_sym_use] = ACTIONS(3794),
    [anon_sym_use_BANG] = ACTIONS(3796),
    [anon_sym_do_BANG] = ACTIONS(3796),
    [anon_sym_begin] = ACTIONS(3794),
    [aux_sym_char_token1] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [anon_sym_AT_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3796),
    [sym_bool] = ACTIONS(3794),
    [sym_unit] = ACTIONS(3796),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3794),
    [sym_op_identifier] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_DOT] = ACTIONS(3796),
    [anon_sym_DASH_DOT] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_TILDE] = ACTIONS(3796),
    [aux_sym_prefix_op_token1] = ACTIONS(3796),
    [sym_int] = ACTIONS(3794),
    [sym_xint] = ACTIONS(3796),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3796),
  },
  [3491] = {
    [sym_xml_doc] = STATE(3491),
    [sym_block_comment] = STATE(3491),
    [sym_line_comment] = STATE(3491),
    [sym_compiler_directive_decl] = STATE(3491),
    [sym_fsi_directive_decl] = STATE(3491),
    [sym_preproc_line] = STATE(3491),
    [sym_identifier] = ACTIONS(5868),
    [anon_sym_return] = ACTIONS(5868),
    [anon_sym_do] = ACTIONS(5868),
    [anon_sym_let] = ACTIONS(5868),
    [anon_sym_let_BANG] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5868),
    [anon_sym_null] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5868),
    [anon_sym_LT_AT] = ACTIONS(5868),
    [anon_sym_LT_AT_AT] = ACTIONS(5866),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5866),
    [anon_sym_new] = ACTIONS(5868),
    [anon_sym_return_BANG] = ACTIONS(5866),
    [anon_sym_yield] = ACTIONS(5868),
    [anon_sym_yield_BANG] = ACTIONS(5866),
    [anon_sym_lazy] = ACTIONS(5868),
    [anon_sym_assert] = ACTIONS(5868),
    [anon_sym_upcast] = ACTIONS(5868),
    [anon_sym_downcast] = ACTIONS(5868),
    [anon_sym_for] = ACTIONS(5868),
    [anon_sym_while] = ACTIONS(5868),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_fun] = ACTIONS(5868),
    [anon_sym_try] = ACTIONS(5868),
    [anon_sym_match] = ACTIONS(5868),
    [anon_sym_match_BANG] = ACTIONS(5866),
    [anon_sym_function] = ACTIONS(5868),
    [anon_sym_use] = ACTIONS(5868),
    [anon_sym_use_BANG] = ACTIONS(5866),
    [anon_sym_do_BANG] = ACTIONS(5866),
    [anon_sym_begin] = ACTIONS(5868),
    [aux_sym_char_token1] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5868),
    [anon_sym_DQUOTE] = ACTIONS(5868),
    [anon_sym_AT_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [sym_bool] = ACTIONS(5868),
    [sym_unit] = ACTIONS(5866),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5868),
    [sym_op_identifier] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_DOT] = ACTIONS(5866),
    [anon_sym_DASH_DOT] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(5866),
    [anon_sym_TILDE] = ACTIONS(5866),
    [aux_sym_prefix_op_token1] = ACTIONS(5866),
    [sym_int] = ACTIONS(5868),
    [sym_xint] = ACTIONS(5866),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5866),
    [anon_sym_POUNDendif] = ACTIONS(5866),
    [anon_sym_POUNDelse] = ACTIONS(5866),
  },
  [3492] = {
    [sym_xml_doc] = STATE(3492),
    [sym_block_comment] = STATE(3492),
    [sym_line_comment] = STATE(3492),
    [sym_compiler_directive_decl] = STATE(3492),
    [sym_fsi_directive_decl] = STATE(3492),
    [sym_preproc_line] = STATE(3492),
    [sym_identifier] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3701),
    [anon_sym_do] = ACTIONS(3701),
    [anon_sym_let] = ACTIONS(3701),
    [anon_sym_let_BANG] = ACTIONS(3703),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_null] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_LT_AT] = ACTIONS(3701),
    [anon_sym_LT_AT_AT] = ACTIONS(3703),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3701),
    [anon_sym_return_BANG] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3701),
    [anon_sym_yield_BANG] = ACTIONS(3703),
    [anon_sym_lazy] = ACTIONS(3701),
    [anon_sym_assert] = ACTIONS(3701),
    [anon_sym_upcast] = ACTIONS(3701),
    [anon_sym_downcast] = ACTIONS(3701),
    [anon_sym_for] = ACTIONS(3701),
    [anon_sym_while] = ACTIONS(3701),
    [anon_sym_if] = ACTIONS(3701),
    [anon_sym_fun] = ACTIONS(3701),
    [anon_sym_try] = ACTIONS(3701),
    [anon_sym_match] = ACTIONS(3701),
    [anon_sym_match_BANG] = ACTIONS(3703),
    [anon_sym_function] = ACTIONS(3701),
    [anon_sym_GT] = ACTIONS(3703),
    [anon_sym_use] = ACTIONS(3701),
    [anon_sym_use_BANG] = ACTIONS(3703),
    [anon_sym_do_BANG] = ACTIONS(3703),
    [anon_sym_begin] = ACTIONS(3701),
    [aux_sym_char_token1] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_AT_DQUOTE] = ACTIONS(3703),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3703),
    [sym_bool] = ACTIONS(3701),
    [sym_unit] = ACTIONS(3703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3701),
    [sym_op_identifier] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_DOT] = ACTIONS(3703),
    [anon_sym_DASH_DOT] = ACTIONS(3703),
    [anon_sym_PERCENT] = ACTIONS(3703),
    [anon_sym_AMP_AMP] = ACTIONS(3703),
    [anon_sym_TILDE] = ACTIONS(3703),
    [aux_sym_prefix_op_token1] = ACTIONS(3703),
    [sym_int] = ACTIONS(3701),
    [sym_xint] = ACTIONS(3703),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3703),
  },
  [3493] = {
    [sym_xml_doc] = STATE(3493),
    [sym_block_comment] = STATE(3493),
    [sym_line_comment] = STATE(3493),
    [sym_compiler_directive_decl] = STATE(3493),
    [sym_fsi_directive_decl] = STATE(3493),
    [sym_preproc_line] = STATE(3493),
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_let_BANG] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3598),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_null] = ACTIONS(3598),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3598),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3600),
    [anon_sym_LBRACE] = ACTIONS(3598),
    [anon_sym_LT_AT] = ACTIONS(3598),
    [anon_sym_LT_AT_AT] = ACTIONS(3600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3598),
    [anon_sym_return_BANG] = ACTIONS(3600),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_yield_BANG] = ACTIONS(3600),
    [anon_sym_lazy] = ACTIONS(3598),
    [anon_sym_assert] = ACTIONS(3598),
    [anon_sym_upcast] = ACTIONS(3598),
    [anon_sym_downcast] = ACTIONS(3598),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3598),
    [anon_sym_fun] = ACTIONS(3598),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_match] = ACTIONS(3598),
    [anon_sym_match_BANG] = ACTIONS(3600),
    [anon_sym_function] = ACTIONS(3598),
    [anon_sym_GT] = ACTIONS(3600),
    [anon_sym_use] = ACTIONS(3598),
    [anon_sym_use_BANG] = ACTIONS(3600),
    [anon_sym_do_BANG] = ACTIONS(3600),
    [anon_sym_begin] = ACTIONS(3598),
    [aux_sym_char_token1] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(3598),
    [anon_sym_AT_DQUOTE] = ACTIONS(3600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3598),
    [sym_unit] = ACTIONS(3600),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3598),
    [sym_op_identifier] = ACTIONS(3600),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS_DOT] = ACTIONS(3600),
    [anon_sym_DASH_DOT] = ACTIONS(3600),
    [anon_sym_PERCENT] = ACTIONS(3600),
    [anon_sym_AMP_AMP] = ACTIONS(3600),
    [anon_sym_TILDE] = ACTIONS(3600),
    [aux_sym_prefix_op_token1] = ACTIONS(3600),
    [sym_int] = ACTIONS(3598),
    [sym_xint] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3600),
  },
  [3494] = {
    [sym_xml_doc] = STATE(3494),
    [sym_block_comment] = STATE(3494),
    [sym_line_comment] = STATE(3494),
    [sym_compiler_directive_decl] = STATE(3494),
    [sym_fsi_directive_decl] = STATE(3494),
    [sym_preproc_line] = STATE(3494),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3440),
    [anon_sym_DASH_DOT] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3440),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
    [anon_sym_POUNDendif] = ACTIONS(3440),
  },
  [3495] = {
    [sym_xml_doc] = STATE(3495),
    [sym_block_comment] = STATE(3495),
    [sym_line_comment] = STATE(3495),
    [sym_compiler_directive_decl] = STATE(3495),
    [sym_fsi_directive_decl] = STATE(3495),
    [sym_preproc_line] = STATE(3495),
    [sym_identifier] = ACTIONS(5860),
    [anon_sym_return] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_let] = ACTIONS(5860),
    [anon_sym_let_BANG] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_null] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_LT_AT] = ACTIONS(5860),
    [anon_sym_LT_AT_AT] = ACTIONS(5858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5858),
    [anon_sym_new] = ACTIONS(5860),
    [anon_sym_return_BANG] = ACTIONS(5858),
    [anon_sym_yield] = ACTIONS(5860),
    [anon_sym_yield_BANG] = ACTIONS(5858),
    [anon_sym_lazy] = ACTIONS(5860),
    [anon_sym_assert] = ACTIONS(5860),
    [anon_sym_upcast] = ACTIONS(5860),
    [anon_sym_downcast] = ACTIONS(5860),
    [anon_sym_for] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_fun] = ACTIONS(5860),
    [anon_sym_try] = ACTIONS(5860),
    [anon_sym_match] = ACTIONS(5860),
    [anon_sym_match_BANG] = ACTIONS(5858),
    [anon_sym_function] = ACTIONS(5860),
    [anon_sym_use] = ACTIONS(5860),
    [anon_sym_use_BANG] = ACTIONS(5858),
    [anon_sym_do_BANG] = ACTIONS(5858),
    [anon_sym_begin] = ACTIONS(5860),
    [aux_sym_char_token1] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5860),
    [anon_sym_DQUOTE] = ACTIONS(5860),
    [anon_sym_AT_DQUOTE] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [sym_bool] = ACTIONS(5860),
    [sym_unit] = ACTIONS(5858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5860),
    [sym_op_identifier] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_PLUS_DOT] = ACTIONS(5858),
    [anon_sym_DASH_DOT] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_TILDE] = ACTIONS(5858),
    [aux_sym_prefix_op_token1] = ACTIONS(5858),
    [sym_int] = ACTIONS(5860),
    [sym_xint] = ACTIONS(5858),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5858),
    [anon_sym_POUNDendif] = ACTIONS(5858),
    [anon_sym_POUNDelse] = ACTIONS(5858),
  },
  [3496] = {
    [sym_xml_doc] = STATE(3496),
    [sym_block_comment] = STATE(3496),
    [sym_line_comment] = STATE(3496),
    [sym_compiler_directive_decl] = STATE(3496),
    [sym_fsi_directive_decl] = STATE(3496),
    [sym_preproc_line] = STATE(3496),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3513),
    [sym_identifier] = ACTIONS(5674),
    [anon_sym_return] = ACTIONS(5674),
    [anon_sym_do] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(6011),
    [anon_sym_let] = ACTIONS(5674),
    [anon_sym_let_BANG] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5674),
    [anon_sym_null] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_LT_AT] = ACTIONS(5674),
    [anon_sym_LT_AT_AT] = ACTIONS(5672),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5672),
    [anon_sym_new] = ACTIONS(5674),
    [anon_sym_return_BANG] = ACTIONS(5672),
    [anon_sym_yield] = ACTIONS(5674),
    [anon_sym_yield_BANG] = ACTIONS(5672),
    [anon_sym_lazy] = ACTIONS(5674),
    [anon_sym_assert] = ACTIONS(5674),
    [anon_sym_upcast] = ACTIONS(5674),
    [anon_sym_downcast] = ACTIONS(5674),
    [anon_sym_for] = ACTIONS(5674),
    [anon_sym_while] = ACTIONS(5674),
    [anon_sym_if] = ACTIONS(5674),
    [anon_sym_fun] = ACTIONS(5674),
    [anon_sym_try] = ACTIONS(5674),
    [anon_sym_match] = ACTIONS(5674),
    [anon_sym_match_BANG] = ACTIONS(5672),
    [anon_sym_function] = ACTIONS(5674),
    [anon_sym_use] = ACTIONS(5674),
    [anon_sym_use_BANG] = ACTIONS(5672),
    [anon_sym_do_BANG] = ACTIONS(5672),
    [anon_sym_begin] = ACTIONS(5674),
    [aux_sym_char_token1] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [anon_sym_AT_DQUOTE] = ACTIONS(5672),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5672),
    [sym_bool] = ACTIONS(5674),
    [sym_unit] = ACTIONS(5672),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5674),
    [sym_op_identifier] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_DOT] = ACTIONS(5672),
    [anon_sym_DASH_DOT] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5672),
    [aux_sym_prefix_op_token1] = ACTIONS(5672),
    [sym_int] = ACTIONS(5674),
    [sym_xint] = ACTIONS(5672),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5672),
  },
  [3497] = {
    [sym_xml_doc] = STATE(3497),
    [sym_block_comment] = STATE(3497),
    [sym_line_comment] = STATE(3497),
    [sym_compiler_directive_decl] = STATE(3497),
    [sym_fsi_directive_decl] = STATE(3497),
    [sym_preproc_line] = STATE(3497),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_let_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_null] = ACTIONS(2768),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2768),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_return_BANG] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_yield_BANG] = ACTIONS(2770),
    [anon_sym_lazy] = ACTIONS(2768),
    [anon_sym_assert] = ACTIONS(2768),
    [anon_sym_upcast] = ACTIONS(2768),
    [anon_sym_downcast] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_fun] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_match_BANG] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_use_BANG] = ACTIONS(2770),
    [anon_sym_do_BANG] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2768),
    [aux_sym_char_token1] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_AT_DQUOTE] = ACTIONS(2770),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2770),
    [sym_bool] = ACTIONS(2768),
    [sym_unit] = ACTIONS(2770),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2768),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [sym_int] = ACTIONS(2768),
    [sym_xint] = ACTIONS(2770),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(2770),
  },
  [3498] = {
    [sym_xml_doc] = STATE(3498),
    [sym_block_comment] = STATE(3498),
    [sym_line_comment] = STATE(3498),
    [sym_compiler_directive_decl] = STATE(3498),
    [sym_fsi_directive_decl] = STATE(3498),
    [sym_preproc_line] = STATE(3498),
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_let_BANG] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_null] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_LT_AT] = ACTIONS(3585),
    [anon_sym_LT_AT_AT] = ACTIONS(3587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_return_BANG] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3585),
    [anon_sym_yield_BANG] = ACTIONS(3587),
    [anon_sym_lazy] = ACTIONS(3585),
    [anon_sym_assert] = ACTIONS(3585),
    [anon_sym_upcast] = ACTIONS(3585),
    [anon_sym_downcast] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_fun] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_match] = ACTIONS(3585),
    [anon_sym_match_BANG] = ACTIONS(3587),
    [anon_sym_function] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3587),
    [anon_sym_use] = ACTIONS(3585),
    [anon_sym_use_BANG] = ACTIONS(3587),
    [anon_sym_do_BANG] = ACTIONS(3587),
    [anon_sym_begin] = ACTIONS(3585),
    [aux_sym_char_token1] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_AT_DQUOTE] = ACTIONS(3587),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3587),
    [sym_bool] = ACTIONS(3585),
    [sym_unit] = ACTIONS(3587),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3585),
    [sym_op_identifier] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS_DOT] = ACTIONS(3587),
    [anon_sym_DASH_DOT] = ACTIONS(3587),
    [anon_sym_PERCENT] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [aux_sym_prefix_op_token1] = ACTIONS(3587),
    [sym_int] = ACTIONS(3585),
    [sym_xint] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3587),
  },
  [3499] = {
    [sym_xml_doc] = STATE(3499),
    [sym_block_comment] = STATE(3499),
    [sym_line_comment] = STATE(3499),
    [sym_compiler_directive_decl] = STATE(3499),
    [sym_fsi_directive_decl] = STATE(3499),
    [sym_preproc_line] = STATE(3499),
    [sym_identifier] = ACTIONS(3840),
    [anon_sym_return] = ACTIONS(3840),
    [anon_sym_do] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3840),
    [anon_sym_let_BANG] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_null] = ACTIONS(3840),
    [anon_sym_AMP] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_LT_AT] = ACTIONS(3840),
    [anon_sym_LT_AT_AT] = ACTIONS(3842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3840),
    [anon_sym_return_BANG] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3840),
    [anon_sym_yield_BANG] = ACTIONS(3842),
    [anon_sym_lazy] = ACTIONS(3840),
    [anon_sym_assert] = ACTIONS(3840),
    [anon_sym_upcast] = ACTIONS(3840),
    [anon_sym_downcast] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3840),
    [anon_sym_while] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3840),
    [anon_sym_fun] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3840),
    [anon_sym_match] = ACTIONS(3840),
    [anon_sym_match_BANG] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3840),
    [anon_sym_GT] = ACTIONS(3842),
    [anon_sym_use] = ACTIONS(3840),
    [anon_sym_use_BANG] = ACTIONS(3842),
    [anon_sym_do_BANG] = ACTIONS(3842),
    [anon_sym_begin] = ACTIONS(3840),
    [aux_sym_char_token1] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_AT_DQUOTE] = ACTIONS(3842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3842),
    [sym_bool] = ACTIONS(3840),
    [sym_unit] = ACTIONS(3842),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3840),
    [sym_op_identifier] = ACTIONS(3842),
    [anon_sym_PLUS] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3840),
    [anon_sym_PLUS_DOT] = ACTIONS(3842),
    [anon_sym_DASH_DOT] = ACTIONS(3842),
    [anon_sym_PERCENT] = ACTIONS(3842),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3842),
    [aux_sym_prefix_op_token1] = ACTIONS(3842),
    [sym_int] = ACTIONS(3840),
    [sym_xint] = ACTIONS(3842),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3842),
  },
  [3500] = {
    [sym_xml_doc] = STATE(3500),
    [sym_block_comment] = STATE(3500),
    [sym_line_comment] = STATE(3500),
    [sym_compiler_directive_decl] = STATE(3500),
    [sym_fsi_directive_decl] = STATE(3500),
    [sym_preproc_line] = STATE(3500),
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_let_BANG] = ACTIONS(3583),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_null] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_LT_AT] = ACTIONS(3581),
    [anon_sym_LT_AT_AT] = ACTIONS(3583),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_return_BANG] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3581),
    [anon_sym_yield_BANG] = ACTIONS(3583),
    [anon_sym_lazy] = ACTIONS(3581),
    [anon_sym_assert] = ACTIONS(3581),
    [anon_sym_upcast] = ACTIONS(3581),
    [anon_sym_downcast] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_fun] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_match] = ACTIONS(3581),
    [anon_sym_match_BANG] = ACTIONS(3583),
    [anon_sym_function] = ACTIONS(3581),
    [anon_sym_GT] = ACTIONS(3583),
    [anon_sym_use] = ACTIONS(3581),
    [anon_sym_use_BANG] = ACTIONS(3583),
    [anon_sym_do_BANG] = ACTIONS(3583),
    [anon_sym_begin] = ACTIONS(3581),
    [aux_sym_char_token1] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_AT_DQUOTE] = ACTIONS(3583),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3583),
    [sym_bool] = ACTIONS(3581),
    [sym_unit] = ACTIONS(3583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3581),
    [sym_op_identifier] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS_DOT] = ACTIONS(3583),
    [anon_sym_DASH_DOT] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3583),
    [anon_sym_AMP_AMP] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [aux_sym_prefix_op_token1] = ACTIONS(3583),
    [sym_int] = ACTIONS(3581),
    [sym_xint] = ACTIONS(3583),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3583),
  },
  [3501] = {
    [sym_xml_doc] = STATE(3501),
    [sym_block_comment] = STATE(3501),
    [sym_line_comment] = STATE(3501),
    [sym_compiler_directive_decl] = STATE(3501),
    [sym_fsi_directive_decl] = STATE(3501),
    [sym_preproc_line] = STATE(3501),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3776),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3776),
    [anon_sym_do_BANG] = ACTIONS(3776),
    [anon_sym_begin] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3776),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3776),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3776),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3776),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3776),
    [anon_sym_DASH_DOT] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(3776),
    [anon_sym_AMP_AMP] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(3776),
    [aux_sym_prefix_op_token1] = ACTIONS(3776),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3776),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3776),
  },
  [3502] = {
    [sym_xml_doc] = STATE(3502),
    [sym_block_comment] = STATE(3502),
    [sym_line_comment] = STATE(3502),
    [sym_compiler_directive_decl] = STATE(3502),
    [sym_fsi_directive_decl] = STATE(3502),
    [sym_preproc_line] = STATE(3502),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3496),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_return] = ACTIONS(5651),
    [anon_sym_do] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(6011),
    [anon_sym_let] = ACTIONS(5651),
    [anon_sym_let_BANG] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(5651),
    [anon_sym_null] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_LBRACK] = ACTIONS(5651),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5651),
    [anon_sym_LT_AT] = ACTIONS(5651),
    [anon_sym_LT_AT_AT] = ACTIONS(5649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5649),
    [anon_sym_new] = ACTIONS(5651),
    [anon_sym_return_BANG] = ACTIONS(5649),
    [anon_sym_yield] = ACTIONS(5651),
    [anon_sym_yield_BANG] = ACTIONS(5649),
    [anon_sym_lazy] = ACTIONS(5651),
    [anon_sym_assert] = ACTIONS(5651),
    [anon_sym_upcast] = ACTIONS(5651),
    [anon_sym_downcast] = ACTIONS(5651),
    [anon_sym_for] = ACTIONS(5651),
    [anon_sym_while] = ACTIONS(5651),
    [anon_sym_if] = ACTIONS(5651),
    [anon_sym_fun] = ACTIONS(5651),
    [anon_sym_try] = ACTIONS(5651),
    [anon_sym_match] = ACTIONS(5651),
    [anon_sym_match_BANG] = ACTIONS(5649),
    [anon_sym_function] = ACTIONS(5651),
    [anon_sym_use] = ACTIONS(5651),
    [anon_sym_use_BANG] = ACTIONS(5649),
    [anon_sym_do_BANG] = ACTIONS(5649),
    [anon_sym_begin] = ACTIONS(5651),
    [aux_sym_char_token1] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(5651),
    [anon_sym_AT_DQUOTE] = ACTIONS(5649),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5649),
    [sym_bool] = ACTIONS(5651),
    [sym_unit] = ACTIONS(5649),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5651),
    [sym_op_identifier] = ACTIONS(5649),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS_DOT] = ACTIONS(5649),
    [anon_sym_DASH_DOT] = ACTIONS(5649),
    [anon_sym_PERCENT] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_TILDE] = ACTIONS(5649),
    [aux_sym_prefix_op_token1] = ACTIONS(5649),
    [sym_int] = ACTIONS(5651),
    [sym_xint] = ACTIONS(5649),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5649),
  },
  [3503] = {
    [sym_xml_doc] = STATE(3503),
    [sym_block_comment] = STATE(3503),
    [sym_line_comment] = STATE(3503),
    [sym_compiler_directive_decl] = STATE(3503),
    [sym_fsi_directive_decl] = STATE(3503),
    [sym_preproc_line] = STATE(3503),
    [sym_identifier] = ACTIONS(3602),
    [anon_sym_return] = ACTIONS(3602),
    [anon_sym_do] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_let_BANG] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_null] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3604),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3602),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3604),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_return_BANG] = ACTIONS(3604),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_yield_BANG] = ACTIONS(3604),
    [anon_sym_lazy] = ACTIONS(3602),
    [anon_sym_assert] = ACTIONS(3602),
    [anon_sym_upcast] = ACTIONS(3602),
    [anon_sym_downcast] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_fun] = ACTIONS(3602),
    [anon_sym_try] = ACTIONS(3602),
    [anon_sym_match] = ACTIONS(3602),
    [anon_sym_match_BANG] = ACTIONS(3604),
    [anon_sym_function] = ACTIONS(3602),
    [anon_sym_GT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3602),
    [anon_sym_use_BANG] = ACTIONS(3604),
    [anon_sym_do_BANG] = ACTIONS(3604),
    [anon_sym_begin] = ACTIONS(3602),
    [aux_sym_char_token1] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(3602),
    [anon_sym_AT_DQUOTE] = ACTIONS(3604),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3604),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3602),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3604),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [sym_int] = ACTIONS(3602),
    [sym_xint] = ACTIONS(3604),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3604),
  },
  [3504] = {
    [sym_xml_doc] = STATE(3504),
    [sym_block_comment] = STATE(3504),
    [sym_line_comment] = STATE(3504),
    [sym_compiler_directive_decl] = STATE(3504),
    [sym_fsi_directive_decl] = STATE(3504),
    [sym_preproc_line] = STATE(3504),
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_return] = ACTIONS(5699),
    [anon_sym_do] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_let] = ACTIONS(5699),
    [anon_sym_let_BANG] = ACTIONS(5697),
    [anon_sym_LPAREN] = ACTIONS(5699),
    [anon_sym_null] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5697),
    [anon_sym_LBRACE] = ACTIONS(5699),
    [anon_sym_LT_AT] = ACTIONS(5699),
    [anon_sym_LT_AT_AT] = ACTIONS(5697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5699),
    [anon_sym_return_BANG] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5699),
    [anon_sym_yield_BANG] = ACTIONS(5697),
    [anon_sym_lazy] = ACTIONS(5699),
    [anon_sym_assert] = ACTIONS(5699),
    [anon_sym_upcast] = ACTIONS(5699),
    [anon_sym_downcast] = ACTIONS(5699),
    [anon_sym_for] = ACTIONS(5699),
    [anon_sym_while] = ACTIONS(5699),
    [anon_sym_if] = ACTIONS(5699),
    [anon_sym_fun] = ACTIONS(5699),
    [anon_sym_try] = ACTIONS(5699),
    [anon_sym_match] = ACTIONS(5699),
    [anon_sym_match_BANG] = ACTIONS(5697),
    [anon_sym_function] = ACTIONS(5699),
    [anon_sym_use] = ACTIONS(5699),
    [anon_sym_use_BANG] = ACTIONS(5697),
    [anon_sym_do_BANG] = ACTIONS(5697),
    [anon_sym_begin] = ACTIONS(5699),
    [aux_sym_char_token1] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [anon_sym_AT_DQUOTE] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [sym_bool] = ACTIONS(5699),
    [sym_unit] = ACTIONS(5697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5699),
    [sym_op_identifier] = ACTIONS(5697),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS_DOT] = ACTIONS(5697),
    [anon_sym_DASH_DOT] = ACTIONS(5697),
    [anon_sym_PERCENT] = ACTIONS(5697),
    [anon_sym_AMP_AMP] = ACTIONS(5697),
    [anon_sym_TILDE] = ACTIONS(5697),
    [aux_sym_prefix_op_token1] = ACTIONS(5697),
    [sym_int] = ACTIONS(5699),
    [sym_xint] = ACTIONS(5697),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5697),
    [anon_sym_POUNDendif] = ACTIONS(5697),
  },
  [3505] = {
    [sym_xml_doc] = STATE(3505),
    [sym_block_comment] = STATE(3505),
    [sym_line_comment] = STATE(3505),
    [sym_compiler_directive_decl] = STATE(3505),
    [sym_fsi_directive_decl] = STATE(3505),
    [sym_preproc_line] = STATE(3505),
    [sym_identifier] = ACTIONS(3616),
    [anon_sym_return] = ACTIONS(3616),
    [anon_sym_do] = ACTIONS(3616),
    [anon_sym_let] = ACTIONS(3616),
    [anon_sym_let_BANG] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3618),
    [anon_sym_null] = ACTIONS(3616),
    [anon_sym_AMP] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(3616),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3616),
    [anon_sym_LT_AT] = ACTIONS(3616),
    [anon_sym_LT_AT_AT] = ACTIONS(3618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3616),
    [anon_sym_return_BANG] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3616),
    [anon_sym_yield_BANG] = ACTIONS(3618),
    [anon_sym_lazy] = ACTIONS(3616),
    [anon_sym_assert] = ACTIONS(3616),
    [anon_sym_upcast] = ACTIONS(3616),
    [anon_sym_downcast] = ACTIONS(3616),
    [anon_sym_for] = ACTIONS(3616),
    [anon_sym_while] = ACTIONS(3616),
    [anon_sym_if] = ACTIONS(3616),
    [anon_sym_fun] = ACTIONS(3616),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_match] = ACTIONS(3616),
    [anon_sym_match_BANG] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3616),
    [anon_sym_GT] = ACTIONS(3618),
    [anon_sym_use] = ACTIONS(3616),
    [anon_sym_use_BANG] = ACTIONS(3618),
    [anon_sym_do_BANG] = ACTIONS(3618),
    [anon_sym_begin] = ACTIONS(3616),
    [aux_sym_char_token1] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_AT_DQUOTE] = ACTIONS(3618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3618),
    [sym_bool] = ACTIONS(3616),
    [sym_unit] = ACTIONS(3618),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3616),
    [sym_op_identifier] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3616),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_PLUS_DOT] = ACTIONS(3618),
    [anon_sym_DASH_DOT] = ACTIONS(3618),
    [anon_sym_PERCENT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [aux_sym_prefix_op_token1] = ACTIONS(3618),
    [sym_int] = ACTIONS(3616),
    [sym_xint] = ACTIONS(3618),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3618),
  },
  [3506] = {
    [sym_xml_doc] = STATE(3506),
    [sym_block_comment] = STATE(3506),
    [sym_line_comment] = STATE(3506),
    [sym_compiler_directive_decl] = STATE(3506),
    [sym_fsi_directive_decl] = STATE(3506),
    [sym_preproc_line] = STATE(3506),
    [sym_identifier] = ACTIONS(3802),
    [anon_sym_return] = ACTIONS(3802),
    [anon_sym_do] = ACTIONS(3802),
    [anon_sym_let] = ACTIONS(3802),
    [anon_sym_let_BANG] = ACTIONS(3804),
    [anon_sym_LPAREN] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3804),
    [anon_sym_null] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_LT_AT] = ACTIONS(3802),
    [anon_sym_LT_AT_AT] = ACTIONS(3804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3802),
    [anon_sym_return_BANG] = ACTIONS(3804),
    [anon_sym_yield] = ACTIONS(3802),
    [anon_sym_yield_BANG] = ACTIONS(3804),
    [anon_sym_lazy] = ACTIONS(3802),
    [anon_sym_assert] = ACTIONS(3802),
    [anon_sym_upcast] = ACTIONS(3802),
    [anon_sym_downcast] = ACTIONS(3802),
    [anon_sym_for] = ACTIONS(3802),
    [anon_sym_while] = ACTIONS(3802),
    [anon_sym_if] = ACTIONS(3802),
    [anon_sym_fun] = ACTIONS(3802),
    [anon_sym_try] = ACTIONS(3802),
    [anon_sym_match] = ACTIONS(3802),
    [anon_sym_match_BANG] = ACTIONS(3804),
    [anon_sym_function] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3804),
    [anon_sym_use] = ACTIONS(3802),
    [anon_sym_use_BANG] = ACTIONS(3804),
    [anon_sym_do_BANG] = ACTIONS(3804),
    [anon_sym_begin] = ACTIONS(3802),
    [aux_sym_char_token1] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [anon_sym_AT_DQUOTE] = ACTIONS(3804),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3804),
    [sym_bool] = ACTIONS(3802),
    [sym_unit] = ACTIONS(3804),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3802),
    [sym_op_identifier] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_DOT] = ACTIONS(3804),
    [anon_sym_DASH_DOT] = ACTIONS(3804),
    [anon_sym_PERCENT] = ACTIONS(3804),
    [anon_sym_AMP_AMP] = ACTIONS(3804),
    [anon_sym_TILDE] = ACTIONS(3804),
    [aux_sym_prefix_op_token1] = ACTIONS(3804),
    [sym_int] = ACTIONS(3802),
    [sym_xint] = ACTIONS(3804),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3804),
  },
  [3507] = {
    [sym_xml_doc] = STATE(3507),
    [sym_block_comment] = STATE(3507),
    [sym_line_comment] = STATE(3507),
    [sym_compiler_directive_decl] = STATE(3507),
    [sym_fsi_directive_decl] = STATE(3507),
    [sym_preproc_line] = STATE(3507),
    [sym_identifier] = ACTIONS(3798),
    [anon_sym_return] = ACTIONS(3798),
    [anon_sym_do] = ACTIONS(3798),
    [anon_sym_let] = ACTIONS(3798),
    [anon_sym_let_BANG] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_COMMA] = ACTIONS(3800),
    [anon_sym_null] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3798),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3798),
    [anon_sym_return_BANG] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_yield_BANG] = ACTIONS(3800),
    [anon_sym_lazy] = ACTIONS(3798),
    [anon_sym_assert] = ACTIONS(3798),
    [anon_sym_upcast] = ACTIONS(3798),
    [anon_sym_downcast] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3798),
    [anon_sym_while] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(3798),
    [anon_sym_fun] = ACTIONS(3798),
    [anon_sym_try] = ACTIONS(3798),
    [anon_sym_match] = ACTIONS(3798),
    [anon_sym_match_BANG] = ACTIONS(3800),
    [anon_sym_function] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3798),
    [anon_sym_use_BANG] = ACTIONS(3800),
    [anon_sym_do_BANG] = ACTIONS(3800),
    [anon_sym_begin] = ACTIONS(3798),
    [aux_sym_char_token1] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_AT_DQUOTE] = ACTIONS(3800),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3800),
    [sym_bool] = ACTIONS(3798),
    [sym_unit] = ACTIONS(3800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3798),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3800),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [sym_int] = ACTIONS(3798),
    [sym_xint] = ACTIONS(3800),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3800),
  },
  [3508] = {
    [sym_xml_doc] = STATE(3508),
    [sym_block_comment] = STATE(3508),
    [sym_line_comment] = STATE(3508),
    [sym_compiler_directive_decl] = STATE(3508),
    [sym_fsi_directive_decl] = STATE(3508),
    [sym_preproc_line] = STATE(3508),
    [sym_identifier] = ACTIONS(5717),
    [anon_sym_return] = ACTIONS(5717),
    [anon_sym_do] = ACTIONS(5717),
    [anon_sym_and] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_let_BANG] = ACTIONS(5715),
    [anon_sym_LPAREN] = ACTIONS(5717),
    [anon_sym_null] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5715),
    [anon_sym_LBRACE] = ACTIONS(5717),
    [anon_sym_LT_AT] = ACTIONS(5717),
    [anon_sym_LT_AT_AT] = ACTIONS(5715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5715),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_return_BANG] = ACTIONS(5715),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_yield_BANG] = ACTIONS(5715),
    [anon_sym_lazy] = ACTIONS(5717),
    [anon_sym_assert] = ACTIONS(5717),
    [anon_sym_upcast] = ACTIONS(5717),
    [anon_sym_downcast] = ACTIONS(5717),
    [anon_sym_for] = ACTIONS(5717),
    [anon_sym_while] = ACTIONS(5717),
    [anon_sym_if] = ACTIONS(5717),
    [anon_sym_fun] = ACTIONS(5717),
    [anon_sym_try] = ACTIONS(5717),
    [anon_sym_match] = ACTIONS(5717),
    [anon_sym_match_BANG] = ACTIONS(5715),
    [anon_sym_function] = ACTIONS(5717),
    [anon_sym_use] = ACTIONS(5717),
    [anon_sym_use_BANG] = ACTIONS(5715),
    [anon_sym_do_BANG] = ACTIONS(5715),
    [anon_sym_begin] = ACTIONS(5717),
    [aux_sym_char_token1] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5717),
    [anon_sym_DQUOTE] = ACTIONS(5717),
    [anon_sym_AT_DQUOTE] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [sym_bool] = ACTIONS(5717),
    [sym_unit] = ACTIONS(5715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5717),
    [sym_op_identifier] = ACTIONS(5715),
    [anon_sym_PLUS] = ACTIONS(5717),
    [anon_sym_DASH] = ACTIONS(5717),
    [anon_sym_PLUS_DOT] = ACTIONS(5715),
    [anon_sym_DASH_DOT] = ACTIONS(5715),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_AMP_AMP] = ACTIONS(5715),
    [anon_sym_TILDE] = ACTIONS(5715),
    [aux_sym_prefix_op_token1] = ACTIONS(5715),
    [sym_int] = ACTIONS(5717),
    [sym_xint] = ACTIONS(5715),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5715),
    [anon_sym_POUNDendif] = ACTIONS(5715),
  },
  [3509] = {
    [sym_xml_doc] = STATE(3509),
    [sym_block_comment] = STATE(3509),
    [sym_line_comment] = STATE(3509),
    [sym_compiler_directive_decl] = STATE(3509),
    [sym_fsi_directive_decl] = STATE(3509),
    [sym_preproc_line] = STATE(3509),
    [sym_identifier] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3825),
    [anon_sym_do] = ACTIONS(3825),
    [anon_sym_let] = ACTIONS(3825),
    [anon_sym_let_BANG] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_null] = ACTIONS(3825),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_LT_AT] = ACTIONS(3825),
    [anon_sym_LT_AT_AT] = ACTIONS(3827),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3825),
    [anon_sym_return_BANG] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3825),
    [anon_sym_yield_BANG] = ACTIONS(3827),
    [anon_sym_lazy] = ACTIONS(3825),
    [anon_sym_assert] = ACTIONS(3825),
    [anon_sym_upcast] = ACTIONS(3825),
    [anon_sym_downcast] = ACTIONS(3825),
    [anon_sym_for] = ACTIONS(3825),
    [anon_sym_while] = ACTIONS(3825),
    [anon_sym_if] = ACTIONS(3825),
    [anon_sym_fun] = ACTIONS(3825),
    [anon_sym_try] = ACTIONS(3825),
    [anon_sym_match] = ACTIONS(3825),
    [anon_sym_match_BANG] = ACTIONS(3827),
    [anon_sym_function] = ACTIONS(3825),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_use] = ACTIONS(3825),
    [anon_sym_use_BANG] = ACTIONS(3827),
    [anon_sym_do_BANG] = ACTIONS(3827),
    [anon_sym_begin] = ACTIONS(3825),
    [aux_sym_char_token1] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3825),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_AT_DQUOTE] = ACTIONS(3827),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3827),
    [sym_bool] = ACTIONS(3825),
    [sym_unit] = ACTIONS(3827),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3825),
    [sym_op_identifier] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS_DOT] = ACTIONS(3827),
    [anon_sym_DASH_DOT] = ACTIONS(3827),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [aux_sym_prefix_op_token1] = ACTIONS(3827),
    [sym_int] = ACTIONS(3825),
    [sym_xint] = ACTIONS(3827),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3827),
  },
  [3510] = {
    [sym_xml_doc] = STATE(3510),
    [sym_block_comment] = STATE(3510),
    [sym_line_comment] = STATE(3510),
    [sym_compiler_directive_decl] = STATE(3510),
    [sym_fsi_directive_decl] = STATE(3510),
    [sym_preproc_line] = STATE(3510),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_return] = ACTIONS(3656),
    [anon_sym_do] = ACTIONS(3656),
    [anon_sym_let] = ACTIONS(3656),
    [anon_sym_let_BANG] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_COMMA] = ACTIONS(3658),
    [anon_sym_null] = ACTIONS(3656),
    [anon_sym_AMP] = ACTIONS(3656),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3656),
    [anon_sym_LT_AT] = ACTIONS(3656),
    [anon_sym_LT_AT_AT] = ACTIONS(3658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3656),
    [anon_sym_return_BANG] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3656),
    [anon_sym_yield_BANG] = ACTIONS(3658),
    [anon_sym_lazy] = ACTIONS(3656),
    [anon_sym_assert] = ACTIONS(3656),
    [anon_sym_upcast] = ACTIONS(3656),
    [anon_sym_downcast] = ACTIONS(3656),
    [anon_sym_for] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(3656),
    [anon_sym_if] = ACTIONS(3656),
    [anon_sym_fun] = ACTIONS(3656),
    [anon_sym_try] = ACTIONS(3656),
    [anon_sym_match] = ACTIONS(3656),
    [anon_sym_match_BANG] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(3656),
    [anon_sym_GT] = ACTIONS(3658),
    [anon_sym_use] = ACTIONS(3656),
    [anon_sym_use_BANG] = ACTIONS(3658),
    [anon_sym_do_BANG] = ACTIONS(3658),
    [anon_sym_begin] = ACTIONS(3656),
    [aux_sym_char_token1] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3656),
    [anon_sym_DQUOTE] = ACTIONS(3656),
    [anon_sym_AT_DQUOTE] = ACTIONS(3658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3658),
    [sym_bool] = ACTIONS(3656),
    [sym_unit] = ACTIONS(3658),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3656),
    [sym_op_identifier] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3656),
    [anon_sym_DASH] = ACTIONS(3656),
    [anon_sym_PLUS_DOT] = ACTIONS(3658),
    [anon_sym_DASH_DOT] = ACTIONS(3658),
    [anon_sym_PERCENT] = ACTIONS(3658),
    [anon_sym_AMP_AMP] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [aux_sym_prefix_op_token1] = ACTIONS(3658),
    [sym_int] = ACTIONS(3656),
    [sym_xint] = ACTIONS(3658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3658),
  },
  [3511] = {
    [sym_xml_doc] = STATE(3511),
    [sym_block_comment] = STATE(3511),
    [sym_line_comment] = STATE(3511),
    [sym_compiler_directive_decl] = STATE(3511),
    [sym_fsi_directive_decl] = STATE(3511),
    [sym_preproc_line] = STATE(3511),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3695),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3695),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_GT] = ACTIONS(3695),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3695),
    [anon_sym_do_BANG] = ACTIONS(3695),
    [anon_sym_begin] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3695),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3695),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3695),
    [anon_sym_DASH_DOT] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3695),
    [anon_sym_AMP_AMP] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [aux_sym_prefix_op_token1] = ACTIONS(3695),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3695),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3695),
  },
  [3512] = {
    [sym_xml_doc] = STATE(3512),
    [sym_block_comment] = STATE(3512),
    [sym_line_comment] = STATE(3512),
    [sym_compiler_directive_decl] = STATE(3512),
    [sym_fsi_directive_decl] = STATE(3512),
    [sym_preproc_line] = STATE(3512),
    [sym_identifier] = ACTIONS(3790),
    [anon_sym_return] = ACTIONS(3790),
    [anon_sym_do] = ACTIONS(3790),
    [anon_sym_let] = ACTIONS(3790),
    [anon_sym_let_BANG] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3792),
    [anon_sym_null] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3790),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_LT_AT] = ACTIONS(3790),
    [anon_sym_LT_AT_AT] = ACTIONS(3792),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_return_BANG] = ACTIONS(3792),
    [anon_sym_yield] = ACTIONS(3790),
    [anon_sym_yield_BANG] = ACTIONS(3792),
    [anon_sym_lazy] = ACTIONS(3790),
    [anon_sym_assert] = ACTIONS(3790),
    [anon_sym_upcast] = ACTIONS(3790),
    [anon_sym_downcast] = ACTIONS(3790),
    [anon_sym_for] = ACTIONS(3790),
    [anon_sym_while] = ACTIONS(3790),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_fun] = ACTIONS(3790),
    [anon_sym_try] = ACTIONS(3790),
    [anon_sym_match] = ACTIONS(3790),
    [anon_sym_match_BANG] = ACTIONS(3792),
    [anon_sym_function] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3792),
    [anon_sym_use] = ACTIONS(3790),
    [anon_sym_use_BANG] = ACTIONS(3792),
    [anon_sym_do_BANG] = ACTIONS(3792),
    [anon_sym_begin] = ACTIONS(3790),
    [aux_sym_char_token1] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_AT_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3792),
    [sym_bool] = ACTIONS(3790),
    [sym_unit] = ACTIONS(3792),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3790),
    [sym_op_identifier] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_DOT] = ACTIONS(3792),
    [anon_sym_DASH_DOT] = ACTIONS(3792),
    [anon_sym_PERCENT] = ACTIONS(3792),
    [anon_sym_AMP_AMP] = ACTIONS(3792),
    [anon_sym_TILDE] = ACTIONS(3792),
    [aux_sym_prefix_op_token1] = ACTIONS(3792),
    [sym_int] = ACTIONS(3790),
    [sym_xint] = ACTIONS(3792),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3792),
  },
  [3513] = {
    [sym_xml_doc] = STATE(3513),
    [sym_block_comment] = STATE(3513),
    [sym_line_comment] = STATE(3513),
    [sym_compiler_directive_decl] = STATE(3513),
    [sym_fsi_directive_decl] = STATE(3513),
    [sym_preproc_line] = STATE(3513),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3513),
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_return] = ACTIONS(5660),
    [anon_sym_do] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(6013),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_let_BANG] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_null] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5658),
    [anon_sym_LBRACE] = ACTIONS(5660),
    [anon_sym_LT_AT] = ACTIONS(5660),
    [anon_sym_LT_AT_AT] = ACTIONS(5658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5658),
    [anon_sym_new] = ACTIONS(5660),
    [anon_sym_return_BANG] = ACTIONS(5658),
    [anon_sym_yield] = ACTIONS(5660),
    [anon_sym_yield_BANG] = ACTIONS(5658),
    [anon_sym_lazy] = ACTIONS(5660),
    [anon_sym_assert] = ACTIONS(5660),
    [anon_sym_upcast] = ACTIONS(5660),
    [anon_sym_downcast] = ACTIONS(5660),
    [anon_sym_for] = ACTIONS(5660),
    [anon_sym_while] = ACTIONS(5660),
    [anon_sym_if] = ACTIONS(5660),
    [anon_sym_fun] = ACTIONS(5660),
    [anon_sym_try] = ACTIONS(5660),
    [anon_sym_match] = ACTIONS(5660),
    [anon_sym_match_BANG] = ACTIONS(5658),
    [anon_sym_function] = ACTIONS(5660),
    [anon_sym_use] = ACTIONS(5660),
    [anon_sym_use_BANG] = ACTIONS(5658),
    [anon_sym_do_BANG] = ACTIONS(5658),
    [anon_sym_begin] = ACTIONS(5660),
    [aux_sym_char_token1] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5660),
    [anon_sym_AT_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5658),
    [sym_bool] = ACTIONS(5660),
    [sym_unit] = ACTIONS(5658),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5660),
    [sym_op_identifier] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS_DOT] = ACTIONS(5658),
    [anon_sym_DASH_DOT] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_TILDE] = ACTIONS(5658),
    [aux_sym_prefix_op_token1] = ACTIONS(5658),
    [sym_int] = ACTIONS(5660),
    [sym_xint] = ACTIONS(5658),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5658),
  },
  [3514] = {
    [sym_xml_doc] = STATE(3514),
    [sym_block_comment] = STATE(3514),
    [sym_line_comment] = STATE(3514),
    [sym_compiler_directive_decl] = STATE(3514),
    [sym_fsi_directive_decl] = STATE(3514),
    [sym_preproc_line] = STATE(3514),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_return] = ACTIONS(3786),
    [anon_sym_do] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3786),
    [anon_sym_let_BANG] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_null] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_LT_AT] = ACTIONS(3786),
    [anon_sym_LT_AT_AT] = ACTIONS(3788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3786),
    [anon_sym_return_BANG] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3786),
    [anon_sym_yield_BANG] = ACTIONS(3788),
    [anon_sym_lazy] = ACTIONS(3786),
    [anon_sym_assert] = ACTIONS(3786),
    [anon_sym_upcast] = ACTIONS(3786),
    [anon_sym_downcast] = ACTIONS(3786),
    [anon_sym_for] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3786),
    [anon_sym_fun] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3786),
    [anon_sym_match] = ACTIONS(3786),
    [anon_sym_match_BANG] = ACTIONS(3788),
    [anon_sym_function] = ACTIONS(3786),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_use] = ACTIONS(3786),
    [anon_sym_use_BANG] = ACTIONS(3788),
    [anon_sym_do_BANG] = ACTIONS(3788),
    [anon_sym_begin] = ACTIONS(3786),
    [aux_sym_char_token1] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_AT_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3788),
    [sym_bool] = ACTIONS(3786),
    [sym_unit] = ACTIONS(3788),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3786),
    [sym_op_identifier] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_DOT] = ACTIONS(3788),
    [anon_sym_DASH_DOT] = ACTIONS(3788),
    [anon_sym_PERCENT] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_TILDE] = ACTIONS(3788),
    [aux_sym_prefix_op_token1] = ACTIONS(3788),
    [sym_int] = ACTIONS(3786),
    [sym_xint] = ACTIONS(3788),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3788),
  },
  [3515] = {
    [sym_xml_doc] = STATE(3515),
    [sym_block_comment] = STATE(3515),
    [sym_line_comment] = STATE(3515),
    [sym_compiler_directive_decl] = STATE(3515),
    [sym_fsi_directive_decl] = STATE(3515),
    [sym_preproc_line] = STATE(3515),
    [sym_identifier] = ACTIONS(3722),
    [anon_sym_return] = ACTIONS(3722),
    [anon_sym_do] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_let_BANG] = ACTIONS(3724),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3724),
    [anon_sym_null] = ACTIONS(3722),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3722),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3724),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_LT_AT] = ACTIONS(3722),
    [anon_sym_LT_AT_AT] = ACTIONS(3724),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3724),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_return_BANG] = ACTIONS(3724),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_yield_BANG] = ACTIONS(3724),
    [anon_sym_lazy] = ACTIONS(3722),
    [anon_sym_assert] = ACTIONS(3722),
    [anon_sym_upcast] = ACTIONS(3722),
    [anon_sym_downcast] = ACTIONS(3722),
    [anon_sym_for] = ACTIONS(3722),
    [anon_sym_while] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(3722),
    [anon_sym_fun] = ACTIONS(3722),
    [anon_sym_try] = ACTIONS(3722),
    [anon_sym_match] = ACTIONS(3722),
    [anon_sym_match_BANG] = ACTIONS(3724),
    [anon_sym_function] = ACTIONS(3722),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_use] = ACTIONS(3722),
    [anon_sym_use_BANG] = ACTIONS(3724),
    [anon_sym_do_BANG] = ACTIONS(3724),
    [anon_sym_begin] = ACTIONS(3722),
    [aux_sym_char_token1] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [anon_sym_AT_DQUOTE] = ACTIONS(3724),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3724),
    [sym_bool] = ACTIONS(3722),
    [sym_unit] = ACTIONS(3724),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3722),
    [sym_op_identifier] = ACTIONS(3724),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_PLUS_DOT] = ACTIONS(3724),
    [anon_sym_DASH_DOT] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_AMP_AMP] = ACTIONS(3724),
    [anon_sym_TILDE] = ACTIONS(3724),
    [aux_sym_prefix_op_token1] = ACTIONS(3724),
    [sym_int] = ACTIONS(3722),
    [sym_xint] = ACTIONS(3724),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3724),
  },
  [3516] = {
    [sym_xml_doc] = STATE(3516),
    [sym_block_comment] = STATE(3516),
    [sym_line_comment] = STATE(3516),
    [sym_compiler_directive_decl] = STATE(3516),
    [sym_fsi_directive_decl] = STATE(3516),
    [sym_preproc_line] = STATE(3516),
    [sym_identifier] = ACTIONS(5713),
    [anon_sym_return] = ACTIONS(5713),
    [anon_sym_do] = ACTIONS(5713),
    [anon_sym_and] = ACTIONS(5713),
    [anon_sym_let] = ACTIONS(5713),
    [anon_sym_let_BANG] = ACTIONS(5711),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_null] = ACTIONS(5713),
    [anon_sym_AMP] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5711),
    [anon_sym_LBRACE] = ACTIONS(5713),
    [anon_sym_LT_AT] = ACTIONS(5713),
    [anon_sym_LT_AT_AT] = ACTIONS(5711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5711),
    [anon_sym_new] = ACTIONS(5713),
    [anon_sym_return_BANG] = ACTIONS(5711),
    [anon_sym_yield] = ACTIONS(5713),
    [anon_sym_yield_BANG] = ACTIONS(5711),
    [anon_sym_lazy] = ACTIONS(5713),
    [anon_sym_assert] = ACTIONS(5713),
    [anon_sym_upcast] = ACTIONS(5713),
    [anon_sym_downcast] = ACTIONS(5713),
    [anon_sym_for] = ACTIONS(5713),
    [anon_sym_while] = ACTIONS(5713),
    [anon_sym_if] = ACTIONS(5713),
    [anon_sym_fun] = ACTIONS(5713),
    [anon_sym_try] = ACTIONS(5713),
    [anon_sym_match] = ACTIONS(5713),
    [anon_sym_match_BANG] = ACTIONS(5711),
    [anon_sym_function] = ACTIONS(5713),
    [anon_sym_use] = ACTIONS(5713),
    [anon_sym_use_BANG] = ACTIONS(5711),
    [anon_sym_do_BANG] = ACTIONS(5711),
    [anon_sym_begin] = ACTIONS(5713),
    [aux_sym_char_token1] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5713),
    [anon_sym_DQUOTE] = ACTIONS(5713),
    [anon_sym_AT_DQUOTE] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [sym_bool] = ACTIONS(5713),
    [sym_unit] = ACTIONS(5711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5713),
    [sym_op_identifier] = ACTIONS(5711),
    [anon_sym_PLUS] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_DOT] = ACTIONS(5711),
    [anon_sym_DASH_DOT] = ACTIONS(5711),
    [anon_sym_PERCENT] = ACTIONS(5711),
    [anon_sym_AMP_AMP] = ACTIONS(5711),
    [anon_sym_TILDE] = ACTIONS(5711),
    [aux_sym_prefix_op_token1] = ACTIONS(5711),
    [sym_int] = ACTIONS(5713),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5711),
    [anon_sym_POUNDendif] = ACTIONS(5711),
  },
  [3517] = {
    [sym_xml_doc] = STATE(3517),
    [sym_block_comment] = STATE(3517),
    [sym_line_comment] = STATE(3517),
    [sym_compiler_directive_decl] = STATE(3517),
    [sym_fsi_directive_decl] = STATE(3517),
    [sym_preproc_line] = STATE(3517),
    [sym_identifier] = ACTIONS(3782),
    [anon_sym_return] = ACTIONS(3782),
    [anon_sym_do] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_let_BANG] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_null] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LT_AT] = ACTIONS(3782),
    [anon_sym_LT_AT_AT] = ACTIONS(3784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_return_BANG] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_yield_BANG] = ACTIONS(3784),
    [anon_sym_lazy] = ACTIONS(3782),
    [anon_sym_assert] = ACTIONS(3782),
    [anon_sym_upcast] = ACTIONS(3782),
    [anon_sym_downcast] = ACTIONS(3782),
    [anon_sym_for] = ACTIONS(3782),
    [anon_sym_while] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3782),
    [anon_sym_fun] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_match] = ACTIONS(3782),
    [anon_sym_match_BANG] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3782),
    [anon_sym_GT] = ACTIONS(3784),
    [anon_sym_use] = ACTIONS(3782),
    [anon_sym_use_BANG] = ACTIONS(3784),
    [anon_sym_do_BANG] = ACTIONS(3784),
    [anon_sym_begin] = ACTIONS(3782),
    [aux_sym_char_token1] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_AT_DQUOTE] = ACTIONS(3784),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3784),
    [sym_bool] = ACTIONS(3782),
    [sym_unit] = ACTIONS(3784),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3782),
    [sym_op_identifier] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_DOT] = ACTIONS(3784),
    [anon_sym_DASH_DOT] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_TILDE] = ACTIONS(3784),
    [aux_sym_prefix_op_token1] = ACTIONS(3784),
    [sym_int] = ACTIONS(3782),
    [sym_xint] = ACTIONS(3784),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3784),
  },
  [3518] = {
    [sym_xml_doc] = STATE(3518),
    [sym_block_comment] = STATE(3518),
    [sym_line_comment] = STATE(3518),
    [sym_compiler_directive_decl] = STATE(3518),
    [sym_fsi_directive_decl] = STATE(3518),
    [sym_preproc_line] = STATE(3518),
    [sym_identifier] = ACTIONS(3836),
    [anon_sym_return] = ACTIONS(3836),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3836),
    [anon_sym_let_BANG] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3838),
    [anon_sym_null] = ACTIONS(3836),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_LT_AT] = ACTIONS(3836),
    [anon_sym_LT_AT_AT] = ACTIONS(3838),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3836),
    [anon_sym_return_BANG] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3836),
    [anon_sym_yield_BANG] = ACTIONS(3838),
    [anon_sym_lazy] = ACTIONS(3836),
    [anon_sym_assert] = ACTIONS(3836),
    [anon_sym_upcast] = ACTIONS(3836),
    [anon_sym_downcast] = ACTIONS(3836),
    [anon_sym_for] = ACTIONS(3836),
    [anon_sym_while] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3836),
    [anon_sym_fun] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3836),
    [anon_sym_match] = ACTIONS(3836),
    [anon_sym_match_BANG] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3836),
    [anon_sym_GT] = ACTIONS(3838),
    [anon_sym_use] = ACTIONS(3836),
    [anon_sym_use_BANG] = ACTIONS(3838),
    [anon_sym_do_BANG] = ACTIONS(3838),
    [anon_sym_begin] = ACTIONS(3836),
    [aux_sym_char_token1] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_AT_DQUOTE] = ACTIONS(3838),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3838),
    [sym_bool] = ACTIONS(3836),
    [sym_unit] = ACTIONS(3838),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3836),
    [sym_op_identifier] = ACTIONS(3838),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_PLUS_DOT] = ACTIONS(3838),
    [anon_sym_DASH_DOT] = ACTIONS(3838),
    [anon_sym_PERCENT] = ACTIONS(3838),
    [anon_sym_AMP_AMP] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3838),
    [aux_sym_prefix_op_token1] = ACTIONS(3838),
    [sym_int] = ACTIONS(3836),
    [sym_xint] = ACTIONS(3838),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3838),
  },
  [3519] = {
    [sym_xml_doc] = STATE(3519),
    [sym_block_comment] = STATE(3519),
    [sym_line_comment] = STATE(3519),
    [sym_compiler_directive_decl] = STATE(3519),
    [sym_fsi_directive_decl] = STATE(3519),
    [sym_preproc_line] = STATE(3519),
    [sym_identifier] = ACTIONS(3778),
    [anon_sym_return] = ACTIONS(3778),
    [anon_sym_do] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3778),
    [anon_sym_let_BANG] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_null] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3778),
    [anon_sym_LT_AT_AT] = ACTIONS(3780),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3778),
    [anon_sym_return_BANG] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3778),
    [anon_sym_yield_BANG] = ACTIONS(3780),
    [anon_sym_lazy] = ACTIONS(3778),
    [anon_sym_assert] = ACTIONS(3778),
    [anon_sym_upcast] = ACTIONS(3778),
    [anon_sym_downcast] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3778),
    [anon_sym_while] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3778),
    [anon_sym_fun] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3778),
    [anon_sym_match] = ACTIONS(3778),
    [anon_sym_match_BANG] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3780),
    [anon_sym_use] = ACTIONS(3778),
    [anon_sym_use_BANG] = ACTIONS(3780),
    [anon_sym_do_BANG] = ACTIONS(3780),
    [anon_sym_begin] = ACTIONS(3778),
    [aux_sym_char_token1] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_AT_DQUOTE] = ACTIONS(3780),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3780),
    [sym_bool] = ACTIONS(3778),
    [sym_unit] = ACTIONS(3780),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3778),
    [sym_op_identifier] = ACTIONS(3780),
    [anon_sym_PLUS] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_PLUS_DOT] = ACTIONS(3780),
    [anon_sym_DASH_DOT] = ACTIONS(3780),
    [anon_sym_PERCENT] = ACTIONS(3780),
    [anon_sym_AMP_AMP] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(3780),
    [aux_sym_prefix_op_token1] = ACTIONS(3780),
    [sym_int] = ACTIONS(3778),
    [sym_xint] = ACTIONS(3780),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3780),
  },
  [3520] = {
    [sym_xml_doc] = STATE(3520),
    [sym_block_comment] = STATE(3520),
    [sym_line_comment] = STATE(3520),
    [sym_compiler_directive_decl] = STATE(3520),
    [sym_fsi_directive_decl] = STATE(3520),
    [sym_preproc_line] = STATE(3520),
    [sym_identifier] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_let] = ACTIONS(3577),
    [anon_sym_let_BANG] = ACTIONS(3579),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_null] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_LT_AT] = ACTIONS(3577),
    [anon_sym_LT_AT_AT] = ACTIONS(3579),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_return_BANG] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3577),
    [anon_sym_yield_BANG] = ACTIONS(3579),
    [anon_sym_lazy] = ACTIONS(3577),
    [anon_sym_assert] = ACTIONS(3577),
    [anon_sym_upcast] = ACTIONS(3577),
    [anon_sym_downcast] = ACTIONS(3577),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_fun] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_match] = ACTIONS(3577),
    [anon_sym_match_BANG] = ACTIONS(3579),
    [anon_sym_function] = ACTIONS(3577),
    [anon_sym_GT] = ACTIONS(3579),
    [anon_sym_use] = ACTIONS(3577),
    [anon_sym_use_BANG] = ACTIONS(3579),
    [anon_sym_do_BANG] = ACTIONS(3579),
    [anon_sym_begin] = ACTIONS(3577),
    [aux_sym_char_token1] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_AT_DQUOTE] = ACTIONS(3579),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3579),
    [sym_bool] = ACTIONS(3577),
    [sym_unit] = ACTIONS(3579),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3577),
    [sym_op_identifier] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS_DOT] = ACTIONS(3579),
    [anon_sym_DASH_DOT] = ACTIONS(3579),
    [anon_sym_PERCENT] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [aux_sym_prefix_op_token1] = ACTIONS(3579),
    [sym_int] = ACTIONS(3577),
    [sym_xint] = ACTIONS(3579),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3579),
  },
  [3521] = {
    [sym_xml_doc] = STATE(3521),
    [sym_block_comment] = STATE(3521),
    [sym_line_comment] = STATE(3521),
    [sym_compiler_directive_decl] = STATE(3521),
    [sym_fsi_directive_decl] = STATE(3521),
    [sym_preproc_line] = STATE(3521),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_return] = ACTIONS(3734),
    [anon_sym_do] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_let_BANG] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_null] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3734),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3736),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_return_BANG] = ACTIONS(3736),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_yield_BANG] = ACTIONS(3736),
    [anon_sym_lazy] = ACTIONS(3734),
    [anon_sym_assert] = ACTIONS(3734),
    [anon_sym_upcast] = ACTIONS(3734),
    [anon_sym_downcast] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3734),
    [anon_sym_while] = ACTIONS(3734),
    [anon_sym_if] = ACTIONS(3734),
    [anon_sym_fun] = ACTIONS(3734),
    [anon_sym_try] = ACTIONS(3734),
    [anon_sym_match] = ACTIONS(3734),
    [anon_sym_match_BANG] = ACTIONS(3736),
    [anon_sym_function] = ACTIONS(3734),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3734),
    [anon_sym_use_BANG] = ACTIONS(3736),
    [anon_sym_do_BANG] = ACTIONS(3736),
    [anon_sym_begin] = ACTIONS(3734),
    [aux_sym_char_token1] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [anon_sym_AT_DQUOTE] = ACTIONS(3736),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3736),
    [sym_bool] = ACTIONS(3734),
    [sym_unit] = ACTIONS(3736),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3734),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3734),
    [anon_sym_DASH] = ACTIONS(3734),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3736),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [sym_int] = ACTIONS(3734),
    [sym_xint] = ACTIONS(3736),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3736),
  },
  [3522] = {
    [sym_xml_doc] = STATE(3522),
    [sym_block_comment] = STATE(3522),
    [sym_line_comment] = STATE(3522),
    [sym_compiler_directive_decl] = STATE(3522),
    [sym_fsi_directive_decl] = STATE(3522),
    [sym_preproc_line] = STATE(3522),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_return] = ACTIONS(3642),
    [anon_sym_do] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_let_BANG] = ACTIONS(3644),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_COMMA] = ACTIONS(3644),
    [anon_sym_null] = ACTIONS(3642),
    [anon_sym_AMP] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3644),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_LT_AT] = ACTIONS(3642),
    [anon_sym_LT_AT_AT] = ACTIONS(3644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3644),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_return_BANG] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_yield_BANG] = ACTIONS(3644),
    [anon_sym_lazy] = ACTIONS(3642),
    [anon_sym_assert] = ACTIONS(3642),
    [anon_sym_upcast] = ACTIONS(3642),
    [anon_sym_downcast] = ACTIONS(3642),
    [anon_sym_for] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(3642),
    [anon_sym_if] = ACTIONS(3642),
    [anon_sym_fun] = ACTIONS(3642),
    [anon_sym_try] = ACTIONS(3642),
    [anon_sym_match] = ACTIONS(3642),
    [anon_sym_match_BANG] = ACTIONS(3644),
    [anon_sym_function] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3644),
    [anon_sym_use] = ACTIONS(3642),
    [anon_sym_use_BANG] = ACTIONS(3644),
    [anon_sym_do_BANG] = ACTIONS(3644),
    [anon_sym_begin] = ACTIONS(3642),
    [aux_sym_char_token1] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_AT_DQUOTE] = ACTIONS(3644),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3644),
    [sym_bool] = ACTIONS(3642),
    [sym_unit] = ACTIONS(3644),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3642),
    [sym_op_identifier] = ACTIONS(3644),
    [anon_sym_PLUS] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3642),
    [anon_sym_PLUS_DOT] = ACTIONS(3644),
    [anon_sym_DASH_DOT] = ACTIONS(3644),
    [anon_sym_PERCENT] = ACTIONS(3644),
    [anon_sym_AMP_AMP] = ACTIONS(3644),
    [anon_sym_TILDE] = ACTIONS(3644),
    [aux_sym_prefix_op_token1] = ACTIONS(3644),
    [sym_int] = ACTIONS(3642),
    [sym_xint] = ACTIONS(3644),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3644),
  },
  [3523] = {
    [sym_xml_doc] = STATE(3523),
    [sym_block_comment] = STATE(3523),
    [sym_line_comment] = STATE(3523),
    [sym_compiler_directive_decl] = STATE(3523),
    [sym_fsi_directive_decl] = STATE(3523),
    [sym_preproc_line] = STATE(3523),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_return] = ACTIONS(3738),
    [anon_sym_do] = ACTIONS(3738),
    [anon_sym_let] = ACTIONS(3738),
    [anon_sym_let_BANG] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_null] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3740),
    [anon_sym_LBRACE] = ACTIONS(3738),
    [anon_sym_LT_AT] = ACTIONS(3738),
    [anon_sym_LT_AT_AT] = ACTIONS(3740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3738),
    [anon_sym_return_BANG] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3738),
    [anon_sym_yield_BANG] = ACTIONS(3740),
    [anon_sym_lazy] = ACTIONS(3738),
    [anon_sym_assert] = ACTIONS(3738),
    [anon_sym_upcast] = ACTIONS(3738),
    [anon_sym_downcast] = ACTIONS(3738),
    [anon_sym_for] = ACTIONS(3738),
    [anon_sym_while] = ACTIONS(3738),
    [anon_sym_if] = ACTIONS(3738),
    [anon_sym_fun] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3738),
    [anon_sym_match] = ACTIONS(3738),
    [anon_sym_match_BANG] = ACTIONS(3740),
    [anon_sym_function] = ACTIONS(3738),
    [anon_sym_GT] = ACTIONS(3740),
    [anon_sym_use] = ACTIONS(3738),
    [anon_sym_use_BANG] = ACTIONS(3740),
    [anon_sym_do_BANG] = ACTIONS(3740),
    [anon_sym_begin] = ACTIONS(3738),
    [aux_sym_char_token1] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(3738),
    [anon_sym_AT_DQUOTE] = ACTIONS(3740),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3740),
    [sym_bool] = ACTIONS(3738),
    [sym_unit] = ACTIONS(3740),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3738),
    [sym_op_identifier] = ACTIONS(3740),
    [anon_sym_PLUS] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3738),
    [anon_sym_PLUS_DOT] = ACTIONS(3740),
    [anon_sym_DASH_DOT] = ACTIONS(3740),
    [anon_sym_PERCENT] = ACTIONS(3740),
    [anon_sym_AMP_AMP] = ACTIONS(3740),
    [anon_sym_TILDE] = ACTIONS(3740),
    [aux_sym_prefix_op_token1] = ACTIONS(3740),
    [sym_int] = ACTIONS(3738),
    [sym_xint] = ACTIONS(3740),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3740),
  },
  [3524] = {
    [sym_xml_doc] = STATE(3524),
    [sym_block_comment] = STATE(3524),
    [sym_line_comment] = STATE(3524),
    [sym_compiler_directive_decl] = STATE(3524),
    [sym_fsi_directive_decl] = STATE(3524),
    [sym_preproc_line] = STATE(3524),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_let_BANG] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_null] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LT_AT] = ACTIONS(3746),
    [anon_sym_LT_AT_AT] = ACTIONS(3748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_return_BANG] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_yield_BANG] = ACTIONS(3748),
    [anon_sym_lazy] = ACTIONS(3746),
    [anon_sym_assert] = ACTIONS(3746),
    [anon_sym_upcast] = ACTIONS(3746),
    [anon_sym_downcast] = ACTIONS(3746),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_fun] = ACTIONS(3746),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_match] = ACTIONS(3746),
    [anon_sym_match_BANG] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3748),
    [anon_sym_use] = ACTIONS(3746),
    [anon_sym_use_BANG] = ACTIONS(3748),
    [anon_sym_do_BANG] = ACTIONS(3748),
    [anon_sym_begin] = ACTIONS(3746),
    [aux_sym_char_token1] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3746),
    [anon_sym_AT_DQUOTE] = ACTIONS(3748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3748),
    [sym_bool] = ACTIONS(3746),
    [sym_unit] = ACTIONS(3748),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3746),
    [sym_op_identifier] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS_DOT] = ACTIONS(3748),
    [anon_sym_DASH_DOT] = ACTIONS(3748),
    [anon_sym_PERCENT] = ACTIONS(3748),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3748),
    [aux_sym_prefix_op_token1] = ACTIONS(3748),
    [sym_int] = ACTIONS(3746),
    [sym_xint] = ACTIONS(3748),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3748),
  },
  [3525] = {
    [sym_xml_doc] = STATE(3525),
    [sym_block_comment] = STATE(3525),
    [sym_line_comment] = STATE(3525),
    [sym_compiler_directive_decl] = STATE(3525),
    [sym_fsi_directive_decl] = STATE(3525),
    [sym_preproc_line] = STATE(3525),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_return] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3766),
    [anon_sym_let_BANG] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_null] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_LT_AT] = ACTIONS(3766),
    [anon_sym_LT_AT_AT] = ACTIONS(3768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3766),
    [anon_sym_return_BANG] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3766),
    [anon_sym_yield_BANG] = ACTIONS(3768),
    [anon_sym_lazy] = ACTIONS(3766),
    [anon_sym_assert] = ACTIONS(3766),
    [anon_sym_upcast] = ACTIONS(3766),
    [anon_sym_downcast] = ACTIONS(3766),
    [anon_sym_for] = ACTIONS(3766),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3766),
    [anon_sym_fun] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3766),
    [anon_sym_match] = ACTIONS(3766),
    [anon_sym_match_BANG] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3766),
    [anon_sym_GT] = ACTIONS(3768),
    [anon_sym_use] = ACTIONS(3766),
    [anon_sym_use_BANG] = ACTIONS(3768),
    [anon_sym_do_BANG] = ACTIONS(3768),
    [anon_sym_begin] = ACTIONS(3766),
    [aux_sym_char_token1] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_AT_DQUOTE] = ACTIONS(3768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3768),
    [sym_bool] = ACTIONS(3766),
    [sym_unit] = ACTIONS(3768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3766),
    [sym_op_identifier] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS_DOT] = ACTIONS(3768),
    [anon_sym_DASH_DOT] = ACTIONS(3768),
    [anon_sym_PERCENT] = ACTIONS(3768),
    [anon_sym_AMP_AMP] = ACTIONS(3768),
    [anon_sym_TILDE] = ACTIONS(3768),
    [aux_sym_prefix_op_token1] = ACTIONS(3768),
    [sym_int] = ACTIONS(3766),
    [sym_xint] = ACTIONS(3768),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3768),
  },
  [3526] = {
    [sym_xml_doc] = STATE(3526),
    [sym_block_comment] = STATE(3526),
    [sym_line_comment] = STATE(3526),
    [sym_compiler_directive_decl] = STATE(3526),
    [sym_fsi_directive_decl] = STATE(3526),
    [sym_preproc_line] = STATE(3526),
    [sym_identifier] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3770),
    [anon_sym_do] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_LT_AT] = ACTIONS(3770),
    [anon_sym_LT_AT_AT] = ACTIONS(3772),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3770),
    [anon_sym_assert] = ACTIONS(3770),
    [anon_sym_upcast] = ACTIONS(3770),
    [anon_sym_downcast] = ACTIONS(3770),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_while] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3770),
    [anon_sym_fun] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3770),
    [anon_sym_match] = ACTIONS(3770),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3770),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3770),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3770),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3770),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3770),
    [sym_op_identifier] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3770),
    [anon_sym_PLUS_DOT] = ACTIONS(3772),
    [anon_sym_DASH_DOT] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3772),
    [anon_sym_AMP_AMP] = ACTIONS(3772),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3772),
    [sym_int] = ACTIONS(3770),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3772),
  },
  [3527] = {
    [sym_xml_doc] = STATE(3527),
    [sym_block_comment] = STATE(3527),
    [sym_line_comment] = STATE(3527),
    [sym_compiler_directive_decl] = STATE(3527),
    [sym_fsi_directive_decl] = STATE(3527),
    [sym_preproc_line] = STATE(3527),
    [aux_sym_prefix_op_repeat1] = STATE(3532),
    [sym_identifier] = ACTIONS(6016),
    [anon_sym_return] = ACTIONS(6016),
    [anon_sym_do] = ACTIONS(6016),
    [anon_sym_let] = ACTIONS(6016),
    [anon_sym_let_BANG] = ACTIONS(6018),
    [anon_sym_LPAREN] = ACTIONS(6016),
    [anon_sym_null] = ACTIONS(6016),
    [anon_sym_AMP] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6016),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6018),
    [anon_sym_LBRACE] = ACTIONS(6016),
    [anon_sym_LT_AT] = ACTIONS(6016),
    [anon_sym_LT_AT_AT] = ACTIONS(6018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6018),
    [anon_sym_new] = ACTIONS(6016),
    [anon_sym_return_BANG] = ACTIONS(6018),
    [anon_sym_yield] = ACTIONS(6016),
    [anon_sym_yield_BANG] = ACTIONS(6018),
    [anon_sym_lazy] = ACTIONS(6016),
    [anon_sym_assert] = ACTIONS(6016),
    [anon_sym_upcast] = ACTIONS(6016),
    [anon_sym_downcast] = ACTIONS(6016),
    [anon_sym_for] = ACTIONS(6016),
    [anon_sym_while] = ACTIONS(6016),
    [anon_sym_if] = ACTIONS(6016),
    [anon_sym_fun] = ACTIONS(6016),
    [anon_sym_try] = ACTIONS(6016),
    [anon_sym_match] = ACTIONS(6016),
    [anon_sym_match_BANG] = ACTIONS(6018),
    [anon_sym_function] = ACTIONS(6016),
    [anon_sym_use] = ACTIONS(6016),
    [anon_sym_use_BANG] = ACTIONS(6018),
    [anon_sym_do_BANG] = ACTIONS(6018),
    [anon_sym_begin] = ACTIONS(6016),
    [aux_sym_char_token1] = ACTIONS(6018),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6016),
    [anon_sym_DQUOTE] = ACTIONS(6016),
    [anon_sym_AT_DQUOTE] = ACTIONS(6018),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6018),
    [sym_bool] = ACTIONS(6016),
    [sym_unit] = ACTIONS(6018),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6016),
    [sym_op_identifier] = ACTIONS(6018),
    [anon_sym_PLUS] = ACTIONS(6016),
    [anon_sym_DASH] = ACTIONS(6016),
    [anon_sym_PLUS_DOT] = ACTIONS(6018),
    [anon_sym_DASH_DOT] = ACTIONS(6018),
    [anon_sym_PERCENT] = ACTIONS(6018),
    [anon_sym_AMP_AMP] = ACTIONS(6018),
    [anon_sym_TILDE] = ACTIONS(6018),
    [aux_sym_prefix_op_token1] = ACTIONS(6018),
    [sym_int] = ACTIONS(6016),
    [sym_xint] = ACTIONS(6018),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6018),
  },
  [3528] = {
    [sym_xml_doc] = STATE(3528),
    [sym_block_comment] = STATE(3528),
    [sym_line_comment] = STATE(3528),
    [sym_compiler_directive_decl] = STATE(3528),
    [sym_fsi_directive_decl] = STATE(3528),
    [sym_preproc_line] = STATE(3528),
    [sym_identifier] = ACTIONS(5868),
    [anon_sym_return] = ACTIONS(5868),
    [anon_sym_do] = ACTIONS(5868),
    [anon_sym_let] = ACTIONS(5868),
    [anon_sym_let_BANG] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5868),
    [anon_sym_null] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5868),
    [anon_sym_LT_AT] = ACTIONS(5868),
    [anon_sym_LT_AT_AT] = ACTIONS(5866),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5866),
    [anon_sym_new] = ACTIONS(5868),
    [anon_sym_return_BANG] = ACTIONS(5866),
    [anon_sym_yield] = ACTIONS(5868),
    [anon_sym_yield_BANG] = ACTIONS(5866),
    [anon_sym_lazy] = ACTIONS(5868),
    [anon_sym_assert] = ACTIONS(5868),
    [anon_sym_upcast] = ACTIONS(5868),
    [anon_sym_downcast] = ACTIONS(5868),
    [anon_sym_for] = ACTIONS(5868),
    [anon_sym_while] = ACTIONS(5868),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_fun] = ACTIONS(5868),
    [anon_sym_try] = ACTIONS(5868),
    [anon_sym_match] = ACTIONS(5868),
    [anon_sym_match_BANG] = ACTIONS(5866),
    [anon_sym_function] = ACTIONS(5868),
    [anon_sym_use] = ACTIONS(5868),
    [anon_sym_use_BANG] = ACTIONS(5866),
    [anon_sym_do_BANG] = ACTIONS(5866),
    [anon_sym_begin] = ACTIONS(5868),
    [aux_sym_char_token1] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5868),
    [anon_sym_DQUOTE] = ACTIONS(5868),
    [anon_sym_AT_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [sym_bool] = ACTIONS(5868),
    [sym_unit] = ACTIONS(5866),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5868),
    [sym_op_identifier] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_DOT] = ACTIONS(5866),
    [anon_sym_DASH_DOT] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(5866),
    [anon_sym_TILDE] = ACTIONS(5866),
    [aux_sym_prefix_op_token1] = ACTIONS(5866),
    [sym_int] = ACTIONS(5868),
    [sym_xint] = ACTIONS(5866),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5866),
    [anon_sym_POUNDendif] = ACTIONS(5866),
  },
  [3529] = {
    [sym_xml_doc] = STATE(3529),
    [sym_block_comment] = STATE(3529),
    [sym_line_comment] = STATE(3529),
    [sym_compiler_directive_decl] = STATE(3529),
    [sym_fsi_directive_decl] = STATE(3529),
    [sym_preproc_line] = STATE(3529),
    [sym_identifier] = ACTIONS(5717),
    [anon_sym_return] = ACTIONS(5717),
    [anon_sym_do] = ACTIONS(5717),
    [anon_sym_and] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_let_BANG] = ACTIONS(5715),
    [anon_sym_LPAREN] = ACTIONS(5717),
    [anon_sym_null] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5715),
    [anon_sym_LBRACE] = ACTIONS(5717),
    [anon_sym_LT_AT] = ACTIONS(5717),
    [anon_sym_LT_AT_AT] = ACTIONS(5715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5715),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_return_BANG] = ACTIONS(5715),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_yield_BANG] = ACTIONS(5715),
    [anon_sym_lazy] = ACTIONS(5717),
    [anon_sym_assert] = ACTIONS(5717),
    [anon_sym_upcast] = ACTIONS(5717),
    [anon_sym_downcast] = ACTIONS(5717),
    [anon_sym_for] = ACTIONS(5717),
    [anon_sym_while] = ACTIONS(5717),
    [anon_sym_if] = ACTIONS(5717),
    [anon_sym_fun] = ACTIONS(5717),
    [anon_sym_try] = ACTIONS(5717),
    [anon_sym_match] = ACTIONS(5717),
    [anon_sym_match_BANG] = ACTIONS(5715),
    [anon_sym_function] = ACTIONS(5717),
    [anon_sym_use] = ACTIONS(5717),
    [anon_sym_use_BANG] = ACTIONS(5715),
    [anon_sym_do_BANG] = ACTIONS(5715),
    [anon_sym_begin] = ACTIONS(5717),
    [aux_sym_char_token1] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5717),
    [anon_sym_DQUOTE] = ACTIONS(5717),
    [anon_sym_AT_DQUOTE] = ACTIONS(5715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5715),
    [sym_bool] = ACTIONS(5717),
    [sym_unit] = ACTIONS(5715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5717),
    [sym_op_identifier] = ACTIONS(5715),
    [anon_sym_PLUS] = ACTIONS(5717),
    [anon_sym_DASH] = ACTIONS(5717),
    [anon_sym_PLUS_DOT] = ACTIONS(5715),
    [anon_sym_DASH_DOT] = ACTIONS(5715),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_AMP_AMP] = ACTIONS(5715),
    [anon_sym_TILDE] = ACTIONS(5715),
    [aux_sym_prefix_op_token1] = ACTIONS(5715),
    [sym_int] = ACTIONS(5717),
    [sym_xint] = ACTIONS(5715),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5715),
  },
  [3530] = {
    [sym_xml_doc] = STATE(3530),
    [sym_block_comment] = STATE(3530),
    [sym_line_comment] = STATE(3530),
    [sym_compiler_directive_decl] = STATE(3530),
    [sym_fsi_directive_decl] = STATE(3530),
    [sym_preproc_line] = STATE(3530),
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_return] = ACTIONS(5699),
    [anon_sym_do] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_let] = ACTIONS(5699),
    [anon_sym_let_BANG] = ACTIONS(5697),
    [anon_sym_LPAREN] = ACTIONS(5699),
    [anon_sym_null] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5697),
    [anon_sym_LBRACE] = ACTIONS(5699),
    [anon_sym_LT_AT] = ACTIONS(5699),
    [anon_sym_LT_AT_AT] = ACTIONS(5697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5699),
    [anon_sym_return_BANG] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5699),
    [anon_sym_yield_BANG] = ACTIONS(5697),
    [anon_sym_lazy] = ACTIONS(5699),
    [anon_sym_assert] = ACTIONS(5699),
    [anon_sym_upcast] = ACTIONS(5699),
    [anon_sym_downcast] = ACTIONS(5699),
    [anon_sym_for] = ACTIONS(5699),
    [anon_sym_while] = ACTIONS(5699),
    [anon_sym_if] = ACTIONS(5699),
    [anon_sym_fun] = ACTIONS(5699),
    [anon_sym_try] = ACTIONS(5699),
    [anon_sym_match] = ACTIONS(5699),
    [anon_sym_match_BANG] = ACTIONS(5697),
    [anon_sym_function] = ACTIONS(5699),
    [anon_sym_use] = ACTIONS(5699),
    [anon_sym_use_BANG] = ACTIONS(5697),
    [anon_sym_do_BANG] = ACTIONS(5697),
    [anon_sym_begin] = ACTIONS(5699),
    [aux_sym_char_token1] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [anon_sym_AT_DQUOTE] = ACTIONS(5697),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [sym_bool] = ACTIONS(5699),
    [sym_unit] = ACTIONS(5697),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5699),
    [sym_op_identifier] = ACTIONS(5697),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS_DOT] = ACTIONS(5697),
    [anon_sym_DASH_DOT] = ACTIONS(5697),
    [anon_sym_PERCENT] = ACTIONS(5697),
    [anon_sym_AMP_AMP] = ACTIONS(5697),
    [anon_sym_TILDE] = ACTIONS(5697),
    [aux_sym_prefix_op_token1] = ACTIONS(5697),
    [sym_int] = ACTIONS(5699),
    [sym_xint] = ACTIONS(5697),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5697),
  },
  [3531] = {
    [sym_xml_doc] = STATE(3531),
    [sym_block_comment] = STATE(3531),
    [sym_line_comment] = STATE(3531),
    [sym_compiler_directive_decl] = STATE(3531),
    [sym_fsi_directive_decl] = STATE(3531),
    [sym_preproc_line] = STATE(3531),
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_let_BANG] = ACTIONS(3440),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_null] = ACTIONS(3438),
    [anon_sym_AMP] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3438),
    [anon_sym_LT_AT] = ACTIONS(3438),
    [anon_sym_LT_AT_AT] = ACTIONS(3440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3440),
    [anon_sym_new] = ACTIONS(3438),
    [anon_sym_return_BANG] = ACTIONS(3440),
    [anon_sym_yield] = ACTIONS(3438),
    [anon_sym_yield_BANG] = ACTIONS(3440),
    [anon_sym_lazy] = ACTIONS(3438),
    [anon_sym_assert] = ACTIONS(3438),
    [anon_sym_upcast] = ACTIONS(3438),
    [anon_sym_downcast] = ACTIONS(3438),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(3438),
    [anon_sym_fun] = ACTIONS(3438),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_match] = ACTIONS(3438),
    [anon_sym_match_BANG] = ACTIONS(3440),
    [anon_sym_function] = ACTIONS(3438),
    [anon_sym_use] = ACTIONS(3438),
    [anon_sym_use_BANG] = ACTIONS(3440),
    [anon_sym_do_BANG] = ACTIONS(3440),
    [anon_sym_begin] = ACTIONS(3438),
    [aux_sym_char_token1] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(3438),
    [anon_sym_AT_DQUOTE] = ACTIONS(3440),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3440),
    [sym_bool] = ACTIONS(3438),
    [sym_unit] = ACTIONS(3440),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3438),
    [sym_op_identifier] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_PLUS_DOT] = ACTIONS(3440),
    [anon_sym_DASH_DOT] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_TILDE] = ACTIONS(3440),
    [aux_sym_prefix_op_token1] = ACTIONS(3440),
    [sym_int] = ACTIONS(3438),
    [sym_xint] = ACTIONS(3440),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(3440),
  },
  [3532] = {
    [sym_xml_doc] = STATE(3532),
    [sym_block_comment] = STATE(3532),
    [sym_line_comment] = STATE(3532),
    [sym_compiler_directive_decl] = STATE(3532),
    [sym_fsi_directive_decl] = STATE(3532),
    [sym_preproc_line] = STATE(3532),
    [aux_sym_prefix_op_repeat1] = STATE(3532),
    [sym_identifier] = ACTIONS(6020),
    [anon_sym_return] = ACTIONS(6020),
    [anon_sym_do] = ACTIONS(6020),
    [anon_sym_let] = ACTIONS(6020),
    [anon_sym_let_BANG] = ACTIONS(6022),
    [anon_sym_LPAREN] = ACTIONS(6020),
    [anon_sym_null] = ACTIONS(6020),
    [anon_sym_AMP] = ACTIONS(6020),
    [anon_sym_LBRACK] = ACTIONS(6020),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6022),
    [anon_sym_LBRACE] = ACTIONS(6020),
    [anon_sym_LT_AT] = ACTIONS(6020),
    [anon_sym_LT_AT_AT] = ACTIONS(6022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6022),
    [anon_sym_new] = ACTIONS(6020),
    [anon_sym_return_BANG] = ACTIONS(6022),
    [anon_sym_yield] = ACTIONS(6020),
    [anon_sym_yield_BANG] = ACTIONS(6022),
    [anon_sym_lazy] = ACTIONS(6020),
    [anon_sym_assert] = ACTIONS(6020),
    [anon_sym_upcast] = ACTIONS(6020),
    [anon_sym_downcast] = ACTIONS(6020),
    [anon_sym_for] = ACTIONS(6020),
    [anon_sym_while] = ACTIONS(6020),
    [anon_sym_if] = ACTIONS(6020),
    [anon_sym_fun] = ACTIONS(6020),
    [anon_sym_try] = ACTIONS(6020),
    [anon_sym_match] = ACTIONS(6020),
    [anon_sym_match_BANG] = ACTIONS(6022),
    [anon_sym_function] = ACTIONS(6020),
    [anon_sym_use] = ACTIONS(6020),
    [anon_sym_use_BANG] = ACTIONS(6022),
    [anon_sym_do_BANG] = ACTIONS(6022),
    [anon_sym_begin] = ACTIONS(6020),
    [aux_sym_char_token1] = ACTIONS(6022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6020),
    [anon_sym_DQUOTE] = ACTIONS(6020),
    [anon_sym_AT_DQUOTE] = ACTIONS(6022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6022),
    [sym_bool] = ACTIONS(6020),
    [sym_unit] = ACTIONS(6022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6020),
    [sym_op_identifier] = ACTIONS(6022),
    [anon_sym_PLUS] = ACTIONS(6020),
    [anon_sym_DASH] = ACTIONS(6020),
    [anon_sym_PLUS_DOT] = ACTIONS(6022),
    [anon_sym_DASH_DOT] = ACTIONS(6022),
    [anon_sym_PERCENT] = ACTIONS(6022),
    [anon_sym_AMP_AMP] = ACTIONS(6022),
    [anon_sym_TILDE] = ACTIONS(6024),
    [aux_sym_prefix_op_token1] = ACTIONS(6022),
    [sym_int] = ACTIONS(6020),
    [sym_xint] = ACTIONS(6022),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6022),
  },
  [3533] = {
    [sym_xml_doc] = STATE(3533),
    [sym_block_comment] = STATE(3533),
    [sym_line_comment] = STATE(3533),
    [sym_compiler_directive_decl] = STATE(3533),
    [sym_fsi_directive_decl] = STATE(3533),
    [sym_preproc_line] = STATE(3533),
    [sym_identifier] = ACTIONS(5860),
    [anon_sym_return] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_let] = ACTIONS(5860),
    [anon_sym_let_BANG] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_null] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_LT_AT] = ACTIONS(5860),
    [anon_sym_LT_AT_AT] = ACTIONS(5858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5858),
    [anon_sym_new] = ACTIONS(5860),
    [anon_sym_return_BANG] = ACTIONS(5858),
    [anon_sym_yield] = ACTIONS(5860),
    [anon_sym_yield_BANG] = ACTIONS(5858),
    [anon_sym_lazy] = ACTIONS(5860),
    [anon_sym_assert] = ACTIONS(5860),
    [anon_sym_upcast] = ACTIONS(5860),
    [anon_sym_downcast] = ACTIONS(5860),
    [anon_sym_for] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_fun] = ACTIONS(5860),
    [anon_sym_try] = ACTIONS(5860),
    [anon_sym_match] = ACTIONS(5860),
    [anon_sym_match_BANG] = ACTIONS(5858),
    [anon_sym_function] = ACTIONS(5860),
    [anon_sym_use] = ACTIONS(5860),
    [anon_sym_use_BANG] = ACTIONS(5858),
    [anon_sym_do_BANG] = ACTIONS(5858),
    [anon_sym_begin] = ACTIONS(5860),
    [aux_sym_char_token1] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5860),
    [anon_sym_DQUOTE] = ACTIONS(5860),
    [anon_sym_AT_DQUOTE] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [sym_bool] = ACTIONS(5860),
    [sym_unit] = ACTIONS(5858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5860),
    [sym_op_identifier] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_PLUS_DOT] = ACTIONS(5858),
    [anon_sym_DASH_DOT] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_TILDE] = ACTIONS(5858),
    [aux_sym_prefix_op_token1] = ACTIONS(5858),
    [sym_int] = ACTIONS(5860),
    [sym_xint] = ACTIONS(5858),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5858),
    [anon_sym_POUNDendif] = ACTIONS(5858),
  },
  [3534] = {
    [sym_xml_doc] = STATE(3534),
    [sym_block_comment] = STATE(3534),
    [sym_line_comment] = STATE(3534),
    [sym_compiler_directive_decl] = STATE(3534),
    [sym_fsi_directive_decl] = STATE(3534),
    [sym_preproc_line] = STATE(3534),
    [sym_identifier] = ACTIONS(5713),
    [anon_sym_return] = ACTIONS(5713),
    [anon_sym_do] = ACTIONS(5713),
    [anon_sym_and] = ACTIONS(5713),
    [anon_sym_let] = ACTIONS(5713),
    [anon_sym_let_BANG] = ACTIONS(5711),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_null] = ACTIONS(5713),
    [anon_sym_AMP] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5711),
    [anon_sym_LBRACE] = ACTIONS(5713),
    [anon_sym_LT_AT] = ACTIONS(5713),
    [anon_sym_LT_AT_AT] = ACTIONS(5711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5711),
    [anon_sym_new] = ACTIONS(5713),
    [anon_sym_return_BANG] = ACTIONS(5711),
    [anon_sym_yield] = ACTIONS(5713),
    [anon_sym_yield_BANG] = ACTIONS(5711),
    [anon_sym_lazy] = ACTIONS(5713),
    [anon_sym_assert] = ACTIONS(5713),
    [anon_sym_upcast] = ACTIONS(5713),
    [anon_sym_downcast] = ACTIONS(5713),
    [anon_sym_for] = ACTIONS(5713),
    [anon_sym_while] = ACTIONS(5713),
    [anon_sym_if] = ACTIONS(5713),
    [anon_sym_fun] = ACTIONS(5713),
    [anon_sym_try] = ACTIONS(5713),
    [anon_sym_match] = ACTIONS(5713),
    [anon_sym_match_BANG] = ACTIONS(5711),
    [anon_sym_function] = ACTIONS(5713),
    [anon_sym_use] = ACTIONS(5713),
    [anon_sym_use_BANG] = ACTIONS(5711),
    [anon_sym_do_BANG] = ACTIONS(5711),
    [anon_sym_begin] = ACTIONS(5713),
    [aux_sym_char_token1] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5713),
    [anon_sym_DQUOTE] = ACTIONS(5713),
    [anon_sym_AT_DQUOTE] = ACTIONS(5711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5711),
    [sym_bool] = ACTIONS(5713),
    [sym_unit] = ACTIONS(5711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5713),
    [sym_op_identifier] = ACTIONS(5711),
    [anon_sym_PLUS] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5713),
    [anon_sym_PLUS_DOT] = ACTIONS(5711),
    [anon_sym_DASH_DOT] = ACTIONS(5711),
    [anon_sym_PERCENT] = ACTIONS(5711),
    [anon_sym_AMP_AMP] = ACTIONS(5711),
    [anon_sym_TILDE] = ACTIONS(5711),
    [aux_sym_prefix_op_token1] = ACTIONS(5711),
    [sym_int] = ACTIONS(5713),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5711),
  },
  [3535] = {
    [sym_xml_doc] = STATE(3535),
    [sym_block_comment] = STATE(3535),
    [sym_line_comment] = STATE(3535),
    [sym_compiler_directive_decl] = STATE(3535),
    [sym_fsi_directive_decl] = STATE(3535),
    [sym_preproc_line] = STATE(3535),
    [sym_identifier] = ACTIONS(6027),
    [anon_sym_return] = ACTIONS(6027),
    [anon_sym_do] = ACTIONS(6027),
    [anon_sym_let] = ACTIONS(6027),
    [anon_sym_let_BANG] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6027),
    [anon_sym_null] = ACTIONS(6027),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6027),
    [anon_sym_LT_AT] = ACTIONS(6027),
    [anon_sym_LT_AT_AT] = ACTIONS(6029),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6029),
    [anon_sym_new] = ACTIONS(6027),
    [anon_sym_return_BANG] = ACTIONS(6029),
    [anon_sym_yield] = ACTIONS(6027),
    [anon_sym_yield_BANG] = ACTIONS(6029),
    [anon_sym_lazy] = ACTIONS(6027),
    [anon_sym_assert] = ACTIONS(6027),
    [anon_sym_upcast] = ACTIONS(6027),
    [anon_sym_downcast] = ACTIONS(6027),
    [anon_sym_for] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(6027),
    [anon_sym_if] = ACTIONS(6027),
    [anon_sym_fun] = ACTIONS(6027),
    [anon_sym_try] = ACTIONS(6027),
    [anon_sym_match] = ACTIONS(6027),
    [anon_sym_match_BANG] = ACTIONS(6029),
    [anon_sym_function] = ACTIONS(6027),
    [anon_sym_use] = ACTIONS(6027),
    [anon_sym_use_BANG] = ACTIONS(6029),
    [anon_sym_do_BANG] = ACTIONS(6029),
    [anon_sym_begin] = ACTIONS(6027),
    [aux_sym_char_token1] = ACTIONS(6029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6027),
    [anon_sym_DQUOTE] = ACTIONS(6027),
    [anon_sym_AT_DQUOTE] = ACTIONS(6029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6029),
    [sym_bool] = ACTIONS(6027),
    [sym_unit] = ACTIONS(6029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6027),
    [sym_op_identifier] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6027),
    [anon_sym_PLUS_DOT] = ACTIONS(6029),
    [anon_sym_DASH_DOT] = ACTIONS(6029),
    [anon_sym_PERCENT] = ACTIONS(6029),
    [anon_sym_AMP_AMP] = ACTIONS(6029),
    [anon_sym_TILDE] = ACTIONS(6029),
    [aux_sym_prefix_op_token1] = ACTIONS(6029),
    [sym_int] = ACTIONS(6027),
    [sym_xint] = ACTIONS(6029),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6029),
  },
  [3536] = {
    [sym_xml_doc] = STATE(3536),
    [sym_block_comment] = STATE(3536),
    [sym_line_comment] = STATE(3536),
    [sym_compiler_directive_decl] = STATE(3536),
    [sym_fsi_directive_decl] = STATE(3536),
    [sym_preproc_line] = STATE(3536),
    [sym_identifier] = ACTIONS(6027),
    [anon_sym_return] = ACTIONS(6027),
    [anon_sym_do] = ACTIONS(6027),
    [anon_sym_let] = ACTIONS(6027),
    [anon_sym_let_BANG] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6027),
    [anon_sym_null] = ACTIONS(6027),
    [anon_sym_AMP] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6027),
    [anon_sym_LT_AT] = ACTIONS(6027),
    [anon_sym_LT_AT_AT] = ACTIONS(6029),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6029),
    [anon_sym_new] = ACTIONS(6027),
    [anon_sym_return_BANG] = ACTIONS(6029),
    [anon_sym_yield] = ACTIONS(6027),
    [anon_sym_yield_BANG] = ACTIONS(6029),
    [anon_sym_lazy] = ACTIONS(6027),
    [anon_sym_assert] = ACTIONS(6027),
    [anon_sym_upcast] = ACTIONS(6027),
    [anon_sym_downcast] = ACTIONS(6027),
    [anon_sym_for] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(6027),
    [anon_sym_if] = ACTIONS(6027),
    [anon_sym_fun] = ACTIONS(6027),
    [anon_sym_try] = ACTIONS(6027),
    [anon_sym_match] = ACTIONS(6027),
    [anon_sym_match_BANG] = ACTIONS(6029),
    [anon_sym_function] = ACTIONS(6027),
    [anon_sym_use] = ACTIONS(6027),
    [anon_sym_use_BANG] = ACTIONS(6029),
    [anon_sym_do_BANG] = ACTIONS(6029),
    [anon_sym_begin] = ACTIONS(6027),
    [aux_sym_char_token1] = ACTIONS(6029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6027),
    [anon_sym_DQUOTE] = ACTIONS(6027),
    [anon_sym_AT_DQUOTE] = ACTIONS(6029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6029),
    [sym_bool] = ACTIONS(6027),
    [sym_unit] = ACTIONS(6029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6027),
    [sym_op_identifier] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6027),
    [anon_sym_PLUS_DOT] = ACTIONS(6029),
    [anon_sym_DASH_DOT] = ACTIONS(6029),
    [anon_sym_PERCENT] = ACTIONS(6029),
    [anon_sym_AMP_AMP] = ACTIONS(6029),
    [anon_sym_TILDE] = ACTIONS(6029),
    [aux_sym_prefix_op_token1] = ACTIONS(6029),
    [sym_int] = ACTIONS(6027),
    [sym_xint] = ACTIONS(6029),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6029),
  },
  [3537] = {
    [sym_xml_doc] = STATE(3537),
    [sym_block_comment] = STATE(3537),
    [sym_line_comment] = STATE(3537),
    [sym_compiler_directive_decl] = STATE(3537),
    [sym_fsi_directive_decl] = STATE(3537),
    [sym_preproc_line] = STATE(3537),
    [sym_identifier] = ACTIONS(5860),
    [anon_sym_return] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_let] = ACTIONS(5860),
    [anon_sym_let_BANG] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_null] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_LT_AT] = ACTIONS(5860),
    [anon_sym_LT_AT_AT] = ACTIONS(5858),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5858),
    [anon_sym_new] = ACTIONS(5860),
    [anon_sym_return_BANG] = ACTIONS(5858),
    [anon_sym_yield] = ACTIONS(5860),
    [anon_sym_yield_BANG] = ACTIONS(5858),
    [anon_sym_lazy] = ACTIONS(5860),
    [anon_sym_assert] = ACTIONS(5860),
    [anon_sym_upcast] = ACTIONS(5860),
    [anon_sym_downcast] = ACTIONS(5860),
    [anon_sym_for] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_fun] = ACTIONS(5860),
    [anon_sym_try] = ACTIONS(5860),
    [anon_sym_match] = ACTIONS(5860),
    [anon_sym_match_BANG] = ACTIONS(5858),
    [anon_sym_function] = ACTIONS(5860),
    [anon_sym_use] = ACTIONS(5860),
    [anon_sym_use_BANG] = ACTIONS(5858),
    [anon_sym_do_BANG] = ACTIONS(5858),
    [anon_sym_begin] = ACTIONS(5860),
    [aux_sym_char_token1] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5860),
    [anon_sym_DQUOTE] = ACTIONS(5860),
    [anon_sym_AT_DQUOTE] = ACTIONS(5858),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5858),
    [sym_bool] = ACTIONS(5860),
    [sym_unit] = ACTIONS(5858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5860),
    [sym_op_identifier] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_PLUS_DOT] = ACTIONS(5858),
    [anon_sym_DASH_DOT] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_TILDE] = ACTIONS(5858),
    [aux_sym_prefix_op_token1] = ACTIONS(5858),
    [sym_int] = ACTIONS(5860),
    [sym_xint] = ACTIONS(5858),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5858),
  },
  [3538] = {
    [sym_xml_doc] = STATE(3538),
    [sym_block_comment] = STATE(3538),
    [sym_line_comment] = STATE(3538),
    [sym_compiler_directive_decl] = STATE(3538),
    [sym_fsi_directive_decl] = STATE(3538),
    [sym_preproc_line] = STATE(3538),
    [sym_identifier] = ACTIONS(5868),
    [anon_sym_return] = ACTIONS(5868),
    [anon_sym_do] = ACTIONS(5868),
    [anon_sym_let] = ACTIONS(5868),
    [anon_sym_let_BANG] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(5868),
    [anon_sym_null] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5868),
    [anon_sym_LT_AT] = ACTIONS(5868),
    [anon_sym_LT_AT_AT] = ACTIONS(5866),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5866),
    [anon_sym_new] = ACTIONS(5868),
    [anon_sym_return_BANG] = ACTIONS(5866),
    [anon_sym_yield] = ACTIONS(5868),
    [anon_sym_yield_BANG] = ACTIONS(5866),
    [anon_sym_lazy] = ACTIONS(5868),
    [anon_sym_assert] = ACTIONS(5868),
    [anon_sym_upcast] = ACTIONS(5868),
    [anon_sym_downcast] = ACTIONS(5868),
    [anon_sym_for] = ACTIONS(5868),
    [anon_sym_while] = ACTIONS(5868),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_fun] = ACTIONS(5868),
    [anon_sym_try] = ACTIONS(5868),
    [anon_sym_match] = ACTIONS(5868),
    [anon_sym_match_BANG] = ACTIONS(5866),
    [anon_sym_function] = ACTIONS(5868),
    [anon_sym_use] = ACTIONS(5868),
    [anon_sym_use_BANG] = ACTIONS(5866),
    [anon_sym_do_BANG] = ACTIONS(5866),
    [anon_sym_begin] = ACTIONS(5868),
    [aux_sym_char_token1] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5868),
    [anon_sym_DQUOTE] = ACTIONS(5868),
    [anon_sym_AT_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5866),
    [sym_bool] = ACTIONS(5868),
    [sym_unit] = ACTIONS(5866),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5868),
    [sym_op_identifier] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_DOT] = ACTIONS(5866),
    [anon_sym_DASH_DOT] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5866),
    [anon_sym_AMP_AMP] = ACTIONS(5866),
    [anon_sym_TILDE] = ACTIONS(5866),
    [aux_sym_prefix_op_token1] = ACTIONS(5866),
    [sym_int] = ACTIONS(5868),
    [sym_xint] = ACTIONS(5866),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(5866),
  },
  [3539] = {
    [sym_xml_doc] = STATE(3539),
    [sym_block_comment] = STATE(3539),
    [sym_line_comment] = STATE(3539),
    [sym_compiler_directive_decl] = STATE(3539),
    [sym_fsi_directive_decl] = STATE(3539),
    [sym_preproc_line] = STATE(3539),
    [sym_identifier] = ACTIONS(6016),
    [anon_sym_return] = ACTIONS(6016),
    [anon_sym_do] = ACTIONS(6016),
    [anon_sym_let] = ACTIONS(6016),
    [anon_sym_let_BANG] = ACTIONS(6018),
    [anon_sym_LPAREN] = ACTIONS(6016),
    [anon_sym_null] = ACTIONS(6016),
    [anon_sym_AMP] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6016),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6018),
    [anon_sym_LBRACE] = ACTIONS(6016),
    [anon_sym_LT_AT] = ACTIONS(6016),
    [anon_sym_LT_AT_AT] = ACTIONS(6018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6018),
    [anon_sym_new] = ACTIONS(6016),
    [anon_sym_return_BANG] = ACTIONS(6018),
    [anon_sym_yield] = ACTIONS(6016),
    [anon_sym_yield_BANG] = ACTIONS(6018),
    [anon_sym_lazy] = ACTIONS(6016),
    [anon_sym_assert] = ACTIONS(6016),
    [anon_sym_upcast] = ACTIONS(6016),
    [anon_sym_downcast] = ACTIONS(6016),
    [anon_sym_for] = ACTIONS(6016),
    [anon_sym_while] = ACTIONS(6016),
    [anon_sym_if] = ACTIONS(6016),
    [anon_sym_fun] = ACTIONS(6016),
    [anon_sym_try] = ACTIONS(6016),
    [anon_sym_match] = ACTIONS(6016),
    [anon_sym_match_BANG] = ACTIONS(6018),
    [anon_sym_function] = ACTIONS(6016),
    [anon_sym_use] = ACTIONS(6016),
    [anon_sym_use_BANG] = ACTIONS(6018),
    [anon_sym_do_BANG] = ACTIONS(6018),
    [anon_sym_begin] = ACTIONS(6016),
    [aux_sym_char_token1] = ACTIONS(6018),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6016),
    [anon_sym_DQUOTE] = ACTIONS(6016),
    [anon_sym_AT_DQUOTE] = ACTIONS(6018),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6018),
    [sym_bool] = ACTIONS(6016),
    [sym_unit] = ACTIONS(6018),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6016),
    [sym_op_identifier] = ACTIONS(6018),
    [anon_sym_PLUS] = ACTIONS(6016),
    [anon_sym_DASH] = ACTIONS(6016),
    [anon_sym_PLUS_DOT] = ACTIONS(6018),
    [anon_sym_DASH_DOT] = ACTIONS(6018),
    [anon_sym_PERCENT] = ACTIONS(6018),
    [anon_sym_AMP_AMP] = ACTIONS(6018),
    [anon_sym_TILDE] = ACTIONS(6018),
    [aux_sym_prefix_op_token1] = ACTIONS(6018),
    [sym_int] = ACTIONS(6016),
    [sym_xint] = ACTIONS(6018),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6018),
  },
  [3540] = {
    [sym_xml_doc] = STATE(3540),
    [sym_block_comment] = STATE(3540),
    [sym_line_comment] = STATE(3540),
    [sym_compiler_directive_decl] = STATE(3540),
    [sym_fsi_directive_decl] = STATE(3540),
    [sym_preproc_line] = STATE(3540),
    [sym_identifier] = ACTIONS(6031),
    [anon_sym_return] = ACTIONS(6031),
    [anon_sym_do] = ACTIONS(6031),
    [anon_sym_let] = ACTIONS(6031),
    [anon_sym_let_BANG] = ACTIONS(6033),
    [anon_sym_LPAREN] = ACTIONS(6031),
    [anon_sym_null] = ACTIONS(6031),
    [anon_sym_AMP] = ACTIONS(6031),
    [anon_sym_LBRACK] = ACTIONS(6031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6033),
    [anon_sym_LBRACE] = ACTIONS(6031),
    [anon_sym_LT_AT] = ACTIONS(6031),
    [anon_sym_LT_AT_AT] = ACTIONS(6033),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6033),
    [anon_sym_new] = ACTIONS(6031),
    [anon_sym_return_BANG] = ACTIONS(6033),
    [anon_sym_yield] = ACTIONS(6031),
    [anon_sym_yield_BANG] = ACTIONS(6033),
    [anon_sym_lazy] = ACTIONS(6031),
    [anon_sym_assert] = ACTIONS(6031),
    [anon_sym_upcast] = ACTIONS(6031),
    [anon_sym_downcast] = ACTIONS(6031),
    [anon_sym_for] = ACTIONS(6031),
    [anon_sym_while] = ACTIONS(6031),
    [anon_sym_if] = ACTIONS(6031),
    [anon_sym_fun] = ACTIONS(6031),
    [anon_sym_try] = ACTIONS(6031),
    [anon_sym_match] = ACTIONS(6031),
    [anon_sym_match_BANG] = ACTIONS(6033),
    [anon_sym_function] = ACTIONS(6031),
    [anon_sym_use] = ACTIONS(6031),
    [anon_sym_use_BANG] = ACTIONS(6033),
    [anon_sym_do_BANG] = ACTIONS(6033),
    [anon_sym_begin] = ACTIONS(6031),
    [aux_sym_char_token1] = ACTIONS(6033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6031),
    [anon_sym_DQUOTE] = ACTIONS(6031),
    [anon_sym_AT_DQUOTE] = ACTIONS(6033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6033),
    [sym_bool] = ACTIONS(6031),
    [sym_unit] = ACTIONS(6033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6031),
    [sym_op_identifier] = ACTIONS(6033),
    [anon_sym_PLUS] = ACTIONS(6031),
    [anon_sym_DASH] = ACTIONS(6031),
    [anon_sym_PLUS_DOT] = ACTIONS(6033),
    [anon_sym_DASH_DOT] = ACTIONS(6033),
    [anon_sym_PERCENT] = ACTIONS(6033),
    [anon_sym_AMP_AMP] = ACTIONS(6033),
    [anon_sym_TILDE] = ACTIONS(6033),
    [aux_sym_prefix_op_token1] = ACTIONS(6033),
    [sym_int] = ACTIONS(6031),
    [sym_xint] = ACTIONS(6033),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6033),
  },
  [3541] = {
    [sym_xml_doc] = STATE(3541),
    [sym_block_comment] = STATE(3541),
    [sym_line_comment] = STATE(3541),
    [sym_compiler_directive_decl] = STATE(3541),
    [sym_fsi_directive_decl] = STATE(3541),
    [sym_preproc_line] = STATE(3541),
    [sym_identifier] = ACTIONS(6035),
    [anon_sym_return] = ACTIONS(6035),
    [anon_sym_do] = ACTIONS(6035),
    [anon_sym_let] = ACTIONS(6035),
    [anon_sym_let_BANG] = ACTIONS(6037),
    [anon_sym_LPAREN] = ACTIONS(6035),
    [anon_sym_null] = ACTIONS(6035),
    [anon_sym_AMP] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(6035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6037),
    [anon_sym_LBRACE] = ACTIONS(6035),
    [anon_sym_LT_AT] = ACTIONS(6035),
    [anon_sym_LT_AT_AT] = ACTIONS(6037),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6037),
    [anon_sym_new] = ACTIONS(6035),
    [anon_sym_return_BANG] = ACTIONS(6037),
    [anon_sym_yield] = ACTIONS(6035),
    [anon_sym_yield_BANG] = ACTIONS(6037),
    [anon_sym_lazy] = ACTIONS(6035),
    [anon_sym_assert] = ACTIONS(6035),
    [anon_sym_upcast] = ACTIONS(6035),
    [anon_sym_downcast] = ACTIONS(6035),
    [anon_sym_for] = ACTIONS(6035),
    [anon_sym_while] = ACTIONS(6035),
    [anon_sym_if] = ACTIONS(6035),
    [anon_sym_fun] = ACTIONS(6035),
    [anon_sym_try] = ACTIONS(6035),
    [anon_sym_match] = ACTIONS(6035),
    [anon_sym_match_BANG] = ACTIONS(6037),
    [anon_sym_function] = ACTIONS(6035),
    [anon_sym_use] = ACTIONS(6035),
    [anon_sym_use_BANG] = ACTIONS(6037),
    [anon_sym_do_BANG] = ACTIONS(6037),
    [anon_sym_begin] = ACTIONS(6035),
    [aux_sym_char_token1] = ACTIONS(6037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6035),
    [anon_sym_DQUOTE] = ACTIONS(6035),
    [anon_sym_AT_DQUOTE] = ACTIONS(6037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6037),
    [sym_bool] = ACTIONS(6035),
    [sym_unit] = ACTIONS(6037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6035),
    [sym_op_identifier] = ACTIONS(6037),
    [anon_sym_PLUS] = ACTIONS(6035),
    [anon_sym_DASH] = ACTIONS(6035),
    [anon_sym_PLUS_DOT] = ACTIONS(6037),
    [anon_sym_DASH_DOT] = ACTIONS(6037),
    [anon_sym_PERCENT] = ACTIONS(6037),
    [anon_sym_AMP_AMP] = ACTIONS(6037),
    [anon_sym_TILDE] = ACTIONS(6037),
    [aux_sym_prefix_op_token1] = ACTIONS(6037),
    [sym_int] = ACTIONS(6035),
    [sym_xint] = ACTIONS(6037),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH] = ACTIONS(7),
    [anon_sym_POUNDnowarn] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(13),
    [anon_sym_POUNDif] = ACTIONS(6037),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5615), 1,
      anon_sym_LBRACE,
    ACTIONS(5617), 1,
      anon_sym_LT2,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3545), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3552), 1,
      sym_type_arguments,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(6607), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3542), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [131] = 33,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5615), 1,
      anon_sym_LBRACE,
    ACTIONS(5617), 1,
      anon_sym_LT2,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3545), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3548), 1,
      sym_type_arguments,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(6657), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3543), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [262] = 30,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6044), 1,
      anon_sym_LPAREN,
    ACTIONS(6050), 1,
      anon_sym_LBRACK,
    ACTIONS(6053), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6056), 1,
      anon_sym_LBRACE,
    ACTIONS(6059), 1,
      aux_sym_char_token1,
    ACTIONS(6062), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6065), 1,
      anon_sym_DQUOTE,
    ACTIONS(6068), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6071), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6074), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6077), 1,
      sym_bool,
    ACTIONS(6080), 1,
      sym_unit,
    ACTIONS(6083), 1,
      sym_int,
    ACTIONS(6086), 1,
      sym_xint,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6042), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6047), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3544), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_argument_patterns_repeat1,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [386] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5615), 1,
      anon_sym_LBRACE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3544), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    ACTIONS(6089), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3545), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [512] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7578), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3546), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [637] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5615), 1,
      anon_sym_LBRACE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3545), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(6607), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3547), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [762] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5615), 1,
      anon_sym_LBRACE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3545), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(6672), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3548), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [887] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(8355), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3549), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1012] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7276), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3550), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1137] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7651), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3551), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1262] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5615), 1,
      anon_sym_LBRACE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3545), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(6657), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3552), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1387] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7392), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3553), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1512] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7540), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3554), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1637] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7336), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3555), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1762] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7446), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3556), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1887] = 30,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6042), 1,
      anon_sym_DASH_GT,
    ACTIONS(6044), 1,
      anon_sym_LPAREN,
    ACTIONS(6050), 1,
      anon_sym_LBRACK,
    ACTIONS(6053), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6059), 1,
      aux_sym_char_token1,
    ACTIONS(6062), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6065), 1,
      anon_sym_DQUOTE,
    ACTIONS(6068), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6071), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6074), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6077), 1,
      sym_bool,
    ACTIONS(6080), 1,
      sym_unit,
    ACTIONS(6083), 1,
      sym_int,
    ACTIONS(6086), 1,
      sym_xint,
    ACTIONS(6093), 1,
      anon_sym_LBRACE,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6047), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3557), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_argument_patterns_repeat1,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2010] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7429), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3558), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2135] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6089), 1,
      anon_sym_DASH_GT,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3557), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3559), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2260] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7615), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3560), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2385] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7234), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3561), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2510] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7201), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3562), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2635] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5605), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_LPAREN,
    ACTIONS(5611), 1,
      anon_sym_LBRACK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(5619), 1,
      aux_sym_char_token1,
    ACTIONS(5621), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5623), 1,
      anon_sym_DQUOTE,
    ACTIONS(5625), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5627), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5629), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5631), 1,
      sym_bool,
    ACTIONS(5633), 1,
      sym_unit,
    ACTIONS(5635), 1,
      sym_int,
    ACTIONS(5637), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6091), 1,
      anon_sym_LBRACE,
    STATE(3559), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4269), 1,
      sym_float,
    STATE(4407), 1,
      sym__atomic_pattern,
    STATE(4663), 1,
      sym_format_triple_quoted_string,
    STATE(7500), 1,
      sym_argument_patterns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5609), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4664), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4440), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(3563), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4700), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2760] = 23,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6096), 1,
      anon_sym_y,
    ACTIONS(6098), 1,
      anon_sym_uy,
    ACTIONS(6100), 1,
      anon_sym_s,
    ACTIONS(6102), 1,
      anon_sym_us,
    ACTIONS(6104), 1,
      anon_sym_l,
    ACTIONS(6106), 1,
      aux_sym_uint32_token1,
    ACTIONS(6108), 1,
      anon_sym_n,
    ACTIONS(6110), 1,
      anon_sym_un,
    ACTIONS(6112), 1,
      anon_sym_L,
    ACTIONS(6114), 1,
      aux_sym_uint64_token1,
    ACTIONS(6116), 1,
      aux_sym_bignum_token1,
    ACTIONS(6118), 1,
      aux_sym_decimal_token1,
    ACTIONS(6120), 1,
      anon_sym_DOT2,
    ACTIONS(6122), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3564), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [2867] = 23,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6124), 1,
      anon_sym_y,
    ACTIONS(6126), 1,
      anon_sym_uy,
    ACTIONS(6128), 1,
      anon_sym_s,
    ACTIONS(6130), 1,
      anon_sym_us,
    ACTIONS(6132), 1,
      anon_sym_l,
    ACTIONS(6134), 1,
      aux_sym_uint32_token1,
    ACTIONS(6136), 1,
      anon_sym_n,
    ACTIONS(6138), 1,
      anon_sym_un,
    ACTIONS(6140), 1,
      anon_sym_L,
    ACTIONS(6142), 1,
      aux_sym_uint64_token1,
    ACTIONS(6144), 1,
      aux_sym_bignum_token1,
    ACTIONS(6146), 1,
      aux_sym_decimal_token1,
    ACTIONS(6148), 1,
      anon_sym_DOT2,
    ACTIONS(6150), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3565), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [2972] = 23,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6152), 1,
      anon_sym_y,
    ACTIONS(6154), 1,
      anon_sym_uy,
    ACTIONS(6156), 1,
      anon_sym_s,
    ACTIONS(6158), 1,
      anon_sym_us,
    ACTIONS(6160), 1,
      anon_sym_l,
    ACTIONS(6162), 1,
      aux_sym_uint32_token1,
    ACTIONS(6164), 1,
      anon_sym_n,
    ACTIONS(6166), 1,
      anon_sym_un,
    ACTIONS(6168), 1,
      anon_sym_L,
    ACTIONS(6170), 1,
      aux_sym_uint64_token1,
    ACTIONS(6172), 1,
      aux_sym_bignum_token1,
    ACTIONS(6174), 1,
      aux_sym_decimal_token1,
    ACTIONS(6176), 1,
      anon_sym_DOT2,
    ACTIONS(6178), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3566), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3077] = 21,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6096), 1,
      anon_sym_y,
    ACTIONS(6098), 1,
      anon_sym_uy,
    ACTIONS(6100), 1,
      anon_sym_s,
    ACTIONS(6102), 1,
      anon_sym_us,
    ACTIONS(6104), 1,
      anon_sym_l,
    ACTIONS(6106), 1,
      aux_sym_uint32_token1,
    ACTIONS(6108), 1,
      anon_sym_n,
    ACTIONS(6110), 1,
      anon_sym_un,
    ACTIONS(6112), 1,
      anon_sym_L,
    ACTIONS(6114), 1,
      aux_sym_uint64_token1,
    ACTIONS(6180), 1,
      anon_sym_lf,
    ACTIONS(6182), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3567), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3178] = 23,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6184), 1,
      anon_sym_y,
    ACTIONS(6186), 1,
      anon_sym_uy,
    ACTIONS(6188), 1,
      anon_sym_s,
    ACTIONS(6190), 1,
      anon_sym_us,
    ACTIONS(6192), 1,
      anon_sym_l,
    ACTIONS(6194), 1,
      aux_sym_uint32_token1,
    ACTIONS(6196), 1,
      anon_sym_n,
    ACTIONS(6198), 1,
      anon_sym_un,
    ACTIONS(6200), 1,
      anon_sym_L,
    ACTIONS(6202), 1,
      aux_sym_uint64_token1,
    ACTIONS(6204), 1,
      aux_sym_bignum_token1,
    ACTIONS(6206), 1,
      aux_sym_decimal_token1,
    ACTIONS(6208), 1,
      anon_sym_DOT2,
    ACTIONS(6210), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3568), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3282] = 21,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6124), 1,
      anon_sym_y,
    ACTIONS(6126), 1,
      anon_sym_uy,
    ACTIONS(6128), 1,
      anon_sym_s,
    ACTIONS(6130), 1,
      anon_sym_us,
    ACTIONS(6132), 1,
      anon_sym_l,
    ACTIONS(6134), 1,
      aux_sym_uint32_token1,
    ACTIONS(6136), 1,
      anon_sym_n,
    ACTIONS(6138), 1,
      anon_sym_un,
    ACTIONS(6140), 1,
      anon_sym_L,
    ACTIONS(6142), 1,
      aux_sym_uint64_token1,
    ACTIONS(6212), 1,
      anon_sym_lf,
    ACTIONS(6214), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3569), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3381] = 21,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6152), 1,
      anon_sym_y,
    ACTIONS(6154), 1,
      anon_sym_uy,
    ACTIONS(6156), 1,
      anon_sym_s,
    ACTIONS(6158), 1,
      anon_sym_us,
    ACTIONS(6160), 1,
      anon_sym_l,
    ACTIONS(6162), 1,
      aux_sym_uint32_token1,
    ACTIONS(6164), 1,
      anon_sym_n,
    ACTIONS(6166), 1,
      anon_sym_un,
    ACTIONS(6168), 1,
      anon_sym_L,
    ACTIONS(6170), 1,
      aux_sym_uint64_token1,
    ACTIONS(6216), 1,
      anon_sym_lf,
    ACTIONS(6218), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3570), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3480] = 21,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6184), 1,
      anon_sym_y,
    ACTIONS(6186), 1,
      anon_sym_uy,
    ACTIONS(6188), 1,
      anon_sym_s,
    ACTIONS(6190), 1,
      anon_sym_us,
    ACTIONS(6192), 1,
      anon_sym_l,
    ACTIONS(6194), 1,
      aux_sym_uint32_token1,
    ACTIONS(6196), 1,
      anon_sym_n,
    ACTIONS(6198), 1,
      anon_sym_un,
    ACTIONS(6200), 1,
      anon_sym_L,
    ACTIONS(6202), 1,
      aux_sym_uint64_token1,
    ACTIONS(6220), 1,
      anon_sym_lf,
    ACTIONS(6222), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3571), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3578] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6224), 1,
      anon_sym_y,
    ACTIONS(6226), 1,
      anon_sym_uy,
    ACTIONS(6228), 1,
      anon_sym_s,
    ACTIONS(6230), 1,
      anon_sym_us,
    ACTIONS(6232), 1,
      anon_sym_l,
    ACTIONS(6234), 1,
      aux_sym_uint32_token1,
    ACTIONS(6236), 1,
      anon_sym_n,
    ACTIONS(6238), 1,
      anon_sym_un,
    ACTIONS(6240), 1,
      anon_sym_L,
    ACTIONS(6242), 1,
      aux_sym_uint64_token1,
    ACTIONS(6244), 1,
      aux_sym_bignum_token1,
    ACTIONS(6246), 1,
      aux_sym_decimal_token1,
    ACTIONS(6248), 1,
      anon_sym_DOT2,
    ACTIONS(6250), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3572), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [3678] = 19,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(6258), 1,
      anon_sym_DASH_GT,
    ACTIONS(6260), 1,
      anon_sym_when,
    ACTIONS(6262), 1,
      anon_sym_STAR,
    ACTIONS(6264), 1,
      anon_sym_LT2,
    ACTIONS(6266), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3606), 1,
      aux_sym__compound_type_repeat1,
    STATE(3636), 1,
      sym_type_arguments,
    STATE(3645), 1,
      sym_long_identifier,
    STATE(3950), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3573), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6256), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(6254), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3769] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6268), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3574), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3274), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3841] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3575), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3030), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3927] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3576), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3022), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4013] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6281), 1,
      anon_sym_or,
    STATE(3588), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3577), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3230), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3232), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4087] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(6258), 1,
      anon_sym_DASH_GT,
    ACTIONS(6262), 1,
      anon_sym_STAR,
    ACTIONS(6264), 1,
      anon_sym_LT2,
    ACTIONS(6266), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3606), 1,
      aux_sym__compound_type_repeat1,
    STATE(3636), 1,
      sym_type_arguments,
    STATE(3645), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3578), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3022), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4173] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(6258), 1,
      anon_sym_DASH_GT,
    ACTIONS(6262), 1,
      anon_sym_STAR,
    ACTIONS(6264), 1,
      anon_sym_LT2,
    ACTIONS(6266), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3606), 1,
      aux_sym__compound_type_repeat1,
    STATE(3636), 1,
      sym_type_arguments,
    STATE(3645), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3579), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3030), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4259] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(6258), 1,
      anon_sym_DASH_GT,
    ACTIONS(6262), 1,
      anon_sym_STAR,
    ACTIONS(6264), 1,
      anon_sym_LT2,
    ACTIONS(6266), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3606), 1,
      aux_sym__compound_type_repeat1,
    STATE(3636), 1,
      sym_type_arguments,
    STATE(3645), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3580), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3010), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4345] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3581), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3090), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4431] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6283), 1,
      anon_sym_or,
    STATE(3587), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3582), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4505] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3583), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6285), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6287), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4589] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6281), 1,
      anon_sym_or,
    STATE(3577), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3584), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4663] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6224), 1,
      anon_sym_y,
    ACTIONS(6226), 1,
      anon_sym_uy,
    ACTIONS(6228), 1,
      anon_sym_s,
    ACTIONS(6230), 1,
      anon_sym_us,
    ACTIONS(6232), 1,
      anon_sym_l,
    ACTIONS(6234), 1,
      aux_sym_uint32_token1,
    ACTIONS(6236), 1,
      anon_sym_n,
    ACTIONS(6238), 1,
      anon_sym_un,
    ACTIONS(6240), 1,
      anon_sym_L,
    ACTIONS(6242), 1,
      aux_sym_uint64_token1,
    ACTIONS(6289), 1,
      anon_sym_lf,
    ACTIONS(6291), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3585), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [4757] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3586), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6293), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6295), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4841] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6283), 1,
      anon_sym_or,
    STATE(3574), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3587), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3230), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3232), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4915] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6297), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3588), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3274), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4987] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3589), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3010), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5073] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(6258), 1,
      anon_sym_DASH_GT,
    ACTIONS(6262), 1,
      anon_sym_STAR,
    ACTIONS(6264), 1,
      anon_sym_LT2,
    ACTIONS(6266), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3606), 1,
      aux_sym__compound_type_repeat1,
    STATE(3636), 1,
      sym_type_arguments,
    STATE(3645), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3590), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3090), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5159] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3591), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3274), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5228] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6300), 1,
      anon_sym_DOT,
    STATE(3595), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3592), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5301] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6302), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3593), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5372] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3594), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3361), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3363), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5441] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6305), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3595), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5512] = 17,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(6273), 1,
      anon_sym_DASH_GT,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    ACTIONS(6277), 1,
      anon_sym_LT2,
    ACTIONS(6279), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3604), 1,
      aux_sym__compound_type_repeat1,
    STATE(3620), 1,
      sym_long_identifier,
    STATE(3638), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3596), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6310), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(6308), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5597] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3597), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3274), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5666] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3598), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3361), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3363), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5735] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6300), 1,
      anon_sym_DOT,
    STATE(3592), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3599), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5808] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6312), 1,
      anon_sym_DOT,
    STATE(3593), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3600), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5881] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6312), 1,
      anon_sym_DOT,
    STATE(3600), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3601), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5954] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6314), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3602), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6024] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3603), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6092] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6275), 1,
      anon_sym_STAR,
    STATE(3611), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3604), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3212), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3214), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6164] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6316), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3605), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6234] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6262), 1,
      anon_sym_STAR,
    STATE(3609), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3606), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3212), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3214), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6306] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3607), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6374] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3608), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6442] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6318), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3609), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3030), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6512] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6321), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3610), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6582] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6323), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3611), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3030), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6652] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5794), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(5796), 1,
      anon_sym_DQUOTE,
    ACTIONS(5798), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(5800), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5802), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5808), 1,
      sym_int,
    ACTIONS(5810), 1,
      sym_xint,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6326), 1,
      aux_sym_char_token1,
    STATE(534), 1,
      sym_const,
    STATE(3458), 1,
      sym_float,
    STATE(3509), 1,
      sym_format_triple_quoted_string,
    STATE(6656), 1,
      sym_static_parameter_value,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5806), 2,
      sym_bool,
      sym_unit,
    STATE(3518), 2,
      sym_format_string,
      sym__string_literal,
    STATE(3612), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3497), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [6746] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3613), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6814] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3614), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6881] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6328), 1,
      aux_sym_char_token1,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6332), 1,
      anon_sym_DQUOTE,
    ACTIONS(6334), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6336), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6338), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6342), 1,
      sym_int,
    ACTIONS(6344), 1,
      sym_xint,
    STATE(6226), 1,
      sym_float,
    STATE(6681), 1,
      sym_const,
    STATE(6764), 1,
      sym_format_triple_quoted_string,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 2,
      sym_bool,
      sym_unit,
    STATE(6763), 2,
      sym_format_string,
      sym__string_literal,
    STATE(3615), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6791), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [6972] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3616), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3030), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [7055] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3617), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3308), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3310), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7122] = 38,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    ACTIONS(6380), 1,
      anon_sym_POUNDendif,
    ACTIONS(6382), 1,
      anon_sym_POUNDelse,
    ACTIONS(6384), 1,
      sym__newline,
    STATE(3634), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(8034), 1,
      sym_access_modifier,
    STATE(8049), 1,
      sym_preproc_else_in_class_definition,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3618), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [7247] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3619), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3304), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3306), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7314] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3620), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3296), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3298), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7381] = 38,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    ACTIONS(6382), 1,
      anon_sym_POUNDelse,
    ACTIONS(6384), 1,
      sym__newline,
    ACTIONS(6386), 1,
      anon_sym_POUNDendif,
    STATE(3644), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(7744), 1,
      sym_preproc_else_in_class_definition,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3621), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [7506] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6388), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3622), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3355), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3357), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7575] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3623), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3300), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3302), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7642] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6118), 1,
      aux_sym_decimal_token1,
    ACTIONS(6180), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3624), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7713] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3625), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3292), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3294), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7780] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3626), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3318), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3320), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7847] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3627), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3322), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3324), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7914] = 38,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    ACTIONS(6382), 1,
      anon_sym_POUNDelse,
    ACTIONS(6384), 1,
      sym__newline,
    ACTIONS(6390), 1,
      anon_sym_POUNDendif,
    STATE(3648), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(7558), 1,
      sym_preproc_else_in_class_definition,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3628), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [8039] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3629), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3453), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8106] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6392), 1,
      anon_sym_or,
    STATE(3653), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3630), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [8177] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3631), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3010), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [8260] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3632), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3022), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [8343] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6394), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3633), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3355), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3357), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8412] = 38,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    ACTIONS(6382), 1,
      anon_sym_POUNDelse,
    ACTIONS(6384), 1,
      sym__newline,
    ACTIONS(6396), 1,
      anon_sym_POUNDendif,
    STATE(3666), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(8026), 1,
      sym_preproc_else_in_class_definition,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3634), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [8537] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3635), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3340), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3342), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8604] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3636), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3336), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3338), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8671] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3637), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3342), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8738] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3638), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3336), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3338), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8805] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6398), 1,
      anon_sym_DOT,
    STATE(3656), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3639), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8876] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3640), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8943] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3641), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3318), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3320), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9010] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6400), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3642), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3274), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [9079] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3643), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3322), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3324), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9146] = 38,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    ACTIONS(6382), 1,
      anon_sym_POUNDelse,
    ACTIONS(6384), 1,
      sym__newline,
    ACTIONS(6403), 1,
      anon_sym_POUNDendif,
    STATE(3666), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(7739), 1,
      sym_preproc_else_in_class_definition,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3644), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [9271] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3645), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3296), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3298), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9338] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3646), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3090), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [9421] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6405), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3647), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3419), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9490] = 38,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    ACTIONS(6382), 1,
      anon_sym_POUNDelse,
    ACTIONS(6384), 1,
      sym__newline,
    ACTIONS(6407), 1,
      anon_sym_POUNDendif,
    STATE(3666), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(7553), 1,
      sym_preproc_else_in_class_definition,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3648), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [9615] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3649), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3308), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3310), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9682] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6409), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3650), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9751] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3651), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3292), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3294), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9818] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3652), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9885] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6392), 1,
      anon_sym_or,
    STATE(3642), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3653), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3230), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3232), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [9956] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3654), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3300), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3302), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10023] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3655), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3304), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3306), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10090] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6398), 1,
      anon_sym_DOT,
    STATE(3650), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3656), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10161] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3657), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3361), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3363), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [10227] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3658), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10293] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3659), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 11,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3030), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [10375] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3660), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 11,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3090), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [10457] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3661), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3274), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [10523] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6422), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3662), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10591] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6428), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3663), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10659] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6430), 1,
      anon_sym_when,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    STATE(4094), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3664), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6256), 10,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(6254), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [10745] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6432), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3665), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [10813] = 35,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6435), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6438), 1,
      anon_sym_do,
    ACTIONS(6441), 1,
      anon_sym_let,
    ACTIONS(6444), 1,
      anon_sym_let_BANG,
    ACTIONS(6447), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6450), 1,
      anon_sym_new,
    ACTIONS(6456), 1,
      anon_sym_static,
    ACTIONS(6459), 1,
      anon_sym_member,
    ACTIONS(6462), 1,
      anon_sym_interface,
    ACTIONS(6465), 1,
      anon_sym_abstract,
    ACTIONS(6468), 1,
      anon_sym_val,
    ACTIONS(6471), 1,
      anon_sym_inherit,
    ACTIONS(6474), 1,
      anon_sym_POUNDif,
    ACTIONS(6479), 1,
      sym__newline,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4884), 1,
      sym__class_type_body_inner,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(5104), 1,
      sym_attributes,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6453), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(6477), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3666), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_preproc_if_in_class_definition_repeat1,
  [10931] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6482), 1,
      anon_sym_y,
    ACTIONS(6484), 1,
      anon_sym_uy,
    ACTIONS(6486), 1,
      anon_sym_s,
    ACTIONS(6488), 1,
      anon_sym_us,
    ACTIONS(6490), 1,
      anon_sym_l,
    ACTIONS(6492), 1,
      aux_sym_uint32_token1,
    ACTIONS(6494), 1,
      anon_sym_n,
    ACTIONS(6496), 1,
      anon_sym_un,
    ACTIONS(6498), 1,
      anon_sym_L,
    ACTIONS(6500), 1,
      aux_sym_uint64_token1,
    ACTIONS(6502), 1,
      aux_sym_bignum_token1,
    ACTIONS(6504), 1,
      aux_sym_decimal_token1,
    ACTIONS(6506), 1,
      anon_sym_DOT2,
    ACTIONS(6508), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3667), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11025] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6510), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3668), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3274), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11093] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    STATE(3674), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3669), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11163] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3670), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 11,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3010), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11245] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6428), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3671), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11313] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6515), 1,
      anon_sym_or,
    STATE(3673), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3672), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11383] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6515), 1,
      anon_sym_or,
    STATE(3668), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3673), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3230), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3232), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11453] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    STATE(3665), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3674), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11523] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3675), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 11,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(3022), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11605] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6517), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3676), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11673] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3677), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3840), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3842), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11738] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3678), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11803] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3679), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6310), 10,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(6308), 15,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [11884] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3680), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3705), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3707), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11949] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3681), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12014] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3682), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [12079] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6519), 1,
      anon_sym_DOT,
    STATE(3691), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3683), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12148] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6521), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3684), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3030), 18,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [12215] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6524), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3685), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [12282] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6527), 1,
      anon_sym_DOT,
    STATE(3742), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3686), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12351] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3687), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3825), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3827), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12416] = 18,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6529), 1,
      anon_sym_when,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    STATE(4094), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3688), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6256), 10,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
    ACTIONS(6254), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [12499] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3689), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3818), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3820), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12564] = 35,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6435), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6447), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6477), 1,
      anon_sym_POUNDendif,
    ACTIONS(6531), 1,
      anon_sym_do,
    ACTIONS(6534), 1,
      anon_sym_let,
    ACTIONS(6537), 1,
      anon_sym_let_BANG,
    ACTIONS(6540), 1,
      anon_sym_new,
    ACTIONS(6546), 1,
      anon_sym_static,
    ACTIONS(6549), 1,
      anon_sym_member,
    ACTIONS(6552), 1,
      anon_sym_interface,
    ACTIONS(6555), 1,
      anon_sym_abstract,
    ACTIONS(6558), 1,
      anon_sym_val,
    ACTIONS(6561), 1,
      anon_sym_inherit,
    ACTIONS(6564), 1,
      anon_sym_POUNDif,
    ACTIONS(6567), 1,
      sym__newline,
    STATE(4185), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4743), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4932), 1,
      sym_function_or_value_defn,
    STATE(4944), 1,
      sym_interface_implementation,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(4963), 1,
      sym__member_defns,
    STATE(4972), 1,
      sym__class_type_body_inner,
    STATE(5098), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6543), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4933), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3690), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_preproc_if_in_class_definition_repeat1,
  [12681] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6519), 1,
      anon_sym_DOT,
    STATE(3743), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3691), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12750] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3692), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12815] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    STATE(3684), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3693), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3212), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3214), 18,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [12884] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3694), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [12949] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6570), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3695), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3419), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13016] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3696), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3453), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13081] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6146), 1,
      aux_sym_decimal_token1,
    ACTIONS(6212), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3697), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13150] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3698), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6285), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6287), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [13229] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3699), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6293), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6295), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [13308] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3700), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3453), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13373] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3701), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3361), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3363), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [13438] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3702), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3802), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3804), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13503] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3703), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3798), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3800), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13568] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6572), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3704), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [13635] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3705), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3790), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3792), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13700] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3706), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3274), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [13765] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3707), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3786), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3788), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13830] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6574), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3708), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3419), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13897] = 36,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6576), 1,
      anon_sym_do,
    ACTIONS(6578), 1,
      anon_sym_let,
    ACTIONS(6580), 1,
      anon_sym_let_BANG,
    ACTIONS(6582), 1,
      anon_sym_new,
    ACTIONS(6586), 1,
      anon_sym_static,
    ACTIONS(6588), 1,
      anon_sym_member,
    ACTIONS(6590), 1,
      anon_sym_interface,
    ACTIONS(6592), 1,
      anon_sym_abstract,
    ACTIONS(6594), 1,
      anon_sym_val,
    ACTIONS(6596), 1,
      anon_sym_inherit,
    ACTIONS(6598), 1,
      anon_sym_POUNDif,
    ACTIONS(6600), 1,
      anon_sym_POUNDendif,
    ACTIONS(6602), 1,
      sym__newline,
    STATE(3690), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4185), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4743), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4932), 1,
      sym_function_or_value_defn,
    STATE(4944), 1,
      sym_interface_implementation,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(4963), 1,
      sym__member_defns,
    STATE(4972), 1,
      sym__class_type_body_inner,
    STATE(5098), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6584), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4933), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3709), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [14016] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3710), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3782), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3784), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14081] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3711), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3814), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3816), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14146] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6604), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3712), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14213] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3713), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14278] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3714), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3585), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3587), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14343] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6607), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3715), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14410] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6398), 1,
      anon_sym_DOT,
    STATE(3656), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3716), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14479] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3717), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3778), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3780), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14544] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3718), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3577), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3579), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14609] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3719), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3770), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3772), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14674] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3720), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3598), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3600), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14739] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6174), 1,
      aux_sym_decimal_token1,
    ACTIONS(6216), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3721), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14808] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3722), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3766), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3768), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14873] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3723), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3701), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3703), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14938] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3724), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3746), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3748), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15003] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3725), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15068] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    STATE(3712), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3726), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15137] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3727), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3738), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3740), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15202] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6611), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3728), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15269] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6614), 1,
      anon_sym_DOT,
    STATE(3741), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3729), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [15338] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3730), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3742), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3744), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15403] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3731), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3734), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3736), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15468] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3732), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3728), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15533] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3733), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3722), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3724), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15598] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3734), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3693), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3695), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15663] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3735), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3730), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3732), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15728] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3736), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3608), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3610), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15793] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3737), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3660), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3662), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15858] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3738), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3656), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3658), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15923] = 36,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6576), 1,
      anon_sym_do,
    ACTIONS(6578), 1,
      anon_sym_let,
    ACTIONS(6580), 1,
      anon_sym_let_BANG,
    ACTIONS(6582), 1,
      anon_sym_new,
    ACTIONS(6586), 1,
      anon_sym_static,
    ACTIONS(6588), 1,
      anon_sym_member,
    ACTIONS(6590), 1,
      anon_sym_interface,
    ACTIONS(6592), 1,
      anon_sym_abstract,
    ACTIONS(6594), 1,
      anon_sym_val,
    ACTIONS(6596), 1,
      anon_sym_inherit,
    ACTIONS(6598), 1,
      anon_sym_POUNDif,
    ACTIONS(6602), 1,
      sym__newline,
    ACTIONS(6616), 1,
      anon_sym_POUNDendif,
    STATE(3709), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4185), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4743), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4932), 1,
      sym_function_or_value_defn,
    STATE(4944), 1,
      sym_interface_implementation,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(4963), 1,
      sym__member_defns,
    STATE(4972), 1,
      sym__class_type_body_inner,
    STATE(5098), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6584), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4933), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3739), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [16042] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3740), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3836), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3838), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16107] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6614), 1,
      anon_sym_DOT,
    STATE(3685), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3741), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [16176] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6527), 1,
      anon_sym_DOT,
    STATE(3728), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3742), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16245] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6618), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3743), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16312] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3744), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3616), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3618), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16377] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3745), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3604), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16442] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3746), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3794), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3796), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16507] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3747), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3774), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3776), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16572] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3748), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3642), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3644), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16637] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3749), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3581), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3583), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16702] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3750), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 20,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16766] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6621), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3751), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16836] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3752), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3308), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3310), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [16900] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6623), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3753), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16966] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3754), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [17030] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6625), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3755), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17100] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3756), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17164] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6631), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3757), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6627), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6629), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17230] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6634), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3758), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3274), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17296] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6206), 1,
      aux_sym_decimal_token1,
    ACTIONS(6220), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3759), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17364] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6637), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3760), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3030), 18,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [17430] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6644), 1,
      anon_sym_and,
    STATE(3757), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3761), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6640), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6642), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17498] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3762), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3300), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3302), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [17562] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6646), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3763), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17628] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6648), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3764), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3419), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17694] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6650), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3765), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17764] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    STATE(3760), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3766), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3212), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3214), 18,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [17832] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3767), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17896] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(436), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    STATE(6504), 1,
      sym_attribute,
    STATE(6578), 1,
      sym_object_construction,
    STATE(8364), 1,
      sym_attribute_target,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3768), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6652), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [17984] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6646), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3769), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18050] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3770), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3318), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3320), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [18114] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(436), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    STATE(6390), 1,
      sym_attribute,
    STATE(6578), 1,
      sym_object_construction,
    STATE(8364), 1,
      sym_attribute_target,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3771), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6652), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [18202] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3772), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18266] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(436), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    STATE(6310), 1,
      sym_attribute,
    STATE(6578), 1,
      sym_object_construction,
    STATE(8364), 1,
      sym_attribute_target,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3773), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6652), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [18354] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6662), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3774), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3355), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3357), 18,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [18420] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6664), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3775), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18490] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6666), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3776), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18560] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(436), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    STATE(6578), 1,
      sym_object_construction,
    STATE(6598), 1,
      sym_attribute,
    STATE(8364), 1,
      sym_attribute_target,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3777), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6652), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [18648] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6668), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3778), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18718] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3779), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3453), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18782] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3780), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3340), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3342), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [18846] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6670), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3781), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18916] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3782), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6293), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6295), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [18992] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6672), 1,
      anon_sym_or,
    STATE(3758), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3783), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3230), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3232), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19060] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6674), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3784), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19130] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6644), 1,
      anon_sym_and,
    STATE(3761), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3785), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6676), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6678), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19198] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3786), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19262] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3787), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6285), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6287), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19338] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6680), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3788), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19408] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3789), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 20,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19472] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3790), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3336), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3338), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19536] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3791), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3292), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3294), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19600] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6482), 1,
      anon_sym_y,
    ACTIONS(6484), 1,
      anon_sym_uy,
    ACTIONS(6486), 1,
      anon_sym_s,
    ACTIONS(6488), 1,
      anon_sym_us,
    ACTIONS(6490), 1,
      anon_sym_l,
    ACTIONS(6492), 1,
      aux_sym_uint32_token1,
    ACTIONS(6494), 1,
      anon_sym_n,
    ACTIONS(6496), 1,
      anon_sym_un,
    ACTIONS(6498), 1,
      anon_sym_L,
    ACTIONS(6500), 1,
      aux_sym_uint64_token1,
    ACTIONS(6682), 1,
      anon_sym_lf,
    ACTIONS(6684), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3792), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19688] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3793), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19756] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6686), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3794), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19826] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3795), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3304), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3306), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [19890] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6688), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3796), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19960] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6672), 1,
      anon_sym_or,
    STATE(3783), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3797), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20028] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6623), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3798), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20094] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6690), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3799), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20164] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6692), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3800), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [20230] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3801), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3322), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3324), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [20294] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3802), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3296), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3298), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [20358] = 12,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    ACTIONS(6694), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3803), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3261), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3264), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20428] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(436), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    STATE(6438), 1,
      sym_attribute,
    STATE(6578), 1,
      sym_object_construction,
    STATE(8364), 1,
      sym_attribute_target,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3804), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6652), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [20516] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3805), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3798), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3800), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20579] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3806), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6627), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6629), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20642] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3807), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3581), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3583), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20705] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3808), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3585), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3587), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20768] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3809), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6696), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6698), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20835] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3810), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3774), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3776), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20898] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6706), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3811), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(6702), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20963] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3812), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3604), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21026] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3813), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6709), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6711), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21093] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3814), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3616), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3618), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21156] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3815), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6713), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6715), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21223] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3816), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6717), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6719), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21290] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3817), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3642), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3644), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21353] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3818), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3336), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3338), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [21416] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3819), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6721), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6723), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21483] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3820), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3608), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3610), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21546] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3821), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3656), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3658), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21609] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3822), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3660), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3662), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21672] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3823), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3693), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3695), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21735] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3824), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3722), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3724), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21798] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3825), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3728), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21861] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3826), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3734), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3736), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21924] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3827), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3738), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3740), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21987] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3828), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3746), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3748), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22050] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3829), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3794), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3796), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22113] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3830), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3766), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3768), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22176] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3831), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3701), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3703), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22239] = 34,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(5991), 1,
      anon_sym_POUNDif,
    ACTIONS(6725), 1,
      anon_sym_do,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6731), 1,
      anon_sym_static,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6735), 1,
      anon_sym_interface,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(6741), 1,
      anon_sym_inherit,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4881), 1,
      sym_member_defn,
    STATE(5109), 1,
      sym_attributes,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5999), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6486), 1,
      sym__class_type_body_inner,
    STATE(6553), 1,
      sym_interface_implementation,
    STATE(6629), 1,
      sym_function_or_value_defn,
    STATE(6718), 1,
      sym__member_defns,
    STATE(7834), 1,
      sym_access_modifier,
    STATE(8120), 1,
      sym__class_type_body,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6633), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3832), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [22352] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3833), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3598), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3600), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22415] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3834), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6702), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22482] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3835), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3770), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3772), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22545] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3836), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3577), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3579), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22608] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3837), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3778), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3780), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22671] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3838), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3782), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3784), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22734] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3839), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3786), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3788), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22797] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3840), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3790), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3792), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22860] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    ACTIONS(6743), 1,
      anon_sym_as,
    ACTIONS(6745), 1,
      anon_sym_COMMA,
    ACTIONS(6747), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6751), 1,
      anon_sym_AMP,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3841), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4764), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4762), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22937] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6745), 1,
      anon_sym_COMMA,
    STATE(3811), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3842), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6753), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6755), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23004] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3843), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3585), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3587), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23067] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3844), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3802), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3804), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23130] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3845), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3581), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3583), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23193] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3846), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3274), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23256] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3847), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3774), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3776), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23319] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3848), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3604), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23382] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3849), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3642), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3644), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23445] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3850), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3616), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3618), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23508] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3851), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3794), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3796), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23571] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3852), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3656), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3658), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23634] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3853), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23697] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3854), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3825), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3827), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23760] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3855), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3730), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3732), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23823] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3856), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3660), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3662), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23886] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3857), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3836), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3838), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23949] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3858), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24012] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3859), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3693), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3695), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24075] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3860), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3840), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3842), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24138] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3861), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3722), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3724), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24201] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3862), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3728), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24264] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3863), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3734), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3736), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24327] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3864), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3738), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3740), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24390] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3865), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3746), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3748), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24453] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3866), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3766), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3768), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24516] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3867), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3770), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3772), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24579] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3868), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3577), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3579), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24642] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3869), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3361), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3363), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24705] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3870), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3778), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3780), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24768] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3871), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3782), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3784), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24831] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3872), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3786), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3788), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24894] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3873), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6757), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6759), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24961] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3874), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3790), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3792), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25024] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    STATE(3886), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3875), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6761), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6763), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25089] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3876), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3701), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3703), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25152] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3877), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3300), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3302), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [25215] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3878), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3598), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3600), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25278] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3879), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3798), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3800), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25341] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3880), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3802), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3804), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25404] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3881), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3840), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3842), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25467] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3882), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3825), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3827), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25530] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3883), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3836), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3838), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25593] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3884), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25656] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3885), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3308), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3310), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [25719] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    STATE(3889), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3886), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6765), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6767), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25784] = 34,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(5991), 1,
      anon_sym_POUNDif,
    ACTIONS(6725), 1,
      anon_sym_do,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6731), 1,
      anon_sym_static,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6735), 1,
      anon_sym_interface,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(6741), 1,
      anon_sym_inherit,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4881), 1,
      sym_member_defn,
    STATE(5109), 1,
      sym_attributes,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5999), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6486), 1,
      sym__class_type_body_inner,
    STATE(6553), 1,
      sym_interface_implementation,
    STATE(6629), 1,
      sym_function_or_value_defn,
    STATE(6718), 1,
      sym__member_defns,
    STATE(7582), 1,
      sym__class_type_body,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6633), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3887), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [25897] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6769), 1,
      anon_sym_SEMI,
    STATE(3916), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3888), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6761), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6763), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25964] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6775), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3889), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
    ACTIONS(6771), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26029] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3890), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3296), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3298), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [26092] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3891), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3318), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3320), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [26155] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3892), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3292), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3294), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [26218] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3893), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3304), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3306), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [26281] = 34,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(5991), 1,
      anon_sym_POUNDif,
    ACTIONS(6725), 1,
      anon_sym_do,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6731), 1,
      anon_sym_static,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6735), 1,
      anon_sym_interface,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(6741), 1,
      anon_sym_inherit,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4881), 1,
      sym_member_defn,
    STATE(5109), 1,
      sym_attributes,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5999), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6486), 1,
      sym__class_type_body_inner,
    STATE(6553), 1,
      sym_interface_implementation,
    STATE(6629), 1,
      sym_function_or_value_defn,
    STATE(6718), 1,
      sym__member_defns,
    STATE(7723), 1,
      sym__class_type_body,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6633), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3894), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [26394] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3895), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26457] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3896), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3322), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3324), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [26520] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3897), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6778), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6780), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26583] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3898), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3730), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3732), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26646] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3899), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3742), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3744), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26709] = 34,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(5991), 1,
      anon_sym_POUNDif,
    ACTIONS(6725), 1,
      anon_sym_do,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6731), 1,
      anon_sym_static,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6735), 1,
      anon_sym_interface,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(6741), 1,
      anon_sym_inherit,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4881), 1,
      sym_member_defn,
    STATE(5109), 1,
      sym_attributes,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5999), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6486), 1,
      sym__class_type_body_inner,
    STATE(6553), 1,
      sym_interface_implementation,
    STATE(6629), 1,
      sym_function_or_value_defn,
    STATE(6718), 1,
      sym__member_defns,
    STATE(7404), 1,
      sym__class_type_body,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6633), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3900), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [26822] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3901), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6782), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6784), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26885] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3902), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3814), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3816), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26948] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3903), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3340), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3342), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [27011] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3904), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3818), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3820), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27074] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3905), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3608), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3610), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27137] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3906), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27200] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    ACTIONS(6743), 1,
      anon_sym_as,
    ACTIONS(6745), 1,
      anon_sym_COMMA,
    ACTIONS(6747), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6751), 1,
      anon_sym_AMP,
    STATE(3842), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3907), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6786), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6788), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27277] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3908), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6790), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6792), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27340] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3909), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3705), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3707), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27403] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3910), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6285), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6287), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27466] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6794), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3911), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27531] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6794), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3912), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27596] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6796), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3913), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3355), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3357), 18,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [27661] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3914), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3818), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3820), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27724] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3915), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3351), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3353), 19,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [27787] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6769), 1,
      anon_sym_SEMI,
    STATE(3889), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3916), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6765), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6767), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27854] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3917), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3814), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3816), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27917] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3918), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3742), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3744), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27980] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3919), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3705), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3707), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28043] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3920), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6798), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6800), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28106] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6806), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3921), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6802), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6804), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28171] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3922), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6293), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6295), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28234] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3923), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28297] = 33,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6576), 1,
      anon_sym_do,
    ACTIONS(6578), 1,
      anon_sym_let,
    ACTIONS(6580), 1,
      anon_sym_let_BANG,
    ACTIONS(6582), 1,
      anon_sym_new,
    ACTIONS(6586), 1,
      anon_sym_static,
    ACTIONS(6588), 1,
      anon_sym_member,
    ACTIONS(6590), 1,
      anon_sym_interface,
    ACTIONS(6592), 1,
      anon_sym_abstract,
    ACTIONS(6594), 1,
      anon_sym_val,
    ACTIONS(6596), 1,
      anon_sym_inherit,
    ACTIONS(6598), 1,
      anon_sym_POUNDif,
    STATE(4185), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4743), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4932), 1,
      sym_function_or_value_defn,
    STATE(4944), 1,
      sym_interface_implementation,
    STATE(4953), 1,
      sym__class_type_body_inner,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(4963), 1,
      sym__member_defns,
    STATE(5098), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6584), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4933), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3924), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [28407] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    ACTIONS(6743), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_COMMA,
    ACTIONS(6810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6812), 1,
      anon_sym_PIPE,
    ACTIONS(6814), 1,
      anon_sym_AMP,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3925), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6786), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6788), 13,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28483] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3926), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6816), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6818), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28545] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3927), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3840), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3842), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28607] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3928), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3705), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3707), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28669] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    ACTIONS(6743), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_COMMA,
    ACTIONS(6810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6812), 1,
      anon_sym_PIPE,
    ACTIONS(6814), 1,
      anon_sym_AMP,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3929), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4764), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4762), 13,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28745] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3930), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3701), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3703), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28807] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6808), 1,
      anon_sym_COMMA,
    STATE(3959), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3931), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6753), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6755), 16,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28873] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3932), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6717), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6719), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28939] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3933), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3730), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3732), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29001] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3934), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3798), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3800), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29063] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3935), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6802), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6804), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29125] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6824), 1,
      anon_sym_as,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3936), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6820), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6822), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29189] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3937), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6702), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29255] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3938), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6713), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6715), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29321] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6826), 1,
      sym_identifier,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2592), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    STATE(2982), 1,
      sym_curried_spec,
    STATE(4020), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3939), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [29419] = 33,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6356), 1,
      anon_sym_do,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(6366), 1,
      anon_sym_static,
    ACTIONS(6368), 1,
      anon_sym_member,
    ACTIONS(6370), 1,
      anon_sym_interface,
    ACTIONS(6372), 1,
      anon_sym_abstract,
    ACTIONS(6374), 1,
      anon_sym_val,
    ACTIONS(6376), 1,
      anon_sym_inherit,
    ACTIONS(6378), 1,
      anon_sym_POUNDif,
    STATE(4182), 1,
      sym_member_defn,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4598), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4793), 1,
      sym_interface_implementation,
    STATE(4794), 1,
      sym__member_defns,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4896), 1,
      sym_function_or_value_defn,
    STATE(4899), 1,
      sym__class_type_body_inner,
    STATE(5104), 1,
      sym_attributes,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6364), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4898), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3940), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [29529] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3941), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3742), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3744), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29591] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6840), 1,
      sym_identifier,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    STATE(4016), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4037), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4726), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3942), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [29689] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3943), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3814), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3816), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29751] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3944), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29813] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      sym_identifier,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2782), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    STATE(3186), 1,
      sym_curried_spec,
    STATE(4010), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3945), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [29911] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6860), 1,
      sym_identifier,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    STATE(4013), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4667), 1,
      sym_type,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    STATE(5323), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3946), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [30009] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3947), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3818), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3820), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30071] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3948), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6721), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6723), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30137] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3949), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6696), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6698), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30203] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3950), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6870), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6872), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30265] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3951), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6874), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6876), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30327] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6878), 1,
      sym_identifier,
    STATE(4009), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4788), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5380), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3952), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [30425] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3953), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6880), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6882), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30487] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3954), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6884), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6886), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30549] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3955), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6709), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6711), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30615] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3956), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6424), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6426), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30677] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3957), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6888), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6890), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30739] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3958), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6892), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6894), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30801] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6896), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3959), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(6702), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 16,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30865] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3960), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3794), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3796), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30927] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3961), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6899), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6901), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30989] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3962), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6903), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6905), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31051] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3963), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3642), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3644), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31113] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6907), 1,
      sym_identifier,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    STATE(4018), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4562), 1,
      sym_type,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5258), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3964), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [31211] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3965), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3786), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3788), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31273] = 16,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6700), 1,
      anon_sym_COLON,
    ACTIONS(6743), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_COMMA,
    ACTIONS(6810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6812), 1,
      anon_sym_PIPE,
    ACTIONS(6814), 1,
      anon_sym_AMP,
    STATE(3931), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3966), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6917), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6919), 13,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31349] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3967), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6771), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31411] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3968), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3608), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3610), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31473] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6921), 1,
      sym_identifier,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    STATE(4019), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4103), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4858), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3969), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [31571] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      sym_identifier,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2782), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    STATE(3180), 1,
      sym_curried_spec,
    STATE(4010), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3970), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [31669] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3971), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3314), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3312), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31731] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3972), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3836), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3838), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31793] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3973), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3825), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3827), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31855] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3974), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3585), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3587), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31917] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6921), 1,
      sym_identifier,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    STATE(4019), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4103), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4861), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3975), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [32015] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6931), 1,
      sym_identifier,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    STATE(4011), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4300), 1,
      sym_type,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4784), 1,
      sym_long_identifier,
    STATE(5217), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3976), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [32113] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3977), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6941), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6943), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32175] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6840), 1,
      sym_identifier,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    STATE(4016), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4037), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4724), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3978), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [32273] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3979), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3581), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3583), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32335] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3980), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3774), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3776), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32397] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3981), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3604), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32459] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3982), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3616), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3618), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32521] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3983), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6945), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6947), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32583] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3984), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3656), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3658), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32645] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3985), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6949), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6951), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32707] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3986), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3802), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3804), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32769] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3987), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3660), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3662), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32831] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3988), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3598), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3600), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32893] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3989), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32955] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3990), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3790), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3792), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33017] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6860), 1,
      sym_identifier,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    STATE(4013), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4667), 1,
      sym_type,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    STATE(5312), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3991), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [33115] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6826), 1,
      sym_identifier,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2592), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    STATE(3002), 1,
      sym_curried_spec,
    STATE(4020), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3992), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [33213] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6907), 1,
      sym_identifier,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    STATE(4018), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4562), 1,
      sym_type,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5244), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3993), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [33311] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3994), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3693), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3695), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33373] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3995), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3722), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3724), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33435] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3996), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3728), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33497] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3997), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3734), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3736), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33559] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(3998), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3738), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3740), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33621] = 33,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(5991), 1,
      anon_sym_POUNDif,
    ACTIONS(6725), 1,
      anon_sym_do,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6731), 1,
      anon_sym_static,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6735), 1,
      anon_sym_interface,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(6741), 1,
      anon_sym_inherit,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4881), 1,
      sym_member_defn,
    STATE(5109), 1,
      sym_attributes,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5999), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6553), 1,
      sym_interface_implementation,
    STATE(6629), 1,
      sym_function_or_value_defn,
    STATE(6686), 1,
      sym__class_type_body_inner,
    STATE(6718), 1,
      sym__member_defns,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6633), 4,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_class_inherits_decl,
      sym_preproc_if_in_class_definition,
    STATE(3999), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [33731] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4000), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3746), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3748), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33793] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4001), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3766), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3768), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33855] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4002), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3770), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3772), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33917] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4003), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3577), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3579), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33979] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6931), 1,
      sym_identifier,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    STATE(4011), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4300), 1,
      sym_type,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4784), 1,
      sym_long_identifier,
    STATE(5210), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4004), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34077] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4005), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3778), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3780), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34139] = 27,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6878), 1,
      sym_identifier,
    STATE(4009), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4788), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5366), 1,
      sym_curried_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4006), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34237] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4007), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3782), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3784), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34299] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6953), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4008), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [34362] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6878), 1,
      sym_identifier,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4789), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4009), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34457] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      sym_identifier,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2805), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4010), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34552] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6931), 1,
      sym_identifier,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4301), 1,
      sym_type,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4784), 1,
      sym_long_identifier,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4011), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34647] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6955), 1,
      anon_sym_DOT,
    STATE(4017), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4012), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [34712] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6860), 1,
      sym_identifier,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4657), 1,
      sym_type,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4013), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34807] = 25,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6957), 1,
      sym_identifier,
    ACTIONS(6960), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6963), 1,
      anon_sym_LPAREN,
    ACTIONS(6966), 1,
      anon_sym__,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6972), 1,
      anon_sym_POUND,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(5873), 1,
      sym_type,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6975), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4014), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_curried_spec_repeat1,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [34900] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6955), 1,
      anon_sym_DOT,
    STATE(4012), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4015), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [34965] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6840), 1,
      sym_identifier,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4052), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4016), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [35060] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6978), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4017), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35123] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6907), 1,
      sym_identifier,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4634), 1,
      sym_type,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4018), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [35218] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6921), 1,
      sym_identifier,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4101), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4019), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [35313] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6826), 1,
      sym_identifier,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2421), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    STATE(4014), 1,
      aux_sym_curried_spec_repeat1,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(6335), 1,
      sym_argument_spec,
    STATE(8124), 1,
      sym_arguments_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4020), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [35408] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6981), 1,
      anon_sym_or,
    STATE(4027), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4021), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3230), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3232), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35472] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4022), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35532] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6981), 1,
      anon_sym_or,
    STATE(4021), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4023), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35596] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6246), 1,
      aux_sym_decimal_token1,
    ACTIONS(6289), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4024), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35660] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6983), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4025), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3419), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35722] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4026), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 17,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35782] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6985), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4027), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3274), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35844] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_with,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    STATE(4800), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4028), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5188), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5190), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [35924] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4029), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3453), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35984] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(7002), 1,
      anon_sym_LBRACK_LT,
    STATE(4118), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4030), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(7000), 12,
      anon_sym_mutable,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      aux_sym_char_token1,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7005), 13,
      aux_sym_access_modifier_token1,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36048] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7007), 1,
      anon_sym_or,
    STATE(4041), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4031), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3242), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [36111] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4032), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6782), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6784), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [36170] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4033), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6285), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6287), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [36229] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7011), 1,
      anon_sym_with,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    STATE(4950), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5188), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4034), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5190), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [36308] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4035), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3022), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3024), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [36383] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4036), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6790), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6792), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [36442] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(4037), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4979), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(4981), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [36515] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4038), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3030), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3032), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [36590] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4039), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3010), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3012), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [36665] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    STATE(4087), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4040), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3257), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [36730] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7007), 1,
      anon_sym_or,
    STATE(4056), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4041), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3230), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [36793] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7023), 1,
      anon_sym_y,
    ACTIONS(7025), 1,
      anon_sym_uy,
    ACTIONS(7027), 1,
      anon_sym_s,
    ACTIONS(7029), 1,
      anon_sym_us,
    ACTIONS(7031), 1,
      anon_sym_l,
    ACTIONS(7033), 1,
      aux_sym_uint32_token1,
    ACTIONS(7035), 1,
      anon_sym_n,
    ACTIONS(7037), 1,
      anon_sym_un,
    ACTIONS(7039), 1,
      anon_sym_L,
    ACTIONS(7041), 1,
      aux_sym_uint64_token1,
    ACTIONS(7043), 1,
      aux_sym_bignum_token1,
    ACTIONS(7045), 1,
      aux_sym_decimal_token1,
    ACTIONS(7047), 1,
      anon_sym_DOT2,
    ACTIONS(7049), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4042), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [36880] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4043), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6798), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6800), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [36939] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7051), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4044), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6802), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6804), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37000] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4045), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3274), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3276), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37059] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4046), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3090), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3092), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [37134] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4047), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6293), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6295), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37193] = 24,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(7053), 1,
      sym_identifier,
    STATE(4251), 1,
      sym_attributes,
    STATE(4710), 1,
      sym_argument_name_spec,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5467), 1,
      aux_sym_attributes_repeat1,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5815), 1,
      sym_attribute_set,
    STATE(5873), 1,
      sym_type,
    STATE(6702), 1,
      sym_argument_spec,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4048), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [37282] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7055), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4049), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6627), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6629), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37343] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4050), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6627), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6629), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37402] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7058), 1,
      anon_sym_and,
    STATE(4049), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4051), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6640), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6642), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37465] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(4052), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4955), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(4957), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [37538] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4053), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6778), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6780), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37597] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7060), 1,
      anon_sym_and,
    STATE(4059), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4054), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6640), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6642), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37660] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7060), 1,
      anon_sym_and,
    STATE(4054), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4055), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6676), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6678), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37723] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7062), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4056), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3274), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [37784] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7058), 1,
      anon_sym_and,
    STATE(4051), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4057), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6676), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6678), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37847] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4058), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3361), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3363), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37906] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7065), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4059), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6627), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6629), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [37967] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4060), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3840), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3842), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38025] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3090), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4061), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [38099] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7068), 1,
      anon_sym_COMMA,
    STATE(4064), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4062), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6753), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6755), 13,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38161] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4063), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6702), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38223] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7072), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4064), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(6702), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 13,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38283] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7075), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4065), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
    ACTIONS(6771), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38343] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4066), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5069), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5071), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [38417] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4067), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5036), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5038), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [38491] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4068), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6721), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6723), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38553] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4069), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5075), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [38627] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4070), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5131), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [38701] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4071), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6709), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6711), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38763] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6988), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_DASH_GT,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_LT2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4183), 1,
      aux_sym__compound_type_repeat1,
    STATE(4196), 1,
      sym_type_arguments,
    STATE(4201), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4072), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5079), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [38837] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4065), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4073), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6765), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6767), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38897] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4074), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6696), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6698), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [38959] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7068), 1,
      anon_sym_COMMA,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_as,
    ACTIONS(7082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7084), 1,
      anon_sym_PIPE,
    ACTIONS(7086), 1,
      anon_sym_AMP,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4075), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6757), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6759), 10,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39031] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4076), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3701), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3703), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39089] = 10,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(7092), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4077), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7088), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7090), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39149] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4078), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6709), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6711), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39211] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7094), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4079), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(6702), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 13,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39271] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_as,
    ACTIONS(7097), 1,
      anon_sym_COMMA,
    ACTIONS(7099), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_AMP,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4080), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6757), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6759), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39343] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_as,
    ACTIONS(7097), 1,
      anon_sym_COMMA,
    ACTIONS(7099), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_AMP,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4081), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6786), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6788), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39415] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4082), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6702), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6704), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39477] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4136), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4083), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6765), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6767), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39537] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4084), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6721), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6723), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39599] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4085), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6696), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6698), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39661] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7068), 1,
      anon_sym_COMMA,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_as,
    ACTIONS(7082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7084), 1,
      anon_sym_PIPE,
    ACTIONS(7086), 1,
      anon_sym_AMP,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4086), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6786), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6788), 10,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39733] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    STATE(4100), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4087), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3202), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [39795] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4088), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6757), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6759), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39857] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4089), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3794), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3796), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39915] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4090), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3642), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3644), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [39973] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4091), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6874), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6876), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40031] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7105), 1,
      anon_sym_DOT,
    STATE(4179), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4092), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3257), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [40095] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4093), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6713), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6715), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40157] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4094), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6870), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6872), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40215] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3022), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4095), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [40289] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7107), 1,
      anon_sym_as,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4096), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6820), 10,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6822), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40349] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4097), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [40423] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4073), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4098), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6761), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6763), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40483] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4099), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6892), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6894), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40541] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7109), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4100), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3285), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [40601] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4955), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4101), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4957), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [40673] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4102), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6816), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6818), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40731] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4979), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4103), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4981), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [40803] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4104), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6888), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6890), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40861] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4083), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4105), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6761), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6763), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40921] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4106), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3242), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3244), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [40979] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3010), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4107), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [41053] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4108), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7112), 12,
      anon_sym_mutable,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      aux_sym_char_token1,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7114), 14,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41111] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4109), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6771), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41169] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4110), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6941), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6943), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41227] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    STATE(4087), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4111), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3257), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [41289] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4112), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6802), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6804), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41347] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4113), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3361), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [41405] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4114), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7116), 12,
      anon_sym_mutable,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      aux_sym_char_token1,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7118), 14,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41463] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7068), 1,
      anon_sym_COMMA,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_as,
    ACTIONS(7082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7084), 1,
      anon_sym_PIPE,
    ACTIONS(7086), 1,
      anon_sym_AMP,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4115), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4764), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4762), 10,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41535] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7120), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4116), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3274), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [41595] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4117), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3274), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [41653] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4118), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7123), 12,
      anon_sym_mutable,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      aux_sym_char_token1,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7125), 14,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41711] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4119), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41769] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4120), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3585), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3587), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41827] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4121), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3581), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3583), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41885] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4122), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3774), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3776), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41943] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4123), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6717), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6719), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42005] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4124), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3836), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3838), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42063] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4125), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3825), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3827), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42121] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4126), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3598), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3600), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42179] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7097), 1,
      anon_sym_COMMA,
    STATE(4079), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4127), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6753), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6755), 13,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42241] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4128), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3604), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42299] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7127), 1,
      anon_sym_or,
    STATE(4116), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4129), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3230), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [42361] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4130), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3616), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3618), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42419] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4131), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6717), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6719), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42481] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_as,
    ACTIONS(7097), 1,
      anon_sym_COMMA,
    ACTIONS(7099), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_AMP,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4132), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4764), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4762), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42553] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4062), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4133), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6713), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6715), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42615] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4134), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3802), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3804), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42673] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      anon_sym_COLON,
    STATE(4127), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4135), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6757), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6759), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42735] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7129), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4136), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
    ACTIONS(6771), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42795] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4137), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3798), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3800), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42853] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7127), 1,
      anon_sym_or,
    STATE(4129), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4138), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3242), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [42915] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4139), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6899), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6901), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [42973] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4140), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3656), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3658), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43031] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4141), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3660), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3662), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43089] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4142), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3693), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3695), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43147] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4143), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3722), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3724), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43205] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4144), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3728), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43263] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4145), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6880), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6882), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43321] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4146), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6884), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6886), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43379] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4147), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3734), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3736), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43437] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4148), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3738), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3740), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43495] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4149), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3746), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3748), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43553] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4150), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6903), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6905), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43611] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4151), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3766), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3768), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43669] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4152), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3770), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3772), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43727] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4153), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3577), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3579), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43785] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4154), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3778), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3780), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43843] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4155), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3782), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3784), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43901] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4156), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3786), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3788), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [43959] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4157), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3790), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3792), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [44017] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4158), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6949), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6951), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [44075] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4159), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6945), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6947), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [44133] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7132), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4160), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3285), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [44192] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5091), 1,
      anon_sym_let,
    ACTIONS(5093), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5096), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7135), 1,
      anon_sym_new,
    ACTIONS(7141), 1,
      anon_sym_static,
    ACTIONS(7144), 1,
      anon_sym_member,
    ACTIONS(7147), 1,
      anon_sym_abstract,
    ACTIONS(7150), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4796), 1,
      sym_member_defn,
    STATE(5569), 1,
      sym_attributes,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7138), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4161), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
    ACTIONS(5089), 8,
      sym__newline,
      anon_sym_do,
      anon_sym_let_BANG,
      anon_sym_interface,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [44277] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5127), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4161), 1,
      aux_sym__member_defns_repeat1,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4796), 1,
      sym_member_defn,
    STATE(5569), 1,
      sym_attributes,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4162), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5125), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [44348] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7153), 1,
      anon_sym_EQ,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(7159), 1,
      anon_sym_with,
    ACTIONS(7161), 1,
      anon_sym_new,
    ACTIONS(7165), 1,
      anon_sym_static,
    ACTIONS(7167), 1,
      anon_sym_member,
    ACTIONS(7169), 1,
      anon_sym_interface,
    ACTIONS(7171), 1,
      anon_sym_abstract,
    ACTIONS(7173), 1,
      anon_sym_val,
    STATE(2835), 1,
      sym_member_defn,
    STATE(3208), 1,
      sym_additional_constr_defn,
    STATE(3224), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(3318), 1,
      sym_interface_implementation,
    STATE(3327), 1,
      sym__member_defns,
    STATE(3329), 1,
      sym__type_defn_elements,
    STATE(3373), 1,
      sym_type_extension_elements,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5353), 1,
      sym_attributes,
    STATE(6624), 1,
      sym_access_modifier,
    STATE(8229), 1,
      sym_primary_constr_args,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7163), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4163), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [44449] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4164), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7175), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7177), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44506] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(7179), 1,
      anon_sym_EQ,
    ACTIONS(7181), 1,
      anon_sym_with,
    ACTIONS(7183), 1,
      anon_sym_new,
    ACTIONS(7187), 1,
      anon_sym_static,
    ACTIONS(7189), 1,
      anon_sym_member,
    ACTIONS(7191), 1,
      anon_sym_interface,
    ACTIONS(7193), 1,
      anon_sym_abstract,
    ACTIONS(7195), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4819), 1,
      sym_member_defn,
    STATE(5330), 1,
      sym_attributes,
    STATE(5359), 1,
      sym_additional_constr_defn,
    STATE(5943), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6150), 1,
      sym_interface_implementation,
    STATE(6334), 1,
      sym__type_defn_elements,
    STATE(6418), 1,
      sym__member_defns,
    STATE(6424), 1,
      sym_type_extension_elements,
    STATE(6619), 1,
      sym_access_modifier,
    STATE(8244), 1,
      sym_primary_constr_args,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7185), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4165), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [44607] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4166), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3361), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [44664] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7197), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4167), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3351), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [44723] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5069), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4168), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5071), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [44796] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4169), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7199), 12,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_new,
      aux_sym_char_token1,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7201), 13,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44853] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7023), 1,
      anon_sym_y,
    ACTIONS(7025), 1,
      anon_sym_uy,
    ACTIONS(7027), 1,
      anon_sym_s,
    ACTIONS(7029), 1,
      anon_sym_us,
    ACTIONS(7033), 1,
      aux_sym_uint32_token1,
    ACTIONS(7035), 1,
      anon_sym_n,
    ACTIONS(7037), 1,
      anon_sym_un,
    ACTIONS(7041), 1,
      aux_sym_uint64_token1,
    ACTIONS(7203), 1,
      anon_sym_l,
    ACTIONS(7205), 1,
      anon_sym_L,
    ACTIONS(7207), 1,
      anon_sym_lf,
    ACTIONS(7209), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4170), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [44934] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5036), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4171), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5038), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [45007] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7211), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4172), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3030), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3032), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45066] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(7214), 1,
      anon_sym_EQ,
    ACTIONS(7216), 1,
      anon_sym_with,
    ACTIONS(7218), 1,
      anon_sym_new,
    ACTIONS(7222), 1,
      anon_sym_static,
    ACTIONS(7224), 1,
      anon_sym_member,
    ACTIONS(7226), 1,
      anon_sym_interface,
    ACTIONS(7228), 1,
      anon_sym_abstract,
    ACTIONS(7230), 1,
      anon_sym_val,
    STATE(2787), 1,
      sym_member_defn,
    STATE(3164), 1,
      sym_additional_constr_defn,
    STATE(3220), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(3239), 1,
      sym_interface_implementation,
    STATE(3294), 1,
      sym__member_defns,
    STATE(3303), 1,
      sym_type_extension_elements,
    STATE(3308), 1,
      sym__type_defn_elements,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5351), 1,
      sym_attributes,
    STATE(6583), 1,
      sym_access_modifier,
    STATE(8328), 1,
      sym_primary_constr_args,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7220), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4173), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [45167] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4174), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3285), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45224] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4175), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3274), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45281] = 31,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(7232), 1,
      anon_sym_EQ,
    ACTIONS(7234), 1,
      anon_sym_with,
    ACTIONS(7236), 1,
      anon_sym_new,
    ACTIONS(7240), 1,
      anon_sym_static,
    ACTIONS(7242), 1,
      anon_sym_member,
    ACTIONS(7244), 1,
      anon_sym_interface,
    ACTIONS(7246), 1,
      anon_sym_abstract,
    ACTIONS(7248), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4777), 1,
      sym_member_defn,
    STATE(5311), 1,
      sym_additional_constr_defn,
    STATE(5382), 1,
      sym_attributes,
    STATE(5931), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6114), 1,
      sym_interface_implementation,
    STATE(6133), 1,
      sym__type_defn_elements,
    STATE(6139), 1,
      sym__member_defns,
    STATE(6228), 1,
      sym_type_extension_elements,
    STATE(6630), 1,
      sym_access_modifier,
    STATE(8208), 1,
      sym_primary_constr_args,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7238), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4176), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [45382] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7105), 1,
      anon_sym_DOT,
    STATE(4179), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4177), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3257), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45443] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5073), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4178), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5075), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [45516] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7105), 1,
      anon_sym_DOT,
    STATE(4160), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4179), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3202), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45577] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5129), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4180), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5131), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [45650] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7009), 1,
      sym_identifier,
    ACTIONS(7013), 1,
      anon_sym_DASH_GT,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(7019), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4187), 1,
      aux_sym__compound_type_repeat1,
    STATE(4217), 1,
      sym_long_identifier,
    STATE(4218), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5077), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4181), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5079), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
  [45723] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5042), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4162), 1,
      aux_sym__member_defns_repeat1,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4795), 1,
      sym_additional_constr_defn,
    STATE(4796), 1,
      sym_member_defn,
    STATE(5569), 1,
      sym_attributes,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4182), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5040), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [45794] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    STATE(4172), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4183), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3212), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45855] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4184), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3242), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [45912] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5042), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4188), 1,
      aux_sym__member_defns_repeat1,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4902), 1,
      sym_member_defn,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(5410), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4185), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5040), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [45982] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4186), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3322), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46038] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7015), 1,
      anon_sym_STAR,
    STATE(4200), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4187), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 9,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3212), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46098] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5127), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4191), 1,
      aux_sym__member_defns_repeat1,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4902), 1,
      sym_member_defn,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(5410), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4188), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5125), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [46168] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4189), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3242), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46224] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4190), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3351), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46280] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5091), 1,
      anon_sym_let,
    ACTIONS(5093), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5096), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      anon_sym_new,
    ACTIONS(7256), 1,
      anon_sym_static,
    ACTIONS(7259), 1,
      anon_sym_member,
    ACTIONS(7262), 1,
      anon_sym_abstract,
    ACTIONS(7265), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4902), 1,
      sym_member_defn,
    STATE(4962), 1,
      sym_additional_constr_defn,
    STATE(5410), 1,
      sym_attributes,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7253), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(5089), 7,
      sym__newline,
      anon_sym_do,
      anon_sym_let_BANG,
      anon_sym_interface,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    STATE(4191), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [46364] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4192), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3285), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46420] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7268), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4193), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3351), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46478] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7270), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4194), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 10,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3285), 12,
      anon_sym_and,
      anon_sym_LPAREN,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [46536] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4195), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3300), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46592] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4196), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3336), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46648] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    STATE(4194), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4197), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 10,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3202), 12,
      anon_sym_and,
      anon_sym_LPAREN,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [46708] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4198), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3308), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46764] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7275), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4199), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3355), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46822] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7277), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4200), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3030), 9,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3032), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46880] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4201), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3296), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46936] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4202), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3340), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [46992] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4203), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3304), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47048] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    STATE(4030), 1,
      aux_sym_attributes_repeat1,
    STATE(4118), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4204), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7280), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7282), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47108] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4205), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3318), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47164] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4206), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3292), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47220] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4207), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3300), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47275] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4208), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 11,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON,
      aux_sym_access_modifier_token1,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3304), 12,
      anon_sym_and,
      anon_sym_LPAREN,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [47330] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7300), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    STATE(8132), 1,
      sym_type_extension_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4209), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [47425] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4210), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3292), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47480] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7302), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4211), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [47537] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4212), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3308), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47592] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7304), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    STATE(8011), 1,
      sym_type_extension_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4213), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [47687] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4214), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3304), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47742] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4215), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3351), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47797] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4216), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 9,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3355), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47854] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4217), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3296), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47909] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4218), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3336), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [47964] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4219), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3322), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [48019] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4220), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3318), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [48074] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7308), 1,
      anon_sym_y,
    ACTIONS(7310), 1,
      anon_sym_uy,
    ACTIONS(7312), 1,
      anon_sym_s,
    ACTIONS(7314), 1,
      anon_sym_us,
    ACTIONS(7316), 1,
      anon_sym_l,
    ACTIONS(7318), 1,
      aux_sym_uint32_token1,
    ACTIONS(7320), 1,
      anon_sym_n,
    ACTIONS(7322), 1,
      anon_sym_un,
    ACTIONS(7324), 1,
      anon_sym_L,
    ACTIONS(7326), 1,
      aux_sym_uint64_token1,
    ACTIONS(7328), 1,
      aux_sym_bignum_token1,
    ACTIONS(7330), 1,
      aux_sym_decimal_token1,
    ACTIONS(7332), 1,
      anon_sym_DOT2,
    ACTIONS(7334), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4221), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [48157] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7336), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7411), 1,
      sym_type_extension_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4222), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [48252] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7338), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7762), 1,
      sym_type_extension_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4223), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [48347] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4224), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3340), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      sym_identifier,
  [48402] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7340), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7730), 1,
      sym_type_extension_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4225), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [48497] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4226), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 11,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3285), 12,
      anon_sym_and,
      anon_sym_LPAREN,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [48552] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4227), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 11,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON,
      aux_sym_access_modifier_token1,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3318), 12,
      anon_sym_and,
      anon_sym_LPAREN,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [48607] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7342), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7592), 1,
      sym_type_extension_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4228), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [48702] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3257), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7344), 1,
      anon_sym_EQ,
    ACTIONS(7348), 1,
      anon_sym_COLON,
    ACTIONS(7350), 1,
      anon_sym_DOT,
    ACTIONS(7354), 1,
      anon_sym_of,
    STATE(4481), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3259), 4,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7346), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4229), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7352), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [48771] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7356), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7367), 1,
      sym_type_extension_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4230), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [48866] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4231), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 11,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON,
      aux_sym_access_modifier_token1,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3292), 12,
      anon_sym_and,
      anon_sym_LPAREN,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [48921] = 29,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7284), 1,
      anon_sym_with,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    ACTIONS(7358), 1,
      sym__dedent,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7541), 1,
      sym_type_extension_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(7993), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4232), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [49016] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7362), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7796), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4233), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [49090] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7364), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7383), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4234), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [49164] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3209), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4173), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4235), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3311), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [49244] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7368), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7591), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4236), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [49318] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7370), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7749), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4237), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [49392] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7372), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7995), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4238), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [49466] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4239), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3318), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3320), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49520] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3090), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4240), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [49590] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4241), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [49660] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4242), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3292), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3294), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49714] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4243), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3453), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [49768] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7384), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7256), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4244), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [49842] = 9,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4245), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3304), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3306), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49896] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3298), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4173), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4246), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3311), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [49976] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7386), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4308), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5050), 1,
      sym_union_type_field,
    STATE(5179), 1,
      sym_union_type_fields,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4247), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [50050] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3269), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4173), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4248), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3311), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [50130] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4165), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(5891), 1,
      sym__type_defn_body,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4249), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6442), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [50210] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7388), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7317), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4250), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [50284] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    ACTIONS(7053), 1,
      sym_identifier,
    STATE(4666), 1,
      sym_argument_name_spec,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5856), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4251), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [50358] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4165), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(5899), 1,
      sym__type_defn_body,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4252), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6442), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [50438] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7157), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4253), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [50512] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4165), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6329), 1,
      sym__type_defn_body,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4254), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6442), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [50592] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3210), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4173), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4255), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3311), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [50672] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4256), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3387), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3389), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [50726] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3010), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4257), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [50796] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7392), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7664), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4258), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [50870] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7394), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7203), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4259), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [50944] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3376), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4163), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4260), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3397), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [51024] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4165), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6281), 1,
      sym__type_defn_body,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4261), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6442), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [51104] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7396), 1,
      anon_sym_or,
    STATE(4275), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4262), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3230), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [51162] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7398), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4263), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3419), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [51218] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7400), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4264), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [51274] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4176), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5858), 1,
      sym__type_defn_body,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4265), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6212), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [51354] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7403), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(8297), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4266), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [51428] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4176), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5851), 1,
      sym__type_defn_body,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4267), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6212), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [51508] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4176), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6203), 1,
      sym__type_defn_body,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4268), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6212), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [51588] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6504), 1,
      aux_sym_decimal_token1,
    ACTIONS(6682), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4269), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [51646] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7405), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(8145), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4270), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [51720] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4176), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6214), 1,
      sym__type_defn_body,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4271), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6212), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [51800] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3022), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4272), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [51870] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7386), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4308), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5050), 1,
      sym_union_type_field,
    STATE(5229), 1,
      sym_union_type_fields,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4273), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [51944] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(7407), 1,
      anon_sym_GT,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5376), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(7866), 1,
      sym_types,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4274), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [52018] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4275), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3274), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [52074] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3216), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4163), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4276), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3397), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [52154] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3217), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4163), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4277), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3397), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [52234] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7412), 1,
      anon_sym_DOT,
    STATE(4281), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4278), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3257), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3259), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [52292] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7396), 1,
      anon_sym_or,
    STATE(4262), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4279), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3242), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [52350] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(3333), 1,
      sym__type_defn_body,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(4163), 1,
      sym_type_name,
    STATE(5031), 1,
      sym_long_identifier,
    STATE(5714), 1,
      sym_attributes,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(5886), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8361), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4280), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3397), 7,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_anon_type_defn,
  [52430] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7412), 1,
      anon_sym_DOT,
    STATE(4264), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4281), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3202), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3204), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [52488] = 18,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7386), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4308), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5077), 1,
      sym_union_type_field,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4282), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [52559] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3022), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4283), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [52628] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7424), 1,
      anon_sym_or,
    STATE(4309), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4284), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3242), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [52685] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7426), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4285), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3274), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [52740] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7429), 1,
      anon_sym_or,
    STATE(4293), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4286), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3242), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [52797] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4287), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [52866] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7433), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4288), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7435), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [52935] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7350), 1,
      anon_sym_DOT,
    ACTIONS(7445), 1,
      anon_sym_COLON,
    STATE(4481), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4289), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3257), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [52994] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(4297), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4290), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3257), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53053] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7449), 1,
      anon_sym_or,
    STATE(4305), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4291), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3230), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53110] = 18,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5573), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7451), 1,
      anon_sym_LPAREN,
    ACTIONS(7453), 1,
      anon_sym__,
    ACTIONS(7455), 1,
      anon_sym_POUND,
    STATE(437), 1,
      sym_type,
    STATE(3228), 1,
      sym__static_type_identifier,
    STATE(3293), 1,
      sym_type_argument,
    STATE(3384), 1,
      sym_long_identifier,
    STATE(6492), 1,
      sym_object_construction,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4292), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3363), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [53181] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7429), 1,
      anon_sym_or,
    STATE(4285), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4293), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3230), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53238] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4294), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3274), 12,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53291] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4295), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3285), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53346] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4324), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7280), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(4296), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7282), 16,
      anon_sym_module,
      anon_sym_type,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [53405] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(4295), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4297), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3202), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53462] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4298), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3285), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3287), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [53515] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3022), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4299), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [53584] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4979), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4300), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4981), 9,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [53651] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4955), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4301), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4957), 9,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [53718] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7449), 1,
      anon_sym_or,
    STATE(4291), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4302), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3242), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53775] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3090), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4303), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [53844] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7472), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_STAR,
    STATE(4304), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7474), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [53911] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7476), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4305), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3274), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [53966] = 18,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(436), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    STATE(6599), 1,
      sym_object_construction,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4306), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [54037] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3010), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4307), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [54106] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7479), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_STAR,
    STATE(4308), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7481), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [54173] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7424), 1,
      anon_sym_or,
    STATE(4312), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4309), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3230), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [54230] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4310), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3361), 12,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [54283] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4311), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [54352] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7483), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4312), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3274), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [54407] = 18,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5573), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7451), 1,
      anon_sym_LPAREN,
    ACTIONS(7453), 1,
      anon_sym__,
    ACTIONS(7455), 1,
      anon_sym_POUND,
    STATE(438), 1,
      sym_type,
    STATE(3228), 1,
      sym__static_type_identifier,
    STATE(3293), 1,
      sym_type_argument,
    STATE(3384), 1,
      sym_long_identifier,
    STATE(6492), 1,
      sym_object_construction,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4313), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3363), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [54478] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7486), 1,
      anon_sym_SEMI,
    STATE(4318), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4314), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6761), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6763), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [54535] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(4297), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4315), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3257), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [54592] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4316), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6771), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [54645] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7308), 1,
      anon_sym_y,
    ACTIONS(7310), 1,
      anon_sym_uy,
    ACTIONS(7312), 1,
      anon_sym_s,
    ACTIONS(7314), 1,
      anon_sym_us,
    ACTIONS(7318), 1,
      aux_sym_uint32_token1,
    ACTIONS(7320), 1,
      anon_sym_n,
    ACTIONS(7322), 1,
      anon_sym_un,
    ACTIONS(7326), 1,
      aux_sym_uint64_token1,
    ACTIONS(7488), 1,
      anon_sym_l,
    ACTIONS(7490), 1,
      anon_sym_L,
    ACTIONS(7492), 1,
      anon_sym_lf,
    ACTIONS(7494), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4317), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [54722] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7486), 1,
      anon_sym_SEMI,
    STATE(4319), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4318), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6765), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6767), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [54779] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7496), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4319), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
    ACTIONS(6771), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [54834] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3022), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4320), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3024), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [54903] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3090), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4321), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [54972] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4322), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3032), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [55041] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3010), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4323), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [55110] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7499), 1,
      anon_sym_LBRACK_LT,
    STATE(4720), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7000), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(4324), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(7005), 16,
      anon_sym_module,
      anon_sym_type,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [55167] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3010), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4325), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3012), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [55236] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7502), 4,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
    STATE(4326), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7504), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [55305] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3090), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4327), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3092), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [55374] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5739), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4328), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55442] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3431), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7506), 1,
      anon_sym_LPAREN,
    ACTIONS(7508), 1,
      anon_sym__,
    ACTIONS(7510), 1,
      anon_sym_POUND,
    STATE(969), 1,
      sym_type,
    STATE(1088), 1,
      sym__static_type_identifier,
    STATE(1254), 1,
      sym_long_identifier,
    STATE(1268), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7512), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4329), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1231), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55510] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5649), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4330), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55578] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5634), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4331), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55646] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4180), 1,
      sym_type,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4332), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55714] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(3253), 1,
      sym_type,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4333), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55782] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4181), 1,
      sym_type,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4334), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55850] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(3271), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4335), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55918] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3782), 1,
      sym_type,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4336), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [55986] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(7542), 1,
      anon_sym__,
    ACTIONS(7544), 1,
      anon_sym_POUND,
    STATE(4831), 1,
      sym_type,
    STATE(4837), 1,
      sym__static_type_identifier,
    STATE(4981), 1,
      sym_type_argument,
    STATE(5033), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4337), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5034), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56054] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(7542), 1,
      anon_sym__,
    ACTIONS(7544), 1,
      anon_sym_POUND,
    STATE(4832), 1,
      sym_type,
    STATE(4837), 1,
      sym__static_type_identifier,
    STATE(4981), 1,
      sym_type_argument,
    STATE(5033), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4338), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5034), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56122] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(7542), 1,
      anon_sym__,
    ACTIONS(7544), 1,
      anon_sym_POUND,
    STATE(4833), 1,
      sym_type,
    STATE(4837), 1,
      sym__static_type_identifier,
    STATE(4981), 1,
      sym_type_argument,
    STATE(5033), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4339), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5034), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56190] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(7542), 1,
      anon_sym__,
    ACTIONS(7544), 1,
      anon_sym_POUND,
    STATE(4836), 1,
      sym_type,
    STATE(4837), 1,
      sym__static_type_identifier,
    STATE(4981), 1,
      sym_type_argument,
    STATE(5033), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4340), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5034), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56258] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_type,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4341), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56326] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4178), 1,
      sym_type,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4342), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56394] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    STATE(8194), 1,
      sym__type_defn_elements,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4343), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [56480] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3317), 1,
      sym_type,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4344), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56548] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(3278), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4345), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56616] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4346), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6949), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6951), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [56668] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4347), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6945), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6947), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [56720] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(443), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4348), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56788] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4841), 1,
      sym_type,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4349), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56856] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4842), 1,
      sym_type,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4350), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56924] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4844), 1,
      sym_type,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4351), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [56992] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4845), 1,
      sym_type,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4352), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57060] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3787), 1,
      sym_type,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4353), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57128] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(445), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4354), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57196] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5702), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4355), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57264] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7558), 1,
      anon_sym_DOT,
    STATE(4661), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4356), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3257), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [57320] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7560), 1,
      anon_sym_SEMI,
    STATE(4422), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4357), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6761), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6763), 9,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [57376] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5664), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4358), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57444] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4171), 1,
      sym_type,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4359), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57512] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4360), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3798), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3800), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [57564] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7558), 1,
      anon_sym_DOT,
    STATE(4661), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4361), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3257), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [57622] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4168), 1,
      sym_type,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4362), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57690] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3853), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(7564), 1,
      anon_sym__,
    ACTIONS(7566), 1,
      anon_sym_POUND,
    STATE(1167), 1,
      sym_type,
    STATE(1416), 1,
      sym__static_type_identifier,
    STATE(1629), 1,
      sym_long_identifier,
    STATE(1630), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7568), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4363), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1633), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57758] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7350), 1,
      anon_sym_DOT,
    STATE(4481), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4364), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3257), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [57814] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5679), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4365), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57882] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4593), 1,
      sym_type,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4366), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [57950] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3853), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(7564), 1,
      anon_sym__,
    ACTIONS(7566), 1,
      anon_sym_POUND,
    STATE(1139), 1,
      sym_type,
    STATE(1416), 1,
      sym__static_type_identifier,
    STATE(1629), 1,
      sym_long_identifier,
    STATE(1630), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7568), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4367), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1633), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58018] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3853), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(7564), 1,
      anon_sym__,
    ACTIONS(7566), 1,
      anon_sym_POUND,
    STATE(1138), 1,
      sym_type,
    STATE(1416), 1,
      sym__static_type_identifier,
    STATE(1629), 1,
      sym_long_identifier,
    STATE(1630), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7568), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4368), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1633), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58086] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4369), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3794), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3796), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [58138] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3220), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7570), 1,
      anon_sym_LPAREN,
    ACTIONS(7572), 1,
      anon_sym__,
    ACTIONS(7574), 1,
      anon_sym_POUND,
    STATE(901), 1,
      sym_type,
    STATE(940), 1,
      sym__static_type_identifier,
    STATE(979), 1,
      sym_long_identifier,
    STATE(980), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7576), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4370), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(981), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58206] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    STATE(4869), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4371), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58274] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5764), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4372), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58342] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4612), 1,
      sym_type,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4373), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58410] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3220), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7570), 1,
      anon_sym_LPAREN,
    ACTIONS(7572), 1,
      anon_sym__,
    ACTIONS(7574), 1,
      anon_sym_POUND,
    STATE(900), 1,
      sym_type,
    STATE(940), 1,
      sym__static_type_identifier,
    STATE(979), 1,
      sym_long_identifier,
    STATE(980), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7576), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4374), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(981), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58478] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    STATE(4843), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4375), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58546] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(447), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4376), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58614] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4377), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3274), 11,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [58666] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4630), 1,
      sym_type,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4378), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58734] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3664), 1,
      sym_type,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4379), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58802] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3220), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7570), 1,
      anon_sym_LPAREN,
    ACTIONS(7572), 1,
      anon_sym__,
    ACTIONS(7574), 1,
      anon_sym_POUND,
    STATE(909), 1,
      sym_type,
    STATE(940), 1,
      sym__static_type_identifier,
    STATE(979), 1,
      sym_long_identifier,
    STATE(980), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7576), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4380), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(981), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58870] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3260), 1,
      sym_type,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4381), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [58938] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4653), 1,
      sym_type,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4382), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59006] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5726), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4383), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59074] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3628), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7586), 1,
      anon_sym_LPAREN,
    ACTIONS(7588), 1,
      anon_sym__,
    ACTIONS(7590), 1,
      anon_sym_POUND,
    STATE(1104), 1,
      sym_type,
    STATE(1401), 1,
      sym__static_type_identifier,
    STATE(1502), 1,
      sym_long_identifier,
    STATE(1508), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4384), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59142] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3675), 1,
      sym_type,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4385), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59210] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4066), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4386), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59278] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4387), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3361), 11,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [59330] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7594), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4388), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3351), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [59384] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7626), 1,
      sym__type_defn_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4389), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [59470] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7158), 1,
      sym__type_defn_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4390), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [59556] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3660), 1,
      sym_type,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4391), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59624] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4731), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4392), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59692] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4393), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3790), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3792), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [59744] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4394), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3786), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3788), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [59796] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    STATE(4403), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4395), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3212), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [59852] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5654), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4396), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59920] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5669), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4397), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [59988] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4398), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3782), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3784), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [60040] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(3255), 1,
      sym_type,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4399), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60108] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3659), 1,
      sym_type,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4400), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60176] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3670), 1,
      sym_type,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4401), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60244] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    STATE(4749), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4402), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60312] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7596), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4403), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [60366] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3301), 1,
      sym_type,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4404), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60434] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4107), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4405), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60502] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(454), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4406), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60570] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4407), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7599), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(7601), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [60622] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5653), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4408), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60690] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(7542), 1,
      anon_sym__,
    ACTIONS(7544), 1,
      anon_sym_POUND,
    STATE(4768), 1,
      sym_type,
    STATE(4837), 1,
      sym__static_type_identifier,
    STATE(4981), 1,
      sym_type_argument,
    STATE(5033), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4409), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5034), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60758] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5644), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4410), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60826] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5750), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4411), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [60894] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4412), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3778), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3780), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [60946] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4413), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7603), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(7605), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [60998] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4097), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4414), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61066] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4732), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4415), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61134] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4061), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4416), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61202] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4417), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6884), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6886), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [61254] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4922), 1,
      sym_type,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4418), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61322] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5627), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4419), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61390] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4420), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6880), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6882), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [61442] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4784), 1,
      sym_long_identifier,
    STATE(5048), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4421), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61510] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7560), 1,
      anon_sym_SEMI,
    STATE(4512), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4422), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6765), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6767), 9,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [61566] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4095), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4423), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61634] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4307), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4424), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61702] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    STATE(4968), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4425), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61770] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3699), 1,
      sym_type,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4426), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61838] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5783), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4427), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [61906] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4428), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3361), 11,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [61958] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4287), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4429), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62026] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5657), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4430), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62094] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3698), 1,
      sym_type,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4431), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62162] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4736), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4432), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62230] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3431), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7506), 1,
      anon_sym_LPAREN,
    ACTIONS(7508), 1,
      anon_sym__,
    ACTIONS(7510), 1,
      anon_sym_POUND,
    STATE(953), 1,
      sym_type,
    STATE(1088), 1,
      sym__static_type_identifier,
    STATE(1254), 1,
      sym_long_identifier,
    STATE(1268), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7512), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4433), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1231), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62298] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4903), 1,
      sym_type,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4434), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62366] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4435), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3577), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3579), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [62418] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5663), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4436), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62486] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4910), 1,
      sym_type,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4437), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62554] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3008), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7617), 1,
      anon_sym_LPAREN,
    ACTIONS(7619), 1,
      anon_sym__,
    ACTIONS(7621), 1,
      anon_sym_POUND,
    STATE(890), 1,
      sym_type,
    STATE(907), 1,
      sym__static_type_identifier,
    STATE(935), 1,
      sym_long_identifier,
    STATE(936), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7623), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4438), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(934), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62622] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    STATE(2957), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4439), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62690] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4440), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7625), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(7627), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [62742] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4906), 1,
      sym_type,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4441), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62810] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6923), 1,
      anon_sym_LPAREN,
    ACTIONS(6925), 1,
      anon_sym__,
    ACTIONS(6927), 1,
      anon_sym_POUND,
    ACTIONS(7009), 1,
      sym_identifier,
    STATE(4034), 1,
      sym_type,
    STATE(4138), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym_type_argument,
    STATE(4216), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4442), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4215), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62878] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3596), 1,
      sym_type,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4443), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [62946] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3326), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7637), 1,
      anon_sym_LPAREN,
    ACTIONS(7639), 1,
      anon_sym__,
    ACTIONS(7641), 1,
      anon_sym_POUND,
    STATE(932), 1,
      sym_type,
    STATE(991), 1,
      sym__static_type_identifier,
    STATE(1008), 1,
      sym_type_argument,
    STATE(1014), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7643), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4444), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1028), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63014] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4067), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4445), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63082] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    STATE(4966), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4446), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63150] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4447), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3274), 11,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [63202] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(4952), 1,
      sym_type,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4448), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63270] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4814), 1,
      sym_type,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4449), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63338] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(451), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4450), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63406] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5670), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4451), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63474] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(440), 1,
      sym_type,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4452), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63542] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4069), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4453), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63610] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4327), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4454), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63678] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5699), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4455), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63746] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4456), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3770), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3772), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [63798] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4283), 1,
      sym_type,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4457), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63866] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4458), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3766), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3768), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [63918] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4750), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4459), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [63986] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5711), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4460), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64054] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5797), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4461), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64122] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4462), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3746), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3748), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [64174] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4039), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4463), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64242] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3513), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7645), 1,
      anon_sym_LPAREN,
    ACTIONS(7647), 1,
      anon_sym__,
    ACTIONS(7649), 1,
      anon_sym_POUND,
    STATE(1019), 1,
      sym_type,
    STATE(1256), 1,
      sym__static_type_identifier,
    STATE(1327), 1,
      sym_type_argument,
    STATE(1456), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7651), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4464), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1305), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64310] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5719), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4465), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64378] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_LPAREN,
    ACTIONS(7552), 1,
      anon_sym__,
    ACTIONS(7554), 1,
      anon_sym_POUND,
    STATE(4792), 1,
      sym_type,
    STATE(4851), 1,
      sym__static_type_identifier,
    STATE(4997), 1,
      sym_type_argument,
    STATE(5051), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4466), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5052), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64446] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    STATE(4834), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4467), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64514] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4038), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4468), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64582] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5792), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4469), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64650] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4470), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3738), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3740), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [64702] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5779), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4471), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64770] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4472), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3734), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3736), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [64822] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3628), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7586), 1,
      anon_sym_LPAREN,
    ACTIONS(7588), 1,
      anon_sym__,
    ACTIONS(7590), 1,
      anon_sym_POUND,
    STATE(1173), 1,
      sym_type,
    STATE(1401), 1,
      sym__static_type_identifier,
    STATE(1502), 1,
      sym_long_identifier,
    STATE(1508), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4473), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64890] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5681), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4474), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [64958] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5518), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4475), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65026] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(7653), 1,
      anon_sym_LPAREN,
    ACTIONS(7655), 1,
      anon_sym__,
    ACTIONS(7657), 1,
      anon_sym_POUND,
    STATE(3573), 1,
      sym_type,
    STATE(3582), 1,
      sym__static_type_identifier,
    STATE(3602), 1,
      sym_type_argument,
    STATE(3622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4476), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3614), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65094] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5766), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4477), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65162] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5762), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4478), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65230] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4046), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4479), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65298] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5749), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4480), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65366] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7350), 1,
      anon_sym_DOT,
    STATE(4489), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4481), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3202), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [65422] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5760), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4482), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65490] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5535), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4483), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65558] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5478), 1,
      sym_type,
    STATE(5501), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4484), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65626] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4035), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4485), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65694] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4070), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4486), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65762] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(464), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4487), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65830] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5131), 1,
      sym_type,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4488), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [65898] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7661), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4489), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3285), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [65952] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4325), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4490), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66020] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(468), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4491), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66088] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3436), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7664), 1,
      anon_sym_LPAREN,
    ACTIONS(7666), 1,
      anon_sym__,
    ACTIONS(7668), 1,
      anon_sym_POUND,
    STATE(992), 1,
      sym_type,
    STATE(1129), 1,
      sym__static_type_identifier,
    STATE(1257), 1,
      sym_type_argument,
    STATE(1269), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7670), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4492), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1261), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66156] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5802), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4493), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66224] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2800), 1,
      sym_type,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4494), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66292] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3436), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7664), 1,
      anon_sym_LPAREN,
    ACTIONS(7666), 1,
      anon_sym__,
    ACTIONS(7668), 1,
      anon_sym_POUND,
    STATE(996), 1,
      sym_type,
    STATE(1129), 1,
      sym__static_type_identifier,
    STATE(1257), 1,
      sym_type_argument,
    STATE(1269), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7670), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4495), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1261), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66360] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5765), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4496), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66428] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4311), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4497), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66496] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4303), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4498), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66564] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(469), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4499), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66632] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4760), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4500), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66700] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5629), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4501), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66768] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7293), 1,
      sym__type_defn_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4502), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [66854] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(461), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4503), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66922] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2844), 1,
      sym_type,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4504), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [66990] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3436), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7664), 1,
      anon_sym_LPAREN,
    ACTIONS(7666), 1,
      anon_sym__,
    ACTIONS(7668), 1,
      anon_sym_POUND,
    STATE(968), 1,
      sym_type,
    STATE(1129), 1,
      sym__static_type_identifier,
    STATE(1257), 1,
      sym_type_argument,
    STATE(1269), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7670), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4505), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1261), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67058] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4506), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3242), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [67110] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3628), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7586), 1,
      anon_sym_LPAREN,
    ACTIONS(7588), 1,
      anon_sym__,
    ACTIONS(7590), 1,
      anon_sym_POUND,
    STATE(1180), 1,
      sym_type,
    STATE(1401), 1,
      sym__static_type_identifier,
    STATE(1502), 1,
      sym_long_identifier,
    STATE(1508), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4507), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67178] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5552), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4508), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67246] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(460), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4509), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67314] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5709), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4510), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67382] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5741), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4511), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67450] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7672), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4512), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
    ACTIONS(6771), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6773), 9,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [67504] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(7530), 1,
      anon_sym_LPAREN,
    ACTIONS(7532), 1,
      anon_sym__,
    ACTIONS(7534), 1,
      anon_sym_POUND,
    STATE(3672), 1,
      sym__static_type_identifier,
    STATE(3679), 1,
      sym_type,
    STATE(3800), 1,
      sym_type_argument,
    STATE(3913), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4513), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3915), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67572] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3628), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7586), 1,
      anon_sym_LPAREN,
    ACTIONS(7588), 1,
      anon_sym__,
    ACTIONS(7590), 1,
      anon_sym_POUND,
    STATE(1067), 1,
      sym_type,
    STATE(1401), 1,
      sym__static_type_identifier,
    STATE(1502), 1,
      sym_long_identifier,
    STATE(1508), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4514), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67640] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5738), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4515), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67708] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5812), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4516), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67776] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5771), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4517), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67844] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5697), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4518), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67912] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2762), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4519), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [67980] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2822), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4520), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68048] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5706), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4521), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68116] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5621), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4522), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68184] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2739), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4523), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68252] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4320), 1,
      sym_type,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4524), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68320] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5703), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4525), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68388] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    STATE(4959), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4526), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68456] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(449), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4527), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68524] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2106), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4528), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68592] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2102), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4529), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68660] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2101), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4530), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68728] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2825), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4531), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68796] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2052), 1,
      sym_type,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4532), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68864] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5790), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4533), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [68932] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3436), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7664), 1,
      anon_sym_LPAREN,
    ACTIONS(7666), 1,
      anon_sym__,
    ACTIONS(7668), 1,
      anon_sym_POUND,
    STATE(961), 1,
      sym_type,
    STATE(1129), 1,
      sym__static_type_identifier,
    STATE(1257), 1,
      sym_type_argument,
    STATE(1269), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7670), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4534), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1261), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69000] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3567), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7675), 1,
      anon_sym_LPAREN,
    ACTIONS(7677), 1,
      anon_sym__,
    ACTIONS(7679), 1,
      anon_sym_POUND,
    STATE(1057), 1,
      sym_type,
    STATE(1432), 1,
      sym__static_type_identifier,
    STATE(1471), 1,
      sym_type_argument,
    STATE(1472), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4535), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1469), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69068] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2673), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4536), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69136] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2531), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4537), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69204] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3567), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7675), 1,
      anon_sym_LPAREN,
    ACTIONS(7677), 1,
      anon_sym__,
    ACTIONS(7679), 1,
      anon_sym_POUND,
    STATE(1045), 1,
      sym_type,
    STATE(1432), 1,
      sym__static_type_identifier,
    STATE(1471), 1,
      sym_type_argument,
    STATE(1472), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4538), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1469), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69272] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4299), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4539), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69340] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3750), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7683), 1,
      anon_sym_LPAREN,
    ACTIONS(7685), 1,
      anon_sym__,
    ACTIONS(7687), 1,
      anon_sym_POUND,
    STATE(1124), 1,
      sym_type,
    STATE(1452), 1,
      sym__static_type_identifier,
    STATE(1551), 1,
      sym_long_identifier,
    STATE(1632), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7689), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4540), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1664), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69408] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    STATE(4941), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4541), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69476] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5752), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4542), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69544] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2829), 1,
      sym_type,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4543), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69612] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3760), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7691), 1,
      anon_sym_LPAREN,
    ACTIONS(7693), 1,
      anon_sym__,
    ACTIONS(7695), 1,
      anon_sym_POUND,
    STATE(1132), 1,
      sym_type,
    STATE(1352), 1,
      sym__static_type_identifier,
    STATE(1536), 1,
      sym_type_argument,
    STATE(1622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7697), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4544), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1544), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69680] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3760), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7691), 1,
      anon_sym_LPAREN,
    ACTIONS(7693), 1,
      anon_sym__,
    ACTIONS(7695), 1,
      anon_sym_POUND,
    STATE(1131), 1,
      sym_type,
    STATE(1352), 1,
      sym__static_type_identifier,
    STATE(1536), 1,
      sym_type_argument,
    STATE(1622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7697), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4545), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1544), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69748] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4546), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3722), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3724), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [69800] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3567), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7675), 1,
      anon_sym_LPAREN,
    ACTIONS(7677), 1,
      anon_sym__,
    ACTIONS(7679), 1,
      anon_sym_POUND,
    STATE(1102), 1,
      sym_type,
    STATE(1432), 1,
      sym__static_type_identifier,
    STATE(1471), 1,
      sym_type_argument,
    STATE(1472), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4547), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1469), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69868] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2786), 1,
      sym_type,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4548), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [69936] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4806), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4549), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70004] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3760), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7691), 1,
      anon_sym_LPAREN,
    ACTIONS(7693), 1,
      anon_sym__,
    ACTIONS(7695), 1,
      anon_sym_POUND,
    STATE(1100), 1,
      sym_type,
    STATE(1352), 1,
      sym__static_type_identifier,
    STATE(1536), 1,
      sym_type_argument,
    STATE(1622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7697), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4550), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1544), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70072] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3750), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7683), 1,
      anon_sym_LPAREN,
    ACTIONS(7685), 1,
      anon_sym__,
    ACTIONS(7687), 1,
      anon_sym_POUND,
    STATE(1123), 1,
      sym_type,
    STATE(1452), 1,
      sym__static_type_identifier,
    STATE(1551), 1,
      sym_long_identifier,
    STATE(1632), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7689), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4551), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1664), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70140] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6852), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym__,
    ACTIONS(6856), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__static_type_identifier,
    STATE(2831), 1,
      sym_type_argument,
    STATE(2840), 1,
      sym_type,
    STATE(2855), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4552), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2851), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70208] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3632), 1,
      sym_type,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4553), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70276] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4321), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4554), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70344] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(472), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4555), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70412] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3646), 1,
      sym_type,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4556), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70480] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3431), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7506), 1,
      anon_sym_LPAREN,
    ACTIONS(7508), 1,
      anon_sym__,
    ACTIONS(7510), 1,
      anon_sym_POUND,
    STATE(964), 1,
      sym_type,
    STATE(1088), 1,
      sym__static_type_identifier,
    STATE(1254), 1,
      sym_long_identifier,
    STATE(1268), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7512), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4557), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1231), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70548] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3750), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7683), 1,
      anon_sym_LPAREN,
    ACTIONS(7685), 1,
      anon_sym__,
    ACTIONS(7687), 1,
      anon_sym_POUND,
    STATE(1099), 1,
      sym_type,
    STATE(1452), 1,
      sym__static_type_identifier,
    STATE(1551), 1,
      sym_long_identifier,
    STATE(1632), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7689), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4558), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1664), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70616] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(3238), 1,
      sym_type,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4559), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70684] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3431), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7506), 1,
      anon_sym_LPAREN,
    ACTIONS(7508), 1,
      anon_sym__,
    ACTIONS(7510), 1,
      anon_sym_POUND,
    STATE(1002), 1,
      sym_type,
    STATE(1088), 1,
      sym__static_type_identifier,
    STATE(1254), 1,
      sym_long_identifier,
    STATE(1268), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7512), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4560), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1231), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70752] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4561), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3693), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3695), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [70804] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4979), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4562), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4981), 8,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [70870] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3616), 1,
      sym_type,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4563), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [70938] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4801), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4564), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71006] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4565), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3660), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3662), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [71058] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3631), 1,
      sym_type,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4566), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71126] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4740), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4567), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71194] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym__,
    ACTIONS(7705), 1,
      anon_sym_POUND,
    STATE(4904), 1,
      sym__static_type_identifier,
    STATE(4919), 1,
      sym_type,
    STATE(5074), 1,
      sym_type_argument,
    STATE(5075), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7707), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4568), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5076), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71262] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4917), 1,
      sym_type,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4569), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71330] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4304), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4570), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71398] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4571), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3656), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3658), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [71450] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3497), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7709), 1,
      anon_sym_LPAREN,
    ACTIONS(7711), 1,
      anon_sym__,
    ACTIONS(7713), 1,
      anon_sym_POUND,
    STATE(1003), 1,
      sym_type,
    STATE(1232), 1,
      sym__static_type_identifier,
    STATE(1378), 1,
      sym_type_argument,
    STATE(1381), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7715), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4572), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1351), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71518] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3497), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7709), 1,
      anon_sym_LPAREN,
    ACTIONS(7711), 1,
      anon_sym__,
    ACTIONS(7713), 1,
      anon_sym_POUND,
    STATE(1030), 1,
      sym_type,
    STATE(1232), 1,
      sym__static_type_identifier,
    STATE(1378), 1,
      sym_type_argument,
    STATE(1381), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7715), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4573), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1351), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71586] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3497), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7709), 1,
      anon_sym_LPAREN,
    ACTIONS(7711), 1,
      anon_sym__,
    ACTIONS(7713), 1,
      anon_sym_POUND,
    STATE(1035), 1,
      sym_type,
    STATE(1232), 1,
      sym__static_type_identifier,
    STATE(1378), 1,
      sym_type_argument,
    STATE(1381), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7715), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4574), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1351), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71654] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4322), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4575), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71722] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5660), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7717), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4576), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(5658), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [71776] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4577), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3802), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3804), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [71828] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5573), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7451), 1,
      anon_sym_LPAREN,
    ACTIONS(7453), 1,
      anon_sym__,
    ACTIONS(7455), 1,
      anon_sym_POUND,
    STATE(3223), 1,
      sym_type,
    STATE(3228), 1,
      sym__static_type_identifier,
    STATE(3293), 1,
      sym_type_argument,
    STATE(3384), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4578), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3363), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [71896] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5674), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7720), 1,
      anon_sym_and,
    STATE(4576), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4579), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5672), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [71952] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5077), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4580), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5079), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [72020] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5651), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7720), 1,
      anon_sym_and,
    STATE(4579), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4581), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5649), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [72076] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym__,
    ACTIONS(7705), 1,
      anon_sym_POUND,
    STATE(4904), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type,
    STATE(5074), 1,
      sym_type_argument,
    STATE(5075), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7707), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4582), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5076), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72144] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym__,
    ACTIONS(7705), 1,
      anon_sym_POUND,
    STATE(4904), 1,
      sym__static_type_identifier,
    STATE(4914), 1,
      sym_type,
    STATE(5074), 1,
      sym_type_argument,
    STATE(5075), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7707), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4583), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5076), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72212] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5597), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4584), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72280] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4846), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4585), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72348] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym__,
    ACTIONS(7705), 1,
      anon_sym_POUND,
    STATE(4904), 1,
      sym__static_type_identifier,
    STATE(4918), 1,
      sym_type,
    STATE(5074), 1,
      sym_type_argument,
    STATE(5075), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7707), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4586), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5076), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72416] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5777), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4587), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72484] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5573), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7451), 1,
      anon_sym_LPAREN,
    ACTIONS(7453), 1,
      anon_sym__,
    ACTIONS(7455), 1,
      anon_sym_POUND,
    STATE(3228), 1,
      sym__static_type_identifier,
    STATE(3229), 1,
      sym_type,
    STATE(3293), 1,
      sym_type_argument,
    STATE(3384), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4588), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3363), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72552] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5674), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4589), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72620] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(456), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4590), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72688] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5758), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4591), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72756] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5734), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4592), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72824] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5129), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4593), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5131), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [72892] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5733), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4594), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [72960] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5628), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4595), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73028] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4739), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4596), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73096] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3583), 1,
      sym_type,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4597), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73164] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5564), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4645), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4793), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4598), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [73220] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2839), 1,
      sym_long_identifier,
    STATE(2890), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4599), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73288] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5665), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4600), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73356] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3853), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(7564), 1,
      anon_sym__,
    ACTIONS(7566), 1,
      anon_sym_POUND,
    STATE(1080), 1,
      sym_type,
    STATE(1416), 1,
      sym__static_type_identifier,
    STATE(1629), 1,
      sym_long_identifier,
    STATE(1630), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7568), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4601), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1633), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73424] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4737), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4602), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73492] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4257), 1,
      sym_type,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4603), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73560] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4241), 1,
      sym_type,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4604), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73628] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3586), 1,
      sym_type,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4605), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73696] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4735), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4606), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73764] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4240), 1,
      sym_type,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4607), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73832] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2806), 1,
      sym_type,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4608), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73900] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4323), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4609), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [73968] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      anon_sym__,
    ACTIONS(6937), 1,
      anon_sym_POUND,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(4272), 1,
      sym_type,
    STATE(4279), 1,
      sym__static_type_identifier,
    STATE(4388), 1,
      sym_type_argument,
    STATE(4784), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4610), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4785), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74036] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7722), 1,
      anon_sym_DOT,
    STATE(4707), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4611), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3257), 10,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [74094] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5073), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4612), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5075), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [74162] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3008), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7617), 1,
      anon_sym_LPAREN,
    ACTIONS(7619), 1,
      anon_sym__,
    ACTIONS(7621), 1,
      anon_sym_POUND,
    STATE(907), 1,
      sym__static_type_identifier,
    STATE(935), 1,
      sym_long_identifier,
    STATE(936), 1,
      sym_type_argument,
    STATE(1264), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7623), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4613), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(934), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74230] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4734), 1,
      sym_type,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4614), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74298] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4615), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3616), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3618), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [74350] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(3232), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4616), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74418] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(3233), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4617), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74486] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3513), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7645), 1,
      anon_sym_LPAREN,
    ACTIONS(7647), 1,
      anon_sym__,
    ACTIONS(7649), 1,
      anon_sym_POUND,
    STATE(1020), 1,
      sym_type,
    STATE(1256), 1,
      sym__static_type_identifier,
    STATE(1327), 1,
      sym_type_argument,
    STATE(1456), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7651), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4618), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1305), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74554] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5290), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4619), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74622] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(3234), 1,
      sym_type,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4620), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74690] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5686), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4621), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74758] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    STATE(5014), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4622), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74826] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4623), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3604), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [74878] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4624), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3598), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3600), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [74930] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3513), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7645), 1,
      anon_sym_LPAREN,
    ACTIONS(7647), 1,
      anon_sym__,
    ACTIONS(7649), 1,
      anon_sym_POUND,
    STATE(1017), 1,
      sym_type,
    STATE(1256), 1,
      sym__static_type_identifier,
    STATE(1327), 1,
      sym_type_argument,
    STATE(1456), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7651), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4625), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1305), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [74998] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3513), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7645), 1,
      anon_sym_LPAREN,
    ACTIONS(7647), 1,
      anon_sym__,
    ACTIONS(7649), 1,
      anon_sym_POUND,
    STATE(1006), 1,
      sym_type,
    STATE(1256), 1,
      sym__static_type_identifier,
    STATE(1327), 1,
      sym_type_argument,
    STATE(1456), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7651), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4626), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1305), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75066] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4627), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3774), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3776), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [75118] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4628), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 9,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3285), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [75170] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4629), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3581), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3583), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [75222] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5036), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4630), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5038), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [75290] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5639), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4631), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75358] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4632), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3585), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3587), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [75410] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5668), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4633), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75478] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4955), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4634), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4957), 8,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [75544] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4915), 1,
      sym_type,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4635), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75612] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7722), 1,
      anon_sym_DOT,
    STATE(4707), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4636), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3257), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [75668] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4637), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3728), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [75720] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3750), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7683), 1,
      anon_sym_LPAREN,
    ACTIONS(7685), 1,
      anon_sym__,
    ACTIONS(7687), 1,
      anon_sym_POUND,
    STATE(1175), 1,
      sym_type,
    STATE(1452), 1,
      sym__static_type_identifier,
    STATE(1551), 1,
      sym_long_identifier,
    STATE(1632), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7689), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4638), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1664), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75788] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4639), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3361), 12,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [75840] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(471), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4640), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75908] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5671), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4641), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [75976] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5606), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4642), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76044] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4643), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3274), 12,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [76096] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4804), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4644), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76164] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5552), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7724), 1,
      anon_sym_interface,
    STATE(4793), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4645), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
    ACTIONS(5550), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [76220] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(439), 1,
      sym_type,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4646), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76288] = 26,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(6185), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    STATE(7443), 1,
      sym__type_defn_elements,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(7951), 1,
      sym__member_defns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4647), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76374] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3567), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7675), 1,
      anon_sym_LPAREN,
    ACTIONS(7677), 1,
      anon_sym__,
    ACTIONS(7679), 1,
      anon_sym_POUND,
    STATE(1157), 1,
      sym_type,
    STATE(1432), 1,
      sym__static_type_identifier,
    STATE(1471), 1,
      sym_type_argument,
    STATE(1472), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4648), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1469), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76442] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6654), 1,
      anon_sym_LPAREN,
    ACTIONS(6656), 1,
      anon_sym__,
    ACTIONS(6658), 1,
      anon_sym_POUND,
    STATE(3235), 1,
      sym__static_type_identifier,
    STATE(3236), 1,
      sym_type,
    STATE(3313), 1,
      sym_type_argument,
    STATE(3346), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4649), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3402), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76510] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(444), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4650), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76578] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5691), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4651), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76646] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    STATE(4928), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4652), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76714] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5069), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4653), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5071), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [76782] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(7653), 1,
      anon_sym_LPAREN,
    ACTIONS(7655), 1,
      anon_sym__,
    ACTIONS(7657), 1,
      anon_sym_POUND,
    STATE(3580), 1,
      sym_type,
    STATE(3582), 1,
      sym__static_type_identifier,
    STATE(3602), 1,
      sym_type_argument,
    STATE(3622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4654), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3614), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76850] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5573), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7451), 1,
      anon_sym_LPAREN,
    ACTIONS(7453), 1,
      anon_sym__,
    ACTIONS(7455), 1,
      anon_sym_POUND,
    STATE(3227), 1,
      sym_type,
    STATE(3228), 1,
      sym__static_type_identifier,
    STATE(3293), 1,
      sym_type_argument,
    STATE(3384), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4655), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3363), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76918] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4028), 1,
      sym_type,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4656), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [76986] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4955), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4657), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4957), 9,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [77052] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5573), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7451), 1,
      anon_sym_LPAREN,
    ACTIONS(7453), 1,
      anon_sym__,
    ACTIONS(7455), 1,
      anon_sym_POUND,
    STATE(3228), 1,
      sym__static_type_identifier,
    STATE(3230), 1,
      sym_type,
    STATE(3293), 1,
      sym_type_argument,
    STATE(3384), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4658), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3363), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77120] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5704), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4659), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77188] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7580), 1,
      anon_sym__,
    ACTIONS(7582), 1,
      anon_sym_POUND,
    STATE(3630), 1,
      sym__static_type_identifier,
    STATE(3688), 1,
      sym_type,
    STATE(3704), 1,
      sym_type_argument,
    STATE(3774), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4660), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3786), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77256] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7558), 1,
      anon_sym_DOT,
    STATE(4665), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4661), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3202), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [77312] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5743), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4662), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77380] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4663), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3825), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3827), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [77432] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4664), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3836), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3838), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [77484] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7727), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4665), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3285), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [77538] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5819), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4666), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77606] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4979), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4667), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4981), 9,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [77672] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5689), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4668), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77740] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4827), 1,
      sym_type,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4669), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77808] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym__,
    ACTIONS(6866), 1,
      anon_sym_POUND,
    ACTIONS(7414), 1,
      sym_identifier,
    STATE(4286), 1,
      sym__static_type_identifier,
    STATE(4759), 1,
      sym_type_argument,
    STATE(4893), 1,
      sym_long_identifier,
    STATE(5106), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4670), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4894), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77876] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(7653), 1,
      anon_sym_LPAREN,
    ACTIONS(7655), 1,
      anon_sym__,
    ACTIONS(7657), 1,
      anon_sym_POUND,
    STATE(3579), 1,
      sym_type,
    STATE(3582), 1,
      sym__static_type_identifier,
    STATE(3602), 1,
      sym_type_argument,
    STATE(3622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4671), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3614), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [77944] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(7653), 1,
      anon_sym_LPAREN,
    ACTIONS(7655), 1,
      anon_sym__,
    ACTIONS(7657), 1,
      anon_sym_POUND,
    STATE(3582), 1,
      sym__static_type_identifier,
    STATE(3590), 1,
      sym_type,
    STATE(3602), 1,
      sym_type_argument,
    STATE(3622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4672), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3614), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78012] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6252), 1,
      sym_identifier,
    ACTIONS(7653), 1,
      anon_sym_LPAREN,
    ACTIONS(7655), 1,
      anon_sym__,
    ACTIONS(7657), 1,
      anon_sym_POUND,
    STATE(3578), 1,
      sym_type,
    STATE(3582), 1,
      sym__static_type_identifier,
    STATE(3602), 1,
      sym_type_argument,
    STATE(3622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4673), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3614), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78080] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2803), 1,
      sym_type,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4674), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78148] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    STATE(5732), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4675), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78216] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3220), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7570), 1,
      anon_sym_LPAREN,
    ACTIONS(7572), 1,
      anon_sym__,
    ACTIONS(7574), 1,
      anon_sym_POUND,
    STATE(902), 1,
      sym_type,
    STATE(940), 1,
      sym__static_type_identifier,
    STATE(979), 1,
      sym_long_identifier,
    STATE(980), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7576), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4676), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(981), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78284] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5212), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4677), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78352] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3326), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7637), 1,
      anon_sym_LPAREN,
    ACTIONS(7639), 1,
      anon_sym__,
    ACTIONS(7641), 1,
      anon_sym_POUND,
    STATE(926), 1,
      sym_type,
    STATE(991), 1,
      sym__static_type_identifier,
    STATE(1008), 1,
      sym_type_argument,
    STATE(1014), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7643), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4678), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1028), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78420] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3567), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7675), 1,
      anon_sym_LPAREN,
    ACTIONS(7677), 1,
      anon_sym__,
    ACTIONS(7679), 1,
      anon_sym_POUND,
    STATE(1136), 1,
      sym_type,
    STATE(1432), 1,
      sym__static_type_identifier,
    STATE(1471), 1,
      sym_type_argument,
    STATE(1472), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4679), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1469), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78488] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3497), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7709), 1,
      anon_sym_LPAREN,
    ACTIONS(7711), 1,
      anon_sym__,
    ACTIONS(7713), 1,
      anon_sym_POUND,
    STATE(1012), 1,
      sym_type,
    STATE(1232), 1,
      sym__static_type_identifier,
    STATE(1378), 1,
      sym_type_argument,
    STATE(1381), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7715), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4680), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1351), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78556] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3326), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7637), 1,
      anon_sym_LPAREN,
    ACTIONS(7639), 1,
      anon_sym__,
    ACTIONS(7641), 1,
      anon_sym_POUND,
    STATE(933), 1,
      sym_type,
    STATE(991), 1,
      sym__static_type_identifier,
    STATE(1008), 1,
      sym_type_argument,
    STATE(1014), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7643), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4681), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1028), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78624] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4682), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3642), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3644), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [78676] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5589), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(7516), 1,
      anon_sym__,
    ACTIONS(7518), 1,
      anon_sym_POUND,
    STATE(441), 1,
      sym_type,
    STATE(3258), 1,
      sym__static_type_identifier,
    STATE(3400), 1,
      sym_type_argument,
    STATE(3437), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4683), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3452), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78744] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4326), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4684), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78812] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      anon_sym__,
    ACTIONS(5971), 1,
      anon_sym_POUND,
    ACTIONS(7431), 1,
      sym_identifier,
    STATE(4284), 1,
      sym__static_type_identifier,
    STATE(4288), 1,
      sym_type,
    STATE(4769), 1,
      sym_type_argument,
    STATE(4888), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4685), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4892), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78880] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3326), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7637), 1,
      anon_sym_LPAREN,
    ACTIONS(7639), 1,
      anon_sym__,
    ACTIONS(7641), 1,
      anon_sym_POUND,
    STATE(937), 1,
      sym_type,
    STATE(991), 1,
      sym__static_type_identifier,
    STATE(1008), 1,
      sym_type_argument,
    STATE(1014), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7643), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4686), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1028), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [78948] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3589), 1,
      sym_type,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4687), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79016] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3008), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7617), 1,
      anon_sym_LPAREN,
    ACTIONS(7619), 1,
      anon_sym__,
    ACTIONS(7621), 1,
      anon_sym_POUND,
    STATE(880), 1,
      sym_type,
    STATE(907), 1,
      sym__static_type_identifier,
    STATE(935), 1,
      sym_long_identifier,
    STATE(936), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7623), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4688), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(934), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79084] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3008), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7617), 1,
      anon_sym_LPAREN,
    ACTIONS(7619), 1,
      anon_sym__,
    ACTIONS(7621), 1,
      anon_sym_POUND,
    STATE(886), 1,
      sym_type,
    STATE(907), 1,
      sym__static_type_identifier,
    STATE(935), 1,
      sym_long_identifier,
    STATE(936), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7623), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4689), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(934), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79152] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5716), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4690), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79220] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4691), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3440), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [79272] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5705), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4692), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79340] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5678), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4693), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79408] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4694), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3701), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3703), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [79460] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5625), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4695), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79528] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5626), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4696), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79596] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym__,
    ACTIONS(7705), 1,
      anon_sym_POUND,
    STATE(4849), 1,
      sym_type,
    STATE(4904), 1,
      sym__static_type_identifier,
    STATE(5074), 1,
      sym_type_argument,
    STATE(5075), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7707), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4697), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5076), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79664] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3008), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7617), 1,
      anon_sym_LPAREN,
    ACTIONS(7619), 1,
      anon_sym__,
    ACTIONS(7621), 1,
      anon_sym_POUND,
    STATE(882), 1,
      sym_type,
    STATE(907), 1,
      sym__static_type_identifier,
    STATE(935), 1,
      sym_long_identifier,
    STATE(936), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7623), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4698), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(934), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79732] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5632), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4699), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79800] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4700), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2768), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2770), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [79852] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym__,
    ACTIONS(6846), 1,
      anon_sym_POUND,
    ACTIONS(6988), 1,
      sym_identifier,
    STATE(4031), 1,
      sym__static_type_identifier,
    STATE(4072), 1,
      sym_type,
    STATE(4167), 1,
      sym_type_argument,
    STATE(4199), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4701), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79920] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(446), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4702), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [79988] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3575), 1,
      sym_type,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4703), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80056] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5213), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4704), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80124] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7609), 1,
      anon_sym_LPAREN,
    ACTIONS(7611), 1,
      anon_sym__,
    ACTIONS(7613), 1,
      anon_sym_POUND,
    STATE(4929), 1,
      sym__static_type_identifier,
    STATE(4995), 1,
      sym_type,
    STATE(5062), 1,
      sym_type_argument,
    STATE(5092), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4705), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5094), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80192] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7730), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3287), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    STATE(4706), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3285), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [80246] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7722), 1,
      anon_sym_DOT,
    STATE(4706), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4707), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3202), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [80302] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5219), 1,
      sym_type,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4708), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80370] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3581), 1,
      sym_type,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4709), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80438] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5856), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4710), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80506] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5701), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4711), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80574] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5794), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4712), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80642] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6271), 1,
      sym_identifier,
    ACTIONS(7629), 1,
      anon_sym_LPAREN,
    ACTIONS(7631), 1,
      anon_sym__,
    ACTIONS(7633), 1,
      anon_sym_POUND,
    STATE(3576), 1,
      sym_type,
    STATE(3584), 1,
      sym__static_type_identifier,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3633), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4713), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3640), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80710] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6909), 1,
      anon_sym_LPAREN,
    ACTIONS(6911), 1,
      anon_sym__,
    ACTIONS(6913), 1,
      anon_sym_POUND,
    ACTIONS(7462), 1,
      sym_identifier,
    STATE(4302), 1,
      sym__static_type_identifier,
    STATE(4774), 1,
      sym_type_argument,
    STATE(4865), 1,
      sym_long_identifier,
    STATE(5186), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4714), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4866), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80778] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5782), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5788), 1,
      anon_sym_POUND,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    STATE(5138), 1,
      sym__static_type_identifier,
    STATE(5378), 1,
      sym_type_argument,
    STATE(5501), 1,
      sym_long_identifier,
    STATE(5530), 1,
      sym_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4715), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5514), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80846] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3760), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7691), 1,
      anon_sym_LPAREN,
    ACTIONS(7693), 1,
      anon_sym__,
    ACTIONS(7695), 1,
      anon_sym_POUND,
    STATE(1075), 1,
      sym_type,
    STATE(1352), 1,
      sym__static_type_identifier,
    STATE(1536), 1,
      sym_type_argument,
    STATE(1622), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7697), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4716), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1544), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [80914] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4717), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3840), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [80966] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      anon_sym_LPAREN,
    ACTIONS(7524), 1,
      anon_sym__,
    ACTIONS(7526), 1,
      anon_sym_POUND,
    STATE(450), 1,
      sym_type,
    STATE(3286), 1,
      sym__static_type_identifier,
    STATE(3433), 1,
      sym_type_argument,
    STATE(3464), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4718), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3479), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [81034] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym__,
    ACTIONS(6836), 1,
      anon_sym_POUND,
    STATE(2093), 1,
      sym__static_type_identifier,
    STATE(2789), 1,
      sym_type_argument,
    STATE(2820), 1,
      sym_type,
    STATE(2839), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4719), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2824), 10,
      sym__simple_type,
      sym__generic_type,
      sym__paren_type,
      sym__function_type,
      sym__compound_type,
      sym__postfix_type,
      sym__list_type,
      sym__static_type,
      sym__constrained_type,
      sym__flexible_type,
  [81102] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7123), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(4720), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7125), 17,
      anon_sym_module,
      anon_sym_LBRACK_LT,
      anon_sym_type,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [81153] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5674), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7733), 1,
      anon_sym_and,
    STATE(4761), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4721), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5672), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [81208] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5350), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4722), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81261] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4723), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3440), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [81312] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5356), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7737), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4724), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5354), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81365] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5374), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7739), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4725), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81418] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5368), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7741), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4726), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5366), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81471] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5374), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7743), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4727), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81524] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5342), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7745), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4728), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81577] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7350), 1,
      anon_sym_DOT,
    STATE(4481), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4729), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3257), 9,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [81634] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5342), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7747), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4730), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [81687] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5069), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4731), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5071), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [81754] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5036), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4732), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5038), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [81821] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4733), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3285), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [81872] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5077), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4734), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5079), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [81939] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5129), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4735), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5131), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82006] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5073), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4736), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5075), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82073] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5073), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4737), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5075), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82140] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7116), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(4738), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7118), 17,
      anon_sym_module,
      anon_sym_LBRACK_LT,
      anon_sym_type,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82191] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5036), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4739), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5038), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82258] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5069), 3,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDendif,
    STATE(4740), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5071), 8,
      anon_sym_and,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82325] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4741), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3242), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [82376] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4742), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3608), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3610), 10,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [82427] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5564), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4745), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(4944), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4743), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [82482] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4744), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3705), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3707), 10,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [82533] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5552), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_interface,
    STATE(4944), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4745), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
    ACTIONS(5550), 15,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [82588] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4746), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3742), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3744), 10,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [82639] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4747), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3814), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3816), 10,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [82690] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4748), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3818), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3820), 10,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [82741] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7752), 1,
      anon_sym_when,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    STATE(5175), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6256), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4749), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6254), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [82812] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5129), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4750), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5131), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [82879] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5713), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4751), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5711), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [82930] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5717), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4752), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5715), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [82981] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5699), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4753), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5697), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [83032] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5336), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7754), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4754), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5334), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [83085] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5350), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7756), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4755), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [83138] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4756), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3285), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83189] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 6,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    STATE(4757), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83242] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    STATE(4757), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3214), 6,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    STATE(4758), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3212), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83297] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7761), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4759), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3351), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83350] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5077), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4760), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5079), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [83417] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5660), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7763), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4761), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(5658), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [83470] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5651), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7733), 1,
      anon_sym_and,
    STATE(4721), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4762), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5649), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [83525] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4763), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3285), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83576] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5093), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5096), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7766), 1,
      anon_sym_new,
    ACTIONS(7772), 1,
      anon_sym_static,
    ACTIONS(7775), 1,
      anon_sym_member,
    ACTIONS(7778), 1,
      anon_sym_abstract,
    ACTIONS(7781), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5236), 1,
      sym_member_defn,
    STATE(5311), 1,
      sym_additional_constr_defn,
    STATE(5455), 1,
      sym_attributes,
    STATE(7955), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7769), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(5089), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4764), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [83653] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4765), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3318), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83704] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4766), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3292), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83755] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4767), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3304), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83806] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7784), 1,
      anon_sym_DASH_GT,
    ACTIONS(7786), 1,
      anon_sym_when,
    ACTIONS(7788), 1,
      anon_sym_STAR,
    ACTIONS(7790), 1,
      anon_sym_LT2,
    ACTIONS(7792), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4990), 1,
      aux_sym__compound_type_repeat1,
    STATE(5026), 1,
      sym_long_identifier,
    STATE(5028), 1,
      sym_type_arguments,
    STATE(5658), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6256), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4768), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6254), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [83877] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7794), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4769), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3351), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83930] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    STATE(4771), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4770), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3212), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [83985] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(4771), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84038] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7236), 1,
      anon_sym_new,
    ACTIONS(7240), 1,
      anon_sym_static,
    ACTIONS(7242), 1,
      anon_sym_member,
    ACTIONS(7246), 1,
      anon_sym_abstract,
    ACTIONS(7248), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4764), 1,
      aux_sym__member_defns_repeat1,
    STATE(5236), 1,
      sym_member_defn,
    STATE(5311), 1,
      sym_additional_constr_defn,
    STATE(5455), 1,
      sym_attributes,
    STATE(7955), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7238), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(5125), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4772), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [84115] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4773), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3242), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84166] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4774), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3351), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84219] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    STATE(4776), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4775), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3212), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84274] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7801), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(4776), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3032), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84327] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7236), 1,
      anon_sym_new,
    ACTIONS(7240), 1,
      anon_sym_static,
    ACTIONS(7242), 1,
      anon_sym_member,
    ACTIONS(7246), 1,
      anon_sym_abstract,
    ACTIONS(7248), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4772), 1,
      aux_sym__member_defns_repeat1,
    STATE(5236), 1,
      sym_member_defn,
    STATE(5311), 1,
      sym_additional_constr_defn,
    STATE(5455), 1,
      sym_attributes,
    STATE(7955), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7238), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(5040), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4777), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [84404] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4778), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3300), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84455] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4779), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3308), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84506] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4780), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3322), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84557] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4781), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3242), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84608] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4782), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3336), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84659] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4783), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3340), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84710] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7804), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4784), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3355), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84763] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4785), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3351), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84814] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7112), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(4786), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7114), 17,
      anon_sym_module,
      anon_sym_LBRACK_LT,
      anon_sym_type,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [84865] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4787), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 8,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3296), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [84916] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4979), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4788), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4981), 8,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [84981] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(4955), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4789), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4957), 8,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [85046] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5093), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5096), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7806), 1,
      anon_sym_new,
    ACTIONS(7812), 1,
      anon_sym_static,
    ACTIONS(7815), 1,
      anon_sym_member,
    ACTIONS(7818), 1,
      anon_sym_abstract,
    ACTIONS(7821), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5342), 1,
      sym_member_defn,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5508), 1,
      sym_attributes,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5089), 2,
      sym__newline,
      sym__dedent,
    ACTIONS(7809), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4790), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [85122] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5699), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4791), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5697), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [85172] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6293), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4792), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6295), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [85238] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5593), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4793), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5591), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85288] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5564), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4794), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85338] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5508), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4795), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5506), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85388] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5484), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4796), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5482), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85438] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5392), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4797), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5390), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85488] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5396), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4798), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5394), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85538] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5400), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4799), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5398), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85588] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5599), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4800), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5597), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85638] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5036), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4801), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5038), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [85704] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5488), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4802), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5486), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85754] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5079), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4803), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85804] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5129), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4804), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5131), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [85870] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5480), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4805), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5478), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [85920] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5069), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4806), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5071), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [85986] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5131), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4807), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86036] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5464), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4808), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5462), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86086] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4809), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5858), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86136] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5442), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4810), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5440), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86186] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5438), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4811), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5436), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86236] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5678), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4812), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5676), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86286] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5075), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4813), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86336] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6285), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4814), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6287), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [86402] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5504), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4815), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5502), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86452] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5494), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4816), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5492), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86502] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5468), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4817), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5466), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86552] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5454), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4818), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5452), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86602] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7183), 1,
      anon_sym_new,
    ACTIONS(7187), 1,
      anon_sym_static,
    ACTIONS(7189), 1,
      anon_sym_member,
    ACTIONS(7193), 1,
      anon_sym_abstract,
    ACTIONS(7195), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4821), 1,
      aux_sym__member_defns_repeat1,
    STATE(5350), 1,
      sym_member_defn,
    STATE(5359), 1,
      sym_additional_constr_defn,
    STATE(5475), 1,
      sym_attributes,
    STATE(8100), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7185), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(5040), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(4819), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [86678] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7834), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4820), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7832), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86728] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7183), 1,
      anon_sym_new,
    ACTIONS(7187), 1,
      anon_sym_static,
    ACTIONS(7189), 1,
      anon_sym_member,
    ACTIONS(7193), 1,
      anon_sym_abstract,
    ACTIONS(7195), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4826), 1,
      aux_sym__member_defns_repeat1,
    STATE(5350), 1,
      sym_member_defn,
    STATE(5359), 1,
      sym_additional_constr_defn,
    STATE(5475), 1,
      sym_attributes,
    STATE(8100), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7185), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(5125), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(4821), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [86804] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7838), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4822), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7836), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86854] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7842), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4823), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7840), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [86904] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7844), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4824), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [86956] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7849), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4825), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7847), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [87006] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5093), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5096), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7851), 1,
      anon_sym_new,
    ACTIONS(7857), 1,
      anon_sym_static,
    ACTIONS(7860), 1,
      anon_sym_member,
    ACTIONS(7863), 1,
      anon_sym_abstract,
    ACTIONS(7866), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5350), 1,
      sym_member_defn,
    STATE(5359), 1,
      sym_additional_constr_defn,
    STATE(5475), 1,
      sym_attributes,
    STATE(8100), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5089), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    ACTIONS(7854), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4826), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [87082] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5077), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4827), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5079), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [87148] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7869), 1,
      anon_sym_or,
    STATE(4824), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3230), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4828), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [87202] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7871), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4829), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [87254] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7874), 1,
      anon_sym_or,
    STATE(4829), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3230), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4830), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [87308] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7784), 1,
      anon_sym_DASH_GT,
    ACTIONS(7788), 1,
      anon_sym_STAR,
    ACTIONS(7790), 1,
      anon_sym_LT2,
    ACTIONS(7792), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4990), 1,
      aux_sym__compound_type_repeat1,
    STATE(5026), 1,
      sym_long_identifier,
    STATE(5028), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3012), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4831), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3010), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [87374] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7784), 1,
      anon_sym_DASH_GT,
    ACTIONS(7788), 1,
      anon_sym_STAR,
    ACTIONS(7790), 1,
      anon_sym_LT2,
    ACTIONS(7792), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4990), 1,
      aux_sym__compound_type_repeat1,
    STATE(5026), 1,
      sym_long_identifier,
    STATE(5028), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4832), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3030), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [87440] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7784), 1,
      anon_sym_DASH_GT,
    ACTIONS(7788), 1,
      anon_sym_STAR,
    ACTIONS(7790), 1,
      anon_sym_LT2,
    ACTIONS(7792), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4990), 1,
      aux_sym__compound_type_repeat1,
    STATE(5026), 1,
      sym_long_identifier,
    STATE(5028), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3092), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4833), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3090), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [87506] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7876), 1,
      anon_sym_when,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    STATE(5175), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6256), 2,
      anon_sym_COLON,
      anon_sym_as,
    ACTIONS(6254), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4834), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [87576] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7880), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4835), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7878), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [87626] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7538), 1,
      sym_identifier,
    ACTIONS(7784), 1,
      anon_sym_DASH_GT,
    ACTIONS(7788), 1,
      anon_sym_STAR,
    ACTIONS(7790), 1,
      anon_sym_LT2,
    ACTIONS(7792), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4990), 1,
      aux_sym__compound_type_repeat1,
    STATE(5026), 1,
      sym_long_identifier,
    STATE(5028), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3024), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4836), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3022), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [87692] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7869), 1,
      anon_sym_or,
    STATE(4828), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4837), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [87746] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7884), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4838), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7882), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [87796] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7888), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4839), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7886), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [87846] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(7890), 1,
      anon_sym_static,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4790), 1,
      aux_sym__member_defns_repeat1,
    STATE(5342), 1,
      sym_member_defn,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5508), 1,
      sym_attributes,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5125), 2,
      sym__newline,
      sym__dedent,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4840), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [87924] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3012), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4841), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3010), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [87990] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4842), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3030), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [88056] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6285), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4843), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6287), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [88122] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3092), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4844), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3090), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [88188] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3024), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4845), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3022), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [88254] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5073), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4846), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5075), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [88320] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4847), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3318), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88370] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4848), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3292), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88420] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7892), 1,
      anon_sym_DASH_GT,
    ACTIONS(7894), 1,
      anon_sym_when,
    ACTIONS(7896), 1,
      anon_sym_STAR,
    ACTIONS(7898), 1,
      anon_sym_LT2,
    ACTIONS(7900), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5068), 1,
      aux_sym__compound_type_repeat1,
    STATE(5084), 1,
      sym_type_arguments,
    STATE(5085), 1,
      sym_long_identifier,
    STATE(5175), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6256), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(6254), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4849), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [88490] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4850), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3304), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88540] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7874), 1,
      anon_sym_or,
    STATE(4830), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4851), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [88594] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4852), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3318), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88644] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4853), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3292), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88694] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4854), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3300), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88744] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4855), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3304), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88794] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5336), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7902), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4856), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5334), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [88846] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4857), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3308), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88896] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5356), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4858), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5354), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [88948] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4859), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3296), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [88998] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4860), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3322), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89048] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5368), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7906), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4861), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5366), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [89100] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4862), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3336), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89150] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4863), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3340), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89200] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5350), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4864), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [89252] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7910), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4865), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3355), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89304] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4866), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3351), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89354] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4867), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3318), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89404] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5374), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7912), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4868), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [89456] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6418), 1,
      anon_sym_LT2,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6293), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4869), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6295), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [89522] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5374), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7914), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4870), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [89574] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4871), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3292), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89624] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5342), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7916), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4872), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [89676] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5342), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7918), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4873), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [89728] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4874), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3300), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89778] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4875), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3304), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89828] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4876), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3308), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89878] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5868), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4877), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5866), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [89928] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4878), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3322), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [89978] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5350), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7920), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4879), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [90030] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4880), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3322), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90080] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(6733), 1,
      anon_sym_member,
    ACTIONS(6737), 1,
      anon_sym_abstract,
    ACTIONS(6739), 1,
      anon_sym_val,
    ACTIONS(7890), 1,
      anon_sym_static,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4840), 1,
      aux_sym__member_defns_repeat1,
    STATE(5342), 1,
      sym_member_defn,
    STATE(5387), 1,
      sym_additional_constr_defn,
    STATE(5508), 1,
      sym_attributes,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5040), 2,
      sym__newline,
      sym__dedent,
    ACTIONS(6729), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4881), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [90158] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7924), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4882), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7922), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [90208] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4883), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3340), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90258] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7928), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4884), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7926), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [90308] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4885), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3300), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90358] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4886), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3308), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90408] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4887), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3296), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90458] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7930), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4888), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3355), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90510] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4889), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3336), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90560] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4890), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3336), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90610] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4891), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3340), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90660] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4892), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3351), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90710] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7932), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3357), 6,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    STATE(4893), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3355), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90762] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4894), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 7,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
    ACTIONS(3351), 11,
      anon_sym_and,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90812] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4895), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3296), 10,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [90862] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7936), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4896), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7934), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [90912] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7940), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4897), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7938), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [90962] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7944), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4898), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7942), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [91012] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7946), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4899), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6477), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [91062] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5717), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4900), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5715), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91112] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5713), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4901), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5711), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91162] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5484), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4902), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5482), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91211] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3024), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3022), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4903), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [91276] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7956), 1,
      anon_sym_or,
    STATE(4920), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(4904), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [91329] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7880), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4905), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7878), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91378] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3030), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4906), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [91443] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7884), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4907), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7882), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91492] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7958), 1,
      anon_sym_DOT,
    STATE(4973), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3257), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4908), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [91545] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7888), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4909), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7886), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91594] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3092), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3090), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4910), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [91659] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7960), 1,
      anon_sym_or,
    STATE(4916), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3230), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4911), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [91712] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5454), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4912), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5452), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [91761] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7892), 1,
      anon_sym_DASH_GT,
    ACTIONS(7896), 1,
      anon_sym_STAR,
    ACTIONS(7898), 1,
      anon_sym_LT2,
    ACTIONS(7900), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5068), 1,
      aux_sym__compound_type_repeat1,
    STATE(5084), 1,
      sym_type_arguments,
    STATE(5085), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3092), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    ACTIONS(3090), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4913), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [91826] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7892), 1,
      anon_sym_DASH_GT,
    ACTIONS(7896), 1,
      anon_sym_STAR,
    ACTIONS(7898), 1,
      anon_sym_LT2,
    ACTIONS(7900), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5068), 1,
      aux_sym__compound_type_repeat1,
    STATE(5084), 1,
      sym_type_arguments,
    STATE(5085), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    ACTIONS(3030), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4914), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [91891] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6293), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(6295), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4915), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [91956] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7962), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4916), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [92007] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6285), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(6287), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4917), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [92072] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7892), 1,
      anon_sym_DASH_GT,
    ACTIONS(7896), 1,
      anon_sym_STAR,
    ACTIONS(7898), 1,
      anon_sym_LT2,
    ACTIONS(7900), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5068), 1,
      aux_sym__compound_type_repeat1,
    STATE(5084), 1,
      sym_type_arguments,
    STATE(5085), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3012), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    ACTIONS(3010), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4918), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [92137] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7892), 1,
      anon_sym_DASH_GT,
    ACTIONS(7896), 1,
      anon_sym_STAR,
    ACTIONS(7898), 1,
      anon_sym_LT2,
    ACTIONS(7900), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5068), 1,
      aux_sym__compound_type_repeat1,
    STATE(5084), 1,
      sym_type_arguments,
    STATE(5085), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3024), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    ACTIONS(3022), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4919), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [92202] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7956), 1,
      anon_sym_or,
    STATE(4924), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3230), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(4920), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [92255] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7849), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4921), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7847), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92304] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7824), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    ACTIONS(7828), 1,
      anon_sym_LT2,
    ACTIONS(7830), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4992), 1,
      aux_sym__compound_type_repeat1,
    STATE(5043), 1,
      sym_long_identifier,
    STATE(5045), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4922), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [92369] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7842), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4923), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7840), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92418] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7965), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(4924), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [92469] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7838), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4925), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7836), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92518] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5125), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4954), 1,
      aux_sym__member_defns_repeat1,
    STATE(5431), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4926), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [92595] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7834), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4927), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7832), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92644] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    STATE(5175), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6256), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(6254), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
    STATE(4928), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [92709] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7960), 1,
      anon_sym_or,
    STATE(4911), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4929), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [92762] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4930), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5858), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92811] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4931), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 8,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(3304), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
  [92860] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7936), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4932), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7934), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92909] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7944), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4933), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7942), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [92958] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5868), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4934), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5866), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93007] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5468), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4935), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5466), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93056] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5494), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4936), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5492), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93105] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5504), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4937), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5502), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93154] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5075), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4938), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93203] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5678), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4939), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5676), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93252] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4940), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [93301] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6285), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(6287), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
    STATE(4941), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [93364] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5438), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4942), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5436), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93413] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5442), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4943), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5440), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93462] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5593), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4944), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5591), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93511] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5464), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4945), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5462), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93560] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5131), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4946), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93609] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5480), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4947), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5478), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93658] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5079), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4948), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93707] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5488), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4949), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5486), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93756] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5599), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4950), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5597), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93805] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7968), 1,
      anon_sym_DOT,
    STATE(4967), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3257), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4951), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [93858] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3012), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3010), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4952), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [93923] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7946), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4953), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6477), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [93972] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5089), 1,
      sym__dedent,
    ACTIONS(5093), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5096), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7970), 1,
      anon_sym_new,
    ACTIONS(7976), 1,
      anon_sym_static,
    ACTIONS(7979), 1,
      anon_sym_member,
    ACTIONS(7982), 1,
      anon_sym_abstract,
    ACTIONS(7985), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5431), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7973), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4954), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [94047] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5396), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4955), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5394), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [94096] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7924), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4956), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7922), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [94145] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5392), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4957), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5390), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [94194] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5400), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4958), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5398), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [94243] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6293), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(6295), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
    STATE(4959), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [94306] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7988), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4960), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94357] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    STATE(4961), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94406] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5508), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4962), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5506), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [94455] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5564), 1,
      anon_sym_let,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4963), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [94504] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4964), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 8,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(3318), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
  [94553] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3361), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    STATE(4965), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94602] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6293), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4966), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6295), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [94665] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7968), 1,
      anon_sym_DOT,
    STATE(4960), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3202), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4967), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94718] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym_identifier,
    ACTIONS(6414), 1,
      anon_sym_DASH_GT,
    ACTIONS(6416), 1,
      anon_sym_STAR,
    ACTIONS(6420), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3766), 1,
      aux_sym__compound_type_repeat1,
    STATE(3818), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6285), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4968), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6287), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [94781] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3361), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4969), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94830] = 23,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5040), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4926), 1,
      aux_sym__member_defns_repeat1,
    STATE(5431), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4970), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [94907] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7991), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4971), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94958] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7928), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4972), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7926), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [95007] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7958), 1,
      anon_sym_DOT,
    STATE(4971), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3202), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4973), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95060] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4974), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 8,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(3292), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
  [95109] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7940), 1,
      anon_sym_let,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4975), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7938), 16,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [95158] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3274), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7994), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4976), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [95208] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7997), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4977), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3030), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95258] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7170), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4978), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [95332] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3387), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8000), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4979), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3389), 14,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [95382] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4980), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95430] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8002), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4981), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95480] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8004), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4982), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3030), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95530] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4983), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95578] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3230), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8007), 1,
      anon_sym_or,
    STATE(4976), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4984), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [95630] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7475), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4985), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [95704] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3242), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8007), 1,
      anon_sym_or,
    STATE(4984), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4986), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [95756] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7344), 1,
      anon_sym_EQ,
    ACTIONS(7348), 1,
      anon_sym_COLON,
    ACTIONS(8009), 1,
      anon_sym_of,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4987), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7346), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [95808] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3259), 1,
      anon_sym_LT2,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4988), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8011), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [95862] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4989), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95910] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7788), 1,
      anon_sym_STAR,
    STATE(4982), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3212), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4990), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95962] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4991), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 12,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96010] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7826), 1,
      anon_sym_STAR,
    STATE(4977), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3212), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4992), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96062] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8015), 1,
      anon_sym_y,
    ACTIONS(8017), 1,
      anon_sym_uy,
    ACTIONS(8019), 1,
      anon_sym_s,
    ACTIONS(8021), 1,
      anon_sym_us,
    ACTIONS(8023), 1,
      anon_sym_l,
    ACTIONS(8025), 1,
      aux_sym_uint32_token1,
    ACTIONS(8027), 1,
      anon_sym_n,
    ACTIONS(8029), 1,
      anon_sym_un,
    ACTIONS(8031), 1,
      anon_sym_L,
    ACTIONS(8033), 1,
      aux_sym_uint64_token1,
    ACTIONS(8035), 1,
      aux_sym_bignum_token1,
    ACTIONS(8037), 1,
      aux_sym_decimal_token1,
    ACTIONS(8039), 1,
      anon_sym_DOT2,
    ACTIONS(8041), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2770), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(4993), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [96136] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3259), 1,
      anon_sym_LT2,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    ACTIONS(8045), 1,
      anon_sym_LPAREN,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4994), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [96190] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7607), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_DASH_GT,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    ACTIONS(7952), 1,
      anon_sym_LT2,
    ACTIONS(7954), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5063), 1,
      aux_sym__compound_type_repeat1,
    STATE(5088), 1,
      sym_long_identifier,
    STATE(5090), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(6308), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(4995), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [96254] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7295), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4996), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [96328] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8047), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4997), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96378] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3259), 1,
      anon_sym_LT2,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    ACTIONS(8051), 1,
      anon_sym_LPAREN,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(4998), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8049), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [96432] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8053), 1,
      anon_sym_DOT,
    STATE(5002), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3257), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4999), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96484] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    STATE(5010), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3257), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5000), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96536] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3417), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8057), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5001), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 14,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [96586] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8053), 1,
      anon_sym_DOT,
    STATE(5015), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3202), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5002), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96638] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8059), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5003), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96688] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7901), 1,
      sym_access_modifier,
    STATE(8079), 1,
      sym__member_defns,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5004), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [96762] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7567), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5005), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [96836] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3361), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    STATE(5006), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96884] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    STATE(5007), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96932] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7388), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5008), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [97006] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7750), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5009), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [97080] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    STATE(5003), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3202), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5010), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97132] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    STATE(5011), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97180] = 22,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(7290), 1,
      anon_sym_static,
    ACTIONS(7292), 1,
      anon_sym_member,
    ACTIONS(7296), 1,
      anon_sym_abstract,
    ACTIONS(7298), 1,
      anon_sym_val,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4970), 1,
      sym_member_defn,
    STATE(5476), 1,
      sym_additional_constr_defn,
    STATE(5592), 1,
      sym_attributes,
    STATE(7251), 1,
      sym__member_defns,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7288), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5012), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [97254] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3361), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    STATE(5013), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97302] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      sym_identifier,
    ACTIONS(6348), 1,
      anon_sym_DASH_GT,
    ACTIONS(6350), 1,
      anon_sym_STAR,
    ACTIONS(6352), 1,
      anon_sym_LT2,
    ACTIONS(6354), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3693), 1,
      aux_sym__compound_type_repeat1,
    STATE(3790), 1,
      sym_type_arguments,
    STATE(3802), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(6308), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(5014), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [97366] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8062), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5015), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97416] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8067), 1,
      anon_sym_COLON,
    ACTIONS(8069), 1,
      anon_sym_of,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5016), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8065), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [97465] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8071), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5017), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3030), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97514] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5018), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97561] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3285), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5019), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97608] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3257), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8074), 1,
      anon_sym_DOT,
    STATE(5058), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5020), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [97659] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3304), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5021), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97706] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3318), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5022), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97753] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3292), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5023), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97800] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3300), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5024), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97847] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3308), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5025), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97894] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3296), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5026), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97941] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3322), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5027), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97988] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3336), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5028), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98035] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5029), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98082] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5953), 1,
      anon_sym_LBRACK_LT,
    STATE(5066), 1,
      aux_sym_attributes_repeat1,
    STATE(5160), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7282), 2,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(5030), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7280), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [98135] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8045), 1,
      anon_sym_LPAREN,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    STATE(5208), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5031), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [98186] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3387), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5032), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3389), 14,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [98233] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8078), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3355), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5033), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [98282] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(5034), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98329] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    STATE(5206), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5035), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8011), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [98380] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8051), 1,
      anon_sym_LPAREN,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    STATE(5177), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5036), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8049), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [98431] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3361), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5037), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 14,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_or,
  [98478] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3318), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5038), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98525] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3292), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5039), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98572] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3300), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5040), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98619] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3304), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5041), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98666] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3308), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5042), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98713] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3296), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5043), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98760] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3322), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5044), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98807] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3336), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5045), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98854] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3274), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5046), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 14,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_or,
  [98901] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3340), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5047), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98948] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7374), 1,
      sym_identifier,
    ACTIONS(7376), 1,
      anon_sym_DASH_GT,
    ACTIONS(7378), 1,
      anon_sym_STAR,
    ACTIONS(7380), 1,
      anon_sym_LT2,
    ACTIONS(7382), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8080), 1,
      anon_sym_with,
    STATE(4395), 1,
      aux_sym__compound_type_repeat1,
    STATE(4782), 1,
      sym_type_arguments,
    STATE(4787), 1,
      sym_long_identifier,
    STATE(6033), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5190), 2,
      anon_sym_and,
      anon_sym_interface,
    ACTIONS(5188), 3,
      anon_sym_LBRACK_LT,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5048), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [99015] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7045), 1,
      aux_sym_decimal_token1,
    ACTIONS(7207), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5049), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99066] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8084), 1,
      anon_sym_STAR,
    STATE(5061), 1,
      aux_sym_union_type_fields_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5050), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8082), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [99115] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8086), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3355), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5051), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [99164] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(5052), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99211] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7348), 1,
      anon_sym_COLON,
    ACTIONS(8009), 1,
      anon_sym_of,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5053), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7346), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [99260] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6778), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5054), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6780), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99307] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6782), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5055), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6784), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99354] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8088), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5056), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99403] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5057), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6629), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99450] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3202), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8074), 1,
      anon_sym_DOT,
    STATE(5056), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5058), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99501] = 21,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(5969), 1,
      anon_sym_new,
    ACTIONS(8091), 1,
      sym_identifier,
    ACTIONS(8093), 1,
      anon_sym_do,
    ACTIONS(8097), 1,
      anon_sym_static,
    ACTIONS(8099), 1,
      anon_sym_member,
    ACTIONS(8101), 1,
      anon_sym_abstract,
    ACTIONS(8103), 1,
      anon_sym_val,
    STATE(5346), 1,
      sym_additional_constr_defn,
    STATE(6659), 1,
      sym_function_or_value_defn,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8095), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5059), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [99572] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6293), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5060), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6295), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99619] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8084), 1,
      anon_sym_STAR,
    STATE(5073), 1,
      aux_sym_union_type_fields_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5061), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8105), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [99668] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8107), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5062), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99717] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7950), 1,
      anon_sym_STAR,
    STATE(5070), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3212), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5063), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99768] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3451), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5064), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3453), 14,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [99815] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6798), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5065), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6800), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [99862] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8109), 1,
      anon_sym_LBRACK_LT,
    STATE(5160), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7005), 2,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(5066), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(7000), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [99913] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5067), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99960] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7896), 1,
      anon_sym_STAR,
    STATE(5017), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3212), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5068), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100011] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6285), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5069), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6287), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [100058] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8112), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5070), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
    ACTIONS(3030), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100107] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6790), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5071), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6792), 14,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [100154] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5072), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100201] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8117), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5073), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_union_type_fields_repeat1,
    ACTIONS(8115), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [100248] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8120), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5074), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100297] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8122), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3355), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5075), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [100345] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5076), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100391] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5077), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8115), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_STAR,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [100435] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3292), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5078), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100481] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3318), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5079), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100527] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3300), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5080), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100573] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3304), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5081), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100619] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3308), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5082), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100665] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3340), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5083), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100711] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3336), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5084), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100757] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3296), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5085), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100803] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3322), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5086), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100849] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3308), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5087), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100895] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3296), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5088), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100941] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3304), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5089), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3306), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100987] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3336), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5090), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101033] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3340), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5091), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101079] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8124), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3355), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5092), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [101127] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3300), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5093), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101173] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5094), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101219] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3292), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5095), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3294), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101265] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3322), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(5096), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101311] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8128), 1,
      anon_sym_PIPE,
    STATE(5112), 1,
      aux_sym_union_type_cases_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5097), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8126), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [101359] = 20,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6578), 1,
      anon_sym_let,
    ACTIONS(6580), 1,
      anon_sym_let_BANG,
    ACTIONS(6582), 1,
      anon_sym_new,
    ACTIONS(8130), 1,
      anon_sym_do,
    ACTIONS(8134), 1,
      anon_sym_static,
    ACTIONS(8136), 1,
      anon_sym_member,
    ACTIONS(8138), 1,
      anon_sym_abstract,
    ACTIONS(8140), 1,
      anon_sym_val,
    STATE(4912), 1,
      sym_additional_constr_defn,
    STATE(4975), 1,
      sym_function_or_value_defn,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8132), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5098), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101427] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3318), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(5099), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3320), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101473] = 20,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8015), 1,
      anon_sym_y,
    ACTIONS(8017), 1,
      anon_sym_uy,
    ACTIONS(8019), 1,
      anon_sym_s,
    ACTIONS(8021), 1,
      anon_sym_us,
    ACTIONS(8025), 1,
      aux_sym_uint32_token1,
    ACTIONS(8027), 1,
      anon_sym_n,
    ACTIONS(8029), 1,
      anon_sym_un,
    ACTIONS(8033), 1,
      aux_sym_uint64_token1,
    ACTIONS(8142), 1,
      anon_sym_l,
    ACTIONS(8144), 1,
      anon_sym_L,
    ACTIONS(8146), 1,
      anon_sym_lf,
    ACTIONS(8148), 1,
      anon_sym_LF,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2770), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(5100), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101541] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5101), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [101587] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8152), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5102), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_union_type_cases_repeat1,
    ACTIONS(8150), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [101633] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5103), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3440), 14,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [101677] = 20,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(8155), 1,
      anon_sym_do,
    ACTIONS(8159), 1,
      anon_sym_static,
    ACTIONS(8161), 1,
      anon_sym_member,
    ACTIONS(8163), 1,
      anon_sym_abstract,
    ACTIONS(8165), 1,
      anon_sym_val,
    STATE(4818), 1,
      sym_additional_constr_defn,
    STATE(4897), 1,
      sym_function_or_value_defn,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8157), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5104), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101745] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8167), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 3,
      anon_sym_COLON,
      anon_sym_and,
      sym_identifier,
    STATE(5105), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101793] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7414), 1,
      sym_identifier,
    ACTIONS(7416), 1,
      anon_sym_DASH_GT,
    ACTIONS(7418), 1,
      anon_sym_STAR,
    ACTIONS(7420), 1,
      anon_sym_LT2,
    ACTIONS(7422), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8170), 1,
      anon_sym_with,
    STATE(4758), 1,
      aux_sym__compound_type_repeat1,
    STATE(4887), 1,
      sym_long_identifier,
    STATE(4890), 1,
      sym_type_arguments,
    STATE(6162), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5188), 2,
      anon_sym_LBRACK_LT,
      anon_sym_POUNDendif,
    ACTIONS(5190), 2,
      anon_sym_and,
      anon_sym_interface,
    STATE(5106), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101859] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8128), 1,
      anon_sym_PIPE,
    STATE(5102), 1,
      aux_sym_union_type_cases_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5107), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8172), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [101907] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3242), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5108), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [101953] = 20,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(8174), 1,
      anon_sym_do,
    ACTIONS(8178), 1,
      anon_sym_static,
    ACTIONS(8180), 1,
      anon_sym_member,
    ACTIONS(8182), 1,
      anon_sym_abstract,
    ACTIONS(8184), 1,
      anon_sym_val,
    STATE(5346), 1,
      sym_additional_constr_defn,
    STATE(6659), 1,
      sym_function_or_value_defn,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8176), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5109), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102021] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8186), 1,
      anon_sym_or,
    STATE(5105), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3230), 3,
      anon_sym_COLON,
      anon_sym_and,
      sym_identifier,
    STATE(5110), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102071] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8128), 1,
      anon_sym_PIPE,
    STATE(5107), 1,
      aux_sym_union_type_cases_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5111), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8188), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [102119] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8128), 1,
      anon_sym_PIPE,
    STATE(5102), 1,
      aux_sym_union_type_cases_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5112), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8188), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [102167] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8198), 1,
      anon_sym_DQUOTE,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5113), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102226] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8208), 1,
      anon_sym_DQUOTE,
    STATE(5166), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5114), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102285] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8210), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5115), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [102330] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8212), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5116), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [102375] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3840), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5117), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3842), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [102420] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6941), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5118), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6943), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [102465] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8214), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5119), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102524] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5120), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3440), 13,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [102567] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8216), 1,
      anon_sym_DQUOTE,
    STATE(5119), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5121), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102626] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3361), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
    STATE(5122), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102671] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8218), 1,
      anon_sym_DQUOTE,
    STATE(5221), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5123), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102730] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8220), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5124), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102789] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3656), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5125), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3658), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [102834] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8222), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5126), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102893] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3660), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5127), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3662), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [102938] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8224), 1,
      anon_sym_DQUOTE,
    STATE(5124), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5128), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102997] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8226), 1,
      anon_sym_DQUOTE,
    STATE(5141), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5129), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103056] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7118), 3,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(5130), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7116), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [103101] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3024), 1,
      anon_sym_and,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3022), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5131), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103162] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8234), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5132), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103221] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6884), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5133), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6886), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103266] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3642), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5134), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3644), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103311] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3693), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5135), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3695), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103356] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3722), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5136), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3724), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103401] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8236), 1,
      anon_sym_DQUOTE,
    STATE(5132), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5137), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103460] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8186), 1,
      anon_sym_or,
    STATE(5110), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5138), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103509] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3726), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5139), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103554] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3734), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5140), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3736), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103599] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8238), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5141), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103658] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3738), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5142), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3740), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103703] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3746), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5143), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3748), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103748] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8240), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5144), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103807] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3766), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5145), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3768), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103852] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3770), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5146), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3772), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [103897] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8242), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5147), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103956] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3577), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5148), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3579), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104001] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3778), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5149), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3780), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104046] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3782), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5150), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3784), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104091] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8244), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5151), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [104136] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8246), 1,
      anon_sym_DQUOTE,
    STATE(5147), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5152), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104195] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3602), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5153), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104240] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8248), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5154), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104299] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6880), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5155), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6882), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104344] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8250), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5156), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104403] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3786), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5157), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3788), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104448] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8252), 1,
      anon_sym_DQUOTE,
    STATE(5156), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5158), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104507] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3790), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5159), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3792), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104552] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7125), 3,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(5160), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7123), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [104597] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8254), 1,
      anon_sym_DQUOTE,
    STATE(5154), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5161), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104656] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6899), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5162), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6901), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104701] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8256), 1,
      anon_sym_DQUOTE,
    STATE(5173), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5163), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104760] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3794), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5164), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3796), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104805] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3598), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5165), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3600), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [104850] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8258), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5166), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104909] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8260), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5167), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104968] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6903), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5168), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6905), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105013] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3774), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5169), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3776), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105058] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3798), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5170), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3800), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105103] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8262), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5171), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [105148] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3802), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5172), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3804), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105193] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8264), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5173), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [105252] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3581), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5174), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3583), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105297] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6870), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5175), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6872), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105342] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5176), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3587), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105387] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8268), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5177), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8266), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [105432] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5178), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8011), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [105477] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5179), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7433), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [105520] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3274), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
    STATE(5180), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105565] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8270), 1,
      anon_sym_DQUOTE,
    STATE(5182), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5181), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [105624] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8272), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5182), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [105683] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5183), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6773), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105728] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8274), 1,
      anon_sym_DQUOTE,
    STATE(5167), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5184), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [105787] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6888), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5185), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6890), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [105832] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5190), 1,
      anon_sym_interface,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7462), 1,
      sym_identifier,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8276), 1,
      anon_sym_with,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    STATE(6422), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5188), 2,
      sym__newline,
      sym__dedent,
    STATE(5186), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [105897] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8284), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8287), 1,
      anon_sym_LBRACE2,
    ACTIONS(8290), 1,
      anon_sym_DQUOTE,
    ACTIONS(8292), 1,
      sym__inside_string_marker,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8278), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8281), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5187), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_format_string_repeat1,
  [105954] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5188), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8150), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [105997] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5189), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6876), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106042] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8295), 1,
      anon_sym_DQUOTE,
    STATE(5198), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5190), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106101] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8297), 1,
      anon_sym_DQUOTE,
    STATE(5126), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5191), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106160] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3825), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5192), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3827), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106205] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3836), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5193), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3838), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106250] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8299), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5194), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106309] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8301), 1,
      anon_sym_DQUOTE,
    STATE(5197), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5195), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106368] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5196), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106413] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8303), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5197), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106472] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8305), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5198), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106531] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8307), 1,
      anon_sym_DQUOTE,
    STATE(5194), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5199), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106590] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6945), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5200), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6947), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106635] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8309), 1,
      anon_sym_DQUOTE,
    STATE(5215), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5201), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106694] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6949), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5202), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6951), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106739] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6802), 1,
      anon_sym_COLON,
    ACTIONS(8311), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5203), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6804), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
  [106786] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6802), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5204), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6804), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106831] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8315), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5205), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8313), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [106876] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8319), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5206), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8317), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [106921] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6820), 1,
      anon_sym_COLON,
    ACTIONS(8321), 1,
      anon_sym_as,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5207), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6822), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106968] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8325), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5208), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8323), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [107013] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8327), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5209), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5334), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [107058] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8329), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5210), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5354), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [107103] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8331), 1,
      anon_sym_DQUOTE,
    STATE(5113), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5211), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107162] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3012), 1,
      anon_sym_and,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3010), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5212), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107223] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3032), 1,
      anon_sym_and,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3030), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5213), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107284] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8333), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5214), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107343] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8335), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5215), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107402] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6816), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5216), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6818), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [107447] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8337), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5217), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5366), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [107492] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6892), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5218), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6894), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [107537] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3092), 1,
      anon_sym_and,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3090), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5219), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107598] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3616), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5220), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3618), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [107643] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8339), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5221), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107702] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8341), 1,
      anon_sym_DQUOTE,
    STATE(5144), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5222), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107761] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8343), 1,
      anon_sym_DQUOTE,
    STATE(5214), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5223), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107820] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8345), 1,
      anon_sym_DQUOTE,
    STATE(5233), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5224), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [107879] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7114), 3,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(5225), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7112), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      sym_identifier,
  [107924] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8347), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5226), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [107969] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8349), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5227), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108028] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8351), 1,
      anon_sym_DQUOTE,
    STATE(5227), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5228), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108087] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5229), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7502), 13,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [108130] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8353), 1,
      anon_sym_DQUOTE,
    STATE(5231), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5230), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108189] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8355), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5231), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108248] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8051), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5232), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8049), 12,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [108293] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8194), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(8196), 1,
      anon_sym_LBRACE2,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8206), 1,
      sym__inside_string_marker,
    ACTIONS(8357), 1,
      anon_sym_DQUOTE,
    STATE(5187), 1,
      aux_sym_format_string_repeat1,
    STATE(5645), 1,
      sym__simple_string_char,
    ACTIONS(8190), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5623), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(8192), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5233), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108352] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8359), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5234), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [108397] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3701), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5235), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3703), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [108442] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5236), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5482), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [108484] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8361), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5237), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [108528] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8372), 1,
      anon_sym_DQUOTE,
    ACTIONS(8374), 1,
      anon_sym_DQUOTEB,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8363), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8369), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8366), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5238), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__string_literal_repeat1,
  [108582] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8382), 1,
      anon_sym_DQUOTE,
    ACTIONS(8384), 1,
      anon_sym_DQUOTEB,
    STATE(5248), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5239), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108638] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5240), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5492), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [108680] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8386), 1,
      anon_sym_DQUOTE,
    ACTIONS(8388), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5241), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108736] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8390), 1,
      anon_sym_DQUOTE,
    ACTIONS(8392), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5242), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108792] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5243), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5466), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [108834] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8394), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5244), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5354), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [108878] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8396), 1,
      anon_sym_DQUOTE,
    ACTIONS(8398), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5245), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108934] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8400), 1,
      anon_sym_DQUOTE,
    ACTIONS(8402), 1,
      anon_sym_DQUOTEB,
    STATE(5241), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5246), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108990] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8404), 1,
      anon_sym_DQUOTE,
    ACTIONS(8406), 1,
      anon_sym_DQUOTEB,
    STATE(5245), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5247), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109046] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8408), 1,
      anon_sym_DQUOTE,
    ACTIONS(8410), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5248), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109102] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8412), 1,
      anon_sym_DQUOTE,
    ACTIONS(8414), 1,
      anon_sym_DQUOTEB,
    STATE(5268), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5249), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109158] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3257), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5250), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109206] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5251), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5486), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [109248] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8416), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5252), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5334), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [109292] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8418), 1,
      anon_sym_DQUOTE,
    ACTIONS(8420), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5253), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109348] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8422), 1,
      anon_sym_DQUOTE,
    ACTIONS(8424), 1,
      anon_sym_DQUOTEB,
    STATE(5259), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5254), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109404] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8426), 1,
      anon_sym_DOT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5255), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3287), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [109450] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8429), 1,
      anon_sym_DQUOTE,
    ACTIONS(8431), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5256), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109506] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8433), 1,
      anon_sym_DQUOTE,
    ACTIONS(8435), 1,
      anon_sym_DQUOTEB,
    STATE(5253), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5257), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109562] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8437), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5258), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5366), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [109606] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8439), 1,
      anon_sym_DQUOTE,
    ACTIONS(8441), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5259), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109662] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3202), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8443), 1,
      anon_sym_DOT,
    STATE(5255), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5260), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3204), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [109710] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3417), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8445), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5261), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 10,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_f,
      aux_sym_decimal_token1,
  [109756] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8447), 1,
      anon_sym_DQUOTE,
    ACTIONS(8449), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5262), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109812] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8451), 1,
      anon_sym_DQUOTE,
    ACTIONS(8453), 1,
      anon_sym_DQUOTEB,
    STATE(5242), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5263), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109868] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8455), 1,
      anon_sym_DQUOTE,
    ACTIONS(8457), 1,
      anon_sym_DQUOTEB,
    STATE(5267), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5264), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [109924] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8459), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5265), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [109968] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8461), 1,
      anon_sym_DQUOTE,
    ACTIONS(8463), 1,
      anon_sym_DQUOTEB,
    STATE(5262), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5266), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110024] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8465), 1,
      anon_sym_DQUOTE,
    ACTIONS(8467), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5267), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110080] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8469), 1,
      anon_sym_DQUOTE,
    ACTIONS(8471), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5268), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110136] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8473), 1,
      anon_sym_DQUOTE,
    ACTIONS(8475), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5269), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110192] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8477), 1,
      anon_sym_DQUOTE,
    ACTIONS(8479), 1,
      anon_sym_DQUOTEB,
    STATE(5284), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5270), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110248] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8481), 1,
      anon_sym_DQUOTE,
    ACTIONS(8483), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5271), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110304] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3387), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8485), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5272), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3389), 10,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_f,
      aux_sym_decimal_token1,
  [110350] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5273), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5462), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [110392] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8487), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5274), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [110436] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8489), 1,
      anon_sym_DQUOTE,
    ACTIONS(8491), 1,
      anon_sym_DQUOTEB,
    STATE(5321), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5275), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110492] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5276), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5502), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [110534] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5277), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5440), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [110576] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5278), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [110618] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8493), 1,
      anon_sym_DQUOTE,
    ACTIONS(8495), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5279), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110674] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5280), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5436), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [110716] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8497), 1,
      anon_sym_DQUOTE,
    ACTIONS(8499), 1,
      anon_sym_DQUOTEB,
    STATE(5269), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5281), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110772] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8501), 1,
      anon_sym_DQUOTE,
    ACTIONS(8503), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5282), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110828] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8505), 1,
      anon_sym_DQUOTE,
    ACTIONS(8507), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5283), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110884] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8509), 1,
      anon_sym_DQUOTE,
    ACTIONS(8511), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5284), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [110940] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5285), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5478), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [110982] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8513), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5286), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [111026] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8515), 1,
      anon_sym_DQUOTE,
    ACTIONS(8517), 1,
      anon_sym_DQUOTEB,
    STATE(5307), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5287), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111082] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8519), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5288), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [111126] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8521), 1,
      anon_sym_DQUOTE,
    ACTIONS(8523), 1,
      anon_sym_DQUOTEB,
    STATE(5283), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5289), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111182] = 19,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5188), 1,
      sym__dedent,
    ACTIONS(5190), 1,
      anon_sym_interface,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8525), 1,
      anon_sym_with,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    STATE(6746), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5290), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111246] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5291), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [111288] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8527), 1,
      anon_sym_DQUOTE,
    ACTIONS(8529), 1,
      anon_sym_DQUOTEB,
    STATE(5282), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5292), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111344] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8531), 1,
      anon_sym_DQUOTE,
    ACTIONS(8533), 1,
      anon_sym_DQUOTEB,
    STATE(5296), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5293), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111400] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8535), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5294), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [111444] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8537), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5295), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [111488] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8539), 1,
      anon_sym_DQUOTE,
    ACTIONS(8541), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5296), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111544] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3257), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8443), 1,
      anon_sym_DOT,
    STATE(5260), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5297), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [111592] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8543), 1,
      anon_sym_DQUOTE,
    ACTIONS(8545), 1,
      anon_sym_DQUOTEB,
    STATE(5271), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5298), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111648] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8547), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5299), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [111692] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8549), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5300), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [111736] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8551), 1,
      anon_sym_DQUOTE,
    ACTIONS(8553), 1,
      anon_sym_DQUOTEB,
    STATE(5302), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5301), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111792] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8555), 1,
      anon_sym_DQUOTE,
    ACTIONS(8557), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5302), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111848] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5303), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [111890] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 3,
      anon_sym_COLON,
      anon_sym_and,
      sym_identifier,
    STATE(5304), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111934] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8559), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5305), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [111978] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8561), 1,
      anon_sym_DQUOTE,
    ACTIONS(8563), 1,
      anon_sym_DQUOTEB,
    STATE(5256), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5306), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112034] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8565), 1,
      anon_sym_DQUOTE,
    ACTIONS(8567), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5307), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112090] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8569), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5308), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [112134] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5309), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3440), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [112176] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8571), 1,
      anon_sym_DQUOTE,
    ACTIONS(8573), 1,
      anon_sym_DQUOTEB,
    STATE(5279), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5310), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112232] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5311), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5506), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [112274] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8575), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5312), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5366), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [112318] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5313), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5398), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [112360] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5314), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5394), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [112402] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5315), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5452), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [112444] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8577), 1,
      anon_sym_DQUOTE,
    ACTIONS(8579), 1,
      anon_sym_DQUOTEB,
    STATE(5326), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5316), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112500] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5317), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5390), 12,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [112542] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8581), 1,
      anon_sym_DQUOTE,
    ACTIONS(8583), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5318), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112598] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8585), 1,
      anon_sym_DQUOTE,
    ACTIONS(8587), 1,
      anon_sym_DQUOTEB,
    STATE(5318), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5319), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112654] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8589), 1,
      anon_sym_DQUOTE,
    ACTIONS(8591), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5320), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112710] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8593), 1,
      anon_sym_DQUOTE,
    ACTIONS(8595), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5321), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112766] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8597), 1,
      anon_sym_DQUOTE,
    ACTIONS(8599), 1,
      anon_sym_DQUOTEB,
    STATE(5320), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5322), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [112822] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8601), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5323), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5354), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [112866] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8603), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5324), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [112910] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5325), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3440), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_with,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [112952] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8605), 1,
      anon_sym_DQUOTE,
    ACTIONS(8607), 1,
      anon_sym_DQUOTEB,
    STATE(5238), 1,
      aux_sym__string_literal_repeat1,
    STATE(5624), 1,
      sym__string_char,
    STATE(5710), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8380), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8378), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5326), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [113008] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8609), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5327), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5334), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113052] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8372), 1,
      anon_sym_DQUOTE,
    STATE(5852), 1,
      sym__simple_string_char,
    STATE(5877), 1,
      sym__string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8611), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8617), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8614), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5328), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__string_literal_repeat1,
  [113103] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5329), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5398), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113144] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7183), 1,
      anon_sym_new,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(8624), 1,
      anon_sym_static,
    ACTIONS(8626), 1,
      anon_sym_member,
    ACTIONS(8628), 1,
      anon_sym_abstract,
    ACTIONS(8630), 1,
      anon_sym_val,
    STATE(5354), 1,
      sym_additional_constr_defn,
    STATE(6615), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8622), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5330), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [113203] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5331), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5478), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113244] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5332), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113285] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5333), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113326] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5334), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5486), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113367] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3230), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8632), 1,
      anon_sym_or,
    STATE(5339), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5335), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3232), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [113414] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5336), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5436), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113455] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5337), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5440), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113496] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8634), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5338), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113539] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3274), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8636), 1,
      anon_sym_or,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5339), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3276), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [113584] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(8639), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5340), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6629), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [113629] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6640), 1,
      anon_sym_COLON,
    ACTIONS(8642), 1,
      anon_sym_and,
    STATE(5340), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5341), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6642), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [113676] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5342), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5482), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113717] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    ACTIONS(8646), 1,
      anon_sym_as,
    ACTIONS(8648), 1,
      anon_sym_COMMA,
    ACTIONS(8650), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8654), 1,
      anon_sym_AMP,
    ACTIONS(8658), 1,
      sym__dedent,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6171), 1,
      aux_sym__list_pattern_content_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8656), 2,
      sym__newline,
      anon_sym_SEMI,
    STATE(5343), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [113776] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6676), 1,
      anon_sym_COLON,
    ACTIONS(8642), 1,
      anon_sym_and,
    STATE(5341), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5344), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6678), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [113823] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5345), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5394), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113864] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5346), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5452), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [113905] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5347), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5390), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113946] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5348), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5462), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [113987] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5349), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5440), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114028] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5350), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5482), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114069] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7218), 1,
      anon_sym_new,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(8662), 1,
      anon_sym_static,
    ACTIONS(8664), 1,
      anon_sym_member,
    ACTIONS(8666), 1,
      anon_sym_abstract,
    ACTIONS(8668), 1,
      anon_sym_val,
    STATE(3075), 1,
      sym_additional_constr_defn,
    STATE(6612), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8660), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5351), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114128] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8670), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5352), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5334), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114171] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7161), 1,
      anon_sym_new,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(8674), 1,
      anon_sym_static,
    ACTIONS(8676), 1,
      anon_sym_member,
    ACTIONS(8678), 1,
      anon_sym_abstract,
    ACTIONS(8680), 1,
      anon_sym_val,
    STATE(3206), 1,
      sym_additional_constr_defn,
    STATE(6623), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8672), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5353), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114230] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5354), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5452), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114271] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5355), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5466), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114312] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5356), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5436), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114353] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6640), 1,
      anon_sym_COLON,
    ACTIONS(8682), 1,
      anon_sym_and,
    STATE(5367), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5357), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6642), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [114400] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5358), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5390), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114441] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5359), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5506), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114482] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8684), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5360), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114525] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5361), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5502), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114566] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5362), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5492), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114607] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5363), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5394), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114648] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5364), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114689] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5365), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114730] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8686), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5366), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5354), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114773] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(8688), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5367), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6629), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [114818] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3451), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5368), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3453), 10,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_f,
      aux_sym_decimal_token1,
  [114861] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5369), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5340), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [114904] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8693), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3032), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(3030), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(5370), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__compound_type_repeat1,
  [114949] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5371), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [114990] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    ACTIONS(8646), 1,
      anon_sym_as,
    ACTIONS(8648), 1,
      anon_sym_COMMA,
    ACTIONS(8650), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8654), 1,
      anon_sym_AMP,
    ACTIONS(8696), 1,
      sym__dedent,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6194), 1,
      aux_sym__list_pattern_content_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8656), 2,
      sym__newline,
      anon_sym_SEMI,
    STATE(5372), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115049] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3387), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5373), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3389), 10,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_f,
      aux_sym_decimal_token1,
  [115092] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6676), 1,
      anon_sym_COLON,
    ACTIONS(8698), 1,
      anon_sym_and,
    STATE(5384), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5374), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6678), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [115139] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6676), 1,
      anon_sym_COLON,
    ACTIONS(8700), 1,
      anon_sym_and,
    STATE(5399), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5375), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6678), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [115186] = 18,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(8704), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    STATE(6265), 1,
      aux_sym_types_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5376), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115247] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8708), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5377), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115290] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8710), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5378), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115335] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(8712), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5379), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6629), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [115380] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8715), 1,
      anon_sym_with,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5380), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5366), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115423] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5381), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5462), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115464] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7155), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7236), 1,
      anon_sym_new,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(8719), 1,
      anon_sym_static,
    ACTIONS(8721), 1,
      anon_sym_member,
    ACTIONS(8723), 1,
      anon_sym_abstract,
    ACTIONS(8725), 1,
      anon_sym_val,
    STATE(5315), 1,
      sym_additional_constr_defn,
    STATE(6628), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8717), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5382), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115523] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3242), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8632), 1,
      anon_sym_or,
    STATE(5335), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5383), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [115570] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6640), 1,
      anon_sym_COLON,
    ACTIONS(8698), 1,
      anon_sym_and,
    STATE(5379), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5384), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6642), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [115617] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5385), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5502), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [115658] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8727), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5386), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5372), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115701] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5387), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5506), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115742] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5388), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5492), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [115783] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5389), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3287), 10,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LT2,
  [115826] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5390), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5486), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115867] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    STATE(5370), 1,
      aux_sym__compound_type_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3212), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5391), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3214), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115914] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5392), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5466), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [115955] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5393), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [115996] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5394), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5398), 11,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
      anon_sym_POUNDendif,
  [116037] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6676), 1,
      anon_sym_COLON,
    ACTIONS(8682), 1,
      anon_sym_and,
    STATE(5357), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5395), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6678), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [116084] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8729), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5396), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5348), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [116127] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(8731), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5397), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(6629), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [116172] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7330), 1,
      aux_sym_decimal_token1,
    ACTIONS(7492), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5398), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [116219] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6640), 1,
      anon_sym_COLON,
    ACTIONS(8700), 1,
      anon_sym_and,
    STATE(5397), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5399), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6642), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [116266] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8740), 1,
      anon_sym_DQUOTE,
    STATE(5402), 1,
      aux_sym__string_literal_repeat1,
    STATE(5852), 1,
      sym__simple_string_char,
    STATE(5877), 1,
      sym__string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8734), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8738), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8736), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5400), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116319] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5401), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [116360] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8742), 1,
      anon_sym_DQUOTE,
    STATE(5328), 1,
      aux_sym__string_literal_repeat1,
    STATE(5852), 1,
      sym__simple_string_char,
    STATE(5877), 1,
      sym__string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8734), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(8738), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8736), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(5402), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116413] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6111), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5403), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116469] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3340), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5404), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3342), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116511] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    ACTIONS(8748), 1,
      anon_sym_SEMI,
    STATE(5479), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5405), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [116557] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5406), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6759), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [116601] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8754), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8756), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5407), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116653] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8758), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8760), 1,
      anon_sym_DQUOTEB,
    STATE(5407), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5408), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116705] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6773), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5409), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [116749] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6582), 1,
      anon_sym_new,
    ACTIONS(8136), 1,
      anon_sym_member,
    ACTIONS(8138), 1,
      anon_sym_abstract,
    ACTIONS(8140), 1,
      anon_sym_val,
    ACTIONS(8765), 1,
      anon_sym_static,
    STATE(4912), 1,
      sym_additional_constr_defn,
    STATE(8067), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8132), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5410), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116805] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6258), 1,
      sym_record_field,
    STATE(7975), 1,
      sym_record_fields,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5411), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116863] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5412), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5398), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [116903] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5413), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5394), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [116943] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5414), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5390), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [116983] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(5421), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5415), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [117027] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5416), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [117071] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3300), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5417), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3302), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117113] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8771), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8773), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5418), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117165] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(5409), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5419), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [117209] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6802), 1,
      anon_sym_COLON,
    ACTIONS(8775), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5420), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6804), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [117253] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(8777), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6773), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5421), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [117297] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6258), 1,
      sym_record_field,
    STATE(7923), 1,
      sym_record_fields,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5422), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117355] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8780), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8782), 1,
      anon_sym_DQUOTEB,
    STATE(5418), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5423), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117407] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5996), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5424), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117463] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6019), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5425), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117519] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8784), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8786), 1,
      anon_sym_DQUOTEB,
    STATE(5442), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5426), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117571] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5427), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [117615] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6410), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5428), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117671] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8788), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8790), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5429), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117723] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6258), 1,
      sym_record_field,
    STATE(7857), 1,
      sym_record_fields,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5430), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117781] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5431), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5482), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [117821] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8792), 1,
      sym_identifier,
    ACTIONS(8794), 1,
      anon_sym_LPAREN,
    ACTIONS(8796), 1,
      anon_sym__,
    ACTIONS(8798), 1,
      anon_sym_POUND,
    STATE(3797), 1,
      sym__static_type_identifier,
    STATE(3921), 1,
      sym_long_identifier,
    STATE(3935), 1,
      sym_type_argument,
    STATE(3936), 1,
      sym_atomic_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8800), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5432), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117877] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3274), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5433), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3276), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_or,
  [117919] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(8648), 1,
      anon_sym_COMMA,
    STATE(5544), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5434), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6755), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [117965] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5435), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5452), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [118005] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6090), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5436), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118061] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8802), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8804), 1,
      anon_sym_DQUOTEB,
    STATE(5429), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5437), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118113] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    ACTIONS(8646), 1,
      anon_sym_as,
    ACTIONS(8648), 1,
      anon_sym_COMMA,
    ACTIONS(8650), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8654), 1,
      anon_sym_AMP,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 3,
      sym__newline,
      sym__dedent,
      anon_sym_SEMI,
    STATE(5438), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118167] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5977), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5439), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118223] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3361), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5440), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3363), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_or,
  [118265] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3308), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5441), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3310), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118307] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8806), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8808), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5442), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118359] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5991), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5443), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118415] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8814), 1,
      anon_sym_COMMA,
    ACTIONS(8816), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8818), 1,
      anon_sym_PIPE,
    ACTIONS(8820), 1,
      anon_sym_AMP,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_LT2,
    STATE(5444), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118469] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(8822), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
    STATE(5445), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [118513] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5446), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [118557] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5447), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [118601] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5448), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [118645] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5449), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [118689] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5450), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5073), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [118729] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    STATE(5419), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5451), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [118773] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    ACTIONS(8825), 1,
      anon_sym_SEMI,
    STATE(5468), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5452), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [118819] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5453), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5486), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [118859] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5454), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5077), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [118899] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7236), 1,
      anon_sym_new,
    ACTIONS(8719), 1,
      anon_sym_static,
    ACTIONS(8721), 1,
      anon_sym_member,
    ACTIONS(8723), 1,
      anon_sym_abstract,
    ACTIONS(8725), 1,
      anon_sym_val,
    STATE(5315), 1,
      sym_additional_constr_defn,
    STATE(7955), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8717), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5455), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118955] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6054), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5456), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119011] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8827), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8829), 1,
      anon_sym_DQUOTEB,
    STATE(5472), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5457), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119063] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5458), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5478), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119103] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5459), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5129), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119143] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5460), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5462), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119183] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8831), 1,
      sym_identifier,
    ACTIONS(8833), 1,
      anon_sym_LPAREN,
    ACTIONS(8835), 1,
      anon_sym__,
    ACTIONS(8837), 1,
      anon_sym_POUND,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5203), 1,
      sym_long_identifier,
    STATE(5204), 1,
      sym_type_argument,
    STATE(5207), 1,
      sym_atomic_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5461), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119239] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8839), 1,
      anon_sym_EQ,
    ACTIONS(8841), 1,
      anon_sym_COMMA,
    ACTIONS(8843), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8845), 1,
      anon_sym_PIPE,
    ACTIONS(8847), 1,
      anon_sym_AMP,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6642), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5462), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119297] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7218), 1,
      anon_sym_new,
    ACTIONS(8662), 1,
      anon_sym_static,
    ACTIONS(8664), 1,
      anon_sym_member,
    ACTIONS(8666), 1,
      anon_sym_abstract,
    ACTIONS(8668), 1,
      anon_sym_val,
    STATE(3075), 1,
      sym_additional_constr_defn,
    STATE(8266), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8660), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5463), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119353] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3322), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5464), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3324), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119395] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5465), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5440), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119435] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5466), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5436), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119475] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6828), 1,
      anon_sym_LBRACK_LT,
    STATE(5474), 1,
      aux_sym_attributes_repeat1,
    STATE(5815), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7282), 3,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(7280), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5467), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119523] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(8849), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6773), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
    STATE(5468), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [119567] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5469), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6759), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [119611] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5470), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5502), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119651] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5471), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5492), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119691] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8852), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8854), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5472), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119743] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5473), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5466), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119783] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8856), 1,
      anon_sym_LBRACK_LT,
    STATE(5815), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7005), 3,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(7000), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5474), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
  [119829] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7183), 1,
      anon_sym_new,
    ACTIONS(8624), 1,
      anon_sym_static,
    ACTIONS(8626), 1,
      anon_sym_member,
    ACTIONS(8628), 1,
      anon_sym_abstract,
    ACTIONS(8630), 1,
      anon_sym_val,
    STATE(5354), 1,
      sym_additional_constr_defn,
    STATE(8100), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8622), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5475), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119885] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5476), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5506), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_override,
      anon_sym_val,
  [119925] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8859), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5477), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119981] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8861), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5478), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120037] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    ACTIONS(8748), 1,
      anon_sym_SEMI,
    STATE(5421), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5479), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [120083] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8863), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8865), 1,
      anon_sym_DQUOTEB,
    STATE(5485), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5480), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120135] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    ACTIONS(8867), 1,
      anon_sym_EQ,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5481), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3259), 7,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [120181] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8814), 1,
      anon_sym_COMMA,
    ACTIONS(8816), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8818), 1,
      anon_sym_PIPE,
    ACTIONS(8820), 1,
      anon_sym_AMP,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_LT2,
    STATE(5482), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120235] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(8814), 1,
      anon_sym_COMMA,
    STATE(5445), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5483), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6755), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [120281] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3296), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5484), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3298), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120323] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8869), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8871), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5485), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120375] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6042), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5486), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120431] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6016), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5487), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120487] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5488), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [120531] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8881), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8883), 1,
      anon_sym_DQUOTEB,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8878), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8875), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5489), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_verbatim_string_repeat1,
  [120581] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6258), 1,
      sym_record_field,
    STATE(8094), 1,
      sym_record_fields,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5490), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120639] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8831), 1,
      sym_identifier,
    ACTIONS(8833), 1,
      anon_sym_LPAREN,
    ACTIONS(8835), 1,
      anon_sym__,
    ACTIONS(8885), 1,
      anon_sym_POUND,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5203), 1,
      sym_long_identifier,
    STATE(5204), 1,
      sym_type_argument,
    STATE(5207), 1,
      sym_atomic_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5491), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120695] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3336), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5492), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3338), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120737] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8887), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8889), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5493), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120789] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8891), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8893), 1,
      anon_sym_DQUOTEB,
    STATE(5511), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5494), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120841] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6068), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5495), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120897] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8895), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8897), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5496), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120949] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6124), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5497), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121005] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6059), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5498), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121061] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8899), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8901), 1,
      anon_sym_DQUOTEB,
    STATE(5496), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5499), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121113] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8903), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8905), 1,
      anon_sym_DQUOTEB,
    STATE(5493), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5500), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121165] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8907), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3355), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5501), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3357), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [121209] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6096), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5502), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121265] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6110), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5503), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121321] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6092), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5504), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121377] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5505), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [121421] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6072), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5506), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121477] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6053), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5507), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121533] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6727), 1,
      anon_sym_new,
    ACTIONS(8180), 1,
      anon_sym_member,
    ACTIONS(8182), 1,
      anon_sym_abstract,
    ACTIONS(8184), 1,
      anon_sym_val,
    ACTIONS(8911), 1,
      anon_sym_static,
    STATE(5346), 1,
      sym_additional_constr_defn,
    STATE(7834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8176), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5508), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121589] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5509), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6759), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [121633] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(8915), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5510), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121687] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8921), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8923), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5511), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121739] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5512), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [121783] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5988), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5513), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121839] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3351), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5514), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3353), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121881] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6040), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5515), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121937] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8925), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8927), 1,
      anon_sym_DQUOTEB,
    STATE(5527), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5516), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121989] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    ACTIONS(8929), 1,
      anon_sym_SEMI,
    STATE(5522), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5517), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [122035] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8931), 1,
      sym_identifier,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8933), 2,
      sym__newline,
      sym__dedent,
    STATE(5518), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122091] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5998), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5519), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122147] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    ACTIONS(8646), 1,
      anon_sym_as,
    ACTIONS(8648), 1,
      anon_sym_COMMA,
    ACTIONS(8650), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8654), 1,
      anon_sym_AMP,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8935), 3,
      sym__newline,
      sym__dedent,
      anon_sym_SEMI,
    STATE(5520), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122201] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5521), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122245] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(8937), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6773), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5522), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [122289] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5523), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122333] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8940), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8942), 1,
      anon_sym_DQUOTEB,
    STATE(5537), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5524), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122385] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6778), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5525), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6780), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122427] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5526), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122471] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8944), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8946), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5527), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122523] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5528), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122567] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5529), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122611] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6293), 1,
      anon_sym_and,
    ACTIONS(6295), 1,
      anon_sym_GT,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5530), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122669] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5531), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122713] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6117), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5532), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122769] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6782), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5533), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6784), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122811] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5975), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5534), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122867] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8931), 1,
      sym_identifier,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8948), 2,
      sym__newline,
      sym__dedent,
    STATE(5535), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122923] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5536), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [122967] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8950), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8952), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5537), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123019] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8954), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8956), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5538), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123071] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6798), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5539), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6800), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [123113] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6009), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5540), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123169] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6640), 1,
      anon_sym_COLON,
    ACTIONS(8958), 1,
      anon_sym_and,
    STATE(5547), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5541), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6642), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [123215] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8960), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8962), 1,
      anon_sym_DQUOTEB,
    STATE(5617), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5542), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123267] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(8915), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5543), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123321] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(5544), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [123365] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
    STATE(5545), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [123409] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8644), 1,
      anon_sym_COLON,
    ACTIONS(8646), 1,
      anon_sym_as,
    ACTIONS(8648), 1,
      anon_sym_COMMA,
    ACTIONS(8650), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8654), 1,
      anon_sym_AMP,
    STATE(5434), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 3,
      sym__newline,
      sym__dedent,
      anon_sym_SEMI,
    STATE(5546), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123463] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(8970), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6629), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(5547), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
  [123507] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6036), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5548), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123563] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5549), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [123607] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    ACTIONS(8825), 1,
      anon_sym_SEMI,
    STATE(5452), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5550), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [123653] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    STATE(5545), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5551), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6755), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [123699] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8931), 1,
      sym_identifier,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8973), 2,
      sym__newline,
      sym__dedent,
    STATE(5552), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123755] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5551), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5553), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [123799] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6790), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5554), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6792), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [123841] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(5522), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5555), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [123885] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6065), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5556), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123941] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    ACTIONS(8929), 1,
      anon_sym_SEMI,
    STATE(5517), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5557), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [123987] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6093), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5558), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124043] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8975), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8977), 1,
      anon_sym_DQUOTEB,
    STATE(5562), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5559), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124095] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(8979), 1,
      anon_sym_COMMA,
    ACTIONS(8981), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8983), 1,
      anon_sym_PIPE,
    ACTIONS(8985), 1,
      anon_sym_AMP,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 3,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5560), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124149] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(8987), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 7,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5561), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [124193] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8990), 1,
      anon_sym_DQUOTE2,
    ACTIONS(8992), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5562), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124245] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7161), 1,
      anon_sym_new,
    ACTIONS(8674), 1,
      anon_sym_static,
    ACTIONS(8676), 1,
      anon_sym_member,
    ACTIONS(8678), 1,
      anon_sym_abstract,
    ACTIONS(8680), 1,
      anon_sym_val,
    STATE(3206), 1,
      sym_additional_constr_defn,
    STATE(8000), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8672), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5563), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124301] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5564), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [124345] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5565), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [124389] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5566), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [124433] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5567), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [124477] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6119), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5568), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124533] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6362), 1,
      anon_sym_new,
    ACTIONS(8161), 1,
      anon_sym_member,
    ACTIONS(8163), 1,
      anon_sym_abstract,
    ACTIONS(8165), 1,
      anon_sym_val,
    ACTIONS(8994), 1,
      anon_sym_static,
    STATE(4818), 1,
      sym_additional_constr_defn,
    STATE(8034), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8157), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5569), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124589] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6285), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5570), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6287), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [124631] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6121), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5571), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124687] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8841), 1,
      anon_sym_COMMA,
    ACTIONS(8843), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8845), 1,
      anon_sym_PIPE,
    ACTIONS(8847), 1,
      anon_sym_AMP,
    ACTIONS(8996), 1,
      anon_sym_EQ,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6608), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5572), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124745] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6116), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5573), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124801] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6087), 1,
      sym_attributes,
    STATE(6106), 1,
      sym_type_argument_defn,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5574), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124857] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    STATE(5555), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5575), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [124901] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    STATE(5415), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5576), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [124945] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8998), 1,
      sym_identifier,
    ACTIONS(9000), 1,
      anon_sym_LPAREN,
    ACTIONS(9002), 1,
      anon_sym__,
    ACTIONS(9004), 1,
      anon_sym_POUND,
    STATE(4023), 1,
      sym__static_type_identifier,
    STATE(4044), 1,
      sym_long_identifier,
    STATE(4096), 1,
      sym_atomic_type,
    STATE(4112), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9006), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5577), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125001] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6007), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5578), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125057] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9008), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9010), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5579), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125109] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9012), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9014), 1,
      anon_sym_DQUOTEB,
    STATE(5591), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5580), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125161] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5581), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [125205] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5483), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5582), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [125249] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(8979), 1,
      anon_sym_COMMA,
    ACTIONS(8981), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8983), 1,
      anon_sym_PIPE,
    ACTIONS(8985), 1,
      anon_sym_AMP,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 3,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5583), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125303] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9016), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9018), 1,
      anon_sym_DQUOTEB,
    STATE(5538), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5584), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125355] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9020), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9022), 1,
      anon_sym_DQUOTEB,
    STATE(5589), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5585), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125407] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    ACTIONS(9024), 1,
      sym__dedent,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6705), 1,
      sym_record_field,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5586), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125465] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(8979), 1,
      anon_sym_COMMA,
    STATE(5561), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5587), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6755), 7,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [125511] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5587), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5588), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6759), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_when,
  [125555] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9026), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9028), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5589), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125607] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9030), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9032), 1,
      anon_sym_DQUOTEB,
    STATE(5579), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5590), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125659] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9034), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9036), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5591), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125711] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7286), 1,
      anon_sym_new,
    ACTIONS(9040), 1,
      anon_sym_static,
    ACTIONS(9042), 1,
      anon_sym_member,
    ACTIONS(9044), 1,
      anon_sym_abstract,
    ACTIONS(9046), 1,
      anon_sym_val,
    STATE(5435), 1,
      sym_additional_constr_defn,
    STATE(7901), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9038), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(5592), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125767] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6043), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5593), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125823] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6085), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5594), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125879] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9048), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9050), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5595), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125931] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6676), 1,
      anon_sym_COLON,
    ACTIONS(8958), 1,
      anon_sym_and,
    STATE(5541), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5596), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6678), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [125977] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7464), 1,
      anon_sym_DASH_GT,
    ACTIONS(7466), 1,
      anon_sym_STAR,
    ACTIONS(7468), 1,
      anon_sym_LT2,
    ACTIONS(7470), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8931), 1,
      sym_identifier,
    STATE(4775), 1,
      aux_sym__compound_type_repeat1,
    STATE(4859), 1,
      sym_long_identifier,
    STATE(4862), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9052), 2,
      sym__newline,
      sym__dedent,
    STATE(5597), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126033] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6050), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5598), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126089] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8831), 1,
      sym_identifier,
    ACTIONS(8833), 1,
      anon_sym_LPAREN,
    ACTIONS(8835), 1,
      anon_sym__,
    ACTIONS(9004), 1,
      anon_sym_POUND,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5203), 1,
      sym_long_identifier,
    STATE(5204), 1,
      sym_type_argument,
    STATE(5207), 1,
      sym_atomic_type,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5599), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126145] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9054), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9056), 1,
      anon_sym_DQUOTEB,
    STATE(5613), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5600), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126197] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9058), 1,
      sym_identifier,
    ACTIONS(9060), 1,
      anon_sym_LPAREN,
    ACTIONS(9062), 1,
      anon_sym__,
    ACTIONS(9064), 1,
      anon_sym_POUND,
    STATE(5383), 1,
      sym__static_type_identifier,
    STATE(5420), 1,
      sym_long_identifier,
    STATE(5652), 1,
      sym_atomic_type,
    STATE(5656), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9066), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5601), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126253] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5602), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6629), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [126295] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9068), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9070), 1,
      anon_sym_DQUOTEB,
    STATE(5595), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5603), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126347] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6293), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5604), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6295), 9,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [126389] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9072), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9074), 1,
      anon_sym_DQUOTEB,
    STATE(5608), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5605), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126441] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6285), 1,
      anon_sym_and,
    ACTIONS(6287), 1,
      anon_sym_GT,
    ACTIONS(7360), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5606), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126499] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8841), 1,
      anon_sym_COMMA,
    ACTIONS(8843), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8845), 1,
      anon_sym_PIPE,
    ACTIONS(8847), 1,
      anon_sym_AMP,
    ACTIONS(9076), 1,
      anon_sym_EQ,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6585), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5607), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126557] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9078), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9080), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5608), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126609] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9082), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9084), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5609), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126661] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9086), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9088), 1,
      anon_sym_DQUOTEB,
    STATE(5609), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5610), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126713] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    STATE(5612), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5611), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [126757] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(5468), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5612), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LT2,
  [126801] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9090), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9092), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5613), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126853] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9094), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9096), 1,
      anon_sym_DQUOTEB,
    STATE(5619), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5614), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126905] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9098), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9100), 1,
      anon_sym_DQUOTEB,
    STATE(5620), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5615), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126957] = 17,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    ACTIONS(9102), 1,
      sym__dedent,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6705), 1,
      sym_record_field,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5616), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127015] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9104), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9106), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5617), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127067] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6015), 1,
      sym_type_argument_defn,
    STATE(6087), 1,
      sym_attributes,
    STATE(6416), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5618), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127123] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9108), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9110), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5619), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127175] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9112), 1,
      anon_sym_DQUOTE2,
    ACTIONS(9114), 1,
      anon_sym_DQUOTEB,
    STATE(5489), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5905), 1,
      sym__verbatim_string_char,
    STATE(5930), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8752), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8750), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5620), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127227] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9116), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5621), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127282] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3602), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5622), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [127323] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9118), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    ACTIONS(9120), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
    STATE(5623), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127364] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9124), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    ACTIONS(9122), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    STATE(5624), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127405] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9126), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5625), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127460] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9128), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5626), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127515] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9130), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5627), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127570] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9132), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5628), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127625] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9134), 1,
      anon_sym_COMMA,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5629), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127680] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5630), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [127723] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5631), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [127766] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9136), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5632), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127821] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5633), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6773), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [127862] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9138), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5634), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127917] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5635), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [127960] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5636), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [128003] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9148), 1,
      anon_sym_DASH_GT,
    ACTIONS(9150), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5637), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128058] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    STATE(5708), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5638), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6763), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [128101] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5639), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128156] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(9154), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 6,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
    STATE(5640), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [128199] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6816), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5641), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6818), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [128240] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8841), 1,
      anon_sym_COMMA,
    ACTIONS(8843), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8845), 1,
      anon_sym_PIPE,
    ACTIONS(8847), 1,
      anon_sym_AMP,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 2,
      anon_sym_EQ,
      anon_sym_LT2,
    STATE(5642), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128293] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    ACTIONS(9157), 1,
      anon_sym_SEMI,
    STATE(5648), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6767), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5643), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128338] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9159), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5644), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128393] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9161), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    ACTIONS(9163), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
    STATE(5645), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128434] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9165), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    ACTIONS(9167), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
    STATE(5646), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128475] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON,
    ACTIONS(9157), 1,
      anon_sym_SEMI,
    STATE(5643), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6763), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5647), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128520] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON,
    ACTIONS(9169), 1,
      anon_sym_SEMI,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6773), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5648), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [128563] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9172), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5649), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128618] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9174), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    ACTIONS(9176), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
    STATE(5650), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128659] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5651), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [128702] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6820), 1,
      anon_sym_COLON,
    ACTIONS(9178), 1,
      anon_sym_as,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5652), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6822), 7,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [128745] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9180), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5653), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128800] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9182), 1,
      anon_sym_COMMA,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5654), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128855] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      anon_sym_not,
    ACTIONS(9190), 1,
      anon_sym_enum,
    ACTIONS(9192), 1,
      anon_sym_delegate,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9186), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
    STATE(5655), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128902] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6802), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5656), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6804), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [128943] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9194), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5657), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128998] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6870), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5658), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6872), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [129039] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5659), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6876), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [129080] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6880), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5660), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6882), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [129121] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6884), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5661), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6886), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [129162] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5662), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [129205] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9196), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5663), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129260] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9198), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5664), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129315] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9200), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5665), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129370] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9206), 1,
      anon_sym_DQUOTE2,
    STATE(5740), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5940), 1,
      sym__verbatim_string_char,
    STATE(5941), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9204), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(9202), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5666), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129419] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9208), 1,
      anon_sym_DASH_GT,
    ACTIONS(9210), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5667), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129474] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9212), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5668), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129529] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9214), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5669), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129584] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9216), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5670), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129639] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5671), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129694] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6892), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5672), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6894), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [129735] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3242), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5673), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3244), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [129776] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9220), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5674), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129831] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9222), 1,
      anon_sym_DASH_GT,
    ACTIONS(9224), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5675), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129886] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9226), 1,
      sym_identifier,
    ACTIONS(9228), 1,
      sym__dedent,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5676), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129941] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9230), 1,
      anon_sym_DASH_GT,
    ACTIONS(9232), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5677), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [129996] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9234), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5678), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130051] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9236), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5679), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130106] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9238), 1,
      anon_sym_LPAREN,
    ACTIONS(9242), 1,
      anon_sym_not,
    ACTIONS(9244), 1,
      anon_sym_enum,
    ACTIONS(9246), 1,
      anon_sym_delegate,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9240), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
    STATE(5680), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130153] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9248), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5681), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130208] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3701), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5682), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3703), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [130249] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3794), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5683), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3796), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [130290] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5684), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [130333] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9252), 1,
      anon_sym_DASH_GT,
    ACTIONS(9254), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5685), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130388] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9256), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5686), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130443] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3642), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5687), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3644), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [130484] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9226), 1,
      sym_identifier,
    ACTIONS(9258), 1,
      sym__dedent,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5688), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130539] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5689), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130594] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9262), 1,
      anon_sym_DASH_GT,
    ACTIONS(9264), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5690), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130649] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9266), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5691), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130704] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5692), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3587), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [130745] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3581), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5693), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3583), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [130786] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5694), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [130829] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3774), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5695), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3776), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [130870] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9268), 1,
      anon_sym_DASH_GT,
    ACTIONS(9270), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5696), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130925] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5697), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130980] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6945), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5698), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6947), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [131021] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9274), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5699), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131076] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6949), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5700), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6951), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [131117] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9276), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5701), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131172] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9278), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5702), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131227] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9280), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5703), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131282] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9282), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5704), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131337] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9284), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5705), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131392] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9286), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5706), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131447] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8881), 1,
      anon_sym_DQUOTE2,
    STATE(5940), 1,
      sym__verbatim_string_char,
    STATE(5941), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9291), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(9288), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5707), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_verbatim_string_repeat1,
  [131494] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(5648), 1,
      aux_sym_record_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5708), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6767), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [131537] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5709), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131592] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9163), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    ACTIONS(9161), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    STATE(5710), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131633] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9296), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5711), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131688] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9226), 1,
      sym_identifier,
    ACTIONS(9298), 1,
      sym__dedent,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5712), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131743] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9167), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    ACTIONS(9165), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    STATE(5713), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131784] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9300), 1,
      sym_identifier,
    STATE(5036), 1,
      sym_long_identifier,
    STATE(5911), 1,
      sym_access_modifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8298), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5714), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131837] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6899), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5715), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6901), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [131878] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9302), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5716), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131933] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6903), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5717), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6905), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [131974] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(9304), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(5718), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [132017] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9307), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5719), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132072] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5720), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [132115] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5721), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [132158] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5722), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [132201] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5723), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [132244] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5724), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [132287] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    STATE(5728), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6755), 6,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5725), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132332] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9311), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5726), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132387] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3598), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5727), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3600), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [132428] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(9313), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 6,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5728), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [132471] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9316), 1,
      anon_sym_DASH_GT,
    ACTIONS(9318), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5729), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132526] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9226), 1,
      sym_identifier,
    ACTIONS(9320), 1,
      sym__dedent,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5730), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132581] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3616), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5731), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3618), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [132622] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7437), 1,
      anon_sym_DASH_GT,
    ACTIONS(7439), 1,
      anon_sym_STAR,
    ACTIONS(7441), 1,
      anon_sym_LT2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9226), 1,
      sym_identifier,
    ACTIONS(9322), 1,
      sym__dedent,
    STATE(4770), 1,
      aux_sym__compound_type_repeat1,
    STATE(4889), 1,
      sym_type_arguments,
    STATE(4895), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5732), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132677] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9324), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5733), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132732] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9326), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5734), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132787] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3656), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5735), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3658), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [132828] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3577), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5736), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3579), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [132869] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3840), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5737), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3842), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [132910] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9328), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5738), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132965] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9330), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5739), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133020] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9332), 1,
      anon_sym_DQUOTE2,
    STATE(5707), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5940), 1,
      sym__verbatim_string_char,
    STATE(5941), 1,
      sym__simple_string_char,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9204), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(9202), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5740), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133069] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9334), 1,
      anon_sym_COMMA,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5741), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133124] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5742), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2770), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [133165] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9336), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5743), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133220] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3836), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5744), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3838), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [133261] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5745), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [133304] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9338), 1,
      anon_sym_DASH_GT,
    ACTIONS(9340), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5746), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133359] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4030), 1,
      aux_sym_attributes_repeat1,
    STATE(4118), 1,
      sym_attribute_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7280), 3,
      anon_sym_mutable,
      anon_sym__,
      sym_identifier,
    ACTIONS(7282), 3,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5747), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133406] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      sym_identifier,
    ACTIONS(8769), 1,
      anon_sym_mutable,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6213), 1,
      sym_attributes,
    STATE(6705), 1,
      sym_record_field,
    STATE(8095), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5748), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133461] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9342), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5749), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133516] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9344), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5750), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133571] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3660), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5751), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3662), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [133612] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9346), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5752), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133667] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3693), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5753), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3695), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [133708] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9348), 1,
      anon_sym_COMMA,
    ACTIONS(9350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9352), 1,
      anon_sym_PIPE,
    ACTIONS(9354), 1,
      anon_sym_AMP,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 2,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(5754), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133761] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(9348), 1,
      anon_sym_COMMA,
    STATE(5718), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6755), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(5755), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133806] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9356), 1,
      anon_sym_LPAREN,
    ACTIONS(9360), 1,
      anon_sym_not,
    ACTIONS(9362), 1,
      anon_sym_enum,
    ACTIONS(9364), 1,
      anon_sym_delegate,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9358), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
    STATE(5756), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133853] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3825), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5757), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3827), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [133894] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5758), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133949] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3722), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5759), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3724), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [133990] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5760), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134045] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9370), 1,
      anon_sym_DASH_GT,
    ACTIONS(9372), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5761), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134100] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9374), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5762), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134155] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3802), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5763), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3804), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [134196] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9376), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5764), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134251] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9378), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5765), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134306] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9380), 1,
      anon_sym_GT,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5766), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134361] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(8841), 1,
      anon_sym_COMMA,
    STATE(5640), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6755), 6,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
    STATE(5767), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134406] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3798), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5768), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3800), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [134447] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8810), 1,
      anon_sym_COLON,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8841), 1,
      anon_sym_COMMA,
    ACTIONS(8843), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8845), 1,
      anon_sym_PIPE,
    ACTIONS(8847), 1,
      anon_sym_AMP,
    STATE(5767), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 2,
      anon_sym_EQ,
      anon_sym_LT2,
    STATE(5769), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134500] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9382), 1,
      anon_sym_DASH_GT,
    ACTIONS(9384), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5770), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134555] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9386), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5771), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134610] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 2,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5772), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134663] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    STATE(5776), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6755), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5773), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134708] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3790), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5774), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3792), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [134749] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3786), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5775), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3788), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [134790] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(9388), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5776), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [134833] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9391), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5777), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134888] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3782), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5778), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3784), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [134929] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9393), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5779), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134984] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 2,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5780), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135037] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5781), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [135080] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5782), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [135123] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9395), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5783), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135178] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6941), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5784), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6943), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [135219] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3726), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5785), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [135260] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5786), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [135303] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9397), 1,
      anon_sym_LPAREN,
    ACTIONS(9401), 1,
      anon_sym_not,
    ACTIONS(9403), 1,
      anon_sym_enum,
    ACTIONS(9405), 1,
      anon_sym_delegate,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9399), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
    STATE(5787), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135350] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5788), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [135393] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3778), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5789), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3780), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [135434] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9407), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5790), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135489] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6888), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5791), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6890), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [135530] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9409), 1,
      anon_sym_EQ,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5792), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135585] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4762), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(5793), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135638] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9417), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5794), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135693] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9348), 1,
      anon_sym_COMMA,
    ACTIONS(9350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9352), 1,
      anon_sym_PIPE,
    ACTIONS(9354), 1,
      anon_sym_AMP,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 2,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(5795), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135746] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5755), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5796), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6759), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_in,
  [135789] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9419), 1,
      anon_sym_COMMA,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5797), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135844] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3770), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5798), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3772), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [135885] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9421), 1,
      anon_sym_DASH_GT,
    ACTIONS(9423), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5799), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135940] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9425), 1,
      anon_sym_DASH_GT,
    ACTIONS(9427), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5800), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135995] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5801), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6704), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [136038] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9429), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5802), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136093] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6788), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(5803), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136146] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5804), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6715), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [136189] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5805), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6711), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [136232] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3734), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5806), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3736), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [136273] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5807), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6723), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [136316] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3766), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5808), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3768), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [136357] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5809), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6698), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [136400] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3746), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5810), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3748), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [136441] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_PIPE,
    ACTIONS(9146), 1,
      anon_sym_AMP,
    ACTIONS(9431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9433), 1,
      anon_sym_when,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5811), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136496] = 16,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    ACTIONS(9435), 1,
      anon_sym_RPAREN,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5812), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136551] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      anon_sym_COLON,
    STATE(5773), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5813), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6719), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [136594] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3738), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5814), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3740), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SEMI,
  [136635] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7123), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(7125), 4,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5815), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136675] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9437), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(9439), 4,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5816), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136715] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    STATE(5844), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6755), 5,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5817), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136759] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9443), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5818), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136811] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9445), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5819), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136861] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9447), 1,
      anon_sym_RPAREN,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5820), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136913] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4762), 1,
      anon_sym_in,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5821), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136965] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7112), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(7114), 4,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5822), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137005] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9455), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5823), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137057] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9457), 1,
      anon_sym_RPAREN,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5824), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137109] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9459), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5825), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137161] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9461), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5826), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137213] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9463), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5827), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137265] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9465), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5828), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137317] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9467), 1,
      anon_sym_RPAREN,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5829), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137369] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9469), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5830), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137421] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9471), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5831), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137473] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9473), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5832), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137525] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6723), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5833), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137567] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9475), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5834), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137619] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9477), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5835), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137671] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9479), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5836), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137723] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9481), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5837), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137775] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6698), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5838), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137817] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6711), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5839), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137859] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4988), 1,
      anon_sym_COLON,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3259), 5,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
    STATE(5840), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137903] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6719), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5841), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137945] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9483), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5842), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137997] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9485), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5843), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138049] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6702), 1,
      anon_sym_COLON,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 5,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5844), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [138091] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9490), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5845), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138143] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5364), 1,
      anon_sym_RPAREN,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5846), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138195] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9492), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5847), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138247] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9494), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5848), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138299] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6715), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5849), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138341] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5857), 1,
      aux_sym_type_definition_repeat1,
    STATE(7414), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5536), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5850), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138391] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5850), 1,
      aux_sym_type_definition_repeat1,
    STATE(7414), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5526), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5851), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138441] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9161), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(9163), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5852), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138481] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9498), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5853), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138533] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9500), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5854), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138585] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9502), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5855), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138637] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9504), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5856), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138687] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5544), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9506), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(7414), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5540), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5857), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_definition_repeat1,
  [138735] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5881), 1,
      aux_sym_type_definition_repeat1,
    STATE(7414), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5532), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5858), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138785] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9509), 1,
      anon_sym_RPAREN,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5859), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138837] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9511), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5860), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138889] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9513), 1,
      anon_sym_RPAREN,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5861), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138941] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9515), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5862), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138993] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9517), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5863), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139045] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9519), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5864), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139097] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9521), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5865), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139149] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7116), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(7118), 4,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5866), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139189] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9523), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5867), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139241] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5360), 1,
      anon_sym_RPAREN,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5868), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139293] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6704), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5869), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139335] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9165), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(9167), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5870), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139375] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9525), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5871), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139427] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9527), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5872), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139479] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(8232), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8702), 1,
      sym_identifier,
    STATE(5391), 1,
      aux_sym__compound_type_repeat1,
    STATE(5484), 1,
      sym_long_identifier,
    STATE(5492), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5873), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139529] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9529), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5874), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139581] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6788), 1,
      anon_sym_in,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5875), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139633] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9531), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5876), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139685] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9122), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(9124), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5877), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139725] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9533), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5878), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139777] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9535), 1,
      anon_sym_RPAREN,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5879), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139829] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(8873), 1,
      anon_sym_COLON,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    ACTIONS(9411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9413), 1,
      anon_sym_PIPE,
    ACTIONS(9415), 1,
      anon_sym_AMP,
    ACTIONS(9537), 1,
      anon_sym_EQ,
    STATE(5725), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5880), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139881] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5857), 1,
      aux_sym_type_definition_repeat1,
    STATE(7414), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5526), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5881), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139931] = 15,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_as,
    ACTIONS(9250), 1,
      anon_sym_COLON,
    ACTIONS(9441), 1,
      anon_sym_COMMA,
    ACTIONS(9449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9451), 1,
      anon_sym_PIPE,
    ACTIONS(9453), 1,
      anon_sym_AMP,
    ACTIONS(9539), 1,
      anon_sym_in,
    STATE(5817), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5882), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139983] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(33), 1,
      anon_sym_let,
    ACTIONS(35), 1,
      anon_sym_let_BANG,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9541), 1,
      anon_sym_module,
    ACTIONS(9543), 1,
      anon_sym_type,
    ACTIONS(9545), 1,
      anon_sym_do,
    STATE(3393), 1,
      sym_do,
    STATE(3398), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5883), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140032] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9549), 1,
      anon_sym_default,
    STATE(5057), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7135), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5884), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140079] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1192), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2265), 1,
      sym_op_identifier,
    ACTIONS(9551), 1,
      sym_identifier,
    STATE(2367), 1,
      sym_long_identifier,
    STATE(2504), 1,
      sym_long_identifier_or_op,
    STATE(2582), 1,
      sym__identifier_or_op,
    STATE(2717), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5885), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140128] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9300), 1,
      sym_identifier,
    STATE(5036), 1,
      sym_long_identifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8298), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5886), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140175] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(808), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2375), 1,
      sym_op_identifier,
    ACTIONS(9553), 1,
      sym_identifier,
    STATE(2063), 1,
      sym_long_identifier,
    STATE(2173), 1,
      sym_active_pattern,
    STATE(2213), 1,
      sym__identifier_or_op,
    STATE(2246), 1,
      sym_long_identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5887), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140224] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9555), 1,
      anon_sym_default,
    STATE(4055), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6940), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5888), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140271] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9555), 1,
      anon_sym_default,
    STATE(4050), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6940), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5889), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140318] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(674), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2283), 1,
      sym_op_identifier,
    ACTIONS(9557), 1,
      sym_identifier,
    STATE(1846), 1,
      sym_long_identifier,
    STATE(1849), 1,
      sym_active_pattern,
    STATE(1906), 1,
      sym__identifier_or_op,
    STATE(2008), 1,
      sym_long_identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5890), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140367] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5532), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9559), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5896), 1,
      aux_sym_type_definition_repeat1,
    STATE(7208), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5891), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140416] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1610), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2385), 1,
      sym_op_identifier,
    ACTIONS(9561), 1,
      sym_identifier,
    STATE(2390), 1,
      sym_active_pattern,
    STATE(2408), 1,
      sym_long_identifier,
    STATE(2722), 1,
      sym_long_identifier_or_op,
    STATE(2726), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5892), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140465] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(9563), 1,
      sym_identifier,
    ACTIONS(9565), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9567), 1,
      sym_op_identifier,
    STATE(3542), 1,
      sym__identifier_or_op,
    STATE(4742), 1,
      sym_active_pattern,
    STATE(5974), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5893), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140514] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9569), 1,
      anon_sym_default,
    STATE(4057), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6959), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5894), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140561] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9571), 1,
      anon_sym_default,
    STATE(5375), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7026), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5895), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140608] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5526), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9559), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5906), 1,
      aux_sym_type_definition_repeat1,
    STATE(7208), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5896), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140657] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1384), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2427), 1,
      sym_op_identifier,
    ACTIONS(9573), 1,
      sym_identifier,
    STATE(2374), 1,
      sym__identifier_or_op,
    STATE(2457), 1,
      sym_active_pattern,
    STATE(2461), 1,
      sym_long_identifier,
    STATE(2771), 1,
      sym_long_identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5897), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140706] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9575), 1,
      anon_sym_module,
    ACTIONS(9577), 1,
      anon_sym_type,
    ACTIONS(9579), 1,
      anon_sym_do,
    ACTIONS(9581), 1,
      anon_sym_let,
    ACTIONS(9583), 1,
      anon_sym_let_BANG,
    STATE(6716), 1,
      sym_do,
    STATE(6717), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5898), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140755] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5526), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9559), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5904), 1,
      aux_sym_type_definition_repeat1,
    STATE(7208), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5899), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140804] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9585), 1,
      anon_sym_default,
    STATE(3785), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6991), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5900), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140851] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(33), 1,
      anon_sym_let,
    ACTIONS(35), 1,
      anon_sym_let_BANG,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9543), 1,
      anon_sym_type,
    ACTIONS(9545), 1,
      anon_sym_do,
    ACTIONS(9587), 1,
      anon_sym_module,
    STATE(3393), 1,
      sym_do,
    STATE(3398), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5901), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140900] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9589), 1,
      anon_sym_default,
    STATE(5374), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7105), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5902), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140947] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9591), 1,
      anon_sym_default,
    STATE(5057), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7053), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5903), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140994] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(25), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5536), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9559), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(5906), 1,
      aux_sym_type_definition_repeat1,
    STATE(7208), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5904), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141043] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9595), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(9593), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5905), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141082] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5540), 1,
      anon_sym_POUNDendif,
    ACTIONS(5544), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9597), 1,
      anon_sym_and,
    STATE(4296), 1,
      aux_sym_attributes_repeat1,
    STATE(4720), 1,
      sym_attribute_set,
    STATE(7208), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5906), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_definition_repeat1,
  [141129] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(207), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2305), 1,
      sym_op_identifier,
    ACTIONS(9600), 1,
      sym_identifier,
    STATE(1058), 1,
      sym_active_pattern,
    STATE(1064), 1,
      sym_long_identifier,
    STATE(1089), 1,
      sym_long_identifier_or_op,
    STATE(1120), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5907), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141178] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9602), 1,
      anon_sym_default,
    STATE(5057), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6654), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5908), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141225] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2043), 1,
      anon_sym_let,
    ACTIONS(2045), 1,
      anon_sym_let_BANG,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9604), 1,
      anon_sym_module,
    ACTIONS(9606), 1,
      anon_sym_type,
    ACTIONS(9608), 1,
      anon_sym_do,
    STATE(3427), 1,
      sym_function_or_value_defn,
    STATE(3435), 1,
      sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5909), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141274] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9589), 1,
      anon_sym_default,
    STATE(5057), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7105), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5910), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141321] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5784), 1,
      anon_sym__,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9610), 1,
      sym_identifier,
    STATE(5035), 1,
      sym_long_identifier,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8277), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5911), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141368] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9612), 1,
      anon_sym_default,
    STATE(5395), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7039), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5912), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141415] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9569), 1,
      anon_sym_default,
    STATE(4050), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6959), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5913), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141462] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9549), 1,
      anon_sym_default,
    STATE(5596), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7135), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5914), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141509] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9612), 1,
      anon_sym_default,
    STATE(5057), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7039), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5915), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141556] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(379), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2053), 1,
      sym_op_identifier,
    ACTIONS(9614), 1,
      sym_identifier,
    STATE(1466), 1,
      sym_active_pattern,
    STATE(1553), 1,
      sym__identifier_or_op,
    STATE(1624), 1,
      sym_long_identifier_or_op,
    STATE(1625), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5916), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141605] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9616), 1,
      anon_sym_interface,
    STATE(6114), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5550), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5917), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
  [141646] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5111), 1,
      sym_union_type_case,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(6377), 1,
      sym_enum_type_case,
    STATE(8139), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5918), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141695] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9571), 1,
      anon_sym_default,
    STATE(5602), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7026), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5919), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141742] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9165), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(9167), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5920), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141781] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(483), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1840), 1,
      sym_op_identifier,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(2160), 1,
      sym_long_identifier,
    STATE(2161), 1,
      sym__identifier_or_op,
    STATE(2277), 1,
      sym_active_pattern,
    STATE(2307), 1,
      sym_long_identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5921), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141830] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9602), 1,
      anon_sym_default,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6305), 1,
      sym_constraint,
    STATE(6654), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5922), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141877] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(579), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2325), 1,
      sym_op_identifier,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1755), 1,
      sym__identifier_or_op,
    STATE(1762), 1,
      sym_active_pattern,
    STATE(1804), 1,
      sym_long_identifier,
    STATE(1982), 1,
      sym_long_identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5923), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141926] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1100), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2395), 1,
      sym_op_identifier,
    ACTIONS(9625), 1,
      sym_identifier,
    STATE(2623), 1,
      sym_long_identifier_or_op,
    STATE(2640), 1,
      sym_active_pattern,
    STATE(2767), 1,
      sym__identifier_or_op,
    STATE(2769), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5924), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141975] = 14,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9627), 1,
      anon_sym_module,
    ACTIONS(9629), 1,
      anon_sym_type,
    ACTIONS(9631), 1,
      anon_sym_do,
    ACTIONS(9633), 1,
      anon_sym_let,
    ACTIONS(9635), 1,
      anon_sym_let_BANG,
    STATE(7943), 1,
      sym_function_or_value_defn,
    STATE(7944), 1,
      sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5925), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142024] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(964), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2335), 1,
      sym_op_identifier,
    ACTIONS(9637), 1,
      sym_identifier,
    STATE(2077), 1,
      sym_long_identifier_or_op,
    STATE(2163), 1,
      sym_long_identifier,
    STATE(2209), 1,
      sym_active_pattern,
    STATE(2301), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5926), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142073] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1282), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2411), 1,
      sym_op_identifier,
    ACTIONS(9639), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_long_identifier,
    STATE(2363), 1,
      sym_active_pattern,
    STATE(2484), 1,
      sym__identifier_or_op,
    STATE(2578), 1,
      sym_long_identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5927), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142122] = 14,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(99), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(101), 1,
      sym_op_identifier,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9641), 1,
      sym_identifier,
    STATE(1282), 1,
      sym_long_identifier_or_op,
    STATE(1300), 1,
      sym_active_pattern,
    STATE(1371), 1,
      sym_long_identifier,
    STATE(1380), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5928), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142171] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    ACTIONS(9585), 1,
      anon_sym_default,
    STATE(3806), 1,
      sym_constraint,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(6991), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5929), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142218] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9645), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(9643), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5930), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142257] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7244), 1,
      anon_sym_interface,
    STATE(5917), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6114), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5562), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5931), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142300] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9649), 1,
      anon_sym_inline,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5393), 1,
      sym_method_or_prop_defn,
    STATE(6306), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5932), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142346] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9651), 1,
      anon_sym_inline,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3197), 1,
      sym_method_or_prop_defn,
    STATE(6381), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5933), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142392] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9655), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(9653), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5934), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142430] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6578), 1,
      anon_sym_let,
    ACTIONS(6580), 1,
      anon_sym_let_BANG,
    ACTIONS(9657), 1,
      anon_sym_do,
    ACTIONS(9659), 1,
      anon_sym_member,
    ACTIONS(9661), 1,
      anon_sym_val,
    STATE(4956), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5935), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142476] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9663), 1,
      anon_sym_inline,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4818), 1,
      sym_method_or_prop_defn,
    STATE(6397), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5936), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142522] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9665), 1,
      anon_sym_inline,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4948), 1,
      sym_method_or_prop_defn,
    STATE(6460), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5937), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142568] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9165), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(9167), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5938), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142606] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(8174), 1,
      anon_sym_do,
    ACTIONS(8180), 1,
      anon_sym_member,
    ACTIONS(8184), 1,
      anon_sym_val,
    STATE(6659), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5939), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142652] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9595), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(9593), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5940), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142690] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9645), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(9643), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5941), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142728] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9667), 1,
      anon_sym_inline,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3173), 1,
      sym_method_or_prop_defn,
    STATE(6315), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5942), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142774] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7191), 1,
      anon_sym_interface,
    STATE(5951), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6150), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5562), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(5943), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142816] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9669), 1,
      anon_sym_inline,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5364), 1,
      sym_method_or_prop_defn,
    STATE(6473), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5944), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142862] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9671), 1,
      anon_sym_inline,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5315), 1,
      sym_method_or_prop_defn,
    STATE(6540), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5945), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142908] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9673), 1,
      anon_sym_inline,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5291), 1,
      sym_method_or_prop_defn,
    STATE(6526), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5946), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142954] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9675), 1,
      anon_sym_inline,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5317), 1,
      sym_method_or_prop_defn,
    STATE(6545), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5947), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143000] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9677), 1,
      anon_sym_inline,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4912), 1,
      sym_method_or_prop_defn,
    STATE(6518), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5948), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143046] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9679), 1,
      anon_sym_inline,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3075), 1,
      sym_method_or_prop_defn,
    STATE(6453), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5949), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143092] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9681), 1,
      anon_sym_inline,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5435), 1,
      sym_method_or_prop_defn,
    STATE(6349), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5950), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143138] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9683), 1,
      anon_sym_interface,
    STATE(6150), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5550), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(5951), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
  [143178] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9686), 1,
      anon_sym_inline,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3037), 1,
      sym_method_or_prop_defn,
    STATE(6471), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5952), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143224] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9688), 1,
      anon_sym_inline,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5454), 1,
      sym_method_or_prop_defn,
    STATE(6287), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5953), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143270] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(8155), 1,
      anon_sym_do,
    ACTIONS(8161), 1,
      anon_sym_member,
    ACTIONS(8165), 1,
      anon_sym_val,
    STATE(4897), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5954), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143316] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_inline,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5347), 1,
      sym_method_or_prop_defn,
    STATE(6458), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5955), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143362] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9692), 1,
      anon_sym_inline,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4797), 1,
      sym_method_or_prop_defn,
    STATE(6276), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5956), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143408] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9694), 1,
      anon_sym_inline,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3201), 1,
      sym_method_or_prop_defn,
    STATE(6411), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5957), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143454] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6578), 1,
      anon_sym_let,
    ACTIONS(6580), 1,
      anon_sym_let_BANG,
    ACTIONS(8130), 1,
      anon_sym_do,
    ACTIONS(8136), 1,
      anon_sym_member,
    ACTIONS(8140), 1,
      anon_sym_val,
    STATE(4975), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5958), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143500] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9696), 1,
      anon_sym_inline,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4957), 1,
      sym_method_or_prop_defn,
    STATE(6489), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5959), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143546] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8095), 1,
      anon_sym_inline,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5346), 1,
      sym_method_or_prop_defn,
    STATE(6286), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5960), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143592] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9698), 1,
      anon_sym_inline,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4803), 1,
      sym_method_or_prop_defn,
    STATE(6239), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5961), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143638] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9700), 1,
      anon_sym_inline,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5354), 1,
      sym_method_or_prop_defn,
    STATE(6421), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5962), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143684] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6358), 1,
      anon_sym_let,
    ACTIONS(6360), 1,
      anon_sym_let_BANG,
    ACTIONS(9702), 1,
      anon_sym_do,
    ACTIONS(9704), 1,
      anon_sym_member,
    ACTIONS(9706), 1,
      anon_sym_val,
    STATE(4882), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5963), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143730] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9708), 1,
      anon_sym_inline,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5358), 1,
      sym_method_or_prop_defn,
    STATE(6257), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5964), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143776] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9710), 1,
      anon_sym_inline,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3206), 1,
      sym_method_or_prop_defn,
    STATE(6457), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5965), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143822] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5957), 1,
      anon_sym_let,
    ACTIONS(5959), 1,
      anon_sym_let_BANG,
    ACTIONS(9712), 1,
      anon_sym_do,
    ACTIONS(9714), 1,
      anon_sym_member,
    ACTIONS(9716), 1,
      anon_sym_val,
    STATE(6680), 1,
      sym_function_or_value_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5966), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143868] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9720), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(9718), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5967), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143906] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4517), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9722), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_attribute_set,
    STATE(5188), 1,
      sym_union_type_case,
    STATE(5747), 1,
      aux_sym_attributes_repeat1,
    STATE(8139), 1,
      sym_attributes,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5968), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143952] = 13,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    ACTIONS(9724), 1,
      anon_sym_inline,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5414), 1,
      sym_method_or_prop_defn,
    STATE(6240), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5969), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143998] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9728), 1,
      anon_sym_GT,
    ACTIONS(9730), 1,
      anon_sym_when,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7853), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5970), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144041] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9732), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7868), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5971), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144084] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9734), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7764), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5972), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144127] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5454), 1,
      sym_method_or_prop_defn,
    STATE(6287), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5973), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144170] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9565), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3543), 1,
      sym__identifier_or_op,
    STATE(4742), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9567), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5974), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144211] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9736), 1,
      anon_sym_GT,
    STATE(5984), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7788), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5975), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144254] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9738), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8360), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5976), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144297] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9740), 1,
      anon_sym_GT,
    STATE(5976), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8368), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5977), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144340] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4912), 1,
      sym_method_or_prop_defn,
    STATE(6518), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5978), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144383] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4797), 1,
      sym_method_or_prop_defn,
    STATE(6276), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5979), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144426] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5291), 1,
      sym_method_or_prop_defn,
    STATE(6526), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5980), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144469] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9742), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_member,
    STATE(4912), 1,
      sym_member_signature,
    STATE(7019), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5981), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144512] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9746), 1,
      aux_sym_float_token1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3389), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(5982), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144549] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7325), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5983), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144590] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9748), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7782), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5984), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144633] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9750), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3419), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(5985), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144670] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4597), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3898), 1,
      sym__identifier_or_op,
    STATE(3905), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4599), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5986), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144711] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9752), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7412), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5987), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144754] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9754), 1,
      anon_sym_GT,
    STATE(6030), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7190), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5988), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144797] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9756), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8348), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5989), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144840] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9758), 1,
      sym_identifier,
    ACTIONS(9760), 1,
      anon_sym_member,
    STATE(3037), 1,
      sym_member_signature,
    STATE(6640), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5990), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144883] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9762), 1,
      anon_sym_GT,
    STATE(5989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8373), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5991), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144926] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4669), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3735), 1,
      sym__identifier_or_op,
    STATE(3736), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4671), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5992), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144967] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(579), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1756), 1,
      sym__identifier_or_op,
    STATE(1762), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2325), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5993), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145008] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9764), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7800), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5994), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145051] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5278), 1,
      sym_method_or_prop_defn,
    STATE(6520), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5995), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145094] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9766), 1,
      anon_sym_GT,
    STATE(6021), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7407), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5996), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145137] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9770), 1,
      anon_sym_member,
    STATE(4797), 1,
      sym_member_signature,
    STATE(7132), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5997), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145180] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9772), 1,
      anon_sym_GT,
    STATE(6100), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7813), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(5998), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145223] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6735), 1,
      anon_sym_interface,
    STATE(6023), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6553), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5562), 2,
      sym__newline,
      sym__dedent,
    STATE(5999), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145264] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9774), 1,
      sym_identifier,
    ACTIONS(9776), 1,
      anon_sym_member,
    STATE(5317), 1,
      sym_member_signature,
    STATE(6984), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6000), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145307] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9758), 1,
      sym_identifier,
    ACTIONS(9778), 1,
      anon_sym_member,
    STATE(3075), 1,
      sym_member_signature,
    STATE(6605), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6001), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145350] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4957), 1,
      sym_method_or_prop_defn,
    STATE(6489), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6002), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145393] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5393), 1,
      sym_method_or_prop_defn,
    STATE(6306), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6003), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145436] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5317), 1,
      sym_method_or_prop_defn,
    STATE(6545), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6004), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145479] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9742), 1,
      sym_identifier,
    ACTIONS(9780), 1,
      anon_sym_member,
    STATE(4957), 1,
      sym_member_signature,
    STATE(6999), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6005), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145522] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9782), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8144), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6006), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145565] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9784), 1,
      anon_sym_GT,
    STATE(5987), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7450), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6007), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145608] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7431), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6008), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145649] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9786), 1,
      anon_sym_GT,
    STATE(6010), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7761), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6009), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145692] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9788), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7760), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6010), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145735] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9790), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8306), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6011), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145778] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3075), 1,
      sym_method_or_prop_defn,
    STATE(6453), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6012), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145821] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(964), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2115), 1,
      sym__identifier_or_op,
    STATE(2209), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2335), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6013), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145862] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9768), 1,
      sym_identifier,
    ACTIONS(9792), 1,
      anon_sym_member,
    STATE(4818), 1,
      sym_member_signature,
    STATE(7146), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6014), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145905] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9794), 1,
      anon_sym_GT,
    STATE(5994), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7756), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6015), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145948] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9796), 1,
      anon_sym_GT,
    STATE(6011), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8299), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6016), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145991] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5435), 1,
      sym_method_or_prop_defn,
    STATE(6349), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6017), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146034] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(483), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2252), 1,
      sym__identifier_or_op,
    STATE(2277), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(1840), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6018), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146075] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9798), 1,
      anon_sym_GT,
    STATE(6022), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8265), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6019), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146118] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9800), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7596), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6020), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146161] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9802), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7442), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6021), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146204] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9804), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8260), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6022), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146247] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9806), 1,
      anon_sym_interface,
    STATE(6553), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5550), 2,
      sym__newline,
      sym__dedent,
    STATE(6023), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
  [146286] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4948), 1,
      sym_method_or_prop_defn,
    STATE(6460), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6024), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146329] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9774), 1,
      sym_identifier,
    ACTIONS(9809), 1,
      anon_sym_member,
    STATE(5315), 1,
      sym_member_signature,
    STATE(6961), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6025), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146372] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5315), 1,
      sym_method_or_prop_defn,
    STATE(6540), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6026), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146415] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3206), 1,
      sym_method_or_prop_defn,
    STATE(6457), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6027), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146458] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5333), 1,
      sym_method_or_prop_defn,
    STATE(6548), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6028), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146501] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      sym_identifier,
    ACTIONS(9813), 1,
      anon_sym_member,
    STATE(3206), 1,
      sym_member_signature,
    STATE(7052), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6029), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146544] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9815), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7218), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6030), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146587] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4818), 1,
      sym_method_or_prop_defn,
    STATE(6397), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6031), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146630] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3173), 1,
      sym_method_or_prop_defn,
    STATE(6315), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6032), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146673] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5597), 5,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_interface,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6033), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146708] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7318), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6034), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146749] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4803), 1,
      sym_method_or_prop_defn,
    STATE(6239), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6035), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146792] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9817), 1,
      anon_sym_GT,
    STATE(6039), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7724), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6036), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146835] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9821), 1,
      anon_sym_member,
    STATE(5358), 1,
      sym_member_signature,
    STATE(6826), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6037), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146878] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9823), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8240), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6038), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146921] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9825), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7722), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6039), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146964] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9827), 1,
      anon_sym_GT,
    STATE(5970), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7856), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6040), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147007] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5676), 5,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_interface,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6041), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147042] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9829), 1,
      anon_sym_GT,
    STATE(6046), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8189), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6042), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147085] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9831), 1,
      anon_sym_GT,
    STATE(6084), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7294), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6043), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147128] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5358), 1,
      sym_method_or_prop_defn,
    STATE(6257), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6044), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147171] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4946), 1,
      sym_method_or_prop_defn,
    STATE(6451), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6045), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147214] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9833), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8179), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6046), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147257] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4814), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3933), 1,
      sym__identifier_or_op,
    STATE(3968), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4816), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6047), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147298] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3201), 1,
      sym_method_or_prop_defn,
    STATE(6411), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6048), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147341] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9819), 1,
      sym_identifier,
    ACTIONS(9835), 1,
      anon_sym_member,
    STATE(5346), 1,
      sym_member_signature,
    STATE(6815), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6049), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147384] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9837), 1,
      anon_sym_GT,
    STATE(6069), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7883), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6050), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147427] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5364), 1,
      sym_method_or_prop_defn,
    STATE(6473), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6051), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147470] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3037), 1,
      sym_method_or_prop_defn,
    STATE(6471), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6052), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147513] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9839), 1,
      anon_sym_GT,
    STATE(5971), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7870), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6053), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147556] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9841), 1,
      anon_sym_GT,
    STATE(5972), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7783), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6054), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147599] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9843), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7290), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6055), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147642] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(9845), 1,
      anon_sym_DQUOTE,
    ACTIONS(9847), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(9849), 1,
      aux_sym_compiler_directive_decl_token1,
    STATE(8340), 1,
      sym_verbatim_string,
    STATE(8341), 1,
      sym__string_literal,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6056), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147685] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5459), 1,
      sym_method_or_prop_defn,
    STATE(6323), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6057), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147728] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7185), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6058), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147769] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9851), 1,
      anon_sym_GT,
    STATE(6038), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8207), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6059), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147812] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      sym_identifier,
    ACTIONS(9853), 1,
      anon_sym_member,
    STATE(3201), 1,
      sym_member_signature,
    STATE(7075), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6060), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147855] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9565), 1,
      anon_sym_LPAREN_PIPE,
    STATE(4742), 1,
      sym_active_pattern,
    STATE(8004), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9567), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6061), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147896] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9855), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7777), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6062), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147939] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4807), 1,
      sym_method_or_prop_defn,
    STATE(6318), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6063), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147982] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7485), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6064), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148023] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9857), 1,
      anon_sym_GT,
    STATE(6066), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7692), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6065), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148066] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9859), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7684), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6066), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148109] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4555), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3820), 1,
      sym_active_pattern,
    STATE(3855), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4557), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6067), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148150] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9861), 1,
      anon_sym_GT,
    STATE(6071), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8133), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6068), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148193] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9863), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7931), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6069), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148236] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1384), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2457), 1,
      sym_active_pattern,
    STATE(2462), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2427), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6070), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148277] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9865), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8129), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6071), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148320] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9867), 1,
      anon_sym_GT,
    STATE(6062), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7889), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6072), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148363] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(99), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    STATE(1300), 1,
      sym_active_pattern,
    STATE(1307), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(101), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6073), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148404] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(808), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2173), 1,
      sym_active_pattern,
    STATE(2228), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2375), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6074), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148445] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9869), 1,
      sym_identifier,
    ACTIONS(9871), 1,
      anon_sym_member,
    STATE(5435), 1,
      sym_member_signature,
    STATE(6880), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6075), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148488] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9875), 1,
      anon_sym_member,
    STATE(5347), 1,
      sym_member_signature,
    STATE(7082), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6076), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148531] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1192), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2717), 1,
      sym_active_pattern,
    STATE(2744), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2265), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6077), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148572] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3130), 1,
      sym_method_or_prop_defn,
    STATE(6264), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6078), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148615] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(379), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1466), 1,
      sym_active_pattern,
    STATE(1503), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2053), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6079), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148656] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5347), 1,
      sym_method_or_prop_defn,
    STATE(6458), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6080), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148699] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9869), 1,
      sym_identifier,
    ACTIONS(9877), 1,
      anon_sym_member,
    STATE(5414), 1,
      sym_member_signature,
    STATE(6900), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6081), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148742] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5414), 1,
      sym_method_or_prop_defn,
    STATE(6240), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6082), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148785] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9879), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7961), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6083), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148828] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9881), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7267), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6084), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148871] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9883), 1,
      anon_sym_GT,
    STATE(6006), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8218), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6085), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148914] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(674), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1809), 1,
      sym__identifier_or_op,
    STATE(1849), 1,
      sym_active_pattern,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2283), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6086), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148955] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8744), 1,
      anon_sym__,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(6508), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6087), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148996] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3197), 1,
      sym_method_or_prop_defn,
    STATE(6381), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6088), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149039] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5332), 1,
      sym_method_or_prop_defn,
    STATE(6333), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6089), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149082] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9885), 1,
      anon_sym_GT,
    STATE(6055), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7278), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6090), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149125] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1610), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2390), 1,
      sym_active_pattern,
    STATE(2624), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2385), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6091), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149166] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9887), 1,
      anon_sym_GT,
    STATE(6083), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7963), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6092), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149209] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9889), 1,
      anon_sym_GT,
    STATE(6098), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7661), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6093), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149252] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(8099), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6094), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149293] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(207), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1058), 1,
      sym_active_pattern,
    STATE(1094), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2305), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6095), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149334] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9891), 1,
      anon_sym_GT,
    STATE(6097), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8089), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6096), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149377] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9893), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8083), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6097), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149420] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9895), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7660), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6098), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149463] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9565), 1,
      anon_sym_LPAREN_PIPE,
    STATE(4742), 1,
      sym_active_pattern,
    STATE(8001), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9567), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6099), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149504] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9897), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7808), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6100), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149547] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7527), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6101), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149588] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9899), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8082), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6102), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149631] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9901), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7576), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6103), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149674] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3195), 1,
      sym_method_or_prop_defn,
    STATE(6352), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6104), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149717] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3244), 1,
      anon_sym_COLON_GT,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8186), 1,
      anon_sym_or,
    STATE(5110), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3242), 2,
      anon_sym_COLON,
      sym_identifier,
    STATE(6105), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149758] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9903), 1,
      anon_sym_GT,
    STATE(6103), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7577), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6106), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149801] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1100), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2640), 1,
      sym_active_pattern,
    STATE(2668), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2395), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6107), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149842] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7252), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6108), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149883] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9905), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7587), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6109), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149926] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9907), 1,
      anon_sym_GT,
    STATE(6113), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8027), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6110), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149969] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9909), 1,
      anon_sym_GT,
    STATE(6109), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7589), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6111), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150012] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9873), 1,
      sym_identifier,
    ACTIONS(9911), 1,
      anon_sym_member,
    STATE(5354), 1,
      sym_member_signature,
    STATE(7094), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6112), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150055] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9913), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8010), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6113), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150098] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5591), 5,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_interface,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6114), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150133] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9915), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7598), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6115), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150176] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9917), 1,
      anon_sym_GT,
    STATE(6115), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7607), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6116), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150219] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9919), 1,
      anon_sym_GT,
    STATE(6125), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7639), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6117), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150262] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5354), 1,
      sym_method_or_prop_defn,
    STATE(6421), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6118), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150305] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9921), 1,
      anon_sym_GT,
    STATE(6102), 1,
      aux_sym_type_arguments_repeat1,
    STATE(8055), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6119), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150348] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9923), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7625), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6120), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150391] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9925), 1,
      anon_sym_GT,
    STATE(6120), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7504), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6121), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150434] = 11,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1282), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2363), 1,
      sym_active_pattern,
    STATE(2650), 1,
      sym__identifier_or_op,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2411), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(6122), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150475] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      anon_sym__,
    STATE(6105), 1,
      sym__static_type_identifier,
    STATE(7377), 1,
      sym_type_argument,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6123), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150516] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9927), 1,
      anon_sym_GT,
    STATE(6020), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7637), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6124), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150559] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9730), 1,
      anon_sym_when,
    ACTIONS(9929), 1,
      anon_sym_GT,
    STATE(6144), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7668), 1,
      sym_type_argument_constraints,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6125), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150602] = 12,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5346), 1,
      sym_method_or_prop_defn,
    STATE(6286), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6126), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150645] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(9931), 1,
      sym__dedent,
    STATE(6199), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6127), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150685] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5730), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6128), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150719] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5747), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6129), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150753] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(8308), 1,
      sym_long_identifier,
    STATE(8309), 1,
      sym_field_initializers,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6130), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150793] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5772), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6131), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150827] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9935), 1,
      sym_identifier,
    ACTIONS(9937), 1,
      anon_sym_mutable,
    STATE(7965), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6132), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150867] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5751), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6133), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150901] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5768), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6134), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150935] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9939), 1,
      sym_identifier,
    ACTIONS(9941), 1,
      anon_sym_mutable,
    STATE(8045), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6135), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150975] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9943), 1,
      sym_identifier,
    ACTIONS(9945), 1,
      anon_sym_mutable,
    STATE(7831), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6136), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151015] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3406), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9947), 1,
      anon_sym_PIPE,
    ACTIONS(9949), 1,
      sym__newline,
    STATE(6208), 1,
      aux_sym_rules_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6137), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151055] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9951), 1,
      anon_sym_new,
    ACTIONS(9953), 1,
      anon_sym_static,
    ACTIONS(9955), 1,
      anon_sym_member,
    STATE(7345), 1,
      sym_trait_member_constraint,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6138), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151095] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5562), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6139), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151129] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5684), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6140), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151163] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7548), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6141), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151203] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9957), 1,
      sym_identifier,
    ACTIONS(9959), 1,
      anon_sym_mutable,
    STATE(7973), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6142), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151243] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7405), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6143), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151283] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9961), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9964), 2,
      anon_sym_GT,
      anon_sym_when,
    STATE(6144), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_arguments_repeat1,
  [151319] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9966), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_mutable,
    STATE(7855), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6145), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151359] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9970), 1,
      sym_identifier,
    ACTIONS(9972), 1,
      anon_sym_mutable,
    STATE(7846), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6146), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151399] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      sym_identifier,
    STATE(3197), 1,
      sym_member_signature,
    STATE(7088), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6147), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151439] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9974), 1,
      sym_identifier,
    ACTIONS(9976), 1,
      anon_sym_mutable,
    STATE(8040), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6148), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151479] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9978), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5658), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6149), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [151515] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5591), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_interface,
      anon_sym_POUNDendif,
    STATE(6150), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151549] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7214), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6151), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151589] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9869), 1,
      sym_identifier,
    STATE(5414), 1,
      sym_member_signature,
    STATE(6900), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6152), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151629] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7401), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6153), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151669] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9981), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5658), 2,
      sym__newline,
      sym__dedent,
    STATE(6154), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [151705] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9984), 1,
      sym_identifier,
    STATE(410), 1,
      sym_long_identifier,
    STATE(6597), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6155), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151745] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9986), 1,
      anon_sym_and,
    STATE(6160), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5649), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6156), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151783] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7586), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6157), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151823] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9873), 1,
      sym_identifier,
    STATE(5347), 1,
      sym_member_signature,
    STATE(7082), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6158), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151863] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9988), 1,
      anon_sym_and,
    STATE(6154), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5672), 2,
      sym__newline,
      sym__dedent,
    STATE(6159), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151901] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9986), 1,
      anon_sym_and,
    STATE(6149), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5672), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6160), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151939] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7508), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6161), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151979] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5597), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_interface,
      anon_sym_POUNDendif,
    STATE(6162), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152013] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9988), 1,
      anon_sym_and,
    STATE(6159), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5649), 2,
      sym__newline,
      sym__dedent,
    STATE(6163), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152051] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9990), 1,
      sym_identifier,
    ACTIONS(9992), 1,
      anon_sym_mutable,
    STATE(8065), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6164), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152091] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9994), 1,
      sym_identifier,
    ACTIONS(9996), 1,
      anon_sym_mutable,
    STATE(7921), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6165), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152131] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5705), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6166), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152165] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9998), 1,
      sym_identifier,
    ACTIONS(10000), 1,
      anon_sym_mutable,
    STATE(8073), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6167), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152205] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10002), 1,
      sym_identifier,
    ACTIONS(10004), 1,
      anon_sym_mutable,
    STATE(8032), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6168), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152245] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3485), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10006), 1,
      anon_sym_PIPE,
    ACTIONS(10009), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6169), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_rules_repeat1,
  [152283] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7347), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6170), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152323] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10012), 1,
      sym__dedent,
    STATE(6174), 1,
      aux_sym__list_pattern_content_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8656), 2,
      sym__newline,
      anon_sym_SEMI,
    STATE(6171), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152361] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3465), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9947), 1,
      anon_sym_PIPE,
    ACTIONS(9949), 1,
      sym__newline,
    STATE(6169), 1,
      aux_sym_rules_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6172), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152401] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10014), 1,
      sym_identifier,
    ACTIONS(10016), 1,
      anon_sym_mutable,
    STATE(7913), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6173), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152441] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8935), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10018), 2,
      sym__newline,
      anon_sym_SEMI,
    STATE(6174), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__list_pattern_content_repeat1,
  [152477] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(8109), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6175), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152517] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(10021), 1,
      sym__dedent,
    STATE(6199), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6176), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152557] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10023), 1,
      sym_identifier,
    ACTIONS(10025), 1,
      anon_sym_mutable,
    STATE(8111), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6177), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152597] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10027), 1,
      sym_identifier,
    ACTIONS(10029), 1,
      anon_sym_mutable,
    STATE(7952), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6178), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152637] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5676), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_interface,
      anon_sym_POUNDendif,
    STATE(6179), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152671] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10031), 1,
      ts_builtin_sym_end,
    ACTIONS(10033), 1,
      anon_sym_namespace,
    STATE(6575), 1,
      sym_namespace,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6180), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_file_repeat1,
  [152709] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(10036), 1,
      sym__dedent,
    STATE(6176), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6181), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152749] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9953), 1,
      anon_sym_static,
    ACTIONS(9955), 1,
      anon_sym_member,
    ACTIONS(10038), 1,
      anon_sym_new,
    STATE(8035), 1,
      sym_trait_member_constraint,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6182), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152789] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      sym_identifier,
    STATE(3201), 1,
      sym_member_signature,
    STATE(7075), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6183), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152829] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7623), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6184), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152869] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5562), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7294), 1,
      anon_sym_interface,
    STATE(6199), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6185), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152909] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10040), 1,
      sym_identifier,
    ACTIONS(10042), 1,
      anon_sym_mutable,
    STATE(8185), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6186), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152949] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9758), 1,
      sym_identifier,
    STATE(3037), 1,
      sym_member_signature,
    STATE(6640), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6187), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152989] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10044), 1,
      sym_identifier,
    ACTIONS(10046), 1,
      anon_sym_mutable,
    STATE(7898), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6188), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153029] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5776), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6189), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153063] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10048), 1,
      sym_identifier,
    ACTIONS(10050), 1,
      anon_sym_mutable,
    STATE(8106), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6190), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153103] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2235), 1,
      ts_builtin_sym_end,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10052), 1,
      anon_sym_namespace,
    STATE(6180), 1,
      aux_sym_file_repeat1,
    STATE(6575), 1,
      sym_namespace,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6191), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153143] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9768), 1,
      sym_identifier,
    STATE(4803), 1,
      sym_member_signature,
    STATE(7128), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6192), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153183] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9819), 1,
      sym_identifier,
    STATE(5358), 1,
      sym_member_signature,
    STATE(6826), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6193), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153223] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8658), 1,
      sym__dedent,
    STATE(6174), 1,
      aux_sym__list_pattern_content_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8656), 2,
      sym__newline,
      anon_sym_SEMI,
    STATE(6194), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153261] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9873), 1,
      sym_identifier,
    STATE(5364), 1,
      sym_member_signature,
    STATE(7071), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6195), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153301] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9758), 1,
      sym_identifier,
    STATE(3173), 1,
      sym_member_signature,
    STATE(6669), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6196), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153341] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10054), 1,
      sym_identifier,
    ACTIONS(10056), 1,
      anon_sym_mutable,
    STATE(8126), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6197), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153381] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7659), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6198), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153421] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5550), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10058), 1,
      anon_sym_interface,
    STATE(6740), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6199), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
  [153459] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9953), 1,
      anon_sym_static,
    ACTIONS(9955), 1,
      anon_sym_member,
    ACTIONS(10061), 1,
      anon_sym_new,
    STATE(7554), 1,
      sym_trait_member_constraint,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6200), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153499] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5701), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6201), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153533] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7294), 1,
      anon_sym_interface,
    ACTIONS(10063), 1,
      sym__dedent,
    STATE(6127), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6740), 1,
      sym_interface_implementation,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6202), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153573] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5680), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6203), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153607] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10065), 1,
      sym_identifier,
    ACTIONS(10067), 1,
      anon_sym_mutable,
    STATE(8012), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6204), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153647] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9742), 1,
      sym_identifier,
    STATE(4948), 1,
      sym_member_signature,
    STATE(6981), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6205), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153687] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5743), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6206), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153721] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5755), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6207), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153755] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3444), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9947), 1,
      anon_sym_PIPE,
    ACTIONS(9949), 1,
      sym__newline,
    STATE(6169), 1,
      aux_sym_rules_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6208), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153795] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9819), 1,
      sym_identifier,
    STATE(5393), 1,
      sym_member_signature,
    STATE(6834), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6209), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153835] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10069), 1,
      sym_identifier,
    ACTIONS(10071), 1,
      anon_sym_mutable,
    STATE(8078), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6210), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153875] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10073), 1,
      sym_identifier,
    ACTIONS(10075), 1,
      anon_sym_mutable,
    STATE(8006), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6211), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153915] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5759), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6212), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153949] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10077), 1,
      sym_identifier,
    ACTIONS(10079), 1,
      anon_sym_mutable,
    STATE(8058), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6213), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153989] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5540), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6214), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154023] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9869), 1,
      sym_identifier,
    STATE(5454), 1,
      sym_member_signature,
    STATE(6910), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6215), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154063] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9953), 1,
      anon_sym_static,
    ACTIONS(9955), 1,
      anon_sym_member,
    ACTIONS(10081), 1,
      anon_sym_new,
    STATE(7740), 1,
      sym_trait_member_constraint,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6216), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154103] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10083), 1,
      sym_identifier,
    STATE(406), 1,
      sym_long_identifier,
    STATE(6577), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6217), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154143] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10085), 1,
      sym_identifier,
    ACTIONS(10087), 1,
      anon_sym_mutable,
    STATE(8098), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6218), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154183] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9742), 1,
      sym_identifier,
    STATE(4957), 1,
      sym_member_signature,
    STATE(6999), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6219), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154223] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9774), 1,
      sym_identifier,
    STATE(5317), 1,
      sym_member_signature,
    STATE(6984), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6220), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154263] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10089), 1,
      sym_identifier,
    ACTIONS(10091), 1,
      anon_sym_global,
    ACTIONS(10093), 1,
      anon_sym_rec,
    STATE(390), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6221), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154303] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10095), 1,
      sym_identifier,
    ACTIONS(10097), 1,
      anon_sym_mutable,
    STATE(8272), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6222), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154343] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9768), 1,
      sym_identifier,
    STATE(4797), 1,
      sym_member_signature,
    STATE(7132), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6223), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154383] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7287), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6224), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154423] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7161), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6225), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154463] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8037), 1,
      aux_sym_decimal_token1,
    ACTIONS(8146), 1,
      anon_sym_f,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2770), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6226), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154501] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9774), 1,
      sym_identifier,
    STATE(5291), 1,
      sym_member_signature,
    STATE(7000), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6227), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154541] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5739), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6228), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154575] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10099), 1,
      sym_identifier,
    ACTIONS(10101), 1,
      anon_sym_mutable,
    STATE(7998), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6229), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154615] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3389), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(6230), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154649] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6344), 1,
      sym_field_initializer,
    STATE(7455), 1,
      sym_field_initializers,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6231), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154689] = 11,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3444), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9947), 1,
      anon_sym_PIPE,
    ACTIONS(9949), 1,
      sym__newline,
    STATE(6172), 1,
      aux_sym_rules_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6232), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154729] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3453), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(6233), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154763] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10103), 1,
      anon_sym_PIPE,
    ACTIONS(10105), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6284), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6234), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154800] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4940), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6235), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154835] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5747), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6236), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154868] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3285), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7520), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6237), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154903] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10107), 1,
      sym__newline,
    ACTIONS(10110), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6238), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__class_type_body_repeat1,
  [154938] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4807), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6239), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154975] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5454), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6240), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155012] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10114), 1,
      anon_sym_with,
    ACTIONS(10116), 1,
      anon_sym_finally,
    ACTIONS(10118), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6241), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155049] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10120), 1,
      anon_sym_POUNDendif,
    ACTIONS(10122), 1,
      anon_sym_POUNDelse,
    STATE(7767), 1,
      sym_preproc_else,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6242), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155086] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10124), 1,
      anon_sym_with,
    ACTIONS(10126), 1,
      anon_sym_finally,
    ACTIONS(10128), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6243), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155123] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5684), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6244), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155156] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5768), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6245), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155189] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10130), 1,
      anon_sym_RBRACK,
    ACTIONS(10132), 1,
      sym__indent,
    STATE(7835), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6246), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155226] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10134), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7837), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6247), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155263] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10136), 1,
      anon_sym_PIPE,
    ACTIONS(10138), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6248), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155300] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5772), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6249), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155333] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5743), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6250), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155366] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5705), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6251), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155399] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10140), 1,
      sym_identifier,
    STATE(8080), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6252), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155436] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4109), 1,
      sym_field_pattern,
    STATE(7220), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6253), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155473] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10144), 1,
      sym_identifier,
    STATE(7924), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6254), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155510] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1595), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6255), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155545] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3591), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7635), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6256), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155580] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5393), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6257), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155617] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10146), 1,
      sym__newline,
    ACTIONS(10148), 1,
      sym__dedent,
    STATE(6338), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6258), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155654] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5730), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6259), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155687] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10150), 1,
      anon_sym_DASH_GT,
    ACTIONS(10152), 1,
      anon_sym_STAR,
    STATE(6351), 1,
      aux_sym_arguments_spec_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6260), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155724] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10069), 1,
      sym_identifier,
    STATE(8078), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6261), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155761] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10077), 1,
      sym_identifier,
    STATE(8058), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6262), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155798] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5575), 1,
      sym_field_pattern,
    STATE(7778), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6263), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155835] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3094), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6264), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155872] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8704), 1,
      anon_sym_COMMA,
    ACTIONS(10154), 1,
      anon_sym_GT,
    STATE(6417), 1,
      aux_sym_types_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6265), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155909] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(2361), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6838), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6266), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155944] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_field_pattern,
    STATE(7805), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6267), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155981] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10156), 1,
      anon_sym_EQ,
    ACTIONS(10158), 1,
      anon_sym_as,
    STATE(8042), 1,
      sym_class_as_reference,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6268), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156018] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10160), 1,
      anon_sym_RPAREN,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7202), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6269), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156055] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10164), 1,
      anon_sym_RPAREN,
    STATE(7867), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6270), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156092] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3597), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6271), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156127] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9998), 1,
      sym_identifier,
    STATE(8073), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6272), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156164] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1501), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7568), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6273), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156199] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10166), 1,
      sym_identifier,
    STATE(8292), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6274), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156236] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10168), 1,
      anon_sym_PIPE,
    ACTIONS(10170), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6275), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156273] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4803), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6276), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156310] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10172), 1,
      anon_sym_PIPE,
    ACTIONS(10174), 1,
      sym__dedent,
    STATE(6320), 1,
      aux_sym_enum_type_cases_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6277), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156347] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3268), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6660), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6278), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156382] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10176), 1,
      anon_sym_PIPE,
    ACTIONS(10178), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6248), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6279), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156419] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1025), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7643), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6280), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156454] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5680), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6281), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156487] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10180), 1,
      anon_sym_COLON,
    STATE(7435), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6282), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156524] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10122), 1,
      anon_sym_POUNDelse,
    ACTIONS(10182), 1,
      anon_sym_POUNDendif,
    STATE(7603), 1,
      sym_preproc_else,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6283), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156561] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10184), 1,
      anon_sym_PIPE,
    ACTIONS(10186), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6284), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156598] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1587), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7689), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6285), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156633] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5358), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6286), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156670] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5459), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6287), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156707] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10188), 1,
      anon_sym_RPAREN,
    STATE(7751), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6288), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156744] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6642), 1,
      anon_sym_GT,
    ACTIONS(10190), 1,
      anon_sym_and,
    STATE(6307), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6289), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156781] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10048), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6290), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156818] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10192), 1,
      anon_sym_GT_RBRACK,
    ACTIONS(10194), 1,
      sym__newline,
    STATE(6415), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6291), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156855] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3440), 3,
      sym__newline,
      anon_sym_with,
      anon_sym_finally,
    STATE(6292), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156888] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3525), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6293), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156921] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3535), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6294), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156954] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5701), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6295), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156987] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1365), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7715), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6296), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157022] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10196), 1,
      anon_sym_with,
    ACTIONS(10198), 1,
      anon_sym_finally,
    ACTIONS(10200), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6297), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157059] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4105), 1,
      sym_field_pattern,
    STATE(7333), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6298), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157096] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10202), 1,
      anon_sym_PIPE,
    ACTIONS(10204), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6275), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6299), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157133] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10206), 1,
      anon_sym_PIPE,
    ACTIONS(10208), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6300), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157170] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5776), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6301), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157203] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1448), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7651), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6302), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157238] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10023), 1,
      sym_identifier,
    STATE(8111), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6303), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157275] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10210), 1,
      anon_sym_with,
    ACTIONS(10212), 1,
      anon_sym_finally,
    ACTIONS(10214), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6304), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157312] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6678), 1,
      anon_sym_GT,
    ACTIONS(10190), 1,
      anon_sym_and,
    STATE(6289), 1,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6305), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157349] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5332), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6306), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157386] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6629), 1,
      anon_sym_GT,
    ACTIONS(10216), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6307), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
  [157421] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5183), 1,
      sym_field_pattern,
    STATE(7778), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6308), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157458] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10219), 1,
      anon_sym_RPAREN,
    STATE(8296), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6309), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157495] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10221), 1,
      anon_sym_GT_RBRACK,
    STATE(6480), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6310), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157532] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4045), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9006), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6311), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157567] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5697), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6312), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157600] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10223), 1,
      sym_identifier,
    STATE(8113), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6313), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157637] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10225), 1,
      anon_sym_COLON,
    STATE(7616), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6314), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157674] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3130), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6315), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157711] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10227), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7228), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6316), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157748] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10229), 1,
      anon_sym_RBRACK,
    STATE(7229), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6317), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157785] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4813), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6318), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157822] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10231), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7696), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6319), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157859] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10233), 1,
      anon_sym_PIPE,
    ACTIONS(10236), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6320), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_enum_type_cases_repeat1,
  [157894] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10238), 1,
      anon_sym_RBRACK,
    STATE(7854), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6321), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157931] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10240), 1,
      sym_identifier,
    STATE(8072), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6322), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157968] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5450), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6323), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158005] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5711), 3,
      sym__newline,
      sym__dedent,
      anon_sym_and,
    STATE(6324), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158038] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10158), 1,
      anon_sym_as,
    ACTIONS(10242), 1,
      anon_sym_EQ,
    STATE(8075), 1,
      sym_class_as_reference,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6325), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158075] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10244), 1,
      anon_sym_RBRACK,
    STATE(7958), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6326), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158112] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10246), 1,
      anon_sym_PIPE_RBRACK,
    STATE(8093), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6327), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158149] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5715), 3,
      sym__newline,
      sym__dedent,
      anon_sym_and,
    STATE(6328), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158182] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5540), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6329), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158215] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5755), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6330), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158248] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5697), 3,
      sym__newline,
      sym__dedent,
      anon_sym_and,
    STATE(6331), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158281] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10248), 1,
      sym_identifier,
    STATE(8031), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6332), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158318] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_property_or_ident,
    STATE(5365), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6333), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158355] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5751), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6334), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158388] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10152), 1,
      anon_sym_STAR,
    ACTIONS(10250), 1,
      anon_sym_DASH_GT,
    STATE(6260), 1,
      aux_sym_arguments_spec_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6335), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158425] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4294), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6939), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6336), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158460] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10252), 1,
      anon_sym_PIPE,
    ACTIONS(10254), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6375), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6337), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158497] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9102), 1,
      sym__dedent,
    ACTIONS(10256), 1,
      sym__newline,
    STATE(6419), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6338), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158534] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9957), 1,
      sym_identifier,
    STATE(7973), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6339), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158571] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10258), 1,
      anon_sym_COMMA,
    ACTIONS(10260), 1,
      sym__dedent,
    STATE(6535), 1,
      aux_sym_slice_ranges_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6340), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158608] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10262), 1,
      anon_sym_RBRACK,
    STATE(7211), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6341), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158645] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10264), 1,
      sym_identifier,
    STATE(8047), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6342), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158682] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10266), 1,
      anon_sym_with,
    ACTIONS(10268), 1,
      anon_sym_finally,
    ACTIONS(10270), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6343), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158719] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10272), 1,
      sym__newline,
    ACTIONS(10274), 1,
      sym__dedent,
    STATE(6542), 1,
      aux_sym_field_initializers_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6344), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158756] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10276), 1,
      anon_sym_PIPE,
    ACTIONS(10278), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6363), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6345), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158793] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1675), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6346), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158828] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10280), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7212), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6347), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158865] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(5180), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5790), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6348), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158900] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2814), 1,
      sym_property_or_ident,
    STATE(5414), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6349), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158937] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10282), 1,
      anon_sym_RPAREN,
    STATE(7997), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6350), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158974] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10284), 1,
      anon_sym_DASH_GT,
    ACTIONS(10286), 1,
      anon_sym_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6351), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_arguments_spec_repeat1,
  [159009] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3203), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6352), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159046] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(5011), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7615), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6353), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159081] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10289), 1,
      anon_sym_GT_RBRACK,
    STATE(6415), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6354), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159118] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1543), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7697), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6355), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159153] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4098), 1,
      sym_field_pattern,
    STATE(7220), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6356), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159190] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9939), 1,
      sym_identifier,
    STATE(8045), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6357), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159227] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10291), 1,
      sym__newline,
    ACTIONS(10293), 1,
      sym__dedent,
    STATE(6238), 1,
      aux_sym__class_type_body_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6358), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159264] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10295), 1,
      anon_sym_PIPE,
    ACTIONS(10297), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6359), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159301] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10299), 1,
      anon_sym_PIPE,
    ACTIONS(10301), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6409), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6360), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159338] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10303), 1,
      anon_sym_RPAREN,
    STATE(7795), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6361), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159375] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5647), 1,
      sym_field_pattern,
    STATE(7408), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6362), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159412] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10305), 1,
      anon_sym_PIPE,
    ACTIONS(10307), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6363), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159449] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10309), 1,
      anon_sym_with,
    ACTIONS(10311), 1,
      anon_sym_finally,
    ACTIONS(10313), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6364), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159486] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9994), 1,
      sym_identifier,
    STATE(7921), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6365), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159523] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10315), 1,
      anon_sym_with,
    ACTIONS(10317), 1,
      anon_sym_finally,
    ACTIONS(10319), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6366), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159560] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10321), 1,
      anon_sym_PIPE,
    ACTIONS(10323), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6300), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6367), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159597] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10325), 1,
      anon_sym_RPAREN,
    STATE(7257), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6368), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159634] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(2791), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6369), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159669] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3706), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7536), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6370), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159704] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1215), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7670), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6371), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159739] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10327), 1,
      anon_sym_PIPE,
    ACTIONS(10329), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6372), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159776] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9935), 1,
      sym_identifier,
    STATE(7965), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6373), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159813] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10331), 1,
      sym_identifier,
    STATE(7976), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6374), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159850] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10333), 1,
      anon_sym_PIPE,
    ACTIONS(10335), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6375), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159887] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4117), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6848), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6376), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159922] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10172), 1,
      anon_sym_PIPE,
    ACTIONS(10337), 1,
      sym__dedent,
    STATE(6277), 1,
      aux_sym_enum_type_cases_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6377), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159959] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4961), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6378), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159994] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3259), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6379), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160029] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10339), 1,
      anon_sym_COMMA,
    ACTIONS(10342), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6380), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_slice_ranges_repeat1,
  [160064] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3195), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6381), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160101] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4357), 1,
      sym_field_pattern,
    STATE(7805), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6382), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160138] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10344), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(10346), 1,
      sym__indent,
    STATE(7806), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6383), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160175] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10348), 1,
      anon_sym_COMMA,
    ACTIONS(10351), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6384), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_attributes_repeat1,
  [160210] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10353), 1,
      anon_sym_RPAREN,
    STATE(7604), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6385), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160247] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10355), 1,
      anon_sym_RBRACK,
    STATE(7807), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6386), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160284] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5550), 1,
      sym_field_pattern,
    STATE(8322), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6387), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160321] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10357), 1,
      anon_sym_RBRACK,
    STATE(7538), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6388), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160358] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10359), 1,
      anon_sym_PIPE_RBRACK,
    STATE(8323), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6389), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160395] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10361), 1,
      anon_sym_GT_RBRACK,
    STATE(6354), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6390), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160432] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10363), 1,
      anon_sym_RBRACK,
    STATE(7522), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6391), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160469] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4643), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6868), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6392), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160504] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10365), 1,
      sym_identifier,
    STATE(8220), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6393), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160541] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10367), 1,
      anon_sym_PIPE,
    ACTIONS(10369), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6372), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6394), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160578] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10371), 1,
      anon_sym_RBRACK,
    STATE(8324), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6395), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160615] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10373), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7518), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6396), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160652] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2815), 1,
      sym_property_or_ident,
    STATE(4797), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6397), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160689] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10375), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7823), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6398), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160726] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10377), 1,
      anon_sym_with,
    ACTIONS(10379), 1,
      anon_sym_finally,
    ACTIONS(10381), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6399), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160763] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10383), 1,
      anon_sym_RBRACK,
    STATE(7824), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6400), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160800] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9970), 1,
      sym_identifier,
    STATE(7846), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6401), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160837] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4175), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6929), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6402), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160872] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5649), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10385), 1,
      anon_sym_and,
    STATE(6406), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6403), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160909] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10387), 1,
      anon_sym_RBRACK,
    STATE(8114), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6404), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160946] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10389), 1,
      anon_sym_PIPE_RBRACK,
    STATE(8115), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6405), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160983] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5672), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10385), 1,
      anon_sym_and,
    STATE(6412), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6406), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161020] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9974), 1,
      sym_identifier,
    STATE(8040), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6407), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161057] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5711), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6408), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161090] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10391), 1,
      anon_sym_PIPE,
    ACTIONS(10393), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6409), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161127] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9964), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(6410), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161160] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3197), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6411), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161197] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5658), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10395), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6412), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [161232] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5638), 1,
      sym_field_pattern,
    STATE(7408), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6413), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161269] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4316), 1,
      sym_field_pattern,
    STATE(7262), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6414), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161306] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10398), 1,
      anon_sym_GT_RBRACK,
    ACTIONS(10400), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6415), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attribute_set_repeat1,
  [161341] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10403), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(6416), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161374] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8861), 1,
      anon_sym_GT,
    ACTIONS(10405), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6417), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_types_repeat1,
  [161409] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5562), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6418), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161442] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10408), 1,
      sym__newline,
    ACTIONS(10411), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6419), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_fields_repeat1,
  [161477] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10413), 1,
      anon_sym_COLON,
    STATE(7284), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6420), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161514] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5347), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6421), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161551] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5597), 3,
      sym__newline,
      sym__dedent,
      anon_sym_interface,
    STATE(6422), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161584] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10415), 1,
      anon_sym_PIPE,
    ACTIONS(10417), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6441), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6423), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161621] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5739), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6424), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161654] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10014), 1,
      sym_identifier,
    STATE(7913), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6425), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161691] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10419), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7550), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6426), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161728] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10421), 1,
      anon_sym_PIPE,
    ACTIONS(10423), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6511), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6427), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161765] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10425), 1,
      anon_sym_RPAREN,
    STATE(8163), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6428), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161802] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5715), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6429), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161835] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10427), 1,
      anon_sym_RBRACK,
    STATE(7469), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6430), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161872] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(5007), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7707), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6431), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161907] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10429), 1,
      sym_identifier,
    STATE(8245), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6432), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161944] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10431), 1,
      anon_sym_COMMA,
    ACTIONS(10433), 1,
      anon_sym_GT,
    STATE(6516), 1,
      aux_sym_type_attributes_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6433), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161981] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3485), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6434), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162014] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3544), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6435), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162047] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10435), 1,
      sym__newline,
    ACTIONS(10438), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6436), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_field_initializers_repeat1,
  [162082] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10440), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7501), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6437), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162119] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10442), 1,
      anon_sym_GT_RBRACK,
    STATE(6291), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6438), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162156] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3259), 1,
      anon_sym_EQ,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7273), 1,
      anon_sym_DOT,
    STATE(4197), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6439), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162193] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3846), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8800), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6440), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162228] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10444), 1,
      anon_sym_PIPE,
    ACTIONS(10446), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6441), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162265] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5759), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6442), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162298] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4109), 1,
      sym_field_pattern,
    STATE(7333), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6443), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162335] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10158), 1,
      anon_sym_as,
    ACTIONS(10448), 1,
      anon_sym_EQ,
    STATE(8195), 1,
      sym_class_as_reference,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6444), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162372] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10342), 1,
      sym__dedent,
    ACTIONS(10450), 1,
      anon_sym_COMMA,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6445), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_slice_ranges_repeat1,
  [162407] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10453), 1,
      sym__newline,
    ACTIONS(10456), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6446), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__list_elements_repeat1,
  [162442] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5649), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10458), 1,
      anon_sym_and,
    STATE(6450), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6447), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162479] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10460), 1,
      sym_identifier,
    STATE(8014), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6448), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162516] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10462), 1,
      sym__newline,
    ACTIONS(10464), 1,
      sym__dedent,
    STATE(6446), 1,
      aux_sym__list_elements_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6449), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162553] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5672), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10458), 1,
      anon_sym_and,
    STATE(6452), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6450), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162590] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4938), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6451), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162627] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5658), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10466), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6452), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [162662] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3037), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6453), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162699] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10469), 1,
      anon_sym_COLON,
    STATE(8178), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6454), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162736] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10040), 1,
      sym_identifier,
    STATE(8185), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6455), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162773] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(3888), 1,
      sym_field_pattern,
    STATE(7499), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6456), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162810] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2784), 1,
      sym_property_or_ident,
    STATE(3201), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6457), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162847] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5364), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6458), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162884] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5676), 3,
      sym__newline,
      sym__dedent,
      anon_sym_interface,
    STATE(6459), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162917] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4946), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6460), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162954] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10471), 1,
      anon_sym_PIPE,
    ACTIONS(10473), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6461), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162991] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5633), 1,
      sym_field_pattern,
    STATE(7683), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6462), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163028] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3332), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6463), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163063] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10475), 1,
      anon_sym_COMMA,
    ACTIONS(10477), 1,
      anon_sym_RBRACK,
    STATE(6380), 1,
      aux_sym_slice_ranges_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6464), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163100] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10479), 1,
      anon_sym_PIPE,
    ACTIONS(10481), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6465), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163137] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4377), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6915), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6466), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163172] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10054), 1,
      sym_identifier,
    STATE(8126), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6467), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163209] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10483), 1,
      anon_sym_with,
    ACTIONS(10485), 1,
      anon_sym_finally,
    ACTIONS(10487), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6468), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163246] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10489), 1,
      anon_sym_PIPE,
    ACTIONS(10491), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6461), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6469), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163283] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10065), 1,
      sym_identifier,
    STATE(8012), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6470), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163320] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_property_or_ident,
    STATE(3173), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6471), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163357] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10493), 1,
      anon_sym_with,
    ACTIONS(10495), 1,
      anon_sym_finally,
    ACTIONS(10497), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6472), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163394] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5333), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6473), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163431] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10499), 1,
      anon_sym_GT_RBRACK,
    STATE(6415), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6474), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163468] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(999), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7576), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6475), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163503] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10501), 1,
      anon_sym_with,
    ACTIONS(10503), 1,
      anon_sym_finally,
    ACTIONS(10505), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6476), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163540] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10507), 1,
      anon_sym_RPAREN,
    STATE(7316), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6477), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163577] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10509), 1,
      anon_sym_RPAREN,
    STATE(7477), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6478), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163614] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10511), 1,
      anon_sym_PIPE,
    ACTIONS(10513), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6465), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6479), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163651] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10515), 1,
      anon_sym_GT_RBRACK,
    STATE(6415), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6480), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163688] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(5046), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8746), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6481), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163723] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10158), 1,
      anon_sym_as,
    ACTIONS(10517), 1,
      anon_sym_EQ,
    STATE(8130), 1,
      sym_class_as_reference,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6482), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163760] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5611), 1,
      sym_field_pattern,
    STATE(8322), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6483), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163797] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10519), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7335), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6484), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163834] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10521), 1,
      anon_sym_RBRACK,
    STATE(7337), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6485), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163871] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10291), 1,
      sym__newline,
    ACTIONS(10523), 1,
      sym__dedent,
    STATE(6358), 1,
      aux_sym__class_type_body_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6486), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163908] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10525), 1,
      anon_sym_COLON,
    STATE(7187), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6487), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163945] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10527), 1,
      anon_sym_with,
    ACTIONS(10529), 1,
      anon_sym_finally,
    ACTIONS(10531), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6488), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163982] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4948), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6489), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164019] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10533), 1,
      anon_sym_PIPE,
    ACTIONS(10535), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6500), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6490), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164056] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10537), 1,
      sym_identifier,
    STATE(8210), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6491), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164093] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10539), 1,
      anon_sym_as,
    ACTIONS(10541), 1,
      anon_sym_with,
    STATE(6181), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6492), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164130] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10543), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7350), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6493), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164167] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10545), 1,
      anon_sym_RBRACK,
    STATE(7352), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6494), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164204] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(925), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7623), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6495), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164239] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10073), 1,
      sym_identifier,
    STATE(8006), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6496), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164276] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5183), 1,
      sym_field_pattern,
    STATE(8322), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6497), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164313] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10547), 1,
      anon_sym_PIPE_RBRACK,
    STATE(8357), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6498), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164350] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10549), 1,
      anon_sym_PIPE,
    ACTIONS(10551), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6499), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164387] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10553), 1,
      anon_sym_PIPE,
    ACTIONS(10555), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6500), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164424] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10557), 1,
      sym_identifier,
    STATE(8216), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6501), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164461] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10559), 1,
      anon_sym_RBRACK,
    STATE(8358), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6502), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164498] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5183), 1,
      sym_field_pattern,
    STATE(8389), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6503), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164535] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10194), 1,
      sym__newline,
    ACTIONS(10561), 1,
      anon_sym_GT_RBRACK,
    STATE(6474), 1,
      aux_sym_attribute_set_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6504), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164572] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(5433), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(9066), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6505), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164607] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10563), 1,
      anon_sym_PIPE,
    ACTIONS(10565), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6536), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6506), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164644] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10567), 1,
      anon_sym_PIPE,
    ACTIONS(10569), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6499), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6507), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164681] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10571), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(6508), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164714] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10573), 1,
      anon_sym_RBRACK,
    STATE(7688), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6509), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164751] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3259), 1,
      anon_sym_EQ2,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6609), 1,
      anon_sym_DOT,
    STATE(3726), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6510), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164788] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10575), 1,
      anon_sym_PIPE,
    ACTIONS(10577), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6511), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164825] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10579), 1,
      anon_sym_COLON,
    STATE(7774), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6512), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164862] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      sym__indent,
    ACTIONS(10581), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7685), 1,
      sym__list_pattern_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6513), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164899] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10583), 1,
      anon_sym_PIPE,
    ACTIONS(10586), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6514), 7,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_active_pattern_repeat1,
  [164934] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10122), 1,
      anon_sym_POUNDelse,
    ACTIONS(10588), 1,
      anon_sym_POUNDendif,
    STATE(8157), 1,
      sym_preproc_else,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6515), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164971] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10431), 1,
      anon_sym_COMMA,
    ACTIONS(10590), 1,
      anon_sym_GT,
    STATE(6384), 1,
      aux_sym_type_attributes_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6516), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165008] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10260), 1,
      anon_sym_RBRACK,
    ACTIONS(10475), 1,
      anon_sym_COMMA,
    STATE(6464), 1,
      aux_sym_slice_ranges_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6517), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165045] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_property_or_ident,
    STATE(4957), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6518), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165082] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(3967), 1,
      sym_field_pattern,
    STATE(7499), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6519), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165119] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5303), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6520), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165156] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10592), 1,
      sym_identifier,
    STATE(8234), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6521), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165193] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10594), 1,
      anon_sym_with,
    ACTIONS(10596), 1,
      anon_sym_finally,
    ACTIONS(10598), 1,
      sym__newline,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6522), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165230] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10600), 1,
      anon_sym_COLON,
    STATE(7410), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6523), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165267] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5183), 1,
      sym_field_pattern,
    STATE(7408), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6524), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165304] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(3875), 1,
      sym_field_pattern,
    STATE(7499), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6525), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165341] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5278), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6526), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165378] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10602), 1,
      sym_identifier,
    STATE(8230), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6527), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165415] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5557), 1,
      sym_field_pattern,
    STATE(7778), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6528), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165452] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10604), 1,
      anon_sym_PIPE,
    ACTIONS(10606), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6534), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6529), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165489] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8076), 1,
      anon_sym_LT2,
    ACTIONS(10608), 1,
      anon_sym_COLON,
    STATE(7280), 1,
      sym_type_arguments,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6530), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165526] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(4447), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5973), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6531), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165561] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10122), 1,
      anon_sym_POUNDelse,
    ACTIONS(10610), 1,
      anon_sym_POUNDendif,
    STATE(7421), 1,
      sym_preproc_else,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6532), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165598] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(838), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10462), 1,
      sym__newline,
    STATE(6446), 1,
      aux_sym__list_elements_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6533), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165635] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10612), 1,
      anon_sym_PIPE,
    ACTIONS(10614), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6534), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165672] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10258), 1,
      anon_sym_COMMA,
    ACTIONS(10477), 1,
      sym__dedent,
    STATE(6445), 1,
      aux_sym_slice_ranges_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6535), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165709] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10616), 1,
      anon_sym_PIPE,
    ACTIONS(10618), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6536), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165746] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10620), 1,
      anon_sym_RPAREN,
    STATE(7662), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6537), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165783] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      sym_identifier,
    STATE(6649), 1,
      sym_field_initializer,
    STATE(8308), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6538), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165820] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(4314), 1,
      sym_field_pattern,
    STATE(7262), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6539), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165857] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5317), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6540), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165894] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5576), 1,
      sym_field_pattern,
    STATE(8389), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6541), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165931] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10272), 1,
      sym__newline,
    ACTIONS(10622), 1,
      sym__dedent,
    STATE(6436), 1,
      aux_sym_field_initializers_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6542), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165968] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5451), 1,
      sym_field_pattern,
    STATE(7683), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6543), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166005] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10624), 1,
      sym_identifier,
    STATE(7858), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6544), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166042] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2780), 1,
      sym_property_or_ident,
    STATE(5291), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6545), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166079] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10626), 1,
      anon_sym_RBRACK,
    STATE(7707), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6546), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166116] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10628), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7705), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6547), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166153] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10112), 1,
      sym_identifier,
    STATE(2792), 1,
      sym_property_or_ident,
    STATE(5371), 1,
      sym_method_or_prop_defn,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6548), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166190] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10630), 1,
      anon_sym_PIPE,
    ACTIONS(10632), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6554), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6549), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166227] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10634), 1,
      anon_sym_PIPE,
    ACTIONS(10636), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6359), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6550), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166264] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(1216), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7512), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6551), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166299] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    STATE(5405), 1,
      sym_field_pattern,
    STATE(8389), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6552), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166336] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5591), 3,
      sym__newline,
      sym__dedent,
      anon_sym_interface,
    STATE(6553), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166369] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10638), 1,
      anon_sym_PIPE,
    ACTIONS(10640), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6514), 1,
      aux_sym_active_pattern_repeat1,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6554), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166406] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10642), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7334), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6555), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166443] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10644), 1,
      sym_identifier,
    STATE(8249), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6556), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166480] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    STATE(3661), 1,
      sym__static_type_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6557), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166515] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10132), 1,
      sym__indent,
    ACTIONS(10646), 1,
      anon_sym_RBRACK,
    STATE(7332), 1,
      sym__list_element,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6558), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166552] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    ACTIONS(10648), 1,
      anon_sym_RPAREN,
    STATE(7389), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6559), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166589] = 10,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4953), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9966), 1,
      sym_identifier,
    STATE(7855), 1,
      sym_access_modifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6560), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166626] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3800), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6561), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166658] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10650), 1,
      sym__indent,
    STATE(1720), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6562), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166692] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(770), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6563), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166726] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(1763), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6564), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166760] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(1760), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6565), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166794] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10658), 1,
      sym__indent,
    STATE(1676), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6566), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166828] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(8370), 1,
      sym__string_literal,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6567), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166862] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(8369), 1,
      sym__string_literal,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6568), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166896] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10662), 1,
      sym_identifier,
    STATE(3351), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6569), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166930] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1387), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6570), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166964] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(8337), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6571), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166998] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(8356), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6572), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167032] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6364), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6573), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167066] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1328), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6574), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167100] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10670), 2,
      ts_builtin_sym_end,
      anon_sym_namespace,
    STATE(6575), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167132] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10662), 1,
      sym_identifier,
    STATE(393), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6576), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167166] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10672), 1,
      sym_identifier,
    STATE(410), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6577), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167200] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10674), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(6578), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167232] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10676), 1,
      anon_sym_EQ,
    ACTIONS(10678), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6579), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167266] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3326), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6580), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167300] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10682), 1,
      sym__indent,
    STATE(945), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6581), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167334] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8664), 1,
      anon_sym_member,
    ACTIONS(8668), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6582), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167368] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(10684), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6583), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167402] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3287), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6584), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167436] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8996), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6585), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167468] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10686), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6586), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167500] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(878), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(6587), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167532] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10688), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(6588), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167564] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1259), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6589), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167598] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1275), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6590), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167632] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10690), 1,
      anon_sym_with,
    ACTIONS(10692), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6591), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167666] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1320), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6592), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167700] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10694), 1,
      sym__newline,
    ACTIONS(10696), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6593), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167734] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(661), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6594), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167768] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(1691), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6595), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167802] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10702), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6596), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167836] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10704), 1,
      sym_identifier,
    STATE(405), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6597), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167870] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10398), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(6598), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167902] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10706), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(6599), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167934] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8859), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6600), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167966] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10658), 1,
      sym__indent,
    STATE(1687), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6601), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168000] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(575), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6602), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168034] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10708), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6603), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168066] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(592), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6604), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168100] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10710), 1,
      sym_identifier,
    STATE(3037), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6605), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168134] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10712), 1,
      anon_sym_member,
    ACTIONS(10714), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6606), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168168] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10716), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6607), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168200] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8839), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6608), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168232] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(2025), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6609), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168266] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(1781), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6610), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168300] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10720), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6611), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168332] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10684), 1,
      anon_sym_new,
    ACTIONS(10722), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6612), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168366] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1333), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6613), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168400] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10724), 1,
      sym__newline,
    ACTIONS(10726), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6614), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168434] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10722), 1,
      anon_sym_LPAREN,
    ACTIONS(10728), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6615), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168468] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6435), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6616), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168502] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1706), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6617), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168536] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10732), 1,
      sym__indent,
    STATE(1585), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6618), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168570] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(10728), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6619), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168604] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10734), 1,
      sym__indent,
    STATE(2182), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6620), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168638] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10736), 1,
      anon_sym_PIPE,
    ACTIONS(10738), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6621), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168672] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6622), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168706] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10722), 1,
      anon_sym_LPAREN,
    ACTIONS(10742), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6623), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168740] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(10742), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6624), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168774] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1369), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6625), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168808] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(8148), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6626), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168842] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6659), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6627), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168876] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10722), 1,
      anon_sym_LPAREN,
    ACTIONS(10744), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6628), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168910] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7934), 2,
      sym__newline,
      sym__dedent,
    STATE(6629), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168942] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8620), 1,
      anon_sym_LPAREN,
    ACTIONS(10744), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6630), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168976] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1707), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6631), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169010] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(1945), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6632), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169044] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7942), 2,
      sym__newline,
      sym__dedent,
    STATE(6633), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169076] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3140), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6634), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169110] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7674), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6635), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169144] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(2970), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6636), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169178] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6297), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6637), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169212] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1899), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6638), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169246] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1600), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6639), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169280] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10710), 1,
      sym_identifier,
    STATE(3173), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6640), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169314] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7638), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6641), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169348] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10748), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6642), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169380] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10750), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6643), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169412] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3280), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6644), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169446] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10734), 1,
      sym__indent,
    STATE(2184), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6645), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169480] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1927), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6646), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169514] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10342), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(6647), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169546] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6243), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6648), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169580] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10438), 2,
      sym__newline,
      sym__dedent,
    STATE(6649), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169612] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1090), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6650), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169646] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1227), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6651), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169680] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7602), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6652), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169714] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6304), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6653), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169748] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10752), 1,
      anon_sym_COLON,
    ACTIONS(10754), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6654), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169782] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7564), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6655), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169816] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10756), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6656), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169848] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10758), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6657), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169880] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(778), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6658), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169914] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7938), 2,
      sym__newline,
      sym__dedent,
    STATE(6659), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169946] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1961), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6660), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169980] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6680), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6661), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170014] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6343), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6662), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170048] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3132), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6663), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170082] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1962), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6664), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170116] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7524), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6665), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170150] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10718), 1,
      sym__indent,
    STATE(1714), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6666), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170184] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10732), 1,
      sym__indent,
    STATE(1116), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6667), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170218] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10351), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6668), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170250] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10710), 1,
      sym_identifier,
    STATE(3130), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6669), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170284] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3089), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6670), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170318] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6488), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6671), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170352] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10760), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6672), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170384] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10762), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6673), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170416] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10764), 1,
      anon_sym_do,
    ACTIONS(10766), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6674), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170450] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10541), 1,
      anon_sym_with,
    STATE(6202), 1,
      sym__object_members,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6675), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170484] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6294), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6676), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170518] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7478), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6677), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170552] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10682), 1,
      sym__indent,
    STATE(1142), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6678), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170586] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10768), 1,
      sym_identifier,
    STATE(6694), 1,
      sym_enum_type_case,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6679), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170620] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7922), 2,
      sym__newline,
      sym__dedent,
    STATE(6680), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170652] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10770), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6681), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170684] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2090), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6682), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170718] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10772), 1,
      sym__indent,
    STATE(2007), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6683), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170752] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10774), 1,
      sym__indent,
    STATE(1998), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6684), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170786] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6701), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6685), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170820] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10110), 2,
      sym__newline,
      sym__dedent,
    STATE(6686), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170852] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10776), 1,
      anon_sym_get,
    ACTIONS(10778), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6687), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170886] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6472), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6688), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170920] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10680), 1,
      sym__indent,
    STATE(3055), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6689), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170954] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10780), 1,
      anon_sym_get,
    ACTIONS(10782), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6690), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170988] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10784), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6691), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171020] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7424), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6692), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171054] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10664), 1,
      sym__indent,
    STATE(1201), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6693), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171088] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10236), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6694), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171120] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2109), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6695), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171154] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7886), 2,
      sym__newline,
      sym__dedent,
    STATE(6696), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171186] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1266), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6697), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171220] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7882), 2,
      sym__newline,
      sym__dedent,
    STATE(6698), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171252] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2647), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6699), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171286] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6522), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6700), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171320] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7878), 2,
      sym__newline,
      sym__dedent,
    STATE(6701), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171352] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10284), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(6702), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171384] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10788), 1,
      anon_sym_get,
    ACTIONS(10790), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6703), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171418] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7370), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6704), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171452] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10411), 2,
      sym__newline,
      sym__dedent,
    STATE(6705), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171484] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7847), 2,
      sym__newline,
      sym__dedent,
    STATE(6706), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171516] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10774), 1,
      sym__indent,
    STATE(1964), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6707), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171550] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2613), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6708), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171584] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7840), 2,
      sym__newline,
      sym__dedent,
    STATE(6709), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171616] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7836), 2,
      sym__newline,
      sym__dedent,
    STATE(6710), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171648] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6476), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6711), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171682] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7832), 2,
      sym__newline,
      sym__dedent,
    STATE(6712), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171714] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7311), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6713), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171748] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7199), 1,
      anon_sym_LPAREN,
    ACTIONS(7201), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6714), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171782] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5854), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6715), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171814] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5911), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6716), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171846] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5911), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6717), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171878] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5562), 2,
      sym__newline,
      sym__dedent,
    STATE(6718), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171910] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(643), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6719), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171944] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(878), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6720), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171976] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10688), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6721), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172008] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2553), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6722), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172042] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2540), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6723), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172076] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2186), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6724), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172110] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2413), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6725), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172142] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(4173), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6726), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172174] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6399), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6727), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172208] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10342), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6728), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172240] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10772), 1,
      sym__indent,
    STATE(1411), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6729), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172274] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5886), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6730), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172306] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5872), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6731), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172338] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5828), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6732), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172370] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5824), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6733), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172402] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5903), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6734), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172434] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5676), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(6735), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172466] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5842), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6736), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172498] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4901), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6737), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172532] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7244), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6738), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172566] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5878), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6739), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172598] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5591), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(6740), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172630] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5936), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6741), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172662] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2419), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6742), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172696] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(1883), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6743), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172730] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10794), 1,
      sym__indent,
    STATE(1719), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6744), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172764] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10796), 1,
      sym__indent,
    STATE(1882), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6745), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172798] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5597), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(6746), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172830] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6241), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6747), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172864] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5866), 2,
      sym__newline,
      sym__dedent,
    STATE(6748), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172896] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5858), 2,
      sym__newline,
      sym__dedent,
    STATE(6749), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172928] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5858), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6750), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172960] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5866), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6751), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172992] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5715), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6752), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173024] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7177), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6753), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173058] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5711), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6754), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173090] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5697), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6755), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173122] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5711), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6756), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173154] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(1868), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6757), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173188] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10798), 1,
      sym__indent,
    STATE(1489), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6758), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173222] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5697), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6759), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173254] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(5715), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6760), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173286] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3842), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6761), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173318] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4791), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6762), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173352] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3838), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6763), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173384] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3827), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6764), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173416] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(2319), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6765), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173450] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3804), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6766), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173482] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3792), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6767), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173514] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6366), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6768), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173548] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3788), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6769), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173580] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3784), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6770), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173612] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10796), 1,
      sym__indent,
    STATE(1860), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6771), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173646] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(2346), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6772), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173680] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3780), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6773), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173712] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3579), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6774), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173744] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3772), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6775), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173776] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3768), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6776), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173808] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3748), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6777), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173840] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3740), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6778), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173872] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3736), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6779), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173904] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3728), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6780), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173936] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3724), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6781), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173968] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3695), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6782), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174000] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3662), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6783), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174032] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(632), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6784), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174066] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3658), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6785), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174098] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(2256), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6786), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174132] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(2255), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6787), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174166] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(1844), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6788), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174200] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3618), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6789), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174232] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6790), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174264] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(2770), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6791), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174296] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3583), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6792), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174328] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10794), 1,
      sym__indent,
    STATE(1273), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6793), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174362] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3587), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6794), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174394] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3644), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6795), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174426] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3796), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6796), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174458] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3703), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6797), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174490] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3600), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6798), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174522] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10666), 1,
      sym__indent,
    STATE(7356), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6799), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174556] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(3776), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6800), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174588] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(2036), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6801), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174622] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2777), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6802), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174656] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(6726), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6803), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174690] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10806), 1,
      sym__indent,
    STATE(1335), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6804), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174724] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10668), 1,
      sym__indent,
    STATE(6468), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6805), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174758] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10654), 1,
      sym__indent,
    STATE(2171), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6806), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174792] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(3534), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6807), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174826] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(1796), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6808), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174860] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10808), 1,
      sym__indent,
    STATE(1685), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6809), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174894] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10810), 1,
      sym__indent,
    STATE(2157), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6810), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174928] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2188), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6811), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174962] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2537), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6812), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174996] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2536), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6813), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175030] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(743), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6814), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175064] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10812), 1,
      sym_identifier,
    STATE(5358), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6815), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175098] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10814), 1,
      sym_identifier,
    STATE(6715), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6816), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175132] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2483), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6817), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175166] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10816), 1,
      sym__indent,
    STATE(1270), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6818), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175200] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2474), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6819), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175234] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4897), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6820), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175268] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(5390), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6821), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175302] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(1790), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6822), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175336] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(1717), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6823), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175370] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4753), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6824), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175404] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(5252), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6825), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175438] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10812), 1,
      sym_identifier,
    STATE(5393), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6826), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175472] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(3530), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6827), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175506] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(2132), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6828), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175540] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(1845), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6829), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175574] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2254), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6830), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175608] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4882), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6831), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175642] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10810), 1,
      sym__indent,
    STATE(2120), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6832), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175676] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(5401), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6833), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175710] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10812), 1,
      sym_identifier,
    STATE(5332), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6834), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175744] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(2113), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6835), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175778] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(5381), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6836), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175812] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10816), 1,
      sym__indent,
    STATE(1246), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6837), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175846] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10806), 1,
      sym__indent,
    STATE(1857), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6838), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175880] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4835), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6839), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175914] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10820), 1,
      anon_sym_get,
    ACTIONS(10822), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6840), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175948] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(5336), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6841), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175982] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10824), 1,
      anon_sym_get,
    ACTIONS(10826), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6842), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176016] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10802), 1,
      sym__indent,
    STATE(2340), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6843), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176050] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10828), 1,
      anon_sym_get,
    ACTIONS(10830), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6844), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176084] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(792), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6845), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176118] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10832), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6846), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176152] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10834), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6847), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176186] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1509), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6848), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176220] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(2083), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6849), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176254] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2451), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6850), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176288] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(2082), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6851), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176322] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(1773), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6852), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176356] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4751), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6853), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176390] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10808), 1,
      sym__indent,
    STATE(1240), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6854), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176424] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10838), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6855), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176458] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10840), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6856), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176492] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10842), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6857), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176526] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10844), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6858), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176560] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10846), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6859), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176594] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10848), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6860), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176628] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3425), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6861), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176662] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10852), 1,
      sym__indent,
    STATE(1377), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6862), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176696] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10854), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6863), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176730] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10856), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6864), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176764] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10858), 1,
      sym__indent,
    STATE(3483), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6865), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176798] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10860), 1,
      sym_identifier,
    STATE(3447), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6866), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176832] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2663), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6867), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176866] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10698), 1,
      sym__indent,
    STATE(2045), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6868), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176900] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2033), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6869), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176934] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2662), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6870), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176968] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10862), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6871), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177002] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10864), 1,
      sym__indent,
    STATE(1759), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6872), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177036] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10866), 1,
      sym__indent,
    STATE(1428), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6873), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177070] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(659), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6874), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177104] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10868), 1,
      sym__newline,
    ACTIONS(10870), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6875), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177138] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6876), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177172] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10874), 1,
      sym__newline,
    ACTIONS(10876), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6877), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177206] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10878), 1,
      anon_sym_with,
    ACTIONS(10880), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6878), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177240] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1278), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6879), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177274] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10882), 1,
      sym_identifier,
    STATE(5414), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6880), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177308] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2597), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6881), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177342] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10884), 1,
      sym__indent,
    STATE(2153), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6882), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177376] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2035), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6883), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177410] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2137), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6884), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177444] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(8112), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6885), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177478] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2568), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6886), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177512] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(6759), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6887), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177546] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4975), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6888), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177580] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2688), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6889), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177614] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10890), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6890), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177648] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2095), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6891), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177682] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10892), 1,
      sym__newline,
    ACTIONS(10894), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6892), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177716] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10896), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6893), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177750] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10898), 1,
      sym__newline,
    ACTIONS(10900), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6894), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177784] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10902), 1,
      anon_sym_with,
    ACTIONS(10904), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6895), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177818] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(5453), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6896), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177852] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(5352), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6897), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177886] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10866), 1,
      sym__indent,
    STATE(1403), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6898), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177920] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2775), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6899), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177954] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10882), 1,
      sym_identifier,
    STATE(5454), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6900), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177988] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10858), 1,
      sym__indent,
    STATE(3481), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6901), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178022] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(1915), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6902), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178056] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2195), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6903), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178090] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7956), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6904), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178124] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10908), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6905), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178158] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10910), 1,
      sym__newline,
    ACTIONS(10912), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6906), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178192] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4956), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6907), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178226] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(5458), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6908), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178260] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10914), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6909), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178294] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10882), 1,
      sym_identifier,
    STATE(5459), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6910), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178328] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(723), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6911), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178362] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10916), 1,
      sym__newline,
    ACTIONS(10918), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6912), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178396] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10920), 1,
      anon_sym_with,
    ACTIONS(10922), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6913), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178430] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(5460), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6914), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178464] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10884), 1,
      sym__indent,
    STATE(2297), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6915), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178498] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10852), 1,
      sym__indent,
    STATE(1880), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6916), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178532] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2749), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6917), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178566] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2748), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6918), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178600] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2047), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6919), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178634] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10924), 1,
      anon_sym_EQ,
    ACTIONS(10926), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6920), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178668] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(6756), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6921), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178702] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4905), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6922), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178736] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10928), 1,
      anon_sym_get,
    ACTIONS(10930), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6923), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178770] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(5466), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6924), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178804] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10864), 1,
      sym__indent,
    STATE(1382), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6925), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178838] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7832), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6926), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178872] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10932), 1,
      anon_sym_get,
    ACTIONS(10934), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6927), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178906] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10836), 1,
      sym__indent,
    STATE(2332), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6928), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178940] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10936), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6929), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178974] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10938), 1,
      sym__newline,
    ACTIONS(10940), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6930), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179008] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10942), 1,
      anon_sym_get,
    ACTIONS(10944), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6931), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179042] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10946), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6932), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179076] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10948), 1,
      sym__newline,
    ACTIONS(10950), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6933), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179110] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10952), 1,
      anon_sym_with,
    ACTIONS(10954), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6934), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179144] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10956), 1,
      anon_sym_EQ,
    ACTIONS(10958), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6935), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179178] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10960), 1,
      sym_identifier,
    STATE(7945), 1,
      sym_long_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6936), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179212] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10656), 1,
      sym__indent,
    STATE(2466), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6937), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179246] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1079), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6938), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179280] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7682), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6939), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179314] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10964), 1,
      anon_sym_COLON,
    ACTIONS(10966), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6940), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179348] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10968), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6941), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179382] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10746), 1,
      sym__indent,
    STATE(2656), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6942), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179416] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10970), 1,
      sym__newline,
    ACTIONS(10972), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6943), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179450] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(10974), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6944), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179484] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10976), 1,
      sym__newline,
    ACTIONS(10978), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6945), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179518] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10980), 1,
      anon_sym_with,
    ACTIONS(10982), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6946), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179552] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(7929), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6947), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179586] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10984), 1,
      sym__indent,
    STATE(908), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6948), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179620] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10986), 1,
      anon_sym_EQ,
    ACTIONS(10988), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6949), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179654] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3388), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6950), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179688] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1009), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6951), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179722] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1161), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6952), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179756] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1165), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6953), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179790] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7531), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6954), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179824] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(665), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6955), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179858] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10990), 1,
      anon_sym_get,
    ACTIONS(10992), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6956), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179892] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(779), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6957), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179926] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1294), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6958), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179960] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10964), 1,
      anon_sym_COLON,
    ACTIONS(10994), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6959), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179994] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10996), 1,
      anon_sym_get,
    ACTIONS(10998), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6960), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180028] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11000), 1,
      sym_identifier,
    STATE(5317), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6961), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180062] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11002), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6962), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180096] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11004), 1,
      sym__newline,
    ACTIONS(11006), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6963), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180130] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4942), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6964), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180164] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1174), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6965), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180198] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9659), 1,
      anon_sym_member,
    ACTIONS(9661), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6966), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180232] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11008), 1,
      sym__indent,
    STATE(2231), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6967), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180266] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11010), 1,
      anon_sym_get,
    ACTIONS(11012), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6968), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180300] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11014), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6969), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180334] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11016), 1,
      sym__newline,
    ACTIONS(11018), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6970), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180368] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(7829), 1,
      sym__string_literal,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6971), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180402] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11020), 1,
      sym__indent,
    STATE(1186), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6972), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180436] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7825), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6973), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180470] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11022), 1,
      sym__indent,
    STATE(1792), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6974), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180504] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11024), 1,
      anon_sym_with,
    ACTIONS(11026), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6975), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180538] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4945), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6976), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180572] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8136), 1,
      anon_sym_member,
    ACTIONS(8140), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6977), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180606] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1163), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6978), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180640] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11028), 1,
      anon_sym_EQ,
    ACTIONS(11030), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6979), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180674] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(5251), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6980), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180708] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11032), 1,
      sym_identifier,
    STATE(4946), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6981), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180742] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4947), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6982), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180776] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(5209), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6983), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180810] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11000), 1,
      sym_identifier,
    STATE(5291), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6984), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180844] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7327), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6985), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180878] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11034), 1,
      anon_sym_EQ,
    ACTIONS(11036), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6986), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180912] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3403), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6987), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180946] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(1022), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6988), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180980] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1004), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6989), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181014] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1668), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6990), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181048] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11038), 1,
      anon_sym_COLON,
    ACTIONS(11040), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6991), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181082] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11042), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6992), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181116] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1738), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6993), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181150] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11046), 1,
      sym__indent,
    STATE(3504), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6994), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181184] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11048), 1,
      sym__newline,
    ACTIONS(11050), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6995), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181218] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9704), 1,
      anon_sym_member,
    ACTIONS(9706), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6996), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181252] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9042), 1,
      anon_sym_member,
    ACTIONS(9046), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6997), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181286] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(5285), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6998), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181320] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11032), 1,
      sym_identifier,
    STATE(4948), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(6999), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181354] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11000), 1,
      sym_identifier,
    STATE(5278), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7000), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181388] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4856), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7001), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181422] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10792), 1,
      sym__indent,
    STATE(4949), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7002), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181456] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(5273), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7003), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181490] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11052), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7004), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181524] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11054), 1,
      sym__newline,
    ACTIONS(11056), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7005), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181558] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11058), 1,
      anon_sym_with,
    ACTIONS(11060), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7006), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181592] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11062), 1,
      sym__newline,
    ACTIONS(11064), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7007), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181626] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(6755), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7008), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181660] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11066), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7009), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181694] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11068), 1,
      anon_sym_with,
    ACTIONS(11070), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7010), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181728] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8161), 1,
      anon_sym_member,
    ACTIONS(8165), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7011), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181762] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11008), 1,
      sym__indent,
    STATE(2150), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7012), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181796] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11022), 1,
      sym__indent,
    STATE(1800), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7013), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181830] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1660), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7014), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181864] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10984), 1,
      sym__indent,
    STATE(978), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7015), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181898] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11072), 1,
      anon_sym_get,
    ACTIONS(11074), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7016), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181932] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11076), 1,
      anon_sym_member,
    ACTIONS(11078), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7017), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181966] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11080), 1,
      anon_sym_EQ,
    ACTIONS(11082), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7018), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182000] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11032), 1,
      sym_identifier,
    STATE(4957), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7019), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182034] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(5280), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7020), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182068] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11084), 1,
      anon_sym_get,
    ACTIONS(11086), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7021), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182102] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1039), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7022), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182136] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7159), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7023), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182170] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11088), 1,
      sym__newline,
    ACTIONS(11090), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7024), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182204] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11092), 1,
      anon_sym_get,
    ACTIONS(11094), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7025), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182238] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11096), 1,
      anon_sym_COLON,
    ACTIONS(11098), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7026), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182272] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11100), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7027), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182306] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11102), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7028), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182340] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(664), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7029), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182374] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11104), 1,
      sym__newline,
    ACTIONS(11106), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7030), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182408] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(2018), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7031), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182442] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1636), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7032), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182476] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1635), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7033), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182510] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1424), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7034), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182544] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11046), 1,
      sym__indent,
    STATE(3516), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7035), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182578] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11020), 1,
      sym__indent,
    STATE(975), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7036), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182612] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11108), 1,
      anon_sym_member,
    ACTIONS(11110), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7037), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182646] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7038), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182680] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10752), 1,
      anon_sym_COLON,
    ACTIONS(11114), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7039), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182714] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11116), 1,
      sym__newline,
    ACTIONS(11118), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7040), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182748] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11120), 1,
      anon_sym_with,
    ACTIONS(11122), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7041), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182782] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8626), 1,
      anon_sym_member,
    ACTIONS(8630), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7042), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182816] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11124), 1,
      sym__indent,
    STATE(1049), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7043), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182850] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11126), 1,
      anon_sym_EQ,
    ACTIONS(11128), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7044), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182884] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6324), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7045), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182918] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1749), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7046), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182952] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1983), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7047), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182986] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1981), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7048), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183020] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7232), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7049), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183054] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10786), 1,
      sym__indent,
    STATE(1575), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7050), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183088] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(749), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7051), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183122] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11130), 1,
      sym_identifier,
    STATE(3201), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7052), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183156] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10752), 1,
      anon_sym_COLON,
    ACTIONS(11132), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7053), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183190] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1954), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7054), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183224] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11134), 1,
      sym__indent,
    STATE(1018), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7055), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183258] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11136), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7056), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183292] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11138), 1,
      sym__newline,
    ACTIONS(11140), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7057), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183326] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11142), 1,
      anon_sym_member,
    ACTIONS(11144), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7058), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183360] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1753), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7059), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183394] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11146), 1,
      anon_sym_get,
    ACTIONS(11148), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7060), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183428] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(1852), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7061), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183462] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11150), 1,
      anon_sym_get,
    ACTIONS(11152), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7062), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183496] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3198), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7063), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183530] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(5356), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7064), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183564] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11154), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7065), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183598] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11156), 1,
      anon_sym_get,
    ACTIONS(11158), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7066), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183632] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11160), 1,
      sym__indent,
    STATE(1718), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7067), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183666] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11162), 1,
      sym__indent,
    STATE(2030), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7068), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183700] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3175), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7069), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183734] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(5348), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7070), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183768] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11164), 1,
      sym_identifier,
    STATE(5333), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7071), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183802] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(5331), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7072), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183836] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11166), 1,
      sym__newline,
    ACTIONS(11168), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7073), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183870] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11170), 1,
      anon_sym_with,
    ACTIONS(11172), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7074), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183904] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11130), 1,
      sym_identifier,
    STATE(3197), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7075), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183938] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8676), 1,
      anon_sym_member,
    ACTIONS(8680), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7076), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183972] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10730), 1,
      sym__indent,
    STATE(6331), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7077), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184006] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(1855), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7078), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184040] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10962), 1,
      sym__indent,
    STATE(1682), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7079), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184074] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11174), 1,
      sym__indent,
    STATE(1748), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7080), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184108] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1752), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7081), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184142] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11164), 1,
      sym_identifier,
    STATE(5364), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7082), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184176] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(5327), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7083), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184210] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10888), 1,
      sym__indent,
    STATE(5334), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7084), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184244] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11176), 1,
      anon_sym_EQ,
    ACTIONS(11178), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7085), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184278] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(2344), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7086), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184312] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3196), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7087), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184346] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11130), 1,
      sym_identifier,
    STATE(3195), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7088), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184380] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7353), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7089), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184414] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11162), 1,
      sym__indent,
    STATE(2189), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7090), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184448] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(2338), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7091), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184482] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(7357), 1,
      sym__string_literal,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7092), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184516] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3194), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7093), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184550] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11164), 1,
      sym_identifier,
    STATE(5347), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7094), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184584] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11134), 1,
      sym__indent,
    STATE(1010), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7095), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184618] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11124), 1,
      sym__indent,
    STATE(1491), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7096), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184652] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11180), 1,
      anon_sym_get,
    ACTIONS(11182), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7097), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184686] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(7715), 1,
      sym__string_literal,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7098), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184720] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10850), 1,
      sym__indent,
    STATE(3193), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7099), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184754] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7712), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7100), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184788] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11184), 1,
      anon_sym_get,
    ACTIONS(11186), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7101), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184822] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(578), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7102), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184856] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11044), 1,
      sym__indent,
    STATE(1742), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7103), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184890] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11188), 1,
      anon_sym_get,
    ACTIONS(11190), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7104), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184924] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10752), 1,
      anon_sym_COLON,
    ACTIONS(11192), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7105), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184958] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2452), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7106), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184992] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11194), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7107), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185026] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(2322), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7108), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185060] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(2321), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7109), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185094] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(1867), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7110), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185128] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10906), 1,
      sym__indent,
    STATE(6754), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7111), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185162] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11196), 1,
      anon_sym_EQ,
    ACTIONS(11198), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7112), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185196] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11160), 1,
      sym__indent,
    STATE(1229), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7113), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185230] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11200), 1,
      sym__newline,
    ACTIONS(11202), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7114), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185264] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11204), 1,
      anon_sym_member,
    ACTIONS(11206), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7115), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185298] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11208), 1,
      sym__indent,
    STATE(1321), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7116), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185332] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(6408), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7117), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185366] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11210), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7118), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185400] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2084), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7119), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185434] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11212), 1,
      sym__newline,
    ACTIONS(11214), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7120), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185468] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11216), 1,
      anon_sym_with,
    ACTIONS(11218), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7121), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185502] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2684), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7122), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185536] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_member,
    ACTIONS(8184), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7123), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185570] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2707), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7124), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185604] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8721), 1,
      anon_sym_member,
    ACTIONS(8725), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7125), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185638] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10162), 1,
      sym__indent,
    STATE(7523), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7126), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185672] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4808), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7127), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185706] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11220), 1,
      sym_identifier,
    STATE(4807), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7128), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185740] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4805), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7129), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185774] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11222), 1,
      anon_sym_with,
    ACTIONS(11224), 1,
      anon_sym_finally,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7130), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185808] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11226), 1,
      sym__newline,
    ACTIONS(11228), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7131), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185842] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11220), 1,
      sym_identifier,
    STATE(4803), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7132), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185876] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11230), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7133), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185910] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10800), 1,
      sym__indent,
    STATE(2240), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7134), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185944] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10752), 1,
      anon_sym_COLON,
    ACTIONS(11232), 1,
      anon_sym_COLON_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7135), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185978] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10652), 1,
      sym__indent,
    STATE(814), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7136), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186012] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10650), 1,
      sym__indent,
    STATE(1728), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7137), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186046] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4754), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7138), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186080] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4802), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7139), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186114] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2763), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7140), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186148] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9714), 1,
      anon_sym_member,
    ACTIONS(9716), 1,
      anon_sym_val,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7141), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186182] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2634), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7142), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186216] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11234), 1,
      anon_sym_get,
    ACTIONS(11236), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7143), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186250] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2202), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7144), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186284] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11238), 1,
      anon_sym_get,
    ACTIONS(11240), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7145), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186318] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11220), 1,
      sym_identifier,
    STATE(4797), 1,
      sym_member_signature,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7146), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186352] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10886), 1,
      sym__indent,
    STATE(2156), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7147), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186386] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11242), 1,
      sym__newline,
    ACTIONS(11244), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7148), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186420] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10818), 1,
      sym__indent,
    STATE(4811), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7149), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186454] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(7529), 1,
      sym__string_literal,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7150), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186488] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      sym_identifier,
    ACTIONS(11246), 1,
      anon_sym__,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7151), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186522] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11248), 1,
      sym__indent,
    STATE(1546), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7152), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186556] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      sym__indent,
    STATE(6312), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7153), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186590] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11250), 1,
      anon_sym_get,
    ACTIONS(11252), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7154), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186624] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11254), 1,
      anon_sym_EQ,
    ACTIONS(11256), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7155), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186658] = 9,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11208), 1,
      sym__indent,
    STATE(1912), 1,
      sym__expression_block,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7156), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186692] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11258), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7157), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186723] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11260), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7158), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186754] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11262), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7159), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186785] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11264), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7160), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186816] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11266), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7161), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186847] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11268), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7162), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186878] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11270), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7163), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186909] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11270), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7164), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186940] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11272), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7165), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186971] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11272), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7166), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187002] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11274), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7167), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187033] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11276), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7168), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187064] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11274), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7169), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187095] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11278), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7170), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187126] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11280), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7171), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187157] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11282), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7172), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187188] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11284), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7173), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187219] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11286), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7174), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187250] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11288), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7175), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187281] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11290), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7176), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187312] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11292), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7177), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187343] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11294), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7178), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187374] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11296), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7179), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187405] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11298), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7180), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187436] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11300), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7181), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187467] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11302), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7182), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187498] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11304), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7183), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187529] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11306), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7184), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187560] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11308), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7185), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187591] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11310), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7186), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187622] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11312), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7187), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187653] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11314), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7188), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187684] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11316), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7189), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187715] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9815), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7190), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187746] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11318), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7191), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187777] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11320), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7192), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187808] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11322), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7193), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187839] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11324), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7194), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187870] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11326), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7195), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187901] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11328), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7196), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187932] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11330), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7197), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187963] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11332), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7198), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187994] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11334), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7199), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188025] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11336), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7200), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188056] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11338), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7201), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188087] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11340), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7202), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188118] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11342), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7203), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188149] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11344), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7204), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188180] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11346), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7205), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188211] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11348), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7206), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188242] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11350), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7207), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188273] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11352), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7208), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188304] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11354), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7209), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188335] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11356), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7210), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188366] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11358), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7211), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188397] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11360), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7212), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188428] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11362), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7213), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188459] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11364), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7214), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188490] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11366), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7215), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188521] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11368), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7216), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188552] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11370), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7217), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188583] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11372), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7218), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188614] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11374), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7219), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188645] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11376), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7220), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188676] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11378), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7221), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188707] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11380), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7222), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188738] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11382), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7223), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188769] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11384), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7224), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188800] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11386), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7225), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188831] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11388), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7226), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188862] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11390), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7227), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188893] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11392), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7228), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188924] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11394), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7229), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188955] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11396), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7230), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188986] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11398), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7231), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189017] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11400), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7232), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189048] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11402), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7233), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189079] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11404), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7234), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189110] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11406), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7235), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189141] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11408), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7236), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189172] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11410), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7237), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189203] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11412), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7238), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189234] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11414), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7239), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189265] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11294), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7240), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189296] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11416), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7241), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189327] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11416), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7242), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189358] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11414), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7243), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189389] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11418), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7244), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189420] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11420), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7245), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189451] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11422), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7246), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189482] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11424), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7247), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189513] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11426), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7248), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189544] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11428), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7249), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189575] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11430), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7250), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189606] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11432), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7251), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189637] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11434), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7252), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189668] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11436), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7253), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189699] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11438), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7254), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189730] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11440), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7255), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189761] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11442), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7256), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189792] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11444), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7257), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189823] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11446), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7258), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189854] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11448), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7259), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189885] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11450), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7260), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189916] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11452), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7261), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189947] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11454), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7262), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189978] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11456), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7263), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190009] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11458), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7264), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190040] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11460), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7265), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190071] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11462), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7266), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190102] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11464), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7267), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190133] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11466), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7268), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190164] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11468), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7269), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190195] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11470), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7270), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190226] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11472), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7271), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190257] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11474), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7272), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190288] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11476), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7273), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190319] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11478), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7274), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190350] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11480), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7275), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190381] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11482), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7276), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190412] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11484), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7277), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190443] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9843), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7278), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190474] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11486), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7279), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190505] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11488), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7280), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190536] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11490), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7281), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190567] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11492), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7282), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190598] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7283), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190629] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11496), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7284), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190660] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11498), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7285), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190691] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11500), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7286), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190722] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11502), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7287), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190753] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11504), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7288), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190784] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11506), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7289), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190815] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11508), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7290), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190846] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11510), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7291), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190877] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11512), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7292), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190908] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11514), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7293), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190939] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9881), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7294), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190970] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11516), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7295), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191001] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11518), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7296), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191032] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11520), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7297), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191063] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11522), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7298), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191094] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11524), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7299), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191125] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10764), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7300), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191156] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11520), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7301), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191187] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11526), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7302), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191218] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11528), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7303), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191249] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11530), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7304), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191280] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11532), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7305), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191311] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11534), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7306), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191342] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11536), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7307), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191373] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11538), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7308), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191404] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11540), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7309), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191435] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11542), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7310), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191466] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11544), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7311), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191497] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11530), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7312), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191528] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11546), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7313), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191559] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11548), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7314), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191590] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11550), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7315), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191621] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11552), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7316), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191652] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11554), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7317), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191683] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11556), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7318), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191714] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11558), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7319), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191745] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11560), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7320), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191776] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11562), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7321), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191807] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11564), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7322), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191838] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11566), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7323), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191869] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11546), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7324), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191900] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11568), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7325), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191931] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11570), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7326), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191962] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11572), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7327), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191993] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11574), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7328), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192024] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11576), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7329), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192055] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11578), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7330), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192086] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11580), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7331), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192117] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11582), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7332), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192148] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11584), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7333), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192179] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11586), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7334), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192210] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11588), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7335), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192241] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11590), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7336), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192272] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11592), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7337), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192303] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11594), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7338), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192334] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11596), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7339), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192365] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11598), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7340), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192396] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11600), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7341), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192427] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11602), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7342), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192458] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11604), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7343), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192489] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11606), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7344), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192520] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11608), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7345), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192551] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11610), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7346), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192582] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11612), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7347), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192613] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11614), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7348), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192644] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11616), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7349), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192675] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11618), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7350), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192706] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11620), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7351), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192737] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11622), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7352), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192768] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11624), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7353), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192799] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11626), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7354), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192830] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11628), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7355), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192861] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11630), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7356), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192892] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11632), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7357), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192923] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11634), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7358), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192954] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11636), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7359), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192985] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11638), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7360), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193016] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11640), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7361), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193047] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11642), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7362), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193078] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11644), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7363), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193109] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11646), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7364), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193140] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11640), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7365), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193171] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11648), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7366), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193202] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11650), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7367), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193233] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11652), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7368), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193264] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11652), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7369), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193295] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11654), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7370), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193326] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11656), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7371), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193357] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11658), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7372), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193388] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11658), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7373), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193419] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11660), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7374), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193450] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11662), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7375), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193481] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11664), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7376), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193512] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11666), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7377), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193543] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11668), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7378), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193574] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11670), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7379), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193605] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11672), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7380), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193636] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11674), 1,
      anon_sym_struct,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7381), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193667] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11676), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7382), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193698] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11678), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7383), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193729] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11680), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7384), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193760] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11682), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7385), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193791] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11684), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7386), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193822] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11686), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7387), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193853] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11688), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7388), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193884] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11690), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7389), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193915] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11692), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7390), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193946] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11694), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7391), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193977] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11696), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7392), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194008] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11698), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7393), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194039] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11700), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7394), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194070] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11702), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7395), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194101] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11704), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7396), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194132] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11706), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7397), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194163] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11708), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7398), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194194] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11710), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7399), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194225] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11712), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7400), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194256] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11714), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7401), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194287] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11716), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7402), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194318] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11718), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7403), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194349] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11720), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7404), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194380] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11722), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7405), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194411] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11724), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7406), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194442] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9802), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7407), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194473] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11726), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7408), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194504] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11728), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7409), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194535] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11730), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7410), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194566] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11732), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7411), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194597] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11734), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7412), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194628] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11736), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7413), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194659] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11738), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7414), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194690] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11740), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7415), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194721] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11742), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7416), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194752] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11744), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7417), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194783] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11746), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7418), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194814] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11748), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7419), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194845] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11750), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7420), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194876] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11752), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7421), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194907] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11754), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7422), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194938] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11756), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7423), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194969] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11758), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7424), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195000] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11760), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7425), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195031] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11762), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7426), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195062] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11764), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7427), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195093] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11766), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7428), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195124] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11768), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7429), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195155] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11770), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7430), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195186] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11772), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7431), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195217] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11774), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7432), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195248] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11776), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7433), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195279] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11778), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7434), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195310] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11780), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7435), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195341] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11782), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7436), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195372] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11784), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7437), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195403] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11786), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7438), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195434] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11788), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7439), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195465] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7440), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195496] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11792), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7441), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195527] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11794), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7442), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195558] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11796), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7443), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195589] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11798), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7444), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195620] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11800), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7445), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195651] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11802), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7446), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195682] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11804), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7447), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195713] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11806), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7448), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195744] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11808), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7449), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195775] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9752), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7450), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195806] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11810), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7451), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195837] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11812), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7452), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195868] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11814), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7453), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195899] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11816), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7454), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195930] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11818), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7455), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195961] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11820), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7456), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195992] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11822), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7457), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196023] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11824), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7458), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196054] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11826), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7459), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196085] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11828), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7460), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196116] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11830), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7461), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196147] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11832), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7462), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196178] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11834), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7463), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196209] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11836), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7464), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196240] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11838), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7465), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196271] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11840), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7466), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196302] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11842), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7467), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196333] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11844), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7468), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196364] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11846), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7469), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196395] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11848), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7470), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196426] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11850), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7471), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196457] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11852), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7472), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196488] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11854), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7473), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196519] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11856), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7474), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196550] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11858), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7475), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196581] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11860), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7476), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196612] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11862), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7477), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196643] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11864), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7478), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196674] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11866), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7479), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196705] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11868), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7480), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196736] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11870), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7481), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196767] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11872), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7482), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196798] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11874), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7483), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196829] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11876), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7484), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196860] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11878), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7485), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196891] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7486), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196922] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11882), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7487), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196953] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11884), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7488), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196984] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11886), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7489), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197015] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11888), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7490), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197046] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11886), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7491), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197077] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11890), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7492), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197108] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11892), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7493), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197139] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11894), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7494), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197170] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11896), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7495), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197201] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11898), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7496), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197232] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11900), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7497), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197263] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11902), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7498), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197294] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11904), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7499), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197325] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11906), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7500), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197356] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11908), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7501), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197387] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11910), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7502), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197418] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11912), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7503), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197449] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9923), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7504), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197480] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11902), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7505), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197511] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11914), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7506), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197542] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11916), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7507), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197573] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11918), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7508), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197604] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11920), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7509), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197635] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11922), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7510), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197666] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11924), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7511), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197697] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11926), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7512), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197728] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11928), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7513), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197759] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11930), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7514), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197790] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11932), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7515), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197821] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11934), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7516), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197852] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11922), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7517), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197883] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11936), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7518), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197914] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11938), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7519), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197945] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11940), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7520), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197976] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11942), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7521), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198007] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11944), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7522), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198038] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11946), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7523), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198069] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11948), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7524), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198100] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11950), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7525), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198131] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11952), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7526), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198162] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11954), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7527), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198193] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11956), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7528), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198224] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11958), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7529), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198255] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11960), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7530), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198286] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11962), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7531), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198317] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11964), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7532), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198348] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11966), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7533), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198379] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11968), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7534), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198410] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11970), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7535), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198441] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11972), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7536), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198472] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11974), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7537), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198503] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11976), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7538), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198534] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11974), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7539), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198565] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11978), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7540), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198596] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11980), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7541), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198627] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11982), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7542), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198658] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11984), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7543), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198689] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11982), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7544), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198720] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11910), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7545), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198751] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(11986), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7546), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198782] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11988), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7547), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198813] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11990), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7548), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198844] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7549), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198875] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11994), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7550), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198906] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11996), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7551), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198937] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11998), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7552), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198968] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12000), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7553), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198999] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12002), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7554), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199030] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12004), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7555), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199061] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12006), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7556), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199092] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12008), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7557), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199123] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12010), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7558), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199154] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12012), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7559), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199185] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12014), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7560), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199216] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12016), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7561), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199247] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12018), 1,
      anon_sym_struct,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7562), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199278] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12020), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7563), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199309] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12022), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7564), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199340] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12024), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7565), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199371] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12026), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7566), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199402] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12028), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7567), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199433] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12030), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7568), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199464] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12032), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7569), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199495] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12034), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7570), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199526] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12036), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7571), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199557] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12038), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7572), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199588] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12040), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7573), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199619] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12042), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7574), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199650] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12044), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7575), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199681] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12046), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7576), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199712] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9901), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7577), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199743] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12048), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7578), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199774] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12050), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7579), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199805] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12052), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7580), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199836] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12054), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7581), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199867] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12056), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7582), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199898] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12058), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7583), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199929] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(12060), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7584), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199960] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12062), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7585), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199991] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12064), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7586), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200022] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12066), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7587), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200053] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12068), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7588), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200084] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9905), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7589), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200115] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12070), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7590), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200146] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12072), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7591), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200177] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12074), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7592), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200208] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12076), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7593), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200239] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12078), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7594), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200270] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12080), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7595), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200301] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12082), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7596), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200332] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12084), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7597), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200363] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12086), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7598), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200394] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12088), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7599), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200425] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12090), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7600), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200456] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12092), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7601), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200487] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12094), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7602), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200518] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12096), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7603), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200549] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12098), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7604), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200580] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12100), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7605), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200611] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12102), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7606), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200642] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9915), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7607), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200673] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12104), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7608), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200704] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12106), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7609), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200735] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12108), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7610), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200766] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12110), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7611), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200797] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12112), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7612), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200828] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12114), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7613), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200859] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12116), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7614), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200890] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12118), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7615), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200921] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12120), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7616), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200952] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12122), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7617), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200983] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12124), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7618), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201014] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12126), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7619), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201045] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12128), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7620), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201076] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(12130), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7621), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201107] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12132), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7622), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201138] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12134), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7623), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201169] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12136), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7624), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201200] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12138), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7625), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201231] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12140), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7626), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201262] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12142), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7627), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201293] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12144), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7628), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201324] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12146), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7629), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201355] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12148), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7630), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201386] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12150), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7631), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201417] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12152), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7632), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201448] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12154), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7633), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201479] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12156), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7634), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201510] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12158), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7635), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201541] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12160), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7636), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201572] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9800), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7637), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201603] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12162), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7638), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201634] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9929), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7639), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201665] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12164), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7640), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201696] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12166), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7641), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201727] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12168), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7642), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201758] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12170), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7643), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201789] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12172), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7644), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201820] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12174), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7645), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201851] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12176), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7646), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201882] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12178), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7647), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201913] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12180), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7648), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201944] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12182), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7649), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201975] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12184), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7650), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202006] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12186), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7651), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202037] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12188), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7652), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202068] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12190), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7653), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202099] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12192), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7654), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202130] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12194), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7655), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202161] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12196), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7656), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202192] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(12198), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7657), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202223] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12200), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7658), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202254] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12202), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7659), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202285] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12204), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7660), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202316] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9895), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7661), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202347] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12206), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7662), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202378] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12208), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7663), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202409] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12210), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7664), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202440] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12212), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7665), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202471] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12214), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7666), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202502] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12216), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7667), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202533] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12218), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7668), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202564] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12220), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7669), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202595] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12222), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7670), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202626] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12224), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7671), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202657] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12226), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7672), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202688] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12228), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7673), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202719] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12230), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7674), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202750] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12232), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7675), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202781] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12234), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7676), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202812] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12236), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7677), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202843] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12238), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7678), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202874] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12240), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7679), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202905] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12242), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7680), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202936] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12244), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7681), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202967] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12246), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7682), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202998] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12248), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7683), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203029] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12250), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7684), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203060] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12252), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7685), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203091] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12254), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7686), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203122] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12256), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7687), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203153] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12258), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7688), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203184] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12260), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7689), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203215] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12262), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7690), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203246] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12264), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7691), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203277] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9859), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7692), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203308] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12266), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7693), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203339] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12268), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7694), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203370] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12270), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7695), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203401] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12272), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7696), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203432] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12274), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7697), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203463] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12276), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7698), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203494] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12278), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7699), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203525] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12280), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7700), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203556] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12282), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7701), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203587] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12284), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7702), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203618] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12286), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7703), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203649] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12288), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7704), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203680] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12290), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7705), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203711] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12292), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7706), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203742] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12294), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7707), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203773] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12296), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7708), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203804] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12298), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7709), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203835] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12300), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7710), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203866] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12302), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7711), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203897] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12304), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7712), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203928] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12306), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7713), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203959] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12308), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7714), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203990] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(12310), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7715), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204021] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12312), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7716), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204052] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12314), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7717), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204083] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12316), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7718), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204114] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12318), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7719), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204145] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12320), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7720), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204176] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12322), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7721), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204207] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12324), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7722), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204238] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12326), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7723), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204269] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9825), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7724), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204300] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12328), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7725), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204331] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12330), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7726), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204362] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12332), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7727), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204393] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12334), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7728), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204424] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12334), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7729), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204455] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12336), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7730), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204486] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12338), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7731), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204517] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12340), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7732), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204548] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12342), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7733), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204579] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12342), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7734), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204610] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12344), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7735), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204641] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12346), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7736), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204672] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12348), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7737), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204703] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12344), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7738), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204734] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12350), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7739), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204765] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12352), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7740), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204796] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12354), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7741), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204827] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12356), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7742), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204858] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12358), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7743), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204889] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12360), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7744), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204920] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12362), 1,
      anon_sym_struct,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7745), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204951] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12364), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7746), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204982] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12366), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7747), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205013] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12368), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7748), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205044] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12370), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7749), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205075] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12372), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7750), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205106] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12374), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7751), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205137] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12376), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7752), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205168] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12378), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7753), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205199] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12380), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7754), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205230] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12382), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7755), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205261] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9764), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7756), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205292] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12384), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7757), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205323] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12386), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7758), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205354] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12388), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7759), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205385] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12390), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7760), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205416] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9788), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7761), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205447] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12392), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7762), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205478] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12394), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7763), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205509] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12396), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7764), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205540] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12398), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7765), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205571] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12400), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7766), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205602] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12402), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7767), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205633] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12404), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7768), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205664] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12406), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7769), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205695] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12408), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7770), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205726] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12410), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7771), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205757] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12412), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7772), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205788] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12414), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7773), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205819] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12416), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7774), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205850] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12418), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7775), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205881] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12420), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7776), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205912] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12422), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7777), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205943] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12424), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7778), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205974] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12426), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7779), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206005] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12428), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7780), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206036] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12430), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7781), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206067] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12432), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7782), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206098] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9734), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7783), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206129] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12434), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7784), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206160] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12436), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7785), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206191] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12438), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7786), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206222] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12440), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7787), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206253] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9748), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7788), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206284] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12442), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7789), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206315] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12444), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7790), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206346] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12446), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7791), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206377] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12448), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7792), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206408] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12450), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7793), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206439] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12452), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7794), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206470] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12454), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7795), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206501] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12456), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7796), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206532] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12458), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7797), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206563] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12460), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7798), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206594] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12462), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7799), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206625] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12464), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7800), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206656] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12466), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7801), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206687] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12468), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7802), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206718] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12470), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7803), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206749] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12472), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7804), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206780] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12474), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7805), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206811] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12476), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7806), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206842] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12478), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7807), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206873] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12480), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7808), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206904] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12482), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7809), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206935] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12484), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7810), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206966] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12486), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7811), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206997] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12488), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7812), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207028] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9897), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7813), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207059] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12490), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7814), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207090] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12492), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7815), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207121] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12494), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7816), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207152] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12496), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7817), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207183] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12498), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7818), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207214] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12500), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7819), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207245] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12502), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7820), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207276] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12504), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7821), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207307] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12506), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7822), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207338] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12508), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7823), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207369] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12510), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7824), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207400] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12512), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7825), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207431] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12514), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7826), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207462] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12516), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7827), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207493] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12518), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7828), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207524] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(12520), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7829), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207555] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12522), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7830), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207586] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12524), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7831), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207617] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12526), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7832), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207648] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12528), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7833), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207679] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12530), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7834), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207710] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12532), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7835), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207741] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12534), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7836), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207772] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12536), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7837), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207803] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12538), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7838), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207834] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12540), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7839), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207865] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12542), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7840), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207896] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12544), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7841), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207927] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12546), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7842), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207958] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12548), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7843), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207989] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12550), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7844), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208020] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12552), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7845), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208051] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12554), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7846), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208082] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12556), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7847), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208113] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12558), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7848), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208144] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12560), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7849), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208175] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12562), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7850), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208206] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12564), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7851), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208237] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12566), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7852), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208268] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12568), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7853), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208299] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12570), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7854), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208330] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12572), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7855), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208361] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9728), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7856), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208392] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12574), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7857), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208423] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12576), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7858), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208454] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12578), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7859), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208485] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12580), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7860), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208516] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12582), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7861), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208547] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12584), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7862), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208578] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12586), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7863), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208609] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12588), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7864), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208640] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12590), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7865), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208671] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12592), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7866), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208702] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12594), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7867), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208733] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12596), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7868), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208764] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12598), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7869), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208795] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9732), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7870), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208826] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12600), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7871), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208857] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12602), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7872), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208888] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12604), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7873), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208919] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12606), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7874), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208950] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12608), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7875), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208981] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12610), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7876), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209012] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12612), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7877), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209043] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12614), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7878), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209074] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12616), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7879), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209105] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12618), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7880), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209136] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12620), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7881), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209167] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12622), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7882), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209198] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9863), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7883), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209229] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12624), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7884), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209260] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12626), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7885), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209291] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12628), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7886), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209322] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12630), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7887), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209353] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12632), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7888), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209384] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9855), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7889), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209415] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12634), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7890), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209446] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12636), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7891), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209477] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5858), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7892), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209508] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12638), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7893), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209539] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12640), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7894), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209570] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12642), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7895), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209601] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5866), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7896), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209632] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(3796), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7897), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209663] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12644), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7898), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209694] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12646), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7899), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209725] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12648), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7900), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209756] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12650), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7901), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209787] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(3600), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7902), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209818] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12652), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7903), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209849] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12654), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7904), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209880] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12656), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7905), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209911] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12658), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7906), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209942] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12660), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7907), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209973] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12662), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7908), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210004] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12664), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7909), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210035] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12666), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7910), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210066] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12668), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7911), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210097] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12670), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7912), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210128] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12672), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7913), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210159] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12674), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7914), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210190] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12676), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7915), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210221] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5828), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7916), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210252] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12678), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7917), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210283] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12680), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7918), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210314] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5936), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7919), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210345] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12682), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7920), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210376] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12684), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7921), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210407] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5842), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7922), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210438] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12686), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7923), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210469] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12688), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7924), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210500] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12690), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7925), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210531] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5903), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7926), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210562] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12692), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7927), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210593] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5824), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7928), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210624] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4173), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7929), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210655] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7930), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210686] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12694), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7931), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210717] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12696), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7932), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210748] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12698), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7933), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210779] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12700), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7934), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210810] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7935), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210841] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5878), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7936), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210872] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5886), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7937), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210903] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2413), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7938), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210934] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12704), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7939), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210965] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12706), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7940), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210996] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12708), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7941), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211027] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12710), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7942), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211058] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5911), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7943), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211089] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5911), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7944), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211120] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5854), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7945), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211151] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3440), 1,
      anon_sym_then,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7946), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211182] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12712), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7947), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211213] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12714), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7948), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211244] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12716), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7949), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211275] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12718), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7950), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211306] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5562), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7951), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211337] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12720), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7952), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211368] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12722), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7953), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211399] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12724), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7954), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211430] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10744), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7955), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211461] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12726), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7956), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211492] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12728), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7957), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211523] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12730), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7958), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211554] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7959), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211585] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12734), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7960), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211616] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12736), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7961), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211647] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12738), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7962), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211678] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9879), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7963), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211709] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12740), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7964), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211740] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12742), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7965), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211771] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12744), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7966), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211802] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12746), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7967), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211833] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12748), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7968), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211864] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12750), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7969), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211895] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12752), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7970), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211926] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5755), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7971), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211957] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12754), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7972), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211988] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12756), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7973), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212019] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(3703), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7974), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212050] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12758), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7975), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212081] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12760), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7976), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212112] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12762), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7977), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212143] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12764), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7978), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212174] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12766), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7979), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212205] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12768), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7980), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212236] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(3440), 1,
      anon_sym_RPAREN,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7981), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212267] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12770), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7982), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212298] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12772), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7983), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212329] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12774), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7984), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212360] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12776), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7985), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212391] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12778), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7986), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212422] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12780), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7987), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212453] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12782), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7988), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212484] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12784), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7989), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212515] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12786), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7990), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212546] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12788), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7991), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212577] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12790), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7992), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212608] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5751), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7993), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212639] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12792), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7994), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212670] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12794), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7995), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212701] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(3644), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7996), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212732] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12796), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7997), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212763] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12798), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7998), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212794] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12800), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7999), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212825] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10742), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8000), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212856] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12802), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8001), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212887] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12804), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8002), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212918] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12806), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8003), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212949] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12808), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8004), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212980] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12810), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8005), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213011] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12812), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8006), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213042] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12814), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8007), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213073] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12816), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8008), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213104] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12816), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8009), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213135] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12818), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8010), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213166] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12820), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8011), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213197] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12822), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8012), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213228] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12824), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8013), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213259] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12826), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8014), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213290] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12828), 1,
      anon_sym_struct,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8015), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213321] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12830), 1,
      anon_sym_unit,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8016), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213352] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12832), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8017), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213383] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12834), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8018), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213414] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12836), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8019), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213445] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12838), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8020), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213476] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12840), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8021), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213507] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12840), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8022), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213538] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12842), 1,
      anon_sym_get,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8023), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213569] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12844), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8024), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213600] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12842), 1,
      anon_sym_set,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8025), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213631] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12846), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8026), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213662] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9913), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8027), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213693] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12848), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8028), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213724] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12850), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8029), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213755] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12852), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8030), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213786] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12854), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8031), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213817] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12856), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8032), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213848] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12858), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8033), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213879] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12860), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8034), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213910] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12862), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8035), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213941] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12864), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8036), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213972] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12866), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8037), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214003] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12868), 1,
      anon_sym_member,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8038), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214034] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12870), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8039), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214065] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12872), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8040), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214096] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12874), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8041), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214127] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12876), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8042), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214158] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12878), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8043), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214189] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12880), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8044), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214220] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12882), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8045), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214251] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12884), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8046), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214282] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12886), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8047), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214313] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12888), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8048), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214344] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12890), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8049), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214375] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12892), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8050), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214406] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12894), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8051), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214437] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12896), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8052), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214468] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12898), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8053), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214499] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12900), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8054), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214530] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9899), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8055), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214561] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12902), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8056), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214592] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12904), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8057), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214623] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12906), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8058), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214654] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12908), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8059), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214685] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12910), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8060), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214716] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7344), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8061), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214747] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12912), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8062), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214778] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12914), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8063), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214809] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12916), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8064), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214840] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12918), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8065), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214871] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12920), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8066), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214902] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12922), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8067), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214933] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12924), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8068), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214964] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12926), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8069), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214995] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12928), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8070), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215026] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12930), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8071), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215057] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12932), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8072), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215088] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12934), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8073), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215119] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12936), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8074), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215150] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10156), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8075), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215181] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12938), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8076), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215212] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12940), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8077), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215243] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12942), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8078), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215274] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12944), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8079), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215305] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12946), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8080), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215336] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12948), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8081), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215367] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12950), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8082), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215398] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12952), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8083), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215429] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12954), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8084), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215460] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12956), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8085), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215491] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12958), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8086), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215522] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12960), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8087), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215553] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12962), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8088), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215584] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9893), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8089), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215615] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12964), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8090), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215646] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12966), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8091), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215677] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12968), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8092), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215708] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12970), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8093), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215739] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12972), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8094), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215770] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12974), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8095), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215801] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12976), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8096), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215832] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12978), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8097), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215863] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12980), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8098), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215894] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12982), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8099), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215925] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10728), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8100), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215956] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12984), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8101), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215987] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12986), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8102), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216018] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12988), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8103), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216049] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(1670), 1,
      anon_sym_POUNDendif,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8104), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216080] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12990), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8105), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216111] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12992), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8106), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216142] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12994), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8107), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216173] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12996), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8108), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216204] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12998), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8109), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216235] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13000), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8110), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216266] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13002), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8111), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216297] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13004), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8112), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216328] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13006), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8113), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216359] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13008), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8114), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216390] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13010), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8115), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216421] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13012), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8116), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216452] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13014), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8117), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216483] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13016), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8118), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216514] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13018), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8119), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216545] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13020), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8120), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216576] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13022), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8121), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216607] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13024), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8122), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216638] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13026), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8123), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216669] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13028), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8124), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216700] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13030), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8125), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216731] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13032), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8126), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216762] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13034), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8127), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216793] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13036), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8128), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216824] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13038), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8129), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216855] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10242), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8130), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216886] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13040), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8131), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216917] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13042), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8132), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216948] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9865), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8133), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216979] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13044), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8134), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217010] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13046), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8135), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217041] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13048), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8136), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217072] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13050), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8137), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217103] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13052), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8138), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217134] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13054), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8139), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217165] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13056), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8140), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217196] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13058), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8141), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217227] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13060), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8142), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217258] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13062), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8143), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217289] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13064), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8144), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217320] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13066), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8145), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217351] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13068), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8146), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217382] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5639), 1,
      anon_sym_EQ,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8147), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217413] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13070), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8148), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217444] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13072), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8149), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217475] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13074), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8150), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217506] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13076), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8151), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217537] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13078), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8152), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217568] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13080), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8153), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217599] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13082), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8154), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217630] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13084), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8155), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217661] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13086), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8156), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217692] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13088), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8157), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217723] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13090), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8158), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217754] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13092), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8159), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217785] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13094), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8160), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217816] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13096), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8161), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217847] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13098), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8162), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217878] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13100), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8163), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217909] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13102), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8164), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217940] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13104), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8165), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217971] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13106), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8166), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218002] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13108), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8167), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218033] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13110), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8168), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218064] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13112), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8169), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218095] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13114), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8170), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218126] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13116), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8171), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218157] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13118), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8172), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218188] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13120), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8173), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218219] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13122), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8174), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218250] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13124), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8175), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218281] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13126), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8176), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218312] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13128), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8177), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218343] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13130), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8178), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218374] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13132), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8179), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218405] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13134), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8180), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218436] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13136), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8181), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218467] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13138), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8182), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218498] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13140), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8183), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218529] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13142), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8184), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218560] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13144), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8185), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218591] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13146), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8186), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218622] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13148), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8187), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218653] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13150), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8188), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218684] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9833), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8189), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218715] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13152), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8190), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218746] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13154), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8191), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218777] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13156), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8192), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218808] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13158), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8193), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218839] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13160), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8194), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218870] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10517), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8195), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218901] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13162), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8196), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218932] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13164), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8197), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218963] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13166), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8198), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218994] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13168), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8199), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219025] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13170), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8200), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219056] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13172), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8201), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219087] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13174), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8202), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219118] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13176), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8203), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219149] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13178), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8204), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219180] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13180), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8205), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219211] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13182), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8206), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219242] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9823), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8207), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219273] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13184), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8208), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219304] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13186), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8209), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219335] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13188), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8210), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219366] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13190), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8211), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219397] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13192), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8212), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219428] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13194), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8213), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219459] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13196), 1,
      anon_sym_of,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8214), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219490] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13198), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8215), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219521] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13200), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8216), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219552] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13202), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8217), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219583] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9782), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8218), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219614] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13204), 1,
      anon_sym_unit,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8219), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219645] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13206), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8220), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219676] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5667), 1,
      anon_sym_EQ,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8221), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219707] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5603), 1,
      anon_sym_EQ,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8222), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219738] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13208), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8223), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219769] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13210), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8224), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219800] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13212), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8225), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219831] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13214), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8226), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219862] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13216), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8227), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219893] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13218), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8228), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219924] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13220), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8229), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219955] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13222), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8230), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219986] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13224), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8231), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220017] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13226), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8232), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220048] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13228), 1,
      anon_sym_POUNDendif,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8233), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220079] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13230), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8234), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220110] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13232), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8235), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220141] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13234), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8236), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220172] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13236), 1,
      anon_sym_unit,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8237), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220203] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13238), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8238), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220234] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13240), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8239), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220265] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13242), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8240), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220296] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13244), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8241), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220327] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13246), 1,
      anon_sym_PIPE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8242), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220358] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13248), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8243), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220389] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13250), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8244), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220420] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13252), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8245), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220451] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13254), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8246), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220482] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13256), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8247), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220513] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13258), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8248), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220544] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13260), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8249), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220575] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13262), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8250), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220606] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13264), 1,
      anon_sym_do,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8251), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220637] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13266), 1,
      anon_sym_unit,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8252), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220668] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13268), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8253), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220699] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13270), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8254), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220730] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13272), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8255), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220761] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13274), 1,
      anon_sym_RBRACE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8256), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220792] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13276), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8257), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220823] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13278), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8258), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220854] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13280), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8259), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220885] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13282), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8260), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220916] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13284), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8261), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220947] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13286), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8262), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220978] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13288), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8263), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221009] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13290), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8264), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221040] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9804), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8265), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221071] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10684), 1,
      anon_sym_new,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8266), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221102] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13292), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8267), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221133] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13294), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8268), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221164] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13296), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8269), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221195] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13298), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8270), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221226] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13300), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8271), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221257] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13302), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8272), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221288] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8273), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221319] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13306), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8274), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221350] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8275), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221381] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13310), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8276), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221412] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13312), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8277), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221443] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13314), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8278), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221474] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13316), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8279), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221505] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13318), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8280), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221536] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13320), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8281), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221567] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13322), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8282), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221598] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13324), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8283), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221629] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13326), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8284), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221660] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13328), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8285), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221691] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13330), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8286), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221722] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13332), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8287), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221753] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13334), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8288), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221784] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13336), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8289), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221815] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13338), 1,
      sym_block_comment_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8290), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221846] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13340), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8291), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221877] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13342), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8292), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221908] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13344), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8293), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221939] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13346), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8294), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221970] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5665), 1,
      anon_sym_EQ,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8295), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222001] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13348), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8296), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222032] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13350), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8297), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222063] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13352), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8298), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222094] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9790), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8299), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222125] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13354), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8300), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222156] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13356), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8301), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222187] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13358), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8302), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222218] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13360), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8303), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222249] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13362), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8304), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222280] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13364), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8305), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222311] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13366), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8306), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222342] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13368), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8307), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222373] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(4483), 1,
      anon_sym_EQ2,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8308), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222404] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13370), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8309), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222435] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13372), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8310), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222466] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13374), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8311), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222497] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13376), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8312), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222528] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13378), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8313), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222559] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13380), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8314), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222590] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(864), 1,
      sym__dedent,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8315), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222621] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13382), 1,
      sym__dedent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8316), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222652] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13384), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8317), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222683] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13386), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8318), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222714] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13388), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8319), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222745] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13390), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8320), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222776] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13392), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8321), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222807] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13394), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8322), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222838] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13396), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8323), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222869] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13398), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8324), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222900] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13400), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8325), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222931] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13402), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8326), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222962] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13404), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8327), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222993] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13406), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8328), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223024] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13408), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8329), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223055] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13410), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8330), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223086] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13412), 1,
      anon_sym_LT2,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8331), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223117] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13414), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8332), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223148] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13416), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8333), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223179] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13418), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8334), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223210] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13420), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8335), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223241] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13422), 1,
      anon_sym_and,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8336), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223272] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13424), 1,
      anon_sym_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8337), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223303] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13426), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8338), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223334] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13428), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8339), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223365] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13430), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8340), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223396] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13432), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8341), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223427] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13434), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8342), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223458] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13436), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8343), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223489] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13438), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8344), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223520] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13440), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8345), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223551] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13442), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8346), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223582] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13444), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8347), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223613] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13446), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8348), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223644] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13448), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8349), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223675] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13450), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8350), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223706] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13452), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8351), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223737] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13454), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8352), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223768] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13456), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8353), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223799] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13458), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8354), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223830] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13460), 1,
      anon_sym_DASH_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8355), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223861] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13462), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8356), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223892] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13464), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8357), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223923] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13466), 1,
      anon_sym_RBRACK,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8358), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223954] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13468), 1,
      aux_sym_xml_doc_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8359), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223985] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13470), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8360), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224016] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13472), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8361), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224047] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13474), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8362), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224078] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13476), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8363), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224109] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8364), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224140] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13480), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8365), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224171] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13482), 1,
      anon_sym_COLON,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8366), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224202] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13484), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8367), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224233] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9738), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8368), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224264] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13486), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8369), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224295] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(8200), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(8202), 1,
      anon_sym_POUNDr,
    ACTIONS(13488), 1,
      aux_sym_compiler_directive_decl_token1,
    ACTIONS(8204), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8370), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224326] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13490), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8371), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224357] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13492), 1,
      anon_sym_STAR_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8372), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224388] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9756), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8373), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224419] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13494), 1,
      anon_sym_then,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8374), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224450] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(2235), 1,
      ts_builtin_sym_end,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8375), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224481] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13496), 1,
      sym_int,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8376), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224512] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13498), 1,
      ts_builtin_sym_end,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8377), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224543] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13500), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8378), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224574] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13502), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8379), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224605] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13504), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8380), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224636] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13506), 1,
      sym__triple_quoted_content,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8381), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224667] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13508), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8382), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224698] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13510), 1,
      sym_identifier,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8383), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224729] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13512), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8384), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224760] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13514), 1,
      anon_sym_GT,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8385), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224791] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13516), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8386), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224822] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13518), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8387), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224853] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13520), 1,
      sym__indent,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8388), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224884] = 8,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(113), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5812), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13522), 1,
      anon_sym_EQ,
    ACTIONS(13), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(8389), 6,
      sym_xml_doc,
      sym_block_comment,
      sym_line_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224915] = 1,
    ACTIONS(13524), 1,
      ts_builtin_sym_end,
  [224919] = 1,
    ACTIONS(13526), 1,
      ts_builtin_sym_end,
  [224923] = 1,
    ACTIONS(13528), 1,
      ts_builtin_sym_end,
  [224927] = 1,
    ACTIONS(13530), 1,
      ts_builtin_sym_end,
  [224931] = 1,
    ACTIONS(5936), 1,
      ts_builtin_sym_end,
  [224935] = 1,
    ACTIONS(13532), 1,
      ts_builtin_sym_end,
  [224939] = 1,
    ACTIONS(13534), 1,
      ts_builtin_sym_end,
  [224943] = 1,
    ACTIONS(13536), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3542)] = 0,
  [SMALL_STATE(3543)] = 131,
  [SMALL_STATE(3544)] = 262,
  [SMALL_STATE(3545)] = 386,
  [SMALL_STATE(3546)] = 512,
  [SMALL_STATE(3547)] = 637,
  [SMALL_STATE(3548)] = 762,
  [SMALL_STATE(3549)] = 887,
  [SMALL_STATE(3550)] = 1012,
  [SMALL_STATE(3551)] = 1137,
  [SMALL_STATE(3552)] = 1262,
  [SMALL_STATE(3553)] = 1387,
  [SMALL_STATE(3554)] = 1512,
  [SMALL_STATE(3555)] = 1637,
  [SMALL_STATE(3556)] = 1762,
  [SMALL_STATE(3557)] = 1887,
  [SMALL_STATE(3558)] = 2010,
  [SMALL_STATE(3559)] = 2135,
  [SMALL_STATE(3560)] = 2260,
  [SMALL_STATE(3561)] = 2385,
  [SMALL_STATE(3562)] = 2510,
  [SMALL_STATE(3563)] = 2635,
  [SMALL_STATE(3564)] = 2760,
  [SMALL_STATE(3565)] = 2867,
  [SMALL_STATE(3566)] = 2972,
  [SMALL_STATE(3567)] = 3077,
  [SMALL_STATE(3568)] = 3178,
  [SMALL_STATE(3569)] = 3282,
  [SMALL_STATE(3570)] = 3381,
  [SMALL_STATE(3571)] = 3480,
  [SMALL_STATE(3572)] = 3578,
  [SMALL_STATE(3573)] = 3678,
  [SMALL_STATE(3574)] = 3769,
  [SMALL_STATE(3575)] = 3841,
  [SMALL_STATE(3576)] = 3927,
  [SMALL_STATE(3577)] = 4013,
  [SMALL_STATE(3578)] = 4087,
  [SMALL_STATE(3579)] = 4173,
  [SMALL_STATE(3580)] = 4259,
  [SMALL_STATE(3581)] = 4345,
  [SMALL_STATE(3582)] = 4431,
  [SMALL_STATE(3583)] = 4505,
  [SMALL_STATE(3584)] = 4589,
  [SMALL_STATE(3585)] = 4663,
  [SMALL_STATE(3586)] = 4757,
  [SMALL_STATE(3587)] = 4841,
  [SMALL_STATE(3588)] = 4915,
  [SMALL_STATE(3589)] = 4987,
  [SMALL_STATE(3590)] = 5073,
  [SMALL_STATE(3591)] = 5159,
  [SMALL_STATE(3592)] = 5228,
  [SMALL_STATE(3593)] = 5301,
  [SMALL_STATE(3594)] = 5372,
  [SMALL_STATE(3595)] = 5441,
  [SMALL_STATE(3596)] = 5512,
  [SMALL_STATE(3597)] = 5597,
  [SMALL_STATE(3598)] = 5666,
  [SMALL_STATE(3599)] = 5735,
  [SMALL_STATE(3600)] = 5808,
  [SMALL_STATE(3601)] = 5881,
  [SMALL_STATE(3602)] = 5954,
  [SMALL_STATE(3603)] = 6024,
  [SMALL_STATE(3604)] = 6092,
  [SMALL_STATE(3605)] = 6164,
  [SMALL_STATE(3606)] = 6234,
  [SMALL_STATE(3607)] = 6306,
  [SMALL_STATE(3608)] = 6374,
  [SMALL_STATE(3609)] = 6442,
  [SMALL_STATE(3610)] = 6512,
  [SMALL_STATE(3611)] = 6582,
  [SMALL_STATE(3612)] = 6652,
  [SMALL_STATE(3613)] = 6746,
  [SMALL_STATE(3614)] = 6814,
  [SMALL_STATE(3615)] = 6881,
  [SMALL_STATE(3616)] = 6972,
  [SMALL_STATE(3617)] = 7055,
  [SMALL_STATE(3618)] = 7122,
  [SMALL_STATE(3619)] = 7247,
  [SMALL_STATE(3620)] = 7314,
  [SMALL_STATE(3621)] = 7381,
  [SMALL_STATE(3622)] = 7506,
  [SMALL_STATE(3623)] = 7575,
  [SMALL_STATE(3624)] = 7642,
  [SMALL_STATE(3625)] = 7713,
  [SMALL_STATE(3626)] = 7780,
  [SMALL_STATE(3627)] = 7847,
  [SMALL_STATE(3628)] = 7914,
  [SMALL_STATE(3629)] = 8039,
  [SMALL_STATE(3630)] = 8106,
  [SMALL_STATE(3631)] = 8177,
  [SMALL_STATE(3632)] = 8260,
  [SMALL_STATE(3633)] = 8343,
  [SMALL_STATE(3634)] = 8412,
  [SMALL_STATE(3635)] = 8537,
  [SMALL_STATE(3636)] = 8604,
  [SMALL_STATE(3637)] = 8671,
  [SMALL_STATE(3638)] = 8738,
  [SMALL_STATE(3639)] = 8805,
  [SMALL_STATE(3640)] = 8876,
  [SMALL_STATE(3641)] = 8943,
  [SMALL_STATE(3642)] = 9010,
  [SMALL_STATE(3643)] = 9079,
  [SMALL_STATE(3644)] = 9146,
  [SMALL_STATE(3645)] = 9271,
  [SMALL_STATE(3646)] = 9338,
  [SMALL_STATE(3647)] = 9421,
  [SMALL_STATE(3648)] = 9490,
  [SMALL_STATE(3649)] = 9615,
  [SMALL_STATE(3650)] = 9682,
  [SMALL_STATE(3651)] = 9751,
  [SMALL_STATE(3652)] = 9818,
  [SMALL_STATE(3653)] = 9885,
  [SMALL_STATE(3654)] = 9956,
  [SMALL_STATE(3655)] = 10023,
  [SMALL_STATE(3656)] = 10090,
  [SMALL_STATE(3657)] = 10161,
  [SMALL_STATE(3658)] = 10227,
  [SMALL_STATE(3659)] = 10293,
  [SMALL_STATE(3660)] = 10375,
  [SMALL_STATE(3661)] = 10457,
  [SMALL_STATE(3662)] = 10523,
  [SMALL_STATE(3663)] = 10591,
  [SMALL_STATE(3664)] = 10659,
  [SMALL_STATE(3665)] = 10745,
  [SMALL_STATE(3666)] = 10813,
  [SMALL_STATE(3667)] = 10931,
  [SMALL_STATE(3668)] = 11025,
  [SMALL_STATE(3669)] = 11093,
  [SMALL_STATE(3670)] = 11163,
  [SMALL_STATE(3671)] = 11245,
  [SMALL_STATE(3672)] = 11313,
  [SMALL_STATE(3673)] = 11383,
  [SMALL_STATE(3674)] = 11453,
  [SMALL_STATE(3675)] = 11523,
  [SMALL_STATE(3676)] = 11605,
  [SMALL_STATE(3677)] = 11673,
  [SMALL_STATE(3678)] = 11738,
  [SMALL_STATE(3679)] = 11803,
  [SMALL_STATE(3680)] = 11884,
  [SMALL_STATE(3681)] = 11949,
  [SMALL_STATE(3682)] = 12014,
  [SMALL_STATE(3683)] = 12079,
  [SMALL_STATE(3684)] = 12148,
  [SMALL_STATE(3685)] = 12215,
  [SMALL_STATE(3686)] = 12282,
  [SMALL_STATE(3687)] = 12351,
  [SMALL_STATE(3688)] = 12416,
  [SMALL_STATE(3689)] = 12499,
  [SMALL_STATE(3690)] = 12564,
  [SMALL_STATE(3691)] = 12681,
  [SMALL_STATE(3692)] = 12750,
  [SMALL_STATE(3693)] = 12815,
  [SMALL_STATE(3694)] = 12884,
  [SMALL_STATE(3695)] = 12949,
  [SMALL_STATE(3696)] = 13016,
  [SMALL_STATE(3697)] = 13081,
  [SMALL_STATE(3698)] = 13150,
  [SMALL_STATE(3699)] = 13229,
  [SMALL_STATE(3700)] = 13308,
  [SMALL_STATE(3701)] = 13373,
  [SMALL_STATE(3702)] = 13438,
  [SMALL_STATE(3703)] = 13503,
  [SMALL_STATE(3704)] = 13568,
  [SMALL_STATE(3705)] = 13635,
  [SMALL_STATE(3706)] = 13700,
  [SMALL_STATE(3707)] = 13765,
  [SMALL_STATE(3708)] = 13830,
  [SMALL_STATE(3709)] = 13897,
  [SMALL_STATE(3710)] = 14016,
  [SMALL_STATE(3711)] = 14081,
  [SMALL_STATE(3712)] = 14146,
  [SMALL_STATE(3713)] = 14213,
  [SMALL_STATE(3714)] = 14278,
  [SMALL_STATE(3715)] = 14343,
  [SMALL_STATE(3716)] = 14410,
  [SMALL_STATE(3717)] = 14479,
  [SMALL_STATE(3718)] = 14544,
  [SMALL_STATE(3719)] = 14609,
  [SMALL_STATE(3720)] = 14674,
  [SMALL_STATE(3721)] = 14739,
  [SMALL_STATE(3722)] = 14808,
  [SMALL_STATE(3723)] = 14873,
  [SMALL_STATE(3724)] = 14938,
  [SMALL_STATE(3725)] = 15003,
  [SMALL_STATE(3726)] = 15068,
  [SMALL_STATE(3727)] = 15137,
  [SMALL_STATE(3728)] = 15202,
  [SMALL_STATE(3729)] = 15269,
  [SMALL_STATE(3730)] = 15338,
  [SMALL_STATE(3731)] = 15403,
  [SMALL_STATE(3732)] = 15468,
  [SMALL_STATE(3733)] = 15533,
  [SMALL_STATE(3734)] = 15598,
  [SMALL_STATE(3735)] = 15663,
  [SMALL_STATE(3736)] = 15728,
  [SMALL_STATE(3737)] = 15793,
  [SMALL_STATE(3738)] = 15858,
  [SMALL_STATE(3739)] = 15923,
  [SMALL_STATE(3740)] = 16042,
  [SMALL_STATE(3741)] = 16107,
  [SMALL_STATE(3742)] = 16176,
  [SMALL_STATE(3743)] = 16245,
  [SMALL_STATE(3744)] = 16312,
  [SMALL_STATE(3745)] = 16377,
  [SMALL_STATE(3746)] = 16442,
  [SMALL_STATE(3747)] = 16507,
  [SMALL_STATE(3748)] = 16572,
  [SMALL_STATE(3749)] = 16637,
  [SMALL_STATE(3750)] = 16702,
  [SMALL_STATE(3751)] = 16766,
  [SMALL_STATE(3752)] = 16836,
  [SMALL_STATE(3753)] = 16900,
  [SMALL_STATE(3754)] = 16966,
  [SMALL_STATE(3755)] = 17030,
  [SMALL_STATE(3756)] = 17100,
  [SMALL_STATE(3757)] = 17164,
  [SMALL_STATE(3758)] = 17230,
  [SMALL_STATE(3759)] = 17296,
  [SMALL_STATE(3760)] = 17364,
  [SMALL_STATE(3761)] = 17430,
  [SMALL_STATE(3762)] = 17498,
  [SMALL_STATE(3763)] = 17562,
  [SMALL_STATE(3764)] = 17628,
  [SMALL_STATE(3765)] = 17694,
  [SMALL_STATE(3766)] = 17764,
  [SMALL_STATE(3767)] = 17832,
  [SMALL_STATE(3768)] = 17896,
  [SMALL_STATE(3769)] = 17984,
  [SMALL_STATE(3770)] = 18050,
  [SMALL_STATE(3771)] = 18114,
  [SMALL_STATE(3772)] = 18202,
  [SMALL_STATE(3773)] = 18266,
  [SMALL_STATE(3774)] = 18354,
  [SMALL_STATE(3775)] = 18420,
  [SMALL_STATE(3776)] = 18490,
  [SMALL_STATE(3777)] = 18560,
  [SMALL_STATE(3778)] = 18648,
  [SMALL_STATE(3779)] = 18718,
  [SMALL_STATE(3780)] = 18782,
  [SMALL_STATE(3781)] = 18846,
  [SMALL_STATE(3782)] = 18916,
  [SMALL_STATE(3783)] = 18992,
  [SMALL_STATE(3784)] = 19060,
  [SMALL_STATE(3785)] = 19130,
  [SMALL_STATE(3786)] = 19198,
  [SMALL_STATE(3787)] = 19262,
  [SMALL_STATE(3788)] = 19338,
  [SMALL_STATE(3789)] = 19408,
  [SMALL_STATE(3790)] = 19472,
  [SMALL_STATE(3791)] = 19536,
  [SMALL_STATE(3792)] = 19600,
  [SMALL_STATE(3793)] = 19688,
  [SMALL_STATE(3794)] = 19756,
  [SMALL_STATE(3795)] = 19826,
  [SMALL_STATE(3796)] = 19890,
  [SMALL_STATE(3797)] = 19960,
  [SMALL_STATE(3798)] = 20028,
  [SMALL_STATE(3799)] = 20094,
  [SMALL_STATE(3800)] = 20164,
  [SMALL_STATE(3801)] = 20230,
  [SMALL_STATE(3802)] = 20294,
  [SMALL_STATE(3803)] = 20358,
  [SMALL_STATE(3804)] = 20428,
  [SMALL_STATE(3805)] = 20516,
  [SMALL_STATE(3806)] = 20579,
  [SMALL_STATE(3807)] = 20642,
  [SMALL_STATE(3808)] = 20705,
  [SMALL_STATE(3809)] = 20768,
  [SMALL_STATE(3810)] = 20835,
  [SMALL_STATE(3811)] = 20898,
  [SMALL_STATE(3812)] = 20963,
  [SMALL_STATE(3813)] = 21026,
  [SMALL_STATE(3814)] = 21093,
  [SMALL_STATE(3815)] = 21156,
  [SMALL_STATE(3816)] = 21223,
  [SMALL_STATE(3817)] = 21290,
  [SMALL_STATE(3818)] = 21353,
  [SMALL_STATE(3819)] = 21416,
  [SMALL_STATE(3820)] = 21483,
  [SMALL_STATE(3821)] = 21546,
  [SMALL_STATE(3822)] = 21609,
  [SMALL_STATE(3823)] = 21672,
  [SMALL_STATE(3824)] = 21735,
  [SMALL_STATE(3825)] = 21798,
  [SMALL_STATE(3826)] = 21861,
  [SMALL_STATE(3827)] = 21924,
  [SMALL_STATE(3828)] = 21987,
  [SMALL_STATE(3829)] = 22050,
  [SMALL_STATE(3830)] = 22113,
  [SMALL_STATE(3831)] = 22176,
  [SMALL_STATE(3832)] = 22239,
  [SMALL_STATE(3833)] = 22352,
  [SMALL_STATE(3834)] = 22415,
  [SMALL_STATE(3835)] = 22482,
  [SMALL_STATE(3836)] = 22545,
  [SMALL_STATE(3837)] = 22608,
  [SMALL_STATE(3838)] = 22671,
  [SMALL_STATE(3839)] = 22734,
  [SMALL_STATE(3840)] = 22797,
  [SMALL_STATE(3841)] = 22860,
  [SMALL_STATE(3842)] = 22937,
  [SMALL_STATE(3843)] = 23004,
  [SMALL_STATE(3844)] = 23067,
  [SMALL_STATE(3845)] = 23130,
  [SMALL_STATE(3846)] = 23193,
  [SMALL_STATE(3847)] = 23256,
  [SMALL_STATE(3848)] = 23319,
  [SMALL_STATE(3849)] = 23382,
  [SMALL_STATE(3850)] = 23445,
  [SMALL_STATE(3851)] = 23508,
  [SMALL_STATE(3852)] = 23571,
  [SMALL_STATE(3853)] = 23634,
  [SMALL_STATE(3854)] = 23697,
  [SMALL_STATE(3855)] = 23760,
  [SMALL_STATE(3856)] = 23823,
  [SMALL_STATE(3857)] = 23886,
  [SMALL_STATE(3858)] = 23949,
  [SMALL_STATE(3859)] = 24012,
  [SMALL_STATE(3860)] = 24075,
  [SMALL_STATE(3861)] = 24138,
  [SMALL_STATE(3862)] = 24201,
  [SMALL_STATE(3863)] = 24264,
  [SMALL_STATE(3864)] = 24327,
  [SMALL_STATE(3865)] = 24390,
  [SMALL_STATE(3866)] = 24453,
  [SMALL_STATE(3867)] = 24516,
  [SMALL_STATE(3868)] = 24579,
  [SMALL_STATE(3869)] = 24642,
  [SMALL_STATE(3870)] = 24705,
  [SMALL_STATE(3871)] = 24768,
  [SMALL_STATE(3872)] = 24831,
  [SMALL_STATE(3873)] = 24894,
  [SMALL_STATE(3874)] = 24961,
  [SMALL_STATE(3875)] = 25024,
  [SMALL_STATE(3876)] = 25089,
  [SMALL_STATE(3877)] = 25152,
  [SMALL_STATE(3878)] = 25215,
  [SMALL_STATE(3879)] = 25278,
  [SMALL_STATE(3880)] = 25341,
  [SMALL_STATE(3881)] = 25404,
  [SMALL_STATE(3882)] = 25467,
  [SMALL_STATE(3883)] = 25530,
  [SMALL_STATE(3884)] = 25593,
  [SMALL_STATE(3885)] = 25656,
  [SMALL_STATE(3886)] = 25719,
  [SMALL_STATE(3887)] = 25784,
  [SMALL_STATE(3888)] = 25897,
  [SMALL_STATE(3889)] = 25964,
  [SMALL_STATE(3890)] = 26029,
  [SMALL_STATE(3891)] = 26092,
  [SMALL_STATE(3892)] = 26155,
  [SMALL_STATE(3893)] = 26218,
  [SMALL_STATE(3894)] = 26281,
  [SMALL_STATE(3895)] = 26394,
  [SMALL_STATE(3896)] = 26457,
  [SMALL_STATE(3897)] = 26520,
  [SMALL_STATE(3898)] = 26583,
  [SMALL_STATE(3899)] = 26646,
  [SMALL_STATE(3900)] = 26709,
  [SMALL_STATE(3901)] = 26822,
  [SMALL_STATE(3902)] = 26885,
  [SMALL_STATE(3903)] = 26948,
  [SMALL_STATE(3904)] = 27011,
  [SMALL_STATE(3905)] = 27074,
  [SMALL_STATE(3906)] = 27137,
  [SMALL_STATE(3907)] = 27200,
  [SMALL_STATE(3908)] = 27277,
  [SMALL_STATE(3909)] = 27340,
  [SMALL_STATE(3910)] = 27403,
  [SMALL_STATE(3911)] = 27466,
  [SMALL_STATE(3912)] = 27531,
  [SMALL_STATE(3913)] = 27596,
  [SMALL_STATE(3914)] = 27661,
  [SMALL_STATE(3915)] = 27724,
  [SMALL_STATE(3916)] = 27787,
  [SMALL_STATE(3917)] = 27854,
  [SMALL_STATE(3918)] = 27917,
  [SMALL_STATE(3919)] = 27980,
  [SMALL_STATE(3920)] = 28043,
  [SMALL_STATE(3921)] = 28106,
  [SMALL_STATE(3922)] = 28171,
  [SMALL_STATE(3923)] = 28234,
  [SMALL_STATE(3924)] = 28297,
  [SMALL_STATE(3925)] = 28407,
  [SMALL_STATE(3926)] = 28483,
  [SMALL_STATE(3927)] = 28545,
  [SMALL_STATE(3928)] = 28607,
  [SMALL_STATE(3929)] = 28669,
  [SMALL_STATE(3930)] = 28745,
  [SMALL_STATE(3931)] = 28807,
  [SMALL_STATE(3932)] = 28873,
  [SMALL_STATE(3933)] = 28939,
  [SMALL_STATE(3934)] = 29001,
  [SMALL_STATE(3935)] = 29063,
  [SMALL_STATE(3936)] = 29125,
  [SMALL_STATE(3937)] = 29189,
  [SMALL_STATE(3938)] = 29255,
  [SMALL_STATE(3939)] = 29321,
  [SMALL_STATE(3940)] = 29419,
  [SMALL_STATE(3941)] = 29529,
  [SMALL_STATE(3942)] = 29591,
  [SMALL_STATE(3943)] = 29689,
  [SMALL_STATE(3944)] = 29751,
  [SMALL_STATE(3945)] = 29813,
  [SMALL_STATE(3946)] = 29911,
  [SMALL_STATE(3947)] = 30009,
  [SMALL_STATE(3948)] = 30071,
  [SMALL_STATE(3949)] = 30137,
  [SMALL_STATE(3950)] = 30203,
  [SMALL_STATE(3951)] = 30265,
  [SMALL_STATE(3952)] = 30327,
  [SMALL_STATE(3953)] = 30425,
  [SMALL_STATE(3954)] = 30487,
  [SMALL_STATE(3955)] = 30549,
  [SMALL_STATE(3956)] = 30615,
  [SMALL_STATE(3957)] = 30677,
  [SMALL_STATE(3958)] = 30739,
  [SMALL_STATE(3959)] = 30801,
  [SMALL_STATE(3960)] = 30865,
  [SMALL_STATE(3961)] = 30927,
  [SMALL_STATE(3962)] = 30989,
  [SMALL_STATE(3963)] = 31051,
  [SMALL_STATE(3964)] = 31113,
  [SMALL_STATE(3965)] = 31211,
  [SMALL_STATE(3966)] = 31273,
  [SMALL_STATE(3967)] = 31349,
  [SMALL_STATE(3968)] = 31411,
  [SMALL_STATE(3969)] = 31473,
  [SMALL_STATE(3970)] = 31571,
  [SMALL_STATE(3971)] = 31669,
  [SMALL_STATE(3972)] = 31731,
  [SMALL_STATE(3973)] = 31793,
  [SMALL_STATE(3974)] = 31855,
  [SMALL_STATE(3975)] = 31917,
  [SMALL_STATE(3976)] = 32015,
  [SMALL_STATE(3977)] = 32113,
  [SMALL_STATE(3978)] = 32175,
  [SMALL_STATE(3979)] = 32273,
  [SMALL_STATE(3980)] = 32335,
  [SMALL_STATE(3981)] = 32397,
  [SMALL_STATE(3982)] = 32459,
  [SMALL_STATE(3983)] = 32521,
  [SMALL_STATE(3984)] = 32583,
  [SMALL_STATE(3985)] = 32645,
  [SMALL_STATE(3986)] = 32707,
  [SMALL_STATE(3987)] = 32769,
  [SMALL_STATE(3988)] = 32831,
  [SMALL_STATE(3989)] = 32893,
  [SMALL_STATE(3990)] = 32955,
  [SMALL_STATE(3991)] = 33017,
  [SMALL_STATE(3992)] = 33115,
  [SMALL_STATE(3993)] = 33213,
  [SMALL_STATE(3994)] = 33311,
  [SMALL_STATE(3995)] = 33373,
  [SMALL_STATE(3996)] = 33435,
  [SMALL_STATE(3997)] = 33497,
  [SMALL_STATE(3998)] = 33559,
  [SMALL_STATE(3999)] = 33621,
  [SMALL_STATE(4000)] = 33731,
  [SMALL_STATE(4001)] = 33793,
  [SMALL_STATE(4002)] = 33855,
  [SMALL_STATE(4003)] = 33917,
  [SMALL_STATE(4004)] = 33979,
  [SMALL_STATE(4005)] = 34077,
  [SMALL_STATE(4006)] = 34139,
  [SMALL_STATE(4007)] = 34237,
  [SMALL_STATE(4008)] = 34299,
  [SMALL_STATE(4009)] = 34362,
  [SMALL_STATE(4010)] = 34457,
  [SMALL_STATE(4011)] = 34552,
  [SMALL_STATE(4012)] = 34647,
  [SMALL_STATE(4013)] = 34712,
  [SMALL_STATE(4014)] = 34807,
  [SMALL_STATE(4015)] = 34900,
  [SMALL_STATE(4016)] = 34965,
  [SMALL_STATE(4017)] = 35060,
  [SMALL_STATE(4018)] = 35123,
  [SMALL_STATE(4019)] = 35218,
  [SMALL_STATE(4020)] = 35313,
  [SMALL_STATE(4021)] = 35408,
  [SMALL_STATE(4022)] = 35472,
  [SMALL_STATE(4023)] = 35532,
  [SMALL_STATE(4024)] = 35596,
  [SMALL_STATE(4025)] = 35660,
  [SMALL_STATE(4026)] = 35722,
  [SMALL_STATE(4027)] = 35782,
  [SMALL_STATE(4028)] = 35844,
  [SMALL_STATE(4029)] = 35924,
  [SMALL_STATE(4030)] = 35984,
  [SMALL_STATE(4031)] = 36048,
  [SMALL_STATE(4032)] = 36111,
  [SMALL_STATE(4033)] = 36170,
  [SMALL_STATE(4034)] = 36229,
  [SMALL_STATE(4035)] = 36308,
  [SMALL_STATE(4036)] = 36383,
  [SMALL_STATE(4037)] = 36442,
  [SMALL_STATE(4038)] = 36515,
  [SMALL_STATE(4039)] = 36590,
  [SMALL_STATE(4040)] = 36665,
  [SMALL_STATE(4041)] = 36730,
  [SMALL_STATE(4042)] = 36793,
  [SMALL_STATE(4043)] = 36880,
  [SMALL_STATE(4044)] = 36939,
  [SMALL_STATE(4045)] = 37000,
  [SMALL_STATE(4046)] = 37059,
  [SMALL_STATE(4047)] = 37134,
  [SMALL_STATE(4048)] = 37193,
  [SMALL_STATE(4049)] = 37282,
  [SMALL_STATE(4050)] = 37343,
  [SMALL_STATE(4051)] = 37402,
  [SMALL_STATE(4052)] = 37465,
  [SMALL_STATE(4053)] = 37538,
  [SMALL_STATE(4054)] = 37597,
  [SMALL_STATE(4055)] = 37660,
  [SMALL_STATE(4056)] = 37723,
  [SMALL_STATE(4057)] = 37784,
  [SMALL_STATE(4058)] = 37847,
  [SMALL_STATE(4059)] = 37906,
  [SMALL_STATE(4060)] = 37967,
  [SMALL_STATE(4061)] = 38025,
  [SMALL_STATE(4062)] = 38099,
  [SMALL_STATE(4063)] = 38161,
  [SMALL_STATE(4064)] = 38223,
  [SMALL_STATE(4065)] = 38283,
  [SMALL_STATE(4066)] = 38343,
  [SMALL_STATE(4067)] = 38417,
  [SMALL_STATE(4068)] = 38491,
  [SMALL_STATE(4069)] = 38553,
  [SMALL_STATE(4070)] = 38627,
  [SMALL_STATE(4071)] = 38701,
  [SMALL_STATE(4072)] = 38763,
  [SMALL_STATE(4073)] = 38837,
  [SMALL_STATE(4074)] = 38897,
  [SMALL_STATE(4075)] = 38959,
  [SMALL_STATE(4076)] = 39031,
  [SMALL_STATE(4077)] = 39089,
  [SMALL_STATE(4078)] = 39149,
  [SMALL_STATE(4079)] = 39211,
  [SMALL_STATE(4080)] = 39271,
  [SMALL_STATE(4081)] = 39343,
  [SMALL_STATE(4082)] = 39415,
  [SMALL_STATE(4083)] = 39477,
  [SMALL_STATE(4084)] = 39537,
  [SMALL_STATE(4085)] = 39599,
  [SMALL_STATE(4086)] = 39661,
  [SMALL_STATE(4087)] = 39733,
  [SMALL_STATE(4088)] = 39795,
  [SMALL_STATE(4089)] = 39857,
  [SMALL_STATE(4090)] = 39915,
  [SMALL_STATE(4091)] = 39973,
  [SMALL_STATE(4092)] = 40031,
  [SMALL_STATE(4093)] = 40095,
  [SMALL_STATE(4094)] = 40157,
  [SMALL_STATE(4095)] = 40215,
  [SMALL_STATE(4096)] = 40289,
  [SMALL_STATE(4097)] = 40349,
  [SMALL_STATE(4098)] = 40423,
  [SMALL_STATE(4099)] = 40483,
  [SMALL_STATE(4100)] = 40541,
  [SMALL_STATE(4101)] = 40601,
  [SMALL_STATE(4102)] = 40673,
  [SMALL_STATE(4103)] = 40731,
  [SMALL_STATE(4104)] = 40803,
  [SMALL_STATE(4105)] = 40861,
  [SMALL_STATE(4106)] = 40921,
  [SMALL_STATE(4107)] = 40979,
  [SMALL_STATE(4108)] = 41053,
  [SMALL_STATE(4109)] = 41111,
  [SMALL_STATE(4110)] = 41169,
  [SMALL_STATE(4111)] = 41227,
  [SMALL_STATE(4112)] = 41289,
  [SMALL_STATE(4113)] = 41347,
  [SMALL_STATE(4114)] = 41405,
  [SMALL_STATE(4115)] = 41463,
  [SMALL_STATE(4116)] = 41535,
  [SMALL_STATE(4117)] = 41595,
  [SMALL_STATE(4118)] = 41653,
  [SMALL_STATE(4119)] = 41711,
  [SMALL_STATE(4120)] = 41769,
  [SMALL_STATE(4121)] = 41827,
  [SMALL_STATE(4122)] = 41885,
  [SMALL_STATE(4123)] = 41943,
  [SMALL_STATE(4124)] = 42005,
  [SMALL_STATE(4125)] = 42063,
  [SMALL_STATE(4126)] = 42121,
  [SMALL_STATE(4127)] = 42179,
  [SMALL_STATE(4128)] = 42241,
  [SMALL_STATE(4129)] = 42299,
  [SMALL_STATE(4130)] = 42361,
  [SMALL_STATE(4131)] = 42419,
  [SMALL_STATE(4132)] = 42481,
  [SMALL_STATE(4133)] = 42553,
  [SMALL_STATE(4134)] = 42615,
  [SMALL_STATE(4135)] = 42673,
  [SMALL_STATE(4136)] = 42735,
  [SMALL_STATE(4137)] = 42795,
  [SMALL_STATE(4138)] = 42853,
  [SMALL_STATE(4139)] = 42915,
  [SMALL_STATE(4140)] = 42973,
  [SMALL_STATE(4141)] = 43031,
  [SMALL_STATE(4142)] = 43089,
  [SMALL_STATE(4143)] = 43147,
  [SMALL_STATE(4144)] = 43205,
  [SMALL_STATE(4145)] = 43263,
  [SMALL_STATE(4146)] = 43321,
  [SMALL_STATE(4147)] = 43379,
  [SMALL_STATE(4148)] = 43437,
  [SMALL_STATE(4149)] = 43495,
  [SMALL_STATE(4150)] = 43553,
  [SMALL_STATE(4151)] = 43611,
  [SMALL_STATE(4152)] = 43669,
  [SMALL_STATE(4153)] = 43727,
  [SMALL_STATE(4154)] = 43785,
  [SMALL_STATE(4155)] = 43843,
  [SMALL_STATE(4156)] = 43901,
  [SMALL_STATE(4157)] = 43959,
  [SMALL_STATE(4158)] = 44017,
  [SMALL_STATE(4159)] = 44075,
  [SMALL_STATE(4160)] = 44133,
  [SMALL_STATE(4161)] = 44192,
  [SMALL_STATE(4162)] = 44277,
  [SMALL_STATE(4163)] = 44348,
  [SMALL_STATE(4164)] = 44449,
  [SMALL_STATE(4165)] = 44506,
  [SMALL_STATE(4166)] = 44607,
  [SMALL_STATE(4167)] = 44664,
  [SMALL_STATE(4168)] = 44723,
  [SMALL_STATE(4169)] = 44796,
  [SMALL_STATE(4170)] = 44853,
  [SMALL_STATE(4171)] = 44934,
  [SMALL_STATE(4172)] = 45007,
  [SMALL_STATE(4173)] = 45066,
  [SMALL_STATE(4174)] = 45167,
  [SMALL_STATE(4175)] = 45224,
  [SMALL_STATE(4176)] = 45281,
  [SMALL_STATE(4177)] = 45382,
  [SMALL_STATE(4178)] = 45443,
  [SMALL_STATE(4179)] = 45516,
  [SMALL_STATE(4180)] = 45577,
  [SMALL_STATE(4181)] = 45650,
  [SMALL_STATE(4182)] = 45723,
  [SMALL_STATE(4183)] = 45794,
  [SMALL_STATE(4184)] = 45855,
  [SMALL_STATE(4185)] = 45912,
  [SMALL_STATE(4186)] = 45982,
  [SMALL_STATE(4187)] = 46038,
  [SMALL_STATE(4188)] = 46098,
  [SMALL_STATE(4189)] = 46168,
  [SMALL_STATE(4190)] = 46224,
  [SMALL_STATE(4191)] = 46280,
  [SMALL_STATE(4192)] = 46364,
  [SMALL_STATE(4193)] = 46420,
  [SMALL_STATE(4194)] = 46478,
  [SMALL_STATE(4195)] = 46536,
  [SMALL_STATE(4196)] = 46592,
  [SMALL_STATE(4197)] = 46648,
  [SMALL_STATE(4198)] = 46708,
  [SMALL_STATE(4199)] = 46764,
  [SMALL_STATE(4200)] = 46822,
  [SMALL_STATE(4201)] = 46880,
  [SMALL_STATE(4202)] = 46936,
  [SMALL_STATE(4203)] = 46992,
  [SMALL_STATE(4204)] = 47048,
  [SMALL_STATE(4205)] = 47108,
  [SMALL_STATE(4206)] = 47164,
  [SMALL_STATE(4207)] = 47220,
  [SMALL_STATE(4208)] = 47275,
  [SMALL_STATE(4209)] = 47330,
  [SMALL_STATE(4210)] = 47425,
  [SMALL_STATE(4211)] = 47480,
  [SMALL_STATE(4212)] = 47537,
  [SMALL_STATE(4213)] = 47592,
  [SMALL_STATE(4214)] = 47687,
  [SMALL_STATE(4215)] = 47742,
  [SMALL_STATE(4216)] = 47797,
  [SMALL_STATE(4217)] = 47854,
  [SMALL_STATE(4218)] = 47909,
  [SMALL_STATE(4219)] = 47964,
  [SMALL_STATE(4220)] = 48019,
  [SMALL_STATE(4221)] = 48074,
  [SMALL_STATE(4222)] = 48157,
  [SMALL_STATE(4223)] = 48252,
  [SMALL_STATE(4224)] = 48347,
  [SMALL_STATE(4225)] = 48402,
  [SMALL_STATE(4226)] = 48497,
  [SMALL_STATE(4227)] = 48552,
  [SMALL_STATE(4228)] = 48607,
  [SMALL_STATE(4229)] = 48702,
  [SMALL_STATE(4230)] = 48771,
  [SMALL_STATE(4231)] = 48866,
  [SMALL_STATE(4232)] = 48921,
  [SMALL_STATE(4233)] = 49016,
  [SMALL_STATE(4234)] = 49090,
  [SMALL_STATE(4235)] = 49164,
  [SMALL_STATE(4236)] = 49244,
  [SMALL_STATE(4237)] = 49318,
  [SMALL_STATE(4238)] = 49392,
  [SMALL_STATE(4239)] = 49466,
  [SMALL_STATE(4240)] = 49520,
  [SMALL_STATE(4241)] = 49590,
  [SMALL_STATE(4242)] = 49660,
  [SMALL_STATE(4243)] = 49714,
  [SMALL_STATE(4244)] = 49768,
  [SMALL_STATE(4245)] = 49842,
  [SMALL_STATE(4246)] = 49896,
  [SMALL_STATE(4247)] = 49976,
  [SMALL_STATE(4248)] = 50050,
  [SMALL_STATE(4249)] = 50130,
  [SMALL_STATE(4250)] = 50210,
  [SMALL_STATE(4251)] = 50284,
  [SMALL_STATE(4252)] = 50358,
  [SMALL_STATE(4253)] = 50438,
  [SMALL_STATE(4254)] = 50512,
  [SMALL_STATE(4255)] = 50592,
  [SMALL_STATE(4256)] = 50672,
  [SMALL_STATE(4257)] = 50726,
  [SMALL_STATE(4258)] = 50796,
  [SMALL_STATE(4259)] = 50870,
  [SMALL_STATE(4260)] = 50944,
  [SMALL_STATE(4261)] = 51024,
  [SMALL_STATE(4262)] = 51104,
  [SMALL_STATE(4263)] = 51162,
  [SMALL_STATE(4264)] = 51218,
  [SMALL_STATE(4265)] = 51274,
  [SMALL_STATE(4266)] = 51354,
  [SMALL_STATE(4267)] = 51428,
  [SMALL_STATE(4268)] = 51508,
  [SMALL_STATE(4269)] = 51588,
  [SMALL_STATE(4270)] = 51646,
  [SMALL_STATE(4271)] = 51720,
  [SMALL_STATE(4272)] = 51800,
  [SMALL_STATE(4273)] = 51870,
  [SMALL_STATE(4274)] = 51944,
  [SMALL_STATE(4275)] = 52018,
  [SMALL_STATE(4276)] = 52074,
  [SMALL_STATE(4277)] = 52154,
  [SMALL_STATE(4278)] = 52234,
  [SMALL_STATE(4279)] = 52292,
  [SMALL_STATE(4280)] = 52350,
  [SMALL_STATE(4281)] = 52430,
  [SMALL_STATE(4282)] = 52488,
  [SMALL_STATE(4283)] = 52559,
  [SMALL_STATE(4284)] = 52628,
  [SMALL_STATE(4285)] = 52685,
  [SMALL_STATE(4286)] = 52740,
  [SMALL_STATE(4287)] = 52797,
  [SMALL_STATE(4288)] = 52866,
  [SMALL_STATE(4289)] = 52935,
  [SMALL_STATE(4290)] = 52994,
  [SMALL_STATE(4291)] = 53053,
  [SMALL_STATE(4292)] = 53110,
  [SMALL_STATE(4293)] = 53181,
  [SMALL_STATE(4294)] = 53238,
  [SMALL_STATE(4295)] = 53291,
  [SMALL_STATE(4296)] = 53346,
  [SMALL_STATE(4297)] = 53405,
  [SMALL_STATE(4298)] = 53462,
  [SMALL_STATE(4299)] = 53515,
  [SMALL_STATE(4300)] = 53584,
  [SMALL_STATE(4301)] = 53651,
  [SMALL_STATE(4302)] = 53718,
  [SMALL_STATE(4303)] = 53775,
  [SMALL_STATE(4304)] = 53844,
  [SMALL_STATE(4305)] = 53911,
  [SMALL_STATE(4306)] = 53966,
  [SMALL_STATE(4307)] = 54037,
  [SMALL_STATE(4308)] = 54106,
  [SMALL_STATE(4309)] = 54173,
  [SMALL_STATE(4310)] = 54230,
  [SMALL_STATE(4311)] = 54283,
  [SMALL_STATE(4312)] = 54352,
  [SMALL_STATE(4313)] = 54407,
  [SMALL_STATE(4314)] = 54478,
  [SMALL_STATE(4315)] = 54535,
  [SMALL_STATE(4316)] = 54592,
  [SMALL_STATE(4317)] = 54645,
  [SMALL_STATE(4318)] = 54722,
  [SMALL_STATE(4319)] = 54779,
  [SMALL_STATE(4320)] = 54834,
  [SMALL_STATE(4321)] = 54903,
  [SMALL_STATE(4322)] = 54972,
  [SMALL_STATE(4323)] = 55041,
  [SMALL_STATE(4324)] = 55110,
  [SMALL_STATE(4325)] = 55167,
  [SMALL_STATE(4326)] = 55236,
  [SMALL_STATE(4327)] = 55305,
  [SMALL_STATE(4328)] = 55374,
  [SMALL_STATE(4329)] = 55442,
  [SMALL_STATE(4330)] = 55510,
  [SMALL_STATE(4331)] = 55578,
  [SMALL_STATE(4332)] = 55646,
  [SMALL_STATE(4333)] = 55714,
  [SMALL_STATE(4334)] = 55782,
  [SMALL_STATE(4335)] = 55850,
  [SMALL_STATE(4336)] = 55918,
  [SMALL_STATE(4337)] = 55986,
  [SMALL_STATE(4338)] = 56054,
  [SMALL_STATE(4339)] = 56122,
  [SMALL_STATE(4340)] = 56190,
  [SMALL_STATE(4341)] = 56258,
  [SMALL_STATE(4342)] = 56326,
  [SMALL_STATE(4343)] = 56394,
  [SMALL_STATE(4344)] = 56480,
  [SMALL_STATE(4345)] = 56548,
  [SMALL_STATE(4346)] = 56616,
  [SMALL_STATE(4347)] = 56668,
  [SMALL_STATE(4348)] = 56720,
  [SMALL_STATE(4349)] = 56788,
  [SMALL_STATE(4350)] = 56856,
  [SMALL_STATE(4351)] = 56924,
  [SMALL_STATE(4352)] = 56992,
  [SMALL_STATE(4353)] = 57060,
  [SMALL_STATE(4354)] = 57128,
  [SMALL_STATE(4355)] = 57196,
  [SMALL_STATE(4356)] = 57264,
  [SMALL_STATE(4357)] = 57320,
  [SMALL_STATE(4358)] = 57376,
  [SMALL_STATE(4359)] = 57444,
  [SMALL_STATE(4360)] = 57512,
  [SMALL_STATE(4361)] = 57564,
  [SMALL_STATE(4362)] = 57622,
  [SMALL_STATE(4363)] = 57690,
  [SMALL_STATE(4364)] = 57758,
  [SMALL_STATE(4365)] = 57814,
  [SMALL_STATE(4366)] = 57882,
  [SMALL_STATE(4367)] = 57950,
  [SMALL_STATE(4368)] = 58018,
  [SMALL_STATE(4369)] = 58086,
  [SMALL_STATE(4370)] = 58138,
  [SMALL_STATE(4371)] = 58206,
  [SMALL_STATE(4372)] = 58274,
  [SMALL_STATE(4373)] = 58342,
  [SMALL_STATE(4374)] = 58410,
  [SMALL_STATE(4375)] = 58478,
  [SMALL_STATE(4376)] = 58546,
  [SMALL_STATE(4377)] = 58614,
  [SMALL_STATE(4378)] = 58666,
  [SMALL_STATE(4379)] = 58734,
  [SMALL_STATE(4380)] = 58802,
  [SMALL_STATE(4381)] = 58870,
  [SMALL_STATE(4382)] = 58938,
  [SMALL_STATE(4383)] = 59006,
  [SMALL_STATE(4384)] = 59074,
  [SMALL_STATE(4385)] = 59142,
  [SMALL_STATE(4386)] = 59210,
  [SMALL_STATE(4387)] = 59278,
  [SMALL_STATE(4388)] = 59330,
  [SMALL_STATE(4389)] = 59384,
  [SMALL_STATE(4390)] = 59470,
  [SMALL_STATE(4391)] = 59556,
  [SMALL_STATE(4392)] = 59624,
  [SMALL_STATE(4393)] = 59692,
  [SMALL_STATE(4394)] = 59744,
  [SMALL_STATE(4395)] = 59796,
  [SMALL_STATE(4396)] = 59852,
  [SMALL_STATE(4397)] = 59920,
  [SMALL_STATE(4398)] = 59988,
  [SMALL_STATE(4399)] = 60040,
  [SMALL_STATE(4400)] = 60108,
  [SMALL_STATE(4401)] = 60176,
  [SMALL_STATE(4402)] = 60244,
  [SMALL_STATE(4403)] = 60312,
  [SMALL_STATE(4404)] = 60366,
  [SMALL_STATE(4405)] = 60434,
  [SMALL_STATE(4406)] = 60502,
  [SMALL_STATE(4407)] = 60570,
  [SMALL_STATE(4408)] = 60622,
  [SMALL_STATE(4409)] = 60690,
  [SMALL_STATE(4410)] = 60758,
  [SMALL_STATE(4411)] = 60826,
  [SMALL_STATE(4412)] = 60894,
  [SMALL_STATE(4413)] = 60946,
  [SMALL_STATE(4414)] = 60998,
  [SMALL_STATE(4415)] = 61066,
  [SMALL_STATE(4416)] = 61134,
  [SMALL_STATE(4417)] = 61202,
  [SMALL_STATE(4418)] = 61254,
  [SMALL_STATE(4419)] = 61322,
  [SMALL_STATE(4420)] = 61390,
  [SMALL_STATE(4421)] = 61442,
  [SMALL_STATE(4422)] = 61510,
  [SMALL_STATE(4423)] = 61566,
  [SMALL_STATE(4424)] = 61634,
  [SMALL_STATE(4425)] = 61702,
  [SMALL_STATE(4426)] = 61770,
  [SMALL_STATE(4427)] = 61838,
  [SMALL_STATE(4428)] = 61906,
  [SMALL_STATE(4429)] = 61958,
  [SMALL_STATE(4430)] = 62026,
  [SMALL_STATE(4431)] = 62094,
  [SMALL_STATE(4432)] = 62162,
  [SMALL_STATE(4433)] = 62230,
  [SMALL_STATE(4434)] = 62298,
  [SMALL_STATE(4435)] = 62366,
  [SMALL_STATE(4436)] = 62418,
  [SMALL_STATE(4437)] = 62486,
  [SMALL_STATE(4438)] = 62554,
  [SMALL_STATE(4439)] = 62622,
  [SMALL_STATE(4440)] = 62690,
  [SMALL_STATE(4441)] = 62742,
  [SMALL_STATE(4442)] = 62810,
  [SMALL_STATE(4443)] = 62878,
  [SMALL_STATE(4444)] = 62946,
  [SMALL_STATE(4445)] = 63014,
  [SMALL_STATE(4446)] = 63082,
  [SMALL_STATE(4447)] = 63150,
  [SMALL_STATE(4448)] = 63202,
  [SMALL_STATE(4449)] = 63270,
  [SMALL_STATE(4450)] = 63338,
  [SMALL_STATE(4451)] = 63406,
  [SMALL_STATE(4452)] = 63474,
  [SMALL_STATE(4453)] = 63542,
  [SMALL_STATE(4454)] = 63610,
  [SMALL_STATE(4455)] = 63678,
  [SMALL_STATE(4456)] = 63746,
  [SMALL_STATE(4457)] = 63798,
  [SMALL_STATE(4458)] = 63866,
  [SMALL_STATE(4459)] = 63918,
  [SMALL_STATE(4460)] = 63986,
  [SMALL_STATE(4461)] = 64054,
  [SMALL_STATE(4462)] = 64122,
  [SMALL_STATE(4463)] = 64174,
  [SMALL_STATE(4464)] = 64242,
  [SMALL_STATE(4465)] = 64310,
  [SMALL_STATE(4466)] = 64378,
  [SMALL_STATE(4467)] = 64446,
  [SMALL_STATE(4468)] = 64514,
  [SMALL_STATE(4469)] = 64582,
  [SMALL_STATE(4470)] = 64650,
  [SMALL_STATE(4471)] = 64702,
  [SMALL_STATE(4472)] = 64770,
  [SMALL_STATE(4473)] = 64822,
  [SMALL_STATE(4474)] = 64890,
  [SMALL_STATE(4475)] = 64958,
  [SMALL_STATE(4476)] = 65026,
  [SMALL_STATE(4477)] = 65094,
  [SMALL_STATE(4478)] = 65162,
  [SMALL_STATE(4479)] = 65230,
  [SMALL_STATE(4480)] = 65298,
  [SMALL_STATE(4481)] = 65366,
  [SMALL_STATE(4482)] = 65422,
  [SMALL_STATE(4483)] = 65490,
  [SMALL_STATE(4484)] = 65558,
  [SMALL_STATE(4485)] = 65626,
  [SMALL_STATE(4486)] = 65694,
  [SMALL_STATE(4487)] = 65762,
  [SMALL_STATE(4488)] = 65830,
  [SMALL_STATE(4489)] = 65898,
  [SMALL_STATE(4490)] = 65952,
  [SMALL_STATE(4491)] = 66020,
  [SMALL_STATE(4492)] = 66088,
  [SMALL_STATE(4493)] = 66156,
  [SMALL_STATE(4494)] = 66224,
  [SMALL_STATE(4495)] = 66292,
  [SMALL_STATE(4496)] = 66360,
  [SMALL_STATE(4497)] = 66428,
  [SMALL_STATE(4498)] = 66496,
  [SMALL_STATE(4499)] = 66564,
  [SMALL_STATE(4500)] = 66632,
  [SMALL_STATE(4501)] = 66700,
  [SMALL_STATE(4502)] = 66768,
  [SMALL_STATE(4503)] = 66854,
  [SMALL_STATE(4504)] = 66922,
  [SMALL_STATE(4505)] = 66990,
  [SMALL_STATE(4506)] = 67058,
  [SMALL_STATE(4507)] = 67110,
  [SMALL_STATE(4508)] = 67178,
  [SMALL_STATE(4509)] = 67246,
  [SMALL_STATE(4510)] = 67314,
  [SMALL_STATE(4511)] = 67382,
  [SMALL_STATE(4512)] = 67450,
  [SMALL_STATE(4513)] = 67504,
  [SMALL_STATE(4514)] = 67572,
  [SMALL_STATE(4515)] = 67640,
  [SMALL_STATE(4516)] = 67708,
  [SMALL_STATE(4517)] = 67776,
  [SMALL_STATE(4518)] = 67844,
  [SMALL_STATE(4519)] = 67912,
  [SMALL_STATE(4520)] = 67980,
  [SMALL_STATE(4521)] = 68048,
  [SMALL_STATE(4522)] = 68116,
  [SMALL_STATE(4523)] = 68184,
  [SMALL_STATE(4524)] = 68252,
  [SMALL_STATE(4525)] = 68320,
  [SMALL_STATE(4526)] = 68388,
  [SMALL_STATE(4527)] = 68456,
  [SMALL_STATE(4528)] = 68524,
  [SMALL_STATE(4529)] = 68592,
  [SMALL_STATE(4530)] = 68660,
  [SMALL_STATE(4531)] = 68728,
  [SMALL_STATE(4532)] = 68796,
  [SMALL_STATE(4533)] = 68864,
  [SMALL_STATE(4534)] = 68932,
  [SMALL_STATE(4535)] = 69000,
  [SMALL_STATE(4536)] = 69068,
  [SMALL_STATE(4537)] = 69136,
  [SMALL_STATE(4538)] = 69204,
  [SMALL_STATE(4539)] = 69272,
  [SMALL_STATE(4540)] = 69340,
  [SMALL_STATE(4541)] = 69408,
  [SMALL_STATE(4542)] = 69476,
  [SMALL_STATE(4543)] = 69544,
  [SMALL_STATE(4544)] = 69612,
  [SMALL_STATE(4545)] = 69680,
  [SMALL_STATE(4546)] = 69748,
  [SMALL_STATE(4547)] = 69800,
  [SMALL_STATE(4548)] = 69868,
  [SMALL_STATE(4549)] = 69936,
  [SMALL_STATE(4550)] = 70004,
  [SMALL_STATE(4551)] = 70072,
  [SMALL_STATE(4552)] = 70140,
  [SMALL_STATE(4553)] = 70208,
  [SMALL_STATE(4554)] = 70276,
  [SMALL_STATE(4555)] = 70344,
  [SMALL_STATE(4556)] = 70412,
  [SMALL_STATE(4557)] = 70480,
  [SMALL_STATE(4558)] = 70548,
  [SMALL_STATE(4559)] = 70616,
  [SMALL_STATE(4560)] = 70684,
  [SMALL_STATE(4561)] = 70752,
  [SMALL_STATE(4562)] = 70804,
  [SMALL_STATE(4563)] = 70870,
  [SMALL_STATE(4564)] = 70938,
  [SMALL_STATE(4565)] = 71006,
  [SMALL_STATE(4566)] = 71058,
  [SMALL_STATE(4567)] = 71126,
  [SMALL_STATE(4568)] = 71194,
  [SMALL_STATE(4569)] = 71262,
  [SMALL_STATE(4570)] = 71330,
  [SMALL_STATE(4571)] = 71398,
  [SMALL_STATE(4572)] = 71450,
  [SMALL_STATE(4573)] = 71518,
  [SMALL_STATE(4574)] = 71586,
  [SMALL_STATE(4575)] = 71654,
  [SMALL_STATE(4576)] = 71722,
  [SMALL_STATE(4577)] = 71776,
  [SMALL_STATE(4578)] = 71828,
  [SMALL_STATE(4579)] = 71896,
  [SMALL_STATE(4580)] = 71952,
  [SMALL_STATE(4581)] = 72020,
  [SMALL_STATE(4582)] = 72076,
  [SMALL_STATE(4583)] = 72144,
  [SMALL_STATE(4584)] = 72212,
  [SMALL_STATE(4585)] = 72280,
  [SMALL_STATE(4586)] = 72348,
  [SMALL_STATE(4587)] = 72416,
  [SMALL_STATE(4588)] = 72484,
  [SMALL_STATE(4589)] = 72552,
  [SMALL_STATE(4590)] = 72620,
  [SMALL_STATE(4591)] = 72688,
  [SMALL_STATE(4592)] = 72756,
  [SMALL_STATE(4593)] = 72824,
  [SMALL_STATE(4594)] = 72892,
  [SMALL_STATE(4595)] = 72960,
  [SMALL_STATE(4596)] = 73028,
  [SMALL_STATE(4597)] = 73096,
  [SMALL_STATE(4598)] = 73164,
  [SMALL_STATE(4599)] = 73220,
  [SMALL_STATE(4600)] = 73288,
  [SMALL_STATE(4601)] = 73356,
  [SMALL_STATE(4602)] = 73424,
  [SMALL_STATE(4603)] = 73492,
  [SMALL_STATE(4604)] = 73560,
  [SMALL_STATE(4605)] = 73628,
  [SMALL_STATE(4606)] = 73696,
  [SMALL_STATE(4607)] = 73764,
  [SMALL_STATE(4608)] = 73832,
  [SMALL_STATE(4609)] = 73900,
  [SMALL_STATE(4610)] = 73968,
  [SMALL_STATE(4611)] = 74036,
  [SMALL_STATE(4612)] = 74094,
  [SMALL_STATE(4613)] = 74162,
  [SMALL_STATE(4614)] = 74230,
  [SMALL_STATE(4615)] = 74298,
  [SMALL_STATE(4616)] = 74350,
  [SMALL_STATE(4617)] = 74418,
  [SMALL_STATE(4618)] = 74486,
  [SMALL_STATE(4619)] = 74554,
  [SMALL_STATE(4620)] = 74622,
  [SMALL_STATE(4621)] = 74690,
  [SMALL_STATE(4622)] = 74758,
  [SMALL_STATE(4623)] = 74826,
  [SMALL_STATE(4624)] = 74878,
  [SMALL_STATE(4625)] = 74930,
  [SMALL_STATE(4626)] = 74998,
  [SMALL_STATE(4627)] = 75066,
  [SMALL_STATE(4628)] = 75118,
  [SMALL_STATE(4629)] = 75170,
  [SMALL_STATE(4630)] = 75222,
  [SMALL_STATE(4631)] = 75290,
  [SMALL_STATE(4632)] = 75358,
  [SMALL_STATE(4633)] = 75410,
  [SMALL_STATE(4634)] = 75478,
  [SMALL_STATE(4635)] = 75544,
  [SMALL_STATE(4636)] = 75612,
  [SMALL_STATE(4637)] = 75668,
  [SMALL_STATE(4638)] = 75720,
  [SMALL_STATE(4639)] = 75788,
  [SMALL_STATE(4640)] = 75840,
  [SMALL_STATE(4641)] = 75908,
  [SMALL_STATE(4642)] = 75976,
  [SMALL_STATE(4643)] = 76044,
  [SMALL_STATE(4644)] = 76096,
  [SMALL_STATE(4645)] = 76164,
  [SMALL_STATE(4646)] = 76220,
  [SMALL_STATE(4647)] = 76288,
  [SMALL_STATE(4648)] = 76374,
  [SMALL_STATE(4649)] = 76442,
  [SMALL_STATE(4650)] = 76510,
  [SMALL_STATE(4651)] = 76578,
  [SMALL_STATE(4652)] = 76646,
  [SMALL_STATE(4653)] = 76714,
  [SMALL_STATE(4654)] = 76782,
  [SMALL_STATE(4655)] = 76850,
  [SMALL_STATE(4656)] = 76918,
  [SMALL_STATE(4657)] = 76986,
  [SMALL_STATE(4658)] = 77052,
  [SMALL_STATE(4659)] = 77120,
  [SMALL_STATE(4660)] = 77188,
  [SMALL_STATE(4661)] = 77256,
  [SMALL_STATE(4662)] = 77312,
  [SMALL_STATE(4663)] = 77380,
  [SMALL_STATE(4664)] = 77432,
  [SMALL_STATE(4665)] = 77484,
  [SMALL_STATE(4666)] = 77538,
  [SMALL_STATE(4667)] = 77606,
  [SMALL_STATE(4668)] = 77672,
  [SMALL_STATE(4669)] = 77740,
  [SMALL_STATE(4670)] = 77808,
  [SMALL_STATE(4671)] = 77876,
  [SMALL_STATE(4672)] = 77944,
  [SMALL_STATE(4673)] = 78012,
  [SMALL_STATE(4674)] = 78080,
  [SMALL_STATE(4675)] = 78148,
  [SMALL_STATE(4676)] = 78216,
  [SMALL_STATE(4677)] = 78284,
  [SMALL_STATE(4678)] = 78352,
  [SMALL_STATE(4679)] = 78420,
  [SMALL_STATE(4680)] = 78488,
  [SMALL_STATE(4681)] = 78556,
  [SMALL_STATE(4682)] = 78624,
  [SMALL_STATE(4683)] = 78676,
  [SMALL_STATE(4684)] = 78744,
  [SMALL_STATE(4685)] = 78812,
  [SMALL_STATE(4686)] = 78880,
  [SMALL_STATE(4687)] = 78948,
  [SMALL_STATE(4688)] = 79016,
  [SMALL_STATE(4689)] = 79084,
  [SMALL_STATE(4690)] = 79152,
  [SMALL_STATE(4691)] = 79220,
  [SMALL_STATE(4692)] = 79272,
  [SMALL_STATE(4693)] = 79340,
  [SMALL_STATE(4694)] = 79408,
  [SMALL_STATE(4695)] = 79460,
  [SMALL_STATE(4696)] = 79528,
  [SMALL_STATE(4697)] = 79596,
  [SMALL_STATE(4698)] = 79664,
  [SMALL_STATE(4699)] = 79732,
  [SMALL_STATE(4700)] = 79800,
  [SMALL_STATE(4701)] = 79852,
  [SMALL_STATE(4702)] = 79920,
  [SMALL_STATE(4703)] = 79988,
  [SMALL_STATE(4704)] = 80056,
  [SMALL_STATE(4705)] = 80124,
  [SMALL_STATE(4706)] = 80192,
  [SMALL_STATE(4707)] = 80246,
  [SMALL_STATE(4708)] = 80302,
  [SMALL_STATE(4709)] = 80370,
  [SMALL_STATE(4710)] = 80438,
  [SMALL_STATE(4711)] = 80506,
  [SMALL_STATE(4712)] = 80574,
  [SMALL_STATE(4713)] = 80642,
  [SMALL_STATE(4714)] = 80710,
  [SMALL_STATE(4715)] = 80778,
  [SMALL_STATE(4716)] = 80846,
  [SMALL_STATE(4717)] = 80914,
  [SMALL_STATE(4718)] = 80966,
  [SMALL_STATE(4719)] = 81034,
  [SMALL_STATE(4720)] = 81102,
  [SMALL_STATE(4721)] = 81153,
  [SMALL_STATE(4722)] = 81208,
  [SMALL_STATE(4723)] = 81261,
  [SMALL_STATE(4724)] = 81312,
  [SMALL_STATE(4725)] = 81365,
  [SMALL_STATE(4726)] = 81418,
  [SMALL_STATE(4727)] = 81471,
  [SMALL_STATE(4728)] = 81524,
  [SMALL_STATE(4729)] = 81577,
  [SMALL_STATE(4730)] = 81634,
  [SMALL_STATE(4731)] = 81687,
  [SMALL_STATE(4732)] = 81754,
  [SMALL_STATE(4733)] = 81821,
  [SMALL_STATE(4734)] = 81872,
  [SMALL_STATE(4735)] = 81939,
  [SMALL_STATE(4736)] = 82006,
  [SMALL_STATE(4737)] = 82073,
  [SMALL_STATE(4738)] = 82140,
  [SMALL_STATE(4739)] = 82191,
  [SMALL_STATE(4740)] = 82258,
  [SMALL_STATE(4741)] = 82325,
  [SMALL_STATE(4742)] = 82376,
  [SMALL_STATE(4743)] = 82427,
  [SMALL_STATE(4744)] = 82482,
  [SMALL_STATE(4745)] = 82533,
  [SMALL_STATE(4746)] = 82588,
  [SMALL_STATE(4747)] = 82639,
  [SMALL_STATE(4748)] = 82690,
  [SMALL_STATE(4749)] = 82741,
  [SMALL_STATE(4750)] = 82812,
  [SMALL_STATE(4751)] = 82879,
  [SMALL_STATE(4752)] = 82930,
  [SMALL_STATE(4753)] = 82981,
  [SMALL_STATE(4754)] = 83032,
  [SMALL_STATE(4755)] = 83085,
  [SMALL_STATE(4756)] = 83138,
  [SMALL_STATE(4757)] = 83189,
  [SMALL_STATE(4758)] = 83242,
  [SMALL_STATE(4759)] = 83297,
  [SMALL_STATE(4760)] = 83350,
  [SMALL_STATE(4761)] = 83417,
  [SMALL_STATE(4762)] = 83470,
  [SMALL_STATE(4763)] = 83525,
  [SMALL_STATE(4764)] = 83576,
  [SMALL_STATE(4765)] = 83653,
  [SMALL_STATE(4766)] = 83704,
  [SMALL_STATE(4767)] = 83755,
  [SMALL_STATE(4768)] = 83806,
  [SMALL_STATE(4769)] = 83877,
  [SMALL_STATE(4770)] = 83930,
  [SMALL_STATE(4771)] = 83985,
  [SMALL_STATE(4772)] = 84038,
  [SMALL_STATE(4773)] = 84115,
  [SMALL_STATE(4774)] = 84166,
  [SMALL_STATE(4775)] = 84219,
  [SMALL_STATE(4776)] = 84274,
  [SMALL_STATE(4777)] = 84327,
  [SMALL_STATE(4778)] = 84404,
  [SMALL_STATE(4779)] = 84455,
  [SMALL_STATE(4780)] = 84506,
  [SMALL_STATE(4781)] = 84557,
  [SMALL_STATE(4782)] = 84608,
  [SMALL_STATE(4783)] = 84659,
  [SMALL_STATE(4784)] = 84710,
  [SMALL_STATE(4785)] = 84763,
  [SMALL_STATE(4786)] = 84814,
  [SMALL_STATE(4787)] = 84865,
  [SMALL_STATE(4788)] = 84916,
  [SMALL_STATE(4789)] = 84981,
  [SMALL_STATE(4790)] = 85046,
  [SMALL_STATE(4791)] = 85122,
  [SMALL_STATE(4792)] = 85172,
  [SMALL_STATE(4793)] = 85238,
  [SMALL_STATE(4794)] = 85288,
  [SMALL_STATE(4795)] = 85338,
  [SMALL_STATE(4796)] = 85388,
  [SMALL_STATE(4797)] = 85438,
  [SMALL_STATE(4798)] = 85488,
  [SMALL_STATE(4799)] = 85538,
  [SMALL_STATE(4800)] = 85588,
  [SMALL_STATE(4801)] = 85638,
  [SMALL_STATE(4802)] = 85704,
  [SMALL_STATE(4803)] = 85754,
  [SMALL_STATE(4804)] = 85804,
  [SMALL_STATE(4805)] = 85870,
  [SMALL_STATE(4806)] = 85920,
  [SMALL_STATE(4807)] = 85986,
  [SMALL_STATE(4808)] = 86036,
  [SMALL_STATE(4809)] = 86086,
  [SMALL_STATE(4810)] = 86136,
  [SMALL_STATE(4811)] = 86186,
  [SMALL_STATE(4812)] = 86236,
  [SMALL_STATE(4813)] = 86286,
  [SMALL_STATE(4814)] = 86336,
  [SMALL_STATE(4815)] = 86402,
  [SMALL_STATE(4816)] = 86452,
  [SMALL_STATE(4817)] = 86502,
  [SMALL_STATE(4818)] = 86552,
  [SMALL_STATE(4819)] = 86602,
  [SMALL_STATE(4820)] = 86678,
  [SMALL_STATE(4821)] = 86728,
  [SMALL_STATE(4822)] = 86804,
  [SMALL_STATE(4823)] = 86854,
  [SMALL_STATE(4824)] = 86904,
  [SMALL_STATE(4825)] = 86956,
  [SMALL_STATE(4826)] = 87006,
  [SMALL_STATE(4827)] = 87082,
  [SMALL_STATE(4828)] = 87148,
  [SMALL_STATE(4829)] = 87202,
  [SMALL_STATE(4830)] = 87254,
  [SMALL_STATE(4831)] = 87308,
  [SMALL_STATE(4832)] = 87374,
  [SMALL_STATE(4833)] = 87440,
  [SMALL_STATE(4834)] = 87506,
  [SMALL_STATE(4835)] = 87576,
  [SMALL_STATE(4836)] = 87626,
  [SMALL_STATE(4837)] = 87692,
  [SMALL_STATE(4838)] = 87746,
  [SMALL_STATE(4839)] = 87796,
  [SMALL_STATE(4840)] = 87846,
  [SMALL_STATE(4841)] = 87924,
  [SMALL_STATE(4842)] = 87990,
  [SMALL_STATE(4843)] = 88056,
  [SMALL_STATE(4844)] = 88122,
  [SMALL_STATE(4845)] = 88188,
  [SMALL_STATE(4846)] = 88254,
  [SMALL_STATE(4847)] = 88320,
  [SMALL_STATE(4848)] = 88370,
  [SMALL_STATE(4849)] = 88420,
  [SMALL_STATE(4850)] = 88490,
  [SMALL_STATE(4851)] = 88540,
  [SMALL_STATE(4852)] = 88594,
  [SMALL_STATE(4853)] = 88644,
  [SMALL_STATE(4854)] = 88694,
  [SMALL_STATE(4855)] = 88744,
  [SMALL_STATE(4856)] = 88794,
  [SMALL_STATE(4857)] = 88846,
  [SMALL_STATE(4858)] = 88896,
  [SMALL_STATE(4859)] = 88948,
  [SMALL_STATE(4860)] = 88998,
  [SMALL_STATE(4861)] = 89048,
  [SMALL_STATE(4862)] = 89100,
  [SMALL_STATE(4863)] = 89150,
  [SMALL_STATE(4864)] = 89200,
  [SMALL_STATE(4865)] = 89252,
  [SMALL_STATE(4866)] = 89304,
  [SMALL_STATE(4867)] = 89354,
  [SMALL_STATE(4868)] = 89404,
  [SMALL_STATE(4869)] = 89456,
  [SMALL_STATE(4870)] = 89522,
  [SMALL_STATE(4871)] = 89574,
  [SMALL_STATE(4872)] = 89624,
  [SMALL_STATE(4873)] = 89676,
  [SMALL_STATE(4874)] = 89728,
  [SMALL_STATE(4875)] = 89778,
  [SMALL_STATE(4876)] = 89828,
  [SMALL_STATE(4877)] = 89878,
  [SMALL_STATE(4878)] = 89928,
  [SMALL_STATE(4879)] = 89978,
  [SMALL_STATE(4880)] = 90030,
  [SMALL_STATE(4881)] = 90080,
  [SMALL_STATE(4882)] = 90158,
  [SMALL_STATE(4883)] = 90208,
  [SMALL_STATE(4884)] = 90258,
  [SMALL_STATE(4885)] = 90308,
  [SMALL_STATE(4886)] = 90358,
  [SMALL_STATE(4887)] = 90408,
  [SMALL_STATE(4888)] = 90458,
  [SMALL_STATE(4889)] = 90510,
  [SMALL_STATE(4890)] = 90560,
  [SMALL_STATE(4891)] = 90610,
  [SMALL_STATE(4892)] = 90660,
  [SMALL_STATE(4893)] = 90710,
  [SMALL_STATE(4894)] = 90762,
  [SMALL_STATE(4895)] = 90812,
  [SMALL_STATE(4896)] = 90862,
  [SMALL_STATE(4897)] = 90912,
  [SMALL_STATE(4898)] = 90962,
  [SMALL_STATE(4899)] = 91012,
  [SMALL_STATE(4900)] = 91062,
  [SMALL_STATE(4901)] = 91112,
  [SMALL_STATE(4902)] = 91162,
  [SMALL_STATE(4903)] = 91211,
  [SMALL_STATE(4904)] = 91276,
  [SMALL_STATE(4905)] = 91329,
  [SMALL_STATE(4906)] = 91378,
  [SMALL_STATE(4907)] = 91443,
  [SMALL_STATE(4908)] = 91492,
  [SMALL_STATE(4909)] = 91545,
  [SMALL_STATE(4910)] = 91594,
  [SMALL_STATE(4911)] = 91659,
  [SMALL_STATE(4912)] = 91712,
  [SMALL_STATE(4913)] = 91761,
  [SMALL_STATE(4914)] = 91826,
  [SMALL_STATE(4915)] = 91891,
  [SMALL_STATE(4916)] = 91956,
  [SMALL_STATE(4917)] = 92007,
  [SMALL_STATE(4918)] = 92072,
  [SMALL_STATE(4919)] = 92137,
  [SMALL_STATE(4920)] = 92202,
  [SMALL_STATE(4921)] = 92255,
  [SMALL_STATE(4922)] = 92304,
  [SMALL_STATE(4923)] = 92369,
  [SMALL_STATE(4924)] = 92418,
  [SMALL_STATE(4925)] = 92469,
  [SMALL_STATE(4926)] = 92518,
  [SMALL_STATE(4927)] = 92595,
  [SMALL_STATE(4928)] = 92644,
  [SMALL_STATE(4929)] = 92709,
  [SMALL_STATE(4930)] = 92762,
  [SMALL_STATE(4931)] = 92811,
  [SMALL_STATE(4932)] = 92860,
  [SMALL_STATE(4933)] = 92909,
  [SMALL_STATE(4934)] = 92958,
  [SMALL_STATE(4935)] = 93007,
  [SMALL_STATE(4936)] = 93056,
  [SMALL_STATE(4937)] = 93105,
  [SMALL_STATE(4938)] = 93154,
  [SMALL_STATE(4939)] = 93203,
  [SMALL_STATE(4940)] = 93252,
  [SMALL_STATE(4941)] = 93301,
  [SMALL_STATE(4942)] = 93364,
  [SMALL_STATE(4943)] = 93413,
  [SMALL_STATE(4944)] = 93462,
  [SMALL_STATE(4945)] = 93511,
  [SMALL_STATE(4946)] = 93560,
  [SMALL_STATE(4947)] = 93609,
  [SMALL_STATE(4948)] = 93658,
  [SMALL_STATE(4949)] = 93707,
  [SMALL_STATE(4950)] = 93756,
  [SMALL_STATE(4951)] = 93805,
  [SMALL_STATE(4952)] = 93858,
  [SMALL_STATE(4953)] = 93923,
  [SMALL_STATE(4954)] = 93972,
  [SMALL_STATE(4955)] = 94047,
  [SMALL_STATE(4956)] = 94096,
  [SMALL_STATE(4957)] = 94145,
  [SMALL_STATE(4958)] = 94194,
  [SMALL_STATE(4959)] = 94243,
  [SMALL_STATE(4960)] = 94306,
  [SMALL_STATE(4961)] = 94357,
  [SMALL_STATE(4962)] = 94406,
  [SMALL_STATE(4963)] = 94455,
  [SMALL_STATE(4964)] = 94504,
  [SMALL_STATE(4965)] = 94553,
  [SMALL_STATE(4966)] = 94602,
  [SMALL_STATE(4967)] = 94665,
  [SMALL_STATE(4968)] = 94718,
  [SMALL_STATE(4969)] = 94781,
  [SMALL_STATE(4970)] = 94830,
  [SMALL_STATE(4971)] = 94907,
  [SMALL_STATE(4972)] = 94958,
  [SMALL_STATE(4973)] = 95007,
  [SMALL_STATE(4974)] = 95060,
  [SMALL_STATE(4975)] = 95109,
  [SMALL_STATE(4976)] = 95158,
  [SMALL_STATE(4977)] = 95208,
  [SMALL_STATE(4978)] = 95258,
  [SMALL_STATE(4979)] = 95332,
  [SMALL_STATE(4980)] = 95382,
  [SMALL_STATE(4981)] = 95430,
  [SMALL_STATE(4982)] = 95480,
  [SMALL_STATE(4983)] = 95530,
  [SMALL_STATE(4984)] = 95578,
  [SMALL_STATE(4985)] = 95630,
  [SMALL_STATE(4986)] = 95704,
  [SMALL_STATE(4987)] = 95756,
  [SMALL_STATE(4988)] = 95808,
  [SMALL_STATE(4989)] = 95862,
  [SMALL_STATE(4990)] = 95910,
  [SMALL_STATE(4991)] = 95962,
  [SMALL_STATE(4992)] = 96010,
  [SMALL_STATE(4993)] = 96062,
  [SMALL_STATE(4994)] = 96136,
  [SMALL_STATE(4995)] = 96190,
  [SMALL_STATE(4996)] = 96254,
  [SMALL_STATE(4997)] = 96328,
  [SMALL_STATE(4998)] = 96378,
  [SMALL_STATE(4999)] = 96432,
  [SMALL_STATE(5000)] = 96484,
  [SMALL_STATE(5001)] = 96536,
  [SMALL_STATE(5002)] = 96586,
  [SMALL_STATE(5003)] = 96638,
  [SMALL_STATE(5004)] = 96688,
  [SMALL_STATE(5005)] = 96762,
  [SMALL_STATE(5006)] = 96836,
  [SMALL_STATE(5007)] = 96884,
  [SMALL_STATE(5008)] = 96932,
  [SMALL_STATE(5009)] = 97006,
  [SMALL_STATE(5010)] = 97080,
  [SMALL_STATE(5011)] = 97132,
  [SMALL_STATE(5012)] = 97180,
  [SMALL_STATE(5013)] = 97254,
  [SMALL_STATE(5014)] = 97302,
  [SMALL_STATE(5015)] = 97366,
  [SMALL_STATE(5016)] = 97416,
  [SMALL_STATE(5017)] = 97465,
  [SMALL_STATE(5018)] = 97514,
  [SMALL_STATE(5019)] = 97561,
  [SMALL_STATE(5020)] = 97608,
  [SMALL_STATE(5021)] = 97659,
  [SMALL_STATE(5022)] = 97706,
  [SMALL_STATE(5023)] = 97753,
  [SMALL_STATE(5024)] = 97800,
  [SMALL_STATE(5025)] = 97847,
  [SMALL_STATE(5026)] = 97894,
  [SMALL_STATE(5027)] = 97941,
  [SMALL_STATE(5028)] = 97988,
  [SMALL_STATE(5029)] = 98035,
  [SMALL_STATE(5030)] = 98082,
  [SMALL_STATE(5031)] = 98135,
  [SMALL_STATE(5032)] = 98186,
  [SMALL_STATE(5033)] = 98233,
  [SMALL_STATE(5034)] = 98282,
  [SMALL_STATE(5035)] = 98329,
  [SMALL_STATE(5036)] = 98380,
  [SMALL_STATE(5037)] = 98431,
  [SMALL_STATE(5038)] = 98478,
  [SMALL_STATE(5039)] = 98525,
  [SMALL_STATE(5040)] = 98572,
  [SMALL_STATE(5041)] = 98619,
  [SMALL_STATE(5042)] = 98666,
  [SMALL_STATE(5043)] = 98713,
  [SMALL_STATE(5044)] = 98760,
  [SMALL_STATE(5045)] = 98807,
  [SMALL_STATE(5046)] = 98854,
  [SMALL_STATE(5047)] = 98901,
  [SMALL_STATE(5048)] = 98948,
  [SMALL_STATE(5049)] = 99015,
  [SMALL_STATE(5050)] = 99066,
  [SMALL_STATE(5051)] = 99115,
  [SMALL_STATE(5052)] = 99164,
  [SMALL_STATE(5053)] = 99211,
  [SMALL_STATE(5054)] = 99260,
  [SMALL_STATE(5055)] = 99307,
  [SMALL_STATE(5056)] = 99354,
  [SMALL_STATE(5057)] = 99403,
  [SMALL_STATE(5058)] = 99450,
  [SMALL_STATE(5059)] = 99501,
  [SMALL_STATE(5060)] = 99572,
  [SMALL_STATE(5061)] = 99619,
  [SMALL_STATE(5062)] = 99668,
  [SMALL_STATE(5063)] = 99717,
  [SMALL_STATE(5064)] = 99768,
  [SMALL_STATE(5065)] = 99815,
  [SMALL_STATE(5066)] = 99862,
  [SMALL_STATE(5067)] = 99913,
  [SMALL_STATE(5068)] = 99960,
  [SMALL_STATE(5069)] = 100011,
  [SMALL_STATE(5070)] = 100058,
  [SMALL_STATE(5071)] = 100107,
  [SMALL_STATE(5072)] = 100154,
  [SMALL_STATE(5073)] = 100201,
  [SMALL_STATE(5074)] = 100248,
  [SMALL_STATE(5075)] = 100297,
  [SMALL_STATE(5076)] = 100345,
  [SMALL_STATE(5077)] = 100391,
  [SMALL_STATE(5078)] = 100435,
  [SMALL_STATE(5079)] = 100481,
  [SMALL_STATE(5080)] = 100527,
  [SMALL_STATE(5081)] = 100573,
  [SMALL_STATE(5082)] = 100619,
  [SMALL_STATE(5083)] = 100665,
  [SMALL_STATE(5084)] = 100711,
  [SMALL_STATE(5085)] = 100757,
  [SMALL_STATE(5086)] = 100803,
  [SMALL_STATE(5087)] = 100849,
  [SMALL_STATE(5088)] = 100895,
  [SMALL_STATE(5089)] = 100941,
  [SMALL_STATE(5090)] = 100987,
  [SMALL_STATE(5091)] = 101033,
  [SMALL_STATE(5092)] = 101079,
  [SMALL_STATE(5093)] = 101127,
  [SMALL_STATE(5094)] = 101173,
  [SMALL_STATE(5095)] = 101219,
  [SMALL_STATE(5096)] = 101265,
  [SMALL_STATE(5097)] = 101311,
  [SMALL_STATE(5098)] = 101359,
  [SMALL_STATE(5099)] = 101427,
  [SMALL_STATE(5100)] = 101473,
  [SMALL_STATE(5101)] = 101541,
  [SMALL_STATE(5102)] = 101587,
  [SMALL_STATE(5103)] = 101633,
  [SMALL_STATE(5104)] = 101677,
  [SMALL_STATE(5105)] = 101745,
  [SMALL_STATE(5106)] = 101793,
  [SMALL_STATE(5107)] = 101859,
  [SMALL_STATE(5108)] = 101907,
  [SMALL_STATE(5109)] = 101953,
  [SMALL_STATE(5110)] = 102021,
  [SMALL_STATE(5111)] = 102071,
  [SMALL_STATE(5112)] = 102119,
  [SMALL_STATE(5113)] = 102167,
  [SMALL_STATE(5114)] = 102226,
  [SMALL_STATE(5115)] = 102285,
  [SMALL_STATE(5116)] = 102330,
  [SMALL_STATE(5117)] = 102375,
  [SMALL_STATE(5118)] = 102420,
  [SMALL_STATE(5119)] = 102465,
  [SMALL_STATE(5120)] = 102524,
  [SMALL_STATE(5121)] = 102567,
  [SMALL_STATE(5122)] = 102626,
  [SMALL_STATE(5123)] = 102671,
  [SMALL_STATE(5124)] = 102730,
  [SMALL_STATE(5125)] = 102789,
  [SMALL_STATE(5126)] = 102834,
  [SMALL_STATE(5127)] = 102893,
  [SMALL_STATE(5128)] = 102938,
  [SMALL_STATE(5129)] = 102997,
  [SMALL_STATE(5130)] = 103056,
  [SMALL_STATE(5131)] = 103101,
  [SMALL_STATE(5132)] = 103162,
  [SMALL_STATE(5133)] = 103221,
  [SMALL_STATE(5134)] = 103266,
  [SMALL_STATE(5135)] = 103311,
  [SMALL_STATE(5136)] = 103356,
  [SMALL_STATE(5137)] = 103401,
  [SMALL_STATE(5138)] = 103460,
  [SMALL_STATE(5139)] = 103509,
  [SMALL_STATE(5140)] = 103554,
  [SMALL_STATE(5141)] = 103599,
  [SMALL_STATE(5142)] = 103658,
  [SMALL_STATE(5143)] = 103703,
  [SMALL_STATE(5144)] = 103748,
  [SMALL_STATE(5145)] = 103807,
  [SMALL_STATE(5146)] = 103852,
  [SMALL_STATE(5147)] = 103897,
  [SMALL_STATE(5148)] = 103956,
  [SMALL_STATE(5149)] = 104001,
  [SMALL_STATE(5150)] = 104046,
  [SMALL_STATE(5151)] = 104091,
  [SMALL_STATE(5152)] = 104136,
  [SMALL_STATE(5153)] = 104195,
  [SMALL_STATE(5154)] = 104240,
  [SMALL_STATE(5155)] = 104299,
  [SMALL_STATE(5156)] = 104344,
  [SMALL_STATE(5157)] = 104403,
  [SMALL_STATE(5158)] = 104448,
  [SMALL_STATE(5159)] = 104507,
  [SMALL_STATE(5160)] = 104552,
  [SMALL_STATE(5161)] = 104597,
  [SMALL_STATE(5162)] = 104656,
  [SMALL_STATE(5163)] = 104701,
  [SMALL_STATE(5164)] = 104760,
  [SMALL_STATE(5165)] = 104805,
  [SMALL_STATE(5166)] = 104850,
  [SMALL_STATE(5167)] = 104909,
  [SMALL_STATE(5168)] = 104968,
  [SMALL_STATE(5169)] = 105013,
  [SMALL_STATE(5170)] = 105058,
  [SMALL_STATE(5171)] = 105103,
  [SMALL_STATE(5172)] = 105148,
  [SMALL_STATE(5173)] = 105193,
  [SMALL_STATE(5174)] = 105252,
  [SMALL_STATE(5175)] = 105297,
  [SMALL_STATE(5176)] = 105342,
  [SMALL_STATE(5177)] = 105387,
  [SMALL_STATE(5178)] = 105432,
  [SMALL_STATE(5179)] = 105477,
  [SMALL_STATE(5180)] = 105520,
  [SMALL_STATE(5181)] = 105565,
  [SMALL_STATE(5182)] = 105624,
  [SMALL_STATE(5183)] = 105683,
  [SMALL_STATE(5184)] = 105728,
  [SMALL_STATE(5185)] = 105787,
  [SMALL_STATE(5186)] = 105832,
  [SMALL_STATE(5187)] = 105897,
  [SMALL_STATE(5188)] = 105954,
  [SMALL_STATE(5189)] = 105997,
  [SMALL_STATE(5190)] = 106042,
  [SMALL_STATE(5191)] = 106101,
  [SMALL_STATE(5192)] = 106160,
  [SMALL_STATE(5193)] = 106205,
  [SMALL_STATE(5194)] = 106250,
  [SMALL_STATE(5195)] = 106309,
  [SMALL_STATE(5196)] = 106368,
  [SMALL_STATE(5197)] = 106413,
  [SMALL_STATE(5198)] = 106472,
  [SMALL_STATE(5199)] = 106531,
  [SMALL_STATE(5200)] = 106590,
  [SMALL_STATE(5201)] = 106635,
  [SMALL_STATE(5202)] = 106694,
  [SMALL_STATE(5203)] = 106739,
  [SMALL_STATE(5204)] = 106786,
  [SMALL_STATE(5205)] = 106831,
  [SMALL_STATE(5206)] = 106876,
  [SMALL_STATE(5207)] = 106921,
  [SMALL_STATE(5208)] = 106968,
  [SMALL_STATE(5209)] = 107013,
  [SMALL_STATE(5210)] = 107058,
  [SMALL_STATE(5211)] = 107103,
  [SMALL_STATE(5212)] = 107162,
  [SMALL_STATE(5213)] = 107223,
  [SMALL_STATE(5214)] = 107284,
  [SMALL_STATE(5215)] = 107343,
  [SMALL_STATE(5216)] = 107402,
  [SMALL_STATE(5217)] = 107447,
  [SMALL_STATE(5218)] = 107492,
  [SMALL_STATE(5219)] = 107537,
  [SMALL_STATE(5220)] = 107598,
  [SMALL_STATE(5221)] = 107643,
  [SMALL_STATE(5222)] = 107702,
  [SMALL_STATE(5223)] = 107761,
  [SMALL_STATE(5224)] = 107820,
  [SMALL_STATE(5225)] = 107879,
  [SMALL_STATE(5226)] = 107924,
  [SMALL_STATE(5227)] = 107969,
  [SMALL_STATE(5228)] = 108028,
  [SMALL_STATE(5229)] = 108087,
  [SMALL_STATE(5230)] = 108130,
  [SMALL_STATE(5231)] = 108189,
  [SMALL_STATE(5232)] = 108248,
  [SMALL_STATE(5233)] = 108293,
  [SMALL_STATE(5234)] = 108352,
  [SMALL_STATE(5235)] = 108397,
  [SMALL_STATE(5236)] = 108442,
  [SMALL_STATE(5237)] = 108484,
  [SMALL_STATE(5238)] = 108528,
  [SMALL_STATE(5239)] = 108582,
  [SMALL_STATE(5240)] = 108638,
  [SMALL_STATE(5241)] = 108680,
  [SMALL_STATE(5242)] = 108736,
  [SMALL_STATE(5243)] = 108792,
  [SMALL_STATE(5244)] = 108834,
  [SMALL_STATE(5245)] = 108878,
  [SMALL_STATE(5246)] = 108934,
  [SMALL_STATE(5247)] = 108990,
  [SMALL_STATE(5248)] = 109046,
  [SMALL_STATE(5249)] = 109102,
  [SMALL_STATE(5250)] = 109158,
  [SMALL_STATE(5251)] = 109206,
  [SMALL_STATE(5252)] = 109248,
  [SMALL_STATE(5253)] = 109292,
  [SMALL_STATE(5254)] = 109348,
  [SMALL_STATE(5255)] = 109404,
  [SMALL_STATE(5256)] = 109450,
  [SMALL_STATE(5257)] = 109506,
  [SMALL_STATE(5258)] = 109562,
  [SMALL_STATE(5259)] = 109606,
  [SMALL_STATE(5260)] = 109662,
  [SMALL_STATE(5261)] = 109710,
  [SMALL_STATE(5262)] = 109756,
  [SMALL_STATE(5263)] = 109812,
  [SMALL_STATE(5264)] = 109868,
  [SMALL_STATE(5265)] = 109924,
  [SMALL_STATE(5266)] = 109968,
  [SMALL_STATE(5267)] = 110024,
  [SMALL_STATE(5268)] = 110080,
  [SMALL_STATE(5269)] = 110136,
  [SMALL_STATE(5270)] = 110192,
  [SMALL_STATE(5271)] = 110248,
  [SMALL_STATE(5272)] = 110304,
  [SMALL_STATE(5273)] = 110350,
  [SMALL_STATE(5274)] = 110392,
  [SMALL_STATE(5275)] = 110436,
  [SMALL_STATE(5276)] = 110492,
  [SMALL_STATE(5277)] = 110534,
  [SMALL_STATE(5278)] = 110576,
  [SMALL_STATE(5279)] = 110618,
  [SMALL_STATE(5280)] = 110674,
  [SMALL_STATE(5281)] = 110716,
  [SMALL_STATE(5282)] = 110772,
  [SMALL_STATE(5283)] = 110828,
  [SMALL_STATE(5284)] = 110884,
  [SMALL_STATE(5285)] = 110940,
  [SMALL_STATE(5286)] = 110982,
  [SMALL_STATE(5287)] = 111026,
  [SMALL_STATE(5288)] = 111082,
  [SMALL_STATE(5289)] = 111126,
  [SMALL_STATE(5290)] = 111182,
  [SMALL_STATE(5291)] = 111246,
  [SMALL_STATE(5292)] = 111288,
  [SMALL_STATE(5293)] = 111344,
  [SMALL_STATE(5294)] = 111400,
  [SMALL_STATE(5295)] = 111444,
  [SMALL_STATE(5296)] = 111488,
  [SMALL_STATE(5297)] = 111544,
  [SMALL_STATE(5298)] = 111592,
  [SMALL_STATE(5299)] = 111648,
  [SMALL_STATE(5300)] = 111692,
  [SMALL_STATE(5301)] = 111736,
  [SMALL_STATE(5302)] = 111792,
  [SMALL_STATE(5303)] = 111848,
  [SMALL_STATE(5304)] = 111890,
  [SMALL_STATE(5305)] = 111934,
  [SMALL_STATE(5306)] = 111978,
  [SMALL_STATE(5307)] = 112034,
  [SMALL_STATE(5308)] = 112090,
  [SMALL_STATE(5309)] = 112134,
  [SMALL_STATE(5310)] = 112176,
  [SMALL_STATE(5311)] = 112232,
  [SMALL_STATE(5312)] = 112274,
  [SMALL_STATE(5313)] = 112318,
  [SMALL_STATE(5314)] = 112360,
  [SMALL_STATE(5315)] = 112402,
  [SMALL_STATE(5316)] = 112444,
  [SMALL_STATE(5317)] = 112500,
  [SMALL_STATE(5318)] = 112542,
  [SMALL_STATE(5319)] = 112598,
  [SMALL_STATE(5320)] = 112654,
  [SMALL_STATE(5321)] = 112710,
  [SMALL_STATE(5322)] = 112766,
  [SMALL_STATE(5323)] = 112822,
  [SMALL_STATE(5324)] = 112866,
  [SMALL_STATE(5325)] = 112910,
  [SMALL_STATE(5326)] = 112952,
  [SMALL_STATE(5327)] = 113008,
  [SMALL_STATE(5328)] = 113052,
  [SMALL_STATE(5329)] = 113103,
  [SMALL_STATE(5330)] = 113144,
  [SMALL_STATE(5331)] = 113203,
  [SMALL_STATE(5332)] = 113244,
  [SMALL_STATE(5333)] = 113285,
  [SMALL_STATE(5334)] = 113326,
  [SMALL_STATE(5335)] = 113367,
  [SMALL_STATE(5336)] = 113414,
  [SMALL_STATE(5337)] = 113455,
  [SMALL_STATE(5338)] = 113496,
  [SMALL_STATE(5339)] = 113539,
  [SMALL_STATE(5340)] = 113584,
  [SMALL_STATE(5341)] = 113629,
  [SMALL_STATE(5342)] = 113676,
  [SMALL_STATE(5343)] = 113717,
  [SMALL_STATE(5344)] = 113776,
  [SMALL_STATE(5345)] = 113823,
  [SMALL_STATE(5346)] = 113864,
  [SMALL_STATE(5347)] = 113905,
  [SMALL_STATE(5348)] = 113946,
  [SMALL_STATE(5349)] = 113987,
  [SMALL_STATE(5350)] = 114028,
  [SMALL_STATE(5351)] = 114069,
  [SMALL_STATE(5352)] = 114128,
  [SMALL_STATE(5353)] = 114171,
  [SMALL_STATE(5354)] = 114230,
  [SMALL_STATE(5355)] = 114271,
  [SMALL_STATE(5356)] = 114312,
  [SMALL_STATE(5357)] = 114353,
  [SMALL_STATE(5358)] = 114400,
  [SMALL_STATE(5359)] = 114441,
  [SMALL_STATE(5360)] = 114482,
  [SMALL_STATE(5361)] = 114525,
  [SMALL_STATE(5362)] = 114566,
  [SMALL_STATE(5363)] = 114607,
  [SMALL_STATE(5364)] = 114648,
  [SMALL_STATE(5365)] = 114689,
  [SMALL_STATE(5366)] = 114730,
  [SMALL_STATE(5367)] = 114773,
  [SMALL_STATE(5368)] = 114818,
  [SMALL_STATE(5369)] = 114861,
  [SMALL_STATE(5370)] = 114904,
  [SMALL_STATE(5371)] = 114949,
  [SMALL_STATE(5372)] = 114990,
  [SMALL_STATE(5373)] = 115049,
  [SMALL_STATE(5374)] = 115092,
  [SMALL_STATE(5375)] = 115139,
  [SMALL_STATE(5376)] = 115186,
  [SMALL_STATE(5377)] = 115247,
  [SMALL_STATE(5378)] = 115290,
  [SMALL_STATE(5379)] = 115335,
  [SMALL_STATE(5380)] = 115380,
  [SMALL_STATE(5381)] = 115423,
  [SMALL_STATE(5382)] = 115464,
  [SMALL_STATE(5383)] = 115523,
  [SMALL_STATE(5384)] = 115570,
  [SMALL_STATE(5385)] = 115617,
  [SMALL_STATE(5386)] = 115658,
  [SMALL_STATE(5387)] = 115701,
  [SMALL_STATE(5388)] = 115742,
  [SMALL_STATE(5389)] = 115783,
  [SMALL_STATE(5390)] = 115826,
  [SMALL_STATE(5391)] = 115867,
  [SMALL_STATE(5392)] = 115914,
  [SMALL_STATE(5393)] = 115955,
  [SMALL_STATE(5394)] = 115996,
  [SMALL_STATE(5395)] = 116037,
  [SMALL_STATE(5396)] = 116084,
  [SMALL_STATE(5397)] = 116127,
  [SMALL_STATE(5398)] = 116172,
  [SMALL_STATE(5399)] = 116219,
  [SMALL_STATE(5400)] = 116266,
  [SMALL_STATE(5401)] = 116319,
  [SMALL_STATE(5402)] = 116360,
  [SMALL_STATE(5403)] = 116413,
  [SMALL_STATE(5404)] = 116469,
  [SMALL_STATE(5405)] = 116511,
  [SMALL_STATE(5406)] = 116557,
  [SMALL_STATE(5407)] = 116601,
  [SMALL_STATE(5408)] = 116653,
  [SMALL_STATE(5409)] = 116705,
  [SMALL_STATE(5410)] = 116749,
  [SMALL_STATE(5411)] = 116805,
  [SMALL_STATE(5412)] = 116863,
  [SMALL_STATE(5413)] = 116903,
  [SMALL_STATE(5414)] = 116943,
  [SMALL_STATE(5415)] = 116983,
  [SMALL_STATE(5416)] = 117027,
  [SMALL_STATE(5417)] = 117071,
  [SMALL_STATE(5418)] = 117113,
  [SMALL_STATE(5419)] = 117165,
  [SMALL_STATE(5420)] = 117209,
  [SMALL_STATE(5421)] = 117253,
  [SMALL_STATE(5422)] = 117297,
  [SMALL_STATE(5423)] = 117355,
  [SMALL_STATE(5424)] = 117407,
  [SMALL_STATE(5425)] = 117463,
  [SMALL_STATE(5426)] = 117519,
  [SMALL_STATE(5427)] = 117571,
  [SMALL_STATE(5428)] = 117615,
  [SMALL_STATE(5429)] = 117671,
  [SMALL_STATE(5430)] = 117723,
  [SMALL_STATE(5431)] = 117781,
  [SMALL_STATE(5432)] = 117821,
  [SMALL_STATE(5433)] = 117877,
  [SMALL_STATE(5434)] = 117919,
  [SMALL_STATE(5435)] = 117965,
  [SMALL_STATE(5436)] = 118005,
  [SMALL_STATE(5437)] = 118061,
  [SMALL_STATE(5438)] = 118113,
  [SMALL_STATE(5439)] = 118167,
  [SMALL_STATE(5440)] = 118223,
  [SMALL_STATE(5441)] = 118265,
  [SMALL_STATE(5442)] = 118307,
  [SMALL_STATE(5443)] = 118359,
  [SMALL_STATE(5444)] = 118415,
  [SMALL_STATE(5445)] = 118469,
  [SMALL_STATE(5446)] = 118513,
  [SMALL_STATE(5447)] = 118557,
  [SMALL_STATE(5448)] = 118601,
  [SMALL_STATE(5449)] = 118645,
  [SMALL_STATE(5450)] = 118689,
  [SMALL_STATE(5451)] = 118729,
  [SMALL_STATE(5452)] = 118773,
  [SMALL_STATE(5453)] = 118819,
  [SMALL_STATE(5454)] = 118859,
  [SMALL_STATE(5455)] = 118899,
  [SMALL_STATE(5456)] = 118955,
  [SMALL_STATE(5457)] = 119011,
  [SMALL_STATE(5458)] = 119063,
  [SMALL_STATE(5459)] = 119103,
  [SMALL_STATE(5460)] = 119143,
  [SMALL_STATE(5461)] = 119183,
  [SMALL_STATE(5462)] = 119239,
  [SMALL_STATE(5463)] = 119297,
  [SMALL_STATE(5464)] = 119353,
  [SMALL_STATE(5465)] = 119395,
  [SMALL_STATE(5466)] = 119435,
  [SMALL_STATE(5467)] = 119475,
  [SMALL_STATE(5468)] = 119523,
  [SMALL_STATE(5469)] = 119567,
  [SMALL_STATE(5470)] = 119611,
  [SMALL_STATE(5471)] = 119651,
  [SMALL_STATE(5472)] = 119691,
  [SMALL_STATE(5473)] = 119743,
  [SMALL_STATE(5474)] = 119783,
  [SMALL_STATE(5475)] = 119829,
  [SMALL_STATE(5476)] = 119885,
  [SMALL_STATE(5477)] = 119925,
  [SMALL_STATE(5478)] = 119981,
  [SMALL_STATE(5479)] = 120037,
  [SMALL_STATE(5480)] = 120083,
  [SMALL_STATE(5481)] = 120135,
  [SMALL_STATE(5482)] = 120181,
  [SMALL_STATE(5483)] = 120235,
  [SMALL_STATE(5484)] = 120281,
  [SMALL_STATE(5485)] = 120323,
  [SMALL_STATE(5486)] = 120375,
  [SMALL_STATE(5487)] = 120431,
  [SMALL_STATE(5488)] = 120487,
  [SMALL_STATE(5489)] = 120531,
  [SMALL_STATE(5490)] = 120581,
  [SMALL_STATE(5491)] = 120639,
  [SMALL_STATE(5492)] = 120695,
  [SMALL_STATE(5493)] = 120737,
  [SMALL_STATE(5494)] = 120789,
  [SMALL_STATE(5495)] = 120841,
  [SMALL_STATE(5496)] = 120897,
  [SMALL_STATE(5497)] = 120949,
  [SMALL_STATE(5498)] = 121005,
  [SMALL_STATE(5499)] = 121061,
  [SMALL_STATE(5500)] = 121113,
  [SMALL_STATE(5501)] = 121165,
  [SMALL_STATE(5502)] = 121209,
  [SMALL_STATE(5503)] = 121265,
  [SMALL_STATE(5504)] = 121321,
  [SMALL_STATE(5505)] = 121377,
  [SMALL_STATE(5506)] = 121421,
  [SMALL_STATE(5507)] = 121477,
  [SMALL_STATE(5508)] = 121533,
  [SMALL_STATE(5509)] = 121589,
  [SMALL_STATE(5510)] = 121633,
  [SMALL_STATE(5511)] = 121687,
  [SMALL_STATE(5512)] = 121739,
  [SMALL_STATE(5513)] = 121783,
  [SMALL_STATE(5514)] = 121839,
  [SMALL_STATE(5515)] = 121881,
  [SMALL_STATE(5516)] = 121937,
  [SMALL_STATE(5517)] = 121989,
  [SMALL_STATE(5518)] = 122035,
  [SMALL_STATE(5519)] = 122091,
  [SMALL_STATE(5520)] = 122147,
  [SMALL_STATE(5521)] = 122201,
  [SMALL_STATE(5522)] = 122245,
  [SMALL_STATE(5523)] = 122289,
  [SMALL_STATE(5524)] = 122333,
  [SMALL_STATE(5525)] = 122385,
  [SMALL_STATE(5526)] = 122427,
  [SMALL_STATE(5527)] = 122471,
  [SMALL_STATE(5528)] = 122523,
  [SMALL_STATE(5529)] = 122567,
  [SMALL_STATE(5530)] = 122611,
  [SMALL_STATE(5531)] = 122669,
  [SMALL_STATE(5532)] = 122713,
  [SMALL_STATE(5533)] = 122769,
  [SMALL_STATE(5534)] = 122811,
  [SMALL_STATE(5535)] = 122867,
  [SMALL_STATE(5536)] = 122923,
  [SMALL_STATE(5537)] = 122967,
  [SMALL_STATE(5538)] = 123019,
  [SMALL_STATE(5539)] = 123071,
  [SMALL_STATE(5540)] = 123113,
  [SMALL_STATE(5541)] = 123169,
  [SMALL_STATE(5542)] = 123215,
  [SMALL_STATE(5543)] = 123267,
  [SMALL_STATE(5544)] = 123321,
  [SMALL_STATE(5545)] = 123365,
  [SMALL_STATE(5546)] = 123409,
  [SMALL_STATE(5547)] = 123463,
  [SMALL_STATE(5548)] = 123507,
  [SMALL_STATE(5549)] = 123563,
  [SMALL_STATE(5550)] = 123607,
  [SMALL_STATE(5551)] = 123653,
  [SMALL_STATE(5552)] = 123699,
  [SMALL_STATE(5553)] = 123755,
  [SMALL_STATE(5554)] = 123799,
  [SMALL_STATE(5555)] = 123841,
  [SMALL_STATE(5556)] = 123885,
  [SMALL_STATE(5557)] = 123941,
  [SMALL_STATE(5558)] = 123987,
  [SMALL_STATE(5559)] = 124043,
  [SMALL_STATE(5560)] = 124095,
  [SMALL_STATE(5561)] = 124149,
  [SMALL_STATE(5562)] = 124193,
  [SMALL_STATE(5563)] = 124245,
  [SMALL_STATE(5564)] = 124301,
  [SMALL_STATE(5565)] = 124345,
  [SMALL_STATE(5566)] = 124389,
  [SMALL_STATE(5567)] = 124433,
  [SMALL_STATE(5568)] = 124477,
  [SMALL_STATE(5569)] = 124533,
  [SMALL_STATE(5570)] = 124589,
  [SMALL_STATE(5571)] = 124631,
  [SMALL_STATE(5572)] = 124687,
  [SMALL_STATE(5573)] = 124745,
  [SMALL_STATE(5574)] = 124801,
  [SMALL_STATE(5575)] = 124857,
  [SMALL_STATE(5576)] = 124901,
  [SMALL_STATE(5577)] = 124945,
  [SMALL_STATE(5578)] = 125001,
  [SMALL_STATE(5579)] = 125057,
  [SMALL_STATE(5580)] = 125109,
  [SMALL_STATE(5581)] = 125161,
  [SMALL_STATE(5582)] = 125205,
  [SMALL_STATE(5583)] = 125249,
  [SMALL_STATE(5584)] = 125303,
  [SMALL_STATE(5585)] = 125355,
  [SMALL_STATE(5586)] = 125407,
  [SMALL_STATE(5587)] = 125465,
  [SMALL_STATE(5588)] = 125511,
  [SMALL_STATE(5589)] = 125555,
  [SMALL_STATE(5590)] = 125607,
  [SMALL_STATE(5591)] = 125659,
  [SMALL_STATE(5592)] = 125711,
  [SMALL_STATE(5593)] = 125767,
  [SMALL_STATE(5594)] = 125823,
  [SMALL_STATE(5595)] = 125879,
  [SMALL_STATE(5596)] = 125931,
  [SMALL_STATE(5597)] = 125977,
  [SMALL_STATE(5598)] = 126033,
  [SMALL_STATE(5599)] = 126089,
  [SMALL_STATE(5600)] = 126145,
  [SMALL_STATE(5601)] = 126197,
  [SMALL_STATE(5602)] = 126253,
  [SMALL_STATE(5603)] = 126295,
  [SMALL_STATE(5604)] = 126347,
  [SMALL_STATE(5605)] = 126389,
  [SMALL_STATE(5606)] = 126441,
  [SMALL_STATE(5607)] = 126499,
  [SMALL_STATE(5608)] = 126557,
  [SMALL_STATE(5609)] = 126609,
  [SMALL_STATE(5610)] = 126661,
  [SMALL_STATE(5611)] = 126713,
  [SMALL_STATE(5612)] = 126757,
  [SMALL_STATE(5613)] = 126801,
  [SMALL_STATE(5614)] = 126853,
  [SMALL_STATE(5615)] = 126905,
  [SMALL_STATE(5616)] = 126957,
  [SMALL_STATE(5617)] = 127015,
  [SMALL_STATE(5618)] = 127067,
  [SMALL_STATE(5619)] = 127123,
  [SMALL_STATE(5620)] = 127175,
  [SMALL_STATE(5621)] = 127227,
  [SMALL_STATE(5622)] = 127282,
  [SMALL_STATE(5623)] = 127323,
  [SMALL_STATE(5624)] = 127364,
  [SMALL_STATE(5625)] = 127405,
  [SMALL_STATE(5626)] = 127460,
  [SMALL_STATE(5627)] = 127515,
  [SMALL_STATE(5628)] = 127570,
  [SMALL_STATE(5629)] = 127625,
  [SMALL_STATE(5630)] = 127680,
  [SMALL_STATE(5631)] = 127723,
  [SMALL_STATE(5632)] = 127766,
  [SMALL_STATE(5633)] = 127821,
  [SMALL_STATE(5634)] = 127862,
  [SMALL_STATE(5635)] = 127917,
  [SMALL_STATE(5636)] = 127960,
  [SMALL_STATE(5637)] = 128003,
  [SMALL_STATE(5638)] = 128058,
  [SMALL_STATE(5639)] = 128101,
  [SMALL_STATE(5640)] = 128156,
  [SMALL_STATE(5641)] = 128199,
  [SMALL_STATE(5642)] = 128240,
  [SMALL_STATE(5643)] = 128293,
  [SMALL_STATE(5644)] = 128338,
  [SMALL_STATE(5645)] = 128393,
  [SMALL_STATE(5646)] = 128434,
  [SMALL_STATE(5647)] = 128475,
  [SMALL_STATE(5648)] = 128520,
  [SMALL_STATE(5649)] = 128563,
  [SMALL_STATE(5650)] = 128618,
  [SMALL_STATE(5651)] = 128659,
  [SMALL_STATE(5652)] = 128702,
  [SMALL_STATE(5653)] = 128745,
  [SMALL_STATE(5654)] = 128800,
  [SMALL_STATE(5655)] = 128855,
  [SMALL_STATE(5656)] = 128902,
  [SMALL_STATE(5657)] = 128943,
  [SMALL_STATE(5658)] = 128998,
  [SMALL_STATE(5659)] = 129039,
  [SMALL_STATE(5660)] = 129080,
  [SMALL_STATE(5661)] = 129121,
  [SMALL_STATE(5662)] = 129162,
  [SMALL_STATE(5663)] = 129205,
  [SMALL_STATE(5664)] = 129260,
  [SMALL_STATE(5665)] = 129315,
  [SMALL_STATE(5666)] = 129370,
  [SMALL_STATE(5667)] = 129419,
  [SMALL_STATE(5668)] = 129474,
  [SMALL_STATE(5669)] = 129529,
  [SMALL_STATE(5670)] = 129584,
  [SMALL_STATE(5671)] = 129639,
  [SMALL_STATE(5672)] = 129694,
  [SMALL_STATE(5673)] = 129735,
  [SMALL_STATE(5674)] = 129776,
  [SMALL_STATE(5675)] = 129831,
  [SMALL_STATE(5676)] = 129886,
  [SMALL_STATE(5677)] = 129941,
  [SMALL_STATE(5678)] = 129996,
  [SMALL_STATE(5679)] = 130051,
  [SMALL_STATE(5680)] = 130106,
  [SMALL_STATE(5681)] = 130153,
  [SMALL_STATE(5682)] = 130208,
  [SMALL_STATE(5683)] = 130249,
  [SMALL_STATE(5684)] = 130290,
  [SMALL_STATE(5685)] = 130333,
  [SMALL_STATE(5686)] = 130388,
  [SMALL_STATE(5687)] = 130443,
  [SMALL_STATE(5688)] = 130484,
  [SMALL_STATE(5689)] = 130539,
  [SMALL_STATE(5690)] = 130594,
  [SMALL_STATE(5691)] = 130649,
  [SMALL_STATE(5692)] = 130704,
  [SMALL_STATE(5693)] = 130745,
  [SMALL_STATE(5694)] = 130786,
  [SMALL_STATE(5695)] = 130829,
  [SMALL_STATE(5696)] = 130870,
  [SMALL_STATE(5697)] = 130925,
  [SMALL_STATE(5698)] = 130980,
  [SMALL_STATE(5699)] = 131021,
  [SMALL_STATE(5700)] = 131076,
  [SMALL_STATE(5701)] = 131117,
  [SMALL_STATE(5702)] = 131172,
  [SMALL_STATE(5703)] = 131227,
  [SMALL_STATE(5704)] = 131282,
  [SMALL_STATE(5705)] = 131337,
  [SMALL_STATE(5706)] = 131392,
  [SMALL_STATE(5707)] = 131447,
  [SMALL_STATE(5708)] = 131494,
  [SMALL_STATE(5709)] = 131537,
  [SMALL_STATE(5710)] = 131592,
  [SMALL_STATE(5711)] = 131633,
  [SMALL_STATE(5712)] = 131688,
  [SMALL_STATE(5713)] = 131743,
  [SMALL_STATE(5714)] = 131784,
  [SMALL_STATE(5715)] = 131837,
  [SMALL_STATE(5716)] = 131878,
  [SMALL_STATE(5717)] = 131933,
  [SMALL_STATE(5718)] = 131974,
  [SMALL_STATE(5719)] = 132017,
  [SMALL_STATE(5720)] = 132072,
  [SMALL_STATE(5721)] = 132115,
  [SMALL_STATE(5722)] = 132158,
  [SMALL_STATE(5723)] = 132201,
  [SMALL_STATE(5724)] = 132244,
  [SMALL_STATE(5725)] = 132287,
  [SMALL_STATE(5726)] = 132332,
  [SMALL_STATE(5727)] = 132387,
  [SMALL_STATE(5728)] = 132428,
  [SMALL_STATE(5729)] = 132471,
  [SMALL_STATE(5730)] = 132526,
  [SMALL_STATE(5731)] = 132581,
  [SMALL_STATE(5732)] = 132622,
  [SMALL_STATE(5733)] = 132677,
  [SMALL_STATE(5734)] = 132732,
  [SMALL_STATE(5735)] = 132787,
  [SMALL_STATE(5736)] = 132828,
  [SMALL_STATE(5737)] = 132869,
  [SMALL_STATE(5738)] = 132910,
  [SMALL_STATE(5739)] = 132965,
  [SMALL_STATE(5740)] = 133020,
  [SMALL_STATE(5741)] = 133069,
  [SMALL_STATE(5742)] = 133124,
  [SMALL_STATE(5743)] = 133165,
  [SMALL_STATE(5744)] = 133220,
  [SMALL_STATE(5745)] = 133261,
  [SMALL_STATE(5746)] = 133304,
  [SMALL_STATE(5747)] = 133359,
  [SMALL_STATE(5748)] = 133406,
  [SMALL_STATE(5749)] = 133461,
  [SMALL_STATE(5750)] = 133516,
  [SMALL_STATE(5751)] = 133571,
  [SMALL_STATE(5752)] = 133612,
  [SMALL_STATE(5753)] = 133667,
  [SMALL_STATE(5754)] = 133708,
  [SMALL_STATE(5755)] = 133761,
  [SMALL_STATE(5756)] = 133806,
  [SMALL_STATE(5757)] = 133853,
  [SMALL_STATE(5758)] = 133894,
  [SMALL_STATE(5759)] = 133949,
  [SMALL_STATE(5760)] = 133990,
  [SMALL_STATE(5761)] = 134045,
  [SMALL_STATE(5762)] = 134100,
  [SMALL_STATE(5763)] = 134155,
  [SMALL_STATE(5764)] = 134196,
  [SMALL_STATE(5765)] = 134251,
  [SMALL_STATE(5766)] = 134306,
  [SMALL_STATE(5767)] = 134361,
  [SMALL_STATE(5768)] = 134406,
  [SMALL_STATE(5769)] = 134447,
  [SMALL_STATE(5770)] = 134500,
  [SMALL_STATE(5771)] = 134555,
  [SMALL_STATE(5772)] = 134610,
  [SMALL_STATE(5773)] = 134663,
  [SMALL_STATE(5774)] = 134708,
  [SMALL_STATE(5775)] = 134749,
  [SMALL_STATE(5776)] = 134790,
  [SMALL_STATE(5777)] = 134833,
  [SMALL_STATE(5778)] = 134888,
  [SMALL_STATE(5779)] = 134929,
  [SMALL_STATE(5780)] = 134984,
  [SMALL_STATE(5781)] = 135037,
  [SMALL_STATE(5782)] = 135080,
  [SMALL_STATE(5783)] = 135123,
  [SMALL_STATE(5784)] = 135178,
  [SMALL_STATE(5785)] = 135219,
  [SMALL_STATE(5786)] = 135260,
  [SMALL_STATE(5787)] = 135303,
  [SMALL_STATE(5788)] = 135350,
  [SMALL_STATE(5789)] = 135393,
  [SMALL_STATE(5790)] = 135434,
  [SMALL_STATE(5791)] = 135489,
  [SMALL_STATE(5792)] = 135530,
  [SMALL_STATE(5793)] = 135585,
  [SMALL_STATE(5794)] = 135638,
  [SMALL_STATE(5795)] = 135693,
  [SMALL_STATE(5796)] = 135746,
  [SMALL_STATE(5797)] = 135789,
  [SMALL_STATE(5798)] = 135844,
  [SMALL_STATE(5799)] = 135885,
  [SMALL_STATE(5800)] = 135940,
  [SMALL_STATE(5801)] = 135995,
  [SMALL_STATE(5802)] = 136038,
  [SMALL_STATE(5803)] = 136093,
  [SMALL_STATE(5804)] = 136146,
  [SMALL_STATE(5805)] = 136189,
  [SMALL_STATE(5806)] = 136232,
  [SMALL_STATE(5807)] = 136273,
  [SMALL_STATE(5808)] = 136316,
  [SMALL_STATE(5809)] = 136357,
  [SMALL_STATE(5810)] = 136400,
  [SMALL_STATE(5811)] = 136441,
  [SMALL_STATE(5812)] = 136496,
  [SMALL_STATE(5813)] = 136551,
  [SMALL_STATE(5814)] = 136594,
  [SMALL_STATE(5815)] = 136635,
  [SMALL_STATE(5816)] = 136675,
  [SMALL_STATE(5817)] = 136715,
  [SMALL_STATE(5818)] = 136759,
  [SMALL_STATE(5819)] = 136811,
  [SMALL_STATE(5820)] = 136861,
  [SMALL_STATE(5821)] = 136913,
  [SMALL_STATE(5822)] = 136965,
  [SMALL_STATE(5823)] = 137005,
  [SMALL_STATE(5824)] = 137057,
  [SMALL_STATE(5825)] = 137109,
  [SMALL_STATE(5826)] = 137161,
  [SMALL_STATE(5827)] = 137213,
  [SMALL_STATE(5828)] = 137265,
  [SMALL_STATE(5829)] = 137317,
  [SMALL_STATE(5830)] = 137369,
  [SMALL_STATE(5831)] = 137421,
  [SMALL_STATE(5832)] = 137473,
  [SMALL_STATE(5833)] = 137525,
  [SMALL_STATE(5834)] = 137567,
  [SMALL_STATE(5835)] = 137619,
  [SMALL_STATE(5836)] = 137671,
  [SMALL_STATE(5837)] = 137723,
  [SMALL_STATE(5838)] = 137775,
  [SMALL_STATE(5839)] = 137817,
  [SMALL_STATE(5840)] = 137859,
  [SMALL_STATE(5841)] = 137903,
  [SMALL_STATE(5842)] = 137945,
  [SMALL_STATE(5843)] = 137997,
  [SMALL_STATE(5844)] = 138049,
  [SMALL_STATE(5845)] = 138091,
  [SMALL_STATE(5846)] = 138143,
  [SMALL_STATE(5847)] = 138195,
  [SMALL_STATE(5848)] = 138247,
  [SMALL_STATE(5849)] = 138299,
  [SMALL_STATE(5850)] = 138341,
  [SMALL_STATE(5851)] = 138391,
  [SMALL_STATE(5852)] = 138441,
  [SMALL_STATE(5853)] = 138481,
  [SMALL_STATE(5854)] = 138533,
  [SMALL_STATE(5855)] = 138585,
  [SMALL_STATE(5856)] = 138637,
  [SMALL_STATE(5857)] = 138687,
  [SMALL_STATE(5858)] = 138735,
  [SMALL_STATE(5859)] = 138785,
  [SMALL_STATE(5860)] = 138837,
  [SMALL_STATE(5861)] = 138889,
  [SMALL_STATE(5862)] = 138941,
  [SMALL_STATE(5863)] = 138993,
  [SMALL_STATE(5864)] = 139045,
  [SMALL_STATE(5865)] = 139097,
  [SMALL_STATE(5866)] = 139149,
  [SMALL_STATE(5867)] = 139189,
  [SMALL_STATE(5868)] = 139241,
  [SMALL_STATE(5869)] = 139293,
  [SMALL_STATE(5870)] = 139335,
  [SMALL_STATE(5871)] = 139375,
  [SMALL_STATE(5872)] = 139427,
  [SMALL_STATE(5873)] = 139479,
  [SMALL_STATE(5874)] = 139529,
  [SMALL_STATE(5875)] = 139581,
  [SMALL_STATE(5876)] = 139633,
  [SMALL_STATE(5877)] = 139685,
  [SMALL_STATE(5878)] = 139725,
  [SMALL_STATE(5879)] = 139777,
  [SMALL_STATE(5880)] = 139829,
  [SMALL_STATE(5881)] = 139881,
  [SMALL_STATE(5882)] = 139931,
  [SMALL_STATE(5883)] = 139983,
  [SMALL_STATE(5884)] = 140032,
  [SMALL_STATE(5885)] = 140079,
  [SMALL_STATE(5886)] = 140128,
  [SMALL_STATE(5887)] = 140175,
  [SMALL_STATE(5888)] = 140224,
  [SMALL_STATE(5889)] = 140271,
  [SMALL_STATE(5890)] = 140318,
  [SMALL_STATE(5891)] = 140367,
  [SMALL_STATE(5892)] = 140416,
  [SMALL_STATE(5893)] = 140465,
  [SMALL_STATE(5894)] = 140514,
  [SMALL_STATE(5895)] = 140561,
  [SMALL_STATE(5896)] = 140608,
  [SMALL_STATE(5897)] = 140657,
  [SMALL_STATE(5898)] = 140706,
  [SMALL_STATE(5899)] = 140755,
  [SMALL_STATE(5900)] = 140804,
  [SMALL_STATE(5901)] = 140851,
  [SMALL_STATE(5902)] = 140900,
  [SMALL_STATE(5903)] = 140947,
  [SMALL_STATE(5904)] = 140994,
  [SMALL_STATE(5905)] = 141043,
  [SMALL_STATE(5906)] = 141082,
  [SMALL_STATE(5907)] = 141129,
  [SMALL_STATE(5908)] = 141178,
  [SMALL_STATE(5909)] = 141225,
  [SMALL_STATE(5910)] = 141274,
  [SMALL_STATE(5911)] = 141321,
  [SMALL_STATE(5912)] = 141368,
  [SMALL_STATE(5913)] = 141415,
  [SMALL_STATE(5914)] = 141462,
  [SMALL_STATE(5915)] = 141509,
  [SMALL_STATE(5916)] = 141556,
  [SMALL_STATE(5917)] = 141605,
  [SMALL_STATE(5918)] = 141646,
  [SMALL_STATE(5919)] = 141695,
  [SMALL_STATE(5920)] = 141742,
  [SMALL_STATE(5921)] = 141781,
  [SMALL_STATE(5922)] = 141830,
  [SMALL_STATE(5923)] = 141877,
  [SMALL_STATE(5924)] = 141926,
  [SMALL_STATE(5925)] = 141975,
  [SMALL_STATE(5926)] = 142024,
  [SMALL_STATE(5927)] = 142073,
  [SMALL_STATE(5928)] = 142122,
  [SMALL_STATE(5929)] = 142171,
  [SMALL_STATE(5930)] = 142218,
  [SMALL_STATE(5931)] = 142257,
  [SMALL_STATE(5932)] = 142300,
  [SMALL_STATE(5933)] = 142346,
  [SMALL_STATE(5934)] = 142392,
  [SMALL_STATE(5935)] = 142430,
  [SMALL_STATE(5936)] = 142476,
  [SMALL_STATE(5937)] = 142522,
  [SMALL_STATE(5938)] = 142568,
  [SMALL_STATE(5939)] = 142606,
  [SMALL_STATE(5940)] = 142652,
  [SMALL_STATE(5941)] = 142690,
  [SMALL_STATE(5942)] = 142728,
  [SMALL_STATE(5943)] = 142774,
  [SMALL_STATE(5944)] = 142816,
  [SMALL_STATE(5945)] = 142862,
  [SMALL_STATE(5946)] = 142908,
  [SMALL_STATE(5947)] = 142954,
  [SMALL_STATE(5948)] = 143000,
  [SMALL_STATE(5949)] = 143046,
  [SMALL_STATE(5950)] = 143092,
  [SMALL_STATE(5951)] = 143138,
  [SMALL_STATE(5952)] = 143178,
  [SMALL_STATE(5953)] = 143224,
  [SMALL_STATE(5954)] = 143270,
  [SMALL_STATE(5955)] = 143316,
  [SMALL_STATE(5956)] = 143362,
  [SMALL_STATE(5957)] = 143408,
  [SMALL_STATE(5958)] = 143454,
  [SMALL_STATE(5959)] = 143500,
  [SMALL_STATE(5960)] = 143546,
  [SMALL_STATE(5961)] = 143592,
  [SMALL_STATE(5962)] = 143638,
  [SMALL_STATE(5963)] = 143684,
  [SMALL_STATE(5964)] = 143730,
  [SMALL_STATE(5965)] = 143776,
  [SMALL_STATE(5966)] = 143822,
  [SMALL_STATE(5967)] = 143868,
  [SMALL_STATE(5968)] = 143906,
  [SMALL_STATE(5969)] = 143952,
  [SMALL_STATE(5970)] = 143998,
  [SMALL_STATE(5971)] = 144041,
  [SMALL_STATE(5972)] = 144084,
  [SMALL_STATE(5973)] = 144127,
  [SMALL_STATE(5974)] = 144170,
  [SMALL_STATE(5975)] = 144211,
  [SMALL_STATE(5976)] = 144254,
  [SMALL_STATE(5977)] = 144297,
  [SMALL_STATE(5978)] = 144340,
  [SMALL_STATE(5979)] = 144383,
  [SMALL_STATE(5980)] = 144426,
  [SMALL_STATE(5981)] = 144469,
  [SMALL_STATE(5982)] = 144512,
  [SMALL_STATE(5983)] = 144549,
  [SMALL_STATE(5984)] = 144590,
  [SMALL_STATE(5985)] = 144633,
  [SMALL_STATE(5986)] = 144670,
  [SMALL_STATE(5987)] = 144711,
  [SMALL_STATE(5988)] = 144754,
  [SMALL_STATE(5989)] = 144797,
  [SMALL_STATE(5990)] = 144840,
  [SMALL_STATE(5991)] = 144883,
  [SMALL_STATE(5992)] = 144926,
  [SMALL_STATE(5993)] = 144967,
  [SMALL_STATE(5994)] = 145008,
  [SMALL_STATE(5995)] = 145051,
  [SMALL_STATE(5996)] = 145094,
  [SMALL_STATE(5997)] = 145137,
  [SMALL_STATE(5998)] = 145180,
  [SMALL_STATE(5999)] = 145223,
  [SMALL_STATE(6000)] = 145264,
  [SMALL_STATE(6001)] = 145307,
  [SMALL_STATE(6002)] = 145350,
  [SMALL_STATE(6003)] = 145393,
  [SMALL_STATE(6004)] = 145436,
  [SMALL_STATE(6005)] = 145479,
  [SMALL_STATE(6006)] = 145522,
  [SMALL_STATE(6007)] = 145565,
  [SMALL_STATE(6008)] = 145608,
  [SMALL_STATE(6009)] = 145649,
  [SMALL_STATE(6010)] = 145692,
  [SMALL_STATE(6011)] = 145735,
  [SMALL_STATE(6012)] = 145778,
  [SMALL_STATE(6013)] = 145821,
  [SMALL_STATE(6014)] = 145862,
  [SMALL_STATE(6015)] = 145905,
  [SMALL_STATE(6016)] = 145948,
  [SMALL_STATE(6017)] = 145991,
  [SMALL_STATE(6018)] = 146034,
  [SMALL_STATE(6019)] = 146075,
  [SMALL_STATE(6020)] = 146118,
  [SMALL_STATE(6021)] = 146161,
  [SMALL_STATE(6022)] = 146204,
  [SMALL_STATE(6023)] = 146247,
  [SMALL_STATE(6024)] = 146286,
  [SMALL_STATE(6025)] = 146329,
  [SMALL_STATE(6026)] = 146372,
  [SMALL_STATE(6027)] = 146415,
  [SMALL_STATE(6028)] = 146458,
  [SMALL_STATE(6029)] = 146501,
  [SMALL_STATE(6030)] = 146544,
  [SMALL_STATE(6031)] = 146587,
  [SMALL_STATE(6032)] = 146630,
  [SMALL_STATE(6033)] = 146673,
  [SMALL_STATE(6034)] = 146708,
  [SMALL_STATE(6035)] = 146749,
  [SMALL_STATE(6036)] = 146792,
  [SMALL_STATE(6037)] = 146835,
  [SMALL_STATE(6038)] = 146878,
  [SMALL_STATE(6039)] = 146921,
  [SMALL_STATE(6040)] = 146964,
  [SMALL_STATE(6041)] = 147007,
  [SMALL_STATE(6042)] = 147042,
  [SMALL_STATE(6043)] = 147085,
  [SMALL_STATE(6044)] = 147128,
  [SMALL_STATE(6045)] = 147171,
  [SMALL_STATE(6046)] = 147214,
  [SMALL_STATE(6047)] = 147257,
  [SMALL_STATE(6048)] = 147298,
  [SMALL_STATE(6049)] = 147341,
  [SMALL_STATE(6050)] = 147384,
  [SMALL_STATE(6051)] = 147427,
  [SMALL_STATE(6052)] = 147470,
  [SMALL_STATE(6053)] = 147513,
  [SMALL_STATE(6054)] = 147556,
  [SMALL_STATE(6055)] = 147599,
  [SMALL_STATE(6056)] = 147642,
  [SMALL_STATE(6057)] = 147685,
  [SMALL_STATE(6058)] = 147728,
  [SMALL_STATE(6059)] = 147769,
  [SMALL_STATE(6060)] = 147812,
  [SMALL_STATE(6061)] = 147855,
  [SMALL_STATE(6062)] = 147896,
  [SMALL_STATE(6063)] = 147939,
  [SMALL_STATE(6064)] = 147982,
  [SMALL_STATE(6065)] = 148023,
  [SMALL_STATE(6066)] = 148066,
  [SMALL_STATE(6067)] = 148109,
  [SMALL_STATE(6068)] = 148150,
  [SMALL_STATE(6069)] = 148193,
  [SMALL_STATE(6070)] = 148236,
  [SMALL_STATE(6071)] = 148277,
  [SMALL_STATE(6072)] = 148320,
  [SMALL_STATE(6073)] = 148363,
  [SMALL_STATE(6074)] = 148404,
  [SMALL_STATE(6075)] = 148445,
  [SMALL_STATE(6076)] = 148488,
  [SMALL_STATE(6077)] = 148531,
  [SMALL_STATE(6078)] = 148572,
  [SMALL_STATE(6079)] = 148615,
  [SMALL_STATE(6080)] = 148656,
  [SMALL_STATE(6081)] = 148699,
  [SMALL_STATE(6082)] = 148742,
  [SMALL_STATE(6083)] = 148785,
  [SMALL_STATE(6084)] = 148828,
  [SMALL_STATE(6085)] = 148871,
  [SMALL_STATE(6086)] = 148914,
  [SMALL_STATE(6087)] = 148955,
  [SMALL_STATE(6088)] = 148996,
  [SMALL_STATE(6089)] = 149039,
  [SMALL_STATE(6090)] = 149082,
  [SMALL_STATE(6091)] = 149125,
  [SMALL_STATE(6092)] = 149166,
  [SMALL_STATE(6093)] = 149209,
  [SMALL_STATE(6094)] = 149252,
  [SMALL_STATE(6095)] = 149293,
  [SMALL_STATE(6096)] = 149334,
  [SMALL_STATE(6097)] = 149377,
  [SMALL_STATE(6098)] = 149420,
  [SMALL_STATE(6099)] = 149463,
  [SMALL_STATE(6100)] = 149504,
  [SMALL_STATE(6101)] = 149547,
  [SMALL_STATE(6102)] = 149588,
  [SMALL_STATE(6103)] = 149631,
  [SMALL_STATE(6104)] = 149674,
  [SMALL_STATE(6105)] = 149717,
  [SMALL_STATE(6106)] = 149758,
  [SMALL_STATE(6107)] = 149801,
  [SMALL_STATE(6108)] = 149842,
  [SMALL_STATE(6109)] = 149883,
  [SMALL_STATE(6110)] = 149926,
  [SMALL_STATE(6111)] = 149969,
  [SMALL_STATE(6112)] = 150012,
  [SMALL_STATE(6113)] = 150055,
  [SMALL_STATE(6114)] = 150098,
  [SMALL_STATE(6115)] = 150133,
  [SMALL_STATE(6116)] = 150176,
  [SMALL_STATE(6117)] = 150219,
  [SMALL_STATE(6118)] = 150262,
  [SMALL_STATE(6119)] = 150305,
  [SMALL_STATE(6120)] = 150348,
  [SMALL_STATE(6121)] = 150391,
  [SMALL_STATE(6122)] = 150434,
  [SMALL_STATE(6123)] = 150475,
  [SMALL_STATE(6124)] = 150516,
  [SMALL_STATE(6125)] = 150559,
  [SMALL_STATE(6126)] = 150602,
  [SMALL_STATE(6127)] = 150645,
  [SMALL_STATE(6128)] = 150685,
  [SMALL_STATE(6129)] = 150719,
  [SMALL_STATE(6130)] = 150753,
  [SMALL_STATE(6131)] = 150793,
  [SMALL_STATE(6132)] = 150827,
  [SMALL_STATE(6133)] = 150867,
  [SMALL_STATE(6134)] = 150901,
  [SMALL_STATE(6135)] = 150935,
  [SMALL_STATE(6136)] = 150975,
  [SMALL_STATE(6137)] = 151015,
  [SMALL_STATE(6138)] = 151055,
  [SMALL_STATE(6139)] = 151095,
  [SMALL_STATE(6140)] = 151129,
  [SMALL_STATE(6141)] = 151163,
  [SMALL_STATE(6142)] = 151203,
  [SMALL_STATE(6143)] = 151243,
  [SMALL_STATE(6144)] = 151283,
  [SMALL_STATE(6145)] = 151319,
  [SMALL_STATE(6146)] = 151359,
  [SMALL_STATE(6147)] = 151399,
  [SMALL_STATE(6148)] = 151439,
  [SMALL_STATE(6149)] = 151479,
  [SMALL_STATE(6150)] = 151515,
  [SMALL_STATE(6151)] = 151549,
  [SMALL_STATE(6152)] = 151589,
  [SMALL_STATE(6153)] = 151629,
  [SMALL_STATE(6154)] = 151669,
  [SMALL_STATE(6155)] = 151705,
  [SMALL_STATE(6156)] = 151745,
  [SMALL_STATE(6157)] = 151783,
  [SMALL_STATE(6158)] = 151823,
  [SMALL_STATE(6159)] = 151863,
  [SMALL_STATE(6160)] = 151901,
  [SMALL_STATE(6161)] = 151939,
  [SMALL_STATE(6162)] = 151979,
  [SMALL_STATE(6163)] = 152013,
  [SMALL_STATE(6164)] = 152051,
  [SMALL_STATE(6165)] = 152091,
  [SMALL_STATE(6166)] = 152131,
  [SMALL_STATE(6167)] = 152165,
  [SMALL_STATE(6168)] = 152205,
  [SMALL_STATE(6169)] = 152245,
  [SMALL_STATE(6170)] = 152283,
  [SMALL_STATE(6171)] = 152323,
  [SMALL_STATE(6172)] = 152361,
  [SMALL_STATE(6173)] = 152401,
  [SMALL_STATE(6174)] = 152441,
  [SMALL_STATE(6175)] = 152477,
  [SMALL_STATE(6176)] = 152517,
  [SMALL_STATE(6177)] = 152557,
  [SMALL_STATE(6178)] = 152597,
  [SMALL_STATE(6179)] = 152637,
  [SMALL_STATE(6180)] = 152671,
  [SMALL_STATE(6181)] = 152709,
  [SMALL_STATE(6182)] = 152749,
  [SMALL_STATE(6183)] = 152789,
  [SMALL_STATE(6184)] = 152829,
  [SMALL_STATE(6185)] = 152869,
  [SMALL_STATE(6186)] = 152909,
  [SMALL_STATE(6187)] = 152949,
  [SMALL_STATE(6188)] = 152989,
  [SMALL_STATE(6189)] = 153029,
  [SMALL_STATE(6190)] = 153063,
  [SMALL_STATE(6191)] = 153103,
  [SMALL_STATE(6192)] = 153143,
  [SMALL_STATE(6193)] = 153183,
  [SMALL_STATE(6194)] = 153223,
  [SMALL_STATE(6195)] = 153261,
  [SMALL_STATE(6196)] = 153301,
  [SMALL_STATE(6197)] = 153341,
  [SMALL_STATE(6198)] = 153381,
  [SMALL_STATE(6199)] = 153421,
  [SMALL_STATE(6200)] = 153459,
  [SMALL_STATE(6201)] = 153499,
  [SMALL_STATE(6202)] = 153533,
  [SMALL_STATE(6203)] = 153573,
  [SMALL_STATE(6204)] = 153607,
  [SMALL_STATE(6205)] = 153647,
  [SMALL_STATE(6206)] = 153687,
  [SMALL_STATE(6207)] = 153721,
  [SMALL_STATE(6208)] = 153755,
  [SMALL_STATE(6209)] = 153795,
  [SMALL_STATE(6210)] = 153835,
  [SMALL_STATE(6211)] = 153875,
  [SMALL_STATE(6212)] = 153915,
  [SMALL_STATE(6213)] = 153949,
  [SMALL_STATE(6214)] = 153989,
  [SMALL_STATE(6215)] = 154023,
  [SMALL_STATE(6216)] = 154063,
  [SMALL_STATE(6217)] = 154103,
  [SMALL_STATE(6218)] = 154143,
  [SMALL_STATE(6219)] = 154183,
  [SMALL_STATE(6220)] = 154223,
  [SMALL_STATE(6221)] = 154263,
  [SMALL_STATE(6222)] = 154303,
  [SMALL_STATE(6223)] = 154343,
  [SMALL_STATE(6224)] = 154383,
  [SMALL_STATE(6225)] = 154423,
  [SMALL_STATE(6226)] = 154463,
  [SMALL_STATE(6227)] = 154501,
  [SMALL_STATE(6228)] = 154541,
  [SMALL_STATE(6229)] = 154575,
  [SMALL_STATE(6230)] = 154615,
  [SMALL_STATE(6231)] = 154649,
  [SMALL_STATE(6232)] = 154689,
  [SMALL_STATE(6233)] = 154729,
  [SMALL_STATE(6234)] = 154763,
  [SMALL_STATE(6235)] = 154800,
  [SMALL_STATE(6236)] = 154835,
  [SMALL_STATE(6237)] = 154868,
  [SMALL_STATE(6238)] = 154903,
  [SMALL_STATE(6239)] = 154938,
  [SMALL_STATE(6240)] = 154975,
  [SMALL_STATE(6241)] = 155012,
  [SMALL_STATE(6242)] = 155049,
  [SMALL_STATE(6243)] = 155086,
  [SMALL_STATE(6244)] = 155123,
  [SMALL_STATE(6245)] = 155156,
  [SMALL_STATE(6246)] = 155189,
  [SMALL_STATE(6247)] = 155226,
  [SMALL_STATE(6248)] = 155263,
  [SMALL_STATE(6249)] = 155300,
  [SMALL_STATE(6250)] = 155333,
  [SMALL_STATE(6251)] = 155366,
  [SMALL_STATE(6252)] = 155399,
  [SMALL_STATE(6253)] = 155436,
  [SMALL_STATE(6254)] = 155473,
  [SMALL_STATE(6255)] = 155510,
  [SMALL_STATE(6256)] = 155545,
  [SMALL_STATE(6257)] = 155580,
  [SMALL_STATE(6258)] = 155617,
  [SMALL_STATE(6259)] = 155654,
  [SMALL_STATE(6260)] = 155687,
  [SMALL_STATE(6261)] = 155724,
  [SMALL_STATE(6262)] = 155761,
  [SMALL_STATE(6263)] = 155798,
  [SMALL_STATE(6264)] = 155835,
  [SMALL_STATE(6265)] = 155872,
  [SMALL_STATE(6266)] = 155909,
  [SMALL_STATE(6267)] = 155944,
  [SMALL_STATE(6268)] = 155981,
  [SMALL_STATE(6269)] = 156018,
  [SMALL_STATE(6270)] = 156055,
  [SMALL_STATE(6271)] = 156092,
  [SMALL_STATE(6272)] = 156127,
  [SMALL_STATE(6273)] = 156164,
  [SMALL_STATE(6274)] = 156199,
  [SMALL_STATE(6275)] = 156236,
  [SMALL_STATE(6276)] = 156273,
  [SMALL_STATE(6277)] = 156310,
  [SMALL_STATE(6278)] = 156347,
  [SMALL_STATE(6279)] = 156382,
  [SMALL_STATE(6280)] = 156419,
  [SMALL_STATE(6281)] = 156454,
  [SMALL_STATE(6282)] = 156487,
  [SMALL_STATE(6283)] = 156524,
  [SMALL_STATE(6284)] = 156561,
  [SMALL_STATE(6285)] = 156598,
  [SMALL_STATE(6286)] = 156633,
  [SMALL_STATE(6287)] = 156670,
  [SMALL_STATE(6288)] = 156707,
  [SMALL_STATE(6289)] = 156744,
  [SMALL_STATE(6290)] = 156781,
  [SMALL_STATE(6291)] = 156818,
  [SMALL_STATE(6292)] = 156855,
  [SMALL_STATE(6293)] = 156888,
  [SMALL_STATE(6294)] = 156921,
  [SMALL_STATE(6295)] = 156954,
  [SMALL_STATE(6296)] = 156987,
  [SMALL_STATE(6297)] = 157022,
  [SMALL_STATE(6298)] = 157059,
  [SMALL_STATE(6299)] = 157096,
  [SMALL_STATE(6300)] = 157133,
  [SMALL_STATE(6301)] = 157170,
  [SMALL_STATE(6302)] = 157203,
  [SMALL_STATE(6303)] = 157238,
  [SMALL_STATE(6304)] = 157275,
  [SMALL_STATE(6305)] = 157312,
  [SMALL_STATE(6306)] = 157349,
  [SMALL_STATE(6307)] = 157386,
  [SMALL_STATE(6308)] = 157421,
  [SMALL_STATE(6309)] = 157458,
  [SMALL_STATE(6310)] = 157495,
  [SMALL_STATE(6311)] = 157532,
  [SMALL_STATE(6312)] = 157567,
  [SMALL_STATE(6313)] = 157600,
  [SMALL_STATE(6314)] = 157637,
  [SMALL_STATE(6315)] = 157674,
  [SMALL_STATE(6316)] = 157711,
  [SMALL_STATE(6317)] = 157748,
  [SMALL_STATE(6318)] = 157785,
  [SMALL_STATE(6319)] = 157822,
  [SMALL_STATE(6320)] = 157859,
  [SMALL_STATE(6321)] = 157894,
  [SMALL_STATE(6322)] = 157931,
  [SMALL_STATE(6323)] = 157968,
  [SMALL_STATE(6324)] = 158005,
  [SMALL_STATE(6325)] = 158038,
  [SMALL_STATE(6326)] = 158075,
  [SMALL_STATE(6327)] = 158112,
  [SMALL_STATE(6328)] = 158149,
  [SMALL_STATE(6329)] = 158182,
  [SMALL_STATE(6330)] = 158215,
  [SMALL_STATE(6331)] = 158248,
  [SMALL_STATE(6332)] = 158281,
  [SMALL_STATE(6333)] = 158318,
  [SMALL_STATE(6334)] = 158355,
  [SMALL_STATE(6335)] = 158388,
  [SMALL_STATE(6336)] = 158425,
  [SMALL_STATE(6337)] = 158460,
  [SMALL_STATE(6338)] = 158497,
  [SMALL_STATE(6339)] = 158534,
  [SMALL_STATE(6340)] = 158571,
  [SMALL_STATE(6341)] = 158608,
  [SMALL_STATE(6342)] = 158645,
  [SMALL_STATE(6343)] = 158682,
  [SMALL_STATE(6344)] = 158719,
  [SMALL_STATE(6345)] = 158756,
  [SMALL_STATE(6346)] = 158793,
  [SMALL_STATE(6347)] = 158828,
  [SMALL_STATE(6348)] = 158865,
  [SMALL_STATE(6349)] = 158900,
  [SMALL_STATE(6350)] = 158937,
  [SMALL_STATE(6351)] = 158974,
  [SMALL_STATE(6352)] = 159009,
  [SMALL_STATE(6353)] = 159046,
  [SMALL_STATE(6354)] = 159081,
  [SMALL_STATE(6355)] = 159118,
  [SMALL_STATE(6356)] = 159153,
  [SMALL_STATE(6357)] = 159190,
  [SMALL_STATE(6358)] = 159227,
  [SMALL_STATE(6359)] = 159264,
  [SMALL_STATE(6360)] = 159301,
  [SMALL_STATE(6361)] = 159338,
  [SMALL_STATE(6362)] = 159375,
  [SMALL_STATE(6363)] = 159412,
  [SMALL_STATE(6364)] = 159449,
  [SMALL_STATE(6365)] = 159486,
  [SMALL_STATE(6366)] = 159523,
  [SMALL_STATE(6367)] = 159560,
  [SMALL_STATE(6368)] = 159597,
  [SMALL_STATE(6369)] = 159634,
  [SMALL_STATE(6370)] = 159669,
  [SMALL_STATE(6371)] = 159704,
  [SMALL_STATE(6372)] = 159739,
  [SMALL_STATE(6373)] = 159776,
  [SMALL_STATE(6374)] = 159813,
  [SMALL_STATE(6375)] = 159850,
  [SMALL_STATE(6376)] = 159887,
  [SMALL_STATE(6377)] = 159922,
  [SMALL_STATE(6378)] = 159959,
  [SMALL_STATE(6379)] = 159994,
  [SMALL_STATE(6380)] = 160029,
  [SMALL_STATE(6381)] = 160064,
  [SMALL_STATE(6382)] = 160101,
  [SMALL_STATE(6383)] = 160138,
  [SMALL_STATE(6384)] = 160175,
  [SMALL_STATE(6385)] = 160210,
  [SMALL_STATE(6386)] = 160247,
  [SMALL_STATE(6387)] = 160284,
  [SMALL_STATE(6388)] = 160321,
  [SMALL_STATE(6389)] = 160358,
  [SMALL_STATE(6390)] = 160395,
  [SMALL_STATE(6391)] = 160432,
  [SMALL_STATE(6392)] = 160469,
  [SMALL_STATE(6393)] = 160504,
  [SMALL_STATE(6394)] = 160541,
  [SMALL_STATE(6395)] = 160578,
  [SMALL_STATE(6396)] = 160615,
  [SMALL_STATE(6397)] = 160652,
  [SMALL_STATE(6398)] = 160689,
  [SMALL_STATE(6399)] = 160726,
  [SMALL_STATE(6400)] = 160763,
  [SMALL_STATE(6401)] = 160800,
  [SMALL_STATE(6402)] = 160837,
  [SMALL_STATE(6403)] = 160872,
  [SMALL_STATE(6404)] = 160909,
  [SMALL_STATE(6405)] = 160946,
  [SMALL_STATE(6406)] = 160983,
  [SMALL_STATE(6407)] = 161020,
  [SMALL_STATE(6408)] = 161057,
  [SMALL_STATE(6409)] = 161090,
  [SMALL_STATE(6410)] = 161127,
  [SMALL_STATE(6411)] = 161160,
  [SMALL_STATE(6412)] = 161197,
  [SMALL_STATE(6413)] = 161232,
  [SMALL_STATE(6414)] = 161269,
  [SMALL_STATE(6415)] = 161306,
  [SMALL_STATE(6416)] = 161341,
  [SMALL_STATE(6417)] = 161374,
  [SMALL_STATE(6418)] = 161409,
  [SMALL_STATE(6419)] = 161442,
  [SMALL_STATE(6420)] = 161477,
  [SMALL_STATE(6421)] = 161514,
  [SMALL_STATE(6422)] = 161551,
  [SMALL_STATE(6423)] = 161584,
  [SMALL_STATE(6424)] = 161621,
  [SMALL_STATE(6425)] = 161654,
  [SMALL_STATE(6426)] = 161691,
  [SMALL_STATE(6427)] = 161728,
  [SMALL_STATE(6428)] = 161765,
  [SMALL_STATE(6429)] = 161802,
  [SMALL_STATE(6430)] = 161835,
  [SMALL_STATE(6431)] = 161872,
  [SMALL_STATE(6432)] = 161907,
  [SMALL_STATE(6433)] = 161944,
  [SMALL_STATE(6434)] = 161981,
  [SMALL_STATE(6435)] = 162014,
  [SMALL_STATE(6436)] = 162047,
  [SMALL_STATE(6437)] = 162082,
  [SMALL_STATE(6438)] = 162119,
  [SMALL_STATE(6439)] = 162156,
  [SMALL_STATE(6440)] = 162193,
  [SMALL_STATE(6441)] = 162228,
  [SMALL_STATE(6442)] = 162265,
  [SMALL_STATE(6443)] = 162298,
  [SMALL_STATE(6444)] = 162335,
  [SMALL_STATE(6445)] = 162372,
  [SMALL_STATE(6446)] = 162407,
  [SMALL_STATE(6447)] = 162442,
  [SMALL_STATE(6448)] = 162479,
  [SMALL_STATE(6449)] = 162516,
  [SMALL_STATE(6450)] = 162553,
  [SMALL_STATE(6451)] = 162590,
  [SMALL_STATE(6452)] = 162627,
  [SMALL_STATE(6453)] = 162662,
  [SMALL_STATE(6454)] = 162699,
  [SMALL_STATE(6455)] = 162736,
  [SMALL_STATE(6456)] = 162773,
  [SMALL_STATE(6457)] = 162810,
  [SMALL_STATE(6458)] = 162847,
  [SMALL_STATE(6459)] = 162884,
  [SMALL_STATE(6460)] = 162917,
  [SMALL_STATE(6461)] = 162954,
  [SMALL_STATE(6462)] = 162991,
  [SMALL_STATE(6463)] = 163028,
  [SMALL_STATE(6464)] = 163063,
  [SMALL_STATE(6465)] = 163100,
  [SMALL_STATE(6466)] = 163137,
  [SMALL_STATE(6467)] = 163172,
  [SMALL_STATE(6468)] = 163209,
  [SMALL_STATE(6469)] = 163246,
  [SMALL_STATE(6470)] = 163283,
  [SMALL_STATE(6471)] = 163320,
  [SMALL_STATE(6472)] = 163357,
  [SMALL_STATE(6473)] = 163394,
  [SMALL_STATE(6474)] = 163431,
  [SMALL_STATE(6475)] = 163468,
  [SMALL_STATE(6476)] = 163503,
  [SMALL_STATE(6477)] = 163540,
  [SMALL_STATE(6478)] = 163577,
  [SMALL_STATE(6479)] = 163614,
  [SMALL_STATE(6480)] = 163651,
  [SMALL_STATE(6481)] = 163688,
  [SMALL_STATE(6482)] = 163723,
  [SMALL_STATE(6483)] = 163760,
  [SMALL_STATE(6484)] = 163797,
  [SMALL_STATE(6485)] = 163834,
  [SMALL_STATE(6486)] = 163871,
  [SMALL_STATE(6487)] = 163908,
  [SMALL_STATE(6488)] = 163945,
  [SMALL_STATE(6489)] = 163982,
  [SMALL_STATE(6490)] = 164019,
  [SMALL_STATE(6491)] = 164056,
  [SMALL_STATE(6492)] = 164093,
  [SMALL_STATE(6493)] = 164130,
  [SMALL_STATE(6494)] = 164167,
  [SMALL_STATE(6495)] = 164204,
  [SMALL_STATE(6496)] = 164239,
  [SMALL_STATE(6497)] = 164276,
  [SMALL_STATE(6498)] = 164313,
  [SMALL_STATE(6499)] = 164350,
  [SMALL_STATE(6500)] = 164387,
  [SMALL_STATE(6501)] = 164424,
  [SMALL_STATE(6502)] = 164461,
  [SMALL_STATE(6503)] = 164498,
  [SMALL_STATE(6504)] = 164535,
  [SMALL_STATE(6505)] = 164572,
  [SMALL_STATE(6506)] = 164607,
  [SMALL_STATE(6507)] = 164644,
  [SMALL_STATE(6508)] = 164681,
  [SMALL_STATE(6509)] = 164714,
  [SMALL_STATE(6510)] = 164751,
  [SMALL_STATE(6511)] = 164788,
  [SMALL_STATE(6512)] = 164825,
  [SMALL_STATE(6513)] = 164862,
  [SMALL_STATE(6514)] = 164899,
  [SMALL_STATE(6515)] = 164934,
  [SMALL_STATE(6516)] = 164971,
  [SMALL_STATE(6517)] = 165008,
  [SMALL_STATE(6518)] = 165045,
  [SMALL_STATE(6519)] = 165082,
  [SMALL_STATE(6520)] = 165119,
  [SMALL_STATE(6521)] = 165156,
  [SMALL_STATE(6522)] = 165193,
  [SMALL_STATE(6523)] = 165230,
  [SMALL_STATE(6524)] = 165267,
  [SMALL_STATE(6525)] = 165304,
  [SMALL_STATE(6526)] = 165341,
  [SMALL_STATE(6527)] = 165378,
  [SMALL_STATE(6528)] = 165415,
  [SMALL_STATE(6529)] = 165452,
  [SMALL_STATE(6530)] = 165489,
  [SMALL_STATE(6531)] = 165526,
  [SMALL_STATE(6532)] = 165561,
  [SMALL_STATE(6533)] = 165598,
  [SMALL_STATE(6534)] = 165635,
  [SMALL_STATE(6535)] = 165672,
  [SMALL_STATE(6536)] = 165709,
  [SMALL_STATE(6537)] = 165746,
  [SMALL_STATE(6538)] = 165783,
  [SMALL_STATE(6539)] = 165820,
  [SMALL_STATE(6540)] = 165857,
  [SMALL_STATE(6541)] = 165894,
  [SMALL_STATE(6542)] = 165931,
  [SMALL_STATE(6543)] = 165968,
  [SMALL_STATE(6544)] = 166005,
  [SMALL_STATE(6545)] = 166042,
  [SMALL_STATE(6546)] = 166079,
  [SMALL_STATE(6547)] = 166116,
  [SMALL_STATE(6548)] = 166153,
  [SMALL_STATE(6549)] = 166190,
  [SMALL_STATE(6550)] = 166227,
  [SMALL_STATE(6551)] = 166264,
  [SMALL_STATE(6552)] = 166299,
  [SMALL_STATE(6553)] = 166336,
  [SMALL_STATE(6554)] = 166369,
  [SMALL_STATE(6555)] = 166406,
  [SMALL_STATE(6556)] = 166443,
  [SMALL_STATE(6557)] = 166480,
  [SMALL_STATE(6558)] = 166515,
  [SMALL_STATE(6559)] = 166552,
  [SMALL_STATE(6560)] = 166589,
  [SMALL_STATE(6561)] = 166626,
  [SMALL_STATE(6562)] = 166658,
  [SMALL_STATE(6563)] = 166692,
  [SMALL_STATE(6564)] = 166726,
  [SMALL_STATE(6565)] = 166760,
  [SMALL_STATE(6566)] = 166794,
  [SMALL_STATE(6567)] = 166828,
  [SMALL_STATE(6568)] = 166862,
  [SMALL_STATE(6569)] = 166896,
  [SMALL_STATE(6570)] = 166930,
  [SMALL_STATE(6571)] = 166964,
  [SMALL_STATE(6572)] = 166998,
  [SMALL_STATE(6573)] = 167032,
  [SMALL_STATE(6574)] = 167066,
  [SMALL_STATE(6575)] = 167100,
  [SMALL_STATE(6576)] = 167132,
  [SMALL_STATE(6577)] = 167166,
  [SMALL_STATE(6578)] = 167200,
  [SMALL_STATE(6579)] = 167232,
  [SMALL_STATE(6580)] = 167266,
  [SMALL_STATE(6581)] = 167300,
  [SMALL_STATE(6582)] = 167334,
  [SMALL_STATE(6583)] = 167368,
  [SMALL_STATE(6584)] = 167402,
  [SMALL_STATE(6585)] = 167436,
  [SMALL_STATE(6586)] = 167468,
  [SMALL_STATE(6587)] = 167500,
  [SMALL_STATE(6588)] = 167532,
  [SMALL_STATE(6589)] = 167564,
  [SMALL_STATE(6590)] = 167598,
  [SMALL_STATE(6591)] = 167632,
  [SMALL_STATE(6592)] = 167666,
  [SMALL_STATE(6593)] = 167700,
  [SMALL_STATE(6594)] = 167734,
  [SMALL_STATE(6595)] = 167768,
  [SMALL_STATE(6596)] = 167802,
  [SMALL_STATE(6597)] = 167836,
  [SMALL_STATE(6598)] = 167870,
  [SMALL_STATE(6599)] = 167902,
  [SMALL_STATE(6600)] = 167934,
  [SMALL_STATE(6601)] = 167966,
  [SMALL_STATE(6602)] = 168000,
  [SMALL_STATE(6603)] = 168034,
  [SMALL_STATE(6604)] = 168066,
  [SMALL_STATE(6605)] = 168100,
  [SMALL_STATE(6606)] = 168134,
  [SMALL_STATE(6607)] = 168168,
  [SMALL_STATE(6608)] = 168200,
  [SMALL_STATE(6609)] = 168232,
  [SMALL_STATE(6610)] = 168266,
  [SMALL_STATE(6611)] = 168300,
  [SMALL_STATE(6612)] = 168332,
  [SMALL_STATE(6613)] = 168366,
  [SMALL_STATE(6614)] = 168400,
  [SMALL_STATE(6615)] = 168434,
  [SMALL_STATE(6616)] = 168468,
  [SMALL_STATE(6617)] = 168502,
  [SMALL_STATE(6618)] = 168536,
  [SMALL_STATE(6619)] = 168570,
  [SMALL_STATE(6620)] = 168604,
  [SMALL_STATE(6621)] = 168638,
  [SMALL_STATE(6622)] = 168672,
  [SMALL_STATE(6623)] = 168706,
  [SMALL_STATE(6624)] = 168740,
  [SMALL_STATE(6625)] = 168774,
  [SMALL_STATE(6626)] = 168808,
  [SMALL_STATE(6627)] = 168842,
  [SMALL_STATE(6628)] = 168876,
  [SMALL_STATE(6629)] = 168910,
  [SMALL_STATE(6630)] = 168942,
  [SMALL_STATE(6631)] = 168976,
  [SMALL_STATE(6632)] = 169010,
  [SMALL_STATE(6633)] = 169044,
  [SMALL_STATE(6634)] = 169076,
  [SMALL_STATE(6635)] = 169110,
  [SMALL_STATE(6636)] = 169144,
  [SMALL_STATE(6637)] = 169178,
  [SMALL_STATE(6638)] = 169212,
  [SMALL_STATE(6639)] = 169246,
  [SMALL_STATE(6640)] = 169280,
  [SMALL_STATE(6641)] = 169314,
  [SMALL_STATE(6642)] = 169348,
  [SMALL_STATE(6643)] = 169380,
  [SMALL_STATE(6644)] = 169412,
  [SMALL_STATE(6645)] = 169446,
  [SMALL_STATE(6646)] = 169480,
  [SMALL_STATE(6647)] = 169514,
  [SMALL_STATE(6648)] = 169546,
  [SMALL_STATE(6649)] = 169580,
  [SMALL_STATE(6650)] = 169612,
  [SMALL_STATE(6651)] = 169646,
  [SMALL_STATE(6652)] = 169680,
  [SMALL_STATE(6653)] = 169714,
  [SMALL_STATE(6654)] = 169748,
  [SMALL_STATE(6655)] = 169782,
  [SMALL_STATE(6656)] = 169816,
  [SMALL_STATE(6657)] = 169848,
  [SMALL_STATE(6658)] = 169880,
  [SMALL_STATE(6659)] = 169914,
  [SMALL_STATE(6660)] = 169946,
  [SMALL_STATE(6661)] = 169980,
  [SMALL_STATE(6662)] = 170014,
  [SMALL_STATE(6663)] = 170048,
  [SMALL_STATE(6664)] = 170082,
  [SMALL_STATE(6665)] = 170116,
  [SMALL_STATE(6666)] = 170150,
  [SMALL_STATE(6667)] = 170184,
  [SMALL_STATE(6668)] = 170218,
  [SMALL_STATE(6669)] = 170250,
  [SMALL_STATE(6670)] = 170284,
  [SMALL_STATE(6671)] = 170318,
  [SMALL_STATE(6672)] = 170352,
  [SMALL_STATE(6673)] = 170384,
  [SMALL_STATE(6674)] = 170416,
  [SMALL_STATE(6675)] = 170450,
  [SMALL_STATE(6676)] = 170484,
  [SMALL_STATE(6677)] = 170518,
  [SMALL_STATE(6678)] = 170552,
  [SMALL_STATE(6679)] = 170586,
  [SMALL_STATE(6680)] = 170620,
  [SMALL_STATE(6681)] = 170652,
  [SMALL_STATE(6682)] = 170684,
  [SMALL_STATE(6683)] = 170718,
  [SMALL_STATE(6684)] = 170752,
  [SMALL_STATE(6685)] = 170786,
  [SMALL_STATE(6686)] = 170820,
  [SMALL_STATE(6687)] = 170852,
  [SMALL_STATE(6688)] = 170886,
  [SMALL_STATE(6689)] = 170920,
  [SMALL_STATE(6690)] = 170954,
  [SMALL_STATE(6691)] = 170988,
  [SMALL_STATE(6692)] = 171020,
  [SMALL_STATE(6693)] = 171054,
  [SMALL_STATE(6694)] = 171088,
  [SMALL_STATE(6695)] = 171120,
  [SMALL_STATE(6696)] = 171154,
  [SMALL_STATE(6697)] = 171186,
  [SMALL_STATE(6698)] = 171220,
  [SMALL_STATE(6699)] = 171252,
  [SMALL_STATE(6700)] = 171286,
  [SMALL_STATE(6701)] = 171320,
  [SMALL_STATE(6702)] = 171352,
  [SMALL_STATE(6703)] = 171384,
  [SMALL_STATE(6704)] = 171418,
  [SMALL_STATE(6705)] = 171452,
  [SMALL_STATE(6706)] = 171484,
  [SMALL_STATE(6707)] = 171516,
  [SMALL_STATE(6708)] = 171550,
  [SMALL_STATE(6709)] = 171584,
  [SMALL_STATE(6710)] = 171616,
  [SMALL_STATE(6711)] = 171648,
  [SMALL_STATE(6712)] = 171682,
  [SMALL_STATE(6713)] = 171714,
  [SMALL_STATE(6714)] = 171748,
  [SMALL_STATE(6715)] = 171782,
  [SMALL_STATE(6716)] = 171814,
  [SMALL_STATE(6717)] = 171846,
  [SMALL_STATE(6718)] = 171878,
  [SMALL_STATE(6719)] = 171910,
  [SMALL_STATE(6720)] = 171944,
  [SMALL_STATE(6721)] = 171976,
  [SMALL_STATE(6722)] = 172008,
  [SMALL_STATE(6723)] = 172042,
  [SMALL_STATE(6724)] = 172076,
  [SMALL_STATE(6725)] = 172110,
  [SMALL_STATE(6726)] = 172142,
  [SMALL_STATE(6727)] = 172174,
  [SMALL_STATE(6728)] = 172208,
  [SMALL_STATE(6729)] = 172240,
  [SMALL_STATE(6730)] = 172274,
  [SMALL_STATE(6731)] = 172306,
  [SMALL_STATE(6732)] = 172338,
  [SMALL_STATE(6733)] = 172370,
  [SMALL_STATE(6734)] = 172402,
  [SMALL_STATE(6735)] = 172434,
  [SMALL_STATE(6736)] = 172466,
  [SMALL_STATE(6737)] = 172498,
  [SMALL_STATE(6738)] = 172532,
  [SMALL_STATE(6739)] = 172566,
  [SMALL_STATE(6740)] = 172598,
  [SMALL_STATE(6741)] = 172630,
  [SMALL_STATE(6742)] = 172662,
  [SMALL_STATE(6743)] = 172696,
  [SMALL_STATE(6744)] = 172730,
  [SMALL_STATE(6745)] = 172764,
  [SMALL_STATE(6746)] = 172798,
  [SMALL_STATE(6747)] = 172830,
  [SMALL_STATE(6748)] = 172864,
  [SMALL_STATE(6749)] = 172896,
  [SMALL_STATE(6750)] = 172928,
  [SMALL_STATE(6751)] = 172960,
  [SMALL_STATE(6752)] = 172992,
  [SMALL_STATE(6753)] = 173024,
  [SMALL_STATE(6754)] = 173058,
  [SMALL_STATE(6755)] = 173090,
  [SMALL_STATE(6756)] = 173122,
  [SMALL_STATE(6757)] = 173154,
  [SMALL_STATE(6758)] = 173188,
  [SMALL_STATE(6759)] = 173222,
  [SMALL_STATE(6760)] = 173254,
  [SMALL_STATE(6761)] = 173286,
  [SMALL_STATE(6762)] = 173318,
  [SMALL_STATE(6763)] = 173352,
  [SMALL_STATE(6764)] = 173384,
  [SMALL_STATE(6765)] = 173416,
  [SMALL_STATE(6766)] = 173450,
  [SMALL_STATE(6767)] = 173482,
  [SMALL_STATE(6768)] = 173514,
  [SMALL_STATE(6769)] = 173548,
  [SMALL_STATE(6770)] = 173580,
  [SMALL_STATE(6771)] = 173612,
  [SMALL_STATE(6772)] = 173646,
  [SMALL_STATE(6773)] = 173680,
  [SMALL_STATE(6774)] = 173712,
  [SMALL_STATE(6775)] = 173744,
  [SMALL_STATE(6776)] = 173776,
  [SMALL_STATE(6777)] = 173808,
  [SMALL_STATE(6778)] = 173840,
  [SMALL_STATE(6779)] = 173872,
  [SMALL_STATE(6780)] = 173904,
  [SMALL_STATE(6781)] = 173936,
  [SMALL_STATE(6782)] = 173968,
  [SMALL_STATE(6783)] = 174000,
  [SMALL_STATE(6784)] = 174032,
  [SMALL_STATE(6785)] = 174066,
  [SMALL_STATE(6786)] = 174098,
  [SMALL_STATE(6787)] = 174132,
  [SMALL_STATE(6788)] = 174166,
  [SMALL_STATE(6789)] = 174200,
  [SMALL_STATE(6790)] = 174232,
  [SMALL_STATE(6791)] = 174264,
  [SMALL_STATE(6792)] = 174296,
  [SMALL_STATE(6793)] = 174328,
  [SMALL_STATE(6794)] = 174362,
  [SMALL_STATE(6795)] = 174394,
  [SMALL_STATE(6796)] = 174426,
  [SMALL_STATE(6797)] = 174458,
  [SMALL_STATE(6798)] = 174490,
  [SMALL_STATE(6799)] = 174522,
  [SMALL_STATE(6800)] = 174556,
  [SMALL_STATE(6801)] = 174588,
  [SMALL_STATE(6802)] = 174622,
  [SMALL_STATE(6803)] = 174656,
  [SMALL_STATE(6804)] = 174690,
  [SMALL_STATE(6805)] = 174724,
  [SMALL_STATE(6806)] = 174758,
  [SMALL_STATE(6807)] = 174792,
  [SMALL_STATE(6808)] = 174826,
  [SMALL_STATE(6809)] = 174860,
  [SMALL_STATE(6810)] = 174894,
  [SMALL_STATE(6811)] = 174928,
  [SMALL_STATE(6812)] = 174962,
  [SMALL_STATE(6813)] = 174996,
  [SMALL_STATE(6814)] = 175030,
  [SMALL_STATE(6815)] = 175064,
  [SMALL_STATE(6816)] = 175098,
  [SMALL_STATE(6817)] = 175132,
  [SMALL_STATE(6818)] = 175166,
  [SMALL_STATE(6819)] = 175200,
  [SMALL_STATE(6820)] = 175234,
  [SMALL_STATE(6821)] = 175268,
  [SMALL_STATE(6822)] = 175302,
  [SMALL_STATE(6823)] = 175336,
  [SMALL_STATE(6824)] = 175370,
  [SMALL_STATE(6825)] = 175404,
  [SMALL_STATE(6826)] = 175438,
  [SMALL_STATE(6827)] = 175472,
  [SMALL_STATE(6828)] = 175506,
  [SMALL_STATE(6829)] = 175540,
  [SMALL_STATE(6830)] = 175574,
  [SMALL_STATE(6831)] = 175608,
  [SMALL_STATE(6832)] = 175642,
  [SMALL_STATE(6833)] = 175676,
  [SMALL_STATE(6834)] = 175710,
  [SMALL_STATE(6835)] = 175744,
  [SMALL_STATE(6836)] = 175778,
  [SMALL_STATE(6837)] = 175812,
  [SMALL_STATE(6838)] = 175846,
  [SMALL_STATE(6839)] = 175880,
  [SMALL_STATE(6840)] = 175914,
  [SMALL_STATE(6841)] = 175948,
  [SMALL_STATE(6842)] = 175982,
  [SMALL_STATE(6843)] = 176016,
  [SMALL_STATE(6844)] = 176050,
  [SMALL_STATE(6845)] = 176084,
  [SMALL_STATE(6846)] = 176118,
  [SMALL_STATE(6847)] = 176152,
  [SMALL_STATE(6848)] = 176186,
  [SMALL_STATE(6849)] = 176220,
  [SMALL_STATE(6850)] = 176254,
  [SMALL_STATE(6851)] = 176288,
  [SMALL_STATE(6852)] = 176322,
  [SMALL_STATE(6853)] = 176356,
  [SMALL_STATE(6854)] = 176390,
  [SMALL_STATE(6855)] = 176424,
  [SMALL_STATE(6856)] = 176458,
  [SMALL_STATE(6857)] = 176492,
  [SMALL_STATE(6858)] = 176526,
  [SMALL_STATE(6859)] = 176560,
  [SMALL_STATE(6860)] = 176594,
  [SMALL_STATE(6861)] = 176628,
  [SMALL_STATE(6862)] = 176662,
  [SMALL_STATE(6863)] = 176696,
  [SMALL_STATE(6864)] = 176730,
  [SMALL_STATE(6865)] = 176764,
  [SMALL_STATE(6866)] = 176798,
  [SMALL_STATE(6867)] = 176832,
  [SMALL_STATE(6868)] = 176866,
  [SMALL_STATE(6869)] = 176900,
  [SMALL_STATE(6870)] = 176934,
  [SMALL_STATE(6871)] = 176968,
  [SMALL_STATE(6872)] = 177002,
  [SMALL_STATE(6873)] = 177036,
  [SMALL_STATE(6874)] = 177070,
  [SMALL_STATE(6875)] = 177104,
  [SMALL_STATE(6876)] = 177138,
  [SMALL_STATE(6877)] = 177172,
  [SMALL_STATE(6878)] = 177206,
  [SMALL_STATE(6879)] = 177240,
  [SMALL_STATE(6880)] = 177274,
  [SMALL_STATE(6881)] = 177308,
  [SMALL_STATE(6882)] = 177342,
  [SMALL_STATE(6883)] = 177376,
  [SMALL_STATE(6884)] = 177410,
  [SMALL_STATE(6885)] = 177444,
  [SMALL_STATE(6886)] = 177478,
  [SMALL_STATE(6887)] = 177512,
  [SMALL_STATE(6888)] = 177546,
  [SMALL_STATE(6889)] = 177580,
  [SMALL_STATE(6890)] = 177614,
  [SMALL_STATE(6891)] = 177648,
  [SMALL_STATE(6892)] = 177682,
  [SMALL_STATE(6893)] = 177716,
  [SMALL_STATE(6894)] = 177750,
  [SMALL_STATE(6895)] = 177784,
  [SMALL_STATE(6896)] = 177818,
  [SMALL_STATE(6897)] = 177852,
  [SMALL_STATE(6898)] = 177886,
  [SMALL_STATE(6899)] = 177920,
  [SMALL_STATE(6900)] = 177954,
  [SMALL_STATE(6901)] = 177988,
  [SMALL_STATE(6902)] = 178022,
  [SMALL_STATE(6903)] = 178056,
  [SMALL_STATE(6904)] = 178090,
  [SMALL_STATE(6905)] = 178124,
  [SMALL_STATE(6906)] = 178158,
  [SMALL_STATE(6907)] = 178192,
  [SMALL_STATE(6908)] = 178226,
  [SMALL_STATE(6909)] = 178260,
  [SMALL_STATE(6910)] = 178294,
  [SMALL_STATE(6911)] = 178328,
  [SMALL_STATE(6912)] = 178362,
  [SMALL_STATE(6913)] = 178396,
  [SMALL_STATE(6914)] = 178430,
  [SMALL_STATE(6915)] = 178464,
  [SMALL_STATE(6916)] = 178498,
  [SMALL_STATE(6917)] = 178532,
  [SMALL_STATE(6918)] = 178566,
  [SMALL_STATE(6919)] = 178600,
  [SMALL_STATE(6920)] = 178634,
  [SMALL_STATE(6921)] = 178668,
  [SMALL_STATE(6922)] = 178702,
  [SMALL_STATE(6923)] = 178736,
  [SMALL_STATE(6924)] = 178770,
  [SMALL_STATE(6925)] = 178804,
  [SMALL_STATE(6926)] = 178838,
  [SMALL_STATE(6927)] = 178872,
  [SMALL_STATE(6928)] = 178906,
  [SMALL_STATE(6929)] = 178940,
  [SMALL_STATE(6930)] = 178974,
  [SMALL_STATE(6931)] = 179008,
  [SMALL_STATE(6932)] = 179042,
  [SMALL_STATE(6933)] = 179076,
  [SMALL_STATE(6934)] = 179110,
  [SMALL_STATE(6935)] = 179144,
  [SMALL_STATE(6936)] = 179178,
  [SMALL_STATE(6937)] = 179212,
  [SMALL_STATE(6938)] = 179246,
  [SMALL_STATE(6939)] = 179280,
  [SMALL_STATE(6940)] = 179314,
  [SMALL_STATE(6941)] = 179348,
  [SMALL_STATE(6942)] = 179382,
  [SMALL_STATE(6943)] = 179416,
  [SMALL_STATE(6944)] = 179450,
  [SMALL_STATE(6945)] = 179484,
  [SMALL_STATE(6946)] = 179518,
  [SMALL_STATE(6947)] = 179552,
  [SMALL_STATE(6948)] = 179586,
  [SMALL_STATE(6949)] = 179620,
  [SMALL_STATE(6950)] = 179654,
  [SMALL_STATE(6951)] = 179688,
  [SMALL_STATE(6952)] = 179722,
  [SMALL_STATE(6953)] = 179756,
  [SMALL_STATE(6954)] = 179790,
  [SMALL_STATE(6955)] = 179824,
  [SMALL_STATE(6956)] = 179858,
  [SMALL_STATE(6957)] = 179892,
  [SMALL_STATE(6958)] = 179926,
  [SMALL_STATE(6959)] = 179960,
  [SMALL_STATE(6960)] = 179994,
  [SMALL_STATE(6961)] = 180028,
  [SMALL_STATE(6962)] = 180062,
  [SMALL_STATE(6963)] = 180096,
  [SMALL_STATE(6964)] = 180130,
  [SMALL_STATE(6965)] = 180164,
  [SMALL_STATE(6966)] = 180198,
  [SMALL_STATE(6967)] = 180232,
  [SMALL_STATE(6968)] = 180266,
  [SMALL_STATE(6969)] = 180300,
  [SMALL_STATE(6970)] = 180334,
  [SMALL_STATE(6971)] = 180368,
  [SMALL_STATE(6972)] = 180402,
  [SMALL_STATE(6973)] = 180436,
  [SMALL_STATE(6974)] = 180470,
  [SMALL_STATE(6975)] = 180504,
  [SMALL_STATE(6976)] = 180538,
  [SMALL_STATE(6977)] = 180572,
  [SMALL_STATE(6978)] = 180606,
  [SMALL_STATE(6979)] = 180640,
  [SMALL_STATE(6980)] = 180674,
  [SMALL_STATE(6981)] = 180708,
  [SMALL_STATE(6982)] = 180742,
  [SMALL_STATE(6983)] = 180776,
  [SMALL_STATE(6984)] = 180810,
  [SMALL_STATE(6985)] = 180844,
  [SMALL_STATE(6986)] = 180878,
  [SMALL_STATE(6987)] = 180912,
  [SMALL_STATE(6988)] = 180946,
  [SMALL_STATE(6989)] = 180980,
  [SMALL_STATE(6990)] = 181014,
  [SMALL_STATE(6991)] = 181048,
  [SMALL_STATE(6992)] = 181082,
  [SMALL_STATE(6993)] = 181116,
  [SMALL_STATE(6994)] = 181150,
  [SMALL_STATE(6995)] = 181184,
  [SMALL_STATE(6996)] = 181218,
  [SMALL_STATE(6997)] = 181252,
  [SMALL_STATE(6998)] = 181286,
  [SMALL_STATE(6999)] = 181320,
  [SMALL_STATE(7000)] = 181354,
  [SMALL_STATE(7001)] = 181388,
  [SMALL_STATE(7002)] = 181422,
  [SMALL_STATE(7003)] = 181456,
  [SMALL_STATE(7004)] = 181490,
  [SMALL_STATE(7005)] = 181524,
  [SMALL_STATE(7006)] = 181558,
  [SMALL_STATE(7007)] = 181592,
  [SMALL_STATE(7008)] = 181626,
  [SMALL_STATE(7009)] = 181660,
  [SMALL_STATE(7010)] = 181694,
  [SMALL_STATE(7011)] = 181728,
  [SMALL_STATE(7012)] = 181762,
  [SMALL_STATE(7013)] = 181796,
  [SMALL_STATE(7014)] = 181830,
  [SMALL_STATE(7015)] = 181864,
  [SMALL_STATE(7016)] = 181898,
  [SMALL_STATE(7017)] = 181932,
  [SMALL_STATE(7018)] = 181966,
  [SMALL_STATE(7019)] = 182000,
  [SMALL_STATE(7020)] = 182034,
  [SMALL_STATE(7021)] = 182068,
  [SMALL_STATE(7022)] = 182102,
  [SMALL_STATE(7023)] = 182136,
  [SMALL_STATE(7024)] = 182170,
  [SMALL_STATE(7025)] = 182204,
  [SMALL_STATE(7026)] = 182238,
  [SMALL_STATE(7027)] = 182272,
  [SMALL_STATE(7028)] = 182306,
  [SMALL_STATE(7029)] = 182340,
  [SMALL_STATE(7030)] = 182374,
  [SMALL_STATE(7031)] = 182408,
  [SMALL_STATE(7032)] = 182442,
  [SMALL_STATE(7033)] = 182476,
  [SMALL_STATE(7034)] = 182510,
  [SMALL_STATE(7035)] = 182544,
  [SMALL_STATE(7036)] = 182578,
  [SMALL_STATE(7037)] = 182612,
  [SMALL_STATE(7038)] = 182646,
  [SMALL_STATE(7039)] = 182680,
  [SMALL_STATE(7040)] = 182714,
  [SMALL_STATE(7041)] = 182748,
  [SMALL_STATE(7042)] = 182782,
  [SMALL_STATE(7043)] = 182816,
  [SMALL_STATE(7044)] = 182850,
  [SMALL_STATE(7045)] = 182884,
  [SMALL_STATE(7046)] = 182918,
  [SMALL_STATE(7047)] = 182952,
  [SMALL_STATE(7048)] = 182986,
  [SMALL_STATE(7049)] = 183020,
  [SMALL_STATE(7050)] = 183054,
  [SMALL_STATE(7051)] = 183088,
  [SMALL_STATE(7052)] = 183122,
  [SMALL_STATE(7053)] = 183156,
  [SMALL_STATE(7054)] = 183190,
  [SMALL_STATE(7055)] = 183224,
  [SMALL_STATE(7056)] = 183258,
  [SMALL_STATE(7057)] = 183292,
  [SMALL_STATE(7058)] = 183326,
  [SMALL_STATE(7059)] = 183360,
  [SMALL_STATE(7060)] = 183394,
  [SMALL_STATE(7061)] = 183428,
  [SMALL_STATE(7062)] = 183462,
  [SMALL_STATE(7063)] = 183496,
  [SMALL_STATE(7064)] = 183530,
  [SMALL_STATE(7065)] = 183564,
  [SMALL_STATE(7066)] = 183598,
  [SMALL_STATE(7067)] = 183632,
  [SMALL_STATE(7068)] = 183666,
  [SMALL_STATE(7069)] = 183700,
  [SMALL_STATE(7070)] = 183734,
  [SMALL_STATE(7071)] = 183768,
  [SMALL_STATE(7072)] = 183802,
  [SMALL_STATE(7073)] = 183836,
  [SMALL_STATE(7074)] = 183870,
  [SMALL_STATE(7075)] = 183904,
  [SMALL_STATE(7076)] = 183938,
  [SMALL_STATE(7077)] = 183972,
  [SMALL_STATE(7078)] = 184006,
  [SMALL_STATE(7079)] = 184040,
  [SMALL_STATE(7080)] = 184074,
  [SMALL_STATE(7081)] = 184108,
  [SMALL_STATE(7082)] = 184142,
  [SMALL_STATE(7083)] = 184176,
  [SMALL_STATE(7084)] = 184210,
  [SMALL_STATE(7085)] = 184244,
  [SMALL_STATE(7086)] = 184278,
  [SMALL_STATE(7087)] = 184312,
  [SMALL_STATE(7088)] = 184346,
  [SMALL_STATE(7089)] = 184380,
  [SMALL_STATE(7090)] = 184414,
  [SMALL_STATE(7091)] = 184448,
  [SMALL_STATE(7092)] = 184482,
  [SMALL_STATE(7093)] = 184516,
  [SMALL_STATE(7094)] = 184550,
  [SMALL_STATE(7095)] = 184584,
  [SMALL_STATE(7096)] = 184618,
  [SMALL_STATE(7097)] = 184652,
  [SMALL_STATE(7098)] = 184686,
  [SMALL_STATE(7099)] = 184720,
  [SMALL_STATE(7100)] = 184754,
  [SMALL_STATE(7101)] = 184788,
  [SMALL_STATE(7102)] = 184822,
  [SMALL_STATE(7103)] = 184856,
  [SMALL_STATE(7104)] = 184890,
  [SMALL_STATE(7105)] = 184924,
  [SMALL_STATE(7106)] = 184958,
  [SMALL_STATE(7107)] = 184992,
  [SMALL_STATE(7108)] = 185026,
  [SMALL_STATE(7109)] = 185060,
  [SMALL_STATE(7110)] = 185094,
  [SMALL_STATE(7111)] = 185128,
  [SMALL_STATE(7112)] = 185162,
  [SMALL_STATE(7113)] = 185196,
  [SMALL_STATE(7114)] = 185230,
  [SMALL_STATE(7115)] = 185264,
  [SMALL_STATE(7116)] = 185298,
  [SMALL_STATE(7117)] = 185332,
  [SMALL_STATE(7118)] = 185366,
  [SMALL_STATE(7119)] = 185400,
  [SMALL_STATE(7120)] = 185434,
  [SMALL_STATE(7121)] = 185468,
  [SMALL_STATE(7122)] = 185502,
  [SMALL_STATE(7123)] = 185536,
  [SMALL_STATE(7124)] = 185570,
  [SMALL_STATE(7125)] = 185604,
  [SMALL_STATE(7126)] = 185638,
  [SMALL_STATE(7127)] = 185672,
  [SMALL_STATE(7128)] = 185706,
  [SMALL_STATE(7129)] = 185740,
  [SMALL_STATE(7130)] = 185774,
  [SMALL_STATE(7131)] = 185808,
  [SMALL_STATE(7132)] = 185842,
  [SMALL_STATE(7133)] = 185876,
  [SMALL_STATE(7134)] = 185910,
  [SMALL_STATE(7135)] = 185944,
  [SMALL_STATE(7136)] = 185978,
  [SMALL_STATE(7137)] = 186012,
  [SMALL_STATE(7138)] = 186046,
  [SMALL_STATE(7139)] = 186080,
  [SMALL_STATE(7140)] = 186114,
  [SMALL_STATE(7141)] = 186148,
  [SMALL_STATE(7142)] = 186182,
  [SMALL_STATE(7143)] = 186216,
  [SMALL_STATE(7144)] = 186250,
  [SMALL_STATE(7145)] = 186284,
  [SMALL_STATE(7146)] = 186318,
  [SMALL_STATE(7147)] = 186352,
  [SMALL_STATE(7148)] = 186386,
  [SMALL_STATE(7149)] = 186420,
  [SMALL_STATE(7150)] = 186454,
  [SMALL_STATE(7151)] = 186488,
  [SMALL_STATE(7152)] = 186522,
  [SMALL_STATE(7153)] = 186556,
  [SMALL_STATE(7154)] = 186590,
  [SMALL_STATE(7155)] = 186624,
  [SMALL_STATE(7156)] = 186658,
  [SMALL_STATE(7157)] = 186692,
  [SMALL_STATE(7158)] = 186723,
  [SMALL_STATE(7159)] = 186754,
  [SMALL_STATE(7160)] = 186785,
  [SMALL_STATE(7161)] = 186816,
  [SMALL_STATE(7162)] = 186847,
  [SMALL_STATE(7163)] = 186878,
  [SMALL_STATE(7164)] = 186909,
  [SMALL_STATE(7165)] = 186940,
  [SMALL_STATE(7166)] = 186971,
  [SMALL_STATE(7167)] = 187002,
  [SMALL_STATE(7168)] = 187033,
  [SMALL_STATE(7169)] = 187064,
  [SMALL_STATE(7170)] = 187095,
  [SMALL_STATE(7171)] = 187126,
  [SMALL_STATE(7172)] = 187157,
  [SMALL_STATE(7173)] = 187188,
  [SMALL_STATE(7174)] = 187219,
  [SMALL_STATE(7175)] = 187250,
  [SMALL_STATE(7176)] = 187281,
  [SMALL_STATE(7177)] = 187312,
  [SMALL_STATE(7178)] = 187343,
  [SMALL_STATE(7179)] = 187374,
  [SMALL_STATE(7180)] = 187405,
  [SMALL_STATE(7181)] = 187436,
  [SMALL_STATE(7182)] = 187467,
  [SMALL_STATE(7183)] = 187498,
  [SMALL_STATE(7184)] = 187529,
  [SMALL_STATE(7185)] = 187560,
  [SMALL_STATE(7186)] = 187591,
  [SMALL_STATE(7187)] = 187622,
  [SMALL_STATE(7188)] = 187653,
  [SMALL_STATE(7189)] = 187684,
  [SMALL_STATE(7190)] = 187715,
  [SMALL_STATE(7191)] = 187746,
  [SMALL_STATE(7192)] = 187777,
  [SMALL_STATE(7193)] = 187808,
  [SMALL_STATE(7194)] = 187839,
  [SMALL_STATE(7195)] = 187870,
  [SMALL_STATE(7196)] = 187901,
  [SMALL_STATE(7197)] = 187932,
  [SMALL_STATE(7198)] = 187963,
  [SMALL_STATE(7199)] = 187994,
  [SMALL_STATE(7200)] = 188025,
  [SMALL_STATE(7201)] = 188056,
  [SMALL_STATE(7202)] = 188087,
  [SMALL_STATE(7203)] = 188118,
  [SMALL_STATE(7204)] = 188149,
  [SMALL_STATE(7205)] = 188180,
  [SMALL_STATE(7206)] = 188211,
  [SMALL_STATE(7207)] = 188242,
  [SMALL_STATE(7208)] = 188273,
  [SMALL_STATE(7209)] = 188304,
  [SMALL_STATE(7210)] = 188335,
  [SMALL_STATE(7211)] = 188366,
  [SMALL_STATE(7212)] = 188397,
  [SMALL_STATE(7213)] = 188428,
  [SMALL_STATE(7214)] = 188459,
  [SMALL_STATE(7215)] = 188490,
  [SMALL_STATE(7216)] = 188521,
  [SMALL_STATE(7217)] = 188552,
  [SMALL_STATE(7218)] = 188583,
  [SMALL_STATE(7219)] = 188614,
  [SMALL_STATE(7220)] = 188645,
  [SMALL_STATE(7221)] = 188676,
  [SMALL_STATE(7222)] = 188707,
  [SMALL_STATE(7223)] = 188738,
  [SMALL_STATE(7224)] = 188769,
  [SMALL_STATE(7225)] = 188800,
  [SMALL_STATE(7226)] = 188831,
  [SMALL_STATE(7227)] = 188862,
  [SMALL_STATE(7228)] = 188893,
  [SMALL_STATE(7229)] = 188924,
  [SMALL_STATE(7230)] = 188955,
  [SMALL_STATE(7231)] = 188986,
  [SMALL_STATE(7232)] = 189017,
  [SMALL_STATE(7233)] = 189048,
  [SMALL_STATE(7234)] = 189079,
  [SMALL_STATE(7235)] = 189110,
  [SMALL_STATE(7236)] = 189141,
  [SMALL_STATE(7237)] = 189172,
  [SMALL_STATE(7238)] = 189203,
  [SMALL_STATE(7239)] = 189234,
  [SMALL_STATE(7240)] = 189265,
  [SMALL_STATE(7241)] = 189296,
  [SMALL_STATE(7242)] = 189327,
  [SMALL_STATE(7243)] = 189358,
  [SMALL_STATE(7244)] = 189389,
  [SMALL_STATE(7245)] = 189420,
  [SMALL_STATE(7246)] = 189451,
  [SMALL_STATE(7247)] = 189482,
  [SMALL_STATE(7248)] = 189513,
  [SMALL_STATE(7249)] = 189544,
  [SMALL_STATE(7250)] = 189575,
  [SMALL_STATE(7251)] = 189606,
  [SMALL_STATE(7252)] = 189637,
  [SMALL_STATE(7253)] = 189668,
  [SMALL_STATE(7254)] = 189699,
  [SMALL_STATE(7255)] = 189730,
  [SMALL_STATE(7256)] = 189761,
  [SMALL_STATE(7257)] = 189792,
  [SMALL_STATE(7258)] = 189823,
  [SMALL_STATE(7259)] = 189854,
  [SMALL_STATE(7260)] = 189885,
  [SMALL_STATE(7261)] = 189916,
  [SMALL_STATE(7262)] = 189947,
  [SMALL_STATE(7263)] = 189978,
  [SMALL_STATE(7264)] = 190009,
  [SMALL_STATE(7265)] = 190040,
  [SMALL_STATE(7266)] = 190071,
  [SMALL_STATE(7267)] = 190102,
  [SMALL_STATE(7268)] = 190133,
  [SMALL_STATE(7269)] = 190164,
  [SMALL_STATE(7270)] = 190195,
  [SMALL_STATE(7271)] = 190226,
  [SMALL_STATE(7272)] = 190257,
  [SMALL_STATE(7273)] = 190288,
  [SMALL_STATE(7274)] = 190319,
  [SMALL_STATE(7275)] = 190350,
  [SMALL_STATE(7276)] = 190381,
  [SMALL_STATE(7277)] = 190412,
  [SMALL_STATE(7278)] = 190443,
  [SMALL_STATE(7279)] = 190474,
  [SMALL_STATE(7280)] = 190505,
  [SMALL_STATE(7281)] = 190536,
  [SMALL_STATE(7282)] = 190567,
  [SMALL_STATE(7283)] = 190598,
  [SMALL_STATE(7284)] = 190629,
  [SMALL_STATE(7285)] = 190660,
  [SMALL_STATE(7286)] = 190691,
  [SMALL_STATE(7287)] = 190722,
  [SMALL_STATE(7288)] = 190753,
  [SMALL_STATE(7289)] = 190784,
  [SMALL_STATE(7290)] = 190815,
  [SMALL_STATE(7291)] = 190846,
  [SMALL_STATE(7292)] = 190877,
  [SMALL_STATE(7293)] = 190908,
  [SMALL_STATE(7294)] = 190939,
  [SMALL_STATE(7295)] = 190970,
  [SMALL_STATE(7296)] = 191001,
  [SMALL_STATE(7297)] = 191032,
  [SMALL_STATE(7298)] = 191063,
  [SMALL_STATE(7299)] = 191094,
  [SMALL_STATE(7300)] = 191125,
  [SMALL_STATE(7301)] = 191156,
  [SMALL_STATE(7302)] = 191187,
  [SMALL_STATE(7303)] = 191218,
  [SMALL_STATE(7304)] = 191249,
  [SMALL_STATE(7305)] = 191280,
  [SMALL_STATE(7306)] = 191311,
  [SMALL_STATE(7307)] = 191342,
  [SMALL_STATE(7308)] = 191373,
  [SMALL_STATE(7309)] = 191404,
  [SMALL_STATE(7310)] = 191435,
  [SMALL_STATE(7311)] = 191466,
  [SMALL_STATE(7312)] = 191497,
  [SMALL_STATE(7313)] = 191528,
  [SMALL_STATE(7314)] = 191559,
  [SMALL_STATE(7315)] = 191590,
  [SMALL_STATE(7316)] = 191621,
  [SMALL_STATE(7317)] = 191652,
  [SMALL_STATE(7318)] = 191683,
  [SMALL_STATE(7319)] = 191714,
  [SMALL_STATE(7320)] = 191745,
  [SMALL_STATE(7321)] = 191776,
  [SMALL_STATE(7322)] = 191807,
  [SMALL_STATE(7323)] = 191838,
  [SMALL_STATE(7324)] = 191869,
  [SMALL_STATE(7325)] = 191900,
  [SMALL_STATE(7326)] = 191931,
  [SMALL_STATE(7327)] = 191962,
  [SMALL_STATE(7328)] = 191993,
  [SMALL_STATE(7329)] = 192024,
  [SMALL_STATE(7330)] = 192055,
  [SMALL_STATE(7331)] = 192086,
  [SMALL_STATE(7332)] = 192117,
  [SMALL_STATE(7333)] = 192148,
  [SMALL_STATE(7334)] = 192179,
  [SMALL_STATE(7335)] = 192210,
  [SMALL_STATE(7336)] = 192241,
  [SMALL_STATE(7337)] = 192272,
  [SMALL_STATE(7338)] = 192303,
  [SMALL_STATE(7339)] = 192334,
  [SMALL_STATE(7340)] = 192365,
  [SMALL_STATE(7341)] = 192396,
  [SMALL_STATE(7342)] = 192427,
  [SMALL_STATE(7343)] = 192458,
  [SMALL_STATE(7344)] = 192489,
  [SMALL_STATE(7345)] = 192520,
  [SMALL_STATE(7346)] = 192551,
  [SMALL_STATE(7347)] = 192582,
  [SMALL_STATE(7348)] = 192613,
  [SMALL_STATE(7349)] = 192644,
  [SMALL_STATE(7350)] = 192675,
  [SMALL_STATE(7351)] = 192706,
  [SMALL_STATE(7352)] = 192737,
  [SMALL_STATE(7353)] = 192768,
  [SMALL_STATE(7354)] = 192799,
  [SMALL_STATE(7355)] = 192830,
  [SMALL_STATE(7356)] = 192861,
  [SMALL_STATE(7357)] = 192892,
  [SMALL_STATE(7358)] = 192923,
  [SMALL_STATE(7359)] = 192954,
  [SMALL_STATE(7360)] = 192985,
  [SMALL_STATE(7361)] = 193016,
  [SMALL_STATE(7362)] = 193047,
  [SMALL_STATE(7363)] = 193078,
  [SMALL_STATE(7364)] = 193109,
  [SMALL_STATE(7365)] = 193140,
  [SMALL_STATE(7366)] = 193171,
  [SMALL_STATE(7367)] = 193202,
  [SMALL_STATE(7368)] = 193233,
  [SMALL_STATE(7369)] = 193264,
  [SMALL_STATE(7370)] = 193295,
  [SMALL_STATE(7371)] = 193326,
  [SMALL_STATE(7372)] = 193357,
  [SMALL_STATE(7373)] = 193388,
  [SMALL_STATE(7374)] = 193419,
  [SMALL_STATE(7375)] = 193450,
  [SMALL_STATE(7376)] = 193481,
  [SMALL_STATE(7377)] = 193512,
  [SMALL_STATE(7378)] = 193543,
  [SMALL_STATE(7379)] = 193574,
  [SMALL_STATE(7380)] = 193605,
  [SMALL_STATE(7381)] = 193636,
  [SMALL_STATE(7382)] = 193667,
  [SMALL_STATE(7383)] = 193698,
  [SMALL_STATE(7384)] = 193729,
  [SMALL_STATE(7385)] = 193760,
  [SMALL_STATE(7386)] = 193791,
  [SMALL_STATE(7387)] = 193822,
  [SMALL_STATE(7388)] = 193853,
  [SMALL_STATE(7389)] = 193884,
  [SMALL_STATE(7390)] = 193915,
  [SMALL_STATE(7391)] = 193946,
  [SMALL_STATE(7392)] = 193977,
  [SMALL_STATE(7393)] = 194008,
  [SMALL_STATE(7394)] = 194039,
  [SMALL_STATE(7395)] = 194070,
  [SMALL_STATE(7396)] = 194101,
  [SMALL_STATE(7397)] = 194132,
  [SMALL_STATE(7398)] = 194163,
  [SMALL_STATE(7399)] = 194194,
  [SMALL_STATE(7400)] = 194225,
  [SMALL_STATE(7401)] = 194256,
  [SMALL_STATE(7402)] = 194287,
  [SMALL_STATE(7403)] = 194318,
  [SMALL_STATE(7404)] = 194349,
  [SMALL_STATE(7405)] = 194380,
  [SMALL_STATE(7406)] = 194411,
  [SMALL_STATE(7407)] = 194442,
  [SMALL_STATE(7408)] = 194473,
  [SMALL_STATE(7409)] = 194504,
  [SMALL_STATE(7410)] = 194535,
  [SMALL_STATE(7411)] = 194566,
  [SMALL_STATE(7412)] = 194597,
  [SMALL_STATE(7413)] = 194628,
  [SMALL_STATE(7414)] = 194659,
  [SMALL_STATE(7415)] = 194690,
  [SMALL_STATE(7416)] = 194721,
  [SMALL_STATE(7417)] = 194752,
  [SMALL_STATE(7418)] = 194783,
  [SMALL_STATE(7419)] = 194814,
  [SMALL_STATE(7420)] = 194845,
  [SMALL_STATE(7421)] = 194876,
  [SMALL_STATE(7422)] = 194907,
  [SMALL_STATE(7423)] = 194938,
  [SMALL_STATE(7424)] = 194969,
  [SMALL_STATE(7425)] = 195000,
  [SMALL_STATE(7426)] = 195031,
  [SMALL_STATE(7427)] = 195062,
  [SMALL_STATE(7428)] = 195093,
  [SMALL_STATE(7429)] = 195124,
  [SMALL_STATE(7430)] = 195155,
  [SMALL_STATE(7431)] = 195186,
  [SMALL_STATE(7432)] = 195217,
  [SMALL_STATE(7433)] = 195248,
  [SMALL_STATE(7434)] = 195279,
  [SMALL_STATE(7435)] = 195310,
  [SMALL_STATE(7436)] = 195341,
  [SMALL_STATE(7437)] = 195372,
  [SMALL_STATE(7438)] = 195403,
  [SMALL_STATE(7439)] = 195434,
  [SMALL_STATE(7440)] = 195465,
  [SMALL_STATE(7441)] = 195496,
  [SMALL_STATE(7442)] = 195527,
  [SMALL_STATE(7443)] = 195558,
  [SMALL_STATE(7444)] = 195589,
  [SMALL_STATE(7445)] = 195620,
  [SMALL_STATE(7446)] = 195651,
  [SMALL_STATE(7447)] = 195682,
  [SMALL_STATE(7448)] = 195713,
  [SMALL_STATE(7449)] = 195744,
  [SMALL_STATE(7450)] = 195775,
  [SMALL_STATE(7451)] = 195806,
  [SMALL_STATE(7452)] = 195837,
  [SMALL_STATE(7453)] = 195868,
  [SMALL_STATE(7454)] = 195899,
  [SMALL_STATE(7455)] = 195930,
  [SMALL_STATE(7456)] = 195961,
  [SMALL_STATE(7457)] = 195992,
  [SMALL_STATE(7458)] = 196023,
  [SMALL_STATE(7459)] = 196054,
  [SMALL_STATE(7460)] = 196085,
  [SMALL_STATE(7461)] = 196116,
  [SMALL_STATE(7462)] = 196147,
  [SMALL_STATE(7463)] = 196178,
  [SMALL_STATE(7464)] = 196209,
  [SMALL_STATE(7465)] = 196240,
  [SMALL_STATE(7466)] = 196271,
  [SMALL_STATE(7467)] = 196302,
  [SMALL_STATE(7468)] = 196333,
  [SMALL_STATE(7469)] = 196364,
  [SMALL_STATE(7470)] = 196395,
  [SMALL_STATE(7471)] = 196426,
  [SMALL_STATE(7472)] = 196457,
  [SMALL_STATE(7473)] = 196488,
  [SMALL_STATE(7474)] = 196519,
  [SMALL_STATE(7475)] = 196550,
  [SMALL_STATE(7476)] = 196581,
  [SMALL_STATE(7477)] = 196612,
  [SMALL_STATE(7478)] = 196643,
  [SMALL_STATE(7479)] = 196674,
  [SMALL_STATE(7480)] = 196705,
  [SMALL_STATE(7481)] = 196736,
  [SMALL_STATE(7482)] = 196767,
  [SMALL_STATE(7483)] = 196798,
  [SMALL_STATE(7484)] = 196829,
  [SMALL_STATE(7485)] = 196860,
  [SMALL_STATE(7486)] = 196891,
  [SMALL_STATE(7487)] = 196922,
  [SMALL_STATE(7488)] = 196953,
  [SMALL_STATE(7489)] = 196984,
  [SMALL_STATE(7490)] = 197015,
  [SMALL_STATE(7491)] = 197046,
  [SMALL_STATE(7492)] = 197077,
  [SMALL_STATE(7493)] = 197108,
  [SMALL_STATE(7494)] = 197139,
  [SMALL_STATE(7495)] = 197170,
  [SMALL_STATE(7496)] = 197201,
  [SMALL_STATE(7497)] = 197232,
  [SMALL_STATE(7498)] = 197263,
  [SMALL_STATE(7499)] = 197294,
  [SMALL_STATE(7500)] = 197325,
  [SMALL_STATE(7501)] = 197356,
  [SMALL_STATE(7502)] = 197387,
  [SMALL_STATE(7503)] = 197418,
  [SMALL_STATE(7504)] = 197449,
  [SMALL_STATE(7505)] = 197480,
  [SMALL_STATE(7506)] = 197511,
  [SMALL_STATE(7507)] = 197542,
  [SMALL_STATE(7508)] = 197573,
  [SMALL_STATE(7509)] = 197604,
  [SMALL_STATE(7510)] = 197635,
  [SMALL_STATE(7511)] = 197666,
  [SMALL_STATE(7512)] = 197697,
  [SMALL_STATE(7513)] = 197728,
  [SMALL_STATE(7514)] = 197759,
  [SMALL_STATE(7515)] = 197790,
  [SMALL_STATE(7516)] = 197821,
  [SMALL_STATE(7517)] = 197852,
  [SMALL_STATE(7518)] = 197883,
  [SMALL_STATE(7519)] = 197914,
  [SMALL_STATE(7520)] = 197945,
  [SMALL_STATE(7521)] = 197976,
  [SMALL_STATE(7522)] = 198007,
  [SMALL_STATE(7523)] = 198038,
  [SMALL_STATE(7524)] = 198069,
  [SMALL_STATE(7525)] = 198100,
  [SMALL_STATE(7526)] = 198131,
  [SMALL_STATE(7527)] = 198162,
  [SMALL_STATE(7528)] = 198193,
  [SMALL_STATE(7529)] = 198224,
  [SMALL_STATE(7530)] = 198255,
  [SMALL_STATE(7531)] = 198286,
  [SMALL_STATE(7532)] = 198317,
  [SMALL_STATE(7533)] = 198348,
  [SMALL_STATE(7534)] = 198379,
  [SMALL_STATE(7535)] = 198410,
  [SMALL_STATE(7536)] = 198441,
  [SMALL_STATE(7537)] = 198472,
  [SMALL_STATE(7538)] = 198503,
  [SMALL_STATE(7539)] = 198534,
  [SMALL_STATE(7540)] = 198565,
  [SMALL_STATE(7541)] = 198596,
  [SMALL_STATE(7542)] = 198627,
  [SMALL_STATE(7543)] = 198658,
  [SMALL_STATE(7544)] = 198689,
  [SMALL_STATE(7545)] = 198720,
  [SMALL_STATE(7546)] = 198751,
  [SMALL_STATE(7547)] = 198782,
  [SMALL_STATE(7548)] = 198813,
  [SMALL_STATE(7549)] = 198844,
  [SMALL_STATE(7550)] = 198875,
  [SMALL_STATE(7551)] = 198906,
  [SMALL_STATE(7552)] = 198937,
  [SMALL_STATE(7553)] = 198968,
  [SMALL_STATE(7554)] = 198999,
  [SMALL_STATE(7555)] = 199030,
  [SMALL_STATE(7556)] = 199061,
  [SMALL_STATE(7557)] = 199092,
  [SMALL_STATE(7558)] = 199123,
  [SMALL_STATE(7559)] = 199154,
  [SMALL_STATE(7560)] = 199185,
  [SMALL_STATE(7561)] = 199216,
  [SMALL_STATE(7562)] = 199247,
  [SMALL_STATE(7563)] = 199278,
  [SMALL_STATE(7564)] = 199309,
  [SMALL_STATE(7565)] = 199340,
  [SMALL_STATE(7566)] = 199371,
  [SMALL_STATE(7567)] = 199402,
  [SMALL_STATE(7568)] = 199433,
  [SMALL_STATE(7569)] = 199464,
  [SMALL_STATE(7570)] = 199495,
  [SMALL_STATE(7571)] = 199526,
  [SMALL_STATE(7572)] = 199557,
  [SMALL_STATE(7573)] = 199588,
  [SMALL_STATE(7574)] = 199619,
  [SMALL_STATE(7575)] = 199650,
  [SMALL_STATE(7576)] = 199681,
  [SMALL_STATE(7577)] = 199712,
  [SMALL_STATE(7578)] = 199743,
  [SMALL_STATE(7579)] = 199774,
  [SMALL_STATE(7580)] = 199805,
  [SMALL_STATE(7581)] = 199836,
  [SMALL_STATE(7582)] = 199867,
  [SMALL_STATE(7583)] = 199898,
  [SMALL_STATE(7584)] = 199929,
  [SMALL_STATE(7585)] = 199960,
  [SMALL_STATE(7586)] = 199991,
  [SMALL_STATE(7587)] = 200022,
  [SMALL_STATE(7588)] = 200053,
  [SMALL_STATE(7589)] = 200084,
  [SMALL_STATE(7590)] = 200115,
  [SMALL_STATE(7591)] = 200146,
  [SMALL_STATE(7592)] = 200177,
  [SMALL_STATE(7593)] = 200208,
  [SMALL_STATE(7594)] = 200239,
  [SMALL_STATE(7595)] = 200270,
  [SMALL_STATE(7596)] = 200301,
  [SMALL_STATE(7597)] = 200332,
  [SMALL_STATE(7598)] = 200363,
  [SMALL_STATE(7599)] = 200394,
  [SMALL_STATE(7600)] = 200425,
  [SMALL_STATE(7601)] = 200456,
  [SMALL_STATE(7602)] = 200487,
  [SMALL_STATE(7603)] = 200518,
  [SMALL_STATE(7604)] = 200549,
  [SMALL_STATE(7605)] = 200580,
  [SMALL_STATE(7606)] = 200611,
  [SMALL_STATE(7607)] = 200642,
  [SMALL_STATE(7608)] = 200673,
  [SMALL_STATE(7609)] = 200704,
  [SMALL_STATE(7610)] = 200735,
  [SMALL_STATE(7611)] = 200766,
  [SMALL_STATE(7612)] = 200797,
  [SMALL_STATE(7613)] = 200828,
  [SMALL_STATE(7614)] = 200859,
  [SMALL_STATE(7615)] = 200890,
  [SMALL_STATE(7616)] = 200921,
  [SMALL_STATE(7617)] = 200952,
  [SMALL_STATE(7618)] = 200983,
  [SMALL_STATE(7619)] = 201014,
  [SMALL_STATE(7620)] = 201045,
  [SMALL_STATE(7621)] = 201076,
  [SMALL_STATE(7622)] = 201107,
  [SMALL_STATE(7623)] = 201138,
  [SMALL_STATE(7624)] = 201169,
  [SMALL_STATE(7625)] = 201200,
  [SMALL_STATE(7626)] = 201231,
  [SMALL_STATE(7627)] = 201262,
  [SMALL_STATE(7628)] = 201293,
  [SMALL_STATE(7629)] = 201324,
  [SMALL_STATE(7630)] = 201355,
  [SMALL_STATE(7631)] = 201386,
  [SMALL_STATE(7632)] = 201417,
  [SMALL_STATE(7633)] = 201448,
  [SMALL_STATE(7634)] = 201479,
  [SMALL_STATE(7635)] = 201510,
  [SMALL_STATE(7636)] = 201541,
  [SMALL_STATE(7637)] = 201572,
  [SMALL_STATE(7638)] = 201603,
  [SMALL_STATE(7639)] = 201634,
  [SMALL_STATE(7640)] = 201665,
  [SMALL_STATE(7641)] = 201696,
  [SMALL_STATE(7642)] = 201727,
  [SMALL_STATE(7643)] = 201758,
  [SMALL_STATE(7644)] = 201789,
  [SMALL_STATE(7645)] = 201820,
  [SMALL_STATE(7646)] = 201851,
  [SMALL_STATE(7647)] = 201882,
  [SMALL_STATE(7648)] = 201913,
  [SMALL_STATE(7649)] = 201944,
  [SMALL_STATE(7650)] = 201975,
  [SMALL_STATE(7651)] = 202006,
  [SMALL_STATE(7652)] = 202037,
  [SMALL_STATE(7653)] = 202068,
  [SMALL_STATE(7654)] = 202099,
  [SMALL_STATE(7655)] = 202130,
  [SMALL_STATE(7656)] = 202161,
  [SMALL_STATE(7657)] = 202192,
  [SMALL_STATE(7658)] = 202223,
  [SMALL_STATE(7659)] = 202254,
  [SMALL_STATE(7660)] = 202285,
  [SMALL_STATE(7661)] = 202316,
  [SMALL_STATE(7662)] = 202347,
  [SMALL_STATE(7663)] = 202378,
  [SMALL_STATE(7664)] = 202409,
  [SMALL_STATE(7665)] = 202440,
  [SMALL_STATE(7666)] = 202471,
  [SMALL_STATE(7667)] = 202502,
  [SMALL_STATE(7668)] = 202533,
  [SMALL_STATE(7669)] = 202564,
  [SMALL_STATE(7670)] = 202595,
  [SMALL_STATE(7671)] = 202626,
  [SMALL_STATE(7672)] = 202657,
  [SMALL_STATE(7673)] = 202688,
  [SMALL_STATE(7674)] = 202719,
  [SMALL_STATE(7675)] = 202750,
  [SMALL_STATE(7676)] = 202781,
  [SMALL_STATE(7677)] = 202812,
  [SMALL_STATE(7678)] = 202843,
  [SMALL_STATE(7679)] = 202874,
  [SMALL_STATE(7680)] = 202905,
  [SMALL_STATE(7681)] = 202936,
  [SMALL_STATE(7682)] = 202967,
  [SMALL_STATE(7683)] = 202998,
  [SMALL_STATE(7684)] = 203029,
  [SMALL_STATE(7685)] = 203060,
  [SMALL_STATE(7686)] = 203091,
  [SMALL_STATE(7687)] = 203122,
  [SMALL_STATE(7688)] = 203153,
  [SMALL_STATE(7689)] = 203184,
  [SMALL_STATE(7690)] = 203215,
  [SMALL_STATE(7691)] = 203246,
  [SMALL_STATE(7692)] = 203277,
  [SMALL_STATE(7693)] = 203308,
  [SMALL_STATE(7694)] = 203339,
  [SMALL_STATE(7695)] = 203370,
  [SMALL_STATE(7696)] = 203401,
  [SMALL_STATE(7697)] = 203432,
  [SMALL_STATE(7698)] = 203463,
  [SMALL_STATE(7699)] = 203494,
  [SMALL_STATE(7700)] = 203525,
  [SMALL_STATE(7701)] = 203556,
  [SMALL_STATE(7702)] = 203587,
  [SMALL_STATE(7703)] = 203618,
  [SMALL_STATE(7704)] = 203649,
  [SMALL_STATE(7705)] = 203680,
  [SMALL_STATE(7706)] = 203711,
  [SMALL_STATE(7707)] = 203742,
  [SMALL_STATE(7708)] = 203773,
  [SMALL_STATE(7709)] = 203804,
  [SMALL_STATE(7710)] = 203835,
  [SMALL_STATE(7711)] = 203866,
  [SMALL_STATE(7712)] = 203897,
  [SMALL_STATE(7713)] = 203928,
  [SMALL_STATE(7714)] = 203959,
  [SMALL_STATE(7715)] = 203990,
  [SMALL_STATE(7716)] = 204021,
  [SMALL_STATE(7717)] = 204052,
  [SMALL_STATE(7718)] = 204083,
  [SMALL_STATE(7719)] = 204114,
  [SMALL_STATE(7720)] = 204145,
  [SMALL_STATE(7721)] = 204176,
  [SMALL_STATE(7722)] = 204207,
  [SMALL_STATE(7723)] = 204238,
  [SMALL_STATE(7724)] = 204269,
  [SMALL_STATE(7725)] = 204300,
  [SMALL_STATE(7726)] = 204331,
  [SMALL_STATE(7727)] = 204362,
  [SMALL_STATE(7728)] = 204393,
  [SMALL_STATE(7729)] = 204424,
  [SMALL_STATE(7730)] = 204455,
  [SMALL_STATE(7731)] = 204486,
  [SMALL_STATE(7732)] = 204517,
  [SMALL_STATE(7733)] = 204548,
  [SMALL_STATE(7734)] = 204579,
  [SMALL_STATE(7735)] = 204610,
  [SMALL_STATE(7736)] = 204641,
  [SMALL_STATE(7737)] = 204672,
  [SMALL_STATE(7738)] = 204703,
  [SMALL_STATE(7739)] = 204734,
  [SMALL_STATE(7740)] = 204765,
  [SMALL_STATE(7741)] = 204796,
  [SMALL_STATE(7742)] = 204827,
  [SMALL_STATE(7743)] = 204858,
  [SMALL_STATE(7744)] = 204889,
  [SMALL_STATE(7745)] = 204920,
  [SMALL_STATE(7746)] = 204951,
  [SMALL_STATE(7747)] = 204982,
  [SMALL_STATE(7748)] = 205013,
  [SMALL_STATE(7749)] = 205044,
  [SMALL_STATE(7750)] = 205075,
  [SMALL_STATE(7751)] = 205106,
  [SMALL_STATE(7752)] = 205137,
  [SMALL_STATE(7753)] = 205168,
  [SMALL_STATE(7754)] = 205199,
  [SMALL_STATE(7755)] = 205230,
  [SMALL_STATE(7756)] = 205261,
  [SMALL_STATE(7757)] = 205292,
  [SMALL_STATE(7758)] = 205323,
  [SMALL_STATE(7759)] = 205354,
  [SMALL_STATE(7760)] = 205385,
  [SMALL_STATE(7761)] = 205416,
  [SMALL_STATE(7762)] = 205447,
  [SMALL_STATE(7763)] = 205478,
  [SMALL_STATE(7764)] = 205509,
  [SMALL_STATE(7765)] = 205540,
  [SMALL_STATE(7766)] = 205571,
  [SMALL_STATE(7767)] = 205602,
  [SMALL_STATE(7768)] = 205633,
  [SMALL_STATE(7769)] = 205664,
  [SMALL_STATE(7770)] = 205695,
  [SMALL_STATE(7771)] = 205726,
  [SMALL_STATE(7772)] = 205757,
  [SMALL_STATE(7773)] = 205788,
  [SMALL_STATE(7774)] = 205819,
  [SMALL_STATE(7775)] = 205850,
  [SMALL_STATE(7776)] = 205881,
  [SMALL_STATE(7777)] = 205912,
  [SMALL_STATE(7778)] = 205943,
  [SMALL_STATE(7779)] = 205974,
  [SMALL_STATE(7780)] = 206005,
  [SMALL_STATE(7781)] = 206036,
  [SMALL_STATE(7782)] = 206067,
  [SMALL_STATE(7783)] = 206098,
  [SMALL_STATE(7784)] = 206129,
  [SMALL_STATE(7785)] = 206160,
  [SMALL_STATE(7786)] = 206191,
  [SMALL_STATE(7787)] = 206222,
  [SMALL_STATE(7788)] = 206253,
  [SMALL_STATE(7789)] = 206284,
  [SMALL_STATE(7790)] = 206315,
  [SMALL_STATE(7791)] = 206346,
  [SMALL_STATE(7792)] = 206377,
  [SMALL_STATE(7793)] = 206408,
  [SMALL_STATE(7794)] = 206439,
  [SMALL_STATE(7795)] = 206470,
  [SMALL_STATE(7796)] = 206501,
  [SMALL_STATE(7797)] = 206532,
  [SMALL_STATE(7798)] = 206563,
  [SMALL_STATE(7799)] = 206594,
  [SMALL_STATE(7800)] = 206625,
  [SMALL_STATE(7801)] = 206656,
  [SMALL_STATE(7802)] = 206687,
  [SMALL_STATE(7803)] = 206718,
  [SMALL_STATE(7804)] = 206749,
  [SMALL_STATE(7805)] = 206780,
  [SMALL_STATE(7806)] = 206811,
  [SMALL_STATE(7807)] = 206842,
  [SMALL_STATE(7808)] = 206873,
  [SMALL_STATE(7809)] = 206904,
  [SMALL_STATE(7810)] = 206935,
  [SMALL_STATE(7811)] = 206966,
  [SMALL_STATE(7812)] = 206997,
  [SMALL_STATE(7813)] = 207028,
  [SMALL_STATE(7814)] = 207059,
  [SMALL_STATE(7815)] = 207090,
  [SMALL_STATE(7816)] = 207121,
  [SMALL_STATE(7817)] = 207152,
  [SMALL_STATE(7818)] = 207183,
  [SMALL_STATE(7819)] = 207214,
  [SMALL_STATE(7820)] = 207245,
  [SMALL_STATE(7821)] = 207276,
  [SMALL_STATE(7822)] = 207307,
  [SMALL_STATE(7823)] = 207338,
  [SMALL_STATE(7824)] = 207369,
  [SMALL_STATE(7825)] = 207400,
  [SMALL_STATE(7826)] = 207431,
  [SMALL_STATE(7827)] = 207462,
  [SMALL_STATE(7828)] = 207493,
  [SMALL_STATE(7829)] = 207524,
  [SMALL_STATE(7830)] = 207555,
  [SMALL_STATE(7831)] = 207586,
  [SMALL_STATE(7832)] = 207617,
  [SMALL_STATE(7833)] = 207648,
  [SMALL_STATE(7834)] = 207679,
  [SMALL_STATE(7835)] = 207710,
  [SMALL_STATE(7836)] = 207741,
  [SMALL_STATE(7837)] = 207772,
  [SMALL_STATE(7838)] = 207803,
  [SMALL_STATE(7839)] = 207834,
  [SMALL_STATE(7840)] = 207865,
  [SMALL_STATE(7841)] = 207896,
  [SMALL_STATE(7842)] = 207927,
  [SMALL_STATE(7843)] = 207958,
  [SMALL_STATE(7844)] = 207989,
  [SMALL_STATE(7845)] = 208020,
  [SMALL_STATE(7846)] = 208051,
  [SMALL_STATE(7847)] = 208082,
  [SMALL_STATE(7848)] = 208113,
  [SMALL_STATE(7849)] = 208144,
  [SMALL_STATE(7850)] = 208175,
  [SMALL_STATE(7851)] = 208206,
  [SMALL_STATE(7852)] = 208237,
  [SMALL_STATE(7853)] = 208268,
  [SMALL_STATE(7854)] = 208299,
  [SMALL_STATE(7855)] = 208330,
  [SMALL_STATE(7856)] = 208361,
  [SMALL_STATE(7857)] = 208392,
  [SMALL_STATE(7858)] = 208423,
  [SMALL_STATE(7859)] = 208454,
  [SMALL_STATE(7860)] = 208485,
  [SMALL_STATE(7861)] = 208516,
  [SMALL_STATE(7862)] = 208547,
  [SMALL_STATE(7863)] = 208578,
  [SMALL_STATE(7864)] = 208609,
  [SMALL_STATE(7865)] = 208640,
  [SMALL_STATE(7866)] = 208671,
  [SMALL_STATE(7867)] = 208702,
  [SMALL_STATE(7868)] = 208733,
  [SMALL_STATE(7869)] = 208764,
  [SMALL_STATE(7870)] = 208795,
  [SMALL_STATE(7871)] = 208826,
  [SMALL_STATE(7872)] = 208857,
  [SMALL_STATE(7873)] = 208888,
  [SMALL_STATE(7874)] = 208919,
  [SMALL_STATE(7875)] = 208950,
  [SMALL_STATE(7876)] = 208981,
  [SMALL_STATE(7877)] = 209012,
  [SMALL_STATE(7878)] = 209043,
  [SMALL_STATE(7879)] = 209074,
  [SMALL_STATE(7880)] = 209105,
  [SMALL_STATE(7881)] = 209136,
  [SMALL_STATE(7882)] = 209167,
  [SMALL_STATE(7883)] = 209198,
  [SMALL_STATE(7884)] = 209229,
  [SMALL_STATE(7885)] = 209260,
  [SMALL_STATE(7886)] = 209291,
  [SMALL_STATE(7887)] = 209322,
  [SMALL_STATE(7888)] = 209353,
  [SMALL_STATE(7889)] = 209384,
  [SMALL_STATE(7890)] = 209415,
  [SMALL_STATE(7891)] = 209446,
  [SMALL_STATE(7892)] = 209477,
  [SMALL_STATE(7893)] = 209508,
  [SMALL_STATE(7894)] = 209539,
  [SMALL_STATE(7895)] = 209570,
  [SMALL_STATE(7896)] = 209601,
  [SMALL_STATE(7897)] = 209632,
  [SMALL_STATE(7898)] = 209663,
  [SMALL_STATE(7899)] = 209694,
  [SMALL_STATE(7900)] = 209725,
  [SMALL_STATE(7901)] = 209756,
  [SMALL_STATE(7902)] = 209787,
  [SMALL_STATE(7903)] = 209818,
  [SMALL_STATE(7904)] = 209849,
  [SMALL_STATE(7905)] = 209880,
  [SMALL_STATE(7906)] = 209911,
  [SMALL_STATE(7907)] = 209942,
  [SMALL_STATE(7908)] = 209973,
  [SMALL_STATE(7909)] = 210004,
  [SMALL_STATE(7910)] = 210035,
  [SMALL_STATE(7911)] = 210066,
  [SMALL_STATE(7912)] = 210097,
  [SMALL_STATE(7913)] = 210128,
  [SMALL_STATE(7914)] = 210159,
  [SMALL_STATE(7915)] = 210190,
  [SMALL_STATE(7916)] = 210221,
  [SMALL_STATE(7917)] = 210252,
  [SMALL_STATE(7918)] = 210283,
  [SMALL_STATE(7919)] = 210314,
  [SMALL_STATE(7920)] = 210345,
  [SMALL_STATE(7921)] = 210376,
  [SMALL_STATE(7922)] = 210407,
  [SMALL_STATE(7923)] = 210438,
  [SMALL_STATE(7924)] = 210469,
  [SMALL_STATE(7925)] = 210500,
  [SMALL_STATE(7926)] = 210531,
  [SMALL_STATE(7927)] = 210562,
  [SMALL_STATE(7928)] = 210593,
  [SMALL_STATE(7929)] = 210624,
  [SMALL_STATE(7930)] = 210655,
  [SMALL_STATE(7931)] = 210686,
  [SMALL_STATE(7932)] = 210717,
  [SMALL_STATE(7933)] = 210748,
  [SMALL_STATE(7934)] = 210779,
  [SMALL_STATE(7935)] = 210810,
  [SMALL_STATE(7936)] = 210841,
  [SMALL_STATE(7937)] = 210872,
  [SMALL_STATE(7938)] = 210903,
  [SMALL_STATE(7939)] = 210934,
  [SMALL_STATE(7940)] = 210965,
  [SMALL_STATE(7941)] = 210996,
  [SMALL_STATE(7942)] = 211027,
  [SMALL_STATE(7943)] = 211058,
  [SMALL_STATE(7944)] = 211089,
  [SMALL_STATE(7945)] = 211120,
  [SMALL_STATE(7946)] = 211151,
  [SMALL_STATE(7947)] = 211182,
  [SMALL_STATE(7948)] = 211213,
  [SMALL_STATE(7949)] = 211244,
  [SMALL_STATE(7950)] = 211275,
  [SMALL_STATE(7951)] = 211306,
  [SMALL_STATE(7952)] = 211337,
  [SMALL_STATE(7953)] = 211368,
  [SMALL_STATE(7954)] = 211399,
  [SMALL_STATE(7955)] = 211430,
  [SMALL_STATE(7956)] = 211461,
  [SMALL_STATE(7957)] = 211492,
  [SMALL_STATE(7958)] = 211523,
  [SMALL_STATE(7959)] = 211554,
  [SMALL_STATE(7960)] = 211585,
  [SMALL_STATE(7961)] = 211616,
  [SMALL_STATE(7962)] = 211647,
  [SMALL_STATE(7963)] = 211678,
  [SMALL_STATE(7964)] = 211709,
  [SMALL_STATE(7965)] = 211740,
  [SMALL_STATE(7966)] = 211771,
  [SMALL_STATE(7967)] = 211802,
  [SMALL_STATE(7968)] = 211833,
  [SMALL_STATE(7969)] = 211864,
  [SMALL_STATE(7970)] = 211895,
  [SMALL_STATE(7971)] = 211926,
  [SMALL_STATE(7972)] = 211957,
  [SMALL_STATE(7973)] = 211988,
  [SMALL_STATE(7974)] = 212019,
  [SMALL_STATE(7975)] = 212050,
  [SMALL_STATE(7976)] = 212081,
  [SMALL_STATE(7977)] = 212112,
  [SMALL_STATE(7978)] = 212143,
  [SMALL_STATE(7979)] = 212174,
  [SMALL_STATE(7980)] = 212205,
  [SMALL_STATE(7981)] = 212236,
  [SMALL_STATE(7982)] = 212267,
  [SMALL_STATE(7983)] = 212298,
  [SMALL_STATE(7984)] = 212329,
  [SMALL_STATE(7985)] = 212360,
  [SMALL_STATE(7986)] = 212391,
  [SMALL_STATE(7987)] = 212422,
  [SMALL_STATE(7988)] = 212453,
  [SMALL_STATE(7989)] = 212484,
  [SMALL_STATE(7990)] = 212515,
  [SMALL_STATE(7991)] = 212546,
  [SMALL_STATE(7992)] = 212577,
  [SMALL_STATE(7993)] = 212608,
  [SMALL_STATE(7994)] = 212639,
  [SMALL_STATE(7995)] = 212670,
  [SMALL_STATE(7996)] = 212701,
  [SMALL_STATE(7997)] = 212732,
  [SMALL_STATE(7998)] = 212763,
  [SMALL_STATE(7999)] = 212794,
  [SMALL_STATE(8000)] = 212825,
  [SMALL_STATE(8001)] = 212856,
  [SMALL_STATE(8002)] = 212887,
  [SMALL_STATE(8003)] = 212918,
  [SMALL_STATE(8004)] = 212949,
  [SMALL_STATE(8005)] = 212980,
  [SMALL_STATE(8006)] = 213011,
  [SMALL_STATE(8007)] = 213042,
  [SMALL_STATE(8008)] = 213073,
  [SMALL_STATE(8009)] = 213104,
  [SMALL_STATE(8010)] = 213135,
  [SMALL_STATE(8011)] = 213166,
  [SMALL_STATE(8012)] = 213197,
  [SMALL_STATE(8013)] = 213228,
  [SMALL_STATE(8014)] = 213259,
  [SMALL_STATE(8015)] = 213290,
  [SMALL_STATE(8016)] = 213321,
  [SMALL_STATE(8017)] = 213352,
  [SMALL_STATE(8018)] = 213383,
  [SMALL_STATE(8019)] = 213414,
  [SMALL_STATE(8020)] = 213445,
  [SMALL_STATE(8021)] = 213476,
  [SMALL_STATE(8022)] = 213507,
  [SMALL_STATE(8023)] = 213538,
  [SMALL_STATE(8024)] = 213569,
  [SMALL_STATE(8025)] = 213600,
  [SMALL_STATE(8026)] = 213631,
  [SMALL_STATE(8027)] = 213662,
  [SMALL_STATE(8028)] = 213693,
  [SMALL_STATE(8029)] = 213724,
  [SMALL_STATE(8030)] = 213755,
  [SMALL_STATE(8031)] = 213786,
  [SMALL_STATE(8032)] = 213817,
  [SMALL_STATE(8033)] = 213848,
  [SMALL_STATE(8034)] = 213879,
  [SMALL_STATE(8035)] = 213910,
  [SMALL_STATE(8036)] = 213941,
  [SMALL_STATE(8037)] = 213972,
  [SMALL_STATE(8038)] = 214003,
  [SMALL_STATE(8039)] = 214034,
  [SMALL_STATE(8040)] = 214065,
  [SMALL_STATE(8041)] = 214096,
  [SMALL_STATE(8042)] = 214127,
  [SMALL_STATE(8043)] = 214158,
  [SMALL_STATE(8044)] = 214189,
  [SMALL_STATE(8045)] = 214220,
  [SMALL_STATE(8046)] = 214251,
  [SMALL_STATE(8047)] = 214282,
  [SMALL_STATE(8048)] = 214313,
  [SMALL_STATE(8049)] = 214344,
  [SMALL_STATE(8050)] = 214375,
  [SMALL_STATE(8051)] = 214406,
  [SMALL_STATE(8052)] = 214437,
  [SMALL_STATE(8053)] = 214468,
  [SMALL_STATE(8054)] = 214499,
  [SMALL_STATE(8055)] = 214530,
  [SMALL_STATE(8056)] = 214561,
  [SMALL_STATE(8057)] = 214592,
  [SMALL_STATE(8058)] = 214623,
  [SMALL_STATE(8059)] = 214654,
  [SMALL_STATE(8060)] = 214685,
  [SMALL_STATE(8061)] = 214716,
  [SMALL_STATE(8062)] = 214747,
  [SMALL_STATE(8063)] = 214778,
  [SMALL_STATE(8064)] = 214809,
  [SMALL_STATE(8065)] = 214840,
  [SMALL_STATE(8066)] = 214871,
  [SMALL_STATE(8067)] = 214902,
  [SMALL_STATE(8068)] = 214933,
  [SMALL_STATE(8069)] = 214964,
  [SMALL_STATE(8070)] = 214995,
  [SMALL_STATE(8071)] = 215026,
  [SMALL_STATE(8072)] = 215057,
  [SMALL_STATE(8073)] = 215088,
  [SMALL_STATE(8074)] = 215119,
  [SMALL_STATE(8075)] = 215150,
  [SMALL_STATE(8076)] = 215181,
  [SMALL_STATE(8077)] = 215212,
  [SMALL_STATE(8078)] = 215243,
  [SMALL_STATE(8079)] = 215274,
  [SMALL_STATE(8080)] = 215305,
  [SMALL_STATE(8081)] = 215336,
  [SMALL_STATE(8082)] = 215367,
  [SMALL_STATE(8083)] = 215398,
  [SMALL_STATE(8084)] = 215429,
  [SMALL_STATE(8085)] = 215460,
  [SMALL_STATE(8086)] = 215491,
  [SMALL_STATE(8087)] = 215522,
  [SMALL_STATE(8088)] = 215553,
  [SMALL_STATE(8089)] = 215584,
  [SMALL_STATE(8090)] = 215615,
  [SMALL_STATE(8091)] = 215646,
  [SMALL_STATE(8092)] = 215677,
  [SMALL_STATE(8093)] = 215708,
  [SMALL_STATE(8094)] = 215739,
  [SMALL_STATE(8095)] = 215770,
  [SMALL_STATE(8096)] = 215801,
  [SMALL_STATE(8097)] = 215832,
  [SMALL_STATE(8098)] = 215863,
  [SMALL_STATE(8099)] = 215894,
  [SMALL_STATE(8100)] = 215925,
  [SMALL_STATE(8101)] = 215956,
  [SMALL_STATE(8102)] = 215987,
  [SMALL_STATE(8103)] = 216018,
  [SMALL_STATE(8104)] = 216049,
  [SMALL_STATE(8105)] = 216080,
  [SMALL_STATE(8106)] = 216111,
  [SMALL_STATE(8107)] = 216142,
  [SMALL_STATE(8108)] = 216173,
  [SMALL_STATE(8109)] = 216204,
  [SMALL_STATE(8110)] = 216235,
  [SMALL_STATE(8111)] = 216266,
  [SMALL_STATE(8112)] = 216297,
  [SMALL_STATE(8113)] = 216328,
  [SMALL_STATE(8114)] = 216359,
  [SMALL_STATE(8115)] = 216390,
  [SMALL_STATE(8116)] = 216421,
  [SMALL_STATE(8117)] = 216452,
  [SMALL_STATE(8118)] = 216483,
  [SMALL_STATE(8119)] = 216514,
  [SMALL_STATE(8120)] = 216545,
  [SMALL_STATE(8121)] = 216576,
  [SMALL_STATE(8122)] = 216607,
  [SMALL_STATE(8123)] = 216638,
  [SMALL_STATE(8124)] = 216669,
  [SMALL_STATE(8125)] = 216700,
  [SMALL_STATE(8126)] = 216731,
  [SMALL_STATE(8127)] = 216762,
  [SMALL_STATE(8128)] = 216793,
  [SMALL_STATE(8129)] = 216824,
  [SMALL_STATE(8130)] = 216855,
  [SMALL_STATE(8131)] = 216886,
  [SMALL_STATE(8132)] = 216917,
  [SMALL_STATE(8133)] = 216948,
  [SMALL_STATE(8134)] = 216979,
  [SMALL_STATE(8135)] = 217010,
  [SMALL_STATE(8136)] = 217041,
  [SMALL_STATE(8137)] = 217072,
  [SMALL_STATE(8138)] = 217103,
  [SMALL_STATE(8139)] = 217134,
  [SMALL_STATE(8140)] = 217165,
  [SMALL_STATE(8141)] = 217196,
  [SMALL_STATE(8142)] = 217227,
  [SMALL_STATE(8143)] = 217258,
  [SMALL_STATE(8144)] = 217289,
  [SMALL_STATE(8145)] = 217320,
  [SMALL_STATE(8146)] = 217351,
  [SMALL_STATE(8147)] = 217382,
  [SMALL_STATE(8148)] = 217413,
  [SMALL_STATE(8149)] = 217444,
  [SMALL_STATE(8150)] = 217475,
  [SMALL_STATE(8151)] = 217506,
  [SMALL_STATE(8152)] = 217537,
  [SMALL_STATE(8153)] = 217568,
  [SMALL_STATE(8154)] = 217599,
  [SMALL_STATE(8155)] = 217630,
  [SMALL_STATE(8156)] = 217661,
  [SMALL_STATE(8157)] = 217692,
  [SMALL_STATE(8158)] = 217723,
  [SMALL_STATE(8159)] = 217754,
  [SMALL_STATE(8160)] = 217785,
  [SMALL_STATE(8161)] = 217816,
  [SMALL_STATE(8162)] = 217847,
  [SMALL_STATE(8163)] = 217878,
  [SMALL_STATE(8164)] = 217909,
  [SMALL_STATE(8165)] = 217940,
  [SMALL_STATE(8166)] = 217971,
  [SMALL_STATE(8167)] = 218002,
  [SMALL_STATE(8168)] = 218033,
  [SMALL_STATE(8169)] = 218064,
  [SMALL_STATE(8170)] = 218095,
  [SMALL_STATE(8171)] = 218126,
  [SMALL_STATE(8172)] = 218157,
  [SMALL_STATE(8173)] = 218188,
  [SMALL_STATE(8174)] = 218219,
  [SMALL_STATE(8175)] = 218250,
  [SMALL_STATE(8176)] = 218281,
  [SMALL_STATE(8177)] = 218312,
  [SMALL_STATE(8178)] = 218343,
  [SMALL_STATE(8179)] = 218374,
  [SMALL_STATE(8180)] = 218405,
  [SMALL_STATE(8181)] = 218436,
  [SMALL_STATE(8182)] = 218467,
  [SMALL_STATE(8183)] = 218498,
  [SMALL_STATE(8184)] = 218529,
  [SMALL_STATE(8185)] = 218560,
  [SMALL_STATE(8186)] = 218591,
  [SMALL_STATE(8187)] = 218622,
  [SMALL_STATE(8188)] = 218653,
  [SMALL_STATE(8189)] = 218684,
  [SMALL_STATE(8190)] = 218715,
  [SMALL_STATE(8191)] = 218746,
  [SMALL_STATE(8192)] = 218777,
  [SMALL_STATE(8193)] = 218808,
  [SMALL_STATE(8194)] = 218839,
  [SMALL_STATE(8195)] = 218870,
  [SMALL_STATE(8196)] = 218901,
  [SMALL_STATE(8197)] = 218932,
  [SMALL_STATE(8198)] = 218963,
  [SMALL_STATE(8199)] = 218994,
  [SMALL_STATE(8200)] = 219025,
  [SMALL_STATE(8201)] = 219056,
  [SMALL_STATE(8202)] = 219087,
  [SMALL_STATE(8203)] = 219118,
  [SMALL_STATE(8204)] = 219149,
  [SMALL_STATE(8205)] = 219180,
  [SMALL_STATE(8206)] = 219211,
  [SMALL_STATE(8207)] = 219242,
  [SMALL_STATE(8208)] = 219273,
  [SMALL_STATE(8209)] = 219304,
  [SMALL_STATE(8210)] = 219335,
  [SMALL_STATE(8211)] = 219366,
  [SMALL_STATE(8212)] = 219397,
  [SMALL_STATE(8213)] = 219428,
  [SMALL_STATE(8214)] = 219459,
  [SMALL_STATE(8215)] = 219490,
  [SMALL_STATE(8216)] = 219521,
  [SMALL_STATE(8217)] = 219552,
  [SMALL_STATE(8218)] = 219583,
  [SMALL_STATE(8219)] = 219614,
  [SMALL_STATE(8220)] = 219645,
  [SMALL_STATE(8221)] = 219676,
  [SMALL_STATE(8222)] = 219707,
  [SMALL_STATE(8223)] = 219738,
  [SMALL_STATE(8224)] = 219769,
  [SMALL_STATE(8225)] = 219800,
  [SMALL_STATE(8226)] = 219831,
  [SMALL_STATE(8227)] = 219862,
  [SMALL_STATE(8228)] = 219893,
  [SMALL_STATE(8229)] = 219924,
  [SMALL_STATE(8230)] = 219955,
  [SMALL_STATE(8231)] = 219986,
  [SMALL_STATE(8232)] = 220017,
  [SMALL_STATE(8233)] = 220048,
  [SMALL_STATE(8234)] = 220079,
  [SMALL_STATE(8235)] = 220110,
  [SMALL_STATE(8236)] = 220141,
  [SMALL_STATE(8237)] = 220172,
  [SMALL_STATE(8238)] = 220203,
  [SMALL_STATE(8239)] = 220234,
  [SMALL_STATE(8240)] = 220265,
  [SMALL_STATE(8241)] = 220296,
  [SMALL_STATE(8242)] = 220327,
  [SMALL_STATE(8243)] = 220358,
  [SMALL_STATE(8244)] = 220389,
  [SMALL_STATE(8245)] = 220420,
  [SMALL_STATE(8246)] = 220451,
  [SMALL_STATE(8247)] = 220482,
  [SMALL_STATE(8248)] = 220513,
  [SMALL_STATE(8249)] = 220544,
  [SMALL_STATE(8250)] = 220575,
  [SMALL_STATE(8251)] = 220606,
  [SMALL_STATE(8252)] = 220637,
  [SMALL_STATE(8253)] = 220668,
  [SMALL_STATE(8254)] = 220699,
  [SMALL_STATE(8255)] = 220730,
  [SMALL_STATE(8256)] = 220761,
  [SMALL_STATE(8257)] = 220792,
  [SMALL_STATE(8258)] = 220823,
  [SMALL_STATE(8259)] = 220854,
  [SMALL_STATE(8260)] = 220885,
  [SMALL_STATE(8261)] = 220916,
  [SMALL_STATE(8262)] = 220947,
  [SMALL_STATE(8263)] = 220978,
  [SMALL_STATE(8264)] = 221009,
  [SMALL_STATE(8265)] = 221040,
  [SMALL_STATE(8266)] = 221071,
  [SMALL_STATE(8267)] = 221102,
  [SMALL_STATE(8268)] = 221133,
  [SMALL_STATE(8269)] = 221164,
  [SMALL_STATE(8270)] = 221195,
  [SMALL_STATE(8271)] = 221226,
  [SMALL_STATE(8272)] = 221257,
  [SMALL_STATE(8273)] = 221288,
  [SMALL_STATE(8274)] = 221319,
  [SMALL_STATE(8275)] = 221350,
  [SMALL_STATE(8276)] = 221381,
  [SMALL_STATE(8277)] = 221412,
  [SMALL_STATE(8278)] = 221443,
  [SMALL_STATE(8279)] = 221474,
  [SMALL_STATE(8280)] = 221505,
  [SMALL_STATE(8281)] = 221536,
  [SMALL_STATE(8282)] = 221567,
  [SMALL_STATE(8283)] = 221598,
  [SMALL_STATE(8284)] = 221629,
  [SMALL_STATE(8285)] = 221660,
  [SMALL_STATE(8286)] = 221691,
  [SMALL_STATE(8287)] = 221722,
  [SMALL_STATE(8288)] = 221753,
  [SMALL_STATE(8289)] = 221784,
  [SMALL_STATE(8290)] = 221815,
  [SMALL_STATE(8291)] = 221846,
  [SMALL_STATE(8292)] = 221877,
  [SMALL_STATE(8293)] = 221908,
  [SMALL_STATE(8294)] = 221939,
  [SMALL_STATE(8295)] = 221970,
  [SMALL_STATE(8296)] = 222001,
  [SMALL_STATE(8297)] = 222032,
  [SMALL_STATE(8298)] = 222063,
  [SMALL_STATE(8299)] = 222094,
  [SMALL_STATE(8300)] = 222125,
  [SMALL_STATE(8301)] = 222156,
  [SMALL_STATE(8302)] = 222187,
  [SMALL_STATE(8303)] = 222218,
  [SMALL_STATE(8304)] = 222249,
  [SMALL_STATE(8305)] = 222280,
  [SMALL_STATE(8306)] = 222311,
  [SMALL_STATE(8307)] = 222342,
  [SMALL_STATE(8308)] = 222373,
  [SMALL_STATE(8309)] = 222404,
  [SMALL_STATE(8310)] = 222435,
  [SMALL_STATE(8311)] = 222466,
  [SMALL_STATE(8312)] = 222497,
  [SMALL_STATE(8313)] = 222528,
  [SMALL_STATE(8314)] = 222559,
  [SMALL_STATE(8315)] = 222590,
  [SMALL_STATE(8316)] = 222621,
  [SMALL_STATE(8317)] = 222652,
  [SMALL_STATE(8318)] = 222683,
  [SMALL_STATE(8319)] = 222714,
  [SMALL_STATE(8320)] = 222745,
  [SMALL_STATE(8321)] = 222776,
  [SMALL_STATE(8322)] = 222807,
  [SMALL_STATE(8323)] = 222838,
  [SMALL_STATE(8324)] = 222869,
  [SMALL_STATE(8325)] = 222900,
  [SMALL_STATE(8326)] = 222931,
  [SMALL_STATE(8327)] = 222962,
  [SMALL_STATE(8328)] = 222993,
  [SMALL_STATE(8329)] = 223024,
  [SMALL_STATE(8330)] = 223055,
  [SMALL_STATE(8331)] = 223086,
  [SMALL_STATE(8332)] = 223117,
  [SMALL_STATE(8333)] = 223148,
  [SMALL_STATE(8334)] = 223179,
  [SMALL_STATE(8335)] = 223210,
  [SMALL_STATE(8336)] = 223241,
  [SMALL_STATE(8337)] = 223272,
  [SMALL_STATE(8338)] = 223303,
  [SMALL_STATE(8339)] = 223334,
  [SMALL_STATE(8340)] = 223365,
  [SMALL_STATE(8341)] = 223396,
  [SMALL_STATE(8342)] = 223427,
  [SMALL_STATE(8343)] = 223458,
  [SMALL_STATE(8344)] = 223489,
  [SMALL_STATE(8345)] = 223520,
  [SMALL_STATE(8346)] = 223551,
  [SMALL_STATE(8347)] = 223582,
  [SMALL_STATE(8348)] = 223613,
  [SMALL_STATE(8349)] = 223644,
  [SMALL_STATE(8350)] = 223675,
  [SMALL_STATE(8351)] = 223706,
  [SMALL_STATE(8352)] = 223737,
  [SMALL_STATE(8353)] = 223768,
  [SMALL_STATE(8354)] = 223799,
  [SMALL_STATE(8355)] = 223830,
  [SMALL_STATE(8356)] = 223861,
  [SMALL_STATE(8357)] = 223892,
  [SMALL_STATE(8358)] = 223923,
  [SMALL_STATE(8359)] = 223954,
  [SMALL_STATE(8360)] = 223985,
  [SMALL_STATE(8361)] = 224016,
  [SMALL_STATE(8362)] = 224047,
  [SMALL_STATE(8363)] = 224078,
  [SMALL_STATE(8364)] = 224109,
  [SMALL_STATE(8365)] = 224140,
  [SMALL_STATE(8366)] = 224171,
  [SMALL_STATE(8367)] = 224202,
  [SMALL_STATE(8368)] = 224233,
  [SMALL_STATE(8369)] = 224264,
  [SMALL_STATE(8370)] = 224295,
  [SMALL_STATE(8371)] = 224326,
  [SMALL_STATE(8372)] = 224357,
  [SMALL_STATE(8373)] = 224388,
  [SMALL_STATE(8374)] = 224419,
  [SMALL_STATE(8375)] = 224450,
  [SMALL_STATE(8376)] = 224481,
  [SMALL_STATE(8377)] = 224512,
  [SMALL_STATE(8378)] = 224543,
  [SMALL_STATE(8379)] = 224574,
  [SMALL_STATE(8380)] = 224605,
  [SMALL_STATE(8381)] = 224636,
  [SMALL_STATE(8382)] = 224667,
  [SMALL_STATE(8383)] = 224698,
  [SMALL_STATE(8384)] = 224729,
  [SMALL_STATE(8385)] = 224760,
  [SMALL_STATE(8386)] = 224791,
  [SMALL_STATE(8387)] = 224822,
  [SMALL_STATE(8388)] = 224853,
  [SMALL_STATE(8389)] = 224884,
  [SMALL_STATE(8390)] = 224915,
  [SMALL_STATE(8391)] = 224919,
  [SMALL_STATE(8392)] = 224923,
  [SMALL_STATE(8393)] = 224927,
  [SMALL_STATE(8394)] = 224931,
  [SMALL_STATE(8395)] = 224935,
  [SMALL_STATE(8396)] = 224939,
  [SMALL_STATE(8397)] = 224943,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8359),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8290),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8291),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8344),
  [15] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 0),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6569),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6571),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8388),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6572),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6573),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8384),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8383),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8383),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5222),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5249),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8381),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8379),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8378),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutate_expression, 3, .production_id = 19),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4438),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6938),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7126),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6391),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutate_expression, 3, .production_id = 19),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5907),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4503),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7932),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7933),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5190),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7330),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7935),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 5, .production_id = 42),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7939),
  [223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_expression, 5, .production_id = 42),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_application_expression, 2),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_application_expression, 2),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, .production_id = 7),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_expression, 2, .production_id = 7),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_expression, 3),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_expression, 3),
  [239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_instantiation_expression, 3),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_instantiation_expression, 3),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_expression, 2),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_expression, 2),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, .production_id = 17),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, .production_id = 17),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5928),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4676),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6574),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7984),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7984),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8362),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8347),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 1),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 1),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4444),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7050),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6558),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8090),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4590),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6688),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8084),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5191),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5306),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7690),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8168),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_construction, 2),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5923),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4680),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7023),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6341),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8057),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5921),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6700),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8051),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8135),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8135),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5228),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5254),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7676),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7610),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1), SHIFT(6730),
  [496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1), SHIFT(434),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1), SHIFT(3370),
  [504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1), SHIFT(7937),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4534),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6609),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6885),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6404),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8187),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8181),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8200),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5152),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7742),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7720),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1), SHIFT(3444),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4433),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7031),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7089),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6494),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7989),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5890),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8254),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4718),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6727),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7983),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8052),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5266),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7386),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7985),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 1),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4640),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8019),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8085),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4679),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6926),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6246),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8156),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5887),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8284),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4348),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6653),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8150),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8198),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8198),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6270),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5184),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7701),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 2),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6758),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8177),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comp_or_range_expression, 1),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, .production_id = 17),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_range, 1),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4464),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6939),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8140),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4650),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6662),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8134),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8182),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8182),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5230),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5247),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7718),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7691),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8119),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7152),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4613),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7012),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8193),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6684),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7106),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7049),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6317),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8024),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5924),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6711),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8018),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8118),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8118),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5264),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7572),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6904),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6326),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8172),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5885),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8289),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4487),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [1154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8166),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8196),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8196),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5289),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7736),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7711),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4638),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6802),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6400),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7817),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5927),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4509),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6805),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7809),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7810),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7209),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 3, .production_id = 39),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6593),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6873),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6850),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6546),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7884),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5897),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6768),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7876),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7877),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5211),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7196),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7879),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6823),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 2, .production_id = 26),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7073),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6884),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5892),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7068),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6993),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6562),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [1470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7079),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6810),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7120),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7131),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7095),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6745),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7040),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7080),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_comp_expression, 6),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_construction, 2),
  [1536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 5),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6954),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6388),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8274),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4702),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8117),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8167),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5246),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7699),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7678),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7005),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6829),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6988),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6970),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6566),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6650),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 2),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6915),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6697),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6837),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6902),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6933),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6620),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6564),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_parameter_value, 2),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6676),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7007),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, .production_id = 40),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7981),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6894),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6617),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6589),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6808),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7103),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6919),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7046),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6811),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6843),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7119),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6724),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7110),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7061),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6958),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6951),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6666),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6928),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6682),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6693),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6491),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6816),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4265),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6801),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8263),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7098),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 2, .production_id = 1),
  [1860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 2, .production_id = 1),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6274),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2),
  [1866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1262),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2),
  [1871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6274),
  [1874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6569),
  [1877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3804),
  [1880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(854),
  [1883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(4255),
  [1886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6570),
  [1889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(2638),
  [1892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(2638),
  [1895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6571),
  [1898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1318),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3541),
  [1904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6502),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6498),
  [1910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8388),
  [1913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(688),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(687),
  [1919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8387),
  [1922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(4406),
  [1925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(854),
  [1928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3059),
  [1931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(674),
  [1934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6572),
  [1937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3549),
  [1940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6573),
  [1943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(653),
  [1946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(653),
  [1949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8384),
  [1952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7984),
  [1955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7984),
  [1958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6574),
  [1961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(600),
  [1964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1412),
  [1967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(5222),
  [1970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(5249),
  [1973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(5542),
  [1976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8381),
  [1979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8380),
  [1982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1283),
  [1985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1283),
  [1988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8379),
  [1991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1300),
  [1994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3541),
  [1997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3540),
  [2000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3539),
  [2003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(865),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(869),
  [2009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6971),
  [2012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8378),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 3),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3, .production_id = 9),
  [2021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 3, .production_id = 9),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3, .production_id = 1),
  [2025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 3, .production_id = 1),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 4, .production_id = 9),
  [2029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 4, .production_id = 9),
  [2031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 2),
  [2033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 2),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6527),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6866),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6848),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8268),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [2065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(790),
  [2068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(4527),
  [2071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(790),
  [2074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8383),
  [2077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8383),
  [2080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(868),
  [2083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(872),
  [2086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1402),
  [2089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6527),
  [2092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6866),
  [2095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(729),
  [2098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(4277),
  [2101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6848),
  [2104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(2496),
  [2107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(2496),
  [2110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6985),
  [2113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1558),
  [2116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6558),
  [2119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6555),
  [2122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8268),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(622),
  [2128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(623),
  [2131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8269),
  [2134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(4590),
  [2137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(729),
  [2140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3062),
  [2143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(857),
  [2146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(3556),
  [2149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(6688),
  [2152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(825),
  [2155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(825),
  [2158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8084),
  [2161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8151),
  [2164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(8151),
  [2167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7050),
  [2170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(624),
  [2173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1674),
  [2176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(5191),
  [2179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(5306),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(5437),
  [2185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7689),
  [2188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7690),
  [2191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1661),
  [2194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1661),
  [2197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7646),
  [2200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(1466),
  [2203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(867),
  [2206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(870),
  [2209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7150),
  [2212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2), SHIFT_REPEAT(7878),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 4, .production_id = 30),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 2, .production_id = 1),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 3, .production_id = 1),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 4, .production_id = 10),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 3, .production_id = 10),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 1),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 5, .production_id = 30),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6936),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6937),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8288),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8253),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_construction, 1),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8238),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5594),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [2309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_construction, 1),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8293),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5618),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8278),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5515),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6696),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8283),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5578),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8273),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8258),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8201),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration, 1),
  [2415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration, 1),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8223),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4313),
  [2483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(1801),
  [2486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(700),
  [2489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7134),
  [2492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2393),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2393),
  [2498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7023),
  [2501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2215),
  [2504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3541),
  [2507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6341),
  [2510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6347),
  [2513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8263),
  [2516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(785),
  [2519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(791),
  [2522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8264),
  [2525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(4450),
  [2528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(700),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3061),
  [2534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(747),
  [2537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6572),
  [2540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3553),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6700),
  [2546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(808),
  [2549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(808),
  [2552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8051),
  [2555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8135),
  [2558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8135),
  [2561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7134),
  [2564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(839),
  [2567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2302),
  [2570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(5228),
  [2573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(5254),
  [2576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(5500),
  [2579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7676),
  [2582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7677),
  [2585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2306),
  [2588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2306),
  [2591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7610),
  [2594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2277),
  [2597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3541),
  [2600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3540),
  [2603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3539),
  [2606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(874),
  [2609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(894),
  [2612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8086),
  [2615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(633),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 1),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2134),
  [2625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(844),
  [2628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6742),
  [2631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6904),
  [2634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2379),
  [2637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6326),
  [2640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6327),
  [2643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8288),
  [2646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(841),
  [2649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(836),
  [2652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8289),
  [2655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(4487),
  [2658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(844),
  [2661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3096),
  [2664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(677),
  [2667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(3560),
  [2670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6648),
  [2673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(773),
  [2676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(773),
  [2679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8166),
  [2682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8196),
  [2685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8196),
  [2688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(6742),
  [2691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(835),
  [2694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2435),
  [2697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(5158),
  [2700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(5289),
  [2703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(5605),
  [2706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7736),
  [2709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7737),
  [2712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2429),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2429),
  [2718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(7711),
  [2721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(2717),
  [2724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(891),
  [2727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(906),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(8152),
  [2733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2), SHIFT_REPEAT(602),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 2),
  [2738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 2, .production_id = 27),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_parameter_value, 1),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7057),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7030),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7148),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6995),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6614),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6906),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7024),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const, 1),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const, 1),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7341),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8351),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8346),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7986),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8226),
  [2924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [2932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8257),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [2960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [2962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [2964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [2970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [2976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7226),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [2982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8102),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constrained_type, 3),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constrained_type, 3),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5443),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flexible_type, 2),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__flexible_type, 2),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [3046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [3056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [3060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7978),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [3072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [3086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7697),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3),
  [3094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [3100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [3106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [3128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [3138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [3144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7513),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typecast_expression, 3),
  [3156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typecast_expression, 3),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8048),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier, 2),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier, 2),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7980),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__compound_type, 2),
  [3214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compound_type, 2),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5593),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument, 2),
  [3232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 2),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [3242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument, 1),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 1),
  [3246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6495),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, .production_id = 20),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, .production_id = 20),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6978),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6738),
  [3257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier, 1),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier, 1),
  [3261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1),
  [3264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1),
  [3267] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7980),
  [3271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4698),
  [3274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2),
  [3278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6495),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, .production_id = 20),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, .production_id = 20),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7980),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [3296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_type, 2),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_type, 2),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__generic_type, 4),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_type, 4),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__generic_type, 3),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_type, 3),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier_or_op, 1),
  [3314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier_or_op, 1),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [3318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_type, 3),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_type, 3),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [3328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [3332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5506),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [3336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__static_type, 2),
  [3338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_type, 2),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_type, 2),
  [3342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_type, 2),
  [3344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 2),
  [3348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6738),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1),
  [3359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__static_type_identifier, 2),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_type_identifier, 2),
  [3365] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(8343),
  [3369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6475),
  [3372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8343),
  [3375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6475),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6626),
  [3382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4370),
  [3385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8343),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 3, .production_id = 16),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 3, .production_id = 16),
  [3391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7299),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5425),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6626),
  [3404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 1),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 1),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [3410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7303),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6677),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 2, .production_id = 6),
  [3419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 2, .production_id = 6),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4495),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5571),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [3433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4686),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_block, 3),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_block, 3),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 2),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 2),
  [3446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7303),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7376),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 5, .production_id = 44),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 5, .production_id = 44),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_expression, 4, .production_id = 61),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_expression, 4, .production_id = 61),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3375),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6073),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 3),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 3),
  [3467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7303),
  [3470] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7376),
  [3474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7376),
  [3477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6280),
  [3480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6280),
  [3483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2),
  [3487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(2991),
  [3490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7303),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 1),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 1),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4573),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5504),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 6),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 6),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [3515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5540),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 3),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 3),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 4),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 4),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 5, .production_id = 60),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 5, .production_id = 60),
  [3537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [3539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7716),
  [3542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 3, .production_id = 41),
  [3544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 3, .production_id = 41),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_expression, 2),
  [3548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8235),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6079),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7716),
  [3554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 8),
  [3556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 8),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [3560] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7716),
  [3564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6677),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4547),
  [3573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint16, 2),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint16, 2),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_triple_quoted_string, 3),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_triple_quoted_string, 3),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_triple_quoted_string, 3),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triple_quoted_string, 3),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7059),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6713),
  [3593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4492),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7620),
  [3598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_string, 3),
  [3600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_string, 3),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bytearray, 3),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bytearray, 3),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8371),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_op, 1),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_op, 1),
  [3612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_expression, 2),
  [3614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_expression, 2),
  [3616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string, 3),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string, 3),
  [3620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_expression, 3),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_expression, 3),
  [3624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 3),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 3),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4507),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [3638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 2),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 2),
  [3646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_expression, 3),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_expression, 3),
  [3650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7620),
  [3653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6551),
  [3656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ieee64, 2),
  [3658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ieee64, 2),
  [3660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ieee32, 2),
  [3662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ieee32, 2),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [3672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6371),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_end_expression, 3),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_end_expression, 3),
  [3679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_expression, 2),
  [3681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4367),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decimal, 2),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 2),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 2),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 2),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 3),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 3),
  [3705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 3, .production_id = 15),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 3, .production_id = 15),
  [3709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6551),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_expression, 3, .production_id = 18),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_expression, 3, .production_id = 18),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [3718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 3),
  [3720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 3),
  [3722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bignum, 2),
  [3724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bignum, 2),
  [3726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint64, 2),
  [3728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint64, 2),
  [3730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier_or_op, 3),
  [3732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier_or_op, 3),
  [3734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int64, 2),
  [3736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int64, 2),
  [3738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unativeint, 2),
  [3740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unativeint, 2),
  [3742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 4, .production_id = 15),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 4, .production_id = 15),
  [3746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nativeint, 2),
  [3748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nativeint, 2),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4551),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5598),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [3762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_application_expression, 3),
  [3764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_application_expression, 3),
  [3766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint32, 2),
  [3768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint32, 2),
  [3770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int32, 2),
  [3772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int32, 2),
  [3774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_bytearray, 3),
  [3776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_bytearray, 3),
  [3778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int16, 2),
  [3780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int16, 2),
  [3782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_byte, 2),
  [3784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_byte, 2),
  [3786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sbyte, 2),
  [3788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sbyte, 2),
  [3790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_bytearray, 2),
  [3792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_bytearray, 2),
  [3794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_string, 2),
  [3796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_string, 2),
  [3798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bytearray, 2),
  [3800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bytearray, 2),
  [3802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string, 2),
  [3804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string, 2),
  [3806] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7620),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6638),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6635),
  [3814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 5, .production_id = 43),
  [3816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 5, .production_id = 43),
  [3818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 6, .production_id = 53),
  [3820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 6, .production_id = 53),
  [3822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4557),
  [3825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_triple_quoted_string, 1),
  [3827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triple_quoted_string, 1),
  [3829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequential_expression_repeat1, 2),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2),
  [3833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(856),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1),
  [3840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 1),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 1),
  [3844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6371),
  [3847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 9),
  [3849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 9),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [3855] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7497),
  [3859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 7, .production_id = 55),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 7, .production_id = 55),
  [3867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3015),
  [3870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7281),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [3875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7281),
  [3878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7),
  [3880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [3884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ce_expression, 6, .production_id = 49),
  [3886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ce_expression, 6, .production_id = 49),
  [3888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 6, .production_id = 54),
  [3890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 6, .production_id = 54),
  [3892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7497),
  [3895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6, .production_id = 48),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6, .production_id = 48),
  [3899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6),
  [3903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7281),
  [3906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, .production_id = 47),
  [3908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, .production_id = 47),
  [3910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fun_expression, 4),
  [3912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fun_expression, 4),
  [3914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__else_expression, 2, .production_id = 46),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__else_expression, 2, .production_id = 46),
  [3918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7281),
  [3921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 4),
  [3923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 4),
  [3925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, .production_id = 29),
  [3927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, .production_id = 29),
  [3929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, .production_id = 28),
  [3931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, .production_id = 28),
  [3933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, .production_id = 45),
  [3935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, .production_id = 45),
  [3937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 4, .production_id = 29),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 4, .production_id = 29),
  [3941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 5),
  [3943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 5),
  [3945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 5),
  [3947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 5),
  [3949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5),
  [3951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5),
  [3953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_record_expression, 5, .production_id = 28),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_record_expression, 5, .production_id = 28),
  [3957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_expression, 5, .production_id = 28),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_expression, 5, .production_id = 28),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, .production_id = 32),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, .production_id = 32),
  [3965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_application_expression, 4),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_application_expression, 4),
  [3969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 4),
  [3971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 4),
  [3973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4),
  [3977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, .production_id = 31),
  [3979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, .production_id = 31),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7509),
  [3983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(701),
  [3986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6302),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7579),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [3993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6713),
  [3996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8350),
  [3999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3016),
  [4002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7519),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [4007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7519),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [4012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7519),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6086),
  [4017] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7509),
  [4021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6296),
  [4024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7509),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7086),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6692),
  [4031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6296),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [4036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4574),
  [4039] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7579),
  [4043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7519),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6655),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8350),
  [4052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4618),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [4057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6635),
  [4060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6302),
  [4063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7579),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [4068] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(8350),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6765),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6013),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [4084] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7875),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7875),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [4092] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7907),
  [4096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4368),
  [4099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6285),
  [4102] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7479),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6886),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6753),
  [4110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(573),
  [4113] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7490),
  [4117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6652),
  [4120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7490),
  [4123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4540),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7142),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6704),
  [4130] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7520),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7479),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [4140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7479),
  [4143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6692),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7266),
  [4148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(690),
  [4151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6355),
  [4154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6655),
  [4157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6355),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7717),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6889),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6665),
  [4170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6346),
  [4173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 2),
  [4175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 2),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7520),
  [4179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6255),
  [4182] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7717),
  [4186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7717),
  [4189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7520),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6699),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [4196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6273),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7907),
  [4201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4547),
  [4204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6273),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [4209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4544),
  [4212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6346),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7964),
  [4217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7907),
  [4220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6255),
  [4223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1), SHIFT(6285),
  [4226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4473),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [4231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7875),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6107),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [4238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6122),
  [4240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6641),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [4257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7362),
  [4260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7362),
  [4263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6665),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6091),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8091),
  [4274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7362),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [4279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3025),
  [4282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7362),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8191),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [4293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6799),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7936),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6077),
  [4300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [4302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7686),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8286),
  [4309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6753),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [4314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7686),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [4319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7686),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [4326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3029),
  [4329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7686),
  [4332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2), SHIFT_REPEAT(6704),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [4337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7470),
  [4340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7470),
  [4343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3011),
  [4346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7470),
  [4349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [4351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7470),
  [4354] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7753),
  [4358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8128),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [4363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7597),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7753),
  [4368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7753),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8376),
  [4373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8128),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8036),
  [4381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7597),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8028),
  [4386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7597),
  [4389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [4391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3012),
  [4394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7597),
  [4397] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(8128),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7460),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7468),
  [4409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7468),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [4416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7633),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7642),
  [4421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7633),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [4426] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7468),
  [4430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7633),
  [4433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(2993),
  [4436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7633),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [4441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(583),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7574),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [4450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7574),
  [4453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [4455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(615),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [4460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7559),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [4465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7559),
  [4470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7559),
  [4473] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(8333),
  [4477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3018),
  [4480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7559),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [4485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [4487] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7775),
  [4491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7525),
  [4493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7525),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2971),
  [4498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7233),
  [4501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3027),
  [4504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7416),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [4509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7416),
  [4512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7416),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3686),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [4519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 1),
  [4521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [4523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 1),
  [4525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [4527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5162),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6395),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6389),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [4541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5163),
  [4543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7645),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7494),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3114),
  [4567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [4569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5715),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [4575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6509),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [4583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5123),
  [4585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5281),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [4593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [4597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7534),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [4607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8333),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(756),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [4621] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7525),
  [4625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7416),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [4630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7233),
  [4633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7775),
  [4636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(797),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8333),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5199),
  [4657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5316),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7438),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7439),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [4669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7451),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [4677] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7574),
  [4681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7233),
  [4684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(2971),
  [4687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7233),
  [4690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(676),
  [4693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [4695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(3028),
  [4698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7669),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [4703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(614),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [4708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7669),
  [4711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [4713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(2979),
  [4716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(7172),
  [4719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7669),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [4724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3), SHIFT(7172),
  [4727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(781),
  [4730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2), SHIFT(7172),
  [4733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7669),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7775),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [4742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1), SHIFT(7172),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [4747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(766),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [4762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 2),
  [4764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 2),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5168),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5161),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5196),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3793),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5181),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [4824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6266),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [4830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(758),
  [4833] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7673),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7557),
  [4839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7557),
  [4842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(807),
  [4845] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7557),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [4859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7570),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4221),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [4877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(644),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7673),
  [4882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [4884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [4886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(662),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [4891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7231),
  [4894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7231),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [4900] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7231),
  [4904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2), SHIFT_REPEAT(598),
  [4907] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7802),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7222),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [4915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7802),
  [4918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7673),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [4927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7222),
  [4930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6266),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [4937] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1), REDUCE(sym__identifier_or_op, 1), SHIFT(7222),
  [4941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5893),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [4955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curried_spec, 2),
  [4957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curried_spec, 2),
  [4959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 1),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [4973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5558),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [4979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curried_spec, 1),
  [4981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curried_spec, 1),
  [4983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8225),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8225),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [4992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6369),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [4997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [4999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [5005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [5013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6430),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7962),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [5029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7464),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7069),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8003),
  [5036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 7),
  [5038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 7),
  [5040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_defns, 1),
  [5042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__member_defns, 1),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6012),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6582),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5949),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6001),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6222),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [5056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4529),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8070),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7843),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [5069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 8),
  [5071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 8),
  [5073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 6),
  [5075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 6),
  [5077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 4),
  [5079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 4),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8188),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8103),
  [5089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2),
  [5091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2),
  [5093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3804),
  [5096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(4169),
  [5099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3171),
  [5102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6012),
  [5105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6582),
  [5108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5949),
  [5111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6001),
  [5114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6222),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [5119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7910),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8037),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_defns, 2),
  [5127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__member_defns, 2),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 5),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 5),
  [5133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4523),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6027),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6029),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [5148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3176),
  [5151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6027),
  [5154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(7076),
  [5157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5965),
  [5160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6029),
  [5163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6229),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [5188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_implementation, 2),
  [5190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_implementation, 2),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8184),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [5204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3639),
  [5207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2),
  [5209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3771),
  [5212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3115),
  [5215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3962),
  [5218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3961),
  [5221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3181),
  [5224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(5432),
  [5227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(6430),
  [5230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(6437),
  [5233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(6456),
  [5236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3677),
  [5239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(5199),
  [5242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(5316),
  [5245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(5423),
  [5248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(7438),
  [5251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(7439),
  [5254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3725),
  [5257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3725),
  [5260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(7451),
  [5263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3736),
  [5266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3564),
  [5269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2), SHIFT_REPEAT(3567),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8007),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [5298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [5300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [5308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [5314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [5316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [5320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7708),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [5334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 2),
  [5336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 2),
  [5338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6687),
  [5340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 6),
  [5342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 6),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [5348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 4),
  [5350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 4),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [5354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 3),
  [5356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 3),
  [5358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6690),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [5366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 4),
  [5368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 4),
  [5370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6703),
  [5372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 5),
  [5374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 5),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8021),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8022),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [5384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [5390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 3),
  [5392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 3),
  [5394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 2, .production_id = 34),
  [5396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_or_prop_defn, 2, .production_id = 34),
  [5398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 2, .production_id = 35),
  [5400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_or_prop_defn, 2, .production_id = 35),
  [5402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [5404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [5406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [5408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [5416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5239),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7726),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [5426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [5430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_defn, 4, .production_id = 63),
  [5438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_defn, 4, .production_id = 63),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 5, .production_id = 62),
  [5442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_or_prop_defn, 5, .production_id = 62),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3803),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3765),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 2),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 2),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3778),
  [5462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additional_constr_defn, 5),
  [5464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additional_constr_defn, 5),
  [5466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 8),
  [5468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 8),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [5476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3776),
  [5478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_defn, 3, .production_id = 57),
  [5480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_defn, 3, .production_id = 57),
  [5482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 1),
  [5484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__member_defns_repeat1, 1),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additional_constr_defn, 4),
  [5488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additional_constr_defn, 4),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [5492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 7),
  [5494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 7),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 6),
  [5504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 6),
  [5506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 1),
  [5508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 1),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7097),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7101),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7241),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7104),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 3),
  [5528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 3),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 2),
  [5534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 2),
  [5536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4),
  [5538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4),
  [5540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [5542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [5544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(3804),
  [5547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(4246),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2),
  [5552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2),
  [5554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4599),
  [5557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(4280),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_defn_elements, 1),
  [5564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_defn_elements, 1),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4599),
  [5568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6379),
  [5571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6278),
  [5573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [5575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [5577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6379),
  [5579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4439),
  [5582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6278),
  [5585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [5589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 1),
  [5593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__object_expression_inner_repeat1, 1),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [5597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_implementation, 3, .production_id = 36),
  [5599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_implementation, 3, .production_id = 36),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8287),
  [5605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4278),
  [5607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [5609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4440),
  [5611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6386),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [5621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5223),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5270),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [5631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [5635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8154),
  [5641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7695),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6237),
  [5646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7982),
  [5649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defns, 1, .production_id = 13),
  [5651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defns, 1, .production_id = 13),
  [5653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [5655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6237),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23),
  [5660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23),
  [5662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2816),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [5669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7815),
  [5672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defns, 2, .production_id = 23),
  [5674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defns, 2, .production_id = 23),
  [5676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_members, 4, .production_id = 28),
  [5678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__object_members, 4, .production_id = 28),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 3),
  [5682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 3),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_defn, 5, .production_id = 49),
  [5686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_defn, 5, .production_id = 49),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [5692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7488),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [5697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defn_body, 5, .production_id = 52),
  [5699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defn_body, 5, .production_id = 52),
  [5701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_defn, 9, .production_id = 66),
  [5703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_defn, 9, .production_id = 66),
  [5705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 6, .production_id = 48),
  [5707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 6, .production_id = 48),
  [5709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [5711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defn_body, 3, .production_id = 25),
  [5713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defn_body, 3, .production_id = 25),
  [5715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 4),
  [5717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 4),
  [5719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2799),
  [5722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4655),
  [5725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4617),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_abbrev_defn, 5, .production_id = 49),
  [5732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_abbrev_defn, 5, .production_id = 49),
  [5734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7552),
  [5737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [5739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_extension, 2),
  [5741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_extension, 2),
  [5743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_defn, 6, .production_id = 56),
  [5745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_defn, 6, .production_id = 56),
  [5747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_type_defn, 5, .production_id = 49),
  [5749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_type_defn, 5, .production_id = 49),
  [5751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_extension_elements, 1),
  [5753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_extension_elements, 1),
  [5755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_extension_elements, 4, .production_id = 28),
  [5757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_extension_elements, 4, .production_id = 28),
  [5759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_defn_body, 1),
  [5761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_defn_body, 1),
  [5763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6463),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [5768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_defn, 5, .production_id = 49),
  [5770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type_defn, 5, .production_id = 49),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 5, .production_id = 49),
  [5774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 5, .production_id = 49),
  [5776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_defn, 10, .production_id = 67),
  [5778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_defn, 10, .production_id = 67),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5481),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5304),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4488),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5322),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [5824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_defn, 7, .production_id = 55),
  [5826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_defn, 7, .production_id = 55),
  [5828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, .production_id = 54),
  [5830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, .production_id = 54),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_defn, 8, .production_id = 64),
  [5844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_defn, 8, .production_id = 64),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [5854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_decl, 2),
  [5856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_decl, 2),
  [5858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_or_value_defn, 3, .production_id = 12),
  [5860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_or_value_defn, 3, .production_id = 12),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [5866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_or_value_defn, 2, .production_id = 4),
  [5868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_or_value_defn, 2, .production_id = 4),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_defn, 6, .production_id = 48),
  [5874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_defn, 6, .production_id = 48),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_abbrev, 6, .production_id = 48),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_abbrev, 6, .production_id = 48),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [5886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 29),
  [5888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 29),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [5900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7358),
  [5903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_abbrev, 7, .production_id = 55),
  [5905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_abbrev, 7, .production_id = 55),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [5911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration, 2),
  [5913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration, 2),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [5931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4333),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [5936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fsi_directive_decl, 3, .production_id = 8),
  [5938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fsi_directive_decl, 3, .production_id = 8),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [5942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4344),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [5947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [5949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [5951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [5955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4773),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [5969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [5971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4539),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8312),
  [5975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8214),
  [5977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6126),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5939),
  [5981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5960),
  [5983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [5985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6049),
  [5987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6136),
  [5989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8213),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [5993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8330),
  [5997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8311),
  [6001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2810),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8215),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [6008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2811),
  [6011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [6013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2795),
  [6016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_op, 1),
  [6018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_op, 1),
  [6020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_prefix_op_repeat1, 2),
  [6022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 2),
  [6024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 2), SHIFT_REPEAT(3540),
  [6027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_op, 1),
  [6029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_op, 1),
  [6031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_prefix_op_repeat1, 1),
  [6033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 1),
  [6035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_or_prefix_op, 1),
  [6037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_or_prefix_op, 1),
  [6039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(4278),
  [6042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2),
  [6044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(3137),
  [6047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(4440),
  [6050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(6386),
  [6053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(6383),
  [6056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(6539),
  [6059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(4717),
  [6062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(5223),
  [6065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(5270),
  [6068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(5603),
  [6071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(7328),
  [6074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(7329),
  [6077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(4700),
  [6080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(4700),
  [6083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(3667),
  [6086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(3792),
  [6089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_patterns, 1),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [6093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2), SHIFT_REPEAT(6382),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [6104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3719),
  [6106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [6110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3727),
  [6112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3731),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [6116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [6118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [6124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [6130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3868),
  [6132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [6134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [6136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [6138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [6142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8127),
  [6152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [6154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [6156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [6158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [6160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [6162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [6166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [6168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [6174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3823),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8301),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3737),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [6184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3995),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7563),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3852),
  [6216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [6220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [6222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [6224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4154),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4153),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4151),
  [6236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4149),
  [6238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4147),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4143),
  [6246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4142),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [6250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8149),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3601),
  [6254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_pattern, 3),
  [6256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_pattern, 3),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [6260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5900),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [6268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6271),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [6285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 4),
  [6287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 4),
  [6289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4140),
  [6293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 3),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 3),
  [6297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6256),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [6302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7480),
  [6305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7483),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 2),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 2),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [6318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4671),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [6323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4703),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [6330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5128),
  [6332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5257),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [6342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [6346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [6358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [6392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6557),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [6400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6557),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [6409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7340),
  [6412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [6422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8175),
  [6424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_param, 1),
  [6426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_param, 1),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [6430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5888),
  [6432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8046),
  [6435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(3804),
  [6438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(6820),
  [6441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(2482),
  [6444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(2482),
  [6447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(4169),
  [6450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(3166),
  [6453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(6031),
  [6456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(5954),
  [6459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(5936),
  [6462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(4656),
  [6465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(6014),
  [6468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(6168),
  [6471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(7841),
  [6474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(7842),
  [6477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2),
  [6479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(3940),
  [6482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [6484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [6486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [6488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4435),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4456),
  [6492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4458),
  [6494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [6496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4470),
  [6498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [6500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4637),
  [6502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4546),
  [6504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4561),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [6510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6370),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6370),
  [6517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8141),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8101),
  [6521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4563),
  [6524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8146),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8300),
  [6529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5894),
  [6531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(6888),
  [6534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(2764),
  [6537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(2764),
  [6540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(3179),
  [6543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(5978),
  [6546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(5958),
  [6549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(5948),
  [6552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(4442),
  [6555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(5981),
  [6558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(6218),
  [6561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(7908),
  [6564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(7909),
  [6567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2), SHIFT_REPEAT(3924),
  [6570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [6574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [6578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6218),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7908),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [6600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_class_definition, 2),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [6604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7568),
  [6607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7634),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [6611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8300),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [6616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_class_definition, 1),
  [6618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8101),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [6627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2),
  [6629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2),
  [6631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5929),
  [6634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6440),
  [6637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4400),
  [6640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_constraints, 3),
  [6642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_constraints, 3),
  [6644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5929),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [6648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [6652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8366),
  [6654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4633),
  [6656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [6658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4649),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [6672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [6676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_constraints, 2),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_constraints, 2),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [6684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4571),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [6696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunct_pattern, 3),
  [6698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunct_pattern, 3),
  [6700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4476),
  [6702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2),
  [6704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2),
  [6706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3101),
  [6709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conjunct_pattern, 3),
  [6711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conjunct_pattern, 3),
  [6713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_pattern, 2),
  [6715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_pattern, 2),
  [6717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_pattern, 2),
  [6719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_pattern, 2),
  [6721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cons_pattern, 3),
  [6723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cons_pattern, 3),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8213),
  [6743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7680),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [6753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_pattern, 2),
  [6755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_pattern, 2),
  [6757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_pattern, 3),
  [6759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3),
  [6761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 2),
  [6763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 2),
  [6765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 3),
  [6767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 3),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [6771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_record_pattern_repeat1, 2),
  [6773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2),
  [6775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6519),
  [6778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 9),
  [6780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 9),
  [6782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 8),
  [6784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 8),
  [6786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 3),
  [6788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 3),
  [6790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 5),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 5),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [6798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 6),
  [6800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 6),
  [6802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 1),
  [6804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 1),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [6816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 4),
  [6818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 4),
  [6820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_check_pattern, 2),
  [6822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_check_pattern, 2),
  [6824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7653),
  [6826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [6830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4517),
  [6832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [6836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4532),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [6840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [6842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4493),
  [6844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4485),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7583),
  [6850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [6854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4537),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4611),
  [6862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4516),
  [6864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4741),
  [6866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4457),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [6870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_pattern, 4, .production_id = 38),
  [6872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_pattern, 4, .production_id = 38),
  [6874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_check_pattern, 4),
  [6876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_check_pattern, 4),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [6880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, .production_id = 24),
  [6882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, .production_id = 24),
  [6884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, .production_id = 24),
  [6886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, .production_id = 24),
  [6888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3),
  [6890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3),
  [6892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 3),
  [6894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 3),
  [6896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3145),
  [6899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, .production_id = 3),
  [6901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, .production_id = 3),
  [6903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1),
  [6905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [6907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [6909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [6911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4781),
  [6913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4524),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [6917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 1),
  [6919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 1),
  [6921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [6923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4533),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4189),
  [6927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [6931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4290),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [6935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4610),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7675),
  [6941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_pattern, 3),
  [6943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_pattern, 3),
  [6945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [6947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [6949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2),
  [6951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8138),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [6957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(5840),
  [6960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(3773),
  [6963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(4651),
  [6966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(5304),
  [6969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(8125),
  [6972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(4488),
  [6975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2), SHIFT_REPEAT(7826),
  [6978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7512),
  [6981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6311),
  [6983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [6985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6311),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [6990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8041),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [7000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 2),
  [7002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2), SHIFT_REPEAT(3771),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2),
  [7007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6376),
  [7009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [7011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8107),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [7033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5840),
  [7055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5913),
  [7058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5913),
  [7060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5889),
  [7062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6376),
  [7065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5889),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [7070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [7072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3063),
  [7075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6253),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4379),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7496),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [7088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_or_ident, 1),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_or_ident, 1),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [7094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3041),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7459),
  [7107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7473),
  [7109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7462),
  [7112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_set, 4),
  [7114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_set, 4),
  [7116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_set, 3),
  [7118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_set, 3),
  [7120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6402),
  [7123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 1),
  [7125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 1),
  [7127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6402),
  [7129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6443),
  [7132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7459),
  [7135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3166),
  [7138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6031),
  [7141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(7011),
  [7144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5936),
  [7147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6014),
  [7150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6168),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [7157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [7175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_or_ident, 3, .production_id = 50),
  [7177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_or_ident, 3, .production_id = 50),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7990),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6112),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [7199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_modifier, 1),
  [7201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_modifier, 1),
  [7203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5140),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [7211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4468),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8335),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8334),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5949),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [7250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3179),
  [7253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5978),
  [7256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6977),
  [7259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5948),
  [7262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5981),
  [7265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6218),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [7270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7511),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7511),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [7277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4414),
  [7280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributes, 1),
  [7282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 1),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6188),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [7302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7192),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5808),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [7346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 1),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [7352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 1),
  [7354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [7360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [7374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [7396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [7398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [7400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7850),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [7409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6336),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [7414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [7424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [7426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6392),
  [7429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6392),
  [7431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4364),
  [7433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 3),
  [7435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 3),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [7449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6466),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [7455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [7459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7565),
  [7462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4356),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [7472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_field, 3),
  [7474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_field, 3),
  [7476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6466),
  [7479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_field, 1),
  [7481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_field, 1),
  [7483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6531),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6414),
  [7488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5806),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [7496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6414),
  [7499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2), SHIFT_REPEAT(3804),
  [7502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 4),
  [7504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 4),
  [7506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4600),
  [7508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [7510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4560),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8367),
  [7514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [7516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [7518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [7522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4331),
  [7524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [7526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4404),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [7530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4474),
  [7532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3789),
  [7534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [7538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4951),
  [7540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [7542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4989),
  [7544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4340),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8017),
  [7548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4908),
  [7550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4510),
  [7552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [7554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8116),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4542),
  [7564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [7566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [7570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4690),
  [7572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [7574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [7578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4372),
  [7580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4553),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [7586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [7588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [7590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4514),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7845),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [7596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4604),
  [7599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 1),
  [7601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 1),
  [7603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atomic_pattern, 3),
  [7605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atomic_pattern, 3),
  [7607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [7609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4589),
  [7611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [7613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4434),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [7617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [7619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [7621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [7625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atomic_pattern, 1),
  [7627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atomic_pattern, 1),
  [7629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4436),
  [7631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3607),
  [7633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4713),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7776),
  [7637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4408),
  [7639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [7641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4678),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7864),
  [7645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [7647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [7649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [7653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [7655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [7657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [7661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7640),
  [7664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4482),
  [7666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [7668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4505),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [7672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6267),
  [7675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [7677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [7679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [7683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [7685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [7691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4465),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [7695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4550),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7648),
  [7699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5000),
  [7701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4659),
  [7703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5067),
  [7705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [7709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4397),
  [7711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [7713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [7717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2788),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7471),
  [7724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4656),
  [7727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7549),
  [7730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7471),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7167),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [7749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4442),
  [7752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5902),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [7758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4429),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [7763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2804),
  [7766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3070),
  [7769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6026),
  [7772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(7125),
  [7775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5945),
  [7778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6025),
  [7781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6178),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [7786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5895),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [7796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4575),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [7801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4497),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [7806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3158),
  [7809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6126),
  [7812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(7123),
  [7815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5960),
  [7818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6049),
  [7821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6136),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [7832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 6, .production_id = 54),
  [7834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 6, .production_id = 54),
  [7836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 5, .production_id = 29),
  [7838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 5, .production_id = 29),
  [7840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 5, .production_id = 45),
  [7842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 5, .production_id = 45),
  [7844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6378),
  [7847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_inherits_decl, 5, .production_id = 65),
  [7849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_inherits_decl, 5, .production_id = 65),
  [7851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3076),
  [7854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6118),
  [7857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(7042),
  [7860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5962),
  [7863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6112),
  [7866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6164),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6378),
  [7871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6235),
  [7874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6235),
  [7876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [7878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 4),
  [7880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 4),
  [7882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 4, .production_id = 29),
  [7884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 4, .production_id = 29),
  [7886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_inherits_decl, 4, .production_id = 28),
  [7888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_inherits_decl, 4, .production_id = 28),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [7894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5914),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6956),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7517),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [7922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 3),
  [7924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 3),
  [7926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 1),
  [7928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 1),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [7934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 1),
  [7936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 1),
  [7938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 2),
  [7940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 2),
  [7942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_type_body_inner, 1),
  [7944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_type_body_inner, 1),
  [7946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [7956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [7960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [7962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6353),
  [7965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6431),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7530),
  [7970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(3090),
  [7973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6017),
  [7976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6997),
  [7979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(5950),
  [7982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6075),
  [7985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2), SHIFT_REPEAT(6188),
  [7988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7530),
  [7991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7536),
  [7994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6481),
  [7997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4350),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [8004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4338),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [8011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3, .production_id = 22),
  [8013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 3, .production_id = 22),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6769),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6776),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [8043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 2),
  [8045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 2),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [8049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 2, .production_id = 11),
  [8051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 2, .production_id = 11),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7863),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [8059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7844),
  [8062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7863),
  [8065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 2),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [8071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4583),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8319),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [8080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7966),
  [8082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_fields, 1),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [8088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(8319),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [8093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6661),
  [8095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6044),
  [8097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5966),
  [8099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [8101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6037),
  [8103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6146),
  [8105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_fields, 2),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [8109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2), SHIFT_REPEAT(3768),
  [8112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4441),
  [8115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_fields_repeat1, 2),
  [8117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_fields_repeat1, 2), SHIFT_REPEAT(4282),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [8126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_cases, 1),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [8142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [8144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [8150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_cases_repeat1, 2),
  [8152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_cases_repeat1, 2), SHIFT_REPEAT(5968),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [8167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6348),
  [8170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8074),
  [8172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_cases, 3),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [8186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [8188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_cases, 2),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [8192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5645),
  [8194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5646),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [8198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [8200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6567),
  [8202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6568),
  [8204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8344),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [8208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4134),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [8214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [8216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [8218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [8220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6789),
  [8222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [8224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6766),
  [8226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [8234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [8238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [8240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [8242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [8246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [8248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5220),
  [8250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [8252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [8254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5172),
  [8256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3880),
  [8258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [8260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [8264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3850),
  [8266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3, .production_id = 11),
  [8268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 3, .production_id = 11),
  [8270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [8272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3982),
  [8274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [8276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7914),
  [8278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2), SHIFT_REPEAT(5645),
  [8281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2), SHIFT_REPEAT(5645),
  [8284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2), SHIFT_REPEAT(5646),
  [8287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2), SHIFT_REPEAT(595),
  [8290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2),
  [8292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2), SHIFT_REPEAT(5646),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [8297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [8299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [8301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [8303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [8305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [8307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [8309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [8313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 4, .production_id = 33),
  [8315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 4, .production_id = 33),
  [8317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 4, .production_id = 22),
  [8319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 4, .production_id = 22),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8261),
  [8323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 2, .production_id = 2),
  [8325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 2, .production_id = 2),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [8331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [8335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [8339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3814),
  [8341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [8345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5763),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [8349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [8351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [8353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [8355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [8357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5731),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7734),
  [8363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(5710),
  [8366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(5710),
  [8369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(5713),
  [8372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2),
  [8374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [8378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5710),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [8382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [8386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5682),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [8396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [8400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [8408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [8418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [8422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [8426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2), SHIFT_REPEAT(7593),
  [8429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [8433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6795),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [8439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7593),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [8447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [8451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5687),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [8455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2661),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [8461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [8465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [8469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [8473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [8477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4682),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [8481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [8497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [8501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5235),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [8505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [8509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [8515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [8521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [8525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7847),
  [8527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5134),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [8531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [8539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [8543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [8551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [8555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [8561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [8565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [8571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7060),
  [8577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [8581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [8585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [8589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [8593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [8597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7062),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7733),
  [8605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3723),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [8611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(5852),
  [8614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(5852),
  [8617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2), SHIFT_REPEAT(5870),
  [8620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3001),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6167),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [8636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2), SHIFT_REPEAT(6505),
  [8639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5903),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [8644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4409),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6673),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7058),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6211),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [8688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5915),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [8693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compound_type_repeat1, 2), SHIFT_REPEAT(4704),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6643),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [8706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_types, 1),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [8712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5910),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7115),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [8731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5919),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [8736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5852),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [8740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7996),
  [8742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7974),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [8750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5930),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [8754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [8758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [8762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6462),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6966),
  [8767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8096),
  [8769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [8771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3720),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [8777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6503),
  [8780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [8784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [8792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [8794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [8796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [8798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [8802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [8806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [8810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4467),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [8822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3051),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [8827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [8831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [8833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4518),
  [8835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [8837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4705),
  [8839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 3),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [8849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6497),
  [8852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [8856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2), SHIFT_REPEAT(3773),
  [8859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attribute, 1),
  [8861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_types_repeat1, 2),
  [8863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [8869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [8873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [8875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2), SHIFT_REPEAT(5930),
  [8878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2), SHIFT_REPEAT(5920),
  [8881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2),
  [8883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4622),
  [8887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [8895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [8899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [8903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [8921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [8925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [8933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 6),
  [8935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_pattern_content_repeat1, 2),
  [8937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6308),
  [8940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [8944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [8948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 5),
  [8950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [8954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [8960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [8964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3136),
  [8967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3118),
  [8970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5884),
  [8973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 4),
  [8975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4089),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [8987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3109),
  [8990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [8996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 2),
  [8998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [9000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4668),
  [9002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [9004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4513),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [9008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3833),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [9012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5683),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [9016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [9020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [9024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 3),
  [9026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [9030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3829),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [9034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5727),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [9048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [9052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 3),
  [9054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5164),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [9058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [9060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [9062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5673),
  [9064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8307),
  [9068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4369),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [9072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [9076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 1),
  [9078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [9082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6798),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [9086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [9090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [9094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [9098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [9102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 2),
  [9104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [9108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [9118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 1),
  [9120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 1),
  [9122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 1),
  [9124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 1),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [9154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3064),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [9161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_char, 1),
  [9163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_char, 1),
  [9165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_char, 1),
  [9167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_char, 1),
  [9169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2), SHIFT_REPEAT(6524),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [9174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string_eval, 3),
  [9176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string_eval, 3),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [9184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6200),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [9202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [9206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7897),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [9238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6138),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [9250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4697),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [9288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2), SHIFT_REPEAT(5941),
  [9291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2), SHIFT_REPEAT(5938),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4998),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [9304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3123),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [9313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3135),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6707),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [9322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_signature, 3),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [9332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7902),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6601),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [9356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6182),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8015),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8062),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [9374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_member_constraint, 4),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [9388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3160),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [9395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_member_constraint, 5),
  [9397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6216),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [9411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [9415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [9421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [9425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [9427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [9437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2),
  [9439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [9445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 3),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [9451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [9463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6268),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [9487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2), SHIFT_REPEAT(3159),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [9498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [9504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 2),
  [9506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(4271),
  [9509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [9519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [9521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [9523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [9525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [9535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [9541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [9545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [9553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [9563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7440),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [9571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [9575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [9579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [9585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [9589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [9593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 1),
  [9595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 1),
  [9597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(4254),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [9610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [9612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [9616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4421),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [9627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [9633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [9639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [9643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__verbatim_string_char, 1),
  [9645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_string_char, 1),
  [9647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4077),
  [9649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6089),
  [9651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6104),
  [9653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_name_spec, 2, .production_id = 35),
  [9655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_name_spec, 2, .production_id = 35),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5937),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [9663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5979),
  [9665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [9667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6078),
  [9669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [9671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6004),
  [9673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [9675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [9677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [9679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6052),
  [9681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6082),
  [9683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4670),
  [9686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6032),
  [9688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6057),
  [9690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6051),
  [9692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6035),
  [9694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [9696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [9698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6063),
  [9700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6080),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [9708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [9710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [9718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_name_spec, 3, .production_id = 1),
  [9720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_name_spec, 3, .production_id = 1),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [9724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5973),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [9742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6523),
  [9744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7890),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [9758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6454),
  [9760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6196),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [9766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6487),
  [9770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6192),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [9774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [9776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6227),
  [9778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [9780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [9784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [9792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6223),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [9798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [9806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4714),
  [9809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [9811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6420),
  [9813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6512),
  [9821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6209),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6193),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [9845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [9847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [9853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6147),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [9861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [9869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [9871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6152),
  [9873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6530),
  [9875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6195),
  [9877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [9909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [9911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6158),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [9931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 6, .production_id = 59),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [9935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7238),
  [9937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [9939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7374),
  [9941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [9943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7394),
  [9945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7248),
  [9959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [9961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(5428),
  [9964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [9966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [9968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6544),
  [9970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7360),
  [9972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6560),
  [9974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [9976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6357),
  [9978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2793),
  [9981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2785),
  [9984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3261),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [9988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [9990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7409),
  [9992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6272),
  [9994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7182),
  [9996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6254),
  [9998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [10000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6261),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7355),
  [10004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6407),
  [10006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(2980),
  [10009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2), SHIFT_REPEAT(8242),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [10014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7175),
  [10016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6365),
  [10018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_pattern_content_repeat1, 2), SHIFT_REPEAT(3073),
  [10021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 4, .production_id = 36),
  [10023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7482),
  [10025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6313),
  [10027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7225),
  [10029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6373),
  [10031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2),
  [10033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2), SHIFT_REPEAT(6221),
  [10036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 3, .production_id = 36),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [10040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8186),
  [10042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6467),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [10046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [10048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7474),
  [10050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [10054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8064),
  [10056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6322),
  [10058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2), SHIFT_REPEAT(4619),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8327),
  [10063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 5, .production_id = 59),
  [10065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7315),
  [10067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [10069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7428),
  [10071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [10073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7307),
  [10075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [10077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8059),
  [10079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8314),
  [10083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [10085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7463),
  [10087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6290),
  [10089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [10091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [10093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6576),
  [10095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8275),
  [10097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6455),
  [10099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [10101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [10103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [10107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_type_body_repeat1, 2), SHIFT_REPEAT(3999),
  [10110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_type_body_repeat1, 2),
  [10112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [10114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [10116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [10118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [10122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [10136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7028),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [10140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7432),
  [10142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [10144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7186),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [10148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 1),
  [10150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments_spec, 2),
  [10152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [10154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_types, 2),
  [10156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 5),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8197),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [10166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8295),
  [10168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6679),
  [10174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_cases, 3),
  [10176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7038),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [10184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6905),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [10194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [10202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6932),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [10206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7027),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [10212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [10214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [10216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2), SHIFT_REPEAT(5908),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [10223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7486),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [10233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_type_cases_repeat1, 2), SHIFT_REPEAT(6679),
  [10236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_type_cases_repeat1, 2),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [10240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8081),
  [10242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 4),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [10248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8033),
  [10250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments_spec, 1),
  [10252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6596),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [10258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [10260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_ranges, 1),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [10264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7378),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [10274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializers, 1),
  [10276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6893),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [10284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_spec_repeat1, 2),
  [10286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_spec_repeat1, 2), SHIFT_REPEAT(4048),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [10293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_type_body, 2),
  [10295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7151),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [10299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7004),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [10305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6890),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [10321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7009),
  [10323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [10327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7255),
  [10333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [10337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_cases, 2),
  [10339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2), SHIFT_REPEAT(528),
  [10342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [10348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_attributes_repeat1, 2), SHIFT_REPEAT(3477),
  [10351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_attributes_repeat1, 2),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [10365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8221),
  [10367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [10375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [10383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [10385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [10391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6992),
  [10393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [10395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2813),
  [10398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_set_repeat1, 2),
  [10400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_set_repeat1, 2), SHIFT_REPEAT(3777),
  [10403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_defn, 1),
  [10405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_types_repeat1, 2), SHIFT_REPEAT(4484),
  [10408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2), SHIFT_REPEAT(5748),
  [10411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [10415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6876),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [10421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7118),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [10429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7948),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [10433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attributes, 1),
  [10435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializers_repeat1, 2), SHIFT_REPEAT(6538),
  [10438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializers_repeat1, 2),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [10444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6871),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [10448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 2),
  [10450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2), SHIFT_REPEAT(518),
  [10453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2), SHIFT_REPEAT(667),
  [10456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [10460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7321),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [10464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 3),
  [10466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2802),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [10471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6846),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [10477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_ranges, 2),
  [10479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [10487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7006),
  [10489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7041),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [10511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7065),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [10517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 3),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [10523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_type_body, 1),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6946),
  [10533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6864),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [10537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7827),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8169),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7847),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [10549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6855),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [10553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6863),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [10557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7839),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [10563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6969),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [10567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6856),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [10571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_defn, 2),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [10575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7107),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [10583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_active_pattern_repeat1, 2), SHIFT_REPEAT(8158),
  [10586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_active_pattern_repeat1, 2),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [10590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attributes, 2),
  [10592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7906),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [10602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7894),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6860),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7937),
  [10612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6859),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [10616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6962),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [10622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializers, 2),
  [10624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7320),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [10628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [10630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6858),
  [10632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [10634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7133),
  [10636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [10638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [10644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7960),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [10652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 1),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [10674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [10686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 2),
  [10688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_range, 1, .production_id = 14),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [10696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [10700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6621),
  [10702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8241),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [10706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3),
  [10708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_parameter, 1),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5942),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [10716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 3),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [10720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_element, 3),
  [10722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [10736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_active_pattern_repeat1, 2, .production_id = 15),
  [10738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_active_pattern_repeat1, 2, .production_id = 15),
  [10740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8159),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [10748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 4),
  [10750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 3, .production_id = 37),
  [10752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5756),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [10756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_static_parameter, 3),
  [10758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 4),
  [10760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 5),
  [10762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 4, .production_id = 51),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [10770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_case, 3),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [10774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [10784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 5, .production_id = 58),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [10808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [10832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8180),
  [10834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8192),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [10838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8262),
  [10840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8276),
  [10842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8363),
  [10844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8382),
  [10846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8386),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8345),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [10854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8305),
  [10856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [10862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8212),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [10872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8173),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6314),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [10890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8069),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8030),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6708),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [10908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7899),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [10914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7874),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [10928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7791),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [10946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7770),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [10964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5680),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [10968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7655),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [10974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7627),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6899),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [11002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [11010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [11014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7399),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6807),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [11038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5655),
  [11040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [11042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [11044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [11046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [11052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7265),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [11066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7787),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [11096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5787),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7768),
  [11102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [11112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7193),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [11136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7275),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [11154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [11194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7422),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [11200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [11206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6142),
  [11208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [11210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [11212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [11230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7643),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [11238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [11240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [11246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7605),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [11256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7971),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [11286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [11346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [11352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [11356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [11360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [11370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [11376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [11384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [11386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7702),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7703),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [11446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [11454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [11466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [11472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7043),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [11480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7047),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [11590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [11592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7199),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6838),
  [11632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [11636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7765),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6360),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7078),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [11762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [11764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [11766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [11768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [11770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [11772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [11780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [11784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7348),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6249),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7821),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7393),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [11822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [11824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [11826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [11834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [11836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [11840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [11862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [11894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [11896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [11898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [11902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [11904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [11908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6911),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [11920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6883),
  [11936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [11938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7698),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7706),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [12018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [12022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [12030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7840),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [12040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6784),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [12070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [12080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7968),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6345),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6723),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8002),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6683),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8171),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [12234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [12236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8250),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [12246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8317),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8318),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8304),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8303),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8232),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8110),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8054),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7987),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6206),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [12412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7426),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [12560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7851),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7308),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7885),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7895),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7949),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7957),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7969),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7279),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7321),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8005),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8016),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [12876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 6),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7420),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [12924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_field_expression, 5, .production_id = 49),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8043),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8056),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7474),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [13040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_as_reference, 2),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7618),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7621),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7654),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7681),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7694),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [13176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_cases, 1),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7838),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8137),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7861),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6225),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8153),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7954),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7970),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7979),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [13326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [13332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [13334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [13336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6184),
  [13338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8372),
  [13340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8391),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6198),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [13374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8252),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8397),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [13462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_branch, 2, .production_id = 5),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [13466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [13468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8390),
  [13470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [13472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8338),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [13478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [13482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_target, 1),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8393),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [13496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [13498] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8349),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8352),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8353),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8354),
  [13512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [13514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [13516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [13524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xml_doc, 2),
  [13526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 2),
  [13528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3),
  [13530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compiler_directive_decl, 3, .production_id = 8),
  [13532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 3),
  [13534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, .production_id = 21),
  [13536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_then = 3,
  ts_external_token_else = 4,
  ts_external_token_elif = 5,
  ts_external_token_POUNDif = 6,
  ts_external_token_POUNDelse = 7,
  ts_external_token_POUNDendif = 8,
  ts_external_token__triple_quoted_content = 9,
  ts_external_token_block_comment_content = 10,
  ts_external_token__inside_string_marker = 11,
  ts_external_token__error_sentinel = 12,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_then] = anon_sym_then,
  [ts_external_token_else] = anon_sym_else,
  [ts_external_token_elif] = anon_sym_elif,
  [ts_external_token_POUNDif] = anon_sym_POUNDif,
  [ts_external_token_POUNDelse] = anon_sym_POUNDelse,
  [ts_external_token_POUNDendif] = anon_sym_POUNDendif,
  [ts_external_token__triple_quoted_content] = sym__triple_quoted_content,
  [ts_external_token_block_comment_content] = sym_block_comment_content,
  [ts_external_token__inside_string_marker] = sym__inside_string_marker,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[25][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_then] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token__triple_quoted_content] = true,
    [ts_external_token_block_comment_content] = true,
    [ts_external_token__inside_string_marker] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token_POUNDif] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [7] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
  },
  [8] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [9] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
  },
  [11] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
  },
  [12] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [13] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [14] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
  },
  [15] = {
    [ts_external_token__newline] = true,
  },
  [16] = {
    [ts_external_token__dedent] = true,
  },
  [17] = {
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [18] = {
    [ts_external_token_POUNDendif] = true,
  },
  [19] = {
    [ts_external_token__inside_string_marker] = true,
  },
  [20] = {
    [ts_external_token__indent] = true,
  },
  [21] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
  },
  [22] = {
    [ts_external_token_then] = true,
  },
  [23] = {
    [ts_external_token__triple_quoted_content] = true,
  },
  [24] = {
    [ts_external_token_block_comment_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_fsharp_external_scanner_create(void);
void tree_sitter_fsharp_external_scanner_destroy(void *);
bool tree_sitter_fsharp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_fsharp_external_scanner_serialize(void *, char *);
void tree_sitter_fsharp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_fsharp() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_fsharp_external_scanner_create,
      tree_sitter_fsharp_external_scanner_destroy,
      tree_sitter_fsharp_external_scanner_scan,
      tree_sitter_fsharp_external_scanner_serialize,
      tree_sitter_fsharp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
